/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 89;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 64,
  Feature_HasStdExtZicondBit = 65,
  Feature_HasStdExtZimopBit = 63,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZmmulBit = 22,
  Feature_HasStdExtMBit = 23,
  Feature_HasStdExtABit = 25,
  Feature_HasStdExtZtsoBit = 27,
  Feature_NotHasStdExtZtsoBit = 26,
  Feature_HasStdExtZabhaBit = 30,
  Feature_HasStdExtZacasBit = 29,
  Feature_NoStdExtZacasBit = 28,
  Feature_HasStdExtZalasrBit = 31,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 32,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtCOrZcaBit = 20,
  Feature_HasStdExtZbaBit = 38,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 35,
  Feature_NoStdExtZbbBit = 37,
  Feature_HasStdExtZbcBit = 40,
  Feature_HasStdExtZbsBit = 34,
  Feature_HasStdExtZbkbBit = 36,
  Feature_NoStdExtZbkbBit = 86,
  Feature_HasStdExtZbkxBit = 41,
  Feature_HasStdExtZbbOrZbkbBit = 33,
  Feature_HasStdExtZbcOrZbkcBit = 39,
  Feature_HasStdExtZkndBit = 42,
  Feature_HasStdExtZkneBit = 44,
  Feature_HasStdExtZkndOrZkneBit = 43,
  Feature_HasStdExtZknhBit = 45,
  Feature_HasStdExtZksedBit = 46,
  Feature_HasStdExtZkshBit = 47,
  Feature_HasStdExtZvkbBit = 55,
  Feature_HasStdExtZvbbBit = 54,
  Feature_HasStdExtZvbcBit = 59,
  Feature_HasStdExtZvkgBit = 56,
  Feature_HasStdExtZvknedBit = 57,
  Feature_HasStdExtZvknhaBit = 60,
  Feature_HasStdExtZvknhbBit = 61,
  Feature_HasStdExtZvksedBit = 62,
  Feature_HasStdExtZvkshBit = 58,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 50,
  Feature_HasVInstructionsAnyFBit = 49,
  Feature_HasVInstructionsF16MinimalBit = 52,
  Feature_HasVInstructionsF16Bit = 48,
  Feature_HasVInstructionsF64Bit = 53,
  Feature_HasVInstructionsFullMultiplyBit = 51,
  Feature_HasVendorXVentanaCondOpsBit = 66,
  Feature_HasVendorXTHeadBaBit = 67,
  Feature_HasVendorXTHeadBbBit = 68,
  Feature_HasVendorXTHeadBsBit = 69,
  Feature_HasVendorXTHeadCondMovBit = 70,
  Feature_HasVendorXTHeadFMemIdxBit = 75,
  Feature_HasVendorXTHeadMacBit = 71,
  Feature_HasVendorXTHeadMemIdxBit = 74,
  Feature_HasVendorXTHeadMemPairBit = 73,
  Feature_HasVendorXTHeadVdotBit = 72,
  Feature_HasVendorXSfvcpBit = 76,
  Feature_HasVendorXSfvqmaccdodBit = 77,
  Feature_HasVendorXSfvqmaccqoqBit = 78,
  Feature_HasVendorXSfvfnrclipxfqfBit = 79,
  Feature_HasVendorXCVbitmanipBit = 81,
  Feature_HasVendorXCVmacBit = 84,
  Feature_HasVendorXCVmemBit = 80,
  Feature_HasVendorXCValuBit = 82,
  Feature_HasVendorXCVbiBit = 83,
  Feature_UseCCMovInsnBit = 85,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 24,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 88,
  Feature_HwMode0Bit = 87,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtCOrZca())
    Features.set(Feature_HasStdExtCOrZcaBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9501,
  GICXXPred_MI_Predicate_anonymous_9503,
  GICXXPred_MI_Predicate_anonymous_9591,
  GICXXPred_MI_Predicate_anonymous_9632,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9501: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9503: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9591: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9632: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm9_lsb0,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb0,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(329), /*)*//*default:*//*Label 121*/ GIMT_Encode4(2546159),
    /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1114),
    /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(9468),
    /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(12320),
    /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15189),
    /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(17923),
    /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(20657),
    /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(23436), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(26170),
    /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(35454),
    /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(47419), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(62214), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(62275), GIMT_Encode4(0),
    /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(62336), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(62427), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(62794),
    /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(62992),
    /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(63190),
    /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(63770),
    /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(63980),
    /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(64178),
    /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(64217),
    /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(64256),
    /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(72718),
    /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(73013), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(73308), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(80106),
    /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(84992),
    /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(87902), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(90812),
    /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(93722),
    /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(94634),
    /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(97544),
    /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(100454),
    /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(103364),
    /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(106274),
    /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(109184), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(112094), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(112312),
    /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2305851), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2307367), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2310488),
    /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2313963),
    /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2314512),
    /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2318199),
    /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2321273),
    /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2324179), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2327118),
    /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2330058),
    /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2332968),
    /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2359631), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2367093), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2373805),
    /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2376539),
    /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2379273),
    /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2382059),
    /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2384845),
    /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2387631), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(2390417),
    /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(2392845),
    /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(2395273),
    /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(2397701), GIMT_Encode4(0),
    /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(2414346), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(2416774),
    /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(2418745),
    /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(2419198),
    /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(2420734),
    /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(2425620),
    /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(2430506),
    /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(2435792), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FABS*//*Label 69*/ GIMT_Encode4(2441078),
    /*TargetOpcode::G_FCOPYSIGN*//*Label 70*/ GIMT_Encode4(2443049), GIMT_Encode4(0),
    /*TargetOpcode::G_FCANONICALIZE*//*Label 71*/ GIMT_Encode4(2449111),
    /*TargetOpcode::G_FMINNUM*//*Label 72*/ GIMT_Encode4(2449301),
    /*TargetOpcode::G_FMAXNUM*//*Label 73*/ GIMT_Encode4(2451386), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FMINIMUM*//*Label 74*/ GIMT_Encode4(2453471),
    /*TargetOpcode::G_FMAXIMUM*//*Label 75*/ GIMT_Encode4(2453597), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SMIN*//*Label 76*/ GIMT_Encode4(2453723),
    /*TargetOpcode::G_SMAX*//*Label 77*/ GIMT_Encode4(2456499),
    /*TargetOpcode::G_UMIN*//*Label 78*/ GIMT_Encode4(2459275),
    /*TargetOpcode::G_UMAX*//*Label 79*/ GIMT_Encode4(2462051),
    /*TargetOpcode::G_ABS*//*Label 80*/ GIMT_Encode4(2464827),
    /*TargetOpcode::G_LROUND*//*Label 81*/ GIMT_Encode4(2464985),
    /*TargetOpcode::G_LLROUND*//*Label 82*/ GIMT_Encode4(2465565),
    /*TargetOpcode::G_BR*//*Label 83*/ GIMT_Encode4(2465775), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_CTTZ*//*Label 84*/ GIMT_Encode4(2465791), GIMT_Encode4(0),
    /*TargetOpcode::G_CTLZ*//*Label 85*/ GIMT_Encode4(2468311), GIMT_Encode4(0),
    /*TargetOpcode::G_CTPOP*//*Label 86*/ GIMT_Encode4(2470969),
    /*TargetOpcode::G_BSWAP*//*Label 87*/ GIMT_Encode4(2473520),
    /*TargetOpcode::G_BITREVERSE*//*Label 88*/ GIMT_Encode4(2476055),
    /*TargetOpcode::G_FCEIL*//*Label 89*/ GIMT_Encode4(2478549), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FSQRT*//*Label 90*/ GIMT_Encode4(2478747),
    /*TargetOpcode::G_FFLOOR*//*Label 91*/ GIMT_Encode4(2480923),
    /*TargetOpcode::G_FRINT*//*Label 92*/ GIMT_Encode4(2481121),
    /*TargetOpcode::G_FNEARBYINT*//*Label 93*/ GIMT_Encode4(2481319), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FADD*//*Label 94*/ GIMT_Encode4(2481517),
    /*TargetOpcode::G_STRICT_FSUB*//*Label 95*/ GIMT_Encode4(2483945),
    /*TargetOpcode::G_STRICT_FMUL*//*Label 96*/ GIMT_Encode4(2486373),
    /*TargetOpcode::G_STRICT_FDIV*//*Label 97*/ GIMT_Encode4(2488801), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FMA*//*Label 98*/ GIMT_Encode4(2491229),
    /*TargetOpcode::G_STRICT_FSQRT*//*Label 99*/ GIMT_Encode4(2507874), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_TRAP*//*Label 100*/ GIMT_Encode4(2510050),
    /*TargetOpcode::G_DEBUGTRAP*//*Label 101*/ GIMT_Encode4(2510063), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*RISCV::G_CLZW*//*Label 102*/ GIMT_Encode4(2510076),
    /*RISCV::G_CTZW*//*Label 103*/ GIMT_Encode4(2510171),
    /*RISCV::G_DIVUW*//*Label 104*/ GIMT_Encode4(2510201),
    /*RISCV::G_DIVW*//*Label 105*/ GIMT_Encode4(2510238),
    /*RISCV::G_FCLASS*//*Label 106*/ GIMT_Encode4(2510275),
    /*RISCV::G_FCVT_WU_RV64*//*Label 107*/ GIMT_Encode4(2510635),
    /*RISCV::G_FCVT_W_RV64*//*Label 108*/ GIMT_Encode4(2510833),
    /*RISCV::G_READ_VLENB*//*Label 109*/ GIMT_Encode4(2511031),
    /*RISCV::G_REMUW*//*Label 110*/ GIMT_Encode4(2511091),
    /*RISCV::G_ROLW*//*Label 111*/ GIMT_Encode4(2511128),
    /*RISCV::G_RORW*//*Label 112*/ GIMT_Encode4(2511253),
    /*RISCV::G_SLLW*//*Label 113*/ GIMT_Encode4(2511374), GIMT_Encode4(0),
    /*RISCV::G_SRAW*//*Label 114*/ GIMT_Encode4(2511421),
    /*RISCV::G_SRLW*//*Label 115*/ GIMT_Encode4(2511468),
    /*RISCV::G_VMCLR_VL*//*Label 116*/ GIMT_Encode4(2511515),
    /*RISCV::G_VMSET_VL*//*Label 117*/ GIMT_Encode4(2512164),
    /*RISCV::G_VMV_V_V_VL*//*Label 118*/ GIMT_Encode4(2512813),
    /*RISCV::G_VSLIDEDOWN_VL*//*Label 119*/ GIMT_Encode4(2517071),
    /*RISCV::G_VSLIDEUP_VL*//*Label 120*/ GIMT_Encode4(2531615),
    // Label 0: @1114
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 146*/ GIMT_Encode4(9467),
    /*GILLT_s32*//*Label 122*/ GIMT_Encode4(1249),
    /*GILLT_s64*//*Label 123*/ GIMT_Encode4(2734), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 124*/ GIMT_Encode4(6937),
    /*GILLT_nxv1s16*//*Label 125*/ GIMT_Encode4(7052),
    /*GILLT_nxv1s32*//*Label 126*/ GIMT_Encode4(7167),
    /*GILLT_nxv1s64*//*Label 127*/ GIMT_Encode4(7282), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 128*/ GIMT_Encode4(7397),
    /*GILLT_nxv2s16*//*Label 129*/ GIMT_Encode4(7512),
    /*GILLT_nxv2s32*//*Label 130*/ GIMT_Encode4(7627),
    /*GILLT_nxv2s64*//*Label 131*/ GIMT_Encode4(7742), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 132*/ GIMT_Encode4(7857),
    /*GILLT_nxv4s16*//*Label 133*/ GIMT_Encode4(7972),
    /*GILLT_nxv4s32*//*Label 134*/ GIMT_Encode4(8087),
    /*GILLT_nxv4s64*//*Label 135*/ GIMT_Encode4(8202), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 136*/ GIMT_Encode4(8317),
    /*GILLT_nxv8s16*//*Label 137*/ GIMT_Encode4(8432),
    /*GILLT_nxv8s32*//*Label 138*/ GIMT_Encode4(8547),
    /*GILLT_nxv8s64*//*Label 139*/ GIMT_Encode4(8662), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 140*/ GIMT_Encode4(8777),
    /*GILLT_nxv16s16*//*Label 141*/ GIMT_Encode4(8892),
    /*GILLT_nxv16s32*//*Label 142*/ GIMT_Encode4(9007), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 143*/ GIMT_Encode4(9122),
    /*GILLT_nxv32s16*//*Label 144*/ GIMT_Encode4(9237), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 145*/ GIMT_Encode4(9352),
    // Label 122: @1249
    GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2733),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1308), // Rule ID 2428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
        // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2428,
        GIR_EraseRootFromParent_Done,
      // Label 148: @1308
      GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(1356), // Rule ID 2438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
        // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2438,
        GIR_EraseRootFromParent_Done,
      // Label 149: @1356
      GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(1404), // Rule ID 2448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
        // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2448,
        GIR_EraseRootFromParent_Done,
      // Label 150: @1404
      GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(1455), // Rule ID 61943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
        // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61943,
        GIR_EraseRootFromParent_Done,
      // Label 151: @1455
      GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1506), // Rule ID 61947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
        // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61947,
        GIR_EraseRootFromParent_Done,
      // Label 152: @1506
      GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1557), // Rule ID 61951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
        // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61951,
        GIR_EraseRootFromParent_Done,
      // Label 153: @1557
      GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1605), // Rule ID 64208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64208,
        GIR_EraseRootFromParent_Done,
      // Label 154: @1605
      GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1653), // Rule ID 64216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64216,
        GIR_EraseRootFromParent_Done,
      // Label 155: @1653
      GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1701), // Rule ID 64224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64224,
        GIR_EraseRootFromParent_Done,
      // Label 156: @1701
      GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1752), // Rule ID 72762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72762,
        GIR_EraseRootFromParent_Done,
      // Label 157: @1752
      GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1803), // Rule ID 72766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72766,
        GIR_EraseRootFromParent_Done,
      // Label 158: @1803
      GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1854), // Rule ID 72770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72770,
        GIR_EraseRootFromParent_Done,
      // Label 159: @1854
      GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1922), // Rule ID 2422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2422,
        GIR_EraseRootFromParent_Done,
      // Label 160: @1922
      GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1990), // Rule ID 2432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2432,
        GIR_EraseRootFromParent_Done,
      // Label 161: @1990
      GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2058), // Rule ID 2442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2442,
        GIR_EraseRootFromParent_Done,
      // Label 162: @2058
      GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2126), // Rule ID 64204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64204,
        GIR_EraseRootFromParent_Done,
      // Label 163: @2126
      GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2194), // Rule ID 64212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64212,
        GIR_EraseRootFromParent_Done,
      // Label 164: @2194
      GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2262), // Rule ID 64220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64220,
        GIR_EraseRootFromParent_Done,
      // Label 165: @2262
      GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2341), // Rule ID 61937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61937,
        GIR_EraseRootFromParent_Done,
      // Label 166: @2341
      GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2420), // Rule ID 72758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72758,
        GIR_EraseRootFromParent_Done,
      // Label 167: @2420
      GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2469), // Rule ID 115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 115,
        GIR_EraseRootFromParent_Done,
      // Label 168: @2469
      GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2511), // Rule ID 75 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 75,
        GIR_EraseRootFromParent_Done,
      // Label 169: @2511
      GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2583), // Rule ID 285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9632),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_9632>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 285,
        GIR_EraseRootFromParent_Done,
      // Label 170: @2583
      GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2644), // Rule ID 72772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72772,
        GIR_EraseRootFromParent_Done,
      // Label 171: @2644
      GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2705), // Rule ID 62005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62005,
        GIR_EraseRootFromParent_Done,
      // Label 172: @2705
      GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2732), // Rule ID 73 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 73,
        GIR_Done,
      // Label 173: @2732
      GIM_Reject,
    // Label 147: @2733
    GIM_Reject,
    // Label 123: @2734
    GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(6936),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2840), // Rule ID 2472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2472,
        GIR_EraseRootFromParent_Done,
      // Label 175: @2840
      GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2935), // Rule ID 2474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2474,
        GIR_EraseRootFromParent_Done,
      // Label 176: @2935
      GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(3030), // Rule ID 2476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 3,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738367),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), 34359738367:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2476,
        GIR_EraseRootFromParent_Done,
      // Label 177: @3030
      GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(3125), // Rule ID 2463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2463,
        GIR_EraseRootFromParent_Done,
      // Label 178: @3125
      GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(3220), // Rule ID 2466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2466,
        GIR_EraseRootFromParent_Done,
      // Label 179: @3220
      GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(3315), // Rule ID 2469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2469,
        GIR_EraseRootFromParent_Done,
      // Label 180: @3315
      GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(3410), // Rule ID 64234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64234,
        GIR_EraseRootFromParent_Done,
      // Label 181: @3410
      GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3505), // Rule ID 64236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64236,
        GIR_EraseRootFromParent_Done,
      // Label 182: @3505
      GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3600), // Rule ID 64238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 3,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738367),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), 34359738367:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64238,
        GIR_EraseRootFromParent_Done,
      // Label 183: @3600
      GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3695), // Rule ID 64228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64228,
        GIR_EraseRootFromParent_Done,
      // Label 184: @3695
      GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3790), // Rule ID 64230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64230,
        GIR_EraseRootFromParent_Done,
      // Label 185: @3790
      GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3885), // Rule ID 64232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64232,
        GIR_EraseRootFromParent_Done,
      // Label 186: @3885
      GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3933), // Rule ID 2427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
        // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2427,
        GIR_EraseRootFromParent_Done,
      // Label 187: @3933
      GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3981), // Rule ID 2437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
        // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2437,
        GIR_EraseRootFromParent_Done,
      // Label 188: @3981
      GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(4029), // Rule ID 2447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
        // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2447,
        GIR_EraseRootFromParent_Done,
      // Label 189: @4029
      GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(4077), // Rule ID 2478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
        // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2478,
        GIR_EraseRootFromParent_Done,
      // Label 190: @4077
      GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(4125), // Rule ID 2480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
        // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2480,
        GIR_EraseRootFromParent_Done,
      // Label 191: @4125
      GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(4173), // Rule ID 2482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
        // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2482,
        GIR_EraseRootFromParent_Done,
      // Label 192: @4173
      GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(4224), // Rule ID 61942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
        // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61942,
        GIR_EraseRootFromParent_Done,
      // Label 193: @4224
      GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(4275), // Rule ID 61946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
        // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61946,
        GIR_EraseRootFromParent_Done,
      // Label 194: @4275
      GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(4326), // Rule ID 61950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
        // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61950,
        GIR_EraseRootFromParent_Done,
      // Label 195: @4326
      GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(4374), // Rule ID 64207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64207,
        GIR_EraseRootFromParent_Done,
      // Label 196: @4374
      GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4422), // Rule ID 64215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64215,
        GIR_EraseRootFromParent_Done,
      // Label 197: @4422
      GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4470), // Rule ID 64223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64223,
        GIR_EraseRootFromParent_Done,
      // Label 198: @4470
      GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4518), // Rule ID 64240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64240,
        GIR_EraseRootFromParent_Done,
      // Label 199: @4518
      GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4566), // Rule ID 64242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64242,
        GIR_EraseRootFromParent_Done,
      // Label 200: @4566
      GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4614), // Rule ID 64244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64244,
        GIR_EraseRootFromParent_Done,
      // Label 201: @4614
      GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4665), // Rule ID 72761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72761,
        GIR_EraseRootFromParent_Done,
      // Label 202: @4665
      GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4716), // Rule ID 72765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72765,
        GIR_EraseRootFromParent_Done,
      // Label 203: @4716
      GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4767), // Rule ID 72769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72769,
        GIR_EraseRootFromParent_Done,
      // Label 204: @4767
      GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4842), // Rule ID 2460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2460,
        GIR_EraseRootFromParent_Done,
      // Label 205: @4842
      GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4937), // Rule ID 2484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2484,
        GIR_EraseRootFromParent_Done,
      // Label 206: @4937
      GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(5032), // Rule ID 2486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2486,
        GIR_EraseRootFromParent_Done,
      // Label 207: @5032
      GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5127), // Rule ID 2488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2488,
        GIR_EraseRootFromParent_Done,
      // Label 208: @5127
      GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5222), // Rule ID 2490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2490,
        GIR_EraseRootFromParent_Done,
      // Label 209: @5222
      GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(5317), // Rule ID 2492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2492,
        GIR_EraseRootFromParent_Done,
      // Label 210: @5317
      GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(5412), // Rule ID 2494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2494,
        GIR_EraseRootFromParent_Done,
      // Label 211: @5412
      GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5480), // Rule ID 2421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2421,
        GIR_EraseRootFromParent_Done,
      // Label 212: @5480
      GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5548), // Rule ID 2431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2431,
        GIR_EraseRootFromParent_Done,
      // Label 213: @5548
      GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5616), // Rule ID 2441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2441,
        GIR_EraseRootFromParent_Done,
      // Label 214: @5616
      GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5691), // Rule ID 64226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64226,
        GIR_EraseRootFromParent_Done,
      // Label 215: @5691
      GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5786), // Rule ID 64246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64246,
        GIR_EraseRootFromParent_Done,
      // Label 216: @5786
      GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5881), // Rule ID 64248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64248,
        GIR_EraseRootFromParent_Done,
      // Label 217: @5881
      GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5976), // Rule ID 64250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64250,
        GIR_EraseRootFromParent_Done,
      // Label 218: @5976
      GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(6071), // Rule ID 64252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64252,
        GIR_EraseRootFromParent_Done,
      // Label 219: @6071
      GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6166), // Rule ID 64254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64254,
        GIR_EraseRootFromParent_Done,
      // Label 220: @6166
      GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6261), // Rule ID 64256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64256,
        GIR_EraseRootFromParent_Done,
      // Label 221: @6261
      GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6329), // Rule ID 64203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64203,
        GIR_EraseRootFromParent_Done,
      // Label 222: @6329
      GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6397), // Rule ID 64211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64211,
        GIR_EraseRootFromParent_Done,
      // Label 223: @6397
      GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6465), // Rule ID 64219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64219,
        GIR_EraseRootFromParent_Done,
      // Label 224: @6465
      GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6544), // Rule ID 61936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61936,
        GIR_EraseRootFromParent_Done,
      // Label 225: @6544
      GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6623), // Rule ID 72757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72757,
        GIR_EraseRootFromParent_Done,
      // Label 226: @6623
      GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6672), // Rule ID 114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 114,
        GIR_EraseRootFromParent_Done,
      // Label 227: @6672
      GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6714), // Rule ID 74 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 74,
        GIR_EraseRootFromParent_Done,
      // Label 228: @6714
      GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6786), // Rule ID 284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9632),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_9632>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 284,
        GIR_EraseRootFromParent_Done,
      // Label 229: @6786
      GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6847), // Rule ID 72771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72771,
        GIR_EraseRootFromParent_Done,
      // Label 230: @6847
      GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6908), // Rule ID 62004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62004,
        GIR_EraseRootFromParent_Done,
      // Label 231: @6908
      GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6935), // Rule ID 72 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72,
        GIR_Done,
      // Label 232: @6935
      GIM_Reject,
    // Label 174: @6936
    GIM_Reject,
    // Label 124: @6937
    GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(7051),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(7005), // Rule ID 45528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45528,
        GIR_EraseRootFromParent_Done,
      // Label 234: @7005
      GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(7050), // Rule ID 45529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45529,
        GIR_EraseRootFromParent_Done,
      // Label 235: @7050
      GIM_Reject,
    // Label 233: @7051
    GIM_Reject,
    // Label 125: @7052
    GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(7166),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7120), // Rule ID 45888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45888,
        GIR_EraseRootFromParent_Done,
      // Label 237: @7120
      GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7165), // Rule ID 45889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45889,
        GIR_EraseRootFromParent_Done,
      // Label 238: @7165
      GIM_Reject,
    // Label 236: @7166
    GIM_Reject,
    // Label 126: @7167
    GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(7281),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(7235), // Rule ID 45896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45896,
        GIR_EraseRootFromParent_Done,
      // Label 240: @7235
      GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(7280), // Rule ID 45897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45897,
        GIR_EraseRootFromParent_Done,
      // Label 241: @7280
      GIM_Reject,
    // Label 239: @7281
    GIM_Reject,
    // Label 127: @7282
    GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(7396),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(7350), // Rule ID 45912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45912,
        GIR_EraseRootFromParent_Done,
      // Label 243: @7350
      GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7395), // Rule ID 45913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45913,
        GIR_EraseRootFromParent_Done,
      // Label 244: @7395
      GIM_Reject,
    // Label 242: @7396
    GIM_Reject,
    // Label 128: @7397
    GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7511),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7465), // Rule ID 45880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45880,
        GIR_EraseRootFromParent_Done,
      // Label 246: @7465
      GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7510), // Rule ID 45881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45881,
        GIR_EraseRootFromParent_Done,
      // Label 247: @7510
      GIM_Reject,
    // Label 245: @7511
    GIM_Reject,
    // Label 129: @7512
    GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7626),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7580), // Rule ID 45892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45892,
        GIR_EraseRootFromParent_Done,
      // Label 249: @7580
      GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7625), // Rule ID 45893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45893,
        GIR_EraseRootFromParent_Done,
      // Label 250: @7625
      GIM_Reject,
    // Label 248: @7626
    GIM_Reject,
    // Label 130: @7627
    GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(7741),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7695), // Rule ID 45908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45908,
        GIR_EraseRootFromParent_Done,
      // Label 252: @7695
      GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7740), // Rule ID 45909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45909,
        GIR_EraseRootFromParent_Done,
      // Label 253: @7740
      GIM_Reject,
    // Label 251: @7741
    GIM_Reject,
    // Label 131: @7742
    GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(7856),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(7810), // Rule ID 45952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45952,
        GIR_EraseRootFromParent_Done,
      // Label 255: @7810
      GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(7855), // Rule ID 45953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45953,
        GIR_EraseRootFromParent_Done,
      // Label 256: @7855
      GIM_Reject,
    // Label 254: @7856
    GIM_Reject,
    // Label 132: @7857
    GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(7971),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(7925), // Rule ID 45884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45884,
        GIR_EraseRootFromParent_Done,
      // Label 258: @7925
      GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(7970), // Rule ID 45885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45885,
        GIR_EraseRootFromParent_Done,
      // Label 259: @7970
      GIM_Reject,
    // Label 257: @7971
    GIM_Reject,
    // Label 133: @7972
    GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8086),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8040), // Rule ID 45904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45904,
        GIR_EraseRootFromParent_Done,
      // Label 261: @8040
      GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8085), // Rule ID 45905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45905,
        GIR_EraseRootFromParent_Done,
      // Label 262: @8085
      GIM_Reject,
    // Label 260: @8086
    GIM_Reject,
    // Label 134: @8087
    GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8201),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8155), // Rule ID 45940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45940,
        GIR_EraseRootFromParent_Done,
      // Label 264: @8155
      GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(8200), // Rule ID 45941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45941,
        GIR_EraseRootFromParent_Done,
      // Label 265: @8200
      GIM_Reject,
    // Label 263: @8201
    GIM_Reject,
    // Label 135: @8202
    GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8316),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(8270), // Rule ID 45956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45956,
        GIR_EraseRootFromParent_Done,
      // Label 267: @8270
      GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(8315), // Rule ID 45957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45957,
        GIR_EraseRootFromParent_Done,
      // Label 268: @8315
      GIM_Reject,
    // Label 266: @8316
    GIM_Reject,
    // Label 136: @8317
    GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(8431),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(8385), // Rule ID 45900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45900,
        GIR_EraseRootFromParent_Done,
      // Label 270: @8385
      GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(8430), // Rule ID 45901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45901,
        GIR_EraseRootFromParent_Done,
      // Label 271: @8430
      GIM_Reject,
    // Label 269: @8431
    GIM_Reject,
    // Label 137: @8432
    GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(8546),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(8500), // Rule ID 45928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45928,
        GIR_EraseRootFromParent_Done,
      // Label 273: @8500
      GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(8545), // Rule ID 45929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45929,
        GIR_EraseRootFromParent_Done,
      // Label 274: @8545
      GIM_Reject,
    // Label 272: @8546
    GIM_Reject,
    // Label 138: @8547
    GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(8661),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(8615), // Rule ID 45944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45944,
        GIR_EraseRootFromParent_Done,
      // Label 276: @8615
      GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(8660), // Rule ID 45945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45945,
        GIR_EraseRootFromParent_Done,
      // Label 277: @8660
      GIM_Reject,
    // Label 275: @8661
    GIM_Reject,
    // Label 139: @8662
    GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(8776),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(8730), // Rule ID 45960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45960,
        GIR_EraseRootFromParent_Done,
      // Label 279: @8730
      GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(8775), // Rule ID 45961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45961,
        GIR_EraseRootFromParent_Done,
      // Label 280: @8775
      GIM_Reject,
    // Label 278: @8776
    GIM_Reject,
    // Label 140: @8777
    GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8891),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8845), // Rule ID 45916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45916,
        GIR_EraseRootFromParent_Done,
      // Label 282: @8845
      GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8890), // Rule ID 45917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45917,
        GIR_EraseRootFromParent_Done,
      // Label 283: @8890
      GIM_Reject,
    // Label 281: @8891
    GIM_Reject,
    // Label 141: @8892
    GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(9006),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8960), // Rule ID 45932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45932,
        GIR_EraseRootFromParent_Done,
      // Label 285: @8960
      GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(9005), // Rule ID 45933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45933,
        GIR_EraseRootFromParent_Done,
      // Label 286: @9005
      GIM_Reject,
    // Label 284: @9006
    GIM_Reject,
    // Label 142: @9007
    GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(9121),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(9075), // Rule ID 45948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45948,
        GIR_EraseRootFromParent_Done,
      // Label 288: @9075
      GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(9120), // Rule ID 45949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45949,
        GIR_EraseRootFromParent_Done,
      // Label 289: @9120
      GIM_Reject,
    // Label 287: @9121
    GIM_Reject,
    // Label 143: @9122
    GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(9236),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(9190), // Rule ID 45920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45920,
        GIR_EraseRootFromParent_Done,
      // Label 291: @9190
      GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(9235), // Rule ID 45921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45921,
        GIR_EraseRootFromParent_Done,
      // Label 292: @9235
      GIM_Reject,
    // Label 290: @9236
    GIM_Reject,
    // Label 144: @9237
    GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(9351),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(9305), // Rule ID 45936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45936,
        GIR_EraseRootFromParent_Done,
      // Label 294: @9305
      GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(9350), // Rule ID 45937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45937,
        GIR_EraseRootFromParent_Done,
      // Label 295: @9350
      GIM_Reject,
    // Label 293: @9351
    GIM_Reject,
    // Label 145: @9352
    GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(9466),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(9420), // Rule ID 45924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45924,
        GIR_EraseRootFromParent_Done,
      // Label 297: @9420
      GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(9465), // Rule ID 45925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45925,
        GIR_EraseRootFromParent_Done,
      // Label 298: @9465
      GIM_Reject,
    // Label 296: @9466
    GIM_Reject,
    // Label 146: @9467
    GIM_Reject,
    // Label 1: @9468
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 323*/ GIMT_Encode4(12319),
    /*GILLT_s32*//*Label 299*/ GIMT_Encode4(9603),
    /*GILLT_s64*//*Label 300*/ GIMT_Encode4(9696), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 301*/ GIMT_Encode4(9789),
    /*GILLT_nxv1s16*//*Label 302*/ GIMT_Encode4(9904),
    /*GILLT_nxv1s32*//*Label 303*/ GIMT_Encode4(10019),
    /*GILLT_nxv1s64*//*Label 304*/ GIMT_Encode4(10134), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 305*/ GIMT_Encode4(10249),
    /*GILLT_nxv2s16*//*Label 306*/ GIMT_Encode4(10364),
    /*GILLT_nxv2s32*//*Label 307*/ GIMT_Encode4(10479),
    /*GILLT_nxv2s64*//*Label 308*/ GIMT_Encode4(10594), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 309*/ GIMT_Encode4(10709),
    /*GILLT_nxv4s16*//*Label 310*/ GIMT_Encode4(10824),
    /*GILLT_nxv4s32*//*Label 311*/ GIMT_Encode4(10939),
    /*GILLT_nxv4s64*//*Label 312*/ GIMT_Encode4(11054), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 313*/ GIMT_Encode4(11169),
    /*GILLT_nxv8s16*//*Label 314*/ GIMT_Encode4(11284),
    /*GILLT_nxv8s32*//*Label 315*/ GIMT_Encode4(11399),
    /*GILLT_nxv8s64*//*Label 316*/ GIMT_Encode4(11514), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 317*/ GIMT_Encode4(11629),
    /*GILLT_nxv16s16*//*Label 318*/ GIMT_Encode4(11744),
    /*GILLT_nxv16s32*//*Label 319*/ GIMT_Encode4(11859), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 320*/ GIMT_Encode4(11974),
    /*GILLT_nxv32s16*//*Label 321*/ GIMT_Encode4(12089), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 322*/ GIMT_Encode4(12204),
    // Label 299: @9603
    GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(9695),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(9675), // Rule ID 62007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62007,
        GIR_EraseRootFromParent_Done,
      // Label 325: @9675
      GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(9694), // Rule ID 77 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 77,
        GIR_Done,
      // Label 326: @9694
      GIM_Reject,
    // Label 324: @9695
    GIM_Reject,
    // Label 300: @9696
    GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(9788),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(9768), // Rule ID 62006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62006,
        GIR_EraseRootFromParent_Done,
      // Label 328: @9768
      GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(9787), // Rule ID 76 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 76,
        GIR_Done,
      // Label 329: @9787
      GIM_Reject,
    // Label 327: @9788
    GIM_Reject,
    // Label 301: @9789
    GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(9903),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(9857), // Rule ID 46006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46006,
        GIR_EraseRootFromParent_Done,
      // Label 331: @9857
      GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(9902), // Rule ID 46007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46007,
        GIR_EraseRootFromParent_Done,
      // Label 332: @9902
      GIM_Reject,
    // Label 330: @9903
    GIM_Reject,
    // Label 302: @9904
    GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(10018),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(9972), // Rule ID 46018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46018,
        GIR_EraseRootFromParent_Done,
      // Label 334: @9972
      GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(10017), // Rule ID 46019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46019,
        GIR_EraseRootFromParent_Done,
      // Label 335: @10017
      GIM_Reject,
    // Label 333: @10018
    GIM_Reject,
    // Label 303: @10019
    GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(10133),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(10087), // Rule ID 46026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46026,
        GIR_EraseRootFromParent_Done,
      // Label 337: @10087
      GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(10132), // Rule ID 46027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46027,
        GIR_EraseRootFromParent_Done,
      // Label 338: @10132
      GIM_Reject,
    // Label 336: @10133
    GIM_Reject,
    // Label 304: @10134
    GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(10248),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(10202), // Rule ID 46042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46042,
        GIR_EraseRootFromParent_Done,
      // Label 340: @10202
      GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(10247), // Rule ID 46043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46043,
        GIR_EraseRootFromParent_Done,
      // Label 341: @10247
      GIM_Reject,
    // Label 339: @10248
    GIM_Reject,
    // Label 305: @10249
    GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(10363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(10317), // Rule ID 46010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46010,
        GIR_EraseRootFromParent_Done,
      // Label 343: @10317
      GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(10362), // Rule ID 46011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46011,
        GIR_EraseRootFromParent_Done,
      // Label 344: @10362
      GIM_Reject,
    // Label 342: @10363
    GIM_Reject,
    // Label 306: @10364
    GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(10478),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(10432), // Rule ID 46022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46022,
        GIR_EraseRootFromParent_Done,
      // Label 346: @10432
      GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(10477), // Rule ID 46023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46023,
        GIR_EraseRootFromParent_Done,
      // Label 347: @10477
      GIM_Reject,
    // Label 345: @10478
    GIM_Reject,
    // Label 307: @10479
    GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(10593),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(10547), // Rule ID 46038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46038,
        GIR_EraseRootFromParent_Done,
      // Label 349: @10547
      GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(10592), // Rule ID 46039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46039,
        GIR_EraseRootFromParent_Done,
      // Label 350: @10592
      GIM_Reject,
    // Label 348: @10593
    GIM_Reject,
    // Label 308: @10594
    GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(10708),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(10662), // Rule ID 46082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46082,
        GIR_EraseRootFromParent_Done,
      // Label 352: @10662
      GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(10707), // Rule ID 46083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46083,
        GIR_EraseRootFromParent_Done,
      // Label 353: @10707
      GIM_Reject,
    // Label 351: @10708
    GIM_Reject,
    // Label 309: @10709
    GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(10823),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(10777), // Rule ID 46014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46014,
        GIR_EraseRootFromParent_Done,
      // Label 355: @10777
      GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(10822), // Rule ID 46015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46015,
        GIR_EraseRootFromParent_Done,
      // Label 356: @10822
      GIM_Reject,
    // Label 354: @10823
    GIM_Reject,
    // Label 310: @10824
    GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(10938),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(10892), // Rule ID 46034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46034,
        GIR_EraseRootFromParent_Done,
      // Label 358: @10892
      GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(10937), // Rule ID 46035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46035,
        GIR_EraseRootFromParent_Done,
      // Label 359: @10937
      GIM_Reject,
    // Label 357: @10938
    GIM_Reject,
    // Label 311: @10939
    GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(11053),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(11007), // Rule ID 46070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46070,
        GIR_EraseRootFromParent_Done,
      // Label 361: @11007
      GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(11052), // Rule ID 46071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46071,
        GIR_EraseRootFromParent_Done,
      // Label 362: @11052
      GIM_Reject,
    // Label 360: @11053
    GIM_Reject,
    // Label 312: @11054
    GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(11168),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(11122), // Rule ID 46086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46086,
        GIR_EraseRootFromParent_Done,
      // Label 364: @11122
      GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(11167), // Rule ID 46087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46087,
        GIR_EraseRootFromParent_Done,
      // Label 365: @11167
      GIM_Reject,
    // Label 363: @11168
    GIM_Reject,
    // Label 313: @11169
    GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(11283),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(11237), // Rule ID 46030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46030,
        GIR_EraseRootFromParent_Done,
      // Label 367: @11237
      GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(11282), // Rule ID 46031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46031,
        GIR_EraseRootFromParent_Done,
      // Label 368: @11282
      GIM_Reject,
    // Label 366: @11283
    GIM_Reject,
    // Label 314: @11284
    GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(11398),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(11352), // Rule ID 46058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46058,
        GIR_EraseRootFromParent_Done,
      // Label 370: @11352
      GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(11397), // Rule ID 46059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46059,
        GIR_EraseRootFromParent_Done,
      // Label 371: @11397
      GIM_Reject,
    // Label 369: @11398
    GIM_Reject,
    // Label 315: @11399
    GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(11513),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(11467), // Rule ID 46074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46074,
        GIR_EraseRootFromParent_Done,
      // Label 373: @11467
      GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(11512), // Rule ID 46075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46075,
        GIR_EraseRootFromParent_Done,
      // Label 374: @11512
      GIM_Reject,
    // Label 372: @11513
    GIM_Reject,
    // Label 316: @11514
    GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(11628),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(11582), // Rule ID 46090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46090,
        GIR_EraseRootFromParent_Done,
      // Label 376: @11582
      GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(11627), // Rule ID 46091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46091,
        GIR_EraseRootFromParent_Done,
      // Label 377: @11627
      GIM_Reject,
    // Label 375: @11628
    GIM_Reject,
    // Label 317: @11629
    GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(11743),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(11697), // Rule ID 46046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46046,
        GIR_EraseRootFromParent_Done,
      // Label 379: @11697
      GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(11742), // Rule ID 46047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46047,
        GIR_EraseRootFromParent_Done,
      // Label 380: @11742
      GIM_Reject,
    // Label 378: @11743
    GIM_Reject,
    // Label 318: @11744
    GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(11858),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(11812), // Rule ID 46062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46062,
        GIR_EraseRootFromParent_Done,
      // Label 382: @11812
      GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(11857), // Rule ID 46063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46063,
        GIR_EraseRootFromParent_Done,
      // Label 383: @11857
      GIM_Reject,
    // Label 381: @11858
    GIM_Reject,
    // Label 319: @11859
    GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(11973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(11927), // Rule ID 46078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46078,
        GIR_EraseRootFromParent_Done,
      // Label 385: @11927
      GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(11972), // Rule ID 46079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46079,
        GIR_EraseRootFromParent_Done,
      // Label 386: @11972
      GIM_Reject,
    // Label 384: @11973
    GIM_Reject,
    // Label 320: @11974
    GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(12088),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(12042), // Rule ID 46050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46050,
        GIR_EraseRootFromParent_Done,
      // Label 388: @12042
      GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(12087), // Rule ID 46051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46051,
        GIR_EraseRootFromParent_Done,
      // Label 389: @12087
      GIM_Reject,
    // Label 387: @12088
    GIM_Reject,
    // Label 321: @12089
    GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(12203),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(12157), // Rule ID 46066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46066,
        GIR_EraseRootFromParent_Done,
      // Label 391: @12157
      GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(12202), // Rule ID 46067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46067,
        GIR_EraseRootFromParent_Done,
      // Label 392: @12202
      GIM_Reject,
    // Label 390: @12203
    GIM_Reject,
    // Label 322: @12204
    GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(12318),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(12272), // Rule ID 46054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46054,
        GIR_EraseRootFromParent_Done,
      // Label 394: @12272
      GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(12317), // Rule ID 46055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 46055,
        GIR_EraseRootFromParent_Done,
      // Label 395: @12317
      GIM_Reject,
    // Label 393: @12318
    GIM_Reject,
    // Label 323: @12319
    GIM_Reject,
    // Label 2: @12320
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 420*/ GIMT_Encode4(15188),
    /*GILLT_s32*//*Label 396*/ GIMT_Encode4(12455),
    /*GILLT_s64*//*Label 397*/ GIMT_Encode4(12489), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 398*/ GIMT_Encode4(12658),
    /*GILLT_nxv1s16*//*Label 399*/ GIMT_Encode4(12773),
    /*GILLT_nxv1s32*//*Label 400*/ GIMT_Encode4(12888),
    /*GILLT_nxv1s64*//*Label 401*/ GIMT_Encode4(13003), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 402*/ GIMT_Encode4(13118),
    /*GILLT_nxv2s16*//*Label 403*/ GIMT_Encode4(13233),
    /*GILLT_nxv2s32*//*Label 404*/ GIMT_Encode4(13348),
    /*GILLT_nxv2s64*//*Label 405*/ GIMT_Encode4(13463), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 406*/ GIMT_Encode4(13578),
    /*GILLT_nxv4s16*//*Label 407*/ GIMT_Encode4(13693),
    /*GILLT_nxv4s32*//*Label 408*/ GIMT_Encode4(13808),
    /*GILLT_nxv4s64*//*Label 409*/ GIMT_Encode4(13923), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 410*/ GIMT_Encode4(14038),
    /*GILLT_nxv8s16*//*Label 411*/ GIMT_Encode4(14153),
    /*GILLT_nxv8s32*//*Label 412*/ GIMT_Encode4(14268),
    /*GILLT_nxv8s64*//*Label 413*/ GIMT_Encode4(14383), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 414*/ GIMT_Encode4(14498),
    /*GILLT_nxv16s16*//*Label 415*/ GIMT_Encode4(14613),
    /*GILLT_nxv16s32*//*Label 416*/ GIMT_Encode4(14728), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 417*/ GIMT_Encode4(14843),
    /*GILLT_nxv32s16*//*Label 418*/ GIMT_Encode4(14958), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 419*/ GIMT_Encode4(15073),
    // Label 396: @12455
    GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(12488), // Rule ID 288 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 288,
      GIR_Done,
    // Label 421: @12488
    GIM_Reject,
    // Label 397: @12489
    GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(12657),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(12633), // Rule ID 310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 310,
        GIR_EraseRootFromParent_Done,
      // Label 423: @12633
      GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(12656), // Rule ID 287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 287,
        GIR_Done,
      // Label 424: @12656
      GIM_Reject,
    // Label 422: @12657
    GIM_Reject,
    // Label 398: @12658
    GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(12772),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(12726), // Rule ID 50410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50410,
        GIR_EraseRootFromParent_Done,
      // Label 426: @12726
      GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(12771), // Rule ID 50411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50411,
        GIR_EraseRootFromParent_Done,
      // Label 427: @12771
      GIM_Reject,
    // Label 425: @12772
    GIM_Reject,
    // Label 399: @12773
    GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(12887),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(12841), // Rule ID 50422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50422,
        GIR_EraseRootFromParent_Done,
      // Label 429: @12841
      GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(12886), // Rule ID 50423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50423,
        GIR_EraseRootFromParent_Done,
      // Label 430: @12886
      GIM_Reject,
    // Label 428: @12887
    GIM_Reject,
    // Label 400: @12888
    GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(13002),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(12956), // Rule ID 50430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50430,
        GIR_EraseRootFromParent_Done,
      // Label 432: @12956
      GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(13001), // Rule ID 50431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50431,
        GIR_EraseRootFromParent_Done,
      // Label 433: @13001
      GIM_Reject,
    // Label 431: @13002
    GIM_Reject,
    // Label 401: @13003
    GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(13117),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(13071), // Rule ID 50446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50446,
        GIR_EraseRootFromParent_Done,
      // Label 435: @13071
      GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(13116), // Rule ID 50447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50447,
        GIR_EraseRootFromParent_Done,
      // Label 436: @13116
      GIM_Reject,
    // Label 434: @13117
    GIM_Reject,
    // Label 402: @13118
    GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(13232),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(13186), // Rule ID 50414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50414,
        GIR_EraseRootFromParent_Done,
      // Label 438: @13186
      GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(13231), // Rule ID 50415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50415,
        GIR_EraseRootFromParent_Done,
      // Label 439: @13231
      GIM_Reject,
    // Label 437: @13232
    GIM_Reject,
    // Label 403: @13233
    GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(13347),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(13301), // Rule ID 50426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50426,
        GIR_EraseRootFromParent_Done,
      // Label 441: @13301
      GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(13346), // Rule ID 50427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50427,
        GIR_EraseRootFromParent_Done,
      // Label 442: @13346
      GIM_Reject,
    // Label 440: @13347
    GIM_Reject,
    // Label 404: @13348
    GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(13462),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(13416), // Rule ID 50442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50442,
        GIR_EraseRootFromParent_Done,
      // Label 444: @13416
      GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(13461), // Rule ID 50443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50443,
        GIR_EraseRootFromParent_Done,
      // Label 445: @13461
      GIM_Reject,
    // Label 443: @13462
    GIM_Reject,
    // Label 405: @13463
    GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(13577),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(13531), // Rule ID 50486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50486,
        GIR_EraseRootFromParent_Done,
      // Label 447: @13531
      GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(13576), // Rule ID 50487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50487,
        GIR_EraseRootFromParent_Done,
      // Label 448: @13576
      GIM_Reject,
    // Label 446: @13577
    GIM_Reject,
    // Label 406: @13578
    GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(13692),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(13646), // Rule ID 50418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50418,
        GIR_EraseRootFromParent_Done,
      // Label 450: @13646
      GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(13691), // Rule ID 50419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50419,
        GIR_EraseRootFromParent_Done,
      // Label 451: @13691
      GIM_Reject,
    // Label 449: @13692
    GIM_Reject,
    // Label 407: @13693
    GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(13807),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(13761), // Rule ID 50438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50438,
        GIR_EraseRootFromParent_Done,
      // Label 453: @13761
      GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(13806), // Rule ID 50439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50439,
        GIR_EraseRootFromParent_Done,
      // Label 454: @13806
      GIM_Reject,
    // Label 452: @13807
    GIM_Reject,
    // Label 408: @13808
    GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(13922),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(13876), // Rule ID 50474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50474,
        GIR_EraseRootFromParent_Done,
      // Label 456: @13876
      GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(13921), // Rule ID 50475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50475,
        GIR_EraseRootFromParent_Done,
      // Label 457: @13921
      GIM_Reject,
    // Label 455: @13922
    GIM_Reject,
    // Label 409: @13923
    GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(14037),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(13991), // Rule ID 50490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50490,
        GIR_EraseRootFromParent_Done,
      // Label 459: @13991
      GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(14036), // Rule ID 50491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50491,
        GIR_EraseRootFromParent_Done,
      // Label 460: @14036
      GIM_Reject,
    // Label 458: @14037
    GIM_Reject,
    // Label 410: @14038
    GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(14152),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(14106), // Rule ID 50434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50434,
        GIR_EraseRootFromParent_Done,
      // Label 462: @14106
      GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(14151), // Rule ID 50435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50435,
        GIR_EraseRootFromParent_Done,
      // Label 463: @14151
      GIM_Reject,
    // Label 461: @14152
    GIM_Reject,
    // Label 411: @14153
    GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(14267),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(14221), // Rule ID 50462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50462,
        GIR_EraseRootFromParent_Done,
      // Label 465: @14221
      GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(14266), // Rule ID 50463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50463,
        GIR_EraseRootFromParent_Done,
      // Label 466: @14266
      GIM_Reject,
    // Label 464: @14267
    GIM_Reject,
    // Label 412: @14268
    GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(14382),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(14336), // Rule ID 50478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50478,
        GIR_EraseRootFromParent_Done,
      // Label 468: @14336
      GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(14381), // Rule ID 50479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50479,
        GIR_EraseRootFromParent_Done,
      // Label 469: @14381
      GIM_Reject,
    // Label 467: @14382
    GIM_Reject,
    // Label 413: @14383
    GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(14497),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(14451), // Rule ID 50494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50494,
        GIR_EraseRootFromParent_Done,
      // Label 471: @14451
      GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(14496), // Rule ID 50495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50495,
        GIR_EraseRootFromParent_Done,
      // Label 472: @14496
      GIM_Reject,
    // Label 470: @14497
    GIM_Reject,
    // Label 414: @14498
    GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(14612),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(14566), // Rule ID 50450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50450,
        GIR_EraseRootFromParent_Done,
      // Label 474: @14566
      GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(14611), // Rule ID 50451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50451,
        GIR_EraseRootFromParent_Done,
      // Label 475: @14611
      GIM_Reject,
    // Label 473: @14612
    GIM_Reject,
    // Label 415: @14613
    GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(14727),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(14681), // Rule ID 50466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50466,
        GIR_EraseRootFromParent_Done,
      // Label 477: @14681
      GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(14726), // Rule ID 50467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50467,
        GIR_EraseRootFromParent_Done,
      // Label 478: @14726
      GIM_Reject,
    // Label 476: @14727
    GIM_Reject,
    // Label 416: @14728
    GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(14842),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(14796), // Rule ID 50482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50482,
        GIR_EraseRootFromParent_Done,
      // Label 480: @14796
      GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(14841), // Rule ID 50483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50483,
        GIR_EraseRootFromParent_Done,
      // Label 481: @14841
      GIM_Reject,
    // Label 479: @14842
    GIM_Reject,
    // Label 417: @14843
    GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(14957),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(14911), // Rule ID 50454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50454,
        GIR_EraseRootFromParent_Done,
      // Label 483: @14911
      GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(14956), // Rule ID 50455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50455,
        GIR_EraseRootFromParent_Done,
      // Label 484: @14956
      GIM_Reject,
    // Label 482: @14957
    GIM_Reject,
    // Label 418: @14958
    GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(15072),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(15026), // Rule ID 50470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50470,
        GIR_EraseRootFromParent_Done,
      // Label 486: @15026
      GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(15071), // Rule ID 50471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50471,
        GIR_EraseRootFromParent_Done,
      // Label 487: @15071
      GIM_Reject,
    // Label 485: @15072
    GIM_Reject,
    // Label 419: @15073
    GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(15187),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(15141), // Rule ID 50458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50458,
        GIR_EraseRootFromParent_Done,
      // Label 489: @15141
      GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(15186), // Rule ID 50459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50459,
        GIR_EraseRootFromParent_Done,
      // Label 490: @15186
      GIM_Reject,
    // Label 488: @15187
    GIM_Reject,
    // Label 420: @15188
    GIM_Reject,
    // Label 3: @15189
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 515*/ GIMT_Encode4(17922),
    /*GILLT_s32*//*Label 491*/ GIMT_Encode4(15324),
    /*GILLT_s64*//*Label 492*/ GIMT_Encode4(15358), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 493*/ GIMT_Encode4(15392),
    /*GILLT_nxv1s16*//*Label 494*/ GIMT_Encode4(15507),
    /*GILLT_nxv1s32*//*Label 495*/ GIMT_Encode4(15622),
    /*GILLT_nxv1s64*//*Label 496*/ GIMT_Encode4(15737), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 497*/ GIMT_Encode4(15852),
    /*GILLT_nxv2s16*//*Label 498*/ GIMT_Encode4(15967),
    /*GILLT_nxv2s32*//*Label 499*/ GIMT_Encode4(16082),
    /*GILLT_nxv2s64*//*Label 500*/ GIMT_Encode4(16197), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 501*/ GIMT_Encode4(16312),
    /*GILLT_nxv4s16*//*Label 502*/ GIMT_Encode4(16427),
    /*GILLT_nxv4s32*//*Label 503*/ GIMT_Encode4(16542),
    /*GILLT_nxv4s64*//*Label 504*/ GIMT_Encode4(16657), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 505*/ GIMT_Encode4(16772),
    /*GILLT_nxv8s16*//*Label 506*/ GIMT_Encode4(16887),
    /*GILLT_nxv8s32*//*Label 507*/ GIMT_Encode4(17002),
    /*GILLT_nxv8s64*//*Label 508*/ GIMT_Encode4(17117), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 509*/ GIMT_Encode4(17232),
    /*GILLT_nxv16s16*//*Label 510*/ GIMT_Encode4(17347),
    /*GILLT_nxv16s32*//*Label 511*/ GIMT_Encode4(17462), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 512*/ GIMT_Encode4(17577),
    /*GILLT_nxv32s16*//*Label 513*/ GIMT_Encode4(17692), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 514*/ GIMT_Encode4(17807),
    // Label 491: @15324
    GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(15357), // Rule ID 296 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 296,
      GIR_Done,
    // Label 516: @15357
    GIM_Reject,
    // Label 492: @15358
    GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(15391), // Rule ID 295 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 295,
      GIR_Done,
    // Label 517: @15391
    GIM_Reject,
    // Label 493: @15392
    GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(15506),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(15460), // Rule ID 50762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50762,
        GIR_EraseRootFromParent_Done,
      // Label 519: @15460
      GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(15505), // Rule ID 50763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50763,
        GIR_EraseRootFromParent_Done,
      // Label 520: @15505
      GIM_Reject,
    // Label 518: @15506
    GIM_Reject,
    // Label 494: @15507
    GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(15621),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(15575), // Rule ID 50774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50774,
        GIR_EraseRootFromParent_Done,
      // Label 522: @15575
      GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(15620), // Rule ID 50775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50775,
        GIR_EraseRootFromParent_Done,
      // Label 523: @15620
      GIM_Reject,
    // Label 521: @15621
    GIM_Reject,
    // Label 495: @15622
    GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(15736),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(15690), // Rule ID 50782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50782,
        GIR_EraseRootFromParent_Done,
      // Label 525: @15690
      GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(15735), // Rule ID 50783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50783,
        GIR_EraseRootFromParent_Done,
      // Label 526: @15735
      GIM_Reject,
    // Label 524: @15736
    GIM_Reject,
    // Label 496: @15737
    GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(15851),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(15805), // Rule ID 50798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50798,
        GIR_EraseRootFromParent_Done,
      // Label 528: @15805
      GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(15850), // Rule ID 50799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50799,
        GIR_EraseRootFromParent_Done,
      // Label 529: @15850
      GIM_Reject,
    // Label 527: @15851
    GIM_Reject,
    // Label 497: @15852
    GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(15966),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(15920), // Rule ID 50766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50766,
        GIR_EraseRootFromParent_Done,
      // Label 531: @15920
      GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(15965), // Rule ID 50767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50767,
        GIR_EraseRootFromParent_Done,
      // Label 532: @15965
      GIM_Reject,
    // Label 530: @15966
    GIM_Reject,
    // Label 498: @15967
    GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(16081),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(16035), // Rule ID 50778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50778,
        GIR_EraseRootFromParent_Done,
      // Label 534: @16035
      GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(16080), // Rule ID 50779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50779,
        GIR_EraseRootFromParent_Done,
      // Label 535: @16080
      GIM_Reject,
    // Label 533: @16081
    GIM_Reject,
    // Label 499: @16082
    GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(16196),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(16150), // Rule ID 50794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50794,
        GIR_EraseRootFromParent_Done,
      // Label 537: @16150
      GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(16195), // Rule ID 50795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50795,
        GIR_EraseRootFromParent_Done,
      // Label 538: @16195
      GIM_Reject,
    // Label 536: @16196
    GIM_Reject,
    // Label 500: @16197
    GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(16311),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(16265), // Rule ID 50838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50838,
        GIR_EraseRootFromParent_Done,
      // Label 540: @16265
      GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(16310), // Rule ID 50839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50839,
        GIR_EraseRootFromParent_Done,
      // Label 541: @16310
      GIM_Reject,
    // Label 539: @16311
    GIM_Reject,
    // Label 501: @16312
    GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(16426),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(16380), // Rule ID 50770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50770,
        GIR_EraseRootFromParent_Done,
      // Label 543: @16380
      GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(16425), // Rule ID 50771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50771,
        GIR_EraseRootFromParent_Done,
      // Label 544: @16425
      GIM_Reject,
    // Label 542: @16426
    GIM_Reject,
    // Label 502: @16427
    GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(16541),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(16495), // Rule ID 50790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50790,
        GIR_EraseRootFromParent_Done,
      // Label 546: @16495
      GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(16540), // Rule ID 50791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50791,
        GIR_EraseRootFromParent_Done,
      // Label 547: @16540
      GIM_Reject,
    // Label 545: @16541
    GIM_Reject,
    // Label 503: @16542
    GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(16656),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(16610), // Rule ID 50826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50826,
        GIR_EraseRootFromParent_Done,
      // Label 549: @16610
      GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(16655), // Rule ID 50827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50827,
        GIR_EraseRootFromParent_Done,
      // Label 550: @16655
      GIM_Reject,
    // Label 548: @16656
    GIM_Reject,
    // Label 504: @16657
    GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(16771),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(16725), // Rule ID 50842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50842,
        GIR_EraseRootFromParent_Done,
      // Label 552: @16725
      GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(16770), // Rule ID 50843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50843,
        GIR_EraseRootFromParent_Done,
      // Label 553: @16770
      GIM_Reject,
    // Label 551: @16771
    GIM_Reject,
    // Label 505: @16772
    GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(16886),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(16840), // Rule ID 50786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50786,
        GIR_EraseRootFromParent_Done,
      // Label 555: @16840
      GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(16885), // Rule ID 50787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50787,
        GIR_EraseRootFromParent_Done,
      // Label 556: @16885
      GIM_Reject,
    // Label 554: @16886
    GIM_Reject,
    // Label 506: @16887
    GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(17001),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(16955), // Rule ID 50814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50814,
        GIR_EraseRootFromParent_Done,
      // Label 558: @16955
      GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(17000), // Rule ID 50815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50815,
        GIR_EraseRootFromParent_Done,
      // Label 559: @17000
      GIM_Reject,
    // Label 557: @17001
    GIM_Reject,
    // Label 507: @17002
    GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(17116),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(17070), // Rule ID 50830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50830,
        GIR_EraseRootFromParent_Done,
      // Label 561: @17070
      GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(17115), // Rule ID 50831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50831,
        GIR_EraseRootFromParent_Done,
      // Label 562: @17115
      GIM_Reject,
    // Label 560: @17116
    GIM_Reject,
    // Label 508: @17117
    GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(17231),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(17185), // Rule ID 50846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50846,
        GIR_EraseRootFromParent_Done,
      // Label 564: @17185
      GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(17230), // Rule ID 50847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50847,
        GIR_EraseRootFromParent_Done,
      // Label 565: @17230
      GIM_Reject,
    // Label 563: @17231
    GIM_Reject,
    // Label 509: @17232
    GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(17346),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(17300), // Rule ID 50802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50802,
        GIR_EraseRootFromParent_Done,
      // Label 567: @17300
      GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(17345), // Rule ID 50803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50803,
        GIR_EraseRootFromParent_Done,
      // Label 568: @17345
      GIM_Reject,
    // Label 566: @17346
    GIM_Reject,
    // Label 510: @17347
    GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(17461),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(17415), // Rule ID 50818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50818,
        GIR_EraseRootFromParent_Done,
      // Label 570: @17415
      GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(17460), // Rule ID 50819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50819,
        GIR_EraseRootFromParent_Done,
      // Label 571: @17460
      GIM_Reject,
    // Label 569: @17461
    GIM_Reject,
    // Label 511: @17462
    GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(17576),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(17530), // Rule ID 50834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50834,
        GIR_EraseRootFromParent_Done,
      // Label 573: @17530
      GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(17575), // Rule ID 50835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50835,
        GIR_EraseRootFromParent_Done,
      // Label 574: @17575
      GIM_Reject,
    // Label 572: @17576
    GIM_Reject,
    // Label 512: @17577
    GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(17691),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(17645), // Rule ID 50806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50806,
        GIR_EraseRootFromParent_Done,
      // Label 576: @17645
      GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(17690), // Rule ID 50807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50807,
        GIR_EraseRootFromParent_Done,
      // Label 577: @17690
      GIM_Reject,
    // Label 575: @17691
    GIM_Reject,
    // Label 513: @17692
    GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(17806),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(17760), // Rule ID 50822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50822,
        GIR_EraseRootFromParent_Done,
      // Label 579: @17760
      GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(17805), // Rule ID 50823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50823,
        GIR_EraseRootFromParent_Done,
      // Label 580: @17805
      GIM_Reject,
    // Label 578: @17806
    GIM_Reject,
    // Label 514: @17807
    GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(17921),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(17875), // Rule ID 50810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50810,
        GIR_EraseRootFromParent_Done,
      // Label 582: @17875
      GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(17920), // Rule ID 50811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50811,
        GIR_EraseRootFromParent_Done,
      // Label 583: @17920
      GIM_Reject,
    // Label 581: @17921
    GIM_Reject,
    // Label 515: @17922
    GIM_Reject,
    // Label 4: @17923
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 608*/ GIMT_Encode4(20656),
    /*GILLT_s32*//*Label 584*/ GIMT_Encode4(18058),
    /*GILLT_s64*//*Label 585*/ GIMT_Encode4(18092), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 586*/ GIMT_Encode4(18126),
    /*GILLT_nxv1s16*//*Label 587*/ GIMT_Encode4(18241),
    /*GILLT_nxv1s32*//*Label 588*/ GIMT_Encode4(18356),
    /*GILLT_nxv1s64*//*Label 589*/ GIMT_Encode4(18471), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 590*/ GIMT_Encode4(18586),
    /*GILLT_nxv2s16*//*Label 591*/ GIMT_Encode4(18701),
    /*GILLT_nxv2s32*//*Label 592*/ GIMT_Encode4(18816),
    /*GILLT_nxv2s64*//*Label 593*/ GIMT_Encode4(18931), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 594*/ GIMT_Encode4(19046),
    /*GILLT_nxv4s16*//*Label 595*/ GIMT_Encode4(19161),
    /*GILLT_nxv4s32*//*Label 596*/ GIMT_Encode4(19276),
    /*GILLT_nxv4s64*//*Label 597*/ GIMT_Encode4(19391), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 598*/ GIMT_Encode4(19506),
    /*GILLT_nxv8s16*//*Label 599*/ GIMT_Encode4(19621),
    /*GILLT_nxv8s32*//*Label 600*/ GIMT_Encode4(19736),
    /*GILLT_nxv8s64*//*Label 601*/ GIMT_Encode4(19851), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 602*/ GIMT_Encode4(19966),
    /*GILLT_nxv16s16*//*Label 603*/ GIMT_Encode4(20081),
    /*GILLT_nxv16s32*//*Label 604*/ GIMT_Encode4(20196), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 605*/ GIMT_Encode4(20311),
    /*GILLT_nxv32s16*//*Label 606*/ GIMT_Encode4(20426), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 607*/ GIMT_Encode4(20541),
    // Label 584: @18058
    GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(18091), // Rule ID 298 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 298,
      GIR_Done,
    // Label 609: @18091
    GIM_Reject,
    // Label 585: @18092
    GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(18125), // Rule ID 297 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 297,
      GIR_Done,
    // Label 610: @18125
    GIM_Reject,
    // Label 586: @18126
    GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(18240),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(18194), // Rule ID 50674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50674,
        GIR_EraseRootFromParent_Done,
      // Label 612: @18194
      GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(18239), // Rule ID 50675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50675,
        GIR_EraseRootFromParent_Done,
      // Label 613: @18239
      GIM_Reject,
    // Label 611: @18240
    GIM_Reject,
    // Label 587: @18241
    GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(18355),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(18309), // Rule ID 50686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50686,
        GIR_EraseRootFromParent_Done,
      // Label 615: @18309
      GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(18354), // Rule ID 50687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50687,
        GIR_EraseRootFromParent_Done,
      // Label 616: @18354
      GIM_Reject,
    // Label 614: @18355
    GIM_Reject,
    // Label 588: @18356
    GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(18470),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(18424), // Rule ID 50694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50694,
        GIR_EraseRootFromParent_Done,
      // Label 618: @18424
      GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(18469), // Rule ID 50695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50695,
        GIR_EraseRootFromParent_Done,
      // Label 619: @18469
      GIM_Reject,
    // Label 617: @18470
    GIM_Reject,
    // Label 589: @18471
    GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(18585),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(18539), // Rule ID 50710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50710,
        GIR_EraseRootFromParent_Done,
      // Label 621: @18539
      GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(18584), // Rule ID 50711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50711,
        GIR_EraseRootFromParent_Done,
      // Label 622: @18584
      GIM_Reject,
    // Label 620: @18585
    GIM_Reject,
    // Label 590: @18586
    GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(18700),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(18654), // Rule ID 50678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50678,
        GIR_EraseRootFromParent_Done,
      // Label 624: @18654
      GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(18699), // Rule ID 50679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50679,
        GIR_EraseRootFromParent_Done,
      // Label 625: @18699
      GIM_Reject,
    // Label 623: @18700
    GIM_Reject,
    // Label 591: @18701
    GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(18815),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(18769), // Rule ID 50690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50690,
        GIR_EraseRootFromParent_Done,
      // Label 627: @18769
      GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(18814), // Rule ID 50691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50691,
        GIR_EraseRootFromParent_Done,
      // Label 628: @18814
      GIM_Reject,
    // Label 626: @18815
    GIM_Reject,
    // Label 592: @18816
    GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(18930),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(18884), // Rule ID 50706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50706,
        GIR_EraseRootFromParent_Done,
      // Label 630: @18884
      GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(18929), // Rule ID 50707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50707,
        GIR_EraseRootFromParent_Done,
      // Label 631: @18929
      GIM_Reject,
    // Label 629: @18930
    GIM_Reject,
    // Label 593: @18931
    GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(19045),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(18999), // Rule ID 50750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50750,
        GIR_EraseRootFromParent_Done,
      // Label 633: @18999
      GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(19044), // Rule ID 50751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50751,
        GIR_EraseRootFromParent_Done,
      // Label 634: @19044
      GIM_Reject,
    // Label 632: @19045
    GIM_Reject,
    // Label 594: @19046
    GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(19160),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(19114), // Rule ID 50682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50682,
        GIR_EraseRootFromParent_Done,
      // Label 636: @19114
      GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(19159), // Rule ID 50683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50683,
        GIR_EraseRootFromParent_Done,
      // Label 637: @19159
      GIM_Reject,
    // Label 635: @19160
    GIM_Reject,
    // Label 595: @19161
    GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(19275),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(19229), // Rule ID 50702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50702,
        GIR_EraseRootFromParent_Done,
      // Label 639: @19229
      GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(19274), // Rule ID 50703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50703,
        GIR_EraseRootFromParent_Done,
      // Label 640: @19274
      GIM_Reject,
    // Label 638: @19275
    GIM_Reject,
    // Label 596: @19276
    GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(19390),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(19344), // Rule ID 50738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50738,
        GIR_EraseRootFromParent_Done,
      // Label 642: @19344
      GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(19389), // Rule ID 50739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50739,
        GIR_EraseRootFromParent_Done,
      // Label 643: @19389
      GIM_Reject,
    // Label 641: @19390
    GIM_Reject,
    // Label 597: @19391
    GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(19505),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(19459), // Rule ID 50754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50754,
        GIR_EraseRootFromParent_Done,
      // Label 645: @19459
      GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(19504), // Rule ID 50755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50755,
        GIR_EraseRootFromParent_Done,
      // Label 646: @19504
      GIM_Reject,
    // Label 644: @19505
    GIM_Reject,
    // Label 598: @19506
    GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(19620),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(19574), // Rule ID 50698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50698,
        GIR_EraseRootFromParent_Done,
      // Label 648: @19574
      GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(19619), // Rule ID 50699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50699,
        GIR_EraseRootFromParent_Done,
      // Label 649: @19619
      GIM_Reject,
    // Label 647: @19620
    GIM_Reject,
    // Label 599: @19621
    GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(19735),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(19689), // Rule ID 50726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50726,
        GIR_EraseRootFromParent_Done,
      // Label 651: @19689
      GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(19734), // Rule ID 50727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50727,
        GIR_EraseRootFromParent_Done,
      // Label 652: @19734
      GIM_Reject,
    // Label 650: @19735
    GIM_Reject,
    // Label 600: @19736
    GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(19850),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(19804), // Rule ID 50742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50742,
        GIR_EraseRootFromParent_Done,
      // Label 654: @19804
      GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(19849), // Rule ID 50743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50743,
        GIR_EraseRootFromParent_Done,
      // Label 655: @19849
      GIM_Reject,
    // Label 653: @19850
    GIM_Reject,
    // Label 601: @19851
    GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(19965),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(19919), // Rule ID 50758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50758,
        GIR_EraseRootFromParent_Done,
      // Label 657: @19919
      GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(19964), // Rule ID 50759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50759,
        GIR_EraseRootFromParent_Done,
      // Label 658: @19964
      GIM_Reject,
    // Label 656: @19965
    GIM_Reject,
    // Label 602: @19966
    GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(20080),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(20034), // Rule ID 50714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50714,
        GIR_EraseRootFromParent_Done,
      // Label 660: @20034
      GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(20079), // Rule ID 50715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50715,
        GIR_EraseRootFromParent_Done,
      // Label 661: @20079
      GIM_Reject,
    // Label 659: @20080
    GIM_Reject,
    // Label 603: @20081
    GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(20195),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(20149), // Rule ID 50730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50730,
        GIR_EraseRootFromParent_Done,
      // Label 663: @20149
      GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(20194), // Rule ID 50731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50731,
        GIR_EraseRootFromParent_Done,
      // Label 664: @20194
      GIM_Reject,
    // Label 662: @20195
    GIM_Reject,
    // Label 604: @20196
    GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(20310),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(20264), // Rule ID 50746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50746,
        GIR_EraseRootFromParent_Done,
      // Label 666: @20264
      GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(20309), // Rule ID 50747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50747,
        GIR_EraseRootFromParent_Done,
      // Label 667: @20309
      GIM_Reject,
    // Label 665: @20310
    GIM_Reject,
    // Label 605: @20311
    GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(20425),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(20379), // Rule ID 50718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50718,
        GIR_EraseRootFromParent_Done,
      // Label 669: @20379
      GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(20424), // Rule ID 50719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50719,
        GIR_EraseRootFromParent_Done,
      // Label 670: @20424
      GIM_Reject,
    // Label 668: @20425
    GIM_Reject,
    // Label 606: @20426
    GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(20540),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(20494), // Rule ID 50734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50734,
        GIR_EraseRootFromParent_Done,
      // Label 672: @20494
      GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(20539), // Rule ID 50735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50735,
        GIR_EraseRootFromParent_Done,
      // Label 673: @20539
      GIM_Reject,
    // Label 671: @20540
    GIM_Reject,
    // Label 607: @20541
    GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(20655),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(20609), // Rule ID 50722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50722,
        GIR_EraseRootFromParent_Done,
      // Label 675: @20609
      GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(20654), // Rule ID 50723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50723,
        GIR_EraseRootFromParent_Done,
      // Label 676: @20654
      GIM_Reject,
    // Label 674: @20655
    GIM_Reject,
    // Label 608: @20656
    GIM_Reject,
    // Label 5: @20657
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 701*/ GIMT_Encode4(23435),
    /*GILLT_s32*//*Label 677*/ GIMT_Encode4(20792),
    /*GILLT_s64*//*Label 678*/ GIMT_Encode4(20826), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 679*/ GIMT_Encode4(20905),
    /*GILLT_nxv1s16*//*Label 680*/ GIMT_Encode4(21020),
    /*GILLT_nxv1s32*//*Label 681*/ GIMT_Encode4(21135),
    /*GILLT_nxv1s64*//*Label 682*/ GIMT_Encode4(21250), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 683*/ GIMT_Encode4(21365),
    /*GILLT_nxv2s16*//*Label 684*/ GIMT_Encode4(21480),
    /*GILLT_nxv2s32*//*Label 685*/ GIMT_Encode4(21595),
    /*GILLT_nxv2s64*//*Label 686*/ GIMT_Encode4(21710), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 687*/ GIMT_Encode4(21825),
    /*GILLT_nxv4s16*//*Label 688*/ GIMT_Encode4(21940),
    /*GILLT_nxv4s32*//*Label 689*/ GIMT_Encode4(22055),
    /*GILLT_nxv4s64*//*Label 690*/ GIMT_Encode4(22170), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 691*/ GIMT_Encode4(22285),
    /*GILLT_nxv8s16*//*Label 692*/ GIMT_Encode4(22400),
    /*GILLT_nxv8s32*//*Label 693*/ GIMT_Encode4(22515),
    /*GILLT_nxv8s64*//*Label 694*/ GIMT_Encode4(22630), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 695*/ GIMT_Encode4(22745),
    /*GILLT_nxv16s16*//*Label 696*/ GIMT_Encode4(22860),
    /*GILLT_nxv16s32*//*Label 697*/ GIMT_Encode4(22975), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 698*/ GIMT_Encode4(23090),
    /*GILLT_nxv32s16*//*Label 699*/ GIMT_Encode4(23205), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 700*/ GIMT_Encode4(23320),
    // Label 677: @20792
    GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(20825), // Rule ID 300 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 300,
      GIR_Done,
    // Label 702: @20825
    GIM_Reject,
    // Label 678: @20826
    GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(20904),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(20880), // Rule ID 309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
        // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 309,
        GIR_EraseRootFromParent_Done,
      // Label 704: @20880
      GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(20903), // Rule ID 299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 299,
        GIR_Done,
      // Label 705: @20903
      GIM_Reject,
    // Label 703: @20904
    GIM_Reject,
    // Label 679: @20905
    GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(21019),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(20973), // Rule ID 50938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50938,
        GIR_EraseRootFromParent_Done,
      // Label 707: @20973
      GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(21018), // Rule ID 50939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50939,
        GIR_EraseRootFromParent_Done,
      // Label 708: @21018
      GIM_Reject,
    // Label 706: @21019
    GIM_Reject,
    // Label 680: @21020
    GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(21134),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(21088), // Rule ID 50950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50950,
        GIR_EraseRootFromParent_Done,
      // Label 710: @21088
      GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(21133), // Rule ID 50951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50951,
        GIR_EraseRootFromParent_Done,
      // Label 711: @21133
      GIM_Reject,
    // Label 709: @21134
    GIM_Reject,
    // Label 681: @21135
    GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(21249),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(21203), // Rule ID 50958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50958,
        GIR_EraseRootFromParent_Done,
      // Label 713: @21203
      GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(21248), // Rule ID 50959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50959,
        GIR_EraseRootFromParent_Done,
      // Label 714: @21248
      GIM_Reject,
    // Label 712: @21249
    GIM_Reject,
    // Label 682: @21250
    GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(21364),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(21318), // Rule ID 50974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50974,
        GIR_EraseRootFromParent_Done,
      // Label 716: @21318
      GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(21363), // Rule ID 50975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50975,
        GIR_EraseRootFromParent_Done,
      // Label 717: @21363
      GIM_Reject,
    // Label 715: @21364
    GIM_Reject,
    // Label 683: @21365
    GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(21479),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(21433), // Rule ID 50942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50942,
        GIR_EraseRootFromParent_Done,
      // Label 719: @21433
      GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(21478), // Rule ID 50943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50943,
        GIR_EraseRootFromParent_Done,
      // Label 720: @21478
      GIM_Reject,
    // Label 718: @21479
    GIM_Reject,
    // Label 684: @21480
    GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(21594),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(21548), // Rule ID 50954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50954,
        GIR_EraseRootFromParent_Done,
      // Label 722: @21548
      GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(21593), // Rule ID 50955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50955,
        GIR_EraseRootFromParent_Done,
      // Label 723: @21593
      GIM_Reject,
    // Label 721: @21594
    GIM_Reject,
    // Label 685: @21595
    GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(21709),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(21663), // Rule ID 50970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50970,
        GIR_EraseRootFromParent_Done,
      // Label 725: @21663
      GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(21708), // Rule ID 50971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50971,
        GIR_EraseRootFromParent_Done,
      // Label 726: @21708
      GIM_Reject,
    // Label 724: @21709
    GIM_Reject,
    // Label 686: @21710
    GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(21824),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(21778), // Rule ID 51014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51014,
        GIR_EraseRootFromParent_Done,
      // Label 728: @21778
      GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(21823), // Rule ID 51015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51015,
        GIR_EraseRootFromParent_Done,
      // Label 729: @21823
      GIM_Reject,
    // Label 727: @21824
    GIM_Reject,
    // Label 687: @21825
    GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(21939),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(21893), // Rule ID 50946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50946,
        GIR_EraseRootFromParent_Done,
      // Label 731: @21893
      GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(21938), // Rule ID 50947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50947,
        GIR_EraseRootFromParent_Done,
      // Label 732: @21938
      GIM_Reject,
    // Label 730: @21939
    GIM_Reject,
    // Label 688: @21940
    GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(22054),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(22008), // Rule ID 50966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50966,
        GIR_EraseRootFromParent_Done,
      // Label 734: @22008
      GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(22053), // Rule ID 50967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50967,
        GIR_EraseRootFromParent_Done,
      // Label 735: @22053
      GIM_Reject,
    // Label 733: @22054
    GIM_Reject,
    // Label 689: @22055
    GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(22169),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(22123), // Rule ID 51002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51002,
        GIR_EraseRootFromParent_Done,
      // Label 737: @22123
      GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(22168), // Rule ID 51003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51003,
        GIR_EraseRootFromParent_Done,
      // Label 738: @22168
      GIM_Reject,
    // Label 736: @22169
    GIM_Reject,
    // Label 690: @22170
    GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(22284),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(22238), // Rule ID 51018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51018,
        GIR_EraseRootFromParent_Done,
      // Label 740: @22238
      GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(22283), // Rule ID 51019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51019,
        GIR_EraseRootFromParent_Done,
      // Label 741: @22283
      GIM_Reject,
    // Label 739: @22284
    GIM_Reject,
    // Label 691: @22285
    GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(22399),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(22353), // Rule ID 50962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50962,
        GIR_EraseRootFromParent_Done,
      // Label 743: @22353
      GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(22398), // Rule ID 50963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50963,
        GIR_EraseRootFromParent_Done,
      // Label 744: @22398
      GIM_Reject,
    // Label 742: @22399
    GIM_Reject,
    // Label 692: @22400
    GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(22514),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(22468), // Rule ID 50990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50990,
        GIR_EraseRootFromParent_Done,
      // Label 746: @22468
      GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(22513), // Rule ID 50991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50991,
        GIR_EraseRootFromParent_Done,
      // Label 747: @22513
      GIM_Reject,
    // Label 745: @22514
    GIM_Reject,
    // Label 693: @22515
    GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(22629),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(22583), // Rule ID 51006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51006,
        GIR_EraseRootFromParent_Done,
      // Label 749: @22583
      GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(22628), // Rule ID 51007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51007,
        GIR_EraseRootFromParent_Done,
      // Label 750: @22628
      GIM_Reject,
    // Label 748: @22629
    GIM_Reject,
    // Label 694: @22630
    GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(22744),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(22698), // Rule ID 51022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51022,
        GIR_EraseRootFromParent_Done,
      // Label 752: @22698
      GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(22743), // Rule ID 51023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51023,
        GIR_EraseRootFromParent_Done,
      // Label 753: @22743
      GIM_Reject,
    // Label 751: @22744
    GIM_Reject,
    // Label 695: @22745
    GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(22859),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(22813), // Rule ID 50978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50978,
        GIR_EraseRootFromParent_Done,
      // Label 755: @22813
      GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(22858), // Rule ID 50979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50979,
        GIR_EraseRootFromParent_Done,
      // Label 756: @22858
      GIM_Reject,
    // Label 754: @22859
    GIM_Reject,
    // Label 696: @22860
    GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(22974),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(22928), // Rule ID 50994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50994,
        GIR_EraseRootFromParent_Done,
      // Label 758: @22928
      GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(22973), // Rule ID 50995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50995,
        GIR_EraseRootFromParent_Done,
      // Label 759: @22973
      GIM_Reject,
    // Label 757: @22974
    GIM_Reject,
    // Label 697: @22975
    GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(23089),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(23043), // Rule ID 51010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51010,
        GIR_EraseRootFromParent_Done,
      // Label 761: @23043
      GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(23088), // Rule ID 51011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51011,
        GIR_EraseRootFromParent_Done,
      // Label 762: @23088
      GIM_Reject,
    // Label 760: @23089
    GIM_Reject,
    // Label 698: @23090
    GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(23204),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(23158), // Rule ID 50982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50982,
        GIR_EraseRootFromParent_Done,
      // Label 764: @23158
      GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(23203), // Rule ID 50983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50983,
        GIR_EraseRootFromParent_Done,
      // Label 765: @23203
      GIM_Reject,
    // Label 763: @23204
    GIM_Reject,
    // Label 699: @23205
    GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(23319),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(23273), // Rule ID 50998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50998,
        GIR_EraseRootFromParent_Done,
      // Label 767: @23273
      GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(23318), // Rule ID 50999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50999,
        GIR_EraseRootFromParent_Done,
      // Label 768: @23318
      GIM_Reject,
    // Label 766: @23319
    GIM_Reject,
    // Label 700: @23320
    GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(23434),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(23388), // Rule ID 50986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50986,
        GIR_EraseRootFromParent_Done,
      // Label 770: @23388
      GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(23433), // Rule ID 50987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50987,
        GIR_EraseRootFromParent_Done,
      // Label 771: @23433
      GIM_Reject,
    // Label 769: @23434
    GIM_Reject,
    // Label 701: @23435
    GIM_Reject,
    // Label 6: @23436
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 796*/ GIMT_Encode4(26169),
    /*GILLT_s32*//*Label 772*/ GIMT_Encode4(23571),
    /*GILLT_s64*//*Label 773*/ GIMT_Encode4(23605), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 774*/ GIMT_Encode4(23639),
    /*GILLT_nxv1s16*//*Label 775*/ GIMT_Encode4(23754),
    /*GILLT_nxv1s32*//*Label 776*/ GIMT_Encode4(23869),
    /*GILLT_nxv1s64*//*Label 777*/ GIMT_Encode4(23984), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 778*/ GIMT_Encode4(24099),
    /*GILLT_nxv2s16*//*Label 779*/ GIMT_Encode4(24214),
    /*GILLT_nxv2s32*//*Label 780*/ GIMT_Encode4(24329),
    /*GILLT_nxv2s64*//*Label 781*/ GIMT_Encode4(24444), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 782*/ GIMT_Encode4(24559),
    /*GILLT_nxv4s16*//*Label 783*/ GIMT_Encode4(24674),
    /*GILLT_nxv4s32*//*Label 784*/ GIMT_Encode4(24789),
    /*GILLT_nxv4s64*//*Label 785*/ GIMT_Encode4(24904), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 786*/ GIMT_Encode4(25019),
    /*GILLT_nxv8s16*//*Label 787*/ GIMT_Encode4(25134),
    /*GILLT_nxv8s32*//*Label 788*/ GIMT_Encode4(25249),
    /*GILLT_nxv8s64*//*Label 789*/ GIMT_Encode4(25364), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 790*/ GIMT_Encode4(25479),
    /*GILLT_nxv16s16*//*Label 791*/ GIMT_Encode4(25594),
    /*GILLT_nxv16s32*//*Label 792*/ GIMT_Encode4(25709), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 793*/ GIMT_Encode4(25824),
    /*GILLT_nxv32s16*//*Label 794*/ GIMT_Encode4(25939), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 795*/ GIMT_Encode4(26054),
    // Label 772: @23571
    GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(23604), // Rule ID 302 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 302,
      GIR_Done,
    // Label 797: @23604
    GIM_Reject,
    // Label 773: @23605
    GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(23638), // Rule ID 301 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 301,
      GIR_Done,
    // Label 798: @23638
    GIM_Reject,
    // Label 774: @23639
    GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(23753),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(23707), // Rule ID 50850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50850,
        GIR_EraseRootFromParent_Done,
      // Label 800: @23707
      GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(23752), // Rule ID 50851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50851,
        GIR_EraseRootFromParent_Done,
      // Label 801: @23752
      GIM_Reject,
    // Label 799: @23753
    GIM_Reject,
    // Label 775: @23754
    GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(23868),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(23822), // Rule ID 50862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50862,
        GIR_EraseRootFromParent_Done,
      // Label 803: @23822
      GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(23867), // Rule ID 50863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50863,
        GIR_EraseRootFromParent_Done,
      // Label 804: @23867
      GIM_Reject,
    // Label 802: @23868
    GIM_Reject,
    // Label 776: @23869
    GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(23983),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(23937), // Rule ID 50870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50870,
        GIR_EraseRootFromParent_Done,
      // Label 806: @23937
      GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(23982), // Rule ID 50871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50871,
        GIR_EraseRootFromParent_Done,
      // Label 807: @23982
      GIM_Reject,
    // Label 805: @23983
    GIM_Reject,
    // Label 777: @23984
    GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(24098),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(24052), // Rule ID 50886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50886,
        GIR_EraseRootFromParent_Done,
      // Label 809: @24052
      GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(24097), // Rule ID 50887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50887,
        GIR_EraseRootFromParent_Done,
      // Label 810: @24097
      GIM_Reject,
    // Label 808: @24098
    GIM_Reject,
    // Label 778: @24099
    GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(24213),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(24167), // Rule ID 50854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50854,
        GIR_EraseRootFromParent_Done,
      // Label 812: @24167
      GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(24212), // Rule ID 50855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50855,
        GIR_EraseRootFromParent_Done,
      // Label 813: @24212
      GIM_Reject,
    // Label 811: @24213
    GIM_Reject,
    // Label 779: @24214
    GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(24328),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(24282), // Rule ID 50866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50866,
        GIR_EraseRootFromParent_Done,
      // Label 815: @24282
      GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(24327), // Rule ID 50867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50867,
        GIR_EraseRootFromParent_Done,
      // Label 816: @24327
      GIM_Reject,
    // Label 814: @24328
    GIM_Reject,
    // Label 780: @24329
    GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(24443),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(24397), // Rule ID 50882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50882,
        GIR_EraseRootFromParent_Done,
      // Label 818: @24397
      GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(24442), // Rule ID 50883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50883,
        GIR_EraseRootFromParent_Done,
      // Label 819: @24442
      GIM_Reject,
    // Label 817: @24443
    GIM_Reject,
    // Label 781: @24444
    GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(24558),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(24512), // Rule ID 50926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50926,
        GIR_EraseRootFromParent_Done,
      // Label 821: @24512
      GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(24557), // Rule ID 50927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50927,
        GIR_EraseRootFromParent_Done,
      // Label 822: @24557
      GIM_Reject,
    // Label 820: @24558
    GIM_Reject,
    // Label 782: @24559
    GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(24673),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(24627), // Rule ID 50858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50858,
        GIR_EraseRootFromParent_Done,
      // Label 824: @24627
      GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(24672), // Rule ID 50859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50859,
        GIR_EraseRootFromParent_Done,
      // Label 825: @24672
      GIM_Reject,
    // Label 823: @24673
    GIM_Reject,
    // Label 783: @24674
    GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(24788),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(24742), // Rule ID 50878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50878,
        GIR_EraseRootFromParent_Done,
      // Label 827: @24742
      GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(24787), // Rule ID 50879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50879,
        GIR_EraseRootFromParent_Done,
      // Label 828: @24787
      GIM_Reject,
    // Label 826: @24788
    GIM_Reject,
    // Label 784: @24789
    GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(24903),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(24857), // Rule ID 50914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50914,
        GIR_EraseRootFromParent_Done,
      // Label 830: @24857
      GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(24902), // Rule ID 50915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50915,
        GIR_EraseRootFromParent_Done,
      // Label 831: @24902
      GIM_Reject,
    // Label 829: @24903
    GIM_Reject,
    // Label 785: @24904
    GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(25018),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(24972), // Rule ID 50930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50930,
        GIR_EraseRootFromParent_Done,
      // Label 833: @24972
      GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(25017), // Rule ID 50931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50931,
        GIR_EraseRootFromParent_Done,
      // Label 834: @25017
      GIM_Reject,
    // Label 832: @25018
    GIM_Reject,
    // Label 786: @25019
    GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(25133),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(25087), // Rule ID 50874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50874,
        GIR_EraseRootFromParent_Done,
      // Label 836: @25087
      GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(25132), // Rule ID 50875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50875,
        GIR_EraseRootFromParent_Done,
      // Label 837: @25132
      GIM_Reject,
    // Label 835: @25133
    GIM_Reject,
    // Label 787: @25134
    GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(25248),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(25202), // Rule ID 50902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50902,
        GIR_EraseRootFromParent_Done,
      // Label 839: @25202
      GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(25247), // Rule ID 50903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50903,
        GIR_EraseRootFromParent_Done,
      // Label 840: @25247
      GIM_Reject,
    // Label 838: @25248
    GIM_Reject,
    // Label 788: @25249
    GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(25363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(25317), // Rule ID 50918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50918,
        GIR_EraseRootFromParent_Done,
      // Label 842: @25317
      GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(25362), // Rule ID 50919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50919,
        GIR_EraseRootFromParent_Done,
      // Label 843: @25362
      GIM_Reject,
    // Label 841: @25363
    GIM_Reject,
    // Label 789: @25364
    GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(25478),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(25432), // Rule ID 50934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50934,
        GIR_EraseRootFromParent_Done,
      // Label 845: @25432
      GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(25477), // Rule ID 50935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50935,
        GIR_EraseRootFromParent_Done,
      // Label 846: @25477
      GIM_Reject,
    // Label 844: @25478
    GIM_Reject,
    // Label 790: @25479
    GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(25593),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(25547), // Rule ID 50890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50890,
        GIR_EraseRootFromParent_Done,
      // Label 848: @25547
      GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(25592), // Rule ID 50891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50891,
        GIR_EraseRootFromParent_Done,
      // Label 849: @25592
      GIM_Reject,
    // Label 847: @25593
    GIM_Reject,
    // Label 791: @25594
    GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(25708),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(25662), // Rule ID 50906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50906,
        GIR_EraseRootFromParent_Done,
      // Label 851: @25662
      GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(25707), // Rule ID 50907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50907,
        GIR_EraseRootFromParent_Done,
      // Label 852: @25707
      GIM_Reject,
    // Label 850: @25708
    GIM_Reject,
    // Label 792: @25709
    GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(25823),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(25777), // Rule ID 50922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50922,
        GIR_EraseRootFromParent_Done,
      // Label 854: @25777
      GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(25822), // Rule ID 50923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50923,
        GIR_EraseRootFromParent_Done,
      // Label 855: @25822
      GIM_Reject,
    // Label 853: @25823
    GIM_Reject,
    // Label 793: @25824
    GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(25938),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(25892), // Rule ID 50894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50894,
        GIR_EraseRootFromParent_Done,
      // Label 857: @25892
      GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(25937), // Rule ID 50895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50895,
        GIR_EraseRootFromParent_Done,
      // Label 858: @25937
      GIM_Reject,
    // Label 856: @25938
    GIM_Reject,
    // Label 794: @25939
    GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(26053),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(26007), // Rule ID 50910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50910,
        GIR_EraseRootFromParent_Done,
      // Label 860: @26007
      GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(26052), // Rule ID 50911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50911,
        GIR_EraseRootFromParent_Done,
      // Label 861: @26052
      GIM_Reject,
    // Label 859: @26053
    GIM_Reject,
    // Label 795: @26054
    GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(26168),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(26122), // Rule ID 50898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50898,
        GIR_EraseRootFromParent_Done,
      // Label 863: @26122
      GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(26167), // Rule ID 50899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50899,
        GIR_EraseRootFromParent_Done,
      // Label 864: @26167
      GIM_Reject,
    // Label 862: @26168
    GIM_Reject,
    // Label 796: @26169
    GIM_Reject,
    // Label 7: @26170
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 896*/ GIMT_Encode4(35453),
    /*GILLT_s32*//*Label 865*/ GIMT_Encode4(26305),
    /*GILLT_s64*//*Label 866*/ GIMT_Encode4(27363),
    /*GILLT_nxv1s1*//*Label 867*/ GIMT_Encode4(28646),
    /*GILLT_nxv1s8*//*Label 868*/ GIMT_Encode4(29257),
    /*GILLT_nxv1s16*//*Label 869*/ GIMT_Encode4(29372),
    /*GILLT_nxv1s32*//*Label 870*/ GIMT_Encode4(29487),
    /*GILLT_nxv1s64*//*Label 871*/ GIMT_Encode4(29602),
    /*GILLT_nxv2s1*//*Label 872*/ GIMT_Encode4(29717),
    /*GILLT_nxv2s8*//*Label 873*/ GIMT_Encode4(30328),
    /*GILLT_nxv2s16*//*Label 874*/ GIMT_Encode4(30443),
    /*GILLT_nxv2s32*//*Label 875*/ GIMT_Encode4(30558),
    /*GILLT_nxv2s64*//*Label 876*/ GIMT_Encode4(30673),
    /*GILLT_nxv4s1*//*Label 877*/ GIMT_Encode4(30788),
    /*GILLT_nxv4s8*//*Label 878*/ GIMT_Encode4(31399),
    /*GILLT_nxv4s16*//*Label 879*/ GIMT_Encode4(31514),
    /*GILLT_nxv4s32*//*Label 880*/ GIMT_Encode4(31629),
    /*GILLT_nxv4s64*//*Label 881*/ GIMT_Encode4(31744),
    /*GILLT_nxv8s1*//*Label 882*/ GIMT_Encode4(31859),
    /*GILLT_nxv8s8*//*Label 883*/ GIMT_Encode4(32470),
    /*GILLT_nxv8s16*//*Label 884*/ GIMT_Encode4(32585),
    /*GILLT_nxv8s32*//*Label 885*/ GIMT_Encode4(32700),
    /*GILLT_nxv8s64*//*Label 886*/ GIMT_Encode4(32815),
    /*GILLT_nxv16s1*//*Label 887*/ GIMT_Encode4(32930),
    /*GILLT_nxv16s8*//*Label 888*/ GIMT_Encode4(33541),
    /*GILLT_nxv16s16*//*Label 889*/ GIMT_Encode4(33656),
    /*GILLT_nxv16s32*//*Label 890*/ GIMT_Encode4(33771),
    /*GILLT_nxv32s1*//*Label 891*/ GIMT_Encode4(33886),
    /*GILLT_nxv32s8*//*Label 892*/ GIMT_Encode4(34497),
    /*GILLT_nxv32s16*//*Label 893*/ GIMT_Encode4(34612),
    /*GILLT_nxv64s1*//*Label 894*/ GIMT_Encode4(34727),
    /*GILLT_nxv64s8*//*Label 895*/ GIMT_Encode4(35338),
    // Label 865: @26305
    GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(27362),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(26405), // Rule ID 64178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64178,
        GIR_EraseRootFromParent_Done,
      // Label 898: @26405
      GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(26490), // Rule ID 2402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2402,
        GIR_EraseRootFromParent_Done,
      // Label 899: @26490
      GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(26565), // Rule ID 2329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2329,
        GIR_EraseRootFromParent_Done,
      // Label 900: @26565
      GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(26640), // Rule ID 64166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64166,
        GIR_EraseRootFromParent_Done,
      // Label 901: @26640
      GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(26701), // Rule ID 2349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2349,
        GIR_EraseRootFromParent_Done,
      // Label 902: @26701
      GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(26762), // Rule ID 61983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61983,
        GIR_EraseRootFromParent_Done,
      // Label 903: @26762
      GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(26820), // Rule ID 2337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2337,
        GIR_EraseRootFromParent_Done,
      // Label 904: @26820
      GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(26872), // Rule ID 2331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2331,
        GIR_EraseRootFromParent_Done,
      // Label 905: @26872
      GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(26924), // Rule ID 64152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64152,
        GIR_EraseRootFromParent_Done,
      // Label 906: @26924
      GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(26976), // Rule ID 64168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64168,
        GIR_EraseRootFromParent_Done,
      // Label 907: @26976
      GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(27028), // Rule ID 2305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2305,
        GIR_EraseRootFromParent_Done,
      // Label 908: @27028
      GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(27060), // Rule ID 63887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63887,
        GIR_EraseRootFromParent_Done,
      // Label 909: @27060
      GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(27092), // Rule ID 63889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63889,
        GIR_EraseRootFromParent_Done,
      // Label 910: @27092
      GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(27124), // Rule ID 2413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2413,
        GIR_EraseRootFromParent_Done,
      // Label 911: @27124
      GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(27156), // Rule ID 2414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2414,
        GIR_EraseRootFromParent_Done,
      // Label 912: @27156
      GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(27194), // Rule ID 2416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2416,
        GIR_EraseRootFromParent_Done,
      // Label 913: @27194
      GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(27232), // Rule ID 2417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2417,
        GIR_EraseRootFromParent_Done,
      // Label 914: @27232
      GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(27270), // Rule ID 85 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 85,
        GIR_EraseRootFromParent_Done,
      // Label 915: @27270
      GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(27338), // Rule ID 103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9503),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9503>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 103,
        GIR_EraseRootFromParent_Done,
      // Label 916: @27338
      GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(27361), // Rule ID 83 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 83,
        GIR_Done,
      // Label 917: @27361
      GIM_Reject,
    // Label 897: @27362
    GIM_Reject,
    // Label 866: @27363
    GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(28645),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(27463), // Rule ID 64177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64177,
        GIR_EraseRootFromParent_Done,
      // Label 919: @27463
      GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(27548), // Rule ID 2401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2401,
        GIR_EraseRootFromParent_Done,
      // Label 920: @27548
      GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(27623), // Rule ID 2328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2328,
        GIR_EraseRootFromParent_Done,
      // Label 921: @27623
      GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(27698), // Rule ID 64165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64165,
        GIR_EraseRootFromParent_Done,
      // Label 922: @27698
      GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(27759), // Rule ID 2348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2348,
        GIR_EraseRootFromParent_Done,
      // Label 923: @27759
      GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(27820), // Rule ID 61982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61982,
        GIR_EraseRootFromParent_Done,
      // Label 924: @27820
      GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(27878), // Rule ID 2336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2336,
        GIR_EraseRootFromParent_Done,
      // Label 925: @27878
      GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(27930), // Rule ID 2330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2330,
        GIR_EraseRootFromParent_Done,
      // Label 926: @27930
      GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(27982), // Rule ID 64151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64151,
        GIR_EraseRootFromParent_Done,
      // Label 927: @27982
      GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(28034), // Rule ID 64167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64167,
        GIR_EraseRootFromParent_Done,
      // Label 928: @28034
      GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(28086), // Rule ID 2304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2304,
        GIR_EraseRootFromParent_Done,
      // Label 929: @28086
      GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(28118), // Rule ID 63886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63886,
        GIR_EraseRootFromParent_Done,
      // Label 930: @28118
      GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(28150), // Rule ID 63888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63888,
        GIR_EraseRootFromParent_Done,
      // Label 931: @28150
      GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(28207), // Rule ID 252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 252,
        GIR_EraseRootFromParent_Done,
      // Label 932: @28207
      GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(28239), // Rule ID 2415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2415,
        GIR_EraseRootFromParent_Done,
      // Label 933: @28239
      GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(28277), // Rule ID 2418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2418,
        GIR_EraseRootFromParent_Done,
      // Label 934: @28277
      GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(28315), // Rule ID 2461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2461,
        GIR_EraseRootFromParent_Done,
      // Label 935: @28315
      GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(28353), // Rule ID 84 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 84,
        GIR_EraseRootFromParent_Done,
      // Label 936: @28353
      GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(28421), // Rule ID 101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9501),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9501>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 101,
        GIR_EraseRootFromParent_Done,
      // Label 937: @28421
      GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(28489), // Rule ID 102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9503),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9503>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 102,
        GIR_EraseRootFromParent_Done,
      // Label 938: @28489
      GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(28557), // Rule ID 254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9591),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_9591>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 254,
        GIR_EraseRootFromParent_Done,
      // Label 939: @28557
      GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(28621), // Rule ID 2458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2458,
        GIR_EraseRootFromParent_Done,
      // Label 940: @28621
      GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(28644), // Rule ID 82 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 82,
        GIR_Done,
      // Label 941: @28644
      GIM_Reject,
    // Label 918: @28645
    GIM_Reject,
    // Label 867: @28646
    GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(29256),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(28727), // Rule ID 70217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70217,
        GIR_EraseRootFromParent_Done,
      // Label 943: @28727
      GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(28793), // Rule ID 70218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70218,
        GIR_EraseRootFromParent_Done,
      // Label 944: @28793
      GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(28859), // Rule ID 70215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70215,
        GIR_EraseRootFromParent_Done,
      // Label 945: @28859
      GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(28925), // Rule ID 70216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70216,
        GIR_EraseRootFromParent_Done,
      // Label 946: @28925
      GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(28991), // Rule ID 70213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70213,
        GIR_EraseRootFromParent_Done,
      // Label 947: @28991
      GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(29057), // Rule ID 70214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70214,
        GIR_EraseRootFromParent_Done,
      // Label 948: @29057
      GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(29123), // Rule ID 52726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52726,
        GIR_EraseRootFromParent_Done,
      // Label 949: @29123
      GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(29189), // Rule ID 52727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52727,
        GIR_EraseRootFromParent_Done,
      // Label 950: @29189
      GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(29222), // Rule ID 52714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52714,
        GIR_EraseRootFromParent_Done,
      // Label 951: @29222
      GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(29255), // Rule ID 52715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52715,
        GIR_EraseRootFromParent_Done,
      // Label 952: @29255
      GIM_Reject,
    // Label 942: @29256
    GIM_Reject,
    // Label 868: @29257
    GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(29371),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(29325), // Rule ID 47210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47210,
        GIR_EraseRootFromParent_Done,
      // Label 954: @29325
      GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(29370), // Rule ID 47211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47211,
        GIR_EraseRootFromParent_Done,
      // Label 955: @29370
      GIM_Reject,
    // Label 953: @29371
    GIM_Reject,
    // Label 869: @29372
    GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(29486),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(29440), // Rule ID 47222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47222,
        GIR_EraseRootFromParent_Done,
      // Label 957: @29440
      GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(29485), // Rule ID 47223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47223,
        GIR_EraseRootFromParent_Done,
      // Label 958: @29485
      GIM_Reject,
    // Label 956: @29486
    GIM_Reject,
    // Label 870: @29487
    GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(29601),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(29555), // Rule ID 47230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47230,
        GIR_EraseRootFromParent_Done,
      // Label 960: @29555
      GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(29600), // Rule ID 47231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47231,
        GIR_EraseRootFromParent_Done,
      // Label 961: @29600
      GIM_Reject,
    // Label 959: @29601
    GIM_Reject,
    // Label 871: @29602
    GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(29716),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(29670), // Rule ID 47246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47246,
        GIR_EraseRootFromParent_Done,
      // Label 963: @29670
      GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(29715), // Rule ID 47247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47247,
        GIR_EraseRootFromParent_Done,
      // Label 964: @29715
      GIM_Reject,
    // Label 962: @29716
    GIM_Reject,
    // Label 872: @29717
    GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(30327),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(29798), // Rule ID 70245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70245,
        GIR_EraseRootFromParent_Done,
      // Label 966: @29798
      GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(29864), // Rule ID 70246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70246,
        GIR_EraseRootFromParent_Done,
      // Label 967: @29864
      GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(29930), // Rule ID 70243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70243,
        GIR_EraseRootFromParent_Done,
      // Label 968: @29930
      GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(29996), // Rule ID 70244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70244,
        GIR_EraseRootFromParent_Done,
      // Label 969: @29996
      GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(30062), // Rule ID 70241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70241,
        GIR_EraseRootFromParent_Done,
      // Label 970: @30062
      GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(30128), // Rule ID 70242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70242,
        GIR_EraseRootFromParent_Done,
      // Label 971: @30128
      GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(30194), // Rule ID 52744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52744,
        GIR_EraseRootFromParent_Done,
      // Label 972: @30194
      GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(30260), // Rule ID 52745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52745,
        GIR_EraseRootFromParent_Done,
      // Label 973: @30260
      GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(30293), // Rule ID 52732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52732,
        GIR_EraseRootFromParent_Done,
      // Label 974: @30293
      GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(30326), // Rule ID 52733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52733,
        GIR_EraseRootFromParent_Done,
      // Label 975: @30326
      GIM_Reject,
    // Label 965: @30327
    GIM_Reject,
    // Label 873: @30328
    GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(30442),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(30396), // Rule ID 47214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47214,
        GIR_EraseRootFromParent_Done,
      // Label 977: @30396
      GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(30441), // Rule ID 47215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47215,
        GIR_EraseRootFromParent_Done,
      // Label 978: @30441
      GIM_Reject,
    // Label 976: @30442
    GIM_Reject,
    // Label 874: @30443
    GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(30557),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(30511), // Rule ID 47226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47226,
        GIR_EraseRootFromParent_Done,
      // Label 980: @30511
      GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(30556), // Rule ID 47227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47227,
        GIR_EraseRootFromParent_Done,
      // Label 981: @30556
      GIM_Reject,
    // Label 979: @30557
    GIM_Reject,
    // Label 875: @30558
    GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(30672),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(30626), // Rule ID 47242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47242,
        GIR_EraseRootFromParent_Done,
      // Label 983: @30626
      GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(30671), // Rule ID 47243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47243,
        GIR_EraseRootFromParent_Done,
      // Label 984: @30671
      GIM_Reject,
    // Label 982: @30672
    GIM_Reject,
    // Label 876: @30673
    GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(30787),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(30741), // Rule ID 47286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47286,
        GIR_EraseRootFromParent_Done,
      // Label 986: @30741
      GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(30786), // Rule ID 47287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47287,
        GIR_EraseRootFromParent_Done,
      // Label 987: @30786
      GIM_Reject,
    // Label 985: @30787
    GIM_Reject,
    // Label 877: @30788
    GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(31398),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(30869), // Rule ID 70273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70273,
        GIR_EraseRootFromParent_Done,
      // Label 989: @30869
      GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(30935), // Rule ID 70274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70274,
        GIR_EraseRootFromParent_Done,
      // Label 990: @30935
      GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(31001), // Rule ID 70271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70271,
        GIR_EraseRootFromParent_Done,
      // Label 991: @31001
      GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(31067), // Rule ID 70272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70272,
        GIR_EraseRootFromParent_Done,
      // Label 992: @31067
      GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(31133), // Rule ID 70269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70269,
        GIR_EraseRootFromParent_Done,
      // Label 993: @31133
      GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(31199), // Rule ID 70270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70270,
        GIR_EraseRootFromParent_Done,
      // Label 994: @31199
      GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(31265), // Rule ID 52762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52762,
        GIR_EraseRootFromParent_Done,
      // Label 995: @31265
      GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(31331), // Rule ID 52763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52763,
        GIR_EraseRootFromParent_Done,
      // Label 996: @31331
      GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(31364), // Rule ID 52750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52750,
        GIR_EraseRootFromParent_Done,
      // Label 997: @31364
      GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(31397), // Rule ID 52751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52751,
        GIR_EraseRootFromParent_Done,
      // Label 998: @31397
      GIM_Reject,
    // Label 988: @31398
    GIM_Reject,
    // Label 878: @31399
    GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(31513),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(31467), // Rule ID 47218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47218,
        GIR_EraseRootFromParent_Done,
      // Label 1000: @31467
      GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(31512), // Rule ID 47219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47219,
        GIR_EraseRootFromParent_Done,
      // Label 1001: @31512
      GIM_Reject,
    // Label 999: @31513
    GIM_Reject,
    // Label 879: @31514
    GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(31628),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(31582), // Rule ID 47238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47238,
        GIR_EraseRootFromParent_Done,
      // Label 1003: @31582
      GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(31627), // Rule ID 47239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47239,
        GIR_EraseRootFromParent_Done,
      // Label 1004: @31627
      GIM_Reject,
    // Label 1002: @31628
    GIM_Reject,
    // Label 880: @31629
    GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(31743),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(31697), // Rule ID 47274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47274,
        GIR_EraseRootFromParent_Done,
      // Label 1006: @31697
      GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(31742), // Rule ID 47275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47275,
        GIR_EraseRootFromParent_Done,
      // Label 1007: @31742
      GIM_Reject,
    // Label 1005: @31743
    GIM_Reject,
    // Label 881: @31744
    GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(31858),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(31812), // Rule ID 47290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47290,
        GIR_EraseRootFromParent_Done,
      // Label 1009: @31812
      GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(31857), // Rule ID 47291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47291,
        GIR_EraseRootFromParent_Done,
      // Label 1010: @31857
      GIM_Reject,
    // Label 1008: @31858
    GIM_Reject,
    // Label 882: @31859
    GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(32469),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(31940), // Rule ID 70301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70301,
        GIR_EraseRootFromParent_Done,
      // Label 1012: @31940
      GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(32006), // Rule ID 70302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70302,
        GIR_EraseRootFromParent_Done,
      // Label 1013: @32006
      GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(32072), // Rule ID 70299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70299,
        GIR_EraseRootFromParent_Done,
      // Label 1014: @32072
      GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(32138), // Rule ID 70300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70300,
        GIR_EraseRootFromParent_Done,
      // Label 1015: @32138
      GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(32204), // Rule ID 70297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70297,
        GIR_EraseRootFromParent_Done,
      // Label 1016: @32204
      GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(32270), // Rule ID 70298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70298,
        GIR_EraseRootFromParent_Done,
      // Label 1017: @32270
      GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(32336), // Rule ID 52780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52780,
        GIR_EraseRootFromParent_Done,
      // Label 1018: @32336
      GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(32402), // Rule ID 52781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52781,
        GIR_EraseRootFromParent_Done,
      // Label 1019: @32402
      GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(32435), // Rule ID 52768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52768,
        GIR_EraseRootFromParent_Done,
      // Label 1020: @32435
      GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(32468), // Rule ID 52769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52769,
        GIR_EraseRootFromParent_Done,
      // Label 1021: @32468
      GIM_Reject,
    // Label 1011: @32469
    GIM_Reject,
    // Label 883: @32470
    GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(32584),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(32538), // Rule ID 47234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47234,
        GIR_EraseRootFromParent_Done,
      // Label 1023: @32538
      GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(32583), // Rule ID 47235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47235,
        GIR_EraseRootFromParent_Done,
      // Label 1024: @32583
      GIM_Reject,
    // Label 1022: @32584
    GIM_Reject,
    // Label 884: @32585
    GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(32699),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(32653), // Rule ID 47262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47262,
        GIR_EraseRootFromParent_Done,
      // Label 1026: @32653
      GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(32698), // Rule ID 47263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47263,
        GIR_EraseRootFromParent_Done,
      // Label 1027: @32698
      GIM_Reject,
    // Label 1025: @32699
    GIM_Reject,
    // Label 885: @32700
    GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(32814),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(32768), // Rule ID 47278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47278,
        GIR_EraseRootFromParent_Done,
      // Label 1029: @32768
      GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(32813), // Rule ID 47279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47279,
        GIR_EraseRootFromParent_Done,
      // Label 1030: @32813
      GIM_Reject,
    // Label 1028: @32814
    GIM_Reject,
    // Label 886: @32815
    GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(32929),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(32883), // Rule ID 47294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47294,
        GIR_EraseRootFromParent_Done,
      // Label 1032: @32883
      GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(32928), // Rule ID 47295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47295,
        GIR_EraseRootFromParent_Done,
      // Label 1033: @32928
      GIM_Reject,
    // Label 1031: @32929
    GIM_Reject,
    // Label 887: @32930
    GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(33540),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(33011), // Rule ID 70329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70329,
        GIR_EraseRootFromParent_Done,
      // Label 1035: @33011
      GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(33077), // Rule ID 70330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70330,
        GIR_EraseRootFromParent_Done,
      // Label 1036: @33077
      GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(33143), // Rule ID 70327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70327,
        GIR_EraseRootFromParent_Done,
      // Label 1037: @33143
      GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(33209), // Rule ID 70328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70328,
        GIR_EraseRootFromParent_Done,
      // Label 1038: @33209
      GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(33275), // Rule ID 70325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70325,
        GIR_EraseRootFromParent_Done,
      // Label 1039: @33275
      GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(33341), // Rule ID 70326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70326,
        GIR_EraseRootFromParent_Done,
      // Label 1040: @33341
      GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(33407), // Rule ID 52798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52798,
        GIR_EraseRootFromParent_Done,
      // Label 1041: @33407
      GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(33473), // Rule ID 52799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52799,
        GIR_EraseRootFromParent_Done,
      // Label 1042: @33473
      GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(33506), // Rule ID 52786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52786,
        GIR_EraseRootFromParent_Done,
      // Label 1043: @33506
      GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(33539), // Rule ID 52787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52787,
        GIR_EraseRootFromParent_Done,
      // Label 1044: @33539
      GIM_Reject,
    // Label 1034: @33540
    GIM_Reject,
    // Label 888: @33541
    GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(33655),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(33609), // Rule ID 47250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47250,
        GIR_EraseRootFromParent_Done,
      // Label 1046: @33609
      GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(33654), // Rule ID 47251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47251,
        GIR_EraseRootFromParent_Done,
      // Label 1047: @33654
      GIM_Reject,
    // Label 1045: @33655
    GIM_Reject,
    // Label 889: @33656
    GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(33770),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(33724), // Rule ID 47266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47266,
        GIR_EraseRootFromParent_Done,
      // Label 1049: @33724
      GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(33769), // Rule ID 47267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47267,
        GIR_EraseRootFromParent_Done,
      // Label 1050: @33769
      GIM_Reject,
    // Label 1048: @33770
    GIM_Reject,
    // Label 890: @33771
    GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(33885),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(33839), // Rule ID 47282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47282,
        GIR_EraseRootFromParent_Done,
      // Label 1052: @33839
      GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(33884), // Rule ID 47283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47283,
        GIR_EraseRootFromParent_Done,
      // Label 1053: @33884
      GIM_Reject,
    // Label 1051: @33885
    GIM_Reject,
    // Label 891: @33886
    GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(34496),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(33967), // Rule ID 70357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70357,
        GIR_EraseRootFromParent_Done,
      // Label 1055: @33967
      GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(34033), // Rule ID 70358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70358,
        GIR_EraseRootFromParent_Done,
      // Label 1056: @34033
      GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(34099), // Rule ID 70355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70355,
        GIR_EraseRootFromParent_Done,
      // Label 1057: @34099
      GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(34165), // Rule ID 70356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70356,
        GIR_EraseRootFromParent_Done,
      // Label 1058: @34165
      GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(34231), // Rule ID 70353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70353,
        GIR_EraseRootFromParent_Done,
      // Label 1059: @34231
      GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(34297), // Rule ID 70354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70354,
        GIR_EraseRootFromParent_Done,
      // Label 1060: @34297
      GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(34363), // Rule ID 52816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52816,
        GIR_EraseRootFromParent_Done,
      // Label 1061: @34363
      GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(34429), // Rule ID 52817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52817,
        GIR_EraseRootFromParent_Done,
      // Label 1062: @34429
      GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(34462), // Rule ID 52804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52804,
        GIR_EraseRootFromParent_Done,
      // Label 1063: @34462
      GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(34495), // Rule ID 52805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52805,
        GIR_EraseRootFromParent_Done,
      // Label 1064: @34495
      GIM_Reject,
    // Label 1054: @34496
    GIM_Reject,
    // Label 892: @34497
    GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(34611),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(34565), // Rule ID 47254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47254,
        GIR_EraseRootFromParent_Done,
      // Label 1066: @34565
      GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(34610), // Rule ID 47255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47255,
        GIR_EraseRootFromParent_Done,
      // Label 1067: @34610
      GIM_Reject,
    // Label 1065: @34611
    GIM_Reject,
    // Label 893: @34612
    GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(34726),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(34680), // Rule ID 47270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47270,
        GIR_EraseRootFromParent_Done,
      // Label 1069: @34680
      GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(34725), // Rule ID 47271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47271,
        GIR_EraseRootFromParent_Done,
      // Label 1070: @34725
      GIM_Reject,
    // Label 1068: @34726
    GIM_Reject,
    // Label 894: @34727
    GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(35337),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(34808), // Rule ID 70385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70385,
        GIR_EraseRootFromParent_Done,
      // Label 1072: @34808
      GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(34874), // Rule ID 70386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70386,
        GIR_EraseRootFromParent_Done,
      // Label 1073: @34874
      GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(34940), // Rule ID 70383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70383,
        GIR_EraseRootFromParent_Done,
      // Label 1074: @34940
      GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(35006), // Rule ID 70384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70384,
        GIR_EraseRootFromParent_Done,
      // Label 1075: @35006
      GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(35072), // Rule ID 70381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70381,
        GIR_EraseRootFromParent_Done,
      // Label 1076: @35072
      GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(35138), // Rule ID 70382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70382,
        GIR_EraseRootFromParent_Done,
      // Label 1077: @35138
      GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(35204), // Rule ID 52834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52834,
        GIR_EraseRootFromParent_Done,
      // Label 1078: @35204
      GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(35270), // Rule ID 52835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52835,
        GIR_EraseRootFromParent_Done,
      // Label 1079: @35270
      GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(35303), // Rule ID 52822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52822,
        GIR_EraseRootFromParent_Done,
      // Label 1080: @35303
      GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(35336), // Rule ID 52823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52823,
        GIR_EraseRootFromParent_Done,
      // Label 1081: @35336
      GIM_Reject,
    // Label 1071: @35337
    GIM_Reject,
    // Label 895: @35338
    GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(35452),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(35406), // Rule ID 47258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47258,
        GIR_EraseRootFromParent_Done,
      // Label 1083: @35406
      GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(35451), // Rule ID 47259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47259,
        GIR_EraseRootFromParent_Done,
      // Label 1084: @35451
      GIM_Reject,
    // Label 1082: @35452
    GIM_Reject,
    // Label 896: @35453
    GIM_Reject,
    // Label 8: @35454
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1116*/ GIMT_Encode4(47418),
    /*GILLT_s32*//*Label 1085*/ GIMT_Encode4(35589),
    /*GILLT_s64*//*Label 1086*/ GIMT_Encode4(38019),
    /*GILLT_nxv1s1*//*Label 1087*/ GIMT_Encode4(40611),
    /*GILLT_nxv1s8*//*Label 1088*/ GIMT_Encode4(41222),
    /*GILLT_nxv1s16*//*Label 1089*/ GIMT_Encode4(41337),
    /*GILLT_nxv1s32*//*Label 1090*/ GIMT_Encode4(41452),
    /*GILLT_nxv1s64*//*Label 1091*/ GIMT_Encode4(41567),
    /*GILLT_nxv2s1*//*Label 1092*/ GIMT_Encode4(41682),
    /*GILLT_nxv2s8*//*Label 1093*/ GIMT_Encode4(42293),
    /*GILLT_nxv2s16*//*Label 1094*/ GIMT_Encode4(42408),
    /*GILLT_nxv2s32*//*Label 1095*/ GIMT_Encode4(42523),
    /*GILLT_nxv2s64*//*Label 1096*/ GIMT_Encode4(42638),
    /*GILLT_nxv4s1*//*Label 1097*/ GIMT_Encode4(42753),
    /*GILLT_nxv4s8*//*Label 1098*/ GIMT_Encode4(43364),
    /*GILLT_nxv4s16*//*Label 1099*/ GIMT_Encode4(43479),
    /*GILLT_nxv4s32*//*Label 1100*/ GIMT_Encode4(43594),
    /*GILLT_nxv4s64*//*Label 1101*/ GIMT_Encode4(43709),
    /*GILLT_nxv8s1*//*Label 1102*/ GIMT_Encode4(43824),
    /*GILLT_nxv8s8*//*Label 1103*/ GIMT_Encode4(44435),
    /*GILLT_nxv8s16*//*Label 1104*/ GIMT_Encode4(44550),
    /*GILLT_nxv8s32*//*Label 1105*/ GIMT_Encode4(44665),
    /*GILLT_nxv8s64*//*Label 1106*/ GIMT_Encode4(44780),
    /*GILLT_nxv16s1*//*Label 1107*/ GIMT_Encode4(44895),
    /*GILLT_nxv16s8*//*Label 1108*/ GIMT_Encode4(45506),
    /*GILLT_nxv16s16*//*Label 1109*/ GIMT_Encode4(45621),
    /*GILLT_nxv16s32*//*Label 1110*/ GIMT_Encode4(45736),
    /*GILLT_nxv32s1*//*Label 1111*/ GIMT_Encode4(45851),
    /*GILLT_nxv32s8*//*Label 1112*/ GIMT_Encode4(46462),
    /*GILLT_nxv32s16*//*Label 1113*/ GIMT_Encode4(46577),
    /*GILLT_nxv64s1*//*Label 1114*/ GIMT_Encode4(46692),
    /*GILLT_nxv64s8*//*Label 1115*/ GIMT_Encode4(47303),
    // Label 1085: @35589
    GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(38018),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(35795), // Rule ID 64195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64195,
        GIR_EraseRootFromParent_Done,
      // Label 1118: @35795
      GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(35986), // Rule ID 64197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64197,
        GIR_EraseRootFromParent_Done,
      // Label 1119: @35986
      GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(36177), // Rule ID 64191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64191,
        GIR_EraseRootFromParent_Done,
      // Label 1120: @36177
      GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(36368), // Rule ID 64193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64193,
        GIR_EraseRootFromParent_Done,
      // Label 1121: @36368
      GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(36559), // Rule ID 64185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64185,
        GIR_EraseRootFromParent_Done,
      // Label 1122: @36559
      GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(36750), // Rule ID 64189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64189,
        GIR_EraseRootFromParent_Done,
      // Label 1123: @36750
      GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(36941), // Rule ID 2409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2409,
        GIR_EraseRootFromParent_Done,
      // Label 1124: @36941
      GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(37132), // Rule ID 64187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64187,
        GIR_EraseRootFromParent_Done,
      // Label 1125: @37132
      GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(37233), // Rule ID 2404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2404,
        GIR_EraseRootFromParent_Done,
      // Label 1126: @37233
      GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(37334), // Rule ID 64180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64180,
        GIR_EraseRootFromParent_Done,
      // Label 1127: @37334
      GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(37419), // Rule ID 64174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64174,
        GIR_EraseRootFromParent_Done,
      // Label 1128: @37419
      GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(37504), // Rule ID 2398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2398,
        GIR_EraseRootFromParent_Done,
      // Label 1129: @37504
      GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(37565), // Rule ID 64176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64176,
        GIR_EraseRootFromParent_Done,
      // Label 1130: @37565
      GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(37626), // Rule ID 2400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2400,
        GIR_EraseRootFromParent_Done,
      // Label 1131: @37626
      GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(37684), // Rule ID 2407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
        // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2407,
        GIR_EraseRootFromParent_Done,
      // Label 1132: @37684
      GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(37742), // Rule ID 64183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
        // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64183,
        GIR_EraseRootFromParent_Done,
      // Label 1133: @37742
      GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(37797), // Rule ID 2333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2333,
        GIR_EraseRootFromParent_Done,
      // Label 1134: @37797
      GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(37852), // Rule ID 64170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64170,
        GIR_EraseRootFromParent_Done,
      // Label 1135: @37852
      GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(37904), // Rule ID 64154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64154,
        GIR_EraseRootFromParent_Done,
      // Label 1136: @37904
      GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(37956), // Rule ID 2307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2307,
        GIR_EraseRootFromParent_Done,
      // Label 1137: @37956
      GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(37994), // Rule ID 81 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 81,
        GIR_EraseRootFromParent_Done,
      // Label 1138: @37994
      GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(38017), // Rule ID 79 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 79,
        GIR_Done,
      // Label 1139: @38017
      GIM_Reject,
    // Label 1117: @38018
    GIM_Reject,
    // Label 1086: @38019
    GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(40610),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(38225), // Rule ID 64194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64194,
        GIR_EraseRootFromParent_Done,
      // Label 1141: @38225
      GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(38416), // Rule ID 64196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64196,
        GIR_EraseRootFromParent_Done,
      // Label 1142: @38416
      GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(38607), // Rule ID 64190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64190,
        GIR_EraseRootFromParent_Done,
      // Label 1143: @38607
      GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(38798), // Rule ID 64192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64192,
        GIR_EraseRootFromParent_Done,
      // Label 1144: @38798
      GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(38989), // Rule ID 64184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64184,
        GIR_EraseRootFromParent_Done,
      // Label 1145: @38989
      GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(39180), // Rule ID 64188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64188,
        GIR_EraseRootFromParent_Done,
      // Label 1146: @39180
      GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(39371), // Rule ID 2408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2408,
        GIR_EraseRootFromParent_Done,
      // Label 1147: @39371
      GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(39562), // Rule ID 64186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64186,
        GIR_EraseRootFromParent_Done,
      // Label 1148: @39562
      GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(39663), // Rule ID 2403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2403,
        GIR_EraseRootFromParent_Done,
      // Label 1149: @39663
      GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(39764), // Rule ID 64179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64179,
        GIR_EraseRootFromParent_Done,
      // Label 1150: @39764
      GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(39849), // Rule ID 64173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64173,
        GIR_EraseRootFromParent_Done,
      // Label 1151: @39849
      GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(39934), // Rule ID 2397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2397,
        GIR_EraseRootFromParent_Done,
      // Label 1152: @39934
      GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(39995), // Rule ID 64175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64175,
        GIR_EraseRootFromParent_Done,
      // Label 1153: @39995
      GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(40056), // Rule ID 2399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
        // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2399,
        GIR_EraseRootFromParent_Done,
      // Label 1154: @40056
      GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(40137), // Rule ID 64200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
        // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64200,
        GIR_EraseRootFromParent_Done,
      // Label 1155: @40137
      GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(40218), // Rule ID 2412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
        // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2412,
        GIR_EraseRootFromParent_Done,
      // Label 1156: @40218
      GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(40276), // Rule ID 2410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
        // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2410,
        GIR_EraseRootFromParent_Done,
      // Label 1157: @40276
      GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(40334), // Rule ID 64198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
        // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64198,
        GIR_EraseRootFromParent_Done,
      // Label 1158: @40334
      GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(40389), // Rule ID 2332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2332,
        GIR_EraseRootFromParent_Done,
      // Label 1159: @40389
      GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(40444), // Rule ID 64169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64169,
        GIR_EraseRootFromParent_Done,
      // Label 1160: @40444
      GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(40496), // Rule ID 64153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64153,
        GIR_EraseRootFromParent_Done,
      // Label 1161: @40496
      GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(40548), // Rule ID 2306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2306,
        GIR_EraseRootFromParent_Done,
      // Label 1162: @40548
      GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(40586), // Rule ID 80 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 80,
        GIR_EraseRootFromParent_Done,
      // Label 1163: @40586
      GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(40609), // Rule ID 78 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 78,
        GIR_Done,
      // Label 1164: @40609
      GIM_Reject,
    // Label 1140: @40610
    GIM_Reject,
    // Label 1087: @40611
    GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(41221),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(40692), // Rule ID 70223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70223,
        GIR_EraseRootFromParent_Done,
      // Label 1166: @40692
      GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(40758), // Rule ID 70224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70224,
        GIR_EraseRootFromParent_Done,
      // Label 1167: @40758
      GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(40824), // Rule ID 70221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70221,
        GIR_EraseRootFromParent_Done,
      // Label 1168: @40824
      GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(40890), // Rule ID 70222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70222,
        GIR_EraseRootFromParent_Done,
      // Label 1169: @40890
      GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(40956), // Rule ID 70219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70219,
        GIR_EraseRootFromParent_Done,
      // Label 1170: @40956
      GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(41022), // Rule ID 70220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70220,
        GIR_EraseRootFromParent_Done,
      // Label 1171: @41022
      GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(41088), // Rule ID 52728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52728,
        GIR_EraseRootFromParent_Done,
      // Label 1172: @41088
      GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(41154), // Rule ID 52729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52729,
        GIR_EraseRootFromParent_Done,
      // Label 1173: @41154
      GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(41187), // Rule ID 52716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52716,
        GIR_EraseRootFromParent_Done,
      // Label 1174: @41187
      GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(41220), // Rule ID 52717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52717,
        GIR_EraseRootFromParent_Done,
      // Label 1175: @41220
      GIM_Reject,
    // Label 1165: @41221
    GIM_Reject,
    // Label 1088: @41222
    GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(41336),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(41290), // Rule ID 47342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47342,
        GIR_EraseRootFromParent_Done,
      // Label 1177: @41290
      GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(41335), // Rule ID 47343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47343,
        GIR_EraseRootFromParent_Done,
      // Label 1178: @41335
      GIM_Reject,
    // Label 1176: @41336
    GIM_Reject,
    // Label 1089: @41337
    GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(41451),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(41405), // Rule ID 47354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47354,
        GIR_EraseRootFromParent_Done,
      // Label 1180: @41405
      GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(41450), // Rule ID 47355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47355,
        GIR_EraseRootFromParent_Done,
      // Label 1181: @41450
      GIM_Reject,
    // Label 1179: @41451
    GIM_Reject,
    // Label 1090: @41452
    GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(41566),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(41520), // Rule ID 47362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47362,
        GIR_EraseRootFromParent_Done,
      // Label 1183: @41520
      GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(41565), // Rule ID 47363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47363,
        GIR_EraseRootFromParent_Done,
      // Label 1184: @41565
      GIM_Reject,
    // Label 1182: @41566
    GIM_Reject,
    // Label 1091: @41567
    GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(41681),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(41635), // Rule ID 47378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47378,
        GIR_EraseRootFromParent_Done,
      // Label 1186: @41635
      GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(41680), // Rule ID 47379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47379,
        GIR_EraseRootFromParent_Done,
      // Label 1187: @41680
      GIM_Reject,
    // Label 1185: @41681
    GIM_Reject,
    // Label 1092: @41682
    GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(42292),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(41763), // Rule ID 70251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70251,
        GIR_EraseRootFromParent_Done,
      // Label 1189: @41763
      GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(41829), // Rule ID 70252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70252,
        GIR_EraseRootFromParent_Done,
      // Label 1190: @41829
      GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(41895), // Rule ID 70249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70249,
        GIR_EraseRootFromParent_Done,
      // Label 1191: @41895
      GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(41961), // Rule ID 70250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70250,
        GIR_EraseRootFromParent_Done,
      // Label 1192: @41961
      GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(42027), // Rule ID 70247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70247,
        GIR_EraseRootFromParent_Done,
      // Label 1193: @42027
      GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(42093), // Rule ID 70248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70248,
        GIR_EraseRootFromParent_Done,
      // Label 1194: @42093
      GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(42159), // Rule ID 52746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52746,
        GIR_EraseRootFromParent_Done,
      // Label 1195: @42159
      GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(42225), // Rule ID 52747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52747,
        GIR_EraseRootFromParent_Done,
      // Label 1196: @42225
      GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(42258), // Rule ID 52734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52734,
        GIR_EraseRootFromParent_Done,
      // Label 1197: @42258
      GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(42291), // Rule ID 52735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52735,
        GIR_EraseRootFromParent_Done,
      // Label 1198: @42291
      GIM_Reject,
    // Label 1188: @42292
    GIM_Reject,
    // Label 1093: @42293
    GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(42407),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(42361), // Rule ID 47346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47346,
        GIR_EraseRootFromParent_Done,
      // Label 1200: @42361
      GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(42406), // Rule ID 47347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47347,
        GIR_EraseRootFromParent_Done,
      // Label 1201: @42406
      GIM_Reject,
    // Label 1199: @42407
    GIM_Reject,
    // Label 1094: @42408
    GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(42522),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(42476), // Rule ID 47358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47358,
        GIR_EraseRootFromParent_Done,
      // Label 1203: @42476
      GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(42521), // Rule ID 47359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47359,
        GIR_EraseRootFromParent_Done,
      // Label 1204: @42521
      GIM_Reject,
    // Label 1202: @42522
    GIM_Reject,
    // Label 1095: @42523
    GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(42637),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(42591), // Rule ID 47374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47374,
        GIR_EraseRootFromParent_Done,
      // Label 1206: @42591
      GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(42636), // Rule ID 47375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47375,
        GIR_EraseRootFromParent_Done,
      // Label 1207: @42636
      GIM_Reject,
    // Label 1205: @42637
    GIM_Reject,
    // Label 1096: @42638
    GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(42752),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(42706), // Rule ID 47418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47418,
        GIR_EraseRootFromParent_Done,
      // Label 1209: @42706
      GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(42751), // Rule ID 47419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47419,
        GIR_EraseRootFromParent_Done,
      // Label 1210: @42751
      GIM_Reject,
    // Label 1208: @42752
    GIM_Reject,
    // Label 1097: @42753
    GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(43363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(42834), // Rule ID 70279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70279,
        GIR_EraseRootFromParent_Done,
      // Label 1212: @42834
      GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(42900), // Rule ID 70280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70280,
        GIR_EraseRootFromParent_Done,
      // Label 1213: @42900
      GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(42966), // Rule ID 70277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70277,
        GIR_EraseRootFromParent_Done,
      // Label 1214: @42966
      GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(43032), // Rule ID 70278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70278,
        GIR_EraseRootFromParent_Done,
      // Label 1215: @43032
      GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(43098), // Rule ID 70275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70275,
        GIR_EraseRootFromParent_Done,
      // Label 1216: @43098
      GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(43164), // Rule ID 70276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70276,
        GIR_EraseRootFromParent_Done,
      // Label 1217: @43164
      GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(43230), // Rule ID 52764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52764,
        GIR_EraseRootFromParent_Done,
      // Label 1218: @43230
      GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(43296), // Rule ID 52765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52765,
        GIR_EraseRootFromParent_Done,
      // Label 1219: @43296
      GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(43329), // Rule ID 52752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52752,
        GIR_EraseRootFromParent_Done,
      // Label 1220: @43329
      GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(43362), // Rule ID 52753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52753,
        GIR_EraseRootFromParent_Done,
      // Label 1221: @43362
      GIM_Reject,
    // Label 1211: @43363
    GIM_Reject,
    // Label 1098: @43364
    GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(43478),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(43432), // Rule ID 47350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47350,
        GIR_EraseRootFromParent_Done,
      // Label 1223: @43432
      GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(43477), // Rule ID 47351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47351,
        GIR_EraseRootFromParent_Done,
      // Label 1224: @43477
      GIM_Reject,
    // Label 1222: @43478
    GIM_Reject,
    // Label 1099: @43479
    GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(43593),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(43547), // Rule ID 47370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47370,
        GIR_EraseRootFromParent_Done,
      // Label 1226: @43547
      GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(43592), // Rule ID 47371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47371,
        GIR_EraseRootFromParent_Done,
      // Label 1227: @43592
      GIM_Reject,
    // Label 1225: @43593
    GIM_Reject,
    // Label 1100: @43594
    GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(43708),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(43662), // Rule ID 47406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47406,
        GIR_EraseRootFromParent_Done,
      // Label 1229: @43662
      GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(43707), // Rule ID 47407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47407,
        GIR_EraseRootFromParent_Done,
      // Label 1230: @43707
      GIM_Reject,
    // Label 1228: @43708
    GIM_Reject,
    // Label 1101: @43709
    GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(43823),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(43777), // Rule ID 47422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47422,
        GIR_EraseRootFromParent_Done,
      // Label 1232: @43777
      GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(43822), // Rule ID 47423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47423,
        GIR_EraseRootFromParent_Done,
      // Label 1233: @43822
      GIM_Reject,
    // Label 1231: @43823
    GIM_Reject,
    // Label 1102: @43824
    GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(44434),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(43905), // Rule ID 70307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70307,
        GIR_EraseRootFromParent_Done,
      // Label 1235: @43905
      GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(43971), // Rule ID 70308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70308,
        GIR_EraseRootFromParent_Done,
      // Label 1236: @43971
      GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(44037), // Rule ID 70305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70305,
        GIR_EraseRootFromParent_Done,
      // Label 1237: @44037
      GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(44103), // Rule ID 70306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70306,
        GIR_EraseRootFromParent_Done,
      // Label 1238: @44103
      GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(44169), // Rule ID 70303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70303,
        GIR_EraseRootFromParent_Done,
      // Label 1239: @44169
      GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(44235), // Rule ID 70304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70304,
        GIR_EraseRootFromParent_Done,
      // Label 1240: @44235
      GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(44301), // Rule ID 52782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52782,
        GIR_EraseRootFromParent_Done,
      // Label 1241: @44301
      GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(44367), // Rule ID 52783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52783,
        GIR_EraseRootFromParent_Done,
      // Label 1242: @44367
      GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(44400), // Rule ID 52770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52770,
        GIR_EraseRootFromParent_Done,
      // Label 1243: @44400
      GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(44433), // Rule ID 52771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52771,
        GIR_EraseRootFromParent_Done,
      // Label 1244: @44433
      GIM_Reject,
    // Label 1234: @44434
    GIM_Reject,
    // Label 1103: @44435
    GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(44549),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(44503), // Rule ID 47366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47366,
        GIR_EraseRootFromParent_Done,
      // Label 1246: @44503
      GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(44548), // Rule ID 47367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47367,
        GIR_EraseRootFromParent_Done,
      // Label 1247: @44548
      GIM_Reject,
    // Label 1245: @44549
    GIM_Reject,
    // Label 1104: @44550
    GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(44664),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(44618), // Rule ID 47394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47394,
        GIR_EraseRootFromParent_Done,
      // Label 1249: @44618
      GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(44663), // Rule ID 47395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47395,
        GIR_EraseRootFromParent_Done,
      // Label 1250: @44663
      GIM_Reject,
    // Label 1248: @44664
    GIM_Reject,
    // Label 1105: @44665
    GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(44779),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(44733), // Rule ID 47410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47410,
        GIR_EraseRootFromParent_Done,
      // Label 1252: @44733
      GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(44778), // Rule ID 47411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47411,
        GIR_EraseRootFromParent_Done,
      // Label 1253: @44778
      GIM_Reject,
    // Label 1251: @44779
    GIM_Reject,
    // Label 1106: @44780
    GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(44894),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(44848), // Rule ID 47426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47426,
        GIR_EraseRootFromParent_Done,
      // Label 1255: @44848
      GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(44893), // Rule ID 47427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47427,
        GIR_EraseRootFromParent_Done,
      // Label 1256: @44893
      GIM_Reject,
    // Label 1254: @44894
    GIM_Reject,
    // Label 1107: @44895
    GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(45505),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(44976), // Rule ID 70335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70335,
        GIR_EraseRootFromParent_Done,
      // Label 1258: @44976
      GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(45042), // Rule ID 70336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70336,
        GIR_EraseRootFromParent_Done,
      // Label 1259: @45042
      GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(45108), // Rule ID 70333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70333,
        GIR_EraseRootFromParent_Done,
      // Label 1260: @45108
      GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(45174), // Rule ID 70334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70334,
        GIR_EraseRootFromParent_Done,
      // Label 1261: @45174
      GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(45240), // Rule ID 70331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70331,
        GIR_EraseRootFromParent_Done,
      // Label 1262: @45240
      GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(45306), // Rule ID 70332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70332,
        GIR_EraseRootFromParent_Done,
      // Label 1263: @45306
      GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(45372), // Rule ID 52800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52800,
        GIR_EraseRootFromParent_Done,
      // Label 1264: @45372
      GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(45438), // Rule ID 52801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52801,
        GIR_EraseRootFromParent_Done,
      // Label 1265: @45438
      GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(45471), // Rule ID 52788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52788,
        GIR_EraseRootFromParent_Done,
      // Label 1266: @45471
      GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(45504), // Rule ID 52789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52789,
        GIR_EraseRootFromParent_Done,
      // Label 1267: @45504
      GIM_Reject,
    // Label 1257: @45505
    GIM_Reject,
    // Label 1108: @45506
    GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(45620),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(45574), // Rule ID 47382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47382,
        GIR_EraseRootFromParent_Done,
      // Label 1269: @45574
      GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(45619), // Rule ID 47383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47383,
        GIR_EraseRootFromParent_Done,
      // Label 1270: @45619
      GIM_Reject,
    // Label 1268: @45620
    GIM_Reject,
    // Label 1109: @45621
    GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(45735),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(45689), // Rule ID 47398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47398,
        GIR_EraseRootFromParent_Done,
      // Label 1272: @45689
      GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(45734), // Rule ID 47399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47399,
        GIR_EraseRootFromParent_Done,
      // Label 1273: @45734
      GIM_Reject,
    // Label 1271: @45735
    GIM_Reject,
    // Label 1110: @45736
    GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(45850),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(45804), // Rule ID 47414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47414,
        GIR_EraseRootFromParent_Done,
      // Label 1275: @45804
      GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(45849), // Rule ID 47415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47415,
        GIR_EraseRootFromParent_Done,
      // Label 1276: @45849
      GIM_Reject,
    // Label 1274: @45850
    GIM_Reject,
    // Label 1111: @45851
    GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(46461),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(45932), // Rule ID 70363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70363,
        GIR_EraseRootFromParent_Done,
      // Label 1278: @45932
      GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(45998), // Rule ID 70364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70364,
        GIR_EraseRootFromParent_Done,
      // Label 1279: @45998
      GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(46064), // Rule ID 70361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70361,
        GIR_EraseRootFromParent_Done,
      // Label 1280: @46064
      GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(46130), // Rule ID 70362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70362,
        GIR_EraseRootFromParent_Done,
      // Label 1281: @46130
      GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(46196), // Rule ID 70359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70359,
        GIR_EraseRootFromParent_Done,
      // Label 1282: @46196
      GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(46262), // Rule ID 70360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70360,
        GIR_EraseRootFromParent_Done,
      // Label 1283: @46262
      GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(46328), // Rule ID 52818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52818,
        GIR_EraseRootFromParent_Done,
      // Label 1284: @46328
      GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(46394), // Rule ID 52819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52819,
        GIR_EraseRootFromParent_Done,
      // Label 1285: @46394
      GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(46427), // Rule ID 52806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52806,
        GIR_EraseRootFromParent_Done,
      // Label 1286: @46427
      GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(46460), // Rule ID 52807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52807,
        GIR_EraseRootFromParent_Done,
      // Label 1287: @46460
      GIM_Reject,
    // Label 1277: @46461
    GIM_Reject,
    // Label 1112: @46462
    GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(46576),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(46530), // Rule ID 47386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47386,
        GIR_EraseRootFromParent_Done,
      // Label 1289: @46530
      GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(46575), // Rule ID 47387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47387,
        GIR_EraseRootFromParent_Done,
      // Label 1290: @46575
      GIM_Reject,
    // Label 1288: @46576
    GIM_Reject,
    // Label 1113: @46577
    GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(46691),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(46645), // Rule ID 47402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47402,
        GIR_EraseRootFromParent_Done,
      // Label 1292: @46645
      GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(46690), // Rule ID 47403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47403,
        GIR_EraseRootFromParent_Done,
      // Label 1293: @46690
      GIM_Reject,
    // Label 1291: @46691
    GIM_Reject,
    // Label 1114: @46692
    GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(47302),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(46773), // Rule ID 70391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70391,
        GIR_EraseRootFromParent_Done,
      // Label 1295: @46773
      GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(46839), // Rule ID 70392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70392,
        GIR_EraseRootFromParent_Done,
      // Label 1296: @46839
      GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(46905), // Rule ID 70389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70389,
        GIR_EraseRootFromParent_Done,
      // Label 1297: @46905
      GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(46971), // Rule ID 70390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70390,
        GIR_EraseRootFromParent_Done,
      // Label 1298: @46971
      GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(47037), // Rule ID 70387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70387,
        GIR_EraseRootFromParent_Done,
      // Label 1299: @47037
      GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(47103), // Rule ID 70388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70388,
        GIR_EraseRootFromParent_Done,
      // Label 1300: @47103
      GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(47169), // Rule ID 52836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52836,
        GIR_EraseRootFromParent_Done,
      // Label 1301: @47169
      GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(47235), // Rule ID 52837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52837,
        GIR_EraseRootFromParent_Done,
      // Label 1302: @47235
      GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(47268), // Rule ID 52824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52824,
        GIR_EraseRootFromParent_Done,
      // Label 1303: @47268
      GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(47301), // Rule ID 52825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52825,
        GIR_EraseRootFromParent_Done,
      // Label 1304: @47301
      GIM_Reject,
    // Label 1294: @47302
    GIM_Reject,
    // Label 1115: @47303
    GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(47417),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(47371), // Rule ID 47390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47390,
        GIR_EraseRootFromParent_Done,
      // Label 1306: @47371
      GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(47416), // Rule ID 47391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47391,
        GIR_EraseRootFromParent_Done,
      // Label 1307: @47416
      GIM_Reject,
    // Label 1305: @47417
    GIM_Reject,
    // Label 1116: @47418
    GIM_Reject,
    // Label 9: @47419
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1339*/ GIMT_Encode4(62213),
    /*GILLT_s32*//*Label 1308*/ GIMT_Encode4(47554),
    /*GILLT_s64*//*Label 1309*/ GIMT_Encode4(47980),
    /*GILLT_nxv1s1*//*Label 1310*/ GIMT_Encode4(48406),
    /*GILLT_nxv1s8*//*Label 1311*/ GIMT_Encode4(50017),
    /*GILLT_nxv1s16*//*Label 1312*/ GIMT_Encode4(50132),
    /*GILLT_nxv1s32*//*Label 1313*/ GIMT_Encode4(50247),
    /*GILLT_nxv1s64*//*Label 1314*/ GIMT_Encode4(50362),
    /*GILLT_nxv2s1*//*Label 1315*/ GIMT_Encode4(50477),
    /*GILLT_nxv2s8*//*Label 1316*/ GIMT_Encode4(52088),
    /*GILLT_nxv2s16*//*Label 1317*/ GIMT_Encode4(52203),
    /*GILLT_nxv2s32*//*Label 1318*/ GIMT_Encode4(52318),
    /*GILLT_nxv2s64*//*Label 1319*/ GIMT_Encode4(52433),
    /*GILLT_nxv4s1*//*Label 1320*/ GIMT_Encode4(52548),
    /*GILLT_nxv4s8*//*Label 1321*/ GIMT_Encode4(54159),
    /*GILLT_nxv4s16*//*Label 1322*/ GIMT_Encode4(54274),
    /*GILLT_nxv4s32*//*Label 1323*/ GIMT_Encode4(54389),
    /*GILLT_nxv4s64*//*Label 1324*/ GIMT_Encode4(54504),
    /*GILLT_nxv8s1*//*Label 1325*/ GIMT_Encode4(54619),
    /*GILLT_nxv8s8*//*Label 1326*/ GIMT_Encode4(56230),
    /*GILLT_nxv8s16*//*Label 1327*/ GIMT_Encode4(56345),
    /*GILLT_nxv8s32*//*Label 1328*/ GIMT_Encode4(56460),
    /*GILLT_nxv8s64*//*Label 1329*/ GIMT_Encode4(56575),
    /*GILLT_nxv16s1*//*Label 1330*/ GIMT_Encode4(56690),
    /*GILLT_nxv16s8*//*Label 1331*/ GIMT_Encode4(58301),
    /*GILLT_nxv16s16*//*Label 1332*/ GIMT_Encode4(58416),
    /*GILLT_nxv16s32*//*Label 1333*/ GIMT_Encode4(58531),
    /*GILLT_nxv32s1*//*Label 1334*/ GIMT_Encode4(58646),
    /*GILLT_nxv32s8*//*Label 1335*/ GIMT_Encode4(60257),
    /*GILLT_nxv32s16*//*Label 1336*/ GIMT_Encode4(60372),
    /*GILLT_nxv64s1*//*Label 1337*/ GIMT_Encode4(60487),
    /*GILLT_nxv64s8*//*Label 1338*/ GIMT_Encode4(62098),
    // Label 1308: @47554
    GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(47979),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(47648), // Rule ID 2341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2341,
        GIR_EraseRootFromParent_Done,
      // Label 1341: @47648
      GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(47703), // Rule ID 2335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2335,
        GIR_EraseRootFromParent_Done,
      // Label 1342: @47703
      GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(47758), // Rule ID 64172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64172,
        GIR_EraseRootFromParent_Done,
      // Label 1343: @47758
      GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(47810), // Rule ID 64158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64158,
        GIR_EraseRootFromParent_Done,
      // Label 1344: @47810
      GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(47865), // Rule ID 64156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64156,
        GIR_EraseRootFromParent_Done,
      // Label 1345: @47865
      GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(47917), // Rule ID 2309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2309,
        GIR_EraseRootFromParent_Done,
      // Label 1346: @47917
      GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(47955), // Rule ID 89 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 89,
        GIR_EraseRootFromParent_Done,
      // Label 1347: @47955
      GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(47978), // Rule ID 87 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 87,
        GIR_Done,
      // Label 1348: @47978
      GIM_Reject,
    // Label 1340: @47979
    GIM_Reject,
    // Label 1309: @47980
    GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(48405),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(48074), // Rule ID 2340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2340,
        GIR_EraseRootFromParent_Done,
      // Label 1350: @48074
      GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(48129), // Rule ID 2334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2334,
        GIR_EraseRootFromParent_Done,
      // Label 1351: @48129
      GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(48184), // Rule ID 64171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64171,
        GIR_EraseRootFromParent_Done,
      // Label 1352: @48184
      GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(48236), // Rule ID 64157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64157,
        GIR_EraseRootFromParent_Done,
      // Label 1353: @48236
      GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(48291), // Rule ID 64155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64155,
        GIR_EraseRootFromParent_Done,
      // Label 1354: @48291
      GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(48343), // Rule ID 2308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2308,
        GIR_EraseRootFromParent_Done,
      // Label 1355: @48343
      GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(48381), // Rule ID 88 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 88,
        GIR_EraseRootFromParent_Done,
      // Label 1356: @48381
      GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(48404), // Rule ID 86 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 86,
        GIR_Done,
      // Label 1357: @48404
      GIM_Reject,
    // Label 1349: @48405
    GIM_Reject,
    // Label 1310: @48406
    GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(50016),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(48490), // Rule ID 52720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52720,
        GIR_EraseRootFromParent_Done,
      // Label 1359: @48490
      GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(48559), // Rule ID 52721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52721,
        GIR_EraseRootFromParent_Done,
      // Label 1360: @48559
      GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(48628), // Rule ID 52722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52722,
        GIR_EraseRootFromParent_Done,
      // Label 1361: @48628
      GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(48697), // Rule ID 52723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52723,
        GIR_EraseRootFromParent_Done,
      // Label 1362: @48697
      GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(48763), // Rule ID 70205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70205,
        GIR_EraseRootFromParent_Done,
      // Label 1363: @48763
      GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(48829), // Rule ID 70206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70206,
        GIR_EraseRootFromParent_Done,
      // Label 1364: @48829
      GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(48895), // Rule ID 70203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70203,
        GIR_EraseRootFromParent_Done,
      // Label 1365: @48895
      GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(48961), // Rule ID 70204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70204,
        GIR_EraseRootFromParent_Done,
      // Label 1366: @48961
      GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(49030), // Rule ID 52724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52724,
        GIR_EraseRootFromParent_Done,
      // Label 1367: @49030
      GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(49099), // Rule ID 52725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52725,
        GIR_EraseRootFromParent_Done,
      // Label 1368: @49099
      GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(49168), // Rule ID 70199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70199,
        GIR_EraseRootFromParent_Done,
      // Label 1369: @49168
      GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(49237), // Rule ID 70200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70200,
        GIR_EraseRootFromParent_Done,
      // Label 1370: @49237
      GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(49306), // Rule ID 70201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70201,
        GIR_EraseRootFromParent_Done,
      // Label 1371: @49306
      GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(49375), // Rule ID 70202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70202,
        GIR_EraseRootFromParent_Done,
      // Label 1372: @49375
      GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(49444), // Rule ID 70207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70207,
        GIR_EraseRootFromParent_Done,
      // Label 1373: @49444
      GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(49513), // Rule ID 70208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70208,
        GIR_EraseRootFromParent_Done,
      // Label 1374: @49513
      GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(49579), // Rule ID 70211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70211,
        GIR_EraseRootFromParent_Done,
      // Label 1375: @49579
      GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(49645), // Rule ID 70212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70212,
        GIR_EraseRootFromParent_Done,
      // Label 1376: @49645
      GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(49711), // Rule ID 70209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70209,
        GIR_EraseRootFromParent_Done,
      // Label 1377: @49711
      GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(49777), // Rule ID 70210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70210,
        GIR_EraseRootFromParent_Done,
      // Label 1378: @49777
      GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(49820), // Rule ID 70225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70225,
        GIR_EraseRootFromParent_Done,
      // Label 1379: @49820
      GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(49863), // Rule ID 70226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70226,
        GIR_EraseRootFromParent_Done,
      // Label 1380: @49863
      GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(49906), // Rule ID 52730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52730,
        GIR_EraseRootFromParent_Done,
      // Label 1381: @49906
      GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(49949), // Rule ID 52731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52731,
        GIR_EraseRootFromParent_Done,
      // Label 1382: @49949
      GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(49982), // Rule ID 52718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52718,
        GIR_EraseRootFromParent_Done,
      // Label 1383: @49982
      GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(50015), // Rule ID 52719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52719,
        GIR_EraseRootFromParent_Done,
      // Label 1384: @50015
      GIM_Reject,
    // Label 1358: @50016
    GIM_Reject,
    // Label 1311: @50017
    GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(50131),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(50085), // Rule ID 47474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47474,
        GIR_EraseRootFromParent_Done,
      // Label 1386: @50085
      GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(50130), // Rule ID 47475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47475,
        GIR_EraseRootFromParent_Done,
      // Label 1387: @50130
      GIM_Reject,
    // Label 1385: @50131
    GIM_Reject,
    // Label 1312: @50132
    GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(50246),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(50200), // Rule ID 47486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47486,
        GIR_EraseRootFromParent_Done,
      // Label 1389: @50200
      GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(50245), // Rule ID 47487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47487,
        GIR_EraseRootFromParent_Done,
      // Label 1390: @50245
      GIM_Reject,
    // Label 1388: @50246
    GIM_Reject,
    // Label 1313: @50247
    GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(50361),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(50315), // Rule ID 47494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47494,
        GIR_EraseRootFromParent_Done,
      // Label 1392: @50315
      GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(50360), // Rule ID 47495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47495,
        GIR_EraseRootFromParent_Done,
      // Label 1393: @50360
      GIM_Reject,
    // Label 1391: @50361
    GIM_Reject,
    // Label 1314: @50362
    GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(50476),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(50430), // Rule ID 47510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47510,
        GIR_EraseRootFromParent_Done,
      // Label 1395: @50430
      GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(50475), // Rule ID 47511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47511,
        GIR_EraseRootFromParent_Done,
      // Label 1396: @50475
      GIM_Reject,
    // Label 1394: @50476
    GIM_Reject,
    // Label 1315: @50477
    GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(52087),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(50561), // Rule ID 52738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52738,
        GIR_EraseRootFromParent_Done,
      // Label 1398: @50561
      GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(50630), // Rule ID 52739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52739,
        GIR_EraseRootFromParent_Done,
      // Label 1399: @50630
      GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(50699), // Rule ID 52740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52740,
        GIR_EraseRootFromParent_Done,
      // Label 1400: @50699
      GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(50768), // Rule ID 52741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52741,
        GIR_EraseRootFromParent_Done,
      // Label 1401: @50768
      GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(50834), // Rule ID 70233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70233,
        GIR_EraseRootFromParent_Done,
      // Label 1402: @50834
      GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(50900), // Rule ID 70234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70234,
        GIR_EraseRootFromParent_Done,
      // Label 1403: @50900
      GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(50966), // Rule ID 70231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70231,
        GIR_EraseRootFromParent_Done,
      // Label 1404: @50966
      GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(51032), // Rule ID 70232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70232,
        GIR_EraseRootFromParent_Done,
      // Label 1405: @51032
      GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(51101), // Rule ID 52742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52742,
        GIR_EraseRootFromParent_Done,
      // Label 1406: @51101
      GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(51170), // Rule ID 52743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52743,
        GIR_EraseRootFromParent_Done,
      // Label 1407: @51170
      GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(51239), // Rule ID 70227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70227,
        GIR_EraseRootFromParent_Done,
      // Label 1408: @51239
      GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(51308), // Rule ID 70228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70228,
        GIR_EraseRootFromParent_Done,
      // Label 1409: @51308
      GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(51377), // Rule ID 70229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70229,
        GIR_EraseRootFromParent_Done,
      // Label 1410: @51377
      GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(51446), // Rule ID 70230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70230,
        GIR_EraseRootFromParent_Done,
      // Label 1411: @51446
      GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(51515), // Rule ID 70235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70235,
        GIR_EraseRootFromParent_Done,
      // Label 1412: @51515
      GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(51584), // Rule ID 70236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70236,
        GIR_EraseRootFromParent_Done,
      // Label 1413: @51584
      GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(51650), // Rule ID 70239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70239,
        GIR_EraseRootFromParent_Done,
      // Label 1414: @51650
      GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(51716), // Rule ID 70240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70240,
        GIR_EraseRootFromParent_Done,
      // Label 1415: @51716
      GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(51782), // Rule ID 70237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70237,
        GIR_EraseRootFromParent_Done,
      // Label 1416: @51782
      GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(51848), // Rule ID 70238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70238,
        GIR_EraseRootFromParent_Done,
      // Label 1417: @51848
      GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(51891), // Rule ID 70253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70253,
        GIR_EraseRootFromParent_Done,
      // Label 1418: @51891
      GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(51934), // Rule ID 70254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70254,
        GIR_EraseRootFromParent_Done,
      // Label 1419: @51934
      GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(51977), // Rule ID 52748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52748,
        GIR_EraseRootFromParent_Done,
      // Label 1420: @51977
      GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(52020), // Rule ID 52749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52749,
        GIR_EraseRootFromParent_Done,
      // Label 1421: @52020
      GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(52053), // Rule ID 52736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52736,
        GIR_EraseRootFromParent_Done,
      // Label 1422: @52053
      GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(52086), // Rule ID 52737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52737,
        GIR_EraseRootFromParent_Done,
      // Label 1423: @52086
      GIM_Reject,
    // Label 1397: @52087
    GIM_Reject,
    // Label 1316: @52088
    GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(52202),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(52156), // Rule ID 47478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47478,
        GIR_EraseRootFromParent_Done,
      // Label 1425: @52156
      GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(52201), // Rule ID 47479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47479,
        GIR_EraseRootFromParent_Done,
      // Label 1426: @52201
      GIM_Reject,
    // Label 1424: @52202
    GIM_Reject,
    // Label 1317: @52203
    GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(52317),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(52271), // Rule ID 47490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47490,
        GIR_EraseRootFromParent_Done,
      // Label 1428: @52271
      GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(52316), // Rule ID 47491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47491,
        GIR_EraseRootFromParent_Done,
      // Label 1429: @52316
      GIM_Reject,
    // Label 1427: @52317
    GIM_Reject,
    // Label 1318: @52318
    GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(52432),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(52386), // Rule ID 47506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47506,
        GIR_EraseRootFromParent_Done,
      // Label 1431: @52386
      GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(52431), // Rule ID 47507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47507,
        GIR_EraseRootFromParent_Done,
      // Label 1432: @52431
      GIM_Reject,
    // Label 1430: @52432
    GIM_Reject,
    // Label 1319: @52433
    GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(52547),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(52501), // Rule ID 47550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47550,
        GIR_EraseRootFromParent_Done,
      // Label 1434: @52501
      GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(52546), // Rule ID 47551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47551,
        GIR_EraseRootFromParent_Done,
      // Label 1435: @52546
      GIM_Reject,
    // Label 1433: @52547
    GIM_Reject,
    // Label 1320: @52548
    GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(54158),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(52632), // Rule ID 52756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52756,
        GIR_EraseRootFromParent_Done,
      // Label 1437: @52632
      GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(52701), // Rule ID 52757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52757,
        GIR_EraseRootFromParent_Done,
      // Label 1438: @52701
      GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(52770), // Rule ID 52758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52758,
        GIR_EraseRootFromParent_Done,
      // Label 1439: @52770
      GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(52839), // Rule ID 52759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52759,
        GIR_EraseRootFromParent_Done,
      // Label 1440: @52839
      GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(52905), // Rule ID 70261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70261,
        GIR_EraseRootFromParent_Done,
      // Label 1441: @52905
      GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(52971), // Rule ID 70262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70262,
        GIR_EraseRootFromParent_Done,
      // Label 1442: @52971
      GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(53037), // Rule ID 70259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70259,
        GIR_EraseRootFromParent_Done,
      // Label 1443: @53037
      GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(53103), // Rule ID 70260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70260,
        GIR_EraseRootFromParent_Done,
      // Label 1444: @53103
      GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(53172), // Rule ID 52760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52760,
        GIR_EraseRootFromParent_Done,
      // Label 1445: @53172
      GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(53241), // Rule ID 52761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52761,
        GIR_EraseRootFromParent_Done,
      // Label 1446: @53241
      GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(53310), // Rule ID 70255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70255,
        GIR_EraseRootFromParent_Done,
      // Label 1447: @53310
      GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(53379), // Rule ID 70256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70256,
        GIR_EraseRootFromParent_Done,
      // Label 1448: @53379
      GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(53448), // Rule ID 70257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70257,
        GIR_EraseRootFromParent_Done,
      // Label 1449: @53448
      GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(53517), // Rule ID 70258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70258,
        GIR_EraseRootFromParent_Done,
      // Label 1450: @53517
      GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(53586), // Rule ID 70263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70263,
        GIR_EraseRootFromParent_Done,
      // Label 1451: @53586
      GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(53655), // Rule ID 70264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70264,
        GIR_EraseRootFromParent_Done,
      // Label 1452: @53655
      GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(53721), // Rule ID 70267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70267,
        GIR_EraseRootFromParent_Done,
      // Label 1453: @53721
      GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(53787), // Rule ID 70268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70268,
        GIR_EraseRootFromParent_Done,
      // Label 1454: @53787
      GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(53853), // Rule ID 70265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70265,
        GIR_EraseRootFromParent_Done,
      // Label 1455: @53853
      GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(53919), // Rule ID 70266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70266,
        GIR_EraseRootFromParent_Done,
      // Label 1456: @53919
      GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(53962), // Rule ID 70281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70281,
        GIR_EraseRootFromParent_Done,
      // Label 1457: @53962
      GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(54005), // Rule ID 70282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70282,
        GIR_EraseRootFromParent_Done,
      // Label 1458: @54005
      GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(54048), // Rule ID 52766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52766,
        GIR_EraseRootFromParent_Done,
      // Label 1459: @54048
      GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(54091), // Rule ID 52767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52767,
        GIR_EraseRootFromParent_Done,
      // Label 1460: @54091
      GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(54124), // Rule ID 52754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52754,
        GIR_EraseRootFromParent_Done,
      // Label 1461: @54124
      GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(54157), // Rule ID 52755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52755,
        GIR_EraseRootFromParent_Done,
      // Label 1462: @54157
      GIM_Reject,
    // Label 1436: @54158
    GIM_Reject,
    // Label 1321: @54159
    GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(54273),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(54227), // Rule ID 47482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47482,
        GIR_EraseRootFromParent_Done,
      // Label 1464: @54227
      GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(54272), // Rule ID 47483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47483,
        GIR_EraseRootFromParent_Done,
      // Label 1465: @54272
      GIM_Reject,
    // Label 1463: @54273
    GIM_Reject,
    // Label 1322: @54274
    GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(54388),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(54342), // Rule ID 47502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47502,
        GIR_EraseRootFromParent_Done,
      // Label 1467: @54342
      GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(54387), // Rule ID 47503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47503,
        GIR_EraseRootFromParent_Done,
      // Label 1468: @54387
      GIM_Reject,
    // Label 1466: @54388
    GIM_Reject,
    // Label 1323: @54389
    GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(54503),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(54457), // Rule ID 47538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47538,
        GIR_EraseRootFromParent_Done,
      // Label 1470: @54457
      GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(54502), // Rule ID 47539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47539,
        GIR_EraseRootFromParent_Done,
      // Label 1471: @54502
      GIM_Reject,
    // Label 1469: @54503
    GIM_Reject,
    // Label 1324: @54504
    GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(54618),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(54572), // Rule ID 47554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47554,
        GIR_EraseRootFromParent_Done,
      // Label 1473: @54572
      GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(54617), // Rule ID 47555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47555,
        GIR_EraseRootFromParent_Done,
      // Label 1474: @54617
      GIM_Reject,
    // Label 1472: @54618
    GIM_Reject,
    // Label 1325: @54619
    GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(56229),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(54703), // Rule ID 52774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52774,
        GIR_EraseRootFromParent_Done,
      // Label 1476: @54703
      GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(54772), // Rule ID 52775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52775,
        GIR_EraseRootFromParent_Done,
      // Label 1477: @54772
      GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(54841), // Rule ID 52776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52776,
        GIR_EraseRootFromParent_Done,
      // Label 1478: @54841
      GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(54910), // Rule ID 52777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52777,
        GIR_EraseRootFromParent_Done,
      // Label 1479: @54910
      GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(54976), // Rule ID 70289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70289,
        GIR_EraseRootFromParent_Done,
      // Label 1480: @54976
      GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(55042), // Rule ID 70290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70290,
        GIR_EraseRootFromParent_Done,
      // Label 1481: @55042
      GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(55108), // Rule ID 70287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70287,
        GIR_EraseRootFromParent_Done,
      // Label 1482: @55108
      GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(55174), // Rule ID 70288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70288,
        GIR_EraseRootFromParent_Done,
      // Label 1483: @55174
      GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(55243), // Rule ID 52778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52778,
        GIR_EraseRootFromParent_Done,
      // Label 1484: @55243
      GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(55312), // Rule ID 52779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52779,
        GIR_EraseRootFromParent_Done,
      // Label 1485: @55312
      GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(55381), // Rule ID 70283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70283,
        GIR_EraseRootFromParent_Done,
      // Label 1486: @55381
      GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(55450), // Rule ID 70284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70284,
        GIR_EraseRootFromParent_Done,
      // Label 1487: @55450
      GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(55519), // Rule ID 70285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70285,
        GIR_EraseRootFromParent_Done,
      // Label 1488: @55519
      GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(55588), // Rule ID 70286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70286,
        GIR_EraseRootFromParent_Done,
      // Label 1489: @55588
      GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(55657), // Rule ID 70291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70291,
        GIR_EraseRootFromParent_Done,
      // Label 1490: @55657
      GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(55726), // Rule ID 70292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70292,
        GIR_EraseRootFromParent_Done,
      // Label 1491: @55726
      GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(55792), // Rule ID 70295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70295,
        GIR_EraseRootFromParent_Done,
      // Label 1492: @55792
      GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(55858), // Rule ID 70296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70296,
        GIR_EraseRootFromParent_Done,
      // Label 1493: @55858
      GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(55924), // Rule ID 70293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70293,
        GIR_EraseRootFromParent_Done,
      // Label 1494: @55924
      GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(55990), // Rule ID 70294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70294,
        GIR_EraseRootFromParent_Done,
      // Label 1495: @55990
      GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(56033), // Rule ID 70309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70309,
        GIR_EraseRootFromParent_Done,
      // Label 1496: @56033
      GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(56076), // Rule ID 70310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70310,
        GIR_EraseRootFromParent_Done,
      // Label 1497: @56076
      GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(56119), // Rule ID 52784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52784,
        GIR_EraseRootFromParent_Done,
      // Label 1498: @56119
      GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(56162), // Rule ID 52785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52785,
        GIR_EraseRootFromParent_Done,
      // Label 1499: @56162
      GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(56195), // Rule ID 52772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52772,
        GIR_EraseRootFromParent_Done,
      // Label 1500: @56195
      GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(56228), // Rule ID 52773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52773,
        GIR_EraseRootFromParent_Done,
      // Label 1501: @56228
      GIM_Reject,
    // Label 1475: @56229
    GIM_Reject,
    // Label 1326: @56230
    GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(56344),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(56298), // Rule ID 47498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47498,
        GIR_EraseRootFromParent_Done,
      // Label 1503: @56298
      GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(56343), // Rule ID 47499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47499,
        GIR_EraseRootFromParent_Done,
      // Label 1504: @56343
      GIM_Reject,
    // Label 1502: @56344
    GIM_Reject,
    // Label 1327: @56345
    GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(56459),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(56413), // Rule ID 47526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47526,
        GIR_EraseRootFromParent_Done,
      // Label 1506: @56413
      GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(56458), // Rule ID 47527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47527,
        GIR_EraseRootFromParent_Done,
      // Label 1507: @56458
      GIM_Reject,
    // Label 1505: @56459
    GIM_Reject,
    // Label 1328: @56460
    GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(56574),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(56528), // Rule ID 47542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47542,
        GIR_EraseRootFromParent_Done,
      // Label 1509: @56528
      GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(56573), // Rule ID 47543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47543,
        GIR_EraseRootFromParent_Done,
      // Label 1510: @56573
      GIM_Reject,
    // Label 1508: @56574
    GIM_Reject,
    // Label 1329: @56575
    GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(56689),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(56643), // Rule ID 47558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47558,
        GIR_EraseRootFromParent_Done,
      // Label 1512: @56643
      GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(56688), // Rule ID 47559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47559,
        GIR_EraseRootFromParent_Done,
      // Label 1513: @56688
      GIM_Reject,
    // Label 1511: @56689
    GIM_Reject,
    // Label 1330: @56690
    GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(58300),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(56774), // Rule ID 52792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52792,
        GIR_EraseRootFromParent_Done,
      // Label 1515: @56774
      GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(56843), // Rule ID 52793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52793,
        GIR_EraseRootFromParent_Done,
      // Label 1516: @56843
      GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(56912), // Rule ID 52794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52794,
        GIR_EraseRootFromParent_Done,
      // Label 1517: @56912
      GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(56981), // Rule ID 52795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52795,
        GIR_EraseRootFromParent_Done,
      // Label 1518: @56981
      GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(57047), // Rule ID 70317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70317,
        GIR_EraseRootFromParent_Done,
      // Label 1519: @57047
      GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(57113), // Rule ID 70318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70318,
        GIR_EraseRootFromParent_Done,
      // Label 1520: @57113
      GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(57179), // Rule ID 70315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70315,
        GIR_EraseRootFromParent_Done,
      // Label 1521: @57179
      GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(57245), // Rule ID 70316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70316,
        GIR_EraseRootFromParent_Done,
      // Label 1522: @57245
      GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(57314), // Rule ID 52796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52796,
        GIR_EraseRootFromParent_Done,
      // Label 1523: @57314
      GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(57383), // Rule ID 52797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52797,
        GIR_EraseRootFromParent_Done,
      // Label 1524: @57383
      GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(57452), // Rule ID 70311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70311,
        GIR_EraseRootFromParent_Done,
      // Label 1525: @57452
      GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(57521), // Rule ID 70312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70312,
        GIR_EraseRootFromParent_Done,
      // Label 1526: @57521
      GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(57590), // Rule ID 70313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70313,
        GIR_EraseRootFromParent_Done,
      // Label 1527: @57590
      GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(57659), // Rule ID 70314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70314,
        GIR_EraseRootFromParent_Done,
      // Label 1528: @57659
      GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(57728), // Rule ID 70319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70319,
        GIR_EraseRootFromParent_Done,
      // Label 1529: @57728
      GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(57797), // Rule ID 70320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70320,
        GIR_EraseRootFromParent_Done,
      // Label 1530: @57797
      GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(57863), // Rule ID 70323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70323,
        GIR_EraseRootFromParent_Done,
      // Label 1531: @57863
      GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(57929), // Rule ID 70324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70324,
        GIR_EraseRootFromParent_Done,
      // Label 1532: @57929
      GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(57995), // Rule ID 70321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70321,
        GIR_EraseRootFromParent_Done,
      // Label 1533: @57995
      GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(58061), // Rule ID 70322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70322,
        GIR_EraseRootFromParent_Done,
      // Label 1534: @58061
      GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(58104), // Rule ID 70337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70337,
        GIR_EraseRootFromParent_Done,
      // Label 1535: @58104
      GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(58147), // Rule ID 70338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70338,
        GIR_EraseRootFromParent_Done,
      // Label 1536: @58147
      GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(58190), // Rule ID 52802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52802,
        GIR_EraseRootFromParent_Done,
      // Label 1537: @58190
      GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(58233), // Rule ID 52803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52803,
        GIR_EraseRootFromParent_Done,
      // Label 1538: @58233
      GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(58266), // Rule ID 52790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52790,
        GIR_EraseRootFromParent_Done,
      // Label 1539: @58266
      GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(58299), // Rule ID 52791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52791,
        GIR_EraseRootFromParent_Done,
      // Label 1540: @58299
      GIM_Reject,
    // Label 1514: @58300
    GIM_Reject,
    // Label 1331: @58301
    GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(58415),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(58369), // Rule ID 47514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47514,
        GIR_EraseRootFromParent_Done,
      // Label 1542: @58369
      GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(58414), // Rule ID 47515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47515,
        GIR_EraseRootFromParent_Done,
      // Label 1543: @58414
      GIM_Reject,
    // Label 1541: @58415
    GIM_Reject,
    // Label 1332: @58416
    GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(58530),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(58484), // Rule ID 47530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47530,
        GIR_EraseRootFromParent_Done,
      // Label 1545: @58484
      GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(58529), // Rule ID 47531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47531,
        GIR_EraseRootFromParent_Done,
      // Label 1546: @58529
      GIM_Reject,
    // Label 1544: @58530
    GIM_Reject,
    // Label 1333: @58531
    GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(58645),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(58599), // Rule ID 47546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47546,
        GIR_EraseRootFromParent_Done,
      // Label 1548: @58599
      GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(58644), // Rule ID 47547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47547,
        GIR_EraseRootFromParent_Done,
      // Label 1549: @58644
      GIM_Reject,
    // Label 1547: @58645
    GIM_Reject,
    // Label 1334: @58646
    GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(60256),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(58730), // Rule ID 52810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52810,
        GIR_EraseRootFromParent_Done,
      // Label 1551: @58730
      GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(58799), // Rule ID 52811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52811,
        GIR_EraseRootFromParent_Done,
      // Label 1552: @58799
      GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(58868), // Rule ID 52812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52812,
        GIR_EraseRootFromParent_Done,
      // Label 1553: @58868
      GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(58937), // Rule ID 52813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52813,
        GIR_EraseRootFromParent_Done,
      // Label 1554: @58937
      GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(59003), // Rule ID 70345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70345,
        GIR_EraseRootFromParent_Done,
      // Label 1555: @59003
      GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(59069), // Rule ID 70346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70346,
        GIR_EraseRootFromParent_Done,
      // Label 1556: @59069
      GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(59135), // Rule ID 70343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70343,
        GIR_EraseRootFromParent_Done,
      // Label 1557: @59135
      GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(59201), // Rule ID 70344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70344,
        GIR_EraseRootFromParent_Done,
      // Label 1558: @59201
      GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(59270), // Rule ID 52814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52814,
        GIR_EraseRootFromParent_Done,
      // Label 1559: @59270
      GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(59339), // Rule ID 52815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52815,
        GIR_EraseRootFromParent_Done,
      // Label 1560: @59339
      GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(59408), // Rule ID 70339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70339,
        GIR_EraseRootFromParent_Done,
      // Label 1561: @59408
      GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(59477), // Rule ID 70340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70340,
        GIR_EraseRootFromParent_Done,
      // Label 1562: @59477
      GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(59546), // Rule ID 70341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70341,
        GIR_EraseRootFromParent_Done,
      // Label 1563: @59546
      GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(59615), // Rule ID 70342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70342,
        GIR_EraseRootFromParent_Done,
      // Label 1564: @59615
      GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(59684), // Rule ID 70347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70347,
        GIR_EraseRootFromParent_Done,
      // Label 1565: @59684
      GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(59753), // Rule ID 70348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70348,
        GIR_EraseRootFromParent_Done,
      // Label 1566: @59753
      GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(59819), // Rule ID 70351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70351,
        GIR_EraseRootFromParent_Done,
      // Label 1567: @59819
      GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(59885), // Rule ID 70352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70352,
        GIR_EraseRootFromParent_Done,
      // Label 1568: @59885
      GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(59951), // Rule ID 70349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70349,
        GIR_EraseRootFromParent_Done,
      // Label 1569: @59951
      GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(60017), // Rule ID 70350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70350,
        GIR_EraseRootFromParent_Done,
      // Label 1570: @60017
      GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(60060), // Rule ID 70365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70365,
        GIR_EraseRootFromParent_Done,
      // Label 1571: @60060
      GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(60103), // Rule ID 70366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70366,
        GIR_EraseRootFromParent_Done,
      // Label 1572: @60103
      GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(60146), // Rule ID 52820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52820,
        GIR_EraseRootFromParent_Done,
      // Label 1573: @60146
      GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(60189), // Rule ID 52821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52821,
        GIR_EraseRootFromParent_Done,
      // Label 1574: @60189
      GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(60222), // Rule ID 52808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52808,
        GIR_EraseRootFromParent_Done,
      // Label 1575: @60222
      GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(60255), // Rule ID 52809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52809,
        GIR_EraseRootFromParent_Done,
      // Label 1576: @60255
      GIM_Reject,
    // Label 1550: @60256
    GIM_Reject,
    // Label 1335: @60257
    GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(60371),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(60325), // Rule ID 47518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47518,
        GIR_EraseRootFromParent_Done,
      // Label 1578: @60325
      GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(60370), // Rule ID 47519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47519,
        GIR_EraseRootFromParent_Done,
      // Label 1579: @60370
      GIM_Reject,
    // Label 1577: @60371
    GIM_Reject,
    // Label 1336: @60372
    GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(60486),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(60440), // Rule ID 47534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47534,
        GIR_EraseRootFromParent_Done,
      // Label 1581: @60440
      GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(60485), // Rule ID 47535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47535,
        GIR_EraseRootFromParent_Done,
      // Label 1582: @60485
      GIM_Reject,
    // Label 1580: @60486
    GIM_Reject,
    // Label 1337: @60487
    GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(62097),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(60571), // Rule ID 52828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52828,
        GIR_EraseRootFromParent_Done,
      // Label 1584: @60571
      GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(60640), // Rule ID 52829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52829,
        GIR_EraseRootFromParent_Done,
      // Label 1585: @60640
      GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(60709), // Rule ID 52830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52830,
        GIR_EraseRootFromParent_Done,
      // Label 1586: @60709
      GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(60778), // Rule ID 52831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52831,
        GIR_EraseRootFromParent_Done,
      // Label 1587: @60778
      GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(60844), // Rule ID 70373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70373,
        GIR_EraseRootFromParent_Done,
      // Label 1588: @60844
      GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(60910), // Rule ID 70374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70374,
        GIR_EraseRootFromParent_Done,
      // Label 1589: @60910
      GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(60976), // Rule ID 70371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70371,
        GIR_EraseRootFromParent_Done,
      // Label 1590: @60976
      GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(61042), // Rule ID 70372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70372,
        GIR_EraseRootFromParent_Done,
      // Label 1591: @61042
      GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(61111), // Rule ID 52832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52832,
        GIR_EraseRootFromParent_Done,
      // Label 1592: @61111
      GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(61180), // Rule ID 52833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52833,
        GIR_EraseRootFromParent_Done,
      // Label 1593: @61180
      GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(61249), // Rule ID 70367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70367,
        GIR_EraseRootFromParent_Done,
      // Label 1594: @61249
      GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(61318), // Rule ID 70368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70368,
        GIR_EraseRootFromParent_Done,
      // Label 1595: @61318
      GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(61387), // Rule ID 70369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70369,
        GIR_EraseRootFromParent_Done,
      // Label 1596: @61387
      GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(61456), // Rule ID 70370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70370,
        GIR_EraseRootFromParent_Done,
      // Label 1597: @61456
      GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(61525), // Rule ID 70375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70375,
        GIR_EraseRootFromParent_Done,
      // Label 1598: @61525
      GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(61594), // Rule ID 70376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70376,
        GIR_EraseRootFromParent_Done,
      // Label 1599: @61594
      GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(61660), // Rule ID 70379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70379,
        GIR_EraseRootFromParent_Done,
      // Label 1600: @61660
      GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(61726), // Rule ID 70380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70380,
        GIR_EraseRootFromParent_Done,
      // Label 1601: @61726
      GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(61792), // Rule ID 70377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70377,
        GIR_EraseRootFromParent_Done,
      // Label 1602: @61792
      GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(61858), // Rule ID 70378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70378,
        GIR_EraseRootFromParent_Done,
      // Label 1603: @61858
      GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(61901), // Rule ID 70393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70393,
        GIR_EraseRootFromParent_Done,
      // Label 1604: @61901
      GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(61944), // Rule ID 70394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_RootToRootCopy, /*OpIdx*/2, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70394,
        GIR_EraseRootFromParent_Done,
      // Label 1605: @61944
      GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(61987), // Rule ID 52838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52838,
        GIR_EraseRootFromParent_Done,
      // Label 1606: @61987
      GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(62030), // Rule ID 52839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52839,
        GIR_EraseRootFromParent_Done,
      // Label 1607: @62030
      GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(62063), // Rule ID 52826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52826,
        GIR_EraseRootFromParent_Done,
      // Label 1608: @62063
      GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(62096), // Rule ID 52827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52827,
        GIR_EraseRootFromParent_Done,
      // Label 1609: @62096
      GIM_Reject,
    // Label 1583: @62097
    GIM_Reject,
    // Label 1338: @62098
    GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(62212),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(62166), // Rule ID 47522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47522,
        GIR_EraseRootFromParent_Done,
      // Label 1611: @62166
      GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(62211), // Rule ID 47523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47523,
        GIR_EraseRootFromParent_Done,
      // Label 1612: @62211
      GIM_Reject,
    // Label 1610: @62212
    GIM_Reject,
    // Label 1339: @62213
    GIM_Reject,
    // Label 10: @62214
    GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(62274),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(62250), // Rule ID 110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        // MIs[0] Operand 1
        // No operand predicates
        // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 110,
        GIR_EraseRootFromParent_Done,
      // Label 1614: @62250
      GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(62273), // Rule ID 111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        // MIs[0] Operand 1
        // No operand predicates
        // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 111,
        GIR_EraseRootFromParent_Done,
      // Label 1615: @62273
      GIM_Reject,
    // Label 1613: @62274
    GIM_Reject,
    // Label 11: @62275
    GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(62335),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(62319), // Rule ID 50 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
        // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50,
        GIR_Done,
      // Label 1617: @62319
      GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(62334), // Rule ID 51 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
        // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51,
        GIR_Done,
      // Label 1618: @62334
      GIM_Reject,
    // Label 1616: @62335
    GIM_Reject,
    // Label 12: @62336
    GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(62426),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(62380), // Rule ID 48 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
        // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48,
        GIR_Done,
      // Label 1620: @62380
      GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(62395), // Rule ID 49 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
        // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 49,
        GIR_Done,
      // Label 1621: @62395
      GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(62410), // Rule ID 2262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
        // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2262,
        GIR_Done,
      // Label 1622: @62410
      GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(62425), // Rule ID 2263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
        // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2263,
        GIR_Done,
      // Label 1623: @62425
      GIM_Reject,
    // Label 1619: @62426
    GIM_Reject,
    // Label 13: @62427
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1626*/ GIMT_Encode4(62793),
    /*GILLT_s32*//*Label 1624*/ GIMT_Encode4(62446),
    /*GILLT_s64*//*Label 1625*/ GIMT_Encode4(62683),
    // Label 1624: @62446
    GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(62682),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(62477), // Rule ID 1305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1305,
        GIR_Done,
      // Label 1628: @62477
      GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(62500), // Rule ID 1306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1306,
        GIR_Done,
      // Label 1629: @62500
      GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(62523), // Rule ID 1307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1307,
        GIR_Done,
      // Label 1630: @62523
      GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(62546), // Rule ID 1308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1308,
        GIR_Done,
      // Label 1631: @62546
      GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(62584), // Rule ID 1309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
        // GIR_Coverage, 1309,
        GIR_EraseRootFromParent_Done,
      // Label 1632: @62584
      GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(62622), // Rule ID 1310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
        // GIR_Coverage, 1310,
        GIR_EraseRootFromParent_Done,
      // Label 1633: @62622
      GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(62681), // Rule ID 1311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
        // GIR_Coverage, 1311,
        GIR_EraseRootFromParent_Done,
      // Label 1634: @62681
      GIM_Reject,
    // Label 1627: @62682
    GIM_Reject,
    // Label 1625: @62683
    GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(62792),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(62714), // Rule ID 1758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1758,
        GIR_Done,
      // Label 1636: @62714
      GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(62737), // Rule ID 1759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1759,
        GIR_Done,
      // Label 1637: @62737
      GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(62764), // Rule ID 1786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
        // GIR_Coverage, 1786,
        GIR_Done,
      // Label 1638: @62764
      GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(62791), // Rule ID 1787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
        // GIR_Coverage, 1787,
        GIR_Done,
      // Label 1639: @62791
      GIM_Reject,
    // Label 1635: @62792
    GIM_Reject,
    // Label 1626: @62793
    GIM_Reject,
    // Label 14: @62794
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1643*/ GIMT_Encode4(62991),
    /*GILLT_s16*//*Label 1640*/ GIMT_Encode4(62817),
    /*GILLT_s32*//*Label 1641*/ GIMT_Encode4(62875),
    /*GILLT_s64*//*Label 1642*/ GIMT_Encode4(62933),
    // Label 1640: @62817
    GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(62874),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(62853), // Rule ID 2294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
        // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2294,
        GIR_EraseRootFromParent_Done,
      // Label 1645: @62853
      GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(62873), // Rule ID 2295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
        // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2295,
        GIR_EraseRootFromParent_Done,
      // Label 1646: @62873
      GIM_Reject,
    // Label 1644: @62874
    GIM_Reject,
    // Label 1641: @62875
    GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(62932),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(62911), // Rule ID 2212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
        // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2212,
        GIR_EraseRootFromParent_Done,
      // Label 1648: @62911
      GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(62931), // Rule ID 2213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
        // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2213,
        GIR_EraseRootFromParent_Done,
      // Label 1649: @62931
      GIM_Reject,
    // Label 1647: @62932
    GIM_Reject,
    // Label 1642: @62933
    GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(62990),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(62969), // Rule ID 2252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
        // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2252,
        GIR_EraseRootFromParent_Done,
      // Label 1651: @62969
      GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(62989), // Rule ID 2253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
        // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2253,
        GIR_EraseRootFromParent_Done,
      // Label 1652: @62989
      GIM_Reject,
    // Label 1650: @62990
    GIM_Reject,
    // Label 1643: @62991
    GIM_Reject,
    // Label 15: @62992
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1656*/ GIMT_Encode4(63189),
    /*GILLT_s16*//*Label 1653*/ GIMT_Encode4(63015),
    /*GILLT_s32*//*Label 1654*/ GIMT_Encode4(63073),
    /*GILLT_s64*//*Label 1655*/ GIMT_Encode4(63131),
    // Label 1653: @63015
    GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(63072),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(63051), // Rule ID 2278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
        // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2278,
        GIR_EraseRootFromParent_Done,
      // Label 1658: @63051
      GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(63071), // Rule ID 2279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
        // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2279,
        GIR_EraseRootFromParent_Done,
      // Label 1659: @63071
      GIM_Reject,
    // Label 1657: @63072
    GIM_Reject,
    // Label 1654: @63073
    GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(63130),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(63109), // Rule ID 2196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
        // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2196,
        GIR_EraseRootFromParent_Done,
      // Label 1661: @63109
      GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(63129), // Rule ID 2197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
        // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2197,
        GIR_EraseRootFromParent_Done,
      // Label 1662: @63129
      GIM_Reject,
    // Label 1660: @63130
    GIM_Reject,
    // Label 1655: @63131
    GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(63188),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(63167), // Rule ID 2236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
        // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2236,
        GIR_EraseRootFromParent_Done,
      // Label 1664: @63167
      GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(63187), // Rule ID 2237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
        // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2237,
        GIR_EraseRootFromParent_Done,
      // Label 1665: @63187
      GIM_Reject,
    // Label 1663: @63188
    GIM_Reject,
    // Label 1656: @63189
    GIM_Reject,
    // Label 16: @63190
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1668*/ GIMT_Encode4(63769),
    /*GILLT_s32*//*Label 1666*/ GIMT_Encode4(63209),
    /*GILLT_s64*//*Label 1667*/ GIMT_Encode4(63582),
    // Label 1666: @63209
    GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(63240), // Rule ID 1324 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1324,
      GIR_EraseRootFromParent_Done,
    // Label 1669: @63240
    GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(63271), // Rule ID 1325 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1325,
      GIR_EraseRootFromParent_Done,
    // Label 1670: @63271
    GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(63302), // Rule ID 1350 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1350,
      GIR_EraseRootFromParent_Done,
    // Label 1671: @63302
    GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(63333), // Rule ID 1351 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1351,
      GIR_EraseRootFromParent_Done,
    // Label 1672: @63333
    GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(63364), // Rule ID 1718 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1718,
      GIR_EraseRootFromParent_Done,
    // Label 1673: @63364
    GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(63395), // Rule ID 1719 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1719,
      GIR_EraseRootFromParent_Done,
    // Label 1674: @63395
    GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(63426), // Rule ID 1744 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1744,
      GIR_EraseRootFromParent_Done,
    // Label 1675: @63426
    GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(63457), // Rule ID 1745 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1745,
      GIR_EraseRootFromParent_Done,
    // Label 1676: @63457
    GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(63488), // Rule ID 2060 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2060,
      GIR_EraseRootFromParent_Done,
    // Label 1677: @63488
    GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(63519), // Rule ID 2061 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2061,
      GIR_EraseRootFromParent_Done,
    // Label 1678: @63519
    GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(63550), // Rule ID 2086 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2086,
      GIR_EraseRootFromParent_Done,
    // Label 1679: @63550
    GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(63581), // Rule ID 2087 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2087,
      GIR_EraseRootFromParent_Done,
    // Label 1680: @63581
    GIM_Reject,
    // Label 1667: @63582
    GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(63613), // Rule ID 1377 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1377,
      GIR_EraseRootFromParent_Done,
    // Label 1681: @63613
    GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(63644), // Rule ID 1405 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1405,
      GIR_EraseRootFromParent_Done,
    // Label 1682: @63644
    GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(63675), // Rule ID 1775 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1775,
      GIR_EraseRootFromParent_Done,
    // Label 1683: @63675
    GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(63706), // Rule ID 1803 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1803,
      GIR_EraseRootFromParent_Done,
    // Label 1684: @63706
    GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(63737), // Rule ID 2111 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2111,
      GIR_EraseRootFromParent_Done,
    // Label 1685: @63737
    GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(63768), // Rule ID 2137 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2137,
      GIR_EraseRootFromParent_Done,
    // Label 1686: @63768
    GIM_Reject,
    // Label 1668: @63769
    GIM_Reject,
    // Label 17: @63770
    GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(63979),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1691*/ GIMT_Encode4(63978),
      /*GILLT_s16*//*Label 1688*/ GIMT_Encode4(63801),
      /*GILLT_s32*//*Label 1689*/ GIMT_Encode4(63860),
      /*GILLT_s64*//*Label 1690*/ GIMT_Encode4(63919),
      // Label 1688: @63801
      GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(63859),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(63834), // Rule ID 2113 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
          // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2113,
          GIR_EraseRootFromParent_Done,
        // Label 1693: @63834
        GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(63858), // Rule ID 2139 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
          // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2139,
          GIR_EraseRootFromParent_Done,
        // Label 1694: @63858
        GIM_Reject,
      // Label 1692: @63859
      GIM_Reject,
      // Label 1689: @63860
      GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(63918),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(63893), // Rule ID 1379 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
          // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1379,
          GIR_EraseRootFromParent_Done,
        // Label 1696: @63893
        GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(63917), // Rule ID 1407 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
          // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1407,
          GIR_EraseRootFromParent_Done,
        // Label 1697: @63917
        GIM_Reject,
      // Label 1695: @63918
      GIM_Reject,
      // Label 1690: @63919
      GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(63977),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(63952), // Rule ID 1777 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
          // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1777,
          GIR_EraseRootFromParent_Done,
        // Label 1699: @63952
        GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(63976), // Rule ID 1805 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
          // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1805,
          GIR_EraseRootFromParent_Done,
        // Label 1700: @63976
        GIM_Reject,
      // Label 1698: @63977
      GIM_Reject,
      // Label 1691: @63978
      GIM_Reject,
    // Label 1687: @63979
    GIM_Reject,
    // Label 18: @63980
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1704*/ GIMT_Encode4(64177),
    /*GILLT_s16*//*Label 1701*/ GIMT_Encode4(64003),
    /*GILLT_s32*//*Label 1702*/ GIMT_Encode4(64061),
    /*GILLT_s64*//*Label 1703*/ GIMT_Encode4(64119),
    // Label 1701: @64003
    GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(64060),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(64039), // Rule ID 2282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
        // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2282,
        GIR_EraseRootFromParent_Done,
      // Label 1706: @64039
      GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(64059), // Rule ID 2283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
        // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2283,
        GIR_EraseRootFromParent_Done,
      // Label 1707: @64059
      GIM_Reject,
    // Label 1705: @64060
    GIM_Reject,
    // Label 1702: @64061
    GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(64118),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(64097), // Rule ID 2200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
        // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2200,
        GIR_EraseRootFromParent_Done,
      // Label 1709: @64097
      GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(64117), // Rule ID 2201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
        // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2201,
        GIR_EraseRootFromParent_Done,
      // Label 1710: @64117
      GIM_Reject,
    // Label 1708: @64118
    GIM_Reject,
    // Label 1703: @64119
    GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(64176),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(64155), // Rule ID 2240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
        // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2240,
        GIR_EraseRootFromParent_Done,
      // Label 1712: @64155
      GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(64175), // Rule ID 2241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
        // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2241,
        GIR_EraseRootFromParent_Done,
      // Label 1713: @64175
      GIM_Reject,
    // Label 1711: @64176
    GIM_Reject,
    // Label 1704: @64177
    GIM_Reject,
    // Label 19: @64178
    GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(64216), // Rule ID 280 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 280,
      GIR_EraseRootFromParent_Done,
    // Label 1714: @64216
    GIM_Reject,
    // Label 20: @64217
    GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(64255), // Rule ID 281 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 281,
      GIR_EraseRootFromParent_Done,
    // Label 1715: @64255
    GIM_Reject,
    // Label 21: @64256
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 1750*/ GIMT_Encode4(72717),
    /*GILLT_p0s32*//*Label 1716*/ GIMT_Encode4(64403),
    /*GILLT_p0s64*//*Label 1717*/ GIMT_Encode4(64497),
    /*GILLT_s16*//*Label 1718*/ GIMT_Encode4(64591),
    /*GILLT_s32*//*Label 1719*/ GIMT_Encode4(65230),
    /*GILLT_s64*//*Label 1720*/ GIMT_Encode4(66484),
    /*GILLT_nxv1s1*//*Label 1721*/ GIMT_Encode4(67411),
    /*GILLT_nxv1s8*//*Label 1722*/ GIMT_Encode4(67531),
    /*GILLT_nxv1s16*//*Label 1723*/ GIMT_Encode4(67659),
    /*GILLT_nxv1s32*//*Label 1724*/ GIMT_Encode4(67897),
    /*GILLT_nxv1s64*//*Label 1725*/ GIMT_Encode4(68135),
    /*GILLT_nxv2s1*//*Label 1726*/ GIMT_Encode4(68373),
    /*GILLT_nxv2s8*//*Label 1727*/ GIMT_Encode4(68493),
    /*GILLT_nxv2s16*//*Label 1728*/ GIMT_Encode4(68621),
    /*GILLT_nxv2s32*//*Label 1729*/ GIMT_Encode4(68859),
    /*GILLT_nxv2s64*//*Label 1730*/ GIMT_Encode4(69097),
    /*GILLT_nxv4s1*//*Label 1731*/ GIMT_Encode4(69335),
    /*GILLT_nxv4s8*//*Label 1732*/ GIMT_Encode4(69455),
    /*GILLT_nxv4s16*//*Label 1733*/ GIMT_Encode4(69583),
    /*GILLT_nxv4s32*//*Label 1734*/ GIMT_Encode4(69821),
    /*GILLT_nxv4s64*//*Label 1735*/ GIMT_Encode4(70059),
    /*GILLT_nxv8s1*//*Label 1736*/ GIMT_Encode4(70297),
    /*GILLT_nxv8s8*//*Label 1737*/ GIMT_Encode4(70417),
    /*GILLT_nxv8s16*//*Label 1738*/ GIMT_Encode4(70545),
    /*GILLT_nxv8s32*//*Label 1739*/ GIMT_Encode4(70783),
    /*GILLT_nxv8s64*//*Label 1740*/ GIMT_Encode4(71021),
    /*GILLT_nxv16s1*//*Label 1741*/ GIMT_Encode4(71259),
    /*GILLT_nxv16s8*//*Label 1742*/ GIMT_Encode4(71379),
    /*GILLT_nxv16s16*//*Label 1743*/ GIMT_Encode4(71507),
    /*GILLT_nxv16s32*//*Label 1744*/ GIMT_Encode4(71745),
    /*GILLT_nxv32s1*//*Label 1745*/ GIMT_Encode4(71983),
    /*GILLT_nxv32s8*//*Label 1746*/ GIMT_Encode4(72103),
    /*GILLT_nxv32s16*//*Label 1747*/ GIMT_Encode4(72231),
    /*GILLT_nxv64s1*//*Label 1748*/ GIMT_Encode4(72469),
    /*GILLT_nxv64s8*//*Label 1749*/ GIMT_Encode4(72589),
    // Label 1716: @64403
    GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(64496),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(64459), // Rule ID 64034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64034,
        GIR_EraseRootFromParent_Done,
      // Label 1752: @64459
      GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(64495), // Rule ID 64038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64038,
        GIR_EraseRootFromParent_Done,
      // Label 1753: @64495
      GIM_Reject,
    // Label 1751: @64496
    GIM_Reject,
    // Label 1717: @64497
    GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(64590),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(64553), // Rule ID 64033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64033,
        GIR_EraseRootFromParent_Done,
      // Label 1755: @64553
      GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(64589), // Rule ID 64037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64037,
        GIR_EraseRootFromParent_Done,
      // Label 1756: @64589
      GIM_Reject,
    // Label 1754: @64590
    GIM_Reject,
    // Label 1718: @64591
    GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(64645), // Rule ID 64049 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_8>>  =>  (LB:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64049,
      GIR_EraseRootFromParent_Done,
    // Label 1757: @64645
    GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(64699), // Rule ID 64050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_8>>  =>  (LB:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64050,
      GIR_EraseRootFromParent_Done,
    // Label 1758: @64699
    GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(64753), // Rule ID 64051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_16>>  =>  (LH:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64051,
      GIR_EraseRootFromParent_Done,
    // Label 1759: @64753
    GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(64807), // Rule ID 64052 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_16>>  =>  (LH:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64052,
      GIR_EraseRootFromParent_Done,
    // Label 1760: @64807
    GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(64858), // Rule ID 2008 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2008,
      GIR_EraseRootFromParent_Done,
    // Label 1761: @64858
    GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(64909), // Rule ID 2009 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2009,
      GIR_EraseRootFromParent_Done,
    // Label 1762: @64909
    GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(64960), // Rule ID 2014 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2014,
      GIR_EraseRootFromParent_Done,
    // Label 1763: @64960
    GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(65011), // Rule ID 2015 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2015,
      GIR_EraseRootFromParent_Done,
    // Label 1764: @65011
    GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(65062), // Rule ID 64041 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64041,
      GIR_EraseRootFromParent_Done,
    // Label 1765: @65062
    GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(65113), // Rule ID 64042 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64042,
      GIR_EraseRootFromParent_Done,
    // Label 1766: @65113
    GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(65171), // Rule ID 64045 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64045,
      GIR_EraseRootFromParent_Done,
    // Label 1767: @65171
    GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(65229), // Rule ID 64046 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64046,
      GIR_EraseRootFromParent_Done,
    // Label 1768: @65229
    GIM_Reject,
    // Label 1719: @65230
    GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(65287), // Rule ID 312 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_9652>>  =>  (LB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 312,
      GIR_EraseRootFromParent_Done,
    // Label 1769: @65287
    GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(65344), // Rule ID 314 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_9654>>  =>  (LH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 314,
      GIR_EraseRootFromParent_Done,
    // Label 1770: @65344
    GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(65401), // Rule ID 316 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_9656>>  =>  (LW:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 316,
      GIR_EraseRootFromParent_Done,
    // Label 1771: @65401
    GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(65455), // Rule ID 64057 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_32>>  =>  (LW:{ *:[i32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64057,
      GIR_EraseRootFromParent_Done,
    // Label 1772: @65455
    GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(65509), // Rule ID 64058 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_32>>  =>  (LW:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64058,
      GIR_EraseRootFromParent_Done,
    // Label 1773: @65509
    GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(65567), // Rule ID 227 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 227,
      GIR_EraseRootFromParent_Done,
    // Label 1774: @65567
    GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(65625), // Rule ID 231 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 231,
      GIR_EraseRootFromParent_Done,
    // Label 1775: @65625
    GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(65676), // Rule ID 232 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 232,
      GIR_EraseRootFromParent_Done,
    // Label 1776: @65676
    GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(65727), // Rule ID 233 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 233,
      GIR_EraseRootFromParent_Done,
    // Label 1777: @65727
    GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(65778), // Rule ID 1295 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1295,
      GIR_EraseRootFromParent_Done,
    // Label 1778: @65778
    GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(65829), // Rule ID 1296 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1296,
      GIR_EraseRootFromParent_Done,
    // Label 1779: @65829
    GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(65880), // Rule ID 1301 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1301,
      GIR_EraseRootFromParent_Done,
    // Label 1780: @65880
    GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(65931), // Rule ID 1302 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1302,
      GIR_EraseRootFromParent_Done,
    // Label 1781: @65931
    GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(65989), // Rule ID 64061 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64061,
      GIR_EraseRootFromParent_Done,
    // Label 1782: @65989
    GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(66047), // Rule ID 64062 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64062,
      GIR_EraseRootFromParent_Done,
    // Label 1783: @66047
    GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(66105), // Rule ID 64063 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64063,
      GIR_EraseRootFromParent_Done,
    // Label 1784: @66105
    GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(66163), // Rule ID 64064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64064,
      GIR_EraseRootFromParent_Done,
    // Label 1785: @66163
    GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(66203), // Rule ID 1074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_10148>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1074,
      GIR_Done,
    // Label 1786: @66203
    GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(66243), // Rule ID 1076 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_10150>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1076,
      GIR_Done,
    // Label 1787: @66243
    GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(66283), // Rule ID 1078 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_10152>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1078,
      GIR_Done,
    // Label 1788: @66283
    GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(66323), // Rule ID 1080 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_10154>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1080,
      GIR_Done,
    // Label 1789: @66323
    GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(66363), // Rule ID 1082 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_10156>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1082,
      GIR_Done,
    // Label 1790: @66363
    GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(66403), // Rule ID 1084 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_10158>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1084,
      GIR_Done,
    // Label 1791: @66403
    GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(66443), // Rule ID 1098 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_10172>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1098,
      GIR_Done,
    // Label 1792: @66443
    GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(66483), // Rule ID 1100 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_10174>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1100,
      GIR_Done,
    // Label 1793: @66483
    GIM_Reject,
    // Label 1720: @66484
    GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(66541), // Rule ID 311 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_9652>>  =>  (LB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 311,
      GIR_EraseRootFromParent_Done,
    // Label 1794: @66541
    GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(66598), // Rule ID 313 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_9654>>  =>  (LH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 313,
      GIR_EraseRootFromParent_Done,
    // Label 1795: @66598
    GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(66655), // Rule ID 315 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_9656>>  =>  (LW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 315,
      GIR_EraseRootFromParent_Done,
    // Label 1796: @66655
    GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(66712), // Rule ID 323 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_9664>>  =>  (LD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 323,
      GIR_EraseRootFromParent_Done,
    // Label 1797: @66712
    GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(66770), // Rule ID 226 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 226,
      GIR_EraseRootFromParent_Done,
    // Label 1798: @66770
    GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(66828), // Rule ID 230 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 230,
      GIR_EraseRootFromParent_Done,
    // Label 1799: @66828
    GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(66886), // Rule ID 275 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 275,
      GIR_EraseRootFromParent_Done,
    // Label 1800: @66886
    GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(66937), // Rule ID 277 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 277,
      GIR_EraseRootFromParent_Done,
    // Label 1801: @66937
    GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(66988), // Rule ID 1693 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1693,
      GIR_EraseRootFromParent_Done,
    // Label 1802: @66988
    GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(67039), // Rule ID 1694 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1694,
      GIR_EraseRootFromParent_Done,
    // Label 1803: @67039
    GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(67090), // Rule ID 1698 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1698,
      GIR_EraseRootFromParent_Done,
    // Label 1804: @67090
    GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(67130), // Rule ID 1073 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_10148>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1073,
      GIR_Done,
    // Label 1805: @67130
    GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(67170), // Rule ID 1075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_10150>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1075,
      GIR_Done,
    // Label 1806: @67170
    GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(67210), // Rule ID 1077 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_10152>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1077,
      GIR_Done,
    // Label 1807: @67210
    GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(67250), // Rule ID 1079 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_10154>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1079,
      GIR_Done,
    // Label 1808: @67250
    GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(67290), // Rule ID 1081 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_10156>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1081,
      GIR_Done,
    // Label 1809: @67290
    GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(67330), // Rule ID 1083 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_10158>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1083,
      GIR_Done,
    // Label 1810: @67330
    GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(67370), // Rule ID 1097 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_10172>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1097,
      GIR_Done,
    // Label 1811: @67370
    GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(67410), // Rule ID 1099 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_10174>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1099,
      GIR_Done,
    // Label 1812: @67410
    GIM_Reject,
    // Label 1721: @67411
    GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(67530),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(67482), // Rule ID 45524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45524,
        GIR_EraseRootFromParent_Done,
      // Label 1814: @67482
      GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(67529), // Rule ID 45525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45525,
        GIR_EraseRootFromParent_Done,
      // Label 1815: @67529
      GIM_Reject,
    // Label 1813: @67530
    GIM_Reject,
    // Label 1722: @67531
    GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(67658),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(67602), // Rule ID 45520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45520,
        GIR_EraseRootFromParent_Done,
      // Label 1817: @67602
      GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(67657), // Rule ID 45521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45521,
        GIR_EraseRootFromParent_Done,
      // Label 1818: @67657
      GIM_Reject,
    // Label 1816: @67658
    GIM_Reject,
    // Label 1723: @67659
    GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(67896),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(67730), // Rule ID 45720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45720,
        GIR_EraseRootFromParent_Done,
      // Label 1820: @67730
      GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(67785), // Rule ID 45721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45721,
        GIR_EraseRootFromParent_Done,
      // Label 1821: @67785
      GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(67840), // Rule ID 45796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45796,
        GIR_EraseRootFromParent_Done,
      // Label 1822: @67840
      GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(67895), // Rule ID 45797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45797,
        GIR_EraseRootFromParent_Done,
      // Label 1823: @67895
      GIM_Reject,
    // Label 1819: @67896
    GIM_Reject,
    // Label 1724: @67897
    GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(68134),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(67968), // Rule ID 45728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45728,
        GIR_EraseRootFromParent_Done,
      // Label 1825: @67968
      GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(68023), // Rule ID 45729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45729,
        GIR_EraseRootFromParent_Done,
      // Label 1826: @68023
      GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(68078), // Rule ID 45804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45804,
        GIR_EraseRootFromParent_Done,
      // Label 1827: @68078
      GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(68133), // Rule ID 45805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45805,
        GIR_EraseRootFromParent_Done,
      // Label 1828: @68133
      GIM_Reject,
    // Label 1824: @68134
    GIM_Reject,
    // Label 1725: @68135
    GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(68372),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(68206), // Rule ID 45744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45744,
        GIR_EraseRootFromParent_Done,
      // Label 1830: @68206
      GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(68261), // Rule ID 45745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45745,
        GIR_EraseRootFromParent_Done,
      // Label 1831: @68261
      GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(68316), // Rule ID 45816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45816,
        GIR_EraseRootFromParent_Done,
      // Label 1832: @68316
      GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(68371), // Rule ID 45817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45817,
        GIR_EraseRootFromParent_Done,
      // Label 1833: @68371
      GIM_Reject,
    // Label 1829: @68372
    GIM_Reject,
    // Label 1726: @68373
    GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(68492),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(68444), // Rule ID 45856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45856,
        GIR_EraseRootFromParent_Done,
      // Label 1835: @68444
      GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(68491), // Rule ID 45857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45857,
        GIR_EraseRootFromParent_Done,
      // Label 1836: @68491
      GIM_Reject,
    // Label 1834: @68492
    GIM_Reject,
    // Label 1727: @68493
    GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(68620),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(68564), // Rule ID 45712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45712,
        GIR_EraseRootFromParent_Done,
      // Label 1838: @68564
      GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(68619), // Rule ID 45713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45713,
        GIR_EraseRootFromParent_Done,
      // Label 1839: @68619
      GIM_Reject,
    // Label 1837: @68620
    GIM_Reject,
    // Label 1728: @68621
    GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(68858),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(68692), // Rule ID 45724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45724,
        GIR_EraseRootFromParent_Done,
      // Label 1841: @68692
      GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(68747), // Rule ID 45725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45725,
        GIR_EraseRootFromParent_Done,
      // Label 1842: @68747
      GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(68802), // Rule ID 45800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45800,
        GIR_EraseRootFromParent_Done,
      // Label 1843: @68802
      GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(68857), // Rule ID 45801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45801,
        GIR_EraseRootFromParent_Done,
      // Label 1844: @68857
      GIM_Reject,
    // Label 1840: @68858
    GIM_Reject,
    // Label 1729: @68859
    GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(69096),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(68930), // Rule ID 45740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45740,
        GIR_EraseRootFromParent_Done,
      // Label 1846: @68930
      GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(68985), // Rule ID 45741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45741,
        GIR_EraseRootFromParent_Done,
      // Label 1847: @68985
      GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(69040), // Rule ID 45812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45812,
        GIR_EraseRootFromParent_Done,
      // Label 1848: @69040
      GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(69095), // Rule ID 45813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45813,
        GIR_EraseRootFromParent_Done,
      // Label 1849: @69095
      GIM_Reject,
    // Label 1845: @69096
    GIM_Reject,
    // Label 1730: @69097
    GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(69334),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(69168), // Rule ID 45784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45784,
        GIR_EraseRootFromParent_Done,
      // Label 1851: @69168
      GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(69223), // Rule ID 45785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45785,
        GIR_EraseRootFromParent_Done,
      // Label 1852: @69223
      GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(69278), // Rule ID 45844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45844,
        GIR_EraseRootFromParent_Done,
      // Label 1853: @69278
      GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(69333), // Rule ID 45845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45845,
        GIR_EraseRootFromParent_Done,
      // Label 1854: @69333
      GIM_Reject,
    // Label 1850: @69334
    GIM_Reject,
    // Label 1731: @69335
    GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(69454),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(69406), // Rule ID 45860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45860,
        GIR_EraseRootFromParent_Done,
      // Label 1856: @69406
      GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(69453), // Rule ID 45861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45861,
        GIR_EraseRootFromParent_Done,
      // Label 1857: @69453
      GIM_Reject,
    // Label 1855: @69454
    GIM_Reject,
    // Label 1732: @69455
    GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(69582),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(69526), // Rule ID 45716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45716,
        GIR_EraseRootFromParent_Done,
      // Label 1859: @69526
      GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(69581), // Rule ID 45717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45717,
        GIR_EraseRootFromParent_Done,
      // Label 1860: @69581
      GIM_Reject,
    // Label 1858: @69582
    GIM_Reject,
    // Label 1733: @69583
    GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(69820),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(69654), // Rule ID 45736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45736,
        GIR_EraseRootFromParent_Done,
      // Label 1862: @69654
      GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(69709), // Rule ID 45737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45737,
        GIR_EraseRootFromParent_Done,
      // Label 1863: @69709
      GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(69764), // Rule ID 45808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45808,
        GIR_EraseRootFromParent_Done,
      // Label 1864: @69764
      GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(69819), // Rule ID 45809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45809,
        GIR_EraseRootFromParent_Done,
      // Label 1865: @69819
      GIM_Reject,
    // Label 1861: @69820
    GIM_Reject,
    // Label 1734: @69821
    GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(70058),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(69892), // Rule ID 45772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45772,
        GIR_EraseRootFromParent_Done,
      // Label 1867: @69892
      GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(69947), // Rule ID 45773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45773,
        GIR_EraseRootFromParent_Done,
      // Label 1868: @69947
      GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(70002), // Rule ID 45832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45832,
        GIR_EraseRootFromParent_Done,
      // Label 1869: @70002
      GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(70057), // Rule ID 45833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45833,
        GIR_EraseRootFromParent_Done,
      // Label 1870: @70057
      GIM_Reject,
    // Label 1866: @70058
    GIM_Reject,
    // Label 1735: @70059
    GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(70296),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(70130), // Rule ID 45788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45788,
        GIR_EraseRootFromParent_Done,
      // Label 1872: @70130
      GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(70185), // Rule ID 45789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45789,
        GIR_EraseRootFromParent_Done,
      // Label 1873: @70185
      GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(70240), // Rule ID 45848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45848,
        GIR_EraseRootFromParent_Done,
      // Label 1874: @70240
      GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(70295), // Rule ID 45849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45849,
        GIR_EraseRootFromParent_Done,
      // Label 1875: @70295
      GIM_Reject,
    // Label 1871: @70296
    GIM_Reject,
    // Label 1736: @70297
    GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(70416),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(70368), // Rule ID 45864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45864,
        GIR_EraseRootFromParent_Done,
      // Label 1877: @70368
      GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(70415), // Rule ID 45865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45865,
        GIR_EraseRootFromParent_Done,
      // Label 1878: @70415
      GIM_Reject,
    // Label 1876: @70416
    GIM_Reject,
    // Label 1737: @70417
    GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(70544),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(70488), // Rule ID 45732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45732,
        GIR_EraseRootFromParent_Done,
      // Label 1880: @70488
      GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(70543), // Rule ID 45733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45733,
        GIR_EraseRootFromParent_Done,
      // Label 1881: @70543
      GIM_Reject,
    // Label 1879: @70544
    GIM_Reject,
    // Label 1738: @70545
    GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(70782),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(70616), // Rule ID 45760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45760,
        GIR_EraseRootFromParent_Done,
      // Label 1883: @70616
      GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(70671), // Rule ID 45761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45761,
        GIR_EraseRootFromParent_Done,
      // Label 1884: @70671
      GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(70726), // Rule ID 45820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45820,
        GIR_EraseRootFromParent_Done,
      // Label 1885: @70726
      GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(70781), // Rule ID 45821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45821,
        GIR_EraseRootFromParent_Done,
      // Label 1886: @70781
      GIM_Reject,
    // Label 1882: @70782
    GIM_Reject,
    // Label 1739: @70783
    GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(71020),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(70854), // Rule ID 45776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45776,
        GIR_EraseRootFromParent_Done,
      // Label 1888: @70854
      GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(70909), // Rule ID 45777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45777,
        GIR_EraseRootFromParent_Done,
      // Label 1889: @70909
      GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(70964), // Rule ID 45836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45836,
        GIR_EraseRootFromParent_Done,
      // Label 1890: @70964
      GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(71019), // Rule ID 45837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45837,
        GIR_EraseRootFromParent_Done,
      // Label 1891: @71019
      GIM_Reject,
    // Label 1887: @71020
    GIM_Reject,
    // Label 1740: @71021
    GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(71258),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(71092), // Rule ID 45792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45792,
        GIR_EraseRootFromParent_Done,
      // Label 1893: @71092
      GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(71147), // Rule ID 45793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45793,
        GIR_EraseRootFromParent_Done,
      // Label 1894: @71147
      GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(71202), // Rule ID 45852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45852,
        GIR_EraseRootFromParent_Done,
      // Label 1895: @71202
      GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(71257), // Rule ID 45853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45853,
        GIR_EraseRootFromParent_Done,
      // Label 1896: @71257
      GIM_Reject,
    // Label 1892: @71258
    GIM_Reject,
    // Label 1741: @71259
    GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(71378),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(71330), // Rule ID 45868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45868,
        GIR_EraseRootFromParent_Done,
      // Label 1898: @71330
      GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(71377), // Rule ID 45869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45869,
        GIR_EraseRootFromParent_Done,
      // Label 1899: @71377
      GIM_Reject,
    // Label 1897: @71378
    GIM_Reject,
    // Label 1742: @71379
    GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(71506),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(71450), // Rule ID 45748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45748,
        GIR_EraseRootFromParent_Done,
      // Label 1901: @71450
      GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(71505), // Rule ID 45749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45749,
        GIR_EraseRootFromParent_Done,
      // Label 1902: @71505
      GIM_Reject,
    // Label 1900: @71506
    GIM_Reject,
    // Label 1743: @71507
    GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(71744),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(71578), // Rule ID 45764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45764,
        GIR_EraseRootFromParent_Done,
      // Label 1904: @71578
      GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(71633), // Rule ID 45765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45765,
        GIR_EraseRootFromParent_Done,
      // Label 1905: @71633
      GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(71688), // Rule ID 45824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45824,
        GIR_EraseRootFromParent_Done,
      // Label 1906: @71688
      GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(71743), // Rule ID 45825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45825,
        GIR_EraseRootFromParent_Done,
      // Label 1907: @71743
      GIM_Reject,
    // Label 1903: @71744
    GIM_Reject,
    // Label 1744: @71745
    GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(71982),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(71816), // Rule ID 45780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45780,
        GIR_EraseRootFromParent_Done,
      // Label 1909: @71816
      GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(71871), // Rule ID 45781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45781,
        GIR_EraseRootFromParent_Done,
      // Label 1910: @71871
      GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(71926), // Rule ID 45840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45840,
        GIR_EraseRootFromParent_Done,
      // Label 1911: @71926
      GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(71981), // Rule ID 45841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45841,
        GIR_EraseRootFromParent_Done,
      // Label 1912: @71981
      GIM_Reject,
    // Label 1908: @71982
    GIM_Reject,
    // Label 1745: @71983
    GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(72102),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(72054), // Rule ID 45872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45872,
        GIR_EraseRootFromParent_Done,
      // Label 1914: @72054
      GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(72101), // Rule ID 45873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45873,
        GIR_EraseRootFromParent_Done,
      // Label 1915: @72101
      GIM_Reject,
    // Label 1913: @72102
    GIM_Reject,
    // Label 1746: @72103
    GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(72230),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(72174), // Rule ID 45752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45752,
        GIR_EraseRootFromParent_Done,
      // Label 1917: @72174
      GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(72229), // Rule ID 45753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45753,
        GIR_EraseRootFromParent_Done,
      // Label 1918: @72229
      GIM_Reject,
    // Label 1916: @72230
    GIM_Reject,
    // Label 1747: @72231
    GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(72468),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(72302), // Rule ID 45768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45768,
        GIR_EraseRootFromParent_Done,
      // Label 1920: @72302
      GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(72357), // Rule ID 45769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45769,
        GIR_EraseRootFromParent_Done,
      // Label 1921: @72357
      GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(72412), // Rule ID 45828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45828,
        GIR_EraseRootFromParent_Done,
      // Label 1922: @72412
      GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(72467), // Rule ID 45829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45829,
        GIR_EraseRootFromParent_Done,
      // Label 1923: @72467
      GIM_Reject,
    // Label 1919: @72468
    GIM_Reject,
    // Label 1748: @72469
    GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(72588),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(72540), // Rule ID 45876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45876,
        GIR_EraseRootFromParent_Done,
      // Label 1925: @72540
      GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(72587), // Rule ID 45877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45877,
        GIR_EraseRootFromParent_Done,
      // Label 1926: @72587
      GIM_Reject,
    // Label 1924: @72588
    GIM_Reject,
    // Label 1749: @72589
    GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(72716),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(72660), // Rule ID 45756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45756,
        GIR_EraseRootFromParent_Done,
      // Label 1928: @72660
      GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(72715), // Rule ID 45757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45757,
        GIR_EraseRootFromParent_Done,
      // Label 1929: @72715
      GIM_Reject,
    // Label 1927: @72716
    GIM_Reject,
    // Label 1750: @72717
    GIM_Reject,
    // Label 22: @72718
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1932*/ GIMT_Encode4(73012),
    /*GILLT_s32*//*Label 1930*/ GIMT_Encode4(72737),
    /*GILLT_s64*//*Label 1931*/ GIMT_Encode4(72849),
    // Label 1930: @72737
    GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(72848),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(72796), // Rule ID 225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 225,
        GIR_EraseRootFromParent_Done,
      // Label 1934: @72796
      GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(72847), // Rule ID 229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 229,
        GIR_EraseRootFromParent_Done,
      // Label 1935: @72847
      GIM_Reject,
    // Label 1933: @72848
    GIM_Reject,
    // Label 1931: @72849
    GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(73011),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(72908), // Rule ID 224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 224,
        GIR_EraseRootFromParent_Done,
      // Label 1937: @72908
      GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(72959), // Rule ID 228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 228,
        GIR_EraseRootFromParent_Done,
      // Label 1938: @72959
      GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(73010), // Rule ID 274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 274,
        GIR_EraseRootFromParent_Done,
      // Label 1939: @73010
      GIM_Reject,
    // Label 1936: @73011
    GIM_Reject,
    // Label 1932: @73012
    GIM_Reject,
    // Label 23: @73013
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 1942*/ GIMT_Encode4(73307),
    /*GILLT_s32*//*Label 1940*/ GIMT_Encode4(73032),
    /*GILLT_s64*//*Label 1941*/ GIMT_Encode4(73144),
    // Label 1940: @73032
    GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(73143),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(73091), // Rule ID 235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 235,
        GIR_EraseRootFromParent_Done,
      // Label 1944: @73091
      GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(73142), // Rule ID 237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 237,
        GIR_EraseRootFromParent_Done,
      // Label 1945: @73142
      GIM_Reject,
    // Label 1943: @73143
    GIM_Reject,
    // Label 1941: @73144
    GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(73306),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(73203), // Rule ID 234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 234,
        GIR_EraseRootFromParent_Done,
      // Label 1947: @73203
      GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(73254), // Rule ID 236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 236,
        GIR_EraseRootFromParent_Done,
      // Label 1948: @73254
      GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(73305), // Rule ID 276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 276,
        GIR_EraseRootFromParent_Done,
      // Label 1949: @73305
      GIM_Reject,
    // Label 1946: @73306
    GIM_Reject,
    // Label 1942: @73307
    GIM_Reject,
    // Label 24: @73308
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 1984*/ GIMT_Encode4(80105),
    /*GILLT_p0s32*//*Label 1950*/ GIMT_Encode4(73455),
    /*GILLT_p0s64*//*Label 1951*/ GIMT_Encode4(73549),
    /*GILLT_s16*//*Label 1952*/ GIMT_Encode4(73643),
    /*GILLT_s32*//*Label 1953*/ GIMT_Encode4(74282),
    /*GILLT_s64*//*Label 1954*/ GIMT_Encode4(75584),
    /*GILLT_nxv1s1*//*Label 1955*/ GIMT_Encode4(76559),
    /*GILLT_nxv1s8*//*Label 1956*/ GIMT_Encode4(76639),
    /*GILLT_nxv1s16*//*Label 1957*/ GIMT_Encode4(76727),
    /*GILLT_nxv1s32*//*Label 1958*/ GIMT_Encode4(76885),
    /*GILLT_nxv1s64*//*Label 1959*/ GIMT_Encode4(77043),
    /*GILLT_nxv2s1*//*Label 1960*/ GIMT_Encode4(77201),
    /*GILLT_nxv2s8*//*Label 1961*/ GIMT_Encode4(77281),
    /*GILLT_nxv2s16*//*Label 1962*/ GIMT_Encode4(77369),
    /*GILLT_nxv2s32*//*Label 1963*/ GIMT_Encode4(77527),
    /*GILLT_nxv2s64*//*Label 1964*/ GIMT_Encode4(77685),
    /*GILLT_nxv4s1*//*Label 1965*/ GIMT_Encode4(77843),
    /*GILLT_nxv4s8*//*Label 1966*/ GIMT_Encode4(77923),
    /*GILLT_nxv4s16*//*Label 1967*/ GIMT_Encode4(78011),
    /*GILLT_nxv4s32*//*Label 1968*/ GIMT_Encode4(78169),
    /*GILLT_nxv4s64*//*Label 1969*/ GIMT_Encode4(78327),
    /*GILLT_nxv8s1*//*Label 1970*/ GIMT_Encode4(78485),
    /*GILLT_nxv8s8*//*Label 1971*/ GIMT_Encode4(78565),
    /*GILLT_nxv8s16*//*Label 1972*/ GIMT_Encode4(78653),
    /*GILLT_nxv8s32*//*Label 1973*/ GIMT_Encode4(78811),
    /*GILLT_nxv8s64*//*Label 1974*/ GIMT_Encode4(78969),
    /*GILLT_nxv16s1*//*Label 1975*/ GIMT_Encode4(79127),
    /*GILLT_nxv16s8*//*Label 1976*/ GIMT_Encode4(79207),
    /*GILLT_nxv16s16*//*Label 1977*/ GIMT_Encode4(79295),
    /*GILLT_nxv16s32*//*Label 1978*/ GIMT_Encode4(79453),
    /*GILLT_nxv32s1*//*Label 1979*/ GIMT_Encode4(79611),
    /*GILLT_nxv32s8*//*Label 1980*/ GIMT_Encode4(79691),
    /*GILLT_nxv32s16*//*Label 1981*/ GIMT_Encode4(79779),
    /*GILLT_nxv64s1*//*Label 1982*/ GIMT_Encode4(79937),
    /*GILLT_nxv64s8*//*Label 1983*/ GIMT_Encode4(80017),
    // Label 1950: @73455
    GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(73548),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(73511), // Rule ID 64036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64036,
        GIR_EraseRootFromParent_Done,
      // Label 1986: @73511
      GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(73547), // Rule ID 64040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64040,
        GIR_EraseRootFromParent_Done,
      // Label 1987: @73547
      GIM_Reject,
    // Label 1985: @73548
    GIM_Reject,
    // Label 1951: @73549
    GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(73642),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(73605), // Rule ID 64035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64035,
        GIR_EraseRootFromParent_Done,
      // Label 1989: @73605
      GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(73641), // Rule ID 64039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
        // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64039,
        GIR_EraseRootFromParent_Done,
      // Label 1990: @73641
      GIM_Reject,
    // Label 1988: @73642
    GIM_Reject,
    // Label 1952: @73643
    GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(73697), // Rule ID 64053 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64053,
      GIR_EraseRootFromParent_Done,
    // Label 1991: @73697
    GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(73751), // Rule ID 64054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64054,
      GIR_EraseRootFromParent_Done,
    // Label 1992: @73751
    GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(73805), // Rule ID 64055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64055,
      GIR_EraseRootFromParent_Done,
    // Label 1993: @73805
    GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(73859), // Rule ID 64056 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64056,
      GIR_EraseRootFromParent_Done,
    // Label 1994: @73859
    GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(73910), // Rule ID 2010 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2010,
      GIR_EraseRootFromParent_Done,
    // Label 1995: @73910
    GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(73961), // Rule ID 2011 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2011,
      GIR_EraseRootFromParent_Done,
    // Label 1996: @73961
    GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(74012), // Rule ID 2016 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2016,
      GIR_EraseRootFromParent_Done,
    // Label 1997: @74012
    GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(74063), // Rule ID 2017 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2017,
      GIR_EraseRootFromParent_Done,
    // Label 1998: @74063
    GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(74114), // Rule ID 64043 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64043,
      GIR_EraseRootFromParent_Done,
    // Label 1999: @74114
    GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(74165), // Rule ID 64044 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64044,
      GIR_EraseRootFromParent_Done,
    // Label 2000: @74165
    GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(74223), // Rule ID 64047 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64047,
      GIR_EraseRootFromParent_Done,
    // Label 2001: @74223
    GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(74281), // Rule ID 64048 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64048,
      GIR_EraseRootFromParent_Done,
    // Label 2002: @74281
    GIM_Reject,
    // Label 1953: @74282
    GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(74339), // Rule ID 318 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_9658>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 318,
      GIR_EraseRootFromParent_Done,
    // Label 2003: @74339
    GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(74396), // Rule ID 320 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_9660>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 320,
      GIR_EraseRootFromParent_Done,
    // Label 2004: @74396
    GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(74453), // Rule ID 322 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_9662>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 322,
      GIR_EraseRootFromParent_Done,
    // Label 2005: @74453
    GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(74507), // Rule ID 64059 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64059,
      GIR_EraseRootFromParent_Done,
    // Label 2006: @74507
    GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(74561), // Rule ID 64060 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64060,
      GIR_EraseRootFromParent_Done,
    // Label 2007: @74561
    GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(74619), // Rule ID 239 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 239,
      GIR_EraseRootFromParent_Done,
    // Label 2008: @74619
    GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(74677), // Rule ID 241 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 241,
      GIR_EraseRootFromParent_Done,
    // Label 2009: @74677
    GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(74728), // Rule ID 242 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 242,
      GIR_EraseRootFromParent_Done,
    // Label 2010: @74728
    GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(74779), // Rule ID 243 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 243,
      GIR_EraseRootFromParent_Done,
    // Label 2011: @74779
    GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(74830), // Rule ID 1297 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1297,
      GIR_EraseRootFromParent_Done,
    // Label 2012: @74830
    GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(74881), // Rule ID 1298 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1298,
      GIR_EraseRootFromParent_Done,
    // Label 2013: @74881
    GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(74932), // Rule ID 1303 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1303,
      GIR_EraseRootFromParent_Done,
    // Label 2014: @74932
    GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(74983), // Rule ID 1304 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1304,
      GIR_EraseRootFromParent_Done,
    // Label 2015: @74983
    GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(75041), // Rule ID 64065 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64065,
      GIR_EraseRootFromParent_Done,
    // Label 2016: @75041
    GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(75099), // Rule ID 64066 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64066,
      GIR_EraseRootFromParent_Done,
    // Label 2017: @75099
    GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(75157), // Rule ID 64067 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64067,
      GIR_EraseRootFromParent_Done,
    // Label 2018: @75157
    GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(75215), // Rule ID 64068 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64068,
      GIR_EraseRootFromParent_Done,
    // Label 2019: @75215
    GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(75261), // Rule ID 1086 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10160>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1086,
      GIR_EraseRootFromParent_Done,
    // Label 2020: @75261
    GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(75307), // Rule ID 1088 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10162>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1088,
      GIR_EraseRootFromParent_Done,
    // Label 2021: @75307
    GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(75353), // Rule ID 1090 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10164>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1090,
      GIR_EraseRootFromParent_Done,
    // Label 2022: @75353
    GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(75399), // Rule ID 1092 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10166>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1092,
      GIR_EraseRootFromParent_Done,
    // Label 2023: @75399
    GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(75445), // Rule ID 1094 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10168>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1094,
      GIR_EraseRootFromParent_Done,
    // Label 2024: @75445
    GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(75491), // Rule ID 1096 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10170>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1096,
      GIR_EraseRootFromParent_Done,
    // Label 2025: @75491
    GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(75537), // Rule ID 1102 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10176>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1102,
      GIR_EraseRootFromParent_Done,
    // Label 2026: @75537
    GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(75583), // Rule ID 1104 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10178>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1104,
      GIR_EraseRootFromParent_Done,
    // Label 2027: @75583
    GIM_Reject,
    // Label 1954: @75584
    GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(75641), // Rule ID 317 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_9658>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 317,
      GIR_EraseRootFromParent_Done,
    // Label 2028: @75641
    GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(75698), // Rule ID 319 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_9660>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 319,
      GIR_EraseRootFromParent_Done,
    // Label 2029: @75698
    GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(75755), // Rule ID 321 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_9662>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 321,
      GIR_EraseRootFromParent_Done,
    // Label 2030: @75755
    GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(75812), // Rule ID 324 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_9666>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 324,
      GIR_EraseRootFromParent_Done,
    // Label 2031: @75812
    GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(75870), // Rule ID 238 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 238,
      GIR_EraseRootFromParent_Done,
    // Label 2032: @75870
    GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(75928), // Rule ID 240 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 240,
      GIR_EraseRootFromParent_Done,
    // Label 2033: @75928
    GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(75986), // Rule ID 278 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 278,
      GIR_EraseRootFromParent_Done,
    // Label 2034: @75986
    GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(76037), // Rule ID 279 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 279,
      GIR_EraseRootFromParent_Done,
    // Label 2035: @76037
    GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(76088), // Rule ID 1695 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1695,
      GIR_EraseRootFromParent_Done,
    // Label 2036: @76088
    GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(76139), // Rule ID 1696 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1696,
      GIR_EraseRootFromParent_Done,
    // Label 2037: @76139
    GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(76190), // Rule ID 1699 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
      // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1699,
      GIR_EraseRootFromParent_Done,
    // Label 2038: @76190
    GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(76236), // Rule ID 1085 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10160>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1085,
      GIR_EraseRootFromParent_Done,
    // Label 2039: @76236
    GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(76282), // Rule ID 1087 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10162>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1087,
      GIR_EraseRootFromParent_Done,
    // Label 2040: @76282
    GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(76328), // Rule ID 1089 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10164>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1089,
      GIR_EraseRootFromParent_Done,
    // Label 2041: @76328
    GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(76374), // Rule ID 1091 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10166>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1091,
      GIR_EraseRootFromParent_Done,
    // Label 2042: @76374
    GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(76420), // Rule ID 1093 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10168>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1093,
      GIR_EraseRootFromParent_Done,
    // Label 2043: @76420
    GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(76466), // Rule ID 1095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10170>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1095,
      GIR_EraseRootFromParent_Done,
    // Label 2044: @76466
    GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(76512), // Rule ID 1101 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10176>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1101,
      GIR_EraseRootFromParent_Done,
    // Label 2045: @76512
    GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(76558), // Rule ID 1103 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] rs1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10178>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_RootToRootCopy, /*OpIdx*/0, // rs2
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1103,
      GIR_EraseRootFromParent_Done,
    // Label 2046: @76558
    GIM_Reject,
    // Label 1955: @76559
    GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(76638),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(76610), // Rule ID 45526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45526,
        GIR_EraseRootFromParent_Done,
      // Label 2048: @76610
      GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(76637), // Rule ID 45527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45527,
        GIR_EraseRootFromParent_Done,
      // Label 2049: @76637
      GIM_Reject,
    // Label 2047: @76638
    GIM_Reject,
    // Label 1956: @76639
    GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(76726),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(76690), // Rule ID 45522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45522,
        GIR_EraseRootFromParent_Done,
      // Label 2051: @76690
      GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(76725), // Rule ID 45523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45523,
        GIR_EraseRootFromParent_Done,
      // Label 2052: @76725
      GIM_Reject,
    // Label 2050: @76726
    GIM_Reject,
    // Label 1957: @76727
    GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(76884),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(76778), // Rule ID 45722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45722,
        GIR_EraseRootFromParent_Done,
      // Label 2054: @76778
      GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(76813), // Rule ID 45723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45723,
        GIR_EraseRootFromParent_Done,
      // Label 2055: @76813
      GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(76848), // Rule ID 45798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45798,
        GIR_EraseRootFromParent_Done,
      // Label 2056: @76848
      GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(76883), // Rule ID 45799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45799,
        GIR_EraseRootFromParent_Done,
      // Label 2057: @76883
      GIM_Reject,
    // Label 2053: @76884
    GIM_Reject,
    // Label 1958: @76885
    GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(77042),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(76936), // Rule ID 45730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45730,
        GIR_EraseRootFromParent_Done,
      // Label 2059: @76936
      GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(76971), // Rule ID 45731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45731,
        GIR_EraseRootFromParent_Done,
      // Label 2060: @76971
      GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(77006), // Rule ID 45806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45806,
        GIR_EraseRootFromParent_Done,
      // Label 2061: @77006
      GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(77041), // Rule ID 45807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45807,
        GIR_EraseRootFromParent_Done,
      // Label 2062: @77041
      GIM_Reject,
    // Label 2058: @77042
    GIM_Reject,
    // Label 1959: @77043
    GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(77200),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(77094), // Rule ID 45746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45746,
        GIR_EraseRootFromParent_Done,
      // Label 2064: @77094
      GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(77129), // Rule ID 45747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45747,
        GIR_EraseRootFromParent_Done,
      // Label 2065: @77129
      GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(77164), // Rule ID 45818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45818,
        GIR_EraseRootFromParent_Done,
      // Label 2066: @77164
      GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(77199), // Rule ID 45819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45819,
        GIR_EraseRootFromParent_Done,
      // Label 2067: @77199
      GIM_Reject,
    // Label 2063: @77200
    GIM_Reject,
    // Label 1960: @77201
    GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(77280),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(77252), // Rule ID 45858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45858,
        GIR_EraseRootFromParent_Done,
      // Label 2069: @77252
      GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(77279), // Rule ID 45859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45859,
        GIR_EraseRootFromParent_Done,
      // Label 2070: @77279
      GIM_Reject,
    // Label 2068: @77280
    GIM_Reject,
    // Label 1961: @77281
    GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(77368),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(77332), // Rule ID 45714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45714,
        GIR_EraseRootFromParent_Done,
      // Label 2072: @77332
      GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(77367), // Rule ID 45715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45715,
        GIR_EraseRootFromParent_Done,
      // Label 2073: @77367
      GIM_Reject,
    // Label 2071: @77368
    GIM_Reject,
    // Label 1962: @77369
    GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(77526),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(77420), // Rule ID 45726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45726,
        GIR_EraseRootFromParent_Done,
      // Label 2075: @77420
      GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(77455), // Rule ID 45727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45727,
        GIR_EraseRootFromParent_Done,
      // Label 2076: @77455
      GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(77490), // Rule ID 45802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45802,
        GIR_EraseRootFromParent_Done,
      // Label 2077: @77490
      GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(77525), // Rule ID 45803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45803,
        GIR_EraseRootFromParent_Done,
      // Label 2078: @77525
      GIM_Reject,
    // Label 2074: @77526
    GIM_Reject,
    // Label 1963: @77527
    GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(77684),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(77578), // Rule ID 45742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45742,
        GIR_EraseRootFromParent_Done,
      // Label 2080: @77578
      GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(77613), // Rule ID 45743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45743,
        GIR_EraseRootFromParent_Done,
      // Label 2081: @77613
      GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(77648), // Rule ID 45814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45814,
        GIR_EraseRootFromParent_Done,
      // Label 2082: @77648
      GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(77683), // Rule ID 45815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45815,
        GIR_EraseRootFromParent_Done,
      // Label 2083: @77683
      GIM_Reject,
    // Label 2079: @77684
    GIM_Reject,
    // Label 1964: @77685
    GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(77842),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(77736), // Rule ID 45786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45786,
        GIR_EraseRootFromParent_Done,
      // Label 2085: @77736
      GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(77771), // Rule ID 45787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45787,
        GIR_EraseRootFromParent_Done,
      // Label 2086: @77771
      GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(77806), // Rule ID 45846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45846,
        GIR_EraseRootFromParent_Done,
      // Label 2087: @77806
      GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(77841), // Rule ID 45847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45847,
        GIR_EraseRootFromParent_Done,
      // Label 2088: @77841
      GIM_Reject,
    // Label 2084: @77842
    GIM_Reject,
    // Label 1965: @77843
    GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(77922),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(77894), // Rule ID 45862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45862,
        GIR_EraseRootFromParent_Done,
      // Label 2090: @77894
      GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(77921), // Rule ID 45863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45863,
        GIR_EraseRootFromParent_Done,
      // Label 2091: @77921
      GIM_Reject,
    // Label 2089: @77922
    GIM_Reject,
    // Label 1966: @77923
    GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(78010),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(77974), // Rule ID 45718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45718,
        GIR_EraseRootFromParent_Done,
      // Label 2093: @77974
      GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(78009), // Rule ID 45719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45719,
        GIR_EraseRootFromParent_Done,
      // Label 2094: @78009
      GIM_Reject,
    // Label 2092: @78010
    GIM_Reject,
    // Label 1967: @78011
    GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(78168),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(78062), // Rule ID 45738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45738,
        GIR_EraseRootFromParent_Done,
      // Label 2096: @78062
      GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(78097), // Rule ID 45739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45739,
        GIR_EraseRootFromParent_Done,
      // Label 2097: @78097
      GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(78132), // Rule ID 45810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45810,
        GIR_EraseRootFromParent_Done,
      // Label 2098: @78132
      GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(78167), // Rule ID 45811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45811,
        GIR_EraseRootFromParent_Done,
      // Label 2099: @78167
      GIM_Reject,
    // Label 2095: @78168
    GIM_Reject,
    // Label 1968: @78169
    GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(78326),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(78220), // Rule ID 45774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45774,
        GIR_EraseRootFromParent_Done,
      // Label 2101: @78220
      GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(78255), // Rule ID 45775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45775,
        GIR_EraseRootFromParent_Done,
      // Label 2102: @78255
      GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(78290), // Rule ID 45834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45834,
        GIR_EraseRootFromParent_Done,
      // Label 2103: @78290
      GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(78325), // Rule ID 45835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45835,
        GIR_EraseRootFromParent_Done,
      // Label 2104: @78325
      GIM_Reject,
    // Label 2100: @78326
    GIM_Reject,
    // Label 1969: @78327
    GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(78484),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(78378), // Rule ID 45790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45790,
        GIR_EraseRootFromParent_Done,
      // Label 2106: @78378
      GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(78413), // Rule ID 45791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45791,
        GIR_EraseRootFromParent_Done,
      // Label 2107: @78413
      GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(78448), // Rule ID 45850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45850,
        GIR_EraseRootFromParent_Done,
      // Label 2108: @78448
      GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(78483), // Rule ID 45851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45851,
        GIR_EraseRootFromParent_Done,
      // Label 2109: @78483
      GIM_Reject,
    // Label 2105: @78484
    GIM_Reject,
    // Label 1970: @78485
    GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(78564),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(78536), // Rule ID 45866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45866,
        GIR_EraseRootFromParent_Done,
      // Label 2111: @78536
      GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(78563), // Rule ID 45867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45867,
        GIR_EraseRootFromParent_Done,
      // Label 2112: @78563
      GIM_Reject,
    // Label 2110: @78564
    GIM_Reject,
    // Label 1971: @78565
    GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(78652),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(78616), // Rule ID 45734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45734,
        GIR_EraseRootFromParent_Done,
      // Label 2114: @78616
      GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(78651), // Rule ID 45735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45735,
        GIR_EraseRootFromParent_Done,
      // Label 2115: @78651
      GIM_Reject,
    // Label 2113: @78652
    GIM_Reject,
    // Label 1972: @78653
    GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(78810),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(78704), // Rule ID 45762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45762,
        GIR_EraseRootFromParent_Done,
      // Label 2117: @78704
      GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(78739), // Rule ID 45763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45763,
        GIR_EraseRootFromParent_Done,
      // Label 2118: @78739
      GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(78774), // Rule ID 45822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45822,
        GIR_EraseRootFromParent_Done,
      // Label 2119: @78774
      GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(78809), // Rule ID 45823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45823,
        GIR_EraseRootFromParent_Done,
      // Label 2120: @78809
      GIM_Reject,
    // Label 2116: @78810
    GIM_Reject,
    // Label 1973: @78811
    GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(78968),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(78862), // Rule ID 45778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45778,
        GIR_EraseRootFromParent_Done,
      // Label 2122: @78862
      GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(78897), // Rule ID 45779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45779,
        GIR_EraseRootFromParent_Done,
      // Label 2123: @78897
      GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(78932), // Rule ID 45838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45838,
        GIR_EraseRootFromParent_Done,
      // Label 2124: @78932
      GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(78967), // Rule ID 45839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45839,
        GIR_EraseRootFromParent_Done,
      // Label 2125: @78967
      GIM_Reject,
    // Label 2121: @78968
    GIM_Reject,
    // Label 1974: @78969
    GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(79126),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(79020), // Rule ID 45794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45794,
        GIR_EraseRootFromParent_Done,
      // Label 2127: @79020
      GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(79055), // Rule ID 45795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45795,
        GIR_EraseRootFromParent_Done,
      // Label 2128: @79055
      GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(79090), // Rule ID 45854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45854,
        GIR_EraseRootFromParent_Done,
      // Label 2129: @79090
      GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(79125), // Rule ID 45855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45855,
        GIR_EraseRootFromParent_Done,
      // Label 2130: @79125
      GIM_Reject,
    // Label 2126: @79126
    GIM_Reject,
    // Label 1975: @79127
    GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(79206),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(79178), // Rule ID 45870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45870,
        GIR_EraseRootFromParent_Done,
      // Label 2132: @79178
      GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(79205), // Rule ID 45871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45871,
        GIR_EraseRootFromParent_Done,
      // Label 2133: @79205
      GIM_Reject,
    // Label 2131: @79206
    GIM_Reject,
    // Label 1976: @79207
    GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(79294),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(79258), // Rule ID 45750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45750,
        GIR_EraseRootFromParent_Done,
      // Label 2135: @79258
      GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(79293), // Rule ID 45751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45751,
        GIR_EraseRootFromParent_Done,
      // Label 2136: @79293
      GIM_Reject,
    // Label 2134: @79294
    GIM_Reject,
    // Label 1977: @79295
    GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(79452),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(79346), // Rule ID 45766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45766,
        GIR_EraseRootFromParent_Done,
      // Label 2138: @79346
      GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(79381), // Rule ID 45767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45767,
        GIR_EraseRootFromParent_Done,
      // Label 2139: @79381
      GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(79416), // Rule ID 45826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45826,
        GIR_EraseRootFromParent_Done,
      // Label 2140: @79416
      GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(79451), // Rule ID 45827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45827,
        GIR_EraseRootFromParent_Done,
      // Label 2141: @79451
      GIM_Reject,
    // Label 2137: @79452
    GIM_Reject,
    // Label 1978: @79453
    GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(79610),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(79504), // Rule ID 45782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45782,
        GIR_EraseRootFromParent_Done,
      // Label 2143: @79504
      GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(79539), // Rule ID 45783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45783,
        GIR_EraseRootFromParent_Done,
      // Label 2144: @79539
      GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(79574), // Rule ID 45842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45842,
        GIR_EraseRootFromParent_Done,
      // Label 2145: @79574
      GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(79609), // Rule ID 45843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45843,
        GIR_EraseRootFromParent_Done,
      // Label 2146: @79609
      GIM_Reject,
    // Label 2142: @79610
    GIM_Reject,
    // Label 1979: @79611
    GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(79690),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(79662), // Rule ID 45874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45874,
        GIR_EraseRootFromParent_Done,
      // Label 2148: @79662
      GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(79689), // Rule ID 45875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45875,
        GIR_EraseRootFromParent_Done,
      // Label 2149: @79689
      GIM_Reject,
    // Label 2147: @79690
    GIM_Reject,
    // Label 1980: @79691
    GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(79778),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(79742), // Rule ID 45754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45754,
        GIR_EraseRootFromParent_Done,
      // Label 2151: @79742
      GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(79777), // Rule ID 45755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45755,
        GIR_EraseRootFromParent_Done,
      // Label 2152: @79777
      GIM_Reject,
    // Label 2150: @79778
    GIM_Reject,
    // Label 1981: @79779
    GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(79936),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(79830), // Rule ID 45770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45770,
        GIR_EraseRootFromParent_Done,
      // Label 2154: @79830
      GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(79865), // Rule ID 45771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45771,
        GIR_EraseRootFromParent_Done,
      // Label 2155: @79865
      GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(79900), // Rule ID 45830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45830,
        GIR_EraseRootFromParent_Done,
      // Label 2156: @79900
      GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(79935), // Rule ID 45831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45831,
        GIR_EraseRootFromParent_Done,
      // Label 2157: @79935
      GIM_Reject,
    // Label 2153: @79936
    GIM_Reject,
    // Label 1982: @79937
    GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(80016),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(79988), // Rule ID 45878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45878,
        GIR_EraseRootFromParent_Done,
      // Label 2159: @79988
      GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(80015), // Rule ID 45879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45879,
        GIR_EraseRootFromParent_Done,
      // Label 2160: @80015
      GIM_Reject,
    // Label 2158: @80016
    GIM_Reject,
    // Label 1983: @80017
    GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(80104),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(80068), // Rule ID 45758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45758,
        GIR_EraseRootFromParent_Done,
      // Label 2162: @80068
      GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(80103), // Rule ID 45759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // rs2
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45759,
        GIR_EraseRootFromParent_Done,
      // Label 2163: @80103
      GIM_Reject,
    // Label 2161: @80104
    GIM_Reject,
    // Label 1984: @80105
    GIM_Reject,
    // Label 25: @80106
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2166*/ GIMT_Encode4(84991),
    /*GILLT_s32*//*Label 2164*/ GIMT_Encode4(80125),
    /*GILLT_s64*//*Label 2165*/ GIMT_Encode4(82118),
    // Label 2164: @80125
    GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(82117),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(80202), // Rule ID 627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 627,
        GIR_EraseRootFromParent_Done,
      // Label 2168: @80202
      GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(80268), // Rule ID 629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 629,
        GIR_EraseRootFromParent_Done,
      // Label 2169: @80268
      GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(80334), // Rule ID 631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 631,
        GIR_EraseRootFromParent_Done,
      // Label 2170: @80334
      GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(80400), // Rule ID 633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 633,
        GIR_EraseRootFromParent_Done,
      // Label 2171: @80400
      GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(80466), // Rule ID 635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 635,
        GIR_EraseRootFromParent_Done,
      // Label 2172: @80466
      GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(80521), // Rule ID 644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 644,
        GIR_EraseRootFromParent_Done,
      // Label 2173: @80521
      GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(80576), // Rule ID 646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 646,
        GIR_EraseRootFromParent_Done,
      // Label 2174: @80576
      GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(80631), // Rule ID 648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 648,
        GIR_EraseRootFromParent_Done,
      // Label 2175: @80631
      GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(80686), // Rule ID 650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 650,
        GIR_EraseRootFromParent_Done,
      // Label 2176: @80686
      GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(80741), // Rule ID 652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 652,
        GIR_EraseRootFromParent_Done,
      // Label 2177: @80741
      GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(80796), // Rule ID 654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 654,
        GIR_EraseRootFromParent_Done,
      // Label 2178: @80796
      GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(80851), // Rule ID 656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 656,
        GIR_EraseRootFromParent_Done,
      // Label 2179: @80851
      GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(80906), // Rule ID 658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 658,
        GIR_EraseRootFromParent_Done,
      // Label 2180: @80906
      GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(80961), // Rule ID 660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 660,
        GIR_EraseRootFromParent_Done,
      // Label 2181: @80961
      GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(81016), // Rule ID 662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 662,
        GIR_EraseRootFromParent_Done,
      // Label 2182: @81016
      GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(81071), // Rule ID 1034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1034,
        GIR_EraseRootFromParent_Done,
      // Label 2183: @81071
      GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(81126), // Rule ID 1036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1036,
        GIR_EraseRootFromParent_Done,
      // Label 2184: @81126
      GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(81181), // Rule ID 1038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1038,
        GIR_EraseRootFromParent_Done,
      // Label 2185: @81181
      GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(81236), // Rule ID 1040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1040,
        GIR_EraseRootFromParent_Done,
      // Label 2186: @81236
      GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(81291), // Rule ID 1042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1042,
        GIR_EraseRootFromParent_Done,
      // Label 2187: @81291
      GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(81346), // Rule ID 1044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1044,
        GIR_EraseRootFromParent_Done,
      // Label 2188: @81346
      GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(81401), // Rule ID 1046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1046,
        GIR_EraseRootFromParent_Done,
      // Label 2189: @81401
      GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(81456), // Rule ID 1048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1048,
        GIR_EraseRootFromParent_Done,
      // Label 2190: @81456
      GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(81511), // Rule ID 1050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1050,
        GIR_EraseRootFromParent_Done,
      // Label 2191: @81511
      GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(81566), // Rule ID 1052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1052,
        GIR_EraseRootFromParent_Done,
      // Label 2192: @81566
      GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(81621), // Rule ID 1054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1054,
        GIR_EraseRootFromParent_Done,
      // Label 2193: @81621
      GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(81676), // Rule ID 1056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1056,
        GIR_EraseRootFromParent_Done,
      // Label 2194: @81676
      GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(81731), // Rule ID 1058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1058,
        GIR_EraseRootFromParent_Done,
      // Label 2195: @81731
      GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(81786), // Rule ID 1060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1060,
        GIR_EraseRootFromParent_Done,
      // Label 2196: @81786
      GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(81841), // Rule ID 1062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1062,
        GIR_EraseRootFromParent_Done,
      // Label 2197: @81841
      GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(81896), // Rule ID 1064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1064,
        GIR_EraseRootFromParent_Done,
      // Label 2198: @81896
      GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(81951), // Rule ID 1066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1066,
        GIR_EraseRootFromParent_Done,
      // Label 2199: @81951
      GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(82006), // Rule ID 1068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1068,
        GIR_EraseRootFromParent_Done,
      // Label 2200: @82006
      GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(82061), // Rule ID 1070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1070,
        GIR_EraseRootFromParent_Done,
      // Label 2201: @82061
      GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(82116), // Rule ID 1072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1072,
        GIR_EraseRootFromParent_Done,
      // Label 2202: @82116
      GIM_Reject,
    // Label 2167: @82117
    GIM_Reject,
    // Label 2165: @82118
    GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(84990),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(82195), // Rule ID 626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 626,
        GIR_EraseRootFromParent_Done,
      // Label 2204: @82195
      GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(82261), // Rule ID 628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 628,
        GIR_EraseRootFromParent_Done,
      // Label 2205: @82261
      GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(82327), // Rule ID 630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 630,
        GIR_EraseRootFromParent_Done,
      // Label 2206: @82327
      GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(82393), // Rule ID 632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 632,
        GIR_EraseRootFromParent_Done,
      // Label 2207: @82393
      GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(82459), // Rule ID 634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 634,
        GIR_EraseRootFromParent_Done,
      // Label 2208: @82459
      GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(82525), // Rule ID 636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 636,
        GIR_EraseRootFromParent_Done,
      // Label 2209: @82525
      GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(82591), // Rule ID 637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 637,
        GIR_EraseRootFromParent_Done,
      // Label 2210: @82591
      GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(82657), // Rule ID 638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 638,
        GIR_EraseRootFromParent_Done,
      // Label 2211: @82657
      GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(82723), // Rule ID 639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 639,
        GIR_EraseRootFromParent_Done,
      // Label 2212: @82723
      GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(82789), // Rule ID 640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 640,
        GIR_EraseRootFromParent_Done,
      // Label 2213: @82789
      GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(82844), // Rule ID 643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 643,
        GIR_EraseRootFromParent_Done,
      // Label 2214: @82844
      GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(82899), // Rule ID 645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 645,
        GIR_EraseRootFromParent_Done,
      // Label 2215: @82899
      GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(82954), // Rule ID 647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 647,
        GIR_EraseRootFromParent_Done,
      // Label 2216: @82954
      GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(83009), // Rule ID 649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 649,
        GIR_EraseRootFromParent_Done,
      // Label 2217: @83009
      GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(83064), // Rule ID 651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 651,
        GIR_EraseRootFromParent_Done,
      // Label 2218: @83064
      GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(83119), // Rule ID 653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 653,
        GIR_EraseRootFromParent_Done,
      // Label 2219: @83119
      GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(83174), // Rule ID 655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 655,
        GIR_EraseRootFromParent_Done,
      // Label 2220: @83174
      GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(83229), // Rule ID 657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 657,
        GIR_EraseRootFromParent_Done,
      // Label 2221: @83229
      GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(83284), // Rule ID 659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 659,
        GIR_EraseRootFromParent_Done,
      // Label 2222: @83284
      GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(83339), // Rule ID 661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 661,
        GIR_EraseRootFromParent_Done,
      // Label 2223: @83339
      GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(83394), // Rule ID 663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 663,
        GIR_EraseRootFromParent_Done,
      // Label 2224: @83394
      GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(83449), // Rule ID 664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 664,
        GIR_EraseRootFromParent_Done,
      // Label 2225: @83449
      GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(83504), // Rule ID 665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 665,
        GIR_EraseRootFromParent_Done,
      // Label 2226: @83504
      GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(83559), // Rule ID 666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 666,
        GIR_EraseRootFromParent_Done,
      // Label 2227: @83559
      GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(83614), // Rule ID 667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 667,
        GIR_EraseRootFromParent_Done,
      // Label 2228: @83614
      GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(83669), // Rule ID 668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 668,
        GIR_EraseRootFromParent_Done,
      // Label 2229: @83669
      GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(83724), // Rule ID 669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 669,
        GIR_EraseRootFromParent_Done,
      // Label 2230: @83724
      GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(83779), // Rule ID 670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 670,
        GIR_EraseRootFromParent_Done,
      // Label 2231: @83779
      GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(83834), // Rule ID 671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 671,
        GIR_EraseRootFromParent_Done,
      // Label 2232: @83834
      GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(83889), // Rule ID 672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 672,
        GIR_EraseRootFromParent_Done,
      // Label 2233: @83889
      GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(83944), // Rule ID 1033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1033,
        GIR_EraseRootFromParent_Done,
      // Label 2234: @83944
      GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(83999), // Rule ID 1035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1035,
        GIR_EraseRootFromParent_Done,
      // Label 2235: @83999
      GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(84054), // Rule ID 1037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1037,
        GIR_EraseRootFromParent_Done,
      // Label 2236: @84054
      GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(84109), // Rule ID 1039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1039,
        GIR_EraseRootFromParent_Done,
      // Label 2237: @84109
      GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(84164), // Rule ID 1041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1041,
        GIR_EraseRootFromParent_Done,
      // Label 2238: @84164
      GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(84219), // Rule ID 1043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1043,
        GIR_EraseRootFromParent_Done,
      // Label 2239: @84219
      GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(84274), // Rule ID 1045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1045,
        GIR_EraseRootFromParent_Done,
      // Label 2240: @84274
      GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(84329), // Rule ID 1047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1047,
        GIR_EraseRootFromParent_Done,
      // Label 2241: @84329
      GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(84384), // Rule ID 1049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1049,
        GIR_EraseRootFromParent_Done,
      // Label 2242: @84384
      GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(84439), // Rule ID 1051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1051,
        GIR_EraseRootFromParent_Done,
      // Label 2243: @84439
      GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(84494), // Rule ID 1053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1053,
        GIR_EraseRootFromParent_Done,
      // Label 2244: @84494
      GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(84549), // Rule ID 1055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1055,
        GIR_EraseRootFromParent_Done,
      // Label 2245: @84549
      GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(84604), // Rule ID 1057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1057,
        GIR_EraseRootFromParent_Done,
      // Label 2246: @84604
      GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(84659), // Rule ID 1059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1059,
        GIR_EraseRootFromParent_Done,
      // Label 2247: @84659
      GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(84714), // Rule ID 1061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1061,
        GIR_EraseRootFromParent_Done,
      // Label 2248: @84714
      GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(84769), // Rule ID 1063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1063,
        GIR_EraseRootFromParent_Done,
      // Label 2249: @84769
      GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(84824), // Rule ID 1065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1065,
        GIR_EraseRootFromParent_Done,
      // Label 2250: @84824
      GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(84879), // Rule ID 1067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1067,
        GIR_EraseRootFromParent_Done,
      // Label 2251: @84879
      GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(84934), // Rule ID 1069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1069,
        GIR_EraseRootFromParent_Done,
      // Label 2252: @84934
      GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(84989), // Rule ID 1071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1071,
        GIR_EraseRootFromParent_Done,
      // Label 2253: @84989
      GIM_Reject,
    // Label 2203: @84990
    GIM_Reject,
    // Label 2166: @84991
    GIM_Reject,
    // Label 26: @84992
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2256*/ GIMT_Encode4(87901),
    /*GILLT_s32*//*Label 2254*/ GIMT_Encode4(85011),
    /*GILLT_s64*//*Label 2255*/ GIMT_Encode4(86251),
    // Label 2254: @85011
    GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(86250),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(85060), // Rule ID 326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 326,
        GIR_Done,
      // Label 2258: @85060
      GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(85101), // Rule ID 328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 328,
        GIR_Done,
      // Label 2259: @85101
      GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(85142), // Rule ID 330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 330,
        GIR_Done,
      // Label 2260: @85142
      GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(85183), // Rule ID 332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 332,
        GIR_Done,
      // Label 2261: @85183
      GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(85224), // Rule ID 334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 334,
        GIR_Done,
      // Label 2262: @85224
      GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(85265), // Rule ID 336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 336,
        GIR_Done,
      // Label 2263: @85265
      GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(85306), // Rule ID 338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 338,
        GIR_Done,
      // Label 2264: @85306
      GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(85347), // Rule ID 340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 340,
        GIR_Done,
      // Label 2265: @85347
      GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(85388), // Rule ID 342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 342,
        GIR_Done,
      // Label 2266: @85388
      GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(85429), // Rule ID 344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 344,
        GIR_Done,
      // Label 2267: @85429
      GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(85470), // Rule ID 674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 674,
        GIR_Done,
      // Label 2268: @85470
      GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(85511), // Rule ID 676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 676,
        GIR_Done,
      // Label 2269: @85511
      GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(85552), // Rule ID 678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 678,
        GIR_Done,
      // Label 2270: @85552
      GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(85593), // Rule ID 680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 680,
        GIR_Done,
      // Label 2271: @85593
      GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(85634), // Rule ID 682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 682,
        GIR_Done,
      // Label 2272: @85634
      GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(85675), // Rule ID 684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 684,
        GIR_Done,
      // Label 2273: @85675
      GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(85716), // Rule ID 686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 686,
        GIR_Done,
      // Label 2274: @85716
      GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(85757), // Rule ID 688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 688,
        GIR_Done,
      // Label 2275: @85757
      GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(85798), // Rule ID 690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 690,
        GIR_Done,
      // Label 2276: @85798
      GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(85839), // Rule ID 692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 692,
        GIR_Done,
      // Label 2277: @85839
      GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(85880), // Rule ID 854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 854,
        GIR_Done,
      // Label 2278: @85880
      GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(85921), // Rule ID 856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 856,
        GIR_Done,
      // Label 2279: @85921
      GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(85962), // Rule ID 858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 858,
        GIR_Done,
      // Label 2280: @85962
      GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(86003), // Rule ID 860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 860,
        GIR_Done,
      // Label 2281: @86003
      GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(86044), // Rule ID 862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 862,
        GIR_Done,
      // Label 2282: @86044
      GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(86085), // Rule ID 864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 864,
        GIR_Done,
      // Label 2283: @86085
      GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(86126), // Rule ID 866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 866,
        GIR_Done,
      // Label 2284: @86126
      GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(86167), // Rule ID 868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 868,
        GIR_Done,
      // Label 2285: @86167
      GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(86208), // Rule ID 870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 870,
        GIR_Done,
      // Label 2286: @86208
      GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(86249), // Rule ID 872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 872,
        GIR_Done,
      // Label 2287: @86249
      GIM_Reject,
    // Label 2257: @86250
    GIM_Reject,
    // Label 2255: @86251
    GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(87900),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(86300), // Rule ID 325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 325,
        GIR_Done,
      // Label 2289: @86300
      GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(86341), // Rule ID 327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 327,
        GIR_Done,
      // Label 2290: @86341
      GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(86382), // Rule ID 329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 329,
        GIR_Done,
      // Label 2291: @86382
      GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(86423), // Rule ID 331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 331,
        GIR_Done,
      // Label 2292: @86423
      GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(86464), // Rule ID 333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 333,
        GIR_Done,
      // Label 2293: @86464
      GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(86505), // Rule ID 335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 335,
        GIR_Done,
      // Label 2294: @86505
      GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(86546), // Rule ID 337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 337,
        GIR_Done,
      // Label 2295: @86546
      GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(86587), // Rule ID 339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 339,
        GIR_Done,
      // Label 2296: @86587
      GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(86628), // Rule ID 341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 341,
        GIR_Done,
      // Label 2297: @86628
      GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(86669), // Rule ID 343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 343,
        GIR_Done,
      // Label 2298: @86669
      GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(86710), // Rule ID 505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 505,
        GIR_Done,
      // Label 2299: @86710
      GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(86751), // Rule ID 506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 506,
        GIR_Done,
      // Label 2300: @86751
      GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(86792), // Rule ID 507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 507,
        GIR_Done,
      // Label 2301: @86792
      GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(86833), // Rule ID 508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 508,
        GIR_Done,
      // Label 2302: @86833
      GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(86874), // Rule ID 509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 509,
        GIR_Done,
      // Label 2303: @86874
      GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(86915), // Rule ID 510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 510,
        GIR_Done,
      // Label 2304: @86915
      GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(86956), // Rule ID 511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 511,
        GIR_Done,
      // Label 2305: @86956
      GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(86997), // Rule ID 512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 512,
        GIR_Done,
      // Label 2306: @86997
      GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(87038), // Rule ID 513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 513,
        GIR_Done,
      // Label 2307: @87038
      GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(87079), // Rule ID 514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 514,
        GIR_Done,
      // Label 2308: @87079
      GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(87120), // Rule ID 673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 673,
        GIR_Done,
      // Label 2309: @87120
      GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(87161), // Rule ID 675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 675,
        GIR_Done,
      // Label 2310: @87161
      GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(87202), // Rule ID 677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 677,
        GIR_Done,
      // Label 2311: @87202
      GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(87243), // Rule ID 679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 679,
        GIR_Done,
      // Label 2312: @87243
      GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(87284), // Rule ID 681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 681,
        GIR_Done,
      // Label 2313: @87284
      GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(87325), // Rule ID 683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 683,
        GIR_Done,
      // Label 2314: @87325
      GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(87366), // Rule ID 685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 685,
        GIR_Done,
      // Label 2315: @87366
      GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(87407), // Rule ID 687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 687,
        GIR_Done,
      // Label 2316: @87407
      GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(87448), // Rule ID 689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 689,
        GIR_Done,
      // Label 2317: @87448
      GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(87489), // Rule ID 691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 691,
        GIR_Done,
      // Label 2318: @87489
      GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(87530), // Rule ID 853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 853,
        GIR_Done,
      // Label 2319: @87530
      GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(87571), // Rule ID 855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 855,
        GIR_Done,
      // Label 2320: @87571
      GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(87612), // Rule ID 857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 857,
        GIR_Done,
      // Label 2321: @87612
      GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(87653), // Rule ID 859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 859,
        GIR_Done,
      // Label 2322: @87653
      GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(87694), // Rule ID 861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 861,
        GIR_Done,
      // Label 2323: @87694
      GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(87735), // Rule ID 863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 863,
        GIR_Done,
      // Label 2324: @87735
      GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(87776), // Rule ID 865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 865,
        GIR_Done,
      // Label 2325: @87776
      GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(87817), // Rule ID 867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 867,
        GIR_Done,
      // Label 2326: @87817
      GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(87858), // Rule ID 869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 869,
        GIR_Done,
      // Label 2327: @87858
      GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(87899), // Rule ID 871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 871,
        GIR_Done,
      // Label 2328: @87899
      GIM_Reject,
    // Label 2288: @87900
    GIM_Reject,
    // Label 2256: @87901
    GIM_Reject,
    // Label 27: @87902
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2331*/ GIMT_Encode4(90811),
    /*GILLT_s32*//*Label 2329*/ GIMT_Encode4(87921),
    /*GILLT_s64*//*Label 2330*/ GIMT_Encode4(89161),
    // Label 2329: @87921
    GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(89160),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(87970), // Rule ID 346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 346,
        GIR_Done,
      // Label 2333: @87970
      GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(88011), // Rule ID 348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 348,
        GIR_Done,
      // Label 2334: @88011
      GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(88052), // Rule ID 350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 350,
        GIR_Done,
      // Label 2335: @88052
      GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(88093), // Rule ID 352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 352,
        GIR_Done,
      // Label 2336: @88093
      GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(88134), // Rule ID 354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 354,
        GIR_Done,
      // Label 2337: @88134
      GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(88175), // Rule ID 356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 356,
        GIR_Done,
      // Label 2338: @88175
      GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(88216), // Rule ID 358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 358,
        GIR_Done,
      // Label 2339: @88216
      GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(88257), // Rule ID 360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 360,
        GIR_Done,
      // Label 2340: @88257
      GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(88298), // Rule ID 362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 362,
        GIR_Done,
      // Label 2341: @88298
      GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(88339), // Rule ID 364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 364,
        GIR_Done,
      // Label 2342: @88339
      GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(88380), // Rule ID 694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 694,
        GIR_Done,
      // Label 2343: @88380
      GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(88421), // Rule ID 696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 696,
        GIR_Done,
      // Label 2344: @88421
      GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(88462), // Rule ID 698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 698,
        GIR_Done,
      // Label 2345: @88462
      GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(88503), // Rule ID 700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 700,
        GIR_Done,
      // Label 2346: @88503
      GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(88544), // Rule ID 702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 702,
        GIR_Done,
      // Label 2347: @88544
      GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(88585), // Rule ID 704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 704,
        GIR_Done,
      // Label 2348: @88585
      GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(88626), // Rule ID 706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 706,
        GIR_Done,
      // Label 2349: @88626
      GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(88667), // Rule ID 708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 708,
        GIR_Done,
      // Label 2350: @88667
      GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(88708), // Rule ID 710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 710,
        GIR_Done,
      // Label 2351: @88708
      GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(88749), // Rule ID 712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 712,
        GIR_Done,
      // Label 2352: @88749
      GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(88790), // Rule ID 874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 874,
        GIR_Done,
      // Label 2353: @88790
      GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(88831), // Rule ID 876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 876,
        GIR_Done,
      // Label 2354: @88831
      GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(88872), // Rule ID 878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 878,
        GIR_Done,
      // Label 2355: @88872
      GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(88913), // Rule ID 880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 880,
        GIR_Done,
      // Label 2356: @88913
      GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(88954), // Rule ID 882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 882,
        GIR_Done,
      // Label 2357: @88954
      GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(88995), // Rule ID 884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 884,
        GIR_Done,
      // Label 2358: @88995
      GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(89036), // Rule ID 886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 886,
        GIR_Done,
      // Label 2359: @89036
      GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(89077), // Rule ID 888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 888,
        GIR_Done,
      // Label 2360: @89077
      GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(89118), // Rule ID 890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 890,
        GIR_Done,
      // Label 2361: @89118
      GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(89159), // Rule ID 892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 892,
        GIR_Done,
      // Label 2362: @89159
      GIM_Reject,
    // Label 2332: @89160
    GIM_Reject,
    // Label 2330: @89161
    GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(90810),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(89210), // Rule ID 345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 345,
        GIR_Done,
      // Label 2364: @89210
      GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(89251), // Rule ID 347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 347,
        GIR_Done,
      // Label 2365: @89251
      GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(89292), // Rule ID 349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 349,
        GIR_Done,
      // Label 2366: @89292
      GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(89333), // Rule ID 351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 351,
        GIR_Done,
      // Label 2367: @89333
      GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(89374), // Rule ID 353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 353,
        GIR_Done,
      // Label 2368: @89374
      GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(89415), // Rule ID 355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 355,
        GIR_Done,
      // Label 2369: @89415
      GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(89456), // Rule ID 357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 357,
        GIR_Done,
      // Label 2370: @89456
      GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(89497), // Rule ID 359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 359,
        GIR_Done,
      // Label 2371: @89497
      GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(89538), // Rule ID 361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 361,
        GIR_Done,
      // Label 2372: @89538
      GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(89579), // Rule ID 363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 363,
        GIR_Done,
      // Label 2373: @89579
      GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(89620), // Rule ID 515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 515,
        GIR_Done,
      // Label 2374: @89620
      GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(89661), // Rule ID 516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 516,
        GIR_Done,
      // Label 2375: @89661
      GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(89702), // Rule ID 517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 517,
        GIR_Done,
      // Label 2376: @89702
      GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(89743), // Rule ID 518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 518,
        GIR_Done,
      // Label 2377: @89743
      GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(89784), // Rule ID 519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 519,
        GIR_Done,
      // Label 2378: @89784
      GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(89825), // Rule ID 520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 520,
        GIR_Done,
      // Label 2379: @89825
      GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(89866), // Rule ID 521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 521,
        GIR_Done,
      // Label 2380: @89866
      GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(89907), // Rule ID 522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 522,
        GIR_Done,
      // Label 2381: @89907
      GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(89948), // Rule ID 523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 523,
        GIR_Done,
      // Label 2382: @89948
      GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(89989), // Rule ID 524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 524,
        GIR_Done,
      // Label 2383: @89989
      GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(90030), // Rule ID 693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 693,
        GIR_Done,
      // Label 2384: @90030
      GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(90071), // Rule ID 695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 695,
        GIR_Done,
      // Label 2385: @90071
      GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(90112), // Rule ID 697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 697,
        GIR_Done,
      // Label 2386: @90112
      GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(90153), // Rule ID 699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 699,
        GIR_Done,
      // Label 2387: @90153
      GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(90194), // Rule ID 701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 701,
        GIR_Done,
      // Label 2388: @90194
      GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(90235), // Rule ID 703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 703,
        GIR_Done,
      // Label 2389: @90235
      GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(90276), // Rule ID 705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 705,
        GIR_Done,
      // Label 2390: @90276
      GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(90317), // Rule ID 707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 707,
        GIR_Done,
      // Label 2391: @90317
      GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(90358), // Rule ID 709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 709,
        GIR_Done,
      // Label 2392: @90358
      GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(90399), // Rule ID 711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 711,
        GIR_Done,
      // Label 2393: @90399
      GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(90440), // Rule ID 873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 873,
        GIR_Done,
      // Label 2394: @90440
      GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(90481), // Rule ID 875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 875,
        GIR_Done,
      // Label 2395: @90481
      GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(90522), // Rule ID 877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 877,
        GIR_Done,
      // Label 2396: @90522
      GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(90563), // Rule ID 879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 879,
        GIR_Done,
      // Label 2397: @90563
      GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(90604), // Rule ID 881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 881,
        GIR_Done,
      // Label 2398: @90604
      GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(90645), // Rule ID 883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 883,
        GIR_Done,
      // Label 2399: @90645
      GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(90686), // Rule ID 885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 885,
        GIR_Done,
      // Label 2400: @90686
      GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(90727), // Rule ID 887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 887,
        GIR_Done,
      // Label 2401: @90727
      GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(90768), // Rule ID 889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 889,
        GIR_Done,
      // Label 2402: @90768
      GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(90809), // Rule ID 891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 891,
        GIR_Done,
      // Label 2403: @90809
      GIM_Reject,
    // Label 2363: @90810
    GIM_Reject,
    // Label 2331: @90811
    GIM_Reject,
    // Label 28: @90812
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2406*/ GIMT_Encode4(93721),
    /*GILLT_s32*//*Label 2404*/ GIMT_Encode4(90831),
    /*GILLT_s64*//*Label 2405*/ GIMT_Encode4(92071),
    // Label 2404: @90831
    GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(92070),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(90880), // Rule ID 366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 366,
        GIR_Done,
      // Label 2408: @90880
      GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(90921), // Rule ID 368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 368,
        GIR_Done,
      // Label 2409: @90921
      GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(90962), // Rule ID 370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 370,
        GIR_Done,
      // Label 2410: @90962
      GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(91003), // Rule ID 372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 372,
        GIR_Done,
      // Label 2411: @91003
      GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(91044), // Rule ID 374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 374,
        GIR_Done,
      // Label 2412: @91044
      GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(91085), // Rule ID 376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 376,
        GIR_Done,
      // Label 2413: @91085
      GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(91126), // Rule ID 378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 378,
        GIR_Done,
      // Label 2414: @91126
      GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(91167), // Rule ID 380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 380,
        GIR_Done,
      // Label 2415: @91167
      GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(91208), // Rule ID 382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 382,
        GIR_Done,
      // Label 2416: @91208
      GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(91249), // Rule ID 384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 384,
        GIR_Done,
      // Label 2417: @91249
      GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(91290), // Rule ID 714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 714,
        GIR_Done,
      // Label 2418: @91290
      GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(91331), // Rule ID 716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 716,
        GIR_Done,
      // Label 2419: @91331
      GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(91372), // Rule ID 718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 718,
        GIR_Done,
      // Label 2420: @91372
      GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(91413), // Rule ID 720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 720,
        GIR_Done,
      // Label 2421: @91413
      GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(91454), // Rule ID 722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 722,
        GIR_Done,
      // Label 2422: @91454
      GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(91495), // Rule ID 724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 724,
        GIR_Done,
      // Label 2423: @91495
      GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(91536), // Rule ID 726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 726,
        GIR_Done,
      // Label 2424: @91536
      GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(91577), // Rule ID 728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 728,
        GIR_Done,
      // Label 2425: @91577
      GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(91618), // Rule ID 730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 730,
        GIR_Done,
      // Label 2426: @91618
      GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(91659), // Rule ID 732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 732,
        GIR_Done,
      // Label 2427: @91659
      GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(91700), // Rule ID 894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 894,
        GIR_Done,
      // Label 2428: @91700
      GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(91741), // Rule ID 896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 896,
        GIR_Done,
      // Label 2429: @91741
      GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(91782), // Rule ID 898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 898,
        GIR_Done,
      // Label 2430: @91782
      GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(91823), // Rule ID 900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 900,
        GIR_Done,
      // Label 2431: @91823
      GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(91864), // Rule ID 902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 902,
        GIR_Done,
      // Label 2432: @91864
      GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(91905), // Rule ID 904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 904,
        GIR_Done,
      // Label 2433: @91905
      GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(91946), // Rule ID 906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 906,
        GIR_Done,
      // Label 2434: @91946
      GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(91987), // Rule ID 908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 908,
        GIR_Done,
      // Label 2435: @91987
      GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(92028), // Rule ID 910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 910,
        GIR_Done,
      // Label 2436: @92028
      GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(92069), // Rule ID 912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 912,
        GIR_Done,
      // Label 2437: @92069
      GIM_Reject,
    // Label 2407: @92070
    GIM_Reject,
    // Label 2405: @92071
    GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(93720),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(92120), // Rule ID 365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 365,
        GIR_Done,
      // Label 2439: @92120
      GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(92161), // Rule ID 367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 367,
        GIR_Done,
      // Label 2440: @92161
      GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(92202), // Rule ID 369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 369,
        GIR_Done,
      // Label 2441: @92202
      GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(92243), // Rule ID 371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 371,
        GIR_Done,
      // Label 2442: @92243
      GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(92284), // Rule ID 373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 373,
        GIR_Done,
      // Label 2443: @92284
      GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(92325), // Rule ID 375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 375,
        GIR_Done,
      // Label 2444: @92325
      GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(92366), // Rule ID 377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 377,
        GIR_Done,
      // Label 2445: @92366
      GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(92407), // Rule ID 379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 379,
        GIR_Done,
      // Label 2446: @92407
      GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(92448), // Rule ID 381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 381,
        GIR_Done,
      // Label 2447: @92448
      GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(92489), // Rule ID 383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 383,
        GIR_Done,
      // Label 2448: @92489
      GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(92530), // Rule ID 525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 525,
        GIR_Done,
      // Label 2449: @92530
      GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(92571), // Rule ID 526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 526,
        GIR_Done,
      // Label 2450: @92571
      GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(92612), // Rule ID 527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 527,
        GIR_Done,
      // Label 2451: @92612
      GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(92653), // Rule ID 528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 528,
        GIR_Done,
      // Label 2452: @92653
      GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(92694), // Rule ID 529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 529,
        GIR_Done,
      // Label 2453: @92694
      GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(92735), // Rule ID 530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 530,
        GIR_Done,
      // Label 2454: @92735
      GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(92776), // Rule ID 531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 531,
        GIR_Done,
      // Label 2455: @92776
      GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(92817), // Rule ID 532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 532,
        GIR_Done,
      // Label 2456: @92817
      GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(92858), // Rule ID 533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 533,
        GIR_Done,
      // Label 2457: @92858
      GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(92899), // Rule ID 534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 534,
        GIR_Done,
      // Label 2458: @92899
      GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(92940), // Rule ID 713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 713,
        GIR_Done,
      // Label 2459: @92940
      GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(92981), // Rule ID 715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 715,
        GIR_Done,
      // Label 2460: @92981
      GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(93022), // Rule ID 717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 717,
        GIR_Done,
      // Label 2461: @93022
      GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(93063), // Rule ID 719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 719,
        GIR_Done,
      // Label 2462: @93063
      GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(93104), // Rule ID 721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 721,
        GIR_Done,
      // Label 2463: @93104
      GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(93145), // Rule ID 723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 723,
        GIR_Done,
      // Label 2464: @93145
      GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(93186), // Rule ID 725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 725,
        GIR_Done,
      // Label 2465: @93186
      GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(93227), // Rule ID 727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 727,
        GIR_Done,
      // Label 2466: @93227
      GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(93268), // Rule ID 729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 729,
        GIR_Done,
      // Label 2467: @93268
      GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(93309), // Rule ID 731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 731,
        GIR_Done,
      // Label 2468: @93309
      GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(93350), // Rule ID 893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 893,
        GIR_Done,
      // Label 2469: @93350
      GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(93391), // Rule ID 895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 895,
        GIR_Done,
      // Label 2470: @93391
      GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(93432), // Rule ID 897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 897,
        GIR_Done,
      // Label 2471: @93432
      GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(93473), // Rule ID 899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 899,
        GIR_Done,
      // Label 2472: @93473
      GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(93514), // Rule ID 901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 901,
        GIR_Done,
      // Label 2473: @93514
      GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(93555), // Rule ID 903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 903,
        GIR_Done,
      // Label 2474: @93555
      GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(93596), // Rule ID 905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 905,
        GIR_Done,
      // Label 2475: @93596
      GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(93637), // Rule ID 907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 907,
        GIR_Done,
      // Label 2476: @93637
      GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(93678), // Rule ID 909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 909,
        GIR_Done,
      // Label 2477: @93678
      GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(93719), // Rule ID 911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 911,
        GIR_Done,
      // Label 2478: @93719
      GIM_Reject,
    // Label 2438: @93720
    GIM_Reject,
    // Label 2406: @93721
    GIM_Reject,
    // Label 29: @93722
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2481*/ GIMT_Encode4(94633),
    /*GILLT_s32*//*Label 2479*/ GIMT_Encode4(93741),
    /*GILLT_s64*//*Label 2480*/ GIMT_Encode4(94023),
    // Label 2479: @93741
    GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(94022),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(93809), // Rule ID 596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 596,
        GIR_EraseRootFromParent_Done,
      // Label 2483: @93809
      GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(93862), // Rule ID 598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 598,
        GIR_EraseRootFromParent_Done,
      // Label 2484: @93862
      GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(93915), // Rule ID 600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 600,
        GIR_EraseRootFromParent_Done,
      // Label 2485: @93915
      GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(93968), // Rule ID 602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 602,
        GIR_EraseRootFromParent_Done,
      // Label 2486: @93968
      GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(94021), // Rule ID 604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 604,
        GIR_EraseRootFromParent_Done,
      // Label 2487: @94021
      GIM_Reject,
    // Label 2482: @94022
    GIM_Reject,
    // Label 2480: @94023
    GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(94632),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(94091), // Rule ID 595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 595,
        GIR_EraseRootFromParent_Done,
      // Label 2489: @94091
      GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(94151), // Rule ID 597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 597,
        GIR_EraseRootFromParent_Done,
      // Label 2490: @94151
      GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(94211), // Rule ID 599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 599,
        GIR_EraseRootFromParent_Done,
      // Label 2491: @94211
      GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(94271), // Rule ID 601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 601,
        GIR_EraseRootFromParent_Done,
      // Label 2492: @94271
      GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(94331), // Rule ID 603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 603,
        GIR_EraseRootFromParent_Done,
      // Label 2493: @94331
      GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(94391), // Rule ID 613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 613,
        GIR_EraseRootFromParent_Done,
      // Label 2494: @94391
      GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(94451), // Rule ID 614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 614,
        GIR_EraseRootFromParent_Done,
      // Label 2495: @94451
      GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(94511), // Rule ID 615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 615,
        GIR_EraseRootFromParent_Done,
      // Label 2496: @94511
      GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(94571), // Rule ID 616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 616,
        GIR_EraseRootFromParent_Done,
      // Label 2497: @94571
      GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(94631), // Rule ID 617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // incr
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 617,
        GIR_EraseRootFromParent_Done,
      // Label 2498: @94631
      GIM_Reject,
    // Label 2488: @94632
    GIM_Reject,
    // Label 2481: @94633
    GIM_Reject,
    // Label 30: @94634
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2501*/ GIMT_Encode4(97543),
    /*GILLT_s32*//*Label 2499*/ GIMT_Encode4(94653),
    /*GILLT_s64*//*Label 2500*/ GIMT_Encode4(95893),
    // Label 2499: @94653
    GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(95892),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(94702), // Rule ID 386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 386,
        GIR_Done,
      // Label 2503: @94702
      GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(94743), // Rule ID 388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 388,
        GIR_Done,
      // Label 2504: @94743
      GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(94784), // Rule ID 390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 390,
        GIR_Done,
      // Label 2505: @94784
      GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(94825), // Rule ID 392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 392,
        GIR_Done,
      // Label 2506: @94825
      GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(94866), // Rule ID 394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 394,
        GIR_Done,
      // Label 2507: @94866
      GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(94907), // Rule ID 396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 396,
        GIR_Done,
      // Label 2508: @94907
      GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(94948), // Rule ID 398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 398,
        GIR_Done,
      // Label 2509: @94948
      GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(94989), // Rule ID 400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 400,
        GIR_Done,
      // Label 2510: @94989
      GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(95030), // Rule ID 402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 402,
        GIR_Done,
      // Label 2511: @95030
      GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(95071), // Rule ID 404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 404,
        GIR_Done,
      // Label 2512: @95071
      GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(95112), // Rule ID 734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 734,
        GIR_Done,
      // Label 2513: @95112
      GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(95153), // Rule ID 736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 736,
        GIR_Done,
      // Label 2514: @95153
      GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(95194), // Rule ID 738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 738,
        GIR_Done,
      // Label 2515: @95194
      GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(95235), // Rule ID 740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 740,
        GIR_Done,
      // Label 2516: @95235
      GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(95276), // Rule ID 742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 742,
        GIR_Done,
      // Label 2517: @95276
      GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(95317), // Rule ID 744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 744,
        GIR_Done,
      // Label 2518: @95317
      GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(95358), // Rule ID 746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 746,
        GIR_Done,
      // Label 2519: @95358
      GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(95399), // Rule ID 748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 748,
        GIR_Done,
      // Label 2520: @95399
      GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(95440), // Rule ID 750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 750,
        GIR_Done,
      // Label 2521: @95440
      GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(95481), // Rule ID 752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 752,
        GIR_Done,
      // Label 2522: @95481
      GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(95522), // Rule ID 914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 914,
        GIR_Done,
      // Label 2523: @95522
      GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(95563), // Rule ID 916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 916,
        GIR_Done,
      // Label 2524: @95563
      GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(95604), // Rule ID 918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 918,
        GIR_Done,
      // Label 2525: @95604
      GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(95645), // Rule ID 920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 920,
        GIR_Done,
      // Label 2526: @95645
      GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(95686), // Rule ID 922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 922,
        GIR_Done,
      // Label 2527: @95686
      GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(95727), // Rule ID 924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 924,
        GIR_Done,
      // Label 2528: @95727
      GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(95768), // Rule ID 926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 926,
        GIR_Done,
      // Label 2529: @95768
      GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(95809), // Rule ID 928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 928,
        GIR_Done,
      // Label 2530: @95809
      GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(95850), // Rule ID 930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 930,
        GIR_Done,
      // Label 2531: @95850
      GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(95891), // Rule ID 932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 932,
        GIR_Done,
      // Label 2532: @95891
      GIM_Reject,
    // Label 2502: @95892
    GIM_Reject,
    // Label 2500: @95893
    GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(97542),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(95942), // Rule ID 385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 385,
        GIR_Done,
      // Label 2534: @95942
      GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(95983), // Rule ID 387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 387,
        GIR_Done,
      // Label 2535: @95983
      GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(96024), // Rule ID 389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 389,
        GIR_Done,
      // Label 2536: @96024
      GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(96065), // Rule ID 391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 391,
        GIR_Done,
      // Label 2537: @96065
      GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(96106), // Rule ID 393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 393,
        GIR_Done,
      // Label 2538: @96106
      GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(96147), // Rule ID 395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 395,
        GIR_Done,
      // Label 2539: @96147
      GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(96188), // Rule ID 397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 397,
        GIR_Done,
      // Label 2540: @96188
      GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(96229), // Rule ID 399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 399,
        GIR_Done,
      // Label 2541: @96229
      GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(96270), // Rule ID 401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 401,
        GIR_Done,
      // Label 2542: @96270
      GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(96311), // Rule ID 403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 403,
        GIR_Done,
      // Label 2543: @96311
      GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(96352), // Rule ID 535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 535,
        GIR_Done,
      // Label 2544: @96352
      GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(96393), // Rule ID 536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 536,
        GIR_Done,
      // Label 2545: @96393
      GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(96434), // Rule ID 537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 537,
        GIR_Done,
      // Label 2546: @96434
      GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(96475), // Rule ID 538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 538,
        GIR_Done,
      // Label 2547: @96475
      GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(96516), // Rule ID 539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 539,
        GIR_Done,
      // Label 2548: @96516
      GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(96557), // Rule ID 540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 540,
        GIR_Done,
      // Label 2549: @96557
      GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(96598), // Rule ID 541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 541,
        GIR_Done,
      // Label 2550: @96598
      GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(96639), // Rule ID 542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 542,
        GIR_Done,
      // Label 2551: @96639
      GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(96680), // Rule ID 543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 543,
        GIR_Done,
      // Label 2552: @96680
      GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(96721), // Rule ID 544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 544,
        GIR_Done,
      // Label 2553: @96721
      GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(96762), // Rule ID 733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 733,
        GIR_Done,
      // Label 2554: @96762
      GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(96803), // Rule ID 735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 735,
        GIR_Done,
      // Label 2555: @96803
      GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(96844), // Rule ID 737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 737,
        GIR_Done,
      // Label 2556: @96844
      GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(96885), // Rule ID 739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 739,
        GIR_Done,
      // Label 2557: @96885
      GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(96926), // Rule ID 741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 741,
        GIR_Done,
      // Label 2558: @96926
      GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(96967), // Rule ID 743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 743,
        GIR_Done,
      // Label 2559: @96967
      GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(97008), // Rule ID 745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 745,
        GIR_Done,
      // Label 2560: @97008
      GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(97049), // Rule ID 747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 747,
        GIR_Done,
      // Label 2561: @97049
      GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(97090), // Rule ID 749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 749,
        GIR_Done,
      // Label 2562: @97090
      GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(97131), // Rule ID 751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 751,
        GIR_Done,
      // Label 2563: @97131
      GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(97172), // Rule ID 913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 913,
        GIR_Done,
      // Label 2564: @97172
      GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(97213), // Rule ID 915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 915,
        GIR_Done,
      // Label 2565: @97213
      GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(97254), // Rule ID 917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 917,
        GIR_Done,
      // Label 2566: @97254
      GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(97295), // Rule ID 919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 919,
        GIR_Done,
      // Label 2567: @97295
      GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(97336), // Rule ID 921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 921,
        GIR_Done,
      // Label 2568: @97336
      GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(97377), // Rule ID 923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 923,
        GIR_Done,
      // Label 2569: @97377
      GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(97418), // Rule ID 925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 925,
        GIR_Done,
      // Label 2570: @97418
      GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(97459), // Rule ID 927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 927,
        GIR_Done,
      // Label 2571: @97459
      GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(97500), // Rule ID 929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 929,
        GIR_Done,
      // Label 2572: @97500
      GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(97541), // Rule ID 931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 931,
        GIR_Done,
      // Label 2573: @97541
      GIM_Reject,
    // Label 2533: @97542
    GIM_Reject,
    // Label 2501: @97543
    GIM_Reject,
    // Label 31: @97544
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2576*/ GIMT_Encode4(100453),
    /*GILLT_s32*//*Label 2574*/ GIMT_Encode4(97563),
    /*GILLT_s64*//*Label 2575*/ GIMT_Encode4(98803),
    // Label 2574: @97563
    GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(98802),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(97612), // Rule ID 406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 406,
        GIR_Done,
      // Label 2578: @97612
      GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(97653), // Rule ID 408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 408,
        GIR_Done,
      // Label 2579: @97653
      GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(97694), // Rule ID 410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 410,
        GIR_Done,
      // Label 2580: @97694
      GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(97735), // Rule ID 412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 412,
        GIR_Done,
      // Label 2581: @97735
      GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(97776), // Rule ID 414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 414,
        GIR_Done,
      // Label 2582: @97776
      GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(97817), // Rule ID 416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 416,
        GIR_Done,
      // Label 2583: @97817
      GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(97858), // Rule ID 418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 418,
        GIR_Done,
      // Label 2584: @97858
      GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(97899), // Rule ID 420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 420,
        GIR_Done,
      // Label 2585: @97899
      GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(97940), // Rule ID 422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 422,
        GIR_Done,
      // Label 2586: @97940
      GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(97981), // Rule ID 424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 424,
        GIR_Done,
      // Label 2587: @97981
      GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(98022), // Rule ID 754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 754,
        GIR_Done,
      // Label 2588: @98022
      GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(98063), // Rule ID 756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 756,
        GIR_Done,
      // Label 2589: @98063
      GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(98104), // Rule ID 758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 758,
        GIR_Done,
      // Label 2590: @98104
      GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(98145), // Rule ID 760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 760,
        GIR_Done,
      // Label 2591: @98145
      GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(98186), // Rule ID 762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 762,
        GIR_Done,
      // Label 2592: @98186
      GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(98227), // Rule ID 764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 764,
        GIR_Done,
      // Label 2593: @98227
      GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(98268), // Rule ID 766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 766,
        GIR_Done,
      // Label 2594: @98268
      GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(98309), // Rule ID 768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 768,
        GIR_Done,
      // Label 2595: @98309
      GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(98350), // Rule ID 770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 770,
        GIR_Done,
      // Label 2596: @98350
      GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(98391), // Rule ID 772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 772,
        GIR_Done,
      // Label 2597: @98391
      GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(98432), // Rule ID 934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 934,
        GIR_Done,
      // Label 2598: @98432
      GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(98473), // Rule ID 936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 936,
        GIR_Done,
      // Label 2599: @98473
      GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(98514), // Rule ID 938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 938,
        GIR_Done,
      // Label 2600: @98514
      GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(98555), // Rule ID 940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 940,
        GIR_Done,
      // Label 2601: @98555
      GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(98596), // Rule ID 942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 942,
        GIR_Done,
      // Label 2602: @98596
      GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(98637), // Rule ID 944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 944,
        GIR_Done,
      // Label 2603: @98637
      GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(98678), // Rule ID 946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 946,
        GIR_Done,
      // Label 2604: @98678
      GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(98719), // Rule ID 948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 948,
        GIR_Done,
      // Label 2605: @98719
      GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(98760), // Rule ID 950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 950,
        GIR_Done,
      // Label 2606: @98760
      GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(98801), // Rule ID 952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 952,
        GIR_Done,
      // Label 2607: @98801
      GIM_Reject,
    // Label 2577: @98802
    GIM_Reject,
    // Label 2575: @98803
    GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(100452),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(98852), // Rule ID 405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 405,
        GIR_Done,
      // Label 2609: @98852
      GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(98893), // Rule ID 407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 407,
        GIR_Done,
      // Label 2610: @98893
      GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(98934), // Rule ID 409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 409,
        GIR_Done,
      // Label 2611: @98934
      GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(98975), // Rule ID 411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 411,
        GIR_Done,
      // Label 2612: @98975
      GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(99016), // Rule ID 413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 413,
        GIR_Done,
      // Label 2613: @99016
      GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(99057), // Rule ID 415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 415,
        GIR_Done,
      // Label 2614: @99057
      GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(99098), // Rule ID 417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 417,
        GIR_Done,
      // Label 2615: @99098
      GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(99139), // Rule ID 419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 419,
        GIR_Done,
      // Label 2616: @99139
      GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(99180), // Rule ID 421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 421,
        GIR_Done,
      // Label 2617: @99180
      GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(99221), // Rule ID 423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 423,
        GIR_Done,
      // Label 2618: @99221
      GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(99262), // Rule ID 545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 545,
        GIR_Done,
      // Label 2619: @99262
      GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(99303), // Rule ID 546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 546,
        GIR_Done,
      // Label 2620: @99303
      GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(99344), // Rule ID 547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 547,
        GIR_Done,
      // Label 2621: @99344
      GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(99385), // Rule ID 548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 548,
        GIR_Done,
      // Label 2622: @99385
      GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(99426), // Rule ID 549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 549,
        GIR_Done,
      // Label 2623: @99426
      GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(99467), // Rule ID 550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 550,
        GIR_Done,
      // Label 2624: @99467
      GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(99508), // Rule ID 551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 551,
        GIR_Done,
      // Label 2625: @99508
      GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(99549), // Rule ID 552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 552,
        GIR_Done,
      // Label 2626: @99549
      GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(99590), // Rule ID 553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 553,
        GIR_Done,
      // Label 2627: @99590
      GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(99631), // Rule ID 554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 554,
        GIR_Done,
      // Label 2628: @99631
      GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(99672), // Rule ID 753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 753,
        GIR_Done,
      // Label 2629: @99672
      GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(99713), // Rule ID 755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 755,
        GIR_Done,
      // Label 2630: @99713
      GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(99754), // Rule ID 757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 757,
        GIR_Done,
      // Label 2631: @99754
      GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(99795), // Rule ID 759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 759,
        GIR_Done,
      // Label 2632: @99795
      GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(99836), // Rule ID 761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 761,
        GIR_Done,
      // Label 2633: @99836
      GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(99877), // Rule ID 763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 763,
        GIR_Done,
      // Label 2634: @99877
      GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(99918), // Rule ID 765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 765,
        GIR_Done,
      // Label 2635: @99918
      GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(99959), // Rule ID 767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 767,
        GIR_Done,
      // Label 2636: @99959
      GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(100000), // Rule ID 769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 769,
        GIR_Done,
      // Label 2637: @100000
      GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(100041), // Rule ID 771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 771,
        GIR_Done,
      // Label 2638: @100041
      GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(100082), // Rule ID 933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 933,
        GIR_Done,
      // Label 2639: @100082
      GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(100123), // Rule ID 935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 935,
        GIR_Done,
      // Label 2640: @100123
      GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(100164), // Rule ID 937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 937,
        GIR_Done,
      // Label 2641: @100164
      GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(100205), // Rule ID 939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 939,
        GIR_Done,
      // Label 2642: @100205
      GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(100246), // Rule ID 941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 941,
        GIR_Done,
      // Label 2643: @100246
      GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(100287), // Rule ID 943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 943,
        GIR_Done,
      // Label 2644: @100287
      GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(100328), // Rule ID 945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 945,
        GIR_Done,
      // Label 2645: @100328
      GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(100369), // Rule ID 947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 947,
        GIR_Done,
      // Label 2646: @100369
      GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(100410), // Rule ID 949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 949,
        GIR_Done,
      // Label 2647: @100410
      GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(100451), // Rule ID 951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 951,
        GIR_Done,
      // Label 2648: @100451
      GIM_Reject,
    // Label 2608: @100452
    GIM_Reject,
    // Label 2576: @100453
    GIM_Reject,
    // Label 32: @100454
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2651*/ GIMT_Encode4(103363),
    /*GILLT_s32*//*Label 2649*/ GIMT_Encode4(100473),
    /*GILLT_s64*//*Label 2650*/ GIMT_Encode4(101713),
    // Label 2649: @100473
    GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(101712),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(100522), // Rule ID 426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 426,
        GIR_Done,
      // Label 2653: @100522
      GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(100563), // Rule ID 428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 428,
        GIR_Done,
      // Label 2654: @100563
      GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(100604), // Rule ID 430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 430,
        GIR_Done,
      // Label 2655: @100604
      GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(100645), // Rule ID 432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 432,
        GIR_Done,
      // Label 2656: @100645
      GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(100686), // Rule ID 434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 434,
        GIR_Done,
      // Label 2657: @100686
      GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(100727), // Rule ID 436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 436,
        GIR_Done,
      // Label 2658: @100727
      GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(100768), // Rule ID 438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 438,
        GIR_Done,
      // Label 2659: @100768
      GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(100809), // Rule ID 440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 440,
        GIR_Done,
      // Label 2660: @100809
      GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(100850), // Rule ID 442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 442,
        GIR_Done,
      // Label 2661: @100850
      GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(100891), // Rule ID 444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 444,
        GIR_Done,
      // Label 2662: @100891
      GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(100932), // Rule ID 774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 774,
        GIR_Done,
      // Label 2663: @100932
      GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(100973), // Rule ID 776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 776,
        GIR_Done,
      // Label 2664: @100973
      GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(101014), // Rule ID 778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 778,
        GIR_Done,
      // Label 2665: @101014
      GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(101055), // Rule ID 780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 780,
        GIR_Done,
      // Label 2666: @101055
      GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(101096), // Rule ID 782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 782,
        GIR_Done,
      // Label 2667: @101096
      GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(101137), // Rule ID 784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 784,
        GIR_Done,
      // Label 2668: @101137
      GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(101178), // Rule ID 786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 786,
        GIR_Done,
      // Label 2669: @101178
      GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(101219), // Rule ID 788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 788,
        GIR_Done,
      // Label 2670: @101219
      GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(101260), // Rule ID 790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 790,
        GIR_Done,
      // Label 2671: @101260
      GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(101301), // Rule ID 792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 792,
        GIR_Done,
      // Label 2672: @101301
      GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(101342), // Rule ID 954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 954,
        GIR_Done,
      // Label 2673: @101342
      GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(101383), // Rule ID 956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 956,
        GIR_Done,
      // Label 2674: @101383
      GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(101424), // Rule ID 958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 958,
        GIR_Done,
      // Label 2675: @101424
      GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(101465), // Rule ID 960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 960,
        GIR_Done,
      // Label 2676: @101465
      GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(101506), // Rule ID 962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 962,
        GIR_Done,
      // Label 2677: @101506
      GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(101547), // Rule ID 964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 964,
        GIR_Done,
      // Label 2678: @101547
      GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(101588), // Rule ID 966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 966,
        GIR_Done,
      // Label 2679: @101588
      GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(101629), // Rule ID 968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 968,
        GIR_Done,
      // Label 2680: @101629
      GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(101670), // Rule ID 970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 970,
        GIR_Done,
      // Label 2681: @101670
      GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(101711), // Rule ID 972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 972,
        GIR_Done,
      // Label 2682: @101711
      GIM_Reject,
    // Label 2652: @101712
    GIM_Reject,
    // Label 2650: @101713
    GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(103362),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(101762), // Rule ID 425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 425,
        GIR_Done,
      // Label 2684: @101762
      GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(101803), // Rule ID 427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 427,
        GIR_Done,
      // Label 2685: @101803
      GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(101844), // Rule ID 429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 429,
        GIR_Done,
      // Label 2686: @101844
      GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(101885), // Rule ID 431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 431,
        GIR_Done,
      // Label 2687: @101885
      GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(101926), // Rule ID 433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 433,
        GIR_Done,
      // Label 2688: @101926
      GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(101967), // Rule ID 435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 435,
        GIR_Done,
      // Label 2689: @101967
      GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(102008), // Rule ID 437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 437,
        GIR_Done,
      // Label 2690: @102008
      GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(102049), // Rule ID 439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 439,
        GIR_Done,
      // Label 2691: @102049
      GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(102090), // Rule ID 441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 441,
        GIR_Done,
      // Label 2692: @102090
      GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(102131), // Rule ID 443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 443,
        GIR_Done,
      // Label 2693: @102131
      GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(102172), // Rule ID 555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 555,
        GIR_Done,
      // Label 2694: @102172
      GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(102213), // Rule ID 556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 556,
        GIR_Done,
      // Label 2695: @102213
      GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(102254), // Rule ID 557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 557,
        GIR_Done,
      // Label 2696: @102254
      GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(102295), // Rule ID 558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 558,
        GIR_Done,
      // Label 2697: @102295
      GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(102336), // Rule ID 559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 559,
        GIR_Done,
      // Label 2698: @102336
      GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(102377), // Rule ID 560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 560,
        GIR_Done,
      // Label 2699: @102377
      GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(102418), // Rule ID 561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 561,
        GIR_Done,
      // Label 2700: @102418
      GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(102459), // Rule ID 562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 562,
        GIR_Done,
      // Label 2701: @102459
      GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(102500), // Rule ID 563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 563,
        GIR_Done,
      // Label 2702: @102500
      GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(102541), // Rule ID 564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 564,
        GIR_Done,
      // Label 2703: @102541
      GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(102582), // Rule ID 773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 773,
        GIR_Done,
      // Label 2704: @102582
      GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(102623), // Rule ID 775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 775,
        GIR_Done,
      // Label 2705: @102623
      GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(102664), // Rule ID 777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 777,
        GIR_Done,
      // Label 2706: @102664
      GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(102705), // Rule ID 779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 779,
        GIR_Done,
      // Label 2707: @102705
      GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(102746), // Rule ID 781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 781,
        GIR_Done,
      // Label 2708: @102746
      GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(102787), // Rule ID 783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 783,
        GIR_Done,
      // Label 2709: @102787
      GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(102828), // Rule ID 785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 785,
        GIR_Done,
      // Label 2710: @102828
      GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(102869), // Rule ID 787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 787,
        GIR_Done,
      // Label 2711: @102869
      GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(102910), // Rule ID 789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 789,
        GIR_Done,
      // Label 2712: @102910
      GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(102951), // Rule ID 791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 791,
        GIR_Done,
      // Label 2713: @102951
      GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(102992), // Rule ID 953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 953,
        GIR_Done,
      // Label 2714: @102992
      GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(103033), // Rule ID 955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 955,
        GIR_Done,
      // Label 2715: @103033
      GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(103074), // Rule ID 957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 957,
        GIR_Done,
      // Label 2716: @103074
      GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(103115), // Rule ID 959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 959,
        GIR_Done,
      // Label 2717: @103115
      GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(103156), // Rule ID 961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 961,
        GIR_Done,
      // Label 2718: @103156
      GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(103197), // Rule ID 963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 963,
        GIR_Done,
      // Label 2719: @103197
      GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(103238), // Rule ID 965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 965,
        GIR_Done,
      // Label 2720: @103238
      GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(103279), // Rule ID 967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 967,
        GIR_Done,
      // Label 2721: @103279
      GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(103320), // Rule ID 969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 969,
        GIR_Done,
      // Label 2722: @103320
      GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(103361), // Rule ID 971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 971,
        GIR_Done,
      // Label 2723: @103361
      GIM_Reject,
    // Label 2683: @103362
    GIM_Reject,
    // Label 2651: @103363
    GIM_Reject,
    // Label 33: @103364
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2726*/ GIMT_Encode4(106273),
    /*GILLT_s32*//*Label 2724*/ GIMT_Encode4(103383),
    /*GILLT_s64*//*Label 2725*/ GIMT_Encode4(104623),
    // Label 2724: @103383
    GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(104622),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(103432), // Rule ID 446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 446,
        GIR_Done,
      // Label 2728: @103432
      GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(103473), // Rule ID 448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 448,
        GIR_Done,
      // Label 2729: @103473
      GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(103514), // Rule ID 450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 450,
        GIR_Done,
      // Label 2730: @103514
      GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(103555), // Rule ID 452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 452,
        GIR_Done,
      // Label 2731: @103555
      GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(103596), // Rule ID 454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 454,
        GIR_Done,
      // Label 2732: @103596
      GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(103637), // Rule ID 456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 456,
        GIR_Done,
      // Label 2733: @103637
      GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(103678), // Rule ID 458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 458,
        GIR_Done,
      // Label 2734: @103678
      GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(103719), // Rule ID 460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 460,
        GIR_Done,
      // Label 2735: @103719
      GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(103760), // Rule ID 462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 462,
        GIR_Done,
      // Label 2736: @103760
      GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(103801), // Rule ID 464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 464,
        GIR_Done,
      // Label 2737: @103801
      GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(103842), // Rule ID 794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 794,
        GIR_Done,
      // Label 2738: @103842
      GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(103883), // Rule ID 796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 796,
        GIR_Done,
      // Label 2739: @103883
      GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(103924), // Rule ID 798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 798,
        GIR_Done,
      // Label 2740: @103924
      GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(103965), // Rule ID 800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 800,
        GIR_Done,
      // Label 2741: @103965
      GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(104006), // Rule ID 802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 802,
        GIR_Done,
      // Label 2742: @104006
      GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(104047), // Rule ID 804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 804,
        GIR_Done,
      // Label 2743: @104047
      GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(104088), // Rule ID 806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 806,
        GIR_Done,
      // Label 2744: @104088
      GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(104129), // Rule ID 808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 808,
        GIR_Done,
      // Label 2745: @104129
      GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(104170), // Rule ID 810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 810,
        GIR_Done,
      // Label 2746: @104170
      GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(104211), // Rule ID 812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 812,
        GIR_Done,
      // Label 2747: @104211
      GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(104252), // Rule ID 974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 974,
        GIR_Done,
      // Label 2748: @104252
      GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(104293), // Rule ID 976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 976,
        GIR_Done,
      // Label 2749: @104293
      GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(104334), // Rule ID 978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 978,
        GIR_Done,
      // Label 2750: @104334
      GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(104375), // Rule ID 980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 980,
        GIR_Done,
      // Label 2751: @104375
      GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(104416), // Rule ID 982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 982,
        GIR_Done,
      // Label 2752: @104416
      GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(104457), // Rule ID 984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 984,
        GIR_Done,
      // Label 2753: @104457
      GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(104498), // Rule ID 986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 986,
        GIR_Done,
      // Label 2754: @104498
      GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(104539), // Rule ID 988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 988,
        GIR_Done,
      // Label 2755: @104539
      GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(104580), // Rule ID 990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 990,
        GIR_Done,
      // Label 2756: @104580
      GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(104621), // Rule ID 992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 992,
        GIR_Done,
      // Label 2757: @104621
      GIM_Reject,
    // Label 2727: @104622
    GIM_Reject,
    // Label 2725: @104623
    GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(106272),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(104672), // Rule ID 445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 445,
        GIR_Done,
      // Label 2759: @104672
      GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(104713), // Rule ID 447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 447,
        GIR_Done,
      // Label 2760: @104713
      GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(104754), // Rule ID 449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 449,
        GIR_Done,
      // Label 2761: @104754
      GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(104795), // Rule ID 451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 451,
        GIR_Done,
      // Label 2762: @104795
      GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(104836), // Rule ID 453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 453,
        GIR_Done,
      // Label 2763: @104836
      GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(104877), // Rule ID 455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 455,
        GIR_Done,
      // Label 2764: @104877
      GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(104918), // Rule ID 457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 457,
        GIR_Done,
      // Label 2765: @104918
      GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(104959), // Rule ID 459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 459,
        GIR_Done,
      // Label 2766: @104959
      GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(105000), // Rule ID 461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 461,
        GIR_Done,
      // Label 2767: @105000
      GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(105041), // Rule ID 463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 463,
        GIR_Done,
      // Label 2768: @105041
      GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(105082), // Rule ID 565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 565,
        GIR_Done,
      // Label 2769: @105082
      GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(105123), // Rule ID 566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 566,
        GIR_Done,
      // Label 2770: @105123
      GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(105164), // Rule ID 567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 567,
        GIR_Done,
      // Label 2771: @105164
      GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(105205), // Rule ID 568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 568,
        GIR_Done,
      // Label 2772: @105205
      GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(105246), // Rule ID 569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 569,
        GIR_Done,
      // Label 2773: @105246
      GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(105287), // Rule ID 570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 570,
        GIR_Done,
      // Label 2774: @105287
      GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(105328), // Rule ID 571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 571,
        GIR_Done,
      // Label 2775: @105328
      GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(105369), // Rule ID 572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 572,
        GIR_Done,
      // Label 2776: @105369
      GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(105410), // Rule ID 573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 573,
        GIR_Done,
      // Label 2777: @105410
      GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(105451), // Rule ID 574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 574,
        GIR_Done,
      // Label 2778: @105451
      GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(105492), // Rule ID 793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 793,
        GIR_Done,
      // Label 2779: @105492
      GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(105533), // Rule ID 795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 795,
        GIR_Done,
      // Label 2780: @105533
      GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(105574), // Rule ID 797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 797,
        GIR_Done,
      // Label 2781: @105574
      GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(105615), // Rule ID 799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 799,
        GIR_Done,
      // Label 2782: @105615
      GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(105656), // Rule ID 801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 801,
        GIR_Done,
      // Label 2783: @105656
      GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(105697), // Rule ID 803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 803,
        GIR_Done,
      // Label 2784: @105697
      GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(105738), // Rule ID 805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 805,
        GIR_Done,
      // Label 2785: @105738
      GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(105779), // Rule ID 807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 807,
        GIR_Done,
      // Label 2786: @105779
      GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(105820), // Rule ID 809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 809,
        GIR_Done,
      // Label 2787: @105820
      GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(105861), // Rule ID 811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 811,
        GIR_Done,
      // Label 2788: @105861
      GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(105902), // Rule ID 973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 973,
        GIR_Done,
      // Label 2789: @105902
      GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(105943), // Rule ID 975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 975,
        GIR_Done,
      // Label 2790: @105943
      GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(105984), // Rule ID 977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 977,
        GIR_Done,
      // Label 2791: @105984
      GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(106025), // Rule ID 979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 979,
        GIR_Done,
      // Label 2792: @106025
      GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(106066), // Rule ID 981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 981,
        GIR_Done,
      // Label 2793: @106066
      GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(106107), // Rule ID 983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 983,
        GIR_Done,
      // Label 2794: @106107
      GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(106148), // Rule ID 985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 985,
        GIR_Done,
      // Label 2795: @106148
      GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(106189), // Rule ID 987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 987,
        GIR_Done,
      // Label 2796: @106189
      GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(106230), // Rule ID 989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 989,
        GIR_Done,
      // Label 2797: @106230
      GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(106271), // Rule ID 991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 991,
        GIR_Done,
      // Label 2798: @106271
      GIM_Reject,
    // Label 2758: @106272
    GIM_Reject,
    // Label 2726: @106273
    GIM_Reject,
    // Label 34: @106274
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2801*/ GIMT_Encode4(109183),
    /*GILLT_s32*//*Label 2799*/ GIMT_Encode4(106293),
    /*GILLT_s64*//*Label 2800*/ GIMT_Encode4(107533),
    // Label 2799: @106293
    GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(107532),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(106342), // Rule ID 466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 466,
        GIR_Done,
      // Label 2803: @106342
      GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(106383), // Rule ID 468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 468,
        GIR_Done,
      // Label 2804: @106383
      GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(106424), // Rule ID 470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 470,
        GIR_Done,
      // Label 2805: @106424
      GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(106465), // Rule ID 472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 472,
        GIR_Done,
      // Label 2806: @106465
      GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(106506), // Rule ID 474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 474,
        GIR_Done,
      // Label 2807: @106506
      GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(106547), // Rule ID 476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 476,
        GIR_Done,
      // Label 2808: @106547
      GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(106588), // Rule ID 478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 478,
        GIR_Done,
      // Label 2809: @106588
      GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(106629), // Rule ID 480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 480,
        GIR_Done,
      // Label 2810: @106629
      GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(106670), // Rule ID 482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 482,
        GIR_Done,
      // Label 2811: @106670
      GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(106711), // Rule ID 484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 484,
        GIR_Done,
      // Label 2812: @106711
      GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(106752), // Rule ID 814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 814,
        GIR_Done,
      // Label 2813: @106752
      GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(106793), // Rule ID 816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 816,
        GIR_Done,
      // Label 2814: @106793
      GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(106834), // Rule ID 818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 818,
        GIR_Done,
      // Label 2815: @106834
      GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(106875), // Rule ID 820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 820,
        GIR_Done,
      // Label 2816: @106875
      GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(106916), // Rule ID 822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 822,
        GIR_Done,
      // Label 2817: @106916
      GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(106957), // Rule ID 824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 824,
        GIR_Done,
      // Label 2818: @106957
      GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(106998), // Rule ID 826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 826,
        GIR_Done,
      // Label 2819: @106998
      GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(107039), // Rule ID 828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 828,
        GIR_Done,
      // Label 2820: @107039
      GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(107080), // Rule ID 830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 830,
        GIR_Done,
      // Label 2821: @107080
      GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(107121), // Rule ID 832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 832,
        GIR_Done,
      // Label 2822: @107121
      GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(107162), // Rule ID 994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 994,
        GIR_Done,
      // Label 2823: @107162
      GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(107203), // Rule ID 996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 996,
        GIR_Done,
      // Label 2824: @107203
      GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(107244), // Rule ID 998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 998,
        GIR_Done,
      // Label 2825: @107244
      GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(107285), // Rule ID 1000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1000,
        GIR_Done,
      // Label 2826: @107285
      GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(107326), // Rule ID 1002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1002,
        GIR_Done,
      // Label 2827: @107326
      GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(107367), // Rule ID 1004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1004,
        GIR_Done,
      // Label 2828: @107367
      GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(107408), // Rule ID 1006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1006,
        GIR_Done,
      // Label 2829: @107408
      GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(107449), // Rule ID 1008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1008,
        GIR_Done,
      // Label 2830: @107449
      GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(107490), // Rule ID 1010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1010,
        GIR_Done,
      // Label 2831: @107490
      GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(107531), // Rule ID 1012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1012,
        GIR_Done,
      // Label 2832: @107531
      GIM_Reject,
    // Label 2802: @107532
    GIM_Reject,
    // Label 2800: @107533
    GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(109182),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(107582), // Rule ID 465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 465,
        GIR_Done,
      // Label 2834: @107582
      GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(107623), // Rule ID 467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 467,
        GIR_Done,
      // Label 2835: @107623
      GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(107664), // Rule ID 469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 469,
        GIR_Done,
      // Label 2836: @107664
      GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(107705), // Rule ID 471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 471,
        GIR_Done,
      // Label 2837: @107705
      GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(107746), // Rule ID 473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 473,
        GIR_Done,
      // Label 2838: @107746
      GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(107787), // Rule ID 475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 475,
        GIR_Done,
      // Label 2839: @107787
      GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(107828), // Rule ID 477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 477,
        GIR_Done,
      // Label 2840: @107828
      GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(107869), // Rule ID 479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 479,
        GIR_Done,
      // Label 2841: @107869
      GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(107910), // Rule ID 481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 481,
        GIR_Done,
      // Label 2842: @107910
      GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(107951), // Rule ID 483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 483,
        GIR_Done,
      // Label 2843: @107951
      GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(107992), // Rule ID 575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 575,
        GIR_Done,
      // Label 2844: @107992
      GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(108033), // Rule ID 576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 576,
        GIR_Done,
      // Label 2845: @108033
      GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(108074), // Rule ID 577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 577,
        GIR_Done,
      // Label 2846: @108074
      GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(108115), // Rule ID 578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 578,
        GIR_Done,
      // Label 2847: @108115
      GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(108156), // Rule ID 579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 579,
        GIR_Done,
      // Label 2848: @108156
      GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(108197), // Rule ID 580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 580,
        GIR_Done,
      // Label 2849: @108197
      GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(108238), // Rule ID 581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 581,
        GIR_Done,
      // Label 2850: @108238
      GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(108279), // Rule ID 582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 582,
        GIR_Done,
      // Label 2851: @108279
      GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(108320), // Rule ID 583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 583,
        GIR_Done,
      // Label 2852: @108320
      GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(108361), // Rule ID 584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 584,
        GIR_Done,
      // Label 2853: @108361
      GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(108402), // Rule ID 813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 813,
        GIR_Done,
      // Label 2854: @108402
      GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(108443), // Rule ID 815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 815,
        GIR_Done,
      // Label 2855: @108443
      GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(108484), // Rule ID 817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 817,
        GIR_Done,
      // Label 2856: @108484
      GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(108525), // Rule ID 819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 819,
        GIR_Done,
      // Label 2857: @108525
      GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(108566), // Rule ID 821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 821,
        GIR_Done,
      // Label 2858: @108566
      GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(108607), // Rule ID 823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 823,
        GIR_Done,
      // Label 2859: @108607
      GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(108648), // Rule ID 825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 825,
        GIR_Done,
      // Label 2860: @108648
      GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(108689), // Rule ID 827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 827,
        GIR_Done,
      // Label 2861: @108689
      GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(108730), // Rule ID 829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 829,
        GIR_Done,
      // Label 2862: @108730
      GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(108771), // Rule ID 831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 831,
        GIR_Done,
      // Label 2863: @108771
      GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(108812), // Rule ID 993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 993,
        GIR_Done,
      // Label 2864: @108812
      GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(108853), // Rule ID 995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 995,
        GIR_Done,
      // Label 2865: @108853
      GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(108894), // Rule ID 997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 997,
        GIR_Done,
      // Label 2866: @108894
      GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(108935), // Rule ID 999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 999,
        GIR_Done,
      // Label 2867: @108935
      GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(108976), // Rule ID 1001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1001,
        GIR_Done,
      // Label 2868: @108976
      GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(109017), // Rule ID 1003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1003,
        GIR_Done,
      // Label 2869: @109017
      GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(109058), // Rule ID 1005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1005,
        GIR_Done,
      // Label 2870: @109058
      GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(109099), // Rule ID 1007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1007,
        GIR_Done,
      // Label 2871: @109099
      GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(109140), // Rule ID 1009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1009,
        GIR_Done,
      // Label 2872: @109140
      GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(109181), // Rule ID 1011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1011,
        GIR_Done,
      // Label 2873: @109181
      GIM_Reject,
    // Label 2833: @109182
    GIM_Reject,
    // Label 2801: @109183
    GIM_Reject,
    // Label 35: @109184
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2876*/ GIMT_Encode4(112093),
    /*GILLT_s32*//*Label 2874*/ GIMT_Encode4(109203),
    /*GILLT_s64*//*Label 2875*/ GIMT_Encode4(110443),
    // Label 2874: @109203
    GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(110442),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(109252), // Rule ID 486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 486,
        GIR_Done,
      // Label 2878: @109252
      GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(109293), // Rule ID 488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 488,
        GIR_Done,
      // Label 2879: @109293
      GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(109334), // Rule ID 490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 490,
        GIR_Done,
      // Label 2880: @109334
      GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(109375), // Rule ID 492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 492,
        GIR_Done,
      // Label 2881: @109375
      GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(109416), // Rule ID 494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 494,
        GIR_Done,
      // Label 2882: @109416
      GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(109457), // Rule ID 496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 496,
        GIR_Done,
      // Label 2883: @109457
      GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(109498), // Rule ID 498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 498,
        GIR_Done,
      // Label 2884: @109498
      GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(109539), // Rule ID 500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 500,
        GIR_Done,
      // Label 2885: @109539
      GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(109580), // Rule ID 502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 502,
        GIR_Done,
      // Label 2886: @109580
      GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(109621), // Rule ID 504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 504,
        GIR_Done,
      // Label 2887: @109621
      GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(109662), // Rule ID 834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 834,
        GIR_Done,
      // Label 2888: @109662
      GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(109703), // Rule ID 836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 836,
        GIR_Done,
      // Label 2889: @109703
      GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(109744), // Rule ID 838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 838,
        GIR_Done,
      // Label 2890: @109744
      GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(109785), // Rule ID 840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 840,
        GIR_Done,
      // Label 2891: @109785
      GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(109826), // Rule ID 842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 842,
        GIR_Done,
      // Label 2892: @109826
      GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(109867), // Rule ID 844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 844,
        GIR_Done,
      // Label 2893: @109867
      GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(109908), // Rule ID 846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 846,
        GIR_Done,
      // Label 2894: @109908
      GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(109949), // Rule ID 848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 848,
        GIR_Done,
      // Label 2895: @109949
      GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(109990), // Rule ID 850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 850,
        GIR_Done,
      // Label 2896: @109990
      GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(110031), // Rule ID 852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 852,
        GIR_Done,
      // Label 2897: @110031
      GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(110072), // Rule ID 1014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1014,
        GIR_Done,
      // Label 2898: @110072
      GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(110113), // Rule ID 1016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1016,
        GIR_Done,
      // Label 2899: @110113
      GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(110154), // Rule ID 1018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1018,
        GIR_Done,
      // Label 2900: @110154
      GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(110195), // Rule ID 1020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1020,
        GIR_Done,
      // Label 2901: @110195
      GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(110236), // Rule ID 1022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1022,
        GIR_Done,
      // Label 2902: @110236
      GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(110277), // Rule ID 1024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1024,
        GIR_Done,
      // Label 2903: @110277
      GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(110318), // Rule ID 1026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1026,
        GIR_Done,
      // Label 2904: @110318
      GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(110359), // Rule ID 1028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1028,
        GIR_Done,
      // Label 2905: @110359
      GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(110400), // Rule ID 1030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1030,
        GIR_Done,
      // Label 2906: @110400
      GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(110441), // Rule ID 1032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1032,
        GIR_Done,
      // Label 2907: @110441
      GIM_Reject,
    // Label 2877: @110442
    GIM_Reject,
    // Label 2875: @110443
    GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(112092),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(110492), // Rule ID 485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 485,
        GIR_Done,
      // Label 2909: @110492
      GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(110533), // Rule ID 487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 487,
        GIR_Done,
      // Label 2910: @110533
      GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(110574), // Rule ID 489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 489,
        GIR_Done,
      // Label 2911: @110574
      GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(110615), // Rule ID 491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 491,
        GIR_Done,
      // Label 2912: @110615
      GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(110656), // Rule ID 493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 493,
        GIR_Done,
      // Label 2913: @110656
      GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(110697), // Rule ID 495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 495,
        GIR_Done,
      // Label 2914: @110697
      GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(110738), // Rule ID 497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 497,
        GIR_Done,
      // Label 2915: @110738
      GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(110779), // Rule ID 499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 499,
        GIR_Done,
      // Label 2916: @110779
      GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(110820), // Rule ID 501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 501,
        GIR_Done,
      // Label 2917: @110820
      GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(110861), // Rule ID 503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 503,
        GIR_Done,
      // Label 2918: @110861
      GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(110902), // Rule ID 585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 585,
        GIR_Done,
      // Label 2919: @110902
      GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(110943), // Rule ID 586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 586,
        GIR_Done,
      // Label 2920: @110943
      GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(110984), // Rule ID 587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 587,
        GIR_Done,
      // Label 2921: @110984
      GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(111025), // Rule ID 588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 588,
        GIR_Done,
      // Label 2922: @111025
      GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(111066), // Rule ID 589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 589,
        GIR_Done,
      // Label 2923: @111066
      GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(111107), // Rule ID 590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 590,
        GIR_Done,
      // Label 2924: @111107
      GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(111148), // Rule ID 591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 591,
        GIR_Done,
      // Label 2925: @111148
      GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(111189), // Rule ID 592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 592,
        GIR_Done,
      // Label 2926: @111189
      GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(111230), // Rule ID 593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 593,
        GIR_Done,
      // Label 2927: @111230
      GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(111271), // Rule ID 594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 594,
        GIR_Done,
      // Label 2928: @111271
      GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(111312), // Rule ID 833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 833,
        GIR_Done,
      // Label 2929: @111312
      GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(111353), // Rule ID 835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 835,
        GIR_Done,
      // Label 2930: @111353
      GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(111394), // Rule ID 837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 837,
        GIR_Done,
      // Label 2931: @111394
      GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(111435), // Rule ID 839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 839,
        GIR_Done,
      // Label 2932: @111435
      GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(111476), // Rule ID 841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 841,
        GIR_Done,
      // Label 2933: @111476
      GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(111517), // Rule ID 843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 843,
        GIR_Done,
      // Label 2934: @111517
      GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(111558), // Rule ID 845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 845,
        GIR_Done,
      // Label 2935: @111558
      GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(111599), // Rule ID 847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 847,
        GIR_Done,
      // Label 2936: @111599
      GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(111640), // Rule ID 849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 849,
        GIR_Done,
      // Label 2937: @111640
      GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(111681), // Rule ID 851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 851,
        GIR_Done,
      // Label 2938: @111681
      GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(111722), // Rule ID 1013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1013,
        GIR_Done,
      // Label 2939: @111722
      GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(111763), // Rule ID 1015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1015,
        GIR_Done,
      // Label 2940: @111763
      GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(111804), // Rule ID 1017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1017,
        GIR_Done,
      // Label 2941: @111804
      GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(111845), // Rule ID 1019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1019,
        GIR_Done,
      // Label 2942: @111845
      GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(111886), // Rule ID 1021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1021,
        GIR_Done,
      // Label 2943: @111886
      GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(111927), // Rule ID 1023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1023,
        GIR_Done,
      // Label 2944: @111927
      GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(111968), // Rule ID 1025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1025,
        GIR_Done,
      // Label 2945: @111968
      GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(112009), // Rule ID 1027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1027,
        GIR_Done,
      // Label 2946: @112009
      GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(112050), // Rule ID 1029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1029,
        GIR_Done,
      // Label 2947: @112050
      GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(112091), // Rule ID 1031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rs1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1031,
        GIR_Done,
      // Label 2948: @112091
      GIM_Reject,
    // Label 2908: @112092
    GIM_Reject,
    // Label 2876: @112093
    GIM_Reject,
    // Label 36: @112094
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2951*/ GIMT_Encode4(112311),
    /*GILLT_s32*//*Label 2949*/ GIMT_Encode4(112113),
    /*GILLT_s64*//*Label 2950*/ GIMT_Encode4(112212),
    // Label 2949: @112113
    GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(112139), // Rule ID 245 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 245,
      GIR_EraseRootFromParent_Done,
    // Label 2952: @112139
    GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(112165), // Rule ID 247 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 247,
      GIR_EraseRootFromParent_Done,
    // Label 2953: @112165
    GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(112185), // Rule ID 249 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 249,
      GIR_EraseRootFromParent_Done,
    // Label 2954: @112185
    GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(112211), // Rule ID 251 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 251,
      GIR_EraseRootFromParent_Done,
    // Label 2955: @112211
    GIM_Reject,
    // Label 2950: @112212
    GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(112238), // Rule ID 244 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 244,
      GIR_EraseRootFromParent_Done,
    // Label 2956: @112238
    GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(112264), // Rule ID 246 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 246,
      GIR_EraseRootFromParent_Done,
    // Label 2957: @112264
    GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(112284), // Rule ID 248 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 248,
      GIR_EraseRootFromParent_Done,
    // Label 2958: @112284
    GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(112310), // Rule ID 250 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 250,
      GIR_EraseRootFromParent_Done,
    // Label 2959: @112310
    GIM_Reject,
    // Label 2951: @112311
    GIM_Reject,
    // Label 37: @112312
    GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(113797),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(112365), // Rule ID 2572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2572,
        GIR_EraseRootFromParent_Done,
      // Label 2961: @112365
      GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(112410), // Rule ID 2573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2573,
        GIR_EraseRootFromParent_Done,
      // Label 2962: @112410
      GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(112455), // Rule ID 23114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23114,
        GIR_EraseRootFromParent_Done,
      // Label 2963: @112455
      GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(112500), // Rule ID 23115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23115,
        GIR_EraseRootFromParent_Done,
      // Label 2964: @112500
      GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(112545), // Rule ID 23116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23116,
        GIR_EraseRootFromParent_Done,
      // Label 2965: @112545
      GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(112590), // Rule ID 23117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23117,
        GIR_EraseRootFromParent_Done,
      // Label 2966: @112590
      GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(112635), // Rule ID 23118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23118,
        GIR_EraseRootFromParent_Done,
      // Label 2967: @112635
      GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(112680), // Rule ID 23119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23119,
        GIR_EraseRootFromParent_Done,
      // Label 2968: @112680
      GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(112725), // Rule ID 23120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23120,
        GIR_EraseRootFromParent_Done,
      // Label 2969: @112725
      GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(112770), // Rule ID 23121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23121,
        GIR_EraseRootFromParent_Done,
      // Label 2970: @112770
      GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(112815), // Rule ID 23122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23122,
        GIR_EraseRootFromParent_Done,
      // Label 2971: @112815
      GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(112860), // Rule ID 23123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23123,
        GIR_EraseRootFromParent_Done,
      // Label 2972: @112860
      GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(112905), // Rule ID 23124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23124,
        GIR_EraseRootFromParent_Done,
      // Label 2973: @112905
      GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(112950), // Rule ID 23125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11025:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23125,
        GIR_EraseRootFromParent_Done,
      // Label 2974: @112950
      GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(112995), // Rule ID 23126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23126,
        GIR_EraseRootFromParent_Done,
      // Label 2975: @112995
      GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(113040), // Rule ID 23127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23127,
        GIR_EraseRootFromParent_Done,
      // Label 2976: @113040
      GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(113085), // Rule ID 23128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23128,
        GIR_EraseRootFromParent_Done,
      // Label 2977: @113085
      GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(113130), // Rule ID 23129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23129,
        GIR_EraseRootFromParent_Done,
      // Label 2978: @113130
      GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(113175), // Rule ID 23130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23130,
        GIR_EraseRootFromParent_Done,
      // Label 2979: @113175
      GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(113220), // Rule ID 23131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23131,
        GIR_EraseRootFromParent_Done,
      // Label 2980: @113220
      GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(113265), // Rule ID 23132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23132,
        GIR_EraseRootFromParent_Done,
      // Label 2981: @113265
      GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(113310), // Rule ID 23133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23133,
        GIR_EraseRootFromParent_Done,
      // Label 2982: @113310
      GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(113355), // Rule ID 23134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23134,
        GIR_EraseRootFromParent_Done,
      // Label 2983: @113355
      GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(113400), // Rule ID 23135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23135,
        GIR_EraseRootFromParent_Done,
      // Label 2984: @113400
      GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(113445), // Rule ID 23136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23136,
        GIR_EraseRootFromParent_Done,
      // Label 2985: @113445
      GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(113490), // Rule ID 23137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23137,
        GIR_EraseRootFromParent_Done,
      // Label 2986: @113490
      GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(113535), // Rule ID 23138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23138,
        GIR_EraseRootFromParent_Done,
      // Label 2987: @113535
      GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(113580), // Rule ID 23139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11053:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23139,
        GIR_EraseRootFromParent_Done,
      // Label 2988: @113580
      GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(113616), // Rule ID 2509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10584:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2509,
        GIR_EraseRootFromParent_Done,
      // Label 2989: @113616
      GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(113652), // Rule ID 2530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10720:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2530,
        GIR_EraseRootFromParent_Done,
      // Label 2990: @113652
      GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(113688), // Rule ID 2531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10723:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2531,
        GIR_EraseRootFromParent_Done,
      // Label 2991: @113688
      GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(113724), // Rule ID 2532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10726:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2532,
        GIR_EraseRootFromParent_Done,
      // Label 2992: @113724
      GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(113760), // Rule ID 2533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10728:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2533,
        GIR_EraseRootFromParent_Done,
      // Label 2993: @113760
      GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(113796), // Rule ID 63855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10604:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63855,
        GIR_EraseRootFromParent_Done,
      // Label 2994: @113796
      GIM_Reject,
    // Label 2960: @113797
    GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(121085),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(113859), // Rule ID 2542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10782:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2542,
        GIR_EraseRootFromParent_Done,
      // Label 2996: @113859
      GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(113913), // Rule ID 2543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10782:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2543,
        GIR_EraseRootFromParent_Done,
      // Label 2997: @113913
      GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(113967), // Rule ID 2548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2548,
        GIR_EraseRootFromParent_Done,
      // Label 2998: @113967
      GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(114021), // Rule ID 2549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2549,
        GIR_EraseRootFromParent_Done,
      // Label 2999: @114021
      GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(114078), // Rule ID 2568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2568,
        GIR_EraseRootFromParent_Done,
      // Label 3000: @114078
      GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(114135), // Rule ID 2569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2569,
        GIR_EraseRootFromParent_Done,
      // Label 3001: @114135
      GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(114189), // Rule ID 23140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10782:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23140,
        GIR_EraseRootFromParent_Done,
      // Label 3002: @114189
      GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(114243), // Rule ID 23141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10782:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23141,
        GIR_EraseRootFromParent_Done,
      // Label 3003: @114243
      GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(114297), // Rule ID 23144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10782:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23144,
        GIR_EraseRootFromParent_Done,
      // Label 3004: @114297
      GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(114351), // Rule ID 23145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10782:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23145,
        GIR_EraseRootFromParent_Done,
      // Label 3005: @114351
      GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(114405), // Rule ID 23148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10782:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23148,
        GIR_EraseRootFromParent_Done,
      // Label 3006: @114405
      GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(114459), // Rule ID 23149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10782:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23149,
        GIR_EraseRootFromParent_Done,
      // Label 3007: @114459
      GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(114513), // Rule ID 23152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10782:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23152,
        GIR_EraseRootFromParent_Done,
      // Label 3008: @114513
      GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(114567), // Rule ID 23153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10782:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23153,
        GIR_EraseRootFromParent_Done,
      // Label 3009: @114567
      GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(114621), // Rule ID 23156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10782:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23156,
        GIR_EraseRootFromParent_Done,
      // Label 3010: @114621
      GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(114675), // Rule ID 23157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10782:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23157,
        GIR_EraseRootFromParent_Done,
      // Label 3011: @114675
      GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(114729), // Rule ID 23160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10782:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23160,
        GIR_EraseRootFromParent_Done,
      // Label 3012: @114729
      GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(114783), // Rule ID 23161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10782:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23161,
        GIR_EraseRootFromParent_Done,
      // Label 3013: @114783
      GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(114837), // Rule ID 23164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10810:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23164,
        GIR_EraseRootFromParent_Done,
      // Label 3014: @114837
      GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(114891), // Rule ID 23165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10810:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23165,
        GIR_EraseRootFromParent_Done,
      // Label 3015: @114891
      GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(114945), // Rule ID 23168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10810:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23168,
        GIR_EraseRootFromParent_Done,
      // Label 3016: @114945
      GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(114999), // Rule ID 23169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10810:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23169,
        GIR_EraseRootFromParent_Done,
      // Label 3017: @114999
      GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(115053), // Rule ID 23172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10810:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23172,
        GIR_EraseRootFromParent_Done,
      // Label 3018: @115053
      GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(115107), // Rule ID 23173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10810:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23173,
        GIR_EraseRootFromParent_Done,
      // Label 3019: @115107
      GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(115161), // Rule ID 23176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10810:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23176,
        GIR_EraseRootFromParent_Done,
      // Label 3020: @115161
      GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(115215), // Rule ID 23177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10810:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23177,
        GIR_EraseRootFromParent_Done,
      // Label 3021: @115215
      GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(115269), // Rule ID 23180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10810:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23180,
        GIR_EraseRootFromParent_Done,
      // Label 3022: @115269
      GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(115323), // Rule ID 23181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10810:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23181,
        GIR_EraseRootFromParent_Done,
      // Label 3023: @115323
      GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(115377), // Rule ID 23184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10810:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23184,
        GIR_EraseRootFromParent_Done,
      // Label 3024: @115377
      GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(115431), // Rule ID 23185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10810:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23185,
        GIR_EraseRootFromParent_Done,
      // Label 3025: @115431
      GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(115485), // Rule ID 23188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10810:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23188,
        GIR_EraseRootFromParent_Done,
      // Label 3026: @115485
      GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(115539), // Rule ID 23189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10810:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23189,
        GIR_EraseRootFromParent_Done,
      // Label 3027: @115539
      GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(115593), // Rule ID 23192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23192,
        GIR_EraseRootFromParent_Done,
      // Label 3028: @115593
      GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(115647), // Rule ID 23193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23193,
        GIR_EraseRootFromParent_Done,
      // Label 3029: @115647
      GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(115701), // Rule ID 23196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23196,
        GIR_EraseRootFromParent_Done,
      // Label 3030: @115701
      GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(115755), // Rule ID 23197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23197,
        GIR_EraseRootFromParent_Done,
      // Label 3031: @115755
      GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(115809), // Rule ID 23200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23200,
        GIR_EraseRootFromParent_Done,
      // Label 3032: @115809
      GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(115863), // Rule ID 23201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23201,
        GIR_EraseRootFromParent_Done,
      // Label 3033: @115863
      GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(115917), // Rule ID 23204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23204,
        GIR_EraseRootFromParent_Done,
      // Label 3034: @115917
      GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(115971), // Rule ID 23205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23205,
        GIR_EraseRootFromParent_Done,
      // Label 3035: @115971
      GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(116025), // Rule ID 23208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23208,
        GIR_EraseRootFromParent_Done,
      // Label 3036: @116025
      GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(116079), // Rule ID 23209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23209,
        GIR_EraseRootFromParent_Done,
      // Label 3037: @116079
      GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(116133), // Rule ID 23212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23212,
        GIR_EraseRootFromParent_Done,
      // Label 3038: @116133
      GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(116187), // Rule ID 23213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11049:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23213,
        GIR_EraseRootFromParent_Done,
      // Label 3039: @116187
      GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(116241), // Rule ID 23216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23216,
        GIR_EraseRootFromParent_Done,
      // Label 3040: @116241
      GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(116295), // Rule ID 23217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23217,
        GIR_EraseRootFromParent_Done,
      // Label 3041: @116295
      GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(116349), // Rule ID 23220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23220,
        GIR_EraseRootFromParent_Done,
      // Label 3042: @116349
      GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(116403), // Rule ID 23221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23221,
        GIR_EraseRootFromParent_Done,
      // Label 3043: @116403
      GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(116457), // Rule ID 23224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23224,
        GIR_EraseRootFromParent_Done,
      // Label 3044: @116457
      GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(116511), // Rule ID 23225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23225,
        GIR_EraseRootFromParent_Done,
      // Label 3045: @116511
      GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(116565), // Rule ID 23228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23228,
        GIR_EraseRootFromParent_Done,
      // Label 3046: @116565
      GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(116619), // Rule ID 23229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23229,
        GIR_EraseRootFromParent_Done,
      // Label 3047: @116619
      GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(116673), // Rule ID 23232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23232,
        GIR_EraseRootFromParent_Done,
      // Label 3048: @116673
      GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(116727), // Rule ID 23233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23233,
        GIR_EraseRootFromParent_Done,
      // Label 3049: @116727
      GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(116781), // Rule ID 23236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23236,
        GIR_EraseRootFromParent_Done,
      // Label 3050: @116781
      GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(116835), // Rule ID 23237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23237,
        GIR_EraseRootFromParent_Done,
      // Label 3051: @116835
      GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(116889), // Rule ID 23240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23240,
        GIR_EraseRootFromParent_Done,
      // Label 3052: @116889
      GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(116943), // Rule ID 23241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11062:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23241,
        GIR_EraseRootFromParent_Done,
      // Label 3053: @116943
      GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(116997), // Rule ID 23244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23244,
        GIR_EraseRootFromParent_Done,
      // Label 3054: @116997
      GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(117051), // Rule ID 23245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23245,
        GIR_EraseRootFromParent_Done,
      // Label 3055: @117051
      GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(117105), // Rule ID 23248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23248,
        GIR_EraseRootFromParent_Done,
      // Label 3056: @117105
      GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(117159), // Rule ID 23249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23249,
        GIR_EraseRootFromParent_Done,
      // Label 3057: @117159
      GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(117213), // Rule ID 23252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23252,
        GIR_EraseRootFromParent_Done,
      // Label 3058: @117213
      GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(117267), // Rule ID 23253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23253,
        GIR_EraseRootFromParent_Done,
      // Label 3059: @117267
      GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(117321), // Rule ID 23256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23256,
        GIR_EraseRootFromParent_Done,
      // Label 3060: @117321
      GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(117375), // Rule ID 23257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23257,
        GIR_EraseRootFromParent_Done,
      // Label 3061: @117375
      GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(117429), // Rule ID 23260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23260,
        GIR_EraseRootFromParent_Done,
      // Label 3062: @117429
      GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(117483), // Rule ID 23261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23261,
        GIR_EraseRootFromParent_Done,
      // Label 3063: @117483
      GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(117537), // Rule ID 23264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23264,
        GIR_EraseRootFromParent_Done,
      // Label 3064: @117537
      GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(117591), // Rule ID 23265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23265,
        GIR_EraseRootFromParent_Done,
      // Label 3065: @117591
      GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(117645), // Rule ID 23268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23268,
        GIR_EraseRootFromParent_Done,
      // Label 3066: @117645
      GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(117699), // Rule ID 23269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11074:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23269,
        GIR_EraseRootFromParent_Done,
      // Label 3067: @117699
      GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(117756), // Rule ID 23356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23356,
        GIR_EraseRootFromParent_Done,
      // Label 3068: @117756
      GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(117813), // Rule ID 23357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23357,
        GIR_EraseRootFromParent_Done,
      // Label 3069: @117813
      GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(117870), // Rule ID 23360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23360,
        GIR_EraseRootFromParent_Done,
      // Label 3070: @117870
      GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(117927), // Rule ID 23361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23361,
        GIR_EraseRootFromParent_Done,
      // Label 3071: @117927
      GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(117984), // Rule ID 23364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23364,
        GIR_EraseRootFromParent_Done,
      // Label 3072: @117984
      GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(118041), // Rule ID 23365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23365,
        GIR_EraseRootFromParent_Done,
      // Label 3073: @118041
      GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(118098), // Rule ID 23368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23368,
        GIR_EraseRootFromParent_Done,
      // Label 3074: @118098
      GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(118155), // Rule ID 23369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23369,
        GIR_EraseRootFromParent_Done,
      // Label 3075: @118155
      GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(118212), // Rule ID 23372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23372,
        GIR_EraseRootFromParent_Done,
      // Label 3076: @118212
      GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(118269), // Rule ID 23373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23373,
        GIR_EraseRootFromParent_Done,
      // Label 3077: @118269
      GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(118326), // Rule ID 23376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23376,
        GIR_EraseRootFromParent_Done,
      // Label 3078: @118326
      GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(118383), // Rule ID 23377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10928:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23377,
        GIR_EraseRootFromParent_Done,
      // Label 3079: @118383
      GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(118440), // Rule ID 23380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23380,
        GIR_EraseRootFromParent_Done,
      // Label 3080: @118440
      GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(118497), // Rule ID 23381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10928:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23381,
        GIR_EraseRootFromParent_Done,
      // Label 3081: @118497
      GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(118554), // Rule ID 23384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23384,
        GIR_EraseRootFromParent_Done,
      // Label 3082: @118554
      GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(118611), // Rule ID 23385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10928:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23385,
        GIR_EraseRootFromParent_Done,
      // Label 3083: @118611
      GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(118668), // Rule ID 23388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23388,
        GIR_EraseRootFromParent_Done,
      // Label 3084: @118668
      GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(118725), // Rule ID 23389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10928:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23389,
        GIR_EraseRootFromParent_Done,
      // Label 3085: @118725
      GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(118782), // Rule ID 23392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23392,
        GIR_EraseRootFromParent_Done,
      // Label 3086: @118782
      GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(118839), // Rule ID 23393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23393,
        GIR_EraseRootFromParent_Done,
      // Label 3087: @118839
      GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(118896), // Rule ID 23396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23396,
        GIR_EraseRootFromParent_Done,
      // Label 3088: @118896
      GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(118953), // Rule ID 23397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23397,
        GIR_EraseRootFromParent_Done,
      // Label 3089: @118953
      GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(119010), // Rule ID 23400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10928:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23400,
        GIR_EraseRootFromParent_Done,
      // Label 3090: @119010
      GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(119067), // Rule ID 23401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10928:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23401,
        GIR_EraseRootFromParent_Done,
      // Label 3091: @119067
      GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(119124), // Rule ID 23404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23404,
        GIR_EraseRootFromParent_Done,
      // Label 3092: @119124
      GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(119181), // Rule ID 23405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23405,
        GIR_EraseRootFromParent_Done,
      // Label 3093: @119181
      GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(119238), // Rule ID 23408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23408,
        GIR_EraseRootFromParent_Done,
      // Label 3094: @119238
      GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(119295), // Rule ID 23409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23409,
        GIR_EraseRootFromParent_Done,
      // Label 3095: @119295
      GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(119352), // Rule ID 23412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10928:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23412,
        GIR_EraseRootFromParent_Done,
      // Label 3096: @119352
      GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(119409), // Rule ID 23413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10928:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23413,
        GIR_EraseRootFromParent_Done,
      // Label 3097: @119409
      GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(119466), // Rule ID 23416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23416,
        GIR_EraseRootFromParent_Done,
      // Label 3098: @119466
      GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(119523), // Rule ID 23417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23417,
        GIR_EraseRootFromParent_Done,
      // Label 3099: @119523
      GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(119580), // Rule ID 23420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23420,
        GIR_EraseRootFromParent_Done,
      // Label 3100: @119580
      GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(119637), // Rule ID 23421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23421,
        GIR_EraseRootFromParent_Done,
      // Label 3101: @119637
      GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(119694), // Rule ID 23424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10928:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23424,
        GIR_EraseRootFromParent_Done,
      // Label 3102: @119694
      GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(119751), // Rule ID 23425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10928:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23425,
        GIR_EraseRootFromParent_Done,
      // Label 3103: @119751
      GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(119808), // Rule ID 23428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23428,
        GIR_EraseRootFromParent_Done,
      // Label 3104: @119808
      GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(119865), // Rule ID 23429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10928:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23429,
        GIR_EraseRootFromParent_Done,
      // Label 3105: @119865
      GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(119922), // Rule ID 23432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23432,
        GIR_EraseRootFromParent_Done,
      // Label 3106: @119922
      GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(119979), // Rule ID 23433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10928:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23433,
        GIR_EraseRootFromParent_Done,
      // Label 3107: @119979
      GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(120036), // Rule ID 23436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10928:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23436,
        GIR_EraseRootFromParent_Done,
      // Label 3108: @120036
      GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(120093), // Rule ID 23437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10928:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23437,
        GIR_EraseRootFromParent_Done,
      // Label 3109: @120093
      GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(120139), // Rule ID 2511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] rnum
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
        // (intrinsic_wo_chain:{ *:[i64] } 10585:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rnum
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2511,
        GIR_EraseRootFromParent_Done,
      // Label 3110: @120139
      GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(120184), // Rule ID 63863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10595:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63863,
        GIR_EraseRootFromParent_Done,
      // Label 3111: @120184
      GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(120229), // Rule ID 63890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10596:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63890,
        GIR_EraseRootFromParent_Done,
      // Label 3112: @120229
      GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(120274), // Rule ID 2501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 11286:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2501,
        GIR_EraseRootFromParent_Done,
      // Label 3113: @120274
      GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(120319), // Rule ID 2502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 11286:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2502,
        GIR_EraseRootFromParent_Done,
      // Label 3114: @120319
      GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(120364), // Rule ID 2503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 11287:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2503,
        GIR_EraseRootFromParent_Done,
      // Label 3115: @120364
      GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(120409), // Rule ID 2504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 11287:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2504,
        GIR_EraseRootFromParent_Done,
      // Label 3116: @120409
      GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(120454), // Rule ID 2507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10580:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2507,
        GIR_EraseRootFromParent_Done,
      // Label 3117: @120454
      GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(120499), // Rule ID 2508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10581:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2508,
        GIR_EraseRootFromParent_Done,
      // Label 3118: @120499
      GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(120544), // Rule ID 2510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10586:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2510,
        GIR_EraseRootFromParent_Done,
      // Label 3119: @120544
      GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(120589), // Rule ID 2514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10582:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2514,
        GIR_EraseRootFromParent_Done,
      // Label 3120: @120589
      GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(120634), // Rule ID 2515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 10583:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2515,
        GIR_EraseRootFromParent_Done,
      // Label 3121: @120634
      GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(120679), // Rule ID 2524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10722:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2524,
        GIR_EraseRootFromParent_Done,
      // Label 3122: @120679
      GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(120724), // Rule ID 2525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10721:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2525,
        GIR_EraseRootFromParent_Done,
      // Label 3123: @120724
      GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(120769), // Rule ID 2526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10725:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2526,
        GIR_EraseRootFromParent_Done,
      // Label 3124: @120769
      GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(120814), // Rule ID 2527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10724:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2527,
        GIR_EraseRootFromParent_Done,
      // Label 3125: @120814
      GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(120859), // Rule ID 2528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10727:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2528,
        GIR_EraseRootFromParent_Done,
      // Label 3126: @120859
      GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(120904), // Rule ID 2529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10729:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2529,
        GIR_EraseRootFromParent_Done,
      // Label 3127: @120904
      GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(120949), // Rule ID 63840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10605:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63840,
        GIR_EraseRootFromParent_Done,
      // Label 3128: @120949
      GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(120994), // Rule ID 63842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10606:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63842,
        GIR_EraseRootFromParent_Done,
      // Label 3129: @120994
      GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(121039), // Rule ID 63844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10601:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63844,
        GIR_EraseRootFromParent_Done,
      // Label 3130: @121039
      GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(121084), // Rule ID 63846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10603:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63846,
        GIR_EraseRootFromParent_Done,
      // Label 3131: @121084
      GIM_Reject,
    // Label 2995: @121085
    GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(292494),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
      GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(121167), // Rule ID 5314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5314,
        GIR_EraseRootFromParent_Done,
      // Label 3133: @121167
      GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(121241), // Rule ID 5315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5315,
        GIR_EraseRootFromParent_Done,
      // Label 3134: @121241
      GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(121315), // Rule ID 5316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5316,
        GIR_EraseRootFromParent_Done,
      // Label 3135: @121315
      GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(121389), // Rule ID 5317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5317,
        GIR_EraseRootFromParent_Done,
      // Label 3136: @121389
      GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(121463), // Rule ID 5318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5318,
        GIR_EraseRootFromParent_Done,
      // Label 3137: @121463
      GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(121537), // Rule ID 5319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5319,
        GIR_EraseRootFromParent_Done,
      // Label 3138: @121537
      GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(121611), // Rule ID 5320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5320,
        GIR_EraseRootFromParent_Done,
      // Label 3139: @121611
      GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(121685), // Rule ID 5321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5321,
        GIR_EraseRootFromParent_Done,
      // Label 3140: @121685
      GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(121759), // Rule ID 5322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5322,
        GIR_EraseRootFromParent_Done,
      // Label 3141: @121759
      GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(121833), // Rule ID 5323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5323,
        GIR_EraseRootFromParent_Done,
      // Label 3142: @121833
      GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(121907), // Rule ID 5324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5324,
        GIR_EraseRootFromParent_Done,
      // Label 3143: @121907
      GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(121981), // Rule ID 5325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5325,
        GIR_EraseRootFromParent_Done,
      // Label 3144: @121981
      GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(122055), // Rule ID 5326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5326,
        GIR_EraseRootFromParent_Done,
      // Label 3145: @122055
      GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(122129), // Rule ID 5327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5327,
        GIR_EraseRootFromParent_Done,
      // Label 3146: @122129
      GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(122203), // Rule ID 5328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5328,
        GIR_EraseRootFromParent_Done,
      // Label 3147: @122203
      GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(122277), // Rule ID 5329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5329,
        GIR_EraseRootFromParent_Done,
      // Label 3148: @122277
      GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(122351), // Rule ID 5330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5330,
        GIR_EraseRootFromParent_Done,
      // Label 3149: @122351
      GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(122425), // Rule ID 5331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5331,
        GIR_EraseRootFromParent_Done,
      // Label 3150: @122425
      GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(122499), // Rule ID 5332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5332,
        GIR_EraseRootFromParent_Done,
      // Label 3151: @122499
      GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(122573), // Rule ID 5333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5333,
        GIR_EraseRootFromParent_Done,
      // Label 3152: @122573
      GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(122647), // Rule ID 5334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5334,
        GIR_EraseRootFromParent_Done,
      // Label 3153: @122647
      GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(122721), // Rule ID 5335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5335,
        GIR_EraseRootFromParent_Done,
      // Label 3154: @122721
      GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(122795), // Rule ID 5336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5336,
        GIR_EraseRootFromParent_Done,
      // Label 3155: @122795
      GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(122869), // Rule ID 5337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5337,
        GIR_EraseRootFromParent_Done,
      // Label 3156: @122869
      GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(122943), // Rule ID 5338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5338,
        GIR_EraseRootFromParent_Done,
      // Label 3157: @122943
      GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(123017), // Rule ID 5339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5339,
        GIR_EraseRootFromParent_Done,
      // Label 3158: @123017
      GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(123091), // Rule ID 5340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5340,
        GIR_EraseRootFromParent_Done,
      // Label 3159: @123091
      GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(123165), // Rule ID 5341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5341,
        GIR_EraseRootFromParent_Done,
      // Label 3160: @123165
      GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(123239), // Rule ID 5342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5342,
        GIR_EraseRootFromParent_Done,
      // Label 3161: @123239
      GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(123313), // Rule ID 5343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5343,
        GIR_EraseRootFromParent_Done,
      // Label 3162: @123313
      GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(123387), // Rule ID 5344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5344,
        GIR_EraseRootFromParent_Done,
      // Label 3163: @123387
      GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(123461), // Rule ID 5345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5345,
        GIR_EraseRootFromParent_Done,
      // Label 3164: @123461
      GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(123535), // Rule ID 5346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5346,
        GIR_EraseRootFromParent_Done,
      // Label 3165: @123535
      GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(123609), // Rule ID 5347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5347,
        GIR_EraseRootFromParent_Done,
      // Label 3166: @123609
      GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(123683), // Rule ID 5348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5348,
        GIR_EraseRootFromParent_Done,
      // Label 3167: @123683
      GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(123757), // Rule ID 5349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5349,
        GIR_EraseRootFromParent_Done,
      // Label 3168: @123757
      GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(123831), // Rule ID 5350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5350,
        GIR_EraseRootFromParent_Done,
      // Label 3169: @123831
      GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(123905), // Rule ID 5351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5351,
        GIR_EraseRootFromParent_Done,
      // Label 3170: @123905
      GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(123979), // Rule ID 5352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5352,
        GIR_EraseRootFromParent_Done,
      // Label 3171: @123979
      GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(124053), // Rule ID 5353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5353,
        GIR_EraseRootFromParent_Done,
      // Label 3172: @124053
      GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(124127), // Rule ID 5354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5354,
        GIR_EraseRootFromParent_Done,
      // Label 3173: @124127
      GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(124201), // Rule ID 5355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5355,
        GIR_EraseRootFromParent_Done,
      // Label 3174: @124201
      GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(124275), // Rule ID 5356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5356,
        GIR_EraseRootFromParent_Done,
      // Label 3175: @124275
      GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(124349), // Rule ID 5357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5357,
        GIR_EraseRootFromParent_Done,
      // Label 3176: @124349
      GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(124423), // Rule ID 7826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7826,
        GIR_EraseRootFromParent_Done,
      // Label 3177: @124423
      GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(124497), // Rule ID 7827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7827,
        GIR_EraseRootFromParent_Done,
      // Label 3178: @124497
      GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(124571), // Rule ID 7830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7830,
        GIR_EraseRootFromParent_Done,
      // Label 3179: @124571
      GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(124645), // Rule ID 7831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7831,
        GIR_EraseRootFromParent_Done,
      // Label 3180: @124645
      GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(124719), // Rule ID 7834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7834,
        GIR_EraseRootFromParent_Done,
      // Label 3181: @124719
      GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(124793), // Rule ID 7835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7835,
        GIR_EraseRootFromParent_Done,
      // Label 3182: @124793
      GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(124867), // Rule ID 7838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7838,
        GIR_EraseRootFromParent_Done,
      // Label 3183: @124867
      GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(124941), // Rule ID 7839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7839,
        GIR_EraseRootFromParent_Done,
      // Label 3184: @124941
      GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(125015), // Rule ID 7842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7842,
        GIR_EraseRootFromParent_Done,
      // Label 3185: @125015
      GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(125089), // Rule ID 7843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7843,
        GIR_EraseRootFromParent_Done,
      // Label 3186: @125089
      GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(125163), // Rule ID 7846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7846,
        GIR_EraseRootFromParent_Done,
      // Label 3187: @125163
      GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(125237), // Rule ID 7847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7847,
        GIR_EraseRootFromParent_Done,
      // Label 3188: @125237
      GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(125311), // Rule ID 7850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7850,
        GIR_EraseRootFromParent_Done,
      // Label 3189: @125311
      GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(125385), // Rule ID 7851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7851,
        GIR_EraseRootFromParent_Done,
      // Label 3190: @125385
      GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(125459), // Rule ID 7854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7854,
        GIR_EraseRootFromParent_Done,
      // Label 3191: @125459
      GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(125533), // Rule ID 7855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7855,
        GIR_EraseRootFromParent_Done,
      // Label 3192: @125533
      GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(125607), // Rule ID 7858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7858,
        GIR_EraseRootFromParent_Done,
      // Label 3193: @125607
      GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(125681), // Rule ID 7859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7859,
        GIR_EraseRootFromParent_Done,
      // Label 3194: @125681
      GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(125755), // Rule ID 7862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7862,
        GIR_EraseRootFromParent_Done,
      // Label 3195: @125755
      GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(125829), // Rule ID 7863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7863,
        GIR_EraseRootFromParent_Done,
      // Label 3196: @125829
      GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(125903), // Rule ID 7866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7866,
        GIR_EraseRootFromParent_Done,
      // Label 3197: @125903
      GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(125977), // Rule ID 7867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7867,
        GIR_EraseRootFromParent_Done,
      // Label 3198: @125977
      GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(126051), // Rule ID 7870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7870,
        GIR_EraseRootFromParent_Done,
      // Label 3199: @126051
      GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(126125), // Rule ID 7871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7871,
        GIR_EraseRootFromParent_Done,
      // Label 3200: @126125
      GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(126199), // Rule ID 7874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7874,
        GIR_EraseRootFromParent_Done,
      // Label 3201: @126199
      GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(126273), // Rule ID 7875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7875,
        GIR_EraseRootFromParent_Done,
      // Label 3202: @126273
      GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(126347), // Rule ID 7878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7878,
        GIR_EraseRootFromParent_Done,
      // Label 3203: @126347
      GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(126421), // Rule ID 7879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7879,
        GIR_EraseRootFromParent_Done,
      // Label 3204: @126421
      GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(126495), // Rule ID 7882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7882,
        GIR_EraseRootFromParent_Done,
      // Label 3205: @126495
      GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(126569), // Rule ID 7883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7883,
        GIR_EraseRootFromParent_Done,
      // Label 3206: @126569
      GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(126643), // Rule ID 7886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7886,
        GIR_EraseRootFromParent_Done,
      // Label 3207: @126643
      GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(126717), // Rule ID 7887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7887,
        GIR_EraseRootFromParent_Done,
      // Label 3208: @126717
      GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(126791), // Rule ID 7890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7890,
        GIR_EraseRootFromParent_Done,
      // Label 3209: @126791
      GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(126865), // Rule ID 7891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7891,
        GIR_EraseRootFromParent_Done,
      // Label 3210: @126865
      GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(126939), // Rule ID 7894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7894,
        GIR_EraseRootFromParent_Done,
      // Label 3211: @126939
      GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(127013), // Rule ID 7895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7895,
        GIR_EraseRootFromParent_Done,
      // Label 3212: @127013
      GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(127087), // Rule ID 7898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7898,
        GIR_EraseRootFromParent_Done,
      // Label 3213: @127087
      GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(127161), // Rule ID 7899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7899,
        GIR_EraseRootFromParent_Done,
      // Label 3214: @127161
      GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(127235), // Rule ID 7902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7902,
        GIR_EraseRootFromParent_Done,
      // Label 3215: @127235
      GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(127309), // Rule ID 7903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7903,
        GIR_EraseRootFromParent_Done,
      // Label 3216: @127309
      GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(127383), // Rule ID 7906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7906,
        GIR_EraseRootFromParent_Done,
      // Label 3217: @127383
      GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(127457), // Rule ID 7907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7907,
        GIR_EraseRootFromParent_Done,
      // Label 3218: @127457
      GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(127531), // Rule ID 7910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7910,
        GIR_EraseRootFromParent_Done,
      // Label 3219: @127531
      GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(127605), // Rule ID 7911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7911,
        GIR_EraseRootFromParent_Done,
      // Label 3220: @127605
      GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(127679), // Rule ID 8090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8090,
        GIR_EraseRootFromParent_Done,
      // Label 3221: @127679
      GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(127753), // Rule ID 8091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8091,
        GIR_EraseRootFromParent_Done,
      // Label 3222: @127753
      GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(127827), // Rule ID 8094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8094,
        GIR_EraseRootFromParent_Done,
      // Label 3223: @127827
      GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(127901), // Rule ID 8095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8095,
        GIR_EraseRootFromParent_Done,
      // Label 3224: @127901
      GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(127975), // Rule ID 8098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8098,
        GIR_EraseRootFromParent_Done,
      // Label 3225: @127975
      GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(128049), // Rule ID 8099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8099,
        GIR_EraseRootFromParent_Done,
      // Label 3226: @128049
      GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(128123), // Rule ID 8102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8102,
        GIR_EraseRootFromParent_Done,
      // Label 3227: @128123
      GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(128197), // Rule ID 8103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8103,
        GIR_EraseRootFromParent_Done,
      // Label 3228: @128197
      GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(128271), // Rule ID 8106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8106,
        GIR_EraseRootFromParent_Done,
      // Label 3229: @128271
      GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(128345), // Rule ID 8107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8107,
        GIR_EraseRootFromParent_Done,
      // Label 3230: @128345
      GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(128419), // Rule ID 8110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8110,
        GIR_EraseRootFromParent_Done,
      // Label 3231: @128419
      GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(128493), // Rule ID 8111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8111,
        GIR_EraseRootFromParent_Done,
      // Label 3232: @128493
      GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(128567), // Rule ID 8114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8114,
        GIR_EraseRootFromParent_Done,
      // Label 3233: @128567
      GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(128641), // Rule ID 8115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8115,
        GIR_EraseRootFromParent_Done,
      // Label 3234: @128641
      GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(128715), // Rule ID 8118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8118,
        GIR_EraseRootFromParent_Done,
      // Label 3235: @128715
      GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(128789), // Rule ID 8119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8119,
        GIR_EraseRootFromParent_Done,
      // Label 3236: @128789
      GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(128863), // Rule ID 8122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8122,
        GIR_EraseRootFromParent_Done,
      // Label 3237: @128863
      GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(128937), // Rule ID 8123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8123,
        GIR_EraseRootFromParent_Done,
      // Label 3238: @128937
      GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(129011), // Rule ID 8126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8126,
        GIR_EraseRootFromParent_Done,
      // Label 3239: @129011
      GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(129085), // Rule ID 8127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8127,
        GIR_EraseRootFromParent_Done,
      // Label 3240: @129085
      GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(129159), // Rule ID 8130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8130,
        GIR_EraseRootFromParent_Done,
      // Label 3241: @129159
      GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(129233), // Rule ID 8131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8131,
        GIR_EraseRootFromParent_Done,
      // Label 3242: @129233
      GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(129307), // Rule ID 8134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8134,
        GIR_EraseRootFromParent_Done,
      // Label 3243: @129307
      GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(129381), // Rule ID 8135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8135,
        GIR_EraseRootFromParent_Done,
      // Label 3244: @129381
      GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(129455), // Rule ID 8138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8138,
        GIR_EraseRootFromParent_Done,
      // Label 3245: @129455
      GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(129529), // Rule ID 8139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8139,
        GIR_EraseRootFromParent_Done,
      // Label 3246: @129529
      GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(129603), // Rule ID 8142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8142,
        GIR_EraseRootFromParent_Done,
      // Label 3247: @129603
      GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(129677), // Rule ID 8143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8143,
        GIR_EraseRootFromParent_Done,
      // Label 3248: @129677
      GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(129751), // Rule ID 8146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8146,
        GIR_EraseRootFromParent_Done,
      // Label 3249: @129751
      GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(129825), // Rule ID 8147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8147,
        GIR_EraseRootFromParent_Done,
      // Label 3250: @129825
      GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(129899), // Rule ID 8150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8150,
        GIR_EraseRootFromParent_Done,
      // Label 3251: @129899
      GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(129973), // Rule ID 8151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8151,
        GIR_EraseRootFromParent_Done,
      // Label 3252: @129973
      GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(130047), // Rule ID 8154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8154,
        GIR_EraseRootFromParent_Done,
      // Label 3253: @130047
      GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(130121), // Rule ID 8155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8155,
        GIR_EraseRootFromParent_Done,
      // Label 3254: @130121
      GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(130195), // Rule ID 8158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8158,
        GIR_EraseRootFromParent_Done,
      // Label 3255: @130195
      GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(130269), // Rule ID 8159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8159,
        GIR_EraseRootFromParent_Done,
      // Label 3256: @130269
      GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(130343), // Rule ID 8162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8162,
        GIR_EraseRootFromParent_Done,
      // Label 3257: @130343
      GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(130417), // Rule ID 8163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8163,
        GIR_EraseRootFromParent_Done,
      // Label 3258: @130417
      GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(130491), // Rule ID 8166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8166,
        GIR_EraseRootFromParent_Done,
      // Label 3259: @130491
      GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(130565), // Rule ID 8167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8167,
        GIR_EraseRootFromParent_Done,
      // Label 3260: @130565
      GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(130639), // Rule ID 8170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8170,
        GIR_EraseRootFromParent_Done,
      // Label 3261: @130639
      GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(130713), // Rule ID 8171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8171,
        GIR_EraseRootFromParent_Done,
      // Label 3262: @130713
      GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(130787), // Rule ID 8174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8174,
        GIR_EraseRootFromParent_Done,
      // Label 3263: @130787
      GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(130861), // Rule ID 8175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8175,
        GIR_EraseRootFromParent_Done,
      // Label 3264: @130861
      GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(130935), // Rule ID 8706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8706,
        GIR_EraseRootFromParent_Done,
      // Label 3265: @130935
      GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(131009), // Rule ID 8707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8707,
        GIR_EraseRootFromParent_Done,
      // Label 3266: @131009
      GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(131083), // Rule ID 8710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8710,
        GIR_EraseRootFromParent_Done,
      // Label 3267: @131083
      GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(131157), // Rule ID 8711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8711,
        GIR_EraseRootFromParent_Done,
      // Label 3268: @131157
      GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(131231), // Rule ID 8714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8714,
        GIR_EraseRootFromParent_Done,
      // Label 3269: @131231
      GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(131305), // Rule ID 8715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8715,
        GIR_EraseRootFromParent_Done,
      // Label 3270: @131305
      GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(131379), // Rule ID 8718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8718,
        GIR_EraseRootFromParent_Done,
      // Label 3271: @131379
      GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(131453), // Rule ID 8719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8719,
        GIR_EraseRootFromParent_Done,
      // Label 3272: @131453
      GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(131527), // Rule ID 8722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8722,
        GIR_EraseRootFromParent_Done,
      // Label 3273: @131527
      GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(131601), // Rule ID 8723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8723,
        GIR_EraseRootFromParent_Done,
      // Label 3274: @131601
      GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(131675), // Rule ID 8726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8726,
        GIR_EraseRootFromParent_Done,
      // Label 3275: @131675
      GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(131749), // Rule ID 8727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8727,
        GIR_EraseRootFromParent_Done,
      // Label 3276: @131749
      GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(131823), // Rule ID 8730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8730,
        GIR_EraseRootFromParent_Done,
      // Label 3277: @131823
      GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(131897), // Rule ID 8731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8731,
        GIR_EraseRootFromParent_Done,
      // Label 3278: @131897
      GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(131971), // Rule ID 8734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8734,
        GIR_EraseRootFromParent_Done,
      // Label 3279: @131971
      GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(132045), // Rule ID 8735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8735,
        GIR_EraseRootFromParent_Done,
      // Label 3280: @132045
      GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(132119), // Rule ID 8738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8738,
        GIR_EraseRootFromParent_Done,
      // Label 3281: @132119
      GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(132193), // Rule ID 8739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8739,
        GIR_EraseRootFromParent_Done,
      // Label 3282: @132193
      GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(132267), // Rule ID 8742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8742,
        GIR_EraseRootFromParent_Done,
      // Label 3283: @132267
      GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(132341), // Rule ID 8743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8743,
        GIR_EraseRootFromParent_Done,
      // Label 3284: @132341
      GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(132415), // Rule ID 8746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8746,
        GIR_EraseRootFromParent_Done,
      // Label 3285: @132415
      GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(132489), // Rule ID 8747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8747,
        GIR_EraseRootFromParent_Done,
      // Label 3286: @132489
      GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(132563), // Rule ID 8750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8750,
        GIR_EraseRootFromParent_Done,
      // Label 3287: @132563
      GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(132637), // Rule ID 8751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8751,
        GIR_EraseRootFromParent_Done,
      // Label 3288: @132637
      GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(132711), // Rule ID 8754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8754,
        GIR_EraseRootFromParent_Done,
      // Label 3289: @132711
      GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(132785), // Rule ID 8755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8755,
        GIR_EraseRootFromParent_Done,
      // Label 3290: @132785
      GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(132859), // Rule ID 8758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8758,
        GIR_EraseRootFromParent_Done,
      // Label 3291: @132859
      GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(132933), // Rule ID 8759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8759,
        GIR_EraseRootFromParent_Done,
      // Label 3292: @132933
      GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(133007), // Rule ID 8762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8762,
        GIR_EraseRootFromParent_Done,
      // Label 3293: @133007
      GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(133081), // Rule ID 8763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8763,
        GIR_EraseRootFromParent_Done,
      // Label 3294: @133081
      GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(133155), // Rule ID 8766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8766,
        GIR_EraseRootFromParent_Done,
      // Label 3295: @133155
      GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(133229), // Rule ID 8767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8767,
        GIR_EraseRootFromParent_Done,
      // Label 3296: @133229
      GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(133303), // Rule ID 8770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8770,
        GIR_EraseRootFromParent_Done,
      // Label 3297: @133303
      GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(133377), // Rule ID 8771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8771,
        GIR_EraseRootFromParent_Done,
      // Label 3298: @133377
      GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(133451), // Rule ID 8774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8774,
        GIR_EraseRootFromParent_Done,
      // Label 3299: @133451
      GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(133525), // Rule ID 8775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8775,
        GIR_EraseRootFromParent_Done,
      // Label 3300: @133525
      GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(133599), // Rule ID 8778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8778,
        GIR_EraseRootFromParent_Done,
      // Label 3301: @133599
      GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(133673), // Rule ID 8779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8779,
        GIR_EraseRootFromParent_Done,
      // Label 3302: @133673
      GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(133747), // Rule ID 8782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8782,
        GIR_EraseRootFromParent_Done,
      // Label 3303: @133747
      GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(133821), // Rule ID 8783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8783,
        GIR_EraseRootFromParent_Done,
      // Label 3304: @133821
      GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(133895), // Rule ID 8786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8786,
        GIR_EraseRootFromParent_Done,
      // Label 3305: @133895
      GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(133969), // Rule ID 8787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8787,
        GIR_EraseRootFromParent_Done,
      // Label 3306: @133969
      GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(134043), // Rule ID 8790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8790,
        GIR_EraseRootFromParent_Done,
      // Label 3307: @134043
      GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(134117), // Rule ID 8791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8791,
        GIR_EraseRootFromParent_Done,
      // Label 3308: @134117
      GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(134191), // Rule ID 8970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8970,
        GIR_EraseRootFromParent_Done,
      // Label 3309: @134191
      GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(134265), // Rule ID 8971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8971,
        GIR_EraseRootFromParent_Done,
      // Label 3310: @134265
      GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(134339), // Rule ID 8974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8974,
        GIR_EraseRootFromParent_Done,
      // Label 3311: @134339
      GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(134413), // Rule ID 8975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8975,
        GIR_EraseRootFromParent_Done,
      // Label 3312: @134413
      GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(134487), // Rule ID 8978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8978,
        GIR_EraseRootFromParent_Done,
      // Label 3313: @134487
      GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(134561), // Rule ID 8979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8979,
        GIR_EraseRootFromParent_Done,
      // Label 3314: @134561
      GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(134635), // Rule ID 8982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8982,
        GIR_EraseRootFromParent_Done,
      // Label 3315: @134635
      GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(134709), // Rule ID 8983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8983,
        GIR_EraseRootFromParent_Done,
      // Label 3316: @134709
      GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(134783), // Rule ID 8986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8986,
        GIR_EraseRootFromParent_Done,
      // Label 3317: @134783
      GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(134857), // Rule ID 8987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8987,
        GIR_EraseRootFromParent_Done,
      // Label 3318: @134857
      GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(134931), // Rule ID 8990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8990,
        GIR_EraseRootFromParent_Done,
      // Label 3319: @134931
      GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(135005), // Rule ID 8991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8991,
        GIR_EraseRootFromParent_Done,
      // Label 3320: @135005
      GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(135079), // Rule ID 8994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8994,
        GIR_EraseRootFromParent_Done,
      // Label 3321: @135079
      GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(135153), // Rule ID 8995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8995,
        GIR_EraseRootFromParent_Done,
      // Label 3322: @135153
      GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(135227), // Rule ID 8998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8998,
        GIR_EraseRootFromParent_Done,
      // Label 3323: @135227
      GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(135301), // Rule ID 8999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8999,
        GIR_EraseRootFromParent_Done,
      // Label 3324: @135301
      GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(135375), // Rule ID 9002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9002,
        GIR_EraseRootFromParent_Done,
      // Label 3325: @135375
      GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(135449), // Rule ID 9003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9003,
        GIR_EraseRootFromParent_Done,
      // Label 3326: @135449
      GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(135523), // Rule ID 9006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9006,
        GIR_EraseRootFromParent_Done,
      // Label 3327: @135523
      GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(135597), // Rule ID 9007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9007,
        GIR_EraseRootFromParent_Done,
      // Label 3328: @135597
      GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(135671), // Rule ID 9010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9010,
        GIR_EraseRootFromParent_Done,
      // Label 3329: @135671
      GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(135745), // Rule ID 9011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9011,
        GIR_EraseRootFromParent_Done,
      // Label 3330: @135745
      GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(135819), // Rule ID 9014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9014,
        GIR_EraseRootFromParent_Done,
      // Label 3331: @135819
      GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(135893), // Rule ID 9015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9015,
        GIR_EraseRootFromParent_Done,
      // Label 3332: @135893
      GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(135967), // Rule ID 9018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9018,
        GIR_EraseRootFromParent_Done,
      // Label 3333: @135967
      GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(136041), // Rule ID 9019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9019,
        GIR_EraseRootFromParent_Done,
      // Label 3334: @136041
      GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(136115), // Rule ID 9022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9022,
        GIR_EraseRootFromParent_Done,
      // Label 3335: @136115
      GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(136189), // Rule ID 9023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9023,
        GIR_EraseRootFromParent_Done,
      // Label 3336: @136189
      GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(136263), // Rule ID 9026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9026,
        GIR_EraseRootFromParent_Done,
      // Label 3337: @136263
      GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(136337), // Rule ID 9027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9027,
        GIR_EraseRootFromParent_Done,
      // Label 3338: @136337
      GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(136411), // Rule ID 9030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9030,
        GIR_EraseRootFromParent_Done,
      // Label 3339: @136411
      GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(136485), // Rule ID 9031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9031,
        GIR_EraseRootFromParent_Done,
      // Label 3340: @136485
      GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(136559), // Rule ID 9034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9034,
        GIR_EraseRootFromParent_Done,
      // Label 3341: @136559
      GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(136633), // Rule ID 9035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9035,
        GIR_EraseRootFromParent_Done,
      // Label 3342: @136633
      GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(136707), // Rule ID 9038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9038,
        GIR_EraseRootFromParent_Done,
      // Label 3343: @136707
      GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(136781), // Rule ID 9039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9039,
        GIR_EraseRootFromParent_Done,
      // Label 3344: @136781
      GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(136855), // Rule ID 9042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9042,
        GIR_EraseRootFromParent_Done,
      // Label 3345: @136855
      GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(136929), // Rule ID 9043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9043,
        GIR_EraseRootFromParent_Done,
      // Label 3346: @136929
      GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(137003), // Rule ID 9046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9046,
        GIR_EraseRootFromParent_Done,
      // Label 3347: @137003
      GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(137077), // Rule ID 9047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9047,
        GIR_EraseRootFromParent_Done,
      // Label 3348: @137077
      GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(137151), // Rule ID 9050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9050,
        GIR_EraseRootFromParent_Done,
      // Label 3349: @137151
      GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(137225), // Rule ID 9051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9051,
        GIR_EraseRootFromParent_Done,
      // Label 3350: @137225
      GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(137299), // Rule ID 9054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9054,
        GIR_EraseRootFromParent_Done,
      // Label 3351: @137299
      GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(137373), // Rule ID 9055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9055,
        GIR_EraseRootFromParent_Done,
      // Label 3352: @137373
      GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(137447), // Rule ID 9146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9146,
        GIR_EraseRootFromParent_Done,
      // Label 3353: @137447
      GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(137521), // Rule ID 9147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9147,
        GIR_EraseRootFromParent_Done,
      // Label 3354: @137521
      GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(137595), // Rule ID 9150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9150,
        GIR_EraseRootFromParent_Done,
      // Label 3355: @137595
      GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(137669), // Rule ID 9151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9151,
        GIR_EraseRootFromParent_Done,
      // Label 3356: @137669
      GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(137743), // Rule ID 9154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9154,
        GIR_EraseRootFromParent_Done,
      // Label 3357: @137743
      GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(137817), // Rule ID 9155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9155,
        GIR_EraseRootFromParent_Done,
      // Label 3358: @137817
      GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(137891), // Rule ID 9158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9158,
        GIR_EraseRootFromParent_Done,
      // Label 3359: @137891
      GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(137965), // Rule ID 9159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9159,
        GIR_EraseRootFromParent_Done,
      // Label 3360: @137965
      GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(138039), // Rule ID 9162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9162,
        GIR_EraseRootFromParent_Done,
      // Label 3361: @138039
      GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(138113), // Rule ID 9163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9163,
        GIR_EraseRootFromParent_Done,
      // Label 3362: @138113
      GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(138187), // Rule ID 9166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9166,
        GIR_EraseRootFromParent_Done,
      // Label 3363: @138187
      GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(138261), // Rule ID 9167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9167,
        GIR_EraseRootFromParent_Done,
      // Label 3364: @138261
      GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(138335), // Rule ID 9170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9170,
        GIR_EraseRootFromParent_Done,
      // Label 3365: @138335
      GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(138409), // Rule ID 9171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9171,
        GIR_EraseRootFromParent_Done,
      // Label 3366: @138409
      GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(138483), // Rule ID 9174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9174,
        GIR_EraseRootFromParent_Done,
      // Label 3367: @138483
      GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(138557), // Rule ID 9175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9175,
        GIR_EraseRootFromParent_Done,
      // Label 3368: @138557
      GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(138631), // Rule ID 9178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9178,
        GIR_EraseRootFromParent_Done,
      // Label 3369: @138631
      GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(138705), // Rule ID 9179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9179,
        GIR_EraseRootFromParent_Done,
      // Label 3370: @138705
      GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(138779), // Rule ID 9182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9182,
        GIR_EraseRootFromParent_Done,
      // Label 3371: @138779
      GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(138853), // Rule ID 9183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9183,
        GIR_EraseRootFromParent_Done,
      // Label 3372: @138853
      GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(138927), // Rule ID 9186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9186,
        GIR_EraseRootFromParent_Done,
      // Label 3373: @138927
      GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(139001), // Rule ID 9187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9187,
        GIR_EraseRootFromParent_Done,
      // Label 3374: @139001
      GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(139075), // Rule ID 9190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9190,
        GIR_EraseRootFromParent_Done,
      // Label 3375: @139075
      GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(139149), // Rule ID 9191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9191,
        GIR_EraseRootFromParent_Done,
      // Label 3376: @139149
      GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(139223), // Rule ID 9194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9194,
        GIR_EraseRootFromParent_Done,
      // Label 3377: @139223
      GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(139297), // Rule ID 9195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9195,
        GIR_EraseRootFromParent_Done,
      // Label 3378: @139297
      GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(139371), // Rule ID 9198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9198,
        GIR_EraseRootFromParent_Done,
      // Label 3379: @139371
      GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(139445), // Rule ID 9199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9199,
        GIR_EraseRootFromParent_Done,
      // Label 3380: @139445
      GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(139519), // Rule ID 9202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9202,
        GIR_EraseRootFromParent_Done,
      // Label 3381: @139519
      GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(139593), // Rule ID 9203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9203,
        GIR_EraseRootFromParent_Done,
      // Label 3382: @139593
      GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(139667), // Rule ID 9206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9206,
        GIR_EraseRootFromParent_Done,
      // Label 3383: @139667
      GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(139741), // Rule ID 9207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9207,
        GIR_EraseRootFromParent_Done,
      // Label 3384: @139741
      GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(139815), // Rule ID 9210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9210,
        GIR_EraseRootFromParent_Done,
      // Label 3385: @139815
      GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(139889), // Rule ID 9211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9211,
        GIR_EraseRootFromParent_Done,
      // Label 3386: @139889
      GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(139963), // Rule ID 9214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9214,
        GIR_EraseRootFromParent_Done,
      // Label 3387: @139963
      GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(140037), // Rule ID 9215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9215,
        GIR_EraseRootFromParent_Done,
      // Label 3388: @140037
      GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(140111), // Rule ID 9218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9218,
        GIR_EraseRootFromParent_Done,
      // Label 3389: @140111
      GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(140185), // Rule ID 9219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9219,
        GIR_EraseRootFromParent_Done,
      // Label 3390: @140185
      GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(140259), // Rule ID 9222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9222,
        GIR_EraseRootFromParent_Done,
      // Label 3391: @140259
      GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(140333), // Rule ID 9223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9223,
        GIR_EraseRootFromParent_Done,
      // Label 3392: @140333
      GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(140407), // Rule ID 9226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9226,
        GIR_EraseRootFromParent_Done,
      // Label 3393: @140407
      GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(140481), // Rule ID 9227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9227,
        GIR_EraseRootFromParent_Done,
      // Label 3394: @140481
      GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(140555), // Rule ID 9230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9230,
        GIR_EraseRootFromParent_Done,
      // Label 3395: @140555
      GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(140629), // Rule ID 9231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9231,
        GIR_EraseRootFromParent_Done,
      // Label 3396: @140629
      GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(140703), // Rule ID 9322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9322,
        GIR_EraseRootFromParent_Done,
      // Label 3397: @140703
      GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(140777), // Rule ID 9323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9323,
        GIR_EraseRootFromParent_Done,
      // Label 3398: @140777
      GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(140851), // Rule ID 9326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9326,
        GIR_EraseRootFromParent_Done,
      // Label 3399: @140851
      GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(140925), // Rule ID 9327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9327,
        GIR_EraseRootFromParent_Done,
      // Label 3400: @140925
      GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(140999), // Rule ID 9330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9330,
        GIR_EraseRootFromParent_Done,
      // Label 3401: @140999
      GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(141073), // Rule ID 9331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9331,
        GIR_EraseRootFromParent_Done,
      // Label 3402: @141073
      GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(141147), // Rule ID 9334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9334,
        GIR_EraseRootFromParent_Done,
      // Label 3403: @141147
      GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(141221), // Rule ID 9335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9335,
        GIR_EraseRootFromParent_Done,
      // Label 3404: @141221
      GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(141295), // Rule ID 9338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9338,
        GIR_EraseRootFromParent_Done,
      // Label 3405: @141295
      GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(141369), // Rule ID 9339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9339,
        GIR_EraseRootFromParent_Done,
      // Label 3406: @141369
      GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(141443), // Rule ID 9342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9342,
        GIR_EraseRootFromParent_Done,
      // Label 3407: @141443
      GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(141517), // Rule ID 9343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9343,
        GIR_EraseRootFromParent_Done,
      // Label 3408: @141517
      GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(141591), // Rule ID 9346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9346,
        GIR_EraseRootFromParent_Done,
      // Label 3409: @141591
      GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(141665), // Rule ID 9347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9347,
        GIR_EraseRootFromParent_Done,
      // Label 3410: @141665
      GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(141739), // Rule ID 9350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9350,
        GIR_EraseRootFromParent_Done,
      // Label 3411: @141739
      GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(141813), // Rule ID 9351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9351,
        GIR_EraseRootFromParent_Done,
      // Label 3412: @141813
      GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(141887), // Rule ID 9354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9354,
        GIR_EraseRootFromParent_Done,
      // Label 3413: @141887
      GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(141961), // Rule ID 9355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9355,
        GIR_EraseRootFromParent_Done,
      // Label 3414: @141961
      GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(142035), // Rule ID 9358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9358,
        GIR_EraseRootFromParent_Done,
      // Label 3415: @142035
      GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(142109), // Rule ID 9359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9359,
        GIR_EraseRootFromParent_Done,
      // Label 3416: @142109
      GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(142183), // Rule ID 9362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9362,
        GIR_EraseRootFromParent_Done,
      // Label 3417: @142183
      GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(142257), // Rule ID 9363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9363,
        GIR_EraseRootFromParent_Done,
      // Label 3418: @142257
      GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(142331), // Rule ID 9366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9366,
        GIR_EraseRootFromParent_Done,
      // Label 3419: @142331
      GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(142405), // Rule ID 9367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9367,
        GIR_EraseRootFromParent_Done,
      // Label 3420: @142405
      GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(142479), // Rule ID 9370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9370,
        GIR_EraseRootFromParent_Done,
      // Label 3421: @142479
      GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(142553), // Rule ID 9371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9371,
        GIR_EraseRootFromParent_Done,
      // Label 3422: @142553
      GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(142627), // Rule ID 9374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9374,
        GIR_EraseRootFromParent_Done,
      // Label 3423: @142627
      GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(142701), // Rule ID 9375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9375,
        GIR_EraseRootFromParent_Done,
      // Label 3424: @142701
      GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(142775), // Rule ID 9378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9378,
        GIR_EraseRootFromParent_Done,
      // Label 3425: @142775
      GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(142849), // Rule ID 9379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9379,
        GIR_EraseRootFromParent_Done,
      // Label 3426: @142849
      GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(142923), // Rule ID 9382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9382,
        GIR_EraseRootFromParent_Done,
      // Label 3427: @142923
      GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(142997), // Rule ID 9383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9383,
        GIR_EraseRootFromParent_Done,
      // Label 3428: @142997
      GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(143071), // Rule ID 9386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9386,
        GIR_EraseRootFromParent_Done,
      // Label 3429: @143071
      GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(143145), // Rule ID 9387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9387,
        GIR_EraseRootFromParent_Done,
      // Label 3430: @143145
      GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(143219), // Rule ID 9390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9390,
        GIR_EraseRootFromParent_Done,
      // Label 3431: @143219
      GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(143293), // Rule ID 9391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9391,
        GIR_EraseRootFromParent_Done,
      // Label 3432: @143293
      GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(143367), // Rule ID 9394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9394,
        GIR_EraseRootFromParent_Done,
      // Label 3433: @143367
      GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(143441), // Rule ID 9395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9395,
        GIR_EraseRootFromParent_Done,
      // Label 3434: @143441
      GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(143515), // Rule ID 9398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9398,
        GIR_EraseRootFromParent_Done,
      // Label 3435: @143515
      GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(143589), // Rule ID 9399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9399,
        GIR_EraseRootFromParent_Done,
      // Label 3436: @143589
      GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(143663), // Rule ID 9402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9402,
        GIR_EraseRootFromParent_Done,
      // Label 3437: @143663
      GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(143737), // Rule ID 9403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9403,
        GIR_EraseRootFromParent_Done,
      // Label 3438: @143737
      GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(143811), // Rule ID 9406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9406,
        GIR_EraseRootFromParent_Done,
      // Label 3439: @143811
      GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(143885), // Rule ID 9407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9407,
        GIR_EraseRootFromParent_Done,
      // Label 3440: @143885
      GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(143941), // Rule ID 63860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] pts
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // MIs[0] radix
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
        // (intrinsic_wo_chain:{ *:[i32] } 10602:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // radix
        GIR_RootToRootCopy, /*OpIdx*/3, // pts
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63860,
        GIR_EraseRootFromParent_Done,
      // Label 3441: @143941
      GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(144022), // Rule ID 2544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10783:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2544,
        GIR_EraseRootFromParent_Done,
      // Label 3442: @144022
      GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(144103), // Rule ID 2545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10783:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2545,
        GIR_EraseRootFromParent_Done,
      // Label 3443: @144103
      GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(144169), // Rule ID 2552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10930:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2552,
        GIR_EraseRootFromParent_Done,
      // Label 3444: @144169
      GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(144235), // Rule ID 2553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10930:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2553,
        GIR_EraseRootFromParent_Done,
      // Label 3445: @144235
      GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(144301), // Rule ID 2556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2556,
        GIR_EraseRootFromParent_Done,
      // Label 3446: @144301
      GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(144367), // Rule ID 2557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2557,
        GIR_EraseRootFromParent_Done,
      // Label 3447: @144367
      GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(144433), // Rule ID 2560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2560,
        GIR_EraseRootFromParent_Done,
      // Label 3448: @144433
      GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(144499), // Rule ID 2561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2561,
        GIR_EraseRootFromParent_Done,
      // Label 3449: @144499
      GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(144562), // Rule ID 2574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2574,
        GIR_EraseRootFromParent_Done,
      // Label 3450: @144562
      GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(144625), // Rule ID 2575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2575,
        GIR_EraseRootFromParent_Done,
      // Label 3451: @144625
      GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(144688), // Rule ID 2586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2586,
        GIR_EraseRootFromParent_Done,
      // Label 3452: @144688
      GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(144751), // Rule ID 2587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2587,
        GIR_EraseRootFromParent_Done,
      // Label 3453: @144751
      GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(144814), // Rule ID 2594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2594,
        GIR_EraseRootFromParent_Done,
      // Label 3454: @144814
      GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(144877), // Rule ID 2595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2595,
        GIR_EraseRootFromParent_Done,
      // Label 3455: @144877
      GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(144943), // Rule ID 2596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10794:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2596,
        GIR_EraseRootFromParent_Done,
      // Label 3456: @144943
      GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(145009), // Rule ID 2597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10794:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2597,
        GIR_EraseRootFromParent_Done,
      // Label 3457: @145009
      GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(145072), // Rule ID 2608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2608,
        GIR_EraseRootFromParent_Done,
      // Label 3458: @145072
      GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(145135), // Rule ID 2609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2609,
        GIR_EraseRootFromParent_Done,
      // Label 3459: @145135
      GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(145201), // Rule ID 4748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4748,
        GIR_EraseRootFromParent_Done,
      // Label 3460: @145201
      GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(145267), // Rule ID 4749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4749,
        GIR_EraseRootFromParent_Done,
      // Label 3461: @145267
      GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(145333), // Rule ID 4752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4752,
        GIR_EraseRootFromParent_Done,
      // Label 3462: @145333
      GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(145399), // Rule ID 4753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4753,
        GIR_EraseRootFromParent_Done,
      // Label 3463: @145399
      GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(145465), // Rule ID 4756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4756,
        GIR_EraseRootFromParent_Done,
      // Label 3464: @145465
      GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(145531), // Rule ID 4757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4757,
        GIR_EraseRootFromParent_Done,
      // Label 3465: @145531
      GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(145597), // Rule ID 4760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4760,
        GIR_EraseRootFromParent_Done,
      // Label 3466: @145597
      GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(145663), // Rule ID 4761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4761,
        GIR_EraseRootFromParent_Done,
      // Label 3467: @145663
      GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(145729), // Rule ID 4764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4764,
        GIR_EraseRootFromParent_Done,
      // Label 3468: @145729
      GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(145795), // Rule ID 4765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4765,
        GIR_EraseRootFromParent_Done,
      // Label 3469: @145795
      GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(145861), // Rule ID 4768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4768,
        GIR_EraseRootFromParent_Done,
      // Label 3470: @145861
      GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(145927), // Rule ID 4769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4769,
        GIR_EraseRootFromParent_Done,
      // Label 3471: @145927
      GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(145993), // Rule ID 4772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4772,
        GIR_EraseRootFromParent_Done,
      // Label 3472: @145993
      GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(146059), // Rule ID 4773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4773,
        GIR_EraseRootFromParent_Done,
      // Label 3473: @146059
      GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(146125), // Rule ID 4776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4776,
        GIR_EraseRootFromParent_Done,
      // Label 3474: @146125
      GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(146191), // Rule ID 4777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4777,
        GIR_EraseRootFromParent_Done,
      // Label 3475: @146191
      GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(146257), // Rule ID 4780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4780,
        GIR_EraseRootFromParent_Done,
      // Label 3476: @146257
      GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(146323), // Rule ID 4781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4781,
        GIR_EraseRootFromParent_Done,
      // Label 3477: @146323
      GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(146389), // Rule ID 4784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4784,
        GIR_EraseRootFromParent_Done,
      // Label 3478: @146389
      GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(146455), // Rule ID 4785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4785,
        GIR_EraseRootFromParent_Done,
      // Label 3479: @146455
      GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(146521), // Rule ID 4788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4788,
        GIR_EraseRootFromParent_Done,
      // Label 3480: @146521
      GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(146587), // Rule ID 4789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4789,
        GIR_EraseRootFromParent_Done,
      // Label 3481: @146587
      GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(146653), // Rule ID 4792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4792,
        GIR_EraseRootFromParent_Done,
      // Label 3482: @146653
      GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(146719), // Rule ID 4793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4793,
        GIR_EraseRootFromParent_Done,
      // Label 3483: @146719
      GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(146785), // Rule ID 4796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4796,
        GIR_EraseRootFromParent_Done,
      // Label 3484: @146785
      GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(146851), // Rule ID 4797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4797,
        GIR_EraseRootFromParent_Done,
      // Label 3485: @146851
      GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(146917), // Rule ID 4800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4800,
        GIR_EraseRootFromParent_Done,
      // Label 3486: @146917
      GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(146983), // Rule ID 4801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4801,
        GIR_EraseRootFromParent_Done,
      // Label 3487: @146983
      GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(147049), // Rule ID 4804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4804,
        GIR_EraseRootFromParent_Done,
      // Label 3488: @147049
      GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(147115), // Rule ID 4805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4805,
        GIR_EraseRootFromParent_Done,
      // Label 3489: @147115
      GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(147181), // Rule ID 4808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4808,
        GIR_EraseRootFromParent_Done,
      // Label 3490: @147181
      GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(147247), // Rule ID 4809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4809,
        GIR_EraseRootFromParent_Done,
      // Label 3491: @147247
      GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(147313), // Rule ID 4812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4812,
        GIR_EraseRootFromParent_Done,
      // Label 3492: @147313
      GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(147379), // Rule ID 4813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4813,
        GIR_EraseRootFromParent_Done,
      // Label 3493: @147379
      GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(147445), // Rule ID 4816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4816,
        GIR_EraseRootFromParent_Done,
      // Label 3494: @147445
      GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(147511), // Rule ID 4817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4817,
        GIR_EraseRootFromParent_Done,
      // Label 3495: @147511
      GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(147577), // Rule ID 4820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4820,
        GIR_EraseRootFromParent_Done,
      // Label 3496: @147577
      GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(147643), // Rule ID 4821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4821,
        GIR_EraseRootFromParent_Done,
      // Label 3497: @147643
      GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(147709), // Rule ID 4824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4824,
        GIR_EraseRootFromParent_Done,
      // Label 3498: @147709
      GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(147775), // Rule ID 4825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4825,
        GIR_EraseRootFromParent_Done,
      // Label 3499: @147775
      GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(147841), // Rule ID 4828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4828,
        GIR_EraseRootFromParent_Done,
      // Label 3500: @147841
      GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(147907), // Rule ID 4829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4829,
        GIR_EraseRootFromParent_Done,
      // Label 3501: @147907
      GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(147973), // Rule ID 4832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4832,
        GIR_EraseRootFromParent_Done,
      // Label 3502: @147973
      GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(148039), // Rule ID 4833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4833,
        GIR_EraseRootFromParent_Done,
      // Label 3503: @148039
      GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(148105), // Rule ID 4836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4836,
        GIR_EraseRootFromParent_Done,
      // Label 3504: @148105
      GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(148171), // Rule ID 4837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4837,
        GIR_EraseRootFromParent_Done,
      // Label 3505: @148171
      GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(148237), // Rule ID 4840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4840,
        GIR_EraseRootFromParent_Done,
      // Label 3506: @148237
      GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(148303), // Rule ID 4841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4841,
        GIR_EraseRootFromParent_Done,
      // Label 3507: @148303
      GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(148369), // Rule ID 4844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4844,
        GIR_EraseRootFromParent_Done,
      // Label 3508: @148369
      GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(148435), // Rule ID 4845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4845,
        GIR_EraseRootFromParent_Done,
      // Label 3509: @148435
      GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(148501), // Rule ID 4848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4848,
        GIR_EraseRootFromParent_Done,
      // Label 3510: @148501
      GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(148567), // Rule ID 4849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4849,
        GIR_EraseRootFromParent_Done,
      // Label 3511: @148567
      GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(148633), // Rule ID 4852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4852,
        GIR_EraseRootFromParent_Done,
      // Label 3512: @148633
      GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(148699), // Rule ID 4853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4853,
        GIR_EraseRootFromParent_Done,
      // Label 3513: @148699
      GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(148765), // Rule ID 4856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4856,
        GIR_EraseRootFromParent_Done,
      // Label 3514: @148765
      GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(148831), // Rule ID 4857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4857,
        GIR_EraseRootFromParent_Done,
      // Label 3515: @148831
      GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(148897), // Rule ID 4860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4860,
        GIR_EraseRootFromParent_Done,
      // Label 3516: @148897
      GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(148963), // Rule ID 4861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4861,
        GIR_EraseRootFromParent_Done,
      // Label 3517: @148963
      GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(149029), // Rule ID 4864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4864,
        GIR_EraseRootFromParent_Done,
      // Label 3518: @149029
      GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(149095), // Rule ID 4865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4865,
        GIR_EraseRootFromParent_Done,
      // Label 3519: @149095
      GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(149161), // Rule ID 4868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4868,
        GIR_EraseRootFromParent_Done,
      // Label 3520: @149161
      GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(149227), // Rule ID 4869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4869,
        GIR_EraseRootFromParent_Done,
      // Label 3521: @149227
      GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(149293), // Rule ID 4872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4872,
        GIR_EraseRootFromParent_Done,
      // Label 3522: @149293
      GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(149359), // Rule ID 4873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4873,
        GIR_EraseRootFromParent_Done,
      // Label 3523: @149359
      GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(149425), // Rule ID 4876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4876,
        GIR_EraseRootFromParent_Done,
      // Label 3524: @149425
      GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(149491), // Rule ID 4877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4877,
        GIR_EraseRootFromParent_Done,
      // Label 3525: @149491
      GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(149557), // Rule ID 4880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4880,
        GIR_EraseRootFromParent_Done,
      // Label 3526: @149557
      GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(149623), // Rule ID 4881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4881,
        GIR_EraseRootFromParent_Done,
      // Label 3527: @149623
      GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(149689), // Rule ID 4884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4884,
        GIR_EraseRootFromParent_Done,
      // Label 3528: @149689
      GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(149755), // Rule ID 4885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4885,
        GIR_EraseRootFromParent_Done,
      // Label 3529: @149755
      GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(149821), // Rule ID 4888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4888,
        GIR_EraseRootFromParent_Done,
      // Label 3530: @149821
      GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(149887), // Rule ID 4889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4889,
        GIR_EraseRootFromParent_Done,
      // Label 3531: @149887
      GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(149953), // Rule ID 4892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4892,
        GIR_EraseRootFromParent_Done,
      // Label 3532: @149953
      GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(150019), // Rule ID 4893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4893,
        GIR_EraseRootFromParent_Done,
      // Label 3533: @150019
      GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(150085), // Rule ID 4896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4896,
        GIR_EraseRootFromParent_Done,
      // Label 3534: @150085
      GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(150151), // Rule ID 4897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4897,
        GIR_EraseRootFromParent_Done,
      // Label 3535: @150151
      GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(150217), // Rule ID 4900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4900,
        GIR_EraseRootFromParent_Done,
      // Label 3536: @150217
      GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(150283), // Rule ID 4901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4901,
        GIR_EraseRootFromParent_Done,
      // Label 3537: @150283
      GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(150349), // Rule ID 4904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4904,
        GIR_EraseRootFromParent_Done,
      // Label 3538: @150349
      GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(150415), // Rule ID 4905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4905,
        GIR_EraseRootFromParent_Done,
      // Label 3539: @150415
      GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(150481), // Rule ID 4908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4908,
        GIR_EraseRootFromParent_Done,
      // Label 3540: @150481
      GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(150547), // Rule ID 4909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4909,
        GIR_EraseRootFromParent_Done,
      // Label 3541: @150547
      GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(150613), // Rule ID 4912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4912,
        GIR_EraseRootFromParent_Done,
      // Label 3542: @150613
      GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(150679), // Rule ID 4913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4913,
        GIR_EraseRootFromParent_Done,
      // Label 3543: @150679
      GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(150745), // Rule ID 4916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4916,
        GIR_EraseRootFromParent_Done,
      // Label 3544: @150745
      GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(150811), // Rule ID 4917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4917,
        GIR_EraseRootFromParent_Done,
      // Label 3545: @150811
      GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(150877), // Rule ID 4920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4920,
        GIR_EraseRootFromParent_Done,
      // Label 3546: @150877
      GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(150943), // Rule ID 4921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4921,
        GIR_EraseRootFromParent_Done,
      // Label 3547: @150943
      GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(151009), // Rule ID 4924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4924,
        GIR_EraseRootFromParent_Done,
      // Label 3548: @151009
      GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(151075), // Rule ID 4925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4925,
        GIR_EraseRootFromParent_Done,
      // Label 3549: @151075
      GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(151141), // Rule ID 4928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4928,
        GIR_EraseRootFromParent_Done,
      // Label 3550: @151141
      GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(151207), // Rule ID 4929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4929,
        GIR_EraseRootFromParent_Done,
      // Label 3551: @151207
      GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(151273), // Rule ID 4932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4932,
        GIR_EraseRootFromParent_Done,
      // Label 3552: @151273
      GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(151339), // Rule ID 4933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4933,
        GIR_EraseRootFromParent_Done,
      // Label 3553: @151339
      GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(151405), // Rule ID 4936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4936,
        GIR_EraseRootFromParent_Done,
      // Label 3554: @151405
      GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(151471), // Rule ID 4937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4937,
        GIR_EraseRootFromParent_Done,
      // Label 3555: @151471
      GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(151537), // Rule ID 4940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4940,
        GIR_EraseRootFromParent_Done,
      // Label 3556: @151537
      GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(151603), // Rule ID 4941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4941,
        GIR_EraseRootFromParent_Done,
      // Label 3557: @151603
      GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(151669), // Rule ID 4944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4944,
        GIR_EraseRootFromParent_Done,
      // Label 3558: @151669
      GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(151735), // Rule ID 4945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4945,
        GIR_EraseRootFromParent_Done,
      // Label 3559: @151735
      GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(151801), // Rule ID 4948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4948,
        GIR_EraseRootFromParent_Done,
      // Label 3560: @151801
      GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(151867), // Rule ID 4949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4949,
        GIR_EraseRootFromParent_Done,
      // Label 3561: @151867
      GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(151933), // Rule ID 4952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4952,
        GIR_EraseRootFromParent_Done,
      // Label 3562: @151933
      GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(151999), // Rule ID 4953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4953,
        GIR_EraseRootFromParent_Done,
      // Label 3563: @151999
      GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(152065), // Rule ID 4956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4956,
        GIR_EraseRootFromParent_Done,
      // Label 3564: @152065
      GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(152131), // Rule ID 4957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4957,
        GIR_EraseRootFromParent_Done,
      // Label 3565: @152131
      GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(152197), // Rule ID 4960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4960,
        GIR_EraseRootFromParent_Done,
      // Label 3566: @152197
      GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(152263), // Rule ID 4961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4961,
        GIR_EraseRootFromParent_Done,
      // Label 3567: @152263
      GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(152329), // Rule ID 4964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4964,
        GIR_EraseRootFromParent_Done,
      // Label 3568: @152329
      GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(152395), // Rule ID 4965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4965,
        GIR_EraseRootFromParent_Done,
      // Label 3569: @152395
      GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(152458), // Rule ID 5228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5228,
        GIR_EraseRootFromParent_Done,
      // Label 3570: @152458
      GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(152521), // Rule ID 5229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5229,
        GIR_EraseRootFromParent_Done,
      // Label 3571: @152521
      GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(152584), // Rule ID 5230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5230,
        GIR_EraseRootFromParent_Done,
      // Label 3572: @152584
      GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(152647), // Rule ID 5231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5231,
        GIR_EraseRootFromParent_Done,
      // Label 3573: @152647
      GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(152710), // Rule ID 5232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5232,
        GIR_EraseRootFromParent_Done,
      // Label 3574: @152710
      GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(152773), // Rule ID 5233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5233,
        GIR_EraseRootFromParent_Done,
      // Label 3575: @152773
      GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(152836), // Rule ID 5234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5234,
        GIR_EraseRootFromParent_Done,
      // Label 3576: @152836
      GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(152899), // Rule ID 5235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5235,
        GIR_EraseRootFromParent_Done,
      // Label 3577: @152899
      GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(152962), // Rule ID 5236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5236,
        GIR_EraseRootFromParent_Done,
      // Label 3578: @152962
      GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(153025), // Rule ID 5237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5237,
        GIR_EraseRootFromParent_Done,
      // Label 3579: @153025
      GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(153088), // Rule ID 5238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5238,
        GIR_EraseRootFromParent_Done,
      // Label 3580: @153088
      GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(153151), // Rule ID 5239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5239,
        GIR_EraseRootFromParent_Done,
      // Label 3581: @153151
      GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(153214), // Rule ID 5240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5240,
        GIR_EraseRootFromParent_Done,
      // Label 3582: @153214
      GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(153277), // Rule ID 5241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5241,
        GIR_EraseRootFromParent_Done,
      // Label 3583: @153277
      GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(153340), // Rule ID 5242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5242,
        GIR_EraseRootFromParent_Done,
      // Label 3584: @153340
      GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(153403), // Rule ID 5243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5243,
        GIR_EraseRootFromParent_Done,
      // Label 3585: @153403
      GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(153466), // Rule ID 5244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5244,
        GIR_EraseRootFromParent_Done,
      // Label 3586: @153466
      GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(153529), // Rule ID 5245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5245,
        GIR_EraseRootFromParent_Done,
      // Label 3587: @153529
      GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(153592), // Rule ID 5246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5246,
        GIR_EraseRootFromParent_Done,
      // Label 3588: @153592
      GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(153655), // Rule ID 5247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5247,
        GIR_EraseRootFromParent_Done,
      // Label 3589: @153655
      GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(153718), // Rule ID 5248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5248,
        GIR_EraseRootFromParent_Done,
      // Label 3590: @153718
      GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(153781), // Rule ID 5249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5249,
        GIR_EraseRootFromParent_Done,
      // Label 3591: @153781
      GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(153844), // Rule ID 5250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5250,
        GIR_EraseRootFromParent_Done,
      // Label 3592: @153844
      GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(153907), // Rule ID 5251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5251,
        GIR_EraseRootFromParent_Done,
      // Label 3593: @153907
      GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(153970), // Rule ID 5252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5252,
        GIR_EraseRootFromParent_Done,
      // Label 3594: @153970
      GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(154033), // Rule ID 5253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5253,
        GIR_EraseRootFromParent_Done,
      // Label 3595: @154033
      GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(154096), // Rule ID 5254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5254,
        GIR_EraseRootFromParent_Done,
      // Label 3596: @154096
      GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(154159), // Rule ID 5255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5255,
        GIR_EraseRootFromParent_Done,
      // Label 3597: @154159
      GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(154222), // Rule ID 5256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5256,
        GIR_EraseRootFromParent_Done,
      // Label 3598: @154222
      GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(154285), // Rule ID 5257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5257,
        GIR_EraseRootFromParent_Done,
      // Label 3599: @154285
      GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(154348), // Rule ID 5258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5258,
        GIR_EraseRootFromParent_Done,
      // Label 3600: @154348
      GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(154411), // Rule ID 5259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5259,
        GIR_EraseRootFromParent_Done,
      // Label 3601: @154411
      GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(154474), // Rule ID 5260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5260,
        GIR_EraseRootFromParent_Done,
      // Label 3602: @154474
      GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(154537), // Rule ID 5261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5261,
        GIR_EraseRootFromParent_Done,
      // Label 3603: @154537
      GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(154600), // Rule ID 5262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5262,
        GIR_EraseRootFromParent_Done,
      // Label 3604: @154600
      GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(154663), // Rule ID 5263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5263,
        GIR_EraseRootFromParent_Done,
      // Label 3605: @154663
      GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(154726), // Rule ID 5264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5264,
        GIR_EraseRootFromParent_Done,
      // Label 3606: @154726
      GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(154789), // Rule ID 5265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5265,
        GIR_EraseRootFromParent_Done,
      // Label 3607: @154789
      GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(154852), // Rule ID 5266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5266,
        GIR_EraseRootFromParent_Done,
      // Label 3608: @154852
      GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(154915), // Rule ID 5267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5267,
        GIR_EraseRootFromParent_Done,
      // Label 3609: @154915
      GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(154978), // Rule ID 5268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5268,
        GIR_EraseRootFromParent_Done,
      // Label 3610: @154978
      GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(155041), // Rule ID 5269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5269,
        GIR_EraseRootFromParent_Done,
      // Label 3611: @155041
      GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(155104), // Rule ID 5270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5270,
        GIR_EraseRootFromParent_Done,
      // Label 3612: @155104
      GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(155167), // Rule ID 5271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5271,
        GIR_EraseRootFromParent_Done,
      // Label 3613: @155167
      GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(155230), // Rule ID 5272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5272,
        GIR_EraseRootFromParent_Done,
      // Label 3614: @155230
      GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(155293), // Rule ID 5273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5273,
        GIR_EraseRootFromParent_Done,
      // Label 3615: @155293
      GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(155356), // Rule ID 5274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5274,
        GIR_EraseRootFromParent_Done,
      // Label 3616: @155356
      GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(155419), // Rule ID 5275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5275,
        GIR_EraseRootFromParent_Done,
      // Label 3617: @155419
      GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(155482), // Rule ID 5276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5276,
        GIR_EraseRootFromParent_Done,
      // Label 3618: @155482
      GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(155545), // Rule ID 5277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5277,
        GIR_EraseRootFromParent_Done,
      // Label 3619: @155545
      GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(155608), // Rule ID 5278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5278,
        GIR_EraseRootFromParent_Done,
      // Label 3620: @155608
      GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(155671), // Rule ID 5279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5279,
        GIR_EraseRootFromParent_Done,
      // Label 3621: @155671
      GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(155734), // Rule ID 5280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5280,
        GIR_EraseRootFromParent_Done,
      // Label 3622: @155734
      GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(155797), // Rule ID 5281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5281,
        GIR_EraseRootFromParent_Done,
      // Label 3623: @155797
      GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(155860), // Rule ID 5282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5282,
        GIR_EraseRootFromParent_Done,
      // Label 3624: @155860
      GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(155923), // Rule ID 5283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5283,
        GIR_EraseRootFromParent_Done,
      // Label 3625: @155923
      GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(155986), // Rule ID 5284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5284,
        GIR_EraseRootFromParent_Done,
      // Label 3626: @155986
      GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(156049), // Rule ID 5285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5285,
        GIR_EraseRootFromParent_Done,
      // Label 3627: @156049
      GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(156112), // Rule ID 5286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5286,
        GIR_EraseRootFromParent_Done,
      // Label 3628: @156112
      GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(156175), // Rule ID 5287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5287,
        GIR_EraseRootFromParent_Done,
      // Label 3629: @156175
      GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(156238), // Rule ID 5288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5288,
        GIR_EraseRootFromParent_Done,
      // Label 3630: @156238
      GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(156301), // Rule ID 5289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11015:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5289,
        GIR_EraseRootFromParent_Done,
      // Label 3631: @156301
      GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(156364), // Rule ID 5290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5290,
        GIR_EraseRootFromParent_Done,
      // Label 3632: @156364
      GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(156427), // Rule ID 5291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5291,
        GIR_EraseRootFromParent_Done,
      // Label 3633: @156427
      GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(156490), // Rule ID 5292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5292,
        GIR_EraseRootFromParent_Done,
      // Label 3634: @156490
      GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(156553), // Rule ID 5293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5293,
        GIR_EraseRootFromParent_Done,
      // Label 3635: @156553
      GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(156616), // Rule ID 5294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5294,
        GIR_EraseRootFromParent_Done,
      // Label 3636: @156616
      GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(156679), // Rule ID 5295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5295,
        GIR_EraseRootFromParent_Done,
      // Label 3637: @156679
      GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(156742), // Rule ID 5296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5296,
        GIR_EraseRootFromParent_Done,
      // Label 3638: @156742
      GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(156805), // Rule ID 5297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5297,
        GIR_EraseRootFromParent_Done,
      // Label 3639: @156805
      GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(156868), // Rule ID 5298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5298,
        GIR_EraseRootFromParent_Done,
      // Label 3640: @156868
      GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(156931), // Rule ID 5299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5299,
        GIR_EraseRootFromParent_Done,
      // Label 3641: @156931
      GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(156994), // Rule ID 5300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5300,
        GIR_EraseRootFromParent_Done,
      // Label 3642: @156994
      GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(157057), // Rule ID 5301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5301,
        GIR_EraseRootFromParent_Done,
      // Label 3643: @157057
      GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(157120), // Rule ID 5302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5302,
        GIR_EraseRootFromParent_Done,
      // Label 3644: @157120
      GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(157183), // Rule ID 5303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5303,
        GIR_EraseRootFromParent_Done,
      // Label 3645: @157183
      GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(157246), // Rule ID 5304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5304,
        GIR_EraseRootFromParent_Done,
      // Label 3646: @157246
      GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(157309), // Rule ID 5305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5305,
        GIR_EraseRootFromParent_Done,
      // Label 3647: @157309
      GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(157372), // Rule ID 5306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5306,
        GIR_EraseRootFromParent_Done,
      // Label 3648: @157372
      GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(157435), // Rule ID 5307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5307,
        GIR_EraseRootFromParent_Done,
      // Label 3649: @157435
      GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(157498), // Rule ID 5308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5308,
        GIR_EraseRootFromParent_Done,
      // Label 3650: @157498
      GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(157561), // Rule ID 5309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11015:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5309,
        GIR_EraseRootFromParent_Done,
      // Label 3651: @157561
      GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(157624), // Rule ID 5310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5310,
        GIR_EraseRootFromParent_Done,
      // Label 3652: @157624
      GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(157687), // Rule ID 5311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11015:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5311,
        GIR_EraseRootFromParent_Done,
      // Label 3653: @157687
      GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(157750), // Rule ID 5312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5312,
        GIR_EraseRootFromParent_Done,
      // Label 3654: @157750
      GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(157813), // Rule ID 5313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11015:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5313,
        GIR_EraseRootFromParent_Done,
      // Label 3655: @157813
      GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(157876), // Rule ID 5534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5534,
        GIR_EraseRootFromParent_Done,
      // Label 3656: @157876
      GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(157939), // Rule ID 5535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5535,
        GIR_EraseRootFromParent_Done,
      // Label 3657: @157939
      GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(158002), // Rule ID 5536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5536,
        GIR_EraseRootFromParent_Done,
      // Label 3658: @158002
      GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(158065), // Rule ID 5537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5537,
        GIR_EraseRootFromParent_Done,
      // Label 3659: @158065
      GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(158128), // Rule ID 5538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5538,
        GIR_EraseRootFromParent_Done,
      // Label 3660: @158128
      GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(158191), // Rule ID 5539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5539,
        GIR_EraseRootFromParent_Done,
      // Label 3661: @158191
      GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(158254), // Rule ID 5540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5540,
        GIR_EraseRootFromParent_Done,
      // Label 3662: @158254
      GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(158317), // Rule ID 5541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5541,
        GIR_EraseRootFromParent_Done,
      // Label 3663: @158317
      GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(158380), // Rule ID 5542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5542,
        GIR_EraseRootFromParent_Done,
      // Label 3664: @158380
      GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(158443), // Rule ID 5543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5543,
        GIR_EraseRootFromParent_Done,
      // Label 3665: @158443
      GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(158506), // Rule ID 5544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5544,
        GIR_EraseRootFromParent_Done,
      // Label 3666: @158506
      GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(158569), // Rule ID 5545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5545,
        GIR_EraseRootFromParent_Done,
      // Label 3667: @158569
      GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(158632), // Rule ID 5546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5546,
        GIR_EraseRootFromParent_Done,
      // Label 3668: @158632
      GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(158695), // Rule ID 5547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5547,
        GIR_EraseRootFromParent_Done,
      // Label 3669: @158695
      GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(158758), // Rule ID 5548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5548,
        GIR_EraseRootFromParent_Done,
      // Label 3670: @158758
      GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(158821), // Rule ID 5549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5549,
        GIR_EraseRootFromParent_Done,
      // Label 3671: @158821
      GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(158884), // Rule ID 5550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5550,
        GIR_EraseRootFromParent_Done,
      // Label 3672: @158884
      GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(158947), // Rule ID 5551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5551,
        GIR_EraseRootFromParent_Done,
      // Label 3673: @158947
      GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(159010), // Rule ID 5552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5552,
        GIR_EraseRootFromParent_Done,
      // Label 3674: @159010
      GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(159073), // Rule ID 5553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5553,
        GIR_EraseRootFromParent_Done,
      // Label 3675: @159073
      GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(159136), // Rule ID 5554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5554,
        GIR_EraseRootFromParent_Done,
      // Label 3676: @159136
      GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(159199), // Rule ID 5555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5555,
        GIR_EraseRootFromParent_Done,
      // Label 3677: @159199
      GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(159262), // Rule ID 5556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5556,
        GIR_EraseRootFromParent_Done,
      // Label 3678: @159262
      GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(159325), // Rule ID 5557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5557,
        GIR_EraseRootFromParent_Done,
      // Label 3679: @159325
      GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(159388), // Rule ID 5558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5558,
        GIR_EraseRootFromParent_Done,
      // Label 3680: @159388
      GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(159451), // Rule ID 5559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5559,
        GIR_EraseRootFromParent_Done,
      // Label 3681: @159451
      GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(159514), // Rule ID 5560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5560,
        GIR_EraseRootFromParent_Done,
      // Label 3682: @159514
      GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(159577), // Rule ID 5561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5561,
        GIR_EraseRootFromParent_Done,
      // Label 3683: @159577
      GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(159640), // Rule ID 5562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5562,
        GIR_EraseRootFromParent_Done,
      // Label 3684: @159640
      GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(159703), // Rule ID 5563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5563,
        GIR_EraseRootFromParent_Done,
      // Label 3685: @159703
      GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(159766), // Rule ID 5564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5564,
        GIR_EraseRootFromParent_Done,
      // Label 3686: @159766
      GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(159829), // Rule ID 5565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5565,
        GIR_EraseRootFromParent_Done,
      // Label 3687: @159829
      GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(159892), // Rule ID 5566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5566,
        GIR_EraseRootFromParent_Done,
      // Label 3688: @159892
      GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(159955), // Rule ID 5567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5567,
        GIR_EraseRootFromParent_Done,
      // Label 3689: @159955
      GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(160018), // Rule ID 5568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5568,
        GIR_EraseRootFromParent_Done,
      // Label 3690: @160018
      GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(160081), // Rule ID 5569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5569,
        GIR_EraseRootFromParent_Done,
      // Label 3691: @160081
      GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(160144), // Rule ID 5570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5570,
        GIR_EraseRootFromParent_Done,
      // Label 3692: @160144
      GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(160207), // Rule ID 5571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5571,
        GIR_EraseRootFromParent_Done,
      // Label 3693: @160207
      GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(160270), // Rule ID 5572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5572,
        GIR_EraseRootFromParent_Done,
      // Label 3694: @160270
      GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(160333), // Rule ID 5573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5573,
        GIR_EraseRootFromParent_Done,
      // Label 3695: @160333
      GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(160396), // Rule ID 5574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5574,
        GIR_EraseRootFromParent_Done,
      // Label 3696: @160396
      GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(160459), // Rule ID 5575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5575,
        GIR_EraseRootFromParent_Done,
      // Label 3697: @160459
      GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(160522), // Rule ID 5576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5576,
        GIR_EraseRootFromParent_Done,
      // Label 3698: @160522
      GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(160585), // Rule ID 5577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5577,
        GIR_EraseRootFromParent_Done,
      // Label 3699: @160585
      GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(160648), // Rule ID 5578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5578,
        GIR_EraseRootFromParent_Done,
      // Label 3700: @160648
      GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(160711), // Rule ID 5579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5579,
        GIR_EraseRootFromParent_Done,
      // Label 3701: @160711
      GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(160774), // Rule ID 5580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5580,
        GIR_EraseRootFromParent_Done,
      // Label 3702: @160774
      GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(160837), // Rule ID 5581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5581,
        GIR_EraseRootFromParent_Done,
      // Label 3703: @160837
      GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(160900), // Rule ID 5582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5582,
        GIR_EraseRootFromParent_Done,
      // Label 3704: @160900
      GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(160963), // Rule ID 5583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5583,
        GIR_EraseRootFromParent_Done,
      // Label 3705: @160963
      GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(161026), // Rule ID 5584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5584,
        GIR_EraseRootFromParent_Done,
      // Label 3706: @161026
      GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(161089), // Rule ID 5585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5585,
        GIR_EraseRootFromParent_Done,
      // Label 3707: @161089
      GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(161152), // Rule ID 5586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5586,
        GIR_EraseRootFromParent_Done,
      // Label 3708: @161152
      GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(161215), // Rule ID 5587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5587,
        GIR_EraseRootFromParent_Done,
      // Label 3709: @161215
      GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(161278), // Rule ID 5588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5588,
        GIR_EraseRootFromParent_Done,
      // Label 3710: @161278
      GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(161341), // Rule ID 5589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5589,
        GIR_EraseRootFromParent_Done,
      // Label 3711: @161341
      GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(161404), // Rule ID 5590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5590,
        GIR_EraseRootFromParent_Done,
      // Label 3712: @161404
      GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(161467), // Rule ID 5591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5591,
        GIR_EraseRootFromParent_Done,
      // Label 3713: @161467
      GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(161530), // Rule ID 5592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5592,
        GIR_EraseRootFromParent_Done,
      // Label 3714: @161530
      GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(161593), // Rule ID 5593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5593,
        GIR_EraseRootFromParent_Done,
      // Label 3715: @161593
      GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(161656), // Rule ID 5594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5594,
        GIR_EraseRootFromParent_Done,
      // Label 3716: @161656
      GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(161719), // Rule ID 5595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5595,
        GIR_EraseRootFromParent_Done,
      // Label 3717: @161719
      GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(161782), // Rule ID 5596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5596,
        GIR_EraseRootFromParent_Done,
      // Label 3718: @161782
      GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(161845), // Rule ID 5597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11047:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5597,
        GIR_EraseRootFromParent_Done,
      // Label 3719: @161845
      GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(161908), // Rule ID 5598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5598,
        GIR_EraseRootFromParent_Done,
      // Label 3720: @161908
      GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(161971), // Rule ID 5599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5599,
        GIR_EraseRootFromParent_Done,
      // Label 3721: @161971
      GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(162034), // Rule ID 5600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5600,
        GIR_EraseRootFromParent_Done,
      // Label 3722: @162034
      GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(162097), // Rule ID 5601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5601,
        GIR_EraseRootFromParent_Done,
      // Label 3723: @162097
      GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(162160), // Rule ID 5602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5602,
        GIR_EraseRootFromParent_Done,
      // Label 3724: @162160
      GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(162223), // Rule ID 5603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5603,
        GIR_EraseRootFromParent_Done,
      // Label 3725: @162223
      GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(162286), // Rule ID 5604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5604,
        GIR_EraseRootFromParent_Done,
      // Label 3726: @162286
      GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(162349), // Rule ID 5605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5605,
        GIR_EraseRootFromParent_Done,
      // Label 3727: @162349
      GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(162412), // Rule ID 5606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5606,
        GIR_EraseRootFromParent_Done,
      // Label 3728: @162412
      GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(162475), // Rule ID 5607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5607,
        GIR_EraseRootFromParent_Done,
      // Label 3729: @162475
      GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(162538), // Rule ID 5608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5608,
        GIR_EraseRootFromParent_Done,
      // Label 3730: @162538
      GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(162601), // Rule ID 5609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5609,
        GIR_EraseRootFromParent_Done,
      // Label 3731: @162601
      GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(162664), // Rule ID 5610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5610,
        GIR_EraseRootFromParent_Done,
      // Label 3732: @162664
      GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(162727), // Rule ID 5611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5611,
        GIR_EraseRootFromParent_Done,
      // Label 3733: @162727
      GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(162790), // Rule ID 5612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5612,
        GIR_EraseRootFromParent_Done,
      // Label 3734: @162790
      GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(162853), // Rule ID 5613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5613,
        GIR_EraseRootFromParent_Done,
      // Label 3735: @162853
      GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(162916), // Rule ID 5614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5614,
        GIR_EraseRootFromParent_Done,
      // Label 3736: @162916
      GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(162979), // Rule ID 5615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5615,
        GIR_EraseRootFromParent_Done,
      // Label 3737: @162979
      GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(163042), // Rule ID 5616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5616,
        GIR_EraseRootFromParent_Done,
      // Label 3738: @163042
      GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(163105), // Rule ID 5617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5617,
        GIR_EraseRootFromParent_Done,
      // Label 3739: @163105
      GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(163168), // Rule ID 5618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5618,
        GIR_EraseRootFromParent_Done,
      // Label 3740: @163168
      GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(163231), // Rule ID 5619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5619,
        GIR_EraseRootFromParent_Done,
      // Label 3741: @163231
      GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(163294), // Rule ID 5620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5620,
        GIR_EraseRootFromParent_Done,
      // Label 3742: @163294
      GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(163357), // Rule ID 5621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5621,
        GIR_EraseRootFromParent_Done,
      // Label 3743: @163357
      GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(163420), // Rule ID 7654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7654,
        GIR_EraseRootFromParent_Done,
      // Label 3744: @163420
      GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(163483), // Rule ID 7655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7655,
        GIR_EraseRootFromParent_Done,
      // Label 3745: @163483
      GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(163546), // Rule ID 7658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7658,
        GIR_EraseRootFromParent_Done,
      // Label 3746: @163546
      GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(163609), // Rule ID 7659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7659,
        GIR_EraseRootFromParent_Done,
      // Label 3747: @163609
      GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(163672), // Rule ID 7662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7662,
        GIR_EraseRootFromParent_Done,
      // Label 3748: @163672
      GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(163735), // Rule ID 7663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7663,
        GIR_EraseRootFromParent_Done,
      // Label 3749: @163735
      GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(163798), // Rule ID 7666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7666,
        GIR_EraseRootFromParent_Done,
      // Label 3750: @163798
      GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(163861), // Rule ID 7667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7667,
        GIR_EraseRootFromParent_Done,
      // Label 3751: @163861
      GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(163924), // Rule ID 7670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7670,
        GIR_EraseRootFromParent_Done,
      // Label 3752: @163924
      GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(163987), // Rule ID 7671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7671,
        GIR_EraseRootFromParent_Done,
      // Label 3753: @163987
      GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(164050), // Rule ID 7674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7674,
        GIR_EraseRootFromParent_Done,
      // Label 3754: @164050
      GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(164113), // Rule ID 7675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7675,
        GIR_EraseRootFromParent_Done,
      // Label 3755: @164113
      GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(164176), // Rule ID 7678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7678,
        GIR_EraseRootFromParent_Done,
      // Label 3756: @164176
      GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(164239), // Rule ID 7679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7679,
        GIR_EraseRootFromParent_Done,
      // Label 3757: @164239
      GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(164302), // Rule ID 7682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7682,
        GIR_EraseRootFromParent_Done,
      // Label 3758: @164302
      GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(164365), // Rule ID 7683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7683,
        GIR_EraseRootFromParent_Done,
      // Label 3759: @164365
      GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(164428), // Rule ID 7686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7686,
        GIR_EraseRootFromParent_Done,
      // Label 3760: @164428
      GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(164491), // Rule ID 7687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7687,
        GIR_EraseRootFromParent_Done,
      // Label 3761: @164491
      GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(164554), // Rule ID 7690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7690,
        GIR_EraseRootFromParent_Done,
      // Label 3762: @164554
      GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(164617), // Rule ID 7691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7691,
        GIR_EraseRootFromParent_Done,
      // Label 3763: @164617
      GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(164680), // Rule ID 7694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7694,
        GIR_EraseRootFromParent_Done,
      // Label 3764: @164680
      GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(164743), // Rule ID 7695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7695,
        GIR_EraseRootFromParent_Done,
      // Label 3765: @164743
      GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(164806), // Rule ID 7698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7698,
        GIR_EraseRootFromParent_Done,
      // Label 3766: @164806
      GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(164869), // Rule ID 7699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7699,
        GIR_EraseRootFromParent_Done,
      // Label 3767: @164869
      GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(164932), // Rule ID 7702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7702,
        GIR_EraseRootFromParent_Done,
      // Label 3768: @164932
      GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(164995), // Rule ID 7703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7703,
        GIR_EraseRootFromParent_Done,
      // Label 3769: @164995
      GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(165058), // Rule ID 7706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7706,
        GIR_EraseRootFromParent_Done,
      // Label 3770: @165058
      GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(165121), // Rule ID 7707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7707,
        GIR_EraseRootFromParent_Done,
      // Label 3771: @165121
      GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(165184), // Rule ID 7710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7710,
        GIR_EraseRootFromParent_Done,
      // Label 3772: @165184
      GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(165247), // Rule ID 7711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7711,
        GIR_EraseRootFromParent_Done,
      // Label 3773: @165247
      GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(165310), // Rule ID 7714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7714,
        GIR_EraseRootFromParent_Done,
      // Label 3774: @165310
      GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(165373), // Rule ID 7715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7715,
        GIR_EraseRootFromParent_Done,
      // Label 3775: @165373
      GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(165436), // Rule ID 7718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7718,
        GIR_EraseRootFromParent_Done,
      // Label 3776: @165436
      GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(165499), // Rule ID 7719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7719,
        GIR_EraseRootFromParent_Done,
      // Label 3777: @165499
      GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(165562), // Rule ID 7722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7722,
        GIR_EraseRootFromParent_Done,
      // Label 3778: @165562
      GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(165625), // Rule ID 7723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7723,
        GIR_EraseRootFromParent_Done,
      // Label 3779: @165625
      GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(165688), // Rule ID 7726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7726,
        GIR_EraseRootFromParent_Done,
      // Label 3780: @165688
      GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(165751), // Rule ID 7727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7727,
        GIR_EraseRootFromParent_Done,
      // Label 3781: @165751
      GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(165814), // Rule ID 7730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7730,
        GIR_EraseRootFromParent_Done,
      // Label 3782: @165814
      GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(165877), // Rule ID 7731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7731,
        GIR_EraseRootFromParent_Done,
      // Label 3783: @165877
      GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(165940), // Rule ID 7734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7734,
        GIR_EraseRootFromParent_Done,
      // Label 3784: @165940
      GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(166003), // Rule ID 7735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7735,
        GIR_EraseRootFromParent_Done,
      // Label 3785: @166003
      GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(166066), // Rule ID 7738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7738,
        GIR_EraseRootFromParent_Done,
      // Label 3786: @166066
      GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(166129), // Rule ID 7739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7739,
        GIR_EraseRootFromParent_Done,
      // Label 3787: @166129
      GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(166192), // Rule ID 7742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7742,
        GIR_EraseRootFromParent_Done,
      // Label 3788: @166192
      GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(166255), // Rule ID 7743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7743,
        GIR_EraseRootFromParent_Done,
      // Label 3789: @166255
      GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(166318), // Rule ID 7746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7746,
        GIR_EraseRootFromParent_Done,
      // Label 3790: @166318
      GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(166381), // Rule ID 7747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7747,
        GIR_EraseRootFromParent_Done,
      // Label 3791: @166381
      GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(166444), // Rule ID 7750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7750,
        GIR_EraseRootFromParent_Done,
      // Label 3792: @166444
      GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(166507), // Rule ID 7751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7751,
        GIR_EraseRootFromParent_Done,
      // Label 3793: @166507
      GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(166570), // Rule ID 7754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7754,
        GIR_EraseRootFromParent_Done,
      // Label 3794: @166570
      GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(166633), // Rule ID 7755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7755,
        GIR_EraseRootFromParent_Done,
      // Label 3795: @166633
      GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(166696), // Rule ID 7758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7758,
        GIR_EraseRootFromParent_Done,
      // Label 3796: @166696
      GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(166759), // Rule ID 7759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7759,
        GIR_EraseRootFromParent_Done,
      // Label 3797: @166759
      GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(166822), // Rule ID 7762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7762,
        GIR_EraseRootFromParent_Done,
      // Label 3798: @166822
      GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(166885), // Rule ID 7763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7763,
        GIR_EraseRootFromParent_Done,
      // Label 3799: @166885
      GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(166948), // Rule ID 7766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7766,
        GIR_EraseRootFromParent_Done,
      // Label 3800: @166948
      GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(167011), // Rule ID 7767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7767,
        GIR_EraseRootFromParent_Done,
      // Label 3801: @167011
      GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(167074), // Rule ID 7770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7770,
        GIR_EraseRootFromParent_Done,
      // Label 3802: @167074
      GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(167137), // Rule ID 7771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7771,
        GIR_EraseRootFromParent_Done,
      // Label 3803: @167137
      GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(167200), // Rule ID 7774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7774,
        GIR_EraseRootFromParent_Done,
      // Label 3804: @167200
      GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(167263), // Rule ID 7775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11051:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7775,
        GIR_EraseRootFromParent_Done,
      // Label 3805: @167263
      GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(167326), // Rule ID 7778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7778,
        GIR_EraseRootFromParent_Done,
      // Label 3806: @167326
      GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(167389), // Rule ID 7779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7779,
        GIR_EraseRootFromParent_Done,
      // Label 3807: @167389
      GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(167452), // Rule ID 7782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7782,
        GIR_EraseRootFromParent_Done,
      // Label 3808: @167452
      GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(167515), // Rule ID 7783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7783,
        GIR_EraseRootFromParent_Done,
      // Label 3809: @167515
      GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(167578), // Rule ID 7786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7786,
        GIR_EraseRootFromParent_Done,
      // Label 3810: @167578
      GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(167641), // Rule ID 7787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7787,
        GIR_EraseRootFromParent_Done,
      // Label 3811: @167641
      GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(167704), // Rule ID 7790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7790,
        GIR_EraseRootFromParent_Done,
      // Label 3812: @167704
      GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(167767), // Rule ID 7791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7791,
        GIR_EraseRootFromParent_Done,
      // Label 3813: @167767
      GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(167830), // Rule ID 7794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7794,
        GIR_EraseRootFromParent_Done,
      // Label 3814: @167830
      GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(167893), // Rule ID 7795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7795,
        GIR_EraseRootFromParent_Done,
      // Label 3815: @167893
      GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(167956), // Rule ID 7798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7798,
        GIR_EraseRootFromParent_Done,
      // Label 3816: @167956
      GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(168019), // Rule ID 7799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7799,
        GIR_EraseRootFromParent_Done,
      // Label 3817: @168019
      GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(168082), // Rule ID 7802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7802,
        GIR_EraseRootFromParent_Done,
      // Label 3818: @168082
      GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(168145), // Rule ID 7803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7803,
        GIR_EraseRootFromParent_Done,
      // Label 3819: @168145
      GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(168208), // Rule ID 7806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7806,
        GIR_EraseRootFromParent_Done,
      // Label 3820: @168208
      GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(168271), // Rule ID 7807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7807,
        GIR_EraseRootFromParent_Done,
      // Label 3821: @168271
      GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(168334), // Rule ID 7810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7810,
        GIR_EraseRootFromParent_Done,
      // Label 3822: @168334
      GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(168397), // Rule ID 7811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7811,
        GIR_EraseRootFromParent_Done,
      // Label 3823: @168397
      GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(168460), // Rule ID 7814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7814,
        GIR_EraseRootFromParent_Done,
      // Label 3824: @168460
      GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(168523), // Rule ID 7815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11051:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7815,
        GIR_EraseRootFromParent_Done,
      // Label 3825: @168523
      GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(168586), // Rule ID 7818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7818,
        GIR_EraseRootFromParent_Done,
      // Label 3826: @168586
      GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(168649), // Rule ID 7819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11051:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7819,
        GIR_EraseRootFromParent_Done,
      // Label 3827: @168649
      GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(168712), // Rule ID 7822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7822,
        GIR_EraseRootFromParent_Done,
      // Label 3828: @168712
      GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(168775), // Rule ID 7823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11051:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7823,
        GIR_EraseRootFromParent_Done,
      // Label 3829: @168775
      GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(168838), // Rule ID 7914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7914,
        GIR_EraseRootFromParent_Done,
      // Label 3830: @168838
      GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(168901), // Rule ID 7915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7915,
        GIR_EraseRootFromParent_Done,
      // Label 3831: @168901
      GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(168964), // Rule ID 7918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7918,
        GIR_EraseRootFromParent_Done,
      // Label 3832: @168964
      GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(169027), // Rule ID 7919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7919,
        GIR_EraseRootFromParent_Done,
      // Label 3833: @169027
      GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(169090), // Rule ID 7922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7922,
        GIR_EraseRootFromParent_Done,
      // Label 3834: @169090
      GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(169153), // Rule ID 7923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7923,
        GIR_EraseRootFromParent_Done,
      // Label 3835: @169153
      GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(169216), // Rule ID 7926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7926,
        GIR_EraseRootFromParent_Done,
      // Label 3836: @169216
      GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(169279), // Rule ID 7927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7927,
        GIR_EraseRootFromParent_Done,
      // Label 3837: @169279
      GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(169342), // Rule ID 7930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7930,
        GIR_EraseRootFromParent_Done,
      // Label 3838: @169342
      GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(169405), // Rule ID 7931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7931,
        GIR_EraseRootFromParent_Done,
      // Label 3839: @169405
      GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(169468), // Rule ID 7934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7934,
        GIR_EraseRootFromParent_Done,
      // Label 3840: @169468
      GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(169531), // Rule ID 7935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7935,
        GIR_EraseRootFromParent_Done,
      // Label 3841: @169531
      GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(169594), // Rule ID 7938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7938,
        GIR_EraseRootFromParent_Done,
      // Label 3842: @169594
      GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(169657), // Rule ID 7939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7939,
        GIR_EraseRootFromParent_Done,
      // Label 3843: @169657
      GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(169720), // Rule ID 7942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7942,
        GIR_EraseRootFromParent_Done,
      // Label 3844: @169720
      GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(169783), // Rule ID 7943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7943,
        GIR_EraseRootFromParent_Done,
      // Label 3845: @169783
      GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(169846), // Rule ID 7946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7946,
        GIR_EraseRootFromParent_Done,
      // Label 3846: @169846
      GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(169909), // Rule ID 7947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7947,
        GIR_EraseRootFromParent_Done,
      // Label 3847: @169909
      GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(169972), // Rule ID 7950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7950,
        GIR_EraseRootFromParent_Done,
      // Label 3848: @169972
      GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(170035), // Rule ID 7951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7951,
        GIR_EraseRootFromParent_Done,
      // Label 3849: @170035
      GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(170098), // Rule ID 7954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7954,
        GIR_EraseRootFromParent_Done,
      // Label 3850: @170098
      GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(170161), // Rule ID 7955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7955,
        GIR_EraseRootFromParent_Done,
      // Label 3851: @170161
      GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(170224), // Rule ID 7958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7958,
        GIR_EraseRootFromParent_Done,
      // Label 3852: @170224
      GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(170287), // Rule ID 7959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7959,
        GIR_EraseRootFromParent_Done,
      // Label 3853: @170287
      GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(170350), // Rule ID 7962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7962,
        GIR_EraseRootFromParent_Done,
      // Label 3854: @170350
      GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(170413), // Rule ID 7963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7963,
        GIR_EraseRootFromParent_Done,
      // Label 3855: @170413
      GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(170476), // Rule ID 7966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7966,
        GIR_EraseRootFromParent_Done,
      // Label 3856: @170476
      GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(170539), // Rule ID 7967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7967,
        GIR_EraseRootFromParent_Done,
      // Label 3857: @170539
      GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(170602), // Rule ID 7970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7970,
        GIR_EraseRootFromParent_Done,
      // Label 3858: @170602
      GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(170665), // Rule ID 7971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7971,
        GIR_EraseRootFromParent_Done,
      // Label 3859: @170665
      GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(170728), // Rule ID 7974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7974,
        GIR_EraseRootFromParent_Done,
      // Label 3860: @170728
      GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(170791), // Rule ID 7975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7975,
        GIR_EraseRootFromParent_Done,
      // Label 3861: @170791
      GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(170854), // Rule ID 7978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7978,
        GIR_EraseRootFromParent_Done,
      // Label 3862: @170854
      GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(170917), // Rule ID 7979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7979,
        GIR_EraseRootFromParent_Done,
      // Label 3863: @170917
      GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(170980), // Rule ID 7982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7982,
        GIR_EraseRootFromParent_Done,
      // Label 3864: @170980
      GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(171043), // Rule ID 7983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7983,
        GIR_EraseRootFromParent_Done,
      // Label 3865: @171043
      GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(171106), // Rule ID 7986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7986,
        GIR_EraseRootFromParent_Done,
      // Label 3866: @171106
      GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(171169), // Rule ID 7987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7987,
        GIR_EraseRootFromParent_Done,
      // Label 3867: @171169
      GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(171232), // Rule ID 7990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7990,
        GIR_EraseRootFromParent_Done,
      // Label 3868: @171232
      GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(171295), // Rule ID 7991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7991,
        GIR_EraseRootFromParent_Done,
      // Label 3869: @171295
      GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(171358), // Rule ID 7994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7994,
        GIR_EraseRootFromParent_Done,
      // Label 3870: @171358
      GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(171421), // Rule ID 7995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7995,
        GIR_EraseRootFromParent_Done,
      // Label 3871: @171421
      GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(171484), // Rule ID 7998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7998,
        GIR_EraseRootFromParent_Done,
      // Label 3872: @171484
      GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(171547), // Rule ID 7999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7999,
        GIR_EraseRootFromParent_Done,
      // Label 3873: @171547
      GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(171610), // Rule ID 8002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8002,
        GIR_EraseRootFromParent_Done,
      // Label 3874: @171610
      GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(171673), // Rule ID 8003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8003,
        GIR_EraseRootFromParent_Done,
      // Label 3875: @171673
      GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(171736), // Rule ID 8006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8006,
        GIR_EraseRootFromParent_Done,
      // Label 3876: @171736
      GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(171799), // Rule ID 8007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8007,
        GIR_EraseRootFromParent_Done,
      // Label 3877: @171799
      GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(171862), // Rule ID 8010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8010,
        GIR_EraseRootFromParent_Done,
      // Label 3878: @171862
      GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(171925), // Rule ID 8011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8011,
        GIR_EraseRootFromParent_Done,
      // Label 3879: @171925
      GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(171988), // Rule ID 8014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8014,
        GIR_EraseRootFromParent_Done,
      // Label 3880: @171988
      GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(172051), // Rule ID 8015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8015,
        GIR_EraseRootFromParent_Done,
      // Label 3881: @172051
      GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(172114), // Rule ID 8018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8018,
        GIR_EraseRootFromParent_Done,
      // Label 3882: @172114
      GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(172177), // Rule ID 8019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8019,
        GIR_EraseRootFromParent_Done,
      // Label 3883: @172177
      GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(172240), // Rule ID 8022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8022,
        GIR_EraseRootFromParent_Done,
      // Label 3884: @172240
      GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(172303), // Rule ID 8023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8023,
        GIR_EraseRootFromParent_Done,
      // Label 3885: @172303
      GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(172366), // Rule ID 8026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8026,
        GIR_EraseRootFromParent_Done,
      // Label 3886: @172366
      GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(172429), // Rule ID 8027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8027,
        GIR_EraseRootFromParent_Done,
      // Label 3887: @172429
      GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(172492), // Rule ID 8030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8030,
        GIR_EraseRootFromParent_Done,
      // Label 3888: @172492
      GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(172555), // Rule ID 8031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8031,
        GIR_EraseRootFromParent_Done,
      // Label 3889: @172555
      GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(172618), // Rule ID 8034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8034,
        GIR_EraseRootFromParent_Done,
      // Label 3890: @172618
      GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(172681), // Rule ID 8035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8035,
        GIR_EraseRootFromParent_Done,
      // Label 3891: @172681
      GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(172744), // Rule ID 8038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8038,
        GIR_EraseRootFromParent_Done,
      // Label 3892: @172744
      GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(172807), // Rule ID 8039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8039,
        GIR_EraseRootFromParent_Done,
      // Label 3893: @172807
      GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(172870), // Rule ID 8042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8042,
        GIR_EraseRootFromParent_Done,
      // Label 3894: @172870
      GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(172933), // Rule ID 8043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8043,
        GIR_EraseRootFromParent_Done,
      // Label 3895: @172933
      GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(172996), // Rule ID 8046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8046,
        GIR_EraseRootFromParent_Done,
      // Label 3896: @172996
      GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(173059), // Rule ID 8047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8047,
        GIR_EraseRootFromParent_Done,
      // Label 3897: @173059
      GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(173122), // Rule ID 8050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8050,
        GIR_EraseRootFromParent_Done,
      // Label 3898: @173122
      GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(173185), // Rule ID 8051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8051,
        GIR_EraseRootFromParent_Done,
      // Label 3899: @173185
      GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(173248), // Rule ID 8054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8054,
        GIR_EraseRootFromParent_Done,
      // Label 3900: @173248
      GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(173311), // Rule ID 8055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8055,
        GIR_EraseRootFromParent_Done,
      // Label 3901: @173311
      GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(173374), // Rule ID 8058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8058,
        GIR_EraseRootFromParent_Done,
      // Label 3902: @173374
      GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(173437), // Rule ID 8059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8059,
        GIR_EraseRootFromParent_Done,
      // Label 3903: @173437
      GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(173500), // Rule ID 8062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8062,
        GIR_EraseRootFromParent_Done,
      // Label 3904: @173500
      GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(173563), // Rule ID 8063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8063,
        GIR_EraseRootFromParent_Done,
      // Label 3905: @173563
      GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(173626), // Rule ID 8066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8066,
        GIR_EraseRootFromParent_Done,
      // Label 3906: @173626
      GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(173689), // Rule ID 8067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8067,
        GIR_EraseRootFromParent_Done,
      // Label 3907: @173689
      GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(173752), // Rule ID 8070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8070,
        GIR_EraseRootFromParent_Done,
      // Label 3908: @173752
      GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(173815), // Rule ID 8071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8071,
        GIR_EraseRootFromParent_Done,
      // Label 3909: @173815
      GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(173878), // Rule ID 8074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8074,
        GIR_EraseRootFromParent_Done,
      // Label 3910: @173878
      GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(173941), // Rule ID 8075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8075,
        GIR_EraseRootFromParent_Done,
      // Label 3911: @173941
      GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(174004), // Rule ID 8078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8078,
        GIR_EraseRootFromParent_Done,
      // Label 3912: @174004
      GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(174067), // Rule ID 8079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8079,
        GIR_EraseRootFromParent_Done,
      // Label 3913: @174067
      GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(174130), // Rule ID 8082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8082,
        GIR_EraseRootFromParent_Done,
      // Label 3914: @174130
      GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(174193), // Rule ID 8083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8083,
        GIR_EraseRootFromParent_Done,
      // Label 3915: @174193
      GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(174256), // Rule ID 8086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8086,
        GIR_EraseRootFromParent_Done,
      // Label 3916: @174256
      GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(174319), // Rule ID 8087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8087,
        GIR_EraseRootFromParent_Done,
      // Label 3917: @174319
      GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(174382), // Rule ID 8178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8178,
        GIR_EraseRootFromParent_Done,
      // Label 3918: @174382
      GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(174445), // Rule ID 8179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8179,
        GIR_EraseRootFromParent_Done,
      // Label 3919: @174445
      GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(174508), // Rule ID 8182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8182,
        GIR_EraseRootFromParent_Done,
      // Label 3920: @174508
      GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(174571), // Rule ID 8183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8183,
        GIR_EraseRootFromParent_Done,
      // Label 3921: @174571
      GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(174634), // Rule ID 8186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8186,
        GIR_EraseRootFromParent_Done,
      // Label 3922: @174634
      GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(174697), // Rule ID 8187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8187,
        GIR_EraseRootFromParent_Done,
      // Label 3923: @174697
      GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(174760), // Rule ID 8190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8190,
        GIR_EraseRootFromParent_Done,
      // Label 3924: @174760
      GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(174823), // Rule ID 8191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8191,
        GIR_EraseRootFromParent_Done,
      // Label 3925: @174823
      GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(174886), // Rule ID 8194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8194,
        GIR_EraseRootFromParent_Done,
      // Label 3926: @174886
      GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(174949), // Rule ID 8195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8195,
        GIR_EraseRootFromParent_Done,
      // Label 3927: @174949
      GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(175012), // Rule ID 8198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8198,
        GIR_EraseRootFromParent_Done,
      // Label 3928: @175012
      GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(175075), // Rule ID 8199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8199,
        GIR_EraseRootFromParent_Done,
      // Label 3929: @175075
      GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(175138), // Rule ID 8202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8202,
        GIR_EraseRootFromParent_Done,
      // Label 3930: @175138
      GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(175201), // Rule ID 8203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8203,
        GIR_EraseRootFromParent_Done,
      // Label 3931: @175201
      GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(175264), // Rule ID 8206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8206,
        GIR_EraseRootFromParent_Done,
      // Label 3932: @175264
      GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(175327), // Rule ID 8207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8207,
        GIR_EraseRootFromParent_Done,
      // Label 3933: @175327
      GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(175390), // Rule ID 8210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8210,
        GIR_EraseRootFromParent_Done,
      // Label 3934: @175390
      GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(175453), // Rule ID 8211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8211,
        GIR_EraseRootFromParent_Done,
      // Label 3935: @175453
      GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(175516), // Rule ID 8214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8214,
        GIR_EraseRootFromParent_Done,
      // Label 3936: @175516
      GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(175579), // Rule ID 8215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8215,
        GIR_EraseRootFromParent_Done,
      // Label 3937: @175579
      GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(175642), // Rule ID 8218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8218,
        GIR_EraseRootFromParent_Done,
      // Label 3938: @175642
      GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(175705), // Rule ID 8219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8219,
        GIR_EraseRootFromParent_Done,
      // Label 3939: @175705
      GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(175768), // Rule ID 8222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8222,
        GIR_EraseRootFromParent_Done,
      // Label 3940: @175768
      GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(175831), // Rule ID 8223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8223,
        GIR_EraseRootFromParent_Done,
      // Label 3941: @175831
      GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(175894), // Rule ID 8226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8226,
        GIR_EraseRootFromParent_Done,
      // Label 3942: @175894
      GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(175957), // Rule ID 8227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8227,
        GIR_EraseRootFromParent_Done,
      // Label 3943: @175957
      GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(176020), // Rule ID 8230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8230,
        GIR_EraseRootFromParent_Done,
      // Label 3944: @176020
      GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(176083), // Rule ID 8231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8231,
        GIR_EraseRootFromParent_Done,
      // Label 3945: @176083
      GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(176146), // Rule ID 8234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8234,
        GIR_EraseRootFromParent_Done,
      // Label 3946: @176146
      GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(176209), // Rule ID 8235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8235,
        GIR_EraseRootFromParent_Done,
      // Label 3947: @176209
      GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(176272), // Rule ID 8238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8238,
        GIR_EraseRootFromParent_Done,
      // Label 3948: @176272
      GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(176335), // Rule ID 8239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8239,
        GIR_EraseRootFromParent_Done,
      // Label 3949: @176335
      GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(176398), // Rule ID 8242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8242,
        GIR_EraseRootFromParent_Done,
      // Label 3950: @176398
      GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(176461), // Rule ID 8243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8243,
        GIR_EraseRootFromParent_Done,
      // Label 3951: @176461
      GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(176524), // Rule ID 8246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8246,
        GIR_EraseRootFromParent_Done,
      // Label 3952: @176524
      GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(176587), // Rule ID 8247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8247,
        GIR_EraseRootFromParent_Done,
      // Label 3953: @176587
      GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(176650), // Rule ID 8250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8250,
        GIR_EraseRootFromParent_Done,
      // Label 3954: @176650
      GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(176713), // Rule ID 8251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8251,
        GIR_EraseRootFromParent_Done,
      // Label 3955: @176713
      GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(176776), // Rule ID 8254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8254,
        GIR_EraseRootFromParent_Done,
      // Label 3956: @176776
      GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(176839), // Rule ID 8255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8255,
        GIR_EraseRootFromParent_Done,
      // Label 3957: @176839
      GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(176902), // Rule ID 8258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8258,
        GIR_EraseRootFromParent_Done,
      // Label 3958: @176902
      GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(176965), // Rule ID 8259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8259,
        GIR_EraseRootFromParent_Done,
      // Label 3959: @176965
      GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(177028), // Rule ID 8262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8262,
        GIR_EraseRootFromParent_Done,
      // Label 3960: @177028
      GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(177091), // Rule ID 8263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8263,
        GIR_EraseRootFromParent_Done,
      // Label 3961: @177091
      GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(177154), // Rule ID 8266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8266,
        GIR_EraseRootFromParent_Done,
      // Label 3962: @177154
      GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(177217), // Rule ID 8267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8267,
        GIR_EraseRootFromParent_Done,
      // Label 3963: @177217
      GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(177280), // Rule ID 8270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8270,
        GIR_EraseRootFromParent_Done,
      // Label 3964: @177280
      GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(177343), // Rule ID 8271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8271,
        GIR_EraseRootFromParent_Done,
      // Label 3965: @177343
      GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(177406), // Rule ID 8274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8274,
        GIR_EraseRootFromParent_Done,
      // Label 3966: @177406
      GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(177469), // Rule ID 8275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8275,
        GIR_EraseRootFromParent_Done,
      // Label 3967: @177469
      GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(177532), // Rule ID 8278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8278,
        GIR_EraseRootFromParent_Done,
      // Label 3968: @177532
      GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(177595), // Rule ID 8279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8279,
        GIR_EraseRootFromParent_Done,
      // Label 3969: @177595
      GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(177658), // Rule ID 8282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8282,
        GIR_EraseRootFromParent_Done,
      // Label 3970: @177658
      GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(177721), // Rule ID 8283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8283,
        GIR_EraseRootFromParent_Done,
      // Label 3971: @177721
      GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(177784), // Rule ID 8286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8286,
        GIR_EraseRootFromParent_Done,
      // Label 3972: @177784
      GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(177847), // Rule ID 8287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8287,
        GIR_EraseRootFromParent_Done,
      // Label 3973: @177847
      GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(177910), // Rule ID 8290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8290,
        GIR_EraseRootFromParent_Done,
      // Label 3974: @177910
      GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(177973), // Rule ID 8291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8291,
        GIR_EraseRootFromParent_Done,
      // Label 3975: @177973
      GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(178036), // Rule ID 8294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8294,
        GIR_EraseRootFromParent_Done,
      // Label 3976: @178036
      GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(178099), // Rule ID 8295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8295,
        GIR_EraseRootFromParent_Done,
      // Label 3977: @178099
      GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(178162), // Rule ID 8298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8298,
        GIR_EraseRootFromParent_Done,
      // Label 3978: @178162
      GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(178225), // Rule ID 8299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8299,
        GIR_EraseRootFromParent_Done,
      // Label 3979: @178225
      GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(178288), // Rule ID 8302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8302,
        GIR_EraseRootFromParent_Done,
      // Label 3980: @178288
      GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(178351), // Rule ID 8303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8303,
        GIR_EraseRootFromParent_Done,
      // Label 3981: @178351
      GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(178414), // Rule ID 8306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8306,
        GIR_EraseRootFromParent_Done,
      // Label 3982: @178414
      GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(178477), // Rule ID 8307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8307,
        GIR_EraseRootFromParent_Done,
      // Label 3983: @178477
      GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(178540), // Rule ID 8310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8310,
        GIR_EraseRootFromParent_Done,
      // Label 3984: @178540
      GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(178603), // Rule ID 8311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8311,
        GIR_EraseRootFromParent_Done,
      // Label 3985: @178603
      GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(178666), // Rule ID 8314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8314,
        GIR_EraseRootFromParent_Done,
      // Label 3986: @178666
      GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(178729), // Rule ID 8315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8315,
        GIR_EraseRootFromParent_Done,
      // Label 3987: @178729
      GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(178792), // Rule ID 8318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8318,
        GIR_EraseRootFromParent_Done,
      // Label 3988: @178792
      GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(178855), // Rule ID 8319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8319,
        GIR_EraseRootFromParent_Done,
      // Label 3989: @178855
      GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(178918), // Rule ID 8322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8322,
        GIR_EraseRootFromParent_Done,
      // Label 3990: @178918
      GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(178981), // Rule ID 8323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8323,
        GIR_EraseRootFromParent_Done,
      // Label 3991: @178981
      GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(179044), // Rule ID 8326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8326,
        GIR_EraseRootFromParent_Done,
      // Label 3992: @179044
      GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(179107), // Rule ID 8327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8327,
        GIR_EraseRootFromParent_Done,
      // Label 3993: @179107
      GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(179170), // Rule ID 8330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8330,
        GIR_EraseRootFromParent_Done,
      // Label 3994: @179170
      GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(179233), // Rule ID 8331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8331,
        GIR_EraseRootFromParent_Done,
      // Label 3995: @179233
      GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(179296), // Rule ID 8334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8334,
        GIR_EraseRootFromParent_Done,
      // Label 3996: @179296
      GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(179359), // Rule ID 8335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8335,
        GIR_EraseRootFromParent_Done,
      // Label 3997: @179359
      GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(179422), // Rule ID 8338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8338,
        GIR_EraseRootFromParent_Done,
      // Label 3998: @179422
      GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(179485), // Rule ID 8339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8339,
        GIR_EraseRootFromParent_Done,
      // Label 3999: @179485
      GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(179548), // Rule ID 8342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8342,
        GIR_EraseRootFromParent_Done,
      // Label 4000: @179548
      GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(179611), // Rule ID 8343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8343,
        GIR_EraseRootFromParent_Done,
      // Label 4001: @179611
      GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(179674), // Rule ID 8346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8346,
        GIR_EraseRootFromParent_Done,
      // Label 4002: @179674
      GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(179737), // Rule ID 8347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8347,
        GIR_EraseRootFromParent_Done,
      // Label 4003: @179737
      GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(179800), // Rule ID 8350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8350,
        GIR_EraseRootFromParent_Done,
      // Label 4004: @179800
      GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(179863), // Rule ID 8351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8351,
        GIR_EraseRootFromParent_Done,
      // Label 4005: @179863
      GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(179926), // Rule ID 8354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8354,
        GIR_EraseRootFromParent_Done,
      // Label 4006: @179926
      GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(179989), // Rule ID 8355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8355,
        GIR_EraseRootFromParent_Done,
      // Label 4007: @179989
      GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(180052), // Rule ID 8358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8358,
        GIR_EraseRootFromParent_Done,
      // Label 4008: @180052
      GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(180115), // Rule ID 8359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8359,
        GIR_EraseRootFromParent_Done,
      // Label 4009: @180115
      GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(180178), // Rule ID 8362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8362,
        GIR_EraseRootFromParent_Done,
      // Label 4010: @180178
      GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(180241), // Rule ID 8363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8363,
        GIR_EraseRootFromParent_Done,
      // Label 4011: @180241
      GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(180304), // Rule ID 8366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8366,
        GIR_EraseRootFromParent_Done,
      // Label 4012: @180304
      GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(180367), // Rule ID 8367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8367,
        GIR_EraseRootFromParent_Done,
      // Label 4013: @180367
      GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(180430), // Rule ID 8370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8370,
        GIR_EraseRootFromParent_Done,
      // Label 4014: @180430
      GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(180493), // Rule ID 8371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8371,
        GIR_EraseRootFromParent_Done,
      // Label 4015: @180493
      GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(180556), // Rule ID 8374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8374,
        GIR_EraseRootFromParent_Done,
      // Label 4016: @180556
      GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(180619), // Rule ID 8375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8375,
        GIR_EraseRootFromParent_Done,
      // Label 4017: @180619
      GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(180682), // Rule ID 8378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8378,
        GIR_EraseRootFromParent_Done,
      // Label 4018: @180682
      GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(180745), // Rule ID 8379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8379,
        GIR_EraseRootFromParent_Done,
      // Label 4019: @180745
      GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(180808), // Rule ID 8382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8382,
        GIR_EraseRootFromParent_Done,
      // Label 4020: @180808
      GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(180871), // Rule ID 8383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8383,
        GIR_EraseRootFromParent_Done,
      // Label 4021: @180871
      GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(180934), // Rule ID 8386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8386,
        GIR_EraseRootFromParent_Done,
      // Label 4022: @180934
      GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(180997), // Rule ID 8387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8387,
        GIR_EraseRootFromParent_Done,
      // Label 4023: @180997
      GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(181060), // Rule ID 8390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8390,
        GIR_EraseRootFromParent_Done,
      // Label 4024: @181060
      GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(181123), // Rule ID 8391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8391,
        GIR_EraseRootFromParent_Done,
      // Label 4025: @181123
      GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(181186), // Rule ID 8394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8394,
        GIR_EraseRootFromParent_Done,
      // Label 4026: @181186
      GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(181249), // Rule ID 8395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8395,
        GIR_EraseRootFromParent_Done,
      // Label 4027: @181249
      GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(181312), // Rule ID 8398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8398,
        GIR_EraseRootFromParent_Done,
      // Label 4028: @181312
      GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(181375), // Rule ID 8399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8399,
        GIR_EraseRootFromParent_Done,
      // Label 4029: @181375
      GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(181438), // Rule ID 8402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8402,
        GIR_EraseRootFromParent_Done,
      // Label 4030: @181438
      GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(181501), // Rule ID 8403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8403,
        GIR_EraseRootFromParent_Done,
      // Label 4031: @181501
      GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(181564), // Rule ID 8406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8406,
        GIR_EraseRootFromParent_Done,
      // Label 4032: @181564
      GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(181627), // Rule ID 8407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8407,
        GIR_EraseRootFromParent_Done,
      // Label 4033: @181627
      GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(181690), // Rule ID 8410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8410,
        GIR_EraseRootFromParent_Done,
      // Label 4034: @181690
      GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(181753), // Rule ID 8411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8411,
        GIR_EraseRootFromParent_Done,
      // Label 4035: @181753
      GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(181816), // Rule ID 8414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8414,
        GIR_EraseRootFromParent_Done,
      // Label 4036: @181816
      GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(181879), // Rule ID 8415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8415,
        GIR_EraseRootFromParent_Done,
      // Label 4037: @181879
      GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(181942), // Rule ID 8418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8418,
        GIR_EraseRootFromParent_Done,
      // Label 4038: @181942
      GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(182005), // Rule ID 8419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8419,
        GIR_EraseRootFromParent_Done,
      // Label 4039: @182005
      GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(182068), // Rule ID 8422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8422,
        GIR_EraseRootFromParent_Done,
      // Label 4040: @182068
      GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(182131), // Rule ID 8423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8423,
        GIR_EraseRootFromParent_Done,
      // Label 4041: @182131
      GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(182194), // Rule ID 8426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8426,
        GIR_EraseRootFromParent_Done,
      // Label 4042: @182194
      GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(182257), // Rule ID 8427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8427,
        GIR_EraseRootFromParent_Done,
      // Label 4043: @182257
      GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(182320), // Rule ID 8430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8430,
        GIR_EraseRootFromParent_Done,
      // Label 4044: @182320
      GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(182383), // Rule ID 8431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8431,
        GIR_EraseRootFromParent_Done,
      // Label 4045: @182383
      GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(182446), // Rule ID 8434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8434,
        GIR_EraseRootFromParent_Done,
      // Label 4046: @182446
      GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(182509), // Rule ID 8435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8435,
        GIR_EraseRootFromParent_Done,
      // Label 4047: @182509
      GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(182572), // Rule ID 8438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8438,
        GIR_EraseRootFromParent_Done,
      // Label 4048: @182572
      GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(182635), // Rule ID 8439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8439,
        GIR_EraseRootFromParent_Done,
      // Label 4049: @182635
      GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(182698), // Rule ID 8442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8442,
        GIR_EraseRootFromParent_Done,
      // Label 4050: @182698
      GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(182761), // Rule ID 8443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8443,
        GIR_EraseRootFromParent_Done,
      // Label 4051: @182761
      GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(182824), // Rule ID 8446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8446,
        GIR_EraseRootFromParent_Done,
      // Label 4052: @182824
      GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(182887), // Rule ID 8447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8447,
        GIR_EraseRootFromParent_Done,
      // Label 4053: @182887
      GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(182950), // Rule ID 8450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8450,
        GIR_EraseRootFromParent_Done,
      // Label 4054: @182950
      GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(183013), // Rule ID 8451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8451,
        GIR_EraseRootFromParent_Done,
      // Label 4055: @183013
      GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(183076), // Rule ID 8454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8454,
        GIR_EraseRootFromParent_Done,
      // Label 4056: @183076
      GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(183139), // Rule ID 8455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8455,
        GIR_EraseRootFromParent_Done,
      // Label 4057: @183139
      GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(183202), // Rule ID 8458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8458,
        GIR_EraseRootFromParent_Done,
      // Label 4058: @183202
      GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(183265), // Rule ID 8459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8459,
        GIR_EraseRootFromParent_Done,
      // Label 4059: @183265
      GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(183328), // Rule ID 8462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8462,
        GIR_EraseRootFromParent_Done,
      // Label 4060: @183328
      GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(183391), // Rule ID 8463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8463,
        GIR_EraseRootFromParent_Done,
      // Label 4061: @183391
      GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(183454), // Rule ID 8466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8466,
        GIR_EraseRootFromParent_Done,
      // Label 4062: @183454
      GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(183517), // Rule ID 8467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8467,
        GIR_EraseRootFromParent_Done,
      // Label 4063: @183517
      GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(183580), // Rule ID 8470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8470,
        GIR_EraseRootFromParent_Done,
      // Label 4064: @183580
      GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(183643), // Rule ID 8471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8471,
        GIR_EraseRootFromParent_Done,
      // Label 4065: @183643
      GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(183706), // Rule ID 8474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8474,
        GIR_EraseRootFromParent_Done,
      // Label 4066: @183706
      GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(183769), // Rule ID 8475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8475,
        GIR_EraseRootFromParent_Done,
      // Label 4067: @183769
      GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(183832), // Rule ID 8478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8478,
        GIR_EraseRootFromParent_Done,
      // Label 4068: @183832
      GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(183895), // Rule ID 8479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8479,
        GIR_EraseRootFromParent_Done,
      // Label 4069: @183895
      GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(183958), // Rule ID 8482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8482,
        GIR_EraseRootFromParent_Done,
      // Label 4070: @183958
      GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(184021), // Rule ID 8483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8483,
        GIR_EraseRootFromParent_Done,
      // Label 4071: @184021
      GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(184084), // Rule ID 8486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8486,
        GIR_EraseRootFromParent_Done,
      // Label 4072: @184084
      GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(184147), // Rule ID 8487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8487,
        GIR_EraseRootFromParent_Done,
      // Label 4073: @184147
      GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(184210), // Rule ID 8490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8490,
        GIR_EraseRootFromParent_Done,
      // Label 4074: @184210
      GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(184273), // Rule ID 8491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8491,
        GIR_EraseRootFromParent_Done,
      // Label 4075: @184273
      GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(184336), // Rule ID 8494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8494,
        GIR_EraseRootFromParent_Done,
      // Label 4076: @184336
      GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(184399), // Rule ID 8495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8495,
        GIR_EraseRootFromParent_Done,
      // Label 4077: @184399
      GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(184462), // Rule ID 8498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8498,
        GIR_EraseRootFromParent_Done,
      // Label 4078: @184462
      GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(184525), // Rule ID 8499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8499,
        GIR_EraseRootFromParent_Done,
      // Label 4079: @184525
      GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(184588), // Rule ID 8502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8502,
        GIR_EraseRootFromParent_Done,
      // Label 4080: @184588
      GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(184651), // Rule ID 8503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8503,
        GIR_EraseRootFromParent_Done,
      // Label 4081: @184651
      GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(184714), // Rule ID 8506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8506,
        GIR_EraseRootFromParent_Done,
      // Label 4082: @184714
      GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(184777), // Rule ID 8507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8507,
        GIR_EraseRootFromParent_Done,
      // Label 4083: @184777
      GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(184840), // Rule ID 8510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8510,
        GIR_EraseRootFromParent_Done,
      // Label 4084: @184840
      GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(184903), // Rule ID 8511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8511,
        GIR_EraseRootFromParent_Done,
      // Label 4085: @184903
      GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(184966), // Rule ID 8514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8514,
        GIR_EraseRootFromParent_Done,
      // Label 4086: @184966
      GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(185029), // Rule ID 8515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8515,
        GIR_EraseRootFromParent_Done,
      // Label 4087: @185029
      GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(185092), // Rule ID 8518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8518,
        GIR_EraseRootFromParent_Done,
      // Label 4088: @185092
      GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(185155), // Rule ID 8519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8519,
        GIR_EraseRootFromParent_Done,
      // Label 4089: @185155
      GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(185218), // Rule ID 8522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8522,
        GIR_EraseRootFromParent_Done,
      // Label 4090: @185218
      GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(185281), // Rule ID 8523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8523,
        GIR_EraseRootFromParent_Done,
      // Label 4091: @185281
      GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(185344), // Rule ID 8526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8526,
        GIR_EraseRootFromParent_Done,
      // Label 4092: @185344
      GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(185407), // Rule ID 8527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8527,
        GIR_EraseRootFromParent_Done,
      // Label 4093: @185407
      GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(185470), // Rule ID 8530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8530,
        GIR_EraseRootFromParent_Done,
      // Label 4094: @185470
      GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(185533), // Rule ID 8531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8531,
        GIR_EraseRootFromParent_Done,
      // Label 4095: @185533
      GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(185596), // Rule ID 8534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8534,
        GIR_EraseRootFromParent_Done,
      // Label 4096: @185596
      GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(185659), // Rule ID 8535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8535,
        GIR_EraseRootFromParent_Done,
      // Label 4097: @185659
      GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(185722), // Rule ID 8538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8538,
        GIR_EraseRootFromParent_Done,
      // Label 4098: @185722
      GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(185785), // Rule ID 8539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8539,
        GIR_EraseRootFromParent_Done,
      // Label 4099: @185785
      GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(185848), // Rule ID 8542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8542,
        GIR_EraseRootFromParent_Done,
      // Label 4100: @185848
      GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(185911), // Rule ID 8543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8543,
        GIR_EraseRootFromParent_Done,
      // Label 4101: @185911
      GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(185974), // Rule ID 8546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8546,
        GIR_EraseRootFromParent_Done,
      // Label 4102: @185974
      GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(186037), // Rule ID 8547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8547,
        GIR_EraseRootFromParent_Done,
      // Label 4103: @186037
      GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(186100), // Rule ID 8550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8550,
        GIR_EraseRootFromParent_Done,
      // Label 4104: @186100
      GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(186163), // Rule ID 8551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8551,
        GIR_EraseRootFromParent_Done,
      // Label 4105: @186163
      GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(186226), // Rule ID 8554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8554,
        GIR_EraseRootFromParent_Done,
      // Label 4106: @186226
      GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(186289), // Rule ID 8555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8555,
        GIR_EraseRootFromParent_Done,
      // Label 4107: @186289
      GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(186352), // Rule ID 8558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8558,
        GIR_EraseRootFromParent_Done,
      // Label 4108: @186352
      GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(186415), // Rule ID 8559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8559,
        GIR_EraseRootFromParent_Done,
      // Label 4109: @186415
      GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(186478), // Rule ID 8562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8562,
        GIR_EraseRootFromParent_Done,
      // Label 4110: @186478
      GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(186541), // Rule ID 8563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8563,
        GIR_EraseRootFromParent_Done,
      // Label 4111: @186541
      GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(186604), // Rule ID 8566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8566,
        GIR_EraseRootFromParent_Done,
      // Label 4112: @186604
      GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(186667), // Rule ID 8567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8567,
        GIR_EraseRootFromParent_Done,
      // Label 4113: @186667
      GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(186730), // Rule ID 8570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8570,
        GIR_EraseRootFromParent_Done,
      // Label 4114: @186730
      GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(186793), // Rule ID 8571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8571,
        GIR_EraseRootFromParent_Done,
      // Label 4115: @186793
      GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(186856), // Rule ID 8574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8574,
        GIR_EraseRootFromParent_Done,
      // Label 4116: @186856
      GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(186919), // Rule ID 8575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8575,
        GIR_EraseRootFromParent_Done,
      // Label 4117: @186919
      GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(186982), // Rule ID 8578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8578,
        GIR_EraseRootFromParent_Done,
      // Label 4118: @186982
      GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(187045), // Rule ID 8579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8579,
        GIR_EraseRootFromParent_Done,
      // Label 4119: @187045
      GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(187108), // Rule ID 8582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8582,
        GIR_EraseRootFromParent_Done,
      // Label 4120: @187108
      GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(187171), // Rule ID 8583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8583,
        GIR_EraseRootFromParent_Done,
      // Label 4121: @187171
      GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(187234), // Rule ID 8586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8586,
        GIR_EraseRootFromParent_Done,
      // Label 4122: @187234
      GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(187297), // Rule ID 8587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8587,
        GIR_EraseRootFromParent_Done,
      // Label 4123: @187297
      GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(187360), // Rule ID 8590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8590,
        GIR_EraseRootFromParent_Done,
      // Label 4124: @187360
      GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(187423), // Rule ID 8591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8591,
        GIR_EraseRootFromParent_Done,
      // Label 4125: @187423
      GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(187486), // Rule ID 8594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8594,
        GIR_EraseRootFromParent_Done,
      // Label 4126: @187486
      GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(187549), // Rule ID 8595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8595,
        GIR_EraseRootFromParent_Done,
      // Label 4127: @187549
      GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(187612), // Rule ID 8598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8598,
        GIR_EraseRootFromParent_Done,
      // Label 4128: @187612
      GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(187675), // Rule ID 8599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8599,
        GIR_EraseRootFromParent_Done,
      // Label 4129: @187675
      GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(187738), // Rule ID 8602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8602,
        GIR_EraseRootFromParent_Done,
      // Label 4130: @187738
      GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(187801), // Rule ID 8603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8603,
        GIR_EraseRootFromParent_Done,
      // Label 4131: @187801
      GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(187864), // Rule ID 8606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8606,
        GIR_EraseRootFromParent_Done,
      // Label 4132: @187864
      GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(187927), // Rule ID 8607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8607,
        GIR_EraseRootFromParent_Done,
      // Label 4133: @187927
      GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(187990), // Rule ID 8610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8610,
        GIR_EraseRootFromParent_Done,
      // Label 4134: @187990
      GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(188053), // Rule ID 8611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8611,
        GIR_EraseRootFromParent_Done,
      // Label 4135: @188053
      GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(188116), // Rule ID 8614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8614,
        GIR_EraseRootFromParent_Done,
      // Label 4136: @188116
      GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(188179), // Rule ID 8615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8615,
        GIR_EraseRootFromParent_Done,
      // Label 4137: @188179
      GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(188242), // Rule ID 8618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8618,
        GIR_EraseRootFromParent_Done,
      // Label 4138: @188242
      GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(188305), // Rule ID 8619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8619,
        GIR_EraseRootFromParent_Done,
      // Label 4139: @188305
      GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(188368), // Rule ID 8622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8622,
        GIR_EraseRootFromParent_Done,
      // Label 4140: @188368
      GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(188431), // Rule ID 8623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8623,
        GIR_EraseRootFromParent_Done,
      // Label 4141: @188431
      GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(188494), // Rule ID 8626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8626,
        GIR_EraseRootFromParent_Done,
      // Label 4142: @188494
      GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(188557), // Rule ID 8627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8627,
        GIR_EraseRootFromParent_Done,
      // Label 4143: @188557
      GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(188620), // Rule ID 8630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8630,
        GIR_EraseRootFromParent_Done,
      // Label 4144: @188620
      GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(188683), // Rule ID 8631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8631,
        GIR_EraseRootFromParent_Done,
      // Label 4145: @188683
      GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(188746), // Rule ID 8634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8634,
        GIR_EraseRootFromParent_Done,
      // Label 4146: @188746
      GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(188809), // Rule ID 8635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8635,
        GIR_EraseRootFromParent_Done,
      // Label 4147: @188809
      GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(188872), // Rule ID 8638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8638,
        GIR_EraseRootFromParent_Done,
      // Label 4148: @188872
      GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(188935), // Rule ID 8639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8639,
        GIR_EraseRootFromParent_Done,
      // Label 4149: @188935
      GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(188998), // Rule ID 8642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8642,
        GIR_EraseRootFromParent_Done,
      // Label 4150: @188998
      GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(189061), // Rule ID 8643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8643,
        GIR_EraseRootFromParent_Done,
      // Label 4151: @189061
      GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(189124), // Rule ID 8646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8646,
        GIR_EraseRootFromParent_Done,
      // Label 4152: @189124
      GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(189187), // Rule ID 8647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8647,
        GIR_EraseRootFromParent_Done,
      // Label 4153: @189187
      GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(189250), // Rule ID 8650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8650,
        GIR_EraseRootFromParent_Done,
      // Label 4154: @189250
      GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(189313), // Rule ID 8651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8651,
        GIR_EraseRootFromParent_Done,
      // Label 4155: @189313
      GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(189376), // Rule ID 8654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8654,
        GIR_EraseRootFromParent_Done,
      // Label 4156: @189376
      GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(189439), // Rule ID 8655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8655,
        GIR_EraseRootFromParent_Done,
      // Label 4157: @189439
      GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(189502), // Rule ID 8658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8658,
        GIR_EraseRootFromParent_Done,
      // Label 4158: @189502
      GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(189565), // Rule ID 8659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8659,
        GIR_EraseRootFromParent_Done,
      // Label 4159: @189565
      GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(189628), // Rule ID 8662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8662,
        GIR_EraseRootFromParent_Done,
      // Label 4160: @189628
      GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(189691), // Rule ID 8663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8663,
        GIR_EraseRootFromParent_Done,
      // Label 4161: @189691
      GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(189754), // Rule ID 8666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8666,
        GIR_EraseRootFromParent_Done,
      // Label 4162: @189754
      GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(189817), // Rule ID 8667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8667,
        GIR_EraseRootFromParent_Done,
      // Label 4163: @189817
      GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(189880), // Rule ID 8670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8670,
        GIR_EraseRootFromParent_Done,
      // Label 4164: @189880
      GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(189943), // Rule ID 8671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8671,
        GIR_EraseRootFromParent_Done,
      // Label 4165: @189943
      GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(190006), // Rule ID 8674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8674,
        GIR_EraseRootFromParent_Done,
      // Label 4166: @190006
      GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(190069), // Rule ID 8675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8675,
        GIR_EraseRootFromParent_Done,
      // Label 4167: @190069
      GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(190132), // Rule ID 8678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8678,
        GIR_EraseRootFromParent_Done,
      // Label 4168: @190132
      GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(190195), // Rule ID 8679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8679,
        GIR_EraseRootFromParent_Done,
      // Label 4169: @190195
      GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(190258), // Rule ID 8682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8682,
        GIR_EraseRootFromParent_Done,
      // Label 4170: @190258
      GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(190321), // Rule ID 8683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8683,
        GIR_EraseRootFromParent_Done,
      // Label 4171: @190321
      GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(190384), // Rule ID 8686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8686,
        GIR_EraseRootFromParent_Done,
      // Label 4172: @190384
      GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(190447), // Rule ID 8687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8687,
        GIR_EraseRootFromParent_Done,
      // Label 4173: @190447
      GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(190510), // Rule ID 8690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8690,
        GIR_EraseRootFromParent_Done,
      // Label 4174: @190510
      GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(190573), // Rule ID 8691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8691,
        GIR_EraseRootFromParent_Done,
      // Label 4175: @190573
      GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(190636), // Rule ID 8694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8694,
        GIR_EraseRootFromParent_Done,
      // Label 4176: @190636
      GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(190699), // Rule ID 8695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8695,
        GIR_EraseRootFromParent_Done,
      // Label 4177: @190699
      GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(190762), // Rule ID 8698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8698,
        GIR_EraseRootFromParent_Done,
      // Label 4178: @190762
      GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(190825), // Rule ID 8699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8699,
        GIR_EraseRootFromParent_Done,
      // Label 4179: @190825
      GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(190888), // Rule ID 8702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8702,
        GIR_EraseRootFromParent_Done,
      // Label 4180: @190888
      GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(190951), // Rule ID 8703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8703,
        GIR_EraseRootFromParent_Done,
      // Label 4181: @190951
      GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(191014), // Rule ID 8794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8794,
        GIR_EraseRootFromParent_Done,
      // Label 4182: @191014
      GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(191077), // Rule ID 8795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8795,
        GIR_EraseRootFromParent_Done,
      // Label 4183: @191077
      GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(191140), // Rule ID 8798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8798,
        GIR_EraseRootFromParent_Done,
      // Label 4184: @191140
      GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(191203), // Rule ID 8799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8799,
        GIR_EraseRootFromParent_Done,
      // Label 4185: @191203
      GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(191266), // Rule ID 8802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8802,
        GIR_EraseRootFromParent_Done,
      // Label 4186: @191266
      GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(191329), // Rule ID 8803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8803,
        GIR_EraseRootFromParent_Done,
      // Label 4187: @191329
      GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(191392), // Rule ID 8806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8806,
        GIR_EraseRootFromParent_Done,
      // Label 4188: @191392
      GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(191455), // Rule ID 8807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8807,
        GIR_EraseRootFromParent_Done,
      // Label 4189: @191455
      GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(191518), // Rule ID 8810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8810,
        GIR_EraseRootFromParent_Done,
      // Label 4190: @191518
      GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(191581), // Rule ID 8811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8811,
        GIR_EraseRootFromParent_Done,
      // Label 4191: @191581
      GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(191644), // Rule ID 8814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8814,
        GIR_EraseRootFromParent_Done,
      // Label 4192: @191644
      GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(191707), // Rule ID 8815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8815,
        GIR_EraseRootFromParent_Done,
      // Label 4193: @191707
      GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(191770), // Rule ID 8818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8818,
        GIR_EraseRootFromParent_Done,
      // Label 4194: @191770
      GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(191833), // Rule ID 8819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8819,
        GIR_EraseRootFromParent_Done,
      // Label 4195: @191833
      GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(191896), // Rule ID 8822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8822,
        GIR_EraseRootFromParent_Done,
      // Label 4196: @191896
      GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(191959), // Rule ID 8823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8823,
        GIR_EraseRootFromParent_Done,
      // Label 4197: @191959
      GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(192022), // Rule ID 8826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8826,
        GIR_EraseRootFromParent_Done,
      // Label 4198: @192022
      GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(192085), // Rule ID 8827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8827,
        GIR_EraseRootFromParent_Done,
      // Label 4199: @192085
      GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(192148), // Rule ID 8830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8830,
        GIR_EraseRootFromParent_Done,
      // Label 4200: @192148
      GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(192211), // Rule ID 8831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8831,
        GIR_EraseRootFromParent_Done,
      // Label 4201: @192211
      GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(192274), // Rule ID 8834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8834,
        GIR_EraseRootFromParent_Done,
      // Label 4202: @192274
      GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(192337), // Rule ID 8835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8835,
        GIR_EraseRootFromParent_Done,
      // Label 4203: @192337
      GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(192400), // Rule ID 8838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8838,
        GIR_EraseRootFromParent_Done,
      // Label 4204: @192400
      GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(192463), // Rule ID 8839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8839,
        GIR_EraseRootFromParent_Done,
      // Label 4205: @192463
      GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(192526), // Rule ID 8842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8842,
        GIR_EraseRootFromParent_Done,
      // Label 4206: @192526
      GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(192589), // Rule ID 8843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8843,
        GIR_EraseRootFromParent_Done,
      // Label 4207: @192589
      GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(192652), // Rule ID 8846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8846,
        GIR_EraseRootFromParent_Done,
      // Label 4208: @192652
      GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(192715), // Rule ID 8847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8847,
        GIR_EraseRootFromParent_Done,
      // Label 4209: @192715
      GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(192778), // Rule ID 8850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8850,
        GIR_EraseRootFromParent_Done,
      // Label 4210: @192778
      GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(192841), // Rule ID 8851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8851,
        GIR_EraseRootFromParent_Done,
      // Label 4211: @192841
      GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(192904), // Rule ID 8854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8854,
        GIR_EraseRootFromParent_Done,
      // Label 4212: @192904
      GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(192967), // Rule ID 8855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8855,
        GIR_EraseRootFromParent_Done,
      // Label 4213: @192967
      GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(193030), // Rule ID 8858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8858,
        GIR_EraseRootFromParent_Done,
      // Label 4214: @193030
      GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(193093), // Rule ID 8859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8859,
        GIR_EraseRootFromParent_Done,
      // Label 4215: @193093
      GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(193156), // Rule ID 8862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8862,
        GIR_EraseRootFromParent_Done,
      // Label 4216: @193156
      GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(193219), // Rule ID 8863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8863,
        GIR_EraseRootFromParent_Done,
      // Label 4217: @193219
      GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(193282), // Rule ID 8866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8866,
        GIR_EraseRootFromParent_Done,
      // Label 4218: @193282
      GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(193345), // Rule ID 8867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8867,
        GIR_EraseRootFromParent_Done,
      // Label 4219: @193345
      GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(193408), // Rule ID 8870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8870,
        GIR_EraseRootFromParent_Done,
      // Label 4220: @193408
      GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(193471), // Rule ID 8871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8871,
        GIR_EraseRootFromParent_Done,
      // Label 4221: @193471
      GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(193534), // Rule ID 8874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8874,
        GIR_EraseRootFromParent_Done,
      // Label 4222: @193534
      GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(193597), // Rule ID 8875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8875,
        GIR_EraseRootFromParent_Done,
      // Label 4223: @193597
      GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(193660), // Rule ID 8878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8878,
        GIR_EraseRootFromParent_Done,
      // Label 4224: @193660
      GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(193723), // Rule ID 8879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8879,
        GIR_EraseRootFromParent_Done,
      // Label 4225: @193723
      GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(193786), // Rule ID 8882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8882,
        GIR_EraseRootFromParent_Done,
      // Label 4226: @193786
      GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(193849), // Rule ID 8883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8883,
        GIR_EraseRootFromParent_Done,
      // Label 4227: @193849
      GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(193912), // Rule ID 8886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8886,
        GIR_EraseRootFromParent_Done,
      // Label 4228: @193912
      GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(193975), // Rule ID 8887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8887,
        GIR_EraseRootFromParent_Done,
      // Label 4229: @193975
      GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(194038), // Rule ID 8890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8890,
        GIR_EraseRootFromParent_Done,
      // Label 4230: @194038
      GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(194101), // Rule ID 8891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8891,
        GIR_EraseRootFromParent_Done,
      // Label 4231: @194101
      GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(194164), // Rule ID 8894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8894,
        GIR_EraseRootFromParent_Done,
      // Label 4232: @194164
      GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(194227), // Rule ID 8895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8895,
        GIR_EraseRootFromParent_Done,
      // Label 4233: @194227
      GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(194290), // Rule ID 8898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8898,
        GIR_EraseRootFromParent_Done,
      // Label 4234: @194290
      GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(194353), // Rule ID 8899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8899,
        GIR_EraseRootFromParent_Done,
      // Label 4235: @194353
      GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(194416), // Rule ID 8902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8902,
        GIR_EraseRootFromParent_Done,
      // Label 4236: @194416
      GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(194479), // Rule ID 8903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8903,
        GIR_EraseRootFromParent_Done,
      // Label 4237: @194479
      GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(194542), // Rule ID 8906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8906,
        GIR_EraseRootFromParent_Done,
      // Label 4238: @194542
      GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(194605), // Rule ID 8907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8907,
        GIR_EraseRootFromParent_Done,
      // Label 4239: @194605
      GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(194668), // Rule ID 8910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8910,
        GIR_EraseRootFromParent_Done,
      // Label 4240: @194668
      GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(194731), // Rule ID 8911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8911,
        GIR_EraseRootFromParent_Done,
      // Label 4241: @194731
      GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(194794), // Rule ID 8914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8914,
        GIR_EraseRootFromParent_Done,
      // Label 4242: @194794
      GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(194857), // Rule ID 8915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8915,
        GIR_EraseRootFromParent_Done,
      // Label 4243: @194857
      GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(194920), // Rule ID 8918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8918,
        GIR_EraseRootFromParent_Done,
      // Label 4244: @194920
      GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(194983), // Rule ID 8919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8919,
        GIR_EraseRootFromParent_Done,
      // Label 4245: @194983
      GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(195046), // Rule ID 8922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8922,
        GIR_EraseRootFromParent_Done,
      // Label 4246: @195046
      GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(195109), // Rule ID 8923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8923,
        GIR_EraseRootFromParent_Done,
      // Label 4247: @195109
      GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(195172), // Rule ID 8926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8926,
        GIR_EraseRootFromParent_Done,
      // Label 4248: @195172
      GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(195235), // Rule ID 8927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8927,
        GIR_EraseRootFromParent_Done,
      // Label 4249: @195235
      GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(195298), // Rule ID 8930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8930,
        GIR_EraseRootFromParent_Done,
      // Label 4250: @195298
      GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(195361), // Rule ID 8931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8931,
        GIR_EraseRootFromParent_Done,
      // Label 4251: @195361
      GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(195424), // Rule ID 8934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8934,
        GIR_EraseRootFromParent_Done,
      // Label 4252: @195424
      GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(195487), // Rule ID 8935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8935,
        GIR_EraseRootFromParent_Done,
      // Label 4253: @195487
      GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(195550), // Rule ID 8938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8938,
        GIR_EraseRootFromParent_Done,
      // Label 4254: @195550
      GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(195613), // Rule ID 8939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8939,
        GIR_EraseRootFromParent_Done,
      // Label 4255: @195613
      GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(195676), // Rule ID 8942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8942,
        GIR_EraseRootFromParent_Done,
      // Label 4256: @195676
      GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(195739), // Rule ID 8943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8943,
        GIR_EraseRootFromParent_Done,
      // Label 4257: @195739
      GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(195802), // Rule ID 8946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8946,
        GIR_EraseRootFromParent_Done,
      // Label 4258: @195802
      GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(195865), // Rule ID 8947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8947,
        GIR_EraseRootFromParent_Done,
      // Label 4259: @195865
      GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(195928), // Rule ID 8950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8950,
        GIR_EraseRootFromParent_Done,
      // Label 4260: @195928
      GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(195991), // Rule ID 8951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8951,
        GIR_EraseRootFromParent_Done,
      // Label 4261: @195991
      GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(196054), // Rule ID 8954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8954,
        GIR_EraseRootFromParent_Done,
      // Label 4262: @196054
      GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(196117), // Rule ID 8955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8955,
        GIR_EraseRootFromParent_Done,
      // Label 4263: @196117
      GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(196180), // Rule ID 8958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8958,
        GIR_EraseRootFromParent_Done,
      // Label 4264: @196180
      GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(196243), // Rule ID 8959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8959,
        GIR_EraseRootFromParent_Done,
      // Label 4265: @196243
      GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(196306), // Rule ID 8962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8962,
        GIR_EraseRootFromParent_Done,
      // Label 4266: @196306
      GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(196369), // Rule ID 8963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8963,
        GIR_EraseRootFromParent_Done,
      // Label 4267: @196369
      GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(196432), // Rule ID 8966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8966,
        GIR_EraseRootFromParent_Done,
      // Label 4268: @196432
      GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(196495), // Rule ID 8967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8967,
        GIR_EraseRootFromParent_Done,
      // Label 4269: @196495
      GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(196558), // Rule ID 9058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9058,
        GIR_EraseRootFromParent_Done,
      // Label 4270: @196558
      GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(196621), // Rule ID 9059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9059,
        GIR_EraseRootFromParent_Done,
      // Label 4271: @196621
      GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(196684), // Rule ID 9062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9062,
        GIR_EraseRootFromParent_Done,
      // Label 4272: @196684
      GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(196747), // Rule ID 9063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9063,
        GIR_EraseRootFromParent_Done,
      // Label 4273: @196747
      GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(196810), // Rule ID 9066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9066,
        GIR_EraseRootFromParent_Done,
      // Label 4274: @196810
      GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(196873), // Rule ID 9067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9067,
        GIR_EraseRootFromParent_Done,
      // Label 4275: @196873
      GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(196936), // Rule ID 9070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9070,
        GIR_EraseRootFromParent_Done,
      // Label 4276: @196936
      GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(196999), // Rule ID 9071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9071,
        GIR_EraseRootFromParent_Done,
      // Label 4277: @196999
      GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(197062), // Rule ID 9074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9074,
        GIR_EraseRootFromParent_Done,
      // Label 4278: @197062
      GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(197125), // Rule ID 9075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9075,
        GIR_EraseRootFromParent_Done,
      // Label 4279: @197125
      GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(197188), // Rule ID 9078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9078,
        GIR_EraseRootFromParent_Done,
      // Label 4280: @197188
      GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(197251), // Rule ID 9079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9079,
        GIR_EraseRootFromParent_Done,
      // Label 4281: @197251
      GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(197314), // Rule ID 9082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9082,
        GIR_EraseRootFromParent_Done,
      // Label 4282: @197314
      GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(197377), // Rule ID 9083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9083,
        GIR_EraseRootFromParent_Done,
      // Label 4283: @197377
      GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(197440), // Rule ID 9086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9086,
        GIR_EraseRootFromParent_Done,
      // Label 4284: @197440
      GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(197503), // Rule ID 9087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9087,
        GIR_EraseRootFromParent_Done,
      // Label 4285: @197503
      GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(197566), // Rule ID 9090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9090,
        GIR_EraseRootFromParent_Done,
      // Label 4286: @197566
      GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(197629), // Rule ID 9091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9091,
        GIR_EraseRootFromParent_Done,
      // Label 4287: @197629
      GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(197692), // Rule ID 9094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9094,
        GIR_EraseRootFromParent_Done,
      // Label 4288: @197692
      GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(197755), // Rule ID 9095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9095,
        GIR_EraseRootFromParent_Done,
      // Label 4289: @197755
      GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(197818), // Rule ID 9098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9098,
        GIR_EraseRootFromParent_Done,
      // Label 4290: @197818
      GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(197881), // Rule ID 9099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9099,
        GIR_EraseRootFromParent_Done,
      // Label 4291: @197881
      GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(197944), // Rule ID 9102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9102,
        GIR_EraseRootFromParent_Done,
      // Label 4292: @197944
      GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(198007), // Rule ID 9103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9103,
        GIR_EraseRootFromParent_Done,
      // Label 4293: @198007
      GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(198070), // Rule ID 9106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9106,
        GIR_EraseRootFromParent_Done,
      // Label 4294: @198070
      GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(198133), // Rule ID 9107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9107,
        GIR_EraseRootFromParent_Done,
      // Label 4295: @198133
      GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(198196), // Rule ID 9110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9110,
        GIR_EraseRootFromParent_Done,
      // Label 4296: @198196
      GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(198259), // Rule ID 9111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9111,
        GIR_EraseRootFromParent_Done,
      // Label 4297: @198259
      GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(198322), // Rule ID 9114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9114,
        GIR_EraseRootFromParent_Done,
      // Label 4298: @198322
      GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(198385), // Rule ID 9115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9115,
        GIR_EraseRootFromParent_Done,
      // Label 4299: @198385
      GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(198448), // Rule ID 9118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9118,
        GIR_EraseRootFromParent_Done,
      // Label 4300: @198448
      GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(198511), // Rule ID 9119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9119,
        GIR_EraseRootFromParent_Done,
      // Label 4301: @198511
      GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(198574), // Rule ID 9122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9122,
        GIR_EraseRootFromParent_Done,
      // Label 4302: @198574
      GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(198637), // Rule ID 9123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9123,
        GIR_EraseRootFromParent_Done,
      // Label 4303: @198637
      GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(198700), // Rule ID 9126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9126,
        GIR_EraseRootFromParent_Done,
      // Label 4304: @198700
      GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(198763), // Rule ID 9127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9127,
        GIR_EraseRootFromParent_Done,
      // Label 4305: @198763
      GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(198826), // Rule ID 9130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9130,
        GIR_EraseRootFromParent_Done,
      // Label 4306: @198826
      GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(198889), // Rule ID 9131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9131,
        GIR_EraseRootFromParent_Done,
      // Label 4307: @198889
      GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(198952), // Rule ID 9134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9134,
        GIR_EraseRootFromParent_Done,
      // Label 4308: @198952
      GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(199015), // Rule ID 9135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9135,
        GIR_EraseRootFromParent_Done,
      // Label 4309: @199015
      GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(199078), // Rule ID 9138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9138,
        GIR_EraseRootFromParent_Done,
      // Label 4310: @199078
      GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(199141), // Rule ID 9139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9139,
        GIR_EraseRootFromParent_Done,
      // Label 4311: @199141
      GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(199204), // Rule ID 9142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9142,
        GIR_EraseRootFromParent_Done,
      // Label 4312: @199204
      GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(199267), // Rule ID 9143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9143,
        GIR_EraseRootFromParent_Done,
      // Label 4313: @199267
      GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(199330), // Rule ID 9234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9234,
        GIR_EraseRootFromParent_Done,
      // Label 4314: @199330
      GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(199393), // Rule ID 9235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9235,
        GIR_EraseRootFromParent_Done,
      // Label 4315: @199393
      GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(199456), // Rule ID 9238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9238,
        GIR_EraseRootFromParent_Done,
      // Label 4316: @199456
      GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(199519), // Rule ID 9239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9239,
        GIR_EraseRootFromParent_Done,
      // Label 4317: @199519
      GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(199582), // Rule ID 9242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9242,
        GIR_EraseRootFromParent_Done,
      // Label 4318: @199582
      GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(199645), // Rule ID 9243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9243,
        GIR_EraseRootFromParent_Done,
      // Label 4319: @199645
      GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(199708), // Rule ID 9246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9246,
        GIR_EraseRootFromParent_Done,
      // Label 4320: @199708
      GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(199771), // Rule ID 9247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9247,
        GIR_EraseRootFromParent_Done,
      // Label 4321: @199771
      GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(199834), // Rule ID 9250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9250,
        GIR_EraseRootFromParent_Done,
      // Label 4322: @199834
      GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(199897), // Rule ID 9251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9251,
        GIR_EraseRootFromParent_Done,
      // Label 4323: @199897
      GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(199960), // Rule ID 9254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9254,
        GIR_EraseRootFromParent_Done,
      // Label 4324: @199960
      GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(200023), // Rule ID 9255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9255,
        GIR_EraseRootFromParent_Done,
      // Label 4325: @200023
      GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(200086), // Rule ID 9258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9258,
        GIR_EraseRootFromParent_Done,
      // Label 4326: @200086
      GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(200149), // Rule ID 9259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9259,
        GIR_EraseRootFromParent_Done,
      // Label 4327: @200149
      GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(200212), // Rule ID 9262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9262,
        GIR_EraseRootFromParent_Done,
      // Label 4328: @200212
      GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(200275), // Rule ID 9263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9263,
        GIR_EraseRootFromParent_Done,
      // Label 4329: @200275
      GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(200338), // Rule ID 9266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9266,
        GIR_EraseRootFromParent_Done,
      // Label 4330: @200338
      GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(200401), // Rule ID 9267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9267,
        GIR_EraseRootFromParent_Done,
      // Label 4331: @200401
      GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(200464), // Rule ID 9270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9270,
        GIR_EraseRootFromParent_Done,
      // Label 4332: @200464
      GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(200527), // Rule ID 9271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9271,
        GIR_EraseRootFromParent_Done,
      // Label 4333: @200527
      GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(200590), // Rule ID 9274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9274,
        GIR_EraseRootFromParent_Done,
      // Label 4334: @200590
      GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(200653), // Rule ID 9275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9275,
        GIR_EraseRootFromParent_Done,
      // Label 4335: @200653
      GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(200716), // Rule ID 9278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9278,
        GIR_EraseRootFromParent_Done,
      // Label 4336: @200716
      GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(200779), // Rule ID 9279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9279,
        GIR_EraseRootFromParent_Done,
      // Label 4337: @200779
      GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(200842), // Rule ID 9282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9282,
        GIR_EraseRootFromParent_Done,
      // Label 4338: @200842
      GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(200905), // Rule ID 9283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9283,
        GIR_EraseRootFromParent_Done,
      // Label 4339: @200905
      GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(200968), // Rule ID 9286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9286,
        GIR_EraseRootFromParent_Done,
      // Label 4340: @200968
      GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(201031), // Rule ID 9287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9287,
        GIR_EraseRootFromParent_Done,
      // Label 4341: @201031
      GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(201094), // Rule ID 9290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9290,
        GIR_EraseRootFromParent_Done,
      // Label 4342: @201094
      GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(201157), // Rule ID 9291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9291,
        GIR_EraseRootFromParent_Done,
      // Label 4343: @201157
      GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(201220), // Rule ID 9294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9294,
        GIR_EraseRootFromParent_Done,
      // Label 4344: @201220
      GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(201283), // Rule ID 9295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9295,
        GIR_EraseRootFromParent_Done,
      // Label 4345: @201283
      GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(201346), // Rule ID 9298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9298,
        GIR_EraseRootFromParent_Done,
      // Label 4346: @201346
      GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(201409), // Rule ID 9299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9299,
        GIR_EraseRootFromParent_Done,
      // Label 4347: @201409
      GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(201472), // Rule ID 9302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9302,
        GIR_EraseRootFromParent_Done,
      // Label 4348: @201472
      GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(201535), // Rule ID 9303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9303,
        GIR_EraseRootFromParent_Done,
      // Label 4349: @201535
      GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(201598), // Rule ID 9306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9306,
        GIR_EraseRootFromParent_Done,
      // Label 4350: @201598
      GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(201661), // Rule ID 9307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9307,
        GIR_EraseRootFromParent_Done,
      // Label 4351: @201661
      GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(201724), // Rule ID 9310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9310,
        GIR_EraseRootFromParent_Done,
      // Label 4352: @201724
      GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(201787), // Rule ID 9311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9311,
        GIR_EraseRootFromParent_Done,
      // Label 4353: @201787
      GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(201850), // Rule ID 9314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9314,
        GIR_EraseRootFromParent_Done,
      // Label 4354: @201850
      GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(201913), // Rule ID 9315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9315,
        GIR_EraseRootFromParent_Done,
      // Label 4355: @201913
      GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(201976), // Rule ID 9318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9318,
        GIR_EraseRootFromParent_Done,
      // Label 4356: @201976
      GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(202039), // Rule ID 9319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9319,
        GIR_EraseRootFromParent_Done,
      // Label 4357: @202039
      GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(202102), // Rule ID 9410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9410,
        GIR_EraseRootFromParent_Done,
      // Label 4358: @202102
      GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(202165), // Rule ID 9411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9411,
        GIR_EraseRootFromParent_Done,
      // Label 4359: @202165
      GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(202228), // Rule ID 9414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9414,
        GIR_EraseRootFromParent_Done,
      // Label 4360: @202228
      GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(202291), // Rule ID 9415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9415,
        GIR_EraseRootFromParent_Done,
      // Label 4361: @202291
      GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(202354), // Rule ID 9418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9418,
        GIR_EraseRootFromParent_Done,
      // Label 4362: @202354
      GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(202417), // Rule ID 9419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9419,
        GIR_EraseRootFromParent_Done,
      // Label 4363: @202417
      GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(202480), // Rule ID 9422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9422,
        GIR_EraseRootFromParent_Done,
      // Label 4364: @202480
      GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(202543), // Rule ID 9423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9423,
        GIR_EraseRootFromParent_Done,
      // Label 4365: @202543
      GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(202606), // Rule ID 9426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9426,
        GIR_EraseRootFromParent_Done,
      // Label 4366: @202606
      GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(202669), // Rule ID 9427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9427,
        GIR_EraseRootFromParent_Done,
      // Label 4367: @202669
      GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(202732), // Rule ID 9430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9430,
        GIR_EraseRootFromParent_Done,
      // Label 4368: @202732
      GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(202795), // Rule ID 9431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9431,
        GIR_EraseRootFromParent_Done,
      // Label 4369: @202795
      GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(202858), // Rule ID 9434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9434,
        GIR_EraseRootFromParent_Done,
      // Label 4370: @202858
      GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(202921), // Rule ID 9435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9435,
        GIR_EraseRootFromParent_Done,
      // Label 4371: @202921
      GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(202984), // Rule ID 9438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9438,
        GIR_EraseRootFromParent_Done,
      // Label 4372: @202984
      GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(203047), // Rule ID 9439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9439,
        GIR_EraseRootFromParent_Done,
      // Label 4373: @203047
      GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(203110), // Rule ID 9442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9442,
        GIR_EraseRootFromParent_Done,
      // Label 4374: @203110
      GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(203173), // Rule ID 9443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9443,
        GIR_EraseRootFromParent_Done,
      // Label 4375: @203173
      GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(203236), // Rule ID 9446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9446,
        GIR_EraseRootFromParent_Done,
      // Label 4376: @203236
      GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(203299), // Rule ID 9447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9447,
        GIR_EraseRootFromParent_Done,
      // Label 4377: @203299
      GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(203362), // Rule ID 9450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9450,
        GIR_EraseRootFromParent_Done,
      // Label 4378: @203362
      GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(203425), // Rule ID 9451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9451,
        GIR_EraseRootFromParent_Done,
      // Label 4379: @203425
      GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(203488), // Rule ID 9454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9454,
        GIR_EraseRootFromParent_Done,
      // Label 4380: @203488
      GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(203551), // Rule ID 9455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9455,
        GIR_EraseRootFromParent_Done,
      // Label 4381: @203551
      GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(203614), // Rule ID 9458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9458,
        GIR_EraseRootFromParent_Done,
      // Label 4382: @203614
      GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(203677), // Rule ID 9459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9459,
        GIR_EraseRootFromParent_Done,
      // Label 4383: @203677
      GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(203740), // Rule ID 9462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9462,
        GIR_EraseRootFromParent_Done,
      // Label 4384: @203740
      GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(203803), // Rule ID 9463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9463,
        GIR_EraseRootFromParent_Done,
      // Label 4385: @203803
      GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(203866), // Rule ID 9466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9466,
        GIR_EraseRootFromParent_Done,
      // Label 4386: @203866
      GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(203929), // Rule ID 9467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9467,
        GIR_EraseRootFromParent_Done,
      // Label 4387: @203929
      GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(203992), // Rule ID 9470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9470,
        GIR_EraseRootFromParent_Done,
      // Label 4388: @203992
      GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(204055), // Rule ID 9471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9471,
        GIR_EraseRootFromParent_Done,
      // Label 4389: @204055
      GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(204118), // Rule ID 9474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9474,
        GIR_EraseRootFromParent_Done,
      // Label 4390: @204118
      GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(204181), // Rule ID 9475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9475,
        GIR_EraseRootFromParent_Done,
      // Label 4391: @204181
      GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(204244), // Rule ID 9478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9478,
        GIR_EraseRootFromParent_Done,
      // Label 4392: @204244
      GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(204307), // Rule ID 9479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9479,
        GIR_EraseRootFromParent_Done,
      // Label 4393: @204307
      GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(204370), // Rule ID 9482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9482,
        GIR_EraseRootFromParent_Done,
      // Label 4394: @204370
      GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(204433), // Rule ID 9483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9483,
        GIR_EraseRootFromParent_Done,
      // Label 4395: @204433
      GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(204496), // Rule ID 9486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9486,
        GIR_EraseRootFromParent_Done,
      // Label 4396: @204496
      GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(204559), // Rule ID 9487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9487,
        GIR_EraseRootFromParent_Done,
      // Label 4397: @204559
      GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(204622), // Rule ID 9490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9490,
        GIR_EraseRootFromParent_Done,
      // Label 4398: @204622
      GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(204685), // Rule ID 9491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9491,
        GIR_EraseRootFromParent_Done,
      // Label 4399: @204685
      GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(204748), // Rule ID 9494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9494,
        GIR_EraseRootFromParent_Done,
      // Label 4400: @204748
      GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(204811), // Rule ID 9495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9495,
        GIR_EraseRootFromParent_Done,
      // Label 4401: @204811
      GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(204874), // Rule ID 9498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9498,
        GIR_EraseRootFromParent_Done,
      // Label 4402: @204874
      GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(204937), // Rule ID 9499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9499,
        GIR_EraseRootFromParent_Done,
      // Label 4403: @204937
      GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(205000), // Rule ID 9502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9502,
        GIR_EraseRootFromParent_Done,
      // Label 4404: @205000
      GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(205063), // Rule ID 9503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9503,
        GIR_EraseRootFromParent_Done,
      // Label 4405: @205063
      GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(205126), // Rule ID 9506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9506,
        GIR_EraseRootFromParent_Done,
      // Label 4406: @205126
      GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(205189), // Rule ID 9507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9507,
        GIR_EraseRootFromParent_Done,
      // Label 4407: @205189
      GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(205252), // Rule ID 9510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9510,
        GIR_EraseRootFromParent_Done,
      // Label 4408: @205252
      GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(205315), // Rule ID 9511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9511,
        GIR_EraseRootFromParent_Done,
      // Label 4409: @205315
      GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(205378), // Rule ID 9514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9514,
        GIR_EraseRootFromParent_Done,
      // Label 4410: @205378
      GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(205441), // Rule ID 9515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9515,
        GIR_EraseRootFromParent_Done,
      // Label 4411: @205441
      GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(205504), // Rule ID 9518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9518,
        GIR_EraseRootFromParent_Done,
      // Label 4412: @205504
      GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(205567), // Rule ID 9519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9519,
        GIR_EraseRootFromParent_Done,
      // Label 4413: @205567
      GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(205630), // Rule ID 9522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9522,
        GIR_EraseRootFromParent_Done,
      // Label 4414: @205630
      GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(205693), // Rule ID 9523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9523,
        GIR_EraseRootFromParent_Done,
      // Label 4415: @205693
      GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(205756), // Rule ID 9526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9526,
        GIR_EraseRootFromParent_Done,
      // Label 4416: @205756
      GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(205819), // Rule ID 9527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9527,
        GIR_EraseRootFromParent_Done,
      // Label 4417: @205819
      GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(205882), // Rule ID 9530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9530,
        GIR_EraseRootFromParent_Done,
      // Label 4418: @205882
      GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(205945), // Rule ID 9531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9531,
        GIR_EraseRootFromParent_Done,
      // Label 4419: @205945
      GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(206008), // Rule ID 9534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9534,
        GIR_EraseRootFromParent_Done,
      // Label 4420: @206008
      GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(206071), // Rule ID 9535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9535,
        GIR_EraseRootFromParent_Done,
      // Label 4421: @206071
      GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(206134), // Rule ID 9538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9538,
        GIR_EraseRootFromParent_Done,
      // Label 4422: @206134
      GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(206197), // Rule ID 9539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9539,
        GIR_EraseRootFromParent_Done,
      // Label 4423: @206197
      GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(206260), // Rule ID 9542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9542,
        GIR_EraseRootFromParent_Done,
      // Label 4424: @206260
      GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(206323), // Rule ID 9543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9543,
        GIR_EraseRootFromParent_Done,
      // Label 4425: @206323
      GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(206386), // Rule ID 9546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9546,
        GIR_EraseRootFromParent_Done,
      // Label 4426: @206386
      GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(206449), // Rule ID 9547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9547,
        GIR_EraseRootFromParent_Done,
      // Label 4427: @206449
      GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(206512), // Rule ID 9550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9550,
        GIR_EraseRootFromParent_Done,
      // Label 4428: @206512
      GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(206575), // Rule ID 9551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9551,
        GIR_EraseRootFromParent_Done,
      // Label 4429: @206575
      GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(206638), // Rule ID 9554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9554,
        GIR_EraseRootFromParent_Done,
      // Label 4430: @206638
      GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(206701), // Rule ID 9555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9555,
        GIR_EraseRootFromParent_Done,
      // Label 4431: @206701
      GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(206764), // Rule ID 9558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9558,
        GIR_EraseRootFromParent_Done,
      // Label 4432: @206764
      GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(206827), // Rule ID 9559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9559,
        GIR_EraseRootFromParent_Done,
      // Label 4433: @206827
      GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(206890), // Rule ID 9562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9562,
        GIR_EraseRootFromParent_Done,
      // Label 4434: @206890
      GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(206953), // Rule ID 9563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9563,
        GIR_EraseRootFromParent_Done,
      // Label 4435: @206953
      GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(207016), // Rule ID 9566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9566,
        GIR_EraseRootFromParent_Done,
      // Label 4436: @207016
      GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(207079), // Rule ID 9567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9567,
        GIR_EraseRootFromParent_Done,
      // Label 4437: @207079
      GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(207142), // Rule ID 9570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9570,
        GIR_EraseRootFromParent_Done,
      // Label 4438: @207142
      GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(207205), // Rule ID 9571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9571,
        GIR_EraseRootFromParent_Done,
      // Label 4439: @207205
      GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(207268), // Rule ID 9574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9574,
        GIR_EraseRootFromParent_Done,
      // Label 4440: @207268
      GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(207331), // Rule ID 9575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9575,
        GIR_EraseRootFromParent_Done,
      // Label 4441: @207331
      GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(207394), // Rule ID 9578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9578,
        GIR_EraseRootFromParent_Done,
      // Label 4442: @207394
      GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(207457), // Rule ID 9579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9579,
        GIR_EraseRootFromParent_Done,
      // Label 4443: @207457
      GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(207520), // Rule ID 9582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9582,
        GIR_EraseRootFromParent_Done,
      // Label 4444: @207520
      GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(207583), // Rule ID 9583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9583,
        GIR_EraseRootFromParent_Done,
      // Label 4445: @207583
      GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(207646), // Rule ID 9586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9586,
        GIR_EraseRootFromParent_Done,
      // Label 4446: @207646
      GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(207709), // Rule ID 9587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9587,
        GIR_EraseRootFromParent_Done,
      // Label 4447: @207709
      GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(207772), // Rule ID 9590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9590,
        GIR_EraseRootFromParent_Done,
      // Label 4448: @207772
      GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(207835), // Rule ID 9591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9591,
        GIR_EraseRootFromParent_Done,
      // Label 4449: @207835
      GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(207898), // Rule ID 9594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9594,
        GIR_EraseRootFromParent_Done,
      // Label 4450: @207898
      GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(207961), // Rule ID 9595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9595,
        GIR_EraseRootFromParent_Done,
      // Label 4451: @207961
      GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(208024), // Rule ID 9598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9598,
        GIR_EraseRootFromParent_Done,
      // Label 4452: @208024
      GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(208087), // Rule ID 9599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9599,
        GIR_EraseRootFromParent_Done,
      // Label 4453: @208087
      GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(208150), // Rule ID 9602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9602,
        GIR_EraseRootFromParent_Done,
      // Label 4454: @208150
      GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(208213), // Rule ID 9603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9603,
        GIR_EraseRootFromParent_Done,
      // Label 4455: @208213
      GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(208276), // Rule ID 9606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9606,
        GIR_EraseRootFromParent_Done,
      // Label 4456: @208276
      GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(208339), // Rule ID 9607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9607,
        GIR_EraseRootFromParent_Done,
      // Label 4457: @208339
      GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(208402), // Rule ID 9610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9610,
        GIR_EraseRootFromParent_Done,
      // Label 4458: @208402
      GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(208465), // Rule ID 9611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9611,
        GIR_EraseRootFromParent_Done,
      // Label 4459: @208465
      GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(208528), // Rule ID 9614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9614,
        GIR_EraseRootFromParent_Done,
      // Label 4460: @208528
      GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(208591), // Rule ID 9615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9615,
        GIR_EraseRootFromParent_Done,
      // Label 4461: @208591
      GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(208654), // Rule ID 9618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9618,
        GIR_EraseRootFromParent_Done,
      // Label 4462: @208654
      GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(208717), // Rule ID 9619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11056:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9619,
        GIR_EraseRootFromParent_Done,
      // Label 4463: @208717
      GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(208780), // Rule ID 9622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11056:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9622,
        GIR_EraseRootFromParent_Done,
      // Label 4464: @208780
      GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(208843), // Rule ID 9623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11056:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9623,
        GIR_EraseRootFromParent_Done,
      // Label 4465: @208843
      GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(208906), // Rule ID 9626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11056:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9626,
        GIR_EraseRootFromParent_Done,
      // Label 4466: @208906
      GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(208969), // Rule ID 9627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11056:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9627,
        GIR_EraseRootFromParent_Done,
      // Label 4467: @208969
      GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(209032), // Rule ID 9630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11056:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9630,
        GIR_EraseRootFromParent_Done,
      // Label 4468: @209032
      GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(209095), // Rule ID 9631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11056:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9631,
        GIR_EraseRootFromParent_Done,
      // Label 4469: @209095
      GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(209158), // Rule ID 9634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11056:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9634,
        GIR_EraseRootFromParent_Done,
      // Label 4470: @209158
      GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(209221), // Rule ID 9635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11056:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9635,
        GIR_EraseRootFromParent_Done,
      // Label 4471: @209221
      GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(209284), // Rule ID 9638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11056:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9638,
        GIR_EraseRootFromParent_Done,
      // Label 4472: @209284
      GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(209347), // Rule ID 9639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11056:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9639,
        GIR_EraseRootFromParent_Done,
      // Label 4473: @209347
      GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(209410), // Rule ID 9642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11056:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9642,
        GIR_EraseRootFromParent_Done,
      // Label 4474: @209410
      GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(209473), // Rule ID 9643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11056:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9643,
        GIR_EraseRootFromParent_Done,
      // Label 4475: @209473
      GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(209536), // Rule ID 9646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11056:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9646,
        GIR_EraseRootFromParent_Done,
      // Label 4476: @209536
      GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(209599), // Rule ID 9647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11056:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9647,
        GIR_EraseRootFromParent_Done,
      // Label 4477: @209599
      GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(209662), // Rule ID 9650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11056:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9650,
        GIR_EraseRootFromParent_Done,
      // Label 4478: @209662
      GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(209725), // Rule ID 9651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11056:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9651,
        GIR_EraseRootFromParent_Done,
      // Label 4479: @209725
      GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(209788), // Rule ID 9654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11056:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9654,
        GIR_EraseRootFromParent_Done,
      // Label 4480: @209788
      GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(209851), // Rule ID 9655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11056:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9655,
        GIR_EraseRootFromParent_Done,
      // Label 4481: @209851
      GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(209914), // Rule ID 9658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11056:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9658,
        GIR_EraseRootFromParent_Done,
      // Label 4482: @209914
      GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(209977), // Rule ID 9659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11056:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9659,
        GIR_EraseRootFromParent_Done,
      // Label 4483: @209977
      GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(210040), // Rule ID 9662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11056:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9662,
        GIR_EraseRootFromParent_Done,
      // Label 4484: @210040
      GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(210103), // Rule ID 9663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11056:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9663,
        GIR_EraseRootFromParent_Done,
      // Label 4485: @210103
      GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(210166), // Rule ID 9666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11056:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9666,
        GIR_EraseRootFromParent_Done,
      // Label 4486: @210166
      GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(210229), // Rule ID 9667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11056:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9667,
        GIR_EraseRootFromParent_Done,
      // Label 4487: @210229
      GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(210292), // Rule ID 9670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9670,
        GIR_EraseRootFromParent_Done,
      // Label 4488: @210292
      GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(210355), // Rule ID 9671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9671,
        GIR_EraseRootFromParent_Done,
      // Label 4489: @210355
      GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(210418), // Rule ID 9674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9674,
        GIR_EraseRootFromParent_Done,
      // Label 4490: @210418
      GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(210481), // Rule ID 9675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9675,
        GIR_EraseRootFromParent_Done,
      // Label 4491: @210481
      GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(210544), // Rule ID 9678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9678,
        GIR_EraseRootFromParent_Done,
      // Label 4492: @210544
      GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(210607), // Rule ID 9679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9679,
        GIR_EraseRootFromParent_Done,
      // Label 4493: @210607
      GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(210670), // Rule ID 9682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9682,
        GIR_EraseRootFromParent_Done,
      // Label 4494: @210670
      GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(210733), // Rule ID 9683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9683,
        GIR_EraseRootFromParent_Done,
      // Label 4495: @210733
      GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(210796), // Rule ID 9686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9686,
        GIR_EraseRootFromParent_Done,
      // Label 4496: @210796
      GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(210859), // Rule ID 9687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9687,
        GIR_EraseRootFromParent_Done,
      // Label 4497: @210859
      GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(210922), // Rule ID 9690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9690,
        GIR_EraseRootFromParent_Done,
      // Label 4498: @210922
      GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(210985), // Rule ID 9691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9691,
        GIR_EraseRootFromParent_Done,
      // Label 4499: @210985
      GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(211048), // Rule ID 9694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9694,
        GIR_EraseRootFromParent_Done,
      // Label 4500: @211048
      GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(211111), // Rule ID 9695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9695,
        GIR_EraseRootFromParent_Done,
      // Label 4501: @211111
      GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(211174), // Rule ID 9698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9698,
        GIR_EraseRootFromParent_Done,
      // Label 4502: @211174
      GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(211237), // Rule ID 9699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9699,
        GIR_EraseRootFromParent_Done,
      // Label 4503: @211237
      GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(211300), // Rule ID 9702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9702,
        GIR_EraseRootFromParent_Done,
      // Label 4504: @211300
      GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(211363), // Rule ID 9703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9703,
        GIR_EraseRootFromParent_Done,
      // Label 4505: @211363
      GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(211426), // Rule ID 9706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9706,
        GIR_EraseRootFromParent_Done,
      // Label 4506: @211426
      GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(211489), // Rule ID 9707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11054:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9707,
        GIR_EraseRootFromParent_Done,
      // Label 4507: @211489
      GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(211552), // Rule ID 9710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11054:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9710,
        GIR_EraseRootFromParent_Done,
      // Label 4508: @211552
      GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(211615), // Rule ID 9711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11054:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9711,
        GIR_EraseRootFromParent_Done,
      // Label 4509: @211615
      GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(211678), // Rule ID 9714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11054:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9714,
        GIR_EraseRootFromParent_Done,
      // Label 4510: @211678
      GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(211741), // Rule ID 9715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11054:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9715,
        GIR_EraseRootFromParent_Done,
      // Label 4511: @211741
      GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(211804), // Rule ID 9718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11054:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9718,
        GIR_EraseRootFromParent_Done,
      // Label 4512: @211804
      GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(211867), // Rule ID 9719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11054:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9719,
        GIR_EraseRootFromParent_Done,
      // Label 4513: @211867
      GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(211930), // Rule ID 9722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11054:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9722,
        GIR_EraseRootFromParent_Done,
      // Label 4514: @211930
      GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(211993), // Rule ID 9723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11054:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9723,
        GIR_EraseRootFromParent_Done,
      // Label 4515: @211993
      GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(212056), // Rule ID 9726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11054:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9726,
        GIR_EraseRootFromParent_Done,
      // Label 4516: @212056
      GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(212119), // Rule ID 9727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11054:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9727,
        GIR_EraseRootFromParent_Done,
      // Label 4517: @212119
      GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(212182), // Rule ID 9730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11054:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9730,
        GIR_EraseRootFromParent_Done,
      // Label 4518: @212182
      GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(212245), // Rule ID 9731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11054:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9731,
        GIR_EraseRootFromParent_Done,
      // Label 4519: @212245
      GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(212308), // Rule ID 9734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11054:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9734,
        GIR_EraseRootFromParent_Done,
      // Label 4520: @212308
      GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(212371), // Rule ID 9735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11054:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9735,
        GIR_EraseRootFromParent_Done,
      // Label 4521: @212371
      GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(212434), // Rule ID 9738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11054:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9738,
        GIR_EraseRootFromParent_Done,
      // Label 4522: @212434
      GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(212497), // Rule ID 9739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11054:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9739,
        GIR_EraseRootFromParent_Done,
      // Label 4523: @212497
      GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(212560), // Rule ID 9742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11054:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9742,
        GIR_EraseRootFromParent_Done,
      // Label 4524: @212560
      GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(212623), // Rule ID 9743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11054:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9743,
        GIR_EraseRootFromParent_Done,
      // Label 4525: @212623
      GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(212686), // Rule ID 9746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11054:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9746,
        GIR_EraseRootFromParent_Done,
      // Label 4526: @212686
      GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(212749), // Rule ID 9747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11054:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9747,
        GIR_EraseRootFromParent_Done,
      // Label 4527: @212749
      GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(212812), // Rule ID 9750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11054:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9750,
        GIR_EraseRootFromParent_Done,
      // Label 4528: @212812
      GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(212875), // Rule ID 9751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11054:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9751,
        GIR_EraseRootFromParent_Done,
      // Label 4529: @212875
      GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(212938), // Rule ID 9754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11054:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9754,
        GIR_EraseRootFromParent_Done,
      // Label 4530: @212938
      GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(213001), // Rule ID 9755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11054:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9755,
        GIR_EraseRootFromParent_Done,
      // Label 4531: @213001
      GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(213067), // Rule ID 13830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13830,
        GIR_EraseRootFromParent_Done,
      // Label 4532: @213067
      GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(213133), // Rule ID 13831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13831,
        GIR_EraseRootFromParent_Done,
      // Label 4533: @213133
      GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(213199), // Rule ID 13832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13832,
        GIR_EraseRootFromParent_Done,
      // Label 4534: @213199
      GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(213265), // Rule ID 13833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13833,
        GIR_EraseRootFromParent_Done,
      // Label 4535: @213265
      GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(213331), // Rule ID 13834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13834,
        GIR_EraseRootFromParent_Done,
      // Label 4536: @213331
      GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(213397), // Rule ID 13835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13835,
        GIR_EraseRootFromParent_Done,
      // Label 4537: @213397
      GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(213463), // Rule ID 13836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13836,
        GIR_EraseRootFromParent_Done,
      // Label 4538: @213463
      GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(213529), // Rule ID 13837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13837,
        GIR_EraseRootFromParent_Done,
      // Label 4539: @213529
      GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(213595), // Rule ID 13838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13838,
        GIR_EraseRootFromParent_Done,
      // Label 4540: @213595
      GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(213661), // Rule ID 13839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13839,
        GIR_EraseRootFromParent_Done,
      // Label 4541: @213661
      GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(213727), // Rule ID 13840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13840,
        GIR_EraseRootFromParent_Done,
      // Label 4542: @213727
      GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(213793), // Rule ID 13841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13841,
        GIR_EraseRootFromParent_Done,
      // Label 4543: @213793
      GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(213859), // Rule ID 13842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11085:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13842,
        GIR_EraseRootFromParent_Done,
      // Label 4544: @213859
      GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(213925), // Rule ID 13843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11085:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13843,
        GIR_EraseRootFromParent_Done,
      // Label 4545: @213925
      GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(213991), // Rule ID 13844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13844,
        GIR_EraseRootFromParent_Done,
      // Label 4546: @213991
      GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(214057), // Rule ID 13845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13845,
        GIR_EraseRootFromParent_Done,
      // Label 4547: @214057
      GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(214123), // Rule ID 13846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13846,
        GIR_EraseRootFromParent_Done,
      // Label 4548: @214123
      GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(214189), // Rule ID 13847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13847,
        GIR_EraseRootFromParent_Done,
      // Label 4549: @214189
      GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(214255), // Rule ID 13848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13848,
        GIR_EraseRootFromParent_Done,
      // Label 4550: @214255
      GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(214321), // Rule ID 13849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13849,
        GIR_EraseRootFromParent_Done,
      // Label 4551: @214321
      GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(214387), // Rule ID 13850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13850,
        GIR_EraseRootFromParent_Done,
      // Label 4552: @214387
      GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(214453), // Rule ID 13851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13851,
        GIR_EraseRootFromParent_Done,
      // Label 4553: @214453
      GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(214519), // Rule ID 13852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13852,
        GIR_EraseRootFromParent_Done,
      // Label 4554: @214519
      GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(214585), // Rule ID 13853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13853,
        GIR_EraseRootFromParent_Done,
      // Label 4555: @214585
      GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(214651), // Rule ID 13854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13854,
        GIR_EraseRootFromParent_Done,
      // Label 4556: @214651
      GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(214717), // Rule ID 13855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13855,
        GIR_EraseRootFromParent_Done,
      // Label 4557: @214717
      GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(214783), // Rule ID 13856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13856,
        GIR_EraseRootFromParent_Done,
      // Label 4558: @214783
      GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(214849), // Rule ID 13857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13857,
        GIR_EraseRootFromParent_Done,
      // Label 4559: @214849
      GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(214915), // Rule ID 13858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13858,
        GIR_EraseRootFromParent_Done,
      // Label 4560: @214915
      GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(214981), // Rule ID 13859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13859,
        GIR_EraseRootFromParent_Done,
      // Label 4561: @214981
      GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(215047), // Rule ID 13860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13860,
        GIR_EraseRootFromParent_Done,
      // Label 4562: @215047
      GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(215113), // Rule ID 13861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13861,
        GIR_EraseRootFromParent_Done,
      // Label 4563: @215113
      GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(215179), // Rule ID 13862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13862,
        GIR_EraseRootFromParent_Done,
      // Label 4564: @215179
      GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(215245), // Rule ID 13863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13863,
        GIR_EraseRootFromParent_Done,
      // Label 4565: @215245
      GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(215311), // Rule ID 13864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13864,
        GIR_EraseRootFromParent_Done,
      // Label 4566: @215311
      GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(215377), // Rule ID 13865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13865,
        GIR_EraseRootFromParent_Done,
      // Label 4567: @215377
      GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(215443), // Rule ID 13866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13866,
        GIR_EraseRootFromParent_Done,
      // Label 4568: @215443
      GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(215509), // Rule ID 13867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13867,
        GIR_EraseRootFromParent_Done,
      // Label 4569: @215509
      GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(215575), // Rule ID 13868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13868,
        GIR_EraseRootFromParent_Done,
      // Label 4570: @215575
      GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(215641), // Rule ID 13869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13869,
        GIR_EraseRootFromParent_Done,
      // Label 4571: @215641
      GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(215707), // Rule ID 13870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13870,
        GIR_EraseRootFromParent_Done,
      // Label 4572: @215707
      GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(215773), // Rule ID 13871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13871,
        GIR_EraseRootFromParent_Done,
      // Label 4573: @215773
      GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(215839), // Rule ID 13872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13872,
        GIR_EraseRootFromParent_Done,
      // Label 4574: @215839
      GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(215905), // Rule ID 13873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13873,
        GIR_EraseRootFromParent_Done,
      // Label 4575: @215905
      GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(215971), // Rule ID 13874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13874,
        GIR_EraseRootFromParent_Done,
      // Label 4576: @215971
      GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(216037), // Rule ID 13875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13875,
        GIR_EraseRootFromParent_Done,
      // Label 4577: @216037
      GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(216103), // Rule ID 13876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13876,
        GIR_EraseRootFromParent_Done,
      // Label 4578: @216103
      GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(216169), // Rule ID 13877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13877,
        GIR_EraseRootFromParent_Done,
      // Label 4579: @216169
      GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(216235), // Rule ID 13878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13878,
        GIR_EraseRootFromParent_Done,
      // Label 4580: @216235
      GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(216301), // Rule ID 13879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13879,
        GIR_EraseRootFromParent_Done,
      // Label 4581: @216301
      GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(216367), // Rule ID 13880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13880,
        GIR_EraseRootFromParent_Done,
      // Label 4582: @216367
      GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(216433), // Rule ID 13881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13881,
        GIR_EraseRootFromParent_Done,
      // Label 4583: @216433
      GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(216499), // Rule ID 13882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13882,
        GIR_EraseRootFromParent_Done,
      // Label 4584: @216499
      GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(216565), // Rule ID 13883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13883,
        GIR_EraseRootFromParent_Done,
      // Label 4585: @216565
      GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(216631), // Rule ID 13884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13884,
        GIR_EraseRootFromParent_Done,
      // Label 4586: @216631
      GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(216697), // Rule ID 13885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13885,
        GIR_EraseRootFromParent_Done,
      // Label 4587: @216697
      GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(216763), // Rule ID 13886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13886,
        GIR_EraseRootFromParent_Done,
      // Label 4588: @216763
      GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(216829), // Rule ID 13887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13887,
        GIR_EraseRootFromParent_Done,
      // Label 4589: @216829
      GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(216895), // Rule ID 13888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13888,
        GIR_EraseRootFromParent_Done,
      // Label 4590: @216895
      GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(216961), // Rule ID 13889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13889,
        GIR_EraseRootFromParent_Done,
      // Label 4591: @216961
      GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(217027), // Rule ID 13890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13890,
        GIR_EraseRootFromParent_Done,
      // Label 4592: @217027
      GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(217093), // Rule ID 13891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13891,
        GIR_EraseRootFromParent_Done,
      // Label 4593: @217093
      GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(217159), // Rule ID 13892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13892,
        GIR_EraseRootFromParent_Done,
      // Label 4594: @217159
      GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(217225), // Rule ID 13893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13893,
        GIR_EraseRootFromParent_Done,
      // Label 4595: @217225
      GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(217291), // Rule ID 13894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13894,
        GIR_EraseRootFromParent_Done,
      // Label 4596: @217291
      GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(217357), // Rule ID 13895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13895,
        GIR_EraseRootFromParent_Done,
      // Label 4597: @217357
      GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(217423), // Rule ID 13896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13896,
        GIR_EraseRootFromParent_Done,
      // Label 4598: @217423
      GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(217489), // Rule ID 13897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13897,
        GIR_EraseRootFromParent_Done,
      // Label 4599: @217489
      GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(217555), // Rule ID 13898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13898,
        GIR_EraseRootFromParent_Done,
      // Label 4600: @217555
      GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(217621), // Rule ID 13899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13899,
        GIR_EraseRootFromParent_Done,
      // Label 4601: @217621
      GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(217687), // Rule ID 13900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13900,
        GIR_EraseRootFromParent_Done,
      // Label 4602: @217687
      GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(217753), // Rule ID 13901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13901,
        GIR_EraseRootFromParent_Done,
      // Label 4603: @217753
      GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(217819), // Rule ID 13902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13902,
        GIR_EraseRootFromParent_Done,
      // Label 4604: @217819
      GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(217885), // Rule ID 13903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13903,
        GIR_EraseRootFromParent_Done,
      // Label 4605: @217885
      GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(217951), // Rule ID 18906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18906,
        GIR_EraseRootFromParent_Done,
      // Label 4606: @217951
      GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(218017), // Rule ID 18907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18907,
        GIR_EraseRootFromParent_Done,
      // Label 4607: @218017
      GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(218083), // Rule ID 18910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18910,
        GIR_EraseRootFromParent_Done,
      // Label 4608: @218083
      GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(218149), // Rule ID 18911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18911,
        GIR_EraseRootFromParent_Done,
      // Label 4609: @218149
      GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(218215), // Rule ID 18914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18914,
        GIR_EraseRootFromParent_Done,
      // Label 4610: @218215
      GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(218281), // Rule ID 18915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10868:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18915,
        GIR_EraseRootFromParent_Done,
      // Label 4611: @218281
      GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(218347), // Rule ID 18918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18918,
        GIR_EraseRootFromParent_Done,
      // Label 4612: @218347
      GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(218413), // Rule ID 18919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10868:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18919,
        GIR_EraseRootFromParent_Done,
      // Label 4613: @218413
      GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(218479), // Rule ID 18922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18922,
        GIR_EraseRootFromParent_Done,
      // Label 4614: @218479
      GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(218545), // Rule ID 18923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10868:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18923,
        GIR_EraseRootFromParent_Done,
      // Label 4615: @218545
      GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(218611), // Rule ID 18926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18926,
        GIR_EraseRootFromParent_Done,
      // Label 4616: @218611
      GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(218677), // Rule ID 18927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18927,
        GIR_EraseRootFromParent_Done,
      // Label 4617: @218677
      GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(218743), // Rule ID 18930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18930,
        GIR_EraseRootFromParent_Done,
      // Label 4618: @218743
      GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(218809), // Rule ID 18931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18931,
        GIR_EraseRootFromParent_Done,
      // Label 4619: @218809
      GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(218875), // Rule ID 18934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18934,
        GIR_EraseRootFromParent_Done,
      // Label 4620: @218875
      GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(218941), // Rule ID 18935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18935,
        GIR_EraseRootFromParent_Done,
      // Label 4621: @218941
      GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(219007), // Rule ID 18938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18938,
        GIR_EraseRootFromParent_Done,
      // Label 4622: @219007
      GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(219073), // Rule ID 18939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18939,
        GIR_EraseRootFromParent_Done,
      // Label 4623: @219073
      GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(219139), // Rule ID 18942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18942,
        GIR_EraseRootFromParent_Done,
      // Label 4624: @219139
      GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(219205), // Rule ID 18943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18943,
        GIR_EraseRootFromParent_Done,
      // Label 4625: @219205
      GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(219271), // Rule ID 18946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18946,
        GIR_EraseRootFromParent_Done,
      // Label 4626: @219271
      GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(219337), // Rule ID 18947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18947,
        GIR_EraseRootFromParent_Done,
      // Label 4627: @219337
      GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(219403), // Rule ID 18950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18950,
        GIR_EraseRootFromParent_Done,
      // Label 4628: @219403
      GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(219469), // Rule ID 18951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10868:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18951,
        GIR_EraseRootFromParent_Done,
      // Label 4629: @219469
      GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(219535), // Rule ID 18954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18954,
        GIR_EraseRootFromParent_Done,
      // Label 4630: @219535
      GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(219601), // Rule ID 18955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10868:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18955,
        GIR_EraseRootFromParent_Done,
      // Label 4631: @219601
      GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(219667), // Rule ID 18958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18958,
        GIR_EraseRootFromParent_Done,
      // Label 4632: @219667
      GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(219733), // Rule ID 18959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10868:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18959,
        GIR_EraseRootFromParent_Done,
      // Label 4633: @219733
      GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(219796), // Rule ID 19622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19622,
        GIR_EraseRootFromParent_Done,
      // Label 4634: @219796
      GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(219859), // Rule ID 19623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19623,
        GIR_EraseRootFromParent_Done,
      // Label 4635: @219859
      GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(219922), // Rule ID 19626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19626,
        GIR_EraseRootFromParent_Done,
      // Label 4636: @219922
      GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(219985), // Rule ID 19627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19627,
        GIR_EraseRootFromParent_Done,
      // Label 4637: @219985
      GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(220048), // Rule ID 19630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19630,
        GIR_EraseRootFromParent_Done,
      // Label 4638: @220048
      GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(220111), // Rule ID 19631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19631,
        GIR_EraseRootFromParent_Done,
      // Label 4639: @220111
      GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(220174), // Rule ID 19634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19634,
        GIR_EraseRootFromParent_Done,
      // Label 4640: @220174
      GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(220237), // Rule ID 19635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19635,
        GIR_EraseRootFromParent_Done,
      // Label 4641: @220237
      GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(220300), // Rule ID 19638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19638,
        GIR_EraseRootFromParent_Done,
      // Label 4642: @220300
      GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(220363), // Rule ID 19639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19639,
        GIR_EraseRootFromParent_Done,
      // Label 4643: @220363
      GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(220426), // Rule ID 19642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19642,
        GIR_EraseRootFromParent_Done,
      // Label 4644: @220426
      GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(220489), // Rule ID 19643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19643,
        GIR_EraseRootFromParent_Done,
      // Label 4645: @220489
      GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(220552), // Rule ID 19646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19646,
        GIR_EraseRootFromParent_Done,
      // Label 4646: @220552
      GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(220615), // Rule ID 19647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19647,
        GIR_EraseRootFromParent_Done,
      // Label 4647: @220615
      GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(220678), // Rule ID 19650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19650,
        GIR_EraseRootFromParent_Done,
      // Label 4648: @220678
      GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(220741), // Rule ID 19651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19651,
        GIR_EraseRootFromParent_Done,
      // Label 4649: @220741
      GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(220804), // Rule ID 19654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19654,
        GIR_EraseRootFromParent_Done,
      // Label 4650: @220804
      GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(220867), // Rule ID 19655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19655,
        GIR_EraseRootFromParent_Done,
      // Label 4651: @220867
      GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(220930), // Rule ID 19658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19658,
        GIR_EraseRootFromParent_Done,
      // Label 4652: @220930
      GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(220993), // Rule ID 19659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19659,
        GIR_EraseRootFromParent_Done,
      // Label 4653: @220993
      GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(221056), // Rule ID 19662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19662,
        GIR_EraseRootFromParent_Done,
      // Label 4654: @221056
      GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(221119), // Rule ID 19663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19663,
        GIR_EraseRootFromParent_Done,
      // Label 4655: @221119
      GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(221182), // Rule ID 19666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19666,
        GIR_EraseRootFromParent_Done,
      // Label 4656: @221182
      GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(221245), // Rule ID 19667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19667,
        GIR_EraseRootFromParent_Done,
      // Label 4657: @221245
      GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(221308), // Rule ID 19670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19670,
        GIR_EraseRootFromParent_Done,
      // Label 4658: @221308
      GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(221371), // Rule ID 19671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19671,
        GIR_EraseRootFromParent_Done,
      // Label 4659: @221371
      GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(221434), // Rule ID 19674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19674,
        GIR_EraseRootFromParent_Done,
      // Label 4660: @221434
      GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(221497), // Rule ID 19675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19675,
        GIR_EraseRootFromParent_Done,
      // Label 4661: @221497
      GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(221560), // Rule ID 19678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19678,
        GIR_EraseRootFromParent_Done,
      // Label 4662: @221560
      GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(221623), // Rule ID 19679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19679,
        GIR_EraseRootFromParent_Done,
      // Label 4663: @221623
      GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(221686), // Rule ID 19682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19682,
        GIR_EraseRootFromParent_Done,
      // Label 4664: @221686
      GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(221749), // Rule ID 19683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19683,
        GIR_EraseRootFromParent_Done,
      // Label 4665: @221749
      GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(221812), // Rule ID 19686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19686,
        GIR_EraseRootFromParent_Done,
      // Label 4666: @221812
      GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(221875), // Rule ID 19687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19687,
        GIR_EraseRootFromParent_Done,
      // Label 4667: @221875
      GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(221938), // Rule ID 19690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19690,
        GIR_EraseRootFromParent_Done,
      // Label 4668: @221938
      GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(222001), // Rule ID 19691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19691,
        GIR_EraseRootFromParent_Done,
      // Label 4669: @222001
      GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(222064), // Rule ID 19694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19694,
        GIR_EraseRootFromParent_Done,
      // Label 4670: @222064
      GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(222127), // Rule ID 19695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19695,
        GIR_EraseRootFromParent_Done,
      // Label 4671: @222127
      GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(222190), // Rule ID 19698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19698,
        GIR_EraseRootFromParent_Done,
      // Label 4672: @222190
      GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(222253), // Rule ID 19699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19699,
        GIR_EraseRootFromParent_Done,
      // Label 4673: @222253
      GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(222316), // Rule ID 19702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19702,
        GIR_EraseRootFromParent_Done,
      // Label 4674: @222316
      GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(222379), // Rule ID 19703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19703,
        GIR_EraseRootFromParent_Done,
      // Label 4675: @222379
      GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(222442), // Rule ID 19706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19706,
        GIR_EraseRootFromParent_Done,
      // Label 4676: @222442
      GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(222505), // Rule ID 19707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19707,
        GIR_EraseRootFromParent_Done,
      // Label 4677: @222505
      GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(222568), // Rule ID 19710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19710,
        GIR_EraseRootFromParent_Done,
      // Label 4678: @222568
      GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(222631), // Rule ID 19711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19711,
        GIR_EraseRootFromParent_Done,
      // Label 4679: @222631
      GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(222694), // Rule ID 19714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19714,
        GIR_EraseRootFromParent_Done,
      // Label 4680: @222694
      GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(222757), // Rule ID 19715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19715,
        GIR_EraseRootFromParent_Done,
      // Label 4681: @222757
      GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(222820), // Rule ID 19718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19718,
        GIR_EraseRootFromParent_Done,
      // Label 4682: @222820
      GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(222883), // Rule ID 19719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19719,
        GIR_EraseRootFromParent_Done,
      // Label 4683: @222883
      GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(222946), // Rule ID 19722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19722,
        GIR_EraseRootFromParent_Done,
      // Label 4684: @222946
      GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(223009), // Rule ID 19723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19723,
        GIR_EraseRootFromParent_Done,
      // Label 4685: @223009
      GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(223072), // Rule ID 19726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19726,
        GIR_EraseRootFromParent_Done,
      // Label 4686: @223072
      GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(223135), // Rule ID 19727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19727,
        GIR_EraseRootFromParent_Done,
      // Label 4687: @223135
      GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(223198), // Rule ID 19730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19730,
        GIR_EraseRootFromParent_Done,
      // Label 4688: @223198
      GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(223261), // Rule ID 19731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19731,
        GIR_EraseRootFromParent_Done,
      // Label 4689: @223261
      GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(223324), // Rule ID 19734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19734,
        GIR_EraseRootFromParent_Done,
      // Label 4690: @223324
      GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(223387), // Rule ID 19735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19735,
        GIR_EraseRootFromParent_Done,
      // Label 4691: @223387
      GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(223450), // Rule ID 19738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19738,
        GIR_EraseRootFromParent_Done,
      // Label 4692: @223450
      GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(223513), // Rule ID 19739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19739,
        GIR_EraseRootFromParent_Done,
      // Label 4693: @223513
      GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(223576), // Rule ID 19742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19742,
        GIR_EraseRootFromParent_Done,
      // Label 4694: @223576
      GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(223639), // Rule ID 19743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19743,
        GIR_EraseRootFromParent_Done,
      // Label 4695: @223639
      GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(223702), // Rule ID 19746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19746,
        GIR_EraseRootFromParent_Done,
      // Label 4696: @223702
      GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(223765), // Rule ID 19747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19747,
        GIR_EraseRootFromParent_Done,
      // Label 4697: @223765
      GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(223828), // Rule ID 19750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19750,
        GIR_EraseRootFromParent_Done,
      // Label 4698: @223828
      GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(223891), // Rule ID 19751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19751,
        GIR_EraseRootFromParent_Done,
      // Label 4699: @223891
      GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(223954), // Rule ID 19754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19754,
        GIR_EraseRootFromParent_Done,
      // Label 4700: @223954
      GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(224017), // Rule ID 19755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19755,
        GIR_EraseRootFromParent_Done,
      // Label 4701: @224017
      GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(224080), // Rule ID 19758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19758,
        GIR_EraseRootFromParent_Done,
      // Label 4702: @224080
      GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(224143), // Rule ID 19759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19759,
        GIR_EraseRootFromParent_Done,
      // Label 4703: @224143
      GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(224206), // Rule ID 19762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19762,
        GIR_EraseRootFromParent_Done,
      // Label 4704: @224206
      GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(224269), // Rule ID 19763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19763,
        GIR_EraseRootFromParent_Done,
      // Label 4705: @224269
      GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(224332), // Rule ID 19766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19766,
        GIR_EraseRootFromParent_Done,
      // Label 4706: @224332
      GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(224395), // Rule ID 19767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19767,
        GIR_EraseRootFromParent_Done,
      // Label 4707: @224395
      GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(224458), // Rule ID 19770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19770,
        GIR_EraseRootFromParent_Done,
      // Label 4708: @224458
      GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(224521), // Rule ID 19771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19771,
        GIR_EraseRootFromParent_Done,
      // Label 4709: @224521
      GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(224584), // Rule ID 19774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19774,
        GIR_EraseRootFromParent_Done,
      // Label 4710: @224584
      GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(224647), // Rule ID 19775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19775,
        GIR_EraseRootFromParent_Done,
      // Label 4711: @224647
      GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(224710), // Rule ID 19778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19778,
        GIR_EraseRootFromParent_Done,
      // Label 4712: @224710
      GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(224773), // Rule ID 19779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19779,
        GIR_EraseRootFromParent_Done,
      // Label 4713: @224773
      GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(224836), // Rule ID 19782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19782,
        GIR_EraseRootFromParent_Done,
      // Label 4714: @224836
      GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(224899), // Rule ID 19783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19783,
        GIR_EraseRootFromParent_Done,
      // Label 4715: @224899
      GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(224962), // Rule ID 19786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19786,
        GIR_EraseRootFromParent_Done,
      // Label 4716: @224962
      GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(225025), // Rule ID 19787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19787,
        GIR_EraseRootFromParent_Done,
      // Label 4717: @225025
      GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(225088), // Rule ID 19790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19790,
        GIR_EraseRootFromParent_Done,
      // Label 4718: @225088
      GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(225151), // Rule ID 19791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19791,
        GIR_EraseRootFromParent_Done,
      // Label 4719: @225151
      GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(225214), // Rule ID 19794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19794,
        GIR_EraseRootFromParent_Done,
      // Label 4720: @225214
      GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(225277), // Rule ID 19795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19795,
        GIR_EraseRootFromParent_Done,
      // Label 4721: @225277
      GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(225340), // Rule ID 19798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19798,
        GIR_EraseRootFromParent_Done,
      // Label 4722: @225340
      GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(225403), // Rule ID 19799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19799,
        GIR_EraseRootFromParent_Done,
      // Label 4723: @225403
      GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(225466), // Rule ID 19802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19802,
        GIR_EraseRootFromParent_Done,
      // Label 4724: @225466
      GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(225529), // Rule ID 19803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19803,
        GIR_EraseRootFromParent_Done,
      // Label 4725: @225529
      GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(225592), // Rule ID 19806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19806,
        GIR_EraseRootFromParent_Done,
      // Label 4726: @225592
      GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(225655), // Rule ID 19807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19807,
        GIR_EraseRootFromParent_Done,
      // Label 4727: @225655
      GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(225718), // Rule ID 19810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19810,
        GIR_EraseRootFromParent_Done,
      // Label 4728: @225718
      GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(225781), // Rule ID 19811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19811,
        GIR_EraseRootFromParent_Done,
      // Label 4729: @225781
      GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(225844), // Rule ID 19814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19814,
        GIR_EraseRootFromParent_Done,
      // Label 4730: @225844
      GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(225907), // Rule ID 19815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19815,
        GIR_EraseRootFromParent_Done,
      // Label 4731: @225907
      GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(225970), // Rule ID 19818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19818,
        GIR_EraseRootFromParent_Done,
      // Label 4732: @225970
      GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(226033), // Rule ID 19819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19819,
        GIR_EraseRootFromParent_Done,
      // Label 4733: @226033
      GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(226096), // Rule ID 19822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19822,
        GIR_EraseRootFromParent_Done,
      // Label 4734: @226096
      GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(226159), // Rule ID 19823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19823,
        GIR_EraseRootFromParent_Done,
      // Label 4735: @226159
      GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(226222), // Rule ID 19826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19826,
        GIR_EraseRootFromParent_Done,
      // Label 4736: @226222
      GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(226285), // Rule ID 19827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19827,
        GIR_EraseRootFromParent_Done,
      // Label 4737: @226285
      GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(226348), // Rule ID 19830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19830,
        GIR_EraseRootFromParent_Done,
      // Label 4738: @226348
      GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(226411), // Rule ID 19831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19831,
        GIR_EraseRootFromParent_Done,
      // Label 4739: @226411
      GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(226474), // Rule ID 19834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19834,
        GIR_EraseRootFromParent_Done,
      // Label 4740: @226474
      GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(226537), // Rule ID 19835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19835,
        GIR_EraseRootFromParent_Done,
      // Label 4741: @226537
      GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(226600), // Rule ID 19838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19838,
        GIR_EraseRootFromParent_Done,
      // Label 4742: @226600
      GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(226663), // Rule ID 19839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19839,
        GIR_EraseRootFromParent_Done,
      // Label 4743: @226663
      GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(226726), // Rule ID 19842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19842,
        GIR_EraseRootFromParent_Done,
      // Label 4744: @226726
      GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(226789), // Rule ID 19843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19843,
        GIR_EraseRootFromParent_Done,
      // Label 4745: @226789
      GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(226852), // Rule ID 19846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19846,
        GIR_EraseRootFromParent_Done,
      // Label 4746: @226852
      GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(226915), // Rule ID 19847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19847,
        GIR_EraseRootFromParent_Done,
      // Label 4747: @226915
      GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(226978), // Rule ID 19850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19850,
        GIR_EraseRootFromParent_Done,
      // Label 4748: @226978
      GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(227041), // Rule ID 19851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19851,
        GIR_EraseRootFromParent_Done,
      // Label 4749: @227041
      GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(227104), // Rule ID 19854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19854,
        GIR_EraseRootFromParent_Done,
      // Label 4750: @227104
      GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(227167), // Rule ID 19855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19855,
        GIR_EraseRootFromParent_Done,
      // Label 4751: @227167
      GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(227230), // Rule ID 19858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19858,
        GIR_EraseRootFromParent_Done,
      // Label 4752: @227230
      GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(227293), // Rule ID 19859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19859,
        GIR_EraseRootFromParent_Done,
      // Label 4753: @227293
      GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(227356), // Rule ID 19862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19862,
        GIR_EraseRootFromParent_Done,
      // Label 4754: @227356
      GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(227419), // Rule ID 19863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19863,
        GIR_EraseRootFromParent_Done,
      // Label 4755: @227419
      GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(227482), // Rule ID 19866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19866,
        GIR_EraseRootFromParent_Done,
      // Label 4756: @227482
      GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(227545), // Rule ID 19867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19867,
        GIR_EraseRootFromParent_Done,
      // Label 4757: @227545
      GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(227608), // Rule ID 19870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19870,
        GIR_EraseRootFromParent_Done,
      // Label 4758: @227608
      GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(227671), // Rule ID 19871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19871,
        GIR_EraseRootFromParent_Done,
      // Label 4759: @227671
      GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(227734), // Rule ID 19874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19874,
        GIR_EraseRootFromParent_Done,
      // Label 4760: @227734
      GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(227797), // Rule ID 19875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19875,
        GIR_EraseRootFromParent_Done,
      // Label 4761: @227797
      GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(227860), // Rule ID 19878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19878,
        GIR_EraseRootFromParent_Done,
      // Label 4762: @227860
      GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(227923), // Rule ID 19879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19879,
        GIR_EraseRootFromParent_Done,
      // Label 4763: @227923
      GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(227986), // Rule ID 19882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19882,
        GIR_EraseRootFromParent_Done,
      // Label 4764: @227986
      GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(228049), // Rule ID 19883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19883,
        GIR_EraseRootFromParent_Done,
      // Label 4765: @228049
      GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(228112), // Rule ID 19886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19886,
        GIR_EraseRootFromParent_Done,
      // Label 4766: @228112
      GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(228175), // Rule ID 19887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19887,
        GIR_EraseRootFromParent_Done,
      // Label 4767: @228175
      GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(228238), // Rule ID 19890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19890,
        GIR_EraseRootFromParent_Done,
      // Label 4768: @228238
      GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(228301), // Rule ID 19891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19891,
        GIR_EraseRootFromParent_Done,
      // Label 4769: @228301
      GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(228364), // Rule ID 19894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19894,
        GIR_EraseRootFromParent_Done,
      // Label 4770: @228364
      GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(228427), // Rule ID 19895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19895,
        GIR_EraseRootFromParent_Done,
      // Label 4771: @228427
      GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(228490), // Rule ID 19898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19898,
        GIR_EraseRootFromParent_Done,
      // Label 4772: @228490
      GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(228553), // Rule ID 19899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19899,
        GIR_EraseRootFromParent_Done,
      // Label 4773: @228553
      GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(228616), // Rule ID 19902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19902,
        GIR_EraseRootFromParent_Done,
      // Label 4774: @228616
      GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(228679), // Rule ID 19903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19903,
        GIR_EraseRootFromParent_Done,
      // Label 4775: @228679
      GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(228742), // Rule ID 19906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19906,
        GIR_EraseRootFromParent_Done,
      // Label 4776: @228742
      GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(228805), // Rule ID 19907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19907,
        GIR_EraseRootFromParent_Done,
      // Label 4777: @228805
      GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(228868), // Rule ID 19910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19910,
        GIR_EraseRootFromParent_Done,
      // Label 4778: @228868
      GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(228931), // Rule ID 19911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19911,
        GIR_EraseRootFromParent_Done,
      // Label 4779: @228931
      GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(228994), // Rule ID 19914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19914,
        GIR_EraseRootFromParent_Done,
      // Label 4780: @228994
      GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(229057), // Rule ID 19915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19915,
        GIR_EraseRootFromParent_Done,
      // Label 4781: @229057
      GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(229120), // Rule ID 19918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19918,
        GIR_EraseRootFromParent_Done,
      // Label 4782: @229120
      GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(229183), // Rule ID 19919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19919,
        GIR_EraseRootFromParent_Done,
      // Label 4783: @229183
      GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(229246), // Rule ID 19922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19922,
        GIR_EraseRootFromParent_Done,
      // Label 4784: @229246
      GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(229309), // Rule ID 19923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19923,
        GIR_EraseRootFromParent_Done,
      // Label 4785: @229309
      GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(229372), // Rule ID 19926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19926,
        GIR_EraseRootFromParent_Done,
      // Label 4786: @229372
      GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(229435), // Rule ID 19927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19927,
        GIR_EraseRootFromParent_Done,
      // Label 4787: @229435
      GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(229498), // Rule ID 19930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19930,
        GIR_EraseRootFromParent_Done,
      // Label 4788: @229498
      GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(229561), // Rule ID 19931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19931,
        GIR_EraseRootFromParent_Done,
      // Label 4789: @229561
      GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(229624), // Rule ID 19934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19934,
        GIR_EraseRootFromParent_Done,
      // Label 4790: @229624
      GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(229687), // Rule ID 19935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19935,
        GIR_EraseRootFromParent_Done,
      // Label 4791: @229687
      GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(229750), // Rule ID 19938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19938,
        GIR_EraseRootFromParent_Done,
      // Label 4792: @229750
      GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(229813), // Rule ID 19939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19939,
        GIR_EraseRootFromParent_Done,
      // Label 4793: @229813
      GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(229876), // Rule ID 19942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19942,
        GIR_EraseRootFromParent_Done,
      // Label 4794: @229876
      GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(229939), // Rule ID 19943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19943,
        GIR_EraseRootFromParent_Done,
      // Label 4795: @229939
      GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(230002), // Rule ID 19946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19946,
        GIR_EraseRootFromParent_Done,
      // Label 4796: @230002
      GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(230065), // Rule ID 19947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19947,
        GIR_EraseRootFromParent_Done,
      // Label 4797: @230065
      GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(230128), // Rule ID 19950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19950,
        GIR_EraseRootFromParent_Done,
      // Label 4798: @230128
      GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(230191), // Rule ID 19951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19951,
        GIR_EraseRootFromParent_Done,
      // Label 4799: @230191
      GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(230254), // Rule ID 19954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19954,
        GIR_EraseRootFromParent_Done,
      // Label 4800: @230254
      GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(230317), // Rule ID 19955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19955,
        GIR_EraseRootFromParent_Done,
      // Label 4801: @230317
      GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(230380), // Rule ID 19958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19958,
        GIR_EraseRootFromParent_Done,
      // Label 4802: @230380
      GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(230443), // Rule ID 19959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19959,
        GIR_EraseRootFromParent_Done,
      // Label 4803: @230443
      GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(230506), // Rule ID 19962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19962,
        GIR_EraseRootFromParent_Done,
      // Label 4804: @230506
      GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(230569), // Rule ID 19963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19963,
        GIR_EraseRootFromParent_Done,
      // Label 4805: @230569
      GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(230632), // Rule ID 19966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19966,
        GIR_EraseRootFromParent_Done,
      // Label 4806: @230632
      GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(230695), // Rule ID 19967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19967,
        GIR_EraseRootFromParent_Done,
      // Label 4807: @230695
      GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(230758), // Rule ID 19970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19970,
        GIR_EraseRootFromParent_Done,
      // Label 4808: @230758
      GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(230821), // Rule ID 19971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19971,
        GIR_EraseRootFromParent_Done,
      // Label 4809: @230821
      GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(230884), // Rule ID 19974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19974,
        GIR_EraseRootFromParent_Done,
      // Label 4810: @230884
      GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(230947), // Rule ID 19975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19975,
        GIR_EraseRootFromParent_Done,
      // Label 4811: @230947
      GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(231010), // Rule ID 19978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19978,
        GIR_EraseRootFromParent_Done,
      // Label 4812: @231010
      GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(231073), // Rule ID 19979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19979,
        GIR_EraseRootFromParent_Done,
      // Label 4813: @231073
      GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(231136), // Rule ID 19982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19982,
        GIR_EraseRootFromParent_Done,
      // Label 4814: @231136
      GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(231199), // Rule ID 19983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19983,
        GIR_EraseRootFromParent_Done,
      // Label 4815: @231199
      GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(231262), // Rule ID 19986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19986,
        GIR_EraseRootFromParent_Done,
      // Label 4816: @231262
      GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(231325), // Rule ID 19987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19987,
        GIR_EraseRootFromParent_Done,
      // Label 4817: @231325
      GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(231388), // Rule ID 19990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19990,
        GIR_EraseRootFromParent_Done,
      // Label 4818: @231388
      GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(231451), // Rule ID 19991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19991,
        GIR_EraseRootFromParent_Done,
      // Label 4819: @231451
      GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(231514), // Rule ID 19994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19994,
        GIR_EraseRootFromParent_Done,
      // Label 4820: @231514
      GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(231577), // Rule ID 19995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19995,
        GIR_EraseRootFromParent_Done,
      // Label 4821: @231577
      GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(231640), // Rule ID 19998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19998,
        GIR_EraseRootFromParent_Done,
      // Label 4822: @231640
      GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(231703), // Rule ID 19999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19999,
        GIR_EraseRootFromParent_Done,
      // Label 4823: @231703
      GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(231766), // Rule ID 20002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20002,
        GIR_EraseRootFromParent_Done,
      // Label 4824: @231766
      GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(231829), // Rule ID 20003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20003,
        GIR_EraseRootFromParent_Done,
      // Label 4825: @231829
      GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(231892), // Rule ID 20006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20006,
        GIR_EraseRootFromParent_Done,
      // Label 4826: @231892
      GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(231955), // Rule ID 20007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20007,
        GIR_EraseRootFromParent_Done,
      // Label 4827: @231955
      GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(232018), // Rule ID 20010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20010,
        GIR_EraseRootFromParent_Done,
      // Label 4828: @232018
      GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(232081), // Rule ID 20011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20011,
        GIR_EraseRootFromParent_Done,
      // Label 4829: @232081
      GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(232144), // Rule ID 20014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20014,
        GIR_EraseRootFromParent_Done,
      // Label 4830: @232144
      GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(232207), // Rule ID 20015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20015,
        GIR_EraseRootFromParent_Done,
      // Label 4831: @232207
      GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(232270), // Rule ID 20018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20018,
        GIR_EraseRootFromParent_Done,
      // Label 4832: @232270
      GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(232333), // Rule ID 20019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20019,
        GIR_EraseRootFromParent_Done,
      // Label 4833: @232333
      GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(232396), // Rule ID 20022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20022,
        GIR_EraseRootFromParent_Done,
      // Label 4834: @232396
      GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(232459), // Rule ID 20023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20023,
        GIR_EraseRootFromParent_Done,
      // Label 4835: @232459
      GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(232522), // Rule ID 20026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20026,
        GIR_EraseRootFromParent_Done,
      // Label 4836: @232522
      GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(232585), // Rule ID 20027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20027,
        GIR_EraseRootFromParent_Done,
      // Label 4837: @232585
      GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(232648), // Rule ID 20030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20030,
        GIR_EraseRootFromParent_Done,
      // Label 4838: @232648
      GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(232711), // Rule ID 20031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20031,
        GIR_EraseRootFromParent_Done,
      // Label 4839: @232711
      GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(232774), // Rule ID 20034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20034,
        GIR_EraseRootFromParent_Done,
      // Label 4840: @232774
      GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(232837), // Rule ID 20035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20035,
        GIR_EraseRootFromParent_Done,
      // Label 4841: @232837
      GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(232900), // Rule ID 20038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20038,
        GIR_EraseRootFromParent_Done,
      // Label 4842: @232900
      GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(232963), // Rule ID 20039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20039,
        GIR_EraseRootFromParent_Done,
      // Label 4843: @232963
      GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(233026), // Rule ID 20042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20042,
        GIR_EraseRootFromParent_Done,
      // Label 4844: @233026
      GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(233089), // Rule ID 20043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20043,
        GIR_EraseRootFromParent_Done,
      // Label 4845: @233089
      GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(233152), // Rule ID 20046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20046,
        GIR_EraseRootFromParent_Done,
      // Label 4846: @233152
      GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(233215), // Rule ID 20047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20047,
        GIR_EraseRootFromParent_Done,
      // Label 4847: @233215
      GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(233278), // Rule ID 20050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20050,
        GIR_EraseRootFromParent_Done,
      // Label 4848: @233278
      GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(233341), // Rule ID 20051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20051,
        GIR_EraseRootFromParent_Done,
      // Label 4849: @233341
      GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(233404), // Rule ID 20054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20054,
        GIR_EraseRootFromParent_Done,
      // Label 4850: @233404
      GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(233467), // Rule ID 20055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20055,
        GIR_EraseRootFromParent_Done,
      // Label 4851: @233467
      GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(233530), // Rule ID 20058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20058,
        GIR_EraseRootFromParent_Done,
      // Label 4852: @233530
      GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(233593), // Rule ID 20059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20059,
        GIR_EraseRootFromParent_Done,
      // Label 4853: @233593
      GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(233656), // Rule ID 20062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20062,
        GIR_EraseRootFromParent_Done,
      // Label 4854: @233656
      GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(233719), // Rule ID 20063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20063,
        GIR_EraseRootFromParent_Done,
      // Label 4855: @233719
      GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(233782), // Rule ID 20066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20066,
        GIR_EraseRootFromParent_Done,
      // Label 4856: @233782
      GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(233845), // Rule ID 20067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20067,
        GIR_EraseRootFromParent_Done,
      // Label 4857: @233845
      GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(233908), // Rule ID 20070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20070,
        GIR_EraseRootFromParent_Done,
      // Label 4858: @233908
      GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(233971), // Rule ID 20071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20071,
        GIR_EraseRootFromParent_Done,
      // Label 4859: @233971
      GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(234034), // Rule ID 20074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20074,
        GIR_EraseRootFromParent_Done,
      // Label 4860: @234034
      GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(234097), // Rule ID 20075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20075,
        GIR_EraseRootFromParent_Done,
      // Label 4861: @234097
      GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(234160), // Rule ID 20078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20078,
        GIR_EraseRootFromParent_Done,
      // Label 4862: @234160
      GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(234223), // Rule ID 20079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20079,
        GIR_EraseRootFromParent_Done,
      // Label 4863: @234223
      GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(234286), // Rule ID 20082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20082,
        GIR_EraseRootFromParent_Done,
      // Label 4864: @234286
      GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(234349), // Rule ID 20083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20083,
        GIR_EraseRootFromParent_Done,
      // Label 4865: @234349
      GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(234412), // Rule ID 20086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20086,
        GIR_EraseRootFromParent_Done,
      // Label 4866: @234412
      GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(234475), // Rule ID 20087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20087,
        GIR_EraseRootFromParent_Done,
      // Label 4867: @234475
      GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(234538), // Rule ID 20090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20090,
        GIR_EraseRootFromParent_Done,
      // Label 4868: @234538
      GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(234601), // Rule ID 20091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20091,
        GIR_EraseRootFromParent_Done,
      // Label 4869: @234601
      GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(234664), // Rule ID 20094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20094,
        GIR_EraseRootFromParent_Done,
      // Label 4870: @234664
      GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(234727), // Rule ID 20095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20095,
        GIR_EraseRootFromParent_Done,
      // Label 4871: @234727
      GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(234790), // Rule ID 20098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20098,
        GIR_EraseRootFromParent_Done,
      // Label 4872: @234790
      GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(234853), // Rule ID 20099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20099,
        GIR_EraseRootFromParent_Done,
      // Label 4873: @234853
      GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(234916), // Rule ID 20102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20102,
        GIR_EraseRootFromParent_Done,
      // Label 4874: @234916
      GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(234979), // Rule ID 20103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20103,
        GIR_EraseRootFromParent_Done,
      // Label 4875: @234979
      GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(235042), // Rule ID 20106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20106,
        GIR_EraseRootFromParent_Done,
      // Label 4876: @235042
      GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(235105), // Rule ID 20107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20107,
        GIR_EraseRootFromParent_Done,
      // Label 4877: @235105
      GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(235168), // Rule ID 20110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20110,
        GIR_EraseRootFromParent_Done,
      // Label 4878: @235168
      GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(235231), // Rule ID 20111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20111,
        GIR_EraseRootFromParent_Done,
      // Label 4879: @235231
      GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(235294), // Rule ID 20114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20114,
        GIR_EraseRootFromParent_Done,
      // Label 4880: @235294
      GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(235357), // Rule ID 20115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20115,
        GIR_EraseRootFromParent_Done,
      // Label 4881: @235357
      GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(235420), // Rule ID 20118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20118,
        GIR_EraseRootFromParent_Done,
      // Label 4882: @235420
      GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(235483), // Rule ID 20119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20119,
        GIR_EraseRootFromParent_Done,
      // Label 4883: @235483
      GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(235546), // Rule ID 20122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20122,
        GIR_EraseRootFromParent_Done,
      // Label 4884: @235546
      GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(235609), // Rule ID 20123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20123,
        GIR_EraseRootFromParent_Done,
      // Label 4885: @235609
      GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(235672), // Rule ID 20126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20126,
        GIR_EraseRootFromParent_Done,
      // Label 4886: @235672
      GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(235735), // Rule ID 20127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20127,
        GIR_EraseRootFromParent_Done,
      // Label 4887: @235735
      GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(235798), // Rule ID 20130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20130,
        GIR_EraseRootFromParent_Done,
      // Label 4888: @235798
      GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(235861), // Rule ID 20131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20131,
        GIR_EraseRootFromParent_Done,
      // Label 4889: @235861
      GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(235924), // Rule ID 20134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20134,
        GIR_EraseRootFromParent_Done,
      // Label 4890: @235924
      GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(235987), // Rule ID 20135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20135,
        GIR_EraseRootFromParent_Done,
      // Label 4891: @235987
      GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(236050), // Rule ID 20138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20138,
        GIR_EraseRootFromParent_Done,
      // Label 4892: @236050
      GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(236113), // Rule ID 20139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20139,
        GIR_EraseRootFromParent_Done,
      // Label 4893: @236113
      GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(236176), // Rule ID 20142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20142,
        GIR_EraseRootFromParent_Done,
      // Label 4894: @236176
      GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(236239), // Rule ID 20143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20143,
        GIR_EraseRootFromParent_Done,
      // Label 4895: @236239
      GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(236302), // Rule ID 20146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20146,
        GIR_EraseRootFromParent_Done,
      // Label 4896: @236302
      GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(236365), // Rule ID 20147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20147,
        GIR_EraseRootFromParent_Done,
      // Label 4897: @236365
      GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(236428), // Rule ID 20150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20150,
        GIR_EraseRootFromParent_Done,
      // Label 4898: @236428
      GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(236491), // Rule ID 20151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20151,
        GIR_EraseRootFromParent_Done,
      // Label 4899: @236491
      GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(236554), // Rule ID 20154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20154,
        GIR_EraseRootFromParent_Done,
      // Label 4900: @236554
      GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(236617), // Rule ID 20155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20155,
        GIR_EraseRootFromParent_Done,
      // Label 4901: @236617
      GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(236680), // Rule ID 20158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20158,
        GIR_EraseRootFromParent_Done,
      // Label 4902: @236680
      GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(236743), // Rule ID 20159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20159,
        GIR_EraseRootFromParent_Done,
      // Label 4903: @236743
      GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(236806), // Rule ID 20162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20162,
        GIR_EraseRootFromParent_Done,
      // Label 4904: @236806
      GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(236869), // Rule ID 20163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20163,
        GIR_EraseRootFromParent_Done,
      // Label 4905: @236869
      GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(236932), // Rule ID 20166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20166,
        GIR_EraseRootFromParent_Done,
      // Label 4906: @236932
      GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(236995), // Rule ID 20167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20167,
        GIR_EraseRootFromParent_Done,
      // Label 4907: @236995
      GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(237058), // Rule ID 20170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20170,
        GIR_EraseRootFromParent_Done,
      // Label 4908: @237058
      GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(237121), // Rule ID 20171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20171,
        GIR_EraseRootFromParent_Done,
      // Label 4909: @237121
      GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(237184), // Rule ID 20174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20174,
        GIR_EraseRootFromParent_Done,
      // Label 4910: @237184
      GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(237247), // Rule ID 20175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20175,
        GIR_EraseRootFromParent_Done,
      // Label 4911: @237247
      GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(237310), // Rule ID 20178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20178,
        GIR_EraseRootFromParent_Done,
      // Label 4912: @237310
      GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(237373), // Rule ID 20179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20179,
        GIR_EraseRootFromParent_Done,
      // Label 4913: @237373
      GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(237436), // Rule ID 20182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20182,
        GIR_EraseRootFromParent_Done,
      // Label 4914: @237436
      GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(237499), // Rule ID 20183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20183,
        GIR_EraseRootFromParent_Done,
      // Label 4915: @237499
      GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(237562), // Rule ID 20186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20186,
        GIR_EraseRootFromParent_Done,
      // Label 4916: @237562
      GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(237625), // Rule ID 20187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20187,
        GIR_EraseRootFromParent_Done,
      // Label 4917: @237625
      GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(237688), // Rule ID 20190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20190,
        GIR_EraseRootFromParent_Done,
      // Label 4918: @237688
      GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(237751), // Rule ID 20191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20191,
        GIR_EraseRootFromParent_Done,
      // Label 4919: @237751
      GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(237814), // Rule ID 20194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20194,
        GIR_EraseRootFromParent_Done,
      // Label 4920: @237814
      GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(237877), // Rule ID 20195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20195,
        GIR_EraseRootFromParent_Done,
      // Label 4921: @237877
      GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(237940), // Rule ID 20198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20198,
        GIR_EraseRootFromParent_Done,
      // Label 4922: @237940
      GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(238003), // Rule ID 20199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20199,
        GIR_EraseRootFromParent_Done,
      // Label 4923: @238003
      GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(238066), // Rule ID 20202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20202,
        GIR_EraseRootFromParent_Done,
      // Label 4924: @238066
      GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(238129), // Rule ID 20203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20203,
        GIR_EraseRootFromParent_Done,
      // Label 4925: @238129
      GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(238192), // Rule ID 20206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20206,
        GIR_EraseRootFromParent_Done,
      // Label 4926: @238192
      GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(238255), // Rule ID 20207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20207,
        GIR_EraseRootFromParent_Done,
      // Label 4927: @238255
      GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(238318), // Rule ID 20210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20210,
        GIR_EraseRootFromParent_Done,
      // Label 4928: @238318
      GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(238381), // Rule ID 20211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20211,
        GIR_EraseRootFromParent_Done,
      // Label 4929: @238381
      GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(238444), // Rule ID 20214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20214,
        GIR_EraseRootFromParent_Done,
      // Label 4930: @238444
      GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(238507), // Rule ID 20215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20215,
        GIR_EraseRootFromParent_Done,
      // Label 4931: @238507
      GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(238570), // Rule ID 20218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20218,
        GIR_EraseRootFromParent_Done,
      // Label 4932: @238570
      GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(238633), // Rule ID 20219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20219,
        GIR_EraseRootFromParent_Done,
      // Label 4933: @238633
      GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(238696), // Rule ID 20222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20222,
        GIR_EraseRootFromParent_Done,
      // Label 4934: @238696
      GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(238759), // Rule ID 20223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20223,
        GIR_EraseRootFromParent_Done,
      // Label 4935: @238759
      GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(238822), // Rule ID 20226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20226,
        GIR_EraseRootFromParent_Done,
      // Label 4936: @238822
      GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(238885), // Rule ID 20227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20227,
        GIR_EraseRootFromParent_Done,
      // Label 4937: @238885
      GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(238948), // Rule ID 20230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20230,
        GIR_EraseRootFromParent_Done,
      // Label 4938: @238948
      GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(239011), // Rule ID 20231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20231,
        GIR_EraseRootFromParent_Done,
      // Label 4939: @239011
      GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(239074), // Rule ID 20234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20234,
        GIR_EraseRootFromParent_Done,
      // Label 4940: @239074
      GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(239137), // Rule ID 20235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20235,
        GIR_EraseRootFromParent_Done,
      // Label 4941: @239137
      GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(239200), // Rule ID 20238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20238,
        GIR_EraseRootFromParent_Done,
      // Label 4942: @239200
      GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(239263), // Rule ID 20239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20239,
        GIR_EraseRootFromParent_Done,
      // Label 4943: @239263
      GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(239326), // Rule ID 20242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20242,
        GIR_EraseRootFromParent_Done,
      // Label 4944: @239326
      GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(239389), // Rule ID 20243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20243,
        GIR_EraseRootFromParent_Done,
      // Label 4945: @239389
      GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(239452), // Rule ID 20246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20246,
        GIR_EraseRootFromParent_Done,
      // Label 4946: @239452
      GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(239515), // Rule ID 20247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20247,
        GIR_EraseRootFromParent_Done,
      // Label 4947: @239515
      GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(239578), // Rule ID 20250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20250,
        GIR_EraseRootFromParent_Done,
      // Label 4948: @239578
      GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(239641), // Rule ID 20251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20251,
        GIR_EraseRootFromParent_Done,
      // Label 4949: @239641
      GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(239704), // Rule ID 20254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20254,
        GIR_EraseRootFromParent_Done,
      // Label 4950: @239704
      GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(239767), // Rule ID 20255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20255,
        GIR_EraseRootFromParent_Done,
      // Label 4951: @239767
      GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(239830), // Rule ID 20258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20258,
        GIR_EraseRootFromParent_Done,
      // Label 4952: @239830
      GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(239893), // Rule ID 20259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20259,
        GIR_EraseRootFromParent_Done,
      // Label 4953: @239893
      GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(239956), // Rule ID 20262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20262,
        GIR_EraseRootFromParent_Done,
      // Label 4954: @239956
      GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(240019), // Rule ID 20263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20263,
        GIR_EraseRootFromParent_Done,
      // Label 4955: @240019
      GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(240082), // Rule ID 20266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20266,
        GIR_EraseRootFromParent_Done,
      // Label 4956: @240082
      GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(240145), // Rule ID 20267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20267,
        GIR_EraseRootFromParent_Done,
      // Label 4957: @240145
      GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(240208), // Rule ID 20270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20270,
        GIR_EraseRootFromParent_Done,
      // Label 4958: @240208
      GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(240271), // Rule ID 20271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20271,
        GIR_EraseRootFromParent_Done,
      // Label 4959: @240271
      GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(240334), // Rule ID 20274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20274,
        GIR_EraseRootFromParent_Done,
      // Label 4960: @240334
      GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(240397), // Rule ID 20275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20275,
        GIR_EraseRootFromParent_Done,
      // Label 4961: @240397
      GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(240460), // Rule ID 20278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20278,
        GIR_EraseRootFromParent_Done,
      // Label 4962: @240460
      GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(240523), // Rule ID 20279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20279,
        GIR_EraseRootFromParent_Done,
      // Label 4963: @240523
      GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(240586), // Rule ID 20282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20282,
        GIR_EraseRootFromParent_Done,
      // Label 4964: @240586
      GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(240649), // Rule ID 20283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20283,
        GIR_EraseRootFromParent_Done,
      // Label 4965: @240649
      GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(240712), // Rule ID 20286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20286,
        GIR_EraseRootFromParent_Done,
      // Label 4966: @240712
      GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(240775), // Rule ID 20287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20287,
        GIR_EraseRootFromParent_Done,
      // Label 4967: @240775
      GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(240838), // Rule ID 20290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20290,
        GIR_EraseRootFromParent_Done,
      // Label 4968: @240838
      GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(240901), // Rule ID 20291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20291,
        GIR_EraseRootFromParent_Done,
      // Label 4969: @240901
      GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(240964), // Rule ID 20294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20294,
        GIR_EraseRootFromParent_Done,
      // Label 4970: @240964
      GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(241027), // Rule ID 20295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20295,
        GIR_EraseRootFromParent_Done,
      // Label 4971: @241027
      GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(241090), // Rule ID 20298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20298,
        GIR_EraseRootFromParent_Done,
      // Label 4972: @241090
      GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(241153), // Rule ID 20299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20299,
        GIR_EraseRootFromParent_Done,
      // Label 4973: @241153
      GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(241216), // Rule ID 20302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20302,
        GIR_EraseRootFromParent_Done,
      // Label 4974: @241216
      GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(241279), // Rule ID 20303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20303,
        GIR_EraseRootFromParent_Done,
      // Label 4975: @241279
      GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(241342), // Rule ID 20306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20306,
        GIR_EraseRootFromParent_Done,
      // Label 4976: @241342
      GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(241405), // Rule ID 20307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20307,
        GIR_EraseRootFromParent_Done,
      // Label 4977: @241405
      GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(241468), // Rule ID 20310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20310,
        GIR_EraseRootFromParent_Done,
      // Label 4978: @241468
      GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(241531), // Rule ID 20311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20311,
        GIR_EraseRootFromParent_Done,
      // Label 4979: @241531
      GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(241594), // Rule ID 20314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20314,
        GIR_EraseRootFromParent_Done,
      // Label 4980: @241594
      GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(241657), // Rule ID 20315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20315,
        GIR_EraseRootFromParent_Done,
      // Label 4981: @241657
      GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(241720), // Rule ID 20318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20318,
        GIR_EraseRootFromParent_Done,
      // Label 4982: @241720
      GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(241783), // Rule ID 20319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20319,
        GIR_EraseRootFromParent_Done,
      // Label 4983: @241783
      GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(241846), // Rule ID 20322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20322,
        GIR_EraseRootFromParent_Done,
      // Label 4984: @241846
      GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(241909), // Rule ID 20323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20323,
        GIR_EraseRootFromParent_Done,
      // Label 4985: @241909
      GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(241972), // Rule ID 20326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20326,
        GIR_EraseRootFromParent_Done,
      // Label 4986: @241972
      GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(242035), // Rule ID 20327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20327,
        GIR_EraseRootFromParent_Done,
      // Label 4987: @242035
      GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(242098), // Rule ID 20330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20330,
        GIR_EraseRootFromParent_Done,
      // Label 4988: @242098
      GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(242161), // Rule ID 20331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20331,
        GIR_EraseRootFromParent_Done,
      // Label 4989: @242161
      GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(242224), // Rule ID 20334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20334,
        GIR_EraseRootFromParent_Done,
      // Label 4990: @242224
      GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(242287), // Rule ID 20335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20335,
        GIR_EraseRootFromParent_Done,
      // Label 4991: @242287
      GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(242350), // Rule ID 20338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20338,
        GIR_EraseRootFromParent_Done,
      // Label 4992: @242350
      GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(242413), // Rule ID 20339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20339,
        GIR_EraseRootFromParent_Done,
      // Label 4993: @242413
      GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(242479), // Rule ID 20342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10794:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20342,
        GIR_EraseRootFromParent_Done,
      // Label 4994: @242479
      GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(242545), // Rule ID 20343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10794:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20343,
        GIR_EraseRootFromParent_Done,
      // Label 4995: @242545
      GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(242611), // Rule ID 20346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10794:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20346,
        GIR_EraseRootFromParent_Done,
      // Label 4996: @242611
      GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(242677), // Rule ID 20347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10794:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20347,
        GIR_EraseRootFromParent_Done,
      // Label 4997: @242677
      GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(242743), // Rule ID 20350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10794:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20350,
        GIR_EraseRootFromParent_Done,
      // Label 4998: @242743
      GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(242809), // Rule ID 20351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10794:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20351,
        GIR_EraseRootFromParent_Done,
      // Label 4999: @242809
      GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(242875), // Rule ID 20354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10794:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20354,
        GIR_EraseRootFromParent_Done,
      // Label 5000: @242875
      GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(242941), // Rule ID 20355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10794:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20355,
        GIR_EraseRootFromParent_Done,
      // Label 5001: @242941
      GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(243007), // Rule ID 20358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10794:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20358,
        GIR_EraseRootFromParent_Done,
      // Label 5002: @243007
      GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(243073), // Rule ID 20359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10794:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20359,
        GIR_EraseRootFromParent_Done,
      // Label 5003: @243073
      GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(243139), // Rule ID 20362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10794:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20362,
        GIR_EraseRootFromParent_Done,
      // Label 5004: @243139
      GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(243205), // Rule ID 20363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10794:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20363,
        GIR_EraseRootFromParent_Done,
      // Label 5005: @243205
      GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(243271), // Rule ID 20366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10794:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20366,
        GIR_EraseRootFromParent_Done,
      // Label 5006: @243271
      GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(243337), // Rule ID 20367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10794:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20367,
        GIR_EraseRootFromParent_Done,
      // Label 5007: @243337
      GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(243403), // Rule ID 20370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10794:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20370,
        GIR_EraseRootFromParent_Done,
      // Label 5008: @243403
      GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(243469), // Rule ID 20371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10794:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20371,
        GIR_EraseRootFromParent_Done,
      // Label 5009: @243469
      GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(243535), // Rule ID 20374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10794:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20374,
        GIR_EraseRootFromParent_Done,
      // Label 5010: @243535
      GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(243601), // Rule ID 20375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10794:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20375,
        GIR_EraseRootFromParent_Done,
      // Label 5011: @243601
      GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(243667), // Rule ID 20378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10794:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20378,
        GIR_EraseRootFromParent_Done,
      // Label 5012: @243667
      GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(243733), // Rule ID 20379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10794:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20379,
        GIR_EraseRootFromParent_Done,
      // Label 5013: @243733
      GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(243799), // Rule ID 20382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10794:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20382,
        GIR_EraseRootFromParent_Done,
      // Label 5014: @243799
      GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(243865), // Rule ID 20383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10794:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20383,
        GIR_EraseRootFromParent_Done,
      // Label 5015: @243865
      GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(243931), // Rule ID 20386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10794:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20386,
        GIR_EraseRootFromParent_Done,
      // Label 5016: @243931
      GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(243997), // Rule ID 20387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10794:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20387,
        GIR_EraseRootFromParent_Done,
      // Label 5017: @243997
      GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(244063), // Rule ID 20390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10794:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20390,
        GIR_EraseRootFromParent_Done,
      // Label 5018: @244063
      GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(244129), // Rule ID 20391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10794:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20391,
        GIR_EraseRootFromParent_Done,
      // Label 5019: @244129
      GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(244195), // Rule ID 20394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10794:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20394,
        GIR_EraseRootFromParent_Done,
      // Label 5020: @244195
      GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(244261), // Rule ID 20395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10794:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20395,
        GIR_EraseRootFromParent_Done,
      // Label 5021: @244261
      GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(244327), // Rule ID 20720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10802:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20720,
        GIR_EraseRootFromParent_Done,
      // Label 5022: @244327
      GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(244393), // Rule ID 20721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10802:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20721,
        GIR_EraseRootFromParent_Done,
      // Label 5023: @244393
      GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(244459), // Rule ID 20724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10802:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20724,
        GIR_EraseRootFromParent_Done,
      // Label 5024: @244459
      GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(244525), // Rule ID 20725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10802:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20725,
        GIR_EraseRootFromParent_Done,
      // Label 5025: @244525
      GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(244591), // Rule ID 20728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10802:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20728,
        GIR_EraseRootFromParent_Done,
      // Label 5026: @244591
      GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(244657), // Rule ID 20729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10802:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20729,
        GIR_EraseRootFromParent_Done,
      // Label 5027: @244657
      GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(244723), // Rule ID 20732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10802:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20732,
        GIR_EraseRootFromParent_Done,
      // Label 5028: @244723
      GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(244789), // Rule ID 20733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10802:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20733,
        GIR_EraseRootFromParent_Done,
      // Label 5029: @244789
      GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(244855), // Rule ID 20736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10802:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20736,
        GIR_EraseRootFromParent_Done,
      // Label 5030: @244855
      GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(244921), // Rule ID 20737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10802:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20737,
        GIR_EraseRootFromParent_Done,
      // Label 5031: @244921
      GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(244987), // Rule ID 20740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10802:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20740,
        GIR_EraseRootFromParent_Done,
      // Label 5032: @244987
      GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(245053), // Rule ID 20741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10802:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20741,
        GIR_EraseRootFromParent_Done,
      // Label 5033: @245053
      GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(245119), // Rule ID 20744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10802:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20744,
        GIR_EraseRootFromParent_Done,
      // Label 5034: @245119
      GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(245185), // Rule ID 20745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10802:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20745,
        GIR_EraseRootFromParent_Done,
      // Label 5035: @245185
      GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(245251), // Rule ID 20748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10802:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20748,
        GIR_EraseRootFromParent_Done,
      // Label 5036: @245251
      GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(245317), // Rule ID 20749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10802:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20749,
        GIR_EraseRootFromParent_Done,
      // Label 5037: @245317
      GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(245383), // Rule ID 20752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10802:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20752,
        GIR_EraseRootFromParent_Done,
      // Label 5038: @245383
      GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(245449), // Rule ID 20753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10802:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20753,
        GIR_EraseRootFromParent_Done,
      // Label 5039: @245449
      GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(245515), // Rule ID 20756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10802:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20756,
        GIR_EraseRootFromParent_Done,
      // Label 5040: @245515
      GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(245581), // Rule ID 20757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10802:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20757,
        GIR_EraseRootFromParent_Done,
      // Label 5041: @245581
      GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(245647), // Rule ID 20760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10802:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20760,
        GIR_EraseRootFromParent_Done,
      // Label 5042: @245647
      GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(245713), // Rule ID 20761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10802:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20761,
        GIR_EraseRootFromParent_Done,
      // Label 5043: @245713
      GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(245779), // Rule ID 20764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10802:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20764,
        GIR_EraseRootFromParent_Done,
      // Label 5044: @245779
      GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(245845), // Rule ID 20765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10802:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20765,
        GIR_EraseRootFromParent_Done,
      // Label 5045: @245845
      GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(245911), // Rule ID 20768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10802:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20768,
        GIR_EraseRootFromParent_Done,
      // Label 5046: @245911
      GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(245977), // Rule ID 20769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10802:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20769,
        GIR_EraseRootFromParent_Done,
      // Label 5047: @245977
      GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(246043), // Rule ID 20772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10802:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20772,
        GIR_EraseRootFromParent_Done,
      // Label 5048: @246043
      GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(246109), // Rule ID 20773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10802:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20773,
        GIR_EraseRootFromParent_Done,
      // Label 5049: @246109
      GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(246175), // Rule ID 20776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10802:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20776,
        GIR_EraseRootFromParent_Done,
      // Label 5050: @246175
      GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(246241), // Rule ID 20777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10802:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20777,
        GIR_EraseRootFromParent_Done,
      // Label 5051: @246241
      GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(246307), // Rule ID 20780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10800:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20780,
        GIR_EraseRootFromParent_Done,
      // Label 5052: @246307
      GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(246373), // Rule ID 20781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10800:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20781,
        GIR_EraseRootFromParent_Done,
      // Label 5053: @246373
      GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(246439), // Rule ID 20784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10800:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20784,
        GIR_EraseRootFromParent_Done,
      // Label 5054: @246439
      GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(246505), // Rule ID 20785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10800:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20785,
        GIR_EraseRootFromParent_Done,
      // Label 5055: @246505
      GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(246571), // Rule ID 20788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10800:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20788,
        GIR_EraseRootFromParent_Done,
      // Label 5056: @246571
      GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(246637), // Rule ID 20789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10800:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20789,
        GIR_EraseRootFromParent_Done,
      // Label 5057: @246637
      GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(246703), // Rule ID 20792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10800:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20792,
        GIR_EraseRootFromParent_Done,
      // Label 5058: @246703
      GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(246769), // Rule ID 20793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10800:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20793,
        GIR_EraseRootFromParent_Done,
      // Label 5059: @246769
      GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(246835), // Rule ID 20796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10800:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20796,
        GIR_EraseRootFromParent_Done,
      // Label 5060: @246835
      GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(246901), // Rule ID 20797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10800:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20797,
        GIR_EraseRootFromParent_Done,
      // Label 5061: @246901
      GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(246967), // Rule ID 20800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10800:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20800,
        GIR_EraseRootFromParent_Done,
      // Label 5062: @246967
      GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(247033), // Rule ID 20801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10800:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20801,
        GIR_EraseRootFromParent_Done,
      // Label 5063: @247033
      GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(247099), // Rule ID 20804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10800:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20804,
        GIR_EraseRootFromParent_Done,
      // Label 5064: @247099
      GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(247165), // Rule ID 20805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10800:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20805,
        GIR_EraseRootFromParent_Done,
      // Label 5065: @247165
      GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(247231), // Rule ID 20808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10800:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20808,
        GIR_EraseRootFromParent_Done,
      // Label 5066: @247231
      GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(247297), // Rule ID 20809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10800:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20809,
        GIR_EraseRootFromParent_Done,
      // Label 5067: @247297
      GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(247363), // Rule ID 20812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10800:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20812,
        GIR_EraseRootFromParent_Done,
      // Label 5068: @247363
      GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(247429), // Rule ID 20813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10800:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20813,
        GIR_EraseRootFromParent_Done,
      // Label 5069: @247429
      GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(247495), // Rule ID 20816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10800:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20816,
        GIR_EraseRootFromParent_Done,
      // Label 5070: @247495
      GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(247561), // Rule ID 20817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10800:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20817,
        GIR_EraseRootFromParent_Done,
      // Label 5071: @247561
      GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(247627), // Rule ID 20820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10800:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20820,
        GIR_EraseRootFromParent_Done,
      // Label 5072: @247627
      GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(247693), // Rule ID 20821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10800:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20821,
        GIR_EraseRootFromParent_Done,
      // Label 5073: @247693
      GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(247759), // Rule ID 20824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10800:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20824,
        GIR_EraseRootFromParent_Done,
      // Label 5074: @247759
      GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(247825), // Rule ID 20825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10800:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20825,
        GIR_EraseRootFromParent_Done,
      // Label 5075: @247825
      GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(247891), // Rule ID 20828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10800:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20828,
        GIR_EraseRootFromParent_Done,
      // Label 5076: @247891
      GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(247957), // Rule ID 20829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10800:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20829,
        GIR_EraseRootFromParent_Done,
      // Label 5077: @247957
      GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(248023), // Rule ID 20832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10800:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20832,
        GIR_EraseRootFromParent_Done,
      // Label 5078: @248023
      GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(248089), // Rule ID 20833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10800:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20833,
        GIR_EraseRootFromParent_Done,
      // Label 5079: @248089
      GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(248155), // Rule ID 20836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10800:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20836,
        GIR_EraseRootFromParent_Done,
      // Label 5080: @248155
      GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(248221), // Rule ID 20837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10800:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20837,
        GIR_EraseRootFromParent_Done,
      // Label 5081: @248221
      GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(248287), // Rule ID 21104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21104,
        GIR_EraseRootFromParent_Done,
      // Label 5082: @248287
      GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(248353), // Rule ID 21105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21105,
        GIR_EraseRootFromParent_Done,
      // Label 5083: @248353
      GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(248419), // Rule ID 21108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21108,
        GIR_EraseRootFromParent_Done,
      // Label 5084: @248419
      GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(248485), // Rule ID 21109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10898:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21109,
        GIR_EraseRootFromParent_Done,
      // Label 5085: @248485
      GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(248551), // Rule ID 21112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21112,
        GIR_EraseRootFromParent_Done,
      // Label 5086: @248551
      GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(248617), // Rule ID 21113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21113,
        GIR_EraseRootFromParent_Done,
      // Label 5087: @248617
      GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(248683), // Rule ID 21116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21116,
        GIR_EraseRootFromParent_Done,
      // Label 5088: @248683
      GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(248749), // Rule ID 21117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21117,
        GIR_EraseRootFromParent_Done,
      // Label 5089: @248749
      GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(248815), // Rule ID 21120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21120,
        GIR_EraseRootFromParent_Done,
      // Label 5090: @248815
      GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(248881), // Rule ID 21121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21121,
        GIR_EraseRootFromParent_Done,
      // Label 5091: @248881
      GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(248947), // Rule ID 21124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21124,
        GIR_EraseRootFromParent_Done,
      // Label 5092: @248947
      GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(249013), // Rule ID 21125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10898:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21125,
        GIR_EraseRootFromParent_Done,
      // Label 5093: @249013
      GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(249079), // Rule ID 21128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21128,
        GIR_EraseRootFromParent_Done,
      // Label 5094: @249079
      GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(249145), // Rule ID 21129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10898:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21129,
        GIR_EraseRootFromParent_Done,
      // Label 5095: @249145
      GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(249211), // Rule ID 21132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21132,
        GIR_EraseRootFromParent_Done,
      // Label 5096: @249211
      GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(249277), // Rule ID 21133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10898:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21133,
        GIR_EraseRootFromParent_Done,
      // Label 5097: @249277
      GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(249343), // Rule ID 21136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21136,
        GIR_EraseRootFromParent_Done,
      // Label 5098: @249343
      GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(249409), // Rule ID 21137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10898:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21137,
        GIR_EraseRootFromParent_Done,
      // Label 5099: @249409
      GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(249475), // Rule ID 21140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21140,
        GIR_EraseRootFromParent_Done,
      // Label 5100: @249475
      GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(249541), // Rule ID 21141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21141,
        GIR_EraseRootFromParent_Done,
      // Label 5101: @249541
      GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(249607), // Rule ID 21144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21144,
        GIR_EraseRootFromParent_Done,
      // Label 5102: @249607
      GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(249673), // Rule ID 21145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10896:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21145,
        GIR_EraseRootFromParent_Done,
      // Label 5103: @249673
      GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(249739), // Rule ID 21148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21148,
        GIR_EraseRootFromParent_Done,
      // Label 5104: @249739
      GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(249805), // Rule ID 21149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21149,
        GIR_EraseRootFromParent_Done,
      // Label 5105: @249805
      GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(249871), // Rule ID 21152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21152,
        GIR_EraseRootFromParent_Done,
      // Label 5106: @249871
      GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(249937), // Rule ID 21153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21153,
        GIR_EraseRootFromParent_Done,
      // Label 5107: @249937
      GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(250003), // Rule ID 21156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21156,
        GIR_EraseRootFromParent_Done,
      // Label 5108: @250003
      GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(250069), // Rule ID 21157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21157,
        GIR_EraseRootFromParent_Done,
      // Label 5109: @250069
      GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(250135), // Rule ID 21160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21160,
        GIR_EraseRootFromParent_Done,
      // Label 5110: @250135
      GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(250201), // Rule ID 21161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10896:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21161,
        GIR_EraseRootFromParent_Done,
      // Label 5111: @250201
      GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(250267), // Rule ID 21164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21164,
        GIR_EraseRootFromParent_Done,
      // Label 5112: @250267
      GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(250333), // Rule ID 21165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10896:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21165,
        GIR_EraseRootFromParent_Done,
      // Label 5113: @250333
      GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(250399), // Rule ID 21168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21168,
        GIR_EraseRootFromParent_Done,
      // Label 5114: @250399
      GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(250465), // Rule ID 21169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10896:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21169,
        GIR_EraseRootFromParent_Done,
      // Label 5115: @250465
      GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(250531), // Rule ID 21172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21172,
        GIR_EraseRootFromParent_Done,
      // Label 5116: @250531
      GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(250597), // Rule ID 21173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10896:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21173,
        GIR_EraseRootFromParent_Done,
      // Label 5117: @250597
      GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(250663), // Rule ID 21176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10894:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21176,
        GIR_EraseRootFromParent_Done,
      // Label 5118: @250663
      GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(250729), // Rule ID 21177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10894:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21177,
        GIR_EraseRootFromParent_Done,
      // Label 5119: @250729
      GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(250795), // Rule ID 21180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10894:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21180,
        GIR_EraseRootFromParent_Done,
      // Label 5120: @250795
      GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(250861), // Rule ID 21181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10894:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21181,
        GIR_EraseRootFromParent_Done,
      // Label 5121: @250861
      GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(250927), // Rule ID 21184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10894:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21184,
        GIR_EraseRootFromParent_Done,
      // Label 5122: @250927
      GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(250993), // Rule ID 21185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10894:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21185,
        GIR_EraseRootFromParent_Done,
      // Label 5123: @250993
      GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(251059), // Rule ID 21188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10894:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21188,
        GIR_EraseRootFromParent_Done,
      // Label 5124: @251059
      GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(251125), // Rule ID 21189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10894:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21189,
        GIR_EraseRootFromParent_Done,
      // Label 5125: @251125
      GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(251191), // Rule ID 21192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10894:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21192,
        GIR_EraseRootFromParent_Done,
      // Label 5126: @251191
      GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(251257), // Rule ID 21193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10894:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21193,
        GIR_EraseRootFromParent_Done,
      // Label 5127: @251257
      GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(251323), // Rule ID 21196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10894:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21196,
        GIR_EraseRootFromParent_Done,
      // Label 5128: @251323
      GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(251389), // Rule ID 21197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10894:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21197,
        GIR_EraseRootFromParent_Done,
      // Label 5129: @251389
      GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(251455), // Rule ID 21200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21200,
        GIR_EraseRootFromParent_Done,
      // Label 5130: @251455
      GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(251521), // Rule ID 21201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21201,
        GIR_EraseRootFromParent_Done,
      // Label 5131: @251521
      GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(251587), // Rule ID 21204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21204,
        GIR_EraseRootFromParent_Done,
      // Label 5132: @251587
      GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(251653), // Rule ID 21205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10894:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21205,
        GIR_EraseRootFromParent_Done,
      // Label 5133: @251653
      GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(251719), // Rule ID 21208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10894:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21208,
        GIR_EraseRootFromParent_Done,
      // Label 5134: @251719
      GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(251785), // Rule ID 21209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10894:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21209,
        GIR_EraseRootFromParent_Done,
      // Label 5135: @251785
      GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(251851), // Rule ID 21212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10894:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21212,
        GIR_EraseRootFromParent_Done,
      // Label 5136: @251851
      GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(251917), // Rule ID 21213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10894:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21213,
        GIR_EraseRootFromParent_Done,
      // Label 5137: @251917
      GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(251983), // Rule ID 21216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10894:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21216,
        GIR_EraseRootFromParent_Done,
      // Label 5138: @251983
      GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(252049), // Rule ID 21217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10894:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21217,
        GIR_EraseRootFromParent_Done,
      // Label 5139: @252049
      GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(252115), // Rule ID 21220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21220,
        GIR_EraseRootFromParent_Done,
      // Label 5140: @252115
      GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(252181), // Rule ID 21221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10894:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21221,
        GIR_EraseRootFromParent_Done,
      // Label 5141: @252181
      GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(252247), // Rule ID 21224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10894:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21224,
        GIR_EraseRootFromParent_Done,
      // Label 5142: @252247
      GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(252313), // Rule ID 21225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10894:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21225,
        GIR_EraseRootFromParent_Done,
      // Label 5143: @252313
      GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(252379), // Rule ID 21228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10894:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21228,
        GIR_EraseRootFromParent_Done,
      // Label 5144: @252379
      GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(252445), // Rule ID 21229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10894:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21229,
        GIR_EraseRootFromParent_Done,
      // Label 5145: @252445
      GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(252511), // Rule ID 21232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10894:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21232,
        GIR_EraseRootFromParent_Done,
      // Label 5146: @252511
      GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(252577), // Rule ID 21233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10894:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21233,
        GIR_EraseRootFromParent_Done,
      // Label 5147: @252577
      GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(252643), // Rule ID 21236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21236,
        GIR_EraseRootFromParent_Done,
      // Label 5148: @252643
      GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(252709), // Rule ID 21237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21237,
        GIR_EraseRootFromParent_Done,
      // Label 5149: @252709
      GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(252775), // Rule ID 21240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21240,
        GIR_EraseRootFromParent_Done,
      // Label 5150: @252775
      GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(252841), // Rule ID 21241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21241,
        GIR_EraseRootFromParent_Done,
      // Label 5151: @252841
      GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(252907), // Rule ID 21244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21244,
        GIR_EraseRootFromParent_Done,
      // Label 5152: @252907
      GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(252973), // Rule ID 21245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10892:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21245,
        GIR_EraseRootFromParent_Done,
      // Label 5153: @252973
      GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(253039), // Rule ID 21248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21248,
        GIR_EraseRootFromParent_Done,
      // Label 5154: @253039
      GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(253105), // Rule ID 21249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21249,
        GIR_EraseRootFromParent_Done,
      // Label 5155: @253105
      GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(253171), // Rule ID 21252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21252,
        GIR_EraseRootFromParent_Done,
      // Label 5156: @253171
      GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(253237), // Rule ID 21253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21253,
        GIR_EraseRootFromParent_Done,
      // Label 5157: @253237
      GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(253303), // Rule ID 21256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21256,
        GIR_EraseRootFromParent_Done,
      // Label 5158: @253303
      GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(253369), // Rule ID 21257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21257,
        GIR_EraseRootFromParent_Done,
      // Label 5159: @253369
      GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(253435), // Rule ID 21260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21260,
        GIR_EraseRootFromParent_Done,
      // Label 5160: @253435
      GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(253501), // Rule ID 21261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21261,
        GIR_EraseRootFromParent_Done,
      // Label 5161: @253501
      GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(253567), // Rule ID 21264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21264,
        GIR_EraseRootFromParent_Done,
      // Label 5162: @253567
      GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(253633), // Rule ID 21265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10892:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21265,
        GIR_EraseRootFromParent_Done,
      // Label 5163: @253633
      GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(253699), // Rule ID 21268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21268,
        GIR_EraseRootFromParent_Done,
      // Label 5164: @253699
      GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(253765), // Rule ID 21269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21269,
        GIR_EraseRootFromParent_Done,
      // Label 5165: @253765
      GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(253831), // Rule ID 21272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21272,
        GIR_EraseRootFromParent_Done,
      // Label 5166: @253831
      GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(253897), // Rule ID 21273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21273,
        GIR_EraseRootFromParent_Done,
      // Label 5167: @253897
      GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(253963), // Rule ID 21276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21276,
        GIR_EraseRootFromParent_Done,
      // Label 5168: @253963
      GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(254029), // Rule ID 21277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21277,
        GIR_EraseRootFromParent_Done,
      // Label 5169: @254029
      GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(254095), // Rule ID 21280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21280,
        GIR_EraseRootFromParent_Done,
      // Label 5170: @254095
      GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(254161), // Rule ID 21281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10892:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21281,
        GIR_EraseRootFromParent_Done,
      // Label 5171: @254161
      GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(254227), // Rule ID 21284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21284,
        GIR_EraseRootFromParent_Done,
      // Label 5172: @254227
      GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(254293), // Rule ID 21285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10892:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21285,
        GIR_EraseRootFromParent_Done,
      // Label 5173: @254293
      GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(254359), // Rule ID 21288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21288,
        GIR_EraseRootFromParent_Done,
      // Label 5174: @254359
      GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(254425), // Rule ID 21289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10892:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21289,
        GIR_EraseRootFromParent_Done,
      // Label 5175: @254425
      GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(254491), // Rule ID 21292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21292,
        GIR_EraseRootFromParent_Done,
      // Label 5176: @254491
      GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(254557), // Rule ID 21293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10892:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21293,
        GIR_EraseRootFromParent_Done,
      // Label 5177: @254557
      GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(254623), // Rule ID 21296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21296,
        GIR_EraseRootFromParent_Done,
      // Label 5178: @254623
      GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(254689), // Rule ID 21297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21297,
        GIR_EraseRootFromParent_Done,
      // Label 5179: @254689
      GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(254755), // Rule ID 21300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21300,
        GIR_EraseRootFromParent_Done,
      // Label 5180: @254755
      GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(254821), // Rule ID 21301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10890:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21301,
        GIR_EraseRootFromParent_Done,
      // Label 5181: @254821
      GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(254887), // Rule ID 21304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21304,
        GIR_EraseRootFromParent_Done,
      // Label 5182: @254887
      GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(254953), // Rule ID 21305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21305,
        GIR_EraseRootFromParent_Done,
      // Label 5183: @254953
      GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(255019), // Rule ID 21308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21308,
        GIR_EraseRootFromParent_Done,
      // Label 5184: @255019
      GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(255085), // Rule ID 21309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21309,
        GIR_EraseRootFromParent_Done,
      // Label 5185: @255085
      GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(255151), // Rule ID 21312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21312,
        GIR_EraseRootFromParent_Done,
      // Label 5186: @255151
      GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(255217), // Rule ID 21313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21313,
        GIR_EraseRootFromParent_Done,
      // Label 5187: @255217
      GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(255283), // Rule ID 21316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21316,
        GIR_EraseRootFromParent_Done,
      // Label 5188: @255283
      GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(255349), // Rule ID 21317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10890:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21317,
        GIR_EraseRootFromParent_Done,
      // Label 5189: @255349
      GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(255415), // Rule ID 21320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21320,
        GIR_EraseRootFromParent_Done,
      // Label 5190: @255415
      GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(255481), // Rule ID 21321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10890:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21321,
        GIR_EraseRootFromParent_Done,
      // Label 5191: @255481
      GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(255547), // Rule ID 21324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21324,
        GIR_EraseRootFromParent_Done,
      // Label 5192: @255547
      GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(255613), // Rule ID 21325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10890:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21325,
        GIR_EraseRootFromParent_Done,
      // Label 5193: @255613
      GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(255679), // Rule ID 21328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21328,
        GIR_EraseRootFromParent_Done,
      // Label 5194: @255679
      GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(255745), // Rule ID 21329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10890:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21329,
        GIR_EraseRootFromParent_Done,
      // Label 5195: @255745
      GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(255811), // Rule ID 21572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10840:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21572,
        GIR_EraseRootFromParent_Done,
      // Label 5196: @255811
      GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(255877), // Rule ID 21573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10840:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21573,
        GIR_EraseRootFromParent_Done,
      // Label 5197: @255877
      GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(255943), // Rule ID 21576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21576,
        GIR_EraseRootFromParent_Done,
      // Label 5198: @255943
      GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(256009), // Rule ID 21577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21577,
        GIR_EraseRootFromParent_Done,
      // Label 5199: @256009
      GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(256075), // Rule ID 21580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10840:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21580,
        GIR_EraseRootFromParent_Done,
      // Label 5200: @256075
      GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(256141), // Rule ID 21581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10840:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21581,
        GIR_EraseRootFromParent_Done,
      // Label 5201: @256141
      GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(256207), // Rule ID 21584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10840:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21584,
        GIR_EraseRootFromParent_Done,
      // Label 5202: @256207
      GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(256273), // Rule ID 21585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10840:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21585,
        GIR_EraseRootFromParent_Done,
      // Label 5203: @256273
      GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(256339), // Rule ID 21588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21588,
        GIR_EraseRootFromParent_Done,
      // Label 5204: @256339
      GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(256405), // Rule ID 21589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21589,
        GIR_EraseRootFromParent_Done,
      // Label 5205: @256405
      GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(256471), // Rule ID 21592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21592,
        GIR_EraseRootFromParent_Done,
      // Label 5206: @256471
      GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(256537), // Rule ID 21593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21593,
        GIR_EraseRootFromParent_Done,
      // Label 5207: @256537
      GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(256603), // Rule ID 21596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10840:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21596,
        GIR_EraseRootFromParent_Done,
      // Label 5208: @256603
      GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(256669), // Rule ID 21597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10840:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21597,
        GIR_EraseRootFromParent_Done,
      // Label 5209: @256669
      GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(256735), // Rule ID 21600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21600,
        GIR_EraseRootFromParent_Done,
      // Label 5210: @256735
      GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(256801), // Rule ID 21601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21601,
        GIR_EraseRootFromParent_Done,
      // Label 5211: @256801
      GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(256867), // Rule ID 21604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10840:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21604,
        GIR_EraseRootFromParent_Done,
      // Label 5212: @256867
      GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(256933), // Rule ID 21605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10840:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21605,
        GIR_EraseRootFromParent_Done,
      // Label 5213: @256933
      GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(256999), // Rule ID 21608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21608,
        GIR_EraseRootFromParent_Done,
      // Label 5214: @256999
      GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(257065), // Rule ID 21609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21609,
        GIR_EraseRootFromParent_Done,
      // Label 5215: @257065
      GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(257131), // Rule ID 21612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21612,
        GIR_EraseRootFromParent_Done,
      // Label 5216: @257131
      GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(257197), // Rule ID 21613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21613,
        GIR_EraseRootFromParent_Done,
      // Label 5217: @257197
      GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(257263), // Rule ID 21616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21616,
        GIR_EraseRootFromParent_Done,
      // Label 5218: @257263
      GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(257329), // Rule ID 21617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21617,
        GIR_EraseRootFromParent_Done,
      // Label 5219: @257329
      GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(257395), // Rule ID 21620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21620,
        GIR_EraseRootFromParent_Done,
      // Label 5220: @257395
      GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(257461), // Rule ID 21621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10840:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21621,
        GIR_EraseRootFromParent_Done,
      // Label 5221: @257461
      GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(257527), // Rule ID 21624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21624,
        GIR_EraseRootFromParent_Done,
      // Label 5222: @257527
      GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(257593), // Rule ID 21625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10840:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21625,
        GIR_EraseRootFromParent_Done,
      // Label 5223: @257593
      GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(257659), // Rule ID 21628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21628,
        GIR_EraseRootFromParent_Done,
      // Label 5224: @257659
      GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(257725), // Rule ID 21629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10840:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21629,
        GIR_EraseRootFromParent_Done,
      // Label 5225: @257725
      GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(257791), // Rule ID 21632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10838:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21632,
        GIR_EraseRootFromParent_Done,
      // Label 5226: @257791
      GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(257857), // Rule ID 21633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10838:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21633,
        GIR_EraseRootFromParent_Done,
      // Label 5227: @257857
      GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(257923), // Rule ID 21636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21636,
        GIR_EraseRootFromParent_Done,
      // Label 5228: @257923
      GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(257989), // Rule ID 21637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21637,
        GIR_EraseRootFromParent_Done,
      // Label 5229: @257989
      GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(258055), // Rule ID 21640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10838:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21640,
        GIR_EraseRootFromParent_Done,
      // Label 5230: @258055
      GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(258121), // Rule ID 21641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10838:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21641,
        GIR_EraseRootFromParent_Done,
      // Label 5231: @258121
      GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(258187), // Rule ID 21644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10838:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21644,
        GIR_EraseRootFromParent_Done,
      // Label 5232: @258187
      GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(258253), // Rule ID 21645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10838:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21645,
        GIR_EraseRootFromParent_Done,
      // Label 5233: @258253
      GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(258319), // Rule ID 21648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21648,
        GIR_EraseRootFromParent_Done,
      // Label 5234: @258319
      GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(258385), // Rule ID 21649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21649,
        GIR_EraseRootFromParent_Done,
      // Label 5235: @258385
      GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(258451), // Rule ID 21652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21652,
        GIR_EraseRootFromParent_Done,
      // Label 5236: @258451
      GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(258517), // Rule ID 21653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21653,
        GIR_EraseRootFromParent_Done,
      // Label 5237: @258517
      GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(258583), // Rule ID 21656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10838:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21656,
        GIR_EraseRootFromParent_Done,
      // Label 5238: @258583
      GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(258649), // Rule ID 21657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10838:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21657,
        GIR_EraseRootFromParent_Done,
      // Label 5239: @258649
      GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(258715), // Rule ID 21660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21660,
        GIR_EraseRootFromParent_Done,
      // Label 5240: @258715
      GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(258781), // Rule ID 21661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21661,
        GIR_EraseRootFromParent_Done,
      // Label 5241: @258781
      GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(258847), // Rule ID 21664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10838:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21664,
        GIR_EraseRootFromParent_Done,
      // Label 5242: @258847
      GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(258913), // Rule ID 21665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10838:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21665,
        GIR_EraseRootFromParent_Done,
      // Label 5243: @258913
      GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(258979), // Rule ID 21668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21668,
        GIR_EraseRootFromParent_Done,
      // Label 5244: @258979
      GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(259045), // Rule ID 21669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21669,
        GIR_EraseRootFromParent_Done,
      // Label 5245: @259045
      GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(259111), // Rule ID 21672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21672,
        GIR_EraseRootFromParent_Done,
      // Label 5246: @259111
      GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(259177), // Rule ID 21673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21673,
        GIR_EraseRootFromParent_Done,
      // Label 5247: @259177
      GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(259243), // Rule ID 21676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21676,
        GIR_EraseRootFromParent_Done,
      // Label 5248: @259243
      GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(259309), // Rule ID 21677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21677,
        GIR_EraseRootFromParent_Done,
      // Label 5249: @259309
      GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(259375), // Rule ID 21680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21680,
        GIR_EraseRootFromParent_Done,
      // Label 5250: @259375
      GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(259441), // Rule ID 21681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10838:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21681,
        GIR_EraseRootFromParent_Done,
      // Label 5251: @259441
      GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(259507), // Rule ID 21684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21684,
        GIR_EraseRootFromParent_Done,
      // Label 5252: @259507
      GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(259573), // Rule ID 21685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10838:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21685,
        GIR_EraseRootFromParent_Done,
      // Label 5253: @259573
      GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(259639), // Rule ID 21688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21688,
        GIR_EraseRootFromParent_Done,
      // Label 5254: @259639
      GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(259705), // Rule ID 21689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10838:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21689,
        GIR_EraseRootFromParent_Done,
      // Label 5255: @259705
      GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(259771), // Rule ID 21800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10836:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21800,
        GIR_EraseRootFromParent_Done,
      // Label 5256: @259771
      GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(259837), // Rule ID 21801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10836:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21801,
        GIR_EraseRootFromParent_Done,
      // Label 5257: @259837
      GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(259903), // Rule ID 21804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10836:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21804,
        GIR_EraseRootFromParent_Done,
      // Label 5258: @259903
      GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(259969), // Rule ID 21805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10836:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21805,
        GIR_EraseRootFromParent_Done,
      // Label 5259: @259969
      GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(260035), // Rule ID 21808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10836:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21808,
        GIR_EraseRootFromParent_Done,
      // Label 5260: @260035
      GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(260101), // Rule ID 21809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10836:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21809,
        GIR_EraseRootFromParent_Done,
      // Label 5261: @260101
      GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(260167), // Rule ID 21812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21812,
        GIR_EraseRootFromParent_Done,
      // Label 5262: @260167
      GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(260233), // Rule ID 21813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21813,
        GIR_EraseRootFromParent_Done,
      // Label 5263: @260233
      GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(260299), // Rule ID 21816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21816,
        GIR_EraseRootFromParent_Done,
      // Label 5264: @260299
      GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(260365), // Rule ID 21817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21817,
        GIR_EraseRootFromParent_Done,
      // Label 5265: @260365
      GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(260431), // Rule ID 21820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21820,
        GIR_EraseRootFromParent_Done,
      // Label 5266: @260431
      GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(260497), // Rule ID 21821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21821,
        GIR_EraseRootFromParent_Done,
      // Label 5267: @260497
      GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(260563), // Rule ID 21824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21824,
        GIR_EraseRootFromParent_Done,
      // Label 5268: @260563
      GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(260629), // Rule ID 21825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10836:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21825,
        GIR_EraseRootFromParent_Done,
      // Label 5269: @260629
      GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(260695), // Rule ID 21828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21828,
        GIR_EraseRootFromParent_Done,
      // Label 5270: @260695
      GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(260761), // Rule ID 21829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10836:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21829,
        GIR_EraseRootFromParent_Done,
      // Label 5271: @260761
      GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(260827), // Rule ID 21832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21832,
        GIR_EraseRootFromParent_Done,
      // Label 5272: @260827
      GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(260893), // Rule ID 21833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10836:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21833,
        GIR_EraseRootFromParent_Done,
      // Label 5273: @260893
      GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(260956), // Rule ID 23004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23004,
        GIR_EraseRootFromParent_Done,
      // Label 5274: @260956
      GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(261019), // Rule ID 23005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23005,
        GIR_EraseRootFromParent_Done,
      // Label 5275: @261019
      GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(261082), // Rule ID 23006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23006,
        GIR_EraseRootFromParent_Done,
      // Label 5276: @261082
      GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(261145), // Rule ID 23007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23007,
        GIR_EraseRootFromParent_Done,
      // Label 5277: @261145
      GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(261208), // Rule ID 23008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23008,
        GIR_EraseRootFromParent_Done,
      // Label 5278: @261208
      GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(261271), // Rule ID 23009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23009,
        GIR_EraseRootFromParent_Done,
      // Label 5279: @261271
      GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(261334), // Rule ID 23010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23010,
        GIR_EraseRootFromParent_Done,
      // Label 5280: @261334
      GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(261397), // Rule ID 23011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23011,
        GIR_EraseRootFromParent_Done,
      // Label 5281: @261397
      GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(261460), // Rule ID 23012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23012,
        GIR_EraseRootFromParent_Done,
      // Label 5282: @261460
      GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(261523), // Rule ID 23013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23013,
        GIR_EraseRootFromParent_Done,
      // Label 5283: @261523
      GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(261586), // Rule ID 23014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23014,
        GIR_EraseRootFromParent_Done,
      // Label 5284: @261586
      GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(261649), // Rule ID 23015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11019:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23015,
        GIR_EraseRootFromParent_Done,
      // Label 5285: @261649
      GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(261712), // Rule ID 23016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23016,
        GIR_EraseRootFromParent_Done,
      // Label 5286: @261712
      GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(261775), // Rule ID 23017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23017,
        GIR_EraseRootFromParent_Done,
      // Label 5287: @261775
      GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(261838), // Rule ID 23018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23018,
        GIR_EraseRootFromParent_Done,
      // Label 5288: @261838
      GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(261901), // Rule ID 23019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23019,
        GIR_EraseRootFromParent_Done,
      // Label 5289: @261901
      GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(261964), // Rule ID 23020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23020,
        GIR_EraseRootFromParent_Done,
      // Label 5290: @261964
      GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(262027), // Rule ID 23021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23021,
        GIR_EraseRootFromParent_Done,
      // Label 5291: @262027
      GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(262090), // Rule ID 23022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23022,
        GIR_EraseRootFromParent_Done,
      // Label 5292: @262090
      GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(262153), // Rule ID 23023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23023,
        GIR_EraseRootFromParent_Done,
      // Label 5293: @262153
      GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(262216), // Rule ID 23024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23024,
        GIR_EraseRootFromParent_Done,
      // Label 5294: @262216
      GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(262279), // Rule ID 23025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23025,
        GIR_EraseRootFromParent_Done,
      // Label 5295: @262279
      GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(262342), // Rule ID 23026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23026,
        GIR_EraseRootFromParent_Done,
      // Label 5296: @262342
      GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(262405), // Rule ID 23027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23027,
        GIR_EraseRootFromParent_Done,
      // Label 5297: @262405
      GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(262468), // Rule ID 23028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23028,
        GIR_EraseRootFromParent_Done,
      // Label 5298: @262468
      GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(262531), // Rule ID 23029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11043:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23029,
        GIR_EraseRootFromParent_Done,
      // Label 5299: @262531
      GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(262594), // Rule ID 23030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23030,
        GIR_EraseRootFromParent_Done,
      // Label 5300: @262594
      GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(262657), // Rule ID 23031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23031,
        GIR_EraseRootFromParent_Done,
      // Label 5301: @262657
      GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(262720), // Rule ID 23032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23032,
        GIR_EraseRootFromParent_Done,
      // Label 5302: @262720
      GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(262783), // Rule ID 23033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23033,
        GIR_EraseRootFromParent_Done,
      // Label 5303: @262783
      GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(262846), // Rule ID 23034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23034,
        GIR_EraseRootFromParent_Done,
      // Label 5304: @262846
      GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(262909), // Rule ID 23035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23035,
        GIR_EraseRootFromParent_Done,
      // Label 5305: @262909
      GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(262972), // Rule ID 23036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23036,
        GIR_EraseRootFromParent_Done,
      // Label 5306: @262972
      GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(263035), // Rule ID 23037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23037,
        GIR_EraseRootFromParent_Done,
      // Label 5307: @263035
      GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(263098), // Rule ID 23038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23038,
        GIR_EraseRootFromParent_Done,
      // Label 5308: @263098
      GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(263161), // Rule ID 23039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23039,
        GIR_EraseRootFromParent_Done,
      // Label 5309: @263161
      GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(263224), // Rule ID 23040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23040,
        GIR_EraseRootFromParent_Done,
      // Label 5310: @263224
      GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(263287), // Rule ID 23041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23041,
        GIR_EraseRootFromParent_Done,
      // Label 5311: @263287
      GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(263350), // Rule ID 23042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23042,
        GIR_EraseRootFromParent_Done,
      // Label 5312: @263350
      GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(263413), // Rule ID 23043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11020:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23043,
        GIR_EraseRootFromParent_Done,
      // Label 5313: @263413
      GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(263476), // Rule ID 23044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23044,
        GIR_EraseRootFromParent_Done,
      // Label 5314: @263476
      GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(263539), // Rule ID 23045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23045,
        GIR_EraseRootFromParent_Done,
      // Label 5315: @263539
      GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(263602), // Rule ID 23046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23046,
        GIR_EraseRootFromParent_Done,
      // Label 5316: @263602
      GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(263665), // Rule ID 23047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23047,
        GIR_EraseRootFromParent_Done,
      // Label 5317: @263665
      GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(263728), // Rule ID 23048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23048,
        GIR_EraseRootFromParent_Done,
      // Label 5318: @263728
      GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(263791), // Rule ID 23049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23049,
        GIR_EraseRootFromParent_Done,
      // Label 5319: @263791
      GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(263854), // Rule ID 23050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23050,
        GIR_EraseRootFromParent_Done,
      // Label 5320: @263854
      GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(263917), // Rule ID 23051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23051,
        GIR_EraseRootFromParent_Done,
      // Label 5321: @263917
      GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(263980), // Rule ID 23052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23052,
        GIR_EraseRootFromParent_Done,
      // Label 5322: @263980
      GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(264043), // Rule ID 23053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23053,
        GIR_EraseRootFromParent_Done,
      // Label 5323: @264043
      GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(264106), // Rule ID 23054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23054,
        GIR_EraseRootFromParent_Done,
      // Label 5324: @264106
      GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(264169), // Rule ID 23055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23055,
        GIR_EraseRootFromParent_Done,
      // Label 5325: @264169
      GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(264232), // Rule ID 23056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23056,
        GIR_EraseRootFromParent_Done,
      // Label 5326: @264232
      GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(264295), // Rule ID 23057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11089:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23057,
        GIR_EraseRootFromParent_Done,
      // Label 5327: @264295
      GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(264358), // Rule ID 23058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23058,
        GIR_EraseRootFromParent_Done,
      // Label 5328: @264358
      GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(264421), // Rule ID 23059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23059,
        GIR_EraseRootFromParent_Done,
      // Label 5329: @264421
      GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(264484), // Rule ID 23060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23060,
        GIR_EraseRootFromParent_Done,
      // Label 5330: @264484
      GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(264547), // Rule ID 23061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23061,
        GIR_EraseRootFromParent_Done,
      // Label 5331: @264547
      GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(264610), // Rule ID 23062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23062,
        GIR_EraseRootFromParent_Done,
      // Label 5332: @264610
      GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(264673), // Rule ID 23063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23063,
        GIR_EraseRootFromParent_Done,
      // Label 5333: @264673
      GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(264736), // Rule ID 23064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23064,
        GIR_EraseRootFromParent_Done,
      // Label 5334: @264736
      GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(264799), // Rule ID 23065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23065,
        GIR_EraseRootFromParent_Done,
      // Label 5335: @264799
      GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(264862), // Rule ID 23066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23066,
        GIR_EraseRootFromParent_Done,
      // Label 5336: @264862
      GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(264925), // Rule ID 23067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23067,
        GIR_EraseRootFromParent_Done,
      // Label 5337: @264925
      GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(264988), // Rule ID 23068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23068,
        GIR_EraseRootFromParent_Done,
      // Label 5338: @264988
      GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(265051), // Rule ID 23069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23069,
        GIR_EraseRootFromParent_Done,
      // Label 5339: @265051
      GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(265114), // Rule ID 23070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23070,
        GIR_EraseRootFromParent_Done,
      // Label 5340: @265114
      GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(265177), // Rule ID 23071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11045:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23071,
        GIR_EraseRootFromParent_Done,
      // Label 5341: @265177
      GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(265240), // Rule ID 23072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23072,
        GIR_EraseRootFromParent_Done,
      // Label 5342: @265240
      GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(265303), // Rule ID 23073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23073,
        GIR_EraseRootFromParent_Done,
      // Label 5343: @265303
      GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(265366), // Rule ID 23074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23074,
        GIR_EraseRootFromParent_Done,
      // Label 5344: @265366
      GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(265429), // Rule ID 23075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23075,
        GIR_EraseRootFromParent_Done,
      // Label 5345: @265429
      GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(265492), // Rule ID 23076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23076,
        GIR_EraseRootFromParent_Done,
      // Label 5346: @265492
      GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(265555), // Rule ID 23077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23077,
        GIR_EraseRootFromParent_Done,
      // Label 5347: @265555
      GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(265618), // Rule ID 23078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23078,
        GIR_EraseRootFromParent_Done,
      // Label 5348: @265618
      GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(265681), // Rule ID 23079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23079,
        GIR_EraseRootFromParent_Done,
      // Label 5349: @265681
      GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(265744), // Rule ID 23080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23080,
        GIR_EraseRootFromParent_Done,
      // Label 5350: @265744
      GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(265807), // Rule ID 23081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23081,
        GIR_EraseRootFromParent_Done,
      // Label 5351: @265807
      GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(265870), // Rule ID 23082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23082,
        GIR_EraseRootFromParent_Done,
      // Label 5352: @265870
      GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(265933), // Rule ID 23083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23083,
        GIR_EraseRootFromParent_Done,
      // Label 5353: @265933
      GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(265996), // Rule ID 23084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23084,
        GIR_EraseRootFromParent_Done,
      // Label 5354: @265996
      GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(266059), // Rule ID 23085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11044:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23085,
        GIR_EraseRootFromParent_Done,
      // Label 5355: @266059
      GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(266122), // Rule ID 23086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23086,
        GIR_EraseRootFromParent_Done,
      // Label 5356: @266122
      GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(266185), // Rule ID 23087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23087,
        GIR_EraseRootFromParent_Done,
      // Label 5357: @266185
      GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(266248), // Rule ID 23088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23088,
        GIR_EraseRootFromParent_Done,
      // Label 5358: @266248
      GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(266311), // Rule ID 23089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23089,
        GIR_EraseRootFromParent_Done,
      // Label 5359: @266311
      GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(266374), // Rule ID 23090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23090,
        GIR_EraseRootFromParent_Done,
      // Label 5360: @266374
      GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(266437), // Rule ID 23091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23091,
        GIR_EraseRootFromParent_Done,
      // Label 5361: @266437
      GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(266500), // Rule ID 23092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23092,
        GIR_EraseRootFromParent_Done,
      // Label 5362: @266500
      GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(266563), // Rule ID 23093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23093,
        GIR_EraseRootFromParent_Done,
      // Label 5363: @266563
      GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(266626), // Rule ID 23094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23094,
        GIR_EraseRootFromParent_Done,
      // Label 5364: @266626
      GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(266689), // Rule ID 23095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23095,
        GIR_EraseRootFromParent_Done,
      // Label 5365: @266689
      GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(266752), // Rule ID 23096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23096,
        GIR_EraseRootFromParent_Done,
      // Label 5366: @266752
      GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(266815), // Rule ID 23097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23097,
        GIR_EraseRootFromParent_Done,
      // Label 5367: @266815
      GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(266878), // Rule ID 23098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23098,
        GIR_EraseRootFromParent_Done,
      // Label 5368: @266878
      GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(266941), // Rule ID 23099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11046:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23099,
        GIR_EraseRootFromParent_Done,
      // Label 5369: @266941
      GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(267004), // Rule ID 23100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23100,
        GIR_EraseRootFromParent_Done,
      // Label 5370: @267004
      GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(267067), // Rule ID 23101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23101,
        GIR_EraseRootFromParent_Done,
      // Label 5371: @267067
      GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(267130), // Rule ID 23102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23102,
        GIR_EraseRootFromParent_Done,
      // Label 5372: @267130
      GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(267193), // Rule ID 23103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23103,
        GIR_EraseRootFromParent_Done,
      // Label 5373: @267193
      GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(267256), // Rule ID 23104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23104,
        GIR_EraseRootFromParent_Done,
      // Label 5374: @267256
      GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(267319), // Rule ID 23105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23105,
        GIR_EraseRootFromParent_Done,
      // Label 5375: @267319
      GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(267382), // Rule ID 23106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23106,
        GIR_EraseRootFromParent_Done,
      // Label 5376: @267382
      GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(267445), // Rule ID 23107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23107,
        GIR_EraseRootFromParent_Done,
      // Label 5377: @267445
      GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(267508), // Rule ID 23108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23108,
        GIR_EraseRootFromParent_Done,
      // Label 5378: @267508
      GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(267571), // Rule ID 23109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23109,
        GIR_EraseRootFromParent_Done,
      // Label 5379: @267571
      GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(267634), // Rule ID 23110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23110,
        GIR_EraseRootFromParent_Done,
      // Label 5380: @267634
      GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(267697), // Rule ID 23111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23111,
        GIR_EraseRootFromParent_Done,
      // Label 5381: @267697
      GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(267760), // Rule ID 23112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23112,
        GIR_EraseRootFromParent_Done,
      // Label 5382: @267760
      GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(267823), // Rule ID 23113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11088:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23113,
        GIR_EraseRootFromParent_Done,
      // Label 5383: @267823
      GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(267904), // Rule ID 23142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10783:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23142,
        GIR_EraseRootFromParent_Done,
      // Label 5384: @267904
      GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(267985), // Rule ID 23143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10783:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23143,
        GIR_EraseRootFromParent_Done,
      // Label 5385: @267985
      GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(268066), // Rule ID 23146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10783:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23146,
        GIR_EraseRootFromParent_Done,
      // Label 5386: @268066
      GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(268147), // Rule ID 23147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10783:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23147,
        GIR_EraseRootFromParent_Done,
      // Label 5387: @268147
      GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(268228), // Rule ID 23150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10783:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23150,
        GIR_EraseRootFromParent_Done,
      // Label 5388: @268228
      GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(268309), // Rule ID 23151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10783:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23151,
        GIR_EraseRootFromParent_Done,
      // Label 5389: @268309
      GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(268390), // Rule ID 23154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10783:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23154,
        GIR_EraseRootFromParent_Done,
      // Label 5390: @268390
      GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(268471), // Rule ID 23155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10783:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23155,
        GIR_EraseRootFromParent_Done,
      // Label 5391: @268471
      GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(268552), // Rule ID 23158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10783:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23158,
        GIR_EraseRootFromParent_Done,
      // Label 5392: @268552
      GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(268633), // Rule ID 23159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10783:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23159,
        GIR_EraseRootFromParent_Done,
      // Label 5393: @268633
      GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(268714), // Rule ID 23162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10783:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23162,
        GIR_EraseRootFromParent_Done,
      // Label 5394: @268714
      GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(268795), // Rule ID 23163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10783:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23163,
        GIR_EraseRootFromParent_Done,
      // Label 5395: @268795
      GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(268876), // Rule ID 23166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10811:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23166,
        GIR_EraseRootFromParent_Done,
      // Label 5396: @268876
      GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(268957), // Rule ID 23167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10811:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23167,
        GIR_EraseRootFromParent_Done,
      // Label 5397: @268957
      GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(269038), // Rule ID 23170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10811:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23170,
        GIR_EraseRootFromParent_Done,
      // Label 5398: @269038
      GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(269119), // Rule ID 23171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10811:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23171,
        GIR_EraseRootFromParent_Done,
      // Label 5399: @269119
      GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(269200), // Rule ID 23174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10811:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23174,
        GIR_EraseRootFromParent_Done,
      // Label 5400: @269200
      GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(269281), // Rule ID 23175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10811:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23175,
        GIR_EraseRootFromParent_Done,
      // Label 5401: @269281
      GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(269362), // Rule ID 23178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10811:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23178,
        GIR_EraseRootFromParent_Done,
      // Label 5402: @269362
      GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(269443), // Rule ID 23179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10811:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23179,
        GIR_EraseRootFromParent_Done,
      // Label 5403: @269443
      GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(269524), // Rule ID 23182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10811:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23182,
        GIR_EraseRootFromParent_Done,
      // Label 5404: @269524
      GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(269605), // Rule ID 23183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10811:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23183,
        GIR_EraseRootFromParent_Done,
      // Label 5405: @269605
      GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(269686), // Rule ID 23186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10811:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23186,
        GIR_EraseRootFromParent_Done,
      // Label 5406: @269686
      GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(269767), // Rule ID 23187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10811:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23187,
        GIR_EraseRootFromParent_Done,
      // Label 5407: @269767
      GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(269848), // Rule ID 23190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i64] } 10811:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23190,
        GIR_EraseRootFromParent_Done,
      // Label 5408: @269848
      GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(269929), // Rule ID 23191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[i32] } 10811:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23191,
        GIR_EraseRootFromParent_Done,
      // Label 5409: @269929
      GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(269995), // Rule ID 23272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10930:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23272,
        GIR_EraseRootFromParent_Done,
      // Label 5410: @269995
      GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(270061), // Rule ID 23273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10930:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23273,
        GIR_EraseRootFromParent_Done,
      // Label 5411: @270061
      GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(270127), // Rule ID 23276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10930:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23276,
        GIR_EraseRootFromParent_Done,
      // Label 5412: @270127
      GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(270193), // Rule ID 23277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10930:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23277,
        GIR_EraseRootFromParent_Done,
      // Label 5413: @270193
      GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(270259), // Rule ID 23280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10930:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23280,
        GIR_EraseRootFromParent_Done,
      // Label 5414: @270259
      GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(270325), // Rule ID 23281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10930:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23281,
        GIR_EraseRootFromParent_Done,
      // Label 5415: @270325
      GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(270391), // Rule ID 23284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10930:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23284,
        GIR_EraseRootFromParent_Done,
      // Label 5416: @270391
      GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(270457), // Rule ID 23285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10930:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23285,
        GIR_EraseRootFromParent_Done,
      // Label 5417: @270457
      GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(270523), // Rule ID 23288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10930:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23288,
        GIR_EraseRootFromParent_Done,
      // Label 5418: @270523
      GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(270589), // Rule ID 23289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10930:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23289,
        GIR_EraseRootFromParent_Done,
      // Label 5419: @270589
      GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(270655), // Rule ID 23292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10930:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23292,
        GIR_EraseRootFromParent_Done,
      // Label 5420: @270655
      GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(270721), // Rule ID 23293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10930:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23293,
        GIR_EraseRootFromParent_Done,
      // Label 5421: @270721
      GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(270787), // Rule ID 23296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10930:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23296,
        GIR_EraseRootFromParent_Done,
      // Label 5422: @270787
      GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(270853), // Rule ID 23297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10930:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23297,
        GIR_EraseRootFromParent_Done,
      // Label 5423: @270853
      GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(270919), // Rule ID 23300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10930:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23300,
        GIR_EraseRootFromParent_Done,
      // Label 5424: @270919
      GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(270985), // Rule ID 23301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10930:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23301,
        GIR_EraseRootFromParent_Done,
      // Label 5425: @270985
      GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(271051), // Rule ID 23304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10930:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23304,
        GIR_EraseRootFromParent_Done,
      // Label 5426: @271051
      GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(271117), // Rule ID 23305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10930:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23305,
        GIR_EraseRootFromParent_Done,
      // Label 5427: @271117
      GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(271183), // Rule ID 23308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10930:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23308,
        GIR_EraseRootFromParent_Done,
      // Label 5428: @271183
      GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(271249), // Rule ID 23309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10930:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23309,
        GIR_EraseRootFromParent_Done,
      // Label 5429: @271249
      GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(271315), // Rule ID 23312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10930:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23312,
        GIR_EraseRootFromParent_Done,
      // Label 5430: @271315
      GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(271381), // Rule ID 23313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10930:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23313,
        GIR_EraseRootFromParent_Done,
      // Label 5431: @271381
      GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(271447), // Rule ID 23316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10930:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23316,
        GIR_EraseRootFromParent_Done,
      // Label 5432: @271447
      GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(271513), // Rule ID 23317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10930:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23317,
        GIR_EraseRootFromParent_Done,
      // Label 5433: @271513
      GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271579), // Rule ID 23320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10930:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23320,
        GIR_EraseRootFromParent_Done,
      // Label 5434: @271579
      GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(271645), // Rule ID 23321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10930:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23321,
        GIR_EraseRootFromParent_Done,
      // Label 5435: @271645
      GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(271711), // Rule ID 23324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10930:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23324,
        GIR_EraseRootFromParent_Done,
      // Label 5436: @271711
      GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(271777), // Rule ID 23325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10930:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23325,
        GIR_EraseRootFromParent_Done,
      // Label 5437: @271777
      GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(271843), // Rule ID 23328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10930:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23328,
        GIR_EraseRootFromParent_Done,
      // Label 5438: @271843
      GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(271909), // Rule ID 23329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10930:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23329,
        GIR_EraseRootFromParent_Done,
      // Label 5439: @271909
      GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(271975), // Rule ID 23332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10930:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23332,
        GIR_EraseRootFromParent_Done,
      // Label 5440: @271975
      GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(272041), // Rule ID 23333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10930:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23333,
        GIR_EraseRootFromParent_Done,
      // Label 5441: @272041
      GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(272107), // Rule ID 23336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10930:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23336,
        GIR_EraseRootFromParent_Done,
      // Label 5442: @272107
      GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(272173), // Rule ID 23337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10930:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23337,
        GIR_EraseRootFromParent_Done,
      // Label 5443: @272173
      GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(272239), // Rule ID 23340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10930:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23340,
        GIR_EraseRootFromParent_Done,
      // Label 5444: @272239
      GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(272305), // Rule ID 23341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10930:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23341,
        GIR_EraseRootFromParent_Done,
      // Label 5445: @272305
      GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(272371), // Rule ID 23344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10930:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23344,
        GIR_EraseRootFromParent_Done,
      // Label 5446: @272371
      GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(272437), // Rule ID 23345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10930:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23345,
        GIR_EraseRootFromParent_Done,
      // Label 5447: @272437
      GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(272503), // Rule ID 23348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10930:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23348,
        GIR_EraseRootFromParent_Done,
      // Label 5448: @272503
      GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(272569), // Rule ID 23349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10930:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23349,
        GIR_EraseRootFromParent_Done,
      // Label 5449: @272569
      GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(272635), // Rule ID 23352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10930:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23352,
        GIR_EraseRootFromParent_Done,
      // Label 5450: @272635
      GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(272701), // Rule ID 23353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10930:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23353,
        GIR_EraseRootFromParent_Done,
      // Label 5451: @272701
      GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(272767), // Rule ID 59992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10771:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59992,
        GIR_EraseRootFromParent_Done,
      // Label 5452: @272767
      GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(272833), // Rule ID 59993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10771:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59993,
        GIR_EraseRootFromParent_Done,
      // Label 5453: @272833
      GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(272899), // Rule ID 59996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10771:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59996,
        GIR_EraseRootFromParent_Done,
      // Label 5454: @272899
      GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(272965), // Rule ID 59997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10771:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59997,
        GIR_EraseRootFromParent_Done,
      // Label 5455: @272965
      GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(273031), // Rule ID 60000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10771:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60000,
        GIR_EraseRootFromParent_Done,
      // Label 5456: @273031
      GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(273097), // Rule ID 60001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10771:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60001,
        GIR_EraseRootFromParent_Done,
      // Label 5457: @273097
      GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(273163), // Rule ID 60004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10771:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60004,
        GIR_EraseRootFromParent_Done,
      // Label 5458: @273163
      GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(273229), // Rule ID 60005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10771:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60005,
        GIR_EraseRootFromParent_Done,
      // Label 5459: @273229
      GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(273295), // Rule ID 60008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10771:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60008,
        GIR_EraseRootFromParent_Done,
      // Label 5460: @273295
      GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(273361), // Rule ID 60009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10771:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60009,
        GIR_EraseRootFromParent_Done,
      // Label 5461: @273361
      GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(273427), // Rule ID 60012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10771:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60012,
        GIR_EraseRootFromParent_Done,
      // Label 5462: @273427
      GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(273493), // Rule ID 60013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10771:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60013,
        GIR_EraseRootFromParent_Done,
      // Label 5463: @273493
      GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(273559), // Rule ID 60016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10771:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60016,
        GIR_EraseRootFromParent_Done,
      // Label 5464: @273559
      GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(273625), // Rule ID 60017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10771:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60017,
        GIR_EraseRootFromParent_Done,
      // Label 5465: @273625
      GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(273691), // Rule ID 60020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10771:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60020,
        GIR_EraseRootFromParent_Done,
      // Label 5466: @273691
      GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(273757), // Rule ID 60021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10771:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60021,
        GIR_EraseRootFromParent_Done,
      // Label 5467: @273757
      GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(273823), // Rule ID 60024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10771:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60024,
        GIR_EraseRootFromParent_Done,
      // Label 5468: @273823
      GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(273889), // Rule ID 60025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10771:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60025,
        GIR_EraseRootFromParent_Done,
      // Label 5469: @273889
      GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(273955), // Rule ID 60028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10771:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60028,
        GIR_EraseRootFromParent_Done,
      // Label 5470: @273955
      GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(274021), // Rule ID 60029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10771:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60029,
        GIR_EraseRootFromParent_Done,
      // Label 5471: @274021
      GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(274087), // Rule ID 60032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10771:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60032,
        GIR_EraseRootFromParent_Done,
      // Label 5472: @274087
      GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(274153), // Rule ID 60033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10771:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60033,
        GIR_EraseRootFromParent_Done,
      // Label 5473: @274153
      GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(274219), // Rule ID 60036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10771:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60036,
        GIR_EraseRootFromParent_Done,
      // Label 5474: @274219
      GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(274285), // Rule ID 60037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10771:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60037,
        GIR_EraseRootFromParent_Done,
      // Label 5475: @274285
      GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(274351), // Rule ID 60040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10771:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60040,
        GIR_EraseRootFromParent_Done,
      // Label 5476: @274351
      GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(274417), // Rule ID 60041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10771:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60041,
        GIR_EraseRootFromParent_Done,
      // Label 5477: @274417
      GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(274483), // Rule ID 60044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10771:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60044,
        GIR_EraseRootFromParent_Done,
      // Label 5478: @274483
      GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(274549), // Rule ID 60045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10771:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60045,
        GIR_EraseRootFromParent_Done,
      // Label 5479: @274549
      GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(274615), // Rule ID 60048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10771:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60048,
        GIR_EraseRootFromParent_Done,
      // Label 5480: @274615
      GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(274681), // Rule ID 60049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10771:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60049,
        GIR_EraseRootFromParent_Done,
      // Label 5481: @274681
      GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(274747), // Rule ID 60052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10771:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60052,
        GIR_EraseRootFromParent_Done,
      // Label 5482: @274747
      GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(274813), // Rule ID 60053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10771:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60053,
        GIR_EraseRootFromParent_Done,
      // Label 5483: @274813
      GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(274879), // Rule ID 60056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10771:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60056,
        GIR_EraseRootFromParent_Done,
      // Label 5484: @274879
      GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(274945), // Rule ID 60057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10771:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60057,
        GIR_EraseRootFromParent_Done,
      // Label 5485: @274945
      GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(275011), // Rule ID 60060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10771:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60060,
        GIR_EraseRootFromParent_Done,
      // Label 5486: @275011
      GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(275077), // Rule ID 60061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10771:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60061,
        GIR_EraseRootFromParent_Done,
      // Label 5487: @275077
      GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(275143), // Rule ID 60064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10771:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60064,
        GIR_EraseRootFromParent_Done,
      // Label 5488: @275143
      GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(275209), // Rule ID 60065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10771:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60065,
        GIR_EraseRootFromParent_Done,
      // Label 5489: @275209
      GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(275275), // Rule ID 60068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10771:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60068,
        GIR_EraseRootFromParent_Done,
      // Label 5490: @275275
      GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(275341), // Rule ID 60069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10771:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60069,
        GIR_EraseRootFromParent_Done,
      // Label 5491: @275341
      GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(275407), // Rule ID 60072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10771:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60072,
        GIR_EraseRootFromParent_Done,
      // Label 5492: @275407
      GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(275473), // Rule ID 60073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10771:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60073,
        GIR_EraseRootFromParent_Done,
      // Label 5493: @275473
      GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(275539), // Rule ID 60076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10771:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60076,
        GIR_EraseRootFromParent_Done,
      // Label 5494: @275539
      GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(275605), // Rule ID 60077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10771:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60077,
        GIR_EraseRootFromParent_Done,
      // Label 5495: @275605
      GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(275671), // Rule ID 60080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10779:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60080,
        GIR_EraseRootFromParent_Done,
      // Label 5496: @275671
      GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(275737), // Rule ID 60081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10779:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60081,
        GIR_EraseRootFromParent_Done,
      // Label 5497: @275737
      GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(275803), // Rule ID 60084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10779:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60084,
        GIR_EraseRootFromParent_Done,
      // Label 5498: @275803
      GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(275869), // Rule ID 60085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10779:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60085,
        GIR_EraseRootFromParent_Done,
      // Label 5499: @275869
      GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(275935), // Rule ID 60088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10779:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60088,
        GIR_EraseRootFromParent_Done,
      // Label 5500: @275935
      GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(276001), // Rule ID 60089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10779:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60089,
        GIR_EraseRootFromParent_Done,
      // Label 5501: @276001
      GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(276067), // Rule ID 60092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10779:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60092,
        GIR_EraseRootFromParent_Done,
      // Label 5502: @276067
      GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(276133), // Rule ID 60093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10779:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60093,
        GIR_EraseRootFromParent_Done,
      // Label 5503: @276133
      GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(276199), // Rule ID 60096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10779:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60096,
        GIR_EraseRootFromParent_Done,
      // Label 5504: @276199
      GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(276265), // Rule ID 60097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10779:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60097,
        GIR_EraseRootFromParent_Done,
      // Label 5505: @276265
      GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(276331), // Rule ID 60100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10779:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60100,
        GIR_EraseRootFromParent_Done,
      // Label 5506: @276331
      GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(276397), // Rule ID 60101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10779:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60101,
        GIR_EraseRootFromParent_Done,
      // Label 5507: @276397
      GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(276463), // Rule ID 60104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10779:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60104,
        GIR_EraseRootFromParent_Done,
      // Label 5508: @276463
      GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(276529), // Rule ID 60105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10779:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60105,
        GIR_EraseRootFromParent_Done,
      // Label 5509: @276529
      GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(276595), // Rule ID 60108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10779:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60108,
        GIR_EraseRootFromParent_Done,
      // Label 5510: @276595
      GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(276661), // Rule ID 60109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10779:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60109,
        GIR_EraseRootFromParent_Done,
      // Label 5511: @276661
      GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(276727), // Rule ID 60112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10779:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60112,
        GIR_EraseRootFromParent_Done,
      // Label 5512: @276727
      GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(276793), // Rule ID 60113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10779:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60113,
        GIR_EraseRootFromParent_Done,
      // Label 5513: @276793
      GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(276859), // Rule ID 60116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10779:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60116,
        GIR_EraseRootFromParent_Done,
      // Label 5514: @276859
      GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(276925), // Rule ID 60117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10779:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60117,
        GIR_EraseRootFromParent_Done,
      // Label 5515: @276925
      GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(276991), // Rule ID 60120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10779:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60120,
        GIR_EraseRootFromParent_Done,
      // Label 5516: @276991
      GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(277057), // Rule ID 60121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10779:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60121,
        GIR_EraseRootFromParent_Done,
      // Label 5517: @277057
      GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(277123), // Rule ID 60124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10779:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60124,
        GIR_EraseRootFromParent_Done,
      // Label 5518: @277123
      GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(277189), // Rule ID 60125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10779:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60125,
        GIR_EraseRootFromParent_Done,
      // Label 5519: @277189
      GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(277255), // Rule ID 60128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10779:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60128,
        GIR_EraseRootFromParent_Done,
      // Label 5520: @277255
      GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(277321), // Rule ID 60129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10779:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60129,
        GIR_EraseRootFromParent_Done,
      // Label 5521: @277321
      GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(277387), // Rule ID 60132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10779:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60132,
        GIR_EraseRootFromParent_Done,
      // Label 5522: @277387
      GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(277453), // Rule ID 60133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10779:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60133,
        GIR_EraseRootFromParent_Done,
      // Label 5523: @277453
      GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(277519), // Rule ID 60136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10779:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60136,
        GIR_EraseRootFromParent_Done,
      // Label 5524: @277519
      GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(277585), // Rule ID 60137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10779:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60137,
        GIR_EraseRootFromParent_Done,
      // Label 5525: @277585
      GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(277651), // Rule ID 60140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10779:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60140,
        GIR_EraseRootFromParent_Done,
      // Label 5526: @277651
      GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(277717), // Rule ID 60141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10779:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60141,
        GIR_EraseRootFromParent_Done,
      // Label 5527: @277717
      GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(277783), // Rule ID 60144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10779:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60144,
        GIR_EraseRootFromParent_Done,
      // Label 5528: @277783
      GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(277849), // Rule ID 60145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10779:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60145,
        GIR_EraseRootFromParent_Done,
      // Label 5529: @277849
      GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(277915), // Rule ID 60148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10779:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60148,
        GIR_EraseRootFromParent_Done,
      // Label 5530: @277915
      GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(277981), // Rule ID 60149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10779:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60149,
        GIR_EraseRootFromParent_Done,
      // Label 5531: @277981
      GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(278047), // Rule ID 60152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10779:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60152,
        GIR_EraseRootFromParent_Done,
      // Label 5532: @278047
      GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(278113), // Rule ID 60153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10779:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60153,
        GIR_EraseRootFromParent_Done,
      // Label 5533: @278113
      GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(278179), // Rule ID 60156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10779:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60156,
        GIR_EraseRootFromParent_Done,
      // Label 5534: @278179
      GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(278245), // Rule ID 60157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10779:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60157,
        GIR_EraseRootFromParent_Done,
      // Label 5535: @278245
      GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(278311), // Rule ID 60160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10779:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60160,
        GIR_EraseRootFromParent_Done,
      // Label 5536: @278311
      GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(278377), // Rule ID 60161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10779:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60161,
        GIR_EraseRootFromParent_Done,
      // Label 5537: @278377
      GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(278443), // Rule ID 60164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10779:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60164,
        GIR_EraseRootFromParent_Done,
      // Label 5538: @278443
      GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(278509), // Rule ID 60165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10779:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60165,
        GIR_EraseRootFromParent_Done,
      // Label 5539: @278509
      GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(278575), // Rule ID 60168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10786:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60168,
        GIR_EraseRootFromParent_Done,
      // Label 5540: @278575
      GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(278641), // Rule ID 60169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10786:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60169,
        GIR_EraseRootFromParent_Done,
      // Label 5541: @278641
      GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(278707), // Rule ID 60172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10786:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60172,
        GIR_EraseRootFromParent_Done,
      // Label 5542: @278707
      GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(278773), // Rule ID 60173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10786:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60173,
        GIR_EraseRootFromParent_Done,
      // Label 5543: @278773
      GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(278839), // Rule ID 60176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10786:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60176,
        GIR_EraseRootFromParent_Done,
      // Label 5544: @278839
      GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(278905), // Rule ID 60177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10786:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60177,
        GIR_EraseRootFromParent_Done,
      // Label 5545: @278905
      GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(278971), // Rule ID 60180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10786:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60180,
        GIR_EraseRootFromParent_Done,
      // Label 5546: @278971
      GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(279037), // Rule ID 60181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10786:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60181,
        GIR_EraseRootFromParent_Done,
      // Label 5547: @279037
      GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(279103), // Rule ID 60184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10786:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60184,
        GIR_EraseRootFromParent_Done,
      // Label 5548: @279103
      GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(279169), // Rule ID 60185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10786:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60185,
        GIR_EraseRootFromParent_Done,
      // Label 5549: @279169
      GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(279235), // Rule ID 60188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10786:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60188,
        GIR_EraseRootFromParent_Done,
      // Label 5550: @279235
      GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(279301), // Rule ID 60189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10786:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60189,
        GIR_EraseRootFromParent_Done,
      // Label 5551: @279301
      GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(279367), // Rule ID 60192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10786:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60192,
        GIR_EraseRootFromParent_Done,
      // Label 5552: @279367
      GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(279433), // Rule ID 60193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10786:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60193,
        GIR_EraseRootFromParent_Done,
      // Label 5553: @279433
      GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(279499), // Rule ID 60196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10786:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60196,
        GIR_EraseRootFromParent_Done,
      // Label 5554: @279499
      GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(279565), // Rule ID 60197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10786:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60197,
        GIR_EraseRootFromParent_Done,
      // Label 5555: @279565
      GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(279631), // Rule ID 60200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10786:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60200,
        GIR_EraseRootFromParent_Done,
      // Label 5556: @279631
      GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(279697), // Rule ID 60201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10786:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60201,
        GIR_EraseRootFromParent_Done,
      // Label 5557: @279697
      GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(279763), // Rule ID 60204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10786:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60204,
        GIR_EraseRootFromParent_Done,
      // Label 5558: @279763
      GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(279829), // Rule ID 60205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10786:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60205,
        GIR_EraseRootFromParent_Done,
      // Label 5559: @279829
      GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(279895), // Rule ID 60208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10786:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60208,
        GIR_EraseRootFromParent_Done,
      // Label 5560: @279895
      GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(279961), // Rule ID 60209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10786:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60209,
        GIR_EraseRootFromParent_Done,
      // Label 5561: @279961
      GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(280027), // Rule ID 60212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10786:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60212,
        GIR_EraseRootFromParent_Done,
      // Label 5562: @280027
      GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(280093), // Rule ID 60213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10786:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60213,
        GIR_EraseRootFromParent_Done,
      // Label 5563: @280093
      GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(280159), // Rule ID 60216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10786:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60216,
        GIR_EraseRootFromParent_Done,
      // Label 5564: @280159
      GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(280225), // Rule ID 60217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10786:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60217,
        GIR_EraseRootFromParent_Done,
      // Label 5565: @280225
      GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(280291), // Rule ID 60220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10786:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60220,
        GIR_EraseRootFromParent_Done,
      // Label 5566: @280291
      GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(280357), // Rule ID 60221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10786:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60221,
        GIR_EraseRootFromParent_Done,
      // Label 5567: @280357
      GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(280423), // Rule ID 60224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10786:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60224,
        GIR_EraseRootFromParent_Done,
      // Label 5568: @280423
      GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(280489), // Rule ID 60225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10786:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60225,
        GIR_EraseRootFromParent_Done,
      // Label 5569: @280489
      GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(280555), // Rule ID 60228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10786:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60228,
        GIR_EraseRootFromParent_Done,
      // Label 5570: @280555
      GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(280621), // Rule ID 60229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10786:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60229,
        GIR_EraseRootFromParent_Done,
      // Label 5571: @280621
      GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(280687), // Rule ID 60232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10786:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60232,
        GIR_EraseRootFromParent_Done,
      // Label 5572: @280687
      GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(280753), // Rule ID 60233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10786:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60233,
        GIR_EraseRootFromParent_Done,
      // Label 5573: @280753
      GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(280819), // Rule ID 60236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10786:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60236,
        GIR_EraseRootFromParent_Done,
      // Label 5574: @280819
      GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(280885), // Rule ID 60237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10786:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60237,
        GIR_EraseRootFromParent_Done,
      // Label 5575: @280885
      GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(280951), // Rule ID 60240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10786:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60240,
        GIR_EraseRootFromParent_Done,
      // Label 5576: @280951
      GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(281017), // Rule ID 60241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10786:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60241,
        GIR_EraseRootFromParent_Done,
      // Label 5577: @281017
      GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(281083), // Rule ID 60244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10786:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60244,
        GIR_EraseRootFromParent_Done,
      // Label 5578: @281083
      GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(281149), // Rule ID 60245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10786:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60245,
        GIR_EraseRootFromParent_Done,
      // Label 5579: @281149
      GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(281215), // Rule ID 60248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10786:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60248,
        GIR_EraseRootFromParent_Done,
      // Label 5580: @281215
      GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(281281), // Rule ID 60249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10786:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60249,
        GIR_EraseRootFromParent_Done,
      // Label 5581: @281281
      GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(281347), // Rule ID 60252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10786:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60252,
        GIR_EraseRootFromParent_Done,
      // Label 5582: @281347
      GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(281413), // Rule ID 60253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10786:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60253,
        GIR_EraseRootFromParent_Done,
      // Label 5583: @281413
      GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(281479), // Rule ID 60256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10784:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60256,
        GIR_EraseRootFromParent_Done,
      // Label 5584: @281479
      GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(281545), // Rule ID 60257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10784:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60257,
        GIR_EraseRootFromParent_Done,
      // Label 5585: @281545
      GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(281611), // Rule ID 60260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10784:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60260,
        GIR_EraseRootFromParent_Done,
      // Label 5586: @281611
      GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(281677), // Rule ID 60261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10784:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60261,
        GIR_EraseRootFromParent_Done,
      // Label 5587: @281677
      GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(281743), // Rule ID 60264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10784:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60264,
        GIR_EraseRootFromParent_Done,
      // Label 5588: @281743
      GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(281809), // Rule ID 60265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10784:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60265,
        GIR_EraseRootFromParent_Done,
      // Label 5589: @281809
      GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(281875), // Rule ID 60268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10784:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60268,
        GIR_EraseRootFromParent_Done,
      // Label 5590: @281875
      GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(281941), // Rule ID 60269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10784:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60269,
        GIR_EraseRootFromParent_Done,
      // Label 5591: @281941
      GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(282007), // Rule ID 60272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10784:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60272,
        GIR_EraseRootFromParent_Done,
      // Label 5592: @282007
      GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(282073), // Rule ID 60273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10784:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60273,
        GIR_EraseRootFromParent_Done,
      // Label 5593: @282073
      GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(282139), // Rule ID 60276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10784:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60276,
        GIR_EraseRootFromParent_Done,
      // Label 5594: @282139
      GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(282205), // Rule ID 60277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10784:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60277,
        GIR_EraseRootFromParent_Done,
      // Label 5595: @282205
      GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(282271), // Rule ID 60280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10784:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60280,
        GIR_EraseRootFromParent_Done,
      // Label 5596: @282271
      GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(282337), // Rule ID 60281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10784:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60281,
        GIR_EraseRootFromParent_Done,
      // Label 5597: @282337
      GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(282403), // Rule ID 60284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10784:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60284,
        GIR_EraseRootFromParent_Done,
      // Label 5598: @282403
      GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(282469), // Rule ID 60285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10784:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60285,
        GIR_EraseRootFromParent_Done,
      // Label 5599: @282469
      GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(282535), // Rule ID 60288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10784:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60288,
        GIR_EraseRootFromParent_Done,
      // Label 5600: @282535
      GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(282601), // Rule ID 60289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10784:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60289,
        GIR_EraseRootFromParent_Done,
      // Label 5601: @282601
      GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(282667), // Rule ID 60292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10784:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60292,
        GIR_EraseRootFromParent_Done,
      // Label 5602: @282667
      GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(282733), // Rule ID 60293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10784:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60293,
        GIR_EraseRootFromParent_Done,
      // Label 5603: @282733
      GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(282799), // Rule ID 60296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10784:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60296,
        GIR_EraseRootFromParent_Done,
      // Label 5604: @282799
      GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(282865), // Rule ID 60297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10784:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60297,
        GIR_EraseRootFromParent_Done,
      // Label 5605: @282865
      GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(282931), // Rule ID 60300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10784:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60300,
        GIR_EraseRootFromParent_Done,
      // Label 5606: @282931
      GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(282997), // Rule ID 60301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10784:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60301,
        GIR_EraseRootFromParent_Done,
      // Label 5607: @282997
      GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(283063), // Rule ID 60304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10784:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60304,
        GIR_EraseRootFromParent_Done,
      // Label 5608: @283063
      GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(283129), // Rule ID 60305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10784:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60305,
        GIR_EraseRootFromParent_Done,
      // Label 5609: @283129
      GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(283195), // Rule ID 60308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10784:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60308,
        GIR_EraseRootFromParent_Done,
      // Label 5610: @283195
      GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(283261), // Rule ID 60309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10784:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60309,
        GIR_EraseRootFromParent_Done,
      // Label 5611: @283261
      GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(283327), // Rule ID 60312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10784:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60312,
        GIR_EraseRootFromParent_Done,
      // Label 5612: @283327
      GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(283393), // Rule ID 60313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10784:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60313,
        GIR_EraseRootFromParent_Done,
      // Label 5613: @283393
      GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(283459), // Rule ID 60316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10784:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60316,
        GIR_EraseRootFromParent_Done,
      // Label 5614: @283459
      GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(283525), // Rule ID 60317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10784:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60317,
        GIR_EraseRootFromParent_Done,
      // Label 5615: @283525
      GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(283591), // Rule ID 60320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10784:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60320,
        GIR_EraseRootFromParent_Done,
      // Label 5616: @283591
      GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(283657), // Rule ID 60321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10784:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60321,
        GIR_EraseRootFromParent_Done,
      // Label 5617: @283657
      GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(283723), // Rule ID 60324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10784:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60324,
        GIR_EraseRootFromParent_Done,
      // Label 5618: @283723
      GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(283789), // Rule ID 60325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10784:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60325,
        GIR_EraseRootFromParent_Done,
      // Label 5619: @283789
      GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(283855), // Rule ID 60328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10784:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60328,
        GIR_EraseRootFromParent_Done,
      // Label 5620: @283855
      GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(283921), // Rule ID 60329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10784:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60329,
        GIR_EraseRootFromParent_Done,
      // Label 5621: @283921
      GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(283987), // Rule ID 60332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10784:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60332,
        GIR_EraseRootFromParent_Done,
      // Label 5622: @283987
      GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(284053), // Rule ID 60333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10784:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60333,
        GIR_EraseRootFromParent_Done,
      // Label 5623: @284053
      GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(284119), // Rule ID 60336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10784:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60336,
        GIR_EraseRootFromParent_Done,
      // Label 5624: @284119
      GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(284185), // Rule ID 60337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10784:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60337,
        GIR_EraseRootFromParent_Done,
      // Label 5625: @284185
      GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(284251), // Rule ID 60340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10784:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60340,
        GIR_EraseRootFromParent_Done,
      // Label 5626: @284251
      GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(284317), // Rule ID 60341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10784:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60341,
        GIR_EraseRootFromParent_Done,
      // Label 5627: @284317
      GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(284383), // Rule ID 60764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10773:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60764,
        GIR_EraseRootFromParent_Done,
      // Label 5628: @284383
      GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(284449), // Rule ID 60765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10773:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60765,
        GIR_EraseRootFromParent_Done,
      // Label 5629: @284449
      GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(284515), // Rule ID 60768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10773:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60768,
        GIR_EraseRootFromParent_Done,
      // Label 5630: @284515
      GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(284581), // Rule ID 60769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10773:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60769,
        GIR_EraseRootFromParent_Done,
      // Label 5631: @284581
      GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(284647), // Rule ID 60772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10773:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60772,
        GIR_EraseRootFromParent_Done,
      // Label 5632: @284647
      GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(284713), // Rule ID 60773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10773:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60773,
        GIR_EraseRootFromParent_Done,
      // Label 5633: @284713
      GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(284779), // Rule ID 60776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10773:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60776,
        GIR_EraseRootFromParent_Done,
      // Label 5634: @284779
      GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(284845), // Rule ID 60777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10773:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60777,
        GIR_EraseRootFromParent_Done,
      // Label 5635: @284845
      GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(284911), // Rule ID 60780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10773:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60780,
        GIR_EraseRootFromParent_Done,
      // Label 5636: @284911
      GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(284977), // Rule ID 60781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10773:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60781,
        GIR_EraseRootFromParent_Done,
      // Label 5637: @284977
      GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(285043), // Rule ID 60784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10773:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60784,
        GIR_EraseRootFromParent_Done,
      // Label 5638: @285043
      GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(285109), // Rule ID 60785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10773:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60785,
        GIR_EraseRootFromParent_Done,
      // Label 5639: @285109
      GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(285175), // Rule ID 60788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10773:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60788,
        GIR_EraseRootFromParent_Done,
      // Label 5640: @285175
      GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(285241), // Rule ID 60789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10773:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60789,
        GIR_EraseRootFromParent_Done,
      // Label 5641: @285241
      GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(285307), // Rule ID 60792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10773:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60792,
        GIR_EraseRootFromParent_Done,
      // Label 5642: @285307
      GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(285373), // Rule ID 60793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10773:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60793,
        GIR_EraseRootFromParent_Done,
      // Label 5643: @285373
      GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(285439), // Rule ID 60796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10773:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60796,
        GIR_EraseRootFromParent_Done,
      // Label 5644: @285439
      GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(285505), // Rule ID 60797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10773:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60797,
        GIR_EraseRootFromParent_Done,
      // Label 5645: @285505
      GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(285571), // Rule ID 60800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10773:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60800,
        GIR_EraseRootFromParent_Done,
      // Label 5646: @285571
      GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(285637), // Rule ID 60801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10773:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60801,
        GIR_EraseRootFromParent_Done,
      // Label 5647: @285637
      GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(285703), // Rule ID 60804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10773:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60804,
        GIR_EraseRootFromParent_Done,
      // Label 5648: @285703
      GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(285769), // Rule ID 60805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10773:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60805,
        GIR_EraseRootFromParent_Done,
      // Label 5649: @285769
      GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(285835), // Rule ID 60808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10773:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60808,
        GIR_EraseRootFromParent_Done,
      // Label 5650: @285835
      GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(285901), // Rule ID 60809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10773:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60809,
        GIR_EraseRootFromParent_Done,
      // Label 5651: @285901
      GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(285967), // Rule ID 60812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10773:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60812,
        GIR_EraseRootFromParent_Done,
      // Label 5652: @285967
      GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(286033), // Rule ID 60813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10773:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60813,
        GIR_EraseRootFromParent_Done,
      // Label 5653: @286033
      GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(286099), // Rule ID 60816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10773:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60816,
        GIR_EraseRootFromParent_Done,
      // Label 5654: @286099
      GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(286165), // Rule ID 60817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10773:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60817,
        GIR_EraseRootFromParent_Done,
      // Label 5655: @286165
      GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(286231), // Rule ID 60820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10773:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60820,
        GIR_EraseRootFromParent_Done,
      // Label 5656: @286231
      GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(286297), // Rule ID 60821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10773:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60821,
        GIR_EraseRootFromParent_Done,
      // Label 5657: @286297
      GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(286363), // Rule ID 60824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10773:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60824,
        GIR_EraseRootFromParent_Done,
      // Label 5658: @286363
      GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(286429), // Rule ID 60825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10773:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60825,
        GIR_EraseRootFromParent_Done,
      // Label 5659: @286429
      GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(286495), // Rule ID 60828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10773:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60828,
        GIR_EraseRootFromParent_Done,
      // Label 5660: @286495
      GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(286561), // Rule ID 60829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10773:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60829,
        GIR_EraseRootFromParent_Done,
      // Label 5661: @286561
      GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(286627), // Rule ID 60832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10773:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60832,
        GIR_EraseRootFromParent_Done,
      // Label 5662: @286627
      GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(286693), // Rule ID 60833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10773:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60833,
        GIR_EraseRootFromParent_Done,
      // Label 5663: @286693
      GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(286759), // Rule ID 60836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10773:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60836,
        GIR_EraseRootFromParent_Done,
      // Label 5664: @286759
      GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(286825), // Rule ID 60837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10773:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60837,
        GIR_EraseRootFromParent_Done,
      // Label 5665: @286825
      GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(286891), // Rule ID 60840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10773:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60840,
        GIR_EraseRootFromParent_Done,
      // Label 5666: @286891
      GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(286957), // Rule ID 60841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10773:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60841,
        GIR_EraseRootFromParent_Done,
      // Label 5667: @286957
      GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(287023), // Rule ID 60844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10773:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60844,
        GIR_EraseRootFromParent_Done,
      // Label 5668: @287023
      GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(287089), // Rule ID 60845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10773:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60845,
        GIR_EraseRootFromParent_Done,
      // Label 5669: @287089
      GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(287155), // Rule ID 60848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10773:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60848,
        GIR_EraseRootFromParent_Done,
      // Label 5670: @287155
      GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(287221), // Rule ID 60849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10773:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60849,
        GIR_EraseRootFromParent_Done,
      // Label 5671: @287221
      GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(287287), // Rule ID 60852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60852,
        GIR_EraseRootFromParent_Done,
      // Label 5672: @287287
      GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(287353), // Rule ID 60853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60853,
        GIR_EraseRootFromParent_Done,
      // Label 5673: @287353
      GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(287419), // Rule ID 60856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60856,
        GIR_EraseRootFromParent_Done,
      // Label 5674: @287419
      GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(287485), // Rule ID 60857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60857,
        GIR_EraseRootFromParent_Done,
      // Label 5675: @287485
      GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(287551), // Rule ID 60860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60860,
        GIR_EraseRootFromParent_Done,
      // Label 5676: @287551
      GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(287617), // Rule ID 60861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60861,
        GIR_EraseRootFromParent_Done,
      // Label 5677: @287617
      GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(287683), // Rule ID 60864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60864,
        GIR_EraseRootFromParent_Done,
      // Label 5678: @287683
      GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(287749), // Rule ID 60865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60865,
        GIR_EraseRootFromParent_Done,
      // Label 5679: @287749
      GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(287815), // Rule ID 60868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60868,
        GIR_EraseRootFromParent_Done,
      // Label 5680: @287815
      GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(287881), // Rule ID 60869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60869,
        GIR_EraseRootFromParent_Done,
      // Label 5681: @287881
      GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(287947), // Rule ID 60872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60872,
        GIR_EraseRootFromParent_Done,
      // Label 5682: @287947
      GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(288013), // Rule ID 60873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60873,
        GIR_EraseRootFromParent_Done,
      // Label 5683: @288013
      GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(288079), // Rule ID 60876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60876,
        GIR_EraseRootFromParent_Done,
      // Label 5684: @288079
      GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(288145), // Rule ID 60877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11124:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60877,
        GIR_EraseRootFromParent_Done,
      // Label 5685: @288145
      GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(288211), // Rule ID 60880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60880,
        GIR_EraseRootFromParent_Done,
      // Label 5686: @288211
      GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(288277), // Rule ID 60881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60881,
        GIR_EraseRootFromParent_Done,
      // Label 5687: @288277
      GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(288343), // Rule ID 60884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60884,
        GIR_EraseRootFromParent_Done,
      // Label 5688: @288343
      GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(288409), // Rule ID 60885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60885,
        GIR_EraseRootFromParent_Done,
      // Label 5689: @288409
      GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(288475), // Rule ID 60888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60888,
        GIR_EraseRootFromParent_Done,
      // Label 5690: @288475
      GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(288541), // Rule ID 60889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60889,
        GIR_EraseRootFromParent_Done,
      // Label 5691: @288541
      GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(288607), // Rule ID 60892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60892,
        GIR_EraseRootFromParent_Done,
      // Label 5692: @288607
      GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(288673), // Rule ID 60893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60893,
        GIR_EraseRootFromParent_Done,
      // Label 5693: @288673
      GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(288739), // Rule ID 60896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60896,
        GIR_EraseRootFromParent_Done,
      // Label 5694: @288739
      GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(288805), // Rule ID 60897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60897,
        GIR_EraseRootFromParent_Done,
      // Label 5695: @288805
      GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(288871), // Rule ID 60900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60900,
        GIR_EraseRootFromParent_Done,
      // Label 5696: @288871
      GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(288937), // Rule ID 60901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60901,
        GIR_EraseRootFromParent_Done,
      // Label 5697: @288937
      GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(289003), // Rule ID 60904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60904,
        GIR_EraseRootFromParent_Done,
      // Label 5698: @289003
      GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(289069), // Rule ID 60905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60905,
        GIR_EraseRootFromParent_Done,
      // Label 5699: @289069
      GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(289135), // Rule ID 60908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60908,
        GIR_EraseRootFromParent_Done,
      // Label 5700: @289135
      GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(289201), // Rule ID 60909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60909,
        GIR_EraseRootFromParent_Done,
      // Label 5701: @289201
      GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(289267), // Rule ID 60912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60912,
        GIR_EraseRootFromParent_Done,
      // Label 5702: @289267
      GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(289333), // Rule ID 60913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60913,
        GIR_EraseRootFromParent_Done,
      // Label 5703: @289333
      GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(289399), // Rule ID 60916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60916,
        GIR_EraseRootFromParent_Done,
      // Label 5704: @289399
      GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(289465), // Rule ID 60917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60917,
        GIR_EraseRootFromParent_Done,
      // Label 5705: @289465
      GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(289531), // Rule ID 60920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60920,
        GIR_EraseRootFromParent_Done,
      // Label 5706: @289531
      GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(289597), // Rule ID 60921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60921,
        GIR_EraseRootFromParent_Done,
      // Label 5707: @289597
      GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(289663), // Rule ID 60924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60924,
        GIR_EraseRootFromParent_Done,
      // Label 5708: @289663
      GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(289729), // Rule ID 60925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60925,
        GIR_EraseRootFromParent_Done,
      // Label 5709: @289729
      GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(289795), // Rule ID 60928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60928,
        GIR_EraseRootFromParent_Done,
      // Label 5710: @289795
      GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(289861), // Rule ID 60929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60929,
        GIR_EraseRootFromParent_Done,
      // Label 5711: @289861
      GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(289927), // Rule ID 60932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60932,
        GIR_EraseRootFromParent_Done,
      // Label 5712: @289927
      GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(289993), // Rule ID 60933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60933,
        GIR_EraseRootFromParent_Done,
      // Label 5713: @289993
      GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(290059), // Rule ID 60936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60936,
        GIR_EraseRootFromParent_Done,
      // Label 5714: @290059
      GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(290125), // Rule ID 60937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60937,
        GIR_EraseRootFromParent_Done,
      // Label 5715: @290125
      GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(290190), // Rule ID 63867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 10591:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63867,
        GIR_EraseRootFromParent_Done,
      // Label 5716: @290190
      GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(290255), // Rule ID 63894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 10593:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63894,
        GIR_EraseRootFromParent_Done,
      // Label 5717: @290255
      GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(290320), // Rule ID 63897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 10592:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63897,
        GIR_EraseRootFromParent_Done,
      // Label 5718: @290320
      GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(290385), // Rule ID 63900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 10594:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63900,
        GIR_EraseRootFromParent_Done,
      // Label 5719: @290385
      GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(290450), // Rule ID 63903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 10597:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63903,
        GIR_EraseRootFromParent_Done,
      // Label 5720: @290450
      GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(290515), // Rule ID 63906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 10599:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63906,
        GIR_EraseRootFromParent_Done,
      // Label 5721: @290515
      GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(290580), // Rule ID 63909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 10598:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63909,
        GIR_EraseRootFromParent_Done,
      // Label 5722: @290580
      GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(290645), // Rule ID 63912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 10600:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63912,
        GIR_EraseRootFromParent_Done,
      // Label 5723: @290645
      GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(290700), // Rule ID 2505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
        // (intrinsic_wo_chain:{ *:[i32] } 10576:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2505,
        GIR_EraseRootFromParent_Done,
      // Label 5724: @290700
      GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(290755), // Rule ID 2506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
        // (intrinsic_wo_chain:{ *:[i32] } 10577:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2506,
        GIR_EraseRootFromParent_Done,
      // Label 5725: @290755
      GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(290810), // Rule ID 2512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
        // (intrinsic_wo_chain:{ *:[i32] } 10578:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2512,
        GIR_EraseRootFromParent_Done,
      // Label 5726: @290810
      GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(290865), // Rule ID 2513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
        // (intrinsic_wo_chain:{ *:[i32] } 10579:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2513,
        GIR_EraseRootFromParent_Done,
      // Label 5727: @290865
      GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(290920), // Rule ID 63923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10624:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63923,
        GIR_EraseRootFromParent_Done,
      // Label 5728: @290920
      GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(290975), // Rule ID 63924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10620:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63924,
        GIR_EraseRootFromParent_Done,
      // Label 5729: @290975
      GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(291030), // Rule ID 63925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10622:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63925,
        GIR_EraseRootFromParent_Done,
      // Label 5730: @291030
      GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(291085), // Rule ID 63926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10618:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63926,
        GIR_EraseRootFromParent_Done,
      // Label 5731: @291085
      GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(291140), // Rule ID 63927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10625:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63927,
        GIR_EraseRootFromParent_Done,
      // Label 5732: @291140
      GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(291195), // Rule ID 63928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10621:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63928,
        GIR_EraseRootFromParent_Done,
      // Label 5733: @291195
      GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(291250), // Rule ID 63929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10623:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63929,
        GIR_EraseRootFromParent_Done,
      // Label 5734: @291250
      GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(291305), // Rule ID 63930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10619:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63930,
        GIR_EraseRootFromParent_Done,
      // Label 5735: @291305
      GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(291359), // Rule ID 63865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10591:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63865,
        GIR_EraseRootFromParent_Done,
      // Label 5736: @291359
      GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(291413), // Rule ID 63866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10591:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63866,
        GIR_EraseRootFromParent_Done,
      // Label 5737: @291413
      GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(291467), // Rule ID 63892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10593:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63892,
        GIR_EraseRootFromParent_Done,
      // Label 5738: @291467
      GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(291521), // Rule ID 63893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10593:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63893,
        GIR_EraseRootFromParent_Done,
      // Label 5739: @291521
      GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(291575), // Rule ID 63895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10592:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63895,
        GIR_EraseRootFromParent_Done,
      // Label 5740: @291575
      GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(291629), // Rule ID 63896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10592:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63896,
        GIR_EraseRootFromParent_Done,
      // Label 5741: @291629
      GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(291683), // Rule ID 63898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10594:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63898,
        GIR_EraseRootFromParent_Done,
      // Label 5742: @291683
      GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(291737), // Rule ID 63899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10594:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63899,
        GIR_EraseRootFromParent_Done,
      // Label 5743: @291737
      GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(291791), // Rule ID 63901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10597:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63901,
        GIR_EraseRootFromParent_Done,
      // Label 5744: @291791
      GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(291845), // Rule ID 63902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10597:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63902,
        GIR_EraseRootFromParent_Done,
      // Label 5745: @291845
      GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(291899), // Rule ID 63904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10599:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63904,
        GIR_EraseRootFromParent_Done,
      // Label 5746: @291899
      GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(291953), // Rule ID 63905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10599:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63905,
        GIR_EraseRootFromParent_Done,
      // Label 5747: @291953
      GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(292007), // Rule ID 63907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10598:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63907,
        GIR_EraseRootFromParent_Done,
      // Label 5748: @292007
      GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(292061), // Rule ID 63908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10598:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63908,
        GIR_EraseRootFromParent_Done,
      // Label 5749: @292061
      GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(292115), // Rule ID 63910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10600:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63910,
        GIR_EraseRootFromParent_Done,
      // Label 5750: @292115
      GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(292169), // Rule ID 63911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10600:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63911,
        GIR_EraseRootFromParent_Done,
      // Label 5751: @292169
      GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(292223), // Rule ID 63848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10607:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63848,
        GIR_EraseRootFromParent_Done,
      // Label 5752: @292223
      GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(292277), // Rule ID 63849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10607:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63849,
        GIR_EraseRootFromParent_Done,
      // Label 5753: @292277
      GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(292331), // Rule ID 63919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10608:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63919,
        GIR_EraseRootFromParent_Done,
      // Label 5754: @292331
      GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(292385), // Rule ID 63920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10608:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63920,
        GIR_EraseRootFromParent_Done,
      // Label 5755: @292385
      GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(292439), // Rule ID 63921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10617:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63921,
        GIR_EraseRootFromParent_Done,
      // Label 5756: @292439
      GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(292493), // Rule ID 63922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 10617:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63922,
        GIR_EraseRootFromParent_Done,
      // Label 5757: @292493
      GIM_Reject,
    // Label 3132: @292494
    GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(816779),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
      GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(292577), // Rule ID 62249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62249,
        GIR_EraseRootFromParent_Done,
      // Label 5759: @292577
      GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(292652), // Rule ID 62250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62250,
        GIR_EraseRootFromParent_Done,
      // Label 5760: @292652
      GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(292727), // Rule ID 62281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62281,
        GIR_EraseRootFromParent_Done,
      // Label 5761: @292727
      GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(292802), // Rule ID 62282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62282,
        GIR_EraseRootFromParent_Done,
      // Label 5762: @292802
      GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(292877), // Rule ID 62325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62325,
        GIR_EraseRootFromParent_Done,
      // Label 5763: @292877
      GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(292952), // Rule ID 62326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62326,
        GIR_EraseRootFromParent_Done,
      // Label 5764: @292952
      GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(293027), // Rule ID 62369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62369,
        GIR_EraseRootFromParent_Done,
      // Label 5765: @293027
      GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(293102), // Rule ID 62370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62370,
        GIR_EraseRootFromParent_Done,
      // Label 5766: @293102
      GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(293177), // Rule ID 62425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62425,
        GIR_EraseRootFromParent_Done,
      // Label 5767: @293177
      GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(293252), // Rule ID 62426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62426,
        GIR_EraseRootFromParent_Done,
      // Label 5768: @293252
      GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(293327), // Rule ID 62481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62481,
        GIR_EraseRootFromParent_Done,
      // Label 5769: @293327
      GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(293402), // Rule ID 62482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62482,
        GIR_EraseRootFromParent_Done,
      // Label 5770: @293402
      GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(293477), // Rule ID 62537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62537,
        GIR_EraseRootFromParent_Done,
      // Label 5771: @293477
      GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(293552), // Rule ID 62538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62538,
        GIR_EraseRootFromParent_Done,
      // Label 5772: @293552
      GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(293627), // Rule ID 62581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62581,
        GIR_EraseRootFromParent_Done,
      // Label 5773: @293627
      GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(293702), // Rule ID 62582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62582,
        GIR_EraseRootFromParent_Done,
      // Label 5774: @293702
      GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(293777), // Rule ID 62637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62637,
        GIR_EraseRootFromParent_Done,
      // Label 5775: @293777
      GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(293852), // Rule ID 62638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62638,
        GIR_EraseRootFromParent_Done,
      // Label 5776: @293852
      GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(293927), // Rule ID 62693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62693,
        GIR_EraseRootFromParent_Done,
      // Label 5777: @293927
      GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(294002), // Rule ID 62694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62694,
        GIR_EraseRootFromParent_Done,
      // Label 5778: @294002
      GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(294077), // Rule ID 62749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62749,
        GIR_EraseRootFromParent_Done,
      // Label 5779: @294077
      GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(294152), // Rule ID 62750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62750,
        GIR_EraseRootFromParent_Done,
      // Label 5780: @294152
      GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(294227), // Rule ID 62793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62793,
        GIR_EraseRootFromParent_Done,
      // Label 5781: @294227
      GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(294302), // Rule ID 62794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62794,
        GIR_EraseRootFromParent_Done,
      // Label 5782: @294302
      GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(294377), // Rule ID 62837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62837,
        GIR_EraseRootFromParent_Done,
      // Label 5783: @294377
      GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(294452), // Rule ID 62838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62838,
        GIR_EraseRootFromParent_Done,
      // Label 5784: @294452
      GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(294527), // Rule ID 62881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62881,
        GIR_EraseRootFromParent_Done,
      // Label 5785: @294527
      GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(294602), // Rule ID 62882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62882,
        GIR_EraseRootFromParent_Done,
      // Label 5786: @294602
      GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(294677), // Rule ID 62937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62937,
        GIR_EraseRootFromParent_Done,
      // Label 5787: @294677
      GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(294752), // Rule ID 62938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62938,
        GIR_EraseRootFromParent_Done,
      // Label 5788: @294752
      GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(294827), // Rule ID 62993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62993,
        GIR_EraseRootFromParent_Done,
      // Label 5789: @294827
      GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(294902), // Rule ID 62994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62994,
        GIR_EraseRootFromParent_Done,
      // Label 5790: @294902
      GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(294977), // Rule ID 63049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63049,
        GIR_EraseRootFromParent_Done,
      // Label 5791: @294977
      GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(295052), // Rule ID 63050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63050,
        GIR_EraseRootFromParent_Done,
      // Label 5792: @295052
      GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(295127), // Rule ID 63105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63105,
        GIR_EraseRootFromParent_Done,
      // Label 5793: @295127
      GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(295202), // Rule ID 63106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63106,
        GIR_EraseRootFromParent_Done,
      // Label 5794: @295202
      GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(295277), // Rule ID 63161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63161,
        GIR_EraseRootFromParent_Done,
      // Label 5795: @295277
      GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(295352), // Rule ID 63162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63162,
        GIR_EraseRootFromParent_Done,
      // Label 5796: @295352
      GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(295427), // Rule ID 63217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63217,
        GIR_EraseRootFromParent_Done,
      // Label 5797: @295427
      GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(295502), // Rule ID 63218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63218,
        GIR_EraseRootFromParent_Done,
      // Label 5798: @295502
      GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(295577), // Rule ID 63273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63273,
        GIR_EraseRootFromParent_Done,
      // Label 5799: @295577
      GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(295652), // Rule ID 63274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63274,
        GIR_EraseRootFromParent_Done,
      // Label 5800: @295652
      GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(295727), // Rule ID 63329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10674:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63329,
        GIR_EraseRootFromParent_Done,
      // Label 5801: @295727
      GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(295802), // Rule ID 63330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10674:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63330,
        GIR_EraseRootFromParent_Done,
      // Label 5802: @295802
      GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(295876), // Rule ID 62231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62231,
        GIR_EraseRootFromParent_Done,
      // Label 5803: @295876
      GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(295950), // Rule ID 62232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62232,
        GIR_EraseRootFromParent_Done,
      // Label 5804: @295950
      GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(296024), // Rule ID 62277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62277,
        GIR_EraseRootFromParent_Done,
      // Label 5805: @296024
      GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(296098), // Rule ID 62278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62278,
        GIR_EraseRootFromParent_Done,
      // Label 5806: @296098
      GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(296172), // Rule ID 62321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62321,
        GIR_EraseRootFromParent_Done,
      // Label 5807: @296172
      GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(296246), // Rule ID 62322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62322,
        GIR_EraseRootFromParent_Done,
      // Label 5808: @296246
      GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(296320), // Rule ID 62365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62365,
        GIR_EraseRootFromParent_Done,
      // Label 5809: @296320
      GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(296394), // Rule ID 62366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62366,
        GIR_EraseRootFromParent_Done,
      // Label 5810: @296394
      GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(296468), // Rule ID 62421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62421,
        GIR_EraseRootFromParent_Done,
      // Label 5811: @296468
      GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(296542), // Rule ID 62422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62422,
        GIR_EraseRootFromParent_Done,
      // Label 5812: @296542
      GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(296616), // Rule ID 62477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62477,
        GIR_EraseRootFromParent_Done,
      // Label 5813: @296616
      GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(296690), // Rule ID 62478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62478,
        GIR_EraseRootFromParent_Done,
      // Label 5814: @296690
      GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(296764), // Rule ID 62533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62533,
        GIR_EraseRootFromParent_Done,
      // Label 5815: @296764
      GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(296838), // Rule ID 62534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62534,
        GIR_EraseRootFromParent_Done,
      // Label 5816: @296838
      GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(296912), // Rule ID 62577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62577,
        GIR_EraseRootFromParent_Done,
      // Label 5817: @296912
      GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(296986), // Rule ID 62578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62578,
        GIR_EraseRootFromParent_Done,
      // Label 5818: @296986
      GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(297060), // Rule ID 62633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62633,
        GIR_EraseRootFromParent_Done,
      // Label 5819: @297060
      GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(297134), // Rule ID 62634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62634,
        GIR_EraseRootFromParent_Done,
      // Label 5820: @297134
      GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(297208), // Rule ID 62689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62689,
        GIR_EraseRootFromParent_Done,
      // Label 5821: @297208
      GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(297282), // Rule ID 62690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62690,
        GIR_EraseRootFromParent_Done,
      // Label 5822: @297282
      GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(297356), // Rule ID 62745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62745,
        GIR_EraseRootFromParent_Done,
      // Label 5823: @297356
      GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(297430), // Rule ID 62746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62746,
        GIR_EraseRootFromParent_Done,
      // Label 5824: @297430
      GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(297504), // Rule ID 62789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62789,
        GIR_EraseRootFromParent_Done,
      // Label 5825: @297504
      GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(297578), // Rule ID 62790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62790,
        GIR_EraseRootFromParent_Done,
      // Label 5826: @297578
      GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(297652), // Rule ID 62833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62833,
        GIR_EraseRootFromParent_Done,
      // Label 5827: @297652
      GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(297726), // Rule ID 62834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62834,
        GIR_EraseRootFromParent_Done,
      // Label 5828: @297726
      GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(297800), // Rule ID 62877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62877,
        GIR_EraseRootFromParent_Done,
      // Label 5829: @297800
      GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(297874), // Rule ID 62878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62878,
        GIR_EraseRootFromParent_Done,
      // Label 5830: @297874
      GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(297948), // Rule ID 62933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62933,
        GIR_EraseRootFromParent_Done,
      // Label 5831: @297948
      GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(298022), // Rule ID 62934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62934,
        GIR_EraseRootFromParent_Done,
      // Label 5832: @298022
      GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(298096), // Rule ID 62989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62989,
        GIR_EraseRootFromParent_Done,
      // Label 5833: @298096
      GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(298170), // Rule ID 62990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62990,
        GIR_EraseRootFromParent_Done,
      // Label 5834: @298170
      GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(298244), // Rule ID 63045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63045,
        GIR_EraseRootFromParent_Done,
      // Label 5835: @298244
      GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(298318), // Rule ID 63046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63046,
        GIR_EraseRootFromParent_Done,
      // Label 5836: @298318
      GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(298392), // Rule ID 63101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63101,
        GIR_EraseRootFromParent_Done,
      // Label 5837: @298392
      GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(298466), // Rule ID 63102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63102,
        GIR_EraseRootFromParent_Done,
      // Label 5838: @298466
      GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(298540), // Rule ID 63157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63157,
        GIR_EraseRootFromParent_Done,
      // Label 5839: @298540
      GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(298614), // Rule ID 63158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63158,
        GIR_EraseRootFromParent_Done,
      // Label 5840: @298614
      GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(298688), // Rule ID 63213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63213,
        GIR_EraseRootFromParent_Done,
      // Label 5841: @298688
      GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(298762), // Rule ID 63214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63214,
        GIR_EraseRootFromParent_Done,
      // Label 5842: @298762
      GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(298836), // Rule ID 63269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63269,
        GIR_EraseRootFromParent_Done,
      // Label 5843: @298836
      GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(298910), // Rule ID 63270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63270,
        GIR_EraseRootFromParent_Done,
      // Label 5844: @298910
      GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(298984), // Rule ID 63325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10688:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63325,
        GIR_EraseRootFromParent_Done,
      // Label 5845: @298984
      GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(299058), // Rule ID 63326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        // MIs[0] op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10688:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63326,
        GIR_EraseRootFromParent_Done,
      // Label 5846: @299058
      GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(299132), // Rule ID 62255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62255,
        GIR_EraseRootFromParent_Done,
      // Label 5847: @299132
      GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(299206), // Rule ID 62256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62256,
        GIR_EraseRootFromParent_Done,
      // Label 5848: @299206
      GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(299280), // Rule ID 62293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62293,
        GIR_EraseRootFromParent_Done,
      // Label 5849: @299280
      GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(299354), // Rule ID 62294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62294,
        GIR_EraseRootFromParent_Done,
      // Label 5850: @299354
      GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(299428), // Rule ID 62337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62337,
        GIR_EraseRootFromParent_Done,
      // Label 5851: @299428
      GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(299502), // Rule ID 62338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62338,
        GIR_EraseRootFromParent_Done,
      // Label 5852: @299502
      GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(299576), // Rule ID 62381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62381,
        GIR_EraseRootFromParent_Done,
      // Label 5853: @299576
      GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(299650), // Rule ID 62382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62382,
        GIR_EraseRootFromParent_Done,
      // Label 5854: @299650
      GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(299724), // Rule ID 62437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62437,
        GIR_EraseRootFromParent_Done,
      // Label 5855: @299724
      GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(299798), // Rule ID 62438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62438,
        GIR_EraseRootFromParent_Done,
      // Label 5856: @299798
      GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(299872), // Rule ID 62493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62493,
        GIR_EraseRootFromParent_Done,
      // Label 5857: @299872
      GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(299946), // Rule ID 62494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62494,
        GIR_EraseRootFromParent_Done,
      // Label 5858: @299946
      GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(300020), // Rule ID 62549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62549,
        GIR_EraseRootFromParent_Done,
      // Label 5859: @300020
      GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(300094), // Rule ID 62550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62550,
        GIR_EraseRootFromParent_Done,
      // Label 5860: @300094
      GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(300168), // Rule ID 62593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62593,
        GIR_EraseRootFromParent_Done,
      // Label 5861: @300168
      GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(300242), // Rule ID 62594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62594,
        GIR_EraseRootFromParent_Done,
      // Label 5862: @300242
      GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(300316), // Rule ID 62649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62649,
        GIR_EraseRootFromParent_Done,
      // Label 5863: @300316
      GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(300390), // Rule ID 62650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62650,
        GIR_EraseRootFromParent_Done,
      // Label 5864: @300390
      GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(300464), // Rule ID 62705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62705,
        GIR_EraseRootFromParent_Done,
      // Label 5865: @300464
      GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(300538), // Rule ID 62706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62706,
        GIR_EraseRootFromParent_Done,
      // Label 5866: @300538
      GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(300612), // Rule ID 62761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62761,
        GIR_EraseRootFromParent_Done,
      // Label 5867: @300612
      GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(300686), // Rule ID 62762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62762,
        GIR_EraseRootFromParent_Done,
      // Label 5868: @300686
      GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(300760), // Rule ID 62805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62805,
        GIR_EraseRootFromParent_Done,
      // Label 5869: @300760
      GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(300834), // Rule ID 62806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62806,
        GIR_EraseRootFromParent_Done,
      // Label 5870: @300834
      GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(300908), // Rule ID 62849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62849,
        GIR_EraseRootFromParent_Done,
      // Label 5871: @300908
      GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(300982), // Rule ID 62850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62850,
        GIR_EraseRootFromParent_Done,
      // Label 5872: @300982
      GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(301056), // Rule ID 62893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62893,
        GIR_EraseRootFromParent_Done,
      // Label 5873: @301056
      GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(301130), // Rule ID 62894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62894,
        GIR_EraseRootFromParent_Done,
      // Label 5874: @301130
      GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(301204), // Rule ID 62949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62949,
        GIR_EraseRootFromParent_Done,
      // Label 5875: @301204
      GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(301278), // Rule ID 62950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62950,
        GIR_EraseRootFromParent_Done,
      // Label 5876: @301278
      GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(301352), // Rule ID 63005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63005,
        GIR_EraseRootFromParent_Done,
      // Label 5877: @301352
      GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(301426), // Rule ID 63006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63006,
        GIR_EraseRootFromParent_Done,
      // Label 5878: @301426
      GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(301500), // Rule ID 63061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63061,
        GIR_EraseRootFromParent_Done,
      // Label 5879: @301500
      GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(301574), // Rule ID 63062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63062,
        GIR_EraseRootFromParent_Done,
      // Label 5880: @301574
      GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(301648), // Rule ID 63117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63117,
        GIR_EraseRootFromParent_Done,
      // Label 5881: @301648
      GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(301722), // Rule ID 63118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63118,
        GIR_EraseRootFromParent_Done,
      // Label 5882: @301722
      GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(301796), // Rule ID 63173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63173,
        GIR_EraseRootFromParent_Done,
      // Label 5883: @301796
      GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(301870), // Rule ID 63174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63174,
        GIR_EraseRootFromParent_Done,
      // Label 5884: @301870
      GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(301944), // Rule ID 63229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63229,
        GIR_EraseRootFromParent_Done,
      // Label 5885: @301944
      GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(302018), // Rule ID 63230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63230,
        GIR_EraseRootFromParent_Done,
      // Label 5886: @302018
      GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(302092), // Rule ID 63285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63285,
        GIR_EraseRootFromParent_Done,
      // Label 5887: @302092
      GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(302166), // Rule ID 63286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63286,
        GIR_EraseRootFromParent_Done,
      // Label 5888: @302166
      GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(302240), // Rule ID 63341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10676:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63341,
        GIR_EraseRootFromParent_Done,
      // Label 5889: @302240
      GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(302314), // Rule ID 63342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10676:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63342,
        GIR_EraseRootFromParent_Done,
      // Label 5890: @302314
      GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(302389), // Rule ID 7206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7206,
        GIR_EraseRootFromParent_Done,
      // Label 5891: @302389
      GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(302464), // Rule ID 7207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7207,
        GIR_EraseRootFromParent_Done,
      // Label 5892: @302464
      GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(302539), // Rule ID 7210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7210,
        GIR_EraseRootFromParent_Done,
      // Label 5893: @302539
      GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(302614), // Rule ID 7211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7211,
        GIR_EraseRootFromParent_Done,
      // Label 5894: @302614
      GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(302689), // Rule ID 7214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7214,
        GIR_EraseRootFromParent_Done,
      // Label 5895: @302689
      GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(302764), // Rule ID 7215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7215,
        GIR_EraseRootFromParent_Done,
      // Label 5896: @302764
      GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(302839), // Rule ID 7218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7218,
        GIR_EraseRootFromParent_Done,
      // Label 5897: @302839
      GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(302914), // Rule ID 7219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7219,
        GIR_EraseRootFromParent_Done,
      // Label 5898: @302914
      GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(302989), // Rule ID 7222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7222,
        GIR_EraseRootFromParent_Done,
      // Label 5899: @302989
      GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(303064), // Rule ID 7223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7223,
        GIR_EraseRootFromParent_Done,
      // Label 5900: @303064
      GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(303139), // Rule ID 7226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7226,
        GIR_EraseRootFromParent_Done,
      // Label 5901: @303139
      GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(303214), // Rule ID 7227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7227,
        GIR_EraseRootFromParent_Done,
      // Label 5902: @303214
      GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(303289), // Rule ID 7230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7230,
        GIR_EraseRootFromParent_Done,
      // Label 5903: @303289
      GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(303364), // Rule ID 7231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7231,
        GIR_EraseRootFromParent_Done,
      // Label 5904: @303364
      GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(303439), // Rule ID 7234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7234,
        GIR_EraseRootFromParent_Done,
      // Label 5905: @303439
      GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(303514), // Rule ID 7235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7235,
        GIR_EraseRootFromParent_Done,
      // Label 5906: @303514
      GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(303589), // Rule ID 7238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7238,
        GIR_EraseRootFromParent_Done,
      // Label 5907: @303589
      GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(303664), // Rule ID 7239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7239,
        GIR_EraseRootFromParent_Done,
      // Label 5908: @303664
      GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(303739), // Rule ID 7242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7242,
        GIR_EraseRootFromParent_Done,
      // Label 5909: @303739
      GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(303814), // Rule ID 7243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7243,
        GIR_EraseRootFromParent_Done,
      // Label 5910: @303814
      GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(303889), // Rule ID 7246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7246,
        GIR_EraseRootFromParent_Done,
      // Label 5911: @303889
      GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(303964), // Rule ID 7247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7247,
        GIR_EraseRootFromParent_Done,
      // Label 5912: @303964
      GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(304039), // Rule ID 7250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7250,
        GIR_EraseRootFromParent_Done,
      // Label 5913: @304039
      GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(304114), // Rule ID 7251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7251,
        GIR_EraseRootFromParent_Done,
      // Label 5914: @304114
      GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(304189), // Rule ID 7254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7254,
        GIR_EraseRootFromParent_Done,
      // Label 5915: @304189
      GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(304264), // Rule ID 7255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7255,
        GIR_EraseRootFromParent_Done,
      // Label 5916: @304264
      GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(304339), // Rule ID 7258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7258,
        GIR_EraseRootFromParent_Done,
      // Label 5917: @304339
      GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(304414), // Rule ID 7259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7259,
        GIR_EraseRootFromParent_Done,
      // Label 5918: @304414
      GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(304489), // Rule ID 7262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7262,
        GIR_EraseRootFromParent_Done,
      // Label 5919: @304489
      GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(304564), // Rule ID 7263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7263,
        GIR_EraseRootFromParent_Done,
      // Label 5920: @304564
      GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(304639), // Rule ID 7266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7266,
        GIR_EraseRootFromParent_Done,
      // Label 5921: @304639
      GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(304714), // Rule ID 7267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7267,
        GIR_EraseRootFromParent_Done,
      // Label 5922: @304714
      GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(304789), // Rule ID 7270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7270,
        GIR_EraseRootFromParent_Done,
      // Label 5923: @304789
      GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(304864), // Rule ID 7271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7271,
        GIR_EraseRootFromParent_Done,
      // Label 5924: @304864
      GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(304939), // Rule ID 7274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7274,
        GIR_EraseRootFromParent_Done,
      // Label 5925: @304939
      GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(305014), // Rule ID 7275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7275,
        GIR_EraseRootFromParent_Done,
      // Label 5926: @305014
      GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(305089), // Rule ID 7278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7278,
        GIR_EraseRootFromParent_Done,
      // Label 5927: @305089
      GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(305164), // Rule ID 7279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7279,
        GIR_EraseRootFromParent_Done,
      // Label 5928: @305164
      GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(305239), // Rule ID 7282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7282,
        GIR_EraseRootFromParent_Done,
      // Label 5929: @305239
      GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(305314), // Rule ID 7283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7283,
        GIR_EraseRootFromParent_Done,
      // Label 5930: @305314
      GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(305389), // Rule ID 7286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7286,
        GIR_EraseRootFromParent_Done,
      // Label 5931: @305389
      GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(305464), // Rule ID 7287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7287,
        GIR_EraseRootFromParent_Done,
      // Label 5932: @305464
      GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(305539), // Rule ID 7290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7290,
        GIR_EraseRootFromParent_Done,
      // Label 5933: @305539
      GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(305614), // Rule ID 7291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7291,
        GIR_EraseRootFromParent_Done,
      // Label 5934: @305614
      GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(305691), // Rule ID 2604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2604,
        GIR_EraseRootFromParent_Done,
      // Label 5935: @305691
      GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(305768), // Rule ID 2605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2605,
        GIR_EraseRootFromParent_Done,
      // Label 5936: @305768
      GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(305845), // Rule ID 20488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20488,
        GIR_EraseRootFromParent_Done,
      // Label 5937: @305845
      GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(305922), // Rule ID 20489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20489,
        GIR_EraseRootFromParent_Done,
      // Label 5938: @305922
      GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(305999), // Rule ID 20492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20492,
        GIR_EraseRootFromParent_Done,
      // Label 5939: @305999
      GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(306076), // Rule ID 20493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20493,
        GIR_EraseRootFromParent_Done,
      // Label 5940: @306076
      GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(306153), // Rule ID 20496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20496,
        GIR_EraseRootFromParent_Done,
      // Label 5941: @306153
      GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(306230), // Rule ID 20497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20497,
        GIR_EraseRootFromParent_Done,
      // Label 5942: @306230
      GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(306307), // Rule ID 20500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10804:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20500,
        GIR_EraseRootFromParent_Done,
      // Label 5943: @306307
      GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(306384), // Rule ID 20501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10804:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20501,
        GIR_EraseRootFromParent_Done,
      // Label 5944: @306384
      GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(306461), // Rule ID 20504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20504,
        GIR_EraseRootFromParent_Done,
      // Label 5945: @306461
      GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(306538), // Rule ID 20505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20505,
        GIR_EraseRootFromParent_Done,
      // Label 5946: @306538
      GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(306615), // Rule ID 20508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20508,
        GIR_EraseRootFromParent_Done,
      // Label 5947: @306615
      GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(306692), // Rule ID 20509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20509,
        GIR_EraseRootFromParent_Done,
      // Label 5948: @306692
      GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(306769), // Rule ID 20512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20512,
        GIR_EraseRootFromParent_Done,
      // Label 5949: @306769
      GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(306846), // Rule ID 20513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20513,
        GIR_EraseRootFromParent_Done,
      // Label 5950: @306846
      GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(306923), // Rule ID 20516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20516,
        GIR_EraseRootFromParent_Done,
      // Label 5951: @306923
      GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(307000), // Rule ID 20517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20517,
        GIR_EraseRootFromParent_Done,
      // Label 5952: @307000
      GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(307077), // Rule ID 20520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20520,
        GIR_EraseRootFromParent_Done,
      // Label 5953: @307077
      GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(307154), // Rule ID 20521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20521,
        GIR_EraseRootFromParent_Done,
      // Label 5954: @307154
      GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(307231), // Rule ID 20524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20524,
        GIR_EraseRootFromParent_Done,
      // Label 5955: @307231
      GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(307308), // Rule ID 20525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20525,
        GIR_EraseRootFromParent_Done,
      // Label 5956: @307308
      GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(307385), // Rule ID 20528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20528,
        GIR_EraseRootFromParent_Done,
      // Label 5957: @307385
      GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(307462), // Rule ID 20529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20529,
        GIR_EraseRootFromParent_Done,
      // Label 5958: @307462
      GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(307539), // Rule ID 20532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20532,
        GIR_EraseRootFromParent_Done,
      // Label 5959: @307539
      GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(307616), // Rule ID 20533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20533,
        GIR_EraseRootFromParent_Done,
      // Label 5960: @307616
      GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(307693), // Rule ID 20536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20536,
        GIR_EraseRootFromParent_Done,
      // Label 5961: @307693
      GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(307770), // Rule ID 20537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20537,
        GIR_EraseRootFromParent_Done,
      // Label 5962: @307770
      GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(307847), // Rule ID 20540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20540,
        GIR_EraseRootFromParent_Done,
      // Label 5963: @307847
      GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(307924), // Rule ID 20541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20541,
        GIR_EraseRootFromParent_Done,
      // Label 5964: @307924
      GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(308001), // Rule ID 20544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20544,
        GIR_EraseRootFromParent_Done,
      // Label 5965: @308001
      GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(308078), // Rule ID 20545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20545,
        GIR_EraseRootFromParent_Done,
      // Label 5966: @308078
      GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(308155), // Rule ID 20548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20548,
        GIR_EraseRootFromParent_Done,
      // Label 5967: @308155
      GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(308232), // Rule ID 20549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20549,
        GIR_EraseRootFromParent_Done,
      // Label 5968: @308232
      GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(308309), // Rule ID 20552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20552,
        GIR_EraseRootFromParent_Done,
      // Label 5969: @308309
      GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(308386), // Rule ID 20553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20553,
        GIR_EraseRootFromParent_Done,
      // Label 5970: @308386
      GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(308463), // Rule ID 20556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20556,
        GIR_EraseRootFromParent_Done,
      // Label 5971: @308463
      GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(308540), // Rule ID 20557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20557,
        GIR_EraseRootFromParent_Done,
      // Label 5972: @308540
      GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(308617), // Rule ID 20560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10806:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20560,
        GIR_EraseRootFromParent_Done,
      // Label 5973: @308617
      GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(308694), // Rule ID 20561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10806:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20561,
        GIR_EraseRootFromParent_Done,
      // Label 5974: @308694
      GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(308771), // Rule ID 20564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20564,
        GIR_EraseRootFromParent_Done,
      // Label 5975: @308771
      GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(308848), // Rule ID 20565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20565,
        GIR_EraseRootFromParent_Done,
      // Label 5976: @308848
      GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(308925), // Rule ID 20568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20568,
        GIR_EraseRootFromParent_Done,
      // Label 5977: @308925
      GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(309002), // Rule ID 20569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20569,
        GIR_EraseRootFromParent_Done,
      // Label 5978: @309002
      GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(309079), // Rule ID 20572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20572,
        GIR_EraseRootFromParent_Done,
      // Label 5979: @309079
      GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(309156), // Rule ID 20573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20573,
        GIR_EraseRootFromParent_Done,
      // Label 5980: @309156
      GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(309233), // Rule ID 20576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20576,
        GIR_EraseRootFromParent_Done,
      // Label 5981: @309233
      GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(309310), // Rule ID 20577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20577,
        GIR_EraseRootFromParent_Done,
      // Label 5982: @309310
      GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(309387), // Rule ID 20580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20580,
        GIR_EraseRootFromParent_Done,
      // Label 5983: @309387
      GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(309464), // Rule ID 20581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20581,
        GIR_EraseRootFromParent_Done,
      // Label 5984: @309464
      GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(309541), // Rule ID 20584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20584,
        GIR_EraseRootFromParent_Done,
      // Label 5985: @309541
      GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(309618), // Rule ID 20585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20585,
        GIR_EraseRootFromParent_Done,
      // Label 5986: @309618
      GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(309695), // Rule ID 20588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20588,
        GIR_EraseRootFromParent_Done,
      // Label 5987: @309695
      GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(309772), // Rule ID 20589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20589,
        GIR_EraseRootFromParent_Done,
      // Label 5988: @309772
      GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(309849), // Rule ID 20592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20592,
        GIR_EraseRootFromParent_Done,
      // Label 5989: @309849
      GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(309926), // Rule ID 20593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20593,
        GIR_EraseRootFromParent_Done,
      // Label 5990: @309926
      GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(310003), // Rule ID 20596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20596,
        GIR_EraseRootFromParent_Done,
      // Label 5991: @310003
      GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(310080), // Rule ID 20597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20597,
        GIR_EraseRootFromParent_Done,
      // Label 5992: @310080
      GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(310157), // Rule ID 20600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20600,
        GIR_EraseRootFromParent_Done,
      // Label 5993: @310157
      GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(310234), // Rule ID 20601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20601,
        GIR_EraseRootFromParent_Done,
      // Label 5994: @310234
      GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(310311), // Rule ID 20960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20960,
        GIR_EraseRootFromParent_Done,
      // Label 5995: @310311
      GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(310388), // Rule ID 20961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20961,
        GIR_EraseRootFromParent_Done,
      // Label 5996: @310388
      GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(310465), // Rule ID 20964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20964,
        GIR_EraseRootFromParent_Done,
      // Label 5997: @310465
      GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(310542), // Rule ID 20965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20965,
        GIR_EraseRootFromParent_Done,
      // Label 5998: @310542
      GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(310619), // Rule ID 20968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20968,
        GIR_EraseRootFromParent_Done,
      // Label 5999: @310619
      GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(310696), // Rule ID 20969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20969,
        GIR_EraseRootFromParent_Done,
      // Label 6000: @310696
      GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(310773), // Rule ID 20972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20972,
        GIR_EraseRootFromParent_Done,
      // Label 6001: @310773
      GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(310850), // Rule ID 20973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20973,
        GIR_EraseRootFromParent_Done,
      // Label 6002: @310850
      GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(310927), // Rule ID 20976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20976,
        GIR_EraseRootFromParent_Done,
      // Label 6003: @310927
      GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(311004), // Rule ID 20977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20977,
        GIR_EraseRootFromParent_Done,
      // Label 6004: @311004
      GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(311081), // Rule ID 20980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20980,
        GIR_EraseRootFromParent_Done,
      // Label 6005: @311081
      GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(311158), // Rule ID 20981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20981,
        GIR_EraseRootFromParent_Done,
      // Label 6006: @311158
      GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(311235), // Rule ID 20984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20984,
        GIR_EraseRootFromParent_Done,
      // Label 6007: @311235
      GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(311312), // Rule ID 20985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20985,
        GIR_EraseRootFromParent_Done,
      // Label 6008: @311312
      GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(311389), // Rule ID 20988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20988,
        GIR_EraseRootFromParent_Done,
      // Label 6009: @311389
      GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(311466), // Rule ID 20989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20989,
        GIR_EraseRootFromParent_Done,
      // Label 6010: @311466
      GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(311543), // Rule ID 20992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20992,
        GIR_EraseRootFromParent_Done,
      // Label 6011: @311543
      GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(311620), // Rule ID 20993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20993,
        GIR_EraseRootFromParent_Done,
      // Label 6012: @311620
      GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(311697), // Rule ID 20996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20996,
        GIR_EraseRootFromParent_Done,
      // Label 6013: @311697
      GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(311774), // Rule ID 20997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20997,
        GIR_EraseRootFromParent_Done,
      // Label 6014: @311774
      GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(311851), // Rule ID 21000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21000,
        GIR_EraseRootFromParent_Done,
      // Label 6015: @311851
      GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(311928), // Rule ID 21001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21001,
        GIR_EraseRootFromParent_Done,
      // Label 6016: @311928
      GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(312005), // Rule ID 21004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21004,
        GIR_EraseRootFromParent_Done,
      // Label 6017: @312005
      GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(312082), // Rule ID 21005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21005,
        GIR_EraseRootFromParent_Done,
      // Label 6018: @312082
      GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(312159), // Rule ID 21008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21008,
        GIR_EraseRootFromParent_Done,
      // Label 6019: @312159
      GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(312236), // Rule ID 21009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21009,
        GIR_EraseRootFromParent_Done,
      // Label 6020: @312236
      GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(312313), // Rule ID 21012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21012,
        GIR_EraseRootFromParent_Done,
      // Label 6021: @312313
      GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(312390), // Rule ID 21013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21013,
        GIR_EraseRootFromParent_Done,
      // Label 6022: @312390
      GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(312467), // Rule ID 21016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21016,
        GIR_EraseRootFromParent_Done,
      // Label 6023: @312467
      GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(312544), // Rule ID 21017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21017,
        GIR_EraseRootFromParent_Done,
      // Label 6024: @312544
      GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(312621), // Rule ID 21020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21020,
        GIR_EraseRootFromParent_Done,
      // Label 6025: @312621
      GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(312698), // Rule ID 21021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21021,
        GIR_EraseRootFromParent_Done,
      // Label 6026: @312698
      GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(312775), // Rule ID 21024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21024,
        GIR_EraseRootFromParent_Done,
      // Label 6027: @312775
      GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(312852), // Rule ID 21025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21025,
        GIR_EraseRootFromParent_Done,
      // Label 6028: @312852
      GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(312929), // Rule ID 21028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21028,
        GIR_EraseRootFromParent_Done,
      // Label 6029: @312929
      GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(313006), // Rule ID 21029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21029,
        GIR_EraseRootFromParent_Done,
      // Label 6030: @313006
      GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(313083), // Rule ID 21332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21332,
        GIR_EraseRootFromParent_Done,
      // Label 6031: @313083
      GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(313160), // Rule ID 21333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21333,
        GIR_EraseRootFromParent_Done,
      // Label 6032: @313160
      GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(313237), // Rule ID 21336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21336,
        GIR_EraseRootFromParent_Done,
      // Label 6033: @313237
      GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(313314), // Rule ID 21337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21337,
        GIR_EraseRootFromParent_Done,
      // Label 6034: @313314
      GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(313391), // Rule ID 21340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21340,
        GIR_EraseRootFromParent_Done,
      // Label 6035: @313391
      GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(313468), // Rule ID 21341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21341,
        GIR_EraseRootFromParent_Done,
      // Label 6036: @313468
      GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(313545), // Rule ID 21344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21344,
        GIR_EraseRootFromParent_Done,
      // Label 6037: @313545
      GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(313622), // Rule ID 21345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21345,
        GIR_EraseRootFromParent_Done,
      // Label 6038: @313622
      GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(313699), // Rule ID 21348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21348,
        GIR_EraseRootFromParent_Done,
      // Label 6039: @313699
      GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(313776), // Rule ID 21349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21349,
        GIR_EraseRootFromParent_Done,
      // Label 6040: @313776
      GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(313853), // Rule ID 21352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21352,
        GIR_EraseRootFromParent_Done,
      // Label 6041: @313853
      GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(313930), // Rule ID 21353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21353,
        GIR_EraseRootFromParent_Done,
      // Label 6042: @313930
      GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(314007), // Rule ID 21356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21356,
        GIR_EraseRootFromParent_Done,
      // Label 6043: @314007
      GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(314084), // Rule ID 21357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21357,
        GIR_EraseRootFromParent_Done,
      // Label 6044: @314084
      GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(314161), // Rule ID 21360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21360,
        GIR_EraseRootFromParent_Done,
      // Label 6045: @314161
      GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(314238), // Rule ID 21361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21361,
        GIR_EraseRootFromParent_Done,
      // Label 6046: @314238
      GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(314315), // Rule ID 21364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21364,
        GIR_EraseRootFromParent_Done,
      // Label 6047: @314315
      GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(314392), // Rule ID 21365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21365,
        GIR_EraseRootFromParent_Done,
      // Label 6048: @314392
      GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(314469), // Rule ID 21368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21368,
        GIR_EraseRootFromParent_Done,
      // Label 6049: @314469
      GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(314546), // Rule ID 21369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21369,
        GIR_EraseRootFromParent_Done,
      // Label 6050: @314546
      GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(314623), // Rule ID 21372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21372,
        GIR_EraseRootFromParent_Done,
      // Label 6051: @314623
      GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(314700), // Rule ID 21373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21373,
        GIR_EraseRootFromParent_Done,
      // Label 6052: @314700
      GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(314777), // Rule ID 21376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21376,
        GIR_EraseRootFromParent_Done,
      // Label 6053: @314777
      GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(314854), // Rule ID 21377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21377,
        GIR_EraseRootFromParent_Done,
      // Label 6054: @314854
      GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(314931), // Rule ID 21380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21380,
        GIR_EraseRootFromParent_Done,
      // Label 6055: @314931
      GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(315008), // Rule ID 21381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21381,
        GIR_EraseRootFromParent_Done,
      // Label 6056: @315008
      GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(315085), // Rule ID 21384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21384,
        GIR_EraseRootFromParent_Done,
      // Label 6057: @315085
      GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(315162), // Rule ID 21385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21385,
        GIR_EraseRootFromParent_Done,
      // Label 6058: @315162
      GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(315239), // Rule ID 21388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21388,
        GIR_EraseRootFromParent_Done,
      // Label 6059: @315239
      GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(315316), // Rule ID 21389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21389,
        GIR_EraseRootFromParent_Done,
      // Label 6060: @315316
      GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(315393), // Rule ID 21392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21392,
        GIR_EraseRootFromParent_Done,
      // Label 6061: @315393
      GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(315470), // Rule ID 21393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21393,
        GIR_EraseRootFromParent_Done,
      // Label 6062: @315470
      GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(315547), // Rule ID 21396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21396,
        GIR_EraseRootFromParent_Done,
      // Label 6063: @315547
      GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(315624), // Rule ID 21397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21397,
        GIR_EraseRootFromParent_Done,
      // Label 6064: @315624
      GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(315701), // Rule ID 21400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21400,
        GIR_EraseRootFromParent_Done,
      // Label 6065: @315701
      GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(315778), // Rule ID 21401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21401,
        GIR_EraseRootFromParent_Done,
      // Label 6066: @315778
      GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(315855), // Rule ID 21404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21404,
        GIR_EraseRootFromParent_Done,
      // Label 6067: @315855
      GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(315932), // Rule ID 21405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21405,
        GIR_EraseRootFromParent_Done,
      // Label 6068: @315932
      GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(316009), // Rule ID 21408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21408,
        GIR_EraseRootFromParent_Done,
      // Label 6069: @316009
      GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(316086), // Rule ID 21409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21409,
        GIR_EraseRootFromParent_Done,
      // Label 6070: @316086
      GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(316163), // Rule ID 21412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21412,
        GIR_EraseRootFromParent_Done,
      // Label 6071: @316163
      GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(316240), // Rule ID 21413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21413,
        GIR_EraseRootFromParent_Done,
      // Label 6072: @316240
      GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(316317), // Rule ID 21416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21416,
        GIR_EraseRootFromParent_Done,
      // Label 6073: @316317
      GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(316394), // Rule ID 21417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21417,
        GIR_EraseRootFromParent_Done,
      // Label 6074: @316394
      GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(316471), // Rule ID 21420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21420,
        GIR_EraseRootFromParent_Done,
      // Label 6075: @316471
      GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(316548), // Rule ID 21421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21421,
        GIR_EraseRootFromParent_Done,
      // Label 6076: @316548
      GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(316625), // Rule ID 21424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21424,
        GIR_EraseRootFromParent_Done,
      // Label 6077: @316625
      GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(316702), // Rule ID 21425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21425,
        GIR_EraseRootFromParent_Done,
      // Label 6078: @316702
      GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(316779), // Rule ID 21428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21428,
        GIR_EraseRootFromParent_Done,
      // Label 6079: @316779
      GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(316856), // Rule ID 21429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21429,
        GIR_EraseRootFromParent_Done,
      // Label 6080: @316856
      GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(316933), // Rule ID 21432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21432,
        GIR_EraseRootFromParent_Done,
      // Label 6081: @316933
      GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(317010), // Rule ID 21433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21433,
        GIR_EraseRootFromParent_Done,
      // Label 6082: @317010
      GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(317087), // Rule ID 21436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21436,
        GIR_EraseRootFromParent_Done,
      // Label 6083: @317087
      GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(317164), // Rule ID 21437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21437,
        GIR_EraseRootFromParent_Done,
      // Label 6084: @317164
      GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(317241), // Rule ID 21440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21440,
        GIR_EraseRootFromParent_Done,
      // Label 6085: @317241
      GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(317318), // Rule ID 21441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21441,
        GIR_EraseRootFromParent_Done,
      // Label 6086: @317318
      GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(317395), // Rule ID 21444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21444,
        GIR_EraseRootFromParent_Done,
      // Label 6087: @317395
      GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(317472), // Rule ID 21445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21445,
        GIR_EraseRootFromParent_Done,
      // Label 6088: @317472
      GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(317549), // Rule ID 21448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21448,
        GIR_EraseRootFromParent_Done,
      // Label 6089: @317549
      GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(317626), // Rule ID 21449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] Operand 4
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21449,
        GIR_EraseRootFromParent_Done,
      // Label 6090: @317626
      GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(317699), // Rule ID 62237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62237,
        GIR_EraseRootFromParent_Done,
      // Label 6091: @317699
      GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(317772), // Rule ID 62238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62238,
        GIR_EraseRootFromParent_Done,
      // Label 6092: @317772
      GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(317845), // Rule ID 62261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62261,
        GIR_EraseRootFromParent_Done,
      // Label 6093: @317845
      GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(317918), // Rule ID 62262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62262,
        GIR_EraseRootFromParent_Done,
      // Label 6094: @317918
      GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(317991), // Rule ID 62287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62287,
        GIR_EraseRootFromParent_Done,
      // Label 6095: @317991
      GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(318064), // Rule ID 62288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62288,
        GIR_EraseRootFromParent_Done,
      // Label 6096: @318064
      GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(318137), // Rule ID 62299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62299,
        GIR_EraseRootFromParent_Done,
      // Label 6097: @318137
      GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(318210), // Rule ID 62300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62300,
        GIR_EraseRootFromParent_Done,
      // Label 6098: @318210
      GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(318283), // Rule ID 62331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62331,
        GIR_EraseRootFromParent_Done,
      // Label 6099: @318283
      GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(318356), // Rule ID 62332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62332,
        GIR_EraseRootFromParent_Done,
      // Label 6100: @318356
      GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(318429), // Rule ID 62343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62343,
        GIR_EraseRootFromParent_Done,
      // Label 6101: @318429
      GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(318502), // Rule ID 62344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62344,
        GIR_EraseRootFromParent_Done,
      // Label 6102: @318502
      GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(318575), // Rule ID 62375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62375,
        GIR_EraseRootFromParent_Done,
      // Label 6103: @318575
      GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(318648), // Rule ID 62376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62376,
        GIR_EraseRootFromParent_Done,
      // Label 6104: @318648
      GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(318721), // Rule ID 62387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62387,
        GIR_EraseRootFromParent_Done,
      // Label 6105: @318721
      GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(318794), // Rule ID 62388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62388,
        GIR_EraseRootFromParent_Done,
      // Label 6106: @318794
      GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(318867), // Rule ID 62411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62411,
        GIR_EraseRootFromParent_Done,
      // Label 6107: @318867
      GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(318940), // Rule ID 62412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62412,
        GIR_EraseRootFromParent_Done,
      // Label 6108: @318940
      GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(319013), // Rule ID 62431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62431,
        GIR_EraseRootFromParent_Done,
      // Label 6109: @319013
      GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(319086), // Rule ID 62432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62432,
        GIR_EraseRootFromParent_Done,
      // Label 6110: @319086
      GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(319159), // Rule ID 62443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62443,
        GIR_EraseRootFromParent_Done,
      // Label 6111: @319159
      GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(319232), // Rule ID 62444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62444,
        GIR_EraseRootFromParent_Done,
      // Label 6112: @319232
      GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(319305), // Rule ID 62467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62467,
        GIR_EraseRootFromParent_Done,
      // Label 6113: @319305
      GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(319378), // Rule ID 62468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62468,
        GIR_EraseRootFromParent_Done,
      // Label 6114: @319378
      GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(319451), // Rule ID 62487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62487,
        GIR_EraseRootFromParent_Done,
      // Label 6115: @319451
      GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(319524), // Rule ID 62488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62488,
        GIR_EraseRootFromParent_Done,
      // Label 6116: @319524
      GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(319597), // Rule ID 62499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62499,
        GIR_EraseRootFromParent_Done,
      // Label 6117: @319597
      GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(319670), // Rule ID 62500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62500,
        GIR_EraseRootFromParent_Done,
      // Label 6118: @319670
      GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(319743), // Rule ID 62523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62523,
        GIR_EraseRootFromParent_Done,
      // Label 6119: @319743
      GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(319816), // Rule ID 62524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62524,
        GIR_EraseRootFromParent_Done,
      // Label 6120: @319816
      GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(319889), // Rule ID 62543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62543,
        GIR_EraseRootFromParent_Done,
      // Label 6121: @319889
      GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(319962), // Rule ID 62544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62544,
        GIR_EraseRootFromParent_Done,
      // Label 6122: @319962
      GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(320035), // Rule ID 62555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62555,
        GIR_EraseRootFromParent_Done,
      // Label 6123: @320035
      GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(320108), // Rule ID 62556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62556,
        GIR_EraseRootFromParent_Done,
      // Label 6124: @320108
      GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(320181), // Rule ID 62587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62587,
        GIR_EraseRootFromParent_Done,
      // Label 6125: @320181
      GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(320254), // Rule ID 62588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62588,
        GIR_EraseRootFromParent_Done,
      // Label 6126: @320254
      GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(320327), // Rule ID 62599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62599,
        GIR_EraseRootFromParent_Done,
      // Label 6127: @320327
      GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(320400), // Rule ID 62600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62600,
        GIR_EraseRootFromParent_Done,
      // Label 6128: @320400
      GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(320473), // Rule ID 62623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62623,
        GIR_EraseRootFromParent_Done,
      // Label 6129: @320473
      GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(320546), // Rule ID 62624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62624,
        GIR_EraseRootFromParent_Done,
      // Label 6130: @320546
      GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(320619), // Rule ID 62643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62643,
        GIR_EraseRootFromParent_Done,
      // Label 6131: @320619
      GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(320692), // Rule ID 62644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62644,
        GIR_EraseRootFromParent_Done,
      // Label 6132: @320692
      GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(320765), // Rule ID 62655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62655,
        GIR_EraseRootFromParent_Done,
      // Label 6133: @320765
      GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(320838), // Rule ID 62656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62656,
        GIR_EraseRootFromParent_Done,
      // Label 6134: @320838
      GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(320911), // Rule ID 62679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62679,
        GIR_EraseRootFromParent_Done,
      // Label 6135: @320911
      GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(320984), // Rule ID 62680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62680,
        GIR_EraseRootFromParent_Done,
      // Label 6136: @320984
      GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(321057), // Rule ID 62699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62699,
        GIR_EraseRootFromParent_Done,
      // Label 6137: @321057
      GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(321130), // Rule ID 62700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62700,
        GIR_EraseRootFromParent_Done,
      // Label 6138: @321130
      GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(321203), // Rule ID 62711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62711,
        GIR_EraseRootFromParent_Done,
      // Label 6139: @321203
      GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(321276), // Rule ID 62712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62712,
        GIR_EraseRootFromParent_Done,
      // Label 6140: @321276
      GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(321349), // Rule ID 62735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62735,
        GIR_EraseRootFromParent_Done,
      // Label 6141: @321349
      GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(321422), // Rule ID 62736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62736,
        GIR_EraseRootFromParent_Done,
      // Label 6142: @321422
      GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(321495), // Rule ID 62755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62755,
        GIR_EraseRootFromParent_Done,
      // Label 6143: @321495
      GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(321568), // Rule ID 62756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62756,
        GIR_EraseRootFromParent_Done,
      // Label 6144: @321568
      GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(321641), // Rule ID 62767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62767,
        GIR_EraseRootFromParent_Done,
      // Label 6145: @321641
      GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(321714), // Rule ID 62768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62768,
        GIR_EraseRootFromParent_Done,
      // Label 6146: @321714
      GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(321787), // Rule ID 62799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62799,
        GIR_EraseRootFromParent_Done,
      // Label 6147: @321787
      GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(321860), // Rule ID 62800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62800,
        GIR_EraseRootFromParent_Done,
      // Label 6148: @321860
      GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(321933), // Rule ID 62811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62811,
        GIR_EraseRootFromParent_Done,
      // Label 6149: @321933
      GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(322006), // Rule ID 62812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62812,
        GIR_EraseRootFromParent_Done,
      // Label 6150: @322006
      GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(322079), // Rule ID 62843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62843,
        GIR_EraseRootFromParent_Done,
      // Label 6151: @322079
      GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(322152), // Rule ID 62844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62844,
        GIR_EraseRootFromParent_Done,
      // Label 6152: @322152
      GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(322225), // Rule ID 62855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62855,
        GIR_EraseRootFromParent_Done,
      // Label 6153: @322225
      GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(322298), // Rule ID 62856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62856,
        GIR_EraseRootFromParent_Done,
      // Label 6154: @322298
      GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(322371), // Rule ID 62887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62887,
        GIR_EraseRootFromParent_Done,
      // Label 6155: @322371
      GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(322444), // Rule ID 62888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62888,
        GIR_EraseRootFromParent_Done,
      // Label 6156: @322444
      GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(322517), // Rule ID 62899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62899,
        GIR_EraseRootFromParent_Done,
      // Label 6157: @322517
      GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(322590), // Rule ID 62900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62900,
        GIR_EraseRootFromParent_Done,
      // Label 6158: @322590
      GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(322663), // Rule ID 62923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62923,
        GIR_EraseRootFromParent_Done,
      // Label 6159: @322663
      GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(322736), // Rule ID 62924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62924,
        GIR_EraseRootFromParent_Done,
      // Label 6160: @322736
      GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(322809), // Rule ID 62943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62943,
        GIR_EraseRootFromParent_Done,
      // Label 6161: @322809
      GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(322882), // Rule ID 62944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62944,
        GIR_EraseRootFromParent_Done,
      // Label 6162: @322882
      GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(322955), // Rule ID 62955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62955,
        GIR_EraseRootFromParent_Done,
      // Label 6163: @322955
      GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(323028), // Rule ID 62956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62956,
        GIR_EraseRootFromParent_Done,
      // Label 6164: @323028
      GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(323101), // Rule ID 62979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62979,
        GIR_EraseRootFromParent_Done,
      // Label 6165: @323101
      GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(323174), // Rule ID 62980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62980,
        GIR_EraseRootFromParent_Done,
      // Label 6166: @323174
      GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(323247), // Rule ID 62999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62999,
        GIR_EraseRootFromParent_Done,
      // Label 6167: @323247
      GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(323320), // Rule ID 63000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63000,
        GIR_EraseRootFromParent_Done,
      // Label 6168: @323320
      GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(323393), // Rule ID 63011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63011,
        GIR_EraseRootFromParent_Done,
      // Label 6169: @323393
      GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(323466), // Rule ID 63012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63012,
        GIR_EraseRootFromParent_Done,
      // Label 6170: @323466
      GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(323539), // Rule ID 63035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63035,
        GIR_EraseRootFromParent_Done,
      // Label 6171: @323539
      GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(323612), // Rule ID 63036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63036,
        GIR_EraseRootFromParent_Done,
      // Label 6172: @323612
      GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(323685), // Rule ID 63055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63055,
        GIR_EraseRootFromParent_Done,
      // Label 6173: @323685
      GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(323758), // Rule ID 63056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63056,
        GIR_EraseRootFromParent_Done,
      // Label 6174: @323758
      GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(323831), // Rule ID 63067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63067,
        GIR_EraseRootFromParent_Done,
      // Label 6175: @323831
      GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(323904), // Rule ID 63068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63068,
        GIR_EraseRootFromParent_Done,
      // Label 6176: @323904
      GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(323977), // Rule ID 63091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63091,
        GIR_EraseRootFromParent_Done,
      // Label 6177: @323977
      GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(324050), // Rule ID 63092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63092,
        GIR_EraseRootFromParent_Done,
      // Label 6178: @324050
      GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(324123), // Rule ID 63111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63111,
        GIR_EraseRootFromParent_Done,
      // Label 6179: @324123
      GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(324196), // Rule ID 63112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63112,
        GIR_EraseRootFromParent_Done,
      // Label 6180: @324196
      GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(324269), // Rule ID 63123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63123,
        GIR_EraseRootFromParent_Done,
      // Label 6181: @324269
      GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(324342), // Rule ID 63124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63124,
        GIR_EraseRootFromParent_Done,
      // Label 6182: @324342
      GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(324415), // Rule ID 63147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63147,
        GIR_EraseRootFromParent_Done,
      // Label 6183: @324415
      GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(324488), // Rule ID 63148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63148,
        GIR_EraseRootFromParent_Done,
      // Label 6184: @324488
      GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(324561), // Rule ID 63167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63167,
        GIR_EraseRootFromParent_Done,
      // Label 6185: @324561
      GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(324634), // Rule ID 63168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63168,
        GIR_EraseRootFromParent_Done,
      // Label 6186: @324634
      GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(324707), // Rule ID 63179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63179,
        GIR_EraseRootFromParent_Done,
      // Label 6187: @324707
      GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(324780), // Rule ID 63180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63180,
        GIR_EraseRootFromParent_Done,
      // Label 6188: @324780
      GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(324853), // Rule ID 63203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63203,
        GIR_EraseRootFromParent_Done,
      // Label 6189: @324853
      GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(324926), // Rule ID 63204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63204,
        GIR_EraseRootFromParent_Done,
      // Label 6190: @324926
      GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(324999), // Rule ID 63223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63223,
        GIR_EraseRootFromParent_Done,
      // Label 6191: @324999
      GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(325072), // Rule ID 63224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63224,
        GIR_EraseRootFromParent_Done,
      // Label 6192: @325072
      GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(325145), // Rule ID 63235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63235,
        GIR_EraseRootFromParent_Done,
      // Label 6193: @325145
      GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(325218), // Rule ID 63236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63236,
        GIR_EraseRootFromParent_Done,
      // Label 6194: @325218
      GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(325291), // Rule ID 63259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63259,
        GIR_EraseRootFromParent_Done,
      // Label 6195: @325291
      GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(325364), // Rule ID 63260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63260,
        GIR_EraseRootFromParent_Done,
      // Label 6196: @325364
      GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(325437), // Rule ID 63279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63279,
        GIR_EraseRootFromParent_Done,
      // Label 6197: @325437
      GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(325510), // Rule ID 63280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63280,
        GIR_EraseRootFromParent_Done,
      // Label 6198: @325510
      GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(325583), // Rule ID 63291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63291,
        GIR_EraseRootFromParent_Done,
      // Label 6199: @325583
      GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(325656), // Rule ID 63292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63292,
        GIR_EraseRootFromParent_Done,
      // Label 6200: @325656
      GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(325729), // Rule ID 63315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63315,
        GIR_EraseRootFromParent_Done,
      // Label 6201: @325729
      GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(325802), // Rule ID 63316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63316,
        GIR_EraseRootFromParent_Done,
      // Label 6202: @325802
      GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(325875), // Rule ID 63335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10690:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63335,
        GIR_EraseRootFromParent_Done,
      // Label 6203: @325875
      GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(325948), // Rule ID 63336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10690:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63336,
        GIR_EraseRootFromParent_Done,
      // Label 6204: @325948
      GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(326021), // Rule ID 63347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10682:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63347,
        GIR_EraseRootFromParent_Done,
      // Label 6205: @326021
      GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(326094), // Rule ID 63348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10682:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63348,
        GIR_EraseRootFromParent_Done,
      // Label 6206: @326094
      GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(326167), // Rule ID 63371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10668:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63371,
        GIR_EraseRootFromParent_Done,
      // Label 6207: @326167
      GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(326240), // Rule ID 63372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10668:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63372,
        GIR_EraseRootFromParent_Done,
      // Label 6208: @326240
      GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(326341), // Rule ID 5184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5184,
        GIR_EraseRootFromParent_Done,
      // Label 6209: @326341
      GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(326442), // Rule ID 5185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5185,
        GIR_EraseRootFromParent_Done,
      // Label 6210: @326442
      GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(326543), // Rule ID 5186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5186,
        GIR_EraseRootFromParent_Done,
      // Label 6211: @326543
      GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(326644), // Rule ID 5187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5187,
        GIR_EraseRootFromParent_Done,
      // Label 6212: @326644
      GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(326745), // Rule ID 5188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5188,
        GIR_EraseRootFromParent_Done,
      // Label 6213: @326745
      GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(326846), // Rule ID 5189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5189,
        GIR_EraseRootFromParent_Done,
      // Label 6214: @326846
      GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(326947), // Rule ID 5190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5190,
        GIR_EraseRootFromParent_Done,
      // Label 6215: @326947
      GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(327048), // Rule ID 5191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5191,
        GIR_EraseRootFromParent_Done,
      // Label 6216: @327048
      GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(327149), // Rule ID 5192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5192,
        GIR_EraseRootFromParent_Done,
      // Label 6217: @327149
      GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(327250), // Rule ID 5193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5193,
        GIR_EraseRootFromParent_Done,
      // Label 6218: @327250
      GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(327351), // Rule ID 5194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5194,
        GIR_EraseRootFromParent_Done,
      // Label 6219: @327351
      GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(327452), // Rule ID 5195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5195,
        GIR_EraseRootFromParent_Done,
      // Label 6220: @327452
      GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(327553), // Rule ID 5196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5196,
        GIR_EraseRootFromParent_Done,
      // Label 6221: @327553
      GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(327654), // Rule ID 5197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5197,
        GIR_EraseRootFromParent_Done,
      // Label 6222: @327654
      GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(327755), // Rule ID 5198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5198,
        GIR_EraseRootFromParent_Done,
      // Label 6223: @327755
      GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(327856), // Rule ID 5199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5199,
        GIR_EraseRootFromParent_Done,
      // Label 6224: @327856
      GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(327957), // Rule ID 5200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5200,
        GIR_EraseRootFromParent_Done,
      // Label 6225: @327957
      GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(328058), // Rule ID 5201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5201,
        GIR_EraseRootFromParent_Done,
      // Label 6226: @328058
      GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(328159), // Rule ID 5202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5202,
        GIR_EraseRootFromParent_Done,
      // Label 6227: @328159
      GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(328260), // Rule ID 5203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5203,
        GIR_EraseRootFromParent_Done,
      // Label 6228: @328260
      GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(328361), // Rule ID 5204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5204,
        GIR_EraseRootFromParent_Done,
      // Label 6229: @328361
      GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(328462), // Rule ID 5205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5205,
        GIR_EraseRootFromParent_Done,
      // Label 6230: @328462
      GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(328563), // Rule ID 5206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5206,
        GIR_EraseRootFromParent_Done,
      // Label 6231: @328563
      GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(328664), // Rule ID 5207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5207,
        GIR_EraseRootFromParent_Done,
      // Label 6232: @328664
      GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(328765), // Rule ID 5208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5208,
        GIR_EraseRootFromParent_Done,
      // Label 6233: @328765
      GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(328866), // Rule ID 5209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5209,
        GIR_EraseRootFromParent_Done,
      // Label 6234: @328866
      GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(328967), // Rule ID 5210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5210,
        GIR_EraseRootFromParent_Done,
      // Label 6235: @328967
      GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(329068), // Rule ID 5211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5211,
        GIR_EraseRootFromParent_Done,
      // Label 6236: @329068
      GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(329169), // Rule ID 5212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5212,
        GIR_EraseRootFromParent_Done,
      // Label 6237: @329169
      GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(329270), // Rule ID 5213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5213,
        GIR_EraseRootFromParent_Done,
      // Label 6238: @329270
      GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(329371), // Rule ID 5214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5214,
        GIR_EraseRootFromParent_Done,
      // Label 6239: @329371
      GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(329472), // Rule ID 5215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5215,
        GIR_EraseRootFromParent_Done,
      // Label 6240: @329472
      GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(329573), // Rule ID 5216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5216,
        GIR_EraseRootFromParent_Done,
      // Label 6241: @329573
      GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(329674), // Rule ID 5217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5217,
        GIR_EraseRootFromParent_Done,
      // Label 6242: @329674
      GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(329775), // Rule ID 5218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5218,
        GIR_EraseRootFromParent_Done,
      // Label 6243: @329775
      GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(329876), // Rule ID 5219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5219,
        GIR_EraseRootFromParent_Done,
      // Label 6244: @329876
      GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(329977), // Rule ID 5220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5220,
        GIR_EraseRootFromParent_Done,
      // Label 6245: @329977
      GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(330078), // Rule ID 5221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5221,
        GIR_EraseRootFromParent_Done,
      // Label 6246: @330078
      GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(330179), // Rule ID 5222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5222,
        GIR_EraseRootFromParent_Done,
      // Label 6247: @330179
      GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(330280), // Rule ID 5223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5223,
        GIR_EraseRootFromParent_Done,
      // Label 6248: @330280
      GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(330381), // Rule ID 5224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5224,
        GIR_EraseRootFromParent_Done,
      // Label 6249: @330381
      GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(330482), // Rule ID 5225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5225,
        GIR_EraseRootFromParent_Done,
      // Label 6250: @330482
      GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(330583), // Rule ID 5226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5226,
        GIR_EraseRootFromParent_Done,
      // Label 6251: @330583
      GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(330684), // Rule ID 5227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5227,
        GIR_EraseRootFromParent_Done,
      // Label 6252: @330684
      GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(330760), // Rule ID 59984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10760:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59984,
        GIR_EraseRootFromParent_Done,
      // Label 6253: @330760
      GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(330836), // Rule ID 59985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10760:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59985,
        GIR_EraseRootFromParent_Done,
      // Label 6254: @330836
      GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(330912), // Rule ID 61630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10760:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61630,
        GIR_EraseRootFromParent_Done,
      // Label 6255: @330912
      GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(330988), // Rule ID 61631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10760:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61631,
        GIR_EraseRootFromParent_Done,
      // Label 6256: @330988
      GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(331064), // Rule ID 61632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10760:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61632,
        GIR_EraseRootFromParent_Done,
      // Label 6257: @331064
      GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(331140), // Rule ID 61633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10760:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61633,
        GIR_EraseRootFromParent_Done,
      // Label 6258: @331140
      GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(331216), // Rule ID 61634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10760:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61634,
        GIR_EraseRootFromParent_Done,
      // Label 6259: @331216
      GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(331292), // Rule ID 61635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10760:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61635,
        GIR_EraseRootFromParent_Done,
      // Label 6260: @331292
      GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(331368), // Rule ID 61636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10760:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61636,
        GIR_EraseRootFromParent_Done,
      // Label 6261: @331368
      GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(331444), // Rule ID 61637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10760:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61637,
        GIR_EraseRootFromParent_Done,
      // Label 6262: @331444
      GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(331520), // Rule ID 61758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61758,
        GIR_EraseRootFromParent_Done,
      // Label 6263: @331520
      GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(331596), // Rule ID 61759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61759,
        GIR_EraseRootFromParent_Done,
      // Label 6264: @331596
      GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(331672), // Rule ID 61760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61760,
        GIR_EraseRootFromParent_Done,
      // Label 6265: @331672
      GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(331748), // Rule ID 61761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61761,
        GIR_EraseRootFromParent_Done,
      // Label 6266: @331748
      GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(331824), // Rule ID 61762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61762,
        GIR_EraseRootFromParent_Done,
      // Label 6267: @331824
      GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(331900), // Rule ID 61763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61763,
        GIR_EraseRootFromParent_Done,
      // Label 6268: @331900
      GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(331976), // Rule ID 61764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61764,
        GIR_EraseRootFromParent_Done,
      // Label 6269: @331976
      GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(332052), // Rule ID 61765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61765,
        GIR_EraseRootFromParent_Done,
      // Label 6270: @332052
      GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(332128), // Rule ID 61766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61766,
        GIR_EraseRootFromParent_Done,
      // Label 6271: @332128
      GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(332204), // Rule ID 61767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61767,
        GIR_EraseRootFromParent_Done,
      // Label 6272: @332204
      GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(332292), // Rule ID 2654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2654,
        GIR_EraseRootFromParent_Done,
      // Label 6273: @332292
      GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(332380), // Rule ID 2655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2655,
        GIR_EraseRootFromParent_Done,
      // Label 6274: @332380
      GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(332468), // Rule ID 2662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2662,
        GIR_EraseRootFromParent_Done,
      // Label 6275: @332468
      GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(332556), // Rule ID 2663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2663,
        GIR_EraseRootFromParent_Done,
      // Label 6276: @332556
      GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(332644), // Rule ID 2670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2670,
        GIR_EraseRootFromParent_Done,
      // Label 6277: @332644
      GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(332732), // Rule ID 2671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2671,
        GIR_EraseRootFromParent_Done,
      // Label 6278: @332732
      GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(332820), // Rule ID 2678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2678,
        GIR_EraseRootFromParent_Done,
      // Label 6279: @332820
      GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(332908), // Rule ID 2679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2679,
        GIR_EraseRootFromParent_Done,
      // Label 6280: @332908
      GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(332996), // Rule ID 2686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2686,
        GIR_EraseRootFromParent_Done,
      // Label 6281: @332996
      GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(333084), // Rule ID 2687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2687,
        GIR_EraseRootFromParent_Done,
      // Label 6282: @333084
      GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(333172), // Rule ID 2694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2694,
        GIR_EraseRootFromParent_Done,
      // Label 6283: @333172
      GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(333260), // Rule ID 2695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2695,
        GIR_EraseRootFromParent_Done,
      // Label 6284: @333260
      GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(333348), // Rule ID 2702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2702,
        GIR_EraseRootFromParent_Done,
      // Label 6285: @333348
      GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(333436), // Rule ID 2703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2703,
        GIR_EraseRootFromParent_Done,
      // Label 6286: @333436
      GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(333524), // Rule ID 2710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2710,
        GIR_EraseRootFromParent_Done,
      // Label 6287: @333524
      GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(333612), // Rule ID 2711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2711,
        GIR_EraseRootFromParent_Done,
      // Label 6288: @333612
      GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(333700), // Rule ID 2718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2718,
        GIR_EraseRootFromParent_Done,
      // Label 6289: @333700
      GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(333788), // Rule ID 2719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2719,
        GIR_EraseRootFromParent_Done,
      // Label 6290: @333788
      GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(333876), // Rule ID 2726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2726,
        GIR_EraseRootFromParent_Done,
      // Label 6291: @333876
      GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(333964), // Rule ID 2727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2727,
        GIR_EraseRootFromParent_Done,
      // Label 6292: @333964
      GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(334052), // Rule ID 2734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2734,
        GIR_EraseRootFromParent_Done,
      // Label 6293: @334052
      GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(334140), // Rule ID 2735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2735,
        GIR_EraseRootFromParent_Done,
      // Label 6294: @334140
      GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(334228), // Rule ID 2742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2742,
        GIR_EraseRootFromParent_Done,
      // Label 6295: @334228
      GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(334316), // Rule ID 2743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2743,
        GIR_EraseRootFromParent_Done,
      // Label 6296: @334316
      GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(334404), // Rule ID 2750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2750,
        GIR_EraseRootFromParent_Done,
      // Label 6297: @334404
      GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(334492), // Rule ID 2751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2751,
        GIR_EraseRootFromParent_Done,
      // Label 6298: @334492
      GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(334580), // Rule ID 2758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2758,
        GIR_EraseRootFromParent_Done,
      // Label 6299: @334580
      GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(334668), // Rule ID 2759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2759,
        GIR_EraseRootFromParent_Done,
      // Label 6300: @334668
      GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(334756), // Rule ID 2766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2766,
        GIR_EraseRootFromParent_Done,
      // Label 6301: @334756
      GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(334844), // Rule ID 2767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2767,
        GIR_EraseRootFromParent_Done,
      // Label 6302: @334844
      GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(334932), // Rule ID 2774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2774,
        GIR_EraseRootFromParent_Done,
      // Label 6303: @334932
      GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(335020), // Rule ID 2775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2775,
        GIR_EraseRootFromParent_Done,
      // Label 6304: @335020
      GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(335108), // Rule ID 2782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2782,
        GIR_EraseRootFromParent_Done,
      // Label 6305: @335108
      GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(335196), // Rule ID 2783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2783,
        GIR_EraseRootFromParent_Done,
      // Label 6306: @335196
      GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(335284), // Rule ID 2790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2790,
        GIR_EraseRootFromParent_Done,
      // Label 6307: @335284
      GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(335372), // Rule ID 2791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2791,
        GIR_EraseRootFromParent_Done,
      // Label 6308: @335372
      GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(335460), // Rule ID 2798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2798,
        GIR_EraseRootFromParent_Done,
      // Label 6309: @335460
      GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(335548), // Rule ID 2799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2799,
        GIR_EraseRootFromParent_Done,
      // Label 6310: @335548
      GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(335636), // Rule ID 2806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2806,
        GIR_EraseRootFromParent_Done,
      // Label 6311: @335636
      GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(335724), // Rule ID 2807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2807,
        GIR_EraseRootFromParent_Done,
      // Label 6312: @335724
      GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(335812), // Rule ID 2814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2814,
        GIR_EraseRootFromParent_Done,
      // Label 6313: @335812
      GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(335900), // Rule ID 2815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2815,
        GIR_EraseRootFromParent_Done,
      // Label 6314: @335900
      GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(335988), // Rule ID 2822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2822,
        GIR_EraseRootFromParent_Done,
      // Label 6315: @335988
      GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(336076), // Rule ID 2823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2823,
        GIR_EraseRootFromParent_Done,
      // Label 6316: @336076
      GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(336162), // Rule ID 2998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2998,
        GIR_EraseRootFromParent_Done,
      // Label 6317: @336162
      GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(336248), // Rule ID 2999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2999,
        GIR_EraseRootFromParent_Done,
      // Label 6318: @336248
      GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(336334), // Rule ID 3002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3002,
        GIR_EraseRootFromParent_Done,
      // Label 6319: @336334
      GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(336420), // Rule ID 3003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3003,
        GIR_EraseRootFromParent_Done,
      // Label 6320: @336420
      GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(336506), // Rule ID 3006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3006,
        GIR_EraseRootFromParent_Done,
      // Label 6321: @336506
      GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(336592), // Rule ID 3007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3007,
        GIR_EraseRootFromParent_Done,
      // Label 6322: @336592
      GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(336678), // Rule ID 3010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3010,
        GIR_EraseRootFromParent_Done,
      // Label 6323: @336678
      GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(336764), // Rule ID 3011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3011,
        GIR_EraseRootFromParent_Done,
      // Label 6324: @336764
      GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(336850), // Rule ID 3014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3014,
        GIR_EraseRootFromParent_Done,
      // Label 6325: @336850
      GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(336936), // Rule ID 3015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3015,
        GIR_EraseRootFromParent_Done,
      // Label 6326: @336936
      GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(337022), // Rule ID 3018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3018,
        GIR_EraseRootFromParent_Done,
      // Label 6327: @337022
      GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(337108), // Rule ID 3019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3019,
        GIR_EraseRootFromParent_Done,
      // Label 6328: @337108
      GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(337194), // Rule ID 3022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3022,
        GIR_EraseRootFromParent_Done,
      // Label 6329: @337194
      GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(337280), // Rule ID 3023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3023,
        GIR_EraseRootFromParent_Done,
      // Label 6330: @337280
      GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(337366), // Rule ID 3026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3026,
        GIR_EraseRootFromParent_Done,
      // Label 6331: @337366
      GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(337452), // Rule ID 3027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3027,
        GIR_EraseRootFromParent_Done,
      // Label 6332: @337452
      GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(337538), // Rule ID 3030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3030,
        GIR_EraseRootFromParent_Done,
      // Label 6333: @337538
      GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(337624), // Rule ID 3031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3031,
        GIR_EraseRootFromParent_Done,
      // Label 6334: @337624
      GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(337710), // Rule ID 3034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3034,
        GIR_EraseRootFromParent_Done,
      // Label 6335: @337710
      GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(337796), // Rule ID 3035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3035,
        GIR_EraseRootFromParent_Done,
      // Label 6336: @337796
      GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(337882), // Rule ID 3038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3038,
        GIR_EraseRootFromParent_Done,
      // Label 6337: @337882
      GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(337968), // Rule ID 3039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3039,
        GIR_EraseRootFromParent_Done,
      // Label 6338: @337968
      GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(338054), // Rule ID 3042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3042,
        GIR_EraseRootFromParent_Done,
      // Label 6339: @338054
      GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(338140), // Rule ID 3043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3043,
        GIR_EraseRootFromParent_Done,
      // Label 6340: @338140
      GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(338226), // Rule ID 3046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3046,
        GIR_EraseRootFromParent_Done,
      // Label 6341: @338226
      GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(338312), // Rule ID 3047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3047,
        GIR_EraseRootFromParent_Done,
      // Label 6342: @338312
      GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(338398), // Rule ID 3050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3050,
        GIR_EraseRootFromParent_Done,
      // Label 6343: @338398
      GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(338484), // Rule ID 3051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3051,
        GIR_EraseRootFromParent_Done,
      // Label 6344: @338484
      GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(338570), // Rule ID 3054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3054,
        GIR_EraseRootFromParent_Done,
      // Label 6345: @338570
      GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(338656), // Rule ID 3055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3055,
        GIR_EraseRootFromParent_Done,
      // Label 6346: @338656
      GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(338742), // Rule ID 3058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3058,
        GIR_EraseRootFromParent_Done,
      // Label 6347: @338742
      GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(338828), // Rule ID 3059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3059,
        GIR_EraseRootFromParent_Done,
      // Label 6348: @338828
      GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(338914), // Rule ID 3062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3062,
        GIR_EraseRootFromParent_Done,
      // Label 6349: @338914
      GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(339000), // Rule ID 3063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3063,
        GIR_EraseRootFromParent_Done,
      // Label 6350: @339000
      GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(339086), // Rule ID 3066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3066,
        GIR_EraseRootFromParent_Done,
      // Label 6351: @339086
      GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(339172), // Rule ID 3067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3067,
        GIR_EraseRootFromParent_Done,
      // Label 6352: @339172
      GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(339258), // Rule ID 3070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3070,
        GIR_EraseRootFromParent_Done,
      // Label 6353: @339258
      GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(339344), // Rule ID 3071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3071,
        GIR_EraseRootFromParent_Done,
      // Label 6354: @339344
      GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(339430), // Rule ID 3074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3074,
        GIR_EraseRootFromParent_Done,
      // Label 6355: @339430
      GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(339516), // Rule ID 3075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3075,
        GIR_EraseRootFromParent_Done,
      // Label 6356: @339516
      GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(339602), // Rule ID 3078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3078,
        GIR_EraseRootFromParent_Done,
      // Label 6357: @339602
      GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(339688), // Rule ID 3079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3079,
        GIR_EraseRootFromParent_Done,
      // Label 6358: @339688
      GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(339774), // Rule ID 3082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3082,
        GIR_EraseRootFromParent_Done,
      // Label 6359: @339774
      GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(339860), // Rule ID 3083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3083,
        GIR_EraseRootFromParent_Done,
      // Label 6360: @339860
      GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(339946), // Rule ID 3350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3350,
        GIR_EraseRootFromParent_Done,
      // Label 6361: @339946
      GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(340032), // Rule ID 3351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3351,
        GIR_EraseRootFromParent_Done,
      // Label 6362: @340032
      GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(340118), // Rule ID 3354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3354,
        GIR_EraseRootFromParent_Done,
      // Label 6363: @340118
      GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(340204), // Rule ID 3355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3355,
        GIR_EraseRootFromParent_Done,
      // Label 6364: @340204
      GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(340290), // Rule ID 3358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3358,
        GIR_EraseRootFromParent_Done,
      // Label 6365: @340290
      GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(340376), // Rule ID 3359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3359,
        GIR_EraseRootFromParent_Done,
      // Label 6366: @340376
      GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(340462), // Rule ID 3362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3362,
        GIR_EraseRootFromParent_Done,
      // Label 6367: @340462
      GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(340548), // Rule ID 3363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3363,
        GIR_EraseRootFromParent_Done,
      // Label 6368: @340548
      GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(340634), // Rule ID 3366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3366,
        GIR_EraseRootFromParent_Done,
      // Label 6369: @340634
      GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(340720), // Rule ID 3367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3367,
        GIR_EraseRootFromParent_Done,
      // Label 6370: @340720
      GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(340806), // Rule ID 3370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3370,
        GIR_EraseRootFromParent_Done,
      // Label 6371: @340806
      GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(340892), // Rule ID 3371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3371,
        GIR_EraseRootFromParent_Done,
      // Label 6372: @340892
      GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(340978), // Rule ID 3374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3374,
        GIR_EraseRootFromParent_Done,
      // Label 6373: @340978
      GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(341064), // Rule ID 3375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3375,
        GIR_EraseRootFromParent_Done,
      // Label 6374: @341064
      GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(341150), // Rule ID 3378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3378,
        GIR_EraseRootFromParent_Done,
      // Label 6375: @341150
      GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(341236), // Rule ID 3379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3379,
        GIR_EraseRootFromParent_Done,
      // Label 6376: @341236
      GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(341322), // Rule ID 3382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3382,
        GIR_EraseRootFromParent_Done,
      // Label 6377: @341322
      GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(341408), // Rule ID 3383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3383,
        GIR_EraseRootFromParent_Done,
      // Label 6378: @341408
      GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(341494), // Rule ID 3386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3386,
        GIR_EraseRootFromParent_Done,
      // Label 6379: @341494
      GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(341580), // Rule ID 3387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3387,
        GIR_EraseRootFromParent_Done,
      // Label 6380: @341580
      GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(341666), // Rule ID 3390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3390,
        GIR_EraseRootFromParent_Done,
      // Label 6381: @341666
      GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(341752), // Rule ID 3391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3391,
        GIR_EraseRootFromParent_Done,
      // Label 6382: @341752
      GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(341838), // Rule ID 3394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3394,
        GIR_EraseRootFromParent_Done,
      // Label 6383: @341838
      GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(341924), // Rule ID 3395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3395,
        GIR_EraseRootFromParent_Done,
      // Label 6384: @341924
      GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(342010), // Rule ID 3398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3398,
        GIR_EraseRootFromParent_Done,
      // Label 6385: @342010
      GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(342096), // Rule ID 3399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3399,
        GIR_EraseRootFromParent_Done,
      // Label 6386: @342096
      GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(342182), // Rule ID 3402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3402,
        GIR_EraseRootFromParent_Done,
      // Label 6387: @342182
      GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(342268), // Rule ID 3403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3403,
        GIR_EraseRootFromParent_Done,
      // Label 6388: @342268
      GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(342354), // Rule ID 3406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3406,
        GIR_EraseRootFromParent_Done,
      // Label 6389: @342354
      GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(342440), // Rule ID 3407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3407,
        GIR_EraseRootFromParent_Done,
      // Label 6390: @342440
      GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(342526), // Rule ID 3410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3410,
        GIR_EraseRootFromParent_Done,
      // Label 6391: @342526
      GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(342612), // Rule ID 3411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3411,
        GIR_EraseRootFromParent_Done,
      // Label 6392: @342612
      GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(342698), // Rule ID 3414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3414,
        GIR_EraseRootFromParent_Done,
      // Label 6393: @342698
      GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(342784), // Rule ID 3415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3415,
        GIR_EraseRootFromParent_Done,
      // Label 6394: @342784
      GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(342870), // Rule ID 3418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3418,
        GIR_EraseRootFromParent_Done,
      // Label 6395: @342870
      GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(342956), // Rule ID 3419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3419,
        GIR_EraseRootFromParent_Done,
      // Label 6396: @342956
      GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(343042), // Rule ID 3422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3422,
        GIR_EraseRootFromParent_Done,
      // Label 6397: @343042
      GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(343128), // Rule ID 3423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3423,
        GIR_EraseRootFromParent_Done,
      // Label 6398: @343128
      GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(343214), // Rule ID 3426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3426,
        GIR_EraseRootFromParent_Done,
      // Label 6399: @343214
      GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(343300), // Rule ID 3427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3427,
        GIR_EraseRootFromParent_Done,
      // Label 6400: @343300
      GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(343386), // Rule ID 3430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3430,
        GIR_EraseRootFromParent_Done,
      // Label 6401: @343386
      GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(343472), // Rule ID 3431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3431,
        GIR_EraseRootFromParent_Done,
      // Label 6402: @343472
      GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(343558), // Rule ID 3434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3434,
        GIR_EraseRootFromParent_Done,
      // Label 6403: @343558
      GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(343644), // Rule ID 3435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3435,
        GIR_EraseRootFromParent_Done,
      // Label 6404: @343644
      GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(343730), // Rule ID 5798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5798,
        GIR_EraseRootFromParent_Done,
      // Label 6405: @343730
      GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(343816), // Rule ID 5799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5799,
        GIR_EraseRootFromParent_Done,
      // Label 6406: @343816
      GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(343902), // Rule ID 5802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5802,
        GIR_EraseRootFromParent_Done,
      // Label 6407: @343902
      GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(343988), // Rule ID 5803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5803,
        GIR_EraseRootFromParent_Done,
      // Label 6408: @343988
      GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(344074), // Rule ID 5806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5806,
        GIR_EraseRootFromParent_Done,
      // Label 6409: @344074
      GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(344160), // Rule ID 5807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5807,
        GIR_EraseRootFromParent_Done,
      // Label 6410: @344160
      GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(344246), // Rule ID 5810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5810,
        GIR_EraseRootFromParent_Done,
      // Label 6411: @344246
      GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(344332), // Rule ID 5811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5811,
        GIR_EraseRootFromParent_Done,
      // Label 6412: @344332
      GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(344418), // Rule ID 5814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5814,
        GIR_EraseRootFromParent_Done,
      // Label 6413: @344418
      GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(344504), // Rule ID 5815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5815,
        GIR_EraseRootFromParent_Done,
      // Label 6414: @344504
      GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(344590), // Rule ID 5818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5818,
        GIR_EraseRootFromParent_Done,
      // Label 6415: @344590
      GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(344676), // Rule ID 5819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5819,
        GIR_EraseRootFromParent_Done,
      // Label 6416: @344676
      GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(344762), // Rule ID 5822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5822,
        GIR_EraseRootFromParent_Done,
      // Label 6417: @344762
      GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(344848), // Rule ID 5823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5823,
        GIR_EraseRootFromParent_Done,
      // Label 6418: @344848
      GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(344934), // Rule ID 5826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5826,
        GIR_EraseRootFromParent_Done,
      // Label 6419: @344934
      GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(345020), // Rule ID 5827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5827,
        GIR_EraseRootFromParent_Done,
      // Label 6420: @345020
      GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(345106), // Rule ID 5830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5830,
        GIR_EraseRootFromParent_Done,
      // Label 6421: @345106
      GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(345192), // Rule ID 5831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5831,
        GIR_EraseRootFromParent_Done,
      // Label 6422: @345192
      GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(345278), // Rule ID 5834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5834,
        GIR_EraseRootFromParent_Done,
      // Label 6423: @345278
      GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(345364), // Rule ID 5835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5835,
        GIR_EraseRootFromParent_Done,
      // Label 6424: @345364
      GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(345450), // Rule ID 5838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5838,
        GIR_EraseRootFromParent_Done,
      // Label 6425: @345450
      GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(345536), // Rule ID 5839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5839,
        GIR_EraseRootFromParent_Done,
      // Label 6426: @345536
      GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(345622), // Rule ID 5842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5842,
        GIR_EraseRootFromParent_Done,
      // Label 6427: @345622
      GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(345708), // Rule ID 5843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5843,
        GIR_EraseRootFromParent_Done,
      // Label 6428: @345708
      GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(345794), // Rule ID 5846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5846,
        GIR_EraseRootFromParent_Done,
      // Label 6429: @345794
      GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(345880), // Rule ID 5847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5847,
        GIR_EraseRootFromParent_Done,
      // Label 6430: @345880
      GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(345966), // Rule ID 5850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5850,
        GIR_EraseRootFromParent_Done,
      // Label 6431: @345966
      GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(346052), // Rule ID 5851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5851,
        GIR_EraseRootFromParent_Done,
      // Label 6432: @346052
      GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(346138), // Rule ID 5854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5854,
        GIR_EraseRootFromParent_Done,
      // Label 6433: @346138
      GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(346224), // Rule ID 5855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5855,
        GIR_EraseRootFromParent_Done,
      // Label 6434: @346224
      GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(346310), // Rule ID 5858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5858,
        GIR_EraseRootFromParent_Done,
      // Label 6435: @346310
      GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(346396), // Rule ID 5859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5859,
        GIR_EraseRootFromParent_Done,
      // Label 6436: @346396
      GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(346482), // Rule ID 5862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5862,
        GIR_EraseRootFromParent_Done,
      // Label 6437: @346482
      GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(346568), // Rule ID 5863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5863,
        GIR_EraseRootFromParent_Done,
      // Label 6438: @346568
      GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(346654), // Rule ID 5866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5866,
        GIR_EraseRootFromParent_Done,
      // Label 6439: @346654
      GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(346740), // Rule ID 5867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5867,
        GIR_EraseRootFromParent_Done,
      // Label 6440: @346740
      GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(346826), // Rule ID 5870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5870,
        GIR_EraseRootFromParent_Done,
      // Label 6441: @346826
      GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(346912), // Rule ID 5871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5871,
        GIR_EraseRootFromParent_Done,
      // Label 6442: @346912
      GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(346998), // Rule ID 5874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5874,
        GIR_EraseRootFromParent_Done,
      // Label 6443: @346998
      GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(347084), // Rule ID 5875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5875,
        GIR_EraseRootFromParent_Done,
      // Label 6444: @347084
      GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(347170), // Rule ID 5878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5878,
        GIR_EraseRootFromParent_Done,
      // Label 6445: @347170
      GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(347256), // Rule ID 5879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5879,
        GIR_EraseRootFromParent_Done,
      // Label 6446: @347256
      GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(347342), // Rule ID 5882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5882,
        GIR_EraseRootFromParent_Done,
      // Label 6447: @347342
      GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(347428), // Rule ID 5883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5883,
        GIR_EraseRootFromParent_Done,
      // Label 6448: @347428
      GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(347514), // Rule ID 6062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6062,
        GIR_EraseRootFromParent_Done,
      // Label 6449: @347514
      GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(347600), // Rule ID 6063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6063,
        GIR_EraseRootFromParent_Done,
      // Label 6450: @347600
      GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(347686), // Rule ID 6066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6066,
        GIR_EraseRootFromParent_Done,
      // Label 6451: @347686
      GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(347772), // Rule ID 6067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6067,
        GIR_EraseRootFromParent_Done,
      // Label 6452: @347772
      GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(347858), // Rule ID 6070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6070,
        GIR_EraseRootFromParent_Done,
      // Label 6453: @347858
      GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(347944), // Rule ID 6071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6071,
        GIR_EraseRootFromParent_Done,
      // Label 6454: @347944
      GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(348030), // Rule ID 6074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6074,
        GIR_EraseRootFromParent_Done,
      // Label 6455: @348030
      GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(348116), // Rule ID 6075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6075,
        GIR_EraseRootFromParent_Done,
      // Label 6456: @348116
      GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(348202), // Rule ID 6078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6078,
        GIR_EraseRootFromParent_Done,
      // Label 6457: @348202
      GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(348288), // Rule ID 6079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6079,
        GIR_EraseRootFromParent_Done,
      // Label 6458: @348288
      GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(348374), // Rule ID 6082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6082,
        GIR_EraseRootFromParent_Done,
      // Label 6459: @348374
      GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(348460), // Rule ID 6083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6083,
        GIR_EraseRootFromParent_Done,
      // Label 6460: @348460
      GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(348546), // Rule ID 6086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6086,
        GIR_EraseRootFromParent_Done,
      // Label 6461: @348546
      GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(348632), // Rule ID 6087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6087,
        GIR_EraseRootFromParent_Done,
      // Label 6462: @348632
      GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(348718), // Rule ID 6090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6090,
        GIR_EraseRootFromParent_Done,
      // Label 6463: @348718
      GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(348804), // Rule ID 6091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6091,
        GIR_EraseRootFromParent_Done,
      // Label 6464: @348804
      GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(348890), // Rule ID 6094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6094,
        GIR_EraseRootFromParent_Done,
      // Label 6465: @348890
      GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(348976), // Rule ID 6095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6095,
        GIR_EraseRootFromParent_Done,
      // Label 6466: @348976
      GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(349062), // Rule ID 6098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6098,
        GIR_EraseRootFromParent_Done,
      // Label 6467: @349062
      GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(349148), // Rule ID 6099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6099,
        GIR_EraseRootFromParent_Done,
      // Label 6468: @349148
      GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(349234), // Rule ID 6102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6102,
        GIR_EraseRootFromParent_Done,
      // Label 6469: @349234
      GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(349320), // Rule ID 6103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6103,
        GIR_EraseRootFromParent_Done,
      // Label 6470: @349320
      GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(349406), // Rule ID 6106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6106,
        GIR_EraseRootFromParent_Done,
      // Label 6471: @349406
      GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(349492), // Rule ID 6107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6107,
        GIR_EraseRootFromParent_Done,
      // Label 6472: @349492
      GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(349578), // Rule ID 6110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6110,
        GIR_EraseRootFromParent_Done,
      // Label 6473: @349578
      GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(349664), // Rule ID 6111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6111,
        GIR_EraseRootFromParent_Done,
      // Label 6474: @349664
      GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(349750), // Rule ID 6114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6114,
        GIR_EraseRootFromParent_Done,
      // Label 6475: @349750
      GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(349836), // Rule ID 6115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6115,
        GIR_EraseRootFromParent_Done,
      // Label 6476: @349836
      GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(349922), // Rule ID 6118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6118,
        GIR_EraseRootFromParent_Done,
      // Label 6477: @349922
      GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(350008), // Rule ID 6119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6119,
        GIR_EraseRootFromParent_Done,
      // Label 6478: @350008
      GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(350094), // Rule ID 6122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6122,
        GIR_EraseRootFromParent_Done,
      // Label 6479: @350094
      GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(350180), // Rule ID 6123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6123,
        GIR_EraseRootFromParent_Done,
      // Label 6480: @350180
      GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(350266), // Rule ID 6126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6126,
        GIR_EraseRootFromParent_Done,
      // Label 6481: @350266
      GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(350352), // Rule ID 6127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6127,
        GIR_EraseRootFromParent_Done,
      // Label 6482: @350352
      GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(350438), // Rule ID 6130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6130,
        GIR_EraseRootFromParent_Done,
      // Label 6483: @350438
      GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(350524), // Rule ID 6131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6131,
        GIR_EraseRootFromParent_Done,
      // Label 6484: @350524
      GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(350610), // Rule ID 6134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6134,
        GIR_EraseRootFromParent_Done,
      // Label 6485: @350610
      GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(350696), // Rule ID 6135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6135,
        GIR_EraseRootFromParent_Done,
      // Label 6486: @350696
      GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(350782), // Rule ID 6138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6138,
        GIR_EraseRootFromParent_Done,
      // Label 6487: @350782
      GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(350868), // Rule ID 6139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6139,
        GIR_EraseRootFromParent_Done,
      // Label 6488: @350868
      GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(350954), // Rule ID 6142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6142,
        GIR_EraseRootFromParent_Done,
      // Label 6489: @350954
      GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(351040), // Rule ID 6143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6143,
        GIR_EraseRootFromParent_Done,
      // Label 6490: @351040
      GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(351126), // Rule ID 6146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6146,
        GIR_EraseRootFromParent_Done,
      // Label 6491: @351126
      GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(351212), // Rule ID 6147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6147,
        GIR_EraseRootFromParent_Done,
      // Label 6492: @351212
      GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(351298), // Rule ID 6326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6326,
        GIR_EraseRootFromParent_Done,
      // Label 6493: @351298
      GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(351384), // Rule ID 6327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6327,
        GIR_EraseRootFromParent_Done,
      // Label 6494: @351384
      GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(351470), // Rule ID 6330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6330,
        GIR_EraseRootFromParent_Done,
      // Label 6495: @351470
      GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(351556), // Rule ID 6331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6331,
        GIR_EraseRootFromParent_Done,
      // Label 6496: @351556
      GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(351642), // Rule ID 6334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6334,
        GIR_EraseRootFromParent_Done,
      // Label 6497: @351642
      GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(351728), // Rule ID 6335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6335,
        GIR_EraseRootFromParent_Done,
      // Label 6498: @351728
      GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(351814), // Rule ID 6338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6338,
        GIR_EraseRootFromParent_Done,
      // Label 6499: @351814
      GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(351900), // Rule ID 6339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6339,
        GIR_EraseRootFromParent_Done,
      // Label 6500: @351900
      GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(351986), // Rule ID 6342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6342,
        GIR_EraseRootFromParent_Done,
      // Label 6501: @351986
      GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(352072), // Rule ID 6343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6343,
        GIR_EraseRootFromParent_Done,
      // Label 6502: @352072
      GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(352158), // Rule ID 6346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6346,
        GIR_EraseRootFromParent_Done,
      // Label 6503: @352158
      GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(352244), // Rule ID 6347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6347,
        GIR_EraseRootFromParent_Done,
      // Label 6504: @352244
      GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(352330), // Rule ID 6350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6350,
        GIR_EraseRootFromParent_Done,
      // Label 6505: @352330
      GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(352416), // Rule ID 6351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6351,
        GIR_EraseRootFromParent_Done,
      // Label 6506: @352416
      GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(352502), // Rule ID 6354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6354,
        GIR_EraseRootFromParent_Done,
      // Label 6507: @352502
      GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(352588), // Rule ID 6355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6355,
        GIR_EraseRootFromParent_Done,
      // Label 6508: @352588
      GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(352674), // Rule ID 6358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6358,
        GIR_EraseRootFromParent_Done,
      // Label 6509: @352674
      GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(352760), // Rule ID 6359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6359,
        GIR_EraseRootFromParent_Done,
      // Label 6510: @352760
      GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(352846), // Rule ID 6362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6362,
        GIR_EraseRootFromParent_Done,
      // Label 6511: @352846
      GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(352932), // Rule ID 6363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6363,
        GIR_EraseRootFromParent_Done,
      // Label 6512: @352932
      GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(353018), // Rule ID 6366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6366,
        GIR_EraseRootFromParent_Done,
      // Label 6513: @353018
      GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(353104), // Rule ID 6367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6367,
        GIR_EraseRootFromParent_Done,
      // Label 6514: @353104
      GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(353190), // Rule ID 6370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6370,
        GIR_EraseRootFromParent_Done,
      // Label 6515: @353190
      GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(353276), // Rule ID 6371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6371,
        GIR_EraseRootFromParent_Done,
      // Label 6516: @353276
      GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(353362), // Rule ID 6374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6374,
        GIR_EraseRootFromParent_Done,
      // Label 6517: @353362
      GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(353448), // Rule ID 6375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6375,
        GIR_EraseRootFromParent_Done,
      // Label 6518: @353448
      GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(353534), // Rule ID 6378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6378,
        GIR_EraseRootFromParent_Done,
      // Label 6519: @353534
      GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(353620), // Rule ID 6379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6379,
        GIR_EraseRootFromParent_Done,
      // Label 6520: @353620
      GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(353706), // Rule ID 6382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6382,
        GIR_EraseRootFromParent_Done,
      // Label 6521: @353706
      GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(353792), // Rule ID 6383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6383,
        GIR_EraseRootFromParent_Done,
      // Label 6522: @353792
      GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(353878), // Rule ID 6386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6386,
        GIR_EraseRootFromParent_Done,
      // Label 6523: @353878
      GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(353964), // Rule ID 6387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6387,
        GIR_EraseRootFromParent_Done,
      // Label 6524: @353964
      GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(354050), // Rule ID 6390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6390,
        GIR_EraseRootFromParent_Done,
      // Label 6525: @354050
      GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(354136), // Rule ID 6391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6391,
        GIR_EraseRootFromParent_Done,
      // Label 6526: @354136
      GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(354222), // Rule ID 6394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6394,
        GIR_EraseRootFromParent_Done,
      // Label 6527: @354222
      GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(354308), // Rule ID 6395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6395,
        GIR_EraseRootFromParent_Done,
      // Label 6528: @354308
      GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(354394), // Rule ID 6398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6398,
        GIR_EraseRootFromParent_Done,
      // Label 6529: @354394
      GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(354480), // Rule ID 6399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6399,
        GIR_EraseRootFromParent_Done,
      // Label 6530: @354480
      GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(354566), // Rule ID 6402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6402,
        GIR_EraseRootFromParent_Done,
      // Label 6531: @354566
      GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(354652), // Rule ID 6403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6403,
        GIR_EraseRootFromParent_Done,
      // Label 6532: @354652
      GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(354738), // Rule ID 6406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6406,
        GIR_EraseRootFromParent_Done,
      // Label 6533: @354738
      GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(354824), // Rule ID 6407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6407,
        GIR_EraseRootFromParent_Done,
      // Label 6534: @354824
      GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(354910), // Rule ID 6410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6410,
        GIR_EraseRootFromParent_Done,
      // Label 6535: @354910
      GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(354996), // Rule ID 6411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6411,
        GIR_EraseRootFromParent_Done,
      // Label 6536: @354996
      GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(355082), // Rule ID 6590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6590,
        GIR_EraseRootFromParent_Done,
      // Label 6537: @355082
      GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(355168), // Rule ID 6591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6591,
        GIR_EraseRootFromParent_Done,
      // Label 6538: @355168
      GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(355254), // Rule ID 6594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6594,
        GIR_EraseRootFromParent_Done,
      // Label 6539: @355254
      GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(355340), // Rule ID 6595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6595,
        GIR_EraseRootFromParent_Done,
      // Label 6540: @355340
      GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(355426), // Rule ID 6598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6598,
        GIR_EraseRootFromParent_Done,
      // Label 6541: @355426
      GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(355512), // Rule ID 6599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6599,
        GIR_EraseRootFromParent_Done,
      // Label 6542: @355512
      GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(355598), // Rule ID 6602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6602,
        GIR_EraseRootFromParent_Done,
      // Label 6543: @355598
      GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(355684), // Rule ID 6603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6603,
        GIR_EraseRootFromParent_Done,
      // Label 6544: @355684
      GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(355770), // Rule ID 6606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6606,
        GIR_EraseRootFromParent_Done,
      // Label 6545: @355770
      GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(355856), // Rule ID 6607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6607,
        GIR_EraseRootFromParent_Done,
      // Label 6546: @355856
      GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(355942), // Rule ID 6610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6610,
        GIR_EraseRootFromParent_Done,
      // Label 6547: @355942
      GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(356028), // Rule ID 6611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6611,
        GIR_EraseRootFromParent_Done,
      // Label 6548: @356028
      GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(356114), // Rule ID 6614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6614,
        GIR_EraseRootFromParent_Done,
      // Label 6549: @356114
      GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(356200), // Rule ID 6615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6615,
        GIR_EraseRootFromParent_Done,
      // Label 6550: @356200
      GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(356286), // Rule ID 6618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6618,
        GIR_EraseRootFromParent_Done,
      // Label 6551: @356286
      GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(356372), // Rule ID 6619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6619,
        GIR_EraseRootFromParent_Done,
      // Label 6552: @356372
      GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(356458), // Rule ID 6622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6622,
        GIR_EraseRootFromParent_Done,
      // Label 6553: @356458
      GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(356544), // Rule ID 6623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6623,
        GIR_EraseRootFromParent_Done,
      // Label 6554: @356544
      GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(356630), // Rule ID 6626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6626,
        GIR_EraseRootFromParent_Done,
      // Label 6555: @356630
      GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(356716), // Rule ID 6627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6627,
        GIR_EraseRootFromParent_Done,
      // Label 6556: @356716
      GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(356802), // Rule ID 6630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6630,
        GIR_EraseRootFromParent_Done,
      // Label 6557: @356802
      GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(356888), // Rule ID 6631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6631,
        GIR_EraseRootFromParent_Done,
      // Label 6558: @356888
      GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(356974), // Rule ID 6634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6634,
        GIR_EraseRootFromParent_Done,
      // Label 6559: @356974
      GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(357060), // Rule ID 6635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6635,
        GIR_EraseRootFromParent_Done,
      // Label 6560: @357060
      GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(357146), // Rule ID 6638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6638,
        GIR_EraseRootFromParent_Done,
      // Label 6561: @357146
      GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(357232), // Rule ID 6639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6639,
        GIR_EraseRootFromParent_Done,
      // Label 6562: @357232
      GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(357318), // Rule ID 6642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6642,
        GIR_EraseRootFromParent_Done,
      // Label 6563: @357318
      GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(357404), // Rule ID 6643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6643,
        GIR_EraseRootFromParent_Done,
      // Label 6564: @357404
      GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(357490), // Rule ID 6646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6646,
        GIR_EraseRootFromParent_Done,
      // Label 6565: @357490
      GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(357576), // Rule ID 6647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6647,
        GIR_EraseRootFromParent_Done,
      // Label 6566: @357576
      GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(357662), // Rule ID 6650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6650,
        GIR_EraseRootFromParent_Done,
      // Label 6567: @357662
      GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(357748), // Rule ID 6651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6651,
        GIR_EraseRootFromParent_Done,
      // Label 6568: @357748
      GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(357834), // Rule ID 6654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6654,
        GIR_EraseRootFromParent_Done,
      // Label 6569: @357834
      GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(357920), // Rule ID 6655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6655,
        GIR_EraseRootFromParent_Done,
      // Label 6570: @357920
      GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(358006), // Rule ID 6658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6658,
        GIR_EraseRootFromParent_Done,
      // Label 6571: @358006
      GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(358092), // Rule ID 6659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6659,
        GIR_EraseRootFromParent_Done,
      // Label 6572: @358092
      GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(358178), // Rule ID 6662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6662,
        GIR_EraseRootFromParent_Done,
      // Label 6573: @358178
      GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(358264), // Rule ID 6663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6663,
        GIR_EraseRootFromParent_Done,
      // Label 6574: @358264
      GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(358350), // Rule ID 6666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6666,
        GIR_EraseRootFromParent_Done,
      // Label 6575: @358350
      GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(358436), // Rule ID 6667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6667,
        GIR_EraseRootFromParent_Done,
      // Label 6576: @358436
      GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(358522), // Rule ID 6670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6670,
        GIR_EraseRootFromParent_Done,
      // Label 6577: @358522
      GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(358608), // Rule ID 6671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6671,
        GIR_EraseRootFromParent_Done,
      // Label 6578: @358608
      GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(358694), // Rule ID 6674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6674,
        GIR_EraseRootFromParent_Done,
      // Label 6579: @358694
      GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(358780), // Rule ID 6675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6675,
        GIR_EraseRootFromParent_Done,
      // Label 6580: @358780
      GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(358866), // Rule ID 6854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6854,
        GIR_EraseRootFromParent_Done,
      // Label 6581: @358866
      GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(358952), // Rule ID 6855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6855,
        GIR_EraseRootFromParent_Done,
      // Label 6582: @358952
      GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(359038), // Rule ID 6858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6858,
        GIR_EraseRootFromParent_Done,
      // Label 6583: @359038
      GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(359124), // Rule ID 6859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6859,
        GIR_EraseRootFromParent_Done,
      // Label 6584: @359124
      GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(359210), // Rule ID 6862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6862,
        GIR_EraseRootFromParent_Done,
      // Label 6585: @359210
      GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(359296), // Rule ID 6863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6863,
        GIR_EraseRootFromParent_Done,
      // Label 6586: @359296
      GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(359382), // Rule ID 6866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6866,
        GIR_EraseRootFromParent_Done,
      // Label 6587: @359382
      GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(359468), // Rule ID 6867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6867,
        GIR_EraseRootFromParent_Done,
      // Label 6588: @359468
      GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(359554), // Rule ID 6870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6870,
        GIR_EraseRootFromParent_Done,
      // Label 6589: @359554
      GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(359640), // Rule ID 6871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6871,
        GIR_EraseRootFromParent_Done,
      // Label 6590: @359640
      GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(359726), // Rule ID 6874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6874,
        GIR_EraseRootFromParent_Done,
      // Label 6591: @359726
      GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(359812), // Rule ID 6875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6875,
        GIR_EraseRootFromParent_Done,
      // Label 6592: @359812
      GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(359898), // Rule ID 6878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6878,
        GIR_EraseRootFromParent_Done,
      // Label 6593: @359898
      GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(359984), // Rule ID 6879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6879,
        GIR_EraseRootFromParent_Done,
      // Label 6594: @359984
      GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(360070), // Rule ID 6882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6882,
        GIR_EraseRootFromParent_Done,
      // Label 6595: @360070
      GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(360156), // Rule ID 6883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6883,
        GIR_EraseRootFromParent_Done,
      // Label 6596: @360156
      GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(360242), // Rule ID 6886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6886,
        GIR_EraseRootFromParent_Done,
      // Label 6597: @360242
      GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(360328), // Rule ID 6887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6887,
        GIR_EraseRootFromParent_Done,
      // Label 6598: @360328
      GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(360414), // Rule ID 6890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6890,
        GIR_EraseRootFromParent_Done,
      // Label 6599: @360414
      GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(360500), // Rule ID 6891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6891,
        GIR_EraseRootFromParent_Done,
      // Label 6600: @360500
      GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(360586), // Rule ID 6894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6894,
        GIR_EraseRootFromParent_Done,
      // Label 6601: @360586
      GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(360672), // Rule ID 6895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6895,
        GIR_EraseRootFromParent_Done,
      // Label 6602: @360672
      GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(360758), // Rule ID 6898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6898,
        GIR_EraseRootFromParent_Done,
      // Label 6603: @360758
      GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(360844), // Rule ID 6899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6899,
        GIR_EraseRootFromParent_Done,
      // Label 6604: @360844
      GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(360930), // Rule ID 6902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6902,
        GIR_EraseRootFromParent_Done,
      // Label 6605: @360930
      GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(361016), // Rule ID 6903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6903,
        GIR_EraseRootFromParent_Done,
      // Label 6606: @361016
      GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(361102), // Rule ID 6906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6906,
        GIR_EraseRootFromParent_Done,
      // Label 6607: @361102
      GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(361188), // Rule ID 6907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6907,
        GIR_EraseRootFromParent_Done,
      // Label 6608: @361188
      GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(361274), // Rule ID 6910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6910,
        GIR_EraseRootFromParent_Done,
      // Label 6609: @361274
      GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(361360), // Rule ID 6911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6911,
        GIR_EraseRootFromParent_Done,
      // Label 6610: @361360
      GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(361446), // Rule ID 6914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6914,
        GIR_EraseRootFromParent_Done,
      // Label 6611: @361446
      GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(361532), // Rule ID 6915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6915,
        GIR_EraseRootFromParent_Done,
      // Label 6612: @361532
      GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(361618), // Rule ID 6918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6918,
        GIR_EraseRootFromParent_Done,
      // Label 6613: @361618
      GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(361704), // Rule ID 6919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6919,
        GIR_EraseRootFromParent_Done,
      // Label 6614: @361704
      GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(361790), // Rule ID 6922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6922,
        GIR_EraseRootFromParent_Done,
      // Label 6615: @361790
      GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(361876), // Rule ID 6923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6923,
        GIR_EraseRootFromParent_Done,
      // Label 6616: @361876
      GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(361962), // Rule ID 6926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6926,
        GIR_EraseRootFromParent_Done,
      // Label 6617: @361962
      GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(362048), // Rule ID 6927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6927,
        GIR_EraseRootFromParent_Done,
      // Label 6618: @362048
      GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(362134), // Rule ID 6930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6930,
        GIR_EraseRootFromParent_Done,
      // Label 6619: @362134
      GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(362220), // Rule ID 6931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6931,
        GIR_EraseRootFromParent_Done,
      // Label 6620: @362220
      GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(362306), // Rule ID 6934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6934,
        GIR_EraseRootFromParent_Done,
      // Label 6621: @362306
      GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(362392), // Rule ID 6935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6935,
        GIR_EraseRootFromParent_Done,
      // Label 6622: @362392
      GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(362478), // Rule ID 6938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6938,
        GIR_EraseRootFromParent_Done,
      // Label 6623: @362478
      GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(362564), // Rule ID 6939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6939,
        GIR_EraseRootFromParent_Done,
      // Label 6624: @362564
      GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(362650), // Rule ID 7118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7118,
        GIR_EraseRootFromParent_Done,
      // Label 6625: @362650
      GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(362736), // Rule ID 7119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7119,
        GIR_EraseRootFromParent_Done,
      // Label 6626: @362736
      GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(362822), // Rule ID 7122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7122,
        GIR_EraseRootFromParent_Done,
      // Label 6627: @362822
      GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(362908), // Rule ID 7123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7123,
        GIR_EraseRootFromParent_Done,
      // Label 6628: @362908
      GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(362994), // Rule ID 7126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7126,
        GIR_EraseRootFromParent_Done,
      // Label 6629: @362994
      GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(363080), // Rule ID 7127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7127,
        GIR_EraseRootFromParent_Done,
      // Label 6630: @363080
      GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(363166), // Rule ID 7130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7130,
        GIR_EraseRootFromParent_Done,
      // Label 6631: @363166
      GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(363252), // Rule ID 7131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7131,
        GIR_EraseRootFromParent_Done,
      // Label 6632: @363252
      GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(363338), // Rule ID 7134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7134,
        GIR_EraseRootFromParent_Done,
      // Label 6633: @363338
      GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(363424), // Rule ID 7135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7135,
        GIR_EraseRootFromParent_Done,
      // Label 6634: @363424
      GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(363510), // Rule ID 7138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7138,
        GIR_EraseRootFromParent_Done,
      // Label 6635: @363510
      GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(363596), // Rule ID 7139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7139,
        GIR_EraseRootFromParent_Done,
      // Label 6636: @363596
      GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(363682), // Rule ID 7142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7142,
        GIR_EraseRootFromParent_Done,
      // Label 6637: @363682
      GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(363768), // Rule ID 7143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7143,
        GIR_EraseRootFromParent_Done,
      // Label 6638: @363768
      GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(363854), // Rule ID 7146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7146,
        GIR_EraseRootFromParent_Done,
      // Label 6639: @363854
      GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(363940), // Rule ID 7147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7147,
        GIR_EraseRootFromParent_Done,
      // Label 6640: @363940
      GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(364026), // Rule ID 7150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7150,
        GIR_EraseRootFromParent_Done,
      // Label 6641: @364026
      GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(364112), // Rule ID 7151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7151,
        GIR_EraseRootFromParent_Done,
      // Label 6642: @364112
      GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(364198), // Rule ID 7154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7154,
        GIR_EraseRootFromParent_Done,
      // Label 6643: @364198
      GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(364284), // Rule ID 7155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7155,
        GIR_EraseRootFromParent_Done,
      // Label 6644: @364284
      GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(364370), // Rule ID 7158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7158,
        GIR_EraseRootFromParent_Done,
      // Label 6645: @364370
      GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(364456), // Rule ID 7159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7159,
        GIR_EraseRootFromParent_Done,
      // Label 6646: @364456
      GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(364542), // Rule ID 7162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7162,
        GIR_EraseRootFromParent_Done,
      // Label 6647: @364542
      GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(364628), // Rule ID 7163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7163,
        GIR_EraseRootFromParent_Done,
      // Label 6648: @364628
      GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(364714), // Rule ID 7166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7166,
        GIR_EraseRootFromParent_Done,
      // Label 6649: @364714
      GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(364800), // Rule ID 7167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7167,
        GIR_EraseRootFromParent_Done,
      // Label 6650: @364800
      GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(364886), // Rule ID 7170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7170,
        GIR_EraseRootFromParent_Done,
      // Label 6651: @364886
      GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(364972), // Rule ID 7171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7171,
        GIR_EraseRootFromParent_Done,
      // Label 6652: @364972
      GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(365058), // Rule ID 7174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7174,
        GIR_EraseRootFromParent_Done,
      // Label 6653: @365058
      GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(365144), // Rule ID 7175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7175,
        GIR_EraseRootFromParent_Done,
      // Label 6654: @365144
      GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(365230), // Rule ID 7178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7178,
        GIR_EraseRootFromParent_Done,
      // Label 6655: @365230
      GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(365316), // Rule ID 7179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7179,
        GIR_EraseRootFromParent_Done,
      // Label 6656: @365316
      GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(365402), // Rule ID 7182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7182,
        GIR_EraseRootFromParent_Done,
      // Label 6657: @365402
      GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(365488), // Rule ID 7183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7183,
        GIR_EraseRootFromParent_Done,
      // Label 6658: @365488
      GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(365574), // Rule ID 7186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7186,
        GIR_EraseRootFromParent_Done,
      // Label 6659: @365574
      GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(365660), // Rule ID 7187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7187,
        GIR_EraseRootFromParent_Done,
      // Label 6660: @365660
      GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(365746), // Rule ID 7190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7190,
        GIR_EraseRootFromParent_Done,
      // Label 6661: @365746
      GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(365832), // Rule ID 7191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7191,
        GIR_EraseRootFromParent_Done,
      // Label 6662: @365832
      GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(365918), // Rule ID 7194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7194,
        GIR_EraseRootFromParent_Done,
      // Label 6663: @365918
      GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(366004), // Rule ID 7195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7195,
        GIR_EraseRootFromParent_Done,
      // Label 6664: @366004
      GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(366090), // Rule ID 7198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7198,
        GIR_EraseRootFromParent_Done,
      // Label 6665: @366090
      GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(366176), // Rule ID 7199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7199,
        GIR_EraseRootFromParent_Done,
      // Label 6666: @366176
      GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(366262), // Rule ID 7202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7202,
        GIR_EraseRootFromParent_Done,
      // Label 6667: @366262
      GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(366348), // Rule ID 7203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7203,
        GIR_EraseRootFromParent_Done,
      // Label 6668: @366348
      GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(366434), // Rule ID 7414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7414,
        GIR_EraseRootFromParent_Done,
      // Label 6669: @366434
      GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(366520), // Rule ID 7415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7415,
        GIR_EraseRootFromParent_Done,
      // Label 6670: @366520
      GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(366606), // Rule ID 7418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7418,
        GIR_EraseRootFromParent_Done,
      // Label 6671: @366606
      GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(366692), // Rule ID 7419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7419,
        GIR_EraseRootFromParent_Done,
      // Label 6672: @366692
      GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(366778), // Rule ID 7422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7422,
        GIR_EraseRootFromParent_Done,
      // Label 6673: @366778
      GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(366864), // Rule ID 7423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7423,
        GIR_EraseRootFromParent_Done,
      // Label 6674: @366864
      GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(366950), // Rule ID 7426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7426,
        GIR_EraseRootFromParent_Done,
      // Label 6675: @366950
      GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(367036), // Rule ID 7427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7427,
        GIR_EraseRootFromParent_Done,
      // Label 6676: @367036
      GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(367122), // Rule ID 7430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7430,
        GIR_EraseRootFromParent_Done,
      // Label 6677: @367122
      GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(367208), // Rule ID 7431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7431,
        GIR_EraseRootFromParent_Done,
      // Label 6678: @367208
      GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(367294), // Rule ID 7434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7434,
        GIR_EraseRootFromParent_Done,
      // Label 6679: @367294
      GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(367380), // Rule ID 7435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7435,
        GIR_EraseRootFromParent_Done,
      // Label 6680: @367380
      GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(367466), // Rule ID 7438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7438,
        GIR_EraseRootFromParent_Done,
      // Label 6681: @367466
      GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(367552), // Rule ID 7439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7439,
        GIR_EraseRootFromParent_Done,
      // Label 6682: @367552
      GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(367638), // Rule ID 7442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7442,
        GIR_EraseRootFromParent_Done,
      // Label 6683: @367638
      GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(367724), // Rule ID 7443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7443,
        GIR_EraseRootFromParent_Done,
      // Label 6684: @367724
      GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(367810), // Rule ID 7446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7446,
        GIR_EraseRootFromParent_Done,
      // Label 6685: @367810
      GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(367896), // Rule ID 7447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7447,
        GIR_EraseRootFromParent_Done,
      // Label 6686: @367896
      GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(367982), // Rule ID 7450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7450,
        GIR_EraseRootFromParent_Done,
      // Label 6687: @367982
      GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(368068), // Rule ID 7451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7451,
        GIR_EraseRootFromParent_Done,
      // Label 6688: @368068
      GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(368154), // Rule ID 7454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7454,
        GIR_EraseRootFromParent_Done,
      // Label 6689: @368154
      GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(368240), // Rule ID 7455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7455,
        GIR_EraseRootFromParent_Done,
      // Label 6690: @368240
      GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(368326), // Rule ID 7458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7458,
        GIR_EraseRootFromParent_Done,
      // Label 6691: @368326
      GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(368412), // Rule ID 7459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7459,
        GIR_EraseRootFromParent_Done,
      // Label 6692: @368412
      GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(368498), // Rule ID 7462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7462,
        GIR_EraseRootFromParent_Done,
      // Label 6693: @368498
      GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(368584), // Rule ID 7463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7463,
        GIR_EraseRootFromParent_Done,
      // Label 6694: @368584
      GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(368670), // Rule ID 7466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7466,
        GIR_EraseRootFromParent_Done,
      // Label 6695: @368670
      GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(368756), // Rule ID 7467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7467,
        GIR_EraseRootFromParent_Done,
      // Label 6696: @368756
      GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(368842), // Rule ID 7470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7470,
        GIR_EraseRootFromParent_Done,
      // Label 6697: @368842
      GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(368928), // Rule ID 7471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7471,
        GIR_EraseRootFromParent_Done,
      // Label 6698: @368928
      GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(369014), // Rule ID 7594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7594,
        GIR_EraseRootFromParent_Done,
      // Label 6699: @369014
      GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(369100), // Rule ID 7595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7595,
        GIR_EraseRootFromParent_Done,
      // Label 6700: @369100
      GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(369186), // Rule ID 7598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7598,
        GIR_EraseRootFromParent_Done,
      // Label 6701: @369186
      GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(369272), // Rule ID 7599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7599,
        GIR_EraseRootFromParent_Done,
      // Label 6702: @369272
      GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(369358), // Rule ID 7602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7602,
        GIR_EraseRootFromParent_Done,
      // Label 6703: @369358
      GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(369444), // Rule ID 7603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7603,
        GIR_EraseRootFromParent_Done,
      // Label 6704: @369444
      GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(369530), // Rule ID 7606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7606,
        GIR_EraseRootFromParent_Done,
      // Label 6705: @369530
      GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(369616), // Rule ID 7607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7607,
        GIR_EraseRootFromParent_Done,
      // Label 6706: @369616
      GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(369702), // Rule ID 7610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7610,
        GIR_EraseRootFromParent_Done,
      // Label 6707: @369702
      GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(369788), // Rule ID 7611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7611,
        GIR_EraseRootFromParent_Done,
      // Label 6708: @369788
      GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(369874), // Rule ID 7614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7614,
        GIR_EraseRootFromParent_Done,
      // Label 6709: @369874
      GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(369960), // Rule ID 7615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7615,
        GIR_EraseRootFromParent_Done,
      // Label 6710: @369960
      GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(370046), // Rule ID 7618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7618,
        GIR_EraseRootFromParent_Done,
      // Label 6711: @370046
      GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(370132), // Rule ID 7619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7619,
        GIR_EraseRootFromParent_Done,
      // Label 6712: @370132
      GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(370218), // Rule ID 7622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7622,
        GIR_EraseRootFromParent_Done,
      // Label 6713: @370218
      GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(370304), // Rule ID 7623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7623,
        GIR_EraseRootFromParent_Done,
      // Label 6714: @370304
      GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(370390), // Rule ID 7626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7626,
        GIR_EraseRootFromParent_Done,
      // Label 6715: @370390
      GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(370476), // Rule ID 7627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7627,
        GIR_EraseRootFromParent_Done,
      // Label 6716: @370476
      GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(370562), // Rule ID 7630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7630,
        GIR_EraseRootFromParent_Done,
      // Label 6717: @370562
      GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(370648), // Rule ID 7631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7631,
        GIR_EraseRootFromParent_Done,
      // Label 6718: @370648
      GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(370734), // Rule ID 7634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7634,
        GIR_EraseRootFromParent_Done,
      // Label 6719: @370734
      GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(370820), // Rule ID 7635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7635,
        GIR_EraseRootFromParent_Done,
      // Label 6720: @370820
      GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(370906), // Rule ID 7638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7638,
        GIR_EraseRootFromParent_Done,
      // Label 6721: @370906
      GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(370992), // Rule ID 7639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7639,
        GIR_EraseRootFromParent_Done,
      // Label 6722: @370992
      GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(371078), // Rule ID 7642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7642,
        GIR_EraseRootFromParent_Done,
      // Label 6723: @371078
      GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(371164), // Rule ID 7643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7643,
        GIR_EraseRootFromParent_Done,
      // Label 6724: @371164
      GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(371250), // Rule ID 7646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7646,
        GIR_EraseRootFromParent_Done,
      // Label 6725: @371250
      GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(371336), // Rule ID 7647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7647,
        GIR_EraseRootFromParent_Done,
      // Label 6726: @371336
      GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(371422), // Rule ID 7650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7650,
        GIR_EraseRootFromParent_Done,
      // Label 6727: @371422
      GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(371508), // Rule ID 7651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7651,
        GIR_EraseRootFromParent_Done,
      // Label 6728: @371508
      GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(371597), // Rule ID 14080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14080,
        GIR_EraseRootFromParent_Done,
      // Label 6729: @371597
      GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(371686), // Rule ID 14081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14081,
        GIR_EraseRootFromParent_Done,
      // Label 6730: @371686
      GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(371775), // Rule ID 14084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14084,
        GIR_EraseRootFromParent_Done,
      // Label 6731: @371775
      GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(371864), // Rule ID 14085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14085,
        GIR_EraseRootFromParent_Done,
      // Label 6732: @371864
      GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(371953), // Rule ID 14088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14088,
        GIR_EraseRootFromParent_Done,
      // Label 6733: @371953
      GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(372042), // Rule ID 14089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14089,
        GIR_EraseRootFromParent_Done,
      // Label 6734: @372042
      GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(372131), // Rule ID 14092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14092,
        GIR_EraseRootFromParent_Done,
      // Label 6735: @372131
      GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(372220), // Rule ID 14093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14093,
        GIR_EraseRootFromParent_Done,
      // Label 6736: @372220
      GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(372309), // Rule ID 14096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14096,
        GIR_EraseRootFromParent_Done,
      // Label 6737: @372309
      GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(372398), // Rule ID 14097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14097,
        GIR_EraseRootFromParent_Done,
      // Label 6738: @372398
      GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(372487), // Rule ID 14100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14100,
        GIR_EraseRootFromParent_Done,
      // Label 6739: @372487
      GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(372576), // Rule ID 14101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14101,
        GIR_EraseRootFromParent_Done,
      // Label 6740: @372576
      GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(372665), // Rule ID 14104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14104,
        GIR_EraseRootFromParent_Done,
      // Label 6741: @372665
      GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(372754), // Rule ID 14105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14105,
        GIR_EraseRootFromParent_Done,
      // Label 6742: @372754
      GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(372843), // Rule ID 14108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14108,
        GIR_EraseRootFromParent_Done,
      // Label 6743: @372843
      GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(372932), // Rule ID 14109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14109,
        GIR_EraseRootFromParent_Done,
      // Label 6744: @372932
      GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(373021), // Rule ID 14112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14112,
        GIR_EraseRootFromParent_Done,
      // Label 6745: @373021
      GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(373110), // Rule ID 14113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14113,
        GIR_EraseRootFromParent_Done,
      // Label 6746: @373110
      GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(373199), // Rule ID 14116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14116,
        GIR_EraseRootFromParent_Done,
      // Label 6747: @373199
      GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(373288), // Rule ID 14117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14117,
        GIR_EraseRootFromParent_Done,
      // Label 6748: @373288
      GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(373377), // Rule ID 14120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14120,
        GIR_EraseRootFromParent_Done,
      // Label 6749: @373377
      GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(373466), // Rule ID 14121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14121,
        GIR_EraseRootFromParent_Done,
      // Label 6750: @373466
      GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(373555), // Rule ID 14124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14124,
        GIR_EraseRootFromParent_Done,
      // Label 6751: @373555
      GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(373644), // Rule ID 14125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14125,
        GIR_EraseRootFromParent_Done,
      // Label 6752: @373644
      GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(373733), // Rule ID 14128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14128,
        GIR_EraseRootFromParent_Done,
      // Label 6753: @373733
      GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(373822), // Rule ID 14129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14129,
        GIR_EraseRootFromParent_Done,
      // Label 6754: @373822
      GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(373911), // Rule ID 14132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14132,
        GIR_EraseRootFromParent_Done,
      // Label 6755: @373911
      GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(374000), // Rule ID 14133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14133,
        GIR_EraseRootFromParent_Done,
      // Label 6756: @374000
      GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(374089), // Rule ID 14136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14136,
        GIR_EraseRootFromParent_Done,
      // Label 6757: @374089
      GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(374178), // Rule ID 14137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14137,
        GIR_EraseRootFromParent_Done,
      // Label 6758: @374178
      GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(374267), // Rule ID 14140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14140,
        GIR_EraseRootFromParent_Done,
      // Label 6759: @374267
      GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(374356), // Rule ID 14141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14141,
        GIR_EraseRootFromParent_Done,
      // Label 6760: @374356
      GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(374445), // Rule ID 14144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14144,
        GIR_EraseRootFromParent_Done,
      // Label 6761: @374445
      GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(374534), // Rule ID 14145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14145,
        GIR_EraseRootFromParent_Done,
      // Label 6762: @374534
      GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(374623), // Rule ID 14148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14148,
        GIR_EraseRootFromParent_Done,
      // Label 6763: @374623
      GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(374712), // Rule ID 14149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14149,
        GIR_EraseRootFromParent_Done,
      // Label 6764: @374712
      GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(374801), // Rule ID 14152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14152,
        GIR_EraseRootFromParent_Done,
      // Label 6765: @374801
      GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(374890), // Rule ID 14153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14153,
        GIR_EraseRootFromParent_Done,
      // Label 6766: @374890
      GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(374979), // Rule ID 14156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14156,
        GIR_EraseRootFromParent_Done,
      // Label 6767: @374979
      GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(375068), // Rule ID 14157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14157,
        GIR_EraseRootFromParent_Done,
      // Label 6768: @375068
      GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(375157), // Rule ID 14160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14160,
        GIR_EraseRootFromParent_Done,
      // Label 6769: @375157
      GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(375246), // Rule ID 14161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14161,
        GIR_EraseRootFromParent_Done,
      // Label 6770: @375246
      GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(375335), // Rule ID 14164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14164,
        GIR_EraseRootFromParent_Done,
      // Label 6771: @375335
      GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(375424), // Rule ID 14165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14165,
        GIR_EraseRootFromParent_Done,
      // Label 6772: @375424
      GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(375513), // Rule ID 14344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14344,
        GIR_EraseRootFromParent_Done,
      // Label 6773: @375513
      GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(375602), // Rule ID 14345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14345,
        GIR_EraseRootFromParent_Done,
      // Label 6774: @375602
      GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(375691), // Rule ID 14348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14348,
        GIR_EraseRootFromParent_Done,
      // Label 6775: @375691
      GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(375780), // Rule ID 14349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14349,
        GIR_EraseRootFromParent_Done,
      // Label 6776: @375780
      GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(375869), // Rule ID 14352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14352,
        GIR_EraseRootFromParent_Done,
      // Label 6777: @375869
      GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(375958), // Rule ID 14353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14353,
        GIR_EraseRootFromParent_Done,
      // Label 6778: @375958
      GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(376047), // Rule ID 14356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14356,
        GIR_EraseRootFromParent_Done,
      // Label 6779: @376047
      GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(376136), // Rule ID 14357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14357,
        GIR_EraseRootFromParent_Done,
      // Label 6780: @376136
      GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(376225), // Rule ID 14360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14360,
        GIR_EraseRootFromParent_Done,
      // Label 6781: @376225
      GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(376314), // Rule ID 14361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14361,
        GIR_EraseRootFromParent_Done,
      // Label 6782: @376314
      GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(376403), // Rule ID 14364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14364,
        GIR_EraseRootFromParent_Done,
      // Label 6783: @376403
      GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(376492), // Rule ID 14365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14365,
        GIR_EraseRootFromParent_Done,
      // Label 6784: @376492
      GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(376581), // Rule ID 14368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14368,
        GIR_EraseRootFromParent_Done,
      // Label 6785: @376581
      GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(376670), // Rule ID 14369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14369,
        GIR_EraseRootFromParent_Done,
      // Label 6786: @376670
      GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(376759), // Rule ID 14372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14372,
        GIR_EraseRootFromParent_Done,
      // Label 6787: @376759
      GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(376848), // Rule ID 14373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14373,
        GIR_EraseRootFromParent_Done,
      // Label 6788: @376848
      GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(376937), // Rule ID 14376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14376,
        GIR_EraseRootFromParent_Done,
      // Label 6789: @376937
      GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(377026), // Rule ID 14377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14377,
        GIR_EraseRootFromParent_Done,
      // Label 6790: @377026
      GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(377115), // Rule ID 14380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14380,
        GIR_EraseRootFromParent_Done,
      // Label 6791: @377115
      GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(377204), // Rule ID 14381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14381,
        GIR_EraseRootFromParent_Done,
      // Label 6792: @377204
      GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(377293), // Rule ID 14384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14384,
        GIR_EraseRootFromParent_Done,
      // Label 6793: @377293
      GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(377382), // Rule ID 14385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14385,
        GIR_EraseRootFromParent_Done,
      // Label 6794: @377382
      GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(377471), // Rule ID 14388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14388,
        GIR_EraseRootFromParent_Done,
      // Label 6795: @377471
      GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(377560), // Rule ID 14389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14389,
        GIR_EraseRootFromParent_Done,
      // Label 6796: @377560
      GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(377649), // Rule ID 14392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14392,
        GIR_EraseRootFromParent_Done,
      // Label 6797: @377649
      GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(377738), // Rule ID 14393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14393,
        GIR_EraseRootFromParent_Done,
      // Label 6798: @377738
      GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(377827), // Rule ID 14396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14396,
        GIR_EraseRootFromParent_Done,
      // Label 6799: @377827
      GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(377916), // Rule ID 14397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14397,
        GIR_EraseRootFromParent_Done,
      // Label 6800: @377916
      GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(378005), // Rule ID 14400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14400,
        GIR_EraseRootFromParent_Done,
      // Label 6801: @378005
      GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(378094), // Rule ID 14401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14401,
        GIR_EraseRootFromParent_Done,
      // Label 6802: @378094
      GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(378183), // Rule ID 14404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14404,
        GIR_EraseRootFromParent_Done,
      // Label 6803: @378183
      GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(378272), // Rule ID 14405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14405,
        GIR_EraseRootFromParent_Done,
      // Label 6804: @378272
      GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(378361), // Rule ID 14408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14408,
        GIR_EraseRootFromParent_Done,
      // Label 6805: @378361
      GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(378450), // Rule ID 14409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14409,
        GIR_EraseRootFromParent_Done,
      // Label 6806: @378450
      GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(378539), // Rule ID 14412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14412,
        GIR_EraseRootFromParent_Done,
      // Label 6807: @378539
      GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(378628), // Rule ID 14413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14413,
        GIR_EraseRootFromParent_Done,
      // Label 6808: @378628
      GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(378717), // Rule ID 14416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14416,
        GIR_EraseRootFromParent_Done,
      // Label 6809: @378717
      GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(378806), // Rule ID 14417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14417,
        GIR_EraseRootFromParent_Done,
      // Label 6810: @378806
      GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(378895), // Rule ID 14420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14420,
        GIR_EraseRootFromParent_Done,
      // Label 6811: @378895
      GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(378984), // Rule ID 14421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14421,
        GIR_EraseRootFromParent_Done,
      // Label 6812: @378984
      GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(379073), // Rule ID 14424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14424,
        GIR_EraseRootFromParent_Done,
      // Label 6813: @379073
      GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(379162), // Rule ID 14425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14425,
        GIR_EraseRootFromParent_Done,
      // Label 6814: @379162
      GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(379251), // Rule ID 14428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14428,
        GIR_EraseRootFromParent_Done,
      // Label 6815: @379251
      GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(379340), // Rule ID 14429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14429,
        GIR_EraseRootFromParent_Done,
      // Label 6816: @379340
      GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(379426), // Rule ID 24524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24524,
        GIR_EraseRootFromParent_Done,
      // Label 6817: @379426
      GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(379512), // Rule ID 24525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24525,
        GIR_EraseRootFromParent_Done,
      // Label 6818: @379512
      GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(379598), // Rule ID 24528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24528,
        GIR_EraseRootFromParent_Done,
      // Label 6819: @379598
      GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(379684), // Rule ID 24529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24529,
        GIR_EraseRootFromParent_Done,
      // Label 6820: @379684
      GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(379770), // Rule ID 24532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24532,
        GIR_EraseRootFromParent_Done,
      // Label 6821: @379770
      GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(379856), // Rule ID 24533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24533,
        GIR_EraseRootFromParent_Done,
      // Label 6822: @379856
      GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(379942), // Rule ID 24536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24536,
        GIR_EraseRootFromParent_Done,
      // Label 6823: @379942
      GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(380028), // Rule ID 24537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24537,
        GIR_EraseRootFromParent_Done,
      // Label 6824: @380028
      GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(380114), // Rule ID 24540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24540,
        GIR_EraseRootFromParent_Done,
      // Label 6825: @380114
      GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(380200), // Rule ID 24541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24541,
        GIR_EraseRootFromParent_Done,
      // Label 6826: @380200
      GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(380286), // Rule ID 24544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24544,
        GIR_EraseRootFromParent_Done,
      // Label 6827: @380286
      GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(380372), // Rule ID 24545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24545,
        GIR_EraseRootFromParent_Done,
      // Label 6828: @380372
      GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(380458), // Rule ID 24548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24548,
        GIR_EraseRootFromParent_Done,
      // Label 6829: @380458
      GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(380544), // Rule ID 24549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24549,
        GIR_EraseRootFromParent_Done,
      // Label 6830: @380544
      GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(380630), // Rule ID 24552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24552,
        GIR_EraseRootFromParent_Done,
      // Label 6831: @380630
      GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(380716), // Rule ID 24553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24553,
        GIR_EraseRootFromParent_Done,
      // Label 6832: @380716
      GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(380802), // Rule ID 24556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24556,
        GIR_EraseRootFromParent_Done,
      // Label 6833: @380802
      GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(380888), // Rule ID 24557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24557,
        GIR_EraseRootFromParent_Done,
      // Label 6834: @380888
      GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(380974), // Rule ID 24560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24560,
        GIR_EraseRootFromParent_Done,
      // Label 6835: @380974
      GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(381060), // Rule ID 24561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24561,
        GIR_EraseRootFromParent_Done,
      // Label 6836: @381060
      GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(381146), // Rule ID 24564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24564,
        GIR_EraseRootFromParent_Done,
      // Label 6837: @381146
      GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(381232), // Rule ID 24565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24565,
        GIR_EraseRootFromParent_Done,
      // Label 6838: @381232
      GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(381318), // Rule ID 24568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24568,
        GIR_EraseRootFromParent_Done,
      // Label 6839: @381318
      GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(381404), // Rule ID 24569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24569,
        GIR_EraseRootFromParent_Done,
      // Label 6840: @381404
      GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(381490), // Rule ID 24572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24572,
        GIR_EraseRootFromParent_Done,
      // Label 6841: @381490
      GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(381576), // Rule ID 24573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24573,
        GIR_EraseRootFromParent_Done,
      // Label 6842: @381576
      GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(381662), // Rule ID 24576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24576,
        GIR_EraseRootFromParent_Done,
      // Label 6843: @381662
      GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(381748), // Rule ID 24577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24577,
        GIR_EraseRootFromParent_Done,
      // Label 6844: @381748
      GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(381834), // Rule ID 24580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24580,
        GIR_EraseRootFromParent_Done,
      // Label 6845: @381834
      GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(381920), // Rule ID 24581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24581,
        GIR_EraseRootFromParent_Done,
      // Label 6846: @381920
      GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(382006), // Rule ID 24584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24584,
        GIR_EraseRootFromParent_Done,
      // Label 6847: @382006
      GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(382092), // Rule ID 24585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24585,
        GIR_EraseRootFromParent_Done,
      // Label 6848: @382092
      GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(382178), // Rule ID 24588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24588,
        GIR_EraseRootFromParent_Done,
      // Label 6849: @382178
      GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(382264), // Rule ID 24589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24589,
        GIR_EraseRootFromParent_Done,
      // Label 6850: @382264
      GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(382350), // Rule ID 24592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24592,
        GIR_EraseRootFromParent_Done,
      // Label 6851: @382350
      GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(382436), // Rule ID 24593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24593,
        GIR_EraseRootFromParent_Done,
      // Label 6852: @382436
      GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(382522), // Rule ID 24596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24596,
        GIR_EraseRootFromParent_Done,
      // Label 6853: @382522
      GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(382608), // Rule ID 24597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24597,
        GIR_EraseRootFromParent_Done,
      // Label 6854: @382608
      GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(382694), // Rule ID 24600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24600,
        GIR_EraseRootFromParent_Done,
      // Label 6855: @382694
      GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(382780), // Rule ID 24601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24601,
        GIR_EraseRootFromParent_Done,
      // Label 6856: @382780
      GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(382866), // Rule ID 24604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24604,
        GIR_EraseRootFromParent_Done,
      // Label 6857: @382866
      GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(382952), // Rule ID 24605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24605,
        GIR_EraseRootFromParent_Done,
      // Label 6858: @382952
      GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(383038), // Rule ID 24608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24608,
        GIR_EraseRootFromParent_Done,
      // Label 6859: @383038
      GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(383124), // Rule ID 24609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24609,
        GIR_EraseRootFromParent_Done,
      // Label 6860: @383124
      GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(383210), // Rule ID 24768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24768,
        GIR_EraseRootFromParent_Done,
      // Label 6861: @383210
      GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(383296), // Rule ID 24769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24769,
        GIR_EraseRootFromParent_Done,
      // Label 6862: @383296
      GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(383382), // Rule ID 24772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24772,
        GIR_EraseRootFromParent_Done,
      // Label 6863: @383382
      GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(383468), // Rule ID 24773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24773,
        GIR_EraseRootFromParent_Done,
      // Label 6864: @383468
      GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(383554), // Rule ID 24776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24776,
        GIR_EraseRootFromParent_Done,
      // Label 6865: @383554
      GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(383640), // Rule ID 24777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24777,
        GIR_EraseRootFromParent_Done,
      // Label 6866: @383640
      GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(383726), // Rule ID 24780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24780,
        GIR_EraseRootFromParent_Done,
      // Label 6867: @383726
      GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(383812), // Rule ID 24781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24781,
        GIR_EraseRootFromParent_Done,
      // Label 6868: @383812
      GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(383898), // Rule ID 24784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24784,
        GIR_EraseRootFromParent_Done,
      // Label 6869: @383898
      GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(383984), // Rule ID 24785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24785,
        GIR_EraseRootFromParent_Done,
      // Label 6870: @383984
      GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(384070), // Rule ID 24788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24788,
        GIR_EraseRootFromParent_Done,
      // Label 6871: @384070
      GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(384156), // Rule ID 24789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24789,
        GIR_EraseRootFromParent_Done,
      // Label 6872: @384156
      GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(384242), // Rule ID 24792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24792,
        GIR_EraseRootFromParent_Done,
      // Label 6873: @384242
      GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(384328), // Rule ID 24793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24793,
        GIR_EraseRootFromParent_Done,
      // Label 6874: @384328
      GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(384414), // Rule ID 24796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24796,
        GIR_EraseRootFromParent_Done,
      // Label 6875: @384414
      GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(384500), // Rule ID 24797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24797,
        GIR_EraseRootFromParent_Done,
      // Label 6876: @384500
      GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(384586), // Rule ID 24800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24800,
        GIR_EraseRootFromParent_Done,
      // Label 6877: @384586
      GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(384672), // Rule ID 24801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24801,
        GIR_EraseRootFromParent_Done,
      // Label 6878: @384672
      GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(384758), // Rule ID 24852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24852,
        GIR_EraseRootFromParent_Done,
      // Label 6879: @384758
      GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(384844), // Rule ID 24853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24853,
        GIR_EraseRootFromParent_Done,
      // Label 6880: @384844
      GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(384930), // Rule ID 24856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24856,
        GIR_EraseRootFromParent_Done,
      // Label 6881: @384930
      GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(385016), // Rule ID 24857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24857,
        GIR_EraseRootFromParent_Done,
      // Label 6882: @385016
      GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(385102), // Rule ID 24860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24860,
        GIR_EraseRootFromParent_Done,
      // Label 6883: @385102
      GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(385188), // Rule ID 24861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24861,
        GIR_EraseRootFromParent_Done,
      // Label 6884: @385188
      GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(385274), // Rule ID 24864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24864,
        GIR_EraseRootFromParent_Done,
      // Label 6885: @385274
      GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(385360), // Rule ID 24865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24865,
        GIR_EraseRootFromParent_Done,
      // Label 6886: @385360
      GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(385446), // Rule ID 24868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24868,
        GIR_EraseRootFromParent_Done,
      // Label 6887: @385446
      GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(385532), // Rule ID 24869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24869,
        GIR_EraseRootFromParent_Done,
      // Label 6888: @385532
      GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(385618), // Rule ID 24872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24872,
        GIR_EraseRootFromParent_Done,
      // Label 6889: @385618
      GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(385704), // Rule ID 24873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24873,
        GIR_EraseRootFromParent_Done,
      // Label 6890: @385704
      GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(385790), // Rule ID 60408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60408,
        GIR_EraseRootFromParent_Done,
      // Label 6891: @385790
      GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(385876), // Rule ID 60409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60409,
        GIR_EraseRootFromParent_Done,
      // Label 6892: @385876
      GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(385962), // Rule ID 60416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60416,
        GIR_EraseRootFromParent_Done,
      // Label 6893: @385962
      GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(386048), // Rule ID 60417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60417,
        GIR_EraseRootFromParent_Done,
      // Label 6894: @386048
      GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(386134), // Rule ID 60424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60424,
        GIR_EraseRootFromParent_Done,
      // Label 6895: @386134
      GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(386220), // Rule ID 60425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60425,
        GIR_EraseRootFromParent_Done,
      // Label 6896: @386220
      GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(386306), // Rule ID 60432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60432,
        GIR_EraseRootFromParent_Done,
      // Label 6897: @386306
      GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(386392), // Rule ID 60433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60433,
        GIR_EraseRootFromParent_Done,
      // Label 6898: @386392
      GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(386478), // Rule ID 60440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60440,
        GIR_EraseRootFromParent_Done,
      // Label 6899: @386478
      GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(386564), // Rule ID 60441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60441,
        GIR_EraseRootFromParent_Done,
      // Label 6900: @386564
      GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(386650), // Rule ID 60448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60448,
        GIR_EraseRootFromParent_Done,
      // Label 6901: @386650
      GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(386736), // Rule ID 60449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60449,
        GIR_EraseRootFromParent_Done,
      // Label 6902: @386736
      GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(386822), // Rule ID 60456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60456,
        GIR_EraseRootFromParent_Done,
      // Label 6903: @386822
      GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(386908), // Rule ID 60457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60457,
        GIR_EraseRootFromParent_Done,
      // Label 6904: @386908
      GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(386994), // Rule ID 60464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60464,
        GIR_EraseRootFromParent_Done,
      // Label 6905: @386994
      GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(387080), // Rule ID 60465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60465,
        GIR_EraseRootFromParent_Done,
      // Label 6906: @387080
      GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(387166), // Rule ID 60472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60472,
        GIR_EraseRootFromParent_Done,
      // Label 6907: @387166
      GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(387252), // Rule ID 60473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60473,
        GIR_EraseRootFromParent_Done,
      // Label 6908: @387252
      GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(387338), // Rule ID 60480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60480,
        GIR_EraseRootFromParent_Done,
      // Label 6909: @387338
      GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(387424), // Rule ID 60481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60481,
        GIR_EraseRootFromParent_Done,
      // Label 6910: @387424
      GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(387510), // Rule ID 60488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60488,
        GIR_EraseRootFromParent_Done,
      // Label 6911: @387510
      GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(387596), // Rule ID 60489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60489,
        GIR_EraseRootFromParent_Done,
      // Label 6912: @387596
      GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(387682), // Rule ID 60496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60496,
        GIR_EraseRootFromParent_Done,
      // Label 6913: @387682
      GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(387768), // Rule ID 60497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60497,
        GIR_EraseRootFromParent_Done,
      // Label 6914: @387768
      GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(387854), // Rule ID 60504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60504,
        GIR_EraseRootFromParent_Done,
      // Label 6915: @387854
      GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(387940), // Rule ID 60505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60505,
        GIR_EraseRootFromParent_Done,
      // Label 6916: @387940
      GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(388026), // Rule ID 60512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60512,
        GIR_EraseRootFromParent_Done,
      // Label 6917: @388026
      GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(388112), // Rule ID 60513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60513,
        GIR_EraseRootFromParent_Done,
      // Label 6918: @388112
      GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(388198), // Rule ID 60520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60520,
        GIR_EraseRootFromParent_Done,
      // Label 6919: @388198
      GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(388284), // Rule ID 60521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60521,
        GIR_EraseRootFromParent_Done,
      // Label 6920: @388284
      GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(388370), // Rule ID 61376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61376,
        GIR_EraseRootFromParent_Done,
      // Label 6921: @388370
      GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(388456), // Rule ID 61377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61377,
        GIR_EraseRootFromParent_Done,
      // Label 6922: @388456
      GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(388542), // Rule ID 61380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61380,
        GIR_EraseRootFromParent_Done,
      // Label 6923: @388542
      GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(388628), // Rule ID 61381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61381,
        GIR_EraseRootFromParent_Done,
      // Label 6924: @388628
      GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(388714), // Rule ID 61384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61384,
        GIR_EraseRootFromParent_Done,
      // Label 6925: @388714
      GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(388800), // Rule ID 61385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61385,
        GIR_EraseRootFromParent_Done,
      // Label 6926: @388800
      GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(388886), // Rule ID 61388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61388,
        GIR_EraseRootFromParent_Done,
      // Label 6927: @388886
      GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(388972), // Rule ID 61389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61389,
        GIR_EraseRootFromParent_Done,
      // Label 6928: @388972
      GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(389058), // Rule ID 61392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61392,
        GIR_EraseRootFromParent_Done,
      // Label 6929: @389058
      GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(389144), // Rule ID 61393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61393,
        GIR_EraseRootFromParent_Done,
      // Label 6930: @389144
      GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(389230), // Rule ID 61396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61396,
        GIR_EraseRootFromParent_Done,
      // Label 6931: @389230
      GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(389316), // Rule ID 61397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61397,
        GIR_EraseRootFromParent_Done,
      // Label 6932: @389316
      GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(389402), // Rule ID 61400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61400,
        GIR_EraseRootFromParent_Done,
      // Label 6933: @389402
      GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(389488), // Rule ID 61401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61401,
        GIR_EraseRootFromParent_Done,
      // Label 6934: @389488
      GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(389574), // Rule ID 61404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61404,
        GIR_EraseRootFromParent_Done,
      // Label 6935: @389574
      GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(389660), // Rule ID 61405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61405,
        GIR_EraseRootFromParent_Done,
      // Label 6936: @389660
      GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(389746), // Rule ID 61408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61408,
        GIR_EraseRootFromParent_Done,
      // Label 6937: @389746
      GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(389832), // Rule ID 61409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61409,
        GIR_EraseRootFromParent_Done,
      // Label 6938: @389832
      GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(389918), // Rule ID 61412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61412,
        GIR_EraseRootFromParent_Done,
      // Label 6939: @389918
      GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(390004), // Rule ID 61413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61413,
        GIR_EraseRootFromParent_Done,
      // Label 6940: @390004
      GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(390090), // Rule ID 61416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61416,
        GIR_EraseRootFromParent_Done,
      // Label 6941: @390090
      GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(390176), // Rule ID 61417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61417,
        GIR_EraseRootFromParent_Done,
      // Label 6942: @390176
      GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(390262), // Rule ID 61420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61420,
        GIR_EraseRootFromParent_Done,
      // Label 6943: @390262
      GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(390348), // Rule ID 61421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61421,
        GIR_EraseRootFromParent_Done,
      // Label 6944: @390348
      GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(390434), // Rule ID 61424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61424,
        GIR_EraseRootFromParent_Done,
      // Label 6945: @390434
      GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(390520), // Rule ID 61425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61425,
        GIR_EraseRootFromParent_Done,
      // Label 6946: @390520
      GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(390606), // Rule ID 61428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61428,
        GIR_EraseRootFromParent_Done,
      // Label 6947: @390606
      GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(390692), // Rule ID 61429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61429,
        GIR_EraseRootFromParent_Done,
      // Label 6948: @390692
      GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(390778), // Rule ID 61432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61432,
        GIR_EraseRootFromParent_Done,
      // Label 6949: @390778
      GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(390864), // Rule ID 61433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61433,
        GIR_EraseRootFromParent_Done,
      // Label 6950: @390864
      GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(390950), // Rule ID 61436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61436,
        GIR_EraseRootFromParent_Done,
      // Label 6951: @390950
      GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(391036), // Rule ID 61437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61437,
        GIR_EraseRootFromParent_Done,
      // Label 6952: @391036
      GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(391122), // Rule ID 61440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61440,
        GIR_EraseRootFromParent_Done,
      // Label 6953: @391122
      GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(391208), // Rule ID 61441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61441,
        GIR_EraseRootFromParent_Done,
      // Label 6954: @391208
      GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(391294), // Rule ID 61444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61444,
        GIR_EraseRootFromParent_Done,
      // Label 6955: @391294
      GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(391380), // Rule ID 61445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61445,
        GIR_EraseRootFromParent_Done,
      // Label 6956: @391380
      GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(391466), // Rule ID 61448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61448,
        GIR_EraseRootFromParent_Done,
      // Label 6957: @391466
      GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(391552), // Rule ID 61449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61449,
        GIR_EraseRootFromParent_Done,
      // Label 6958: @391552
      GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(391638), // Rule ID 61452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61452,
        GIR_EraseRootFromParent_Done,
      // Label 6959: @391638
      GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(391724), // Rule ID 61453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61453,
        GIR_EraseRootFromParent_Done,
      // Label 6960: @391724
      GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(391810), // Rule ID 61456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61456,
        GIR_EraseRootFromParent_Done,
      // Label 6961: @391810
      GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(391896), // Rule ID 61457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61457,
        GIR_EraseRootFromParent_Done,
      // Label 6962: @391896
      GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(391982), // Rule ID 61460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61460,
        GIR_EraseRootFromParent_Done,
      // Label 6963: @391982
      GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(392068), // Rule ID 61461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61461,
        GIR_EraseRootFromParent_Done,
      // Label 6964: @392068
      GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(392147), // Rule ID 2610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2610,
        GIR_EraseRootFromParent_Done,
      // Label 6965: @392147
      GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(392226), // Rule ID 2611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2611,
        GIR_EraseRootFromParent_Done,
      // Label 6966: @392226
      GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(392305), // Rule ID 3918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3918,
        GIR_EraseRootFromParent_Done,
      // Label 6967: @392305
      GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(392384), // Rule ID 3919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3919,
        GIR_EraseRootFromParent_Done,
      // Label 6968: @392384
      GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(392463), // Rule ID 3928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3928,
        GIR_EraseRootFromParent_Done,
      // Label 6969: @392463
      GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(392542), // Rule ID 3929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3929,
        GIR_EraseRootFromParent_Done,
      // Label 6970: @392542
      GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(392621), // Rule ID 3938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3938,
        GIR_EraseRootFromParent_Done,
      // Label 6971: @392621
      GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(392700), // Rule ID 3939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3939,
        GIR_EraseRootFromParent_Done,
      // Label 6972: @392700
      GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(392779), // Rule ID 3948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3948,
        GIR_EraseRootFromParent_Done,
      // Label 6973: @392779
      GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(392858), // Rule ID 3949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3949,
        GIR_EraseRootFromParent_Done,
      // Label 6974: @392858
      GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(392937), // Rule ID 3958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3958,
        GIR_EraseRootFromParent_Done,
      // Label 6975: @392937
      GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(393016), // Rule ID 3959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3959,
        GIR_EraseRootFromParent_Done,
      // Label 6976: @393016
      GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(393095), // Rule ID 3968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3968,
        GIR_EraseRootFromParent_Done,
      // Label 6977: @393095
      GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(393174), // Rule ID 3969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3969,
        GIR_EraseRootFromParent_Done,
      // Label 6978: @393174
      GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(393253), // Rule ID 3978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3978,
        GIR_EraseRootFromParent_Done,
      // Label 6979: @393253
      GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(393332), // Rule ID 3979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3979,
        GIR_EraseRootFromParent_Done,
      // Label 6980: @393332
      GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(393411), // Rule ID 3988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3988,
        GIR_EraseRootFromParent_Done,
      // Label 6981: @393411
      GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(393490), // Rule ID 3989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3989,
        GIR_EraseRootFromParent_Done,
      // Label 6982: @393490
      GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(393569), // Rule ID 3998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3998,
        GIR_EraseRootFromParent_Done,
      // Label 6983: @393569
      GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(393648), // Rule ID 3999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3999,
        GIR_EraseRootFromParent_Done,
      // Label 6984: @393648
      GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(393727), // Rule ID 4008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4008,
        GIR_EraseRootFromParent_Done,
      // Label 6985: @393727
      GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(393806), // Rule ID 4009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4009,
        GIR_EraseRootFromParent_Done,
      // Label 6986: @393806
      GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(393885), // Rule ID 4018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4018,
        GIR_EraseRootFromParent_Done,
      // Label 6987: @393885
      GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(393964), // Rule ID 4019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4019,
        GIR_EraseRootFromParent_Done,
      // Label 6988: @393964
      GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(394043), // Rule ID 4028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4028,
        GIR_EraseRootFromParent_Done,
      // Label 6989: @394043
      GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(394122), // Rule ID 4029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4029,
        GIR_EraseRootFromParent_Done,
      // Label 6990: @394122
      GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(394201), // Rule ID 4038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4038,
        GIR_EraseRootFromParent_Done,
      // Label 6991: @394201
      GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(394280), // Rule ID 4039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4039,
        GIR_EraseRootFromParent_Done,
      // Label 6992: @394280
      GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(394359), // Rule ID 4048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4048,
        GIR_EraseRootFromParent_Done,
      // Label 6993: @394359
      GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(394438), // Rule ID 4049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4049,
        GIR_EraseRootFromParent_Done,
      // Label 6994: @394438
      GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(394517), // Rule ID 4118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4118,
        GIR_EraseRootFromParent_Done,
      // Label 6995: @394517
      GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(394596), // Rule ID 4119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4119,
        GIR_EraseRootFromParent_Done,
      // Label 6996: @394596
      GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(394675), // Rule ID 4128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4128,
        GIR_EraseRootFromParent_Done,
      // Label 6997: @394675
      GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(394754), // Rule ID 4129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4129,
        GIR_EraseRootFromParent_Done,
      // Label 6998: @394754
      GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(394833), // Rule ID 4138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4138,
        GIR_EraseRootFromParent_Done,
      // Label 6999: @394833
      GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(394912), // Rule ID 4139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4139,
        GIR_EraseRootFromParent_Done,
      // Label 7000: @394912
      GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(394991), // Rule ID 4148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4148,
        GIR_EraseRootFromParent_Done,
      // Label 7001: @394991
      GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(395070), // Rule ID 4149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4149,
        GIR_EraseRootFromParent_Done,
      // Label 7002: @395070
      GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(395149), // Rule ID 4158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4158,
        GIR_EraseRootFromParent_Done,
      // Label 7003: @395149
      GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(395228), // Rule ID 4159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4159,
        GIR_EraseRootFromParent_Done,
      // Label 7004: @395228
      GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(395307), // Rule ID 4168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4168,
        GIR_EraseRootFromParent_Done,
      // Label 7005: @395307
      GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(395386), // Rule ID 4169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4169,
        GIR_EraseRootFromParent_Done,
      // Label 7006: @395386
      GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(395465), // Rule ID 4178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4178,
        GIR_EraseRootFromParent_Done,
      // Label 7007: @395465
      GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(395544), // Rule ID 4179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4179,
        GIR_EraseRootFromParent_Done,
      // Label 7008: @395544
      GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(395623), // Rule ID 4188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4188,
        GIR_EraseRootFromParent_Done,
      // Label 7009: @395623
      GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(395702), // Rule ID 4189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4189,
        GIR_EraseRootFromParent_Done,
      // Label 7010: @395702
      GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(395781), // Rule ID 4198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4198,
        GIR_EraseRootFromParent_Done,
      // Label 7011: @395781
      GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(395860), // Rule ID 4199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4199,
        GIR_EraseRootFromParent_Done,
      // Label 7012: @395860
      GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(395939), // Rule ID 4208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4208,
        GIR_EraseRootFromParent_Done,
      // Label 7013: @395939
      GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(396018), // Rule ID 4209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4209,
        GIR_EraseRootFromParent_Done,
      // Label 7014: @396018
      GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(396097), // Rule ID 4218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4218,
        GIR_EraseRootFromParent_Done,
      // Label 7015: @396097
      GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(396176), // Rule ID 4219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4219,
        GIR_EraseRootFromParent_Done,
      // Label 7016: @396176
      GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(396255), // Rule ID 4228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4228,
        GIR_EraseRootFromParent_Done,
      // Label 7017: @396255
      GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(396334), // Rule ID 4229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4229,
        GIR_EraseRootFromParent_Done,
      // Label 7018: @396334
      GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(396413), // Rule ID 4238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4238,
        GIR_EraseRootFromParent_Done,
      // Label 7019: @396413
      GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(396492), // Rule ID 4239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4239,
        GIR_EraseRootFromParent_Done,
      // Label 7020: @396492
      GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(396571), // Rule ID 4248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4248,
        GIR_EraseRootFromParent_Done,
      // Label 7021: @396571
      GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(396650), // Rule ID 4249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4249,
        GIR_EraseRootFromParent_Done,
      // Label 7022: @396650
      GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(396729), // Rule ID 4258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4258,
        GIR_EraseRootFromParent_Done,
      // Label 7023: @396729
      GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(396808), // Rule ID 4259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11280:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4259,
        GIR_EraseRootFromParent_Done,
      // Label 7024: @396808
      GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(396887), // Rule ID 4328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4328,
        GIR_EraseRootFromParent_Done,
      // Label 7025: @396887
      GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(396966), // Rule ID 4329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4329,
        GIR_EraseRootFromParent_Done,
      // Label 7026: @396966
      GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(397045), // Rule ID 4338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4338,
        GIR_EraseRootFromParent_Done,
      // Label 7027: @397045
      GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(397124), // Rule ID 4339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4339,
        GIR_EraseRootFromParent_Done,
      // Label 7028: @397124
      GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(397203), // Rule ID 4348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4348,
        GIR_EraseRootFromParent_Done,
      // Label 7029: @397203
      GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(397282), // Rule ID 4349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4349,
        GIR_EraseRootFromParent_Done,
      // Label 7030: @397282
      GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(397361), // Rule ID 4358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4358,
        GIR_EraseRootFromParent_Done,
      // Label 7031: @397361
      GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(397440), // Rule ID 4359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4359,
        GIR_EraseRootFromParent_Done,
      // Label 7032: @397440
      GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(397519), // Rule ID 4368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4368,
        GIR_EraseRootFromParent_Done,
      // Label 7033: @397519
      GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(397598), // Rule ID 4369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4369,
        GIR_EraseRootFromParent_Done,
      // Label 7034: @397598
      GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(397677), // Rule ID 4378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4378,
        GIR_EraseRootFromParent_Done,
      // Label 7035: @397677
      GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(397756), // Rule ID 4379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4379,
        GIR_EraseRootFromParent_Done,
      // Label 7036: @397756
      GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(397835), // Rule ID 4388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4388,
        GIR_EraseRootFromParent_Done,
      // Label 7037: @397835
      GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(397914), // Rule ID 4389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4389,
        GIR_EraseRootFromParent_Done,
      // Label 7038: @397914
      GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(397993), // Rule ID 4398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4398,
        GIR_EraseRootFromParent_Done,
      // Label 7039: @397993
      GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(398072), // Rule ID 4399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4399,
        GIR_EraseRootFromParent_Done,
      // Label 7040: @398072
      GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(398151), // Rule ID 4408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4408,
        GIR_EraseRootFromParent_Done,
      // Label 7041: @398151
      GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(398230), // Rule ID 4409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4409,
        GIR_EraseRootFromParent_Done,
      // Label 7042: @398230
      GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(398309), // Rule ID 4418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4418,
        GIR_EraseRootFromParent_Done,
      // Label 7043: @398309
      GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(398388), // Rule ID 4419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4419,
        GIR_EraseRootFromParent_Done,
      // Label 7044: @398388
      GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(398467), // Rule ID 4428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4428,
        GIR_EraseRootFromParent_Done,
      // Label 7045: @398467
      GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(398546), // Rule ID 4429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4429,
        GIR_EraseRootFromParent_Done,
      // Label 7046: @398546
      GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(398625), // Rule ID 4438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4438,
        GIR_EraseRootFromParent_Done,
      // Label 7047: @398625
      GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(398704), // Rule ID 4439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4439,
        GIR_EraseRootFromParent_Done,
      // Label 7048: @398704
      GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(398783), // Rule ID 4448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4448,
        GIR_EraseRootFromParent_Done,
      // Label 7049: @398783
      GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(398862), // Rule ID 4449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4449,
        GIR_EraseRootFromParent_Done,
      // Label 7050: @398862
      GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(398941), // Rule ID 4458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4458,
        GIR_EraseRootFromParent_Done,
      // Label 7051: @398941
      GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(399020), // Rule ID 4459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4459,
        GIR_EraseRootFromParent_Done,
      // Label 7052: @399020
      GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(399099), // Rule ID 4468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4468,
        GIR_EraseRootFromParent_Done,
      // Label 7053: @399099
      GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(399178), // Rule ID 4469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4469,
        GIR_EraseRootFromParent_Done,
      // Label 7054: @399178
      GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(399257), // Rule ID 4538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4538,
        GIR_EraseRootFromParent_Done,
      // Label 7055: @399257
      GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(399336), // Rule ID 4539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4539,
        GIR_EraseRootFromParent_Done,
      // Label 7056: @399336
      GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(399415), // Rule ID 4548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4548,
        GIR_EraseRootFromParent_Done,
      // Label 7057: @399415
      GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(399494), // Rule ID 4549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4549,
        GIR_EraseRootFromParent_Done,
      // Label 7058: @399494
      GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(399573), // Rule ID 4558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4558,
        GIR_EraseRootFromParent_Done,
      // Label 7059: @399573
      GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(399652), // Rule ID 4559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4559,
        GIR_EraseRootFromParent_Done,
      // Label 7060: @399652
      GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(399731), // Rule ID 4568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4568,
        GIR_EraseRootFromParent_Done,
      // Label 7061: @399731
      GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(399810), // Rule ID 4569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4569,
        GIR_EraseRootFromParent_Done,
      // Label 7062: @399810
      GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(399889), // Rule ID 4578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4578,
        GIR_EraseRootFromParent_Done,
      // Label 7063: @399889
      GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(399968), // Rule ID 4579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4579,
        GIR_EraseRootFromParent_Done,
      // Label 7064: @399968
      GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(400047), // Rule ID 4588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4588,
        GIR_EraseRootFromParent_Done,
      // Label 7065: @400047
      GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(400126), // Rule ID 4589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4589,
        GIR_EraseRootFromParent_Done,
      // Label 7066: @400126
      GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(400205), // Rule ID 4598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4598,
        GIR_EraseRootFromParent_Done,
      // Label 7067: @400205
      GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(400284), // Rule ID 4599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4599,
        GIR_EraseRootFromParent_Done,
      // Label 7068: @400284
      GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(400363), // Rule ID 4608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4608,
        GIR_EraseRootFromParent_Done,
      // Label 7069: @400363
      GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(400442), // Rule ID 4609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4609,
        GIR_EraseRootFromParent_Done,
      // Label 7070: @400442
      GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(400521), // Rule ID 4618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4618,
        GIR_EraseRootFromParent_Done,
      // Label 7071: @400521
      GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(400600), // Rule ID 4619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4619,
        GIR_EraseRootFromParent_Done,
      // Label 7072: @400600
      GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(400679), // Rule ID 4628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4628,
        GIR_EraseRootFromParent_Done,
      // Label 7073: @400679
      GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(400758), // Rule ID 4629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4629,
        GIR_EraseRootFromParent_Done,
      // Label 7074: @400758
      GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(400837), // Rule ID 4638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4638,
        GIR_EraseRootFromParent_Done,
      // Label 7075: @400837
      GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(400916), // Rule ID 4639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4639,
        GIR_EraseRootFromParent_Done,
      // Label 7076: @400916
      GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(400995), // Rule ID 4648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4648,
        GIR_EraseRootFromParent_Done,
      // Label 7077: @400995
      GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(401074), // Rule ID 4649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4649,
        GIR_EraseRootFromParent_Done,
      // Label 7078: @401074
      GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(401153), // Rule ID 4658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4658,
        GIR_EraseRootFromParent_Done,
      // Label 7079: @401153
      GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(401232), // Rule ID 4659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4659,
        GIR_EraseRootFromParent_Done,
      // Label 7080: @401232
      GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(401311), // Rule ID 4668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4668,
        GIR_EraseRootFromParent_Done,
      // Label 7081: @401311
      GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(401390), // Rule ID 4669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4669,
        GIR_EraseRootFromParent_Done,
      // Label 7082: @401390
      GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(401469), // Rule ID 4678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4678,
        GIR_EraseRootFromParent_Done,
      // Label 7083: @401469
      GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(401548), // Rule ID 4679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11276:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4679,
        GIR_EraseRootFromParent_Done,
      // Label 7084: @401548
      GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(401634), // Rule ID 2570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2570,
        GIR_EraseRootFromParent_Done,
      // Label 7085: @401634
      GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(401720), // Rule ID 2571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2571,
        GIR_EraseRootFromParent_Done,
      // Label 7086: @401720
      GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(401806), // Rule ID 23358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23358,
        GIR_EraseRootFromParent_Done,
      // Label 7087: @401806
      GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(401892), // Rule ID 23359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23359,
        GIR_EraseRootFromParent_Done,
      // Label 7088: @401892
      GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(401978), // Rule ID 23362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23362,
        GIR_EraseRootFromParent_Done,
      // Label 7089: @401978
      GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(402064), // Rule ID 23363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23363,
        GIR_EraseRootFromParent_Done,
      // Label 7090: @402064
      GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(402150), // Rule ID 23366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23366,
        GIR_EraseRootFromParent_Done,
      // Label 7091: @402150
      GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(402236), // Rule ID 23367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23367,
        GIR_EraseRootFromParent_Done,
      // Label 7092: @402236
      GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(402322), // Rule ID 23370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23370,
        GIR_EraseRootFromParent_Done,
      // Label 7093: @402322
      GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(402408), // Rule ID 23371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23371,
        GIR_EraseRootFromParent_Done,
      // Label 7094: @402408
      GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(402494), // Rule ID 23374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23374,
        GIR_EraseRootFromParent_Done,
      // Label 7095: @402494
      GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(402580), // Rule ID 23375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23375,
        GIR_EraseRootFromParent_Done,
      // Label 7096: @402580
      GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(402666), // Rule ID 23378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23378,
        GIR_EraseRootFromParent_Done,
      // Label 7097: @402666
      GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(402752), // Rule ID 23379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10929:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23379,
        GIR_EraseRootFromParent_Done,
      // Label 7098: @402752
      GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(402838), // Rule ID 23382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23382,
        GIR_EraseRootFromParent_Done,
      // Label 7099: @402838
      GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(402924), // Rule ID 23383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10929:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23383,
        GIR_EraseRootFromParent_Done,
      // Label 7100: @402924
      GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(403010), // Rule ID 23386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23386,
        GIR_EraseRootFromParent_Done,
      // Label 7101: @403010
      GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(403096), // Rule ID 23387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10929:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23387,
        GIR_EraseRootFromParent_Done,
      // Label 7102: @403096
      GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(403182), // Rule ID 23390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23390,
        GIR_EraseRootFromParent_Done,
      // Label 7103: @403182
      GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(403268), // Rule ID 23391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10929:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23391,
        GIR_EraseRootFromParent_Done,
      // Label 7104: @403268
      GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(403354), // Rule ID 23394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23394,
        GIR_EraseRootFromParent_Done,
      // Label 7105: @403354
      GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(403440), // Rule ID 23395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23395,
        GIR_EraseRootFromParent_Done,
      // Label 7106: @403440
      GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(403526), // Rule ID 23398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23398,
        GIR_EraseRootFromParent_Done,
      // Label 7107: @403526
      GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(403612), // Rule ID 23399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23399,
        GIR_EraseRootFromParent_Done,
      // Label 7108: @403612
      GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(403698), // Rule ID 23402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10929:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23402,
        GIR_EraseRootFromParent_Done,
      // Label 7109: @403698
      GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(403784), // Rule ID 23403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10929:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23403,
        GIR_EraseRootFromParent_Done,
      // Label 7110: @403784
      GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(403870), // Rule ID 23406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23406,
        GIR_EraseRootFromParent_Done,
      // Label 7111: @403870
      GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(403956), // Rule ID 23407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23407,
        GIR_EraseRootFromParent_Done,
      // Label 7112: @403956
      GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(404042), // Rule ID 23410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23410,
        GIR_EraseRootFromParent_Done,
      // Label 7113: @404042
      GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(404128), // Rule ID 23411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23411,
        GIR_EraseRootFromParent_Done,
      // Label 7114: @404128
      GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(404214), // Rule ID 23414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10929:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23414,
        GIR_EraseRootFromParent_Done,
      // Label 7115: @404214
      GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(404300), // Rule ID 23415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10929:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23415,
        GIR_EraseRootFromParent_Done,
      // Label 7116: @404300
      GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(404386), // Rule ID 23418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23418,
        GIR_EraseRootFromParent_Done,
      // Label 7117: @404386
      GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(404472), // Rule ID 23419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23419,
        GIR_EraseRootFromParent_Done,
      // Label 7118: @404472
      GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(404558), // Rule ID 23422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23422,
        GIR_EraseRootFromParent_Done,
      // Label 7119: @404558
      GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(404644), // Rule ID 23423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23423,
        GIR_EraseRootFromParent_Done,
      // Label 7120: @404644
      GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(404730), // Rule ID 23426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10929:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23426,
        GIR_EraseRootFromParent_Done,
      // Label 7121: @404730
      GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(404816), // Rule ID 23427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10929:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23427,
        GIR_EraseRootFromParent_Done,
      // Label 7122: @404816
      GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(404902), // Rule ID 23430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23430,
        GIR_EraseRootFromParent_Done,
      // Label 7123: @404902
      GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(404988), // Rule ID 23431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10929:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23431,
        GIR_EraseRootFromParent_Done,
      // Label 7124: @404988
      GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(405074), // Rule ID 23434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23434,
        GIR_EraseRootFromParent_Done,
      // Label 7125: @405074
      GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(405160), // Rule ID 23435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10929:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23435,
        GIR_EraseRootFromParent_Done,
      // Label 7126: @405160
      GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(405246), // Rule ID 23438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10929:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23438,
        GIR_EraseRootFromParent_Done,
      // Label 7127: @405246
      GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(405332), // Rule ID 23439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10929:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23439,
        GIR_EraseRootFromParent_Done,
      // Label 7128: @405332
      GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(405400), // Rule ID 59976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59976,
        GIR_EraseRootFromParent_Done,
      // Label 7129: @405400
      GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(405468), // Rule ID 59977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59977,
        GIR_EraseRootFromParent_Done,
      // Label 7130: @405468
      GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(405536), // Rule ID 59978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10752:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59978,
        GIR_EraseRootFromParent_Done,
      // Label 7131: @405536
      GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(405604), // Rule ID 59979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10752:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59979,
        GIR_EraseRootFromParent_Done,
      // Label 7132: @405604
      GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(405672), // Rule ID 61472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61472,
        GIR_EraseRootFromParent_Done,
      // Label 7133: @405672
      GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(405740), // Rule ID 61473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10927:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61473,
        GIR_EraseRootFromParent_Done,
      // Label 7134: @405740
      GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(405808), // Rule ID 61474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61474,
        GIR_EraseRootFromParent_Done,
      // Label 7135: @405808
      GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(405876), // Rule ID 61475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10927:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61475,
        GIR_EraseRootFromParent_Done,
      // Label 7136: @405876
      GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(405944), // Rule ID 61476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61476,
        GIR_EraseRootFromParent_Done,
      // Label 7137: @405944
      GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(406012), // Rule ID 61477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10927:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61477,
        GIR_EraseRootFromParent_Done,
      // Label 7138: @406012
      GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(406080), // Rule ID 61478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10927:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61478,
        GIR_EraseRootFromParent_Done,
      // Label 7139: @406080
      GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(406148), // Rule ID 61479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10927:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61479,
        GIR_EraseRootFromParent_Done,
      // Label 7140: @406148
      GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(406216), // Rule ID 61480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10753:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61480,
        GIR_EraseRootFromParent_Done,
      // Label 7141: @406216
      GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(406284), // Rule ID 61481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10753:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61481,
        GIR_EraseRootFromParent_Done,
      // Label 7142: @406284
      GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(406352), // Rule ID 61482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10753:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61482,
        GIR_EraseRootFromParent_Done,
      // Label 7143: @406352
      GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(406420), // Rule ID 61483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10753:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61483,
        GIR_EraseRootFromParent_Done,
      // Label 7144: @406420
      GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(406488), // Rule ID 61484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10753:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61484,
        GIR_EraseRootFromParent_Done,
      // Label 7145: @406488
      GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(406556), // Rule ID 61485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10753:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61485,
        GIR_EraseRootFromParent_Done,
      // Label 7146: @406556
      GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(406624), // Rule ID 61486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10753:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61486,
        GIR_EraseRootFromParent_Done,
      // Label 7147: @406624
      GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(406692), // Rule ID 61487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10753:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61487,
        GIR_EraseRootFromParent_Done,
      // Label 7148: @406692
      GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(406760), // Rule ID 61488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10753:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61488,
        GIR_EraseRootFromParent_Done,
      // Label 7149: @406760
      GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(406828), // Rule ID 61489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10753:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61489,
        GIR_EraseRootFromParent_Done,
      // Label 7150: @406828
      GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(406896), // Rule ID 61490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10752:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61490,
        GIR_EraseRootFromParent_Done,
      // Label 7151: @406896
      GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(406964), // Rule ID 61491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10752:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61491,
        GIR_EraseRootFromParent_Done,
      // Label 7152: @406964
      GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(407032), // Rule ID 61492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10752:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61492,
        GIR_EraseRootFromParent_Done,
      // Label 7153: @407032
      GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(407100), // Rule ID 61493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10752:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61493,
        GIR_EraseRootFromParent_Done,
      // Label 7154: @407100
      GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(407168), // Rule ID 61494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10752:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61494,
        GIR_EraseRootFromParent_Done,
      // Label 7155: @407168
      GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(407236), // Rule ID 61495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10752:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61495,
        GIR_EraseRootFromParent_Done,
      // Label 7156: @407236
      GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(407304), // Rule ID 61496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10752:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61496,
        GIR_EraseRootFromParent_Done,
      // Label 7157: @407304
      GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(407372), // Rule ID 61497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10752:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61497,
        GIR_EraseRootFromParent_Done,
      // Label 7158: @407372
      GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(407440), // Rule ID 61498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10752:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61498,
        GIR_EraseRootFromParent_Done,
      // Label 7159: @407440
      GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(407508), // Rule ID 61499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10752:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61499,
        GIR_EraseRootFromParent_Done,
      // Label 7160: @407508
      GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(407576), // Rule ID 61500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61500,
        GIR_EraseRootFromParent_Done,
      // Label 7161: @407576
      GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(407644), // Rule ID 61501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61501,
        GIR_EraseRootFromParent_Done,
      // Label 7162: @407644
      GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(407712), // Rule ID 61502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61502,
        GIR_EraseRootFromParent_Done,
      // Label 7163: @407712
      GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(407780), // Rule ID 61503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61503,
        GIR_EraseRootFromParent_Done,
      // Label 7164: @407780
      GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(407848), // Rule ID 61504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61504,
        GIR_EraseRootFromParent_Done,
      // Label 7165: @407848
      GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(407916), // Rule ID 61505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61505,
        GIR_EraseRootFromParent_Done,
      // Label 7166: @407916
      GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(407984), // Rule ID 61506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61506,
        GIR_EraseRootFromParent_Done,
      // Label 7167: @407984
      GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(408052), // Rule ID 61507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10752:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61507,
        GIR_EraseRootFromParent_Done,
      // Label 7168: @408052
      GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(408120), // Rule ID 61508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61508,
        GIR_EraseRootFromParent_Done,
      // Label 7169: @408120
      GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(408188), // Rule ID 61509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61509,
        GIR_EraseRootFromParent_Done,
      // Label 7170: @408188
      GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(408256), // Rule ID 61510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61510,
        GIR_EraseRootFromParent_Done,
      // Label 7171: @408256
      GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(408324), // Rule ID 61511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61511,
        GIR_EraseRootFromParent_Done,
      // Label 7172: @408324
      GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(408392), // Rule ID 61512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61512,
        GIR_EraseRootFromParent_Done,
      // Label 7173: @408392
      GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(408460), // Rule ID 61513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61513,
        GIR_EraseRootFromParent_Done,
      // Label 7174: @408460
      GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(408528), // Rule ID 61514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61514,
        GIR_EraseRootFromParent_Done,
      // Label 7175: @408528
      GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(408596), // Rule ID 61515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10752:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61515,
        GIR_EraseRootFromParent_Done,
      // Label 7176: @408596
      GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(408664), // Rule ID 61516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10755:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61516,
        GIR_EraseRootFromParent_Done,
      // Label 7177: @408664
      GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(408732), // Rule ID 61517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10755:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61517,
        GIR_EraseRootFromParent_Done,
      // Label 7178: @408732
      GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(408800), // Rule ID 61518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10755:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61518,
        GIR_EraseRootFromParent_Done,
      // Label 7179: @408800
      GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(408868), // Rule ID 61519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10755:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61519,
        GIR_EraseRootFromParent_Done,
      // Label 7180: @408868
      GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(408936), // Rule ID 61520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10755:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61520,
        GIR_EraseRootFromParent_Done,
      // Label 7181: @408936
      GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(409004), // Rule ID 61521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10755:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61521,
        GIR_EraseRootFromParent_Done,
      // Label 7182: @409004
      GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(409072), // Rule ID 61522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10755:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61522,
        GIR_EraseRootFromParent_Done,
      // Label 7183: @409072
      GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(409140), // Rule ID 61523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10755:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61523,
        GIR_EraseRootFromParent_Done,
      // Label 7184: @409140
      GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(409208), // Rule ID 61524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10755:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61524,
        GIR_EraseRootFromParent_Done,
      // Label 7185: @409208
      GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(409276), // Rule ID 61525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10755:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61525,
        GIR_EraseRootFromParent_Done,
      // Label 7186: @409276
      GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(409344), // Rule ID 61526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10754:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61526,
        GIR_EraseRootFromParent_Done,
      // Label 7187: @409344
      GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(409412), // Rule ID 61527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10754:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61527,
        GIR_EraseRootFromParent_Done,
      // Label 7188: @409412
      GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(409480), // Rule ID 61528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10754:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61528,
        GIR_EraseRootFromParent_Done,
      // Label 7189: @409480
      GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(409548), // Rule ID 61529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10754:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61529,
        GIR_EraseRootFromParent_Done,
      // Label 7190: @409548
      GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(409616), // Rule ID 61530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10754:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61530,
        GIR_EraseRootFromParent_Done,
      // Label 7191: @409616
      GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(409684), // Rule ID 61531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10754:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61531,
        GIR_EraseRootFromParent_Done,
      // Label 7192: @409684
      GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(409752), // Rule ID 61532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10754:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61532,
        GIR_EraseRootFromParent_Done,
      // Label 7193: @409752
      GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(409820), // Rule ID 61533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10754:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61533,
        GIR_EraseRootFromParent_Done,
      // Label 7194: @409820
      GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(409888), // Rule ID 61534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10754:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61534,
        GIR_EraseRootFromParent_Done,
      // Label 7195: @409888
      GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(409956), // Rule ID 61535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10754:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61535,
        GIR_EraseRootFromParent_Done,
      // Label 7196: @409956
      GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(410024), // Rule ID 61536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10754:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61536,
        GIR_EraseRootFromParent_Done,
      // Label 7197: @410024
      GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(410092), // Rule ID 61537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10754:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61537,
        GIR_EraseRootFromParent_Done,
      // Label 7198: @410092
      GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(410160), // Rule ID 61538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61538,
        GIR_EraseRootFromParent_Done,
      // Label 7199: @410160
      GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(410228), // Rule ID 61539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61539,
        GIR_EraseRootFromParent_Done,
      // Label 7200: @410228
      GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(410296), // Rule ID 61540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61540,
        GIR_EraseRootFromParent_Done,
      // Label 7201: @410296
      GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(410364), // Rule ID 61541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61541,
        GIR_EraseRootFromParent_Done,
      // Label 7202: @410364
      GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(410432), // Rule ID 61542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61542,
        GIR_EraseRootFromParent_Done,
      // Label 7203: @410432
      GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(410500), // Rule ID 61543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61543,
        GIR_EraseRootFromParent_Done,
      // Label 7204: @410500
      GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(410568), // Rule ID 61544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61544,
        GIR_EraseRootFromParent_Done,
      // Label 7205: @410568
      GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(410636), // Rule ID 61545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10754:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61545,
        GIR_EraseRootFromParent_Done,
      // Label 7206: @410636
      GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(410704), // Rule ID 61546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61546,
        GIR_EraseRootFromParent_Done,
      // Label 7207: @410704
      GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(410772), // Rule ID 61547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61547,
        GIR_EraseRootFromParent_Done,
      // Label 7208: @410772
      GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(410840), // Rule ID 61548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61548,
        GIR_EraseRootFromParent_Done,
      // Label 7209: @410840
      GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(410908), // Rule ID 61549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61549,
        GIR_EraseRootFromParent_Done,
      // Label 7210: @410908
      GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(410976), // Rule ID 61550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61550,
        GIR_EraseRootFromParent_Done,
      // Label 7211: @410976
      GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(411044), // Rule ID 61551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61551,
        GIR_EraseRootFromParent_Done,
      // Label 7212: @411044
      GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(411112), // Rule ID 61552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61552,
        GIR_EraseRootFromParent_Done,
      // Label 7213: @411112
      GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(411180), // Rule ID 61553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10754:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61553,
        GIR_EraseRootFromParent_Done,
      // Label 7214: @411180
      GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(411248), // Rule ID 61554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10757:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61554,
        GIR_EraseRootFromParent_Done,
      // Label 7215: @411248
      GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(411316), // Rule ID 61555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10757:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61555,
        GIR_EraseRootFromParent_Done,
      // Label 7216: @411316
      GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(411384), // Rule ID 61556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10757:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61556,
        GIR_EraseRootFromParent_Done,
      // Label 7217: @411384
      GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(411452), // Rule ID 61557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10757:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61557,
        GIR_EraseRootFromParent_Done,
      // Label 7218: @411452
      GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(411520), // Rule ID 61558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10757:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61558,
        GIR_EraseRootFromParent_Done,
      // Label 7219: @411520
      GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(411588), // Rule ID 61559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10757:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61559,
        GIR_EraseRootFromParent_Done,
      // Label 7220: @411588
      GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(411656), // Rule ID 61560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10757:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61560,
        GIR_EraseRootFromParent_Done,
      // Label 7221: @411656
      GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(411724), // Rule ID 61561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10757:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61561,
        GIR_EraseRootFromParent_Done,
      // Label 7222: @411724
      GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(411792), // Rule ID 61562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10757:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61562,
        GIR_EraseRootFromParent_Done,
      // Label 7223: @411792
      GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(411860), // Rule ID 61563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10757:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61563,
        GIR_EraseRootFromParent_Done,
      // Label 7224: @411860
      GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(411928), // Rule ID 61564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10756:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61564,
        GIR_EraseRootFromParent_Done,
      // Label 7225: @411928
      GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(411996), // Rule ID 61565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10756:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61565,
        GIR_EraseRootFromParent_Done,
      // Label 7226: @411996
      GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(412064), // Rule ID 61566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10756:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61566,
        GIR_EraseRootFromParent_Done,
      // Label 7227: @412064
      GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(412132), // Rule ID 61567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10756:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61567,
        GIR_EraseRootFromParent_Done,
      // Label 7228: @412132
      GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(412200), // Rule ID 61568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10756:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61568,
        GIR_EraseRootFromParent_Done,
      // Label 7229: @412200
      GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(412268), // Rule ID 61569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10756:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61569,
        GIR_EraseRootFromParent_Done,
      // Label 7230: @412268
      GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(412336), // Rule ID 61570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10756:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61570,
        GIR_EraseRootFromParent_Done,
      // Label 7231: @412336
      GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(412404), // Rule ID 61571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10756:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61571,
        GIR_EraseRootFromParent_Done,
      // Label 7232: @412404
      GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(412472), // Rule ID 61572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10756:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61572,
        GIR_EraseRootFromParent_Done,
      // Label 7233: @412472
      GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(412540), // Rule ID 61573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10756:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61573,
        GIR_EraseRootFromParent_Done,
      // Label 7234: @412540
      GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(412608), // Rule ID 61574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10756:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61574,
        GIR_EraseRootFromParent_Done,
      // Label 7235: @412608
      GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(412676), // Rule ID 61575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10756:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61575,
        GIR_EraseRootFromParent_Done,
      // Label 7236: @412676
      GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(412744), // Rule ID 61576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61576,
        GIR_EraseRootFromParent_Done,
      // Label 7237: @412744
      GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(412812), // Rule ID 61577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61577,
        GIR_EraseRootFromParent_Done,
      // Label 7238: @412812
      GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(412880), // Rule ID 61578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61578,
        GIR_EraseRootFromParent_Done,
      // Label 7239: @412880
      GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(412948), // Rule ID 61579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61579,
        GIR_EraseRootFromParent_Done,
      // Label 7240: @412948
      GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(413016), // Rule ID 61580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61580,
        GIR_EraseRootFromParent_Done,
      // Label 7241: @413016
      GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(413084), // Rule ID 61581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61581,
        GIR_EraseRootFromParent_Done,
      // Label 7242: @413084
      GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(413152), // Rule ID 61582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61582,
        GIR_EraseRootFromParent_Done,
      // Label 7243: @413152
      GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(413220), // Rule ID 61583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10756:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61583,
        GIR_EraseRootFromParent_Done,
      // Label 7244: @413220
      GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(413288), // Rule ID 61584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61584,
        GIR_EraseRootFromParent_Done,
      // Label 7245: @413288
      GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(413356), // Rule ID 61585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61585,
        GIR_EraseRootFromParent_Done,
      // Label 7246: @413356
      GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(413424), // Rule ID 61586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61586,
        GIR_EraseRootFromParent_Done,
      // Label 7247: @413424
      GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(413492), // Rule ID 61587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61587,
        GIR_EraseRootFromParent_Done,
      // Label 7248: @413492
      GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(413560), // Rule ID 61588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61588,
        GIR_EraseRootFromParent_Done,
      // Label 7249: @413560
      GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(413628), // Rule ID 61589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61589,
        GIR_EraseRootFromParent_Done,
      // Label 7250: @413628
      GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(413696), // Rule ID 61590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61590,
        GIR_EraseRootFromParent_Done,
      // Label 7251: @413696
      GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(413764), // Rule ID 61591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10756:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61591,
        GIR_EraseRootFromParent_Done,
      // Label 7252: @413764
      GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(413832), // Rule ID 61592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10759:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61592,
        GIR_EraseRootFromParent_Done,
      // Label 7253: @413832
      GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(413900), // Rule ID 61593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10759:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61593,
        GIR_EraseRootFromParent_Done,
      // Label 7254: @413900
      GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(413968), // Rule ID 61594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10759:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61594,
        GIR_EraseRootFromParent_Done,
      // Label 7255: @413968
      GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(414036), // Rule ID 61595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10759:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61595,
        GIR_EraseRootFromParent_Done,
      // Label 7256: @414036
      GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(414104), // Rule ID 61596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10759:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61596,
        GIR_EraseRootFromParent_Done,
      // Label 7257: @414104
      GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(414172), // Rule ID 61597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10759:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61597,
        GIR_EraseRootFromParent_Done,
      // Label 7258: @414172
      GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(414240), // Rule ID 61598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10759:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61598,
        GIR_EraseRootFromParent_Done,
      // Label 7259: @414240
      GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(414308), // Rule ID 61599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10759:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61599,
        GIR_EraseRootFromParent_Done,
      // Label 7260: @414308
      GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(414376), // Rule ID 61600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10759:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61600,
        GIR_EraseRootFromParent_Done,
      // Label 7261: @414376
      GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(414444), // Rule ID 61601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10759:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61601,
        GIR_EraseRootFromParent_Done,
      // Label 7262: @414444
      GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(414512), // Rule ID 61602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10758:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61602,
        GIR_EraseRootFromParent_Done,
      // Label 7263: @414512
      GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(414580), // Rule ID 61603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10758:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61603,
        GIR_EraseRootFromParent_Done,
      // Label 7264: @414580
      GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(414648), // Rule ID 61604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10758:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61604,
        GIR_EraseRootFromParent_Done,
      // Label 7265: @414648
      GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(414716), // Rule ID 61605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10758:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61605,
        GIR_EraseRootFromParent_Done,
      // Label 7266: @414716
      GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(414784), // Rule ID 61606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10758:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61606,
        GIR_EraseRootFromParent_Done,
      // Label 7267: @414784
      GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(414852), // Rule ID 61607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10758:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61607,
        GIR_EraseRootFromParent_Done,
      // Label 7268: @414852
      GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(414920), // Rule ID 61608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10758:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61608,
        GIR_EraseRootFromParent_Done,
      // Label 7269: @414920
      GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(414988), // Rule ID 61609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10758:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61609,
        GIR_EraseRootFromParent_Done,
      // Label 7270: @414988
      GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(415056), // Rule ID 61610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10758:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61610,
        GIR_EraseRootFromParent_Done,
      // Label 7271: @415056
      GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(415124), // Rule ID 61611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10758:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61611,
        GIR_EraseRootFromParent_Done,
      // Label 7272: @415124
      GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(415192), // Rule ID 61612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10758:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61612,
        GIR_EraseRootFromParent_Done,
      // Label 7273: @415192
      GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(415260), // Rule ID 61613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10758:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61613,
        GIR_EraseRootFromParent_Done,
      // Label 7274: @415260
      GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(415328), // Rule ID 61614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61614,
        GIR_EraseRootFromParent_Done,
      // Label 7275: @415328
      GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(415396), // Rule ID 61615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61615,
        GIR_EraseRootFromParent_Done,
      // Label 7276: @415396
      GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(415464), // Rule ID 61616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61616,
        GIR_EraseRootFromParent_Done,
      // Label 7277: @415464
      GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(415532), // Rule ID 61617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61617,
        GIR_EraseRootFromParent_Done,
      // Label 7278: @415532
      GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(415600), // Rule ID 61618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61618,
        GIR_EraseRootFromParent_Done,
      // Label 7279: @415600
      GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(415668), // Rule ID 61619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61619,
        GIR_EraseRootFromParent_Done,
      // Label 7280: @415668
      GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(415736), // Rule ID 61620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61620,
        GIR_EraseRootFromParent_Done,
      // Label 7281: @415736
      GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(415804), // Rule ID 61621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10758:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61621,
        GIR_EraseRootFromParent_Done,
      // Label 7282: @415804
      GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(415872), // Rule ID 61622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61622,
        GIR_EraseRootFromParent_Done,
      // Label 7283: @415872
      GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(415940), // Rule ID 61623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61623,
        GIR_EraseRootFromParent_Done,
      // Label 7284: @415940
      GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(416008), // Rule ID 61624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61624,
        GIR_EraseRootFromParent_Done,
      // Label 7285: @416008
      GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(416076), // Rule ID 61625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61625,
        GIR_EraseRootFromParent_Done,
      // Label 7286: @416076
      GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(416144), // Rule ID 61626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61626,
        GIR_EraseRootFromParent_Done,
      // Label 7287: @416144
      GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(416212), // Rule ID 61627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61627,
        GIR_EraseRootFromParent_Done,
      // Label 7288: @416212
      GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(416280), // Rule ID 61628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61628,
        GIR_EraseRootFromParent_Done,
      // Label 7289: @416280
      GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(416348), // Rule ID 61629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10758:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61629,
        GIR_EraseRootFromParent_Done,
      // Label 7290: @416348
      GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(416416), // Rule ID 61646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10762:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61646,
        GIR_EraseRootFromParent_Done,
      // Label 7291: @416416
      GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(416484), // Rule ID 61647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10762:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61647,
        GIR_EraseRootFromParent_Done,
      // Label 7292: @416484
      GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(416552), // Rule ID 61648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10762:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61648,
        GIR_EraseRootFromParent_Done,
      // Label 7293: @416552
      GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(416620), // Rule ID 61649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10762:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61649,
        GIR_EraseRootFromParent_Done,
      // Label 7294: @416620
      GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(416688), // Rule ID 61650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10762:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61650,
        GIR_EraseRootFromParent_Done,
      // Label 7295: @416688
      GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(416756), // Rule ID 61651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10762:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61651,
        GIR_EraseRootFromParent_Done,
      // Label 7296: @416756
      GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(416824), // Rule ID 61652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10762:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61652,
        GIR_EraseRootFromParent_Done,
      // Label 7297: @416824
      GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(416892), // Rule ID 61653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10762:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61653,
        GIR_EraseRootFromParent_Done,
      // Label 7298: @416892
      GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(416960), // Rule ID 61654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10762:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61654,
        GIR_EraseRootFromParent_Done,
      // Label 7299: @416960
      GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(417028), // Rule ID 61655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10762:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61655,
        GIR_EraseRootFromParent_Done,
      // Label 7300: @417028
      GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(417096), // Rule ID 61656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10762:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61656,
        GIR_EraseRootFromParent_Done,
      // Label 7301: @417096
      GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(417164), // Rule ID 61657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10762:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61657,
        GIR_EraseRootFromParent_Done,
      // Label 7302: @417164
      GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(417232), // Rule ID 61658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61658,
        GIR_EraseRootFromParent_Done,
      // Label 7303: @417232
      GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(417300), // Rule ID 61659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61659,
        GIR_EraseRootFromParent_Done,
      // Label 7304: @417300
      GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(417368), // Rule ID 61660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61660,
        GIR_EraseRootFromParent_Done,
      // Label 7305: @417368
      GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(417436), // Rule ID 61661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61661,
        GIR_EraseRootFromParent_Done,
      // Label 7306: @417436
      GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(417504), // Rule ID 61662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61662,
        GIR_EraseRootFromParent_Done,
      // Label 7307: @417504
      GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(417572), // Rule ID 61663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61663,
        GIR_EraseRootFromParent_Done,
      // Label 7308: @417572
      GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(417640), // Rule ID 61664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61664,
        GIR_EraseRootFromParent_Done,
      // Label 7309: @417640
      GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(417708), // Rule ID 61665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10762:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61665,
        GIR_EraseRootFromParent_Done,
      // Label 7310: @417708
      GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(417776), // Rule ID 61666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61666,
        GIR_EraseRootFromParent_Done,
      // Label 7311: @417776
      GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(417844), // Rule ID 61667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61667,
        GIR_EraseRootFromParent_Done,
      // Label 7312: @417844
      GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(417912), // Rule ID 61668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61668,
        GIR_EraseRootFromParent_Done,
      // Label 7313: @417912
      GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(417980), // Rule ID 61669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61669,
        GIR_EraseRootFromParent_Done,
      // Label 7314: @417980
      GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(418048), // Rule ID 61670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61670,
        GIR_EraseRootFromParent_Done,
      // Label 7315: @418048
      GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(418116), // Rule ID 61671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61671,
        GIR_EraseRootFromParent_Done,
      // Label 7316: @418116
      GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(418184), // Rule ID 61672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61672,
        GIR_EraseRootFromParent_Done,
      // Label 7317: @418184
      GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(418252), // Rule ID 61673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10762:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61673,
        GIR_EraseRootFromParent_Done,
      // Label 7318: @418252
      GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(418320), // Rule ID 61768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61768,
        GIR_EraseRootFromParent_Done,
      // Label 7319: @418320
      GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(418388), // Rule ID 61769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61769,
        GIR_EraseRootFromParent_Done,
      // Label 7320: @418388
      GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(418456), // Rule ID 61770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61770,
        GIR_EraseRootFromParent_Done,
      // Label 7321: @418456
      GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(418524), // Rule ID 61771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61771,
        GIR_EraseRootFromParent_Done,
      // Label 7322: @418524
      GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(418592), // Rule ID 61772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61772,
        GIR_EraseRootFromParent_Done,
      // Label 7323: @418592
      GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(418660), // Rule ID 61773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61773,
        GIR_EraseRootFromParent_Done,
      // Label 7324: @418660
      GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(418728), // Rule ID 61774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61774,
        GIR_EraseRootFromParent_Done,
      // Label 7325: @418728
      GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(418796), // Rule ID 61775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61775,
        GIR_EraseRootFromParent_Done,
      // Label 7326: @418796
      GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(418864), // Rule ID 61776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61776,
        GIR_EraseRootFromParent_Done,
      // Label 7327: @418864
      GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(418932), // Rule ID 61777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61777,
        GIR_EraseRootFromParent_Done,
      // Label 7328: @418932
      GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(419000), // Rule ID 61778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61778,
        GIR_EraseRootFromParent_Done,
      // Label 7329: @419000
      GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(419068), // Rule ID 61779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61779,
        GIR_EraseRootFromParent_Done,
      // Label 7330: @419068
      GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(419136), // Rule ID 61780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61780,
        GIR_EraseRootFromParent_Done,
      // Label 7331: @419136
      GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(419204), // Rule ID 61781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61781,
        GIR_EraseRootFromParent_Done,
      // Label 7332: @419204
      GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(419272), // Rule ID 61782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61782,
        GIR_EraseRootFromParent_Done,
      // Label 7333: @419272
      GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(419340), // Rule ID 61783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61783,
        GIR_EraseRootFromParent_Done,
      // Label 7334: @419340
      GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(419408), // Rule ID 61784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61784,
        GIR_EraseRootFromParent_Done,
      // Label 7335: @419408
      GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(419476), // Rule ID 61785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61785,
        GIR_EraseRootFromParent_Done,
      // Label 7336: @419476
      GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(419544), // Rule ID 61786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61786,
        GIR_EraseRootFromParent_Done,
      // Label 7337: @419544
      GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(419612), // Rule ID 61787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61787,
        GIR_EraseRootFromParent_Done,
      // Label 7338: @419612
      GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(419680), // Rule ID 61788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61788,
        GIR_EraseRootFromParent_Done,
      // Label 7339: @419680
      GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(419748), // Rule ID 61789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61789,
        GIR_EraseRootFromParent_Done,
      // Label 7340: @419748
      GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(419816), // Rule ID 61790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61790,
        GIR_EraseRootFromParent_Done,
      // Label 7341: @419816
      GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(419884), // Rule ID 61791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61791,
        GIR_EraseRootFromParent_Done,
      // Label 7342: @419884
      GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(419952), // Rule ID 61792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61792,
        GIR_EraseRootFromParent_Done,
      // Label 7343: @419952
      GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(420020), // Rule ID 61793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61793,
        GIR_EraseRootFromParent_Done,
      // Label 7344: @420020
      GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(420088), // Rule ID 61794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61794,
        GIR_EraseRootFromParent_Done,
      // Label 7345: @420088
      GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(420156), // Rule ID 61795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61795,
        GIR_EraseRootFromParent_Done,
      // Label 7346: @420156
      GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(420224), // Rule ID 61796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61796,
        GIR_EraseRootFromParent_Done,
      // Label 7347: @420224
      GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(420292), // Rule ID 61797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61797,
        GIR_EraseRootFromParent_Done,
      // Label 7348: @420292
      GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(420360), // Rule ID 61798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61798,
        GIR_EraseRootFromParent_Done,
      // Label 7349: @420360
      GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(420428), // Rule ID 61799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61799,
        GIR_EraseRootFromParent_Done,
      // Label 7350: @420428
      GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(420496), // Rule ID 61800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61800,
        GIR_EraseRootFromParent_Done,
      // Label 7351: @420496
      GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(420564), // Rule ID 61801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61801,
        GIR_EraseRootFromParent_Done,
      // Label 7352: @420564
      GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(420632), // Rule ID 61802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61802,
        GIR_EraseRootFromParent_Done,
      // Label 7353: @420632
      GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(420700), // Rule ID 61803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61803,
        GIR_EraseRootFromParent_Done,
      // Label 7354: @420700
      GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(420768), // Rule ID 61804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61804,
        GIR_EraseRootFromParent_Done,
      // Label 7355: @420768
      GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(420836), // Rule ID 61805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/5, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61805,
        GIR_EraseRootFromParent_Done,
      // Label 7356: @420836
      GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(420907), // Rule ID 2564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2564,
        GIR_EraseRootFromParent_Done,
      // Label 7357: @420907
      GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(420978), // Rule ID 2565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2565,
        GIR_EraseRootFromParent_Done,
      // Label 7358: @420978
      GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(421049), // Rule ID 2600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2600,
        GIR_EraseRootFromParent_Done,
      // Label 7359: @421049
      GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(421120), // Rule ID 2601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2601,
        GIR_EraseRootFromParent_Done,
      // Label 7360: @421120
      GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(421191), // Rule ID 18850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18850,
        GIR_EraseRootFromParent_Done,
      // Label 7361: @421191
      GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(421262), // Rule ID 18851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18851,
        GIR_EraseRootFromParent_Done,
      // Label 7362: @421262
      GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(421333), // Rule ID 18854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18854,
        GIR_EraseRootFromParent_Done,
      // Label 7363: @421333
      GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(421404), // Rule ID 18855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18855,
        GIR_EraseRootFromParent_Done,
      // Label 7364: @421404
      GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(421475), // Rule ID 18858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18858,
        GIR_EraseRootFromParent_Done,
      // Label 7365: @421475
      GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(421546), // Rule ID 18859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10882:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18859,
        GIR_EraseRootFromParent_Done,
      // Label 7366: @421546
      GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(421617), // Rule ID 18862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10882:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18862,
        GIR_EraseRootFromParent_Done,
      // Label 7367: @421617
      GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(421688), // Rule ID 18863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10882:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18863,
        GIR_EraseRootFromParent_Done,
      // Label 7368: @421688
      GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(421759), // Rule ID 18866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18866,
        GIR_EraseRootFromParent_Done,
      // Label 7369: @421759
      GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(421830), // Rule ID 18867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10882:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18867,
        GIR_EraseRootFromParent_Done,
      // Label 7370: @421830
      GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(421901), // Rule ID 18870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18870,
        GIR_EraseRootFromParent_Done,
      // Label 7371: @421901
      GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(421972), // Rule ID 18871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18871,
        GIR_EraseRootFromParent_Done,
      // Label 7372: @421972
      GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(422043), // Rule ID 18874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18874,
        GIR_EraseRootFromParent_Done,
      // Label 7373: @422043
      GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(422114), // Rule ID 18875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18875,
        GIR_EraseRootFromParent_Done,
      // Label 7374: @422114
      GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(422185), // Rule ID 18878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18878,
        GIR_EraseRootFromParent_Done,
      // Label 7375: @422185
      GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(422256), // Rule ID 18879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18879,
        GIR_EraseRootFromParent_Done,
      // Label 7376: @422256
      GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(422327), // Rule ID 18882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18882,
        GIR_EraseRootFromParent_Done,
      // Label 7377: @422327
      GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(422398), // Rule ID 18883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18883,
        GIR_EraseRootFromParent_Done,
      // Label 7378: @422398
      GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(422469), // Rule ID 18886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18886,
        GIR_EraseRootFromParent_Done,
      // Label 7379: @422469
      GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(422540), // Rule ID 18887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18887,
        GIR_EraseRootFromParent_Done,
      // Label 7380: @422540
      GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(422611), // Rule ID 18890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18890,
        GIR_EraseRootFromParent_Done,
      // Label 7381: @422611
      GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(422682), // Rule ID 18891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18891,
        GIR_EraseRootFromParent_Done,
      // Label 7382: @422682
      GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(422753), // Rule ID 18894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18894,
        GIR_EraseRootFromParent_Done,
      // Label 7383: @422753
      GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(422824), // Rule ID 18895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10882:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18895,
        GIR_EraseRootFromParent_Done,
      // Label 7384: @422824
      GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(422895), // Rule ID 18898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18898,
        GIR_EraseRootFromParent_Done,
      // Label 7385: @422895
      GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(422966), // Rule ID 18899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10882:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18899,
        GIR_EraseRootFromParent_Done,
      // Label 7386: @422966
      GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(423037), // Rule ID 18902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18902,
        GIR_EraseRootFromParent_Done,
      // Label 7387: @423037
      GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(423108), // Rule ID 18903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10882:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18903,
        GIR_EraseRootFromParent_Done,
      // Label 7388: @423108
      GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(423179), // Rule ID 18962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18962,
        GIR_EraseRootFromParent_Done,
      // Label 7389: @423179
      GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(423250), // Rule ID 18963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18963,
        GIR_EraseRootFromParent_Done,
      // Label 7390: @423250
      GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(423321), // Rule ID 18966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18966,
        GIR_EraseRootFromParent_Done,
      // Label 7391: @423321
      GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(423392), // Rule ID 18967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18967,
        GIR_EraseRootFromParent_Done,
      // Label 7392: @423392
      GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(423463), // Rule ID 18970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18970,
        GIR_EraseRootFromParent_Done,
      // Label 7393: @423463
      GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(423534), // Rule ID 18971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18971,
        GIR_EraseRootFromParent_Done,
      // Label 7394: @423534
      GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(423605), // Rule ID 18974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18974,
        GIR_EraseRootFromParent_Done,
      // Label 7395: @423605
      GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(423676), // Rule ID 18975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10858:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18975,
        GIR_EraseRootFromParent_Done,
      // Label 7396: @423676
      GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(423747), // Rule ID 18978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18978,
        GIR_EraseRootFromParent_Done,
      // Label 7397: @423747
      GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(423818), // Rule ID 18979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10858:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18979,
        GIR_EraseRootFromParent_Done,
      // Label 7398: @423818
      GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(423889), // Rule ID 18982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18982,
        GIR_EraseRootFromParent_Done,
      // Label 7399: @423889
      GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(423960), // Rule ID 18983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10858:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18983,
        GIR_EraseRootFromParent_Done,
      // Label 7400: @423960
      GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(424031), // Rule ID 18986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18986,
        GIR_EraseRootFromParent_Done,
      // Label 7401: @424031
      GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(424102), // Rule ID 18987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18987,
        GIR_EraseRootFromParent_Done,
      // Label 7402: @424102
      GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(424173), // Rule ID 18990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18990,
        GIR_EraseRootFromParent_Done,
      // Label 7403: @424173
      GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(424244), // Rule ID 18991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18991,
        GIR_EraseRootFromParent_Done,
      // Label 7404: @424244
      GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(424315), // Rule ID 18994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18994,
        GIR_EraseRootFromParent_Done,
      // Label 7405: @424315
      GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(424386), // Rule ID 18995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18995,
        GIR_EraseRootFromParent_Done,
      // Label 7406: @424386
      GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(424457), // Rule ID 18998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18998,
        GIR_EraseRootFromParent_Done,
      // Label 7407: @424457
      GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(424528), // Rule ID 18999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18999,
        GIR_EraseRootFromParent_Done,
      // Label 7408: @424528
      GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(424599), // Rule ID 19002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19002,
        GIR_EraseRootFromParent_Done,
      // Label 7409: @424599
      GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(424670), // Rule ID 19003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19003,
        GIR_EraseRootFromParent_Done,
      // Label 7410: @424670
      GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(424741), // Rule ID 19006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19006,
        GIR_EraseRootFromParent_Done,
      // Label 7411: @424741
      GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(424812), // Rule ID 19007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19007,
        GIR_EraseRootFromParent_Done,
      // Label 7412: @424812
      GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(424883), // Rule ID 19010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19010,
        GIR_EraseRootFromParent_Done,
      // Label 7413: @424883
      GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(424954), // Rule ID 19011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10858:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19011,
        GIR_EraseRootFromParent_Done,
      // Label 7414: @424954
      GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(425025), // Rule ID 19014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19014,
        GIR_EraseRootFromParent_Done,
      // Label 7415: @425025
      GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(425096), // Rule ID 19015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10858:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19015,
        GIR_EraseRootFromParent_Done,
      // Label 7416: @425096
      GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(425167), // Rule ID 19018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19018,
        GIR_EraseRootFromParent_Done,
      // Label 7417: @425167
      GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(425238), // Rule ID 19019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10858:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19019,
        GIR_EraseRootFromParent_Done,
      // Label 7418: @425238
      GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(425309), // Rule ID 20604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20604,
        GIR_EraseRootFromParent_Done,
      // Label 7419: @425309
      GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(425380), // Rule ID 20605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20605,
        GIR_EraseRootFromParent_Done,
      // Label 7420: @425380
      GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(425451), // Rule ID 20608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20608,
        GIR_EraseRootFromParent_Done,
      // Label 7421: @425451
      GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(425522), // Rule ID 20609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20609,
        GIR_EraseRootFromParent_Done,
      // Label 7422: @425522
      GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(425593), // Rule ID 20612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20612,
        GIR_EraseRootFromParent_Done,
      // Label 7423: @425593
      GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(425664), // Rule ID 20613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10804:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20613,
        GIR_EraseRootFromParent_Done,
      // Label 7424: @425664
      GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(425735), // Rule ID 20616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10804:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20616,
        GIR_EraseRootFromParent_Done,
      // Label 7425: @425735
      GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(425806), // Rule ID 20617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10804:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20617,
        GIR_EraseRootFromParent_Done,
      // Label 7426: @425806
      GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(425877), // Rule ID 20620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20620,
        GIR_EraseRootFromParent_Done,
      // Label 7427: @425877
      GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(425948), // Rule ID 20621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10804:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20621,
        GIR_EraseRootFromParent_Done,
      // Label 7428: @425948
      GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(426019), // Rule ID 20624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20624,
        GIR_EraseRootFromParent_Done,
      // Label 7429: @426019
      GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(426090), // Rule ID 20625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20625,
        GIR_EraseRootFromParent_Done,
      // Label 7430: @426090
      GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(426161), // Rule ID 20628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20628,
        GIR_EraseRootFromParent_Done,
      // Label 7431: @426161
      GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(426232), // Rule ID 20629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20629,
        GIR_EraseRootFromParent_Done,
      // Label 7432: @426232
      GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(426303), // Rule ID 20632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20632,
        GIR_EraseRootFromParent_Done,
      // Label 7433: @426303
      GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(426374), // Rule ID 20633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20633,
        GIR_EraseRootFromParent_Done,
      // Label 7434: @426374
      GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(426445), // Rule ID 20636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20636,
        GIR_EraseRootFromParent_Done,
      // Label 7435: @426445
      GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(426516), // Rule ID 20637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20637,
        GIR_EraseRootFromParent_Done,
      // Label 7436: @426516
      GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(426587), // Rule ID 20640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20640,
        GIR_EraseRootFromParent_Done,
      // Label 7437: @426587
      GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(426658), // Rule ID 20641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20641,
        GIR_EraseRootFromParent_Done,
      // Label 7438: @426658
      GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(426729), // Rule ID 20644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20644,
        GIR_EraseRootFromParent_Done,
      // Label 7439: @426729
      GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(426800), // Rule ID 20645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20645,
        GIR_EraseRootFromParent_Done,
      // Label 7440: @426800
      GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(426871), // Rule ID 20648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20648,
        GIR_EraseRootFromParent_Done,
      // Label 7441: @426871
      GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(426942), // Rule ID 20649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10804:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20649,
        GIR_EraseRootFromParent_Done,
      // Label 7442: @426942
      GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(427013), // Rule ID 20652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20652,
        GIR_EraseRootFromParent_Done,
      // Label 7443: @427013
      GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(427084), // Rule ID 20653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10804:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20653,
        GIR_EraseRootFromParent_Done,
      // Label 7444: @427084
      GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(427155), // Rule ID 20656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20656,
        GIR_EraseRootFromParent_Done,
      // Label 7445: @427155
      GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(427226), // Rule ID 20657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10804:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20657,
        GIR_EraseRootFromParent_Done,
      // Label 7446: @427226
      GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(427297), // Rule ID 20660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20660,
        GIR_EraseRootFromParent_Done,
      // Label 7447: @427297
      GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(427368), // Rule ID 20661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20661,
        GIR_EraseRootFromParent_Done,
      // Label 7448: @427368
      GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(427439), // Rule ID 20664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20664,
        GIR_EraseRootFromParent_Done,
      // Label 7449: @427439
      GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(427510), // Rule ID 20665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20665,
        GIR_EraseRootFromParent_Done,
      // Label 7450: @427510
      GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(427581), // Rule ID 20668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20668,
        GIR_EraseRootFromParent_Done,
      // Label 7451: @427581
      GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(427652), // Rule ID 20669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20669,
        GIR_EraseRootFromParent_Done,
      // Label 7452: @427652
      GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(427723), // Rule ID 20672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20672,
        GIR_EraseRootFromParent_Done,
      // Label 7453: @427723
      GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(427794), // Rule ID 20673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10806:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20673,
        GIR_EraseRootFromParent_Done,
      // Label 7454: @427794
      GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(427865), // Rule ID 20676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10806:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20676,
        GIR_EraseRootFromParent_Done,
      // Label 7455: @427865
      GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(427936), // Rule ID 20677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10806:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20677,
        GIR_EraseRootFromParent_Done,
      // Label 7456: @427936
      GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(428007), // Rule ID 20680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20680,
        GIR_EraseRootFromParent_Done,
      // Label 7457: @428007
      GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(428078), // Rule ID 20681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10806:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20681,
        GIR_EraseRootFromParent_Done,
      // Label 7458: @428078
      GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(428149), // Rule ID 20684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20684,
        GIR_EraseRootFromParent_Done,
      // Label 7459: @428149
      GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(428220), // Rule ID 20685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20685,
        GIR_EraseRootFromParent_Done,
      // Label 7460: @428220
      GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(428291), // Rule ID 20688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20688,
        GIR_EraseRootFromParent_Done,
      // Label 7461: @428291
      GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(428362), // Rule ID 20689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20689,
        GIR_EraseRootFromParent_Done,
      // Label 7462: @428362
      GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(428433), // Rule ID 20692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20692,
        GIR_EraseRootFromParent_Done,
      // Label 7463: @428433
      GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(428504), // Rule ID 20693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20693,
        GIR_EraseRootFromParent_Done,
      // Label 7464: @428504
      GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(428575), // Rule ID 20696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20696,
        GIR_EraseRootFromParent_Done,
      // Label 7465: @428575
      GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(428646), // Rule ID 20697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20697,
        GIR_EraseRootFromParent_Done,
      // Label 7466: @428646
      GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(428717), // Rule ID 20700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20700,
        GIR_EraseRootFromParent_Done,
      // Label 7467: @428717
      GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(428788), // Rule ID 20701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20701,
        GIR_EraseRootFromParent_Done,
      // Label 7468: @428788
      GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(428859), // Rule ID 20704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20704,
        GIR_EraseRootFromParent_Done,
      // Label 7469: @428859
      GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(428930), // Rule ID 20705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20705,
        GIR_EraseRootFromParent_Done,
      // Label 7470: @428930
      GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(429001), // Rule ID 20708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20708,
        GIR_EraseRootFromParent_Done,
      // Label 7471: @429001
      GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(429072), // Rule ID 20709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10806:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20709,
        GIR_EraseRootFromParent_Done,
      // Label 7472: @429072
      GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(429143), // Rule ID 20712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20712,
        GIR_EraseRootFromParent_Done,
      // Label 7473: @429143
      GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(429214), // Rule ID 20713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10806:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20713,
        GIR_EraseRootFromParent_Done,
      // Label 7474: @429214
      GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(429285), // Rule ID 20716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20716,
        GIR_EraseRootFromParent_Done,
      // Label 7475: @429285
      GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(429356), // Rule ID 20717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10806:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20717,
        GIR_EraseRootFromParent_Done,
      // Label 7476: @429356
      GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(429427), // Rule ID 20840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10796:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20840,
        GIR_EraseRootFromParent_Done,
      // Label 7477: @429427
      GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(429498), // Rule ID 20841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10796:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20841,
        GIR_EraseRootFromParent_Done,
      // Label 7478: @429498
      GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(429569), // Rule ID 20844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10796:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20844,
        GIR_EraseRootFromParent_Done,
      // Label 7479: @429569
      GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(429640), // Rule ID 20845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10796:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20845,
        GIR_EraseRootFromParent_Done,
      // Label 7480: @429640
      GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(429711), // Rule ID 20848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10796:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20848,
        GIR_EraseRootFromParent_Done,
      // Label 7481: @429711
      GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(429782), // Rule ID 20849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10796:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20849,
        GIR_EraseRootFromParent_Done,
      // Label 7482: @429782
      GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(429853), // Rule ID 20852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10796:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20852,
        GIR_EraseRootFromParent_Done,
      // Label 7483: @429853
      GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(429924), // Rule ID 20853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10796:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20853,
        GIR_EraseRootFromParent_Done,
      // Label 7484: @429924
      GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(429995), // Rule ID 20856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10796:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20856,
        GIR_EraseRootFromParent_Done,
      // Label 7485: @429995
      GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(430066), // Rule ID 20857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10796:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20857,
        GIR_EraseRootFromParent_Done,
      // Label 7486: @430066
      GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(430137), // Rule ID 20860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10796:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20860,
        GIR_EraseRootFromParent_Done,
      // Label 7487: @430137
      GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(430208), // Rule ID 20861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10796:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20861,
        GIR_EraseRootFromParent_Done,
      // Label 7488: @430208
      GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(430279), // Rule ID 20864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10796:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20864,
        GIR_EraseRootFromParent_Done,
      // Label 7489: @430279
      GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(430350), // Rule ID 20865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10796:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20865,
        GIR_EraseRootFromParent_Done,
      // Label 7490: @430350
      GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(430421), // Rule ID 20868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10796:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20868,
        GIR_EraseRootFromParent_Done,
      // Label 7491: @430421
      GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(430492), // Rule ID 20869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10796:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20869,
        GIR_EraseRootFromParent_Done,
      // Label 7492: @430492
      GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(430563), // Rule ID 20872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10796:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20872,
        GIR_EraseRootFromParent_Done,
      // Label 7493: @430563
      GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(430634), // Rule ID 20873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10796:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20873,
        GIR_EraseRootFromParent_Done,
      // Label 7494: @430634
      GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(430705), // Rule ID 20876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10796:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20876,
        GIR_EraseRootFromParent_Done,
      // Label 7495: @430705
      GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(430776), // Rule ID 20877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10796:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20877,
        GIR_EraseRootFromParent_Done,
      // Label 7496: @430776
      GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(430847), // Rule ID 20880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10796:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20880,
        GIR_EraseRootFromParent_Done,
      // Label 7497: @430847
      GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(430918), // Rule ID 20881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10796:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20881,
        GIR_EraseRootFromParent_Done,
      // Label 7498: @430918
      GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(430989), // Rule ID 20884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10796:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20884,
        GIR_EraseRootFromParent_Done,
      // Label 7499: @430989
      GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(431060), // Rule ID 20885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10796:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20885,
        GIR_EraseRootFromParent_Done,
      // Label 7500: @431060
      GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(431131), // Rule ID 20888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10796:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20888,
        GIR_EraseRootFromParent_Done,
      // Label 7501: @431131
      GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(431202), // Rule ID 20889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10796:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20889,
        GIR_EraseRootFromParent_Done,
      // Label 7502: @431202
      GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(431273), // Rule ID 20892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10796:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20892,
        GIR_EraseRootFromParent_Done,
      // Label 7503: @431273
      GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(431344), // Rule ID 20893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10796:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20893,
        GIR_EraseRootFromParent_Done,
      // Label 7504: @431344
      GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(431415), // Rule ID 20896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10796:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20896,
        GIR_EraseRootFromParent_Done,
      // Label 7505: @431415
      GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(431486), // Rule ID 20897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10796:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20897,
        GIR_EraseRootFromParent_Done,
      // Label 7506: @431486
      GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(431557), // Rule ID 20900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10798:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20900,
        GIR_EraseRootFromParent_Done,
      // Label 7507: @431557
      GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(431628), // Rule ID 20901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10798:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20901,
        GIR_EraseRootFromParent_Done,
      // Label 7508: @431628
      GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(431699), // Rule ID 20904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10798:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20904,
        GIR_EraseRootFromParent_Done,
      // Label 7509: @431699
      GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(431770), // Rule ID 20905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10798:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20905,
        GIR_EraseRootFromParent_Done,
      // Label 7510: @431770
      GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(431841), // Rule ID 20908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10798:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20908,
        GIR_EraseRootFromParent_Done,
      // Label 7511: @431841
      GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(431912), // Rule ID 20909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10798:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20909,
        GIR_EraseRootFromParent_Done,
      // Label 7512: @431912
      GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(431983), // Rule ID 20912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10798:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20912,
        GIR_EraseRootFromParent_Done,
      // Label 7513: @431983
      GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(432054), // Rule ID 20913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10798:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20913,
        GIR_EraseRootFromParent_Done,
      // Label 7514: @432054
      GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(432125), // Rule ID 20916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10798:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20916,
        GIR_EraseRootFromParent_Done,
      // Label 7515: @432125
      GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(432196), // Rule ID 20917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10798:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20917,
        GIR_EraseRootFromParent_Done,
      // Label 7516: @432196
      GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(432267), // Rule ID 20920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10798:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20920,
        GIR_EraseRootFromParent_Done,
      // Label 7517: @432267
      GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(432338), // Rule ID 20921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10798:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20921,
        GIR_EraseRootFromParent_Done,
      // Label 7518: @432338
      GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(432409), // Rule ID 20924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10798:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20924,
        GIR_EraseRootFromParent_Done,
      // Label 7519: @432409
      GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(432480), // Rule ID 20925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10798:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20925,
        GIR_EraseRootFromParent_Done,
      // Label 7520: @432480
      GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(432551), // Rule ID 20928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10798:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20928,
        GIR_EraseRootFromParent_Done,
      // Label 7521: @432551
      GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(432622), // Rule ID 20929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10798:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20929,
        GIR_EraseRootFromParent_Done,
      // Label 7522: @432622
      GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(432693), // Rule ID 20932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10798:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20932,
        GIR_EraseRootFromParent_Done,
      // Label 7523: @432693
      GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(432764), // Rule ID 20933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10798:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20933,
        GIR_EraseRootFromParent_Done,
      // Label 7524: @432764
      GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(432835), // Rule ID 20936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10798:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20936,
        GIR_EraseRootFromParent_Done,
      // Label 7525: @432835
      GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(432906), // Rule ID 20937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10798:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20937,
        GIR_EraseRootFromParent_Done,
      // Label 7526: @432906
      GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(432977), // Rule ID 20940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10798:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20940,
        GIR_EraseRootFromParent_Done,
      // Label 7527: @432977
      GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(433048), // Rule ID 20941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10798:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20941,
        GIR_EraseRootFromParent_Done,
      // Label 7528: @433048
      GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(433119), // Rule ID 20944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10798:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20944,
        GIR_EraseRootFromParent_Done,
      // Label 7529: @433119
      GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(433190), // Rule ID 20945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10798:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20945,
        GIR_EraseRootFromParent_Done,
      // Label 7530: @433190
      GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(433261), // Rule ID 20948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10798:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20948,
        GIR_EraseRootFromParent_Done,
      // Label 7531: @433261
      GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(433332), // Rule ID 20949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10798:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20949,
        GIR_EraseRootFromParent_Done,
      // Label 7532: @433332
      GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(433403), // Rule ID 20952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10798:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20952,
        GIR_EraseRootFromParent_Done,
      // Label 7533: @433403
      GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(433474), // Rule ID 20953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10798:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20953,
        GIR_EraseRootFromParent_Done,
      // Label 7534: @433474
      GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(433545), // Rule ID 20956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10798:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20956,
        GIR_EraseRootFromParent_Done,
      // Label 7535: @433545
      GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(433616), // Rule ID 20957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10798:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20957,
        GIR_EraseRootFromParent_Done,
      // Label 7536: @433616
      GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(433687), // Rule ID 21032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21032,
        GIR_EraseRootFromParent_Done,
      // Label 7537: @433687
      GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(433758), // Rule ID 21033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21033,
        GIR_EraseRootFromParent_Done,
      // Label 7538: @433758
      GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(433829), // Rule ID 21036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21036,
        GIR_EraseRootFromParent_Done,
      // Label 7539: @433829
      GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(433900), // Rule ID 21037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10902:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21037,
        GIR_EraseRootFromParent_Done,
      // Label 7540: @433900
      GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(433971), // Rule ID 21040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21040,
        GIR_EraseRootFromParent_Done,
      // Label 7541: @433971
      GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(434042), // Rule ID 21041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21041,
        GIR_EraseRootFromParent_Done,
      // Label 7542: @434042
      GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(434113), // Rule ID 21044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21044,
        GIR_EraseRootFromParent_Done,
      // Label 7543: @434113
      GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(434184), // Rule ID 21045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21045,
        GIR_EraseRootFromParent_Done,
      // Label 7544: @434184
      GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(434255), // Rule ID 21048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21048,
        GIR_EraseRootFromParent_Done,
      // Label 7545: @434255
      GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(434326), // Rule ID 21049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21049,
        GIR_EraseRootFromParent_Done,
      // Label 7546: @434326
      GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(434397), // Rule ID 21052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21052,
        GIR_EraseRootFromParent_Done,
      // Label 7547: @434397
      GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(434468), // Rule ID 21053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10902:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21053,
        GIR_EraseRootFromParent_Done,
      // Label 7548: @434468
      GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(434539), // Rule ID 21056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21056,
        GIR_EraseRootFromParent_Done,
      // Label 7549: @434539
      GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(434610), // Rule ID 21057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10902:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21057,
        GIR_EraseRootFromParent_Done,
      // Label 7550: @434610
      GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(434681), // Rule ID 21060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21060,
        GIR_EraseRootFromParent_Done,
      // Label 7551: @434681
      GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(434752), // Rule ID 21061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10902:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21061,
        GIR_EraseRootFromParent_Done,
      // Label 7552: @434752
      GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(434823), // Rule ID 21064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21064,
        GIR_EraseRootFromParent_Done,
      // Label 7553: @434823
      GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(434894), // Rule ID 21065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10902:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21065,
        GIR_EraseRootFromParent_Done,
      // Label 7554: @434894
      GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(434965), // Rule ID 21068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21068,
        GIR_EraseRootFromParent_Done,
      // Label 7555: @434965
      GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(435036), // Rule ID 21069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21069,
        GIR_EraseRootFromParent_Done,
      // Label 7556: @435036
      GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(435107), // Rule ID 21072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21072,
        GIR_EraseRootFromParent_Done,
      // Label 7557: @435107
      GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(435178), // Rule ID 21073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10900:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21073,
        GIR_EraseRootFromParent_Done,
      // Label 7558: @435178
      GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(435249), // Rule ID 21076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21076,
        GIR_EraseRootFromParent_Done,
      // Label 7559: @435249
      GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(435320), // Rule ID 21077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21077,
        GIR_EraseRootFromParent_Done,
      // Label 7560: @435320
      GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(435391), // Rule ID 21080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21080,
        GIR_EraseRootFromParent_Done,
      // Label 7561: @435391
      GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(435462), // Rule ID 21081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21081,
        GIR_EraseRootFromParent_Done,
      // Label 7562: @435462
      GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(435533), // Rule ID 21084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21084,
        GIR_EraseRootFromParent_Done,
      // Label 7563: @435533
      GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(435604), // Rule ID 21085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21085,
        GIR_EraseRootFromParent_Done,
      // Label 7564: @435604
      GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(435675), // Rule ID 21088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21088,
        GIR_EraseRootFromParent_Done,
      // Label 7565: @435675
      GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(435746), // Rule ID 21089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10900:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21089,
        GIR_EraseRootFromParent_Done,
      // Label 7566: @435746
      GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(435817), // Rule ID 21092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21092,
        GIR_EraseRootFromParent_Done,
      // Label 7567: @435817
      GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(435888), // Rule ID 21093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10900:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21093,
        GIR_EraseRootFromParent_Done,
      // Label 7568: @435888
      GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(435959), // Rule ID 21096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21096,
        GIR_EraseRootFromParent_Done,
      // Label 7569: @435959
      GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(436030), // Rule ID 21097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10900:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21097,
        GIR_EraseRootFromParent_Done,
      // Label 7570: @436030
      GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(436101), // Rule ID 21100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21100,
        GIR_EraseRootFromParent_Done,
      // Label 7571: @436101
      GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(436172), // Rule ID 21101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10900:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21101,
        GIR_EraseRootFromParent_Done,
      // Label 7572: @436172
      GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(436243), // Rule ID 21452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21452,
        GIR_EraseRootFromParent_Done,
      // Label 7573: @436243
      GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(436314), // Rule ID 21453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21453,
        GIR_EraseRootFromParent_Done,
      // Label 7574: @436314
      GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(436385), // Rule ID 21456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21456,
        GIR_EraseRootFromParent_Done,
      // Label 7575: @436385
      GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(436456), // Rule ID 21457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21457,
        GIR_EraseRootFromParent_Done,
      // Label 7576: @436456
      GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(436527), // Rule ID 21460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21460,
        GIR_EraseRootFromParent_Done,
      // Label 7577: @436527
      GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(436598), // Rule ID 21461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21461,
        GIR_EraseRootFromParent_Done,
      // Label 7578: @436598
      GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(436669), // Rule ID 21464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21464,
        GIR_EraseRootFromParent_Done,
      // Label 7579: @436669
      GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(436740), // Rule ID 21465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10844:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21465,
        GIR_EraseRootFromParent_Done,
      // Label 7580: @436740
      GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(436811), // Rule ID 21468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21468,
        GIR_EraseRootFromParent_Done,
      // Label 7581: @436811
      GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(436882), // Rule ID 21469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21469,
        GIR_EraseRootFromParent_Done,
      // Label 7582: @436882
      GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(436953), // Rule ID 21472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21472,
        GIR_EraseRootFromParent_Done,
      // Label 7583: @436953
      GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(437024), // Rule ID 21473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21473,
        GIR_EraseRootFromParent_Done,
      // Label 7584: @437024
      GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(437095), // Rule ID 21476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21476,
        GIR_EraseRootFromParent_Done,
      // Label 7585: @437095
      GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(437166), // Rule ID 21477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21477,
        GIR_EraseRootFromParent_Done,
      // Label 7586: @437166
      GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(437237), // Rule ID 21480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21480,
        GIR_EraseRootFromParent_Done,
      // Label 7587: @437237
      GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(437308), // Rule ID 21481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21481,
        GIR_EraseRootFromParent_Done,
      // Label 7588: @437308
      GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(437379), // Rule ID 21484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21484,
        GIR_EraseRootFromParent_Done,
      // Label 7589: @437379
      GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(437450), // Rule ID 21485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10844:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21485,
        GIR_EraseRootFromParent_Done,
      // Label 7590: @437450
      GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(437521), // Rule ID 21488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21488,
        GIR_EraseRootFromParent_Done,
      // Label 7591: @437521
      GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(437592), // Rule ID 21489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21489,
        GIR_EraseRootFromParent_Done,
      // Label 7592: @437592
      GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(437663), // Rule ID 21492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21492,
        GIR_EraseRootFromParent_Done,
      // Label 7593: @437663
      GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(437734), // Rule ID 21493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21493,
        GIR_EraseRootFromParent_Done,
      // Label 7594: @437734
      GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(437805), // Rule ID 21496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21496,
        GIR_EraseRootFromParent_Done,
      // Label 7595: @437805
      GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(437876), // Rule ID 21497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21497,
        GIR_EraseRootFromParent_Done,
      // Label 7596: @437876
      GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(437947), // Rule ID 21500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21500,
        GIR_EraseRootFromParent_Done,
      // Label 7597: @437947
      GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(438018), // Rule ID 21501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10844:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21501,
        GIR_EraseRootFromParent_Done,
      // Label 7598: @438018
      GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(438089), // Rule ID 21504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21504,
        GIR_EraseRootFromParent_Done,
      // Label 7599: @438089
      GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(438160), // Rule ID 21505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10844:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21505,
        GIR_EraseRootFromParent_Done,
      // Label 7600: @438160
      GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(438231), // Rule ID 21508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21508,
        GIR_EraseRootFromParent_Done,
      // Label 7601: @438231
      GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(438302), // Rule ID 21509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10844:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21509,
        GIR_EraseRootFromParent_Done,
      // Label 7602: @438302
      GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(438373), // Rule ID 21512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21512,
        GIR_EraseRootFromParent_Done,
      // Label 7603: @438373
      GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(438444), // Rule ID 21513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21513,
        GIR_EraseRootFromParent_Done,
      // Label 7604: @438444
      GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(438515), // Rule ID 21516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21516,
        GIR_EraseRootFromParent_Done,
      // Label 7605: @438515
      GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(438586), // Rule ID 21517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21517,
        GIR_EraseRootFromParent_Done,
      // Label 7606: @438586
      GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(438657), // Rule ID 21520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21520,
        GIR_EraseRootFromParent_Done,
      // Label 7607: @438657
      GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(438728), // Rule ID 21521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21521,
        GIR_EraseRootFromParent_Done,
      // Label 7608: @438728
      GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(438799), // Rule ID 21524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21524,
        GIR_EraseRootFromParent_Done,
      // Label 7609: @438799
      GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(438870), // Rule ID 21525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10842:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21525,
        GIR_EraseRootFromParent_Done,
      // Label 7610: @438870
      GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(438941), // Rule ID 21528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21528,
        GIR_EraseRootFromParent_Done,
      // Label 7611: @438941
      GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(439012), // Rule ID 21529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21529,
        GIR_EraseRootFromParent_Done,
      // Label 7612: @439012
      GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(439083), // Rule ID 21532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21532,
        GIR_EraseRootFromParent_Done,
      // Label 7613: @439083
      GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(439154), // Rule ID 21533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21533,
        GIR_EraseRootFromParent_Done,
      // Label 7614: @439154
      GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(439225), // Rule ID 21536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21536,
        GIR_EraseRootFromParent_Done,
      // Label 7615: @439225
      GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(439296), // Rule ID 21537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21537,
        GIR_EraseRootFromParent_Done,
      // Label 7616: @439296
      GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(439367), // Rule ID 21540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21540,
        GIR_EraseRootFromParent_Done,
      // Label 7617: @439367
      GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(439438), // Rule ID 21541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21541,
        GIR_EraseRootFromParent_Done,
      // Label 7618: @439438
      GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(439509), // Rule ID 21544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21544,
        GIR_EraseRootFromParent_Done,
      // Label 7619: @439509
      GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(439580), // Rule ID 21545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10842:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21545,
        GIR_EraseRootFromParent_Done,
      // Label 7620: @439580
      GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(439651), // Rule ID 21548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21548,
        GIR_EraseRootFromParent_Done,
      // Label 7621: @439651
      GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(439722), // Rule ID 21549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21549,
        GIR_EraseRootFromParent_Done,
      // Label 7622: @439722
      GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(439793), // Rule ID 21552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21552,
        GIR_EraseRootFromParent_Done,
      // Label 7623: @439793
      GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(439864), // Rule ID 21553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21553,
        GIR_EraseRootFromParent_Done,
      // Label 7624: @439864
      GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(439935), // Rule ID 21556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21556,
        GIR_EraseRootFromParent_Done,
      // Label 7625: @439935
      GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(440006), // Rule ID 21557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21557,
        GIR_EraseRootFromParent_Done,
      // Label 7626: @440006
      GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(440077), // Rule ID 21560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21560,
        GIR_EraseRootFromParent_Done,
      // Label 7627: @440077
      GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(440148), // Rule ID 21561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10842:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21561,
        GIR_EraseRootFromParent_Done,
      // Label 7628: @440148
      GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(440219), // Rule ID 21564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21564,
        GIR_EraseRootFromParent_Done,
      // Label 7629: @440219
      GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(440290), // Rule ID 21565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10842:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21565,
        GIR_EraseRootFromParent_Done,
      // Label 7630: @440290
      GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(440361), // Rule ID 21568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21568,
        GIR_EraseRootFromParent_Done,
      // Label 7631: @440361
      GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(440432), // Rule ID 21569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10842:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21569,
        GIR_EraseRootFromParent_Done,
      // Label 7632: @440432
      GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(440503), // Rule ID 21692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21692,
        GIR_EraseRootFromParent_Done,
      // Label 7633: @440503
      GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(440574), // Rule ID 21693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21693,
        GIR_EraseRootFromParent_Done,
      // Label 7634: @440574
      GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(440645), // Rule ID 21696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21696,
        GIR_EraseRootFromParent_Done,
      // Label 7635: @440645
      GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(440716), // Rule ID 21697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21697,
        GIR_EraseRootFromParent_Done,
      // Label 7636: @440716
      GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(440787), // Rule ID 21700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21700,
        GIR_EraseRootFromParent_Done,
      // Label 7637: @440787
      GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(440858), // Rule ID 21701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10834:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21701,
        GIR_EraseRootFromParent_Done,
      // Label 7638: @440858
      GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(440929), // Rule ID 21704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21704,
        GIR_EraseRootFromParent_Done,
      // Label 7639: @440929
      GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(441000), // Rule ID 21705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21705,
        GIR_EraseRootFromParent_Done,
      // Label 7640: @441000
      GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(441071), // Rule ID 21708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21708,
        GIR_EraseRootFromParent_Done,
      // Label 7641: @441071
      GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(441142), // Rule ID 21709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21709,
        GIR_EraseRootFromParent_Done,
      // Label 7642: @441142
      GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(441213), // Rule ID 21712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21712,
        GIR_EraseRootFromParent_Done,
      // Label 7643: @441213
      GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(441284), // Rule ID 21713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21713,
        GIR_EraseRootFromParent_Done,
      // Label 7644: @441284
      GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(441355), // Rule ID 21716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21716,
        GIR_EraseRootFromParent_Done,
      // Label 7645: @441355
      GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(441426), // Rule ID 21717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10834:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21717,
        GIR_EraseRootFromParent_Done,
      // Label 7646: @441426
      GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(441497), // Rule ID 21720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21720,
        GIR_EraseRootFromParent_Done,
      // Label 7647: @441497
      GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(441568), // Rule ID 21721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10834:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21721,
        GIR_EraseRootFromParent_Done,
      // Label 7648: @441568
      GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(441639), // Rule ID 21724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21724,
        GIR_EraseRootFromParent_Done,
      // Label 7649: @441639
      GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(441710), // Rule ID 21725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10834:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21725,
        GIR_EraseRootFromParent_Done,
      // Label 7650: @441710
      GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(441781), // Rule ID 21728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21728,
        GIR_EraseRootFromParent_Done,
      // Label 7651: @441781
      GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(441852), // Rule ID 21729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21729,
        GIR_EraseRootFromParent_Done,
      // Label 7652: @441852
      GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(441923), // Rule ID 21732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21732,
        GIR_EraseRootFromParent_Done,
      // Label 7653: @441923
      GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(441994), // Rule ID 21733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21733,
        GIR_EraseRootFromParent_Done,
      // Label 7654: @441994
      GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(442065), // Rule ID 21736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21736,
        GIR_EraseRootFromParent_Done,
      // Label 7655: @442065
      GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(442136), // Rule ID 21737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10832:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21737,
        GIR_EraseRootFromParent_Done,
      // Label 7656: @442136
      GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(442207), // Rule ID 21740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21740,
        GIR_EraseRootFromParent_Done,
      // Label 7657: @442207
      GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(442278), // Rule ID 21741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21741,
        GIR_EraseRootFromParent_Done,
      // Label 7658: @442278
      GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(442349), // Rule ID 21744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21744,
        GIR_EraseRootFromParent_Done,
      // Label 7659: @442349
      GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(442420), // Rule ID 21745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21745,
        GIR_EraseRootFromParent_Done,
      // Label 7660: @442420
      GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(442491), // Rule ID 21748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21748,
        GIR_EraseRootFromParent_Done,
      // Label 7661: @442491
      GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(442562), // Rule ID 21749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21749,
        GIR_EraseRootFromParent_Done,
      // Label 7662: @442562
      GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(442633), // Rule ID 21752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21752,
        GIR_EraseRootFromParent_Done,
      // Label 7663: @442633
      GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(442704), // Rule ID 21753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10832:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21753,
        GIR_EraseRootFromParent_Done,
      // Label 7664: @442704
      GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(442775), // Rule ID 21756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21756,
        GIR_EraseRootFromParent_Done,
      // Label 7665: @442775
      GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(442846), // Rule ID 21757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10832:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21757,
        GIR_EraseRootFromParent_Done,
      // Label 7666: @442846
      GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(442917), // Rule ID 21760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21760,
        GIR_EraseRootFromParent_Done,
      // Label 7667: @442917
      GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(442988), // Rule ID 21761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10832:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21761,
        GIR_EraseRootFromParent_Done,
      // Label 7668: @442988
      GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(443059), // Rule ID 21764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21764,
        GIR_EraseRootFromParent_Done,
      // Label 7669: @443059
      GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(443130), // Rule ID 21765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21765,
        GIR_EraseRootFromParent_Done,
      // Label 7670: @443130
      GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(443201), // Rule ID 21768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21768,
        GIR_EraseRootFromParent_Done,
      // Label 7671: @443201
      GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(443272), // Rule ID 21769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21769,
        GIR_EraseRootFromParent_Done,
      // Label 7672: @443272
      GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(443343), // Rule ID 21772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21772,
        GIR_EraseRootFromParent_Done,
      // Label 7673: @443343
      GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(443414), // Rule ID 21773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21773,
        GIR_EraseRootFromParent_Done,
      // Label 7674: @443414
      GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(443485), // Rule ID 21776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21776,
        GIR_EraseRootFromParent_Done,
      // Label 7675: @443485
      GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(443556), // Rule ID 21777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21777,
        GIR_EraseRootFromParent_Done,
      // Label 7676: @443556
      GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(443627), // Rule ID 21780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21780,
        GIR_EraseRootFromParent_Done,
      // Label 7677: @443627
      GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(443698), // Rule ID 21781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21781,
        GIR_EraseRootFromParent_Done,
      // Label 7678: @443698
      GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(443769), // Rule ID 21784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21784,
        GIR_EraseRootFromParent_Done,
      // Label 7679: @443769
      GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(443840), // Rule ID 21785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21785,
        GIR_EraseRootFromParent_Done,
      // Label 7680: @443840
      GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(443911), // Rule ID 21788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21788,
        GIR_EraseRootFromParent_Done,
      // Label 7681: @443911
      GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(443982), // Rule ID 21789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10830:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21789,
        GIR_EraseRootFromParent_Done,
      // Label 7682: @443982
      GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(444053), // Rule ID 21792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21792,
        GIR_EraseRootFromParent_Done,
      // Label 7683: @444053
      GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(444124), // Rule ID 21793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10830:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21793,
        GIR_EraseRootFromParent_Done,
      // Label 7684: @444124
      GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(444195), // Rule ID 21796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21796,
        GIR_EraseRootFromParent_Done,
      // Label 7685: @444195
      GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(444266), // Rule ID 21797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10830:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/4, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21797,
        GIR_EraseRootFromParent_Done,
      // Label 7686: @444266
      GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(444337), // Rule ID 2614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2614,
        GIR_EraseRootFromParent_Done,
      // Label 7687: @444337
      GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(444408), // Rule ID 2615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2615,
        GIR_EraseRootFromParent_Done,
      // Label 7688: @444408
      GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(444479), // Rule ID 3922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3922,
        GIR_EraseRootFromParent_Done,
      // Label 7689: @444479
      GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(444550), // Rule ID 3923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3923,
        GIR_EraseRootFromParent_Done,
      // Label 7690: @444550
      GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(444621), // Rule ID 3932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3932,
        GIR_EraseRootFromParent_Done,
      // Label 7691: @444621
      GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(444692), // Rule ID 3933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3933,
        GIR_EraseRootFromParent_Done,
      // Label 7692: @444692
      GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(444763), // Rule ID 3942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3942,
        GIR_EraseRootFromParent_Done,
      // Label 7693: @444763
      GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(444834), // Rule ID 3943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3943,
        GIR_EraseRootFromParent_Done,
      // Label 7694: @444834
      GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(444905), // Rule ID 3952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3952,
        GIR_EraseRootFromParent_Done,
      // Label 7695: @444905
      GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(444976), // Rule ID 3953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3953,
        GIR_EraseRootFromParent_Done,
      // Label 7696: @444976
      GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(445047), // Rule ID 3962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3962,
        GIR_EraseRootFromParent_Done,
      // Label 7697: @445047
      GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(445118), // Rule ID 3963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3963,
        GIR_EraseRootFromParent_Done,
      // Label 7698: @445118
      GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(445189), // Rule ID 3972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3972,
        GIR_EraseRootFromParent_Done,
      // Label 7699: @445189
      GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(445260), // Rule ID 3973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3973,
        GIR_EraseRootFromParent_Done,
      // Label 7700: @445260
      GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(445331), // Rule ID 3982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3982,
        GIR_EraseRootFromParent_Done,
      // Label 7701: @445331
      GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(445402), // Rule ID 3983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3983,
        GIR_EraseRootFromParent_Done,
      // Label 7702: @445402
      GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(445473), // Rule ID 3992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3992,
        GIR_EraseRootFromParent_Done,
      // Label 7703: @445473
      GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(445544), // Rule ID 3993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3993,
        GIR_EraseRootFromParent_Done,
      // Label 7704: @445544
      GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(445615), // Rule ID 4002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4002,
        GIR_EraseRootFromParent_Done,
      // Label 7705: @445615
      GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(445686), // Rule ID 4003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4003,
        GIR_EraseRootFromParent_Done,
      // Label 7706: @445686
      GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(445757), // Rule ID 4012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4012,
        GIR_EraseRootFromParent_Done,
      // Label 7707: @445757
      GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(445828), // Rule ID 4013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4013,
        GIR_EraseRootFromParent_Done,
      // Label 7708: @445828
      GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(445899), // Rule ID 4022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4022,
        GIR_EraseRootFromParent_Done,
      // Label 7709: @445899
      GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(445970), // Rule ID 4023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4023,
        GIR_EraseRootFromParent_Done,
      // Label 7710: @445970
      GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(446041), // Rule ID 4032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4032,
        GIR_EraseRootFromParent_Done,
      // Label 7711: @446041
      GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(446112), // Rule ID 4033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4033,
        GIR_EraseRootFromParent_Done,
      // Label 7712: @446112
      GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(446183), // Rule ID 4042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4042,
        GIR_EraseRootFromParent_Done,
      // Label 7713: @446183
      GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(446254), // Rule ID 4043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4043,
        GIR_EraseRootFromParent_Done,
      // Label 7714: @446254
      GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(446325), // Rule ID 4052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4052,
        GIR_EraseRootFromParent_Done,
      // Label 7715: @446325
      GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(446396), // Rule ID 4053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4053,
        GIR_EraseRootFromParent_Done,
      // Label 7716: @446396
      GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(446467), // Rule ID 4122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4122,
        GIR_EraseRootFromParent_Done,
      // Label 7717: @446467
      GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(446538), // Rule ID 4123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4123,
        GIR_EraseRootFromParent_Done,
      // Label 7718: @446538
      GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(446609), // Rule ID 4132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4132,
        GIR_EraseRootFromParent_Done,
      // Label 7719: @446609
      GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(446680), // Rule ID 4133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4133,
        GIR_EraseRootFromParent_Done,
      // Label 7720: @446680
      GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(446751), // Rule ID 4142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4142,
        GIR_EraseRootFromParent_Done,
      // Label 7721: @446751
      GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(446822), // Rule ID 4143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4143,
        GIR_EraseRootFromParent_Done,
      // Label 7722: @446822
      GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(446893), // Rule ID 4152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4152,
        GIR_EraseRootFromParent_Done,
      // Label 7723: @446893
      GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(446964), // Rule ID 4153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4153,
        GIR_EraseRootFromParent_Done,
      // Label 7724: @446964
      GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(447035), // Rule ID 4162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4162,
        GIR_EraseRootFromParent_Done,
      // Label 7725: @447035
      GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(447106), // Rule ID 4163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4163,
        GIR_EraseRootFromParent_Done,
      // Label 7726: @447106
      GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(447177), // Rule ID 4172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4172,
        GIR_EraseRootFromParent_Done,
      // Label 7727: @447177
      GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(447248), // Rule ID 4173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4173,
        GIR_EraseRootFromParent_Done,
      // Label 7728: @447248
      GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(447319), // Rule ID 4182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4182,
        GIR_EraseRootFromParent_Done,
      // Label 7729: @447319
      GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(447390), // Rule ID 4183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4183,
        GIR_EraseRootFromParent_Done,
      // Label 7730: @447390
      GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(447461), // Rule ID 4192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4192,
        GIR_EraseRootFromParent_Done,
      // Label 7731: @447461
      GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(447532), // Rule ID 4193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4193,
        GIR_EraseRootFromParent_Done,
      // Label 7732: @447532
      GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(447603), // Rule ID 4202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4202,
        GIR_EraseRootFromParent_Done,
      // Label 7733: @447603
      GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(447674), // Rule ID 4203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4203,
        GIR_EraseRootFromParent_Done,
      // Label 7734: @447674
      GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(447745), // Rule ID 4212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4212,
        GIR_EraseRootFromParent_Done,
      // Label 7735: @447745
      GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(447816), // Rule ID 4213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4213,
        GIR_EraseRootFromParent_Done,
      // Label 7736: @447816
      GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(447887), // Rule ID 4222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4222,
        GIR_EraseRootFromParent_Done,
      // Label 7737: @447887
      GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(447958), // Rule ID 4223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4223,
        GIR_EraseRootFromParent_Done,
      // Label 7738: @447958
      GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(448029), // Rule ID 4232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4232,
        GIR_EraseRootFromParent_Done,
      // Label 7739: @448029
      GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(448100), // Rule ID 4233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4233,
        GIR_EraseRootFromParent_Done,
      // Label 7740: @448100
      GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(448171), // Rule ID 4242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4242,
        GIR_EraseRootFromParent_Done,
      // Label 7741: @448171
      GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(448242), // Rule ID 4243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4243,
        GIR_EraseRootFromParent_Done,
      // Label 7742: @448242
      GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(448313), // Rule ID 4252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4252,
        GIR_EraseRootFromParent_Done,
      // Label 7743: @448313
      GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(448384), // Rule ID 4253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4253,
        GIR_EraseRootFromParent_Done,
      // Label 7744: @448384
      GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(448455), // Rule ID 4262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4262,
        GIR_EraseRootFromParent_Done,
      // Label 7745: @448455
      GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(448526), // Rule ID 4263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4263,
        GIR_EraseRootFromParent_Done,
      // Label 7746: @448526
      GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(448597), // Rule ID 4332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4332,
        GIR_EraseRootFromParent_Done,
      // Label 7747: @448597
      GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(448668), // Rule ID 4333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4333,
        GIR_EraseRootFromParent_Done,
      // Label 7748: @448668
      GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(448739), // Rule ID 4342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4342,
        GIR_EraseRootFromParent_Done,
      // Label 7749: @448739
      GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(448810), // Rule ID 4343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4343,
        GIR_EraseRootFromParent_Done,
      // Label 7750: @448810
      GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(448881), // Rule ID 4352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4352,
        GIR_EraseRootFromParent_Done,
      // Label 7751: @448881
      GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(448952), // Rule ID 4353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4353,
        GIR_EraseRootFromParent_Done,
      // Label 7752: @448952
      GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(449023), // Rule ID 4362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4362,
        GIR_EraseRootFromParent_Done,
      // Label 7753: @449023
      GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(449094), // Rule ID 4363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4363,
        GIR_EraseRootFromParent_Done,
      // Label 7754: @449094
      GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(449165), // Rule ID 4372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4372,
        GIR_EraseRootFromParent_Done,
      // Label 7755: @449165
      GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(449236), // Rule ID 4373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4373,
        GIR_EraseRootFromParent_Done,
      // Label 7756: @449236
      GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(449307), // Rule ID 4382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4382,
        GIR_EraseRootFromParent_Done,
      // Label 7757: @449307
      GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(449378), // Rule ID 4383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4383,
        GIR_EraseRootFromParent_Done,
      // Label 7758: @449378
      GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(449449), // Rule ID 4392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4392,
        GIR_EraseRootFromParent_Done,
      // Label 7759: @449449
      GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(449520), // Rule ID 4393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4393,
        GIR_EraseRootFromParent_Done,
      // Label 7760: @449520
      GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(449591), // Rule ID 4402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4402,
        GIR_EraseRootFromParent_Done,
      // Label 7761: @449591
      GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(449662), // Rule ID 4403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4403,
        GIR_EraseRootFromParent_Done,
      // Label 7762: @449662
      GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(449733), // Rule ID 4412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4412,
        GIR_EraseRootFromParent_Done,
      // Label 7763: @449733
      GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(449804), // Rule ID 4413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4413,
        GIR_EraseRootFromParent_Done,
      // Label 7764: @449804
      GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(449875), // Rule ID 4422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4422,
        GIR_EraseRootFromParent_Done,
      // Label 7765: @449875
      GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(449946), // Rule ID 4423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4423,
        GIR_EraseRootFromParent_Done,
      // Label 7766: @449946
      GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(450017), // Rule ID 4432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4432,
        GIR_EraseRootFromParent_Done,
      // Label 7767: @450017
      GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(450088), // Rule ID 4433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4433,
        GIR_EraseRootFromParent_Done,
      // Label 7768: @450088
      GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(450159), // Rule ID 4442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4442,
        GIR_EraseRootFromParent_Done,
      // Label 7769: @450159
      GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(450230), // Rule ID 4443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4443,
        GIR_EraseRootFromParent_Done,
      // Label 7770: @450230
      GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(450301), // Rule ID 4452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4452,
        GIR_EraseRootFromParent_Done,
      // Label 7771: @450301
      GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(450372), // Rule ID 4453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4453,
        GIR_EraseRootFromParent_Done,
      // Label 7772: @450372
      GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(450443), // Rule ID 4462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4462,
        GIR_EraseRootFromParent_Done,
      // Label 7773: @450443
      GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(450514), // Rule ID 4463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4463,
        GIR_EraseRootFromParent_Done,
      // Label 7774: @450514
      GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(450585), // Rule ID 4472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4472,
        GIR_EraseRootFromParent_Done,
      // Label 7775: @450585
      GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(450656), // Rule ID 4473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4473,
        GIR_EraseRootFromParent_Done,
      // Label 7776: @450656
      GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(450727), // Rule ID 4542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4542,
        GIR_EraseRootFromParent_Done,
      // Label 7777: @450727
      GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(450798), // Rule ID 4543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4543,
        GIR_EraseRootFromParent_Done,
      // Label 7778: @450798
      GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(450869), // Rule ID 4552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4552,
        GIR_EraseRootFromParent_Done,
      // Label 7779: @450869
      GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(450940), // Rule ID 4553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4553,
        GIR_EraseRootFromParent_Done,
      // Label 7780: @450940
      GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(451011), // Rule ID 4562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4562,
        GIR_EraseRootFromParent_Done,
      // Label 7781: @451011
      GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(451082), // Rule ID 4563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4563,
        GIR_EraseRootFromParent_Done,
      // Label 7782: @451082
      GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(451153), // Rule ID 4572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4572,
        GIR_EraseRootFromParent_Done,
      // Label 7783: @451153
      GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(451224), // Rule ID 4573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4573,
        GIR_EraseRootFromParent_Done,
      // Label 7784: @451224
      GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(451295), // Rule ID 4582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4582,
        GIR_EraseRootFromParent_Done,
      // Label 7785: @451295
      GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(451366), // Rule ID 4583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4583,
        GIR_EraseRootFromParent_Done,
      // Label 7786: @451366
      GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(451437), // Rule ID 4592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4592,
        GIR_EraseRootFromParent_Done,
      // Label 7787: @451437
      GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(451508), // Rule ID 4593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4593,
        GIR_EraseRootFromParent_Done,
      // Label 7788: @451508
      GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(451579), // Rule ID 4602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4602,
        GIR_EraseRootFromParent_Done,
      // Label 7789: @451579
      GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(451650), // Rule ID 4603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4603,
        GIR_EraseRootFromParent_Done,
      // Label 7790: @451650
      GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(451721), // Rule ID 4612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4612,
        GIR_EraseRootFromParent_Done,
      // Label 7791: @451721
      GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(451792), // Rule ID 4613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4613,
        GIR_EraseRootFromParent_Done,
      // Label 7792: @451792
      GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(451863), // Rule ID 4622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4622,
        GIR_EraseRootFromParent_Done,
      // Label 7793: @451863
      GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(451934), // Rule ID 4623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4623,
        GIR_EraseRootFromParent_Done,
      // Label 7794: @451934
      GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(452005), // Rule ID 4632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4632,
        GIR_EraseRootFromParent_Done,
      // Label 7795: @452005
      GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(452076), // Rule ID 4633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4633,
        GIR_EraseRootFromParent_Done,
      // Label 7796: @452076
      GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(452147), // Rule ID 4642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4642,
        GIR_EraseRootFromParent_Done,
      // Label 7797: @452147
      GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(452218), // Rule ID 4643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4643,
        GIR_EraseRootFromParent_Done,
      // Label 7798: @452218
      GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(452289), // Rule ID 4652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4652,
        GIR_EraseRootFromParent_Done,
      // Label 7799: @452289
      GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(452360), // Rule ID 4653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4653,
        GIR_EraseRootFromParent_Done,
      // Label 7800: @452360
      GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(452431), // Rule ID 4662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4662,
        GIR_EraseRootFromParent_Done,
      // Label 7801: @452431
      GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(452502), // Rule ID 4663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4663,
        GIR_EraseRootFromParent_Done,
      // Label 7802: @452502
      GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(452573), // Rule ID 4672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4672,
        GIR_EraseRootFromParent_Done,
      // Label 7803: @452573
      GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(452644), // Rule ID 4673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4673,
        GIR_EraseRootFromParent_Done,
      // Label 7804: @452644
      GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(452715), // Rule ID 4682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4682,
        GIR_EraseRootFromParent_Done,
      // Label 7805: @452715
      GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(452786), // Rule ID 4683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4683,
        GIR_EraseRootFromParent_Done,
      // Label 7806: @452786
      GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(452858), // Rule ID 2546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2546,
        GIR_EraseRootFromParent_Done,
      // Label 7807: @452858
      GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(452930), // Rule ID 2547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2547,
        GIR_EraseRootFromParent_Done,
      // Label 7808: @452930
      GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(453023), // Rule ID 2550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2550,
        GIR_EraseRootFromParent_Done,
      // Label 7809: @453023
      GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(453116), // Rule ID 2551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2551,
        GIR_EraseRootFromParent_Done,
      // Label 7810: @453116
      GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(453191), // Rule ID 2578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2578,
        GIR_EraseRootFromParent_Done,
      // Label 7811: @453191
      GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(453266), // Rule ID 2579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2579,
        GIR_EraseRootFromParent_Done,
      // Label 7812: @453266
      GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(453356), // Rule ID 2592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2592,
        GIR_EraseRootFromParent_Done,
      // Label 7813: @453356
      GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(453446), // Rule ID 2593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2593,
        GIR_EraseRootFromParent_Done,
      // Label 7814: @453446
      GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(453521), // Rule ID 2612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2612,
        GIR_EraseRootFromParent_Done,
      // Label 7815: @453521
      GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(453596), // Rule ID 2613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2613,
        GIR_EraseRootFromParent_Done,
      // Label 7816: @453596
      GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(453671), // Rule ID 2638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2638,
        GIR_EraseRootFromParent_Done,
      // Label 7817: @453671
      GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(453746), // Rule ID 2639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2639,
        GIR_EraseRootFromParent_Done,
      // Label 7818: @453746
      GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(453821), // Rule ID 2650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2650,
        GIR_EraseRootFromParent_Done,
      // Label 7819: @453821
      GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(453896), // Rule ID 2651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2651,
        GIR_EraseRootFromParent_Done,
      // Label 7820: @453896
      GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(453971), // Rule ID 2658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2658,
        GIR_EraseRootFromParent_Done,
      // Label 7821: @453971
      GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(454046), // Rule ID 2659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2659,
        GIR_EraseRootFromParent_Done,
      // Label 7822: @454046
      GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(454121), // Rule ID 2666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2666,
        GIR_EraseRootFromParent_Done,
      // Label 7823: @454121
      GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(454196), // Rule ID 2667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2667,
        GIR_EraseRootFromParent_Done,
      // Label 7824: @454196
      GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(454271), // Rule ID 2674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2674,
        GIR_EraseRootFromParent_Done,
      // Label 7825: @454271
      GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(454346), // Rule ID 2675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2675,
        GIR_EraseRootFromParent_Done,
      // Label 7826: @454346
      GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(454421), // Rule ID 2682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2682,
        GIR_EraseRootFromParent_Done,
      // Label 7827: @454421
      GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(454496), // Rule ID 2683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2683,
        GIR_EraseRootFromParent_Done,
      // Label 7828: @454496
      GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(454571), // Rule ID 2690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2690,
        GIR_EraseRootFromParent_Done,
      // Label 7829: @454571
      GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(454646), // Rule ID 2691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2691,
        GIR_EraseRootFromParent_Done,
      // Label 7830: @454646
      GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(454721), // Rule ID 2698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2698,
        GIR_EraseRootFromParent_Done,
      // Label 7831: @454721
      GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(454796), // Rule ID 2699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2699,
        GIR_EraseRootFromParent_Done,
      // Label 7832: @454796
      GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(454871), // Rule ID 2706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2706,
        GIR_EraseRootFromParent_Done,
      // Label 7833: @454871
      GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(454946), // Rule ID 2707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2707,
        GIR_EraseRootFromParent_Done,
      // Label 7834: @454946
      GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(455021), // Rule ID 2714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2714,
        GIR_EraseRootFromParent_Done,
      // Label 7835: @455021
      GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(455096), // Rule ID 2715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2715,
        GIR_EraseRootFromParent_Done,
      // Label 7836: @455096
      GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(455171), // Rule ID 2722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2722,
        GIR_EraseRootFromParent_Done,
      // Label 7837: @455171
      GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(455246), // Rule ID 2723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2723,
        GIR_EraseRootFromParent_Done,
      // Label 7838: @455246
      GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(455321), // Rule ID 2730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2730,
        GIR_EraseRootFromParent_Done,
      // Label 7839: @455321
      GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(455396), // Rule ID 2731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2731,
        GIR_EraseRootFromParent_Done,
      // Label 7840: @455396
      GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(455471), // Rule ID 2738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2738,
        GIR_EraseRootFromParent_Done,
      // Label 7841: @455471
      GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(455546), // Rule ID 2739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2739,
        GIR_EraseRootFromParent_Done,
      // Label 7842: @455546
      GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(455621), // Rule ID 2746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2746,
        GIR_EraseRootFromParent_Done,
      // Label 7843: @455621
      GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(455696), // Rule ID 2747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2747,
        GIR_EraseRootFromParent_Done,
      // Label 7844: @455696
      GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(455771), // Rule ID 2754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2754,
        GIR_EraseRootFromParent_Done,
      // Label 7845: @455771
      GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(455846), // Rule ID 2755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2755,
        GIR_EraseRootFromParent_Done,
      // Label 7846: @455846
      GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(455921), // Rule ID 2762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2762,
        GIR_EraseRootFromParent_Done,
      // Label 7847: @455921
      GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(455996), // Rule ID 2763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2763,
        GIR_EraseRootFromParent_Done,
      // Label 7848: @455996
      GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(456071), // Rule ID 2770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2770,
        GIR_EraseRootFromParent_Done,
      // Label 7849: @456071
      GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(456146), // Rule ID 2771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2771,
        GIR_EraseRootFromParent_Done,
      // Label 7850: @456146
      GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(456221), // Rule ID 2778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2778,
        GIR_EraseRootFromParent_Done,
      // Label 7851: @456221
      GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(456296), // Rule ID 2779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2779,
        GIR_EraseRootFromParent_Done,
      // Label 7852: @456296
      GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(456371), // Rule ID 2786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2786,
        GIR_EraseRootFromParent_Done,
      // Label 7853: @456371
      GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(456446), // Rule ID 2787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2787,
        GIR_EraseRootFromParent_Done,
      // Label 7854: @456446
      GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(456521), // Rule ID 2794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2794,
        GIR_EraseRootFromParent_Done,
      // Label 7855: @456521
      GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(456596), // Rule ID 2795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2795,
        GIR_EraseRootFromParent_Done,
      // Label 7856: @456596
      GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(456671), // Rule ID 2802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2802,
        GIR_EraseRootFromParent_Done,
      // Label 7857: @456671
      GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(456746), // Rule ID 2803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2803,
        GIR_EraseRootFromParent_Done,
      // Label 7858: @456746
      GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(456821), // Rule ID 2810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2810,
        GIR_EraseRootFromParent_Done,
      // Label 7859: @456821
      GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(456896), // Rule ID 2811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2811,
        GIR_EraseRootFromParent_Done,
      // Label 7860: @456896
      GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(456971), // Rule ID 2818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2818,
        GIR_EraseRootFromParent_Done,
      // Label 7861: @456971
      GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(457046), // Rule ID 2819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2819,
        GIR_EraseRootFromParent_Done,
      // Label 7862: @457046
      GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(457121), // Rule ID 2826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2826,
        GIR_EraseRootFromParent_Done,
      // Label 7863: @457121
      GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(457196), // Rule ID 2827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2827,
        GIR_EraseRootFromParent_Done,
      // Label 7864: @457196
      GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(457271), // Rule ID 2830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2830,
        GIR_EraseRootFromParent_Done,
      // Label 7865: @457271
      GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(457346), // Rule ID 2831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2831,
        GIR_EraseRootFromParent_Done,
      // Label 7866: @457346
      GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(457421), // Rule ID 2834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2834,
        GIR_EraseRootFromParent_Done,
      // Label 7867: @457421
      GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(457496), // Rule ID 2835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2835,
        GIR_EraseRootFromParent_Done,
      // Label 7868: @457496
      GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(457571), // Rule ID 2838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2838,
        GIR_EraseRootFromParent_Done,
      // Label 7869: @457571
      GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(457646), // Rule ID 2839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2839,
        GIR_EraseRootFromParent_Done,
      // Label 7870: @457646
      GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(457721), // Rule ID 2842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2842,
        GIR_EraseRootFromParent_Done,
      // Label 7871: @457721
      GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(457796), // Rule ID 2843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2843,
        GIR_EraseRootFromParent_Done,
      // Label 7872: @457796
      GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(457871), // Rule ID 2846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2846,
        GIR_EraseRootFromParent_Done,
      // Label 7873: @457871
      GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(457946), // Rule ID 2847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2847,
        GIR_EraseRootFromParent_Done,
      // Label 7874: @457946
      GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(458021), // Rule ID 2850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2850,
        GIR_EraseRootFromParent_Done,
      // Label 7875: @458021
      GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(458096), // Rule ID 2851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2851,
        GIR_EraseRootFromParent_Done,
      // Label 7876: @458096
      GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(458171), // Rule ID 2854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2854,
        GIR_EraseRootFromParent_Done,
      // Label 7877: @458171
      GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(458246), // Rule ID 2855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2855,
        GIR_EraseRootFromParent_Done,
      // Label 7878: @458246
      GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(458321), // Rule ID 2858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2858,
        GIR_EraseRootFromParent_Done,
      // Label 7879: @458321
      GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(458396), // Rule ID 2859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2859,
        GIR_EraseRootFromParent_Done,
      // Label 7880: @458396
      GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(458471), // Rule ID 2862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2862,
        GIR_EraseRootFromParent_Done,
      // Label 7881: @458471
      GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(458546), // Rule ID 2863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2863,
        GIR_EraseRootFromParent_Done,
      // Label 7882: @458546
      GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(458621), // Rule ID 2866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2866,
        GIR_EraseRootFromParent_Done,
      // Label 7883: @458621
      GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(458696), // Rule ID 2867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2867,
        GIR_EraseRootFromParent_Done,
      // Label 7884: @458696
      GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(458771), // Rule ID 2870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2870,
        GIR_EraseRootFromParent_Done,
      // Label 7885: @458771
      GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(458846), // Rule ID 2871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2871,
        GIR_EraseRootFromParent_Done,
      // Label 7886: @458846
      GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(458921), // Rule ID 2874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2874,
        GIR_EraseRootFromParent_Done,
      // Label 7887: @458921
      GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(458996), // Rule ID 2875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2875,
        GIR_EraseRootFromParent_Done,
      // Label 7888: @458996
      GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(459071), // Rule ID 2878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2878,
        GIR_EraseRootFromParent_Done,
      // Label 7889: @459071
      GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(459146), // Rule ID 2879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2879,
        GIR_EraseRootFromParent_Done,
      // Label 7890: @459146
      GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(459221), // Rule ID 2882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2882,
        GIR_EraseRootFromParent_Done,
      // Label 7891: @459221
      GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(459296), // Rule ID 2883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2883,
        GIR_EraseRootFromParent_Done,
      // Label 7892: @459296
      GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(459371), // Rule ID 2886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2886,
        GIR_EraseRootFromParent_Done,
      // Label 7893: @459371
      GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(459446), // Rule ID 2887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2887,
        GIR_EraseRootFromParent_Done,
      // Label 7894: @459446
      GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(459521), // Rule ID 2890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2890,
        GIR_EraseRootFromParent_Done,
      // Label 7895: @459521
      GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(459596), // Rule ID 2891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2891,
        GIR_EraseRootFromParent_Done,
      // Label 7896: @459596
      GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(459671), // Rule ID 2894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2894,
        GIR_EraseRootFromParent_Done,
      // Label 7897: @459671
      GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(459746), // Rule ID 2895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2895,
        GIR_EraseRootFromParent_Done,
      // Label 7898: @459746
      GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(459821), // Rule ID 2898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2898,
        GIR_EraseRootFromParent_Done,
      // Label 7899: @459821
      GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(459896), // Rule ID 2899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2899,
        GIR_EraseRootFromParent_Done,
      // Label 7900: @459896
      GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(459971), // Rule ID 2902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2902,
        GIR_EraseRootFromParent_Done,
      // Label 7901: @459971
      GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(460046), // Rule ID 2903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2903,
        GIR_EraseRootFromParent_Done,
      // Label 7902: @460046
      GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(460121), // Rule ID 2906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2906,
        GIR_EraseRootFromParent_Done,
      // Label 7903: @460121
      GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(460196), // Rule ID 2907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2907,
        GIR_EraseRootFromParent_Done,
      // Label 7904: @460196
      GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(460271), // Rule ID 2910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2910,
        GIR_EraseRootFromParent_Done,
      // Label 7905: @460271
      GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(460346), // Rule ID 2911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2911,
        GIR_EraseRootFromParent_Done,
      // Label 7906: @460346
      GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(460421), // Rule ID 2914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2914,
        GIR_EraseRootFromParent_Done,
      // Label 7907: @460421
      GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(460496), // Rule ID 2915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2915,
        GIR_EraseRootFromParent_Done,
      // Label 7908: @460496
      GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(460571), // Rule ID 2918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2918,
        GIR_EraseRootFromParent_Done,
      // Label 7909: @460571
      GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(460646), // Rule ID 2919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2919,
        GIR_EraseRootFromParent_Done,
      // Label 7910: @460646
      GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(460721), // Rule ID 2922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2922,
        GIR_EraseRootFromParent_Done,
      // Label 7911: @460721
      GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(460796), // Rule ID 2923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2923,
        GIR_EraseRootFromParent_Done,
      // Label 7912: @460796
      GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(460871), // Rule ID 2926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2926,
        GIR_EraseRootFromParent_Done,
      // Label 7913: @460871
      GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(460946), // Rule ID 2927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2927,
        GIR_EraseRootFromParent_Done,
      // Label 7914: @460946
      GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(461021), // Rule ID 2930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2930,
        GIR_EraseRootFromParent_Done,
      // Label 7915: @461021
      GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(461096), // Rule ID 2931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2931,
        GIR_EraseRootFromParent_Done,
      // Label 7916: @461096
      GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(461171), // Rule ID 2934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2934,
        GIR_EraseRootFromParent_Done,
      // Label 7917: @461171
      GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(461246), // Rule ID 2935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10750:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2935,
        GIR_EraseRootFromParent_Done,
      // Label 7918: @461246
      GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(461321), // Rule ID 2938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2938,
        GIR_EraseRootFromParent_Done,
      // Label 7919: @461321
      GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(461396), // Rule ID 2939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10750:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2939,
        GIR_EraseRootFromParent_Done,
      // Label 7920: @461396
      GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(461471), // Rule ID 2942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2942,
        GIR_EraseRootFromParent_Done,
      // Label 7921: @461471
      GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(461546), // Rule ID 2943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10750:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2943,
        GIR_EraseRootFromParent_Done,
      // Label 7922: @461546
      GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(461621), // Rule ID 2946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2946,
        GIR_EraseRootFromParent_Done,
      // Label 7923: @461621
      GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(461696), // Rule ID 2947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10750:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2947,
        GIR_EraseRootFromParent_Done,
      // Label 7924: @461696
      GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(461771), // Rule ID 2950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2950,
        GIR_EraseRootFromParent_Done,
      // Label 7925: @461771
      GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(461846), // Rule ID 2951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2951,
        GIR_EraseRootFromParent_Done,
      // Label 7926: @461846
      GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(461921), // Rule ID 2954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2954,
        GIR_EraseRootFromParent_Done,
      // Label 7927: @461921
      GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(461996), // Rule ID 2955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2955,
        GIR_EraseRootFromParent_Done,
      // Label 7928: @461996
      GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(462071), // Rule ID 2958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2958,
        GIR_EraseRootFromParent_Done,
      // Label 7929: @462071
      GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(462146), // Rule ID 2959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2959,
        GIR_EraseRootFromParent_Done,
      // Label 7930: @462146
      GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(462221), // Rule ID 2962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2962,
        GIR_EraseRootFromParent_Done,
      // Label 7931: @462221
      GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(462296), // Rule ID 2963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2963,
        GIR_EraseRootFromParent_Done,
      // Label 7932: @462296
      GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(462371), // Rule ID 2966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2966,
        GIR_EraseRootFromParent_Done,
      // Label 7933: @462371
      GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(462446), // Rule ID 2967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2967,
        GIR_EraseRootFromParent_Done,
      // Label 7934: @462446
      GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(462521), // Rule ID 2970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2970,
        GIR_EraseRootFromParent_Done,
      // Label 7935: @462521
      GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(462596), // Rule ID 2971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2971,
        GIR_EraseRootFromParent_Done,
      // Label 7936: @462596
      GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(462671), // Rule ID 2974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2974,
        GIR_EraseRootFromParent_Done,
      // Label 7937: @462671
      GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(462746), // Rule ID 2975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2975,
        GIR_EraseRootFromParent_Done,
      // Label 7938: @462746
      GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(462821), // Rule ID 2978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2978,
        GIR_EraseRootFromParent_Done,
      // Label 7939: @462821
      GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(462896), // Rule ID 2979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2979,
        GIR_EraseRootFromParent_Done,
      // Label 7940: @462896
      GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(462971), // Rule ID 2982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2982,
        GIR_EraseRootFromParent_Done,
      // Label 7941: @462971
      GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(463046), // Rule ID 2983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2983,
        GIR_EraseRootFromParent_Done,
      // Label 7942: @463046
      GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(463121), // Rule ID 2986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2986,
        GIR_EraseRootFromParent_Done,
      // Label 7943: @463121
      GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(463196), // Rule ID 2987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10750:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2987,
        GIR_EraseRootFromParent_Done,
      // Label 7944: @463196
      GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(463271), // Rule ID 2990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2990,
        GIR_EraseRootFromParent_Done,
      // Label 7945: @463271
      GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(463346), // Rule ID 2991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10750:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2991,
        GIR_EraseRootFromParent_Done,
      // Label 7946: @463346
      GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(463421), // Rule ID 2994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2994,
        GIR_EraseRootFromParent_Done,
      // Label 7947: @463421
      GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(463496), // Rule ID 2995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10750:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2995,
        GIR_EraseRootFromParent_Done,
      // Label 7948: @463496
      GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(463571), // Rule ID 3086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3086,
        GIR_EraseRootFromParent_Done,
      // Label 7949: @463571
      GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(463646), // Rule ID 3087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3087,
        GIR_EraseRootFromParent_Done,
      // Label 7950: @463646
      GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(463721), // Rule ID 3090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3090,
        GIR_EraseRootFromParent_Done,
      // Label 7951: @463721
      GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(463796), // Rule ID 3091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3091,
        GIR_EraseRootFromParent_Done,
      // Label 7952: @463796
      GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(463871), // Rule ID 3094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3094,
        GIR_EraseRootFromParent_Done,
      // Label 7953: @463871
      GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(463946), // Rule ID 3095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3095,
        GIR_EraseRootFromParent_Done,
      // Label 7954: @463946
      GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(464021), // Rule ID 3098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3098,
        GIR_EraseRootFromParent_Done,
      // Label 7955: @464021
      GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(464096), // Rule ID 3099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3099,
        GIR_EraseRootFromParent_Done,
      // Label 7956: @464096
      GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(464171), // Rule ID 3102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3102,
        GIR_EraseRootFromParent_Done,
      // Label 7957: @464171
      GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(464246), // Rule ID 3103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3103,
        GIR_EraseRootFromParent_Done,
      // Label 7958: @464246
      GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(464321), // Rule ID 3106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3106,
        GIR_EraseRootFromParent_Done,
      // Label 7959: @464321
      GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(464396), // Rule ID 3107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3107,
        GIR_EraseRootFromParent_Done,
      // Label 7960: @464396
      GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(464471), // Rule ID 3110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3110,
        GIR_EraseRootFromParent_Done,
      // Label 7961: @464471
      GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(464546), // Rule ID 3111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3111,
        GIR_EraseRootFromParent_Done,
      // Label 7962: @464546
      GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(464621), // Rule ID 3114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3114,
        GIR_EraseRootFromParent_Done,
      // Label 7963: @464621
      GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(464696), // Rule ID 3115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3115,
        GIR_EraseRootFromParent_Done,
      // Label 7964: @464696
      GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(464771), // Rule ID 3118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3118,
        GIR_EraseRootFromParent_Done,
      // Label 7965: @464771
      GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(464846), // Rule ID 3119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3119,
        GIR_EraseRootFromParent_Done,
      // Label 7966: @464846
      GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(464921), // Rule ID 3122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3122,
        GIR_EraseRootFromParent_Done,
      // Label 7967: @464921
      GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(464996), // Rule ID 3123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3123,
        GIR_EraseRootFromParent_Done,
      // Label 7968: @464996
      GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(465071), // Rule ID 3126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3126,
        GIR_EraseRootFromParent_Done,
      // Label 7969: @465071
      GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(465146), // Rule ID 3127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3127,
        GIR_EraseRootFromParent_Done,
      // Label 7970: @465146
      GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(465221), // Rule ID 3130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3130,
        GIR_EraseRootFromParent_Done,
      // Label 7971: @465221
      GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(465296), // Rule ID 3131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3131,
        GIR_EraseRootFromParent_Done,
      // Label 7972: @465296
      GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(465371), // Rule ID 3134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3134,
        GIR_EraseRootFromParent_Done,
      // Label 7973: @465371
      GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(465446), // Rule ID 3135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3135,
        GIR_EraseRootFromParent_Done,
      // Label 7974: @465446
      GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(465521), // Rule ID 3138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3138,
        GIR_EraseRootFromParent_Done,
      // Label 7975: @465521
      GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(465596), // Rule ID 3139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3139,
        GIR_EraseRootFromParent_Done,
      // Label 7976: @465596
      GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(465671), // Rule ID 3142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3142,
        GIR_EraseRootFromParent_Done,
      // Label 7977: @465671
      GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(465746), // Rule ID 3143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3143,
        GIR_EraseRootFromParent_Done,
      // Label 7978: @465746
      GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(465821), // Rule ID 3146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3146,
        GIR_EraseRootFromParent_Done,
      // Label 7979: @465821
      GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(465896), // Rule ID 3147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3147,
        GIR_EraseRootFromParent_Done,
      // Label 7980: @465896
      GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(465971), // Rule ID 3150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3150,
        GIR_EraseRootFromParent_Done,
      // Label 7981: @465971
      GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(466046), // Rule ID 3151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3151,
        GIR_EraseRootFromParent_Done,
      // Label 7982: @466046
      GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(466121), // Rule ID 3154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3154,
        GIR_EraseRootFromParent_Done,
      // Label 7983: @466121
      GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(466196), // Rule ID 3155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3155,
        GIR_EraseRootFromParent_Done,
      // Label 7984: @466196
      GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(466271), // Rule ID 3158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3158,
        GIR_EraseRootFromParent_Done,
      // Label 7985: @466271
      GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(466346), // Rule ID 3159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3159,
        GIR_EraseRootFromParent_Done,
      // Label 7986: @466346
      GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(466421), // Rule ID 3162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3162,
        GIR_EraseRootFromParent_Done,
      // Label 7987: @466421
      GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(466496), // Rule ID 3163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3163,
        GIR_EraseRootFromParent_Done,
      // Label 7988: @466496
      GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(466571), // Rule ID 3166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3166,
        GIR_EraseRootFromParent_Done,
      // Label 7989: @466571
      GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(466646), // Rule ID 3167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3167,
        GIR_EraseRootFromParent_Done,
      // Label 7990: @466646
      GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(466721), // Rule ID 3170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3170,
        GIR_EraseRootFromParent_Done,
      // Label 7991: @466721
      GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(466796), // Rule ID 3171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3171,
        GIR_EraseRootFromParent_Done,
      // Label 7992: @466796
      GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(466871), // Rule ID 3174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3174,
        GIR_EraseRootFromParent_Done,
      // Label 7993: @466871
      GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(466946), // Rule ID 3175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3175,
        GIR_EraseRootFromParent_Done,
      // Label 7994: @466946
      GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(467021), // Rule ID 3178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3178,
        GIR_EraseRootFromParent_Done,
      // Label 7995: @467021
      GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(467096), // Rule ID 3179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3179,
        GIR_EraseRootFromParent_Done,
      // Label 7996: @467096
      GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(467171), // Rule ID 3182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3182,
        GIR_EraseRootFromParent_Done,
      // Label 7997: @467171
      GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(467246), // Rule ID 3183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3183,
        GIR_EraseRootFromParent_Done,
      // Label 7998: @467246
      GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(467321), // Rule ID 3186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3186,
        GIR_EraseRootFromParent_Done,
      // Label 7999: @467321
      GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(467396), // Rule ID 3187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3187,
        GIR_EraseRootFromParent_Done,
      // Label 8000: @467396
      GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(467471), // Rule ID 3190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3190,
        GIR_EraseRootFromParent_Done,
      // Label 8001: @467471
      GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(467546), // Rule ID 3191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3191,
        GIR_EraseRootFromParent_Done,
      // Label 8002: @467546
      GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(467621), // Rule ID 3194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3194,
        GIR_EraseRootFromParent_Done,
      // Label 8003: @467621
      GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(467696), // Rule ID 3195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3195,
        GIR_EraseRootFromParent_Done,
      // Label 8004: @467696
      GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(467771), // Rule ID 3198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3198,
        GIR_EraseRootFromParent_Done,
      // Label 8005: @467771
      GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(467846), // Rule ID 3199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3199,
        GIR_EraseRootFromParent_Done,
      // Label 8006: @467846
      GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(467921), // Rule ID 3202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3202,
        GIR_EraseRootFromParent_Done,
      // Label 8007: @467921
      GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(467996), // Rule ID 3203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3203,
        GIR_EraseRootFromParent_Done,
      // Label 8008: @467996
      GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(468071), // Rule ID 3206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3206,
        GIR_EraseRootFromParent_Done,
      // Label 8009: @468071
      GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(468146), // Rule ID 3207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3207,
        GIR_EraseRootFromParent_Done,
      // Label 8010: @468146
      GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(468221), // Rule ID 3210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3210,
        GIR_EraseRootFromParent_Done,
      // Label 8011: @468221
      GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(468296), // Rule ID 3211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3211,
        GIR_EraseRootFromParent_Done,
      // Label 8012: @468296
      GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(468371), // Rule ID 3214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3214,
        GIR_EraseRootFromParent_Done,
      // Label 8013: @468371
      GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(468446), // Rule ID 3215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3215,
        GIR_EraseRootFromParent_Done,
      // Label 8014: @468446
      GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(468521), // Rule ID 3218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3218,
        GIR_EraseRootFromParent_Done,
      // Label 8015: @468521
      GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(468596), // Rule ID 3219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3219,
        GIR_EraseRootFromParent_Done,
      // Label 8016: @468596
      GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(468671), // Rule ID 3222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3222,
        GIR_EraseRootFromParent_Done,
      // Label 8017: @468671
      GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(468746), // Rule ID 3223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3223,
        GIR_EraseRootFromParent_Done,
      // Label 8018: @468746
      GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(468821), // Rule ID 3226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3226,
        GIR_EraseRootFromParent_Done,
      // Label 8019: @468821
      GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(468896), // Rule ID 3227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3227,
        GIR_EraseRootFromParent_Done,
      // Label 8020: @468896
      GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(468971), // Rule ID 3230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3230,
        GIR_EraseRootFromParent_Done,
      // Label 8021: @468971
      GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(469046), // Rule ID 3231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3231,
        GIR_EraseRootFromParent_Done,
      // Label 8022: @469046
      GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(469121), // Rule ID 3234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3234,
        GIR_EraseRootFromParent_Done,
      // Label 8023: @469121
      GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(469196), // Rule ID 3235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3235,
        GIR_EraseRootFromParent_Done,
      // Label 8024: @469196
      GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(469271), // Rule ID 3238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3238,
        GIR_EraseRootFromParent_Done,
      // Label 8025: @469271
      GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(469346), // Rule ID 3239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3239,
        GIR_EraseRootFromParent_Done,
      // Label 8026: @469346
      GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(469421), // Rule ID 3242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3242,
        GIR_EraseRootFromParent_Done,
      // Label 8027: @469421
      GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(469496), // Rule ID 3243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3243,
        GIR_EraseRootFromParent_Done,
      // Label 8028: @469496
      GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(469571), // Rule ID 3246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3246,
        GIR_EraseRootFromParent_Done,
      // Label 8029: @469571
      GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(469646), // Rule ID 3247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3247,
        GIR_EraseRootFromParent_Done,
      // Label 8030: @469646
      GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(469721), // Rule ID 3250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3250,
        GIR_EraseRootFromParent_Done,
      // Label 8031: @469721
      GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(469796), // Rule ID 3251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3251,
        GIR_EraseRootFromParent_Done,
      // Label 8032: @469796
      GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(469871), // Rule ID 3254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3254,
        GIR_EraseRootFromParent_Done,
      // Label 8033: @469871
      GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(469946), // Rule ID 3255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3255,
        GIR_EraseRootFromParent_Done,
      // Label 8034: @469946
      GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(470021), // Rule ID 3258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3258,
        GIR_EraseRootFromParent_Done,
      // Label 8035: @470021
      GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(470096), // Rule ID 3259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3259,
        GIR_EraseRootFromParent_Done,
      // Label 8036: @470096
      GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(470171), // Rule ID 3262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3262,
        GIR_EraseRootFromParent_Done,
      // Label 8037: @470171
      GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(470246), // Rule ID 3263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3263,
        GIR_EraseRootFromParent_Done,
      // Label 8038: @470246
      GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(470321), // Rule ID 3266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3266,
        GIR_EraseRootFromParent_Done,
      // Label 8039: @470321
      GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(470396), // Rule ID 3267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3267,
        GIR_EraseRootFromParent_Done,
      // Label 8040: @470396
      GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(470471), // Rule ID 3270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3270,
        GIR_EraseRootFromParent_Done,
      // Label 8041: @470471
      GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(470546), // Rule ID 3271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3271,
        GIR_EraseRootFromParent_Done,
      // Label 8042: @470546
      GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(470621), // Rule ID 3274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3274,
        GIR_EraseRootFromParent_Done,
      // Label 8043: @470621
      GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(470696), // Rule ID 3275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3275,
        GIR_EraseRootFromParent_Done,
      // Label 8044: @470696
      GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(470771), // Rule ID 3278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3278,
        GIR_EraseRootFromParent_Done,
      // Label 8045: @470771
      GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(470846), // Rule ID 3279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3279,
        GIR_EraseRootFromParent_Done,
      // Label 8046: @470846
      GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(470921), // Rule ID 3282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3282,
        GIR_EraseRootFromParent_Done,
      // Label 8047: @470921
      GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(470996), // Rule ID 3283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3283,
        GIR_EraseRootFromParent_Done,
      // Label 8048: @470996
      GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(471071), // Rule ID 3286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3286,
        GIR_EraseRootFromParent_Done,
      // Label 8049: @471071
      GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(471146), // Rule ID 3287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11136:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3287,
        GIR_EraseRootFromParent_Done,
      // Label 8050: @471146
      GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(471221), // Rule ID 3290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3290,
        GIR_EraseRootFromParent_Done,
      // Label 8051: @471221
      GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(471296), // Rule ID 3291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3291,
        GIR_EraseRootFromParent_Done,
      // Label 8052: @471296
      GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(471371), // Rule ID 3294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3294,
        GIR_EraseRootFromParent_Done,
      // Label 8053: @471371
      GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(471446), // Rule ID 3295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3295,
        GIR_EraseRootFromParent_Done,
      // Label 8054: @471446
      GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(471521), // Rule ID 3298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3298,
        GIR_EraseRootFromParent_Done,
      // Label 8055: @471521
      GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(471596), // Rule ID 3299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3299,
        GIR_EraseRootFromParent_Done,
      // Label 8056: @471596
      GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(471671), // Rule ID 3302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3302,
        GIR_EraseRootFromParent_Done,
      // Label 8057: @471671
      GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(471746), // Rule ID 3303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3303,
        GIR_EraseRootFromParent_Done,
      // Label 8058: @471746
      GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(471821), // Rule ID 3306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3306,
        GIR_EraseRootFromParent_Done,
      // Label 8059: @471821
      GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(471896), // Rule ID 3307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3307,
        GIR_EraseRootFromParent_Done,
      // Label 8060: @471896
      GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(471971), // Rule ID 3310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3310,
        GIR_EraseRootFromParent_Done,
      // Label 8061: @471971
      GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(472046), // Rule ID 3311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3311,
        GIR_EraseRootFromParent_Done,
      // Label 8062: @472046
      GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(472121), // Rule ID 3314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3314,
        GIR_EraseRootFromParent_Done,
      // Label 8063: @472121
      GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(472196), // Rule ID 3315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3315,
        GIR_EraseRootFromParent_Done,
      // Label 8064: @472196
      GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(472271), // Rule ID 3318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3318,
        GIR_EraseRootFromParent_Done,
      // Label 8065: @472271
      GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(472346), // Rule ID 3319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3319,
        GIR_EraseRootFromParent_Done,
      // Label 8066: @472346
      GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(472421), // Rule ID 3322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3322,
        GIR_EraseRootFromParent_Done,
      // Label 8067: @472421
      GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(472496), // Rule ID 3323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3323,
        GIR_EraseRootFromParent_Done,
      // Label 8068: @472496
      GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(472571), // Rule ID 3326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3326,
        GIR_EraseRootFromParent_Done,
      // Label 8069: @472571
      GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(472646), // Rule ID 3327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3327,
        GIR_EraseRootFromParent_Done,
      // Label 8070: @472646
      GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(472721), // Rule ID 3330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3330,
        GIR_EraseRootFromParent_Done,
      // Label 8071: @472721
      GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(472796), // Rule ID 3331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3331,
        GIR_EraseRootFromParent_Done,
      // Label 8072: @472796
      GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(472871), // Rule ID 3334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3334,
        GIR_EraseRootFromParent_Done,
      // Label 8073: @472871
      GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(472946), // Rule ID 3335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3335,
        GIR_EraseRootFromParent_Done,
      // Label 8074: @472946
      GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(473021), // Rule ID 3338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3338,
        GIR_EraseRootFromParent_Done,
      // Label 8075: @473021
      GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(473096), // Rule ID 3339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3339,
        GIR_EraseRootFromParent_Done,
      // Label 8076: @473096
      GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(473171), // Rule ID 3342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3342,
        GIR_EraseRootFromParent_Done,
      // Label 8077: @473171
      GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(473246), // Rule ID 3343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3343,
        GIR_EraseRootFromParent_Done,
      // Label 8078: @473246
      GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(473321), // Rule ID 3346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3346,
        GIR_EraseRootFromParent_Done,
      // Label 8079: @473321
      GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(473396), // Rule ID 3347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3347,
        GIR_EraseRootFromParent_Done,
      // Label 8080: @473396
      GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(473471), // Rule ID 3438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3438,
        GIR_EraseRootFromParent_Done,
      // Label 8081: @473471
      GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(473546), // Rule ID 3439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3439,
        GIR_EraseRootFromParent_Done,
      // Label 8082: @473546
      GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(473621), // Rule ID 3442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3442,
        GIR_EraseRootFromParent_Done,
      // Label 8083: @473621
      GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(473696), // Rule ID 3443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3443,
        GIR_EraseRootFromParent_Done,
      // Label 8084: @473696
      GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(473771), // Rule ID 3446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3446,
        GIR_EraseRootFromParent_Done,
      // Label 8085: @473771
      GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(473846), // Rule ID 3447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3447,
        GIR_EraseRootFromParent_Done,
      // Label 8086: @473846
      GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(473921), // Rule ID 3450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3450,
        GIR_EraseRootFromParent_Done,
      // Label 8087: @473921
      GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(473996), // Rule ID 3451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3451,
        GIR_EraseRootFromParent_Done,
      // Label 8088: @473996
      GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(474071), // Rule ID 3454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3454,
        GIR_EraseRootFromParent_Done,
      // Label 8089: @474071
      GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(474146), // Rule ID 3455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3455,
        GIR_EraseRootFromParent_Done,
      // Label 8090: @474146
      GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(474221), // Rule ID 3458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3458,
        GIR_EraseRootFromParent_Done,
      // Label 8091: @474221
      GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(474296), // Rule ID 3459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3459,
        GIR_EraseRootFromParent_Done,
      // Label 8092: @474296
      GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(474371), // Rule ID 3462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3462,
        GIR_EraseRootFromParent_Done,
      // Label 8093: @474371
      GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(474446), // Rule ID 3463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3463,
        GIR_EraseRootFromParent_Done,
      // Label 8094: @474446
      GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(474521), // Rule ID 3466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3466,
        GIR_EraseRootFromParent_Done,
      // Label 8095: @474521
      GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(474596), // Rule ID 3467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3467,
        GIR_EraseRootFromParent_Done,
      // Label 8096: @474596
      GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(474671), // Rule ID 3470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3470,
        GIR_EraseRootFromParent_Done,
      // Label 8097: @474671
      GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(474746), // Rule ID 3471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3471,
        GIR_EraseRootFromParent_Done,
      // Label 8098: @474746
      GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(474821), // Rule ID 3474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3474,
        GIR_EraseRootFromParent_Done,
      // Label 8099: @474821
      GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(474896), // Rule ID 3475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3475,
        GIR_EraseRootFromParent_Done,
      // Label 8100: @474896
      GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(474971), // Rule ID 3478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3478,
        GIR_EraseRootFromParent_Done,
      // Label 8101: @474971
      GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(475046), // Rule ID 3479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3479,
        GIR_EraseRootFromParent_Done,
      // Label 8102: @475046
      GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(475121), // Rule ID 3482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3482,
        GIR_EraseRootFromParent_Done,
      // Label 8103: @475121
      GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(475196), // Rule ID 3483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3483,
        GIR_EraseRootFromParent_Done,
      // Label 8104: @475196
      GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(475271), // Rule ID 3486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3486,
        GIR_EraseRootFromParent_Done,
      // Label 8105: @475271
      GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(475346), // Rule ID 3487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3487,
        GIR_EraseRootFromParent_Done,
      // Label 8106: @475346
      GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(475421), // Rule ID 3490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3490,
        GIR_EraseRootFromParent_Done,
      // Label 8107: @475421
      GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(475496), // Rule ID 3491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3491,
        GIR_EraseRootFromParent_Done,
      // Label 8108: @475496
      GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(475571), // Rule ID 3494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3494,
        GIR_EraseRootFromParent_Done,
      // Label 8109: @475571
      GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(475646), // Rule ID 3495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3495,
        GIR_EraseRootFromParent_Done,
      // Label 8110: @475646
      GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(475721), // Rule ID 3498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3498,
        GIR_EraseRootFromParent_Done,
      // Label 8111: @475721
      GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(475796), // Rule ID 3499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3499,
        GIR_EraseRootFromParent_Done,
      // Label 8112: @475796
      GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(475871), // Rule ID 3502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3502,
        GIR_EraseRootFromParent_Done,
      // Label 8113: @475871
      GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(475946), // Rule ID 3503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3503,
        GIR_EraseRootFromParent_Done,
      // Label 8114: @475946
      GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(476021), // Rule ID 3506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3506,
        GIR_EraseRootFromParent_Done,
      // Label 8115: @476021
      GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(476096), // Rule ID 3507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3507,
        GIR_EraseRootFromParent_Done,
      // Label 8116: @476096
      GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(476171), // Rule ID 3510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3510,
        GIR_EraseRootFromParent_Done,
      // Label 8117: @476171
      GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(476246), // Rule ID 3511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3511,
        GIR_EraseRootFromParent_Done,
      // Label 8118: @476246
      GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(476321), // Rule ID 3514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3514,
        GIR_EraseRootFromParent_Done,
      // Label 8119: @476321
      GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(476396), // Rule ID 3515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3515,
        GIR_EraseRootFromParent_Done,
      // Label 8120: @476396
      GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(476471), // Rule ID 3518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3518,
        GIR_EraseRootFromParent_Done,
      // Label 8121: @476471
      GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(476546), // Rule ID 3519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3519,
        GIR_EraseRootFromParent_Done,
      // Label 8122: @476546
      GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(476621), // Rule ID 3522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3522,
        GIR_EraseRootFromParent_Done,
      // Label 8123: @476621
      GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(476696), // Rule ID 3523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3523,
        GIR_EraseRootFromParent_Done,
      // Label 8124: @476696
      GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(476771), // Rule ID 3526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3526,
        GIR_EraseRootFromParent_Done,
      // Label 8125: @476771
      GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(476846), // Rule ID 3527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3527,
        GIR_EraseRootFromParent_Done,
      // Label 8126: @476846
      GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(476921), // Rule ID 3530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3530,
        GIR_EraseRootFromParent_Done,
      // Label 8127: @476921
      GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(476996), // Rule ID 3531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3531,
        GIR_EraseRootFromParent_Done,
      // Label 8128: @476996
      GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(477071), // Rule ID 3534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3534,
        GIR_EraseRootFromParent_Done,
      // Label 8129: @477071
      GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(477146), // Rule ID 3535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3535,
        GIR_EraseRootFromParent_Done,
      // Label 8130: @477146
      GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(477221), // Rule ID 3538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3538,
        GIR_EraseRootFromParent_Done,
      // Label 8131: @477221
      GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(477296), // Rule ID 3539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3539,
        GIR_EraseRootFromParent_Done,
      // Label 8132: @477296
      GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(477371), // Rule ID 3542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3542,
        GIR_EraseRootFromParent_Done,
      // Label 8133: @477371
      GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(477446), // Rule ID 3543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3543,
        GIR_EraseRootFromParent_Done,
      // Label 8134: @477446
      GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(477521), // Rule ID 3546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3546,
        GIR_EraseRootFromParent_Done,
      // Label 8135: @477521
      GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(477596), // Rule ID 3547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3547,
        GIR_EraseRootFromParent_Done,
      // Label 8136: @477596
      GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(477671), // Rule ID 3550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3550,
        GIR_EraseRootFromParent_Done,
      // Label 8137: @477671
      GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(477746), // Rule ID 3551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3551,
        GIR_EraseRootFromParent_Done,
      // Label 8138: @477746
      GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(477821), // Rule ID 3554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3554,
        GIR_EraseRootFromParent_Done,
      // Label 8139: @477821
      GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(477896), // Rule ID 3555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3555,
        GIR_EraseRootFromParent_Done,
      // Label 8140: @477896
      GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(477971), // Rule ID 3558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3558,
        GIR_EraseRootFromParent_Done,
      // Label 8141: @477971
      GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(478046), // Rule ID 3559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3559,
        GIR_EraseRootFromParent_Done,
      // Label 8142: @478046
      GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(478121), // Rule ID 3562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3562,
        GIR_EraseRootFromParent_Done,
      // Label 8143: @478121
      GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(478196), // Rule ID 3563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3563,
        GIR_EraseRootFromParent_Done,
      // Label 8144: @478196
      GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(478271), // Rule ID 3566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3566,
        GIR_EraseRootFromParent_Done,
      // Label 8145: @478271
      GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(478346), // Rule ID 3567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3567,
        GIR_EraseRootFromParent_Done,
      // Label 8146: @478346
      GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(478421), // Rule ID 3570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3570,
        GIR_EraseRootFromParent_Done,
      // Label 8147: @478421
      GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(478496), // Rule ID 3571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3571,
        GIR_EraseRootFromParent_Done,
      // Label 8148: @478496
      GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(478571), // Rule ID 3574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3574,
        GIR_EraseRootFromParent_Done,
      // Label 8149: @478571
      GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(478646), // Rule ID 3575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3575,
        GIR_EraseRootFromParent_Done,
      // Label 8150: @478646
      GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(478721), // Rule ID 3578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3578,
        GIR_EraseRootFromParent_Done,
      // Label 8151: @478721
      GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(478796), // Rule ID 3579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3579,
        GIR_EraseRootFromParent_Done,
      // Label 8152: @478796
      GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(478871), // Rule ID 3582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3582,
        GIR_EraseRootFromParent_Done,
      // Label 8153: @478871
      GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(478946), // Rule ID 3583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3583,
        GIR_EraseRootFromParent_Done,
      // Label 8154: @478946
      GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(479021), // Rule ID 3586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3586,
        GIR_EraseRootFromParent_Done,
      // Label 8155: @479021
      GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(479096), // Rule ID 3587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3587,
        GIR_EraseRootFromParent_Done,
      // Label 8156: @479096
      GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(479171), // Rule ID 3590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3590,
        GIR_EraseRootFromParent_Done,
      // Label 8157: @479171
      GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(479246), // Rule ID 3591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3591,
        GIR_EraseRootFromParent_Done,
      // Label 8158: @479246
      GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(479321), // Rule ID 3594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3594,
        GIR_EraseRootFromParent_Done,
      // Label 8159: @479321
      GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(479396), // Rule ID 3595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3595,
        GIR_EraseRootFromParent_Done,
      // Label 8160: @479396
      GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(479471), // Rule ID 3598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3598,
        GIR_EraseRootFromParent_Done,
      // Label 8161: @479471
      GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(479546), // Rule ID 3599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3599,
        GIR_EraseRootFromParent_Done,
      // Label 8162: @479546
      GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(479621), // Rule ID 3602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3602,
        GIR_EraseRootFromParent_Done,
      // Label 8163: @479621
      GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(479696), // Rule ID 3603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3603,
        GIR_EraseRootFromParent_Done,
      // Label 8164: @479696
      GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(479771), // Rule ID 3606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3606,
        GIR_EraseRootFromParent_Done,
      // Label 8165: @479771
      GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(479846), // Rule ID 3607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3607,
        GIR_EraseRootFromParent_Done,
      // Label 8166: @479846
      GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(479921), // Rule ID 3610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3610,
        GIR_EraseRootFromParent_Done,
      // Label 8167: @479921
      GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(479996), // Rule ID 3611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3611,
        GIR_EraseRootFromParent_Done,
      // Label 8168: @479996
      GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(480071), // Rule ID 3614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3614,
        GIR_EraseRootFromParent_Done,
      // Label 8169: @480071
      GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(480146), // Rule ID 3615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3615,
        GIR_EraseRootFromParent_Done,
      // Label 8170: @480146
      GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(480221), // Rule ID 3618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3618,
        GIR_EraseRootFromParent_Done,
      // Label 8171: @480221
      GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(480296), // Rule ID 3619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3619,
        GIR_EraseRootFromParent_Done,
      // Label 8172: @480296
      GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(480371), // Rule ID 3622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3622,
        GIR_EraseRootFromParent_Done,
      // Label 8173: @480371
      GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(480446), // Rule ID 3623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3623,
        GIR_EraseRootFromParent_Done,
      // Label 8174: @480446
      GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(480521), // Rule ID 3626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3626,
        GIR_EraseRootFromParent_Done,
      // Label 8175: @480521
      GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(480596), // Rule ID 3627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3627,
        GIR_EraseRootFromParent_Done,
      // Label 8176: @480596
      GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(480671), // Rule ID 3630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3630,
        GIR_EraseRootFromParent_Done,
      // Label 8177: @480671
      GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(480746), // Rule ID 3631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3631,
        GIR_EraseRootFromParent_Done,
      // Label 8178: @480746
      GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(480821), // Rule ID 3634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3634,
        GIR_EraseRootFromParent_Done,
      // Label 8179: @480821
      GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(480896), // Rule ID 3635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3635,
        GIR_EraseRootFromParent_Done,
      // Label 8180: @480896
      GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(480971), // Rule ID 3638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3638,
        GIR_EraseRootFromParent_Done,
      // Label 8181: @480971
      GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(481046), // Rule ID 3639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3639,
        GIR_EraseRootFromParent_Done,
      // Label 8182: @481046
      GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(481121), // Rule ID 3642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3642,
        GIR_EraseRootFromParent_Done,
      // Label 8183: @481121
      GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(481196), // Rule ID 3643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3643,
        GIR_EraseRootFromParent_Done,
      // Label 8184: @481196
      GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(481271), // Rule ID 3646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3646,
        GIR_EraseRootFromParent_Done,
      // Label 8185: @481271
      GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(481346), // Rule ID 3647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3647,
        GIR_EraseRootFromParent_Done,
      // Label 8186: @481346
      GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(481421), // Rule ID 3650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3650,
        GIR_EraseRootFromParent_Done,
      // Label 8187: @481421
      GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(481496), // Rule ID 3651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3651,
        GIR_EraseRootFromParent_Done,
      // Label 8188: @481496
      GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(481571), // Rule ID 3654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3654,
        GIR_EraseRootFromParent_Done,
      // Label 8189: @481571
      GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(481646), // Rule ID 3655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3655,
        GIR_EraseRootFromParent_Done,
      // Label 8190: @481646
      GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(481721), // Rule ID 3658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3658,
        GIR_EraseRootFromParent_Done,
      // Label 8191: @481721
      GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(481796), // Rule ID 3659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3659,
        GIR_EraseRootFromParent_Done,
      // Label 8192: @481796
      GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(481871), // Rule ID 3662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3662,
        GIR_EraseRootFromParent_Done,
      // Label 8193: @481871
      GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(481946), // Rule ID 3663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3663,
        GIR_EraseRootFromParent_Done,
      // Label 8194: @481946
      GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(482021), // Rule ID 3666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3666,
        GIR_EraseRootFromParent_Done,
      // Label 8195: @482021
      GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(482096), // Rule ID 3667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3667,
        GIR_EraseRootFromParent_Done,
      // Label 8196: @482096
      GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(482171), // Rule ID 3670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3670,
        GIR_EraseRootFromParent_Done,
      // Label 8197: @482171
      GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(482246), // Rule ID 3671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3671,
        GIR_EraseRootFromParent_Done,
      // Label 8198: @482246
      GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(482321), // Rule ID 3674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3674,
        GIR_EraseRootFromParent_Done,
      // Label 8199: @482321
      GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(482396), // Rule ID 3675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3675,
        GIR_EraseRootFromParent_Done,
      // Label 8200: @482396
      GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(482471), // Rule ID 3678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3678,
        GIR_EraseRootFromParent_Done,
      // Label 8201: @482471
      GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(482546), // Rule ID 3679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3679,
        GIR_EraseRootFromParent_Done,
      // Label 8202: @482546
      GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(482621), // Rule ID 3682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3682,
        GIR_EraseRootFromParent_Done,
      // Label 8203: @482621
      GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(482696), // Rule ID 3683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3683,
        GIR_EraseRootFromParent_Done,
      // Label 8204: @482696
      GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(482771), // Rule ID 3686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3686,
        GIR_EraseRootFromParent_Done,
      // Label 8205: @482771
      GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(482846), // Rule ID 3687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3687,
        GIR_EraseRootFromParent_Done,
      // Label 8206: @482846
      GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(482921), // Rule ID 3690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3690,
        GIR_EraseRootFromParent_Done,
      // Label 8207: @482921
      GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(482996), // Rule ID 3691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3691,
        GIR_EraseRootFromParent_Done,
      // Label 8208: @482996
      GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(483071), // Rule ID 3694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3694,
        GIR_EraseRootFromParent_Done,
      // Label 8209: @483071
      GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(483146), // Rule ID 3695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3695,
        GIR_EraseRootFromParent_Done,
      // Label 8210: @483146
      GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(483221), // Rule ID 3698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3698,
        GIR_EraseRootFromParent_Done,
      // Label 8211: @483221
      GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(483296), // Rule ID 3699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3699,
        GIR_EraseRootFromParent_Done,
      // Label 8212: @483296
      GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(483371), // Rule ID 3702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3702,
        GIR_EraseRootFromParent_Done,
      // Label 8213: @483371
      GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(483446), // Rule ID 3703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3703,
        GIR_EraseRootFromParent_Done,
      // Label 8214: @483446
      GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(483521), // Rule ID 3706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3706,
        GIR_EraseRootFromParent_Done,
      // Label 8215: @483521
      GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(483596), // Rule ID 3707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3707,
        GIR_EraseRootFromParent_Done,
      // Label 8216: @483596
      GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(483671), // Rule ID 3710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3710,
        GIR_EraseRootFromParent_Done,
      // Label 8217: @483671
      GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(483746), // Rule ID 3711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3711,
        GIR_EraseRootFromParent_Done,
      // Label 8218: @483746
      GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(483821), // Rule ID 3714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3714,
        GIR_EraseRootFromParent_Done,
      // Label 8219: @483821
      GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(483896), // Rule ID 3715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3715,
        GIR_EraseRootFromParent_Done,
      // Label 8220: @483896
      GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(483971), // Rule ID 3718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3718,
        GIR_EraseRootFromParent_Done,
      // Label 8221: @483971
      GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(484046), // Rule ID 3719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3719,
        GIR_EraseRootFromParent_Done,
      // Label 8222: @484046
      GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(484121), // Rule ID 3722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3722,
        GIR_EraseRootFromParent_Done,
      // Label 8223: @484121
      GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(484196), // Rule ID 3723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3723,
        GIR_EraseRootFromParent_Done,
      // Label 8224: @484196
      GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(484271), // Rule ID 3726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3726,
        GIR_EraseRootFromParent_Done,
      // Label 8225: @484271
      GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(484346), // Rule ID 3727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3727,
        GIR_EraseRootFromParent_Done,
      // Label 8226: @484346
      GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(484421), // Rule ID 3730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3730,
        GIR_EraseRootFromParent_Done,
      // Label 8227: @484421
      GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(484496), // Rule ID 3731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3731,
        GIR_EraseRootFromParent_Done,
      // Label 8228: @484496
      GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(484571), // Rule ID 3734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3734,
        GIR_EraseRootFromParent_Done,
      // Label 8229: @484571
      GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(484646), // Rule ID 3735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3735,
        GIR_EraseRootFromParent_Done,
      // Label 8230: @484646
      GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(484721), // Rule ID 3738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3738,
        GIR_EraseRootFromParent_Done,
      // Label 8231: @484721
      GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(484796), // Rule ID 3739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3739,
        GIR_EraseRootFromParent_Done,
      // Label 8232: @484796
      GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(484871), // Rule ID 3742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3742,
        GIR_EraseRootFromParent_Done,
      // Label 8233: @484871
      GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(484946), // Rule ID 3743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3743,
        GIR_EraseRootFromParent_Done,
      // Label 8234: @484946
      GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(485021), // Rule ID 3746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3746,
        GIR_EraseRootFromParent_Done,
      // Label 8235: @485021
      GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(485096), // Rule ID 3747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3747,
        GIR_EraseRootFromParent_Done,
      // Label 8236: @485096
      GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(485171), // Rule ID 3750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3750,
        GIR_EraseRootFromParent_Done,
      // Label 8237: @485171
      GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(485246), // Rule ID 3751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3751,
        GIR_EraseRootFromParent_Done,
      // Label 8238: @485246
      GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(485321), // Rule ID 3754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3754,
        GIR_EraseRootFromParent_Done,
      // Label 8239: @485321
      GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(485396), // Rule ID 3755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3755,
        GIR_EraseRootFromParent_Done,
      // Label 8240: @485396
      GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(485471), // Rule ID 3758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3758,
        GIR_EraseRootFromParent_Done,
      // Label 8241: @485471
      GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(485546), // Rule ID 3759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3759,
        GIR_EraseRootFromParent_Done,
      // Label 8242: @485546
      GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(485621), // Rule ID 3762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3762,
        GIR_EraseRootFromParent_Done,
      // Label 8243: @485621
      GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(485696), // Rule ID 3763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3763,
        GIR_EraseRootFromParent_Done,
      // Label 8244: @485696
      GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(485771), // Rule ID 3766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3766,
        GIR_EraseRootFromParent_Done,
      // Label 8245: @485771
      GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(485846), // Rule ID 3767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3767,
        GIR_EraseRootFromParent_Done,
      // Label 8246: @485846
      GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(485921), // Rule ID 3770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3770,
        GIR_EraseRootFromParent_Done,
      // Label 8247: @485921
      GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(485996), // Rule ID 3771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3771,
        GIR_EraseRootFromParent_Done,
      // Label 8248: @485996
      GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(486071), // Rule ID 3774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3774,
        GIR_EraseRootFromParent_Done,
      // Label 8249: @486071
      GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(486146), // Rule ID 3775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3775,
        GIR_EraseRootFromParent_Done,
      // Label 8250: @486146
      GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(486221), // Rule ID 3778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3778,
        GIR_EraseRootFromParent_Done,
      // Label 8251: @486221
      GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(486296), // Rule ID 3779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3779,
        GIR_EraseRootFromParent_Done,
      // Label 8252: @486296
      GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(486371), // Rule ID 3782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3782,
        GIR_EraseRootFromParent_Done,
      // Label 8253: @486371
      GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(486446), // Rule ID 3783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3783,
        GIR_EraseRootFromParent_Done,
      // Label 8254: @486446
      GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(486521), // Rule ID 3786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3786,
        GIR_EraseRootFromParent_Done,
      // Label 8255: @486521
      GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(486596), // Rule ID 3787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3787,
        GIR_EraseRootFromParent_Done,
      // Label 8256: @486596
      GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(486671), // Rule ID 3790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3790,
        GIR_EraseRootFromParent_Done,
      // Label 8257: @486671
      GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(486746), // Rule ID 3791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3791,
        GIR_EraseRootFromParent_Done,
      // Label 8258: @486746
      GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(486821), // Rule ID 3794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3794,
        GIR_EraseRootFromParent_Done,
      // Label 8259: @486821
      GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(486896), // Rule ID 3795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3795,
        GIR_EraseRootFromParent_Done,
      // Label 8260: @486896
      GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(486971), // Rule ID 3798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3798,
        GIR_EraseRootFromParent_Done,
      // Label 8261: @486971
      GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(487046), // Rule ID 3799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3799,
        GIR_EraseRootFromParent_Done,
      // Label 8262: @487046
      GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(487121), // Rule ID 3802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3802,
        GIR_EraseRootFromParent_Done,
      // Label 8263: @487121
      GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(487196), // Rule ID 3803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3803,
        GIR_EraseRootFromParent_Done,
      // Label 8264: @487196
      GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(487271), // Rule ID 3806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3806,
        GIR_EraseRootFromParent_Done,
      // Label 8265: @487271
      GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(487346), // Rule ID 3807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3807,
        GIR_EraseRootFromParent_Done,
      // Label 8266: @487346
      GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(487421), // Rule ID 3810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3810,
        GIR_EraseRootFromParent_Done,
      // Label 8267: @487421
      GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(487496), // Rule ID 3811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3811,
        GIR_EraseRootFromParent_Done,
      // Label 8268: @487496
      GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(487571), // Rule ID 3814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3814,
        GIR_EraseRootFromParent_Done,
      // Label 8269: @487571
      GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(487646), // Rule ID 3815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3815,
        GIR_EraseRootFromParent_Done,
      // Label 8270: @487646
      GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(487721), // Rule ID 3818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3818,
        GIR_EraseRootFromParent_Done,
      // Label 8271: @487721
      GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(487796), // Rule ID 3819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3819,
        GIR_EraseRootFromParent_Done,
      // Label 8272: @487796
      GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(487871), // Rule ID 3822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3822,
        GIR_EraseRootFromParent_Done,
      // Label 8273: @487871
      GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(487946), // Rule ID 3823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3823,
        GIR_EraseRootFromParent_Done,
      // Label 8274: @487946
      GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(488021), // Rule ID 3826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3826,
        GIR_EraseRootFromParent_Done,
      // Label 8275: @488021
      GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(488096), // Rule ID 3827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3827,
        GIR_EraseRootFromParent_Done,
      // Label 8276: @488096
      GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(488171), // Rule ID 3830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3830,
        GIR_EraseRootFromParent_Done,
      // Label 8277: @488171
      GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(488246), // Rule ID 3831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3831,
        GIR_EraseRootFromParent_Done,
      // Label 8278: @488246
      GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(488321), // Rule ID 3834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3834,
        GIR_EraseRootFromParent_Done,
      // Label 8279: @488321
      GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(488396), // Rule ID 3835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3835,
        GIR_EraseRootFromParent_Done,
      // Label 8280: @488396
      GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(488471), // Rule ID 3838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3838,
        GIR_EraseRootFromParent_Done,
      // Label 8281: @488471
      GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(488546), // Rule ID 3839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3839,
        GIR_EraseRootFromParent_Done,
      // Label 8282: @488546
      GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(488621), // Rule ID 3842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3842,
        GIR_EraseRootFromParent_Done,
      // Label 8283: @488621
      GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(488696), // Rule ID 3843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3843,
        GIR_EraseRootFromParent_Done,
      // Label 8284: @488696
      GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(488771), // Rule ID 3846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3846,
        GIR_EraseRootFromParent_Done,
      // Label 8285: @488771
      GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(488846), // Rule ID 3847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3847,
        GIR_EraseRootFromParent_Done,
      // Label 8286: @488846
      GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(488921), // Rule ID 3850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3850,
        GIR_EraseRootFromParent_Done,
      // Label 8287: @488921
      GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(488996), // Rule ID 3851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3851,
        GIR_EraseRootFromParent_Done,
      // Label 8288: @488996
      GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(489071), // Rule ID 3854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3854,
        GIR_EraseRootFromParent_Done,
      // Label 8289: @489071
      GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(489146), // Rule ID 3855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3855,
        GIR_EraseRootFromParent_Done,
      // Label 8290: @489146
      GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(489221), // Rule ID 3858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3858,
        GIR_EraseRootFromParent_Done,
      // Label 8291: @489221
      GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(489296), // Rule ID 3859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3859,
        GIR_EraseRootFromParent_Done,
      // Label 8292: @489296
      GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(489371), // Rule ID 3862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3862,
        GIR_EraseRootFromParent_Done,
      // Label 8293: @489371
      GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(489446), // Rule ID 3863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3863,
        GIR_EraseRootFromParent_Done,
      // Label 8294: @489446
      GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(489521), // Rule ID 3866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3866,
        GIR_EraseRootFromParent_Done,
      // Label 8295: @489521
      GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(489596), // Rule ID 3867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3867,
        GIR_EraseRootFromParent_Done,
      // Label 8296: @489596
      GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(489671), // Rule ID 3870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3870,
        GIR_EraseRootFromParent_Done,
      // Label 8297: @489671
      GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(489746), // Rule ID 3871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3871,
        GIR_EraseRootFromParent_Done,
      // Label 8298: @489746
      GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(489821), // Rule ID 3874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3874,
        GIR_EraseRootFromParent_Done,
      // Label 8299: @489821
      GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(489896), // Rule ID 3875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3875,
        GIR_EraseRootFromParent_Done,
      // Label 8300: @489896
      GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(489971), // Rule ID 3878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3878,
        GIR_EraseRootFromParent_Done,
      // Label 8301: @489971
      GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(490046), // Rule ID 3879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3879,
        GIR_EraseRootFromParent_Done,
      // Label 8302: @490046
      GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(490121), // Rule ID 3882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3882,
        GIR_EraseRootFromParent_Done,
      // Label 8303: @490121
      GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(490196), // Rule ID 3883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3883,
        GIR_EraseRootFromParent_Done,
      // Label 8304: @490196
      GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(490271), // Rule ID 3886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3886,
        GIR_EraseRootFromParent_Done,
      // Label 8305: @490271
      GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(490346), // Rule ID 3887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3887,
        GIR_EraseRootFromParent_Done,
      // Label 8306: @490346
      GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(490421), // Rule ID 3890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3890,
        GIR_EraseRootFromParent_Done,
      // Label 8307: @490421
      GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(490496), // Rule ID 3891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3891,
        GIR_EraseRootFromParent_Done,
      // Label 8308: @490496
      GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(490571), // Rule ID 3894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3894,
        GIR_EraseRootFromParent_Done,
      // Label 8309: @490571
      GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(490646), // Rule ID 3895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3895,
        GIR_EraseRootFromParent_Done,
      // Label 8310: @490646
      GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(490721), // Rule ID 3898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3898,
        GIR_EraseRootFromParent_Done,
      // Label 8311: @490721
      GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(490796), // Rule ID 3899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3899,
        GIR_EraseRootFromParent_Done,
      // Label 8312: @490796
      GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(490871), // Rule ID 3902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3902,
        GIR_EraseRootFromParent_Done,
      // Label 8313: @490871
      GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(490946), // Rule ID 3903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3903,
        GIR_EraseRootFromParent_Done,
      // Label 8314: @490946
      GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(491021), // Rule ID 3906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3906,
        GIR_EraseRootFromParent_Done,
      // Label 8315: @491021
      GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(491096), // Rule ID 3907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3907,
        GIR_EraseRootFromParent_Done,
      // Label 8316: @491096
      GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(491171), // Rule ID 3910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3910,
        GIR_EraseRootFromParent_Done,
      // Label 8317: @491171
      GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(491246), // Rule ID 3911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3911,
        GIR_EraseRootFromParent_Done,
      // Label 8318: @491246
      GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(491321), // Rule ID 3914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3914,
        GIR_EraseRootFromParent_Done,
      // Label 8319: @491321
      GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(491396), // Rule ID 3915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3915,
        GIR_EraseRootFromParent_Done,
      // Label 8320: @491396
      GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(491471), // Rule ID 3920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3920,
        GIR_EraseRootFromParent_Done,
      // Label 8321: @491471
      GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(491546), // Rule ID 3921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3921,
        GIR_EraseRootFromParent_Done,
      // Label 8322: @491546
      GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(491621), // Rule ID 3930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3930,
        GIR_EraseRootFromParent_Done,
      // Label 8323: @491621
      GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(491696), // Rule ID 3931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3931,
        GIR_EraseRootFromParent_Done,
      // Label 8324: @491696
      GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(491771), // Rule ID 3940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3940,
        GIR_EraseRootFromParent_Done,
      // Label 8325: @491771
      GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(491846), // Rule ID 3941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3941,
        GIR_EraseRootFromParent_Done,
      // Label 8326: @491846
      GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(491921), // Rule ID 3950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3950,
        GIR_EraseRootFromParent_Done,
      // Label 8327: @491921
      GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(491996), // Rule ID 3951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3951,
        GIR_EraseRootFromParent_Done,
      // Label 8328: @491996
      GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(492071), // Rule ID 3960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3960,
        GIR_EraseRootFromParent_Done,
      // Label 8329: @492071
      GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(492146), // Rule ID 3961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3961,
        GIR_EraseRootFromParent_Done,
      // Label 8330: @492146
      GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(492221), // Rule ID 3970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3970,
        GIR_EraseRootFromParent_Done,
      // Label 8331: @492221
      GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(492296), // Rule ID 3971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3971,
        GIR_EraseRootFromParent_Done,
      // Label 8332: @492296
      GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(492371), // Rule ID 3980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3980,
        GIR_EraseRootFromParent_Done,
      // Label 8333: @492371
      GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(492446), // Rule ID 3981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3981,
        GIR_EraseRootFromParent_Done,
      // Label 8334: @492446
      GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(492521), // Rule ID 3990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3990,
        GIR_EraseRootFromParent_Done,
      // Label 8335: @492521
      GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(492596), // Rule ID 3991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3991,
        GIR_EraseRootFromParent_Done,
      // Label 8336: @492596
      GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(492671), // Rule ID 4000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4000,
        GIR_EraseRootFromParent_Done,
      // Label 8337: @492671
      GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(492746), // Rule ID 4001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4001,
        GIR_EraseRootFromParent_Done,
      // Label 8338: @492746
      GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(492821), // Rule ID 4010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4010,
        GIR_EraseRootFromParent_Done,
      // Label 8339: @492821
      GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(492896), // Rule ID 4011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4011,
        GIR_EraseRootFromParent_Done,
      // Label 8340: @492896
      GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(492971), // Rule ID 4020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4020,
        GIR_EraseRootFromParent_Done,
      // Label 8341: @492971
      GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(493046), // Rule ID 4021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4021,
        GIR_EraseRootFromParent_Done,
      // Label 8342: @493046
      GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(493121), // Rule ID 4030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4030,
        GIR_EraseRootFromParent_Done,
      // Label 8343: @493121
      GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(493196), // Rule ID 4031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4031,
        GIR_EraseRootFromParent_Done,
      // Label 8344: @493196
      GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(493271), // Rule ID 4040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4040,
        GIR_EraseRootFromParent_Done,
      // Label 8345: @493271
      GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(493346), // Rule ID 4041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4041,
        GIR_EraseRootFromParent_Done,
      // Label 8346: @493346
      GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(493421), // Rule ID 4050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4050,
        GIR_EraseRootFromParent_Done,
      // Label 8347: @493421
      GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(493496), // Rule ID 4051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4051,
        GIR_EraseRootFromParent_Done,
      // Label 8348: @493496
      GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(493571), // Rule ID 4058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4058,
        GIR_EraseRootFromParent_Done,
      // Label 8349: @493571
      GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(493646), // Rule ID 4059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4059,
        GIR_EraseRootFromParent_Done,
      // Label 8350: @493646
      GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(493721), // Rule ID 4062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4062,
        GIR_EraseRootFromParent_Done,
      // Label 8351: @493721
      GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(493796), // Rule ID 4063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4063,
        GIR_EraseRootFromParent_Done,
      // Label 8352: @493796
      GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(493871), // Rule ID 4066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4066,
        GIR_EraseRootFromParent_Done,
      // Label 8353: @493871
      GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(493946), // Rule ID 4067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4067,
        GIR_EraseRootFromParent_Done,
      // Label 8354: @493946
      GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(494021), // Rule ID 4070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4070,
        GIR_EraseRootFromParent_Done,
      // Label 8355: @494021
      GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(494096), // Rule ID 4071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4071,
        GIR_EraseRootFromParent_Done,
      // Label 8356: @494096
      GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(494171), // Rule ID 4074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4074,
        GIR_EraseRootFromParent_Done,
      // Label 8357: @494171
      GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(494246), // Rule ID 4075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4075,
        GIR_EraseRootFromParent_Done,
      // Label 8358: @494246
      GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(494321), // Rule ID 4078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4078,
        GIR_EraseRootFromParent_Done,
      // Label 8359: @494321
      GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(494396), // Rule ID 4079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4079,
        GIR_EraseRootFromParent_Done,
      // Label 8360: @494396
      GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(494471), // Rule ID 4082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4082,
        GIR_EraseRootFromParent_Done,
      // Label 8361: @494471
      GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(494546), // Rule ID 4083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4083,
        GIR_EraseRootFromParent_Done,
      // Label 8362: @494546
      GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(494621), // Rule ID 4086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4086,
        GIR_EraseRootFromParent_Done,
      // Label 8363: @494621
      GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(494696), // Rule ID 4087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4087,
        GIR_EraseRootFromParent_Done,
      // Label 8364: @494696
      GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(494771), // Rule ID 4090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4090,
        GIR_EraseRootFromParent_Done,
      // Label 8365: @494771
      GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(494846), // Rule ID 4091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4091,
        GIR_EraseRootFromParent_Done,
      // Label 8366: @494846
      GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(494921), // Rule ID 4094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4094,
        GIR_EraseRootFromParent_Done,
      // Label 8367: @494921
      GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(494996), // Rule ID 4095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4095,
        GIR_EraseRootFromParent_Done,
      // Label 8368: @494996
      GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(495071), // Rule ID 4098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4098,
        GIR_EraseRootFromParent_Done,
      // Label 8369: @495071
      GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(495146), // Rule ID 4099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4099,
        GIR_EraseRootFromParent_Done,
      // Label 8370: @495146
      GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(495221), // Rule ID 4102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4102,
        GIR_EraseRootFromParent_Done,
      // Label 8371: @495221
      GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(495296), // Rule ID 4103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4103,
        GIR_EraseRootFromParent_Done,
      // Label 8372: @495296
      GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(495371), // Rule ID 4106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4106,
        GIR_EraseRootFromParent_Done,
      // Label 8373: @495371
      GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(495446), // Rule ID 4107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4107,
        GIR_EraseRootFromParent_Done,
      // Label 8374: @495446
      GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(495521), // Rule ID 4110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4110,
        GIR_EraseRootFromParent_Done,
      // Label 8375: @495521
      GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(495596), // Rule ID 4111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4111,
        GIR_EraseRootFromParent_Done,
      // Label 8376: @495596
      GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(495671), // Rule ID 4114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4114,
        GIR_EraseRootFromParent_Done,
      // Label 8377: @495671
      GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(495746), // Rule ID 4115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4115,
        GIR_EraseRootFromParent_Done,
      // Label 8378: @495746
      GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(495821), // Rule ID 4120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4120,
        GIR_EraseRootFromParent_Done,
      // Label 8379: @495821
      GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(495896), // Rule ID 4121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4121,
        GIR_EraseRootFromParent_Done,
      // Label 8380: @495896
      GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(495971), // Rule ID 4130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4130,
        GIR_EraseRootFromParent_Done,
      // Label 8381: @495971
      GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(496046), // Rule ID 4131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4131,
        GIR_EraseRootFromParent_Done,
      // Label 8382: @496046
      GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(496121), // Rule ID 4140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4140,
        GIR_EraseRootFromParent_Done,
      // Label 8383: @496121
      GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(496196), // Rule ID 4141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4141,
        GIR_EraseRootFromParent_Done,
      // Label 8384: @496196
      GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(496271), // Rule ID 4150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4150,
        GIR_EraseRootFromParent_Done,
      // Label 8385: @496271
      GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(496346), // Rule ID 4151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4151,
        GIR_EraseRootFromParent_Done,
      // Label 8386: @496346
      GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(496421), // Rule ID 4160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4160,
        GIR_EraseRootFromParent_Done,
      // Label 8387: @496421
      GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(496496), // Rule ID 4161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4161,
        GIR_EraseRootFromParent_Done,
      // Label 8388: @496496
      GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(496571), // Rule ID 4170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4170,
        GIR_EraseRootFromParent_Done,
      // Label 8389: @496571
      GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(496646), // Rule ID 4171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4171,
        GIR_EraseRootFromParent_Done,
      // Label 8390: @496646
      GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(496721), // Rule ID 4180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4180,
        GIR_EraseRootFromParent_Done,
      // Label 8391: @496721
      GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(496796), // Rule ID 4181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4181,
        GIR_EraseRootFromParent_Done,
      // Label 8392: @496796
      GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(496871), // Rule ID 4190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4190,
        GIR_EraseRootFromParent_Done,
      // Label 8393: @496871
      GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(496946), // Rule ID 4191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4191,
        GIR_EraseRootFromParent_Done,
      // Label 8394: @496946
      GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(497021), // Rule ID 4200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4200,
        GIR_EraseRootFromParent_Done,
      // Label 8395: @497021
      GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(497096), // Rule ID 4201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4201,
        GIR_EraseRootFromParent_Done,
      // Label 8396: @497096
      GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(497171), // Rule ID 4210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4210,
        GIR_EraseRootFromParent_Done,
      // Label 8397: @497171
      GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(497246), // Rule ID 4211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4211,
        GIR_EraseRootFromParent_Done,
      // Label 8398: @497246
      GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(497321), // Rule ID 4220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4220,
        GIR_EraseRootFromParent_Done,
      // Label 8399: @497321
      GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(497396), // Rule ID 4221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4221,
        GIR_EraseRootFromParent_Done,
      // Label 8400: @497396
      GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(497471), // Rule ID 4230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4230,
        GIR_EraseRootFromParent_Done,
      // Label 8401: @497471
      GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(497546), // Rule ID 4231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4231,
        GIR_EraseRootFromParent_Done,
      // Label 8402: @497546
      GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(497621), // Rule ID 4240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4240,
        GIR_EraseRootFromParent_Done,
      // Label 8403: @497621
      GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(497696), // Rule ID 4241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4241,
        GIR_EraseRootFromParent_Done,
      // Label 8404: @497696
      GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(497771), // Rule ID 4250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4250,
        GIR_EraseRootFromParent_Done,
      // Label 8405: @497771
      GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(497846), // Rule ID 4251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4251,
        GIR_EraseRootFromParent_Done,
      // Label 8406: @497846
      GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(497921), // Rule ID 4260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4260,
        GIR_EraseRootFromParent_Done,
      // Label 8407: @497921
      GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(497996), // Rule ID 4261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4261,
        GIR_EraseRootFromParent_Done,
      // Label 8408: @497996
      GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(498071), // Rule ID 4268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4268,
        GIR_EraseRootFromParent_Done,
      // Label 8409: @498071
      GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(498146), // Rule ID 4269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4269,
        GIR_EraseRootFromParent_Done,
      // Label 8410: @498146
      GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(498221), // Rule ID 4272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4272,
        GIR_EraseRootFromParent_Done,
      // Label 8411: @498221
      GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(498296), // Rule ID 4273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4273,
        GIR_EraseRootFromParent_Done,
      // Label 8412: @498296
      GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(498371), // Rule ID 4276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4276,
        GIR_EraseRootFromParent_Done,
      // Label 8413: @498371
      GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(498446), // Rule ID 4277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4277,
        GIR_EraseRootFromParent_Done,
      // Label 8414: @498446
      GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(498521), // Rule ID 4280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4280,
        GIR_EraseRootFromParent_Done,
      // Label 8415: @498521
      GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(498596), // Rule ID 4281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4281,
        GIR_EraseRootFromParent_Done,
      // Label 8416: @498596
      GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(498671), // Rule ID 4284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4284,
        GIR_EraseRootFromParent_Done,
      // Label 8417: @498671
      GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(498746), // Rule ID 4285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4285,
        GIR_EraseRootFromParent_Done,
      // Label 8418: @498746
      GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(498821), // Rule ID 4288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4288,
        GIR_EraseRootFromParent_Done,
      // Label 8419: @498821
      GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(498896), // Rule ID 4289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4289,
        GIR_EraseRootFromParent_Done,
      // Label 8420: @498896
      GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(498971), // Rule ID 4292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4292,
        GIR_EraseRootFromParent_Done,
      // Label 8421: @498971
      GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(499046), // Rule ID 4293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4293,
        GIR_EraseRootFromParent_Done,
      // Label 8422: @499046
      GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(499121), // Rule ID 4296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4296,
        GIR_EraseRootFromParent_Done,
      // Label 8423: @499121
      GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(499196), // Rule ID 4297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4297,
        GIR_EraseRootFromParent_Done,
      // Label 8424: @499196
      GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(499271), // Rule ID 4300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4300,
        GIR_EraseRootFromParent_Done,
      // Label 8425: @499271
      GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(499346), // Rule ID 4301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4301,
        GIR_EraseRootFromParent_Done,
      // Label 8426: @499346
      GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(499421), // Rule ID 4304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4304,
        GIR_EraseRootFromParent_Done,
      // Label 8427: @499421
      GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(499496), // Rule ID 4305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4305,
        GIR_EraseRootFromParent_Done,
      // Label 8428: @499496
      GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(499571), // Rule ID 4308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4308,
        GIR_EraseRootFromParent_Done,
      // Label 8429: @499571
      GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(499646), // Rule ID 4309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4309,
        GIR_EraseRootFromParent_Done,
      // Label 8430: @499646
      GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(499721), // Rule ID 4312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4312,
        GIR_EraseRootFromParent_Done,
      // Label 8431: @499721
      GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(499796), // Rule ID 4313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4313,
        GIR_EraseRootFromParent_Done,
      // Label 8432: @499796
      GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(499871), // Rule ID 4316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4316,
        GIR_EraseRootFromParent_Done,
      // Label 8433: @499871
      GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(499946), // Rule ID 4317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4317,
        GIR_EraseRootFromParent_Done,
      // Label 8434: @499946
      GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(500021), // Rule ID 4320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4320,
        GIR_EraseRootFromParent_Done,
      // Label 8435: @500021
      GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(500096), // Rule ID 4321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4321,
        GIR_EraseRootFromParent_Done,
      // Label 8436: @500096
      GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(500171), // Rule ID 4324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4324,
        GIR_EraseRootFromParent_Done,
      // Label 8437: @500171
      GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(500246), // Rule ID 4325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4325,
        GIR_EraseRootFromParent_Done,
      // Label 8438: @500246
      GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(500321), // Rule ID 4330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4330,
        GIR_EraseRootFromParent_Done,
      // Label 8439: @500321
      GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(500396), // Rule ID 4331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4331,
        GIR_EraseRootFromParent_Done,
      // Label 8440: @500396
      GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(500471), // Rule ID 4340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4340,
        GIR_EraseRootFromParent_Done,
      // Label 8441: @500471
      GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(500546), // Rule ID 4341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4341,
        GIR_EraseRootFromParent_Done,
      // Label 8442: @500546
      GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(500621), // Rule ID 4350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4350,
        GIR_EraseRootFromParent_Done,
      // Label 8443: @500621
      GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(500696), // Rule ID 4351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4351,
        GIR_EraseRootFromParent_Done,
      // Label 8444: @500696
      GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(500771), // Rule ID 4360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4360,
        GIR_EraseRootFromParent_Done,
      // Label 8445: @500771
      GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(500846), // Rule ID 4361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4361,
        GIR_EraseRootFromParent_Done,
      // Label 8446: @500846
      GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(500921), // Rule ID 4370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4370,
        GIR_EraseRootFromParent_Done,
      // Label 8447: @500921
      GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(500996), // Rule ID 4371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4371,
        GIR_EraseRootFromParent_Done,
      // Label 8448: @500996
      GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(501071), // Rule ID 4380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4380,
        GIR_EraseRootFromParent_Done,
      // Label 8449: @501071
      GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(501146), // Rule ID 4381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4381,
        GIR_EraseRootFromParent_Done,
      // Label 8450: @501146
      GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(501221), // Rule ID 4390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4390,
        GIR_EraseRootFromParent_Done,
      // Label 8451: @501221
      GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(501296), // Rule ID 4391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4391,
        GIR_EraseRootFromParent_Done,
      // Label 8452: @501296
      GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(501371), // Rule ID 4400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4400,
        GIR_EraseRootFromParent_Done,
      // Label 8453: @501371
      GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(501446), // Rule ID 4401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4401,
        GIR_EraseRootFromParent_Done,
      // Label 8454: @501446
      GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(501521), // Rule ID 4410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4410,
        GIR_EraseRootFromParent_Done,
      // Label 8455: @501521
      GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(501596), // Rule ID 4411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4411,
        GIR_EraseRootFromParent_Done,
      // Label 8456: @501596
      GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(501671), // Rule ID 4420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4420,
        GIR_EraseRootFromParent_Done,
      // Label 8457: @501671
      GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(501746), // Rule ID 4421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4421,
        GIR_EraseRootFromParent_Done,
      // Label 8458: @501746
      GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(501821), // Rule ID 4430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4430,
        GIR_EraseRootFromParent_Done,
      // Label 8459: @501821
      GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(501896), // Rule ID 4431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4431,
        GIR_EraseRootFromParent_Done,
      // Label 8460: @501896
      GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(501971), // Rule ID 4440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4440,
        GIR_EraseRootFromParent_Done,
      // Label 8461: @501971
      GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(502046), // Rule ID 4441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4441,
        GIR_EraseRootFromParent_Done,
      // Label 8462: @502046
      GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(502121), // Rule ID 4450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4450,
        GIR_EraseRootFromParent_Done,
      // Label 8463: @502121
      GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(502196), // Rule ID 4451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4451,
        GIR_EraseRootFromParent_Done,
      // Label 8464: @502196
      GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(502271), // Rule ID 4460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4460,
        GIR_EraseRootFromParent_Done,
      // Label 8465: @502271
      GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(502346), // Rule ID 4461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4461,
        GIR_EraseRootFromParent_Done,
      // Label 8466: @502346
      GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(502421), // Rule ID 4470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4470,
        GIR_EraseRootFromParent_Done,
      // Label 8467: @502421
      GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(502496), // Rule ID 4471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4471,
        GIR_EraseRootFromParent_Done,
      // Label 8468: @502496
      GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(502571), // Rule ID 4478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4478,
        GIR_EraseRootFromParent_Done,
      // Label 8469: @502571
      GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(502646), // Rule ID 4479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4479,
        GIR_EraseRootFromParent_Done,
      // Label 8470: @502646
      GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(502721), // Rule ID 4482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4482,
        GIR_EraseRootFromParent_Done,
      // Label 8471: @502721
      GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(502796), // Rule ID 4483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4483,
        GIR_EraseRootFromParent_Done,
      // Label 8472: @502796
      GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(502871), // Rule ID 4486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4486,
        GIR_EraseRootFromParent_Done,
      // Label 8473: @502871
      GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(502946), // Rule ID 4487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4487,
        GIR_EraseRootFromParent_Done,
      // Label 8474: @502946
      GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(503021), // Rule ID 4490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4490,
        GIR_EraseRootFromParent_Done,
      // Label 8475: @503021
      GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(503096), // Rule ID 4491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4491,
        GIR_EraseRootFromParent_Done,
      // Label 8476: @503096
      GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(503171), // Rule ID 4494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4494,
        GIR_EraseRootFromParent_Done,
      // Label 8477: @503171
      GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(503246), // Rule ID 4495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4495,
        GIR_EraseRootFromParent_Done,
      // Label 8478: @503246
      GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(503321), // Rule ID 4498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4498,
        GIR_EraseRootFromParent_Done,
      // Label 8479: @503321
      GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(503396), // Rule ID 4499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4499,
        GIR_EraseRootFromParent_Done,
      // Label 8480: @503396
      GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(503471), // Rule ID 4502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4502,
        GIR_EraseRootFromParent_Done,
      // Label 8481: @503471
      GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(503546), // Rule ID 4503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4503,
        GIR_EraseRootFromParent_Done,
      // Label 8482: @503546
      GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(503621), // Rule ID 4506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4506,
        GIR_EraseRootFromParent_Done,
      // Label 8483: @503621
      GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(503696), // Rule ID 4507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4507,
        GIR_EraseRootFromParent_Done,
      // Label 8484: @503696
      GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(503771), // Rule ID 4510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4510,
        GIR_EraseRootFromParent_Done,
      // Label 8485: @503771
      GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(503846), // Rule ID 4511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4511,
        GIR_EraseRootFromParent_Done,
      // Label 8486: @503846
      GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(503921), // Rule ID 4514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4514,
        GIR_EraseRootFromParent_Done,
      // Label 8487: @503921
      GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(503996), // Rule ID 4515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4515,
        GIR_EraseRootFromParent_Done,
      // Label 8488: @503996
      GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(504071), // Rule ID 4518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4518,
        GIR_EraseRootFromParent_Done,
      // Label 8489: @504071
      GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(504146), // Rule ID 4519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4519,
        GIR_EraseRootFromParent_Done,
      // Label 8490: @504146
      GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(504221), // Rule ID 4522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4522,
        GIR_EraseRootFromParent_Done,
      // Label 8491: @504221
      GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(504296), // Rule ID 4523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4523,
        GIR_EraseRootFromParent_Done,
      // Label 8492: @504296
      GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(504371), // Rule ID 4526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4526,
        GIR_EraseRootFromParent_Done,
      // Label 8493: @504371
      GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(504446), // Rule ID 4527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4527,
        GIR_EraseRootFromParent_Done,
      // Label 8494: @504446
      GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(504521), // Rule ID 4530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4530,
        GIR_EraseRootFromParent_Done,
      // Label 8495: @504521
      GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(504596), // Rule ID 4531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4531,
        GIR_EraseRootFromParent_Done,
      // Label 8496: @504596
      GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(504671), // Rule ID 4534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4534,
        GIR_EraseRootFromParent_Done,
      // Label 8497: @504671
      GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(504746), // Rule ID 4535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4535,
        GIR_EraseRootFromParent_Done,
      // Label 8498: @504746
      GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(504821), // Rule ID 4540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4540,
        GIR_EraseRootFromParent_Done,
      // Label 8499: @504821
      GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(504896), // Rule ID 4541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4541,
        GIR_EraseRootFromParent_Done,
      // Label 8500: @504896
      GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(504971), // Rule ID 4550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4550,
        GIR_EraseRootFromParent_Done,
      // Label 8501: @504971
      GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(505046), // Rule ID 4551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4551,
        GIR_EraseRootFromParent_Done,
      // Label 8502: @505046
      GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(505121), // Rule ID 4560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4560,
        GIR_EraseRootFromParent_Done,
      // Label 8503: @505121
      GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(505196), // Rule ID 4561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4561,
        GIR_EraseRootFromParent_Done,
      // Label 8504: @505196
      GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(505271), // Rule ID 4570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4570,
        GIR_EraseRootFromParent_Done,
      // Label 8505: @505271
      GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(505346), // Rule ID 4571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4571,
        GIR_EraseRootFromParent_Done,
      // Label 8506: @505346
      GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(505421), // Rule ID 4580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4580,
        GIR_EraseRootFromParent_Done,
      // Label 8507: @505421
      GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(505496), // Rule ID 4581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4581,
        GIR_EraseRootFromParent_Done,
      // Label 8508: @505496
      GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(505571), // Rule ID 4590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4590,
        GIR_EraseRootFromParent_Done,
      // Label 8509: @505571
      GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(505646), // Rule ID 4591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4591,
        GIR_EraseRootFromParent_Done,
      // Label 8510: @505646
      GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(505721), // Rule ID 4600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4600,
        GIR_EraseRootFromParent_Done,
      // Label 8511: @505721
      GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(505796), // Rule ID 4601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4601,
        GIR_EraseRootFromParent_Done,
      // Label 8512: @505796
      GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(505871), // Rule ID 4610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4610,
        GIR_EraseRootFromParent_Done,
      // Label 8513: @505871
      GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(505946), // Rule ID 4611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4611,
        GIR_EraseRootFromParent_Done,
      // Label 8514: @505946
      GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(506021), // Rule ID 4620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4620,
        GIR_EraseRootFromParent_Done,
      // Label 8515: @506021
      GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(506096), // Rule ID 4621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4621,
        GIR_EraseRootFromParent_Done,
      // Label 8516: @506096
      GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(506171), // Rule ID 4630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4630,
        GIR_EraseRootFromParent_Done,
      // Label 8517: @506171
      GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(506246), // Rule ID 4631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4631,
        GIR_EraseRootFromParent_Done,
      // Label 8518: @506246
      GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(506321), // Rule ID 4640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4640,
        GIR_EraseRootFromParent_Done,
      // Label 8519: @506321
      GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(506396), // Rule ID 4641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4641,
        GIR_EraseRootFromParent_Done,
      // Label 8520: @506396
      GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(506471), // Rule ID 4650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4650,
        GIR_EraseRootFromParent_Done,
      // Label 8521: @506471
      GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(506546), // Rule ID 4651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4651,
        GIR_EraseRootFromParent_Done,
      // Label 8522: @506546
      GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(506621), // Rule ID 4660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4660,
        GIR_EraseRootFromParent_Done,
      // Label 8523: @506621
      GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(506696), // Rule ID 4661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4661,
        GIR_EraseRootFromParent_Done,
      // Label 8524: @506696
      GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(506771), // Rule ID 4670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4670,
        GIR_EraseRootFromParent_Done,
      // Label 8525: @506771
      GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(506846), // Rule ID 4671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4671,
        GIR_EraseRootFromParent_Done,
      // Label 8526: @506846
      GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(506921), // Rule ID 4680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4680,
        GIR_EraseRootFromParent_Done,
      // Label 8527: @506921
      GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(506996), // Rule ID 4681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4681,
        GIR_EraseRootFromParent_Done,
      // Label 8528: @506996
      GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(507071), // Rule ID 4688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4688,
        GIR_EraseRootFromParent_Done,
      // Label 8529: @507071
      GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(507146), // Rule ID 4689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4689,
        GIR_EraseRootFromParent_Done,
      // Label 8530: @507146
      GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(507221), // Rule ID 4692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4692,
        GIR_EraseRootFromParent_Done,
      // Label 8531: @507221
      GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(507296), // Rule ID 4693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4693,
        GIR_EraseRootFromParent_Done,
      // Label 8532: @507296
      GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(507371), // Rule ID 4696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4696,
        GIR_EraseRootFromParent_Done,
      // Label 8533: @507371
      GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(507446), // Rule ID 4697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4697,
        GIR_EraseRootFromParent_Done,
      // Label 8534: @507446
      GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(507521), // Rule ID 4700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4700,
        GIR_EraseRootFromParent_Done,
      // Label 8535: @507521
      GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(507596), // Rule ID 4701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4701,
        GIR_EraseRootFromParent_Done,
      // Label 8536: @507596
      GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(507671), // Rule ID 4704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4704,
        GIR_EraseRootFromParent_Done,
      // Label 8537: @507671
      GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(507746), // Rule ID 4705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4705,
        GIR_EraseRootFromParent_Done,
      // Label 8538: @507746
      GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(507821), // Rule ID 4708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4708,
        GIR_EraseRootFromParent_Done,
      // Label 8539: @507821
      GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(507896), // Rule ID 4709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4709,
        GIR_EraseRootFromParent_Done,
      // Label 8540: @507896
      GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(507971), // Rule ID 4712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4712,
        GIR_EraseRootFromParent_Done,
      // Label 8541: @507971
      GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(508046), // Rule ID 4713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4713,
        GIR_EraseRootFromParent_Done,
      // Label 8542: @508046
      GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(508121), // Rule ID 4716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4716,
        GIR_EraseRootFromParent_Done,
      // Label 8543: @508121
      GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(508196), // Rule ID 4717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4717,
        GIR_EraseRootFromParent_Done,
      // Label 8544: @508196
      GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(508271), // Rule ID 4720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4720,
        GIR_EraseRootFromParent_Done,
      // Label 8545: @508271
      GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(508346), // Rule ID 4721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4721,
        GIR_EraseRootFromParent_Done,
      // Label 8546: @508346
      GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(508421), // Rule ID 4724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4724,
        GIR_EraseRootFromParent_Done,
      // Label 8547: @508421
      GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(508496), // Rule ID 4725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4725,
        GIR_EraseRootFromParent_Done,
      // Label 8548: @508496
      GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(508571), // Rule ID 4728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4728,
        GIR_EraseRootFromParent_Done,
      // Label 8549: @508571
      GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(508646), // Rule ID 4729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4729,
        GIR_EraseRootFromParent_Done,
      // Label 8550: @508646
      GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(508721), // Rule ID 4732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4732,
        GIR_EraseRootFromParent_Done,
      // Label 8551: @508721
      GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(508796), // Rule ID 4733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4733,
        GIR_EraseRootFromParent_Done,
      // Label 8552: @508796
      GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(508871), // Rule ID 4736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4736,
        GIR_EraseRootFromParent_Done,
      // Label 8553: @508871
      GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(508946), // Rule ID 4737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4737,
        GIR_EraseRootFromParent_Done,
      // Label 8554: @508946
      GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(509021), // Rule ID 4740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4740,
        GIR_EraseRootFromParent_Done,
      // Label 8555: @509021
      GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(509096), // Rule ID 4741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4741,
        GIR_EraseRootFromParent_Done,
      // Label 8556: @509096
      GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(509171), // Rule ID 4744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4744,
        GIR_EraseRootFromParent_Done,
      // Label 8557: @509171
      GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(509246), // Rule ID 4745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4745,
        GIR_EraseRootFromParent_Done,
      // Label 8558: @509246
      GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(509336), // Rule ID 5098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5098,
        GIR_EraseRootFromParent_Done,
      // Label 8559: @509336
      GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(509426), // Rule ID 5099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5099,
        GIR_EraseRootFromParent_Done,
      // Label 8560: @509426
      GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(509516), // Rule ID 5100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5100,
        GIR_EraseRootFromParent_Done,
      // Label 8561: @509516
      GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(509606), // Rule ID 5101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5101,
        GIR_EraseRootFromParent_Done,
      // Label 8562: @509606
      GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(509696), // Rule ID 5102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5102,
        GIR_EraseRootFromParent_Done,
      // Label 8563: @509696
      GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(509786), // Rule ID 5103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5103,
        GIR_EraseRootFromParent_Done,
      // Label 8564: @509786
      GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(509876), // Rule ID 5104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5104,
        GIR_EraseRootFromParent_Done,
      // Label 8565: @509876
      GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(509966), // Rule ID 5105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5105,
        GIR_EraseRootFromParent_Done,
      // Label 8566: @509966
      GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(510056), // Rule ID 5106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5106,
        GIR_EraseRootFromParent_Done,
      // Label 8567: @510056
      GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(510146), // Rule ID 5107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5107,
        GIR_EraseRootFromParent_Done,
      // Label 8568: @510146
      GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(510236), // Rule ID 5108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5108,
        GIR_EraseRootFromParent_Done,
      // Label 8569: @510236
      GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(510326), // Rule ID 5109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5109,
        GIR_EraseRootFromParent_Done,
      // Label 8570: @510326
      GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(510416), // Rule ID 5110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5110,
        GIR_EraseRootFromParent_Done,
      // Label 8571: @510416
      GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(510506), // Rule ID 5111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5111,
        GIR_EraseRootFromParent_Done,
      // Label 8572: @510506
      GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(510596), // Rule ID 5112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5112,
        GIR_EraseRootFromParent_Done,
      // Label 8573: @510596
      GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(510686), // Rule ID 5113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5113,
        GIR_EraseRootFromParent_Done,
      // Label 8574: @510686
      GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(510776), // Rule ID 5114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5114,
        GIR_EraseRootFromParent_Done,
      // Label 8575: @510776
      GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(510866), // Rule ID 5115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5115,
        GIR_EraseRootFromParent_Done,
      // Label 8576: @510866
      GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(510956), // Rule ID 5116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5116,
        GIR_EraseRootFromParent_Done,
      // Label 8577: @510956
      GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(511046), // Rule ID 5117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5117,
        GIR_EraseRootFromParent_Done,
      // Label 8578: @511046
      GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(511136), // Rule ID 5118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5118,
        GIR_EraseRootFromParent_Done,
      // Label 8579: @511136
      GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(511226), // Rule ID 5119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5119,
        GIR_EraseRootFromParent_Done,
      // Label 8580: @511226
      GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(511316), // Rule ID 5120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5120,
        GIR_EraseRootFromParent_Done,
      // Label 8581: @511316
      GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(511406), // Rule ID 5121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5121,
        GIR_EraseRootFromParent_Done,
      // Label 8582: @511406
      GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(511496), // Rule ID 5122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5122,
        GIR_EraseRootFromParent_Done,
      // Label 8583: @511496
      GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(511586), // Rule ID 5123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5123,
        GIR_EraseRootFromParent_Done,
      // Label 8584: @511586
      GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(511676), // Rule ID 5124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5124,
        GIR_EraseRootFromParent_Done,
      // Label 8585: @511676
      GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(511766), // Rule ID 5125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5125,
        GIR_EraseRootFromParent_Done,
      // Label 8586: @511766
      GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(511856), // Rule ID 5126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5126,
        GIR_EraseRootFromParent_Done,
      // Label 8587: @511856
      GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(511946), // Rule ID 5127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5127,
        GIR_EraseRootFromParent_Done,
      // Label 8588: @511946
      GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(512036), // Rule ID 5128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5128,
        GIR_EraseRootFromParent_Done,
      // Label 8589: @512036
      GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(512126), // Rule ID 5129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5129,
        GIR_EraseRootFromParent_Done,
      // Label 8590: @512126
      GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(512216), // Rule ID 5130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5130,
        GIR_EraseRootFromParent_Done,
      // Label 8591: @512216
      GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(512306), // Rule ID 5131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5131,
        GIR_EraseRootFromParent_Done,
      // Label 8592: @512306
      GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(512396), // Rule ID 5132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5132,
        GIR_EraseRootFromParent_Done,
      // Label 8593: @512396
      GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(512486), // Rule ID 5133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5133,
        GIR_EraseRootFromParent_Done,
      // Label 8594: @512486
      GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(512576), // Rule ID 5134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5134,
        GIR_EraseRootFromParent_Done,
      // Label 8595: @512576
      GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(512666), // Rule ID 5135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5135,
        GIR_EraseRootFromParent_Done,
      // Label 8596: @512666
      GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(512756), // Rule ID 5136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5136,
        GIR_EraseRootFromParent_Done,
      // Label 8597: @512756
      GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(512846), // Rule ID 5137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5137,
        GIR_EraseRootFromParent_Done,
      // Label 8598: @512846
      GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(512936), // Rule ID 5138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5138,
        GIR_EraseRootFromParent_Done,
      // Label 8599: @512936
      GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(513026), // Rule ID 5139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5139,
        GIR_EraseRootFromParent_Done,
      // Label 8600: @513026
      GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(513116), // Rule ID 5140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5140,
        GIR_EraseRootFromParent_Done,
      // Label 8601: @513116
      GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(513206), // Rule ID 5141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5141,
        GIR_EraseRootFromParent_Done,
      // Label 8602: @513206
      GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(513296), // Rule ID 5142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5142,
        GIR_EraseRootFromParent_Done,
      // Label 8603: @513296
      GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(513386), // Rule ID 5143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5143,
        GIR_EraseRootFromParent_Done,
      // Label 8604: @513386
      GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(513476), // Rule ID 5144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5144,
        GIR_EraseRootFromParent_Done,
      // Label 8605: @513476
      GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(513566), // Rule ID 5145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5145,
        GIR_EraseRootFromParent_Done,
      // Label 8606: @513566
      GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(513656), // Rule ID 5146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5146,
        GIR_EraseRootFromParent_Done,
      // Label 8607: @513656
      GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(513746), // Rule ID 5147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5147,
        GIR_EraseRootFromParent_Done,
      // Label 8608: @513746
      GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(513836), // Rule ID 5148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5148,
        GIR_EraseRootFromParent_Done,
      // Label 8609: @513836
      GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(513926), // Rule ID 5149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5149,
        GIR_EraseRootFromParent_Done,
      // Label 8610: @513926
      GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(514016), // Rule ID 5150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5150,
        GIR_EraseRootFromParent_Done,
      // Label 8611: @514016
      GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(514106), // Rule ID 5151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5151,
        GIR_EraseRootFromParent_Done,
      // Label 8612: @514106
      GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(514196), // Rule ID 5152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5152,
        GIR_EraseRootFromParent_Done,
      // Label 8613: @514196
      GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(514286), // Rule ID 5153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5153,
        GIR_EraseRootFromParent_Done,
      // Label 8614: @514286
      GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(514376), // Rule ID 5154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5154,
        GIR_EraseRootFromParent_Done,
      // Label 8615: @514376
      GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(514466), // Rule ID 5155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5155,
        GIR_EraseRootFromParent_Done,
      // Label 8616: @514466
      GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(514556), // Rule ID 5156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5156,
        GIR_EraseRootFromParent_Done,
      // Label 8617: @514556
      GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(514646), // Rule ID 5157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5157,
        GIR_EraseRootFromParent_Done,
      // Label 8618: @514646
      GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(514736), // Rule ID 5158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5158,
        GIR_EraseRootFromParent_Done,
      // Label 8619: @514736
      GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(514826), // Rule ID 5159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11016:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5159,
        GIR_EraseRootFromParent_Done,
      // Label 8620: @514826
      GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(514916), // Rule ID 5160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5160,
        GIR_EraseRootFromParent_Done,
      // Label 8621: @514916
      GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(515006), // Rule ID 5161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5161,
        GIR_EraseRootFromParent_Done,
      // Label 8622: @515006
      GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(515096), // Rule ID 5162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5162,
        GIR_EraseRootFromParent_Done,
      // Label 8623: @515096
      GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(515186), // Rule ID 5163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5163,
        GIR_EraseRootFromParent_Done,
      // Label 8624: @515186
      GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(515276), // Rule ID 5164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5164,
        GIR_EraseRootFromParent_Done,
      // Label 8625: @515276
      GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(515366), // Rule ID 5165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5165,
        GIR_EraseRootFromParent_Done,
      // Label 8626: @515366
      GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(515456), // Rule ID 5166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5166,
        GIR_EraseRootFromParent_Done,
      // Label 8627: @515456
      GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(515546), // Rule ID 5167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5167,
        GIR_EraseRootFromParent_Done,
      // Label 8628: @515546
      GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(515636), // Rule ID 5168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5168,
        GIR_EraseRootFromParent_Done,
      // Label 8629: @515636
      GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(515726), // Rule ID 5169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5169,
        GIR_EraseRootFromParent_Done,
      // Label 8630: @515726
      GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(515816), // Rule ID 5170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5170,
        GIR_EraseRootFromParent_Done,
      // Label 8631: @515816
      GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(515906), // Rule ID 5171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5171,
        GIR_EraseRootFromParent_Done,
      // Label 8632: @515906
      GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(515996), // Rule ID 5172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5172,
        GIR_EraseRootFromParent_Done,
      // Label 8633: @515996
      GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(516086), // Rule ID 5173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5173,
        GIR_EraseRootFromParent_Done,
      // Label 8634: @516086
      GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(516176), // Rule ID 5174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5174,
        GIR_EraseRootFromParent_Done,
      // Label 8635: @516176
      GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(516266), // Rule ID 5175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5175,
        GIR_EraseRootFromParent_Done,
      // Label 8636: @516266
      GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(516356), // Rule ID 5176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5176,
        GIR_EraseRootFromParent_Done,
      // Label 8637: @516356
      GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(516446), // Rule ID 5177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5177,
        GIR_EraseRootFromParent_Done,
      // Label 8638: @516446
      GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(516536), // Rule ID 5178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5178,
        GIR_EraseRootFromParent_Done,
      // Label 8639: @516536
      GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(516626), // Rule ID 5179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11016:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5179,
        GIR_EraseRootFromParent_Done,
      // Label 8640: @516626
      GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(516716), // Rule ID 5180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5180,
        GIR_EraseRootFromParent_Done,
      // Label 8641: @516716
      GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(516806), // Rule ID 5181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11016:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5181,
        GIR_EraseRootFromParent_Done,
      // Label 8642: @516806
      GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(516896), // Rule ID 5182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5182,
        GIR_EraseRootFromParent_Done,
      // Label 8643: @516896
      GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(516986), // Rule ID 5183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11016:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5183,
        GIR_EraseRootFromParent_Done,
      // Label 8644: @516986
      GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(517076), // Rule ID 5446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5446,
        GIR_EraseRootFromParent_Done,
      // Label 8645: @517076
      GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(517166), // Rule ID 5447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5447,
        GIR_EraseRootFromParent_Done,
      // Label 8646: @517166
      GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(517256), // Rule ID 5448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5448,
        GIR_EraseRootFromParent_Done,
      // Label 8647: @517256
      GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(517346), // Rule ID 5449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5449,
        GIR_EraseRootFromParent_Done,
      // Label 8648: @517346
      GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(517436), // Rule ID 5450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5450,
        GIR_EraseRootFromParent_Done,
      // Label 8649: @517436
      GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(517526), // Rule ID 5451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5451,
        GIR_EraseRootFromParent_Done,
      // Label 8650: @517526
      GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(517616), // Rule ID 5452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5452,
        GIR_EraseRootFromParent_Done,
      // Label 8651: @517616
      GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(517706), // Rule ID 5453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5453,
        GIR_EraseRootFromParent_Done,
      // Label 8652: @517706
      GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(517796), // Rule ID 5454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5454,
        GIR_EraseRootFromParent_Done,
      // Label 8653: @517796
      GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(517886), // Rule ID 5455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5455,
        GIR_EraseRootFromParent_Done,
      // Label 8654: @517886
      GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(517976), // Rule ID 5456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5456,
        GIR_EraseRootFromParent_Done,
      // Label 8655: @517976
      GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(518066), // Rule ID 5457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5457,
        GIR_EraseRootFromParent_Done,
      // Label 8656: @518066
      GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(518156), // Rule ID 5458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5458,
        GIR_EraseRootFromParent_Done,
      // Label 8657: @518156
      GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(518246), // Rule ID 5459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5459,
        GIR_EraseRootFromParent_Done,
      // Label 8658: @518246
      GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(518336), // Rule ID 5460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5460,
        GIR_EraseRootFromParent_Done,
      // Label 8659: @518336
      GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(518426), // Rule ID 5461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5461,
        GIR_EraseRootFromParent_Done,
      // Label 8660: @518426
      GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(518516), // Rule ID 5462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5462,
        GIR_EraseRootFromParent_Done,
      // Label 8661: @518516
      GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(518606), // Rule ID 5463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5463,
        GIR_EraseRootFromParent_Done,
      // Label 8662: @518606
      GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(518696), // Rule ID 5464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5464,
        GIR_EraseRootFromParent_Done,
      // Label 8663: @518696
      GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(518786), // Rule ID 5465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5465,
        GIR_EraseRootFromParent_Done,
      // Label 8664: @518786
      GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(518876), // Rule ID 5466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5466,
        GIR_EraseRootFromParent_Done,
      // Label 8665: @518876
      GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(518966), // Rule ID 5467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5467,
        GIR_EraseRootFromParent_Done,
      // Label 8666: @518966
      GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(519056), // Rule ID 5468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5468,
        GIR_EraseRootFromParent_Done,
      // Label 8667: @519056
      GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(519146), // Rule ID 5469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5469,
        GIR_EraseRootFromParent_Done,
      // Label 8668: @519146
      GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(519236), // Rule ID 5470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5470,
        GIR_EraseRootFromParent_Done,
      // Label 8669: @519236
      GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(519326), // Rule ID 5471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5471,
        GIR_EraseRootFromParent_Done,
      // Label 8670: @519326
      GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(519416), // Rule ID 5472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5472,
        GIR_EraseRootFromParent_Done,
      // Label 8671: @519416
      GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(519506), // Rule ID 5473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5473,
        GIR_EraseRootFromParent_Done,
      // Label 8672: @519506
      GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(519596), // Rule ID 5474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5474,
        GIR_EraseRootFromParent_Done,
      // Label 8673: @519596
      GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(519686), // Rule ID 5475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5475,
        GIR_EraseRootFromParent_Done,
      // Label 8674: @519686
      GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(519776), // Rule ID 5476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5476,
        GIR_EraseRootFromParent_Done,
      // Label 8675: @519776
      GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(519866), // Rule ID 5477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5477,
        GIR_EraseRootFromParent_Done,
      // Label 8676: @519866
      GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(519956), // Rule ID 5478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5478,
        GIR_EraseRootFromParent_Done,
      // Label 8677: @519956
      GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(520046), // Rule ID 5479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5479,
        GIR_EraseRootFromParent_Done,
      // Label 8678: @520046
      GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(520136), // Rule ID 5480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5480,
        GIR_EraseRootFromParent_Done,
      // Label 8679: @520136
      GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(520226), // Rule ID 5481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5481,
        GIR_EraseRootFromParent_Done,
      // Label 8680: @520226
      GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(520316), // Rule ID 5482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5482,
        GIR_EraseRootFromParent_Done,
      // Label 8681: @520316
      GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(520406), // Rule ID 5483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5483,
        GIR_EraseRootFromParent_Done,
      // Label 8682: @520406
      GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(520496), // Rule ID 5484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5484,
        GIR_EraseRootFromParent_Done,
      // Label 8683: @520496
      GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(520586), // Rule ID 5485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5485,
        GIR_EraseRootFromParent_Done,
      // Label 8684: @520586
      GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(520676), // Rule ID 5486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5486,
        GIR_EraseRootFromParent_Done,
      // Label 8685: @520676
      GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(520766), // Rule ID 5487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5487,
        GIR_EraseRootFromParent_Done,
      // Label 8686: @520766
      GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(520856), // Rule ID 5488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5488,
        GIR_EraseRootFromParent_Done,
      // Label 8687: @520856
      GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(520946), // Rule ID 5489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5489,
        GIR_EraseRootFromParent_Done,
      // Label 8688: @520946
      GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(521036), // Rule ID 5490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5490,
        GIR_EraseRootFromParent_Done,
      // Label 8689: @521036
      GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(521126), // Rule ID 5491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5491,
        GIR_EraseRootFromParent_Done,
      // Label 8690: @521126
      GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(521216), // Rule ID 5492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5492,
        GIR_EraseRootFromParent_Done,
      // Label 8691: @521216
      GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(521306), // Rule ID 5493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5493,
        GIR_EraseRootFromParent_Done,
      // Label 8692: @521306
      GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(521396), // Rule ID 5494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5494,
        GIR_EraseRootFromParent_Done,
      // Label 8693: @521396
      GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(521486), // Rule ID 5495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5495,
        GIR_EraseRootFromParent_Done,
      // Label 8694: @521486
      GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(521576), // Rule ID 5496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5496,
        GIR_EraseRootFromParent_Done,
      // Label 8695: @521576
      GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(521666), // Rule ID 5497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5497,
        GIR_EraseRootFromParent_Done,
      // Label 8696: @521666
      GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(521756), // Rule ID 5498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5498,
        GIR_EraseRootFromParent_Done,
      // Label 8697: @521756
      GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(521846), // Rule ID 5499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5499,
        GIR_EraseRootFromParent_Done,
      // Label 8698: @521846
      GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(521936), // Rule ID 5500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5500,
        GIR_EraseRootFromParent_Done,
      // Label 8699: @521936
      GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(522026), // Rule ID 5501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5501,
        GIR_EraseRootFromParent_Done,
      // Label 8700: @522026
      GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(522116), // Rule ID 5502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5502,
        GIR_EraseRootFromParent_Done,
      // Label 8701: @522116
      GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(522206), // Rule ID 5503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5503,
        GIR_EraseRootFromParent_Done,
      // Label 8702: @522206
      GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(522296), // Rule ID 5504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5504,
        GIR_EraseRootFromParent_Done,
      // Label 8703: @522296
      GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(522386), // Rule ID 5505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5505,
        GIR_EraseRootFromParent_Done,
      // Label 8704: @522386
      GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(522476), // Rule ID 5506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5506,
        GIR_EraseRootFromParent_Done,
      // Label 8705: @522476
      GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(522566), // Rule ID 5507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5507,
        GIR_EraseRootFromParent_Done,
      // Label 8706: @522566
      GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(522656), // Rule ID 5508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5508,
        GIR_EraseRootFromParent_Done,
      // Label 8707: @522656
      GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(522746), // Rule ID 5509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11048:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5509,
        GIR_EraseRootFromParent_Done,
      // Label 8708: @522746
      GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(522836), // Rule ID 5510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5510,
        GIR_EraseRootFromParent_Done,
      // Label 8709: @522836
      GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(522926), // Rule ID 5511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5511,
        GIR_EraseRootFromParent_Done,
      // Label 8710: @522926
      GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(523016), // Rule ID 5512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5512,
        GIR_EraseRootFromParent_Done,
      // Label 8711: @523016
      GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(523106), // Rule ID 5513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5513,
        GIR_EraseRootFromParent_Done,
      // Label 8712: @523106
      GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(523196), // Rule ID 5514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5514,
        GIR_EraseRootFromParent_Done,
      // Label 8713: @523196
      GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(523286), // Rule ID 5515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5515,
        GIR_EraseRootFromParent_Done,
      // Label 8714: @523286
      GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(523376), // Rule ID 5516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5516,
        GIR_EraseRootFromParent_Done,
      // Label 8715: @523376
      GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(523466), // Rule ID 5517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5517,
        GIR_EraseRootFromParent_Done,
      // Label 8716: @523466
      GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(523556), // Rule ID 5518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5518,
        GIR_EraseRootFromParent_Done,
      // Label 8717: @523556
      GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(523646), // Rule ID 5519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5519,
        GIR_EraseRootFromParent_Done,
      // Label 8718: @523646
      GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(523736), // Rule ID 5520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5520,
        GIR_EraseRootFromParent_Done,
      // Label 8719: @523736
      GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(523826), // Rule ID 5521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5521,
        GIR_EraseRootFromParent_Done,
      // Label 8720: @523826
      GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(523916), // Rule ID 5522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5522,
        GIR_EraseRootFromParent_Done,
      // Label 8721: @523916
      GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(524006), // Rule ID 5523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5523,
        GIR_EraseRootFromParent_Done,
      // Label 8722: @524006
      GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(524096), // Rule ID 5524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5524,
        GIR_EraseRootFromParent_Done,
      // Label 8723: @524096
      GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(524186), // Rule ID 5525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5525,
        GIR_EraseRootFromParent_Done,
      // Label 8724: @524186
      GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(524276), // Rule ID 5526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5526,
        GIR_EraseRootFromParent_Done,
      // Label 8725: @524276
      GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(524366), // Rule ID 5527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5527,
        GIR_EraseRootFromParent_Done,
      // Label 8726: @524366
      GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(524456), // Rule ID 5528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5528,
        GIR_EraseRootFromParent_Done,
      // Label 8727: @524456
      GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(524546), // Rule ID 5529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11048:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5529,
        GIR_EraseRootFromParent_Done,
      // Label 8728: @524546
      GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(524636), // Rule ID 5530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5530,
        GIR_EraseRootFromParent_Done,
      // Label 8729: @524636
      GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(524726), // Rule ID 5531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11048:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5531,
        GIR_EraseRootFromParent_Done,
      // Label 8730: @524726
      GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(524816), // Rule ID 5532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5532,
        GIR_EraseRootFromParent_Done,
      // Label 8731: @524816
      GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(524906), // Rule ID 5533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11048:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5533,
        GIR_EraseRootFromParent_Done,
      // Label 8732: @524906
      GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(524981), // Rule ID 5622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5622,
        GIR_EraseRootFromParent_Done,
      // Label 8733: @524981
      GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(525056), // Rule ID 5623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5623,
        GIR_EraseRootFromParent_Done,
      // Label 8734: @525056
      GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(525131), // Rule ID 5626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5626,
        GIR_EraseRootFromParent_Done,
      // Label 8735: @525131
      GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(525206), // Rule ID 5627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5627,
        GIR_EraseRootFromParent_Done,
      // Label 8736: @525206
      GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(525281), // Rule ID 5630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5630,
        GIR_EraseRootFromParent_Done,
      // Label 8737: @525281
      GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(525356), // Rule ID 5631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5631,
        GIR_EraseRootFromParent_Done,
      // Label 8738: @525356
      GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(525431), // Rule ID 5634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5634,
        GIR_EraseRootFromParent_Done,
      // Label 8739: @525431
      GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(525506), // Rule ID 5635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5635,
        GIR_EraseRootFromParent_Done,
      // Label 8740: @525506
      GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(525581), // Rule ID 5638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5638,
        GIR_EraseRootFromParent_Done,
      // Label 8741: @525581
      GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(525656), // Rule ID 5639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5639,
        GIR_EraseRootFromParent_Done,
      // Label 8742: @525656
      GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(525731), // Rule ID 5642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5642,
        GIR_EraseRootFromParent_Done,
      // Label 8743: @525731
      GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(525806), // Rule ID 5643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5643,
        GIR_EraseRootFromParent_Done,
      // Label 8744: @525806
      GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(525881), // Rule ID 5646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5646,
        GIR_EraseRootFromParent_Done,
      // Label 8745: @525881
      GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(525956), // Rule ID 5647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5647,
        GIR_EraseRootFromParent_Done,
      // Label 8746: @525956
      GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(526031), // Rule ID 5650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5650,
        GIR_EraseRootFromParent_Done,
      // Label 8747: @526031
      GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(526106), // Rule ID 5651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5651,
        GIR_EraseRootFromParent_Done,
      // Label 8748: @526106
      GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(526181), // Rule ID 5654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5654,
        GIR_EraseRootFromParent_Done,
      // Label 8749: @526181
      GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(526256), // Rule ID 5655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5655,
        GIR_EraseRootFromParent_Done,
      // Label 8750: @526256
      GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(526331), // Rule ID 5658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5658,
        GIR_EraseRootFromParent_Done,
      // Label 8751: @526331
      GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(526406), // Rule ID 5659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5659,
        GIR_EraseRootFromParent_Done,
      // Label 8752: @526406
      GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(526481), // Rule ID 5662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5662,
        GIR_EraseRootFromParent_Done,
      // Label 8753: @526481
      GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(526556), // Rule ID 5663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5663,
        GIR_EraseRootFromParent_Done,
      // Label 8754: @526556
      GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(526631), // Rule ID 5666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5666,
        GIR_EraseRootFromParent_Done,
      // Label 8755: @526631
      GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(526706), // Rule ID 5667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5667,
        GIR_EraseRootFromParent_Done,
      // Label 8756: @526706
      GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(526781), // Rule ID 5670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5670,
        GIR_EraseRootFromParent_Done,
      // Label 8757: @526781
      GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(526856), // Rule ID 5671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5671,
        GIR_EraseRootFromParent_Done,
      // Label 8758: @526856
      GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(526931), // Rule ID 5674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5674,
        GIR_EraseRootFromParent_Done,
      // Label 8759: @526931
      GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(527006), // Rule ID 5675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5675,
        GIR_EraseRootFromParent_Done,
      // Label 8760: @527006
      GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(527081), // Rule ID 5678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5678,
        GIR_EraseRootFromParent_Done,
      // Label 8761: @527081
      GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(527156), // Rule ID 5679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5679,
        GIR_EraseRootFromParent_Done,
      // Label 8762: @527156
      GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(527231), // Rule ID 5682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5682,
        GIR_EraseRootFromParent_Done,
      // Label 8763: @527231
      GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(527306), // Rule ID 5683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5683,
        GIR_EraseRootFromParent_Done,
      // Label 8764: @527306
      GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(527381), // Rule ID 5686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5686,
        GIR_EraseRootFromParent_Done,
      // Label 8765: @527381
      GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(527456), // Rule ID 5687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5687,
        GIR_EraseRootFromParent_Done,
      // Label 8766: @527456
      GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(527531), // Rule ID 5690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5690,
        GIR_EraseRootFromParent_Done,
      // Label 8767: @527531
      GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(527606), // Rule ID 5691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5691,
        GIR_EraseRootFromParent_Done,
      // Label 8768: @527606
      GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(527681), // Rule ID 5694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5694,
        GIR_EraseRootFromParent_Done,
      // Label 8769: @527681
      GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(527756), // Rule ID 5695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5695,
        GIR_EraseRootFromParent_Done,
      // Label 8770: @527756
      GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(527831), // Rule ID 5698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5698,
        GIR_EraseRootFromParent_Done,
      // Label 8771: @527831
      GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(527906), // Rule ID 5699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5699,
        GIR_EraseRootFromParent_Done,
      // Label 8772: @527906
      GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(527981), // Rule ID 5702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5702,
        GIR_EraseRootFromParent_Done,
      // Label 8773: @527981
      GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(528056), // Rule ID 5703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5703,
        GIR_EraseRootFromParent_Done,
      // Label 8774: @528056
      GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(528131), // Rule ID 5706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5706,
        GIR_EraseRootFromParent_Done,
      // Label 8775: @528131
      GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(528206), // Rule ID 5707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5707,
        GIR_EraseRootFromParent_Done,
      // Label 8776: @528206
      GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(528281), // Rule ID 5710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5710,
        GIR_EraseRootFromParent_Done,
      // Label 8777: @528281
      GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(528356), // Rule ID 5711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5711,
        GIR_EraseRootFromParent_Done,
      // Label 8778: @528356
      GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(528431), // Rule ID 5714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5714,
        GIR_EraseRootFromParent_Done,
      // Label 8779: @528431
      GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(528506), // Rule ID 5715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5715,
        GIR_EraseRootFromParent_Done,
      // Label 8780: @528506
      GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(528581), // Rule ID 5718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5718,
        GIR_EraseRootFromParent_Done,
      // Label 8781: @528581
      GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(528656), // Rule ID 5719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5719,
        GIR_EraseRootFromParent_Done,
      // Label 8782: @528656
      GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(528731), // Rule ID 5722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5722,
        GIR_EraseRootFromParent_Done,
      // Label 8783: @528731
      GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(528806), // Rule ID 5723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5723,
        GIR_EraseRootFromParent_Done,
      // Label 8784: @528806
      GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(528881), // Rule ID 5726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5726,
        GIR_EraseRootFromParent_Done,
      // Label 8785: @528881
      GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(528956), // Rule ID 5727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5727,
        GIR_EraseRootFromParent_Done,
      // Label 8786: @528956
      GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(529031), // Rule ID 5730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5730,
        GIR_EraseRootFromParent_Done,
      // Label 8787: @529031
      GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(529106), // Rule ID 5731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5731,
        GIR_EraseRootFromParent_Done,
      // Label 8788: @529106
      GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(529181), // Rule ID 5734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5734,
        GIR_EraseRootFromParent_Done,
      // Label 8789: @529181
      GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(529256), // Rule ID 5735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10763:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5735,
        GIR_EraseRootFromParent_Done,
      // Label 8790: @529256
      GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(529331), // Rule ID 5738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5738,
        GIR_EraseRootFromParent_Done,
      // Label 8791: @529331
      GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(529406), // Rule ID 5739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10763:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5739,
        GIR_EraseRootFromParent_Done,
      // Label 8792: @529406
      GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(529481), // Rule ID 5742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5742,
        GIR_EraseRootFromParent_Done,
      // Label 8793: @529481
      GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(529556), // Rule ID 5743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10763:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5743,
        GIR_EraseRootFromParent_Done,
      // Label 8794: @529556
      GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(529631), // Rule ID 5746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5746,
        GIR_EraseRootFromParent_Done,
      // Label 8795: @529631
      GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(529706), // Rule ID 5747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10763:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5747,
        GIR_EraseRootFromParent_Done,
      // Label 8796: @529706
      GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(529781), // Rule ID 5750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5750,
        GIR_EraseRootFromParent_Done,
      // Label 8797: @529781
      GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(529856), // Rule ID 5751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5751,
        GIR_EraseRootFromParent_Done,
      // Label 8798: @529856
      GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(529931), // Rule ID 5754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5754,
        GIR_EraseRootFromParent_Done,
      // Label 8799: @529931
      GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(530006), // Rule ID 5755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5755,
        GIR_EraseRootFromParent_Done,
      // Label 8800: @530006
      GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(530081), // Rule ID 5758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5758,
        GIR_EraseRootFromParent_Done,
      // Label 8801: @530081
      GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(530156), // Rule ID 5759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5759,
        GIR_EraseRootFromParent_Done,
      // Label 8802: @530156
      GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(530231), // Rule ID 5762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5762,
        GIR_EraseRootFromParent_Done,
      // Label 8803: @530231
      GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(530306), // Rule ID 5763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5763,
        GIR_EraseRootFromParent_Done,
      // Label 8804: @530306
      GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(530381), // Rule ID 5766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5766,
        GIR_EraseRootFromParent_Done,
      // Label 8805: @530381
      GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(530456), // Rule ID 5767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5767,
        GIR_EraseRootFromParent_Done,
      // Label 8806: @530456
      GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(530531), // Rule ID 5770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5770,
        GIR_EraseRootFromParent_Done,
      // Label 8807: @530531
      GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(530606), // Rule ID 5771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5771,
        GIR_EraseRootFromParent_Done,
      // Label 8808: @530606
      GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(530681), // Rule ID 5774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5774,
        GIR_EraseRootFromParent_Done,
      // Label 8809: @530681
      GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(530756), // Rule ID 5775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5775,
        GIR_EraseRootFromParent_Done,
      // Label 8810: @530756
      GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(530831), // Rule ID 5778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5778,
        GIR_EraseRootFromParent_Done,
      // Label 8811: @530831
      GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(530906), // Rule ID 5779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5779,
        GIR_EraseRootFromParent_Done,
      // Label 8812: @530906
      GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(530981), // Rule ID 5782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5782,
        GIR_EraseRootFromParent_Done,
      // Label 8813: @530981
      GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(531056), // Rule ID 5783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5783,
        GIR_EraseRootFromParent_Done,
      // Label 8814: @531056
      GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(531131), // Rule ID 5786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5786,
        GIR_EraseRootFromParent_Done,
      // Label 8815: @531131
      GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(531206), // Rule ID 5787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10763:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5787,
        GIR_EraseRootFromParent_Done,
      // Label 8816: @531206
      GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(531281), // Rule ID 5790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5790,
        GIR_EraseRootFromParent_Done,
      // Label 8817: @531281
      GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(531356), // Rule ID 5791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10763:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5791,
        GIR_EraseRootFromParent_Done,
      // Label 8818: @531356
      GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(531431), // Rule ID 5794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5794,
        GIR_EraseRootFromParent_Done,
      // Label 8819: @531431
      GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(531506), // Rule ID 5795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10763:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5795,
        GIR_EraseRootFromParent_Done,
      // Label 8820: @531506
      GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(531581), // Rule ID 5886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5886,
        GIR_EraseRootFromParent_Done,
      // Label 8821: @531581
      GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(531656), // Rule ID 5887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5887,
        GIR_EraseRootFromParent_Done,
      // Label 8822: @531656
      GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(531731), // Rule ID 5890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5890,
        GIR_EraseRootFromParent_Done,
      // Label 8823: @531731
      GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(531806), // Rule ID 5891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5891,
        GIR_EraseRootFromParent_Done,
      // Label 8824: @531806
      GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(531881), // Rule ID 5894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5894,
        GIR_EraseRootFromParent_Done,
      // Label 8825: @531881
      GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(531956), // Rule ID 5895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5895,
        GIR_EraseRootFromParent_Done,
      // Label 8826: @531956
      GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(532031), // Rule ID 5898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5898,
        GIR_EraseRootFromParent_Done,
      // Label 8827: @532031
      GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(532106), // Rule ID 5899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5899,
        GIR_EraseRootFromParent_Done,
      // Label 8828: @532106
      GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(532181), // Rule ID 5902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5902,
        GIR_EraseRootFromParent_Done,
      // Label 8829: @532181
      GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(532256), // Rule ID 5903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5903,
        GIR_EraseRootFromParent_Done,
      // Label 8830: @532256
      GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(532331), // Rule ID 5906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5906,
        GIR_EraseRootFromParent_Done,
      // Label 8831: @532331
      GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(532406), // Rule ID 5907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5907,
        GIR_EraseRootFromParent_Done,
      // Label 8832: @532406
      GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(532481), // Rule ID 5910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5910,
        GIR_EraseRootFromParent_Done,
      // Label 8833: @532481
      GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(532556), // Rule ID 5911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5911,
        GIR_EraseRootFromParent_Done,
      // Label 8834: @532556
      GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(532631), // Rule ID 5914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5914,
        GIR_EraseRootFromParent_Done,
      // Label 8835: @532631
      GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(532706), // Rule ID 5915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5915,
        GIR_EraseRootFromParent_Done,
      // Label 8836: @532706
      GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(532781), // Rule ID 5918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5918,
        GIR_EraseRootFromParent_Done,
      // Label 8837: @532781
      GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(532856), // Rule ID 5919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5919,
        GIR_EraseRootFromParent_Done,
      // Label 8838: @532856
      GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(532931), // Rule ID 5922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5922,
        GIR_EraseRootFromParent_Done,
      // Label 8839: @532931
      GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(533006), // Rule ID 5923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5923,
        GIR_EraseRootFromParent_Done,
      // Label 8840: @533006
      GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(533081), // Rule ID 5926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5926,
        GIR_EraseRootFromParent_Done,
      // Label 8841: @533081
      GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(533156), // Rule ID 5927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5927,
        GIR_EraseRootFromParent_Done,
      // Label 8842: @533156
      GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(533231), // Rule ID 5930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5930,
        GIR_EraseRootFromParent_Done,
      // Label 8843: @533231
      GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(533306), // Rule ID 5931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5931,
        GIR_EraseRootFromParent_Done,
      // Label 8844: @533306
      GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(533381), // Rule ID 5934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5934,
        GIR_EraseRootFromParent_Done,
      // Label 8845: @533381
      GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(533456), // Rule ID 5935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5935,
        GIR_EraseRootFromParent_Done,
      // Label 8846: @533456
      GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(533531), // Rule ID 5938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5938,
        GIR_EraseRootFromParent_Done,
      // Label 8847: @533531
      GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(533606), // Rule ID 5939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5939,
        GIR_EraseRootFromParent_Done,
      // Label 8848: @533606
      GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(533681), // Rule ID 5942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5942,
        GIR_EraseRootFromParent_Done,
      // Label 8849: @533681
      GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(533756), // Rule ID 5943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5943,
        GIR_EraseRootFromParent_Done,
      // Label 8850: @533756
      GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(533831), // Rule ID 5946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5946,
        GIR_EraseRootFromParent_Done,
      // Label 8851: @533831
      GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(533906), // Rule ID 5947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5947,
        GIR_EraseRootFromParent_Done,
      // Label 8852: @533906
      GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(533981), // Rule ID 5950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5950,
        GIR_EraseRootFromParent_Done,
      // Label 8853: @533981
      GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(534056), // Rule ID 5951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5951,
        GIR_EraseRootFromParent_Done,
      // Label 8854: @534056
      GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(534131), // Rule ID 5954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5954,
        GIR_EraseRootFromParent_Done,
      // Label 8855: @534131
      GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(534206), // Rule ID 5955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5955,
        GIR_EraseRootFromParent_Done,
      // Label 8856: @534206
      GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(534281), // Rule ID 5958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5958,
        GIR_EraseRootFromParent_Done,
      // Label 8857: @534281
      GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(534356), // Rule ID 5959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5959,
        GIR_EraseRootFromParent_Done,
      // Label 8858: @534356
      GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(534431), // Rule ID 5962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5962,
        GIR_EraseRootFromParent_Done,
      // Label 8859: @534431
      GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(534506), // Rule ID 5963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5963,
        GIR_EraseRootFromParent_Done,
      // Label 8860: @534506
      GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(534581), // Rule ID 5966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5966,
        GIR_EraseRootFromParent_Done,
      // Label 8861: @534581
      GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(534656), // Rule ID 5967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5967,
        GIR_EraseRootFromParent_Done,
      // Label 8862: @534656
      GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(534731), // Rule ID 5970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5970,
        GIR_EraseRootFromParent_Done,
      // Label 8863: @534731
      GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(534806), // Rule ID 5971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5971,
        GIR_EraseRootFromParent_Done,
      // Label 8864: @534806
      GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(534881), // Rule ID 5974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5974,
        GIR_EraseRootFromParent_Done,
      // Label 8865: @534881
      GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(534956), // Rule ID 5975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5975,
        GIR_EraseRootFromParent_Done,
      // Label 8866: @534956
      GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(535031), // Rule ID 5978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5978,
        GIR_EraseRootFromParent_Done,
      // Label 8867: @535031
      GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(535106), // Rule ID 5979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5979,
        GIR_EraseRootFromParent_Done,
      // Label 8868: @535106
      GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(535181), // Rule ID 5982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5982,
        GIR_EraseRootFromParent_Done,
      // Label 8869: @535181
      GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(535256), // Rule ID 5983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5983,
        GIR_EraseRootFromParent_Done,
      // Label 8870: @535256
      GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(535331), // Rule ID 5986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5986,
        GIR_EraseRootFromParent_Done,
      // Label 8871: @535331
      GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(535406), // Rule ID 5987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5987,
        GIR_EraseRootFromParent_Done,
      // Label 8872: @535406
      GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(535481), // Rule ID 5990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5990,
        GIR_EraseRootFromParent_Done,
      // Label 8873: @535481
      GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(535556), // Rule ID 5991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5991,
        GIR_EraseRootFromParent_Done,
      // Label 8874: @535556
      GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(535631), // Rule ID 5994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5994,
        GIR_EraseRootFromParent_Done,
      // Label 8875: @535631
      GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(535706), // Rule ID 5995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5995,
        GIR_EraseRootFromParent_Done,
      // Label 8876: @535706
      GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(535781), // Rule ID 5998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5998,
        GIR_EraseRootFromParent_Done,
      // Label 8877: @535781
      GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(535856), // Rule ID 5999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5999,
        GIR_EraseRootFromParent_Done,
      // Label 8878: @535856
      GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(535931), // Rule ID 6002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6002,
        GIR_EraseRootFromParent_Done,
      // Label 8879: @535931
      GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(536006), // Rule ID 6003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6003,
        GIR_EraseRootFromParent_Done,
      // Label 8880: @536006
      GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(536081), // Rule ID 6006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6006,
        GIR_EraseRootFromParent_Done,
      // Label 8881: @536081
      GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(536156), // Rule ID 6007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6007,
        GIR_EraseRootFromParent_Done,
      // Label 8882: @536156
      GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(536231), // Rule ID 6010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6010,
        GIR_EraseRootFromParent_Done,
      // Label 8883: @536231
      GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(536306), // Rule ID 6011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6011,
        GIR_EraseRootFromParent_Done,
      // Label 8884: @536306
      GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(536381), // Rule ID 6014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6014,
        GIR_EraseRootFromParent_Done,
      // Label 8885: @536381
      GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(536456), // Rule ID 6015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6015,
        GIR_EraseRootFromParent_Done,
      // Label 8886: @536456
      GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(536531), // Rule ID 6018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6018,
        GIR_EraseRootFromParent_Done,
      // Label 8887: @536531
      GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(536606), // Rule ID 6019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6019,
        GIR_EraseRootFromParent_Done,
      // Label 8888: @536606
      GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(536681), // Rule ID 6022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6022,
        GIR_EraseRootFromParent_Done,
      // Label 8889: @536681
      GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(536756), // Rule ID 6023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6023,
        GIR_EraseRootFromParent_Done,
      // Label 8890: @536756
      GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(536831), // Rule ID 6026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6026,
        GIR_EraseRootFromParent_Done,
      // Label 8891: @536831
      GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(536906), // Rule ID 6027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6027,
        GIR_EraseRootFromParent_Done,
      // Label 8892: @536906
      GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(536981), // Rule ID 6030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6030,
        GIR_EraseRootFromParent_Done,
      // Label 8893: @536981
      GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(537056), // Rule ID 6031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6031,
        GIR_EraseRootFromParent_Done,
      // Label 8894: @537056
      GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(537131), // Rule ID 6034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6034,
        GIR_EraseRootFromParent_Done,
      // Label 8895: @537131
      GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(537206), // Rule ID 6035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6035,
        GIR_EraseRootFromParent_Done,
      // Label 8896: @537206
      GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(537281), // Rule ID 6038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6038,
        GIR_EraseRootFromParent_Done,
      // Label 8897: @537281
      GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(537356), // Rule ID 6039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6039,
        GIR_EraseRootFromParent_Done,
      // Label 8898: @537356
      GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(537431), // Rule ID 6042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6042,
        GIR_EraseRootFromParent_Done,
      // Label 8899: @537431
      GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(537506), // Rule ID 6043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6043,
        GIR_EraseRootFromParent_Done,
      // Label 8900: @537506
      GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(537581), // Rule ID 6046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6046,
        GIR_EraseRootFromParent_Done,
      // Label 8901: @537581
      GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(537656), // Rule ID 6047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6047,
        GIR_EraseRootFromParent_Done,
      // Label 8902: @537656
      GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(537731), // Rule ID 6050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6050,
        GIR_EraseRootFromParent_Done,
      // Label 8903: @537731
      GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(537806), // Rule ID 6051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6051,
        GIR_EraseRootFromParent_Done,
      // Label 8904: @537806
      GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(537881), // Rule ID 6054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6054,
        GIR_EraseRootFromParent_Done,
      // Label 8905: @537881
      GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(537956), // Rule ID 6055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6055,
        GIR_EraseRootFromParent_Done,
      // Label 8906: @537956
      GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(538031), // Rule ID 6058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6058,
        GIR_EraseRootFromParent_Done,
      // Label 8907: @538031
      GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(538106), // Rule ID 6059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6059,
        GIR_EraseRootFromParent_Done,
      // Label 8908: @538106
      GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(538181), // Rule ID 6150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6150,
        GIR_EraseRootFromParent_Done,
      // Label 8909: @538181
      GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(538256), // Rule ID 6151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6151,
        GIR_EraseRootFromParent_Done,
      // Label 8910: @538256
      GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(538331), // Rule ID 6154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6154,
        GIR_EraseRootFromParent_Done,
      // Label 8911: @538331
      GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(538406), // Rule ID 6155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6155,
        GIR_EraseRootFromParent_Done,
      // Label 8912: @538406
      GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(538481), // Rule ID 6158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6158,
        GIR_EraseRootFromParent_Done,
      // Label 8913: @538481
      GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(538556), // Rule ID 6159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6159,
        GIR_EraseRootFromParent_Done,
      // Label 8914: @538556
      GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(538631), // Rule ID 6162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6162,
        GIR_EraseRootFromParent_Done,
      // Label 8915: @538631
      GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(538706), // Rule ID 6163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6163,
        GIR_EraseRootFromParent_Done,
      // Label 8916: @538706
      GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(538781), // Rule ID 6166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6166,
        GIR_EraseRootFromParent_Done,
      // Label 8917: @538781
      GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(538856), // Rule ID 6167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6167,
        GIR_EraseRootFromParent_Done,
      // Label 8918: @538856
      GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(538931), // Rule ID 6170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6170,
        GIR_EraseRootFromParent_Done,
      // Label 8919: @538931
      GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(539006), // Rule ID 6171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6171,
        GIR_EraseRootFromParent_Done,
      // Label 8920: @539006
      GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(539081), // Rule ID 6174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6174,
        GIR_EraseRootFromParent_Done,
      // Label 8921: @539081
      GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(539156), // Rule ID 6175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6175,
        GIR_EraseRootFromParent_Done,
      // Label 8922: @539156
      GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(539231), // Rule ID 6178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6178,
        GIR_EraseRootFromParent_Done,
      // Label 8923: @539231
      GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(539306), // Rule ID 6179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6179,
        GIR_EraseRootFromParent_Done,
      // Label 8924: @539306
      GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(539381), // Rule ID 6182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6182,
        GIR_EraseRootFromParent_Done,
      // Label 8925: @539381
      GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(539456), // Rule ID 6183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6183,
        GIR_EraseRootFromParent_Done,
      // Label 8926: @539456
      GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(539531), // Rule ID 6186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6186,
        GIR_EraseRootFromParent_Done,
      // Label 8927: @539531
      GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(539606), // Rule ID 6187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6187,
        GIR_EraseRootFromParent_Done,
      // Label 8928: @539606
      GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(539681), // Rule ID 6190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6190,
        GIR_EraseRootFromParent_Done,
      // Label 8929: @539681
      GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(539756), // Rule ID 6191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6191,
        GIR_EraseRootFromParent_Done,
      // Label 8930: @539756
      GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(539831), // Rule ID 6194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6194,
        GIR_EraseRootFromParent_Done,
      // Label 8931: @539831
      GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(539906), // Rule ID 6195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6195,
        GIR_EraseRootFromParent_Done,
      // Label 8932: @539906
      GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(539981), // Rule ID 6198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6198,
        GIR_EraseRootFromParent_Done,
      // Label 8933: @539981
      GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(540056), // Rule ID 6199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6199,
        GIR_EraseRootFromParent_Done,
      // Label 8934: @540056
      GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(540131), // Rule ID 6202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6202,
        GIR_EraseRootFromParent_Done,
      // Label 8935: @540131
      GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(540206), // Rule ID 6203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6203,
        GIR_EraseRootFromParent_Done,
      // Label 8936: @540206
      GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(540281), // Rule ID 6206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6206,
        GIR_EraseRootFromParent_Done,
      // Label 8937: @540281
      GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(540356), // Rule ID 6207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6207,
        GIR_EraseRootFromParent_Done,
      // Label 8938: @540356
      GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(540431), // Rule ID 6210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6210,
        GIR_EraseRootFromParent_Done,
      // Label 8939: @540431
      GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(540506), // Rule ID 6211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6211,
        GIR_EraseRootFromParent_Done,
      // Label 8940: @540506
      GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(540581), // Rule ID 6214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6214,
        GIR_EraseRootFromParent_Done,
      // Label 8941: @540581
      GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(540656), // Rule ID 6215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6215,
        GIR_EraseRootFromParent_Done,
      // Label 8942: @540656
      GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(540731), // Rule ID 6218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6218,
        GIR_EraseRootFromParent_Done,
      // Label 8943: @540731
      GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(540806), // Rule ID 6219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6219,
        GIR_EraseRootFromParent_Done,
      // Label 8944: @540806
      GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(540881), // Rule ID 6222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6222,
        GIR_EraseRootFromParent_Done,
      // Label 8945: @540881
      GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(540956), // Rule ID 6223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6223,
        GIR_EraseRootFromParent_Done,
      // Label 8946: @540956
      GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(541031), // Rule ID 6226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6226,
        GIR_EraseRootFromParent_Done,
      // Label 8947: @541031
      GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(541106), // Rule ID 6227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6227,
        GIR_EraseRootFromParent_Done,
      // Label 8948: @541106
      GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(541181), // Rule ID 6230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6230,
        GIR_EraseRootFromParent_Done,
      // Label 8949: @541181
      GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(541256), // Rule ID 6231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6231,
        GIR_EraseRootFromParent_Done,
      // Label 8950: @541256
      GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(541331), // Rule ID 6234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6234,
        GIR_EraseRootFromParent_Done,
      // Label 8951: @541331
      GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(541406), // Rule ID 6235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6235,
        GIR_EraseRootFromParent_Done,
      // Label 8952: @541406
      GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(541481), // Rule ID 6238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6238,
        GIR_EraseRootFromParent_Done,
      // Label 8953: @541481
      GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(541556), // Rule ID 6239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6239,
        GIR_EraseRootFromParent_Done,
      // Label 8954: @541556
      GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(541631), // Rule ID 6242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6242,
        GIR_EraseRootFromParent_Done,
      // Label 8955: @541631
      GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(541706), // Rule ID 6243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6243,
        GIR_EraseRootFromParent_Done,
      // Label 8956: @541706
      GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(541781), // Rule ID 6246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6246,
        GIR_EraseRootFromParent_Done,
      // Label 8957: @541781
      GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(541856), // Rule ID 6247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6247,
        GIR_EraseRootFromParent_Done,
      // Label 8958: @541856
      GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(541931), // Rule ID 6250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6250,
        GIR_EraseRootFromParent_Done,
      // Label 8959: @541931
      GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(542006), // Rule ID 6251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6251,
        GIR_EraseRootFromParent_Done,
      // Label 8960: @542006
      GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(542081), // Rule ID 6254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6254,
        GIR_EraseRootFromParent_Done,
      // Label 8961: @542081
      GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(542156), // Rule ID 6255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6255,
        GIR_EraseRootFromParent_Done,
      // Label 8962: @542156
      GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(542231), // Rule ID 6258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6258,
        GIR_EraseRootFromParent_Done,
      // Label 8963: @542231
      GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(542306), // Rule ID 6259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6259,
        GIR_EraseRootFromParent_Done,
      // Label 8964: @542306
      GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(542381), // Rule ID 6262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6262,
        GIR_EraseRootFromParent_Done,
      // Label 8965: @542381
      GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(542456), // Rule ID 6263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11282:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6263,
        GIR_EraseRootFromParent_Done,
      // Label 8966: @542456
      GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(542531), // Rule ID 6266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6266,
        GIR_EraseRootFromParent_Done,
      // Label 8967: @542531
      GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(542606), // Rule ID 6267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6267,
        GIR_EraseRootFromParent_Done,
      // Label 8968: @542606
      GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(542681), // Rule ID 6270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6270,
        GIR_EraseRootFromParent_Done,
      // Label 8969: @542681
      GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(542756), // Rule ID 6271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6271,
        GIR_EraseRootFromParent_Done,
      // Label 8970: @542756
      GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(542831), // Rule ID 6274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6274,
        GIR_EraseRootFromParent_Done,
      // Label 8971: @542831
      GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(542906), // Rule ID 6275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6275,
        GIR_EraseRootFromParent_Done,
      // Label 8972: @542906
      GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(542981), // Rule ID 6278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6278,
        GIR_EraseRootFromParent_Done,
      // Label 8973: @542981
      GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(543056), // Rule ID 6279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6279,
        GIR_EraseRootFromParent_Done,
      // Label 8974: @543056
      GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(543131), // Rule ID 6282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6282,
        GIR_EraseRootFromParent_Done,
      // Label 8975: @543131
      GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(543206), // Rule ID 6283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6283,
        GIR_EraseRootFromParent_Done,
      // Label 8976: @543206
      GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(543281), // Rule ID 6286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6286,
        GIR_EraseRootFromParent_Done,
      // Label 8977: @543281
      GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(543356), // Rule ID 6287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6287,
        GIR_EraseRootFromParent_Done,
      // Label 8978: @543356
      GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(543431), // Rule ID 6290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6290,
        GIR_EraseRootFromParent_Done,
      // Label 8979: @543431
      GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(543506), // Rule ID 6291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6291,
        GIR_EraseRootFromParent_Done,
      // Label 8980: @543506
      GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(543581), // Rule ID 6294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6294,
        GIR_EraseRootFromParent_Done,
      // Label 8981: @543581
      GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(543656), // Rule ID 6295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6295,
        GIR_EraseRootFromParent_Done,
      // Label 8982: @543656
      GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(543731), // Rule ID 6298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6298,
        GIR_EraseRootFromParent_Done,
      // Label 8983: @543731
      GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(543806), // Rule ID 6299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6299,
        GIR_EraseRootFromParent_Done,
      // Label 8984: @543806
      GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(543881), // Rule ID 6302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6302,
        GIR_EraseRootFromParent_Done,
      // Label 8985: @543881
      GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(543956), // Rule ID 6303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6303,
        GIR_EraseRootFromParent_Done,
      // Label 8986: @543956
      GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(544031), // Rule ID 6306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6306,
        GIR_EraseRootFromParent_Done,
      // Label 8987: @544031
      GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(544106), // Rule ID 6307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6307,
        GIR_EraseRootFromParent_Done,
      // Label 8988: @544106
      GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(544181), // Rule ID 6310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6310,
        GIR_EraseRootFromParent_Done,
      // Label 8989: @544181
      GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(544256), // Rule ID 6311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6311,
        GIR_EraseRootFromParent_Done,
      // Label 8990: @544256
      GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(544331), // Rule ID 6314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6314,
        GIR_EraseRootFromParent_Done,
      // Label 8991: @544331
      GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(544406), // Rule ID 6315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6315,
        GIR_EraseRootFromParent_Done,
      // Label 8992: @544406
      GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(544481), // Rule ID 6318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6318,
        GIR_EraseRootFromParent_Done,
      // Label 8993: @544481
      GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(544556), // Rule ID 6319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6319,
        GIR_EraseRootFromParent_Done,
      // Label 8994: @544556
      GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(544631), // Rule ID 6322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6322,
        GIR_EraseRootFromParent_Done,
      // Label 8995: @544631
      GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(544706), // Rule ID 6323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6323,
        GIR_EraseRootFromParent_Done,
      // Label 8996: @544706
      GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(544781), // Rule ID 6414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6414,
        GIR_EraseRootFromParent_Done,
      // Label 8997: @544781
      GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(544856), // Rule ID 6415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6415,
        GIR_EraseRootFromParent_Done,
      // Label 8998: @544856
      GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(544931), // Rule ID 6418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6418,
        GIR_EraseRootFromParent_Done,
      // Label 8999: @544931
      GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(545006), // Rule ID 6419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6419,
        GIR_EraseRootFromParent_Done,
      // Label 9000: @545006
      GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(545081), // Rule ID 6422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6422,
        GIR_EraseRootFromParent_Done,
      // Label 9001: @545081
      GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(545156), // Rule ID 6423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6423,
        GIR_EraseRootFromParent_Done,
      // Label 9002: @545156
      GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(545231), // Rule ID 6426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6426,
        GIR_EraseRootFromParent_Done,
      // Label 9003: @545231
      GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(545306), // Rule ID 6427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6427,
        GIR_EraseRootFromParent_Done,
      // Label 9004: @545306
      GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(545381), // Rule ID 6430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6430,
        GIR_EraseRootFromParent_Done,
      // Label 9005: @545381
      GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(545456), // Rule ID 6431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6431,
        GIR_EraseRootFromParent_Done,
      // Label 9006: @545456
      GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(545531), // Rule ID 6434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6434,
        GIR_EraseRootFromParent_Done,
      // Label 9007: @545531
      GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(545606), // Rule ID 6435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6435,
        GIR_EraseRootFromParent_Done,
      // Label 9008: @545606
      GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(545681), // Rule ID 6438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6438,
        GIR_EraseRootFromParent_Done,
      // Label 9009: @545681
      GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(545756), // Rule ID 6439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6439,
        GIR_EraseRootFromParent_Done,
      // Label 9010: @545756
      GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(545831), // Rule ID 6442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6442,
        GIR_EraseRootFromParent_Done,
      // Label 9011: @545831
      GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(545906), // Rule ID 6443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6443,
        GIR_EraseRootFromParent_Done,
      // Label 9012: @545906
      GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(545981), // Rule ID 6446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6446,
        GIR_EraseRootFromParent_Done,
      // Label 9013: @545981
      GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(546056), // Rule ID 6447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6447,
        GIR_EraseRootFromParent_Done,
      // Label 9014: @546056
      GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(546131), // Rule ID 6450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6450,
        GIR_EraseRootFromParent_Done,
      // Label 9015: @546131
      GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(546206), // Rule ID 6451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6451,
        GIR_EraseRootFromParent_Done,
      // Label 9016: @546206
      GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(546281), // Rule ID 6454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6454,
        GIR_EraseRootFromParent_Done,
      // Label 9017: @546281
      GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(546356), // Rule ID 6455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6455,
        GIR_EraseRootFromParent_Done,
      // Label 9018: @546356
      GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(546431), // Rule ID 6458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6458,
        GIR_EraseRootFromParent_Done,
      // Label 9019: @546431
      GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(546506), // Rule ID 6459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6459,
        GIR_EraseRootFromParent_Done,
      // Label 9020: @546506
      GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(546581), // Rule ID 6462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6462,
        GIR_EraseRootFromParent_Done,
      // Label 9021: @546581
      GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(546656), // Rule ID 6463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6463,
        GIR_EraseRootFromParent_Done,
      // Label 9022: @546656
      GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(546731), // Rule ID 6466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6466,
        GIR_EraseRootFromParent_Done,
      // Label 9023: @546731
      GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(546806), // Rule ID 6467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6467,
        GIR_EraseRootFromParent_Done,
      // Label 9024: @546806
      GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(546881), // Rule ID 6470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6470,
        GIR_EraseRootFromParent_Done,
      // Label 9025: @546881
      GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(546956), // Rule ID 6471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6471,
        GIR_EraseRootFromParent_Done,
      // Label 9026: @546956
      GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(547031), // Rule ID 6474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6474,
        GIR_EraseRootFromParent_Done,
      // Label 9027: @547031
      GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(547106), // Rule ID 6475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6475,
        GIR_EraseRootFromParent_Done,
      // Label 9028: @547106
      GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(547181), // Rule ID 6478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6478,
        GIR_EraseRootFromParent_Done,
      // Label 9029: @547181
      GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(547256), // Rule ID 6479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6479,
        GIR_EraseRootFromParent_Done,
      // Label 9030: @547256
      GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(547331), // Rule ID 6482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6482,
        GIR_EraseRootFromParent_Done,
      // Label 9031: @547331
      GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(547406), // Rule ID 6483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6483,
        GIR_EraseRootFromParent_Done,
      // Label 9032: @547406
      GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(547481), // Rule ID 6486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6486,
        GIR_EraseRootFromParent_Done,
      // Label 9033: @547481
      GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(547556), // Rule ID 6487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6487,
        GIR_EraseRootFromParent_Done,
      // Label 9034: @547556
      GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(547631), // Rule ID 6490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6490,
        GIR_EraseRootFromParent_Done,
      // Label 9035: @547631
      GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(547706), // Rule ID 6491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6491,
        GIR_EraseRootFromParent_Done,
      // Label 9036: @547706
      GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(547781), // Rule ID 6494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6494,
        GIR_EraseRootFromParent_Done,
      // Label 9037: @547781
      GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(547856), // Rule ID 6495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6495,
        GIR_EraseRootFromParent_Done,
      // Label 9038: @547856
      GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(547931), // Rule ID 6498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6498,
        GIR_EraseRootFromParent_Done,
      // Label 9039: @547931
      GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(548006), // Rule ID 6499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6499,
        GIR_EraseRootFromParent_Done,
      // Label 9040: @548006
      GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(548081), // Rule ID 6502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6502,
        GIR_EraseRootFromParent_Done,
      // Label 9041: @548081
      GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(548156), // Rule ID 6503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6503,
        GIR_EraseRootFromParent_Done,
      // Label 9042: @548156
      GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(548231), // Rule ID 6506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6506,
        GIR_EraseRootFromParent_Done,
      // Label 9043: @548231
      GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(548306), // Rule ID 6507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6507,
        GIR_EraseRootFromParent_Done,
      // Label 9044: @548306
      GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(548381), // Rule ID 6510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6510,
        GIR_EraseRootFromParent_Done,
      // Label 9045: @548381
      GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(548456), // Rule ID 6511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6511,
        GIR_EraseRootFromParent_Done,
      // Label 9046: @548456
      GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(548531), // Rule ID 6514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6514,
        GIR_EraseRootFromParent_Done,
      // Label 9047: @548531
      GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(548606), // Rule ID 6515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6515,
        GIR_EraseRootFromParent_Done,
      // Label 9048: @548606
      GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(548681), // Rule ID 6518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6518,
        GIR_EraseRootFromParent_Done,
      // Label 9049: @548681
      GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(548756), // Rule ID 6519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6519,
        GIR_EraseRootFromParent_Done,
      // Label 9050: @548756
      GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(548831), // Rule ID 6522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6522,
        GIR_EraseRootFromParent_Done,
      // Label 9051: @548831
      GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(548906), // Rule ID 6523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6523,
        GIR_EraseRootFromParent_Done,
      // Label 9052: @548906
      GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(548981), // Rule ID 6526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6526,
        GIR_EraseRootFromParent_Done,
      // Label 9053: @548981
      GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(549056), // Rule ID 6527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6527,
        GIR_EraseRootFromParent_Done,
      // Label 9054: @549056
      GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(549131), // Rule ID 6530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6530,
        GIR_EraseRootFromParent_Done,
      // Label 9055: @549131
      GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(549206), // Rule ID 6531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6531,
        GIR_EraseRootFromParent_Done,
      // Label 9056: @549206
      GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(549281), // Rule ID 6534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6534,
        GIR_EraseRootFromParent_Done,
      // Label 9057: @549281
      GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(549356), // Rule ID 6535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6535,
        GIR_EraseRootFromParent_Done,
      // Label 9058: @549356
      GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(549431), // Rule ID 6538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6538,
        GIR_EraseRootFromParent_Done,
      // Label 9059: @549431
      GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(549506), // Rule ID 6539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6539,
        GIR_EraseRootFromParent_Done,
      // Label 9060: @549506
      GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(549581), // Rule ID 6542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6542,
        GIR_EraseRootFromParent_Done,
      // Label 9061: @549581
      GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(549656), // Rule ID 6543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6543,
        GIR_EraseRootFromParent_Done,
      // Label 9062: @549656
      GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(549731), // Rule ID 6546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6546,
        GIR_EraseRootFromParent_Done,
      // Label 9063: @549731
      GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(549806), // Rule ID 6547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6547,
        GIR_EraseRootFromParent_Done,
      // Label 9064: @549806
      GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(549881), // Rule ID 6550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6550,
        GIR_EraseRootFromParent_Done,
      // Label 9065: @549881
      GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(549956), // Rule ID 6551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6551,
        GIR_EraseRootFromParent_Done,
      // Label 9066: @549956
      GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(550031), // Rule ID 6554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6554,
        GIR_EraseRootFromParent_Done,
      // Label 9067: @550031
      GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(550106), // Rule ID 6555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6555,
        GIR_EraseRootFromParent_Done,
      // Label 9068: @550106
      GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(550181), // Rule ID 6558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6558,
        GIR_EraseRootFromParent_Done,
      // Label 9069: @550181
      GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(550256), // Rule ID 6559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6559,
        GIR_EraseRootFromParent_Done,
      // Label 9070: @550256
      GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(550331), // Rule ID 6562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6562,
        GIR_EraseRootFromParent_Done,
      // Label 9071: @550331
      GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(550406), // Rule ID 6563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6563,
        GIR_EraseRootFromParent_Done,
      // Label 9072: @550406
      GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(550481), // Rule ID 6566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6566,
        GIR_EraseRootFromParent_Done,
      // Label 9073: @550481
      GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(550556), // Rule ID 6567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6567,
        GIR_EraseRootFromParent_Done,
      // Label 9074: @550556
      GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(550631), // Rule ID 6570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6570,
        GIR_EraseRootFromParent_Done,
      // Label 9075: @550631
      GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(550706), // Rule ID 6571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6571,
        GIR_EraseRootFromParent_Done,
      // Label 9076: @550706
      GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(550781), // Rule ID 6574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6574,
        GIR_EraseRootFromParent_Done,
      // Label 9077: @550781
      GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(550856), // Rule ID 6575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6575,
        GIR_EraseRootFromParent_Done,
      // Label 9078: @550856
      GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(550931), // Rule ID 6578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6578,
        GIR_EraseRootFromParent_Done,
      // Label 9079: @550931
      GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(551006), // Rule ID 6579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6579,
        GIR_EraseRootFromParent_Done,
      // Label 9080: @551006
      GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(551081), // Rule ID 6582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6582,
        GIR_EraseRootFromParent_Done,
      // Label 9081: @551081
      GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(551156), // Rule ID 6583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6583,
        GIR_EraseRootFromParent_Done,
      // Label 9082: @551156
      GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(551231), // Rule ID 6586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6586,
        GIR_EraseRootFromParent_Done,
      // Label 9083: @551231
      GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(551306), // Rule ID 6587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6587,
        GIR_EraseRootFromParent_Done,
      // Label 9084: @551306
      GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(551381), // Rule ID 6678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6678,
        GIR_EraseRootFromParent_Done,
      // Label 9085: @551381
      GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(551456), // Rule ID 6679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6679,
        GIR_EraseRootFromParent_Done,
      // Label 9086: @551456
      GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(551531), // Rule ID 6682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6682,
        GIR_EraseRootFromParent_Done,
      // Label 9087: @551531
      GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(551606), // Rule ID 6683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6683,
        GIR_EraseRootFromParent_Done,
      // Label 9088: @551606
      GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(551681), // Rule ID 6686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6686,
        GIR_EraseRootFromParent_Done,
      // Label 9089: @551681
      GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(551756), // Rule ID 6687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6687,
        GIR_EraseRootFromParent_Done,
      // Label 9090: @551756
      GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(551831), // Rule ID 6690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6690,
        GIR_EraseRootFromParent_Done,
      // Label 9091: @551831
      GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(551906), // Rule ID 6691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6691,
        GIR_EraseRootFromParent_Done,
      // Label 9092: @551906
      GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(551981), // Rule ID 6694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6694,
        GIR_EraseRootFromParent_Done,
      // Label 9093: @551981
      GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(552056), // Rule ID 6695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6695,
        GIR_EraseRootFromParent_Done,
      // Label 9094: @552056
      GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(552131), // Rule ID 6698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6698,
        GIR_EraseRootFromParent_Done,
      // Label 9095: @552131
      GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(552206), // Rule ID 6699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6699,
        GIR_EraseRootFromParent_Done,
      // Label 9096: @552206
      GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(552281), // Rule ID 6702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6702,
        GIR_EraseRootFromParent_Done,
      // Label 9097: @552281
      GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(552356), // Rule ID 6703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6703,
        GIR_EraseRootFromParent_Done,
      // Label 9098: @552356
      GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(552431), // Rule ID 6706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6706,
        GIR_EraseRootFromParent_Done,
      // Label 9099: @552431
      GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(552506), // Rule ID 6707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6707,
        GIR_EraseRootFromParent_Done,
      // Label 9100: @552506
      GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(552581), // Rule ID 6710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6710,
        GIR_EraseRootFromParent_Done,
      // Label 9101: @552581
      GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(552656), // Rule ID 6711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6711,
        GIR_EraseRootFromParent_Done,
      // Label 9102: @552656
      GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(552731), // Rule ID 6714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6714,
        GIR_EraseRootFromParent_Done,
      // Label 9103: @552731
      GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(552806), // Rule ID 6715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6715,
        GIR_EraseRootFromParent_Done,
      // Label 9104: @552806
      GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(552881), // Rule ID 6718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6718,
        GIR_EraseRootFromParent_Done,
      // Label 9105: @552881
      GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(552956), // Rule ID 6719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6719,
        GIR_EraseRootFromParent_Done,
      // Label 9106: @552956
      GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(553031), // Rule ID 6722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6722,
        GIR_EraseRootFromParent_Done,
      // Label 9107: @553031
      GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(553106), // Rule ID 6723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6723,
        GIR_EraseRootFromParent_Done,
      // Label 9108: @553106
      GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(553181), // Rule ID 6726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6726,
        GIR_EraseRootFromParent_Done,
      // Label 9109: @553181
      GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(553256), // Rule ID 6727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6727,
        GIR_EraseRootFromParent_Done,
      // Label 9110: @553256
      GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(553331), // Rule ID 6730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6730,
        GIR_EraseRootFromParent_Done,
      // Label 9111: @553331
      GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(553406), // Rule ID 6731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6731,
        GIR_EraseRootFromParent_Done,
      // Label 9112: @553406
      GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(553481), // Rule ID 6734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6734,
        GIR_EraseRootFromParent_Done,
      // Label 9113: @553481
      GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(553556), // Rule ID 6735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6735,
        GIR_EraseRootFromParent_Done,
      // Label 9114: @553556
      GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(553631), // Rule ID 6738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6738,
        GIR_EraseRootFromParent_Done,
      // Label 9115: @553631
      GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(553706), // Rule ID 6739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6739,
        GIR_EraseRootFromParent_Done,
      // Label 9116: @553706
      GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(553781), // Rule ID 6742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6742,
        GIR_EraseRootFromParent_Done,
      // Label 9117: @553781
      GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(553856), // Rule ID 6743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6743,
        GIR_EraseRootFromParent_Done,
      // Label 9118: @553856
      GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(553931), // Rule ID 6746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6746,
        GIR_EraseRootFromParent_Done,
      // Label 9119: @553931
      GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(554006), // Rule ID 6747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6747,
        GIR_EraseRootFromParent_Done,
      // Label 9120: @554006
      GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(554081), // Rule ID 6750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6750,
        GIR_EraseRootFromParent_Done,
      // Label 9121: @554081
      GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(554156), // Rule ID 6751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6751,
        GIR_EraseRootFromParent_Done,
      // Label 9122: @554156
      GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(554231), // Rule ID 6754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6754,
        GIR_EraseRootFromParent_Done,
      // Label 9123: @554231
      GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(554306), // Rule ID 6755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6755,
        GIR_EraseRootFromParent_Done,
      // Label 9124: @554306
      GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(554381), // Rule ID 6758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6758,
        GIR_EraseRootFromParent_Done,
      // Label 9125: @554381
      GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(554456), // Rule ID 6759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6759,
        GIR_EraseRootFromParent_Done,
      // Label 9126: @554456
      GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(554531), // Rule ID 6762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6762,
        GIR_EraseRootFromParent_Done,
      // Label 9127: @554531
      GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(554606), // Rule ID 6763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6763,
        GIR_EraseRootFromParent_Done,
      // Label 9128: @554606
      GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(554681), // Rule ID 6766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6766,
        GIR_EraseRootFromParent_Done,
      // Label 9129: @554681
      GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(554756), // Rule ID 6767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6767,
        GIR_EraseRootFromParent_Done,
      // Label 9130: @554756
      GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(554831), // Rule ID 6770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6770,
        GIR_EraseRootFromParent_Done,
      // Label 9131: @554831
      GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(554906), // Rule ID 6771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6771,
        GIR_EraseRootFromParent_Done,
      // Label 9132: @554906
      GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(554981), // Rule ID 6774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6774,
        GIR_EraseRootFromParent_Done,
      // Label 9133: @554981
      GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(555056), // Rule ID 6775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6775,
        GIR_EraseRootFromParent_Done,
      // Label 9134: @555056
      GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(555131), // Rule ID 6778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6778,
        GIR_EraseRootFromParent_Done,
      // Label 9135: @555131
      GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(555206), // Rule ID 6779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6779,
        GIR_EraseRootFromParent_Done,
      // Label 9136: @555206
      GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(555281), // Rule ID 6782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6782,
        GIR_EraseRootFromParent_Done,
      // Label 9137: @555281
      GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(555356), // Rule ID 6783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6783,
        GIR_EraseRootFromParent_Done,
      // Label 9138: @555356
      GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(555431), // Rule ID 6786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6786,
        GIR_EraseRootFromParent_Done,
      // Label 9139: @555431
      GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(555506), // Rule ID 6787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6787,
        GIR_EraseRootFromParent_Done,
      // Label 9140: @555506
      GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(555581), // Rule ID 6790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6790,
        GIR_EraseRootFromParent_Done,
      // Label 9141: @555581
      GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(555656), // Rule ID 6791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11188:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6791,
        GIR_EraseRootFromParent_Done,
      // Label 9142: @555656
      GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(555731), // Rule ID 6794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6794,
        GIR_EraseRootFromParent_Done,
      // Label 9143: @555731
      GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(555806), // Rule ID 6795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6795,
        GIR_EraseRootFromParent_Done,
      // Label 9144: @555806
      GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(555881), // Rule ID 6798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6798,
        GIR_EraseRootFromParent_Done,
      // Label 9145: @555881
      GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(555956), // Rule ID 6799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6799,
        GIR_EraseRootFromParent_Done,
      // Label 9146: @555956
      GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(556031), // Rule ID 6802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6802,
        GIR_EraseRootFromParent_Done,
      // Label 9147: @556031
      GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(556106), // Rule ID 6803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6803,
        GIR_EraseRootFromParent_Done,
      // Label 9148: @556106
      GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(556181), // Rule ID 6806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6806,
        GIR_EraseRootFromParent_Done,
      // Label 9149: @556181
      GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(556256), // Rule ID 6807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6807,
        GIR_EraseRootFromParent_Done,
      // Label 9150: @556256
      GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(556331), // Rule ID 6810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6810,
        GIR_EraseRootFromParent_Done,
      // Label 9151: @556331
      GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(556406), // Rule ID 6811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6811,
        GIR_EraseRootFromParent_Done,
      // Label 9152: @556406
      GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(556481), // Rule ID 6814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6814,
        GIR_EraseRootFromParent_Done,
      // Label 9153: @556481
      GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(556556), // Rule ID 6815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6815,
        GIR_EraseRootFromParent_Done,
      // Label 9154: @556556
      GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(556631), // Rule ID 6818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6818,
        GIR_EraseRootFromParent_Done,
      // Label 9155: @556631
      GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(556706), // Rule ID 6819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6819,
        GIR_EraseRootFromParent_Done,
      // Label 9156: @556706
      GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(556781), // Rule ID 6822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6822,
        GIR_EraseRootFromParent_Done,
      // Label 9157: @556781
      GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(556856), // Rule ID 6823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6823,
        GIR_EraseRootFromParent_Done,
      // Label 9158: @556856
      GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(556931), // Rule ID 6826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6826,
        GIR_EraseRootFromParent_Done,
      // Label 9159: @556931
      GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(557006), // Rule ID 6827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6827,
        GIR_EraseRootFromParent_Done,
      // Label 9160: @557006
      GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(557081), // Rule ID 6830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6830,
        GIR_EraseRootFromParent_Done,
      // Label 9161: @557081
      GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(557156), // Rule ID 6831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6831,
        GIR_EraseRootFromParent_Done,
      // Label 9162: @557156
      GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(557231), // Rule ID 6834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6834,
        GIR_EraseRootFromParent_Done,
      // Label 9163: @557231
      GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(557306), // Rule ID 6835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6835,
        GIR_EraseRootFromParent_Done,
      // Label 9164: @557306
      GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(557381), // Rule ID 6838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6838,
        GIR_EraseRootFromParent_Done,
      // Label 9165: @557381
      GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(557456), // Rule ID 6839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6839,
        GIR_EraseRootFromParent_Done,
      // Label 9166: @557456
      GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(557531), // Rule ID 6842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6842,
        GIR_EraseRootFromParent_Done,
      // Label 9167: @557531
      GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(557606), // Rule ID 6843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6843,
        GIR_EraseRootFromParent_Done,
      // Label 9168: @557606
      GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(557681), // Rule ID 6846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6846,
        GIR_EraseRootFromParent_Done,
      // Label 9169: @557681
      GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(557756), // Rule ID 6847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6847,
        GIR_EraseRootFromParent_Done,
      // Label 9170: @557756
      GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(557831), // Rule ID 6850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6850,
        GIR_EraseRootFromParent_Done,
      // Label 9171: @557831
      GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(557906), // Rule ID 6851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6851,
        GIR_EraseRootFromParent_Done,
      // Label 9172: @557906
      GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(557981), // Rule ID 6942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6942,
        GIR_EraseRootFromParent_Done,
      // Label 9173: @557981
      GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(558056), // Rule ID 6943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6943,
        GIR_EraseRootFromParent_Done,
      // Label 9174: @558056
      GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(558131), // Rule ID 6946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6946,
        GIR_EraseRootFromParent_Done,
      // Label 9175: @558131
      GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(558206), // Rule ID 6947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6947,
        GIR_EraseRootFromParent_Done,
      // Label 9176: @558206
      GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(558281), // Rule ID 6950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6950,
        GIR_EraseRootFromParent_Done,
      // Label 9177: @558281
      GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(558356), // Rule ID 6951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6951,
        GIR_EraseRootFromParent_Done,
      // Label 9178: @558356
      GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(558431), // Rule ID 6954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6954,
        GIR_EraseRootFromParent_Done,
      // Label 9179: @558431
      GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(558506), // Rule ID 6955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6955,
        GIR_EraseRootFromParent_Done,
      // Label 9180: @558506
      GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(558581), // Rule ID 6958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6958,
        GIR_EraseRootFromParent_Done,
      // Label 9181: @558581
      GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(558656), // Rule ID 6959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6959,
        GIR_EraseRootFromParent_Done,
      // Label 9182: @558656
      GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(558731), // Rule ID 6962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6962,
        GIR_EraseRootFromParent_Done,
      // Label 9183: @558731
      GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(558806), // Rule ID 6963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6963,
        GIR_EraseRootFromParent_Done,
      // Label 9184: @558806
      GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(558881), // Rule ID 6966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6966,
        GIR_EraseRootFromParent_Done,
      // Label 9185: @558881
      GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(558956), // Rule ID 6967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6967,
        GIR_EraseRootFromParent_Done,
      // Label 9186: @558956
      GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(559031), // Rule ID 6970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6970,
        GIR_EraseRootFromParent_Done,
      // Label 9187: @559031
      GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(559106), // Rule ID 6971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6971,
        GIR_EraseRootFromParent_Done,
      // Label 9188: @559106
      GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(559181), // Rule ID 6974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6974,
        GIR_EraseRootFromParent_Done,
      // Label 9189: @559181
      GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(559256), // Rule ID 6975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6975,
        GIR_EraseRootFromParent_Done,
      // Label 9190: @559256
      GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(559331), // Rule ID 6978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6978,
        GIR_EraseRootFromParent_Done,
      // Label 9191: @559331
      GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(559406), // Rule ID 6979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6979,
        GIR_EraseRootFromParent_Done,
      // Label 9192: @559406
      GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(559481), // Rule ID 6982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6982,
        GIR_EraseRootFromParent_Done,
      // Label 9193: @559481
      GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(559556), // Rule ID 6983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6983,
        GIR_EraseRootFromParent_Done,
      // Label 9194: @559556
      GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(559631), // Rule ID 6986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6986,
        GIR_EraseRootFromParent_Done,
      // Label 9195: @559631
      GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(559706), // Rule ID 6987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6987,
        GIR_EraseRootFromParent_Done,
      // Label 9196: @559706
      GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(559781), // Rule ID 6990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6990,
        GIR_EraseRootFromParent_Done,
      // Label 9197: @559781
      GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(559856), // Rule ID 6991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6991,
        GIR_EraseRootFromParent_Done,
      // Label 9198: @559856
      GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(559931), // Rule ID 6994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6994,
        GIR_EraseRootFromParent_Done,
      // Label 9199: @559931
      GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(560006), // Rule ID 6995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6995,
        GIR_EraseRootFromParent_Done,
      // Label 9200: @560006
      GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(560081), // Rule ID 6998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6998,
        GIR_EraseRootFromParent_Done,
      // Label 9201: @560081
      GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(560156), // Rule ID 6999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6999,
        GIR_EraseRootFromParent_Done,
      // Label 9202: @560156
      GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(560231), // Rule ID 7002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7002,
        GIR_EraseRootFromParent_Done,
      // Label 9203: @560231
      GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(560306), // Rule ID 7003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7003,
        GIR_EraseRootFromParent_Done,
      // Label 9204: @560306
      GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(560381), // Rule ID 7006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7006,
        GIR_EraseRootFromParent_Done,
      // Label 9205: @560381
      GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(560456), // Rule ID 7007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7007,
        GIR_EraseRootFromParent_Done,
      // Label 9206: @560456
      GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(560531), // Rule ID 7010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7010,
        GIR_EraseRootFromParent_Done,
      // Label 9207: @560531
      GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(560606), // Rule ID 7011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7011,
        GIR_EraseRootFromParent_Done,
      // Label 9208: @560606
      GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(560681), // Rule ID 7014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7014,
        GIR_EraseRootFromParent_Done,
      // Label 9209: @560681
      GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(560756), // Rule ID 7015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7015,
        GIR_EraseRootFromParent_Done,
      // Label 9210: @560756
      GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(560831), // Rule ID 7018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7018,
        GIR_EraseRootFromParent_Done,
      // Label 9211: @560831
      GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(560906), // Rule ID 7019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7019,
        GIR_EraseRootFromParent_Done,
      // Label 9212: @560906
      GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(560981), // Rule ID 7022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7022,
        GIR_EraseRootFromParent_Done,
      // Label 9213: @560981
      GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(561056), // Rule ID 7023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7023,
        GIR_EraseRootFromParent_Done,
      // Label 9214: @561056
      GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(561131), // Rule ID 7026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7026,
        GIR_EraseRootFromParent_Done,
      // Label 9215: @561131
      GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(561206), // Rule ID 7027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7027,
        GIR_EraseRootFromParent_Done,
      // Label 9216: @561206
      GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(561281), // Rule ID 7030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7030,
        GIR_EraseRootFromParent_Done,
      // Label 9217: @561281
      GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(561356), // Rule ID 7031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7031,
        GIR_EraseRootFromParent_Done,
      // Label 9218: @561356
      GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(561431), // Rule ID 7034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7034,
        GIR_EraseRootFromParent_Done,
      // Label 9219: @561431
      GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(561506), // Rule ID 7035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7035,
        GIR_EraseRootFromParent_Done,
      // Label 9220: @561506
      GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(561581), // Rule ID 7038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7038,
        GIR_EraseRootFromParent_Done,
      // Label 9221: @561581
      GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(561656), // Rule ID 7039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7039,
        GIR_EraseRootFromParent_Done,
      // Label 9222: @561656
      GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(561731), // Rule ID 7042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7042,
        GIR_EraseRootFromParent_Done,
      // Label 9223: @561731
      GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(561806), // Rule ID 7043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7043,
        GIR_EraseRootFromParent_Done,
      // Label 9224: @561806
      GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(561881), // Rule ID 7046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7046,
        GIR_EraseRootFromParent_Done,
      // Label 9225: @561881
      GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(561956), // Rule ID 7047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7047,
        GIR_EraseRootFromParent_Done,
      // Label 9226: @561956
      GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(562031), // Rule ID 7050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7050,
        GIR_EraseRootFromParent_Done,
      // Label 9227: @562031
      GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(562106), // Rule ID 7051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7051,
        GIR_EraseRootFromParent_Done,
      // Label 9228: @562106
      GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(562181), // Rule ID 7054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7054,
        GIR_EraseRootFromParent_Done,
      // Label 9229: @562181
      GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(562256), // Rule ID 7055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11186:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7055,
        GIR_EraseRootFromParent_Done,
      // Label 9230: @562256
      GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(562331), // Rule ID 7058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7058,
        GIR_EraseRootFromParent_Done,
      // Label 9231: @562331
      GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(562406), // Rule ID 7059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7059,
        GIR_EraseRootFromParent_Done,
      // Label 9232: @562406
      GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(562481), // Rule ID 7062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7062,
        GIR_EraseRootFromParent_Done,
      // Label 9233: @562481
      GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(562556), // Rule ID 7063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7063,
        GIR_EraseRootFromParent_Done,
      // Label 9234: @562556
      GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(562631), // Rule ID 7066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7066,
        GIR_EraseRootFromParent_Done,
      // Label 9235: @562631
      GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(562706), // Rule ID 7067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7067,
        GIR_EraseRootFromParent_Done,
      // Label 9236: @562706
      GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(562781), // Rule ID 7070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7070,
        GIR_EraseRootFromParent_Done,
      // Label 9237: @562781
      GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(562856), // Rule ID 7071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7071,
        GIR_EraseRootFromParent_Done,
      // Label 9238: @562856
      GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(562931), // Rule ID 7074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7074,
        GIR_EraseRootFromParent_Done,
      // Label 9239: @562931
      GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(563006), // Rule ID 7075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7075,
        GIR_EraseRootFromParent_Done,
      // Label 9240: @563006
      GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(563081), // Rule ID 7078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7078,
        GIR_EraseRootFromParent_Done,
      // Label 9241: @563081
      GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(563156), // Rule ID 7079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7079,
        GIR_EraseRootFromParent_Done,
      // Label 9242: @563156
      GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(563231), // Rule ID 7082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7082,
        GIR_EraseRootFromParent_Done,
      // Label 9243: @563231
      GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(563306), // Rule ID 7083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7083,
        GIR_EraseRootFromParent_Done,
      // Label 9244: @563306
      GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(563381), // Rule ID 7086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7086,
        GIR_EraseRootFromParent_Done,
      // Label 9245: @563381
      GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(563456), // Rule ID 7087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7087,
        GIR_EraseRootFromParent_Done,
      // Label 9246: @563456
      GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(563531), // Rule ID 7090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7090,
        GIR_EraseRootFromParent_Done,
      // Label 9247: @563531
      GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(563606), // Rule ID 7091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7091,
        GIR_EraseRootFromParent_Done,
      // Label 9248: @563606
      GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(563681), // Rule ID 7094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7094,
        GIR_EraseRootFromParent_Done,
      // Label 9249: @563681
      GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(563756), // Rule ID 7095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7095,
        GIR_EraseRootFromParent_Done,
      // Label 9250: @563756
      GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(563831), // Rule ID 7098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7098,
        GIR_EraseRootFromParent_Done,
      // Label 9251: @563831
      GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(563906), // Rule ID 7099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7099,
        GIR_EraseRootFromParent_Done,
      // Label 9252: @563906
      GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(563981), // Rule ID 7102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7102,
        GIR_EraseRootFromParent_Done,
      // Label 9253: @563981
      GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(564056), // Rule ID 7103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7103,
        GIR_EraseRootFromParent_Done,
      // Label 9254: @564056
      GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(564131), // Rule ID 7106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7106,
        GIR_EraseRootFromParent_Done,
      // Label 9255: @564131
      GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(564206), // Rule ID 7107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7107,
        GIR_EraseRootFromParent_Done,
      // Label 9256: @564206
      GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(564281), // Rule ID 7110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7110,
        GIR_EraseRootFromParent_Done,
      // Label 9257: @564281
      GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(564356), // Rule ID 7111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7111,
        GIR_EraseRootFromParent_Done,
      // Label 9258: @564356
      GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(564431), // Rule ID 7114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7114,
        GIR_EraseRootFromParent_Done,
      // Label 9259: @564431
      GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(564506), // Rule ID 7115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7115,
        GIR_EraseRootFromParent_Done,
      // Label 9260: @564506
      GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(564581), // Rule ID 7294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7294,
        GIR_EraseRootFromParent_Done,
      // Label 9261: @564581
      GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(564656), // Rule ID 7295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7295,
        GIR_EraseRootFromParent_Done,
      // Label 9262: @564656
      GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(564731), // Rule ID 7298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7298,
        GIR_EraseRootFromParent_Done,
      // Label 9263: @564731
      GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(564806), // Rule ID 7299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7299,
        GIR_EraseRootFromParent_Done,
      // Label 9264: @564806
      GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(564881), // Rule ID 7302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7302,
        GIR_EraseRootFromParent_Done,
      // Label 9265: @564881
      GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(564956), // Rule ID 7303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7303,
        GIR_EraseRootFromParent_Done,
      // Label 9266: @564956
      GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(565031), // Rule ID 7306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7306,
        GIR_EraseRootFromParent_Done,
      // Label 9267: @565031
      GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(565106), // Rule ID 7307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7307,
        GIR_EraseRootFromParent_Done,
      // Label 9268: @565106
      GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(565181), // Rule ID 7310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7310,
        GIR_EraseRootFromParent_Done,
      // Label 9269: @565181
      GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(565256), // Rule ID 7311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7311,
        GIR_EraseRootFromParent_Done,
      // Label 9270: @565256
      GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(565331), // Rule ID 7314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7314,
        GIR_EraseRootFromParent_Done,
      // Label 9271: @565331
      GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(565406), // Rule ID 7315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7315,
        GIR_EraseRootFromParent_Done,
      // Label 9272: @565406
      GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(565481), // Rule ID 7318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7318,
        GIR_EraseRootFromParent_Done,
      // Label 9273: @565481
      GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(565556), // Rule ID 7319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7319,
        GIR_EraseRootFromParent_Done,
      // Label 9274: @565556
      GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(565631), // Rule ID 7322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7322,
        GIR_EraseRootFromParent_Done,
      // Label 9275: @565631
      GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(565706), // Rule ID 7323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7323,
        GIR_EraseRootFromParent_Done,
      // Label 9276: @565706
      GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(565781), // Rule ID 7326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7326,
        GIR_EraseRootFromParent_Done,
      // Label 9277: @565781
      GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(565856), // Rule ID 7327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7327,
        GIR_EraseRootFromParent_Done,
      // Label 9278: @565856
      GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(565931), // Rule ID 7330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7330,
        GIR_EraseRootFromParent_Done,
      // Label 9279: @565931
      GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(566006), // Rule ID 7331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7331,
        GIR_EraseRootFromParent_Done,
      // Label 9280: @566006
      GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(566081), // Rule ID 7334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7334,
        GIR_EraseRootFromParent_Done,
      // Label 9281: @566081
      GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(566156), // Rule ID 7335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7335,
        GIR_EraseRootFromParent_Done,
      // Label 9282: @566156
      GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(566231), // Rule ID 7338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7338,
        GIR_EraseRootFromParent_Done,
      // Label 9283: @566231
      GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(566306), // Rule ID 7339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7339,
        GIR_EraseRootFromParent_Done,
      // Label 9284: @566306
      GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(566381), // Rule ID 7342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7342,
        GIR_EraseRootFromParent_Done,
      // Label 9285: @566381
      GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(566456), // Rule ID 7343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7343,
        GIR_EraseRootFromParent_Done,
      // Label 9286: @566456
      GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(566531), // Rule ID 7346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7346,
        GIR_EraseRootFromParent_Done,
      // Label 9287: @566531
      GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(566606), // Rule ID 7347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7347,
        GIR_EraseRootFromParent_Done,
      // Label 9288: @566606
      GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(566681), // Rule ID 7350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7350,
        GIR_EraseRootFromParent_Done,
      // Label 9289: @566681
      GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(566756), // Rule ID 7351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7351,
        GIR_EraseRootFromParent_Done,
      // Label 9290: @566756
      GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(566831), // Rule ID 7354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7354,
        GIR_EraseRootFromParent_Done,
      // Label 9291: @566831
      GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(566906), // Rule ID 7355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7355,
        GIR_EraseRootFromParent_Done,
      // Label 9292: @566906
      GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(566981), // Rule ID 7358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7358,
        GIR_EraseRootFromParent_Done,
      // Label 9293: @566981
      GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(567056), // Rule ID 7359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7359,
        GIR_EraseRootFromParent_Done,
      // Label 9294: @567056
      GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(567131), // Rule ID 7362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7362,
        GIR_EraseRootFromParent_Done,
      // Label 9295: @567131
      GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(567206), // Rule ID 7363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7363,
        GIR_EraseRootFromParent_Done,
      // Label 9296: @567206
      GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(567281), // Rule ID 7366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7366,
        GIR_EraseRootFromParent_Done,
      // Label 9297: @567281
      GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(567356), // Rule ID 7367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7367,
        GIR_EraseRootFromParent_Done,
      // Label 9298: @567356
      GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(567431), // Rule ID 7370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7370,
        GIR_EraseRootFromParent_Done,
      // Label 9299: @567431
      GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(567506), // Rule ID 7371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7371,
        GIR_EraseRootFromParent_Done,
      // Label 9300: @567506
      GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(567581), // Rule ID 7374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7374,
        GIR_EraseRootFromParent_Done,
      // Label 9301: @567581
      GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(567656), // Rule ID 7375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7375,
        GIR_EraseRootFromParent_Done,
      // Label 9302: @567656
      GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(567731), // Rule ID 7378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7378,
        GIR_EraseRootFromParent_Done,
      // Label 9303: @567731
      GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(567806), // Rule ID 7379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7379,
        GIR_EraseRootFromParent_Done,
      // Label 9304: @567806
      GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(567881), // Rule ID 7382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7382,
        GIR_EraseRootFromParent_Done,
      // Label 9305: @567881
      GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(567956), // Rule ID 7383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7383,
        GIR_EraseRootFromParent_Done,
      // Label 9306: @567956
      GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(568031), // Rule ID 7386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7386,
        GIR_EraseRootFromParent_Done,
      // Label 9307: @568031
      GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(568106), // Rule ID 7387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7387,
        GIR_EraseRootFromParent_Done,
      // Label 9308: @568106
      GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(568181), // Rule ID 7390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7390,
        GIR_EraseRootFromParent_Done,
      // Label 9309: @568181
      GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(568256), // Rule ID 7391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7391,
        GIR_EraseRootFromParent_Done,
      // Label 9310: @568256
      GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(568331), // Rule ID 7394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7394,
        GIR_EraseRootFromParent_Done,
      // Label 9311: @568331
      GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(568406), // Rule ID 7395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7395,
        GIR_EraseRootFromParent_Done,
      // Label 9312: @568406
      GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(568481), // Rule ID 7398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7398,
        GIR_EraseRootFromParent_Done,
      // Label 9313: @568481
      GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(568556), // Rule ID 7399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7399,
        GIR_EraseRootFromParent_Done,
      // Label 9314: @568556
      GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(568631), // Rule ID 7402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7402,
        GIR_EraseRootFromParent_Done,
      // Label 9315: @568631
      GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(568706), // Rule ID 7403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7403,
        GIR_EraseRootFromParent_Done,
      // Label 9316: @568706
      GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(568781), // Rule ID 7406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7406,
        GIR_EraseRootFromParent_Done,
      // Label 9317: @568781
      GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(568856), // Rule ID 7407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7407,
        GIR_EraseRootFromParent_Done,
      // Label 9318: @568856
      GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(568931), // Rule ID 7410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7410,
        GIR_EraseRootFromParent_Done,
      // Label 9319: @568931
      GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(569006), // Rule ID 7411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7411,
        GIR_EraseRootFromParent_Done,
      // Label 9320: @569006
      GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(569081), // Rule ID 7474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7474,
        GIR_EraseRootFromParent_Done,
      // Label 9321: @569081
      GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(569156), // Rule ID 7475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7475,
        GIR_EraseRootFromParent_Done,
      // Label 9322: @569156
      GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(569231), // Rule ID 7478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7478,
        GIR_EraseRootFromParent_Done,
      // Label 9323: @569231
      GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(569306), // Rule ID 7479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7479,
        GIR_EraseRootFromParent_Done,
      // Label 9324: @569306
      GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(569381), // Rule ID 7482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7482,
        GIR_EraseRootFromParent_Done,
      // Label 9325: @569381
      GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(569456), // Rule ID 7483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7483,
        GIR_EraseRootFromParent_Done,
      // Label 9326: @569456
      GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(569531), // Rule ID 7486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7486,
        GIR_EraseRootFromParent_Done,
      // Label 9327: @569531
      GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(569606), // Rule ID 7487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7487,
        GIR_EraseRootFromParent_Done,
      // Label 9328: @569606
      GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(569681), // Rule ID 7490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7490,
        GIR_EraseRootFromParent_Done,
      // Label 9329: @569681
      GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(569756), // Rule ID 7491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7491,
        GIR_EraseRootFromParent_Done,
      // Label 9330: @569756
      GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(569831), // Rule ID 7494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7494,
        GIR_EraseRootFromParent_Done,
      // Label 9331: @569831
      GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(569906), // Rule ID 7495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7495,
        GIR_EraseRootFromParent_Done,
      // Label 9332: @569906
      GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(569981), // Rule ID 7498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7498,
        GIR_EraseRootFromParent_Done,
      // Label 9333: @569981
      GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(570056), // Rule ID 7499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7499,
        GIR_EraseRootFromParent_Done,
      // Label 9334: @570056
      GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(570131), // Rule ID 7502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7502,
        GIR_EraseRootFromParent_Done,
      // Label 9335: @570131
      GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(570206), // Rule ID 7503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7503,
        GIR_EraseRootFromParent_Done,
      // Label 9336: @570206
      GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(570281), // Rule ID 7506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7506,
        GIR_EraseRootFromParent_Done,
      // Label 9337: @570281
      GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(570356), // Rule ID 7507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7507,
        GIR_EraseRootFromParent_Done,
      // Label 9338: @570356
      GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(570431), // Rule ID 7510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7510,
        GIR_EraseRootFromParent_Done,
      // Label 9339: @570431
      GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(570506), // Rule ID 7511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7511,
        GIR_EraseRootFromParent_Done,
      // Label 9340: @570506
      GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(570581), // Rule ID 7514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7514,
        GIR_EraseRootFromParent_Done,
      // Label 9341: @570581
      GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(570656), // Rule ID 7515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7515,
        GIR_EraseRootFromParent_Done,
      // Label 9342: @570656
      GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(570731), // Rule ID 7518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7518,
        GIR_EraseRootFromParent_Done,
      // Label 9343: @570731
      GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(570806), // Rule ID 7519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7519,
        GIR_EraseRootFromParent_Done,
      // Label 9344: @570806
      GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(570881), // Rule ID 7522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7522,
        GIR_EraseRootFromParent_Done,
      // Label 9345: @570881
      GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(570956), // Rule ID 7523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7523,
        GIR_EraseRootFromParent_Done,
      // Label 9346: @570956
      GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(571031), // Rule ID 7526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7526,
        GIR_EraseRootFromParent_Done,
      // Label 9347: @571031
      GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(571106), // Rule ID 7527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7527,
        GIR_EraseRootFromParent_Done,
      // Label 9348: @571106
      GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(571181), // Rule ID 7530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7530,
        GIR_EraseRootFromParent_Done,
      // Label 9349: @571181
      GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(571256), // Rule ID 7531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7531,
        GIR_EraseRootFromParent_Done,
      // Label 9350: @571256
      GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(571331), // Rule ID 7534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7534,
        GIR_EraseRootFromParent_Done,
      // Label 9351: @571331
      GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(571406), // Rule ID 7535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7535,
        GIR_EraseRootFromParent_Done,
      // Label 9352: @571406
      GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(571481), // Rule ID 7538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7538,
        GIR_EraseRootFromParent_Done,
      // Label 9353: @571481
      GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(571556), // Rule ID 7539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7539,
        GIR_EraseRootFromParent_Done,
      // Label 9354: @571556
      GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(571631), // Rule ID 7542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7542,
        GIR_EraseRootFromParent_Done,
      // Label 9355: @571631
      GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(571706), // Rule ID 7543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7543,
        GIR_EraseRootFromParent_Done,
      // Label 9356: @571706
      GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(571781), // Rule ID 7546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7546,
        GIR_EraseRootFromParent_Done,
      // Label 9357: @571781
      GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(571856), // Rule ID 7547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7547,
        GIR_EraseRootFromParent_Done,
      // Label 9358: @571856
      GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(571931), // Rule ID 7550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7550,
        GIR_EraseRootFromParent_Done,
      // Label 9359: @571931
      GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(572006), // Rule ID 7551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7551,
        GIR_EraseRootFromParent_Done,
      // Label 9360: @572006
      GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(572081), // Rule ID 7554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7554,
        GIR_EraseRootFromParent_Done,
      // Label 9361: @572081
      GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(572156), // Rule ID 7555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7555,
        GIR_EraseRootFromParent_Done,
      // Label 9362: @572156
      GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(572231), // Rule ID 7558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7558,
        GIR_EraseRootFromParent_Done,
      // Label 9363: @572231
      GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(572306), // Rule ID 7559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7559,
        GIR_EraseRootFromParent_Done,
      // Label 9364: @572306
      GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(572381), // Rule ID 7562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7562,
        GIR_EraseRootFromParent_Done,
      // Label 9365: @572381
      GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(572456), // Rule ID 7563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7563,
        GIR_EraseRootFromParent_Done,
      // Label 9366: @572456
      GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(572531), // Rule ID 7566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7566,
        GIR_EraseRootFromParent_Done,
      // Label 9367: @572531
      GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(572606), // Rule ID 7567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7567,
        GIR_EraseRootFromParent_Done,
      // Label 9368: @572606
      GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(572681), // Rule ID 7570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7570,
        GIR_EraseRootFromParent_Done,
      // Label 9369: @572681
      GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(572756), // Rule ID 7571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7571,
        GIR_EraseRootFromParent_Done,
      // Label 9370: @572756
      GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(572831), // Rule ID 7574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7574,
        GIR_EraseRootFromParent_Done,
      // Label 9371: @572831
      GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(572906), // Rule ID 7575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7575,
        GIR_EraseRootFromParent_Done,
      // Label 9372: @572906
      GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(572981), // Rule ID 7578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7578,
        GIR_EraseRootFromParent_Done,
      // Label 9373: @572981
      GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(573056), // Rule ID 7579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7579,
        GIR_EraseRootFromParent_Done,
      // Label 9374: @573056
      GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(573131), // Rule ID 7582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7582,
        GIR_EraseRootFromParent_Done,
      // Label 9375: @573131
      GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(573206), // Rule ID 7583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7583,
        GIR_EraseRootFromParent_Done,
      // Label 9376: @573206
      GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(573281), // Rule ID 7586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7586,
        GIR_EraseRootFromParent_Done,
      // Label 9377: @573281
      GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(573356), // Rule ID 7587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7587,
        GIR_EraseRootFromParent_Done,
      // Label 9378: @573356
      GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(573431), // Rule ID 7590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7590,
        GIR_EraseRootFromParent_Done,
      // Label 9379: @573431
      GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(573506), // Rule ID 7591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7591,
        GIR_EraseRootFromParent_Done,
      // Label 9380: @573506
      GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(573581), // Rule ID 10106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10106,
        GIR_EraseRootFromParent_Done,
      // Label 9381: @573581
      GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(573656), // Rule ID 10107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10107,
        GIR_EraseRootFromParent_Done,
      // Label 9382: @573656
      GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(573731), // Rule ID 10110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10110,
        GIR_EraseRootFromParent_Done,
      // Label 9383: @573731
      GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(573806), // Rule ID 10111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10111,
        GIR_EraseRootFromParent_Done,
      // Label 9384: @573806
      GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(573881), // Rule ID 10114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10114,
        GIR_EraseRootFromParent_Done,
      // Label 9385: @573881
      GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(573956), // Rule ID 10115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10115,
        GIR_EraseRootFromParent_Done,
      // Label 9386: @573956
      GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(574031), // Rule ID 10118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10118,
        GIR_EraseRootFromParent_Done,
      // Label 9387: @574031
      GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(574106), // Rule ID 10119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10119,
        GIR_EraseRootFromParent_Done,
      // Label 9388: @574106
      GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(574181), // Rule ID 10122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10122,
        GIR_EraseRootFromParent_Done,
      // Label 9389: @574181
      GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(574256), // Rule ID 10123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10123,
        GIR_EraseRootFromParent_Done,
      // Label 9390: @574256
      GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(574331), // Rule ID 10126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10126,
        GIR_EraseRootFromParent_Done,
      // Label 9391: @574331
      GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(574406), // Rule ID 10127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10127,
        GIR_EraseRootFromParent_Done,
      // Label 9392: @574406
      GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(574481), // Rule ID 10130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10130,
        GIR_EraseRootFromParent_Done,
      // Label 9393: @574481
      GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(574556), // Rule ID 10131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10131,
        GIR_EraseRootFromParent_Done,
      // Label 9394: @574556
      GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(574631), // Rule ID 10134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10134,
        GIR_EraseRootFromParent_Done,
      // Label 9395: @574631
      GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(574706), // Rule ID 10135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10135,
        GIR_EraseRootFromParent_Done,
      // Label 9396: @574706
      GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(574781), // Rule ID 10138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10138,
        GIR_EraseRootFromParent_Done,
      // Label 9397: @574781
      GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(574856), // Rule ID 10139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10139,
        GIR_EraseRootFromParent_Done,
      // Label 9398: @574856
      GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(574931), // Rule ID 10142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10142,
        GIR_EraseRootFromParent_Done,
      // Label 9399: @574931
      GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(575006), // Rule ID 10143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10143,
        GIR_EraseRootFromParent_Done,
      // Label 9400: @575006
      GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(575081), // Rule ID 10146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10146,
        GIR_EraseRootFromParent_Done,
      // Label 9401: @575081
      GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(575156), // Rule ID 10147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10147,
        GIR_EraseRootFromParent_Done,
      // Label 9402: @575156
      GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(575231), // Rule ID 10150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10150,
        GIR_EraseRootFromParent_Done,
      // Label 9403: @575231
      GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(575306), // Rule ID 10151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10151,
        GIR_EraseRootFromParent_Done,
      // Label 9404: @575306
      GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(575381), // Rule ID 10154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10154,
        GIR_EraseRootFromParent_Done,
      // Label 9405: @575381
      GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(575456), // Rule ID 10155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10155,
        GIR_EraseRootFromParent_Done,
      // Label 9406: @575456
      GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(575531), // Rule ID 10158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10158,
        GIR_EraseRootFromParent_Done,
      // Label 9407: @575531
      GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(575606), // Rule ID 10159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10159,
        GIR_EraseRootFromParent_Done,
      // Label 9408: @575606
      GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(575681), // Rule ID 10162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10162,
        GIR_EraseRootFromParent_Done,
      // Label 9409: @575681
      GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(575756), // Rule ID 10163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10163,
        GIR_EraseRootFromParent_Done,
      // Label 9410: @575756
      GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(575831), // Rule ID 10166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10166,
        GIR_EraseRootFromParent_Done,
      // Label 9411: @575831
      GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(575906), // Rule ID 10167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10167,
        GIR_EraseRootFromParent_Done,
      // Label 9412: @575906
      GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(575981), // Rule ID 10170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10170,
        GIR_EraseRootFromParent_Done,
      // Label 9413: @575981
      GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(576056), // Rule ID 10171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10171,
        GIR_EraseRootFromParent_Done,
      // Label 9414: @576056
      GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(576131), // Rule ID 10174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10174,
        GIR_EraseRootFromParent_Done,
      // Label 9415: @576131
      GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(576206), // Rule ID 10175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10175,
        GIR_EraseRootFromParent_Done,
      // Label 9416: @576206
      GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(576281), // Rule ID 10178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10178,
        GIR_EraseRootFromParent_Done,
      // Label 9417: @576281
      GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(576356), // Rule ID 10179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10179,
        GIR_EraseRootFromParent_Done,
      // Label 9418: @576356
      GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(576431), // Rule ID 10182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10182,
        GIR_EraseRootFromParent_Done,
      // Label 9419: @576431
      GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(576506), // Rule ID 10183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10183,
        GIR_EraseRootFromParent_Done,
      // Label 9420: @576506
      GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(576581), // Rule ID 10186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10186,
        GIR_EraseRootFromParent_Done,
      // Label 9421: @576581
      GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(576656), // Rule ID 10187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10187,
        GIR_EraseRootFromParent_Done,
      // Label 9422: @576656
      GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(576731), // Rule ID 10190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10190,
        GIR_EraseRootFromParent_Done,
      // Label 9423: @576731
      GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(576806), // Rule ID 10191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10191,
        GIR_EraseRootFromParent_Done,
      // Label 9424: @576806
      GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(576881), // Rule ID 10194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10194,
        GIR_EraseRootFromParent_Done,
      // Label 9425: @576881
      GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(576956), // Rule ID 10195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10195,
        GIR_EraseRootFromParent_Done,
      // Label 9426: @576956
      GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(577031), // Rule ID 10198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10198,
        GIR_EraseRootFromParent_Done,
      // Label 9427: @577031
      GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(577106), // Rule ID 10199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10199,
        GIR_EraseRootFromParent_Done,
      // Label 9428: @577106
      GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(577181), // Rule ID 10202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10202,
        GIR_EraseRootFromParent_Done,
      // Label 9429: @577181
      GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(577256), // Rule ID 10203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10203,
        GIR_EraseRootFromParent_Done,
      // Label 9430: @577256
      GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(577331), // Rule ID 10206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10206,
        GIR_EraseRootFromParent_Done,
      // Label 9431: @577331
      GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(577406), // Rule ID 10207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10207,
        GIR_EraseRootFromParent_Done,
      // Label 9432: @577406
      GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(577481), // Rule ID 10210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10210,
        GIR_EraseRootFromParent_Done,
      // Label 9433: @577481
      GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(577556), // Rule ID 10211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10211,
        GIR_EraseRootFromParent_Done,
      // Label 9434: @577556
      GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(577631), // Rule ID 10214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10214,
        GIR_EraseRootFromParent_Done,
      // Label 9435: @577631
      GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(577706), // Rule ID 10215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10215,
        GIR_EraseRootFromParent_Done,
      // Label 9436: @577706
      GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(577781), // Rule ID 10218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10218,
        GIR_EraseRootFromParent_Done,
      // Label 9437: @577781
      GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(577856), // Rule ID 10219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11041:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10219,
        GIR_EraseRootFromParent_Done,
      // Label 9438: @577856
      GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(577931), // Rule ID 10222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10222,
        GIR_EraseRootFromParent_Done,
      // Label 9439: @577931
      GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(578006), // Rule ID 10223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11041:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10223,
        GIR_EraseRootFromParent_Done,
      // Label 9440: @578006
      GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(578081), // Rule ID 10226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10226,
        GIR_EraseRootFromParent_Done,
      // Label 9441: @578081
      GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(578156), // Rule ID 10227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10227,
        GIR_EraseRootFromParent_Done,
      // Label 9442: @578156
      GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(578231), // Rule ID 10230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10230,
        GIR_EraseRootFromParent_Done,
      // Label 9443: @578231
      GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(578306), // Rule ID 10231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11041:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10231,
        GIR_EraseRootFromParent_Done,
      // Label 9444: @578306
      GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(578381), // Rule ID 10234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10234,
        GIR_EraseRootFromParent_Done,
      // Label 9445: @578381
      GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(578456), // Rule ID 10235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10235,
        GIR_EraseRootFromParent_Done,
      // Label 9446: @578456
      GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(578531), // Rule ID 10238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10238,
        GIR_EraseRootFromParent_Done,
      // Label 9447: @578531
      GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(578606), // Rule ID 10239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10239,
        GIR_EraseRootFromParent_Done,
      // Label 9448: @578606
      GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(578681), // Rule ID 10242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10242,
        GIR_EraseRootFromParent_Done,
      // Label 9449: @578681
      GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(578756), // Rule ID 10243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10243,
        GIR_EraseRootFromParent_Done,
      // Label 9450: @578756
      GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(578831), // Rule ID 10246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10246,
        GIR_EraseRootFromParent_Done,
      // Label 9451: @578831
      GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(578906), // Rule ID 10247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10247,
        GIR_EraseRootFromParent_Done,
      // Label 9452: @578906
      GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(578981), // Rule ID 10250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10250,
        GIR_EraseRootFromParent_Done,
      // Label 9453: @578981
      GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(579056), // Rule ID 10251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10251,
        GIR_EraseRootFromParent_Done,
      // Label 9454: @579056
      GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(579131), // Rule ID 10254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10254,
        GIR_EraseRootFromParent_Done,
      // Label 9455: @579131
      GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(579206), // Rule ID 10255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10255,
        GIR_EraseRootFromParent_Done,
      // Label 9456: @579206
      GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(579281), // Rule ID 10258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10258,
        GIR_EraseRootFromParent_Done,
      // Label 9457: @579281
      GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(579356), // Rule ID 10259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10259,
        GIR_EraseRootFromParent_Done,
      // Label 9458: @579356
      GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(579431), // Rule ID 10262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10262,
        GIR_EraseRootFromParent_Done,
      // Label 9459: @579431
      GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(579506), // Rule ID 10263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10263,
        GIR_EraseRootFromParent_Done,
      // Label 9460: @579506
      GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(579581), // Rule ID 10266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10266,
        GIR_EraseRootFromParent_Done,
      // Label 9461: @579581
      GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(579656), // Rule ID 10267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10267,
        GIR_EraseRootFromParent_Done,
      // Label 9462: @579656
      GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(579731), // Rule ID 10270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10270,
        GIR_EraseRootFromParent_Done,
      // Label 9463: @579731
      GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(579806), // Rule ID 10271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10271,
        GIR_EraseRootFromParent_Done,
      // Label 9464: @579806
      GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(579881), // Rule ID 10274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10274,
        GIR_EraseRootFromParent_Done,
      // Label 9465: @579881
      GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(579956), // Rule ID 10275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10275,
        GIR_EraseRootFromParent_Done,
      // Label 9466: @579956
      GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(580031), // Rule ID 10278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10278,
        GIR_EraseRootFromParent_Done,
      // Label 9467: @580031
      GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(580106), // Rule ID 10279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10279,
        GIR_EraseRootFromParent_Done,
      // Label 9468: @580106
      GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(580181), // Rule ID 10282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10282,
        GIR_EraseRootFromParent_Done,
      // Label 9469: @580181
      GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(580256), // Rule ID 10283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10283,
        GIR_EraseRootFromParent_Done,
      // Label 9470: @580256
      GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(580331), // Rule ID 10286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10286,
        GIR_EraseRootFromParent_Done,
      // Label 9471: @580331
      GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(580406), // Rule ID 10287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10287,
        GIR_EraseRootFromParent_Done,
      // Label 9472: @580406
      GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(580481), // Rule ID 10290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10290,
        GIR_EraseRootFromParent_Done,
      // Label 9473: @580481
      GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(580556), // Rule ID 10291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10291,
        GIR_EraseRootFromParent_Done,
      // Label 9474: @580556
      GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(580631), // Rule ID 10294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10294,
        GIR_EraseRootFromParent_Done,
      // Label 9475: @580631
      GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(580706), // Rule ID 10295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10295,
        GIR_EraseRootFromParent_Done,
      // Label 9476: @580706
      GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(580781), // Rule ID 10298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10298,
        GIR_EraseRootFromParent_Done,
      // Label 9477: @580781
      GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(580856), // Rule ID 10299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10299,
        GIR_EraseRootFromParent_Done,
      // Label 9478: @580856
      GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(580931), // Rule ID 10302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10302,
        GIR_EraseRootFromParent_Done,
      // Label 9479: @580931
      GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(581006), // Rule ID 10303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10303,
        GIR_EraseRootFromParent_Done,
      // Label 9480: @581006
      GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(581081), // Rule ID 10306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10306,
        GIR_EraseRootFromParent_Done,
      // Label 9481: @581081
      GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(581156), // Rule ID 10307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10307,
        GIR_EraseRootFromParent_Done,
      // Label 9482: @581156
      GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(581231), // Rule ID 10310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10310,
        GIR_EraseRootFromParent_Done,
      // Label 9483: @581231
      GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(581306), // Rule ID 10311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10311,
        GIR_EraseRootFromParent_Done,
      // Label 9484: @581306
      GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(581381), // Rule ID 10314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10314,
        GIR_EraseRootFromParent_Done,
      // Label 9485: @581381
      GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(581456), // Rule ID 10315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10315,
        GIR_EraseRootFromParent_Done,
      // Label 9486: @581456
      GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(581531), // Rule ID 10318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10318,
        GIR_EraseRootFromParent_Done,
      // Label 9487: @581531
      GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(581606), // Rule ID 10319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10319,
        GIR_EraseRootFromParent_Done,
      // Label 9488: @581606
      GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(581681), // Rule ID 10322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10322,
        GIR_EraseRootFromParent_Done,
      // Label 9489: @581681
      GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(581756), // Rule ID 10323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10323,
        GIR_EraseRootFromParent_Done,
      // Label 9490: @581756
      GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(581831), // Rule ID 10326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10326,
        GIR_EraseRootFromParent_Done,
      // Label 9491: @581831
      GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(581906), // Rule ID 10327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10327,
        GIR_EraseRootFromParent_Done,
      // Label 9492: @581906
      GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(581981), // Rule ID 10330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10330,
        GIR_EraseRootFromParent_Done,
      // Label 9493: @581981
      GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(582056), // Rule ID 10331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10331,
        GIR_EraseRootFromParent_Done,
      // Label 9494: @582056
      GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(582131), // Rule ID 10334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10334,
        GIR_EraseRootFromParent_Done,
      // Label 9495: @582131
      GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(582206), // Rule ID 10335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10335,
        GIR_EraseRootFromParent_Done,
      // Label 9496: @582206
      GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(582281), // Rule ID 10338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10338,
        GIR_EraseRootFromParent_Done,
      // Label 9497: @582281
      GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(582356), // Rule ID 10339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10339,
        GIR_EraseRootFromParent_Done,
      // Label 9498: @582356
      GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(582431), // Rule ID 10342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10342,
        GIR_EraseRootFromParent_Done,
      // Label 9499: @582431
      GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(582506), // Rule ID 10343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10343,
        GIR_EraseRootFromParent_Done,
      // Label 9500: @582506
      GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(582581), // Rule ID 10346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10346,
        GIR_EraseRootFromParent_Done,
      // Label 9501: @582581
      GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(582656), // Rule ID 10347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10347,
        GIR_EraseRootFromParent_Done,
      // Label 9502: @582656
      GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(582731), // Rule ID 10350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10350,
        GIR_EraseRootFromParent_Done,
      // Label 9503: @582731
      GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(582806), // Rule ID 10351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10351,
        GIR_EraseRootFromParent_Done,
      // Label 9504: @582806
      GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(582881), // Rule ID 10354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10354,
        GIR_EraseRootFromParent_Done,
      // Label 9505: @582881
      GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(582956), // Rule ID 10355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10355,
        GIR_EraseRootFromParent_Done,
      // Label 9506: @582956
      GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(583031), // Rule ID 10358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10358,
        GIR_EraseRootFromParent_Done,
      // Label 9507: @583031
      GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(583106), // Rule ID 10359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10359,
        GIR_EraseRootFromParent_Done,
      // Label 9508: @583106
      GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(583181), // Rule ID 10362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10362,
        GIR_EraseRootFromParent_Done,
      // Label 9509: @583181
      GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(583256), // Rule ID 10363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10363,
        GIR_EraseRootFromParent_Done,
      // Label 9510: @583256
      GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(583331), // Rule ID 10366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10366,
        GIR_EraseRootFromParent_Done,
      // Label 9511: @583331
      GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(583406), // Rule ID 10367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10367,
        GIR_EraseRootFromParent_Done,
      // Label 9512: @583406
      GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(583481), // Rule ID 10370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10370,
        GIR_EraseRootFromParent_Done,
      // Label 9513: @583481
      GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(583556), // Rule ID 10371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10371,
        GIR_EraseRootFromParent_Done,
      // Label 9514: @583556
      GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(583631), // Rule ID 10374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10374,
        GIR_EraseRootFromParent_Done,
      // Label 9515: @583631
      GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(583706), // Rule ID 10375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10375,
        GIR_EraseRootFromParent_Done,
      // Label 9516: @583706
      GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(583781), // Rule ID 10378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10378,
        GIR_EraseRootFromParent_Done,
      // Label 9517: @583781
      GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(583856), // Rule ID 10379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10379,
        GIR_EraseRootFromParent_Done,
      // Label 9518: @583856
      GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(583931), // Rule ID 10382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10382,
        GIR_EraseRootFromParent_Done,
      // Label 9519: @583931
      GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(584006), // Rule ID 10383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10383,
        GIR_EraseRootFromParent_Done,
      // Label 9520: @584006
      GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(584081), // Rule ID 10386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10386,
        GIR_EraseRootFromParent_Done,
      // Label 9521: @584081
      GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(584156), // Rule ID 10387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10387,
        GIR_EraseRootFromParent_Done,
      // Label 9522: @584156
      GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(584231), // Rule ID 10390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10390,
        GIR_EraseRootFromParent_Done,
      // Label 9523: @584231
      GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(584306), // Rule ID 10391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10391,
        GIR_EraseRootFromParent_Done,
      // Label 9524: @584306
      GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(584381), // Rule ID 10394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10394,
        GIR_EraseRootFromParent_Done,
      // Label 9525: @584381
      GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(584456), // Rule ID 10395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11039:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10395,
        GIR_EraseRootFromParent_Done,
      // Label 9526: @584456
      GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(584531), // Rule ID 10398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10398,
        GIR_EraseRootFromParent_Done,
      // Label 9527: @584531
      GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(584606), // Rule ID 10399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11039:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10399,
        GIR_EraseRootFromParent_Done,
      // Label 9528: @584606
      GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(584681), // Rule ID 10402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10402,
        GIR_EraseRootFromParent_Done,
      // Label 9529: @584681
      GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(584756), // Rule ID 10403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10403,
        GIR_EraseRootFromParent_Done,
      // Label 9530: @584756
      GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(584831), // Rule ID 10406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10406,
        GIR_EraseRootFromParent_Done,
      // Label 9531: @584831
      GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(584906), // Rule ID 10407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11039:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10407,
        GIR_EraseRootFromParent_Done,
      // Label 9532: @584906
      GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(584981), // Rule ID 10410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10410,
        GIR_EraseRootFromParent_Done,
      // Label 9533: @584981
      GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(585056), // Rule ID 10411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10411,
        GIR_EraseRootFromParent_Done,
      // Label 9534: @585056
      GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(585131), // Rule ID 10414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10414,
        GIR_EraseRootFromParent_Done,
      // Label 9535: @585131
      GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(585206), // Rule ID 10415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10415,
        GIR_EraseRootFromParent_Done,
      // Label 9536: @585206
      GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(585281), // Rule ID 10418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10418,
        GIR_EraseRootFromParent_Done,
      // Label 9537: @585281
      GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(585356), // Rule ID 10419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10419,
        GIR_EraseRootFromParent_Done,
      // Label 9538: @585356
      GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(585431), // Rule ID 10422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10422,
        GIR_EraseRootFromParent_Done,
      // Label 9539: @585431
      GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(585506), // Rule ID 10423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10423,
        GIR_EraseRootFromParent_Done,
      // Label 9540: @585506
      GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(585581), // Rule ID 10426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10426,
        GIR_EraseRootFromParent_Done,
      // Label 9541: @585581
      GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(585656), // Rule ID 10427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10427,
        GIR_EraseRootFromParent_Done,
      // Label 9542: @585656
      GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(585731), // Rule ID 10430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10430,
        GIR_EraseRootFromParent_Done,
      // Label 9543: @585731
      GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(585806), // Rule ID 10431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10431,
        GIR_EraseRootFromParent_Done,
      // Label 9544: @585806
      GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(585881), // Rule ID 10434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10434,
        GIR_EraseRootFromParent_Done,
      // Label 9545: @585881
      GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(585956), // Rule ID 10435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10435,
        GIR_EraseRootFromParent_Done,
      // Label 9546: @585956
      GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(586031), // Rule ID 10438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10438,
        GIR_EraseRootFromParent_Done,
      // Label 9547: @586031
      GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(586106), // Rule ID 10439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10439,
        GIR_EraseRootFromParent_Done,
      // Label 9548: @586106
      GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(586181), // Rule ID 10442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10442,
        GIR_EraseRootFromParent_Done,
      // Label 9549: @586181
      GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(586256), // Rule ID 10443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10443,
        GIR_EraseRootFromParent_Done,
      // Label 9550: @586256
      GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(586331), // Rule ID 10446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10446,
        GIR_EraseRootFromParent_Done,
      // Label 9551: @586331
      GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(586406), // Rule ID 10447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10447,
        GIR_EraseRootFromParent_Done,
      // Label 9552: @586406
      GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(586481), // Rule ID 10450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10450,
        GIR_EraseRootFromParent_Done,
      // Label 9553: @586481
      GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(586556), // Rule ID 10451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10451,
        GIR_EraseRootFromParent_Done,
      // Label 9554: @586556
      GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(586631), // Rule ID 10454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10454,
        GIR_EraseRootFromParent_Done,
      // Label 9555: @586631
      GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(586706), // Rule ID 10455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10455,
        GIR_EraseRootFromParent_Done,
      // Label 9556: @586706
      GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(586781), // Rule ID 10458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10458,
        GIR_EraseRootFromParent_Done,
      // Label 9557: @586781
      GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(586856), // Rule ID 10459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10459,
        GIR_EraseRootFromParent_Done,
      // Label 9558: @586856
      GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(586931), // Rule ID 10462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10462,
        GIR_EraseRootFromParent_Done,
      // Label 9559: @586931
      GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(587006), // Rule ID 10463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10463,
        GIR_EraseRootFromParent_Done,
      // Label 9560: @587006
      GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(587081), // Rule ID 10466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10466,
        GIR_EraseRootFromParent_Done,
      // Label 9561: @587081
      GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(587156), // Rule ID 10467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10467,
        GIR_EraseRootFromParent_Done,
      // Label 9562: @587156
      GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(587231), // Rule ID 10470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10470,
        GIR_EraseRootFromParent_Done,
      // Label 9563: @587231
      GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(587306), // Rule ID 10471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10471,
        GIR_EraseRootFromParent_Done,
      // Label 9564: @587306
      GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(587381), // Rule ID 10474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10474,
        GIR_EraseRootFromParent_Done,
      // Label 9565: @587381
      GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(587456), // Rule ID 10475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10475,
        GIR_EraseRootFromParent_Done,
      // Label 9566: @587456
      GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(587531), // Rule ID 10478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10478,
        GIR_EraseRootFromParent_Done,
      // Label 9567: @587531
      GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(587606), // Rule ID 10479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10479,
        GIR_EraseRootFromParent_Done,
      // Label 9568: @587606
      GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(587681), // Rule ID 10482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10482,
        GIR_EraseRootFromParent_Done,
      // Label 9569: @587681
      GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(587756), // Rule ID 10483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10483,
        GIR_EraseRootFromParent_Done,
      // Label 9570: @587756
      GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(587831), // Rule ID 10486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10486,
        GIR_EraseRootFromParent_Done,
      // Label 9571: @587831
      GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(587906), // Rule ID 10487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10487,
        GIR_EraseRootFromParent_Done,
      // Label 9572: @587906
      GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(587981), // Rule ID 10490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10490,
        GIR_EraseRootFromParent_Done,
      // Label 9573: @587981
      GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(588056), // Rule ID 10491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10491,
        GIR_EraseRootFromParent_Done,
      // Label 9574: @588056
      GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(588131), // Rule ID 10494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10494,
        GIR_EraseRootFromParent_Done,
      // Label 9575: @588131
      GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(588206), // Rule ID 10495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10495,
        GIR_EraseRootFromParent_Done,
      // Label 9576: @588206
      GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(588281), // Rule ID 10498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10498,
        GIR_EraseRootFromParent_Done,
      // Label 9577: @588281
      GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(588356), // Rule ID 10499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10499,
        GIR_EraseRootFromParent_Done,
      // Label 9578: @588356
      GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(588431), // Rule ID 10502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10502,
        GIR_EraseRootFromParent_Done,
      // Label 9579: @588431
      GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(588506), // Rule ID 10503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10503,
        GIR_EraseRootFromParent_Done,
      // Label 9580: @588506
      GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(588581), // Rule ID 10506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10506,
        GIR_EraseRootFromParent_Done,
      // Label 9581: @588581
      GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(588656), // Rule ID 10507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10507,
        GIR_EraseRootFromParent_Done,
      // Label 9582: @588656
      GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(588731), // Rule ID 10510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10510,
        GIR_EraseRootFromParent_Done,
      // Label 9583: @588731
      GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(588806), // Rule ID 10511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10511,
        GIR_EraseRootFromParent_Done,
      // Label 9584: @588806
      GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(588881), // Rule ID 10514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10514,
        GIR_EraseRootFromParent_Done,
      // Label 9585: @588881
      GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(588956), // Rule ID 10515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10515,
        GIR_EraseRootFromParent_Done,
      // Label 9586: @588956
      GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(589031), // Rule ID 10518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10518,
        GIR_EraseRootFromParent_Done,
      // Label 9587: @589031
      GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(589106), // Rule ID 10519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10519,
        GIR_EraseRootFromParent_Done,
      // Label 9588: @589106
      GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(589181), // Rule ID 10522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10522,
        GIR_EraseRootFromParent_Done,
      // Label 9589: @589181
      GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(589256), // Rule ID 10523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10523,
        GIR_EraseRootFromParent_Done,
      // Label 9590: @589256
      GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(589331), // Rule ID 10526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10526,
        GIR_EraseRootFromParent_Done,
      // Label 9591: @589331
      GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(589406), // Rule ID 10527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10527,
        GIR_EraseRootFromParent_Done,
      // Label 9592: @589406
      GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(589481), // Rule ID 10530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10530,
        GIR_EraseRootFromParent_Done,
      // Label 9593: @589481
      GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(589556), // Rule ID 10531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10531,
        GIR_EraseRootFromParent_Done,
      // Label 9594: @589556
      GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(589631), // Rule ID 10534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10534,
        GIR_EraseRootFromParent_Done,
      // Label 9595: @589631
      GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(589706), // Rule ID 10535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10535,
        GIR_EraseRootFromParent_Done,
      // Label 9596: @589706
      GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(589781), // Rule ID 10538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10538,
        GIR_EraseRootFromParent_Done,
      // Label 9597: @589781
      GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(589856), // Rule ID 10539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10539,
        GIR_EraseRootFromParent_Done,
      // Label 9598: @589856
      GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(589931), // Rule ID 10542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10542,
        GIR_EraseRootFromParent_Done,
      // Label 9599: @589931
      GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(590006), // Rule ID 10543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10543,
        GIR_EraseRootFromParent_Done,
      // Label 9600: @590006
      GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(590081), // Rule ID 10546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10546,
        GIR_EraseRootFromParent_Done,
      // Label 9601: @590081
      GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(590156), // Rule ID 10547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10547,
        GIR_EraseRootFromParent_Done,
      // Label 9602: @590156
      GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(590231), // Rule ID 10550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10550,
        GIR_EraseRootFromParent_Done,
      // Label 9603: @590231
      GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(590306), // Rule ID 10551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10551,
        GIR_EraseRootFromParent_Done,
      // Label 9604: @590306
      GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(590381), // Rule ID 10554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10554,
        GIR_EraseRootFromParent_Done,
      // Label 9605: @590381
      GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(590456), // Rule ID 10555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10555,
        GIR_EraseRootFromParent_Done,
      // Label 9606: @590456
      GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(590531), // Rule ID 10558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10558,
        GIR_EraseRootFromParent_Done,
      // Label 9607: @590531
      GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(590606), // Rule ID 10559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10559,
        GIR_EraseRootFromParent_Done,
      // Label 9608: @590606
      GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(590681), // Rule ID 10562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10562,
        GIR_EraseRootFromParent_Done,
      // Label 9609: @590681
      GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(590756), // Rule ID 10563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10563,
        GIR_EraseRootFromParent_Done,
      // Label 9610: @590756
      GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(590831), // Rule ID 10566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10566,
        GIR_EraseRootFromParent_Done,
      // Label 9611: @590831
      GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(590906), // Rule ID 10567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10567,
        GIR_EraseRootFromParent_Done,
      // Label 9612: @590906
      GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(590981), // Rule ID 10570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10570,
        GIR_EraseRootFromParent_Done,
      // Label 9613: @590981
      GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(591056), // Rule ID 10571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11023:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10571,
        GIR_EraseRootFromParent_Done,
      // Label 9614: @591056
      GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(591131), // Rule ID 10574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10574,
        GIR_EraseRootFromParent_Done,
      // Label 9615: @591131
      GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(591206), // Rule ID 10575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11023:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10575,
        GIR_EraseRootFromParent_Done,
      // Label 9616: @591206
      GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(591281), // Rule ID 10578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10578,
        GIR_EraseRootFromParent_Done,
      // Label 9617: @591281
      GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(591356), // Rule ID 10579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11023:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10579,
        GIR_EraseRootFromParent_Done,
      // Label 9618: @591356
      GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(591431), // Rule ID 10582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10582,
        GIR_EraseRootFromParent_Done,
      // Label 9619: @591431
      GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(591506), // Rule ID 10583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11023:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10583,
        GIR_EraseRootFromParent_Done,
      // Label 9620: @591506
      GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(591581), // Rule ID 10586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10586,
        GIR_EraseRootFromParent_Done,
      // Label 9621: @591581
      GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(591656), // Rule ID 10587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10587,
        GIR_EraseRootFromParent_Done,
      // Label 9622: @591656
      GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(591731), // Rule ID 10590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10590,
        GIR_EraseRootFromParent_Done,
      // Label 9623: @591731
      GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(591806), // Rule ID 10591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10591,
        GIR_EraseRootFromParent_Done,
      // Label 9624: @591806
      GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(591881), // Rule ID 10594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10594,
        GIR_EraseRootFromParent_Done,
      // Label 9625: @591881
      GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(591956), // Rule ID 10595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10595,
        GIR_EraseRootFromParent_Done,
      // Label 9626: @591956
      GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(592031), // Rule ID 10598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10598,
        GIR_EraseRootFromParent_Done,
      // Label 9627: @592031
      GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(592106), // Rule ID 10599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10599,
        GIR_EraseRootFromParent_Done,
      // Label 9628: @592106
      GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(592181), // Rule ID 10602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10602,
        GIR_EraseRootFromParent_Done,
      // Label 9629: @592181
      GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(592256), // Rule ID 10603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10603,
        GIR_EraseRootFromParent_Done,
      // Label 9630: @592256
      GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(592331), // Rule ID 10606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10606,
        GIR_EraseRootFromParent_Done,
      // Label 9631: @592331
      GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(592406), // Rule ID 10607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10607,
        GIR_EraseRootFromParent_Done,
      // Label 9632: @592406
      GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(592481), // Rule ID 10610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10610,
        GIR_EraseRootFromParent_Done,
      // Label 9633: @592481
      GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(592556), // Rule ID 10611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10611,
        GIR_EraseRootFromParent_Done,
      // Label 9634: @592556
      GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(592631), // Rule ID 10614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10614,
        GIR_EraseRootFromParent_Done,
      // Label 9635: @592631
      GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(592706), // Rule ID 10615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10615,
        GIR_EraseRootFromParent_Done,
      // Label 9636: @592706
      GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(592781), // Rule ID 10618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10618,
        GIR_EraseRootFromParent_Done,
      // Label 9637: @592781
      GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(592856), // Rule ID 10619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10619,
        GIR_EraseRootFromParent_Done,
      // Label 9638: @592856
      GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(592931), // Rule ID 10622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10622,
        GIR_EraseRootFromParent_Done,
      // Label 9639: @592931
      GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(593006), // Rule ID 10623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11023:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10623,
        GIR_EraseRootFromParent_Done,
      // Label 9640: @593006
      GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(593081), // Rule ID 10626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10626,
        GIR_EraseRootFromParent_Done,
      // Label 9641: @593081
      GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(593156), // Rule ID 10627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11023:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10627,
        GIR_EraseRootFromParent_Done,
      // Label 9642: @593156
      GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(593231), // Rule ID 10630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10630,
        GIR_EraseRootFromParent_Done,
      // Label 9643: @593231
      GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(593306), // Rule ID 10631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11023:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10631,
        GIR_EraseRootFromParent_Done,
      // Label 9644: @593306
      GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(593381), // Rule ID 10634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10634,
        GIR_EraseRootFromParent_Done,
      // Label 9645: @593381
      GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(593456), // Rule ID 10635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10635,
        GIR_EraseRootFromParent_Done,
      // Label 9646: @593456
      GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(593531), // Rule ID 10638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10638,
        GIR_EraseRootFromParent_Done,
      // Label 9647: @593531
      GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(593606), // Rule ID 10639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10639,
        GIR_EraseRootFromParent_Done,
      // Label 9648: @593606
      GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(593681), // Rule ID 10642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10642,
        GIR_EraseRootFromParent_Done,
      // Label 9649: @593681
      GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(593756), // Rule ID 10643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10643,
        GIR_EraseRootFromParent_Done,
      // Label 9650: @593756
      GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(593831), // Rule ID 10646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10646,
        GIR_EraseRootFromParent_Done,
      // Label 9651: @593831
      GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(593906), // Rule ID 10647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10647,
        GIR_EraseRootFromParent_Done,
      // Label 9652: @593906
      GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(593981), // Rule ID 10650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10650,
        GIR_EraseRootFromParent_Done,
      // Label 9653: @593981
      GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(594056), // Rule ID 10651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10651,
        GIR_EraseRootFromParent_Done,
      // Label 9654: @594056
      GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(594131), // Rule ID 10654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10654,
        GIR_EraseRootFromParent_Done,
      // Label 9655: @594131
      GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(594206), // Rule ID 10655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10655,
        GIR_EraseRootFromParent_Done,
      // Label 9656: @594206
      GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(594281), // Rule ID 10658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10658,
        GIR_EraseRootFromParent_Done,
      // Label 9657: @594281
      GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(594356), // Rule ID 10659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10659,
        GIR_EraseRootFromParent_Done,
      // Label 9658: @594356
      GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(594431), // Rule ID 10662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10662,
        GIR_EraseRootFromParent_Done,
      // Label 9659: @594431
      GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(594506), // Rule ID 10663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10663,
        GIR_EraseRootFromParent_Done,
      // Label 9660: @594506
      GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(594581), // Rule ID 10666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10666,
        GIR_EraseRootFromParent_Done,
      // Label 9661: @594581
      GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(594656), // Rule ID 10667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10667,
        GIR_EraseRootFromParent_Done,
      // Label 9662: @594656
      GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(594731), // Rule ID 10670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10670,
        GIR_EraseRootFromParent_Done,
      // Label 9663: @594731
      GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(594806), // Rule ID 10671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10671,
        GIR_EraseRootFromParent_Done,
      // Label 9664: @594806
      GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(594881), // Rule ID 10674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10674,
        GIR_EraseRootFromParent_Done,
      // Label 9665: @594881
      GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(594956), // Rule ID 10675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10675,
        GIR_EraseRootFromParent_Done,
      // Label 9666: @594956
      GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(595031), // Rule ID 10678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10678,
        GIR_EraseRootFromParent_Done,
      // Label 9667: @595031
      GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(595106), // Rule ID 10679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10679,
        GIR_EraseRootFromParent_Done,
      // Label 9668: @595106
      GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(595181), // Rule ID 10682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10682,
        GIR_EraseRootFromParent_Done,
      // Label 9669: @595181
      GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(595256), // Rule ID 10683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10683,
        GIR_EraseRootFromParent_Done,
      // Label 9670: @595256
      GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(595331), // Rule ID 10686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10686,
        GIR_EraseRootFromParent_Done,
      // Label 9671: @595331
      GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(595406), // Rule ID 10687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10687,
        GIR_EraseRootFromParent_Done,
      // Label 9672: @595406
      GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(595481), // Rule ID 10690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10690,
        GIR_EraseRootFromParent_Done,
      // Label 9673: @595481
      GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(595556), // Rule ID 10691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10691,
        GIR_EraseRootFromParent_Done,
      // Label 9674: @595556
      GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(595631), // Rule ID 10694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10694,
        GIR_EraseRootFromParent_Done,
      // Label 9675: @595631
      GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(595706), // Rule ID 10695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10695,
        GIR_EraseRootFromParent_Done,
      // Label 9676: @595706
      GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(595781), // Rule ID 10698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10698,
        GIR_EraseRootFromParent_Done,
      // Label 9677: @595781
      GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(595856), // Rule ID 10699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10699,
        GIR_EraseRootFromParent_Done,
      // Label 9678: @595856
      GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(595931), // Rule ID 10702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10702,
        GIR_EraseRootFromParent_Done,
      // Label 9679: @595931
      GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(596006), // Rule ID 10703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10703,
        GIR_EraseRootFromParent_Done,
      // Label 9680: @596006
      GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(596081), // Rule ID 10706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10706,
        GIR_EraseRootFromParent_Done,
      // Label 9681: @596081
      GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(596156), // Rule ID 10707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10707,
        GIR_EraseRootFromParent_Done,
      // Label 9682: @596156
      GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(596231), // Rule ID 10710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10710,
        GIR_EraseRootFromParent_Done,
      // Label 9683: @596231
      GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(596306), // Rule ID 10711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10711,
        GIR_EraseRootFromParent_Done,
      // Label 9684: @596306
      GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(596381), // Rule ID 10714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10714,
        GIR_EraseRootFromParent_Done,
      // Label 9685: @596381
      GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(596456), // Rule ID 10715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10715,
        GIR_EraseRootFromParent_Done,
      // Label 9686: @596456
      GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(596531), // Rule ID 10718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10718,
        GIR_EraseRootFromParent_Done,
      // Label 9687: @596531
      GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(596606), // Rule ID 10719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10719,
        GIR_EraseRootFromParent_Done,
      // Label 9688: @596606
      GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(596681), // Rule ID 10722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10722,
        GIR_EraseRootFromParent_Done,
      // Label 9689: @596681
      GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(596756), // Rule ID 10723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10723,
        GIR_EraseRootFromParent_Done,
      // Label 9690: @596756
      GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(596831), // Rule ID 10726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10726,
        GIR_EraseRootFromParent_Done,
      // Label 9691: @596831
      GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(596906), // Rule ID 10727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10727,
        GIR_EraseRootFromParent_Done,
      // Label 9692: @596906
      GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(596981), // Rule ID 10730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10730,
        GIR_EraseRootFromParent_Done,
      // Label 9693: @596981
      GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(597056), // Rule ID 10731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10731,
        GIR_EraseRootFromParent_Done,
      // Label 9694: @597056
      GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(597131), // Rule ID 10734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10734,
        GIR_EraseRootFromParent_Done,
      // Label 9695: @597131
      GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(597206), // Rule ID 10735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10735,
        GIR_EraseRootFromParent_Done,
      // Label 9696: @597206
      GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(597281), // Rule ID 10738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10738,
        GIR_EraseRootFromParent_Done,
      // Label 9697: @597281
      GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(597356), // Rule ID 10739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10739,
        GIR_EraseRootFromParent_Done,
      // Label 9698: @597356
      GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(597431), // Rule ID 10742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10742,
        GIR_EraseRootFromParent_Done,
      // Label 9699: @597431
      GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(597506), // Rule ID 10743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10743,
        GIR_EraseRootFromParent_Done,
      // Label 9700: @597506
      GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(597581), // Rule ID 10746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10746,
        GIR_EraseRootFromParent_Done,
      // Label 9701: @597581
      GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(597656), // Rule ID 10747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11021:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10747,
        GIR_EraseRootFromParent_Done,
      // Label 9702: @597656
      GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(597731), // Rule ID 10750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10750,
        GIR_EraseRootFromParent_Done,
      // Label 9703: @597731
      GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(597806), // Rule ID 10751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11021:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10751,
        GIR_EraseRootFromParent_Done,
      // Label 9704: @597806
      GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(597881), // Rule ID 10754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10754,
        GIR_EraseRootFromParent_Done,
      // Label 9705: @597881
      GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(597956), // Rule ID 10755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11021:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10755,
        GIR_EraseRootFromParent_Done,
      // Label 9706: @597956
      GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(598031), // Rule ID 10758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10758,
        GIR_EraseRootFromParent_Done,
      // Label 9707: @598031
      GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(598106), // Rule ID 10759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11021:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10759,
        GIR_EraseRootFromParent_Done,
      // Label 9708: @598106
      GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(598181), // Rule ID 10762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10762,
        GIR_EraseRootFromParent_Done,
      // Label 9709: @598181
      GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(598256), // Rule ID 10763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10763,
        GIR_EraseRootFromParent_Done,
      // Label 9710: @598256
      GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(598331), // Rule ID 10766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10766,
        GIR_EraseRootFromParent_Done,
      // Label 9711: @598331
      GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(598406), // Rule ID 10767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10767,
        GIR_EraseRootFromParent_Done,
      // Label 9712: @598406
      GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(598481), // Rule ID 10770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10770,
        GIR_EraseRootFromParent_Done,
      // Label 9713: @598481
      GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(598556), // Rule ID 10771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10771,
        GIR_EraseRootFromParent_Done,
      // Label 9714: @598556
      GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(598631), // Rule ID 10774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10774,
        GIR_EraseRootFromParent_Done,
      // Label 9715: @598631
      GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(598706), // Rule ID 10775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10775,
        GIR_EraseRootFromParent_Done,
      // Label 9716: @598706
      GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(598781), // Rule ID 10778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10778,
        GIR_EraseRootFromParent_Done,
      // Label 9717: @598781
      GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(598856), // Rule ID 10779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10779,
        GIR_EraseRootFromParent_Done,
      // Label 9718: @598856
      GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(598931), // Rule ID 10782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10782,
        GIR_EraseRootFromParent_Done,
      // Label 9719: @598931
      GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(599006), // Rule ID 10783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10783,
        GIR_EraseRootFromParent_Done,
      // Label 9720: @599006
      GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(599081), // Rule ID 10786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10786,
        GIR_EraseRootFromParent_Done,
      // Label 9721: @599081
      GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(599156), // Rule ID 10787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10787,
        GIR_EraseRootFromParent_Done,
      // Label 9722: @599156
      GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(599231), // Rule ID 10790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10790,
        GIR_EraseRootFromParent_Done,
      // Label 9723: @599231
      GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(599306), // Rule ID 10791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10791,
        GIR_EraseRootFromParent_Done,
      // Label 9724: @599306
      GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(599381), // Rule ID 10794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10794,
        GIR_EraseRootFromParent_Done,
      // Label 9725: @599381
      GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(599456), // Rule ID 10795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10795,
        GIR_EraseRootFromParent_Done,
      // Label 9726: @599456
      GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(599531), // Rule ID 10798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10798,
        GIR_EraseRootFromParent_Done,
      // Label 9727: @599531
      GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(599606), // Rule ID 10799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11021:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10799,
        GIR_EraseRootFromParent_Done,
      // Label 9728: @599606
      GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(599681), // Rule ID 10802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10802,
        GIR_EraseRootFromParent_Done,
      // Label 9729: @599681
      GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(599756), // Rule ID 10803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11021:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10803,
        GIR_EraseRootFromParent_Done,
      // Label 9730: @599756
      GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(599831), // Rule ID 10806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10806,
        GIR_EraseRootFromParent_Done,
      // Label 9731: @599831
      GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(599906), // Rule ID 10807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11021:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10807,
        GIR_EraseRootFromParent_Done,
      // Label 9732: @599906
      GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(599981), // Rule ID 10810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10810,
        GIR_EraseRootFromParent_Done,
      // Label 9733: @599981
      GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(600056), // Rule ID 10811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10811,
        GIR_EraseRootFromParent_Done,
      // Label 9734: @600056
      GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(600131), // Rule ID 10814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10814,
        GIR_EraseRootFromParent_Done,
      // Label 9735: @600131
      GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(600206), // Rule ID 10815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10815,
        GIR_EraseRootFromParent_Done,
      // Label 9736: @600206
      GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(600281), // Rule ID 10818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10818,
        GIR_EraseRootFromParent_Done,
      // Label 9737: @600281
      GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(600356), // Rule ID 10819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10819,
        GIR_EraseRootFromParent_Done,
      // Label 9738: @600356
      GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(600431), // Rule ID 10822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10822,
        GIR_EraseRootFromParent_Done,
      // Label 9739: @600431
      GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(600506), // Rule ID 10823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10823,
        GIR_EraseRootFromParent_Done,
      // Label 9740: @600506
      GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(600581), // Rule ID 10826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10826,
        GIR_EraseRootFromParent_Done,
      // Label 9741: @600581
      GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(600656), // Rule ID 10827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10827,
        GIR_EraseRootFromParent_Done,
      // Label 9742: @600656
      GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(600731), // Rule ID 10830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10830,
        GIR_EraseRootFromParent_Done,
      // Label 9743: @600731
      GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(600806), // Rule ID 10831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10831,
        GIR_EraseRootFromParent_Done,
      // Label 9744: @600806
      GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(600881), // Rule ID 10834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10834,
        GIR_EraseRootFromParent_Done,
      // Label 9745: @600881
      GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(600956), // Rule ID 10835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10835,
        GIR_EraseRootFromParent_Done,
      // Label 9746: @600956
      GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(601031), // Rule ID 10838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10838,
        GIR_EraseRootFromParent_Done,
      // Label 9747: @601031
      GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(601106), // Rule ID 10839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10839,
        GIR_EraseRootFromParent_Done,
      // Label 9748: @601106
      GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(601181), // Rule ID 10842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10842,
        GIR_EraseRootFromParent_Done,
      // Label 9749: @601181
      GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(601256), // Rule ID 10843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10843,
        GIR_EraseRootFromParent_Done,
      // Label 9750: @601256
      GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(601331), // Rule ID 10846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10846,
        GIR_EraseRootFromParent_Done,
      // Label 9751: @601331
      GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(601406), // Rule ID 10847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10847,
        GIR_EraseRootFromParent_Done,
      // Label 9752: @601406
      GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(601481), // Rule ID 10850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10850,
        GIR_EraseRootFromParent_Done,
      // Label 9753: @601481
      GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(601556), // Rule ID 10851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10851,
        GIR_EraseRootFromParent_Done,
      // Label 9754: @601556
      GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(601631), // Rule ID 10854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10854,
        GIR_EraseRootFromParent_Done,
      // Label 9755: @601631
      GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(601706), // Rule ID 10855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10855,
        GIR_EraseRootFromParent_Done,
      // Label 9756: @601706
      GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(601781), // Rule ID 10858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10858,
        GIR_EraseRootFromParent_Done,
      // Label 9757: @601781
      GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(601856), // Rule ID 10859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10859,
        GIR_EraseRootFromParent_Done,
      // Label 9758: @601856
      GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(601931), // Rule ID 10862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10862,
        GIR_EraseRootFromParent_Done,
      // Label 9759: @601931
      GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(602006), // Rule ID 10863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10863,
        GIR_EraseRootFromParent_Done,
      // Label 9760: @602006
      GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(602081), // Rule ID 10866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10866,
        GIR_EraseRootFromParent_Done,
      // Label 9761: @602081
      GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(602156), // Rule ID 10867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10867,
        GIR_EraseRootFromParent_Done,
      // Label 9762: @602156
      GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(602231), // Rule ID 10870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10870,
        GIR_EraseRootFromParent_Done,
      // Label 9763: @602231
      GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(602306), // Rule ID 10871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10871,
        GIR_EraseRootFromParent_Done,
      // Label 9764: @602306
      GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(602381), // Rule ID 10874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10874,
        GIR_EraseRootFromParent_Done,
      // Label 9765: @602381
      GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(602456), // Rule ID 10875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10875,
        GIR_EraseRootFromParent_Done,
      // Label 9766: @602456
      GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(602531), // Rule ID 10878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10878,
        GIR_EraseRootFromParent_Done,
      // Label 9767: @602531
      GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(602606), // Rule ID 10879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10879,
        GIR_EraseRootFromParent_Done,
      // Label 9768: @602606
      GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(602681), // Rule ID 10882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10882,
        GIR_EraseRootFromParent_Done,
      // Label 9769: @602681
      GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(602756), // Rule ID 10883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10883,
        GIR_EraseRootFromParent_Done,
      // Label 9770: @602756
      GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(602831), // Rule ID 10886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10886,
        GIR_EraseRootFromParent_Done,
      // Label 9771: @602831
      GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(602906), // Rule ID 10887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10887,
        GIR_EraseRootFromParent_Done,
      // Label 9772: @602906
      GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(602981), // Rule ID 10890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10890,
        GIR_EraseRootFromParent_Done,
      // Label 9773: @602981
      GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(603056), // Rule ID 10891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10891,
        GIR_EraseRootFromParent_Done,
      // Label 9774: @603056
      GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(603131), // Rule ID 10894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10894,
        GIR_EraseRootFromParent_Done,
      // Label 9775: @603131
      GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(603206), // Rule ID 10895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10895,
        GIR_EraseRootFromParent_Done,
      // Label 9776: @603206
      GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(603281), // Rule ID 10898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10898,
        GIR_EraseRootFromParent_Done,
      // Label 9777: @603281
      GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(603356), // Rule ID 10899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10899,
        GIR_EraseRootFromParent_Done,
      // Label 9778: @603356
      GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(603431), // Rule ID 10902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10902,
        GIR_EraseRootFromParent_Done,
      // Label 9779: @603431
      GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(603506), // Rule ID 10903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10903,
        GIR_EraseRootFromParent_Done,
      // Label 9780: @603506
      GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(603581), // Rule ID 10906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10906,
        GIR_EraseRootFromParent_Done,
      // Label 9781: @603581
      GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(603656), // Rule ID 10907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10907,
        GIR_EraseRootFromParent_Done,
      // Label 9782: @603656
      GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(603731), // Rule ID 10910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10910,
        GIR_EraseRootFromParent_Done,
      // Label 9783: @603731
      GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(603806), // Rule ID 10911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10911,
        GIR_EraseRootFromParent_Done,
      // Label 9784: @603806
      GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(603881), // Rule ID 10914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10914,
        GIR_EraseRootFromParent_Done,
      // Label 9785: @603881
      GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(603956), // Rule ID 10915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10915,
        GIR_EraseRootFromParent_Done,
      // Label 9786: @603956
      GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(604031), // Rule ID 10918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10918,
        GIR_EraseRootFromParent_Done,
      // Label 9787: @604031
      GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(604106), // Rule ID 10919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10919,
        GIR_EraseRootFromParent_Done,
      // Label 9788: @604106
      GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(604181), // Rule ID 10922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10922,
        GIR_EraseRootFromParent_Done,
      // Label 9789: @604181
      GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(604256), // Rule ID 10923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11076:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10923,
        GIR_EraseRootFromParent_Done,
      // Label 9790: @604256
      GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(604331), // Rule ID 10926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10926,
        GIR_EraseRootFromParent_Done,
      // Label 9791: @604331
      GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(604406), // Rule ID 10927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11076:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10927,
        GIR_EraseRootFromParent_Done,
      // Label 9792: @604406
      GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(604481), // Rule ID 10930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10930,
        GIR_EraseRootFromParent_Done,
      // Label 9793: @604481
      GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(604556), // Rule ID 10931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10931,
        GIR_EraseRootFromParent_Done,
      // Label 9794: @604556
      GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(604631), // Rule ID 10934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10934,
        GIR_EraseRootFromParent_Done,
      // Label 9795: @604631
      GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(604706), // Rule ID 10935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10935,
        GIR_EraseRootFromParent_Done,
      // Label 9796: @604706
      GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(604781), // Rule ID 10938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10938,
        GIR_EraseRootFromParent_Done,
      // Label 9797: @604781
      GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(604856), // Rule ID 10939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10939,
        GIR_EraseRootFromParent_Done,
      // Label 9798: @604856
      GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(604931), // Rule ID 10942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10942,
        GIR_EraseRootFromParent_Done,
      // Label 9799: @604931
      GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(605006), // Rule ID 10943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10943,
        GIR_EraseRootFromParent_Done,
      // Label 9800: @605006
      GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(605081), // Rule ID 10946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10946,
        GIR_EraseRootFromParent_Done,
      // Label 9801: @605081
      GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(605156), // Rule ID 10947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10947,
        GIR_EraseRootFromParent_Done,
      // Label 9802: @605156
      GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(605231), // Rule ID 10950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10950,
        GIR_EraseRootFromParent_Done,
      // Label 9803: @605231
      GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(605306), // Rule ID 10951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10951,
        GIR_EraseRootFromParent_Done,
      // Label 9804: @605306
      GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(605381), // Rule ID 10954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10954,
        GIR_EraseRootFromParent_Done,
      // Label 9805: @605381
      GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(605456), // Rule ID 10955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10955,
        GIR_EraseRootFromParent_Done,
      // Label 9806: @605456
      GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(605531), // Rule ID 10958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10958,
        GIR_EraseRootFromParent_Done,
      // Label 9807: @605531
      GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(605606), // Rule ID 10959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10959,
        GIR_EraseRootFromParent_Done,
      // Label 9808: @605606
      GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(605681), // Rule ID 10962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10962,
        GIR_EraseRootFromParent_Done,
      // Label 9809: @605681
      GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(605756), // Rule ID 10963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10963,
        GIR_EraseRootFromParent_Done,
      // Label 9810: @605756
      GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(605831), // Rule ID 10966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10966,
        GIR_EraseRootFromParent_Done,
      // Label 9811: @605831
      GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(605906), // Rule ID 10967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10967,
        GIR_EraseRootFromParent_Done,
      // Label 9812: @605906
      GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(605981), // Rule ID 10970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10970,
        GIR_EraseRootFromParent_Done,
      // Label 9813: @605981
      GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(606056), // Rule ID 10971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10971,
        GIR_EraseRootFromParent_Done,
      // Label 9814: @606056
      GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(606131), // Rule ID 10974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10974,
        GIR_EraseRootFromParent_Done,
      // Label 9815: @606131
      GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(606206), // Rule ID 10975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10975,
        GIR_EraseRootFromParent_Done,
      // Label 9816: @606206
      GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(606281), // Rule ID 10978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10978,
        GIR_EraseRootFromParent_Done,
      // Label 9817: @606281
      GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(606356), // Rule ID 10979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10979,
        GIR_EraseRootFromParent_Done,
      // Label 9818: @606356
      GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(606431), // Rule ID 10982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10982,
        GIR_EraseRootFromParent_Done,
      // Label 9819: @606431
      GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(606506), // Rule ID 10983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10983,
        GIR_EraseRootFromParent_Done,
      // Label 9820: @606506
      GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(606581), // Rule ID 10986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10986,
        GIR_EraseRootFromParent_Done,
      // Label 9821: @606581
      GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(606656), // Rule ID 10987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10987,
        GIR_EraseRootFromParent_Done,
      // Label 9822: @606656
      GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(606731), // Rule ID 10990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10990,
        GIR_EraseRootFromParent_Done,
      // Label 9823: @606731
      GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(606806), // Rule ID 10991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10991,
        GIR_EraseRootFromParent_Done,
      // Label 9824: @606806
      GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(606881), // Rule ID 10994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10994,
        GIR_EraseRootFromParent_Done,
      // Label 9825: @606881
      GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(606956), // Rule ID 10995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10995,
        GIR_EraseRootFromParent_Done,
      // Label 9826: @606956
      GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(607031), // Rule ID 10998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10998,
        GIR_EraseRootFromParent_Done,
      // Label 9827: @607031
      GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(607106), // Rule ID 10999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10999,
        GIR_EraseRootFromParent_Done,
      // Label 9828: @607106
      GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(607181), // Rule ID 11002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11002,
        GIR_EraseRootFromParent_Done,
      // Label 9829: @607181
      GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(607256), // Rule ID 11003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11003,
        GIR_EraseRootFromParent_Done,
      // Label 9830: @607256
      GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(607331), // Rule ID 11006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11006,
        GIR_EraseRootFromParent_Done,
      // Label 9831: @607331
      GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(607406), // Rule ID 11007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11007,
        GIR_EraseRootFromParent_Done,
      // Label 9832: @607406
      GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(607481), // Rule ID 11010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11010,
        GIR_EraseRootFromParent_Done,
      // Label 9833: @607481
      GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(607556), // Rule ID 11011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11011,
        GIR_EraseRootFromParent_Done,
      // Label 9834: @607556
      GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(607631), // Rule ID 11014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11014,
        GIR_EraseRootFromParent_Done,
      // Label 9835: @607631
      GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(607706), // Rule ID 11015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11015,
        GIR_EraseRootFromParent_Done,
      // Label 9836: @607706
      GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(607781), // Rule ID 11018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11018,
        GIR_EraseRootFromParent_Done,
      // Label 9837: @607781
      GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(607856), // Rule ID 11019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11019,
        GIR_EraseRootFromParent_Done,
      // Label 9838: @607856
      GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(607931), // Rule ID 11022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11022,
        GIR_EraseRootFromParent_Done,
      // Label 9839: @607931
      GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(608006), // Rule ID 11023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11023,
        GIR_EraseRootFromParent_Done,
      // Label 9840: @608006
      GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(608081), // Rule ID 11026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11026,
        GIR_EraseRootFromParent_Done,
      // Label 9841: @608081
      GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(608156), // Rule ID 11027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11027,
        GIR_EraseRootFromParent_Done,
      // Label 9842: @608156
      GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(608231), // Rule ID 11030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11030,
        GIR_EraseRootFromParent_Done,
      // Label 9843: @608231
      GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(608306), // Rule ID 11031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11031,
        GIR_EraseRootFromParent_Done,
      // Label 9844: @608306
      GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(608381), // Rule ID 11034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11034,
        GIR_EraseRootFromParent_Done,
      // Label 9845: @608381
      GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(608456), // Rule ID 11035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11035,
        GIR_EraseRootFromParent_Done,
      // Label 9846: @608456
      GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(608531), // Rule ID 11038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11038,
        GIR_EraseRootFromParent_Done,
      // Label 9847: @608531
      GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(608606), // Rule ID 11039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11039,
        GIR_EraseRootFromParent_Done,
      // Label 9848: @608606
      GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(608681), // Rule ID 11042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11042,
        GIR_EraseRootFromParent_Done,
      // Label 9849: @608681
      GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(608756), // Rule ID 11043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11043,
        GIR_EraseRootFromParent_Done,
      // Label 9850: @608756
      GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(608831), // Rule ID 11046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11046,
        GIR_EraseRootFromParent_Done,
      // Label 9851: @608831
      GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(608906), // Rule ID 11047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11047,
        GIR_EraseRootFromParent_Done,
      // Label 9852: @608906
      GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(608981), // Rule ID 11050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11050,
        GIR_EraseRootFromParent_Done,
      // Label 9853: @608981
      GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(609056), // Rule ID 11051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11051,
        GIR_EraseRootFromParent_Done,
      // Label 9854: @609056
      GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(609131), // Rule ID 11054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11054,
        GIR_EraseRootFromParent_Done,
      // Label 9855: @609131
      GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(609206), // Rule ID 11055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11055,
        GIR_EraseRootFromParent_Done,
      // Label 9856: @609206
      GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(609281), // Rule ID 11058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11058,
        GIR_EraseRootFromParent_Done,
      // Label 9857: @609281
      GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(609356), // Rule ID 11059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11059,
        GIR_EraseRootFromParent_Done,
      // Label 9858: @609356
      GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(609431), // Rule ID 11062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11062,
        GIR_EraseRootFromParent_Done,
      // Label 9859: @609431
      GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(609506), // Rule ID 11063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11063,
        GIR_EraseRootFromParent_Done,
      // Label 9860: @609506
      GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(609581), // Rule ID 11066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11066,
        GIR_EraseRootFromParent_Done,
      // Label 9861: @609581
      GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(609656), // Rule ID 11067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11067,
        GIR_EraseRootFromParent_Done,
      // Label 9862: @609656
      GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(609731), // Rule ID 11070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11070,
        GIR_EraseRootFromParent_Done,
      // Label 9863: @609731
      GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(609806), // Rule ID 11071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11071,
        GIR_EraseRootFromParent_Done,
      // Label 9864: @609806
      GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(609881), // Rule ID 11074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11074,
        GIR_EraseRootFromParent_Done,
      // Label 9865: @609881
      GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(609956), // Rule ID 11075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11075,
        GIR_EraseRootFromParent_Done,
      // Label 9866: @609956
      GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(610031), // Rule ID 11078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11078,
        GIR_EraseRootFromParent_Done,
      // Label 9867: @610031
      GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(610106), // Rule ID 11079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11079,
        GIR_EraseRootFromParent_Done,
      // Label 9868: @610106
      GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(610181), // Rule ID 11082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11082,
        GIR_EraseRootFromParent_Done,
      // Label 9869: @610181
      GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(610256), // Rule ID 11083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11083,
        GIR_EraseRootFromParent_Done,
      // Label 9870: @610256
      GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(610331), // Rule ID 11086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11086,
        GIR_EraseRootFromParent_Done,
      // Label 9871: @610331
      GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(610406), // Rule ID 11087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11087,
        GIR_EraseRootFromParent_Done,
      // Label 9872: @610406
      GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(610481), // Rule ID 11090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11090,
        GIR_EraseRootFromParent_Done,
      // Label 9873: @610481
      GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(610556), // Rule ID 11091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11091,
        GIR_EraseRootFromParent_Done,
      // Label 9874: @610556
      GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(610631), // Rule ID 11094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11094,
        GIR_EraseRootFromParent_Done,
      // Label 9875: @610631
      GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(610706), // Rule ID 11095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11095,
        GIR_EraseRootFromParent_Done,
      // Label 9876: @610706
      GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(610781), // Rule ID 11098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11098,
        GIR_EraseRootFromParent_Done,
      // Label 9877: @610781
      GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(610856), // Rule ID 11099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11099,
        GIR_EraseRootFromParent_Done,
      // Label 9878: @610856
      GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(610931), // Rule ID 11102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11102,
        GIR_EraseRootFromParent_Done,
      // Label 9879: @610931
      GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(611006), // Rule ID 11103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11103,
        GIR_EraseRootFromParent_Done,
      // Label 9880: @611006
      GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(611081), // Rule ID 11106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11106,
        GIR_EraseRootFromParent_Done,
      // Label 9881: @611081
      GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(611156), // Rule ID 11107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11107,
        GIR_EraseRootFromParent_Done,
      // Label 9882: @611156
      GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(611231), // Rule ID 11110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11110,
        GIR_EraseRootFromParent_Done,
      // Label 9883: @611231
      GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(611306), // Rule ID 11111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11111,
        GIR_EraseRootFromParent_Done,
      // Label 9884: @611306
      GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(611381), // Rule ID 11114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11114,
        GIR_EraseRootFromParent_Done,
      // Label 9885: @611381
      GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(611456), // Rule ID 11115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11115,
        GIR_EraseRootFromParent_Done,
      // Label 9886: @611456
      GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(611531), // Rule ID 11118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11118,
        GIR_EraseRootFromParent_Done,
      // Label 9887: @611531
      GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(611606), // Rule ID 11119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11119,
        GIR_EraseRootFromParent_Done,
      // Label 9888: @611606
      GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(611681), // Rule ID 11122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11122,
        GIR_EraseRootFromParent_Done,
      // Label 9889: @611681
      GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(611756), // Rule ID 11123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11123,
        GIR_EraseRootFromParent_Done,
      // Label 9890: @611756
      GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(611831), // Rule ID 11126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11126,
        GIR_EraseRootFromParent_Done,
      // Label 9891: @611831
      GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(611906), // Rule ID 11127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11127,
        GIR_EraseRootFromParent_Done,
      // Label 9892: @611906
      GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(611981), // Rule ID 11130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11130,
        GIR_EraseRootFromParent_Done,
      // Label 9893: @611981
      GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(612056), // Rule ID 11131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11131,
        GIR_EraseRootFromParent_Done,
      // Label 9894: @612056
      GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(612131), // Rule ID 11134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11134,
        GIR_EraseRootFromParent_Done,
      // Label 9895: @612131
      GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(612206), // Rule ID 11135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11135,
        GIR_EraseRootFromParent_Done,
      // Label 9896: @612206
      GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(612281), // Rule ID 11138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11138,
        GIR_EraseRootFromParent_Done,
      // Label 9897: @612281
      GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(612356), // Rule ID 11139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11139,
        GIR_EraseRootFromParent_Done,
      // Label 9898: @612356
      GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(612431), // Rule ID 11142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11142,
        GIR_EraseRootFromParent_Done,
      // Label 9899: @612431
      GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(612506), // Rule ID 11143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11143,
        GIR_EraseRootFromParent_Done,
      // Label 9900: @612506
      GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(612581), // Rule ID 11146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11146,
        GIR_EraseRootFromParent_Done,
      // Label 9901: @612581
      GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(612656), // Rule ID 11147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11147,
        GIR_EraseRootFromParent_Done,
      // Label 9902: @612656
      GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(612731), // Rule ID 11150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11150,
        GIR_EraseRootFromParent_Done,
      // Label 9903: @612731
      GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(612806), // Rule ID 11151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11151,
        GIR_EraseRootFromParent_Done,
      // Label 9904: @612806
      GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(612881), // Rule ID 11154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11154,
        GIR_EraseRootFromParent_Done,
      // Label 9905: @612881
      GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(612956), // Rule ID 11155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11155,
        GIR_EraseRootFromParent_Done,
      // Label 9906: @612956
      GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(613031), // Rule ID 11158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11158,
        GIR_EraseRootFromParent_Done,
      // Label 9907: @613031
      GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(613106), // Rule ID 11159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11159,
        GIR_EraseRootFromParent_Done,
      // Label 9908: @613106
      GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(613181), // Rule ID 11162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11162,
        GIR_EraseRootFromParent_Done,
      // Label 9909: @613181
      GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(613256), // Rule ID 11163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11163,
        GIR_EraseRootFromParent_Done,
      // Label 9910: @613256
      GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(613331), // Rule ID 11166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11166,
        GIR_EraseRootFromParent_Done,
      // Label 9911: @613331
      GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(613406), // Rule ID 11167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11167,
        GIR_EraseRootFromParent_Done,
      // Label 9912: @613406
      GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(613481), // Rule ID 11170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11170,
        GIR_EraseRootFromParent_Done,
      // Label 9913: @613481
      GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(613556), // Rule ID 11171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11171,
        GIR_EraseRootFromParent_Done,
      // Label 9914: @613556
      GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(613631), // Rule ID 11174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11174,
        GIR_EraseRootFromParent_Done,
      // Label 9915: @613631
      GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(613706), // Rule ID 11175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11175,
        GIR_EraseRootFromParent_Done,
      // Label 9916: @613706
      GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(613781), // Rule ID 11178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11178,
        GIR_EraseRootFromParent_Done,
      // Label 9917: @613781
      GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(613856), // Rule ID 11179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11179,
        GIR_EraseRootFromParent_Done,
      // Label 9918: @613856
      GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(613931), // Rule ID 11182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11182,
        GIR_EraseRootFromParent_Done,
      // Label 9919: @613931
      GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(614006), // Rule ID 11183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11183,
        GIR_EraseRootFromParent_Done,
      // Label 9920: @614006
      GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(614081), // Rule ID 11186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11186,
        GIR_EraseRootFromParent_Done,
      // Label 9921: @614081
      GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(614156), // Rule ID 11187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11187,
        GIR_EraseRootFromParent_Done,
      // Label 9922: @614156
      GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(614231), // Rule ID 11190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11190,
        GIR_EraseRootFromParent_Done,
      // Label 9923: @614231
      GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(614306), // Rule ID 11191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11191,
        GIR_EraseRootFromParent_Done,
      // Label 9924: @614306
      GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(614381), // Rule ID 11194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11194,
        GIR_EraseRootFromParent_Done,
      // Label 9925: @614381
      GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(614456), // Rule ID 11195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11195,
        GIR_EraseRootFromParent_Done,
      // Label 9926: @614456
      GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(614531), // Rule ID 11198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11198,
        GIR_EraseRootFromParent_Done,
      // Label 9927: @614531
      GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(614606), // Rule ID 11199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11199,
        GIR_EraseRootFromParent_Done,
      // Label 9928: @614606
      GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(614681), // Rule ID 11202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11202,
        GIR_EraseRootFromParent_Done,
      // Label 9929: @614681
      GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(614756), // Rule ID 11203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11203,
        GIR_EraseRootFromParent_Done,
      // Label 9930: @614756
      GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(614831), // Rule ID 11206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11206,
        GIR_EraseRootFromParent_Done,
      // Label 9931: @614831
      GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(614906), // Rule ID 11207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11207,
        GIR_EraseRootFromParent_Done,
      // Label 9932: @614906
      GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(614981), // Rule ID 11210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11210,
        GIR_EraseRootFromParent_Done,
      // Label 9933: @614981
      GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(615056), // Rule ID 11211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11211,
        GIR_EraseRootFromParent_Done,
      // Label 9934: @615056
      GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(615131), // Rule ID 11214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11214,
        GIR_EraseRootFromParent_Done,
      // Label 9935: @615131
      GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(615206), // Rule ID 11215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11215,
        GIR_EraseRootFromParent_Done,
      // Label 9936: @615206
      GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(615281), // Rule ID 11218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11218,
        GIR_EraseRootFromParent_Done,
      // Label 9937: @615281
      GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(615356), // Rule ID 11219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11219,
        GIR_EraseRootFromParent_Done,
      // Label 9938: @615356
      GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(615431), // Rule ID 11222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11222,
        GIR_EraseRootFromParent_Done,
      // Label 9939: @615431
      GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(615506), // Rule ID 11223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11223,
        GIR_EraseRootFromParent_Done,
      // Label 9940: @615506
      GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(615581), // Rule ID 11226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11226,
        GIR_EraseRootFromParent_Done,
      // Label 9941: @615581
      GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(615656), // Rule ID 11227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11227,
        GIR_EraseRootFromParent_Done,
      // Label 9942: @615656
      GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(615731), // Rule ID 11230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11230,
        GIR_EraseRootFromParent_Done,
      // Label 9943: @615731
      GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(615806), // Rule ID 11231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11231,
        GIR_EraseRootFromParent_Done,
      // Label 9944: @615806
      GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(615881), // Rule ID 11234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11234,
        GIR_EraseRootFromParent_Done,
      // Label 9945: @615881
      GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(615956), // Rule ID 11235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11235,
        GIR_EraseRootFromParent_Done,
      // Label 9946: @615956
      GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(616031), // Rule ID 11238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11238,
        GIR_EraseRootFromParent_Done,
      // Label 9947: @616031
      GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(616106), // Rule ID 11239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11239,
        GIR_EraseRootFromParent_Done,
      // Label 9948: @616106
      GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(616181), // Rule ID 11242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11242,
        GIR_EraseRootFromParent_Done,
      // Label 9949: @616181
      GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(616256), // Rule ID 11243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11243,
        GIR_EraseRootFromParent_Done,
      // Label 9950: @616256
      GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(616331), // Rule ID 11246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11246,
        GIR_EraseRootFromParent_Done,
      // Label 9951: @616331
      GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(616406), // Rule ID 11247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11247,
        GIR_EraseRootFromParent_Done,
      // Label 9952: @616406
      GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(616481), // Rule ID 11250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11250,
        GIR_EraseRootFromParent_Done,
      // Label 9953: @616481
      GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(616556), // Rule ID 11251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11251,
        GIR_EraseRootFromParent_Done,
      // Label 9954: @616556
      GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(616631), // Rule ID 11254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11254,
        GIR_EraseRootFromParent_Done,
      // Label 9955: @616631
      GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(616706), // Rule ID 11255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11255,
        GIR_EraseRootFromParent_Done,
      // Label 9956: @616706
      GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(616781), // Rule ID 11258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11258,
        GIR_EraseRootFromParent_Done,
      // Label 9957: @616781
      GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(616856), // Rule ID 11259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11259,
        GIR_EraseRootFromParent_Done,
      // Label 9958: @616856
      GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(616931), // Rule ID 11262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11262,
        GIR_EraseRootFromParent_Done,
      // Label 9959: @616931
      GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(617006), // Rule ID 11263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11263,
        GIR_EraseRootFromParent_Done,
      // Label 9960: @617006
      GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(617081), // Rule ID 11266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11266,
        GIR_EraseRootFromParent_Done,
      // Label 9961: @617081
      GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(617156), // Rule ID 11267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11267,
        GIR_EraseRootFromParent_Done,
      // Label 9962: @617156
      GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(617231), // Rule ID 11270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11270,
        GIR_EraseRootFromParent_Done,
      // Label 9963: @617231
      GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(617306), // Rule ID 11271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11271,
        GIR_EraseRootFromParent_Done,
      // Label 9964: @617306
      GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(617381), // Rule ID 11274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11274,
        GIR_EraseRootFromParent_Done,
      // Label 9965: @617381
      GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(617456), // Rule ID 11275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11275,
        GIR_EraseRootFromParent_Done,
      // Label 9966: @617456
      GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(617531), // Rule ID 11278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11278,
        GIR_EraseRootFromParent_Done,
      // Label 9967: @617531
      GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(617606), // Rule ID 11279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11279,
        GIR_EraseRootFromParent_Done,
      // Label 9968: @617606
      GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(617681), // Rule ID 11282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11282,
        GIR_EraseRootFromParent_Done,
      // Label 9969: @617681
      GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(617756), // Rule ID 11283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11283,
        GIR_EraseRootFromParent_Done,
      // Label 9970: @617756
      GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(617831), // Rule ID 11286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11286,
        GIR_EraseRootFromParent_Done,
      // Label 9971: @617831
      GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(617906), // Rule ID 11287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11287,
        GIR_EraseRootFromParent_Done,
      // Label 9972: @617906
      GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(617981), // Rule ID 11290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11290,
        GIR_EraseRootFromParent_Done,
      // Label 9973: @617981
      GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(618056), // Rule ID 11291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11291,
        GIR_EraseRootFromParent_Done,
      // Label 9974: @618056
      GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(618131), // Rule ID 11294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11294,
        GIR_EraseRootFromParent_Done,
      // Label 9975: @618131
      GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(618206), // Rule ID 11295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11295,
        GIR_EraseRootFromParent_Done,
      // Label 9976: @618206
      GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(618281), // Rule ID 11298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11298,
        GIR_EraseRootFromParent_Done,
      // Label 9977: @618281
      GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(618356), // Rule ID 11299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11299,
        GIR_EraseRootFromParent_Done,
      // Label 9978: @618356
      GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(618431), // Rule ID 11302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11302,
        GIR_EraseRootFromParent_Done,
      // Label 9979: @618431
      GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(618506), // Rule ID 11303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11303,
        GIR_EraseRootFromParent_Done,
      // Label 9980: @618506
      GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(618581), // Rule ID 11306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11306,
        GIR_EraseRootFromParent_Done,
      // Label 9981: @618581
      GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(618656), // Rule ID 11307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11307,
        GIR_EraseRootFromParent_Done,
      // Label 9982: @618656
      GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(618731), // Rule ID 11310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11310,
        GIR_EraseRootFromParent_Done,
      // Label 9983: @618731
      GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(618806), // Rule ID 11311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11311,
        GIR_EraseRootFromParent_Done,
      // Label 9984: @618806
      GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(618881), // Rule ID 11314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11314,
        GIR_EraseRootFromParent_Done,
      // Label 9985: @618881
      GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(618956), // Rule ID 11315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11315,
        GIR_EraseRootFromParent_Done,
      // Label 9986: @618956
      GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(619031), // Rule ID 11318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11318,
        GIR_EraseRootFromParent_Done,
      // Label 9987: @619031
      GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(619106), // Rule ID 11319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11319,
        GIR_EraseRootFromParent_Done,
      // Label 9988: @619106
      GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(619181), // Rule ID 11322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11322,
        GIR_EraseRootFromParent_Done,
      // Label 9989: @619181
      GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(619256), // Rule ID 11323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11323,
        GIR_EraseRootFromParent_Done,
      // Label 9990: @619256
      GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(619331), // Rule ID 11326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11326,
        GIR_EraseRootFromParent_Done,
      // Label 9991: @619331
      GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(619406), // Rule ID 11327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11327,
        GIR_EraseRootFromParent_Done,
      // Label 9992: @619406
      GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(619481), // Rule ID 11330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11330,
        GIR_EraseRootFromParent_Done,
      // Label 9993: @619481
      GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(619556), // Rule ID 11331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11331,
        GIR_EraseRootFromParent_Done,
      // Label 9994: @619556
      GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(619631), // Rule ID 11334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11334,
        GIR_EraseRootFromParent_Done,
      // Label 9995: @619631
      GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(619706), // Rule ID 11335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11335,
        GIR_EraseRootFromParent_Done,
      // Label 9996: @619706
      GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(619781), // Rule ID 11338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11338,
        GIR_EraseRootFromParent_Done,
      // Label 9997: @619781
      GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(619856), // Rule ID 11339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11339,
        GIR_EraseRootFromParent_Done,
      // Label 9998: @619856
      GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(619931), // Rule ID 11342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11342,
        GIR_EraseRootFromParent_Done,
      // Label 9999: @619931
      GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(620006), // Rule ID 11343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11343,
        GIR_EraseRootFromParent_Done,
      // Label 10000: @620006
      GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(620081), // Rule ID 11346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11346,
        GIR_EraseRootFromParent_Done,
      // Label 10001: @620081
      GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(620156), // Rule ID 11347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11347,
        GIR_EraseRootFromParent_Done,
      // Label 10002: @620156
      GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(620231), // Rule ID 11350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11350,
        GIR_EraseRootFromParent_Done,
      // Label 10003: @620231
      GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(620306), // Rule ID 11351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11351,
        GIR_EraseRootFromParent_Done,
      // Label 10004: @620306
      GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(620381), // Rule ID 11354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11354,
        GIR_EraseRootFromParent_Done,
      // Label 10005: @620381
      GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(620456), // Rule ID 11355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11355,
        GIR_EraseRootFromParent_Done,
      // Label 10006: @620456
      GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(620531), // Rule ID 11358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11358,
        GIR_EraseRootFromParent_Done,
      // Label 10007: @620531
      GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(620606), // Rule ID 11359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11359,
        GIR_EraseRootFromParent_Done,
      // Label 10008: @620606
      GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(620681), // Rule ID 11362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11362,
        GIR_EraseRootFromParent_Done,
      // Label 10009: @620681
      GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(620756), // Rule ID 11363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11363,
        GIR_EraseRootFromParent_Done,
      // Label 10010: @620756
      GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(620831), // Rule ID 11366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11366,
        GIR_EraseRootFromParent_Done,
      // Label 10011: @620831
      GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(620906), // Rule ID 11367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11367,
        GIR_EraseRootFromParent_Done,
      // Label 10012: @620906
      GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(620981), // Rule ID 11370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11370,
        GIR_EraseRootFromParent_Done,
      // Label 10013: @620981
      GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(621056), // Rule ID 11371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11371,
        GIR_EraseRootFromParent_Done,
      // Label 10014: @621056
      GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(621131), // Rule ID 11374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11374,
        GIR_EraseRootFromParent_Done,
      // Label 10015: @621131
      GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(621206), // Rule ID 11375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11375,
        GIR_EraseRootFromParent_Done,
      // Label 10016: @621206
      GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(621281), // Rule ID 11378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11378,
        GIR_EraseRootFromParent_Done,
      // Label 10017: @621281
      GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(621356), // Rule ID 11379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11379,
        GIR_EraseRootFromParent_Done,
      // Label 10018: @621356
      GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(621431), // Rule ID 11382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11382,
        GIR_EraseRootFromParent_Done,
      // Label 10019: @621431
      GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(621506), // Rule ID 11383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11383,
        GIR_EraseRootFromParent_Done,
      // Label 10020: @621506
      GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(621581), // Rule ID 11386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11386,
        GIR_EraseRootFromParent_Done,
      // Label 10021: @621581
      GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(621656), // Rule ID 11387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11387,
        GIR_EraseRootFromParent_Done,
      // Label 10022: @621656
      GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(621731), // Rule ID 11390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11390,
        GIR_EraseRootFromParent_Done,
      // Label 10023: @621731
      GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(621806), // Rule ID 11391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11391,
        GIR_EraseRootFromParent_Done,
      // Label 10024: @621806
      GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(621881), // Rule ID 11394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11394,
        GIR_EraseRootFromParent_Done,
      // Label 10025: @621881
      GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(621956), // Rule ID 11395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11395,
        GIR_EraseRootFromParent_Done,
      // Label 10026: @621956
      GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(622031), // Rule ID 11398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11398,
        GIR_EraseRootFromParent_Done,
      // Label 10027: @622031
      GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(622106), // Rule ID 11399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11399,
        GIR_EraseRootFromParent_Done,
      // Label 10028: @622106
      GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(622181), // Rule ID 11402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11402,
        GIR_EraseRootFromParent_Done,
      // Label 10029: @622181
      GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(622256), // Rule ID 11403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11403,
        GIR_EraseRootFromParent_Done,
      // Label 10030: @622256
      GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(622331), // Rule ID 11406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11406,
        GIR_EraseRootFromParent_Done,
      // Label 10031: @622331
      GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(622406), // Rule ID 11407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11407,
        GIR_EraseRootFromParent_Done,
      // Label 10032: @622406
      GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(622481), // Rule ID 11410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11410,
        GIR_EraseRootFromParent_Done,
      // Label 10033: @622481
      GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(622556), // Rule ID 11411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11411,
        GIR_EraseRootFromParent_Done,
      // Label 10034: @622556
      GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(622631), // Rule ID 11414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11414,
        GIR_EraseRootFromParent_Done,
      // Label 10035: @622631
      GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(622706), // Rule ID 11415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11415,
        GIR_EraseRootFromParent_Done,
      // Label 10036: @622706
      GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(622781), // Rule ID 11418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11418,
        GIR_EraseRootFromParent_Done,
      // Label 10037: @622781
      GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(622856), // Rule ID 11419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11419,
        GIR_EraseRootFromParent_Done,
      // Label 10038: @622856
      GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(622931), // Rule ID 11422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11422,
        GIR_EraseRootFromParent_Done,
      // Label 10039: @622931
      GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(623006), // Rule ID 11423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11423,
        GIR_EraseRootFromParent_Done,
      // Label 10040: @623006
      GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(623081), // Rule ID 11426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11426,
        GIR_EraseRootFromParent_Done,
      // Label 10041: @623081
      GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(623156), // Rule ID 11427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11427,
        GIR_EraseRootFromParent_Done,
      // Label 10042: @623156
      GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(623231), // Rule ID 11430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11430,
        GIR_EraseRootFromParent_Done,
      // Label 10043: @623231
      GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(623306), // Rule ID 11431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11431,
        GIR_EraseRootFromParent_Done,
      // Label 10044: @623306
      GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(623381), // Rule ID 11434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11434,
        GIR_EraseRootFromParent_Done,
      // Label 10045: @623381
      GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(623456), // Rule ID 11435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11435,
        GIR_EraseRootFromParent_Done,
      // Label 10046: @623456
      GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(623531), // Rule ID 11438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11438,
        GIR_EraseRootFromParent_Done,
      // Label 10047: @623531
      GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(623606), // Rule ID 11439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11439,
        GIR_EraseRootFromParent_Done,
      // Label 10048: @623606
      GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(623681), // Rule ID 11442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11442,
        GIR_EraseRootFromParent_Done,
      // Label 10049: @623681
      GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(623756), // Rule ID 11443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11443,
        GIR_EraseRootFromParent_Done,
      // Label 10050: @623756
      GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(623831), // Rule ID 11446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11446,
        GIR_EraseRootFromParent_Done,
      // Label 10051: @623831
      GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(623906), // Rule ID 11447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11447,
        GIR_EraseRootFromParent_Done,
      // Label 10052: @623906
      GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(623981), // Rule ID 11450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11450,
        GIR_EraseRootFromParent_Done,
      // Label 10053: @623981
      GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(624056), // Rule ID 11451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11451,
        GIR_EraseRootFromParent_Done,
      // Label 10054: @624056
      GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(624131), // Rule ID 11454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11454,
        GIR_EraseRootFromParent_Done,
      // Label 10055: @624131
      GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(624206), // Rule ID 11455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11455,
        GIR_EraseRootFromParent_Done,
      // Label 10056: @624206
      GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(624281), // Rule ID 11458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11458,
        GIR_EraseRootFromParent_Done,
      // Label 10057: @624281
      GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(624356), // Rule ID 11459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11459,
        GIR_EraseRootFromParent_Done,
      // Label 10058: @624356
      GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(624431), // Rule ID 11462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11462,
        GIR_EraseRootFromParent_Done,
      // Label 10059: @624431
      GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(624506), // Rule ID 11463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11463,
        GIR_EraseRootFromParent_Done,
      // Label 10060: @624506
      GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(624581), // Rule ID 11466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11466,
        GIR_EraseRootFromParent_Done,
      // Label 10061: @624581
      GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(624656), // Rule ID 11467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11467,
        GIR_EraseRootFromParent_Done,
      // Label 10062: @624656
      GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(624731), // Rule ID 11470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11470,
        GIR_EraseRootFromParent_Done,
      // Label 10063: @624731
      GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(624806), // Rule ID 11471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11471,
        GIR_EraseRootFromParent_Done,
      // Label 10064: @624806
      GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(624881), // Rule ID 11474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11474,
        GIR_EraseRootFromParent_Done,
      // Label 10065: @624881
      GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(624956), // Rule ID 11475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11475,
        GIR_EraseRootFromParent_Done,
      // Label 10066: @624956
      GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(625031), // Rule ID 11478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11478,
        GIR_EraseRootFromParent_Done,
      // Label 10067: @625031
      GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(625106), // Rule ID 11479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11479,
        GIR_EraseRootFromParent_Done,
      // Label 10068: @625106
      GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(625181), // Rule ID 11482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11482,
        GIR_EraseRootFromParent_Done,
      // Label 10069: @625181
      GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(625256), // Rule ID 11483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11483,
        GIR_EraseRootFromParent_Done,
      // Label 10070: @625256
      GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(625331), // Rule ID 11486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11486,
        GIR_EraseRootFromParent_Done,
      // Label 10071: @625331
      GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(625406), // Rule ID 11487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11487,
        GIR_EraseRootFromParent_Done,
      // Label 10072: @625406
      GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(625481), // Rule ID 11490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11490,
        GIR_EraseRootFromParent_Done,
      // Label 10073: @625481
      GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(625556), // Rule ID 11491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11491,
        GIR_EraseRootFromParent_Done,
      // Label 10074: @625556
      GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(625631), // Rule ID 11494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11494,
        GIR_EraseRootFromParent_Done,
      // Label 10075: @625631
      GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(625706), // Rule ID 11495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11495,
        GIR_EraseRootFromParent_Done,
      // Label 10076: @625706
      GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(625781), // Rule ID 11498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11498,
        GIR_EraseRootFromParent_Done,
      // Label 10077: @625781
      GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(625856), // Rule ID 11499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11499,
        GIR_EraseRootFromParent_Done,
      // Label 10078: @625856
      GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(625931), // Rule ID 11502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11502,
        GIR_EraseRootFromParent_Done,
      // Label 10079: @625931
      GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(626006), // Rule ID 11503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11503,
        GIR_EraseRootFromParent_Done,
      // Label 10080: @626006
      GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(626081), // Rule ID 11506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11506,
        GIR_EraseRootFromParent_Done,
      // Label 10081: @626081
      GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(626156), // Rule ID 11507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11507,
        GIR_EraseRootFromParent_Done,
      // Label 10082: @626156
      GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(626231), // Rule ID 11510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11510,
        GIR_EraseRootFromParent_Done,
      // Label 10083: @626231
      GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(626306), // Rule ID 11511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11511,
        GIR_EraseRootFromParent_Done,
      // Label 10084: @626306
      GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(626381), // Rule ID 11514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11514,
        GIR_EraseRootFromParent_Done,
      // Label 10085: @626381
      GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(626456), // Rule ID 11515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11515,
        GIR_EraseRootFromParent_Done,
      // Label 10086: @626456
      GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(626531), // Rule ID 11518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11518,
        GIR_EraseRootFromParent_Done,
      // Label 10087: @626531
      GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(626606), // Rule ID 11519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11519,
        GIR_EraseRootFromParent_Done,
      // Label 10088: @626606
      GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(626681), // Rule ID 11522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11522,
        GIR_EraseRootFromParent_Done,
      // Label 10089: @626681
      GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(626756), // Rule ID 11523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11523,
        GIR_EraseRootFromParent_Done,
      // Label 10090: @626756
      GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(626831), // Rule ID 11526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11526,
        GIR_EraseRootFromParent_Done,
      // Label 10091: @626831
      GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(626906), // Rule ID 11527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11527,
        GIR_EraseRootFromParent_Done,
      // Label 10092: @626906
      GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(626981), // Rule ID 11530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11530,
        GIR_EraseRootFromParent_Done,
      // Label 10093: @626981
      GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(627056), // Rule ID 11531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11531,
        GIR_EraseRootFromParent_Done,
      // Label 10094: @627056
      GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(627131), // Rule ID 11534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11534,
        GIR_EraseRootFromParent_Done,
      // Label 10095: @627131
      GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(627206), // Rule ID 11535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11535,
        GIR_EraseRootFromParent_Done,
      // Label 10096: @627206
      GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(627281), // Rule ID 11538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11538,
        GIR_EraseRootFromParent_Done,
      // Label 10097: @627281
      GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(627356), // Rule ID 11539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11539,
        GIR_EraseRootFromParent_Done,
      // Label 10098: @627356
      GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(627431), // Rule ID 11542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11542,
        GIR_EraseRootFromParent_Done,
      // Label 10099: @627431
      GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(627506), // Rule ID 11543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11543,
        GIR_EraseRootFromParent_Done,
      // Label 10100: @627506
      GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(627581), // Rule ID 11546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11546,
        GIR_EraseRootFromParent_Done,
      // Label 10101: @627581
      GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(627656), // Rule ID 11547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11547,
        GIR_EraseRootFromParent_Done,
      // Label 10102: @627656
      GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(627731), // Rule ID 11550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11550,
        GIR_EraseRootFromParent_Done,
      // Label 10103: @627731
      GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(627806), // Rule ID 11551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11551,
        GIR_EraseRootFromParent_Done,
      // Label 10104: @627806
      GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(627881), // Rule ID 11554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11554,
        GIR_EraseRootFromParent_Done,
      // Label 10105: @627881
      GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(627956), // Rule ID 11555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11555,
        GIR_EraseRootFromParent_Done,
      // Label 10106: @627956
      GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(628031), // Rule ID 11558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11558,
        GIR_EraseRootFromParent_Done,
      // Label 10107: @628031
      GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(628106), // Rule ID 11559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11559,
        GIR_EraseRootFromParent_Done,
      // Label 10108: @628106
      GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(628181), // Rule ID 11562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11562,
        GIR_EraseRootFromParent_Done,
      // Label 10109: @628181
      GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(628256), // Rule ID 11563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11563,
        GIR_EraseRootFromParent_Done,
      // Label 10110: @628256
      GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(628331), // Rule ID 11566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11566,
        GIR_EraseRootFromParent_Done,
      // Label 10111: @628331
      GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(628406), // Rule ID 11567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11567,
        GIR_EraseRootFromParent_Done,
      // Label 10112: @628406
      GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(628481), // Rule ID 11570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11570,
        GIR_EraseRootFromParent_Done,
      // Label 10113: @628481
      GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(628556), // Rule ID 11571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11571,
        GIR_EraseRootFromParent_Done,
      // Label 10114: @628556
      GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(628631), // Rule ID 11574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11574,
        GIR_EraseRootFromParent_Done,
      // Label 10115: @628631
      GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(628706), // Rule ID 11575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11575,
        GIR_EraseRootFromParent_Done,
      // Label 10116: @628706
      GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(628781), // Rule ID 11578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11578,
        GIR_EraseRootFromParent_Done,
      // Label 10117: @628781
      GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(628856), // Rule ID 11579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11579,
        GIR_EraseRootFromParent_Done,
      // Label 10118: @628856
      GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(628931), // Rule ID 11582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11582,
        GIR_EraseRootFromParent_Done,
      // Label 10119: @628931
      GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(629006), // Rule ID 11583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11583,
        GIR_EraseRootFromParent_Done,
      // Label 10120: @629006
      GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(629081), // Rule ID 11586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11586,
        GIR_EraseRootFromParent_Done,
      // Label 10121: @629081
      GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(629156), // Rule ID 11587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11587,
        GIR_EraseRootFromParent_Done,
      // Label 10122: @629156
      GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(629231), // Rule ID 11590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11590,
        GIR_EraseRootFromParent_Done,
      // Label 10123: @629231
      GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(629306), // Rule ID 11591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11591,
        GIR_EraseRootFromParent_Done,
      // Label 10124: @629306
      GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(629381), // Rule ID 11594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11594,
        GIR_EraseRootFromParent_Done,
      // Label 10125: @629381
      GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(629456), // Rule ID 11595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11595,
        GIR_EraseRootFromParent_Done,
      // Label 10126: @629456
      GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(629531), // Rule ID 11598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11598,
        GIR_EraseRootFromParent_Done,
      // Label 10127: @629531
      GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(629606), // Rule ID 11599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11599,
        GIR_EraseRootFromParent_Done,
      // Label 10128: @629606
      GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(629681), // Rule ID 11602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11602,
        GIR_EraseRootFromParent_Done,
      // Label 10129: @629681
      GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(629756), // Rule ID 11603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11603,
        GIR_EraseRootFromParent_Done,
      // Label 10130: @629756
      GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(629831), // Rule ID 11606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11606,
        GIR_EraseRootFromParent_Done,
      // Label 10131: @629831
      GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(629906), // Rule ID 11607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11607,
        GIR_EraseRootFromParent_Done,
      // Label 10132: @629906
      GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(629981), // Rule ID 11610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11610,
        GIR_EraseRootFromParent_Done,
      // Label 10133: @629981
      GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(630056), // Rule ID 11611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11611,
        GIR_EraseRootFromParent_Done,
      // Label 10134: @630056
      GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(630131), // Rule ID 11614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11614,
        GIR_EraseRootFromParent_Done,
      // Label 10135: @630131
      GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(630206), // Rule ID 11615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11615,
        GIR_EraseRootFromParent_Done,
      // Label 10136: @630206
      GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(630281), // Rule ID 11618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11618,
        GIR_EraseRootFromParent_Done,
      // Label 10137: @630281
      GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(630356), // Rule ID 11619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11619,
        GIR_EraseRootFromParent_Done,
      // Label 10138: @630356
      GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(630431), // Rule ID 11622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11622,
        GIR_EraseRootFromParent_Done,
      // Label 10139: @630431
      GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(630506), // Rule ID 11623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11623,
        GIR_EraseRootFromParent_Done,
      // Label 10140: @630506
      GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(630581), // Rule ID 11626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11626,
        GIR_EraseRootFromParent_Done,
      // Label 10141: @630581
      GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(630656), // Rule ID 11627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10790:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11627,
        GIR_EraseRootFromParent_Done,
      // Label 10142: @630656
      GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(630731), // Rule ID 11630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11630,
        GIR_EraseRootFromParent_Done,
      // Label 10143: @630731
      GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(630806), // Rule ID 11631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10790:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11631,
        GIR_EraseRootFromParent_Done,
      // Label 10144: @630806
      GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(630881), // Rule ID 11634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11634,
        GIR_EraseRootFromParent_Done,
      // Label 10145: @630881
      GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(630956), // Rule ID 11635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10790:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11635,
        GIR_EraseRootFromParent_Done,
      // Label 10146: @630956
      GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(631031), // Rule ID 11638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11638,
        GIR_EraseRootFromParent_Done,
      // Label 10147: @631031
      GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(631106), // Rule ID 11639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10790:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11639,
        GIR_EraseRootFromParent_Done,
      // Label 10148: @631106
      GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(631181), // Rule ID 11642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11642,
        GIR_EraseRootFromParent_Done,
      // Label 10149: @631181
      GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(631256), // Rule ID 11643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11643,
        GIR_EraseRootFromParent_Done,
      // Label 10150: @631256
      GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(631331), // Rule ID 11646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11646,
        GIR_EraseRootFromParent_Done,
      // Label 10151: @631331
      GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(631406), // Rule ID 11647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11647,
        GIR_EraseRootFromParent_Done,
      // Label 10152: @631406
      GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(631481), // Rule ID 11650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11650,
        GIR_EraseRootFromParent_Done,
      // Label 10153: @631481
      GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(631556), // Rule ID 11651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11651,
        GIR_EraseRootFromParent_Done,
      // Label 10154: @631556
      GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(631631), // Rule ID 11654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11654,
        GIR_EraseRootFromParent_Done,
      // Label 10155: @631631
      GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(631706), // Rule ID 11655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11655,
        GIR_EraseRootFromParent_Done,
      // Label 10156: @631706
      GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(631781), // Rule ID 11658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11658,
        GIR_EraseRootFromParent_Done,
      // Label 10157: @631781
      GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(631856), // Rule ID 11659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11659,
        GIR_EraseRootFromParent_Done,
      // Label 10158: @631856
      GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(631931), // Rule ID 11662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11662,
        GIR_EraseRootFromParent_Done,
      // Label 10159: @631931
      GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(632006), // Rule ID 11663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11663,
        GIR_EraseRootFromParent_Done,
      // Label 10160: @632006
      GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(632081), // Rule ID 11666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11666,
        GIR_EraseRootFromParent_Done,
      // Label 10161: @632081
      GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(632156), // Rule ID 11667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11667,
        GIR_EraseRootFromParent_Done,
      // Label 10162: @632156
      GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(632231), // Rule ID 11670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11670,
        GIR_EraseRootFromParent_Done,
      // Label 10163: @632231
      GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(632306), // Rule ID 11671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11671,
        GIR_EraseRootFromParent_Done,
      // Label 10164: @632306
      GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(632381), // Rule ID 11674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11674,
        GIR_EraseRootFromParent_Done,
      // Label 10165: @632381
      GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(632456), // Rule ID 11675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11675,
        GIR_EraseRootFromParent_Done,
      // Label 10166: @632456
      GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(632531), // Rule ID 11678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11678,
        GIR_EraseRootFromParent_Done,
      // Label 10167: @632531
      GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(632606), // Rule ID 11679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10790:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11679,
        GIR_EraseRootFromParent_Done,
      // Label 10168: @632606
      GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(632681), // Rule ID 11682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11682,
        GIR_EraseRootFromParent_Done,
      // Label 10169: @632681
      GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(632756), // Rule ID 11683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10790:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11683,
        GIR_EraseRootFromParent_Done,
      // Label 10170: @632756
      GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(632831), // Rule ID 11686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11686,
        GIR_EraseRootFromParent_Done,
      // Label 10171: @632831
      GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(632906), // Rule ID 11687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10790:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11687,
        GIR_EraseRootFromParent_Done,
      // Label 10172: @632906
      GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(632981), // Rule ID 11690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11690,
        GIR_EraseRootFromParent_Done,
      // Label 10173: @632981
      GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(633056), // Rule ID 11691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11691,
        GIR_EraseRootFromParent_Done,
      // Label 10174: @633056
      GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(633131), // Rule ID 11694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11694,
        GIR_EraseRootFromParent_Done,
      // Label 10175: @633131
      GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(633206), // Rule ID 11695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11695,
        GIR_EraseRootFromParent_Done,
      // Label 10176: @633206
      GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(633281), // Rule ID 11698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11698,
        GIR_EraseRootFromParent_Done,
      // Label 10177: @633281
      GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(633356), // Rule ID 11699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11699,
        GIR_EraseRootFromParent_Done,
      // Label 10178: @633356
      GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(633431), // Rule ID 11702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11702,
        GIR_EraseRootFromParent_Done,
      // Label 10179: @633431
      GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(633506), // Rule ID 11703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11703,
        GIR_EraseRootFromParent_Done,
      // Label 10180: @633506
      GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(633581), // Rule ID 11706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11706,
        GIR_EraseRootFromParent_Done,
      // Label 10181: @633581
      GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(633656), // Rule ID 11707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11707,
        GIR_EraseRootFromParent_Done,
      // Label 10182: @633656
      GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(633731), // Rule ID 11710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11710,
        GIR_EraseRootFromParent_Done,
      // Label 10183: @633731
      GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(633806), // Rule ID 11711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11711,
        GIR_EraseRootFromParent_Done,
      // Label 10184: @633806
      GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(633881), // Rule ID 11714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11714,
        GIR_EraseRootFromParent_Done,
      // Label 10185: @633881
      GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(633956), // Rule ID 11715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11715,
        GIR_EraseRootFromParent_Done,
      // Label 10186: @633956
      GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(634031), // Rule ID 11718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11718,
        GIR_EraseRootFromParent_Done,
      // Label 10187: @634031
      GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(634106), // Rule ID 11719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11719,
        GIR_EraseRootFromParent_Done,
      // Label 10188: @634106
      GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(634181), // Rule ID 11722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11722,
        GIR_EraseRootFromParent_Done,
      // Label 10189: @634181
      GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(634256), // Rule ID 11723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11723,
        GIR_EraseRootFromParent_Done,
      // Label 10190: @634256
      GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(634331), // Rule ID 11726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11726,
        GIR_EraseRootFromParent_Done,
      // Label 10191: @634331
      GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(634406), // Rule ID 11727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11727,
        GIR_EraseRootFromParent_Done,
      // Label 10192: @634406
      GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(634481), // Rule ID 11730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11730,
        GIR_EraseRootFromParent_Done,
      // Label 10193: @634481
      GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(634556), // Rule ID 11731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11731,
        GIR_EraseRootFromParent_Done,
      // Label 10194: @634556
      GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(634631), // Rule ID 11734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11734,
        GIR_EraseRootFromParent_Done,
      // Label 10195: @634631
      GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(634706), // Rule ID 11735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11735,
        GIR_EraseRootFromParent_Done,
      // Label 10196: @634706
      GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(634781), // Rule ID 11738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11738,
        GIR_EraseRootFromParent_Done,
      // Label 10197: @634781
      GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(634856), // Rule ID 11739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11739,
        GIR_EraseRootFromParent_Done,
      // Label 10198: @634856
      GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(634931), // Rule ID 11742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11742,
        GIR_EraseRootFromParent_Done,
      // Label 10199: @634931
      GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(635006), // Rule ID 11743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11743,
        GIR_EraseRootFromParent_Done,
      // Label 10200: @635006
      GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(635081), // Rule ID 11746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11746,
        GIR_EraseRootFromParent_Done,
      // Label 10201: @635081
      GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(635156), // Rule ID 11747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11747,
        GIR_EraseRootFromParent_Done,
      // Label 10202: @635156
      GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(635231), // Rule ID 11750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11750,
        GIR_EraseRootFromParent_Done,
      // Label 10203: @635231
      GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(635306), // Rule ID 11751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11751,
        GIR_EraseRootFromParent_Done,
      // Label 10204: @635306
      GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(635381), // Rule ID 11754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11754,
        GIR_EraseRootFromParent_Done,
      // Label 10205: @635381
      GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(635456), // Rule ID 11755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11755,
        GIR_EraseRootFromParent_Done,
      // Label 10206: @635456
      GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(635531), // Rule ID 11758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11758,
        GIR_EraseRootFromParent_Done,
      // Label 10207: @635531
      GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(635606), // Rule ID 11759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11759,
        GIR_EraseRootFromParent_Done,
      // Label 10208: @635606
      GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(635681), // Rule ID 11762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11762,
        GIR_EraseRootFromParent_Done,
      // Label 10209: @635681
      GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(635756), // Rule ID 11763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11763,
        GIR_EraseRootFromParent_Done,
      // Label 10210: @635756
      GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(635831), // Rule ID 11766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11766,
        GIR_EraseRootFromParent_Done,
      // Label 10211: @635831
      GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(635906), // Rule ID 11767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11767,
        GIR_EraseRootFromParent_Done,
      // Label 10212: @635906
      GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(635981), // Rule ID 11770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11770,
        GIR_EraseRootFromParent_Done,
      // Label 10213: @635981
      GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(636056), // Rule ID 11771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11771,
        GIR_EraseRootFromParent_Done,
      // Label 10214: @636056
      GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(636131), // Rule ID 11774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11774,
        GIR_EraseRootFromParent_Done,
      // Label 10215: @636131
      GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(636206), // Rule ID 11775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11775,
        GIR_EraseRootFromParent_Done,
      // Label 10216: @636206
      GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(636281), // Rule ID 11778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11778,
        GIR_EraseRootFromParent_Done,
      // Label 10217: @636281
      GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(636356), // Rule ID 11779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11779,
        GIR_EraseRootFromParent_Done,
      // Label 10218: @636356
      GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(636431), // Rule ID 11782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11782,
        GIR_EraseRootFromParent_Done,
      // Label 10219: @636431
      GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(636506), // Rule ID 11783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11783,
        GIR_EraseRootFromParent_Done,
      // Label 10220: @636506
      GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(636581), // Rule ID 11786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11786,
        GIR_EraseRootFromParent_Done,
      // Label 10221: @636581
      GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(636656), // Rule ID 11787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11787,
        GIR_EraseRootFromParent_Done,
      // Label 10222: @636656
      GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(636731), // Rule ID 11790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11790,
        GIR_EraseRootFromParent_Done,
      // Label 10223: @636731
      GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(636806), // Rule ID 11791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11791,
        GIR_EraseRootFromParent_Done,
      // Label 10224: @636806
      GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(636881), // Rule ID 11794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11794,
        GIR_EraseRootFromParent_Done,
      // Label 10225: @636881
      GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(636956), // Rule ID 11795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11795,
        GIR_EraseRootFromParent_Done,
      // Label 10226: @636956
      GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(637031), // Rule ID 11798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11798,
        GIR_EraseRootFromParent_Done,
      // Label 10227: @637031
      GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(637106), // Rule ID 11799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11799,
        GIR_EraseRootFromParent_Done,
      // Label 10228: @637106
      GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(637181), // Rule ID 11802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11802,
        GIR_EraseRootFromParent_Done,
      // Label 10229: @637181
      GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(637256), // Rule ID 11803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10788:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11803,
        GIR_EraseRootFromParent_Done,
      // Label 10230: @637256
      GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(637331), // Rule ID 11806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11806,
        GIR_EraseRootFromParent_Done,
      // Label 10231: @637331
      GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(637406), // Rule ID 11807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10788:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11807,
        GIR_EraseRootFromParent_Done,
      // Label 10232: @637406
      GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(637481), // Rule ID 11810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11810,
        GIR_EraseRootFromParent_Done,
      // Label 10233: @637481
      GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(637556), // Rule ID 11811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10788:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11811,
        GIR_EraseRootFromParent_Done,
      // Label 10234: @637556
      GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(637631), // Rule ID 11814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11814,
        GIR_EraseRootFromParent_Done,
      // Label 10235: @637631
      GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(637706), // Rule ID 11815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10788:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11815,
        GIR_EraseRootFromParent_Done,
      // Label 10236: @637706
      GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(637781), // Rule ID 11818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11818,
        GIR_EraseRootFromParent_Done,
      // Label 10237: @637781
      GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(637856), // Rule ID 11819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11819,
        GIR_EraseRootFromParent_Done,
      // Label 10238: @637856
      GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(637931), // Rule ID 11822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11822,
        GIR_EraseRootFromParent_Done,
      // Label 10239: @637931
      GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(638006), // Rule ID 11823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11823,
        GIR_EraseRootFromParent_Done,
      // Label 10240: @638006
      GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(638081), // Rule ID 11826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11826,
        GIR_EraseRootFromParent_Done,
      // Label 10241: @638081
      GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(638156), // Rule ID 11827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11827,
        GIR_EraseRootFromParent_Done,
      // Label 10242: @638156
      GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(638231), // Rule ID 11830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11830,
        GIR_EraseRootFromParent_Done,
      // Label 10243: @638231
      GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(638306), // Rule ID 11831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11831,
        GIR_EraseRootFromParent_Done,
      // Label 10244: @638306
      GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(638381), // Rule ID 11834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11834,
        GIR_EraseRootFromParent_Done,
      // Label 10245: @638381
      GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(638456), // Rule ID 11835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11835,
        GIR_EraseRootFromParent_Done,
      // Label 10246: @638456
      GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(638531), // Rule ID 11838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11838,
        GIR_EraseRootFromParent_Done,
      // Label 10247: @638531
      GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(638606), // Rule ID 11839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11839,
        GIR_EraseRootFromParent_Done,
      // Label 10248: @638606
      GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(638681), // Rule ID 11842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11842,
        GIR_EraseRootFromParent_Done,
      // Label 10249: @638681
      GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(638756), // Rule ID 11843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11843,
        GIR_EraseRootFromParent_Done,
      // Label 10250: @638756
      GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(638831), // Rule ID 11846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11846,
        GIR_EraseRootFromParent_Done,
      // Label 10251: @638831
      GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(638906), // Rule ID 11847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11847,
        GIR_EraseRootFromParent_Done,
      // Label 10252: @638906
      GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(638981), // Rule ID 11850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11850,
        GIR_EraseRootFromParent_Done,
      // Label 10253: @638981
      GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(639056), // Rule ID 11851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11851,
        GIR_EraseRootFromParent_Done,
      // Label 10254: @639056
      GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(639131), // Rule ID 11854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11854,
        GIR_EraseRootFromParent_Done,
      // Label 10255: @639131
      GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(639206), // Rule ID 11855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10788:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11855,
        GIR_EraseRootFromParent_Done,
      // Label 10256: @639206
      GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(639281), // Rule ID 11858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11858,
        GIR_EraseRootFromParent_Done,
      // Label 10257: @639281
      GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(639356), // Rule ID 11859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10788:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11859,
        GIR_EraseRootFromParent_Done,
      // Label 10258: @639356
      GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(639431), // Rule ID 11862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11862,
        GIR_EraseRootFromParent_Done,
      // Label 10259: @639431
      GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(639506), // Rule ID 11863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10788:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11863,
        GIR_EraseRootFromParent_Done,
      // Label 10260: @639506
      GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(639581), // Rule ID 11866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11866,
        GIR_EraseRootFromParent_Done,
      // Label 10261: @639581
      GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(639656), // Rule ID 11867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11867,
        GIR_EraseRootFromParent_Done,
      // Label 10262: @639656
      GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(639731), // Rule ID 11870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11870,
        GIR_EraseRootFromParent_Done,
      // Label 10263: @639731
      GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(639806), // Rule ID 11871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11871,
        GIR_EraseRootFromParent_Done,
      // Label 10264: @639806
      GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(639881), // Rule ID 11874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11874,
        GIR_EraseRootFromParent_Done,
      // Label 10265: @639881
      GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(639956), // Rule ID 11875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11875,
        GIR_EraseRootFromParent_Done,
      // Label 10266: @639956
      GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(640031), // Rule ID 11878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11878,
        GIR_EraseRootFromParent_Done,
      // Label 10267: @640031
      GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(640106), // Rule ID 11879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11879,
        GIR_EraseRootFromParent_Done,
      // Label 10268: @640106
      GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(640181), // Rule ID 11882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11882,
        GIR_EraseRootFromParent_Done,
      // Label 10269: @640181
      GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(640256), // Rule ID 11883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11883,
        GIR_EraseRootFromParent_Done,
      // Label 10270: @640256
      GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(640331), // Rule ID 11886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11886,
        GIR_EraseRootFromParent_Done,
      // Label 10271: @640331
      GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(640406), // Rule ID 11887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11887,
        GIR_EraseRootFromParent_Done,
      // Label 10272: @640406
      GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(640481), // Rule ID 11890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11890,
        GIR_EraseRootFromParent_Done,
      // Label 10273: @640481
      GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(640556), // Rule ID 11891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11891,
        GIR_EraseRootFromParent_Done,
      // Label 10274: @640556
      GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(640631), // Rule ID 11894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11894,
        GIR_EraseRootFromParent_Done,
      // Label 10275: @640631
      GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(640706), // Rule ID 11895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11895,
        GIR_EraseRootFromParent_Done,
      // Label 10276: @640706
      GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(640781), // Rule ID 11898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11898,
        GIR_EraseRootFromParent_Done,
      // Label 10277: @640781
      GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(640856), // Rule ID 11899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11899,
        GIR_EraseRootFromParent_Done,
      // Label 10278: @640856
      GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(640931), // Rule ID 11902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11902,
        GIR_EraseRootFromParent_Done,
      // Label 10279: @640931
      GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(641006), // Rule ID 11903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11903,
        GIR_EraseRootFromParent_Done,
      // Label 10280: @641006
      GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(641081), // Rule ID 11906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11906,
        GIR_EraseRootFromParent_Done,
      // Label 10281: @641081
      GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(641156), // Rule ID 11907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11907,
        GIR_EraseRootFromParent_Done,
      // Label 10282: @641156
      GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(641231), // Rule ID 11910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11910,
        GIR_EraseRootFromParent_Done,
      // Label 10283: @641231
      GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(641306), // Rule ID 11911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11911,
        GIR_EraseRootFromParent_Done,
      // Label 10284: @641306
      GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(641381), // Rule ID 11914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11914,
        GIR_EraseRootFromParent_Done,
      // Label 10285: @641381
      GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(641456), // Rule ID 11915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11915,
        GIR_EraseRootFromParent_Done,
      // Label 10286: @641456
      GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(641531), // Rule ID 11918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11918,
        GIR_EraseRootFromParent_Done,
      // Label 10287: @641531
      GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(641606), // Rule ID 11919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11919,
        GIR_EraseRootFromParent_Done,
      // Label 10288: @641606
      GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(641681), // Rule ID 11922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11922,
        GIR_EraseRootFromParent_Done,
      // Label 10289: @641681
      GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(641756), // Rule ID 11923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11923,
        GIR_EraseRootFromParent_Done,
      // Label 10290: @641756
      GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(641831), // Rule ID 11926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11926,
        GIR_EraseRootFromParent_Done,
      // Label 10291: @641831
      GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(641906), // Rule ID 11927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11927,
        GIR_EraseRootFromParent_Done,
      // Label 10292: @641906
      GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(641981), // Rule ID 11930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11930,
        GIR_EraseRootFromParent_Done,
      // Label 10293: @641981
      GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(642056), // Rule ID 11931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11931,
        GIR_EraseRootFromParent_Done,
      // Label 10294: @642056
      GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(642131), // Rule ID 11934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11934,
        GIR_EraseRootFromParent_Done,
      // Label 10295: @642131
      GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(642206), // Rule ID 11935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11935,
        GIR_EraseRootFromParent_Done,
      // Label 10296: @642206
      GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(642281), // Rule ID 11938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11938,
        GIR_EraseRootFromParent_Done,
      // Label 10297: @642281
      GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(642356), // Rule ID 11939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11939,
        GIR_EraseRootFromParent_Done,
      // Label 10298: @642356
      GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(642431), // Rule ID 11942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11942,
        GIR_EraseRootFromParent_Done,
      // Label 10299: @642431
      GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(642506), // Rule ID 11943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11943,
        GIR_EraseRootFromParent_Done,
      // Label 10300: @642506
      GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(642581), // Rule ID 11946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11946,
        GIR_EraseRootFromParent_Done,
      // Label 10301: @642581
      GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(642656), // Rule ID 11947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11947,
        GIR_EraseRootFromParent_Done,
      // Label 10302: @642656
      GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(642731), // Rule ID 11950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11950,
        GIR_EraseRootFromParent_Done,
      // Label 10303: @642731
      GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(642806), // Rule ID 11951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11951,
        GIR_EraseRootFromParent_Done,
      // Label 10304: @642806
      GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(642881), // Rule ID 11954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11954,
        GIR_EraseRootFromParent_Done,
      // Label 10305: @642881
      GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(642956), // Rule ID 11955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11955,
        GIR_EraseRootFromParent_Done,
      // Label 10306: @642956
      GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(643031), // Rule ID 11958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11958,
        GIR_EraseRootFromParent_Done,
      // Label 10307: @643031
      GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(643106), // Rule ID 11959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11959,
        GIR_EraseRootFromParent_Done,
      // Label 10308: @643106
      GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(643181), // Rule ID 11962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11962,
        GIR_EraseRootFromParent_Done,
      // Label 10309: @643181
      GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(643256), // Rule ID 11963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11963,
        GIR_EraseRootFromParent_Done,
      // Label 10310: @643256
      GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(643331), // Rule ID 11966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11966,
        GIR_EraseRootFromParent_Done,
      // Label 10311: @643331
      GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(643406), // Rule ID 11967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11967,
        GIR_EraseRootFromParent_Done,
      // Label 10312: @643406
      GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(643481), // Rule ID 11970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11970,
        GIR_EraseRootFromParent_Done,
      // Label 10313: @643481
      GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(643556), // Rule ID 11971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11971,
        GIR_EraseRootFromParent_Done,
      // Label 10314: @643556
      GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(643631), // Rule ID 11974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11974,
        GIR_EraseRootFromParent_Done,
      // Label 10315: @643631
      GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(643706), // Rule ID 11975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11975,
        GIR_EraseRootFromParent_Done,
      // Label 10316: @643706
      GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(643781), // Rule ID 11978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11978,
        GIR_EraseRootFromParent_Done,
      // Label 10317: @643781
      GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(643856), // Rule ID 11979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11979,
        GIR_EraseRootFromParent_Done,
      // Label 10318: @643856
      GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(643931), // Rule ID 11982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11982,
        GIR_EraseRootFromParent_Done,
      // Label 10319: @643931
      GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(644006), // Rule ID 11983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11983,
        GIR_EraseRootFromParent_Done,
      // Label 10320: @644006
      GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(644081), // Rule ID 11986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11986,
        GIR_EraseRootFromParent_Done,
      // Label 10321: @644081
      GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(644156), // Rule ID 11987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11987,
        GIR_EraseRootFromParent_Done,
      // Label 10322: @644156
      GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(644231), // Rule ID 11990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11990,
        GIR_EraseRootFromParent_Done,
      // Label 10323: @644231
      GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(644306), // Rule ID 11991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11991,
        GIR_EraseRootFromParent_Done,
      // Label 10324: @644306
      GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(644381), // Rule ID 11994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11994,
        GIR_EraseRootFromParent_Done,
      // Label 10325: @644381
      GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(644456), // Rule ID 11995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11995,
        GIR_EraseRootFromParent_Done,
      // Label 10326: @644456
      GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(644531), // Rule ID 11998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11998,
        GIR_EraseRootFromParent_Done,
      // Label 10327: @644531
      GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(644606), // Rule ID 11999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11999,
        GIR_EraseRootFromParent_Done,
      // Label 10328: @644606
      GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(644681), // Rule ID 12002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12002,
        GIR_EraseRootFromParent_Done,
      // Label 10329: @644681
      GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(644756), // Rule ID 12003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12003,
        GIR_EraseRootFromParent_Done,
      // Label 10330: @644756
      GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(644831), // Rule ID 12006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12006,
        GIR_EraseRootFromParent_Done,
      // Label 10331: @644831
      GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(644906), // Rule ID 12007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12007,
        GIR_EraseRootFromParent_Done,
      // Label 10332: @644906
      GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(644981), // Rule ID 12010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12010,
        GIR_EraseRootFromParent_Done,
      // Label 10333: @644981
      GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(645056), // Rule ID 12011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12011,
        GIR_EraseRootFromParent_Done,
      // Label 10334: @645056
      GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(645131), // Rule ID 12014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12014,
        GIR_EraseRootFromParent_Done,
      // Label 10335: @645131
      GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(645206), // Rule ID 12015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12015,
        GIR_EraseRootFromParent_Done,
      // Label 10336: @645206
      GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(645281), // Rule ID 12018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12018,
        GIR_EraseRootFromParent_Done,
      // Label 10337: @645281
      GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(645356), // Rule ID 12019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12019,
        GIR_EraseRootFromParent_Done,
      // Label 10338: @645356
      GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(645431), // Rule ID 12022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12022,
        GIR_EraseRootFromParent_Done,
      // Label 10339: @645431
      GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(645506), // Rule ID 12023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12023,
        GIR_EraseRootFromParent_Done,
      // Label 10340: @645506
      GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(645581), // Rule ID 12026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12026,
        GIR_EraseRootFromParent_Done,
      // Label 10341: @645581
      GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(645656), // Rule ID 12027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12027,
        GIR_EraseRootFromParent_Done,
      // Label 10342: @645656
      GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(645731), // Rule ID 12030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12030,
        GIR_EraseRootFromParent_Done,
      // Label 10343: @645731
      GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(645806), // Rule ID 12031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12031,
        GIR_EraseRootFromParent_Done,
      // Label 10344: @645806
      GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(645881), // Rule ID 12034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12034,
        GIR_EraseRootFromParent_Done,
      // Label 10345: @645881
      GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(645956), // Rule ID 12035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12035,
        GIR_EraseRootFromParent_Done,
      // Label 10346: @645956
      GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(646031), // Rule ID 12038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12038,
        GIR_EraseRootFromParent_Done,
      // Label 10347: @646031
      GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(646106), // Rule ID 12039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12039,
        GIR_EraseRootFromParent_Done,
      // Label 10348: @646106
      GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(646181), // Rule ID 12042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12042,
        GIR_EraseRootFromParent_Done,
      // Label 10349: @646181
      GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(646256), // Rule ID 12043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12043,
        GIR_EraseRootFromParent_Done,
      // Label 10350: @646256
      GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(646331), // Rule ID 12046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12046,
        GIR_EraseRootFromParent_Done,
      // Label 10351: @646331
      GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(646406), // Rule ID 12047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12047,
        GIR_EraseRootFromParent_Done,
      // Label 10352: @646406
      GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(646481), // Rule ID 12050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12050,
        GIR_EraseRootFromParent_Done,
      // Label 10353: @646481
      GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(646556), // Rule ID 12051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12051,
        GIR_EraseRootFromParent_Done,
      // Label 10354: @646556
      GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(646631), // Rule ID 12054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12054,
        GIR_EraseRootFromParent_Done,
      // Label 10355: @646631
      GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(646706), // Rule ID 12055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12055,
        GIR_EraseRootFromParent_Done,
      // Label 10356: @646706
      GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(646781), // Rule ID 12058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12058,
        GIR_EraseRootFromParent_Done,
      // Label 10357: @646781
      GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(646856), // Rule ID 12059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12059,
        GIR_EraseRootFromParent_Done,
      // Label 10358: @646856
      GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(646931), // Rule ID 12062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12062,
        GIR_EraseRootFromParent_Done,
      // Label 10359: @646931
      GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(647006), // Rule ID 12063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12063,
        GIR_EraseRootFromParent_Done,
      // Label 10360: @647006
      GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(647081), // Rule ID 12066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12066,
        GIR_EraseRootFromParent_Done,
      // Label 10361: @647081
      GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(647156), // Rule ID 12067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12067,
        GIR_EraseRootFromParent_Done,
      // Label 10362: @647156
      GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(647231), // Rule ID 12070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12070,
        GIR_EraseRootFromParent_Done,
      // Label 10363: @647231
      GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(647306), // Rule ID 12071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12071,
        GIR_EraseRootFromParent_Done,
      // Label 10364: @647306
      GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(647381), // Rule ID 12074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12074,
        GIR_EraseRootFromParent_Done,
      // Label 10365: @647381
      GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(647456), // Rule ID 12075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12075,
        GIR_EraseRootFromParent_Done,
      // Label 10366: @647456
      GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(647531), // Rule ID 12078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12078,
        GIR_EraseRootFromParent_Done,
      // Label 10367: @647531
      GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(647606), // Rule ID 12079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12079,
        GIR_EraseRootFromParent_Done,
      // Label 10368: @647606
      GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(647681), // Rule ID 12082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12082,
        GIR_EraseRootFromParent_Done,
      // Label 10369: @647681
      GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(647756), // Rule ID 12083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12083,
        GIR_EraseRootFromParent_Done,
      // Label 10370: @647756
      GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(647831), // Rule ID 12086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12086,
        GIR_EraseRootFromParent_Done,
      // Label 10371: @647831
      GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(647906), // Rule ID 12087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12087,
        GIR_EraseRootFromParent_Done,
      // Label 10372: @647906
      GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(647981), // Rule ID 12090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12090,
        GIR_EraseRootFromParent_Done,
      // Label 10373: @647981
      GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(648056), // Rule ID 12091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12091,
        GIR_EraseRootFromParent_Done,
      // Label 10374: @648056
      GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(648131), // Rule ID 12094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12094,
        GIR_EraseRootFromParent_Done,
      // Label 10375: @648131
      GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(648206), // Rule ID 12095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12095,
        GIR_EraseRootFromParent_Done,
      // Label 10376: @648206
      GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(648281), // Rule ID 12098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12098,
        GIR_EraseRootFromParent_Done,
      // Label 10377: @648281
      GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(648356), // Rule ID 12099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12099,
        GIR_EraseRootFromParent_Done,
      // Label 10378: @648356
      GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(648431), // Rule ID 12102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12102,
        GIR_EraseRootFromParent_Done,
      // Label 10379: @648431
      GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(648506), // Rule ID 12103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12103,
        GIR_EraseRootFromParent_Done,
      // Label 10380: @648506
      GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(648581), // Rule ID 12106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12106,
        GIR_EraseRootFromParent_Done,
      // Label 10381: @648581
      GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(648656), // Rule ID 12107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12107,
        GIR_EraseRootFromParent_Done,
      // Label 10382: @648656
      GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(648731), // Rule ID 12110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12110,
        GIR_EraseRootFromParent_Done,
      // Label 10383: @648731
      GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(648806), // Rule ID 12111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12111,
        GIR_EraseRootFromParent_Done,
      // Label 10384: @648806
      GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(648881), // Rule ID 12114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12114,
        GIR_EraseRootFromParent_Done,
      // Label 10385: @648881
      GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(648956), // Rule ID 12115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12115,
        GIR_EraseRootFromParent_Done,
      // Label 10386: @648956
      GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(649031), // Rule ID 12118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12118,
        GIR_EraseRootFromParent_Done,
      // Label 10387: @649031
      GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(649106), // Rule ID 12119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12119,
        GIR_EraseRootFromParent_Done,
      // Label 10388: @649106
      GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(649181), // Rule ID 12122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12122,
        GIR_EraseRootFromParent_Done,
      // Label 10389: @649181
      GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(649256), // Rule ID 12123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12123,
        GIR_EraseRootFromParent_Done,
      // Label 10390: @649256
      GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(649331), // Rule ID 12126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12126,
        GIR_EraseRootFromParent_Done,
      // Label 10391: @649331
      GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(649406), // Rule ID 12127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12127,
        GIR_EraseRootFromParent_Done,
      // Label 10392: @649406
      GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(649481), // Rule ID 12130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12130,
        GIR_EraseRootFromParent_Done,
      // Label 10393: @649481
      GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(649556), // Rule ID 12131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12131,
        GIR_EraseRootFromParent_Done,
      // Label 10394: @649556
      GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(649631), // Rule ID 12134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12134,
        GIR_EraseRootFromParent_Done,
      // Label 10395: @649631
      GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(649706), // Rule ID 12135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12135,
        GIR_EraseRootFromParent_Done,
      // Label 10396: @649706
      GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(649781), // Rule ID 12138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12138,
        GIR_EraseRootFromParent_Done,
      // Label 10397: @649781
      GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(649856), // Rule ID 12139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12139,
        GIR_EraseRootFromParent_Done,
      // Label 10398: @649856
      GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(649931), // Rule ID 12142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12142,
        GIR_EraseRootFromParent_Done,
      // Label 10399: @649931
      GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(650006), // Rule ID 12143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12143,
        GIR_EraseRootFromParent_Done,
      // Label 10400: @650006
      GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(650081), // Rule ID 12146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12146,
        GIR_EraseRootFromParent_Done,
      // Label 10401: @650081
      GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(650156), // Rule ID 12147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12147,
        GIR_EraseRootFromParent_Done,
      // Label 10402: @650156
      GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(650231), // Rule ID 12150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12150,
        GIR_EraseRootFromParent_Done,
      // Label 10403: @650231
      GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(650306), // Rule ID 12151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12151,
        GIR_EraseRootFromParent_Done,
      // Label 10404: @650306
      GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(650381), // Rule ID 12154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12154,
        GIR_EraseRootFromParent_Done,
      // Label 10405: @650381
      GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(650456), // Rule ID 12155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12155,
        GIR_EraseRootFromParent_Done,
      // Label 10406: @650456
      GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(650531), // Rule ID 12158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12158,
        GIR_EraseRootFromParent_Done,
      // Label 10407: @650531
      GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(650606), // Rule ID 12159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12159,
        GIR_EraseRootFromParent_Done,
      // Label 10408: @650606
      GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(650681), // Rule ID 12162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12162,
        GIR_EraseRootFromParent_Done,
      // Label 10409: @650681
      GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(650756), // Rule ID 12163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12163,
        GIR_EraseRootFromParent_Done,
      // Label 10410: @650756
      GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(650831), // Rule ID 12166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12166,
        GIR_EraseRootFromParent_Done,
      // Label 10411: @650831
      GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(650906), // Rule ID 12167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12167,
        GIR_EraseRootFromParent_Done,
      // Label 10412: @650906
      GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(650981), // Rule ID 12170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12170,
        GIR_EraseRootFromParent_Done,
      // Label 10413: @650981
      GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(651056), // Rule ID 12171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12171,
        GIR_EraseRootFromParent_Done,
      // Label 10414: @651056
      GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(651131), // Rule ID 12174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12174,
        GIR_EraseRootFromParent_Done,
      // Label 10415: @651131
      GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(651206), // Rule ID 12175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12175,
        GIR_EraseRootFromParent_Done,
      // Label 10416: @651206
      GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(651281), // Rule ID 12178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12178,
        GIR_EraseRootFromParent_Done,
      // Label 10417: @651281
      GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(651356), // Rule ID 12179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12179,
        GIR_EraseRootFromParent_Done,
      // Label 10418: @651356
      GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(651431), // Rule ID 12182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12182,
        GIR_EraseRootFromParent_Done,
      // Label 10419: @651431
      GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(651506), // Rule ID 12183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12183,
        GIR_EraseRootFromParent_Done,
      // Label 10420: @651506
      GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(651581), // Rule ID 12186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12186,
        GIR_EraseRootFromParent_Done,
      // Label 10421: @651581
      GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(651656), // Rule ID 12187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12187,
        GIR_EraseRootFromParent_Done,
      // Label 10422: @651656
      GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(651731), // Rule ID 12190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12190,
        GIR_EraseRootFromParent_Done,
      // Label 10423: @651731
      GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(651806), // Rule ID 12191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12191,
        GIR_EraseRootFromParent_Done,
      // Label 10424: @651806
      GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(651881), // Rule ID 12194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12194,
        GIR_EraseRootFromParent_Done,
      // Label 10425: @651881
      GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(651956), // Rule ID 12195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12195,
        GIR_EraseRootFromParent_Done,
      // Label 10426: @651956
      GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(652031), // Rule ID 12198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12198,
        GIR_EraseRootFromParent_Done,
      // Label 10427: @652031
      GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(652106), // Rule ID 12199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12199,
        GIR_EraseRootFromParent_Done,
      // Label 10428: @652106
      GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(652181), // Rule ID 12202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12202,
        GIR_EraseRootFromParent_Done,
      // Label 10429: @652181
      GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(652256), // Rule ID 12203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12203,
        GIR_EraseRootFromParent_Done,
      // Label 10430: @652256
      GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(652331), // Rule ID 12206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12206,
        GIR_EraseRootFromParent_Done,
      // Label 10431: @652331
      GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(652406), // Rule ID 12207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12207,
        GIR_EraseRootFromParent_Done,
      // Label 10432: @652406
      GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(652481), // Rule ID 12210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12210,
        GIR_EraseRootFromParent_Done,
      // Label 10433: @652481
      GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(652556), // Rule ID 12211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12211,
        GIR_EraseRootFromParent_Done,
      // Label 10434: @652556
      GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(652631), // Rule ID 12214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12214,
        GIR_EraseRootFromParent_Done,
      // Label 10435: @652631
      GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(652706), // Rule ID 12215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12215,
        GIR_EraseRootFromParent_Done,
      // Label 10436: @652706
      GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(652781), // Rule ID 12218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12218,
        GIR_EraseRootFromParent_Done,
      // Label 10437: @652781
      GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(652856), // Rule ID 12219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12219,
        GIR_EraseRootFromParent_Done,
      // Label 10438: @652856
      GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(652931), // Rule ID 12222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12222,
        GIR_EraseRootFromParent_Done,
      // Label 10439: @652931
      GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(653006), // Rule ID 12223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12223,
        GIR_EraseRootFromParent_Done,
      // Label 10440: @653006
      GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(653081), // Rule ID 12226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12226,
        GIR_EraseRootFromParent_Done,
      // Label 10441: @653081
      GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(653156), // Rule ID 12227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12227,
        GIR_EraseRootFromParent_Done,
      // Label 10442: @653156
      GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(653231), // Rule ID 12230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12230,
        GIR_EraseRootFromParent_Done,
      // Label 10443: @653231
      GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(653306), // Rule ID 12231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12231,
        GIR_EraseRootFromParent_Done,
      // Label 10444: @653306
      GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(653381), // Rule ID 12234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12234,
        GIR_EraseRootFromParent_Done,
      // Label 10445: @653381
      GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(653456), // Rule ID 12235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12235,
        GIR_EraseRootFromParent_Done,
      // Label 10446: @653456
      GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(653531), // Rule ID 12238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12238,
        GIR_EraseRootFromParent_Done,
      // Label 10447: @653531
      GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(653606), // Rule ID 12239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12239,
        GIR_EraseRootFromParent_Done,
      // Label 10448: @653606
      GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(653681), // Rule ID 12242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12242,
        GIR_EraseRootFromParent_Done,
      // Label 10449: @653681
      GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(653756), // Rule ID 12243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12243,
        GIR_EraseRootFromParent_Done,
      // Label 10450: @653756
      GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(653831), // Rule ID 12246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12246,
        GIR_EraseRootFromParent_Done,
      // Label 10451: @653831
      GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(653906), // Rule ID 12247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12247,
        GIR_EraseRootFromParent_Done,
      // Label 10452: @653906
      GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(653981), // Rule ID 12250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12250,
        GIR_EraseRootFromParent_Done,
      // Label 10453: @653981
      GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(654056), // Rule ID 12251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12251,
        GIR_EraseRootFromParent_Done,
      // Label 10454: @654056
      GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(654131), // Rule ID 12254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12254,
        GIR_EraseRootFromParent_Done,
      // Label 10455: @654131
      GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(654206), // Rule ID 12255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12255,
        GIR_EraseRootFromParent_Done,
      // Label 10456: @654206
      GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(654281), // Rule ID 12258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12258,
        GIR_EraseRootFromParent_Done,
      // Label 10457: @654281
      GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(654356), // Rule ID 12259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12259,
        GIR_EraseRootFromParent_Done,
      // Label 10458: @654356
      GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(654431), // Rule ID 12262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12262,
        GIR_EraseRootFromParent_Done,
      // Label 10459: @654431
      GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(654506), // Rule ID 12263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12263,
        GIR_EraseRootFromParent_Done,
      // Label 10460: @654506
      GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(654581), // Rule ID 12266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12266,
        GIR_EraseRootFromParent_Done,
      // Label 10461: @654581
      GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(654656), // Rule ID 12267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12267,
        GIR_EraseRootFromParent_Done,
      // Label 10462: @654656
      GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(654731), // Rule ID 12270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12270,
        GIR_EraseRootFromParent_Done,
      // Label 10463: @654731
      GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(654806), // Rule ID 12271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12271,
        GIR_EraseRootFromParent_Done,
      // Label 10464: @654806
      GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(654881), // Rule ID 12274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12274,
        GIR_EraseRootFromParent_Done,
      // Label 10465: @654881
      GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(654956), // Rule ID 12275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12275,
        GIR_EraseRootFromParent_Done,
      // Label 10466: @654956
      GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(655031), // Rule ID 12278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12278,
        GIR_EraseRootFromParent_Done,
      // Label 10467: @655031
      GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(655106), // Rule ID 12279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12279,
        GIR_EraseRootFromParent_Done,
      // Label 10468: @655106
      GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(655181), // Rule ID 12282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12282,
        GIR_EraseRootFromParent_Done,
      // Label 10469: @655181
      GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(655256), // Rule ID 12283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12283,
        GIR_EraseRootFromParent_Done,
      // Label 10470: @655256
      GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(655331), // Rule ID 12286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12286,
        GIR_EraseRootFromParent_Done,
      // Label 10471: @655331
      GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(655406), // Rule ID 12287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12287,
        GIR_EraseRootFromParent_Done,
      // Label 10472: @655406
      GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(655481), // Rule ID 12290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12290,
        GIR_EraseRootFromParent_Done,
      // Label 10473: @655481
      GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(655556), // Rule ID 12291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12291,
        GIR_EraseRootFromParent_Done,
      // Label 10474: @655556
      GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(655631), // Rule ID 12294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12294,
        GIR_EraseRootFromParent_Done,
      // Label 10475: @655631
      GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(655706), // Rule ID 12295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12295,
        GIR_EraseRootFromParent_Done,
      // Label 10476: @655706
      GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(655781), // Rule ID 12298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12298,
        GIR_EraseRootFromParent_Done,
      // Label 10477: @655781
      GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(655856), // Rule ID 12299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12299,
        GIR_EraseRootFromParent_Done,
      // Label 10478: @655856
      GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(655931), // Rule ID 12302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12302,
        GIR_EraseRootFromParent_Done,
      // Label 10479: @655931
      GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(656006), // Rule ID 12303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12303,
        GIR_EraseRootFromParent_Done,
      // Label 10480: @656006
      GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(656081), // Rule ID 12306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12306,
        GIR_EraseRootFromParent_Done,
      // Label 10481: @656081
      GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(656156), // Rule ID 12307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12307,
        GIR_EraseRootFromParent_Done,
      // Label 10482: @656156
      GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(656231), // Rule ID 12310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12310,
        GIR_EraseRootFromParent_Done,
      // Label 10483: @656231
      GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(656306), // Rule ID 12311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12311,
        GIR_EraseRootFromParent_Done,
      // Label 10484: @656306
      GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(656381), // Rule ID 12314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12314,
        GIR_EraseRootFromParent_Done,
      // Label 10485: @656381
      GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(656456), // Rule ID 12315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12315,
        GIR_EraseRootFromParent_Done,
      // Label 10486: @656456
      GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(656531), // Rule ID 12318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12318,
        GIR_EraseRootFromParent_Done,
      // Label 10487: @656531
      GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(656606), // Rule ID 12319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12319,
        GIR_EraseRootFromParent_Done,
      // Label 10488: @656606
      GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(656681), // Rule ID 12322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12322,
        GIR_EraseRootFromParent_Done,
      // Label 10489: @656681
      GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(656756), // Rule ID 12323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12323,
        GIR_EraseRootFromParent_Done,
      // Label 10490: @656756
      GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(656831), // Rule ID 12326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12326,
        GIR_EraseRootFromParent_Done,
      // Label 10491: @656831
      GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(656906), // Rule ID 12327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12327,
        GIR_EraseRootFromParent_Done,
      // Label 10492: @656906
      GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(656981), // Rule ID 12330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12330,
        GIR_EraseRootFromParent_Done,
      // Label 10493: @656981
      GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(657056), // Rule ID 12331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12331,
        GIR_EraseRootFromParent_Done,
      // Label 10494: @657056
      GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(657131), // Rule ID 12334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12334,
        GIR_EraseRootFromParent_Done,
      // Label 10495: @657131
      GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(657206), // Rule ID 12335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12335,
        GIR_EraseRootFromParent_Done,
      // Label 10496: @657206
      GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(657281), // Rule ID 12338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12338,
        GIR_EraseRootFromParent_Done,
      // Label 10497: @657281
      GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(657356), // Rule ID 12339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12339,
        GIR_EraseRootFromParent_Done,
      // Label 10498: @657356
      GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(657431), // Rule ID 12342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12342,
        GIR_EraseRootFromParent_Done,
      // Label 10499: @657431
      GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(657506), // Rule ID 12343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12343,
        GIR_EraseRootFromParent_Done,
      // Label 10500: @657506
      GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(657581), // Rule ID 12346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12346,
        GIR_EraseRootFromParent_Done,
      // Label 10501: @657581
      GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(657656), // Rule ID 12347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12347,
        GIR_EraseRootFromParent_Done,
      // Label 10502: @657656
      GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(657731), // Rule ID 12350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12350,
        GIR_EraseRootFromParent_Done,
      // Label 10503: @657731
      GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(657806), // Rule ID 12351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12351,
        GIR_EraseRootFromParent_Done,
      // Label 10504: @657806
      GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(657881), // Rule ID 12354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12354,
        GIR_EraseRootFromParent_Done,
      // Label 10505: @657881
      GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(657956), // Rule ID 12355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12355,
        GIR_EraseRootFromParent_Done,
      // Label 10506: @657956
      GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(658031), // Rule ID 12358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12358,
        GIR_EraseRootFromParent_Done,
      // Label 10507: @658031
      GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(658106), // Rule ID 12359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12359,
        GIR_EraseRootFromParent_Done,
      // Label 10508: @658106
      GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(658181), // Rule ID 12362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12362,
        GIR_EraseRootFromParent_Done,
      // Label 10509: @658181
      GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(658256), // Rule ID 12363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12363,
        GIR_EraseRootFromParent_Done,
      // Label 10510: @658256
      GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(658331), // Rule ID 12366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12366,
        GIR_EraseRootFromParent_Done,
      // Label 10511: @658331
      GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(658406), // Rule ID 12367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12367,
        GIR_EraseRootFromParent_Done,
      // Label 10512: @658406
      GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(658481), // Rule ID 12370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12370,
        GIR_EraseRootFromParent_Done,
      // Label 10513: @658481
      GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(658556), // Rule ID 12371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12371,
        GIR_EraseRootFromParent_Done,
      // Label 10514: @658556
      GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(658631), // Rule ID 12374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12374,
        GIR_EraseRootFromParent_Done,
      // Label 10515: @658631
      GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(658706), // Rule ID 12375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12375,
        GIR_EraseRootFromParent_Done,
      // Label 10516: @658706
      GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(658781), // Rule ID 12378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12378,
        GIR_EraseRootFromParent_Done,
      // Label 10517: @658781
      GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(658856), // Rule ID 12379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12379,
        GIR_EraseRootFromParent_Done,
      // Label 10518: @658856
      GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(658931), // Rule ID 12382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12382,
        GIR_EraseRootFromParent_Done,
      // Label 10519: @658931
      GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(659006), // Rule ID 12383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12383,
        GIR_EraseRootFromParent_Done,
      // Label 10520: @659006
      GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(659081), // Rule ID 12386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12386,
        GIR_EraseRootFromParent_Done,
      // Label 10521: @659081
      GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(659156), // Rule ID 12387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12387,
        GIR_EraseRootFromParent_Done,
      // Label 10522: @659156
      GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(659231), // Rule ID 12390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12390,
        GIR_EraseRootFromParent_Done,
      // Label 10523: @659231
      GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(659306), // Rule ID 12391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12391,
        GIR_EraseRootFromParent_Done,
      // Label 10524: @659306
      GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(659381), // Rule ID 12394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12394,
        GIR_EraseRootFromParent_Done,
      // Label 10525: @659381
      GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(659456), // Rule ID 12395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12395,
        GIR_EraseRootFromParent_Done,
      // Label 10526: @659456
      GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(659531), // Rule ID 12398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12398,
        GIR_EraseRootFromParent_Done,
      // Label 10527: @659531
      GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(659606), // Rule ID 12399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12399,
        GIR_EraseRootFromParent_Done,
      // Label 10528: @659606
      GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(659681), // Rule ID 12402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12402,
        GIR_EraseRootFromParent_Done,
      // Label 10529: @659681
      GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(659756), // Rule ID 12403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12403,
        GIR_EraseRootFromParent_Done,
      // Label 10530: @659756
      GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(659831), // Rule ID 12406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12406,
        GIR_EraseRootFromParent_Done,
      // Label 10531: @659831
      GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(659906), // Rule ID 12407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12407,
        GIR_EraseRootFromParent_Done,
      // Label 10532: @659906
      GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(659981), // Rule ID 12410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12410,
        GIR_EraseRootFromParent_Done,
      // Label 10533: @659981
      GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(660056), // Rule ID 12411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12411,
        GIR_EraseRootFromParent_Done,
      // Label 10534: @660056
      GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(660131), // Rule ID 12414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12414,
        GIR_EraseRootFromParent_Done,
      // Label 10535: @660131
      GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(660206), // Rule ID 12415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12415,
        GIR_EraseRootFromParent_Done,
      // Label 10536: @660206
      GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(660281), // Rule ID 12418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12418,
        GIR_EraseRootFromParent_Done,
      // Label 10537: @660281
      GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(660356), // Rule ID 12419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12419,
        GIR_EraseRootFromParent_Done,
      // Label 10538: @660356
      GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(660431), // Rule ID 12422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12422,
        GIR_EraseRootFromParent_Done,
      // Label 10539: @660431
      GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(660506), // Rule ID 12423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12423,
        GIR_EraseRootFromParent_Done,
      // Label 10540: @660506
      GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(660581), // Rule ID 12426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12426,
        GIR_EraseRootFromParent_Done,
      // Label 10541: @660581
      GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(660656), // Rule ID 12427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12427,
        GIR_EraseRootFromParent_Done,
      // Label 10542: @660656
      GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(660731), // Rule ID 12430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12430,
        GIR_EraseRootFromParent_Done,
      // Label 10543: @660731
      GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(660806), // Rule ID 12431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12431,
        GIR_EraseRootFromParent_Done,
      // Label 10544: @660806
      GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(660881), // Rule ID 12434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12434,
        GIR_EraseRootFromParent_Done,
      // Label 10545: @660881
      GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(660956), // Rule ID 12435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12435,
        GIR_EraseRootFromParent_Done,
      // Label 10546: @660956
      GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(661031), // Rule ID 12438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12438,
        GIR_EraseRootFromParent_Done,
      // Label 10547: @661031
      GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(661106), // Rule ID 12439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12439,
        GIR_EraseRootFromParent_Done,
      // Label 10548: @661106
      GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(661181), // Rule ID 12442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12442,
        GIR_EraseRootFromParent_Done,
      // Label 10549: @661181
      GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(661256), // Rule ID 12443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12443,
        GIR_EraseRootFromParent_Done,
      // Label 10550: @661256
      GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(661331), // Rule ID 12446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12446,
        GIR_EraseRootFromParent_Done,
      // Label 10551: @661331
      GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(661406), // Rule ID 12447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12447,
        GIR_EraseRootFromParent_Done,
      // Label 10552: @661406
      GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(661481), // Rule ID 12450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12450,
        GIR_EraseRootFromParent_Done,
      // Label 10553: @661481
      GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(661556), // Rule ID 12451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12451,
        GIR_EraseRootFromParent_Done,
      // Label 10554: @661556
      GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(661631), // Rule ID 12454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12454,
        GIR_EraseRootFromParent_Done,
      // Label 10555: @661631
      GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(661706), // Rule ID 12455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12455,
        GIR_EraseRootFromParent_Done,
      // Label 10556: @661706
      GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(661781), // Rule ID 12458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12458,
        GIR_EraseRootFromParent_Done,
      // Label 10557: @661781
      GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(661856), // Rule ID 12459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12459,
        GIR_EraseRootFromParent_Done,
      // Label 10558: @661856
      GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(661931), // Rule ID 12462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12462,
        GIR_EraseRootFromParent_Done,
      // Label 10559: @661931
      GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(662006), // Rule ID 12463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12463,
        GIR_EraseRootFromParent_Done,
      // Label 10560: @662006
      GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(662081), // Rule ID 12466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12466,
        GIR_EraseRootFromParent_Done,
      // Label 10561: @662081
      GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(662156), // Rule ID 12467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12467,
        GIR_EraseRootFromParent_Done,
      // Label 10562: @662156
      GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(662231), // Rule ID 12470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12470,
        GIR_EraseRootFromParent_Done,
      // Label 10563: @662231
      GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(662306), // Rule ID 12471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12471,
        GIR_EraseRootFromParent_Done,
      // Label 10564: @662306
      GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(662381), // Rule ID 12474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12474,
        GIR_EraseRootFromParent_Done,
      // Label 10565: @662381
      GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(662456), // Rule ID 12475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12475,
        GIR_EraseRootFromParent_Done,
      // Label 10566: @662456
      GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(662531), // Rule ID 12478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12478,
        GIR_EraseRootFromParent_Done,
      // Label 10567: @662531
      GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(662606), // Rule ID 12479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12479,
        GIR_EraseRootFromParent_Done,
      // Label 10568: @662606
      GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(662681), // Rule ID 12482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12482,
        GIR_EraseRootFromParent_Done,
      // Label 10569: @662681
      GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(662756), // Rule ID 12483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12483,
        GIR_EraseRootFromParent_Done,
      // Label 10570: @662756
      GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(662831), // Rule ID 12486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12486,
        GIR_EraseRootFromParent_Done,
      // Label 10571: @662831
      GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(662906), // Rule ID 12487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12487,
        GIR_EraseRootFromParent_Done,
      // Label 10572: @662906
      GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(662981), // Rule ID 12490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12490,
        GIR_EraseRootFromParent_Done,
      // Label 10573: @662981
      GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(663056), // Rule ID 12491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12491,
        GIR_EraseRootFromParent_Done,
      // Label 10574: @663056
      GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(663131), // Rule ID 12494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12494,
        GIR_EraseRootFromParent_Done,
      // Label 10575: @663131
      GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(663206), // Rule ID 12495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12495,
        GIR_EraseRootFromParent_Done,
      // Label 10576: @663206
      GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(663281), // Rule ID 12498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12498,
        GIR_EraseRootFromParent_Done,
      // Label 10577: @663281
      GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(663356), // Rule ID 12499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12499,
        GIR_EraseRootFromParent_Done,
      // Label 10578: @663356
      GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(663431), // Rule ID 12502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12502,
        GIR_EraseRootFromParent_Done,
      // Label 10579: @663431
      GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(663506), // Rule ID 12503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12503,
        GIR_EraseRootFromParent_Done,
      // Label 10580: @663506
      GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(663581), // Rule ID 12506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12506,
        GIR_EraseRootFromParent_Done,
      // Label 10581: @663581
      GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(663656), // Rule ID 12507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12507,
        GIR_EraseRootFromParent_Done,
      // Label 10582: @663656
      GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(663731), // Rule ID 12510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12510,
        GIR_EraseRootFromParent_Done,
      // Label 10583: @663731
      GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(663806), // Rule ID 12511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12511,
        GIR_EraseRootFromParent_Done,
      // Label 10584: @663806
      GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(663881), // Rule ID 12514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12514,
        GIR_EraseRootFromParent_Done,
      // Label 10585: @663881
      GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(663956), // Rule ID 12515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12515,
        GIR_EraseRootFromParent_Done,
      // Label 10586: @663956
      GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(664031), // Rule ID 12518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12518,
        GIR_EraseRootFromParent_Done,
      // Label 10587: @664031
      GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(664106), // Rule ID 12519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12519,
        GIR_EraseRootFromParent_Done,
      // Label 10588: @664106
      GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(664181), // Rule ID 12522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12522,
        GIR_EraseRootFromParent_Done,
      // Label 10589: @664181
      GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(664256), // Rule ID 12523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12523,
        GIR_EraseRootFromParent_Done,
      // Label 10590: @664256
      GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(664331), // Rule ID 12526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12526,
        GIR_EraseRootFromParent_Done,
      // Label 10591: @664331
      GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(664406), // Rule ID 12527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12527,
        GIR_EraseRootFromParent_Done,
      // Label 10592: @664406
      GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(664481), // Rule ID 12530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12530,
        GIR_EraseRootFromParent_Done,
      // Label 10593: @664481
      GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(664556), // Rule ID 12531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12531,
        GIR_EraseRootFromParent_Done,
      // Label 10594: @664556
      GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(664631), // Rule ID 12534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12534,
        GIR_EraseRootFromParent_Done,
      // Label 10595: @664631
      GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(664706), // Rule ID 12535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12535,
        GIR_EraseRootFromParent_Done,
      // Label 10596: @664706
      GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(664781), // Rule ID 12538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12538,
        GIR_EraseRootFromParent_Done,
      // Label 10597: @664781
      GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(664856), // Rule ID 12539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12539,
        GIR_EraseRootFromParent_Done,
      // Label 10598: @664856
      GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(664931), // Rule ID 12542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12542,
        GIR_EraseRootFromParent_Done,
      // Label 10599: @664931
      GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(665006), // Rule ID 12543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12543,
        GIR_EraseRootFromParent_Done,
      // Label 10600: @665006
      GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(665081), // Rule ID 12546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12546,
        GIR_EraseRootFromParent_Done,
      // Label 10601: @665081
      GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(665156), // Rule ID 12547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12547,
        GIR_EraseRootFromParent_Done,
      // Label 10602: @665156
      GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(665231), // Rule ID 12550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12550,
        GIR_EraseRootFromParent_Done,
      // Label 10603: @665231
      GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(665306), // Rule ID 12551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12551,
        GIR_EraseRootFromParent_Done,
      // Label 10604: @665306
      GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(665381), // Rule ID 12554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12554,
        GIR_EraseRootFromParent_Done,
      // Label 10605: @665381
      GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(665456), // Rule ID 12555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12555,
        GIR_EraseRootFromParent_Done,
      // Label 10606: @665456
      GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(665531), // Rule ID 12558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12558,
        GIR_EraseRootFromParent_Done,
      // Label 10607: @665531
      GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(665606), // Rule ID 12559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12559,
        GIR_EraseRootFromParent_Done,
      // Label 10608: @665606
      GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(665681), // Rule ID 12562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12562,
        GIR_EraseRootFromParent_Done,
      // Label 10609: @665681
      GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(665756), // Rule ID 12563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12563,
        GIR_EraseRootFromParent_Done,
      // Label 10610: @665756
      GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(665831), // Rule ID 12566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12566,
        GIR_EraseRootFromParent_Done,
      // Label 10611: @665831
      GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(665906), // Rule ID 12567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12567,
        GIR_EraseRootFromParent_Done,
      // Label 10612: @665906
      GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(665981), // Rule ID 12570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12570,
        GIR_EraseRootFromParent_Done,
      // Label 10613: @665981
      GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(666056), // Rule ID 12571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12571,
        GIR_EraseRootFromParent_Done,
      // Label 10614: @666056
      GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(666131), // Rule ID 12574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12574,
        GIR_EraseRootFromParent_Done,
      // Label 10615: @666131
      GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(666206), // Rule ID 12575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12575,
        GIR_EraseRootFromParent_Done,
      // Label 10616: @666206
      GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(666284), // Rule ID 13904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13904,
        GIR_EraseRootFromParent_Done,
      // Label 10617: @666284
      GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(666362), // Rule ID 13905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13905,
        GIR_EraseRootFromParent_Done,
      // Label 10618: @666362
      GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(666440), // Rule ID 13908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13908,
        GIR_EraseRootFromParent_Done,
      // Label 10619: @666440
      GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(666518), // Rule ID 13909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13909,
        GIR_EraseRootFromParent_Done,
      // Label 10620: @666518
      GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(666596), // Rule ID 13912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13912,
        GIR_EraseRootFromParent_Done,
      // Label 10621: @666596
      GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(666674), // Rule ID 13913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13913,
        GIR_EraseRootFromParent_Done,
      // Label 10622: @666674
      GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(666752), // Rule ID 13916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13916,
        GIR_EraseRootFromParent_Done,
      // Label 10623: @666752
      GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(666830), // Rule ID 13917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13917,
        GIR_EraseRootFromParent_Done,
      // Label 10624: @666830
      GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(666908), // Rule ID 13920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13920,
        GIR_EraseRootFromParent_Done,
      // Label 10625: @666908
      GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(666986), // Rule ID 13921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13921,
        GIR_EraseRootFromParent_Done,
      // Label 10626: @666986
      GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(667064), // Rule ID 13924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13924,
        GIR_EraseRootFromParent_Done,
      // Label 10627: @667064
      GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(667142), // Rule ID 13925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13925,
        GIR_EraseRootFromParent_Done,
      // Label 10628: @667142
      GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(667220), // Rule ID 13928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13928,
        GIR_EraseRootFromParent_Done,
      // Label 10629: @667220
      GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(667298), // Rule ID 13929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13929,
        GIR_EraseRootFromParent_Done,
      // Label 10630: @667298
      GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(667376), // Rule ID 13932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13932,
        GIR_EraseRootFromParent_Done,
      // Label 10631: @667376
      GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(667454), // Rule ID 13933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13933,
        GIR_EraseRootFromParent_Done,
      // Label 10632: @667454
      GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(667532), // Rule ID 13936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13936,
        GIR_EraseRootFromParent_Done,
      // Label 10633: @667532
      GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(667610), // Rule ID 13937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13937,
        GIR_EraseRootFromParent_Done,
      // Label 10634: @667610
      GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(667688), // Rule ID 13940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13940,
        GIR_EraseRootFromParent_Done,
      // Label 10635: @667688
      GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(667766), // Rule ID 13941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13941,
        GIR_EraseRootFromParent_Done,
      // Label 10636: @667766
      GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(667844), // Rule ID 13944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13944,
        GIR_EraseRootFromParent_Done,
      // Label 10637: @667844
      GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(667922), // Rule ID 13945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13945,
        GIR_EraseRootFromParent_Done,
      // Label 10638: @667922
      GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(668000), // Rule ID 13948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13948,
        GIR_EraseRootFromParent_Done,
      // Label 10639: @668000
      GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(668078), // Rule ID 13949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13949,
        GIR_EraseRootFromParent_Done,
      // Label 10640: @668078
      GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(668156), // Rule ID 13952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13952,
        GIR_EraseRootFromParent_Done,
      // Label 10641: @668156
      GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(668234), // Rule ID 13953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13953,
        GIR_EraseRootFromParent_Done,
      // Label 10642: @668234
      GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(668312), // Rule ID 13956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13956,
        GIR_EraseRootFromParent_Done,
      // Label 10643: @668312
      GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(668390), // Rule ID 13957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13957,
        GIR_EraseRootFromParent_Done,
      // Label 10644: @668390
      GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(668468), // Rule ID 13960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13960,
        GIR_EraseRootFromParent_Done,
      // Label 10645: @668468
      GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(668546), // Rule ID 13961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13961,
        GIR_EraseRootFromParent_Done,
      // Label 10646: @668546
      GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(668624), // Rule ID 13964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13964,
        GIR_EraseRootFromParent_Done,
      // Label 10647: @668624
      GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(668702), // Rule ID 13965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13965,
        GIR_EraseRootFromParent_Done,
      // Label 10648: @668702
      GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(668780), // Rule ID 13968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13968,
        GIR_EraseRootFromParent_Done,
      // Label 10649: @668780
      GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(668858), // Rule ID 13969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13969,
        GIR_EraseRootFromParent_Done,
      // Label 10650: @668858
      GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(668936), // Rule ID 13972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13972,
        GIR_EraseRootFromParent_Done,
      // Label 10651: @668936
      GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(669014), // Rule ID 13973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13973,
        GIR_EraseRootFromParent_Done,
      // Label 10652: @669014
      GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(669092), // Rule ID 13976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13976,
        GIR_EraseRootFromParent_Done,
      // Label 10653: @669092
      GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(669170), // Rule ID 13977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13977,
        GIR_EraseRootFromParent_Done,
      // Label 10654: @669170
      GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(669248), // Rule ID 13980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13980,
        GIR_EraseRootFromParent_Done,
      // Label 10655: @669248
      GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(669326), // Rule ID 13981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13981,
        GIR_EraseRootFromParent_Done,
      // Label 10656: @669326
      GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(669404), // Rule ID 13984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13984,
        GIR_EraseRootFromParent_Done,
      // Label 10657: @669404
      GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(669482), // Rule ID 13985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13985,
        GIR_EraseRootFromParent_Done,
      // Label 10658: @669482
      GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(669560), // Rule ID 13988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13988,
        GIR_EraseRootFromParent_Done,
      // Label 10659: @669560
      GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(669638), // Rule ID 13989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13989,
        GIR_EraseRootFromParent_Done,
      // Label 10660: @669638
      GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(669716), // Rule ID 13992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13992,
        GIR_EraseRootFromParent_Done,
      // Label 10661: @669716
      GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(669794), // Rule ID 13993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13993,
        GIR_EraseRootFromParent_Done,
      // Label 10662: @669794
      GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(669872), // Rule ID 13996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13996,
        GIR_EraseRootFromParent_Done,
      // Label 10663: @669872
      GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(669950), // Rule ID 13997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13997,
        GIR_EraseRootFromParent_Done,
      // Label 10664: @669950
      GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(670028), // Rule ID 14000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14000,
        GIR_EraseRootFromParent_Done,
      // Label 10665: @670028
      GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(670106), // Rule ID 14001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14001,
        GIR_EraseRootFromParent_Done,
      // Label 10666: @670106
      GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(670184), // Rule ID 14004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14004,
        GIR_EraseRootFromParent_Done,
      // Label 10667: @670184
      GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(670262), // Rule ID 14005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14005,
        GIR_EraseRootFromParent_Done,
      // Label 10668: @670262
      GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(670340), // Rule ID 14008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14008,
        GIR_EraseRootFromParent_Done,
      // Label 10669: @670340
      GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(670418), // Rule ID 14009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14009,
        GIR_EraseRootFromParent_Done,
      // Label 10670: @670418
      GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(670496), // Rule ID 14012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14012,
        GIR_EraseRootFromParent_Done,
      // Label 10671: @670496
      GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(670574), // Rule ID 14013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14013,
        GIR_EraseRootFromParent_Done,
      // Label 10672: @670574
      GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(670652), // Rule ID 14016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14016,
        GIR_EraseRootFromParent_Done,
      // Label 10673: @670652
      GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(670730), // Rule ID 14017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14017,
        GIR_EraseRootFromParent_Done,
      // Label 10674: @670730
      GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(670808), // Rule ID 14020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14020,
        GIR_EraseRootFromParent_Done,
      // Label 10675: @670808
      GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(670886), // Rule ID 14021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14021,
        GIR_EraseRootFromParent_Done,
      // Label 10676: @670886
      GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(670964), // Rule ID 14024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14024,
        GIR_EraseRootFromParent_Done,
      // Label 10677: @670964
      GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(671042), // Rule ID 14025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14025,
        GIR_EraseRootFromParent_Done,
      // Label 10678: @671042
      GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(671120), // Rule ID 14028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14028,
        GIR_EraseRootFromParent_Done,
      // Label 10679: @671120
      GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(671198), // Rule ID 14029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14029,
        GIR_EraseRootFromParent_Done,
      // Label 10680: @671198
      GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(671276), // Rule ID 14032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14032,
        GIR_EraseRootFromParent_Done,
      // Label 10681: @671276
      GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(671354), // Rule ID 14033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14033,
        GIR_EraseRootFromParent_Done,
      // Label 10682: @671354
      GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(671432), // Rule ID 14036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14036,
        GIR_EraseRootFromParent_Done,
      // Label 10683: @671432
      GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(671510), // Rule ID 14037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14037,
        GIR_EraseRootFromParent_Done,
      // Label 10684: @671510
      GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(671588), // Rule ID 14040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14040,
        GIR_EraseRootFromParent_Done,
      // Label 10685: @671588
      GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(671666), // Rule ID 14041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14041,
        GIR_EraseRootFromParent_Done,
      // Label 10686: @671666
      GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(671744), // Rule ID 14044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14044,
        GIR_EraseRootFromParent_Done,
      // Label 10687: @671744
      GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(671822), // Rule ID 14045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14045,
        GIR_EraseRootFromParent_Done,
      // Label 10688: @671822
      GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(671900), // Rule ID 14048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14048,
        GIR_EraseRootFromParent_Done,
      // Label 10689: @671900
      GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(671978), // Rule ID 14049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14049,
        GIR_EraseRootFromParent_Done,
      // Label 10690: @671978
      GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(672056), // Rule ID 14052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14052,
        GIR_EraseRootFromParent_Done,
      // Label 10691: @672056
      GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(672134), // Rule ID 14053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14053,
        GIR_EraseRootFromParent_Done,
      // Label 10692: @672134
      GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(672212), // Rule ID 14056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14056,
        GIR_EraseRootFromParent_Done,
      // Label 10693: @672212
      GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(672290), // Rule ID 14057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14057,
        GIR_EraseRootFromParent_Done,
      // Label 10694: @672290
      GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(672368), // Rule ID 14060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14060,
        GIR_EraseRootFromParent_Done,
      // Label 10695: @672368
      GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(672446), // Rule ID 14061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14061,
        GIR_EraseRootFromParent_Done,
      // Label 10696: @672446
      GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(672524), // Rule ID 14064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14064,
        GIR_EraseRootFromParent_Done,
      // Label 10697: @672524
      GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(672602), // Rule ID 14065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14065,
        GIR_EraseRootFromParent_Done,
      // Label 10698: @672602
      GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(672680), // Rule ID 14068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14068,
        GIR_EraseRootFromParent_Done,
      // Label 10699: @672680
      GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(672758), // Rule ID 14069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14069,
        GIR_EraseRootFromParent_Done,
      // Label 10700: @672758
      GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(672836), // Rule ID 14072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14072,
        GIR_EraseRootFromParent_Done,
      // Label 10701: @672836
      GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(672914), // Rule ID 14073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14073,
        GIR_EraseRootFromParent_Done,
      // Label 10702: @672914
      GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(672992), // Rule ID 14076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14076,
        GIR_EraseRootFromParent_Done,
      // Label 10703: @672992
      GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(673070), // Rule ID 14077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14077,
        GIR_EraseRootFromParent_Done,
      // Label 10704: @673070
      GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(673148), // Rule ID 14168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14168,
        GIR_EraseRootFromParent_Done,
      // Label 10705: @673148
      GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(673226), // Rule ID 14169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14169,
        GIR_EraseRootFromParent_Done,
      // Label 10706: @673226
      GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(673304), // Rule ID 14172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14172,
        GIR_EraseRootFromParent_Done,
      // Label 10707: @673304
      GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(673382), // Rule ID 14173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14173,
        GIR_EraseRootFromParent_Done,
      // Label 10708: @673382
      GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(673460), // Rule ID 14176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14176,
        GIR_EraseRootFromParent_Done,
      // Label 10709: @673460
      GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(673538), // Rule ID 14177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14177,
        GIR_EraseRootFromParent_Done,
      // Label 10710: @673538
      GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(673616), // Rule ID 14180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14180,
        GIR_EraseRootFromParent_Done,
      // Label 10711: @673616
      GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(673694), // Rule ID 14181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14181,
        GIR_EraseRootFromParent_Done,
      // Label 10712: @673694
      GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(673772), // Rule ID 14184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14184,
        GIR_EraseRootFromParent_Done,
      // Label 10713: @673772
      GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(673850), // Rule ID 14185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14185,
        GIR_EraseRootFromParent_Done,
      // Label 10714: @673850
      GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(673928), // Rule ID 14188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14188,
        GIR_EraseRootFromParent_Done,
      // Label 10715: @673928
      GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(674006), // Rule ID 14189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14189,
        GIR_EraseRootFromParent_Done,
      // Label 10716: @674006
      GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(674084), // Rule ID 14192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14192,
        GIR_EraseRootFromParent_Done,
      // Label 10717: @674084
      GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(674162), // Rule ID 14193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14193,
        GIR_EraseRootFromParent_Done,
      // Label 10718: @674162
      GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(674240), // Rule ID 14196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14196,
        GIR_EraseRootFromParent_Done,
      // Label 10719: @674240
      GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(674318), // Rule ID 14197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14197,
        GIR_EraseRootFromParent_Done,
      // Label 10720: @674318
      GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(674396), // Rule ID 14200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14200,
        GIR_EraseRootFromParent_Done,
      // Label 10721: @674396
      GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(674474), // Rule ID 14201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14201,
        GIR_EraseRootFromParent_Done,
      // Label 10722: @674474
      GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(674552), // Rule ID 14204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14204,
        GIR_EraseRootFromParent_Done,
      // Label 10723: @674552
      GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(674630), // Rule ID 14205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14205,
        GIR_EraseRootFromParent_Done,
      // Label 10724: @674630
      GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(674708), // Rule ID 14208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14208,
        GIR_EraseRootFromParent_Done,
      // Label 10725: @674708
      GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(674786), // Rule ID 14209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14209,
        GIR_EraseRootFromParent_Done,
      // Label 10726: @674786
      GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(674864), // Rule ID 14212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14212,
        GIR_EraseRootFromParent_Done,
      // Label 10727: @674864
      GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(674942), // Rule ID 14213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14213,
        GIR_EraseRootFromParent_Done,
      // Label 10728: @674942
      GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(675020), // Rule ID 14216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14216,
        GIR_EraseRootFromParent_Done,
      // Label 10729: @675020
      GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(675098), // Rule ID 14217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14217,
        GIR_EraseRootFromParent_Done,
      // Label 10730: @675098
      GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(675176), // Rule ID 14220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14220,
        GIR_EraseRootFromParent_Done,
      // Label 10731: @675176
      GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(675254), // Rule ID 14221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14221,
        GIR_EraseRootFromParent_Done,
      // Label 10732: @675254
      GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(675332), // Rule ID 14224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14224,
        GIR_EraseRootFromParent_Done,
      // Label 10733: @675332
      GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(675410), // Rule ID 14225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14225,
        GIR_EraseRootFromParent_Done,
      // Label 10734: @675410
      GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(675488), // Rule ID 14228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14228,
        GIR_EraseRootFromParent_Done,
      // Label 10735: @675488
      GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(675566), // Rule ID 14229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14229,
        GIR_EraseRootFromParent_Done,
      // Label 10736: @675566
      GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(675644), // Rule ID 14232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14232,
        GIR_EraseRootFromParent_Done,
      // Label 10737: @675644
      GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(675722), // Rule ID 14233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14233,
        GIR_EraseRootFromParent_Done,
      // Label 10738: @675722
      GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(675800), // Rule ID 14236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14236,
        GIR_EraseRootFromParent_Done,
      // Label 10739: @675800
      GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(675878), // Rule ID 14237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14237,
        GIR_EraseRootFromParent_Done,
      // Label 10740: @675878
      GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(675956), // Rule ID 14240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14240,
        GIR_EraseRootFromParent_Done,
      // Label 10741: @675956
      GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(676034), // Rule ID 14241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14241,
        GIR_EraseRootFromParent_Done,
      // Label 10742: @676034
      GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(676112), // Rule ID 14244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14244,
        GIR_EraseRootFromParent_Done,
      // Label 10743: @676112
      GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(676190), // Rule ID 14245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14245,
        GIR_EraseRootFromParent_Done,
      // Label 10744: @676190
      GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(676268), // Rule ID 14248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14248,
        GIR_EraseRootFromParent_Done,
      // Label 10745: @676268
      GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(676346), // Rule ID 14249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14249,
        GIR_EraseRootFromParent_Done,
      // Label 10746: @676346
      GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(676424), // Rule ID 14252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14252,
        GIR_EraseRootFromParent_Done,
      // Label 10747: @676424
      GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(676502), // Rule ID 14253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14253,
        GIR_EraseRootFromParent_Done,
      // Label 10748: @676502
      GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(676580), // Rule ID 14256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14256,
        GIR_EraseRootFromParent_Done,
      // Label 10749: @676580
      GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(676658), // Rule ID 14257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14257,
        GIR_EraseRootFromParent_Done,
      // Label 10750: @676658
      GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(676736), // Rule ID 14260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14260,
        GIR_EraseRootFromParent_Done,
      // Label 10751: @676736
      GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(676814), // Rule ID 14261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14261,
        GIR_EraseRootFromParent_Done,
      // Label 10752: @676814
      GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(676892), // Rule ID 14264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14264,
        GIR_EraseRootFromParent_Done,
      // Label 10753: @676892
      GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(676970), // Rule ID 14265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14265,
        GIR_EraseRootFromParent_Done,
      // Label 10754: @676970
      GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(677048), // Rule ID 14268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14268,
        GIR_EraseRootFromParent_Done,
      // Label 10755: @677048
      GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(677126), // Rule ID 14269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14269,
        GIR_EraseRootFromParent_Done,
      // Label 10756: @677126
      GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(677204), // Rule ID 14272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14272,
        GIR_EraseRootFromParent_Done,
      // Label 10757: @677204
      GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(677282), // Rule ID 14273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14273,
        GIR_EraseRootFromParent_Done,
      // Label 10758: @677282
      GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(677360), // Rule ID 14276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14276,
        GIR_EraseRootFromParent_Done,
      // Label 10759: @677360
      GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(677438), // Rule ID 14277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14277,
        GIR_EraseRootFromParent_Done,
      // Label 10760: @677438
      GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(677516), // Rule ID 14280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14280,
        GIR_EraseRootFromParent_Done,
      // Label 10761: @677516
      GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(677594), // Rule ID 14281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14281,
        GIR_EraseRootFromParent_Done,
      // Label 10762: @677594
      GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(677672), // Rule ID 14284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14284,
        GIR_EraseRootFromParent_Done,
      // Label 10763: @677672
      GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(677750), // Rule ID 14285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14285,
        GIR_EraseRootFromParent_Done,
      // Label 10764: @677750
      GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(677828), // Rule ID 14288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14288,
        GIR_EraseRootFromParent_Done,
      // Label 10765: @677828
      GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(677906), // Rule ID 14289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14289,
        GIR_EraseRootFromParent_Done,
      // Label 10766: @677906
      GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(677984), // Rule ID 14292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14292,
        GIR_EraseRootFromParent_Done,
      // Label 10767: @677984
      GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(678062), // Rule ID 14293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14293,
        GIR_EraseRootFromParent_Done,
      // Label 10768: @678062
      GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(678140), // Rule ID 14296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14296,
        GIR_EraseRootFromParent_Done,
      // Label 10769: @678140
      GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(678218), // Rule ID 14297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14297,
        GIR_EraseRootFromParent_Done,
      // Label 10770: @678218
      GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(678296), // Rule ID 14300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14300,
        GIR_EraseRootFromParent_Done,
      // Label 10771: @678296
      GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(678374), // Rule ID 14301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14301,
        GIR_EraseRootFromParent_Done,
      // Label 10772: @678374
      GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(678452), // Rule ID 14304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14304,
        GIR_EraseRootFromParent_Done,
      // Label 10773: @678452
      GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(678530), // Rule ID 14305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14305,
        GIR_EraseRootFromParent_Done,
      // Label 10774: @678530
      GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(678608), // Rule ID 14308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14308,
        GIR_EraseRootFromParent_Done,
      // Label 10775: @678608
      GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(678686), // Rule ID 14309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14309,
        GIR_EraseRootFromParent_Done,
      // Label 10776: @678686
      GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(678764), // Rule ID 14312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14312,
        GIR_EraseRootFromParent_Done,
      // Label 10777: @678764
      GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(678842), // Rule ID 14313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14313,
        GIR_EraseRootFromParent_Done,
      // Label 10778: @678842
      GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(678920), // Rule ID 14316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14316,
        GIR_EraseRootFromParent_Done,
      // Label 10779: @678920
      GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(678998), // Rule ID 14317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14317,
        GIR_EraseRootFromParent_Done,
      // Label 10780: @678998
      GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(679076), // Rule ID 14320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14320,
        GIR_EraseRootFromParent_Done,
      // Label 10781: @679076
      GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(679154), // Rule ID 14321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14321,
        GIR_EraseRootFromParent_Done,
      // Label 10782: @679154
      GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(679232), // Rule ID 14324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14324,
        GIR_EraseRootFromParent_Done,
      // Label 10783: @679232
      GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(679310), // Rule ID 14325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14325,
        GIR_EraseRootFromParent_Done,
      // Label 10784: @679310
      GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(679388), // Rule ID 14328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14328,
        GIR_EraseRootFromParent_Done,
      // Label 10785: @679388
      GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(679466), // Rule ID 14329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14329,
        GIR_EraseRootFromParent_Done,
      // Label 10786: @679466
      GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(679544), // Rule ID 14332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14332,
        GIR_EraseRootFromParent_Done,
      // Label 10787: @679544
      GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(679622), // Rule ID 14333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14333,
        GIR_EraseRootFromParent_Done,
      // Label 10788: @679622
      GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(679700), // Rule ID 14336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14336,
        GIR_EraseRootFromParent_Done,
      // Label 10789: @679700
      GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(679778), // Rule ID 14337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14337,
        GIR_EraseRootFromParent_Done,
      // Label 10790: @679778
      GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(679856), // Rule ID 14340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14340,
        GIR_EraseRootFromParent_Done,
      // Label 10791: @679856
      GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(679934), // Rule ID 14341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14341,
        GIR_EraseRootFromParent_Done,
      // Label 10792: @679934
      GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(680012), // Rule ID 14432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14432,
        GIR_EraseRootFromParent_Done,
      // Label 10793: @680012
      GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(680090), // Rule ID 14433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14433,
        GIR_EraseRootFromParent_Done,
      // Label 10794: @680090
      GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(680168), // Rule ID 14436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14436,
        GIR_EraseRootFromParent_Done,
      // Label 10795: @680168
      GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(680246), // Rule ID 14437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14437,
        GIR_EraseRootFromParent_Done,
      // Label 10796: @680246
      GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(680324), // Rule ID 14440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14440,
        GIR_EraseRootFromParent_Done,
      // Label 10797: @680324
      GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(680402), // Rule ID 14441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14441,
        GIR_EraseRootFromParent_Done,
      // Label 10798: @680402
      GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(680480), // Rule ID 14444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14444,
        GIR_EraseRootFromParent_Done,
      // Label 10799: @680480
      GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(680558), // Rule ID 14445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14445,
        GIR_EraseRootFromParent_Done,
      // Label 10800: @680558
      GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(680636), // Rule ID 14448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14448,
        GIR_EraseRootFromParent_Done,
      // Label 10801: @680636
      GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(680714), // Rule ID 14449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14449,
        GIR_EraseRootFromParent_Done,
      // Label 10802: @680714
      GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(680792), // Rule ID 14452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14452,
        GIR_EraseRootFromParent_Done,
      // Label 10803: @680792
      GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(680870), // Rule ID 14453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14453,
        GIR_EraseRootFromParent_Done,
      // Label 10804: @680870
      GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(680948), // Rule ID 14456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14456,
        GIR_EraseRootFromParent_Done,
      // Label 10805: @680948
      GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(681026), // Rule ID 14457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14457,
        GIR_EraseRootFromParent_Done,
      // Label 10806: @681026
      GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(681104), // Rule ID 14460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14460,
        GIR_EraseRootFromParent_Done,
      // Label 10807: @681104
      GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(681182), // Rule ID 14461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14461,
        GIR_EraseRootFromParent_Done,
      // Label 10808: @681182
      GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(681260), // Rule ID 14464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14464,
        GIR_EraseRootFromParent_Done,
      // Label 10809: @681260
      GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(681338), // Rule ID 14465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14465,
        GIR_EraseRootFromParent_Done,
      // Label 10810: @681338
      GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(681416), // Rule ID 14468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14468,
        GIR_EraseRootFromParent_Done,
      // Label 10811: @681416
      GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(681494), // Rule ID 14469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14469,
        GIR_EraseRootFromParent_Done,
      // Label 10812: @681494
      GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(681572), // Rule ID 14472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14472,
        GIR_EraseRootFromParent_Done,
      // Label 10813: @681572
      GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(681650), // Rule ID 14473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14473,
        GIR_EraseRootFromParent_Done,
      // Label 10814: @681650
      GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(681728), // Rule ID 14476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14476,
        GIR_EraseRootFromParent_Done,
      // Label 10815: @681728
      GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(681806), // Rule ID 14477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14477,
        GIR_EraseRootFromParent_Done,
      // Label 10816: @681806
      GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(681884), // Rule ID 14480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14480,
        GIR_EraseRootFromParent_Done,
      // Label 10817: @681884
      GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(681962), // Rule ID 14481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14481,
        GIR_EraseRootFromParent_Done,
      // Label 10818: @681962
      GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(682040), // Rule ID 14484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14484,
        GIR_EraseRootFromParent_Done,
      // Label 10819: @682040
      GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(682118), // Rule ID 14485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14485,
        GIR_EraseRootFromParent_Done,
      // Label 10820: @682118
      GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(682196), // Rule ID 14488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14488,
        GIR_EraseRootFromParent_Done,
      // Label 10821: @682196
      GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(682274), // Rule ID 14489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14489,
        GIR_EraseRootFromParent_Done,
      // Label 10822: @682274
      GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(682352), // Rule ID 14492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14492,
        GIR_EraseRootFromParent_Done,
      // Label 10823: @682352
      GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(682430), // Rule ID 14493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14493,
        GIR_EraseRootFromParent_Done,
      // Label 10824: @682430
      GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(682508), // Rule ID 14496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14496,
        GIR_EraseRootFromParent_Done,
      // Label 10825: @682508
      GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(682586), // Rule ID 14497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14497,
        GIR_EraseRootFromParent_Done,
      // Label 10826: @682586
      GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(682664), // Rule ID 14500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14500,
        GIR_EraseRootFromParent_Done,
      // Label 10827: @682664
      GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(682742), // Rule ID 14501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14501,
        GIR_EraseRootFromParent_Done,
      // Label 10828: @682742
      GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(682820), // Rule ID 14504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14504,
        GIR_EraseRootFromParent_Done,
      // Label 10829: @682820
      GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(682898), // Rule ID 14505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14505,
        GIR_EraseRootFromParent_Done,
      // Label 10830: @682898
      GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(682976), // Rule ID 14508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14508,
        GIR_EraseRootFromParent_Done,
      // Label 10831: @682976
      GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(683054), // Rule ID 14509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14509,
        GIR_EraseRootFromParent_Done,
      // Label 10832: @683054
      GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(683132), // Rule ID 14512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14512,
        GIR_EraseRootFromParent_Done,
      // Label 10833: @683132
      GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(683210), // Rule ID 14513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14513,
        GIR_EraseRootFromParent_Done,
      // Label 10834: @683210
      GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(683288), // Rule ID 14516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14516,
        GIR_EraseRootFromParent_Done,
      // Label 10835: @683288
      GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(683366), // Rule ID 14517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14517,
        GIR_EraseRootFromParent_Done,
      // Label 10836: @683366
      GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(683444), // Rule ID 14520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14520,
        GIR_EraseRootFromParent_Done,
      // Label 10837: @683444
      GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(683522), // Rule ID 14521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14521,
        GIR_EraseRootFromParent_Done,
      // Label 10838: @683522
      GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(683600), // Rule ID 14524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14524,
        GIR_EraseRootFromParent_Done,
      // Label 10839: @683600
      GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(683678), // Rule ID 14525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14525,
        GIR_EraseRootFromParent_Done,
      // Label 10840: @683678
      GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(683756), // Rule ID 14528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14528,
        GIR_EraseRootFromParent_Done,
      // Label 10841: @683756
      GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(683834), // Rule ID 14529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14529,
        GIR_EraseRootFromParent_Done,
      // Label 10842: @683834
      GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(683912), // Rule ID 14532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14532,
        GIR_EraseRootFromParent_Done,
      // Label 10843: @683912
      GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(683990), // Rule ID 14533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14533,
        GIR_EraseRootFromParent_Done,
      // Label 10844: @683990
      GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(684068), // Rule ID 14536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14536,
        GIR_EraseRootFromParent_Done,
      // Label 10845: @684068
      GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(684146), // Rule ID 14537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14537,
        GIR_EraseRootFromParent_Done,
      // Label 10846: @684146
      GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(684224), // Rule ID 14540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14540,
        GIR_EraseRootFromParent_Done,
      // Label 10847: @684224
      GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(684302), // Rule ID 14541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14541,
        GIR_EraseRootFromParent_Done,
      // Label 10848: @684302
      GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(684380), // Rule ID 14544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14544,
        GIR_EraseRootFromParent_Done,
      // Label 10849: @684380
      GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(684458), // Rule ID 14545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11226:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14545,
        GIR_EraseRootFromParent_Done,
      // Label 10850: @684458
      GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(684536), // Rule ID 14548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14548,
        GIR_EraseRootFromParent_Done,
      // Label 10851: @684536
      GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(684614), // Rule ID 14549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14549,
        GIR_EraseRootFromParent_Done,
      // Label 10852: @684614
      GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(684692), // Rule ID 14552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14552,
        GIR_EraseRootFromParent_Done,
      // Label 10853: @684692
      GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(684770), // Rule ID 14553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14553,
        GIR_EraseRootFromParent_Done,
      // Label 10854: @684770
      GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(684848), // Rule ID 14556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14556,
        GIR_EraseRootFromParent_Done,
      // Label 10855: @684848
      GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(684926), // Rule ID 14557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14557,
        GIR_EraseRootFromParent_Done,
      // Label 10856: @684926
      GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(685004), // Rule ID 14560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14560,
        GIR_EraseRootFromParent_Done,
      // Label 10857: @685004
      GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(685082), // Rule ID 14561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14561,
        GIR_EraseRootFromParent_Done,
      // Label 10858: @685082
      GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(685160), // Rule ID 14564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14564,
        GIR_EraseRootFromParent_Done,
      // Label 10859: @685160
      GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(685238), // Rule ID 14565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14565,
        GIR_EraseRootFromParent_Done,
      // Label 10860: @685238
      GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(685316), // Rule ID 14568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14568,
        GIR_EraseRootFromParent_Done,
      // Label 10861: @685316
      GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(685394), // Rule ID 14569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14569,
        GIR_EraseRootFromParent_Done,
      // Label 10862: @685394
      GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(685472), // Rule ID 14572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14572,
        GIR_EraseRootFromParent_Done,
      // Label 10863: @685472
      GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(685550), // Rule ID 14573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14573,
        GIR_EraseRootFromParent_Done,
      // Label 10864: @685550
      GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(685628), // Rule ID 14576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14576,
        GIR_EraseRootFromParent_Done,
      // Label 10865: @685628
      GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(685706), // Rule ID 14577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14577,
        GIR_EraseRootFromParent_Done,
      // Label 10866: @685706
      GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(685784), // Rule ID 14580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14580,
        GIR_EraseRootFromParent_Done,
      // Label 10867: @685784
      GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(685862), // Rule ID 14581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14581,
        GIR_EraseRootFromParent_Done,
      // Label 10868: @685862
      GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(685940), // Rule ID 14584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14584,
        GIR_EraseRootFromParent_Done,
      // Label 10869: @685940
      GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(686018), // Rule ID 14585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14585,
        GIR_EraseRootFromParent_Done,
      // Label 10870: @686018
      GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(686096), // Rule ID 14588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14588,
        GIR_EraseRootFromParent_Done,
      // Label 10871: @686096
      GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(686174), // Rule ID 14589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14589,
        GIR_EraseRootFromParent_Done,
      // Label 10872: @686174
      GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(686252), // Rule ID 14592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14592,
        GIR_EraseRootFromParent_Done,
      // Label 10873: @686252
      GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(686330), // Rule ID 14593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14593,
        GIR_EraseRootFromParent_Done,
      // Label 10874: @686330
      GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(686408), // Rule ID 14596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14596,
        GIR_EraseRootFromParent_Done,
      // Label 10875: @686408
      GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(686486), // Rule ID 14597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14597,
        GIR_EraseRootFromParent_Done,
      // Label 10876: @686486
      GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(686564), // Rule ID 14600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14600,
        GIR_EraseRootFromParent_Done,
      // Label 10877: @686564
      GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(686642), // Rule ID 14601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14601,
        GIR_EraseRootFromParent_Done,
      // Label 10878: @686642
      GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(686720), // Rule ID 14604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14604,
        GIR_EraseRootFromParent_Done,
      // Label 10879: @686720
      GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(686798), // Rule ID 14605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14605,
        GIR_EraseRootFromParent_Done,
      // Label 10880: @686798
      GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(686876), // Rule ID 14608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14608,
        GIR_EraseRootFromParent_Done,
      // Label 10881: @686876
      GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(686954), // Rule ID 14609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14609,
        GIR_EraseRootFromParent_Done,
      // Label 10882: @686954
      GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(687032), // Rule ID 14612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14612,
        GIR_EraseRootFromParent_Done,
      // Label 10883: @687032
      GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(687110), // Rule ID 14613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14613,
        GIR_EraseRootFromParent_Done,
      // Label 10884: @687110
      GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(687188), // Rule ID 14616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14616,
        GIR_EraseRootFromParent_Done,
      // Label 10885: @687188
      GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(687266), // Rule ID 14617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14617,
        GIR_EraseRootFromParent_Done,
      // Label 10886: @687266
      GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(687344), // Rule ID 14620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14620,
        GIR_EraseRootFromParent_Done,
      // Label 10887: @687344
      GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(687422), // Rule ID 14621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14621,
        GIR_EraseRootFromParent_Done,
      // Label 10888: @687422
      GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(687500), // Rule ID 14624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14624,
        GIR_EraseRootFromParent_Done,
      // Label 10889: @687500
      GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(687578), // Rule ID 14625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14625,
        GIR_EraseRootFromParent_Done,
      // Label 10890: @687578
      GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(687656), // Rule ID 14628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14628,
        GIR_EraseRootFromParent_Done,
      // Label 10891: @687656
      GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(687734), // Rule ID 14629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14629,
        GIR_EraseRootFromParent_Done,
      // Label 10892: @687734
      GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(687812), // Rule ID 14632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14632,
        GIR_EraseRootFromParent_Done,
      // Label 10893: @687812
      GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(687890), // Rule ID 14633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14633,
        GIR_EraseRootFromParent_Done,
      // Label 10894: @687890
      GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(687968), // Rule ID 14636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14636,
        GIR_EraseRootFromParent_Done,
      // Label 10895: @687968
      GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(688046), // Rule ID 14637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14637,
        GIR_EraseRootFromParent_Done,
      // Label 10896: @688046
      GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(688124), // Rule ID 14640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14640,
        GIR_EraseRootFromParent_Done,
      // Label 10897: @688124
      GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(688202), // Rule ID 14641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14641,
        GIR_EraseRootFromParent_Done,
      // Label 10898: @688202
      GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(688280), // Rule ID 14644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14644,
        GIR_EraseRootFromParent_Done,
      // Label 10899: @688280
      GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(688358), // Rule ID 14645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14645,
        GIR_EraseRootFromParent_Done,
      // Label 10900: @688358
      GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(688436), // Rule ID 14648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14648,
        GIR_EraseRootFromParent_Done,
      // Label 10901: @688436
      GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(688514), // Rule ID 14649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14649,
        GIR_EraseRootFromParent_Done,
      // Label 10902: @688514
      GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(688592), // Rule ID 14652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14652,
        GIR_EraseRootFromParent_Done,
      // Label 10903: @688592
      GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(688670), // Rule ID 14653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14653,
        GIR_EraseRootFromParent_Done,
      // Label 10904: @688670
      GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(688748), // Rule ID 14656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14656,
        GIR_EraseRootFromParent_Done,
      // Label 10905: @688748
      GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(688826), // Rule ID 14657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14657,
        GIR_EraseRootFromParent_Done,
      // Label 10906: @688826
      GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(688904), // Rule ID 14660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14660,
        GIR_EraseRootFromParent_Done,
      // Label 10907: @688904
      GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(688982), // Rule ID 14661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14661,
        GIR_EraseRootFromParent_Done,
      // Label 10908: @688982
      GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(689060), // Rule ID 14664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14664,
        GIR_EraseRootFromParent_Done,
      // Label 10909: @689060
      GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(689138), // Rule ID 14665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14665,
        GIR_EraseRootFromParent_Done,
      // Label 10910: @689138
      GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(689216), // Rule ID 14668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14668,
        GIR_EraseRootFromParent_Done,
      // Label 10911: @689216
      GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(689294), // Rule ID 14669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14669,
        GIR_EraseRootFromParent_Done,
      // Label 10912: @689294
      GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(689372), // Rule ID 14672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14672,
        GIR_EraseRootFromParent_Done,
      // Label 10913: @689372
      GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(689450), // Rule ID 14673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14673,
        GIR_EraseRootFromParent_Done,
      // Label 10914: @689450
      GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(689528), // Rule ID 14676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14676,
        GIR_EraseRootFromParent_Done,
      // Label 10915: @689528
      GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(689606), // Rule ID 14677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14677,
        GIR_EraseRootFromParent_Done,
      // Label 10916: @689606
      GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(689684), // Rule ID 14680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14680,
        GIR_EraseRootFromParent_Done,
      // Label 10917: @689684
      GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(689762), // Rule ID 14681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14681,
        GIR_EraseRootFromParent_Done,
      // Label 10918: @689762
      GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(689840), // Rule ID 14684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14684,
        GIR_EraseRootFromParent_Done,
      // Label 10919: @689840
      GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(689918), // Rule ID 14685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14685,
        GIR_EraseRootFromParent_Done,
      // Label 10920: @689918
      GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(689996), // Rule ID 14688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14688,
        GIR_EraseRootFromParent_Done,
      // Label 10921: @689996
      GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(690074), // Rule ID 14689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14689,
        GIR_EraseRootFromParent_Done,
      // Label 10922: @690074
      GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(690152), // Rule ID 14692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14692,
        GIR_EraseRootFromParent_Done,
      // Label 10923: @690152
      GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(690230), // Rule ID 14693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14693,
        GIR_EraseRootFromParent_Done,
      // Label 10924: @690230
      GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(690308), // Rule ID 14696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14696,
        GIR_EraseRootFromParent_Done,
      // Label 10925: @690308
      GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(690386), // Rule ID 14697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14697,
        GIR_EraseRootFromParent_Done,
      // Label 10926: @690386
      GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(690464), // Rule ID 14700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14700,
        GIR_EraseRootFromParent_Done,
      // Label 10927: @690464
      GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(690542), // Rule ID 14701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14701,
        GIR_EraseRootFromParent_Done,
      // Label 10928: @690542
      GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(690620), // Rule ID 14704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14704,
        GIR_EraseRootFromParent_Done,
      // Label 10929: @690620
      GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(690698), // Rule ID 14705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14705,
        GIR_EraseRootFromParent_Done,
      // Label 10930: @690698
      GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(690776), // Rule ID 14708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14708,
        GIR_EraseRootFromParent_Done,
      // Label 10931: @690776
      GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(690854), // Rule ID 14709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14709,
        GIR_EraseRootFromParent_Done,
      // Label 10932: @690854
      GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(690932), // Rule ID 14712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14712,
        GIR_EraseRootFromParent_Done,
      // Label 10933: @690932
      GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(691010), // Rule ID 14713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14713,
        GIR_EraseRootFromParent_Done,
      // Label 10934: @691010
      GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(691088), // Rule ID 14716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14716,
        GIR_EraseRootFromParent_Done,
      // Label 10935: @691088
      GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(691166), // Rule ID 14717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14717,
        GIR_EraseRootFromParent_Done,
      // Label 10936: @691166
      GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(691244), // Rule ID 14720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14720,
        GIR_EraseRootFromParent_Done,
      // Label 10937: @691244
      GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(691322), // Rule ID 14721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11224:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14721,
        GIR_EraseRootFromParent_Done,
      // Label 10938: @691322
      GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(691400), // Rule ID 14724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14724,
        GIR_EraseRootFromParent_Done,
      // Label 10939: @691400
      GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(691478), // Rule ID 14725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14725,
        GIR_EraseRootFromParent_Done,
      // Label 10940: @691478
      GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(691556), // Rule ID 14728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14728,
        GIR_EraseRootFromParent_Done,
      // Label 10941: @691556
      GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(691634), // Rule ID 14729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14729,
        GIR_EraseRootFromParent_Done,
      // Label 10942: @691634
      GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(691712), // Rule ID 14732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14732,
        GIR_EraseRootFromParent_Done,
      // Label 10943: @691712
      GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(691790), // Rule ID 14733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14733,
        GIR_EraseRootFromParent_Done,
      // Label 10944: @691790
      GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(691868), // Rule ID 14736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14736,
        GIR_EraseRootFromParent_Done,
      // Label 10945: @691868
      GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(691946), // Rule ID 14737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14737,
        GIR_EraseRootFromParent_Done,
      // Label 10946: @691946
      GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(692024), // Rule ID 14740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14740,
        GIR_EraseRootFromParent_Done,
      // Label 10947: @692024
      GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(692102), // Rule ID 14741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14741,
        GIR_EraseRootFromParent_Done,
      // Label 10948: @692102
      GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(692180), // Rule ID 14744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14744,
        GIR_EraseRootFromParent_Done,
      // Label 10949: @692180
      GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(692258), // Rule ID 14745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14745,
        GIR_EraseRootFromParent_Done,
      // Label 10950: @692258
      GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(692336), // Rule ID 14748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14748,
        GIR_EraseRootFromParent_Done,
      // Label 10951: @692336
      GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(692414), // Rule ID 14749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14749,
        GIR_EraseRootFromParent_Done,
      // Label 10952: @692414
      GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(692492), // Rule ID 14752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14752,
        GIR_EraseRootFromParent_Done,
      // Label 10953: @692492
      GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(692570), // Rule ID 14753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14753,
        GIR_EraseRootFromParent_Done,
      // Label 10954: @692570
      GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(692648), // Rule ID 14756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14756,
        GIR_EraseRootFromParent_Done,
      // Label 10955: @692648
      GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(692726), // Rule ID 14757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14757,
        GIR_EraseRootFromParent_Done,
      // Label 10956: @692726
      GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(692804), // Rule ID 14760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14760,
        GIR_EraseRootFromParent_Done,
      // Label 10957: @692804
      GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(692882), // Rule ID 14761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14761,
        GIR_EraseRootFromParent_Done,
      // Label 10958: @692882
      GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(692960), // Rule ID 14764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14764,
        GIR_EraseRootFromParent_Done,
      // Label 10959: @692960
      GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(693038), // Rule ID 14765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14765,
        GIR_EraseRootFromParent_Done,
      // Label 10960: @693038
      GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(693116), // Rule ID 14768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14768,
        GIR_EraseRootFromParent_Done,
      // Label 10961: @693116
      GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(693194), // Rule ID 14769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14769,
        GIR_EraseRootFromParent_Done,
      // Label 10962: @693194
      GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(693272), // Rule ID 14772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14772,
        GIR_EraseRootFromParent_Done,
      // Label 10963: @693272
      GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(693350), // Rule ID 14773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14773,
        GIR_EraseRootFromParent_Done,
      // Label 10964: @693350
      GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(693428), // Rule ID 14776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14776,
        GIR_EraseRootFromParent_Done,
      // Label 10965: @693428
      GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(693506), // Rule ID 14777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14777,
        GIR_EraseRootFromParent_Done,
      // Label 10966: @693506
      GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(693584), // Rule ID 14780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14780,
        GIR_EraseRootFromParent_Done,
      // Label 10967: @693584
      GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(693662), // Rule ID 14781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14781,
        GIR_EraseRootFromParent_Done,
      // Label 10968: @693662
      GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(693737), // Rule ID 19022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19022,
        GIR_EraseRootFromParent_Done,
      // Label 10969: @693737
      GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(693812), // Rule ID 19023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19023,
        GIR_EraseRootFromParent_Done,
      // Label 10970: @693812
      GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(693887), // Rule ID 19026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19026,
        GIR_EraseRootFromParent_Done,
      // Label 10971: @693887
      GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(693962), // Rule ID 19027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19027,
        GIR_EraseRootFromParent_Done,
      // Label 10972: @693962
      GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(694037), // Rule ID 19030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19030,
        GIR_EraseRootFromParent_Done,
      // Label 10973: @694037
      GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(694112), // Rule ID 19031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19031,
        GIR_EraseRootFromParent_Done,
      // Label 10974: @694112
      GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(694187), // Rule ID 19034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19034,
        GIR_EraseRootFromParent_Done,
      // Label 10975: @694187
      GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(694262), // Rule ID 19035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19035,
        GIR_EraseRootFromParent_Done,
      // Label 10976: @694262
      GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(694337), // Rule ID 19038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19038,
        GIR_EraseRootFromParent_Done,
      // Label 10977: @694337
      GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(694412), // Rule ID 19039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19039,
        GIR_EraseRootFromParent_Done,
      // Label 10978: @694412
      GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(694487), // Rule ID 19042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19042,
        GIR_EraseRootFromParent_Done,
      // Label 10979: @694487
      GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(694562), // Rule ID 19043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19043,
        GIR_EraseRootFromParent_Done,
      // Label 10980: @694562
      GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(694637), // Rule ID 19046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19046,
        GIR_EraseRootFromParent_Done,
      // Label 10981: @694637
      GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(694712), // Rule ID 19047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19047,
        GIR_EraseRootFromParent_Done,
      // Label 10982: @694712
      GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(694787), // Rule ID 19050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19050,
        GIR_EraseRootFromParent_Done,
      // Label 10983: @694787
      GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(694862), // Rule ID 19051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19051,
        GIR_EraseRootFromParent_Done,
      // Label 10984: @694862
      GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(694937), // Rule ID 19054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19054,
        GIR_EraseRootFromParent_Done,
      // Label 10985: @694937
      GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(695012), // Rule ID 19055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19055,
        GIR_EraseRootFromParent_Done,
      // Label 10986: @695012
      GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(695087), // Rule ID 19058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19058,
        GIR_EraseRootFromParent_Done,
      // Label 10987: @695087
      GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(695162), // Rule ID 19059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19059,
        GIR_EraseRootFromParent_Done,
      // Label 10988: @695162
      GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(695237), // Rule ID 19062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19062,
        GIR_EraseRootFromParent_Done,
      // Label 10989: @695237
      GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(695312), // Rule ID 19063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19063,
        GIR_EraseRootFromParent_Done,
      // Label 10990: @695312
      GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(695387), // Rule ID 19066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19066,
        GIR_EraseRootFromParent_Done,
      // Label 10991: @695387
      GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(695462), // Rule ID 19067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19067,
        GIR_EraseRootFromParent_Done,
      // Label 10992: @695462
      GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(695537), // Rule ID 19070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19070,
        GIR_EraseRootFromParent_Done,
      // Label 10993: @695537
      GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(695612), // Rule ID 19071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19071,
        GIR_EraseRootFromParent_Done,
      // Label 10994: @695612
      GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(695687), // Rule ID 19074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19074,
        GIR_EraseRootFromParent_Done,
      // Label 10995: @695687
      GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(695762), // Rule ID 19075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19075,
        GIR_EraseRootFromParent_Done,
      // Label 10996: @695762
      GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(695837), // Rule ID 19078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19078,
        GIR_EraseRootFromParent_Done,
      // Label 10997: @695837
      GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(695912), // Rule ID 19079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19079,
        GIR_EraseRootFromParent_Done,
      // Label 10998: @695912
      GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(695987), // Rule ID 19082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19082,
        GIR_EraseRootFromParent_Done,
      // Label 10999: @695987
      GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(696062), // Rule ID 19083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19083,
        GIR_EraseRootFromParent_Done,
      // Label 11000: @696062
      GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(696137), // Rule ID 19086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19086,
        GIR_EraseRootFromParent_Done,
      // Label 11001: @696137
      GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(696212), // Rule ID 19087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19087,
        GIR_EraseRootFromParent_Done,
      // Label 11002: @696212
      GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(696287), // Rule ID 19090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19090,
        GIR_EraseRootFromParent_Done,
      // Label 11003: @696287
      GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(696362), // Rule ID 19091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19091,
        GIR_EraseRootFromParent_Done,
      // Label 11004: @696362
      GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(696437), // Rule ID 19094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19094,
        GIR_EraseRootFromParent_Done,
      // Label 11005: @696437
      GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(696512), // Rule ID 19095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10819:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19095,
        GIR_EraseRootFromParent_Done,
      // Label 11006: @696512
      GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(696587), // Rule ID 19098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19098,
        GIR_EraseRootFromParent_Done,
      // Label 11007: @696587
      GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(696662), // Rule ID 19099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10819:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19099,
        GIR_EraseRootFromParent_Done,
      // Label 11008: @696662
      GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(696737), // Rule ID 19102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19102,
        GIR_EraseRootFromParent_Done,
      // Label 11009: @696737
      GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(696812), // Rule ID 19103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10819:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19103,
        GIR_EraseRootFromParent_Done,
      // Label 11010: @696812
      GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(696887), // Rule ID 19106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19106,
        GIR_EraseRootFromParent_Done,
      // Label 11011: @696887
      GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(696962), // Rule ID 19107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19107,
        GIR_EraseRootFromParent_Done,
      // Label 11012: @696962
      GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(697037), // Rule ID 19110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19110,
        GIR_EraseRootFromParent_Done,
      // Label 11013: @697037
      GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(697112), // Rule ID 19111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19111,
        GIR_EraseRootFromParent_Done,
      // Label 11014: @697112
      GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(697187), // Rule ID 19114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19114,
        GIR_EraseRootFromParent_Done,
      // Label 11015: @697187
      GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(697262), // Rule ID 19115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19115,
        GIR_EraseRootFromParent_Done,
      // Label 11016: @697262
      GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(697337), // Rule ID 19118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19118,
        GIR_EraseRootFromParent_Done,
      // Label 11017: @697337
      GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(697412), // Rule ID 19119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19119,
        GIR_EraseRootFromParent_Done,
      // Label 11018: @697412
      GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(697487), // Rule ID 19122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19122,
        GIR_EraseRootFromParent_Done,
      // Label 11019: @697487
      GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(697562), // Rule ID 19123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19123,
        GIR_EraseRootFromParent_Done,
      // Label 11020: @697562
      GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(697637), // Rule ID 19126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19126,
        GIR_EraseRootFromParent_Done,
      // Label 11021: @697637
      GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(697712), // Rule ID 19127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19127,
        GIR_EraseRootFromParent_Done,
      // Label 11022: @697712
      GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(697787), // Rule ID 19130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19130,
        GIR_EraseRootFromParent_Done,
      // Label 11023: @697787
      GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(697862), // Rule ID 19131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10819:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19131,
        GIR_EraseRootFromParent_Done,
      // Label 11024: @697862
      GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(697937), // Rule ID 19134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19134,
        GIR_EraseRootFromParent_Done,
      // Label 11025: @697937
      GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(698012), // Rule ID 19135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10819:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19135,
        GIR_EraseRootFromParent_Done,
      // Label 11026: @698012
      GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(698087), // Rule ID 19138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19138,
        GIR_EraseRootFromParent_Done,
      // Label 11027: @698087
      GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(698162), // Rule ID 19139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10819:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19139,
        GIR_EraseRootFromParent_Done,
      // Label 11028: @698162
      GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(698237), // Rule ID 19142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19142,
        GIR_EraseRootFromParent_Done,
      // Label 11029: @698237
      GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(698312), // Rule ID 19143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19143,
        GIR_EraseRootFromParent_Done,
      // Label 11030: @698312
      GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(698387), // Rule ID 19146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19146,
        GIR_EraseRootFromParent_Done,
      // Label 11031: @698387
      GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(698462), // Rule ID 19147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19147,
        GIR_EraseRootFromParent_Done,
      // Label 11032: @698462
      GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(698537), // Rule ID 19150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19150,
        GIR_EraseRootFromParent_Done,
      // Label 11033: @698537
      GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(698612), // Rule ID 19151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19151,
        GIR_EraseRootFromParent_Done,
      // Label 11034: @698612
      GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(698687), // Rule ID 19154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19154,
        GIR_EraseRootFromParent_Done,
      // Label 11035: @698687
      GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(698762), // Rule ID 19155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19155,
        GIR_EraseRootFromParent_Done,
      // Label 11036: @698762
      GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(698837), // Rule ID 19158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10816:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19158,
        GIR_EraseRootFromParent_Done,
      // Label 11037: @698837
      GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(698912), // Rule ID 19159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10816:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19159,
        GIR_EraseRootFromParent_Done,
      // Label 11038: @698912
      GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(698987), // Rule ID 19162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19162,
        GIR_EraseRootFromParent_Done,
      // Label 11039: @698987
      GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(699062), // Rule ID 19163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19163,
        GIR_EraseRootFromParent_Done,
      // Label 11040: @699062
      GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(699137), // Rule ID 19166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19166,
        GIR_EraseRootFromParent_Done,
      // Label 11041: @699137
      GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(699212), // Rule ID 19167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19167,
        GIR_EraseRootFromParent_Done,
      // Label 11042: @699212
      GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(699287), // Rule ID 19170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19170,
        GIR_EraseRootFromParent_Done,
      // Label 11043: @699287
      GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(699362), // Rule ID 19171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19171,
        GIR_EraseRootFromParent_Done,
      // Label 11044: @699362
      GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(699437), // Rule ID 19174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19174,
        GIR_EraseRootFromParent_Done,
      // Label 11045: @699437
      GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(699512), // Rule ID 19175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19175,
        GIR_EraseRootFromParent_Done,
      // Label 11046: @699512
      GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(699587), // Rule ID 19178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19178,
        GIR_EraseRootFromParent_Done,
      // Label 11047: @699587
      GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(699662), // Rule ID 19179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19179,
        GIR_EraseRootFromParent_Done,
      // Label 11048: @699662
      GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(699737), // Rule ID 19182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19182,
        GIR_EraseRootFromParent_Done,
      // Label 11049: @699737
      GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(699812), // Rule ID 19183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19183,
        GIR_EraseRootFromParent_Done,
      // Label 11050: @699812
      GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(699887), // Rule ID 19186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19186,
        GIR_EraseRootFromParent_Done,
      // Label 11051: @699887
      GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(699962), // Rule ID 19187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19187,
        GIR_EraseRootFromParent_Done,
      // Label 11052: @699962
      GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(700037), // Rule ID 19190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19190,
        GIR_EraseRootFromParent_Done,
      // Label 11053: @700037
      GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(700112), // Rule ID 19191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19191,
        GIR_EraseRootFromParent_Done,
      // Label 11054: @700112
      GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(700187), // Rule ID 19194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19194,
        GIR_EraseRootFromParent_Done,
      // Label 11055: @700187
      GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(700262), // Rule ID 19195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19195,
        GIR_EraseRootFromParent_Done,
      // Label 11056: @700262
      GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(700337), // Rule ID 19198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19198,
        GIR_EraseRootFromParent_Done,
      // Label 11057: @700337
      GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(700412), // Rule ID 19199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19199,
        GIR_EraseRootFromParent_Done,
      // Label 11058: @700412
      GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(700487), // Rule ID 19202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19202,
        GIR_EraseRootFromParent_Done,
      // Label 11059: @700487
      GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(700562), // Rule ID 19203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19203,
        GIR_EraseRootFromParent_Done,
      // Label 11060: @700562
      GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(700637), // Rule ID 19206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19206,
        GIR_EraseRootFromParent_Done,
      // Label 11061: @700637
      GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(700712), // Rule ID 19207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19207,
        GIR_EraseRootFromParent_Done,
      // Label 11062: @700712
      GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(700787), // Rule ID 19210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19210,
        GIR_EraseRootFromParent_Done,
      // Label 11063: @700787
      GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(700862), // Rule ID 19211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19211,
        GIR_EraseRootFromParent_Done,
      // Label 11064: @700862
      GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(700937), // Rule ID 19214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19214,
        GIR_EraseRootFromParent_Done,
      // Label 11065: @700937
      GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(701012), // Rule ID 19215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10816:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19215,
        GIR_EraseRootFromParent_Done,
      // Label 11066: @701012
      GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(701087), // Rule ID 19218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10816:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19218,
        GIR_EraseRootFromParent_Done,
      // Label 11067: @701087
      GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(701162), // Rule ID 19219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10816:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19219,
        GIR_EraseRootFromParent_Done,
      // Label 11068: @701162
      GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(701237), // Rule ID 19222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19222,
        GIR_EraseRootFromParent_Done,
      // Label 11069: @701237
      GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(701312), // Rule ID 19223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10816:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19223,
        GIR_EraseRootFromParent_Done,
      // Label 11070: @701312
      GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(701387), // Rule ID 19226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19226,
        GIR_EraseRootFromParent_Done,
      // Label 11071: @701387
      GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(701462), // Rule ID 19227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19227,
        GIR_EraseRootFromParent_Done,
      // Label 11072: @701462
      GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(701537), // Rule ID 19230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19230,
        GIR_EraseRootFromParent_Done,
      // Label 11073: @701537
      GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(701612), // Rule ID 19231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19231,
        GIR_EraseRootFromParent_Done,
      // Label 11074: @701612
      GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(701687), // Rule ID 19234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19234,
        GIR_EraseRootFromParent_Done,
      // Label 11075: @701687
      GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(701762), // Rule ID 19235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19235,
        GIR_EraseRootFromParent_Done,
      // Label 11076: @701762
      GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(701837), // Rule ID 19238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19238,
        GIR_EraseRootFromParent_Done,
      // Label 11077: @701837
      GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(701912), // Rule ID 19239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19239,
        GIR_EraseRootFromParent_Done,
      // Label 11078: @701912
      GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(701987), // Rule ID 19242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19242,
        GIR_EraseRootFromParent_Done,
      // Label 11079: @701987
      GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(702062), // Rule ID 19243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19243,
        GIR_EraseRootFromParent_Done,
      // Label 11080: @702062
      GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(702137), // Rule ID 19246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19246,
        GIR_EraseRootFromParent_Done,
      // Label 11081: @702137
      GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(702212), // Rule ID 19247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19247,
        GIR_EraseRootFromParent_Done,
      // Label 11082: @702212
      GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(702287), // Rule ID 19250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19250,
        GIR_EraseRootFromParent_Done,
      // Label 11083: @702287
      GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(702362), // Rule ID 19251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10816:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19251,
        GIR_EraseRootFromParent_Done,
      // Label 11084: @702362
      GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(702437), // Rule ID 19254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19254,
        GIR_EraseRootFromParent_Done,
      // Label 11085: @702437
      GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(702512), // Rule ID 19255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10816:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19255,
        GIR_EraseRootFromParent_Done,
      // Label 11086: @702512
      GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(702587), // Rule ID 19258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19258,
        GIR_EraseRootFromParent_Done,
      // Label 11087: @702587
      GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(702662), // Rule ID 19259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10816:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19259,
        GIR_EraseRootFromParent_Done,
      // Label 11088: @702662
      GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(702737), // Rule ID 19262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19262,
        GIR_EraseRootFromParent_Done,
      // Label 11089: @702737
      GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(702812), // Rule ID 19263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19263,
        GIR_EraseRootFromParent_Done,
      // Label 11090: @702812
      GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(702887), // Rule ID 19266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19266,
        GIR_EraseRootFromParent_Done,
      // Label 11091: @702887
      GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(702962), // Rule ID 19267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19267,
        GIR_EraseRootFromParent_Done,
      // Label 11092: @702962
      GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(703037), // Rule ID 19270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19270,
        GIR_EraseRootFromParent_Done,
      // Label 11093: @703037
      GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(703112), // Rule ID 19271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19271,
        GIR_EraseRootFromParent_Done,
      // Label 11094: @703112
      GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(703187), // Rule ID 19274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19274,
        GIR_EraseRootFromParent_Done,
      // Label 11095: @703187
      GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(703262), // Rule ID 19275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19275,
        GIR_EraseRootFromParent_Done,
      // Label 11096: @703262
      GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(703337), // Rule ID 19278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19278,
        GIR_EraseRootFromParent_Done,
      // Label 11097: @703337
      GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(703412), // Rule ID 19279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19279,
        GIR_EraseRootFromParent_Done,
      // Label 11098: @703412
      GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(703487), // Rule ID 19282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19282,
        GIR_EraseRootFromParent_Done,
      // Label 11099: @703487
      GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(703562), // Rule ID 19283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19283,
        GIR_EraseRootFromParent_Done,
      // Label 11100: @703562
      GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(703637), // Rule ID 19286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19286,
        GIR_EraseRootFromParent_Done,
      // Label 11101: @703637
      GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(703712), // Rule ID 19287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19287,
        GIR_EraseRootFromParent_Done,
      // Label 11102: @703712
      GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(703787), // Rule ID 19290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19290,
        GIR_EraseRootFromParent_Done,
      // Label 11103: @703787
      GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(703862), // Rule ID 19291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19291,
        GIR_EraseRootFromParent_Done,
      // Label 11104: @703862
      GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(703937), // Rule ID 19294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19294,
        GIR_EraseRootFromParent_Done,
      // Label 11105: @703937
      GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(704012), // Rule ID 19295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19295,
        GIR_EraseRootFromParent_Done,
      // Label 11106: @704012
      GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(704087), // Rule ID 19298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19298,
        GIR_EraseRootFromParent_Done,
      // Label 11107: @704087
      GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(704162), // Rule ID 19299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19299,
        GIR_EraseRootFromParent_Done,
      // Label 11108: @704162
      GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(704237), // Rule ID 19302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19302,
        GIR_EraseRootFromParent_Done,
      // Label 11109: @704237
      GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(704312), // Rule ID 19303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19303,
        GIR_EraseRootFromParent_Done,
      // Label 11110: @704312
      GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(704387), // Rule ID 19306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19306,
        GIR_EraseRootFromParent_Done,
      // Label 11111: @704387
      GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(704462), // Rule ID 19307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19307,
        GIR_EraseRootFromParent_Done,
      // Label 11112: @704462
      GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(704537), // Rule ID 19310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19310,
        GIR_EraseRootFromParent_Done,
      // Label 11113: @704537
      GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(704612), // Rule ID 19311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19311,
        GIR_EraseRootFromParent_Done,
      // Label 11114: @704612
      GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(704687), // Rule ID 19314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19314,
        GIR_EraseRootFromParent_Done,
      // Label 11115: @704687
      GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(704762), // Rule ID 19315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19315,
        GIR_EraseRootFromParent_Done,
      // Label 11116: @704762
      GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(704837), // Rule ID 19318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19318,
        GIR_EraseRootFromParent_Done,
      // Label 11117: @704837
      GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(704912), // Rule ID 19319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19319,
        GIR_EraseRootFromParent_Done,
      // Label 11118: @704912
      GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(704987), // Rule ID 19322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19322,
        GIR_EraseRootFromParent_Done,
      // Label 11119: @704987
      GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(705062), // Rule ID 19323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19323,
        GIR_EraseRootFromParent_Done,
      // Label 11120: @705062
      GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(705137), // Rule ID 19326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19326,
        GIR_EraseRootFromParent_Done,
      // Label 11121: @705137
      GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(705212), // Rule ID 19327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19327,
        GIR_EraseRootFromParent_Done,
      // Label 11122: @705212
      GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(705287), // Rule ID 19330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19330,
        GIR_EraseRootFromParent_Done,
      // Label 11123: @705287
      GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(705362), // Rule ID 19331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19331,
        GIR_EraseRootFromParent_Done,
      // Label 11124: @705362
      GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(705437), // Rule ID 19334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19334,
        GIR_EraseRootFromParent_Done,
      // Label 11125: @705437
      GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(705512), // Rule ID 19335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10872:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19335,
        GIR_EraseRootFromParent_Done,
      // Label 11126: @705512
      GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(705587), // Rule ID 19338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19338,
        GIR_EraseRootFromParent_Done,
      // Label 11127: @705587
      GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(705662), // Rule ID 19339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10872:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19339,
        GIR_EraseRootFromParent_Done,
      // Label 11128: @705662
      GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(705737), // Rule ID 19342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19342,
        GIR_EraseRootFromParent_Done,
      // Label 11129: @705737
      GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(705812), // Rule ID 19343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10872:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19343,
        GIR_EraseRootFromParent_Done,
      // Label 11130: @705812
      GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(705887), // Rule ID 19346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19346,
        GIR_EraseRootFromParent_Done,
      // Label 11131: @705887
      GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(705962), // Rule ID 19347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19347,
        GIR_EraseRootFromParent_Done,
      // Label 11132: @705962
      GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(706037), // Rule ID 19350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19350,
        GIR_EraseRootFromParent_Done,
      // Label 11133: @706037
      GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(706112), // Rule ID 19351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19351,
        GIR_EraseRootFromParent_Done,
      // Label 11134: @706112
      GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(706187), // Rule ID 19354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19354,
        GIR_EraseRootFromParent_Done,
      // Label 11135: @706187
      GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(706262), // Rule ID 19355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19355,
        GIR_EraseRootFromParent_Done,
      // Label 11136: @706262
      GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(706337), // Rule ID 19358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19358,
        GIR_EraseRootFromParent_Done,
      // Label 11137: @706337
      GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(706412), // Rule ID 19359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19359,
        GIR_EraseRootFromParent_Done,
      // Label 11138: @706412
      GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(706487), // Rule ID 19362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19362,
        GIR_EraseRootFromParent_Done,
      // Label 11139: @706487
      GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(706562), // Rule ID 19363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19363,
        GIR_EraseRootFromParent_Done,
      // Label 11140: @706562
      GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(706637), // Rule ID 19366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19366,
        GIR_EraseRootFromParent_Done,
      // Label 11141: @706637
      GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(706712), // Rule ID 19367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19367,
        GIR_EraseRootFromParent_Done,
      // Label 11142: @706712
      GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(706787), // Rule ID 19370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19370,
        GIR_EraseRootFromParent_Done,
      // Label 11143: @706787
      GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(706862), // Rule ID 19371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10872:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19371,
        GIR_EraseRootFromParent_Done,
      // Label 11144: @706862
      GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(706937), // Rule ID 19374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19374,
        GIR_EraseRootFromParent_Done,
      // Label 11145: @706937
      GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(707012), // Rule ID 19375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10872:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19375,
        GIR_EraseRootFromParent_Done,
      // Label 11146: @707012
      GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(707087), // Rule ID 19378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19378,
        GIR_EraseRootFromParent_Done,
      // Label 11147: @707087
      GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(707162), // Rule ID 19379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10872:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19379,
        GIR_EraseRootFromParent_Done,
      // Label 11148: @707162
      GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(707237), // Rule ID 19382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19382,
        GIR_EraseRootFromParent_Done,
      // Label 11149: @707237
      GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(707312), // Rule ID 19383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19383,
        GIR_EraseRootFromParent_Done,
      // Label 11150: @707312
      GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(707387), // Rule ID 19386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19386,
        GIR_EraseRootFromParent_Done,
      // Label 11151: @707387
      GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(707462), // Rule ID 19387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19387,
        GIR_EraseRootFromParent_Done,
      // Label 11152: @707462
      GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(707537), // Rule ID 19390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19390,
        GIR_EraseRootFromParent_Done,
      // Label 11153: @707537
      GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(707612), // Rule ID 19391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19391,
        GIR_EraseRootFromParent_Done,
      // Label 11154: @707612
      GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(707687), // Rule ID 19394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19394,
        GIR_EraseRootFromParent_Done,
      // Label 11155: @707687
      GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(707762), // Rule ID 19395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19395,
        GIR_EraseRootFromParent_Done,
      // Label 11156: @707762
      GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(707837), // Rule ID 19398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19398,
        GIR_EraseRootFromParent_Done,
      // Label 11157: @707837
      GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(707912), // Rule ID 19399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19399,
        GIR_EraseRootFromParent_Done,
      // Label 11158: @707912
      GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(707987), // Rule ID 19402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19402,
        GIR_EraseRootFromParent_Done,
      // Label 11159: @707987
      GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(708062), // Rule ID 19403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19403,
        GIR_EraseRootFromParent_Done,
      // Label 11160: @708062
      GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(708137), // Rule ID 19406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19406,
        GIR_EraseRootFromParent_Done,
      // Label 11161: @708137
      GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(708212), // Rule ID 19407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19407,
        GIR_EraseRootFromParent_Done,
      // Label 11162: @708212
      GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(708287), // Rule ID 19410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19410,
        GIR_EraseRootFromParent_Done,
      // Label 11163: @708287
      GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(708362), // Rule ID 19411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19411,
        GIR_EraseRootFromParent_Done,
      // Label 11164: @708362
      GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(708437), // Rule ID 19414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19414,
        GIR_EraseRootFromParent_Done,
      // Label 11165: @708437
      GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(708512), // Rule ID 19415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19415,
        GIR_EraseRootFromParent_Done,
      // Label 11166: @708512
      GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(708587), // Rule ID 19418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19418,
        GIR_EraseRootFromParent_Done,
      // Label 11167: @708587
      GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(708662), // Rule ID 19419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19419,
        GIR_EraseRootFromParent_Done,
      // Label 11168: @708662
      GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(708737), // Rule ID 19422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19422,
        GIR_EraseRootFromParent_Done,
      // Label 11169: @708737
      GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(708812), // Rule ID 19423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19423,
        GIR_EraseRootFromParent_Done,
      // Label 11170: @708812
      GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(708887), // Rule ID 19426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19426,
        GIR_EraseRootFromParent_Done,
      // Label 11171: @708887
      GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(708962), // Rule ID 19427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19427,
        GIR_EraseRootFromParent_Done,
      // Label 11172: @708962
      GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(709037), // Rule ID 19430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19430,
        GIR_EraseRootFromParent_Done,
      // Label 11173: @709037
      GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(709112), // Rule ID 19431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19431,
        GIR_EraseRootFromParent_Done,
      // Label 11174: @709112
      GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(709187), // Rule ID 19434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19434,
        GIR_EraseRootFromParent_Done,
      // Label 11175: @709187
      GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(709262), // Rule ID 19435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19435,
        GIR_EraseRootFromParent_Done,
      // Label 11176: @709262
      GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(709337), // Rule ID 19438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19438,
        GIR_EraseRootFromParent_Done,
      // Label 11177: @709337
      GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(709412), // Rule ID 19439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19439,
        GIR_EraseRootFromParent_Done,
      // Label 11178: @709412
      GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(709487), // Rule ID 19442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19442,
        GIR_EraseRootFromParent_Done,
      // Label 11179: @709487
      GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(709562), // Rule ID 19443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19443,
        GIR_EraseRootFromParent_Done,
      // Label 11180: @709562
      GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(709637), // Rule ID 19446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19446,
        GIR_EraseRootFromParent_Done,
      // Label 11181: @709637
      GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(709712), // Rule ID 19447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19447,
        GIR_EraseRootFromParent_Done,
      // Label 11182: @709712
      GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(709787), // Rule ID 19450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19450,
        GIR_EraseRootFromParent_Done,
      // Label 11183: @709787
      GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(709862), // Rule ID 19451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19451,
        GIR_EraseRootFromParent_Done,
      // Label 11184: @709862
      GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(709937), // Rule ID 19454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19454,
        GIR_EraseRootFromParent_Done,
      // Label 11185: @709937
      GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(710012), // Rule ID 19455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10874:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19455,
        GIR_EraseRootFromParent_Done,
      // Label 11186: @710012
      GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(710087), // Rule ID 19458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19458,
        GIR_EraseRootFromParent_Done,
      // Label 11187: @710087
      GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(710162), // Rule ID 19459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10874:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19459,
        GIR_EraseRootFromParent_Done,
      // Label 11188: @710162
      GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(710237), // Rule ID 19462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19462,
        GIR_EraseRootFromParent_Done,
      // Label 11189: @710237
      GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(710312), // Rule ID 19463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10874:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19463,
        GIR_EraseRootFromParent_Done,
      // Label 11190: @710312
      GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(710387), // Rule ID 19466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19466,
        GIR_EraseRootFromParent_Done,
      // Label 11191: @710387
      GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(710462), // Rule ID 19467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19467,
        GIR_EraseRootFromParent_Done,
      // Label 11192: @710462
      GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(710537), // Rule ID 19470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19470,
        GIR_EraseRootFromParent_Done,
      // Label 11193: @710537
      GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(710612), // Rule ID 19471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19471,
        GIR_EraseRootFromParent_Done,
      // Label 11194: @710612
      GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(710687), // Rule ID 19474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19474,
        GIR_EraseRootFromParent_Done,
      // Label 11195: @710687
      GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(710762), // Rule ID 19475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19475,
        GIR_EraseRootFromParent_Done,
      // Label 11196: @710762
      GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(710837), // Rule ID 19478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19478,
        GIR_EraseRootFromParent_Done,
      // Label 11197: @710837
      GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(710912), // Rule ID 19479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19479,
        GIR_EraseRootFromParent_Done,
      // Label 11198: @710912
      GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(710987), // Rule ID 19482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19482,
        GIR_EraseRootFromParent_Done,
      // Label 11199: @710987
      GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(711062), // Rule ID 19483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19483,
        GIR_EraseRootFromParent_Done,
      // Label 11200: @711062
      GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(711137), // Rule ID 19486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19486,
        GIR_EraseRootFromParent_Done,
      // Label 11201: @711137
      GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(711212), // Rule ID 19487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19487,
        GIR_EraseRootFromParent_Done,
      // Label 11202: @711212
      GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(711287), // Rule ID 19490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19490,
        GIR_EraseRootFromParent_Done,
      // Label 11203: @711287
      GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(711362), // Rule ID 19491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10874:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19491,
        GIR_EraseRootFromParent_Done,
      // Label 11204: @711362
      GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(711437), // Rule ID 19494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19494,
        GIR_EraseRootFromParent_Done,
      // Label 11205: @711437
      GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(711512), // Rule ID 19495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10874:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19495,
        GIR_EraseRootFromParent_Done,
      // Label 11206: @711512
      GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(711587), // Rule ID 19498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19498,
        GIR_EraseRootFromParent_Done,
      // Label 11207: @711587
      GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(711662), // Rule ID 19499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10874:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19499,
        GIR_EraseRootFromParent_Done,
      // Label 11208: @711662
      GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(711737), // Rule ID 19502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19502,
        GIR_EraseRootFromParent_Done,
      // Label 11209: @711737
      GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(711812), // Rule ID 19503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19503,
        GIR_EraseRootFromParent_Done,
      // Label 11210: @711812
      GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(711887), // Rule ID 19506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19506,
        GIR_EraseRootFromParent_Done,
      // Label 11211: @711887
      GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(711962), // Rule ID 19507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19507,
        GIR_EraseRootFromParent_Done,
      // Label 11212: @711962
      GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(712037), // Rule ID 19510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19510,
        GIR_EraseRootFromParent_Done,
      // Label 11213: @712037
      GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(712112), // Rule ID 19511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19511,
        GIR_EraseRootFromParent_Done,
      // Label 11214: @712112
      GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(712187), // Rule ID 19514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19514,
        GIR_EraseRootFromParent_Done,
      // Label 11215: @712187
      GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(712262), // Rule ID 19515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19515,
        GIR_EraseRootFromParent_Done,
      // Label 11216: @712262
      GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(712337), // Rule ID 19518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19518,
        GIR_EraseRootFromParent_Done,
      // Label 11217: @712337
      GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(712412), // Rule ID 19519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19519,
        GIR_EraseRootFromParent_Done,
      // Label 11218: @712412
      GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(712487), // Rule ID 19522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19522,
        GIR_EraseRootFromParent_Done,
      // Label 11219: @712487
      GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(712562), // Rule ID 19523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19523,
        GIR_EraseRootFromParent_Done,
      // Label 11220: @712562
      GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(712637), // Rule ID 19526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19526,
        GIR_EraseRootFromParent_Done,
      // Label 11221: @712637
      GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(712712), // Rule ID 19527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19527,
        GIR_EraseRootFromParent_Done,
      // Label 11222: @712712
      GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(712787), // Rule ID 19530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19530,
        GIR_EraseRootFromParent_Done,
      // Label 11223: @712787
      GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(712862), // Rule ID 19531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19531,
        GIR_EraseRootFromParent_Done,
      // Label 11224: @712862
      GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(712937), // Rule ID 19534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19534,
        GIR_EraseRootFromParent_Done,
      // Label 11225: @712937
      GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(713012), // Rule ID 19535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19535,
        GIR_EraseRootFromParent_Done,
      // Label 11226: @713012
      GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(713087), // Rule ID 19538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19538,
        GIR_EraseRootFromParent_Done,
      // Label 11227: @713087
      GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(713162), // Rule ID 19539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19539,
        GIR_EraseRootFromParent_Done,
      // Label 11228: @713162
      GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(713237), // Rule ID 19542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19542,
        GIR_EraseRootFromParent_Done,
      // Label 11229: @713237
      GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(713312), // Rule ID 19543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19543,
        GIR_EraseRootFromParent_Done,
      // Label 11230: @713312
      GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(713387), // Rule ID 19546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19546,
        GIR_EraseRootFromParent_Done,
      // Label 11231: @713387
      GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(713462), // Rule ID 19547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19547,
        GIR_EraseRootFromParent_Done,
      // Label 11232: @713462
      GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(713537), // Rule ID 19550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19550,
        GIR_EraseRootFromParent_Done,
      // Label 11233: @713537
      GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(713612), // Rule ID 19551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19551,
        GIR_EraseRootFromParent_Done,
      // Label 11234: @713612
      GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(713687), // Rule ID 19554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19554,
        GIR_EraseRootFromParent_Done,
      // Label 11235: @713687
      GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(713762), // Rule ID 19555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19555,
        GIR_EraseRootFromParent_Done,
      // Label 11236: @713762
      GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(713837), // Rule ID 19558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19558,
        GIR_EraseRootFromParent_Done,
      // Label 11237: @713837
      GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(713912), // Rule ID 19559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19559,
        GIR_EraseRootFromParent_Done,
      // Label 11238: @713912
      GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(713987), // Rule ID 19562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19562,
        GIR_EraseRootFromParent_Done,
      // Label 11239: @713987
      GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(714062), // Rule ID 19563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19563,
        GIR_EraseRootFromParent_Done,
      // Label 11240: @714062
      GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(714137), // Rule ID 19566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19566,
        GIR_EraseRootFromParent_Done,
      // Label 11241: @714137
      GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(714212), // Rule ID 19567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19567,
        GIR_EraseRootFromParent_Done,
      // Label 11242: @714212
      GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(714287), // Rule ID 19570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19570,
        GIR_EraseRootFromParent_Done,
      // Label 11243: @714287
      GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(714362), // Rule ID 19571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19571,
        GIR_EraseRootFromParent_Done,
      // Label 11244: @714362
      GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(714437), // Rule ID 19574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19574,
        GIR_EraseRootFromParent_Done,
      // Label 11245: @714437
      GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(714512), // Rule ID 19575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10876:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19575,
        GIR_EraseRootFromParent_Done,
      // Label 11246: @714512
      GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(714587), // Rule ID 19578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19578,
        GIR_EraseRootFromParent_Done,
      // Label 11247: @714587
      GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(714662), // Rule ID 19579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10876:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19579,
        GIR_EraseRootFromParent_Done,
      // Label 11248: @714662
      GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(714737), // Rule ID 19582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19582,
        GIR_EraseRootFromParent_Done,
      // Label 11249: @714737
      GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(714812), // Rule ID 19583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10876:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19583,
        GIR_EraseRootFromParent_Done,
      // Label 11250: @714812
      GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(714887), // Rule ID 19586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19586,
        GIR_EraseRootFromParent_Done,
      // Label 11251: @714887
      GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(714962), // Rule ID 19587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19587,
        GIR_EraseRootFromParent_Done,
      // Label 11252: @714962
      GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(715037), // Rule ID 19590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19590,
        GIR_EraseRootFromParent_Done,
      // Label 11253: @715037
      GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(715112), // Rule ID 19591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19591,
        GIR_EraseRootFromParent_Done,
      // Label 11254: @715112
      GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(715187), // Rule ID 19594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19594,
        GIR_EraseRootFromParent_Done,
      // Label 11255: @715187
      GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(715262), // Rule ID 19595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19595,
        GIR_EraseRootFromParent_Done,
      // Label 11256: @715262
      GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(715337), // Rule ID 19598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19598,
        GIR_EraseRootFromParent_Done,
      // Label 11257: @715337
      GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(715412), // Rule ID 19599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19599,
        GIR_EraseRootFromParent_Done,
      // Label 11258: @715412
      GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(715487), // Rule ID 19602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19602,
        GIR_EraseRootFromParent_Done,
      // Label 11259: @715487
      GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(715562), // Rule ID 19603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19603,
        GIR_EraseRootFromParent_Done,
      // Label 11260: @715562
      GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(715637), // Rule ID 19606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19606,
        GIR_EraseRootFromParent_Done,
      // Label 11261: @715637
      GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(715712), // Rule ID 19607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19607,
        GIR_EraseRootFromParent_Done,
      // Label 11262: @715712
      GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(715787), // Rule ID 19610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19610,
        GIR_EraseRootFromParent_Done,
      // Label 11263: @715787
      GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(715862), // Rule ID 19611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10876:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19611,
        GIR_EraseRootFromParent_Done,
      // Label 11264: @715862
      GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(715937), // Rule ID 19614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19614,
        GIR_EraseRootFromParent_Done,
      // Label 11265: @715937
      GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(716012), // Rule ID 19615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10876:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19615,
        GIR_EraseRootFromParent_Done,
      // Label 11266: @716012
      GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(716087), // Rule ID 19618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19618,
        GIR_EraseRootFromParent_Done,
      // Label 11267: @716087
      GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(716162), // Rule ID 19619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10876:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19619,
        GIR_EraseRootFromParent_Done,
      // Label 11268: @716162
      GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(716237), // Rule ID 21836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21836,
        GIR_EraseRootFromParent_Done,
      // Label 11269: @716237
      GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(716312), // Rule ID 21837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21837,
        GIR_EraseRootFromParent_Done,
      // Label 11270: @716312
      GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(716387), // Rule ID 21840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21840,
        GIR_EraseRootFromParent_Done,
      // Label 11271: @716387
      GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(716462), // Rule ID 21841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21841,
        GIR_EraseRootFromParent_Done,
      // Label 11272: @716462
      GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(716537), // Rule ID 21844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21844,
        GIR_EraseRootFromParent_Done,
      // Label 11273: @716537
      GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(716612), // Rule ID 21845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21845,
        GIR_EraseRootFromParent_Done,
      // Label 11274: @716612
      GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(716687), // Rule ID 21848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21848,
        GIR_EraseRootFromParent_Done,
      // Label 11275: @716687
      GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(716762), // Rule ID 21849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21849,
        GIR_EraseRootFromParent_Done,
      // Label 11276: @716762
      GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(716837), // Rule ID 21852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21852,
        GIR_EraseRootFromParent_Done,
      // Label 11277: @716837
      GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(716912), // Rule ID 21853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21853,
        GIR_EraseRootFromParent_Done,
      // Label 11278: @716912
      GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(716987), // Rule ID 21856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21856,
        GIR_EraseRootFromParent_Done,
      // Label 11279: @716987
      GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(717062), // Rule ID 21857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21857,
        GIR_EraseRootFromParent_Done,
      // Label 11280: @717062
      GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(717137), // Rule ID 21860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21860,
        GIR_EraseRootFromParent_Done,
      // Label 11281: @717137
      GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(717212), // Rule ID 21861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21861,
        GIR_EraseRootFromParent_Done,
      // Label 11282: @717212
      GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(717287), // Rule ID 21864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21864,
        GIR_EraseRootFromParent_Done,
      // Label 11283: @717287
      GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(717362), // Rule ID 21865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21865,
        GIR_EraseRootFromParent_Done,
      // Label 11284: @717362
      GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(717437), // Rule ID 21868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21868,
        GIR_EraseRootFromParent_Done,
      // Label 11285: @717437
      GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(717512), // Rule ID 21869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21869,
        GIR_EraseRootFromParent_Done,
      // Label 11286: @717512
      GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(717587), // Rule ID 21872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21872,
        GIR_EraseRootFromParent_Done,
      // Label 11287: @717587
      GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(717662), // Rule ID 21873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21873,
        GIR_EraseRootFromParent_Done,
      // Label 11288: @717662
      GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(717737), // Rule ID 21876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21876,
        GIR_EraseRootFromParent_Done,
      // Label 11289: @717737
      GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(717812), // Rule ID 21877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21877,
        GIR_EraseRootFromParent_Done,
      // Label 11290: @717812
      GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(717887), // Rule ID 21880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21880,
        GIR_EraseRootFromParent_Done,
      // Label 11291: @717887
      GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(717962), // Rule ID 21881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21881,
        GIR_EraseRootFromParent_Done,
      // Label 11292: @717962
      GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(718037), // Rule ID 21884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21884,
        GIR_EraseRootFromParent_Done,
      // Label 11293: @718037
      GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(718112), // Rule ID 21885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21885,
        GIR_EraseRootFromParent_Done,
      // Label 11294: @718112
      GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(718187), // Rule ID 21888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21888,
        GIR_EraseRootFromParent_Done,
      // Label 11295: @718187
      GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(718262), // Rule ID 21889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21889,
        GIR_EraseRootFromParent_Done,
      // Label 11296: @718262
      GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(718337), // Rule ID 21892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21892,
        GIR_EraseRootFromParent_Done,
      // Label 11297: @718337
      GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(718412), // Rule ID 21893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21893,
        GIR_EraseRootFromParent_Done,
      // Label 11298: @718412
      GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(718487), // Rule ID 21896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21896,
        GIR_EraseRootFromParent_Done,
      // Label 11299: @718487
      GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(718562), // Rule ID 21897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21897,
        GIR_EraseRootFromParent_Done,
      // Label 11300: @718562
      GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(718637), // Rule ID 21900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21900,
        GIR_EraseRootFromParent_Done,
      // Label 11301: @718637
      GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(718712), // Rule ID 21901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21901,
        GIR_EraseRootFromParent_Done,
      // Label 11302: @718712
      GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(718787), // Rule ID 21904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21904,
        GIR_EraseRootFromParent_Done,
      // Label 11303: @718787
      GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(718862), // Rule ID 21905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21905,
        GIR_EraseRootFromParent_Done,
      // Label 11304: @718862
      GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(718937), // Rule ID 21908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21908,
        GIR_EraseRootFromParent_Done,
      // Label 11305: @718937
      GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(719012), // Rule ID 21909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21909,
        GIR_EraseRootFromParent_Done,
      // Label 11306: @719012
      GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(719087), // Rule ID 21912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21912,
        GIR_EraseRootFromParent_Done,
      // Label 11307: @719087
      GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(719162), // Rule ID 21913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21913,
        GIR_EraseRootFromParent_Done,
      // Label 11308: @719162
      GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(719237), // Rule ID 21916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21916,
        GIR_EraseRootFromParent_Done,
      // Label 11309: @719237
      GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(719312), // Rule ID 21917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21917,
        GIR_EraseRootFromParent_Done,
      // Label 11310: @719312
      GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(719387), // Rule ID 21920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21920,
        GIR_EraseRootFromParent_Done,
      // Label 11311: @719387
      GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(719462), // Rule ID 21921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21921,
        GIR_EraseRootFromParent_Done,
      // Label 11312: @719462
      GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(719537), // Rule ID 21924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21924,
        GIR_EraseRootFromParent_Done,
      // Label 11313: @719537
      GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(719612), // Rule ID 21925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21925,
        GIR_EraseRootFromParent_Done,
      // Label 11314: @719612
      GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(719687), // Rule ID 21928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21928,
        GIR_EraseRootFromParent_Done,
      // Label 11315: @719687
      GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(719762), // Rule ID 21929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21929,
        GIR_EraseRootFromParent_Done,
      // Label 11316: @719762
      GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(719837), // Rule ID 21932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21932,
        GIR_EraseRootFromParent_Done,
      // Label 11317: @719837
      GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(719912), // Rule ID 21933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21933,
        GIR_EraseRootFromParent_Done,
      // Label 11318: @719912
      GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(719987), // Rule ID 21936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21936,
        GIR_EraseRootFromParent_Done,
      // Label 11319: @719987
      GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(720062), // Rule ID 21937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21937,
        GIR_EraseRootFromParent_Done,
      // Label 11320: @720062
      GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(720137), // Rule ID 21940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21940,
        GIR_EraseRootFromParent_Done,
      // Label 11321: @720137
      GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(720212), // Rule ID 21941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21941,
        GIR_EraseRootFromParent_Done,
      // Label 11322: @720212
      GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(720287), // Rule ID 21944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21944,
        GIR_EraseRootFromParent_Done,
      // Label 11323: @720287
      GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(720362), // Rule ID 21945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21945,
        GIR_EraseRootFromParent_Done,
      // Label 11324: @720362
      GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(720437), // Rule ID 21948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21948,
        GIR_EraseRootFromParent_Done,
      // Label 11325: @720437
      GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(720512), // Rule ID 21949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21949,
        GIR_EraseRootFromParent_Done,
      // Label 11326: @720512
      GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(720587), // Rule ID 21952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21952,
        GIR_EraseRootFromParent_Done,
      // Label 11327: @720587
      GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(720662), // Rule ID 21953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21953,
        GIR_EraseRootFromParent_Done,
      // Label 11328: @720662
      GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(720737), // Rule ID 21956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21956,
        GIR_EraseRootFromParent_Done,
      // Label 11329: @720737
      GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(720812), // Rule ID 21957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21957,
        GIR_EraseRootFromParent_Done,
      // Label 11330: @720812
      GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(720887), // Rule ID 21960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21960,
        GIR_EraseRootFromParent_Done,
      // Label 11331: @720887
      GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(720962), // Rule ID 21961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21961,
        GIR_EraseRootFromParent_Done,
      // Label 11332: @720962
      GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(721037), // Rule ID 21964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21964,
        GIR_EraseRootFromParent_Done,
      // Label 11333: @721037
      GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(721112), // Rule ID 21965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21965,
        GIR_EraseRootFromParent_Done,
      // Label 11334: @721112
      GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(721187), // Rule ID 21968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21968,
        GIR_EraseRootFromParent_Done,
      // Label 11335: @721187
      GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(721262), // Rule ID 21969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21969,
        GIR_EraseRootFromParent_Done,
      // Label 11336: @721262
      GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(721337), // Rule ID 21972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21972,
        GIR_EraseRootFromParent_Done,
      // Label 11337: @721337
      GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(721412), // Rule ID 21973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21973,
        GIR_EraseRootFromParent_Done,
      // Label 11338: @721412
      GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(721487), // Rule ID 21976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21976,
        GIR_EraseRootFromParent_Done,
      // Label 11339: @721487
      GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(721562), // Rule ID 21977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21977,
        GIR_EraseRootFromParent_Done,
      // Label 11340: @721562
      GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(721637), // Rule ID 21980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21980,
        GIR_EraseRootFromParent_Done,
      // Label 11341: @721637
      GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(721712), // Rule ID 21981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21981,
        GIR_EraseRootFromParent_Done,
      // Label 11342: @721712
      GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(721787), // Rule ID 21984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21984,
        GIR_EraseRootFromParent_Done,
      // Label 11343: @721787
      GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(721862), // Rule ID 21985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21985,
        GIR_EraseRootFromParent_Done,
      // Label 11344: @721862
      GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(721937), // Rule ID 21988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21988,
        GIR_EraseRootFromParent_Done,
      // Label 11345: @721937
      GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(722012), // Rule ID 21989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21989,
        GIR_EraseRootFromParent_Done,
      // Label 11346: @722012
      GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(722087), // Rule ID 21992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21992,
        GIR_EraseRootFromParent_Done,
      // Label 11347: @722087
      GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(722162), // Rule ID 21993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21993,
        GIR_EraseRootFromParent_Done,
      // Label 11348: @722162
      GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(722237), // Rule ID 21996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21996,
        GIR_EraseRootFromParent_Done,
      // Label 11349: @722237
      GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(722312), // Rule ID 21997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21997,
        GIR_EraseRootFromParent_Done,
      // Label 11350: @722312
      GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(722387), // Rule ID 22000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22000,
        GIR_EraseRootFromParent_Done,
      // Label 11351: @722387
      GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(722462), // Rule ID 22001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22001,
        GIR_EraseRootFromParent_Done,
      // Label 11352: @722462
      GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(722537), // Rule ID 22004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22004,
        GIR_EraseRootFromParent_Done,
      // Label 11353: @722537
      GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(722612), // Rule ID 22005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22005,
        GIR_EraseRootFromParent_Done,
      // Label 11354: @722612
      GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(722687), // Rule ID 22008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22008,
        GIR_EraseRootFromParent_Done,
      // Label 11355: @722687
      GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(722762), // Rule ID 22009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22009,
        GIR_EraseRootFromParent_Done,
      // Label 11356: @722762
      GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(722837), // Rule ID 22012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22012,
        GIR_EraseRootFromParent_Done,
      // Label 11357: @722837
      GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(722912), // Rule ID 22013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22013,
        GIR_EraseRootFromParent_Done,
      // Label 11358: @722912
      GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(722987), // Rule ID 22016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22016,
        GIR_EraseRootFromParent_Done,
      // Label 11359: @722987
      GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(723062), // Rule ID 22017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22017,
        GIR_EraseRootFromParent_Done,
      // Label 11360: @723062
      GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(723137), // Rule ID 22020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22020,
        GIR_EraseRootFromParent_Done,
      // Label 11361: @723137
      GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(723212), // Rule ID 22021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22021,
        GIR_EraseRootFromParent_Done,
      // Label 11362: @723212
      GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(723287), // Rule ID 22024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22024,
        GIR_EraseRootFromParent_Done,
      // Label 11363: @723287
      GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(723362), // Rule ID 22025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22025,
        GIR_EraseRootFromParent_Done,
      // Label 11364: @723362
      GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(723437), // Rule ID 22028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22028,
        GIR_EraseRootFromParent_Done,
      // Label 11365: @723437
      GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(723512), // Rule ID 22029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22029,
        GIR_EraseRootFromParent_Done,
      // Label 11366: @723512
      GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(723587), // Rule ID 22032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22032,
        GIR_EraseRootFromParent_Done,
      // Label 11367: @723587
      GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(723662), // Rule ID 22033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22033,
        GIR_EraseRootFromParent_Done,
      // Label 11368: @723662
      GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(723737), // Rule ID 22036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22036,
        GIR_EraseRootFromParent_Done,
      // Label 11369: @723737
      GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(723812), // Rule ID 22037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22037,
        GIR_EraseRootFromParent_Done,
      // Label 11370: @723812
      GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(723887), // Rule ID 22040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22040,
        GIR_EraseRootFromParent_Done,
      // Label 11371: @723887
      GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(723962), // Rule ID 22041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22041,
        GIR_EraseRootFromParent_Done,
      // Label 11372: @723962
      GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(724037), // Rule ID 22044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22044,
        GIR_EraseRootFromParent_Done,
      // Label 11373: @724037
      GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(724112), // Rule ID 22045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22045,
        GIR_EraseRootFromParent_Done,
      // Label 11374: @724112
      GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(724187), // Rule ID 22048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22048,
        GIR_EraseRootFromParent_Done,
      // Label 11375: @724187
      GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(724262), // Rule ID 22049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22049,
        GIR_EraseRootFromParent_Done,
      // Label 11376: @724262
      GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(724337), // Rule ID 22052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22052,
        GIR_EraseRootFromParent_Done,
      // Label 11377: @724337
      GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(724412), // Rule ID 22053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22053,
        GIR_EraseRootFromParent_Done,
      // Label 11378: @724412
      GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(724487), // Rule ID 22056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22056,
        GIR_EraseRootFromParent_Done,
      // Label 11379: @724487
      GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(724562), // Rule ID 22057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22057,
        GIR_EraseRootFromParent_Done,
      // Label 11380: @724562
      GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(724637), // Rule ID 22060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22060,
        GIR_EraseRootFromParent_Done,
      // Label 11381: @724637
      GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(724712), // Rule ID 22061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22061,
        GIR_EraseRootFromParent_Done,
      // Label 11382: @724712
      GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(724787), // Rule ID 22064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22064,
        GIR_EraseRootFromParent_Done,
      // Label 11383: @724787
      GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(724862), // Rule ID 22065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22065,
        GIR_EraseRootFromParent_Done,
      // Label 11384: @724862
      GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(724937), // Rule ID 22068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22068,
        GIR_EraseRootFromParent_Done,
      // Label 11385: @724937
      GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(725012), // Rule ID 22069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22069,
        GIR_EraseRootFromParent_Done,
      // Label 11386: @725012
      GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(725087), // Rule ID 22072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22072,
        GIR_EraseRootFromParent_Done,
      // Label 11387: @725087
      GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(725162), // Rule ID 22073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22073,
        GIR_EraseRootFromParent_Done,
      // Label 11388: @725162
      GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(725237), // Rule ID 22076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22076,
        GIR_EraseRootFromParent_Done,
      // Label 11389: @725237
      GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(725312), // Rule ID 22077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22077,
        GIR_EraseRootFromParent_Done,
      // Label 11390: @725312
      GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(725387), // Rule ID 22080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22080,
        GIR_EraseRootFromParent_Done,
      // Label 11391: @725387
      GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(725462), // Rule ID 22081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22081,
        GIR_EraseRootFromParent_Done,
      // Label 11392: @725462
      GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(725537), // Rule ID 22084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22084,
        GIR_EraseRootFromParent_Done,
      // Label 11393: @725537
      GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(725612), // Rule ID 22085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22085,
        GIR_EraseRootFromParent_Done,
      // Label 11394: @725612
      GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(725687), // Rule ID 22088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22088,
        GIR_EraseRootFromParent_Done,
      // Label 11395: @725687
      GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(725762), // Rule ID 22089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22089,
        GIR_EraseRootFromParent_Done,
      // Label 11396: @725762
      GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(725837), // Rule ID 22092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22092,
        GIR_EraseRootFromParent_Done,
      // Label 11397: @725837
      GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(725912), // Rule ID 22093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22093,
        GIR_EraseRootFromParent_Done,
      // Label 11398: @725912
      GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(725987), // Rule ID 22096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22096,
        GIR_EraseRootFromParent_Done,
      // Label 11399: @725987
      GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(726062), // Rule ID 22097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22097,
        GIR_EraseRootFromParent_Done,
      // Label 11400: @726062
      GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(726137), // Rule ID 22100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22100,
        GIR_EraseRootFromParent_Done,
      // Label 11401: @726137
      GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(726212), // Rule ID 22101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22101,
        GIR_EraseRootFromParent_Done,
      // Label 11402: @726212
      GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(726287), // Rule ID 22104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22104,
        GIR_EraseRootFromParent_Done,
      // Label 11403: @726287
      GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(726362), // Rule ID 22105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22105,
        GIR_EraseRootFromParent_Done,
      // Label 11404: @726362
      GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(726437), // Rule ID 22108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22108,
        GIR_EraseRootFromParent_Done,
      // Label 11405: @726437
      GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(726512), // Rule ID 22109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22109,
        GIR_EraseRootFromParent_Done,
      // Label 11406: @726512
      GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(726587), // Rule ID 22112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22112,
        GIR_EraseRootFromParent_Done,
      // Label 11407: @726587
      GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(726662), // Rule ID 22113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22113,
        GIR_EraseRootFromParent_Done,
      // Label 11408: @726662
      GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(726737), // Rule ID 22116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22116,
        GIR_EraseRootFromParent_Done,
      // Label 11409: @726737
      GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(726812), // Rule ID 22117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22117,
        GIR_EraseRootFromParent_Done,
      // Label 11410: @726812
      GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(726887), // Rule ID 22120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22120,
        GIR_EraseRootFromParent_Done,
      // Label 11411: @726887
      GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(726962), // Rule ID 22121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22121,
        GIR_EraseRootFromParent_Done,
      // Label 11412: @726962
      GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(727037), // Rule ID 22124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22124,
        GIR_EraseRootFromParent_Done,
      // Label 11413: @727037
      GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(727112), // Rule ID 22125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22125,
        GIR_EraseRootFromParent_Done,
      // Label 11414: @727112
      GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(727187), // Rule ID 22128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22128,
        GIR_EraseRootFromParent_Done,
      // Label 11415: @727187
      GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(727262), // Rule ID 22129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22129,
        GIR_EraseRootFromParent_Done,
      // Label 11416: @727262
      GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(727337), // Rule ID 22132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22132,
        GIR_EraseRootFromParent_Done,
      // Label 11417: @727337
      GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(727412), // Rule ID 22133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22133,
        GIR_EraseRootFromParent_Done,
      // Label 11418: @727412
      GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(727487), // Rule ID 22136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22136,
        GIR_EraseRootFromParent_Done,
      // Label 11419: @727487
      GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(727562), // Rule ID 22137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22137,
        GIR_EraseRootFromParent_Done,
      // Label 11420: @727562
      GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(727637), // Rule ID 22140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22140,
        GIR_EraseRootFromParent_Done,
      // Label 11421: @727637
      GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(727712), // Rule ID 22141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22141,
        GIR_EraseRootFromParent_Done,
      // Label 11422: @727712
      GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(727787), // Rule ID 22144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22144,
        GIR_EraseRootFromParent_Done,
      // Label 11423: @727787
      GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(727862), // Rule ID 22145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22145,
        GIR_EraseRootFromParent_Done,
      // Label 11424: @727862
      GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(727937), // Rule ID 22148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22148,
        GIR_EraseRootFromParent_Done,
      // Label 11425: @727937
      GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(728012), // Rule ID 22149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22149,
        GIR_EraseRootFromParent_Done,
      // Label 11426: @728012
      GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(728087), // Rule ID 22152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22152,
        GIR_EraseRootFromParent_Done,
      // Label 11427: @728087
      GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(728162), // Rule ID 22153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22153,
        GIR_EraseRootFromParent_Done,
      // Label 11428: @728162
      GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(728237), // Rule ID 22156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22156,
        GIR_EraseRootFromParent_Done,
      // Label 11429: @728237
      GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(728312), // Rule ID 22157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22157,
        GIR_EraseRootFromParent_Done,
      // Label 11430: @728312
      GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(728387), // Rule ID 22160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22160,
        GIR_EraseRootFromParent_Done,
      // Label 11431: @728387
      GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(728462), // Rule ID 22161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22161,
        GIR_EraseRootFromParent_Done,
      // Label 11432: @728462
      GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(728537), // Rule ID 22164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22164,
        GIR_EraseRootFromParent_Done,
      // Label 11433: @728537
      GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(728612), // Rule ID 22165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22165,
        GIR_EraseRootFromParent_Done,
      // Label 11434: @728612
      GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(728687), // Rule ID 22168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22168,
        GIR_EraseRootFromParent_Done,
      // Label 11435: @728687
      GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(728762), // Rule ID 22169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22169,
        GIR_EraseRootFromParent_Done,
      // Label 11436: @728762
      GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(728837), // Rule ID 22172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22172,
        GIR_EraseRootFromParent_Done,
      // Label 11437: @728837
      GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(728912), // Rule ID 22173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22173,
        GIR_EraseRootFromParent_Done,
      // Label 11438: @728912
      GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(728987), // Rule ID 22176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22176,
        GIR_EraseRootFromParent_Done,
      // Label 11439: @728987
      GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(729062), // Rule ID 22177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22177,
        GIR_EraseRootFromParent_Done,
      // Label 11440: @729062
      GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(729137), // Rule ID 22180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22180,
        GIR_EraseRootFromParent_Done,
      // Label 11441: @729137
      GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(729212), // Rule ID 22181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22181,
        GIR_EraseRootFromParent_Done,
      // Label 11442: @729212
      GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(729287), // Rule ID 22184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22184,
        GIR_EraseRootFromParent_Done,
      // Label 11443: @729287
      GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(729362), // Rule ID 22185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22185,
        GIR_EraseRootFromParent_Done,
      // Label 11444: @729362
      GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(729437), // Rule ID 22188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22188,
        GIR_EraseRootFromParent_Done,
      // Label 11445: @729437
      GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(729512), // Rule ID 22189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22189,
        GIR_EraseRootFromParent_Done,
      // Label 11446: @729512
      GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(729587), // Rule ID 22192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22192,
        GIR_EraseRootFromParent_Done,
      // Label 11447: @729587
      GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(729662), // Rule ID 22193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22193,
        GIR_EraseRootFromParent_Done,
      // Label 11448: @729662
      GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(729737), // Rule ID 22196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22196,
        GIR_EraseRootFromParent_Done,
      // Label 11449: @729737
      GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(729812), // Rule ID 22197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22197,
        GIR_EraseRootFromParent_Done,
      // Label 11450: @729812
      GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(729887), // Rule ID 22200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22200,
        GIR_EraseRootFromParent_Done,
      // Label 11451: @729887
      GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(729962), // Rule ID 22201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22201,
        GIR_EraseRootFromParent_Done,
      // Label 11452: @729962
      GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(730037), // Rule ID 22204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22204,
        GIR_EraseRootFromParent_Done,
      // Label 11453: @730037
      GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(730112), // Rule ID 22205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22205,
        GIR_EraseRootFromParent_Done,
      // Label 11454: @730112
      GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(730187), // Rule ID 22208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22208,
        GIR_EraseRootFromParent_Done,
      // Label 11455: @730187
      GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(730262), // Rule ID 22209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22209,
        GIR_EraseRootFromParent_Done,
      // Label 11456: @730262
      GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(730337), // Rule ID 22212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22212,
        GIR_EraseRootFromParent_Done,
      // Label 11457: @730337
      GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(730412), // Rule ID 22213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22213,
        GIR_EraseRootFromParent_Done,
      // Label 11458: @730412
      GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(730487), // Rule ID 22216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22216,
        GIR_EraseRootFromParent_Done,
      // Label 11459: @730487
      GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(730562), // Rule ID 22217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22217,
        GIR_EraseRootFromParent_Done,
      // Label 11460: @730562
      GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(730637), // Rule ID 22220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22220,
        GIR_EraseRootFromParent_Done,
      // Label 11461: @730637
      GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(730712), // Rule ID 22221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22221,
        GIR_EraseRootFromParent_Done,
      // Label 11462: @730712
      GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(730787), // Rule ID 22224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22224,
        GIR_EraseRootFromParent_Done,
      // Label 11463: @730787
      GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(730862), // Rule ID 22225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22225,
        GIR_EraseRootFromParent_Done,
      // Label 11464: @730862
      GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(730937), // Rule ID 22228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22228,
        GIR_EraseRootFromParent_Done,
      // Label 11465: @730937
      GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(731012), // Rule ID 22229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22229,
        GIR_EraseRootFromParent_Done,
      // Label 11466: @731012
      GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(731087), // Rule ID 22232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22232,
        GIR_EraseRootFromParent_Done,
      // Label 11467: @731087
      GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(731162), // Rule ID 22233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22233,
        GIR_EraseRootFromParent_Done,
      // Label 11468: @731162
      GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(731237), // Rule ID 22236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22236,
        GIR_EraseRootFromParent_Done,
      // Label 11469: @731237
      GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(731312), // Rule ID 22237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22237,
        GIR_EraseRootFromParent_Done,
      // Label 11470: @731312
      GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(731387), // Rule ID 22240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22240,
        GIR_EraseRootFromParent_Done,
      // Label 11471: @731387
      GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(731462), // Rule ID 22241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22241,
        GIR_EraseRootFromParent_Done,
      // Label 11472: @731462
      GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(731537), // Rule ID 22244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22244,
        GIR_EraseRootFromParent_Done,
      // Label 11473: @731537
      GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(731612), // Rule ID 22245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22245,
        GIR_EraseRootFromParent_Done,
      // Label 11474: @731612
      GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(731687), // Rule ID 22248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22248,
        GIR_EraseRootFromParent_Done,
      // Label 11475: @731687
      GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(731762), // Rule ID 22249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22249,
        GIR_EraseRootFromParent_Done,
      // Label 11476: @731762
      GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(731837), // Rule ID 22252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22252,
        GIR_EraseRootFromParent_Done,
      // Label 11477: @731837
      GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(731912), // Rule ID 22253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22253,
        GIR_EraseRootFromParent_Done,
      // Label 11478: @731912
      GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(731987), // Rule ID 22256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22256,
        GIR_EraseRootFromParent_Done,
      // Label 11479: @731987
      GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(732062), // Rule ID 22257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22257,
        GIR_EraseRootFromParent_Done,
      // Label 11480: @732062
      GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(732137), // Rule ID 22260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22260,
        GIR_EraseRootFromParent_Done,
      // Label 11481: @732137
      GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(732212), // Rule ID 22261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22261,
        GIR_EraseRootFromParent_Done,
      // Label 11482: @732212
      GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(732287), // Rule ID 22264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22264,
        GIR_EraseRootFromParent_Done,
      // Label 11483: @732287
      GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(732362), // Rule ID 22265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22265,
        GIR_EraseRootFromParent_Done,
      // Label 11484: @732362
      GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(732437), // Rule ID 22268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22268,
        GIR_EraseRootFromParent_Done,
      // Label 11485: @732437
      GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(732512), // Rule ID 22269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22269,
        GIR_EraseRootFromParent_Done,
      // Label 11486: @732512
      GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(732587), // Rule ID 22272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22272,
        GIR_EraseRootFromParent_Done,
      // Label 11487: @732587
      GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(732662), // Rule ID 22273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22273,
        GIR_EraseRootFromParent_Done,
      // Label 11488: @732662
      GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(732737), // Rule ID 22276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22276,
        GIR_EraseRootFromParent_Done,
      // Label 11489: @732737
      GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(732812), // Rule ID 22277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22277,
        GIR_EraseRootFromParent_Done,
      // Label 11490: @732812
      GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(732887), // Rule ID 22280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22280,
        GIR_EraseRootFromParent_Done,
      // Label 11491: @732887
      GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(732962), // Rule ID 22281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22281,
        GIR_EraseRootFromParent_Done,
      // Label 11492: @732962
      GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(733037), // Rule ID 22284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22284,
        GIR_EraseRootFromParent_Done,
      // Label 11493: @733037
      GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(733112), // Rule ID 22285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22285,
        GIR_EraseRootFromParent_Done,
      // Label 11494: @733112
      GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(733187), // Rule ID 22288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22288,
        GIR_EraseRootFromParent_Done,
      // Label 11495: @733187
      GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(733262), // Rule ID 22289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22289,
        GIR_EraseRootFromParent_Done,
      // Label 11496: @733262
      GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(733337), // Rule ID 22292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22292,
        GIR_EraseRootFromParent_Done,
      // Label 11497: @733337
      GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(733412), // Rule ID 22293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22293,
        GIR_EraseRootFromParent_Done,
      // Label 11498: @733412
      GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(733487), // Rule ID 22296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22296,
        GIR_EraseRootFromParent_Done,
      // Label 11499: @733487
      GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(733562), // Rule ID 22297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22297,
        GIR_EraseRootFromParent_Done,
      // Label 11500: @733562
      GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(733637), // Rule ID 22300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22300,
        GIR_EraseRootFromParent_Done,
      // Label 11501: @733637
      GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(733712), // Rule ID 22301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22301,
        GIR_EraseRootFromParent_Done,
      // Label 11502: @733712
      GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(733787), // Rule ID 22304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22304,
        GIR_EraseRootFromParent_Done,
      // Label 11503: @733787
      GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(733862), // Rule ID 22305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22305,
        GIR_EraseRootFromParent_Done,
      // Label 11504: @733862
      GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(733937), // Rule ID 22308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22308,
        GIR_EraseRootFromParent_Done,
      // Label 11505: @733937
      GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(734012), // Rule ID 22309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22309,
        GIR_EraseRootFromParent_Done,
      // Label 11506: @734012
      GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(734087), // Rule ID 22312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22312,
        GIR_EraseRootFromParent_Done,
      // Label 11507: @734087
      GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(734162), // Rule ID 22313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22313,
        GIR_EraseRootFromParent_Done,
      // Label 11508: @734162
      GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(734237), // Rule ID 22316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22316,
        GIR_EraseRootFromParent_Done,
      // Label 11509: @734237
      GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(734312), // Rule ID 22317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22317,
        GIR_EraseRootFromParent_Done,
      // Label 11510: @734312
      GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(734387), // Rule ID 22320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22320,
        GIR_EraseRootFromParent_Done,
      // Label 11511: @734387
      GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(734462), // Rule ID 22321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22321,
        GIR_EraseRootFromParent_Done,
      // Label 11512: @734462
      GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(734537), // Rule ID 22324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22324,
        GIR_EraseRootFromParent_Done,
      // Label 11513: @734537
      GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(734612), // Rule ID 22325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22325,
        GIR_EraseRootFromParent_Done,
      // Label 11514: @734612
      GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(734687), // Rule ID 22328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22328,
        GIR_EraseRootFromParent_Done,
      // Label 11515: @734687
      GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(734762), // Rule ID 22329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22329,
        GIR_EraseRootFromParent_Done,
      // Label 11516: @734762
      GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(734837), // Rule ID 22332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22332,
        GIR_EraseRootFromParent_Done,
      // Label 11517: @734837
      GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(734912), // Rule ID 22333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22333,
        GIR_EraseRootFromParent_Done,
      // Label 11518: @734912
      GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(734987), // Rule ID 22336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22336,
        GIR_EraseRootFromParent_Done,
      // Label 11519: @734987
      GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(735062), // Rule ID 22337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22337,
        GIR_EraseRootFromParent_Done,
      // Label 11520: @735062
      GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(735137), // Rule ID 22340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22340,
        GIR_EraseRootFromParent_Done,
      // Label 11521: @735137
      GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(735212), // Rule ID 22341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22341,
        GIR_EraseRootFromParent_Done,
      // Label 11522: @735212
      GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(735287), // Rule ID 22344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22344,
        GIR_EraseRootFromParent_Done,
      // Label 11523: @735287
      GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(735362), // Rule ID 22345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22345,
        GIR_EraseRootFromParent_Done,
      // Label 11524: @735362
      GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(735437), // Rule ID 22348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22348,
        GIR_EraseRootFromParent_Done,
      // Label 11525: @735437
      GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(735512), // Rule ID 22349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22349,
        GIR_EraseRootFromParent_Done,
      // Label 11526: @735512
      GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(735587), // Rule ID 22352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22352,
        GIR_EraseRootFromParent_Done,
      // Label 11527: @735587
      GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(735662), // Rule ID 22353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22353,
        GIR_EraseRootFromParent_Done,
      // Label 11528: @735662
      GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(735737), // Rule ID 22356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22356,
        GIR_EraseRootFromParent_Done,
      // Label 11529: @735737
      GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(735812), // Rule ID 22357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22357,
        GIR_EraseRootFromParent_Done,
      // Label 11530: @735812
      GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(735887), // Rule ID 22360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22360,
        GIR_EraseRootFromParent_Done,
      // Label 11531: @735887
      GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(735962), // Rule ID 22361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22361,
        GIR_EraseRootFromParent_Done,
      // Label 11532: @735962
      GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(736037), // Rule ID 22364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22364,
        GIR_EraseRootFromParent_Done,
      // Label 11533: @736037
      GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(736112), // Rule ID 22365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22365,
        GIR_EraseRootFromParent_Done,
      // Label 11534: @736112
      GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(736187), // Rule ID 22368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22368,
        GIR_EraseRootFromParent_Done,
      // Label 11535: @736187
      GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(736262), // Rule ID 22369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22369,
        GIR_EraseRootFromParent_Done,
      // Label 11536: @736262
      GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(736337), // Rule ID 22372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22372,
        GIR_EraseRootFromParent_Done,
      // Label 11537: @736337
      GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(736412), // Rule ID 22373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22373,
        GIR_EraseRootFromParent_Done,
      // Label 11538: @736412
      GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(736487), // Rule ID 22376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22376,
        GIR_EraseRootFromParent_Done,
      // Label 11539: @736487
      GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(736562), // Rule ID 22377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22377,
        GIR_EraseRootFromParent_Done,
      // Label 11540: @736562
      GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(736637), // Rule ID 22380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22380,
        GIR_EraseRootFromParent_Done,
      // Label 11541: @736637
      GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(736712), // Rule ID 22381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22381,
        GIR_EraseRootFromParent_Done,
      // Label 11542: @736712
      GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(736787), // Rule ID 22384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22384,
        GIR_EraseRootFromParent_Done,
      // Label 11543: @736787
      GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(736862), // Rule ID 22385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22385,
        GIR_EraseRootFromParent_Done,
      // Label 11544: @736862
      GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(736937), // Rule ID 22388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22388,
        GIR_EraseRootFromParent_Done,
      // Label 11545: @736937
      GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(737012), // Rule ID 22389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22389,
        GIR_EraseRootFromParent_Done,
      // Label 11546: @737012
      GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(737087), // Rule ID 22392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22392,
        GIR_EraseRootFromParent_Done,
      // Label 11547: @737087
      GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(737162), // Rule ID 22393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22393,
        GIR_EraseRootFromParent_Done,
      // Label 11548: @737162
      GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(737237), // Rule ID 22396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22396,
        GIR_EraseRootFromParent_Done,
      // Label 11549: @737237
      GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(737312), // Rule ID 22397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22397,
        GIR_EraseRootFromParent_Done,
      // Label 11550: @737312
      GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(737387), // Rule ID 22400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22400,
        GIR_EraseRootFromParent_Done,
      // Label 11551: @737387
      GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(737462), // Rule ID 22401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22401,
        GIR_EraseRootFromParent_Done,
      // Label 11552: @737462
      GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(737537), // Rule ID 22404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22404,
        GIR_EraseRootFromParent_Done,
      // Label 11553: @737537
      GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(737612), // Rule ID 22405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22405,
        GIR_EraseRootFromParent_Done,
      // Label 11554: @737612
      GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(737687), // Rule ID 22408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22408,
        GIR_EraseRootFromParent_Done,
      // Label 11555: @737687
      GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(737762), // Rule ID 22409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22409,
        GIR_EraseRootFromParent_Done,
      // Label 11556: @737762
      GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(737837), // Rule ID 22412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22412,
        GIR_EraseRootFromParent_Done,
      // Label 11557: @737837
      GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(737912), // Rule ID 22413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22413,
        GIR_EraseRootFromParent_Done,
      // Label 11558: @737912
      GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(737987), // Rule ID 22416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22416,
        GIR_EraseRootFromParent_Done,
      // Label 11559: @737987
      GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(738062), // Rule ID 22417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22417,
        GIR_EraseRootFromParent_Done,
      // Label 11560: @738062
      GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(738137), // Rule ID 22420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22420,
        GIR_EraseRootFromParent_Done,
      // Label 11561: @738137
      GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(738212), // Rule ID 22421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22421,
        GIR_EraseRootFromParent_Done,
      // Label 11562: @738212
      GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(738287), // Rule ID 22424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22424,
        GIR_EraseRootFromParent_Done,
      // Label 11563: @738287
      GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(738362), // Rule ID 22425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22425,
        GIR_EraseRootFromParent_Done,
      // Label 11564: @738362
      GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(738437), // Rule ID 22428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22428,
        GIR_EraseRootFromParent_Done,
      // Label 11565: @738437
      GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(738512), // Rule ID 22429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22429,
        GIR_EraseRootFromParent_Done,
      // Label 11566: @738512
      GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(738587), // Rule ID 22432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22432,
        GIR_EraseRootFromParent_Done,
      // Label 11567: @738587
      GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(738662), // Rule ID 22433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22433,
        GIR_EraseRootFromParent_Done,
      // Label 11568: @738662
      GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(738737), // Rule ID 22436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22436,
        GIR_EraseRootFromParent_Done,
      // Label 11569: @738737
      GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(738812), // Rule ID 22437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22437,
        GIR_EraseRootFromParent_Done,
      // Label 11570: @738812
      GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(738887), // Rule ID 22440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22440,
        GIR_EraseRootFromParent_Done,
      // Label 11571: @738887
      GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(738962), // Rule ID 22441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22441,
        GIR_EraseRootFromParent_Done,
      // Label 11572: @738962
      GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(739037), // Rule ID 22444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22444,
        GIR_EraseRootFromParent_Done,
      // Label 11573: @739037
      GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(739112), // Rule ID 22445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22445,
        GIR_EraseRootFromParent_Done,
      // Label 11574: @739112
      GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(739187), // Rule ID 22448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22448,
        GIR_EraseRootFromParent_Done,
      // Label 11575: @739187
      GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(739262), // Rule ID 22449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22449,
        GIR_EraseRootFromParent_Done,
      // Label 11576: @739262
      GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(739337), // Rule ID 22452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22452,
        GIR_EraseRootFromParent_Done,
      // Label 11577: @739337
      GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(739412), // Rule ID 22453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22453,
        GIR_EraseRootFromParent_Done,
      // Label 11578: @739412
      GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(739487), // Rule ID 22456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22456,
        GIR_EraseRootFromParent_Done,
      // Label 11579: @739487
      GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(739562), // Rule ID 22457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22457,
        GIR_EraseRootFromParent_Done,
      // Label 11580: @739562
      GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(739637), // Rule ID 22460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22460,
        GIR_EraseRootFromParent_Done,
      // Label 11581: @739637
      GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(739712), // Rule ID 22461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22461,
        GIR_EraseRootFromParent_Done,
      // Label 11582: @739712
      GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(739787), // Rule ID 22464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22464,
        GIR_EraseRootFromParent_Done,
      // Label 11583: @739787
      GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(739862), // Rule ID 22465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22465,
        GIR_EraseRootFromParent_Done,
      // Label 11584: @739862
      GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(739937), // Rule ID 22468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22468,
        GIR_EraseRootFromParent_Done,
      // Label 11585: @739937
      GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(740012), // Rule ID 22469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22469,
        GIR_EraseRootFromParent_Done,
      // Label 11586: @740012
      GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(740087), // Rule ID 22472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22472,
        GIR_EraseRootFromParent_Done,
      // Label 11587: @740087
      GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(740162), // Rule ID 22473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22473,
        GIR_EraseRootFromParent_Done,
      // Label 11588: @740162
      GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(740237), // Rule ID 22476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22476,
        GIR_EraseRootFromParent_Done,
      // Label 11589: @740237
      GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(740312), // Rule ID 22477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22477,
        GIR_EraseRootFromParent_Done,
      // Label 11590: @740312
      GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(740387), // Rule ID 22480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22480,
        GIR_EraseRootFromParent_Done,
      // Label 11591: @740387
      GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(740462), // Rule ID 22481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22481,
        GIR_EraseRootFromParent_Done,
      // Label 11592: @740462
      GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(740537), // Rule ID 22484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22484,
        GIR_EraseRootFromParent_Done,
      // Label 11593: @740537
      GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(740612), // Rule ID 22485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22485,
        GIR_EraseRootFromParent_Done,
      // Label 11594: @740612
      GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(740687), // Rule ID 22488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22488,
        GIR_EraseRootFromParent_Done,
      // Label 11595: @740687
      GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(740762), // Rule ID 22489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22489,
        GIR_EraseRootFromParent_Done,
      // Label 11596: @740762
      GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(740837), // Rule ID 22492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22492,
        GIR_EraseRootFromParent_Done,
      // Label 11597: @740837
      GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(740912), // Rule ID 22493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22493,
        GIR_EraseRootFromParent_Done,
      // Label 11598: @740912
      GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(740987), // Rule ID 22496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22496,
        GIR_EraseRootFromParent_Done,
      // Label 11599: @740987
      GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(741062), // Rule ID 22497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22497,
        GIR_EraseRootFromParent_Done,
      // Label 11600: @741062
      GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(741137), // Rule ID 22500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22500,
        GIR_EraseRootFromParent_Done,
      // Label 11601: @741137
      GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(741212), // Rule ID 22501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22501,
        GIR_EraseRootFromParent_Done,
      // Label 11602: @741212
      GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(741287), // Rule ID 22504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22504,
        GIR_EraseRootFromParent_Done,
      // Label 11603: @741287
      GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(741362), // Rule ID 22505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22505,
        GIR_EraseRootFromParent_Done,
      // Label 11604: @741362
      GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(741437), // Rule ID 22508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22508,
        GIR_EraseRootFromParent_Done,
      // Label 11605: @741437
      GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(741512), // Rule ID 22509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22509,
        GIR_EraseRootFromParent_Done,
      // Label 11606: @741512
      GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(741587), // Rule ID 22512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22512,
        GIR_EraseRootFromParent_Done,
      // Label 11607: @741587
      GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(741662), // Rule ID 22513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22513,
        GIR_EraseRootFromParent_Done,
      // Label 11608: @741662
      GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(741737), // Rule ID 22516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22516,
        GIR_EraseRootFromParent_Done,
      // Label 11609: @741737
      GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(741812), // Rule ID 22517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22517,
        GIR_EraseRootFromParent_Done,
      // Label 11610: @741812
      GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(741887), // Rule ID 22520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22520,
        GIR_EraseRootFromParent_Done,
      // Label 11611: @741887
      GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(741962), // Rule ID 22521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22521,
        GIR_EraseRootFromParent_Done,
      // Label 11612: @741962
      GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(742037), // Rule ID 22524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22524,
        GIR_EraseRootFromParent_Done,
      // Label 11613: @742037
      GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(742112), // Rule ID 22525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22525,
        GIR_EraseRootFromParent_Done,
      // Label 11614: @742112
      GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(742187), // Rule ID 22528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22528,
        GIR_EraseRootFromParent_Done,
      // Label 11615: @742187
      GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(742262), // Rule ID 22529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22529,
        GIR_EraseRootFromParent_Done,
      // Label 11616: @742262
      GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(742337), // Rule ID 22532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22532,
        GIR_EraseRootFromParent_Done,
      // Label 11617: @742337
      GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(742412), // Rule ID 22533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22533,
        GIR_EraseRootFromParent_Done,
      // Label 11618: @742412
      GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(742487), // Rule ID 22536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22536,
        GIR_EraseRootFromParent_Done,
      // Label 11619: @742487
      GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(742562), // Rule ID 22537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22537,
        GIR_EraseRootFromParent_Done,
      // Label 11620: @742562
      GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(742637), // Rule ID 22540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22540,
        GIR_EraseRootFromParent_Done,
      // Label 11621: @742637
      GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(742712), // Rule ID 22541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22541,
        GIR_EraseRootFromParent_Done,
      // Label 11622: @742712
      GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(742787), // Rule ID 22544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22544,
        GIR_EraseRootFromParent_Done,
      // Label 11623: @742787
      GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(742862), // Rule ID 22545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22545,
        GIR_EraseRootFromParent_Done,
      // Label 11624: @742862
      GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(742937), // Rule ID 22548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22548,
        GIR_EraseRootFromParent_Done,
      // Label 11625: @742937
      GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(743012), // Rule ID 22549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22549,
        GIR_EraseRootFromParent_Done,
      // Label 11626: @743012
      GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(743087), // Rule ID 22552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22552,
        GIR_EraseRootFromParent_Done,
      // Label 11627: @743087
      GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(743162), // Rule ID 22553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22553,
        GIR_EraseRootFromParent_Done,
      // Label 11628: @743162
      GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(743237), // Rule ID 22556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22556,
        GIR_EraseRootFromParent_Done,
      // Label 11629: @743237
      GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(743312), // Rule ID 22557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22557,
        GIR_EraseRootFromParent_Done,
      // Label 11630: @743312
      GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(743387), // Rule ID 22560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22560,
        GIR_EraseRootFromParent_Done,
      // Label 11631: @743387
      GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(743462), // Rule ID 22561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22561,
        GIR_EraseRootFromParent_Done,
      // Label 11632: @743462
      GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(743537), // Rule ID 22564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22564,
        GIR_EraseRootFromParent_Done,
      // Label 11633: @743537
      GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(743612), // Rule ID 22565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22565,
        GIR_EraseRootFromParent_Done,
      // Label 11634: @743612
      GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(743687), // Rule ID 22568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22568,
        GIR_EraseRootFromParent_Done,
      // Label 11635: @743687
      GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(743762), // Rule ID 22569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22569,
        GIR_EraseRootFromParent_Done,
      // Label 11636: @743762
      GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(743837), // Rule ID 22572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22572,
        GIR_EraseRootFromParent_Done,
      // Label 11637: @743837
      GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(743912), // Rule ID 22573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22573,
        GIR_EraseRootFromParent_Done,
      // Label 11638: @743912
      GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(743987), // Rule ID 22576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22576,
        GIR_EraseRootFromParent_Done,
      // Label 11639: @743987
      GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(744062), // Rule ID 22577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22577,
        GIR_EraseRootFromParent_Done,
      // Label 11640: @744062
      GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(744137), // Rule ID 22580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22580,
        GIR_EraseRootFromParent_Done,
      // Label 11641: @744137
      GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(744212), // Rule ID 22581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22581,
        GIR_EraseRootFromParent_Done,
      // Label 11642: @744212
      GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(744287), // Rule ID 22584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22584,
        GIR_EraseRootFromParent_Done,
      // Label 11643: @744287
      GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(744362), // Rule ID 22585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22585,
        GIR_EraseRootFromParent_Done,
      // Label 11644: @744362
      GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(744437), // Rule ID 22588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22588,
        GIR_EraseRootFromParent_Done,
      // Label 11645: @744437
      GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(744512), // Rule ID 22589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22589,
        GIR_EraseRootFromParent_Done,
      // Label 11646: @744512
      GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(744587), // Rule ID 22592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22592,
        GIR_EraseRootFromParent_Done,
      // Label 11647: @744587
      GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(744662), // Rule ID 22593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22593,
        GIR_EraseRootFromParent_Done,
      // Label 11648: @744662
      GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(744737), // Rule ID 22596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22596,
        GIR_EraseRootFromParent_Done,
      // Label 11649: @744737
      GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(744812), // Rule ID 22597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22597,
        GIR_EraseRootFromParent_Done,
      // Label 11650: @744812
      GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(744887), // Rule ID 22600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22600,
        GIR_EraseRootFromParent_Done,
      // Label 11651: @744887
      GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(744962), // Rule ID 22601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22601,
        GIR_EraseRootFromParent_Done,
      // Label 11652: @744962
      GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(745037), // Rule ID 22604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22604,
        GIR_EraseRootFromParent_Done,
      // Label 11653: @745037
      GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(745112), // Rule ID 22605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22605,
        GIR_EraseRootFromParent_Done,
      // Label 11654: @745112
      GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(745187), // Rule ID 22608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22608,
        GIR_EraseRootFromParent_Done,
      // Label 11655: @745187
      GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(745262), // Rule ID 22609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22609,
        GIR_EraseRootFromParent_Done,
      // Label 11656: @745262
      GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(745337), // Rule ID 22612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22612,
        GIR_EraseRootFromParent_Done,
      // Label 11657: @745337
      GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(745412), // Rule ID 22613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22613,
        GIR_EraseRootFromParent_Done,
      // Label 11658: @745412
      GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(745487), // Rule ID 22616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22616,
        GIR_EraseRootFromParent_Done,
      // Label 11659: @745487
      GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(745562), // Rule ID 22617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22617,
        GIR_EraseRootFromParent_Done,
      // Label 11660: @745562
      GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(745637), // Rule ID 22620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22620,
        GIR_EraseRootFromParent_Done,
      // Label 11661: @745637
      GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(745712), // Rule ID 22621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22621,
        GIR_EraseRootFromParent_Done,
      // Label 11662: @745712
      GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(745787), // Rule ID 22624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22624,
        GIR_EraseRootFromParent_Done,
      // Label 11663: @745787
      GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(745862), // Rule ID 22625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22625,
        GIR_EraseRootFromParent_Done,
      // Label 11664: @745862
      GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(745937), // Rule ID 22628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22628,
        GIR_EraseRootFromParent_Done,
      // Label 11665: @745937
      GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(746012), // Rule ID 22629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22629,
        GIR_EraseRootFromParent_Done,
      // Label 11666: @746012
      GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(746087), // Rule ID 22632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22632,
        GIR_EraseRootFromParent_Done,
      // Label 11667: @746087
      GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(746162), // Rule ID 22633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22633,
        GIR_EraseRootFromParent_Done,
      // Label 11668: @746162
      GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(746237), // Rule ID 22636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22636,
        GIR_EraseRootFromParent_Done,
      // Label 11669: @746237
      GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(746312), // Rule ID 22637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22637,
        GIR_EraseRootFromParent_Done,
      // Label 11670: @746312
      GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(746387), // Rule ID 22640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22640,
        GIR_EraseRootFromParent_Done,
      // Label 11671: @746387
      GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(746462), // Rule ID 22641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22641,
        GIR_EraseRootFromParent_Done,
      // Label 11672: @746462
      GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(746537), // Rule ID 22644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22644,
        GIR_EraseRootFromParent_Done,
      // Label 11673: @746537
      GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(746612), // Rule ID 22645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22645,
        GIR_EraseRootFromParent_Done,
      // Label 11674: @746612
      GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(746687), // Rule ID 22648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22648,
        GIR_EraseRootFromParent_Done,
      // Label 11675: @746687
      GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(746762), // Rule ID 22649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22649,
        GIR_EraseRootFromParent_Done,
      // Label 11676: @746762
      GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(746837), // Rule ID 22652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22652,
        GIR_EraseRootFromParent_Done,
      // Label 11677: @746837
      GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(746912), // Rule ID 22653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22653,
        GIR_EraseRootFromParent_Done,
      // Label 11678: @746912
      GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(746987), // Rule ID 22656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22656,
        GIR_EraseRootFromParent_Done,
      // Label 11679: @746987
      GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(747062), // Rule ID 22657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22657,
        GIR_EraseRootFromParent_Done,
      // Label 11680: @747062
      GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(747137), // Rule ID 22660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22660,
        GIR_EraseRootFromParent_Done,
      // Label 11681: @747137
      GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(747212), // Rule ID 22661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22661,
        GIR_EraseRootFromParent_Done,
      // Label 11682: @747212
      GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(747287), // Rule ID 22664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22664,
        GIR_EraseRootFromParent_Done,
      // Label 11683: @747287
      GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(747362), // Rule ID 22665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22665,
        GIR_EraseRootFromParent_Done,
      // Label 11684: @747362
      GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(747437), // Rule ID 22668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22668,
        GIR_EraseRootFromParent_Done,
      // Label 11685: @747437
      GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(747512), // Rule ID 22669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22669,
        GIR_EraseRootFromParent_Done,
      // Label 11686: @747512
      GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(747587), // Rule ID 22672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22672,
        GIR_EraseRootFromParent_Done,
      // Label 11687: @747587
      GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(747662), // Rule ID 22673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22673,
        GIR_EraseRootFromParent_Done,
      // Label 11688: @747662
      GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(747737), // Rule ID 22676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22676,
        GIR_EraseRootFromParent_Done,
      // Label 11689: @747737
      GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(747812), // Rule ID 22677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22677,
        GIR_EraseRootFromParent_Done,
      // Label 11690: @747812
      GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(747887), // Rule ID 22796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22796,
        GIR_EraseRootFromParent_Done,
      // Label 11691: @747887
      GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(747962), // Rule ID 22797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22797,
        GIR_EraseRootFromParent_Done,
      // Label 11692: @747962
      GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(748037), // Rule ID 22800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22800,
        GIR_EraseRootFromParent_Done,
      // Label 11693: @748037
      GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(748112), // Rule ID 22801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22801,
        GIR_EraseRootFromParent_Done,
      // Label 11694: @748112
      GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(748187), // Rule ID 22804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22804,
        GIR_EraseRootFromParent_Done,
      // Label 11695: @748187
      GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(748262), // Rule ID 22805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22805,
        GIR_EraseRootFromParent_Done,
      // Label 11696: @748262
      GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(748337), // Rule ID 22808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22808,
        GIR_EraseRootFromParent_Done,
      // Label 11697: @748337
      GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(748412), // Rule ID 22809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22809,
        GIR_EraseRootFromParent_Done,
      // Label 11698: @748412
      GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(748487), // Rule ID 22812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22812,
        GIR_EraseRootFromParent_Done,
      // Label 11699: @748487
      GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(748562), // Rule ID 22813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22813,
        GIR_EraseRootFromParent_Done,
      // Label 11700: @748562
      GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(748637), // Rule ID 22816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22816,
        GIR_EraseRootFromParent_Done,
      // Label 11701: @748637
      GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(748712), // Rule ID 22817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22817,
        GIR_EraseRootFromParent_Done,
      // Label 11702: @748712
      GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(748787), // Rule ID 22820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22820,
        GIR_EraseRootFromParent_Done,
      // Label 11703: @748787
      GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(748862), // Rule ID 22821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22821,
        GIR_EraseRootFromParent_Done,
      // Label 11704: @748862
      GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(748937), // Rule ID 22824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22824,
        GIR_EraseRootFromParent_Done,
      // Label 11705: @748937
      GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(749012), // Rule ID 22825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22825,
        GIR_EraseRootFromParent_Done,
      // Label 11706: @749012
      GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(749087), // Rule ID 22828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22828,
        GIR_EraseRootFromParent_Done,
      // Label 11707: @749087
      GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(749162), // Rule ID 22829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10862:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22829,
        GIR_EraseRootFromParent_Done,
      // Label 11708: @749162
      GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(749237), // Rule ID 22832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22832,
        GIR_EraseRootFromParent_Done,
      // Label 11709: @749237
      GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(749312), // Rule ID 22833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22833,
        GIR_EraseRootFromParent_Done,
      // Label 11710: @749312
      GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(749387), // Rule ID 22836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22836,
        GIR_EraseRootFromParent_Done,
      // Label 11711: @749387
      GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(749462), // Rule ID 22837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22837,
        GIR_EraseRootFromParent_Done,
      // Label 11712: @749462
      GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(749537), // Rule ID 22840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22840,
        GIR_EraseRootFromParent_Done,
      // Label 11713: @749537
      GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(749612), // Rule ID 22841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10862:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22841,
        GIR_EraseRootFromParent_Done,
      // Label 11714: @749612
      GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(749687), // Rule ID 22844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22844,
        GIR_EraseRootFromParent_Done,
      // Label 11715: @749687
      GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(749762), // Rule ID 22845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22845,
        GIR_EraseRootFromParent_Done,
      // Label 11716: @749762
      GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(749837), // Rule ID 22848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22848,
        GIR_EraseRootFromParent_Done,
      // Label 11717: @749837
      GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(749912), // Rule ID 22849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22849,
        GIR_EraseRootFromParent_Done,
      // Label 11718: @749912
      GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(749987), // Rule ID 22852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22852,
        GIR_EraseRootFromParent_Done,
      // Label 11719: @749987
      GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(750062), // Rule ID 22853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10862:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22853,
        GIR_EraseRootFromParent_Done,
      // Label 11720: @750062
      GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(750137), // Rule ID 22856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22856,
        GIR_EraseRootFromParent_Done,
      // Label 11721: @750137
      GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(750212), // Rule ID 22857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22857,
        GIR_EraseRootFromParent_Done,
      // Label 11722: @750212
      GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(750287), // Rule ID 22860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22860,
        GIR_EraseRootFromParent_Done,
      // Label 11723: @750287
      GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(750362), // Rule ID 22861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22861,
        GIR_EraseRootFromParent_Done,
      // Label 11724: @750362
      GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(750437), // Rule ID 22864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22864,
        GIR_EraseRootFromParent_Done,
      // Label 11725: @750437
      GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(750512), // Rule ID 22865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22865,
        GIR_EraseRootFromParent_Done,
      // Label 11726: @750512
      GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(750587), // Rule ID 22868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22868,
        GIR_EraseRootFromParent_Done,
      // Label 11727: @750587
      GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(750662), // Rule ID 22869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22869,
        GIR_EraseRootFromParent_Done,
      // Label 11728: @750662
      GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(750737), // Rule ID 22872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22872,
        GIR_EraseRootFromParent_Done,
      // Label 11729: @750737
      GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(750812), // Rule ID 22873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22873,
        GIR_EraseRootFromParent_Done,
      // Label 11730: @750812
      GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(750887), // Rule ID 22876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22876,
        GIR_EraseRootFromParent_Done,
      // Label 11731: @750887
      GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(750962), // Rule ID 22877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22877,
        GIR_EraseRootFromParent_Done,
      // Label 11732: @750962
      GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(751037), // Rule ID 22880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22880,
        GIR_EraseRootFromParent_Done,
      // Label 11733: @751037
      GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(751112), // Rule ID 22881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22881,
        GIR_EraseRootFromParent_Done,
      // Label 11734: @751112
      GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(751187), // Rule ID 22884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22884,
        GIR_EraseRootFromParent_Done,
      // Label 11735: @751187
      GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(751262), // Rule ID 22885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22885,
        GIR_EraseRootFromParent_Done,
      // Label 11736: @751262
      GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(751337), // Rule ID 22888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22888,
        GIR_EraseRootFromParent_Done,
      // Label 11737: @751337
      GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(751412), // Rule ID 22889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10860:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22889,
        GIR_EraseRootFromParent_Done,
      // Label 11738: @751412
      GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(751487), // Rule ID 22892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22892,
        GIR_EraseRootFromParent_Done,
      // Label 11739: @751487
      GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(751562), // Rule ID 22893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22893,
        GIR_EraseRootFromParent_Done,
      // Label 11740: @751562
      GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(751637), // Rule ID 22896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22896,
        GIR_EraseRootFromParent_Done,
      // Label 11741: @751637
      GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(751712), // Rule ID 22897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22897,
        GIR_EraseRootFromParent_Done,
      // Label 11742: @751712
      GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(751787), // Rule ID 22900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22900,
        GIR_EraseRootFromParent_Done,
      // Label 11743: @751787
      GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(751862), // Rule ID 22901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10860:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22901,
        GIR_EraseRootFromParent_Done,
      // Label 11744: @751862
      GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(751937), // Rule ID 22904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22904,
        GIR_EraseRootFromParent_Done,
      // Label 11745: @751937
      GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(752012), // Rule ID 22905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22905,
        GIR_EraseRootFromParent_Done,
      // Label 11746: @752012
      GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(752087), // Rule ID 22908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22908,
        GIR_EraseRootFromParent_Done,
      // Label 11747: @752087
      GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(752162), // Rule ID 22909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22909,
        GIR_EraseRootFromParent_Done,
      // Label 11748: @752162
      GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(752237), // Rule ID 22912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22912,
        GIR_EraseRootFromParent_Done,
      // Label 11749: @752237
      GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(752312), // Rule ID 22913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10860:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22913,
        GIR_EraseRootFromParent_Done,
      // Label 11750: @752312
      GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(752405), // Rule ID 23194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23194,
        GIR_EraseRootFromParent_Done,
      // Label 11751: @752405
      GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(752498), // Rule ID 23195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23195,
        GIR_EraseRootFromParent_Done,
      // Label 11752: @752498
      GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(752591), // Rule ID 23198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23198,
        GIR_EraseRootFromParent_Done,
      // Label 11753: @752591
      GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(752684), // Rule ID 23199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23199,
        GIR_EraseRootFromParent_Done,
      // Label 11754: @752684
      GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(752777), // Rule ID 23202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23202,
        GIR_EraseRootFromParent_Done,
      // Label 11755: @752777
      GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(752870), // Rule ID 23203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23203,
        GIR_EraseRootFromParent_Done,
      // Label 11756: @752870
      GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(752963), // Rule ID 23206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23206,
        GIR_EraseRootFromParent_Done,
      // Label 11757: @752963
      GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(753056), // Rule ID 23207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23207,
        GIR_EraseRootFromParent_Done,
      // Label 11758: @753056
      GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(753149), // Rule ID 23210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23210,
        GIR_EraseRootFromParent_Done,
      // Label 11759: @753149
      GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(753242), // Rule ID 23211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23211,
        GIR_EraseRootFromParent_Done,
      // Label 11760: @753242
      GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(753335), // Rule ID 23214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23214,
        GIR_EraseRootFromParent_Done,
      // Label 11761: @753335
      GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(753428), // Rule ID 23215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11050:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23215,
        GIR_EraseRootFromParent_Done,
      // Label 11762: @753428
      GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(753521), // Rule ID 23218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23218,
        GIR_EraseRootFromParent_Done,
      // Label 11763: @753521
      GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(753614), // Rule ID 23219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23219,
        GIR_EraseRootFromParent_Done,
      // Label 11764: @753614
      GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(753707), // Rule ID 23222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23222,
        GIR_EraseRootFromParent_Done,
      // Label 11765: @753707
      GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(753800), // Rule ID 23223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23223,
        GIR_EraseRootFromParent_Done,
      // Label 11766: @753800
      GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(753893), // Rule ID 23226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23226,
        GIR_EraseRootFromParent_Done,
      // Label 11767: @753893
      GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(753986), // Rule ID 23227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23227,
        GIR_EraseRootFromParent_Done,
      // Label 11768: @753986
      GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(754079), // Rule ID 23230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23230,
        GIR_EraseRootFromParent_Done,
      // Label 11769: @754079
      GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(754172), // Rule ID 23231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23231,
        GIR_EraseRootFromParent_Done,
      // Label 11770: @754172
      GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(754265), // Rule ID 23234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23234,
        GIR_EraseRootFromParent_Done,
      // Label 11771: @754265
      GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(754358), // Rule ID 23235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23235,
        GIR_EraseRootFromParent_Done,
      // Label 11772: @754358
      GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(754451), // Rule ID 23238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23238,
        GIR_EraseRootFromParent_Done,
      // Label 11773: @754451
      GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(754544), // Rule ID 23239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23239,
        GIR_EraseRootFromParent_Done,
      // Label 11774: @754544
      GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(754637), // Rule ID 23242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23242,
        GIR_EraseRootFromParent_Done,
      // Label 11775: @754637
      GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(754730), // Rule ID 23243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11063:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23243,
        GIR_EraseRootFromParent_Done,
      // Label 11776: @754730
      GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(754823), // Rule ID 23246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23246,
        GIR_EraseRootFromParent_Done,
      // Label 11777: @754823
      GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(754916), // Rule ID 23247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23247,
        GIR_EraseRootFromParent_Done,
      // Label 11778: @754916
      GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(755009), // Rule ID 23250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23250,
        GIR_EraseRootFromParent_Done,
      // Label 11779: @755009
      GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(755102), // Rule ID 23251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23251,
        GIR_EraseRootFromParent_Done,
      // Label 11780: @755102
      GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(755195), // Rule ID 23254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23254,
        GIR_EraseRootFromParent_Done,
      // Label 11781: @755195
      GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(755288), // Rule ID 23255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23255,
        GIR_EraseRootFromParent_Done,
      // Label 11782: @755288
      GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(755381), // Rule ID 23258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23258,
        GIR_EraseRootFromParent_Done,
      // Label 11783: @755381
      GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(755474), // Rule ID 23259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23259,
        GIR_EraseRootFromParent_Done,
      // Label 11784: @755474
      GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(755567), // Rule ID 23262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23262,
        GIR_EraseRootFromParent_Done,
      // Label 11785: @755567
      GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(755660), // Rule ID 23263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23263,
        GIR_EraseRootFromParent_Done,
      // Label 11786: @755660
      GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(755753), // Rule ID 23266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23266,
        GIR_EraseRootFromParent_Done,
      // Label 11787: @755753
      GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(755846), // Rule ID 23267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23267,
        GIR_EraseRootFromParent_Done,
      // Label 11788: @755846
      GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(755939), // Rule ID 23270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23270,
        GIR_EraseRootFromParent_Done,
      // Label 11789: @755939
      GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(756032), // Rule ID 23271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11075:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23271,
        GIR_EraseRootFromParent_Done,
      // Label 11790: @756032
      GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(756107), // Rule ID 23812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23812,
        GIR_EraseRootFromParent_Done,
      // Label 11791: @756107
      GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(756182), // Rule ID 23813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23813,
        GIR_EraseRootFromParent_Done,
      // Label 11792: @756182
      GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(756257), // Rule ID 23816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23816,
        GIR_EraseRootFromParent_Done,
      // Label 11793: @756257
      GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(756332), // Rule ID 23817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23817,
        GIR_EraseRootFromParent_Done,
      // Label 11794: @756332
      GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(756407), // Rule ID 23820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23820,
        GIR_EraseRootFromParent_Done,
      // Label 11795: @756407
      GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(756482), // Rule ID 23821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23821,
        GIR_EraseRootFromParent_Done,
      // Label 11796: @756482
      GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(756557), // Rule ID 23824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23824,
        GIR_EraseRootFromParent_Done,
      // Label 11797: @756557
      GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(756632), // Rule ID 23825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23825,
        GIR_EraseRootFromParent_Done,
      // Label 11798: @756632
      GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(756707), // Rule ID 23828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23828,
        GIR_EraseRootFromParent_Done,
      // Label 11799: @756707
      GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(756782), // Rule ID 23829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23829,
        GIR_EraseRootFromParent_Done,
      // Label 11800: @756782
      GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(756857), // Rule ID 23832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23832,
        GIR_EraseRootFromParent_Done,
      // Label 11801: @756857
      GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(756932), // Rule ID 23833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23833,
        GIR_EraseRootFromParent_Done,
      // Label 11802: @756932
      GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(757007), // Rule ID 23836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23836,
        GIR_EraseRootFromParent_Done,
      // Label 11803: @757007
      GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(757082), // Rule ID 23837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23837,
        GIR_EraseRootFromParent_Done,
      // Label 11804: @757082
      GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(757157), // Rule ID 23840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23840,
        GIR_EraseRootFromParent_Done,
      // Label 11805: @757157
      GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(757232), // Rule ID 23841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23841,
        GIR_EraseRootFromParent_Done,
      // Label 11806: @757232
      GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(757307), // Rule ID 23844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23844,
        GIR_EraseRootFromParent_Done,
      // Label 11807: @757307
      GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(757382), // Rule ID 23845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23845,
        GIR_EraseRootFromParent_Done,
      // Label 11808: @757382
      GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(757457), // Rule ID 23848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23848,
        GIR_EraseRootFromParent_Done,
      // Label 11809: @757457
      GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(757532), // Rule ID 23849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23849,
        GIR_EraseRootFromParent_Done,
      // Label 11810: @757532
      GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(757607), // Rule ID 23852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23852,
        GIR_EraseRootFromParent_Done,
      // Label 11811: @757607
      GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(757682), // Rule ID 23853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23853,
        GIR_EraseRootFromParent_Done,
      // Label 11812: @757682
      GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(757757), // Rule ID 23856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23856,
        GIR_EraseRootFromParent_Done,
      // Label 11813: @757757
      GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(757832), // Rule ID 23857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23857,
        GIR_EraseRootFromParent_Done,
      // Label 11814: @757832
      GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(757907), // Rule ID 23860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23860,
        GIR_EraseRootFromParent_Done,
      // Label 11815: @757907
      GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(757982), // Rule ID 23861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23861,
        GIR_EraseRootFromParent_Done,
      // Label 11816: @757982
      GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(758057), // Rule ID 23864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23864,
        GIR_EraseRootFromParent_Done,
      // Label 11817: @758057
      GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(758132), // Rule ID 23865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23865,
        GIR_EraseRootFromParent_Done,
      // Label 11818: @758132
      GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(758207), // Rule ID 23868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23868,
        GIR_EraseRootFromParent_Done,
      // Label 11819: @758207
      GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(758282), // Rule ID 23869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23869,
        GIR_EraseRootFromParent_Done,
      // Label 11820: @758282
      GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(758357), // Rule ID 23872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23872,
        GIR_EraseRootFromParent_Done,
      // Label 11821: @758357
      GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(758432), // Rule ID 23873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23873,
        GIR_EraseRootFromParent_Done,
      // Label 11822: @758432
      GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(758507), // Rule ID 23876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23876,
        GIR_EraseRootFromParent_Done,
      // Label 11823: @758507
      GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(758582), // Rule ID 23877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23877,
        GIR_EraseRootFromParent_Done,
      // Label 11824: @758582
      GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(758657), // Rule ID 23880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23880,
        GIR_EraseRootFromParent_Done,
      // Label 11825: @758657
      GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(758732), // Rule ID 23881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23881,
        GIR_EraseRootFromParent_Done,
      // Label 11826: @758732
      GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(758807), // Rule ID 23884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23884,
        GIR_EraseRootFromParent_Done,
      // Label 11827: @758807
      GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(758882), // Rule ID 23885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23885,
        GIR_EraseRootFromParent_Done,
      // Label 11828: @758882
      GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(758957), // Rule ID 23888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23888,
        GIR_EraseRootFromParent_Done,
      // Label 11829: @758957
      GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(759032), // Rule ID 23889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23889,
        GIR_EraseRootFromParent_Done,
      // Label 11830: @759032
      GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(759107), // Rule ID 23892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23892,
        GIR_EraseRootFromParent_Done,
      // Label 11831: @759107
      GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(759182), // Rule ID 23893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23893,
        GIR_EraseRootFromParent_Done,
      // Label 11832: @759182
      GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(759257), // Rule ID 23896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23896,
        GIR_EraseRootFromParent_Done,
      // Label 11833: @759257
      GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(759332), // Rule ID 23897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23897,
        GIR_EraseRootFromParent_Done,
      // Label 11834: @759332
      GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(759407), // Rule ID 23900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23900,
        GIR_EraseRootFromParent_Done,
      // Label 11835: @759407
      GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(759482), // Rule ID 23901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23901,
        GIR_EraseRootFromParent_Done,
      // Label 11836: @759482
      GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(759557), // Rule ID 23904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23904,
        GIR_EraseRootFromParent_Done,
      // Label 11837: @759557
      GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(759632), // Rule ID 23905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23905,
        GIR_EraseRootFromParent_Done,
      // Label 11838: @759632
      GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(759707), // Rule ID 23908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23908,
        GIR_EraseRootFromParent_Done,
      // Label 11839: @759707
      GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(759782), // Rule ID 23909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23909,
        GIR_EraseRootFromParent_Done,
      // Label 11840: @759782
      GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(759857), // Rule ID 23912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23912,
        GIR_EraseRootFromParent_Done,
      // Label 11841: @759857
      GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(759932), // Rule ID 23913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23913,
        GIR_EraseRootFromParent_Done,
      // Label 11842: @759932
      GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(760007), // Rule ID 23916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23916,
        GIR_EraseRootFromParent_Done,
      // Label 11843: @760007
      GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(760082), // Rule ID 23917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23917,
        GIR_EraseRootFromParent_Done,
      // Label 11844: @760082
      GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(760157), // Rule ID 23920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23920,
        GIR_EraseRootFromParent_Done,
      // Label 11845: @760157
      GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(760232), // Rule ID 23921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23921,
        GIR_EraseRootFromParent_Done,
      // Label 11846: @760232
      GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(760307), // Rule ID 23924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23924,
        GIR_EraseRootFromParent_Done,
      // Label 11847: @760307
      GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(760382), // Rule ID 23925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23925,
        GIR_EraseRootFromParent_Done,
      // Label 11848: @760382
      GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(760457), // Rule ID 23928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23928,
        GIR_EraseRootFromParent_Done,
      // Label 11849: @760457
      GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(760532), // Rule ID 23929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23929,
        GIR_EraseRootFromParent_Done,
      // Label 11850: @760532
      GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(760607), // Rule ID 23932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23932,
        GIR_EraseRootFromParent_Done,
      // Label 11851: @760607
      GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(760682), // Rule ID 23933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23933,
        GIR_EraseRootFromParent_Done,
      // Label 11852: @760682
      GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(760757), // Rule ID 23936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23936,
        GIR_EraseRootFromParent_Done,
      // Label 11853: @760757
      GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(760832), // Rule ID 23937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23937,
        GIR_EraseRootFromParent_Done,
      // Label 11854: @760832
      GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(760907), // Rule ID 23940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23940,
        GIR_EraseRootFromParent_Done,
      // Label 11855: @760907
      GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(760982), // Rule ID 23941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23941,
        GIR_EraseRootFromParent_Done,
      // Label 11856: @760982
      GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(761057), // Rule ID 23944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23944,
        GIR_EraseRootFromParent_Done,
      // Label 11857: @761057
      GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(761132), // Rule ID 23945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23945,
        GIR_EraseRootFromParent_Done,
      // Label 11858: @761132
      GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(761207), // Rule ID 23948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23948,
        GIR_EraseRootFromParent_Done,
      // Label 11859: @761207
      GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(761282), // Rule ID 23949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23949,
        GIR_EraseRootFromParent_Done,
      // Label 11860: @761282
      GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(761357), // Rule ID 23952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23952,
        GIR_EraseRootFromParent_Done,
      // Label 11861: @761357
      GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(761432), // Rule ID 23953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23953,
        GIR_EraseRootFromParent_Done,
      // Label 11862: @761432
      GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(761507), // Rule ID 23956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23956,
        GIR_EraseRootFromParent_Done,
      // Label 11863: @761507
      GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(761582), // Rule ID 23957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23957,
        GIR_EraseRootFromParent_Done,
      // Label 11864: @761582
      GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(761657), // Rule ID 23960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23960,
        GIR_EraseRootFromParent_Done,
      // Label 11865: @761657
      GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(761732), // Rule ID 23961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23961,
        GIR_EraseRootFromParent_Done,
      // Label 11866: @761732
      GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(761807), // Rule ID 23964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23964,
        GIR_EraseRootFromParent_Done,
      // Label 11867: @761807
      GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(761882), // Rule ID 23965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23965,
        GIR_EraseRootFromParent_Done,
      // Label 11868: @761882
      GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(761957), // Rule ID 23968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23968,
        GIR_EraseRootFromParent_Done,
      // Label 11869: @761957
      GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(762032), // Rule ID 23969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23969,
        GIR_EraseRootFromParent_Done,
      // Label 11870: @762032
      GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(762107), // Rule ID 23972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23972,
        GIR_EraseRootFromParent_Done,
      // Label 11871: @762107
      GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(762182), // Rule ID 23973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23973,
        GIR_EraseRootFromParent_Done,
      // Label 11872: @762182
      GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(762257), // Rule ID 23976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23976,
        GIR_EraseRootFromParent_Done,
      // Label 11873: @762257
      GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(762332), // Rule ID 23977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23977,
        GIR_EraseRootFromParent_Done,
      // Label 11874: @762332
      GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(762407), // Rule ID 23980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23980,
        GIR_EraseRootFromParent_Done,
      // Label 11875: @762407
      GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(762482), // Rule ID 23981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23981,
        GIR_EraseRootFromParent_Done,
      // Label 11876: @762482
      GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(762557), // Rule ID 23984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23984,
        GIR_EraseRootFromParent_Done,
      // Label 11877: @762557
      GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(762632), // Rule ID 23985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23985,
        GIR_EraseRootFromParent_Done,
      // Label 11878: @762632
      GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(762707), // Rule ID 24228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24228,
        GIR_EraseRootFromParent_Done,
      // Label 11879: @762707
      GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(762782), // Rule ID 24229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24229,
        GIR_EraseRootFromParent_Done,
      // Label 11880: @762782
      GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(762857), // Rule ID 24232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24232,
        GIR_EraseRootFromParent_Done,
      // Label 11881: @762857
      GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(762932), // Rule ID 24233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24233,
        GIR_EraseRootFromParent_Done,
      // Label 11882: @762932
      GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(763007), // Rule ID 24236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24236,
        GIR_EraseRootFromParent_Done,
      // Label 11883: @763007
      GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(763082), // Rule ID 24237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24237,
        GIR_EraseRootFromParent_Done,
      // Label 11884: @763082
      GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(763157), // Rule ID 24240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24240,
        GIR_EraseRootFromParent_Done,
      // Label 11885: @763157
      GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(763232), // Rule ID 24241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10880:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24241,
        GIR_EraseRootFromParent_Done,
      // Label 11886: @763232
      GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(763307), // Rule ID 24244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10880:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24244,
        GIR_EraseRootFromParent_Done,
      // Label 11887: @763307
      GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(763382), // Rule ID 24245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10880:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24245,
        GIR_EraseRootFromParent_Done,
      // Label 11888: @763382
      GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(763457), // Rule ID 24248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24248,
        GIR_EraseRootFromParent_Done,
      // Label 11889: @763457
      GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(763532), // Rule ID 24249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10880:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24249,
        GIR_EraseRootFromParent_Done,
      // Label 11890: @763532
      GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(763607), // Rule ID 24252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24252,
        GIR_EraseRootFromParent_Done,
      // Label 11891: @763607
      GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(763682), // Rule ID 24253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24253,
        GIR_EraseRootFromParent_Done,
      // Label 11892: @763682
      GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(763757), // Rule ID 24256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24256,
        GIR_EraseRootFromParent_Done,
      // Label 11893: @763757
      GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(763832), // Rule ID 24257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24257,
        GIR_EraseRootFromParent_Done,
      // Label 11894: @763832
      GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(763907), // Rule ID 24260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24260,
        GIR_EraseRootFromParent_Done,
      // Label 11895: @763907
      GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(763982), // Rule ID 24261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24261,
        GIR_EraseRootFromParent_Done,
      // Label 11896: @763982
      GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(764057), // Rule ID 24264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24264,
        GIR_EraseRootFromParent_Done,
      // Label 11897: @764057
      GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(764132), // Rule ID 24265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24265,
        GIR_EraseRootFromParent_Done,
      // Label 11898: @764132
      GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(764207), // Rule ID 24268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24268,
        GIR_EraseRootFromParent_Done,
      // Label 11899: @764207
      GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(764282), // Rule ID 24269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24269,
        GIR_EraseRootFromParent_Done,
      // Label 11900: @764282
      GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(764357), // Rule ID 24272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24272,
        GIR_EraseRootFromParent_Done,
      // Label 11901: @764357
      GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(764432), // Rule ID 24273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24273,
        GIR_EraseRootFromParent_Done,
      // Label 11902: @764432
      GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(764507), // Rule ID 24276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24276,
        GIR_EraseRootFromParent_Done,
      // Label 11903: @764507
      GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(764582), // Rule ID 24277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10880:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24277,
        GIR_EraseRootFromParent_Done,
      // Label 11904: @764582
      GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(764657), // Rule ID 24280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24280,
        GIR_EraseRootFromParent_Done,
      // Label 11905: @764657
      GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(764732), // Rule ID 24281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10880:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24281,
        GIR_EraseRootFromParent_Done,
      // Label 11906: @764732
      GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(764807), // Rule ID 24284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24284,
        GIR_EraseRootFromParent_Done,
      // Label 11907: @764807
      GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(764882), // Rule ID 24285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10880:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24285,
        GIR_EraseRootFromParent_Done,
      // Label 11908: @764882
      GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(764957), // Rule ID 24288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24288,
        GIR_EraseRootFromParent_Done,
      // Label 11909: @764957
      GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(765032), // Rule ID 24289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24289,
        GIR_EraseRootFromParent_Done,
      // Label 11910: @765032
      GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(765107), // Rule ID 24292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24292,
        GIR_EraseRootFromParent_Done,
      // Label 11911: @765107
      GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(765182), // Rule ID 24293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24293,
        GIR_EraseRootFromParent_Done,
      // Label 11912: @765182
      GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(765257), // Rule ID 24296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24296,
        GIR_EraseRootFromParent_Done,
      // Label 11913: @765257
      GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(765332), // Rule ID 24297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24297,
        GIR_EraseRootFromParent_Done,
      // Label 11914: @765332
      GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(765407), // Rule ID 24300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24300,
        GIR_EraseRootFromParent_Done,
      // Label 11915: @765407
      GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(765482), // Rule ID 24301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10878:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24301,
        GIR_EraseRootFromParent_Done,
      // Label 11916: @765482
      GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(765557), // Rule ID 24304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10878:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24304,
        GIR_EraseRootFromParent_Done,
      // Label 11917: @765557
      GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(765632), // Rule ID 24305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10878:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24305,
        GIR_EraseRootFromParent_Done,
      // Label 11918: @765632
      GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(765707), // Rule ID 24308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24308,
        GIR_EraseRootFromParent_Done,
      // Label 11919: @765707
      GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(765782), // Rule ID 24309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10878:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24309,
        GIR_EraseRootFromParent_Done,
      // Label 11920: @765782
      GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(765857), // Rule ID 24312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24312,
        GIR_EraseRootFromParent_Done,
      // Label 11921: @765857
      GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(765932), // Rule ID 24313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24313,
        GIR_EraseRootFromParent_Done,
      // Label 11922: @765932
      GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(766007), // Rule ID 24316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24316,
        GIR_EraseRootFromParent_Done,
      // Label 11923: @766007
      GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(766082), // Rule ID 24317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24317,
        GIR_EraseRootFromParent_Done,
      // Label 11924: @766082
      GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(766157), // Rule ID 24320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24320,
        GIR_EraseRootFromParent_Done,
      // Label 11925: @766157
      GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(766232), // Rule ID 24321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24321,
        GIR_EraseRootFromParent_Done,
      // Label 11926: @766232
      GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(766307), // Rule ID 24324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24324,
        GIR_EraseRootFromParent_Done,
      // Label 11927: @766307
      GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(766382), // Rule ID 24325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24325,
        GIR_EraseRootFromParent_Done,
      // Label 11928: @766382
      GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(766457), // Rule ID 24328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24328,
        GIR_EraseRootFromParent_Done,
      // Label 11929: @766457
      GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(766532), // Rule ID 24329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24329,
        GIR_EraseRootFromParent_Done,
      // Label 11930: @766532
      GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(766607), // Rule ID 24332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24332,
        GIR_EraseRootFromParent_Done,
      // Label 11931: @766607
      GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(766682), // Rule ID 24333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24333,
        GIR_EraseRootFromParent_Done,
      // Label 11932: @766682
      GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(766757), // Rule ID 24336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24336,
        GIR_EraseRootFromParent_Done,
      // Label 11933: @766757
      GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(766832), // Rule ID 24337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10878:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24337,
        GIR_EraseRootFromParent_Done,
      // Label 11934: @766832
      GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(766907), // Rule ID 24340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24340,
        GIR_EraseRootFromParent_Done,
      // Label 11935: @766907
      GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(766982), // Rule ID 24341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10878:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24341,
        GIR_EraseRootFromParent_Done,
      // Label 11936: @766982
      GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(767057), // Rule ID 24344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24344,
        GIR_EraseRootFromParent_Done,
      // Label 11937: @767057
      GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(767132), // Rule ID 24345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10878:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24345,
        GIR_EraseRootFromParent_Done,
      // Label 11938: @767132
      GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(767207), // Rule ID 24348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24348,
        GIR_EraseRootFromParent_Done,
      // Label 11939: @767207
      GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(767282), // Rule ID 24349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24349,
        GIR_EraseRootFromParent_Done,
      // Label 11940: @767282
      GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(767357), // Rule ID 24352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24352,
        GIR_EraseRootFromParent_Done,
      // Label 11941: @767357
      GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(767432), // Rule ID 24353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24353,
        GIR_EraseRootFromParent_Done,
      // Label 11942: @767432
      GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(767507), // Rule ID 24356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24356,
        GIR_EraseRootFromParent_Done,
      // Label 11943: @767507
      GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(767582), // Rule ID 24357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24357,
        GIR_EraseRootFromParent_Done,
      // Label 11944: @767582
      GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(767657), // Rule ID 24360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24360,
        GIR_EraseRootFromParent_Done,
      // Label 11945: @767657
      GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(767732), // Rule ID 24361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24361,
        GIR_EraseRootFromParent_Done,
      // Label 11946: @767732
      GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(767807), // Rule ID 24364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24364,
        GIR_EraseRootFromParent_Done,
      // Label 11947: @767807
      GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(767882), // Rule ID 24365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24365,
        GIR_EraseRootFromParent_Done,
      // Label 11948: @767882
      GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(767957), // Rule ID 24368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24368,
        GIR_EraseRootFromParent_Done,
      // Label 11949: @767957
      GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(768032), // Rule ID 24369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24369,
        GIR_EraseRootFromParent_Done,
      // Label 11950: @768032
      GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(768107), // Rule ID 24372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24372,
        GIR_EraseRootFromParent_Done,
      // Label 11951: @768107
      GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(768182), // Rule ID 24373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11126:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24373,
        GIR_EraseRootFromParent_Done,
      // Label 11952: @768182
      GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(768257), // Rule ID 24376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24376,
        GIR_EraseRootFromParent_Done,
      // Label 11953: @768257
      GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(768332), // Rule ID 24377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24377,
        GIR_EraseRootFromParent_Done,
      // Label 11954: @768332
      GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(768407), // Rule ID 24380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24380,
        GIR_EraseRootFromParent_Done,
      // Label 11955: @768407
      GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(768482), // Rule ID 24381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24381,
        GIR_EraseRootFromParent_Done,
      // Label 11956: @768482
      GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(768557), // Rule ID 24384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24384,
        GIR_EraseRootFromParent_Done,
      // Label 11957: @768557
      GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(768632), // Rule ID 24385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24385,
        GIR_EraseRootFromParent_Done,
      // Label 11958: @768632
      GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(768707), // Rule ID 24388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24388,
        GIR_EraseRootFromParent_Done,
      // Label 11959: @768707
      GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(768782), // Rule ID 24389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24389,
        GIR_EraseRootFromParent_Done,
      // Label 11960: @768782
      GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(768857), // Rule ID 24392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24392,
        GIR_EraseRootFromParent_Done,
      // Label 11961: @768857
      GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(768932), // Rule ID 24393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24393,
        GIR_EraseRootFromParent_Done,
      // Label 11962: @768932
      GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(769007), // Rule ID 24396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24396,
        GIR_EraseRootFromParent_Done,
      // Label 11963: @769007
      GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(769082), // Rule ID 24397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24397,
        GIR_EraseRootFromParent_Done,
      // Label 11964: @769082
      GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(769157), // Rule ID 24400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24400,
        GIR_EraseRootFromParent_Done,
      // Label 11965: @769157
      GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(769232), // Rule ID 24401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24401,
        GIR_EraseRootFromParent_Done,
      // Label 11966: @769232
      GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(769307), // Rule ID 24404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24404,
        GIR_EraseRootFromParent_Done,
      // Label 11967: @769307
      GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(769382), // Rule ID 24405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24405,
        GIR_EraseRootFromParent_Done,
      // Label 11968: @769382
      GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(769457), // Rule ID 24408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24408,
        GIR_EraseRootFromParent_Done,
      // Label 11969: @769457
      GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(769532), // Rule ID 24409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24409,
        GIR_EraseRootFromParent_Done,
      // Label 11970: @769532
      GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(769607), // Rule ID 24412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24412,
        GIR_EraseRootFromParent_Done,
      // Label 11971: @769607
      GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(769682), // Rule ID 24413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24413,
        GIR_EraseRootFromParent_Done,
      // Label 11972: @769682
      GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(769757), // Rule ID 24416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24416,
        GIR_EraseRootFromParent_Done,
      // Label 11973: @769757
      GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(769832), // Rule ID 24417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24417,
        GIR_EraseRootFromParent_Done,
      // Label 11974: @769832
      GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(769907), // Rule ID 24420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24420,
        GIR_EraseRootFromParent_Done,
      // Label 11975: @769907
      GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(769982), // Rule ID 24421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24421,
        GIR_EraseRootFromParent_Done,
      // Label 11976: @769982
      GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(770057), // Rule ID 24424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24424,
        GIR_EraseRootFromParent_Done,
      // Label 11977: @770057
      GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(770132), // Rule ID 24425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24425,
        GIR_EraseRootFromParent_Done,
      // Label 11978: @770132
      GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(770207), // Rule ID 24428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24428,
        GIR_EraseRootFromParent_Done,
      // Label 11979: @770207
      GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(770282), // Rule ID 24429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24429,
        GIR_EraseRootFromParent_Done,
      // Label 11980: @770282
      GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(770357), // Rule ID 24432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24432,
        GIR_EraseRootFromParent_Done,
      // Label 11981: @770357
      GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(770432), // Rule ID 24433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24433,
        GIR_EraseRootFromParent_Done,
      // Label 11982: @770432
      GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(770507), // Rule ID 24436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24436,
        GIR_EraseRootFromParent_Done,
      // Label 11983: @770507
      GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(770582), // Rule ID 24437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24437,
        GIR_EraseRootFromParent_Done,
      // Label 11984: @770582
      GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(770657), // Rule ID 24440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24440,
        GIR_EraseRootFromParent_Done,
      // Label 11985: @770657
      GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(770732), // Rule ID 24441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24441,
        GIR_EraseRootFromParent_Done,
      // Label 11986: @770732
      GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(770807), // Rule ID 24444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24444,
        GIR_EraseRootFromParent_Done,
      // Label 11987: @770807
      GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(770882), // Rule ID 24445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24445,
        GIR_EraseRootFromParent_Done,
      // Label 11988: @770882
      GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(770957), // Rule ID 24448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24448,
        GIR_EraseRootFromParent_Done,
      // Label 11989: @770957
      GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(771032), // Rule ID 24449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24449,
        GIR_EraseRootFromParent_Done,
      // Label 11990: @771032
      GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(771107), // Rule ID 24452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24452,
        GIR_EraseRootFromParent_Done,
      // Label 11991: @771107
      GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(771182), // Rule ID 24453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24453,
        GIR_EraseRootFromParent_Done,
      // Label 11992: @771182
      GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(771257), // Rule ID 24456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24456,
        GIR_EraseRootFromParent_Done,
      // Label 11993: @771257
      GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(771332), // Rule ID 24457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24457,
        GIR_EraseRootFromParent_Done,
      // Label 11994: @771332
      GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(771407), // Rule ID 24460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24460,
        GIR_EraseRootFromParent_Done,
      // Label 11995: @771407
      GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(771482), // Rule ID 24461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11128:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24461,
        GIR_EraseRootFromParent_Done,
      // Label 11996: @771482
      GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(771557), // Rule ID 24464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24464,
        GIR_EraseRootFromParent_Done,
      // Label 11997: @771557
      GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(771632), // Rule ID 24465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24465,
        GIR_EraseRootFromParent_Done,
      // Label 11998: @771632
      GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(771707), // Rule ID 24468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24468,
        GIR_EraseRootFromParent_Done,
      // Label 11999: @771707
      GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(771782), // Rule ID 24469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24469,
        GIR_EraseRootFromParent_Done,
      // Label 12000: @771782
      GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(771857), // Rule ID 24472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24472,
        GIR_EraseRootFromParent_Done,
      // Label 12001: @771857
      GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(771932), // Rule ID 24473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24473,
        GIR_EraseRootFromParent_Done,
      // Label 12002: @771932
      GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(772007), // Rule ID 24476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24476,
        GIR_EraseRootFromParent_Done,
      // Label 12003: @772007
      GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(772082), // Rule ID 24477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24477,
        GIR_EraseRootFromParent_Done,
      // Label 12004: @772082
      GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(772157), // Rule ID 24480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24480,
        GIR_EraseRootFromParent_Done,
      // Label 12005: @772157
      GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(772232), // Rule ID 24481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24481,
        GIR_EraseRootFromParent_Done,
      // Label 12006: @772232
      GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(772307), // Rule ID 24484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24484,
        GIR_EraseRootFromParent_Done,
      // Label 12007: @772307
      GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(772382), // Rule ID 24485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24485,
        GIR_EraseRootFromParent_Done,
      // Label 12008: @772382
      GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(772457), // Rule ID 24488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24488,
        GIR_EraseRootFromParent_Done,
      // Label 12009: @772457
      GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(772532), // Rule ID 24489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24489,
        GIR_EraseRootFromParent_Done,
      // Label 12010: @772532
      GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(772607), // Rule ID 24492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24492,
        GIR_EraseRootFromParent_Done,
      // Label 12011: @772607
      GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(772682), // Rule ID 24493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24493,
        GIR_EraseRootFromParent_Done,
      // Label 12012: @772682
      GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(772757), // Rule ID 24496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24496,
        GIR_EraseRootFromParent_Done,
      // Label 12013: @772757
      GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(772832), // Rule ID 24497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24497,
        GIR_EraseRootFromParent_Done,
      // Label 12014: @772832
      GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(772907), // Rule ID 24500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24500,
        GIR_EraseRootFromParent_Done,
      // Label 12015: @772907
      GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(772982), // Rule ID 24501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24501,
        GIR_EraseRootFromParent_Done,
      // Label 12016: @772982
      GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(773057), // Rule ID 24504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24504,
        GIR_EraseRootFromParent_Done,
      // Label 12017: @773057
      GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(773132), // Rule ID 24505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24505,
        GIR_EraseRootFromParent_Done,
      // Label 12018: @773132
      GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(773207), // Rule ID 24508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24508,
        GIR_EraseRootFromParent_Done,
      // Label 12019: @773207
      GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(773282), // Rule ID 24509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24509,
        GIR_EraseRootFromParent_Done,
      // Label 12020: @773282
      GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(773357), // Rule ID 24512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24512,
        GIR_EraseRootFromParent_Done,
      // Label 12021: @773357
      GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(773432), // Rule ID 24513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24513,
        GIR_EraseRootFromParent_Done,
      // Label 12022: @773432
      GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(773507), // Rule ID 24516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24516,
        GIR_EraseRootFromParent_Done,
      // Label 12023: @773507
      GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(773582), // Rule ID 24517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24517,
        GIR_EraseRootFromParent_Done,
      // Label 12024: @773582
      GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(773657), // Rule ID 24520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24520,
        GIR_EraseRootFromParent_Done,
      // Label 12025: @773657
      GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(773732), // Rule ID 24521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24521,
        GIR_EraseRootFromParent_Done,
      // Label 12026: @773732
      GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(773807), // Rule ID 24612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24612,
        GIR_EraseRootFromParent_Done,
      // Label 12027: @773807
      GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(773882), // Rule ID 24613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24613,
        GIR_EraseRootFromParent_Done,
      // Label 12028: @773882
      GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(773957), // Rule ID 24616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24616,
        GIR_EraseRootFromParent_Done,
      // Label 12029: @773957
      GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(774032), // Rule ID 24617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24617,
        GIR_EraseRootFromParent_Done,
      // Label 12030: @774032
      GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(774107), // Rule ID 24620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24620,
        GIR_EraseRootFromParent_Done,
      // Label 12031: @774107
      GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(774182), // Rule ID 24621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24621,
        GIR_EraseRootFromParent_Done,
      // Label 12032: @774182
      GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(774257), // Rule ID 24624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24624,
        GIR_EraseRootFromParent_Done,
      // Label 12033: @774257
      GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(774332), // Rule ID 24625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24625,
        GIR_EraseRootFromParent_Done,
      // Label 12034: @774332
      GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(774407), // Rule ID 24628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24628,
        GIR_EraseRootFromParent_Done,
      // Label 12035: @774407
      GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(774482), // Rule ID 24629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24629,
        GIR_EraseRootFromParent_Done,
      // Label 12036: @774482
      GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(774557), // Rule ID 24632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24632,
        GIR_EraseRootFromParent_Done,
      // Label 12037: @774557
      GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(774632), // Rule ID 24633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24633,
        GIR_EraseRootFromParent_Done,
      // Label 12038: @774632
      GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(774707), // Rule ID 24636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11130:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24636,
        GIR_EraseRootFromParent_Done,
      // Label 12039: @774707
      GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(774782), // Rule ID 24637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11130:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24637,
        GIR_EraseRootFromParent_Done,
      // Label 12040: @774782
      GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(774857), // Rule ID 24640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24640,
        GIR_EraseRootFromParent_Done,
      // Label 12041: @774857
      GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(774932), // Rule ID 24641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24641,
        GIR_EraseRootFromParent_Done,
      // Label 12042: @774932
      GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(775007), // Rule ID 24644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24644,
        GIR_EraseRootFromParent_Done,
      // Label 12043: @775007
      GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(775082), // Rule ID 24645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24645,
        GIR_EraseRootFromParent_Done,
      // Label 12044: @775082
      GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(775157), // Rule ID 24648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24648,
        GIR_EraseRootFromParent_Done,
      // Label 12045: @775157
      GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(775232), // Rule ID 24649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24649,
        GIR_EraseRootFromParent_Done,
      // Label 12046: @775232
      GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(775307), // Rule ID 24652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24652,
        GIR_EraseRootFromParent_Done,
      // Label 12047: @775307
      GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(775382), // Rule ID 24653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24653,
        GIR_EraseRootFromParent_Done,
      // Label 12048: @775382
      GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(775457), // Rule ID 24656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24656,
        GIR_EraseRootFromParent_Done,
      // Label 12049: @775457
      GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(775532), // Rule ID 24657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24657,
        GIR_EraseRootFromParent_Done,
      // Label 12050: @775532
      GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(775607), // Rule ID 24660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24660,
        GIR_EraseRootFromParent_Done,
      // Label 12051: @775607
      GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(775682), // Rule ID 24661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24661,
        GIR_EraseRootFromParent_Done,
      // Label 12052: @775682
      GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(775757), // Rule ID 24664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24664,
        GIR_EraseRootFromParent_Done,
      // Label 12053: @775757
      GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(775832), // Rule ID 24665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24665,
        GIR_EraseRootFromParent_Done,
      // Label 12054: @775832
      GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(775907), // Rule ID 24668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24668,
        GIR_EraseRootFromParent_Done,
      // Label 12055: @775907
      GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(775982), // Rule ID 24669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24669,
        GIR_EraseRootFromParent_Done,
      // Label 12056: @775982
      GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(776057), // Rule ID 24672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24672,
        GIR_EraseRootFromParent_Done,
      // Label 12057: @776057
      GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(776132), // Rule ID 24673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24673,
        GIR_EraseRootFromParent_Done,
      // Label 12058: @776132
      GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(776207), // Rule ID 24676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24676,
        GIR_EraseRootFromParent_Done,
      // Label 12059: @776207
      GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(776282), // Rule ID 24677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24677,
        GIR_EraseRootFromParent_Done,
      // Label 12060: @776282
      GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(776357), // Rule ID 24680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24680,
        GIR_EraseRootFromParent_Done,
      // Label 12061: @776357
      GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(776432), // Rule ID 24681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24681,
        GIR_EraseRootFromParent_Done,
      // Label 12062: @776432
      GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(776507), // Rule ID 24684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24684,
        GIR_EraseRootFromParent_Done,
      // Label 12063: @776507
      GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(776582), // Rule ID 24685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24685,
        GIR_EraseRootFromParent_Done,
      // Label 12064: @776582
      GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(776657), // Rule ID 24688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24688,
        GIR_EraseRootFromParent_Done,
      // Label 12065: @776657
      GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(776732), // Rule ID 24689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24689,
        GIR_EraseRootFromParent_Done,
      // Label 12066: @776732
      GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(776807), // Rule ID 24692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24692,
        GIR_EraseRootFromParent_Done,
      // Label 12067: @776807
      GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(776882), // Rule ID 24693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24693,
        GIR_EraseRootFromParent_Done,
      // Label 12068: @776882
      GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(776957), // Rule ID 24696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24696,
        GIR_EraseRootFromParent_Done,
      // Label 12069: @776957
      GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(777032), // Rule ID 24697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24697,
        GIR_EraseRootFromParent_Done,
      // Label 12070: @777032
      GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(777107), // Rule ID 24700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24700,
        GIR_EraseRootFromParent_Done,
      // Label 12071: @777107
      GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(777182), // Rule ID 24701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24701,
        GIR_EraseRootFromParent_Done,
      // Label 12072: @777182
      GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(777257), // Rule ID 24704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24704,
        GIR_EraseRootFromParent_Done,
      // Label 12073: @777257
      GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(777332), // Rule ID 24705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24705,
        GIR_EraseRootFromParent_Done,
      // Label 12074: @777332
      GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(777407), // Rule ID 24708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24708,
        GIR_EraseRootFromParent_Done,
      // Label 12075: @777407
      GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(777482), // Rule ID 24709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24709,
        GIR_EraseRootFromParent_Done,
      // Label 12076: @777482
      GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(777557), // Rule ID 24712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24712,
        GIR_EraseRootFromParent_Done,
      // Label 12077: @777557
      GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(777632), // Rule ID 24713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24713,
        GIR_EraseRootFromParent_Done,
      // Label 12078: @777632
      GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(777707), // Rule ID 24716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24716,
        GIR_EraseRootFromParent_Done,
      // Label 12079: @777707
      GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(777782), // Rule ID 24717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24717,
        GIR_EraseRootFromParent_Done,
      // Label 12080: @777782
      GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(777857), // Rule ID 24720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24720,
        GIR_EraseRootFromParent_Done,
      // Label 12081: @777857
      GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(777932), // Rule ID 24721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24721,
        GIR_EraseRootFromParent_Done,
      // Label 12082: @777932
      GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(778007), // Rule ID 24724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24724,
        GIR_EraseRootFromParent_Done,
      // Label 12083: @778007
      GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(778082), // Rule ID 24725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24725,
        GIR_EraseRootFromParent_Done,
      // Label 12084: @778082
      GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(778157), // Rule ID 24728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24728,
        GIR_EraseRootFromParent_Done,
      // Label 12085: @778157
      GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(778232), // Rule ID 24729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24729,
        GIR_EraseRootFromParent_Done,
      // Label 12086: @778232
      GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(778307), // Rule ID 24732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24732,
        GIR_EraseRootFromParent_Done,
      // Label 12087: @778307
      GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(778382), // Rule ID 24733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24733,
        GIR_EraseRootFromParent_Done,
      // Label 12088: @778382
      GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(778457), // Rule ID 24736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24736,
        GIR_EraseRootFromParent_Done,
      // Label 12089: @778457
      GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(778532), // Rule ID 24737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24737,
        GIR_EraseRootFromParent_Done,
      // Label 12090: @778532
      GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(778607), // Rule ID 24740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24740,
        GIR_EraseRootFromParent_Done,
      // Label 12091: @778607
      GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(778682), // Rule ID 24741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24741,
        GIR_EraseRootFromParent_Done,
      // Label 12092: @778682
      GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(778757), // Rule ID 24744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24744,
        GIR_EraseRootFromParent_Done,
      // Label 12093: @778757
      GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(778832), // Rule ID 24745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24745,
        GIR_EraseRootFromParent_Done,
      // Label 12094: @778832
      GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(778907), // Rule ID 24748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24748,
        GIR_EraseRootFromParent_Done,
      // Label 12095: @778907
      GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(778982), // Rule ID 24749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24749,
        GIR_EraseRootFromParent_Done,
      // Label 12096: @778982
      GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(779057), // Rule ID 24752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24752,
        GIR_EraseRootFromParent_Done,
      // Label 12097: @779057
      GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(779132), // Rule ID 24753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24753,
        GIR_EraseRootFromParent_Done,
      // Label 12098: @779132
      GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(779207), // Rule ID 24756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24756,
        GIR_EraseRootFromParent_Done,
      // Label 12099: @779207
      GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(779282), // Rule ID 24757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24757,
        GIR_EraseRootFromParent_Done,
      // Label 12100: @779282
      GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(779357), // Rule ID 24760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24760,
        GIR_EraseRootFromParent_Done,
      // Label 12101: @779357
      GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(779432), // Rule ID 24761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24761,
        GIR_EraseRootFromParent_Done,
      // Label 12102: @779432
      GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(779507), // Rule ID 24764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24764,
        GIR_EraseRootFromParent_Done,
      // Label 12103: @779507
      GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(779582), // Rule ID 24765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24765,
        GIR_EraseRootFromParent_Done,
      // Label 12104: @779582
      GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(779657), // Rule ID 24804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24804,
        GIR_EraseRootFromParent_Done,
      // Label 12105: @779657
      GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(779732), // Rule ID 24805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24805,
        GIR_EraseRootFromParent_Done,
      // Label 12106: @779732
      GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(779807), // Rule ID 24808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24808,
        GIR_EraseRootFromParent_Done,
      // Label 12107: @779807
      GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(779882), // Rule ID 24809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24809,
        GIR_EraseRootFromParent_Done,
      // Label 12108: @779882
      GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(779957), // Rule ID 24812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24812,
        GIR_EraseRootFromParent_Done,
      // Label 12109: @779957
      GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(780032), // Rule ID 24813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24813,
        GIR_EraseRootFromParent_Done,
      // Label 12110: @780032
      GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(780107), // Rule ID 24816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24816,
        GIR_EraseRootFromParent_Done,
      // Label 12111: @780107
      GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(780182), // Rule ID 24817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24817,
        GIR_EraseRootFromParent_Done,
      // Label 12112: @780182
      GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(780257), // Rule ID 24820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24820,
        GIR_EraseRootFromParent_Done,
      // Label 12113: @780257
      GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(780332), // Rule ID 24821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24821,
        GIR_EraseRootFromParent_Done,
      // Label 12114: @780332
      GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(780407), // Rule ID 24824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24824,
        GIR_EraseRootFromParent_Done,
      // Label 12115: @780407
      GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(780482), // Rule ID 24825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24825,
        GIR_EraseRootFromParent_Done,
      // Label 12116: @780482
      GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(780557), // Rule ID 24828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24828,
        GIR_EraseRootFromParent_Done,
      // Label 12117: @780557
      GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(780632), // Rule ID 24829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24829,
        GIR_EraseRootFromParent_Done,
      // Label 12118: @780632
      GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(780707), // Rule ID 24832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24832,
        GIR_EraseRootFromParent_Done,
      // Label 12119: @780707
      GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(780782), // Rule ID 24833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24833,
        GIR_EraseRootFromParent_Done,
      // Label 12120: @780782
      GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(780857), // Rule ID 24836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24836,
        GIR_EraseRootFromParent_Done,
      // Label 12121: @780857
      GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(780932), // Rule ID 24837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24837,
        GIR_EraseRootFromParent_Done,
      // Label 12122: @780932
      GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(781007), // Rule ID 24840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24840,
        GIR_EraseRootFromParent_Done,
      // Label 12123: @781007
      GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(781082), // Rule ID 24841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24841,
        GIR_EraseRootFromParent_Done,
      // Label 12124: @781082
      GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(781157), // Rule ID 24844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24844,
        GIR_EraseRootFromParent_Done,
      // Label 12125: @781157
      GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(781232), // Rule ID 24845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24845,
        GIR_EraseRootFromParent_Done,
      // Label 12126: @781232
      GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(781307), // Rule ID 24848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24848,
        GIR_EraseRootFromParent_Done,
      // Label 12127: @781307
      GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(781382), // Rule ID 24849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24849,
        GIR_EraseRootFromParent_Done,
      // Label 12128: @781382
      GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(781457), // Rule ID 24876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24876,
        GIR_EraseRootFromParent_Done,
      // Label 12129: @781457
      GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(781532), // Rule ID 24877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24877,
        GIR_EraseRootFromParent_Done,
      // Label 12130: @781532
      GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(781607), // Rule ID 24880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24880,
        GIR_EraseRootFromParent_Done,
      // Label 12131: @781607
      GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(781682), // Rule ID 24881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24881,
        GIR_EraseRootFromParent_Done,
      // Label 12132: @781682
      GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(781757), // Rule ID 24884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24884,
        GIR_EraseRootFromParent_Done,
      // Label 12133: @781757
      GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(781832), // Rule ID 24885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24885,
        GIR_EraseRootFromParent_Done,
      // Label 12134: @781832
      GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(781907), // Rule ID 24888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24888,
        GIR_EraseRootFromParent_Done,
      // Label 12135: @781907
      GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(781982), // Rule ID 24889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24889,
        GIR_EraseRootFromParent_Done,
      // Label 12136: @781982
      GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(782057), // Rule ID 24892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24892,
        GIR_EraseRootFromParent_Done,
      // Label 12137: @782057
      GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(782132), // Rule ID 24893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24893,
        GIR_EraseRootFromParent_Done,
      // Label 12138: @782132
      GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(782207), // Rule ID 24896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24896,
        GIR_EraseRootFromParent_Done,
      // Label 12139: @782207
      GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(782282), // Rule ID 24897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24897,
        GIR_EraseRootFromParent_Done,
      // Label 12140: @782282
      GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(782357), // Rule ID 24900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24900,
        GIR_EraseRootFromParent_Done,
      // Label 12141: @782357
      GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(782432), // Rule ID 24901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24901,
        GIR_EraseRootFromParent_Done,
      // Label 12142: @782432
      GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(782507), // Rule ID 24904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24904,
        GIR_EraseRootFromParent_Done,
      // Label 12143: @782507
      GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(782582), // Rule ID 24905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24905,
        GIR_EraseRootFromParent_Done,
      // Label 12144: @782582
      GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(782657), // Rule ID 24908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24908,
        GIR_EraseRootFromParent_Done,
      // Label 12145: @782657
      GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(782732), // Rule ID 24909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24909,
        GIR_EraseRootFromParent_Done,
      // Label 12146: @782732
      GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(782807), // Rule ID 24912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24912,
        GIR_EraseRootFromParent_Done,
      // Label 12147: @782807
      GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(782882), // Rule ID 24913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24913,
        GIR_EraseRootFromParent_Done,
      // Label 12148: @782882
      GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(782957), // Rule ID 24916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24916,
        GIR_EraseRootFromParent_Done,
      // Label 12149: @782957
      GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(783032), // Rule ID 24917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24917,
        GIR_EraseRootFromParent_Done,
      // Label 12150: @783032
      GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(783107), // Rule ID 24920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24920,
        GIR_EraseRootFromParent_Done,
      // Label 12151: @783107
      GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(783182), // Rule ID 24921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24921,
        GIR_EraseRootFromParent_Done,
      // Label 12152: @783182
      GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(783257), // Rule ID 24924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24924,
        GIR_EraseRootFromParent_Done,
      // Label 12153: @783257
      GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(783332), // Rule ID 24925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24925,
        GIR_EraseRootFromParent_Done,
      // Label 12154: @783332
      GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(783407), // Rule ID 24928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24928,
        GIR_EraseRootFromParent_Done,
      // Label 12155: @783407
      GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(783482), // Rule ID 24929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24929,
        GIR_EraseRootFromParent_Done,
      // Label 12156: @783482
      GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(783557), // Rule ID 24932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24932,
        GIR_EraseRootFromParent_Done,
      // Label 12157: @783557
      GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(783632), // Rule ID 24933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24933,
        GIR_EraseRootFromParent_Done,
      // Label 12158: @783632
      GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(783704), // Rule ID 24936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24936,
        GIR_EraseRootFromParent_Done,
      // Label 12159: @783704
      GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(783776), // Rule ID 24937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24937,
        GIR_EraseRootFromParent_Done,
      // Label 12160: @783776
      GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(783848), // Rule ID 24938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10781:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24938,
        GIR_EraseRootFromParent_Done,
      // Label 12161: @783848
      GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(783920), // Rule ID 24939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10781:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24939,
        GIR_EraseRootFromParent_Done,
      // Label 12162: @783920
      GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(783992), // Rule ID 24940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24940,
        GIR_EraseRootFromParent_Done,
      // Label 12163: @783992
      GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(784064), // Rule ID 24941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24941,
        GIR_EraseRootFromParent_Done,
      // Label 12164: @784064
      GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(784136), // Rule ID 24942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24942,
        GIR_EraseRootFromParent_Done,
      // Label 12165: @784136
      GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(784208), // Rule ID 24943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24943,
        GIR_EraseRootFromParent_Done,
      // Label 12166: @784208
      GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(784280), // Rule ID 24944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24944,
        GIR_EraseRootFromParent_Done,
      // Label 12167: @784280
      GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(784352), // Rule ID 24945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24945,
        GIR_EraseRootFromParent_Done,
      // Label 12168: @784352
      GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(784424), // Rule ID 24946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10781:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24946,
        GIR_EraseRootFromParent_Done,
      // Label 12169: @784424
      GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(784496), // Rule ID 24947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10781:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24947,
        GIR_EraseRootFromParent_Done,
      // Label 12170: @784496
      GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(784568), // Rule ID 24948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24948,
        GIR_EraseRootFromParent_Done,
      // Label 12171: @784568
      GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(784640), // Rule ID 24949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24949,
        GIR_EraseRootFromParent_Done,
      // Label 12172: @784640
      GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(784712), // Rule ID 24950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24950,
        GIR_EraseRootFromParent_Done,
      // Label 12173: @784712
      GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(784784), // Rule ID 24951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24951,
        GIR_EraseRootFromParent_Done,
      // Label 12174: @784784
      GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(784856), // Rule ID 24952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24952,
        GIR_EraseRootFromParent_Done,
      // Label 12175: @784856
      GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(784928), // Rule ID 24953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24953,
        GIR_EraseRootFromParent_Done,
      // Label 12176: @784928
      GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(785000), // Rule ID 24954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24954,
        GIR_EraseRootFromParent_Done,
      // Label 12177: @785000
      GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(785072), // Rule ID 24955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24955,
        GIR_EraseRootFromParent_Done,
      // Label 12178: @785072
      GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(785144), // Rule ID 24956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24956,
        GIR_EraseRootFromParent_Done,
      // Label 12179: @785144
      GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(785216), // Rule ID 24957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24957,
        GIR_EraseRootFromParent_Done,
      // Label 12180: @785216
      GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(785288), // Rule ID 24958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24958,
        GIR_EraseRootFromParent_Done,
      // Label 12181: @785288
      GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(785360), // Rule ID 24959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24959,
        GIR_EraseRootFromParent_Done,
      // Label 12182: @785360
      GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(785432), // Rule ID 24960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24960,
        GIR_EraseRootFromParent_Done,
      // Label 12183: @785432
      GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(785504), // Rule ID 24961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24961,
        GIR_EraseRootFromParent_Done,
      // Label 12184: @785504
      GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(785576), // Rule ID 24962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24962,
        GIR_EraseRootFromParent_Done,
      // Label 12185: @785576
      GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(785648), // Rule ID 24963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24963,
        GIR_EraseRootFromParent_Done,
      // Label 12186: @785648
      GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(785720), // Rule ID 24964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24964,
        GIR_EraseRootFromParent_Done,
      // Label 12187: @785720
      GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(785792), // Rule ID 24965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24965,
        GIR_EraseRootFromParent_Done,
      // Label 12188: @785792
      GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(785864), // Rule ID 24966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24966,
        GIR_EraseRootFromParent_Done,
      // Label 12189: @785864
      GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(785936), // Rule ID 24967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24967,
        GIR_EraseRootFromParent_Done,
      // Label 12190: @785936
      GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(786008), // Rule ID 24968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24968,
        GIR_EraseRootFromParent_Done,
      // Label 12191: @786008
      GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(786080), // Rule ID 24969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24969,
        GIR_EraseRootFromParent_Done,
      // Label 12192: @786080
      GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(786152), // Rule ID 24970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24970,
        GIR_EraseRootFromParent_Done,
      // Label 12193: @786152
      GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(786224), // Rule ID 24971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24971,
        GIR_EraseRootFromParent_Done,
      // Label 12194: @786224
      GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(786296), // Rule ID 24972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24972,
        GIR_EraseRootFromParent_Done,
      // Label 12195: @786296
      GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(786368), // Rule ID 24973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24973,
        GIR_EraseRootFromParent_Done,
      // Label 12196: @786368
      GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(786440), // Rule ID 24974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24974,
        GIR_EraseRootFromParent_Done,
      // Label 12197: @786440
      GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(786512), // Rule ID 24975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24975,
        GIR_EraseRootFromParent_Done,
      // Label 12198: @786512
      GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(786584), // Rule ID 24976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24976,
        GIR_EraseRootFromParent_Done,
      // Label 12199: @786584
      GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(786656), // Rule ID 24977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24977,
        GIR_EraseRootFromParent_Done,
      // Label 12200: @786656
      GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(786728), // Rule ID 24978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24978,
        GIR_EraseRootFromParent_Done,
      // Label 12201: @786728
      GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(786800), // Rule ID 24979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24979,
        GIR_EraseRootFromParent_Done,
      // Label 12202: @786800
      GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(786872), // Rule ID 24980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24980,
        GIR_EraseRootFromParent_Done,
      // Label 12203: @786872
      GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(786944), // Rule ID 24981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24981,
        GIR_EraseRootFromParent_Done,
      // Label 12204: @786944
      GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(787016), // Rule ID 24982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24982,
        GIR_EraseRootFromParent_Done,
      // Label 12205: @787016
      GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(787088), // Rule ID 24983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24983,
        GIR_EraseRootFromParent_Done,
      // Label 12206: @787088
      GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(787160), // Rule ID 24984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24984,
        GIR_EraseRootFromParent_Done,
      // Label 12207: @787160
      GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(787232), // Rule ID 24985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24985,
        GIR_EraseRootFromParent_Done,
      // Label 12208: @787232
      GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(787304), // Rule ID 24986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24986,
        GIR_EraseRootFromParent_Done,
      // Label 12209: @787304
      GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(787376), // Rule ID 24987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24987,
        GIR_EraseRootFromParent_Done,
      // Label 12210: @787376
      GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(787448), // Rule ID 24988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24988,
        GIR_EraseRootFromParent_Done,
      // Label 12211: @787448
      GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(787520), // Rule ID 24989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24989,
        GIR_EraseRootFromParent_Done,
      // Label 12212: @787520
      GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(787592), // Rule ID 24990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24990,
        GIR_EraseRootFromParent_Done,
      // Label 12213: @787592
      GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(787664), // Rule ID 24991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24991,
        GIR_EraseRootFromParent_Done,
      // Label 12214: @787664
      GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(787736), // Rule ID 24992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24992,
        GIR_EraseRootFromParent_Done,
      // Label 12215: @787736
      GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(787808), // Rule ID 24993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24993,
        GIR_EraseRootFromParent_Done,
      // Label 12216: @787808
      GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(787880), // Rule ID 24994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24994,
        GIR_EraseRootFromParent_Done,
      // Label 12217: @787880
      GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(787952), // Rule ID 24995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24995,
        GIR_EraseRootFromParent_Done,
      // Label 12218: @787952
      GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(788024), // Rule ID 24996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24996,
        GIR_EraseRootFromParent_Done,
      // Label 12219: @788024
      GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(788096), // Rule ID 24997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24997,
        GIR_EraseRootFromParent_Done,
      // Label 12220: @788096
      GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(788168), // Rule ID 24998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24998,
        GIR_EraseRootFromParent_Done,
      // Label 12221: @788168
      GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(788240), // Rule ID 24999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24999,
        GIR_EraseRootFromParent_Done,
      // Label 12222: @788240
      GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(788312), // Rule ID 25000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25000,
        GIR_EraseRootFromParent_Done,
      // Label 12223: @788312
      GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(788384), // Rule ID 25001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10781:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25001,
        GIR_EraseRootFromParent_Done,
      // Label 12224: @788384
      GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(788456), // Rule ID 25002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25002,
        GIR_EraseRootFromParent_Done,
      // Label 12225: @788456
      GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(788528), // Rule ID 25003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10781:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25003,
        GIR_EraseRootFromParent_Done,
      // Label 12226: @788528
      GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(788600), // Rule ID 25004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25004,
        GIR_EraseRootFromParent_Done,
      // Label 12227: @788600
      GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(788672), // Rule ID 25005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10781:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25005,
        GIR_EraseRootFromParent_Done,
      // Label 12228: @788672
      GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(788744), // Rule ID 25006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25006,
        GIR_EraseRootFromParent_Done,
      // Label 12229: @788744
      GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(788816), // Rule ID 25007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10781:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25007,
        GIR_EraseRootFromParent_Done,
      // Label 12230: @788816
      GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(788891), // Rule ID 59986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59986,
        GIR_EraseRootFromParent_Done,
      // Label 12231: @788891
      GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(788966), // Rule ID 59987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59987,
        GIR_EraseRootFromParent_Done,
      // Label 12232: @788966
      GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(789041), // Rule ID 60344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60344,
        GIR_EraseRootFromParent_Done,
      // Label 12233: @789041
      GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(789116), // Rule ID 60345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60345,
        GIR_EraseRootFromParent_Done,
      // Label 12234: @789116
      GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(789191), // Rule ID 60348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60348,
        GIR_EraseRootFromParent_Done,
      // Label 12235: @789191
      GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(789266), // Rule ID 60349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60349,
        GIR_EraseRootFromParent_Done,
      // Label 12236: @789266
      GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(789341), // Rule ID 60352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60352,
        GIR_EraseRootFromParent_Done,
      // Label 12237: @789341
      GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(789416), // Rule ID 60353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60353,
        GIR_EraseRootFromParent_Done,
      // Label 12238: @789416
      GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(789491), // Rule ID 60356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60356,
        GIR_EraseRootFromParent_Done,
      // Label 12239: @789491
      GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(789566), // Rule ID 60357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60357,
        GIR_EraseRootFromParent_Done,
      // Label 12240: @789566
      GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(789641), // Rule ID 60360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60360,
        GIR_EraseRootFromParent_Done,
      // Label 12241: @789641
      GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(789716), // Rule ID 60361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60361,
        GIR_EraseRootFromParent_Done,
      // Label 12242: @789716
      GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(789791), // Rule ID 60364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60364,
        GIR_EraseRootFromParent_Done,
      // Label 12243: @789791
      GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(789866), // Rule ID 60365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60365,
        GIR_EraseRootFromParent_Done,
      // Label 12244: @789866
      GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(789941), // Rule ID 60368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60368,
        GIR_EraseRootFromParent_Done,
      // Label 12245: @789941
      GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(790016), // Rule ID 60369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60369,
        GIR_EraseRootFromParent_Done,
      // Label 12246: @790016
      GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(790091), // Rule ID 60372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60372,
        GIR_EraseRootFromParent_Done,
      // Label 12247: @790091
      GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(790166), // Rule ID 60373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60373,
        GIR_EraseRootFromParent_Done,
      // Label 12248: @790166
      GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(790241), // Rule ID 60376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60376,
        GIR_EraseRootFromParent_Done,
      // Label 12249: @790241
      GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(790316), // Rule ID 60377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60377,
        GIR_EraseRootFromParent_Done,
      // Label 12250: @790316
      GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(790391), // Rule ID 60380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60380,
        GIR_EraseRootFromParent_Done,
      // Label 12251: @790391
      GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(790466), // Rule ID 60381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60381,
        GIR_EraseRootFromParent_Done,
      // Label 12252: @790466
      GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(790541), // Rule ID 60384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60384,
        GIR_EraseRootFromParent_Done,
      // Label 12253: @790541
      GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(790616), // Rule ID 60385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60385,
        GIR_EraseRootFromParent_Done,
      // Label 12254: @790616
      GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(790691), // Rule ID 60388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60388,
        GIR_EraseRootFromParent_Done,
      // Label 12255: @790691
      GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(790766), // Rule ID 60389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60389,
        GIR_EraseRootFromParent_Done,
      // Label 12256: @790766
      GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(790841), // Rule ID 60392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60392,
        GIR_EraseRootFromParent_Done,
      // Label 12257: @790841
      GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(790916), // Rule ID 60393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60393,
        GIR_EraseRootFromParent_Done,
      // Label 12258: @790916
      GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(790991), // Rule ID 60396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60396,
        GIR_EraseRootFromParent_Done,
      // Label 12259: @790991
      GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(791066), // Rule ID 60397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60397,
        GIR_EraseRootFromParent_Done,
      // Label 12260: @791066
      GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(791141), // Rule ID 60400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60400,
        GIR_EraseRootFromParent_Done,
      // Label 12261: @791141
      GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(791216), // Rule ID 60401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60401,
        GIR_EraseRootFromParent_Done,
      // Label 12262: @791216
      GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(791291), // Rule ID 60404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60404,
        GIR_EraseRootFromParent_Done,
      // Label 12263: @791291
      GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(791366), // Rule ID 60405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60405,
        GIR_EraseRootFromParent_Done,
      // Label 12264: @791366
      GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(791441), // Rule ID 60412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60412,
        GIR_EraseRootFromParent_Done,
      // Label 12265: @791441
      GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(791516), // Rule ID 60413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60413,
        GIR_EraseRootFromParent_Done,
      // Label 12266: @791516
      GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(791591), // Rule ID 60420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60420,
        GIR_EraseRootFromParent_Done,
      // Label 12267: @791591
      GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(791666), // Rule ID 60421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60421,
        GIR_EraseRootFromParent_Done,
      // Label 12268: @791666
      GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(791741), // Rule ID 60428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60428,
        GIR_EraseRootFromParent_Done,
      // Label 12269: @791741
      GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(791816), // Rule ID 60429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60429,
        GIR_EraseRootFromParent_Done,
      // Label 12270: @791816
      GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(791891), // Rule ID 60436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60436,
        GIR_EraseRootFromParent_Done,
      // Label 12271: @791891
      GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(791966), // Rule ID 60437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60437,
        GIR_EraseRootFromParent_Done,
      // Label 12272: @791966
      GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(792041), // Rule ID 60444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60444,
        GIR_EraseRootFromParent_Done,
      // Label 12273: @792041
      GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(792116), // Rule ID 60445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60445,
        GIR_EraseRootFromParent_Done,
      // Label 12274: @792116
      GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(792191), // Rule ID 60452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60452,
        GIR_EraseRootFromParent_Done,
      // Label 12275: @792191
      GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(792266), // Rule ID 60453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60453,
        GIR_EraseRootFromParent_Done,
      // Label 12276: @792266
      GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(792341), // Rule ID 60460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60460,
        GIR_EraseRootFromParent_Done,
      // Label 12277: @792341
      GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(792416), // Rule ID 60461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60461,
        GIR_EraseRootFromParent_Done,
      // Label 12278: @792416
      GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(792491), // Rule ID 60468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60468,
        GIR_EraseRootFromParent_Done,
      // Label 12279: @792491
      GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(792566), // Rule ID 60469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60469,
        GIR_EraseRootFromParent_Done,
      // Label 12280: @792566
      GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(792641), // Rule ID 60476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60476,
        GIR_EraseRootFromParent_Done,
      // Label 12281: @792641
      GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(792716), // Rule ID 60477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60477,
        GIR_EraseRootFromParent_Done,
      // Label 12282: @792716
      GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(792791), // Rule ID 60484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60484,
        GIR_EraseRootFromParent_Done,
      // Label 12283: @792791
      GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(792866), // Rule ID 60485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60485,
        GIR_EraseRootFromParent_Done,
      // Label 12284: @792866
      GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(792941), // Rule ID 60492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60492,
        GIR_EraseRootFromParent_Done,
      // Label 12285: @792941
      GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(793016), // Rule ID 60493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60493,
        GIR_EraseRootFromParent_Done,
      // Label 12286: @793016
      GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(793091), // Rule ID 60500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60500,
        GIR_EraseRootFromParent_Done,
      // Label 12287: @793091
      GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(793166), // Rule ID 60501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60501,
        GIR_EraseRootFromParent_Done,
      // Label 12288: @793166
      GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(793241), // Rule ID 60508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60508,
        GIR_EraseRootFromParent_Done,
      // Label 12289: @793241
      GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(793316), // Rule ID 60509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60509,
        GIR_EraseRootFromParent_Done,
      // Label 12290: @793316
      GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(793391), // Rule ID 60516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60516,
        GIR_EraseRootFromParent_Done,
      // Label 12291: @793391
      GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(793466), // Rule ID 60517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60517,
        GIR_EraseRootFromParent_Done,
      // Label 12292: @793466
      GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(793541), // Rule ID 60524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10775:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60524,
        GIR_EraseRootFromParent_Done,
      // Label 12293: @793541
      GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(793616), // Rule ID 60525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10775:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60525,
        GIR_EraseRootFromParent_Done,
      // Label 12294: @793616
      GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(793691), // Rule ID 60528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10775:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60528,
        GIR_EraseRootFromParent_Done,
      // Label 12295: @793691
      GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(793766), // Rule ID 60529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10775:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60529,
        GIR_EraseRootFromParent_Done,
      // Label 12296: @793766
      GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(793841), // Rule ID 60532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10775:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60532,
        GIR_EraseRootFromParent_Done,
      // Label 12297: @793841
      GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(793916), // Rule ID 60533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10775:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60533,
        GIR_EraseRootFromParent_Done,
      // Label 12298: @793916
      GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(793991), // Rule ID 60536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10775:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60536,
        GIR_EraseRootFromParent_Done,
      // Label 12299: @793991
      GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(794066), // Rule ID 60537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10775:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60537,
        GIR_EraseRootFromParent_Done,
      // Label 12300: @794066
      GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(794141), // Rule ID 60540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10775:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60540,
        GIR_EraseRootFromParent_Done,
      // Label 12301: @794141
      GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(794216), // Rule ID 60541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10775:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60541,
        GIR_EraseRootFromParent_Done,
      // Label 12302: @794216
      GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(794291), // Rule ID 60544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10775:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60544,
        GIR_EraseRootFromParent_Done,
      // Label 12303: @794291
      GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(794366), // Rule ID 60545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10775:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60545,
        GIR_EraseRootFromParent_Done,
      // Label 12304: @794366
      GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(794441), // Rule ID 60548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10775:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60548,
        GIR_EraseRootFromParent_Done,
      // Label 12305: @794441
      GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(794516), // Rule ID 60549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10775:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60549,
        GIR_EraseRootFromParent_Done,
      // Label 12306: @794516
      GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(794591), // Rule ID 60552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10775:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60552,
        GIR_EraseRootFromParent_Done,
      // Label 12307: @794591
      GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(794666), // Rule ID 60553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10775:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60553,
        GIR_EraseRootFromParent_Done,
      // Label 12308: @794666
      GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(794741), // Rule ID 60556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10777:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60556,
        GIR_EraseRootFromParent_Done,
      // Label 12309: @794741
      GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(794816), // Rule ID 60557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10777:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60557,
        GIR_EraseRootFromParent_Done,
      // Label 12310: @794816
      GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(794891), // Rule ID 60560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10777:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60560,
        GIR_EraseRootFromParent_Done,
      // Label 12311: @794891
      GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(794966), // Rule ID 60561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10777:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60561,
        GIR_EraseRootFromParent_Done,
      // Label 12312: @794966
      GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(795041), // Rule ID 60564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10777:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60564,
        GIR_EraseRootFromParent_Done,
      // Label 12313: @795041
      GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(795116), // Rule ID 60565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10777:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60565,
        GIR_EraseRootFromParent_Done,
      // Label 12314: @795116
      GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(795191), // Rule ID 60568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10777:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60568,
        GIR_EraseRootFromParent_Done,
      // Label 12315: @795191
      GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(795266), // Rule ID 60569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10777:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60569,
        GIR_EraseRootFromParent_Done,
      // Label 12316: @795266
      GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(795341), // Rule ID 60572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10777:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60572,
        GIR_EraseRootFromParent_Done,
      // Label 12317: @795341
      GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(795416), // Rule ID 60573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10777:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60573,
        GIR_EraseRootFromParent_Done,
      // Label 12318: @795416
      GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(795491), // Rule ID 60576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10777:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60576,
        GIR_EraseRootFromParent_Done,
      // Label 12319: @795491
      GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(795566), // Rule ID 60577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10777:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60577,
        GIR_EraseRootFromParent_Done,
      // Label 12320: @795566
      GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(795641), // Rule ID 60580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10777:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60580,
        GIR_EraseRootFromParent_Done,
      // Label 12321: @795641
      GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(795716), // Rule ID 60581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10777:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60581,
        GIR_EraseRootFromParent_Done,
      // Label 12322: @795716
      GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(795791), // Rule ID 60584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10777:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60584,
        GIR_EraseRootFromParent_Done,
      // Label 12323: @795791
      GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(795866), // Rule ID 60585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10777:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60585,
        GIR_EraseRootFromParent_Done,
      // Label 12324: @795866
      GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(795941), // Rule ID 60588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60588,
        GIR_EraseRootFromParent_Done,
      // Label 12325: @795941
      GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(796016), // Rule ID 60589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60589,
        GIR_EraseRootFromParent_Done,
      // Label 12326: @796016
      GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(796091), // Rule ID 60592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60592,
        GIR_EraseRootFromParent_Done,
      // Label 12327: @796091
      GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(796166), // Rule ID 60593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60593,
        GIR_EraseRootFromParent_Done,
      // Label 12328: @796166
      GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(796241), // Rule ID 60596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60596,
        GIR_EraseRootFromParent_Done,
      // Label 12329: @796241
      GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(796316), // Rule ID 60597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60597,
        GIR_EraseRootFromParent_Done,
      // Label 12330: @796316
      GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(796391), // Rule ID 60600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60600,
        GIR_EraseRootFromParent_Done,
      // Label 12331: @796391
      GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(796466), // Rule ID 60601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60601,
        GIR_EraseRootFromParent_Done,
      // Label 12332: @796466
      GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(796541), // Rule ID 60604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60604,
        GIR_EraseRootFromParent_Done,
      // Label 12333: @796541
      GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(796616), // Rule ID 60605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60605,
        GIR_EraseRootFromParent_Done,
      // Label 12334: @796616
      GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(796691), // Rule ID 60608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60608,
        GIR_EraseRootFromParent_Done,
      // Label 12335: @796691
      GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(796766), // Rule ID 60609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60609,
        GIR_EraseRootFromParent_Done,
      // Label 12336: @796766
      GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(796841), // Rule ID 60612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60612,
        GIR_EraseRootFromParent_Done,
      // Label 12337: @796841
      GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(796916), // Rule ID 60613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60613,
        GIR_EraseRootFromParent_Done,
      // Label 12338: @796916
      GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(796991), // Rule ID 60616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60616,
        GIR_EraseRootFromParent_Done,
      // Label 12339: @796991
      GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(797066), // Rule ID 60617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60617,
        GIR_EraseRootFromParent_Done,
      // Label 12340: @797066
      GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(797141), // Rule ID 60620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60620,
        GIR_EraseRootFromParent_Done,
      // Label 12341: @797141
      GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(797216), // Rule ID 60621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60621,
        GIR_EraseRootFromParent_Done,
      // Label 12342: @797216
      GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(797291), // Rule ID 60624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60624,
        GIR_EraseRootFromParent_Done,
      // Label 12343: @797291
      GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(797366), // Rule ID 60625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60625,
        GIR_EraseRootFromParent_Done,
      // Label 12344: @797366
      GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(797441), // Rule ID 60628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60628,
        GIR_EraseRootFromParent_Done,
      // Label 12345: @797441
      GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(797516), // Rule ID 60629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60629,
        GIR_EraseRootFromParent_Done,
      // Label 12346: @797516
      GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(797591), // Rule ID 60632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60632,
        GIR_EraseRootFromParent_Done,
      // Label 12347: @797591
      GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(797666), // Rule ID 60633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60633,
        GIR_EraseRootFromParent_Done,
      // Label 12348: @797666
      GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(797741), // Rule ID 60636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60636,
        GIR_EraseRootFromParent_Done,
      // Label 12349: @797741
      GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(797816), // Rule ID 60637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60637,
        GIR_EraseRootFromParent_Done,
      // Label 12350: @797816
      GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(797891), // Rule ID 60640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60640,
        GIR_EraseRootFromParent_Done,
      // Label 12351: @797891
      GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(797966), // Rule ID 60641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60641,
        GIR_EraseRootFromParent_Done,
      // Label 12352: @797966
      GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(798041), // Rule ID 60644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60644,
        GIR_EraseRootFromParent_Done,
      // Label 12353: @798041
      GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(798116), // Rule ID 60645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60645,
        GIR_EraseRootFromParent_Done,
      // Label 12354: @798116
      GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(798191), // Rule ID 60648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60648,
        GIR_EraseRootFromParent_Done,
      // Label 12355: @798191
      GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(798266), // Rule ID 60649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60649,
        GIR_EraseRootFromParent_Done,
      // Label 12356: @798266
      GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(798341), // Rule ID 60652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60652,
        GIR_EraseRootFromParent_Done,
      // Label 12357: @798341
      GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(798416), // Rule ID 60653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60653,
        GIR_EraseRootFromParent_Done,
      // Label 12358: @798416
      GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(798491), // Rule ID 60656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60656,
        GIR_EraseRootFromParent_Done,
      // Label 12359: @798491
      GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(798566), // Rule ID 60657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60657,
        GIR_EraseRootFromParent_Done,
      // Label 12360: @798566
      GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(798641), // Rule ID 60660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60660,
        GIR_EraseRootFromParent_Done,
      // Label 12361: @798641
      GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(798716), // Rule ID 60661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60661,
        GIR_EraseRootFromParent_Done,
      // Label 12362: @798716
      GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(798791), // Rule ID 60664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60664,
        GIR_EraseRootFromParent_Done,
      // Label 12363: @798791
      GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(798866), // Rule ID 60665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60665,
        GIR_EraseRootFromParent_Done,
      // Label 12364: @798866
      GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(798941), // Rule ID 60668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60668,
        GIR_EraseRootFromParent_Done,
      // Label 12365: @798941
      GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(799016), // Rule ID 60669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60669,
        GIR_EraseRootFromParent_Done,
      // Label 12366: @799016
      GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(799091), // Rule ID 60672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60672,
        GIR_EraseRootFromParent_Done,
      // Label 12367: @799091
      GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(799166), // Rule ID 60673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60673,
        GIR_EraseRootFromParent_Done,
      // Label 12368: @799166
      GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(799241), // Rule ID 60676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60676,
        GIR_EraseRootFromParent_Done,
      // Label 12369: @799241
      GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(799316), // Rule ID 60677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60677,
        GIR_EraseRootFromParent_Done,
      // Label 12370: @799316
      GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(799391), // Rule ID 60680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60680,
        GIR_EraseRootFromParent_Done,
      // Label 12371: @799391
      GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(799466), // Rule ID 60681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60681,
        GIR_EraseRootFromParent_Done,
      // Label 12372: @799466
      GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(799541), // Rule ID 60684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60684,
        GIR_EraseRootFromParent_Done,
      // Label 12373: @799541
      GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(799616), // Rule ID 60685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60685,
        GIR_EraseRootFromParent_Done,
      // Label 12374: @799616
      GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(799691), // Rule ID 60688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60688,
        GIR_EraseRootFromParent_Done,
      // Label 12375: @799691
      GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(799766), // Rule ID 60689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60689,
        GIR_EraseRootFromParent_Done,
      // Label 12376: @799766
      GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(799841), // Rule ID 60692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60692,
        GIR_EraseRootFromParent_Done,
      // Label 12377: @799841
      GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(799916), // Rule ID 60693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60693,
        GIR_EraseRootFromParent_Done,
      // Label 12378: @799916
      GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(799991), // Rule ID 60696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60696,
        GIR_EraseRootFromParent_Done,
      // Label 12379: @799991
      GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(800066), // Rule ID 60697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60697,
        GIR_EraseRootFromParent_Done,
      // Label 12380: @800066
      GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(800141), // Rule ID 60700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60700,
        GIR_EraseRootFromParent_Done,
      // Label 12381: @800141
      GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(800216), // Rule ID 60701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10765:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60701,
        GIR_EraseRootFromParent_Done,
      // Label 12382: @800216
      GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(800291), // Rule ID 60704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60704,
        GIR_EraseRootFromParent_Done,
      // Label 12383: @800291
      GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(800366), // Rule ID 60705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10765:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60705,
        GIR_EraseRootFromParent_Done,
      // Label 12384: @800366
      GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(800441), // Rule ID 60708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60708,
        GIR_EraseRootFromParent_Done,
      // Label 12385: @800441
      GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(800516), // Rule ID 60709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10765:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60709,
        GIR_EraseRootFromParent_Done,
      // Label 12386: @800516
      GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(800591), // Rule ID 60712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60712,
        GIR_EraseRootFromParent_Done,
      // Label 12387: @800591
      GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(800666), // Rule ID 60713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10765:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60713,
        GIR_EraseRootFromParent_Done,
      // Label 12388: @800666
      GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(800741), // Rule ID 60716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60716,
        GIR_EraseRootFromParent_Done,
      // Label 12389: @800741
      GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(800816), // Rule ID 60717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60717,
        GIR_EraseRootFromParent_Done,
      // Label 12390: @800816
      GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(800891), // Rule ID 60720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60720,
        GIR_EraseRootFromParent_Done,
      // Label 12391: @800891
      GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(800966), // Rule ID 60721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60721,
        GIR_EraseRootFromParent_Done,
      // Label 12392: @800966
      GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(801041), // Rule ID 60724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60724,
        GIR_EraseRootFromParent_Done,
      // Label 12393: @801041
      GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(801116), // Rule ID 60725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60725,
        GIR_EraseRootFromParent_Done,
      // Label 12394: @801116
      GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(801191), // Rule ID 60728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60728,
        GIR_EraseRootFromParent_Done,
      // Label 12395: @801191
      GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(801266), // Rule ID 60729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60729,
        GIR_EraseRootFromParent_Done,
      // Label 12396: @801266
      GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(801341), // Rule ID 60732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60732,
        GIR_EraseRootFromParent_Done,
      // Label 12397: @801341
      GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(801416), // Rule ID 60733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60733,
        GIR_EraseRootFromParent_Done,
      // Label 12398: @801416
      GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(801491), // Rule ID 60736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60736,
        GIR_EraseRootFromParent_Done,
      // Label 12399: @801491
      GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(801566), // Rule ID 60737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60737,
        GIR_EraseRootFromParent_Done,
      // Label 12400: @801566
      GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(801641), // Rule ID 60740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60740,
        GIR_EraseRootFromParent_Done,
      // Label 12401: @801641
      GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(801716), // Rule ID 60741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60741,
        GIR_EraseRootFromParent_Done,
      // Label 12402: @801716
      GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(801791), // Rule ID 60744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60744,
        GIR_EraseRootFromParent_Done,
      // Label 12403: @801791
      GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(801866), // Rule ID 60745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60745,
        GIR_EraseRootFromParent_Done,
      // Label 12404: @801866
      GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(801941), // Rule ID 60748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60748,
        GIR_EraseRootFromParent_Done,
      // Label 12405: @801941
      GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(802016), // Rule ID 60749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60749,
        GIR_EraseRootFromParent_Done,
      // Label 12406: @802016
      GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(802091), // Rule ID 60752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60752,
        GIR_EraseRootFromParent_Done,
      // Label 12407: @802091
      GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(802166), // Rule ID 60753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10765:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60753,
        GIR_EraseRootFromParent_Done,
      // Label 12408: @802166
      GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(802241), // Rule ID 60756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60756,
        GIR_EraseRootFromParent_Done,
      // Label 12409: @802241
      GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(802316), // Rule ID 60757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10765:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60757,
        GIR_EraseRootFromParent_Done,
      // Label 12410: @802316
      GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(802391), // Rule ID 60760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60760,
        GIR_EraseRootFromParent_Done,
      // Label 12411: @802391
      GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(802466), // Rule ID 60761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10765:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60761,
        GIR_EraseRootFromParent_Done,
      // Label 12412: @802466
      GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(802541), // Rule ID 60940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60940,
        GIR_EraseRootFromParent_Done,
      // Label 12413: @802541
      GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(802616), // Rule ID 60941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60941,
        GIR_EraseRootFromParent_Done,
      // Label 12414: @802616
      GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(802691), // Rule ID 60944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60944,
        GIR_EraseRootFromParent_Done,
      // Label 12415: @802691
      GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(802766), // Rule ID 60945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60945,
        GIR_EraseRootFromParent_Done,
      // Label 12416: @802766
      GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(802841), // Rule ID 60948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60948,
        GIR_EraseRootFromParent_Done,
      // Label 12417: @802841
      GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(802916), // Rule ID 60949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60949,
        GIR_EraseRootFromParent_Done,
      // Label 12418: @802916
      GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(802991), // Rule ID 60952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60952,
        GIR_EraseRootFromParent_Done,
      // Label 12419: @802991
      GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(803066), // Rule ID 60953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60953,
        GIR_EraseRootFromParent_Done,
      // Label 12420: @803066
      GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(803141), // Rule ID 60956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60956,
        GIR_EraseRootFromParent_Done,
      // Label 12421: @803141
      GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(803216), // Rule ID 60957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60957,
        GIR_EraseRootFromParent_Done,
      // Label 12422: @803216
      GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(803291), // Rule ID 60960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60960,
        GIR_EraseRootFromParent_Done,
      // Label 12423: @803291
      GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(803366), // Rule ID 60961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60961,
        GIR_EraseRootFromParent_Done,
      // Label 12424: @803366
      GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(803441), // Rule ID 60964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60964,
        GIR_EraseRootFromParent_Done,
      // Label 12425: @803441
      GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(803516), // Rule ID 60965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60965,
        GIR_EraseRootFromParent_Done,
      // Label 12426: @803516
      GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(803591), // Rule ID 60968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60968,
        GIR_EraseRootFromParent_Done,
      // Label 12427: @803591
      GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(803666), // Rule ID 60969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60969,
        GIR_EraseRootFromParent_Done,
      // Label 12428: @803666
      GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(803741), // Rule ID 60972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60972,
        GIR_EraseRootFromParent_Done,
      // Label 12429: @803741
      GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(803816), // Rule ID 60973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60973,
        GIR_EraseRootFromParent_Done,
      // Label 12430: @803816
      GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(803891), // Rule ID 60976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60976,
        GIR_EraseRootFromParent_Done,
      // Label 12431: @803891
      GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(803966), // Rule ID 60977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60977,
        GIR_EraseRootFromParent_Done,
      // Label 12432: @803966
      GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(804041), // Rule ID 60980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60980,
        GIR_EraseRootFromParent_Done,
      // Label 12433: @804041
      GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(804116), // Rule ID 60981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60981,
        GIR_EraseRootFromParent_Done,
      // Label 12434: @804116
      GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(804191), // Rule ID 60984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60984,
        GIR_EraseRootFromParent_Done,
      // Label 12435: @804191
      GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(804266), // Rule ID 60985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60985,
        GIR_EraseRootFromParent_Done,
      // Label 12436: @804266
      GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(804341), // Rule ID 60988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60988,
        GIR_EraseRootFromParent_Done,
      // Label 12437: @804341
      GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(804416), // Rule ID 60989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60989,
        GIR_EraseRootFromParent_Done,
      // Label 12438: @804416
      GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(804491), // Rule ID 60992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60992,
        GIR_EraseRootFromParent_Done,
      // Label 12439: @804491
      GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(804566), // Rule ID 60993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60993,
        GIR_EraseRootFromParent_Done,
      // Label 12440: @804566
      GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(804641), // Rule ID 60996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60996,
        GIR_EraseRootFromParent_Done,
      // Label 12441: @804641
      GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(804716), // Rule ID 60997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60997,
        GIR_EraseRootFromParent_Done,
      // Label 12442: @804716
      GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(804791), // Rule ID 61000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61000,
        GIR_EraseRootFromParent_Done,
      // Label 12443: @804791
      GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(804866), // Rule ID 61001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61001,
        GIR_EraseRootFromParent_Done,
      // Label 12444: @804866
      GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(804941), // Rule ID 61004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61004,
        GIR_EraseRootFromParent_Done,
      // Label 12445: @804941
      GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(805016), // Rule ID 61005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61005,
        GIR_EraseRootFromParent_Done,
      // Label 12446: @805016
      GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(805091), // Rule ID 61008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61008,
        GIR_EraseRootFromParent_Done,
      // Label 12447: @805091
      GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(805166), // Rule ID 61009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61009,
        GIR_EraseRootFromParent_Done,
      // Label 12448: @805166
      GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(805241), // Rule ID 61012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61012,
        GIR_EraseRootFromParent_Done,
      // Label 12449: @805241
      GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(805316), // Rule ID 61013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61013,
        GIR_EraseRootFromParent_Done,
      // Label 12450: @805316
      GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(805391), // Rule ID 61016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61016,
        GIR_EraseRootFromParent_Done,
      // Label 12451: @805391
      GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(805466), // Rule ID 61017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61017,
        GIR_EraseRootFromParent_Done,
      // Label 12452: @805466
      GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(805541), // Rule ID 61020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61020,
        GIR_EraseRootFromParent_Done,
      // Label 12453: @805541
      GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(805616), // Rule ID 61021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61021,
        GIR_EraseRootFromParent_Done,
      // Label 12454: @805616
      GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(805691), // Rule ID 61024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61024,
        GIR_EraseRootFromParent_Done,
      // Label 12455: @805691
      GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(805766), // Rule ID 61025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61025,
        GIR_EraseRootFromParent_Done,
      // Label 12456: @805766
      GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(805841), // Rule ID 61028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61028,
        GIR_EraseRootFromParent_Done,
      // Label 12457: @805841
      GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(805916), // Rule ID 61029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61029,
        GIR_EraseRootFromParent_Done,
      // Label 12458: @805916
      GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(805991), // Rule ID 61032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61032,
        GIR_EraseRootFromParent_Done,
      // Label 12459: @805991
      GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(806066), // Rule ID 61033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61033,
        GIR_EraseRootFromParent_Done,
      // Label 12460: @806066
      GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(806141), // Rule ID 61036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61036,
        GIR_EraseRootFromParent_Done,
      // Label 12461: @806141
      GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(806216), // Rule ID 61037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61037,
        GIR_EraseRootFromParent_Done,
      // Label 12462: @806216
      GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(806291), // Rule ID 61040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61040,
        GIR_EraseRootFromParent_Done,
      // Label 12463: @806291
      GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(806366), // Rule ID 61041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61041,
        GIR_EraseRootFromParent_Done,
      // Label 12464: @806366
      GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(806441), // Rule ID 61044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61044,
        GIR_EraseRootFromParent_Done,
      // Label 12465: @806441
      GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(806516), // Rule ID 61045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61045,
        GIR_EraseRootFromParent_Done,
      // Label 12466: @806516
      GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(806591), // Rule ID 61048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61048,
        GIR_EraseRootFromParent_Done,
      // Label 12467: @806591
      GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(806666), // Rule ID 61049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61049,
        GIR_EraseRootFromParent_Done,
      // Label 12468: @806666
      GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(806741), // Rule ID 61052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61052,
        GIR_EraseRootFromParent_Done,
      // Label 12469: @806741
      GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(806816), // Rule ID 61053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11132:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61053,
        GIR_EraseRootFromParent_Done,
      // Label 12470: @806816
      GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(806891), // Rule ID 61056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61056,
        GIR_EraseRootFromParent_Done,
      // Label 12471: @806891
      GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(806966), // Rule ID 61057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61057,
        GIR_EraseRootFromParent_Done,
      // Label 12472: @806966
      GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(807041), // Rule ID 61060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61060,
        GIR_EraseRootFromParent_Done,
      // Label 12473: @807041
      GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(807116), // Rule ID 61061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61061,
        GIR_EraseRootFromParent_Done,
      // Label 12474: @807116
      GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(807191), // Rule ID 61064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61064,
        GIR_EraseRootFromParent_Done,
      // Label 12475: @807191
      GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(807266), // Rule ID 61065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61065,
        GIR_EraseRootFromParent_Done,
      // Label 12476: @807266
      GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(807341), // Rule ID 61068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61068,
        GIR_EraseRootFromParent_Done,
      // Label 12477: @807341
      GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(807416), // Rule ID 61069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61069,
        GIR_EraseRootFromParent_Done,
      // Label 12478: @807416
      GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(807491), // Rule ID 61072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61072,
        GIR_EraseRootFromParent_Done,
      // Label 12479: @807491
      GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(807566), // Rule ID 61073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61073,
        GIR_EraseRootFromParent_Done,
      // Label 12480: @807566
      GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(807641), // Rule ID 61076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61076,
        GIR_EraseRootFromParent_Done,
      // Label 12481: @807641
      GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(807716), // Rule ID 61077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61077,
        GIR_EraseRootFromParent_Done,
      // Label 12482: @807716
      GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(807791), // Rule ID 61080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61080,
        GIR_EraseRootFromParent_Done,
      // Label 12483: @807791
      GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(807866), // Rule ID 61081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61081,
        GIR_EraseRootFromParent_Done,
      // Label 12484: @807866
      GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(807941), // Rule ID 61084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61084,
        GIR_EraseRootFromParent_Done,
      // Label 12485: @807941
      GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(808016), // Rule ID 61085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61085,
        GIR_EraseRootFromParent_Done,
      // Label 12486: @808016
      GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(808091), // Rule ID 61088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61088,
        GIR_EraseRootFromParent_Done,
      // Label 12487: @808091
      GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(808166), // Rule ID 61089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61089,
        GIR_EraseRootFromParent_Done,
      // Label 12488: @808166
      GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(808241), // Rule ID 61092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61092,
        GIR_EraseRootFromParent_Done,
      // Label 12489: @808241
      GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(808316), // Rule ID 61093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61093,
        GIR_EraseRootFromParent_Done,
      // Label 12490: @808316
      GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(808391), // Rule ID 61096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61096,
        GIR_EraseRootFromParent_Done,
      // Label 12491: @808391
      GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(808466), // Rule ID 61097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61097,
        GIR_EraseRootFromParent_Done,
      // Label 12492: @808466
      GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(808541), // Rule ID 61100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61100,
        GIR_EraseRootFromParent_Done,
      // Label 12493: @808541
      GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(808616), // Rule ID 61101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61101,
        GIR_EraseRootFromParent_Done,
      // Label 12494: @808616
      GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(808691), // Rule ID 61104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61104,
        GIR_EraseRootFromParent_Done,
      // Label 12495: @808691
      GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(808766), // Rule ID 61105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61105,
        GIR_EraseRootFromParent_Done,
      // Label 12496: @808766
      GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(808841), // Rule ID 61108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61108,
        GIR_EraseRootFromParent_Done,
      // Label 12497: @808841
      GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(808916), // Rule ID 61109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61109,
        GIR_EraseRootFromParent_Done,
      // Label 12498: @808916
      GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(808991), // Rule ID 61112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61112,
        GIR_EraseRootFromParent_Done,
      // Label 12499: @808991
      GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(809066), // Rule ID 61113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61113,
        GIR_EraseRootFromParent_Done,
      // Label 12500: @809066
      GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(809141), // Rule ID 61200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61200,
        GIR_EraseRootFromParent_Done,
      // Label 12501: @809141
      GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(809216), // Rule ID 61201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61201,
        GIR_EraseRootFromParent_Done,
      // Label 12502: @809216
      GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(809291), // Rule ID 61204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61204,
        GIR_EraseRootFromParent_Done,
      // Label 12503: @809291
      GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(809366), // Rule ID 61205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61205,
        GIR_EraseRootFromParent_Done,
      // Label 12504: @809366
      GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(809441), // Rule ID 61208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61208,
        GIR_EraseRootFromParent_Done,
      // Label 12505: @809441
      GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(809516), // Rule ID 61209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61209,
        GIR_EraseRootFromParent_Done,
      // Label 12506: @809516
      GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(809591), // Rule ID 61212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61212,
        GIR_EraseRootFromParent_Done,
      // Label 12507: @809591
      GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(809666), // Rule ID 61213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61213,
        GIR_EraseRootFromParent_Done,
      // Label 12508: @809666
      GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(809741), // Rule ID 61216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61216,
        GIR_EraseRootFromParent_Done,
      // Label 12509: @809741
      GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(809816), // Rule ID 61217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61217,
        GIR_EraseRootFromParent_Done,
      // Label 12510: @809816
      GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(809891), // Rule ID 61220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61220,
        GIR_EraseRootFromParent_Done,
      // Label 12511: @809891
      GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(809966), // Rule ID 61221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61221,
        GIR_EraseRootFromParent_Done,
      // Label 12512: @809966
      GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(810041), // Rule ID 61224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61224,
        GIR_EraseRootFromParent_Done,
      // Label 12513: @810041
      GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(810116), // Rule ID 61225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61225,
        GIR_EraseRootFromParent_Done,
      // Label 12514: @810116
      GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(810191), // Rule ID 61228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61228,
        GIR_EraseRootFromParent_Done,
      // Label 12515: @810191
      GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(810266), // Rule ID 61229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61229,
        GIR_EraseRootFromParent_Done,
      // Label 12516: @810266
      GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(810341), // Rule ID 61232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61232,
        GIR_EraseRootFromParent_Done,
      // Label 12517: @810341
      GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(810416), // Rule ID 61233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61233,
        GIR_EraseRootFromParent_Done,
      // Label 12518: @810416
      GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(810491), // Rule ID 61236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61236,
        GIR_EraseRootFromParent_Done,
      // Label 12519: @810491
      GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(810566), // Rule ID 61237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61237,
        GIR_EraseRootFromParent_Done,
      // Label 12520: @810566
      GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(810641), // Rule ID 61240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61240,
        GIR_EraseRootFromParent_Done,
      // Label 12521: @810641
      GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(810716), // Rule ID 61241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61241,
        GIR_EraseRootFromParent_Done,
      // Label 12522: @810716
      GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(810791), // Rule ID 61244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61244,
        GIR_EraseRootFromParent_Done,
      // Label 12523: @810791
      GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(810866), // Rule ID 61245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61245,
        GIR_EraseRootFromParent_Done,
      // Label 12524: @810866
      GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(810941), // Rule ID 61248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61248,
        GIR_EraseRootFromParent_Done,
      // Label 12525: @810941
      GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(811016), // Rule ID 61249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61249,
        GIR_EraseRootFromParent_Done,
      // Label 12526: @811016
      GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(811091), // Rule ID 61252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61252,
        GIR_EraseRootFromParent_Done,
      // Label 12527: @811091
      GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(811166), // Rule ID 61253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61253,
        GIR_EraseRootFromParent_Done,
      // Label 12528: @811166
      GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(811241), // Rule ID 61256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61256,
        GIR_EraseRootFromParent_Done,
      // Label 12529: @811241
      GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(811316), // Rule ID 61257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61257,
        GIR_EraseRootFromParent_Done,
      // Label 12530: @811316
      GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(811391), // Rule ID 61260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61260,
        GIR_EraseRootFromParent_Done,
      // Label 12531: @811391
      GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(811466), // Rule ID 61261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61261,
        GIR_EraseRootFromParent_Done,
      // Label 12532: @811466
      GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(811541), // Rule ID 61264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61264,
        GIR_EraseRootFromParent_Done,
      // Label 12533: @811541
      GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(811616), // Rule ID 61265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61265,
        GIR_EraseRootFromParent_Done,
      // Label 12534: @811616
      GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(811691), // Rule ID 61268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61268,
        GIR_EraseRootFromParent_Done,
      // Label 12535: @811691
      GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(811766), // Rule ID 61269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61269,
        GIR_EraseRootFromParent_Done,
      // Label 12536: @811766
      GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(811841), // Rule ID 61272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61272,
        GIR_EraseRootFromParent_Done,
      // Label 12537: @811841
      GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(811916), // Rule ID 61273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61273,
        GIR_EraseRootFromParent_Done,
      // Label 12538: @811916
      GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(811991), // Rule ID 61276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61276,
        GIR_EraseRootFromParent_Done,
      // Label 12539: @811991
      GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(812066), // Rule ID 61277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61277,
        GIR_EraseRootFromParent_Done,
      // Label 12540: @812066
      GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(812141), // Rule ID 61280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61280,
        GIR_EraseRootFromParent_Done,
      // Label 12541: @812141
      GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(812216), // Rule ID 61281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61281,
        GIR_EraseRootFromParent_Done,
      // Label 12542: @812216
      GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(812291), // Rule ID 61284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61284,
        GIR_EraseRootFromParent_Done,
      // Label 12543: @812291
      GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(812366), // Rule ID 61285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61285,
        GIR_EraseRootFromParent_Done,
      // Label 12544: @812366
      GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(812441), // Rule ID 61288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61288,
        GIR_EraseRootFromParent_Done,
      // Label 12545: @812441
      GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(812516), // Rule ID 61289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61289,
        GIR_EraseRootFromParent_Done,
      // Label 12546: @812516
      GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(812591), // Rule ID 61292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61292,
        GIR_EraseRootFromParent_Done,
      // Label 12547: @812591
      GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(812666), // Rule ID 61293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61293,
        GIR_EraseRootFromParent_Done,
      // Label 12548: @812666
      GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(812741), // Rule ID 61296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61296,
        GIR_EraseRootFromParent_Done,
      // Label 12549: @812741
      GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(812816), // Rule ID 61297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61297,
        GIR_EraseRootFromParent_Done,
      // Label 12550: @812816
      GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(812891), // Rule ID 61300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61300,
        GIR_EraseRootFromParent_Done,
      // Label 12551: @812891
      GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(812966), // Rule ID 61301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61301,
        GIR_EraseRootFromParent_Done,
      // Label 12552: @812966
      GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(813041), // Rule ID 61304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61304,
        GIR_EraseRootFromParent_Done,
      // Label 12553: @813041
      GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(813116), // Rule ID 61305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61305,
        GIR_EraseRootFromParent_Done,
      // Label 12554: @813116
      GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(813191), // Rule ID 61308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61308,
        GIR_EraseRootFromParent_Done,
      // Label 12555: @813191
      GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(813266), // Rule ID 61309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61309,
        GIR_EraseRootFromParent_Done,
      // Label 12556: @813266
      GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(813341), // Rule ID 61312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61312,
        GIR_EraseRootFromParent_Done,
      // Label 12557: @813341
      GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(813416), // Rule ID 61313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61313,
        GIR_EraseRootFromParent_Done,
      // Label 12558: @813416
      GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(813491), // Rule ID 61316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61316,
        GIR_EraseRootFromParent_Done,
      // Label 12559: @813491
      GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(813566), // Rule ID 61317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61317,
        GIR_EraseRootFromParent_Done,
      // Label 12560: @813566
      GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(813641), // Rule ID 61320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61320,
        GIR_EraseRootFromParent_Done,
      // Label 12561: @813641
      GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(813716), // Rule ID 61321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61321,
        GIR_EraseRootFromParent_Done,
      // Label 12562: @813716
      GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(813791), // Rule ID 61324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61324,
        GIR_EraseRootFromParent_Done,
      // Label 12563: @813791
      GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(813866), // Rule ID 61325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61325,
        GIR_EraseRootFromParent_Done,
      // Label 12564: @813866
      GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(813941), // Rule ID 61328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61328,
        GIR_EraseRootFromParent_Done,
      // Label 12565: @813941
      GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(814016), // Rule ID 61329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61329,
        GIR_EraseRootFromParent_Done,
      // Label 12566: @814016
      GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(814091), // Rule ID 61332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61332,
        GIR_EraseRootFromParent_Done,
      // Label 12567: @814091
      GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(814166), // Rule ID 61333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61333,
        GIR_EraseRootFromParent_Done,
      // Label 12568: @814166
      GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(814241), // Rule ID 61336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61336,
        GIR_EraseRootFromParent_Done,
      // Label 12569: @814241
      GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(814316), // Rule ID 61337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61337,
        GIR_EraseRootFromParent_Done,
      // Label 12570: @814316
      GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(814391), // Rule ID 61340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61340,
        GIR_EraseRootFromParent_Done,
      // Label 12571: @814391
      GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(814466), // Rule ID 61341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61341,
        GIR_EraseRootFromParent_Done,
      // Label 12572: @814466
      GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(814541), // Rule ID 61344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61344,
        GIR_EraseRootFromParent_Done,
      // Label 12573: @814541
      GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(814616), // Rule ID 61345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61345,
        GIR_EraseRootFromParent_Done,
      // Label 12574: @814616
      GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(814691), // Rule ID 61348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61348,
        GIR_EraseRootFromParent_Done,
      // Label 12575: @814691
      GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(814766), // Rule ID 61349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61349,
        GIR_EraseRootFromParent_Done,
      // Label 12576: @814766
      GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(814841), // Rule ID 61352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61352,
        GIR_EraseRootFromParent_Done,
      // Label 12577: @814841
      GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(814916), // Rule ID 61353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61353,
        GIR_EraseRootFromParent_Done,
      // Label 12578: @814916
      GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(814991), // Rule ID 61356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61356,
        GIR_EraseRootFromParent_Done,
      // Label 12579: @814991
      GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(815066), // Rule ID 61357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61357,
        GIR_EraseRootFromParent_Done,
      // Label 12580: @815066
      GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(815141), // Rule ID 61360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61360,
        GIR_EraseRootFromParent_Done,
      // Label 12581: @815141
      GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(815216), // Rule ID 61361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61361,
        GIR_EraseRootFromParent_Done,
      // Label 12582: @815216
      GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(815291), // Rule ID 61364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61364,
        GIR_EraseRootFromParent_Done,
      // Label 12583: @815291
      GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(815366), // Rule ID 61365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61365,
        GIR_EraseRootFromParent_Done,
      // Label 12584: @815366
      GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(815441), // Rule ID 61368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61368,
        GIR_EraseRootFromParent_Done,
      // Label 12585: @815441
      GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(815516), // Rule ID 61369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61369,
        GIR_EraseRootFromParent_Done,
      // Label 12586: @815516
      GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(815591), // Rule ID 61372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61372,
        GIR_EraseRootFromParent_Done,
      // Label 12587: @815591
      GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(815666), // Rule ID 61373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61373,
        GIR_EraseRootFromParent_Done,
      // Label 12588: @815666
      GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(815741), // Rule ID 61816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61816,
        GIR_EraseRootFromParent_Done,
      // Label 12589: @815741
      GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(815816), // Rule ID 61817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61817,
        GIR_EraseRootFromParent_Done,
      // Label 12590: @815816
      GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(815891), // Rule ID 61818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61818,
        GIR_EraseRootFromParent_Done,
      // Label 12591: @815891
      GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(815966), // Rule ID 61819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61819,
        GIR_EraseRootFromParent_Done,
      // Label 12592: @815966
      GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(816041), // Rule ID 61820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61820,
        GIR_EraseRootFromParent_Done,
      // Label 12593: @816041
      GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(816116), // Rule ID 61821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61821,
        GIR_EraseRootFromParent_Done,
      // Label 12594: @816116
      GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(816191), // Rule ID 61822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61822,
        GIR_EraseRootFromParent_Done,
      // Label 12595: @816191
      GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(816266), // Rule ID 61823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61823,
        GIR_EraseRootFromParent_Done,
      // Label 12596: @816266
      GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(816330), // Rule ID 63931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10615:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63931,
        GIR_EraseRootFromParent_Done,
      // Label 12597: @816330
      GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(816394), // Rule ID 63932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10611:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63932,
        GIR_EraseRootFromParent_Done,
      // Label 12598: @816394
      GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(816458), // Rule ID 63933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10613:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63933,
        GIR_EraseRootFromParent_Done,
      // Label 12599: @816458
      GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(816522), // Rule ID 63934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10609:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63934,
        GIR_EraseRootFromParent_Done,
      // Label 12600: @816522
      GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(816586), // Rule ID 63935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10616:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63935,
        GIR_EraseRootFromParent_Done,
      // Label 12601: @816586
      GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(816650), // Rule ID 63936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10612:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63936,
        GIR_EraseRootFromParent_Done,
      // Label 12602: @816650
      GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(816714), // Rule ID 63937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10614:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63937,
        GIR_EraseRootFromParent_Done,
      // Label 12603: @816714
      GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(816778), // Rule ID 63938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] imm5
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
        // (intrinsic_wo_chain:{ *:[i32] } 10610:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/4, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // imm5
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63938,
        GIR_EraseRootFromParent_Done,
      // Label 12604: @816778
      GIM_Reject,
    // Label 5758: @816779
    GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(1356796),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
      GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(816870), // Rule ID 62267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62267,
        GIR_EraseRootFromParent_Done,
      // Label 12606: @816870
      GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(816953), // Rule ID 62268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62268,
        GIR_EraseRootFromParent_Done,
      // Label 12607: @816953
      GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(817036), // Rule ID 62311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62311,
        GIR_EraseRootFromParent_Done,
      // Label 12608: @817036
      GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(817119), // Rule ID 62312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62312,
        GIR_EraseRootFromParent_Done,
      // Label 12609: @817119
      GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(817202), // Rule ID 62355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62355,
        GIR_EraseRootFromParent_Done,
      // Label 12610: @817202
      GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(817285), // Rule ID 62356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62356,
        GIR_EraseRootFromParent_Done,
      // Label 12611: @817285
      GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(817368), // Rule ID 62399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62399,
        GIR_EraseRootFromParent_Done,
      // Label 12612: @817368
      GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(817451), // Rule ID 62400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62400,
        GIR_EraseRootFromParent_Done,
      // Label 12613: @817451
      GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(817534), // Rule ID 62455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62455,
        GIR_EraseRootFromParent_Done,
      // Label 12614: @817534
      GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(817617), // Rule ID 62456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62456,
        GIR_EraseRootFromParent_Done,
      // Label 12615: @817617
      GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(817700), // Rule ID 62511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62511,
        GIR_EraseRootFromParent_Done,
      // Label 12616: @817700
      GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(817783), // Rule ID 62512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62512,
        GIR_EraseRootFromParent_Done,
      // Label 12617: @817783
      GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(817866), // Rule ID 62567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62567,
        GIR_EraseRootFromParent_Done,
      // Label 12618: @817866
      GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(817949), // Rule ID 62568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62568,
        GIR_EraseRootFromParent_Done,
      // Label 12619: @817949
      GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(818032), // Rule ID 62611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62611,
        GIR_EraseRootFromParent_Done,
      // Label 12620: @818032
      GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(818115), // Rule ID 62612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62612,
        GIR_EraseRootFromParent_Done,
      // Label 12621: @818115
      GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(818198), // Rule ID 62667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62667,
        GIR_EraseRootFromParent_Done,
      // Label 12622: @818198
      GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(818281), // Rule ID 62668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62668,
        GIR_EraseRootFromParent_Done,
      // Label 12623: @818281
      GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(818364), // Rule ID 62723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62723,
        GIR_EraseRootFromParent_Done,
      // Label 12624: @818364
      GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(818447), // Rule ID 62724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62724,
        GIR_EraseRootFromParent_Done,
      // Label 12625: @818447
      GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(818530), // Rule ID 62779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62779,
        GIR_EraseRootFromParent_Done,
      // Label 12626: @818530
      GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(818613), // Rule ID 62780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62780,
        GIR_EraseRootFromParent_Done,
      // Label 12627: @818613
      GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(818696), // Rule ID 62823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62823,
        GIR_EraseRootFromParent_Done,
      // Label 12628: @818696
      GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(818779), // Rule ID 62824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62824,
        GIR_EraseRootFromParent_Done,
      // Label 12629: @818779
      GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(818862), // Rule ID 62867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62867,
        GIR_EraseRootFromParent_Done,
      // Label 12630: @818862
      GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(818945), // Rule ID 62868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62868,
        GIR_EraseRootFromParent_Done,
      // Label 12631: @818945
      GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(819028), // Rule ID 62911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62911,
        GIR_EraseRootFromParent_Done,
      // Label 12632: @819028
      GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(819111), // Rule ID 62912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62912,
        GIR_EraseRootFromParent_Done,
      // Label 12633: @819111
      GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(819194), // Rule ID 62967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62967,
        GIR_EraseRootFromParent_Done,
      // Label 12634: @819194
      GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(819277), // Rule ID 62968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62968,
        GIR_EraseRootFromParent_Done,
      // Label 12635: @819277
      GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(819360), // Rule ID 63023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63023,
        GIR_EraseRootFromParent_Done,
      // Label 12636: @819360
      GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(819443), // Rule ID 63024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63024,
        GIR_EraseRootFromParent_Done,
      // Label 12637: @819443
      GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(819526), // Rule ID 63079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63079,
        GIR_EraseRootFromParent_Done,
      // Label 12638: @819526
      GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(819609), // Rule ID 63080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63080,
        GIR_EraseRootFromParent_Done,
      // Label 12639: @819609
      GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(819692), // Rule ID 63135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63135,
        GIR_EraseRootFromParent_Done,
      // Label 12640: @819692
      GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(819775), // Rule ID 63136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63136,
        GIR_EraseRootFromParent_Done,
      // Label 12641: @819775
      GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(819858), // Rule ID 63191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63191,
        GIR_EraseRootFromParent_Done,
      // Label 12642: @819858
      GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(819941), // Rule ID 63192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63192,
        GIR_EraseRootFromParent_Done,
      // Label 12643: @819941
      GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(820024), // Rule ID 63247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63247,
        GIR_EraseRootFromParent_Done,
      // Label 12644: @820024
      GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(820107), // Rule ID 63248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63248,
        GIR_EraseRootFromParent_Done,
      // Label 12645: @820107
      GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(820190), // Rule ID 63303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63303,
        GIR_EraseRootFromParent_Done,
      // Label 12646: @820190
      GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(820273), // Rule ID 63304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63304,
        GIR_EraseRootFromParent_Done,
      // Label 12647: @820273
      GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(820356), // Rule ID 63359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10678:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63359,
        GIR_EraseRootFromParent_Done,
      // Label 12648: @820356
      GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(820439), // Rule ID 63360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10678:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63360,
        GIR_EraseRootFromParent_Done,
      // Label 12649: @820439
      GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(820522), // Rule ID 63389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63389,
        GIR_EraseRootFromParent_Done,
      // Label 12650: @820522
      GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(820605), // Rule ID 63390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63390,
        GIR_EraseRootFromParent_Done,
      // Label 12651: @820605
      GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(820688), // Rule ID 63407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63407,
        GIR_EraseRootFromParent_Done,
      // Label 12652: @820688
      GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(820771), // Rule ID 63408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63408,
        GIR_EraseRootFromParent_Done,
      // Label 12653: @820771
      GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(820854), // Rule ID 63425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63425,
        GIR_EraseRootFromParent_Done,
      // Label 12654: @820854
      GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(820937), // Rule ID 63426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63426,
        GIR_EraseRootFromParent_Done,
      // Label 12655: @820937
      GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(821020), // Rule ID 63443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63443,
        GIR_EraseRootFromParent_Done,
      // Label 12656: @821020
      GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(821103), // Rule ID 63444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63444,
        GIR_EraseRootFromParent_Done,
      // Label 12657: @821103
      GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(821186), // Rule ID 63461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63461,
        GIR_EraseRootFromParent_Done,
      // Label 12658: @821186
      GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(821269), // Rule ID 63462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63462,
        GIR_EraseRootFromParent_Done,
      // Label 12659: @821269
      GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(821352), // Rule ID 63479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63479,
        GIR_EraseRootFromParent_Done,
      // Label 12660: @821352
      GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(821435), // Rule ID 63480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63480,
        GIR_EraseRootFromParent_Done,
      // Label 12661: @821435
      GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(821518), // Rule ID 63497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63497,
        GIR_EraseRootFromParent_Done,
      // Label 12662: @821518
      GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(821601), // Rule ID 63498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63498,
        GIR_EraseRootFromParent_Done,
      // Label 12663: @821601
      GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(821684), // Rule ID 63521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63521,
        GIR_EraseRootFromParent_Done,
      // Label 12664: @821684
      GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(821767), // Rule ID 63522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63522,
        GIR_EraseRootFromParent_Done,
      // Label 12665: @821767
      GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(821850), // Rule ID 63545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63545,
        GIR_EraseRootFromParent_Done,
      // Label 12666: @821850
      GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(821933), // Rule ID 63546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63546,
        GIR_EraseRootFromParent_Done,
      // Label 12667: @821933
      GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(822016), // Rule ID 63569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63569,
        GIR_EraseRootFromParent_Done,
      // Label 12668: @822016
      GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(822099), // Rule ID 63570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63570,
        GIR_EraseRootFromParent_Done,
      // Label 12669: @822099
      GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(822182), // Rule ID 63593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63593,
        GIR_EraseRootFromParent_Done,
      // Label 12670: @822182
      GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(822265), // Rule ID 63594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63594,
        GIR_EraseRootFromParent_Done,
      // Label 12671: @822265
      GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(822348), // Rule ID 63617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63617,
        GIR_EraseRootFromParent_Done,
      // Label 12672: @822348
      GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(822431), // Rule ID 63618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63618,
        GIR_EraseRootFromParent_Done,
      // Label 12673: @822431
      GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(822514), // Rule ID 63641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63641,
        GIR_EraseRootFromParent_Done,
      // Label 12674: @822514
      GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(822597), // Rule ID 63642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63642,
        GIR_EraseRootFromParent_Done,
      // Label 12675: @822597
      GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(822680), // Rule ID 63665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63665,
        GIR_EraseRootFromParent_Done,
      // Label 12676: @822680
      GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(822763), // Rule ID 63666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63666,
        GIR_EraseRootFromParent_Done,
      // Label 12677: @822763
      GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(822846), // Rule ID 63689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63689,
        GIR_EraseRootFromParent_Done,
      // Label 12678: @822846
      GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(822929), // Rule ID 63690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63690,
        GIR_EraseRootFromParent_Done,
      // Label 12679: @822929
      GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(823007), // Rule ID 59982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10761:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59982,
        GIR_EraseRootFromParent_Done,
      // Label 12680: @823007
      GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(823085), // Rule ID 59983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10761:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59983,
        GIR_EraseRootFromParent_Done,
      // Label 12681: @823085
      GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(823163), // Rule ID 61638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10761:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61638,
        GIR_EraseRootFromParent_Done,
      // Label 12682: @823163
      GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(823241), // Rule ID 61639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10761:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61639,
        GIR_EraseRootFromParent_Done,
      // Label 12683: @823241
      GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(823319), // Rule ID 61640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10761:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61640,
        GIR_EraseRootFromParent_Done,
      // Label 12684: @823319
      GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(823397), // Rule ID 61641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10761:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61641,
        GIR_EraseRootFromParent_Done,
      // Label 12685: @823397
      GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(823475), // Rule ID 61642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10761:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61642,
        GIR_EraseRootFromParent_Done,
      // Label 12686: @823475
      GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(823553), // Rule ID 61643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10761:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61643,
        GIR_EraseRootFromParent_Done,
      // Label 12687: @823553
      GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(823631), // Rule ID 61644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10761:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61644,
        GIR_EraseRootFromParent_Done,
      // Label 12688: @823631
      GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(823709), // Rule ID 61645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10761:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61645,
        GIR_EraseRootFromParent_Done,
      // Label 12689: @823709
      GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(823787), // Rule ID 61806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61806,
        GIR_EraseRootFromParent_Done,
      // Label 12690: @823787
      GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(823865), // Rule ID 61807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61807,
        GIR_EraseRootFromParent_Done,
      // Label 12691: @823865
      GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(823943), // Rule ID 61808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61808,
        GIR_EraseRootFromParent_Done,
      // Label 12692: @823943
      GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(824021), // Rule ID 61809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61809,
        GIR_EraseRootFromParent_Done,
      // Label 12693: @824021
      GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(824099), // Rule ID 61810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61810,
        GIR_EraseRootFromParent_Done,
      // Label 12694: @824099
      GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(824177), // Rule ID 61811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61811,
        GIR_EraseRootFromParent_Done,
      // Label 12695: @824177
      GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(824255), // Rule ID 61812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61812,
        GIR_EraseRootFromParent_Done,
      // Label 12696: @824255
      GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(824333), // Rule ID 61813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61813,
        GIR_EraseRootFromParent_Done,
      // Label 12697: @824333
      GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(824411), // Rule ID 61814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61814,
        GIR_EraseRootFromParent_Done,
      // Label 12698: @824411
      GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(824489), // Rule ID 61815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] rs2
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61815,
        GIR_EraseRootFromParent_Done,
      // Label 12699: @824489
      GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(824577), // Rule ID 23548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23548,
        GIR_EraseRootFromParent_Done,
      // Label 12700: @824577
      GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(824665), // Rule ID 23549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23549,
        GIR_EraseRootFromParent_Done,
      // Label 12701: @824665
      GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(824753), // Rule ID 23552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23552,
        GIR_EraseRootFromParent_Done,
      // Label 12702: @824753
      GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(824841), // Rule ID 23553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23553,
        GIR_EraseRootFromParent_Done,
      // Label 12703: @824841
      GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(824929), // Rule ID 23556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23556,
        GIR_EraseRootFromParent_Done,
      // Label 12704: @824929
      GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(825017), // Rule ID 23557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23557,
        GIR_EraseRootFromParent_Done,
      // Label 12705: @825017
      GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(825105), // Rule ID 23560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23560,
        GIR_EraseRootFromParent_Done,
      // Label 12706: @825105
      GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(825193), // Rule ID 23561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23561,
        GIR_EraseRootFromParent_Done,
      // Label 12707: @825193
      GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(825281), // Rule ID 23564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23564,
        GIR_EraseRootFromParent_Done,
      // Label 12708: @825281
      GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(825369), // Rule ID 23565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23565,
        GIR_EraseRootFromParent_Done,
      // Label 12709: @825369
      GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(825457), // Rule ID 23568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23568,
        GIR_EraseRootFromParent_Done,
      // Label 12710: @825457
      GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(825545), // Rule ID 23569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23569,
        GIR_EraseRootFromParent_Done,
      // Label 12711: @825545
      GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(825633), // Rule ID 23572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23572,
        GIR_EraseRootFromParent_Done,
      // Label 12712: @825633
      GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(825721), // Rule ID 23573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23573,
        GIR_EraseRootFromParent_Done,
      // Label 12713: @825721
      GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(825809), // Rule ID 23576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23576,
        GIR_EraseRootFromParent_Done,
      // Label 12714: @825809
      GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(825897), // Rule ID 23577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23577,
        GIR_EraseRootFromParent_Done,
      // Label 12715: @825897
      GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(825985), // Rule ID 23580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23580,
        GIR_EraseRootFromParent_Done,
      // Label 12716: @825985
      GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(826073), // Rule ID 23581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23581,
        GIR_EraseRootFromParent_Done,
      // Label 12717: @826073
      GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(826161), // Rule ID 23584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23584,
        GIR_EraseRootFromParent_Done,
      // Label 12718: @826161
      GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(826249), // Rule ID 23585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23585,
        GIR_EraseRootFromParent_Done,
      // Label 12719: @826249
      GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(826337), // Rule ID 23588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23588,
        GIR_EraseRootFromParent_Done,
      // Label 12720: @826337
      GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(826425), // Rule ID 23589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23589,
        GIR_EraseRootFromParent_Done,
      // Label 12721: @826425
      GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(826513), // Rule ID 23592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23592,
        GIR_EraseRootFromParent_Done,
      // Label 12722: @826513
      GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(826601), // Rule ID 23593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23593,
        GIR_EraseRootFromParent_Done,
      // Label 12723: @826601
      GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(826689), // Rule ID 23596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23596,
        GIR_EraseRootFromParent_Done,
      // Label 12724: @826689
      GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(826777), // Rule ID 23597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23597,
        GIR_EraseRootFromParent_Done,
      // Label 12725: @826777
      GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(826865), // Rule ID 23600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23600,
        GIR_EraseRootFromParent_Done,
      // Label 12726: @826865
      GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(826953), // Rule ID 23601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23601,
        GIR_EraseRootFromParent_Done,
      // Label 12727: @826953
      GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(827041), // Rule ID 23604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23604,
        GIR_EraseRootFromParent_Done,
      // Label 12728: @827041
      GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(827129), // Rule ID 23605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23605,
        GIR_EraseRootFromParent_Done,
      // Label 12729: @827129
      GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(827217), // Rule ID 23608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23608,
        GIR_EraseRootFromParent_Done,
      // Label 12730: @827217
      GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(827305), // Rule ID 23609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23609,
        GIR_EraseRootFromParent_Done,
      // Label 12731: @827305
      GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(827393), // Rule ID 23612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23612,
        GIR_EraseRootFromParent_Done,
      // Label 12732: @827393
      GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(827481), // Rule ID 23613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23613,
        GIR_EraseRootFromParent_Done,
      // Label 12733: @827481
      GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(827569), // Rule ID 23616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23616,
        GIR_EraseRootFromParent_Done,
      // Label 12734: @827569
      GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(827657), // Rule ID 23617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23617,
        GIR_EraseRootFromParent_Done,
      // Label 12735: @827657
      GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(827745), // Rule ID 23620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23620,
        GIR_EraseRootFromParent_Done,
      // Label 12736: @827745
      GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(827833), // Rule ID 23621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23621,
        GIR_EraseRootFromParent_Done,
      // Label 12737: @827833
      GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(827921), // Rule ID 23624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23624,
        GIR_EraseRootFromParent_Done,
      // Label 12738: @827921
      GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(828009), // Rule ID 23625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23625,
        GIR_EraseRootFromParent_Done,
      // Label 12739: @828009
      GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(828097), // Rule ID 23628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23628,
        GIR_EraseRootFromParent_Done,
      // Label 12740: @828097
      GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(828185), // Rule ID 23629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23629,
        GIR_EraseRootFromParent_Done,
      // Label 12741: @828185
      GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(828273), // Rule ID 23632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23632,
        GIR_EraseRootFromParent_Done,
      // Label 12742: @828273
      GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(828361), // Rule ID 23633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23633,
        GIR_EraseRootFromParent_Done,
      // Label 12743: @828361
      GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(828449), // Rule ID 23724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23724,
        GIR_EraseRootFromParent_Done,
      // Label 12744: @828449
      GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(828537), // Rule ID 23725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23725,
        GIR_EraseRootFromParent_Done,
      // Label 12745: @828537
      GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(828625), // Rule ID 23728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23728,
        GIR_EraseRootFromParent_Done,
      // Label 12746: @828625
      GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(828713), // Rule ID 23729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23729,
        GIR_EraseRootFromParent_Done,
      // Label 12747: @828713
      GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(828801), // Rule ID 23732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23732,
        GIR_EraseRootFromParent_Done,
      // Label 12748: @828801
      GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(828889), // Rule ID 23733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23733,
        GIR_EraseRootFromParent_Done,
      // Label 12749: @828889
      GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(828977), // Rule ID 23736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23736,
        GIR_EraseRootFromParent_Done,
      // Label 12750: @828977
      GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(829065), // Rule ID 23737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23737,
        GIR_EraseRootFromParent_Done,
      // Label 12751: @829065
      GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(829153), // Rule ID 23740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23740,
        GIR_EraseRootFromParent_Done,
      // Label 12752: @829153
      GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(829241), // Rule ID 23741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23741,
        GIR_EraseRootFromParent_Done,
      // Label 12753: @829241
      GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(829329), // Rule ID 23744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23744,
        GIR_EraseRootFromParent_Done,
      // Label 12754: @829329
      GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(829417), // Rule ID 23745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23745,
        GIR_EraseRootFromParent_Done,
      // Label 12755: @829417
      GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(829505), // Rule ID 23748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23748,
        GIR_EraseRootFromParent_Done,
      // Label 12756: @829505
      GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(829593), // Rule ID 23749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23749,
        GIR_EraseRootFromParent_Done,
      // Label 12757: @829593
      GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(829681), // Rule ID 23752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23752,
        GIR_EraseRootFromParent_Done,
      // Label 12758: @829681
      GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(829769), // Rule ID 23753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23753,
        GIR_EraseRootFromParent_Done,
      // Label 12759: @829769
      GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(829857), // Rule ID 23756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23756,
        GIR_EraseRootFromParent_Done,
      // Label 12760: @829857
      GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(829945), // Rule ID 23757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23757,
        GIR_EraseRootFromParent_Done,
      // Label 12761: @829945
      GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(830033), // Rule ID 23760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23760,
        GIR_EraseRootFromParent_Done,
      // Label 12762: @830033
      GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(830121), // Rule ID 23761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23761,
        GIR_EraseRootFromParent_Done,
      // Label 12763: @830121
      GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(830209), // Rule ID 23764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23764,
        GIR_EraseRootFromParent_Done,
      // Label 12764: @830209
      GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(830297), // Rule ID 23765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23765,
        GIR_EraseRootFromParent_Done,
      // Label 12765: @830297
      GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(830385), // Rule ID 23768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23768,
        GIR_EraseRootFromParent_Done,
      // Label 12766: @830385
      GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(830473), // Rule ID 23769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23769,
        GIR_EraseRootFromParent_Done,
      // Label 12767: @830473
      GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(830561), // Rule ID 23772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23772,
        GIR_EraseRootFromParent_Done,
      // Label 12768: @830561
      GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(830649), // Rule ID 23773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23773,
        GIR_EraseRootFromParent_Done,
      // Label 12769: @830649
      GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(830737), // Rule ID 23776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23776,
        GIR_EraseRootFromParent_Done,
      // Label 12770: @830737
      GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(830825), // Rule ID 23777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23777,
        GIR_EraseRootFromParent_Done,
      // Label 12771: @830825
      GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(830913), // Rule ID 23780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23780,
        GIR_EraseRootFromParent_Done,
      // Label 12772: @830913
      GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(831001), // Rule ID 23781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23781,
        GIR_EraseRootFromParent_Done,
      // Label 12773: @831001
      GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(831089), // Rule ID 23784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23784,
        GIR_EraseRootFromParent_Done,
      // Label 12774: @831089
      GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(831177), // Rule ID 23785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23785,
        GIR_EraseRootFromParent_Done,
      // Label 12775: @831177
      GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(831265), // Rule ID 23788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23788,
        GIR_EraseRootFromParent_Done,
      // Label 12776: @831265
      GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(831353), // Rule ID 23789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23789,
        GIR_EraseRootFromParent_Done,
      // Label 12777: @831353
      GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(831441), // Rule ID 23792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23792,
        GIR_EraseRootFromParent_Done,
      // Label 12778: @831441
      GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(831529), // Rule ID 23793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23793,
        GIR_EraseRootFromParent_Done,
      // Label 12779: @831529
      GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(831617), // Rule ID 23796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23796,
        GIR_EraseRootFromParent_Done,
      // Label 12780: @831617
      GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(831705), // Rule ID 23797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23797,
        GIR_EraseRootFromParent_Done,
      // Label 12781: @831705
      GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(831793), // Rule ID 23800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23800,
        GIR_EraseRootFromParent_Done,
      // Label 12782: @831793
      GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(831881), // Rule ID 23801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23801,
        GIR_EraseRootFromParent_Done,
      // Label 12783: @831881
      GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(831969), // Rule ID 23804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23804,
        GIR_EraseRootFromParent_Done,
      // Label 12784: @831969
      GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(832057), // Rule ID 23805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23805,
        GIR_EraseRootFromParent_Done,
      // Label 12785: @832057
      GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(832145), // Rule ID 23808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23808,
        GIR_EraseRootFromParent_Done,
      // Label 12786: @832145
      GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(832233), // Rule ID 23809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23809,
        GIR_EraseRootFromParent_Done,
      // Label 12787: @832233
      GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(832321), // Rule ID 24048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24048,
        GIR_EraseRootFromParent_Done,
      // Label 12788: @832321
      GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(832409), // Rule ID 24049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24049,
        GIR_EraseRootFromParent_Done,
      // Label 12789: @832409
      GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(832497), // Rule ID 24052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24052,
        GIR_EraseRootFromParent_Done,
      // Label 12790: @832497
      GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(832585), // Rule ID 24053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24053,
        GIR_EraseRootFromParent_Done,
      // Label 12791: @832585
      GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(832673), // Rule ID 24056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24056,
        GIR_EraseRootFromParent_Done,
      // Label 12792: @832673
      GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(832761), // Rule ID 24057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24057,
        GIR_EraseRootFromParent_Done,
      // Label 12793: @832761
      GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(832849), // Rule ID 24060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24060,
        GIR_EraseRootFromParent_Done,
      // Label 12794: @832849
      GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(832937), // Rule ID 24061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24061,
        GIR_EraseRootFromParent_Done,
      // Label 12795: @832937
      GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(833025), // Rule ID 24064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24064,
        GIR_EraseRootFromParent_Done,
      // Label 12796: @833025
      GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(833113), // Rule ID 24065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24065,
        GIR_EraseRootFromParent_Done,
      // Label 12797: @833113
      GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(833201), // Rule ID 24068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24068,
        GIR_EraseRootFromParent_Done,
      // Label 12798: @833201
      GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(833289), // Rule ID 24069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24069,
        GIR_EraseRootFromParent_Done,
      // Label 12799: @833289
      GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(833377), // Rule ID 24072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24072,
        GIR_EraseRootFromParent_Done,
      // Label 12800: @833377
      GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(833465), // Rule ID 24073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24073,
        GIR_EraseRootFromParent_Done,
      // Label 12801: @833465
      GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(833553), // Rule ID 24076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24076,
        GIR_EraseRootFromParent_Done,
      // Label 12802: @833553
      GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(833641), // Rule ID 24077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24077,
        GIR_EraseRootFromParent_Done,
      // Label 12803: @833641
      GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(833729), // Rule ID 24080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24080,
        GIR_EraseRootFromParent_Done,
      // Label 12804: @833729
      GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(833817), // Rule ID 24081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24081,
        GIR_EraseRootFromParent_Done,
      // Label 12805: @833817
      GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(833905), // Rule ID 24084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24084,
        GIR_EraseRootFromParent_Done,
      // Label 12806: @833905
      GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(833993), // Rule ID 24085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24085,
        GIR_EraseRootFromParent_Done,
      // Label 12807: @833993
      GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(834081), // Rule ID 24088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24088,
        GIR_EraseRootFromParent_Done,
      // Label 12808: @834081
      GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(834169), // Rule ID 24089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24089,
        GIR_EraseRootFromParent_Done,
      // Label 12809: @834169
      GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(834257), // Rule ID 24092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24092,
        GIR_EraseRootFromParent_Done,
      // Label 12810: @834257
      GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(834345), // Rule ID 24093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24093,
        GIR_EraseRootFromParent_Done,
      // Label 12811: @834345
      GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(834433), // Rule ID 24096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24096,
        GIR_EraseRootFromParent_Done,
      // Label 12812: @834433
      GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(834521), // Rule ID 24097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24097,
        GIR_EraseRootFromParent_Done,
      // Label 12813: @834521
      GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(834609), // Rule ID 24100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24100,
        GIR_EraseRootFromParent_Done,
      // Label 12814: @834609
      GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(834697), // Rule ID 24101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24101,
        GIR_EraseRootFromParent_Done,
      // Label 12815: @834697
      GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(834785), // Rule ID 24104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24104,
        GIR_EraseRootFromParent_Done,
      // Label 12816: @834785
      GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(834873), // Rule ID 24105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24105,
        GIR_EraseRootFromParent_Done,
      // Label 12817: @834873
      GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(834961), // Rule ID 24168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24168,
        GIR_EraseRootFromParent_Done,
      // Label 12818: @834961
      GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(835049), // Rule ID 24169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24169,
        GIR_EraseRootFromParent_Done,
      // Label 12819: @835049
      GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(835137), // Rule ID 24172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24172,
        GIR_EraseRootFromParent_Done,
      // Label 12820: @835137
      GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(835225), // Rule ID 24173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24173,
        GIR_EraseRootFromParent_Done,
      // Label 12821: @835225
      GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(835313), // Rule ID 24176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24176,
        GIR_EraseRootFromParent_Done,
      // Label 12822: @835313
      GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(835401), // Rule ID 24177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24177,
        GIR_EraseRootFromParent_Done,
      // Label 12823: @835401
      GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(835489), // Rule ID 24180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24180,
        GIR_EraseRootFromParent_Done,
      // Label 12824: @835489
      GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(835577), // Rule ID 24181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24181,
        GIR_EraseRootFromParent_Done,
      // Label 12825: @835577
      GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(835665), // Rule ID 24184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24184,
        GIR_EraseRootFromParent_Done,
      // Label 12826: @835665
      GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(835753), // Rule ID 24185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24185,
        GIR_EraseRootFromParent_Done,
      // Label 12827: @835753
      GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(835841), // Rule ID 24188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24188,
        GIR_EraseRootFromParent_Done,
      // Label 12828: @835841
      GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(835929), // Rule ID 24189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24189,
        GIR_EraseRootFromParent_Done,
      // Label 12829: @835929
      GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(836017), // Rule ID 24192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24192,
        GIR_EraseRootFromParent_Done,
      // Label 12830: @836017
      GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(836105), // Rule ID 24193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24193,
        GIR_EraseRootFromParent_Done,
      // Label 12831: @836105
      GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(836193), // Rule ID 24196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24196,
        GIR_EraseRootFromParent_Done,
      // Label 12832: @836193
      GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(836281), // Rule ID 24197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24197,
        GIR_EraseRootFromParent_Done,
      // Label 12833: @836281
      GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(836369), // Rule ID 24200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24200,
        GIR_EraseRootFromParent_Done,
      // Label 12834: @836369
      GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(836457), // Rule ID 24201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24201,
        GIR_EraseRootFromParent_Done,
      // Label 12835: @836457
      GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(836545), // Rule ID 24204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24204,
        GIR_EraseRootFromParent_Done,
      // Label 12836: @836545
      GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(836633), // Rule ID 24205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24205,
        GIR_EraseRootFromParent_Done,
      // Label 12837: @836633
      GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(836721), // Rule ID 24208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24208,
        GIR_EraseRootFromParent_Done,
      // Label 12838: @836721
      GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(836809), // Rule ID 24209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24209,
        GIR_EraseRootFromParent_Done,
      // Label 12839: @836809
      GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(836897), // Rule ID 24212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24212,
        GIR_EraseRootFromParent_Done,
      // Label 12840: @836897
      GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(836985), // Rule ID 24213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24213,
        GIR_EraseRootFromParent_Done,
      // Label 12841: @836985
      GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(837073), // Rule ID 24216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24216,
        GIR_EraseRootFromParent_Done,
      // Label 12842: @837073
      GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(837161), // Rule ID 24217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24217,
        GIR_EraseRootFromParent_Done,
      // Label 12843: @837161
      GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(837249), // Rule ID 24220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24220,
        GIR_EraseRootFromParent_Done,
      // Label 12844: @837249
      GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(837337), // Rule ID 24221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24221,
        GIR_EraseRootFromParent_Done,
      // Label 12845: @837337
      GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(837425), // Rule ID 24224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24224,
        GIR_EraseRootFromParent_Done,
      // Label 12846: @837425
      GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(837513), // Rule ID 24225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24225,
        GIR_EraseRootFromParent_Done,
      // Label 12847: @837513
      GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(837604), // Rule ID 15836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15836,
        GIR_EraseRootFromParent_Done,
      // Label 12848: @837604
      GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(837695), // Rule ID 15837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15837,
        GIR_EraseRootFromParent_Done,
      // Label 12849: @837695
      GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(837786), // Rule ID 15840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15840,
        GIR_EraseRootFromParent_Done,
      // Label 12850: @837786
      GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(837877), // Rule ID 15841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15841,
        GIR_EraseRootFromParent_Done,
      // Label 12851: @837877
      GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(837968), // Rule ID 15844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15844,
        GIR_EraseRootFromParent_Done,
      // Label 12852: @837968
      GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(838059), // Rule ID 15845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15845,
        GIR_EraseRootFromParent_Done,
      // Label 12853: @838059
      GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(838150), // Rule ID 15848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15848,
        GIR_EraseRootFromParent_Done,
      // Label 12854: @838150
      GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(838241), // Rule ID 15849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15849,
        GIR_EraseRootFromParent_Done,
      // Label 12855: @838241
      GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(838332), // Rule ID 15852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15852,
        GIR_EraseRootFromParent_Done,
      // Label 12856: @838332
      GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(838423), // Rule ID 15853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15853,
        GIR_EraseRootFromParent_Done,
      // Label 12857: @838423
      GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(838514), // Rule ID 15856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15856,
        GIR_EraseRootFromParent_Done,
      // Label 12858: @838514
      GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(838605), // Rule ID 15857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15857,
        GIR_EraseRootFromParent_Done,
      // Label 12859: @838605
      GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(838696), // Rule ID 15860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15860,
        GIR_EraseRootFromParent_Done,
      // Label 12860: @838696
      GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(838787), // Rule ID 15861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15861,
        GIR_EraseRootFromParent_Done,
      // Label 12861: @838787
      GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(838878), // Rule ID 15864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15864,
        GIR_EraseRootFromParent_Done,
      // Label 12862: @838878
      GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(838969), // Rule ID 15865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15865,
        GIR_EraseRootFromParent_Done,
      // Label 12863: @838969
      GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(839060), // Rule ID 15868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15868,
        GIR_EraseRootFromParent_Done,
      // Label 12864: @839060
      GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(839151), // Rule ID 15869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15869,
        GIR_EraseRootFromParent_Done,
      // Label 12865: @839151
      GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(839242), // Rule ID 15872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15872,
        GIR_EraseRootFromParent_Done,
      // Label 12866: @839242
      GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(839333), // Rule ID 15873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15873,
        GIR_EraseRootFromParent_Done,
      // Label 12867: @839333
      GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(839424), // Rule ID 15876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15876,
        GIR_EraseRootFromParent_Done,
      // Label 12868: @839424
      GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(839515), // Rule ID 15877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15877,
        GIR_EraseRootFromParent_Done,
      // Label 12869: @839515
      GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(839606), // Rule ID 15880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15880,
        GIR_EraseRootFromParent_Done,
      // Label 12870: @839606
      GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(839697), // Rule ID 15881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15881,
        GIR_EraseRootFromParent_Done,
      // Label 12871: @839697
      GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(839788), // Rule ID 15884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15884,
        GIR_EraseRootFromParent_Done,
      // Label 12872: @839788
      GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(839879), // Rule ID 15885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15885,
        GIR_EraseRootFromParent_Done,
      // Label 12873: @839879
      GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(839970), // Rule ID 15888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15888,
        GIR_EraseRootFromParent_Done,
      // Label 12874: @839970
      GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(840061), // Rule ID 15889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15889,
        GIR_EraseRootFromParent_Done,
      // Label 12875: @840061
      GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(840152), // Rule ID 15892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15892,
        GIR_EraseRootFromParent_Done,
      // Label 12876: @840152
      GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(840243), // Rule ID 15893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15893,
        GIR_EraseRootFromParent_Done,
      // Label 12877: @840243
      GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(840334), // Rule ID 15896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15896,
        GIR_EraseRootFromParent_Done,
      // Label 12878: @840334
      GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(840425), // Rule ID 15897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15897,
        GIR_EraseRootFromParent_Done,
      // Label 12879: @840425
      GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(840516), // Rule ID 15900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15900,
        GIR_EraseRootFromParent_Done,
      // Label 12880: @840516
      GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(840607), // Rule ID 15901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15901,
        GIR_EraseRootFromParent_Done,
      // Label 12881: @840607
      GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(840698), // Rule ID 15904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15904,
        GIR_EraseRootFromParent_Done,
      // Label 12882: @840698
      GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(840789), // Rule ID 15905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15905,
        GIR_EraseRootFromParent_Done,
      // Label 12883: @840789
      GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(840880), // Rule ID 15908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15908,
        GIR_EraseRootFromParent_Done,
      // Label 12884: @840880
      GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(840971), // Rule ID 15909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15909,
        GIR_EraseRootFromParent_Done,
      // Label 12885: @840971
      GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(841062), // Rule ID 15912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15912,
        GIR_EraseRootFromParent_Done,
      // Label 12886: @841062
      GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(841153), // Rule ID 15913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15913,
        GIR_EraseRootFromParent_Done,
      // Label 12887: @841153
      GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(841244), // Rule ID 15916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15916,
        GIR_EraseRootFromParent_Done,
      // Label 12888: @841244
      GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(841335), // Rule ID 15917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15917,
        GIR_EraseRootFromParent_Done,
      // Label 12889: @841335
      GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(841426), // Rule ID 15920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15920,
        GIR_EraseRootFromParent_Done,
      // Label 12890: @841426
      GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(841517), // Rule ID 15921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15921,
        GIR_EraseRootFromParent_Done,
      // Label 12891: @841517
      GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(841608), // Rule ID 16100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16100,
        GIR_EraseRootFromParent_Done,
      // Label 12892: @841608
      GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(841699), // Rule ID 16101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16101,
        GIR_EraseRootFromParent_Done,
      // Label 12893: @841699
      GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(841790), // Rule ID 16104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16104,
        GIR_EraseRootFromParent_Done,
      // Label 12894: @841790
      GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(841881), // Rule ID 16105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16105,
        GIR_EraseRootFromParent_Done,
      // Label 12895: @841881
      GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(841972), // Rule ID 16108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16108,
        GIR_EraseRootFromParent_Done,
      // Label 12896: @841972
      GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(842063), // Rule ID 16109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16109,
        GIR_EraseRootFromParent_Done,
      // Label 12897: @842063
      GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(842154), // Rule ID 16112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16112,
        GIR_EraseRootFromParent_Done,
      // Label 12898: @842154
      GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(842245), // Rule ID 16113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16113,
        GIR_EraseRootFromParent_Done,
      // Label 12899: @842245
      GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(842336), // Rule ID 16116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16116,
        GIR_EraseRootFromParent_Done,
      // Label 12900: @842336
      GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(842427), // Rule ID 16117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16117,
        GIR_EraseRootFromParent_Done,
      // Label 12901: @842427
      GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(842518), // Rule ID 16120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16120,
        GIR_EraseRootFromParent_Done,
      // Label 12902: @842518
      GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(842609), // Rule ID 16121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16121,
        GIR_EraseRootFromParent_Done,
      // Label 12903: @842609
      GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(842700), // Rule ID 16124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16124,
        GIR_EraseRootFromParent_Done,
      // Label 12904: @842700
      GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(842791), // Rule ID 16125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16125,
        GIR_EraseRootFromParent_Done,
      // Label 12905: @842791
      GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(842882), // Rule ID 16128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16128,
        GIR_EraseRootFromParent_Done,
      // Label 12906: @842882
      GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(842973), // Rule ID 16129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16129,
        GIR_EraseRootFromParent_Done,
      // Label 12907: @842973
      GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(843064), // Rule ID 16132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16132,
        GIR_EraseRootFromParent_Done,
      // Label 12908: @843064
      GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(843155), // Rule ID 16133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16133,
        GIR_EraseRootFromParent_Done,
      // Label 12909: @843155
      GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(843246), // Rule ID 16136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16136,
        GIR_EraseRootFromParent_Done,
      // Label 12910: @843246
      GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(843337), // Rule ID 16137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16137,
        GIR_EraseRootFromParent_Done,
      // Label 12911: @843337
      GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(843428), // Rule ID 16140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16140,
        GIR_EraseRootFromParent_Done,
      // Label 12912: @843428
      GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(843519), // Rule ID 16141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16141,
        GIR_EraseRootFromParent_Done,
      // Label 12913: @843519
      GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(843610), // Rule ID 16144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16144,
        GIR_EraseRootFromParent_Done,
      // Label 12914: @843610
      GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(843701), // Rule ID 16145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16145,
        GIR_EraseRootFromParent_Done,
      // Label 12915: @843701
      GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(843792), // Rule ID 16148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16148,
        GIR_EraseRootFromParent_Done,
      // Label 12916: @843792
      GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(843883), // Rule ID 16149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16149,
        GIR_EraseRootFromParent_Done,
      // Label 12917: @843883
      GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(843974), // Rule ID 16152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16152,
        GIR_EraseRootFromParent_Done,
      // Label 12918: @843974
      GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(844065), // Rule ID 16153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16153,
        GIR_EraseRootFromParent_Done,
      // Label 12919: @844065
      GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(844156), // Rule ID 16156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16156,
        GIR_EraseRootFromParent_Done,
      // Label 12920: @844156
      GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(844247), // Rule ID 16157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16157,
        GIR_EraseRootFromParent_Done,
      // Label 12921: @844247
      GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(844338), // Rule ID 16160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16160,
        GIR_EraseRootFromParent_Done,
      // Label 12922: @844338
      GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(844429), // Rule ID 16161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16161,
        GIR_EraseRootFromParent_Done,
      // Label 12923: @844429
      GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(844520), // Rule ID 16164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16164,
        GIR_EraseRootFromParent_Done,
      // Label 12924: @844520
      GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(844611), // Rule ID 16165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16165,
        GIR_EraseRootFromParent_Done,
      // Label 12925: @844611
      GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(844702), // Rule ID 16168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16168,
        GIR_EraseRootFromParent_Done,
      // Label 12926: @844702
      GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(844793), // Rule ID 16169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16169,
        GIR_EraseRootFromParent_Done,
      // Label 12927: @844793
      GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(844884), // Rule ID 16172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16172,
        GIR_EraseRootFromParent_Done,
      // Label 12928: @844884
      GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(844975), // Rule ID 16173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16173,
        GIR_EraseRootFromParent_Done,
      // Label 12929: @844975
      GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(845066), // Rule ID 16176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16176,
        GIR_EraseRootFromParent_Done,
      // Label 12930: @845066
      GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(845157), // Rule ID 16177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16177,
        GIR_EraseRootFromParent_Done,
      // Label 12931: @845157
      GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(845248), // Rule ID 16180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16180,
        GIR_EraseRootFromParent_Done,
      // Label 12932: @845248
      GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(845339), // Rule ID 16181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16181,
        GIR_EraseRootFromParent_Done,
      // Label 12933: @845339
      GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(845430), // Rule ID 16184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16184,
        GIR_EraseRootFromParent_Done,
      // Label 12934: @845430
      GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(845521), // Rule ID 16185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16185,
        GIR_EraseRootFromParent_Done,
      // Label 12935: @845521
      GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(845615), // Rule ID 16308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16308,
        GIR_EraseRootFromParent_Done,
      // Label 12936: @845615
      GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(845709), // Rule ID 16309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16309,
        GIR_EraseRootFromParent_Done,
      // Label 12937: @845709
      GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(845803), // Rule ID 16312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16312,
        GIR_EraseRootFromParent_Done,
      // Label 12938: @845803
      GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(845897), // Rule ID 16313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16313,
        GIR_EraseRootFromParent_Done,
      // Label 12939: @845897
      GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(845991), // Rule ID 16316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16316,
        GIR_EraseRootFromParent_Done,
      // Label 12940: @845991
      GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(846085), // Rule ID 16317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16317,
        GIR_EraseRootFromParent_Done,
      // Label 12941: @846085
      GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(846179), // Rule ID 16320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16320,
        GIR_EraseRootFromParent_Done,
      // Label 12942: @846179
      GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(846273), // Rule ID 16321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16321,
        GIR_EraseRootFromParent_Done,
      // Label 12943: @846273
      GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(846367), // Rule ID 16324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16324,
        GIR_EraseRootFromParent_Done,
      // Label 12944: @846367
      GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(846461), // Rule ID 16325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16325,
        GIR_EraseRootFromParent_Done,
      // Label 12945: @846461
      GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(846555), // Rule ID 16328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16328,
        GIR_EraseRootFromParent_Done,
      // Label 12946: @846555
      GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(846649), // Rule ID 16329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16329,
        GIR_EraseRootFromParent_Done,
      // Label 12947: @846649
      GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(846743), // Rule ID 16332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16332,
        GIR_EraseRootFromParent_Done,
      // Label 12948: @846743
      GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(846837), // Rule ID 16333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16333,
        GIR_EraseRootFromParent_Done,
      // Label 12949: @846837
      GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(846931), // Rule ID 16336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16336,
        GIR_EraseRootFromParent_Done,
      // Label 12950: @846931
      GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(847025), // Rule ID 16337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16337,
        GIR_EraseRootFromParent_Done,
      // Label 12951: @847025
      GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(847119), // Rule ID 16340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16340,
        GIR_EraseRootFromParent_Done,
      // Label 12952: @847119
      GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(847213), // Rule ID 16341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16341,
        GIR_EraseRootFromParent_Done,
      // Label 12953: @847213
      GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(847307), // Rule ID 16344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16344,
        GIR_EraseRootFromParent_Done,
      // Label 12954: @847307
      GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(847401), // Rule ID 16345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16345,
        GIR_EraseRootFromParent_Done,
      // Label 12955: @847401
      GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(847495), // Rule ID 16348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16348,
        GIR_EraseRootFromParent_Done,
      // Label 12956: @847495
      GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(847589), // Rule ID 16349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16349,
        GIR_EraseRootFromParent_Done,
      // Label 12957: @847589
      GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(847683), // Rule ID 16352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16352,
        GIR_EraseRootFromParent_Done,
      // Label 12958: @847683
      GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(847777), // Rule ID 16353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16353,
        GIR_EraseRootFromParent_Done,
      // Label 12959: @847777
      GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(847871), // Rule ID 16356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16356,
        GIR_EraseRootFromParent_Done,
      // Label 12960: @847871
      GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(847965), // Rule ID 16357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16357,
        GIR_EraseRootFromParent_Done,
      // Label 12961: @847965
      GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(848059), // Rule ID 16360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16360,
        GIR_EraseRootFromParent_Done,
      // Label 12962: @848059
      GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(848153), // Rule ID 16361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16361,
        GIR_EraseRootFromParent_Done,
      // Label 12963: @848153
      GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(848247), // Rule ID 16364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16364,
        GIR_EraseRootFromParent_Done,
      // Label 12964: @848247
      GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(848341), // Rule ID 16365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16365,
        GIR_EraseRootFromParent_Done,
      // Label 12965: @848341
      GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(848435), // Rule ID 16488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16488,
        GIR_EraseRootFromParent_Done,
      // Label 12966: @848435
      GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(848529), // Rule ID 16489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16489,
        GIR_EraseRootFromParent_Done,
      // Label 12967: @848529
      GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(848623), // Rule ID 16492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16492,
        GIR_EraseRootFromParent_Done,
      // Label 12968: @848623
      GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(848717), // Rule ID 16493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16493,
        GIR_EraseRootFromParent_Done,
      // Label 12969: @848717
      GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(848811), // Rule ID 16496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16496,
        GIR_EraseRootFromParent_Done,
      // Label 12970: @848811
      GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(848905), // Rule ID 16497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16497,
        GIR_EraseRootFromParent_Done,
      // Label 12971: @848905
      GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(848999), // Rule ID 16500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16500,
        GIR_EraseRootFromParent_Done,
      // Label 12972: @848999
      GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(849093), // Rule ID 16501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16501,
        GIR_EraseRootFromParent_Done,
      // Label 12973: @849093
      GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(849187), // Rule ID 16504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16504,
        GIR_EraseRootFromParent_Done,
      // Label 12974: @849187
      GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(849281), // Rule ID 16505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16505,
        GIR_EraseRootFromParent_Done,
      // Label 12975: @849281
      GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(849375), // Rule ID 16508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16508,
        GIR_EraseRootFromParent_Done,
      // Label 12976: @849375
      GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(849469), // Rule ID 16509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16509,
        GIR_EraseRootFromParent_Done,
      // Label 12977: @849469
      GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(849563), // Rule ID 16512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16512,
        GIR_EraseRootFromParent_Done,
      // Label 12978: @849563
      GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(849657), // Rule ID 16513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16513,
        GIR_EraseRootFromParent_Done,
      // Label 12979: @849657
      GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(849751), // Rule ID 16516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16516,
        GIR_EraseRootFromParent_Done,
      // Label 12980: @849751
      GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(849845), // Rule ID 16517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16517,
        GIR_EraseRootFromParent_Done,
      // Label 12981: @849845
      GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(849939), // Rule ID 16520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16520,
        GIR_EraseRootFromParent_Done,
      // Label 12982: @849939
      GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(850033), // Rule ID 16521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16521,
        GIR_EraseRootFromParent_Done,
      // Label 12983: @850033
      GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(850127), // Rule ID 16524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16524,
        GIR_EraseRootFromParent_Done,
      // Label 12984: @850127
      GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(850221), // Rule ID 16525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16525,
        GIR_EraseRootFromParent_Done,
      // Label 12985: @850221
      GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(850315), // Rule ID 16528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16528,
        GIR_EraseRootFromParent_Done,
      // Label 12986: @850315
      GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(850409), // Rule ID 16529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16529,
        GIR_EraseRootFromParent_Done,
      // Label 12987: @850409
      GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(850503), // Rule ID 16532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16532,
        GIR_EraseRootFromParent_Done,
      // Label 12988: @850503
      GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(850597), // Rule ID 16533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16533,
        GIR_EraseRootFromParent_Done,
      // Label 12989: @850597
      GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(850691), // Rule ID 16536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16536,
        GIR_EraseRootFromParent_Done,
      // Label 12990: @850691
      GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(850785), // Rule ID 16537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16537,
        GIR_EraseRootFromParent_Done,
      // Label 12991: @850785
      GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(850879), // Rule ID 16540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16540,
        GIR_EraseRootFromParent_Done,
      // Label 12992: @850879
      GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(850973), // Rule ID 16541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16541,
        GIR_EraseRootFromParent_Done,
      // Label 12993: @850973
      GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(851067), // Rule ID 16544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16544,
        GIR_EraseRootFromParent_Done,
      // Label 12994: @851067
      GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(851161), // Rule ID 16545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16545,
        GIR_EraseRootFromParent_Done,
      // Label 12995: @851161
      GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(851245), // Rule ID 2620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2620,
        GIR_EraseRootFromParent_Done,
      // Label 12996: @851245
      GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(851329), // Rule ID 2621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2621,
        GIR_EraseRootFromParent_Done,
      // Label 12997: @851329
      GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(851413), // Rule ID 16992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16992,
        GIR_EraseRootFromParent_Done,
      // Label 12998: @851413
      GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(851497), // Rule ID 16993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16993,
        GIR_EraseRootFromParent_Done,
      // Label 12999: @851497
      GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(851581), // Rule ID 17002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17002,
        GIR_EraseRootFromParent_Done,
      // Label 13000: @851581
      GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(851665), // Rule ID 17003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17003,
        GIR_EraseRootFromParent_Done,
      // Label 13001: @851665
      GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(851749), // Rule ID 17012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17012,
        GIR_EraseRootFromParent_Done,
      // Label 13002: @851749
      GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(851833), // Rule ID 17013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17013,
        GIR_EraseRootFromParent_Done,
      // Label 13003: @851833
      GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(851917), // Rule ID 17022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17022,
        GIR_EraseRootFromParent_Done,
      // Label 13004: @851917
      GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(852001), // Rule ID 17023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17023,
        GIR_EraseRootFromParent_Done,
      // Label 13005: @852001
      GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(852085), // Rule ID 17032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17032,
        GIR_EraseRootFromParent_Done,
      // Label 13006: @852085
      GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(852169), // Rule ID 17033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17033,
        GIR_EraseRootFromParent_Done,
      // Label 13007: @852169
      GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(852253), // Rule ID 17042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17042,
        GIR_EraseRootFromParent_Done,
      // Label 13008: @852253
      GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(852337), // Rule ID 17043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17043,
        GIR_EraseRootFromParent_Done,
      // Label 13009: @852337
      GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(852421), // Rule ID 17052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17052,
        GIR_EraseRootFromParent_Done,
      // Label 13010: @852421
      GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(852505), // Rule ID 17053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17053,
        GIR_EraseRootFromParent_Done,
      // Label 13011: @852505
      GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(852589), // Rule ID 17062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17062,
        GIR_EraseRootFromParent_Done,
      // Label 13012: @852589
      GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(852673), // Rule ID 17063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10888:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17063,
        GIR_EraseRootFromParent_Done,
      // Label 13013: @852673
      GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(852757), // Rule ID 17108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17108,
        GIR_EraseRootFromParent_Done,
      // Label 13014: @852757
      GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(852841), // Rule ID 17109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17109,
        GIR_EraseRootFromParent_Done,
      // Label 13015: @852841
      GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(852925), // Rule ID 17118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17118,
        GIR_EraseRootFromParent_Done,
      // Label 13016: @852925
      GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(853009), // Rule ID 17119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17119,
        GIR_EraseRootFromParent_Done,
      // Label 13017: @853009
      GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(853093), // Rule ID 17128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17128,
        GIR_EraseRootFromParent_Done,
      // Label 13018: @853093
      GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(853177), // Rule ID 17129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17129,
        GIR_EraseRootFromParent_Done,
      // Label 13019: @853177
      GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(853261), // Rule ID 17138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17138,
        GIR_EraseRootFromParent_Done,
      // Label 13020: @853261
      GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(853345), // Rule ID 17139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17139,
        GIR_EraseRootFromParent_Done,
      // Label 13021: @853345
      GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(853429), // Rule ID 17148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17148,
        GIR_EraseRootFromParent_Done,
      // Label 13022: @853429
      GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(853513), // Rule ID 17149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17149,
        GIR_EraseRootFromParent_Done,
      // Label 13023: @853513
      GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(853597), // Rule ID 17158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17158,
        GIR_EraseRootFromParent_Done,
      // Label 13024: @853597
      GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(853681), // Rule ID 17159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17159,
        GIR_EraseRootFromParent_Done,
      // Label 13025: @853681
      GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(853765), // Rule ID 17168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17168,
        GIR_EraseRootFromParent_Done,
      // Label 13026: @853765
      GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(853849), // Rule ID 17169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17169,
        GIR_EraseRootFromParent_Done,
      // Label 13027: @853849
      GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(853933), // Rule ID 17178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17178,
        GIR_EraseRootFromParent_Done,
      // Label 13028: @853933
      GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(854017), // Rule ID 17179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17179,
        GIR_EraseRootFromParent_Done,
      // Label 13029: @854017
      GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(854101), // Rule ID 17188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17188,
        GIR_EraseRootFromParent_Done,
      // Label 13030: @854101
      GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(854185), // Rule ID 17189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10924:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17189,
        GIR_EraseRootFromParent_Done,
      // Label 13031: @854185
      GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(854267), // Rule ID 62243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62243,
        GIR_EraseRootFromParent_Done,
      // Label 13032: @854267
      GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(854349), // Rule ID 62244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62244,
        GIR_EraseRootFromParent_Done,
      // Label 13033: @854349
      GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(854431), // Rule ID 62273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62273,
        GIR_EraseRootFromParent_Done,
      // Label 13034: @854431
      GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(854513), // Rule ID 62274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62274,
        GIR_EraseRootFromParent_Done,
      // Label 13035: @854513
      GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(854595), // Rule ID 62305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62305,
        GIR_EraseRootFromParent_Done,
      // Label 13036: @854595
      GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(854677), // Rule ID 62306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62306,
        GIR_EraseRootFromParent_Done,
      // Label 13037: @854677
      GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(854759), // Rule ID 62317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62317,
        GIR_EraseRootFromParent_Done,
      // Label 13038: @854759
      GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(854841), // Rule ID 62318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62318,
        GIR_EraseRootFromParent_Done,
      // Label 13039: @854841
      GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(854923), // Rule ID 62349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62349,
        GIR_EraseRootFromParent_Done,
      // Label 13040: @854923
      GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(855005), // Rule ID 62350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62350,
        GIR_EraseRootFromParent_Done,
      // Label 13041: @855005
      GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(855087), // Rule ID 62361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62361,
        GIR_EraseRootFromParent_Done,
      // Label 13042: @855087
      GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(855169), // Rule ID 62362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62362,
        GIR_EraseRootFromParent_Done,
      // Label 13043: @855169
      GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(855251), // Rule ID 62393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62393,
        GIR_EraseRootFromParent_Done,
      // Label 13044: @855251
      GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(855333), // Rule ID 62394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62394,
        GIR_EraseRootFromParent_Done,
      // Label 13045: @855333
      GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(855415), // Rule ID 62405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62405,
        GIR_EraseRootFromParent_Done,
      // Label 13046: @855415
      GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(855497), // Rule ID 62406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62406,
        GIR_EraseRootFromParent_Done,
      // Label 13047: @855497
      GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(855579), // Rule ID 62417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62417,
        GIR_EraseRootFromParent_Done,
      // Label 13048: @855579
      GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(855661), // Rule ID 62418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62418,
        GIR_EraseRootFromParent_Done,
      // Label 13049: @855661
      GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(855743), // Rule ID 62449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62449,
        GIR_EraseRootFromParent_Done,
      // Label 13050: @855743
      GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(855825), // Rule ID 62450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62450,
        GIR_EraseRootFromParent_Done,
      // Label 13051: @855825
      GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(855907), // Rule ID 62461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62461,
        GIR_EraseRootFromParent_Done,
      // Label 13052: @855907
      GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(855989), // Rule ID 62462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62462,
        GIR_EraseRootFromParent_Done,
      // Label 13053: @855989
      GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(856071), // Rule ID 62473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62473,
        GIR_EraseRootFromParent_Done,
      // Label 13054: @856071
      GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(856153), // Rule ID 62474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62474,
        GIR_EraseRootFromParent_Done,
      // Label 13055: @856153
      GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(856235), // Rule ID 62505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62505,
        GIR_EraseRootFromParent_Done,
      // Label 13056: @856235
      GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(856317), // Rule ID 62506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62506,
        GIR_EraseRootFromParent_Done,
      // Label 13057: @856317
      GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(856399), // Rule ID 62517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62517,
        GIR_EraseRootFromParent_Done,
      // Label 13058: @856399
      GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(856481), // Rule ID 62518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62518,
        GIR_EraseRootFromParent_Done,
      // Label 13059: @856481
      GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(856563), // Rule ID 62529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62529,
        GIR_EraseRootFromParent_Done,
      // Label 13060: @856563
      GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(856645), // Rule ID 62530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62530,
        GIR_EraseRootFromParent_Done,
      // Label 13061: @856645
      GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(856727), // Rule ID 62561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62561,
        GIR_EraseRootFromParent_Done,
      // Label 13062: @856727
      GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(856809), // Rule ID 62562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62562,
        GIR_EraseRootFromParent_Done,
      // Label 13063: @856809
      GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(856891), // Rule ID 62573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62573,
        GIR_EraseRootFromParent_Done,
      // Label 13064: @856891
      GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(856973), // Rule ID 62574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62574,
        GIR_EraseRootFromParent_Done,
      // Label 13065: @856973
      GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(857055), // Rule ID 62605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62605,
        GIR_EraseRootFromParent_Done,
      // Label 13066: @857055
      GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(857137), // Rule ID 62606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62606,
        GIR_EraseRootFromParent_Done,
      // Label 13067: @857137
      GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(857219), // Rule ID 62617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62617,
        GIR_EraseRootFromParent_Done,
      // Label 13068: @857219
      GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(857301), // Rule ID 62618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62618,
        GIR_EraseRootFromParent_Done,
      // Label 13069: @857301
      GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(857383), // Rule ID 62629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62629,
        GIR_EraseRootFromParent_Done,
      // Label 13070: @857383
      GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(857465), // Rule ID 62630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62630,
        GIR_EraseRootFromParent_Done,
      // Label 13071: @857465
      GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(857547), // Rule ID 62661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62661,
        GIR_EraseRootFromParent_Done,
      // Label 13072: @857547
      GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(857629), // Rule ID 62662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62662,
        GIR_EraseRootFromParent_Done,
      // Label 13073: @857629
      GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(857711), // Rule ID 62673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62673,
        GIR_EraseRootFromParent_Done,
      // Label 13074: @857711
      GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(857793), // Rule ID 62674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62674,
        GIR_EraseRootFromParent_Done,
      // Label 13075: @857793
      GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(857875), // Rule ID 62685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62685,
        GIR_EraseRootFromParent_Done,
      // Label 13076: @857875
      GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(857957), // Rule ID 62686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62686,
        GIR_EraseRootFromParent_Done,
      // Label 13077: @857957
      GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(858039), // Rule ID 62717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62717,
        GIR_EraseRootFromParent_Done,
      // Label 13078: @858039
      GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(858121), // Rule ID 62718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62718,
        GIR_EraseRootFromParent_Done,
      // Label 13079: @858121
      GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(858203), // Rule ID 62729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62729,
        GIR_EraseRootFromParent_Done,
      // Label 13080: @858203
      GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(858285), // Rule ID 62730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62730,
        GIR_EraseRootFromParent_Done,
      // Label 13081: @858285
      GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(858367), // Rule ID 62741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62741,
        GIR_EraseRootFromParent_Done,
      // Label 13082: @858367
      GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(858449), // Rule ID 62742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62742,
        GIR_EraseRootFromParent_Done,
      // Label 13083: @858449
      GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(858531), // Rule ID 62773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62773,
        GIR_EraseRootFromParent_Done,
      // Label 13084: @858531
      GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(858613), // Rule ID 62774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62774,
        GIR_EraseRootFromParent_Done,
      // Label 13085: @858613
      GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(858695), // Rule ID 62785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62785,
        GIR_EraseRootFromParent_Done,
      // Label 13086: @858695
      GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(858777), // Rule ID 62786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62786,
        GIR_EraseRootFromParent_Done,
      // Label 13087: @858777
      GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(858859), // Rule ID 62817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62817,
        GIR_EraseRootFromParent_Done,
      // Label 13088: @858859
      GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(858941), // Rule ID 62818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62818,
        GIR_EraseRootFromParent_Done,
      // Label 13089: @858941
      GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(859023), // Rule ID 62829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62829,
        GIR_EraseRootFromParent_Done,
      // Label 13090: @859023
      GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(859105), // Rule ID 62830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62830,
        GIR_EraseRootFromParent_Done,
      // Label 13091: @859105
      GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(859187), // Rule ID 62861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62861,
        GIR_EraseRootFromParent_Done,
      // Label 13092: @859187
      GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(859269), // Rule ID 62862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62862,
        GIR_EraseRootFromParent_Done,
      // Label 13093: @859269
      GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(859351), // Rule ID 62873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62873,
        GIR_EraseRootFromParent_Done,
      // Label 13094: @859351
      GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(859433), // Rule ID 62874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62874,
        GIR_EraseRootFromParent_Done,
      // Label 13095: @859433
      GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(859515), // Rule ID 62905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62905,
        GIR_EraseRootFromParent_Done,
      // Label 13096: @859515
      GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(859597), // Rule ID 62906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62906,
        GIR_EraseRootFromParent_Done,
      // Label 13097: @859597
      GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(859679), // Rule ID 62917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62917,
        GIR_EraseRootFromParent_Done,
      // Label 13098: @859679
      GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(859761), // Rule ID 62918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62918,
        GIR_EraseRootFromParent_Done,
      // Label 13099: @859761
      GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(859843), // Rule ID 62929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62929,
        GIR_EraseRootFromParent_Done,
      // Label 13100: @859843
      GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(859925), // Rule ID 62930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62930,
        GIR_EraseRootFromParent_Done,
      // Label 13101: @859925
      GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(860007), // Rule ID 62961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62961,
        GIR_EraseRootFromParent_Done,
      // Label 13102: @860007
      GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(860089), // Rule ID 62962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62962,
        GIR_EraseRootFromParent_Done,
      // Label 13103: @860089
      GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(860171), // Rule ID 62973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62973,
        GIR_EraseRootFromParent_Done,
      // Label 13104: @860171
      GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(860253), // Rule ID 62974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62974,
        GIR_EraseRootFromParent_Done,
      // Label 13105: @860253
      GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(860335), // Rule ID 62985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62985,
        GIR_EraseRootFromParent_Done,
      // Label 13106: @860335
      GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(860417), // Rule ID 62986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62986,
        GIR_EraseRootFromParent_Done,
      // Label 13107: @860417
      GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(860499), // Rule ID 63017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63017,
        GIR_EraseRootFromParent_Done,
      // Label 13108: @860499
      GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(860581), // Rule ID 63018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63018,
        GIR_EraseRootFromParent_Done,
      // Label 13109: @860581
      GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(860663), // Rule ID 63029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63029,
        GIR_EraseRootFromParent_Done,
      // Label 13110: @860663
      GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(860745), // Rule ID 63030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63030,
        GIR_EraseRootFromParent_Done,
      // Label 13111: @860745
      GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(860827), // Rule ID 63041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63041,
        GIR_EraseRootFromParent_Done,
      // Label 13112: @860827
      GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(860909), // Rule ID 63042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63042,
        GIR_EraseRootFromParent_Done,
      // Label 13113: @860909
      GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(860991), // Rule ID 63073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63073,
        GIR_EraseRootFromParent_Done,
      // Label 13114: @860991
      GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(861073), // Rule ID 63074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63074,
        GIR_EraseRootFromParent_Done,
      // Label 13115: @861073
      GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(861155), // Rule ID 63085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63085,
        GIR_EraseRootFromParent_Done,
      // Label 13116: @861155
      GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(861237), // Rule ID 63086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63086,
        GIR_EraseRootFromParent_Done,
      // Label 13117: @861237
      GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(861319), // Rule ID 63097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63097,
        GIR_EraseRootFromParent_Done,
      // Label 13118: @861319
      GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(861401), // Rule ID 63098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63098,
        GIR_EraseRootFromParent_Done,
      // Label 13119: @861401
      GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(861483), // Rule ID 63129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63129,
        GIR_EraseRootFromParent_Done,
      // Label 13120: @861483
      GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(861565), // Rule ID 63130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63130,
        GIR_EraseRootFromParent_Done,
      // Label 13121: @861565
      GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(861647), // Rule ID 63141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63141,
        GIR_EraseRootFromParent_Done,
      // Label 13122: @861647
      GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(861729), // Rule ID 63142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63142,
        GIR_EraseRootFromParent_Done,
      // Label 13123: @861729
      GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(861811), // Rule ID 63153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63153,
        GIR_EraseRootFromParent_Done,
      // Label 13124: @861811
      GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(861893), // Rule ID 63154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63154,
        GIR_EraseRootFromParent_Done,
      // Label 13125: @861893
      GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(861975), // Rule ID 63185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63185,
        GIR_EraseRootFromParent_Done,
      // Label 13126: @861975
      GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(862057), // Rule ID 63186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63186,
        GIR_EraseRootFromParent_Done,
      // Label 13127: @862057
      GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(862139), // Rule ID 63197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63197,
        GIR_EraseRootFromParent_Done,
      // Label 13128: @862139
      GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(862221), // Rule ID 63198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63198,
        GIR_EraseRootFromParent_Done,
      // Label 13129: @862221
      GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(862303), // Rule ID 63209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63209,
        GIR_EraseRootFromParent_Done,
      // Label 13130: @862303
      GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(862385), // Rule ID 63210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63210,
        GIR_EraseRootFromParent_Done,
      // Label 13131: @862385
      GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(862467), // Rule ID 63241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63241,
        GIR_EraseRootFromParent_Done,
      // Label 13132: @862467
      GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(862549), // Rule ID 63242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63242,
        GIR_EraseRootFromParent_Done,
      // Label 13133: @862549
      GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(862631), // Rule ID 63253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63253,
        GIR_EraseRootFromParent_Done,
      // Label 13134: @862631
      GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(862713), // Rule ID 63254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63254,
        GIR_EraseRootFromParent_Done,
      // Label 13135: @862713
      GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(862795), // Rule ID 63265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63265,
        GIR_EraseRootFromParent_Done,
      // Label 13136: @862795
      GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(862877), // Rule ID 63266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63266,
        GIR_EraseRootFromParent_Done,
      // Label 13137: @862877
      GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(862959), // Rule ID 63297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63297,
        GIR_EraseRootFromParent_Done,
      // Label 13138: @862959
      GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(863041), // Rule ID 63298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63298,
        GIR_EraseRootFromParent_Done,
      // Label 13139: @863041
      GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(863123), // Rule ID 63309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63309,
        GIR_EraseRootFromParent_Done,
      // Label 13140: @863123
      GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(863205), // Rule ID 63310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63310,
        GIR_EraseRootFromParent_Done,
      // Label 13141: @863205
      GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(863287), // Rule ID 63321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63321,
        GIR_EraseRootFromParent_Done,
      // Label 13142: @863287
      GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(863369), // Rule ID 63322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63322,
        GIR_EraseRootFromParent_Done,
      // Label 13143: @863369
      GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(863451), // Rule ID 63353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10692:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63353,
        GIR_EraseRootFromParent_Done,
      // Label 13144: @863451
      GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(863533), // Rule ID 63354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10692:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63354,
        GIR_EraseRootFromParent_Done,
      // Label 13145: @863533
      GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(863615), // Rule ID 63365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10684:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63365,
        GIR_EraseRootFromParent_Done,
      // Label 13146: @863615
      GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(863697), // Rule ID 63366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10684:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63366,
        GIR_EraseRootFromParent_Done,
      // Label 13147: @863697
      GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(863779), // Rule ID 63377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63377,
        GIR_EraseRootFromParent_Done,
      // Label 13148: @863779
      GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(863861), // Rule ID 63378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63378,
        GIR_EraseRootFromParent_Done,
      // Label 13149: @863861
      GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(863943), // Rule ID 63383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63383,
        GIR_EraseRootFromParent_Done,
      // Label 13150: @863943
      GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(864025), // Rule ID 63384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63384,
        GIR_EraseRootFromParent_Done,
      // Label 13151: @864025
      GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(864107), // Rule ID 63395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63395,
        GIR_EraseRootFromParent_Done,
      // Label 13152: @864107
      GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(864189), // Rule ID 63396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63396,
        GIR_EraseRootFromParent_Done,
      // Label 13153: @864189
      GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(864271), // Rule ID 63401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63401,
        GIR_EraseRootFromParent_Done,
      // Label 13154: @864271
      GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(864353), // Rule ID 63402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63402,
        GIR_EraseRootFromParent_Done,
      // Label 13155: @864353
      GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(864435), // Rule ID 63413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63413,
        GIR_EraseRootFromParent_Done,
      // Label 13156: @864435
      GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(864517), // Rule ID 63414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63414,
        GIR_EraseRootFromParent_Done,
      // Label 13157: @864517
      GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(864599), // Rule ID 63419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63419,
        GIR_EraseRootFromParent_Done,
      // Label 13158: @864599
      GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(864681), // Rule ID 63420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63420,
        GIR_EraseRootFromParent_Done,
      // Label 13159: @864681
      GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(864763), // Rule ID 63431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63431,
        GIR_EraseRootFromParent_Done,
      // Label 13160: @864763
      GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(864845), // Rule ID 63432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63432,
        GIR_EraseRootFromParent_Done,
      // Label 13161: @864845
      GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(864927), // Rule ID 63437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63437,
        GIR_EraseRootFromParent_Done,
      // Label 13162: @864927
      GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(865009), // Rule ID 63438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63438,
        GIR_EraseRootFromParent_Done,
      // Label 13163: @865009
      GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(865091), // Rule ID 63449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63449,
        GIR_EraseRootFromParent_Done,
      // Label 13164: @865091
      GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(865173), // Rule ID 63450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63450,
        GIR_EraseRootFromParent_Done,
      // Label 13165: @865173
      GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(865255), // Rule ID 63455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63455,
        GIR_EraseRootFromParent_Done,
      // Label 13166: @865255
      GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(865337), // Rule ID 63456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63456,
        GIR_EraseRootFromParent_Done,
      // Label 13167: @865337
      GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(865419), // Rule ID 63467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63467,
        GIR_EraseRootFromParent_Done,
      // Label 13168: @865419
      GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(865501), // Rule ID 63468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63468,
        GIR_EraseRootFromParent_Done,
      // Label 13169: @865501
      GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(865583), // Rule ID 63473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63473,
        GIR_EraseRootFromParent_Done,
      // Label 13170: @865583
      GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(865665), // Rule ID 63474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63474,
        GIR_EraseRootFromParent_Done,
      // Label 13171: @865665
      GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(865747), // Rule ID 63485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63485,
        GIR_EraseRootFromParent_Done,
      // Label 13172: @865747
      GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(865829), // Rule ID 63486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63486,
        GIR_EraseRootFromParent_Done,
      // Label 13173: @865829
      GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(865911), // Rule ID 63491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63491,
        GIR_EraseRootFromParent_Done,
      // Label 13174: @865911
      GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(865993), // Rule ID 63492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63492,
        GIR_EraseRootFromParent_Done,
      // Label 13175: @865993
      GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(866075), // Rule ID 63503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63503,
        GIR_EraseRootFromParent_Done,
      // Label 13176: @866075
      GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(866157), // Rule ID 63504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63504,
        GIR_EraseRootFromParent_Done,
      // Label 13177: @866157
      GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(866239), // Rule ID 63509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63509,
        GIR_EraseRootFromParent_Done,
      // Label 13178: @866239
      GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(866321), // Rule ID 63510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63510,
        GIR_EraseRootFromParent_Done,
      // Label 13179: @866321
      GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(866403), // Rule ID 63515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63515,
        GIR_EraseRootFromParent_Done,
      // Label 13180: @866403
      GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(866485), // Rule ID 63516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63516,
        GIR_EraseRootFromParent_Done,
      // Label 13181: @866485
      GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(866567), // Rule ID 63527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63527,
        GIR_EraseRootFromParent_Done,
      // Label 13182: @866567
      GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(866649), // Rule ID 63528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63528,
        GIR_EraseRootFromParent_Done,
      // Label 13183: @866649
      GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(866731), // Rule ID 63533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63533,
        GIR_EraseRootFromParent_Done,
      // Label 13184: @866731
      GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(866813), // Rule ID 63534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63534,
        GIR_EraseRootFromParent_Done,
      // Label 13185: @866813
      GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(866895), // Rule ID 63539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63539,
        GIR_EraseRootFromParent_Done,
      // Label 13186: @866895
      GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(866977), // Rule ID 63540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63540,
        GIR_EraseRootFromParent_Done,
      // Label 13187: @866977
      GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(867059), // Rule ID 63551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63551,
        GIR_EraseRootFromParent_Done,
      // Label 13188: @867059
      GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(867141), // Rule ID 63552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63552,
        GIR_EraseRootFromParent_Done,
      // Label 13189: @867141
      GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(867223), // Rule ID 63557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63557,
        GIR_EraseRootFromParent_Done,
      // Label 13190: @867223
      GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(867305), // Rule ID 63558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63558,
        GIR_EraseRootFromParent_Done,
      // Label 13191: @867305
      GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(867387), // Rule ID 63563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63563,
        GIR_EraseRootFromParent_Done,
      // Label 13192: @867387
      GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(867469), // Rule ID 63564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63564,
        GIR_EraseRootFromParent_Done,
      // Label 13193: @867469
      GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(867551), // Rule ID 63575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63575,
        GIR_EraseRootFromParent_Done,
      // Label 13194: @867551
      GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(867633), // Rule ID 63576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63576,
        GIR_EraseRootFromParent_Done,
      // Label 13195: @867633
      GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(867715), // Rule ID 63581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63581,
        GIR_EraseRootFromParent_Done,
      // Label 13196: @867715
      GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(867797), // Rule ID 63582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63582,
        GIR_EraseRootFromParent_Done,
      // Label 13197: @867797
      GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(867879), // Rule ID 63587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63587,
        GIR_EraseRootFromParent_Done,
      // Label 13198: @867879
      GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(867961), // Rule ID 63588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63588,
        GIR_EraseRootFromParent_Done,
      // Label 13199: @867961
      GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(868043), // Rule ID 63599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63599,
        GIR_EraseRootFromParent_Done,
      // Label 13200: @868043
      GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(868125), // Rule ID 63600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63600,
        GIR_EraseRootFromParent_Done,
      // Label 13201: @868125
      GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(868207), // Rule ID 63605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63605,
        GIR_EraseRootFromParent_Done,
      // Label 13202: @868207
      GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(868289), // Rule ID 63606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63606,
        GIR_EraseRootFromParent_Done,
      // Label 13203: @868289
      GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(868371), // Rule ID 63611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63611,
        GIR_EraseRootFromParent_Done,
      // Label 13204: @868371
      GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(868453), // Rule ID 63612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63612,
        GIR_EraseRootFromParent_Done,
      // Label 13205: @868453
      GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(868535), // Rule ID 63623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63623,
        GIR_EraseRootFromParent_Done,
      // Label 13206: @868535
      GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(868617), // Rule ID 63624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63624,
        GIR_EraseRootFromParent_Done,
      // Label 13207: @868617
      GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(868699), // Rule ID 63629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63629,
        GIR_EraseRootFromParent_Done,
      // Label 13208: @868699
      GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(868781), // Rule ID 63630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63630,
        GIR_EraseRootFromParent_Done,
      // Label 13209: @868781
      GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(868863), // Rule ID 63635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63635,
        GIR_EraseRootFromParent_Done,
      // Label 13210: @868863
      GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(868945), // Rule ID 63636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63636,
        GIR_EraseRootFromParent_Done,
      // Label 13211: @868945
      GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(869027), // Rule ID 63647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63647,
        GIR_EraseRootFromParent_Done,
      // Label 13212: @869027
      GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(869109), // Rule ID 63648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63648,
        GIR_EraseRootFromParent_Done,
      // Label 13213: @869109
      GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(869191), // Rule ID 63653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63653,
        GIR_EraseRootFromParent_Done,
      // Label 13214: @869191
      GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(869273), // Rule ID 63654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63654,
        GIR_EraseRootFromParent_Done,
      // Label 13215: @869273
      GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(869355), // Rule ID 63659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63659,
        GIR_EraseRootFromParent_Done,
      // Label 13216: @869355
      GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(869437), // Rule ID 63660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63660,
        GIR_EraseRootFromParent_Done,
      // Label 13217: @869437
      GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(869519), // Rule ID 63671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63671,
        GIR_EraseRootFromParent_Done,
      // Label 13218: @869519
      GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(869601), // Rule ID 63672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63672,
        GIR_EraseRootFromParent_Done,
      // Label 13219: @869601
      GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(869683), // Rule ID 63677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63677,
        GIR_EraseRootFromParent_Done,
      // Label 13220: @869683
      GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(869765), // Rule ID 63678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63678,
        GIR_EraseRootFromParent_Done,
      // Label 13221: @869765
      GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(869847), // Rule ID 63683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10694:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63683,
        GIR_EraseRootFromParent_Done,
      // Label 13222: @869847
      GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(869929), // Rule ID 63684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10694:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63684,
        GIR_EraseRootFromParent_Done,
      // Label 13223: @869929
      GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(870011), // Rule ID 63695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10686:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63695,
        GIR_EraseRootFromParent_Done,
      // Label 13224: @870011
      GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(870093), // Rule ID 63696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10686:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63696,
        GIR_EraseRootFromParent_Done,
      // Label 13225: @870093
      GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(870175), // Rule ID 63701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10672:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63701,
        GIR_EraseRootFromParent_Done,
      // Label 13226: @870175
      GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(870257), // Rule ID 63702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] op1
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10672:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // op4
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63702,
        GIR_EraseRootFromParent_Done,
      // Label 13227: @870257
      GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(870367), // Rule ID 5054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5054,
        GIR_EraseRootFromParent_Done,
      // Label 13228: @870367
      GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(870477), // Rule ID 5055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5055,
        GIR_EraseRootFromParent_Done,
      // Label 13229: @870477
      GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(870587), // Rule ID 5056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5056,
        GIR_EraseRootFromParent_Done,
      // Label 13230: @870587
      GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(870697), // Rule ID 5057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5057,
        GIR_EraseRootFromParent_Done,
      // Label 13231: @870697
      GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(870807), // Rule ID 5058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5058,
        GIR_EraseRootFromParent_Done,
      // Label 13232: @870807
      GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(870917), // Rule ID 5059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5059,
        GIR_EraseRootFromParent_Done,
      // Label 13233: @870917
      GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(871027), // Rule ID 5060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5060,
        GIR_EraseRootFromParent_Done,
      // Label 13234: @871027
      GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(871137), // Rule ID 5061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5061,
        GIR_EraseRootFromParent_Done,
      // Label 13235: @871137
      GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(871247), // Rule ID 5062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5062,
        GIR_EraseRootFromParent_Done,
      // Label 13236: @871247
      GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(871357), // Rule ID 5063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5063,
        GIR_EraseRootFromParent_Done,
      // Label 13237: @871357
      GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(871467), // Rule ID 5064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5064,
        GIR_EraseRootFromParent_Done,
      // Label 13238: @871467
      GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(871577), // Rule ID 5065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5065,
        GIR_EraseRootFromParent_Done,
      // Label 13239: @871577
      GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(871687), // Rule ID 5066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5066,
        GIR_EraseRootFromParent_Done,
      // Label 13240: @871687
      GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(871797), // Rule ID 5067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5067,
        GIR_EraseRootFromParent_Done,
      // Label 13241: @871797
      GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(871907), // Rule ID 5068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5068,
        GIR_EraseRootFromParent_Done,
      // Label 13242: @871907
      GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(872017), // Rule ID 5069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5069,
        GIR_EraseRootFromParent_Done,
      // Label 13243: @872017
      GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(872127), // Rule ID 5070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5070,
        GIR_EraseRootFromParent_Done,
      // Label 13244: @872127
      GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(872237), // Rule ID 5071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5071,
        GIR_EraseRootFromParent_Done,
      // Label 13245: @872237
      GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(872347), // Rule ID 5072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5072,
        GIR_EraseRootFromParent_Done,
      // Label 13246: @872347
      GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(872457), // Rule ID 5073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5073,
        GIR_EraseRootFromParent_Done,
      // Label 13247: @872457
      GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(872567), // Rule ID 5074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5074,
        GIR_EraseRootFromParent_Done,
      // Label 13248: @872567
      GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(872677), // Rule ID 5075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5075,
        GIR_EraseRootFromParent_Done,
      // Label 13249: @872677
      GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(872787), // Rule ID 5076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5076,
        GIR_EraseRootFromParent_Done,
      // Label 13250: @872787
      GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(872897), // Rule ID 5077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5077,
        GIR_EraseRootFromParent_Done,
      // Label 13251: @872897
      GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(873007), // Rule ID 5078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5078,
        GIR_EraseRootFromParent_Done,
      // Label 13252: @873007
      GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(873117), // Rule ID 5079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5079,
        GIR_EraseRootFromParent_Done,
      // Label 13253: @873117
      GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(873227), // Rule ID 5080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5080,
        GIR_EraseRootFromParent_Done,
      // Label 13254: @873227
      GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(873337), // Rule ID 5081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5081,
        GIR_EraseRootFromParent_Done,
      // Label 13255: @873337
      GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(873447), // Rule ID 5082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5082,
        GIR_EraseRootFromParent_Done,
      // Label 13256: @873447
      GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(873557), // Rule ID 5083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5083,
        GIR_EraseRootFromParent_Done,
      // Label 13257: @873557
      GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(873667), // Rule ID 5084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5084,
        GIR_EraseRootFromParent_Done,
      // Label 13258: @873667
      GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(873777), // Rule ID 5085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5085,
        GIR_EraseRootFromParent_Done,
      // Label 13259: @873777
      GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(873887), // Rule ID 5086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5086,
        GIR_EraseRootFromParent_Done,
      // Label 13260: @873887
      GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(873997), // Rule ID 5087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5087,
        GIR_EraseRootFromParent_Done,
      // Label 13261: @873997
      GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(874107), // Rule ID 5088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5088,
        GIR_EraseRootFromParent_Done,
      // Label 13262: @874107
      GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(874217), // Rule ID 5089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5089,
        GIR_EraseRootFromParent_Done,
      // Label 13263: @874217
      GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(874327), // Rule ID 5090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5090,
        GIR_EraseRootFromParent_Done,
      // Label 13264: @874327
      GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(874437), // Rule ID 5091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5091,
        GIR_EraseRootFromParent_Done,
      // Label 13265: @874437
      GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(874547), // Rule ID 5092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5092,
        GIR_EraseRootFromParent_Done,
      // Label 13266: @874547
      GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(874657), // Rule ID 5093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5093,
        GIR_EraseRootFromParent_Done,
      // Label 13267: @874657
      GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(874767), // Rule ID 5094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5094,
        GIR_EraseRootFromParent_Done,
      // Label 13268: @874767
      GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(874877), // Rule ID 5095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5095,
        GIR_EraseRootFromParent_Done,
      // Label 13269: @874877
      GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(874987), // Rule ID 5096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5096,
        GIR_EraseRootFromParent_Done,
      // Label 13270: @874987
      GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(875097), // Rule ID 5097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5097,
        GIR_EraseRootFromParent_Done,
      // Label 13271: @875097
      GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(875207), // Rule ID 7828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7828,
        GIR_EraseRootFromParent_Done,
      // Label 13272: @875207
      GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(875317), // Rule ID 7829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7829,
        GIR_EraseRootFromParent_Done,
      // Label 13273: @875317
      GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(875427), // Rule ID 7832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7832,
        GIR_EraseRootFromParent_Done,
      // Label 13274: @875427
      GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(875537), // Rule ID 7833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7833,
        GIR_EraseRootFromParent_Done,
      // Label 13275: @875537
      GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(875647), // Rule ID 7836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7836,
        GIR_EraseRootFromParent_Done,
      // Label 13276: @875647
      GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(875757), // Rule ID 7837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7837,
        GIR_EraseRootFromParent_Done,
      // Label 13277: @875757
      GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(875867), // Rule ID 7840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7840,
        GIR_EraseRootFromParent_Done,
      // Label 13278: @875867
      GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(875977), // Rule ID 7841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7841,
        GIR_EraseRootFromParent_Done,
      // Label 13279: @875977
      GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(876087), // Rule ID 7844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7844,
        GIR_EraseRootFromParent_Done,
      // Label 13280: @876087
      GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(876197), // Rule ID 7845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7845,
        GIR_EraseRootFromParent_Done,
      // Label 13281: @876197
      GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(876307), // Rule ID 7848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7848,
        GIR_EraseRootFromParent_Done,
      // Label 13282: @876307
      GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(876417), // Rule ID 7849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7849,
        GIR_EraseRootFromParent_Done,
      // Label 13283: @876417
      GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(876527), // Rule ID 7852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7852,
        GIR_EraseRootFromParent_Done,
      // Label 13284: @876527
      GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(876637), // Rule ID 7853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7853,
        GIR_EraseRootFromParent_Done,
      // Label 13285: @876637
      GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(876747), // Rule ID 7856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7856,
        GIR_EraseRootFromParent_Done,
      // Label 13286: @876747
      GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(876857), // Rule ID 7857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7857,
        GIR_EraseRootFromParent_Done,
      // Label 13287: @876857
      GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(876967), // Rule ID 7860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7860,
        GIR_EraseRootFromParent_Done,
      // Label 13288: @876967
      GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(877077), // Rule ID 7861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7861,
        GIR_EraseRootFromParent_Done,
      // Label 13289: @877077
      GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(877187), // Rule ID 7864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7864,
        GIR_EraseRootFromParent_Done,
      // Label 13290: @877187
      GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(877297), // Rule ID 7865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7865,
        GIR_EraseRootFromParent_Done,
      // Label 13291: @877297
      GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(877407), // Rule ID 7868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7868,
        GIR_EraseRootFromParent_Done,
      // Label 13292: @877407
      GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(877517), // Rule ID 7869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7869,
        GIR_EraseRootFromParent_Done,
      // Label 13293: @877517
      GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(877627), // Rule ID 7872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7872,
        GIR_EraseRootFromParent_Done,
      // Label 13294: @877627
      GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(877737), // Rule ID 7873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7873,
        GIR_EraseRootFromParent_Done,
      // Label 13295: @877737
      GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(877847), // Rule ID 7876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7876,
        GIR_EraseRootFromParent_Done,
      // Label 13296: @877847
      GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(877957), // Rule ID 7877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7877,
        GIR_EraseRootFromParent_Done,
      // Label 13297: @877957
      GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(878067), // Rule ID 7880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7880,
        GIR_EraseRootFromParent_Done,
      // Label 13298: @878067
      GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(878177), // Rule ID 7881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7881,
        GIR_EraseRootFromParent_Done,
      // Label 13299: @878177
      GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(878287), // Rule ID 7884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7884,
        GIR_EraseRootFromParent_Done,
      // Label 13300: @878287
      GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(878397), // Rule ID 7885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7885,
        GIR_EraseRootFromParent_Done,
      // Label 13301: @878397
      GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(878507), // Rule ID 7888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7888,
        GIR_EraseRootFromParent_Done,
      // Label 13302: @878507
      GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(878617), // Rule ID 7889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7889,
        GIR_EraseRootFromParent_Done,
      // Label 13303: @878617
      GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(878727), // Rule ID 7892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7892,
        GIR_EraseRootFromParent_Done,
      // Label 13304: @878727
      GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(878837), // Rule ID 7893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7893,
        GIR_EraseRootFromParent_Done,
      // Label 13305: @878837
      GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(878947), // Rule ID 7896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7896,
        GIR_EraseRootFromParent_Done,
      // Label 13306: @878947
      GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(879057), // Rule ID 7897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7897,
        GIR_EraseRootFromParent_Done,
      // Label 13307: @879057
      GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(879167), // Rule ID 7900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7900,
        GIR_EraseRootFromParent_Done,
      // Label 13308: @879167
      GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(879277), // Rule ID 7901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7901,
        GIR_EraseRootFromParent_Done,
      // Label 13309: @879277
      GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(879387), // Rule ID 7904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7904,
        GIR_EraseRootFromParent_Done,
      // Label 13310: @879387
      GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(879497), // Rule ID 7905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7905,
        GIR_EraseRootFromParent_Done,
      // Label 13311: @879497
      GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(879607), // Rule ID 7908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7908,
        GIR_EraseRootFromParent_Done,
      // Label 13312: @879607
      GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(879717), // Rule ID 7909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7909,
        GIR_EraseRootFromParent_Done,
      // Label 13313: @879717
      GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(879827), // Rule ID 7912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7912,
        GIR_EraseRootFromParent_Done,
      // Label 13314: @879827
      GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(879937), // Rule ID 7913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7913,
        GIR_EraseRootFromParent_Done,
      // Label 13315: @879937
      GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(880047), // Rule ID 8092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8092,
        GIR_EraseRootFromParent_Done,
      // Label 13316: @880047
      GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(880157), // Rule ID 8093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8093,
        GIR_EraseRootFromParent_Done,
      // Label 13317: @880157
      GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(880267), // Rule ID 8096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8096,
        GIR_EraseRootFromParent_Done,
      // Label 13318: @880267
      GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(880377), // Rule ID 8097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8097,
        GIR_EraseRootFromParent_Done,
      // Label 13319: @880377
      GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(880487), // Rule ID 8100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8100,
        GIR_EraseRootFromParent_Done,
      // Label 13320: @880487
      GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(880597), // Rule ID 8101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8101,
        GIR_EraseRootFromParent_Done,
      // Label 13321: @880597
      GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(880707), // Rule ID 8104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8104,
        GIR_EraseRootFromParent_Done,
      // Label 13322: @880707
      GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(880817), // Rule ID 8105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8105,
        GIR_EraseRootFromParent_Done,
      // Label 13323: @880817
      GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(880927), // Rule ID 8108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8108,
        GIR_EraseRootFromParent_Done,
      // Label 13324: @880927
      GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(881037), // Rule ID 8109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8109,
        GIR_EraseRootFromParent_Done,
      // Label 13325: @881037
      GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(881147), // Rule ID 8112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8112,
        GIR_EraseRootFromParent_Done,
      // Label 13326: @881147
      GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(881257), // Rule ID 8113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8113,
        GIR_EraseRootFromParent_Done,
      // Label 13327: @881257
      GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(881367), // Rule ID 8116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8116,
        GIR_EraseRootFromParent_Done,
      // Label 13328: @881367
      GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(881477), // Rule ID 8117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8117,
        GIR_EraseRootFromParent_Done,
      // Label 13329: @881477
      GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(881587), // Rule ID 8120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8120,
        GIR_EraseRootFromParent_Done,
      // Label 13330: @881587
      GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(881697), // Rule ID 8121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8121,
        GIR_EraseRootFromParent_Done,
      // Label 13331: @881697
      GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(881807), // Rule ID 8124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8124,
        GIR_EraseRootFromParent_Done,
      // Label 13332: @881807
      GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(881917), // Rule ID 8125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8125,
        GIR_EraseRootFromParent_Done,
      // Label 13333: @881917
      GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(882027), // Rule ID 8128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8128,
        GIR_EraseRootFromParent_Done,
      // Label 13334: @882027
      GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(882137), // Rule ID 8129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8129,
        GIR_EraseRootFromParent_Done,
      // Label 13335: @882137
      GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(882247), // Rule ID 8132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8132,
        GIR_EraseRootFromParent_Done,
      // Label 13336: @882247
      GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(882357), // Rule ID 8133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8133,
        GIR_EraseRootFromParent_Done,
      // Label 13337: @882357
      GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(882467), // Rule ID 8136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8136,
        GIR_EraseRootFromParent_Done,
      // Label 13338: @882467
      GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(882577), // Rule ID 8137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8137,
        GIR_EraseRootFromParent_Done,
      // Label 13339: @882577
      GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(882687), // Rule ID 8140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8140,
        GIR_EraseRootFromParent_Done,
      // Label 13340: @882687
      GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(882797), // Rule ID 8141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8141,
        GIR_EraseRootFromParent_Done,
      // Label 13341: @882797
      GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(882907), // Rule ID 8144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8144,
        GIR_EraseRootFromParent_Done,
      // Label 13342: @882907
      GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(883017), // Rule ID 8145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8145,
        GIR_EraseRootFromParent_Done,
      // Label 13343: @883017
      GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(883127), // Rule ID 8148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8148,
        GIR_EraseRootFromParent_Done,
      // Label 13344: @883127
      GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(883237), // Rule ID 8149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8149,
        GIR_EraseRootFromParent_Done,
      // Label 13345: @883237
      GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(883347), // Rule ID 8152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8152,
        GIR_EraseRootFromParent_Done,
      // Label 13346: @883347
      GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(883457), // Rule ID 8153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8153,
        GIR_EraseRootFromParent_Done,
      // Label 13347: @883457
      GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(883567), // Rule ID 8156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8156,
        GIR_EraseRootFromParent_Done,
      // Label 13348: @883567
      GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(883677), // Rule ID 8157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8157,
        GIR_EraseRootFromParent_Done,
      // Label 13349: @883677
      GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(883787), // Rule ID 8160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8160,
        GIR_EraseRootFromParent_Done,
      // Label 13350: @883787
      GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(883897), // Rule ID 8161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8161,
        GIR_EraseRootFromParent_Done,
      // Label 13351: @883897
      GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(884007), // Rule ID 8164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8164,
        GIR_EraseRootFromParent_Done,
      // Label 13352: @884007
      GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(884117), // Rule ID 8165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8165,
        GIR_EraseRootFromParent_Done,
      // Label 13353: @884117
      GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(884227), // Rule ID 8168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8168,
        GIR_EraseRootFromParent_Done,
      // Label 13354: @884227
      GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(884337), // Rule ID 8169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8169,
        GIR_EraseRootFromParent_Done,
      // Label 13355: @884337
      GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(884447), // Rule ID 8172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8172,
        GIR_EraseRootFromParent_Done,
      // Label 13356: @884447
      GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(884557), // Rule ID 8173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8173,
        GIR_EraseRootFromParent_Done,
      // Label 13357: @884557
      GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(884667), // Rule ID 8176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8176,
        GIR_EraseRootFromParent_Done,
      // Label 13358: @884667
      GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(884777), // Rule ID 8177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8177,
        GIR_EraseRootFromParent_Done,
      // Label 13359: @884777
      GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(884887), // Rule ID 8708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8708,
        GIR_EraseRootFromParent_Done,
      // Label 13360: @884887
      GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(884997), // Rule ID 8709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8709,
        GIR_EraseRootFromParent_Done,
      // Label 13361: @884997
      GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(885107), // Rule ID 8712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8712,
        GIR_EraseRootFromParent_Done,
      // Label 13362: @885107
      GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(885217), // Rule ID 8713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8713,
        GIR_EraseRootFromParent_Done,
      // Label 13363: @885217
      GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(885327), // Rule ID 8716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8716,
        GIR_EraseRootFromParent_Done,
      // Label 13364: @885327
      GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(885437), // Rule ID 8717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8717,
        GIR_EraseRootFromParent_Done,
      // Label 13365: @885437
      GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(885547), // Rule ID 8720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8720,
        GIR_EraseRootFromParent_Done,
      // Label 13366: @885547
      GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(885657), // Rule ID 8721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8721,
        GIR_EraseRootFromParent_Done,
      // Label 13367: @885657
      GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(885767), // Rule ID 8724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8724,
        GIR_EraseRootFromParent_Done,
      // Label 13368: @885767
      GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(885877), // Rule ID 8725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8725,
        GIR_EraseRootFromParent_Done,
      // Label 13369: @885877
      GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(885987), // Rule ID 8728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8728,
        GIR_EraseRootFromParent_Done,
      // Label 13370: @885987
      GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(886097), // Rule ID 8729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8729,
        GIR_EraseRootFromParent_Done,
      // Label 13371: @886097
      GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(886207), // Rule ID 8732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8732,
        GIR_EraseRootFromParent_Done,
      // Label 13372: @886207
      GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(886317), // Rule ID 8733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8733,
        GIR_EraseRootFromParent_Done,
      // Label 13373: @886317
      GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(886427), // Rule ID 8736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8736,
        GIR_EraseRootFromParent_Done,
      // Label 13374: @886427
      GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(886537), // Rule ID 8737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8737,
        GIR_EraseRootFromParent_Done,
      // Label 13375: @886537
      GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(886647), // Rule ID 8740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8740,
        GIR_EraseRootFromParent_Done,
      // Label 13376: @886647
      GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(886757), // Rule ID 8741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8741,
        GIR_EraseRootFromParent_Done,
      // Label 13377: @886757
      GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(886867), // Rule ID 8744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8744,
        GIR_EraseRootFromParent_Done,
      // Label 13378: @886867
      GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(886977), // Rule ID 8745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8745,
        GIR_EraseRootFromParent_Done,
      // Label 13379: @886977
      GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(887087), // Rule ID 8748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8748,
        GIR_EraseRootFromParent_Done,
      // Label 13380: @887087
      GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(887197), // Rule ID 8749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8749,
        GIR_EraseRootFromParent_Done,
      // Label 13381: @887197
      GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(887307), // Rule ID 8752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8752,
        GIR_EraseRootFromParent_Done,
      // Label 13382: @887307
      GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(887417), // Rule ID 8753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8753,
        GIR_EraseRootFromParent_Done,
      // Label 13383: @887417
      GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(887527), // Rule ID 8756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8756,
        GIR_EraseRootFromParent_Done,
      // Label 13384: @887527
      GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(887637), // Rule ID 8757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8757,
        GIR_EraseRootFromParent_Done,
      // Label 13385: @887637
      GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(887747), // Rule ID 8760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8760,
        GIR_EraseRootFromParent_Done,
      // Label 13386: @887747
      GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(887857), // Rule ID 8761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8761,
        GIR_EraseRootFromParent_Done,
      // Label 13387: @887857
      GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(887967), // Rule ID 8764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8764,
        GIR_EraseRootFromParent_Done,
      // Label 13388: @887967
      GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(888077), // Rule ID 8765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8765,
        GIR_EraseRootFromParent_Done,
      // Label 13389: @888077
      GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(888187), // Rule ID 8768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8768,
        GIR_EraseRootFromParent_Done,
      // Label 13390: @888187
      GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(888297), // Rule ID 8769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8769,
        GIR_EraseRootFromParent_Done,
      // Label 13391: @888297
      GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(888407), // Rule ID 8772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8772,
        GIR_EraseRootFromParent_Done,
      // Label 13392: @888407
      GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(888517), // Rule ID 8773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8773,
        GIR_EraseRootFromParent_Done,
      // Label 13393: @888517
      GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(888627), // Rule ID 8776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8776,
        GIR_EraseRootFromParent_Done,
      // Label 13394: @888627
      GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(888737), // Rule ID 8777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8777,
        GIR_EraseRootFromParent_Done,
      // Label 13395: @888737
      GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(888847), // Rule ID 8780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8780,
        GIR_EraseRootFromParent_Done,
      // Label 13396: @888847
      GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(888957), // Rule ID 8781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8781,
        GIR_EraseRootFromParent_Done,
      // Label 13397: @888957
      GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(889067), // Rule ID 8784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8784,
        GIR_EraseRootFromParent_Done,
      // Label 13398: @889067
      GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(889177), // Rule ID 8785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8785,
        GIR_EraseRootFromParent_Done,
      // Label 13399: @889177
      GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(889287), // Rule ID 8788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8788,
        GIR_EraseRootFromParent_Done,
      // Label 13400: @889287
      GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(889397), // Rule ID 8789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8789,
        GIR_EraseRootFromParent_Done,
      // Label 13401: @889397
      GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(889507), // Rule ID 8792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8792,
        GIR_EraseRootFromParent_Done,
      // Label 13402: @889507
      GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(889617), // Rule ID 8793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8793,
        GIR_EraseRootFromParent_Done,
      // Label 13403: @889617
      GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(889727), // Rule ID 8972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8972,
        GIR_EraseRootFromParent_Done,
      // Label 13404: @889727
      GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(889837), // Rule ID 8973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8973,
        GIR_EraseRootFromParent_Done,
      // Label 13405: @889837
      GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(889947), // Rule ID 8976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8976,
        GIR_EraseRootFromParent_Done,
      // Label 13406: @889947
      GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(890057), // Rule ID 8977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8977,
        GIR_EraseRootFromParent_Done,
      // Label 13407: @890057
      GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(890167), // Rule ID 8980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8980,
        GIR_EraseRootFromParent_Done,
      // Label 13408: @890167
      GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(890277), // Rule ID 8981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8981,
        GIR_EraseRootFromParent_Done,
      // Label 13409: @890277
      GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(890387), // Rule ID 8984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8984,
        GIR_EraseRootFromParent_Done,
      // Label 13410: @890387
      GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(890497), // Rule ID 8985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8985,
        GIR_EraseRootFromParent_Done,
      // Label 13411: @890497
      GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(890607), // Rule ID 8988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8988,
        GIR_EraseRootFromParent_Done,
      // Label 13412: @890607
      GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(890717), // Rule ID 8989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8989,
        GIR_EraseRootFromParent_Done,
      // Label 13413: @890717
      GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(890827), // Rule ID 8992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8992,
        GIR_EraseRootFromParent_Done,
      // Label 13414: @890827
      GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(890937), // Rule ID 8993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8993,
        GIR_EraseRootFromParent_Done,
      // Label 13415: @890937
      GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(891047), // Rule ID 8996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8996,
        GIR_EraseRootFromParent_Done,
      // Label 13416: @891047
      GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(891157), // Rule ID 8997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8997,
        GIR_EraseRootFromParent_Done,
      // Label 13417: @891157
      GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(891267), // Rule ID 9000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9000,
        GIR_EraseRootFromParent_Done,
      // Label 13418: @891267
      GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(891377), // Rule ID 9001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9001,
        GIR_EraseRootFromParent_Done,
      // Label 13419: @891377
      GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(891487), // Rule ID 9004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9004,
        GIR_EraseRootFromParent_Done,
      // Label 13420: @891487
      GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(891597), // Rule ID 9005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9005,
        GIR_EraseRootFromParent_Done,
      // Label 13421: @891597
      GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(891707), // Rule ID 9008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9008,
        GIR_EraseRootFromParent_Done,
      // Label 13422: @891707
      GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(891817), // Rule ID 9009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9009,
        GIR_EraseRootFromParent_Done,
      // Label 13423: @891817
      GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(891927), // Rule ID 9012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9012,
        GIR_EraseRootFromParent_Done,
      // Label 13424: @891927
      GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(892037), // Rule ID 9013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9013,
        GIR_EraseRootFromParent_Done,
      // Label 13425: @892037
      GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(892147), // Rule ID 9016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9016,
        GIR_EraseRootFromParent_Done,
      // Label 13426: @892147
      GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(892257), // Rule ID 9017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9017,
        GIR_EraseRootFromParent_Done,
      // Label 13427: @892257
      GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(892367), // Rule ID 9020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9020,
        GIR_EraseRootFromParent_Done,
      // Label 13428: @892367
      GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(892477), // Rule ID 9021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9021,
        GIR_EraseRootFromParent_Done,
      // Label 13429: @892477
      GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(892587), // Rule ID 9024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9024,
        GIR_EraseRootFromParent_Done,
      // Label 13430: @892587
      GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(892697), // Rule ID 9025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9025,
        GIR_EraseRootFromParent_Done,
      // Label 13431: @892697
      GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(892807), // Rule ID 9028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9028,
        GIR_EraseRootFromParent_Done,
      // Label 13432: @892807
      GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(892917), // Rule ID 9029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9029,
        GIR_EraseRootFromParent_Done,
      // Label 13433: @892917
      GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(893027), // Rule ID 9032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9032,
        GIR_EraseRootFromParent_Done,
      // Label 13434: @893027
      GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(893137), // Rule ID 9033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9033,
        GIR_EraseRootFromParent_Done,
      // Label 13435: @893137
      GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(893247), // Rule ID 9036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9036,
        GIR_EraseRootFromParent_Done,
      // Label 13436: @893247
      GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(893357), // Rule ID 9037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9037,
        GIR_EraseRootFromParent_Done,
      // Label 13437: @893357
      GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(893467), // Rule ID 9040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9040,
        GIR_EraseRootFromParent_Done,
      // Label 13438: @893467
      GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(893577), // Rule ID 9041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9041,
        GIR_EraseRootFromParent_Done,
      // Label 13439: @893577
      GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(893687), // Rule ID 9044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9044,
        GIR_EraseRootFromParent_Done,
      // Label 13440: @893687
      GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(893797), // Rule ID 9045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9045,
        GIR_EraseRootFromParent_Done,
      // Label 13441: @893797
      GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(893907), // Rule ID 9048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9048,
        GIR_EraseRootFromParent_Done,
      // Label 13442: @893907
      GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(894017), // Rule ID 9049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9049,
        GIR_EraseRootFromParent_Done,
      // Label 13443: @894017
      GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(894127), // Rule ID 9052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9052,
        GIR_EraseRootFromParent_Done,
      // Label 13444: @894127
      GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(894237), // Rule ID 9053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9053,
        GIR_EraseRootFromParent_Done,
      // Label 13445: @894237
      GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(894347), // Rule ID 9056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9056,
        GIR_EraseRootFromParent_Done,
      // Label 13446: @894347
      GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(894457), // Rule ID 9057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9057,
        GIR_EraseRootFromParent_Done,
      // Label 13447: @894457
      GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(894567), // Rule ID 9148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9148,
        GIR_EraseRootFromParent_Done,
      // Label 13448: @894567
      GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(894677), // Rule ID 9149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9149,
        GIR_EraseRootFromParent_Done,
      // Label 13449: @894677
      GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(894787), // Rule ID 9152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9152,
        GIR_EraseRootFromParent_Done,
      // Label 13450: @894787
      GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(894897), // Rule ID 9153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9153,
        GIR_EraseRootFromParent_Done,
      // Label 13451: @894897
      GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(895007), // Rule ID 9156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9156,
        GIR_EraseRootFromParent_Done,
      // Label 13452: @895007
      GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(895117), // Rule ID 9157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9157,
        GIR_EraseRootFromParent_Done,
      // Label 13453: @895117
      GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(895227), // Rule ID 9160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9160,
        GIR_EraseRootFromParent_Done,
      // Label 13454: @895227
      GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(895337), // Rule ID 9161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9161,
        GIR_EraseRootFromParent_Done,
      // Label 13455: @895337
      GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(895447), // Rule ID 9164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9164,
        GIR_EraseRootFromParent_Done,
      // Label 13456: @895447
      GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(895557), // Rule ID 9165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9165,
        GIR_EraseRootFromParent_Done,
      // Label 13457: @895557
      GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(895667), // Rule ID 9168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9168,
        GIR_EraseRootFromParent_Done,
      // Label 13458: @895667
      GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(895777), // Rule ID 9169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9169,
        GIR_EraseRootFromParent_Done,
      // Label 13459: @895777
      GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(895887), // Rule ID 9172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9172,
        GIR_EraseRootFromParent_Done,
      // Label 13460: @895887
      GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(895997), // Rule ID 9173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9173,
        GIR_EraseRootFromParent_Done,
      // Label 13461: @895997
      GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(896107), // Rule ID 9176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9176,
        GIR_EraseRootFromParent_Done,
      // Label 13462: @896107
      GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(896217), // Rule ID 9177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9177,
        GIR_EraseRootFromParent_Done,
      // Label 13463: @896217
      GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(896327), // Rule ID 9180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9180,
        GIR_EraseRootFromParent_Done,
      // Label 13464: @896327
      GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(896437), // Rule ID 9181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9181,
        GIR_EraseRootFromParent_Done,
      // Label 13465: @896437
      GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(896547), // Rule ID 9184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9184,
        GIR_EraseRootFromParent_Done,
      // Label 13466: @896547
      GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(896657), // Rule ID 9185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9185,
        GIR_EraseRootFromParent_Done,
      // Label 13467: @896657
      GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(896767), // Rule ID 9188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9188,
        GIR_EraseRootFromParent_Done,
      // Label 13468: @896767
      GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(896877), // Rule ID 9189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9189,
        GIR_EraseRootFromParent_Done,
      // Label 13469: @896877
      GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(896987), // Rule ID 9192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9192,
        GIR_EraseRootFromParent_Done,
      // Label 13470: @896987
      GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(897097), // Rule ID 9193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9193,
        GIR_EraseRootFromParent_Done,
      // Label 13471: @897097
      GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(897207), // Rule ID 9196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9196,
        GIR_EraseRootFromParent_Done,
      // Label 13472: @897207
      GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(897317), // Rule ID 9197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9197,
        GIR_EraseRootFromParent_Done,
      // Label 13473: @897317
      GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(897427), // Rule ID 9200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9200,
        GIR_EraseRootFromParent_Done,
      // Label 13474: @897427
      GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(897537), // Rule ID 9201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9201,
        GIR_EraseRootFromParent_Done,
      // Label 13475: @897537
      GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(897647), // Rule ID 9204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9204,
        GIR_EraseRootFromParent_Done,
      // Label 13476: @897647
      GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(897757), // Rule ID 9205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9205,
        GIR_EraseRootFromParent_Done,
      // Label 13477: @897757
      GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(897867), // Rule ID 9208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9208,
        GIR_EraseRootFromParent_Done,
      // Label 13478: @897867
      GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(897977), // Rule ID 9209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9209,
        GIR_EraseRootFromParent_Done,
      // Label 13479: @897977
      GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(898087), // Rule ID 9212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9212,
        GIR_EraseRootFromParent_Done,
      // Label 13480: @898087
      GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(898197), // Rule ID 9213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9213,
        GIR_EraseRootFromParent_Done,
      // Label 13481: @898197
      GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(898307), // Rule ID 9216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9216,
        GIR_EraseRootFromParent_Done,
      // Label 13482: @898307
      GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(898417), // Rule ID 9217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9217,
        GIR_EraseRootFromParent_Done,
      // Label 13483: @898417
      GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(898527), // Rule ID 9220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9220,
        GIR_EraseRootFromParent_Done,
      // Label 13484: @898527
      GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(898637), // Rule ID 9221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9221,
        GIR_EraseRootFromParent_Done,
      // Label 13485: @898637
      GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(898747), // Rule ID 9224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9224,
        GIR_EraseRootFromParent_Done,
      // Label 13486: @898747
      GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(898857), // Rule ID 9225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9225,
        GIR_EraseRootFromParent_Done,
      // Label 13487: @898857
      GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(898967), // Rule ID 9228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9228,
        GIR_EraseRootFromParent_Done,
      // Label 13488: @898967
      GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(899077), // Rule ID 9229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9229,
        GIR_EraseRootFromParent_Done,
      // Label 13489: @899077
      GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(899187), // Rule ID 9232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9232,
        GIR_EraseRootFromParent_Done,
      // Label 13490: @899187
      GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(899297), // Rule ID 9233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9233,
        GIR_EraseRootFromParent_Done,
      // Label 13491: @899297
      GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(899407), // Rule ID 9324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9324,
        GIR_EraseRootFromParent_Done,
      // Label 13492: @899407
      GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(899517), // Rule ID 9325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9325,
        GIR_EraseRootFromParent_Done,
      // Label 13493: @899517
      GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(899627), // Rule ID 9328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9328,
        GIR_EraseRootFromParent_Done,
      // Label 13494: @899627
      GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(899737), // Rule ID 9329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9329,
        GIR_EraseRootFromParent_Done,
      // Label 13495: @899737
      GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(899847), // Rule ID 9332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9332,
        GIR_EraseRootFromParent_Done,
      // Label 13496: @899847
      GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(899957), // Rule ID 9333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9333,
        GIR_EraseRootFromParent_Done,
      // Label 13497: @899957
      GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(900067), // Rule ID 9336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9336,
        GIR_EraseRootFromParent_Done,
      // Label 13498: @900067
      GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(900177), // Rule ID 9337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9337,
        GIR_EraseRootFromParent_Done,
      // Label 13499: @900177
      GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(900287), // Rule ID 9340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9340,
        GIR_EraseRootFromParent_Done,
      // Label 13500: @900287
      GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(900397), // Rule ID 9341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9341,
        GIR_EraseRootFromParent_Done,
      // Label 13501: @900397
      GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(900507), // Rule ID 9344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9344,
        GIR_EraseRootFromParent_Done,
      // Label 13502: @900507
      GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(900617), // Rule ID 9345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9345,
        GIR_EraseRootFromParent_Done,
      // Label 13503: @900617
      GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(900727), // Rule ID 9348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9348,
        GIR_EraseRootFromParent_Done,
      // Label 13504: @900727
      GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(900837), // Rule ID 9349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9349,
        GIR_EraseRootFromParent_Done,
      // Label 13505: @900837
      GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(900947), // Rule ID 9352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9352,
        GIR_EraseRootFromParent_Done,
      // Label 13506: @900947
      GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(901057), // Rule ID 9353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9353,
        GIR_EraseRootFromParent_Done,
      // Label 13507: @901057
      GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(901167), // Rule ID 9356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9356,
        GIR_EraseRootFromParent_Done,
      // Label 13508: @901167
      GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(901277), // Rule ID 9357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9357,
        GIR_EraseRootFromParent_Done,
      // Label 13509: @901277
      GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(901387), // Rule ID 9360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9360,
        GIR_EraseRootFromParent_Done,
      // Label 13510: @901387
      GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(901497), // Rule ID 9361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9361,
        GIR_EraseRootFromParent_Done,
      // Label 13511: @901497
      GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(901607), // Rule ID 9364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9364,
        GIR_EraseRootFromParent_Done,
      // Label 13512: @901607
      GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(901717), // Rule ID 9365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9365,
        GIR_EraseRootFromParent_Done,
      // Label 13513: @901717
      GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(901827), // Rule ID 9368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9368,
        GIR_EraseRootFromParent_Done,
      // Label 13514: @901827
      GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(901937), // Rule ID 9369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9369,
        GIR_EraseRootFromParent_Done,
      // Label 13515: @901937
      GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(902047), // Rule ID 9372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9372,
        GIR_EraseRootFromParent_Done,
      // Label 13516: @902047
      GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(902157), // Rule ID 9373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9373,
        GIR_EraseRootFromParent_Done,
      // Label 13517: @902157
      GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(902267), // Rule ID 9376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9376,
        GIR_EraseRootFromParent_Done,
      // Label 13518: @902267
      GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(902377), // Rule ID 9377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9377,
        GIR_EraseRootFromParent_Done,
      // Label 13519: @902377
      GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(902487), // Rule ID 9380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9380,
        GIR_EraseRootFromParent_Done,
      // Label 13520: @902487
      GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(902597), // Rule ID 9381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9381,
        GIR_EraseRootFromParent_Done,
      // Label 13521: @902597
      GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(902707), // Rule ID 9384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9384,
        GIR_EraseRootFromParent_Done,
      // Label 13522: @902707
      GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(902817), // Rule ID 9385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9385,
        GIR_EraseRootFromParent_Done,
      // Label 13523: @902817
      GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(902927), // Rule ID 9388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9388,
        GIR_EraseRootFromParent_Done,
      // Label 13524: @902927
      GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(903037), // Rule ID 9389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9389,
        GIR_EraseRootFromParent_Done,
      // Label 13525: @903037
      GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(903147), // Rule ID 9392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9392,
        GIR_EraseRootFromParent_Done,
      // Label 13526: @903147
      GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(903257), // Rule ID 9393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9393,
        GIR_EraseRootFromParent_Done,
      // Label 13527: @903257
      GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(903367), // Rule ID 9396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9396,
        GIR_EraseRootFromParent_Done,
      // Label 13528: @903367
      GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(903477), // Rule ID 9397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9397,
        GIR_EraseRootFromParent_Done,
      // Label 13529: @903477
      GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(903587), // Rule ID 9400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9400,
        GIR_EraseRootFromParent_Done,
      // Label 13530: @903587
      GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(903697), // Rule ID 9401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9401,
        GIR_EraseRootFromParent_Done,
      // Label 13531: @903697
      GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(903807), // Rule ID 9404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9404,
        GIR_EraseRootFromParent_Done,
      // Label 13532: @903807
      GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(903917), // Rule ID 9405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9405,
        GIR_EraseRootFromParent_Done,
      // Label 13533: @903917
      GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(904027), // Rule ID 9408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9408,
        GIR_EraseRootFromParent_Done,
      // Label 13534: @904027
      GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(904137), // Rule ID 9409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9409,
        GIR_EraseRootFromParent_Done,
      // Label 13535: @904137
      GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(904247), // Rule ID 13786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13786,
        GIR_EraseRootFromParent_Done,
      // Label 13536: @904247
      GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(904357), // Rule ID 13787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13787,
        GIR_EraseRootFromParent_Done,
      // Label 13537: @904357
      GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(904467), // Rule ID 13788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13788,
        GIR_EraseRootFromParent_Done,
      // Label 13538: @904467
      GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(904577), // Rule ID 13789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13789,
        GIR_EraseRootFromParent_Done,
      // Label 13539: @904577
      GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(904687), // Rule ID 13790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13790,
        GIR_EraseRootFromParent_Done,
      // Label 13540: @904687
      GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(904797), // Rule ID 13791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13791,
        GIR_EraseRootFromParent_Done,
      // Label 13541: @904797
      GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(904907), // Rule ID 13792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13792,
        GIR_EraseRootFromParent_Done,
      // Label 13542: @904907
      GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(905017), // Rule ID 13793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13793,
        GIR_EraseRootFromParent_Done,
      // Label 13543: @905017
      GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(905127), // Rule ID 13794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13794,
        GIR_EraseRootFromParent_Done,
      // Label 13544: @905127
      GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(905237), // Rule ID 13795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13795,
        GIR_EraseRootFromParent_Done,
      // Label 13545: @905237
      GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(905347), // Rule ID 13796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13796,
        GIR_EraseRootFromParent_Done,
      // Label 13546: @905347
      GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(905457), // Rule ID 13797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13797,
        GIR_EraseRootFromParent_Done,
      // Label 13547: @905457
      GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(905567), // Rule ID 13798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13798,
        GIR_EraseRootFromParent_Done,
      // Label 13548: @905567
      GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(905677), // Rule ID 13799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13799,
        GIR_EraseRootFromParent_Done,
      // Label 13549: @905677
      GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(905787), // Rule ID 13800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13800,
        GIR_EraseRootFromParent_Done,
      // Label 13550: @905787
      GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(905897), // Rule ID 13801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13801,
        GIR_EraseRootFromParent_Done,
      // Label 13551: @905897
      GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(906007), // Rule ID 13802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13802,
        GIR_EraseRootFromParent_Done,
      // Label 13552: @906007
      GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(906117), // Rule ID 13803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13803,
        GIR_EraseRootFromParent_Done,
      // Label 13553: @906117
      GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(906227), // Rule ID 13804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13804,
        GIR_EraseRootFromParent_Done,
      // Label 13554: @906227
      GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(906337), // Rule ID 13805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13805,
        GIR_EraseRootFromParent_Done,
      // Label 13555: @906337
      GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(906447), // Rule ID 13806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13806,
        GIR_EraseRootFromParent_Done,
      // Label 13556: @906447
      GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(906557), // Rule ID 13807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13807,
        GIR_EraseRootFromParent_Done,
      // Label 13557: @906557
      GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(906667), // Rule ID 13808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13808,
        GIR_EraseRootFromParent_Done,
      // Label 13558: @906667
      GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(906777), // Rule ID 13809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13809,
        GIR_EraseRootFromParent_Done,
      // Label 13559: @906777
      GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(906887), // Rule ID 13810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13810,
        GIR_EraseRootFromParent_Done,
      // Label 13560: @906887
      GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(906997), // Rule ID 13811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13811,
        GIR_EraseRootFromParent_Done,
      // Label 13561: @906997
      GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(907107), // Rule ID 13812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13812,
        GIR_EraseRootFromParent_Done,
      // Label 13562: @907107
      GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(907217), // Rule ID 13813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13813,
        GIR_EraseRootFromParent_Done,
      // Label 13563: @907217
      GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(907327), // Rule ID 13814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13814,
        GIR_EraseRootFromParent_Done,
      // Label 13564: @907327
      GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(907437), // Rule ID 13815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13815,
        GIR_EraseRootFromParent_Done,
      // Label 13565: @907437
      GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(907547), // Rule ID 13816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13816,
        GIR_EraseRootFromParent_Done,
      // Label 13566: @907547
      GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(907657), // Rule ID 13817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13817,
        GIR_EraseRootFromParent_Done,
      // Label 13567: @907657
      GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(907767), // Rule ID 13818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13818,
        GIR_EraseRootFromParent_Done,
      // Label 13568: @907767
      GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(907877), // Rule ID 13819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13819,
        GIR_EraseRootFromParent_Done,
      // Label 13569: @907877
      GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(907987), // Rule ID 13820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13820,
        GIR_EraseRootFromParent_Done,
      // Label 13570: @907987
      GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(908097), // Rule ID 13821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13821,
        GIR_EraseRootFromParent_Done,
      // Label 13571: @908097
      GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(908207), // Rule ID 13822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13822,
        GIR_EraseRootFromParent_Done,
      // Label 13572: @908207
      GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(908317), // Rule ID 13823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13823,
        GIR_EraseRootFromParent_Done,
      // Label 13573: @908317
      GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(908427), // Rule ID 13824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13824,
        GIR_EraseRootFromParent_Done,
      // Label 13574: @908427
      GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(908537), // Rule ID 13825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13825,
        GIR_EraseRootFromParent_Done,
      // Label 13575: @908537
      GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(908647), // Rule ID 13826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13826,
        GIR_EraseRootFromParent_Done,
      // Label 13576: @908647
      GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(908757), // Rule ID 13827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13827,
        GIR_EraseRootFromParent_Done,
      // Label 13577: @908757
      GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(908867), // Rule ID 13828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13828,
        GIR_EraseRootFromParent_Done,
      // Label 13578: @908867
      GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(908977), // Rule ID 13829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13829,
        GIR_EraseRootFromParent_Done,
      // Label 13579: @908977
      GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(909053), // Rule ID 2624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2624,
        GIR_EraseRootFromParent_Done,
      // Label 13580: @909053
      GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(909129), // Rule ID 2625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2625,
        GIR_EraseRootFromParent_Done,
      // Label 13581: @909129
      GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(909205), // Rule ID 16996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16996,
        GIR_EraseRootFromParent_Done,
      // Label 13582: @909205
      GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(909281), // Rule ID 16997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16997,
        GIR_EraseRootFromParent_Done,
      // Label 13583: @909281
      GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(909357), // Rule ID 17006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17006,
        GIR_EraseRootFromParent_Done,
      // Label 13584: @909357
      GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(909433), // Rule ID 17007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17007,
        GIR_EraseRootFromParent_Done,
      // Label 13585: @909433
      GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(909509), // Rule ID 17016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17016,
        GIR_EraseRootFromParent_Done,
      // Label 13586: @909509
      GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(909585), // Rule ID 17017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17017,
        GIR_EraseRootFromParent_Done,
      // Label 13587: @909585
      GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(909661), // Rule ID 17026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17026,
        GIR_EraseRootFromParent_Done,
      // Label 13588: @909661
      GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(909737), // Rule ID 17027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17027,
        GIR_EraseRootFromParent_Done,
      // Label 13589: @909737
      GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(909813), // Rule ID 17036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17036,
        GIR_EraseRootFromParent_Done,
      // Label 13590: @909813
      GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(909889), // Rule ID 17037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17037,
        GIR_EraseRootFromParent_Done,
      // Label 13591: @909889
      GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(909965), // Rule ID 17046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17046,
        GIR_EraseRootFromParent_Done,
      // Label 13592: @909965
      GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(910041), // Rule ID 17047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17047,
        GIR_EraseRootFromParent_Done,
      // Label 13593: @910041
      GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(910117), // Rule ID 17056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17056,
        GIR_EraseRootFromParent_Done,
      // Label 13594: @910117
      GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(910193), // Rule ID 17057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17057,
        GIR_EraseRootFromParent_Done,
      // Label 13595: @910193
      GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(910269), // Rule ID 17066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17066,
        GIR_EraseRootFromParent_Done,
      // Label 13596: @910269
      GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(910345), // Rule ID 17067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17067,
        GIR_EraseRootFromParent_Done,
      // Label 13597: @910345
      GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(910421), // Rule ID 17112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17112,
        GIR_EraseRootFromParent_Done,
      // Label 13598: @910421
      GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(910497), // Rule ID 17113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17113,
        GIR_EraseRootFromParent_Done,
      // Label 13599: @910497
      GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(910573), // Rule ID 17122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17122,
        GIR_EraseRootFromParent_Done,
      // Label 13600: @910573
      GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(910649), // Rule ID 17123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17123,
        GIR_EraseRootFromParent_Done,
      // Label 13601: @910649
      GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(910725), // Rule ID 17132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17132,
        GIR_EraseRootFromParent_Done,
      // Label 13602: @910725
      GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(910801), // Rule ID 17133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17133,
        GIR_EraseRootFromParent_Done,
      // Label 13603: @910801
      GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(910877), // Rule ID 17142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17142,
        GIR_EraseRootFromParent_Done,
      // Label 13604: @910877
      GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(910953), // Rule ID 17143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17143,
        GIR_EraseRootFromParent_Done,
      // Label 13605: @910953
      GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(911029), // Rule ID 17152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17152,
        GIR_EraseRootFromParent_Done,
      // Label 13606: @911029
      GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(911105), // Rule ID 17153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17153,
        GIR_EraseRootFromParent_Done,
      // Label 13607: @911105
      GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(911181), // Rule ID 17162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17162,
        GIR_EraseRootFromParent_Done,
      // Label 13608: @911181
      GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(911257), // Rule ID 17163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17163,
        GIR_EraseRootFromParent_Done,
      // Label 13609: @911257
      GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(911333), // Rule ID 17172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17172,
        GIR_EraseRootFromParent_Done,
      // Label 13610: @911333
      GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(911409), // Rule ID 17173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17173,
        GIR_EraseRootFromParent_Done,
      // Label 13611: @911409
      GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(911485), // Rule ID 17182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17182,
        GIR_EraseRootFromParent_Done,
      // Label 13612: @911485
      GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(911561), // Rule ID 17183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17183,
        GIR_EraseRootFromParent_Done,
      // Label 13613: @911561
      GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(911637), // Rule ID 17192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17192,
        GIR_EraseRootFromParent_Done,
      // Label 13614: @911637
      GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(911713), // Rule ID 17193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17193,
        GIR_EraseRootFromParent_Done,
      // Label 13615: @911713
      GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(911808), // Rule ID 2554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10931:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2554,
        GIR_EraseRootFromParent_Done,
      // Label 13616: @911808
      GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(911903), // Rule ID 2555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10931:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2555,
        GIR_EraseRootFromParent_Done,
      // Label 13617: @911903
      GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(911998), // Rule ID 2558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2558,
        GIR_EraseRootFromParent_Done,
      // Label 13618: @911998
      GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(912093), // Rule ID 2559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2559,
        GIR_EraseRootFromParent_Done,
      // Label 13619: @912093
      GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(912188), // Rule ID 2562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2562,
        GIR_EraseRootFromParent_Done,
      // Label 13620: @912188
      GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(912283), // Rule ID 2563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2563,
        GIR_EraseRootFromParent_Done,
      // Label 13621: @912283
      GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(912378), // Rule ID 2598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10795:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2598,
        GIR_EraseRootFromParent_Done,
      // Label 13622: @912378
      GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(912473), // Rule ID 2599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10795:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2599,
        GIR_EraseRootFromParent_Done,
      // Label 13623: @912473
      GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(912550), // Rule ID 2630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2630,
        GIR_EraseRootFromParent_Done,
      // Label 13624: @912550
      GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(912627), // Rule ID 2631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2631,
        GIR_EraseRootFromParent_Done,
      // Label 13625: @912627
      GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(912722), // Rule ID 4750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4750,
        GIR_EraseRootFromParent_Done,
      // Label 13626: @912722
      GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(912817), // Rule ID 4751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4751,
        GIR_EraseRootFromParent_Done,
      // Label 13627: @912817
      GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(912912), // Rule ID 4754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4754,
        GIR_EraseRootFromParent_Done,
      // Label 13628: @912912
      GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(913007), // Rule ID 4755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4755,
        GIR_EraseRootFromParent_Done,
      // Label 13629: @913007
      GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(913102), // Rule ID 4758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4758,
        GIR_EraseRootFromParent_Done,
      // Label 13630: @913102
      GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(913197), // Rule ID 4759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4759,
        GIR_EraseRootFromParent_Done,
      // Label 13631: @913197
      GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(913292), // Rule ID 4762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4762,
        GIR_EraseRootFromParent_Done,
      // Label 13632: @913292
      GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(913387), // Rule ID 4763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4763,
        GIR_EraseRootFromParent_Done,
      // Label 13633: @913387
      GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(913482), // Rule ID 4766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4766,
        GIR_EraseRootFromParent_Done,
      // Label 13634: @913482
      GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(913577), // Rule ID 4767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4767,
        GIR_EraseRootFromParent_Done,
      // Label 13635: @913577
      GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(913672), // Rule ID 4770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4770,
        GIR_EraseRootFromParent_Done,
      // Label 13636: @913672
      GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(913767), // Rule ID 4771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4771,
        GIR_EraseRootFromParent_Done,
      // Label 13637: @913767
      GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(913862), // Rule ID 4774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4774,
        GIR_EraseRootFromParent_Done,
      // Label 13638: @913862
      GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(913957), // Rule ID 4775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4775,
        GIR_EraseRootFromParent_Done,
      // Label 13639: @913957
      GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(914052), // Rule ID 4778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4778,
        GIR_EraseRootFromParent_Done,
      // Label 13640: @914052
      GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(914147), // Rule ID 4779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4779,
        GIR_EraseRootFromParent_Done,
      // Label 13641: @914147
      GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(914242), // Rule ID 4782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4782,
        GIR_EraseRootFromParent_Done,
      // Label 13642: @914242
      GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(914337), // Rule ID 4783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4783,
        GIR_EraseRootFromParent_Done,
      // Label 13643: @914337
      GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(914432), // Rule ID 4786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4786,
        GIR_EraseRootFromParent_Done,
      // Label 13644: @914432
      GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(914527), // Rule ID 4787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4787,
        GIR_EraseRootFromParent_Done,
      // Label 13645: @914527
      GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(914622), // Rule ID 4790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4790,
        GIR_EraseRootFromParent_Done,
      // Label 13646: @914622
      GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(914717), // Rule ID 4791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4791,
        GIR_EraseRootFromParent_Done,
      // Label 13647: @914717
      GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(914812), // Rule ID 4794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4794,
        GIR_EraseRootFromParent_Done,
      // Label 13648: @914812
      GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(914907), // Rule ID 4795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4795,
        GIR_EraseRootFromParent_Done,
      // Label 13649: @914907
      GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(915002), // Rule ID 4798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4798,
        GIR_EraseRootFromParent_Done,
      // Label 13650: @915002
      GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(915097), // Rule ID 4799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4799,
        GIR_EraseRootFromParent_Done,
      // Label 13651: @915097
      GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(915192), // Rule ID 4802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4802,
        GIR_EraseRootFromParent_Done,
      // Label 13652: @915192
      GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(915287), // Rule ID 4803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4803,
        GIR_EraseRootFromParent_Done,
      // Label 13653: @915287
      GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(915382), // Rule ID 4806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4806,
        GIR_EraseRootFromParent_Done,
      // Label 13654: @915382
      GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(915477), // Rule ID 4807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4807,
        GIR_EraseRootFromParent_Done,
      // Label 13655: @915477
      GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(915572), // Rule ID 4810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4810,
        GIR_EraseRootFromParent_Done,
      // Label 13656: @915572
      GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(915667), // Rule ID 4811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4811,
        GIR_EraseRootFromParent_Done,
      // Label 13657: @915667
      GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(915762), // Rule ID 4814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4814,
        GIR_EraseRootFromParent_Done,
      // Label 13658: @915762
      GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(915857), // Rule ID 4815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4815,
        GIR_EraseRootFromParent_Done,
      // Label 13659: @915857
      GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(915952), // Rule ID 4818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4818,
        GIR_EraseRootFromParent_Done,
      // Label 13660: @915952
      GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(916047), // Rule ID 4819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4819,
        GIR_EraseRootFromParent_Done,
      // Label 13661: @916047
      GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(916142), // Rule ID 4822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4822,
        GIR_EraseRootFromParent_Done,
      // Label 13662: @916142
      GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(916237), // Rule ID 4823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4823,
        GIR_EraseRootFromParent_Done,
      // Label 13663: @916237
      GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(916332), // Rule ID 4826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4826,
        GIR_EraseRootFromParent_Done,
      // Label 13664: @916332
      GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(916427), // Rule ID 4827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4827,
        GIR_EraseRootFromParent_Done,
      // Label 13665: @916427
      GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(916522), // Rule ID 4830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4830,
        GIR_EraseRootFromParent_Done,
      // Label 13666: @916522
      GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(916617), // Rule ID 4831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4831,
        GIR_EraseRootFromParent_Done,
      // Label 13667: @916617
      GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(916712), // Rule ID 4834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4834,
        GIR_EraseRootFromParent_Done,
      // Label 13668: @916712
      GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(916807), // Rule ID 4835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4835,
        GIR_EraseRootFromParent_Done,
      // Label 13669: @916807
      GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(916902), // Rule ID 4838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4838,
        GIR_EraseRootFromParent_Done,
      // Label 13670: @916902
      GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(916997), // Rule ID 4839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4839,
        GIR_EraseRootFromParent_Done,
      // Label 13671: @916997
      GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(917092), // Rule ID 4842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4842,
        GIR_EraseRootFromParent_Done,
      // Label 13672: @917092
      GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(917187), // Rule ID 4843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4843,
        GIR_EraseRootFromParent_Done,
      // Label 13673: @917187
      GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(917282), // Rule ID 4846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4846,
        GIR_EraseRootFromParent_Done,
      // Label 13674: @917282
      GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(917377), // Rule ID 4847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4847,
        GIR_EraseRootFromParent_Done,
      // Label 13675: @917377
      GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(917472), // Rule ID 4850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4850,
        GIR_EraseRootFromParent_Done,
      // Label 13676: @917472
      GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(917567), // Rule ID 4851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4851,
        GIR_EraseRootFromParent_Done,
      // Label 13677: @917567
      GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(917662), // Rule ID 4854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4854,
        GIR_EraseRootFromParent_Done,
      // Label 13678: @917662
      GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(917757), // Rule ID 4855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4855,
        GIR_EraseRootFromParent_Done,
      // Label 13679: @917757
      GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(917852), // Rule ID 4858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4858,
        GIR_EraseRootFromParent_Done,
      // Label 13680: @917852
      GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(917947), // Rule ID 4859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4859,
        GIR_EraseRootFromParent_Done,
      // Label 13681: @917947
      GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(918042), // Rule ID 4862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4862,
        GIR_EraseRootFromParent_Done,
      // Label 13682: @918042
      GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(918137), // Rule ID 4863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4863,
        GIR_EraseRootFromParent_Done,
      // Label 13683: @918137
      GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(918232), // Rule ID 4866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4866,
        GIR_EraseRootFromParent_Done,
      // Label 13684: @918232
      GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(918327), // Rule ID 4867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4867,
        GIR_EraseRootFromParent_Done,
      // Label 13685: @918327
      GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(918422), // Rule ID 4870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4870,
        GIR_EraseRootFromParent_Done,
      // Label 13686: @918422
      GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(918517), // Rule ID 4871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4871,
        GIR_EraseRootFromParent_Done,
      // Label 13687: @918517
      GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(918612), // Rule ID 4874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4874,
        GIR_EraseRootFromParent_Done,
      // Label 13688: @918612
      GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(918707), // Rule ID 4875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4875,
        GIR_EraseRootFromParent_Done,
      // Label 13689: @918707
      GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(918802), // Rule ID 4878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4878,
        GIR_EraseRootFromParent_Done,
      // Label 13690: @918802
      GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(918897), // Rule ID 4879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4879,
        GIR_EraseRootFromParent_Done,
      // Label 13691: @918897
      GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(918992), // Rule ID 4882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4882,
        GIR_EraseRootFromParent_Done,
      // Label 13692: @918992
      GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(919087), // Rule ID 4883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4883,
        GIR_EraseRootFromParent_Done,
      // Label 13693: @919087
      GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(919182), // Rule ID 4886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4886,
        GIR_EraseRootFromParent_Done,
      // Label 13694: @919182
      GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(919277), // Rule ID 4887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4887,
        GIR_EraseRootFromParent_Done,
      // Label 13695: @919277
      GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(919372), // Rule ID 4890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4890,
        GIR_EraseRootFromParent_Done,
      // Label 13696: @919372
      GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(919467), // Rule ID 4891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4891,
        GIR_EraseRootFromParent_Done,
      // Label 13697: @919467
      GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(919562), // Rule ID 4894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4894,
        GIR_EraseRootFromParent_Done,
      // Label 13698: @919562
      GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(919657), // Rule ID 4895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4895,
        GIR_EraseRootFromParent_Done,
      // Label 13699: @919657
      GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(919752), // Rule ID 4898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4898,
        GIR_EraseRootFromParent_Done,
      // Label 13700: @919752
      GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(919847), // Rule ID 4899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4899,
        GIR_EraseRootFromParent_Done,
      // Label 13701: @919847
      GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(919942), // Rule ID 4902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4902,
        GIR_EraseRootFromParent_Done,
      // Label 13702: @919942
      GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(920037), // Rule ID 4903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4903,
        GIR_EraseRootFromParent_Done,
      // Label 13703: @920037
      GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(920132), // Rule ID 4906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4906,
        GIR_EraseRootFromParent_Done,
      // Label 13704: @920132
      GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(920227), // Rule ID 4907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4907,
        GIR_EraseRootFromParent_Done,
      // Label 13705: @920227
      GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(920322), // Rule ID 4910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4910,
        GIR_EraseRootFromParent_Done,
      // Label 13706: @920322
      GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(920417), // Rule ID 4911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4911,
        GIR_EraseRootFromParent_Done,
      // Label 13707: @920417
      GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(920512), // Rule ID 4914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4914,
        GIR_EraseRootFromParent_Done,
      // Label 13708: @920512
      GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(920607), // Rule ID 4915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4915,
        GIR_EraseRootFromParent_Done,
      // Label 13709: @920607
      GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(920702), // Rule ID 4918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4918,
        GIR_EraseRootFromParent_Done,
      // Label 13710: @920702
      GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(920797), // Rule ID 4919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4919,
        GIR_EraseRootFromParent_Done,
      // Label 13711: @920797
      GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(920892), // Rule ID 4922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4922,
        GIR_EraseRootFromParent_Done,
      // Label 13712: @920892
      GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(920987), // Rule ID 4923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4923,
        GIR_EraseRootFromParent_Done,
      // Label 13713: @920987
      GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(921082), // Rule ID 4926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4926,
        GIR_EraseRootFromParent_Done,
      // Label 13714: @921082
      GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(921177), // Rule ID 4927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4927,
        GIR_EraseRootFromParent_Done,
      // Label 13715: @921177
      GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(921272), // Rule ID 4930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4930,
        GIR_EraseRootFromParent_Done,
      // Label 13716: @921272
      GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(921367), // Rule ID 4931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4931,
        GIR_EraseRootFromParent_Done,
      // Label 13717: @921367
      GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(921462), // Rule ID 4934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4934,
        GIR_EraseRootFromParent_Done,
      // Label 13718: @921462
      GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(921557), // Rule ID 4935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4935,
        GIR_EraseRootFromParent_Done,
      // Label 13719: @921557
      GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(921652), // Rule ID 4938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4938,
        GIR_EraseRootFromParent_Done,
      // Label 13720: @921652
      GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(921747), // Rule ID 4939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4939,
        GIR_EraseRootFromParent_Done,
      // Label 13721: @921747
      GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(921842), // Rule ID 4942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4942,
        GIR_EraseRootFromParent_Done,
      // Label 13722: @921842
      GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(921937), // Rule ID 4943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4943,
        GIR_EraseRootFromParent_Done,
      // Label 13723: @921937
      GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(922032), // Rule ID 4946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4946,
        GIR_EraseRootFromParent_Done,
      // Label 13724: @922032
      GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(922127), // Rule ID 4947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4947,
        GIR_EraseRootFromParent_Done,
      // Label 13725: @922127
      GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(922222), // Rule ID 4950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4950,
        GIR_EraseRootFromParent_Done,
      // Label 13726: @922222
      GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(922317), // Rule ID 4951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4951,
        GIR_EraseRootFromParent_Done,
      // Label 13727: @922317
      GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(922412), // Rule ID 4954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4954,
        GIR_EraseRootFromParent_Done,
      // Label 13728: @922412
      GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(922507), // Rule ID 4955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4955,
        GIR_EraseRootFromParent_Done,
      // Label 13729: @922507
      GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(922602), // Rule ID 4958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4958,
        GIR_EraseRootFromParent_Done,
      // Label 13730: @922602
      GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(922697), // Rule ID 4959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4959,
        GIR_EraseRootFromParent_Done,
      // Label 13731: @922697
      GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(922792), // Rule ID 4962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4962,
        GIR_EraseRootFromParent_Done,
      // Label 13732: @922792
      GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(922887), // Rule ID 4963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4963,
        GIR_EraseRootFromParent_Done,
      // Label 13733: @922887
      GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(922982), // Rule ID 4966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4966,
        GIR_EraseRootFromParent_Done,
      // Label 13734: @922982
      GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(923077), // Rule ID 4967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4967,
        GIR_EraseRootFromParent_Done,
      // Label 13735: @923077
      GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(923154), // Rule ID 12578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12578,
        GIR_EraseRootFromParent_Done,
      // Label 13736: @923154
      GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(923231), // Rule ID 12579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12579,
        GIR_EraseRootFromParent_Done,
      // Label 13737: @923231
      GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(923308), // Rule ID 12582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12582,
        GIR_EraseRootFromParent_Done,
      // Label 13738: @923308
      GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(923385), // Rule ID 12583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12583,
        GIR_EraseRootFromParent_Done,
      // Label 13739: @923385
      GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(923462), // Rule ID 12586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12586,
        GIR_EraseRootFromParent_Done,
      // Label 13740: @923462
      GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(923539), // Rule ID 12587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12587,
        GIR_EraseRootFromParent_Done,
      // Label 13741: @923539
      GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(923616), // Rule ID 12590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12590,
        GIR_EraseRootFromParent_Done,
      // Label 13742: @923616
      GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(923693), // Rule ID 12591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12591,
        GIR_EraseRootFromParent_Done,
      // Label 13743: @923693
      GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(923770), // Rule ID 12594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12594,
        GIR_EraseRootFromParent_Done,
      // Label 13744: @923770
      GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(923847), // Rule ID 12595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12595,
        GIR_EraseRootFromParent_Done,
      // Label 13745: @923847
      GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(923924), // Rule ID 12598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12598,
        GIR_EraseRootFromParent_Done,
      // Label 13746: @923924
      GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(924001), // Rule ID 12599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12599,
        GIR_EraseRootFromParent_Done,
      // Label 13747: @924001
      GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(924078), // Rule ID 12602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12602,
        GIR_EraseRootFromParent_Done,
      // Label 13748: @924078
      GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(924155), // Rule ID 12603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12603,
        GIR_EraseRootFromParent_Done,
      // Label 13749: @924155
      GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(924232), // Rule ID 12606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12606,
        GIR_EraseRootFromParent_Done,
      // Label 13750: @924232
      GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(924309), // Rule ID 12607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12607,
        GIR_EraseRootFromParent_Done,
      // Label 13751: @924309
      GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(924386), // Rule ID 12610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12610,
        GIR_EraseRootFromParent_Done,
      // Label 13752: @924386
      GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(924463), // Rule ID 12611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12611,
        GIR_EraseRootFromParent_Done,
      // Label 13753: @924463
      GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(924540), // Rule ID 12614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12614,
        GIR_EraseRootFromParent_Done,
      // Label 13754: @924540
      GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(924617), // Rule ID 12615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12615,
        GIR_EraseRootFromParent_Done,
      // Label 13755: @924617
      GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(924694), // Rule ID 12618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12618,
        GIR_EraseRootFromParent_Done,
      // Label 13756: @924694
      GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(924771), // Rule ID 12619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12619,
        GIR_EraseRootFromParent_Done,
      // Label 13757: @924771
      GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(924848), // Rule ID 12622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12622,
        GIR_EraseRootFromParent_Done,
      // Label 13758: @924848
      GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(924925), // Rule ID 12623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12623,
        GIR_EraseRootFromParent_Done,
      // Label 13759: @924925
      GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(925002), // Rule ID 12626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12626,
        GIR_EraseRootFromParent_Done,
      // Label 13760: @925002
      GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(925079), // Rule ID 12627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12627,
        GIR_EraseRootFromParent_Done,
      // Label 13761: @925079
      GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(925156), // Rule ID 12630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12630,
        GIR_EraseRootFromParent_Done,
      // Label 13762: @925156
      GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(925233), // Rule ID 12631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12631,
        GIR_EraseRootFromParent_Done,
      // Label 13763: @925233
      GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(925310), // Rule ID 12634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12634,
        GIR_EraseRootFromParent_Done,
      // Label 13764: @925310
      GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(925387), // Rule ID 12635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12635,
        GIR_EraseRootFromParent_Done,
      // Label 13765: @925387
      GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(925464), // Rule ID 12638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12638,
        GIR_EraseRootFromParent_Done,
      // Label 13766: @925464
      GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(925541), // Rule ID 12639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12639,
        GIR_EraseRootFromParent_Done,
      // Label 13767: @925541
      GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(925618), // Rule ID 12642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12642,
        GIR_EraseRootFromParent_Done,
      // Label 13768: @925618
      GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(925695), // Rule ID 12643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12643,
        GIR_EraseRootFromParent_Done,
      // Label 13769: @925695
      GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(925772), // Rule ID 12646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12646,
        GIR_EraseRootFromParent_Done,
      // Label 13770: @925772
      GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(925849), // Rule ID 12647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12647,
        GIR_EraseRootFromParent_Done,
      // Label 13771: @925849
      GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(925926), // Rule ID 12650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12650,
        GIR_EraseRootFromParent_Done,
      // Label 13772: @925926
      GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(926003), // Rule ID 12651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12651,
        GIR_EraseRootFromParent_Done,
      // Label 13773: @926003
      GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(926080), // Rule ID 12654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12654,
        GIR_EraseRootFromParent_Done,
      // Label 13774: @926080
      GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(926157), // Rule ID 12655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12655,
        GIR_EraseRootFromParent_Done,
      // Label 13775: @926157
      GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(926234), // Rule ID 12658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12658,
        GIR_EraseRootFromParent_Done,
      // Label 13776: @926234
      GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(926311), // Rule ID 12659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12659,
        GIR_EraseRootFromParent_Done,
      // Label 13777: @926311
      GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(926388), // Rule ID 12662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12662,
        GIR_EraseRootFromParent_Done,
      // Label 13778: @926388
      GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(926465), // Rule ID 12663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12663,
        GIR_EraseRootFromParent_Done,
      // Label 13779: @926465
      GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(926542), // Rule ID 12666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12666,
        GIR_EraseRootFromParent_Done,
      // Label 13780: @926542
      GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(926619), // Rule ID 12667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12667,
        GIR_EraseRootFromParent_Done,
      // Label 13781: @926619
      GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(926696), // Rule ID 12670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12670,
        GIR_EraseRootFromParent_Done,
      // Label 13782: @926696
      GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(926773), // Rule ID 12671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12671,
        GIR_EraseRootFromParent_Done,
      // Label 13783: @926773
      GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(926850), // Rule ID 12674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12674,
        GIR_EraseRootFromParent_Done,
      // Label 13784: @926850
      GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(926927), // Rule ID 12675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12675,
        GIR_EraseRootFromParent_Done,
      // Label 13785: @926927
      GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(927004), // Rule ID 12678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12678,
        GIR_EraseRootFromParent_Done,
      // Label 13786: @927004
      GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(927081), // Rule ID 12679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12679,
        GIR_EraseRootFromParent_Done,
      // Label 13787: @927081
      GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(927158), // Rule ID 12682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12682,
        GIR_EraseRootFromParent_Done,
      // Label 13788: @927158
      GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(927235), // Rule ID 12683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12683,
        GIR_EraseRootFromParent_Done,
      // Label 13789: @927235
      GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(927312), // Rule ID 12686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12686,
        GIR_EraseRootFromParent_Done,
      // Label 13790: @927312
      GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(927389), // Rule ID 12687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11017:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12687,
        GIR_EraseRootFromParent_Done,
      // Label 13791: @927389
      GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(927466), // Rule ID 12690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12690,
        GIR_EraseRootFromParent_Done,
      // Label 13792: @927466
      GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(927543), // Rule ID 12691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11017:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12691,
        GIR_EraseRootFromParent_Done,
      // Label 13793: @927543
      GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(927620), // Rule ID 12694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12694,
        GIR_EraseRootFromParent_Done,
      // Label 13794: @927620
      GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(927697), // Rule ID 12695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11017:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12695,
        GIR_EraseRootFromParent_Done,
      // Label 13795: @927697
      GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(927774), // Rule ID 12698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12698,
        GIR_EraseRootFromParent_Done,
      // Label 13796: @927774
      GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(927851), // Rule ID 12699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11017:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12699,
        GIR_EraseRootFromParent_Done,
      // Label 13797: @927851
      GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(927928), // Rule ID 12702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12702,
        GIR_EraseRootFromParent_Done,
      // Label 13798: @927928
      GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(928005), // Rule ID 12703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12703,
        GIR_EraseRootFromParent_Done,
      // Label 13799: @928005
      GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(928082), // Rule ID 12706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12706,
        GIR_EraseRootFromParent_Done,
      // Label 13800: @928082
      GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(928159), // Rule ID 12707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12707,
        GIR_EraseRootFromParent_Done,
      // Label 13801: @928159
      GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(928236), // Rule ID 12710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12710,
        GIR_EraseRootFromParent_Done,
      // Label 13802: @928236
      GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(928313), // Rule ID 12711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12711,
        GIR_EraseRootFromParent_Done,
      // Label 13803: @928313
      GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(928390), // Rule ID 12714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12714,
        GIR_EraseRootFromParent_Done,
      // Label 13804: @928390
      GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(928467), // Rule ID 12715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12715,
        GIR_EraseRootFromParent_Done,
      // Label 13805: @928467
      GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(928544), // Rule ID 12718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12718,
        GIR_EraseRootFromParent_Done,
      // Label 13806: @928544
      GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(928621), // Rule ID 12719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12719,
        GIR_EraseRootFromParent_Done,
      // Label 13807: @928621
      GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(928698), // Rule ID 12722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12722,
        GIR_EraseRootFromParent_Done,
      // Label 13808: @928698
      GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(928775), // Rule ID 12723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12723,
        GIR_EraseRootFromParent_Done,
      // Label 13809: @928775
      GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(928852), // Rule ID 12726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12726,
        GIR_EraseRootFromParent_Done,
      // Label 13810: @928852
      GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(928929), // Rule ID 12727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12727,
        GIR_EraseRootFromParent_Done,
      // Label 13811: @928929
      GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(929006), // Rule ID 12730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12730,
        GIR_EraseRootFromParent_Done,
      // Label 13812: @929006
      GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(929083), // Rule ID 12731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12731,
        GIR_EraseRootFromParent_Done,
      // Label 13813: @929083
      GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(929160), // Rule ID 12734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12734,
        GIR_EraseRootFromParent_Done,
      // Label 13814: @929160
      GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(929237), // Rule ID 12735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12735,
        GIR_EraseRootFromParent_Done,
      // Label 13815: @929237
      GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(929314), // Rule ID 12738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12738,
        GIR_EraseRootFromParent_Done,
      // Label 13816: @929314
      GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(929391), // Rule ID 12739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11017:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12739,
        GIR_EraseRootFromParent_Done,
      // Label 13817: @929391
      GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(929468), // Rule ID 12742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12742,
        GIR_EraseRootFromParent_Done,
      // Label 13818: @929468
      GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(929545), // Rule ID 12743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11017:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12743,
        GIR_EraseRootFromParent_Done,
      // Label 13819: @929545
      GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(929622), // Rule ID 12746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12746,
        GIR_EraseRootFromParent_Done,
      // Label 13820: @929622
      GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(929699), // Rule ID 12747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11017:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12747,
        GIR_EraseRootFromParent_Done,
      // Label 13821: @929699
      GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(929776), // Rule ID 12750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12750,
        GIR_EraseRootFromParent_Done,
      // Label 13822: @929776
      GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(929853), // Rule ID 12751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12751,
        GIR_EraseRootFromParent_Done,
      // Label 13823: @929853
      GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(929930), // Rule ID 12754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12754,
        GIR_EraseRootFromParent_Done,
      // Label 13824: @929930
      GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(930007), // Rule ID 12755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12755,
        GIR_EraseRootFromParent_Done,
      // Label 13825: @930007
      GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(930084), // Rule ID 12758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12758,
        GIR_EraseRootFromParent_Done,
      // Label 13826: @930084
      GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(930161), // Rule ID 12759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12759,
        GIR_EraseRootFromParent_Done,
      // Label 13827: @930161
      GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(930238), // Rule ID 12762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12762,
        GIR_EraseRootFromParent_Done,
      // Label 13828: @930238
      GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(930315), // Rule ID 12763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12763,
        GIR_EraseRootFromParent_Done,
      // Label 13829: @930315
      GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(930392), // Rule ID 12766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12766,
        GIR_EraseRootFromParent_Done,
      // Label 13830: @930392
      GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(930469), // Rule ID 12767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12767,
        GIR_EraseRootFromParent_Done,
      // Label 13831: @930469
      GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(930546), // Rule ID 12770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12770,
        GIR_EraseRootFromParent_Done,
      // Label 13832: @930546
      GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(930623), // Rule ID 12771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12771,
        GIR_EraseRootFromParent_Done,
      // Label 13833: @930623
      GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(930700), // Rule ID 12774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12774,
        GIR_EraseRootFromParent_Done,
      // Label 13834: @930700
      GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(930777), // Rule ID 12775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12775,
        GIR_EraseRootFromParent_Done,
      // Label 13835: @930777
      GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(930854), // Rule ID 12778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12778,
        GIR_EraseRootFromParent_Done,
      // Label 13836: @930854
      GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(930931), // Rule ID 12779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12779,
        GIR_EraseRootFromParent_Done,
      // Label 13837: @930931
      GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(931008), // Rule ID 12782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12782,
        GIR_EraseRootFromParent_Done,
      // Label 13838: @931008
      GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(931085), // Rule ID 12783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12783,
        GIR_EraseRootFromParent_Done,
      // Label 13839: @931085
      GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(931162), // Rule ID 12786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12786,
        GIR_EraseRootFromParent_Done,
      // Label 13840: @931162
      GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(931239), // Rule ID 12787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12787,
        GIR_EraseRootFromParent_Done,
      // Label 13841: @931239
      GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(931316), // Rule ID 12790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12790,
        GIR_EraseRootFromParent_Done,
      // Label 13842: @931316
      GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(931393), // Rule ID 12791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12791,
        GIR_EraseRootFromParent_Done,
      // Label 13843: @931393
      GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(931470), // Rule ID 12794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12794,
        GIR_EraseRootFromParent_Done,
      // Label 13844: @931470
      GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(931547), // Rule ID 12795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12795,
        GIR_EraseRootFromParent_Done,
      // Label 13845: @931547
      GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(931624), // Rule ID 12798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12798,
        GIR_EraseRootFromParent_Done,
      // Label 13846: @931624
      GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(931701), // Rule ID 12799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12799,
        GIR_EraseRootFromParent_Done,
      // Label 13847: @931701
      GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(931778), // Rule ID 12802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12802,
        GIR_EraseRootFromParent_Done,
      // Label 13848: @931778
      GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(931855), // Rule ID 12803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12803,
        GIR_EraseRootFromParent_Done,
      // Label 13849: @931855
      GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(931932), // Rule ID 12806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12806,
        GIR_EraseRootFromParent_Done,
      // Label 13850: @931932
      GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(932009), // Rule ID 12807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12807,
        GIR_EraseRootFromParent_Done,
      // Label 13851: @932009
      GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(932086), // Rule ID 12810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12810,
        GIR_EraseRootFromParent_Done,
      // Label 13852: @932086
      GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(932163), // Rule ID 12811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12811,
        GIR_EraseRootFromParent_Done,
      // Label 13853: @932163
      GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(932240), // Rule ID 12814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12814,
        GIR_EraseRootFromParent_Done,
      // Label 13854: @932240
      GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(932317), // Rule ID 12815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12815,
        GIR_EraseRootFromParent_Done,
      // Label 13855: @932317
      GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(932394), // Rule ID 12818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12818,
        GIR_EraseRootFromParent_Done,
      // Label 13856: @932394
      GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(932471), // Rule ID 12819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12819,
        GIR_EraseRootFromParent_Done,
      // Label 13857: @932471
      GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(932548), // Rule ID 12822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12822,
        GIR_EraseRootFromParent_Done,
      // Label 13858: @932548
      GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(932625), // Rule ID 12823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12823,
        GIR_EraseRootFromParent_Done,
      // Label 13859: @932625
      GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(932702), // Rule ID 12826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12826,
        GIR_EraseRootFromParent_Done,
      // Label 13860: @932702
      GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(932779), // Rule ID 12827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12827,
        GIR_EraseRootFromParent_Done,
      // Label 13861: @932779
      GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(932856), // Rule ID 12830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12830,
        GIR_EraseRootFromParent_Done,
      // Label 13862: @932856
      GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(932933), // Rule ID 12831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12831,
        GIR_EraseRootFromParent_Done,
      // Label 13863: @932933
      GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(933010), // Rule ID 12834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12834,
        GIR_EraseRootFromParent_Done,
      // Label 13864: @933010
      GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(933087), // Rule ID 12835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12835,
        GIR_EraseRootFromParent_Done,
      // Label 13865: @933087
      GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(933164), // Rule ID 12838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12838,
        GIR_EraseRootFromParent_Done,
      // Label 13866: @933164
      GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(933241), // Rule ID 12839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12839,
        GIR_EraseRootFromParent_Done,
      // Label 13867: @933241
      GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(933318), // Rule ID 12842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12842,
        GIR_EraseRootFromParent_Done,
      // Label 13868: @933318
      GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(933395), // Rule ID 12843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12843,
        GIR_EraseRootFromParent_Done,
      // Label 13869: @933395
      GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(933472), // Rule ID 12846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12846,
        GIR_EraseRootFromParent_Done,
      // Label 13870: @933472
      GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(933549), // Rule ID 12847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12847,
        GIR_EraseRootFromParent_Done,
      // Label 13871: @933549
      GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(933626), // Rule ID 12850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12850,
        GIR_EraseRootFromParent_Done,
      // Label 13872: @933626
      GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(933703), // Rule ID 12851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12851,
        GIR_EraseRootFromParent_Done,
      // Label 13873: @933703
      GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(933780), // Rule ID 12854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12854,
        GIR_EraseRootFromParent_Done,
      // Label 13874: @933780
      GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(933857), // Rule ID 12855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12855,
        GIR_EraseRootFromParent_Done,
      // Label 13875: @933857
      GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(933934), // Rule ID 12858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12858,
        GIR_EraseRootFromParent_Done,
      // Label 13876: @933934
      GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(934011), // Rule ID 12859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12859,
        GIR_EraseRootFromParent_Done,
      // Label 13877: @934011
      GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(934088), // Rule ID 12862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12862,
        GIR_EraseRootFromParent_Done,
      // Label 13878: @934088
      GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(934165), // Rule ID 12863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12863,
        GIR_EraseRootFromParent_Done,
      // Label 13879: @934165
      GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(934242), // Rule ID 12866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12866,
        GIR_EraseRootFromParent_Done,
      // Label 13880: @934242
      GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(934319), // Rule ID 12867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12867,
        GIR_EraseRootFromParent_Done,
      // Label 13881: @934319
      GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(934396), // Rule ID 12870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12870,
        GIR_EraseRootFromParent_Done,
      // Label 13882: @934396
      GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(934473), // Rule ID 12871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12871,
        GIR_EraseRootFromParent_Done,
      // Label 13883: @934473
      GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(934550), // Rule ID 12874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12874,
        GIR_EraseRootFromParent_Done,
      // Label 13884: @934550
      GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(934627), // Rule ID 12875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12875,
        GIR_EraseRootFromParent_Done,
      // Label 13885: @934627
      GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(934704), // Rule ID 12878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12878,
        GIR_EraseRootFromParent_Done,
      // Label 13886: @934704
      GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(934781), // Rule ID 12879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12879,
        GIR_EraseRootFromParent_Done,
      // Label 13887: @934781
      GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(934858), // Rule ID 12882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12882,
        GIR_EraseRootFromParent_Done,
      // Label 13888: @934858
      GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(934935), // Rule ID 12883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12883,
        GIR_EraseRootFromParent_Done,
      // Label 13889: @934935
      GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(935012), // Rule ID 12886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12886,
        GIR_EraseRootFromParent_Done,
      // Label 13890: @935012
      GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(935089), // Rule ID 12887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12887,
        GIR_EraseRootFromParent_Done,
      // Label 13891: @935089
      GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(935166), // Rule ID 12890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12890,
        GIR_EraseRootFromParent_Done,
      // Label 13892: @935166
      GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(935243), // Rule ID 12891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12891,
        GIR_EraseRootFromParent_Done,
      // Label 13893: @935243
      GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(935320), // Rule ID 12894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12894,
        GIR_EraseRootFromParent_Done,
      // Label 13894: @935320
      GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(935397), // Rule ID 12895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12895,
        GIR_EraseRootFromParent_Done,
      // Label 13895: @935397
      GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(935474), // Rule ID 12898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12898,
        GIR_EraseRootFromParent_Done,
      // Label 13896: @935474
      GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(935551), // Rule ID 12899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12899,
        GIR_EraseRootFromParent_Done,
      // Label 13897: @935551
      GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(935628), // Rule ID 12902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12902,
        GIR_EraseRootFromParent_Done,
      // Label 13898: @935628
      GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(935705), // Rule ID 12903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12903,
        GIR_EraseRootFromParent_Done,
      // Label 13899: @935705
      GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(935782), // Rule ID 12906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12906,
        GIR_EraseRootFromParent_Done,
      // Label 13900: @935782
      GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(935859), // Rule ID 12907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12907,
        GIR_EraseRootFromParent_Done,
      // Label 13901: @935859
      GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(935936), // Rule ID 12910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12910,
        GIR_EraseRootFromParent_Done,
      // Label 13902: @935936
      GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(936013), // Rule ID 12911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12911,
        GIR_EraseRootFromParent_Done,
      // Label 13903: @936013
      GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(936090), // Rule ID 12914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12914,
        GIR_EraseRootFromParent_Done,
      // Label 13904: @936090
      GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(936167), // Rule ID 12915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12915,
        GIR_EraseRootFromParent_Done,
      // Label 13905: @936167
      GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(936244), // Rule ID 12918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12918,
        GIR_EraseRootFromParent_Done,
      // Label 13906: @936244
      GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(936321), // Rule ID 12919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12919,
        GIR_EraseRootFromParent_Done,
      // Label 13907: @936321
      GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(936398), // Rule ID 12922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12922,
        GIR_EraseRootFromParent_Done,
      // Label 13908: @936398
      GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(936475), // Rule ID 12923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12923,
        GIR_EraseRootFromParent_Done,
      // Label 13909: @936475
      GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(936552), // Rule ID 12926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12926,
        GIR_EraseRootFromParent_Done,
      // Label 13910: @936552
      GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(936629), // Rule ID 12927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12927,
        GIR_EraseRootFromParent_Done,
      // Label 13911: @936629
      GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(936706), // Rule ID 12930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12930,
        GIR_EraseRootFromParent_Done,
      // Label 13912: @936706
      GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(936783), // Rule ID 12931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12931,
        GIR_EraseRootFromParent_Done,
      // Label 13913: @936783
      GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(936860), // Rule ID 12934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12934,
        GIR_EraseRootFromParent_Done,
      // Label 13914: @936860
      GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(936937), // Rule ID 12935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12935,
        GIR_EraseRootFromParent_Done,
      // Label 13915: @936937
      GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(937014), // Rule ID 12938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12938,
        GIR_EraseRootFromParent_Done,
      // Label 13916: @937014
      GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(937091), // Rule ID 12939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12939,
        GIR_EraseRootFromParent_Done,
      // Label 13917: @937091
      GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(937168), // Rule ID 12942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12942,
        GIR_EraseRootFromParent_Done,
      // Label 13918: @937168
      GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(937245), // Rule ID 12943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12943,
        GIR_EraseRootFromParent_Done,
      // Label 13919: @937245
      GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(937322), // Rule ID 12946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12946,
        GIR_EraseRootFromParent_Done,
      // Label 13920: @937322
      GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(937399), // Rule ID 12947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12947,
        GIR_EraseRootFromParent_Done,
      // Label 13921: @937399
      GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(937476), // Rule ID 12950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12950,
        GIR_EraseRootFromParent_Done,
      // Label 13922: @937476
      GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(937553), // Rule ID 12951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12951,
        GIR_EraseRootFromParent_Done,
      // Label 13923: @937553
      GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(937630), // Rule ID 12954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12954,
        GIR_EraseRootFromParent_Done,
      // Label 13924: @937630
      GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(937707), // Rule ID 12955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12955,
        GIR_EraseRootFromParent_Done,
      // Label 13925: @937707
      GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(937784), // Rule ID 12958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12958,
        GIR_EraseRootFromParent_Done,
      // Label 13926: @937784
      GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(937861), // Rule ID 12959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12959,
        GIR_EraseRootFromParent_Done,
      // Label 13927: @937861
      GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(937938), // Rule ID 12962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12962,
        GIR_EraseRootFromParent_Done,
      // Label 13928: @937938
      GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(938015), // Rule ID 12963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12963,
        GIR_EraseRootFromParent_Done,
      // Label 13929: @938015
      GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(938092), // Rule ID 12966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12966,
        GIR_EraseRootFromParent_Done,
      // Label 13930: @938092
      GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(938169), // Rule ID 12967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12967,
        GIR_EraseRootFromParent_Done,
      // Label 13931: @938169
      GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(938246), // Rule ID 12970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12970,
        GIR_EraseRootFromParent_Done,
      // Label 13932: @938246
      GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(938323), // Rule ID 12971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12971,
        GIR_EraseRootFromParent_Done,
      // Label 13933: @938323
      GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(938400), // Rule ID 12974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12974,
        GIR_EraseRootFromParent_Done,
      // Label 13934: @938400
      GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(938477), // Rule ID 12975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12975,
        GIR_EraseRootFromParent_Done,
      // Label 13935: @938477
      GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(938554), // Rule ID 12978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12978,
        GIR_EraseRootFromParent_Done,
      // Label 13936: @938554
      GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(938631), // Rule ID 12979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12979,
        GIR_EraseRootFromParent_Done,
      // Label 13937: @938631
      GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(938708), // Rule ID 12982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12982,
        GIR_EraseRootFromParent_Done,
      // Label 13938: @938708
      GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(938785), // Rule ID 12983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12983,
        GIR_EraseRootFromParent_Done,
      // Label 13939: @938785
      GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(938862), // Rule ID 12986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12986,
        GIR_EraseRootFromParent_Done,
      // Label 13940: @938862
      GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(938939), // Rule ID 12987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12987,
        GIR_EraseRootFromParent_Done,
      // Label 13941: @938939
      GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(939016), // Rule ID 12990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12990,
        GIR_EraseRootFromParent_Done,
      // Label 13942: @939016
      GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(939093), // Rule ID 12991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12991,
        GIR_EraseRootFromParent_Done,
      // Label 13943: @939093
      GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(939170), // Rule ID 12994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12994,
        GIR_EraseRootFromParent_Done,
      // Label 13944: @939170
      GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(939247), // Rule ID 12995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12995,
        GIR_EraseRootFromParent_Done,
      // Label 13945: @939247
      GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(939324), // Rule ID 12998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12998,
        GIR_EraseRootFromParent_Done,
      // Label 13946: @939324
      GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(939401), // Rule ID 12999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12999,
        GIR_EraseRootFromParent_Done,
      // Label 13947: @939401
      GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(939478), // Rule ID 13002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13002,
        GIR_EraseRootFromParent_Done,
      // Label 13948: @939478
      GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(939555), // Rule ID 13003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13003,
        GIR_EraseRootFromParent_Done,
      // Label 13949: @939555
      GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(939632), // Rule ID 13006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13006,
        GIR_EraseRootFromParent_Done,
      // Label 13950: @939632
      GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(939709), // Rule ID 13007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13007,
        GIR_EraseRootFromParent_Done,
      // Label 13951: @939709
      GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(939786), // Rule ID 13010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13010,
        GIR_EraseRootFromParent_Done,
      // Label 13952: @939786
      GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(939863), // Rule ID 13011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13011,
        GIR_EraseRootFromParent_Done,
      // Label 13953: @939863
      GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(939940), // Rule ID 13014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13014,
        GIR_EraseRootFromParent_Done,
      // Label 13954: @939940
      GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(940017), // Rule ID 13015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13015,
        GIR_EraseRootFromParent_Done,
      // Label 13955: @940017
      GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(940094), // Rule ID 13018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13018,
        GIR_EraseRootFromParent_Done,
      // Label 13956: @940094
      GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(940171), // Rule ID 13019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13019,
        GIR_EraseRootFromParent_Done,
      // Label 13957: @940171
      GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(940248), // Rule ID 13022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13022,
        GIR_EraseRootFromParent_Done,
      // Label 13958: @940248
      GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(940325), // Rule ID 13023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13023,
        GIR_EraseRootFromParent_Done,
      // Label 13959: @940325
      GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(940402), // Rule ID 13026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13026,
        GIR_EraseRootFromParent_Done,
      // Label 13960: @940402
      GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(940479), // Rule ID 13027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13027,
        GIR_EraseRootFromParent_Done,
      // Label 13961: @940479
      GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(940556), // Rule ID 13030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13030,
        GIR_EraseRootFromParent_Done,
      // Label 13962: @940556
      GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(940633), // Rule ID 13031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13031,
        GIR_EraseRootFromParent_Done,
      // Label 13963: @940633
      GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(940710), // Rule ID 13034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13034,
        GIR_EraseRootFromParent_Done,
      // Label 13964: @940710
      GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(940787), // Rule ID 13035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13035,
        GIR_EraseRootFromParent_Done,
      // Label 13965: @940787
      GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(940864), // Rule ID 13038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13038,
        GIR_EraseRootFromParent_Done,
      // Label 13966: @940864
      GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(940941), // Rule ID 13039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11013:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13039,
        GIR_EraseRootFromParent_Done,
      // Label 13967: @940941
      GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(941018), // Rule ID 13042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13042,
        GIR_EraseRootFromParent_Done,
      // Label 13968: @941018
      GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(941095), // Rule ID 13043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11013:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13043,
        GIR_EraseRootFromParent_Done,
      // Label 13969: @941095
      GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(941172), // Rule ID 13046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13046,
        GIR_EraseRootFromParent_Done,
      // Label 13970: @941172
      GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(941249), // Rule ID 13047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11013:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13047,
        GIR_EraseRootFromParent_Done,
      // Label 13971: @941249
      GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(941326), // Rule ID 13050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13050,
        GIR_EraseRootFromParent_Done,
      // Label 13972: @941326
      GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(941403), // Rule ID 13051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11013:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13051,
        GIR_EraseRootFromParent_Done,
      // Label 13973: @941403
      GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(941480), // Rule ID 13054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13054,
        GIR_EraseRootFromParent_Done,
      // Label 13974: @941480
      GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(941557), // Rule ID 13055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13055,
        GIR_EraseRootFromParent_Done,
      // Label 13975: @941557
      GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(941634), // Rule ID 13058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13058,
        GIR_EraseRootFromParent_Done,
      // Label 13976: @941634
      GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(941711), // Rule ID 13059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13059,
        GIR_EraseRootFromParent_Done,
      // Label 13977: @941711
      GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(941788), // Rule ID 13062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13062,
        GIR_EraseRootFromParent_Done,
      // Label 13978: @941788
      GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(941865), // Rule ID 13063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13063,
        GIR_EraseRootFromParent_Done,
      // Label 13979: @941865
      GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(941942), // Rule ID 13066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13066,
        GIR_EraseRootFromParent_Done,
      // Label 13980: @941942
      GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(942019), // Rule ID 13067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13067,
        GIR_EraseRootFromParent_Done,
      // Label 13981: @942019
      GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(942096), // Rule ID 13070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13070,
        GIR_EraseRootFromParent_Done,
      // Label 13982: @942096
      GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(942173), // Rule ID 13071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13071,
        GIR_EraseRootFromParent_Done,
      // Label 13983: @942173
      GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(942250), // Rule ID 13074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13074,
        GIR_EraseRootFromParent_Done,
      // Label 13984: @942250
      GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(942327), // Rule ID 13075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13075,
        GIR_EraseRootFromParent_Done,
      // Label 13985: @942327
      GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(942404), // Rule ID 13078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13078,
        GIR_EraseRootFromParent_Done,
      // Label 13986: @942404
      GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(942481), // Rule ID 13079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13079,
        GIR_EraseRootFromParent_Done,
      // Label 13987: @942481
      GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(942558), // Rule ID 13082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13082,
        GIR_EraseRootFromParent_Done,
      // Label 13988: @942558
      GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(942635), // Rule ID 13083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13083,
        GIR_EraseRootFromParent_Done,
      // Label 13989: @942635
      GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(942712), // Rule ID 13086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13086,
        GIR_EraseRootFromParent_Done,
      // Label 13990: @942712
      GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(942789), // Rule ID 13087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13087,
        GIR_EraseRootFromParent_Done,
      // Label 13991: @942789
      GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(942866), // Rule ID 13090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13090,
        GIR_EraseRootFromParent_Done,
      // Label 13992: @942866
      GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(942943), // Rule ID 13091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11013:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13091,
        GIR_EraseRootFromParent_Done,
      // Label 13993: @942943
      GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(943020), // Rule ID 13094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13094,
        GIR_EraseRootFromParent_Done,
      // Label 13994: @943020
      GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(943097), // Rule ID 13095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11013:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13095,
        GIR_EraseRootFromParent_Done,
      // Label 13995: @943097
      GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(943174), // Rule ID 13098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13098,
        GIR_EraseRootFromParent_Done,
      // Label 13996: @943174
      GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(943251), // Rule ID 13099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11013:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13099,
        GIR_EraseRootFromParent_Done,
      // Label 13997: @943251
      GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(943328), // Rule ID 13102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13102,
        GIR_EraseRootFromParent_Done,
      // Label 13998: @943328
      GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(943405), // Rule ID 13103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13103,
        GIR_EraseRootFromParent_Done,
      // Label 13999: @943405
      GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(943482), // Rule ID 13106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13106,
        GIR_EraseRootFromParent_Done,
      // Label 14000: @943482
      GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(943559), // Rule ID 13107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13107,
        GIR_EraseRootFromParent_Done,
      // Label 14001: @943559
      GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(943636), // Rule ID 13110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13110,
        GIR_EraseRootFromParent_Done,
      // Label 14002: @943636
      GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(943713), // Rule ID 13111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13111,
        GIR_EraseRootFromParent_Done,
      // Label 14003: @943713
      GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(943790), // Rule ID 13114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13114,
        GIR_EraseRootFromParent_Done,
      // Label 14004: @943790
      GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(943867), // Rule ID 13115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13115,
        GIR_EraseRootFromParent_Done,
      // Label 14005: @943867
      GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(943944), // Rule ID 13118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13118,
        GIR_EraseRootFromParent_Done,
      // Label 14006: @943944
      GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(944021), // Rule ID 13119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13119,
        GIR_EraseRootFromParent_Done,
      // Label 14007: @944021
      GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(944098), // Rule ID 13122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13122,
        GIR_EraseRootFromParent_Done,
      // Label 14008: @944098
      GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(944175), // Rule ID 13123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13123,
        GIR_EraseRootFromParent_Done,
      // Label 14009: @944175
      GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(944252), // Rule ID 13126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13126,
        GIR_EraseRootFromParent_Done,
      // Label 14010: @944252
      GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(944329), // Rule ID 13127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13127,
        GIR_EraseRootFromParent_Done,
      // Label 14011: @944329
      GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(944406), // Rule ID 13130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13130,
        GIR_EraseRootFromParent_Done,
      // Label 14012: @944406
      GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(944483), // Rule ID 13131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13131,
        GIR_EraseRootFromParent_Done,
      // Label 14013: @944483
      GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(944560), // Rule ID 13134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13134,
        GIR_EraseRootFromParent_Done,
      // Label 14014: @944560
      GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(944637), // Rule ID 13135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13135,
        GIR_EraseRootFromParent_Done,
      // Label 14015: @944637
      GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(944714), // Rule ID 13138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13138,
        GIR_EraseRootFromParent_Done,
      // Label 14016: @944714
      GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(944791), // Rule ID 13139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13139,
        GIR_EraseRootFromParent_Done,
      // Label 14017: @944791
      GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(944868), // Rule ID 13142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13142,
        GIR_EraseRootFromParent_Done,
      // Label 14018: @944868
      GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(944945), // Rule ID 13143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13143,
        GIR_EraseRootFromParent_Done,
      // Label 14019: @944945
      GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(945022), // Rule ID 13146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13146,
        GIR_EraseRootFromParent_Done,
      // Label 14020: @945022
      GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(945099), // Rule ID 13147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13147,
        GIR_EraseRootFromParent_Done,
      // Label 14021: @945099
      GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(945176), // Rule ID 13150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13150,
        GIR_EraseRootFromParent_Done,
      // Label 14022: @945176
      GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(945253), // Rule ID 13151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13151,
        GIR_EraseRootFromParent_Done,
      // Label 14023: @945253
      GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(945330), // Rule ID 13154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13154,
        GIR_EraseRootFromParent_Done,
      // Label 14024: @945330
      GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(945407), // Rule ID 13155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13155,
        GIR_EraseRootFromParent_Done,
      // Label 14025: @945407
      GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(945484), // Rule ID 13158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13158,
        GIR_EraseRootFromParent_Done,
      // Label 14026: @945484
      GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(945561), // Rule ID 13159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13159,
        GIR_EraseRootFromParent_Done,
      // Label 14027: @945561
      GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(945638), // Rule ID 13162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13162,
        GIR_EraseRootFromParent_Done,
      // Label 14028: @945638
      GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(945715), // Rule ID 13163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13163,
        GIR_EraseRootFromParent_Done,
      // Label 14029: @945715
      GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(945792), // Rule ID 13166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13166,
        GIR_EraseRootFromParent_Done,
      // Label 14030: @945792
      GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(945869), // Rule ID 13167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13167,
        GIR_EraseRootFromParent_Done,
      // Label 14031: @945869
      GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(945946), // Rule ID 13170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13170,
        GIR_EraseRootFromParent_Done,
      // Label 14032: @945946
      GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(946023), // Rule ID 13171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13171,
        GIR_EraseRootFromParent_Done,
      // Label 14033: @946023
      GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(946100), // Rule ID 13174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13174,
        GIR_EraseRootFromParent_Done,
      // Label 14034: @946100
      GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(946177), // Rule ID 13175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13175,
        GIR_EraseRootFromParent_Done,
      // Label 14035: @946177
      GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(946254), // Rule ID 13178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13178,
        GIR_EraseRootFromParent_Done,
      // Label 14036: @946254
      GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(946331), // Rule ID 13179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13179,
        GIR_EraseRootFromParent_Done,
      // Label 14037: @946331
      GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(946408), // Rule ID 13182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13182,
        GIR_EraseRootFromParent_Done,
      // Label 14038: @946408
      GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(946485), // Rule ID 13183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13183,
        GIR_EraseRootFromParent_Done,
      // Label 14039: @946485
      GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(946562), // Rule ID 13186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13186,
        GIR_EraseRootFromParent_Done,
      // Label 14040: @946562
      GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(946639), // Rule ID 13187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13187,
        GIR_EraseRootFromParent_Done,
      // Label 14041: @946639
      GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(946716), // Rule ID 13190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13190,
        GIR_EraseRootFromParent_Done,
      // Label 14042: @946716
      GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(946793), // Rule ID 13191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13191,
        GIR_EraseRootFromParent_Done,
      // Label 14043: @946793
      GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(946870), // Rule ID 13194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13194,
        GIR_EraseRootFromParent_Done,
      // Label 14044: @946870
      GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(946947), // Rule ID 13195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13195,
        GIR_EraseRootFromParent_Done,
      // Label 14045: @946947
      GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(947024), // Rule ID 13198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13198,
        GIR_EraseRootFromParent_Done,
      // Label 14046: @947024
      GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(947101), // Rule ID 13199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13199,
        GIR_EraseRootFromParent_Done,
      // Label 14047: @947101
      GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(947178), // Rule ID 13202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13202,
        GIR_EraseRootFromParent_Done,
      // Label 14048: @947178
      GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(947255), // Rule ID 13203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13203,
        GIR_EraseRootFromParent_Done,
      // Label 14049: @947255
      GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(947332), // Rule ID 13206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13206,
        GIR_EraseRootFromParent_Done,
      // Label 14050: @947332
      GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(947409), // Rule ID 13207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13207,
        GIR_EraseRootFromParent_Done,
      // Label 14051: @947409
      GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(947486), // Rule ID 13210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13210,
        GIR_EraseRootFromParent_Done,
      // Label 14052: @947486
      GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(947563), // Rule ID 13211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13211,
        GIR_EraseRootFromParent_Done,
      // Label 14053: @947563
      GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(947640), // Rule ID 13214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13214,
        GIR_EraseRootFromParent_Done,
      // Label 14054: @947640
      GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(947717), // Rule ID 13215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13215,
        GIR_EraseRootFromParent_Done,
      // Label 14055: @947717
      GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(947794), // Rule ID 13218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13218,
        GIR_EraseRootFromParent_Done,
      // Label 14056: @947794
      GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(947871), // Rule ID 13219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13219,
        GIR_EraseRootFromParent_Done,
      // Label 14057: @947871
      GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(947948), // Rule ID 13222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13222,
        GIR_EraseRootFromParent_Done,
      // Label 14058: @947948
      GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(948025), // Rule ID 13223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13223,
        GIR_EraseRootFromParent_Done,
      // Label 14059: @948025
      GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(948102), // Rule ID 13226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13226,
        GIR_EraseRootFromParent_Done,
      // Label 14060: @948102
      GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(948179), // Rule ID 13227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13227,
        GIR_EraseRootFromParent_Done,
      // Label 14061: @948179
      GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(948256), // Rule ID 13230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13230,
        GIR_EraseRootFromParent_Done,
      // Label 14062: @948256
      GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(948333), // Rule ID 13231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13231,
        GIR_EraseRootFromParent_Done,
      // Label 14063: @948333
      GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(948410), // Rule ID 13234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13234,
        GIR_EraseRootFromParent_Done,
      // Label 14064: @948410
      GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(948487), // Rule ID 13235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13235,
        GIR_EraseRootFromParent_Done,
      // Label 14065: @948487
      GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(948564), // Rule ID 13238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13238,
        GIR_EraseRootFromParent_Done,
      // Label 14066: @948564
      GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(948641), // Rule ID 13239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13239,
        GIR_EraseRootFromParent_Done,
      // Label 14067: @948641
      GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(948718), // Rule ID 13242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13242,
        GIR_EraseRootFromParent_Done,
      // Label 14068: @948718
      GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(948795), // Rule ID 13243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13243,
        GIR_EraseRootFromParent_Done,
      // Label 14069: @948795
      GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(948872), // Rule ID 13246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13246,
        GIR_EraseRootFromParent_Done,
      // Label 14070: @948872
      GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(948949), // Rule ID 13247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13247,
        GIR_EraseRootFromParent_Done,
      // Label 14071: @948949
      GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(949026), // Rule ID 13250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13250,
        GIR_EraseRootFromParent_Done,
      // Label 14072: @949026
      GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(949103), // Rule ID 13251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13251,
        GIR_EraseRootFromParent_Done,
      // Label 14073: @949103
      GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(949180), // Rule ID 13254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13254,
        GIR_EraseRootFromParent_Done,
      // Label 14074: @949180
      GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(949257), // Rule ID 13255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13255,
        GIR_EraseRootFromParent_Done,
      // Label 14075: @949257
      GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(949334), // Rule ID 13258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13258,
        GIR_EraseRootFromParent_Done,
      // Label 14076: @949334
      GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(949411), // Rule ID 13259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13259,
        GIR_EraseRootFromParent_Done,
      // Label 14077: @949411
      GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(949488), // Rule ID 13262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13262,
        GIR_EraseRootFromParent_Done,
      // Label 14078: @949488
      GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(949565), // Rule ID 13263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13263,
        GIR_EraseRootFromParent_Done,
      // Label 14079: @949565
      GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(949642), // Rule ID 13266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13266,
        GIR_EraseRootFromParent_Done,
      // Label 14080: @949642
      GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(949719), // Rule ID 13267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13267,
        GIR_EraseRootFromParent_Done,
      // Label 14081: @949719
      GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(949796), // Rule ID 13270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13270,
        GIR_EraseRootFromParent_Done,
      // Label 14082: @949796
      GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(949873), // Rule ID 13271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13271,
        GIR_EraseRootFromParent_Done,
      // Label 14083: @949873
      GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(949950), // Rule ID 13274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13274,
        GIR_EraseRootFromParent_Done,
      // Label 14084: @949950
      GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(950027), // Rule ID 13275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13275,
        GIR_EraseRootFromParent_Done,
      // Label 14085: @950027
      GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(950104), // Rule ID 13278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13278,
        GIR_EraseRootFromParent_Done,
      // Label 14086: @950104
      GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(950181), // Rule ID 13279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13279,
        GIR_EraseRootFromParent_Done,
      // Label 14087: @950181
      GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(950258), // Rule ID 13282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13282,
        GIR_EraseRootFromParent_Done,
      // Label 14088: @950258
      GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(950335), // Rule ID 13283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13283,
        GIR_EraseRootFromParent_Done,
      // Label 14089: @950335
      GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(950412), // Rule ID 13286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13286,
        GIR_EraseRootFromParent_Done,
      // Label 14090: @950412
      GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(950489), // Rule ID 13287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13287,
        GIR_EraseRootFromParent_Done,
      // Label 14091: @950489
      GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(950566), // Rule ID 13290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13290,
        GIR_EraseRootFromParent_Done,
      // Label 14092: @950566
      GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(950643), // Rule ID 13291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13291,
        GIR_EraseRootFromParent_Done,
      // Label 14093: @950643
      GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(950720), // Rule ID 13294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13294,
        GIR_EraseRootFromParent_Done,
      // Label 14094: @950720
      GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(950797), // Rule ID 13295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13295,
        GIR_EraseRootFromParent_Done,
      // Label 14095: @950797
      GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(950874), // Rule ID 13298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13298,
        GIR_EraseRootFromParent_Done,
      // Label 14096: @950874
      GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(950951), // Rule ID 13299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13299,
        GIR_EraseRootFromParent_Done,
      // Label 14097: @950951
      GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(951028), // Rule ID 13302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13302,
        GIR_EraseRootFromParent_Done,
      // Label 14098: @951028
      GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(951105), // Rule ID 13303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13303,
        GIR_EraseRootFromParent_Done,
      // Label 14099: @951105
      GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(951182), // Rule ID 13306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13306,
        GIR_EraseRootFromParent_Done,
      // Label 14100: @951182
      GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(951259), // Rule ID 13307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13307,
        GIR_EraseRootFromParent_Done,
      // Label 14101: @951259
      GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(951336), // Rule ID 13310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13310,
        GIR_EraseRootFromParent_Done,
      // Label 14102: @951336
      GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(951413), // Rule ID 13311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13311,
        GIR_EraseRootFromParent_Done,
      // Label 14103: @951413
      GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(951490), // Rule ID 13314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13314,
        GIR_EraseRootFromParent_Done,
      // Label 14104: @951490
      GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(951567), // Rule ID 13315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13315,
        GIR_EraseRootFromParent_Done,
      // Label 14105: @951567
      GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(951644), // Rule ID 13318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13318,
        GIR_EraseRootFromParent_Done,
      // Label 14106: @951644
      GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(951721), // Rule ID 13319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13319,
        GIR_EraseRootFromParent_Done,
      // Label 14107: @951721
      GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(951798), // Rule ID 13322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13322,
        GIR_EraseRootFromParent_Done,
      // Label 14108: @951798
      GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(951875), // Rule ID 13323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13323,
        GIR_EraseRootFromParent_Done,
      // Label 14109: @951875
      GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(951952), // Rule ID 13326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13326,
        GIR_EraseRootFromParent_Done,
      // Label 14110: @951952
      GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(952029), // Rule ID 13327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13327,
        GIR_EraseRootFromParent_Done,
      // Label 14111: @952029
      GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(952106), // Rule ID 13330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13330,
        GIR_EraseRootFromParent_Done,
      // Label 14112: @952106
      GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(952183), // Rule ID 13331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13331,
        GIR_EraseRootFromParent_Done,
      // Label 14113: @952183
      GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(952260), // Rule ID 13334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13334,
        GIR_EraseRootFromParent_Done,
      // Label 14114: @952260
      GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(952337), // Rule ID 13335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13335,
        GIR_EraseRootFromParent_Done,
      // Label 14115: @952337
      GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(952414), // Rule ID 13338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13338,
        GIR_EraseRootFromParent_Done,
      // Label 14116: @952414
      GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(952491), // Rule ID 13339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13339,
        GIR_EraseRootFromParent_Done,
      // Label 14117: @952491
      GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(952568), // Rule ID 13342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13342,
        GIR_EraseRootFromParent_Done,
      // Label 14118: @952568
      GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(952645), // Rule ID 13343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13343,
        GIR_EraseRootFromParent_Done,
      // Label 14119: @952645
      GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(952722), // Rule ID 13346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13346,
        GIR_EraseRootFromParent_Done,
      // Label 14120: @952722
      GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(952799), // Rule ID 13347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13347,
        GIR_EraseRootFromParent_Done,
      // Label 14121: @952799
      GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(952876), // Rule ID 13350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13350,
        GIR_EraseRootFromParent_Done,
      // Label 14122: @952876
      GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(952953), // Rule ID 13351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13351,
        GIR_EraseRootFromParent_Done,
      // Label 14123: @952953
      GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(953030), // Rule ID 13354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13354,
        GIR_EraseRootFromParent_Done,
      // Label 14124: @953030
      GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(953107), // Rule ID 13355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13355,
        GIR_EraseRootFromParent_Done,
      // Label 14125: @953107
      GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(953184), // Rule ID 13358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13358,
        GIR_EraseRootFromParent_Done,
      // Label 14126: @953184
      GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(953261), // Rule ID 13359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13359,
        GIR_EraseRootFromParent_Done,
      // Label 14127: @953261
      GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(953338), // Rule ID 13362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13362,
        GIR_EraseRootFromParent_Done,
      // Label 14128: @953338
      GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(953415), // Rule ID 13363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13363,
        GIR_EraseRootFromParent_Done,
      // Label 14129: @953415
      GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(953492), // Rule ID 13366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13366,
        GIR_EraseRootFromParent_Done,
      // Label 14130: @953492
      GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(953569), // Rule ID 13367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13367,
        GIR_EraseRootFromParent_Done,
      // Label 14131: @953569
      GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(953646), // Rule ID 13370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13370,
        GIR_EraseRootFromParent_Done,
      // Label 14132: @953646
      GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(953723), // Rule ID 13371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13371,
        GIR_EraseRootFromParent_Done,
      // Label 14133: @953723
      GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(953800), // Rule ID 13374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13374,
        GIR_EraseRootFromParent_Done,
      // Label 14134: @953800
      GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(953877), // Rule ID 13375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13375,
        GIR_EraseRootFromParent_Done,
      // Label 14135: @953877
      GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(953954), // Rule ID 13378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13378,
        GIR_EraseRootFromParent_Done,
      // Label 14136: @953954
      GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(954031), // Rule ID 13379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13379,
        GIR_EraseRootFromParent_Done,
      // Label 14137: @954031
      GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(954108), // Rule ID 13382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13382,
        GIR_EraseRootFromParent_Done,
      // Label 14138: @954108
      GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(954185), // Rule ID 13383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13383,
        GIR_EraseRootFromParent_Done,
      // Label 14139: @954185
      GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(954262), // Rule ID 13386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13386,
        GIR_EraseRootFromParent_Done,
      // Label 14140: @954262
      GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(954339), // Rule ID 13387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13387,
        GIR_EraseRootFromParent_Done,
      // Label 14141: @954339
      GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(954416), // Rule ID 13390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13390,
        GIR_EraseRootFromParent_Done,
      // Label 14142: @954416
      GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(954493), // Rule ID 13391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13391,
        GIR_EraseRootFromParent_Done,
      // Label 14143: @954493
      GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(954570), // Rule ID 13394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13394,
        GIR_EraseRootFromParent_Done,
      // Label 14144: @954570
      GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(954647), // Rule ID 13395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13395,
        GIR_EraseRootFromParent_Done,
      // Label 14145: @954647
      GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(954724), // Rule ID 13398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13398,
        GIR_EraseRootFromParent_Done,
      // Label 14146: @954724
      GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(954801), // Rule ID 13399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13399,
        GIR_EraseRootFromParent_Done,
      // Label 14147: @954801
      GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(954878), // Rule ID 13402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13402,
        GIR_EraseRootFromParent_Done,
      // Label 14148: @954878
      GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(954955), // Rule ID 13403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13403,
        GIR_EraseRootFromParent_Done,
      // Label 14149: @954955
      GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(955032), // Rule ID 13406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13406,
        GIR_EraseRootFromParent_Done,
      // Label 14150: @955032
      GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(955109), // Rule ID 13407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13407,
        GIR_EraseRootFromParent_Done,
      // Label 14151: @955109
      GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(955186), // Rule ID 13410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13410,
        GIR_EraseRootFromParent_Done,
      // Label 14152: @955186
      GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(955263), // Rule ID 13411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13411,
        GIR_EraseRootFromParent_Done,
      // Label 14153: @955263
      GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(955340), // Rule ID 13414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13414,
        GIR_EraseRootFromParent_Done,
      // Label 14154: @955340
      GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(955417), // Rule ID 13415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13415,
        GIR_EraseRootFromParent_Done,
      // Label 14155: @955417
      GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(955494), // Rule ID 13418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13418,
        GIR_EraseRootFromParent_Done,
      // Label 14156: @955494
      GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(955571), // Rule ID 13419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13419,
        GIR_EraseRootFromParent_Done,
      // Label 14157: @955571
      GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(955648), // Rule ID 13422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13422,
        GIR_EraseRootFromParent_Done,
      // Label 14158: @955648
      GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(955725), // Rule ID 13423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13423,
        GIR_EraseRootFromParent_Done,
      // Label 14159: @955725
      GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(955802), // Rule ID 13426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13426,
        GIR_EraseRootFromParent_Done,
      // Label 14160: @955802
      GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(955879), // Rule ID 13427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13427,
        GIR_EraseRootFromParent_Done,
      // Label 14161: @955879
      GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(955956), // Rule ID 13430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13430,
        GIR_EraseRootFromParent_Done,
      // Label 14162: @955956
      GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(956033), // Rule ID 13431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13431,
        GIR_EraseRootFromParent_Done,
      // Label 14163: @956033
      GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(956110), // Rule ID 13434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13434,
        GIR_EraseRootFromParent_Done,
      // Label 14164: @956110
      GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(956187), // Rule ID 13435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13435,
        GIR_EraseRootFromParent_Done,
      // Label 14165: @956187
      GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(956264), // Rule ID 13438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13438,
        GIR_EraseRootFromParent_Done,
      // Label 14166: @956264
      GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(956341), // Rule ID 13439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13439,
        GIR_EraseRootFromParent_Done,
      // Label 14167: @956341
      GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(956418), // Rule ID 13442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13442,
        GIR_EraseRootFromParent_Done,
      // Label 14168: @956418
      GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(956495), // Rule ID 13443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13443,
        GIR_EraseRootFromParent_Done,
      // Label 14169: @956495
      GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(956572), // Rule ID 13446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13446,
        GIR_EraseRootFromParent_Done,
      // Label 14170: @956572
      GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(956649), // Rule ID 13447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13447,
        GIR_EraseRootFromParent_Done,
      // Label 14171: @956649
      GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(956726), // Rule ID 13450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13450,
        GIR_EraseRootFromParent_Done,
      // Label 14172: @956726
      GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(956803), // Rule ID 13451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13451,
        GIR_EraseRootFromParent_Done,
      // Label 14173: @956803
      GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(956880), // Rule ID 13454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13454,
        GIR_EraseRootFromParent_Done,
      // Label 14174: @956880
      GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(956957), // Rule ID 13455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13455,
        GIR_EraseRootFromParent_Done,
      // Label 14175: @956957
      GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(957034), // Rule ID 13458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13458,
        GIR_EraseRootFromParent_Done,
      // Label 14176: @957034
      GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(957111), // Rule ID 13459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13459,
        GIR_EraseRootFromParent_Done,
      // Label 14177: @957111
      GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(957188), // Rule ID 13462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13462,
        GIR_EraseRootFromParent_Done,
      // Label 14178: @957188
      GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(957265), // Rule ID 13463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13463,
        GIR_EraseRootFromParent_Done,
      // Label 14179: @957265
      GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(957342), // Rule ID 13466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13466,
        GIR_EraseRootFromParent_Done,
      // Label 14180: @957342
      GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(957419), // Rule ID 13467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13467,
        GIR_EraseRootFromParent_Done,
      // Label 14181: @957419
      GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(957496), // Rule ID 13470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13470,
        GIR_EraseRootFromParent_Done,
      // Label 14182: @957496
      GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(957573), // Rule ID 13471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13471,
        GIR_EraseRootFromParent_Done,
      // Label 14183: @957573
      GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(957650), // Rule ID 13474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13474,
        GIR_EraseRootFromParent_Done,
      // Label 14184: @957650
      GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(957727), // Rule ID 13475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13475,
        GIR_EraseRootFromParent_Done,
      // Label 14185: @957727
      GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(957804), // Rule ID 13478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13478,
        GIR_EraseRootFromParent_Done,
      // Label 14186: @957804
      GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(957881), // Rule ID 13479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13479,
        GIR_EraseRootFromParent_Done,
      // Label 14187: @957881
      GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(957958), // Rule ID 13482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13482,
        GIR_EraseRootFromParent_Done,
      // Label 14188: @957958
      GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(958035), // Rule ID 13483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13483,
        GIR_EraseRootFromParent_Done,
      // Label 14189: @958035
      GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(958112), // Rule ID 13486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13486,
        GIR_EraseRootFromParent_Done,
      // Label 14190: @958112
      GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(958189), // Rule ID 13487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13487,
        GIR_EraseRootFromParent_Done,
      // Label 14191: @958189
      GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(958266), // Rule ID 13490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13490,
        GIR_EraseRootFromParent_Done,
      // Label 14192: @958266
      GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(958343), // Rule ID 13491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13491,
        GIR_EraseRootFromParent_Done,
      // Label 14193: @958343
      GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(958420), // Rule ID 13494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13494,
        GIR_EraseRootFromParent_Done,
      // Label 14194: @958420
      GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(958497), // Rule ID 13495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13495,
        GIR_EraseRootFromParent_Done,
      // Label 14195: @958497
      GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(958574), // Rule ID 13498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13498,
        GIR_EraseRootFromParent_Done,
      // Label 14196: @958574
      GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(958651), // Rule ID 13499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13499,
        GIR_EraseRootFromParent_Done,
      // Label 14197: @958651
      GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(958728), // Rule ID 13502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13502,
        GIR_EraseRootFromParent_Done,
      // Label 14198: @958728
      GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(958805), // Rule ID 13503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13503,
        GIR_EraseRootFromParent_Done,
      // Label 14199: @958805
      GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(958882), // Rule ID 13506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13506,
        GIR_EraseRootFromParent_Done,
      // Label 14200: @958882
      GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(958959), // Rule ID 13507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13507,
        GIR_EraseRootFromParent_Done,
      // Label 14201: @958959
      GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(959036), // Rule ID 13510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13510,
        GIR_EraseRootFromParent_Done,
      // Label 14202: @959036
      GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(959113), // Rule ID 13511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13511,
        GIR_EraseRootFromParent_Done,
      // Label 14203: @959113
      GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(959190), // Rule ID 13514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13514,
        GIR_EraseRootFromParent_Done,
      // Label 14204: @959190
      GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(959267), // Rule ID 13515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13515,
        GIR_EraseRootFromParent_Done,
      // Label 14205: @959267
      GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(959344), // Rule ID 13518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13518,
        GIR_EraseRootFromParent_Done,
      // Label 14206: @959344
      GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(959421), // Rule ID 13519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13519,
        GIR_EraseRootFromParent_Done,
      // Label 14207: @959421
      GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(959498), // Rule ID 13522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13522,
        GIR_EraseRootFromParent_Done,
      // Label 14208: @959498
      GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(959575), // Rule ID 13523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13523,
        GIR_EraseRootFromParent_Done,
      // Label 14209: @959575
      GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(959652), // Rule ID 13526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13526,
        GIR_EraseRootFromParent_Done,
      // Label 14210: @959652
      GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(959729), // Rule ID 13527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13527,
        GIR_EraseRootFromParent_Done,
      // Label 14211: @959729
      GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(959806), // Rule ID 13530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13530,
        GIR_EraseRootFromParent_Done,
      // Label 14212: @959806
      GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(959883), // Rule ID 13531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13531,
        GIR_EraseRootFromParent_Done,
      // Label 14213: @959883
      GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(959960), // Rule ID 13534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13534,
        GIR_EraseRootFromParent_Done,
      // Label 14214: @959960
      GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(960037), // Rule ID 13535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13535,
        GIR_EraseRootFromParent_Done,
      // Label 14215: @960037
      GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(960114), // Rule ID 13538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13538,
        GIR_EraseRootFromParent_Done,
      // Label 14216: @960114
      GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(960191), // Rule ID 13539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13539,
        GIR_EraseRootFromParent_Done,
      // Label 14217: @960191
      GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(960268), // Rule ID 13542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13542,
        GIR_EraseRootFromParent_Done,
      // Label 14218: @960268
      GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(960345), // Rule ID 13543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13543,
        GIR_EraseRootFromParent_Done,
      // Label 14219: @960345
      GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(960422), // Rule ID 13546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13546,
        GIR_EraseRootFromParent_Done,
      // Label 14220: @960422
      GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(960499), // Rule ID 13547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13547,
        GIR_EraseRootFromParent_Done,
      // Label 14221: @960499
      GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(960576), // Rule ID 13550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13550,
        GIR_EraseRootFromParent_Done,
      // Label 14222: @960576
      GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(960653), // Rule ID 13551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13551,
        GIR_EraseRootFromParent_Done,
      // Label 14223: @960653
      GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(960730), // Rule ID 13554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13554,
        GIR_EraseRootFromParent_Done,
      // Label 14224: @960730
      GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(960807), // Rule ID 13555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13555,
        GIR_EraseRootFromParent_Done,
      // Label 14225: @960807
      GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(960884), // Rule ID 13558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13558,
        GIR_EraseRootFromParent_Done,
      // Label 14226: @960884
      GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(960961), // Rule ID 13559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13559,
        GIR_EraseRootFromParent_Done,
      // Label 14227: @960961
      GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(961038), // Rule ID 13562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13562,
        GIR_EraseRootFromParent_Done,
      // Label 14228: @961038
      GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(961115), // Rule ID 13563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13563,
        GIR_EraseRootFromParent_Done,
      // Label 14229: @961115
      GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(961192), // Rule ID 13566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13566,
        GIR_EraseRootFromParent_Done,
      // Label 14230: @961192
      GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(961269), // Rule ID 13567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13567,
        GIR_EraseRootFromParent_Done,
      // Label 14231: @961269
      GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(961346), // Rule ID 13570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13570,
        GIR_EraseRootFromParent_Done,
      // Label 14232: @961346
      GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(961423), // Rule ID 13571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13571,
        GIR_EraseRootFromParent_Done,
      // Label 14233: @961423
      GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(961500), // Rule ID 13574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13574,
        GIR_EraseRootFromParent_Done,
      // Label 14234: @961500
      GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(961577), // Rule ID 13575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13575,
        GIR_EraseRootFromParent_Done,
      // Label 14235: @961577
      GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(961654), // Rule ID 13578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13578,
        GIR_EraseRootFromParent_Done,
      // Label 14236: @961654
      GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(961731), // Rule ID 13579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13579,
        GIR_EraseRootFromParent_Done,
      // Label 14237: @961731
      GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(961808), // Rule ID 13582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13582,
        GIR_EraseRootFromParent_Done,
      // Label 14238: @961808
      GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(961885), // Rule ID 13583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13583,
        GIR_EraseRootFromParent_Done,
      // Label 14239: @961885
      GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(961962), // Rule ID 13586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13586,
        GIR_EraseRootFromParent_Done,
      // Label 14240: @961962
      GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(962039), // Rule ID 13587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13587,
        GIR_EraseRootFromParent_Done,
      // Label 14241: @962039
      GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(962116), // Rule ID 13590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13590,
        GIR_EraseRootFromParent_Done,
      // Label 14242: @962116
      GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(962193), // Rule ID 13591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13591,
        GIR_EraseRootFromParent_Done,
      // Label 14243: @962193
      GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(962270), // Rule ID 13594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13594,
        GIR_EraseRootFromParent_Done,
      // Label 14244: @962270
      GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(962347), // Rule ID 13595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13595,
        GIR_EraseRootFromParent_Done,
      // Label 14245: @962347
      GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(962424), // Rule ID 13598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13598,
        GIR_EraseRootFromParent_Done,
      // Label 14246: @962424
      GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(962501), // Rule ID 13599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13599,
        GIR_EraseRootFromParent_Done,
      // Label 14247: @962501
      GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(962578), // Rule ID 13602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13602,
        GIR_EraseRootFromParent_Done,
      // Label 14248: @962578
      GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(962655), // Rule ID 13603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13603,
        GIR_EraseRootFromParent_Done,
      // Label 14249: @962655
      GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(962732), // Rule ID 13606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13606,
        GIR_EraseRootFromParent_Done,
      // Label 14250: @962732
      GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(962809), // Rule ID 13607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13607,
        GIR_EraseRootFromParent_Done,
      // Label 14251: @962809
      GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(962886), // Rule ID 13610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13610,
        GIR_EraseRootFromParent_Done,
      // Label 14252: @962886
      GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(962963), // Rule ID 13611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13611,
        GIR_EraseRootFromParent_Done,
      // Label 14253: @962963
      GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(963040), // Rule ID 13614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13614,
        GIR_EraseRootFromParent_Done,
      // Label 14254: @963040
      GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(963117), // Rule ID 13615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13615,
        GIR_EraseRootFromParent_Done,
      // Label 14255: @963117
      GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(963194), // Rule ID 13618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13618,
        GIR_EraseRootFromParent_Done,
      // Label 14256: @963194
      GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(963271), // Rule ID 13619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13619,
        GIR_EraseRootFromParent_Done,
      // Label 14257: @963271
      GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(963348), // Rule ID 13622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13622,
        GIR_EraseRootFromParent_Done,
      // Label 14258: @963348
      GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(963425), // Rule ID 13623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13623,
        GIR_EraseRootFromParent_Done,
      // Label 14259: @963425
      GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(963502), // Rule ID 13626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13626,
        GIR_EraseRootFromParent_Done,
      // Label 14260: @963502
      GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(963579), // Rule ID 13627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13627,
        GIR_EraseRootFromParent_Done,
      // Label 14261: @963579
      GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(963656), // Rule ID 13630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13630,
        GIR_EraseRootFromParent_Done,
      // Label 14262: @963656
      GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(963733), // Rule ID 13631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13631,
        GIR_EraseRootFromParent_Done,
      // Label 14263: @963733
      GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(963810), // Rule ID 13634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13634,
        GIR_EraseRootFromParent_Done,
      // Label 14264: @963810
      GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(963887), // Rule ID 13635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13635,
        GIR_EraseRootFromParent_Done,
      // Label 14265: @963887
      GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(963964), // Rule ID 13638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13638,
        GIR_EraseRootFromParent_Done,
      // Label 14266: @963964
      GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(964041), // Rule ID 13639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13639,
        GIR_EraseRootFromParent_Done,
      // Label 14267: @964041
      GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(964118), // Rule ID 13642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13642,
        GIR_EraseRootFromParent_Done,
      // Label 14268: @964118
      GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(964195), // Rule ID 13643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13643,
        GIR_EraseRootFromParent_Done,
      // Label 14269: @964195
      GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(964272), // Rule ID 13646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13646,
        GIR_EraseRootFromParent_Done,
      // Label 14270: @964272
      GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(964349), // Rule ID 13647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13647,
        GIR_EraseRootFromParent_Done,
      // Label 14271: @964349
      GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(964426), // Rule ID 13650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13650,
        GIR_EraseRootFromParent_Done,
      // Label 14272: @964426
      GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(964503), // Rule ID 13651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13651,
        GIR_EraseRootFromParent_Done,
      // Label 14273: @964503
      GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(964580), // Rule ID 13654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13654,
        GIR_EraseRootFromParent_Done,
      // Label 14274: @964580
      GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(964657), // Rule ID 13655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13655,
        GIR_EraseRootFromParent_Done,
      // Label 14275: @964657
      GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(964734), // Rule ID 13658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13658,
        GIR_EraseRootFromParent_Done,
      // Label 14276: @964734
      GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(964811), // Rule ID 13659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13659,
        GIR_EraseRootFromParent_Done,
      // Label 14277: @964811
      GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(964888), // Rule ID 13662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13662,
        GIR_EraseRootFromParent_Done,
      // Label 14278: @964888
      GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(964965), // Rule ID 13663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13663,
        GIR_EraseRootFromParent_Done,
      // Label 14279: @964965
      GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(965042), // Rule ID 13666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13666,
        GIR_EraseRootFromParent_Done,
      // Label 14280: @965042
      GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(965119), // Rule ID 13667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13667,
        GIR_EraseRootFromParent_Done,
      // Label 14281: @965119
      GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(965196), // Rule ID 13670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13670,
        GIR_EraseRootFromParent_Done,
      // Label 14282: @965196
      GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(965273), // Rule ID 13671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13671,
        GIR_EraseRootFromParent_Done,
      // Label 14283: @965273
      GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(965350), // Rule ID 13674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13674,
        GIR_EraseRootFromParent_Done,
      // Label 14284: @965350
      GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(965427), // Rule ID 13675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13675,
        GIR_EraseRootFromParent_Done,
      // Label 14285: @965427
      GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(965504), // Rule ID 13678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13678,
        GIR_EraseRootFromParent_Done,
      // Label 14286: @965504
      GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(965581), // Rule ID 13679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13679,
        GIR_EraseRootFromParent_Done,
      // Label 14287: @965581
      GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(965658), // Rule ID 13682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13682,
        GIR_EraseRootFromParent_Done,
      // Label 14288: @965658
      GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(965735), // Rule ID 13683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13683,
        GIR_EraseRootFromParent_Done,
      // Label 14289: @965735
      GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(965812), // Rule ID 13686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13686,
        GIR_EraseRootFromParent_Done,
      // Label 14290: @965812
      GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(965889), // Rule ID 13687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13687,
        GIR_EraseRootFromParent_Done,
      // Label 14291: @965889
      GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(965966), // Rule ID 13690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13690,
        GIR_EraseRootFromParent_Done,
      // Label 14292: @965966
      GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(966043), // Rule ID 13691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13691,
        GIR_EraseRootFromParent_Done,
      // Label 14293: @966043
      GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(966120), // Rule ID 13694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13694,
        GIR_EraseRootFromParent_Done,
      // Label 14294: @966120
      GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(966197), // Rule ID 13695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13695,
        GIR_EraseRootFromParent_Done,
      // Label 14295: @966197
      GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(966292), // Rule ID 18908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18908,
        GIR_EraseRootFromParent_Done,
      // Label 14296: @966292
      GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(966387), // Rule ID 18909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18909,
        GIR_EraseRootFromParent_Done,
      // Label 14297: @966387
      GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(966482), // Rule ID 18912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18912,
        GIR_EraseRootFromParent_Done,
      // Label 14298: @966482
      GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(966577), // Rule ID 18913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18913,
        GIR_EraseRootFromParent_Done,
      // Label 14299: @966577
      GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(966672), // Rule ID 18916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18916,
        GIR_EraseRootFromParent_Done,
      // Label 14300: @966672
      GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(966767), // Rule ID 18917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10869:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18917,
        GIR_EraseRootFromParent_Done,
      // Label 14301: @966767
      GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(966862), // Rule ID 18920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18920,
        GIR_EraseRootFromParent_Done,
      // Label 14302: @966862
      GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(966957), // Rule ID 18921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10869:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18921,
        GIR_EraseRootFromParent_Done,
      // Label 14303: @966957
      GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(967052), // Rule ID 18924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18924,
        GIR_EraseRootFromParent_Done,
      // Label 14304: @967052
      GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(967147), // Rule ID 18925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10869:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18925,
        GIR_EraseRootFromParent_Done,
      // Label 14305: @967147
      GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(967242), // Rule ID 18928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18928,
        GIR_EraseRootFromParent_Done,
      // Label 14306: @967242
      GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(967337), // Rule ID 18929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18929,
        GIR_EraseRootFromParent_Done,
      // Label 14307: @967337
      GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(967432), // Rule ID 18932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18932,
        GIR_EraseRootFromParent_Done,
      // Label 14308: @967432
      GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(967527), // Rule ID 18933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18933,
        GIR_EraseRootFromParent_Done,
      // Label 14309: @967527
      GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(967622), // Rule ID 18936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18936,
        GIR_EraseRootFromParent_Done,
      // Label 14310: @967622
      GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(967717), // Rule ID 18937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18937,
        GIR_EraseRootFromParent_Done,
      // Label 14311: @967717
      GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(967812), // Rule ID 18940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18940,
        GIR_EraseRootFromParent_Done,
      // Label 14312: @967812
      GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(967907), // Rule ID 18941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18941,
        GIR_EraseRootFromParent_Done,
      // Label 14313: @967907
      GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(968002), // Rule ID 18944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18944,
        GIR_EraseRootFromParent_Done,
      // Label 14314: @968002
      GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(968097), // Rule ID 18945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18945,
        GIR_EraseRootFromParent_Done,
      // Label 14315: @968097
      GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(968192), // Rule ID 18948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18948,
        GIR_EraseRootFromParent_Done,
      // Label 14316: @968192
      GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(968287), // Rule ID 18949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18949,
        GIR_EraseRootFromParent_Done,
      // Label 14317: @968287
      GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(968382), // Rule ID 18952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18952,
        GIR_EraseRootFromParent_Done,
      // Label 14318: @968382
      GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(968477), // Rule ID 18953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10869:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18953,
        GIR_EraseRootFromParent_Done,
      // Label 14319: @968477
      GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(968572), // Rule ID 18956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18956,
        GIR_EraseRootFromParent_Done,
      // Label 14320: @968572
      GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(968667), // Rule ID 18957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10869:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18957,
        GIR_EraseRootFromParent_Done,
      // Label 14321: @968667
      GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(968762), // Rule ID 18960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18960,
        GIR_EraseRootFromParent_Done,
      // Label 14322: @968762
      GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(968857), // Rule ID 18961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10869:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18961,
        GIR_EraseRootFromParent_Done,
      // Label 14323: @968857
      GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(968952), // Rule ID 20344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10795:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20344,
        GIR_EraseRootFromParent_Done,
      // Label 14324: @968952
      GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(969047), // Rule ID 20345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10795:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20345,
        GIR_EraseRootFromParent_Done,
      // Label 14325: @969047
      GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(969142), // Rule ID 20348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10795:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20348,
        GIR_EraseRootFromParent_Done,
      // Label 14326: @969142
      GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(969237), // Rule ID 20349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10795:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20349,
        GIR_EraseRootFromParent_Done,
      // Label 14327: @969237
      GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(969332), // Rule ID 20352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10795:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20352,
        GIR_EraseRootFromParent_Done,
      // Label 14328: @969332
      GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(969427), // Rule ID 20353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10795:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20353,
        GIR_EraseRootFromParent_Done,
      // Label 14329: @969427
      GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(969522), // Rule ID 20356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10795:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20356,
        GIR_EraseRootFromParent_Done,
      // Label 14330: @969522
      GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(969617), // Rule ID 20357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10795:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20357,
        GIR_EraseRootFromParent_Done,
      // Label 14331: @969617
      GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(969712), // Rule ID 20360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10795:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20360,
        GIR_EraseRootFromParent_Done,
      // Label 14332: @969712
      GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(969807), // Rule ID 20361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10795:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20361,
        GIR_EraseRootFromParent_Done,
      // Label 14333: @969807
      GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(969902), // Rule ID 20364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10795:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20364,
        GIR_EraseRootFromParent_Done,
      // Label 14334: @969902
      GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(969997), // Rule ID 20365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10795:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20365,
        GIR_EraseRootFromParent_Done,
      // Label 14335: @969997
      GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(970092), // Rule ID 20368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10795:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20368,
        GIR_EraseRootFromParent_Done,
      // Label 14336: @970092
      GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(970187), // Rule ID 20369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10795:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20369,
        GIR_EraseRootFromParent_Done,
      // Label 14337: @970187
      GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(970282), // Rule ID 20372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10795:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20372,
        GIR_EraseRootFromParent_Done,
      // Label 14338: @970282
      GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(970377), // Rule ID 20373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10795:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20373,
        GIR_EraseRootFromParent_Done,
      // Label 14339: @970377
      GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(970472), // Rule ID 20376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10795:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20376,
        GIR_EraseRootFromParent_Done,
      // Label 14340: @970472
      GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(970567), // Rule ID 20377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10795:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20377,
        GIR_EraseRootFromParent_Done,
      // Label 14341: @970567
      GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(970662), // Rule ID 20380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10795:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20380,
        GIR_EraseRootFromParent_Done,
      // Label 14342: @970662
      GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(970757), // Rule ID 20381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10795:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20381,
        GIR_EraseRootFromParent_Done,
      // Label 14343: @970757
      GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(970852), // Rule ID 20384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10795:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20384,
        GIR_EraseRootFromParent_Done,
      // Label 14344: @970852
      GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(970947), // Rule ID 20385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10795:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20385,
        GIR_EraseRootFromParent_Done,
      // Label 14345: @970947
      GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(971042), // Rule ID 20388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10795:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20388,
        GIR_EraseRootFromParent_Done,
      // Label 14346: @971042
      GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(971137), // Rule ID 20389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10795:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20389,
        GIR_EraseRootFromParent_Done,
      // Label 14347: @971137
      GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(971232), // Rule ID 20392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10795:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20392,
        GIR_EraseRootFromParent_Done,
      // Label 14348: @971232
      GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(971327), // Rule ID 20393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10795:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20393,
        GIR_EraseRootFromParent_Done,
      // Label 14349: @971327
      GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(971422), // Rule ID 20396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10795:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20396,
        GIR_EraseRootFromParent_Done,
      // Label 14350: @971422
      GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(971517), // Rule ID 20397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10795:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20397,
        GIR_EraseRootFromParent_Done,
      // Label 14351: @971517
      GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(971612), // Rule ID 20722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10803:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20722,
        GIR_EraseRootFromParent_Done,
      // Label 14352: @971612
      GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(971707), // Rule ID 20723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10803:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20723,
        GIR_EraseRootFromParent_Done,
      // Label 14353: @971707
      GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(971802), // Rule ID 20726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10803:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20726,
        GIR_EraseRootFromParent_Done,
      // Label 14354: @971802
      GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(971897), // Rule ID 20727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10803:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20727,
        GIR_EraseRootFromParent_Done,
      // Label 14355: @971897
      GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(971992), // Rule ID 20730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10803:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20730,
        GIR_EraseRootFromParent_Done,
      // Label 14356: @971992
      GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(972087), // Rule ID 20731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10803:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20731,
        GIR_EraseRootFromParent_Done,
      // Label 14357: @972087
      GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(972182), // Rule ID 20734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10803:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20734,
        GIR_EraseRootFromParent_Done,
      // Label 14358: @972182
      GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(972277), // Rule ID 20735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10803:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20735,
        GIR_EraseRootFromParent_Done,
      // Label 14359: @972277
      GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(972372), // Rule ID 20738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10803:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20738,
        GIR_EraseRootFromParent_Done,
      // Label 14360: @972372
      GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(972467), // Rule ID 20739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10803:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20739,
        GIR_EraseRootFromParent_Done,
      // Label 14361: @972467
      GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(972562), // Rule ID 20742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10803:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20742,
        GIR_EraseRootFromParent_Done,
      // Label 14362: @972562
      GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(972657), // Rule ID 20743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10803:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20743,
        GIR_EraseRootFromParent_Done,
      // Label 14363: @972657
      GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(972752), // Rule ID 20746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10803:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20746,
        GIR_EraseRootFromParent_Done,
      // Label 14364: @972752
      GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(972847), // Rule ID 20747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10803:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20747,
        GIR_EraseRootFromParent_Done,
      // Label 14365: @972847
      GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(972942), // Rule ID 20750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10803:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20750,
        GIR_EraseRootFromParent_Done,
      // Label 14366: @972942
      GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(973037), // Rule ID 20751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10803:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20751,
        GIR_EraseRootFromParent_Done,
      // Label 14367: @973037
      GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(973132), // Rule ID 20754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10803:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20754,
        GIR_EraseRootFromParent_Done,
      // Label 14368: @973132
      GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(973227), // Rule ID 20755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10803:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20755,
        GIR_EraseRootFromParent_Done,
      // Label 14369: @973227
      GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(973322), // Rule ID 20758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10803:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20758,
        GIR_EraseRootFromParent_Done,
      // Label 14370: @973322
      GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(973417), // Rule ID 20759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10803:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20759,
        GIR_EraseRootFromParent_Done,
      // Label 14371: @973417
      GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(973512), // Rule ID 20762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10803:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20762,
        GIR_EraseRootFromParent_Done,
      // Label 14372: @973512
      GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(973607), // Rule ID 20763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10803:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20763,
        GIR_EraseRootFromParent_Done,
      // Label 14373: @973607
      GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(973702), // Rule ID 20766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10803:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20766,
        GIR_EraseRootFromParent_Done,
      // Label 14374: @973702
      GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(973797), // Rule ID 20767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10803:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20767,
        GIR_EraseRootFromParent_Done,
      // Label 14375: @973797
      GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(973892), // Rule ID 20770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10803:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20770,
        GIR_EraseRootFromParent_Done,
      // Label 14376: @973892
      GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(973987), // Rule ID 20771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10803:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20771,
        GIR_EraseRootFromParent_Done,
      // Label 14377: @973987
      GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(974082), // Rule ID 20774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10803:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20774,
        GIR_EraseRootFromParent_Done,
      // Label 14378: @974082
      GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(974177), // Rule ID 20775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10803:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20775,
        GIR_EraseRootFromParent_Done,
      // Label 14379: @974177
      GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(974272), // Rule ID 20778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10803:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20778,
        GIR_EraseRootFromParent_Done,
      // Label 14380: @974272
      GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(974367), // Rule ID 20779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10803:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20779,
        GIR_EraseRootFromParent_Done,
      // Label 14381: @974367
      GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(974462), // Rule ID 20782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10801:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20782,
        GIR_EraseRootFromParent_Done,
      // Label 14382: @974462
      GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(974557), // Rule ID 20783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10801:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20783,
        GIR_EraseRootFromParent_Done,
      // Label 14383: @974557
      GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(974652), // Rule ID 20786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10801:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20786,
        GIR_EraseRootFromParent_Done,
      // Label 14384: @974652
      GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(974747), // Rule ID 20787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10801:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20787,
        GIR_EraseRootFromParent_Done,
      // Label 14385: @974747
      GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(974842), // Rule ID 20790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10801:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20790,
        GIR_EraseRootFromParent_Done,
      // Label 14386: @974842
      GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(974937), // Rule ID 20791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10801:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20791,
        GIR_EraseRootFromParent_Done,
      // Label 14387: @974937
      GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(975032), // Rule ID 20794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10801:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20794,
        GIR_EraseRootFromParent_Done,
      // Label 14388: @975032
      GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(975127), // Rule ID 20795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10801:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20795,
        GIR_EraseRootFromParent_Done,
      // Label 14389: @975127
      GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(975222), // Rule ID 20798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10801:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20798,
        GIR_EraseRootFromParent_Done,
      // Label 14390: @975222
      GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(975317), // Rule ID 20799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10801:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20799,
        GIR_EraseRootFromParent_Done,
      // Label 14391: @975317
      GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(975412), // Rule ID 20802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10801:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20802,
        GIR_EraseRootFromParent_Done,
      // Label 14392: @975412
      GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(975507), // Rule ID 20803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10801:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20803,
        GIR_EraseRootFromParent_Done,
      // Label 14393: @975507
      GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(975602), // Rule ID 20806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10801:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20806,
        GIR_EraseRootFromParent_Done,
      // Label 14394: @975602
      GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(975697), // Rule ID 20807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10801:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20807,
        GIR_EraseRootFromParent_Done,
      // Label 14395: @975697
      GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(975792), // Rule ID 20810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10801:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20810,
        GIR_EraseRootFromParent_Done,
      // Label 14396: @975792
      GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(975887), // Rule ID 20811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10801:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20811,
        GIR_EraseRootFromParent_Done,
      // Label 14397: @975887
      GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(975982), // Rule ID 20814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10801:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20814,
        GIR_EraseRootFromParent_Done,
      // Label 14398: @975982
      GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(976077), // Rule ID 20815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10801:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20815,
        GIR_EraseRootFromParent_Done,
      // Label 14399: @976077
      GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(976172), // Rule ID 20818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10801:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20818,
        GIR_EraseRootFromParent_Done,
      // Label 14400: @976172
      GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(976267), // Rule ID 20819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10801:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20819,
        GIR_EraseRootFromParent_Done,
      // Label 14401: @976267
      GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(976362), // Rule ID 20822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10801:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20822,
        GIR_EraseRootFromParent_Done,
      // Label 14402: @976362
      GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(976457), // Rule ID 20823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10801:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20823,
        GIR_EraseRootFromParent_Done,
      // Label 14403: @976457
      GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(976552), // Rule ID 20826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10801:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20826,
        GIR_EraseRootFromParent_Done,
      // Label 14404: @976552
      GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(976647), // Rule ID 20827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10801:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20827,
        GIR_EraseRootFromParent_Done,
      // Label 14405: @976647
      GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(976742), // Rule ID 20830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10801:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20830,
        GIR_EraseRootFromParent_Done,
      // Label 14406: @976742
      GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(976837), // Rule ID 20831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10801:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20831,
        GIR_EraseRootFromParent_Done,
      // Label 14407: @976837
      GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(976932), // Rule ID 20834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10801:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20834,
        GIR_EraseRootFromParent_Done,
      // Label 14408: @976932
      GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(977027), // Rule ID 20835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10801:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20835,
        GIR_EraseRootFromParent_Done,
      // Label 14409: @977027
      GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(977122), // Rule ID 20838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10801:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20838,
        GIR_EraseRootFromParent_Done,
      // Label 14410: @977122
      GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(977217), // Rule ID 20839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10801:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20839,
        GIR_EraseRootFromParent_Done,
      // Label 14411: @977217
      GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(977312), // Rule ID 21106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21106,
        GIR_EraseRootFromParent_Done,
      // Label 14412: @977312
      GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(977407), // Rule ID 21107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21107,
        GIR_EraseRootFromParent_Done,
      // Label 14413: @977407
      GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(977502), // Rule ID 21110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21110,
        GIR_EraseRootFromParent_Done,
      // Label 14414: @977502
      GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(977597), // Rule ID 21111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10899:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21111,
        GIR_EraseRootFromParent_Done,
      // Label 14415: @977597
      GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(977692), // Rule ID 21114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21114,
        GIR_EraseRootFromParent_Done,
      // Label 14416: @977692
      GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(977787), // Rule ID 21115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21115,
        GIR_EraseRootFromParent_Done,
      // Label 14417: @977787
      GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(977882), // Rule ID 21118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21118,
        GIR_EraseRootFromParent_Done,
      // Label 14418: @977882
      GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(977977), // Rule ID 21119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21119,
        GIR_EraseRootFromParent_Done,
      // Label 14419: @977977
      GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(978072), // Rule ID 21122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21122,
        GIR_EraseRootFromParent_Done,
      // Label 14420: @978072
      GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(978167), // Rule ID 21123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21123,
        GIR_EraseRootFromParent_Done,
      // Label 14421: @978167
      GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(978262), // Rule ID 21126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21126,
        GIR_EraseRootFromParent_Done,
      // Label 14422: @978262
      GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(978357), // Rule ID 21127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10899:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21127,
        GIR_EraseRootFromParent_Done,
      // Label 14423: @978357
      GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(978452), // Rule ID 21130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21130,
        GIR_EraseRootFromParent_Done,
      // Label 14424: @978452
      GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(978547), // Rule ID 21131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10899:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21131,
        GIR_EraseRootFromParent_Done,
      // Label 14425: @978547
      GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(978642), // Rule ID 21134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21134,
        GIR_EraseRootFromParent_Done,
      // Label 14426: @978642
      GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(978737), // Rule ID 21135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10899:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21135,
        GIR_EraseRootFromParent_Done,
      // Label 14427: @978737
      GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(978832), // Rule ID 21138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21138,
        GIR_EraseRootFromParent_Done,
      // Label 14428: @978832
      GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(978927), // Rule ID 21139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10899:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21139,
        GIR_EraseRootFromParent_Done,
      // Label 14429: @978927
      GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(979022), // Rule ID 21142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21142,
        GIR_EraseRootFromParent_Done,
      // Label 14430: @979022
      GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(979117), // Rule ID 21143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21143,
        GIR_EraseRootFromParent_Done,
      // Label 14431: @979117
      GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(979212), // Rule ID 21146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21146,
        GIR_EraseRootFromParent_Done,
      // Label 14432: @979212
      GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(979307), // Rule ID 21147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10897:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21147,
        GIR_EraseRootFromParent_Done,
      // Label 14433: @979307
      GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(979402), // Rule ID 21150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21150,
        GIR_EraseRootFromParent_Done,
      // Label 14434: @979402
      GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(979497), // Rule ID 21151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21151,
        GIR_EraseRootFromParent_Done,
      // Label 14435: @979497
      GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(979592), // Rule ID 21154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21154,
        GIR_EraseRootFromParent_Done,
      // Label 14436: @979592
      GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(979687), // Rule ID 21155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21155,
        GIR_EraseRootFromParent_Done,
      // Label 14437: @979687
      GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(979782), // Rule ID 21158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21158,
        GIR_EraseRootFromParent_Done,
      // Label 14438: @979782
      GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(979877), // Rule ID 21159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21159,
        GIR_EraseRootFromParent_Done,
      // Label 14439: @979877
      GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(979972), // Rule ID 21162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21162,
        GIR_EraseRootFromParent_Done,
      // Label 14440: @979972
      GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(980067), // Rule ID 21163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10897:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21163,
        GIR_EraseRootFromParent_Done,
      // Label 14441: @980067
      GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(980162), // Rule ID 21166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21166,
        GIR_EraseRootFromParent_Done,
      // Label 14442: @980162
      GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(980257), // Rule ID 21167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10897:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21167,
        GIR_EraseRootFromParent_Done,
      // Label 14443: @980257
      GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(980352), // Rule ID 21170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21170,
        GIR_EraseRootFromParent_Done,
      // Label 14444: @980352
      GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(980447), // Rule ID 21171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10897:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21171,
        GIR_EraseRootFromParent_Done,
      // Label 14445: @980447
      GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(980542), // Rule ID 21174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21174,
        GIR_EraseRootFromParent_Done,
      // Label 14446: @980542
      GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(980637), // Rule ID 21175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10897:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21175,
        GIR_EraseRootFromParent_Done,
      // Label 14447: @980637
      GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(980732), // Rule ID 21178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10895:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21178,
        GIR_EraseRootFromParent_Done,
      // Label 14448: @980732
      GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(980827), // Rule ID 21179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10895:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21179,
        GIR_EraseRootFromParent_Done,
      // Label 14449: @980827
      GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(980922), // Rule ID 21182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10895:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21182,
        GIR_EraseRootFromParent_Done,
      // Label 14450: @980922
      GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(981017), // Rule ID 21183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10895:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21183,
        GIR_EraseRootFromParent_Done,
      // Label 14451: @981017
      GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(981112), // Rule ID 21186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10895:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21186,
        GIR_EraseRootFromParent_Done,
      // Label 14452: @981112
      GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(981207), // Rule ID 21187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10895:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21187,
        GIR_EraseRootFromParent_Done,
      // Label 14453: @981207
      GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(981302), // Rule ID 21190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10895:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21190,
        GIR_EraseRootFromParent_Done,
      // Label 14454: @981302
      GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(981397), // Rule ID 21191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10895:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21191,
        GIR_EraseRootFromParent_Done,
      // Label 14455: @981397
      GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(981492), // Rule ID 21194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10895:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21194,
        GIR_EraseRootFromParent_Done,
      // Label 14456: @981492
      GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(981587), // Rule ID 21195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10895:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21195,
        GIR_EraseRootFromParent_Done,
      // Label 14457: @981587
      GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(981682), // Rule ID 21198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10895:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21198,
        GIR_EraseRootFromParent_Done,
      // Label 14458: @981682
      GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(981777), // Rule ID 21199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10895:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21199,
        GIR_EraseRootFromParent_Done,
      // Label 14459: @981777
      GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(981872), // Rule ID 21202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21202,
        GIR_EraseRootFromParent_Done,
      // Label 14460: @981872
      GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(981967), // Rule ID 21203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21203,
        GIR_EraseRootFromParent_Done,
      // Label 14461: @981967
      GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(982062), // Rule ID 21206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21206,
        GIR_EraseRootFromParent_Done,
      // Label 14462: @982062
      GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(982157), // Rule ID 21207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10895:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21207,
        GIR_EraseRootFromParent_Done,
      // Label 14463: @982157
      GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(982252), // Rule ID 21210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10895:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21210,
        GIR_EraseRootFromParent_Done,
      // Label 14464: @982252
      GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(982347), // Rule ID 21211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10895:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21211,
        GIR_EraseRootFromParent_Done,
      // Label 14465: @982347
      GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(982442), // Rule ID 21214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10895:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21214,
        GIR_EraseRootFromParent_Done,
      // Label 14466: @982442
      GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(982537), // Rule ID 21215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10895:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21215,
        GIR_EraseRootFromParent_Done,
      // Label 14467: @982537
      GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(982632), // Rule ID 21218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10895:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21218,
        GIR_EraseRootFromParent_Done,
      // Label 14468: @982632
      GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(982727), // Rule ID 21219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10895:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21219,
        GIR_EraseRootFromParent_Done,
      // Label 14469: @982727
      GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(982822), // Rule ID 21222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21222,
        GIR_EraseRootFromParent_Done,
      // Label 14470: @982822
      GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(982917), // Rule ID 21223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10895:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21223,
        GIR_EraseRootFromParent_Done,
      // Label 14471: @982917
      GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(983012), // Rule ID 21226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10895:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21226,
        GIR_EraseRootFromParent_Done,
      // Label 14472: @983012
      GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(983107), // Rule ID 21227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10895:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21227,
        GIR_EraseRootFromParent_Done,
      // Label 14473: @983107
      GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(983202), // Rule ID 21230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10895:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21230,
        GIR_EraseRootFromParent_Done,
      // Label 14474: @983202
      GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(983297), // Rule ID 21231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10895:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21231,
        GIR_EraseRootFromParent_Done,
      // Label 14475: @983297
      GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(983392), // Rule ID 21234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10895:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21234,
        GIR_EraseRootFromParent_Done,
      // Label 14476: @983392
      GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(983487), // Rule ID 21235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10895:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21235,
        GIR_EraseRootFromParent_Done,
      // Label 14477: @983487
      GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(983582), // Rule ID 21238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21238,
        GIR_EraseRootFromParent_Done,
      // Label 14478: @983582
      GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(983677), // Rule ID 21239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21239,
        GIR_EraseRootFromParent_Done,
      // Label 14479: @983677
      GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(983772), // Rule ID 21242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21242,
        GIR_EraseRootFromParent_Done,
      // Label 14480: @983772
      GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(983867), // Rule ID 21243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21243,
        GIR_EraseRootFromParent_Done,
      // Label 14481: @983867
      GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(983962), // Rule ID 21246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21246,
        GIR_EraseRootFromParent_Done,
      // Label 14482: @983962
      GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(984057), // Rule ID 21247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10893:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21247,
        GIR_EraseRootFromParent_Done,
      // Label 14483: @984057
      GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(984152), // Rule ID 21250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21250,
        GIR_EraseRootFromParent_Done,
      // Label 14484: @984152
      GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(984247), // Rule ID 21251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21251,
        GIR_EraseRootFromParent_Done,
      // Label 14485: @984247
      GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(984342), // Rule ID 21254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21254,
        GIR_EraseRootFromParent_Done,
      // Label 14486: @984342
      GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(984437), // Rule ID 21255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21255,
        GIR_EraseRootFromParent_Done,
      // Label 14487: @984437
      GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(984532), // Rule ID 21258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21258,
        GIR_EraseRootFromParent_Done,
      // Label 14488: @984532
      GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(984627), // Rule ID 21259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21259,
        GIR_EraseRootFromParent_Done,
      // Label 14489: @984627
      GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(984722), // Rule ID 21262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21262,
        GIR_EraseRootFromParent_Done,
      // Label 14490: @984722
      GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(984817), // Rule ID 21263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21263,
        GIR_EraseRootFromParent_Done,
      // Label 14491: @984817
      GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(984912), // Rule ID 21266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21266,
        GIR_EraseRootFromParent_Done,
      // Label 14492: @984912
      GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(985007), // Rule ID 21267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10893:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21267,
        GIR_EraseRootFromParent_Done,
      // Label 14493: @985007
      GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(985102), // Rule ID 21270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21270,
        GIR_EraseRootFromParent_Done,
      // Label 14494: @985102
      GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(985197), // Rule ID 21271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21271,
        GIR_EraseRootFromParent_Done,
      // Label 14495: @985197
      GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(985292), // Rule ID 21274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21274,
        GIR_EraseRootFromParent_Done,
      // Label 14496: @985292
      GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(985387), // Rule ID 21275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21275,
        GIR_EraseRootFromParent_Done,
      // Label 14497: @985387
      GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(985482), // Rule ID 21278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21278,
        GIR_EraseRootFromParent_Done,
      // Label 14498: @985482
      GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(985577), // Rule ID 21279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21279,
        GIR_EraseRootFromParent_Done,
      // Label 14499: @985577
      GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(985672), // Rule ID 21282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21282,
        GIR_EraseRootFromParent_Done,
      // Label 14500: @985672
      GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(985767), // Rule ID 21283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10893:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21283,
        GIR_EraseRootFromParent_Done,
      // Label 14501: @985767
      GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(985862), // Rule ID 21286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21286,
        GIR_EraseRootFromParent_Done,
      // Label 14502: @985862
      GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(985957), // Rule ID 21287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10893:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21287,
        GIR_EraseRootFromParent_Done,
      // Label 14503: @985957
      GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(986052), // Rule ID 21290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21290,
        GIR_EraseRootFromParent_Done,
      // Label 14504: @986052
      GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(986147), // Rule ID 21291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10893:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21291,
        GIR_EraseRootFromParent_Done,
      // Label 14505: @986147
      GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(986242), // Rule ID 21294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21294,
        GIR_EraseRootFromParent_Done,
      // Label 14506: @986242
      GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(986337), // Rule ID 21295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10893:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21295,
        GIR_EraseRootFromParent_Done,
      // Label 14507: @986337
      GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(986432), // Rule ID 21298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21298,
        GIR_EraseRootFromParent_Done,
      // Label 14508: @986432
      GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(986527), // Rule ID 21299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21299,
        GIR_EraseRootFromParent_Done,
      // Label 14509: @986527
      GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(986622), // Rule ID 21302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21302,
        GIR_EraseRootFromParent_Done,
      // Label 14510: @986622
      GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(986717), // Rule ID 21303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10891:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21303,
        GIR_EraseRootFromParent_Done,
      // Label 14511: @986717
      GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(986812), // Rule ID 21306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21306,
        GIR_EraseRootFromParent_Done,
      // Label 14512: @986812
      GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(986907), // Rule ID 21307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21307,
        GIR_EraseRootFromParent_Done,
      // Label 14513: @986907
      GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(987002), // Rule ID 21310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21310,
        GIR_EraseRootFromParent_Done,
      // Label 14514: @987002
      GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(987097), // Rule ID 21311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21311,
        GIR_EraseRootFromParent_Done,
      // Label 14515: @987097
      GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(987192), // Rule ID 21314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21314,
        GIR_EraseRootFromParent_Done,
      // Label 14516: @987192
      GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(987287), // Rule ID 21315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21315,
        GIR_EraseRootFromParent_Done,
      // Label 14517: @987287
      GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(987382), // Rule ID 21318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21318,
        GIR_EraseRootFromParent_Done,
      // Label 14518: @987382
      GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(987477), // Rule ID 21319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10891:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21319,
        GIR_EraseRootFromParent_Done,
      // Label 14519: @987477
      GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(987572), // Rule ID 21322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21322,
        GIR_EraseRootFromParent_Done,
      // Label 14520: @987572
      GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(987667), // Rule ID 21323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10891:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21323,
        GIR_EraseRootFromParent_Done,
      // Label 14521: @987667
      GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(987762), // Rule ID 21326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21326,
        GIR_EraseRootFromParent_Done,
      // Label 14522: @987762
      GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(987857), // Rule ID 21327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10891:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21327,
        GIR_EraseRootFromParent_Done,
      // Label 14523: @987857
      GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(987952), // Rule ID 21330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21330,
        GIR_EraseRootFromParent_Done,
      // Label 14524: @987952
      GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(988047), // Rule ID 21331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10891:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21331,
        GIR_EraseRootFromParent_Done,
      // Label 14525: @988047
      GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(988142), // Rule ID 21574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10841:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21574,
        GIR_EraseRootFromParent_Done,
      // Label 14526: @988142
      GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(988237), // Rule ID 21575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10841:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21575,
        GIR_EraseRootFromParent_Done,
      // Label 14527: @988237
      GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(988332), // Rule ID 21578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10841:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21578,
        GIR_EraseRootFromParent_Done,
      // Label 14528: @988332
      GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(988427), // Rule ID 21579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10841:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21579,
        GIR_EraseRootFromParent_Done,
      // Label 14529: @988427
      GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(988522), // Rule ID 21582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10841:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21582,
        GIR_EraseRootFromParent_Done,
      // Label 14530: @988522
      GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(988617), // Rule ID 21583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10841:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21583,
        GIR_EraseRootFromParent_Done,
      // Label 14531: @988617
      GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(988712), // Rule ID 21586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10841:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21586,
        GIR_EraseRootFromParent_Done,
      // Label 14532: @988712
      GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(988807), // Rule ID 21587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10841:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21587,
        GIR_EraseRootFromParent_Done,
      // Label 14533: @988807
      GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(988902), // Rule ID 21590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10841:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21590,
        GIR_EraseRootFromParent_Done,
      // Label 14534: @988902
      GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(988997), // Rule ID 21591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10841:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21591,
        GIR_EraseRootFromParent_Done,
      // Label 14535: @988997
      GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(989092), // Rule ID 21594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10841:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21594,
        GIR_EraseRootFromParent_Done,
      // Label 14536: @989092
      GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(989187), // Rule ID 21595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10841:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21595,
        GIR_EraseRootFromParent_Done,
      // Label 14537: @989187
      GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(989282), // Rule ID 21598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10841:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21598,
        GIR_EraseRootFromParent_Done,
      // Label 14538: @989282
      GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(989377), // Rule ID 21599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10841:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21599,
        GIR_EraseRootFromParent_Done,
      // Label 14539: @989377
      GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(989472), // Rule ID 21602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10841:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21602,
        GIR_EraseRootFromParent_Done,
      // Label 14540: @989472
      GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(989567), // Rule ID 21603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10841:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21603,
        GIR_EraseRootFromParent_Done,
      // Label 14541: @989567
      GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(989662), // Rule ID 21606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10841:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21606,
        GIR_EraseRootFromParent_Done,
      // Label 14542: @989662
      GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(989757), // Rule ID 21607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10841:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21607,
        GIR_EraseRootFromParent_Done,
      // Label 14543: @989757
      GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(989852), // Rule ID 21610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10841:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21610,
        GIR_EraseRootFromParent_Done,
      // Label 14544: @989852
      GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(989947), // Rule ID 21611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10841:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21611,
        GIR_EraseRootFromParent_Done,
      // Label 14545: @989947
      GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(990042), // Rule ID 21614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10841:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21614,
        GIR_EraseRootFromParent_Done,
      // Label 14546: @990042
      GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(990137), // Rule ID 21615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10841:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21615,
        GIR_EraseRootFromParent_Done,
      // Label 14547: @990137
      GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(990232), // Rule ID 21618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10841:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21618,
        GIR_EraseRootFromParent_Done,
      // Label 14548: @990232
      GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(990327), // Rule ID 21619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10841:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21619,
        GIR_EraseRootFromParent_Done,
      // Label 14549: @990327
      GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(990422), // Rule ID 21622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10841:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21622,
        GIR_EraseRootFromParent_Done,
      // Label 14550: @990422
      GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(990517), // Rule ID 21623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10841:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21623,
        GIR_EraseRootFromParent_Done,
      // Label 14551: @990517
      GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(990612), // Rule ID 21626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10841:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21626,
        GIR_EraseRootFromParent_Done,
      // Label 14552: @990612
      GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(990707), // Rule ID 21627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10841:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21627,
        GIR_EraseRootFromParent_Done,
      // Label 14553: @990707
      GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(990802), // Rule ID 21630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10841:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21630,
        GIR_EraseRootFromParent_Done,
      // Label 14554: @990802
      GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(990897), // Rule ID 21631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10841:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21631,
        GIR_EraseRootFromParent_Done,
      // Label 14555: @990897
      GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(990992), // Rule ID 21634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10839:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21634,
        GIR_EraseRootFromParent_Done,
      // Label 14556: @990992
      GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(991087), // Rule ID 21635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10839:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21635,
        GIR_EraseRootFromParent_Done,
      // Label 14557: @991087
      GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(991182), // Rule ID 21638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10839:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21638,
        GIR_EraseRootFromParent_Done,
      // Label 14558: @991182
      GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(991277), // Rule ID 21639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10839:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21639,
        GIR_EraseRootFromParent_Done,
      // Label 14559: @991277
      GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(991372), // Rule ID 21642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10839:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21642,
        GIR_EraseRootFromParent_Done,
      // Label 14560: @991372
      GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(991467), // Rule ID 21643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10839:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21643,
        GIR_EraseRootFromParent_Done,
      // Label 14561: @991467
      GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(991562), // Rule ID 21646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10839:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21646,
        GIR_EraseRootFromParent_Done,
      // Label 14562: @991562
      GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(991657), // Rule ID 21647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10839:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21647,
        GIR_EraseRootFromParent_Done,
      // Label 14563: @991657
      GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(991752), // Rule ID 21650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10839:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21650,
        GIR_EraseRootFromParent_Done,
      // Label 14564: @991752
      GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(991847), // Rule ID 21651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10839:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21651,
        GIR_EraseRootFromParent_Done,
      // Label 14565: @991847
      GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(991942), // Rule ID 21654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10839:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21654,
        GIR_EraseRootFromParent_Done,
      // Label 14566: @991942
      GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(992037), // Rule ID 21655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10839:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21655,
        GIR_EraseRootFromParent_Done,
      // Label 14567: @992037
      GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(992132), // Rule ID 21658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10839:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21658,
        GIR_EraseRootFromParent_Done,
      // Label 14568: @992132
      GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(992227), // Rule ID 21659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10839:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21659,
        GIR_EraseRootFromParent_Done,
      // Label 14569: @992227
      GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(992322), // Rule ID 21662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10839:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21662,
        GIR_EraseRootFromParent_Done,
      // Label 14570: @992322
      GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(992417), // Rule ID 21663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10839:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21663,
        GIR_EraseRootFromParent_Done,
      // Label 14571: @992417
      GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(992512), // Rule ID 21666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10839:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21666,
        GIR_EraseRootFromParent_Done,
      // Label 14572: @992512
      GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(992607), // Rule ID 21667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10839:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21667,
        GIR_EraseRootFromParent_Done,
      // Label 14573: @992607
      GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(992702), // Rule ID 21670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10839:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21670,
        GIR_EraseRootFromParent_Done,
      // Label 14574: @992702
      GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(992797), // Rule ID 21671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10839:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21671,
        GIR_EraseRootFromParent_Done,
      // Label 14575: @992797
      GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(992892), // Rule ID 21674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10839:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21674,
        GIR_EraseRootFromParent_Done,
      // Label 14576: @992892
      GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(992987), // Rule ID 21675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10839:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21675,
        GIR_EraseRootFromParent_Done,
      // Label 14577: @992987
      GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(993082), // Rule ID 21678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10839:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21678,
        GIR_EraseRootFromParent_Done,
      // Label 14578: @993082
      GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(993177), // Rule ID 21679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10839:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21679,
        GIR_EraseRootFromParent_Done,
      // Label 14579: @993177
      GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(993272), // Rule ID 21682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10839:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21682,
        GIR_EraseRootFromParent_Done,
      // Label 14580: @993272
      GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(993367), // Rule ID 21683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10839:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21683,
        GIR_EraseRootFromParent_Done,
      // Label 14581: @993367
      GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(993462), // Rule ID 21686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10839:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21686,
        GIR_EraseRootFromParent_Done,
      // Label 14582: @993462
      GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(993557), // Rule ID 21687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10839:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21687,
        GIR_EraseRootFromParent_Done,
      // Label 14583: @993557
      GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(993652), // Rule ID 21690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10839:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21690,
        GIR_EraseRootFromParent_Done,
      // Label 14584: @993652
      GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(993747), // Rule ID 21691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10839:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21691,
        GIR_EraseRootFromParent_Done,
      // Label 14585: @993747
      GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(993842), // Rule ID 21802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10837:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21802,
        GIR_EraseRootFromParent_Done,
      // Label 14586: @993842
      GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(993937), // Rule ID 21803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10837:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21803,
        GIR_EraseRootFromParent_Done,
      // Label 14587: @993937
      GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(994032), // Rule ID 21806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10837:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21806,
        GIR_EraseRootFromParent_Done,
      // Label 14588: @994032
      GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(994127), // Rule ID 21807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10837:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21807,
        GIR_EraseRootFromParent_Done,
      // Label 14589: @994127
      GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(994222), // Rule ID 21810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10837:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21810,
        GIR_EraseRootFromParent_Done,
      // Label 14590: @994222
      GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(994317), // Rule ID 21811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10837:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21811,
        GIR_EraseRootFromParent_Done,
      // Label 14591: @994317
      GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(994412), // Rule ID 21814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10837:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21814,
        GIR_EraseRootFromParent_Done,
      // Label 14592: @994412
      GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(994507), // Rule ID 21815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10837:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21815,
        GIR_EraseRootFromParent_Done,
      // Label 14593: @994507
      GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(994602), // Rule ID 21818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10837:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21818,
        GIR_EraseRootFromParent_Done,
      // Label 14594: @994602
      GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(994697), // Rule ID 21819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10837:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21819,
        GIR_EraseRootFromParent_Done,
      // Label 14595: @994697
      GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(994792), // Rule ID 21822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10837:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21822,
        GIR_EraseRootFromParent_Done,
      // Label 14596: @994792
      GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(994887), // Rule ID 21823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10837:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21823,
        GIR_EraseRootFromParent_Done,
      // Label 14597: @994887
      GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(994982), // Rule ID 21826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10837:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21826,
        GIR_EraseRootFromParent_Done,
      // Label 14598: @994982
      GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(995077), // Rule ID 21827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10837:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21827,
        GIR_EraseRootFromParent_Done,
      // Label 14599: @995077
      GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(995172), // Rule ID 21830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10837:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21830,
        GIR_EraseRootFromParent_Done,
      // Label 14600: @995172
      GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(995267), // Rule ID 21831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10837:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21831,
        GIR_EraseRootFromParent_Done,
      // Label 14601: @995267
      GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(995362), // Rule ID 21834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10837:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21834,
        GIR_EraseRootFromParent_Done,
      // Label 14602: @995362
      GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(995457), // Rule ID 21835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10837:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21835,
        GIR_EraseRootFromParent_Done,
      // Label 14603: @995457
      GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(995552), // Rule ID 23274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10931:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23274,
        GIR_EraseRootFromParent_Done,
      // Label 14604: @995552
      GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(995647), // Rule ID 23275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10931:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23275,
        GIR_EraseRootFromParent_Done,
      // Label 14605: @995647
      GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(995742), // Rule ID 23278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10931:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23278,
        GIR_EraseRootFromParent_Done,
      // Label 14606: @995742
      GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(995837), // Rule ID 23279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10931:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23279,
        GIR_EraseRootFromParent_Done,
      // Label 14607: @995837
      GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(995932), // Rule ID 23282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10931:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23282,
        GIR_EraseRootFromParent_Done,
      // Label 14608: @995932
      GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(996027), // Rule ID 23283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10931:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23283,
        GIR_EraseRootFromParent_Done,
      // Label 14609: @996027
      GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(996122), // Rule ID 23286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10931:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23286,
        GIR_EraseRootFromParent_Done,
      // Label 14610: @996122
      GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(996217), // Rule ID 23287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10931:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23287,
        GIR_EraseRootFromParent_Done,
      // Label 14611: @996217
      GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(996312), // Rule ID 23290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10931:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23290,
        GIR_EraseRootFromParent_Done,
      // Label 14612: @996312
      GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(996407), // Rule ID 23291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10931:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23291,
        GIR_EraseRootFromParent_Done,
      // Label 14613: @996407
      GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(996502), // Rule ID 23294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10931:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23294,
        GIR_EraseRootFromParent_Done,
      // Label 14614: @996502
      GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(996597), // Rule ID 23295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10931:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23295,
        GIR_EraseRootFromParent_Done,
      // Label 14615: @996597
      GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(996692), // Rule ID 23298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10931:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23298,
        GIR_EraseRootFromParent_Done,
      // Label 14616: @996692
      GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(996787), // Rule ID 23299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10931:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23299,
        GIR_EraseRootFromParent_Done,
      // Label 14617: @996787
      GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(996882), // Rule ID 23302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10931:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23302,
        GIR_EraseRootFromParent_Done,
      // Label 14618: @996882
      GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(996977), // Rule ID 23303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10931:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23303,
        GIR_EraseRootFromParent_Done,
      // Label 14619: @996977
      GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(997072), // Rule ID 23306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10931:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23306,
        GIR_EraseRootFromParent_Done,
      // Label 14620: @997072
      GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(997167), // Rule ID 23307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10931:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23307,
        GIR_EraseRootFromParent_Done,
      // Label 14621: @997167
      GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(997262), // Rule ID 23310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10931:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23310,
        GIR_EraseRootFromParent_Done,
      // Label 14622: @997262
      GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(997357), // Rule ID 23311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10931:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23311,
        GIR_EraseRootFromParent_Done,
      // Label 14623: @997357
      GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(997452), // Rule ID 23314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10931:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23314,
        GIR_EraseRootFromParent_Done,
      // Label 14624: @997452
      GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(997547), // Rule ID 23315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10931:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23315,
        GIR_EraseRootFromParent_Done,
      // Label 14625: @997547
      GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(997642), // Rule ID 23318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10931:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23318,
        GIR_EraseRootFromParent_Done,
      // Label 14626: @997642
      GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(997737), // Rule ID 23319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10931:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23319,
        GIR_EraseRootFromParent_Done,
      // Label 14627: @997737
      GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(997832), // Rule ID 23322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10931:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23322,
        GIR_EraseRootFromParent_Done,
      // Label 14628: @997832
      GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(997927), // Rule ID 23323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10931:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23323,
        GIR_EraseRootFromParent_Done,
      // Label 14629: @997927
      GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(998022), // Rule ID 23326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10931:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23326,
        GIR_EraseRootFromParent_Done,
      // Label 14630: @998022
      GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(998117), // Rule ID 23327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10931:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23327,
        GIR_EraseRootFromParent_Done,
      // Label 14631: @998117
      GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(998212), // Rule ID 23330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10931:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23330,
        GIR_EraseRootFromParent_Done,
      // Label 14632: @998212
      GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(998307), // Rule ID 23331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10931:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23331,
        GIR_EraseRootFromParent_Done,
      // Label 14633: @998307
      GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(998402), // Rule ID 23334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10931:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23334,
        GIR_EraseRootFromParent_Done,
      // Label 14634: @998402
      GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(998497), // Rule ID 23335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10931:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23335,
        GIR_EraseRootFromParent_Done,
      // Label 14635: @998497
      GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(998592), // Rule ID 23338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10931:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23338,
        GIR_EraseRootFromParent_Done,
      // Label 14636: @998592
      GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(998687), // Rule ID 23339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10931:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23339,
        GIR_EraseRootFromParent_Done,
      // Label 14637: @998687
      GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(998782), // Rule ID 23342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10931:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23342,
        GIR_EraseRootFromParent_Done,
      // Label 14638: @998782
      GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(998877), // Rule ID 23343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10931:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23343,
        GIR_EraseRootFromParent_Done,
      // Label 14639: @998877
      GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(998972), // Rule ID 23346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10931:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23346,
        GIR_EraseRootFromParent_Done,
      // Label 14640: @998972
      GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(999067), // Rule ID 23347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10931:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23347,
        GIR_EraseRootFromParent_Done,
      // Label 14641: @999067
      GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(999162), // Rule ID 23350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10931:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23350,
        GIR_EraseRootFromParent_Done,
      // Label 14642: @999162
      GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(999257), // Rule ID 23351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10931:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23351,
        GIR_EraseRootFromParent_Done,
      // Label 14643: @999257
      GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(999352), // Rule ID 23354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10931:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23354,
        GIR_EraseRootFromParent_Done,
      // Label 14644: @999352
      GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(999447), // Rule ID 23355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10931:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23355,
        GIR_EraseRootFromParent_Done,
      // Label 14645: @999447
      GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(999524), // Rule ID 23460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23460,
        GIR_EraseRootFromParent_Done,
      // Label 14646: @999524
      GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(999601), // Rule ID 23461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23461,
        GIR_EraseRootFromParent_Done,
      // Label 14647: @999601
      GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(999678), // Rule ID 23464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23464,
        GIR_EraseRootFromParent_Done,
      // Label 14648: @999678
      GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(999755), // Rule ID 23465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23465,
        GIR_EraseRootFromParent_Done,
      // Label 14649: @999755
      GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(999832), // Rule ID 23468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23468,
        GIR_EraseRootFromParent_Done,
      // Label 14650: @999832
      GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(999909), // Rule ID 23469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23469,
        GIR_EraseRootFromParent_Done,
      // Label 14651: @999909
      GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(999986), // Rule ID 23472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23472,
        GIR_EraseRootFromParent_Done,
      // Label 14652: @999986
      GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(1000063), // Rule ID 23473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23473,
        GIR_EraseRootFromParent_Done,
      // Label 14653: @1000063
      GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(1000140), // Rule ID 23476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23476,
        GIR_EraseRootFromParent_Done,
      // Label 14654: @1000140
      GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(1000217), // Rule ID 23477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23477,
        GIR_EraseRootFromParent_Done,
      // Label 14655: @1000217
      GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(1000294), // Rule ID 23480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23480,
        GIR_EraseRootFromParent_Done,
      // Label 14656: @1000294
      GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(1000371), // Rule ID 23481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23481,
        GIR_EraseRootFromParent_Done,
      // Label 14657: @1000371
      GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(1000448), // Rule ID 23484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23484,
        GIR_EraseRootFromParent_Done,
      // Label 14658: @1000448
      GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(1000525), // Rule ID 23485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23485,
        GIR_EraseRootFromParent_Done,
      // Label 14659: @1000525
      GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(1000602), // Rule ID 23488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23488,
        GIR_EraseRootFromParent_Done,
      // Label 14660: @1000602
      GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(1000679), // Rule ID 23489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23489,
        GIR_EraseRootFromParent_Done,
      // Label 14661: @1000679
      GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(1000756), // Rule ID 23492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23492,
        GIR_EraseRootFromParent_Done,
      // Label 14662: @1000756
      GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(1000833), // Rule ID 23493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23493,
        GIR_EraseRootFromParent_Done,
      // Label 14663: @1000833
      GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(1000910), // Rule ID 23496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23496,
        GIR_EraseRootFromParent_Done,
      // Label 14664: @1000910
      GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(1000987), // Rule ID 23497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23497,
        GIR_EraseRootFromParent_Done,
      // Label 14665: @1000987
      GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(1001064), // Rule ID 23500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23500,
        GIR_EraseRootFromParent_Done,
      // Label 14666: @1001064
      GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(1001141), // Rule ID 23501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23501,
        GIR_EraseRootFromParent_Done,
      // Label 14667: @1001141
      GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(1001218), // Rule ID 23504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23504,
        GIR_EraseRootFromParent_Done,
      // Label 14668: @1001218
      GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(1001295), // Rule ID 23505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23505,
        GIR_EraseRootFromParent_Done,
      // Label 14669: @1001295
      GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(1001372), // Rule ID 23508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23508,
        GIR_EraseRootFromParent_Done,
      // Label 14670: @1001372
      GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(1001449), // Rule ID 23509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23509,
        GIR_EraseRootFromParent_Done,
      // Label 14671: @1001449
      GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(1001526), // Rule ID 23512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23512,
        GIR_EraseRootFromParent_Done,
      // Label 14672: @1001526
      GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(1001603), // Rule ID 23513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23513,
        GIR_EraseRootFromParent_Done,
      // Label 14673: @1001603
      GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(1001680), // Rule ID 23516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23516,
        GIR_EraseRootFromParent_Done,
      // Label 14674: @1001680
      GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(1001757), // Rule ID 23517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23517,
        GIR_EraseRootFromParent_Done,
      // Label 14675: @1001757
      GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(1001834), // Rule ID 23520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23520,
        GIR_EraseRootFromParent_Done,
      // Label 14676: @1001834
      GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(1001911), // Rule ID 23521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23521,
        GIR_EraseRootFromParent_Done,
      // Label 14677: @1001911
      GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(1001988), // Rule ID 23524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23524,
        GIR_EraseRootFromParent_Done,
      // Label 14678: @1001988
      GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(1002065), // Rule ID 23525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23525,
        GIR_EraseRootFromParent_Done,
      // Label 14679: @1002065
      GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(1002142), // Rule ID 23528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23528,
        GIR_EraseRootFromParent_Done,
      // Label 14680: @1002142
      GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(1002219), // Rule ID 23529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23529,
        GIR_EraseRootFromParent_Done,
      // Label 14681: @1002219
      GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(1002296), // Rule ID 23532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23532,
        GIR_EraseRootFromParent_Done,
      // Label 14682: @1002296
      GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(1002373), // Rule ID 23533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23533,
        GIR_EraseRootFromParent_Done,
      // Label 14683: @1002373
      GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(1002450), // Rule ID 23536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23536,
        GIR_EraseRootFromParent_Done,
      // Label 14684: @1002450
      GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(1002527), // Rule ID 23537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23537,
        GIR_EraseRootFromParent_Done,
      // Label 14685: @1002527
      GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(1002604), // Rule ID 23540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23540,
        GIR_EraseRootFromParent_Done,
      // Label 14686: @1002604
      GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(1002681), // Rule ID 23541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23541,
        GIR_EraseRootFromParent_Done,
      // Label 14687: @1002681
      GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(1002758), // Rule ID 23544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23544,
        GIR_EraseRootFromParent_Done,
      // Label 14688: @1002758
      GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(1002835), // Rule ID 23545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23545,
        GIR_EraseRootFromParent_Done,
      // Label 14689: @1002835
      GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(1002912), // Rule ID 23636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23636,
        GIR_EraseRootFromParent_Done,
      // Label 14690: @1002912
      GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(1002989), // Rule ID 23637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23637,
        GIR_EraseRootFromParent_Done,
      // Label 14691: @1002989
      GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(1003066), // Rule ID 23640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23640,
        GIR_EraseRootFromParent_Done,
      // Label 14692: @1003066
      GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(1003143), // Rule ID 23641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23641,
        GIR_EraseRootFromParent_Done,
      // Label 14693: @1003143
      GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(1003220), // Rule ID 23644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23644,
        GIR_EraseRootFromParent_Done,
      // Label 14694: @1003220
      GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(1003297), // Rule ID 23645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23645,
        GIR_EraseRootFromParent_Done,
      // Label 14695: @1003297
      GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(1003374), // Rule ID 23648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23648,
        GIR_EraseRootFromParent_Done,
      // Label 14696: @1003374
      GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(1003451), // Rule ID 23649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23649,
        GIR_EraseRootFromParent_Done,
      // Label 14697: @1003451
      GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(1003528), // Rule ID 23652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23652,
        GIR_EraseRootFromParent_Done,
      // Label 14698: @1003528
      GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(1003605), // Rule ID 23653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23653,
        GIR_EraseRootFromParent_Done,
      // Label 14699: @1003605
      GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(1003682), // Rule ID 23656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23656,
        GIR_EraseRootFromParent_Done,
      // Label 14700: @1003682
      GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(1003759), // Rule ID 23657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23657,
        GIR_EraseRootFromParent_Done,
      // Label 14701: @1003759
      GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(1003836), // Rule ID 23660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23660,
        GIR_EraseRootFromParent_Done,
      // Label 14702: @1003836
      GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(1003913), // Rule ID 23661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23661,
        GIR_EraseRootFromParent_Done,
      // Label 14703: @1003913
      GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(1003990), // Rule ID 23664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23664,
        GIR_EraseRootFromParent_Done,
      // Label 14704: @1003990
      GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(1004067), // Rule ID 23665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23665,
        GIR_EraseRootFromParent_Done,
      // Label 14705: @1004067
      GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(1004144), // Rule ID 23668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23668,
        GIR_EraseRootFromParent_Done,
      // Label 14706: @1004144
      GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(1004221), // Rule ID 23669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23669,
        GIR_EraseRootFromParent_Done,
      // Label 14707: @1004221
      GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(1004298), // Rule ID 23672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23672,
        GIR_EraseRootFromParent_Done,
      // Label 14708: @1004298
      GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(1004375), // Rule ID 23673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23673,
        GIR_EraseRootFromParent_Done,
      // Label 14709: @1004375
      GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(1004452), // Rule ID 23676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23676,
        GIR_EraseRootFromParent_Done,
      // Label 14710: @1004452
      GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(1004529), // Rule ID 23677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23677,
        GIR_EraseRootFromParent_Done,
      // Label 14711: @1004529
      GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(1004606), // Rule ID 23680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23680,
        GIR_EraseRootFromParent_Done,
      // Label 14712: @1004606
      GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(1004683), // Rule ID 23681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23681,
        GIR_EraseRootFromParent_Done,
      // Label 14713: @1004683
      GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(1004760), // Rule ID 23684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23684,
        GIR_EraseRootFromParent_Done,
      // Label 14714: @1004760
      GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(1004837), // Rule ID 23685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23685,
        GIR_EraseRootFromParent_Done,
      // Label 14715: @1004837
      GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(1004914), // Rule ID 23688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23688,
        GIR_EraseRootFromParent_Done,
      // Label 14716: @1004914
      GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(1004991), // Rule ID 23689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23689,
        GIR_EraseRootFromParent_Done,
      // Label 14717: @1004991
      GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(1005068), // Rule ID 23692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23692,
        GIR_EraseRootFromParent_Done,
      // Label 14718: @1005068
      GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(1005145), // Rule ID 23693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23693,
        GIR_EraseRootFromParent_Done,
      // Label 14719: @1005145
      GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(1005222), // Rule ID 23696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23696,
        GIR_EraseRootFromParent_Done,
      // Label 14720: @1005222
      GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(1005299), // Rule ID 23697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23697,
        GIR_EraseRootFromParent_Done,
      // Label 14721: @1005299
      GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(1005376), // Rule ID 23700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23700,
        GIR_EraseRootFromParent_Done,
      // Label 14722: @1005376
      GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(1005453), // Rule ID 23701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23701,
        GIR_EraseRootFromParent_Done,
      // Label 14723: @1005453
      GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(1005530), // Rule ID 23704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23704,
        GIR_EraseRootFromParent_Done,
      // Label 14724: @1005530
      GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(1005607), // Rule ID 23705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23705,
        GIR_EraseRootFromParent_Done,
      // Label 14725: @1005607
      GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(1005684), // Rule ID 23708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23708,
        GIR_EraseRootFromParent_Done,
      // Label 14726: @1005684
      GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(1005761), // Rule ID 23709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23709,
        GIR_EraseRootFromParent_Done,
      // Label 14727: @1005761
      GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(1005838), // Rule ID 23712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23712,
        GIR_EraseRootFromParent_Done,
      // Label 14728: @1005838
      GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(1005915), // Rule ID 23713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23713,
        GIR_EraseRootFromParent_Done,
      // Label 14729: @1005915
      GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(1005992), // Rule ID 23716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23716,
        GIR_EraseRootFromParent_Done,
      // Label 14730: @1005992
      GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(1006069), // Rule ID 23717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23717,
        GIR_EraseRootFromParent_Done,
      // Label 14731: @1006069
      GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(1006146), // Rule ID 23720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23720,
        GIR_EraseRootFromParent_Done,
      // Label 14732: @1006146
      GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(1006223), // Rule ID 23721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23721,
        GIR_EraseRootFromParent_Done,
      // Label 14733: @1006223
      GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(1006300), // Rule ID 23988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23988,
        GIR_EraseRootFromParent_Done,
      // Label 14734: @1006300
      GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(1006377), // Rule ID 23989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23989,
        GIR_EraseRootFromParent_Done,
      // Label 14735: @1006377
      GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(1006454), // Rule ID 23992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23992,
        GIR_EraseRootFromParent_Done,
      // Label 14736: @1006454
      GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(1006531), // Rule ID 23993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23993,
        GIR_EraseRootFromParent_Done,
      // Label 14737: @1006531
      GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(1006608), // Rule ID 23996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23996,
        GIR_EraseRootFromParent_Done,
      // Label 14738: @1006608
      GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(1006685), // Rule ID 23997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23997,
        GIR_EraseRootFromParent_Done,
      // Label 14739: @1006685
      GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(1006762), // Rule ID 24000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24000,
        GIR_EraseRootFromParent_Done,
      // Label 14740: @1006762
      GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(1006839), // Rule ID 24001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24001,
        GIR_EraseRootFromParent_Done,
      // Label 14741: @1006839
      GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(1006916), // Rule ID 24004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24004,
        GIR_EraseRootFromParent_Done,
      // Label 14742: @1006916
      GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(1006993), // Rule ID 24005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24005,
        GIR_EraseRootFromParent_Done,
      // Label 14743: @1006993
      GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(1007070), // Rule ID 24008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24008,
        GIR_EraseRootFromParent_Done,
      // Label 14744: @1007070
      GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(1007147), // Rule ID 24009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24009,
        GIR_EraseRootFromParent_Done,
      // Label 14745: @1007147
      GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(1007224), // Rule ID 24012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24012,
        GIR_EraseRootFromParent_Done,
      // Label 14746: @1007224
      GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(1007301), // Rule ID 24013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24013,
        GIR_EraseRootFromParent_Done,
      // Label 14747: @1007301
      GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(1007378), // Rule ID 24016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24016,
        GIR_EraseRootFromParent_Done,
      // Label 14748: @1007378
      GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(1007455), // Rule ID 24017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24017,
        GIR_EraseRootFromParent_Done,
      // Label 14749: @1007455
      GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(1007532), // Rule ID 24020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24020,
        GIR_EraseRootFromParent_Done,
      // Label 14750: @1007532
      GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(1007609), // Rule ID 24021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24021,
        GIR_EraseRootFromParent_Done,
      // Label 14751: @1007609
      GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(1007686), // Rule ID 24024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24024,
        GIR_EraseRootFromParent_Done,
      // Label 14752: @1007686
      GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(1007763), // Rule ID 24025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24025,
        GIR_EraseRootFromParent_Done,
      // Label 14753: @1007763
      GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(1007840), // Rule ID 24028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24028,
        GIR_EraseRootFromParent_Done,
      // Label 14754: @1007840
      GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(1007917), // Rule ID 24029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24029,
        GIR_EraseRootFromParent_Done,
      // Label 14755: @1007917
      GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(1007994), // Rule ID 24032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24032,
        GIR_EraseRootFromParent_Done,
      // Label 14756: @1007994
      GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(1008071), // Rule ID 24033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24033,
        GIR_EraseRootFromParent_Done,
      // Label 14757: @1008071
      GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(1008148), // Rule ID 24036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24036,
        GIR_EraseRootFromParent_Done,
      // Label 14758: @1008148
      GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(1008225), // Rule ID 24037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24037,
        GIR_EraseRootFromParent_Done,
      // Label 14759: @1008225
      GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(1008302), // Rule ID 24040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24040,
        GIR_EraseRootFromParent_Done,
      // Label 14760: @1008302
      GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(1008379), // Rule ID 24041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24041,
        GIR_EraseRootFromParent_Done,
      // Label 14761: @1008379
      GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(1008456), // Rule ID 24044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24044,
        GIR_EraseRootFromParent_Done,
      // Label 14762: @1008456
      GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(1008533), // Rule ID 24045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24045,
        GIR_EraseRootFromParent_Done,
      // Label 14763: @1008533
      GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(1008610), // Rule ID 24108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24108,
        GIR_EraseRootFromParent_Done,
      // Label 14764: @1008610
      GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(1008687), // Rule ID 24109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24109,
        GIR_EraseRootFromParent_Done,
      // Label 14765: @1008687
      GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(1008764), // Rule ID 24112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24112,
        GIR_EraseRootFromParent_Done,
      // Label 14766: @1008764
      GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(1008841), // Rule ID 24113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24113,
        GIR_EraseRootFromParent_Done,
      // Label 14767: @1008841
      GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(1008918), // Rule ID 24116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24116,
        GIR_EraseRootFromParent_Done,
      // Label 14768: @1008918
      GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(1008995), // Rule ID 24117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24117,
        GIR_EraseRootFromParent_Done,
      // Label 14769: @1008995
      GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(1009072), // Rule ID 24120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24120,
        GIR_EraseRootFromParent_Done,
      // Label 14770: @1009072
      GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(1009149), // Rule ID 24121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24121,
        GIR_EraseRootFromParent_Done,
      // Label 14771: @1009149
      GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(1009226), // Rule ID 24124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24124,
        GIR_EraseRootFromParent_Done,
      // Label 14772: @1009226
      GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(1009303), // Rule ID 24125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24125,
        GIR_EraseRootFromParent_Done,
      // Label 14773: @1009303
      GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(1009380), // Rule ID 24128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24128,
        GIR_EraseRootFromParent_Done,
      // Label 14774: @1009380
      GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(1009457), // Rule ID 24129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24129,
        GIR_EraseRootFromParent_Done,
      // Label 14775: @1009457
      GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(1009534), // Rule ID 24132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24132,
        GIR_EraseRootFromParent_Done,
      // Label 14776: @1009534
      GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(1009611), // Rule ID 24133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24133,
        GIR_EraseRootFromParent_Done,
      // Label 14777: @1009611
      GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(1009688), // Rule ID 24136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24136,
        GIR_EraseRootFromParent_Done,
      // Label 14778: @1009688
      GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(1009765), // Rule ID 24137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24137,
        GIR_EraseRootFromParent_Done,
      // Label 14779: @1009765
      GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(1009842), // Rule ID 24140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24140,
        GIR_EraseRootFromParent_Done,
      // Label 14780: @1009842
      GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(1009919), // Rule ID 24141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24141,
        GIR_EraseRootFromParent_Done,
      // Label 14781: @1009919
      GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(1009996), // Rule ID 24144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24144,
        GIR_EraseRootFromParent_Done,
      // Label 14782: @1009996
      GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(1010073), // Rule ID 24145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24145,
        GIR_EraseRootFromParent_Done,
      // Label 14783: @1010073
      GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(1010150), // Rule ID 24148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24148,
        GIR_EraseRootFromParent_Done,
      // Label 14784: @1010150
      GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(1010227), // Rule ID 24149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24149,
        GIR_EraseRootFromParent_Done,
      // Label 14785: @1010227
      GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(1010304), // Rule ID 24152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24152,
        GIR_EraseRootFromParent_Done,
      // Label 14786: @1010304
      GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(1010381), // Rule ID 24153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24153,
        GIR_EraseRootFromParent_Done,
      // Label 14787: @1010381
      GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(1010458), // Rule ID 24156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24156,
        GIR_EraseRootFromParent_Done,
      // Label 14788: @1010458
      GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(1010535), // Rule ID 24157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24157,
        GIR_EraseRootFromParent_Done,
      // Label 14789: @1010535
      GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(1010612), // Rule ID 24160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24160,
        GIR_EraseRootFromParent_Done,
      // Label 14790: @1010612
      GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(1010689), // Rule ID 24161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24161,
        GIR_EraseRootFromParent_Done,
      // Label 14791: @1010689
      GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(1010766), // Rule ID 24164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24164,
        GIR_EraseRootFromParent_Done,
      // Label 14792: @1010766
      GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(1010843), // Rule ID 24165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24165,
        GIR_EraseRootFromParent_Done,
      // Label 14793: @1010843
      GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(1010920), // Rule ID 59980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59980,
        GIR_EraseRootFromParent_Done,
      // Label 14794: @1010920
      GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(1010997), // Rule ID 59981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59981,
        GIR_EraseRootFromParent_Done,
      // Label 14795: @1010997
      GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(1011092), // Rule ID 59994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10772:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59994,
        GIR_EraseRootFromParent_Done,
      // Label 14796: @1011092
      GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(1011187), // Rule ID 59995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10772:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59995,
        GIR_EraseRootFromParent_Done,
      // Label 14797: @1011187
      GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(1011282), // Rule ID 59998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10772:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59998,
        GIR_EraseRootFromParent_Done,
      // Label 14798: @1011282
      GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(1011377), // Rule ID 59999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10772:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59999,
        GIR_EraseRootFromParent_Done,
      // Label 14799: @1011377
      GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(1011472), // Rule ID 60002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10772:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60002,
        GIR_EraseRootFromParent_Done,
      // Label 14800: @1011472
      GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(1011567), // Rule ID 60003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10772:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60003,
        GIR_EraseRootFromParent_Done,
      // Label 14801: @1011567
      GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(1011662), // Rule ID 60006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10772:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60006,
        GIR_EraseRootFromParent_Done,
      // Label 14802: @1011662
      GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(1011757), // Rule ID 60007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10772:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60007,
        GIR_EraseRootFromParent_Done,
      // Label 14803: @1011757
      GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(1011852), // Rule ID 60010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10772:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60010,
        GIR_EraseRootFromParent_Done,
      // Label 14804: @1011852
      GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(1011947), // Rule ID 60011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10772:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60011,
        GIR_EraseRootFromParent_Done,
      // Label 14805: @1011947
      GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(1012042), // Rule ID 60014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10772:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60014,
        GIR_EraseRootFromParent_Done,
      // Label 14806: @1012042
      GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(1012137), // Rule ID 60015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10772:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60015,
        GIR_EraseRootFromParent_Done,
      // Label 14807: @1012137
      GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(1012232), // Rule ID 60018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10772:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60018,
        GIR_EraseRootFromParent_Done,
      // Label 14808: @1012232
      GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(1012327), // Rule ID 60019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10772:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60019,
        GIR_EraseRootFromParent_Done,
      // Label 14809: @1012327
      GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(1012422), // Rule ID 60022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10772:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60022,
        GIR_EraseRootFromParent_Done,
      // Label 14810: @1012422
      GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(1012517), // Rule ID 60023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10772:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60023,
        GIR_EraseRootFromParent_Done,
      // Label 14811: @1012517
      GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(1012612), // Rule ID 60026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10772:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60026,
        GIR_EraseRootFromParent_Done,
      // Label 14812: @1012612
      GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(1012707), // Rule ID 60027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10772:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60027,
        GIR_EraseRootFromParent_Done,
      // Label 14813: @1012707
      GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(1012802), // Rule ID 60030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10772:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60030,
        GIR_EraseRootFromParent_Done,
      // Label 14814: @1012802
      GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(1012897), // Rule ID 60031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10772:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60031,
        GIR_EraseRootFromParent_Done,
      // Label 14815: @1012897
      GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(1012992), // Rule ID 60034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10772:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60034,
        GIR_EraseRootFromParent_Done,
      // Label 14816: @1012992
      GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(1013087), // Rule ID 60035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10772:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60035,
        GIR_EraseRootFromParent_Done,
      // Label 14817: @1013087
      GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(1013182), // Rule ID 60038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10772:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60038,
        GIR_EraseRootFromParent_Done,
      // Label 14818: @1013182
      GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(1013277), // Rule ID 60039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10772:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60039,
        GIR_EraseRootFromParent_Done,
      // Label 14819: @1013277
      GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(1013372), // Rule ID 60042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10772:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60042,
        GIR_EraseRootFromParent_Done,
      // Label 14820: @1013372
      GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(1013467), // Rule ID 60043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10772:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60043,
        GIR_EraseRootFromParent_Done,
      // Label 14821: @1013467
      GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(1013562), // Rule ID 60046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10772:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60046,
        GIR_EraseRootFromParent_Done,
      // Label 14822: @1013562
      GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(1013657), // Rule ID 60047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10772:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60047,
        GIR_EraseRootFromParent_Done,
      // Label 14823: @1013657
      GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(1013752), // Rule ID 60050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10772:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60050,
        GIR_EraseRootFromParent_Done,
      // Label 14824: @1013752
      GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(1013847), // Rule ID 60051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10772:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60051,
        GIR_EraseRootFromParent_Done,
      // Label 14825: @1013847
      GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(1013942), // Rule ID 60054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10772:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60054,
        GIR_EraseRootFromParent_Done,
      // Label 14826: @1013942
      GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(1014037), // Rule ID 60055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10772:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60055,
        GIR_EraseRootFromParent_Done,
      // Label 14827: @1014037
      GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(1014132), // Rule ID 60058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10772:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60058,
        GIR_EraseRootFromParent_Done,
      // Label 14828: @1014132
      GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(1014227), // Rule ID 60059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10772:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60059,
        GIR_EraseRootFromParent_Done,
      // Label 14829: @1014227
      GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(1014322), // Rule ID 60062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10772:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60062,
        GIR_EraseRootFromParent_Done,
      // Label 14830: @1014322
      GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(1014417), // Rule ID 60063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10772:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60063,
        GIR_EraseRootFromParent_Done,
      // Label 14831: @1014417
      GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(1014512), // Rule ID 60066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10772:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60066,
        GIR_EraseRootFromParent_Done,
      // Label 14832: @1014512
      GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(1014607), // Rule ID 60067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10772:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60067,
        GIR_EraseRootFromParent_Done,
      // Label 14833: @1014607
      GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(1014702), // Rule ID 60070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10772:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60070,
        GIR_EraseRootFromParent_Done,
      // Label 14834: @1014702
      GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(1014797), // Rule ID 60071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10772:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60071,
        GIR_EraseRootFromParent_Done,
      // Label 14835: @1014797
      GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(1014892), // Rule ID 60074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10772:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60074,
        GIR_EraseRootFromParent_Done,
      // Label 14836: @1014892
      GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(1014987), // Rule ID 60075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10772:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60075,
        GIR_EraseRootFromParent_Done,
      // Label 14837: @1014987
      GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(1015082), // Rule ID 60078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10772:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60078,
        GIR_EraseRootFromParent_Done,
      // Label 14838: @1015082
      GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(1015177), // Rule ID 60079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10772:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60079,
        GIR_EraseRootFromParent_Done,
      // Label 14839: @1015177
      GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(1015272), // Rule ID 60082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10780:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60082,
        GIR_EraseRootFromParent_Done,
      // Label 14840: @1015272
      GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(1015367), // Rule ID 60083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10780:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60083,
        GIR_EraseRootFromParent_Done,
      // Label 14841: @1015367
      GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(1015462), // Rule ID 60086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10780:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60086,
        GIR_EraseRootFromParent_Done,
      // Label 14842: @1015462
      GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(1015557), // Rule ID 60087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10780:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60087,
        GIR_EraseRootFromParent_Done,
      // Label 14843: @1015557
      GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(1015652), // Rule ID 60090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10780:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60090,
        GIR_EraseRootFromParent_Done,
      // Label 14844: @1015652
      GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(1015747), // Rule ID 60091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10780:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60091,
        GIR_EraseRootFromParent_Done,
      // Label 14845: @1015747
      GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(1015842), // Rule ID 60094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10780:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60094,
        GIR_EraseRootFromParent_Done,
      // Label 14846: @1015842
      GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(1015937), // Rule ID 60095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10780:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60095,
        GIR_EraseRootFromParent_Done,
      // Label 14847: @1015937
      GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(1016032), // Rule ID 60098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10780:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60098,
        GIR_EraseRootFromParent_Done,
      // Label 14848: @1016032
      GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(1016127), // Rule ID 60099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10780:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60099,
        GIR_EraseRootFromParent_Done,
      // Label 14849: @1016127
      GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(1016222), // Rule ID 60102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10780:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60102,
        GIR_EraseRootFromParent_Done,
      // Label 14850: @1016222
      GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(1016317), // Rule ID 60103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10780:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60103,
        GIR_EraseRootFromParent_Done,
      // Label 14851: @1016317
      GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(1016412), // Rule ID 60106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10780:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60106,
        GIR_EraseRootFromParent_Done,
      // Label 14852: @1016412
      GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(1016507), // Rule ID 60107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10780:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60107,
        GIR_EraseRootFromParent_Done,
      // Label 14853: @1016507
      GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(1016602), // Rule ID 60110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10780:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60110,
        GIR_EraseRootFromParent_Done,
      // Label 14854: @1016602
      GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(1016697), // Rule ID 60111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10780:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60111,
        GIR_EraseRootFromParent_Done,
      // Label 14855: @1016697
      GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(1016792), // Rule ID 60114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10780:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60114,
        GIR_EraseRootFromParent_Done,
      // Label 14856: @1016792
      GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(1016887), // Rule ID 60115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10780:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60115,
        GIR_EraseRootFromParent_Done,
      // Label 14857: @1016887
      GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(1016982), // Rule ID 60118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10780:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60118,
        GIR_EraseRootFromParent_Done,
      // Label 14858: @1016982
      GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(1017077), // Rule ID 60119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10780:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60119,
        GIR_EraseRootFromParent_Done,
      // Label 14859: @1017077
      GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(1017172), // Rule ID 60122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10780:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60122,
        GIR_EraseRootFromParent_Done,
      // Label 14860: @1017172
      GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(1017267), // Rule ID 60123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10780:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60123,
        GIR_EraseRootFromParent_Done,
      // Label 14861: @1017267
      GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(1017362), // Rule ID 60126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10780:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60126,
        GIR_EraseRootFromParent_Done,
      // Label 14862: @1017362
      GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(1017457), // Rule ID 60127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10780:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60127,
        GIR_EraseRootFromParent_Done,
      // Label 14863: @1017457
      GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(1017552), // Rule ID 60130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10780:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60130,
        GIR_EraseRootFromParent_Done,
      // Label 14864: @1017552
      GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(1017647), // Rule ID 60131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10780:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60131,
        GIR_EraseRootFromParent_Done,
      // Label 14865: @1017647
      GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(1017742), // Rule ID 60134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10780:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60134,
        GIR_EraseRootFromParent_Done,
      // Label 14866: @1017742
      GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(1017837), // Rule ID 60135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10780:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60135,
        GIR_EraseRootFromParent_Done,
      // Label 14867: @1017837
      GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(1017932), // Rule ID 60138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10780:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60138,
        GIR_EraseRootFromParent_Done,
      // Label 14868: @1017932
      GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(1018027), // Rule ID 60139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10780:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60139,
        GIR_EraseRootFromParent_Done,
      // Label 14869: @1018027
      GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(1018122), // Rule ID 60142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10780:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60142,
        GIR_EraseRootFromParent_Done,
      // Label 14870: @1018122
      GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(1018217), // Rule ID 60143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10780:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60143,
        GIR_EraseRootFromParent_Done,
      // Label 14871: @1018217
      GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(1018312), // Rule ID 60146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10780:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60146,
        GIR_EraseRootFromParent_Done,
      // Label 14872: @1018312
      GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(1018407), // Rule ID 60147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10780:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60147,
        GIR_EraseRootFromParent_Done,
      // Label 14873: @1018407
      GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(1018502), // Rule ID 60150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10780:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60150,
        GIR_EraseRootFromParent_Done,
      // Label 14874: @1018502
      GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(1018597), // Rule ID 60151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10780:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60151,
        GIR_EraseRootFromParent_Done,
      // Label 14875: @1018597
      GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(1018692), // Rule ID 60154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10780:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60154,
        GIR_EraseRootFromParent_Done,
      // Label 14876: @1018692
      GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(1018787), // Rule ID 60155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10780:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60155,
        GIR_EraseRootFromParent_Done,
      // Label 14877: @1018787
      GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(1018882), // Rule ID 60158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10780:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60158,
        GIR_EraseRootFromParent_Done,
      // Label 14878: @1018882
      GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(1018977), // Rule ID 60159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10780:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60159,
        GIR_EraseRootFromParent_Done,
      // Label 14879: @1018977
      GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(1019072), // Rule ID 60162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10780:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60162,
        GIR_EraseRootFromParent_Done,
      // Label 14880: @1019072
      GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(1019167), // Rule ID 60163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10780:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60163,
        GIR_EraseRootFromParent_Done,
      // Label 14881: @1019167
      GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(1019262), // Rule ID 60166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10780:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60166,
        GIR_EraseRootFromParent_Done,
      // Label 14882: @1019262
      GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(1019357), // Rule ID 60167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10780:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60167,
        GIR_EraseRootFromParent_Done,
      // Label 14883: @1019357
      GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(1019452), // Rule ID 60170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60170,
        GIR_EraseRootFromParent_Done,
      // Label 14884: @1019452
      GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(1019547), // Rule ID 60171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60171,
        GIR_EraseRootFromParent_Done,
      // Label 14885: @1019547
      GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(1019642), // Rule ID 60174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60174,
        GIR_EraseRootFromParent_Done,
      // Label 14886: @1019642
      GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(1019737), // Rule ID 60175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60175,
        GIR_EraseRootFromParent_Done,
      // Label 14887: @1019737
      GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(1019832), // Rule ID 60178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60178,
        GIR_EraseRootFromParent_Done,
      // Label 14888: @1019832
      GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(1019927), // Rule ID 60179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60179,
        GIR_EraseRootFromParent_Done,
      // Label 14889: @1019927
      GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(1020022), // Rule ID 60182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60182,
        GIR_EraseRootFromParent_Done,
      // Label 14890: @1020022
      GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(1020117), // Rule ID 60183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60183,
        GIR_EraseRootFromParent_Done,
      // Label 14891: @1020117
      GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(1020212), // Rule ID 60186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10787:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60186,
        GIR_EraseRootFromParent_Done,
      // Label 14892: @1020212
      GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(1020307), // Rule ID 60187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10787:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60187,
        GIR_EraseRootFromParent_Done,
      // Label 14893: @1020307
      GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(1020402), // Rule ID 60190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60190,
        GIR_EraseRootFromParent_Done,
      // Label 14894: @1020402
      GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(1020497), // Rule ID 60191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60191,
        GIR_EraseRootFromParent_Done,
      // Label 14895: @1020497
      GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(1020592), // Rule ID 60194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60194,
        GIR_EraseRootFromParent_Done,
      // Label 14896: @1020592
      GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(1020687), // Rule ID 60195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10787:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60195,
        GIR_EraseRootFromParent_Done,
      // Label 14897: @1020687
      GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(1020782), // Rule ID 60198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10787:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60198,
        GIR_EraseRootFromParent_Done,
      // Label 14898: @1020782
      GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(1020877), // Rule ID 60199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10787:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60199,
        GIR_EraseRootFromParent_Done,
      // Label 14899: @1020877
      GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(1020972), // Rule ID 60202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10787:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60202,
        GIR_EraseRootFromParent_Done,
      // Label 14900: @1020972
      GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(1021067), // Rule ID 60203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10787:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60203,
        GIR_EraseRootFromParent_Done,
      // Label 14901: @1021067
      GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(1021162), // Rule ID 60206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60206,
        GIR_EraseRootFromParent_Done,
      // Label 14902: @1021162
      GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(1021257), // Rule ID 60207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10787:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60207,
        GIR_EraseRootFromParent_Done,
      // Label 14903: @1021257
      GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(1021352), // Rule ID 60210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60210,
        GIR_EraseRootFromParent_Done,
      // Label 14904: @1021352
      GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(1021447), // Rule ID 60211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60211,
        GIR_EraseRootFromParent_Done,
      // Label 14905: @1021447
      GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(1021542), // Rule ID 60214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10787:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60214,
        GIR_EraseRootFromParent_Done,
      // Label 14906: @1021542
      GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(1021637), // Rule ID 60215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10787:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60215,
        GIR_EraseRootFromParent_Done,
      // Label 14907: @1021637
      GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(1021732), // Rule ID 60218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10787:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60218,
        GIR_EraseRootFromParent_Done,
      // Label 14908: @1021732
      GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(1021827), // Rule ID 60219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10787:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60219,
        GIR_EraseRootFromParent_Done,
      // Label 14909: @1021827
      GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(1021922), // Rule ID 60222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60222,
        GIR_EraseRootFromParent_Done,
      // Label 14910: @1021922
      GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(1022017), // Rule ID 60223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60223,
        GIR_EraseRootFromParent_Done,
      // Label 14911: @1022017
      GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(1022112), // Rule ID 60226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10787:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60226,
        GIR_EraseRootFromParent_Done,
      // Label 14912: @1022112
      GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1022207), // Rule ID 60227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10787:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60227,
        GIR_EraseRootFromParent_Done,
      // Label 14913: @1022207
      GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1022302), // Rule ID 60230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10787:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60230,
        GIR_EraseRootFromParent_Done,
      // Label 14914: @1022302
      GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1022397), // Rule ID 60231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10787:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60231,
        GIR_EraseRootFromParent_Done,
      // Label 14915: @1022397
      GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1022492), // Rule ID 60234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60234,
        GIR_EraseRootFromParent_Done,
      // Label 14916: @1022492
      GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1022587), // Rule ID 60235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60235,
        GIR_EraseRootFromParent_Done,
      // Label 14917: @1022587
      GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1022682), // Rule ID 60238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10787:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60238,
        GIR_EraseRootFromParent_Done,
      // Label 14918: @1022682
      GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1022777), // Rule ID 60239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10787:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60239,
        GIR_EraseRootFromParent_Done,
      // Label 14919: @1022777
      GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1022872), // Rule ID 60242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10787:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60242,
        GIR_EraseRootFromParent_Done,
      // Label 14920: @1022872
      GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1022967), // Rule ID 60243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10787:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60243,
        GIR_EraseRootFromParent_Done,
      // Label 14921: @1022967
      GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1023062), // Rule ID 60246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60246,
        GIR_EraseRootFromParent_Done,
      // Label 14922: @1023062
      GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1023157), // Rule ID 60247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10787:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60247,
        GIR_EraseRootFromParent_Done,
      // Label 14923: @1023157
      GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1023252), // Rule ID 60250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10787:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60250,
        GIR_EraseRootFromParent_Done,
      // Label 14924: @1023252
      GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1023347), // Rule ID 60251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10787:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60251,
        GIR_EraseRootFromParent_Done,
      // Label 14925: @1023347
      GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1023442), // Rule ID 60254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10787:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60254,
        GIR_EraseRootFromParent_Done,
      // Label 14926: @1023442
      GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1023537), // Rule ID 60255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10787:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60255,
        GIR_EraseRootFromParent_Done,
      // Label 14927: @1023537
      GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1023632), // Rule ID 60258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10785:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60258,
        GIR_EraseRootFromParent_Done,
      // Label 14928: @1023632
      GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1023727), // Rule ID 60259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10785:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60259,
        GIR_EraseRootFromParent_Done,
      // Label 14929: @1023727
      GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1023822), // Rule ID 60262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10785:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60262,
        GIR_EraseRootFromParent_Done,
      // Label 14930: @1023822
      GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1023917), // Rule ID 60263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10785:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60263,
        GIR_EraseRootFromParent_Done,
      // Label 14931: @1023917
      GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1024012), // Rule ID 60266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10785:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60266,
        GIR_EraseRootFromParent_Done,
      // Label 14932: @1024012
      GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1024107), // Rule ID 60267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10785:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60267,
        GIR_EraseRootFromParent_Done,
      // Label 14933: @1024107
      GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1024202), // Rule ID 60270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10785:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60270,
        GIR_EraseRootFromParent_Done,
      // Label 14934: @1024202
      GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1024297), // Rule ID 60271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10785:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60271,
        GIR_EraseRootFromParent_Done,
      // Label 14935: @1024297
      GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1024392), // Rule ID 60274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10785:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60274,
        GIR_EraseRootFromParent_Done,
      // Label 14936: @1024392
      GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1024487), // Rule ID 60275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10785:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60275,
        GIR_EraseRootFromParent_Done,
      // Label 14937: @1024487
      GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1024582), // Rule ID 60278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10785:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60278,
        GIR_EraseRootFromParent_Done,
      // Label 14938: @1024582
      GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1024677), // Rule ID 60279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10785:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60279,
        GIR_EraseRootFromParent_Done,
      // Label 14939: @1024677
      GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1024772), // Rule ID 60282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10785:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60282,
        GIR_EraseRootFromParent_Done,
      // Label 14940: @1024772
      GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1024867), // Rule ID 60283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10785:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60283,
        GIR_EraseRootFromParent_Done,
      // Label 14941: @1024867
      GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1024962), // Rule ID 60286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10785:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60286,
        GIR_EraseRootFromParent_Done,
      // Label 14942: @1024962
      GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1025057), // Rule ID 60287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10785:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60287,
        GIR_EraseRootFromParent_Done,
      // Label 14943: @1025057
      GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1025152), // Rule ID 60290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10785:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60290,
        GIR_EraseRootFromParent_Done,
      // Label 14944: @1025152
      GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1025247), // Rule ID 60291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10785:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60291,
        GIR_EraseRootFromParent_Done,
      // Label 14945: @1025247
      GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1025342), // Rule ID 60294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10785:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60294,
        GIR_EraseRootFromParent_Done,
      // Label 14946: @1025342
      GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1025437), // Rule ID 60295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10785:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60295,
        GIR_EraseRootFromParent_Done,
      // Label 14947: @1025437
      GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1025532), // Rule ID 60298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10785:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60298,
        GIR_EraseRootFromParent_Done,
      // Label 14948: @1025532
      GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1025627), // Rule ID 60299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10785:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60299,
        GIR_EraseRootFromParent_Done,
      // Label 14949: @1025627
      GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1025722), // Rule ID 60302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10785:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60302,
        GIR_EraseRootFromParent_Done,
      // Label 14950: @1025722
      GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1025817), // Rule ID 60303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10785:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60303,
        GIR_EraseRootFromParent_Done,
      // Label 14951: @1025817
      GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1025912), // Rule ID 60306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10785:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60306,
        GIR_EraseRootFromParent_Done,
      // Label 14952: @1025912
      GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1026007), // Rule ID 60307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10785:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60307,
        GIR_EraseRootFromParent_Done,
      // Label 14953: @1026007
      GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1026102), // Rule ID 60310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10785:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60310,
        GIR_EraseRootFromParent_Done,
      // Label 14954: @1026102
      GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1026197), // Rule ID 60311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10785:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60311,
        GIR_EraseRootFromParent_Done,
      // Label 14955: @1026197
      GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1026292), // Rule ID 60314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10785:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60314,
        GIR_EraseRootFromParent_Done,
      // Label 14956: @1026292
      GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1026387), // Rule ID 60315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10785:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60315,
        GIR_EraseRootFromParent_Done,
      // Label 14957: @1026387
      GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1026482), // Rule ID 60318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10785:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60318,
        GIR_EraseRootFromParent_Done,
      // Label 14958: @1026482
      GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1026577), // Rule ID 60319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10785:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60319,
        GIR_EraseRootFromParent_Done,
      // Label 14959: @1026577
      GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1026672), // Rule ID 60322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10785:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60322,
        GIR_EraseRootFromParent_Done,
      // Label 14960: @1026672
      GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1026767), // Rule ID 60323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10785:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60323,
        GIR_EraseRootFromParent_Done,
      // Label 14961: @1026767
      GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1026862), // Rule ID 60326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10785:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60326,
        GIR_EraseRootFromParent_Done,
      // Label 14962: @1026862
      GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1026957), // Rule ID 60327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10785:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60327,
        GIR_EraseRootFromParent_Done,
      // Label 14963: @1026957
      GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1027052), // Rule ID 60330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10785:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60330,
        GIR_EraseRootFromParent_Done,
      // Label 14964: @1027052
      GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1027147), // Rule ID 60331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10785:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60331,
        GIR_EraseRootFromParent_Done,
      // Label 14965: @1027147
      GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1027242), // Rule ID 60334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10785:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60334,
        GIR_EraseRootFromParent_Done,
      // Label 14966: @1027242
      GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1027337), // Rule ID 60335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10785:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60335,
        GIR_EraseRootFromParent_Done,
      // Label 14967: @1027337
      GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1027432), // Rule ID 60338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10785:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60338,
        GIR_EraseRootFromParent_Done,
      // Label 14968: @1027432
      GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1027527), // Rule ID 60339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10785:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60339,
        GIR_EraseRootFromParent_Done,
      // Label 14969: @1027527
      GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1027622), // Rule ID 60342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10785:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60342,
        GIR_EraseRootFromParent_Done,
      // Label 14970: @1027622
      GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1027717), // Rule ID 60343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10785:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60343,
        GIR_EraseRootFromParent_Done,
      // Label 14971: @1027717
      GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1027812), // Rule ID 60766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10774:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60766,
        GIR_EraseRootFromParent_Done,
      // Label 14972: @1027812
      GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1027907), // Rule ID 60767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10774:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60767,
        GIR_EraseRootFromParent_Done,
      // Label 14973: @1027907
      GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1028002), // Rule ID 60770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10774:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60770,
        GIR_EraseRootFromParent_Done,
      // Label 14974: @1028002
      GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1028097), // Rule ID 60771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10774:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60771,
        GIR_EraseRootFromParent_Done,
      // Label 14975: @1028097
      GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1028192), // Rule ID 60774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10774:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60774,
        GIR_EraseRootFromParent_Done,
      // Label 14976: @1028192
      GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1028287), // Rule ID 60775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10774:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60775,
        GIR_EraseRootFromParent_Done,
      // Label 14977: @1028287
      GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1028382), // Rule ID 60778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10774:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60778,
        GIR_EraseRootFromParent_Done,
      // Label 14978: @1028382
      GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1028477), // Rule ID 60779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10774:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60779,
        GIR_EraseRootFromParent_Done,
      // Label 14979: @1028477
      GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1028572), // Rule ID 60782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10774:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60782,
        GIR_EraseRootFromParent_Done,
      // Label 14980: @1028572
      GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1028667), // Rule ID 60783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10774:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60783,
        GIR_EraseRootFromParent_Done,
      // Label 14981: @1028667
      GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1028762), // Rule ID 60786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10774:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60786,
        GIR_EraseRootFromParent_Done,
      // Label 14982: @1028762
      GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1028857), // Rule ID 60787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10774:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60787,
        GIR_EraseRootFromParent_Done,
      // Label 14983: @1028857
      GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1028952), // Rule ID 60790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10774:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60790,
        GIR_EraseRootFromParent_Done,
      // Label 14984: @1028952
      GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1029047), // Rule ID 60791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10774:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60791,
        GIR_EraseRootFromParent_Done,
      // Label 14985: @1029047
      GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1029142), // Rule ID 60794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10774:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60794,
        GIR_EraseRootFromParent_Done,
      // Label 14986: @1029142
      GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1029237), // Rule ID 60795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10774:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60795,
        GIR_EraseRootFromParent_Done,
      // Label 14987: @1029237
      GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1029332), // Rule ID 60798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10774:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60798,
        GIR_EraseRootFromParent_Done,
      // Label 14988: @1029332
      GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1029427), // Rule ID 60799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10774:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60799,
        GIR_EraseRootFromParent_Done,
      // Label 14989: @1029427
      GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1029522), // Rule ID 60802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10774:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60802,
        GIR_EraseRootFromParent_Done,
      // Label 14990: @1029522
      GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1029617), // Rule ID 60803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10774:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60803,
        GIR_EraseRootFromParent_Done,
      // Label 14991: @1029617
      GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1029712), // Rule ID 60806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10774:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60806,
        GIR_EraseRootFromParent_Done,
      // Label 14992: @1029712
      GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1029807), // Rule ID 60807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10774:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60807,
        GIR_EraseRootFromParent_Done,
      // Label 14993: @1029807
      GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1029902), // Rule ID 60810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10774:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60810,
        GIR_EraseRootFromParent_Done,
      // Label 14994: @1029902
      GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1029997), // Rule ID 60811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10774:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60811,
        GIR_EraseRootFromParent_Done,
      // Label 14995: @1029997
      GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1030092), // Rule ID 60814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10774:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60814,
        GIR_EraseRootFromParent_Done,
      // Label 14996: @1030092
      GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1030187), // Rule ID 60815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10774:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60815,
        GIR_EraseRootFromParent_Done,
      // Label 14997: @1030187
      GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1030282), // Rule ID 60818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10774:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60818,
        GIR_EraseRootFromParent_Done,
      // Label 14998: @1030282
      GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1030377), // Rule ID 60819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10774:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60819,
        GIR_EraseRootFromParent_Done,
      // Label 14999: @1030377
      GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1030472), // Rule ID 60822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10774:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60822,
        GIR_EraseRootFromParent_Done,
      // Label 15000: @1030472
      GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1030567), // Rule ID 60823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10774:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60823,
        GIR_EraseRootFromParent_Done,
      // Label 15001: @1030567
      GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1030662), // Rule ID 60826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10774:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60826,
        GIR_EraseRootFromParent_Done,
      // Label 15002: @1030662
      GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1030757), // Rule ID 60827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10774:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60827,
        GIR_EraseRootFromParent_Done,
      // Label 15003: @1030757
      GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1030852), // Rule ID 60830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10774:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60830,
        GIR_EraseRootFromParent_Done,
      // Label 15004: @1030852
      GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1030947), // Rule ID 60831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10774:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60831,
        GIR_EraseRootFromParent_Done,
      // Label 15005: @1030947
      GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1031042), // Rule ID 60834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10774:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60834,
        GIR_EraseRootFromParent_Done,
      // Label 15006: @1031042
      GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1031137), // Rule ID 60835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10774:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60835,
        GIR_EraseRootFromParent_Done,
      // Label 15007: @1031137
      GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1031232), // Rule ID 60838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10774:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60838,
        GIR_EraseRootFromParent_Done,
      // Label 15008: @1031232
      GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1031327), // Rule ID 60839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10774:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60839,
        GIR_EraseRootFromParent_Done,
      // Label 15009: @1031327
      GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1031422), // Rule ID 60842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10774:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60842,
        GIR_EraseRootFromParent_Done,
      // Label 15010: @1031422
      GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1031517), // Rule ID 60843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10774:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60843,
        GIR_EraseRootFromParent_Done,
      // Label 15011: @1031517
      GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1031612), // Rule ID 60846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10774:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60846,
        GIR_EraseRootFromParent_Done,
      // Label 15012: @1031612
      GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1031707), // Rule ID 60847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10774:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60847,
        GIR_EraseRootFromParent_Done,
      // Label 15013: @1031707
      GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1031802), // Rule ID 60850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10774:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60850,
        GIR_EraseRootFromParent_Done,
      // Label 15014: @1031802
      GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1031897), // Rule ID 60851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10774:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60851,
        GIR_EraseRootFromParent_Done,
      // Label 15015: @1031897
      GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1031992), // Rule ID 60854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60854,
        GIR_EraseRootFromParent_Done,
      // Label 15016: @1031992
      GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1032087), // Rule ID 60855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60855,
        GIR_EraseRootFromParent_Done,
      // Label 15017: @1032087
      GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1032182), // Rule ID 60858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60858,
        GIR_EraseRootFromParent_Done,
      // Label 15018: @1032182
      GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1032277), // Rule ID 60859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60859,
        GIR_EraseRootFromParent_Done,
      // Label 15019: @1032277
      GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1032372), // Rule ID 60862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60862,
        GIR_EraseRootFromParent_Done,
      // Label 15020: @1032372
      GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1032467), // Rule ID 60863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60863,
        GIR_EraseRootFromParent_Done,
      // Label 15021: @1032467
      GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1032562), // Rule ID 60866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60866,
        GIR_EraseRootFromParent_Done,
      // Label 15022: @1032562
      GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1032657), // Rule ID 60867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60867,
        GIR_EraseRootFromParent_Done,
      // Label 15023: @1032657
      GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1032752), // Rule ID 60870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60870,
        GIR_EraseRootFromParent_Done,
      // Label 15024: @1032752
      GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1032847), // Rule ID 60871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60871,
        GIR_EraseRootFromParent_Done,
      // Label 15025: @1032847
      GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1032942), // Rule ID 60874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60874,
        GIR_EraseRootFromParent_Done,
      // Label 15026: @1032942
      GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1033037), // Rule ID 60875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60875,
        GIR_EraseRootFromParent_Done,
      // Label 15027: @1033037
      GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1033132), // Rule ID 60878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60878,
        GIR_EraseRootFromParent_Done,
      // Label 15028: @1033132
      GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1033227), // Rule ID 60879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11125:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60879,
        GIR_EraseRootFromParent_Done,
      // Label 15029: @1033227
      GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1033322), // Rule ID 60882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60882,
        GIR_EraseRootFromParent_Done,
      // Label 15030: @1033322
      GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1033417), // Rule ID 60883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60883,
        GIR_EraseRootFromParent_Done,
      // Label 15031: @1033417
      GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1033512), // Rule ID 60886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60886,
        GIR_EraseRootFromParent_Done,
      // Label 15032: @1033512
      GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1033607), // Rule ID 60887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60887,
        GIR_EraseRootFromParent_Done,
      // Label 15033: @1033607
      GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1033702), // Rule ID 60890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60890,
        GIR_EraseRootFromParent_Done,
      // Label 15034: @1033702
      GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1033797), // Rule ID 60891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60891,
        GIR_EraseRootFromParent_Done,
      // Label 15035: @1033797
      GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1033892), // Rule ID 60894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60894,
        GIR_EraseRootFromParent_Done,
      // Label 15036: @1033892
      GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1033987), // Rule ID 60895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60895,
        GIR_EraseRootFromParent_Done,
      // Label 15037: @1033987
      GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1034082), // Rule ID 60898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60898,
        GIR_EraseRootFromParent_Done,
      // Label 15038: @1034082
      GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1034177), // Rule ID 60899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60899,
        GIR_EraseRootFromParent_Done,
      // Label 15039: @1034177
      GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1034272), // Rule ID 60902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60902,
        GIR_EraseRootFromParent_Done,
      // Label 15040: @1034272
      GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1034367), // Rule ID 60903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60903,
        GIR_EraseRootFromParent_Done,
      // Label 15041: @1034367
      GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1034462), // Rule ID 60906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60906,
        GIR_EraseRootFromParent_Done,
      // Label 15042: @1034462
      GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1034557), // Rule ID 60907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60907,
        GIR_EraseRootFromParent_Done,
      // Label 15043: @1034557
      GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1034652), // Rule ID 60910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60910,
        GIR_EraseRootFromParent_Done,
      // Label 15044: @1034652
      GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1034747), // Rule ID 60911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60911,
        GIR_EraseRootFromParent_Done,
      // Label 15045: @1034747
      GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1034842), // Rule ID 60914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60914,
        GIR_EraseRootFromParent_Done,
      // Label 15046: @1034842
      GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1034937), // Rule ID 60915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60915,
        GIR_EraseRootFromParent_Done,
      // Label 15047: @1034937
      GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1035032), // Rule ID 60918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60918,
        GIR_EraseRootFromParent_Done,
      // Label 15048: @1035032
      GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1035127), // Rule ID 60919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60919,
        GIR_EraseRootFromParent_Done,
      // Label 15049: @1035127
      GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1035222), // Rule ID 60922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60922,
        GIR_EraseRootFromParent_Done,
      // Label 15050: @1035222
      GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1035317), // Rule ID 60923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60923,
        GIR_EraseRootFromParent_Done,
      // Label 15051: @1035317
      GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1035412), // Rule ID 60926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60926,
        GIR_EraseRootFromParent_Done,
      // Label 15052: @1035412
      GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1035507), // Rule ID 60927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60927,
        GIR_EraseRootFromParent_Done,
      // Label 15053: @1035507
      GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1035602), // Rule ID 60930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60930,
        GIR_EraseRootFromParent_Done,
      // Label 15054: @1035602
      GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1035697), // Rule ID 60931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60931,
        GIR_EraseRootFromParent_Done,
      // Label 15055: @1035697
      GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1035792), // Rule ID 60934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60934,
        GIR_EraseRootFromParent_Done,
      // Label 15056: @1035792
      GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1035887), // Rule ID 60935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60935,
        GIR_EraseRootFromParent_Done,
      // Label 15057: @1035887
      GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1035982), // Rule ID 60938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60938,
        GIR_EraseRootFromParent_Done,
      // Label 15058: @1035982
      GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1036077), // Rule ID 60939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60939,
        GIR_EraseRootFromParent_Done,
      // Label 15059: @1036077
      GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1036154), // Rule ID 61464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61464,
        GIR_EraseRootFromParent_Done,
      // Label 15060: @1036154
      GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1036231), // Rule ID 61465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10926:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61465,
        GIR_EraseRootFromParent_Done,
      // Label 15061: @1036231
      GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1036308), // Rule ID 61466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61466,
        GIR_EraseRootFromParent_Done,
      // Label 15062: @1036308
      GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1036385), // Rule ID 61467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10926:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61467,
        GIR_EraseRootFromParent_Done,
      // Label 15063: @1036385
      GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1036462), // Rule ID 61468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61468,
        GIR_EraseRootFromParent_Done,
      // Label 15064: @1036462
      GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1036539), // Rule ID 61469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10926:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61469,
        GIR_EraseRootFromParent_Done,
      // Label 15065: @1036539
      GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1036616), // Rule ID 61470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10926:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61470,
        GIR_EraseRootFromParent_Done,
      // Label 15066: @1036616
      GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1036693), // Rule ID 61471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10926:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61471,
        GIR_EraseRootFromParent_Done,
      // Label 15067: @1036693
      GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1036770), // Rule ID 61674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61674,
        GIR_EraseRootFromParent_Done,
      // Label 15068: @1036770
      GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1036847), // Rule ID 61675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61675,
        GIR_EraseRootFromParent_Done,
      // Label 15069: @1036847
      GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1036924), // Rule ID 61676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61676,
        GIR_EraseRootFromParent_Done,
      // Label 15070: @1036924
      GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1037001), // Rule ID 61677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61677,
        GIR_EraseRootFromParent_Done,
      // Label 15071: @1037001
      GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1037078), // Rule ID 61678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61678,
        GIR_EraseRootFromParent_Done,
      // Label 15072: @1037078
      GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1037155), // Rule ID 61679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61679,
        GIR_EraseRootFromParent_Done,
      // Label 15073: @1037155
      GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1037232), // Rule ID 61680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61680,
        GIR_EraseRootFromParent_Done,
      // Label 15074: @1037232
      GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1037309), // Rule ID 61681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61681,
        GIR_EraseRootFromParent_Done,
      // Label 15075: @1037309
      GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1037386), // Rule ID 61682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61682,
        GIR_EraseRootFromParent_Done,
      // Label 15076: @1037386
      GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1037463), // Rule ID 61683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61683,
        GIR_EraseRootFromParent_Done,
      // Label 15077: @1037463
      GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1037540), // Rule ID 61684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61684,
        GIR_EraseRootFromParent_Done,
      // Label 15078: @1037540
      GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1037617), // Rule ID 61685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61685,
        GIR_EraseRootFromParent_Done,
      // Label 15079: @1037617
      GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1037694), // Rule ID 61686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61686,
        GIR_EraseRootFromParent_Done,
      // Label 15080: @1037694
      GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1037771), // Rule ID 61687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61687,
        GIR_EraseRootFromParent_Done,
      // Label 15081: @1037771
      GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1037848), // Rule ID 61688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61688,
        GIR_EraseRootFromParent_Done,
      // Label 15082: @1037848
      GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1037925), // Rule ID 61689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61689,
        GIR_EraseRootFromParent_Done,
      // Label 15083: @1037925
      GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1038002), // Rule ID 61690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61690,
        GIR_EraseRootFromParent_Done,
      // Label 15084: @1038002
      GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1038079), // Rule ID 61691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61691,
        GIR_EraseRootFromParent_Done,
      // Label 15085: @1038079
      GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1038156), // Rule ID 61692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61692,
        GIR_EraseRootFromParent_Done,
      // Label 15086: @1038156
      GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1038233), // Rule ID 61693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61693,
        GIR_EraseRootFromParent_Done,
      // Label 15087: @1038233
      GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1038310), // Rule ID 61694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61694,
        GIR_EraseRootFromParent_Done,
      // Label 15088: @1038310
      GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1038387), // Rule ID 61695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61695,
        GIR_EraseRootFromParent_Done,
      // Label 15089: @1038387
      GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1038464), // Rule ID 61696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61696,
        GIR_EraseRootFromParent_Done,
      // Label 15090: @1038464
      GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1038541), // Rule ID 61697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61697,
        GIR_EraseRootFromParent_Done,
      // Label 15091: @1038541
      GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1038618), // Rule ID 61698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61698,
        GIR_EraseRootFromParent_Done,
      // Label 15092: @1038618
      GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1038695), // Rule ID 61699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61699,
        GIR_EraseRootFromParent_Done,
      // Label 15093: @1038695
      GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1038772), // Rule ID 61700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61700,
        GIR_EraseRootFromParent_Done,
      // Label 15094: @1038772
      GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1038849), // Rule ID 61701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61701,
        GIR_EraseRootFromParent_Done,
      // Label 15095: @1038849
      GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1038926), // Rule ID 61702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61702,
        GIR_EraseRootFromParent_Done,
      // Label 15096: @1038926
      GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1039003), // Rule ID 61703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61703,
        GIR_EraseRootFromParent_Done,
      // Label 15097: @1039003
      GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1039080), // Rule ID 61704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61704,
        GIR_EraseRootFromParent_Done,
      // Label 15098: @1039080
      GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1039157), // Rule ID 61705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61705,
        GIR_EraseRootFromParent_Done,
      // Label 15099: @1039157
      GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1039234), // Rule ID 61706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61706,
        GIR_EraseRootFromParent_Done,
      // Label 15100: @1039234
      GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1039311), // Rule ID 61707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61707,
        GIR_EraseRootFromParent_Done,
      // Label 15101: @1039311
      GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1039388), // Rule ID 61708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61708,
        GIR_EraseRootFromParent_Done,
      // Label 15102: @1039388
      GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1039465), // Rule ID 61709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61709,
        GIR_EraseRootFromParent_Done,
      // Label 15103: @1039465
      GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1039542), // Rule ID 61710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61710,
        GIR_EraseRootFromParent_Done,
      // Label 15104: @1039542
      GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1039619), // Rule ID 61711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61711,
        GIR_EraseRootFromParent_Done,
      // Label 15105: @1039619
      GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1039696), // Rule ID 61712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61712,
        GIR_EraseRootFromParent_Done,
      // Label 15106: @1039696
      GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1039773), // Rule ID 61713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61713,
        GIR_EraseRootFromParent_Done,
      // Label 15107: @1039773
      GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1039850), // Rule ID 61714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61714,
        GIR_EraseRootFromParent_Done,
      // Label 15108: @1039850
      GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1039927), // Rule ID 61715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61715,
        GIR_EraseRootFromParent_Done,
      // Label 15109: @1039927
      GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1040004), // Rule ID 61716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61716,
        GIR_EraseRootFromParent_Done,
      // Label 15110: @1040004
      GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1040081), // Rule ID 61717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61717,
        GIR_EraseRootFromParent_Done,
      // Label 15111: @1040081
      GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1040158), // Rule ID 61718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61718,
        GIR_EraseRootFromParent_Done,
      // Label 15112: @1040158
      GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1040235), // Rule ID 61719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61719,
        GIR_EraseRootFromParent_Done,
      // Label 15113: @1040235
      GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1040312), // Rule ID 61720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61720,
        GIR_EraseRootFromParent_Done,
      // Label 15114: @1040312
      GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1040389), // Rule ID 61721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61721,
        GIR_EraseRootFromParent_Done,
      // Label 15115: @1040389
      GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1040466), // Rule ID 61722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61722,
        GIR_EraseRootFromParent_Done,
      // Label 15116: @1040466
      GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1040543), // Rule ID 61723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61723,
        GIR_EraseRootFromParent_Done,
      // Label 15117: @1040543
      GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1040620), // Rule ID 61724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61724,
        GIR_EraseRootFromParent_Done,
      // Label 15118: @1040620
      GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1040697), // Rule ID 61725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61725,
        GIR_EraseRootFromParent_Done,
      // Label 15119: @1040697
      GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1040774), // Rule ID 61726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61726,
        GIR_EraseRootFromParent_Done,
      // Label 15120: @1040774
      GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1040851), // Rule ID 61727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61727,
        GIR_EraseRootFromParent_Done,
      // Label 15121: @1040851
      GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1040928), // Rule ID 61728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61728,
        GIR_EraseRootFromParent_Done,
      // Label 15122: @1040928
      GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1041005), // Rule ID 61729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61729,
        GIR_EraseRootFromParent_Done,
      // Label 15123: @1041005
      GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1041082), // Rule ID 61730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61730,
        GIR_EraseRootFromParent_Done,
      // Label 15124: @1041082
      GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1041159), // Rule ID 61731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61731,
        GIR_EraseRootFromParent_Done,
      // Label 15125: @1041159
      GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1041236), // Rule ID 61732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61732,
        GIR_EraseRootFromParent_Done,
      // Label 15126: @1041236
      GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1041313), // Rule ID 61733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61733,
        GIR_EraseRootFromParent_Done,
      // Label 15127: @1041313
      GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1041390), // Rule ID 61734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61734,
        GIR_EraseRootFromParent_Done,
      // Label 15128: @1041390
      GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1041467), // Rule ID 61735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61735,
        GIR_EraseRootFromParent_Done,
      // Label 15129: @1041467
      GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1041544), // Rule ID 61736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61736,
        GIR_EraseRootFromParent_Done,
      // Label 15130: @1041544
      GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1041621), // Rule ID 61737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61737,
        GIR_EraseRootFromParent_Done,
      // Label 15131: @1041621
      GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1041698), // Rule ID 61738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61738,
        GIR_EraseRootFromParent_Done,
      // Label 15132: @1041698
      GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1041775), // Rule ID 61739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61739,
        GIR_EraseRootFromParent_Done,
      // Label 15133: @1041775
      GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1041852), // Rule ID 61740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61740,
        GIR_EraseRootFromParent_Done,
      // Label 15134: @1041852
      GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1041929), // Rule ID 61741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61741,
        GIR_EraseRootFromParent_Done,
      // Label 15135: @1041929
      GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1042006), // Rule ID 61742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61742,
        GIR_EraseRootFromParent_Done,
      // Label 15136: @1042006
      GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1042083), // Rule ID 61743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61743,
        GIR_EraseRootFromParent_Done,
      // Label 15137: @1042083
      GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1042160), // Rule ID 61744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61744,
        GIR_EraseRootFromParent_Done,
      // Label 15138: @1042160
      GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1042237), // Rule ID 61745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61745,
        GIR_EraseRootFromParent_Done,
      // Label 15139: @1042237
      GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1042314), // Rule ID 61746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61746,
        GIR_EraseRootFromParent_Done,
      // Label 15140: @1042314
      GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1042391), // Rule ID 61747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61747,
        GIR_EraseRootFromParent_Done,
      // Label 15141: @1042391
      GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1042468), // Rule ID 61748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61748,
        GIR_EraseRootFromParent_Done,
      // Label 15142: @1042468
      GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1042545), // Rule ID 61749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61749,
        GIR_EraseRootFromParent_Done,
      // Label 15143: @1042545
      GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1042622), // Rule ID 61750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61750,
        GIR_EraseRootFromParent_Done,
      // Label 15144: @1042622
      GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1042699), // Rule ID 61751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61751,
        GIR_EraseRootFromParent_Done,
      // Label 15145: @1042699
      GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1042776), // Rule ID 61752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61752,
        GIR_EraseRootFromParent_Done,
      // Label 15146: @1042776
      GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1042853), // Rule ID 61753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61753,
        GIR_EraseRootFromParent_Done,
      // Label 15147: @1042853
      GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1042930), // Rule ID 61754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61754,
        GIR_EraseRootFromParent_Done,
      // Label 15148: @1042930
      GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1043007), // Rule ID 61755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61755,
        GIR_EraseRootFromParent_Done,
      // Label 15149: @1043007
      GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1043084), // Rule ID 61756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61756,
        GIR_EraseRootFromParent_Done,
      // Label 15150: @1043084
      GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1043161), // Rule ID 61757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61757,
        GIR_EraseRootFromParent_Done,
      // Label 15151: @1043161
      GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1043238), // Rule ID 62014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10734:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62014,
        GIR_EraseRootFromParent_Done,
      // Label 15152: @1043238
      GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1043315), // Rule ID 62015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10734:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62015,
        GIR_EraseRootFromParent_Done,
      // Label 15153: @1043315
      GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1043392), // Rule ID 62018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10734:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62018,
        GIR_EraseRootFromParent_Done,
      // Label 15154: @1043392
      GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1043469), // Rule ID 62019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10734:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62019,
        GIR_EraseRootFromParent_Done,
      // Label 15155: @1043469
      GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1043546), // Rule ID 62022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10734:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62022,
        GIR_EraseRootFromParent_Done,
      // Label 15156: @1043546
      GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1043623), // Rule ID 62023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10734:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62023,
        GIR_EraseRootFromParent_Done,
      // Label 15157: @1043623
      GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1043700), // Rule ID 62026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10734:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62026,
        GIR_EraseRootFromParent_Done,
      // Label 15158: @1043700
      GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1043777), // Rule ID 62027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10734:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62027,
        GIR_EraseRootFromParent_Done,
      // Label 15159: @1043777
      GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1043854), // Rule ID 62030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10734:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62030,
        GIR_EraseRootFromParent_Done,
      // Label 15160: @1043854
      GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1043931), // Rule ID 62031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10734:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62031,
        GIR_EraseRootFromParent_Done,
      // Label 15161: @1043931
      GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1044008), // Rule ID 62034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10734:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62034,
        GIR_EraseRootFromParent_Done,
      // Label 15162: @1044008
      GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1044085), // Rule ID 62035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10734:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62035,
        GIR_EraseRootFromParent_Done,
      // Label 15163: @1044085
      GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1044162), // Rule ID 62038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10734:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62038,
        GIR_EraseRootFromParent_Done,
      // Label 15164: @1044162
      GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1044239), // Rule ID 62039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10734:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62039,
        GIR_EraseRootFromParent_Done,
      // Label 15165: @1044239
      GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1044316), // Rule ID 62042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10734:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62042,
        GIR_EraseRootFromParent_Done,
      // Label 15166: @1044316
      GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1044393), // Rule ID 62043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10734:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62043,
        GIR_EraseRootFromParent_Done,
      // Label 15167: @1044393
      GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1044470), // Rule ID 62046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10734:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62046,
        GIR_EraseRootFromParent_Done,
      // Label 15168: @1044470
      GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1044547), // Rule ID 62047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10734:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62047,
        GIR_EraseRootFromParent_Done,
      // Label 15169: @1044547
      GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1044624), // Rule ID 62050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10734:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62050,
        GIR_EraseRootFromParent_Done,
      // Label 15170: @1044624
      GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1044701), // Rule ID 62051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10734:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62051,
        GIR_EraseRootFromParent_Done,
      // Label 15171: @1044701
      GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1044778), // Rule ID 62054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10738:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62054,
        GIR_EraseRootFromParent_Done,
      // Label 15172: @1044778
      GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1044855), // Rule ID 62055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10738:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62055,
        GIR_EraseRootFromParent_Done,
      // Label 15173: @1044855
      GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1044932), // Rule ID 62058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10738:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62058,
        GIR_EraseRootFromParent_Done,
      // Label 15174: @1044932
      GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1045009), // Rule ID 62059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10738:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62059,
        GIR_EraseRootFromParent_Done,
      // Label 15175: @1045009
      GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1045086), // Rule ID 62062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10738:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62062,
        GIR_EraseRootFromParent_Done,
      // Label 15176: @1045086
      GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1045163), // Rule ID 62063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10738:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62063,
        GIR_EraseRootFromParent_Done,
      // Label 15177: @1045163
      GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1045240), // Rule ID 62066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10738:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62066,
        GIR_EraseRootFromParent_Done,
      // Label 15178: @1045240
      GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1045317), // Rule ID 62067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10738:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62067,
        GIR_EraseRootFromParent_Done,
      // Label 15179: @1045317
      GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1045394), // Rule ID 62070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10738:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62070,
        GIR_EraseRootFromParent_Done,
      // Label 15180: @1045394
      GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1045471), // Rule ID 62071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10738:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62071,
        GIR_EraseRootFromParent_Done,
      // Label 15181: @1045471
      GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1045548), // Rule ID 62074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10738:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62074,
        GIR_EraseRootFromParent_Done,
      // Label 15182: @1045548
      GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1045625), // Rule ID 62075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10738:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62075,
        GIR_EraseRootFromParent_Done,
      // Label 15183: @1045625
      GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1045702), // Rule ID 62078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10738:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62078,
        GIR_EraseRootFromParent_Done,
      // Label 15184: @1045702
      GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1045779), // Rule ID 62079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10738:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62079,
        GIR_EraseRootFromParent_Done,
      // Label 15185: @1045779
      GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1045856), // Rule ID 62082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10738:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62082,
        GIR_EraseRootFromParent_Done,
      // Label 15186: @1045856
      GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1045933), // Rule ID 62083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10738:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62083,
        GIR_EraseRootFromParent_Done,
      // Label 15187: @1045933
      GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1046010), // Rule ID 62086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10738:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62086,
        GIR_EraseRootFromParent_Done,
      // Label 15188: @1046010
      GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1046087), // Rule ID 62087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10738:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62087,
        GIR_EraseRootFromParent_Done,
      // Label 15189: @1046087
      GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1046164), // Rule ID 62090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10738:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62090,
        GIR_EraseRootFromParent_Done,
      // Label 15190: @1046164
      GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1046241), // Rule ID 62091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10738:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62091,
        GIR_EraseRootFromParent_Done,
      // Label 15191: @1046241
      GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1046318), // Rule ID 62094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10736:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62094,
        GIR_EraseRootFromParent_Done,
      // Label 15192: @1046318
      GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1046395), // Rule ID 62095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10736:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62095,
        GIR_EraseRootFromParent_Done,
      // Label 15193: @1046395
      GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1046472), // Rule ID 62098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10736:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62098,
        GIR_EraseRootFromParent_Done,
      // Label 15194: @1046472
      GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1046549), // Rule ID 62099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10736:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62099,
        GIR_EraseRootFromParent_Done,
      // Label 15195: @1046549
      GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1046626), // Rule ID 62102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10736:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62102,
        GIR_EraseRootFromParent_Done,
      // Label 15196: @1046626
      GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1046703), // Rule ID 62103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10736:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62103,
        GIR_EraseRootFromParent_Done,
      // Label 15197: @1046703
      GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1046780), // Rule ID 62106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10736:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62106,
        GIR_EraseRootFromParent_Done,
      // Label 15198: @1046780
      GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1046857), // Rule ID 62107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10736:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62107,
        GIR_EraseRootFromParent_Done,
      // Label 15199: @1046857
      GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1046934), // Rule ID 62110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10736:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62110,
        GIR_EraseRootFromParent_Done,
      // Label 15200: @1046934
      GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1047011), // Rule ID 62111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10736:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62111,
        GIR_EraseRootFromParent_Done,
      // Label 15201: @1047011
      GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1047088), // Rule ID 62114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10736:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62114,
        GIR_EraseRootFromParent_Done,
      // Label 15202: @1047088
      GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1047165), // Rule ID 62115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10736:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62115,
        GIR_EraseRootFromParent_Done,
      // Label 15203: @1047165
      GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1047242), // Rule ID 62118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10736:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62118,
        GIR_EraseRootFromParent_Done,
      // Label 15204: @1047242
      GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1047319), // Rule ID 62119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10736:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62119,
        GIR_EraseRootFromParent_Done,
      // Label 15205: @1047319
      GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1047396), // Rule ID 62122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10736:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62122,
        GIR_EraseRootFromParent_Done,
      // Label 15206: @1047396
      GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1047473), // Rule ID 62123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10736:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62123,
        GIR_EraseRootFromParent_Done,
      // Label 15207: @1047473
      GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1047550), // Rule ID 62126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10736:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62126,
        GIR_EraseRootFromParent_Done,
      // Label 15208: @1047550
      GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1047627), // Rule ID 62127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10736:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62127,
        GIR_EraseRootFromParent_Done,
      // Label 15209: @1047627
      GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1047704), // Rule ID 62130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10736:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62130,
        GIR_EraseRootFromParent_Done,
      // Label 15210: @1047704
      GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1047781), // Rule ID 62131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10736:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62131,
        GIR_EraseRootFromParent_Done,
      // Label 15211: @1047781
      GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1047858), // Rule ID 62134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10740:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62134,
        GIR_EraseRootFromParent_Done,
      // Label 15212: @1047858
      GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1047935), // Rule ID 62135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10740:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62135,
        GIR_EraseRootFromParent_Done,
      // Label 15213: @1047935
      GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1048012), // Rule ID 62138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10740:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62138,
        GIR_EraseRootFromParent_Done,
      // Label 15214: @1048012
      GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1048089), // Rule ID 62139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10740:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62139,
        GIR_EraseRootFromParent_Done,
      // Label 15215: @1048089
      GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1048166), // Rule ID 62142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10740:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62142,
        GIR_EraseRootFromParent_Done,
      // Label 15216: @1048166
      GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1048243), // Rule ID 62143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10740:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62143,
        GIR_EraseRootFromParent_Done,
      // Label 15217: @1048243
      GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1048320), // Rule ID 62146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10740:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62146,
        GIR_EraseRootFromParent_Done,
      // Label 15218: @1048320
      GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1048397), // Rule ID 62147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10740:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62147,
        GIR_EraseRootFromParent_Done,
      // Label 15219: @1048397
      GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1048474), // Rule ID 62150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10740:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62150,
        GIR_EraseRootFromParent_Done,
      // Label 15220: @1048474
      GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1048551), // Rule ID 62151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10740:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62151,
        GIR_EraseRootFromParent_Done,
      // Label 15221: @1048551
      GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1048628), // Rule ID 62245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62245,
        GIR_EraseRootFromParent_Done,
      // Label 15222: @1048628
      GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1048705), // Rule ID 62246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62246,
        GIR_EraseRootFromParent_Done,
      // Label 15223: @1048705
      GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1048782), // Rule ID 63703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63703,
        GIR_EraseRootFromParent_Done,
      // Label 15224: @1048782
      GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1048859), // Rule ID 63704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63704,
        GIR_EraseRootFromParent_Done,
      // Label 15225: @1048859
      GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1048936), // Rule ID 63705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63705,
        GIR_EraseRootFromParent_Done,
      // Label 15226: @1048936
      GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1049013), // Rule ID 63706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63706,
        GIR_EraseRootFromParent_Done,
      // Label 15227: @1049013
      GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1049090), // Rule ID 63707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63707,
        GIR_EraseRootFromParent_Done,
      // Label 15228: @1049090
      GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1049167), // Rule ID 63708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63708,
        GIR_EraseRootFromParent_Done,
      // Label 15229: @1049167
      GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1049244), // Rule ID 63709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10708:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63709,
        GIR_EraseRootFromParent_Done,
      // Label 15230: @1049244
      GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1049321), // Rule ID 63710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10708:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63710,
        GIR_EraseRootFromParent_Done,
      // Label 15231: @1049321
      GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1049398), // Rule ID 63711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10708:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63711,
        GIR_EraseRootFromParent_Done,
      // Label 15232: @1049398
      GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1049475), // Rule ID 63712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10708:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63712,
        GIR_EraseRootFromParent_Done,
      // Label 15233: @1049475
      GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1049552), // Rule ID 63713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10708:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63713,
        GIR_EraseRootFromParent_Done,
      // Label 15234: @1049552
      GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1049629), // Rule ID 63714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10708:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63714,
        GIR_EraseRootFromParent_Done,
      // Label 15235: @1049629
      GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1049706), // Rule ID 63715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10708:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63715,
        GIR_EraseRootFromParent_Done,
      // Label 15236: @1049706
      GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1049783), // Rule ID 63716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10708:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63716,
        GIR_EraseRootFromParent_Done,
      // Label 15237: @1049783
      GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1049860), // Rule ID 63717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63717,
        GIR_EraseRootFromParent_Done,
      // Label 15238: @1049860
      GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1049937), // Rule ID 63718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63718,
        GIR_EraseRootFromParent_Done,
      // Label 15239: @1049937
      GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1050014), // Rule ID 63719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63719,
        GIR_EraseRootFromParent_Done,
      // Label 15240: @1050014
      GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1050091), // Rule ID 63720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63720,
        GIR_EraseRootFromParent_Done,
      // Label 15241: @1050091
      GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1050168), // Rule ID 63721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63721,
        GIR_EraseRootFromParent_Done,
      // Label 15242: @1050168
      GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1050245), // Rule ID 63722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63722,
        GIR_EraseRootFromParent_Done,
      // Label 15243: @1050245
      GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1050322), // Rule ID 63723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63723,
        GIR_EraseRootFromParent_Done,
      // Label 15244: @1050322
      GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1050399), // Rule ID 63724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63724,
        GIR_EraseRootFromParent_Done,
      // Label 15245: @1050399
      GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1050476), // Rule ID 63725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10710:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63725,
        GIR_EraseRootFromParent_Done,
      // Label 15246: @1050476
      GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1050553), // Rule ID 63726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10710:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63726,
        GIR_EraseRootFromParent_Done,
      // Label 15247: @1050553
      GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1050630), // Rule ID 63727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10710:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63727,
        GIR_EraseRootFromParent_Done,
      // Label 15248: @1050630
      GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1050707), // Rule ID 63728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10710:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63728,
        GIR_EraseRootFromParent_Done,
      // Label 15249: @1050707
      GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1050784), // Rule ID 63729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10710:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63729,
        GIR_EraseRootFromParent_Done,
      // Label 15250: @1050784
      GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1050861), // Rule ID 63730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10710:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63730,
        GIR_EraseRootFromParent_Done,
      // Label 15251: @1050861
      GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1050938), // Rule ID 63731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10710:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63731,
        GIR_EraseRootFromParent_Done,
      // Label 15252: @1050938
      GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1051015), // Rule ID 63732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10710:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63732,
        GIR_EraseRootFromParent_Done,
      // Label 15253: @1051015
      GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1051092), // Rule ID 63733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63733,
        GIR_EraseRootFromParent_Done,
      // Label 15254: @1051092
      GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1051169), // Rule ID 63734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63734,
        GIR_EraseRootFromParent_Done,
      // Label 15255: @1051169
      GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1051246), // Rule ID 63735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63735,
        GIR_EraseRootFromParent_Done,
      // Label 15256: @1051246
      GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1051323), // Rule ID 63736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63736,
        GIR_EraseRootFromParent_Done,
      // Label 15257: @1051323
      GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1051400), // Rule ID 63737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63737,
        GIR_EraseRootFromParent_Done,
      // Label 15258: @1051400
      GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1051477), // Rule ID 63738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63738,
        GIR_EraseRootFromParent_Done,
      // Label 15259: @1051477
      GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1051554), // Rule ID 63739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63739,
        GIR_EraseRootFromParent_Done,
      // Label 15260: @1051554
      GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1051631), // Rule ID 63740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63740,
        GIR_EraseRootFromParent_Done,
      // Label 15261: @1051631
      GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1051708), // Rule ID 63741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10709:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63741,
        GIR_EraseRootFromParent_Done,
      // Label 15262: @1051708
      GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1051785), // Rule ID 63742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10709:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63742,
        GIR_EraseRootFromParent_Done,
      // Label 15263: @1051785
      GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1051862), // Rule ID 63743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10709:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63743,
        GIR_EraseRootFromParent_Done,
      // Label 15264: @1051862
      GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1051939), // Rule ID 63744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10709:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63744,
        GIR_EraseRootFromParent_Done,
      // Label 15265: @1051939
      GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1052016), // Rule ID 63745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10709:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63745,
        GIR_EraseRootFromParent_Done,
      // Label 15266: @1052016
      GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1052093), // Rule ID 63746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10709:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63746,
        GIR_EraseRootFromParent_Done,
      // Label 15267: @1052093
      GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1052170), // Rule ID 63747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10709:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63747,
        GIR_EraseRootFromParent_Done,
      // Label 15268: @1052170
      GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1052247), // Rule ID 63748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10709:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63748,
        GIR_EraseRootFromParent_Done,
      // Label 15269: @1052247
      GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1052324), // Rule ID 63749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63749,
        GIR_EraseRootFromParent_Done,
      // Label 15270: @1052324
      GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1052401), // Rule ID 63750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63750,
        GIR_EraseRootFromParent_Done,
      // Label 15271: @1052401
      GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1052478), // Rule ID 63751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63751,
        GIR_EraseRootFromParent_Done,
      // Label 15272: @1052478
      GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1052555), // Rule ID 63752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63752,
        GIR_EraseRootFromParent_Done,
      // Label 15273: @1052555
      GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1052632), // Rule ID 63753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63753,
        GIR_EraseRootFromParent_Done,
      // Label 15274: @1052632
      GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1052709), // Rule ID 63754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63754,
        GIR_EraseRootFromParent_Done,
      // Label 15275: @1052709
      GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1052786), // Rule ID 63755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63755,
        GIR_EraseRootFromParent_Done,
      // Label 15276: @1052786
      GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1052863), // Rule ID 63756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63756,
        GIR_EraseRootFromParent_Done,
      // Label 15277: @1052863
      GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1052940), // Rule ID 63757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63757,
        GIR_EraseRootFromParent_Done,
      // Label 15278: @1052940
      GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1053017), // Rule ID 63758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63758,
        GIR_EraseRootFromParent_Done,
      // Label 15279: @1053017
      GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1053094), // Rule ID 63759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63759,
        GIR_EraseRootFromParent_Done,
      // Label 15280: @1053094
      GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1053171), // Rule ID 63760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63760,
        GIR_EraseRootFromParent_Done,
      // Label 15281: @1053171
      GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1053248), // Rule ID 63761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63761,
        GIR_EraseRootFromParent_Done,
      // Label 15282: @1053248
      GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1053325), // Rule ID 63762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63762,
        GIR_EraseRootFromParent_Done,
      // Label 15283: @1053325
      GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1053402), // Rule ID 63763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63763,
        GIR_EraseRootFromParent_Done,
      // Label 15284: @1053402
      GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1053479), // Rule ID 63764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63764,
        GIR_EraseRootFromParent_Done,
      // Label 15285: @1053479
      GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1053559), // Rule ID 2582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2582,
        GIR_EraseRootFromParent_Done,
      // Label 15286: @1053559
      GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1053639), // Rule ID 2583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2583,
        GIR_EraseRootFromParent_Done,
      // Label 15287: @1053639
      GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1053719), // Rule ID 2622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2622,
        GIR_EraseRootFromParent_Done,
      // Label 15288: @1053719
      GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1053799), // Rule ID 2623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2623,
        GIR_EraseRootFromParent_Done,
      // Label 15289: @1053799
      GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1053879), // Rule ID 2642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2642,
        GIR_EraseRootFromParent_Done,
      // Label 15290: @1053879
      GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1053959), // Rule ID 2643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2643,
        GIR_EraseRootFromParent_Done,
      // Label 15291: @1053959
      GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1054039), // Rule ID 14784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14784,
        GIR_EraseRootFromParent_Done,
      // Label 15292: @1054039
      GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1054119), // Rule ID 14785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14785,
        GIR_EraseRootFromParent_Done,
      // Label 15293: @1054119
      GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1054199), // Rule ID 14788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14788,
        GIR_EraseRootFromParent_Done,
      // Label 15294: @1054199
      GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1054279), // Rule ID 14789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14789,
        GIR_EraseRootFromParent_Done,
      // Label 15295: @1054279
      GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1054359), // Rule ID 14792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14792,
        GIR_EraseRootFromParent_Done,
      // Label 15296: @1054359
      GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1054439), // Rule ID 14793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14793,
        GIR_EraseRootFromParent_Done,
      // Label 15297: @1054439
      GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1054519), // Rule ID 14796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14796,
        GIR_EraseRootFromParent_Done,
      // Label 15298: @1054519
      GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1054599), // Rule ID 14797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14797,
        GIR_EraseRootFromParent_Done,
      // Label 15299: @1054599
      GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1054679), // Rule ID 14800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14800,
        GIR_EraseRootFromParent_Done,
      // Label 15300: @1054679
      GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1054759), // Rule ID 14801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14801,
        GIR_EraseRootFromParent_Done,
      // Label 15301: @1054759
      GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1054839), // Rule ID 14804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14804,
        GIR_EraseRootFromParent_Done,
      // Label 15302: @1054839
      GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1054919), // Rule ID 14805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14805,
        GIR_EraseRootFromParent_Done,
      // Label 15303: @1054919
      GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1054999), // Rule ID 14808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14808,
        GIR_EraseRootFromParent_Done,
      // Label 15304: @1054999
      GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1055079), // Rule ID 14809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14809,
        GIR_EraseRootFromParent_Done,
      // Label 15305: @1055079
      GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1055159), // Rule ID 14812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14812,
        GIR_EraseRootFromParent_Done,
      // Label 15306: @1055159
      GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1055239), // Rule ID 14813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14813,
        GIR_EraseRootFromParent_Done,
      // Label 15307: @1055239
      GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1055319), // Rule ID 14816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14816,
        GIR_EraseRootFromParent_Done,
      // Label 15308: @1055319
      GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1055399), // Rule ID 14817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14817,
        GIR_EraseRootFromParent_Done,
      // Label 15309: @1055399
      GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1055479), // Rule ID 14820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14820,
        GIR_EraseRootFromParent_Done,
      // Label 15310: @1055479
      GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1055559), // Rule ID 14821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14821,
        GIR_EraseRootFromParent_Done,
      // Label 15311: @1055559
      GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1055639), // Rule ID 14824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14824,
        GIR_EraseRootFromParent_Done,
      // Label 15312: @1055639
      GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1055719), // Rule ID 14825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14825,
        GIR_EraseRootFromParent_Done,
      // Label 15313: @1055719
      GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1055799), // Rule ID 14828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14828,
        GIR_EraseRootFromParent_Done,
      // Label 15314: @1055799
      GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1055879), // Rule ID 14829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14829,
        GIR_EraseRootFromParent_Done,
      // Label 15315: @1055879
      GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1055959), // Rule ID 14832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14832,
        GIR_EraseRootFromParent_Done,
      // Label 15316: @1055959
      GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1056039), // Rule ID 14833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14833,
        GIR_EraseRootFromParent_Done,
      // Label 15317: @1056039
      GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1056119), // Rule ID 14836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14836,
        GIR_EraseRootFromParent_Done,
      // Label 15318: @1056119
      GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1056199), // Rule ID 14837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14837,
        GIR_EraseRootFromParent_Done,
      // Label 15319: @1056199
      GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1056279), // Rule ID 14840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14840,
        GIR_EraseRootFromParent_Done,
      // Label 15320: @1056279
      GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1056359), // Rule ID 14841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14841,
        GIR_EraseRootFromParent_Done,
      // Label 15321: @1056359
      GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1056439), // Rule ID 14844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14844,
        GIR_EraseRootFromParent_Done,
      // Label 15322: @1056439
      GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1056519), // Rule ID 14845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14845,
        GIR_EraseRootFromParent_Done,
      // Label 15323: @1056519
      GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1056599), // Rule ID 14848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14848,
        GIR_EraseRootFromParent_Done,
      // Label 15324: @1056599
      GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1056679), // Rule ID 14849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14849,
        GIR_EraseRootFromParent_Done,
      // Label 15325: @1056679
      GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1056759), // Rule ID 14852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14852,
        GIR_EraseRootFromParent_Done,
      // Label 15326: @1056759
      GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1056839), // Rule ID 14853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14853,
        GIR_EraseRootFromParent_Done,
      // Label 15327: @1056839
      GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1056919), // Rule ID 14856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14856,
        GIR_EraseRootFromParent_Done,
      // Label 15328: @1056919
      GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1056999), // Rule ID 14857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14857,
        GIR_EraseRootFromParent_Done,
      // Label 15329: @1056999
      GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1057079), // Rule ID 14860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14860,
        GIR_EraseRootFromParent_Done,
      // Label 15330: @1057079
      GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1057159), // Rule ID 14861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14861,
        GIR_EraseRootFromParent_Done,
      // Label 15331: @1057159
      GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1057239), // Rule ID 14864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14864,
        GIR_EraseRootFromParent_Done,
      // Label 15332: @1057239
      GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1057319), // Rule ID 14865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14865,
        GIR_EraseRootFromParent_Done,
      // Label 15333: @1057319
      GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1057399), // Rule ID 14868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14868,
        GIR_EraseRootFromParent_Done,
      // Label 15334: @1057399
      GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1057479), // Rule ID 14869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14869,
        GIR_EraseRootFromParent_Done,
      // Label 15335: @1057479
      GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1057559), // Rule ID 14872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14872,
        GIR_EraseRootFromParent_Done,
      // Label 15336: @1057559
      GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1057639), // Rule ID 14873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14873,
        GIR_EraseRootFromParent_Done,
      // Label 15337: @1057639
      GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1057719), // Rule ID 14876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14876,
        GIR_EraseRootFromParent_Done,
      // Label 15338: @1057719
      GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1057799), // Rule ID 14877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14877,
        GIR_EraseRootFromParent_Done,
      // Label 15339: @1057799
      GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1057879), // Rule ID 14880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14880,
        GIR_EraseRootFromParent_Done,
      // Label 15340: @1057879
      GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1057959), // Rule ID 14881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14881,
        GIR_EraseRootFromParent_Done,
      // Label 15341: @1057959
      GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1058039), // Rule ID 14884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14884,
        GIR_EraseRootFromParent_Done,
      // Label 15342: @1058039
      GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1058119), // Rule ID 14885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14885,
        GIR_EraseRootFromParent_Done,
      // Label 15343: @1058119
      GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1058199), // Rule ID 14888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14888,
        GIR_EraseRootFromParent_Done,
      // Label 15344: @1058199
      GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1058279), // Rule ID 14889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14889,
        GIR_EraseRootFromParent_Done,
      // Label 15345: @1058279
      GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1058359), // Rule ID 14892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14892,
        GIR_EraseRootFromParent_Done,
      // Label 15346: @1058359
      GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1058439), // Rule ID 14893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10747:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14893,
        GIR_EraseRootFromParent_Done,
      // Label 15347: @1058439
      GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1058519), // Rule ID 14896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14896,
        GIR_EraseRootFromParent_Done,
      // Label 15348: @1058519
      GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1058599), // Rule ID 14897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10747:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14897,
        GIR_EraseRootFromParent_Done,
      // Label 15349: @1058599
      GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1058679), // Rule ID 14900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14900,
        GIR_EraseRootFromParent_Done,
      // Label 15350: @1058679
      GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1058759), // Rule ID 14901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10747:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14901,
        GIR_EraseRootFromParent_Done,
      // Label 15351: @1058759
      GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1058839), // Rule ID 14904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14904,
        GIR_EraseRootFromParent_Done,
      // Label 15352: @1058839
      GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1058919), // Rule ID 14905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10747:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14905,
        GIR_EraseRootFromParent_Done,
      // Label 15353: @1058919
      GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1058999), // Rule ID 14908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14908,
        GIR_EraseRootFromParent_Done,
      // Label 15354: @1058999
      GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1059079), // Rule ID 14909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14909,
        GIR_EraseRootFromParent_Done,
      // Label 15355: @1059079
      GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1059159), // Rule ID 14912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14912,
        GIR_EraseRootFromParent_Done,
      // Label 15356: @1059159
      GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1059239), // Rule ID 14913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14913,
        GIR_EraseRootFromParent_Done,
      // Label 15357: @1059239
      GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1059319), // Rule ID 14916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14916,
        GIR_EraseRootFromParent_Done,
      // Label 15358: @1059319
      GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1059399), // Rule ID 14917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14917,
        GIR_EraseRootFromParent_Done,
      // Label 15359: @1059399
      GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1059479), // Rule ID 14920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14920,
        GIR_EraseRootFromParent_Done,
      // Label 15360: @1059479
      GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1059559), // Rule ID 14921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14921,
        GIR_EraseRootFromParent_Done,
      // Label 15361: @1059559
      GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1059639), // Rule ID 14924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14924,
        GIR_EraseRootFromParent_Done,
      // Label 15362: @1059639
      GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1059719), // Rule ID 14925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14925,
        GIR_EraseRootFromParent_Done,
      // Label 15363: @1059719
      GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1059799), // Rule ID 14928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14928,
        GIR_EraseRootFromParent_Done,
      // Label 15364: @1059799
      GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1059879), // Rule ID 14929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14929,
        GIR_EraseRootFromParent_Done,
      // Label 15365: @1059879
      GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1059959), // Rule ID 14932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14932,
        GIR_EraseRootFromParent_Done,
      // Label 15366: @1059959
      GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1060039), // Rule ID 14933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14933,
        GIR_EraseRootFromParent_Done,
      // Label 15367: @1060039
      GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1060119), // Rule ID 14936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14936,
        GIR_EraseRootFromParent_Done,
      // Label 15368: @1060119
      GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1060199), // Rule ID 14937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14937,
        GIR_EraseRootFromParent_Done,
      // Label 15369: @1060199
      GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1060279), // Rule ID 14940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14940,
        GIR_EraseRootFromParent_Done,
      // Label 15370: @1060279
      GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1060359), // Rule ID 14941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14941,
        GIR_EraseRootFromParent_Done,
      // Label 15371: @1060359
      GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1060439), // Rule ID 14944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14944,
        GIR_EraseRootFromParent_Done,
      // Label 15372: @1060439
      GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1060519), // Rule ID 14945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10747:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14945,
        GIR_EraseRootFromParent_Done,
      // Label 15373: @1060519
      GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1060599), // Rule ID 14948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14948,
        GIR_EraseRootFromParent_Done,
      // Label 15374: @1060599
      GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1060679), // Rule ID 14949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10747:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14949,
        GIR_EraseRootFromParent_Done,
      // Label 15375: @1060679
      GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1060759), // Rule ID 14952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14952,
        GIR_EraseRootFromParent_Done,
      // Label 15376: @1060759
      GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1060839), // Rule ID 14953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10747:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14953,
        GIR_EraseRootFromParent_Done,
      // Label 15377: @1060839
      GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1060919), // Rule ID 14956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14956,
        GIR_EraseRootFromParent_Done,
      // Label 15378: @1060919
      GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1060999), // Rule ID 14957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14957,
        GIR_EraseRootFromParent_Done,
      // Label 15379: @1060999
      GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1061079), // Rule ID 14960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14960,
        GIR_EraseRootFromParent_Done,
      // Label 15380: @1061079
      GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1061159), // Rule ID 14961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14961,
        GIR_EraseRootFromParent_Done,
      // Label 15381: @1061159
      GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1061239), // Rule ID 14964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14964,
        GIR_EraseRootFromParent_Done,
      // Label 15382: @1061239
      GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1061319), // Rule ID 14965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14965,
        GIR_EraseRootFromParent_Done,
      // Label 15383: @1061319
      GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1061399), // Rule ID 14968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14968,
        GIR_EraseRootFromParent_Done,
      // Label 15384: @1061399
      GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1061479), // Rule ID 14969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14969,
        GIR_EraseRootFromParent_Done,
      // Label 15385: @1061479
      GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1061559), // Rule ID 14972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14972,
        GIR_EraseRootFromParent_Done,
      // Label 15386: @1061559
      GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1061639), // Rule ID 14973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14973,
        GIR_EraseRootFromParent_Done,
      // Label 15387: @1061639
      GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1061719), // Rule ID 14976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14976,
        GIR_EraseRootFromParent_Done,
      // Label 15388: @1061719
      GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1061799), // Rule ID 14977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14977,
        GIR_EraseRootFromParent_Done,
      // Label 15389: @1061799
      GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1061879), // Rule ID 14980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14980,
        GIR_EraseRootFromParent_Done,
      // Label 15390: @1061879
      GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1061959), // Rule ID 14981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14981,
        GIR_EraseRootFromParent_Done,
      // Label 15391: @1061959
      GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1062039), // Rule ID 14984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14984,
        GIR_EraseRootFromParent_Done,
      // Label 15392: @1062039
      GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1062119), // Rule ID 14985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14985,
        GIR_EraseRootFromParent_Done,
      // Label 15393: @1062119
      GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1062199), // Rule ID 14988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14988,
        GIR_EraseRootFromParent_Done,
      // Label 15394: @1062199
      GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1062279), // Rule ID 14989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14989,
        GIR_EraseRootFromParent_Done,
      // Label 15395: @1062279
      GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1062359), // Rule ID 14992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14992,
        GIR_EraseRootFromParent_Done,
      // Label 15396: @1062359
      GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1062439), // Rule ID 14993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14993,
        GIR_EraseRootFromParent_Done,
      // Label 15397: @1062439
      GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1062519), // Rule ID 14996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14996,
        GIR_EraseRootFromParent_Done,
      // Label 15398: @1062519
      GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1062599), // Rule ID 14997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14997,
        GIR_EraseRootFromParent_Done,
      // Label 15399: @1062599
      GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1062679), // Rule ID 15000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15000,
        GIR_EraseRootFromParent_Done,
      // Label 15400: @1062679
      GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1062759), // Rule ID 15001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15001,
        GIR_EraseRootFromParent_Done,
      // Label 15401: @1062759
      GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1062839), // Rule ID 15004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15004,
        GIR_EraseRootFromParent_Done,
      // Label 15402: @1062839
      GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1062919), // Rule ID 15005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15005,
        GIR_EraseRootFromParent_Done,
      // Label 15403: @1062919
      GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1062999), // Rule ID 15008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15008,
        GIR_EraseRootFromParent_Done,
      // Label 15404: @1062999
      GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1063079), // Rule ID 15009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15009,
        GIR_EraseRootFromParent_Done,
      // Label 15405: @1063079
      GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1063159), // Rule ID 15012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15012,
        GIR_EraseRootFromParent_Done,
      // Label 15406: @1063159
      GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1063239), // Rule ID 15013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15013,
        GIR_EraseRootFromParent_Done,
      // Label 15407: @1063239
      GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1063319), // Rule ID 15016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15016,
        GIR_EraseRootFromParent_Done,
      // Label 15408: @1063319
      GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1063399), // Rule ID 15017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15017,
        GIR_EraseRootFromParent_Done,
      // Label 15409: @1063399
      GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1063479), // Rule ID 15020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15020,
        GIR_EraseRootFromParent_Done,
      // Label 15410: @1063479
      GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1063559), // Rule ID 15021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15021,
        GIR_EraseRootFromParent_Done,
      // Label 15411: @1063559
      GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1063639), // Rule ID 15024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15024,
        GIR_EraseRootFromParent_Done,
      // Label 15412: @1063639
      GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1063719), // Rule ID 15025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15025,
        GIR_EraseRootFromParent_Done,
      // Label 15413: @1063719
      GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1063799), // Rule ID 15028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15028,
        GIR_EraseRootFromParent_Done,
      // Label 15414: @1063799
      GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1063879), // Rule ID 15029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15029,
        GIR_EraseRootFromParent_Done,
      // Label 15415: @1063879
      GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1063959), // Rule ID 15032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15032,
        GIR_EraseRootFromParent_Done,
      // Label 15416: @1063959
      GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1064039), // Rule ID 15033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15033,
        GIR_EraseRootFromParent_Done,
      // Label 15417: @1064039
      GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1064119), // Rule ID 15036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15036,
        GIR_EraseRootFromParent_Done,
      // Label 15418: @1064119
      GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1064199), // Rule ID 15037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15037,
        GIR_EraseRootFromParent_Done,
      // Label 15419: @1064199
      GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1064279), // Rule ID 15040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15040,
        GIR_EraseRootFromParent_Done,
      // Label 15420: @1064279
      GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1064359), // Rule ID 15041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15041,
        GIR_EraseRootFromParent_Done,
      // Label 15421: @1064359
      GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1064439), // Rule ID 15044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15044,
        GIR_EraseRootFromParent_Done,
      // Label 15422: @1064439
      GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1064519), // Rule ID 15045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15045,
        GIR_EraseRootFromParent_Done,
      // Label 15423: @1064519
      GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1064599), // Rule ID 15048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15048,
        GIR_EraseRootFromParent_Done,
      // Label 15424: @1064599
      GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1064679), // Rule ID 15049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15049,
        GIR_EraseRootFromParent_Done,
      // Label 15425: @1064679
      GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1064759), // Rule ID 15052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15052,
        GIR_EraseRootFromParent_Done,
      // Label 15426: @1064759
      GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1064839), // Rule ID 15053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15053,
        GIR_EraseRootFromParent_Done,
      // Label 15427: @1064839
      GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1064919), // Rule ID 15056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15056,
        GIR_EraseRootFromParent_Done,
      // Label 15428: @1064919
      GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1064999), // Rule ID 15057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15057,
        GIR_EraseRootFromParent_Done,
      // Label 15429: @1064999
      GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1065079), // Rule ID 15060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15060,
        GIR_EraseRootFromParent_Done,
      // Label 15430: @1065079
      GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1065159), // Rule ID 15061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15061,
        GIR_EraseRootFromParent_Done,
      // Label 15431: @1065159
      GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1065239), // Rule ID 15064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15064,
        GIR_EraseRootFromParent_Done,
      // Label 15432: @1065239
      GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1065319), // Rule ID 15065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15065,
        GIR_EraseRootFromParent_Done,
      // Label 15433: @1065319
      GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1065399), // Rule ID 15068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15068,
        GIR_EraseRootFromParent_Done,
      // Label 15434: @1065399
      GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1065479), // Rule ID 15069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10769:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15069,
        GIR_EraseRootFromParent_Done,
      // Label 15435: @1065479
      GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1065559), // Rule ID 15072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15072,
        GIR_EraseRootFromParent_Done,
      // Label 15436: @1065559
      GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1065639), // Rule ID 15073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10769:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15073,
        GIR_EraseRootFromParent_Done,
      // Label 15437: @1065639
      GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1065719), // Rule ID 15076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15076,
        GIR_EraseRootFromParent_Done,
      // Label 15438: @1065719
      GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1065799), // Rule ID 15077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10769:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15077,
        GIR_EraseRootFromParent_Done,
      // Label 15439: @1065799
      GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1065879), // Rule ID 15080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15080,
        GIR_EraseRootFromParent_Done,
      // Label 15440: @1065879
      GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1065959), // Rule ID 15081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10769:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15081,
        GIR_EraseRootFromParent_Done,
      // Label 15441: @1065959
      GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1066039), // Rule ID 15084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15084,
        GIR_EraseRootFromParent_Done,
      // Label 15442: @1066039
      GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1066119), // Rule ID 15085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15085,
        GIR_EraseRootFromParent_Done,
      // Label 15443: @1066119
      GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1066199), // Rule ID 15088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15088,
        GIR_EraseRootFromParent_Done,
      // Label 15444: @1066199
      GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1066279), // Rule ID 15089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15089,
        GIR_EraseRootFromParent_Done,
      // Label 15445: @1066279
      GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1066359), // Rule ID 15092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15092,
        GIR_EraseRootFromParent_Done,
      // Label 15446: @1066359
      GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1066439), // Rule ID 15093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15093,
        GIR_EraseRootFromParent_Done,
      // Label 15447: @1066439
      GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1066519), // Rule ID 15096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15096,
        GIR_EraseRootFromParent_Done,
      // Label 15448: @1066519
      GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1066599), // Rule ID 15097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15097,
        GIR_EraseRootFromParent_Done,
      // Label 15449: @1066599
      GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1066679), // Rule ID 15100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15100,
        GIR_EraseRootFromParent_Done,
      // Label 15450: @1066679
      GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1066759), // Rule ID 15101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15101,
        GIR_EraseRootFromParent_Done,
      // Label 15451: @1066759
      GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1066839), // Rule ID 15104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15104,
        GIR_EraseRootFromParent_Done,
      // Label 15452: @1066839
      GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1066919), // Rule ID 15105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15105,
        GIR_EraseRootFromParent_Done,
      // Label 15453: @1066919
      GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1066999), // Rule ID 15108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15108,
        GIR_EraseRootFromParent_Done,
      // Label 15454: @1066999
      GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1067079), // Rule ID 15109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15109,
        GIR_EraseRootFromParent_Done,
      // Label 15455: @1067079
      GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1067159), // Rule ID 15112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15112,
        GIR_EraseRootFromParent_Done,
      // Label 15456: @1067159
      GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1067239), // Rule ID 15113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15113,
        GIR_EraseRootFromParent_Done,
      // Label 15457: @1067239
      GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1067319), // Rule ID 15116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15116,
        GIR_EraseRootFromParent_Done,
      // Label 15458: @1067319
      GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1067399), // Rule ID 15117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15117,
        GIR_EraseRootFromParent_Done,
      // Label 15459: @1067399
      GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1067479), // Rule ID 15120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15120,
        GIR_EraseRootFromParent_Done,
      // Label 15460: @1067479
      GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1067559), // Rule ID 15121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10769:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15121,
        GIR_EraseRootFromParent_Done,
      // Label 15461: @1067559
      GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1067639), // Rule ID 15124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15124,
        GIR_EraseRootFromParent_Done,
      // Label 15462: @1067639
      GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1067719), // Rule ID 15125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10769:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15125,
        GIR_EraseRootFromParent_Done,
      // Label 15463: @1067719
      GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1067799), // Rule ID 15128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15128,
        GIR_EraseRootFromParent_Done,
      // Label 15464: @1067799
      GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1067879), // Rule ID 15129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10769:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15129,
        GIR_EraseRootFromParent_Done,
      // Label 15465: @1067879
      GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1067959), // Rule ID 15132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15132,
        GIR_EraseRootFromParent_Done,
      // Label 15466: @1067959
      GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1068039), // Rule ID 15133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15133,
        GIR_EraseRootFromParent_Done,
      // Label 15467: @1068039
      GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1068119), // Rule ID 15136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15136,
        GIR_EraseRootFromParent_Done,
      // Label 15468: @1068119
      GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1068199), // Rule ID 15137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15137,
        GIR_EraseRootFromParent_Done,
      // Label 15469: @1068199
      GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1068279), // Rule ID 15140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15140,
        GIR_EraseRootFromParent_Done,
      // Label 15470: @1068279
      GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1068359), // Rule ID 15141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15141,
        GIR_EraseRootFromParent_Done,
      // Label 15471: @1068359
      GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1068439), // Rule ID 15144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15144,
        GIR_EraseRootFromParent_Done,
      // Label 15472: @1068439
      GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1068519), // Rule ID 15145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15145,
        GIR_EraseRootFromParent_Done,
      // Label 15473: @1068519
      GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1068599), // Rule ID 15148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15148,
        GIR_EraseRootFromParent_Done,
      // Label 15474: @1068599
      GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1068679), // Rule ID 15149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15149,
        GIR_EraseRootFromParent_Done,
      // Label 15475: @1068679
      GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1068759), // Rule ID 15152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15152,
        GIR_EraseRootFromParent_Done,
      // Label 15476: @1068759
      GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1068839), // Rule ID 15153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15153,
        GIR_EraseRootFromParent_Done,
      // Label 15477: @1068839
      GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1068919), // Rule ID 15156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15156,
        GIR_EraseRootFromParent_Done,
      // Label 15478: @1068919
      GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1068999), // Rule ID 15157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15157,
        GIR_EraseRootFromParent_Done,
      // Label 15479: @1068999
      GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1069079), // Rule ID 15160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15160,
        GIR_EraseRootFromParent_Done,
      // Label 15480: @1069079
      GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1069159), // Rule ID 15161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15161,
        GIR_EraseRootFromParent_Done,
      // Label 15481: @1069159
      GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1069239), // Rule ID 15164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15164,
        GIR_EraseRootFromParent_Done,
      // Label 15482: @1069239
      GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1069319), // Rule ID 15165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15165,
        GIR_EraseRootFromParent_Done,
      // Label 15483: @1069319
      GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1069399), // Rule ID 15168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15168,
        GIR_EraseRootFromParent_Done,
      // Label 15484: @1069399
      GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1069479), // Rule ID 15169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15169,
        GIR_EraseRootFromParent_Done,
      // Label 15485: @1069479
      GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1069559), // Rule ID 15172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15172,
        GIR_EraseRootFromParent_Done,
      // Label 15486: @1069559
      GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1069639), // Rule ID 15173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15173,
        GIR_EraseRootFromParent_Done,
      // Label 15487: @1069639
      GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1069719), // Rule ID 15176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15176,
        GIR_EraseRootFromParent_Done,
      // Label 15488: @1069719
      GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1069799), // Rule ID 15177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15177,
        GIR_EraseRootFromParent_Done,
      // Label 15489: @1069799
      GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1069879), // Rule ID 15180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15180,
        GIR_EraseRootFromParent_Done,
      // Label 15490: @1069879
      GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1069959), // Rule ID 15181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15181,
        GIR_EraseRootFromParent_Done,
      // Label 15491: @1069959
      GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1070039), // Rule ID 15184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15184,
        GIR_EraseRootFromParent_Done,
      // Label 15492: @1070039
      GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1070119), // Rule ID 15185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15185,
        GIR_EraseRootFromParent_Done,
      // Label 15493: @1070119
      GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1070199), // Rule ID 15188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15188,
        GIR_EraseRootFromParent_Done,
      // Label 15494: @1070199
      GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1070279), // Rule ID 15189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15189,
        GIR_EraseRootFromParent_Done,
      // Label 15495: @1070279
      GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1070359), // Rule ID 15192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15192,
        GIR_EraseRootFromParent_Done,
      // Label 15496: @1070359
      GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1070439), // Rule ID 15193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15193,
        GIR_EraseRootFromParent_Done,
      // Label 15497: @1070439
      GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1070519), // Rule ID 15196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15196,
        GIR_EraseRootFromParent_Done,
      // Label 15498: @1070519
      GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1070599), // Rule ID 15197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15197,
        GIR_EraseRootFromParent_Done,
      // Label 15499: @1070599
      GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1070679), // Rule ID 15200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15200,
        GIR_EraseRootFromParent_Done,
      // Label 15500: @1070679
      GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1070759), // Rule ID 15201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15201,
        GIR_EraseRootFromParent_Done,
      // Label 15501: @1070759
      GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1070839), // Rule ID 15204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15204,
        GIR_EraseRootFromParent_Done,
      // Label 15502: @1070839
      GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1070919), // Rule ID 15205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15205,
        GIR_EraseRootFromParent_Done,
      // Label 15503: @1070919
      GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1070999), // Rule ID 15208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15208,
        GIR_EraseRootFromParent_Done,
      // Label 15504: @1070999
      GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1071079), // Rule ID 15209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15209,
        GIR_EraseRootFromParent_Done,
      // Label 15505: @1071079
      GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1071159), // Rule ID 15212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15212,
        GIR_EraseRootFromParent_Done,
      // Label 15506: @1071159
      GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1071239), // Rule ID 15213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15213,
        GIR_EraseRootFromParent_Done,
      // Label 15507: @1071239
      GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1071319), // Rule ID 15216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15216,
        GIR_EraseRootFromParent_Done,
      // Label 15508: @1071319
      GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1071399), // Rule ID 15217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15217,
        GIR_EraseRootFromParent_Done,
      // Label 15509: @1071399
      GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1071479), // Rule ID 15220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15220,
        GIR_EraseRootFromParent_Done,
      // Label 15510: @1071479
      GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1071559), // Rule ID 15221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15221,
        GIR_EraseRootFromParent_Done,
      // Label 15511: @1071559
      GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1071639), // Rule ID 15224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15224,
        GIR_EraseRootFromParent_Done,
      // Label 15512: @1071639
      GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1071719), // Rule ID 15225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15225,
        GIR_EraseRootFromParent_Done,
      // Label 15513: @1071719
      GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1071799), // Rule ID 15228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15228,
        GIR_EraseRootFromParent_Done,
      // Label 15514: @1071799
      GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1071879), // Rule ID 15229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15229,
        GIR_EraseRootFromParent_Done,
      // Label 15515: @1071879
      GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1071959), // Rule ID 15232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15232,
        GIR_EraseRootFromParent_Done,
      // Label 15516: @1071959
      GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1072039), // Rule ID 15233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15233,
        GIR_EraseRootFromParent_Done,
      // Label 15517: @1072039
      GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1072119), // Rule ID 15236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15236,
        GIR_EraseRootFromParent_Done,
      // Label 15518: @1072119
      GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1072199), // Rule ID 15237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15237,
        GIR_EraseRootFromParent_Done,
      // Label 15519: @1072199
      GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1072279), // Rule ID 15240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15240,
        GIR_EraseRootFromParent_Done,
      // Label 15520: @1072279
      GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1072359), // Rule ID 15241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15241,
        GIR_EraseRootFromParent_Done,
      // Label 15521: @1072359
      GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1072439), // Rule ID 15244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15244,
        GIR_EraseRootFromParent_Done,
      // Label 15522: @1072439
      GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1072519), // Rule ID 15245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10767:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15245,
        GIR_EraseRootFromParent_Done,
      // Label 15523: @1072519
      GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1072599), // Rule ID 15248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15248,
        GIR_EraseRootFromParent_Done,
      // Label 15524: @1072599
      GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1072679), // Rule ID 15249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10767:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15249,
        GIR_EraseRootFromParent_Done,
      // Label 15525: @1072679
      GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1072759), // Rule ID 15252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15252,
        GIR_EraseRootFromParent_Done,
      // Label 15526: @1072759
      GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1072839), // Rule ID 15253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10767:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15253,
        GIR_EraseRootFromParent_Done,
      // Label 15527: @1072839
      GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1072919), // Rule ID 15256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15256,
        GIR_EraseRootFromParent_Done,
      // Label 15528: @1072919
      GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1072999), // Rule ID 15257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10767:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15257,
        GIR_EraseRootFromParent_Done,
      // Label 15529: @1072999
      GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1073079), // Rule ID 15260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15260,
        GIR_EraseRootFromParent_Done,
      // Label 15530: @1073079
      GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1073159), // Rule ID 15261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15261,
        GIR_EraseRootFromParent_Done,
      // Label 15531: @1073159
      GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1073239), // Rule ID 15264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15264,
        GIR_EraseRootFromParent_Done,
      // Label 15532: @1073239
      GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1073319), // Rule ID 15265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15265,
        GIR_EraseRootFromParent_Done,
      // Label 15533: @1073319
      GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1073399), // Rule ID 15268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15268,
        GIR_EraseRootFromParent_Done,
      // Label 15534: @1073399
      GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1073479), // Rule ID 15269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15269,
        GIR_EraseRootFromParent_Done,
      // Label 15535: @1073479
      GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1073559), // Rule ID 15272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15272,
        GIR_EraseRootFromParent_Done,
      // Label 15536: @1073559
      GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1073639), // Rule ID 15273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15273,
        GIR_EraseRootFromParent_Done,
      // Label 15537: @1073639
      GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1073719), // Rule ID 15276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15276,
        GIR_EraseRootFromParent_Done,
      // Label 15538: @1073719
      GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1073799), // Rule ID 15277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15277,
        GIR_EraseRootFromParent_Done,
      // Label 15539: @1073799
      GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1073879), // Rule ID 15280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15280,
        GIR_EraseRootFromParent_Done,
      // Label 15540: @1073879
      GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1073959), // Rule ID 15281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15281,
        GIR_EraseRootFromParent_Done,
      // Label 15541: @1073959
      GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1074039), // Rule ID 15284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15284,
        GIR_EraseRootFromParent_Done,
      // Label 15542: @1074039
      GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1074119), // Rule ID 15285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15285,
        GIR_EraseRootFromParent_Done,
      // Label 15543: @1074119
      GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1074199), // Rule ID 15288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15288,
        GIR_EraseRootFromParent_Done,
      // Label 15544: @1074199
      GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1074279), // Rule ID 15289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15289,
        GIR_EraseRootFromParent_Done,
      // Label 15545: @1074279
      GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1074359), // Rule ID 15292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15292,
        GIR_EraseRootFromParent_Done,
      // Label 15546: @1074359
      GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1074439), // Rule ID 15293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15293,
        GIR_EraseRootFromParent_Done,
      // Label 15547: @1074439
      GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1074519), // Rule ID 15296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15296,
        GIR_EraseRootFromParent_Done,
      // Label 15548: @1074519
      GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1074599), // Rule ID 15297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10767:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15297,
        GIR_EraseRootFromParent_Done,
      // Label 15549: @1074599
      GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1074679), // Rule ID 15300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15300,
        GIR_EraseRootFromParent_Done,
      // Label 15550: @1074679
      GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1074759), // Rule ID 15301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10767:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15301,
        GIR_EraseRootFromParent_Done,
      // Label 15551: @1074759
      GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1074839), // Rule ID 15304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15304,
        GIR_EraseRootFromParent_Done,
      // Label 15552: @1074839
      GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1074919), // Rule ID 15305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10767:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15305,
        GIR_EraseRootFromParent_Done,
      // Label 15553: @1074919
      GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1074999), // Rule ID 15308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15308,
        GIR_EraseRootFromParent_Done,
      // Label 15554: @1074999
      GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1075079), // Rule ID 15309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15309,
        GIR_EraseRootFromParent_Done,
      // Label 15555: @1075079
      GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1075159), // Rule ID 15312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15312,
        GIR_EraseRootFromParent_Done,
      // Label 15556: @1075159
      GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1075239), // Rule ID 15313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15313,
        GIR_EraseRootFromParent_Done,
      // Label 15557: @1075239
      GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1075319), // Rule ID 15316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15316,
        GIR_EraseRootFromParent_Done,
      // Label 15558: @1075319
      GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1075399), // Rule ID 15317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15317,
        GIR_EraseRootFromParent_Done,
      // Label 15559: @1075399
      GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1075479), // Rule ID 15320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15320,
        GIR_EraseRootFromParent_Done,
      // Label 15560: @1075479
      GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1075559), // Rule ID 15321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15321,
        GIR_EraseRootFromParent_Done,
      // Label 15561: @1075559
      GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1075639), // Rule ID 15324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15324,
        GIR_EraseRootFromParent_Done,
      // Label 15562: @1075639
      GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1075719), // Rule ID 15325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15325,
        GIR_EraseRootFromParent_Done,
      // Label 15563: @1075719
      GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1075799), // Rule ID 15328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15328,
        GIR_EraseRootFromParent_Done,
      // Label 15564: @1075799
      GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1075879), // Rule ID 15329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15329,
        GIR_EraseRootFromParent_Done,
      // Label 15565: @1075879
      GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1075959), // Rule ID 15332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15332,
        GIR_EraseRootFromParent_Done,
      // Label 15566: @1075959
      GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1076039), // Rule ID 15333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15333,
        GIR_EraseRootFromParent_Done,
      // Label 15567: @1076039
      GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1076119), // Rule ID 15336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15336,
        GIR_EraseRootFromParent_Done,
      // Label 15568: @1076119
      GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1076199), // Rule ID 15337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15337,
        GIR_EraseRootFromParent_Done,
      // Label 15569: @1076199
      GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1076279), // Rule ID 15340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15340,
        GIR_EraseRootFromParent_Done,
      // Label 15570: @1076279
      GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1076359), // Rule ID 15341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15341,
        GIR_EraseRootFromParent_Done,
      // Label 15571: @1076359
      GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1076439), // Rule ID 15344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15344,
        GIR_EraseRootFromParent_Done,
      // Label 15572: @1076439
      GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1076519), // Rule ID 15345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15345,
        GIR_EraseRootFromParent_Done,
      // Label 15573: @1076519
      GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1076599), // Rule ID 15348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15348,
        GIR_EraseRootFromParent_Done,
      // Label 15574: @1076599
      GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1076679), // Rule ID 15349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15349,
        GIR_EraseRootFromParent_Done,
      // Label 15575: @1076679
      GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1076759), // Rule ID 15352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15352,
        GIR_EraseRootFromParent_Done,
      // Label 15576: @1076759
      GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1076839), // Rule ID 15353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15353,
        GIR_EraseRootFromParent_Done,
      // Label 15577: @1076839
      GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1076919), // Rule ID 15356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15356,
        GIR_EraseRootFromParent_Done,
      // Label 15578: @1076919
      GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1076999), // Rule ID 15357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15357,
        GIR_EraseRootFromParent_Done,
      // Label 15579: @1076999
      GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1077079), // Rule ID 15360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15360,
        GIR_EraseRootFromParent_Done,
      // Label 15580: @1077079
      GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1077159), // Rule ID 15361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15361,
        GIR_EraseRootFromParent_Done,
      // Label 15581: @1077159
      GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1077239), // Rule ID 15364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15364,
        GIR_EraseRootFromParent_Done,
      // Label 15582: @1077239
      GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1077319), // Rule ID 15365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15365,
        GIR_EraseRootFromParent_Done,
      // Label 15583: @1077319
      GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1077399), // Rule ID 15368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15368,
        GIR_EraseRootFromParent_Done,
      // Label 15584: @1077399
      GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1077479), // Rule ID 15369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15369,
        GIR_EraseRootFromParent_Done,
      // Label 15585: @1077479
      GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1077559), // Rule ID 15372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15372,
        GIR_EraseRootFromParent_Done,
      // Label 15586: @1077559
      GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1077639), // Rule ID 15373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15373,
        GIR_EraseRootFromParent_Done,
      // Label 15587: @1077639
      GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1077719), // Rule ID 15376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15376,
        GIR_EraseRootFromParent_Done,
      // Label 15588: @1077719
      GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1077799), // Rule ID 15377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15377,
        GIR_EraseRootFromParent_Done,
      // Label 15589: @1077799
      GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1077879), // Rule ID 15380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15380,
        GIR_EraseRootFromParent_Done,
      // Label 15590: @1077879
      GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1077959), // Rule ID 15381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15381,
        GIR_EraseRootFromParent_Done,
      // Label 15591: @1077959
      GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1078039), // Rule ID 15384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15384,
        GIR_EraseRootFromParent_Done,
      // Label 15592: @1078039
      GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1078119), // Rule ID 15385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15385,
        GIR_EraseRootFromParent_Done,
      // Label 15593: @1078119
      GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1078199), // Rule ID 15388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15388,
        GIR_EraseRootFromParent_Done,
      // Label 15594: @1078199
      GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1078279), // Rule ID 15389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15389,
        GIR_EraseRootFromParent_Done,
      // Label 15595: @1078279
      GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1078359), // Rule ID 15392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15392,
        GIR_EraseRootFromParent_Done,
      // Label 15596: @1078359
      GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1078439), // Rule ID 15393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15393,
        GIR_EraseRootFromParent_Done,
      // Label 15597: @1078439
      GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1078519), // Rule ID 15396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15396,
        GIR_EraseRootFromParent_Done,
      // Label 15598: @1078519
      GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1078599), // Rule ID 15397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15397,
        GIR_EraseRootFromParent_Done,
      // Label 15599: @1078599
      GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1078679), // Rule ID 15400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15400,
        GIR_EraseRootFromParent_Done,
      // Label 15600: @1078679
      GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1078759), // Rule ID 15401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15401,
        GIR_EraseRootFromParent_Done,
      // Label 15601: @1078759
      GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1078839), // Rule ID 15404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15404,
        GIR_EraseRootFromParent_Done,
      // Label 15602: @1078839
      GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1078919), // Rule ID 15405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15405,
        GIR_EraseRootFromParent_Done,
      // Label 15603: @1078919
      GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1078999), // Rule ID 15408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15408,
        GIR_EraseRootFromParent_Done,
      // Label 15604: @1078999
      GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1079079), // Rule ID 15409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15409,
        GIR_EraseRootFromParent_Done,
      // Label 15605: @1079079
      GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1079159), // Rule ID 15412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15412,
        GIR_EraseRootFromParent_Done,
      // Label 15606: @1079159
      GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1079239), // Rule ID 15413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15413,
        GIR_EraseRootFromParent_Done,
      // Label 15607: @1079239
      GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1079319), // Rule ID 15416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15416,
        GIR_EraseRootFromParent_Done,
      // Label 15608: @1079319
      GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1079399), // Rule ID 15417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15417,
        GIR_EraseRootFromParent_Done,
      // Label 15609: @1079399
      GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1079479), // Rule ID 15420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15420,
        GIR_EraseRootFromParent_Done,
      // Label 15610: @1079479
      GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1079559), // Rule ID 15421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10745:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15421,
        GIR_EraseRootFromParent_Done,
      // Label 15611: @1079559
      GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1079639), // Rule ID 15424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15424,
        GIR_EraseRootFromParent_Done,
      // Label 15612: @1079639
      GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1079719), // Rule ID 15425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10745:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15425,
        GIR_EraseRootFromParent_Done,
      // Label 15613: @1079719
      GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1079799), // Rule ID 15428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15428,
        GIR_EraseRootFromParent_Done,
      // Label 15614: @1079799
      GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1079879), // Rule ID 15429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10745:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15429,
        GIR_EraseRootFromParent_Done,
      // Label 15615: @1079879
      GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1079959), // Rule ID 15432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15432,
        GIR_EraseRootFromParent_Done,
      // Label 15616: @1079959
      GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1080039), // Rule ID 15433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10745:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15433,
        GIR_EraseRootFromParent_Done,
      // Label 15617: @1080039
      GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1080119), // Rule ID 15436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15436,
        GIR_EraseRootFromParent_Done,
      // Label 15618: @1080119
      GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1080199), // Rule ID 15437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15437,
        GIR_EraseRootFromParent_Done,
      // Label 15619: @1080199
      GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1080279), // Rule ID 15440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15440,
        GIR_EraseRootFromParent_Done,
      // Label 15620: @1080279
      GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1080359), // Rule ID 15441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15441,
        GIR_EraseRootFromParent_Done,
      // Label 15621: @1080359
      GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1080439), // Rule ID 15444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15444,
        GIR_EraseRootFromParent_Done,
      // Label 15622: @1080439
      GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1080519), // Rule ID 15445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15445,
        GIR_EraseRootFromParent_Done,
      // Label 15623: @1080519
      GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1080599), // Rule ID 15448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15448,
        GIR_EraseRootFromParent_Done,
      // Label 15624: @1080599
      GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1080679), // Rule ID 15449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15449,
        GIR_EraseRootFromParent_Done,
      // Label 15625: @1080679
      GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1080759), // Rule ID 15452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15452,
        GIR_EraseRootFromParent_Done,
      // Label 15626: @1080759
      GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1080839), // Rule ID 15453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15453,
        GIR_EraseRootFromParent_Done,
      // Label 15627: @1080839
      GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1080919), // Rule ID 15456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15456,
        GIR_EraseRootFromParent_Done,
      // Label 15628: @1080919
      GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1080999), // Rule ID 15457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15457,
        GIR_EraseRootFromParent_Done,
      // Label 15629: @1080999
      GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1081079), // Rule ID 15460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15460,
        GIR_EraseRootFromParent_Done,
      // Label 15630: @1081079
      GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1081159), // Rule ID 15461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15461,
        GIR_EraseRootFromParent_Done,
      // Label 15631: @1081159
      GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1081239), // Rule ID 15464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15464,
        GIR_EraseRootFromParent_Done,
      // Label 15632: @1081239
      GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1081319), // Rule ID 15465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15465,
        GIR_EraseRootFromParent_Done,
      // Label 15633: @1081319
      GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1081399), // Rule ID 15468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15468,
        GIR_EraseRootFromParent_Done,
      // Label 15634: @1081399
      GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1081479), // Rule ID 15469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15469,
        GIR_EraseRootFromParent_Done,
      // Label 15635: @1081479
      GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1081559), // Rule ID 15472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15472,
        GIR_EraseRootFromParent_Done,
      // Label 15636: @1081559
      GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1081639), // Rule ID 15473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10745:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15473,
        GIR_EraseRootFromParent_Done,
      // Label 15637: @1081639
      GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1081719), // Rule ID 15476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15476,
        GIR_EraseRootFromParent_Done,
      // Label 15638: @1081719
      GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1081799), // Rule ID 15477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10745:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15477,
        GIR_EraseRootFromParent_Done,
      // Label 15639: @1081799
      GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1081879), // Rule ID 15480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15480,
        GIR_EraseRootFromParent_Done,
      // Label 15640: @1081879
      GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1081959), // Rule ID 15481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10745:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15481,
        GIR_EraseRootFromParent_Done,
      // Label 15641: @1081959
      GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1082042), // Rule ID 15484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15484,
        GIR_EraseRootFromParent_Done,
      // Label 15642: @1082042
      GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1082125), // Rule ID 15485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15485,
        GIR_EraseRootFromParent_Done,
      // Label 15643: @1082125
      GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1082208), // Rule ID 15488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15488,
        GIR_EraseRootFromParent_Done,
      // Label 15644: @1082208
      GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1082291), // Rule ID 15489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15489,
        GIR_EraseRootFromParent_Done,
      // Label 15645: @1082291
      GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1082374), // Rule ID 15492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15492,
        GIR_EraseRootFromParent_Done,
      // Label 15646: @1082374
      GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1082457), // Rule ID 15493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15493,
        GIR_EraseRootFromParent_Done,
      // Label 15647: @1082457
      GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1082540), // Rule ID 15496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15496,
        GIR_EraseRootFromParent_Done,
      // Label 15648: @1082540
      GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1082623), // Rule ID 15497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15497,
        GIR_EraseRootFromParent_Done,
      // Label 15649: @1082623
      GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1082706), // Rule ID 15500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15500,
        GIR_EraseRootFromParent_Done,
      // Label 15650: @1082706
      GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1082789), // Rule ID 15501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15501,
        GIR_EraseRootFromParent_Done,
      // Label 15651: @1082789
      GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1082872), // Rule ID 15504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15504,
        GIR_EraseRootFromParent_Done,
      // Label 15652: @1082872
      GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1082955), // Rule ID 15505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15505,
        GIR_EraseRootFromParent_Done,
      // Label 15653: @1082955
      GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1083038), // Rule ID 15508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15508,
        GIR_EraseRootFromParent_Done,
      // Label 15654: @1083038
      GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1083121), // Rule ID 15509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15509,
        GIR_EraseRootFromParent_Done,
      // Label 15655: @1083121
      GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1083204), // Rule ID 15512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15512,
        GIR_EraseRootFromParent_Done,
      // Label 15656: @1083204
      GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1083287), // Rule ID 15513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15513,
        GIR_EraseRootFromParent_Done,
      // Label 15657: @1083287
      GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1083370), // Rule ID 15516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15516,
        GIR_EraseRootFromParent_Done,
      // Label 15658: @1083370
      GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1083453), // Rule ID 15517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15517,
        GIR_EraseRootFromParent_Done,
      // Label 15659: @1083453
      GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1083536), // Rule ID 15520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15520,
        GIR_EraseRootFromParent_Done,
      // Label 15660: @1083536
      GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1083619), // Rule ID 15521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15521,
        GIR_EraseRootFromParent_Done,
      // Label 15661: @1083619
      GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1083702), // Rule ID 15524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15524,
        GIR_EraseRootFromParent_Done,
      // Label 15662: @1083702
      GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1083785), // Rule ID 15525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15525,
        GIR_EraseRootFromParent_Done,
      // Label 15663: @1083785
      GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1083868), // Rule ID 15528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15528,
        GIR_EraseRootFromParent_Done,
      // Label 15664: @1083868
      GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1083951), // Rule ID 15529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15529,
        GIR_EraseRootFromParent_Done,
      // Label 15665: @1083951
      GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1084034), // Rule ID 15532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15532,
        GIR_EraseRootFromParent_Done,
      // Label 15666: @1084034
      GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1084117), // Rule ID 15533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15533,
        GIR_EraseRootFromParent_Done,
      // Label 15667: @1084117
      GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1084200), // Rule ID 15536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15536,
        GIR_EraseRootFromParent_Done,
      // Label 15668: @1084200
      GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1084283), // Rule ID 15537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15537,
        GIR_EraseRootFromParent_Done,
      // Label 15669: @1084283
      GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1084366), // Rule ID 15540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15540,
        GIR_EraseRootFromParent_Done,
      // Label 15670: @1084366
      GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1084449), // Rule ID 15541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15541,
        GIR_EraseRootFromParent_Done,
      // Label 15671: @1084449
      GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1084532), // Rule ID 15544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15544,
        GIR_EraseRootFromParent_Done,
      // Label 15672: @1084532
      GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1084615), // Rule ID 15545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15545,
        GIR_EraseRootFromParent_Done,
      // Label 15673: @1084615
      GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1084698), // Rule ID 15548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15548,
        GIR_EraseRootFromParent_Done,
      // Label 15674: @1084698
      GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1084781), // Rule ID 15549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15549,
        GIR_EraseRootFromParent_Done,
      // Label 15675: @1084781
      GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1084864), // Rule ID 15552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15552,
        GIR_EraseRootFromParent_Done,
      // Label 15676: @1084864
      GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1084947), // Rule ID 15553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15553,
        GIR_EraseRootFromParent_Done,
      // Label 15677: @1084947
      GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1085030), // Rule ID 15556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15556,
        GIR_EraseRootFromParent_Done,
      // Label 15678: @1085030
      GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1085113), // Rule ID 15557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15557,
        GIR_EraseRootFromParent_Done,
      // Label 15679: @1085113
      GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1085196), // Rule ID 15560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15560,
        GIR_EraseRootFromParent_Done,
      // Label 15680: @1085196
      GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1085279), // Rule ID 15561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15561,
        GIR_EraseRootFromParent_Done,
      // Label 15681: @1085279
      GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1085362), // Rule ID 15564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15564,
        GIR_EraseRootFromParent_Done,
      // Label 15682: @1085362
      GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1085445), // Rule ID 15565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15565,
        GIR_EraseRootFromParent_Done,
      // Label 15683: @1085445
      GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1085528), // Rule ID 15568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15568,
        GIR_EraseRootFromParent_Done,
      // Label 15684: @1085528
      GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1085611), // Rule ID 15569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15569,
        GIR_EraseRootFromParent_Done,
      // Label 15685: @1085611
      GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1085694), // Rule ID 15572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15572,
        GIR_EraseRootFromParent_Done,
      // Label 15686: @1085694
      GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1085777), // Rule ID 15573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15573,
        GIR_EraseRootFromParent_Done,
      // Label 15687: @1085777
      GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1085860), // Rule ID 15576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15576,
        GIR_EraseRootFromParent_Done,
      // Label 15688: @1085860
      GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1085943), // Rule ID 15577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15577,
        GIR_EraseRootFromParent_Done,
      // Label 15689: @1085943
      GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1086026), // Rule ID 15580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15580,
        GIR_EraseRootFromParent_Done,
      // Label 15690: @1086026
      GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1086109), // Rule ID 15581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15581,
        GIR_EraseRootFromParent_Done,
      // Label 15691: @1086109
      GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1086192), // Rule ID 15584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15584,
        GIR_EraseRootFromParent_Done,
      // Label 15692: @1086192
      GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1086275), // Rule ID 15585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15585,
        GIR_EraseRootFromParent_Done,
      // Label 15693: @1086275
      GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1086358), // Rule ID 15588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15588,
        GIR_EraseRootFromParent_Done,
      // Label 15694: @1086358
      GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1086441), // Rule ID 15589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15589,
        GIR_EraseRootFromParent_Done,
      // Label 15695: @1086441
      GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1086524), // Rule ID 15592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15592,
        GIR_EraseRootFromParent_Done,
      // Label 15696: @1086524
      GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1086607), // Rule ID 15593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15593,
        GIR_EraseRootFromParent_Done,
      // Label 15697: @1086607
      GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1086690), // Rule ID 15596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15596,
        GIR_EraseRootFromParent_Done,
      // Label 15698: @1086690
      GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1086773), // Rule ID 15597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15597,
        GIR_EraseRootFromParent_Done,
      // Label 15699: @1086773
      GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1086856), // Rule ID 15600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15600,
        GIR_EraseRootFromParent_Done,
      // Label 15700: @1086856
      GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1086939), // Rule ID 15601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15601,
        GIR_EraseRootFromParent_Done,
      // Label 15701: @1086939
      GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1087022), // Rule ID 15604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15604,
        GIR_EraseRootFromParent_Done,
      // Label 15702: @1087022
      GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1087105), // Rule ID 15605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15605,
        GIR_EraseRootFromParent_Done,
      // Label 15703: @1087105
      GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1087188), // Rule ID 15608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15608,
        GIR_EraseRootFromParent_Done,
      // Label 15704: @1087188
      GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1087271), // Rule ID 15609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15609,
        GIR_EraseRootFromParent_Done,
      // Label 15705: @1087271
      GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1087354), // Rule ID 15612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15612,
        GIR_EraseRootFromParent_Done,
      // Label 15706: @1087354
      GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1087437), // Rule ID 15613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15613,
        GIR_EraseRootFromParent_Done,
      // Label 15707: @1087437
      GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1087520), // Rule ID 15616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15616,
        GIR_EraseRootFromParent_Done,
      // Label 15708: @1087520
      GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1087603), // Rule ID 15617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15617,
        GIR_EraseRootFromParent_Done,
      // Label 15709: @1087603
      GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1087686), // Rule ID 15620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15620,
        GIR_EraseRootFromParent_Done,
      // Label 15710: @1087686
      GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1087769), // Rule ID 15621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15621,
        GIR_EraseRootFromParent_Done,
      // Label 15711: @1087769
      GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1087852), // Rule ID 15624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15624,
        GIR_EraseRootFromParent_Done,
      // Label 15712: @1087852
      GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1087935), // Rule ID 15625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15625,
        GIR_EraseRootFromParent_Done,
      // Label 15713: @1087935
      GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1088018), // Rule ID 15628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15628,
        GIR_EraseRootFromParent_Done,
      // Label 15714: @1088018
      GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1088101), // Rule ID 15629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15629,
        GIR_EraseRootFromParent_Done,
      // Label 15715: @1088101
      GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1088184), // Rule ID 15632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15632,
        GIR_EraseRootFromParent_Done,
      // Label 15716: @1088184
      GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1088267), // Rule ID 15633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15633,
        GIR_EraseRootFromParent_Done,
      // Label 15717: @1088267
      GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1088350), // Rule ID 15636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15636,
        GIR_EraseRootFromParent_Done,
      // Label 15718: @1088350
      GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1088433), // Rule ID 15637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15637,
        GIR_EraseRootFromParent_Done,
      // Label 15719: @1088433
      GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1088516), // Rule ID 15640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15640,
        GIR_EraseRootFromParent_Done,
      // Label 15720: @1088516
      GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1088599), // Rule ID 15641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15641,
        GIR_EraseRootFromParent_Done,
      // Label 15721: @1088599
      GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1088682), // Rule ID 15644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15644,
        GIR_EraseRootFromParent_Done,
      // Label 15722: @1088682
      GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1088765), // Rule ID 15645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15645,
        GIR_EraseRootFromParent_Done,
      // Label 15723: @1088765
      GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1088848), // Rule ID 15648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15648,
        GIR_EraseRootFromParent_Done,
      // Label 15724: @1088848
      GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1088931), // Rule ID 15649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15649,
        GIR_EraseRootFromParent_Done,
      // Label 15725: @1088931
      GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1089014), // Rule ID 15652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15652,
        GIR_EraseRootFromParent_Done,
      // Label 15726: @1089014
      GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1089097), // Rule ID 15653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15653,
        GIR_EraseRootFromParent_Done,
      // Label 15727: @1089097
      GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1089180), // Rule ID 15656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15656,
        GIR_EraseRootFromParent_Done,
      // Label 15728: @1089180
      GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1089263), // Rule ID 15657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15657,
        GIR_EraseRootFromParent_Done,
      // Label 15729: @1089263
      GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1089343), // Rule ID 15660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15660,
        GIR_EraseRootFromParent_Done,
      // Label 15730: @1089343
      GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1089423), // Rule ID 15661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15661,
        GIR_EraseRootFromParent_Done,
      // Label 15731: @1089423
      GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1089503), // Rule ID 15664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15664,
        GIR_EraseRootFromParent_Done,
      // Label 15732: @1089503
      GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1089583), // Rule ID 15665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15665,
        GIR_EraseRootFromParent_Done,
      // Label 15733: @1089583
      GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1089663), // Rule ID 15668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15668,
        GIR_EraseRootFromParent_Done,
      // Label 15734: @1089663
      GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1089743), // Rule ID 15669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15669,
        GIR_EraseRootFromParent_Done,
      // Label 15735: @1089743
      GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1089823), // Rule ID 15672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15672,
        GIR_EraseRootFromParent_Done,
      // Label 15736: @1089823
      GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1089903), // Rule ID 15673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15673,
        GIR_EraseRootFromParent_Done,
      // Label 15737: @1089903
      GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1089983), // Rule ID 15676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15676,
        GIR_EraseRootFromParent_Done,
      // Label 15738: @1089983
      GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1090063), // Rule ID 15677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15677,
        GIR_EraseRootFromParent_Done,
      // Label 15739: @1090063
      GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1090143), // Rule ID 15680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15680,
        GIR_EraseRootFromParent_Done,
      // Label 15740: @1090143
      GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1090223), // Rule ID 15681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15681,
        GIR_EraseRootFromParent_Done,
      // Label 15741: @1090223
      GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1090303), // Rule ID 15684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15684,
        GIR_EraseRootFromParent_Done,
      // Label 15742: @1090303
      GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1090383), // Rule ID 15685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15685,
        GIR_EraseRootFromParent_Done,
      // Label 15743: @1090383
      GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1090463), // Rule ID 15688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15688,
        GIR_EraseRootFromParent_Done,
      // Label 15744: @1090463
      GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1090543), // Rule ID 15689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15689,
        GIR_EraseRootFromParent_Done,
      // Label 15745: @1090543
      GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1090623), // Rule ID 15692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15692,
        GIR_EraseRootFromParent_Done,
      // Label 15746: @1090623
      GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1090703), // Rule ID 15693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15693,
        GIR_EraseRootFromParent_Done,
      // Label 15747: @1090703
      GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1090783), // Rule ID 15696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15696,
        GIR_EraseRootFromParent_Done,
      // Label 15748: @1090783
      GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1090863), // Rule ID 15697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15697,
        GIR_EraseRootFromParent_Done,
      // Label 15749: @1090863
      GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1090943), // Rule ID 15700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15700,
        GIR_EraseRootFromParent_Done,
      // Label 15750: @1090943
      GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1091023), // Rule ID 15701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15701,
        GIR_EraseRootFromParent_Done,
      // Label 15751: @1091023
      GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1091103), // Rule ID 15704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15704,
        GIR_EraseRootFromParent_Done,
      // Label 15752: @1091103
      GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1091183), // Rule ID 15705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15705,
        GIR_EraseRootFromParent_Done,
      // Label 15753: @1091183
      GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1091263), // Rule ID 15708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15708,
        GIR_EraseRootFromParent_Done,
      // Label 15754: @1091263
      GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1091343), // Rule ID 15709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15709,
        GIR_EraseRootFromParent_Done,
      // Label 15755: @1091343
      GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1091423), // Rule ID 15712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15712,
        GIR_EraseRootFromParent_Done,
      // Label 15756: @1091423
      GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1091503), // Rule ID 15713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15713,
        GIR_EraseRootFromParent_Done,
      // Label 15757: @1091503
      GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1091583), // Rule ID 15716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15716,
        GIR_EraseRootFromParent_Done,
      // Label 15758: @1091583
      GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1091663), // Rule ID 15717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15717,
        GIR_EraseRootFromParent_Done,
      // Label 15759: @1091663
      GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1091743), // Rule ID 15720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15720,
        GIR_EraseRootFromParent_Done,
      // Label 15760: @1091743
      GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1091823), // Rule ID 15721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15721,
        GIR_EraseRootFromParent_Done,
      // Label 15761: @1091823
      GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1091903), // Rule ID 15724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15724,
        GIR_EraseRootFromParent_Done,
      // Label 15762: @1091903
      GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1091983), // Rule ID 15725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15725,
        GIR_EraseRootFromParent_Done,
      // Label 15763: @1091983
      GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1092063), // Rule ID 15728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15728,
        GIR_EraseRootFromParent_Done,
      // Label 15764: @1092063
      GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1092143), // Rule ID 15729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15729,
        GIR_EraseRootFromParent_Done,
      // Label 15765: @1092143
      GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1092223), // Rule ID 15732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15732,
        GIR_EraseRootFromParent_Done,
      // Label 15766: @1092223
      GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1092303), // Rule ID 15733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15733,
        GIR_EraseRootFromParent_Done,
      // Label 15767: @1092303
      GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1092383), // Rule ID 15736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15736,
        GIR_EraseRootFromParent_Done,
      // Label 15768: @1092383
      GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1092463), // Rule ID 15737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15737,
        GIR_EraseRootFromParent_Done,
      // Label 15769: @1092463
      GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1092543), // Rule ID 15740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15740,
        GIR_EraseRootFromParent_Done,
      // Label 15770: @1092543
      GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1092623), // Rule ID 15741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15741,
        GIR_EraseRootFromParent_Done,
      // Label 15771: @1092623
      GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1092703), // Rule ID 15744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15744,
        GIR_EraseRootFromParent_Done,
      // Label 15772: @1092703
      GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1092783), // Rule ID 15745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15745,
        GIR_EraseRootFromParent_Done,
      // Label 15773: @1092783
      GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1092863), // Rule ID 15748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15748,
        GIR_EraseRootFromParent_Done,
      // Label 15774: @1092863
      GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1092943), // Rule ID 15749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15749,
        GIR_EraseRootFromParent_Done,
      // Label 15775: @1092943
      GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1093023), // Rule ID 15752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15752,
        GIR_EraseRootFromParent_Done,
      // Label 15776: @1093023
      GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1093103), // Rule ID 15753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15753,
        GIR_EraseRootFromParent_Done,
      // Label 15777: @1093103
      GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1093183), // Rule ID 15756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15756,
        GIR_EraseRootFromParent_Done,
      // Label 15778: @1093183
      GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1093263), // Rule ID 15757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15757,
        GIR_EraseRootFromParent_Done,
      // Label 15779: @1093263
      GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1093343), // Rule ID 15760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15760,
        GIR_EraseRootFromParent_Done,
      // Label 15780: @1093343
      GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1093423), // Rule ID 15761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15761,
        GIR_EraseRootFromParent_Done,
      // Label 15781: @1093423
      GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1093503), // Rule ID 15764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15764,
        GIR_EraseRootFromParent_Done,
      // Label 15782: @1093503
      GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1093583), // Rule ID 15765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15765,
        GIR_EraseRootFromParent_Done,
      // Label 15783: @1093583
      GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1093663), // Rule ID 15768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15768,
        GIR_EraseRootFromParent_Done,
      // Label 15784: @1093663
      GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1093743), // Rule ID 15769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15769,
        GIR_EraseRootFromParent_Done,
      // Label 15785: @1093743
      GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1093823), // Rule ID 15772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15772,
        GIR_EraseRootFromParent_Done,
      // Label 15786: @1093823
      GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1093903), // Rule ID 15773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11208:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15773,
        GIR_EraseRootFromParent_Done,
      // Label 15787: @1093903
      GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1093983), // Rule ID 15776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15776,
        GIR_EraseRootFromParent_Done,
      // Label 15788: @1093983
      GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1094063), // Rule ID 15777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15777,
        GIR_EraseRootFromParent_Done,
      // Label 15789: @1094063
      GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1094143), // Rule ID 15780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15780,
        GIR_EraseRootFromParent_Done,
      // Label 15790: @1094143
      GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1094223), // Rule ID 15781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15781,
        GIR_EraseRootFromParent_Done,
      // Label 15791: @1094223
      GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1094303), // Rule ID 15784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15784,
        GIR_EraseRootFromParent_Done,
      // Label 15792: @1094303
      GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1094383), // Rule ID 15785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15785,
        GIR_EraseRootFromParent_Done,
      // Label 15793: @1094383
      GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1094463), // Rule ID 15788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15788,
        GIR_EraseRootFromParent_Done,
      // Label 15794: @1094463
      GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1094543), // Rule ID 15789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15789,
        GIR_EraseRootFromParent_Done,
      // Label 15795: @1094543
      GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1094623), // Rule ID 15792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15792,
        GIR_EraseRootFromParent_Done,
      // Label 15796: @1094623
      GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1094703), // Rule ID 15793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15793,
        GIR_EraseRootFromParent_Done,
      // Label 15797: @1094703
      GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1094783), // Rule ID 15796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15796,
        GIR_EraseRootFromParent_Done,
      // Label 15798: @1094783
      GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1094863), // Rule ID 15797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15797,
        GIR_EraseRootFromParent_Done,
      // Label 15799: @1094863
      GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1094943), // Rule ID 15800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15800,
        GIR_EraseRootFromParent_Done,
      // Label 15800: @1094943
      GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1095023), // Rule ID 15801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15801,
        GIR_EraseRootFromParent_Done,
      // Label 15801: @1095023
      GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1095103), // Rule ID 15804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15804,
        GIR_EraseRootFromParent_Done,
      // Label 15802: @1095103
      GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1095183), // Rule ID 15805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15805,
        GIR_EraseRootFromParent_Done,
      // Label 15803: @1095183
      GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1095263), // Rule ID 15808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15808,
        GIR_EraseRootFromParent_Done,
      // Label 15804: @1095263
      GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1095343), // Rule ID 15809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15809,
        GIR_EraseRootFromParent_Done,
      // Label 15805: @1095343
      GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1095423), // Rule ID 15812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15812,
        GIR_EraseRootFromParent_Done,
      // Label 15806: @1095423
      GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1095503), // Rule ID 15813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15813,
        GIR_EraseRootFromParent_Done,
      // Label 15807: @1095503
      GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1095583), // Rule ID 15816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15816,
        GIR_EraseRootFromParent_Done,
      // Label 15808: @1095583
      GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1095663), // Rule ID 15817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15817,
        GIR_EraseRootFromParent_Done,
      // Label 15809: @1095663
      GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1095743), // Rule ID 15820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15820,
        GIR_EraseRootFromParent_Done,
      // Label 15810: @1095743
      GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1095823), // Rule ID 15821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15821,
        GIR_EraseRootFromParent_Done,
      // Label 15811: @1095823
      GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1095903), // Rule ID 15824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15824,
        GIR_EraseRootFromParent_Done,
      // Label 15812: @1095903
      GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1095983), // Rule ID 15825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15825,
        GIR_EraseRootFromParent_Done,
      // Label 15813: @1095983
      GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1096063), // Rule ID 15828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15828,
        GIR_EraseRootFromParent_Done,
      // Label 15814: @1096063
      GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1096143), // Rule ID 15829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15829,
        GIR_EraseRootFromParent_Done,
      // Label 15815: @1096143
      GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1096223), // Rule ID 15832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15832,
        GIR_EraseRootFromParent_Done,
      // Label 15816: @1096223
      GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1096303), // Rule ID 15833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15833,
        GIR_EraseRootFromParent_Done,
      // Label 15817: @1096303
      GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1096383), // Rule ID 15924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15924,
        GIR_EraseRootFromParent_Done,
      // Label 15818: @1096383
      GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1096463), // Rule ID 15925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15925,
        GIR_EraseRootFromParent_Done,
      // Label 15819: @1096463
      GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1096543), // Rule ID 15928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15928,
        GIR_EraseRootFromParent_Done,
      // Label 15820: @1096543
      GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1096623), // Rule ID 15929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15929,
        GIR_EraseRootFromParent_Done,
      // Label 15821: @1096623
      GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1096703), // Rule ID 15932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15932,
        GIR_EraseRootFromParent_Done,
      // Label 15822: @1096703
      GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1096783), // Rule ID 15933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15933,
        GIR_EraseRootFromParent_Done,
      // Label 15823: @1096783
      GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1096863), // Rule ID 15936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15936,
        GIR_EraseRootFromParent_Done,
      // Label 15824: @1096863
      GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1096943), // Rule ID 15937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15937,
        GIR_EraseRootFromParent_Done,
      // Label 15825: @1096943
      GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1097023), // Rule ID 15940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15940,
        GIR_EraseRootFromParent_Done,
      // Label 15826: @1097023
      GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1097103), // Rule ID 15941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15941,
        GIR_EraseRootFromParent_Done,
      // Label 15827: @1097103
      GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1097183), // Rule ID 15944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15944,
        GIR_EraseRootFromParent_Done,
      // Label 15828: @1097183
      GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1097263), // Rule ID 15945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15945,
        GIR_EraseRootFromParent_Done,
      // Label 15829: @1097263
      GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1097343), // Rule ID 15948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15948,
        GIR_EraseRootFromParent_Done,
      // Label 15830: @1097343
      GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1097423), // Rule ID 15949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15949,
        GIR_EraseRootFromParent_Done,
      // Label 15831: @1097423
      GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1097503), // Rule ID 15952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15952,
        GIR_EraseRootFromParent_Done,
      // Label 15832: @1097503
      GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1097583), // Rule ID 15953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15953,
        GIR_EraseRootFromParent_Done,
      // Label 15833: @1097583
      GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1097663), // Rule ID 15956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15956,
        GIR_EraseRootFromParent_Done,
      // Label 15834: @1097663
      GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1097743), // Rule ID 15957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15957,
        GIR_EraseRootFromParent_Done,
      // Label 15835: @1097743
      GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1097823), // Rule ID 15960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15960,
        GIR_EraseRootFromParent_Done,
      // Label 15836: @1097823
      GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1097903), // Rule ID 15961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15961,
        GIR_EraseRootFromParent_Done,
      // Label 15837: @1097903
      GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1097983), // Rule ID 15964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15964,
        GIR_EraseRootFromParent_Done,
      // Label 15838: @1097983
      GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1098063), // Rule ID 15965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15965,
        GIR_EraseRootFromParent_Done,
      // Label 15839: @1098063
      GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1098143), // Rule ID 15968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15968,
        GIR_EraseRootFromParent_Done,
      // Label 15840: @1098143
      GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1098223), // Rule ID 15969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15969,
        GIR_EraseRootFromParent_Done,
      // Label 15841: @1098223
      GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1098303), // Rule ID 15972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15972,
        GIR_EraseRootFromParent_Done,
      // Label 15842: @1098303
      GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1098383), // Rule ID 15973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15973,
        GIR_EraseRootFromParent_Done,
      // Label 15843: @1098383
      GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1098463), // Rule ID 15976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15976,
        GIR_EraseRootFromParent_Done,
      // Label 15844: @1098463
      GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1098543), // Rule ID 15977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15977,
        GIR_EraseRootFromParent_Done,
      // Label 15845: @1098543
      GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1098623), // Rule ID 15980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15980,
        GIR_EraseRootFromParent_Done,
      // Label 15846: @1098623
      GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1098703), // Rule ID 15981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15981,
        GIR_EraseRootFromParent_Done,
      // Label 15847: @1098703
      GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1098783), // Rule ID 15984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15984,
        GIR_EraseRootFromParent_Done,
      // Label 15848: @1098783
      GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1098863), // Rule ID 15985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15985,
        GIR_EraseRootFromParent_Done,
      // Label 15849: @1098863
      GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1098943), // Rule ID 15988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15988,
        GIR_EraseRootFromParent_Done,
      // Label 15850: @1098943
      GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1099023), // Rule ID 15989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15989,
        GIR_EraseRootFromParent_Done,
      // Label 15851: @1099023
      GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1099103), // Rule ID 15992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15992,
        GIR_EraseRootFromParent_Done,
      // Label 15852: @1099103
      GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1099183), // Rule ID 15993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15993,
        GIR_EraseRootFromParent_Done,
      // Label 15853: @1099183
      GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1099263), // Rule ID 15996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15996,
        GIR_EraseRootFromParent_Done,
      // Label 15854: @1099263
      GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1099343), // Rule ID 15997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15997,
        GIR_EraseRootFromParent_Done,
      // Label 15855: @1099343
      GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1099423), // Rule ID 16000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16000,
        GIR_EraseRootFromParent_Done,
      // Label 15856: @1099423
      GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1099503), // Rule ID 16001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16001,
        GIR_EraseRootFromParent_Done,
      // Label 15857: @1099503
      GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1099583), // Rule ID 16004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16004,
        GIR_EraseRootFromParent_Done,
      // Label 15858: @1099583
      GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1099663), // Rule ID 16005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16005,
        GIR_EraseRootFromParent_Done,
      // Label 15859: @1099663
      GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1099743), // Rule ID 16008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16008,
        GIR_EraseRootFromParent_Done,
      // Label 15860: @1099743
      GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1099823), // Rule ID 16009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16009,
        GIR_EraseRootFromParent_Done,
      // Label 15861: @1099823
      GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1099903), // Rule ID 16012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16012,
        GIR_EraseRootFromParent_Done,
      // Label 15862: @1099903
      GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1099983), // Rule ID 16013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16013,
        GIR_EraseRootFromParent_Done,
      // Label 15863: @1099983
      GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1100063), // Rule ID 16016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16016,
        GIR_EraseRootFromParent_Done,
      // Label 15864: @1100063
      GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1100143), // Rule ID 16017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16017,
        GIR_EraseRootFromParent_Done,
      // Label 15865: @1100143
      GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1100223), // Rule ID 16020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16020,
        GIR_EraseRootFromParent_Done,
      // Label 15866: @1100223
      GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1100303), // Rule ID 16021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16021,
        GIR_EraseRootFromParent_Done,
      // Label 15867: @1100303
      GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1100383), // Rule ID 16024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16024,
        GIR_EraseRootFromParent_Done,
      // Label 15868: @1100383
      GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1100463), // Rule ID 16025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16025,
        GIR_EraseRootFromParent_Done,
      // Label 15869: @1100463
      GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1100543), // Rule ID 16028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16028,
        GIR_EraseRootFromParent_Done,
      // Label 15870: @1100543
      GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1100623), // Rule ID 16029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16029,
        GIR_EraseRootFromParent_Done,
      // Label 15871: @1100623
      GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1100703), // Rule ID 16032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16032,
        GIR_EraseRootFromParent_Done,
      // Label 15872: @1100703
      GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1100783), // Rule ID 16033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16033,
        GIR_EraseRootFromParent_Done,
      // Label 15873: @1100783
      GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1100863), // Rule ID 16036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16036,
        GIR_EraseRootFromParent_Done,
      // Label 15874: @1100863
      GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1100943), // Rule ID 16037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11206:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16037,
        GIR_EraseRootFromParent_Done,
      // Label 15875: @1100943
      GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1101023), // Rule ID 16040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16040,
        GIR_EraseRootFromParent_Done,
      // Label 15876: @1101023
      GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1101103), // Rule ID 16041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16041,
        GIR_EraseRootFromParent_Done,
      // Label 15877: @1101103
      GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1101183), // Rule ID 16044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16044,
        GIR_EraseRootFromParent_Done,
      // Label 15878: @1101183
      GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1101263), // Rule ID 16045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16045,
        GIR_EraseRootFromParent_Done,
      // Label 15879: @1101263
      GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1101343), // Rule ID 16048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16048,
        GIR_EraseRootFromParent_Done,
      // Label 15880: @1101343
      GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1101423), // Rule ID 16049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16049,
        GIR_EraseRootFromParent_Done,
      // Label 15881: @1101423
      GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1101503), // Rule ID 16052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16052,
        GIR_EraseRootFromParent_Done,
      // Label 15882: @1101503
      GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1101583), // Rule ID 16053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16053,
        GIR_EraseRootFromParent_Done,
      // Label 15883: @1101583
      GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1101663), // Rule ID 16056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16056,
        GIR_EraseRootFromParent_Done,
      // Label 15884: @1101663
      GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1101743), // Rule ID 16057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16057,
        GIR_EraseRootFromParent_Done,
      // Label 15885: @1101743
      GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1101823), // Rule ID 16060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16060,
        GIR_EraseRootFromParent_Done,
      // Label 15886: @1101823
      GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1101903), // Rule ID 16061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16061,
        GIR_EraseRootFromParent_Done,
      // Label 15887: @1101903
      GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1101983), // Rule ID 16064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16064,
        GIR_EraseRootFromParent_Done,
      // Label 15888: @1101983
      GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1102063), // Rule ID 16065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16065,
        GIR_EraseRootFromParent_Done,
      // Label 15889: @1102063
      GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1102143), // Rule ID 16068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16068,
        GIR_EraseRootFromParent_Done,
      // Label 15890: @1102143
      GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1102223), // Rule ID 16069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16069,
        GIR_EraseRootFromParent_Done,
      // Label 15891: @1102223
      GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1102303), // Rule ID 16072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16072,
        GIR_EraseRootFromParent_Done,
      // Label 15892: @1102303
      GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1102383), // Rule ID 16073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16073,
        GIR_EraseRootFromParent_Done,
      // Label 15893: @1102383
      GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1102463), // Rule ID 16076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16076,
        GIR_EraseRootFromParent_Done,
      // Label 15894: @1102463
      GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1102543), // Rule ID 16077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16077,
        GIR_EraseRootFromParent_Done,
      // Label 15895: @1102543
      GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1102623), // Rule ID 16080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16080,
        GIR_EraseRootFromParent_Done,
      // Label 15896: @1102623
      GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1102703), // Rule ID 16081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16081,
        GIR_EraseRootFromParent_Done,
      // Label 15897: @1102703
      GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1102783), // Rule ID 16084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16084,
        GIR_EraseRootFromParent_Done,
      // Label 15898: @1102783
      GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1102863), // Rule ID 16085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16085,
        GIR_EraseRootFromParent_Done,
      // Label 15899: @1102863
      GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1102943), // Rule ID 16088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16088,
        GIR_EraseRootFromParent_Done,
      // Label 15900: @1102943
      GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1103023), // Rule ID 16089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16089,
        GIR_EraseRootFromParent_Done,
      // Label 15901: @1103023
      GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1103103), // Rule ID 16092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16092,
        GIR_EraseRootFromParent_Done,
      // Label 15902: @1103103
      GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1103183), // Rule ID 16093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16093,
        GIR_EraseRootFromParent_Done,
      // Label 15903: @1103183
      GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1103263), // Rule ID 16096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16096,
        GIR_EraseRootFromParent_Done,
      // Label 15904: @1103263
      GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1103343), // Rule ID 16097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16097,
        GIR_EraseRootFromParent_Done,
      // Label 15905: @1103343
      GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1103426), // Rule ID 16188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16188,
        GIR_EraseRootFromParent_Done,
      // Label 15906: @1103426
      GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1103509), // Rule ID 16189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16189,
        GIR_EraseRootFromParent_Done,
      // Label 15907: @1103509
      GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1103592), // Rule ID 16192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16192,
        GIR_EraseRootFromParent_Done,
      // Label 15908: @1103592
      GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1103675), // Rule ID 16193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16193,
        GIR_EraseRootFromParent_Done,
      // Label 15909: @1103675
      GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1103758), // Rule ID 16196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16196,
        GIR_EraseRootFromParent_Done,
      // Label 15910: @1103758
      GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1103841), // Rule ID 16197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16197,
        GIR_EraseRootFromParent_Done,
      // Label 15911: @1103841
      GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1103924), // Rule ID 16200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16200,
        GIR_EraseRootFromParent_Done,
      // Label 15912: @1103924
      GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1104007), // Rule ID 16201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16201,
        GIR_EraseRootFromParent_Done,
      // Label 15913: @1104007
      GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1104090), // Rule ID 16204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16204,
        GIR_EraseRootFromParent_Done,
      // Label 15914: @1104090
      GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1104173), // Rule ID 16205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16205,
        GIR_EraseRootFromParent_Done,
      // Label 15915: @1104173
      GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1104256), // Rule ID 16208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16208,
        GIR_EraseRootFromParent_Done,
      // Label 15916: @1104256
      GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1104339), // Rule ID 16209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16209,
        GIR_EraseRootFromParent_Done,
      // Label 15917: @1104339
      GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1104422), // Rule ID 16212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16212,
        GIR_EraseRootFromParent_Done,
      // Label 15918: @1104422
      GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1104505), // Rule ID 16213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16213,
        GIR_EraseRootFromParent_Done,
      // Label 15919: @1104505
      GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1104588), // Rule ID 16216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16216,
        GIR_EraseRootFromParent_Done,
      // Label 15920: @1104588
      GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1104671), // Rule ID 16217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16217,
        GIR_EraseRootFromParent_Done,
      // Label 15921: @1104671
      GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1104754), // Rule ID 16220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16220,
        GIR_EraseRootFromParent_Done,
      // Label 15922: @1104754
      GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1104837), // Rule ID 16221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16221,
        GIR_EraseRootFromParent_Done,
      // Label 15923: @1104837
      GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1104920), // Rule ID 16224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16224,
        GIR_EraseRootFromParent_Done,
      // Label 15924: @1104920
      GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1105003), // Rule ID 16225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16225,
        GIR_EraseRootFromParent_Done,
      // Label 15925: @1105003
      GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1105086), // Rule ID 16228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16228,
        GIR_EraseRootFromParent_Done,
      // Label 15926: @1105086
      GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1105169), // Rule ID 16229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16229,
        GIR_EraseRootFromParent_Done,
      // Label 15927: @1105169
      GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1105252), // Rule ID 16232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16232,
        GIR_EraseRootFromParent_Done,
      // Label 15928: @1105252
      GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1105335), // Rule ID 16233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16233,
        GIR_EraseRootFromParent_Done,
      // Label 15929: @1105335
      GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1105418), // Rule ID 16236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16236,
        GIR_EraseRootFromParent_Done,
      // Label 15930: @1105418
      GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1105501), // Rule ID 16237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16237,
        GIR_EraseRootFromParent_Done,
      // Label 15931: @1105501
      GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1105584), // Rule ID 16240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16240,
        GIR_EraseRootFromParent_Done,
      // Label 15932: @1105584
      GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1105667), // Rule ID 16241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16241,
        GIR_EraseRootFromParent_Done,
      // Label 15933: @1105667
      GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1105750), // Rule ID 16244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16244,
        GIR_EraseRootFromParent_Done,
      // Label 15934: @1105750
      GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1105833), // Rule ID 16245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16245,
        GIR_EraseRootFromParent_Done,
      // Label 15935: @1105833
      GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1105916), // Rule ID 16248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16248,
        GIR_EraseRootFromParent_Done,
      // Label 15936: @1105916
      GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1105999), // Rule ID 16249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16249,
        GIR_EraseRootFromParent_Done,
      // Label 15937: @1105999
      GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1106082), // Rule ID 16252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16252,
        GIR_EraseRootFromParent_Done,
      // Label 15938: @1106082
      GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1106165), // Rule ID 16253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16253,
        GIR_EraseRootFromParent_Done,
      // Label 15939: @1106165
      GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1106248), // Rule ID 16256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16256,
        GIR_EraseRootFromParent_Done,
      // Label 15940: @1106248
      GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1106331), // Rule ID 16257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16257,
        GIR_EraseRootFromParent_Done,
      // Label 15941: @1106331
      GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1106414), // Rule ID 16260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16260,
        GIR_EraseRootFromParent_Done,
      // Label 15942: @1106414
      GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1106497), // Rule ID 16261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16261,
        GIR_EraseRootFromParent_Done,
      // Label 15943: @1106497
      GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1106580), // Rule ID 16264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16264,
        GIR_EraseRootFromParent_Done,
      // Label 15944: @1106580
      GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1106663), // Rule ID 16265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16265,
        GIR_EraseRootFromParent_Done,
      // Label 15945: @1106663
      GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1106746), // Rule ID 16268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16268,
        GIR_EraseRootFromParent_Done,
      // Label 15946: @1106746
      GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1106829), // Rule ID 16269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16269,
        GIR_EraseRootFromParent_Done,
      // Label 15947: @1106829
      GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1106912), // Rule ID 16272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16272,
        GIR_EraseRootFromParent_Done,
      // Label 15948: @1106912
      GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1106995), // Rule ID 16273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16273,
        GIR_EraseRootFromParent_Done,
      // Label 15949: @1106995
      GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1107078), // Rule ID 16276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16276,
        GIR_EraseRootFromParent_Done,
      // Label 15950: @1107078
      GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1107161), // Rule ID 16277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16277,
        GIR_EraseRootFromParent_Done,
      // Label 15951: @1107161
      GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1107244), // Rule ID 16280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16280,
        GIR_EraseRootFromParent_Done,
      // Label 15952: @1107244
      GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1107327), // Rule ID 16281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16281,
        GIR_EraseRootFromParent_Done,
      // Label 15953: @1107327
      GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1107410), // Rule ID 16284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16284,
        GIR_EraseRootFromParent_Done,
      // Label 15954: @1107410
      GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1107493), // Rule ID 16285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16285,
        GIR_EraseRootFromParent_Done,
      // Label 15955: @1107493
      GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1107576), // Rule ID 16288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16288,
        GIR_EraseRootFromParent_Done,
      // Label 15956: @1107576
      GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1107659), // Rule ID 16289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16289,
        GIR_EraseRootFromParent_Done,
      // Label 15957: @1107659
      GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1107742), // Rule ID 16292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16292,
        GIR_EraseRootFromParent_Done,
      // Label 15958: @1107742
      GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1107825), // Rule ID 16293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16293,
        GIR_EraseRootFromParent_Done,
      // Label 15959: @1107825
      GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1107908), // Rule ID 16296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16296,
        GIR_EraseRootFromParent_Done,
      // Label 15960: @1107908
      GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1107991), // Rule ID 16297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16297,
        GIR_EraseRootFromParent_Done,
      // Label 15961: @1107991
      GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1108074), // Rule ID 16300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16300,
        GIR_EraseRootFromParent_Done,
      // Label 15962: @1108074
      GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1108157), // Rule ID 16301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16301,
        GIR_EraseRootFromParent_Done,
      // Label 15963: @1108157
      GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1108240), // Rule ID 16304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16304,
        GIR_EraseRootFromParent_Done,
      // Label 15964: @1108240
      GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1108323), // Rule ID 16305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16305,
        GIR_EraseRootFromParent_Done,
      // Label 15965: @1108323
      GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1108406), // Rule ID 16368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16368,
        GIR_EraseRootFromParent_Done,
      // Label 15966: @1108406
      GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1108489), // Rule ID 16369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16369,
        GIR_EraseRootFromParent_Done,
      // Label 15967: @1108489
      GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1108572), // Rule ID 16372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16372,
        GIR_EraseRootFromParent_Done,
      // Label 15968: @1108572
      GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1108655), // Rule ID 16373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16373,
        GIR_EraseRootFromParent_Done,
      // Label 15969: @1108655
      GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1108738), // Rule ID 16376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16376,
        GIR_EraseRootFromParent_Done,
      // Label 15970: @1108738
      GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1108821), // Rule ID 16377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16377,
        GIR_EraseRootFromParent_Done,
      // Label 15971: @1108821
      GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1108904), // Rule ID 16380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16380,
        GIR_EraseRootFromParent_Done,
      // Label 15972: @1108904
      GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1108987), // Rule ID 16381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16381,
        GIR_EraseRootFromParent_Done,
      // Label 15973: @1108987
      GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1109070), // Rule ID 16384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16384,
        GIR_EraseRootFromParent_Done,
      // Label 15974: @1109070
      GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1109153), // Rule ID 16385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16385,
        GIR_EraseRootFromParent_Done,
      // Label 15975: @1109153
      GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1109236), // Rule ID 16388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16388,
        GIR_EraseRootFromParent_Done,
      // Label 15976: @1109236
      GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1109319), // Rule ID 16389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16389,
        GIR_EraseRootFromParent_Done,
      // Label 15977: @1109319
      GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1109402), // Rule ID 16392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16392,
        GIR_EraseRootFromParent_Done,
      // Label 15978: @1109402
      GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1109485), // Rule ID 16393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16393,
        GIR_EraseRootFromParent_Done,
      // Label 15979: @1109485
      GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1109568), // Rule ID 16396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16396,
        GIR_EraseRootFromParent_Done,
      // Label 15980: @1109568
      GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1109651), // Rule ID 16397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16397,
        GIR_EraseRootFromParent_Done,
      // Label 15981: @1109651
      GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1109734), // Rule ID 16400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16400,
        GIR_EraseRootFromParent_Done,
      // Label 15982: @1109734
      GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1109817), // Rule ID 16401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16401,
        GIR_EraseRootFromParent_Done,
      // Label 15983: @1109817
      GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1109900), // Rule ID 16404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16404,
        GIR_EraseRootFromParent_Done,
      // Label 15984: @1109900
      GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1109983), // Rule ID 16405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16405,
        GIR_EraseRootFromParent_Done,
      // Label 15985: @1109983
      GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1110066), // Rule ID 16408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16408,
        GIR_EraseRootFromParent_Done,
      // Label 15986: @1110066
      GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1110149), // Rule ID 16409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16409,
        GIR_EraseRootFromParent_Done,
      // Label 15987: @1110149
      GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1110232), // Rule ID 16412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16412,
        GIR_EraseRootFromParent_Done,
      // Label 15988: @1110232
      GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1110315), // Rule ID 16413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16413,
        GIR_EraseRootFromParent_Done,
      // Label 15989: @1110315
      GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1110398), // Rule ID 16416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16416,
        GIR_EraseRootFromParent_Done,
      // Label 15990: @1110398
      GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1110481), // Rule ID 16417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16417,
        GIR_EraseRootFromParent_Done,
      // Label 15991: @1110481
      GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1110564), // Rule ID 16420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16420,
        GIR_EraseRootFromParent_Done,
      // Label 15992: @1110564
      GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1110647), // Rule ID 16421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16421,
        GIR_EraseRootFromParent_Done,
      // Label 15993: @1110647
      GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1110730), // Rule ID 16424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16424,
        GIR_EraseRootFromParent_Done,
      // Label 15994: @1110730
      GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1110813), // Rule ID 16425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16425,
        GIR_EraseRootFromParent_Done,
      // Label 15995: @1110813
      GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1110896), // Rule ID 16428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16428,
        GIR_EraseRootFromParent_Done,
      // Label 15996: @1110896
      GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1110979), // Rule ID 16429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16429,
        GIR_EraseRootFromParent_Done,
      // Label 15997: @1110979
      GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1111062), // Rule ID 16432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16432,
        GIR_EraseRootFromParent_Done,
      // Label 15998: @1111062
      GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1111145), // Rule ID 16433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16433,
        GIR_EraseRootFromParent_Done,
      // Label 15999: @1111145
      GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1111228), // Rule ID 16436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16436,
        GIR_EraseRootFromParent_Done,
      // Label 16000: @1111228
      GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1111311), // Rule ID 16437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16437,
        GIR_EraseRootFromParent_Done,
      // Label 16001: @1111311
      GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1111394), // Rule ID 16440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16440,
        GIR_EraseRootFromParent_Done,
      // Label 16002: @1111394
      GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1111477), // Rule ID 16441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16441,
        GIR_EraseRootFromParent_Done,
      // Label 16003: @1111477
      GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1111560), // Rule ID 16444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16444,
        GIR_EraseRootFromParent_Done,
      // Label 16004: @1111560
      GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1111643), // Rule ID 16445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16445,
        GIR_EraseRootFromParent_Done,
      // Label 16005: @1111643
      GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1111726), // Rule ID 16448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16448,
        GIR_EraseRootFromParent_Done,
      // Label 16006: @1111726
      GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1111809), // Rule ID 16449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16449,
        GIR_EraseRootFromParent_Done,
      // Label 16007: @1111809
      GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1111892), // Rule ID 16452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16452,
        GIR_EraseRootFromParent_Done,
      // Label 16008: @1111892
      GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1111975), // Rule ID 16453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16453,
        GIR_EraseRootFromParent_Done,
      // Label 16009: @1111975
      GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1112058), // Rule ID 16456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16456,
        GIR_EraseRootFromParent_Done,
      // Label 16010: @1112058
      GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1112141), // Rule ID 16457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16457,
        GIR_EraseRootFromParent_Done,
      // Label 16011: @1112141
      GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1112224), // Rule ID 16460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16460,
        GIR_EraseRootFromParent_Done,
      // Label 16012: @1112224
      GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1112307), // Rule ID 16461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16461,
        GIR_EraseRootFromParent_Done,
      // Label 16013: @1112307
      GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1112390), // Rule ID 16464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16464,
        GIR_EraseRootFromParent_Done,
      // Label 16014: @1112390
      GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1112473), // Rule ID 16465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16465,
        GIR_EraseRootFromParent_Done,
      // Label 16015: @1112473
      GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1112556), // Rule ID 16468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16468,
        GIR_EraseRootFromParent_Done,
      // Label 16016: @1112556
      GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1112639), // Rule ID 16469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16469,
        GIR_EraseRootFromParent_Done,
      // Label 16017: @1112639
      GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1112722), // Rule ID 16472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16472,
        GIR_EraseRootFromParent_Done,
      // Label 16018: @1112722
      GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1112805), // Rule ID 16473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16473,
        GIR_EraseRootFromParent_Done,
      // Label 16019: @1112805
      GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1112888), // Rule ID 16476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16476,
        GIR_EraseRootFromParent_Done,
      // Label 16020: @1112888
      GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1112971), // Rule ID 16477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16477,
        GIR_EraseRootFromParent_Done,
      // Label 16021: @1112971
      GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1113054), // Rule ID 16480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16480,
        GIR_EraseRootFromParent_Done,
      // Label 16022: @1113054
      GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1113137), // Rule ID 16481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16481,
        GIR_EraseRootFromParent_Done,
      // Label 16023: @1113137
      GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1113220), // Rule ID 16484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16484,
        GIR_EraseRootFromParent_Done,
      // Label 16024: @1113220
      GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1113303), // Rule ID 16485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16485,
        GIR_EraseRootFromParent_Done,
      // Label 16025: @1113303
      GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1113383), // Rule ID 16548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16548,
        GIR_EraseRootFromParent_Done,
      // Label 16026: @1113383
      GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1113463), // Rule ID 16549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16549,
        GIR_EraseRootFromParent_Done,
      // Label 16027: @1113463
      GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1113543), // Rule ID 16552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16552,
        GIR_EraseRootFromParent_Done,
      // Label 16028: @1113543
      GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1113623), // Rule ID 16553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16553,
        GIR_EraseRootFromParent_Done,
      // Label 16029: @1113623
      GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1113703), // Rule ID 16556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16556,
        GIR_EraseRootFromParent_Done,
      // Label 16030: @1113703
      GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1113783), // Rule ID 16557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16557,
        GIR_EraseRootFromParent_Done,
      // Label 16031: @1113783
      GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1113863), // Rule ID 16560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16560,
        GIR_EraseRootFromParent_Done,
      // Label 16032: @1113863
      GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1113943), // Rule ID 16561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16561,
        GIR_EraseRootFromParent_Done,
      // Label 16033: @1113943
      GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1114023), // Rule ID 16564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16564,
        GIR_EraseRootFromParent_Done,
      // Label 16034: @1114023
      GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1114103), // Rule ID 16565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16565,
        GIR_EraseRootFromParent_Done,
      // Label 16035: @1114103
      GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1114183), // Rule ID 16568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16568,
        GIR_EraseRootFromParent_Done,
      // Label 16036: @1114183
      GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1114263), // Rule ID 16569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16569,
        GIR_EraseRootFromParent_Done,
      // Label 16037: @1114263
      GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1114343), // Rule ID 16572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16572,
        GIR_EraseRootFromParent_Done,
      // Label 16038: @1114343
      GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1114423), // Rule ID 16573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16573,
        GIR_EraseRootFromParent_Done,
      // Label 16039: @1114423
      GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1114503), // Rule ID 16576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16576,
        GIR_EraseRootFromParent_Done,
      // Label 16040: @1114503
      GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1114583), // Rule ID 16577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16577,
        GIR_EraseRootFromParent_Done,
      // Label 16041: @1114583
      GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1114663), // Rule ID 16580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16580,
        GIR_EraseRootFromParent_Done,
      // Label 16042: @1114663
      GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1114743), // Rule ID 16581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16581,
        GIR_EraseRootFromParent_Done,
      // Label 16043: @1114743
      GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1114823), // Rule ID 16584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16584,
        GIR_EraseRootFromParent_Done,
      // Label 16044: @1114823
      GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1114903), // Rule ID 16585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16585,
        GIR_EraseRootFromParent_Done,
      // Label 16045: @1114903
      GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1114983), // Rule ID 16588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16588,
        GIR_EraseRootFromParent_Done,
      // Label 16046: @1114983
      GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1115063), // Rule ID 16589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16589,
        GIR_EraseRootFromParent_Done,
      // Label 16047: @1115063
      GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1115143), // Rule ID 16592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16592,
        GIR_EraseRootFromParent_Done,
      // Label 16048: @1115143
      GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1115223), // Rule ID 16593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16593,
        GIR_EraseRootFromParent_Done,
      // Label 16049: @1115223
      GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1115303), // Rule ID 16596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16596,
        GIR_EraseRootFromParent_Done,
      // Label 16050: @1115303
      GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1115383), // Rule ID 16597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16597,
        GIR_EraseRootFromParent_Done,
      // Label 16051: @1115383
      GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1115463), // Rule ID 16600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16600,
        GIR_EraseRootFromParent_Done,
      // Label 16052: @1115463
      GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1115543), // Rule ID 16601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16601,
        GIR_EraseRootFromParent_Done,
      // Label 16053: @1115543
      GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1115623), // Rule ID 16604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16604,
        GIR_EraseRootFromParent_Done,
      // Label 16054: @1115623
      GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1115703), // Rule ID 16605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16605,
        GIR_EraseRootFromParent_Done,
      // Label 16055: @1115703
      GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1115783), // Rule ID 16608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16608,
        GIR_EraseRootFromParent_Done,
      // Label 16056: @1115783
      GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1115863), // Rule ID 16609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16609,
        GIR_EraseRootFromParent_Done,
      // Label 16057: @1115863
      GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1115943), // Rule ID 16612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16612,
        GIR_EraseRootFromParent_Done,
      // Label 16058: @1115943
      GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1116023), // Rule ID 16613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16613,
        GIR_EraseRootFromParent_Done,
      // Label 16059: @1116023
      GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1116103), // Rule ID 16616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16616,
        GIR_EraseRootFromParent_Done,
      // Label 16060: @1116103
      GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1116183), // Rule ID 16617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16617,
        GIR_EraseRootFromParent_Done,
      // Label 16061: @1116183
      GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1116263), // Rule ID 16620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16620,
        GIR_EraseRootFromParent_Done,
      // Label 16062: @1116263
      GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1116343), // Rule ID 16621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10792:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16621,
        GIR_EraseRootFromParent_Done,
      // Label 16063: @1116343
      GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1116423), // Rule ID 16624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16624,
        GIR_EraseRootFromParent_Done,
      // Label 16064: @1116423
      GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1116503), // Rule ID 16625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10792:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16625,
        GIR_EraseRootFromParent_Done,
      // Label 16065: @1116503
      GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1116583), // Rule ID 16628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16628,
        GIR_EraseRootFromParent_Done,
      // Label 16066: @1116583
      GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1116663), // Rule ID 16629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10792:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16629,
        GIR_EraseRootFromParent_Done,
      // Label 16067: @1116663
      GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1116743), // Rule ID 16632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16632,
        GIR_EraseRootFromParent_Done,
      // Label 16068: @1116743
      GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1116823), // Rule ID 16633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16633,
        GIR_EraseRootFromParent_Done,
      // Label 16069: @1116823
      GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1116903), // Rule ID 16636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16636,
        GIR_EraseRootFromParent_Done,
      // Label 16070: @1116903
      GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1116983), // Rule ID 16637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16637,
        GIR_EraseRootFromParent_Done,
      // Label 16071: @1116983
      GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1117063), // Rule ID 16640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16640,
        GIR_EraseRootFromParent_Done,
      // Label 16072: @1117063
      GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1117143), // Rule ID 16641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16641,
        GIR_EraseRootFromParent_Done,
      // Label 16073: @1117143
      GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1117223), // Rule ID 16644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16644,
        GIR_EraseRootFromParent_Done,
      // Label 16074: @1117223
      GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1117303), // Rule ID 16645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16645,
        GIR_EraseRootFromParent_Done,
      // Label 16075: @1117303
      GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1117383), // Rule ID 16648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16648,
        GIR_EraseRootFromParent_Done,
      // Label 16076: @1117383
      GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1117463), // Rule ID 16649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16649,
        GIR_EraseRootFromParent_Done,
      // Label 16077: @1117463
      GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1117543), // Rule ID 16652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16652,
        GIR_EraseRootFromParent_Done,
      // Label 16078: @1117543
      GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1117623), // Rule ID 16653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16653,
        GIR_EraseRootFromParent_Done,
      // Label 16079: @1117623
      GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1117703), // Rule ID 16656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16656,
        GIR_EraseRootFromParent_Done,
      // Label 16080: @1117703
      GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1117783), // Rule ID 16657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10792:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16657,
        GIR_EraseRootFromParent_Done,
      // Label 16081: @1117783
      GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1117863), // Rule ID 16660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16660,
        GIR_EraseRootFromParent_Done,
      // Label 16082: @1117863
      GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1117943), // Rule ID 16661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10792:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16661,
        GIR_EraseRootFromParent_Done,
      // Label 16083: @1117943
      GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1118023), // Rule ID 16664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16664,
        GIR_EraseRootFromParent_Done,
      // Label 16084: @1118023
      GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1118103), // Rule ID 16665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10792:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16665,
        GIR_EraseRootFromParent_Done,
      // Label 16085: @1118103
      GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1118183), // Rule ID 16668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16668,
        GIR_EraseRootFromParent_Done,
      // Label 16086: @1118183
      GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1118263), // Rule ID 16669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16669,
        GIR_EraseRootFromParent_Done,
      // Label 16087: @1118263
      GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1118343), // Rule ID 16672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16672,
        GIR_EraseRootFromParent_Done,
      // Label 16088: @1118343
      GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1118423), // Rule ID 16673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16673,
        GIR_EraseRootFromParent_Done,
      // Label 16089: @1118423
      GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1118503), // Rule ID 16676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16676,
        GIR_EraseRootFromParent_Done,
      // Label 16090: @1118503
      GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1118583), // Rule ID 16677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16677,
        GIR_EraseRootFromParent_Done,
      // Label 16091: @1118583
      GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1118663), // Rule ID 16680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16680,
        GIR_EraseRootFromParent_Done,
      // Label 16092: @1118663
      GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1118743), // Rule ID 16681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16681,
        GIR_EraseRootFromParent_Done,
      // Label 16093: @1118743
      GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1118823), // Rule ID 16684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16684,
        GIR_EraseRootFromParent_Done,
      // Label 16094: @1118823
      GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1118903), // Rule ID 16685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16685,
        GIR_EraseRootFromParent_Done,
      // Label 16095: @1118903
      GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1118983), // Rule ID 16688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16688,
        GIR_EraseRootFromParent_Done,
      // Label 16096: @1118983
      GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1119063), // Rule ID 16689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16689,
        GIR_EraseRootFromParent_Done,
      // Label 16097: @1119063
      GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1119143), // Rule ID 16692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16692,
        GIR_EraseRootFromParent_Done,
      // Label 16098: @1119143
      GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1119223), // Rule ID 16693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16693,
        GIR_EraseRootFromParent_Done,
      // Label 16099: @1119223
      GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1119303), // Rule ID 16696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16696,
        GIR_EraseRootFromParent_Done,
      // Label 16100: @1119303
      GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1119383), // Rule ID 16697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16697,
        GIR_EraseRootFromParent_Done,
      // Label 16101: @1119383
      GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1119463), // Rule ID 16700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16700,
        GIR_EraseRootFromParent_Done,
      // Label 16102: @1119463
      GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1119543), // Rule ID 16701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16701,
        GIR_EraseRootFromParent_Done,
      // Label 16103: @1119543
      GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1119623), // Rule ID 16704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16704,
        GIR_EraseRootFromParent_Done,
      // Label 16104: @1119623
      GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1119703), // Rule ID 16705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16705,
        GIR_EraseRootFromParent_Done,
      // Label 16105: @1119703
      GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1119783), // Rule ID 16708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16708,
        GIR_EraseRootFromParent_Done,
      // Label 16106: @1119783
      GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1119863), // Rule ID 16709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16709,
        GIR_EraseRootFromParent_Done,
      // Label 16107: @1119863
      GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1119943), // Rule ID 16712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16712,
        GIR_EraseRootFromParent_Done,
      // Label 16108: @1119943
      GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1120023), // Rule ID 16713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16713,
        GIR_EraseRootFromParent_Done,
      // Label 16109: @1120023
      GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1120103), // Rule ID 16716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16716,
        GIR_EraseRootFromParent_Done,
      // Label 16110: @1120103
      GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1120183), // Rule ID 16717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16717,
        GIR_EraseRootFromParent_Done,
      // Label 16111: @1120183
      GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1120263), // Rule ID 16720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16720,
        GIR_EraseRootFromParent_Done,
      // Label 16112: @1120263
      GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1120343), // Rule ID 16721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16721,
        GIR_EraseRootFromParent_Done,
      // Label 16113: @1120343
      GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1120423), // Rule ID 16724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16724,
        GIR_EraseRootFromParent_Done,
      // Label 16114: @1120423
      GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1120503), // Rule ID 16725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16725,
        GIR_EraseRootFromParent_Done,
      // Label 16115: @1120503
      GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1120583), // Rule ID 16728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16728,
        GIR_EraseRootFromParent_Done,
      // Label 16116: @1120583
      GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1120663), // Rule ID 16729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16729,
        GIR_EraseRootFromParent_Done,
      // Label 16117: @1120663
      GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1120743), // Rule ID 16732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16732,
        GIR_EraseRootFromParent_Done,
      // Label 16118: @1120743
      GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1120823), // Rule ID 16733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16733,
        GIR_EraseRootFromParent_Done,
      // Label 16119: @1120823
      GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1120903), // Rule ID 16736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16736,
        GIR_EraseRootFromParent_Done,
      // Label 16120: @1120903
      GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1120983), // Rule ID 16737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16737,
        GIR_EraseRootFromParent_Done,
      // Label 16121: @1120983
      GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1121063), // Rule ID 16740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16740,
        GIR_EraseRootFromParent_Done,
      // Label 16122: @1121063
      GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1121143), // Rule ID 16741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10884:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16741,
        GIR_EraseRootFromParent_Done,
      // Label 16123: @1121143
      GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1121223), // Rule ID 16744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16744,
        GIR_EraseRootFromParent_Done,
      // Label 16124: @1121223
      GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1121303), // Rule ID 16745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10884:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16745,
        GIR_EraseRootFromParent_Done,
      // Label 16125: @1121303
      GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1121383), // Rule ID 16748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16748,
        GIR_EraseRootFromParent_Done,
      // Label 16126: @1121383
      GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1121463), // Rule ID 16749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10884:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16749,
        GIR_EraseRootFromParent_Done,
      // Label 16127: @1121463
      GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1121543), // Rule ID 16752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16752,
        GIR_EraseRootFromParent_Done,
      // Label 16128: @1121543
      GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1121623), // Rule ID 16753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16753,
        GIR_EraseRootFromParent_Done,
      // Label 16129: @1121623
      GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1121703), // Rule ID 16756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16756,
        GIR_EraseRootFromParent_Done,
      // Label 16130: @1121703
      GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1121783), // Rule ID 16757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16757,
        GIR_EraseRootFromParent_Done,
      // Label 16131: @1121783
      GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1121863), // Rule ID 16760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16760,
        GIR_EraseRootFromParent_Done,
      // Label 16132: @1121863
      GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1121943), // Rule ID 16761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16761,
        GIR_EraseRootFromParent_Done,
      // Label 16133: @1121943
      GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1122023), // Rule ID 16764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16764,
        GIR_EraseRootFromParent_Done,
      // Label 16134: @1122023
      GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1122103), // Rule ID 16765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16765,
        GIR_EraseRootFromParent_Done,
      // Label 16135: @1122103
      GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1122183), // Rule ID 16768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16768,
        GIR_EraseRootFromParent_Done,
      // Label 16136: @1122183
      GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1122263), // Rule ID 16769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16769,
        GIR_EraseRootFromParent_Done,
      // Label 16137: @1122263
      GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1122343), // Rule ID 16772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16772,
        GIR_EraseRootFromParent_Done,
      // Label 16138: @1122343
      GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1122423), // Rule ID 16773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16773,
        GIR_EraseRootFromParent_Done,
      // Label 16139: @1122423
      GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1122503), // Rule ID 16776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16776,
        GIR_EraseRootFromParent_Done,
      // Label 16140: @1122503
      GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1122583), // Rule ID 16777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10884:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16777,
        GIR_EraseRootFromParent_Done,
      // Label 16141: @1122583
      GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1122663), // Rule ID 16780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16780,
        GIR_EraseRootFromParent_Done,
      // Label 16142: @1122663
      GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1122743), // Rule ID 16781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10884:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16781,
        GIR_EraseRootFromParent_Done,
      // Label 16143: @1122743
      GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1122823), // Rule ID 16784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16784,
        GIR_EraseRootFromParent_Done,
      // Label 16144: @1122823
      GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1122903), // Rule ID 16785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10884:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16785,
        GIR_EraseRootFromParent_Done,
      // Label 16145: @1122903
      GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1122983), // Rule ID 16788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16788,
        GIR_EraseRootFromParent_Done,
      // Label 16146: @1122983
      GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1123063), // Rule ID 16789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16789,
        GIR_EraseRootFromParent_Done,
      // Label 16147: @1123063
      GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1123143), // Rule ID 16792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16792,
        GIR_EraseRootFromParent_Done,
      // Label 16148: @1123143
      GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1123223), // Rule ID 16793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16793,
        GIR_EraseRootFromParent_Done,
      // Label 16149: @1123223
      GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1123303), // Rule ID 16796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16796,
        GIR_EraseRootFromParent_Done,
      // Label 16150: @1123303
      GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1123383), // Rule ID 16797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16797,
        GIR_EraseRootFromParent_Done,
      // Label 16151: @1123383
      GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1123463), // Rule ID 16800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16800,
        GIR_EraseRootFromParent_Done,
      // Label 16152: @1123463
      GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1123543), // Rule ID 16801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10870:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16801,
        GIR_EraseRootFromParent_Done,
      // Label 16153: @1123543
      GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1123623), // Rule ID 16804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16804,
        GIR_EraseRootFromParent_Done,
      // Label 16154: @1123623
      GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1123703), // Rule ID 16805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10870:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16805,
        GIR_EraseRootFromParent_Done,
      // Label 16155: @1123703
      GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1123783), // Rule ID 16808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16808,
        GIR_EraseRootFromParent_Done,
      // Label 16156: @1123783
      GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1123863), // Rule ID 16809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10870:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16809,
        GIR_EraseRootFromParent_Done,
      // Label 16157: @1123863
      GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1123943), // Rule ID 16812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16812,
        GIR_EraseRootFromParent_Done,
      // Label 16158: @1123943
      GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1124023), // Rule ID 16813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16813,
        GIR_EraseRootFromParent_Done,
      // Label 16159: @1124023
      GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1124103), // Rule ID 16816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16816,
        GIR_EraseRootFromParent_Done,
      // Label 16160: @1124103
      GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1124183), // Rule ID 16817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16817,
        GIR_EraseRootFromParent_Done,
      // Label 16161: @1124183
      GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1124263), // Rule ID 16820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16820,
        GIR_EraseRootFromParent_Done,
      // Label 16162: @1124263
      GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1124343), // Rule ID 16821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16821,
        GIR_EraseRootFromParent_Done,
      // Label 16163: @1124343
      GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1124423), // Rule ID 16824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16824,
        GIR_EraseRootFromParent_Done,
      // Label 16164: @1124423
      GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1124503), // Rule ID 16825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16825,
        GIR_EraseRootFromParent_Done,
      // Label 16165: @1124503
      GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1124583), // Rule ID 16828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16828,
        GIR_EraseRootFromParent_Done,
      // Label 16166: @1124583
      GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1124663), // Rule ID 16829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16829,
        GIR_EraseRootFromParent_Done,
      // Label 16167: @1124663
      GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1124743), // Rule ID 16832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16832,
        GIR_EraseRootFromParent_Done,
      // Label 16168: @1124743
      GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1124823), // Rule ID 16833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16833,
        GIR_EraseRootFromParent_Done,
      // Label 16169: @1124823
      GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1124903), // Rule ID 16836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16836,
        GIR_EraseRootFromParent_Done,
      // Label 16170: @1124903
      GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1124983), // Rule ID 16837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10870:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16837,
        GIR_EraseRootFromParent_Done,
      // Label 16171: @1124983
      GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1125063), // Rule ID 16840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16840,
        GIR_EraseRootFromParent_Done,
      // Label 16172: @1125063
      GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1125143), // Rule ID 16841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10870:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16841,
        GIR_EraseRootFromParent_Done,
      // Label 16173: @1125143
      GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1125223), // Rule ID 16844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16844,
        GIR_EraseRootFromParent_Done,
      // Label 16174: @1125223
      GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1125303), // Rule ID 16845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10870:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16845,
        GIR_EraseRootFromParent_Done,
      // Label 16175: @1125303
      GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1125383), // Rule ID 16848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16848,
        GIR_EraseRootFromParent_Done,
      // Label 16176: @1125383
      GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1125463), // Rule ID 16849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16849,
        GIR_EraseRootFromParent_Done,
      // Label 16177: @1125463
      GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1125543), // Rule ID 16852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16852,
        GIR_EraseRootFromParent_Done,
      // Label 16178: @1125543
      GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1125623), // Rule ID 16853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16853,
        GIR_EraseRootFromParent_Done,
      // Label 16179: @1125623
      GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1125703), // Rule ID 16856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16856,
        GIR_EraseRootFromParent_Done,
      // Label 16180: @1125703
      GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1125783), // Rule ID 16857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16857,
        GIR_EraseRootFromParent_Done,
      // Label 16181: @1125783
      GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1125863), // Rule ID 16860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16860,
        GIR_EraseRootFromParent_Done,
      // Label 16182: @1125863
      GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1125943), // Rule ID 16861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16861,
        GIR_EraseRootFromParent_Done,
      // Label 16183: @1125943
      GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1126023), // Rule ID 16864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16864,
        GIR_EraseRootFromParent_Done,
      // Label 16184: @1126023
      GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1126103), // Rule ID 16865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16865,
        GIR_EraseRootFromParent_Done,
      // Label 16185: @1126103
      GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1126183), // Rule ID 16868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16868,
        GIR_EraseRootFromParent_Done,
      // Label 16186: @1126183
      GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1126263), // Rule ID 16869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16869,
        GIR_EraseRootFromParent_Done,
      // Label 16187: @1126263
      GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1126343), // Rule ID 16872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16872,
        GIR_EraseRootFromParent_Done,
      // Label 16188: @1126343
      GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1126423), // Rule ID 16873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16873,
        GIR_EraseRootFromParent_Done,
      // Label 16189: @1126423
      GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1126503), // Rule ID 16876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16876,
        GIR_EraseRootFromParent_Done,
      // Label 16190: @1126503
      GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1126583), // Rule ID 16877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16877,
        GIR_EraseRootFromParent_Done,
      // Label 16191: @1126583
      GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1126663), // Rule ID 16880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16880,
        GIR_EraseRootFromParent_Done,
      // Label 16192: @1126663
      GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1126743), // Rule ID 16881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16881,
        GIR_EraseRootFromParent_Done,
      // Label 16193: @1126743
      GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1126823), // Rule ID 16884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16884,
        GIR_EraseRootFromParent_Done,
      // Label 16194: @1126823
      GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1126903), // Rule ID 16885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16885,
        GIR_EraseRootFromParent_Done,
      // Label 16195: @1126903
      GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1126983), // Rule ID 16888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16888,
        GIR_EraseRootFromParent_Done,
      // Label 16196: @1126983
      GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1127063), // Rule ID 16889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10886:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16889,
        GIR_EraseRootFromParent_Done,
      // Label 16197: @1127063
      GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1127143), // Rule ID 16892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16892,
        GIR_EraseRootFromParent_Done,
      // Label 16198: @1127143
      GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1127223), // Rule ID 16893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16893,
        GIR_EraseRootFromParent_Done,
      // Label 16199: @1127223
      GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1127303), // Rule ID 16896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16896,
        GIR_EraseRootFromParent_Done,
      // Label 16200: @1127303
      GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1127383), // Rule ID 16897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16897,
        GIR_EraseRootFromParent_Done,
      // Label 16201: @1127383
      GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1127463), // Rule ID 16900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16900,
        GIR_EraseRootFromParent_Done,
      // Label 16202: @1127463
      GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1127543), // Rule ID 16901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16901,
        GIR_EraseRootFromParent_Done,
      // Label 16203: @1127543
      GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1127623), // Rule ID 16904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16904,
        GIR_EraseRootFromParent_Done,
      // Label 16204: @1127623
      GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1127703), // Rule ID 16905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10886:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16905,
        GIR_EraseRootFromParent_Done,
      // Label 16205: @1127703
      GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1127783), // Rule ID 16908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16908,
        GIR_EraseRootFromParent_Done,
      // Label 16206: @1127783
      GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1127863), // Rule ID 16909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10886:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16909,
        GIR_EraseRootFromParent_Done,
      // Label 16207: @1127863
      GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1127943), // Rule ID 16912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16912,
        GIR_EraseRootFromParent_Done,
      // Label 16208: @1127943
      GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1128023), // Rule ID 16913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10886:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16913,
        GIR_EraseRootFromParent_Done,
      // Label 16209: @1128023
      GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1128103), // Rule ID 16916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16916,
        GIR_EraseRootFromParent_Done,
      // Label 16210: @1128103
      GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1128183), // Rule ID 16917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10886:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16917,
        GIR_EraseRootFromParent_Done,
      // Label 16211: @1128183
      GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1128263), // Rule ID 16920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16920,
        GIR_EraseRootFromParent_Done,
      // Label 16212: @1128263
      GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1128343), // Rule ID 16921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16921,
        GIR_EraseRootFromParent_Done,
      // Label 16213: @1128343
      GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1128423), // Rule ID 16924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16924,
        GIR_EraseRootFromParent_Done,
      // Label 16214: @1128423
      GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1128503), // Rule ID 16925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16925,
        GIR_EraseRootFromParent_Done,
      // Label 16215: @1128503
      GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1128583), // Rule ID 16928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16928,
        GIR_EraseRootFromParent_Done,
      // Label 16216: @1128583
      GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1128663), // Rule ID 16929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16929,
        GIR_EraseRootFromParent_Done,
      // Label 16217: @1128663
      GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1128743), // Rule ID 16932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16932,
        GIR_EraseRootFromParent_Done,
      // Label 16218: @1128743
      GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1128823), // Rule ID 16933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16933,
        GIR_EraseRootFromParent_Done,
      // Label 16219: @1128823
      GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1128903), // Rule ID 16936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10922:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16936,
        GIR_EraseRootFromParent_Done,
      // Label 16220: @1128903
      GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1128983), // Rule ID 16937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10922:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16937,
        GIR_EraseRootFromParent_Done,
      // Label 16221: @1128983
      GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1129063), // Rule ID 16940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16940,
        GIR_EraseRootFromParent_Done,
      // Label 16222: @1129063
      GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1129143), // Rule ID 16941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16941,
        GIR_EraseRootFromParent_Done,
      // Label 16223: @1129143
      GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1129223), // Rule ID 16944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16944,
        GIR_EraseRootFromParent_Done,
      // Label 16224: @1129223
      GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1129303), // Rule ID 16945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16945,
        GIR_EraseRootFromParent_Done,
      // Label 16225: @1129303
      GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1129383), // Rule ID 16948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16948,
        GIR_EraseRootFromParent_Done,
      // Label 16226: @1129383
      GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1129463), // Rule ID 16949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16949,
        GIR_EraseRootFromParent_Done,
      // Label 16227: @1129463
      GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1129543), // Rule ID 16952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10922:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16952,
        GIR_EraseRootFromParent_Done,
      // Label 16228: @1129543
      GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1129623), // Rule ID 16953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10922:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16953,
        GIR_EraseRootFromParent_Done,
      // Label 16229: @1129623
      GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1129703), // Rule ID 16956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16956,
        GIR_EraseRootFromParent_Done,
      // Label 16230: @1129703
      GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1129783), // Rule ID 16957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16957,
        GIR_EraseRootFromParent_Done,
      // Label 16231: @1129783
      GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1129863), // Rule ID 16960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16960,
        GIR_EraseRootFromParent_Done,
      // Label 16232: @1129863
      GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1129943), // Rule ID 16961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10922:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16961,
        GIR_EraseRootFromParent_Done,
      // Label 16233: @1129943
      GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1130023), // Rule ID 16964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16964,
        GIR_EraseRootFromParent_Done,
      // Label 16234: @1130023
      GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1130103), // Rule ID 16965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16965,
        GIR_EraseRootFromParent_Done,
      // Label 16235: @1130103
      GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1130183), // Rule ID 16968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16968,
        GIR_EraseRootFromParent_Done,
      // Label 16236: @1130183
      GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1130263), // Rule ID 16969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16969,
        GIR_EraseRootFromParent_Done,
      // Label 16237: @1130263
      GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1130343), // Rule ID 16972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10922:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16972,
        GIR_EraseRootFromParent_Done,
      // Label 16238: @1130343
      GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1130423), // Rule ID 16973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10922:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16973,
        GIR_EraseRootFromParent_Done,
      // Label 16239: @1130423
      GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1130503), // Rule ID 16976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16976,
        GIR_EraseRootFromParent_Done,
      // Label 16240: @1130503
      GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1130583), // Rule ID 16977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10922:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16977,
        GIR_EraseRootFromParent_Done,
      // Label 16241: @1130583
      GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1130663), // Rule ID 16980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16980,
        GIR_EraseRootFromParent_Done,
      // Label 16242: @1130663
      GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1130743), // Rule ID 16981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10922:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16981,
        GIR_EraseRootFromParent_Done,
      // Label 16243: @1130743
      GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1130823), // Rule ID 16984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16984,
        GIR_EraseRootFromParent_Done,
      // Label 16244: @1130823
      GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1130903), // Rule ID 16985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10922:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16985,
        GIR_EraseRootFromParent_Done,
      // Label 16245: @1130903
      GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1130983), // Rule ID 16988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10922:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16988,
        GIR_EraseRootFromParent_Done,
      // Label 16246: @1130983
      GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1131063), // Rule ID 16989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10922:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16989,
        GIR_EraseRootFromParent_Done,
      // Label 16247: @1131063
      GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1131143), // Rule ID 16994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16994,
        GIR_EraseRootFromParent_Done,
      // Label 16248: @1131143
      GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1131223), // Rule ID 16995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16995,
        GIR_EraseRootFromParent_Done,
      // Label 16249: @1131223
      GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1131303), // Rule ID 17004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17004,
        GIR_EraseRootFromParent_Done,
      // Label 16250: @1131303
      GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1131383), // Rule ID 17005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17005,
        GIR_EraseRootFromParent_Done,
      // Label 16251: @1131383
      GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1131463), // Rule ID 17014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17014,
        GIR_EraseRootFromParent_Done,
      // Label 16252: @1131463
      GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1131543), // Rule ID 17015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17015,
        GIR_EraseRootFromParent_Done,
      // Label 16253: @1131543
      GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1131623), // Rule ID 17024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17024,
        GIR_EraseRootFromParent_Done,
      // Label 16254: @1131623
      GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1131703), // Rule ID 17025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17025,
        GIR_EraseRootFromParent_Done,
      // Label 16255: @1131703
      GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1131783), // Rule ID 17034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17034,
        GIR_EraseRootFromParent_Done,
      // Label 16256: @1131783
      GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1131863), // Rule ID 17035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17035,
        GIR_EraseRootFromParent_Done,
      // Label 16257: @1131863
      GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1131943), // Rule ID 17044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17044,
        GIR_EraseRootFromParent_Done,
      // Label 16258: @1131943
      GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1132023), // Rule ID 17045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17045,
        GIR_EraseRootFromParent_Done,
      // Label 16259: @1132023
      GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1132103), // Rule ID 17054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17054,
        GIR_EraseRootFromParent_Done,
      // Label 16260: @1132103
      GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1132183), // Rule ID 17055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17055,
        GIR_EraseRootFromParent_Done,
      // Label 16261: @1132183
      GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1132263), // Rule ID 17064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17064,
        GIR_EraseRootFromParent_Done,
      // Label 16262: @1132263
      GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1132343), // Rule ID 17065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17065,
        GIR_EraseRootFromParent_Done,
      // Label 16263: @1132343
      GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1132423), // Rule ID 17072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17072,
        GIR_EraseRootFromParent_Done,
      // Label 16264: @1132423
      GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1132503), // Rule ID 17073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17073,
        GIR_EraseRootFromParent_Done,
      // Label 16265: @1132503
      GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1132583), // Rule ID 17076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17076,
        GIR_EraseRootFromParent_Done,
      // Label 16266: @1132583
      GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1132663), // Rule ID 17077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10888:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17077,
        GIR_EraseRootFromParent_Done,
      // Label 16267: @1132663
      GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1132743), // Rule ID 17080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17080,
        GIR_EraseRootFromParent_Done,
      // Label 16268: @1132743
      GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1132823), // Rule ID 17081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17081,
        GIR_EraseRootFromParent_Done,
      // Label 16269: @1132823
      GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1132903), // Rule ID 17084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17084,
        GIR_EraseRootFromParent_Done,
      // Label 16270: @1132903
      GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1132983), // Rule ID 17085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17085,
        GIR_EraseRootFromParent_Done,
      // Label 16271: @1132983
      GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1133063), // Rule ID 17088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17088,
        GIR_EraseRootFromParent_Done,
      // Label 16272: @1133063
      GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1133143), // Rule ID 17089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17089,
        GIR_EraseRootFromParent_Done,
      // Label 16273: @1133143
      GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1133223), // Rule ID 17092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17092,
        GIR_EraseRootFromParent_Done,
      // Label 16274: @1133223
      GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1133303), // Rule ID 17093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10888:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17093,
        GIR_EraseRootFromParent_Done,
      // Label 16275: @1133303
      GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1133383), // Rule ID 17096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17096,
        GIR_EraseRootFromParent_Done,
      // Label 16276: @1133383
      GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1133463), // Rule ID 17097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10888:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17097,
        GIR_EraseRootFromParent_Done,
      // Label 16277: @1133463
      GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1133543), // Rule ID 17100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17100,
        GIR_EraseRootFromParent_Done,
      // Label 16278: @1133543
      GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1133623), // Rule ID 17101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10888:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17101,
        GIR_EraseRootFromParent_Done,
      // Label 16279: @1133623
      GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1133703), // Rule ID 17104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17104,
        GIR_EraseRootFromParent_Done,
      // Label 16280: @1133703
      GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1133783), // Rule ID 17105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10888:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17105,
        GIR_EraseRootFromParent_Done,
      // Label 16281: @1133783
      GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1133863), // Rule ID 17110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17110,
        GIR_EraseRootFromParent_Done,
      // Label 16282: @1133863
      GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1133943), // Rule ID 17111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17111,
        GIR_EraseRootFromParent_Done,
      // Label 16283: @1133943
      GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1134023), // Rule ID 17120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17120,
        GIR_EraseRootFromParent_Done,
      // Label 16284: @1134023
      GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1134103), // Rule ID 17121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17121,
        GIR_EraseRootFromParent_Done,
      // Label 16285: @1134103
      GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1134183), // Rule ID 17130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17130,
        GIR_EraseRootFromParent_Done,
      // Label 16286: @1134183
      GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1134263), // Rule ID 17131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17131,
        GIR_EraseRootFromParent_Done,
      // Label 16287: @1134263
      GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1134343), // Rule ID 17140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17140,
        GIR_EraseRootFromParent_Done,
      // Label 16288: @1134343
      GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1134423), // Rule ID 17141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17141,
        GIR_EraseRootFromParent_Done,
      // Label 16289: @1134423
      GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1134503), // Rule ID 17150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17150,
        GIR_EraseRootFromParent_Done,
      // Label 16290: @1134503
      GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1134583), // Rule ID 17151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17151,
        GIR_EraseRootFromParent_Done,
      // Label 16291: @1134583
      GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1134663), // Rule ID 17160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17160,
        GIR_EraseRootFromParent_Done,
      // Label 16292: @1134663
      GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1134743), // Rule ID 17161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17161,
        GIR_EraseRootFromParent_Done,
      // Label 16293: @1134743
      GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1134823), // Rule ID 17170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17170,
        GIR_EraseRootFromParent_Done,
      // Label 16294: @1134823
      GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1134903), // Rule ID 17171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17171,
        GIR_EraseRootFromParent_Done,
      // Label 16295: @1134903
      GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1134983), // Rule ID 17180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17180,
        GIR_EraseRootFromParent_Done,
      // Label 16296: @1134983
      GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1135063), // Rule ID 17181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17181,
        GIR_EraseRootFromParent_Done,
      // Label 16297: @1135063
      GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1135143), // Rule ID 17190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17190,
        GIR_EraseRootFromParent_Done,
      // Label 16298: @1135143
      GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1135223), // Rule ID 17191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17191,
        GIR_EraseRootFromParent_Done,
      // Label 16299: @1135223
      GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1135303), // Rule ID 17198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17198,
        GIR_EraseRootFromParent_Done,
      // Label 16300: @1135303
      GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1135383), // Rule ID 17199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17199,
        GIR_EraseRootFromParent_Done,
      // Label 16301: @1135383
      GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1135463), // Rule ID 17202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17202,
        GIR_EraseRootFromParent_Done,
      // Label 16302: @1135463
      GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1135543), // Rule ID 17203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10924:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17203,
        GIR_EraseRootFromParent_Done,
      // Label 16303: @1135543
      GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1135623), // Rule ID 17206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17206,
        GIR_EraseRootFromParent_Done,
      // Label 16304: @1135623
      GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1135703), // Rule ID 17207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17207,
        GIR_EraseRootFromParent_Done,
      // Label 16305: @1135703
      GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1135783), // Rule ID 17210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17210,
        GIR_EraseRootFromParent_Done,
      // Label 16306: @1135783
      GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1135863), // Rule ID 17211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17211,
        GIR_EraseRootFromParent_Done,
      // Label 16307: @1135863
      GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1135943), // Rule ID 17214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17214,
        GIR_EraseRootFromParent_Done,
      // Label 16308: @1135943
      GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1136023), // Rule ID 17215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17215,
        GIR_EraseRootFromParent_Done,
      // Label 16309: @1136023
      GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1136103), // Rule ID 17218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17218,
        GIR_EraseRootFromParent_Done,
      // Label 16310: @1136103
      GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1136183), // Rule ID 17219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10924:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17219,
        GIR_EraseRootFromParent_Done,
      // Label 16311: @1136183
      GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1136263), // Rule ID 17222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17222,
        GIR_EraseRootFromParent_Done,
      // Label 16312: @1136263
      GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1136343), // Rule ID 17223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10924:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17223,
        GIR_EraseRootFromParent_Done,
      // Label 16313: @1136343
      GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1136423), // Rule ID 17226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17226,
        GIR_EraseRootFromParent_Done,
      // Label 16314: @1136423
      GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1136503), // Rule ID 17227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10924:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17227,
        GIR_EraseRootFromParent_Done,
      // Label 16315: @1136503
      GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1136583), // Rule ID 17230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17230,
        GIR_EraseRootFromParent_Done,
      // Label 16316: @1136583
      GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1136663), // Rule ID 17231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10924:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17231,
        GIR_EraseRootFromParent_Done,
      // Label 16317: @1136663
      GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1136743), // Rule ID 17234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17234,
        GIR_EraseRootFromParent_Done,
      // Label 16318: @1136743
      GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1136823), // Rule ID 17235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17235,
        GIR_EraseRootFromParent_Done,
      // Label 16319: @1136823
      GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1136903), // Rule ID 17238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17238,
        GIR_EraseRootFromParent_Done,
      // Label 16320: @1136903
      GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1136983), // Rule ID 17239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17239,
        GIR_EraseRootFromParent_Done,
      // Label 16321: @1136983
      GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1137063), // Rule ID 17242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17242,
        GIR_EraseRootFromParent_Done,
      // Label 16322: @1137063
      GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1137143), // Rule ID 17243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17243,
        GIR_EraseRootFromParent_Done,
      // Label 16323: @1137143
      GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1137223), // Rule ID 17246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17246,
        GIR_EraseRootFromParent_Done,
      // Label 16324: @1137223
      GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1137303), // Rule ID 17247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17247,
        GIR_EraseRootFromParent_Done,
      // Label 16325: @1137303
      GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1137383), // Rule ID 17250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17250,
        GIR_EraseRootFromParent_Done,
      // Label 16326: @1137383
      GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1137463), // Rule ID 17251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17251,
        GIR_EraseRootFromParent_Done,
      // Label 16327: @1137463
      GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1137543), // Rule ID 17254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17254,
        GIR_EraseRootFromParent_Done,
      // Label 16328: @1137543
      GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1137623), // Rule ID 17255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17255,
        GIR_EraseRootFromParent_Done,
      // Label 16329: @1137623
      GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1137703), // Rule ID 17258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17258,
        GIR_EraseRootFromParent_Done,
      // Label 16330: @1137703
      GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1137783), // Rule ID 17259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17259,
        GIR_EraseRootFromParent_Done,
      // Label 16331: @1137783
      GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1137863), // Rule ID 17262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17262,
        GIR_EraseRootFromParent_Done,
      // Label 16332: @1137863
      GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1137943), // Rule ID 17263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17263,
        GIR_EraseRootFromParent_Done,
      // Label 16333: @1137943
      GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1138023), // Rule ID 17266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17266,
        GIR_EraseRootFromParent_Done,
      // Label 16334: @1138023
      GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1138103), // Rule ID 17267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17267,
        GIR_EraseRootFromParent_Done,
      // Label 16335: @1138103
      GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1138183), // Rule ID 17270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17270,
        GIR_EraseRootFromParent_Done,
      // Label 16336: @1138183
      GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1138263), // Rule ID 17271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17271,
        GIR_EraseRootFromParent_Done,
      // Label 16337: @1138263
      GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1138343), // Rule ID 17274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17274,
        GIR_EraseRootFromParent_Done,
      // Label 16338: @1138343
      GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1138423), // Rule ID 17275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17275,
        GIR_EraseRootFromParent_Done,
      // Label 16339: @1138423
      GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1138503), // Rule ID 17278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17278,
        GIR_EraseRootFromParent_Done,
      // Label 16340: @1138503
      GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1138583), // Rule ID 17279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17279,
        GIR_EraseRootFromParent_Done,
      // Label 16341: @1138583
      GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1138663), // Rule ID 17282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17282,
        GIR_EraseRootFromParent_Done,
      // Label 16342: @1138663
      GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1138743), // Rule ID 17283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17283,
        GIR_EraseRootFromParent_Done,
      // Label 16343: @1138743
      GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1138823), // Rule ID 17286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17286,
        GIR_EraseRootFromParent_Done,
      // Label 16344: @1138823
      GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1138903), // Rule ID 17287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17287,
        GIR_EraseRootFromParent_Done,
      // Label 16345: @1138903
      GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1138983), // Rule ID 17290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17290,
        GIR_EraseRootFromParent_Done,
      // Label 16346: @1138983
      GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1139063), // Rule ID 17291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17291,
        GIR_EraseRootFromParent_Done,
      // Label 16347: @1139063
      GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1139143), // Rule ID 17294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17294,
        GIR_EraseRootFromParent_Done,
      // Label 16348: @1139143
      GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1139223), // Rule ID 17295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17295,
        GIR_EraseRootFromParent_Done,
      // Label 16349: @1139223
      GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1139303), // Rule ID 17298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17298,
        GIR_EraseRootFromParent_Done,
      // Label 16350: @1139303
      GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1139383), // Rule ID 17299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17299,
        GIR_EraseRootFromParent_Done,
      // Label 16351: @1139383
      GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1139463), // Rule ID 17302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17302,
        GIR_EraseRootFromParent_Done,
      // Label 16352: @1139463
      GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1139543), // Rule ID 17303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17303,
        GIR_EraseRootFromParent_Done,
      // Label 16353: @1139543
      GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1139623), // Rule ID 17306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17306,
        GIR_EraseRootFromParent_Done,
      // Label 16354: @1139623
      GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1139703), // Rule ID 17307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10825:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17307,
        GIR_EraseRootFromParent_Done,
      // Label 16355: @1139703
      GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1139783), // Rule ID 17310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17310,
        GIR_EraseRootFromParent_Done,
      // Label 16356: @1139783
      GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1139863), // Rule ID 17311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10825:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17311,
        GIR_EraseRootFromParent_Done,
      // Label 16357: @1139863
      GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1139943), // Rule ID 17314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17314,
        GIR_EraseRootFromParent_Done,
      // Label 16358: @1139943
      GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1140023), // Rule ID 17315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10825:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17315,
        GIR_EraseRootFromParent_Done,
      // Label 16359: @1140023
      GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1140103), // Rule ID 17318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17318,
        GIR_EraseRootFromParent_Done,
      // Label 16360: @1140103
      GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1140183), // Rule ID 17319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17319,
        GIR_EraseRootFromParent_Done,
      // Label 16361: @1140183
      GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1140263), // Rule ID 17322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17322,
        GIR_EraseRootFromParent_Done,
      // Label 16362: @1140263
      GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1140343), // Rule ID 17323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17323,
        GIR_EraseRootFromParent_Done,
      // Label 16363: @1140343
      GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1140423), // Rule ID 17326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17326,
        GIR_EraseRootFromParent_Done,
      // Label 16364: @1140423
      GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1140503), // Rule ID 17327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17327,
        GIR_EraseRootFromParent_Done,
      // Label 16365: @1140503
      GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1140583), // Rule ID 17330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17330,
        GIR_EraseRootFromParent_Done,
      // Label 16366: @1140583
      GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1140663), // Rule ID 17331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17331,
        GIR_EraseRootFromParent_Done,
      // Label 16367: @1140663
      GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1140743), // Rule ID 17334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17334,
        GIR_EraseRootFromParent_Done,
      // Label 16368: @1140743
      GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1140823), // Rule ID 17335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17335,
        GIR_EraseRootFromParent_Done,
      // Label 16369: @1140823
      GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1140903), // Rule ID 17338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17338,
        GIR_EraseRootFromParent_Done,
      // Label 16370: @1140903
      GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1140983), // Rule ID 17339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17339,
        GIR_EraseRootFromParent_Done,
      // Label 16371: @1140983
      GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1141063), // Rule ID 17342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17342,
        GIR_EraseRootFromParent_Done,
      // Label 16372: @1141063
      GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1141143), // Rule ID 17343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10825:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17343,
        GIR_EraseRootFromParent_Done,
      // Label 16373: @1141143
      GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1141223), // Rule ID 17346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17346,
        GIR_EraseRootFromParent_Done,
      // Label 16374: @1141223
      GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1141303), // Rule ID 17347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10825:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17347,
        GIR_EraseRootFromParent_Done,
      // Label 16375: @1141303
      GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1141383), // Rule ID 17350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17350,
        GIR_EraseRootFromParent_Done,
      // Label 16376: @1141383
      GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1141463), // Rule ID 17351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10825:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17351,
        GIR_EraseRootFromParent_Done,
      // Label 16377: @1141463
      GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1141543), // Rule ID 17354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17354,
        GIR_EraseRootFromParent_Done,
      // Label 16378: @1141543
      GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1141623), // Rule ID 17355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17355,
        GIR_EraseRootFromParent_Done,
      // Label 16379: @1141623
      GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1141703), // Rule ID 17358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17358,
        GIR_EraseRootFromParent_Done,
      // Label 16380: @1141703
      GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1141783), // Rule ID 17359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17359,
        GIR_EraseRootFromParent_Done,
      // Label 16381: @1141783
      GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1141863), // Rule ID 17362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17362,
        GIR_EraseRootFromParent_Done,
      // Label 16382: @1141863
      GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1141943), // Rule ID 17363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17363,
        GIR_EraseRootFromParent_Done,
      // Label 16383: @1141943
      GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1142023), // Rule ID 17366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17366,
        GIR_EraseRootFromParent_Done,
      // Label 16384: @1142023
      GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1142103), // Rule ID 17367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17367,
        GIR_EraseRootFromParent_Done,
      // Label 16385: @1142103
      GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1142183), // Rule ID 17370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10808:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17370,
        GIR_EraseRootFromParent_Done,
      // Label 16386: @1142183
      GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1142263), // Rule ID 17371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10808:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17371,
        GIR_EraseRootFromParent_Done,
      // Label 16387: @1142263
      GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1142343), // Rule ID 17374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17374,
        GIR_EraseRootFromParent_Done,
      // Label 16388: @1142343
      GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1142423), // Rule ID 17375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17375,
        GIR_EraseRootFromParent_Done,
      // Label 16389: @1142423
      GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1142503), // Rule ID 17378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17378,
        GIR_EraseRootFromParent_Done,
      // Label 16390: @1142503
      GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1142583), // Rule ID 17379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17379,
        GIR_EraseRootFromParent_Done,
      // Label 16391: @1142583
      GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1142663), // Rule ID 17382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17382,
        GIR_EraseRootFromParent_Done,
      // Label 16392: @1142663
      GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1142743), // Rule ID 17383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17383,
        GIR_EraseRootFromParent_Done,
      // Label 16393: @1142743
      GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1142823), // Rule ID 17386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17386,
        GIR_EraseRootFromParent_Done,
      // Label 16394: @1142823
      GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1142903), // Rule ID 17387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17387,
        GIR_EraseRootFromParent_Done,
      // Label 16395: @1142903
      GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1142983), // Rule ID 17390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17390,
        GIR_EraseRootFromParent_Done,
      // Label 16396: @1142983
      GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1143063), // Rule ID 17391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17391,
        GIR_EraseRootFromParent_Done,
      // Label 16397: @1143063
      GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1143143), // Rule ID 17394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17394,
        GIR_EraseRootFromParent_Done,
      // Label 16398: @1143143
      GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1143223), // Rule ID 17395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17395,
        GIR_EraseRootFromParent_Done,
      // Label 16399: @1143223
      GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1143303), // Rule ID 17398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17398,
        GIR_EraseRootFromParent_Done,
      // Label 16400: @1143303
      GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1143383), // Rule ID 17399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17399,
        GIR_EraseRootFromParent_Done,
      // Label 16401: @1143383
      GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1143463), // Rule ID 17402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17402,
        GIR_EraseRootFromParent_Done,
      // Label 16402: @1143463
      GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1143543), // Rule ID 17403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17403,
        GIR_EraseRootFromParent_Done,
      // Label 16403: @1143543
      GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1143623), // Rule ID 17406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17406,
        GIR_EraseRootFromParent_Done,
      // Label 16404: @1143623
      GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1143703), // Rule ID 17407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17407,
        GIR_EraseRootFromParent_Done,
      // Label 16405: @1143703
      GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1143783), // Rule ID 17410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17410,
        GIR_EraseRootFromParent_Done,
      // Label 16406: @1143783
      GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1143863), // Rule ID 17411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17411,
        GIR_EraseRootFromParent_Done,
      // Label 16407: @1143863
      GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1143943), // Rule ID 17414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17414,
        GIR_EraseRootFromParent_Done,
      // Label 16408: @1143943
      GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1144023), // Rule ID 17415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17415,
        GIR_EraseRootFromParent_Done,
      // Label 16409: @1144023
      GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1144103), // Rule ID 17418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17418,
        GIR_EraseRootFromParent_Done,
      // Label 16410: @1144103
      GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1144183), // Rule ID 17419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17419,
        GIR_EraseRootFromParent_Done,
      // Label 16411: @1144183
      GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1144263), // Rule ID 17422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17422,
        GIR_EraseRootFromParent_Done,
      // Label 16412: @1144263
      GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1144343), // Rule ID 17423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17423,
        GIR_EraseRootFromParent_Done,
      // Label 16413: @1144343
      GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1144423), // Rule ID 17426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17426,
        GIR_EraseRootFromParent_Done,
      // Label 16414: @1144423
      GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1144503), // Rule ID 17427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10808:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17427,
        GIR_EraseRootFromParent_Done,
      // Label 16415: @1144503
      GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1144583), // Rule ID 17430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10808:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17430,
        GIR_EraseRootFromParent_Done,
      // Label 16416: @1144583
      GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1144663), // Rule ID 17431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10808:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17431,
        GIR_EraseRootFromParent_Done,
      // Label 16417: @1144663
      GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1144743), // Rule ID 17434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17434,
        GIR_EraseRootFromParent_Done,
      // Label 16418: @1144743
      GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1144823), // Rule ID 17435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10808:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17435,
        GIR_EraseRootFromParent_Done,
      // Label 16419: @1144823
      GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1144903), // Rule ID 17438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17438,
        GIR_EraseRootFromParent_Done,
      // Label 16420: @1144903
      GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1144983), // Rule ID 17439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17439,
        GIR_EraseRootFromParent_Done,
      // Label 16421: @1144983
      GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1145063), // Rule ID 17442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17442,
        GIR_EraseRootFromParent_Done,
      // Label 16422: @1145063
      GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1145143), // Rule ID 17443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17443,
        GIR_EraseRootFromParent_Done,
      // Label 16423: @1145143
      GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1145223), // Rule ID 17446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17446,
        GIR_EraseRootFromParent_Done,
      // Label 16424: @1145223
      GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1145303), // Rule ID 17447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17447,
        GIR_EraseRootFromParent_Done,
      // Label 16425: @1145303
      GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1145383), // Rule ID 17450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17450,
        GIR_EraseRootFromParent_Done,
      // Label 16426: @1145383
      GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1145463), // Rule ID 17451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17451,
        GIR_EraseRootFromParent_Done,
      // Label 16427: @1145463
      GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1145543), // Rule ID 17454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17454,
        GIR_EraseRootFromParent_Done,
      // Label 16428: @1145543
      GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1145623), // Rule ID 17455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17455,
        GIR_EraseRootFromParent_Done,
      // Label 16429: @1145623
      GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1145703), // Rule ID 17458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17458,
        GIR_EraseRootFromParent_Done,
      // Label 16430: @1145703
      GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1145783), // Rule ID 17459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17459,
        GIR_EraseRootFromParent_Done,
      // Label 16431: @1145783
      GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1145863), // Rule ID 17462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17462,
        GIR_EraseRootFromParent_Done,
      // Label 16432: @1145863
      GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1145943), // Rule ID 17463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10808:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17463,
        GIR_EraseRootFromParent_Done,
      // Label 16433: @1145943
      GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1146023), // Rule ID 17466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17466,
        GIR_EraseRootFromParent_Done,
      // Label 16434: @1146023
      GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1146103), // Rule ID 17467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10808:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17467,
        GIR_EraseRootFromParent_Done,
      // Label 16435: @1146103
      GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1146183), // Rule ID 17470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17470,
        GIR_EraseRootFromParent_Done,
      // Label 16436: @1146183
      GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1146263), // Rule ID 17471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10808:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17471,
        GIR_EraseRootFromParent_Done,
      // Label 16437: @1146263
      GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1146343), // Rule ID 17474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17474,
        GIR_EraseRootFromParent_Done,
      // Label 16438: @1146343
      GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1146423), // Rule ID 17475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17475,
        GIR_EraseRootFromParent_Done,
      // Label 16439: @1146423
      GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1146503), // Rule ID 17478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17478,
        GIR_EraseRootFromParent_Done,
      // Label 16440: @1146503
      GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1146583), // Rule ID 17479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17479,
        GIR_EraseRootFromParent_Done,
      // Label 16441: @1146583
      GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1146663), // Rule ID 17482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17482,
        GIR_EraseRootFromParent_Done,
      // Label 16442: @1146663
      GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1146743), // Rule ID 17483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17483,
        GIR_EraseRootFromParent_Done,
      // Label 16443: @1146743
      GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1146823), // Rule ID 17486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17486,
        GIR_EraseRootFromParent_Done,
      // Label 16444: @1146823
      GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1146903), // Rule ID 17487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10856:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17487,
        GIR_EraseRootFromParent_Done,
      // Label 16445: @1146903
      GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1146983), // Rule ID 17490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17490,
        GIR_EraseRootFromParent_Done,
      // Label 16446: @1146983
      GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1147063), // Rule ID 17491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10856:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17491,
        GIR_EraseRootFromParent_Done,
      // Label 16447: @1147063
      GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1147143), // Rule ID 17494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17494,
        GIR_EraseRootFromParent_Done,
      // Label 16448: @1147143
      GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1147223), // Rule ID 17495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10856:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17495,
        GIR_EraseRootFromParent_Done,
      // Label 16449: @1147223
      GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1147303), // Rule ID 17498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17498,
        GIR_EraseRootFromParent_Done,
      // Label 16450: @1147303
      GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1147383), // Rule ID 17499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17499,
        GIR_EraseRootFromParent_Done,
      // Label 16451: @1147383
      GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1147463), // Rule ID 17502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17502,
        GIR_EraseRootFromParent_Done,
      // Label 16452: @1147463
      GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1147543), // Rule ID 17503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17503,
        GIR_EraseRootFromParent_Done,
      // Label 16453: @1147543
      GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1147623), // Rule ID 17506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17506,
        GIR_EraseRootFromParent_Done,
      // Label 16454: @1147623
      GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1147703), // Rule ID 17507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17507,
        GIR_EraseRootFromParent_Done,
      // Label 16455: @1147703
      GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1147783), // Rule ID 17510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17510,
        GIR_EraseRootFromParent_Done,
      // Label 16456: @1147783
      GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1147863), // Rule ID 17511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17511,
        GIR_EraseRootFromParent_Done,
      // Label 16457: @1147863
      GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1147943), // Rule ID 17514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17514,
        GIR_EraseRootFromParent_Done,
      // Label 16458: @1147943
      GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1148023), // Rule ID 17515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17515,
        GIR_EraseRootFromParent_Done,
      // Label 16459: @1148023
      GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1148103), // Rule ID 17518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17518,
        GIR_EraseRootFromParent_Done,
      // Label 16460: @1148103
      GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1148183), // Rule ID 17519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17519,
        GIR_EraseRootFromParent_Done,
      // Label 16461: @1148183
      GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1148263), // Rule ID 17522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17522,
        GIR_EraseRootFromParent_Done,
      // Label 16462: @1148263
      GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1148343), // Rule ID 17523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10856:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17523,
        GIR_EraseRootFromParent_Done,
      // Label 16463: @1148343
      GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1148423), // Rule ID 17526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17526,
        GIR_EraseRootFromParent_Done,
      // Label 16464: @1148423
      GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1148503), // Rule ID 17527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10856:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17527,
        GIR_EraseRootFromParent_Done,
      // Label 16465: @1148503
      GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1148583), // Rule ID 17530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17530,
        GIR_EraseRootFromParent_Done,
      // Label 16466: @1148583
      GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1148663), // Rule ID 17531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10856:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17531,
        GIR_EraseRootFromParent_Done,
      // Label 16467: @1148663
      GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1148743), // Rule ID 17534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10912:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17534,
        GIR_EraseRootFromParent_Done,
      // Label 16468: @1148743
      GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1148823), // Rule ID 17535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10912:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17535,
        GIR_EraseRootFromParent_Done,
      // Label 16469: @1148823
      GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1148903), // Rule ID 17538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10912:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17538,
        GIR_EraseRootFromParent_Done,
      // Label 16470: @1148903
      GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1148983), // Rule ID 17539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10912:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17539,
        GIR_EraseRootFromParent_Done,
      // Label 16471: @1148983
      GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1149063), // Rule ID 17542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10912:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17542,
        GIR_EraseRootFromParent_Done,
      // Label 16472: @1149063
      GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1149143), // Rule ID 17543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10912:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17543,
        GIR_EraseRootFromParent_Done,
      // Label 16473: @1149143
      GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1149223), // Rule ID 17546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10912:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17546,
        GIR_EraseRootFromParent_Done,
      // Label 16474: @1149223
      GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1149303), // Rule ID 17547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10912:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17547,
        GIR_EraseRootFromParent_Done,
      // Label 16475: @1149303
      GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1149383), // Rule ID 17550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10912:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17550,
        GIR_EraseRootFromParent_Done,
      // Label 16476: @1149383
      GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1149463), // Rule ID 17551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10912:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17551,
        GIR_EraseRootFromParent_Done,
      // Label 16477: @1149463
      GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1149543), // Rule ID 17554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10912:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17554,
        GIR_EraseRootFromParent_Done,
      // Label 16478: @1149543
      GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1149623), // Rule ID 17555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10912:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17555,
        GIR_EraseRootFromParent_Done,
      // Label 16479: @1149623
      GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1149703), // Rule ID 17558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10912:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17558,
        GIR_EraseRootFromParent_Done,
      // Label 16480: @1149703
      GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1149783), // Rule ID 17559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10912:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17559,
        GIR_EraseRootFromParent_Done,
      // Label 16481: @1149783
      GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1149863), // Rule ID 17562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10912:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17562,
        GIR_EraseRootFromParent_Done,
      // Label 16482: @1149863
      GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1149943), // Rule ID 17563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10912:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17563,
        GIR_EraseRootFromParent_Done,
      // Label 16483: @1149943
      GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1150023), // Rule ID 17566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10912:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17566,
        GIR_EraseRootFromParent_Done,
      // Label 16484: @1150023
      GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1150103), // Rule ID 17567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10912:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17567,
        GIR_EraseRootFromParent_Done,
      // Label 16485: @1150103
      GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1150183), // Rule ID 17570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10912:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17570,
        GIR_EraseRootFromParent_Done,
      // Label 16486: @1150183
      GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1150263), // Rule ID 17571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10912:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17571,
        GIR_EraseRootFromParent_Done,
      // Label 16487: @1150263
      GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1150343), // Rule ID 17574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10912:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17574,
        GIR_EraseRootFromParent_Done,
      // Label 16488: @1150343
      GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1150423), // Rule ID 17575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10912:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17575,
        GIR_EraseRootFromParent_Done,
      // Label 16489: @1150423
      GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1150503), // Rule ID 17578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10912:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17578,
        GIR_EraseRootFromParent_Done,
      // Label 16490: @1150503
      GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1150583), // Rule ID 17579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10912:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17579,
        GIR_EraseRootFromParent_Done,
      // Label 16491: @1150583
      GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1150663), // Rule ID 17582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10912:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17582,
        GIR_EraseRootFromParent_Done,
      // Label 16492: @1150663
      GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1150743), // Rule ID 17583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10912:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17583,
        GIR_EraseRootFromParent_Done,
      // Label 16493: @1150743
      GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1150823), // Rule ID 17586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10912:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17586,
        GIR_EraseRootFromParent_Done,
      // Label 16494: @1150823
      GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1150903), // Rule ID 17587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10912:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17587,
        GIR_EraseRootFromParent_Done,
      // Label 16495: @1150903
      GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1150983), // Rule ID 17590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10912:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17590,
        GIR_EraseRootFromParent_Done,
      // Label 16496: @1150983
      GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1151063), // Rule ID 17591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10912:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17591,
        GIR_EraseRootFromParent_Done,
      // Label 16497: @1151063
      GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1151143), // Rule ID 17594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10912:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17594,
        GIR_EraseRootFromParent_Done,
      // Label 16498: @1151143
      GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1151223), // Rule ID 17595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10912:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17595,
        GIR_EraseRootFromParent_Done,
      // Label 16499: @1151223
      GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1151303), // Rule ID 17598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10912:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17598,
        GIR_EraseRootFromParent_Done,
      // Label 16500: @1151303
      GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1151383), // Rule ID 17599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10912:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17599,
        GIR_EraseRootFromParent_Done,
      // Label 16501: @1151383
      GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1151463), // Rule ID 17602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10912:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17602,
        GIR_EraseRootFromParent_Done,
      // Label 16502: @1151463
      GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1151543), // Rule ID 17603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10912:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17603,
        GIR_EraseRootFromParent_Done,
      // Label 16503: @1151543
      GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1151623), // Rule ID 22680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22680,
        GIR_EraseRootFromParent_Done,
      // Label 16504: @1151623
      GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1151703), // Rule ID 22681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22681,
        GIR_EraseRootFromParent_Done,
      // Label 16505: @1151703
      GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1151783), // Rule ID 22684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22684,
        GIR_EraseRootFromParent_Done,
      // Label 16506: @1151783
      GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1151863), // Rule ID 22685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22685,
        GIR_EraseRootFromParent_Done,
      // Label 16507: @1151863
      GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1151943), // Rule ID 22688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22688,
        GIR_EraseRootFromParent_Done,
      // Label 16508: @1151943
      GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1152023), // Rule ID 22689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22689,
        GIR_EraseRootFromParent_Done,
      // Label 16509: @1152023
      GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1152103), // Rule ID 22692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22692,
        GIR_EraseRootFromParent_Done,
      // Label 16510: @1152103
      GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1152183), // Rule ID 22693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22693,
        GIR_EraseRootFromParent_Done,
      // Label 16511: @1152183
      GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1152263), // Rule ID 22696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22696,
        GIR_EraseRootFromParent_Done,
      // Label 16512: @1152263
      GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1152343), // Rule ID 22697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22697,
        GIR_EraseRootFromParent_Done,
      // Label 16513: @1152343
      GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1152423), // Rule ID 22700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22700,
        GIR_EraseRootFromParent_Done,
      // Label 16514: @1152423
      GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1152503), // Rule ID 22701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22701,
        GIR_EraseRootFromParent_Done,
      // Label 16515: @1152503
      GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1152583), // Rule ID 22704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22704,
        GIR_EraseRootFromParent_Done,
      // Label 16516: @1152583
      GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1152663), // Rule ID 22705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22705,
        GIR_EraseRootFromParent_Done,
      // Label 16517: @1152663
      GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1152743), // Rule ID 22708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22708,
        GIR_EraseRootFromParent_Done,
      // Label 16518: @1152743
      GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1152823), // Rule ID 22709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10864:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22709,
        GIR_EraseRootFromParent_Done,
      // Label 16519: @1152823
      GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1152903), // Rule ID 22712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22712,
        GIR_EraseRootFromParent_Done,
      // Label 16520: @1152903
      GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1152983), // Rule ID 22713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22713,
        GIR_EraseRootFromParent_Done,
      // Label 16521: @1152983
      GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1153063), // Rule ID 22716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22716,
        GIR_EraseRootFromParent_Done,
      // Label 16522: @1153063
      GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1153143), // Rule ID 22717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22717,
        GIR_EraseRootFromParent_Done,
      // Label 16523: @1153143
      GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1153223), // Rule ID 22720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22720,
        GIR_EraseRootFromParent_Done,
      // Label 16524: @1153223
      GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1153303), // Rule ID 22721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10864:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22721,
        GIR_EraseRootFromParent_Done,
      // Label 16525: @1153303
      GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1153383), // Rule ID 22724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22724,
        GIR_EraseRootFromParent_Done,
      // Label 16526: @1153383
      GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1153463), // Rule ID 22725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22725,
        GIR_EraseRootFromParent_Done,
      // Label 16527: @1153463
      GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1153543), // Rule ID 22728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22728,
        GIR_EraseRootFromParent_Done,
      // Label 16528: @1153543
      GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1153623), // Rule ID 22729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22729,
        GIR_EraseRootFromParent_Done,
      // Label 16529: @1153623
      GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1153703), // Rule ID 22732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22732,
        GIR_EraseRootFromParent_Done,
      // Label 16530: @1153703
      GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1153783), // Rule ID 22733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10864:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22733,
        GIR_EraseRootFromParent_Done,
      // Label 16531: @1153783
      GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1153863), // Rule ID 22736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22736,
        GIR_EraseRootFromParent_Done,
      // Label 16532: @1153863
      GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1153943), // Rule ID 22737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22737,
        GIR_EraseRootFromParent_Done,
      // Label 16533: @1153943
      GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1154023), // Rule ID 22740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22740,
        GIR_EraseRootFromParent_Done,
      // Label 16534: @1154023
      GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1154103), // Rule ID 22741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22741,
        GIR_EraseRootFromParent_Done,
      // Label 16535: @1154103
      GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1154183), // Rule ID 22744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22744,
        GIR_EraseRootFromParent_Done,
      // Label 16536: @1154183
      GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1154263), // Rule ID 22745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22745,
        GIR_EraseRootFromParent_Done,
      // Label 16537: @1154263
      GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1154343), // Rule ID 22748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22748,
        GIR_EraseRootFromParent_Done,
      // Label 16538: @1154343
      GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1154423), // Rule ID 22749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22749,
        GIR_EraseRootFromParent_Done,
      // Label 16539: @1154423
      GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1154503), // Rule ID 22752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22752,
        GIR_EraseRootFromParent_Done,
      // Label 16540: @1154503
      GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1154583), // Rule ID 22753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22753,
        GIR_EraseRootFromParent_Done,
      // Label 16541: @1154583
      GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1154663), // Rule ID 22756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22756,
        GIR_EraseRootFromParent_Done,
      // Label 16542: @1154663
      GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1154743), // Rule ID 22757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22757,
        GIR_EraseRootFromParent_Done,
      // Label 16543: @1154743
      GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1154823), // Rule ID 22760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22760,
        GIR_EraseRootFromParent_Done,
      // Label 16544: @1154823
      GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1154903), // Rule ID 22761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22761,
        GIR_EraseRootFromParent_Done,
      // Label 16545: @1154903
      GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1154983), // Rule ID 22764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22764,
        GIR_EraseRootFromParent_Done,
      // Label 16546: @1154983
      GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1155063), // Rule ID 22765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22765,
        GIR_EraseRootFromParent_Done,
      // Label 16547: @1155063
      GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1155143), // Rule ID 22768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22768,
        GIR_EraseRootFromParent_Done,
      // Label 16548: @1155143
      GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1155223), // Rule ID 22769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10866:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22769,
        GIR_EraseRootFromParent_Done,
      // Label 16549: @1155223
      GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1155303), // Rule ID 22772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22772,
        GIR_EraseRootFromParent_Done,
      // Label 16550: @1155303
      GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1155383), // Rule ID 22773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22773,
        GIR_EraseRootFromParent_Done,
      // Label 16551: @1155383
      GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1155463), // Rule ID 22776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22776,
        GIR_EraseRootFromParent_Done,
      // Label 16552: @1155463
      GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1155543), // Rule ID 22777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22777,
        GIR_EraseRootFromParent_Done,
      // Label 16553: @1155543
      GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1155623), // Rule ID 22780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22780,
        GIR_EraseRootFromParent_Done,
      // Label 16554: @1155623
      GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1155703), // Rule ID 22781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10866:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22781,
        GIR_EraseRootFromParent_Done,
      // Label 16555: @1155703
      GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1155783), // Rule ID 22784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22784,
        GIR_EraseRootFromParent_Done,
      // Label 16556: @1155783
      GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1155863), // Rule ID 22785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22785,
        GIR_EraseRootFromParent_Done,
      // Label 16557: @1155863
      GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1155943), // Rule ID 22788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22788,
        GIR_EraseRootFromParent_Done,
      // Label 16558: @1155943
      GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1156023), // Rule ID 22789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22789,
        GIR_EraseRootFromParent_Done,
      // Label 16559: @1156023
      GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1156103), // Rule ID 22792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22792,
        GIR_EraseRootFromParent_Done,
      // Label 16560: @1156103
      GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1156183), // Rule ID 22793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10866:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22793,
        GIR_EraseRootFromParent_Done,
      // Label 16561: @1156183
      GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1156263), // Rule ID 22916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22916,
        GIR_EraseRootFromParent_Done,
      // Label 16562: @1156263
      GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1156343), // Rule ID 22917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22917,
        GIR_EraseRootFromParent_Done,
      // Label 16563: @1156343
      GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1156423), // Rule ID 22920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22920,
        GIR_EraseRootFromParent_Done,
      // Label 16564: @1156423
      GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1156503), // Rule ID 22921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22921,
        GIR_EraseRootFromParent_Done,
      // Label 16565: @1156503
      GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1156583), // Rule ID 22924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22924,
        GIR_EraseRootFromParent_Done,
      // Label 16566: @1156583
      GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1156663), // Rule ID 22925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22925,
        GIR_EraseRootFromParent_Done,
      // Label 16567: @1156663
      GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1156743), // Rule ID 22928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22928,
        GIR_EraseRootFromParent_Done,
      // Label 16568: @1156743
      GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1156823), // Rule ID 22929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22929,
        GIR_EraseRootFromParent_Done,
      // Label 16569: @1156823
      GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1156903), // Rule ID 22932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22932,
        GIR_EraseRootFromParent_Done,
      // Label 16570: @1156903
      GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1156983), // Rule ID 22933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22933,
        GIR_EraseRootFromParent_Done,
      // Label 16571: @1156983
      GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1157063), // Rule ID 22936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22936,
        GIR_EraseRootFromParent_Done,
      // Label 16572: @1157063
      GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1157143), // Rule ID 22937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22937,
        GIR_EraseRootFromParent_Done,
      // Label 16573: @1157143
      GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1157223), // Rule ID 22940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22940,
        GIR_EraseRootFromParent_Done,
      // Label 16574: @1157223
      GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1157303), // Rule ID 22941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22941,
        GIR_EraseRootFromParent_Done,
      // Label 16575: @1157303
      GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1157383), // Rule ID 22944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22944,
        GIR_EraseRootFromParent_Done,
      // Label 16576: @1157383
      GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1157463), // Rule ID 22945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10920:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22945,
        GIR_EraseRootFromParent_Done,
      // Label 16577: @1157463
      GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1157543), // Rule ID 22948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22948,
        GIR_EraseRootFromParent_Done,
      // Label 16578: @1157543
      GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1157623), // Rule ID 22949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22949,
        GIR_EraseRootFromParent_Done,
      // Label 16579: @1157623
      GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1157703), // Rule ID 22952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22952,
        GIR_EraseRootFromParent_Done,
      // Label 16580: @1157703
      GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1157783), // Rule ID 22953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22953,
        GIR_EraseRootFromParent_Done,
      // Label 16581: @1157783
      GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1157863), // Rule ID 22956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22956,
        GIR_EraseRootFromParent_Done,
      // Label 16582: @1157863
      GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1157943), // Rule ID 22957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10920:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22957,
        GIR_EraseRootFromParent_Done,
      // Label 16583: @1157943
      GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1158023), // Rule ID 22960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22960,
        GIR_EraseRootFromParent_Done,
      // Label 16584: @1158023
      GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1158103), // Rule ID 22961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22961,
        GIR_EraseRootFromParent_Done,
      // Label 16585: @1158103
      GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1158183), // Rule ID 22964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22964,
        GIR_EraseRootFromParent_Done,
      // Label 16586: @1158183
      GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1158263), // Rule ID 22965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22965,
        GIR_EraseRootFromParent_Done,
      // Label 16587: @1158263
      GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1158343), // Rule ID 22968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22968,
        GIR_EraseRootFromParent_Done,
      // Label 16588: @1158343
      GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1158423), // Rule ID 22969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22969,
        GIR_EraseRootFromParent_Done,
      // Label 16589: @1158423
      GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1158503), // Rule ID 22972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22972,
        GIR_EraseRootFromParent_Done,
      // Label 16590: @1158503
      GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1158583), // Rule ID 22973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22973,
        GIR_EraseRootFromParent_Done,
      // Label 16591: @1158583
      GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1158663), // Rule ID 22976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22976,
        GIR_EraseRootFromParent_Done,
      // Label 16592: @1158663
      GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1158743), // Rule ID 22977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22977,
        GIR_EraseRootFromParent_Done,
      // Label 16593: @1158743
      GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1158823), // Rule ID 22980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22980,
        GIR_EraseRootFromParent_Done,
      // Label 16594: @1158823
      GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1158903), // Rule ID 22981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22981,
        GIR_EraseRootFromParent_Done,
      // Label 16595: @1158903
      GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1158983), // Rule ID 22984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22984,
        GIR_EraseRootFromParent_Done,
      // Label 16596: @1158983
      GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1159063), // Rule ID 22985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22985,
        GIR_EraseRootFromParent_Done,
      // Label 16597: @1159063
      GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1159143), // Rule ID 22988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22988,
        GIR_EraseRootFromParent_Done,
      // Label 16598: @1159143
      GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1159223), // Rule ID 22989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10918:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22989,
        GIR_EraseRootFromParent_Done,
      // Label 16599: @1159223
      GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1159303), // Rule ID 22992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22992,
        GIR_EraseRootFromParent_Done,
      // Label 16600: @1159303
      GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1159383), // Rule ID 22993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22993,
        GIR_EraseRootFromParent_Done,
      // Label 16601: @1159383
      GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1159463), // Rule ID 22996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22996,
        GIR_EraseRootFromParent_Done,
      // Label 16602: @1159463
      GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1159543), // Rule ID 22997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22997,
        GIR_EraseRootFromParent_Done,
      // Label 16603: @1159543
      GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1159623), // Rule ID 23000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23000,
        GIR_EraseRootFromParent_Done,
      // Label 16604: @1159623
      GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1159703), // Rule ID 23001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10918:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23001,
        GIR_EraseRootFromParent_Done,
      // Label 16605: @1159703
      GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1159783), // Rule ID 63765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10705:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63765,
        GIR_EraseRootFromParent_Done,
      // Label 16606: @1159783
      GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1159863), // Rule ID 63766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10705:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63766,
        GIR_EraseRootFromParent_Done,
      // Label 16607: @1159863
      GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1159943), // Rule ID 63769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10705:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63769,
        GIR_EraseRootFromParent_Done,
      // Label 16608: @1159943
      GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1160023), // Rule ID 63770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10705:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63770,
        GIR_EraseRootFromParent_Done,
      // Label 16609: @1160023
      GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1160103), // Rule ID 63773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10705:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63773,
        GIR_EraseRootFromParent_Done,
      // Label 16610: @1160103
      GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1160183), // Rule ID 63774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10705:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63774,
        GIR_EraseRootFromParent_Done,
      // Label 16611: @1160183
      GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1160263), // Rule ID 63777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10705:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63777,
        GIR_EraseRootFromParent_Done,
      // Label 16612: @1160263
      GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1160343), // Rule ID 63778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10705:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63778,
        GIR_EraseRootFromParent_Done,
      // Label 16613: @1160343
      GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1160423), // Rule ID 63781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10705:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63781,
        GIR_EraseRootFromParent_Done,
      // Label 16614: @1160423
      GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1160503), // Rule ID 63782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10705:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63782,
        GIR_EraseRootFromParent_Done,
      // Label 16615: @1160503
      GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1160583), // Rule ID 63785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10703:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63785,
        GIR_EraseRootFromParent_Done,
      // Label 16616: @1160583
      GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1160663), // Rule ID 63786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10703:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63786,
        GIR_EraseRootFromParent_Done,
      // Label 16617: @1160663
      GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1160743), // Rule ID 63789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10703:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63789,
        GIR_EraseRootFromParent_Done,
      // Label 16618: @1160743
      GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1160823), // Rule ID 63790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10703:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63790,
        GIR_EraseRootFromParent_Done,
      // Label 16619: @1160823
      GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1160903), // Rule ID 63793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10703:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63793,
        GIR_EraseRootFromParent_Done,
      // Label 16620: @1160903
      GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1160983), // Rule ID 63794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10703:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63794,
        GIR_EraseRootFromParent_Done,
      // Label 16621: @1160983
      GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1161063), // Rule ID 63797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10703:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63797,
        GIR_EraseRootFromParent_Done,
      // Label 16622: @1161063
      GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1161143), // Rule ID 63798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10703:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63798,
        GIR_EraseRootFromParent_Done,
      // Label 16623: @1161143
      GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1161223), // Rule ID 63801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10703:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63801,
        GIR_EraseRootFromParent_Done,
      // Label 16624: @1161223
      GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1161303), // Rule ID 63802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10703:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63802,
        GIR_EraseRootFromParent_Done,
      // Label 16625: @1161303
      GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1161402), // Rule ID 2576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2576,
        GIR_EraseRootFromParent_Done,
      // Label 16626: @1161402
      GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1161501), // Rule ID 2577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2577,
        GIR_EraseRootFromParent_Done,
      // Label 16627: @1161501
      GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1161600), // Rule ID 2588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2588,
        GIR_EraseRootFromParent_Done,
      // Label 16628: @1161600
      GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1161699), // Rule ID 2589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2589,
        GIR_EraseRootFromParent_Done,
      // Label 16629: @1161699
      GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1161798), // Rule ID 2590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2590,
        GIR_EraseRootFromParent_Done,
      // Label 16630: @1161798
      GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1161897), // Rule ID 2591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2591,
        GIR_EraseRootFromParent_Done,
      // Label 16631: @1161897
      GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1161999), // Rule ID 2640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2640,
        GIR_EraseRootFromParent_Done,
      // Label 16632: @1161999
      GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1162101), // Rule ID 2641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2641,
        GIR_EraseRootFromParent_Done,
      // Label 16633: @1162101
      GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1162200), // Rule ID 4968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4968,
        GIR_EraseRootFromParent_Done,
      // Label 16634: @1162200
      GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1162299), // Rule ID 4969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4969,
        GIR_EraseRootFromParent_Done,
      // Label 16635: @1162299
      GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1162398), // Rule ID 4970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4970,
        GIR_EraseRootFromParent_Done,
      // Label 16636: @1162398
      GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1162497), // Rule ID 4971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4971,
        GIR_EraseRootFromParent_Done,
      // Label 16637: @1162497
      GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1162596), // Rule ID 4972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4972,
        GIR_EraseRootFromParent_Done,
      // Label 16638: @1162596
      GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1162695), // Rule ID 4973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4973,
        GIR_EraseRootFromParent_Done,
      // Label 16639: @1162695
      GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1162794), // Rule ID 4974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4974,
        GIR_EraseRootFromParent_Done,
      // Label 16640: @1162794
      GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1162893), // Rule ID 4975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4975,
        GIR_EraseRootFromParent_Done,
      // Label 16641: @1162893
      GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1162992), // Rule ID 4976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4976,
        GIR_EraseRootFromParent_Done,
      // Label 16642: @1162992
      GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1163091), // Rule ID 4977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4977,
        GIR_EraseRootFromParent_Done,
      // Label 16643: @1163091
      GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1163190), // Rule ID 4978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4978,
        GIR_EraseRootFromParent_Done,
      // Label 16644: @1163190
      GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1163289), // Rule ID 4979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4979,
        GIR_EraseRootFromParent_Done,
      // Label 16645: @1163289
      GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1163388), // Rule ID 4980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4980,
        GIR_EraseRootFromParent_Done,
      // Label 16646: @1163388
      GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1163487), // Rule ID 4981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4981,
        GIR_EraseRootFromParent_Done,
      // Label 16647: @1163487
      GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1163586), // Rule ID 4982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4982,
        GIR_EraseRootFromParent_Done,
      // Label 16648: @1163586
      GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1163685), // Rule ID 4983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4983,
        GIR_EraseRootFromParent_Done,
      // Label 16649: @1163685
      GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1163784), // Rule ID 4984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4984,
        GIR_EraseRootFromParent_Done,
      // Label 16650: @1163784
      GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1163883), // Rule ID 4985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4985,
        GIR_EraseRootFromParent_Done,
      // Label 16651: @1163883
      GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1163982), // Rule ID 4986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4986,
        GIR_EraseRootFromParent_Done,
      // Label 16652: @1163982
      GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1164081), // Rule ID 4987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4987,
        GIR_EraseRootFromParent_Done,
      // Label 16653: @1164081
      GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1164180), // Rule ID 4988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4988,
        GIR_EraseRootFromParent_Done,
      // Label 16654: @1164180
      GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1164279), // Rule ID 4989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4989,
        GIR_EraseRootFromParent_Done,
      // Label 16655: @1164279
      GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1164378), // Rule ID 4990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4990,
        GIR_EraseRootFromParent_Done,
      // Label 16656: @1164378
      GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1164477), // Rule ID 4991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4991,
        GIR_EraseRootFromParent_Done,
      // Label 16657: @1164477
      GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1164576), // Rule ID 4992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4992,
        GIR_EraseRootFromParent_Done,
      // Label 16658: @1164576
      GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1164675), // Rule ID 4993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4993,
        GIR_EraseRootFromParent_Done,
      // Label 16659: @1164675
      GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1164774), // Rule ID 4994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4994,
        GIR_EraseRootFromParent_Done,
      // Label 16660: @1164774
      GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1164873), // Rule ID 4995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4995,
        GIR_EraseRootFromParent_Done,
      // Label 16661: @1164873
      GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1164972), // Rule ID 4996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4996,
        GIR_EraseRootFromParent_Done,
      // Label 16662: @1164972
      GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1165071), // Rule ID 4997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4997,
        GIR_EraseRootFromParent_Done,
      // Label 16663: @1165071
      GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1165170), // Rule ID 4998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4998,
        GIR_EraseRootFromParent_Done,
      // Label 16664: @1165170
      GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1165269), // Rule ID 4999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4999,
        GIR_EraseRootFromParent_Done,
      // Label 16665: @1165269
      GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1165368), // Rule ID 5000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5000,
        GIR_EraseRootFromParent_Done,
      // Label 16666: @1165368
      GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1165467), // Rule ID 5001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5001,
        GIR_EraseRootFromParent_Done,
      // Label 16667: @1165467
      GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1165566), // Rule ID 5002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5002,
        GIR_EraseRootFromParent_Done,
      // Label 16668: @1165566
      GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1165665), // Rule ID 5003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5003,
        GIR_EraseRootFromParent_Done,
      // Label 16669: @1165665
      GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1165764), // Rule ID 5004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5004,
        GIR_EraseRootFromParent_Done,
      // Label 16670: @1165764
      GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1165863), // Rule ID 5005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5005,
        GIR_EraseRootFromParent_Done,
      // Label 16671: @1165863
      GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1165962), // Rule ID 5006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5006,
        GIR_EraseRootFromParent_Done,
      // Label 16672: @1165962
      GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1166061), // Rule ID 5007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5007,
        GIR_EraseRootFromParent_Done,
      // Label 16673: @1166061
      GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1166160), // Rule ID 5008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5008,
        GIR_EraseRootFromParent_Done,
      // Label 16674: @1166160
      GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1166259), // Rule ID 5009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5009,
        GIR_EraseRootFromParent_Done,
      // Label 16675: @1166259
      GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1166358), // Rule ID 5010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5010,
        GIR_EraseRootFromParent_Done,
      // Label 16676: @1166358
      GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1166457), // Rule ID 5011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5011,
        GIR_EraseRootFromParent_Done,
      // Label 16677: @1166457
      GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1166556), // Rule ID 5012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5012,
        GIR_EraseRootFromParent_Done,
      // Label 16678: @1166556
      GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1166655), // Rule ID 5013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5013,
        GIR_EraseRootFromParent_Done,
      // Label 16679: @1166655
      GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1166754), // Rule ID 5014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5014,
        GIR_EraseRootFromParent_Done,
      // Label 16680: @1166754
      GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1166853), // Rule ID 5015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5015,
        GIR_EraseRootFromParent_Done,
      // Label 16681: @1166853
      GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1166952), // Rule ID 5016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5016,
        GIR_EraseRootFromParent_Done,
      // Label 16682: @1166952
      GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1167051), // Rule ID 5017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5017,
        GIR_EraseRootFromParent_Done,
      // Label 16683: @1167051
      GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1167150), // Rule ID 5018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5018,
        GIR_EraseRootFromParent_Done,
      // Label 16684: @1167150
      GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1167249), // Rule ID 5019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5019,
        GIR_EraseRootFromParent_Done,
      // Label 16685: @1167249
      GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1167348), // Rule ID 5020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5020,
        GIR_EraseRootFromParent_Done,
      // Label 16686: @1167348
      GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1167447), // Rule ID 5021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5021,
        GIR_EraseRootFromParent_Done,
      // Label 16687: @1167447
      GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1167546), // Rule ID 5022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5022,
        GIR_EraseRootFromParent_Done,
      // Label 16688: @1167546
      GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1167645), // Rule ID 5023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10749:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5023,
        GIR_EraseRootFromParent_Done,
      // Label 16689: @1167645
      GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1167744), // Rule ID 5024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5024,
        GIR_EraseRootFromParent_Done,
      // Label 16690: @1167744
      GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1167843), // Rule ID 5025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10749:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5025,
        GIR_EraseRootFromParent_Done,
      // Label 16691: @1167843
      GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1167942), // Rule ID 5026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5026,
        GIR_EraseRootFromParent_Done,
      // Label 16692: @1167942
      GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1168041), // Rule ID 5027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10749:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5027,
        GIR_EraseRootFromParent_Done,
      // Label 16693: @1168041
      GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1168140), // Rule ID 5028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5028,
        GIR_EraseRootFromParent_Done,
      // Label 16694: @1168140
      GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1168239), // Rule ID 5029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10749:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5029,
        GIR_EraseRootFromParent_Done,
      // Label 16695: @1168239
      GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1168338), // Rule ID 5030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5030,
        GIR_EraseRootFromParent_Done,
      // Label 16696: @1168338
      GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1168437), // Rule ID 5031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5031,
        GIR_EraseRootFromParent_Done,
      // Label 16697: @1168437
      GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1168536), // Rule ID 5032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5032,
        GIR_EraseRootFromParent_Done,
      // Label 16698: @1168536
      GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1168635), // Rule ID 5033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5033,
        GIR_EraseRootFromParent_Done,
      // Label 16699: @1168635
      GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1168734), // Rule ID 5034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5034,
        GIR_EraseRootFromParent_Done,
      // Label 16700: @1168734
      GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1168833), // Rule ID 5035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5035,
        GIR_EraseRootFromParent_Done,
      // Label 16701: @1168833
      GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1168932), // Rule ID 5036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5036,
        GIR_EraseRootFromParent_Done,
      // Label 16702: @1168932
      GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1169031), // Rule ID 5037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5037,
        GIR_EraseRootFromParent_Done,
      // Label 16703: @1169031
      GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1169130), // Rule ID 5038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5038,
        GIR_EraseRootFromParent_Done,
      // Label 16704: @1169130
      GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1169229), // Rule ID 5039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5039,
        GIR_EraseRootFromParent_Done,
      // Label 16705: @1169229
      GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1169328), // Rule ID 5040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5040,
        GIR_EraseRootFromParent_Done,
      // Label 16706: @1169328
      GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1169427), // Rule ID 5041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5041,
        GIR_EraseRootFromParent_Done,
      // Label 16707: @1169427
      GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1169526), // Rule ID 5042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5042,
        GIR_EraseRootFromParent_Done,
      // Label 16708: @1169526
      GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1169625), // Rule ID 5043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5043,
        GIR_EraseRootFromParent_Done,
      // Label 16709: @1169625
      GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1169724), // Rule ID 5044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5044,
        GIR_EraseRootFromParent_Done,
      // Label 16710: @1169724
      GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1169823), // Rule ID 5045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5045,
        GIR_EraseRootFromParent_Done,
      // Label 16711: @1169823
      GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1169922), // Rule ID 5046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5046,
        GIR_EraseRootFromParent_Done,
      // Label 16712: @1169922
      GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1170021), // Rule ID 5047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5047,
        GIR_EraseRootFromParent_Done,
      // Label 16713: @1170021
      GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1170120), // Rule ID 5048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5048,
        GIR_EraseRootFromParent_Done,
      // Label 16714: @1170120
      GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1170219), // Rule ID 5049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10749:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5049,
        GIR_EraseRootFromParent_Done,
      // Label 16715: @1170219
      GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1170318), // Rule ID 5050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5050,
        GIR_EraseRootFromParent_Done,
      // Label 16716: @1170318
      GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1170417), // Rule ID 5051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10749:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5051,
        GIR_EraseRootFromParent_Done,
      // Label 16717: @1170417
      GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1170516), // Rule ID 5052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5052,
        GIR_EraseRootFromParent_Done,
      // Label 16718: @1170516
      GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1170615), // Rule ID 5053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10749:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5053,
        GIR_EraseRootFromParent_Done,
      // Label 16719: @1170615
      GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1170714), // Rule ID 5358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5358,
        GIR_EraseRootFromParent_Done,
      // Label 16720: @1170714
      GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1170813), // Rule ID 5359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5359,
        GIR_EraseRootFromParent_Done,
      // Label 16721: @1170813
      GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1170912), // Rule ID 5360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5360,
        GIR_EraseRootFromParent_Done,
      // Label 16722: @1170912
      GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1171011), // Rule ID 5361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5361,
        GIR_EraseRootFromParent_Done,
      // Label 16723: @1171011
      GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1171110), // Rule ID 5362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5362,
        GIR_EraseRootFromParent_Done,
      // Label 16724: @1171110
      GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1171209), // Rule ID 5363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5363,
        GIR_EraseRootFromParent_Done,
      // Label 16725: @1171209
      GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1171308), // Rule ID 5364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5364,
        GIR_EraseRootFromParent_Done,
      // Label 16726: @1171308
      GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1171407), // Rule ID 5365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5365,
        GIR_EraseRootFromParent_Done,
      // Label 16727: @1171407
      GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1171506), // Rule ID 5366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5366,
        GIR_EraseRootFromParent_Done,
      // Label 16728: @1171506
      GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1171605), // Rule ID 5367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5367,
        GIR_EraseRootFromParent_Done,
      // Label 16729: @1171605
      GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1171704), // Rule ID 5368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5368,
        GIR_EraseRootFromParent_Done,
      // Label 16730: @1171704
      GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1171803), // Rule ID 5369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5369,
        GIR_EraseRootFromParent_Done,
      // Label 16731: @1171803
      GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1171902), // Rule ID 5370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5370,
        GIR_EraseRootFromParent_Done,
      // Label 16732: @1171902
      GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1172001), // Rule ID 5371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5371,
        GIR_EraseRootFromParent_Done,
      // Label 16733: @1172001
      GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1172100), // Rule ID 5372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5372,
        GIR_EraseRootFromParent_Done,
      // Label 16734: @1172100
      GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1172199), // Rule ID 5373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5373,
        GIR_EraseRootFromParent_Done,
      // Label 16735: @1172199
      GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1172298), // Rule ID 5374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5374,
        GIR_EraseRootFromParent_Done,
      // Label 16736: @1172298
      GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1172397), // Rule ID 5375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5375,
        GIR_EraseRootFromParent_Done,
      // Label 16737: @1172397
      GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1172496), // Rule ID 5376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5376,
        GIR_EraseRootFromParent_Done,
      // Label 16738: @1172496
      GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1172595), // Rule ID 5377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5377,
        GIR_EraseRootFromParent_Done,
      // Label 16739: @1172595
      GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1172694), // Rule ID 5378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5378,
        GIR_EraseRootFromParent_Done,
      // Label 16740: @1172694
      GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1172793), // Rule ID 5379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5379,
        GIR_EraseRootFromParent_Done,
      // Label 16741: @1172793
      GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1172892), // Rule ID 5380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5380,
        GIR_EraseRootFromParent_Done,
      // Label 16742: @1172892
      GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1172991), // Rule ID 5381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5381,
        GIR_EraseRootFromParent_Done,
      // Label 16743: @1172991
      GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1173090), // Rule ID 5382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5382,
        GIR_EraseRootFromParent_Done,
      // Label 16744: @1173090
      GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1173189), // Rule ID 5383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5383,
        GIR_EraseRootFromParent_Done,
      // Label 16745: @1173189
      GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1173288), // Rule ID 5384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5384,
        GIR_EraseRootFromParent_Done,
      // Label 16746: @1173288
      GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1173387), // Rule ID 5385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5385,
        GIR_EraseRootFromParent_Done,
      // Label 16747: @1173387
      GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1173486), // Rule ID 5386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5386,
        GIR_EraseRootFromParent_Done,
      // Label 16748: @1173486
      GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1173585), // Rule ID 5387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5387,
        GIR_EraseRootFromParent_Done,
      // Label 16749: @1173585
      GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1173684), // Rule ID 5388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5388,
        GIR_EraseRootFromParent_Done,
      // Label 16750: @1173684
      GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1173783), // Rule ID 5389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5389,
        GIR_EraseRootFromParent_Done,
      // Label 16751: @1173783
      GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1173882), // Rule ID 5390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5390,
        GIR_EraseRootFromParent_Done,
      // Label 16752: @1173882
      GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1173981), // Rule ID 5391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5391,
        GIR_EraseRootFromParent_Done,
      // Label 16753: @1173981
      GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1174080), // Rule ID 5392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5392,
        GIR_EraseRootFromParent_Done,
      // Label 16754: @1174080
      GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1174179), // Rule ID 5393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5393,
        GIR_EraseRootFromParent_Done,
      // Label 16755: @1174179
      GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1174278), // Rule ID 5394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5394,
        GIR_EraseRootFromParent_Done,
      // Label 16756: @1174278
      GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1174377), // Rule ID 5395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5395,
        GIR_EraseRootFromParent_Done,
      // Label 16757: @1174377
      GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1174476), // Rule ID 5396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5396,
        GIR_EraseRootFromParent_Done,
      // Label 16758: @1174476
      GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1174575), // Rule ID 5397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5397,
        GIR_EraseRootFromParent_Done,
      // Label 16759: @1174575
      GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1174674), // Rule ID 5398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5398,
        GIR_EraseRootFromParent_Done,
      // Label 16760: @1174674
      GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1174773), // Rule ID 5399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5399,
        GIR_EraseRootFromParent_Done,
      // Label 16761: @1174773
      GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1174872), // Rule ID 5400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5400,
        GIR_EraseRootFromParent_Done,
      // Label 16762: @1174872
      GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1174971), // Rule ID 5401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5401,
        GIR_EraseRootFromParent_Done,
      // Label 16763: @1174971
      GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1175070), // Rule ID 5402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5402,
        GIR_EraseRootFromParent_Done,
      // Label 16764: @1175070
      GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1175169), // Rule ID 5403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5403,
        GIR_EraseRootFromParent_Done,
      // Label 16765: @1175169
      GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1175268), // Rule ID 5404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5404,
        GIR_EraseRootFromParent_Done,
      // Label 16766: @1175268
      GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1175367), // Rule ID 5405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5405,
        GIR_EraseRootFromParent_Done,
      // Label 16767: @1175367
      GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1175466), // Rule ID 5406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5406,
        GIR_EraseRootFromParent_Done,
      // Label 16768: @1175466
      GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1175565), // Rule ID 5407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5407,
        GIR_EraseRootFromParent_Done,
      // Label 16769: @1175565
      GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1175664), // Rule ID 5408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5408,
        GIR_EraseRootFromParent_Done,
      // Label 16770: @1175664
      GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1175763), // Rule ID 5409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5409,
        GIR_EraseRootFromParent_Done,
      // Label 16771: @1175763
      GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1175862), // Rule ID 5410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5410,
        GIR_EraseRootFromParent_Done,
      // Label 16772: @1175862
      GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1175961), // Rule ID 5411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5411,
        GIR_EraseRootFromParent_Done,
      // Label 16773: @1175961
      GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1176060), // Rule ID 5412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5412,
        GIR_EraseRootFromParent_Done,
      // Label 16774: @1176060
      GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1176159), // Rule ID 5413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5413,
        GIR_EraseRootFromParent_Done,
      // Label 16775: @1176159
      GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1176258), // Rule ID 5414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5414,
        GIR_EraseRootFromParent_Done,
      // Label 16776: @1176258
      GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1176357), // Rule ID 5415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5415,
        GIR_EraseRootFromParent_Done,
      // Label 16777: @1176357
      GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1176456), // Rule ID 5416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5416,
        GIR_EraseRootFromParent_Done,
      // Label 16778: @1176456
      GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1176555), // Rule ID 5417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5417,
        GIR_EraseRootFromParent_Done,
      // Label 16779: @1176555
      GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1176654), // Rule ID 5418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5418,
        GIR_EraseRootFromParent_Done,
      // Label 16780: @1176654
      GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1176753), // Rule ID 5419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5419,
        GIR_EraseRootFromParent_Done,
      // Label 16781: @1176753
      GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1176852), // Rule ID 5420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5420,
        GIR_EraseRootFromParent_Done,
      // Label 16782: @1176852
      GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1176951), // Rule ID 5421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5421,
        GIR_EraseRootFromParent_Done,
      // Label 16783: @1176951
      GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1177050), // Rule ID 5422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5422,
        GIR_EraseRootFromParent_Done,
      // Label 16784: @1177050
      GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1177149), // Rule ID 5423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5423,
        GIR_EraseRootFromParent_Done,
      // Label 16785: @1177149
      GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1177248), // Rule ID 5424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5424,
        GIR_EraseRootFromParent_Done,
      // Label 16786: @1177248
      GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1177347), // Rule ID 5425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5425,
        GIR_EraseRootFromParent_Done,
      // Label 16787: @1177347
      GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1177446), // Rule ID 5426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5426,
        GIR_EraseRootFromParent_Done,
      // Label 16788: @1177446
      GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1177545), // Rule ID 5427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5427,
        GIR_EraseRootFromParent_Done,
      // Label 16789: @1177545
      GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1177644), // Rule ID 5428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5428,
        GIR_EraseRootFromParent_Done,
      // Label 16790: @1177644
      GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1177743), // Rule ID 5429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5429,
        GIR_EraseRootFromParent_Done,
      // Label 16791: @1177743
      GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1177842), // Rule ID 5430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5430,
        GIR_EraseRootFromParent_Done,
      // Label 16792: @1177842
      GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1177941), // Rule ID 5431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5431,
        GIR_EraseRootFromParent_Done,
      // Label 16793: @1177941
      GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1178040), // Rule ID 5432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5432,
        GIR_EraseRootFromParent_Done,
      // Label 16794: @1178040
      GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1178139), // Rule ID 5433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5433,
        GIR_EraseRootFromParent_Done,
      // Label 16795: @1178139
      GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1178238), // Rule ID 5434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5434,
        GIR_EraseRootFromParent_Done,
      // Label 16796: @1178238
      GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1178337), // Rule ID 5435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5435,
        GIR_EraseRootFromParent_Done,
      // Label 16797: @1178337
      GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1178436), // Rule ID 5436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5436,
        GIR_EraseRootFromParent_Done,
      // Label 16798: @1178436
      GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1178535), // Rule ID 5437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5437,
        GIR_EraseRootFromParent_Done,
      // Label 16799: @1178535
      GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1178634), // Rule ID 5438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5438,
        GIR_EraseRootFromParent_Done,
      // Label 16800: @1178634
      GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1178733), // Rule ID 5439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5439,
        GIR_EraseRootFromParent_Done,
      // Label 16801: @1178733
      GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1178832), // Rule ID 5440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5440,
        GIR_EraseRootFromParent_Done,
      // Label 16802: @1178832
      GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1178931), // Rule ID 5441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5441,
        GIR_EraseRootFromParent_Done,
      // Label 16803: @1178931
      GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1179030), // Rule ID 5442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5442,
        GIR_EraseRootFromParent_Done,
      // Label 16804: @1179030
      GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1179129), // Rule ID 5443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5443,
        GIR_EraseRootFromParent_Done,
      // Label 16805: @1179129
      GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1179228), // Rule ID 5444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5444,
        GIR_EraseRootFromParent_Done,
      // Label 16806: @1179228
      GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1179327), // Rule ID 5445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5445,
        GIR_EraseRootFromParent_Done,
      // Label 16807: @1179327
      GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1179426), // Rule ID 7656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7656,
        GIR_EraseRootFromParent_Done,
      // Label 16808: @1179426
      GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1179525), // Rule ID 7657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7657,
        GIR_EraseRootFromParent_Done,
      // Label 16809: @1179525
      GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1179624), // Rule ID 7660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7660,
        GIR_EraseRootFromParent_Done,
      // Label 16810: @1179624
      GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1179723), // Rule ID 7661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7661,
        GIR_EraseRootFromParent_Done,
      // Label 16811: @1179723
      GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1179822), // Rule ID 7664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7664,
        GIR_EraseRootFromParent_Done,
      // Label 16812: @1179822
      GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1179921), // Rule ID 7665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7665,
        GIR_EraseRootFromParent_Done,
      // Label 16813: @1179921
      GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1180020), // Rule ID 7668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7668,
        GIR_EraseRootFromParent_Done,
      // Label 16814: @1180020
      GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1180119), // Rule ID 7669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7669,
        GIR_EraseRootFromParent_Done,
      // Label 16815: @1180119
      GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1180218), // Rule ID 7672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7672,
        GIR_EraseRootFromParent_Done,
      // Label 16816: @1180218
      GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1180317), // Rule ID 7673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7673,
        GIR_EraseRootFromParent_Done,
      // Label 16817: @1180317
      GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1180416), // Rule ID 7676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7676,
        GIR_EraseRootFromParent_Done,
      // Label 16818: @1180416
      GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1180515), // Rule ID 7677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7677,
        GIR_EraseRootFromParent_Done,
      // Label 16819: @1180515
      GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1180614), // Rule ID 7680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7680,
        GIR_EraseRootFromParent_Done,
      // Label 16820: @1180614
      GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1180713), // Rule ID 7681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7681,
        GIR_EraseRootFromParent_Done,
      // Label 16821: @1180713
      GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1180812), // Rule ID 7684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7684,
        GIR_EraseRootFromParent_Done,
      // Label 16822: @1180812
      GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1180911), // Rule ID 7685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7685,
        GIR_EraseRootFromParent_Done,
      // Label 16823: @1180911
      GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1181010), // Rule ID 7688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7688,
        GIR_EraseRootFromParent_Done,
      // Label 16824: @1181010
      GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1181109), // Rule ID 7689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7689,
        GIR_EraseRootFromParent_Done,
      // Label 16825: @1181109
      GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1181208), // Rule ID 7692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7692,
        GIR_EraseRootFromParent_Done,
      // Label 16826: @1181208
      GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1181307), // Rule ID 7693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7693,
        GIR_EraseRootFromParent_Done,
      // Label 16827: @1181307
      GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1181406), // Rule ID 7696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7696,
        GIR_EraseRootFromParent_Done,
      // Label 16828: @1181406
      GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1181505), // Rule ID 7697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7697,
        GIR_EraseRootFromParent_Done,
      // Label 16829: @1181505
      GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1181604), // Rule ID 7700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7700,
        GIR_EraseRootFromParent_Done,
      // Label 16830: @1181604
      GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1181703), // Rule ID 7701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7701,
        GIR_EraseRootFromParent_Done,
      // Label 16831: @1181703
      GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1181802), // Rule ID 7704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7704,
        GIR_EraseRootFromParent_Done,
      // Label 16832: @1181802
      GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1181901), // Rule ID 7705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7705,
        GIR_EraseRootFromParent_Done,
      // Label 16833: @1181901
      GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1182000), // Rule ID 7708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7708,
        GIR_EraseRootFromParent_Done,
      // Label 16834: @1182000
      GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1182099), // Rule ID 7709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7709,
        GIR_EraseRootFromParent_Done,
      // Label 16835: @1182099
      GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1182198), // Rule ID 7712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7712,
        GIR_EraseRootFromParent_Done,
      // Label 16836: @1182198
      GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1182297), // Rule ID 7713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7713,
        GIR_EraseRootFromParent_Done,
      // Label 16837: @1182297
      GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1182396), // Rule ID 7716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7716,
        GIR_EraseRootFromParent_Done,
      // Label 16838: @1182396
      GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1182495), // Rule ID 7717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7717,
        GIR_EraseRootFromParent_Done,
      // Label 16839: @1182495
      GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1182594), // Rule ID 7720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7720,
        GIR_EraseRootFromParent_Done,
      // Label 16840: @1182594
      GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1182693), // Rule ID 7721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7721,
        GIR_EraseRootFromParent_Done,
      // Label 16841: @1182693
      GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1182792), // Rule ID 7724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7724,
        GIR_EraseRootFromParent_Done,
      // Label 16842: @1182792
      GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1182891), // Rule ID 7725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7725,
        GIR_EraseRootFromParent_Done,
      // Label 16843: @1182891
      GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1182990), // Rule ID 7728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7728,
        GIR_EraseRootFromParent_Done,
      // Label 16844: @1182990
      GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1183089), // Rule ID 7729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7729,
        GIR_EraseRootFromParent_Done,
      // Label 16845: @1183089
      GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1183188), // Rule ID 7732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7732,
        GIR_EraseRootFromParent_Done,
      // Label 16846: @1183188
      GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1183287), // Rule ID 7733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7733,
        GIR_EraseRootFromParent_Done,
      // Label 16847: @1183287
      GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1183386), // Rule ID 7736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7736,
        GIR_EraseRootFromParent_Done,
      // Label 16848: @1183386
      GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1183485), // Rule ID 7737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7737,
        GIR_EraseRootFromParent_Done,
      // Label 16849: @1183485
      GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1183584), // Rule ID 7740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7740,
        GIR_EraseRootFromParent_Done,
      // Label 16850: @1183584
      GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1183683), // Rule ID 7741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7741,
        GIR_EraseRootFromParent_Done,
      // Label 16851: @1183683
      GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1183782), // Rule ID 7744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7744,
        GIR_EraseRootFromParent_Done,
      // Label 16852: @1183782
      GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1183881), // Rule ID 7745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7745,
        GIR_EraseRootFromParent_Done,
      // Label 16853: @1183881
      GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1183980), // Rule ID 7748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7748,
        GIR_EraseRootFromParent_Done,
      // Label 16854: @1183980
      GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1184079), // Rule ID 7749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7749,
        GIR_EraseRootFromParent_Done,
      // Label 16855: @1184079
      GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1184178), // Rule ID 7752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7752,
        GIR_EraseRootFromParent_Done,
      // Label 16856: @1184178
      GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1184277), // Rule ID 7753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7753,
        GIR_EraseRootFromParent_Done,
      // Label 16857: @1184277
      GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1184376), // Rule ID 7756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7756,
        GIR_EraseRootFromParent_Done,
      // Label 16858: @1184376
      GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1184475), // Rule ID 7757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7757,
        GIR_EraseRootFromParent_Done,
      // Label 16859: @1184475
      GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1184574), // Rule ID 7760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7760,
        GIR_EraseRootFromParent_Done,
      // Label 16860: @1184574
      GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1184673), // Rule ID 7761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7761,
        GIR_EraseRootFromParent_Done,
      // Label 16861: @1184673
      GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1184772), // Rule ID 7764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7764,
        GIR_EraseRootFromParent_Done,
      // Label 16862: @1184772
      GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1184871), // Rule ID 7765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7765,
        GIR_EraseRootFromParent_Done,
      // Label 16863: @1184871
      GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1184970), // Rule ID 7768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7768,
        GIR_EraseRootFromParent_Done,
      // Label 16864: @1184970
      GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1185069), // Rule ID 7769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7769,
        GIR_EraseRootFromParent_Done,
      // Label 16865: @1185069
      GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1185168), // Rule ID 7772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7772,
        GIR_EraseRootFromParent_Done,
      // Label 16866: @1185168
      GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1185267), // Rule ID 7773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7773,
        GIR_EraseRootFromParent_Done,
      // Label 16867: @1185267
      GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1185366), // Rule ID 7776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7776,
        GIR_EraseRootFromParent_Done,
      // Label 16868: @1185366
      GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1185465), // Rule ID 7777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7777,
        GIR_EraseRootFromParent_Done,
      // Label 16869: @1185465
      GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1185564), // Rule ID 7780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7780,
        GIR_EraseRootFromParent_Done,
      // Label 16870: @1185564
      GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1185663), // Rule ID 7781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7781,
        GIR_EraseRootFromParent_Done,
      // Label 16871: @1185663
      GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1185762), // Rule ID 7784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7784,
        GIR_EraseRootFromParent_Done,
      // Label 16872: @1185762
      GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1185861), // Rule ID 7785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7785,
        GIR_EraseRootFromParent_Done,
      // Label 16873: @1185861
      GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1185960), // Rule ID 7788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7788,
        GIR_EraseRootFromParent_Done,
      // Label 16874: @1185960
      GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1186059), // Rule ID 7789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7789,
        GIR_EraseRootFromParent_Done,
      // Label 16875: @1186059
      GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1186158), // Rule ID 7792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7792,
        GIR_EraseRootFromParent_Done,
      // Label 16876: @1186158
      GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1186257), // Rule ID 7793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7793,
        GIR_EraseRootFromParent_Done,
      // Label 16877: @1186257
      GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1186356), // Rule ID 7796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7796,
        GIR_EraseRootFromParent_Done,
      // Label 16878: @1186356
      GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1186455), // Rule ID 7797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7797,
        GIR_EraseRootFromParent_Done,
      // Label 16879: @1186455
      GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1186554), // Rule ID 7800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7800,
        GIR_EraseRootFromParent_Done,
      // Label 16880: @1186554
      GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1186653), // Rule ID 7801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7801,
        GIR_EraseRootFromParent_Done,
      // Label 16881: @1186653
      GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1186752), // Rule ID 7804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7804,
        GIR_EraseRootFromParent_Done,
      // Label 16882: @1186752
      GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1186851), // Rule ID 7805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7805,
        GIR_EraseRootFromParent_Done,
      // Label 16883: @1186851
      GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1186950), // Rule ID 7808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7808,
        GIR_EraseRootFromParent_Done,
      // Label 16884: @1186950
      GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1187049), // Rule ID 7809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7809,
        GIR_EraseRootFromParent_Done,
      // Label 16885: @1187049
      GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1187148), // Rule ID 7812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7812,
        GIR_EraseRootFromParent_Done,
      // Label 16886: @1187148
      GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1187247), // Rule ID 7813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7813,
        GIR_EraseRootFromParent_Done,
      // Label 16887: @1187247
      GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1187346), // Rule ID 7816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7816,
        GIR_EraseRootFromParent_Done,
      // Label 16888: @1187346
      GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1187445), // Rule ID 7817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7817,
        GIR_EraseRootFromParent_Done,
      // Label 16889: @1187445
      GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1187544), // Rule ID 7820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7820,
        GIR_EraseRootFromParent_Done,
      // Label 16890: @1187544
      GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1187643), // Rule ID 7821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7821,
        GIR_EraseRootFromParent_Done,
      // Label 16891: @1187643
      GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1187742), // Rule ID 7824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7824,
        GIR_EraseRootFromParent_Done,
      // Label 16892: @1187742
      GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1187841), // Rule ID 7825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11052:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7825,
        GIR_EraseRootFromParent_Done,
      // Label 16893: @1187841
      GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1187940), // Rule ID 7916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7916,
        GIR_EraseRootFromParent_Done,
      // Label 16894: @1187940
      GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1188039), // Rule ID 7917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7917,
        GIR_EraseRootFromParent_Done,
      // Label 16895: @1188039
      GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1188138), // Rule ID 7920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7920,
        GIR_EraseRootFromParent_Done,
      // Label 16896: @1188138
      GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1188237), // Rule ID 7921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7921,
        GIR_EraseRootFromParent_Done,
      // Label 16897: @1188237
      GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1188336), // Rule ID 7924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7924,
        GIR_EraseRootFromParent_Done,
      // Label 16898: @1188336
      GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1188435), // Rule ID 7925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7925,
        GIR_EraseRootFromParent_Done,
      // Label 16899: @1188435
      GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1188534), // Rule ID 7928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7928,
        GIR_EraseRootFromParent_Done,
      // Label 16900: @1188534
      GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1188633), // Rule ID 7929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7929,
        GIR_EraseRootFromParent_Done,
      // Label 16901: @1188633
      GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1188732), // Rule ID 7932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7932,
        GIR_EraseRootFromParent_Done,
      // Label 16902: @1188732
      GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1188831), // Rule ID 7933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7933,
        GIR_EraseRootFromParent_Done,
      // Label 16903: @1188831
      GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1188930), // Rule ID 7936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7936,
        GIR_EraseRootFromParent_Done,
      // Label 16904: @1188930
      GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1189029), // Rule ID 7937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7937,
        GIR_EraseRootFromParent_Done,
      // Label 16905: @1189029
      GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1189128), // Rule ID 7940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7940,
        GIR_EraseRootFromParent_Done,
      // Label 16906: @1189128
      GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1189227), // Rule ID 7941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7941,
        GIR_EraseRootFromParent_Done,
      // Label 16907: @1189227
      GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1189326), // Rule ID 7944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7944,
        GIR_EraseRootFromParent_Done,
      // Label 16908: @1189326
      GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1189425), // Rule ID 7945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7945,
        GIR_EraseRootFromParent_Done,
      // Label 16909: @1189425
      GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1189524), // Rule ID 7948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7948,
        GIR_EraseRootFromParent_Done,
      // Label 16910: @1189524
      GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1189623), // Rule ID 7949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7949,
        GIR_EraseRootFromParent_Done,
      // Label 16911: @1189623
      GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1189722), // Rule ID 7952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7952,
        GIR_EraseRootFromParent_Done,
      // Label 16912: @1189722
      GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1189821), // Rule ID 7953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7953,
        GIR_EraseRootFromParent_Done,
      // Label 16913: @1189821
      GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1189920), // Rule ID 7956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7956,
        GIR_EraseRootFromParent_Done,
      // Label 16914: @1189920
      GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1190019), // Rule ID 7957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7957,
        GIR_EraseRootFromParent_Done,
      // Label 16915: @1190019
      GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1190118), // Rule ID 7960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7960,
        GIR_EraseRootFromParent_Done,
      // Label 16916: @1190118
      GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1190217), // Rule ID 7961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7961,
        GIR_EraseRootFromParent_Done,
      // Label 16917: @1190217
      GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1190316), // Rule ID 7964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7964,
        GIR_EraseRootFromParent_Done,
      // Label 16918: @1190316
      GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1190415), // Rule ID 7965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7965,
        GIR_EraseRootFromParent_Done,
      // Label 16919: @1190415
      GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1190514), // Rule ID 7968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7968,
        GIR_EraseRootFromParent_Done,
      // Label 16920: @1190514
      GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1190613), // Rule ID 7969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7969,
        GIR_EraseRootFromParent_Done,
      // Label 16921: @1190613
      GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1190712), // Rule ID 7972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7972,
        GIR_EraseRootFromParent_Done,
      // Label 16922: @1190712
      GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1190811), // Rule ID 7973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7973,
        GIR_EraseRootFromParent_Done,
      // Label 16923: @1190811
      GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1190910), // Rule ID 7976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7976,
        GIR_EraseRootFromParent_Done,
      // Label 16924: @1190910
      GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1191009), // Rule ID 7977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7977,
        GIR_EraseRootFromParent_Done,
      // Label 16925: @1191009
      GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1191108), // Rule ID 7980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7980,
        GIR_EraseRootFromParent_Done,
      // Label 16926: @1191108
      GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1191207), // Rule ID 7981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7981,
        GIR_EraseRootFromParent_Done,
      // Label 16927: @1191207
      GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1191306), // Rule ID 7984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7984,
        GIR_EraseRootFromParent_Done,
      // Label 16928: @1191306
      GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1191405), // Rule ID 7985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7985,
        GIR_EraseRootFromParent_Done,
      // Label 16929: @1191405
      GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1191504), // Rule ID 7988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7988,
        GIR_EraseRootFromParent_Done,
      // Label 16930: @1191504
      GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1191603), // Rule ID 7989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7989,
        GIR_EraseRootFromParent_Done,
      // Label 16931: @1191603
      GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1191702), // Rule ID 7992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7992,
        GIR_EraseRootFromParent_Done,
      // Label 16932: @1191702
      GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1191801), // Rule ID 7993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7993,
        GIR_EraseRootFromParent_Done,
      // Label 16933: @1191801
      GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1191900), // Rule ID 7996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7996,
        GIR_EraseRootFromParent_Done,
      // Label 16934: @1191900
      GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1191999), // Rule ID 7997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7997,
        GIR_EraseRootFromParent_Done,
      // Label 16935: @1191999
      GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1192098), // Rule ID 8000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8000,
        GIR_EraseRootFromParent_Done,
      // Label 16936: @1192098
      GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1192197), // Rule ID 8001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8001,
        GIR_EraseRootFromParent_Done,
      // Label 16937: @1192197
      GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1192296), // Rule ID 8004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8004,
        GIR_EraseRootFromParent_Done,
      // Label 16938: @1192296
      GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1192395), // Rule ID 8005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8005,
        GIR_EraseRootFromParent_Done,
      // Label 16939: @1192395
      GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1192494), // Rule ID 8008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8008,
        GIR_EraseRootFromParent_Done,
      // Label 16940: @1192494
      GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1192593), // Rule ID 8009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8009,
        GIR_EraseRootFromParent_Done,
      // Label 16941: @1192593
      GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1192692), // Rule ID 8012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8012,
        GIR_EraseRootFromParent_Done,
      // Label 16942: @1192692
      GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1192791), // Rule ID 8013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8013,
        GIR_EraseRootFromParent_Done,
      // Label 16943: @1192791
      GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1192890), // Rule ID 8016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8016,
        GIR_EraseRootFromParent_Done,
      // Label 16944: @1192890
      GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1192989), // Rule ID 8017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8017,
        GIR_EraseRootFromParent_Done,
      // Label 16945: @1192989
      GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1193088), // Rule ID 8020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8020,
        GIR_EraseRootFromParent_Done,
      // Label 16946: @1193088
      GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1193187), // Rule ID 8021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8021,
        GIR_EraseRootFromParent_Done,
      // Label 16947: @1193187
      GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1193286), // Rule ID 8024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8024,
        GIR_EraseRootFromParent_Done,
      // Label 16948: @1193286
      GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1193385), // Rule ID 8025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8025,
        GIR_EraseRootFromParent_Done,
      // Label 16949: @1193385
      GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1193484), // Rule ID 8028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8028,
        GIR_EraseRootFromParent_Done,
      // Label 16950: @1193484
      GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1193583), // Rule ID 8029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8029,
        GIR_EraseRootFromParent_Done,
      // Label 16951: @1193583
      GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1193682), // Rule ID 8032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8032,
        GIR_EraseRootFromParent_Done,
      // Label 16952: @1193682
      GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1193781), // Rule ID 8033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8033,
        GIR_EraseRootFromParent_Done,
      // Label 16953: @1193781
      GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1193880), // Rule ID 8036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8036,
        GIR_EraseRootFromParent_Done,
      // Label 16954: @1193880
      GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1193979), // Rule ID 8037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8037,
        GIR_EraseRootFromParent_Done,
      // Label 16955: @1193979
      GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1194078), // Rule ID 8040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8040,
        GIR_EraseRootFromParent_Done,
      // Label 16956: @1194078
      GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1194177), // Rule ID 8041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8041,
        GIR_EraseRootFromParent_Done,
      // Label 16957: @1194177
      GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1194276), // Rule ID 8044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8044,
        GIR_EraseRootFromParent_Done,
      // Label 16958: @1194276
      GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1194375), // Rule ID 8045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8045,
        GIR_EraseRootFromParent_Done,
      // Label 16959: @1194375
      GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1194474), // Rule ID 8048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8048,
        GIR_EraseRootFromParent_Done,
      // Label 16960: @1194474
      GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1194573), // Rule ID 8049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8049,
        GIR_EraseRootFromParent_Done,
      // Label 16961: @1194573
      GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1194672), // Rule ID 8052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8052,
        GIR_EraseRootFromParent_Done,
      // Label 16962: @1194672
      GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1194771), // Rule ID 8053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8053,
        GIR_EraseRootFromParent_Done,
      // Label 16963: @1194771
      GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1194870), // Rule ID 8056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8056,
        GIR_EraseRootFromParent_Done,
      // Label 16964: @1194870
      GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1194969), // Rule ID 8057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8057,
        GIR_EraseRootFromParent_Done,
      // Label 16965: @1194969
      GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1195068), // Rule ID 8060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8060,
        GIR_EraseRootFromParent_Done,
      // Label 16966: @1195068
      GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1195167), // Rule ID 8061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8061,
        GIR_EraseRootFromParent_Done,
      // Label 16967: @1195167
      GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1195266), // Rule ID 8064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8064,
        GIR_EraseRootFromParent_Done,
      // Label 16968: @1195266
      GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1195365), // Rule ID 8065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8065,
        GIR_EraseRootFromParent_Done,
      // Label 16969: @1195365
      GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1195464), // Rule ID 8068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8068,
        GIR_EraseRootFromParent_Done,
      // Label 16970: @1195464
      GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1195563), // Rule ID 8069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8069,
        GIR_EraseRootFromParent_Done,
      // Label 16971: @1195563
      GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1195662), // Rule ID 8072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8072,
        GIR_EraseRootFromParent_Done,
      // Label 16972: @1195662
      GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1195761), // Rule ID 8073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8073,
        GIR_EraseRootFromParent_Done,
      // Label 16973: @1195761
      GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1195860), // Rule ID 8076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8076,
        GIR_EraseRootFromParent_Done,
      // Label 16974: @1195860
      GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1195959), // Rule ID 8077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8077,
        GIR_EraseRootFromParent_Done,
      // Label 16975: @1195959
      GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1196058), // Rule ID 8080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8080,
        GIR_EraseRootFromParent_Done,
      // Label 16976: @1196058
      GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1196157), // Rule ID 8081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8081,
        GIR_EraseRootFromParent_Done,
      // Label 16977: @1196157
      GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1196256), // Rule ID 8084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8084,
        GIR_EraseRootFromParent_Done,
      // Label 16978: @1196256
      GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1196355), // Rule ID 8085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8085,
        GIR_EraseRootFromParent_Done,
      // Label 16979: @1196355
      GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1196454), // Rule ID 8088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8088,
        GIR_EraseRootFromParent_Done,
      // Label 16980: @1196454
      GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1196553), // Rule ID 8089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8089,
        GIR_EraseRootFromParent_Done,
      // Label 16981: @1196553
      GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1196652), // Rule ID 8180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8180,
        GIR_EraseRootFromParent_Done,
      // Label 16982: @1196652
      GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1196751), // Rule ID 8181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8181,
        GIR_EraseRootFromParent_Done,
      // Label 16983: @1196751
      GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1196850), // Rule ID 8184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8184,
        GIR_EraseRootFromParent_Done,
      // Label 16984: @1196850
      GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1196949), // Rule ID 8185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8185,
        GIR_EraseRootFromParent_Done,
      // Label 16985: @1196949
      GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1197048), // Rule ID 8188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8188,
        GIR_EraseRootFromParent_Done,
      // Label 16986: @1197048
      GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1197147), // Rule ID 8189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8189,
        GIR_EraseRootFromParent_Done,
      // Label 16987: @1197147
      GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1197246), // Rule ID 8192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8192,
        GIR_EraseRootFromParent_Done,
      // Label 16988: @1197246
      GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1197345), // Rule ID 8193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8193,
        GIR_EraseRootFromParent_Done,
      // Label 16989: @1197345
      GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1197444), // Rule ID 8196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8196,
        GIR_EraseRootFromParent_Done,
      // Label 16990: @1197444
      GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1197543), // Rule ID 8197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8197,
        GIR_EraseRootFromParent_Done,
      // Label 16991: @1197543
      GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1197642), // Rule ID 8200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8200,
        GIR_EraseRootFromParent_Done,
      // Label 16992: @1197642
      GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1197741), // Rule ID 8201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8201,
        GIR_EraseRootFromParent_Done,
      // Label 16993: @1197741
      GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1197840), // Rule ID 8204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8204,
        GIR_EraseRootFromParent_Done,
      // Label 16994: @1197840
      GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1197939), // Rule ID 8205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8205,
        GIR_EraseRootFromParent_Done,
      // Label 16995: @1197939
      GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1198038), // Rule ID 8208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8208,
        GIR_EraseRootFromParent_Done,
      // Label 16996: @1198038
      GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1198137), // Rule ID 8209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8209,
        GIR_EraseRootFromParent_Done,
      // Label 16997: @1198137
      GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1198236), // Rule ID 8212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8212,
        GIR_EraseRootFromParent_Done,
      // Label 16998: @1198236
      GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1198335), // Rule ID 8213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8213,
        GIR_EraseRootFromParent_Done,
      // Label 16999: @1198335
      GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1198434), // Rule ID 8216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8216,
        GIR_EraseRootFromParent_Done,
      // Label 17000: @1198434
      GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1198533), // Rule ID 8217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8217,
        GIR_EraseRootFromParent_Done,
      // Label 17001: @1198533
      GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1198632), // Rule ID 8220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8220,
        GIR_EraseRootFromParent_Done,
      // Label 17002: @1198632
      GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1198731), // Rule ID 8221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8221,
        GIR_EraseRootFromParent_Done,
      // Label 17003: @1198731
      GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1198830), // Rule ID 8224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8224,
        GIR_EraseRootFromParent_Done,
      // Label 17004: @1198830
      GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1198929), // Rule ID 8225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8225,
        GIR_EraseRootFromParent_Done,
      // Label 17005: @1198929
      GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1199028), // Rule ID 8228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8228,
        GIR_EraseRootFromParent_Done,
      // Label 17006: @1199028
      GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1199127), // Rule ID 8229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8229,
        GIR_EraseRootFromParent_Done,
      // Label 17007: @1199127
      GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1199226), // Rule ID 8232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8232,
        GIR_EraseRootFromParent_Done,
      // Label 17008: @1199226
      GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1199325), // Rule ID 8233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8233,
        GIR_EraseRootFromParent_Done,
      // Label 17009: @1199325
      GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1199424), // Rule ID 8236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8236,
        GIR_EraseRootFromParent_Done,
      // Label 17010: @1199424
      GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1199523), // Rule ID 8237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8237,
        GIR_EraseRootFromParent_Done,
      // Label 17011: @1199523
      GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1199622), // Rule ID 8240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8240,
        GIR_EraseRootFromParent_Done,
      // Label 17012: @1199622
      GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1199721), // Rule ID 8241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8241,
        GIR_EraseRootFromParent_Done,
      // Label 17013: @1199721
      GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1199820), // Rule ID 8244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8244,
        GIR_EraseRootFromParent_Done,
      // Label 17014: @1199820
      GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1199919), // Rule ID 8245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8245,
        GIR_EraseRootFromParent_Done,
      // Label 17015: @1199919
      GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1200018), // Rule ID 8248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8248,
        GIR_EraseRootFromParent_Done,
      // Label 17016: @1200018
      GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1200117), // Rule ID 8249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8249,
        GIR_EraseRootFromParent_Done,
      // Label 17017: @1200117
      GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1200216), // Rule ID 8252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8252,
        GIR_EraseRootFromParent_Done,
      // Label 17018: @1200216
      GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1200315), // Rule ID 8253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8253,
        GIR_EraseRootFromParent_Done,
      // Label 17019: @1200315
      GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1200414), // Rule ID 8256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8256,
        GIR_EraseRootFromParent_Done,
      // Label 17020: @1200414
      GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1200513), // Rule ID 8257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8257,
        GIR_EraseRootFromParent_Done,
      // Label 17021: @1200513
      GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1200612), // Rule ID 8260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8260,
        GIR_EraseRootFromParent_Done,
      // Label 17022: @1200612
      GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1200711), // Rule ID 8261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8261,
        GIR_EraseRootFromParent_Done,
      // Label 17023: @1200711
      GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1200810), // Rule ID 8264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8264,
        GIR_EraseRootFromParent_Done,
      // Label 17024: @1200810
      GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1200909), // Rule ID 8265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8265,
        GIR_EraseRootFromParent_Done,
      // Label 17025: @1200909
      GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1201008), // Rule ID 8268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8268,
        GIR_EraseRootFromParent_Done,
      // Label 17026: @1201008
      GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1201107), // Rule ID 8269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8269,
        GIR_EraseRootFromParent_Done,
      // Label 17027: @1201107
      GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1201206), // Rule ID 8272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8272,
        GIR_EraseRootFromParent_Done,
      // Label 17028: @1201206
      GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1201305), // Rule ID 8273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8273,
        GIR_EraseRootFromParent_Done,
      // Label 17029: @1201305
      GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1201404), // Rule ID 8276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8276,
        GIR_EraseRootFromParent_Done,
      // Label 17030: @1201404
      GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1201503), // Rule ID 8277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8277,
        GIR_EraseRootFromParent_Done,
      // Label 17031: @1201503
      GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1201602), // Rule ID 8280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8280,
        GIR_EraseRootFromParent_Done,
      // Label 17032: @1201602
      GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1201701), // Rule ID 8281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8281,
        GIR_EraseRootFromParent_Done,
      // Label 17033: @1201701
      GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1201800), // Rule ID 8284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8284,
        GIR_EraseRootFromParent_Done,
      // Label 17034: @1201800
      GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1201899), // Rule ID 8285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8285,
        GIR_EraseRootFromParent_Done,
      // Label 17035: @1201899
      GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1201998), // Rule ID 8288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8288,
        GIR_EraseRootFromParent_Done,
      // Label 17036: @1201998
      GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1202097), // Rule ID 8289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8289,
        GIR_EraseRootFromParent_Done,
      // Label 17037: @1202097
      GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1202196), // Rule ID 8292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8292,
        GIR_EraseRootFromParent_Done,
      // Label 17038: @1202196
      GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1202295), // Rule ID 8293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8293,
        GIR_EraseRootFromParent_Done,
      // Label 17039: @1202295
      GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1202394), // Rule ID 8296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8296,
        GIR_EraseRootFromParent_Done,
      // Label 17040: @1202394
      GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1202493), // Rule ID 8297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8297,
        GIR_EraseRootFromParent_Done,
      // Label 17041: @1202493
      GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1202592), // Rule ID 8300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8300,
        GIR_EraseRootFromParent_Done,
      // Label 17042: @1202592
      GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1202691), // Rule ID 8301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8301,
        GIR_EraseRootFromParent_Done,
      // Label 17043: @1202691
      GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1202790), // Rule ID 8304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8304,
        GIR_EraseRootFromParent_Done,
      // Label 17044: @1202790
      GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1202889), // Rule ID 8305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8305,
        GIR_EraseRootFromParent_Done,
      // Label 17045: @1202889
      GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1202988), // Rule ID 8308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8308,
        GIR_EraseRootFromParent_Done,
      // Label 17046: @1202988
      GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1203087), // Rule ID 8309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8309,
        GIR_EraseRootFromParent_Done,
      // Label 17047: @1203087
      GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1203186), // Rule ID 8312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8312,
        GIR_EraseRootFromParent_Done,
      // Label 17048: @1203186
      GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1203285), // Rule ID 8313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8313,
        GIR_EraseRootFromParent_Done,
      // Label 17049: @1203285
      GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1203384), // Rule ID 8316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8316,
        GIR_EraseRootFromParent_Done,
      // Label 17050: @1203384
      GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1203483), // Rule ID 8317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8317,
        GIR_EraseRootFromParent_Done,
      // Label 17051: @1203483
      GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1203582), // Rule ID 8320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8320,
        GIR_EraseRootFromParent_Done,
      // Label 17052: @1203582
      GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1203681), // Rule ID 8321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8321,
        GIR_EraseRootFromParent_Done,
      // Label 17053: @1203681
      GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1203780), // Rule ID 8324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8324,
        GIR_EraseRootFromParent_Done,
      // Label 17054: @1203780
      GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1203879), // Rule ID 8325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8325,
        GIR_EraseRootFromParent_Done,
      // Label 17055: @1203879
      GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1203978), // Rule ID 8328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8328,
        GIR_EraseRootFromParent_Done,
      // Label 17056: @1203978
      GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1204077), // Rule ID 8329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8329,
        GIR_EraseRootFromParent_Done,
      // Label 17057: @1204077
      GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1204176), // Rule ID 8332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8332,
        GIR_EraseRootFromParent_Done,
      // Label 17058: @1204176
      GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1204275), // Rule ID 8333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8333,
        GIR_EraseRootFromParent_Done,
      // Label 17059: @1204275
      GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1204374), // Rule ID 8336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8336,
        GIR_EraseRootFromParent_Done,
      // Label 17060: @1204374
      GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1204473), // Rule ID 8337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8337,
        GIR_EraseRootFromParent_Done,
      // Label 17061: @1204473
      GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1204572), // Rule ID 8340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8340,
        GIR_EraseRootFromParent_Done,
      // Label 17062: @1204572
      GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1204671), // Rule ID 8341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8341,
        GIR_EraseRootFromParent_Done,
      // Label 17063: @1204671
      GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1204770), // Rule ID 8344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8344,
        GIR_EraseRootFromParent_Done,
      // Label 17064: @1204770
      GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1204869), // Rule ID 8345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8345,
        GIR_EraseRootFromParent_Done,
      // Label 17065: @1204869
      GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1204968), // Rule ID 8348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8348,
        GIR_EraseRootFromParent_Done,
      // Label 17066: @1204968
      GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1205067), // Rule ID 8349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8349,
        GIR_EraseRootFromParent_Done,
      // Label 17067: @1205067
      GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1205166), // Rule ID 8352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8352,
        GIR_EraseRootFromParent_Done,
      // Label 17068: @1205166
      GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1205265), // Rule ID 8353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8353,
        GIR_EraseRootFromParent_Done,
      // Label 17069: @1205265
      GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1205364), // Rule ID 8356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8356,
        GIR_EraseRootFromParent_Done,
      // Label 17070: @1205364
      GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1205463), // Rule ID 8357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8357,
        GIR_EraseRootFromParent_Done,
      // Label 17071: @1205463
      GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1205562), // Rule ID 8360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8360,
        GIR_EraseRootFromParent_Done,
      // Label 17072: @1205562
      GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1205661), // Rule ID 8361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8361,
        GIR_EraseRootFromParent_Done,
      // Label 17073: @1205661
      GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1205760), // Rule ID 8364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8364,
        GIR_EraseRootFromParent_Done,
      // Label 17074: @1205760
      GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1205859), // Rule ID 8365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8365,
        GIR_EraseRootFromParent_Done,
      // Label 17075: @1205859
      GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1205958), // Rule ID 8368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8368,
        GIR_EraseRootFromParent_Done,
      // Label 17076: @1205958
      GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1206057), // Rule ID 8369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8369,
        GIR_EraseRootFromParent_Done,
      // Label 17077: @1206057
      GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1206156), // Rule ID 8372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8372,
        GIR_EraseRootFromParent_Done,
      // Label 17078: @1206156
      GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1206255), // Rule ID 8373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8373,
        GIR_EraseRootFromParent_Done,
      // Label 17079: @1206255
      GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1206354), // Rule ID 8376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8376,
        GIR_EraseRootFromParent_Done,
      // Label 17080: @1206354
      GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1206453), // Rule ID 8377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8377,
        GIR_EraseRootFromParent_Done,
      // Label 17081: @1206453
      GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1206552), // Rule ID 8380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8380,
        GIR_EraseRootFromParent_Done,
      // Label 17082: @1206552
      GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1206651), // Rule ID 8381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8381,
        GIR_EraseRootFromParent_Done,
      // Label 17083: @1206651
      GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1206750), // Rule ID 8384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8384,
        GIR_EraseRootFromParent_Done,
      // Label 17084: @1206750
      GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1206849), // Rule ID 8385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8385,
        GIR_EraseRootFromParent_Done,
      // Label 17085: @1206849
      GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1206948), // Rule ID 8388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8388,
        GIR_EraseRootFromParent_Done,
      // Label 17086: @1206948
      GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1207047), // Rule ID 8389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8389,
        GIR_EraseRootFromParent_Done,
      // Label 17087: @1207047
      GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1207146), // Rule ID 8392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8392,
        GIR_EraseRootFromParent_Done,
      // Label 17088: @1207146
      GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1207245), // Rule ID 8393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8393,
        GIR_EraseRootFromParent_Done,
      // Label 17089: @1207245
      GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1207344), // Rule ID 8396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8396,
        GIR_EraseRootFromParent_Done,
      // Label 17090: @1207344
      GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1207443), // Rule ID 8397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8397,
        GIR_EraseRootFromParent_Done,
      // Label 17091: @1207443
      GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1207542), // Rule ID 8400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8400,
        GIR_EraseRootFromParent_Done,
      // Label 17092: @1207542
      GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1207641), // Rule ID 8401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8401,
        GIR_EraseRootFromParent_Done,
      // Label 17093: @1207641
      GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1207740), // Rule ID 8404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8404,
        GIR_EraseRootFromParent_Done,
      // Label 17094: @1207740
      GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1207839), // Rule ID 8405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8405,
        GIR_EraseRootFromParent_Done,
      // Label 17095: @1207839
      GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1207938), // Rule ID 8408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8408,
        GIR_EraseRootFromParent_Done,
      // Label 17096: @1207938
      GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1208037), // Rule ID 8409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8409,
        GIR_EraseRootFromParent_Done,
      // Label 17097: @1208037
      GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1208136), // Rule ID 8412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8412,
        GIR_EraseRootFromParent_Done,
      // Label 17098: @1208136
      GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1208235), // Rule ID 8413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8413,
        GIR_EraseRootFromParent_Done,
      // Label 17099: @1208235
      GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1208334), // Rule ID 8416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8416,
        GIR_EraseRootFromParent_Done,
      // Label 17100: @1208334
      GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1208433), // Rule ID 8417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8417,
        GIR_EraseRootFromParent_Done,
      // Label 17101: @1208433
      GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1208532), // Rule ID 8420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8420,
        GIR_EraseRootFromParent_Done,
      // Label 17102: @1208532
      GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1208631), // Rule ID 8421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8421,
        GIR_EraseRootFromParent_Done,
      // Label 17103: @1208631
      GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1208730), // Rule ID 8424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8424,
        GIR_EraseRootFromParent_Done,
      // Label 17104: @1208730
      GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1208829), // Rule ID 8425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8425,
        GIR_EraseRootFromParent_Done,
      // Label 17105: @1208829
      GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1208928), // Rule ID 8428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8428,
        GIR_EraseRootFromParent_Done,
      // Label 17106: @1208928
      GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1209027), // Rule ID 8429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8429,
        GIR_EraseRootFromParent_Done,
      // Label 17107: @1209027
      GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1209126), // Rule ID 8432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8432,
        GIR_EraseRootFromParent_Done,
      // Label 17108: @1209126
      GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1209225), // Rule ID 8433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8433,
        GIR_EraseRootFromParent_Done,
      // Label 17109: @1209225
      GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1209324), // Rule ID 8436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8436,
        GIR_EraseRootFromParent_Done,
      // Label 17110: @1209324
      GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1209423), // Rule ID 8437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8437,
        GIR_EraseRootFromParent_Done,
      // Label 17111: @1209423
      GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1209522), // Rule ID 8440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8440,
        GIR_EraseRootFromParent_Done,
      // Label 17112: @1209522
      GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1209621), // Rule ID 8441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8441,
        GIR_EraseRootFromParent_Done,
      // Label 17113: @1209621
      GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1209720), // Rule ID 8444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8444,
        GIR_EraseRootFromParent_Done,
      // Label 17114: @1209720
      GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1209819), // Rule ID 8445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8445,
        GIR_EraseRootFromParent_Done,
      // Label 17115: @1209819
      GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1209918), // Rule ID 8448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8448,
        GIR_EraseRootFromParent_Done,
      // Label 17116: @1209918
      GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1210017), // Rule ID 8449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8449,
        GIR_EraseRootFromParent_Done,
      // Label 17117: @1210017
      GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1210116), // Rule ID 8452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8452,
        GIR_EraseRootFromParent_Done,
      // Label 17118: @1210116
      GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1210215), // Rule ID 8453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8453,
        GIR_EraseRootFromParent_Done,
      // Label 17119: @1210215
      GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1210314), // Rule ID 8456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8456,
        GIR_EraseRootFromParent_Done,
      // Label 17120: @1210314
      GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1210413), // Rule ID 8457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8457,
        GIR_EraseRootFromParent_Done,
      // Label 17121: @1210413
      GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1210512), // Rule ID 8460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8460,
        GIR_EraseRootFromParent_Done,
      // Label 17122: @1210512
      GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1210611), // Rule ID 8461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8461,
        GIR_EraseRootFromParent_Done,
      // Label 17123: @1210611
      GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1210710), // Rule ID 8464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8464,
        GIR_EraseRootFromParent_Done,
      // Label 17124: @1210710
      GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1210809), // Rule ID 8465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8465,
        GIR_EraseRootFromParent_Done,
      // Label 17125: @1210809
      GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1210908), // Rule ID 8468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8468,
        GIR_EraseRootFromParent_Done,
      // Label 17126: @1210908
      GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1211007), // Rule ID 8469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8469,
        GIR_EraseRootFromParent_Done,
      // Label 17127: @1211007
      GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1211106), // Rule ID 8472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8472,
        GIR_EraseRootFromParent_Done,
      // Label 17128: @1211106
      GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1211205), // Rule ID 8473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8473,
        GIR_EraseRootFromParent_Done,
      // Label 17129: @1211205
      GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1211304), // Rule ID 8476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8476,
        GIR_EraseRootFromParent_Done,
      // Label 17130: @1211304
      GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1211403), // Rule ID 8477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8477,
        GIR_EraseRootFromParent_Done,
      // Label 17131: @1211403
      GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1211502), // Rule ID 8480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8480,
        GIR_EraseRootFromParent_Done,
      // Label 17132: @1211502
      GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1211601), // Rule ID 8481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8481,
        GIR_EraseRootFromParent_Done,
      // Label 17133: @1211601
      GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1211700), // Rule ID 8484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8484,
        GIR_EraseRootFromParent_Done,
      // Label 17134: @1211700
      GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1211799), // Rule ID 8485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8485,
        GIR_EraseRootFromParent_Done,
      // Label 17135: @1211799
      GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1211898), // Rule ID 8488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8488,
        GIR_EraseRootFromParent_Done,
      // Label 17136: @1211898
      GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1211997), // Rule ID 8489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8489,
        GIR_EraseRootFromParent_Done,
      // Label 17137: @1211997
      GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1212096), // Rule ID 8492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8492,
        GIR_EraseRootFromParent_Done,
      // Label 17138: @1212096
      GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1212195), // Rule ID 8493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8493,
        GIR_EraseRootFromParent_Done,
      // Label 17139: @1212195
      GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1212294), // Rule ID 8496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8496,
        GIR_EraseRootFromParent_Done,
      // Label 17140: @1212294
      GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1212393), // Rule ID 8497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8497,
        GIR_EraseRootFromParent_Done,
      // Label 17141: @1212393
      GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1212492), // Rule ID 8500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8500,
        GIR_EraseRootFromParent_Done,
      // Label 17142: @1212492
      GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1212591), // Rule ID 8501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8501,
        GIR_EraseRootFromParent_Done,
      // Label 17143: @1212591
      GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1212690), // Rule ID 8504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8504,
        GIR_EraseRootFromParent_Done,
      // Label 17144: @1212690
      GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1212789), // Rule ID 8505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8505,
        GIR_EraseRootFromParent_Done,
      // Label 17145: @1212789
      GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1212888), // Rule ID 8508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8508,
        GIR_EraseRootFromParent_Done,
      // Label 17146: @1212888
      GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1212987), // Rule ID 8509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8509,
        GIR_EraseRootFromParent_Done,
      // Label 17147: @1212987
      GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1213086), // Rule ID 8512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8512,
        GIR_EraseRootFromParent_Done,
      // Label 17148: @1213086
      GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1213185), // Rule ID 8513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8513,
        GIR_EraseRootFromParent_Done,
      // Label 17149: @1213185
      GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1213284), // Rule ID 8516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8516,
        GIR_EraseRootFromParent_Done,
      // Label 17150: @1213284
      GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1213383), // Rule ID 8517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8517,
        GIR_EraseRootFromParent_Done,
      // Label 17151: @1213383
      GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1213482), // Rule ID 8520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8520,
        GIR_EraseRootFromParent_Done,
      // Label 17152: @1213482
      GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1213581), // Rule ID 8521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8521,
        GIR_EraseRootFromParent_Done,
      // Label 17153: @1213581
      GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1213680), // Rule ID 8524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8524,
        GIR_EraseRootFromParent_Done,
      // Label 17154: @1213680
      GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1213779), // Rule ID 8525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8525,
        GIR_EraseRootFromParent_Done,
      // Label 17155: @1213779
      GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1213878), // Rule ID 8528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8528,
        GIR_EraseRootFromParent_Done,
      // Label 17156: @1213878
      GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1213977), // Rule ID 8529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8529,
        GIR_EraseRootFromParent_Done,
      // Label 17157: @1213977
      GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1214076), // Rule ID 8532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8532,
        GIR_EraseRootFromParent_Done,
      // Label 17158: @1214076
      GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1214175), // Rule ID 8533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8533,
        GIR_EraseRootFromParent_Done,
      // Label 17159: @1214175
      GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1214274), // Rule ID 8536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8536,
        GIR_EraseRootFromParent_Done,
      // Label 17160: @1214274
      GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1214373), // Rule ID 8537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8537,
        GIR_EraseRootFromParent_Done,
      // Label 17161: @1214373
      GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1214472), // Rule ID 8540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8540,
        GIR_EraseRootFromParent_Done,
      // Label 17162: @1214472
      GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1214571), // Rule ID 8541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8541,
        GIR_EraseRootFromParent_Done,
      // Label 17163: @1214571
      GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1214670), // Rule ID 8544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8544,
        GIR_EraseRootFromParent_Done,
      // Label 17164: @1214670
      GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1214769), // Rule ID 8545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8545,
        GIR_EraseRootFromParent_Done,
      // Label 17165: @1214769
      GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1214868), // Rule ID 8548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8548,
        GIR_EraseRootFromParent_Done,
      // Label 17166: @1214868
      GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1214967), // Rule ID 8549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8549,
        GIR_EraseRootFromParent_Done,
      // Label 17167: @1214967
      GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1215066), // Rule ID 8552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8552,
        GIR_EraseRootFromParent_Done,
      // Label 17168: @1215066
      GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1215165), // Rule ID 8553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8553,
        GIR_EraseRootFromParent_Done,
      // Label 17169: @1215165
      GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1215264), // Rule ID 8556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8556,
        GIR_EraseRootFromParent_Done,
      // Label 17170: @1215264
      GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1215363), // Rule ID 8557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8557,
        GIR_EraseRootFromParent_Done,
      // Label 17171: @1215363
      GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1215462), // Rule ID 8560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8560,
        GIR_EraseRootFromParent_Done,
      // Label 17172: @1215462
      GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1215561), // Rule ID 8561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8561,
        GIR_EraseRootFromParent_Done,
      // Label 17173: @1215561
      GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1215660), // Rule ID 8564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8564,
        GIR_EraseRootFromParent_Done,
      // Label 17174: @1215660
      GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1215759), // Rule ID 8565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8565,
        GIR_EraseRootFromParent_Done,
      // Label 17175: @1215759
      GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1215858), // Rule ID 8568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8568,
        GIR_EraseRootFromParent_Done,
      // Label 17176: @1215858
      GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1215957), // Rule ID 8569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8569,
        GIR_EraseRootFromParent_Done,
      // Label 17177: @1215957
      GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1216056), // Rule ID 8572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8572,
        GIR_EraseRootFromParent_Done,
      // Label 17178: @1216056
      GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1216155), // Rule ID 8573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8573,
        GIR_EraseRootFromParent_Done,
      // Label 17179: @1216155
      GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1216254), // Rule ID 8576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8576,
        GIR_EraseRootFromParent_Done,
      // Label 17180: @1216254
      GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1216353), // Rule ID 8577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8577,
        GIR_EraseRootFromParent_Done,
      // Label 17181: @1216353
      GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1216452), // Rule ID 8580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8580,
        GIR_EraseRootFromParent_Done,
      // Label 17182: @1216452
      GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1216551), // Rule ID 8581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8581,
        GIR_EraseRootFromParent_Done,
      // Label 17183: @1216551
      GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1216650), // Rule ID 8584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8584,
        GIR_EraseRootFromParent_Done,
      // Label 17184: @1216650
      GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1216749), // Rule ID 8585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8585,
        GIR_EraseRootFromParent_Done,
      // Label 17185: @1216749
      GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1216848), // Rule ID 8588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8588,
        GIR_EraseRootFromParent_Done,
      // Label 17186: @1216848
      GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1216947), // Rule ID 8589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8589,
        GIR_EraseRootFromParent_Done,
      // Label 17187: @1216947
      GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1217046), // Rule ID 8592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8592,
        GIR_EraseRootFromParent_Done,
      // Label 17188: @1217046
      GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1217145), // Rule ID 8593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8593,
        GIR_EraseRootFromParent_Done,
      // Label 17189: @1217145
      GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1217244), // Rule ID 8596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8596,
        GIR_EraseRootFromParent_Done,
      // Label 17190: @1217244
      GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1217343), // Rule ID 8597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8597,
        GIR_EraseRootFromParent_Done,
      // Label 17191: @1217343
      GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1217442), // Rule ID 8600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8600,
        GIR_EraseRootFromParent_Done,
      // Label 17192: @1217442
      GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1217541), // Rule ID 8601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8601,
        GIR_EraseRootFromParent_Done,
      // Label 17193: @1217541
      GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1217640), // Rule ID 8604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8604,
        GIR_EraseRootFromParent_Done,
      // Label 17194: @1217640
      GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1217739), // Rule ID 8605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8605,
        GIR_EraseRootFromParent_Done,
      // Label 17195: @1217739
      GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1217838), // Rule ID 8608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8608,
        GIR_EraseRootFromParent_Done,
      // Label 17196: @1217838
      GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1217937), // Rule ID 8609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8609,
        GIR_EraseRootFromParent_Done,
      // Label 17197: @1217937
      GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1218036), // Rule ID 8612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8612,
        GIR_EraseRootFromParent_Done,
      // Label 17198: @1218036
      GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1218135), // Rule ID 8613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8613,
        GIR_EraseRootFromParent_Done,
      // Label 17199: @1218135
      GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1218234), // Rule ID 8616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8616,
        GIR_EraseRootFromParent_Done,
      // Label 17200: @1218234
      GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1218333), // Rule ID 8617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8617,
        GIR_EraseRootFromParent_Done,
      // Label 17201: @1218333
      GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1218432), // Rule ID 8620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8620,
        GIR_EraseRootFromParent_Done,
      // Label 17202: @1218432
      GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1218531), // Rule ID 8621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8621,
        GIR_EraseRootFromParent_Done,
      // Label 17203: @1218531
      GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1218630), // Rule ID 8624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8624,
        GIR_EraseRootFromParent_Done,
      // Label 17204: @1218630
      GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1218729), // Rule ID 8625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8625,
        GIR_EraseRootFromParent_Done,
      // Label 17205: @1218729
      GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1218828), // Rule ID 8628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8628,
        GIR_EraseRootFromParent_Done,
      // Label 17206: @1218828
      GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1218927), // Rule ID 8629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8629,
        GIR_EraseRootFromParent_Done,
      // Label 17207: @1218927
      GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1219026), // Rule ID 8632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8632,
        GIR_EraseRootFromParent_Done,
      // Label 17208: @1219026
      GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1219125), // Rule ID 8633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8633,
        GIR_EraseRootFromParent_Done,
      // Label 17209: @1219125
      GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1219224), // Rule ID 8636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8636,
        GIR_EraseRootFromParent_Done,
      // Label 17210: @1219224
      GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1219323), // Rule ID 8637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8637,
        GIR_EraseRootFromParent_Done,
      // Label 17211: @1219323
      GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1219422), // Rule ID 8640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8640,
        GIR_EraseRootFromParent_Done,
      // Label 17212: @1219422
      GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1219521), // Rule ID 8641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8641,
        GIR_EraseRootFromParent_Done,
      // Label 17213: @1219521
      GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1219620), // Rule ID 8644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8644,
        GIR_EraseRootFromParent_Done,
      // Label 17214: @1219620
      GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1219719), // Rule ID 8645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8645,
        GIR_EraseRootFromParent_Done,
      // Label 17215: @1219719
      GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1219818), // Rule ID 8648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8648,
        GIR_EraseRootFromParent_Done,
      // Label 17216: @1219818
      GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1219917), // Rule ID 8649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8649,
        GIR_EraseRootFromParent_Done,
      // Label 17217: @1219917
      GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1220016), // Rule ID 8652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8652,
        GIR_EraseRootFromParent_Done,
      // Label 17218: @1220016
      GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1220115), // Rule ID 8653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8653,
        GIR_EraseRootFromParent_Done,
      // Label 17219: @1220115
      GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1220214), // Rule ID 8656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8656,
        GIR_EraseRootFromParent_Done,
      // Label 17220: @1220214
      GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1220313), // Rule ID 8657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8657,
        GIR_EraseRootFromParent_Done,
      // Label 17221: @1220313
      GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1220412), // Rule ID 8660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8660,
        GIR_EraseRootFromParent_Done,
      // Label 17222: @1220412
      GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1220511), // Rule ID 8661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8661,
        GIR_EraseRootFromParent_Done,
      // Label 17223: @1220511
      GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1220610), // Rule ID 8664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8664,
        GIR_EraseRootFromParent_Done,
      // Label 17224: @1220610
      GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1220709), // Rule ID 8665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8665,
        GIR_EraseRootFromParent_Done,
      // Label 17225: @1220709
      GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1220808), // Rule ID 8668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8668,
        GIR_EraseRootFromParent_Done,
      // Label 17226: @1220808
      GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1220907), // Rule ID 8669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8669,
        GIR_EraseRootFromParent_Done,
      // Label 17227: @1220907
      GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1221006), // Rule ID 8672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8672,
        GIR_EraseRootFromParent_Done,
      // Label 17228: @1221006
      GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1221105), // Rule ID 8673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8673,
        GIR_EraseRootFromParent_Done,
      // Label 17229: @1221105
      GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1221204), // Rule ID 8676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8676,
        GIR_EraseRootFromParent_Done,
      // Label 17230: @1221204
      GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1221303), // Rule ID 8677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8677,
        GIR_EraseRootFromParent_Done,
      // Label 17231: @1221303
      GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1221402), // Rule ID 8680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8680,
        GIR_EraseRootFromParent_Done,
      // Label 17232: @1221402
      GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1221501), // Rule ID 8681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8681,
        GIR_EraseRootFromParent_Done,
      // Label 17233: @1221501
      GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1221600), // Rule ID 8684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8684,
        GIR_EraseRootFromParent_Done,
      // Label 17234: @1221600
      GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1221699), // Rule ID 8685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8685,
        GIR_EraseRootFromParent_Done,
      // Label 17235: @1221699
      GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1221798), // Rule ID 8688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8688,
        GIR_EraseRootFromParent_Done,
      // Label 17236: @1221798
      GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1221897), // Rule ID 8689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8689,
        GIR_EraseRootFromParent_Done,
      // Label 17237: @1221897
      GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1221996), // Rule ID 8692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8692,
        GIR_EraseRootFromParent_Done,
      // Label 17238: @1221996
      GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1222095), // Rule ID 8693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8693,
        GIR_EraseRootFromParent_Done,
      // Label 17239: @1222095
      GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1222194), // Rule ID 8696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8696,
        GIR_EraseRootFromParent_Done,
      // Label 17240: @1222194
      GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1222293), // Rule ID 8697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8697,
        GIR_EraseRootFromParent_Done,
      // Label 17241: @1222293
      GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1222392), // Rule ID 8700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8700,
        GIR_EraseRootFromParent_Done,
      // Label 17242: @1222392
      GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1222491), // Rule ID 8701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8701,
        GIR_EraseRootFromParent_Done,
      // Label 17243: @1222491
      GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1222590), // Rule ID 8704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8704,
        GIR_EraseRootFromParent_Done,
      // Label 17244: @1222590
      GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1222689), // Rule ID 8705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11067:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8705,
        GIR_EraseRootFromParent_Done,
      // Label 17245: @1222689
      GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1222788), // Rule ID 8796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8796,
        GIR_EraseRootFromParent_Done,
      // Label 17246: @1222788
      GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1222887), // Rule ID 8797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8797,
        GIR_EraseRootFromParent_Done,
      // Label 17247: @1222887
      GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1222986), // Rule ID 8800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8800,
        GIR_EraseRootFromParent_Done,
      // Label 17248: @1222986
      GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1223085), // Rule ID 8801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8801,
        GIR_EraseRootFromParent_Done,
      // Label 17249: @1223085
      GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1223184), // Rule ID 8804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8804,
        GIR_EraseRootFromParent_Done,
      // Label 17250: @1223184
      GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1223283), // Rule ID 8805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8805,
        GIR_EraseRootFromParent_Done,
      // Label 17251: @1223283
      GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1223382), // Rule ID 8808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8808,
        GIR_EraseRootFromParent_Done,
      // Label 17252: @1223382
      GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1223481), // Rule ID 8809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8809,
        GIR_EraseRootFromParent_Done,
      // Label 17253: @1223481
      GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1223580), // Rule ID 8812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8812,
        GIR_EraseRootFromParent_Done,
      // Label 17254: @1223580
      GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1223679), // Rule ID 8813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8813,
        GIR_EraseRootFromParent_Done,
      // Label 17255: @1223679
      GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1223778), // Rule ID 8816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8816,
        GIR_EraseRootFromParent_Done,
      // Label 17256: @1223778
      GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1223877), // Rule ID 8817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8817,
        GIR_EraseRootFromParent_Done,
      // Label 17257: @1223877
      GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1223976), // Rule ID 8820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8820,
        GIR_EraseRootFromParent_Done,
      // Label 17258: @1223976
      GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1224075), // Rule ID 8821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8821,
        GIR_EraseRootFromParent_Done,
      // Label 17259: @1224075
      GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1224174), // Rule ID 8824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8824,
        GIR_EraseRootFromParent_Done,
      // Label 17260: @1224174
      GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1224273), // Rule ID 8825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8825,
        GIR_EraseRootFromParent_Done,
      // Label 17261: @1224273
      GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1224372), // Rule ID 8828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8828,
        GIR_EraseRootFromParent_Done,
      // Label 17262: @1224372
      GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1224471), // Rule ID 8829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8829,
        GIR_EraseRootFromParent_Done,
      // Label 17263: @1224471
      GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1224570), // Rule ID 8832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8832,
        GIR_EraseRootFromParent_Done,
      // Label 17264: @1224570
      GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1224669), // Rule ID 8833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8833,
        GIR_EraseRootFromParent_Done,
      // Label 17265: @1224669
      GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1224768), // Rule ID 8836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8836,
        GIR_EraseRootFromParent_Done,
      // Label 17266: @1224768
      GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1224867), // Rule ID 8837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8837,
        GIR_EraseRootFromParent_Done,
      // Label 17267: @1224867
      GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1224966), // Rule ID 8840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8840,
        GIR_EraseRootFromParent_Done,
      // Label 17268: @1224966
      GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1225065), // Rule ID 8841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8841,
        GIR_EraseRootFromParent_Done,
      // Label 17269: @1225065
      GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1225164), // Rule ID 8844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8844,
        GIR_EraseRootFromParent_Done,
      // Label 17270: @1225164
      GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1225263), // Rule ID 8845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8845,
        GIR_EraseRootFromParent_Done,
      // Label 17271: @1225263
      GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1225362), // Rule ID 8848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8848,
        GIR_EraseRootFromParent_Done,
      // Label 17272: @1225362
      GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1225461), // Rule ID 8849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8849,
        GIR_EraseRootFromParent_Done,
      // Label 17273: @1225461
      GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1225560), // Rule ID 8852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8852,
        GIR_EraseRootFromParent_Done,
      // Label 17274: @1225560
      GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1225659), // Rule ID 8853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8853,
        GIR_EraseRootFromParent_Done,
      // Label 17275: @1225659
      GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1225758), // Rule ID 8856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8856,
        GIR_EraseRootFromParent_Done,
      // Label 17276: @1225758
      GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1225857), // Rule ID 8857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8857,
        GIR_EraseRootFromParent_Done,
      // Label 17277: @1225857
      GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1225956), // Rule ID 8860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8860,
        GIR_EraseRootFromParent_Done,
      // Label 17278: @1225956
      GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1226055), // Rule ID 8861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8861,
        GIR_EraseRootFromParent_Done,
      // Label 17279: @1226055
      GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1226154), // Rule ID 8864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8864,
        GIR_EraseRootFromParent_Done,
      // Label 17280: @1226154
      GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1226253), // Rule ID 8865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8865,
        GIR_EraseRootFromParent_Done,
      // Label 17281: @1226253
      GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1226352), // Rule ID 8868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8868,
        GIR_EraseRootFromParent_Done,
      // Label 17282: @1226352
      GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1226451), // Rule ID 8869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8869,
        GIR_EraseRootFromParent_Done,
      // Label 17283: @1226451
      GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1226550), // Rule ID 8872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8872,
        GIR_EraseRootFromParent_Done,
      // Label 17284: @1226550
      GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1226649), // Rule ID 8873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8873,
        GIR_EraseRootFromParent_Done,
      // Label 17285: @1226649
      GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1226748), // Rule ID 8876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8876,
        GIR_EraseRootFromParent_Done,
      // Label 17286: @1226748
      GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1226847), // Rule ID 8877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8877,
        GIR_EraseRootFromParent_Done,
      // Label 17287: @1226847
      GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1226946), // Rule ID 8880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8880,
        GIR_EraseRootFromParent_Done,
      // Label 17288: @1226946
      GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1227045), // Rule ID 8881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8881,
        GIR_EraseRootFromParent_Done,
      // Label 17289: @1227045
      GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1227144), // Rule ID 8884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8884,
        GIR_EraseRootFromParent_Done,
      // Label 17290: @1227144
      GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1227243), // Rule ID 8885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8885,
        GIR_EraseRootFromParent_Done,
      // Label 17291: @1227243
      GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1227342), // Rule ID 8888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8888,
        GIR_EraseRootFromParent_Done,
      // Label 17292: @1227342
      GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1227441), // Rule ID 8889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8889,
        GIR_EraseRootFromParent_Done,
      // Label 17293: @1227441
      GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1227540), // Rule ID 8892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8892,
        GIR_EraseRootFromParent_Done,
      // Label 17294: @1227540
      GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1227639), // Rule ID 8893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8893,
        GIR_EraseRootFromParent_Done,
      // Label 17295: @1227639
      GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1227738), // Rule ID 8896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8896,
        GIR_EraseRootFromParent_Done,
      // Label 17296: @1227738
      GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1227837), // Rule ID 8897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8897,
        GIR_EraseRootFromParent_Done,
      // Label 17297: @1227837
      GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1227936), // Rule ID 8900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8900,
        GIR_EraseRootFromParent_Done,
      // Label 17298: @1227936
      GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1228035), // Rule ID 8901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8901,
        GIR_EraseRootFromParent_Done,
      // Label 17299: @1228035
      GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1228134), // Rule ID 8904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8904,
        GIR_EraseRootFromParent_Done,
      // Label 17300: @1228134
      GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1228233), // Rule ID 8905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8905,
        GIR_EraseRootFromParent_Done,
      // Label 17301: @1228233
      GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1228332), // Rule ID 8908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8908,
        GIR_EraseRootFromParent_Done,
      // Label 17302: @1228332
      GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1228431), // Rule ID 8909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8909,
        GIR_EraseRootFromParent_Done,
      // Label 17303: @1228431
      GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1228530), // Rule ID 8912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8912,
        GIR_EraseRootFromParent_Done,
      // Label 17304: @1228530
      GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1228629), // Rule ID 8913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8913,
        GIR_EraseRootFromParent_Done,
      // Label 17305: @1228629
      GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1228728), // Rule ID 8916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8916,
        GIR_EraseRootFromParent_Done,
      // Label 17306: @1228728
      GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1228827), // Rule ID 8917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8917,
        GIR_EraseRootFromParent_Done,
      // Label 17307: @1228827
      GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1228926), // Rule ID 8920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8920,
        GIR_EraseRootFromParent_Done,
      // Label 17308: @1228926
      GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1229025), // Rule ID 8921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8921,
        GIR_EraseRootFromParent_Done,
      // Label 17309: @1229025
      GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1229124), // Rule ID 8924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8924,
        GIR_EraseRootFromParent_Done,
      // Label 17310: @1229124
      GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1229223), // Rule ID 8925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8925,
        GIR_EraseRootFromParent_Done,
      // Label 17311: @1229223
      GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1229322), // Rule ID 8928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8928,
        GIR_EraseRootFromParent_Done,
      // Label 17312: @1229322
      GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1229421), // Rule ID 8929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8929,
        GIR_EraseRootFromParent_Done,
      // Label 17313: @1229421
      GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1229520), // Rule ID 8932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8932,
        GIR_EraseRootFromParent_Done,
      // Label 17314: @1229520
      GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1229619), // Rule ID 8933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8933,
        GIR_EraseRootFromParent_Done,
      // Label 17315: @1229619
      GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1229718), // Rule ID 8936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8936,
        GIR_EraseRootFromParent_Done,
      // Label 17316: @1229718
      GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1229817), // Rule ID 8937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8937,
        GIR_EraseRootFromParent_Done,
      // Label 17317: @1229817
      GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1229916), // Rule ID 8940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8940,
        GIR_EraseRootFromParent_Done,
      // Label 17318: @1229916
      GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1230015), // Rule ID 8941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8941,
        GIR_EraseRootFromParent_Done,
      // Label 17319: @1230015
      GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1230114), // Rule ID 8944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8944,
        GIR_EraseRootFromParent_Done,
      // Label 17320: @1230114
      GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1230213), // Rule ID 8945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8945,
        GIR_EraseRootFromParent_Done,
      // Label 17321: @1230213
      GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1230312), // Rule ID 8948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8948,
        GIR_EraseRootFromParent_Done,
      // Label 17322: @1230312
      GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1230411), // Rule ID 8949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8949,
        GIR_EraseRootFromParent_Done,
      // Label 17323: @1230411
      GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1230510), // Rule ID 8952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8952,
        GIR_EraseRootFromParent_Done,
      // Label 17324: @1230510
      GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1230609), // Rule ID 8953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8953,
        GIR_EraseRootFromParent_Done,
      // Label 17325: @1230609
      GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1230708), // Rule ID 8956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8956,
        GIR_EraseRootFromParent_Done,
      // Label 17326: @1230708
      GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1230807), // Rule ID 8957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8957,
        GIR_EraseRootFromParent_Done,
      // Label 17327: @1230807
      GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1230906), // Rule ID 8960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8960,
        GIR_EraseRootFromParent_Done,
      // Label 17328: @1230906
      GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1231005), // Rule ID 8961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8961,
        GIR_EraseRootFromParent_Done,
      // Label 17329: @1231005
      GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1231104), // Rule ID 8964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8964,
        GIR_EraseRootFromParent_Done,
      // Label 17330: @1231104
      GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1231203), // Rule ID 8965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8965,
        GIR_EraseRootFromParent_Done,
      // Label 17331: @1231203
      GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1231302), // Rule ID 8968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8968,
        GIR_EraseRootFromParent_Done,
      // Label 17332: @1231302
      GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1231401), // Rule ID 8969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11065:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8969,
        GIR_EraseRootFromParent_Done,
      // Label 17333: @1231401
      GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1231500), // Rule ID 9060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9060,
        GIR_EraseRootFromParent_Done,
      // Label 17334: @1231500
      GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1231599), // Rule ID 9061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9061,
        GIR_EraseRootFromParent_Done,
      // Label 17335: @1231599
      GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1231698), // Rule ID 9064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9064,
        GIR_EraseRootFromParent_Done,
      // Label 17336: @1231698
      GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1231797), // Rule ID 9065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9065,
        GIR_EraseRootFromParent_Done,
      // Label 17337: @1231797
      GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1231896), // Rule ID 9068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9068,
        GIR_EraseRootFromParent_Done,
      // Label 17338: @1231896
      GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1231995), // Rule ID 9069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9069,
        GIR_EraseRootFromParent_Done,
      // Label 17339: @1231995
      GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1232094), // Rule ID 9072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9072,
        GIR_EraseRootFromParent_Done,
      // Label 17340: @1232094
      GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1232193), // Rule ID 9073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9073,
        GIR_EraseRootFromParent_Done,
      // Label 17341: @1232193
      GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1232292), // Rule ID 9076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9076,
        GIR_EraseRootFromParent_Done,
      // Label 17342: @1232292
      GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1232391), // Rule ID 9077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9077,
        GIR_EraseRootFromParent_Done,
      // Label 17343: @1232391
      GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1232490), // Rule ID 9080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9080,
        GIR_EraseRootFromParent_Done,
      // Label 17344: @1232490
      GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1232589), // Rule ID 9081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9081,
        GIR_EraseRootFromParent_Done,
      // Label 17345: @1232589
      GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1232688), // Rule ID 9084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9084,
        GIR_EraseRootFromParent_Done,
      // Label 17346: @1232688
      GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1232787), // Rule ID 9085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9085,
        GIR_EraseRootFromParent_Done,
      // Label 17347: @1232787
      GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1232886), // Rule ID 9088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9088,
        GIR_EraseRootFromParent_Done,
      // Label 17348: @1232886
      GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1232985), // Rule ID 9089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9089,
        GIR_EraseRootFromParent_Done,
      // Label 17349: @1232985
      GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1233084), // Rule ID 9092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9092,
        GIR_EraseRootFromParent_Done,
      // Label 17350: @1233084
      GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1233183), // Rule ID 9093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9093,
        GIR_EraseRootFromParent_Done,
      // Label 17351: @1233183
      GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1233282), // Rule ID 9096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9096,
        GIR_EraseRootFromParent_Done,
      // Label 17352: @1233282
      GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1233381), // Rule ID 9097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9097,
        GIR_EraseRootFromParent_Done,
      // Label 17353: @1233381
      GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1233480), // Rule ID 9100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9100,
        GIR_EraseRootFromParent_Done,
      // Label 17354: @1233480
      GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1233579), // Rule ID 9101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9101,
        GIR_EraseRootFromParent_Done,
      // Label 17355: @1233579
      GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1233678), // Rule ID 9104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9104,
        GIR_EraseRootFromParent_Done,
      // Label 17356: @1233678
      GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1233777), // Rule ID 9105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9105,
        GIR_EraseRootFromParent_Done,
      // Label 17357: @1233777
      GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1233876), // Rule ID 9108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9108,
        GIR_EraseRootFromParent_Done,
      // Label 17358: @1233876
      GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1233975), // Rule ID 9109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9109,
        GIR_EraseRootFromParent_Done,
      // Label 17359: @1233975
      GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1234074), // Rule ID 9112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9112,
        GIR_EraseRootFromParent_Done,
      // Label 17360: @1234074
      GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1234173), // Rule ID 9113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9113,
        GIR_EraseRootFromParent_Done,
      // Label 17361: @1234173
      GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1234272), // Rule ID 9116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9116,
        GIR_EraseRootFromParent_Done,
      // Label 17362: @1234272
      GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1234371), // Rule ID 9117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9117,
        GIR_EraseRootFromParent_Done,
      // Label 17363: @1234371
      GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1234470), // Rule ID 9120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9120,
        GIR_EraseRootFromParent_Done,
      // Label 17364: @1234470
      GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1234569), // Rule ID 9121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9121,
        GIR_EraseRootFromParent_Done,
      // Label 17365: @1234569
      GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1234668), // Rule ID 9124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9124,
        GIR_EraseRootFromParent_Done,
      // Label 17366: @1234668
      GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1234767), // Rule ID 9125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9125,
        GIR_EraseRootFromParent_Done,
      // Label 17367: @1234767
      GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1234866), // Rule ID 9128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9128,
        GIR_EraseRootFromParent_Done,
      // Label 17368: @1234866
      GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1234965), // Rule ID 9129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9129,
        GIR_EraseRootFromParent_Done,
      // Label 17369: @1234965
      GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1235064), // Rule ID 9132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9132,
        GIR_EraseRootFromParent_Done,
      // Label 17370: @1235064
      GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1235163), // Rule ID 9133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9133,
        GIR_EraseRootFromParent_Done,
      // Label 17371: @1235163
      GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1235262), // Rule ID 9136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9136,
        GIR_EraseRootFromParent_Done,
      // Label 17372: @1235262
      GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1235361), // Rule ID 9137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9137,
        GIR_EraseRootFromParent_Done,
      // Label 17373: @1235361
      GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1235460), // Rule ID 9140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9140,
        GIR_EraseRootFromParent_Done,
      // Label 17374: @1235460
      GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1235559), // Rule ID 9141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9141,
        GIR_EraseRootFromParent_Done,
      // Label 17375: @1235559
      GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1235658), // Rule ID 9144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9144,
        GIR_EraseRootFromParent_Done,
      // Label 17376: @1235658
      GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1235757), // Rule ID 9145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9145,
        GIR_EraseRootFromParent_Done,
      // Label 17377: @1235757
      GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1235856), // Rule ID 9236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9236,
        GIR_EraseRootFromParent_Done,
      // Label 17378: @1235856
      GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1235955), // Rule ID 9237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9237,
        GIR_EraseRootFromParent_Done,
      // Label 17379: @1235955
      GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1236054), // Rule ID 9240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9240,
        GIR_EraseRootFromParent_Done,
      // Label 17380: @1236054
      GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1236153), // Rule ID 9241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9241,
        GIR_EraseRootFromParent_Done,
      // Label 17381: @1236153
      GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1236252), // Rule ID 9244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9244,
        GIR_EraseRootFromParent_Done,
      // Label 17382: @1236252
      GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1236351), // Rule ID 9245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9245,
        GIR_EraseRootFromParent_Done,
      // Label 17383: @1236351
      GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1236450), // Rule ID 9248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9248,
        GIR_EraseRootFromParent_Done,
      // Label 17384: @1236450
      GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1236549), // Rule ID 9249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9249,
        GIR_EraseRootFromParent_Done,
      // Label 17385: @1236549
      GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1236648), // Rule ID 9252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9252,
        GIR_EraseRootFromParent_Done,
      // Label 17386: @1236648
      GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1236747), // Rule ID 9253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9253,
        GIR_EraseRootFromParent_Done,
      // Label 17387: @1236747
      GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1236846), // Rule ID 9256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9256,
        GIR_EraseRootFromParent_Done,
      // Label 17388: @1236846
      GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1236945), // Rule ID 9257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9257,
        GIR_EraseRootFromParent_Done,
      // Label 17389: @1236945
      GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1237044), // Rule ID 9260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9260,
        GIR_EraseRootFromParent_Done,
      // Label 17390: @1237044
      GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1237143), // Rule ID 9261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9261,
        GIR_EraseRootFromParent_Done,
      // Label 17391: @1237143
      GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1237242), // Rule ID 9264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9264,
        GIR_EraseRootFromParent_Done,
      // Label 17392: @1237242
      GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1237341), // Rule ID 9265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9265,
        GIR_EraseRootFromParent_Done,
      // Label 17393: @1237341
      GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1237440), // Rule ID 9268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9268,
        GIR_EraseRootFromParent_Done,
      // Label 17394: @1237440
      GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1237539), // Rule ID 9269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9269,
        GIR_EraseRootFromParent_Done,
      // Label 17395: @1237539
      GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1237638), // Rule ID 9272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9272,
        GIR_EraseRootFromParent_Done,
      // Label 17396: @1237638
      GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1237737), // Rule ID 9273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9273,
        GIR_EraseRootFromParent_Done,
      // Label 17397: @1237737
      GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1237836), // Rule ID 9276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9276,
        GIR_EraseRootFromParent_Done,
      // Label 17398: @1237836
      GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1237935), // Rule ID 9277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9277,
        GIR_EraseRootFromParent_Done,
      // Label 17399: @1237935
      GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1238034), // Rule ID 9280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9280,
        GIR_EraseRootFromParent_Done,
      // Label 17400: @1238034
      GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1238133), // Rule ID 9281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9281,
        GIR_EraseRootFromParent_Done,
      // Label 17401: @1238133
      GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1238232), // Rule ID 9284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9284,
        GIR_EraseRootFromParent_Done,
      // Label 17402: @1238232
      GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1238331), // Rule ID 9285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9285,
        GIR_EraseRootFromParent_Done,
      // Label 17403: @1238331
      GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1238430), // Rule ID 9288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9288,
        GIR_EraseRootFromParent_Done,
      // Label 17404: @1238430
      GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1238529), // Rule ID 9289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9289,
        GIR_EraseRootFromParent_Done,
      // Label 17405: @1238529
      GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1238628), // Rule ID 9292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9292,
        GIR_EraseRootFromParent_Done,
      // Label 17406: @1238628
      GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1238727), // Rule ID 9293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9293,
        GIR_EraseRootFromParent_Done,
      // Label 17407: @1238727
      GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1238826), // Rule ID 9296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9296,
        GIR_EraseRootFromParent_Done,
      // Label 17408: @1238826
      GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1238925), // Rule ID 9297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9297,
        GIR_EraseRootFromParent_Done,
      // Label 17409: @1238925
      GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1239024), // Rule ID 9300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9300,
        GIR_EraseRootFromParent_Done,
      // Label 17410: @1239024
      GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1239123), // Rule ID 9301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9301,
        GIR_EraseRootFromParent_Done,
      // Label 17411: @1239123
      GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1239222), // Rule ID 9304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9304,
        GIR_EraseRootFromParent_Done,
      // Label 17412: @1239222
      GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1239321), // Rule ID 9305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9305,
        GIR_EraseRootFromParent_Done,
      // Label 17413: @1239321
      GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1239420), // Rule ID 9308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9308,
        GIR_EraseRootFromParent_Done,
      // Label 17414: @1239420
      GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1239519), // Rule ID 9309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9309,
        GIR_EraseRootFromParent_Done,
      // Label 17415: @1239519
      GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1239618), // Rule ID 9312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9312,
        GIR_EraseRootFromParent_Done,
      // Label 17416: @1239618
      GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1239717), // Rule ID 9313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9313,
        GIR_EraseRootFromParent_Done,
      // Label 17417: @1239717
      GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1239816), // Rule ID 9316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9316,
        GIR_EraseRootFromParent_Done,
      // Label 17418: @1239816
      GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1239915), // Rule ID 9317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9317,
        GIR_EraseRootFromParent_Done,
      // Label 17419: @1239915
      GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1240014), // Rule ID 9320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9320,
        GIR_EraseRootFromParent_Done,
      // Label 17420: @1240014
      GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1240113), // Rule ID 9321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9321,
        GIR_EraseRootFromParent_Done,
      // Label 17421: @1240113
      GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1240212), // Rule ID 9412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9412,
        GIR_EraseRootFromParent_Done,
      // Label 17422: @1240212
      GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1240311), // Rule ID 9413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9413,
        GIR_EraseRootFromParent_Done,
      // Label 17423: @1240311
      GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1240410), // Rule ID 9416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9416,
        GIR_EraseRootFromParent_Done,
      // Label 17424: @1240410
      GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1240509), // Rule ID 9417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9417,
        GIR_EraseRootFromParent_Done,
      // Label 17425: @1240509
      GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1240608), // Rule ID 9420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9420,
        GIR_EraseRootFromParent_Done,
      // Label 17426: @1240608
      GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1240707), // Rule ID 9421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9421,
        GIR_EraseRootFromParent_Done,
      // Label 17427: @1240707
      GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1240806), // Rule ID 9424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9424,
        GIR_EraseRootFromParent_Done,
      // Label 17428: @1240806
      GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1240905), // Rule ID 9425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9425,
        GIR_EraseRootFromParent_Done,
      // Label 17429: @1240905
      GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1241004), // Rule ID 9428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9428,
        GIR_EraseRootFromParent_Done,
      // Label 17430: @1241004
      GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1241103), // Rule ID 9429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9429,
        GIR_EraseRootFromParent_Done,
      // Label 17431: @1241103
      GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1241202), // Rule ID 9432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9432,
        GIR_EraseRootFromParent_Done,
      // Label 17432: @1241202
      GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1241301), // Rule ID 9433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9433,
        GIR_EraseRootFromParent_Done,
      // Label 17433: @1241301
      GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1241400), // Rule ID 9436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9436,
        GIR_EraseRootFromParent_Done,
      // Label 17434: @1241400
      GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1241499), // Rule ID 9437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9437,
        GIR_EraseRootFromParent_Done,
      // Label 17435: @1241499
      GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1241598), // Rule ID 9440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9440,
        GIR_EraseRootFromParent_Done,
      // Label 17436: @1241598
      GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1241697), // Rule ID 9441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9441,
        GIR_EraseRootFromParent_Done,
      // Label 17437: @1241697
      GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1241796), // Rule ID 9444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9444,
        GIR_EraseRootFromParent_Done,
      // Label 17438: @1241796
      GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1241895), // Rule ID 9445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9445,
        GIR_EraseRootFromParent_Done,
      // Label 17439: @1241895
      GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1241994), // Rule ID 9448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9448,
        GIR_EraseRootFromParent_Done,
      // Label 17440: @1241994
      GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1242093), // Rule ID 9449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9449,
        GIR_EraseRootFromParent_Done,
      // Label 17441: @1242093
      GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1242192), // Rule ID 9452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9452,
        GIR_EraseRootFromParent_Done,
      // Label 17442: @1242192
      GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1242291), // Rule ID 9453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9453,
        GIR_EraseRootFromParent_Done,
      // Label 17443: @1242291
      GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1242390), // Rule ID 9456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9456,
        GIR_EraseRootFromParent_Done,
      // Label 17444: @1242390
      GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1242489), // Rule ID 9457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9457,
        GIR_EraseRootFromParent_Done,
      // Label 17445: @1242489
      GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1242588), // Rule ID 9460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9460,
        GIR_EraseRootFromParent_Done,
      // Label 17446: @1242588
      GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1242687), // Rule ID 9461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9461,
        GIR_EraseRootFromParent_Done,
      // Label 17447: @1242687
      GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1242786), // Rule ID 9464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9464,
        GIR_EraseRootFromParent_Done,
      // Label 17448: @1242786
      GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1242885), // Rule ID 9465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9465,
        GIR_EraseRootFromParent_Done,
      // Label 17449: @1242885
      GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1242984), // Rule ID 9468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9468,
        GIR_EraseRootFromParent_Done,
      // Label 17450: @1242984
      GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1243083), // Rule ID 9469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9469,
        GIR_EraseRootFromParent_Done,
      // Label 17451: @1243083
      GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1243182), // Rule ID 9472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9472,
        GIR_EraseRootFromParent_Done,
      // Label 17452: @1243182
      GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1243281), // Rule ID 9473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9473,
        GIR_EraseRootFromParent_Done,
      // Label 17453: @1243281
      GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1243380), // Rule ID 9476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9476,
        GIR_EraseRootFromParent_Done,
      // Label 17454: @1243380
      GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1243479), // Rule ID 9477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9477,
        GIR_EraseRootFromParent_Done,
      // Label 17455: @1243479
      GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1243578), // Rule ID 9480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9480,
        GIR_EraseRootFromParent_Done,
      // Label 17456: @1243578
      GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1243677), // Rule ID 9481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9481,
        GIR_EraseRootFromParent_Done,
      // Label 17457: @1243677
      GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1243776), // Rule ID 9484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9484,
        GIR_EraseRootFromParent_Done,
      // Label 17458: @1243776
      GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1243875), // Rule ID 9485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9485,
        GIR_EraseRootFromParent_Done,
      // Label 17459: @1243875
      GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1243974), // Rule ID 9488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9488,
        GIR_EraseRootFromParent_Done,
      // Label 17460: @1243974
      GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1244073), // Rule ID 9489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9489,
        GIR_EraseRootFromParent_Done,
      // Label 17461: @1244073
      GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1244172), // Rule ID 9492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9492,
        GIR_EraseRootFromParent_Done,
      // Label 17462: @1244172
      GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1244271), // Rule ID 9493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11061:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9493,
        GIR_EraseRootFromParent_Done,
      // Label 17463: @1244271
      GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1244370), // Rule ID 9496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9496,
        GIR_EraseRootFromParent_Done,
      // Label 17464: @1244370
      GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1244469), // Rule ID 9497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9497,
        GIR_EraseRootFromParent_Done,
      // Label 17465: @1244469
      GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1244568), // Rule ID 9500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9500,
        GIR_EraseRootFromParent_Done,
      // Label 17466: @1244568
      GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1244667), // Rule ID 9501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9501,
        GIR_EraseRootFromParent_Done,
      // Label 17467: @1244667
      GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1244766), // Rule ID 9504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9504,
        GIR_EraseRootFromParent_Done,
      // Label 17468: @1244766
      GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1244865), // Rule ID 9505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9505,
        GIR_EraseRootFromParent_Done,
      // Label 17469: @1244865
      GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1244964), // Rule ID 9508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9508,
        GIR_EraseRootFromParent_Done,
      // Label 17470: @1244964
      GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1245063), // Rule ID 9509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9509,
        GIR_EraseRootFromParent_Done,
      // Label 17471: @1245063
      GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1245162), // Rule ID 9512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9512,
        GIR_EraseRootFromParent_Done,
      // Label 17472: @1245162
      GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1245261), // Rule ID 9513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9513,
        GIR_EraseRootFromParent_Done,
      // Label 17473: @1245261
      GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1245360), // Rule ID 9516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9516,
        GIR_EraseRootFromParent_Done,
      // Label 17474: @1245360
      GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1245459), // Rule ID 9517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9517,
        GIR_EraseRootFromParent_Done,
      // Label 17475: @1245459
      GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1245558), // Rule ID 9520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9520,
        GIR_EraseRootFromParent_Done,
      // Label 17476: @1245558
      GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1245657), // Rule ID 9521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9521,
        GIR_EraseRootFromParent_Done,
      // Label 17477: @1245657
      GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1245756), // Rule ID 9524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9524,
        GIR_EraseRootFromParent_Done,
      // Label 17478: @1245756
      GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1245855), // Rule ID 9525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9525,
        GIR_EraseRootFromParent_Done,
      // Label 17479: @1245855
      GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1245954), // Rule ID 9528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9528,
        GIR_EraseRootFromParent_Done,
      // Label 17480: @1245954
      GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1246053), // Rule ID 9529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9529,
        GIR_EraseRootFromParent_Done,
      // Label 17481: @1246053
      GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1246152), // Rule ID 9532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9532,
        GIR_EraseRootFromParent_Done,
      // Label 17482: @1246152
      GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1246251), // Rule ID 9533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9533,
        GIR_EraseRootFromParent_Done,
      // Label 17483: @1246251
      GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1246350), // Rule ID 9536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9536,
        GIR_EraseRootFromParent_Done,
      // Label 17484: @1246350
      GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1246449), // Rule ID 9537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9537,
        GIR_EraseRootFromParent_Done,
      // Label 17485: @1246449
      GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1246548), // Rule ID 9540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9540,
        GIR_EraseRootFromParent_Done,
      // Label 17486: @1246548
      GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1246647), // Rule ID 9541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9541,
        GIR_EraseRootFromParent_Done,
      // Label 17487: @1246647
      GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1246746), // Rule ID 9544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9544,
        GIR_EraseRootFromParent_Done,
      // Label 17488: @1246746
      GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1246845), // Rule ID 9545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9545,
        GIR_EraseRootFromParent_Done,
      // Label 17489: @1246845
      GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1246944), // Rule ID 9548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9548,
        GIR_EraseRootFromParent_Done,
      // Label 17490: @1246944
      GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1247043), // Rule ID 9549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9549,
        GIR_EraseRootFromParent_Done,
      // Label 17491: @1247043
      GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1247142), // Rule ID 9552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9552,
        GIR_EraseRootFromParent_Done,
      // Label 17492: @1247142
      GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1247241), // Rule ID 9553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9553,
        GIR_EraseRootFromParent_Done,
      // Label 17493: @1247241
      GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1247340), // Rule ID 9556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9556,
        GIR_EraseRootFromParent_Done,
      // Label 17494: @1247340
      GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1247439), // Rule ID 9557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9557,
        GIR_EraseRootFromParent_Done,
      // Label 17495: @1247439
      GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1247538), // Rule ID 9560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9560,
        GIR_EraseRootFromParent_Done,
      // Label 17496: @1247538
      GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1247637), // Rule ID 9561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9561,
        GIR_EraseRootFromParent_Done,
      // Label 17497: @1247637
      GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1247736), // Rule ID 9564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9564,
        GIR_EraseRootFromParent_Done,
      // Label 17498: @1247736
      GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1247835), // Rule ID 9565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9565,
        GIR_EraseRootFromParent_Done,
      // Label 17499: @1247835
      GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1247934), // Rule ID 9568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9568,
        GIR_EraseRootFromParent_Done,
      // Label 17500: @1247934
      GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1248033), // Rule ID 9569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9569,
        GIR_EraseRootFromParent_Done,
      // Label 17501: @1248033
      GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1248132), // Rule ID 9572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9572,
        GIR_EraseRootFromParent_Done,
      // Label 17502: @1248132
      GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1248231), // Rule ID 9573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9573,
        GIR_EraseRootFromParent_Done,
      // Label 17503: @1248231
      GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1248330), // Rule ID 9576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9576,
        GIR_EraseRootFromParent_Done,
      // Label 17504: @1248330
      GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1248429), // Rule ID 9577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9577,
        GIR_EraseRootFromParent_Done,
      // Label 17505: @1248429
      GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1248528), // Rule ID 9580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9580,
        GIR_EraseRootFromParent_Done,
      // Label 17506: @1248528
      GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1248627), // Rule ID 9581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11059:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9581,
        GIR_EraseRootFromParent_Done,
      // Label 17507: @1248627
      GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1248726), // Rule ID 9584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9584,
        GIR_EraseRootFromParent_Done,
      // Label 17508: @1248726
      GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1248825), // Rule ID 9585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9585,
        GIR_EraseRootFromParent_Done,
      // Label 17509: @1248825
      GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1248924), // Rule ID 9588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9588,
        GIR_EraseRootFromParent_Done,
      // Label 17510: @1248924
      GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1249023), // Rule ID 9589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9589,
        GIR_EraseRootFromParent_Done,
      // Label 17511: @1249023
      GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1249122), // Rule ID 9592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9592,
        GIR_EraseRootFromParent_Done,
      // Label 17512: @1249122
      GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1249221), // Rule ID 9593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9593,
        GIR_EraseRootFromParent_Done,
      // Label 17513: @1249221
      GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1249320), // Rule ID 9596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9596,
        GIR_EraseRootFromParent_Done,
      // Label 17514: @1249320
      GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1249419), // Rule ID 9597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9597,
        GIR_EraseRootFromParent_Done,
      // Label 17515: @1249419
      GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1249518), // Rule ID 9600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9600,
        GIR_EraseRootFromParent_Done,
      // Label 17516: @1249518
      GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1249617), // Rule ID 9601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9601,
        GIR_EraseRootFromParent_Done,
      // Label 17517: @1249617
      GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1249716), // Rule ID 9604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9604,
        GIR_EraseRootFromParent_Done,
      // Label 17518: @1249716
      GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1249815), // Rule ID 9605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9605,
        GIR_EraseRootFromParent_Done,
      // Label 17519: @1249815
      GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1249914), // Rule ID 9608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9608,
        GIR_EraseRootFromParent_Done,
      // Label 17520: @1249914
      GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1250013), // Rule ID 9609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9609,
        GIR_EraseRootFromParent_Done,
      // Label 17521: @1250013
      GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1250112), // Rule ID 9612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9612,
        GIR_EraseRootFromParent_Done,
      // Label 17522: @1250112
      GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1250211), // Rule ID 9613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9613,
        GIR_EraseRootFromParent_Done,
      // Label 17523: @1250211
      GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1250310), // Rule ID 9616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9616,
        GIR_EraseRootFromParent_Done,
      // Label 17524: @1250310
      GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1250409), // Rule ID 9617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9617,
        GIR_EraseRootFromParent_Done,
      // Label 17525: @1250409
      GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1250508), // Rule ID 9620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9620,
        GIR_EraseRootFromParent_Done,
      // Label 17526: @1250508
      GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1250607), // Rule ID 9621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9621,
        GIR_EraseRootFromParent_Done,
      // Label 17527: @1250607
      GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1250706), // Rule ID 9624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9624,
        GIR_EraseRootFromParent_Done,
      // Label 17528: @1250706
      GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1250805), // Rule ID 9625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9625,
        GIR_EraseRootFromParent_Done,
      // Label 17529: @1250805
      GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1250904), // Rule ID 9628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9628,
        GIR_EraseRootFromParent_Done,
      // Label 17530: @1250904
      GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1251003), // Rule ID 9629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9629,
        GIR_EraseRootFromParent_Done,
      // Label 17531: @1251003
      GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1251102), // Rule ID 9632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9632,
        GIR_EraseRootFromParent_Done,
      // Label 17532: @1251102
      GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1251201), // Rule ID 9633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9633,
        GIR_EraseRootFromParent_Done,
      // Label 17533: @1251201
      GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1251300), // Rule ID 9636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9636,
        GIR_EraseRootFromParent_Done,
      // Label 17534: @1251300
      GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1251399), // Rule ID 9637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9637,
        GIR_EraseRootFromParent_Done,
      // Label 17535: @1251399
      GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1251498), // Rule ID 9640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9640,
        GIR_EraseRootFromParent_Done,
      // Label 17536: @1251498
      GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1251597), // Rule ID 9641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9641,
        GIR_EraseRootFromParent_Done,
      // Label 17537: @1251597
      GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1251696), // Rule ID 9644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9644,
        GIR_EraseRootFromParent_Done,
      // Label 17538: @1251696
      GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1251795), // Rule ID 9645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9645,
        GIR_EraseRootFromParent_Done,
      // Label 17539: @1251795
      GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1251894), // Rule ID 9648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9648,
        GIR_EraseRootFromParent_Done,
      // Label 17540: @1251894
      GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1251993), // Rule ID 9649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9649,
        GIR_EraseRootFromParent_Done,
      // Label 17541: @1251993
      GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1252092), // Rule ID 9652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9652,
        GIR_EraseRootFromParent_Done,
      // Label 17542: @1252092
      GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1252191), // Rule ID 9653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9653,
        GIR_EraseRootFromParent_Done,
      // Label 17543: @1252191
      GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1252290), // Rule ID 9656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9656,
        GIR_EraseRootFromParent_Done,
      // Label 17544: @1252290
      GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1252389), // Rule ID 9657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9657,
        GIR_EraseRootFromParent_Done,
      // Label 17545: @1252389
      GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1252488), // Rule ID 9660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9660,
        GIR_EraseRootFromParent_Done,
      // Label 17546: @1252488
      GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1252587), // Rule ID 9661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9661,
        GIR_EraseRootFromParent_Done,
      // Label 17547: @1252587
      GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1252686), // Rule ID 9664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9664,
        GIR_EraseRootFromParent_Done,
      // Label 17548: @1252686
      GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1252785), // Rule ID 9665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9665,
        GIR_EraseRootFromParent_Done,
      // Label 17549: @1252785
      GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1252884), // Rule ID 9668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9668,
        GIR_EraseRootFromParent_Done,
      // Label 17550: @1252884
      GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1252983), // Rule ID 9669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11057:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9669,
        GIR_EraseRootFromParent_Done,
      // Label 17551: @1252983
      GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1253082), // Rule ID 9672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9672,
        GIR_EraseRootFromParent_Done,
      // Label 17552: @1253082
      GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1253181), // Rule ID 9673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9673,
        GIR_EraseRootFromParent_Done,
      // Label 17553: @1253181
      GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1253280), // Rule ID 9676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9676,
        GIR_EraseRootFromParent_Done,
      // Label 17554: @1253280
      GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1253379), // Rule ID 9677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9677,
        GIR_EraseRootFromParent_Done,
      // Label 17555: @1253379
      GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1253478), // Rule ID 9680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9680,
        GIR_EraseRootFromParent_Done,
      // Label 17556: @1253478
      GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1253577), // Rule ID 9681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9681,
        GIR_EraseRootFromParent_Done,
      // Label 17557: @1253577
      GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1253676), // Rule ID 9684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9684,
        GIR_EraseRootFromParent_Done,
      // Label 17558: @1253676
      GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1253775), // Rule ID 9685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9685,
        GIR_EraseRootFromParent_Done,
      // Label 17559: @1253775
      GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1253874), // Rule ID 9688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9688,
        GIR_EraseRootFromParent_Done,
      // Label 17560: @1253874
      GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1253973), // Rule ID 9689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9689,
        GIR_EraseRootFromParent_Done,
      // Label 17561: @1253973
      GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1254072), // Rule ID 9692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9692,
        GIR_EraseRootFromParent_Done,
      // Label 17562: @1254072
      GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1254171), // Rule ID 9693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9693,
        GIR_EraseRootFromParent_Done,
      // Label 17563: @1254171
      GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1254270), // Rule ID 9696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9696,
        GIR_EraseRootFromParent_Done,
      // Label 17564: @1254270
      GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1254369), // Rule ID 9697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9697,
        GIR_EraseRootFromParent_Done,
      // Label 17565: @1254369
      GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1254468), // Rule ID 9700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9700,
        GIR_EraseRootFromParent_Done,
      // Label 17566: @1254468
      GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1254567), // Rule ID 9701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9701,
        GIR_EraseRootFromParent_Done,
      // Label 17567: @1254567
      GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1254666), // Rule ID 9704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9704,
        GIR_EraseRootFromParent_Done,
      // Label 17568: @1254666
      GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1254765), // Rule ID 9705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9705,
        GIR_EraseRootFromParent_Done,
      // Label 17569: @1254765
      GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1254864), // Rule ID 9708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9708,
        GIR_EraseRootFromParent_Done,
      // Label 17570: @1254864
      GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1254963), // Rule ID 9709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9709,
        GIR_EraseRootFromParent_Done,
      // Label 17571: @1254963
      GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1255062), // Rule ID 9712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9712,
        GIR_EraseRootFromParent_Done,
      // Label 17572: @1255062
      GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1255161), // Rule ID 9713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9713,
        GIR_EraseRootFromParent_Done,
      // Label 17573: @1255161
      GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1255260), // Rule ID 9716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9716,
        GIR_EraseRootFromParent_Done,
      // Label 17574: @1255260
      GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1255359), // Rule ID 9717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9717,
        GIR_EraseRootFromParent_Done,
      // Label 17575: @1255359
      GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1255458), // Rule ID 9720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9720,
        GIR_EraseRootFromParent_Done,
      // Label 17576: @1255458
      GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1255557), // Rule ID 9721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9721,
        GIR_EraseRootFromParent_Done,
      // Label 17577: @1255557
      GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1255656), // Rule ID 9724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9724,
        GIR_EraseRootFromParent_Done,
      // Label 17578: @1255656
      GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1255755), // Rule ID 9725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9725,
        GIR_EraseRootFromParent_Done,
      // Label 17579: @1255755
      GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1255854), // Rule ID 9728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9728,
        GIR_EraseRootFromParent_Done,
      // Label 17580: @1255854
      GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1255953), // Rule ID 9729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9729,
        GIR_EraseRootFromParent_Done,
      // Label 17581: @1255953
      GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1256052), // Rule ID 9732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9732,
        GIR_EraseRootFromParent_Done,
      // Label 17582: @1256052
      GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1256151), // Rule ID 9733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9733,
        GIR_EraseRootFromParent_Done,
      // Label 17583: @1256151
      GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1256250), // Rule ID 9736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9736,
        GIR_EraseRootFromParent_Done,
      // Label 17584: @1256250
      GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1256349), // Rule ID 9737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9737,
        GIR_EraseRootFromParent_Done,
      // Label 17585: @1256349
      GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1256448), // Rule ID 9740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9740,
        GIR_EraseRootFromParent_Done,
      // Label 17586: @1256448
      GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1256547), // Rule ID 9741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9741,
        GIR_EraseRootFromParent_Done,
      // Label 17587: @1256547
      GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1256646), // Rule ID 9744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9744,
        GIR_EraseRootFromParent_Done,
      // Label 17588: @1256646
      GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1256745), // Rule ID 9745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9745,
        GIR_EraseRootFromParent_Done,
      // Label 17589: @1256745
      GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1256844), // Rule ID 9748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9748,
        GIR_EraseRootFromParent_Done,
      // Label 17590: @1256844
      GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1256943), // Rule ID 9749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9749,
        GIR_EraseRootFromParent_Done,
      // Label 17591: @1256943
      GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1257042), // Rule ID 9752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9752,
        GIR_EraseRootFromParent_Done,
      // Label 17592: @1257042
      GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1257141), // Rule ID 9753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9753,
        GIR_EraseRootFromParent_Done,
      // Label 17593: @1257141
      GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1257240), // Rule ID 9756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9756,
        GIR_EraseRootFromParent_Done,
      // Label 17594: @1257240
      GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1257339), // Rule ID 9757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11055:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9757,
        GIR_EraseRootFromParent_Done,
      // Label 17595: @1257339
      GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1257438), // Rule ID 13698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13698,
        GIR_EraseRootFromParent_Done,
      // Label 17596: @1257438
      GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1257537), // Rule ID 13699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13699,
        GIR_EraseRootFromParent_Done,
      // Label 17597: @1257537
      GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1257636), // Rule ID 13700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13700,
        GIR_EraseRootFromParent_Done,
      // Label 17598: @1257636
      GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1257735), // Rule ID 13701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13701,
        GIR_EraseRootFromParent_Done,
      // Label 17599: @1257735
      GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1257834), // Rule ID 13702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13702,
        GIR_EraseRootFromParent_Done,
      // Label 17600: @1257834
      GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1257933), // Rule ID 13703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13703,
        GIR_EraseRootFromParent_Done,
      // Label 17601: @1257933
      GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1258032), // Rule ID 13704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13704,
        GIR_EraseRootFromParent_Done,
      // Label 17602: @1258032
      GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1258131), // Rule ID 13705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13705,
        GIR_EraseRootFromParent_Done,
      // Label 17603: @1258131
      GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1258230), // Rule ID 13706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13706,
        GIR_EraseRootFromParent_Done,
      // Label 17604: @1258230
      GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1258329), // Rule ID 13707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13707,
        GIR_EraseRootFromParent_Done,
      // Label 17605: @1258329
      GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1258428), // Rule ID 13708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13708,
        GIR_EraseRootFromParent_Done,
      // Label 17606: @1258428
      GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1258527), // Rule ID 13709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13709,
        GIR_EraseRootFromParent_Done,
      // Label 17607: @1258527
      GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1258626), // Rule ID 13710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13710,
        GIR_EraseRootFromParent_Done,
      // Label 17608: @1258626
      GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1258725), // Rule ID 13711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13711,
        GIR_EraseRootFromParent_Done,
      // Label 17609: @1258725
      GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1258824), // Rule ID 13712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13712,
        GIR_EraseRootFromParent_Done,
      // Label 17610: @1258824
      GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1258923), // Rule ID 13713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13713,
        GIR_EraseRootFromParent_Done,
      // Label 17611: @1258923
      GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1259022), // Rule ID 13714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13714,
        GIR_EraseRootFromParent_Done,
      // Label 17612: @1259022
      GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1259121), // Rule ID 13715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13715,
        GIR_EraseRootFromParent_Done,
      // Label 17613: @1259121
      GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1259220), // Rule ID 13716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13716,
        GIR_EraseRootFromParent_Done,
      // Label 17614: @1259220
      GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1259319), // Rule ID 13717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13717,
        GIR_EraseRootFromParent_Done,
      // Label 17615: @1259319
      GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1259418), // Rule ID 13718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13718,
        GIR_EraseRootFromParent_Done,
      // Label 17616: @1259418
      GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1259517), // Rule ID 13719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13719,
        GIR_EraseRootFromParent_Done,
      // Label 17617: @1259517
      GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1259616), // Rule ID 13720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13720,
        GIR_EraseRootFromParent_Done,
      // Label 17618: @1259616
      GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1259715), // Rule ID 13721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13721,
        GIR_EraseRootFromParent_Done,
      // Label 17619: @1259715
      GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1259814), // Rule ID 13722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13722,
        GIR_EraseRootFromParent_Done,
      // Label 17620: @1259814
      GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1259913), // Rule ID 13723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13723,
        GIR_EraseRootFromParent_Done,
      // Label 17621: @1259913
      GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1260012), // Rule ID 13724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13724,
        GIR_EraseRootFromParent_Done,
      // Label 17622: @1260012
      GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1260111), // Rule ID 13725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13725,
        GIR_EraseRootFromParent_Done,
      // Label 17623: @1260111
      GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1260210), // Rule ID 13726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13726,
        GIR_EraseRootFromParent_Done,
      // Label 17624: @1260210
      GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1260309), // Rule ID 13727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13727,
        GIR_EraseRootFromParent_Done,
      // Label 17625: @1260309
      GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1260408), // Rule ID 13728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13728,
        GIR_EraseRootFromParent_Done,
      // Label 17626: @1260408
      GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1260507), // Rule ID 13729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13729,
        GIR_EraseRootFromParent_Done,
      // Label 17627: @1260507
      GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1260606), // Rule ID 13730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13730,
        GIR_EraseRootFromParent_Done,
      // Label 17628: @1260606
      GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1260705), // Rule ID 13731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13731,
        GIR_EraseRootFromParent_Done,
      // Label 17629: @1260705
      GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1260804), // Rule ID 13732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13732,
        GIR_EraseRootFromParent_Done,
      // Label 17630: @1260804
      GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1260903), // Rule ID 13733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13733,
        GIR_EraseRootFromParent_Done,
      // Label 17631: @1260903
      GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1261002), // Rule ID 13734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13734,
        GIR_EraseRootFromParent_Done,
      // Label 17632: @1261002
      GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1261101), // Rule ID 13735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13735,
        GIR_EraseRootFromParent_Done,
      // Label 17633: @1261101
      GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1261200), // Rule ID 13736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13736,
        GIR_EraseRootFromParent_Done,
      // Label 17634: @1261200
      GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1261299), // Rule ID 13737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13737,
        GIR_EraseRootFromParent_Done,
      // Label 17635: @1261299
      GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1261398), // Rule ID 13738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13738,
        GIR_EraseRootFromParent_Done,
      // Label 17636: @1261398
      GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1261497), // Rule ID 13739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13739,
        GIR_EraseRootFromParent_Done,
      // Label 17637: @1261497
      GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1261596), // Rule ID 13740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13740,
        GIR_EraseRootFromParent_Done,
      // Label 17638: @1261596
      GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1261695), // Rule ID 13741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13741,
        GIR_EraseRootFromParent_Done,
      // Label 17639: @1261695
      GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1261794), // Rule ID 13742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13742,
        GIR_EraseRootFromParent_Done,
      // Label 17640: @1261794
      GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1261893), // Rule ID 13743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13743,
        GIR_EraseRootFromParent_Done,
      // Label 17641: @1261893
      GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1261992), // Rule ID 13744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13744,
        GIR_EraseRootFromParent_Done,
      // Label 17642: @1261992
      GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1262091), // Rule ID 13745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13745,
        GIR_EraseRootFromParent_Done,
      // Label 17643: @1262091
      GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1262190), // Rule ID 13746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13746,
        GIR_EraseRootFromParent_Done,
      // Label 17644: @1262190
      GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1262289), // Rule ID 13747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13747,
        GIR_EraseRootFromParent_Done,
      // Label 17645: @1262289
      GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1262388), // Rule ID 13748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13748,
        GIR_EraseRootFromParent_Done,
      // Label 17646: @1262388
      GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1262487), // Rule ID 13749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13749,
        GIR_EraseRootFromParent_Done,
      // Label 17647: @1262487
      GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1262586), // Rule ID 13750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13750,
        GIR_EraseRootFromParent_Done,
      // Label 17648: @1262586
      GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1262685), // Rule ID 13751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13751,
        GIR_EraseRootFromParent_Done,
      // Label 17649: @1262685
      GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1262784), // Rule ID 13752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13752,
        GIR_EraseRootFromParent_Done,
      // Label 17650: @1262784
      GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1262883), // Rule ID 13753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13753,
        GIR_EraseRootFromParent_Done,
      // Label 17651: @1262883
      GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1262982), // Rule ID 13754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13754,
        GIR_EraseRootFromParent_Done,
      // Label 17652: @1262982
      GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1263081), // Rule ID 13755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11026:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13755,
        GIR_EraseRootFromParent_Done,
      // Label 17653: @1263081
      GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1263180), // Rule ID 13756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13756,
        GIR_EraseRootFromParent_Done,
      // Label 17654: @1263180
      GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1263279), // Rule ID 13757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13757,
        GIR_EraseRootFromParent_Done,
      // Label 17655: @1263279
      GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1263378), // Rule ID 13758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13758,
        GIR_EraseRootFromParent_Done,
      // Label 17656: @1263378
      GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1263477), // Rule ID 13759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13759,
        GIR_EraseRootFromParent_Done,
      // Label 17657: @1263477
      GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1263576), // Rule ID 13760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13760,
        GIR_EraseRootFromParent_Done,
      // Label 17658: @1263576
      GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1263675), // Rule ID 13761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13761,
        GIR_EraseRootFromParent_Done,
      // Label 17659: @1263675
      GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1263774), // Rule ID 13762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13762,
        GIR_EraseRootFromParent_Done,
      // Label 17660: @1263774
      GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1263873), // Rule ID 13763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13763,
        GIR_EraseRootFromParent_Done,
      // Label 17661: @1263873
      GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1263972), // Rule ID 13764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13764,
        GIR_EraseRootFromParent_Done,
      // Label 17662: @1263972
      GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1264071), // Rule ID 13765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13765,
        GIR_EraseRootFromParent_Done,
      // Label 17663: @1264071
      GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1264170), // Rule ID 13766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13766,
        GIR_EraseRootFromParent_Done,
      // Label 17664: @1264170
      GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1264269), // Rule ID 13767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13767,
        GIR_EraseRootFromParent_Done,
      // Label 17665: @1264269
      GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1264368), // Rule ID 13768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13768,
        GIR_EraseRootFromParent_Done,
      // Label 17666: @1264368
      GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1264467), // Rule ID 13769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13769,
        GIR_EraseRootFromParent_Done,
      // Label 17667: @1264467
      GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1264566), // Rule ID 13770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13770,
        GIR_EraseRootFromParent_Done,
      // Label 17668: @1264566
      GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1264665), // Rule ID 13771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13771,
        GIR_EraseRootFromParent_Done,
      // Label 17669: @1264665
      GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1264764), // Rule ID 13772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13772,
        GIR_EraseRootFromParent_Done,
      // Label 17670: @1264764
      GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1264863), // Rule ID 13773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13773,
        GIR_EraseRootFromParent_Done,
      // Label 17671: @1264863
      GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1264962), // Rule ID 13774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13774,
        GIR_EraseRootFromParent_Done,
      // Label 17672: @1264962
      GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1265061), // Rule ID 13775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13775,
        GIR_EraseRootFromParent_Done,
      // Label 17673: @1265061
      GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1265160), // Rule ID 13776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13776,
        GIR_EraseRootFromParent_Done,
      // Label 17674: @1265160
      GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1265259), // Rule ID 13777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13777,
        GIR_EraseRootFromParent_Done,
      // Label 17675: @1265259
      GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1265358), // Rule ID 13778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13778,
        GIR_EraseRootFromParent_Done,
      // Label 17676: @1265358
      GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1265457), // Rule ID 13779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13779,
        GIR_EraseRootFromParent_Done,
      // Label 17677: @1265457
      GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1265556), // Rule ID 13780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13780,
        GIR_EraseRootFromParent_Done,
      // Label 17678: @1265556
      GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1265655), // Rule ID 13781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13781,
        GIR_EraseRootFromParent_Done,
      // Label 17679: @1265655
      GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1265754), // Rule ID 13782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13782,
        GIR_EraseRootFromParent_Done,
      // Label 17680: @1265754
      GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1265853), // Rule ID 13783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13783,
        GIR_EraseRootFromParent_Done,
      // Label 17681: @1265853
      GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1265952), // Rule ID 13784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13784,
        GIR_EraseRootFromParent_Done,
      // Label 17682: @1265952
      GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1266051), // Rule ID 13785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13785,
        GIR_EraseRootFromParent_Done,
      // Label 17683: @1266051
      GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1266150), // Rule ID 19624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19624,
        GIR_EraseRootFromParent_Done,
      // Label 17684: @1266150
      GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1266249), // Rule ID 19625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19625,
        GIR_EraseRootFromParent_Done,
      // Label 17685: @1266249
      GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1266348), // Rule ID 19628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19628,
        GIR_EraseRootFromParent_Done,
      // Label 17686: @1266348
      GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1266447), // Rule ID 19629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19629,
        GIR_EraseRootFromParent_Done,
      // Label 17687: @1266447
      GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1266546), // Rule ID 19632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19632,
        GIR_EraseRootFromParent_Done,
      // Label 17688: @1266546
      GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1266645), // Rule ID 19633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19633,
        GIR_EraseRootFromParent_Done,
      // Label 17689: @1266645
      GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1266744), // Rule ID 19636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19636,
        GIR_EraseRootFromParent_Done,
      // Label 17690: @1266744
      GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1266843), // Rule ID 19637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19637,
        GIR_EraseRootFromParent_Done,
      // Label 17691: @1266843
      GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1266942), // Rule ID 19640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19640,
        GIR_EraseRootFromParent_Done,
      // Label 17692: @1266942
      GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1267041), // Rule ID 19641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19641,
        GIR_EraseRootFromParent_Done,
      // Label 17693: @1267041
      GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1267140), // Rule ID 19644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19644,
        GIR_EraseRootFromParent_Done,
      // Label 17694: @1267140
      GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1267239), // Rule ID 19645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19645,
        GIR_EraseRootFromParent_Done,
      // Label 17695: @1267239
      GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1267338), // Rule ID 19648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19648,
        GIR_EraseRootFromParent_Done,
      // Label 17696: @1267338
      GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1267437), // Rule ID 19649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19649,
        GIR_EraseRootFromParent_Done,
      // Label 17697: @1267437
      GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1267536), // Rule ID 19652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19652,
        GIR_EraseRootFromParent_Done,
      // Label 17698: @1267536
      GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1267635), // Rule ID 19653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19653,
        GIR_EraseRootFromParent_Done,
      // Label 17699: @1267635
      GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1267734), // Rule ID 19656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19656,
        GIR_EraseRootFromParent_Done,
      // Label 17700: @1267734
      GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1267833), // Rule ID 19657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19657,
        GIR_EraseRootFromParent_Done,
      // Label 17701: @1267833
      GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1267932), // Rule ID 19660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19660,
        GIR_EraseRootFromParent_Done,
      // Label 17702: @1267932
      GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1268031), // Rule ID 19661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19661,
        GIR_EraseRootFromParent_Done,
      // Label 17703: @1268031
      GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1268130), // Rule ID 19664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19664,
        GIR_EraseRootFromParent_Done,
      // Label 17704: @1268130
      GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1268229), // Rule ID 19665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19665,
        GIR_EraseRootFromParent_Done,
      // Label 17705: @1268229
      GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1268328), // Rule ID 19668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19668,
        GIR_EraseRootFromParent_Done,
      // Label 17706: @1268328
      GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1268427), // Rule ID 19669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19669,
        GIR_EraseRootFromParent_Done,
      // Label 17707: @1268427
      GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1268526), // Rule ID 19672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19672,
        GIR_EraseRootFromParent_Done,
      // Label 17708: @1268526
      GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1268625), // Rule ID 19673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19673,
        GIR_EraseRootFromParent_Done,
      // Label 17709: @1268625
      GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1268724), // Rule ID 19676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19676,
        GIR_EraseRootFromParent_Done,
      // Label 17710: @1268724
      GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1268823), // Rule ID 19677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19677,
        GIR_EraseRootFromParent_Done,
      // Label 17711: @1268823
      GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1268922), // Rule ID 19680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19680,
        GIR_EraseRootFromParent_Done,
      // Label 17712: @1268922
      GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1269021), // Rule ID 19681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19681,
        GIR_EraseRootFromParent_Done,
      // Label 17713: @1269021
      GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1269120), // Rule ID 19684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19684,
        GIR_EraseRootFromParent_Done,
      // Label 17714: @1269120
      GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1269219), // Rule ID 19685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19685,
        GIR_EraseRootFromParent_Done,
      // Label 17715: @1269219
      GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1269318), // Rule ID 19688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19688,
        GIR_EraseRootFromParent_Done,
      // Label 17716: @1269318
      GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1269417), // Rule ID 19689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19689,
        GIR_EraseRootFromParent_Done,
      // Label 17717: @1269417
      GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1269516), // Rule ID 19692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19692,
        GIR_EraseRootFromParent_Done,
      // Label 17718: @1269516
      GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1269615), // Rule ID 19693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19693,
        GIR_EraseRootFromParent_Done,
      // Label 17719: @1269615
      GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1269714), // Rule ID 19696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19696,
        GIR_EraseRootFromParent_Done,
      // Label 17720: @1269714
      GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1269813), // Rule ID 19697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19697,
        GIR_EraseRootFromParent_Done,
      // Label 17721: @1269813
      GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1269912), // Rule ID 19700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19700,
        GIR_EraseRootFromParent_Done,
      // Label 17722: @1269912
      GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1270011), // Rule ID 19701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19701,
        GIR_EraseRootFromParent_Done,
      // Label 17723: @1270011
      GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1270110), // Rule ID 19704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19704,
        GIR_EraseRootFromParent_Done,
      // Label 17724: @1270110
      GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1270209), // Rule ID 19705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19705,
        GIR_EraseRootFromParent_Done,
      // Label 17725: @1270209
      GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1270308), // Rule ID 19708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19708,
        GIR_EraseRootFromParent_Done,
      // Label 17726: @1270308
      GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1270407), // Rule ID 19709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19709,
        GIR_EraseRootFromParent_Done,
      // Label 17727: @1270407
      GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1270506), // Rule ID 19712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19712,
        GIR_EraseRootFromParent_Done,
      // Label 17728: @1270506
      GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1270605), // Rule ID 19713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19713,
        GIR_EraseRootFromParent_Done,
      // Label 17729: @1270605
      GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1270704), // Rule ID 19716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19716,
        GIR_EraseRootFromParent_Done,
      // Label 17730: @1270704
      GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1270803), // Rule ID 19717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19717,
        GIR_EraseRootFromParent_Done,
      // Label 17731: @1270803
      GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1270902), // Rule ID 19720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19720,
        GIR_EraseRootFromParent_Done,
      // Label 17732: @1270902
      GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1271001), // Rule ID 19721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19721,
        GIR_EraseRootFromParent_Done,
      // Label 17733: @1271001
      GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1271100), // Rule ID 19724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19724,
        GIR_EraseRootFromParent_Done,
      // Label 17734: @1271100
      GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1271199), // Rule ID 19725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19725,
        GIR_EraseRootFromParent_Done,
      // Label 17735: @1271199
      GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1271298), // Rule ID 19728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19728,
        GIR_EraseRootFromParent_Done,
      // Label 17736: @1271298
      GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1271397), // Rule ID 19729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19729,
        GIR_EraseRootFromParent_Done,
      // Label 17737: @1271397
      GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1271496), // Rule ID 19732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19732,
        GIR_EraseRootFromParent_Done,
      // Label 17738: @1271496
      GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1271595), // Rule ID 19733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19733,
        GIR_EraseRootFromParent_Done,
      // Label 17739: @1271595
      GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1271694), // Rule ID 19736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19736,
        GIR_EraseRootFromParent_Done,
      // Label 17740: @1271694
      GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1271793), // Rule ID 19737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19737,
        GIR_EraseRootFromParent_Done,
      // Label 17741: @1271793
      GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1271892), // Rule ID 19740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19740,
        GIR_EraseRootFromParent_Done,
      // Label 17742: @1271892
      GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1271991), // Rule ID 19741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19741,
        GIR_EraseRootFromParent_Done,
      // Label 17743: @1271991
      GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1272090), // Rule ID 19744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19744,
        GIR_EraseRootFromParent_Done,
      // Label 17744: @1272090
      GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1272189), // Rule ID 19745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19745,
        GIR_EraseRootFromParent_Done,
      // Label 17745: @1272189
      GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1272288), // Rule ID 19748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19748,
        GIR_EraseRootFromParent_Done,
      // Label 17746: @1272288
      GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1272387), // Rule ID 19749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19749,
        GIR_EraseRootFromParent_Done,
      // Label 17747: @1272387
      GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1272486), // Rule ID 19752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19752,
        GIR_EraseRootFromParent_Done,
      // Label 17748: @1272486
      GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1272585), // Rule ID 19753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19753,
        GIR_EraseRootFromParent_Done,
      // Label 17749: @1272585
      GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1272684), // Rule ID 19756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19756,
        GIR_EraseRootFromParent_Done,
      // Label 17750: @1272684
      GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1272783), // Rule ID 19757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19757,
        GIR_EraseRootFromParent_Done,
      // Label 17751: @1272783
      GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1272882), // Rule ID 19760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19760,
        GIR_EraseRootFromParent_Done,
      // Label 17752: @1272882
      GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1272981), // Rule ID 19761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19761,
        GIR_EraseRootFromParent_Done,
      // Label 17753: @1272981
      GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1273080), // Rule ID 19764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19764,
        GIR_EraseRootFromParent_Done,
      // Label 17754: @1273080
      GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1273179), // Rule ID 19765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19765,
        GIR_EraseRootFromParent_Done,
      // Label 17755: @1273179
      GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1273278), // Rule ID 19768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19768,
        GIR_EraseRootFromParent_Done,
      // Label 17756: @1273278
      GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1273377), // Rule ID 19769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19769,
        GIR_EraseRootFromParent_Done,
      // Label 17757: @1273377
      GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1273476), // Rule ID 19772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19772,
        GIR_EraseRootFromParent_Done,
      // Label 17758: @1273476
      GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1273575), // Rule ID 19773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19773,
        GIR_EraseRootFromParent_Done,
      // Label 17759: @1273575
      GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1273674), // Rule ID 19776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19776,
        GIR_EraseRootFromParent_Done,
      // Label 17760: @1273674
      GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1273773), // Rule ID 19777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19777,
        GIR_EraseRootFromParent_Done,
      // Label 17761: @1273773
      GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1273872), // Rule ID 19780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19780,
        GIR_EraseRootFromParent_Done,
      // Label 17762: @1273872
      GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1273971), // Rule ID 19781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19781,
        GIR_EraseRootFromParent_Done,
      // Label 17763: @1273971
      GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1274070), // Rule ID 19784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19784,
        GIR_EraseRootFromParent_Done,
      // Label 17764: @1274070
      GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1274169), // Rule ID 19785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19785,
        GIR_EraseRootFromParent_Done,
      // Label 17765: @1274169
      GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1274268), // Rule ID 19788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19788,
        GIR_EraseRootFromParent_Done,
      // Label 17766: @1274268
      GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1274367), // Rule ID 19789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19789,
        GIR_EraseRootFromParent_Done,
      // Label 17767: @1274367
      GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1274466), // Rule ID 19792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19792,
        GIR_EraseRootFromParent_Done,
      // Label 17768: @1274466
      GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1274565), // Rule ID 19793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19793,
        GIR_EraseRootFromParent_Done,
      // Label 17769: @1274565
      GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1274664), // Rule ID 19796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19796,
        GIR_EraseRootFromParent_Done,
      // Label 17770: @1274664
      GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1274763), // Rule ID 19797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19797,
        GIR_EraseRootFromParent_Done,
      // Label 17771: @1274763
      GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1274862), // Rule ID 19800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19800,
        GIR_EraseRootFromParent_Done,
      // Label 17772: @1274862
      GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1274961), // Rule ID 19801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19801,
        GIR_EraseRootFromParent_Done,
      // Label 17773: @1274961
      GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1275060), // Rule ID 19804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19804,
        GIR_EraseRootFromParent_Done,
      // Label 17774: @1275060
      GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1275159), // Rule ID 19805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19805,
        GIR_EraseRootFromParent_Done,
      // Label 17775: @1275159
      GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1275258), // Rule ID 19808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19808,
        GIR_EraseRootFromParent_Done,
      // Label 17776: @1275258
      GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1275357), // Rule ID 19809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19809,
        GIR_EraseRootFromParent_Done,
      // Label 17777: @1275357
      GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1275456), // Rule ID 19812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19812,
        GIR_EraseRootFromParent_Done,
      // Label 17778: @1275456
      GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1275555), // Rule ID 19813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19813,
        GIR_EraseRootFromParent_Done,
      // Label 17779: @1275555
      GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1275654), // Rule ID 19816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19816,
        GIR_EraseRootFromParent_Done,
      // Label 17780: @1275654
      GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1275753), // Rule ID 19817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19817,
        GIR_EraseRootFromParent_Done,
      // Label 17781: @1275753
      GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1275852), // Rule ID 19820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19820,
        GIR_EraseRootFromParent_Done,
      // Label 17782: @1275852
      GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1275951), // Rule ID 19821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19821,
        GIR_EraseRootFromParent_Done,
      // Label 17783: @1275951
      GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1276050), // Rule ID 19824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19824,
        GIR_EraseRootFromParent_Done,
      // Label 17784: @1276050
      GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1276149), // Rule ID 19825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19825,
        GIR_EraseRootFromParent_Done,
      // Label 17785: @1276149
      GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1276248), // Rule ID 19828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19828,
        GIR_EraseRootFromParent_Done,
      // Label 17786: @1276248
      GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1276347), // Rule ID 19829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19829,
        GIR_EraseRootFromParent_Done,
      // Label 17787: @1276347
      GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1276446), // Rule ID 19832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19832,
        GIR_EraseRootFromParent_Done,
      // Label 17788: @1276446
      GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1276545), // Rule ID 19833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19833,
        GIR_EraseRootFromParent_Done,
      // Label 17789: @1276545
      GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1276644), // Rule ID 19836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19836,
        GIR_EraseRootFromParent_Done,
      // Label 17790: @1276644
      GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1276743), // Rule ID 19837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19837,
        GIR_EraseRootFromParent_Done,
      // Label 17791: @1276743
      GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1276842), // Rule ID 19840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19840,
        GIR_EraseRootFromParent_Done,
      // Label 17792: @1276842
      GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1276941), // Rule ID 19841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19841,
        GIR_EraseRootFromParent_Done,
      // Label 17793: @1276941
      GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1277040), // Rule ID 19844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19844,
        GIR_EraseRootFromParent_Done,
      // Label 17794: @1277040
      GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1277139), // Rule ID 19845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19845,
        GIR_EraseRootFromParent_Done,
      // Label 17795: @1277139
      GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1277238), // Rule ID 19848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19848,
        GIR_EraseRootFromParent_Done,
      // Label 17796: @1277238
      GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1277337), // Rule ID 19849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19849,
        GIR_EraseRootFromParent_Done,
      // Label 17797: @1277337
      GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1277436), // Rule ID 19852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19852,
        GIR_EraseRootFromParent_Done,
      // Label 17798: @1277436
      GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1277535), // Rule ID 19853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19853,
        GIR_EraseRootFromParent_Done,
      // Label 17799: @1277535
      GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1277634), // Rule ID 19856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19856,
        GIR_EraseRootFromParent_Done,
      // Label 17800: @1277634
      GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1277733), // Rule ID 19857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19857,
        GIR_EraseRootFromParent_Done,
      // Label 17801: @1277733
      GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1277832), // Rule ID 19860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19860,
        GIR_EraseRootFromParent_Done,
      // Label 17802: @1277832
      GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1277931), // Rule ID 19861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11034:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19861,
        GIR_EraseRootFromParent_Done,
      // Label 17803: @1277931
      GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1278030), // Rule ID 19864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19864,
        GIR_EraseRootFromParent_Done,
      // Label 17804: @1278030
      GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1278129), // Rule ID 19865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19865,
        GIR_EraseRootFromParent_Done,
      // Label 17805: @1278129
      GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1278228), // Rule ID 19868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19868,
        GIR_EraseRootFromParent_Done,
      // Label 17806: @1278228
      GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1278327), // Rule ID 19869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19869,
        GIR_EraseRootFromParent_Done,
      // Label 17807: @1278327
      GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1278426), // Rule ID 19872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19872,
        GIR_EraseRootFromParent_Done,
      // Label 17808: @1278426
      GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1278525), // Rule ID 19873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19873,
        GIR_EraseRootFromParent_Done,
      // Label 17809: @1278525
      GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1278624), // Rule ID 19876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19876,
        GIR_EraseRootFromParent_Done,
      // Label 17810: @1278624
      GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1278723), // Rule ID 19877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19877,
        GIR_EraseRootFromParent_Done,
      // Label 17811: @1278723
      GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1278822), // Rule ID 19880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19880,
        GIR_EraseRootFromParent_Done,
      // Label 17812: @1278822
      GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1278921), // Rule ID 19881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19881,
        GIR_EraseRootFromParent_Done,
      // Label 17813: @1278921
      GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1279020), // Rule ID 19884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19884,
        GIR_EraseRootFromParent_Done,
      // Label 17814: @1279020
      GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1279119), // Rule ID 19885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19885,
        GIR_EraseRootFromParent_Done,
      // Label 17815: @1279119
      GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1279218), // Rule ID 19888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19888,
        GIR_EraseRootFromParent_Done,
      // Label 17816: @1279218
      GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1279317), // Rule ID 19889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19889,
        GIR_EraseRootFromParent_Done,
      // Label 17817: @1279317
      GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1279416), // Rule ID 19892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19892,
        GIR_EraseRootFromParent_Done,
      // Label 17818: @1279416
      GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1279515), // Rule ID 19893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19893,
        GIR_EraseRootFromParent_Done,
      // Label 17819: @1279515
      GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1279614), // Rule ID 19896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19896,
        GIR_EraseRootFromParent_Done,
      // Label 17820: @1279614
      GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1279713), // Rule ID 19897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19897,
        GIR_EraseRootFromParent_Done,
      // Label 17821: @1279713
      GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1279812), // Rule ID 19900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19900,
        GIR_EraseRootFromParent_Done,
      // Label 17822: @1279812
      GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1279911), // Rule ID 19901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19901,
        GIR_EraseRootFromParent_Done,
      // Label 17823: @1279911
      GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1280010), // Rule ID 19904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19904,
        GIR_EraseRootFromParent_Done,
      // Label 17824: @1280010
      GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1280109), // Rule ID 19905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19905,
        GIR_EraseRootFromParent_Done,
      // Label 17825: @1280109
      GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1280208), // Rule ID 19908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19908,
        GIR_EraseRootFromParent_Done,
      // Label 17826: @1280208
      GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1280307), // Rule ID 19909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19909,
        GIR_EraseRootFromParent_Done,
      // Label 17827: @1280307
      GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1280406), // Rule ID 19912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19912,
        GIR_EraseRootFromParent_Done,
      // Label 17828: @1280406
      GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1280505), // Rule ID 19913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19913,
        GIR_EraseRootFromParent_Done,
      // Label 17829: @1280505
      GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1280604), // Rule ID 19916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19916,
        GIR_EraseRootFromParent_Done,
      // Label 17830: @1280604
      GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1280703), // Rule ID 19917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19917,
        GIR_EraseRootFromParent_Done,
      // Label 17831: @1280703
      GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1280802), // Rule ID 19920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19920,
        GIR_EraseRootFromParent_Done,
      // Label 17832: @1280802
      GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1280901), // Rule ID 19921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19921,
        GIR_EraseRootFromParent_Done,
      // Label 17833: @1280901
      GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1281000), // Rule ID 19924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19924,
        GIR_EraseRootFromParent_Done,
      // Label 17834: @1281000
      GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1281099), // Rule ID 19925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19925,
        GIR_EraseRootFromParent_Done,
      // Label 17835: @1281099
      GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1281198), // Rule ID 19928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19928,
        GIR_EraseRootFromParent_Done,
      // Label 17836: @1281198
      GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1281297), // Rule ID 19929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19929,
        GIR_EraseRootFromParent_Done,
      // Label 17837: @1281297
      GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1281396), // Rule ID 19932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19932,
        GIR_EraseRootFromParent_Done,
      // Label 17838: @1281396
      GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1281495), // Rule ID 19933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19933,
        GIR_EraseRootFromParent_Done,
      // Label 17839: @1281495
      GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1281594), // Rule ID 19936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19936,
        GIR_EraseRootFromParent_Done,
      // Label 17840: @1281594
      GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1281693), // Rule ID 19937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19937,
        GIR_EraseRootFromParent_Done,
      // Label 17841: @1281693
      GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1281792), // Rule ID 19940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19940,
        GIR_EraseRootFromParent_Done,
      // Label 17842: @1281792
      GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1281891), // Rule ID 19941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19941,
        GIR_EraseRootFromParent_Done,
      // Label 17843: @1281891
      GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1281990), // Rule ID 19944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19944,
        GIR_EraseRootFromParent_Done,
      // Label 17844: @1281990
      GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1282089), // Rule ID 19945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19945,
        GIR_EraseRootFromParent_Done,
      // Label 17845: @1282089
      GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1282188), // Rule ID 19948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19948,
        GIR_EraseRootFromParent_Done,
      // Label 17846: @1282188
      GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1282287), // Rule ID 19949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19949,
        GIR_EraseRootFromParent_Done,
      // Label 17847: @1282287
      GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1282386), // Rule ID 19952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19952,
        GIR_EraseRootFromParent_Done,
      // Label 17848: @1282386
      GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1282485), // Rule ID 19953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19953,
        GIR_EraseRootFromParent_Done,
      // Label 17849: @1282485
      GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1282584), // Rule ID 19956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19956,
        GIR_EraseRootFromParent_Done,
      // Label 17850: @1282584
      GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1282683), // Rule ID 19957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19957,
        GIR_EraseRootFromParent_Done,
      // Label 17851: @1282683
      GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1282782), // Rule ID 19960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19960,
        GIR_EraseRootFromParent_Done,
      // Label 17852: @1282782
      GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1282881), // Rule ID 19961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19961,
        GIR_EraseRootFromParent_Done,
      // Label 17853: @1282881
      GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1282980), // Rule ID 19964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19964,
        GIR_EraseRootFromParent_Done,
      // Label 17854: @1282980
      GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1283079), // Rule ID 19965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19965,
        GIR_EraseRootFromParent_Done,
      // Label 17855: @1283079
      GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1283178), // Rule ID 19968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19968,
        GIR_EraseRootFromParent_Done,
      // Label 17856: @1283178
      GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1283277), // Rule ID 19969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19969,
        GIR_EraseRootFromParent_Done,
      // Label 17857: @1283277
      GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1283376), // Rule ID 19972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19972,
        GIR_EraseRootFromParent_Done,
      // Label 17858: @1283376
      GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1283475), // Rule ID 19973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19973,
        GIR_EraseRootFromParent_Done,
      // Label 17859: @1283475
      GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1283574), // Rule ID 19976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19976,
        GIR_EraseRootFromParent_Done,
      // Label 17860: @1283574
      GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1283673), // Rule ID 19977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19977,
        GIR_EraseRootFromParent_Done,
      // Label 17861: @1283673
      GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1283772), // Rule ID 19980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19980,
        GIR_EraseRootFromParent_Done,
      // Label 17862: @1283772
      GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1283871), // Rule ID 19981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19981,
        GIR_EraseRootFromParent_Done,
      // Label 17863: @1283871
      GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1283970), // Rule ID 19984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19984,
        GIR_EraseRootFromParent_Done,
      // Label 17864: @1283970
      GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1284069), // Rule ID 19985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19985,
        GIR_EraseRootFromParent_Done,
      // Label 17865: @1284069
      GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1284168), // Rule ID 19988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19988,
        GIR_EraseRootFromParent_Done,
      // Label 17866: @1284168
      GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1284267), // Rule ID 19989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19989,
        GIR_EraseRootFromParent_Done,
      // Label 17867: @1284267
      GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1284366), // Rule ID 19992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19992,
        GIR_EraseRootFromParent_Done,
      // Label 17868: @1284366
      GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1284465), // Rule ID 19993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19993,
        GIR_EraseRootFromParent_Done,
      // Label 17869: @1284465
      GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1284564), // Rule ID 19996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19996,
        GIR_EraseRootFromParent_Done,
      // Label 17870: @1284564
      GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1284663), // Rule ID 19997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19997,
        GIR_EraseRootFromParent_Done,
      // Label 17871: @1284663
      GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1284762), // Rule ID 20000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20000,
        GIR_EraseRootFromParent_Done,
      // Label 17872: @1284762
      GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1284861), // Rule ID 20001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20001,
        GIR_EraseRootFromParent_Done,
      // Label 17873: @1284861
      GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1284960), // Rule ID 20004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20004,
        GIR_EraseRootFromParent_Done,
      // Label 17874: @1284960
      GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1285059), // Rule ID 20005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20005,
        GIR_EraseRootFromParent_Done,
      // Label 17875: @1285059
      GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1285158), // Rule ID 20008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20008,
        GIR_EraseRootFromParent_Done,
      // Label 17876: @1285158
      GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1285257), // Rule ID 20009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20009,
        GIR_EraseRootFromParent_Done,
      // Label 17877: @1285257
      GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1285356), // Rule ID 20012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20012,
        GIR_EraseRootFromParent_Done,
      // Label 17878: @1285356
      GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1285455), // Rule ID 20013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20013,
        GIR_EraseRootFromParent_Done,
      // Label 17879: @1285455
      GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1285554), // Rule ID 20016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20016,
        GIR_EraseRootFromParent_Done,
      // Label 17880: @1285554
      GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1285653), // Rule ID 20017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20017,
        GIR_EraseRootFromParent_Done,
      // Label 17881: @1285653
      GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1285752), // Rule ID 20020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20020,
        GIR_EraseRootFromParent_Done,
      // Label 17882: @1285752
      GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1285851), // Rule ID 20021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20021,
        GIR_EraseRootFromParent_Done,
      // Label 17883: @1285851
      GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1285950), // Rule ID 20024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20024,
        GIR_EraseRootFromParent_Done,
      // Label 17884: @1285950
      GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1286049), // Rule ID 20025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20025,
        GIR_EraseRootFromParent_Done,
      // Label 17885: @1286049
      GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1286148), // Rule ID 20028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20028,
        GIR_EraseRootFromParent_Done,
      // Label 17886: @1286148
      GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1286247), // Rule ID 20029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20029,
        GIR_EraseRootFromParent_Done,
      // Label 17887: @1286247
      GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1286346), // Rule ID 20032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20032,
        GIR_EraseRootFromParent_Done,
      // Label 17888: @1286346
      GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1286445), // Rule ID 20033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20033,
        GIR_EraseRootFromParent_Done,
      // Label 17889: @1286445
      GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1286544), // Rule ID 20036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20036,
        GIR_EraseRootFromParent_Done,
      // Label 17890: @1286544
      GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1286643), // Rule ID 20037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20037,
        GIR_EraseRootFromParent_Done,
      // Label 17891: @1286643
      GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1286742), // Rule ID 20040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20040,
        GIR_EraseRootFromParent_Done,
      // Label 17892: @1286742
      GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1286841), // Rule ID 20041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20041,
        GIR_EraseRootFromParent_Done,
      // Label 17893: @1286841
      GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1286940), // Rule ID 20044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20044,
        GIR_EraseRootFromParent_Done,
      // Label 17894: @1286940
      GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1287039), // Rule ID 20045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20045,
        GIR_EraseRootFromParent_Done,
      // Label 17895: @1287039
      GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1287138), // Rule ID 20048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20048,
        GIR_EraseRootFromParent_Done,
      // Label 17896: @1287138
      GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1287237), // Rule ID 20049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20049,
        GIR_EraseRootFromParent_Done,
      // Label 17897: @1287237
      GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1287336), // Rule ID 20052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20052,
        GIR_EraseRootFromParent_Done,
      // Label 17898: @1287336
      GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1287435), // Rule ID 20053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20053,
        GIR_EraseRootFromParent_Done,
      // Label 17899: @1287435
      GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1287534), // Rule ID 20056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20056,
        GIR_EraseRootFromParent_Done,
      // Label 17900: @1287534
      GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1287633), // Rule ID 20057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20057,
        GIR_EraseRootFromParent_Done,
      // Label 17901: @1287633
      GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1287732), // Rule ID 20060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20060,
        GIR_EraseRootFromParent_Done,
      // Label 17902: @1287732
      GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1287831), // Rule ID 20061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20061,
        GIR_EraseRootFromParent_Done,
      // Label 17903: @1287831
      GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1287930), // Rule ID 20064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20064,
        GIR_EraseRootFromParent_Done,
      // Label 17904: @1287930
      GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1288029), // Rule ID 20065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20065,
        GIR_EraseRootFromParent_Done,
      // Label 17905: @1288029
      GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1288128), // Rule ID 20068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20068,
        GIR_EraseRootFromParent_Done,
      // Label 17906: @1288128
      GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1288227), // Rule ID 20069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20069,
        GIR_EraseRootFromParent_Done,
      // Label 17907: @1288227
      GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1288326), // Rule ID 20072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20072,
        GIR_EraseRootFromParent_Done,
      // Label 17908: @1288326
      GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1288425), // Rule ID 20073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20073,
        GIR_EraseRootFromParent_Done,
      // Label 17909: @1288425
      GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1288524), // Rule ID 20076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20076,
        GIR_EraseRootFromParent_Done,
      // Label 17910: @1288524
      GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1288623), // Rule ID 20077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20077,
        GIR_EraseRootFromParent_Done,
      // Label 17911: @1288623
      GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1288722), // Rule ID 20080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20080,
        GIR_EraseRootFromParent_Done,
      // Label 17912: @1288722
      GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1288821), // Rule ID 20081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20081,
        GIR_EraseRootFromParent_Done,
      // Label 17913: @1288821
      GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1288920), // Rule ID 20084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20084,
        GIR_EraseRootFromParent_Done,
      // Label 17914: @1288920
      GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1289019), // Rule ID 20085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20085,
        GIR_EraseRootFromParent_Done,
      // Label 17915: @1289019
      GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1289118), // Rule ID 20088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20088,
        GIR_EraseRootFromParent_Done,
      // Label 17916: @1289118
      GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1289217), // Rule ID 20089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20089,
        GIR_EraseRootFromParent_Done,
      // Label 17917: @1289217
      GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1289316), // Rule ID 20092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20092,
        GIR_EraseRootFromParent_Done,
      // Label 17918: @1289316
      GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1289415), // Rule ID 20093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20093,
        GIR_EraseRootFromParent_Done,
      // Label 17919: @1289415
      GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1289514), // Rule ID 20096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20096,
        GIR_EraseRootFromParent_Done,
      // Label 17920: @1289514
      GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1289613), // Rule ID 20097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20097,
        GIR_EraseRootFromParent_Done,
      // Label 17921: @1289613
      GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1289712), // Rule ID 20100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20100,
        GIR_EraseRootFromParent_Done,
      // Label 17922: @1289712
      GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1289811), // Rule ID 20101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20101,
        GIR_EraseRootFromParent_Done,
      // Label 17923: @1289811
      GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1289910), // Rule ID 20104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20104,
        GIR_EraseRootFromParent_Done,
      // Label 17924: @1289910
      GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1290009), // Rule ID 20105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20105,
        GIR_EraseRootFromParent_Done,
      // Label 17925: @1290009
      GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1290108), // Rule ID 20108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20108,
        GIR_EraseRootFromParent_Done,
      // Label 17926: @1290108
      GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1290207), // Rule ID 20109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20109,
        GIR_EraseRootFromParent_Done,
      // Label 17927: @1290207
      GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1290306), // Rule ID 20112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20112,
        GIR_EraseRootFromParent_Done,
      // Label 17928: @1290306
      GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1290405), // Rule ID 20113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20113,
        GIR_EraseRootFromParent_Done,
      // Label 17929: @1290405
      GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1290504), // Rule ID 20116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20116,
        GIR_EraseRootFromParent_Done,
      // Label 17930: @1290504
      GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1290603), // Rule ID 20117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20117,
        GIR_EraseRootFromParent_Done,
      // Label 17931: @1290603
      GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1290702), // Rule ID 20120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20120,
        GIR_EraseRootFromParent_Done,
      // Label 17932: @1290702
      GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1290801), // Rule ID 20121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20121,
        GIR_EraseRootFromParent_Done,
      // Label 17933: @1290801
      GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1290900), // Rule ID 20124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20124,
        GIR_EraseRootFromParent_Done,
      // Label 17934: @1290900
      GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1290999), // Rule ID 20125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20125,
        GIR_EraseRootFromParent_Done,
      // Label 17935: @1290999
      GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1291098), // Rule ID 20128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20128,
        GIR_EraseRootFromParent_Done,
      // Label 17936: @1291098
      GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1291197), // Rule ID 20129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20129,
        GIR_EraseRootFromParent_Done,
      // Label 17937: @1291197
      GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1291296), // Rule ID 20132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20132,
        GIR_EraseRootFromParent_Done,
      // Label 17938: @1291296
      GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1291395), // Rule ID 20133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20133,
        GIR_EraseRootFromParent_Done,
      // Label 17939: @1291395
      GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1291494), // Rule ID 20136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20136,
        GIR_EraseRootFromParent_Done,
      // Label 17940: @1291494
      GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1291593), // Rule ID 20137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20137,
        GIR_EraseRootFromParent_Done,
      // Label 17941: @1291593
      GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1291692), // Rule ID 20140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20140,
        GIR_EraseRootFromParent_Done,
      // Label 17942: @1291692
      GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1291791), // Rule ID 20141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20141,
        GIR_EraseRootFromParent_Done,
      // Label 17943: @1291791
      GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1291890), // Rule ID 20144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20144,
        GIR_EraseRootFromParent_Done,
      // Label 17944: @1291890
      GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1291989), // Rule ID 20145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20145,
        GIR_EraseRootFromParent_Done,
      // Label 17945: @1291989
      GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1292088), // Rule ID 20148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20148,
        GIR_EraseRootFromParent_Done,
      // Label 17946: @1292088
      GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1292187), // Rule ID 20149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20149,
        GIR_EraseRootFromParent_Done,
      // Label 17947: @1292187
      GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1292286), // Rule ID 20152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20152,
        GIR_EraseRootFromParent_Done,
      // Label 17948: @1292286
      GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1292385), // Rule ID 20153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20153,
        GIR_EraseRootFromParent_Done,
      // Label 17949: @1292385
      GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1292484), // Rule ID 20156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20156,
        GIR_EraseRootFromParent_Done,
      // Label 17950: @1292484
      GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1292583), // Rule ID 20157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20157,
        GIR_EraseRootFromParent_Done,
      // Label 17951: @1292583
      GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1292682), // Rule ID 20160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20160,
        GIR_EraseRootFromParent_Done,
      // Label 17952: @1292682
      GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1292781), // Rule ID 20161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20161,
        GIR_EraseRootFromParent_Done,
      // Label 17953: @1292781
      GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1292880), // Rule ID 20164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20164,
        GIR_EraseRootFromParent_Done,
      // Label 17954: @1292880
      GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1292979), // Rule ID 20165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20165,
        GIR_EraseRootFromParent_Done,
      // Label 17955: @1292979
      GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1293078), // Rule ID 20168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20168,
        GIR_EraseRootFromParent_Done,
      // Label 17956: @1293078
      GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1293177), // Rule ID 20169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20169,
        GIR_EraseRootFromParent_Done,
      // Label 17957: @1293177
      GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1293276), // Rule ID 20172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20172,
        GIR_EraseRootFromParent_Done,
      // Label 17958: @1293276
      GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1293375), // Rule ID 20173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20173,
        GIR_EraseRootFromParent_Done,
      // Label 17959: @1293375
      GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1293474), // Rule ID 20176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20176,
        GIR_EraseRootFromParent_Done,
      // Label 17960: @1293474
      GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1293573), // Rule ID 20177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20177,
        GIR_EraseRootFromParent_Done,
      // Label 17961: @1293573
      GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1293672), // Rule ID 20180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20180,
        GIR_EraseRootFromParent_Done,
      // Label 17962: @1293672
      GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1293771), // Rule ID 20181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20181,
        GIR_EraseRootFromParent_Done,
      // Label 17963: @1293771
      GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1293870), // Rule ID 20184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20184,
        GIR_EraseRootFromParent_Done,
      // Label 17964: @1293870
      GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1293969), // Rule ID 20185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20185,
        GIR_EraseRootFromParent_Done,
      // Label 17965: @1293969
      GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1294068), // Rule ID 20188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20188,
        GIR_EraseRootFromParent_Done,
      // Label 17966: @1294068
      GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1294167), // Rule ID 20189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20189,
        GIR_EraseRootFromParent_Done,
      // Label 17967: @1294167
      GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1294266), // Rule ID 20192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20192,
        GIR_EraseRootFromParent_Done,
      // Label 17968: @1294266
      GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1294365), // Rule ID 20193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20193,
        GIR_EraseRootFromParent_Done,
      // Label 17969: @1294365
      GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1294464), // Rule ID 20196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20196,
        GIR_EraseRootFromParent_Done,
      // Label 17970: @1294464
      GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1294563), // Rule ID 20197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20197,
        GIR_EraseRootFromParent_Done,
      // Label 17971: @1294563
      GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1294662), // Rule ID 20200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20200,
        GIR_EraseRootFromParent_Done,
      // Label 17972: @1294662
      GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1294761), // Rule ID 20201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20201,
        GIR_EraseRootFromParent_Done,
      // Label 17973: @1294761
      GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1294860), // Rule ID 20204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20204,
        GIR_EraseRootFromParent_Done,
      // Label 17974: @1294860
      GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1294959), // Rule ID 20205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20205,
        GIR_EraseRootFromParent_Done,
      // Label 17975: @1294959
      GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1295058), // Rule ID 20208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20208,
        GIR_EraseRootFromParent_Done,
      // Label 17976: @1295058
      GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1295157), // Rule ID 20209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20209,
        GIR_EraseRootFromParent_Done,
      // Label 17977: @1295157
      GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1295256), // Rule ID 20212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20212,
        GIR_EraseRootFromParent_Done,
      // Label 17978: @1295256
      GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1295355), // Rule ID 20213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20213,
        GIR_EraseRootFromParent_Done,
      // Label 17979: @1295355
      GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1295454), // Rule ID 20216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20216,
        GIR_EraseRootFromParent_Done,
      // Label 17980: @1295454
      GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1295553), // Rule ID 20217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20217,
        GIR_EraseRootFromParent_Done,
      // Label 17981: @1295553
      GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1295652), // Rule ID 20220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20220,
        GIR_EraseRootFromParent_Done,
      // Label 17982: @1295652
      GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1295751), // Rule ID 20221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20221,
        GIR_EraseRootFromParent_Done,
      // Label 17983: @1295751
      GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1295850), // Rule ID 20224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20224,
        GIR_EraseRootFromParent_Done,
      // Label 17984: @1295850
      GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1295949), // Rule ID 20225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20225,
        GIR_EraseRootFromParent_Done,
      // Label 17985: @1295949
      GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1296048), // Rule ID 20228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20228,
        GIR_EraseRootFromParent_Done,
      // Label 17986: @1296048
      GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1296147), // Rule ID 20229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20229,
        GIR_EraseRootFromParent_Done,
      // Label 17987: @1296147
      GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1296246), // Rule ID 20232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20232,
        GIR_EraseRootFromParent_Done,
      // Label 17988: @1296246
      GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1296345), // Rule ID 20233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20233,
        GIR_EraseRootFromParent_Done,
      // Label 17989: @1296345
      GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1296444), // Rule ID 20236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20236,
        GIR_EraseRootFromParent_Done,
      // Label 17990: @1296444
      GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1296543), // Rule ID 20237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20237,
        GIR_EraseRootFromParent_Done,
      // Label 17991: @1296543
      GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1296642), // Rule ID 20240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20240,
        GIR_EraseRootFromParent_Done,
      // Label 17992: @1296642
      GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1296741), // Rule ID 20241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20241,
        GIR_EraseRootFromParent_Done,
      // Label 17993: @1296741
      GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1296840), // Rule ID 20244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20244,
        GIR_EraseRootFromParent_Done,
      // Label 17994: @1296840
      GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1296939), // Rule ID 20245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20245,
        GIR_EraseRootFromParent_Done,
      // Label 17995: @1296939
      GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1297038), // Rule ID 20248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20248,
        GIR_EraseRootFromParent_Done,
      // Label 17996: @1297038
      GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1297137), // Rule ID 20249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20249,
        GIR_EraseRootFromParent_Done,
      // Label 17997: @1297137
      GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1297236), // Rule ID 20252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20252,
        GIR_EraseRootFromParent_Done,
      // Label 17998: @1297236
      GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1297335), // Rule ID 20253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20253,
        GIR_EraseRootFromParent_Done,
      // Label 17999: @1297335
      GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1297434), // Rule ID 20256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20256,
        GIR_EraseRootFromParent_Done,
      // Label 18000: @1297434
      GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1297533), // Rule ID 20257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20257,
        GIR_EraseRootFromParent_Done,
      // Label 18001: @1297533
      GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1297632), // Rule ID 20260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20260,
        GIR_EraseRootFromParent_Done,
      // Label 18002: @1297632
      GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1297731), // Rule ID 20261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20261,
        GIR_EraseRootFromParent_Done,
      // Label 18003: @1297731
      GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1297830), // Rule ID 20264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20264,
        GIR_EraseRootFromParent_Done,
      // Label 18004: @1297830
      GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1297929), // Rule ID 20265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20265,
        GIR_EraseRootFromParent_Done,
      // Label 18005: @1297929
      GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1298028), // Rule ID 20268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20268,
        GIR_EraseRootFromParent_Done,
      // Label 18006: @1298028
      GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1298127), // Rule ID 20269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20269,
        GIR_EraseRootFromParent_Done,
      // Label 18007: @1298127
      GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1298226), // Rule ID 20272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20272,
        GIR_EraseRootFromParent_Done,
      // Label 18008: @1298226
      GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1298325), // Rule ID 20273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20273,
        GIR_EraseRootFromParent_Done,
      // Label 18009: @1298325
      GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1298424), // Rule ID 20276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20276,
        GIR_EraseRootFromParent_Done,
      // Label 18010: @1298424
      GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1298523), // Rule ID 20277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20277,
        GIR_EraseRootFromParent_Done,
      // Label 18011: @1298523
      GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1298622), // Rule ID 20280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20280,
        GIR_EraseRootFromParent_Done,
      // Label 18012: @1298622
      GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1298721), // Rule ID 20281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11032:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20281,
        GIR_EraseRootFromParent_Done,
      // Label 18013: @1298721
      GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1298820), // Rule ID 20284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20284,
        GIR_EraseRootFromParent_Done,
      // Label 18014: @1298820
      GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1298919), // Rule ID 20285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20285,
        GIR_EraseRootFromParent_Done,
      // Label 18015: @1298919
      GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1299018), // Rule ID 20288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20288,
        GIR_EraseRootFromParent_Done,
      // Label 18016: @1299018
      GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1299117), // Rule ID 20289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20289,
        GIR_EraseRootFromParent_Done,
      // Label 18017: @1299117
      GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1299216), // Rule ID 20292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20292,
        GIR_EraseRootFromParent_Done,
      // Label 18018: @1299216
      GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1299315), // Rule ID 20293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20293,
        GIR_EraseRootFromParent_Done,
      // Label 18019: @1299315
      GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1299414), // Rule ID 20296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20296,
        GIR_EraseRootFromParent_Done,
      // Label 18020: @1299414
      GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1299513), // Rule ID 20297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20297,
        GIR_EraseRootFromParent_Done,
      // Label 18021: @1299513
      GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1299612), // Rule ID 20300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20300,
        GIR_EraseRootFromParent_Done,
      // Label 18022: @1299612
      GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1299711), // Rule ID 20301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20301,
        GIR_EraseRootFromParent_Done,
      // Label 18023: @1299711
      GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1299810), // Rule ID 20304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20304,
        GIR_EraseRootFromParent_Done,
      // Label 18024: @1299810
      GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1299909), // Rule ID 20305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20305,
        GIR_EraseRootFromParent_Done,
      // Label 18025: @1299909
      GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1300008), // Rule ID 20308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20308,
        GIR_EraseRootFromParent_Done,
      // Label 18026: @1300008
      GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1300107), // Rule ID 20309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20309,
        GIR_EraseRootFromParent_Done,
      // Label 18027: @1300107
      GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1300206), // Rule ID 20312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20312,
        GIR_EraseRootFromParent_Done,
      // Label 18028: @1300206
      GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1300305), // Rule ID 20313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20313,
        GIR_EraseRootFromParent_Done,
      // Label 18029: @1300305
      GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1300404), // Rule ID 20316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20316,
        GIR_EraseRootFromParent_Done,
      // Label 18030: @1300404
      GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1300503), // Rule ID 20317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20317,
        GIR_EraseRootFromParent_Done,
      // Label 18031: @1300503
      GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1300602), // Rule ID 20320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20320,
        GIR_EraseRootFromParent_Done,
      // Label 18032: @1300602
      GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1300701), // Rule ID 20321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20321,
        GIR_EraseRootFromParent_Done,
      // Label 18033: @1300701
      GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1300800), // Rule ID 20324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20324,
        GIR_EraseRootFromParent_Done,
      // Label 18034: @1300800
      GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1300899), // Rule ID 20325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20325,
        GIR_EraseRootFromParent_Done,
      // Label 18035: @1300899
      GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1300998), // Rule ID 20328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20328,
        GIR_EraseRootFromParent_Done,
      // Label 18036: @1300998
      GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1301097), // Rule ID 20329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20329,
        GIR_EraseRootFromParent_Done,
      // Label 18037: @1301097
      GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1301196), // Rule ID 20332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20332,
        GIR_EraseRootFromParent_Done,
      // Label 18038: @1301196
      GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1301295), // Rule ID 20333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20333,
        GIR_EraseRootFromParent_Done,
      // Label 18039: @1301295
      GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1301394), // Rule ID 20336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20336,
        GIR_EraseRootFromParent_Done,
      // Label 18040: @1301394
      GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1301493), // Rule ID 20337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20337,
        GIR_EraseRootFromParent_Done,
      // Label 18041: @1301493
      GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1301592), // Rule ID 20340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20340,
        GIR_EraseRootFromParent_Done,
      // Label 18042: @1301592
      GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1301691), // Rule ID 20341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20341,
        GIR_EraseRootFromParent_Done,
      // Label 18043: @1301691
      GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1301790), // Rule ID 20398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20398,
        GIR_EraseRootFromParent_Done,
      // Label 18044: @1301790
      GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1301889), // Rule ID 20399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20399,
        GIR_EraseRootFromParent_Done,
      // Label 18045: @1301889
      GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1301988), // Rule ID 20400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20400,
        GIR_EraseRootFromParent_Done,
      // Label 18046: @1301988
      GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1302087), // Rule ID 20401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20401,
        GIR_EraseRootFromParent_Done,
      // Label 18047: @1302087
      GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1302186), // Rule ID 20402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20402,
        GIR_EraseRootFromParent_Done,
      // Label 18048: @1302186
      GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1302285), // Rule ID 20403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20403,
        GIR_EraseRootFromParent_Done,
      // Label 18049: @1302285
      GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1302384), // Rule ID 20404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10818:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20404,
        GIR_EraseRootFromParent_Done,
      // Label 18050: @1302384
      GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1302483), // Rule ID 20405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10818:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20405,
        GIR_EraseRootFromParent_Done,
      // Label 18051: @1302483
      GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1302582), // Rule ID 20406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20406,
        GIR_EraseRootFromParent_Done,
      // Label 18052: @1302582
      GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1302681), // Rule ID 20407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20407,
        GIR_EraseRootFromParent_Done,
      // Label 18053: @1302681
      GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1302780), // Rule ID 20408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20408,
        GIR_EraseRootFromParent_Done,
      // Label 18054: @1302780
      GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1302879), // Rule ID 20409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20409,
        GIR_EraseRootFromParent_Done,
      // Label 18055: @1302879
      GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1302978), // Rule ID 20410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20410,
        GIR_EraseRootFromParent_Done,
      // Label 18056: @1302978
      GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1303077), // Rule ID 20411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11026:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20411,
        GIR_EraseRootFromParent_Done,
      // Label 18057: @1303077
      GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1303176), // Rule ID 20412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10818:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20412,
        GIR_EraseRootFromParent_Done,
      // Label 18058: @1303176
      GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1303275), // Rule ID 20413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10818:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20413,
        GIR_EraseRootFromParent_Done,
      // Label 18059: @1303275
      GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1303374), // Rule ID 20414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20414,
        GIR_EraseRootFromParent_Done,
      // Label 18060: @1303374
      GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1303473), // Rule ID 20415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20415,
        GIR_EraseRootFromParent_Done,
      // Label 18061: @1303473
      GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1303572), // Rule ID 20416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20416,
        GIR_EraseRootFromParent_Done,
      // Label 18062: @1303572
      GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1303671), // Rule ID 20417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10818:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20417,
        GIR_EraseRootFromParent_Done,
      // Label 18063: @1303671
      GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1303770), // Rule ID 20418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20418,
        GIR_EraseRootFromParent_Done,
      // Label 18064: @1303770
      GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1303869), // Rule ID 20419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20419,
        GIR_EraseRootFromParent_Done,
      // Label 18065: @1303869
      GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1303968), // Rule ID 20420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20420,
        GIR_EraseRootFromParent_Done,
      // Label 18066: @1303968
      GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1304067), // Rule ID 20421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10818:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20421,
        GIR_EraseRootFromParent_Done,
      // Label 18067: @1304067
      GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1304166), // Rule ID 20422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20422,
        GIR_EraseRootFromParent_Done,
      // Label 18068: @1304166
      GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1304265), // Rule ID 20423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20423,
        GIR_EraseRootFromParent_Done,
      // Label 18069: @1304265
      GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1304364), // Rule ID 20424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20424,
        GIR_EraseRootFromParent_Done,
      // Label 18070: @1304364
      GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1304463), // Rule ID 20425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20425,
        GIR_EraseRootFromParent_Done,
      // Label 18071: @1304463
      GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1304562), // Rule ID 20426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20426,
        GIR_EraseRootFromParent_Done,
      // Label 18072: @1304562
      GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1304661), // Rule ID 20427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20427,
        GIR_EraseRootFromParent_Done,
      // Label 18073: @1304661
      GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1304760), // Rule ID 20428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20428,
        GIR_EraseRootFromParent_Done,
      // Label 18074: @1304760
      GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1304859), // Rule ID 20429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20429,
        GIR_EraseRootFromParent_Done,
      // Label 18075: @1304859
      GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1304958), // Rule ID 20430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20430,
        GIR_EraseRootFromParent_Done,
      // Label 18076: @1304958
      GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1305057), // Rule ID 20431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20431,
        GIR_EraseRootFromParent_Done,
      // Label 18077: @1305057
      GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1305156), // Rule ID 20432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20432,
        GIR_EraseRootFromParent_Done,
      // Label 18078: @1305156
      GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1305255), // Rule ID 20433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20433,
        GIR_EraseRootFromParent_Done,
      // Label 18079: @1305255
      GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1305354), // Rule ID 20434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20434,
        GIR_EraseRootFromParent_Done,
      // Label 18080: @1305354
      GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1305453), // Rule ID 20435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20435,
        GIR_EraseRootFromParent_Done,
      // Label 18081: @1305453
      GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1305552), // Rule ID 20436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20436,
        GIR_EraseRootFromParent_Done,
      // Label 18082: @1305552
      GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1305651), // Rule ID 20437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20437,
        GIR_EraseRootFromParent_Done,
      // Label 18083: @1305651
      GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1305750), // Rule ID 20438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20438,
        GIR_EraseRootFromParent_Done,
      // Label 18084: @1305750
      GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1305849), // Rule ID 20439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20439,
        GIR_EraseRootFromParent_Done,
      // Label 18085: @1305849
      GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1305948), // Rule ID 20440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20440,
        GIR_EraseRootFromParent_Done,
      // Label 18086: @1305948
      GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1306047), // Rule ID 20441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20441,
        GIR_EraseRootFromParent_Done,
      // Label 18087: @1306047
      GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1306146), // Rule ID 20442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20442,
        GIR_EraseRootFromParent_Done,
      // Label 18088: @1306146
      GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1306245), // Rule ID 20443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20443,
        GIR_EraseRootFromParent_Done,
      // Label 18089: @1306245
      GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1306344), // Rule ID 20444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20444,
        GIR_EraseRootFromParent_Done,
      // Label 18090: @1306344
      GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1306443), // Rule ID 20445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20445,
        GIR_EraseRootFromParent_Done,
      // Label 18091: @1306443
      GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1306542), // Rule ID 20446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20446,
        GIR_EraseRootFromParent_Done,
      // Label 18092: @1306542
      GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1306641), // Rule ID 20447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20447,
        GIR_EraseRootFromParent_Done,
      // Label 18093: @1306641
      GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1306740), // Rule ID 20448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20448,
        GIR_EraseRootFromParent_Done,
      // Label 18094: @1306740
      GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1306839), // Rule ID 20449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10818:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20449,
        GIR_EraseRootFromParent_Done,
      // Label 18095: @1306839
      GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1306938), // Rule ID 20450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20450,
        GIR_EraseRootFromParent_Done,
      // Label 18096: @1306938
      GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1307037), // Rule ID 20451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20451,
        GIR_EraseRootFromParent_Done,
      // Label 18097: @1307037
      GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1307136), // Rule ID 20452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20452,
        GIR_EraseRootFromParent_Done,
      // Label 18098: @1307136
      GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1307235), // Rule ID 20453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10818:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20453,
        GIR_EraseRootFromParent_Done,
      // Label 18099: @1307235
      GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1307334), // Rule ID 20454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20454,
        GIR_EraseRootFromParent_Done,
      // Label 18100: @1307334
      GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1307433), // Rule ID 20455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20455,
        GIR_EraseRootFromParent_Done,
      // Label 18101: @1307433
      GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1307532), // Rule ID 20456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20456,
        GIR_EraseRootFromParent_Done,
      // Label 18102: @1307532
      GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1307631), // Rule ID 20457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10818:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20457,
        GIR_EraseRootFromParent_Done,
      // Label 18103: @1307631
      GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1307733), // Rule ID 21838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21838,
        GIR_EraseRootFromParent_Done,
      // Label 18104: @1307733
      GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1307835), // Rule ID 21839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21839,
        GIR_EraseRootFromParent_Done,
      // Label 18105: @1307835
      GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1307937), // Rule ID 21842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21842,
        GIR_EraseRootFromParent_Done,
      // Label 18106: @1307937
      GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1308039), // Rule ID 21843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21843,
        GIR_EraseRootFromParent_Done,
      // Label 18107: @1308039
      GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1308141), // Rule ID 21846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21846,
        GIR_EraseRootFromParent_Done,
      // Label 18108: @1308141
      GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1308243), // Rule ID 21847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21847,
        GIR_EraseRootFromParent_Done,
      // Label 18109: @1308243
      GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1308345), // Rule ID 21850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21850,
        GIR_EraseRootFromParent_Done,
      // Label 18110: @1308345
      GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1308447), // Rule ID 21851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21851,
        GIR_EraseRootFromParent_Done,
      // Label 18111: @1308447
      GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1308549), // Rule ID 21854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21854,
        GIR_EraseRootFromParent_Done,
      // Label 18112: @1308549
      GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1308651), // Rule ID 21855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21855,
        GIR_EraseRootFromParent_Done,
      // Label 18113: @1308651
      GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1308753), // Rule ID 21858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21858,
        GIR_EraseRootFromParent_Done,
      // Label 18114: @1308753
      GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1308855), // Rule ID 21859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21859,
        GIR_EraseRootFromParent_Done,
      // Label 18115: @1308855
      GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1308957), // Rule ID 21862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21862,
        GIR_EraseRootFromParent_Done,
      // Label 18116: @1308957
      GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1309059), // Rule ID 21863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21863,
        GIR_EraseRootFromParent_Done,
      // Label 18117: @1309059
      GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1309161), // Rule ID 21866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21866,
        GIR_EraseRootFromParent_Done,
      // Label 18118: @1309161
      GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1309263), // Rule ID 21867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21867,
        GIR_EraseRootFromParent_Done,
      // Label 18119: @1309263
      GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1309365), // Rule ID 21870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21870,
        GIR_EraseRootFromParent_Done,
      // Label 18120: @1309365
      GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1309467), // Rule ID 21871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21871,
        GIR_EraseRootFromParent_Done,
      // Label 18121: @1309467
      GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1309569), // Rule ID 21874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21874,
        GIR_EraseRootFromParent_Done,
      // Label 18122: @1309569
      GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1309671), // Rule ID 21875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21875,
        GIR_EraseRootFromParent_Done,
      // Label 18123: @1309671
      GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1309773), // Rule ID 21878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21878,
        GIR_EraseRootFromParent_Done,
      // Label 18124: @1309773
      GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1309875), // Rule ID 21879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21879,
        GIR_EraseRootFromParent_Done,
      // Label 18125: @1309875
      GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1309977), // Rule ID 21882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21882,
        GIR_EraseRootFromParent_Done,
      // Label 18126: @1309977
      GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1310079), // Rule ID 21883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21883,
        GIR_EraseRootFromParent_Done,
      // Label 18127: @1310079
      GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1310181), // Rule ID 21886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21886,
        GIR_EraseRootFromParent_Done,
      // Label 18128: @1310181
      GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1310283), // Rule ID 21887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21887,
        GIR_EraseRootFromParent_Done,
      // Label 18129: @1310283
      GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1310385), // Rule ID 21890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21890,
        GIR_EraseRootFromParent_Done,
      // Label 18130: @1310385
      GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1310487), // Rule ID 21891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21891,
        GIR_EraseRootFromParent_Done,
      // Label 18131: @1310487
      GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1310589), // Rule ID 21894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21894,
        GIR_EraseRootFromParent_Done,
      // Label 18132: @1310589
      GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1310691), // Rule ID 21895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21895,
        GIR_EraseRootFromParent_Done,
      // Label 18133: @1310691
      GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1310793), // Rule ID 21898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21898,
        GIR_EraseRootFromParent_Done,
      // Label 18134: @1310793
      GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1310895), // Rule ID 21899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21899,
        GIR_EraseRootFromParent_Done,
      // Label 18135: @1310895
      GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1310997), // Rule ID 21902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21902,
        GIR_EraseRootFromParent_Done,
      // Label 18136: @1310997
      GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1311099), // Rule ID 21903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21903,
        GIR_EraseRootFromParent_Done,
      // Label 18137: @1311099
      GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1311201), // Rule ID 21906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21906,
        GIR_EraseRootFromParent_Done,
      // Label 18138: @1311201
      GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1311303), // Rule ID 21907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21907,
        GIR_EraseRootFromParent_Done,
      // Label 18139: @1311303
      GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1311405), // Rule ID 21910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21910,
        GIR_EraseRootFromParent_Done,
      // Label 18140: @1311405
      GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1311507), // Rule ID 21911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21911,
        GIR_EraseRootFromParent_Done,
      // Label 18141: @1311507
      GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1311609), // Rule ID 21914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21914,
        GIR_EraseRootFromParent_Done,
      // Label 18142: @1311609
      GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1311711), // Rule ID 21915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21915,
        GIR_EraseRootFromParent_Done,
      // Label 18143: @1311711
      GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1311813), // Rule ID 21918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21918,
        GIR_EraseRootFromParent_Done,
      // Label 18144: @1311813
      GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1311915), // Rule ID 21919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21919,
        GIR_EraseRootFromParent_Done,
      // Label 18145: @1311915
      GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1312017), // Rule ID 21922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21922,
        GIR_EraseRootFromParent_Done,
      // Label 18146: @1312017
      GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1312119), // Rule ID 21923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21923,
        GIR_EraseRootFromParent_Done,
      // Label 18147: @1312119
      GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1312221), // Rule ID 21926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21926,
        GIR_EraseRootFromParent_Done,
      // Label 18148: @1312221
      GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1312323), // Rule ID 21927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21927,
        GIR_EraseRootFromParent_Done,
      // Label 18149: @1312323
      GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1312425), // Rule ID 21930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21930,
        GIR_EraseRootFromParent_Done,
      // Label 18150: @1312425
      GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1312527), // Rule ID 21931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21931,
        GIR_EraseRootFromParent_Done,
      // Label 18151: @1312527
      GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1312629), // Rule ID 21934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21934,
        GIR_EraseRootFromParent_Done,
      // Label 18152: @1312629
      GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1312731), // Rule ID 21935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21935,
        GIR_EraseRootFromParent_Done,
      // Label 18153: @1312731
      GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1312833), // Rule ID 21938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21938,
        GIR_EraseRootFromParent_Done,
      // Label 18154: @1312833
      GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1312935), // Rule ID 21939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21939,
        GIR_EraseRootFromParent_Done,
      // Label 18155: @1312935
      GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1313037), // Rule ID 21942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21942,
        GIR_EraseRootFromParent_Done,
      // Label 18156: @1313037
      GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1313139), // Rule ID 21943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21943,
        GIR_EraseRootFromParent_Done,
      // Label 18157: @1313139
      GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1313241), // Rule ID 21946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21946,
        GIR_EraseRootFromParent_Done,
      // Label 18158: @1313241
      GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1313343), // Rule ID 21947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21947,
        GIR_EraseRootFromParent_Done,
      // Label 18159: @1313343
      GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1313445), // Rule ID 21950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21950,
        GIR_EraseRootFromParent_Done,
      // Label 18160: @1313445
      GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1313547), // Rule ID 21951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21951,
        GIR_EraseRootFromParent_Done,
      // Label 18161: @1313547
      GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1313649), // Rule ID 21954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21954,
        GIR_EraseRootFromParent_Done,
      // Label 18162: @1313649
      GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1313751), // Rule ID 21955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21955,
        GIR_EraseRootFromParent_Done,
      // Label 18163: @1313751
      GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1313853), // Rule ID 21958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21958,
        GIR_EraseRootFromParent_Done,
      // Label 18164: @1313853
      GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1313955), // Rule ID 21959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21959,
        GIR_EraseRootFromParent_Done,
      // Label 18165: @1313955
      GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1314057), // Rule ID 21962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21962,
        GIR_EraseRootFromParent_Done,
      // Label 18166: @1314057
      GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1314159), // Rule ID 21963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21963,
        GIR_EraseRootFromParent_Done,
      // Label 18167: @1314159
      GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1314261), // Rule ID 21966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21966,
        GIR_EraseRootFromParent_Done,
      // Label 18168: @1314261
      GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1314363), // Rule ID 21967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21967,
        GIR_EraseRootFromParent_Done,
      // Label 18169: @1314363
      GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1314465), // Rule ID 21970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21970,
        GIR_EraseRootFromParent_Done,
      // Label 18170: @1314465
      GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1314567), // Rule ID 21971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21971,
        GIR_EraseRootFromParent_Done,
      // Label 18171: @1314567
      GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1314669), // Rule ID 21974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21974,
        GIR_EraseRootFromParent_Done,
      // Label 18172: @1314669
      GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1314771), // Rule ID 21975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21975,
        GIR_EraseRootFromParent_Done,
      // Label 18173: @1314771
      GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1314873), // Rule ID 21978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21978,
        GIR_EraseRootFromParent_Done,
      // Label 18174: @1314873
      GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1314975), // Rule ID 21979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21979,
        GIR_EraseRootFromParent_Done,
      // Label 18175: @1314975
      GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1315077), // Rule ID 21982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21982,
        GIR_EraseRootFromParent_Done,
      // Label 18176: @1315077
      GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1315179), // Rule ID 21983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21983,
        GIR_EraseRootFromParent_Done,
      // Label 18177: @1315179
      GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1315281), // Rule ID 21986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21986,
        GIR_EraseRootFromParent_Done,
      // Label 18178: @1315281
      GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1315383), // Rule ID 21987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21987,
        GIR_EraseRootFromParent_Done,
      // Label 18179: @1315383
      GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1315485), // Rule ID 21990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21990,
        GIR_EraseRootFromParent_Done,
      // Label 18180: @1315485
      GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1315587), // Rule ID 21991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21991,
        GIR_EraseRootFromParent_Done,
      // Label 18181: @1315587
      GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1315689), // Rule ID 21994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21994,
        GIR_EraseRootFromParent_Done,
      // Label 18182: @1315689
      GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1315791), // Rule ID 21995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21995,
        GIR_EraseRootFromParent_Done,
      // Label 18183: @1315791
      GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1315893), // Rule ID 21998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21998,
        GIR_EraseRootFromParent_Done,
      // Label 18184: @1315893
      GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1315995), // Rule ID 21999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21999,
        GIR_EraseRootFromParent_Done,
      // Label 18185: @1315995
      GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1316097), // Rule ID 22002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22002,
        GIR_EraseRootFromParent_Done,
      // Label 18186: @1316097
      GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1316199), // Rule ID 22003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22003,
        GIR_EraseRootFromParent_Done,
      // Label 18187: @1316199
      GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1316301), // Rule ID 22006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22006,
        GIR_EraseRootFromParent_Done,
      // Label 18188: @1316301
      GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1316403), // Rule ID 22007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22007,
        GIR_EraseRootFromParent_Done,
      // Label 18189: @1316403
      GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1316505), // Rule ID 22010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22010,
        GIR_EraseRootFromParent_Done,
      // Label 18190: @1316505
      GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1316607), // Rule ID 22011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22011,
        GIR_EraseRootFromParent_Done,
      // Label 18191: @1316607
      GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1316709), // Rule ID 22014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22014,
        GIR_EraseRootFromParent_Done,
      // Label 18192: @1316709
      GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1316811), // Rule ID 22015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22015,
        GIR_EraseRootFromParent_Done,
      // Label 18193: @1316811
      GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1316913), // Rule ID 22018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22018,
        GIR_EraseRootFromParent_Done,
      // Label 18194: @1316913
      GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1317015), // Rule ID 22019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22019,
        GIR_EraseRootFromParent_Done,
      // Label 18195: @1317015
      GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1317117), // Rule ID 22022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22022,
        GIR_EraseRootFromParent_Done,
      // Label 18196: @1317117
      GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1317219), // Rule ID 22023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22023,
        GIR_EraseRootFromParent_Done,
      // Label 18197: @1317219
      GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1317321), // Rule ID 22026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22026,
        GIR_EraseRootFromParent_Done,
      // Label 18198: @1317321
      GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1317423), // Rule ID 22027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22027,
        GIR_EraseRootFromParent_Done,
      // Label 18199: @1317423
      GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1317525), // Rule ID 22030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22030,
        GIR_EraseRootFromParent_Done,
      // Label 18200: @1317525
      GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1317627), // Rule ID 22031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22031,
        GIR_EraseRootFromParent_Done,
      // Label 18201: @1317627
      GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1317729), // Rule ID 22034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22034,
        GIR_EraseRootFromParent_Done,
      // Label 18202: @1317729
      GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1317831), // Rule ID 22035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22035,
        GIR_EraseRootFromParent_Done,
      // Label 18203: @1317831
      GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1317933), // Rule ID 22038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22038,
        GIR_EraseRootFromParent_Done,
      // Label 18204: @1317933
      GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1318035), // Rule ID 22039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22039,
        GIR_EraseRootFromParent_Done,
      // Label 18205: @1318035
      GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1318137), // Rule ID 22042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22042,
        GIR_EraseRootFromParent_Done,
      // Label 18206: @1318137
      GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1318239), // Rule ID 22043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22043,
        GIR_EraseRootFromParent_Done,
      // Label 18207: @1318239
      GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1318341), // Rule ID 22046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22046,
        GIR_EraseRootFromParent_Done,
      // Label 18208: @1318341
      GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1318443), // Rule ID 22047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22047,
        GIR_EraseRootFromParent_Done,
      // Label 18209: @1318443
      GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1318545), // Rule ID 22050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22050,
        GIR_EraseRootFromParent_Done,
      // Label 18210: @1318545
      GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1318647), // Rule ID 22051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22051,
        GIR_EraseRootFromParent_Done,
      // Label 18211: @1318647
      GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1318749), // Rule ID 22054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22054,
        GIR_EraseRootFromParent_Done,
      // Label 18212: @1318749
      GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1318851), // Rule ID 22055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22055,
        GIR_EraseRootFromParent_Done,
      // Label 18213: @1318851
      GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1318953), // Rule ID 22058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22058,
        GIR_EraseRootFromParent_Done,
      // Label 18214: @1318953
      GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1319055), // Rule ID 22059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22059,
        GIR_EraseRootFromParent_Done,
      // Label 18215: @1319055
      GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1319157), // Rule ID 22062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22062,
        GIR_EraseRootFromParent_Done,
      // Label 18216: @1319157
      GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1319259), // Rule ID 22063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22063,
        GIR_EraseRootFromParent_Done,
      // Label 18217: @1319259
      GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1319361), // Rule ID 22066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22066,
        GIR_EraseRootFromParent_Done,
      // Label 18218: @1319361
      GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1319463), // Rule ID 22067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22067,
        GIR_EraseRootFromParent_Done,
      // Label 18219: @1319463
      GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1319565), // Rule ID 22070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22070,
        GIR_EraseRootFromParent_Done,
      // Label 18220: @1319565
      GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1319667), // Rule ID 22071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22071,
        GIR_EraseRootFromParent_Done,
      // Label 18221: @1319667
      GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1319769), // Rule ID 22074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22074,
        GIR_EraseRootFromParent_Done,
      // Label 18222: @1319769
      GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1319871), // Rule ID 22075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22075,
        GIR_EraseRootFromParent_Done,
      // Label 18223: @1319871
      GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1319973), // Rule ID 22078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22078,
        GIR_EraseRootFromParent_Done,
      // Label 18224: @1319973
      GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1320075), // Rule ID 22079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22079,
        GIR_EraseRootFromParent_Done,
      // Label 18225: @1320075
      GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1320177), // Rule ID 22082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22082,
        GIR_EraseRootFromParent_Done,
      // Label 18226: @1320177
      GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1320279), // Rule ID 22083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22083,
        GIR_EraseRootFromParent_Done,
      // Label 18227: @1320279
      GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1320381), // Rule ID 22086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22086,
        GIR_EraseRootFromParent_Done,
      // Label 18228: @1320381
      GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1320483), // Rule ID 22087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22087,
        GIR_EraseRootFromParent_Done,
      // Label 18229: @1320483
      GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1320585), // Rule ID 22090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22090,
        GIR_EraseRootFromParent_Done,
      // Label 18230: @1320585
      GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1320687), // Rule ID 22091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22091,
        GIR_EraseRootFromParent_Done,
      // Label 18231: @1320687
      GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1320789), // Rule ID 22094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22094,
        GIR_EraseRootFromParent_Done,
      // Label 18232: @1320789
      GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1320891), // Rule ID 22095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22095,
        GIR_EraseRootFromParent_Done,
      // Label 18233: @1320891
      GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1320993), // Rule ID 22098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22098,
        GIR_EraseRootFromParent_Done,
      // Label 18234: @1320993
      GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1321095), // Rule ID 22099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22099,
        GIR_EraseRootFromParent_Done,
      // Label 18235: @1321095
      GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1321197), // Rule ID 22102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22102,
        GIR_EraseRootFromParent_Done,
      // Label 18236: @1321197
      GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1321299), // Rule ID 22103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22103,
        GIR_EraseRootFromParent_Done,
      // Label 18237: @1321299
      GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1321401), // Rule ID 22106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22106,
        GIR_EraseRootFromParent_Done,
      // Label 18238: @1321401
      GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1321503), // Rule ID 22107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22107,
        GIR_EraseRootFromParent_Done,
      // Label 18239: @1321503
      GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1321605), // Rule ID 22110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22110,
        GIR_EraseRootFromParent_Done,
      // Label 18240: @1321605
      GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1321707), // Rule ID 22111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22111,
        GIR_EraseRootFromParent_Done,
      // Label 18241: @1321707
      GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1321809), // Rule ID 22114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22114,
        GIR_EraseRootFromParent_Done,
      // Label 18242: @1321809
      GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1321911), // Rule ID 22115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22115,
        GIR_EraseRootFromParent_Done,
      // Label 18243: @1321911
      GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1322013), // Rule ID 22118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22118,
        GIR_EraseRootFromParent_Done,
      // Label 18244: @1322013
      GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1322115), // Rule ID 22119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22119,
        GIR_EraseRootFromParent_Done,
      // Label 18245: @1322115
      GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1322217), // Rule ID 22122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22122,
        GIR_EraseRootFromParent_Done,
      // Label 18246: @1322217
      GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1322319), // Rule ID 22123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22123,
        GIR_EraseRootFromParent_Done,
      // Label 18247: @1322319
      GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1322421), // Rule ID 22126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22126,
        GIR_EraseRootFromParent_Done,
      // Label 18248: @1322421
      GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1322523), // Rule ID 22127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22127,
        GIR_EraseRootFromParent_Done,
      // Label 18249: @1322523
      GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1322625), // Rule ID 22130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22130,
        GIR_EraseRootFromParent_Done,
      // Label 18250: @1322625
      GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1322727), // Rule ID 22131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22131,
        GIR_EraseRootFromParent_Done,
      // Label 18251: @1322727
      GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1322829), // Rule ID 22134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22134,
        GIR_EraseRootFromParent_Done,
      // Label 18252: @1322829
      GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1322931), // Rule ID 22135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22135,
        GIR_EraseRootFromParent_Done,
      // Label 18253: @1322931
      GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1323033), // Rule ID 22138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22138,
        GIR_EraseRootFromParent_Done,
      // Label 18254: @1323033
      GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1323135), // Rule ID 22139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22139,
        GIR_EraseRootFromParent_Done,
      // Label 18255: @1323135
      GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1323237), // Rule ID 22142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22142,
        GIR_EraseRootFromParent_Done,
      // Label 18256: @1323237
      GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1323339), // Rule ID 22143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22143,
        GIR_EraseRootFromParent_Done,
      // Label 18257: @1323339
      GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1323441), // Rule ID 22146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22146,
        GIR_EraseRootFromParent_Done,
      // Label 18258: @1323441
      GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1323543), // Rule ID 22147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22147,
        GIR_EraseRootFromParent_Done,
      // Label 18259: @1323543
      GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1323645), // Rule ID 22150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22150,
        GIR_EraseRootFromParent_Done,
      // Label 18260: @1323645
      GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1323747), // Rule ID 22151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22151,
        GIR_EraseRootFromParent_Done,
      // Label 18261: @1323747
      GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1323849), // Rule ID 22154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22154,
        GIR_EraseRootFromParent_Done,
      // Label 18262: @1323849
      GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1323951), // Rule ID 22155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22155,
        GIR_EraseRootFromParent_Done,
      // Label 18263: @1323951
      GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1324053), // Rule ID 22158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22158,
        GIR_EraseRootFromParent_Done,
      // Label 18264: @1324053
      GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1324155), // Rule ID 22159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22159,
        GIR_EraseRootFromParent_Done,
      // Label 18265: @1324155
      GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1324257), // Rule ID 22162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22162,
        GIR_EraseRootFromParent_Done,
      // Label 18266: @1324257
      GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1324359), // Rule ID 22163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22163,
        GIR_EraseRootFromParent_Done,
      // Label 18267: @1324359
      GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1324461), // Rule ID 22166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22166,
        GIR_EraseRootFromParent_Done,
      // Label 18268: @1324461
      GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1324563), // Rule ID 22167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22167,
        GIR_EraseRootFromParent_Done,
      // Label 18269: @1324563
      GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1324665), // Rule ID 22170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22170,
        GIR_EraseRootFromParent_Done,
      // Label 18270: @1324665
      GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1324767), // Rule ID 22171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22171,
        GIR_EraseRootFromParent_Done,
      // Label 18271: @1324767
      GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1324869), // Rule ID 22174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22174,
        GIR_EraseRootFromParent_Done,
      // Label 18272: @1324869
      GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1324971), // Rule ID 22175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22175,
        GIR_EraseRootFromParent_Done,
      // Label 18273: @1324971
      GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1325073), // Rule ID 22178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22178,
        GIR_EraseRootFromParent_Done,
      // Label 18274: @1325073
      GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1325175), // Rule ID 22179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22179,
        GIR_EraseRootFromParent_Done,
      // Label 18275: @1325175
      GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1325277), // Rule ID 22182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22182,
        GIR_EraseRootFromParent_Done,
      // Label 18276: @1325277
      GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1325379), // Rule ID 22183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22183,
        GIR_EraseRootFromParent_Done,
      // Label 18277: @1325379
      GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1325481), // Rule ID 22186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22186,
        GIR_EraseRootFromParent_Done,
      // Label 18278: @1325481
      GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1325583), // Rule ID 22187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22187,
        GIR_EraseRootFromParent_Done,
      // Label 18279: @1325583
      GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1325685), // Rule ID 22190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22190,
        GIR_EraseRootFromParent_Done,
      // Label 18280: @1325685
      GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1325787), // Rule ID 22191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22191,
        GIR_EraseRootFromParent_Done,
      // Label 18281: @1325787
      GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1325889), // Rule ID 22194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22194,
        GIR_EraseRootFromParent_Done,
      // Label 18282: @1325889
      GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1325991), // Rule ID 22195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22195,
        GIR_EraseRootFromParent_Done,
      // Label 18283: @1325991
      GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1326093), // Rule ID 22198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22198,
        GIR_EraseRootFromParent_Done,
      // Label 18284: @1326093
      GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1326195), // Rule ID 22199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22199,
        GIR_EraseRootFromParent_Done,
      // Label 18285: @1326195
      GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1326297), // Rule ID 22202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22202,
        GIR_EraseRootFromParent_Done,
      // Label 18286: @1326297
      GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1326399), // Rule ID 22203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22203,
        GIR_EraseRootFromParent_Done,
      // Label 18287: @1326399
      GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1326501), // Rule ID 22206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22206,
        GIR_EraseRootFromParent_Done,
      // Label 18288: @1326501
      GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1326603), // Rule ID 22207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22207,
        GIR_EraseRootFromParent_Done,
      // Label 18289: @1326603
      GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1326705), // Rule ID 22210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22210,
        GIR_EraseRootFromParent_Done,
      // Label 18290: @1326705
      GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1326807), // Rule ID 22211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22211,
        GIR_EraseRootFromParent_Done,
      // Label 18291: @1326807
      GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1326909), // Rule ID 22214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22214,
        GIR_EraseRootFromParent_Done,
      // Label 18292: @1326909
      GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1327011), // Rule ID 22215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22215,
        GIR_EraseRootFromParent_Done,
      // Label 18293: @1327011
      GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1327113), // Rule ID 22218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22218,
        GIR_EraseRootFromParent_Done,
      // Label 18294: @1327113
      GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1327215), // Rule ID 22219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22219,
        GIR_EraseRootFromParent_Done,
      // Label 18295: @1327215
      GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1327317), // Rule ID 22222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22222,
        GIR_EraseRootFromParent_Done,
      // Label 18296: @1327317
      GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1327419), // Rule ID 22223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22223,
        GIR_EraseRootFromParent_Done,
      // Label 18297: @1327419
      GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1327521), // Rule ID 22226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22226,
        GIR_EraseRootFromParent_Done,
      // Label 18298: @1327521
      GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1327623), // Rule ID 22227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22227,
        GIR_EraseRootFromParent_Done,
      // Label 18299: @1327623
      GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1327725), // Rule ID 22230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22230,
        GIR_EraseRootFromParent_Done,
      // Label 18300: @1327725
      GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1327827), // Rule ID 22231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22231,
        GIR_EraseRootFromParent_Done,
      // Label 18301: @1327827
      GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1327929), // Rule ID 22234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22234,
        GIR_EraseRootFromParent_Done,
      // Label 18302: @1327929
      GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1328031), // Rule ID 22235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22235,
        GIR_EraseRootFromParent_Done,
      // Label 18303: @1328031
      GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1328133), // Rule ID 22238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22238,
        GIR_EraseRootFromParent_Done,
      // Label 18304: @1328133
      GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1328235), // Rule ID 22239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22239,
        GIR_EraseRootFromParent_Done,
      // Label 18305: @1328235
      GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1328337), // Rule ID 22242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22242,
        GIR_EraseRootFromParent_Done,
      // Label 18306: @1328337
      GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1328439), // Rule ID 22243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22243,
        GIR_EraseRootFromParent_Done,
      // Label 18307: @1328439
      GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1328541), // Rule ID 22246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22246,
        GIR_EraseRootFromParent_Done,
      // Label 18308: @1328541
      GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1328643), // Rule ID 22247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22247,
        GIR_EraseRootFromParent_Done,
      // Label 18309: @1328643
      GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1328745), // Rule ID 22250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22250,
        GIR_EraseRootFromParent_Done,
      // Label 18310: @1328745
      GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1328847), // Rule ID 22251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22251,
        GIR_EraseRootFromParent_Done,
      // Label 18311: @1328847
      GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1328949), // Rule ID 22254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22254,
        GIR_EraseRootFromParent_Done,
      // Label 18312: @1328949
      GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1329051), // Rule ID 22255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22255,
        GIR_EraseRootFromParent_Done,
      // Label 18313: @1329051
      GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1329153), // Rule ID 22258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22258,
        GIR_EraseRootFromParent_Done,
      // Label 18314: @1329153
      GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1329255), // Rule ID 22259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22259,
        GIR_EraseRootFromParent_Done,
      // Label 18315: @1329255
      GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1329357), // Rule ID 22262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22262,
        GIR_EraseRootFromParent_Done,
      // Label 18316: @1329357
      GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1329459), // Rule ID 22263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22263,
        GIR_EraseRootFromParent_Done,
      // Label 18317: @1329459
      GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1329561), // Rule ID 22266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22266,
        GIR_EraseRootFromParent_Done,
      // Label 18318: @1329561
      GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1329663), // Rule ID 22267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22267,
        GIR_EraseRootFromParent_Done,
      // Label 18319: @1329663
      GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1329765), // Rule ID 22270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22270,
        GIR_EraseRootFromParent_Done,
      // Label 18320: @1329765
      GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1329867), // Rule ID 22271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22271,
        GIR_EraseRootFromParent_Done,
      // Label 18321: @1329867
      GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1329969), // Rule ID 22274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22274,
        GIR_EraseRootFromParent_Done,
      // Label 18322: @1329969
      GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1330071), // Rule ID 22275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22275,
        GIR_EraseRootFromParent_Done,
      // Label 18323: @1330071
      GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1330173), // Rule ID 22278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22278,
        GIR_EraseRootFromParent_Done,
      // Label 18324: @1330173
      GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1330275), // Rule ID 22279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22279,
        GIR_EraseRootFromParent_Done,
      // Label 18325: @1330275
      GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1330377), // Rule ID 22282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22282,
        GIR_EraseRootFromParent_Done,
      // Label 18326: @1330377
      GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1330479), // Rule ID 22283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22283,
        GIR_EraseRootFromParent_Done,
      // Label 18327: @1330479
      GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1330581), // Rule ID 22286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22286,
        GIR_EraseRootFromParent_Done,
      // Label 18328: @1330581
      GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1330683), // Rule ID 22287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22287,
        GIR_EraseRootFromParent_Done,
      // Label 18329: @1330683
      GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1330785), // Rule ID 22290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22290,
        GIR_EraseRootFromParent_Done,
      // Label 18330: @1330785
      GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1330887), // Rule ID 22291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22291,
        GIR_EraseRootFromParent_Done,
      // Label 18331: @1330887
      GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1330989), // Rule ID 22294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22294,
        GIR_EraseRootFromParent_Done,
      // Label 18332: @1330989
      GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1331091), // Rule ID 22295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22295,
        GIR_EraseRootFromParent_Done,
      // Label 18333: @1331091
      GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1331193), // Rule ID 22298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22298,
        GIR_EraseRootFromParent_Done,
      // Label 18334: @1331193
      GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1331295), // Rule ID 22299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22299,
        GIR_EraseRootFromParent_Done,
      // Label 18335: @1331295
      GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1331397), // Rule ID 22302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22302,
        GIR_EraseRootFromParent_Done,
      // Label 18336: @1331397
      GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1331499), // Rule ID 22303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22303,
        GIR_EraseRootFromParent_Done,
      // Label 18337: @1331499
      GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1331601), // Rule ID 22306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22306,
        GIR_EraseRootFromParent_Done,
      // Label 18338: @1331601
      GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1331703), // Rule ID 22307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22307,
        GIR_EraseRootFromParent_Done,
      // Label 18339: @1331703
      GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1331805), // Rule ID 22310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22310,
        GIR_EraseRootFromParent_Done,
      // Label 18340: @1331805
      GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1331907), // Rule ID 22311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22311,
        GIR_EraseRootFromParent_Done,
      // Label 18341: @1331907
      GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1332009), // Rule ID 22314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22314,
        GIR_EraseRootFromParent_Done,
      // Label 18342: @1332009
      GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1332111), // Rule ID 22315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22315,
        GIR_EraseRootFromParent_Done,
      // Label 18343: @1332111
      GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1332213), // Rule ID 22318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22318,
        GIR_EraseRootFromParent_Done,
      // Label 18344: @1332213
      GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1332315), // Rule ID 22319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22319,
        GIR_EraseRootFromParent_Done,
      // Label 18345: @1332315
      GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1332417), // Rule ID 22322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22322,
        GIR_EraseRootFromParent_Done,
      // Label 18346: @1332417
      GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1332519), // Rule ID 22323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22323,
        GIR_EraseRootFromParent_Done,
      // Label 18347: @1332519
      GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1332621), // Rule ID 22326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22326,
        GIR_EraseRootFromParent_Done,
      // Label 18348: @1332621
      GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1332723), // Rule ID 22327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22327,
        GIR_EraseRootFromParent_Done,
      // Label 18349: @1332723
      GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1332825), // Rule ID 22330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22330,
        GIR_EraseRootFromParent_Done,
      // Label 18350: @1332825
      GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1332927), // Rule ID 22331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22331,
        GIR_EraseRootFromParent_Done,
      // Label 18351: @1332927
      GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1333029), // Rule ID 22334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22334,
        GIR_EraseRootFromParent_Done,
      // Label 18352: @1333029
      GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1333131), // Rule ID 22335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22335,
        GIR_EraseRootFromParent_Done,
      // Label 18353: @1333131
      GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1333233), // Rule ID 22338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22338,
        GIR_EraseRootFromParent_Done,
      // Label 18354: @1333233
      GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1333335), // Rule ID 22339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22339,
        GIR_EraseRootFromParent_Done,
      // Label 18355: @1333335
      GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1333437), // Rule ID 22342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22342,
        GIR_EraseRootFromParent_Done,
      // Label 18356: @1333437
      GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1333539), // Rule ID 22343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22343,
        GIR_EraseRootFromParent_Done,
      // Label 18357: @1333539
      GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1333641), // Rule ID 22346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22346,
        GIR_EraseRootFromParent_Done,
      // Label 18358: @1333641
      GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1333743), // Rule ID 22347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22347,
        GIR_EraseRootFromParent_Done,
      // Label 18359: @1333743
      GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1333845), // Rule ID 22350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22350,
        GIR_EraseRootFromParent_Done,
      // Label 18360: @1333845
      GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1333947), // Rule ID 22351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22351,
        GIR_EraseRootFromParent_Done,
      // Label 18361: @1333947
      GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1334049), // Rule ID 22354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22354,
        GIR_EraseRootFromParent_Done,
      // Label 18362: @1334049
      GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1334151), // Rule ID 22355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22355,
        GIR_EraseRootFromParent_Done,
      // Label 18363: @1334151
      GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1334253), // Rule ID 22358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22358,
        GIR_EraseRootFromParent_Done,
      // Label 18364: @1334253
      GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1334355), // Rule ID 22359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22359,
        GIR_EraseRootFromParent_Done,
      // Label 18365: @1334355
      GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1334457), // Rule ID 22362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22362,
        GIR_EraseRootFromParent_Done,
      // Label 18366: @1334457
      GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1334559), // Rule ID 22363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22363,
        GIR_EraseRootFromParent_Done,
      // Label 18367: @1334559
      GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1334661), // Rule ID 22366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22366,
        GIR_EraseRootFromParent_Done,
      // Label 18368: @1334661
      GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1334763), // Rule ID 22367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22367,
        GIR_EraseRootFromParent_Done,
      // Label 18369: @1334763
      GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1334865), // Rule ID 22370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22370,
        GIR_EraseRootFromParent_Done,
      // Label 18370: @1334865
      GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1334967), // Rule ID 22371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22371,
        GIR_EraseRootFromParent_Done,
      // Label 18371: @1334967
      GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1335069), // Rule ID 22374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22374,
        GIR_EraseRootFromParent_Done,
      // Label 18372: @1335069
      GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1335171), // Rule ID 22375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22375,
        GIR_EraseRootFromParent_Done,
      // Label 18373: @1335171
      GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1335273), // Rule ID 22378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22378,
        GIR_EraseRootFromParent_Done,
      // Label 18374: @1335273
      GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1335375), // Rule ID 22379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22379,
        GIR_EraseRootFromParent_Done,
      // Label 18375: @1335375
      GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1335477), // Rule ID 22382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22382,
        GIR_EraseRootFromParent_Done,
      // Label 18376: @1335477
      GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1335579), // Rule ID 22383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22383,
        GIR_EraseRootFromParent_Done,
      // Label 18377: @1335579
      GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1335681), // Rule ID 22386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22386,
        GIR_EraseRootFromParent_Done,
      // Label 18378: @1335681
      GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1335783), // Rule ID 22387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22387,
        GIR_EraseRootFromParent_Done,
      // Label 18379: @1335783
      GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1335885), // Rule ID 22390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22390,
        GIR_EraseRootFromParent_Done,
      // Label 18380: @1335885
      GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1335987), // Rule ID 22391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22391,
        GIR_EraseRootFromParent_Done,
      // Label 18381: @1335987
      GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1336089), // Rule ID 22394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22394,
        GIR_EraseRootFromParent_Done,
      // Label 18382: @1336089
      GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1336191), // Rule ID 22395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22395,
        GIR_EraseRootFromParent_Done,
      // Label 18383: @1336191
      GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1336293), // Rule ID 22398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22398,
        GIR_EraseRootFromParent_Done,
      // Label 18384: @1336293
      GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1336395), // Rule ID 22399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22399,
        GIR_EraseRootFromParent_Done,
      // Label 18385: @1336395
      GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1336497), // Rule ID 22402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22402,
        GIR_EraseRootFromParent_Done,
      // Label 18386: @1336497
      GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1336599), // Rule ID 22403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22403,
        GIR_EraseRootFromParent_Done,
      // Label 18387: @1336599
      GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1336701), // Rule ID 22406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22406,
        GIR_EraseRootFromParent_Done,
      // Label 18388: @1336701
      GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1336803), // Rule ID 22407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22407,
        GIR_EraseRootFromParent_Done,
      // Label 18389: @1336803
      GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1336905), // Rule ID 22410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22410,
        GIR_EraseRootFromParent_Done,
      // Label 18390: @1336905
      GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1337007), // Rule ID 22411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22411,
        GIR_EraseRootFromParent_Done,
      // Label 18391: @1337007
      GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1337109), // Rule ID 22414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22414,
        GIR_EraseRootFromParent_Done,
      // Label 18392: @1337109
      GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1337211), // Rule ID 22415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22415,
        GIR_EraseRootFromParent_Done,
      // Label 18393: @1337211
      GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1337313), // Rule ID 22418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22418,
        GIR_EraseRootFromParent_Done,
      // Label 18394: @1337313
      GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1337415), // Rule ID 22419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22419,
        GIR_EraseRootFromParent_Done,
      // Label 18395: @1337415
      GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1337517), // Rule ID 22422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22422,
        GIR_EraseRootFromParent_Done,
      // Label 18396: @1337517
      GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1337619), // Rule ID 22423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22423,
        GIR_EraseRootFromParent_Done,
      // Label 18397: @1337619
      GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1337721), // Rule ID 22426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22426,
        GIR_EraseRootFromParent_Done,
      // Label 18398: @1337721
      GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1337823), // Rule ID 22427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22427,
        GIR_EraseRootFromParent_Done,
      // Label 18399: @1337823
      GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1337925), // Rule ID 22430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22430,
        GIR_EraseRootFromParent_Done,
      // Label 18400: @1337925
      GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1338027), // Rule ID 22431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22431,
        GIR_EraseRootFromParent_Done,
      // Label 18401: @1338027
      GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1338129), // Rule ID 22434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22434,
        GIR_EraseRootFromParent_Done,
      // Label 18402: @1338129
      GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1338231), // Rule ID 22435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22435,
        GIR_EraseRootFromParent_Done,
      // Label 18403: @1338231
      GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1338333), // Rule ID 22438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22438,
        GIR_EraseRootFromParent_Done,
      // Label 18404: @1338333
      GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1338435), // Rule ID 22439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22439,
        GIR_EraseRootFromParent_Done,
      // Label 18405: @1338435
      GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1338537), // Rule ID 22442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22442,
        GIR_EraseRootFromParent_Done,
      // Label 18406: @1338537
      GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1338639), // Rule ID 22443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22443,
        GIR_EraseRootFromParent_Done,
      // Label 18407: @1338639
      GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1338741), // Rule ID 22446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22446,
        GIR_EraseRootFromParent_Done,
      // Label 18408: @1338741
      GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1338843), // Rule ID 22447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22447,
        GIR_EraseRootFromParent_Done,
      // Label 18409: @1338843
      GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1338945), // Rule ID 22450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22450,
        GIR_EraseRootFromParent_Done,
      // Label 18410: @1338945
      GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1339047), // Rule ID 22451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22451,
        GIR_EraseRootFromParent_Done,
      // Label 18411: @1339047
      GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1339149), // Rule ID 22454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22454,
        GIR_EraseRootFromParent_Done,
      // Label 18412: @1339149
      GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1339251), // Rule ID 22455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22455,
        GIR_EraseRootFromParent_Done,
      // Label 18413: @1339251
      GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1339353), // Rule ID 22458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22458,
        GIR_EraseRootFromParent_Done,
      // Label 18414: @1339353
      GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1339455), // Rule ID 22459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22459,
        GIR_EraseRootFromParent_Done,
      // Label 18415: @1339455
      GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1339557), // Rule ID 22462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22462,
        GIR_EraseRootFromParent_Done,
      // Label 18416: @1339557
      GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1339659), // Rule ID 22463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22463,
        GIR_EraseRootFromParent_Done,
      // Label 18417: @1339659
      GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1339761), // Rule ID 22466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22466,
        GIR_EraseRootFromParent_Done,
      // Label 18418: @1339761
      GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1339863), // Rule ID 22467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22467,
        GIR_EraseRootFromParent_Done,
      // Label 18419: @1339863
      GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1339965), // Rule ID 22470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22470,
        GIR_EraseRootFromParent_Done,
      // Label 18420: @1339965
      GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1340067), // Rule ID 22471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22471,
        GIR_EraseRootFromParent_Done,
      // Label 18421: @1340067
      GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1340169), // Rule ID 22474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22474,
        GIR_EraseRootFromParent_Done,
      // Label 18422: @1340169
      GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1340271), // Rule ID 22475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22475,
        GIR_EraseRootFromParent_Done,
      // Label 18423: @1340271
      GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1340373), // Rule ID 22478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22478,
        GIR_EraseRootFromParent_Done,
      // Label 18424: @1340373
      GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1340475), // Rule ID 22479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22479,
        GIR_EraseRootFromParent_Done,
      // Label 18425: @1340475
      GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1340577), // Rule ID 22482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22482,
        GIR_EraseRootFromParent_Done,
      // Label 18426: @1340577
      GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1340679), // Rule ID 22483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22483,
        GIR_EraseRootFromParent_Done,
      // Label 18427: @1340679
      GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1340781), // Rule ID 22486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22486,
        GIR_EraseRootFromParent_Done,
      // Label 18428: @1340781
      GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1340883), // Rule ID 22487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22487,
        GIR_EraseRootFromParent_Done,
      // Label 18429: @1340883
      GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1340985), // Rule ID 22490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22490,
        GIR_EraseRootFromParent_Done,
      // Label 18430: @1340985
      GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1341087), // Rule ID 22491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22491,
        GIR_EraseRootFromParent_Done,
      // Label 18431: @1341087
      GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1341189), // Rule ID 22494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22494,
        GIR_EraseRootFromParent_Done,
      // Label 18432: @1341189
      GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1341291), // Rule ID 22495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22495,
        GIR_EraseRootFromParent_Done,
      // Label 18433: @1341291
      GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1341393), // Rule ID 22498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22498,
        GIR_EraseRootFromParent_Done,
      // Label 18434: @1341393
      GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1341495), // Rule ID 22499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22499,
        GIR_EraseRootFromParent_Done,
      // Label 18435: @1341495
      GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1341597), // Rule ID 22502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22502,
        GIR_EraseRootFromParent_Done,
      // Label 18436: @1341597
      GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1341699), // Rule ID 22503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22503,
        GIR_EraseRootFromParent_Done,
      // Label 18437: @1341699
      GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1341801), // Rule ID 22506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22506,
        GIR_EraseRootFromParent_Done,
      // Label 18438: @1341801
      GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1341903), // Rule ID 22507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22507,
        GIR_EraseRootFromParent_Done,
      // Label 18439: @1341903
      GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1342005), // Rule ID 22510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22510,
        GIR_EraseRootFromParent_Done,
      // Label 18440: @1342005
      GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1342107), // Rule ID 22511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22511,
        GIR_EraseRootFromParent_Done,
      // Label 18441: @1342107
      GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1342209), // Rule ID 22514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22514,
        GIR_EraseRootFromParent_Done,
      // Label 18442: @1342209
      GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1342311), // Rule ID 22515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22515,
        GIR_EraseRootFromParent_Done,
      // Label 18443: @1342311
      GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1342413), // Rule ID 22518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22518,
        GIR_EraseRootFromParent_Done,
      // Label 18444: @1342413
      GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1342515), // Rule ID 22519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22519,
        GIR_EraseRootFromParent_Done,
      // Label 18445: @1342515
      GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1342617), // Rule ID 22522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22522,
        GIR_EraseRootFromParent_Done,
      // Label 18446: @1342617
      GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1342719), // Rule ID 22523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22523,
        GIR_EraseRootFromParent_Done,
      // Label 18447: @1342719
      GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1342821), // Rule ID 22526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22526,
        GIR_EraseRootFromParent_Done,
      // Label 18448: @1342821
      GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1342923), // Rule ID 22527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22527,
        GIR_EraseRootFromParent_Done,
      // Label 18449: @1342923
      GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1343025), // Rule ID 22530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22530,
        GIR_EraseRootFromParent_Done,
      // Label 18450: @1343025
      GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1343127), // Rule ID 22531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22531,
        GIR_EraseRootFromParent_Done,
      // Label 18451: @1343127
      GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1343229), // Rule ID 22534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22534,
        GIR_EraseRootFromParent_Done,
      // Label 18452: @1343229
      GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1343331), // Rule ID 22535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22535,
        GIR_EraseRootFromParent_Done,
      // Label 18453: @1343331
      GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1343433), // Rule ID 22538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22538,
        GIR_EraseRootFromParent_Done,
      // Label 18454: @1343433
      GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1343535), // Rule ID 22539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22539,
        GIR_EraseRootFromParent_Done,
      // Label 18455: @1343535
      GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1343637), // Rule ID 22542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22542,
        GIR_EraseRootFromParent_Done,
      // Label 18456: @1343637
      GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1343739), // Rule ID 22543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22543,
        GIR_EraseRootFromParent_Done,
      // Label 18457: @1343739
      GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1343841), // Rule ID 22546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22546,
        GIR_EraseRootFromParent_Done,
      // Label 18458: @1343841
      GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1343943), // Rule ID 22547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22547,
        GIR_EraseRootFromParent_Done,
      // Label 18459: @1343943
      GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1344045), // Rule ID 22550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22550,
        GIR_EraseRootFromParent_Done,
      // Label 18460: @1344045
      GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1344147), // Rule ID 22551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22551,
        GIR_EraseRootFromParent_Done,
      // Label 18461: @1344147
      GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1344249), // Rule ID 22554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22554,
        GIR_EraseRootFromParent_Done,
      // Label 18462: @1344249
      GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1344351), // Rule ID 22555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22555,
        GIR_EraseRootFromParent_Done,
      // Label 18463: @1344351
      GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1344453), // Rule ID 22558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22558,
        GIR_EraseRootFromParent_Done,
      // Label 18464: @1344453
      GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1344555), // Rule ID 22559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22559,
        GIR_EraseRootFromParent_Done,
      // Label 18465: @1344555
      GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1344657), // Rule ID 22562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22562,
        GIR_EraseRootFromParent_Done,
      // Label 18466: @1344657
      GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1344759), // Rule ID 22563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22563,
        GIR_EraseRootFromParent_Done,
      // Label 18467: @1344759
      GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1344861), // Rule ID 22566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22566,
        GIR_EraseRootFromParent_Done,
      // Label 18468: @1344861
      GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1344963), // Rule ID 22567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22567,
        GIR_EraseRootFromParent_Done,
      // Label 18469: @1344963
      GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1345065), // Rule ID 22570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22570,
        GIR_EraseRootFromParent_Done,
      // Label 18470: @1345065
      GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1345167), // Rule ID 22571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22571,
        GIR_EraseRootFromParent_Done,
      // Label 18471: @1345167
      GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1345269), // Rule ID 22574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22574,
        GIR_EraseRootFromParent_Done,
      // Label 18472: @1345269
      GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1345371), // Rule ID 22575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22575,
        GIR_EraseRootFromParent_Done,
      // Label 18473: @1345371
      GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1345473), // Rule ID 22578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22578,
        GIR_EraseRootFromParent_Done,
      // Label 18474: @1345473
      GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1345575), // Rule ID 22579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22579,
        GIR_EraseRootFromParent_Done,
      // Label 18475: @1345575
      GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1345677), // Rule ID 22582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22582,
        GIR_EraseRootFromParent_Done,
      // Label 18476: @1345677
      GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1345779), // Rule ID 22583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22583,
        GIR_EraseRootFromParent_Done,
      // Label 18477: @1345779
      GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1345881), // Rule ID 22586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22586,
        GIR_EraseRootFromParent_Done,
      // Label 18478: @1345881
      GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1345983), // Rule ID 22587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22587,
        GIR_EraseRootFromParent_Done,
      // Label 18479: @1345983
      GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1346085), // Rule ID 22590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22590,
        GIR_EraseRootFromParent_Done,
      // Label 18480: @1346085
      GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1346187), // Rule ID 22591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22591,
        GIR_EraseRootFromParent_Done,
      // Label 18481: @1346187
      GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1346289), // Rule ID 22594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22594,
        GIR_EraseRootFromParent_Done,
      // Label 18482: @1346289
      GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1346391), // Rule ID 22595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22595,
        GIR_EraseRootFromParent_Done,
      // Label 18483: @1346391
      GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1346493), // Rule ID 22598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22598,
        GIR_EraseRootFromParent_Done,
      // Label 18484: @1346493
      GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1346595), // Rule ID 22599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22599,
        GIR_EraseRootFromParent_Done,
      // Label 18485: @1346595
      GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1346697), // Rule ID 22602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22602,
        GIR_EraseRootFromParent_Done,
      // Label 18486: @1346697
      GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1346799), // Rule ID 22603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22603,
        GIR_EraseRootFromParent_Done,
      // Label 18487: @1346799
      GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1346901), // Rule ID 22606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22606,
        GIR_EraseRootFromParent_Done,
      // Label 18488: @1346901
      GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1347003), // Rule ID 22607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22607,
        GIR_EraseRootFromParent_Done,
      // Label 18489: @1347003
      GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1347105), // Rule ID 22610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22610,
        GIR_EraseRootFromParent_Done,
      // Label 18490: @1347105
      GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1347207), // Rule ID 22611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22611,
        GIR_EraseRootFromParent_Done,
      // Label 18491: @1347207
      GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1347309), // Rule ID 22614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22614,
        GIR_EraseRootFromParent_Done,
      // Label 18492: @1347309
      GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1347411), // Rule ID 22615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22615,
        GIR_EraseRootFromParent_Done,
      // Label 18493: @1347411
      GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1347513), // Rule ID 22618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22618,
        GIR_EraseRootFromParent_Done,
      // Label 18494: @1347513
      GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1347615), // Rule ID 22619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22619,
        GIR_EraseRootFromParent_Done,
      // Label 18495: @1347615
      GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1347717), // Rule ID 22622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22622,
        GIR_EraseRootFromParent_Done,
      // Label 18496: @1347717
      GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1347819), // Rule ID 22623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22623,
        GIR_EraseRootFromParent_Done,
      // Label 18497: @1347819
      GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1347921), // Rule ID 22626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22626,
        GIR_EraseRootFromParent_Done,
      // Label 18498: @1347921
      GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1348023), // Rule ID 22627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22627,
        GIR_EraseRootFromParent_Done,
      // Label 18499: @1348023
      GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1348125), // Rule ID 22630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22630,
        GIR_EraseRootFromParent_Done,
      // Label 18500: @1348125
      GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1348227), // Rule ID 22631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22631,
        GIR_EraseRootFromParent_Done,
      // Label 18501: @1348227
      GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1348329), // Rule ID 22634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22634,
        GIR_EraseRootFromParent_Done,
      // Label 18502: @1348329
      GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1348431), // Rule ID 22635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22635,
        GIR_EraseRootFromParent_Done,
      // Label 18503: @1348431
      GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1348533), // Rule ID 22638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22638,
        GIR_EraseRootFromParent_Done,
      // Label 18504: @1348533
      GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1348635), // Rule ID 22639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22639,
        GIR_EraseRootFromParent_Done,
      // Label 18505: @1348635
      GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1348737), // Rule ID 22642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22642,
        GIR_EraseRootFromParent_Done,
      // Label 18506: @1348737
      GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1348839), // Rule ID 22643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22643,
        GIR_EraseRootFromParent_Done,
      // Label 18507: @1348839
      GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1348941), // Rule ID 22646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22646,
        GIR_EraseRootFromParent_Done,
      // Label 18508: @1348941
      GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1349043), // Rule ID 22647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22647,
        GIR_EraseRootFromParent_Done,
      // Label 18509: @1349043
      GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1349145), // Rule ID 22650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22650,
        GIR_EraseRootFromParent_Done,
      // Label 18510: @1349145
      GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1349247), // Rule ID 22651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22651,
        GIR_EraseRootFromParent_Done,
      // Label 18511: @1349247
      GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1349349), // Rule ID 22654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22654,
        GIR_EraseRootFromParent_Done,
      // Label 18512: @1349349
      GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1349451), // Rule ID 22655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22655,
        GIR_EraseRootFromParent_Done,
      // Label 18513: @1349451
      GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1349553), // Rule ID 22658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22658,
        GIR_EraseRootFromParent_Done,
      // Label 18514: @1349553
      GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1349655), // Rule ID 22659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22659,
        GIR_EraseRootFromParent_Done,
      // Label 18515: @1349655
      GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1349757), // Rule ID 22662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22662,
        GIR_EraseRootFromParent_Done,
      // Label 18516: @1349757
      GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1349859), // Rule ID 22663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22663,
        GIR_EraseRootFromParent_Done,
      // Label 18517: @1349859
      GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1349961), // Rule ID 22666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22666,
        GIR_EraseRootFromParent_Done,
      // Label 18518: @1349961
      GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1350063), // Rule ID 22667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22667,
        GIR_EraseRootFromParent_Done,
      // Label 18519: @1350063
      GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1350165), // Rule ID 22670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22670,
        GIR_EraseRootFromParent_Done,
      // Label 18520: @1350165
      GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1350267), // Rule ID 22671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22671,
        GIR_EraseRootFromParent_Done,
      // Label 18521: @1350267
      GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1350369), // Rule ID 22674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22674,
        GIR_EraseRootFromParent_Done,
      // Label 18522: @1350369
      GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1350471), // Rule ID 22675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22675,
        GIR_EraseRootFromParent_Done,
      // Label 18523: @1350471
      GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1350573), // Rule ID 22678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22678,
        GIR_EraseRootFromParent_Done,
      // Label 18524: @1350573
      GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1350675), // Rule ID 22679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22679,
        GIR_EraseRootFromParent_Done,
      // Label 18525: @1350675
      GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1350777), // Rule ID 22798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22798,
        GIR_EraseRootFromParent_Done,
      // Label 18526: @1350777
      GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1350879), // Rule ID 22799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22799,
        GIR_EraseRootFromParent_Done,
      // Label 18527: @1350879
      GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1350981), // Rule ID 22802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22802,
        GIR_EraseRootFromParent_Done,
      // Label 18528: @1350981
      GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1351083), // Rule ID 22803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22803,
        GIR_EraseRootFromParent_Done,
      // Label 18529: @1351083
      GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1351185), // Rule ID 22806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22806,
        GIR_EraseRootFromParent_Done,
      // Label 18530: @1351185
      GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1351287), // Rule ID 22807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22807,
        GIR_EraseRootFromParent_Done,
      // Label 18531: @1351287
      GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1351389), // Rule ID 22810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22810,
        GIR_EraseRootFromParent_Done,
      // Label 18532: @1351389
      GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1351491), // Rule ID 22811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22811,
        GIR_EraseRootFromParent_Done,
      // Label 18533: @1351491
      GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1351593), // Rule ID 22814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22814,
        GIR_EraseRootFromParent_Done,
      // Label 18534: @1351593
      GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1351695), // Rule ID 22815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22815,
        GIR_EraseRootFromParent_Done,
      // Label 18535: @1351695
      GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1351797), // Rule ID 22818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22818,
        GIR_EraseRootFromParent_Done,
      // Label 18536: @1351797
      GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1351899), // Rule ID 22819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22819,
        GIR_EraseRootFromParent_Done,
      // Label 18537: @1351899
      GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1352001), // Rule ID 22822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22822,
        GIR_EraseRootFromParent_Done,
      // Label 18538: @1352001
      GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1352103), // Rule ID 22823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22823,
        GIR_EraseRootFromParent_Done,
      // Label 18539: @1352103
      GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1352205), // Rule ID 22826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22826,
        GIR_EraseRootFromParent_Done,
      // Label 18540: @1352205
      GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1352307), // Rule ID 22827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22827,
        GIR_EraseRootFromParent_Done,
      // Label 18541: @1352307
      GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1352409), // Rule ID 22830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22830,
        GIR_EraseRootFromParent_Done,
      // Label 18542: @1352409
      GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1352511), // Rule ID 22831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10863:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22831,
        GIR_EraseRootFromParent_Done,
      // Label 18543: @1352511
      GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1352613), // Rule ID 22834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22834,
        GIR_EraseRootFromParent_Done,
      // Label 18544: @1352613
      GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1352715), // Rule ID 22835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22835,
        GIR_EraseRootFromParent_Done,
      // Label 18545: @1352715
      GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1352817), // Rule ID 22838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22838,
        GIR_EraseRootFromParent_Done,
      // Label 18546: @1352817
      GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1352919), // Rule ID 22839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22839,
        GIR_EraseRootFromParent_Done,
      // Label 18547: @1352919
      GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1353021), // Rule ID 22842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22842,
        GIR_EraseRootFromParent_Done,
      // Label 18548: @1353021
      GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1353123), // Rule ID 22843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10863:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22843,
        GIR_EraseRootFromParent_Done,
      // Label 18549: @1353123
      GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1353225), // Rule ID 22846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22846,
        GIR_EraseRootFromParent_Done,
      // Label 18550: @1353225
      GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1353327), // Rule ID 22847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22847,
        GIR_EraseRootFromParent_Done,
      // Label 18551: @1353327
      GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1353429), // Rule ID 22850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22850,
        GIR_EraseRootFromParent_Done,
      // Label 18552: @1353429
      GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1353531), // Rule ID 22851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22851,
        GIR_EraseRootFromParent_Done,
      // Label 18553: @1353531
      GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1353633), // Rule ID 22854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22854,
        GIR_EraseRootFromParent_Done,
      // Label 18554: @1353633
      GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1353735), // Rule ID 22855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10863:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22855,
        GIR_EraseRootFromParent_Done,
      // Label 18555: @1353735
      GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1353837), // Rule ID 22858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22858,
        GIR_EraseRootFromParent_Done,
      // Label 18556: @1353837
      GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1353939), // Rule ID 22859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22859,
        GIR_EraseRootFromParent_Done,
      // Label 18557: @1353939
      GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1354041), // Rule ID 22862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22862,
        GIR_EraseRootFromParent_Done,
      // Label 18558: @1354041
      GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1354143), // Rule ID 22863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22863,
        GIR_EraseRootFromParent_Done,
      // Label 18559: @1354143
      GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1354245), // Rule ID 22866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22866,
        GIR_EraseRootFromParent_Done,
      // Label 18560: @1354245
      GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1354347), // Rule ID 22867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22867,
        GIR_EraseRootFromParent_Done,
      // Label 18561: @1354347
      GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1354449), // Rule ID 22870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22870,
        GIR_EraseRootFromParent_Done,
      // Label 18562: @1354449
      GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1354551), // Rule ID 22871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22871,
        GIR_EraseRootFromParent_Done,
      // Label 18563: @1354551
      GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1354653), // Rule ID 22874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22874,
        GIR_EraseRootFromParent_Done,
      // Label 18564: @1354653
      GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1354755), // Rule ID 22875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22875,
        GIR_EraseRootFromParent_Done,
      // Label 18565: @1354755
      GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1354857), // Rule ID 22878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22878,
        GIR_EraseRootFromParent_Done,
      // Label 18566: @1354857
      GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1354959), // Rule ID 22879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22879,
        GIR_EraseRootFromParent_Done,
      // Label 18567: @1354959
      GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1355061), // Rule ID 22882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22882,
        GIR_EraseRootFromParent_Done,
      // Label 18568: @1355061
      GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1355163), // Rule ID 22883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22883,
        GIR_EraseRootFromParent_Done,
      // Label 18569: @1355163
      GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1355265), // Rule ID 22886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22886,
        GIR_EraseRootFromParent_Done,
      // Label 18570: @1355265
      GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1355367), // Rule ID 22887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22887,
        GIR_EraseRootFromParent_Done,
      // Label 18571: @1355367
      GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1355469), // Rule ID 22890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22890,
        GIR_EraseRootFromParent_Done,
      // Label 18572: @1355469
      GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1355571), // Rule ID 22891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10861:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22891,
        GIR_EraseRootFromParent_Done,
      // Label 18573: @1355571
      GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1355673), // Rule ID 22894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22894,
        GIR_EraseRootFromParent_Done,
      // Label 18574: @1355673
      GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1355775), // Rule ID 22895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22895,
        GIR_EraseRootFromParent_Done,
      // Label 18575: @1355775
      GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1355877), // Rule ID 22898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22898,
        GIR_EraseRootFromParent_Done,
      // Label 18576: @1355877
      GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1355979), // Rule ID 22899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22899,
        GIR_EraseRootFromParent_Done,
      // Label 18577: @1355979
      GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1356081), // Rule ID 22902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22902,
        GIR_EraseRootFromParent_Done,
      // Label 18578: @1356081
      GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1356183), // Rule ID 22903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10861:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22903,
        GIR_EraseRootFromParent_Done,
      // Label 18579: @1356183
      GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1356285), // Rule ID 22906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22906,
        GIR_EraseRootFromParent_Done,
      // Label 18580: @1356285
      GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1356387), // Rule ID 22907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22907,
        GIR_EraseRootFromParent_Done,
      // Label 18581: @1356387
      GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1356489), // Rule ID 22910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22910,
        GIR_EraseRootFromParent_Done,
      // Label 18582: @1356489
      GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1356591), // Rule ID 22911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22911,
        GIR_EraseRootFromParent_Done,
      // Label 18583: @1356591
      GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1356693), // Rule ID 22914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22914,
        GIR_EraseRootFromParent_Done,
      // Label 18584: @1356693
      GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1356795), // Rule ID 22915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10861:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22915,
        GIR_EraseRootFromParent_Done,
      // Label 18585: @1356795
      GIM_Reject,
    // Label 12605: @1356796
    GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(2080757),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
      GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1356908), // Rule ID 7208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7208,
        GIR_EraseRootFromParent_Done,
      // Label 18587: @1356908
      GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1357012), // Rule ID 7209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7209,
        GIR_EraseRootFromParent_Done,
      // Label 18588: @1357012
      GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1357116), // Rule ID 7212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7212,
        GIR_EraseRootFromParent_Done,
      // Label 18589: @1357116
      GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1357220), // Rule ID 7213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7213,
        GIR_EraseRootFromParent_Done,
      // Label 18590: @1357220
      GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1357324), // Rule ID 7216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7216,
        GIR_EraseRootFromParent_Done,
      // Label 18591: @1357324
      GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1357428), // Rule ID 7217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7217,
        GIR_EraseRootFromParent_Done,
      // Label 18592: @1357428
      GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1357532), // Rule ID 7220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7220,
        GIR_EraseRootFromParent_Done,
      // Label 18593: @1357532
      GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1357636), // Rule ID 7221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7221,
        GIR_EraseRootFromParent_Done,
      // Label 18594: @1357636
      GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1357740), // Rule ID 7224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7224,
        GIR_EraseRootFromParent_Done,
      // Label 18595: @1357740
      GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1357844), // Rule ID 7225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7225,
        GIR_EraseRootFromParent_Done,
      // Label 18596: @1357844
      GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1357948), // Rule ID 7228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7228,
        GIR_EraseRootFromParent_Done,
      // Label 18597: @1357948
      GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1358052), // Rule ID 7229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7229,
        GIR_EraseRootFromParent_Done,
      // Label 18598: @1358052
      GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1358156), // Rule ID 7232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7232,
        GIR_EraseRootFromParent_Done,
      // Label 18599: @1358156
      GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1358260), // Rule ID 7233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7233,
        GIR_EraseRootFromParent_Done,
      // Label 18600: @1358260
      GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1358364), // Rule ID 7236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7236,
        GIR_EraseRootFromParent_Done,
      // Label 18601: @1358364
      GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1358468), // Rule ID 7237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7237,
        GIR_EraseRootFromParent_Done,
      // Label 18602: @1358468
      GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1358572), // Rule ID 7240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7240,
        GIR_EraseRootFromParent_Done,
      // Label 18603: @1358572
      GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1358676), // Rule ID 7241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7241,
        GIR_EraseRootFromParent_Done,
      // Label 18604: @1358676
      GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1358780), // Rule ID 7244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7244,
        GIR_EraseRootFromParent_Done,
      // Label 18605: @1358780
      GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1358884), // Rule ID 7245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7245,
        GIR_EraseRootFromParent_Done,
      // Label 18606: @1358884
      GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1358988), // Rule ID 7248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7248,
        GIR_EraseRootFromParent_Done,
      // Label 18607: @1358988
      GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1359092), // Rule ID 7249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7249,
        GIR_EraseRootFromParent_Done,
      // Label 18608: @1359092
      GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1359196), // Rule ID 7252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7252,
        GIR_EraseRootFromParent_Done,
      // Label 18609: @1359196
      GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1359300), // Rule ID 7253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7253,
        GIR_EraseRootFromParent_Done,
      // Label 18610: @1359300
      GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1359404), // Rule ID 7256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7256,
        GIR_EraseRootFromParent_Done,
      // Label 18611: @1359404
      GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1359508), // Rule ID 7257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7257,
        GIR_EraseRootFromParent_Done,
      // Label 18612: @1359508
      GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1359612), // Rule ID 7260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7260,
        GIR_EraseRootFromParent_Done,
      // Label 18613: @1359612
      GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1359716), // Rule ID 7261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7261,
        GIR_EraseRootFromParent_Done,
      // Label 18614: @1359716
      GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1359820), // Rule ID 7264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7264,
        GIR_EraseRootFromParent_Done,
      // Label 18615: @1359820
      GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1359924), // Rule ID 7265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7265,
        GIR_EraseRootFromParent_Done,
      // Label 18616: @1359924
      GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1360028), // Rule ID 7268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7268,
        GIR_EraseRootFromParent_Done,
      // Label 18617: @1360028
      GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1360132), // Rule ID 7269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7269,
        GIR_EraseRootFromParent_Done,
      // Label 18618: @1360132
      GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1360236), // Rule ID 7272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7272,
        GIR_EraseRootFromParent_Done,
      // Label 18619: @1360236
      GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1360340), // Rule ID 7273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7273,
        GIR_EraseRootFromParent_Done,
      // Label 18620: @1360340
      GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1360444), // Rule ID 7276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7276,
        GIR_EraseRootFromParent_Done,
      // Label 18621: @1360444
      GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1360548), // Rule ID 7277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7277,
        GIR_EraseRootFromParent_Done,
      // Label 18622: @1360548
      GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1360652), // Rule ID 7280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7280,
        GIR_EraseRootFromParent_Done,
      // Label 18623: @1360652
      GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1360756), // Rule ID 7281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7281,
        GIR_EraseRootFromParent_Done,
      // Label 18624: @1360756
      GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1360860), // Rule ID 7284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7284,
        GIR_EraseRootFromParent_Done,
      // Label 18625: @1360860
      GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1360964), // Rule ID 7285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7285,
        GIR_EraseRootFromParent_Done,
      // Label 18626: @1360964
      GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1361068), // Rule ID 7288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7288,
        GIR_EraseRootFromParent_Done,
      // Label 18627: @1361068
      GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1361172), // Rule ID 7289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7289,
        GIR_EraseRootFromParent_Done,
      // Label 18628: @1361172
      GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1361276), // Rule ID 7292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7292,
        GIR_EraseRootFromParent_Done,
      // Label 18629: @1361276
      GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1361380), // Rule ID 7293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7293,
        GIR_EraseRootFromParent_Done,
      // Label 18630: @1361380
      GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1361486), // Rule ID 2606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2606,
        GIR_EraseRootFromParent_Done,
      // Label 18631: @1361486
      GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1361592), // Rule ID 2607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2607,
        GIR_EraseRootFromParent_Done,
      // Label 18632: @1361592
      GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1361698), // Rule ID 20490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20490,
        GIR_EraseRootFromParent_Done,
      // Label 18633: @1361698
      GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1361804), // Rule ID 20491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20491,
        GIR_EraseRootFromParent_Done,
      // Label 18634: @1361804
      GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1361910), // Rule ID 20494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20494,
        GIR_EraseRootFromParent_Done,
      // Label 18635: @1361910
      GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1362016), // Rule ID 20495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20495,
        GIR_EraseRootFromParent_Done,
      // Label 18636: @1362016
      GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1362122), // Rule ID 20498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20498,
        GIR_EraseRootFromParent_Done,
      // Label 18637: @1362122
      GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1362228), // Rule ID 20499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20499,
        GIR_EraseRootFromParent_Done,
      // Label 18638: @1362228
      GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1362334), // Rule ID 20502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10805:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20502,
        GIR_EraseRootFromParent_Done,
      // Label 18639: @1362334
      GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1362440), // Rule ID 20503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10805:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20503,
        GIR_EraseRootFromParent_Done,
      // Label 18640: @1362440
      GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1362546), // Rule ID 20506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20506,
        GIR_EraseRootFromParent_Done,
      // Label 18641: @1362546
      GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1362652), // Rule ID 20507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20507,
        GIR_EraseRootFromParent_Done,
      // Label 18642: @1362652
      GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1362758), // Rule ID 20510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20510,
        GIR_EraseRootFromParent_Done,
      // Label 18643: @1362758
      GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1362864), // Rule ID 20511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20511,
        GIR_EraseRootFromParent_Done,
      // Label 18644: @1362864
      GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1362970), // Rule ID 20514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20514,
        GIR_EraseRootFromParent_Done,
      // Label 18645: @1362970
      GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1363076), // Rule ID 20515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20515,
        GIR_EraseRootFromParent_Done,
      // Label 18646: @1363076
      GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1363182), // Rule ID 20518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20518,
        GIR_EraseRootFromParent_Done,
      // Label 18647: @1363182
      GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1363288), // Rule ID 20519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20519,
        GIR_EraseRootFromParent_Done,
      // Label 18648: @1363288
      GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1363394), // Rule ID 20522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20522,
        GIR_EraseRootFromParent_Done,
      // Label 18649: @1363394
      GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1363500), // Rule ID 20523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20523,
        GIR_EraseRootFromParent_Done,
      // Label 18650: @1363500
      GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1363606), // Rule ID 20526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20526,
        GIR_EraseRootFromParent_Done,
      // Label 18651: @1363606
      GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1363712), // Rule ID 20527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20527,
        GIR_EraseRootFromParent_Done,
      // Label 18652: @1363712
      GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1363818), // Rule ID 20530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20530,
        GIR_EraseRootFromParent_Done,
      // Label 18653: @1363818
      GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1363924), // Rule ID 20531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20531,
        GIR_EraseRootFromParent_Done,
      // Label 18654: @1363924
      GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1364030), // Rule ID 20534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20534,
        GIR_EraseRootFromParent_Done,
      // Label 18655: @1364030
      GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1364136), // Rule ID 20535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20535,
        GIR_EraseRootFromParent_Done,
      // Label 18656: @1364136
      GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1364242), // Rule ID 20538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20538,
        GIR_EraseRootFromParent_Done,
      // Label 18657: @1364242
      GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1364348), // Rule ID 20539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20539,
        GIR_EraseRootFromParent_Done,
      // Label 18658: @1364348
      GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1364454), // Rule ID 20542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20542,
        GIR_EraseRootFromParent_Done,
      // Label 18659: @1364454
      GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1364560), // Rule ID 20543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20543,
        GIR_EraseRootFromParent_Done,
      // Label 18660: @1364560
      GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1364666), // Rule ID 20546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20546,
        GIR_EraseRootFromParent_Done,
      // Label 18661: @1364666
      GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1364772), // Rule ID 20547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20547,
        GIR_EraseRootFromParent_Done,
      // Label 18662: @1364772
      GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1364878), // Rule ID 20550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20550,
        GIR_EraseRootFromParent_Done,
      // Label 18663: @1364878
      GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1364984), // Rule ID 20551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20551,
        GIR_EraseRootFromParent_Done,
      // Label 18664: @1364984
      GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1365090), // Rule ID 20554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20554,
        GIR_EraseRootFromParent_Done,
      // Label 18665: @1365090
      GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1365196), // Rule ID 20555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20555,
        GIR_EraseRootFromParent_Done,
      // Label 18666: @1365196
      GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1365302), // Rule ID 20558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20558,
        GIR_EraseRootFromParent_Done,
      // Label 18667: @1365302
      GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1365408), // Rule ID 20559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20559,
        GIR_EraseRootFromParent_Done,
      // Label 18668: @1365408
      GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1365514), // Rule ID 20562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10807:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20562,
        GIR_EraseRootFromParent_Done,
      // Label 18669: @1365514
      GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1365620), // Rule ID 20563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10807:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20563,
        GIR_EraseRootFromParent_Done,
      // Label 18670: @1365620
      GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1365726), // Rule ID 20566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20566,
        GIR_EraseRootFromParent_Done,
      // Label 18671: @1365726
      GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1365832), // Rule ID 20567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20567,
        GIR_EraseRootFromParent_Done,
      // Label 18672: @1365832
      GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1365938), // Rule ID 20570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20570,
        GIR_EraseRootFromParent_Done,
      // Label 18673: @1365938
      GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1366044), // Rule ID 20571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20571,
        GIR_EraseRootFromParent_Done,
      // Label 18674: @1366044
      GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1366150), // Rule ID 20574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20574,
        GIR_EraseRootFromParent_Done,
      // Label 18675: @1366150
      GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1366256), // Rule ID 20575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20575,
        GIR_EraseRootFromParent_Done,
      // Label 18676: @1366256
      GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1366362), // Rule ID 20578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20578,
        GIR_EraseRootFromParent_Done,
      // Label 18677: @1366362
      GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1366468), // Rule ID 20579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20579,
        GIR_EraseRootFromParent_Done,
      // Label 18678: @1366468
      GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1366574), // Rule ID 20582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20582,
        GIR_EraseRootFromParent_Done,
      // Label 18679: @1366574
      GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1366680), // Rule ID 20583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20583,
        GIR_EraseRootFromParent_Done,
      // Label 18680: @1366680
      GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1366786), // Rule ID 20586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20586,
        GIR_EraseRootFromParent_Done,
      // Label 18681: @1366786
      GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1366892), // Rule ID 20587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20587,
        GIR_EraseRootFromParent_Done,
      // Label 18682: @1366892
      GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1366998), // Rule ID 20590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20590,
        GIR_EraseRootFromParent_Done,
      // Label 18683: @1366998
      GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1367104), // Rule ID 20591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20591,
        GIR_EraseRootFromParent_Done,
      // Label 18684: @1367104
      GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1367210), // Rule ID 20594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20594,
        GIR_EraseRootFromParent_Done,
      // Label 18685: @1367210
      GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1367316), // Rule ID 20595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20595,
        GIR_EraseRootFromParent_Done,
      // Label 18686: @1367316
      GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1367422), // Rule ID 20598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20598,
        GIR_EraseRootFromParent_Done,
      // Label 18687: @1367422
      GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1367528), // Rule ID 20599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20599,
        GIR_EraseRootFromParent_Done,
      // Label 18688: @1367528
      GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1367634), // Rule ID 20602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20602,
        GIR_EraseRootFromParent_Done,
      // Label 18689: @1367634
      GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1367740), // Rule ID 20603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20603,
        GIR_EraseRootFromParent_Done,
      // Label 18690: @1367740
      GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1367846), // Rule ID 20962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20962,
        GIR_EraseRootFromParent_Done,
      // Label 18691: @1367846
      GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1367952), // Rule ID 20963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20963,
        GIR_EraseRootFromParent_Done,
      // Label 18692: @1367952
      GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1368058), // Rule ID 20966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20966,
        GIR_EraseRootFromParent_Done,
      // Label 18693: @1368058
      GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1368164), // Rule ID 20967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20967,
        GIR_EraseRootFromParent_Done,
      // Label 18694: @1368164
      GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1368270), // Rule ID 20970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20970,
        GIR_EraseRootFromParent_Done,
      // Label 18695: @1368270
      GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1368376), // Rule ID 20971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20971,
        GIR_EraseRootFromParent_Done,
      // Label 18696: @1368376
      GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1368482), // Rule ID 20974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20974,
        GIR_EraseRootFromParent_Done,
      // Label 18697: @1368482
      GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1368588), // Rule ID 20975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20975,
        GIR_EraseRootFromParent_Done,
      // Label 18698: @1368588
      GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1368694), // Rule ID 20978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20978,
        GIR_EraseRootFromParent_Done,
      // Label 18699: @1368694
      GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1368800), // Rule ID 20979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20979,
        GIR_EraseRootFromParent_Done,
      // Label 18700: @1368800
      GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1368906), // Rule ID 20982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20982,
        GIR_EraseRootFromParent_Done,
      // Label 18701: @1368906
      GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1369012), // Rule ID 20983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20983,
        GIR_EraseRootFromParent_Done,
      // Label 18702: @1369012
      GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1369118), // Rule ID 20986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20986,
        GIR_EraseRootFromParent_Done,
      // Label 18703: @1369118
      GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1369224), // Rule ID 20987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20987,
        GIR_EraseRootFromParent_Done,
      // Label 18704: @1369224
      GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1369330), // Rule ID 20990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20990,
        GIR_EraseRootFromParent_Done,
      // Label 18705: @1369330
      GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1369436), // Rule ID 20991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20991,
        GIR_EraseRootFromParent_Done,
      // Label 18706: @1369436
      GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1369542), // Rule ID 20994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20994,
        GIR_EraseRootFromParent_Done,
      // Label 18707: @1369542
      GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1369648), // Rule ID 20995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20995,
        GIR_EraseRootFromParent_Done,
      // Label 18708: @1369648
      GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1369754), // Rule ID 20998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20998,
        GIR_EraseRootFromParent_Done,
      // Label 18709: @1369754
      GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1369860), // Rule ID 20999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20999,
        GIR_EraseRootFromParent_Done,
      // Label 18710: @1369860
      GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1369966), // Rule ID 21002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21002,
        GIR_EraseRootFromParent_Done,
      // Label 18711: @1369966
      GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1370072), // Rule ID 21003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21003,
        GIR_EraseRootFromParent_Done,
      // Label 18712: @1370072
      GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1370178), // Rule ID 21006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21006,
        GIR_EraseRootFromParent_Done,
      // Label 18713: @1370178
      GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1370284), // Rule ID 21007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21007,
        GIR_EraseRootFromParent_Done,
      // Label 18714: @1370284
      GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1370390), // Rule ID 21010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21010,
        GIR_EraseRootFromParent_Done,
      // Label 18715: @1370390
      GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1370496), // Rule ID 21011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21011,
        GIR_EraseRootFromParent_Done,
      // Label 18716: @1370496
      GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1370602), // Rule ID 21014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21014,
        GIR_EraseRootFromParent_Done,
      // Label 18717: @1370602
      GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1370708), // Rule ID 21015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21015,
        GIR_EraseRootFromParent_Done,
      // Label 18718: @1370708
      GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1370814), // Rule ID 21018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21018,
        GIR_EraseRootFromParent_Done,
      // Label 18719: @1370814
      GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1370920), // Rule ID 21019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21019,
        GIR_EraseRootFromParent_Done,
      // Label 18720: @1370920
      GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1371026), // Rule ID 21022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21022,
        GIR_EraseRootFromParent_Done,
      // Label 18721: @1371026
      GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1371132), // Rule ID 21023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21023,
        GIR_EraseRootFromParent_Done,
      // Label 18722: @1371132
      GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1371238), // Rule ID 21026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21026,
        GIR_EraseRootFromParent_Done,
      // Label 18723: @1371238
      GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1371344), // Rule ID 21027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21027,
        GIR_EraseRootFromParent_Done,
      // Label 18724: @1371344
      GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1371450), // Rule ID 21030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21030,
        GIR_EraseRootFromParent_Done,
      // Label 18725: @1371450
      GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1371556), // Rule ID 21031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21031,
        GIR_EraseRootFromParent_Done,
      // Label 18726: @1371556
      GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1371662), // Rule ID 21334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21334,
        GIR_EraseRootFromParent_Done,
      // Label 18727: @1371662
      GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1371768), // Rule ID 21335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21335,
        GIR_EraseRootFromParent_Done,
      // Label 18728: @1371768
      GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1371874), // Rule ID 21338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21338,
        GIR_EraseRootFromParent_Done,
      // Label 18729: @1371874
      GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1371980), // Rule ID 21339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21339,
        GIR_EraseRootFromParent_Done,
      // Label 18730: @1371980
      GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1372086), // Rule ID 21342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21342,
        GIR_EraseRootFromParent_Done,
      // Label 18731: @1372086
      GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1372192), // Rule ID 21343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21343,
        GIR_EraseRootFromParent_Done,
      // Label 18732: @1372192
      GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1372298), // Rule ID 21346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21346,
        GIR_EraseRootFromParent_Done,
      // Label 18733: @1372298
      GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1372404), // Rule ID 21347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21347,
        GIR_EraseRootFromParent_Done,
      // Label 18734: @1372404
      GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1372510), // Rule ID 21350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21350,
        GIR_EraseRootFromParent_Done,
      // Label 18735: @1372510
      GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1372616), // Rule ID 21351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21351,
        GIR_EraseRootFromParent_Done,
      // Label 18736: @1372616
      GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1372722), // Rule ID 21354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21354,
        GIR_EraseRootFromParent_Done,
      // Label 18737: @1372722
      GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1372828), // Rule ID 21355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21355,
        GIR_EraseRootFromParent_Done,
      // Label 18738: @1372828
      GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1372934), // Rule ID 21358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21358,
        GIR_EraseRootFromParent_Done,
      // Label 18739: @1372934
      GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1373040), // Rule ID 21359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21359,
        GIR_EraseRootFromParent_Done,
      // Label 18740: @1373040
      GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1373146), // Rule ID 21362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21362,
        GIR_EraseRootFromParent_Done,
      // Label 18741: @1373146
      GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1373252), // Rule ID 21363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21363,
        GIR_EraseRootFromParent_Done,
      // Label 18742: @1373252
      GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1373358), // Rule ID 21366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21366,
        GIR_EraseRootFromParent_Done,
      // Label 18743: @1373358
      GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1373464), // Rule ID 21367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21367,
        GIR_EraseRootFromParent_Done,
      // Label 18744: @1373464
      GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1373570), // Rule ID 21370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21370,
        GIR_EraseRootFromParent_Done,
      // Label 18745: @1373570
      GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1373676), // Rule ID 21371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21371,
        GIR_EraseRootFromParent_Done,
      // Label 18746: @1373676
      GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1373782), // Rule ID 21374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21374,
        GIR_EraseRootFromParent_Done,
      // Label 18747: @1373782
      GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1373888), // Rule ID 21375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21375,
        GIR_EraseRootFromParent_Done,
      // Label 18748: @1373888
      GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1373994), // Rule ID 21378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21378,
        GIR_EraseRootFromParent_Done,
      // Label 18749: @1373994
      GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1374100), // Rule ID 21379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21379,
        GIR_EraseRootFromParent_Done,
      // Label 18750: @1374100
      GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1374206), // Rule ID 21382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21382,
        GIR_EraseRootFromParent_Done,
      // Label 18751: @1374206
      GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1374312), // Rule ID 21383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21383,
        GIR_EraseRootFromParent_Done,
      // Label 18752: @1374312
      GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1374418), // Rule ID 21386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21386,
        GIR_EraseRootFromParent_Done,
      // Label 18753: @1374418
      GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1374524), // Rule ID 21387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21387,
        GIR_EraseRootFromParent_Done,
      // Label 18754: @1374524
      GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1374630), // Rule ID 21390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21390,
        GIR_EraseRootFromParent_Done,
      // Label 18755: @1374630
      GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1374736), // Rule ID 21391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21391,
        GIR_EraseRootFromParent_Done,
      // Label 18756: @1374736
      GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1374842), // Rule ID 21394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21394,
        GIR_EraseRootFromParent_Done,
      // Label 18757: @1374842
      GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1374948), // Rule ID 21395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21395,
        GIR_EraseRootFromParent_Done,
      // Label 18758: @1374948
      GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1375054), // Rule ID 21398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21398,
        GIR_EraseRootFromParent_Done,
      // Label 18759: @1375054
      GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1375160), // Rule ID 21399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21399,
        GIR_EraseRootFromParent_Done,
      // Label 18760: @1375160
      GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1375266), // Rule ID 21402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21402,
        GIR_EraseRootFromParent_Done,
      // Label 18761: @1375266
      GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1375372), // Rule ID 21403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21403,
        GIR_EraseRootFromParent_Done,
      // Label 18762: @1375372
      GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1375478), // Rule ID 21406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21406,
        GIR_EraseRootFromParent_Done,
      // Label 18763: @1375478
      GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1375584), // Rule ID 21407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21407,
        GIR_EraseRootFromParent_Done,
      // Label 18764: @1375584
      GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1375690), // Rule ID 21410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21410,
        GIR_EraseRootFromParent_Done,
      // Label 18765: @1375690
      GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1375796), // Rule ID 21411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21411,
        GIR_EraseRootFromParent_Done,
      // Label 18766: @1375796
      GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1375902), // Rule ID 21414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21414,
        GIR_EraseRootFromParent_Done,
      // Label 18767: @1375902
      GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1376008), // Rule ID 21415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21415,
        GIR_EraseRootFromParent_Done,
      // Label 18768: @1376008
      GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1376114), // Rule ID 21418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21418,
        GIR_EraseRootFromParent_Done,
      // Label 18769: @1376114
      GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1376220), // Rule ID 21419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21419,
        GIR_EraseRootFromParent_Done,
      // Label 18770: @1376220
      GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1376326), // Rule ID 21422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21422,
        GIR_EraseRootFromParent_Done,
      // Label 18771: @1376326
      GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1376432), // Rule ID 21423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21423,
        GIR_EraseRootFromParent_Done,
      // Label 18772: @1376432
      GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1376538), // Rule ID 21426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21426,
        GIR_EraseRootFromParent_Done,
      // Label 18773: @1376538
      GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1376644), // Rule ID 21427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21427,
        GIR_EraseRootFromParent_Done,
      // Label 18774: @1376644
      GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1376750), // Rule ID 21430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21430,
        GIR_EraseRootFromParent_Done,
      // Label 18775: @1376750
      GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1376856), // Rule ID 21431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21431,
        GIR_EraseRootFromParent_Done,
      // Label 18776: @1376856
      GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1376962), // Rule ID 21434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21434,
        GIR_EraseRootFromParent_Done,
      // Label 18777: @1376962
      GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1377068), // Rule ID 21435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21435,
        GIR_EraseRootFromParent_Done,
      // Label 18778: @1377068
      GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1377174), // Rule ID 21438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21438,
        GIR_EraseRootFromParent_Done,
      // Label 18779: @1377174
      GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1377280), // Rule ID 21439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21439,
        GIR_EraseRootFromParent_Done,
      // Label 18780: @1377280
      GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1377386), // Rule ID 21442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21442,
        GIR_EraseRootFromParent_Done,
      // Label 18781: @1377386
      GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1377492), // Rule ID 21443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21443,
        GIR_EraseRootFromParent_Done,
      // Label 18782: @1377492
      GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1377598), // Rule ID 21446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21446,
        GIR_EraseRootFromParent_Done,
      // Label 18783: @1377598
      GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1377704), // Rule ID 21447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21447,
        GIR_EraseRootFromParent_Done,
      // Label 18784: @1377704
      GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1377810), // Rule ID 21450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21450,
        GIR_EraseRootFromParent_Done,
      // Label 18785: @1377810
      GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1377916), // Rule ID 21451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21451,
        GIR_EraseRootFromParent_Done,
      // Label 18786: @1377916
      GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1378033), // Rule ID 2656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2656,
        GIR_EraseRootFromParent_Done,
      // Label 18787: @1378033
      GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1378150), // Rule ID 2657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2657,
        GIR_EraseRootFromParent_Done,
      // Label 18788: @1378150
      GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1378267), // Rule ID 2664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2664,
        GIR_EraseRootFromParent_Done,
      // Label 18789: @1378267
      GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1378384), // Rule ID 2665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2665,
        GIR_EraseRootFromParent_Done,
      // Label 18790: @1378384
      GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1378501), // Rule ID 2672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2672,
        GIR_EraseRootFromParent_Done,
      // Label 18791: @1378501
      GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1378618), // Rule ID 2673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2673,
        GIR_EraseRootFromParent_Done,
      // Label 18792: @1378618
      GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1378735), // Rule ID 2680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2680,
        GIR_EraseRootFromParent_Done,
      // Label 18793: @1378735
      GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1378852), // Rule ID 2681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2681,
        GIR_EraseRootFromParent_Done,
      // Label 18794: @1378852
      GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1378969), // Rule ID 2688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2688,
        GIR_EraseRootFromParent_Done,
      // Label 18795: @1378969
      GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1379086), // Rule ID 2689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2689,
        GIR_EraseRootFromParent_Done,
      // Label 18796: @1379086
      GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1379203), // Rule ID 2696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2696,
        GIR_EraseRootFromParent_Done,
      // Label 18797: @1379203
      GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1379320), // Rule ID 2697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2697,
        GIR_EraseRootFromParent_Done,
      // Label 18798: @1379320
      GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1379437), // Rule ID 2704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2704,
        GIR_EraseRootFromParent_Done,
      // Label 18799: @1379437
      GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1379554), // Rule ID 2705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2705,
        GIR_EraseRootFromParent_Done,
      // Label 18800: @1379554
      GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1379671), // Rule ID 2712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2712,
        GIR_EraseRootFromParent_Done,
      // Label 18801: @1379671
      GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1379788), // Rule ID 2713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2713,
        GIR_EraseRootFromParent_Done,
      // Label 18802: @1379788
      GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1379905), // Rule ID 2720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2720,
        GIR_EraseRootFromParent_Done,
      // Label 18803: @1379905
      GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1380022), // Rule ID 2721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2721,
        GIR_EraseRootFromParent_Done,
      // Label 18804: @1380022
      GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1380139), // Rule ID 2728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2728,
        GIR_EraseRootFromParent_Done,
      // Label 18805: @1380139
      GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1380256), // Rule ID 2729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2729,
        GIR_EraseRootFromParent_Done,
      // Label 18806: @1380256
      GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1380373), // Rule ID 2736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2736,
        GIR_EraseRootFromParent_Done,
      // Label 18807: @1380373
      GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1380490), // Rule ID 2737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2737,
        GIR_EraseRootFromParent_Done,
      // Label 18808: @1380490
      GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1380607), // Rule ID 2744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2744,
        GIR_EraseRootFromParent_Done,
      // Label 18809: @1380607
      GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1380724), // Rule ID 2745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2745,
        GIR_EraseRootFromParent_Done,
      // Label 18810: @1380724
      GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1380841), // Rule ID 2752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2752,
        GIR_EraseRootFromParent_Done,
      // Label 18811: @1380841
      GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1380958), // Rule ID 2753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2753,
        GIR_EraseRootFromParent_Done,
      // Label 18812: @1380958
      GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1381075), // Rule ID 2760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2760,
        GIR_EraseRootFromParent_Done,
      // Label 18813: @1381075
      GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1381192), // Rule ID 2761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2761,
        GIR_EraseRootFromParent_Done,
      // Label 18814: @1381192
      GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1381309), // Rule ID 2768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2768,
        GIR_EraseRootFromParent_Done,
      // Label 18815: @1381309
      GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1381426), // Rule ID 2769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2769,
        GIR_EraseRootFromParent_Done,
      // Label 18816: @1381426
      GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1381543), // Rule ID 2776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2776,
        GIR_EraseRootFromParent_Done,
      // Label 18817: @1381543
      GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1381660), // Rule ID 2777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2777,
        GIR_EraseRootFromParent_Done,
      // Label 18818: @1381660
      GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1381777), // Rule ID 2784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2784,
        GIR_EraseRootFromParent_Done,
      // Label 18819: @1381777
      GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1381894), // Rule ID 2785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2785,
        GIR_EraseRootFromParent_Done,
      // Label 18820: @1381894
      GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1382011), // Rule ID 2792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2792,
        GIR_EraseRootFromParent_Done,
      // Label 18821: @1382011
      GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1382128), // Rule ID 2793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2793,
        GIR_EraseRootFromParent_Done,
      // Label 18822: @1382128
      GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1382245), // Rule ID 2800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2800,
        GIR_EraseRootFromParent_Done,
      // Label 18823: @1382245
      GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1382362), // Rule ID 2801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2801,
        GIR_EraseRootFromParent_Done,
      // Label 18824: @1382362
      GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1382479), // Rule ID 2808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2808,
        GIR_EraseRootFromParent_Done,
      // Label 18825: @1382479
      GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1382596), // Rule ID 2809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2809,
        GIR_EraseRootFromParent_Done,
      // Label 18826: @1382596
      GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1382713), // Rule ID 2816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2816,
        GIR_EraseRootFromParent_Done,
      // Label 18827: @1382713
      GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1382830), // Rule ID 2817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2817,
        GIR_EraseRootFromParent_Done,
      // Label 18828: @1382830
      GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1382947), // Rule ID 2824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2824,
        GIR_EraseRootFromParent_Done,
      // Label 18829: @1382947
      GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1383064), // Rule ID 2825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2825,
        GIR_EraseRootFromParent_Done,
      // Label 18830: @1383064
      GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1383179), // Rule ID 3000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3000,
        GIR_EraseRootFromParent_Done,
      // Label 18831: @1383179
      GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1383294), // Rule ID 3001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3001,
        GIR_EraseRootFromParent_Done,
      // Label 18832: @1383294
      GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1383409), // Rule ID 3004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3004,
        GIR_EraseRootFromParent_Done,
      // Label 18833: @1383409
      GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1383524), // Rule ID 3005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3005,
        GIR_EraseRootFromParent_Done,
      // Label 18834: @1383524
      GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1383639), // Rule ID 3008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3008,
        GIR_EraseRootFromParent_Done,
      // Label 18835: @1383639
      GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1383754), // Rule ID 3009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3009,
        GIR_EraseRootFromParent_Done,
      // Label 18836: @1383754
      GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1383869), // Rule ID 3012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3012,
        GIR_EraseRootFromParent_Done,
      // Label 18837: @1383869
      GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1383984), // Rule ID 3013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3013,
        GIR_EraseRootFromParent_Done,
      // Label 18838: @1383984
      GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1384099), // Rule ID 3016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3016,
        GIR_EraseRootFromParent_Done,
      // Label 18839: @1384099
      GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1384214), // Rule ID 3017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3017,
        GIR_EraseRootFromParent_Done,
      // Label 18840: @1384214
      GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1384329), // Rule ID 3020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3020,
        GIR_EraseRootFromParent_Done,
      // Label 18841: @1384329
      GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1384444), // Rule ID 3021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3021,
        GIR_EraseRootFromParent_Done,
      // Label 18842: @1384444
      GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1384559), // Rule ID 3024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3024,
        GIR_EraseRootFromParent_Done,
      // Label 18843: @1384559
      GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1384674), // Rule ID 3025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3025,
        GIR_EraseRootFromParent_Done,
      // Label 18844: @1384674
      GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1384789), // Rule ID 3028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3028,
        GIR_EraseRootFromParent_Done,
      // Label 18845: @1384789
      GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1384904), // Rule ID 3029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3029,
        GIR_EraseRootFromParent_Done,
      // Label 18846: @1384904
      GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1385019), // Rule ID 3032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3032,
        GIR_EraseRootFromParent_Done,
      // Label 18847: @1385019
      GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1385134), // Rule ID 3033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3033,
        GIR_EraseRootFromParent_Done,
      // Label 18848: @1385134
      GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1385249), // Rule ID 3036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3036,
        GIR_EraseRootFromParent_Done,
      // Label 18849: @1385249
      GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1385364), // Rule ID 3037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3037,
        GIR_EraseRootFromParent_Done,
      // Label 18850: @1385364
      GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1385479), // Rule ID 3040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3040,
        GIR_EraseRootFromParent_Done,
      // Label 18851: @1385479
      GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1385594), // Rule ID 3041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3041,
        GIR_EraseRootFromParent_Done,
      // Label 18852: @1385594
      GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1385709), // Rule ID 3044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3044,
        GIR_EraseRootFromParent_Done,
      // Label 18853: @1385709
      GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1385824), // Rule ID 3045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3045,
        GIR_EraseRootFromParent_Done,
      // Label 18854: @1385824
      GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1385939), // Rule ID 3048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3048,
        GIR_EraseRootFromParent_Done,
      // Label 18855: @1385939
      GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1386054), // Rule ID 3049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3049,
        GIR_EraseRootFromParent_Done,
      // Label 18856: @1386054
      GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1386169), // Rule ID 3052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3052,
        GIR_EraseRootFromParent_Done,
      // Label 18857: @1386169
      GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1386284), // Rule ID 3053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3053,
        GIR_EraseRootFromParent_Done,
      // Label 18858: @1386284
      GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1386399), // Rule ID 3056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3056,
        GIR_EraseRootFromParent_Done,
      // Label 18859: @1386399
      GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1386514), // Rule ID 3057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3057,
        GIR_EraseRootFromParent_Done,
      // Label 18860: @1386514
      GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1386629), // Rule ID 3060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3060,
        GIR_EraseRootFromParent_Done,
      // Label 18861: @1386629
      GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1386744), // Rule ID 3061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3061,
        GIR_EraseRootFromParent_Done,
      // Label 18862: @1386744
      GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1386859), // Rule ID 3064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3064,
        GIR_EraseRootFromParent_Done,
      // Label 18863: @1386859
      GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1386974), // Rule ID 3065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3065,
        GIR_EraseRootFromParent_Done,
      // Label 18864: @1386974
      GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1387089), // Rule ID 3068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3068,
        GIR_EraseRootFromParent_Done,
      // Label 18865: @1387089
      GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1387204), // Rule ID 3069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3069,
        GIR_EraseRootFromParent_Done,
      // Label 18866: @1387204
      GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1387319), // Rule ID 3072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3072,
        GIR_EraseRootFromParent_Done,
      // Label 18867: @1387319
      GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1387434), // Rule ID 3073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3073,
        GIR_EraseRootFromParent_Done,
      // Label 18868: @1387434
      GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1387549), // Rule ID 3076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3076,
        GIR_EraseRootFromParent_Done,
      // Label 18869: @1387549
      GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1387664), // Rule ID 3077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3077,
        GIR_EraseRootFromParent_Done,
      // Label 18870: @1387664
      GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1387779), // Rule ID 3080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3080,
        GIR_EraseRootFromParent_Done,
      // Label 18871: @1387779
      GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1387894), // Rule ID 3081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3081,
        GIR_EraseRootFromParent_Done,
      // Label 18872: @1387894
      GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1388009), // Rule ID 3084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3084,
        GIR_EraseRootFromParent_Done,
      // Label 18873: @1388009
      GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1388124), // Rule ID 3085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3085,
        GIR_EraseRootFromParent_Done,
      // Label 18874: @1388124
      GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1388239), // Rule ID 3352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3352,
        GIR_EraseRootFromParent_Done,
      // Label 18875: @1388239
      GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1388354), // Rule ID 3353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3353,
        GIR_EraseRootFromParent_Done,
      // Label 18876: @1388354
      GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1388469), // Rule ID 3356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3356,
        GIR_EraseRootFromParent_Done,
      // Label 18877: @1388469
      GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1388584), // Rule ID 3357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3357,
        GIR_EraseRootFromParent_Done,
      // Label 18878: @1388584
      GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1388699), // Rule ID 3360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3360,
        GIR_EraseRootFromParent_Done,
      // Label 18879: @1388699
      GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1388814), // Rule ID 3361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3361,
        GIR_EraseRootFromParent_Done,
      // Label 18880: @1388814
      GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1388929), // Rule ID 3364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3364,
        GIR_EraseRootFromParent_Done,
      // Label 18881: @1388929
      GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1389044), // Rule ID 3365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3365,
        GIR_EraseRootFromParent_Done,
      // Label 18882: @1389044
      GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1389159), // Rule ID 3368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3368,
        GIR_EraseRootFromParent_Done,
      // Label 18883: @1389159
      GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1389274), // Rule ID 3369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3369,
        GIR_EraseRootFromParent_Done,
      // Label 18884: @1389274
      GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1389389), // Rule ID 3372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3372,
        GIR_EraseRootFromParent_Done,
      // Label 18885: @1389389
      GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1389504), // Rule ID 3373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3373,
        GIR_EraseRootFromParent_Done,
      // Label 18886: @1389504
      GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1389619), // Rule ID 3376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3376,
        GIR_EraseRootFromParent_Done,
      // Label 18887: @1389619
      GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1389734), // Rule ID 3377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3377,
        GIR_EraseRootFromParent_Done,
      // Label 18888: @1389734
      GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1389849), // Rule ID 3380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3380,
        GIR_EraseRootFromParent_Done,
      // Label 18889: @1389849
      GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1389964), // Rule ID 3381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3381,
        GIR_EraseRootFromParent_Done,
      // Label 18890: @1389964
      GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1390079), // Rule ID 3384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3384,
        GIR_EraseRootFromParent_Done,
      // Label 18891: @1390079
      GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1390194), // Rule ID 3385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3385,
        GIR_EraseRootFromParent_Done,
      // Label 18892: @1390194
      GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1390309), // Rule ID 3388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3388,
        GIR_EraseRootFromParent_Done,
      // Label 18893: @1390309
      GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1390424), // Rule ID 3389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3389,
        GIR_EraseRootFromParent_Done,
      // Label 18894: @1390424
      GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1390539), // Rule ID 3392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3392,
        GIR_EraseRootFromParent_Done,
      // Label 18895: @1390539
      GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1390654), // Rule ID 3393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3393,
        GIR_EraseRootFromParent_Done,
      // Label 18896: @1390654
      GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1390769), // Rule ID 3396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3396,
        GIR_EraseRootFromParent_Done,
      // Label 18897: @1390769
      GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1390884), // Rule ID 3397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3397,
        GIR_EraseRootFromParent_Done,
      // Label 18898: @1390884
      GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1390999), // Rule ID 3400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3400,
        GIR_EraseRootFromParent_Done,
      // Label 18899: @1390999
      GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1391114), // Rule ID 3401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3401,
        GIR_EraseRootFromParent_Done,
      // Label 18900: @1391114
      GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1391229), // Rule ID 3404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3404,
        GIR_EraseRootFromParent_Done,
      // Label 18901: @1391229
      GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1391344), // Rule ID 3405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3405,
        GIR_EraseRootFromParent_Done,
      // Label 18902: @1391344
      GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1391459), // Rule ID 3408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3408,
        GIR_EraseRootFromParent_Done,
      // Label 18903: @1391459
      GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1391574), // Rule ID 3409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3409,
        GIR_EraseRootFromParent_Done,
      // Label 18904: @1391574
      GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1391689), // Rule ID 3412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3412,
        GIR_EraseRootFromParent_Done,
      // Label 18905: @1391689
      GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1391804), // Rule ID 3413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3413,
        GIR_EraseRootFromParent_Done,
      // Label 18906: @1391804
      GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1391919), // Rule ID 3416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3416,
        GIR_EraseRootFromParent_Done,
      // Label 18907: @1391919
      GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1392034), // Rule ID 3417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3417,
        GIR_EraseRootFromParent_Done,
      // Label 18908: @1392034
      GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1392149), // Rule ID 3420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3420,
        GIR_EraseRootFromParent_Done,
      // Label 18909: @1392149
      GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1392264), // Rule ID 3421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3421,
        GIR_EraseRootFromParent_Done,
      // Label 18910: @1392264
      GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1392379), // Rule ID 3424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3424,
        GIR_EraseRootFromParent_Done,
      // Label 18911: @1392379
      GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1392494), // Rule ID 3425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3425,
        GIR_EraseRootFromParent_Done,
      // Label 18912: @1392494
      GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1392609), // Rule ID 3428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3428,
        GIR_EraseRootFromParent_Done,
      // Label 18913: @1392609
      GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1392724), // Rule ID 3429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3429,
        GIR_EraseRootFromParent_Done,
      // Label 18914: @1392724
      GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1392839), // Rule ID 3432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3432,
        GIR_EraseRootFromParent_Done,
      // Label 18915: @1392839
      GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1392954), // Rule ID 3433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3433,
        GIR_EraseRootFromParent_Done,
      // Label 18916: @1392954
      GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1393069), // Rule ID 3436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3436,
        GIR_EraseRootFromParent_Done,
      // Label 18917: @1393069
      GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1393184), // Rule ID 3437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3437,
        GIR_EraseRootFromParent_Done,
      // Label 18918: @1393184
      GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1393299), // Rule ID 5800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5800,
        GIR_EraseRootFromParent_Done,
      // Label 18919: @1393299
      GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1393414), // Rule ID 5801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5801,
        GIR_EraseRootFromParent_Done,
      // Label 18920: @1393414
      GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1393529), // Rule ID 5804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5804,
        GIR_EraseRootFromParent_Done,
      // Label 18921: @1393529
      GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1393644), // Rule ID 5805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5805,
        GIR_EraseRootFromParent_Done,
      // Label 18922: @1393644
      GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1393759), // Rule ID 5808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5808,
        GIR_EraseRootFromParent_Done,
      // Label 18923: @1393759
      GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1393874), // Rule ID 5809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5809,
        GIR_EraseRootFromParent_Done,
      // Label 18924: @1393874
      GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1393989), // Rule ID 5812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5812,
        GIR_EraseRootFromParent_Done,
      // Label 18925: @1393989
      GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1394104), // Rule ID 5813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5813,
        GIR_EraseRootFromParent_Done,
      // Label 18926: @1394104
      GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1394219), // Rule ID 5816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5816,
        GIR_EraseRootFromParent_Done,
      // Label 18927: @1394219
      GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1394334), // Rule ID 5817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5817,
        GIR_EraseRootFromParent_Done,
      // Label 18928: @1394334
      GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1394449), // Rule ID 5820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5820,
        GIR_EraseRootFromParent_Done,
      // Label 18929: @1394449
      GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1394564), // Rule ID 5821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5821,
        GIR_EraseRootFromParent_Done,
      // Label 18930: @1394564
      GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1394679), // Rule ID 5824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5824,
        GIR_EraseRootFromParent_Done,
      // Label 18931: @1394679
      GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1394794), // Rule ID 5825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5825,
        GIR_EraseRootFromParent_Done,
      // Label 18932: @1394794
      GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1394909), // Rule ID 5828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5828,
        GIR_EraseRootFromParent_Done,
      // Label 18933: @1394909
      GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1395024), // Rule ID 5829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5829,
        GIR_EraseRootFromParent_Done,
      // Label 18934: @1395024
      GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1395139), // Rule ID 5832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5832,
        GIR_EraseRootFromParent_Done,
      // Label 18935: @1395139
      GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1395254), // Rule ID 5833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5833,
        GIR_EraseRootFromParent_Done,
      // Label 18936: @1395254
      GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1395369), // Rule ID 5836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5836,
        GIR_EraseRootFromParent_Done,
      // Label 18937: @1395369
      GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1395484), // Rule ID 5837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5837,
        GIR_EraseRootFromParent_Done,
      // Label 18938: @1395484
      GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1395599), // Rule ID 5840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5840,
        GIR_EraseRootFromParent_Done,
      // Label 18939: @1395599
      GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1395714), // Rule ID 5841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5841,
        GIR_EraseRootFromParent_Done,
      // Label 18940: @1395714
      GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1395829), // Rule ID 5844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5844,
        GIR_EraseRootFromParent_Done,
      // Label 18941: @1395829
      GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1395944), // Rule ID 5845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5845,
        GIR_EraseRootFromParent_Done,
      // Label 18942: @1395944
      GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1396059), // Rule ID 5848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5848,
        GIR_EraseRootFromParent_Done,
      // Label 18943: @1396059
      GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1396174), // Rule ID 5849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5849,
        GIR_EraseRootFromParent_Done,
      // Label 18944: @1396174
      GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1396289), // Rule ID 5852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5852,
        GIR_EraseRootFromParent_Done,
      // Label 18945: @1396289
      GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1396404), // Rule ID 5853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5853,
        GIR_EraseRootFromParent_Done,
      // Label 18946: @1396404
      GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1396519), // Rule ID 5856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5856,
        GIR_EraseRootFromParent_Done,
      // Label 18947: @1396519
      GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1396634), // Rule ID 5857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5857,
        GIR_EraseRootFromParent_Done,
      // Label 18948: @1396634
      GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1396749), // Rule ID 5860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5860,
        GIR_EraseRootFromParent_Done,
      // Label 18949: @1396749
      GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1396864), // Rule ID 5861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5861,
        GIR_EraseRootFromParent_Done,
      // Label 18950: @1396864
      GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1396979), // Rule ID 5864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5864,
        GIR_EraseRootFromParent_Done,
      // Label 18951: @1396979
      GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1397094), // Rule ID 5865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5865,
        GIR_EraseRootFromParent_Done,
      // Label 18952: @1397094
      GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1397209), // Rule ID 5868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5868,
        GIR_EraseRootFromParent_Done,
      // Label 18953: @1397209
      GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1397324), // Rule ID 5869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5869,
        GIR_EraseRootFromParent_Done,
      // Label 18954: @1397324
      GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1397439), // Rule ID 5872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5872,
        GIR_EraseRootFromParent_Done,
      // Label 18955: @1397439
      GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1397554), // Rule ID 5873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5873,
        GIR_EraseRootFromParent_Done,
      // Label 18956: @1397554
      GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1397669), // Rule ID 5876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5876,
        GIR_EraseRootFromParent_Done,
      // Label 18957: @1397669
      GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1397784), // Rule ID 5877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5877,
        GIR_EraseRootFromParent_Done,
      // Label 18958: @1397784
      GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1397899), // Rule ID 5880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5880,
        GIR_EraseRootFromParent_Done,
      // Label 18959: @1397899
      GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1398014), // Rule ID 5881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5881,
        GIR_EraseRootFromParent_Done,
      // Label 18960: @1398014
      GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1398129), // Rule ID 5884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5884,
        GIR_EraseRootFromParent_Done,
      // Label 18961: @1398129
      GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1398244), // Rule ID 5885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5885,
        GIR_EraseRootFromParent_Done,
      // Label 18962: @1398244
      GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1398359), // Rule ID 6064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6064,
        GIR_EraseRootFromParent_Done,
      // Label 18963: @1398359
      GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1398474), // Rule ID 6065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6065,
        GIR_EraseRootFromParent_Done,
      // Label 18964: @1398474
      GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1398589), // Rule ID 6068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6068,
        GIR_EraseRootFromParent_Done,
      // Label 18965: @1398589
      GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1398704), // Rule ID 6069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6069,
        GIR_EraseRootFromParent_Done,
      // Label 18966: @1398704
      GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1398819), // Rule ID 6072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6072,
        GIR_EraseRootFromParent_Done,
      // Label 18967: @1398819
      GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1398934), // Rule ID 6073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6073,
        GIR_EraseRootFromParent_Done,
      // Label 18968: @1398934
      GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1399049), // Rule ID 6076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6076,
        GIR_EraseRootFromParent_Done,
      // Label 18969: @1399049
      GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1399164), // Rule ID 6077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6077,
        GIR_EraseRootFromParent_Done,
      // Label 18970: @1399164
      GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1399279), // Rule ID 6080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6080,
        GIR_EraseRootFromParent_Done,
      // Label 18971: @1399279
      GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1399394), // Rule ID 6081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6081,
        GIR_EraseRootFromParent_Done,
      // Label 18972: @1399394
      GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1399509), // Rule ID 6084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6084,
        GIR_EraseRootFromParent_Done,
      // Label 18973: @1399509
      GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1399624), // Rule ID 6085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6085,
        GIR_EraseRootFromParent_Done,
      // Label 18974: @1399624
      GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1399739), // Rule ID 6088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6088,
        GIR_EraseRootFromParent_Done,
      // Label 18975: @1399739
      GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1399854), // Rule ID 6089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6089,
        GIR_EraseRootFromParent_Done,
      // Label 18976: @1399854
      GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1399969), // Rule ID 6092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6092,
        GIR_EraseRootFromParent_Done,
      // Label 18977: @1399969
      GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1400084), // Rule ID 6093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6093,
        GIR_EraseRootFromParent_Done,
      // Label 18978: @1400084
      GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1400199), // Rule ID 6096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6096,
        GIR_EraseRootFromParent_Done,
      // Label 18979: @1400199
      GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1400314), // Rule ID 6097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6097,
        GIR_EraseRootFromParent_Done,
      // Label 18980: @1400314
      GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1400429), // Rule ID 6100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6100,
        GIR_EraseRootFromParent_Done,
      // Label 18981: @1400429
      GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1400544), // Rule ID 6101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6101,
        GIR_EraseRootFromParent_Done,
      // Label 18982: @1400544
      GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1400659), // Rule ID 6104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6104,
        GIR_EraseRootFromParent_Done,
      // Label 18983: @1400659
      GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1400774), // Rule ID 6105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6105,
        GIR_EraseRootFromParent_Done,
      // Label 18984: @1400774
      GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1400889), // Rule ID 6108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6108,
        GIR_EraseRootFromParent_Done,
      // Label 18985: @1400889
      GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1401004), // Rule ID 6109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6109,
        GIR_EraseRootFromParent_Done,
      // Label 18986: @1401004
      GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1401119), // Rule ID 6112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6112,
        GIR_EraseRootFromParent_Done,
      // Label 18987: @1401119
      GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1401234), // Rule ID 6113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6113,
        GIR_EraseRootFromParent_Done,
      // Label 18988: @1401234
      GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1401349), // Rule ID 6116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6116,
        GIR_EraseRootFromParent_Done,
      // Label 18989: @1401349
      GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1401464), // Rule ID 6117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6117,
        GIR_EraseRootFromParent_Done,
      // Label 18990: @1401464
      GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1401579), // Rule ID 6120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6120,
        GIR_EraseRootFromParent_Done,
      // Label 18991: @1401579
      GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1401694), // Rule ID 6121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6121,
        GIR_EraseRootFromParent_Done,
      // Label 18992: @1401694
      GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1401809), // Rule ID 6124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6124,
        GIR_EraseRootFromParent_Done,
      // Label 18993: @1401809
      GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1401924), // Rule ID 6125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6125,
        GIR_EraseRootFromParent_Done,
      // Label 18994: @1401924
      GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1402039), // Rule ID 6128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6128,
        GIR_EraseRootFromParent_Done,
      // Label 18995: @1402039
      GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1402154), // Rule ID 6129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6129,
        GIR_EraseRootFromParent_Done,
      // Label 18996: @1402154
      GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1402269), // Rule ID 6132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6132,
        GIR_EraseRootFromParent_Done,
      // Label 18997: @1402269
      GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1402384), // Rule ID 6133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6133,
        GIR_EraseRootFromParent_Done,
      // Label 18998: @1402384
      GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1402499), // Rule ID 6136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6136,
        GIR_EraseRootFromParent_Done,
      // Label 18999: @1402499
      GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1402614), // Rule ID 6137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6137,
        GIR_EraseRootFromParent_Done,
      // Label 19000: @1402614
      GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1402729), // Rule ID 6140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6140,
        GIR_EraseRootFromParent_Done,
      // Label 19001: @1402729
      GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1402844), // Rule ID 6141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6141,
        GIR_EraseRootFromParent_Done,
      // Label 19002: @1402844
      GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1402959), // Rule ID 6144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6144,
        GIR_EraseRootFromParent_Done,
      // Label 19003: @1402959
      GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1403074), // Rule ID 6145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6145,
        GIR_EraseRootFromParent_Done,
      // Label 19004: @1403074
      GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1403189), // Rule ID 6148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6148,
        GIR_EraseRootFromParent_Done,
      // Label 19005: @1403189
      GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1403304), // Rule ID 6149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6149,
        GIR_EraseRootFromParent_Done,
      // Label 19006: @1403304
      GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1403419), // Rule ID 6328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6328,
        GIR_EraseRootFromParent_Done,
      // Label 19007: @1403419
      GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1403534), // Rule ID 6329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6329,
        GIR_EraseRootFromParent_Done,
      // Label 19008: @1403534
      GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1403649), // Rule ID 6332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6332,
        GIR_EraseRootFromParent_Done,
      // Label 19009: @1403649
      GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1403764), // Rule ID 6333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6333,
        GIR_EraseRootFromParent_Done,
      // Label 19010: @1403764
      GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1403879), // Rule ID 6336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6336,
        GIR_EraseRootFromParent_Done,
      // Label 19011: @1403879
      GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1403994), // Rule ID 6337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6337,
        GIR_EraseRootFromParent_Done,
      // Label 19012: @1403994
      GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1404109), // Rule ID 6340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6340,
        GIR_EraseRootFromParent_Done,
      // Label 19013: @1404109
      GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1404224), // Rule ID 6341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6341,
        GIR_EraseRootFromParent_Done,
      // Label 19014: @1404224
      GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1404339), // Rule ID 6344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6344,
        GIR_EraseRootFromParent_Done,
      // Label 19015: @1404339
      GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1404454), // Rule ID 6345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6345,
        GIR_EraseRootFromParent_Done,
      // Label 19016: @1404454
      GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1404569), // Rule ID 6348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6348,
        GIR_EraseRootFromParent_Done,
      // Label 19017: @1404569
      GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1404684), // Rule ID 6349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6349,
        GIR_EraseRootFromParent_Done,
      // Label 19018: @1404684
      GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1404799), // Rule ID 6352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6352,
        GIR_EraseRootFromParent_Done,
      // Label 19019: @1404799
      GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1404914), // Rule ID 6353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6353,
        GIR_EraseRootFromParent_Done,
      // Label 19020: @1404914
      GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1405029), // Rule ID 6356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6356,
        GIR_EraseRootFromParent_Done,
      // Label 19021: @1405029
      GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1405144), // Rule ID 6357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6357,
        GIR_EraseRootFromParent_Done,
      // Label 19022: @1405144
      GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1405259), // Rule ID 6360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6360,
        GIR_EraseRootFromParent_Done,
      // Label 19023: @1405259
      GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1405374), // Rule ID 6361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6361,
        GIR_EraseRootFromParent_Done,
      // Label 19024: @1405374
      GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1405489), // Rule ID 6364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6364,
        GIR_EraseRootFromParent_Done,
      // Label 19025: @1405489
      GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1405604), // Rule ID 6365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6365,
        GIR_EraseRootFromParent_Done,
      // Label 19026: @1405604
      GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1405719), // Rule ID 6368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6368,
        GIR_EraseRootFromParent_Done,
      // Label 19027: @1405719
      GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1405834), // Rule ID 6369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6369,
        GIR_EraseRootFromParent_Done,
      // Label 19028: @1405834
      GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1405949), // Rule ID 6372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6372,
        GIR_EraseRootFromParent_Done,
      // Label 19029: @1405949
      GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1406064), // Rule ID 6373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6373,
        GIR_EraseRootFromParent_Done,
      // Label 19030: @1406064
      GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1406179), // Rule ID 6376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6376,
        GIR_EraseRootFromParent_Done,
      // Label 19031: @1406179
      GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1406294), // Rule ID 6377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6377,
        GIR_EraseRootFromParent_Done,
      // Label 19032: @1406294
      GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1406409), // Rule ID 6380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6380,
        GIR_EraseRootFromParent_Done,
      // Label 19033: @1406409
      GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1406524), // Rule ID 6381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6381,
        GIR_EraseRootFromParent_Done,
      // Label 19034: @1406524
      GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1406639), // Rule ID 6384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6384,
        GIR_EraseRootFromParent_Done,
      // Label 19035: @1406639
      GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1406754), // Rule ID 6385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6385,
        GIR_EraseRootFromParent_Done,
      // Label 19036: @1406754
      GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1406869), // Rule ID 6388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6388,
        GIR_EraseRootFromParent_Done,
      // Label 19037: @1406869
      GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1406984), // Rule ID 6389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6389,
        GIR_EraseRootFromParent_Done,
      // Label 19038: @1406984
      GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1407099), // Rule ID 6392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6392,
        GIR_EraseRootFromParent_Done,
      // Label 19039: @1407099
      GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1407214), // Rule ID 6393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6393,
        GIR_EraseRootFromParent_Done,
      // Label 19040: @1407214
      GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1407329), // Rule ID 6396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6396,
        GIR_EraseRootFromParent_Done,
      // Label 19041: @1407329
      GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1407444), // Rule ID 6397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6397,
        GIR_EraseRootFromParent_Done,
      // Label 19042: @1407444
      GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1407559), // Rule ID 6400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6400,
        GIR_EraseRootFromParent_Done,
      // Label 19043: @1407559
      GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1407674), // Rule ID 6401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6401,
        GIR_EraseRootFromParent_Done,
      // Label 19044: @1407674
      GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1407789), // Rule ID 6404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6404,
        GIR_EraseRootFromParent_Done,
      // Label 19045: @1407789
      GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1407904), // Rule ID 6405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6405,
        GIR_EraseRootFromParent_Done,
      // Label 19046: @1407904
      GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1408019), // Rule ID 6408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6408,
        GIR_EraseRootFromParent_Done,
      // Label 19047: @1408019
      GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1408134), // Rule ID 6409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6409,
        GIR_EraseRootFromParent_Done,
      // Label 19048: @1408134
      GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1408249), // Rule ID 6412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6412,
        GIR_EraseRootFromParent_Done,
      // Label 19049: @1408249
      GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1408364), // Rule ID 6413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6413,
        GIR_EraseRootFromParent_Done,
      // Label 19050: @1408364
      GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1408479), // Rule ID 6592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6592,
        GIR_EraseRootFromParent_Done,
      // Label 19051: @1408479
      GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1408594), // Rule ID 6593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6593,
        GIR_EraseRootFromParent_Done,
      // Label 19052: @1408594
      GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1408709), // Rule ID 6596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6596,
        GIR_EraseRootFromParent_Done,
      // Label 19053: @1408709
      GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1408824), // Rule ID 6597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6597,
        GIR_EraseRootFromParent_Done,
      // Label 19054: @1408824
      GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1408939), // Rule ID 6600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6600,
        GIR_EraseRootFromParent_Done,
      // Label 19055: @1408939
      GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1409054), // Rule ID 6601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6601,
        GIR_EraseRootFromParent_Done,
      // Label 19056: @1409054
      GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1409169), // Rule ID 6604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6604,
        GIR_EraseRootFromParent_Done,
      // Label 19057: @1409169
      GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1409284), // Rule ID 6605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6605,
        GIR_EraseRootFromParent_Done,
      // Label 19058: @1409284
      GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1409399), // Rule ID 6608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6608,
        GIR_EraseRootFromParent_Done,
      // Label 19059: @1409399
      GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1409514), // Rule ID 6609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6609,
        GIR_EraseRootFromParent_Done,
      // Label 19060: @1409514
      GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1409629), // Rule ID 6612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6612,
        GIR_EraseRootFromParent_Done,
      // Label 19061: @1409629
      GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1409744), // Rule ID 6613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6613,
        GIR_EraseRootFromParent_Done,
      // Label 19062: @1409744
      GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1409859), // Rule ID 6616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6616,
        GIR_EraseRootFromParent_Done,
      // Label 19063: @1409859
      GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1409974), // Rule ID 6617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6617,
        GIR_EraseRootFromParent_Done,
      // Label 19064: @1409974
      GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1410089), // Rule ID 6620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6620,
        GIR_EraseRootFromParent_Done,
      // Label 19065: @1410089
      GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1410204), // Rule ID 6621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6621,
        GIR_EraseRootFromParent_Done,
      // Label 19066: @1410204
      GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1410319), // Rule ID 6624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6624,
        GIR_EraseRootFromParent_Done,
      // Label 19067: @1410319
      GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1410434), // Rule ID 6625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6625,
        GIR_EraseRootFromParent_Done,
      // Label 19068: @1410434
      GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1410549), // Rule ID 6628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6628,
        GIR_EraseRootFromParent_Done,
      // Label 19069: @1410549
      GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1410664), // Rule ID 6629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6629,
        GIR_EraseRootFromParent_Done,
      // Label 19070: @1410664
      GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1410779), // Rule ID 6632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6632,
        GIR_EraseRootFromParent_Done,
      // Label 19071: @1410779
      GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1410894), // Rule ID 6633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6633,
        GIR_EraseRootFromParent_Done,
      // Label 19072: @1410894
      GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1411009), // Rule ID 6636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6636,
        GIR_EraseRootFromParent_Done,
      // Label 19073: @1411009
      GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1411124), // Rule ID 6637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6637,
        GIR_EraseRootFromParent_Done,
      // Label 19074: @1411124
      GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1411239), // Rule ID 6640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6640,
        GIR_EraseRootFromParent_Done,
      // Label 19075: @1411239
      GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1411354), // Rule ID 6641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6641,
        GIR_EraseRootFromParent_Done,
      // Label 19076: @1411354
      GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1411469), // Rule ID 6644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6644,
        GIR_EraseRootFromParent_Done,
      // Label 19077: @1411469
      GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1411584), // Rule ID 6645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6645,
        GIR_EraseRootFromParent_Done,
      // Label 19078: @1411584
      GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1411699), // Rule ID 6648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6648,
        GIR_EraseRootFromParent_Done,
      // Label 19079: @1411699
      GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1411814), // Rule ID 6649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6649,
        GIR_EraseRootFromParent_Done,
      // Label 19080: @1411814
      GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1411929), // Rule ID 6652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6652,
        GIR_EraseRootFromParent_Done,
      // Label 19081: @1411929
      GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1412044), // Rule ID 6653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6653,
        GIR_EraseRootFromParent_Done,
      // Label 19082: @1412044
      GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1412159), // Rule ID 6656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6656,
        GIR_EraseRootFromParent_Done,
      // Label 19083: @1412159
      GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1412274), // Rule ID 6657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6657,
        GIR_EraseRootFromParent_Done,
      // Label 19084: @1412274
      GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1412389), // Rule ID 6660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6660,
        GIR_EraseRootFromParent_Done,
      // Label 19085: @1412389
      GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1412504), // Rule ID 6661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6661,
        GIR_EraseRootFromParent_Done,
      // Label 19086: @1412504
      GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1412619), // Rule ID 6664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6664,
        GIR_EraseRootFromParent_Done,
      // Label 19087: @1412619
      GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1412734), // Rule ID 6665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6665,
        GIR_EraseRootFromParent_Done,
      // Label 19088: @1412734
      GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1412849), // Rule ID 6668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6668,
        GIR_EraseRootFromParent_Done,
      // Label 19089: @1412849
      GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1412964), // Rule ID 6669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6669,
        GIR_EraseRootFromParent_Done,
      // Label 19090: @1412964
      GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1413079), // Rule ID 6672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6672,
        GIR_EraseRootFromParent_Done,
      // Label 19091: @1413079
      GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1413194), // Rule ID 6673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6673,
        GIR_EraseRootFromParent_Done,
      // Label 19092: @1413194
      GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1413309), // Rule ID 6676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6676,
        GIR_EraseRootFromParent_Done,
      // Label 19093: @1413309
      GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1413424), // Rule ID 6677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6677,
        GIR_EraseRootFromParent_Done,
      // Label 19094: @1413424
      GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1413539), // Rule ID 6856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6856,
        GIR_EraseRootFromParent_Done,
      // Label 19095: @1413539
      GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1413654), // Rule ID 6857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6857,
        GIR_EraseRootFromParent_Done,
      // Label 19096: @1413654
      GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1413769), // Rule ID 6860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6860,
        GIR_EraseRootFromParent_Done,
      // Label 19097: @1413769
      GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1413884), // Rule ID 6861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6861,
        GIR_EraseRootFromParent_Done,
      // Label 19098: @1413884
      GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1413999), // Rule ID 6864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6864,
        GIR_EraseRootFromParent_Done,
      // Label 19099: @1413999
      GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1414114), // Rule ID 6865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6865,
        GIR_EraseRootFromParent_Done,
      // Label 19100: @1414114
      GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1414229), // Rule ID 6868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6868,
        GIR_EraseRootFromParent_Done,
      // Label 19101: @1414229
      GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1414344), // Rule ID 6869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6869,
        GIR_EraseRootFromParent_Done,
      // Label 19102: @1414344
      GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1414459), // Rule ID 6872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6872,
        GIR_EraseRootFromParent_Done,
      // Label 19103: @1414459
      GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1414574), // Rule ID 6873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6873,
        GIR_EraseRootFromParent_Done,
      // Label 19104: @1414574
      GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1414689), // Rule ID 6876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6876,
        GIR_EraseRootFromParent_Done,
      // Label 19105: @1414689
      GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1414804), // Rule ID 6877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6877,
        GIR_EraseRootFromParent_Done,
      // Label 19106: @1414804
      GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1414919), // Rule ID 6880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6880,
        GIR_EraseRootFromParent_Done,
      // Label 19107: @1414919
      GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1415034), // Rule ID 6881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6881,
        GIR_EraseRootFromParent_Done,
      // Label 19108: @1415034
      GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1415149), // Rule ID 6884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6884,
        GIR_EraseRootFromParent_Done,
      // Label 19109: @1415149
      GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1415264), // Rule ID 6885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6885,
        GIR_EraseRootFromParent_Done,
      // Label 19110: @1415264
      GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1415379), // Rule ID 6888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6888,
        GIR_EraseRootFromParent_Done,
      // Label 19111: @1415379
      GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1415494), // Rule ID 6889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6889,
        GIR_EraseRootFromParent_Done,
      // Label 19112: @1415494
      GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1415609), // Rule ID 6892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6892,
        GIR_EraseRootFromParent_Done,
      // Label 19113: @1415609
      GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1415724), // Rule ID 6893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6893,
        GIR_EraseRootFromParent_Done,
      // Label 19114: @1415724
      GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1415839), // Rule ID 6896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6896,
        GIR_EraseRootFromParent_Done,
      // Label 19115: @1415839
      GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1415954), // Rule ID 6897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6897,
        GIR_EraseRootFromParent_Done,
      // Label 19116: @1415954
      GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1416069), // Rule ID 6900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6900,
        GIR_EraseRootFromParent_Done,
      // Label 19117: @1416069
      GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1416184), // Rule ID 6901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6901,
        GIR_EraseRootFromParent_Done,
      // Label 19118: @1416184
      GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1416299), // Rule ID 6904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6904,
        GIR_EraseRootFromParent_Done,
      // Label 19119: @1416299
      GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1416414), // Rule ID 6905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6905,
        GIR_EraseRootFromParent_Done,
      // Label 19120: @1416414
      GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1416529), // Rule ID 6908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6908,
        GIR_EraseRootFromParent_Done,
      // Label 19121: @1416529
      GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1416644), // Rule ID 6909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6909,
        GIR_EraseRootFromParent_Done,
      // Label 19122: @1416644
      GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1416759), // Rule ID 6912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6912,
        GIR_EraseRootFromParent_Done,
      // Label 19123: @1416759
      GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1416874), // Rule ID 6913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6913,
        GIR_EraseRootFromParent_Done,
      // Label 19124: @1416874
      GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1416989), // Rule ID 6916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6916,
        GIR_EraseRootFromParent_Done,
      // Label 19125: @1416989
      GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1417104), // Rule ID 6917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6917,
        GIR_EraseRootFromParent_Done,
      // Label 19126: @1417104
      GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1417219), // Rule ID 6920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6920,
        GIR_EraseRootFromParent_Done,
      // Label 19127: @1417219
      GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1417334), // Rule ID 6921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6921,
        GIR_EraseRootFromParent_Done,
      // Label 19128: @1417334
      GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1417449), // Rule ID 6924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6924,
        GIR_EraseRootFromParent_Done,
      // Label 19129: @1417449
      GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1417564), // Rule ID 6925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6925,
        GIR_EraseRootFromParent_Done,
      // Label 19130: @1417564
      GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1417679), // Rule ID 6928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6928,
        GIR_EraseRootFromParent_Done,
      // Label 19131: @1417679
      GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1417794), // Rule ID 6929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6929,
        GIR_EraseRootFromParent_Done,
      // Label 19132: @1417794
      GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1417909), // Rule ID 6932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6932,
        GIR_EraseRootFromParent_Done,
      // Label 19133: @1417909
      GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1418024), // Rule ID 6933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6933,
        GIR_EraseRootFromParent_Done,
      // Label 19134: @1418024
      GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1418139), // Rule ID 6936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6936,
        GIR_EraseRootFromParent_Done,
      // Label 19135: @1418139
      GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1418254), // Rule ID 6937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6937,
        GIR_EraseRootFromParent_Done,
      // Label 19136: @1418254
      GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1418369), // Rule ID 6940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6940,
        GIR_EraseRootFromParent_Done,
      // Label 19137: @1418369
      GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1418484), // Rule ID 6941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6941,
        GIR_EraseRootFromParent_Done,
      // Label 19138: @1418484
      GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1418599), // Rule ID 7120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7120,
        GIR_EraseRootFromParent_Done,
      // Label 19139: @1418599
      GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1418714), // Rule ID 7121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7121,
        GIR_EraseRootFromParent_Done,
      // Label 19140: @1418714
      GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1418829), // Rule ID 7124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7124,
        GIR_EraseRootFromParent_Done,
      // Label 19141: @1418829
      GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1418944), // Rule ID 7125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7125,
        GIR_EraseRootFromParent_Done,
      // Label 19142: @1418944
      GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1419059), // Rule ID 7128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7128,
        GIR_EraseRootFromParent_Done,
      // Label 19143: @1419059
      GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1419174), // Rule ID 7129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7129,
        GIR_EraseRootFromParent_Done,
      // Label 19144: @1419174
      GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1419289), // Rule ID 7132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7132,
        GIR_EraseRootFromParent_Done,
      // Label 19145: @1419289
      GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1419404), // Rule ID 7133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7133,
        GIR_EraseRootFromParent_Done,
      // Label 19146: @1419404
      GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1419519), // Rule ID 7136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7136,
        GIR_EraseRootFromParent_Done,
      // Label 19147: @1419519
      GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1419634), // Rule ID 7137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7137,
        GIR_EraseRootFromParent_Done,
      // Label 19148: @1419634
      GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1419749), // Rule ID 7140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7140,
        GIR_EraseRootFromParent_Done,
      // Label 19149: @1419749
      GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1419864), // Rule ID 7141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7141,
        GIR_EraseRootFromParent_Done,
      // Label 19150: @1419864
      GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1419979), // Rule ID 7144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7144,
        GIR_EraseRootFromParent_Done,
      // Label 19151: @1419979
      GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1420094), // Rule ID 7145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7145,
        GIR_EraseRootFromParent_Done,
      // Label 19152: @1420094
      GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1420209), // Rule ID 7148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7148,
        GIR_EraseRootFromParent_Done,
      // Label 19153: @1420209
      GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1420324), // Rule ID 7149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7149,
        GIR_EraseRootFromParent_Done,
      // Label 19154: @1420324
      GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1420439), // Rule ID 7152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7152,
        GIR_EraseRootFromParent_Done,
      // Label 19155: @1420439
      GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1420554), // Rule ID 7153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7153,
        GIR_EraseRootFromParent_Done,
      // Label 19156: @1420554
      GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1420669), // Rule ID 7156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7156,
        GIR_EraseRootFromParent_Done,
      // Label 19157: @1420669
      GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1420784), // Rule ID 7157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7157,
        GIR_EraseRootFromParent_Done,
      // Label 19158: @1420784
      GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1420899), // Rule ID 7160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7160,
        GIR_EraseRootFromParent_Done,
      // Label 19159: @1420899
      GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1421014), // Rule ID 7161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7161,
        GIR_EraseRootFromParent_Done,
      // Label 19160: @1421014
      GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1421129), // Rule ID 7164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7164,
        GIR_EraseRootFromParent_Done,
      // Label 19161: @1421129
      GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1421244), // Rule ID 7165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7165,
        GIR_EraseRootFromParent_Done,
      // Label 19162: @1421244
      GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1421359), // Rule ID 7168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7168,
        GIR_EraseRootFromParent_Done,
      // Label 19163: @1421359
      GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1421474), // Rule ID 7169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7169,
        GIR_EraseRootFromParent_Done,
      // Label 19164: @1421474
      GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1421589), // Rule ID 7172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7172,
        GIR_EraseRootFromParent_Done,
      // Label 19165: @1421589
      GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1421704), // Rule ID 7173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7173,
        GIR_EraseRootFromParent_Done,
      // Label 19166: @1421704
      GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1421819), // Rule ID 7176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7176,
        GIR_EraseRootFromParent_Done,
      // Label 19167: @1421819
      GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1421934), // Rule ID 7177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7177,
        GIR_EraseRootFromParent_Done,
      // Label 19168: @1421934
      GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1422049), // Rule ID 7180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7180,
        GIR_EraseRootFromParent_Done,
      // Label 19169: @1422049
      GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1422164), // Rule ID 7181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7181,
        GIR_EraseRootFromParent_Done,
      // Label 19170: @1422164
      GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1422279), // Rule ID 7184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7184,
        GIR_EraseRootFromParent_Done,
      // Label 19171: @1422279
      GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1422394), // Rule ID 7185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7185,
        GIR_EraseRootFromParent_Done,
      // Label 19172: @1422394
      GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1422509), // Rule ID 7188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7188,
        GIR_EraseRootFromParent_Done,
      // Label 19173: @1422509
      GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1422624), // Rule ID 7189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7189,
        GIR_EraseRootFromParent_Done,
      // Label 19174: @1422624
      GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1422739), // Rule ID 7192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7192,
        GIR_EraseRootFromParent_Done,
      // Label 19175: @1422739
      GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1422854), // Rule ID 7193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7193,
        GIR_EraseRootFromParent_Done,
      // Label 19176: @1422854
      GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1422969), // Rule ID 7196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7196,
        GIR_EraseRootFromParent_Done,
      // Label 19177: @1422969
      GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1423084), // Rule ID 7197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7197,
        GIR_EraseRootFromParent_Done,
      // Label 19178: @1423084
      GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1423199), // Rule ID 7200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7200,
        GIR_EraseRootFromParent_Done,
      // Label 19179: @1423199
      GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1423314), // Rule ID 7201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7201,
        GIR_EraseRootFromParent_Done,
      // Label 19180: @1423314
      GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1423429), // Rule ID 7204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7204,
        GIR_EraseRootFromParent_Done,
      // Label 19181: @1423429
      GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1423544), // Rule ID 7205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7205,
        GIR_EraseRootFromParent_Done,
      // Label 19182: @1423544
      GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1423659), // Rule ID 7416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7416,
        GIR_EraseRootFromParent_Done,
      // Label 19183: @1423659
      GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1423774), // Rule ID 7417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7417,
        GIR_EraseRootFromParent_Done,
      // Label 19184: @1423774
      GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1423889), // Rule ID 7420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7420,
        GIR_EraseRootFromParent_Done,
      // Label 19185: @1423889
      GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1424004), // Rule ID 7421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7421,
        GIR_EraseRootFromParent_Done,
      // Label 19186: @1424004
      GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1424119), // Rule ID 7424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7424,
        GIR_EraseRootFromParent_Done,
      // Label 19187: @1424119
      GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1424234), // Rule ID 7425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7425,
        GIR_EraseRootFromParent_Done,
      // Label 19188: @1424234
      GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1424349), // Rule ID 7428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7428,
        GIR_EraseRootFromParent_Done,
      // Label 19189: @1424349
      GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1424464), // Rule ID 7429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7429,
        GIR_EraseRootFromParent_Done,
      // Label 19190: @1424464
      GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1424579), // Rule ID 7432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7432,
        GIR_EraseRootFromParent_Done,
      // Label 19191: @1424579
      GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1424694), // Rule ID 7433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7433,
        GIR_EraseRootFromParent_Done,
      // Label 19192: @1424694
      GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1424809), // Rule ID 7436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7436,
        GIR_EraseRootFromParent_Done,
      // Label 19193: @1424809
      GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1424924), // Rule ID 7437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7437,
        GIR_EraseRootFromParent_Done,
      // Label 19194: @1424924
      GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1425039), // Rule ID 7440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7440,
        GIR_EraseRootFromParent_Done,
      // Label 19195: @1425039
      GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1425154), // Rule ID 7441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7441,
        GIR_EraseRootFromParent_Done,
      // Label 19196: @1425154
      GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1425269), // Rule ID 7444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7444,
        GIR_EraseRootFromParent_Done,
      // Label 19197: @1425269
      GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1425384), // Rule ID 7445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7445,
        GIR_EraseRootFromParent_Done,
      // Label 19198: @1425384
      GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1425499), // Rule ID 7448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7448,
        GIR_EraseRootFromParent_Done,
      // Label 19199: @1425499
      GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1425614), // Rule ID 7449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7449,
        GIR_EraseRootFromParent_Done,
      // Label 19200: @1425614
      GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1425729), // Rule ID 7452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7452,
        GIR_EraseRootFromParent_Done,
      // Label 19201: @1425729
      GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1425844), // Rule ID 7453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7453,
        GIR_EraseRootFromParent_Done,
      // Label 19202: @1425844
      GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1425959), // Rule ID 7456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7456,
        GIR_EraseRootFromParent_Done,
      // Label 19203: @1425959
      GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1426074), // Rule ID 7457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7457,
        GIR_EraseRootFromParent_Done,
      // Label 19204: @1426074
      GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1426189), // Rule ID 7460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7460,
        GIR_EraseRootFromParent_Done,
      // Label 19205: @1426189
      GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1426304), // Rule ID 7461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7461,
        GIR_EraseRootFromParent_Done,
      // Label 19206: @1426304
      GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1426419), // Rule ID 7464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7464,
        GIR_EraseRootFromParent_Done,
      // Label 19207: @1426419
      GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1426534), // Rule ID 7465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7465,
        GIR_EraseRootFromParent_Done,
      // Label 19208: @1426534
      GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1426649), // Rule ID 7468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7468,
        GIR_EraseRootFromParent_Done,
      // Label 19209: @1426649
      GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1426764), // Rule ID 7469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7469,
        GIR_EraseRootFromParent_Done,
      // Label 19210: @1426764
      GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1426879), // Rule ID 7472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7472,
        GIR_EraseRootFromParent_Done,
      // Label 19211: @1426879
      GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1426994), // Rule ID 7473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7473,
        GIR_EraseRootFromParent_Done,
      // Label 19212: @1426994
      GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1427109), // Rule ID 7596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7596,
        GIR_EraseRootFromParent_Done,
      // Label 19213: @1427109
      GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1427224), // Rule ID 7597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7597,
        GIR_EraseRootFromParent_Done,
      // Label 19214: @1427224
      GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1427339), // Rule ID 7600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7600,
        GIR_EraseRootFromParent_Done,
      // Label 19215: @1427339
      GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1427454), // Rule ID 7601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7601,
        GIR_EraseRootFromParent_Done,
      // Label 19216: @1427454
      GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1427569), // Rule ID 7604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7604,
        GIR_EraseRootFromParent_Done,
      // Label 19217: @1427569
      GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1427684), // Rule ID 7605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7605,
        GIR_EraseRootFromParent_Done,
      // Label 19218: @1427684
      GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1427799), // Rule ID 7608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7608,
        GIR_EraseRootFromParent_Done,
      // Label 19219: @1427799
      GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1427914), // Rule ID 7609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7609,
        GIR_EraseRootFromParent_Done,
      // Label 19220: @1427914
      GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1428029), // Rule ID 7612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7612,
        GIR_EraseRootFromParent_Done,
      // Label 19221: @1428029
      GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1428144), // Rule ID 7613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7613,
        GIR_EraseRootFromParent_Done,
      // Label 19222: @1428144
      GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1428259), // Rule ID 7616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7616,
        GIR_EraseRootFromParent_Done,
      // Label 19223: @1428259
      GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1428374), // Rule ID 7617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7617,
        GIR_EraseRootFromParent_Done,
      // Label 19224: @1428374
      GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1428489), // Rule ID 7620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7620,
        GIR_EraseRootFromParent_Done,
      // Label 19225: @1428489
      GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1428604), // Rule ID 7621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7621,
        GIR_EraseRootFromParent_Done,
      // Label 19226: @1428604
      GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1428719), // Rule ID 7624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7624,
        GIR_EraseRootFromParent_Done,
      // Label 19227: @1428719
      GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1428834), // Rule ID 7625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7625,
        GIR_EraseRootFromParent_Done,
      // Label 19228: @1428834
      GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1428949), // Rule ID 7628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7628,
        GIR_EraseRootFromParent_Done,
      // Label 19229: @1428949
      GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1429064), // Rule ID 7629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7629,
        GIR_EraseRootFromParent_Done,
      // Label 19230: @1429064
      GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1429179), // Rule ID 7632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7632,
        GIR_EraseRootFromParent_Done,
      // Label 19231: @1429179
      GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1429294), // Rule ID 7633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7633,
        GIR_EraseRootFromParent_Done,
      // Label 19232: @1429294
      GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1429409), // Rule ID 7636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7636,
        GIR_EraseRootFromParent_Done,
      // Label 19233: @1429409
      GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1429524), // Rule ID 7637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7637,
        GIR_EraseRootFromParent_Done,
      // Label 19234: @1429524
      GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1429639), // Rule ID 7640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7640,
        GIR_EraseRootFromParent_Done,
      // Label 19235: @1429639
      GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1429754), // Rule ID 7641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7641,
        GIR_EraseRootFromParent_Done,
      // Label 19236: @1429754
      GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1429869), // Rule ID 7644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7644,
        GIR_EraseRootFromParent_Done,
      // Label 19237: @1429869
      GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1429984), // Rule ID 7645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7645,
        GIR_EraseRootFromParent_Done,
      // Label 19238: @1429984
      GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1430099), // Rule ID 7648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7648,
        GIR_EraseRootFromParent_Done,
      // Label 19239: @1430099
      GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1430214), // Rule ID 7649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7649,
        GIR_EraseRootFromParent_Done,
      // Label 19240: @1430214
      GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1430329), // Rule ID 7652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7652,
        GIR_EraseRootFromParent_Done,
      // Label 19241: @1430329
      GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1430444), // Rule ID 7653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7653,
        GIR_EraseRootFromParent_Done,
      // Label 19242: @1430444
      GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1430562), // Rule ID 14082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14082,
        GIR_EraseRootFromParent_Done,
      // Label 19243: @1430562
      GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1430680), // Rule ID 14083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14083,
        GIR_EraseRootFromParent_Done,
      // Label 19244: @1430680
      GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1430798), // Rule ID 14086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14086,
        GIR_EraseRootFromParent_Done,
      // Label 19245: @1430798
      GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1430916), // Rule ID 14087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14087,
        GIR_EraseRootFromParent_Done,
      // Label 19246: @1430916
      GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1431034), // Rule ID 14090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14090,
        GIR_EraseRootFromParent_Done,
      // Label 19247: @1431034
      GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1431152), // Rule ID 14091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14091,
        GIR_EraseRootFromParent_Done,
      // Label 19248: @1431152
      GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1431270), // Rule ID 14094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14094,
        GIR_EraseRootFromParent_Done,
      // Label 19249: @1431270
      GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1431388), // Rule ID 14095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14095,
        GIR_EraseRootFromParent_Done,
      // Label 19250: @1431388
      GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1431506), // Rule ID 14098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14098,
        GIR_EraseRootFromParent_Done,
      // Label 19251: @1431506
      GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1431624), // Rule ID 14099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14099,
        GIR_EraseRootFromParent_Done,
      // Label 19252: @1431624
      GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1431742), // Rule ID 14102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14102,
        GIR_EraseRootFromParent_Done,
      // Label 19253: @1431742
      GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1431860), // Rule ID 14103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14103,
        GIR_EraseRootFromParent_Done,
      // Label 19254: @1431860
      GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1431978), // Rule ID 14106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14106,
        GIR_EraseRootFromParent_Done,
      // Label 19255: @1431978
      GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1432096), // Rule ID 14107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14107,
        GIR_EraseRootFromParent_Done,
      // Label 19256: @1432096
      GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1432214), // Rule ID 14110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14110,
        GIR_EraseRootFromParent_Done,
      // Label 19257: @1432214
      GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1432332), // Rule ID 14111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14111,
        GIR_EraseRootFromParent_Done,
      // Label 19258: @1432332
      GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1432450), // Rule ID 14114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14114,
        GIR_EraseRootFromParent_Done,
      // Label 19259: @1432450
      GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1432568), // Rule ID 14115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14115,
        GIR_EraseRootFromParent_Done,
      // Label 19260: @1432568
      GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1432686), // Rule ID 14118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14118,
        GIR_EraseRootFromParent_Done,
      // Label 19261: @1432686
      GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1432804), // Rule ID 14119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14119,
        GIR_EraseRootFromParent_Done,
      // Label 19262: @1432804
      GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1432922), // Rule ID 14122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14122,
        GIR_EraseRootFromParent_Done,
      // Label 19263: @1432922
      GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1433040), // Rule ID 14123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14123,
        GIR_EraseRootFromParent_Done,
      // Label 19264: @1433040
      GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1433158), // Rule ID 14126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14126,
        GIR_EraseRootFromParent_Done,
      // Label 19265: @1433158
      GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1433276), // Rule ID 14127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14127,
        GIR_EraseRootFromParent_Done,
      // Label 19266: @1433276
      GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1433394), // Rule ID 14130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14130,
        GIR_EraseRootFromParent_Done,
      // Label 19267: @1433394
      GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1433512), // Rule ID 14131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14131,
        GIR_EraseRootFromParent_Done,
      // Label 19268: @1433512
      GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1433630), // Rule ID 14134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14134,
        GIR_EraseRootFromParent_Done,
      // Label 19269: @1433630
      GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1433748), // Rule ID 14135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14135,
        GIR_EraseRootFromParent_Done,
      // Label 19270: @1433748
      GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1433866), // Rule ID 14138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14138,
        GIR_EraseRootFromParent_Done,
      // Label 19271: @1433866
      GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1433984), // Rule ID 14139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14139,
        GIR_EraseRootFromParent_Done,
      // Label 19272: @1433984
      GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1434102), // Rule ID 14142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14142,
        GIR_EraseRootFromParent_Done,
      // Label 19273: @1434102
      GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1434220), // Rule ID 14143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14143,
        GIR_EraseRootFromParent_Done,
      // Label 19274: @1434220
      GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1434338), // Rule ID 14146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14146,
        GIR_EraseRootFromParent_Done,
      // Label 19275: @1434338
      GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1434456), // Rule ID 14147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14147,
        GIR_EraseRootFromParent_Done,
      // Label 19276: @1434456
      GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1434574), // Rule ID 14150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14150,
        GIR_EraseRootFromParent_Done,
      // Label 19277: @1434574
      GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1434692), // Rule ID 14151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14151,
        GIR_EraseRootFromParent_Done,
      // Label 19278: @1434692
      GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1434810), // Rule ID 14154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14154,
        GIR_EraseRootFromParent_Done,
      // Label 19279: @1434810
      GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1434928), // Rule ID 14155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14155,
        GIR_EraseRootFromParent_Done,
      // Label 19280: @1434928
      GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1435046), // Rule ID 14158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14158,
        GIR_EraseRootFromParent_Done,
      // Label 19281: @1435046
      GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1435164), // Rule ID 14159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14159,
        GIR_EraseRootFromParent_Done,
      // Label 19282: @1435164
      GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1435282), // Rule ID 14162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14162,
        GIR_EraseRootFromParent_Done,
      // Label 19283: @1435282
      GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1435400), // Rule ID 14163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14163,
        GIR_EraseRootFromParent_Done,
      // Label 19284: @1435400
      GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1435518), // Rule ID 14166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14166,
        GIR_EraseRootFromParent_Done,
      // Label 19285: @1435518
      GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1435636), // Rule ID 14167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14167,
        GIR_EraseRootFromParent_Done,
      // Label 19286: @1435636
      GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1435754), // Rule ID 14346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14346,
        GIR_EraseRootFromParent_Done,
      // Label 19287: @1435754
      GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1435872), // Rule ID 14347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14347,
        GIR_EraseRootFromParent_Done,
      // Label 19288: @1435872
      GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1435990), // Rule ID 14350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14350,
        GIR_EraseRootFromParent_Done,
      // Label 19289: @1435990
      GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1436108), // Rule ID 14351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14351,
        GIR_EraseRootFromParent_Done,
      // Label 19290: @1436108
      GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1436226), // Rule ID 14354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14354,
        GIR_EraseRootFromParent_Done,
      // Label 19291: @1436226
      GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1436344), // Rule ID 14355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14355,
        GIR_EraseRootFromParent_Done,
      // Label 19292: @1436344
      GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1436462), // Rule ID 14358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14358,
        GIR_EraseRootFromParent_Done,
      // Label 19293: @1436462
      GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1436580), // Rule ID 14359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14359,
        GIR_EraseRootFromParent_Done,
      // Label 19294: @1436580
      GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1436698), // Rule ID 14362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14362,
        GIR_EraseRootFromParent_Done,
      // Label 19295: @1436698
      GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1436816), // Rule ID 14363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14363,
        GIR_EraseRootFromParent_Done,
      // Label 19296: @1436816
      GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1436934), // Rule ID 14366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14366,
        GIR_EraseRootFromParent_Done,
      // Label 19297: @1436934
      GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1437052), // Rule ID 14367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14367,
        GIR_EraseRootFromParent_Done,
      // Label 19298: @1437052
      GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1437170), // Rule ID 14370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14370,
        GIR_EraseRootFromParent_Done,
      // Label 19299: @1437170
      GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1437288), // Rule ID 14371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14371,
        GIR_EraseRootFromParent_Done,
      // Label 19300: @1437288
      GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1437406), // Rule ID 14374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14374,
        GIR_EraseRootFromParent_Done,
      // Label 19301: @1437406
      GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1437524), // Rule ID 14375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14375,
        GIR_EraseRootFromParent_Done,
      // Label 19302: @1437524
      GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1437642), // Rule ID 14378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14378,
        GIR_EraseRootFromParent_Done,
      // Label 19303: @1437642
      GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1437760), // Rule ID 14379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14379,
        GIR_EraseRootFromParent_Done,
      // Label 19304: @1437760
      GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1437878), // Rule ID 14382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14382,
        GIR_EraseRootFromParent_Done,
      // Label 19305: @1437878
      GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1437996), // Rule ID 14383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14383,
        GIR_EraseRootFromParent_Done,
      // Label 19306: @1437996
      GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1438114), // Rule ID 14386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14386,
        GIR_EraseRootFromParent_Done,
      // Label 19307: @1438114
      GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1438232), // Rule ID 14387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14387,
        GIR_EraseRootFromParent_Done,
      // Label 19308: @1438232
      GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1438350), // Rule ID 14390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14390,
        GIR_EraseRootFromParent_Done,
      // Label 19309: @1438350
      GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1438468), // Rule ID 14391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14391,
        GIR_EraseRootFromParent_Done,
      // Label 19310: @1438468
      GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1438586), // Rule ID 14394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14394,
        GIR_EraseRootFromParent_Done,
      // Label 19311: @1438586
      GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1438704), // Rule ID 14395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14395,
        GIR_EraseRootFromParent_Done,
      // Label 19312: @1438704
      GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1438822), // Rule ID 14398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14398,
        GIR_EraseRootFromParent_Done,
      // Label 19313: @1438822
      GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1438940), // Rule ID 14399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14399,
        GIR_EraseRootFromParent_Done,
      // Label 19314: @1438940
      GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1439058), // Rule ID 14402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14402,
        GIR_EraseRootFromParent_Done,
      // Label 19315: @1439058
      GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1439176), // Rule ID 14403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14403,
        GIR_EraseRootFromParent_Done,
      // Label 19316: @1439176
      GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1439294), // Rule ID 14406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14406,
        GIR_EraseRootFromParent_Done,
      // Label 19317: @1439294
      GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1439412), // Rule ID 14407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14407,
        GIR_EraseRootFromParent_Done,
      // Label 19318: @1439412
      GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1439530), // Rule ID 14410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14410,
        GIR_EraseRootFromParent_Done,
      // Label 19319: @1439530
      GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1439648), // Rule ID 14411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14411,
        GIR_EraseRootFromParent_Done,
      // Label 19320: @1439648
      GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1439766), // Rule ID 14414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14414,
        GIR_EraseRootFromParent_Done,
      // Label 19321: @1439766
      GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1439884), // Rule ID 14415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14415,
        GIR_EraseRootFromParent_Done,
      // Label 19322: @1439884
      GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1440002), // Rule ID 14418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14418,
        GIR_EraseRootFromParent_Done,
      // Label 19323: @1440002
      GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1440120), // Rule ID 14419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14419,
        GIR_EraseRootFromParent_Done,
      // Label 19324: @1440120
      GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1440238), // Rule ID 14422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14422,
        GIR_EraseRootFromParent_Done,
      // Label 19325: @1440238
      GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1440356), // Rule ID 14423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14423,
        GIR_EraseRootFromParent_Done,
      // Label 19326: @1440356
      GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1440474), // Rule ID 14426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14426,
        GIR_EraseRootFromParent_Done,
      // Label 19327: @1440474
      GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1440592), // Rule ID 14427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14427,
        GIR_EraseRootFromParent_Done,
      // Label 19328: @1440592
      GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1440710), // Rule ID 14430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14430,
        GIR_EraseRootFromParent_Done,
      // Label 19329: @1440710
      GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1440828), // Rule ID 14431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14431,
        GIR_EraseRootFromParent_Done,
      // Label 19330: @1440828
      GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1440943), // Rule ID 23550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23550,
        GIR_EraseRootFromParent_Done,
      // Label 19331: @1440943
      GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1441058), // Rule ID 23551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23551,
        GIR_EraseRootFromParent_Done,
      // Label 19332: @1441058
      GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1441173), // Rule ID 23554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23554,
        GIR_EraseRootFromParent_Done,
      // Label 19333: @1441173
      GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1441288), // Rule ID 23555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23555,
        GIR_EraseRootFromParent_Done,
      // Label 19334: @1441288
      GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1441403), // Rule ID 23558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23558,
        GIR_EraseRootFromParent_Done,
      // Label 19335: @1441403
      GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1441518), // Rule ID 23559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23559,
        GIR_EraseRootFromParent_Done,
      // Label 19336: @1441518
      GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1441633), // Rule ID 23562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23562,
        GIR_EraseRootFromParent_Done,
      // Label 19337: @1441633
      GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1441748), // Rule ID 23563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23563,
        GIR_EraseRootFromParent_Done,
      // Label 19338: @1441748
      GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1441863), // Rule ID 23566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23566,
        GIR_EraseRootFromParent_Done,
      // Label 19339: @1441863
      GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1441978), // Rule ID 23567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23567,
        GIR_EraseRootFromParent_Done,
      // Label 19340: @1441978
      GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1442093), // Rule ID 23570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23570,
        GIR_EraseRootFromParent_Done,
      // Label 19341: @1442093
      GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1442208), // Rule ID 23571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23571,
        GIR_EraseRootFromParent_Done,
      // Label 19342: @1442208
      GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1442323), // Rule ID 23574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23574,
        GIR_EraseRootFromParent_Done,
      // Label 19343: @1442323
      GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1442438), // Rule ID 23575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23575,
        GIR_EraseRootFromParent_Done,
      // Label 19344: @1442438
      GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1442553), // Rule ID 23578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23578,
        GIR_EraseRootFromParent_Done,
      // Label 19345: @1442553
      GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1442668), // Rule ID 23579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23579,
        GIR_EraseRootFromParent_Done,
      // Label 19346: @1442668
      GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1442783), // Rule ID 23582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23582,
        GIR_EraseRootFromParent_Done,
      // Label 19347: @1442783
      GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1442898), // Rule ID 23583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23583,
        GIR_EraseRootFromParent_Done,
      // Label 19348: @1442898
      GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1443013), // Rule ID 23586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23586,
        GIR_EraseRootFromParent_Done,
      // Label 19349: @1443013
      GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1443128), // Rule ID 23587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23587,
        GIR_EraseRootFromParent_Done,
      // Label 19350: @1443128
      GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1443243), // Rule ID 23590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23590,
        GIR_EraseRootFromParent_Done,
      // Label 19351: @1443243
      GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1443358), // Rule ID 23591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23591,
        GIR_EraseRootFromParent_Done,
      // Label 19352: @1443358
      GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1443473), // Rule ID 23594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23594,
        GIR_EraseRootFromParent_Done,
      // Label 19353: @1443473
      GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1443588), // Rule ID 23595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23595,
        GIR_EraseRootFromParent_Done,
      // Label 19354: @1443588
      GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1443703), // Rule ID 23598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23598,
        GIR_EraseRootFromParent_Done,
      // Label 19355: @1443703
      GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1443818), // Rule ID 23599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23599,
        GIR_EraseRootFromParent_Done,
      // Label 19356: @1443818
      GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1443933), // Rule ID 23602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23602,
        GIR_EraseRootFromParent_Done,
      // Label 19357: @1443933
      GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1444048), // Rule ID 23603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23603,
        GIR_EraseRootFromParent_Done,
      // Label 19358: @1444048
      GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1444163), // Rule ID 23606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23606,
        GIR_EraseRootFromParent_Done,
      // Label 19359: @1444163
      GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1444278), // Rule ID 23607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23607,
        GIR_EraseRootFromParent_Done,
      // Label 19360: @1444278
      GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1444393), // Rule ID 23610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23610,
        GIR_EraseRootFromParent_Done,
      // Label 19361: @1444393
      GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1444508), // Rule ID 23611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23611,
        GIR_EraseRootFromParent_Done,
      // Label 19362: @1444508
      GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1444623), // Rule ID 23614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23614,
        GIR_EraseRootFromParent_Done,
      // Label 19363: @1444623
      GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1444738), // Rule ID 23615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23615,
        GIR_EraseRootFromParent_Done,
      // Label 19364: @1444738
      GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1444853), // Rule ID 23618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23618,
        GIR_EraseRootFromParent_Done,
      // Label 19365: @1444853
      GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1444968), // Rule ID 23619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23619,
        GIR_EraseRootFromParent_Done,
      // Label 19366: @1444968
      GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1445083), // Rule ID 23622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23622,
        GIR_EraseRootFromParent_Done,
      // Label 19367: @1445083
      GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1445198), // Rule ID 23623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23623,
        GIR_EraseRootFromParent_Done,
      // Label 19368: @1445198
      GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1445313), // Rule ID 23626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23626,
        GIR_EraseRootFromParent_Done,
      // Label 19369: @1445313
      GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1445428), // Rule ID 23627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23627,
        GIR_EraseRootFromParent_Done,
      // Label 19370: @1445428
      GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1445543), // Rule ID 23630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23630,
        GIR_EraseRootFromParent_Done,
      // Label 19371: @1445543
      GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1445658), // Rule ID 23631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23631,
        GIR_EraseRootFromParent_Done,
      // Label 19372: @1445658
      GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1445773), // Rule ID 23634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23634,
        GIR_EraseRootFromParent_Done,
      // Label 19373: @1445773
      GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1445888), // Rule ID 23635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23635,
        GIR_EraseRootFromParent_Done,
      // Label 19374: @1445888
      GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1446003), // Rule ID 23726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23726,
        GIR_EraseRootFromParent_Done,
      // Label 19375: @1446003
      GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1446118), // Rule ID 23727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23727,
        GIR_EraseRootFromParent_Done,
      // Label 19376: @1446118
      GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1446233), // Rule ID 23730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23730,
        GIR_EraseRootFromParent_Done,
      // Label 19377: @1446233
      GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1446348), // Rule ID 23731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23731,
        GIR_EraseRootFromParent_Done,
      // Label 19378: @1446348
      GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1446463), // Rule ID 23734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23734,
        GIR_EraseRootFromParent_Done,
      // Label 19379: @1446463
      GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1446578), // Rule ID 23735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23735,
        GIR_EraseRootFromParent_Done,
      // Label 19380: @1446578
      GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1446693), // Rule ID 23738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23738,
        GIR_EraseRootFromParent_Done,
      // Label 19381: @1446693
      GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1446808), // Rule ID 23739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23739,
        GIR_EraseRootFromParent_Done,
      // Label 19382: @1446808
      GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1446923), // Rule ID 23742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23742,
        GIR_EraseRootFromParent_Done,
      // Label 19383: @1446923
      GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1447038), // Rule ID 23743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23743,
        GIR_EraseRootFromParent_Done,
      // Label 19384: @1447038
      GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1447153), // Rule ID 23746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23746,
        GIR_EraseRootFromParent_Done,
      // Label 19385: @1447153
      GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1447268), // Rule ID 23747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23747,
        GIR_EraseRootFromParent_Done,
      // Label 19386: @1447268
      GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1447383), // Rule ID 23750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23750,
        GIR_EraseRootFromParent_Done,
      // Label 19387: @1447383
      GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1447498), // Rule ID 23751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23751,
        GIR_EraseRootFromParent_Done,
      // Label 19388: @1447498
      GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1447613), // Rule ID 23754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23754,
        GIR_EraseRootFromParent_Done,
      // Label 19389: @1447613
      GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1447728), // Rule ID 23755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23755,
        GIR_EraseRootFromParent_Done,
      // Label 19390: @1447728
      GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1447843), // Rule ID 23758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23758,
        GIR_EraseRootFromParent_Done,
      // Label 19391: @1447843
      GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1447958), // Rule ID 23759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23759,
        GIR_EraseRootFromParent_Done,
      // Label 19392: @1447958
      GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1448073), // Rule ID 23762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23762,
        GIR_EraseRootFromParent_Done,
      // Label 19393: @1448073
      GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1448188), // Rule ID 23763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23763,
        GIR_EraseRootFromParent_Done,
      // Label 19394: @1448188
      GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1448303), // Rule ID 23766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23766,
        GIR_EraseRootFromParent_Done,
      // Label 19395: @1448303
      GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1448418), // Rule ID 23767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23767,
        GIR_EraseRootFromParent_Done,
      // Label 19396: @1448418
      GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1448533), // Rule ID 23770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23770,
        GIR_EraseRootFromParent_Done,
      // Label 19397: @1448533
      GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1448648), // Rule ID 23771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23771,
        GIR_EraseRootFromParent_Done,
      // Label 19398: @1448648
      GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1448763), // Rule ID 23774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23774,
        GIR_EraseRootFromParent_Done,
      // Label 19399: @1448763
      GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1448878), // Rule ID 23775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23775,
        GIR_EraseRootFromParent_Done,
      // Label 19400: @1448878
      GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1448993), // Rule ID 23778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23778,
        GIR_EraseRootFromParent_Done,
      // Label 19401: @1448993
      GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1449108), // Rule ID 23779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23779,
        GIR_EraseRootFromParent_Done,
      // Label 19402: @1449108
      GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1449223), // Rule ID 23782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23782,
        GIR_EraseRootFromParent_Done,
      // Label 19403: @1449223
      GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1449338), // Rule ID 23783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23783,
        GIR_EraseRootFromParent_Done,
      // Label 19404: @1449338
      GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1449453), // Rule ID 23786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23786,
        GIR_EraseRootFromParent_Done,
      // Label 19405: @1449453
      GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1449568), // Rule ID 23787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23787,
        GIR_EraseRootFromParent_Done,
      // Label 19406: @1449568
      GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1449683), // Rule ID 23790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23790,
        GIR_EraseRootFromParent_Done,
      // Label 19407: @1449683
      GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1449798), // Rule ID 23791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23791,
        GIR_EraseRootFromParent_Done,
      // Label 19408: @1449798
      GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1449913), // Rule ID 23794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23794,
        GIR_EraseRootFromParent_Done,
      // Label 19409: @1449913
      GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1450028), // Rule ID 23795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23795,
        GIR_EraseRootFromParent_Done,
      // Label 19410: @1450028
      GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1450143), // Rule ID 23798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23798,
        GIR_EraseRootFromParent_Done,
      // Label 19411: @1450143
      GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1450258), // Rule ID 23799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23799,
        GIR_EraseRootFromParent_Done,
      // Label 19412: @1450258
      GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1450373), // Rule ID 23802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23802,
        GIR_EraseRootFromParent_Done,
      // Label 19413: @1450373
      GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1450488), // Rule ID 23803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23803,
        GIR_EraseRootFromParent_Done,
      // Label 19414: @1450488
      GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1450603), // Rule ID 23806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23806,
        GIR_EraseRootFromParent_Done,
      // Label 19415: @1450603
      GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1450718), // Rule ID 23807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23807,
        GIR_EraseRootFromParent_Done,
      // Label 19416: @1450718
      GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1450833), // Rule ID 23810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23810,
        GIR_EraseRootFromParent_Done,
      // Label 19417: @1450833
      GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1450948), // Rule ID 23811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23811,
        GIR_EraseRootFromParent_Done,
      // Label 19418: @1450948
      GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1451063), // Rule ID 24050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24050,
        GIR_EraseRootFromParent_Done,
      // Label 19419: @1451063
      GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1451178), // Rule ID 24051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24051,
        GIR_EraseRootFromParent_Done,
      // Label 19420: @1451178
      GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1451293), // Rule ID 24054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24054,
        GIR_EraseRootFromParent_Done,
      // Label 19421: @1451293
      GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1451408), // Rule ID 24055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24055,
        GIR_EraseRootFromParent_Done,
      // Label 19422: @1451408
      GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1451523), // Rule ID 24058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24058,
        GIR_EraseRootFromParent_Done,
      // Label 19423: @1451523
      GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1451638), // Rule ID 24059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24059,
        GIR_EraseRootFromParent_Done,
      // Label 19424: @1451638
      GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1451753), // Rule ID 24062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24062,
        GIR_EraseRootFromParent_Done,
      // Label 19425: @1451753
      GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1451868), // Rule ID 24063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24063,
        GIR_EraseRootFromParent_Done,
      // Label 19426: @1451868
      GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1451983), // Rule ID 24066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24066,
        GIR_EraseRootFromParent_Done,
      // Label 19427: @1451983
      GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1452098), // Rule ID 24067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24067,
        GIR_EraseRootFromParent_Done,
      // Label 19428: @1452098
      GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1452213), // Rule ID 24070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24070,
        GIR_EraseRootFromParent_Done,
      // Label 19429: @1452213
      GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1452328), // Rule ID 24071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24071,
        GIR_EraseRootFromParent_Done,
      // Label 19430: @1452328
      GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1452443), // Rule ID 24074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24074,
        GIR_EraseRootFromParent_Done,
      // Label 19431: @1452443
      GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1452558), // Rule ID 24075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24075,
        GIR_EraseRootFromParent_Done,
      // Label 19432: @1452558
      GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1452673), // Rule ID 24078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24078,
        GIR_EraseRootFromParent_Done,
      // Label 19433: @1452673
      GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1452788), // Rule ID 24079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24079,
        GIR_EraseRootFromParent_Done,
      // Label 19434: @1452788
      GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1452903), // Rule ID 24082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24082,
        GIR_EraseRootFromParent_Done,
      // Label 19435: @1452903
      GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1453018), // Rule ID 24083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24083,
        GIR_EraseRootFromParent_Done,
      // Label 19436: @1453018
      GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1453133), // Rule ID 24086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24086,
        GIR_EraseRootFromParent_Done,
      // Label 19437: @1453133
      GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1453248), // Rule ID 24087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24087,
        GIR_EraseRootFromParent_Done,
      // Label 19438: @1453248
      GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1453363), // Rule ID 24090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24090,
        GIR_EraseRootFromParent_Done,
      // Label 19439: @1453363
      GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1453478), // Rule ID 24091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24091,
        GIR_EraseRootFromParent_Done,
      // Label 19440: @1453478
      GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1453593), // Rule ID 24094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24094,
        GIR_EraseRootFromParent_Done,
      // Label 19441: @1453593
      GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1453708), // Rule ID 24095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24095,
        GIR_EraseRootFromParent_Done,
      // Label 19442: @1453708
      GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1453823), // Rule ID 24098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24098,
        GIR_EraseRootFromParent_Done,
      // Label 19443: @1453823
      GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1453938), // Rule ID 24099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24099,
        GIR_EraseRootFromParent_Done,
      // Label 19444: @1453938
      GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1454053), // Rule ID 24102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24102,
        GIR_EraseRootFromParent_Done,
      // Label 19445: @1454053
      GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1454168), // Rule ID 24103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24103,
        GIR_EraseRootFromParent_Done,
      // Label 19446: @1454168
      GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1454283), // Rule ID 24106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24106,
        GIR_EraseRootFromParent_Done,
      // Label 19447: @1454283
      GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1454398), // Rule ID 24107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24107,
        GIR_EraseRootFromParent_Done,
      // Label 19448: @1454398
      GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1454513), // Rule ID 24170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24170,
        GIR_EraseRootFromParent_Done,
      // Label 19449: @1454513
      GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1454628), // Rule ID 24171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24171,
        GIR_EraseRootFromParent_Done,
      // Label 19450: @1454628
      GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1454743), // Rule ID 24174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24174,
        GIR_EraseRootFromParent_Done,
      // Label 19451: @1454743
      GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1454858), // Rule ID 24175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24175,
        GIR_EraseRootFromParent_Done,
      // Label 19452: @1454858
      GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1454973), // Rule ID 24178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24178,
        GIR_EraseRootFromParent_Done,
      // Label 19453: @1454973
      GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1455088), // Rule ID 24179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24179,
        GIR_EraseRootFromParent_Done,
      // Label 19454: @1455088
      GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1455203), // Rule ID 24182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24182,
        GIR_EraseRootFromParent_Done,
      // Label 19455: @1455203
      GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1455318), // Rule ID 24183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24183,
        GIR_EraseRootFromParent_Done,
      // Label 19456: @1455318
      GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1455433), // Rule ID 24186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24186,
        GIR_EraseRootFromParent_Done,
      // Label 19457: @1455433
      GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1455548), // Rule ID 24187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24187,
        GIR_EraseRootFromParent_Done,
      // Label 19458: @1455548
      GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1455663), // Rule ID 24190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24190,
        GIR_EraseRootFromParent_Done,
      // Label 19459: @1455663
      GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1455778), // Rule ID 24191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24191,
        GIR_EraseRootFromParent_Done,
      // Label 19460: @1455778
      GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1455893), // Rule ID 24194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24194,
        GIR_EraseRootFromParent_Done,
      // Label 19461: @1455893
      GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1456008), // Rule ID 24195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24195,
        GIR_EraseRootFromParent_Done,
      // Label 19462: @1456008
      GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1456123), // Rule ID 24198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24198,
        GIR_EraseRootFromParent_Done,
      // Label 19463: @1456123
      GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1456238), // Rule ID 24199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24199,
        GIR_EraseRootFromParent_Done,
      // Label 19464: @1456238
      GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1456353), // Rule ID 24202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24202,
        GIR_EraseRootFromParent_Done,
      // Label 19465: @1456353
      GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1456468), // Rule ID 24203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24203,
        GIR_EraseRootFromParent_Done,
      // Label 19466: @1456468
      GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1456583), // Rule ID 24206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24206,
        GIR_EraseRootFromParent_Done,
      // Label 19467: @1456583
      GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1456698), // Rule ID 24207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24207,
        GIR_EraseRootFromParent_Done,
      // Label 19468: @1456698
      GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1456813), // Rule ID 24210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24210,
        GIR_EraseRootFromParent_Done,
      // Label 19469: @1456813
      GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1456928), // Rule ID 24211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24211,
        GIR_EraseRootFromParent_Done,
      // Label 19470: @1456928
      GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1457043), // Rule ID 24214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24214,
        GIR_EraseRootFromParent_Done,
      // Label 19471: @1457043
      GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1457158), // Rule ID 24215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24215,
        GIR_EraseRootFromParent_Done,
      // Label 19472: @1457158
      GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1457273), // Rule ID 24218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24218,
        GIR_EraseRootFromParent_Done,
      // Label 19473: @1457273
      GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1457388), // Rule ID 24219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24219,
        GIR_EraseRootFromParent_Done,
      // Label 19474: @1457388
      GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1457503), // Rule ID 24222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24222,
        GIR_EraseRootFromParent_Done,
      // Label 19475: @1457503
      GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1457618), // Rule ID 24223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24223,
        GIR_EraseRootFromParent_Done,
      // Label 19476: @1457618
      GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1457733), // Rule ID 24226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24226,
        GIR_EraseRootFromParent_Done,
      // Label 19477: @1457733
      GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1457848), // Rule ID 24227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24227,
        GIR_EraseRootFromParent_Done,
      // Label 19478: @1457848
      GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1457963), // Rule ID 24526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24526,
        GIR_EraseRootFromParent_Done,
      // Label 19479: @1457963
      GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1458078), // Rule ID 24527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24527,
        GIR_EraseRootFromParent_Done,
      // Label 19480: @1458078
      GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1458193), // Rule ID 24530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24530,
        GIR_EraseRootFromParent_Done,
      // Label 19481: @1458193
      GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1458308), // Rule ID 24531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24531,
        GIR_EraseRootFromParent_Done,
      // Label 19482: @1458308
      GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1458423), // Rule ID 24534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24534,
        GIR_EraseRootFromParent_Done,
      // Label 19483: @1458423
      GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1458538), // Rule ID 24535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24535,
        GIR_EraseRootFromParent_Done,
      // Label 19484: @1458538
      GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1458653), // Rule ID 24538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24538,
        GIR_EraseRootFromParent_Done,
      // Label 19485: @1458653
      GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1458768), // Rule ID 24539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24539,
        GIR_EraseRootFromParent_Done,
      // Label 19486: @1458768
      GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1458883), // Rule ID 24542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24542,
        GIR_EraseRootFromParent_Done,
      // Label 19487: @1458883
      GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1458998), // Rule ID 24543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24543,
        GIR_EraseRootFromParent_Done,
      // Label 19488: @1458998
      GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1459113), // Rule ID 24546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24546,
        GIR_EraseRootFromParent_Done,
      // Label 19489: @1459113
      GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1459228), // Rule ID 24547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24547,
        GIR_EraseRootFromParent_Done,
      // Label 19490: @1459228
      GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1459343), // Rule ID 24550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24550,
        GIR_EraseRootFromParent_Done,
      // Label 19491: @1459343
      GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1459458), // Rule ID 24551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24551,
        GIR_EraseRootFromParent_Done,
      // Label 19492: @1459458
      GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1459573), // Rule ID 24554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24554,
        GIR_EraseRootFromParent_Done,
      // Label 19493: @1459573
      GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1459688), // Rule ID 24555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24555,
        GIR_EraseRootFromParent_Done,
      // Label 19494: @1459688
      GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1459803), // Rule ID 24558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24558,
        GIR_EraseRootFromParent_Done,
      // Label 19495: @1459803
      GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1459918), // Rule ID 24559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24559,
        GIR_EraseRootFromParent_Done,
      // Label 19496: @1459918
      GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1460033), // Rule ID 24562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24562,
        GIR_EraseRootFromParent_Done,
      // Label 19497: @1460033
      GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1460148), // Rule ID 24563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24563,
        GIR_EraseRootFromParent_Done,
      // Label 19498: @1460148
      GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1460263), // Rule ID 24566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24566,
        GIR_EraseRootFromParent_Done,
      // Label 19499: @1460263
      GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1460378), // Rule ID 24567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24567,
        GIR_EraseRootFromParent_Done,
      // Label 19500: @1460378
      GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1460493), // Rule ID 24570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24570,
        GIR_EraseRootFromParent_Done,
      // Label 19501: @1460493
      GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1460608), // Rule ID 24571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24571,
        GIR_EraseRootFromParent_Done,
      // Label 19502: @1460608
      GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1460723), // Rule ID 24574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24574,
        GIR_EraseRootFromParent_Done,
      // Label 19503: @1460723
      GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1460838), // Rule ID 24575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24575,
        GIR_EraseRootFromParent_Done,
      // Label 19504: @1460838
      GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1460953), // Rule ID 24578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24578,
        GIR_EraseRootFromParent_Done,
      // Label 19505: @1460953
      GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1461068), // Rule ID 24579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24579,
        GIR_EraseRootFromParent_Done,
      // Label 19506: @1461068
      GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1461183), // Rule ID 24582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24582,
        GIR_EraseRootFromParent_Done,
      // Label 19507: @1461183
      GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1461298), // Rule ID 24583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24583,
        GIR_EraseRootFromParent_Done,
      // Label 19508: @1461298
      GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1461413), // Rule ID 24586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24586,
        GIR_EraseRootFromParent_Done,
      // Label 19509: @1461413
      GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1461528), // Rule ID 24587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24587,
        GIR_EraseRootFromParent_Done,
      // Label 19510: @1461528
      GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1461643), // Rule ID 24590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24590,
        GIR_EraseRootFromParent_Done,
      // Label 19511: @1461643
      GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1461758), // Rule ID 24591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24591,
        GIR_EraseRootFromParent_Done,
      // Label 19512: @1461758
      GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1461873), // Rule ID 24594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24594,
        GIR_EraseRootFromParent_Done,
      // Label 19513: @1461873
      GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1461988), // Rule ID 24595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24595,
        GIR_EraseRootFromParent_Done,
      // Label 19514: @1461988
      GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1462103), // Rule ID 24598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24598,
        GIR_EraseRootFromParent_Done,
      // Label 19515: @1462103
      GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1462218), // Rule ID 24599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24599,
        GIR_EraseRootFromParent_Done,
      // Label 19516: @1462218
      GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1462333), // Rule ID 24602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24602,
        GIR_EraseRootFromParent_Done,
      // Label 19517: @1462333
      GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1462448), // Rule ID 24603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24603,
        GIR_EraseRootFromParent_Done,
      // Label 19518: @1462448
      GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1462563), // Rule ID 24606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24606,
        GIR_EraseRootFromParent_Done,
      // Label 19519: @1462563
      GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1462678), // Rule ID 24607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24607,
        GIR_EraseRootFromParent_Done,
      // Label 19520: @1462678
      GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1462793), // Rule ID 24610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24610,
        GIR_EraseRootFromParent_Done,
      // Label 19521: @1462793
      GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1462908), // Rule ID 24611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24611,
        GIR_EraseRootFromParent_Done,
      // Label 19522: @1462908
      GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1463023), // Rule ID 24770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24770,
        GIR_EraseRootFromParent_Done,
      // Label 19523: @1463023
      GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1463138), // Rule ID 24771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24771,
        GIR_EraseRootFromParent_Done,
      // Label 19524: @1463138
      GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1463253), // Rule ID 24774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24774,
        GIR_EraseRootFromParent_Done,
      // Label 19525: @1463253
      GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1463368), // Rule ID 24775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24775,
        GIR_EraseRootFromParent_Done,
      // Label 19526: @1463368
      GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1463483), // Rule ID 24778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24778,
        GIR_EraseRootFromParent_Done,
      // Label 19527: @1463483
      GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1463598), // Rule ID 24779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24779,
        GIR_EraseRootFromParent_Done,
      // Label 19528: @1463598
      GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1463713), // Rule ID 24782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24782,
        GIR_EraseRootFromParent_Done,
      // Label 19529: @1463713
      GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1463828), // Rule ID 24783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24783,
        GIR_EraseRootFromParent_Done,
      // Label 19530: @1463828
      GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1463943), // Rule ID 24786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24786,
        GIR_EraseRootFromParent_Done,
      // Label 19531: @1463943
      GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1464058), // Rule ID 24787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24787,
        GIR_EraseRootFromParent_Done,
      // Label 19532: @1464058
      GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1464173), // Rule ID 24790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24790,
        GIR_EraseRootFromParent_Done,
      // Label 19533: @1464173
      GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1464288), // Rule ID 24791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24791,
        GIR_EraseRootFromParent_Done,
      // Label 19534: @1464288
      GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1464403), // Rule ID 24794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24794,
        GIR_EraseRootFromParent_Done,
      // Label 19535: @1464403
      GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1464518), // Rule ID 24795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24795,
        GIR_EraseRootFromParent_Done,
      // Label 19536: @1464518
      GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1464633), // Rule ID 24798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24798,
        GIR_EraseRootFromParent_Done,
      // Label 19537: @1464633
      GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1464748), // Rule ID 24799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24799,
        GIR_EraseRootFromParent_Done,
      // Label 19538: @1464748
      GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1464863), // Rule ID 24802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24802,
        GIR_EraseRootFromParent_Done,
      // Label 19539: @1464863
      GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1464978), // Rule ID 24803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24803,
        GIR_EraseRootFromParent_Done,
      // Label 19540: @1464978
      GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1465093), // Rule ID 24854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24854,
        GIR_EraseRootFromParent_Done,
      // Label 19541: @1465093
      GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1465208), // Rule ID 24855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24855,
        GIR_EraseRootFromParent_Done,
      // Label 19542: @1465208
      GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1465323), // Rule ID 24858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24858,
        GIR_EraseRootFromParent_Done,
      // Label 19543: @1465323
      GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1465438), // Rule ID 24859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24859,
        GIR_EraseRootFromParent_Done,
      // Label 19544: @1465438
      GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1465553), // Rule ID 24862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24862,
        GIR_EraseRootFromParent_Done,
      // Label 19545: @1465553
      GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1465668), // Rule ID 24863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24863,
        GIR_EraseRootFromParent_Done,
      // Label 19546: @1465668
      GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1465783), // Rule ID 24866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24866,
        GIR_EraseRootFromParent_Done,
      // Label 19547: @1465783
      GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1465898), // Rule ID 24867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24867,
        GIR_EraseRootFromParent_Done,
      // Label 19548: @1465898
      GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1466013), // Rule ID 24870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24870,
        GIR_EraseRootFromParent_Done,
      // Label 19549: @1466013
      GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1466128), // Rule ID 24871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24871,
        GIR_EraseRootFromParent_Done,
      // Label 19550: @1466128
      GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1466243), // Rule ID 24874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24874,
        GIR_EraseRootFromParent_Done,
      // Label 19551: @1466243
      GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1466358), // Rule ID 24875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24875,
        GIR_EraseRootFromParent_Done,
      // Label 19552: @1466358
      GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1466473), // Rule ID 60410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60410,
        GIR_EraseRootFromParent_Done,
      // Label 19553: @1466473
      GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1466588), // Rule ID 60411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60411,
        GIR_EraseRootFromParent_Done,
      // Label 19554: @1466588
      GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1466703), // Rule ID 60418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60418,
        GIR_EraseRootFromParent_Done,
      // Label 19555: @1466703
      GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1466818), // Rule ID 60419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60419,
        GIR_EraseRootFromParent_Done,
      // Label 19556: @1466818
      GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1466933), // Rule ID 60426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60426,
        GIR_EraseRootFromParent_Done,
      // Label 19557: @1466933
      GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1467048), // Rule ID 60427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60427,
        GIR_EraseRootFromParent_Done,
      // Label 19558: @1467048
      GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1467163), // Rule ID 60434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60434,
        GIR_EraseRootFromParent_Done,
      // Label 19559: @1467163
      GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1467278), // Rule ID 60435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60435,
        GIR_EraseRootFromParent_Done,
      // Label 19560: @1467278
      GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1467393), // Rule ID 60442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60442,
        GIR_EraseRootFromParent_Done,
      // Label 19561: @1467393
      GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1467508), // Rule ID 60443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60443,
        GIR_EraseRootFromParent_Done,
      // Label 19562: @1467508
      GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1467623), // Rule ID 60450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60450,
        GIR_EraseRootFromParent_Done,
      // Label 19563: @1467623
      GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1467738), // Rule ID 60451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60451,
        GIR_EraseRootFromParent_Done,
      // Label 19564: @1467738
      GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1467853), // Rule ID 60458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60458,
        GIR_EraseRootFromParent_Done,
      // Label 19565: @1467853
      GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1467968), // Rule ID 60459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60459,
        GIR_EraseRootFromParent_Done,
      // Label 19566: @1467968
      GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1468083), // Rule ID 60466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60466,
        GIR_EraseRootFromParent_Done,
      // Label 19567: @1468083
      GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1468198), // Rule ID 60467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60467,
        GIR_EraseRootFromParent_Done,
      // Label 19568: @1468198
      GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1468313), // Rule ID 60474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60474,
        GIR_EraseRootFromParent_Done,
      // Label 19569: @1468313
      GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1468428), // Rule ID 60475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60475,
        GIR_EraseRootFromParent_Done,
      // Label 19570: @1468428
      GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1468543), // Rule ID 60482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60482,
        GIR_EraseRootFromParent_Done,
      // Label 19571: @1468543
      GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1468658), // Rule ID 60483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60483,
        GIR_EraseRootFromParent_Done,
      // Label 19572: @1468658
      GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1468773), // Rule ID 60490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60490,
        GIR_EraseRootFromParent_Done,
      // Label 19573: @1468773
      GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1468888), // Rule ID 60491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60491,
        GIR_EraseRootFromParent_Done,
      // Label 19574: @1468888
      GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1469003), // Rule ID 60498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60498,
        GIR_EraseRootFromParent_Done,
      // Label 19575: @1469003
      GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1469118), // Rule ID 60499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60499,
        GIR_EraseRootFromParent_Done,
      // Label 19576: @1469118
      GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1469233), // Rule ID 60506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60506,
        GIR_EraseRootFromParent_Done,
      // Label 19577: @1469233
      GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1469348), // Rule ID 60507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60507,
        GIR_EraseRootFromParent_Done,
      // Label 19578: @1469348
      GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1469463), // Rule ID 60514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60514,
        GIR_EraseRootFromParent_Done,
      // Label 19579: @1469463
      GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1469578), // Rule ID 60515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60515,
        GIR_EraseRootFromParent_Done,
      // Label 19580: @1469578
      GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1469693), // Rule ID 60522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60522,
        GIR_EraseRootFromParent_Done,
      // Label 19581: @1469693
      GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1469808), // Rule ID 60523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60523,
        GIR_EraseRootFromParent_Done,
      // Label 19582: @1469808
      GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1469923), // Rule ID 61378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61378,
        GIR_EraseRootFromParent_Done,
      // Label 19583: @1469923
      GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1470038), // Rule ID 61379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61379,
        GIR_EraseRootFromParent_Done,
      // Label 19584: @1470038
      GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1470153), // Rule ID 61382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61382,
        GIR_EraseRootFromParent_Done,
      // Label 19585: @1470153
      GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1470268), // Rule ID 61383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61383,
        GIR_EraseRootFromParent_Done,
      // Label 19586: @1470268
      GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1470383), // Rule ID 61386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61386,
        GIR_EraseRootFromParent_Done,
      // Label 19587: @1470383
      GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1470498), // Rule ID 61387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61387,
        GIR_EraseRootFromParent_Done,
      // Label 19588: @1470498
      GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1470613), // Rule ID 61390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61390,
        GIR_EraseRootFromParent_Done,
      // Label 19589: @1470613
      GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1470728), // Rule ID 61391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61391,
        GIR_EraseRootFromParent_Done,
      // Label 19590: @1470728
      GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1470843), // Rule ID 61394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61394,
        GIR_EraseRootFromParent_Done,
      // Label 19591: @1470843
      GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1470958), // Rule ID 61395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61395,
        GIR_EraseRootFromParent_Done,
      // Label 19592: @1470958
      GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1471073), // Rule ID 61398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61398,
        GIR_EraseRootFromParent_Done,
      // Label 19593: @1471073
      GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1471188), // Rule ID 61399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61399,
        GIR_EraseRootFromParent_Done,
      // Label 19594: @1471188
      GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1471303), // Rule ID 61402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61402,
        GIR_EraseRootFromParent_Done,
      // Label 19595: @1471303
      GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1471418), // Rule ID 61403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61403,
        GIR_EraseRootFromParent_Done,
      // Label 19596: @1471418
      GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1471533), // Rule ID 61406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61406,
        GIR_EraseRootFromParent_Done,
      // Label 19597: @1471533
      GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1471648), // Rule ID 61407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61407,
        GIR_EraseRootFromParent_Done,
      // Label 19598: @1471648
      GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1471763), // Rule ID 61410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61410,
        GIR_EraseRootFromParent_Done,
      // Label 19599: @1471763
      GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1471878), // Rule ID 61411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61411,
        GIR_EraseRootFromParent_Done,
      // Label 19600: @1471878
      GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1471993), // Rule ID 61414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61414,
        GIR_EraseRootFromParent_Done,
      // Label 19601: @1471993
      GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1472108), // Rule ID 61415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61415,
        GIR_EraseRootFromParent_Done,
      // Label 19602: @1472108
      GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1472223), // Rule ID 61418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61418,
        GIR_EraseRootFromParent_Done,
      // Label 19603: @1472223
      GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1472338), // Rule ID 61419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61419,
        GIR_EraseRootFromParent_Done,
      // Label 19604: @1472338
      GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1472453), // Rule ID 61422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61422,
        GIR_EraseRootFromParent_Done,
      // Label 19605: @1472453
      GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1472568), // Rule ID 61423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61423,
        GIR_EraseRootFromParent_Done,
      // Label 19606: @1472568
      GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1472683), // Rule ID 61426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61426,
        GIR_EraseRootFromParent_Done,
      // Label 19607: @1472683
      GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1472798), // Rule ID 61427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61427,
        GIR_EraseRootFromParent_Done,
      // Label 19608: @1472798
      GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1472913), // Rule ID 61430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61430,
        GIR_EraseRootFromParent_Done,
      // Label 19609: @1472913
      GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1473028), // Rule ID 61431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61431,
        GIR_EraseRootFromParent_Done,
      // Label 19610: @1473028
      GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1473143), // Rule ID 61434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61434,
        GIR_EraseRootFromParent_Done,
      // Label 19611: @1473143
      GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1473258), // Rule ID 61435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61435,
        GIR_EraseRootFromParent_Done,
      // Label 19612: @1473258
      GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1473373), // Rule ID 61438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61438,
        GIR_EraseRootFromParent_Done,
      // Label 19613: @1473373
      GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1473488), // Rule ID 61439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61439,
        GIR_EraseRootFromParent_Done,
      // Label 19614: @1473488
      GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1473603), // Rule ID 61442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61442,
        GIR_EraseRootFromParent_Done,
      // Label 19615: @1473603
      GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1473718), // Rule ID 61443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61443,
        GIR_EraseRootFromParent_Done,
      // Label 19616: @1473718
      GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1473833), // Rule ID 61446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61446,
        GIR_EraseRootFromParent_Done,
      // Label 19617: @1473833
      GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1473948), // Rule ID 61447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61447,
        GIR_EraseRootFromParent_Done,
      // Label 19618: @1473948
      GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1474063), // Rule ID 61450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61450,
        GIR_EraseRootFromParent_Done,
      // Label 19619: @1474063
      GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1474178), // Rule ID 61451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61451,
        GIR_EraseRootFromParent_Done,
      // Label 19620: @1474178
      GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1474293), // Rule ID 61454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61454,
        GIR_EraseRootFromParent_Done,
      // Label 19621: @1474293
      GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1474408), // Rule ID 61455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61455,
        GIR_EraseRootFromParent_Done,
      // Label 19622: @1474408
      GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1474523), // Rule ID 61458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61458,
        GIR_EraseRootFromParent_Done,
      // Label 19623: @1474523
      GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1474638), // Rule ID 61459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61459,
        GIR_EraseRootFromParent_Done,
      // Label 19624: @1474638
      GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1474753), // Rule ID 61462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61462,
        GIR_EraseRootFromParent_Done,
      // Label 19625: @1474753
      GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1474868), // Rule ID 61463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61463,
        GIR_EraseRootFromParent_Done,
      // Label 19626: @1474868
      GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1474968), // Rule ID 2566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2566,
        GIR_EraseRootFromParent_Done,
      // Label 19627: @1474968
      GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1475068), // Rule ID 2567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2567,
        GIR_EraseRootFromParent_Done,
      // Label 19628: @1475068
      GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1475168), // Rule ID 2602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2602,
        GIR_EraseRootFromParent_Done,
      // Label 19629: @1475168
      GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1475268), // Rule ID 2603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2603,
        GIR_EraseRootFromParent_Done,
      // Label 19630: @1475268
      GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1475350), // Rule ID 2634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2634,
        GIR_EraseRootFromParent_Done,
      // Label 19631: @1475350
      GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1475432), // Rule ID 2635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2635,
        GIR_EraseRootFromParent_Done,
      // Label 19632: @1475432
      GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1475514), // Rule ID 17606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17606,
        GIR_EraseRootFromParent_Done,
      // Label 19633: @1475514
      GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1475596), // Rule ID 17607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17607,
        GIR_EraseRootFromParent_Done,
      // Label 19634: @1475596
      GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1475678), // Rule ID 17610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17610,
        GIR_EraseRootFromParent_Done,
      // Label 19635: @1475678
      GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1475760), // Rule ID 17611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17611,
        GIR_EraseRootFromParent_Done,
      // Label 19636: @1475760
      GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1475842), // Rule ID 17614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17614,
        GIR_EraseRootFromParent_Done,
      // Label 19637: @1475842
      GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1475924), // Rule ID 17615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17615,
        GIR_EraseRootFromParent_Done,
      // Label 19638: @1475924
      GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1476006), // Rule ID 17618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10812:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17618,
        GIR_EraseRootFromParent_Done,
      // Label 19639: @1476006
      GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1476088), // Rule ID 17619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10812:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17619,
        GIR_EraseRootFromParent_Done,
      // Label 19640: @1476088
      GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1476170), // Rule ID 17622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17622,
        GIR_EraseRootFromParent_Done,
      // Label 19641: @1476170
      GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1476252), // Rule ID 17623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17623,
        GIR_EraseRootFromParent_Done,
      // Label 19642: @1476252
      GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1476334), // Rule ID 17626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17626,
        GIR_EraseRootFromParent_Done,
      // Label 19643: @1476334
      GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1476416), // Rule ID 17627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17627,
        GIR_EraseRootFromParent_Done,
      // Label 19644: @1476416
      GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1476498), // Rule ID 17630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17630,
        GIR_EraseRootFromParent_Done,
      // Label 19645: @1476498
      GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1476580), // Rule ID 17631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17631,
        GIR_EraseRootFromParent_Done,
      // Label 19646: @1476580
      GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1476662), // Rule ID 17634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17634,
        GIR_EraseRootFromParent_Done,
      // Label 19647: @1476662
      GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1476744), // Rule ID 17635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17635,
        GIR_EraseRootFromParent_Done,
      // Label 19648: @1476744
      GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1476826), // Rule ID 17638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17638,
        GIR_EraseRootFromParent_Done,
      // Label 19649: @1476826
      GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1476908), // Rule ID 17639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17639,
        GIR_EraseRootFromParent_Done,
      // Label 19650: @1476908
      GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1476990), // Rule ID 17642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17642,
        GIR_EraseRootFromParent_Done,
      // Label 19651: @1476990
      GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1477072), // Rule ID 17643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17643,
        GIR_EraseRootFromParent_Done,
      // Label 19652: @1477072
      GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1477154), // Rule ID 17646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17646,
        GIR_EraseRootFromParent_Done,
      // Label 19653: @1477154
      GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1477236), // Rule ID 17647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17647,
        GIR_EraseRootFromParent_Done,
      // Label 19654: @1477236
      GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1477318), // Rule ID 17650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17650,
        GIR_EraseRootFromParent_Done,
      // Label 19655: @1477318
      GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1477400), // Rule ID 17651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17651,
        GIR_EraseRootFromParent_Done,
      // Label 19656: @1477400
      GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1477482), // Rule ID 17654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17654,
        GIR_EraseRootFromParent_Done,
      // Label 19657: @1477482
      GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1477564), // Rule ID 17655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17655,
        GIR_EraseRootFromParent_Done,
      // Label 19658: @1477564
      GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1477646), // Rule ID 17658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17658,
        GIR_EraseRootFromParent_Done,
      // Label 19659: @1477646
      GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1477728), // Rule ID 17659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17659,
        GIR_EraseRootFromParent_Done,
      // Label 19660: @1477728
      GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1477810), // Rule ID 17662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17662,
        GIR_EraseRootFromParent_Done,
      // Label 19661: @1477810
      GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1477892), // Rule ID 17663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17663,
        GIR_EraseRootFromParent_Done,
      // Label 19662: @1477892
      GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1477974), // Rule ID 17666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17666,
        GIR_EraseRootFromParent_Done,
      // Label 19663: @1477974
      GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1478056), // Rule ID 17667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17667,
        GIR_EraseRootFromParent_Done,
      // Label 19664: @1478056
      GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1478138), // Rule ID 17670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17670,
        GIR_EraseRootFromParent_Done,
      // Label 19665: @1478138
      GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1478220), // Rule ID 17671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17671,
        GIR_EraseRootFromParent_Done,
      // Label 19666: @1478220
      GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1478302), // Rule ID 17674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17674,
        GIR_EraseRootFromParent_Done,
      // Label 19667: @1478302
      GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1478384), // Rule ID 17675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10812:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17675,
        GIR_EraseRootFromParent_Done,
      // Label 19668: @1478384
      GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1478466), // Rule ID 17678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10812:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17678,
        GIR_EraseRootFromParent_Done,
      // Label 19669: @1478466
      GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1478548), // Rule ID 17679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10812:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17679,
        GIR_EraseRootFromParent_Done,
      // Label 19670: @1478548
      GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1478630), // Rule ID 17682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17682,
        GIR_EraseRootFromParent_Done,
      // Label 19671: @1478630
      GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1478712), // Rule ID 17683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10812:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17683,
        GIR_EraseRootFromParent_Done,
      // Label 19672: @1478712
      GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1478794), // Rule ID 17686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17686,
        GIR_EraseRootFromParent_Done,
      // Label 19673: @1478794
      GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1478876), // Rule ID 17687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17687,
        GIR_EraseRootFromParent_Done,
      // Label 19674: @1478876
      GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1478958), // Rule ID 17690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17690,
        GIR_EraseRootFromParent_Done,
      // Label 19675: @1478958
      GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1479040), // Rule ID 17691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17691,
        GIR_EraseRootFromParent_Done,
      // Label 19676: @1479040
      GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1479122), // Rule ID 17694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17694,
        GIR_EraseRootFromParent_Done,
      // Label 19677: @1479122
      GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1479204), // Rule ID 17695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17695,
        GIR_EraseRootFromParent_Done,
      // Label 19678: @1479204
      GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1479286), // Rule ID 17698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17698,
        GIR_EraseRootFromParent_Done,
      // Label 19679: @1479286
      GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1479368), // Rule ID 17699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17699,
        GIR_EraseRootFromParent_Done,
      // Label 19680: @1479368
      GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1479450), // Rule ID 17702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17702,
        GIR_EraseRootFromParent_Done,
      // Label 19681: @1479450
      GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1479532), // Rule ID 17703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17703,
        GIR_EraseRootFromParent_Done,
      // Label 19682: @1479532
      GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1479614), // Rule ID 17706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17706,
        GIR_EraseRootFromParent_Done,
      // Label 19683: @1479614
      GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1479696), // Rule ID 17707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17707,
        GIR_EraseRootFromParent_Done,
      // Label 19684: @1479696
      GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1479778), // Rule ID 17710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17710,
        GIR_EraseRootFromParent_Done,
      // Label 19685: @1479778
      GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1479860), // Rule ID 17711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10812:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17711,
        GIR_EraseRootFromParent_Done,
      // Label 19686: @1479860
      GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1479942), // Rule ID 17714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17714,
        GIR_EraseRootFromParent_Done,
      // Label 19687: @1479942
      GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1480024), // Rule ID 17715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10812:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17715,
        GIR_EraseRootFromParent_Done,
      // Label 19688: @1480024
      GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1480106), // Rule ID 17718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17718,
        GIR_EraseRootFromParent_Done,
      // Label 19689: @1480106
      GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1480188), // Rule ID 17719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10812:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17719,
        GIR_EraseRootFromParent_Done,
      // Label 19690: @1480188
      GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1480270), // Rule ID 17722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17722,
        GIR_EraseRootFromParent_Done,
      // Label 19691: @1480270
      GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1480352), // Rule ID 17723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17723,
        GIR_EraseRootFromParent_Done,
      // Label 19692: @1480352
      GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1480434), // Rule ID 17726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17726,
        GIR_EraseRootFromParent_Done,
      // Label 19693: @1480434
      GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1480516), // Rule ID 17727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17727,
        GIR_EraseRootFromParent_Done,
      // Label 19694: @1480516
      GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1480598), // Rule ID 17730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17730,
        GIR_EraseRootFromParent_Done,
      // Label 19695: @1480598
      GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1480680), // Rule ID 17731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17731,
        GIR_EraseRootFromParent_Done,
      // Label 19696: @1480680
      GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1480762), // Rule ID 17734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17734,
        GIR_EraseRootFromParent_Done,
      // Label 19697: @1480762
      GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1480844), // Rule ID 17735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17735,
        GIR_EraseRootFromParent_Done,
      // Label 19698: @1480844
      GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1480926), // Rule ID 17738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17738,
        GIR_EraseRootFromParent_Done,
      // Label 19699: @1480926
      GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1481008), // Rule ID 17739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17739,
        GIR_EraseRootFromParent_Done,
      // Label 19700: @1481008
      GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1481090), // Rule ID 17742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17742,
        GIR_EraseRootFromParent_Done,
      // Label 19701: @1481090
      GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1481172), // Rule ID 17743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17743,
        GIR_EraseRootFromParent_Done,
      // Label 19702: @1481172
      GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1481254), // Rule ID 17746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17746,
        GIR_EraseRootFromParent_Done,
      // Label 19703: @1481254
      GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1481336), // Rule ID 17747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17747,
        GIR_EraseRootFromParent_Done,
      // Label 19704: @1481336
      GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1481418), // Rule ID 17750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17750,
        GIR_EraseRootFromParent_Done,
      // Label 19705: @1481418
      GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1481500), // Rule ID 17751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17751,
        GIR_EraseRootFromParent_Done,
      // Label 19706: @1481500
      GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1481582), // Rule ID 17754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17754,
        GIR_EraseRootFromParent_Done,
      // Label 19707: @1481582
      GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1481664), // Rule ID 17755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17755,
        GIR_EraseRootFromParent_Done,
      // Label 19708: @1481664
      GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1481746), // Rule ID 17758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17758,
        GIR_EraseRootFromParent_Done,
      // Label 19709: @1481746
      GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1481828), // Rule ID 17759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17759,
        GIR_EraseRootFromParent_Done,
      // Label 19710: @1481828
      GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1481910), // Rule ID 17762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17762,
        GIR_EraseRootFromParent_Done,
      // Label 19711: @1481910
      GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1481992), // Rule ID 17763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17763,
        GIR_EraseRootFromParent_Done,
      // Label 19712: @1481992
      GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1482074), // Rule ID 17766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17766,
        GIR_EraseRootFromParent_Done,
      // Label 19713: @1482074
      GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1482156), // Rule ID 17767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17767,
        GIR_EraseRootFromParent_Done,
      // Label 19714: @1482156
      GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1482238), // Rule ID 17770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17770,
        GIR_EraseRootFromParent_Done,
      // Label 19715: @1482238
      GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1482320), // Rule ID 17771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17771,
        GIR_EraseRootFromParent_Done,
      // Label 19716: @1482320
      GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1482402), // Rule ID 17774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17774,
        GIR_EraseRootFromParent_Done,
      // Label 19717: @1482402
      GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1482484), // Rule ID 17775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17775,
        GIR_EraseRootFromParent_Done,
      // Label 19718: @1482484
      GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1482566), // Rule ID 17778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17778,
        GIR_EraseRootFromParent_Done,
      // Label 19719: @1482566
      GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1482648), // Rule ID 17779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17779,
        GIR_EraseRootFromParent_Done,
      // Label 19720: @1482648
      GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1482730), // Rule ID 17782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17782,
        GIR_EraseRootFromParent_Done,
      // Label 19721: @1482730
      GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1482812), // Rule ID 17783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17783,
        GIR_EraseRootFromParent_Done,
      // Label 19722: @1482812
      GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1482894), // Rule ID 17786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17786,
        GIR_EraseRootFromParent_Done,
      // Label 19723: @1482894
      GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1482976), // Rule ID 17787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17787,
        GIR_EraseRootFromParent_Done,
      // Label 19724: @1482976
      GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1483058), // Rule ID 17790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17790,
        GIR_EraseRootFromParent_Done,
      // Label 19725: @1483058
      GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1483140), // Rule ID 17791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17791,
        GIR_EraseRootFromParent_Done,
      // Label 19726: @1483140
      GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1483222), // Rule ID 17794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17794,
        GIR_EraseRootFromParent_Done,
      // Label 19727: @1483222
      GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1483304), // Rule ID 17795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10848:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17795,
        GIR_EraseRootFromParent_Done,
      // Label 19728: @1483304
      GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1483386), // Rule ID 17798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17798,
        GIR_EraseRootFromParent_Done,
      // Label 19729: @1483386
      GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1483468), // Rule ID 17799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10848:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17799,
        GIR_EraseRootFromParent_Done,
      // Label 19730: @1483468
      GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1483550), // Rule ID 17802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17802,
        GIR_EraseRootFromParent_Done,
      // Label 19731: @1483550
      GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1483632), // Rule ID 17803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10848:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17803,
        GIR_EraseRootFromParent_Done,
      // Label 19732: @1483632
      GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1483714), // Rule ID 17806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17806,
        GIR_EraseRootFromParent_Done,
      // Label 19733: @1483714
      GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1483796), // Rule ID 17807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17807,
        GIR_EraseRootFromParent_Done,
      // Label 19734: @1483796
      GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1483878), // Rule ID 17810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17810,
        GIR_EraseRootFromParent_Done,
      // Label 19735: @1483878
      GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1483960), // Rule ID 17811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17811,
        GIR_EraseRootFromParent_Done,
      // Label 19736: @1483960
      GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1484042), // Rule ID 17814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17814,
        GIR_EraseRootFromParent_Done,
      // Label 19737: @1484042
      GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1484124), // Rule ID 17815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17815,
        GIR_EraseRootFromParent_Done,
      // Label 19738: @1484124
      GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1484206), // Rule ID 17818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17818,
        GIR_EraseRootFromParent_Done,
      // Label 19739: @1484206
      GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1484288), // Rule ID 17819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17819,
        GIR_EraseRootFromParent_Done,
      // Label 19740: @1484288
      GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1484370), // Rule ID 17822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17822,
        GIR_EraseRootFromParent_Done,
      // Label 19741: @1484370
      GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1484452), // Rule ID 17823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17823,
        GIR_EraseRootFromParent_Done,
      // Label 19742: @1484452
      GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1484534), // Rule ID 17826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17826,
        GIR_EraseRootFromParent_Done,
      // Label 19743: @1484534
      GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1484616), // Rule ID 17827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17827,
        GIR_EraseRootFromParent_Done,
      // Label 19744: @1484616
      GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1484698), // Rule ID 17830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17830,
        GIR_EraseRootFromParent_Done,
      // Label 19745: @1484698
      GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1484780), // Rule ID 17831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10848:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17831,
        GIR_EraseRootFromParent_Done,
      // Label 19746: @1484780
      GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1484862), // Rule ID 17834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17834,
        GIR_EraseRootFromParent_Done,
      // Label 19747: @1484862
      GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1484944), // Rule ID 17835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10848:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17835,
        GIR_EraseRootFromParent_Done,
      // Label 19748: @1484944
      GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1485026), // Rule ID 17838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17838,
        GIR_EraseRootFromParent_Done,
      // Label 19749: @1485026
      GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1485108), // Rule ID 17839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10848:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17839,
        GIR_EraseRootFromParent_Done,
      // Label 19750: @1485108
      GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1485190), // Rule ID 17842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17842,
        GIR_EraseRootFromParent_Done,
      // Label 19751: @1485190
      GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1485272), // Rule ID 17843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17843,
        GIR_EraseRootFromParent_Done,
      // Label 19752: @1485272
      GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1485354), // Rule ID 17846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17846,
        GIR_EraseRootFromParent_Done,
      // Label 19753: @1485354
      GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1485436), // Rule ID 17847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17847,
        GIR_EraseRootFromParent_Done,
      // Label 19754: @1485436
      GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1485518), // Rule ID 17850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17850,
        GIR_EraseRootFromParent_Done,
      // Label 19755: @1485518
      GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1485600), // Rule ID 17851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17851,
        GIR_EraseRootFromParent_Done,
      // Label 19756: @1485600
      GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1485682), // Rule ID 17854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17854,
        GIR_EraseRootFromParent_Done,
      // Label 19757: @1485682
      GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1485764), // Rule ID 17855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17855,
        GIR_EraseRootFromParent_Done,
      // Label 19758: @1485764
      GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1485846), // Rule ID 17858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17858,
        GIR_EraseRootFromParent_Done,
      // Label 19759: @1485846
      GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1485928), // Rule ID 17859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17859,
        GIR_EraseRootFromParent_Done,
      // Label 19760: @1485928
      GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1486010), // Rule ID 17862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17862,
        GIR_EraseRootFromParent_Done,
      // Label 19761: @1486010
      GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1486092), // Rule ID 17863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17863,
        GIR_EraseRootFromParent_Done,
      // Label 19762: @1486092
      GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1486174), // Rule ID 17866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17866,
        GIR_EraseRootFromParent_Done,
      // Label 19763: @1486174
      GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1486256), // Rule ID 17867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17867,
        GIR_EraseRootFromParent_Done,
      // Label 19764: @1486256
      GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1486338), // Rule ID 17870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17870,
        GIR_EraseRootFromParent_Done,
      // Label 19765: @1486338
      GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1486420), // Rule ID 17871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17871,
        GIR_EraseRootFromParent_Done,
      // Label 19766: @1486420
      GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1486502), // Rule ID 17874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17874,
        GIR_EraseRootFromParent_Done,
      // Label 19767: @1486502
      GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1486584), // Rule ID 17875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17875,
        GIR_EraseRootFromParent_Done,
      // Label 19768: @1486584
      GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1486666), // Rule ID 17878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17878,
        GIR_EraseRootFromParent_Done,
      // Label 19769: @1486666
      GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1486748), // Rule ID 17879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17879,
        GIR_EraseRootFromParent_Done,
      // Label 19770: @1486748
      GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1486830), // Rule ID 17882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17882,
        GIR_EraseRootFromParent_Done,
      // Label 19771: @1486830
      GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1486912), // Rule ID 17883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17883,
        GIR_EraseRootFromParent_Done,
      // Label 19772: @1486912
      GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(1486994), // Rule ID 17886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17886,
        GIR_EraseRootFromParent_Done,
      // Label 19773: @1486994
      GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1487076), // Rule ID 17887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17887,
        GIR_EraseRootFromParent_Done,
      // Label 19774: @1487076
      GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1487158), // Rule ID 17890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17890,
        GIR_EraseRootFromParent_Done,
      // Label 19775: @1487158
      GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1487240), // Rule ID 17891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17891,
        GIR_EraseRootFromParent_Done,
      // Label 19776: @1487240
      GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1487322), // Rule ID 17894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17894,
        GIR_EraseRootFromParent_Done,
      // Label 19777: @1487322
      GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1487404), // Rule ID 17895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17895,
        GIR_EraseRootFromParent_Done,
      // Label 19778: @1487404
      GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1487486), // Rule ID 17898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17898,
        GIR_EraseRootFromParent_Done,
      // Label 19779: @1487486
      GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1487568), // Rule ID 17899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17899,
        GIR_EraseRootFromParent_Done,
      // Label 19780: @1487568
      GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1487650), // Rule ID 17902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17902,
        GIR_EraseRootFromParent_Done,
      // Label 19781: @1487650
      GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1487732), // Rule ID 17903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17903,
        GIR_EraseRootFromParent_Done,
      // Label 19782: @1487732
      GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1487814), // Rule ID 17906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17906,
        GIR_EraseRootFromParent_Done,
      // Label 19783: @1487814
      GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1487896), // Rule ID 17907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17907,
        GIR_EraseRootFromParent_Done,
      // Label 19784: @1487896
      GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1487978), // Rule ID 17910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17910,
        GIR_EraseRootFromParent_Done,
      // Label 19785: @1487978
      GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1488060), // Rule ID 17911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17911,
        GIR_EraseRootFromParent_Done,
      // Label 19786: @1488060
      GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1488142), // Rule ID 17914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17914,
        GIR_EraseRootFromParent_Done,
      // Label 19787: @1488142
      GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1488224), // Rule ID 17915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10821:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17915,
        GIR_EraseRootFromParent_Done,
      // Label 19788: @1488224
      GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1488306), // Rule ID 17918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17918,
        GIR_EraseRootFromParent_Done,
      // Label 19789: @1488306
      GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1488388), // Rule ID 17919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10821:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17919,
        GIR_EraseRootFromParent_Done,
      // Label 19790: @1488388
      GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1488470), // Rule ID 17922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17922,
        GIR_EraseRootFromParent_Done,
      // Label 19791: @1488470
      GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1488552), // Rule ID 17923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10821:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17923,
        GIR_EraseRootFromParent_Done,
      // Label 19792: @1488552
      GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1488634), // Rule ID 17926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17926,
        GIR_EraseRootFromParent_Done,
      // Label 19793: @1488634
      GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1488716), // Rule ID 17927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17927,
        GIR_EraseRootFromParent_Done,
      // Label 19794: @1488716
      GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1488798), // Rule ID 17930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17930,
        GIR_EraseRootFromParent_Done,
      // Label 19795: @1488798
      GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1488880), // Rule ID 17931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17931,
        GIR_EraseRootFromParent_Done,
      // Label 19796: @1488880
      GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1488962), // Rule ID 17934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17934,
        GIR_EraseRootFromParent_Done,
      // Label 19797: @1488962
      GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1489044), // Rule ID 17935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17935,
        GIR_EraseRootFromParent_Done,
      // Label 19798: @1489044
      GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1489126), // Rule ID 17938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17938,
        GIR_EraseRootFromParent_Done,
      // Label 19799: @1489126
      GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1489208), // Rule ID 17939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17939,
        GIR_EraseRootFromParent_Done,
      // Label 19800: @1489208
      GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1489290), // Rule ID 17942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17942,
        GIR_EraseRootFromParent_Done,
      // Label 19801: @1489290
      GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1489372), // Rule ID 17943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17943,
        GIR_EraseRootFromParent_Done,
      // Label 19802: @1489372
      GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1489454), // Rule ID 17946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17946,
        GIR_EraseRootFromParent_Done,
      // Label 19803: @1489454
      GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1489536), // Rule ID 17947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17947,
        GIR_EraseRootFromParent_Done,
      // Label 19804: @1489536
      GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1489618), // Rule ID 17950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17950,
        GIR_EraseRootFromParent_Done,
      // Label 19805: @1489618
      GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1489700), // Rule ID 17951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10821:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17951,
        GIR_EraseRootFromParent_Done,
      // Label 19806: @1489700
      GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1489782), // Rule ID 17954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17954,
        GIR_EraseRootFromParent_Done,
      // Label 19807: @1489782
      GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1489864), // Rule ID 17955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10821:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17955,
        GIR_EraseRootFromParent_Done,
      // Label 19808: @1489864
      GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1489946), // Rule ID 17958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17958,
        GIR_EraseRootFromParent_Done,
      // Label 19809: @1489946
      GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1490028), // Rule ID 17959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10821:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17959,
        GIR_EraseRootFromParent_Done,
      // Label 19810: @1490028
      GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1490110), // Rule ID 17962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17962,
        GIR_EraseRootFromParent_Done,
      // Label 19811: @1490110
      GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1490192), // Rule ID 17963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17963,
        GIR_EraseRootFromParent_Done,
      // Label 19812: @1490192
      GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1490274), // Rule ID 17966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17966,
        GIR_EraseRootFromParent_Done,
      // Label 19813: @1490274
      GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1490356), // Rule ID 17967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17967,
        GIR_EraseRootFromParent_Done,
      // Label 19814: @1490356
      GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1490438), // Rule ID 17970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17970,
        GIR_EraseRootFromParent_Done,
      // Label 19815: @1490438
      GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1490520), // Rule ID 17971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17971,
        GIR_EraseRootFromParent_Done,
      // Label 19816: @1490520
      GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1490602), // Rule ID 17974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17974,
        GIR_EraseRootFromParent_Done,
      // Label 19817: @1490602
      GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1490684), // Rule ID 17975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17975,
        GIR_EraseRootFromParent_Done,
      // Label 19818: @1490684
      GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1490766), // Rule ID 17978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17978,
        GIR_EraseRootFromParent_Done,
      // Label 19819: @1490766
      GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1490848), // Rule ID 17979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17979,
        GIR_EraseRootFromParent_Done,
      // Label 19820: @1490848
      GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1490930), // Rule ID 17982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17982,
        GIR_EraseRootFromParent_Done,
      // Label 19821: @1490930
      GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1491012), // Rule ID 17983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17983,
        GIR_EraseRootFromParent_Done,
      // Label 19822: @1491012
      GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1491094), // Rule ID 17986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17986,
        GIR_EraseRootFromParent_Done,
      // Label 19823: @1491094
      GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1491176), // Rule ID 17987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17987,
        GIR_EraseRootFromParent_Done,
      // Label 19824: @1491176
      GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1491258), // Rule ID 17990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17990,
        GIR_EraseRootFromParent_Done,
      // Label 19825: @1491258
      GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1491340), // Rule ID 17991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17991,
        GIR_EraseRootFromParent_Done,
      // Label 19826: @1491340
      GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1491422), // Rule ID 17994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17994,
        GIR_EraseRootFromParent_Done,
      // Label 19827: @1491422
      GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1491504), // Rule ID 17995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17995,
        GIR_EraseRootFromParent_Done,
      // Label 19828: @1491504
      GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1491586), // Rule ID 17998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17998,
        GIR_EraseRootFromParent_Done,
      // Label 19829: @1491586
      GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1491668), // Rule ID 17999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17999,
        GIR_EraseRootFromParent_Done,
      // Label 19830: @1491668
      GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1491750), // Rule ID 18002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18002,
        GIR_EraseRootFromParent_Done,
      // Label 19831: @1491750
      GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1491832), // Rule ID 18003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18003,
        GIR_EraseRootFromParent_Done,
      // Label 19832: @1491832
      GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1491914), // Rule ID 18006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18006,
        GIR_EraseRootFromParent_Done,
      // Label 19833: @1491914
      GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(1491996), // Rule ID 18007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18007,
        GIR_EraseRootFromParent_Done,
      // Label 19834: @1491996
      GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1492078), // Rule ID 18010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18010,
        GIR_EraseRootFromParent_Done,
      // Label 19835: @1492078
      GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1492160), // Rule ID 18011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18011,
        GIR_EraseRootFromParent_Done,
      // Label 19836: @1492160
      GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1492242), // Rule ID 18014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18014,
        GIR_EraseRootFromParent_Done,
      // Label 19837: @1492242
      GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1492324), // Rule ID 18015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18015,
        GIR_EraseRootFromParent_Done,
      // Label 19838: @1492324
      GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1492406), // Rule ID 18018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18018,
        GIR_EraseRootFromParent_Done,
      // Label 19839: @1492406
      GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1492488), // Rule ID 18019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18019,
        GIR_EraseRootFromParent_Done,
      // Label 19840: @1492488
      GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1492570), // Rule ID 18022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18022,
        GIR_EraseRootFromParent_Done,
      // Label 19841: @1492570
      GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1492652), // Rule ID 18023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18023,
        GIR_EraseRootFromParent_Done,
      // Label 19842: @1492652
      GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1492734), // Rule ID 18026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18026,
        GIR_EraseRootFromParent_Done,
      // Label 19843: @1492734
      GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1492816), // Rule ID 18027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18027,
        GIR_EraseRootFromParent_Done,
      // Label 19844: @1492816
      GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1492898), // Rule ID 18030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18030,
        GIR_EraseRootFromParent_Done,
      // Label 19845: @1492898
      GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1492980), // Rule ID 18031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18031,
        GIR_EraseRootFromParent_Done,
      // Label 19846: @1492980
      GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1493062), // Rule ID 18034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18034,
        GIR_EraseRootFromParent_Done,
      // Label 19847: @1493062
      GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1493144), // Rule ID 18035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10852:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18035,
        GIR_EraseRootFromParent_Done,
      // Label 19848: @1493144
      GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1493226), // Rule ID 18038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18038,
        GIR_EraseRootFromParent_Done,
      // Label 19849: @1493226
      GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1493308), // Rule ID 18039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10852:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18039,
        GIR_EraseRootFromParent_Done,
      // Label 19850: @1493308
      GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1493390), // Rule ID 18042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18042,
        GIR_EraseRootFromParent_Done,
      // Label 19851: @1493390
      GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1493472), // Rule ID 18043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10852:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18043,
        GIR_EraseRootFromParent_Done,
      // Label 19852: @1493472
      GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1493554), // Rule ID 18046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18046,
        GIR_EraseRootFromParent_Done,
      // Label 19853: @1493554
      GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1493636), // Rule ID 18047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18047,
        GIR_EraseRootFromParent_Done,
      // Label 19854: @1493636
      GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1493718), // Rule ID 18050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18050,
        GIR_EraseRootFromParent_Done,
      // Label 19855: @1493718
      GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1493800), // Rule ID 18051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18051,
        GIR_EraseRootFromParent_Done,
      // Label 19856: @1493800
      GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1493882), // Rule ID 18054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18054,
        GIR_EraseRootFromParent_Done,
      // Label 19857: @1493882
      GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1493964), // Rule ID 18055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18055,
        GIR_EraseRootFromParent_Done,
      // Label 19858: @1493964
      GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1494046), // Rule ID 18058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18058,
        GIR_EraseRootFromParent_Done,
      // Label 19859: @1494046
      GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1494128), // Rule ID 18059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18059,
        GIR_EraseRootFromParent_Done,
      // Label 19860: @1494128
      GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1494210), // Rule ID 18062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18062,
        GIR_EraseRootFromParent_Done,
      // Label 19861: @1494210
      GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1494292), // Rule ID 18063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18063,
        GIR_EraseRootFromParent_Done,
      // Label 19862: @1494292
      GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1494374), // Rule ID 18066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18066,
        GIR_EraseRootFromParent_Done,
      // Label 19863: @1494374
      GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1494456), // Rule ID 18067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18067,
        GIR_EraseRootFromParent_Done,
      // Label 19864: @1494456
      GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1494538), // Rule ID 18070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18070,
        GIR_EraseRootFromParent_Done,
      // Label 19865: @1494538
      GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1494620), // Rule ID 18071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10852:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18071,
        GIR_EraseRootFromParent_Done,
      // Label 19866: @1494620
      GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1494702), // Rule ID 18074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18074,
        GIR_EraseRootFromParent_Done,
      // Label 19867: @1494702
      GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1494784), // Rule ID 18075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10852:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18075,
        GIR_EraseRootFromParent_Done,
      // Label 19868: @1494784
      GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1494866), // Rule ID 18078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18078,
        GIR_EraseRootFromParent_Done,
      // Label 19869: @1494866
      GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1494948), // Rule ID 18079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10852:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18079,
        GIR_EraseRootFromParent_Done,
      // Label 19870: @1494948
      GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1495030), // Rule ID 18082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18082,
        GIR_EraseRootFromParent_Done,
      // Label 19871: @1495030
      GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1495112), // Rule ID 18083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18083,
        GIR_EraseRootFromParent_Done,
      // Label 19872: @1495112
      GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1495194), // Rule ID 18086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18086,
        GIR_EraseRootFromParent_Done,
      // Label 19873: @1495194
      GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1495276), // Rule ID 18087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18087,
        GIR_EraseRootFromParent_Done,
      // Label 19874: @1495276
      GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1495358), // Rule ID 18090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18090,
        GIR_EraseRootFromParent_Done,
      // Label 19875: @1495358
      GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1495440), // Rule ID 18091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18091,
        GIR_EraseRootFromParent_Done,
      // Label 19876: @1495440
      GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1495522), // Rule ID 18094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18094,
        GIR_EraseRootFromParent_Done,
      // Label 19877: @1495522
      GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1495604), // Rule ID 18095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18095,
        GIR_EraseRootFromParent_Done,
      // Label 19878: @1495604
      GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1495686), // Rule ID 18098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10814:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18098,
        GIR_EraseRootFromParent_Done,
      // Label 19879: @1495686
      GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1495768), // Rule ID 18099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10814:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18099,
        GIR_EraseRootFromParent_Done,
      // Label 19880: @1495768
      GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1495850), // Rule ID 18102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18102,
        GIR_EraseRootFromParent_Done,
      // Label 19881: @1495850
      GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1495932), // Rule ID 18103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18103,
        GIR_EraseRootFromParent_Done,
      // Label 19882: @1495932
      GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1496014), // Rule ID 18106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18106,
        GIR_EraseRootFromParent_Done,
      // Label 19883: @1496014
      GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(1496096), // Rule ID 18107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18107,
        GIR_EraseRootFromParent_Done,
      // Label 19884: @1496096
      GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1496178), // Rule ID 18110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18110,
        GIR_EraseRootFromParent_Done,
      // Label 19885: @1496178
      GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1496260), // Rule ID 18111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18111,
        GIR_EraseRootFromParent_Done,
      // Label 19886: @1496260
      GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1496342), // Rule ID 18114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18114,
        GIR_EraseRootFromParent_Done,
      // Label 19887: @1496342
      GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1496424), // Rule ID 18115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18115,
        GIR_EraseRootFromParent_Done,
      // Label 19888: @1496424
      GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1496506), // Rule ID 18118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18118,
        GIR_EraseRootFromParent_Done,
      // Label 19889: @1496506
      GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(1496588), // Rule ID 18119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18119,
        GIR_EraseRootFromParent_Done,
      // Label 19890: @1496588
      GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1496670), // Rule ID 18122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18122,
        GIR_EraseRootFromParent_Done,
      // Label 19891: @1496670
      GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1496752), // Rule ID 18123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18123,
        GIR_EraseRootFromParent_Done,
      // Label 19892: @1496752
      GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1496834), // Rule ID 18126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18126,
        GIR_EraseRootFromParent_Done,
      // Label 19893: @1496834
      GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1496916), // Rule ID 18127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18127,
        GIR_EraseRootFromParent_Done,
      // Label 19894: @1496916
      GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1496998), // Rule ID 18130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18130,
        GIR_EraseRootFromParent_Done,
      // Label 19895: @1496998
      GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1497080), // Rule ID 18131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18131,
        GIR_EraseRootFromParent_Done,
      // Label 19896: @1497080
      GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1497162), // Rule ID 18134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18134,
        GIR_EraseRootFromParent_Done,
      // Label 19897: @1497162
      GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1497244), // Rule ID 18135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18135,
        GIR_EraseRootFromParent_Done,
      // Label 19898: @1497244
      GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1497326), // Rule ID 18138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18138,
        GIR_EraseRootFromParent_Done,
      // Label 19899: @1497326
      GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1497408), // Rule ID 18139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18139,
        GIR_EraseRootFromParent_Done,
      // Label 19900: @1497408
      GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1497490), // Rule ID 18142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18142,
        GIR_EraseRootFromParent_Done,
      // Label 19901: @1497490
      GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1497572), // Rule ID 18143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18143,
        GIR_EraseRootFromParent_Done,
      // Label 19902: @1497572
      GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1497654), // Rule ID 18146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18146,
        GIR_EraseRootFromParent_Done,
      // Label 19903: @1497654
      GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1497736), // Rule ID 18147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18147,
        GIR_EraseRootFromParent_Done,
      // Label 19904: @1497736
      GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1497818), // Rule ID 18150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18150,
        GIR_EraseRootFromParent_Done,
      // Label 19905: @1497818
      GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1497900), // Rule ID 18151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18151,
        GIR_EraseRootFromParent_Done,
      // Label 19906: @1497900
      GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1497982), // Rule ID 18154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18154,
        GIR_EraseRootFromParent_Done,
      // Label 19907: @1497982
      GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1498064), // Rule ID 18155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10814:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18155,
        GIR_EraseRootFromParent_Done,
      // Label 19908: @1498064
      GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1498146), // Rule ID 18158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10814:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18158,
        GIR_EraseRootFromParent_Done,
      // Label 19909: @1498146
      GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1498228), // Rule ID 18159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10814:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18159,
        GIR_EraseRootFromParent_Done,
      // Label 19910: @1498228
      GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1498310), // Rule ID 18162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18162,
        GIR_EraseRootFromParent_Done,
      // Label 19911: @1498310
      GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(1498392), // Rule ID 18163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10814:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18163,
        GIR_EraseRootFromParent_Done,
      // Label 19912: @1498392
      GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1498474), // Rule ID 18166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18166,
        GIR_EraseRootFromParent_Done,
      // Label 19913: @1498474
      GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1498556), // Rule ID 18167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18167,
        GIR_EraseRootFromParent_Done,
      // Label 19914: @1498556
      GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1498638), // Rule ID 18170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18170,
        GIR_EraseRootFromParent_Done,
      // Label 19915: @1498638
      GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1498720), // Rule ID 18171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18171,
        GIR_EraseRootFromParent_Done,
      // Label 19916: @1498720
      GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1498802), // Rule ID 18174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18174,
        GIR_EraseRootFromParent_Done,
      // Label 19917: @1498802
      GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1498884), // Rule ID 18175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18175,
        GIR_EraseRootFromParent_Done,
      // Label 19918: @1498884
      GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1498966), // Rule ID 18178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18178,
        GIR_EraseRootFromParent_Done,
      // Label 19919: @1498966
      GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1499048), // Rule ID 18179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18179,
        GIR_EraseRootFromParent_Done,
      // Label 19920: @1499048
      GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1499130), // Rule ID 18182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18182,
        GIR_EraseRootFromParent_Done,
      // Label 19921: @1499130
      GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1499212), // Rule ID 18183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18183,
        GIR_EraseRootFromParent_Done,
      // Label 19922: @1499212
      GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1499294), // Rule ID 18186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18186,
        GIR_EraseRootFromParent_Done,
      // Label 19923: @1499294
      GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1499376), // Rule ID 18187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18187,
        GIR_EraseRootFromParent_Done,
      // Label 19924: @1499376
      GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1499458), // Rule ID 18190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18190,
        GIR_EraseRootFromParent_Done,
      // Label 19925: @1499458
      GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1499540), // Rule ID 18191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10814:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18191,
        GIR_EraseRootFromParent_Done,
      // Label 19926: @1499540
      GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1499622), // Rule ID 18194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18194,
        GIR_EraseRootFromParent_Done,
      // Label 19927: @1499622
      GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1499704), // Rule ID 18195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10814:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18195,
        GIR_EraseRootFromParent_Done,
      // Label 19928: @1499704
      GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1499786), // Rule ID 18198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18198,
        GIR_EraseRootFromParent_Done,
      // Label 19929: @1499786
      GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1499868), // Rule ID 18199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10814:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18199,
        GIR_EraseRootFromParent_Done,
      // Label 19930: @1499868
      GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1499950), // Rule ID 18202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18202,
        GIR_EraseRootFromParent_Done,
      // Label 19931: @1499950
      GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1500032), // Rule ID 18203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18203,
        GIR_EraseRootFromParent_Done,
      // Label 19932: @1500032
      GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1500114), // Rule ID 18206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18206,
        GIR_EraseRootFromParent_Done,
      // Label 19933: @1500114
      GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1500196), // Rule ID 18207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18207,
        GIR_EraseRootFromParent_Done,
      // Label 19934: @1500196
      GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1500278), // Rule ID 18210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18210,
        GIR_EraseRootFromParent_Done,
      // Label 19935: @1500278
      GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1500360), // Rule ID 18211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18211,
        GIR_EraseRootFromParent_Done,
      // Label 19936: @1500360
      GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1500442), // Rule ID 18214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18214,
        GIR_EraseRootFromParent_Done,
      // Label 19937: @1500442
      GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1500524), // Rule ID 18215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18215,
        GIR_EraseRootFromParent_Done,
      // Label 19938: @1500524
      GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1500606), // Rule ID 18218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18218,
        GIR_EraseRootFromParent_Done,
      // Label 19939: @1500606
      GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1500688), // Rule ID 18219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18219,
        GIR_EraseRootFromParent_Done,
      // Label 19940: @1500688
      GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1500770), // Rule ID 18222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18222,
        GIR_EraseRootFromParent_Done,
      // Label 19941: @1500770
      GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1500852), // Rule ID 18223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18223,
        GIR_EraseRootFromParent_Done,
      // Label 19942: @1500852
      GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1500934), // Rule ID 18226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18226,
        GIR_EraseRootFromParent_Done,
      // Label 19943: @1500934
      GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1501016), // Rule ID 18227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18227,
        GIR_EraseRootFromParent_Done,
      // Label 19944: @1501016
      GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1501098), // Rule ID 18230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18230,
        GIR_EraseRootFromParent_Done,
      // Label 19945: @1501098
      GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1501180), // Rule ID 18231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18231,
        GIR_EraseRootFromParent_Done,
      // Label 19946: @1501180
      GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1501262), // Rule ID 18234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18234,
        GIR_EraseRootFromParent_Done,
      // Label 19947: @1501262
      GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1501344), // Rule ID 18235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18235,
        GIR_EraseRootFromParent_Done,
      // Label 19948: @1501344
      GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1501426), // Rule ID 18238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18238,
        GIR_EraseRootFromParent_Done,
      // Label 19949: @1501426
      GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1501508), // Rule ID 18239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18239,
        GIR_EraseRootFromParent_Done,
      // Label 19950: @1501508
      GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1501590), // Rule ID 18242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18242,
        GIR_EraseRootFromParent_Done,
      // Label 19951: @1501590
      GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1501672), // Rule ID 18243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18243,
        GIR_EraseRootFromParent_Done,
      // Label 19952: @1501672
      GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1501754), // Rule ID 18246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18246,
        GIR_EraseRootFromParent_Done,
      // Label 19953: @1501754
      GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1501836), // Rule ID 18247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18247,
        GIR_EraseRootFromParent_Done,
      // Label 19954: @1501836
      GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1501918), // Rule ID 18250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18250,
        GIR_EraseRootFromParent_Done,
      // Label 19955: @1501918
      GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1502000), // Rule ID 18251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18251,
        GIR_EraseRootFromParent_Done,
      // Label 19956: @1502000
      GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1502082), // Rule ID 18254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18254,
        GIR_EraseRootFromParent_Done,
      // Label 19957: @1502082
      GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1502164), // Rule ID 18255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18255,
        GIR_EraseRootFromParent_Done,
      // Label 19958: @1502164
      GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1502246), // Rule ID 18258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18258,
        GIR_EraseRootFromParent_Done,
      // Label 19959: @1502246
      GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1502328), // Rule ID 18259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18259,
        GIR_EraseRootFromParent_Done,
      // Label 19960: @1502328
      GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1502410), // Rule ID 18262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18262,
        GIR_EraseRootFromParent_Done,
      // Label 19961: @1502410
      GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1502492), // Rule ID 18263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18263,
        GIR_EraseRootFromParent_Done,
      // Label 19962: @1502492
      GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1502574), // Rule ID 18266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18266,
        GIR_EraseRootFromParent_Done,
      // Label 19963: @1502574
      GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1502656), // Rule ID 18267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18267,
        GIR_EraseRootFromParent_Done,
      // Label 19964: @1502656
      GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1502738), // Rule ID 18270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18270,
        GIR_EraseRootFromParent_Done,
      // Label 19965: @1502738
      GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1502820), // Rule ID 18271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18271,
        GIR_EraseRootFromParent_Done,
      // Label 19966: @1502820
      GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1502902), // Rule ID 18274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18274,
        GIR_EraseRootFromParent_Done,
      // Label 19967: @1502902
      GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1502984), // Rule ID 18275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10850:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18275,
        GIR_EraseRootFromParent_Done,
      // Label 19968: @1502984
      GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1503066), // Rule ID 18278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18278,
        GIR_EraseRootFromParent_Done,
      // Label 19969: @1503066
      GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1503148), // Rule ID 18279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10850:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18279,
        GIR_EraseRootFromParent_Done,
      // Label 19970: @1503148
      GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1503230), // Rule ID 18282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18282,
        GIR_EraseRootFromParent_Done,
      // Label 19971: @1503230
      GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1503312), // Rule ID 18283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10850:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18283,
        GIR_EraseRootFromParent_Done,
      // Label 19972: @1503312
      GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1503394), // Rule ID 18286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18286,
        GIR_EraseRootFromParent_Done,
      // Label 19973: @1503394
      GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1503476), // Rule ID 18287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18287,
        GIR_EraseRootFromParent_Done,
      // Label 19974: @1503476
      GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1503558), // Rule ID 18290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18290,
        GIR_EraseRootFromParent_Done,
      // Label 19975: @1503558
      GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1503640), // Rule ID 18291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18291,
        GIR_EraseRootFromParent_Done,
      // Label 19976: @1503640
      GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1503722), // Rule ID 18294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18294,
        GIR_EraseRootFromParent_Done,
      // Label 19977: @1503722
      GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1503804), // Rule ID 18295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18295,
        GIR_EraseRootFromParent_Done,
      // Label 19978: @1503804
      GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1503886), // Rule ID 18298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18298,
        GIR_EraseRootFromParent_Done,
      // Label 19979: @1503886
      GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1503968), // Rule ID 18299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18299,
        GIR_EraseRootFromParent_Done,
      // Label 19980: @1503968
      GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1504050), // Rule ID 18302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18302,
        GIR_EraseRootFromParent_Done,
      // Label 19981: @1504050
      GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1504132), // Rule ID 18303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18303,
        GIR_EraseRootFromParent_Done,
      // Label 19982: @1504132
      GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1504214), // Rule ID 18306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18306,
        GIR_EraseRootFromParent_Done,
      // Label 19983: @1504214
      GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1504296), // Rule ID 18307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18307,
        GIR_EraseRootFromParent_Done,
      // Label 19984: @1504296
      GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1504378), // Rule ID 18310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18310,
        GIR_EraseRootFromParent_Done,
      // Label 19985: @1504378
      GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1504460), // Rule ID 18311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10850:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18311,
        GIR_EraseRootFromParent_Done,
      // Label 19986: @1504460
      GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1504542), // Rule ID 18314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18314,
        GIR_EraseRootFromParent_Done,
      // Label 19987: @1504542
      GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1504624), // Rule ID 18315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10850:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18315,
        GIR_EraseRootFromParent_Done,
      // Label 19988: @1504624
      GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1504706), // Rule ID 18318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18318,
        GIR_EraseRootFromParent_Done,
      // Label 19989: @1504706
      GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1504788), // Rule ID 18319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10850:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18319,
        GIR_EraseRootFromParent_Done,
      // Label 19990: @1504788
      GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1504870), // Rule ID 18322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18322,
        GIR_EraseRootFromParent_Done,
      // Label 19991: @1504870
      GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1504952), // Rule ID 18323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18323,
        GIR_EraseRootFromParent_Done,
      // Label 19992: @1504952
      GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1505034), // Rule ID 18326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18326,
        GIR_EraseRootFromParent_Done,
      // Label 19993: @1505034
      GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1505116), // Rule ID 18327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18327,
        GIR_EraseRootFromParent_Done,
      // Label 19994: @1505116
      GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1505198), // Rule ID 18330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18330,
        GIR_EraseRootFromParent_Done,
      // Label 19995: @1505198
      GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1505280), // Rule ID 18331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18331,
        GIR_EraseRootFromParent_Done,
      // Label 19996: @1505280
      GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1505362), // Rule ID 18334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18334,
        GIR_EraseRootFromParent_Done,
      // Label 19997: @1505362
      GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1505444), // Rule ID 18335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18335,
        GIR_EraseRootFromParent_Done,
      // Label 19998: @1505444
      GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1505526), // Rule ID 18338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18338,
        GIR_EraseRootFromParent_Done,
      // Label 19999: @1505526
      GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1505608), // Rule ID 18339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18339,
        GIR_EraseRootFromParent_Done,
      // Label 20000: @1505608
      GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1505690), // Rule ID 18342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18342,
        GIR_EraseRootFromParent_Done,
      // Label 20001: @1505690
      GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1505772), // Rule ID 18343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18343,
        GIR_EraseRootFromParent_Done,
      // Label 20002: @1505772
      GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1505854), // Rule ID 18346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18346,
        GIR_EraseRootFromParent_Done,
      // Label 20003: @1505854
      GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1505936), // Rule ID 18347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18347,
        GIR_EraseRootFromParent_Done,
      // Label 20004: @1505936
      GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1506018), // Rule ID 18350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18350,
        GIR_EraseRootFromParent_Done,
      // Label 20005: @1506018
      GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1506100), // Rule ID 18351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18351,
        GIR_EraseRootFromParent_Done,
      // Label 20006: @1506100
      GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1506182), // Rule ID 18354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18354,
        GIR_EraseRootFromParent_Done,
      // Label 20007: @1506182
      GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1506264), // Rule ID 18355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18355,
        GIR_EraseRootFromParent_Done,
      // Label 20008: @1506264
      GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1506346), // Rule ID 18358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18358,
        GIR_EraseRootFromParent_Done,
      // Label 20009: @1506346
      GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1506428), // Rule ID 18359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18359,
        GIR_EraseRootFromParent_Done,
      // Label 20010: @1506428
      GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1506510), // Rule ID 18362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18362,
        GIR_EraseRootFromParent_Done,
      // Label 20011: @1506510
      GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1506592), // Rule ID 18363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18363,
        GIR_EraseRootFromParent_Done,
      // Label 20012: @1506592
      GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1506674), // Rule ID 18366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18366,
        GIR_EraseRootFromParent_Done,
      // Label 20013: @1506674
      GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1506756), // Rule ID 18367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18367,
        GIR_EraseRootFromParent_Done,
      // Label 20014: @1506756
      GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1506838), // Rule ID 18370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18370,
        GIR_EraseRootFromParent_Done,
      // Label 20015: @1506838
      GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1506920), // Rule ID 18371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18371,
        GIR_EraseRootFromParent_Done,
      // Label 20016: @1506920
      GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1507002), // Rule ID 18374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18374,
        GIR_EraseRootFromParent_Done,
      // Label 20017: @1507002
      GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1507084), // Rule ID 18375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18375,
        GIR_EraseRootFromParent_Done,
      // Label 20018: @1507084
      GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1507166), // Rule ID 18378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18378,
        GIR_EraseRootFromParent_Done,
      // Label 20019: @1507166
      GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1507248), // Rule ID 18379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18379,
        GIR_EraseRootFromParent_Done,
      // Label 20020: @1507248
      GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1507330), // Rule ID 18382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18382,
        GIR_EraseRootFromParent_Done,
      // Label 20021: @1507330
      GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1507412), // Rule ID 18383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18383,
        GIR_EraseRootFromParent_Done,
      // Label 20022: @1507412
      GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1507494), // Rule ID 18386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18386,
        GIR_EraseRootFromParent_Done,
      // Label 20023: @1507494
      GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1507576), // Rule ID 18387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18387,
        GIR_EraseRootFromParent_Done,
      // Label 20024: @1507576
      GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1507658), // Rule ID 18390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18390,
        GIR_EraseRootFromParent_Done,
      // Label 20025: @1507658
      GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1507740), // Rule ID 18391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18391,
        GIR_EraseRootFromParent_Done,
      // Label 20026: @1507740
      GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1507822), // Rule ID 18394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18394,
        GIR_EraseRootFromParent_Done,
      // Label 20027: @1507822
      GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1507904), // Rule ID 18395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10823:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18395,
        GIR_EraseRootFromParent_Done,
      // Label 20028: @1507904
      GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1507986), // Rule ID 18398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18398,
        GIR_EraseRootFromParent_Done,
      // Label 20029: @1507986
      GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1508068), // Rule ID 18399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10823:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18399,
        GIR_EraseRootFromParent_Done,
      // Label 20030: @1508068
      GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1508150), // Rule ID 18402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18402,
        GIR_EraseRootFromParent_Done,
      // Label 20031: @1508150
      GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1508232), // Rule ID 18403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10823:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18403,
        GIR_EraseRootFromParent_Done,
      // Label 20032: @1508232
      GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1508314), // Rule ID 18406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18406,
        GIR_EraseRootFromParent_Done,
      // Label 20033: @1508314
      GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1508396), // Rule ID 18407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18407,
        GIR_EraseRootFromParent_Done,
      // Label 20034: @1508396
      GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1508478), // Rule ID 18410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18410,
        GIR_EraseRootFromParent_Done,
      // Label 20035: @1508478
      GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1508560), // Rule ID 18411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18411,
        GIR_EraseRootFromParent_Done,
      // Label 20036: @1508560
      GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1508642), // Rule ID 18414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18414,
        GIR_EraseRootFromParent_Done,
      // Label 20037: @1508642
      GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1508724), // Rule ID 18415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18415,
        GIR_EraseRootFromParent_Done,
      // Label 20038: @1508724
      GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1508806), // Rule ID 18418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18418,
        GIR_EraseRootFromParent_Done,
      // Label 20039: @1508806
      GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1508888), // Rule ID 18419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18419,
        GIR_EraseRootFromParent_Done,
      // Label 20040: @1508888
      GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1508970), // Rule ID 18422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18422,
        GIR_EraseRootFromParent_Done,
      // Label 20041: @1508970
      GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1509052), // Rule ID 18423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18423,
        GIR_EraseRootFromParent_Done,
      // Label 20042: @1509052
      GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1509134), // Rule ID 18426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18426,
        GIR_EraseRootFromParent_Done,
      // Label 20043: @1509134
      GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1509216), // Rule ID 18427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18427,
        GIR_EraseRootFromParent_Done,
      // Label 20044: @1509216
      GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1509298), // Rule ID 18430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18430,
        GIR_EraseRootFromParent_Done,
      // Label 20045: @1509298
      GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1509380), // Rule ID 18431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10823:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18431,
        GIR_EraseRootFromParent_Done,
      // Label 20046: @1509380
      GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1509462), // Rule ID 18434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18434,
        GIR_EraseRootFromParent_Done,
      // Label 20047: @1509462
      GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1509544), // Rule ID 18435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10823:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18435,
        GIR_EraseRootFromParent_Done,
      // Label 20048: @1509544
      GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1509626), // Rule ID 18438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18438,
        GIR_EraseRootFromParent_Done,
      // Label 20049: @1509626
      GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1509708), // Rule ID 18439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10823:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18439,
        GIR_EraseRootFromParent_Done,
      // Label 20050: @1509708
      GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1509790), // Rule ID 18442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18442,
        GIR_EraseRootFromParent_Done,
      // Label 20051: @1509790
      GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1509872), // Rule ID 18443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18443,
        GIR_EraseRootFromParent_Done,
      // Label 20052: @1509872
      GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1509954), // Rule ID 18446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18446,
        GIR_EraseRootFromParent_Done,
      // Label 20053: @1509954
      GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1510036), // Rule ID 18447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18447,
        GIR_EraseRootFromParent_Done,
      // Label 20054: @1510036
      GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1510118), // Rule ID 18450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18450,
        GIR_EraseRootFromParent_Done,
      // Label 20055: @1510118
      GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1510200), // Rule ID 18451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18451,
        GIR_EraseRootFromParent_Done,
      // Label 20056: @1510200
      GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1510282), // Rule ID 18454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18454,
        GIR_EraseRootFromParent_Done,
      // Label 20057: @1510282
      GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1510364), // Rule ID 18455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18455,
        GIR_EraseRootFromParent_Done,
      // Label 20058: @1510364
      GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1510446), // Rule ID 18458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18458,
        GIR_EraseRootFromParent_Done,
      // Label 20059: @1510446
      GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1510528), // Rule ID 18459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18459,
        GIR_EraseRootFromParent_Done,
      // Label 20060: @1510528
      GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1510610), // Rule ID 18462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18462,
        GIR_EraseRootFromParent_Done,
      // Label 20061: @1510610
      GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1510692), // Rule ID 18463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18463,
        GIR_EraseRootFromParent_Done,
      // Label 20062: @1510692
      GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1510774), // Rule ID 18466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18466,
        GIR_EraseRootFromParent_Done,
      // Label 20063: @1510774
      GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1510856), // Rule ID 18467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18467,
        GIR_EraseRootFromParent_Done,
      // Label 20064: @1510856
      GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1510938), // Rule ID 18470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18470,
        GIR_EraseRootFromParent_Done,
      // Label 20065: @1510938
      GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1511020), // Rule ID 18471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18471,
        GIR_EraseRootFromParent_Done,
      // Label 20066: @1511020
      GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1511102), // Rule ID 18474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18474,
        GIR_EraseRootFromParent_Done,
      // Label 20067: @1511102
      GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1511184), // Rule ID 18475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18475,
        GIR_EraseRootFromParent_Done,
      // Label 20068: @1511184
      GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1511266), // Rule ID 18478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18478,
        GIR_EraseRootFromParent_Done,
      // Label 20069: @1511266
      GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1511348), // Rule ID 18479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18479,
        GIR_EraseRootFromParent_Done,
      // Label 20070: @1511348
      GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1511430), // Rule ID 18482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18482,
        GIR_EraseRootFromParent_Done,
      // Label 20071: @1511430
      GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1511512), // Rule ID 18483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18483,
        GIR_EraseRootFromParent_Done,
      // Label 20072: @1511512
      GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1511594), // Rule ID 18486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18486,
        GIR_EraseRootFromParent_Done,
      // Label 20073: @1511594
      GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1511676), // Rule ID 18487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18487,
        GIR_EraseRootFromParent_Done,
      // Label 20074: @1511676
      GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1511758), // Rule ID 18490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18490,
        GIR_EraseRootFromParent_Done,
      // Label 20075: @1511758
      GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1511840), // Rule ID 18491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18491,
        GIR_EraseRootFromParent_Done,
      // Label 20076: @1511840
      GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1511922), // Rule ID 18494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18494,
        GIR_EraseRootFromParent_Done,
      // Label 20077: @1511922
      GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1512004), // Rule ID 18495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18495,
        GIR_EraseRootFromParent_Done,
      // Label 20078: @1512004
      GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1512086), // Rule ID 18498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18498,
        GIR_EraseRootFromParent_Done,
      // Label 20079: @1512086
      GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1512168), // Rule ID 18499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18499,
        GIR_EraseRootFromParent_Done,
      // Label 20080: @1512168
      GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1512250), // Rule ID 18502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18502,
        GIR_EraseRootFromParent_Done,
      // Label 20081: @1512250
      GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1512332), // Rule ID 18503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18503,
        GIR_EraseRootFromParent_Done,
      // Label 20082: @1512332
      GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1512414), // Rule ID 18506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18506,
        GIR_EraseRootFromParent_Done,
      // Label 20083: @1512414
      GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1512496), // Rule ID 18507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18507,
        GIR_EraseRootFromParent_Done,
      // Label 20084: @1512496
      GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1512578), // Rule ID 18510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18510,
        GIR_EraseRootFromParent_Done,
      // Label 20085: @1512578
      GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1512660), // Rule ID 18511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18511,
        GIR_EraseRootFromParent_Done,
      // Label 20086: @1512660
      GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1512742), // Rule ID 18514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18514,
        GIR_EraseRootFromParent_Done,
      // Label 20087: @1512742
      GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1512824), // Rule ID 18515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10854:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18515,
        GIR_EraseRootFromParent_Done,
      // Label 20088: @1512824
      GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1512906), // Rule ID 18518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18518,
        GIR_EraseRootFromParent_Done,
      // Label 20089: @1512906
      GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1512988), // Rule ID 18519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10854:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18519,
        GIR_EraseRootFromParent_Done,
      // Label 20090: @1512988
      GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1513070), // Rule ID 18522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18522,
        GIR_EraseRootFromParent_Done,
      // Label 20091: @1513070
      GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1513152), // Rule ID 18523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10854:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18523,
        GIR_EraseRootFromParent_Done,
      // Label 20092: @1513152
      GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1513234), // Rule ID 18526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18526,
        GIR_EraseRootFromParent_Done,
      // Label 20093: @1513234
      GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1513316), // Rule ID 18527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18527,
        GIR_EraseRootFromParent_Done,
      // Label 20094: @1513316
      GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1513398), // Rule ID 18530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18530,
        GIR_EraseRootFromParent_Done,
      // Label 20095: @1513398
      GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1513480), // Rule ID 18531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18531,
        GIR_EraseRootFromParent_Done,
      // Label 20096: @1513480
      GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1513562), // Rule ID 18534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18534,
        GIR_EraseRootFromParent_Done,
      // Label 20097: @1513562
      GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1513644), // Rule ID 18535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18535,
        GIR_EraseRootFromParent_Done,
      // Label 20098: @1513644
      GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1513726), // Rule ID 18538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18538,
        GIR_EraseRootFromParent_Done,
      // Label 20099: @1513726
      GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1513808), // Rule ID 18539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18539,
        GIR_EraseRootFromParent_Done,
      // Label 20100: @1513808
      GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1513890), // Rule ID 18542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18542,
        GIR_EraseRootFromParent_Done,
      // Label 20101: @1513890
      GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1513972), // Rule ID 18543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18543,
        GIR_EraseRootFromParent_Done,
      // Label 20102: @1513972
      GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1514054), // Rule ID 18546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18546,
        GIR_EraseRootFromParent_Done,
      // Label 20103: @1514054
      GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1514136), // Rule ID 18547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18547,
        GIR_EraseRootFromParent_Done,
      // Label 20104: @1514136
      GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1514218), // Rule ID 18550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18550,
        GIR_EraseRootFromParent_Done,
      // Label 20105: @1514218
      GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1514300), // Rule ID 18551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10854:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18551,
        GIR_EraseRootFromParent_Done,
      // Label 20106: @1514300
      GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1514382), // Rule ID 18554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18554,
        GIR_EraseRootFromParent_Done,
      // Label 20107: @1514382
      GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1514464), // Rule ID 18555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10854:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18555,
        GIR_EraseRootFromParent_Done,
      // Label 20108: @1514464
      GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1514546), // Rule ID 18558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18558,
        GIR_EraseRootFromParent_Done,
      // Label 20109: @1514546
      GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1514628), // Rule ID 18559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10854:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18559,
        GIR_EraseRootFromParent_Done,
      // Label 20110: @1514628
      GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1514710), // Rule ID 18562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18562,
        GIR_EraseRootFromParent_Done,
      // Label 20111: @1514710
      GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1514792), // Rule ID 18563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18563,
        GIR_EraseRootFromParent_Done,
      // Label 20112: @1514792
      GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1514874), // Rule ID 18566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18566,
        GIR_EraseRootFromParent_Done,
      // Label 20113: @1514874
      GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1514956), // Rule ID 18567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18567,
        GIR_EraseRootFromParent_Done,
      // Label 20114: @1514956
      GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1515038), // Rule ID 18570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18570,
        GIR_EraseRootFromParent_Done,
      // Label 20115: @1515038
      GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1515120), // Rule ID 18571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18571,
        GIR_EraseRootFromParent_Done,
      // Label 20116: @1515120
      GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1515202), // Rule ID 18574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18574,
        GIR_EraseRootFromParent_Done,
      // Label 20117: @1515202
      GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1515284), // Rule ID 18575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18575,
        GIR_EraseRootFromParent_Done,
      // Label 20118: @1515284
      GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1515366), // Rule ID 18578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18578,
        GIR_EraseRootFromParent_Done,
      // Label 20119: @1515366
      GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1515448), // Rule ID 18579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18579,
        GIR_EraseRootFromParent_Done,
      // Label 20120: @1515448
      GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1515530), // Rule ID 18582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18582,
        GIR_EraseRootFromParent_Done,
      // Label 20121: @1515530
      GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1515612), // Rule ID 18583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18583,
        GIR_EraseRootFromParent_Done,
      // Label 20122: @1515612
      GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1515694), // Rule ID 18586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18586,
        GIR_EraseRootFromParent_Done,
      // Label 20123: @1515694
      GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1515776), // Rule ID 18587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18587,
        GIR_EraseRootFromParent_Done,
      // Label 20124: @1515776
      GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1515858), // Rule ID 18590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18590,
        GIR_EraseRootFromParent_Done,
      // Label 20125: @1515858
      GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1515940), // Rule ID 18591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18591,
        GIR_EraseRootFromParent_Done,
      // Label 20126: @1515940
      GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1516022), // Rule ID 18594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18594,
        GIR_EraseRootFromParent_Done,
      // Label 20127: @1516022
      GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1516104), // Rule ID 18595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18595,
        GIR_EraseRootFromParent_Done,
      // Label 20128: @1516104
      GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1516186), // Rule ID 18598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18598,
        GIR_EraseRootFromParent_Done,
      // Label 20129: @1516186
      GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1516268), // Rule ID 18599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18599,
        GIR_EraseRootFromParent_Done,
      // Label 20130: @1516268
      GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1516350), // Rule ID 18602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18602,
        GIR_EraseRootFromParent_Done,
      // Label 20131: @1516350
      GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1516432), // Rule ID 18603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10906:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18603,
        GIR_EraseRootFromParent_Done,
      // Label 20132: @1516432
      GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1516514), // Rule ID 18606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18606,
        GIR_EraseRootFromParent_Done,
      // Label 20133: @1516514
      GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1516596), // Rule ID 18607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18607,
        GIR_EraseRootFromParent_Done,
      // Label 20134: @1516596
      GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1516678), // Rule ID 18610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18610,
        GIR_EraseRootFromParent_Done,
      // Label 20135: @1516678
      GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1516760), // Rule ID 18611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18611,
        GIR_EraseRootFromParent_Done,
      // Label 20136: @1516760
      GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1516842), // Rule ID 18614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18614,
        GIR_EraseRootFromParent_Done,
      // Label 20137: @1516842
      GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1516924), // Rule ID 18615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18615,
        GIR_EraseRootFromParent_Done,
      // Label 20138: @1516924
      GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1517006), // Rule ID 18618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18618,
        GIR_EraseRootFromParent_Done,
      // Label 20139: @1517006
      GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1517088), // Rule ID 18619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10906:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18619,
        GIR_EraseRootFromParent_Done,
      // Label 20140: @1517088
      GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1517170), // Rule ID 18622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18622,
        GIR_EraseRootFromParent_Done,
      // Label 20141: @1517170
      GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1517252), // Rule ID 18623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10906:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18623,
        GIR_EraseRootFromParent_Done,
      // Label 20142: @1517252
      GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1517334), // Rule ID 18626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18626,
        GIR_EraseRootFromParent_Done,
      // Label 20143: @1517334
      GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1517416), // Rule ID 18627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10906:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18627,
        GIR_EraseRootFromParent_Done,
      // Label 20144: @1517416
      GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1517498), // Rule ID 18630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18630,
        GIR_EraseRootFromParent_Done,
      // Label 20145: @1517498
      GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1517580), // Rule ID 18631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10906:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18631,
        GIR_EraseRootFromParent_Done,
      // Label 20146: @1517580
      GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1517662), // Rule ID 18634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18634,
        GIR_EraseRootFromParent_Done,
      // Label 20147: @1517662
      GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1517744), // Rule ID 18635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18635,
        GIR_EraseRootFromParent_Done,
      // Label 20148: @1517744
      GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1517826), // Rule ID 18638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18638,
        GIR_EraseRootFromParent_Done,
      // Label 20149: @1517826
      GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1517908), // Rule ID 18639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18639,
        GIR_EraseRootFromParent_Done,
      // Label 20150: @1517908
      GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1517990), // Rule ID 18642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18642,
        GIR_EraseRootFromParent_Done,
      // Label 20151: @1517990
      GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1518072), // Rule ID 18643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18643,
        GIR_EraseRootFromParent_Done,
      // Label 20152: @1518072
      GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1518154), // Rule ID 18646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18646,
        GIR_EraseRootFromParent_Done,
      // Label 20153: @1518154
      GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1518236), // Rule ID 18647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18647,
        GIR_EraseRootFromParent_Done,
      // Label 20154: @1518236
      GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1518318), // Rule ID 18650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10914:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18650,
        GIR_EraseRootFromParent_Done,
      // Label 20155: @1518318
      GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1518400), // Rule ID 18651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10914:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18651,
        GIR_EraseRootFromParent_Done,
      // Label 20156: @1518400
      GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1518482), // Rule ID 18654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18654,
        GIR_EraseRootFromParent_Done,
      // Label 20157: @1518482
      GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1518564), // Rule ID 18655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18655,
        GIR_EraseRootFromParent_Done,
      // Label 20158: @1518564
      GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1518646), // Rule ID 18658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18658,
        GIR_EraseRootFromParent_Done,
      // Label 20159: @1518646
      GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1518728), // Rule ID 18659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18659,
        GIR_EraseRootFromParent_Done,
      // Label 20160: @1518728
      GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1518810), // Rule ID 18662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18662,
        GIR_EraseRootFromParent_Done,
      // Label 20161: @1518810
      GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1518892), // Rule ID 18663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18663,
        GIR_EraseRootFromParent_Done,
      // Label 20162: @1518892
      GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1518974), // Rule ID 18666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10914:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18666,
        GIR_EraseRootFromParent_Done,
      // Label 20163: @1518974
      GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1519056), // Rule ID 18667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10914:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18667,
        GIR_EraseRootFromParent_Done,
      // Label 20164: @1519056
      GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1519138), // Rule ID 18670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18670,
        GIR_EraseRootFromParent_Done,
      // Label 20165: @1519138
      GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1519220), // Rule ID 18671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18671,
        GIR_EraseRootFromParent_Done,
      // Label 20166: @1519220
      GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1519302), // Rule ID 18674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18674,
        GIR_EraseRootFromParent_Done,
      // Label 20167: @1519302
      GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1519384), // Rule ID 18675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10914:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18675,
        GIR_EraseRootFromParent_Done,
      // Label 20168: @1519384
      GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1519466), // Rule ID 18678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18678,
        GIR_EraseRootFromParent_Done,
      // Label 20169: @1519466
      GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1519548), // Rule ID 18679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18679,
        GIR_EraseRootFromParent_Done,
      // Label 20170: @1519548
      GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1519630), // Rule ID 18682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18682,
        GIR_EraseRootFromParent_Done,
      // Label 20171: @1519630
      GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1519712), // Rule ID 18683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18683,
        GIR_EraseRootFromParent_Done,
      // Label 20172: @1519712
      GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1519794), // Rule ID 18686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10914:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18686,
        GIR_EraseRootFromParent_Done,
      // Label 20173: @1519794
      GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1519876), // Rule ID 18687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10914:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18687,
        GIR_EraseRootFromParent_Done,
      // Label 20174: @1519876
      GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1519958), // Rule ID 18690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18690,
        GIR_EraseRootFromParent_Done,
      // Label 20175: @1519958
      GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1520040), // Rule ID 18691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10914:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18691,
        GIR_EraseRootFromParent_Done,
      // Label 20176: @1520040
      GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1520122), // Rule ID 18694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18694,
        GIR_EraseRootFromParent_Done,
      // Label 20177: @1520122
      GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1520204), // Rule ID 18695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10914:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18695,
        GIR_EraseRootFromParent_Done,
      // Label 20178: @1520204
      GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1520286), // Rule ID 18698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18698,
        GIR_EraseRootFromParent_Done,
      // Label 20179: @1520286
      GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1520368), // Rule ID 18699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10914:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18699,
        GIR_EraseRootFromParent_Done,
      // Label 20180: @1520368
      GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1520450), // Rule ID 18702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10914:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18702,
        GIR_EraseRootFromParent_Done,
      // Label 20181: @1520450
      GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1520532), // Rule ID 18703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10914:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18703,
        GIR_EraseRootFromParent_Done,
      // Label 20182: @1520532
      GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1520614), // Rule ID 18706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18706,
        GIR_EraseRootFromParent_Done,
      // Label 20183: @1520614
      GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1520696), // Rule ID 18707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18707,
        GIR_EraseRootFromParent_Done,
      // Label 20184: @1520696
      GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1520778), // Rule ID 18710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18710,
        GIR_EraseRootFromParent_Done,
      // Label 20185: @1520778
      GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1520860), // Rule ID 18711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18711,
        GIR_EraseRootFromParent_Done,
      // Label 20186: @1520860
      GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1520942), // Rule ID 18714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18714,
        GIR_EraseRootFromParent_Done,
      // Label 20187: @1520942
      GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1521024), // Rule ID 18715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18715,
        GIR_EraseRootFromParent_Done,
      // Label 20188: @1521024
      GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1521106), // Rule ID 18718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18718,
        GIR_EraseRootFromParent_Done,
      // Label 20189: @1521106
      GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1521188), // Rule ID 18719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18719,
        GIR_EraseRootFromParent_Done,
      // Label 20190: @1521188
      GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1521270), // Rule ID 18722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18722,
        GIR_EraseRootFromParent_Done,
      // Label 20191: @1521270
      GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1521352), // Rule ID 18723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18723,
        GIR_EraseRootFromParent_Done,
      // Label 20192: @1521352
      GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1521434), // Rule ID 18726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18726,
        GIR_EraseRootFromParent_Done,
      // Label 20193: @1521434
      GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1521516), // Rule ID 18727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18727,
        GIR_EraseRootFromParent_Done,
      // Label 20194: @1521516
      GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1521598), // Rule ID 18730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18730,
        GIR_EraseRootFromParent_Done,
      // Label 20195: @1521598
      GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1521680), // Rule ID 18731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18731,
        GIR_EraseRootFromParent_Done,
      // Label 20196: @1521680
      GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1521762), // Rule ID 18734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18734,
        GIR_EraseRootFromParent_Done,
      // Label 20197: @1521762
      GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1521844), // Rule ID 18735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18735,
        GIR_EraseRootFromParent_Done,
      // Label 20198: @1521844
      GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1521926), // Rule ID 18738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18738,
        GIR_EraseRootFromParent_Done,
      // Label 20199: @1521926
      GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1522008), // Rule ID 18739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18739,
        GIR_EraseRootFromParent_Done,
      // Label 20200: @1522008
      GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1522090), // Rule ID 18742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18742,
        GIR_EraseRootFromParent_Done,
      // Label 20201: @1522090
      GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1522172), // Rule ID 18743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18743,
        GIR_EraseRootFromParent_Done,
      // Label 20202: @1522172
      GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1522254), // Rule ID 18746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18746,
        GIR_EraseRootFromParent_Done,
      // Label 20203: @1522254
      GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1522336), // Rule ID 18747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10910:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18747,
        GIR_EraseRootFromParent_Done,
      // Label 20204: @1522336
      GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1522418), // Rule ID 18750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18750,
        GIR_EraseRootFromParent_Done,
      // Label 20205: @1522418
      GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1522500), // Rule ID 18751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18751,
        GIR_EraseRootFromParent_Done,
      // Label 20206: @1522500
      GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1522582), // Rule ID 18754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18754,
        GIR_EraseRootFromParent_Done,
      // Label 20207: @1522582
      GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1522664), // Rule ID 18755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18755,
        GIR_EraseRootFromParent_Done,
      // Label 20208: @1522664
      GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1522746), // Rule ID 18758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18758,
        GIR_EraseRootFromParent_Done,
      // Label 20209: @1522746
      GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1522828), // Rule ID 18759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18759,
        GIR_EraseRootFromParent_Done,
      // Label 20210: @1522828
      GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1522910), // Rule ID 18762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18762,
        GIR_EraseRootFromParent_Done,
      // Label 20211: @1522910
      GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1522992), // Rule ID 18763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10910:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18763,
        GIR_EraseRootFromParent_Done,
      // Label 20212: @1522992
      GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1523074), // Rule ID 18766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18766,
        GIR_EraseRootFromParent_Done,
      // Label 20213: @1523074
      GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1523156), // Rule ID 18767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10910:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18767,
        GIR_EraseRootFromParent_Done,
      // Label 20214: @1523156
      GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1523238), // Rule ID 18770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18770,
        GIR_EraseRootFromParent_Done,
      // Label 20215: @1523238
      GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1523320), // Rule ID 18771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10910:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18771,
        GIR_EraseRootFromParent_Done,
      // Label 20216: @1523320
      GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1523402), // Rule ID 18774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18774,
        GIR_EraseRootFromParent_Done,
      // Label 20217: @1523402
      GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1523484), // Rule ID 18775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10910:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18775,
        GIR_EraseRootFromParent_Done,
      // Label 20218: @1523484
      GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1523566), // Rule ID 18778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18778,
        GIR_EraseRootFromParent_Done,
      // Label 20219: @1523566
      GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1523648), // Rule ID 18779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18779,
        GIR_EraseRootFromParent_Done,
      // Label 20220: @1523648
      GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1523730), // Rule ID 18782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18782,
        GIR_EraseRootFromParent_Done,
      // Label 20221: @1523730
      GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1523812), // Rule ID 18783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18783,
        GIR_EraseRootFromParent_Done,
      // Label 20222: @1523812
      GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1523894), // Rule ID 18786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18786,
        GIR_EraseRootFromParent_Done,
      // Label 20223: @1523894
      GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1523976), // Rule ID 18787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18787,
        GIR_EraseRootFromParent_Done,
      // Label 20224: @1523976
      GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1524058), // Rule ID 18790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18790,
        GIR_EraseRootFromParent_Done,
      // Label 20225: @1524058
      GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1524140), // Rule ID 18791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18791,
        GIR_EraseRootFromParent_Done,
      // Label 20226: @1524140
      GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1524222), // Rule ID 18794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10916:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18794,
        GIR_EraseRootFromParent_Done,
      // Label 20227: @1524222
      GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1524304), // Rule ID 18795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10916:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18795,
        GIR_EraseRootFromParent_Done,
      // Label 20228: @1524304
      GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1524386), // Rule ID 18798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18798,
        GIR_EraseRootFromParent_Done,
      // Label 20229: @1524386
      GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1524468), // Rule ID 18799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18799,
        GIR_EraseRootFromParent_Done,
      // Label 20230: @1524468
      GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1524550), // Rule ID 18802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18802,
        GIR_EraseRootFromParent_Done,
      // Label 20231: @1524550
      GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1524632), // Rule ID 18803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18803,
        GIR_EraseRootFromParent_Done,
      // Label 20232: @1524632
      GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1524714), // Rule ID 18806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18806,
        GIR_EraseRootFromParent_Done,
      // Label 20233: @1524714
      GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1524796), // Rule ID 18807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18807,
        GIR_EraseRootFromParent_Done,
      // Label 20234: @1524796
      GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1524878), // Rule ID 18810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10916:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18810,
        GIR_EraseRootFromParent_Done,
      // Label 20235: @1524878
      GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1524960), // Rule ID 18811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10916:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18811,
        GIR_EraseRootFromParent_Done,
      // Label 20236: @1524960
      GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1525042), // Rule ID 18814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18814,
        GIR_EraseRootFromParent_Done,
      // Label 20237: @1525042
      GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1525124), // Rule ID 18815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18815,
        GIR_EraseRootFromParent_Done,
      // Label 20238: @1525124
      GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1525206), // Rule ID 18818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18818,
        GIR_EraseRootFromParent_Done,
      // Label 20239: @1525206
      GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1525288), // Rule ID 18819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10916:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18819,
        GIR_EraseRootFromParent_Done,
      // Label 20240: @1525288
      GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1525370), // Rule ID 18822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18822,
        GIR_EraseRootFromParent_Done,
      // Label 20241: @1525370
      GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1525452), // Rule ID 18823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18823,
        GIR_EraseRootFromParent_Done,
      // Label 20242: @1525452
      GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1525534), // Rule ID 18826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18826,
        GIR_EraseRootFromParent_Done,
      // Label 20243: @1525534
      GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1525616), // Rule ID 18827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18827,
        GIR_EraseRootFromParent_Done,
      // Label 20244: @1525616
      GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1525698), // Rule ID 18830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10916:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18830,
        GIR_EraseRootFromParent_Done,
      // Label 20245: @1525698
      GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1525780), // Rule ID 18831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10916:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18831,
        GIR_EraseRootFromParent_Done,
      // Label 20246: @1525780
      GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1525862), // Rule ID 18834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18834,
        GIR_EraseRootFromParent_Done,
      // Label 20247: @1525862
      GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1525944), // Rule ID 18835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10916:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18835,
        GIR_EraseRootFromParent_Done,
      // Label 20248: @1525944
      GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1526026), // Rule ID 18838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18838,
        GIR_EraseRootFromParent_Done,
      // Label 20249: @1526026
      GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1526108), // Rule ID 18839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10916:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18839,
        GIR_EraseRootFromParent_Done,
      // Label 20250: @1526108
      GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1526190), // Rule ID 18842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18842,
        GIR_EraseRootFromParent_Done,
      // Label 20251: @1526190
      GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1526272), // Rule ID 18843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10916:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18843,
        GIR_EraseRootFromParent_Done,
      // Label 20252: @1526272
      GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1526354), // Rule ID 18846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10916:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18846,
        GIR_EraseRootFromParent_Done,
      // Label 20253: @1526354
      GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1526436), // Rule ID 18847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10916:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18847,
        GIR_EraseRootFromParent_Done,
      // Label 20254: @1526436
      GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1526536), // Rule ID 18852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18852,
        GIR_EraseRootFromParent_Done,
      // Label 20255: @1526536
      GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1526636), // Rule ID 18853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18853,
        GIR_EraseRootFromParent_Done,
      // Label 20256: @1526636
      GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1526736), // Rule ID 18856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18856,
        GIR_EraseRootFromParent_Done,
      // Label 20257: @1526736
      GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1526836), // Rule ID 18857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18857,
        GIR_EraseRootFromParent_Done,
      // Label 20258: @1526836
      GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1526936), // Rule ID 18860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18860,
        GIR_EraseRootFromParent_Done,
      // Label 20259: @1526936
      GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1527036), // Rule ID 18861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10883:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18861,
        GIR_EraseRootFromParent_Done,
      // Label 20260: @1527036
      GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1527136), // Rule ID 18864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10883:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18864,
        GIR_EraseRootFromParent_Done,
      // Label 20261: @1527136
      GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1527236), // Rule ID 18865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10883:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18865,
        GIR_EraseRootFromParent_Done,
      // Label 20262: @1527236
      GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1527336), // Rule ID 18868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18868,
        GIR_EraseRootFromParent_Done,
      // Label 20263: @1527336
      GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1527436), // Rule ID 18869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10883:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18869,
        GIR_EraseRootFromParent_Done,
      // Label 20264: @1527436
      GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1527536), // Rule ID 18872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18872,
        GIR_EraseRootFromParent_Done,
      // Label 20265: @1527536
      GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1527636), // Rule ID 18873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18873,
        GIR_EraseRootFromParent_Done,
      // Label 20266: @1527636
      GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1527736), // Rule ID 18876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18876,
        GIR_EraseRootFromParent_Done,
      // Label 20267: @1527736
      GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1527836), // Rule ID 18877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18877,
        GIR_EraseRootFromParent_Done,
      // Label 20268: @1527836
      GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1527936), // Rule ID 18880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18880,
        GIR_EraseRootFromParent_Done,
      // Label 20269: @1527936
      GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1528036), // Rule ID 18881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18881,
        GIR_EraseRootFromParent_Done,
      // Label 20270: @1528036
      GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1528136), // Rule ID 18884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18884,
        GIR_EraseRootFromParent_Done,
      // Label 20271: @1528136
      GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1528236), // Rule ID 18885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18885,
        GIR_EraseRootFromParent_Done,
      // Label 20272: @1528236
      GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1528336), // Rule ID 18888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18888,
        GIR_EraseRootFromParent_Done,
      // Label 20273: @1528336
      GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1528436), // Rule ID 18889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18889,
        GIR_EraseRootFromParent_Done,
      // Label 20274: @1528436
      GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1528536), // Rule ID 18892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18892,
        GIR_EraseRootFromParent_Done,
      // Label 20275: @1528536
      GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1528636), // Rule ID 18893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18893,
        GIR_EraseRootFromParent_Done,
      // Label 20276: @1528636
      GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1528736), // Rule ID 18896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18896,
        GIR_EraseRootFromParent_Done,
      // Label 20277: @1528736
      GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1528836), // Rule ID 18897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10883:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18897,
        GIR_EraseRootFromParent_Done,
      // Label 20278: @1528836
      GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1528936), // Rule ID 18900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18900,
        GIR_EraseRootFromParent_Done,
      // Label 20279: @1528936
      GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1529036), // Rule ID 18901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10883:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18901,
        GIR_EraseRootFromParent_Done,
      // Label 20280: @1529036
      GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1529136), // Rule ID 18904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18904,
        GIR_EraseRootFromParent_Done,
      // Label 20281: @1529136
      GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1529236), // Rule ID 18905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10883:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18905,
        GIR_EraseRootFromParent_Done,
      // Label 20282: @1529236
      GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1529336), // Rule ID 18964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18964,
        GIR_EraseRootFromParent_Done,
      // Label 20283: @1529336
      GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1529436), // Rule ID 18965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18965,
        GIR_EraseRootFromParent_Done,
      // Label 20284: @1529436
      GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1529536), // Rule ID 18968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10859:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18968,
        GIR_EraseRootFromParent_Done,
      // Label 20285: @1529536
      GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1529636), // Rule ID 18969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10859:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18969,
        GIR_EraseRootFromParent_Done,
      // Label 20286: @1529636
      GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1529736), // Rule ID 18972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18972,
        GIR_EraseRootFromParent_Done,
      // Label 20287: @1529736
      GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1529836), // Rule ID 18973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18973,
        GIR_EraseRootFromParent_Done,
      // Label 20288: @1529836
      GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1529936), // Rule ID 18976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10859:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18976,
        GIR_EraseRootFromParent_Done,
      // Label 20289: @1529936
      GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1530036), // Rule ID 18977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10859:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18977,
        GIR_EraseRootFromParent_Done,
      // Label 20290: @1530036
      GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1530136), // Rule ID 18980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10859:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18980,
        GIR_EraseRootFromParent_Done,
      // Label 20291: @1530136
      GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1530236), // Rule ID 18981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10859:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18981,
        GIR_EraseRootFromParent_Done,
      // Label 20292: @1530236
      GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1530336), // Rule ID 18984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18984,
        GIR_EraseRootFromParent_Done,
      // Label 20293: @1530336
      GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1530436), // Rule ID 18985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10859:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18985,
        GIR_EraseRootFromParent_Done,
      // Label 20294: @1530436
      GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1530536), // Rule ID 18988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18988,
        GIR_EraseRootFromParent_Done,
      // Label 20295: @1530536
      GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1530636), // Rule ID 18989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18989,
        GIR_EraseRootFromParent_Done,
      // Label 20296: @1530636
      GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1530736), // Rule ID 18992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18992,
        GIR_EraseRootFromParent_Done,
      // Label 20297: @1530736
      GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1530836), // Rule ID 18993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18993,
        GIR_EraseRootFromParent_Done,
      // Label 20298: @1530836
      GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1530936), // Rule ID 18996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18996,
        GIR_EraseRootFromParent_Done,
      // Label 20299: @1530936
      GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1531036), // Rule ID 18997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18997,
        GIR_EraseRootFromParent_Done,
      // Label 20300: @1531036
      GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1531136), // Rule ID 19000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19000,
        GIR_EraseRootFromParent_Done,
      // Label 20301: @1531136
      GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1531236), // Rule ID 19001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19001,
        GIR_EraseRootFromParent_Done,
      // Label 20302: @1531236
      GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1531336), // Rule ID 19004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19004,
        GIR_EraseRootFromParent_Done,
      // Label 20303: @1531336
      GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1531436), // Rule ID 19005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19005,
        GIR_EraseRootFromParent_Done,
      // Label 20304: @1531436
      GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1531536), // Rule ID 19008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19008,
        GIR_EraseRootFromParent_Done,
      // Label 20305: @1531536
      GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1531636), // Rule ID 19009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19009,
        GIR_EraseRootFromParent_Done,
      // Label 20306: @1531636
      GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1531736), // Rule ID 19012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19012,
        GIR_EraseRootFromParent_Done,
      // Label 20307: @1531736
      GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1531836), // Rule ID 19013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10859:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19013,
        GIR_EraseRootFromParent_Done,
      // Label 20308: @1531836
      GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1531936), // Rule ID 19016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19016,
        GIR_EraseRootFromParent_Done,
      // Label 20309: @1531936
      GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1532036), // Rule ID 19017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10859:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19017,
        GIR_EraseRootFromParent_Done,
      // Label 20310: @1532036
      GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1532136), // Rule ID 19020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19020,
        GIR_EraseRootFromParent_Done,
      // Label 20311: @1532136
      GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1532236), // Rule ID 19021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10859:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19021,
        GIR_EraseRootFromParent_Done,
      // Label 20312: @1532236
      GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1532336), // Rule ID 20606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20606,
        GIR_EraseRootFromParent_Done,
      // Label 20313: @1532336
      GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1532436), // Rule ID 20607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20607,
        GIR_EraseRootFromParent_Done,
      // Label 20314: @1532436
      GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1532536), // Rule ID 20610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20610,
        GIR_EraseRootFromParent_Done,
      // Label 20315: @1532536
      GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1532636), // Rule ID 20611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20611,
        GIR_EraseRootFromParent_Done,
      // Label 20316: @1532636
      GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1532736), // Rule ID 20614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20614,
        GIR_EraseRootFromParent_Done,
      // Label 20317: @1532736
      GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1532836), // Rule ID 20615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10805:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20615,
        GIR_EraseRootFromParent_Done,
      // Label 20318: @1532836
      GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1532936), // Rule ID 20618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10805:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20618,
        GIR_EraseRootFromParent_Done,
      // Label 20319: @1532936
      GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1533036), // Rule ID 20619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10805:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20619,
        GIR_EraseRootFromParent_Done,
      // Label 20320: @1533036
      GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1533136), // Rule ID 20622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20622,
        GIR_EraseRootFromParent_Done,
      // Label 20321: @1533136
      GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1533236), // Rule ID 20623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10805:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20623,
        GIR_EraseRootFromParent_Done,
      // Label 20322: @1533236
      GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1533336), // Rule ID 20626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20626,
        GIR_EraseRootFromParent_Done,
      // Label 20323: @1533336
      GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1533436), // Rule ID 20627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20627,
        GIR_EraseRootFromParent_Done,
      // Label 20324: @1533436
      GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1533536), // Rule ID 20630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20630,
        GIR_EraseRootFromParent_Done,
      // Label 20325: @1533536
      GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1533636), // Rule ID 20631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20631,
        GIR_EraseRootFromParent_Done,
      // Label 20326: @1533636
      GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1533736), // Rule ID 20634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20634,
        GIR_EraseRootFromParent_Done,
      // Label 20327: @1533736
      GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1533836), // Rule ID 20635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20635,
        GIR_EraseRootFromParent_Done,
      // Label 20328: @1533836
      GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1533936), // Rule ID 20638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20638,
        GIR_EraseRootFromParent_Done,
      // Label 20329: @1533936
      GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1534036), // Rule ID 20639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20639,
        GIR_EraseRootFromParent_Done,
      // Label 20330: @1534036
      GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1534136), // Rule ID 20642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20642,
        GIR_EraseRootFromParent_Done,
      // Label 20331: @1534136
      GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1534236), // Rule ID 20643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20643,
        GIR_EraseRootFromParent_Done,
      // Label 20332: @1534236
      GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1534336), // Rule ID 20646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20646,
        GIR_EraseRootFromParent_Done,
      // Label 20333: @1534336
      GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1534436), // Rule ID 20647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20647,
        GIR_EraseRootFromParent_Done,
      // Label 20334: @1534436
      GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1534536), // Rule ID 20650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20650,
        GIR_EraseRootFromParent_Done,
      // Label 20335: @1534536
      GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1534636), // Rule ID 20651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10805:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20651,
        GIR_EraseRootFromParent_Done,
      // Label 20336: @1534636
      GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1534736), // Rule ID 20654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20654,
        GIR_EraseRootFromParent_Done,
      // Label 20337: @1534736
      GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1534836), // Rule ID 20655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10805:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20655,
        GIR_EraseRootFromParent_Done,
      // Label 20338: @1534836
      GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1534936), // Rule ID 20658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20658,
        GIR_EraseRootFromParent_Done,
      // Label 20339: @1534936
      GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1535036), // Rule ID 20659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10805:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20659,
        GIR_EraseRootFromParent_Done,
      // Label 20340: @1535036
      GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1535136), // Rule ID 20662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20662,
        GIR_EraseRootFromParent_Done,
      // Label 20341: @1535136
      GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1535236), // Rule ID 20663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20663,
        GIR_EraseRootFromParent_Done,
      // Label 20342: @1535236
      GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1535336), // Rule ID 20666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20666,
        GIR_EraseRootFromParent_Done,
      // Label 20343: @1535336
      GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1535436), // Rule ID 20667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20667,
        GIR_EraseRootFromParent_Done,
      // Label 20344: @1535436
      GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1535536), // Rule ID 20670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20670,
        GIR_EraseRootFromParent_Done,
      // Label 20345: @1535536
      GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1535636), // Rule ID 20671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20671,
        GIR_EraseRootFromParent_Done,
      // Label 20346: @1535636
      GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1535736), // Rule ID 20674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20674,
        GIR_EraseRootFromParent_Done,
      // Label 20347: @1535736
      GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1535836), // Rule ID 20675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10807:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20675,
        GIR_EraseRootFromParent_Done,
      // Label 20348: @1535836
      GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1535936), // Rule ID 20678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10807:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20678,
        GIR_EraseRootFromParent_Done,
      // Label 20349: @1535936
      GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1536036), // Rule ID 20679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10807:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20679,
        GIR_EraseRootFromParent_Done,
      // Label 20350: @1536036
      GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1536136), // Rule ID 20682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20682,
        GIR_EraseRootFromParent_Done,
      // Label 20351: @1536136
      GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1536236), // Rule ID 20683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10807:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20683,
        GIR_EraseRootFromParent_Done,
      // Label 20352: @1536236
      GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1536336), // Rule ID 20686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20686,
        GIR_EraseRootFromParent_Done,
      // Label 20353: @1536336
      GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1536436), // Rule ID 20687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20687,
        GIR_EraseRootFromParent_Done,
      // Label 20354: @1536436
      GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1536536), // Rule ID 20690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20690,
        GIR_EraseRootFromParent_Done,
      // Label 20355: @1536536
      GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1536636), // Rule ID 20691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20691,
        GIR_EraseRootFromParent_Done,
      // Label 20356: @1536636
      GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1536736), // Rule ID 20694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20694,
        GIR_EraseRootFromParent_Done,
      // Label 20357: @1536736
      GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1536836), // Rule ID 20695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20695,
        GIR_EraseRootFromParent_Done,
      // Label 20358: @1536836
      GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1536936), // Rule ID 20698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20698,
        GIR_EraseRootFromParent_Done,
      // Label 20359: @1536936
      GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1537036), // Rule ID 20699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20699,
        GIR_EraseRootFromParent_Done,
      // Label 20360: @1537036
      GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1537136), // Rule ID 20702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20702,
        GIR_EraseRootFromParent_Done,
      // Label 20361: @1537136
      GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1537236), // Rule ID 20703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20703,
        GIR_EraseRootFromParent_Done,
      // Label 20362: @1537236
      GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1537336), // Rule ID 20706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20706,
        GIR_EraseRootFromParent_Done,
      // Label 20363: @1537336
      GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1537436), // Rule ID 20707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20707,
        GIR_EraseRootFromParent_Done,
      // Label 20364: @1537436
      GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1537536), // Rule ID 20710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20710,
        GIR_EraseRootFromParent_Done,
      // Label 20365: @1537536
      GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1537636), // Rule ID 20711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10807:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20711,
        GIR_EraseRootFromParent_Done,
      // Label 20366: @1537636
      GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1537736), // Rule ID 20714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20714,
        GIR_EraseRootFromParent_Done,
      // Label 20367: @1537736
      GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1537836), // Rule ID 20715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10807:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20715,
        GIR_EraseRootFromParent_Done,
      // Label 20368: @1537836
      GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1537936), // Rule ID 20718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20718,
        GIR_EraseRootFromParent_Done,
      // Label 20369: @1537936
      GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1538036), // Rule ID 20719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10807:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20719,
        GIR_EraseRootFromParent_Done,
      // Label 20370: @1538036
      GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1538136), // Rule ID 20842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10797:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20842,
        GIR_EraseRootFromParent_Done,
      // Label 20371: @1538136
      GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1538236), // Rule ID 20843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10797:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20843,
        GIR_EraseRootFromParent_Done,
      // Label 20372: @1538236
      GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1538336), // Rule ID 20846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10797:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20846,
        GIR_EraseRootFromParent_Done,
      // Label 20373: @1538336
      GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1538436), // Rule ID 20847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10797:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20847,
        GIR_EraseRootFromParent_Done,
      // Label 20374: @1538436
      GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1538536), // Rule ID 20850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10797:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20850,
        GIR_EraseRootFromParent_Done,
      // Label 20375: @1538536
      GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1538636), // Rule ID 20851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10797:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20851,
        GIR_EraseRootFromParent_Done,
      // Label 20376: @1538636
      GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1538736), // Rule ID 20854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10797:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20854,
        GIR_EraseRootFromParent_Done,
      // Label 20377: @1538736
      GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1538836), // Rule ID 20855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10797:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20855,
        GIR_EraseRootFromParent_Done,
      // Label 20378: @1538836
      GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1538936), // Rule ID 20858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10797:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20858,
        GIR_EraseRootFromParent_Done,
      // Label 20379: @1538936
      GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1539036), // Rule ID 20859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10797:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20859,
        GIR_EraseRootFromParent_Done,
      // Label 20380: @1539036
      GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1539136), // Rule ID 20862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10797:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20862,
        GIR_EraseRootFromParent_Done,
      // Label 20381: @1539136
      GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1539236), // Rule ID 20863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10797:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20863,
        GIR_EraseRootFromParent_Done,
      // Label 20382: @1539236
      GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1539336), // Rule ID 20866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10797:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20866,
        GIR_EraseRootFromParent_Done,
      // Label 20383: @1539336
      GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1539436), // Rule ID 20867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10797:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20867,
        GIR_EraseRootFromParent_Done,
      // Label 20384: @1539436
      GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1539536), // Rule ID 20870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10797:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20870,
        GIR_EraseRootFromParent_Done,
      // Label 20385: @1539536
      GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1539636), // Rule ID 20871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10797:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20871,
        GIR_EraseRootFromParent_Done,
      // Label 20386: @1539636
      GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1539736), // Rule ID 20874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10797:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20874,
        GIR_EraseRootFromParent_Done,
      // Label 20387: @1539736
      GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1539836), // Rule ID 20875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10797:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20875,
        GIR_EraseRootFromParent_Done,
      // Label 20388: @1539836
      GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1539936), // Rule ID 20878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10797:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20878,
        GIR_EraseRootFromParent_Done,
      // Label 20389: @1539936
      GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1540036), // Rule ID 20879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10797:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20879,
        GIR_EraseRootFromParent_Done,
      // Label 20390: @1540036
      GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1540136), // Rule ID 20882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10797:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20882,
        GIR_EraseRootFromParent_Done,
      // Label 20391: @1540136
      GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1540236), // Rule ID 20883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10797:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20883,
        GIR_EraseRootFromParent_Done,
      // Label 20392: @1540236
      GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1540336), // Rule ID 20886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10797:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20886,
        GIR_EraseRootFromParent_Done,
      // Label 20393: @1540336
      GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1540436), // Rule ID 20887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10797:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20887,
        GIR_EraseRootFromParent_Done,
      // Label 20394: @1540436
      GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1540536), // Rule ID 20890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10797:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20890,
        GIR_EraseRootFromParent_Done,
      // Label 20395: @1540536
      GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1540636), // Rule ID 20891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10797:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20891,
        GIR_EraseRootFromParent_Done,
      // Label 20396: @1540636
      GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1540736), // Rule ID 20894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10797:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20894,
        GIR_EraseRootFromParent_Done,
      // Label 20397: @1540736
      GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1540836), // Rule ID 20895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10797:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20895,
        GIR_EraseRootFromParent_Done,
      // Label 20398: @1540836
      GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1540936), // Rule ID 20898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10797:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20898,
        GIR_EraseRootFromParent_Done,
      // Label 20399: @1540936
      GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1541036), // Rule ID 20899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10797:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20899,
        GIR_EraseRootFromParent_Done,
      // Label 20400: @1541036
      GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1541136), // Rule ID 20902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10799:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20902,
        GIR_EraseRootFromParent_Done,
      // Label 20401: @1541136
      GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1541236), // Rule ID 20903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10799:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20903,
        GIR_EraseRootFromParent_Done,
      // Label 20402: @1541236
      GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1541336), // Rule ID 20906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10799:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20906,
        GIR_EraseRootFromParent_Done,
      // Label 20403: @1541336
      GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1541436), // Rule ID 20907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10799:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20907,
        GIR_EraseRootFromParent_Done,
      // Label 20404: @1541436
      GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1541536), // Rule ID 20910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10799:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20910,
        GIR_EraseRootFromParent_Done,
      // Label 20405: @1541536
      GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1541636), // Rule ID 20911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10799:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20911,
        GIR_EraseRootFromParent_Done,
      // Label 20406: @1541636
      GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1541736), // Rule ID 20914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10799:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20914,
        GIR_EraseRootFromParent_Done,
      // Label 20407: @1541736
      GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1541836), // Rule ID 20915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10799:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20915,
        GIR_EraseRootFromParent_Done,
      // Label 20408: @1541836
      GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1541936), // Rule ID 20918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10799:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20918,
        GIR_EraseRootFromParent_Done,
      // Label 20409: @1541936
      GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1542036), // Rule ID 20919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10799:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20919,
        GIR_EraseRootFromParent_Done,
      // Label 20410: @1542036
      GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1542136), // Rule ID 20922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10799:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20922,
        GIR_EraseRootFromParent_Done,
      // Label 20411: @1542136
      GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1542236), // Rule ID 20923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10799:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20923,
        GIR_EraseRootFromParent_Done,
      // Label 20412: @1542236
      GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1542336), // Rule ID 20926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10799:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20926,
        GIR_EraseRootFromParent_Done,
      // Label 20413: @1542336
      GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1542436), // Rule ID 20927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10799:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20927,
        GIR_EraseRootFromParent_Done,
      // Label 20414: @1542436
      GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1542536), // Rule ID 20930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10799:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20930,
        GIR_EraseRootFromParent_Done,
      // Label 20415: @1542536
      GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1542636), // Rule ID 20931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10799:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20931,
        GIR_EraseRootFromParent_Done,
      // Label 20416: @1542636
      GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1542736), // Rule ID 20934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10799:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20934,
        GIR_EraseRootFromParent_Done,
      // Label 20417: @1542736
      GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1542836), // Rule ID 20935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10799:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20935,
        GIR_EraseRootFromParent_Done,
      // Label 20418: @1542836
      GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1542936), // Rule ID 20938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10799:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20938,
        GIR_EraseRootFromParent_Done,
      // Label 20419: @1542936
      GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1543036), // Rule ID 20939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10799:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20939,
        GIR_EraseRootFromParent_Done,
      // Label 20420: @1543036
      GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1543136), // Rule ID 20942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10799:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20942,
        GIR_EraseRootFromParent_Done,
      // Label 20421: @1543136
      GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1543236), // Rule ID 20943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10799:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20943,
        GIR_EraseRootFromParent_Done,
      // Label 20422: @1543236
      GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1543336), // Rule ID 20946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10799:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20946,
        GIR_EraseRootFromParent_Done,
      // Label 20423: @1543336
      GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1543436), // Rule ID 20947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10799:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20947,
        GIR_EraseRootFromParent_Done,
      // Label 20424: @1543436
      GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1543536), // Rule ID 20950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10799:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20950,
        GIR_EraseRootFromParent_Done,
      // Label 20425: @1543536
      GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1543636), // Rule ID 20951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10799:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20951,
        GIR_EraseRootFromParent_Done,
      // Label 20426: @1543636
      GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1543736), // Rule ID 20954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10799:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20954,
        GIR_EraseRootFromParent_Done,
      // Label 20427: @1543736
      GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1543836), // Rule ID 20955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10799:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20955,
        GIR_EraseRootFromParent_Done,
      // Label 20428: @1543836
      GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1543936), // Rule ID 20958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10799:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20958,
        GIR_EraseRootFromParent_Done,
      // Label 20429: @1543936
      GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1544036), // Rule ID 20959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10799:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20959,
        GIR_EraseRootFromParent_Done,
      // Label 20430: @1544036
      GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1544136), // Rule ID 21034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21034,
        GIR_EraseRootFromParent_Done,
      // Label 20431: @1544136
      GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1544236), // Rule ID 21035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21035,
        GIR_EraseRootFromParent_Done,
      // Label 20432: @1544236
      GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1544336), // Rule ID 21038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21038,
        GIR_EraseRootFromParent_Done,
      // Label 20433: @1544336
      GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1544436), // Rule ID 21039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10903:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21039,
        GIR_EraseRootFromParent_Done,
      // Label 20434: @1544436
      GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1544536), // Rule ID 21042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21042,
        GIR_EraseRootFromParent_Done,
      // Label 20435: @1544536
      GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1544636), // Rule ID 21043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21043,
        GIR_EraseRootFromParent_Done,
      // Label 20436: @1544636
      GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1544736), // Rule ID 21046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21046,
        GIR_EraseRootFromParent_Done,
      // Label 20437: @1544736
      GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1544836), // Rule ID 21047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21047,
        GIR_EraseRootFromParent_Done,
      // Label 20438: @1544836
      GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1544936), // Rule ID 21050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21050,
        GIR_EraseRootFromParent_Done,
      // Label 20439: @1544936
      GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1545036), // Rule ID 21051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21051,
        GIR_EraseRootFromParent_Done,
      // Label 20440: @1545036
      GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1545136), // Rule ID 21054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21054,
        GIR_EraseRootFromParent_Done,
      // Label 20441: @1545136
      GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1545236), // Rule ID 21055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10903:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21055,
        GIR_EraseRootFromParent_Done,
      // Label 20442: @1545236
      GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1545336), // Rule ID 21058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21058,
        GIR_EraseRootFromParent_Done,
      // Label 20443: @1545336
      GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1545436), // Rule ID 21059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10903:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21059,
        GIR_EraseRootFromParent_Done,
      // Label 20444: @1545436
      GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1545536), // Rule ID 21062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21062,
        GIR_EraseRootFromParent_Done,
      // Label 20445: @1545536
      GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1545636), // Rule ID 21063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10903:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21063,
        GIR_EraseRootFromParent_Done,
      // Label 20446: @1545636
      GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1545736), // Rule ID 21066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21066,
        GIR_EraseRootFromParent_Done,
      // Label 20447: @1545736
      GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1545836), // Rule ID 21067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10903:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21067,
        GIR_EraseRootFromParent_Done,
      // Label 20448: @1545836
      GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1545936), // Rule ID 21070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21070,
        GIR_EraseRootFromParent_Done,
      // Label 20449: @1545936
      GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1546036), // Rule ID 21071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21071,
        GIR_EraseRootFromParent_Done,
      // Label 20450: @1546036
      GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1546136), // Rule ID 21074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21074,
        GIR_EraseRootFromParent_Done,
      // Label 20451: @1546136
      GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1546236), // Rule ID 21075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10901:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21075,
        GIR_EraseRootFromParent_Done,
      // Label 20452: @1546236
      GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1546336), // Rule ID 21078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21078,
        GIR_EraseRootFromParent_Done,
      // Label 20453: @1546336
      GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1546436), // Rule ID 21079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21079,
        GIR_EraseRootFromParent_Done,
      // Label 20454: @1546436
      GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1546536), // Rule ID 21082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21082,
        GIR_EraseRootFromParent_Done,
      // Label 20455: @1546536
      GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1546636), // Rule ID 21083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21083,
        GIR_EraseRootFromParent_Done,
      // Label 20456: @1546636
      GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1546736), // Rule ID 21086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21086,
        GIR_EraseRootFromParent_Done,
      // Label 20457: @1546736
      GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1546836), // Rule ID 21087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21087,
        GIR_EraseRootFromParent_Done,
      // Label 20458: @1546836
      GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1546936), // Rule ID 21090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21090,
        GIR_EraseRootFromParent_Done,
      // Label 20459: @1546936
      GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1547036), // Rule ID 21091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10901:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21091,
        GIR_EraseRootFromParent_Done,
      // Label 20460: @1547036
      GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1547136), // Rule ID 21094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21094,
        GIR_EraseRootFromParent_Done,
      // Label 20461: @1547136
      GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1547236), // Rule ID 21095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10901:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21095,
        GIR_EraseRootFromParent_Done,
      // Label 20462: @1547236
      GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1547336), // Rule ID 21098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21098,
        GIR_EraseRootFromParent_Done,
      // Label 20463: @1547336
      GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1547436), // Rule ID 21099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10901:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21099,
        GIR_EraseRootFromParent_Done,
      // Label 20464: @1547436
      GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1547536), // Rule ID 21102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21102,
        GIR_EraseRootFromParent_Done,
      // Label 20465: @1547536
      GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1547636), // Rule ID 21103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10901:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21103,
        GIR_EraseRootFromParent_Done,
      // Label 20466: @1547636
      GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1547736), // Rule ID 21454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21454,
        GIR_EraseRootFromParent_Done,
      // Label 20467: @1547736
      GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1547836), // Rule ID 21455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21455,
        GIR_EraseRootFromParent_Done,
      // Label 20468: @1547836
      GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1547936), // Rule ID 21458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21458,
        GIR_EraseRootFromParent_Done,
      // Label 20469: @1547936
      GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1548036), // Rule ID 21459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21459,
        GIR_EraseRootFromParent_Done,
      // Label 20470: @1548036
      GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1548136), // Rule ID 21462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21462,
        GIR_EraseRootFromParent_Done,
      // Label 20471: @1548136
      GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1548236), // Rule ID 21463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21463,
        GIR_EraseRootFromParent_Done,
      // Label 20472: @1548236
      GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1548336), // Rule ID 21466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21466,
        GIR_EraseRootFromParent_Done,
      // Label 20473: @1548336
      GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1548436), // Rule ID 21467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10845:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21467,
        GIR_EraseRootFromParent_Done,
      // Label 20474: @1548436
      GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1548536), // Rule ID 21470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21470,
        GIR_EraseRootFromParent_Done,
      // Label 20475: @1548536
      GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1548636), // Rule ID 21471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21471,
        GIR_EraseRootFromParent_Done,
      // Label 20476: @1548636
      GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1548736), // Rule ID 21474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21474,
        GIR_EraseRootFromParent_Done,
      // Label 20477: @1548736
      GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1548836), // Rule ID 21475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21475,
        GIR_EraseRootFromParent_Done,
      // Label 20478: @1548836
      GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1548936), // Rule ID 21478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21478,
        GIR_EraseRootFromParent_Done,
      // Label 20479: @1548936
      GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1549036), // Rule ID 21479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21479,
        GIR_EraseRootFromParent_Done,
      // Label 20480: @1549036
      GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1549136), // Rule ID 21482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21482,
        GIR_EraseRootFromParent_Done,
      // Label 20481: @1549136
      GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1549236), // Rule ID 21483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21483,
        GIR_EraseRootFromParent_Done,
      // Label 20482: @1549236
      GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1549336), // Rule ID 21486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21486,
        GIR_EraseRootFromParent_Done,
      // Label 20483: @1549336
      GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1549436), // Rule ID 21487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10845:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21487,
        GIR_EraseRootFromParent_Done,
      // Label 20484: @1549436
      GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1549536), // Rule ID 21490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21490,
        GIR_EraseRootFromParent_Done,
      // Label 20485: @1549536
      GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1549636), // Rule ID 21491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21491,
        GIR_EraseRootFromParent_Done,
      // Label 20486: @1549636
      GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1549736), // Rule ID 21494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21494,
        GIR_EraseRootFromParent_Done,
      // Label 20487: @1549736
      GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1549836), // Rule ID 21495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21495,
        GIR_EraseRootFromParent_Done,
      // Label 20488: @1549836
      GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1549936), // Rule ID 21498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21498,
        GIR_EraseRootFromParent_Done,
      // Label 20489: @1549936
      GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1550036), // Rule ID 21499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21499,
        GIR_EraseRootFromParent_Done,
      // Label 20490: @1550036
      GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1550136), // Rule ID 21502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21502,
        GIR_EraseRootFromParent_Done,
      // Label 20491: @1550136
      GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1550236), // Rule ID 21503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10845:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21503,
        GIR_EraseRootFromParent_Done,
      // Label 20492: @1550236
      GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1550336), // Rule ID 21506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21506,
        GIR_EraseRootFromParent_Done,
      // Label 20493: @1550336
      GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1550436), // Rule ID 21507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10845:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21507,
        GIR_EraseRootFromParent_Done,
      // Label 20494: @1550436
      GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1550536), // Rule ID 21510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21510,
        GIR_EraseRootFromParent_Done,
      // Label 20495: @1550536
      GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1550636), // Rule ID 21511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10845:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21511,
        GIR_EraseRootFromParent_Done,
      // Label 20496: @1550636
      GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1550736), // Rule ID 21514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21514,
        GIR_EraseRootFromParent_Done,
      // Label 20497: @1550736
      GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1550836), // Rule ID 21515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21515,
        GIR_EraseRootFromParent_Done,
      // Label 20498: @1550836
      GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1550936), // Rule ID 21518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21518,
        GIR_EraseRootFromParent_Done,
      // Label 20499: @1550936
      GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1551036), // Rule ID 21519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21519,
        GIR_EraseRootFromParent_Done,
      // Label 20500: @1551036
      GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1551136), // Rule ID 21522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21522,
        GIR_EraseRootFromParent_Done,
      // Label 20501: @1551136
      GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1551236), // Rule ID 21523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21523,
        GIR_EraseRootFromParent_Done,
      // Label 20502: @1551236
      GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1551336), // Rule ID 21526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21526,
        GIR_EraseRootFromParent_Done,
      // Label 20503: @1551336
      GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1551436), // Rule ID 21527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10843:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21527,
        GIR_EraseRootFromParent_Done,
      // Label 20504: @1551436
      GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1551536), // Rule ID 21530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21530,
        GIR_EraseRootFromParent_Done,
      // Label 20505: @1551536
      GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1551636), // Rule ID 21531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21531,
        GIR_EraseRootFromParent_Done,
      // Label 20506: @1551636
      GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1551736), // Rule ID 21534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21534,
        GIR_EraseRootFromParent_Done,
      // Label 20507: @1551736
      GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1551836), // Rule ID 21535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21535,
        GIR_EraseRootFromParent_Done,
      // Label 20508: @1551836
      GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1551936), // Rule ID 21538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21538,
        GIR_EraseRootFromParent_Done,
      // Label 20509: @1551936
      GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1552036), // Rule ID 21539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21539,
        GIR_EraseRootFromParent_Done,
      // Label 20510: @1552036
      GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1552136), // Rule ID 21542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21542,
        GIR_EraseRootFromParent_Done,
      // Label 20511: @1552136
      GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1552236), // Rule ID 21543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21543,
        GIR_EraseRootFromParent_Done,
      // Label 20512: @1552236
      GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1552336), // Rule ID 21546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21546,
        GIR_EraseRootFromParent_Done,
      // Label 20513: @1552336
      GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1552436), // Rule ID 21547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10843:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21547,
        GIR_EraseRootFromParent_Done,
      // Label 20514: @1552436
      GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1552536), // Rule ID 21550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21550,
        GIR_EraseRootFromParent_Done,
      // Label 20515: @1552536
      GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1552636), // Rule ID 21551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21551,
        GIR_EraseRootFromParent_Done,
      // Label 20516: @1552636
      GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1552736), // Rule ID 21554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21554,
        GIR_EraseRootFromParent_Done,
      // Label 20517: @1552736
      GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1552836), // Rule ID 21555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21555,
        GIR_EraseRootFromParent_Done,
      // Label 20518: @1552836
      GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1552936), // Rule ID 21558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21558,
        GIR_EraseRootFromParent_Done,
      // Label 20519: @1552936
      GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1553036), // Rule ID 21559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21559,
        GIR_EraseRootFromParent_Done,
      // Label 20520: @1553036
      GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1553136), // Rule ID 21562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21562,
        GIR_EraseRootFromParent_Done,
      // Label 20521: @1553136
      GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1553236), // Rule ID 21563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10843:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21563,
        GIR_EraseRootFromParent_Done,
      // Label 20522: @1553236
      GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1553336), // Rule ID 21566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21566,
        GIR_EraseRootFromParent_Done,
      // Label 20523: @1553336
      GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1553436), // Rule ID 21567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10843:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21567,
        GIR_EraseRootFromParent_Done,
      // Label 20524: @1553436
      GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1553536), // Rule ID 21570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21570,
        GIR_EraseRootFromParent_Done,
      // Label 20525: @1553536
      GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1553636), // Rule ID 21571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10843:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21571,
        GIR_EraseRootFromParent_Done,
      // Label 20526: @1553636
      GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1553736), // Rule ID 21694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21694,
        GIR_EraseRootFromParent_Done,
      // Label 20527: @1553736
      GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1553836), // Rule ID 21695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21695,
        GIR_EraseRootFromParent_Done,
      // Label 20528: @1553836
      GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1553936), // Rule ID 21698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21698,
        GIR_EraseRootFromParent_Done,
      // Label 20529: @1553936
      GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1554036), // Rule ID 21699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21699,
        GIR_EraseRootFromParent_Done,
      // Label 20530: @1554036
      GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1554136), // Rule ID 21702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21702,
        GIR_EraseRootFromParent_Done,
      // Label 20531: @1554136
      GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1554236), // Rule ID 21703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10835:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21703,
        GIR_EraseRootFromParent_Done,
      // Label 20532: @1554236
      GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1554336), // Rule ID 21706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21706,
        GIR_EraseRootFromParent_Done,
      // Label 20533: @1554336
      GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1554436), // Rule ID 21707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21707,
        GIR_EraseRootFromParent_Done,
      // Label 20534: @1554436
      GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1554536), // Rule ID 21710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21710,
        GIR_EraseRootFromParent_Done,
      // Label 20535: @1554536
      GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1554636), // Rule ID 21711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21711,
        GIR_EraseRootFromParent_Done,
      // Label 20536: @1554636
      GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1554736), // Rule ID 21714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21714,
        GIR_EraseRootFromParent_Done,
      // Label 20537: @1554736
      GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1554836), // Rule ID 21715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21715,
        GIR_EraseRootFromParent_Done,
      // Label 20538: @1554836
      GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1554936), // Rule ID 21718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21718,
        GIR_EraseRootFromParent_Done,
      // Label 20539: @1554936
      GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1555036), // Rule ID 21719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10835:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21719,
        GIR_EraseRootFromParent_Done,
      // Label 20540: @1555036
      GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1555136), // Rule ID 21722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21722,
        GIR_EraseRootFromParent_Done,
      // Label 20541: @1555136
      GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1555236), // Rule ID 21723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10835:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21723,
        GIR_EraseRootFromParent_Done,
      // Label 20542: @1555236
      GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1555336), // Rule ID 21726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21726,
        GIR_EraseRootFromParent_Done,
      // Label 20543: @1555336
      GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1555436), // Rule ID 21727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10835:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21727,
        GIR_EraseRootFromParent_Done,
      // Label 20544: @1555436
      GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1555536), // Rule ID 21730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21730,
        GIR_EraseRootFromParent_Done,
      // Label 20545: @1555536
      GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1555636), // Rule ID 21731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21731,
        GIR_EraseRootFromParent_Done,
      // Label 20546: @1555636
      GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1555736), // Rule ID 21734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21734,
        GIR_EraseRootFromParent_Done,
      // Label 20547: @1555736
      GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1555836), // Rule ID 21735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21735,
        GIR_EraseRootFromParent_Done,
      // Label 20548: @1555836
      GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1555936), // Rule ID 21738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21738,
        GIR_EraseRootFromParent_Done,
      // Label 20549: @1555936
      GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1556036), // Rule ID 21739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10833:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21739,
        GIR_EraseRootFromParent_Done,
      // Label 20550: @1556036
      GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1556136), // Rule ID 21742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21742,
        GIR_EraseRootFromParent_Done,
      // Label 20551: @1556136
      GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1556236), // Rule ID 21743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21743,
        GIR_EraseRootFromParent_Done,
      // Label 20552: @1556236
      GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1556336), // Rule ID 21746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21746,
        GIR_EraseRootFromParent_Done,
      // Label 20553: @1556336
      GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1556436), // Rule ID 21747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21747,
        GIR_EraseRootFromParent_Done,
      // Label 20554: @1556436
      GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1556536), // Rule ID 21750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21750,
        GIR_EraseRootFromParent_Done,
      // Label 20555: @1556536
      GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1556636), // Rule ID 21751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21751,
        GIR_EraseRootFromParent_Done,
      // Label 20556: @1556636
      GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1556736), // Rule ID 21754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21754,
        GIR_EraseRootFromParent_Done,
      // Label 20557: @1556736
      GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1556836), // Rule ID 21755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10833:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21755,
        GIR_EraseRootFromParent_Done,
      // Label 20558: @1556836
      GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1556936), // Rule ID 21758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21758,
        GIR_EraseRootFromParent_Done,
      // Label 20559: @1556936
      GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1557036), // Rule ID 21759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10833:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21759,
        GIR_EraseRootFromParent_Done,
      // Label 20560: @1557036
      GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1557136), // Rule ID 21762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21762,
        GIR_EraseRootFromParent_Done,
      // Label 20561: @1557136
      GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1557236), // Rule ID 21763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10833:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21763,
        GIR_EraseRootFromParent_Done,
      // Label 20562: @1557236
      GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1557336), // Rule ID 21766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21766,
        GIR_EraseRootFromParent_Done,
      // Label 20563: @1557336
      GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1557436), // Rule ID 21767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21767,
        GIR_EraseRootFromParent_Done,
      // Label 20564: @1557436
      GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1557536), // Rule ID 21770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21770,
        GIR_EraseRootFromParent_Done,
      // Label 20565: @1557536
      GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1557636), // Rule ID 21771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21771,
        GIR_EraseRootFromParent_Done,
      // Label 20566: @1557636
      GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1557736), // Rule ID 21774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21774,
        GIR_EraseRootFromParent_Done,
      // Label 20567: @1557736
      GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1557836), // Rule ID 21775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21775,
        GIR_EraseRootFromParent_Done,
      // Label 20568: @1557836
      GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1557936), // Rule ID 21778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21778,
        GIR_EraseRootFromParent_Done,
      // Label 20569: @1557936
      GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1558036), // Rule ID 21779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21779,
        GIR_EraseRootFromParent_Done,
      // Label 20570: @1558036
      GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1558136), // Rule ID 21782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21782,
        GIR_EraseRootFromParent_Done,
      // Label 20571: @1558136
      GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1558236), // Rule ID 21783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21783,
        GIR_EraseRootFromParent_Done,
      // Label 20572: @1558236
      GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1558336), // Rule ID 21786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21786,
        GIR_EraseRootFromParent_Done,
      // Label 20573: @1558336
      GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1558436), // Rule ID 21787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21787,
        GIR_EraseRootFromParent_Done,
      // Label 20574: @1558436
      GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1558536), // Rule ID 21790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21790,
        GIR_EraseRootFromParent_Done,
      // Label 20575: @1558536
      GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1558636), // Rule ID 21791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10831:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21791,
        GIR_EraseRootFromParent_Done,
      // Label 20576: @1558636
      GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1558736), // Rule ID 21794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21794,
        GIR_EraseRootFromParent_Done,
      // Label 20577: @1558736
      GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1558836), // Rule ID 21795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10831:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21795,
        GIR_EraseRootFromParent_Done,
      // Label 20578: @1558836
      GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1558936), // Rule ID 21798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21798,
        GIR_EraseRootFromParent_Done,
      // Label 20579: @1558936
      GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1559036), // Rule ID 21799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10831:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/5, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21799,
        GIR_EraseRootFromParent_Done,
      // Label 20580: @1559036
      GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1559136), // Rule ID 2616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2616,
        GIR_EraseRootFromParent_Done,
      // Label 20581: @1559136
      GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1559236), // Rule ID 2617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2617,
        GIR_EraseRootFromParent_Done,
      // Label 20582: @1559236
      GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1559336), // Rule ID 3924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3924,
        GIR_EraseRootFromParent_Done,
      // Label 20583: @1559336
      GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1559436), // Rule ID 3925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3925,
        GIR_EraseRootFromParent_Done,
      // Label 20584: @1559436
      GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1559536), // Rule ID 3934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3934,
        GIR_EraseRootFromParent_Done,
      // Label 20585: @1559536
      GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1559636), // Rule ID 3935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3935,
        GIR_EraseRootFromParent_Done,
      // Label 20586: @1559636
      GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1559736), // Rule ID 3944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3944,
        GIR_EraseRootFromParent_Done,
      // Label 20587: @1559736
      GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1559836), // Rule ID 3945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3945,
        GIR_EraseRootFromParent_Done,
      // Label 20588: @1559836
      GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1559936), // Rule ID 3954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3954,
        GIR_EraseRootFromParent_Done,
      // Label 20589: @1559936
      GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1560036), // Rule ID 3955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3955,
        GIR_EraseRootFromParent_Done,
      // Label 20590: @1560036
      GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1560136), // Rule ID 3964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3964,
        GIR_EraseRootFromParent_Done,
      // Label 20591: @1560136
      GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1560236), // Rule ID 3965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3965,
        GIR_EraseRootFromParent_Done,
      // Label 20592: @1560236
      GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1560336), // Rule ID 3974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3974,
        GIR_EraseRootFromParent_Done,
      // Label 20593: @1560336
      GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1560436), // Rule ID 3975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3975,
        GIR_EraseRootFromParent_Done,
      // Label 20594: @1560436
      GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1560536), // Rule ID 3984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3984,
        GIR_EraseRootFromParent_Done,
      // Label 20595: @1560536
      GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1560636), // Rule ID 3985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3985,
        GIR_EraseRootFromParent_Done,
      // Label 20596: @1560636
      GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1560736), // Rule ID 3994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3994,
        GIR_EraseRootFromParent_Done,
      // Label 20597: @1560736
      GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1560836), // Rule ID 3995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3995,
        GIR_EraseRootFromParent_Done,
      // Label 20598: @1560836
      GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1560936), // Rule ID 4004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4004,
        GIR_EraseRootFromParent_Done,
      // Label 20599: @1560936
      GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1561036), // Rule ID 4005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4005,
        GIR_EraseRootFromParent_Done,
      // Label 20600: @1561036
      GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1561136), // Rule ID 4014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4014,
        GIR_EraseRootFromParent_Done,
      // Label 20601: @1561136
      GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1561236), // Rule ID 4015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4015,
        GIR_EraseRootFromParent_Done,
      // Label 20602: @1561236
      GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1561336), // Rule ID 4024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4024,
        GIR_EraseRootFromParent_Done,
      // Label 20603: @1561336
      GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1561436), // Rule ID 4025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4025,
        GIR_EraseRootFromParent_Done,
      // Label 20604: @1561436
      GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1561536), // Rule ID 4034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4034,
        GIR_EraseRootFromParent_Done,
      // Label 20605: @1561536
      GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1561636), // Rule ID 4035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4035,
        GIR_EraseRootFromParent_Done,
      // Label 20606: @1561636
      GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1561736), // Rule ID 4044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4044,
        GIR_EraseRootFromParent_Done,
      // Label 20607: @1561736
      GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1561836), // Rule ID 4045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4045,
        GIR_EraseRootFromParent_Done,
      // Label 20608: @1561836
      GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1561936), // Rule ID 4054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4054,
        GIR_EraseRootFromParent_Done,
      // Label 20609: @1561936
      GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1562036), // Rule ID 4055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4055,
        GIR_EraseRootFromParent_Done,
      // Label 20610: @1562036
      GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1562136), // Rule ID 4124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4124,
        GIR_EraseRootFromParent_Done,
      // Label 20611: @1562136
      GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1562236), // Rule ID 4125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4125,
        GIR_EraseRootFromParent_Done,
      // Label 20612: @1562236
      GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1562336), // Rule ID 4134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4134,
        GIR_EraseRootFromParent_Done,
      // Label 20613: @1562336
      GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1562436), // Rule ID 4135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4135,
        GIR_EraseRootFromParent_Done,
      // Label 20614: @1562436
      GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1562536), // Rule ID 4144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4144,
        GIR_EraseRootFromParent_Done,
      // Label 20615: @1562536
      GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1562636), // Rule ID 4145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4145,
        GIR_EraseRootFromParent_Done,
      // Label 20616: @1562636
      GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1562736), // Rule ID 4154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4154,
        GIR_EraseRootFromParent_Done,
      // Label 20617: @1562736
      GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1562836), // Rule ID 4155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4155,
        GIR_EraseRootFromParent_Done,
      // Label 20618: @1562836
      GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1562936), // Rule ID 4164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4164,
        GIR_EraseRootFromParent_Done,
      // Label 20619: @1562936
      GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1563036), // Rule ID 4165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4165,
        GIR_EraseRootFromParent_Done,
      // Label 20620: @1563036
      GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1563136), // Rule ID 4174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4174,
        GIR_EraseRootFromParent_Done,
      // Label 20621: @1563136
      GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1563236), // Rule ID 4175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4175,
        GIR_EraseRootFromParent_Done,
      // Label 20622: @1563236
      GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1563336), // Rule ID 4184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4184,
        GIR_EraseRootFromParent_Done,
      // Label 20623: @1563336
      GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1563436), // Rule ID 4185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4185,
        GIR_EraseRootFromParent_Done,
      // Label 20624: @1563436
      GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1563536), // Rule ID 4194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4194,
        GIR_EraseRootFromParent_Done,
      // Label 20625: @1563536
      GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1563636), // Rule ID 4195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4195,
        GIR_EraseRootFromParent_Done,
      // Label 20626: @1563636
      GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1563736), // Rule ID 4204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4204,
        GIR_EraseRootFromParent_Done,
      // Label 20627: @1563736
      GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1563836), // Rule ID 4205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4205,
        GIR_EraseRootFromParent_Done,
      // Label 20628: @1563836
      GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1563936), // Rule ID 4214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4214,
        GIR_EraseRootFromParent_Done,
      // Label 20629: @1563936
      GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1564036), // Rule ID 4215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4215,
        GIR_EraseRootFromParent_Done,
      // Label 20630: @1564036
      GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1564136), // Rule ID 4224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4224,
        GIR_EraseRootFromParent_Done,
      // Label 20631: @1564136
      GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1564236), // Rule ID 4225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4225,
        GIR_EraseRootFromParent_Done,
      // Label 20632: @1564236
      GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1564336), // Rule ID 4234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4234,
        GIR_EraseRootFromParent_Done,
      // Label 20633: @1564336
      GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1564436), // Rule ID 4235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4235,
        GIR_EraseRootFromParent_Done,
      // Label 20634: @1564436
      GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1564536), // Rule ID 4244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4244,
        GIR_EraseRootFromParent_Done,
      // Label 20635: @1564536
      GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1564636), // Rule ID 4245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4245,
        GIR_EraseRootFromParent_Done,
      // Label 20636: @1564636
      GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1564736), // Rule ID 4254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4254,
        GIR_EraseRootFromParent_Done,
      // Label 20637: @1564736
      GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1564836), // Rule ID 4255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4255,
        GIR_EraseRootFromParent_Done,
      // Label 20638: @1564836
      GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1564936), // Rule ID 4264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4264,
        GIR_EraseRootFromParent_Done,
      // Label 20639: @1564936
      GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1565036), // Rule ID 4265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4265,
        GIR_EraseRootFromParent_Done,
      // Label 20640: @1565036
      GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1565136), // Rule ID 4334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4334,
        GIR_EraseRootFromParent_Done,
      // Label 20641: @1565136
      GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1565236), // Rule ID 4335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4335,
        GIR_EraseRootFromParent_Done,
      // Label 20642: @1565236
      GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1565336), // Rule ID 4344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4344,
        GIR_EraseRootFromParent_Done,
      // Label 20643: @1565336
      GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1565436), // Rule ID 4345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4345,
        GIR_EraseRootFromParent_Done,
      // Label 20644: @1565436
      GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1565536), // Rule ID 4354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4354,
        GIR_EraseRootFromParent_Done,
      // Label 20645: @1565536
      GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1565636), // Rule ID 4355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4355,
        GIR_EraseRootFromParent_Done,
      // Label 20646: @1565636
      GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1565736), // Rule ID 4364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4364,
        GIR_EraseRootFromParent_Done,
      // Label 20647: @1565736
      GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1565836), // Rule ID 4365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4365,
        GIR_EraseRootFromParent_Done,
      // Label 20648: @1565836
      GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1565936), // Rule ID 4374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4374,
        GIR_EraseRootFromParent_Done,
      // Label 20649: @1565936
      GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1566036), // Rule ID 4375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4375,
        GIR_EraseRootFromParent_Done,
      // Label 20650: @1566036
      GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1566136), // Rule ID 4384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4384,
        GIR_EraseRootFromParent_Done,
      // Label 20651: @1566136
      GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1566236), // Rule ID 4385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4385,
        GIR_EraseRootFromParent_Done,
      // Label 20652: @1566236
      GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1566336), // Rule ID 4394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4394,
        GIR_EraseRootFromParent_Done,
      // Label 20653: @1566336
      GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1566436), // Rule ID 4395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4395,
        GIR_EraseRootFromParent_Done,
      // Label 20654: @1566436
      GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1566536), // Rule ID 4404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4404,
        GIR_EraseRootFromParent_Done,
      // Label 20655: @1566536
      GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1566636), // Rule ID 4405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4405,
        GIR_EraseRootFromParent_Done,
      // Label 20656: @1566636
      GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1566736), // Rule ID 4414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4414,
        GIR_EraseRootFromParent_Done,
      // Label 20657: @1566736
      GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1566836), // Rule ID 4415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4415,
        GIR_EraseRootFromParent_Done,
      // Label 20658: @1566836
      GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1566936), // Rule ID 4424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4424,
        GIR_EraseRootFromParent_Done,
      // Label 20659: @1566936
      GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1567036), // Rule ID 4425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4425,
        GIR_EraseRootFromParent_Done,
      // Label 20660: @1567036
      GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1567136), // Rule ID 4434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4434,
        GIR_EraseRootFromParent_Done,
      // Label 20661: @1567136
      GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1567236), // Rule ID 4435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4435,
        GIR_EraseRootFromParent_Done,
      // Label 20662: @1567236
      GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1567336), // Rule ID 4444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4444,
        GIR_EraseRootFromParent_Done,
      // Label 20663: @1567336
      GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1567436), // Rule ID 4445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4445,
        GIR_EraseRootFromParent_Done,
      // Label 20664: @1567436
      GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1567536), // Rule ID 4454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4454,
        GIR_EraseRootFromParent_Done,
      // Label 20665: @1567536
      GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1567636), // Rule ID 4455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4455,
        GIR_EraseRootFromParent_Done,
      // Label 20666: @1567636
      GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1567736), // Rule ID 4464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4464,
        GIR_EraseRootFromParent_Done,
      // Label 20667: @1567736
      GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1567836), // Rule ID 4465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4465,
        GIR_EraseRootFromParent_Done,
      // Label 20668: @1567836
      GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1567936), // Rule ID 4474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4474,
        GIR_EraseRootFromParent_Done,
      // Label 20669: @1567936
      GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1568036), // Rule ID 4475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4475,
        GIR_EraseRootFromParent_Done,
      // Label 20670: @1568036
      GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1568136), // Rule ID 4544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4544,
        GIR_EraseRootFromParent_Done,
      // Label 20671: @1568136
      GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1568236), // Rule ID 4545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4545,
        GIR_EraseRootFromParent_Done,
      // Label 20672: @1568236
      GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1568336), // Rule ID 4554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4554,
        GIR_EraseRootFromParent_Done,
      // Label 20673: @1568336
      GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1568436), // Rule ID 4555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4555,
        GIR_EraseRootFromParent_Done,
      // Label 20674: @1568436
      GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1568536), // Rule ID 4564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4564,
        GIR_EraseRootFromParent_Done,
      // Label 20675: @1568536
      GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1568636), // Rule ID 4565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4565,
        GIR_EraseRootFromParent_Done,
      // Label 20676: @1568636
      GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1568736), // Rule ID 4574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4574,
        GIR_EraseRootFromParent_Done,
      // Label 20677: @1568736
      GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1568836), // Rule ID 4575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4575,
        GIR_EraseRootFromParent_Done,
      // Label 20678: @1568836
      GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1568936), // Rule ID 4584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4584,
        GIR_EraseRootFromParent_Done,
      // Label 20679: @1568936
      GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1569036), // Rule ID 4585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4585,
        GIR_EraseRootFromParent_Done,
      // Label 20680: @1569036
      GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1569136), // Rule ID 4594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4594,
        GIR_EraseRootFromParent_Done,
      // Label 20681: @1569136
      GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1569236), // Rule ID 4595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4595,
        GIR_EraseRootFromParent_Done,
      // Label 20682: @1569236
      GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1569336), // Rule ID 4604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4604,
        GIR_EraseRootFromParent_Done,
      // Label 20683: @1569336
      GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1569436), // Rule ID 4605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4605,
        GIR_EraseRootFromParent_Done,
      // Label 20684: @1569436
      GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1569536), // Rule ID 4614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4614,
        GIR_EraseRootFromParent_Done,
      // Label 20685: @1569536
      GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1569636), // Rule ID 4615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4615,
        GIR_EraseRootFromParent_Done,
      // Label 20686: @1569636
      GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1569736), // Rule ID 4624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4624,
        GIR_EraseRootFromParent_Done,
      // Label 20687: @1569736
      GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1569836), // Rule ID 4625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4625,
        GIR_EraseRootFromParent_Done,
      // Label 20688: @1569836
      GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1569936), // Rule ID 4634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4634,
        GIR_EraseRootFromParent_Done,
      // Label 20689: @1569936
      GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1570036), // Rule ID 4635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4635,
        GIR_EraseRootFromParent_Done,
      // Label 20690: @1570036
      GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1570136), // Rule ID 4644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4644,
        GIR_EraseRootFromParent_Done,
      // Label 20691: @1570136
      GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1570236), // Rule ID 4645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4645,
        GIR_EraseRootFromParent_Done,
      // Label 20692: @1570236
      GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1570336), // Rule ID 4654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4654,
        GIR_EraseRootFromParent_Done,
      // Label 20693: @1570336
      GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1570436), // Rule ID 4655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4655,
        GIR_EraseRootFromParent_Done,
      // Label 20694: @1570436
      GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1570536), // Rule ID 4664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4664,
        GIR_EraseRootFromParent_Done,
      // Label 20695: @1570536
      GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1570636), // Rule ID 4665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4665,
        GIR_EraseRootFromParent_Done,
      // Label 20696: @1570636
      GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1570736), // Rule ID 4674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4674,
        GIR_EraseRootFromParent_Done,
      // Label 20697: @1570736
      GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1570836), // Rule ID 4675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4675,
        GIR_EraseRootFromParent_Done,
      // Label 20698: @1570836
      GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1570936), // Rule ID 4684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4684,
        GIR_EraseRootFromParent_Done,
      // Label 20699: @1570936
      GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1571036), // Rule ID 4685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4685,
        GIR_EraseRootFromParent_Done,
      // Label 20700: @1571036
      GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1571140), // Rule ID 2580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2580,
        GIR_EraseRootFromParent_Done,
      // Label 20701: @1571140
      GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1571244), // Rule ID 2581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2581,
        GIR_EraseRootFromParent_Done,
      // Label 20702: @1571244
      GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1571348), // Rule ID 2618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2618,
        GIR_EraseRootFromParent_Done,
      // Label 20703: @1571348
      GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1571452), // Rule ID 2619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2619,
        GIR_EraseRootFromParent_Done,
      // Label 20704: @1571452
      GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1571556), // Rule ID 2632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2632,
        GIR_EraseRootFromParent_Done,
      // Label 20705: @1571556
      GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1571660), // Rule ID 2633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2633,
        GIR_EraseRootFromParent_Done,
      // Label 20706: @1571660
      GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1571764), // Rule ID 2652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2652,
        GIR_EraseRootFromParent_Done,
      // Label 20707: @1571764
      GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1571868), // Rule ID 2653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2653,
        GIR_EraseRootFromParent_Done,
      // Label 20708: @1571868
      GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1571972), // Rule ID 2660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2660,
        GIR_EraseRootFromParent_Done,
      // Label 20709: @1571972
      GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1572076), // Rule ID 2661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2661,
        GIR_EraseRootFromParent_Done,
      // Label 20710: @1572076
      GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1572180), // Rule ID 2668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2668,
        GIR_EraseRootFromParent_Done,
      // Label 20711: @1572180
      GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1572284), // Rule ID 2669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2669,
        GIR_EraseRootFromParent_Done,
      // Label 20712: @1572284
      GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1572388), // Rule ID 2676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2676,
        GIR_EraseRootFromParent_Done,
      // Label 20713: @1572388
      GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1572492), // Rule ID 2677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2677,
        GIR_EraseRootFromParent_Done,
      // Label 20714: @1572492
      GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1572596), // Rule ID 2684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2684,
        GIR_EraseRootFromParent_Done,
      // Label 20715: @1572596
      GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1572700), // Rule ID 2685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2685,
        GIR_EraseRootFromParent_Done,
      // Label 20716: @1572700
      GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1572804), // Rule ID 2692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2692,
        GIR_EraseRootFromParent_Done,
      // Label 20717: @1572804
      GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1572908), // Rule ID 2693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2693,
        GIR_EraseRootFromParent_Done,
      // Label 20718: @1572908
      GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1573012), // Rule ID 2700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2700,
        GIR_EraseRootFromParent_Done,
      // Label 20719: @1573012
      GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1573116), // Rule ID 2701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2701,
        GIR_EraseRootFromParent_Done,
      // Label 20720: @1573116
      GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1573220), // Rule ID 2708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2708,
        GIR_EraseRootFromParent_Done,
      // Label 20721: @1573220
      GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1573324), // Rule ID 2709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2709,
        GIR_EraseRootFromParent_Done,
      // Label 20722: @1573324
      GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1573428), // Rule ID 2716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2716,
        GIR_EraseRootFromParent_Done,
      // Label 20723: @1573428
      GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1573532), // Rule ID 2717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2717,
        GIR_EraseRootFromParent_Done,
      // Label 20724: @1573532
      GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1573636), // Rule ID 2724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2724,
        GIR_EraseRootFromParent_Done,
      // Label 20725: @1573636
      GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1573740), // Rule ID 2725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2725,
        GIR_EraseRootFromParent_Done,
      // Label 20726: @1573740
      GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1573844), // Rule ID 2732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2732,
        GIR_EraseRootFromParent_Done,
      // Label 20727: @1573844
      GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1573948), // Rule ID 2733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2733,
        GIR_EraseRootFromParent_Done,
      // Label 20728: @1573948
      GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1574052), // Rule ID 2740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2740,
        GIR_EraseRootFromParent_Done,
      // Label 20729: @1574052
      GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1574156), // Rule ID 2741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2741,
        GIR_EraseRootFromParent_Done,
      // Label 20730: @1574156
      GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1574260), // Rule ID 2748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2748,
        GIR_EraseRootFromParent_Done,
      // Label 20731: @1574260
      GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1574364), // Rule ID 2749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2749,
        GIR_EraseRootFromParent_Done,
      // Label 20732: @1574364
      GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1574468), // Rule ID 2756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2756,
        GIR_EraseRootFromParent_Done,
      // Label 20733: @1574468
      GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1574572), // Rule ID 2757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2757,
        GIR_EraseRootFromParent_Done,
      // Label 20734: @1574572
      GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1574676), // Rule ID 2764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2764,
        GIR_EraseRootFromParent_Done,
      // Label 20735: @1574676
      GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1574780), // Rule ID 2765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2765,
        GIR_EraseRootFromParent_Done,
      // Label 20736: @1574780
      GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1574884), // Rule ID 2772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2772,
        GIR_EraseRootFromParent_Done,
      // Label 20737: @1574884
      GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1574988), // Rule ID 2773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2773,
        GIR_EraseRootFromParent_Done,
      // Label 20738: @1574988
      GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1575092), // Rule ID 2780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2780,
        GIR_EraseRootFromParent_Done,
      // Label 20739: @1575092
      GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1575196), // Rule ID 2781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2781,
        GIR_EraseRootFromParent_Done,
      // Label 20740: @1575196
      GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1575300), // Rule ID 2788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2788,
        GIR_EraseRootFromParent_Done,
      // Label 20741: @1575300
      GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1575404), // Rule ID 2789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2789,
        GIR_EraseRootFromParent_Done,
      // Label 20742: @1575404
      GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1575508), // Rule ID 2796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2796,
        GIR_EraseRootFromParent_Done,
      // Label 20743: @1575508
      GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1575612), // Rule ID 2797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2797,
        GIR_EraseRootFromParent_Done,
      // Label 20744: @1575612
      GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1575716), // Rule ID 2804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2804,
        GIR_EraseRootFromParent_Done,
      // Label 20745: @1575716
      GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1575820), // Rule ID 2805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2805,
        GIR_EraseRootFromParent_Done,
      // Label 20746: @1575820
      GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1575924), // Rule ID 2812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2812,
        GIR_EraseRootFromParent_Done,
      // Label 20747: @1575924
      GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1576028), // Rule ID 2813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2813,
        GIR_EraseRootFromParent_Done,
      // Label 20748: @1576028
      GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1576132), // Rule ID 2820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2820,
        GIR_EraseRootFromParent_Done,
      // Label 20749: @1576132
      GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1576236), // Rule ID 2821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2821,
        GIR_EraseRootFromParent_Done,
      // Label 20750: @1576236
      GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1576340), // Rule ID 2828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2828,
        GIR_EraseRootFromParent_Done,
      // Label 20751: @1576340
      GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1576444), // Rule ID 2829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2829,
        GIR_EraseRootFromParent_Done,
      // Label 20752: @1576444
      GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1576548), // Rule ID 2832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2832,
        GIR_EraseRootFromParent_Done,
      // Label 20753: @1576548
      GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1576652), // Rule ID 2833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2833,
        GIR_EraseRootFromParent_Done,
      // Label 20754: @1576652
      GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1576756), // Rule ID 2836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2836,
        GIR_EraseRootFromParent_Done,
      // Label 20755: @1576756
      GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1576860), // Rule ID 2837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2837,
        GIR_EraseRootFromParent_Done,
      // Label 20756: @1576860
      GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1576964), // Rule ID 2840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2840,
        GIR_EraseRootFromParent_Done,
      // Label 20757: @1576964
      GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1577068), // Rule ID 2841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2841,
        GIR_EraseRootFromParent_Done,
      // Label 20758: @1577068
      GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1577172), // Rule ID 2844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2844,
        GIR_EraseRootFromParent_Done,
      // Label 20759: @1577172
      GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1577276), // Rule ID 2845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2845,
        GIR_EraseRootFromParent_Done,
      // Label 20760: @1577276
      GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1577380), // Rule ID 2848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2848,
        GIR_EraseRootFromParent_Done,
      // Label 20761: @1577380
      GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1577484), // Rule ID 2849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2849,
        GIR_EraseRootFromParent_Done,
      // Label 20762: @1577484
      GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1577588), // Rule ID 2852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2852,
        GIR_EraseRootFromParent_Done,
      // Label 20763: @1577588
      GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1577692), // Rule ID 2853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2853,
        GIR_EraseRootFromParent_Done,
      // Label 20764: @1577692
      GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1577796), // Rule ID 2856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2856,
        GIR_EraseRootFromParent_Done,
      // Label 20765: @1577796
      GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1577900), // Rule ID 2857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2857,
        GIR_EraseRootFromParent_Done,
      // Label 20766: @1577900
      GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1578004), // Rule ID 2860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2860,
        GIR_EraseRootFromParent_Done,
      // Label 20767: @1578004
      GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1578108), // Rule ID 2861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2861,
        GIR_EraseRootFromParent_Done,
      // Label 20768: @1578108
      GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1578212), // Rule ID 2864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2864,
        GIR_EraseRootFromParent_Done,
      // Label 20769: @1578212
      GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1578316), // Rule ID 2865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2865,
        GIR_EraseRootFromParent_Done,
      // Label 20770: @1578316
      GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1578420), // Rule ID 2868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2868,
        GIR_EraseRootFromParent_Done,
      // Label 20771: @1578420
      GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1578524), // Rule ID 2869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2869,
        GIR_EraseRootFromParent_Done,
      // Label 20772: @1578524
      GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1578628), // Rule ID 2872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2872,
        GIR_EraseRootFromParent_Done,
      // Label 20773: @1578628
      GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1578732), // Rule ID 2873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2873,
        GIR_EraseRootFromParent_Done,
      // Label 20774: @1578732
      GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1578836), // Rule ID 2876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2876,
        GIR_EraseRootFromParent_Done,
      // Label 20775: @1578836
      GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1578940), // Rule ID 2877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2877,
        GIR_EraseRootFromParent_Done,
      // Label 20776: @1578940
      GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1579044), // Rule ID 2880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2880,
        GIR_EraseRootFromParent_Done,
      // Label 20777: @1579044
      GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1579148), // Rule ID 2881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2881,
        GIR_EraseRootFromParent_Done,
      // Label 20778: @1579148
      GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1579252), // Rule ID 2884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2884,
        GIR_EraseRootFromParent_Done,
      // Label 20779: @1579252
      GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1579356), // Rule ID 2885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2885,
        GIR_EraseRootFromParent_Done,
      // Label 20780: @1579356
      GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1579460), // Rule ID 2888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2888,
        GIR_EraseRootFromParent_Done,
      // Label 20781: @1579460
      GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1579564), // Rule ID 2889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2889,
        GIR_EraseRootFromParent_Done,
      // Label 20782: @1579564
      GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1579668), // Rule ID 2892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2892,
        GIR_EraseRootFromParent_Done,
      // Label 20783: @1579668
      GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1579772), // Rule ID 2893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2893,
        GIR_EraseRootFromParent_Done,
      // Label 20784: @1579772
      GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1579876), // Rule ID 2896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2896,
        GIR_EraseRootFromParent_Done,
      // Label 20785: @1579876
      GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1579980), // Rule ID 2897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2897,
        GIR_EraseRootFromParent_Done,
      // Label 20786: @1579980
      GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1580084), // Rule ID 2900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2900,
        GIR_EraseRootFromParent_Done,
      // Label 20787: @1580084
      GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1580188), // Rule ID 2901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2901,
        GIR_EraseRootFromParent_Done,
      // Label 20788: @1580188
      GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1580292), // Rule ID 2904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2904,
        GIR_EraseRootFromParent_Done,
      // Label 20789: @1580292
      GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1580396), // Rule ID 2905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2905,
        GIR_EraseRootFromParent_Done,
      // Label 20790: @1580396
      GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1580500), // Rule ID 2908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2908,
        GIR_EraseRootFromParent_Done,
      // Label 20791: @1580500
      GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1580604), // Rule ID 2909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2909,
        GIR_EraseRootFromParent_Done,
      // Label 20792: @1580604
      GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1580708), // Rule ID 2912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2912,
        GIR_EraseRootFromParent_Done,
      // Label 20793: @1580708
      GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1580812), // Rule ID 2913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2913,
        GIR_EraseRootFromParent_Done,
      // Label 20794: @1580812
      GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1580916), // Rule ID 2916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2916,
        GIR_EraseRootFromParent_Done,
      // Label 20795: @1580916
      GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1581020), // Rule ID 2917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2917,
        GIR_EraseRootFromParent_Done,
      // Label 20796: @1581020
      GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1581124), // Rule ID 2920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2920,
        GIR_EraseRootFromParent_Done,
      // Label 20797: @1581124
      GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1581228), // Rule ID 2921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2921,
        GIR_EraseRootFromParent_Done,
      // Label 20798: @1581228
      GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1581332), // Rule ID 2924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2924,
        GIR_EraseRootFromParent_Done,
      // Label 20799: @1581332
      GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1581436), // Rule ID 2925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2925,
        GIR_EraseRootFromParent_Done,
      // Label 20800: @1581436
      GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1581540), // Rule ID 2928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2928,
        GIR_EraseRootFromParent_Done,
      // Label 20801: @1581540
      GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1581644), // Rule ID 2929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2929,
        GIR_EraseRootFromParent_Done,
      // Label 20802: @1581644
      GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1581748), // Rule ID 2932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2932,
        GIR_EraseRootFromParent_Done,
      // Label 20803: @1581748
      GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1581852), // Rule ID 2933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2933,
        GIR_EraseRootFromParent_Done,
      // Label 20804: @1581852
      GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1581956), // Rule ID 2936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2936,
        GIR_EraseRootFromParent_Done,
      // Label 20805: @1581956
      GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1582060), // Rule ID 2937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10751:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2937,
        GIR_EraseRootFromParent_Done,
      // Label 20806: @1582060
      GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1582164), // Rule ID 2940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2940,
        GIR_EraseRootFromParent_Done,
      // Label 20807: @1582164
      GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1582268), // Rule ID 2941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10751:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2941,
        GIR_EraseRootFromParent_Done,
      // Label 20808: @1582268
      GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1582372), // Rule ID 2944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2944,
        GIR_EraseRootFromParent_Done,
      // Label 20809: @1582372
      GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1582476), // Rule ID 2945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10751:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2945,
        GIR_EraseRootFromParent_Done,
      // Label 20810: @1582476
      GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1582580), // Rule ID 2948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2948,
        GIR_EraseRootFromParent_Done,
      // Label 20811: @1582580
      GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1582684), // Rule ID 2949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10751:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2949,
        GIR_EraseRootFromParent_Done,
      // Label 20812: @1582684
      GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1582788), // Rule ID 2952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2952,
        GIR_EraseRootFromParent_Done,
      // Label 20813: @1582788
      GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1582892), // Rule ID 2953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2953,
        GIR_EraseRootFromParent_Done,
      // Label 20814: @1582892
      GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1582996), // Rule ID 2956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2956,
        GIR_EraseRootFromParent_Done,
      // Label 20815: @1582996
      GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1583100), // Rule ID 2957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2957,
        GIR_EraseRootFromParent_Done,
      // Label 20816: @1583100
      GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1583204), // Rule ID 2960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2960,
        GIR_EraseRootFromParent_Done,
      // Label 20817: @1583204
      GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1583308), // Rule ID 2961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2961,
        GIR_EraseRootFromParent_Done,
      // Label 20818: @1583308
      GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1583412), // Rule ID 2964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2964,
        GIR_EraseRootFromParent_Done,
      // Label 20819: @1583412
      GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1583516), // Rule ID 2965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2965,
        GIR_EraseRootFromParent_Done,
      // Label 20820: @1583516
      GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1583620), // Rule ID 2968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2968,
        GIR_EraseRootFromParent_Done,
      // Label 20821: @1583620
      GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1583724), // Rule ID 2969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2969,
        GIR_EraseRootFromParent_Done,
      // Label 20822: @1583724
      GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1583828), // Rule ID 2972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2972,
        GIR_EraseRootFromParent_Done,
      // Label 20823: @1583828
      GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1583932), // Rule ID 2973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2973,
        GIR_EraseRootFromParent_Done,
      // Label 20824: @1583932
      GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1584036), // Rule ID 2976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2976,
        GIR_EraseRootFromParent_Done,
      // Label 20825: @1584036
      GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1584140), // Rule ID 2977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2977,
        GIR_EraseRootFromParent_Done,
      // Label 20826: @1584140
      GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1584244), // Rule ID 2980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2980,
        GIR_EraseRootFromParent_Done,
      // Label 20827: @1584244
      GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1584348), // Rule ID 2981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2981,
        GIR_EraseRootFromParent_Done,
      // Label 20828: @1584348
      GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1584452), // Rule ID 2984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2984,
        GIR_EraseRootFromParent_Done,
      // Label 20829: @1584452
      GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1584556), // Rule ID 2985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2985,
        GIR_EraseRootFromParent_Done,
      // Label 20830: @1584556
      GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1584660), // Rule ID 2988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2988,
        GIR_EraseRootFromParent_Done,
      // Label 20831: @1584660
      GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1584764), // Rule ID 2989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10751:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2989,
        GIR_EraseRootFromParent_Done,
      // Label 20832: @1584764
      GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1584868), // Rule ID 2992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2992,
        GIR_EraseRootFromParent_Done,
      // Label 20833: @1584868
      GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1584972), // Rule ID 2993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10751:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2993,
        GIR_EraseRootFromParent_Done,
      // Label 20834: @1584972
      GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1585076), // Rule ID 2996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2996,
        GIR_EraseRootFromParent_Done,
      // Label 20835: @1585076
      GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1585180), // Rule ID 2997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10751:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2997,
        GIR_EraseRootFromParent_Done,
      // Label 20836: @1585180
      GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1585284), // Rule ID 3088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3088,
        GIR_EraseRootFromParent_Done,
      // Label 20837: @1585284
      GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1585388), // Rule ID 3089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3089,
        GIR_EraseRootFromParent_Done,
      // Label 20838: @1585388
      GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1585492), // Rule ID 3092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3092,
        GIR_EraseRootFromParent_Done,
      // Label 20839: @1585492
      GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1585596), // Rule ID 3093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3093,
        GIR_EraseRootFromParent_Done,
      // Label 20840: @1585596
      GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1585700), // Rule ID 3096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3096,
        GIR_EraseRootFromParent_Done,
      // Label 20841: @1585700
      GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1585804), // Rule ID 3097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3097,
        GIR_EraseRootFromParent_Done,
      // Label 20842: @1585804
      GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1585908), // Rule ID 3100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3100,
        GIR_EraseRootFromParent_Done,
      // Label 20843: @1585908
      GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1586012), // Rule ID 3101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3101,
        GIR_EraseRootFromParent_Done,
      // Label 20844: @1586012
      GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1586116), // Rule ID 3104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3104,
        GIR_EraseRootFromParent_Done,
      // Label 20845: @1586116
      GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1586220), // Rule ID 3105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3105,
        GIR_EraseRootFromParent_Done,
      // Label 20846: @1586220
      GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1586324), // Rule ID 3108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3108,
        GIR_EraseRootFromParent_Done,
      // Label 20847: @1586324
      GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1586428), // Rule ID 3109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3109,
        GIR_EraseRootFromParent_Done,
      // Label 20848: @1586428
      GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1586532), // Rule ID 3112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3112,
        GIR_EraseRootFromParent_Done,
      // Label 20849: @1586532
      GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1586636), // Rule ID 3113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3113,
        GIR_EraseRootFromParent_Done,
      // Label 20850: @1586636
      GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1586740), // Rule ID 3116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3116,
        GIR_EraseRootFromParent_Done,
      // Label 20851: @1586740
      GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1586844), // Rule ID 3117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3117,
        GIR_EraseRootFromParent_Done,
      // Label 20852: @1586844
      GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1586948), // Rule ID 3120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3120,
        GIR_EraseRootFromParent_Done,
      // Label 20853: @1586948
      GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1587052), // Rule ID 3121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3121,
        GIR_EraseRootFromParent_Done,
      // Label 20854: @1587052
      GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1587156), // Rule ID 3124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3124,
        GIR_EraseRootFromParent_Done,
      // Label 20855: @1587156
      GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1587260), // Rule ID 3125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3125,
        GIR_EraseRootFromParent_Done,
      // Label 20856: @1587260
      GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1587364), // Rule ID 3128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3128,
        GIR_EraseRootFromParent_Done,
      // Label 20857: @1587364
      GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1587468), // Rule ID 3129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3129,
        GIR_EraseRootFromParent_Done,
      // Label 20858: @1587468
      GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1587572), // Rule ID 3132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3132,
        GIR_EraseRootFromParent_Done,
      // Label 20859: @1587572
      GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1587676), // Rule ID 3133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3133,
        GIR_EraseRootFromParent_Done,
      // Label 20860: @1587676
      GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1587780), // Rule ID 3136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3136,
        GIR_EraseRootFromParent_Done,
      // Label 20861: @1587780
      GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1587884), // Rule ID 3137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3137,
        GIR_EraseRootFromParent_Done,
      // Label 20862: @1587884
      GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1587988), // Rule ID 3140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3140,
        GIR_EraseRootFromParent_Done,
      // Label 20863: @1587988
      GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1588092), // Rule ID 3141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3141,
        GIR_EraseRootFromParent_Done,
      // Label 20864: @1588092
      GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1588196), // Rule ID 3144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3144,
        GIR_EraseRootFromParent_Done,
      // Label 20865: @1588196
      GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1588300), // Rule ID 3145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3145,
        GIR_EraseRootFromParent_Done,
      // Label 20866: @1588300
      GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1588404), // Rule ID 3148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3148,
        GIR_EraseRootFromParent_Done,
      // Label 20867: @1588404
      GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1588508), // Rule ID 3149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3149,
        GIR_EraseRootFromParent_Done,
      // Label 20868: @1588508
      GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1588612), // Rule ID 3152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3152,
        GIR_EraseRootFromParent_Done,
      // Label 20869: @1588612
      GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1588716), // Rule ID 3153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3153,
        GIR_EraseRootFromParent_Done,
      // Label 20870: @1588716
      GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1588820), // Rule ID 3156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3156,
        GIR_EraseRootFromParent_Done,
      // Label 20871: @1588820
      GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1588924), // Rule ID 3157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3157,
        GIR_EraseRootFromParent_Done,
      // Label 20872: @1588924
      GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1589028), // Rule ID 3160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3160,
        GIR_EraseRootFromParent_Done,
      // Label 20873: @1589028
      GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1589132), // Rule ID 3161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3161,
        GIR_EraseRootFromParent_Done,
      // Label 20874: @1589132
      GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1589236), // Rule ID 3164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3164,
        GIR_EraseRootFromParent_Done,
      // Label 20875: @1589236
      GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1589340), // Rule ID 3165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3165,
        GIR_EraseRootFromParent_Done,
      // Label 20876: @1589340
      GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1589444), // Rule ID 3168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3168,
        GIR_EraseRootFromParent_Done,
      // Label 20877: @1589444
      GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1589548), // Rule ID 3169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3169,
        GIR_EraseRootFromParent_Done,
      // Label 20878: @1589548
      GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1589652), // Rule ID 3172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3172,
        GIR_EraseRootFromParent_Done,
      // Label 20879: @1589652
      GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1589756), // Rule ID 3173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3173,
        GIR_EraseRootFromParent_Done,
      // Label 20880: @1589756
      GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1589860), // Rule ID 3176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3176,
        GIR_EraseRootFromParent_Done,
      // Label 20881: @1589860
      GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1589964), // Rule ID 3177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3177,
        GIR_EraseRootFromParent_Done,
      // Label 20882: @1589964
      GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1590068), // Rule ID 3180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3180,
        GIR_EraseRootFromParent_Done,
      // Label 20883: @1590068
      GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1590172), // Rule ID 3181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3181,
        GIR_EraseRootFromParent_Done,
      // Label 20884: @1590172
      GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1590276), // Rule ID 3184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3184,
        GIR_EraseRootFromParent_Done,
      // Label 20885: @1590276
      GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1590380), // Rule ID 3185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3185,
        GIR_EraseRootFromParent_Done,
      // Label 20886: @1590380
      GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1590484), // Rule ID 3188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3188,
        GIR_EraseRootFromParent_Done,
      // Label 20887: @1590484
      GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1590588), // Rule ID 3189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3189,
        GIR_EraseRootFromParent_Done,
      // Label 20888: @1590588
      GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1590692), // Rule ID 3192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3192,
        GIR_EraseRootFromParent_Done,
      // Label 20889: @1590692
      GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1590796), // Rule ID 3193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3193,
        GIR_EraseRootFromParent_Done,
      // Label 20890: @1590796
      GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1590900), // Rule ID 3196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3196,
        GIR_EraseRootFromParent_Done,
      // Label 20891: @1590900
      GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1591004), // Rule ID 3197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3197,
        GIR_EraseRootFromParent_Done,
      // Label 20892: @1591004
      GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1591108), // Rule ID 3200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3200,
        GIR_EraseRootFromParent_Done,
      // Label 20893: @1591108
      GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1591212), // Rule ID 3201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3201,
        GIR_EraseRootFromParent_Done,
      // Label 20894: @1591212
      GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1591316), // Rule ID 3204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3204,
        GIR_EraseRootFromParent_Done,
      // Label 20895: @1591316
      GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1591420), // Rule ID 3205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3205,
        GIR_EraseRootFromParent_Done,
      // Label 20896: @1591420
      GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1591524), // Rule ID 3208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3208,
        GIR_EraseRootFromParent_Done,
      // Label 20897: @1591524
      GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1591628), // Rule ID 3209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3209,
        GIR_EraseRootFromParent_Done,
      // Label 20898: @1591628
      GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1591732), // Rule ID 3212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3212,
        GIR_EraseRootFromParent_Done,
      // Label 20899: @1591732
      GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1591836), // Rule ID 3213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3213,
        GIR_EraseRootFromParent_Done,
      // Label 20900: @1591836
      GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1591940), // Rule ID 3216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3216,
        GIR_EraseRootFromParent_Done,
      // Label 20901: @1591940
      GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1592044), // Rule ID 3217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3217,
        GIR_EraseRootFromParent_Done,
      // Label 20902: @1592044
      GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1592148), // Rule ID 3220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3220,
        GIR_EraseRootFromParent_Done,
      // Label 20903: @1592148
      GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1592252), // Rule ID 3221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3221,
        GIR_EraseRootFromParent_Done,
      // Label 20904: @1592252
      GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1592356), // Rule ID 3224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3224,
        GIR_EraseRootFromParent_Done,
      // Label 20905: @1592356
      GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1592460), // Rule ID 3225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3225,
        GIR_EraseRootFromParent_Done,
      // Label 20906: @1592460
      GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1592564), // Rule ID 3228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3228,
        GIR_EraseRootFromParent_Done,
      // Label 20907: @1592564
      GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1592668), // Rule ID 3229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3229,
        GIR_EraseRootFromParent_Done,
      // Label 20908: @1592668
      GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1592772), // Rule ID 3232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3232,
        GIR_EraseRootFromParent_Done,
      // Label 20909: @1592772
      GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1592876), // Rule ID 3233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3233,
        GIR_EraseRootFromParent_Done,
      // Label 20910: @1592876
      GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1592980), // Rule ID 3236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3236,
        GIR_EraseRootFromParent_Done,
      // Label 20911: @1592980
      GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1593084), // Rule ID 3237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3237,
        GIR_EraseRootFromParent_Done,
      // Label 20912: @1593084
      GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1593188), // Rule ID 3240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3240,
        GIR_EraseRootFromParent_Done,
      // Label 20913: @1593188
      GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1593292), // Rule ID 3241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3241,
        GIR_EraseRootFromParent_Done,
      // Label 20914: @1593292
      GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1593396), // Rule ID 3244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3244,
        GIR_EraseRootFromParent_Done,
      // Label 20915: @1593396
      GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1593500), // Rule ID 3245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3245,
        GIR_EraseRootFromParent_Done,
      // Label 20916: @1593500
      GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1593604), // Rule ID 3248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3248,
        GIR_EraseRootFromParent_Done,
      // Label 20917: @1593604
      GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1593708), // Rule ID 3249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3249,
        GIR_EraseRootFromParent_Done,
      // Label 20918: @1593708
      GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1593812), // Rule ID 3252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3252,
        GIR_EraseRootFromParent_Done,
      // Label 20919: @1593812
      GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1593916), // Rule ID 3253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3253,
        GIR_EraseRootFromParent_Done,
      // Label 20920: @1593916
      GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1594020), // Rule ID 3256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3256,
        GIR_EraseRootFromParent_Done,
      // Label 20921: @1594020
      GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1594124), // Rule ID 3257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3257,
        GIR_EraseRootFromParent_Done,
      // Label 20922: @1594124
      GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1594228), // Rule ID 3260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3260,
        GIR_EraseRootFromParent_Done,
      // Label 20923: @1594228
      GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1594332), // Rule ID 3261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3261,
        GIR_EraseRootFromParent_Done,
      // Label 20924: @1594332
      GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1594436), // Rule ID 3264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3264,
        GIR_EraseRootFromParent_Done,
      // Label 20925: @1594436
      GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1594540), // Rule ID 3265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3265,
        GIR_EraseRootFromParent_Done,
      // Label 20926: @1594540
      GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1594644), // Rule ID 3268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3268,
        GIR_EraseRootFromParent_Done,
      // Label 20927: @1594644
      GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1594748), // Rule ID 3269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3269,
        GIR_EraseRootFromParent_Done,
      // Label 20928: @1594748
      GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1594852), // Rule ID 3272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3272,
        GIR_EraseRootFromParent_Done,
      // Label 20929: @1594852
      GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1594956), // Rule ID 3273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3273,
        GIR_EraseRootFromParent_Done,
      // Label 20930: @1594956
      GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1595060), // Rule ID 3276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3276,
        GIR_EraseRootFromParent_Done,
      // Label 20931: @1595060
      GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1595164), // Rule ID 3277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3277,
        GIR_EraseRootFromParent_Done,
      // Label 20932: @1595164
      GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1595268), // Rule ID 3280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3280,
        GIR_EraseRootFromParent_Done,
      // Label 20933: @1595268
      GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1595372), // Rule ID 3281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3281,
        GIR_EraseRootFromParent_Done,
      // Label 20934: @1595372
      GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1595476), // Rule ID 3284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3284,
        GIR_EraseRootFromParent_Done,
      // Label 20935: @1595476
      GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1595580), // Rule ID 3285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3285,
        GIR_EraseRootFromParent_Done,
      // Label 20936: @1595580
      GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1595684), // Rule ID 3288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3288,
        GIR_EraseRootFromParent_Done,
      // Label 20937: @1595684
      GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1595788), // Rule ID 3289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3289,
        GIR_EraseRootFromParent_Done,
      // Label 20938: @1595788
      GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1595892), // Rule ID 3292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3292,
        GIR_EraseRootFromParent_Done,
      // Label 20939: @1595892
      GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1595996), // Rule ID 3293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3293,
        GIR_EraseRootFromParent_Done,
      // Label 20940: @1595996
      GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1596100), // Rule ID 3296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3296,
        GIR_EraseRootFromParent_Done,
      // Label 20941: @1596100
      GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1596204), // Rule ID 3297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3297,
        GIR_EraseRootFromParent_Done,
      // Label 20942: @1596204
      GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1596308), // Rule ID 3300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3300,
        GIR_EraseRootFromParent_Done,
      // Label 20943: @1596308
      GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1596412), // Rule ID 3301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3301,
        GIR_EraseRootFromParent_Done,
      // Label 20944: @1596412
      GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1596516), // Rule ID 3304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3304,
        GIR_EraseRootFromParent_Done,
      // Label 20945: @1596516
      GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1596620), // Rule ID 3305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3305,
        GIR_EraseRootFromParent_Done,
      // Label 20946: @1596620
      GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1596724), // Rule ID 3308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3308,
        GIR_EraseRootFromParent_Done,
      // Label 20947: @1596724
      GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1596828), // Rule ID 3309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3309,
        GIR_EraseRootFromParent_Done,
      // Label 20948: @1596828
      GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1596932), // Rule ID 3312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3312,
        GIR_EraseRootFromParent_Done,
      // Label 20949: @1596932
      GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1597036), // Rule ID 3313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3313,
        GIR_EraseRootFromParent_Done,
      // Label 20950: @1597036
      GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1597140), // Rule ID 3316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3316,
        GIR_EraseRootFromParent_Done,
      // Label 20951: @1597140
      GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1597244), // Rule ID 3317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3317,
        GIR_EraseRootFromParent_Done,
      // Label 20952: @1597244
      GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1597348), // Rule ID 3320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3320,
        GIR_EraseRootFromParent_Done,
      // Label 20953: @1597348
      GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1597452), // Rule ID 3321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3321,
        GIR_EraseRootFromParent_Done,
      // Label 20954: @1597452
      GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1597556), // Rule ID 3324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3324,
        GIR_EraseRootFromParent_Done,
      // Label 20955: @1597556
      GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1597660), // Rule ID 3325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3325,
        GIR_EraseRootFromParent_Done,
      // Label 20956: @1597660
      GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1597764), // Rule ID 3328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3328,
        GIR_EraseRootFromParent_Done,
      // Label 20957: @1597764
      GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1597868), // Rule ID 3329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3329,
        GIR_EraseRootFromParent_Done,
      // Label 20958: @1597868
      GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1597972), // Rule ID 3332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3332,
        GIR_EraseRootFromParent_Done,
      // Label 20959: @1597972
      GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1598076), // Rule ID 3333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3333,
        GIR_EraseRootFromParent_Done,
      // Label 20960: @1598076
      GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1598180), // Rule ID 3336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3336,
        GIR_EraseRootFromParent_Done,
      // Label 20961: @1598180
      GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1598284), // Rule ID 3337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3337,
        GIR_EraseRootFromParent_Done,
      // Label 20962: @1598284
      GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1598388), // Rule ID 3340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3340,
        GIR_EraseRootFromParent_Done,
      // Label 20963: @1598388
      GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1598492), // Rule ID 3341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3341,
        GIR_EraseRootFromParent_Done,
      // Label 20964: @1598492
      GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1598596), // Rule ID 3344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3344,
        GIR_EraseRootFromParent_Done,
      // Label 20965: @1598596
      GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1598700), // Rule ID 3345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3345,
        GIR_EraseRootFromParent_Done,
      // Label 20966: @1598700
      GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1598804), // Rule ID 3348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3348,
        GIR_EraseRootFromParent_Done,
      // Label 20967: @1598804
      GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1598908), // Rule ID 3349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3349,
        GIR_EraseRootFromParent_Done,
      // Label 20968: @1598908
      GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1599012), // Rule ID 3440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3440,
        GIR_EraseRootFromParent_Done,
      // Label 20969: @1599012
      GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1599116), // Rule ID 3441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3441,
        GIR_EraseRootFromParent_Done,
      // Label 20970: @1599116
      GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1599220), // Rule ID 3444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3444,
        GIR_EraseRootFromParent_Done,
      // Label 20971: @1599220
      GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1599324), // Rule ID 3445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3445,
        GIR_EraseRootFromParent_Done,
      // Label 20972: @1599324
      GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1599428), // Rule ID 3448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3448,
        GIR_EraseRootFromParent_Done,
      // Label 20973: @1599428
      GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1599532), // Rule ID 3449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3449,
        GIR_EraseRootFromParent_Done,
      // Label 20974: @1599532
      GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1599636), // Rule ID 3452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3452,
        GIR_EraseRootFromParent_Done,
      // Label 20975: @1599636
      GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1599740), // Rule ID 3453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3453,
        GIR_EraseRootFromParent_Done,
      // Label 20976: @1599740
      GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1599844), // Rule ID 3456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3456,
        GIR_EraseRootFromParent_Done,
      // Label 20977: @1599844
      GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1599948), // Rule ID 3457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3457,
        GIR_EraseRootFromParent_Done,
      // Label 20978: @1599948
      GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1600052), // Rule ID 3460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3460,
        GIR_EraseRootFromParent_Done,
      // Label 20979: @1600052
      GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1600156), // Rule ID 3461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3461,
        GIR_EraseRootFromParent_Done,
      // Label 20980: @1600156
      GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1600260), // Rule ID 3464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3464,
        GIR_EraseRootFromParent_Done,
      // Label 20981: @1600260
      GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1600364), // Rule ID 3465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3465,
        GIR_EraseRootFromParent_Done,
      // Label 20982: @1600364
      GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1600468), // Rule ID 3468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3468,
        GIR_EraseRootFromParent_Done,
      // Label 20983: @1600468
      GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1600572), // Rule ID 3469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3469,
        GIR_EraseRootFromParent_Done,
      // Label 20984: @1600572
      GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1600676), // Rule ID 3472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3472,
        GIR_EraseRootFromParent_Done,
      // Label 20985: @1600676
      GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1600780), // Rule ID 3473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3473,
        GIR_EraseRootFromParent_Done,
      // Label 20986: @1600780
      GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1600884), // Rule ID 3476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3476,
        GIR_EraseRootFromParent_Done,
      // Label 20987: @1600884
      GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1600988), // Rule ID 3477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3477,
        GIR_EraseRootFromParent_Done,
      // Label 20988: @1600988
      GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1601092), // Rule ID 3480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3480,
        GIR_EraseRootFromParent_Done,
      // Label 20989: @1601092
      GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1601196), // Rule ID 3481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3481,
        GIR_EraseRootFromParent_Done,
      // Label 20990: @1601196
      GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1601300), // Rule ID 3484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3484,
        GIR_EraseRootFromParent_Done,
      // Label 20991: @1601300
      GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1601404), // Rule ID 3485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3485,
        GIR_EraseRootFromParent_Done,
      // Label 20992: @1601404
      GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1601508), // Rule ID 3488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3488,
        GIR_EraseRootFromParent_Done,
      // Label 20993: @1601508
      GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1601612), // Rule ID 3489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3489,
        GIR_EraseRootFromParent_Done,
      // Label 20994: @1601612
      GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1601716), // Rule ID 3492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3492,
        GIR_EraseRootFromParent_Done,
      // Label 20995: @1601716
      GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1601820), // Rule ID 3493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3493,
        GIR_EraseRootFromParent_Done,
      // Label 20996: @1601820
      GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1601924), // Rule ID 3496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3496,
        GIR_EraseRootFromParent_Done,
      // Label 20997: @1601924
      GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1602028), // Rule ID 3497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3497,
        GIR_EraseRootFromParent_Done,
      // Label 20998: @1602028
      GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1602132), // Rule ID 3500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3500,
        GIR_EraseRootFromParent_Done,
      // Label 20999: @1602132
      GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1602236), // Rule ID 3501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3501,
        GIR_EraseRootFromParent_Done,
      // Label 21000: @1602236
      GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1602340), // Rule ID 3504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3504,
        GIR_EraseRootFromParent_Done,
      // Label 21001: @1602340
      GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1602444), // Rule ID 3505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3505,
        GIR_EraseRootFromParent_Done,
      // Label 21002: @1602444
      GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1602548), // Rule ID 3508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3508,
        GIR_EraseRootFromParent_Done,
      // Label 21003: @1602548
      GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1602652), // Rule ID 3509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3509,
        GIR_EraseRootFromParent_Done,
      // Label 21004: @1602652
      GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1602756), // Rule ID 3512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3512,
        GIR_EraseRootFromParent_Done,
      // Label 21005: @1602756
      GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1602860), // Rule ID 3513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3513,
        GIR_EraseRootFromParent_Done,
      // Label 21006: @1602860
      GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1602964), // Rule ID 3516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3516,
        GIR_EraseRootFromParent_Done,
      // Label 21007: @1602964
      GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1603068), // Rule ID 3517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3517,
        GIR_EraseRootFromParent_Done,
      // Label 21008: @1603068
      GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1603172), // Rule ID 3520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3520,
        GIR_EraseRootFromParent_Done,
      // Label 21009: @1603172
      GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1603276), // Rule ID 3521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3521,
        GIR_EraseRootFromParent_Done,
      // Label 21010: @1603276
      GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1603380), // Rule ID 3524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3524,
        GIR_EraseRootFromParent_Done,
      // Label 21011: @1603380
      GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1603484), // Rule ID 3525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3525,
        GIR_EraseRootFromParent_Done,
      // Label 21012: @1603484
      GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1603588), // Rule ID 3528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3528,
        GIR_EraseRootFromParent_Done,
      // Label 21013: @1603588
      GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1603692), // Rule ID 3529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3529,
        GIR_EraseRootFromParent_Done,
      // Label 21014: @1603692
      GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1603796), // Rule ID 3532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3532,
        GIR_EraseRootFromParent_Done,
      // Label 21015: @1603796
      GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1603900), // Rule ID 3533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3533,
        GIR_EraseRootFromParent_Done,
      // Label 21016: @1603900
      GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1604004), // Rule ID 3536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3536,
        GIR_EraseRootFromParent_Done,
      // Label 21017: @1604004
      GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1604108), // Rule ID 3537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3537,
        GIR_EraseRootFromParent_Done,
      // Label 21018: @1604108
      GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1604212), // Rule ID 3540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3540,
        GIR_EraseRootFromParent_Done,
      // Label 21019: @1604212
      GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1604316), // Rule ID 3541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3541,
        GIR_EraseRootFromParent_Done,
      // Label 21020: @1604316
      GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1604420), // Rule ID 3544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3544,
        GIR_EraseRootFromParent_Done,
      // Label 21021: @1604420
      GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1604524), // Rule ID 3545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3545,
        GIR_EraseRootFromParent_Done,
      // Label 21022: @1604524
      GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1604628), // Rule ID 3548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3548,
        GIR_EraseRootFromParent_Done,
      // Label 21023: @1604628
      GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1604732), // Rule ID 3549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3549,
        GIR_EraseRootFromParent_Done,
      // Label 21024: @1604732
      GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1604836), // Rule ID 3552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3552,
        GIR_EraseRootFromParent_Done,
      // Label 21025: @1604836
      GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1604940), // Rule ID 3553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3553,
        GIR_EraseRootFromParent_Done,
      // Label 21026: @1604940
      GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1605044), // Rule ID 3556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3556,
        GIR_EraseRootFromParent_Done,
      // Label 21027: @1605044
      GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1605148), // Rule ID 3557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3557,
        GIR_EraseRootFromParent_Done,
      // Label 21028: @1605148
      GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1605252), // Rule ID 3560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3560,
        GIR_EraseRootFromParent_Done,
      // Label 21029: @1605252
      GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1605356), // Rule ID 3561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3561,
        GIR_EraseRootFromParent_Done,
      // Label 21030: @1605356
      GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1605460), // Rule ID 3564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3564,
        GIR_EraseRootFromParent_Done,
      // Label 21031: @1605460
      GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1605564), // Rule ID 3565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3565,
        GIR_EraseRootFromParent_Done,
      // Label 21032: @1605564
      GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1605668), // Rule ID 3568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3568,
        GIR_EraseRootFromParent_Done,
      // Label 21033: @1605668
      GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1605772), // Rule ID 3569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3569,
        GIR_EraseRootFromParent_Done,
      // Label 21034: @1605772
      GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1605876), // Rule ID 3572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3572,
        GIR_EraseRootFromParent_Done,
      // Label 21035: @1605876
      GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1605980), // Rule ID 3573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3573,
        GIR_EraseRootFromParent_Done,
      // Label 21036: @1605980
      GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1606084), // Rule ID 3576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3576,
        GIR_EraseRootFromParent_Done,
      // Label 21037: @1606084
      GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1606188), // Rule ID 3577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3577,
        GIR_EraseRootFromParent_Done,
      // Label 21038: @1606188
      GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1606292), // Rule ID 3580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3580,
        GIR_EraseRootFromParent_Done,
      // Label 21039: @1606292
      GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1606396), // Rule ID 3581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3581,
        GIR_EraseRootFromParent_Done,
      // Label 21040: @1606396
      GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1606500), // Rule ID 3584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3584,
        GIR_EraseRootFromParent_Done,
      // Label 21041: @1606500
      GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1606604), // Rule ID 3585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3585,
        GIR_EraseRootFromParent_Done,
      // Label 21042: @1606604
      GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1606708), // Rule ID 3588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3588,
        GIR_EraseRootFromParent_Done,
      // Label 21043: @1606708
      GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1606812), // Rule ID 3589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3589,
        GIR_EraseRootFromParent_Done,
      // Label 21044: @1606812
      GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1606916), // Rule ID 3592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3592,
        GIR_EraseRootFromParent_Done,
      // Label 21045: @1606916
      GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1607020), // Rule ID 3593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3593,
        GIR_EraseRootFromParent_Done,
      // Label 21046: @1607020
      GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1607124), // Rule ID 3596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3596,
        GIR_EraseRootFromParent_Done,
      // Label 21047: @1607124
      GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1607228), // Rule ID 3597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3597,
        GIR_EraseRootFromParent_Done,
      // Label 21048: @1607228
      GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1607332), // Rule ID 3600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3600,
        GIR_EraseRootFromParent_Done,
      // Label 21049: @1607332
      GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1607436), // Rule ID 3601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3601,
        GIR_EraseRootFromParent_Done,
      // Label 21050: @1607436
      GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1607540), // Rule ID 3604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3604,
        GIR_EraseRootFromParent_Done,
      // Label 21051: @1607540
      GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1607644), // Rule ID 3605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3605,
        GIR_EraseRootFromParent_Done,
      // Label 21052: @1607644
      GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1607748), // Rule ID 3608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3608,
        GIR_EraseRootFromParent_Done,
      // Label 21053: @1607748
      GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1607852), // Rule ID 3609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3609,
        GIR_EraseRootFromParent_Done,
      // Label 21054: @1607852
      GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1607956), // Rule ID 3612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3612,
        GIR_EraseRootFromParent_Done,
      // Label 21055: @1607956
      GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1608060), // Rule ID 3613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3613,
        GIR_EraseRootFromParent_Done,
      // Label 21056: @1608060
      GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1608164), // Rule ID 3616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3616,
        GIR_EraseRootFromParent_Done,
      // Label 21057: @1608164
      GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1608268), // Rule ID 3617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3617,
        GIR_EraseRootFromParent_Done,
      // Label 21058: @1608268
      GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1608372), // Rule ID 3620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3620,
        GIR_EraseRootFromParent_Done,
      // Label 21059: @1608372
      GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1608476), // Rule ID 3621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3621,
        GIR_EraseRootFromParent_Done,
      // Label 21060: @1608476
      GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1608580), // Rule ID 3624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3624,
        GIR_EraseRootFromParent_Done,
      // Label 21061: @1608580
      GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1608684), // Rule ID 3625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3625,
        GIR_EraseRootFromParent_Done,
      // Label 21062: @1608684
      GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1608788), // Rule ID 3628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3628,
        GIR_EraseRootFromParent_Done,
      // Label 21063: @1608788
      GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1608892), // Rule ID 3629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3629,
        GIR_EraseRootFromParent_Done,
      // Label 21064: @1608892
      GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1608996), // Rule ID 3632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3632,
        GIR_EraseRootFromParent_Done,
      // Label 21065: @1608996
      GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1609100), // Rule ID 3633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3633,
        GIR_EraseRootFromParent_Done,
      // Label 21066: @1609100
      GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1609204), // Rule ID 3636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3636,
        GIR_EraseRootFromParent_Done,
      // Label 21067: @1609204
      GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1609308), // Rule ID 3637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3637,
        GIR_EraseRootFromParent_Done,
      // Label 21068: @1609308
      GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1609412), // Rule ID 3640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3640,
        GIR_EraseRootFromParent_Done,
      // Label 21069: @1609412
      GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1609516), // Rule ID 3641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3641,
        GIR_EraseRootFromParent_Done,
      // Label 21070: @1609516
      GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1609620), // Rule ID 3644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3644,
        GIR_EraseRootFromParent_Done,
      // Label 21071: @1609620
      GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1609724), // Rule ID 3645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3645,
        GIR_EraseRootFromParent_Done,
      // Label 21072: @1609724
      GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1609828), // Rule ID 3648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3648,
        GIR_EraseRootFromParent_Done,
      // Label 21073: @1609828
      GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1609932), // Rule ID 3649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3649,
        GIR_EraseRootFromParent_Done,
      // Label 21074: @1609932
      GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1610036), // Rule ID 3652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3652,
        GIR_EraseRootFromParent_Done,
      // Label 21075: @1610036
      GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1610140), // Rule ID 3653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3653,
        GIR_EraseRootFromParent_Done,
      // Label 21076: @1610140
      GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1610244), // Rule ID 3656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3656,
        GIR_EraseRootFromParent_Done,
      // Label 21077: @1610244
      GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1610348), // Rule ID 3657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3657,
        GIR_EraseRootFromParent_Done,
      // Label 21078: @1610348
      GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1610452), // Rule ID 3660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3660,
        GIR_EraseRootFromParent_Done,
      // Label 21079: @1610452
      GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1610556), // Rule ID 3661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3661,
        GIR_EraseRootFromParent_Done,
      // Label 21080: @1610556
      GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1610660), // Rule ID 3664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3664,
        GIR_EraseRootFromParent_Done,
      // Label 21081: @1610660
      GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1610764), // Rule ID 3665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3665,
        GIR_EraseRootFromParent_Done,
      // Label 21082: @1610764
      GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1610868), // Rule ID 3668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3668,
        GIR_EraseRootFromParent_Done,
      // Label 21083: @1610868
      GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1610972), // Rule ID 3669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3669,
        GIR_EraseRootFromParent_Done,
      // Label 21084: @1610972
      GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1611076), // Rule ID 3672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3672,
        GIR_EraseRootFromParent_Done,
      // Label 21085: @1611076
      GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1611180), // Rule ID 3673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3673,
        GIR_EraseRootFromParent_Done,
      // Label 21086: @1611180
      GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1611284), // Rule ID 3676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3676,
        GIR_EraseRootFromParent_Done,
      // Label 21087: @1611284
      GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1611388), // Rule ID 3677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3677,
        GIR_EraseRootFromParent_Done,
      // Label 21088: @1611388
      GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1611492), // Rule ID 3680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3680,
        GIR_EraseRootFromParent_Done,
      // Label 21089: @1611492
      GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1611596), // Rule ID 3681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3681,
        GIR_EraseRootFromParent_Done,
      // Label 21090: @1611596
      GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1611700), // Rule ID 3684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3684,
        GIR_EraseRootFromParent_Done,
      // Label 21091: @1611700
      GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1611804), // Rule ID 3685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3685,
        GIR_EraseRootFromParent_Done,
      // Label 21092: @1611804
      GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1611908), // Rule ID 3688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3688,
        GIR_EraseRootFromParent_Done,
      // Label 21093: @1611908
      GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1612012), // Rule ID 3689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3689,
        GIR_EraseRootFromParent_Done,
      // Label 21094: @1612012
      GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1612116), // Rule ID 3692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3692,
        GIR_EraseRootFromParent_Done,
      // Label 21095: @1612116
      GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1612220), // Rule ID 3693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3693,
        GIR_EraseRootFromParent_Done,
      // Label 21096: @1612220
      GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1612324), // Rule ID 3696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3696,
        GIR_EraseRootFromParent_Done,
      // Label 21097: @1612324
      GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1612428), // Rule ID 3697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3697,
        GIR_EraseRootFromParent_Done,
      // Label 21098: @1612428
      GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1612532), // Rule ID 3700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3700,
        GIR_EraseRootFromParent_Done,
      // Label 21099: @1612532
      GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1612636), // Rule ID 3701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3701,
        GIR_EraseRootFromParent_Done,
      // Label 21100: @1612636
      GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1612740), // Rule ID 3704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3704,
        GIR_EraseRootFromParent_Done,
      // Label 21101: @1612740
      GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1612844), // Rule ID 3705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3705,
        GIR_EraseRootFromParent_Done,
      // Label 21102: @1612844
      GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1612948), // Rule ID 3708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3708,
        GIR_EraseRootFromParent_Done,
      // Label 21103: @1612948
      GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1613052), // Rule ID 3709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3709,
        GIR_EraseRootFromParent_Done,
      // Label 21104: @1613052
      GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1613156), // Rule ID 3712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3712,
        GIR_EraseRootFromParent_Done,
      // Label 21105: @1613156
      GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1613260), // Rule ID 3713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3713,
        GIR_EraseRootFromParent_Done,
      // Label 21106: @1613260
      GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1613364), // Rule ID 3716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3716,
        GIR_EraseRootFromParent_Done,
      // Label 21107: @1613364
      GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1613468), // Rule ID 3717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3717,
        GIR_EraseRootFromParent_Done,
      // Label 21108: @1613468
      GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1613572), // Rule ID 3720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3720,
        GIR_EraseRootFromParent_Done,
      // Label 21109: @1613572
      GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1613676), // Rule ID 3721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3721,
        GIR_EraseRootFromParent_Done,
      // Label 21110: @1613676
      GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1613780), // Rule ID 3724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3724,
        GIR_EraseRootFromParent_Done,
      // Label 21111: @1613780
      GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1613884), // Rule ID 3725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3725,
        GIR_EraseRootFromParent_Done,
      // Label 21112: @1613884
      GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1613988), // Rule ID 3728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3728,
        GIR_EraseRootFromParent_Done,
      // Label 21113: @1613988
      GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1614092), // Rule ID 3729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3729,
        GIR_EraseRootFromParent_Done,
      // Label 21114: @1614092
      GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1614196), // Rule ID 3732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3732,
        GIR_EraseRootFromParent_Done,
      // Label 21115: @1614196
      GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1614300), // Rule ID 3733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3733,
        GIR_EraseRootFromParent_Done,
      // Label 21116: @1614300
      GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1614404), // Rule ID 3736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3736,
        GIR_EraseRootFromParent_Done,
      // Label 21117: @1614404
      GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1614508), // Rule ID 3737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3737,
        GIR_EraseRootFromParent_Done,
      // Label 21118: @1614508
      GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1614612), // Rule ID 3740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3740,
        GIR_EraseRootFromParent_Done,
      // Label 21119: @1614612
      GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1614716), // Rule ID 3741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3741,
        GIR_EraseRootFromParent_Done,
      // Label 21120: @1614716
      GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1614820), // Rule ID 3744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3744,
        GIR_EraseRootFromParent_Done,
      // Label 21121: @1614820
      GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1614924), // Rule ID 3745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3745,
        GIR_EraseRootFromParent_Done,
      // Label 21122: @1614924
      GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1615028), // Rule ID 3748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3748,
        GIR_EraseRootFromParent_Done,
      // Label 21123: @1615028
      GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1615132), // Rule ID 3749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3749,
        GIR_EraseRootFromParent_Done,
      // Label 21124: @1615132
      GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1615236), // Rule ID 3752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3752,
        GIR_EraseRootFromParent_Done,
      // Label 21125: @1615236
      GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1615340), // Rule ID 3753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3753,
        GIR_EraseRootFromParent_Done,
      // Label 21126: @1615340
      GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1615444), // Rule ID 3756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3756,
        GIR_EraseRootFromParent_Done,
      // Label 21127: @1615444
      GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1615548), // Rule ID 3757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3757,
        GIR_EraseRootFromParent_Done,
      // Label 21128: @1615548
      GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1615652), // Rule ID 3760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3760,
        GIR_EraseRootFromParent_Done,
      // Label 21129: @1615652
      GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1615756), // Rule ID 3761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3761,
        GIR_EraseRootFromParent_Done,
      // Label 21130: @1615756
      GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1615860), // Rule ID 3764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3764,
        GIR_EraseRootFromParent_Done,
      // Label 21131: @1615860
      GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1615964), // Rule ID 3765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3765,
        GIR_EraseRootFromParent_Done,
      // Label 21132: @1615964
      GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1616068), // Rule ID 3768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3768,
        GIR_EraseRootFromParent_Done,
      // Label 21133: @1616068
      GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1616172), // Rule ID 3769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3769,
        GIR_EraseRootFromParent_Done,
      // Label 21134: @1616172
      GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1616276), // Rule ID 3772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3772,
        GIR_EraseRootFromParent_Done,
      // Label 21135: @1616276
      GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1616380), // Rule ID 3773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3773,
        GIR_EraseRootFromParent_Done,
      // Label 21136: @1616380
      GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1616484), // Rule ID 3776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3776,
        GIR_EraseRootFromParent_Done,
      // Label 21137: @1616484
      GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1616588), // Rule ID 3777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3777,
        GIR_EraseRootFromParent_Done,
      // Label 21138: @1616588
      GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1616692), // Rule ID 3780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3780,
        GIR_EraseRootFromParent_Done,
      // Label 21139: @1616692
      GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1616796), // Rule ID 3781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3781,
        GIR_EraseRootFromParent_Done,
      // Label 21140: @1616796
      GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1616900), // Rule ID 3784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3784,
        GIR_EraseRootFromParent_Done,
      // Label 21141: @1616900
      GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1617004), // Rule ID 3785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3785,
        GIR_EraseRootFromParent_Done,
      // Label 21142: @1617004
      GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1617108), // Rule ID 3788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3788,
        GIR_EraseRootFromParent_Done,
      // Label 21143: @1617108
      GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1617212), // Rule ID 3789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3789,
        GIR_EraseRootFromParent_Done,
      // Label 21144: @1617212
      GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1617316), // Rule ID 3792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3792,
        GIR_EraseRootFromParent_Done,
      // Label 21145: @1617316
      GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1617420), // Rule ID 3793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3793,
        GIR_EraseRootFromParent_Done,
      // Label 21146: @1617420
      GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1617524), // Rule ID 3796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3796,
        GIR_EraseRootFromParent_Done,
      // Label 21147: @1617524
      GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1617628), // Rule ID 3797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3797,
        GIR_EraseRootFromParent_Done,
      // Label 21148: @1617628
      GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1617732), // Rule ID 3800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3800,
        GIR_EraseRootFromParent_Done,
      // Label 21149: @1617732
      GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1617836), // Rule ID 3801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3801,
        GIR_EraseRootFromParent_Done,
      // Label 21150: @1617836
      GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1617940), // Rule ID 3804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3804,
        GIR_EraseRootFromParent_Done,
      // Label 21151: @1617940
      GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1618044), // Rule ID 3805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3805,
        GIR_EraseRootFromParent_Done,
      // Label 21152: @1618044
      GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1618148), // Rule ID 3808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3808,
        GIR_EraseRootFromParent_Done,
      // Label 21153: @1618148
      GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1618252), // Rule ID 3809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3809,
        GIR_EraseRootFromParent_Done,
      // Label 21154: @1618252
      GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1618356), // Rule ID 3812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3812,
        GIR_EraseRootFromParent_Done,
      // Label 21155: @1618356
      GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1618460), // Rule ID 3813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3813,
        GIR_EraseRootFromParent_Done,
      // Label 21156: @1618460
      GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1618564), // Rule ID 3816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3816,
        GIR_EraseRootFromParent_Done,
      // Label 21157: @1618564
      GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1618668), // Rule ID 3817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3817,
        GIR_EraseRootFromParent_Done,
      // Label 21158: @1618668
      GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1618772), // Rule ID 3820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3820,
        GIR_EraseRootFromParent_Done,
      // Label 21159: @1618772
      GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1618876), // Rule ID 3821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3821,
        GIR_EraseRootFromParent_Done,
      // Label 21160: @1618876
      GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1618980), // Rule ID 3824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3824,
        GIR_EraseRootFromParent_Done,
      // Label 21161: @1618980
      GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1619084), // Rule ID 3825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3825,
        GIR_EraseRootFromParent_Done,
      // Label 21162: @1619084
      GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1619188), // Rule ID 3828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3828,
        GIR_EraseRootFromParent_Done,
      // Label 21163: @1619188
      GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1619292), // Rule ID 3829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3829,
        GIR_EraseRootFromParent_Done,
      // Label 21164: @1619292
      GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1619396), // Rule ID 3832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3832,
        GIR_EraseRootFromParent_Done,
      // Label 21165: @1619396
      GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1619500), // Rule ID 3833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3833,
        GIR_EraseRootFromParent_Done,
      // Label 21166: @1619500
      GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1619604), // Rule ID 3836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3836,
        GIR_EraseRootFromParent_Done,
      // Label 21167: @1619604
      GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1619708), // Rule ID 3837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3837,
        GIR_EraseRootFromParent_Done,
      // Label 21168: @1619708
      GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1619812), // Rule ID 3840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3840,
        GIR_EraseRootFromParent_Done,
      // Label 21169: @1619812
      GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1619916), // Rule ID 3841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3841,
        GIR_EraseRootFromParent_Done,
      // Label 21170: @1619916
      GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1620020), // Rule ID 3844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3844,
        GIR_EraseRootFromParent_Done,
      // Label 21171: @1620020
      GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1620124), // Rule ID 3845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3845,
        GIR_EraseRootFromParent_Done,
      // Label 21172: @1620124
      GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1620228), // Rule ID 3848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3848,
        GIR_EraseRootFromParent_Done,
      // Label 21173: @1620228
      GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1620332), // Rule ID 3849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3849,
        GIR_EraseRootFromParent_Done,
      // Label 21174: @1620332
      GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1620436), // Rule ID 3852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3852,
        GIR_EraseRootFromParent_Done,
      // Label 21175: @1620436
      GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1620540), // Rule ID 3853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3853,
        GIR_EraseRootFromParent_Done,
      // Label 21176: @1620540
      GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1620644), // Rule ID 3856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3856,
        GIR_EraseRootFromParent_Done,
      // Label 21177: @1620644
      GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1620748), // Rule ID 3857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3857,
        GIR_EraseRootFromParent_Done,
      // Label 21178: @1620748
      GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1620852), // Rule ID 3860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3860,
        GIR_EraseRootFromParent_Done,
      // Label 21179: @1620852
      GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1620956), // Rule ID 3861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3861,
        GIR_EraseRootFromParent_Done,
      // Label 21180: @1620956
      GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1621060), // Rule ID 3864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3864,
        GIR_EraseRootFromParent_Done,
      // Label 21181: @1621060
      GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1621164), // Rule ID 3865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3865,
        GIR_EraseRootFromParent_Done,
      // Label 21182: @1621164
      GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1621268), // Rule ID 3868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3868,
        GIR_EraseRootFromParent_Done,
      // Label 21183: @1621268
      GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1621372), // Rule ID 3869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3869,
        GIR_EraseRootFromParent_Done,
      // Label 21184: @1621372
      GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1621476), // Rule ID 3872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3872,
        GIR_EraseRootFromParent_Done,
      // Label 21185: @1621476
      GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1621580), // Rule ID 3873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3873,
        GIR_EraseRootFromParent_Done,
      // Label 21186: @1621580
      GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1621684), // Rule ID 3876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3876,
        GIR_EraseRootFromParent_Done,
      // Label 21187: @1621684
      GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1621788), // Rule ID 3877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3877,
        GIR_EraseRootFromParent_Done,
      // Label 21188: @1621788
      GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1621892), // Rule ID 3880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3880,
        GIR_EraseRootFromParent_Done,
      // Label 21189: @1621892
      GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1621996), // Rule ID 3881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3881,
        GIR_EraseRootFromParent_Done,
      // Label 21190: @1621996
      GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1622100), // Rule ID 3884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3884,
        GIR_EraseRootFromParent_Done,
      // Label 21191: @1622100
      GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1622204), // Rule ID 3885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3885,
        GIR_EraseRootFromParent_Done,
      // Label 21192: @1622204
      GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1622308), // Rule ID 3888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3888,
        GIR_EraseRootFromParent_Done,
      // Label 21193: @1622308
      GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1622412), // Rule ID 3889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3889,
        GIR_EraseRootFromParent_Done,
      // Label 21194: @1622412
      GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1622516), // Rule ID 3892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3892,
        GIR_EraseRootFromParent_Done,
      // Label 21195: @1622516
      GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1622620), // Rule ID 3893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3893,
        GIR_EraseRootFromParent_Done,
      // Label 21196: @1622620
      GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1622724), // Rule ID 3896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3896,
        GIR_EraseRootFromParent_Done,
      // Label 21197: @1622724
      GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1622828), // Rule ID 3897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3897,
        GIR_EraseRootFromParent_Done,
      // Label 21198: @1622828
      GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1622932), // Rule ID 3900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3900,
        GIR_EraseRootFromParent_Done,
      // Label 21199: @1622932
      GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1623036), // Rule ID 3901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3901,
        GIR_EraseRootFromParent_Done,
      // Label 21200: @1623036
      GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1623140), // Rule ID 3904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3904,
        GIR_EraseRootFromParent_Done,
      // Label 21201: @1623140
      GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1623244), // Rule ID 3905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3905,
        GIR_EraseRootFromParent_Done,
      // Label 21202: @1623244
      GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1623348), // Rule ID 3908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3908,
        GIR_EraseRootFromParent_Done,
      // Label 21203: @1623348
      GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1623452), // Rule ID 3909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3909,
        GIR_EraseRootFromParent_Done,
      // Label 21204: @1623452
      GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1623556), // Rule ID 3912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3912,
        GIR_EraseRootFromParent_Done,
      // Label 21205: @1623556
      GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1623660), // Rule ID 3913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3913,
        GIR_EraseRootFromParent_Done,
      // Label 21206: @1623660
      GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1623764), // Rule ID 3916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3916,
        GIR_EraseRootFromParent_Done,
      // Label 21207: @1623764
      GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1623868), // Rule ID 3917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3917,
        GIR_EraseRootFromParent_Done,
      // Label 21208: @1623868
      GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1623972), // Rule ID 3926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3926,
        GIR_EraseRootFromParent_Done,
      // Label 21209: @1623972
      GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1624076), // Rule ID 3927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3927,
        GIR_EraseRootFromParent_Done,
      // Label 21210: @1624076
      GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1624180), // Rule ID 3936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3936,
        GIR_EraseRootFromParent_Done,
      // Label 21211: @1624180
      GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1624284), // Rule ID 3937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3937,
        GIR_EraseRootFromParent_Done,
      // Label 21212: @1624284
      GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1624388), // Rule ID 3946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3946,
        GIR_EraseRootFromParent_Done,
      // Label 21213: @1624388
      GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1624492), // Rule ID 3947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3947,
        GIR_EraseRootFromParent_Done,
      // Label 21214: @1624492
      GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1624596), // Rule ID 3956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3956,
        GIR_EraseRootFromParent_Done,
      // Label 21215: @1624596
      GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1624700), // Rule ID 3957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3957,
        GIR_EraseRootFromParent_Done,
      // Label 21216: @1624700
      GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1624804), // Rule ID 3966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3966,
        GIR_EraseRootFromParent_Done,
      // Label 21217: @1624804
      GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1624908), // Rule ID 3967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3967,
        GIR_EraseRootFromParent_Done,
      // Label 21218: @1624908
      GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1625012), // Rule ID 3976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3976,
        GIR_EraseRootFromParent_Done,
      // Label 21219: @1625012
      GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1625116), // Rule ID 3977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3977,
        GIR_EraseRootFromParent_Done,
      // Label 21220: @1625116
      GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1625220), // Rule ID 3986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3986,
        GIR_EraseRootFromParent_Done,
      // Label 21221: @1625220
      GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1625324), // Rule ID 3987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3987,
        GIR_EraseRootFromParent_Done,
      // Label 21222: @1625324
      GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1625428), // Rule ID 3996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3996,
        GIR_EraseRootFromParent_Done,
      // Label 21223: @1625428
      GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1625532), // Rule ID 3997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3997,
        GIR_EraseRootFromParent_Done,
      // Label 21224: @1625532
      GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1625636), // Rule ID 4006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4006,
        GIR_EraseRootFromParent_Done,
      // Label 21225: @1625636
      GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1625740), // Rule ID 4007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4007,
        GIR_EraseRootFromParent_Done,
      // Label 21226: @1625740
      GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1625844), // Rule ID 4016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4016,
        GIR_EraseRootFromParent_Done,
      // Label 21227: @1625844
      GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1625948), // Rule ID 4017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4017,
        GIR_EraseRootFromParent_Done,
      // Label 21228: @1625948
      GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1626052), // Rule ID 4026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4026,
        GIR_EraseRootFromParent_Done,
      // Label 21229: @1626052
      GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1626156), // Rule ID 4027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4027,
        GIR_EraseRootFromParent_Done,
      // Label 21230: @1626156
      GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1626260), // Rule ID 4036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4036,
        GIR_EraseRootFromParent_Done,
      // Label 21231: @1626260
      GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1626364), // Rule ID 4037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4037,
        GIR_EraseRootFromParent_Done,
      // Label 21232: @1626364
      GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1626468), // Rule ID 4046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4046,
        GIR_EraseRootFromParent_Done,
      // Label 21233: @1626468
      GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1626572), // Rule ID 4047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4047,
        GIR_EraseRootFromParent_Done,
      // Label 21234: @1626572
      GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1626676), // Rule ID 4056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4056,
        GIR_EraseRootFromParent_Done,
      // Label 21235: @1626676
      GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1626780), // Rule ID 4057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4057,
        GIR_EraseRootFromParent_Done,
      // Label 21236: @1626780
      GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1626884), // Rule ID 4060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4060,
        GIR_EraseRootFromParent_Done,
      // Label 21237: @1626884
      GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1626988), // Rule ID 4061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4061,
        GIR_EraseRootFromParent_Done,
      // Label 21238: @1626988
      GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1627092), // Rule ID 4064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4064,
        GIR_EraseRootFromParent_Done,
      // Label 21239: @1627092
      GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1627196), // Rule ID 4065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4065,
        GIR_EraseRootFromParent_Done,
      // Label 21240: @1627196
      GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1627300), // Rule ID 4068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4068,
        GIR_EraseRootFromParent_Done,
      // Label 21241: @1627300
      GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1627404), // Rule ID 4069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4069,
        GIR_EraseRootFromParent_Done,
      // Label 21242: @1627404
      GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1627508), // Rule ID 4072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4072,
        GIR_EraseRootFromParent_Done,
      // Label 21243: @1627508
      GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1627612), // Rule ID 4073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4073,
        GIR_EraseRootFromParent_Done,
      // Label 21244: @1627612
      GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1627716), // Rule ID 4076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4076,
        GIR_EraseRootFromParent_Done,
      // Label 21245: @1627716
      GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1627820), // Rule ID 4077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4077,
        GIR_EraseRootFromParent_Done,
      // Label 21246: @1627820
      GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1627924), // Rule ID 4080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4080,
        GIR_EraseRootFromParent_Done,
      // Label 21247: @1627924
      GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1628028), // Rule ID 4081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4081,
        GIR_EraseRootFromParent_Done,
      // Label 21248: @1628028
      GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1628132), // Rule ID 4084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4084,
        GIR_EraseRootFromParent_Done,
      // Label 21249: @1628132
      GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1628236), // Rule ID 4085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4085,
        GIR_EraseRootFromParent_Done,
      // Label 21250: @1628236
      GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1628340), // Rule ID 4088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4088,
        GIR_EraseRootFromParent_Done,
      // Label 21251: @1628340
      GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1628444), // Rule ID 4089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4089,
        GIR_EraseRootFromParent_Done,
      // Label 21252: @1628444
      GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1628548), // Rule ID 4092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4092,
        GIR_EraseRootFromParent_Done,
      // Label 21253: @1628548
      GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1628652), // Rule ID 4093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4093,
        GIR_EraseRootFromParent_Done,
      // Label 21254: @1628652
      GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1628756), // Rule ID 4096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4096,
        GIR_EraseRootFromParent_Done,
      // Label 21255: @1628756
      GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1628860), // Rule ID 4097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4097,
        GIR_EraseRootFromParent_Done,
      // Label 21256: @1628860
      GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1628964), // Rule ID 4100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4100,
        GIR_EraseRootFromParent_Done,
      // Label 21257: @1628964
      GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1629068), // Rule ID 4101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4101,
        GIR_EraseRootFromParent_Done,
      // Label 21258: @1629068
      GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1629172), // Rule ID 4104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4104,
        GIR_EraseRootFromParent_Done,
      // Label 21259: @1629172
      GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1629276), // Rule ID 4105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4105,
        GIR_EraseRootFromParent_Done,
      // Label 21260: @1629276
      GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1629380), // Rule ID 4108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4108,
        GIR_EraseRootFromParent_Done,
      // Label 21261: @1629380
      GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1629484), // Rule ID 4109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4109,
        GIR_EraseRootFromParent_Done,
      // Label 21262: @1629484
      GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1629588), // Rule ID 4112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4112,
        GIR_EraseRootFromParent_Done,
      // Label 21263: @1629588
      GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1629692), // Rule ID 4113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4113,
        GIR_EraseRootFromParent_Done,
      // Label 21264: @1629692
      GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1629796), // Rule ID 4116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4116,
        GIR_EraseRootFromParent_Done,
      // Label 21265: @1629796
      GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1629900), // Rule ID 4117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4117,
        GIR_EraseRootFromParent_Done,
      // Label 21266: @1629900
      GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1630004), // Rule ID 4126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4126,
        GIR_EraseRootFromParent_Done,
      // Label 21267: @1630004
      GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1630108), // Rule ID 4127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4127,
        GIR_EraseRootFromParent_Done,
      // Label 21268: @1630108
      GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1630212), // Rule ID 4136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4136,
        GIR_EraseRootFromParent_Done,
      // Label 21269: @1630212
      GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1630316), // Rule ID 4137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4137,
        GIR_EraseRootFromParent_Done,
      // Label 21270: @1630316
      GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1630420), // Rule ID 4146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4146,
        GIR_EraseRootFromParent_Done,
      // Label 21271: @1630420
      GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1630524), // Rule ID 4147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4147,
        GIR_EraseRootFromParent_Done,
      // Label 21272: @1630524
      GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1630628), // Rule ID 4156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4156,
        GIR_EraseRootFromParent_Done,
      // Label 21273: @1630628
      GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1630732), // Rule ID 4157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4157,
        GIR_EraseRootFromParent_Done,
      // Label 21274: @1630732
      GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1630836), // Rule ID 4166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4166,
        GIR_EraseRootFromParent_Done,
      // Label 21275: @1630836
      GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1630940), // Rule ID 4167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4167,
        GIR_EraseRootFromParent_Done,
      // Label 21276: @1630940
      GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1631044), // Rule ID 4176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4176,
        GIR_EraseRootFromParent_Done,
      // Label 21277: @1631044
      GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1631148), // Rule ID 4177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4177,
        GIR_EraseRootFromParent_Done,
      // Label 21278: @1631148
      GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1631252), // Rule ID 4186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4186,
        GIR_EraseRootFromParent_Done,
      // Label 21279: @1631252
      GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1631356), // Rule ID 4187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4187,
        GIR_EraseRootFromParent_Done,
      // Label 21280: @1631356
      GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1631460), // Rule ID 4196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4196,
        GIR_EraseRootFromParent_Done,
      // Label 21281: @1631460
      GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1631564), // Rule ID 4197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4197,
        GIR_EraseRootFromParent_Done,
      // Label 21282: @1631564
      GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1631668), // Rule ID 4206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4206,
        GIR_EraseRootFromParent_Done,
      // Label 21283: @1631668
      GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1631772), // Rule ID 4207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4207,
        GIR_EraseRootFromParent_Done,
      // Label 21284: @1631772
      GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1631876), // Rule ID 4216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4216,
        GIR_EraseRootFromParent_Done,
      // Label 21285: @1631876
      GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1631980), // Rule ID 4217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4217,
        GIR_EraseRootFromParent_Done,
      // Label 21286: @1631980
      GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1632084), // Rule ID 4226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4226,
        GIR_EraseRootFromParent_Done,
      // Label 21287: @1632084
      GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1632188), // Rule ID 4227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4227,
        GIR_EraseRootFromParent_Done,
      // Label 21288: @1632188
      GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1632292), // Rule ID 4236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4236,
        GIR_EraseRootFromParent_Done,
      // Label 21289: @1632292
      GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1632396), // Rule ID 4237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4237,
        GIR_EraseRootFromParent_Done,
      // Label 21290: @1632396
      GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1632500), // Rule ID 4246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4246,
        GIR_EraseRootFromParent_Done,
      // Label 21291: @1632500
      GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1632604), // Rule ID 4247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4247,
        GIR_EraseRootFromParent_Done,
      // Label 21292: @1632604
      GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1632708), // Rule ID 4256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4256,
        GIR_EraseRootFromParent_Done,
      // Label 21293: @1632708
      GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1632812), // Rule ID 4257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4257,
        GIR_EraseRootFromParent_Done,
      // Label 21294: @1632812
      GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1632916), // Rule ID 4266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4266,
        GIR_EraseRootFromParent_Done,
      // Label 21295: @1632916
      GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1633020), // Rule ID 4267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4267,
        GIR_EraseRootFromParent_Done,
      // Label 21296: @1633020
      GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1633124), // Rule ID 4270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4270,
        GIR_EraseRootFromParent_Done,
      // Label 21297: @1633124
      GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1633228), // Rule ID 4271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4271,
        GIR_EraseRootFromParent_Done,
      // Label 21298: @1633228
      GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1633332), // Rule ID 4274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4274,
        GIR_EraseRootFromParent_Done,
      // Label 21299: @1633332
      GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1633436), // Rule ID 4275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4275,
        GIR_EraseRootFromParent_Done,
      // Label 21300: @1633436
      GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1633540), // Rule ID 4278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4278,
        GIR_EraseRootFromParent_Done,
      // Label 21301: @1633540
      GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1633644), // Rule ID 4279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4279,
        GIR_EraseRootFromParent_Done,
      // Label 21302: @1633644
      GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1633748), // Rule ID 4282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4282,
        GIR_EraseRootFromParent_Done,
      // Label 21303: @1633748
      GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1633852), // Rule ID 4283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4283,
        GIR_EraseRootFromParent_Done,
      // Label 21304: @1633852
      GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1633956), // Rule ID 4286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4286,
        GIR_EraseRootFromParent_Done,
      // Label 21305: @1633956
      GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1634060), // Rule ID 4287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4287,
        GIR_EraseRootFromParent_Done,
      // Label 21306: @1634060
      GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1634164), // Rule ID 4290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4290,
        GIR_EraseRootFromParent_Done,
      // Label 21307: @1634164
      GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1634268), // Rule ID 4291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4291,
        GIR_EraseRootFromParent_Done,
      // Label 21308: @1634268
      GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1634372), // Rule ID 4294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4294,
        GIR_EraseRootFromParent_Done,
      // Label 21309: @1634372
      GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1634476), // Rule ID 4295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4295,
        GIR_EraseRootFromParent_Done,
      // Label 21310: @1634476
      GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1634580), // Rule ID 4298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4298,
        GIR_EraseRootFromParent_Done,
      // Label 21311: @1634580
      GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1634684), // Rule ID 4299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4299,
        GIR_EraseRootFromParent_Done,
      // Label 21312: @1634684
      GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1634788), // Rule ID 4302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4302,
        GIR_EraseRootFromParent_Done,
      // Label 21313: @1634788
      GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1634892), // Rule ID 4303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4303,
        GIR_EraseRootFromParent_Done,
      // Label 21314: @1634892
      GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1634996), // Rule ID 4306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4306,
        GIR_EraseRootFromParent_Done,
      // Label 21315: @1634996
      GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1635100), // Rule ID 4307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4307,
        GIR_EraseRootFromParent_Done,
      // Label 21316: @1635100
      GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1635204), // Rule ID 4310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4310,
        GIR_EraseRootFromParent_Done,
      // Label 21317: @1635204
      GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1635308), // Rule ID 4311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4311,
        GIR_EraseRootFromParent_Done,
      // Label 21318: @1635308
      GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1635412), // Rule ID 4314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4314,
        GIR_EraseRootFromParent_Done,
      // Label 21319: @1635412
      GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1635516), // Rule ID 4315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4315,
        GIR_EraseRootFromParent_Done,
      // Label 21320: @1635516
      GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1635620), // Rule ID 4318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4318,
        GIR_EraseRootFromParent_Done,
      // Label 21321: @1635620
      GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1635724), // Rule ID 4319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4319,
        GIR_EraseRootFromParent_Done,
      // Label 21322: @1635724
      GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1635828), // Rule ID 4322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4322,
        GIR_EraseRootFromParent_Done,
      // Label 21323: @1635828
      GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1635932), // Rule ID 4323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4323,
        GIR_EraseRootFromParent_Done,
      // Label 21324: @1635932
      GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1636036), // Rule ID 4326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4326,
        GIR_EraseRootFromParent_Done,
      // Label 21325: @1636036
      GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1636140), // Rule ID 4327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4327,
        GIR_EraseRootFromParent_Done,
      // Label 21326: @1636140
      GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1636244), // Rule ID 4336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4336,
        GIR_EraseRootFromParent_Done,
      // Label 21327: @1636244
      GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1636348), // Rule ID 4337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4337,
        GIR_EraseRootFromParent_Done,
      // Label 21328: @1636348
      GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1636452), // Rule ID 4346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4346,
        GIR_EraseRootFromParent_Done,
      // Label 21329: @1636452
      GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1636556), // Rule ID 4347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4347,
        GIR_EraseRootFromParent_Done,
      // Label 21330: @1636556
      GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1636660), // Rule ID 4356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4356,
        GIR_EraseRootFromParent_Done,
      // Label 21331: @1636660
      GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1636764), // Rule ID 4357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4357,
        GIR_EraseRootFromParent_Done,
      // Label 21332: @1636764
      GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1636868), // Rule ID 4366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4366,
        GIR_EraseRootFromParent_Done,
      // Label 21333: @1636868
      GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1636972), // Rule ID 4367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4367,
        GIR_EraseRootFromParent_Done,
      // Label 21334: @1636972
      GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1637076), // Rule ID 4376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4376,
        GIR_EraseRootFromParent_Done,
      // Label 21335: @1637076
      GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1637180), // Rule ID 4377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4377,
        GIR_EraseRootFromParent_Done,
      // Label 21336: @1637180
      GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1637284), // Rule ID 4386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4386,
        GIR_EraseRootFromParent_Done,
      // Label 21337: @1637284
      GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1637388), // Rule ID 4387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4387,
        GIR_EraseRootFromParent_Done,
      // Label 21338: @1637388
      GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1637492), // Rule ID 4396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4396,
        GIR_EraseRootFromParent_Done,
      // Label 21339: @1637492
      GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1637596), // Rule ID 4397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4397,
        GIR_EraseRootFromParent_Done,
      // Label 21340: @1637596
      GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1637700), // Rule ID 4406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4406,
        GIR_EraseRootFromParent_Done,
      // Label 21341: @1637700
      GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1637804), // Rule ID 4407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4407,
        GIR_EraseRootFromParent_Done,
      // Label 21342: @1637804
      GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1637908), // Rule ID 4416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4416,
        GIR_EraseRootFromParent_Done,
      // Label 21343: @1637908
      GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1638012), // Rule ID 4417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4417,
        GIR_EraseRootFromParent_Done,
      // Label 21344: @1638012
      GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1638116), // Rule ID 4426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4426,
        GIR_EraseRootFromParent_Done,
      // Label 21345: @1638116
      GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1638220), // Rule ID 4427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4427,
        GIR_EraseRootFromParent_Done,
      // Label 21346: @1638220
      GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1638324), // Rule ID 4436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4436,
        GIR_EraseRootFromParent_Done,
      // Label 21347: @1638324
      GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1638428), // Rule ID 4437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4437,
        GIR_EraseRootFromParent_Done,
      // Label 21348: @1638428
      GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1638532), // Rule ID 4446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4446,
        GIR_EraseRootFromParent_Done,
      // Label 21349: @1638532
      GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1638636), // Rule ID 4447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4447,
        GIR_EraseRootFromParent_Done,
      // Label 21350: @1638636
      GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1638740), // Rule ID 4456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4456,
        GIR_EraseRootFromParent_Done,
      // Label 21351: @1638740
      GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1638844), // Rule ID 4457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4457,
        GIR_EraseRootFromParent_Done,
      // Label 21352: @1638844
      GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1638948), // Rule ID 4466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4466,
        GIR_EraseRootFromParent_Done,
      // Label 21353: @1638948
      GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1639052), // Rule ID 4467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4467,
        GIR_EraseRootFromParent_Done,
      // Label 21354: @1639052
      GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1639156), // Rule ID 4476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4476,
        GIR_EraseRootFromParent_Done,
      // Label 21355: @1639156
      GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1639260), // Rule ID 4477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4477,
        GIR_EraseRootFromParent_Done,
      // Label 21356: @1639260
      GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1639364), // Rule ID 4480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4480,
        GIR_EraseRootFromParent_Done,
      // Label 21357: @1639364
      GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1639468), // Rule ID 4481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4481,
        GIR_EraseRootFromParent_Done,
      // Label 21358: @1639468
      GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1639572), // Rule ID 4484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4484,
        GIR_EraseRootFromParent_Done,
      // Label 21359: @1639572
      GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1639676), // Rule ID 4485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4485,
        GIR_EraseRootFromParent_Done,
      // Label 21360: @1639676
      GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1639780), // Rule ID 4488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4488,
        GIR_EraseRootFromParent_Done,
      // Label 21361: @1639780
      GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1639884), // Rule ID 4489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4489,
        GIR_EraseRootFromParent_Done,
      // Label 21362: @1639884
      GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1639988), // Rule ID 4492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4492,
        GIR_EraseRootFromParent_Done,
      // Label 21363: @1639988
      GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1640092), // Rule ID 4493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4493,
        GIR_EraseRootFromParent_Done,
      // Label 21364: @1640092
      GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1640196), // Rule ID 4496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4496,
        GIR_EraseRootFromParent_Done,
      // Label 21365: @1640196
      GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1640300), // Rule ID 4497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4497,
        GIR_EraseRootFromParent_Done,
      // Label 21366: @1640300
      GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1640404), // Rule ID 4500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4500,
        GIR_EraseRootFromParent_Done,
      // Label 21367: @1640404
      GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1640508), // Rule ID 4501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4501,
        GIR_EraseRootFromParent_Done,
      // Label 21368: @1640508
      GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1640612), // Rule ID 4504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4504,
        GIR_EraseRootFromParent_Done,
      // Label 21369: @1640612
      GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1640716), // Rule ID 4505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4505,
        GIR_EraseRootFromParent_Done,
      // Label 21370: @1640716
      GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1640820), // Rule ID 4508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4508,
        GIR_EraseRootFromParent_Done,
      // Label 21371: @1640820
      GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1640924), // Rule ID 4509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4509,
        GIR_EraseRootFromParent_Done,
      // Label 21372: @1640924
      GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1641028), // Rule ID 4512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4512,
        GIR_EraseRootFromParent_Done,
      // Label 21373: @1641028
      GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1641132), // Rule ID 4513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4513,
        GIR_EraseRootFromParent_Done,
      // Label 21374: @1641132
      GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1641236), // Rule ID 4516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4516,
        GIR_EraseRootFromParent_Done,
      // Label 21375: @1641236
      GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1641340), // Rule ID 4517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4517,
        GIR_EraseRootFromParent_Done,
      // Label 21376: @1641340
      GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1641444), // Rule ID 4520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4520,
        GIR_EraseRootFromParent_Done,
      // Label 21377: @1641444
      GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1641548), // Rule ID 4521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4521,
        GIR_EraseRootFromParent_Done,
      // Label 21378: @1641548
      GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1641652), // Rule ID 4524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4524,
        GIR_EraseRootFromParent_Done,
      // Label 21379: @1641652
      GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1641756), // Rule ID 4525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4525,
        GIR_EraseRootFromParent_Done,
      // Label 21380: @1641756
      GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1641860), // Rule ID 4528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4528,
        GIR_EraseRootFromParent_Done,
      // Label 21381: @1641860
      GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1641964), // Rule ID 4529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4529,
        GIR_EraseRootFromParent_Done,
      // Label 21382: @1641964
      GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1642068), // Rule ID 4532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4532,
        GIR_EraseRootFromParent_Done,
      // Label 21383: @1642068
      GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1642172), // Rule ID 4533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4533,
        GIR_EraseRootFromParent_Done,
      // Label 21384: @1642172
      GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1642276), // Rule ID 4536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4536,
        GIR_EraseRootFromParent_Done,
      // Label 21385: @1642276
      GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1642380), // Rule ID 4537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4537,
        GIR_EraseRootFromParent_Done,
      // Label 21386: @1642380
      GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1642484), // Rule ID 4546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4546,
        GIR_EraseRootFromParent_Done,
      // Label 21387: @1642484
      GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1642588), // Rule ID 4547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4547,
        GIR_EraseRootFromParent_Done,
      // Label 21388: @1642588
      GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1642692), // Rule ID 4556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4556,
        GIR_EraseRootFromParent_Done,
      // Label 21389: @1642692
      GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1642796), // Rule ID 4557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4557,
        GIR_EraseRootFromParent_Done,
      // Label 21390: @1642796
      GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1642900), // Rule ID 4566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4566,
        GIR_EraseRootFromParent_Done,
      // Label 21391: @1642900
      GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1643004), // Rule ID 4567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4567,
        GIR_EraseRootFromParent_Done,
      // Label 21392: @1643004
      GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1643108), // Rule ID 4576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4576,
        GIR_EraseRootFromParent_Done,
      // Label 21393: @1643108
      GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1643212), // Rule ID 4577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4577,
        GIR_EraseRootFromParent_Done,
      // Label 21394: @1643212
      GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1643316), // Rule ID 4586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4586,
        GIR_EraseRootFromParent_Done,
      // Label 21395: @1643316
      GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1643420), // Rule ID 4587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4587,
        GIR_EraseRootFromParent_Done,
      // Label 21396: @1643420
      GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1643524), // Rule ID 4596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4596,
        GIR_EraseRootFromParent_Done,
      // Label 21397: @1643524
      GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1643628), // Rule ID 4597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4597,
        GIR_EraseRootFromParent_Done,
      // Label 21398: @1643628
      GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1643732), // Rule ID 4606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4606,
        GIR_EraseRootFromParent_Done,
      // Label 21399: @1643732
      GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1643836), // Rule ID 4607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4607,
        GIR_EraseRootFromParent_Done,
      // Label 21400: @1643836
      GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1643940), // Rule ID 4616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4616,
        GIR_EraseRootFromParent_Done,
      // Label 21401: @1643940
      GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1644044), // Rule ID 4617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4617,
        GIR_EraseRootFromParent_Done,
      // Label 21402: @1644044
      GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1644148), // Rule ID 4626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4626,
        GIR_EraseRootFromParent_Done,
      // Label 21403: @1644148
      GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1644252), // Rule ID 4627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4627,
        GIR_EraseRootFromParent_Done,
      // Label 21404: @1644252
      GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1644356), // Rule ID 4636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4636,
        GIR_EraseRootFromParent_Done,
      // Label 21405: @1644356
      GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1644460), // Rule ID 4637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4637,
        GIR_EraseRootFromParent_Done,
      // Label 21406: @1644460
      GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1644564), // Rule ID 4646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4646,
        GIR_EraseRootFromParent_Done,
      // Label 21407: @1644564
      GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1644668), // Rule ID 4647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4647,
        GIR_EraseRootFromParent_Done,
      // Label 21408: @1644668
      GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1644772), // Rule ID 4656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4656,
        GIR_EraseRootFromParent_Done,
      // Label 21409: @1644772
      GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1644876), // Rule ID 4657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4657,
        GIR_EraseRootFromParent_Done,
      // Label 21410: @1644876
      GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1644980), // Rule ID 4666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4666,
        GIR_EraseRootFromParent_Done,
      // Label 21411: @1644980
      GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1645084), // Rule ID 4667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4667,
        GIR_EraseRootFromParent_Done,
      // Label 21412: @1645084
      GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1645188), // Rule ID 4676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4676,
        GIR_EraseRootFromParent_Done,
      // Label 21413: @1645188
      GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1645292), // Rule ID 4677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4677,
        GIR_EraseRootFromParent_Done,
      // Label 21414: @1645292
      GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1645396), // Rule ID 4686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4686,
        GIR_EraseRootFromParent_Done,
      // Label 21415: @1645396
      GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1645500), // Rule ID 4687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4687,
        GIR_EraseRootFromParent_Done,
      // Label 21416: @1645500
      GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1645604), // Rule ID 4690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4690,
        GIR_EraseRootFromParent_Done,
      // Label 21417: @1645604
      GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1645708), // Rule ID 4691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4691,
        GIR_EraseRootFromParent_Done,
      // Label 21418: @1645708
      GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1645812), // Rule ID 4694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4694,
        GIR_EraseRootFromParent_Done,
      // Label 21419: @1645812
      GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1645916), // Rule ID 4695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4695,
        GIR_EraseRootFromParent_Done,
      // Label 21420: @1645916
      GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1646020), // Rule ID 4698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4698,
        GIR_EraseRootFromParent_Done,
      // Label 21421: @1646020
      GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1646124), // Rule ID 4699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4699,
        GIR_EraseRootFromParent_Done,
      // Label 21422: @1646124
      GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1646228), // Rule ID 4702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4702,
        GIR_EraseRootFromParent_Done,
      // Label 21423: @1646228
      GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1646332), // Rule ID 4703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4703,
        GIR_EraseRootFromParent_Done,
      // Label 21424: @1646332
      GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1646436), // Rule ID 4706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4706,
        GIR_EraseRootFromParent_Done,
      // Label 21425: @1646436
      GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1646540), // Rule ID 4707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4707,
        GIR_EraseRootFromParent_Done,
      // Label 21426: @1646540
      GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1646644), // Rule ID 4710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4710,
        GIR_EraseRootFromParent_Done,
      // Label 21427: @1646644
      GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1646748), // Rule ID 4711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4711,
        GIR_EraseRootFromParent_Done,
      // Label 21428: @1646748
      GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1646852), // Rule ID 4714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4714,
        GIR_EraseRootFromParent_Done,
      // Label 21429: @1646852
      GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1646956), // Rule ID 4715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4715,
        GIR_EraseRootFromParent_Done,
      // Label 21430: @1646956
      GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1647060), // Rule ID 4718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4718,
        GIR_EraseRootFromParent_Done,
      // Label 21431: @1647060
      GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1647164), // Rule ID 4719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4719,
        GIR_EraseRootFromParent_Done,
      // Label 21432: @1647164
      GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1647268), // Rule ID 4722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4722,
        GIR_EraseRootFromParent_Done,
      // Label 21433: @1647268
      GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1647372), // Rule ID 4723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4723,
        GIR_EraseRootFromParent_Done,
      // Label 21434: @1647372
      GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1647476), // Rule ID 4726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4726,
        GIR_EraseRootFromParent_Done,
      // Label 21435: @1647476
      GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1647580), // Rule ID 4727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4727,
        GIR_EraseRootFromParent_Done,
      // Label 21436: @1647580
      GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1647684), // Rule ID 4730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4730,
        GIR_EraseRootFromParent_Done,
      // Label 21437: @1647684
      GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1647788), // Rule ID 4731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4731,
        GIR_EraseRootFromParent_Done,
      // Label 21438: @1647788
      GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1647892), // Rule ID 4734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4734,
        GIR_EraseRootFromParent_Done,
      // Label 21439: @1647892
      GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1647996), // Rule ID 4735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4735,
        GIR_EraseRootFromParent_Done,
      // Label 21440: @1647996
      GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1648100), // Rule ID 4738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4738,
        GIR_EraseRootFromParent_Done,
      // Label 21441: @1648100
      GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1648204), // Rule ID 4739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4739,
        GIR_EraseRootFromParent_Done,
      // Label 21442: @1648204
      GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1648308), // Rule ID 4742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4742,
        GIR_EraseRootFromParent_Done,
      // Label 21443: @1648308
      GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1648412), // Rule ID 4743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4743,
        GIR_EraseRootFromParent_Done,
      // Label 21444: @1648412
      GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1648516), // Rule ID 4746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4746,
        GIR_EraseRootFromParent_Done,
      // Label 21445: @1648516
      GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1648620), // Rule ID 4747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4747,
        GIR_EraseRootFromParent_Done,
      // Label 21446: @1648620
      GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1648724), // Rule ID 5624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5624,
        GIR_EraseRootFromParent_Done,
      // Label 21447: @1648724
      GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1648828), // Rule ID 5625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5625,
        GIR_EraseRootFromParent_Done,
      // Label 21448: @1648828
      GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1648932), // Rule ID 5628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5628,
        GIR_EraseRootFromParent_Done,
      // Label 21449: @1648932
      GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1649036), // Rule ID 5629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5629,
        GIR_EraseRootFromParent_Done,
      // Label 21450: @1649036
      GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1649140), // Rule ID 5632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5632,
        GIR_EraseRootFromParent_Done,
      // Label 21451: @1649140
      GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1649244), // Rule ID 5633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5633,
        GIR_EraseRootFromParent_Done,
      // Label 21452: @1649244
      GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1649348), // Rule ID 5636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5636,
        GIR_EraseRootFromParent_Done,
      // Label 21453: @1649348
      GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1649452), // Rule ID 5637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5637,
        GIR_EraseRootFromParent_Done,
      // Label 21454: @1649452
      GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1649556), // Rule ID 5640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5640,
        GIR_EraseRootFromParent_Done,
      // Label 21455: @1649556
      GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1649660), // Rule ID 5641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5641,
        GIR_EraseRootFromParent_Done,
      // Label 21456: @1649660
      GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1649764), // Rule ID 5644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5644,
        GIR_EraseRootFromParent_Done,
      // Label 21457: @1649764
      GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1649868), // Rule ID 5645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5645,
        GIR_EraseRootFromParent_Done,
      // Label 21458: @1649868
      GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1649972), // Rule ID 5648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5648,
        GIR_EraseRootFromParent_Done,
      // Label 21459: @1649972
      GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1650076), // Rule ID 5649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5649,
        GIR_EraseRootFromParent_Done,
      // Label 21460: @1650076
      GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1650180), // Rule ID 5652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5652,
        GIR_EraseRootFromParent_Done,
      // Label 21461: @1650180
      GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1650284), // Rule ID 5653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5653,
        GIR_EraseRootFromParent_Done,
      // Label 21462: @1650284
      GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1650388), // Rule ID 5656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5656,
        GIR_EraseRootFromParent_Done,
      // Label 21463: @1650388
      GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1650492), // Rule ID 5657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5657,
        GIR_EraseRootFromParent_Done,
      // Label 21464: @1650492
      GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1650596), // Rule ID 5660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5660,
        GIR_EraseRootFromParent_Done,
      // Label 21465: @1650596
      GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1650700), // Rule ID 5661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5661,
        GIR_EraseRootFromParent_Done,
      // Label 21466: @1650700
      GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1650804), // Rule ID 5664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5664,
        GIR_EraseRootFromParent_Done,
      // Label 21467: @1650804
      GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1650908), // Rule ID 5665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5665,
        GIR_EraseRootFromParent_Done,
      // Label 21468: @1650908
      GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1651012), // Rule ID 5668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5668,
        GIR_EraseRootFromParent_Done,
      // Label 21469: @1651012
      GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1651116), // Rule ID 5669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5669,
        GIR_EraseRootFromParent_Done,
      // Label 21470: @1651116
      GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1651220), // Rule ID 5672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5672,
        GIR_EraseRootFromParent_Done,
      // Label 21471: @1651220
      GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1651324), // Rule ID 5673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5673,
        GIR_EraseRootFromParent_Done,
      // Label 21472: @1651324
      GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1651428), // Rule ID 5676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5676,
        GIR_EraseRootFromParent_Done,
      // Label 21473: @1651428
      GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1651532), // Rule ID 5677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5677,
        GIR_EraseRootFromParent_Done,
      // Label 21474: @1651532
      GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1651636), // Rule ID 5680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5680,
        GIR_EraseRootFromParent_Done,
      // Label 21475: @1651636
      GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1651740), // Rule ID 5681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5681,
        GIR_EraseRootFromParent_Done,
      // Label 21476: @1651740
      GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1651844), // Rule ID 5684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5684,
        GIR_EraseRootFromParent_Done,
      // Label 21477: @1651844
      GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1651948), // Rule ID 5685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5685,
        GIR_EraseRootFromParent_Done,
      // Label 21478: @1651948
      GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1652052), // Rule ID 5688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5688,
        GIR_EraseRootFromParent_Done,
      // Label 21479: @1652052
      GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1652156), // Rule ID 5689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5689,
        GIR_EraseRootFromParent_Done,
      // Label 21480: @1652156
      GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1652260), // Rule ID 5692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5692,
        GIR_EraseRootFromParent_Done,
      // Label 21481: @1652260
      GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1652364), // Rule ID 5693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5693,
        GIR_EraseRootFromParent_Done,
      // Label 21482: @1652364
      GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1652468), // Rule ID 5696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5696,
        GIR_EraseRootFromParent_Done,
      // Label 21483: @1652468
      GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1652572), // Rule ID 5697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5697,
        GIR_EraseRootFromParent_Done,
      // Label 21484: @1652572
      GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1652676), // Rule ID 5700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5700,
        GIR_EraseRootFromParent_Done,
      // Label 21485: @1652676
      GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1652780), // Rule ID 5701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5701,
        GIR_EraseRootFromParent_Done,
      // Label 21486: @1652780
      GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1652884), // Rule ID 5704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5704,
        GIR_EraseRootFromParent_Done,
      // Label 21487: @1652884
      GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1652988), // Rule ID 5705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5705,
        GIR_EraseRootFromParent_Done,
      // Label 21488: @1652988
      GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1653092), // Rule ID 5708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5708,
        GIR_EraseRootFromParent_Done,
      // Label 21489: @1653092
      GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1653196), // Rule ID 5709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5709,
        GIR_EraseRootFromParent_Done,
      // Label 21490: @1653196
      GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1653300), // Rule ID 5712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5712,
        GIR_EraseRootFromParent_Done,
      // Label 21491: @1653300
      GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1653404), // Rule ID 5713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5713,
        GIR_EraseRootFromParent_Done,
      // Label 21492: @1653404
      GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1653508), // Rule ID 5716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5716,
        GIR_EraseRootFromParent_Done,
      // Label 21493: @1653508
      GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1653612), // Rule ID 5717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5717,
        GIR_EraseRootFromParent_Done,
      // Label 21494: @1653612
      GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1653716), // Rule ID 5720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5720,
        GIR_EraseRootFromParent_Done,
      // Label 21495: @1653716
      GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1653820), // Rule ID 5721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5721,
        GIR_EraseRootFromParent_Done,
      // Label 21496: @1653820
      GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1653924), // Rule ID 5724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5724,
        GIR_EraseRootFromParent_Done,
      // Label 21497: @1653924
      GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1654028), // Rule ID 5725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5725,
        GIR_EraseRootFromParent_Done,
      // Label 21498: @1654028
      GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1654132), // Rule ID 5728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5728,
        GIR_EraseRootFromParent_Done,
      // Label 21499: @1654132
      GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1654236), // Rule ID 5729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5729,
        GIR_EraseRootFromParent_Done,
      // Label 21500: @1654236
      GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1654340), // Rule ID 5732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5732,
        GIR_EraseRootFromParent_Done,
      // Label 21501: @1654340
      GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1654444), // Rule ID 5733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5733,
        GIR_EraseRootFromParent_Done,
      // Label 21502: @1654444
      GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1654548), // Rule ID 5736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5736,
        GIR_EraseRootFromParent_Done,
      // Label 21503: @1654548
      GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1654652), // Rule ID 5737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10764:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5737,
        GIR_EraseRootFromParent_Done,
      // Label 21504: @1654652
      GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1654756), // Rule ID 5740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5740,
        GIR_EraseRootFromParent_Done,
      // Label 21505: @1654756
      GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1654860), // Rule ID 5741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10764:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5741,
        GIR_EraseRootFromParent_Done,
      // Label 21506: @1654860
      GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1654964), // Rule ID 5744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5744,
        GIR_EraseRootFromParent_Done,
      // Label 21507: @1654964
      GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1655068), // Rule ID 5745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10764:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5745,
        GIR_EraseRootFromParent_Done,
      // Label 21508: @1655068
      GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1655172), // Rule ID 5748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5748,
        GIR_EraseRootFromParent_Done,
      // Label 21509: @1655172
      GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1655276), // Rule ID 5749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10764:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5749,
        GIR_EraseRootFromParent_Done,
      // Label 21510: @1655276
      GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1655380), // Rule ID 5752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5752,
        GIR_EraseRootFromParent_Done,
      // Label 21511: @1655380
      GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1655484), // Rule ID 5753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5753,
        GIR_EraseRootFromParent_Done,
      // Label 21512: @1655484
      GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1655588), // Rule ID 5756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5756,
        GIR_EraseRootFromParent_Done,
      // Label 21513: @1655588
      GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1655692), // Rule ID 5757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5757,
        GIR_EraseRootFromParent_Done,
      // Label 21514: @1655692
      GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1655796), // Rule ID 5760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5760,
        GIR_EraseRootFromParent_Done,
      // Label 21515: @1655796
      GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1655900), // Rule ID 5761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5761,
        GIR_EraseRootFromParent_Done,
      // Label 21516: @1655900
      GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1656004), // Rule ID 5764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5764,
        GIR_EraseRootFromParent_Done,
      // Label 21517: @1656004
      GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1656108), // Rule ID 5765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5765,
        GIR_EraseRootFromParent_Done,
      // Label 21518: @1656108
      GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1656212), // Rule ID 5768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5768,
        GIR_EraseRootFromParent_Done,
      // Label 21519: @1656212
      GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1656316), // Rule ID 5769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5769,
        GIR_EraseRootFromParent_Done,
      // Label 21520: @1656316
      GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1656420), // Rule ID 5772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5772,
        GIR_EraseRootFromParent_Done,
      // Label 21521: @1656420
      GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1656524), // Rule ID 5773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5773,
        GIR_EraseRootFromParent_Done,
      // Label 21522: @1656524
      GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1656628), // Rule ID 5776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5776,
        GIR_EraseRootFromParent_Done,
      // Label 21523: @1656628
      GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1656732), // Rule ID 5777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5777,
        GIR_EraseRootFromParent_Done,
      // Label 21524: @1656732
      GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1656836), // Rule ID 5780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5780,
        GIR_EraseRootFromParent_Done,
      // Label 21525: @1656836
      GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1656940), // Rule ID 5781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5781,
        GIR_EraseRootFromParent_Done,
      // Label 21526: @1656940
      GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1657044), // Rule ID 5784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5784,
        GIR_EraseRootFromParent_Done,
      // Label 21527: @1657044
      GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1657148), // Rule ID 5785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5785,
        GIR_EraseRootFromParent_Done,
      // Label 21528: @1657148
      GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1657252), // Rule ID 5788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5788,
        GIR_EraseRootFromParent_Done,
      // Label 21529: @1657252
      GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1657356), // Rule ID 5789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10764:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5789,
        GIR_EraseRootFromParent_Done,
      // Label 21530: @1657356
      GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1657460), // Rule ID 5792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5792,
        GIR_EraseRootFromParent_Done,
      // Label 21531: @1657460
      GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1657564), // Rule ID 5793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10764:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5793,
        GIR_EraseRootFromParent_Done,
      // Label 21532: @1657564
      GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1657668), // Rule ID 5796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5796,
        GIR_EraseRootFromParent_Done,
      // Label 21533: @1657668
      GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1657772), // Rule ID 5797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10764:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5797,
        GIR_EraseRootFromParent_Done,
      // Label 21534: @1657772
      GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1657876), // Rule ID 5888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5888,
        GIR_EraseRootFromParent_Done,
      // Label 21535: @1657876
      GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1657980), // Rule ID 5889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5889,
        GIR_EraseRootFromParent_Done,
      // Label 21536: @1657980
      GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1658084), // Rule ID 5892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5892,
        GIR_EraseRootFromParent_Done,
      // Label 21537: @1658084
      GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1658188), // Rule ID 5893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5893,
        GIR_EraseRootFromParent_Done,
      // Label 21538: @1658188
      GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1658292), // Rule ID 5896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5896,
        GIR_EraseRootFromParent_Done,
      // Label 21539: @1658292
      GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1658396), // Rule ID 5897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5897,
        GIR_EraseRootFromParent_Done,
      // Label 21540: @1658396
      GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1658500), // Rule ID 5900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5900,
        GIR_EraseRootFromParent_Done,
      // Label 21541: @1658500
      GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1658604), // Rule ID 5901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5901,
        GIR_EraseRootFromParent_Done,
      // Label 21542: @1658604
      GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1658708), // Rule ID 5904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5904,
        GIR_EraseRootFromParent_Done,
      // Label 21543: @1658708
      GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1658812), // Rule ID 5905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5905,
        GIR_EraseRootFromParent_Done,
      // Label 21544: @1658812
      GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1658916), // Rule ID 5908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5908,
        GIR_EraseRootFromParent_Done,
      // Label 21545: @1658916
      GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1659020), // Rule ID 5909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5909,
        GIR_EraseRootFromParent_Done,
      // Label 21546: @1659020
      GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1659124), // Rule ID 5912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5912,
        GIR_EraseRootFromParent_Done,
      // Label 21547: @1659124
      GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1659228), // Rule ID 5913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5913,
        GIR_EraseRootFromParent_Done,
      // Label 21548: @1659228
      GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1659332), // Rule ID 5916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5916,
        GIR_EraseRootFromParent_Done,
      // Label 21549: @1659332
      GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1659436), // Rule ID 5917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5917,
        GIR_EraseRootFromParent_Done,
      // Label 21550: @1659436
      GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1659540), // Rule ID 5920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5920,
        GIR_EraseRootFromParent_Done,
      // Label 21551: @1659540
      GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1659644), // Rule ID 5921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5921,
        GIR_EraseRootFromParent_Done,
      // Label 21552: @1659644
      GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1659748), // Rule ID 5924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5924,
        GIR_EraseRootFromParent_Done,
      // Label 21553: @1659748
      GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1659852), // Rule ID 5925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5925,
        GIR_EraseRootFromParent_Done,
      // Label 21554: @1659852
      GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1659956), // Rule ID 5928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5928,
        GIR_EraseRootFromParent_Done,
      // Label 21555: @1659956
      GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1660060), // Rule ID 5929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5929,
        GIR_EraseRootFromParent_Done,
      // Label 21556: @1660060
      GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1660164), // Rule ID 5932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5932,
        GIR_EraseRootFromParent_Done,
      // Label 21557: @1660164
      GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1660268), // Rule ID 5933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5933,
        GIR_EraseRootFromParent_Done,
      // Label 21558: @1660268
      GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1660372), // Rule ID 5936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5936,
        GIR_EraseRootFromParent_Done,
      // Label 21559: @1660372
      GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1660476), // Rule ID 5937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5937,
        GIR_EraseRootFromParent_Done,
      // Label 21560: @1660476
      GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1660580), // Rule ID 5940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5940,
        GIR_EraseRootFromParent_Done,
      // Label 21561: @1660580
      GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1660684), // Rule ID 5941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5941,
        GIR_EraseRootFromParent_Done,
      // Label 21562: @1660684
      GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1660788), // Rule ID 5944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5944,
        GIR_EraseRootFromParent_Done,
      // Label 21563: @1660788
      GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1660892), // Rule ID 5945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5945,
        GIR_EraseRootFromParent_Done,
      // Label 21564: @1660892
      GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1660996), // Rule ID 5948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5948,
        GIR_EraseRootFromParent_Done,
      // Label 21565: @1660996
      GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1661100), // Rule ID 5949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5949,
        GIR_EraseRootFromParent_Done,
      // Label 21566: @1661100
      GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1661204), // Rule ID 5952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5952,
        GIR_EraseRootFromParent_Done,
      // Label 21567: @1661204
      GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1661308), // Rule ID 5953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5953,
        GIR_EraseRootFromParent_Done,
      // Label 21568: @1661308
      GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1661412), // Rule ID 5956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5956,
        GIR_EraseRootFromParent_Done,
      // Label 21569: @1661412
      GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1661516), // Rule ID 5957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5957,
        GIR_EraseRootFromParent_Done,
      // Label 21570: @1661516
      GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1661620), // Rule ID 5960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5960,
        GIR_EraseRootFromParent_Done,
      // Label 21571: @1661620
      GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1661724), // Rule ID 5961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5961,
        GIR_EraseRootFromParent_Done,
      // Label 21572: @1661724
      GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1661828), // Rule ID 5964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5964,
        GIR_EraseRootFromParent_Done,
      // Label 21573: @1661828
      GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1661932), // Rule ID 5965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5965,
        GIR_EraseRootFromParent_Done,
      // Label 21574: @1661932
      GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1662036), // Rule ID 5968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5968,
        GIR_EraseRootFromParent_Done,
      // Label 21575: @1662036
      GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1662140), // Rule ID 5969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5969,
        GIR_EraseRootFromParent_Done,
      // Label 21576: @1662140
      GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1662244), // Rule ID 5972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5972,
        GIR_EraseRootFromParent_Done,
      // Label 21577: @1662244
      GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1662348), // Rule ID 5973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5973,
        GIR_EraseRootFromParent_Done,
      // Label 21578: @1662348
      GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1662452), // Rule ID 5976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5976,
        GIR_EraseRootFromParent_Done,
      // Label 21579: @1662452
      GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1662556), // Rule ID 5977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5977,
        GIR_EraseRootFromParent_Done,
      // Label 21580: @1662556
      GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1662660), // Rule ID 5980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5980,
        GIR_EraseRootFromParent_Done,
      // Label 21581: @1662660
      GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1662764), // Rule ID 5981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5981,
        GIR_EraseRootFromParent_Done,
      // Label 21582: @1662764
      GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1662868), // Rule ID 5984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5984,
        GIR_EraseRootFromParent_Done,
      // Label 21583: @1662868
      GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1662972), // Rule ID 5985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5985,
        GIR_EraseRootFromParent_Done,
      // Label 21584: @1662972
      GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1663076), // Rule ID 5988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5988,
        GIR_EraseRootFromParent_Done,
      // Label 21585: @1663076
      GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1663180), // Rule ID 5989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5989,
        GIR_EraseRootFromParent_Done,
      // Label 21586: @1663180
      GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1663284), // Rule ID 5992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5992,
        GIR_EraseRootFromParent_Done,
      // Label 21587: @1663284
      GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1663388), // Rule ID 5993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5993,
        GIR_EraseRootFromParent_Done,
      // Label 21588: @1663388
      GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1663492), // Rule ID 5996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5996,
        GIR_EraseRootFromParent_Done,
      // Label 21589: @1663492
      GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1663596), // Rule ID 5997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5997,
        GIR_EraseRootFromParent_Done,
      // Label 21590: @1663596
      GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1663700), // Rule ID 6000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6000,
        GIR_EraseRootFromParent_Done,
      // Label 21591: @1663700
      GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1663804), // Rule ID 6001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6001,
        GIR_EraseRootFromParent_Done,
      // Label 21592: @1663804
      GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1663908), // Rule ID 6004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6004,
        GIR_EraseRootFromParent_Done,
      // Label 21593: @1663908
      GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1664012), // Rule ID 6005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6005,
        GIR_EraseRootFromParent_Done,
      // Label 21594: @1664012
      GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1664116), // Rule ID 6008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6008,
        GIR_EraseRootFromParent_Done,
      // Label 21595: @1664116
      GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1664220), // Rule ID 6009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6009,
        GIR_EraseRootFromParent_Done,
      // Label 21596: @1664220
      GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1664324), // Rule ID 6012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6012,
        GIR_EraseRootFromParent_Done,
      // Label 21597: @1664324
      GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1664428), // Rule ID 6013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6013,
        GIR_EraseRootFromParent_Done,
      // Label 21598: @1664428
      GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1664532), // Rule ID 6016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6016,
        GIR_EraseRootFromParent_Done,
      // Label 21599: @1664532
      GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1664636), // Rule ID 6017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6017,
        GIR_EraseRootFromParent_Done,
      // Label 21600: @1664636
      GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1664740), // Rule ID 6020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6020,
        GIR_EraseRootFromParent_Done,
      // Label 21601: @1664740
      GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1664844), // Rule ID 6021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6021,
        GIR_EraseRootFromParent_Done,
      // Label 21602: @1664844
      GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1664948), // Rule ID 6024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6024,
        GIR_EraseRootFromParent_Done,
      // Label 21603: @1664948
      GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1665052), // Rule ID 6025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6025,
        GIR_EraseRootFromParent_Done,
      // Label 21604: @1665052
      GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1665156), // Rule ID 6028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6028,
        GIR_EraseRootFromParent_Done,
      // Label 21605: @1665156
      GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1665260), // Rule ID 6029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6029,
        GIR_EraseRootFromParent_Done,
      // Label 21606: @1665260
      GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1665364), // Rule ID 6032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6032,
        GIR_EraseRootFromParent_Done,
      // Label 21607: @1665364
      GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1665468), // Rule ID 6033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6033,
        GIR_EraseRootFromParent_Done,
      // Label 21608: @1665468
      GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1665572), // Rule ID 6036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6036,
        GIR_EraseRootFromParent_Done,
      // Label 21609: @1665572
      GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1665676), // Rule ID 6037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6037,
        GIR_EraseRootFromParent_Done,
      // Label 21610: @1665676
      GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1665780), // Rule ID 6040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6040,
        GIR_EraseRootFromParent_Done,
      // Label 21611: @1665780
      GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1665884), // Rule ID 6041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6041,
        GIR_EraseRootFromParent_Done,
      // Label 21612: @1665884
      GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1665988), // Rule ID 6044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6044,
        GIR_EraseRootFromParent_Done,
      // Label 21613: @1665988
      GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1666092), // Rule ID 6045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6045,
        GIR_EraseRootFromParent_Done,
      // Label 21614: @1666092
      GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1666196), // Rule ID 6048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6048,
        GIR_EraseRootFromParent_Done,
      // Label 21615: @1666196
      GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1666300), // Rule ID 6049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6049,
        GIR_EraseRootFromParent_Done,
      // Label 21616: @1666300
      GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1666404), // Rule ID 6052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6052,
        GIR_EraseRootFromParent_Done,
      // Label 21617: @1666404
      GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1666508), // Rule ID 6053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6053,
        GIR_EraseRootFromParent_Done,
      // Label 21618: @1666508
      GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1666612), // Rule ID 6056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6056,
        GIR_EraseRootFromParent_Done,
      // Label 21619: @1666612
      GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1666716), // Rule ID 6057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6057,
        GIR_EraseRootFromParent_Done,
      // Label 21620: @1666716
      GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1666820), // Rule ID 6060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6060,
        GIR_EraseRootFromParent_Done,
      // Label 21621: @1666820
      GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1666924), // Rule ID 6061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6061,
        GIR_EraseRootFromParent_Done,
      // Label 21622: @1666924
      GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1667028), // Rule ID 6152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6152,
        GIR_EraseRootFromParent_Done,
      // Label 21623: @1667028
      GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1667132), // Rule ID 6153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6153,
        GIR_EraseRootFromParent_Done,
      // Label 21624: @1667132
      GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1667236), // Rule ID 6156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6156,
        GIR_EraseRootFromParent_Done,
      // Label 21625: @1667236
      GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1667340), // Rule ID 6157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6157,
        GIR_EraseRootFromParent_Done,
      // Label 21626: @1667340
      GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1667444), // Rule ID 6160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6160,
        GIR_EraseRootFromParent_Done,
      // Label 21627: @1667444
      GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1667548), // Rule ID 6161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6161,
        GIR_EraseRootFromParent_Done,
      // Label 21628: @1667548
      GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1667652), // Rule ID 6164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6164,
        GIR_EraseRootFromParent_Done,
      // Label 21629: @1667652
      GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1667756), // Rule ID 6165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6165,
        GIR_EraseRootFromParent_Done,
      // Label 21630: @1667756
      GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1667860), // Rule ID 6168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6168,
        GIR_EraseRootFromParent_Done,
      // Label 21631: @1667860
      GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1667964), // Rule ID 6169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6169,
        GIR_EraseRootFromParent_Done,
      // Label 21632: @1667964
      GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1668068), // Rule ID 6172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6172,
        GIR_EraseRootFromParent_Done,
      // Label 21633: @1668068
      GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1668172), // Rule ID 6173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6173,
        GIR_EraseRootFromParent_Done,
      // Label 21634: @1668172
      GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1668276), // Rule ID 6176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6176,
        GIR_EraseRootFromParent_Done,
      // Label 21635: @1668276
      GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1668380), // Rule ID 6177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6177,
        GIR_EraseRootFromParent_Done,
      // Label 21636: @1668380
      GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1668484), // Rule ID 6180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6180,
        GIR_EraseRootFromParent_Done,
      // Label 21637: @1668484
      GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1668588), // Rule ID 6181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6181,
        GIR_EraseRootFromParent_Done,
      // Label 21638: @1668588
      GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1668692), // Rule ID 6184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6184,
        GIR_EraseRootFromParent_Done,
      // Label 21639: @1668692
      GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1668796), // Rule ID 6185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6185,
        GIR_EraseRootFromParent_Done,
      // Label 21640: @1668796
      GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1668900), // Rule ID 6188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6188,
        GIR_EraseRootFromParent_Done,
      // Label 21641: @1668900
      GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1669004), // Rule ID 6189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6189,
        GIR_EraseRootFromParent_Done,
      // Label 21642: @1669004
      GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1669108), // Rule ID 6192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6192,
        GIR_EraseRootFromParent_Done,
      // Label 21643: @1669108
      GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1669212), // Rule ID 6193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6193,
        GIR_EraseRootFromParent_Done,
      // Label 21644: @1669212
      GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1669316), // Rule ID 6196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6196,
        GIR_EraseRootFromParent_Done,
      // Label 21645: @1669316
      GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1669420), // Rule ID 6197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6197,
        GIR_EraseRootFromParent_Done,
      // Label 21646: @1669420
      GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1669524), // Rule ID 6200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6200,
        GIR_EraseRootFromParent_Done,
      // Label 21647: @1669524
      GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1669628), // Rule ID 6201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6201,
        GIR_EraseRootFromParent_Done,
      // Label 21648: @1669628
      GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1669732), // Rule ID 6204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6204,
        GIR_EraseRootFromParent_Done,
      // Label 21649: @1669732
      GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1669836), // Rule ID 6205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6205,
        GIR_EraseRootFromParent_Done,
      // Label 21650: @1669836
      GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1669940), // Rule ID 6208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6208,
        GIR_EraseRootFromParent_Done,
      // Label 21651: @1669940
      GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1670044), // Rule ID 6209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6209,
        GIR_EraseRootFromParent_Done,
      // Label 21652: @1670044
      GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1670148), // Rule ID 6212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6212,
        GIR_EraseRootFromParent_Done,
      // Label 21653: @1670148
      GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1670252), // Rule ID 6213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6213,
        GIR_EraseRootFromParent_Done,
      // Label 21654: @1670252
      GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1670356), // Rule ID 6216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6216,
        GIR_EraseRootFromParent_Done,
      // Label 21655: @1670356
      GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1670460), // Rule ID 6217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6217,
        GIR_EraseRootFromParent_Done,
      // Label 21656: @1670460
      GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1670564), // Rule ID 6220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6220,
        GIR_EraseRootFromParent_Done,
      // Label 21657: @1670564
      GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1670668), // Rule ID 6221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6221,
        GIR_EraseRootFromParent_Done,
      // Label 21658: @1670668
      GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1670772), // Rule ID 6224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6224,
        GIR_EraseRootFromParent_Done,
      // Label 21659: @1670772
      GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1670876), // Rule ID 6225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6225,
        GIR_EraseRootFromParent_Done,
      // Label 21660: @1670876
      GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1670980), // Rule ID 6228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6228,
        GIR_EraseRootFromParent_Done,
      // Label 21661: @1670980
      GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1671084), // Rule ID 6229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6229,
        GIR_EraseRootFromParent_Done,
      // Label 21662: @1671084
      GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1671188), // Rule ID 6232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6232,
        GIR_EraseRootFromParent_Done,
      // Label 21663: @1671188
      GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1671292), // Rule ID 6233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6233,
        GIR_EraseRootFromParent_Done,
      // Label 21664: @1671292
      GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1671396), // Rule ID 6236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6236,
        GIR_EraseRootFromParent_Done,
      // Label 21665: @1671396
      GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1671500), // Rule ID 6237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6237,
        GIR_EraseRootFromParent_Done,
      // Label 21666: @1671500
      GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1671604), // Rule ID 6240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6240,
        GIR_EraseRootFromParent_Done,
      // Label 21667: @1671604
      GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1671708), // Rule ID 6241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6241,
        GIR_EraseRootFromParent_Done,
      // Label 21668: @1671708
      GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1671812), // Rule ID 6244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6244,
        GIR_EraseRootFromParent_Done,
      // Label 21669: @1671812
      GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1671916), // Rule ID 6245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6245,
        GIR_EraseRootFromParent_Done,
      // Label 21670: @1671916
      GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1672020), // Rule ID 6248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6248,
        GIR_EraseRootFromParent_Done,
      // Label 21671: @1672020
      GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1672124), // Rule ID 6249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6249,
        GIR_EraseRootFromParent_Done,
      // Label 21672: @1672124
      GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1672228), // Rule ID 6252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6252,
        GIR_EraseRootFromParent_Done,
      // Label 21673: @1672228
      GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1672332), // Rule ID 6253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6253,
        GIR_EraseRootFromParent_Done,
      // Label 21674: @1672332
      GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1672436), // Rule ID 6256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6256,
        GIR_EraseRootFromParent_Done,
      // Label 21675: @1672436
      GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1672540), // Rule ID 6257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6257,
        GIR_EraseRootFromParent_Done,
      // Label 21676: @1672540
      GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1672644), // Rule ID 6260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6260,
        GIR_EraseRootFromParent_Done,
      // Label 21677: @1672644
      GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1672748), // Rule ID 6261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6261,
        GIR_EraseRootFromParent_Done,
      // Label 21678: @1672748
      GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1672852), // Rule ID 6264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6264,
        GIR_EraseRootFromParent_Done,
      // Label 21679: @1672852
      GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1672956), // Rule ID 6265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11283:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6265,
        GIR_EraseRootFromParent_Done,
      // Label 21680: @1672956
      GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1673060), // Rule ID 6268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6268,
        GIR_EraseRootFromParent_Done,
      // Label 21681: @1673060
      GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1673164), // Rule ID 6269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6269,
        GIR_EraseRootFromParent_Done,
      // Label 21682: @1673164
      GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1673268), // Rule ID 6272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6272,
        GIR_EraseRootFromParent_Done,
      // Label 21683: @1673268
      GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1673372), // Rule ID 6273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6273,
        GIR_EraseRootFromParent_Done,
      // Label 21684: @1673372
      GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1673476), // Rule ID 6276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6276,
        GIR_EraseRootFromParent_Done,
      // Label 21685: @1673476
      GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1673580), // Rule ID 6277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6277,
        GIR_EraseRootFromParent_Done,
      // Label 21686: @1673580
      GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1673684), // Rule ID 6280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6280,
        GIR_EraseRootFromParent_Done,
      // Label 21687: @1673684
      GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1673788), // Rule ID 6281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6281,
        GIR_EraseRootFromParent_Done,
      // Label 21688: @1673788
      GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1673892), // Rule ID 6284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6284,
        GIR_EraseRootFromParent_Done,
      // Label 21689: @1673892
      GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1673996), // Rule ID 6285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6285,
        GIR_EraseRootFromParent_Done,
      // Label 21690: @1673996
      GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1674100), // Rule ID 6288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6288,
        GIR_EraseRootFromParent_Done,
      // Label 21691: @1674100
      GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1674204), // Rule ID 6289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6289,
        GIR_EraseRootFromParent_Done,
      // Label 21692: @1674204
      GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1674308), // Rule ID 6292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6292,
        GIR_EraseRootFromParent_Done,
      // Label 21693: @1674308
      GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1674412), // Rule ID 6293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6293,
        GIR_EraseRootFromParent_Done,
      // Label 21694: @1674412
      GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1674516), // Rule ID 6296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6296,
        GIR_EraseRootFromParent_Done,
      // Label 21695: @1674516
      GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1674620), // Rule ID 6297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6297,
        GIR_EraseRootFromParent_Done,
      // Label 21696: @1674620
      GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1674724), // Rule ID 6300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6300,
        GIR_EraseRootFromParent_Done,
      // Label 21697: @1674724
      GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1674828), // Rule ID 6301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6301,
        GIR_EraseRootFromParent_Done,
      // Label 21698: @1674828
      GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1674932), // Rule ID 6304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6304,
        GIR_EraseRootFromParent_Done,
      // Label 21699: @1674932
      GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1675036), // Rule ID 6305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6305,
        GIR_EraseRootFromParent_Done,
      // Label 21700: @1675036
      GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1675140), // Rule ID 6308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6308,
        GIR_EraseRootFromParent_Done,
      // Label 21701: @1675140
      GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1675244), // Rule ID 6309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6309,
        GIR_EraseRootFromParent_Done,
      // Label 21702: @1675244
      GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1675348), // Rule ID 6312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6312,
        GIR_EraseRootFromParent_Done,
      // Label 21703: @1675348
      GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1675452), // Rule ID 6313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6313,
        GIR_EraseRootFromParent_Done,
      // Label 21704: @1675452
      GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1675556), // Rule ID 6316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6316,
        GIR_EraseRootFromParent_Done,
      // Label 21705: @1675556
      GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1675660), // Rule ID 6317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6317,
        GIR_EraseRootFromParent_Done,
      // Label 21706: @1675660
      GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1675764), // Rule ID 6320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6320,
        GIR_EraseRootFromParent_Done,
      // Label 21707: @1675764
      GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1675868), // Rule ID 6321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6321,
        GIR_EraseRootFromParent_Done,
      // Label 21708: @1675868
      GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1675972), // Rule ID 6324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6324,
        GIR_EraseRootFromParent_Done,
      // Label 21709: @1675972
      GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1676076), // Rule ID 6325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6325,
        GIR_EraseRootFromParent_Done,
      // Label 21710: @1676076
      GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1676180), // Rule ID 6416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6416,
        GIR_EraseRootFromParent_Done,
      // Label 21711: @1676180
      GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1676284), // Rule ID 6417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6417,
        GIR_EraseRootFromParent_Done,
      // Label 21712: @1676284
      GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1676388), // Rule ID 6420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6420,
        GIR_EraseRootFromParent_Done,
      // Label 21713: @1676388
      GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1676492), // Rule ID 6421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6421,
        GIR_EraseRootFromParent_Done,
      // Label 21714: @1676492
      GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1676596), // Rule ID 6424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6424,
        GIR_EraseRootFromParent_Done,
      // Label 21715: @1676596
      GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1676700), // Rule ID 6425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6425,
        GIR_EraseRootFromParent_Done,
      // Label 21716: @1676700
      GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1676804), // Rule ID 6428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6428,
        GIR_EraseRootFromParent_Done,
      // Label 21717: @1676804
      GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1676908), // Rule ID 6429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6429,
        GIR_EraseRootFromParent_Done,
      // Label 21718: @1676908
      GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1677012), // Rule ID 6432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6432,
        GIR_EraseRootFromParent_Done,
      // Label 21719: @1677012
      GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1677116), // Rule ID 6433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6433,
        GIR_EraseRootFromParent_Done,
      // Label 21720: @1677116
      GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1677220), // Rule ID 6436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6436,
        GIR_EraseRootFromParent_Done,
      // Label 21721: @1677220
      GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1677324), // Rule ID 6437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6437,
        GIR_EraseRootFromParent_Done,
      // Label 21722: @1677324
      GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1677428), // Rule ID 6440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6440,
        GIR_EraseRootFromParent_Done,
      // Label 21723: @1677428
      GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1677532), // Rule ID 6441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6441,
        GIR_EraseRootFromParent_Done,
      // Label 21724: @1677532
      GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1677636), // Rule ID 6444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6444,
        GIR_EraseRootFromParent_Done,
      // Label 21725: @1677636
      GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1677740), // Rule ID 6445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6445,
        GIR_EraseRootFromParent_Done,
      // Label 21726: @1677740
      GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1677844), // Rule ID 6448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6448,
        GIR_EraseRootFromParent_Done,
      // Label 21727: @1677844
      GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1677948), // Rule ID 6449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6449,
        GIR_EraseRootFromParent_Done,
      // Label 21728: @1677948
      GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1678052), // Rule ID 6452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6452,
        GIR_EraseRootFromParent_Done,
      // Label 21729: @1678052
      GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1678156), // Rule ID 6453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6453,
        GIR_EraseRootFromParent_Done,
      // Label 21730: @1678156
      GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1678260), // Rule ID 6456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6456,
        GIR_EraseRootFromParent_Done,
      // Label 21731: @1678260
      GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1678364), // Rule ID 6457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6457,
        GIR_EraseRootFromParent_Done,
      // Label 21732: @1678364
      GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1678468), // Rule ID 6460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6460,
        GIR_EraseRootFromParent_Done,
      // Label 21733: @1678468
      GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1678572), // Rule ID 6461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6461,
        GIR_EraseRootFromParent_Done,
      // Label 21734: @1678572
      GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1678676), // Rule ID 6464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6464,
        GIR_EraseRootFromParent_Done,
      // Label 21735: @1678676
      GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1678780), // Rule ID 6465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6465,
        GIR_EraseRootFromParent_Done,
      // Label 21736: @1678780
      GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1678884), // Rule ID 6468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6468,
        GIR_EraseRootFromParent_Done,
      // Label 21737: @1678884
      GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1678988), // Rule ID 6469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6469,
        GIR_EraseRootFromParent_Done,
      // Label 21738: @1678988
      GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1679092), // Rule ID 6472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6472,
        GIR_EraseRootFromParent_Done,
      // Label 21739: @1679092
      GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1679196), // Rule ID 6473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6473,
        GIR_EraseRootFromParent_Done,
      // Label 21740: @1679196
      GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1679300), // Rule ID 6476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6476,
        GIR_EraseRootFromParent_Done,
      // Label 21741: @1679300
      GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1679404), // Rule ID 6477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6477,
        GIR_EraseRootFromParent_Done,
      // Label 21742: @1679404
      GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1679508), // Rule ID 6480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6480,
        GIR_EraseRootFromParent_Done,
      // Label 21743: @1679508
      GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1679612), // Rule ID 6481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6481,
        GIR_EraseRootFromParent_Done,
      // Label 21744: @1679612
      GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1679716), // Rule ID 6484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6484,
        GIR_EraseRootFromParent_Done,
      // Label 21745: @1679716
      GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1679820), // Rule ID 6485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6485,
        GIR_EraseRootFromParent_Done,
      // Label 21746: @1679820
      GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1679924), // Rule ID 6488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6488,
        GIR_EraseRootFromParent_Done,
      // Label 21747: @1679924
      GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1680028), // Rule ID 6489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6489,
        GIR_EraseRootFromParent_Done,
      // Label 21748: @1680028
      GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1680132), // Rule ID 6492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6492,
        GIR_EraseRootFromParent_Done,
      // Label 21749: @1680132
      GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1680236), // Rule ID 6493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6493,
        GIR_EraseRootFromParent_Done,
      // Label 21750: @1680236
      GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1680340), // Rule ID 6496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6496,
        GIR_EraseRootFromParent_Done,
      // Label 21751: @1680340
      GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1680444), // Rule ID 6497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6497,
        GIR_EraseRootFromParent_Done,
      // Label 21752: @1680444
      GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1680548), // Rule ID 6500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6500,
        GIR_EraseRootFromParent_Done,
      // Label 21753: @1680548
      GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1680652), // Rule ID 6501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6501,
        GIR_EraseRootFromParent_Done,
      // Label 21754: @1680652
      GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1680756), // Rule ID 6504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6504,
        GIR_EraseRootFromParent_Done,
      // Label 21755: @1680756
      GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1680860), // Rule ID 6505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6505,
        GIR_EraseRootFromParent_Done,
      // Label 21756: @1680860
      GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1680964), // Rule ID 6508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6508,
        GIR_EraseRootFromParent_Done,
      // Label 21757: @1680964
      GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1681068), // Rule ID 6509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6509,
        GIR_EraseRootFromParent_Done,
      // Label 21758: @1681068
      GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1681172), // Rule ID 6512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6512,
        GIR_EraseRootFromParent_Done,
      // Label 21759: @1681172
      GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1681276), // Rule ID 6513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6513,
        GIR_EraseRootFromParent_Done,
      // Label 21760: @1681276
      GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1681380), // Rule ID 6516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6516,
        GIR_EraseRootFromParent_Done,
      // Label 21761: @1681380
      GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1681484), // Rule ID 6517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6517,
        GIR_EraseRootFromParent_Done,
      // Label 21762: @1681484
      GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1681588), // Rule ID 6520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6520,
        GIR_EraseRootFromParent_Done,
      // Label 21763: @1681588
      GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1681692), // Rule ID 6521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6521,
        GIR_EraseRootFromParent_Done,
      // Label 21764: @1681692
      GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1681796), // Rule ID 6524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6524,
        GIR_EraseRootFromParent_Done,
      // Label 21765: @1681796
      GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1681900), // Rule ID 6525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6525,
        GIR_EraseRootFromParent_Done,
      // Label 21766: @1681900
      GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1682004), // Rule ID 6528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6528,
        GIR_EraseRootFromParent_Done,
      // Label 21767: @1682004
      GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1682108), // Rule ID 6529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6529,
        GIR_EraseRootFromParent_Done,
      // Label 21768: @1682108
      GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1682212), // Rule ID 6532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6532,
        GIR_EraseRootFromParent_Done,
      // Label 21769: @1682212
      GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1682316), // Rule ID 6533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6533,
        GIR_EraseRootFromParent_Done,
      // Label 21770: @1682316
      GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1682420), // Rule ID 6536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6536,
        GIR_EraseRootFromParent_Done,
      // Label 21771: @1682420
      GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1682524), // Rule ID 6537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6537,
        GIR_EraseRootFromParent_Done,
      // Label 21772: @1682524
      GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1682628), // Rule ID 6540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6540,
        GIR_EraseRootFromParent_Done,
      // Label 21773: @1682628
      GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1682732), // Rule ID 6541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6541,
        GIR_EraseRootFromParent_Done,
      // Label 21774: @1682732
      GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1682836), // Rule ID 6544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6544,
        GIR_EraseRootFromParent_Done,
      // Label 21775: @1682836
      GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1682940), // Rule ID 6545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6545,
        GIR_EraseRootFromParent_Done,
      // Label 21776: @1682940
      GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1683044), // Rule ID 6548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6548,
        GIR_EraseRootFromParent_Done,
      // Label 21777: @1683044
      GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1683148), // Rule ID 6549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6549,
        GIR_EraseRootFromParent_Done,
      // Label 21778: @1683148
      GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1683252), // Rule ID 6552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6552,
        GIR_EraseRootFromParent_Done,
      // Label 21779: @1683252
      GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1683356), // Rule ID 6553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6553,
        GIR_EraseRootFromParent_Done,
      // Label 21780: @1683356
      GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1683460), // Rule ID 6556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6556,
        GIR_EraseRootFromParent_Done,
      // Label 21781: @1683460
      GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1683564), // Rule ID 6557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6557,
        GIR_EraseRootFromParent_Done,
      // Label 21782: @1683564
      GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1683668), // Rule ID 6560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6560,
        GIR_EraseRootFromParent_Done,
      // Label 21783: @1683668
      GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1683772), // Rule ID 6561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6561,
        GIR_EraseRootFromParent_Done,
      // Label 21784: @1683772
      GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1683876), // Rule ID 6564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6564,
        GIR_EraseRootFromParent_Done,
      // Label 21785: @1683876
      GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1683980), // Rule ID 6565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6565,
        GIR_EraseRootFromParent_Done,
      // Label 21786: @1683980
      GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1684084), // Rule ID 6568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6568,
        GIR_EraseRootFromParent_Done,
      // Label 21787: @1684084
      GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1684188), // Rule ID 6569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6569,
        GIR_EraseRootFromParent_Done,
      // Label 21788: @1684188
      GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1684292), // Rule ID 6572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6572,
        GIR_EraseRootFromParent_Done,
      // Label 21789: @1684292
      GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1684396), // Rule ID 6573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6573,
        GIR_EraseRootFromParent_Done,
      // Label 21790: @1684396
      GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1684500), // Rule ID 6576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6576,
        GIR_EraseRootFromParent_Done,
      // Label 21791: @1684500
      GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1684604), // Rule ID 6577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6577,
        GIR_EraseRootFromParent_Done,
      // Label 21792: @1684604
      GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1684708), // Rule ID 6580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6580,
        GIR_EraseRootFromParent_Done,
      // Label 21793: @1684708
      GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1684812), // Rule ID 6581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6581,
        GIR_EraseRootFromParent_Done,
      // Label 21794: @1684812
      GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1684916), // Rule ID 6584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6584,
        GIR_EraseRootFromParent_Done,
      // Label 21795: @1684916
      GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1685020), // Rule ID 6585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6585,
        GIR_EraseRootFromParent_Done,
      // Label 21796: @1685020
      GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1685124), // Rule ID 6588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6588,
        GIR_EraseRootFromParent_Done,
      // Label 21797: @1685124
      GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1685228), // Rule ID 6589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6589,
        GIR_EraseRootFromParent_Done,
      // Label 21798: @1685228
      GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1685332), // Rule ID 6680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6680,
        GIR_EraseRootFromParent_Done,
      // Label 21799: @1685332
      GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1685436), // Rule ID 6681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6681,
        GIR_EraseRootFromParent_Done,
      // Label 21800: @1685436
      GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1685540), // Rule ID 6684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6684,
        GIR_EraseRootFromParent_Done,
      // Label 21801: @1685540
      GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1685644), // Rule ID 6685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6685,
        GIR_EraseRootFromParent_Done,
      // Label 21802: @1685644
      GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1685748), // Rule ID 6688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6688,
        GIR_EraseRootFromParent_Done,
      // Label 21803: @1685748
      GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1685852), // Rule ID 6689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6689,
        GIR_EraseRootFromParent_Done,
      // Label 21804: @1685852
      GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1685956), // Rule ID 6692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6692,
        GIR_EraseRootFromParent_Done,
      // Label 21805: @1685956
      GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1686060), // Rule ID 6693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6693,
        GIR_EraseRootFromParent_Done,
      // Label 21806: @1686060
      GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1686164), // Rule ID 6696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6696,
        GIR_EraseRootFromParent_Done,
      // Label 21807: @1686164
      GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1686268), // Rule ID 6697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6697,
        GIR_EraseRootFromParent_Done,
      // Label 21808: @1686268
      GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1686372), // Rule ID 6700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6700,
        GIR_EraseRootFromParent_Done,
      // Label 21809: @1686372
      GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1686476), // Rule ID 6701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6701,
        GIR_EraseRootFromParent_Done,
      // Label 21810: @1686476
      GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1686580), // Rule ID 6704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6704,
        GIR_EraseRootFromParent_Done,
      // Label 21811: @1686580
      GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1686684), // Rule ID 6705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6705,
        GIR_EraseRootFromParent_Done,
      // Label 21812: @1686684
      GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1686788), // Rule ID 6708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6708,
        GIR_EraseRootFromParent_Done,
      // Label 21813: @1686788
      GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1686892), // Rule ID 6709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6709,
        GIR_EraseRootFromParent_Done,
      // Label 21814: @1686892
      GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1686996), // Rule ID 6712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6712,
        GIR_EraseRootFromParent_Done,
      // Label 21815: @1686996
      GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1687100), // Rule ID 6713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6713,
        GIR_EraseRootFromParent_Done,
      // Label 21816: @1687100
      GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1687204), // Rule ID 6716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6716,
        GIR_EraseRootFromParent_Done,
      // Label 21817: @1687204
      GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1687308), // Rule ID 6717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6717,
        GIR_EraseRootFromParent_Done,
      // Label 21818: @1687308
      GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1687412), // Rule ID 6720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6720,
        GIR_EraseRootFromParent_Done,
      // Label 21819: @1687412
      GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1687516), // Rule ID 6721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6721,
        GIR_EraseRootFromParent_Done,
      // Label 21820: @1687516
      GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1687620), // Rule ID 6724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6724,
        GIR_EraseRootFromParent_Done,
      // Label 21821: @1687620
      GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1687724), // Rule ID 6725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6725,
        GIR_EraseRootFromParent_Done,
      // Label 21822: @1687724
      GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1687828), // Rule ID 6728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6728,
        GIR_EraseRootFromParent_Done,
      // Label 21823: @1687828
      GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1687932), // Rule ID 6729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6729,
        GIR_EraseRootFromParent_Done,
      // Label 21824: @1687932
      GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1688036), // Rule ID 6732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6732,
        GIR_EraseRootFromParent_Done,
      // Label 21825: @1688036
      GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1688140), // Rule ID 6733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6733,
        GIR_EraseRootFromParent_Done,
      // Label 21826: @1688140
      GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1688244), // Rule ID 6736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6736,
        GIR_EraseRootFromParent_Done,
      // Label 21827: @1688244
      GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1688348), // Rule ID 6737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6737,
        GIR_EraseRootFromParent_Done,
      // Label 21828: @1688348
      GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1688452), // Rule ID 6740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6740,
        GIR_EraseRootFromParent_Done,
      // Label 21829: @1688452
      GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1688556), // Rule ID 6741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6741,
        GIR_EraseRootFromParent_Done,
      // Label 21830: @1688556
      GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1688660), // Rule ID 6744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6744,
        GIR_EraseRootFromParent_Done,
      // Label 21831: @1688660
      GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1688764), // Rule ID 6745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6745,
        GIR_EraseRootFromParent_Done,
      // Label 21832: @1688764
      GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1688868), // Rule ID 6748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6748,
        GIR_EraseRootFromParent_Done,
      // Label 21833: @1688868
      GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1688972), // Rule ID 6749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6749,
        GIR_EraseRootFromParent_Done,
      // Label 21834: @1688972
      GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1689076), // Rule ID 6752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6752,
        GIR_EraseRootFromParent_Done,
      // Label 21835: @1689076
      GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1689180), // Rule ID 6753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6753,
        GIR_EraseRootFromParent_Done,
      // Label 21836: @1689180
      GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1689284), // Rule ID 6756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6756,
        GIR_EraseRootFromParent_Done,
      // Label 21837: @1689284
      GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1689388), // Rule ID 6757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6757,
        GIR_EraseRootFromParent_Done,
      // Label 21838: @1689388
      GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1689492), // Rule ID 6760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6760,
        GIR_EraseRootFromParent_Done,
      // Label 21839: @1689492
      GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1689596), // Rule ID 6761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6761,
        GIR_EraseRootFromParent_Done,
      // Label 21840: @1689596
      GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1689700), // Rule ID 6764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6764,
        GIR_EraseRootFromParent_Done,
      // Label 21841: @1689700
      GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1689804), // Rule ID 6765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6765,
        GIR_EraseRootFromParent_Done,
      // Label 21842: @1689804
      GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1689908), // Rule ID 6768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6768,
        GIR_EraseRootFromParent_Done,
      // Label 21843: @1689908
      GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1690012), // Rule ID 6769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6769,
        GIR_EraseRootFromParent_Done,
      // Label 21844: @1690012
      GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1690116), // Rule ID 6772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6772,
        GIR_EraseRootFromParent_Done,
      // Label 21845: @1690116
      GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1690220), // Rule ID 6773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6773,
        GIR_EraseRootFromParent_Done,
      // Label 21846: @1690220
      GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1690324), // Rule ID 6776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6776,
        GIR_EraseRootFromParent_Done,
      // Label 21847: @1690324
      GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1690428), // Rule ID 6777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6777,
        GIR_EraseRootFromParent_Done,
      // Label 21848: @1690428
      GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1690532), // Rule ID 6780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6780,
        GIR_EraseRootFromParent_Done,
      // Label 21849: @1690532
      GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1690636), // Rule ID 6781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6781,
        GIR_EraseRootFromParent_Done,
      // Label 21850: @1690636
      GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1690740), // Rule ID 6784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6784,
        GIR_EraseRootFromParent_Done,
      // Label 21851: @1690740
      GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1690844), // Rule ID 6785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6785,
        GIR_EraseRootFromParent_Done,
      // Label 21852: @1690844
      GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1690948), // Rule ID 6788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6788,
        GIR_EraseRootFromParent_Done,
      // Label 21853: @1690948
      GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1691052), // Rule ID 6789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6789,
        GIR_EraseRootFromParent_Done,
      // Label 21854: @1691052
      GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1691156), // Rule ID 6792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6792,
        GIR_EraseRootFromParent_Done,
      // Label 21855: @1691156
      GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1691260), // Rule ID 6793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11189:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6793,
        GIR_EraseRootFromParent_Done,
      // Label 21856: @1691260
      GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1691364), // Rule ID 6796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6796,
        GIR_EraseRootFromParent_Done,
      // Label 21857: @1691364
      GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1691468), // Rule ID 6797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6797,
        GIR_EraseRootFromParent_Done,
      // Label 21858: @1691468
      GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1691572), // Rule ID 6800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6800,
        GIR_EraseRootFromParent_Done,
      // Label 21859: @1691572
      GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1691676), // Rule ID 6801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6801,
        GIR_EraseRootFromParent_Done,
      // Label 21860: @1691676
      GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1691780), // Rule ID 6804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6804,
        GIR_EraseRootFromParent_Done,
      // Label 21861: @1691780
      GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1691884), // Rule ID 6805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6805,
        GIR_EraseRootFromParent_Done,
      // Label 21862: @1691884
      GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1691988), // Rule ID 6808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6808,
        GIR_EraseRootFromParent_Done,
      // Label 21863: @1691988
      GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1692092), // Rule ID 6809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6809,
        GIR_EraseRootFromParent_Done,
      // Label 21864: @1692092
      GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1692196), // Rule ID 6812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6812,
        GIR_EraseRootFromParent_Done,
      // Label 21865: @1692196
      GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1692300), // Rule ID 6813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6813,
        GIR_EraseRootFromParent_Done,
      // Label 21866: @1692300
      GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1692404), // Rule ID 6816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6816,
        GIR_EraseRootFromParent_Done,
      // Label 21867: @1692404
      GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1692508), // Rule ID 6817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6817,
        GIR_EraseRootFromParent_Done,
      // Label 21868: @1692508
      GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1692612), // Rule ID 6820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6820,
        GIR_EraseRootFromParent_Done,
      // Label 21869: @1692612
      GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1692716), // Rule ID 6821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6821,
        GIR_EraseRootFromParent_Done,
      // Label 21870: @1692716
      GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1692820), // Rule ID 6824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6824,
        GIR_EraseRootFromParent_Done,
      // Label 21871: @1692820
      GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1692924), // Rule ID 6825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6825,
        GIR_EraseRootFromParent_Done,
      // Label 21872: @1692924
      GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1693028), // Rule ID 6828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6828,
        GIR_EraseRootFromParent_Done,
      // Label 21873: @1693028
      GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1693132), // Rule ID 6829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6829,
        GIR_EraseRootFromParent_Done,
      // Label 21874: @1693132
      GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1693236), // Rule ID 6832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6832,
        GIR_EraseRootFromParent_Done,
      // Label 21875: @1693236
      GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1693340), // Rule ID 6833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6833,
        GIR_EraseRootFromParent_Done,
      // Label 21876: @1693340
      GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1693444), // Rule ID 6836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6836,
        GIR_EraseRootFromParent_Done,
      // Label 21877: @1693444
      GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1693548), // Rule ID 6837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6837,
        GIR_EraseRootFromParent_Done,
      // Label 21878: @1693548
      GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1693652), // Rule ID 6840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6840,
        GIR_EraseRootFromParent_Done,
      // Label 21879: @1693652
      GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1693756), // Rule ID 6841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6841,
        GIR_EraseRootFromParent_Done,
      // Label 21880: @1693756
      GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1693860), // Rule ID 6844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6844,
        GIR_EraseRootFromParent_Done,
      // Label 21881: @1693860
      GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1693964), // Rule ID 6845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6845,
        GIR_EraseRootFromParent_Done,
      // Label 21882: @1693964
      GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1694068), // Rule ID 6848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6848,
        GIR_EraseRootFromParent_Done,
      // Label 21883: @1694068
      GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1694172), // Rule ID 6849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6849,
        GIR_EraseRootFromParent_Done,
      // Label 21884: @1694172
      GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1694276), // Rule ID 6852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6852,
        GIR_EraseRootFromParent_Done,
      // Label 21885: @1694276
      GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1694380), // Rule ID 6853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6853,
        GIR_EraseRootFromParent_Done,
      // Label 21886: @1694380
      GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1694484), // Rule ID 6944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6944,
        GIR_EraseRootFromParent_Done,
      // Label 21887: @1694484
      GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1694588), // Rule ID 6945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6945,
        GIR_EraseRootFromParent_Done,
      // Label 21888: @1694588
      GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1694692), // Rule ID 6948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6948,
        GIR_EraseRootFromParent_Done,
      // Label 21889: @1694692
      GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1694796), // Rule ID 6949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6949,
        GIR_EraseRootFromParent_Done,
      // Label 21890: @1694796
      GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1694900), // Rule ID 6952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6952,
        GIR_EraseRootFromParent_Done,
      // Label 21891: @1694900
      GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1695004), // Rule ID 6953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6953,
        GIR_EraseRootFromParent_Done,
      // Label 21892: @1695004
      GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1695108), // Rule ID 6956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6956,
        GIR_EraseRootFromParent_Done,
      // Label 21893: @1695108
      GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1695212), // Rule ID 6957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6957,
        GIR_EraseRootFromParent_Done,
      // Label 21894: @1695212
      GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1695316), // Rule ID 6960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6960,
        GIR_EraseRootFromParent_Done,
      // Label 21895: @1695316
      GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1695420), // Rule ID 6961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6961,
        GIR_EraseRootFromParent_Done,
      // Label 21896: @1695420
      GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1695524), // Rule ID 6964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6964,
        GIR_EraseRootFromParent_Done,
      // Label 21897: @1695524
      GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1695628), // Rule ID 6965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6965,
        GIR_EraseRootFromParent_Done,
      // Label 21898: @1695628
      GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1695732), // Rule ID 6968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6968,
        GIR_EraseRootFromParent_Done,
      // Label 21899: @1695732
      GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1695836), // Rule ID 6969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6969,
        GIR_EraseRootFromParent_Done,
      // Label 21900: @1695836
      GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1695940), // Rule ID 6972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6972,
        GIR_EraseRootFromParent_Done,
      // Label 21901: @1695940
      GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1696044), // Rule ID 6973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6973,
        GIR_EraseRootFromParent_Done,
      // Label 21902: @1696044
      GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1696148), // Rule ID 6976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6976,
        GIR_EraseRootFromParent_Done,
      // Label 21903: @1696148
      GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1696252), // Rule ID 6977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6977,
        GIR_EraseRootFromParent_Done,
      // Label 21904: @1696252
      GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1696356), // Rule ID 6980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6980,
        GIR_EraseRootFromParent_Done,
      // Label 21905: @1696356
      GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1696460), // Rule ID 6981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6981,
        GIR_EraseRootFromParent_Done,
      // Label 21906: @1696460
      GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1696564), // Rule ID 6984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6984,
        GIR_EraseRootFromParent_Done,
      // Label 21907: @1696564
      GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1696668), // Rule ID 6985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6985,
        GIR_EraseRootFromParent_Done,
      // Label 21908: @1696668
      GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1696772), // Rule ID 6988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6988,
        GIR_EraseRootFromParent_Done,
      // Label 21909: @1696772
      GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1696876), // Rule ID 6989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6989,
        GIR_EraseRootFromParent_Done,
      // Label 21910: @1696876
      GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1696980), // Rule ID 6992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6992,
        GIR_EraseRootFromParent_Done,
      // Label 21911: @1696980
      GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1697084), // Rule ID 6993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6993,
        GIR_EraseRootFromParent_Done,
      // Label 21912: @1697084
      GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1697188), // Rule ID 6996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6996,
        GIR_EraseRootFromParent_Done,
      // Label 21913: @1697188
      GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1697292), // Rule ID 6997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6997,
        GIR_EraseRootFromParent_Done,
      // Label 21914: @1697292
      GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1697396), // Rule ID 7000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7000,
        GIR_EraseRootFromParent_Done,
      // Label 21915: @1697396
      GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1697500), // Rule ID 7001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7001,
        GIR_EraseRootFromParent_Done,
      // Label 21916: @1697500
      GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1697604), // Rule ID 7004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7004,
        GIR_EraseRootFromParent_Done,
      // Label 21917: @1697604
      GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1697708), // Rule ID 7005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7005,
        GIR_EraseRootFromParent_Done,
      // Label 21918: @1697708
      GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1697812), // Rule ID 7008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7008,
        GIR_EraseRootFromParent_Done,
      // Label 21919: @1697812
      GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1697916), // Rule ID 7009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7009,
        GIR_EraseRootFromParent_Done,
      // Label 21920: @1697916
      GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1698020), // Rule ID 7012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7012,
        GIR_EraseRootFromParent_Done,
      // Label 21921: @1698020
      GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1698124), // Rule ID 7013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7013,
        GIR_EraseRootFromParent_Done,
      // Label 21922: @1698124
      GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1698228), // Rule ID 7016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7016,
        GIR_EraseRootFromParent_Done,
      // Label 21923: @1698228
      GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1698332), // Rule ID 7017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7017,
        GIR_EraseRootFromParent_Done,
      // Label 21924: @1698332
      GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1698436), // Rule ID 7020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7020,
        GIR_EraseRootFromParent_Done,
      // Label 21925: @1698436
      GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1698540), // Rule ID 7021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7021,
        GIR_EraseRootFromParent_Done,
      // Label 21926: @1698540
      GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1698644), // Rule ID 7024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7024,
        GIR_EraseRootFromParent_Done,
      // Label 21927: @1698644
      GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1698748), // Rule ID 7025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7025,
        GIR_EraseRootFromParent_Done,
      // Label 21928: @1698748
      GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1698852), // Rule ID 7028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7028,
        GIR_EraseRootFromParent_Done,
      // Label 21929: @1698852
      GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1698956), // Rule ID 7029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7029,
        GIR_EraseRootFromParent_Done,
      // Label 21930: @1698956
      GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1699060), // Rule ID 7032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7032,
        GIR_EraseRootFromParent_Done,
      // Label 21931: @1699060
      GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1699164), // Rule ID 7033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7033,
        GIR_EraseRootFromParent_Done,
      // Label 21932: @1699164
      GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1699268), // Rule ID 7036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7036,
        GIR_EraseRootFromParent_Done,
      // Label 21933: @1699268
      GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1699372), // Rule ID 7037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7037,
        GIR_EraseRootFromParent_Done,
      // Label 21934: @1699372
      GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1699476), // Rule ID 7040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7040,
        GIR_EraseRootFromParent_Done,
      // Label 21935: @1699476
      GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1699580), // Rule ID 7041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7041,
        GIR_EraseRootFromParent_Done,
      // Label 21936: @1699580
      GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1699684), // Rule ID 7044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7044,
        GIR_EraseRootFromParent_Done,
      // Label 21937: @1699684
      GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1699788), // Rule ID 7045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7045,
        GIR_EraseRootFromParent_Done,
      // Label 21938: @1699788
      GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1699892), // Rule ID 7048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7048,
        GIR_EraseRootFromParent_Done,
      // Label 21939: @1699892
      GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1699996), // Rule ID 7049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7049,
        GIR_EraseRootFromParent_Done,
      // Label 21940: @1699996
      GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1700100), // Rule ID 7052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7052,
        GIR_EraseRootFromParent_Done,
      // Label 21941: @1700100
      GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1700204), // Rule ID 7053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7053,
        GIR_EraseRootFromParent_Done,
      // Label 21942: @1700204
      GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1700308), // Rule ID 7056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7056,
        GIR_EraseRootFromParent_Done,
      // Label 21943: @1700308
      GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1700412), // Rule ID 7057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11187:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7057,
        GIR_EraseRootFromParent_Done,
      // Label 21944: @1700412
      GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1700516), // Rule ID 7060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7060,
        GIR_EraseRootFromParent_Done,
      // Label 21945: @1700516
      GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1700620), // Rule ID 7061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7061,
        GIR_EraseRootFromParent_Done,
      // Label 21946: @1700620
      GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1700724), // Rule ID 7064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7064,
        GIR_EraseRootFromParent_Done,
      // Label 21947: @1700724
      GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1700828), // Rule ID 7065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7065,
        GIR_EraseRootFromParent_Done,
      // Label 21948: @1700828
      GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1700932), // Rule ID 7068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7068,
        GIR_EraseRootFromParent_Done,
      // Label 21949: @1700932
      GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1701036), // Rule ID 7069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7069,
        GIR_EraseRootFromParent_Done,
      // Label 21950: @1701036
      GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1701140), // Rule ID 7072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7072,
        GIR_EraseRootFromParent_Done,
      // Label 21951: @1701140
      GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1701244), // Rule ID 7073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7073,
        GIR_EraseRootFromParent_Done,
      // Label 21952: @1701244
      GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1701348), // Rule ID 7076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7076,
        GIR_EraseRootFromParent_Done,
      // Label 21953: @1701348
      GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1701452), // Rule ID 7077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7077,
        GIR_EraseRootFromParent_Done,
      // Label 21954: @1701452
      GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1701556), // Rule ID 7080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7080,
        GIR_EraseRootFromParent_Done,
      // Label 21955: @1701556
      GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1701660), // Rule ID 7081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7081,
        GIR_EraseRootFromParent_Done,
      // Label 21956: @1701660
      GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1701764), // Rule ID 7084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7084,
        GIR_EraseRootFromParent_Done,
      // Label 21957: @1701764
      GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1701868), // Rule ID 7085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7085,
        GIR_EraseRootFromParent_Done,
      // Label 21958: @1701868
      GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1701972), // Rule ID 7088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7088,
        GIR_EraseRootFromParent_Done,
      // Label 21959: @1701972
      GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1702076), // Rule ID 7089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7089,
        GIR_EraseRootFromParent_Done,
      // Label 21960: @1702076
      GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1702180), // Rule ID 7092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7092,
        GIR_EraseRootFromParent_Done,
      // Label 21961: @1702180
      GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1702284), // Rule ID 7093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7093,
        GIR_EraseRootFromParent_Done,
      // Label 21962: @1702284
      GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1702388), // Rule ID 7096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7096,
        GIR_EraseRootFromParent_Done,
      // Label 21963: @1702388
      GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1702492), // Rule ID 7097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7097,
        GIR_EraseRootFromParent_Done,
      // Label 21964: @1702492
      GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1702596), // Rule ID 7100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7100,
        GIR_EraseRootFromParent_Done,
      // Label 21965: @1702596
      GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1702700), // Rule ID 7101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7101,
        GIR_EraseRootFromParent_Done,
      // Label 21966: @1702700
      GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1702804), // Rule ID 7104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7104,
        GIR_EraseRootFromParent_Done,
      // Label 21967: @1702804
      GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1702908), // Rule ID 7105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7105,
        GIR_EraseRootFromParent_Done,
      // Label 21968: @1702908
      GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1703012), // Rule ID 7108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7108,
        GIR_EraseRootFromParent_Done,
      // Label 21969: @1703012
      GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1703116), // Rule ID 7109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7109,
        GIR_EraseRootFromParent_Done,
      // Label 21970: @1703116
      GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1703220), // Rule ID 7112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7112,
        GIR_EraseRootFromParent_Done,
      // Label 21971: @1703220
      GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1703324), // Rule ID 7113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7113,
        GIR_EraseRootFromParent_Done,
      // Label 21972: @1703324
      GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1703428), // Rule ID 7116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7116,
        GIR_EraseRootFromParent_Done,
      // Label 21973: @1703428
      GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1703532), // Rule ID 7117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7117,
        GIR_EraseRootFromParent_Done,
      // Label 21974: @1703532
      GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1703636), // Rule ID 7296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7296,
        GIR_EraseRootFromParent_Done,
      // Label 21975: @1703636
      GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1703740), // Rule ID 7297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7297,
        GIR_EraseRootFromParent_Done,
      // Label 21976: @1703740
      GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1703844), // Rule ID 7300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7300,
        GIR_EraseRootFromParent_Done,
      // Label 21977: @1703844
      GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1703948), // Rule ID 7301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7301,
        GIR_EraseRootFromParent_Done,
      // Label 21978: @1703948
      GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1704052), // Rule ID 7304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7304,
        GIR_EraseRootFromParent_Done,
      // Label 21979: @1704052
      GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1704156), // Rule ID 7305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7305,
        GIR_EraseRootFromParent_Done,
      // Label 21980: @1704156
      GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1704260), // Rule ID 7308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7308,
        GIR_EraseRootFromParent_Done,
      // Label 21981: @1704260
      GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1704364), // Rule ID 7309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7309,
        GIR_EraseRootFromParent_Done,
      // Label 21982: @1704364
      GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1704468), // Rule ID 7312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7312,
        GIR_EraseRootFromParent_Done,
      // Label 21983: @1704468
      GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1704572), // Rule ID 7313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7313,
        GIR_EraseRootFromParent_Done,
      // Label 21984: @1704572
      GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1704676), // Rule ID 7316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7316,
        GIR_EraseRootFromParent_Done,
      // Label 21985: @1704676
      GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1704780), // Rule ID 7317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7317,
        GIR_EraseRootFromParent_Done,
      // Label 21986: @1704780
      GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1704884), // Rule ID 7320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7320,
        GIR_EraseRootFromParent_Done,
      // Label 21987: @1704884
      GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1704988), // Rule ID 7321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7321,
        GIR_EraseRootFromParent_Done,
      // Label 21988: @1704988
      GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1705092), // Rule ID 7324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7324,
        GIR_EraseRootFromParent_Done,
      // Label 21989: @1705092
      GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1705196), // Rule ID 7325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7325,
        GIR_EraseRootFromParent_Done,
      // Label 21990: @1705196
      GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1705300), // Rule ID 7328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7328,
        GIR_EraseRootFromParent_Done,
      // Label 21991: @1705300
      GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1705404), // Rule ID 7329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7329,
        GIR_EraseRootFromParent_Done,
      // Label 21992: @1705404
      GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1705508), // Rule ID 7332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7332,
        GIR_EraseRootFromParent_Done,
      // Label 21993: @1705508
      GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1705612), // Rule ID 7333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7333,
        GIR_EraseRootFromParent_Done,
      // Label 21994: @1705612
      GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1705716), // Rule ID 7336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7336,
        GIR_EraseRootFromParent_Done,
      // Label 21995: @1705716
      GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1705820), // Rule ID 7337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7337,
        GIR_EraseRootFromParent_Done,
      // Label 21996: @1705820
      GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1705924), // Rule ID 7340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7340,
        GIR_EraseRootFromParent_Done,
      // Label 21997: @1705924
      GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1706028), // Rule ID 7341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7341,
        GIR_EraseRootFromParent_Done,
      // Label 21998: @1706028
      GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1706132), // Rule ID 7344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7344,
        GIR_EraseRootFromParent_Done,
      // Label 21999: @1706132
      GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1706236), // Rule ID 7345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7345,
        GIR_EraseRootFromParent_Done,
      // Label 22000: @1706236
      GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1706340), // Rule ID 7348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7348,
        GIR_EraseRootFromParent_Done,
      // Label 22001: @1706340
      GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1706444), // Rule ID 7349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7349,
        GIR_EraseRootFromParent_Done,
      // Label 22002: @1706444
      GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1706548), // Rule ID 7352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7352,
        GIR_EraseRootFromParent_Done,
      // Label 22003: @1706548
      GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1706652), // Rule ID 7353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7353,
        GIR_EraseRootFromParent_Done,
      // Label 22004: @1706652
      GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1706756), // Rule ID 7356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7356,
        GIR_EraseRootFromParent_Done,
      // Label 22005: @1706756
      GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1706860), // Rule ID 7357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7357,
        GIR_EraseRootFromParent_Done,
      // Label 22006: @1706860
      GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1706964), // Rule ID 7360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7360,
        GIR_EraseRootFromParent_Done,
      // Label 22007: @1706964
      GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1707068), // Rule ID 7361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7361,
        GIR_EraseRootFromParent_Done,
      // Label 22008: @1707068
      GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1707172), // Rule ID 7364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7364,
        GIR_EraseRootFromParent_Done,
      // Label 22009: @1707172
      GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1707276), // Rule ID 7365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7365,
        GIR_EraseRootFromParent_Done,
      // Label 22010: @1707276
      GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1707380), // Rule ID 7368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7368,
        GIR_EraseRootFromParent_Done,
      // Label 22011: @1707380
      GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1707484), // Rule ID 7369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7369,
        GIR_EraseRootFromParent_Done,
      // Label 22012: @1707484
      GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1707588), // Rule ID 7372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7372,
        GIR_EraseRootFromParent_Done,
      // Label 22013: @1707588
      GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1707692), // Rule ID 7373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7373,
        GIR_EraseRootFromParent_Done,
      // Label 22014: @1707692
      GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1707796), // Rule ID 7376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7376,
        GIR_EraseRootFromParent_Done,
      // Label 22015: @1707796
      GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1707900), // Rule ID 7377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7377,
        GIR_EraseRootFromParent_Done,
      // Label 22016: @1707900
      GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1708004), // Rule ID 7380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7380,
        GIR_EraseRootFromParent_Done,
      // Label 22017: @1708004
      GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1708108), // Rule ID 7381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7381,
        GIR_EraseRootFromParent_Done,
      // Label 22018: @1708108
      GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1708212), // Rule ID 7384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7384,
        GIR_EraseRootFromParent_Done,
      // Label 22019: @1708212
      GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1708316), // Rule ID 7385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7385,
        GIR_EraseRootFromParent_Done,
      // Label 22020: @1708316
      GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1708420), // Rule ID 7388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7388,
        GIR_EraseRootFromParent_Done,
      // Label 22021: @1708420
      GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1708524), // Rule ID 7389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7389,
        GIR_EraseRootFromParent_Done,
      // Label 22022: @1708524
      GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1708628), // Rule ID 7392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7392,
        GIR_EraseRootFromParent_Done,
      // Label 22023: @1708628
      GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1708732), // Rule ID 7393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7393,
        GIR_EraseRootFromParent_Done,
      // Label 22024: @1708732
      GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1708836), // Rule ID 7396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7396,
        GIR_EraseRootFromParent_Done,
      // Label 22025: @1708836
      GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1708940), // Rule ID 7397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7397,
        GIR_EraseRootFromParent_Done,
      // Label 22026: @1708940
      GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1709044), // Rule ID 7400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7400,
        GIR_EraseRootFromParent_Done,
      // Label 22027: @1709044
      GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1709148), // Rule ID 7401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7401,
        GIR_EraseRootFromParent_Done,
      // Label 22028: @1709148
      GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1709252), // Rule ID 7404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7404,
        GIR_EraseRootFromParent_Done,
      // Label 22029: @1709252
      GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1709356), // Rule ID 7405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7405,
        GIR_EraseRootFromParent_Done,
      // Label 22030: @1709356
      GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1709460), // Rule ID 7408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7408,
        GIR_EraseRootFromParent_Done,
      // Label 22031: @1709460
      GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1709564), // Rule ID 7409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7409,
        GIR_EraseRootFromParent_Done,
      // Label 22032: @1709564
      GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1709668), // Rule ID 7412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7412,
        GIR_EraseRootFromParent_Done,
      // Label 22033: @1709668
      GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1709772), // Rule ID 7413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7413,
        GIR_EraseRootFromParent_Done,
      // Label 22034: @1709772
      GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1709876), // Rule ID 7476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7476,
        GIR_EraseRootFromParent_Done,
      // Label 22035: @1709876
      GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1709980), // Rule ID 7477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7477,
        GIR_EraseRootFromParent_Done,
      // Label 22036: @1709980
      GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1710084), // Rule ID 7480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7480,
        GIR_EraseRootFromParent_Done,
      // Label 22037: @1710084
      GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1710188), // Rule ID 7481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7481,
        GIR_EraseRootFromParent_Done,
      // Label 22038: @1710188
      GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1710292), // Rule ID 7484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7484,
        GIR_EraseRootFromParent_Done,
      // Label 22039: @1710292
      GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1710396), // Rule ID 7485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7485,
        GIR_EraseRootFromParent_Done,
      // Label 22040: @1710396
      GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1710500), // Rule ID 7488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7488,
        GIR_EraseRootFromParent_Done,
      // Label 22041: @1710500
      GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1710604), // Rule ID 7489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7489,
        GIR_EraseRootFromParent_Done,
      // Label 22042: @1710604
      GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1710708), // Rule ID 7492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7492,
        GIR_EraseRootFromParent_Done,
      // Label 22043: @1710708
      GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1710812), // Rule ID 7493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7493,
        GIR_EraseRootFromParent_Done,
      // Label 22044: @1710812
      GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1710916), // Rule ID 7496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7496,
        GIR_EraseRootFromParent_Done,
      // Label 22045: @1710916
      GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1711020), // Rule ID 7497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7497,
        GIR_EraseRootFromParent_Done,
      // Label 22046: @1711020
      GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1711124), // Rule ID 7500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7500,
        GIR_EraseRootFromParent_Done,
      // Label 22047: @1711124
      GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1711228), // Rule ID 7501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7501,
        GIR_EraseRootFromParent_Done,
      // Label 22048: @1711228
      GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1711332), // Rule ID 7504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7504,
        GIR_EraseRootFromParent_Done,
      // Label 22049: @1711332
      GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1711436), // Rule ID 7505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7505,
        GIR_EraseRootFromParent_Done,
      // Label 22050: @1711436
      GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1711540), // Rule ID 7508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7508,
        GIR_EraseRootFromParent_Done,
      // Label 22051: @1711540
      GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1711644), // Rule ID 7509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7509,
        GIR_EraseRootFromParent_Done,
      // Label 22052: @1711644
      GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1711748), // Rule ID 7512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7512,
        GIR_EraseRootFromParent_Done,
      // Label 22053: @1711748
      GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1711852), // Rule ID 7513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7513,
        GIR_EraseRootFromParent_Done,
      // Label 22054: @1711852
      GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1711956), // Rule ID 7516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7516,
        GIR_EraseRootFromParent_Done,
      // Label 22055: @1711956
      GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1712060), // Rule ID 7517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7517,
        GIR_EraseRootFromParent_Done,
      // Label 22056: @1712060
      GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1712164), // Rule ID 7520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7520,
        GIR_EraseRootFromParent_Done,
      // Label 22057: @1712164
      GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1712268), // Rule ID 7521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7521,
        GIR_EraseRootFromParent_Done,
      // Label 22058: @1712268
      GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1712372), // Rule ID 7524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7524,
        GIR_EraseRootFromParent_Done,
      // Label 22059: @1712372
      GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1712476), // Rule ID 7525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7525,
        GIR_EraseRootFromParent_Done,
      // Label 22060: @1712476
      GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1712580), // Rule ID 7528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7528,
        GIR_EraseRootFromParent_Done,
      // Label 22061: @1712580
      GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1712684), // Rule ID 7529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7529,
        GIR_EraseRootFromParent_Done,
      // Label 22062: @1712684
      GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1712788), // Rule ID 7532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7532,
        GIR_EraseRootFromParent_Done,
      // Label 22063: @1712788
      GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1712892), // Rule ID 7533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7533,
        GIR_EraseRootFromParent_Done,
      // Label 22064: @1712892
      GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1712996), // Rule ID 7536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7536,
        GIR_EraseRootFromParent_Done,
      // Label 22065: @1712996
      GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1713100), // Rule ID 7537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7537,
        GIR_EraseRootFromParent_Done,
      // Label 22066: @1713100
      GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1713204), // Rule ID 7540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7540,
        GIR_EraseRootFromParent_Done,
      // Label 22067: @1713204
      GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1713308), // Rule ID 7541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7541,
        GIR_EraseRootFromParent_Done,
      // Label 22068: @1713308
      GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1713412), // Rule ID 7544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7544,
        GIR_EraseRootFromParent_Done,
      // Label 22069: @1713412
      GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1713516), // Rule ID 7545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7545,
        GIR_EraseRootFromParent_Done,
      // Label 22070: @1713516
      GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1713620), // Rule ID 7548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7548,
        GIR_EraseRootFromParent_Done,
      // Label 22071: @1713620
      GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1713724), // Rule ID 7549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7549,
        GIR_EraseRootFromParent_Done,
      // Label 22072: @1713724
      GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1713828), // Rule ID 7552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7552,
        GIR_EraseRootFromParent_Done,
      // Label 22073: @1713828
      GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1713932), // Rule ID 7553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7553,
        GIR_EraseRootFromParent_Done,
      // Label 22074: @1713932
      GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1714036), // Rule ID 7556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7556,
        GIR_EraseRootFromParent_Done,
      // Label 22075: @1714036
      GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1714140), // Rule ID 7557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7557,
        GIR_EraseRootFromParent_Done,
      // Label 22076: @1714140
      GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1714244), // Rule ID 7560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7560,
        GIR_EraseRootFromParent_Done,
      // Label 22077: @1714244
      GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1714348), // Rule ID 7561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7561,
        GIR_EraseRootFromParent_Done,
      // Label 22078: @1714348
      GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1714452), // Rule ID 7564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7564,
        GIR_EraseRootFromParent_Done,
      // Label 22079: @1714452
      GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1714556), // Rule ID 7565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7565,
        GIR_EraseRootFromParent_Done,
      // Label 22080: @1714556
      GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1714660), // Rule ID 7568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7568,
        GIR_EraseRootFromParent_Done,
      // Label 22081: @1714660
      GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1714764), // Rule ID 7569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7569,
        GIR_EraseRootFromParent_Done,
      // Label 22082: @1714764
      GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1714868), // Rule ID 7572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7572,
        GIR_EraseRootFromParent_Done,
      // Label 22083: @1714868
      GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1714972), // Rule ID 7573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7573,
        GIR_EraseRootFromParent_Done,
      // Label 22084: @1714972
      GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1715076), // Rule ID 7576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7576,
        GIR_EraseRootFromParent_Done,
      // Label 22085: @1715076
      GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1715180), // Rule ID 7577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7577,
        GIR_EraseRootFromParent_Done,
      // Label 22086: @1715180
      GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1715284), // Rule ID 7580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7580,
        GIR_EraseRootFromParent_Done,
      // Label 22087: @1715284
      GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1715388), // Rule ID 7581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7581,
        GIR_EraseRootFromParent_Done,
      // Label 22088: @1715388
      GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1715492), // Rule ID 7584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7584,
        GIR_EraseRootFromParent_Done,
      // Label 22089: @1715492
      GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1715596), // Rule ID 7585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7585,
        GIR_EraseRootFromParent_Done,
      // Label 22090: @1715596
      GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1715700), // Rule ID 7588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7588,
        GIR_EraseRootFromParent_Done,
      // Label 22091: @1715700
      GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1715804), // Rule ID 7589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7589,
        GIR_EraseRootFromParent_Done,
      // Label 22092: @1715804
      GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1715908), // Rule ID 7592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7592,
        GIR_EraseRootFromParent_Done,
      // Label 22093: @1715908
      GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1716012), // Rule ID 7593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7593,
        GIR_EraseRootFromParent_Done,
      // Label 22094: @1716012
      GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1716116), // Rule ID 10108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10108,
        GIR_EraseRootFromParent_Done,
      // Label 22095: @1716116
      GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1716220), // Rule ID 10109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10109,
        GIR_EraseRootFromParent_Done,
      // Label 22096: @1716220
      GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1716324), // Rule ID 10112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10112,
        GIR_EraseRootFromParent_Done,
      // Label 22097: @1716324
      GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1716428), // Rule ID 10113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10113,
        GIR_EraseRootFromParent_Done,
      // Label 22098: @1716428
      GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1716532), // Rule ID 10116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10116,
        GIR_EraseRootFromParent_Done,
      // Label 22099: @1716532
      GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1716636), // Rule ID 10117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10117,
        GIR_EraseRootFromParent_Done,
      // Label 22100: @1716636
      GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1716740), // Rule ID 10120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10120,
        GIR_EraseRootFromParent_Done,
      // Label 22101: @1716740
      GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1716844), // Rule ID 10121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10121,
        GIR_EraseRootFromParent_Done,
      // Label 22102: @1716844
      GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1716948), // Rule ID 10124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10124,
        GIR_EraseRootFromParent_Done,
      // Label 22103: @1716948
      GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1717052), // Rule ID 10125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10125,
        GIR_EraseRootFromParent_Done,
      // Label 22104: @1717052
      GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1717156), // Rule ID 10128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10128,
        GIR_EraseRootFromParent_Done,
      // Label 22105: @1717156
      GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1717260), // Rule ID 10129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10129,
        GIR_EraseRootFromParent_Done,
      // Label 22106: @1717260
      GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1717364), // Rule ID 10132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10132,
        GIR_EraseRootFromParent_Done,
      // Label 22107: @1717364
      GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1717468), // Rule ID 10133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10133,
        GIR_EraseRootFromParent_Done,
      // Label 22108: @1717468
      GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1717572), // Rule ID 10136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10136,
        GIR_EraseRootFromParent_Done,
      // Label 22109: @1717572
      GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1717676), // Rule ID 10137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10137,
        GIR_EraseRootFromParent_Done,
      // Label 22110: @1717676
      GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1717780), // Rule ID 10140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10140,
        GIR_EraseRootFromParent_Done,
      // Label 22111: @1717780
      GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1717884), // Rule ID 10141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10141,
        GIR_EraseRootFromParent_Done,
      // Label 22112: @1717884
      GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1717988), // Rule ID 10144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10144,
        GIR_EraseRootFromParent_Done,
      // Label 22113: @1717988
      GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1718092), // Rule ID 10145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10145,
        GIR_EraseRootFromParent_Done,
      // Label 22114: @1718092
      GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1718196), // Rule ID 10148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10148,
        GIR_EraseRootFromParent_Done,
      // Label 22115: @1718196
      GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1718300), // Rule ID 10149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10149,
        GIR_EraseRootFromParent_Done,
      // Label 22116: @1718300
      GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1718404), // Rule ID 10152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10152,
        GIR_EraseRootFromParent_Done,
      // Label 22117: @1718404
      GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1718508), // Rule ID 10153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10153,
        GIR_EraseRootFromParent_Done,
      // Label 22118: @1718508
      GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1718612), // Rule ID 10156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10156,
        GIR_EraseRootFromParent_Done,
      // Label 22119: @1718612
      GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1718716), // Rule ID 10157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10157,
        GIR_EraseRootFromParent_Done,
      // Label 22120: @1718716
      GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1718820), // Rule ID 10160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10160,
        GIR_EraseRootFromParent_Done,
      // Label 22121: @1718820
      GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1718924), // Rule ID 10161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10161,
        GIR_EraseRootFromParent_Done,
      // Label 22122: @1718924
      GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1719028), // Rule ID 10164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10164,
        GIR_EraseRootFromParent_Done,
      // Label 22123: @1719028
      GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1719132), // Rule ID 10165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10165,
        GIR_EraseRootFromParent_Done,
      // Label 22124: @1719132
      GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1719236), // Rule ID 10168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10168,
        GIR_EraseRootFromParent_Done,
      // Label 22125: @1719236
      GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1719340), // Rule ID 10169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10169,
        GIR_EraseRootFromParent_Done,
      // Label 22126: @1719340
      GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1719444), // Rule ID 10172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10172,
        GIR_EraseRootFromParent_Done,
      // Label 22127: @1719444
      GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1719548), // Rule ID 10173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10173,
        GIR_EraseRootFromParent_Done,
      // Label 22128: @1719548
      GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1719652), // Rule ID 10176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10176,
        GIR_EraseRootFromParent_Done,
      // Label 22129: @1719652
      GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1719756), // Rule ID 10177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10177,
        GIR_EraseRootFromParent_Done,
      // Label 22130: @1719756
      GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1719860), // Rule ID 10180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10180,
        GIR_EraseRootFromParent_Done,
      // Label 22131: @1719860
      GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1719964), // Rule ID 10181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10181,
        GIR_EraseRootFromParent_Done,
      // Label 22132: @1719964
      GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1720068), // Rule ID 10184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10184,
        GIR_EraseRootFromParent_Done,
      // Label 22133: @1720068
      GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1720172), // Rule ID 10185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10185,
        GIR_EraseRootFromParent_Done,
      // Label 22134: @1720172
      GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1720276), // Rule ID 10188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10188,
        GIR_EraseRootFromParent_Done,
      // Label 22135: @1720276
      GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1720380), // Rule ID 10189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10189,
        GIR_EraseRootFromParent_Done,
      // Label 22136: @1720380
      GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1720484), // Rule ID 10192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10192,
        GIR_EraseRootFromParent_Done,
      // Label 22137: @1720484
      GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1720588), // Rule ID 10193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10193,
        GIR_EraseRootFromParent_Done,
      // Label 22138: @1720588
      GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1720692), // Rule ID 10196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10196,
        GIR_EraseRootFromParent_Done,
      // Label 22139: @1720692
      GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1720796), // Rule ID 10197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10197,
        GIR_EraseRootFromParent_Done,
      // Label 22140: @1720796
      GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1720900), // Rule ID 10200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10200,
        GIR_EraseRootFromParent_Done,
      // Label 22141: @1720900
      GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1721004), // Rule ID 10201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10201,
        GIR_EraseRootFromParent_Done,
      // Label 22142: @1721004
      GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1721108), // Rule ID 10204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10204,
        GIR_EraseRootFromParent_Done,
      // Label 22143: @1721108
      GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1721212), // Rule ID 10205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10205,
        GIR_EraseRootFromParent_Done,
      // Label 22144: @1721212
      GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1721316), // Rule ID 10208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10208,
        GIR_EraseRootFromParent_Done,
      // Label 22145: @1721316
      GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1721420), // Rule ID 10209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10209,
        GIR_EraseRootFromParent_Done,
      // Label 22146: @1721420
      GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1721524), // Rule ID 10212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10212,
        GIR_EraseRootFromParent_Done,
      // Label 22147: @1721524
      GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1721628), // Rule ID 10213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10213,
        GIR_EraseRootFromParent_Done,
      // Label 22148: @1721628
      GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1721732), // Rule ID 10216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10216,
        GIR_EraseRootFromParent_Done,
      // Label 22149: @1721732
      GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1721836), // Rule ID 10217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10217,
        GIR_EraseRootFromParent_Done,
      // Label 22150: @1721836
      GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1721940), // Rule ID 10220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10220,
        GIR_EraseRootFromParent_Done,
      // Label 22151: @1721940
      GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1722044), // Rule ID 10221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11042:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10221,
        GIR_EraseRootFromParent_Done,
      // Label 22152: @1722044
      GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1722148), // Rule ID 10224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10224,
        GIR_EraseRootFromParent_Done,
      // Label 22153: @1722148
      GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1722252), // Rule ID 10225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11042:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10225,
        GIR_EraseRootFromParent_Done,
      // Label 22154: @1722252
      GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1722356), // Rule ID 10228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10228,
        GIR_EraseRootFromParent_Done,
      // Label 22155: @1722356
      GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1722460), // Rule ID 10229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10229,
        GIR_EraseRootFromParent_Done,
      // Label 22156: @1722460
      GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1722564), // Rule ID 10232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10232,
        GIR_EraseRootFromParent_Done,
      // Label 22157: @1722564
      GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1722668), // Rule ID 10233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11042:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10233,
        GIR_EraseRootFromParent_Done,
      // Label 22158: @1722668
      GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1722772), // Rule ID 10236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10236,
        GIR_EraseRootFromParent_Done,
      // Label 22159: @1722772
      GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1722876), // Rule ID 10237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10237,
        GIR_EraseRootFromParent_Done,
      // Label 22160: @1722876
      GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1722980), // Rule ID 10240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10240,
        GIR_EraseRootFromParent_Done,
      // Label 22161: @1722980
      GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1723084), // Rule ID 10241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10241,
        GIR_EraseRootFromParent_Done,
      // Label 22162: @1723084
      GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1723188), // Rule ID 10244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10244,
        GIR_EraseRootFromParent_Done,
      // Label 22163: @1723188
      GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1723292), // Rule ID 10245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10245,
        GIR_EraseRootFromParent_Done,
      // Label 22164: @1723292
      GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1723396), // Rule ID 10248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10248,
        GIR_EraseRootFromParent_Done,
      // Label 22165: @1723396
      GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1723500), // Rule ID 10249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10249,
        GIR_EraseRootFromParent_Done,
      // Label 22166: @1723500
      GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1723604), // Rule ID 10252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10252,
        GIR_EraseRootFromParent_Done,
      // Label 22167: @1723604
      GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1723708), // Rule ID 10253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10253,
        GIR_EraseRootFromParent_Done,
      // Label 22168: @1723708
      GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1723812), // Rule ID 10256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10256,
        GIR_EraseRootFromParent_Done,
      // Label 22169: @1723812
      GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1723916), // Rule ID 10257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10257,
        GIR_EraseRootFromParent_Done,
      // Label 22170: @1723916
      GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1724020), // Rule ID 10260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10260,
        GIR_EraseRootFromParent_Done,
      // Label 22171: @1724020
      GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1724124), // Rule ID 10261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10261,
        GIR_EraseRootFromParent_Done,
      // Label 22172: @1724124
      GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1724228), // Rule ID 10264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10264,
        GIR_EraseRootFromParent_Done,
      // Label 22173: @1724228
      GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1724332), // Rule ID 10265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10265,
        GIR_EraseRootFromParent_Done,
      // Label 22174: @1724332
      GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1724436), // Rule ID 10268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10268,
        GIR_EraseRootFromParent_Done,
      // Label 22175: @1724436
      GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1724540), // Rule ID 10269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10269,
        GIR_EraseRootFromParent_Done,
      // Label 22176: @1724540
      GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1724644), // Rule ID 10272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10272,
        GIR_EraseRootFromParent_Done,
      // Label 22177: @1724644
      GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1724748), // Rule ID 10273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10273,
        GIR_EraseRootFromParent_Done,
      // Label 22178: @1724748
      GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1724852), // Rule ID 10276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10276,
        GIR_EraseRootFromParent_Done,
      // Label 22179: @1724852
      GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1724956), // Rule ID 10277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10277,
        GIR_EraseRootFromParent_Done,
      // Label 22180: @1724956
      GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1725060), // Rule ID 10280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10280,
        GIR_EraseRootFromParent_Done,
      // Label 22181: @1725060
      GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1725164), // Rule ID 10281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10281,
        GIR_EraseRootFromParent_Done,
      // Label 22182: @1725164
      GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1725268), // Rule ID 10284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10284,
        GIR_EraseRootFromParent_Done,
      // Label 22183: @1725268
      GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1725372), // Rule ID 10285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10285,
        GIR_EraseRootFromParent_Done,
      // Label 22184: @1725372
      GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1725476), // Rule ID 10288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10288,
        GIR_EraseRootFromParent_Done,
      // Label 22185: @1725476
      GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1725580), // Rule ID 10289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10289,
        GIR_EraseRootFromParent_Done,
      // Label 22186: @1725580
      GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1725684), // Rule ID 10292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10292,
        GIR_EraseRootFromParent_Done,
      // Label 22187: @1725684
      GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1725788), // Rule ID 10293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10293,
        GIR_EraseRootFromParent_Done,
      // Label 22188: @1725788
      GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1725892), // Rule ID 10296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10296,
        GIR_EraseRootFromParent_Done,
      // Label 22189: @1725892
      GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1725996), // Rule ID 10297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10297,
        GIR_EraseRootFromParent_Done,
      // Label 22190: @1725996
      GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1726100), // Rule ID 10300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10300,
        GIR_EraseRootFromParent_Done,
      // Label 22191: @1726100
      GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1726204), // Rule ID 10301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10301,
        GIR_EraseRootFromParent_Done,
      // Label 22192: @1726204
      GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1726308), // Rule ID 10304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10304,
        GIR_EraseRootFromParent_Done,
      // Label 22193: @1726308
      GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1726412), // Rule ID 10305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10305,
        GIR_EraseRootFromParent_Done,
      // Label 22194: @1726412
      GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1726516), // Rule ID 10308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10308,
        GIR_EraseRootFromParent_Done,
      // Label 22195: @1726516
      GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1726620), // Rule ID 10309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10309,
        GIR_EraseRootFromParent_Done,
      // Label 22196: @1726620
      GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1726724), // Rule ID 10312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10312,
        GIR_EraseRootFromParent_Done,
      // Label 22197: @1726724
      GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1726828), // Rule ID 10313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10313,
        GIR_EraseRootFromParent_Done,
      // Label 22198: @1726828
      GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1726932), // Rule ID 10316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10316,
        GIR_EraseRootFromParent_Done,
      // Label 22199: @1726932
      GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1727036), // Rule ID 10317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10317,
        GIR_EraseRootFromParent_Done,
      // Label 22200: @1727036
      GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1727140), // Rule ID 10320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10320,
        GIR_EraseRootFromParent_Done,
      // Label 22201: @1727140
      GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1727244), // Rule ID 10321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10321,
        GIR_EraseRootFromParent_Done,
      // Label 22202: @1727244
      GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1727348), // Rule ID 10324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10324,
        GIR_EraseRootFromParent_Done,
      // Label 22203: @1727348
      GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1727452), // Rule ID 10325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10325,
        GIR_EraseRootFromParent_Done,
      // Label 22204: @1727452
      GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1727556), // Rule ID 10328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10328,
        GIR_EraseRootFromParent_Done,
      // Label 22205: @1727556
      GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1727660), // Rule ID 10329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10329,
        GIR_EraseRootFromParent_Done,
      // Label 22206: @1727660
      GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1727764), // Rule ID 10332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10332,
        GIR_EraseRootFromParent_Done,
      // Label 22207: @1727764
      GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1727868), // Rule ID 10333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10333,
        GIR_EraseRootFromParent_Done,
      // Label 22208: @1727868
      GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1727972), // Rule ID 10336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10336,
        GIR_EraseRootFromParent_Done,
      // Label 22209: @1727972
      GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1728076), // Rule ID 10337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10337,
        GIR_EraseRootFromParent_Done,
      // Label 22210: @1728076
      GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1728180), // Rule ID 10340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10340,
        GIR_EraseRootFromParent_Done,
      // Label 22211: @1728180
      GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1728284), // Rule ID 10341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10341,
        GIR_EraseRootFromParent_Done,
      // Label 22212: @1728284
      GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1728388), // Rule ID 10344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10344,
        GIR_EraseRootFromParent_Done,
      // Label 22213: @1728388
      GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1728492), // Rule ID 10345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10345,
        GIR_EraseRootFromParent_Done,
      // Label 22214: @1728492
      GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1728596), // Rule ID 10348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10348,
        GIR_EraseRootFromParent_Done,
      // Label 22215: @1728596
      GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1728700), // Rule ID 10349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10349,
        GIR_EraseRootFromParent_Done,
      // Label 22216: @1728700
      GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1728804), // Rule ID 10352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10352,
        GIR_EraseRootFromParent_Done,
      // Label 22217: @1728804
      GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1728908), // Rule ID 10353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10353,
        GIR_EraseRootFromParent_Done,
      // Label 22218: @1728908
      GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1729012), // Rule ID 10356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10356,
        GIR_EraseRootFromParent_Done,
      // Label 22219: @1729012
      GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1729116), // Rule ID 10357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10357,
        GIR_EraseRootFromParent_Done,
      // Label 22220: @1729116
      GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1729220), // Rule ID 10360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10360,
        GIR_EraseRootFromParent_Done,
      // Label 22221: @1729220
      GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1729324), // Rule ID 10361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10361,
        GIR_EraseRootFromParent_Done,
      // Label 22222: @1729324
      GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1729428), // Rule ID 10364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10364,
        GIR_EraseRootFromParent_Done,
      // Label 22223: @1729428
      GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1729532), // Rule ID 10365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10365,
        GIR_EraseRootFromParent_Done,
      // Label 22224: @1729532
      GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1729636), // Rule ID 10368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10368,
        GIR_EraseRootFromParent_Done,
      // Label 22225: @1729636
      GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1729740), // Rule ID 10369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10369,
        GIR_EraseRootFromParent_Done,
      // Label 22226: @1729740
      GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1729844), // Rule ID 10372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10372,
        GIR_EraseRootFromParent_Done,
      // Label 22227: @1729844
      GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1729948), // Rule ID 10373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10373,
        GIR_EraseRootFromParent_Done,
      // Label 22228: @1729948
      GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1730052), // Rule ID 10376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10376,
        GIR_EraseRootFromParent_Done,
      // Label 22229: @1730052
      GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1730156), // Rule ID 10377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10377,
        GIR_EraseRootFromParent_Done,
      // Label 22230: @1730156
      GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1730260), // Rule ID 10380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10380,
        GIR_EraseRootFromParent_Done,
      // Label 22231: @1730260
      GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1730364), // Rule ID 10381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10381,
        GIR_EraseRootFromParent_Done,
      // Label 22232: @1730364
      GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1730468), // Rule ID 10384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10384,
        GIR_EraseRootFromParent_Done,
      // Label 22233: @1730468
      GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1730572), // Rule ID 10385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10385,
        GIR_EraseRootFromParent_Done,
      // Label 22234: @1730572
      GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1730676), // Rule ID 10388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10388,
        GIR_EraseRootFromParent_Done,
      // Label 22235: @1730676
      GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1730780), // Rule ID 10389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10389,
        GIR_EraseRootFromParent_Done,
      // Label 22236: @1730780
      GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1730884), // Rule ID 10392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10392,
        GIR_EraseRootFromParent_Done,
      // Label 22237: @1730884
      GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1730988), // Rule ID 10393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10393,
        GIR_EraseRootFromParent_Done,
      // Label 22238: @1730988
      GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1731092), // Rule ID 10396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10396,
        GIR_EraseRootFromParent_Done,
      // Label 22239: @1731092
      GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1731196), // Rule ID 10397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11040:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10397,
        GIR_EraseRootFromParent_Done,
      // Label 22240: @1731196
      GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1731300), // Rule ID 10400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10400,
        GIR_EraseRootFromParent_Done,
      // Label 22241: @1731300
      GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1731404), // Rule ID 10401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11040:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10401,
        GIR_EraseRootFromParent_Done,
      // Label 22242: @1731404
      GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1731508), // Rule ID 10404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10404,
        GIR_EraseRootFromParent_Done,
      // Label 22243: @1731508
      GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1731612), // Rule ID 10405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10405,
        GIR_EraseRootFromParent_Done,
      // Label 22244: @1731612
      GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1731716), // Rule ID 10408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10408,
        GIR_EraseRootFromParent_Done,
      // Label 22245: @1731716
      GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1731820), // Rule ID 10409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11040:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10409,
        GIR_EraseRootFromParent_Done,
      // Label 22246: @1731820
      GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1731924), // Rule ID 10412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10412,
        GIR_EraseRootFromParent_Done,
      // Label 22247: @1731924
      GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1732028), // Rule ID 10413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10413,
        GIR_EraseRootFromParent_Done,
      // Label 22248: @1732028
      GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1732132), // Rule ID 10416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10416,
        GIR_EraseRootFromParent_Done,
      // Label 22249: @1732132
      GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1732236), // Rule ID 10417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10417,
        GIR_EraseRootFromParent_Done,
      // Label 22250: @1732236
      GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1732340), // Rule ID 10420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10420,
        GIR_EraseRootFromParent_Done,
      // Label 22251: @1732340
      GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1732444), // Rule ID 10421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10421,
        GIR_EraseRootFromParent_Done,
      // Label 22252: @1732444
      GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1732548), // Rule ID 10424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10424,
        GIR_EraseRootFromParent_Done,
      // Label 22253: @1732548
      GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1732652), // Rule ID 10425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10425,
        GIR_EraseRootFromParent_Done,
      // Label 22254: @1732652
      GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1732756), // Rule ID 10428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10428,
        GIR_EraseRootFromParent_Done,
      // Label 22255: @1732756
      GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1732860), // Rule ID 10429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10429,
        GIR_EraseRootFromParent_Done,
      // Label 22256: @1732860
      GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1732964), // Rule ID 10432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10432,
        GIR_EraseRootFromParent_Done,
      // Label 22257: @1732964
      GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1733068), // Rule ID 10433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10433,
        GIR_EraseRootFromParent_Done,
      // Label 22258: @1733068
      GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1733172), // Rule ID 10436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10436,
        GIR_EraseRootFromParent_Done,
      // Label 22259: @1733172
      GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1733276), // Rule ID 10437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10437,
        GIR_EraseRootFromParent_Done,
      // Label 22260: @1733276
      GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1733380), // Rule ID 10440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10440,
        GIR_EraseRootFromParent_Done,
      // Label 22261: @1733380
      GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1733484), // Rule ID 10441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10441,
        GIR_EraseRootFromParent_Done,
      // Label 22262: @1733484
      GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1733588), // Rule ID 10444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10444,
        GIR_EraseRootFromParent_Done,
      // Label 22263: @1733588
      GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1733692), // Rule ID 10445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10445,
        GIR_EraseRootFromParent_Done,
      // Label 22264: @1733692
      GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1733796), // Rule ID 10448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10448,
        GIR_EraseRootFromParent_Done,
      // Label 22265: @1733796
      GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1733900), // Rule ID 10449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10449,
        GIR_EraseRootFromParent_Done,
      // Label 22266: @1733900
      GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1734004), // Rule ID 10452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10452,
        GIR_EraseRootFromParent_Done,
      // Label 22267: @1734004
      GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1734108), // Rule ID 10453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10453,
        GIR_EraseRootFromParent_Done,
      // Label 22268: @1734108
      GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1734212), // Rule ID 10456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10456,
        GIR_EraseRootFromParent_Done,
      // Label 22269: @1734212
      GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1734316), // Rule ID 10457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10457,
        GIR_EraseRootFromParent_Done,
      // Label 22270: @1734316
      GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1734420), // Rule ID 10460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10460,
        GIR_EraseRootFromParent_Done,
      // Label 22271: @1734420
      GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1734524), // Rule ID 10461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10461,
        GIR_EraseRootFromParent_Done,
      // Label 22272: @1734524
      GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1734628), // Rule ID 10464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10464,
        GIR_EraseRootFromParent_Done,
      // Label 22273: @1734628
      GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1734732), // Rule ID 10465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10465,
        GIR_EraseRootFromParent_Done,
      // Label 22274: @1734732
      GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1734836), // Rule ID 10468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10468,
        GIR_EraseRootFromParent_Done,
      // Label 22275: @1734836
      GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1734940), // Rule ID 10469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10469,
        GIR_EraseRootFromParent_Done,
      // Label 22276: @1734940
      GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1735044), // Rule ID 10472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10472,
        GIR_EraseRootFromParent_Done,
      // Label 22277: @1735044
      GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1735148), // Rule ID 10473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10473,
        GIR_EraseRootFromParent_Done,
      // Label 22278: @1735148
      GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1735252), // Rule ID 10476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10476,
        GIR_EraseRootFromParent_Done,
      // Label 22279: @1735252
      GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1735356), // Rule ID 10477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10477,
        GIR_EraseRootFromParent_Done,
      // Label 22280: @1735356
      GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1735460), // Rule ID 10480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10480,
        GIR_EraseRootFromParent_Done,
      // Label 22281: @1735460
      GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1735564), // Rule ID 10481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10481,
        GIR_EraseRootFromParent_Done,
      // Label 22282: @1735564
      GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1735668), // Rule ID 10484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10484,
        GIR_EraseRootFromParent_Done,
      // Label 22283: @1735668
      GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1735772), // Rule ID 10485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10485,
        GIR_EraseRootFromParent_Done,
      // Label 22284: @1735772
      GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1735876), // Rule ID 10488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10488,
        GIR_EraseRootFromParent_Done,
      // Label 22285: @1735876
      GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1735980), // Rule ID 10489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10489,
        GIR_EraseRootFromParent_Done,
      // Label 22286: @1735980
      GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1736084), // Rule ID 10492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10492,
        GIR_EraseRootFromParent_Done,
      // Label 22287: @1736084
      GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1736188), // Rule ID 10493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10493,
        GIR_EraseRootFromParent_Done,
      // Label 22288: @1736188
      GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1736292), // Rule ID 10496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10496,
        GIR_EraseRootFromParent_Done,
      // Label 22289: @1736292
      GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1736396), // Rule ID 10497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10497,
        GIR_EraseRootFromParent_Done,
      // Label 22290: @1736396
      GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1736500), // Rule ID 10500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10500,
        GIR_EraseRootFromParent_Done,
      // Label 22291: @1736500
      GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1736604), // Rule ID 10501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10501,
        GIR_EraseRootFromParent_Done,
      // Label 22292: @1736604
      GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1736708), // Rule ID 10504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10504,
        GIR_EraseRootFromParent_Done,
      // Label 22293: @1736708
      GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1736812), // Rule ID 10505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10505,
        GIR_EraseRootFromParent_Done,
      // Label 22294: @1736812
      GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1736916), // Rule ID 10508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10508,
        GIR_EraseRootFromParent_Done,
      // Label 22295: @1736916
      GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1737020), // Rule ID 10509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10509,
        GIR_EraseRootFromParent_Done,
      // Label 22296: @1737020
      GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1737124), // Rule ID 10512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10512,
        GIR_EraseRootFromParent_Done,
      // Label 22297: @1737124
      GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1737228), // Rule ID 10513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10513,
        GIR_EraseRootFromParent_Done,
      // Label 22298: @1737228
      GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1737332), // Rule ID 10516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10516,
        GIR_EraseRootFromParent_Done,
      // Label 22299: @1737332
      GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1737436), // Rule ID 10517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10517,
        GIR_EraseRootFromParent_Done,
      // Label 22300: @1737436
      GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1737540), // Rule ID 10520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10520,
        GIR_EraseRootFromParent_Done,
      // Label 22301: @1737540
      GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1737644), // Rule ID 10521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10521,
        GIR_EraseRootFromParent_Done,
      // Label 22302: @1737644
      GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1737748), // Rule ID 10524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10524,
        GIR_EraseRootFromParent_Done,
      // Label 22303: @1737748
      GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1737852), // Rule ID 10525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10525,
        GIR_EraseRootFromParent_Done,
      // Label 22304: @1737852
      GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1737956), // Rule ID 10528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10528,
        GIR_EraseRootFromParent_Done,
      // Label 22305: @1737956
      GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1738060), // Rule ID 10529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10529,
        GIR_EraseRootFromParent_Done,
      // Label 22306: @1738060
      GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1738164), // Rule ID 10532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10532,
        GIR_EraseRootFromParent_Done,
      // Label 22307: @1738164
      GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1738268), // Rule ID 10533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10533,
        GIR_EraseRootFromParent_Done,
      // Label 22308: @1738268
      GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1738372), // Rule ID 10536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10536,
        GIR_EraseRootFromParent_Done,
      // Label 22309: @1738372
      GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1738476), // Rule ID 10537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10537,
        GIR_EraseRootFromParent_Done,
      // Label 22310: @1738476
      GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1738580), // Rule ID 10540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10540,
        GIR_EraseRootFromParent_Done,
      // Label 22311: @1738580
      GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1738684), // Rule ID 10541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10541,
        GIR_EraseRootFromParent_Done,
      // Label 22312: @1738684
      GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1738788), // Rule ID 10544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10544,
        GIR_EraseRootFromParent_Done,
      // Label 22313: @1738788
      GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1738892), // Rule ID 10545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10545,
        GIR_EraseRootFromParent_Done,
      // Label 22314: @1738892
      GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1738996), // Rule ID 10548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10548,
        GIR_EraseRootFromParent_Done,
      // Label 22315: @1738996
      GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1739100), // Rule ID 10549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10549,
        GIR_EraseRootFromParent_Done,
      // Label 22316: @1739100
      GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1739204), // Rule ID 10552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10552,
        GIR_EraseRootFromParent_Done,
      // Label 22317: @1739204
      GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1739308), // Rule ID 10553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10553,
        GIR_EraseRootFromParent_Done,
      // Label 22318: @1739308
      GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1739412), // Rule ID 10556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10556,
        GIR_EraseRootFromParent_Done,
      // Label 22319: @1739412
      GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1739516), // Rule ID 10557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10557,
        GIR_EraseRootFromParent_Done,
      // Label 22320: @1739516
      GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1739620), // Rule ID 10560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10560,
        GIR_EraseRootFromParent_Done,
      // Label 22321: @1739620
      GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1739724), // Rule ID 10561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10561,
        GIR_EraseRootFromParent_Done,
      // Label 22322: @1739724
      GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1739828), // Rule ID 10564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10564,
        GIR_EraseRootFromParent_Done,
      // Label 22323: @1739828
      GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1739932), // Rule ID 10565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10565,
        GIR_EraseRootFromParent_Done,
      // Label 22324: @1739932
      GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1740036), // Rule ID 10568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10568,
        GIR_EraseRootFromParent_Done,
      // Label 22325: @1740036
      GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1740140), // Rule ID 10569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10569,
        GIR_EraseRootFromParent_Done,
      // Label 22326: @1740140
      GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1740244), // Rule ID 10572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10572,
        GIR_EraseRootFromParent_Done,
      // Label 22327: @1740244
      GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1740348), // Rule ID 10573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11024:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10573,
        GIR_EraseRootFromParent_Done,
      // Label 22328: @1740348
      GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1740452), // Rule ID 10576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10576,
        GIR_EraseRootFromParent_Done,
      // Label 22329: @1740452
      GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1740556), // Rule ID 10577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11024:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10577,
        GIR_EraseRootFromParent_Done,
      // Label 22330: @1740556
      GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1740660), // Rule ID 10580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10580,
        GIR_EraseRootFromParent_Done,
      // Label 22331: @1740660
      GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1740764), // Rule ID 10581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11024:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10581,
        GIR_EraseRootFromParent_Done,
      // Label 22332: @1740764
      GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1740868), // Rule ID 10584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10584,
        GIR_EraseRootFromParent_Done,
      // Label 22333: @1740868
      GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1740972), // Rule ID 10585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11024:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10585,
        GIR_EraseRootFromParent_Done,
      // Label 22334: @1740972
      GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1741076), // Rule ID 10588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10588,
        GIR_EraseRootFromParent_Done,
      // Label 22335: @1741076
      GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1741180), // Rule ID 10589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10589,
        GIR_EraseRootFromParent_Done,
      // Label 22336: @1741180
      GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1741284), // Rule ID 10592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10592,
        GIR_EraseRootFromParent_Done,
      // Label 22337: @1741284
      GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1741388), // Rule ID 10593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10593,
        GIR_EraseRootFromParent_Done,
      // Label 22338: @1741388
      GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1741492), // Rule ID 10596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10596,
        GIR_EraseRootFromParent_Done,
      // Label 22339: @1741492
      GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1741596), // Rule ID 10597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10597,
        GIR_EraseRootFromParent_Done,
      // Label 22340: @1741596
      GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1741700), // Rule ID 10600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10600,
        GIR_EraseRootFromParent_Done,
      // Label 22341: @1741700
      GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1741804), // Rule ID 10601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10601,
        GIR_EraseRootFromParent_Done,
      // Label 22342: @1741804
      GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1741908), // Rule ID 10604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10604,
        GIR_EraseRootFromParent_Done,
      // Label 22343: @1741908
      GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1742012), // Rule ID 10605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10605,
        GIR_EraseRootFromParent_Done,
      // Label 22344: @1742012
      GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1742116), // Rule ID 10608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10608,
        GIR_EraseRootFromParent_Done,
      // Label 22345: @1742116
      GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1742220), // Rule ID 10609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10609,
        GIR_EraseRootFromParent_Done,
      // Label 22346: @1742220
      GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1742324), // Rule ID 10612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10612,
        GIR_EraseRootFromParent_Done,
      // Label 22347: @1742324
      GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1742428), // Rule ID 10613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10613,
        GIR_EraseRootFromParent_Done,
      // Label 22348: @1742428
      GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1742532), // Rule ID 10616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10616,
        GIR_EraseRootFromParent_Done,
      // Label 22349: @1742532
      GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1742636), // Rule ID 10617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10617,
        GIR_EraseRootFromParent_Done,
      // Label 22350: @1742636
      GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1742740), // Rule ID 10620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10620,
        GIR_EraseRootFromParent_Done,
      // Label 22351: @1742740
      GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1742844), // Rule ID 10621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10621,
        GIR_EraseRootFromParent_Done,
      // Label 22352: @1742844
      GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1742948), // Rule ID 10624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10624,
        GIR_EraseRootFromParent_Done,
      // Label 22353: @1742948
      GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1743052), // Rule ID 10625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11024:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10625,
        GIR_EraseRootFromParent_Done,
      // Label 22354: @1743052
      GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1743156), // Rule ID 10628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10628,
        GIR_EraseRootFromParent_Done,
      // Label 22355: @1743156
      GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1743260), // Rule ID 10629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11024:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10629,
        GIR_EraseRootFromParent_Done,
      // Label 22356: @1743260
      GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1743364), // Rule ID 10632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10632,
        GIR_EraseRootFromParent_Done,
      // Label 22357: @1743364
      GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1743468), // Rule ID 10633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11024:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10633,
        GIR_EraseRootFromParent_Done,
      // Label 22358: @1743468
      GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1743572), // Rule ID 10636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10636,
        GIR_EraseRootFromParent_Done,
      // Label 22359: @1743572
      GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1743676), // Rule ID 10637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10637,
        GIR_EraseRootFromParent_Done,
      // Label 22360: @1743676
      GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1743780), // Rule ID 10640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10640,
        GIR_EraseRootFromParent_Done,
      // Label 22361: @1743780
      GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1743884), // Rule ID 10641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10641,
        GIR_EraseRootFromParent_Done,
      // Label 22362: @1743884
      GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1743988), // Rule ID 10644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10644,
        GIR_EraseRootFromParent_Done,
      // Label 22363: @1743988
      GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1744092), // Rule ID 10645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10645,
        GIR_EraseRootFromParent_Done,
      // Label 22364: @1744092
      GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1744196), // Rule ID 10648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10648,
        GIR_EraseRootFromParent_Done,
      // Label 22365: @1744196
      GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1744300), // Rule ID 10649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10649,
        GIR_EraseRootFromParent_Done,
      // Label 22366: @1744300
      GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1744404), // Rule ID 10652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10652,
        GIR_EraseRootFromParent_Done,
      // Label 22367: @1744404
      GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1744508), // Rule ID 10653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10653,
        GIR_EraseRootFromParent_Done,
      // Label 22368: @1744508
      GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1744612), // Rule ID 10656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10656,
        GIR_EraseRootFromParent_Done,
      // Label 22369: @1744612
      GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1744716), // Rule ID 10657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10657,
        GIR_EraseRootFromParent_Done,
      // Label 22370: @1744716
      GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1744820), // Rule ID 10660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10660,
        GIR_EraseRootFromParent_Done,
      // Label 22371: @1744820
      GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1744924), // Rule ID 10661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10661,
        GIR_EraseRootFromParent_Done,
      // Label 22372: @1744924
      GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1745028), // Rule ID 10664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10664,
        GIR_EraseRootFromParent_Done,
      // Label 22373: @1745028
      GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1745132), // Rule ID 10665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10665,
        GIR_EraseRootFromParent_Done,
      // Label 22374: @1745132
      GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1745236), // Rule ID 10668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10668,
        GIR_EraseRootFromParent_Done,
      // Label 22375: @1745236
      GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1745340), // Rule ID 10669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10669,
        GIR_EraseRootFromParent_Done,
      // Label 22376: @1745340
      GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1745444), // Rule ID 10672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10672,
        GIR_EraseRootFromParent_Done,
      // Label 22377: @1745444
      GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1745548), // Rule ID 10673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10673,
        GIR_EraseRootFromParent_Done,
      // Label 22378: @1745548
      GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1745652), // Rule ID 10676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10676,
        GIR_EraseRootFromParent_Done,
      // Label 22379: @1745652
      GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1745756), // Rule ID 10677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10677,
        GIR_EraseRootFromParent_Done,
      // Label 22380: @1745756
      GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1745860), // Rule ID 10680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10680,
        GIR_EraseRootFromParent_Done,
      // Label 22381: @1745860
      GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1745964), // Rule ID 10681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10681,
        GIR_EraseRootFromParent_Done,
      // Label 22382: @1745964
      GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1746068), // Rule ID 10684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10684,
        GIR_EraseRootFromParent_Done,
      // Label 22383: @1746068
      GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1746172), // Rule ID 10685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10685,
        GIR_EraseRootFromParent_Done,
      // Label 22384: @1746172
      GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1746276), // Rule ID 10688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10688,
        GIR_EraseRootFromParent_Done,
      // Label 22385: @1746276
      GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1746380), // Rule ID 10689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10689,
        GIR_EraseRootFromParent_Done,
      // Label 22386: @1746380
      GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1746484), // Rule ID 10692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10692,
        GIR_EraseRootFromParent_Done,
      // Label 22387: @1746484
      GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1746588), // Rule ID 10693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10693,
        GIR_EraseRootFromParent_Done,
      // Label 22388: @1746588
      GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1746692), // Rule ID 10696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10696,
        GIR_EraseRootFromParent_Done,
      // Label 22389: @1746692
      GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1746796), // Rule ID 10697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10697,
        GIR_EraseRootFromParent_Done,
      // Label 22390: @1746796
      GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1746900), // Rule ID 10700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10700,
        GIR_EraseRootFromParent_Done,
      // Label 22391: @1746900
      GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1747004), // Rule ID 10701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10701,
        GIR_EraseRootFromParent_Done,
      // Label 22392: @1747004
      GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1747108), // Rule ID 10704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10704,
        GIR_EraseRootFromParent_Done,
      // Label 22393: @1747108
      GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1747212), // Rule ID 10705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10705,
        GIR_EraseRootFromParent_Done,
      // Label 22394: @1747212
      GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1747316), // Rule ID 10708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10708,
        GIR_EraseRootFromParent_Done,
      // Label 22395: @1747316
      GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1747420), // Rule ID 10709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10709,
        GIR_EraseRootFromParent_Done,
      // Label 22396: @1747420
      GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1747524), // Rule ID 10712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10712,
        GIR_EraseRootFromParent_Done,
      // Label 22397: @1747524
      GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1747628), // Rule ID 10713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10713,
        GIR_EraseRootFromParent_Done,
      // Label 22398: @1747628
      GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1747732), // Rule ID 10716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10716,
        GIR_EraseRootFromParent_Done,
      // Label 22399: @1747732
      GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1747836), // Rule ID 10717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10717,
        GIR_EraseRootFromParent_Done,
      // Label 22400: @1747836
      GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1747940), // Rule ID 10720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10720,
        GIR_EraseRootFromParent_Done,
      // Label 22401: @1747940
      GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1748044), // Rule ID 10721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10721,
        GIR_EraseRootFromParent_Done,
      // Label 22402: @1748044
      GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1748148), // Rule ID 10724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10724,
        GIR_EraseRootFromParent_Done,
      // Label 22403: @1748148
      GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1748252), // Rule ID 10725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10725,
        GIR_EraseRootFromParent_Done,
      // Label 22404: @1748252
      GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1748356), // Rule ID 10728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10728,
        GIR_EraseRootFromParent_Done,
      // Label 22405: @1748356
      GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1748460), // Rule ID 10729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10729,
        GIR_EraseRootFromParent_Done,
      // Label 22406: @1748460
      GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1748564), // Rule ID 10732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10732,
        GIR_EraseRootFromParent_Done,
      // Label 22407: @1748564
      GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1748668), // Rule ID 10733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10733,
        GIR_EraseRootFromParent_Done,
      // Label 22408: @1748668
      GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1748772), // Rule ID 10736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10736,
        GIR_EraseRootFromParent_Done,
      // Label 22409: @1748772
      GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1748876), // Rule ID 10737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10737,
        GIR_EraseRootFromParent_Done,
      // Label 22410: @1748876
      GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1748980), // Rule ID 10740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10740,
        GIR_EraseRootFromParent_Done,
      // Label 22411: @1748980
      GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1749084), // Rule ID 10741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10741,
        GIR_EraseRootFromParent_Done,
      // Label 22412: @1749084
      GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1749188), // Rule ID 10744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10744,
        GIR_EraseRootFromParent_Done,
      // Label 22413: @1749188
      GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1749292), // Rule ID 10745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10745,
        GIR_EraseRootFromParent_Done,
      // Label 22414: @1749292
      GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1749396), // Rule ID 10748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10748,
        GIR_EraseRootFromParent_Done,
      // Label 22415: @1749396
      GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1749500), // Rule ID 10749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11022:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10749,
        GIR_EraseRootFromParent_Done,
      // Label 22416: @1749500
      GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1749604), // Rule ID 10752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10752,
        GIR_EraseRootFromParent_Done,
      // Label 22417: @1749604
      GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1749708), // Rule ID 10753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11022:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10753,
        GIR_EraseRootFromParent_Done,
      // Label 22418: @1749708
      GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1749812), // Rule ID 10756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10756,
        GIR_EraseRootFromParent_Done,
      // Label 22419: @1749812
      GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1749916), // Rule ID 10757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11022:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10757,
        GIR_EraseRootFromParent_Done,
      // Label 22420: @1749916
      GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1750020), // Rule ID 10760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10760,
        GIR_EraseRootFromParent_Done,
      // Label 22421: @1750020
      GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1750124), // Rule ID 10761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11022:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10761,
        GIR_EraseRootFromParent_Done,
      // Label 22422: @1750124
      GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1750228), // Rule ID 10764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10764,
        GIR_EraseRootFromParent_Done,
      // Label 22423: @1750228
      GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1750332), // Rule ID 10765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10765,
        GIR_EraseRootFromParent_Done,
      // Label 22424: @1750332
      GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1750436), // Rule ID 10768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10768,
        GIR_EraseRootFromParent_Done,
      // Label 22425: @1750436
      GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1750540), // Rule ID 10769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10769,
        GIR_EraseRootFromParent_Done,
      // Label 22426: @1750540
      GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1750644), // Rule ID 10772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10772,
        GIR_EraseRootFromParent_Done,
      // Label 22427: @1750644
      GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1750748), // Rule ID 10773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10773,
        GIR_EraseRootFromParent_Done,
      // Label 22428: @1750748
      GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1750852), // Rule ID 10776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10776,
        GIR_EraseRootFromParent_Done,
      // Label 22429: @1750852
      GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1750956), // Rule ID 10777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10777,
        GIR_EraseRootFromParent_Done,
      // Label 22430: @1750956
      GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1751060), // Rule ID 10780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10780,
        GIR_EraseRootFromParent_Done,
      // Label 22431: @1751060
      GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1751164), // Rule ID 10781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10781,
        GIR_EraseRootFromParent_Done,
      // Label 22432: @1751164
      GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1751268), // Rule ID 10784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10784,
        GIR_EraseRootFromParent_Done,
      // Label 22433: @1751268
      GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1751372), // Rule ID 10785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10785,
        GIR_EraseRootFromParent_Done,
      // Label 22434: @1751372
      GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1751476), // Rule ID 10788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10788,
        GIR_EraseRootFromParent_Done,
      // Label 22435: @1751476
      GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1751580), // Rule ID 10789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10789,
        GIR_EraseRootFromParent_Done,
      // Label 22436: @1751580
      GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1751684), // Rule ID 10792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10792,
        GIR_EraseRootFromParent_Done,
      // Label 22437: @1751684
      GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1751788), // Rule ID 10793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10793,
        GIR_EraseRootFromParent_Done,
      // Label 22438: @1751788
      GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1751892), // Rule ID 10796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10796,
        GIR_EraseRootFromParent_Done,
      // Label 22439: @1751892
      GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1751996), // Rule ID 10797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10797,
        GIR_EraseRootFromParent_Done,
      // Label 22440: @1751996
      GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1752100), // Rule ID 10800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10800,
        GIR_EraseRootFromParent_Done,
      // Label 22441: @1752100
      GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1752204), // Rule ID 10801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11022:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10801,
        GIR_EraseRootFromParent_Done,
      // Label 22442: @1752204
      GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1752308), // Rule ID 10804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10804,
        GIR_EraseRootFromParent_Done,
      // Label 22443: @1752308
      GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1752412), // Rule ID 10805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11022:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10805,
        GIR_EraseRootFromParent_Done,
      // Label 22444: @1752412
      GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1752516), // Rule ID 10808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10808,
        GIR_EraseRootFromParent_Done,
      // Label 22445: @1752516
      GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1752620), // Rule ID 10809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11022:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10809,
        GIR_EraseRootFromParent_Done,
      // Label 22446: @1752620
      GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1752724), // Rule ID 10812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10812,
        GIR_EraseRootFromParent_Done,
      // Label 22447: @1752724
      GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1752828), // Rule ID 10813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10813,
        GIR_EraseRootFromParent_Done,
      // Label 22448: @1752828
      GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1752932), // Rule ID 10816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10816,
        GIR_EraseRootFromParent_Done,
      // Label 22449: @1752932
      GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1753036), // Rule ID 10817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10817,
        GIR_EraseRootFromParent_Done,
      // Label 22450: @1753036
      GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1753140), // Rule ID 10820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10820,
        GIR_EraseRootFromParent_Done,
      // Label 22451: @1753140
      GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1753244), // Rule ID 10821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10821,
        GIR_EraseRootFromParent_Done,
      // Label 22452: @1753244
      GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1753348), // Rule ID 10824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10824,
        GIR_EraseRootFromParent_Done,
      // Label 22453: @1753348
      GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1753452), // Rule ID 10825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10825,
        GIR_EraseRootFromParent_Done,
      // Label 22454: @1753452
      GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1753556), // Rule ID 10828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10828,
        GIR_EraseRootFromParent_Done,
      // Label 22455: @1753556
      GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1753660), // Rule ID 10829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10829,
        GIR_EraseRootFromParent_Done,
      // Label 22456: @1753660
      GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1753764), // Rule ID 10832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10832,
        GIR_EraseRootFromParent_Done,
      // Label 22457: @1753764
      GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1753868), // Rule ID 10833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10833,
        GIR_EraseRootFromParent_Done,
      // Label 22458: @1753868
      GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1753972), // Rule ID 10836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10836,
        GIR_EraseRootFromParent_Done,
      // Label 22459: @1753972
      GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1754076), // Rule ID 10837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10837,
        GIR_EraseRootFromParent_Done,
      // Label 22460: @1754076
      GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1754180), // Rule ID 10840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10840,
        GIR_EraseRootFromParent_Done,
      // Label 22461: @1754180
      GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1754284), // Rule ID 10841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10841,
        GIR_EraseRootFromParent_Done,
      // Label 22462: @1754284
      GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1754388), // Rule ID 10844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10844,
        GIR_EraseRootFromParent_Done,
      // Label 22463: @1754388
      GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1754492), // Rule ID 10845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10845,
        GIR_EraseRootFromParent_Done,
      // Label 22464: @1754492
      GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1754596), // Rule ID 10848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10848,
        GIR_EraseRootFromParent_Done,
      // Label 22465: @1754596
      GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1754700), // Rule ID 10849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10849,
        GIR_EraseRootFromParent_Done,
      // Label 22466: @1754700
      GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1754804), // Rule ID 10852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10852,
        GIR_EraseRootFromParent_Done,
      // Label 22467: @1754804
      GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1754908), // Rule ID 10853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10853,
        GIR_EraseRootFromParent_Done,
      // Label 22468: @1754908
      GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1755012), // Rule ID 10856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10856,
        GIR_EraseRootFromParent_Done,
      // Label 22469: @1755012
      GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1755116), // Rule ID 10857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10857,
        GIR_EraseRootFromParent_Done,
      // Label 22470: @1755116
      GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1755220), // Rule ID 10860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10860,
        GIR_EraseRootFromParent_Done,
      // Label 22471: @1755220
      GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1755324), // Rule ID 10861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10861,
        GIR_EraseRootFromParent_Done,
      // Label 22472: @1755324
      GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1755428), // Rule ID 10864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10864,
        GIR_EraseRootFromParent_Done,
      // Label 22473: @1755428
      GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1755532), // Rule ID 10865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10865,
        GIR_EraseRootFromParent_Done,
      // Label 22474: @1755532
      GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1755636), // Rule ID 10868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10868,
        GIR_EraseRootFromParent_Done,
      // Label 22475: @1755636
      GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1755740), // Rule ID 10869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10869,
        GIR_EraseRootFromParent_Done,
      // Label 22476: @1755740
      GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1755844), // Rule ID 10872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10872,
        GIR_EraseRootFromParent_Done,
      // Label 22477: @1755844
      GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1755948), // Rule ID 10873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10873,
        GIR_EraseRootFromParent_Done,
      // Label 22478: @1755948
      GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1756052), // Rule ID 10876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10876,
        GIR_EraseRootFromParent_Done,
      // Label 22479: @1756052
      GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1756156), // Rule ID 10877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10877,
        GIR_EraseRootFromParent_Done,
      // Label 22480: @1756156
      GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1756260), // Rule ID 10880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10880,
        GIR_EraseRootFromParent_Done,
      // Label 22481: @1756260
      GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1756364), // Rule ID 10881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10881,
        GIR_EraseRootFromParent_Done,
      // Label 22482: @1756364
      GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1756468), // Rule ID 10884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10884,
        GIR_EraseRootFromParent_Done,
      // Label 22483: @1756468
      GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1756572), // Rule ID 10885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10885,
        GIR_EraseRootFromParent_Done,
      // Label 22484: @1756572
      GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1756676), // Rule ID 10888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10888,
        GIR_EraseRootFromParent_Done,
      // Label 22485: @1756676
      GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1756780), // Rule ID 10889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10889,
        GIR_EraseRootFromParent_Done,
      // Label 22486: @1756780
      GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1756884), // Rule ID 10892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10892,
        GIR_EraseRootFromParent_Done,
      // Label 22487: @1756884
      GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1756988), // Rule ID 10893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10893,
        GIR_EraseRootFromParent_Done,
      // Label 22488: @1756988
      GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1757092), // Rule ID 10896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10896,
        GIR_EraseRootFromParent_Done,
      // Label 22489: @1757092
      GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1757196), // Rule ID 10897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10897,
        GIR_EraseRootFromParent_Done,
      // Label 22490: @1757196
      GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1757300), // Rule ID 10900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10900,
        GIR_EraseRootFromParent_Done,
      // Label 22491: @1757300
      GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1757404), // Rule ID 10901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10901,
        GIR_EraseRootFromParent_Done,
      // Label 22492: @1757404
      GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1757508), // Rule ID 10904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10904,
        GIR_EraseRootFromParent_Done,
      // Label 22493: @1757508
      GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1757612), // Rule ID 10905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10905,
        GIR_EraseRootFromParent_Done,
      // Label 22494: @1757612
      GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1757716), // Rule ID 10908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10908,
        GIR_EraseRootFromParent_Done,
      // Label 22495: @1757716
      GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1757820), // Rule ID 10909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10909,
        GIR_EraseRootFromParent_Done,
      // Label 22496: @1757820
      GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1757924), // Rule ID 10912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10912,
        GIR_EraseRootFromParent_Done,
      // Label 22497: @1757924
      GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1758028), // Rule ID 10913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10913,
        GIR_EraseRootFromParent_Done,
      // Label 22498: @1758028
      GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1758132), // Rule ID 10916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10916,
        GIR_EraseRootFromParent_Done,
      // Label 22499: @1758132
      GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1758236), // Rule ID 10917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10917,
        GIR_EraseRootFromParent_Done,
      // Label 22500: @1758236
      GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1758340), // Rule ID 10920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10920,
        GIR_EraseRootFromParent_Done,
      // Label 22501: @1758340
      GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1758444), // Rule ID 10921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10921,
        GIR_EraseRootFromParent_Done,
      // Label 22502: @1758444
      GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1758548), // Rule ID 10924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10924,
        GIR_EraseRootFromParent_Done,
      // Label 22503: @1758548
      GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1758652), // Rule ID 10925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10925,
        GIR_EraseRootFromParent_Done,
      // Label 22504: @1758652
      GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1758756), // Rule ID 10928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10928,
        GIR_EraseRootFromParent_Done,
      // Label 22505: @1758756
      GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1758860), // Rule ID 10929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10929,
        GIR_EraseRootFromParent_Done,
      // Label 22506: @1758860
      GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1758964), // Rule ID 10932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10932,
        GIR_EraseRootFromParent_Done,
      // Label 22507: @1758964
      GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1759068), // Rule ID 10933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10933,
        GIR_EraseRootFromParent_Done,
      // Label 22508: @1759068
      GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1759172), // Rule ID 10936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10936,
        GIR_EraseRootFromParent_Done,
      // Label 22509: @1759172
      GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1759276), // Rule ID 10937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10937,
        GIR_EraseRootFromParent_Done,
      // Label 22510: @1759276
      GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1759380), // Rule ID 10940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10940,
        GIR_EraseRootFromParent_Done,
      // Label 22511: @1759380
      GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1759484), // Rule ID 10941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10941,
        GIR_EraseRootFromParent_Done,
      // Label 22512: @1759484
      GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1759588), // Rule ID 10944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10944,
        GIR_EraseRootFromParent_Done,
      // Label 22513: @1759588
      GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1759692), // Rule ID 10945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10945,
        GIR_EraseRootFromParent_Done,
      // Label 22514: @1759692
      GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1759796), // Rule ID 10948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10948,
        GIR_EraseRootFromParent_Done,
      // Label 22515: @1759796
      GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1759900), // Rule ID 10949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10949,
        GIR_EraseRootFromParent_Done,
      // Label 22516: @1759900
      GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1760004), // Rule ID 10952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10952,
        GIR_EraseRootFromParent_Done,
      // Label 22517: @1760004
      GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1760108), // Rule ID 10953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10953,
        GIR_EraseRootFromParent_Done,
      // Label 22518: @1760108
      GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1760212), // Rule ID 10956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10956,
        GIR_EraseRootFromParent_Done,
      // Label 22519: @1760212
      GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1760316), // Rule ID 10957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10957,
        GIR_EraseRootFromParent_Done,
      // Label 22520: @1760316
      GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1760420), // Rule ID 10960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10960,
        GIR_EraseRootFromParent_Done,
      // Label 22521: @1760420
      GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1760524), // Rule ID 10961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10961,
        GIR_EraseRootFromParent_Done,
      // Label 22522: @1760524
      GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1760628), // Rule ID 10964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10964,
        GIR_EraseRootFromParent_Done,
      // Label 22523: @1760628
      GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1760732), // Rule ID 10965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10965,
        GIR_EraseRootFromParent_Done,
      // Label 22524: @1760732
      GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1760836), // Rule ID 10968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10968,
        GIR_EraseRootFromParent_Done,
      // Label 22525: @1760836
      GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1760940), // Rule ID 10969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10969,
        GIR_EraseRootFromParent_Done,
      // Label 22526: @1760940
      GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1761044), // Rule ID 10972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10972,
        GIR_EraseRootFromParent_Done,
      // Label 22527: @1761044
      GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1761148), // Rule ID 10973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10973,
        GIR_EraseRootFromParent_Done,
      // Label 22528: @1761148
      GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1761252), // Rule ID 10976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10976,
        GIR_EraseRootFromParent_Done,
      // Label 22529: @1761252
      GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1761356), // Rule ID 10977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10977,
        GIR_EraseRootFromParent_Done,
      // Label 22530: @1761356
      GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1761460), // Rule ID 10980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10980,
        GIR_EraseRootFromParent_Done,
      // Label 22531: @1761460
      GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1761564), // Rule ID 10981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10981,
        GIR_EraseRootFromParent_Done,
      // Label 22532: @1761564
      GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1761668), // Rule ID 10984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10984,
        GIR_EraseRootFromParent_Done,
      // Label 22533: @1761668
      GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1761772), // Rule ID 10985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10985,
        GIR_EraseRootFromParent_Done,
      // Label 22534: @1761772
      GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1761876), // Rule ID 10988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10988,
        GIR_EraseRootFromParent_Done,
      // Label 22535: @1761876
      GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1761980), // Rule ID 10989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10989,
        GIR_EraseRootFromParent_Done,
      // Label 22536: @1761980
      GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1762084), // Rule ID 10992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10992,
        GIR_EraseRootFromParent_Done,
      // Label 22537: @1762084
      GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1762188), // Rule ID 10993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10993,
        GIR_EraseRootFromParent_Done,
      // Label 22538: @1762188
      GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1762292), // Rule ID 10996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10996,
        GIR_EraseRootFromParent_Done,
      // Label 22539: @1762292
      GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1762396), // Rule ID 10997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10997,
        GIR_EraseRootFromParent_Done,
      // Label 22540: @1762396
      GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1762500), // Rule ID 11000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11000,
        GIR_EraseRootFromParent_Done,
      // Label 22541: @1762500
      GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1762604), // Rule ID 11001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11001,
        GIR_EraseRootFromParent_Done,
      // Label 22542: @1762604
      GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1762708), // Rule ID 11004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11004,
        GIR_EraseRootFromParent_Done,
      // Label 22543: @1762708
      GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1762812), // Rule ID 11005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11005,
        GIR_EraseRootFromParent_Done,
      // Label 22544: @1762812
      GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1762916), // Rule ID 11008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11008,
        GIR_EraseRootFromParent_Done,
      // Label 22545: @1762916
      GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1763020), // Rule ID 11009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11009,
        GIR_EraseRootFromParent_Done,
      // Label 22546: @1763020
      GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1763124), // Rule ID 11012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11012,
        GIR_EraseRootFromParent_Done,
      // Label 22547: @1763124
      GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1763228), // Rule ID 11013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11013,
        GIR_EraseRootFromParent_Done,
      // Label 22548: @1763228
      GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1763332), // Rule ID 11016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11016,
        GIR_EraseRootFromParent_Done,
      // Label 22549: @1763332
      GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1763436), // Rule ID 11017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11017,
        GIR_EraseRootFromParent_Done,
      // Label 22550: @1763436
      GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1763540), // Rule ID 11020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11020,
        GIR_EraseRootFromParent_Done,
      // Label 22551: @1763540
      GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1763644), // Rule ID 11021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11021,
        GIR_EraseRootFromParent_Done,
      // Label 22552: @1763644
      GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1763748), // Rule ID 11024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11024,
        GIR_EraseRootFromParent_Done,
      // Label 22553: @1763748
      GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1763852), // Rule ID 11025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11025,
        GIR_EraseRootFromParent_Done,
      // Label 22554: @1763852
      GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1763956), // Rule ID 11028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11028,
        GIR_EraseRootFromParent_Done,
      // Label 22555: @1763956
      GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1764060), // Rule ID 11029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11029,
        GIR_EraseRootFromParent_Done,
      // Label 22556: @1764060
      GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1764164), // Rule ID 11032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11032,
        GIR_EraseRootFromParent_Done,
      // Label 22557: @1764164
      GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1764268), // Rule ID 11033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11033,
        GIR_EraseRootFromParent_Done,
      // Label 22558: @1764268
      GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1764372), // Rule ID 11036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11036,
        GIR_EraseRootFromParent_Done,
      // Label 22559: @1764372
      GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1764476), // Rule ID 11037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11037,
        GIR_EraseRootFromParent_Done,
      // Label 22560: @1764476
      GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1764580), // Rule ID 11040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11040,
        GIR_EraseRootFromParent_Done,
      // Label 22561: @1764580
      GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1764684), // Rule ID 11041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11041,
        GIR_EraseRootFromParent_Done,
      // Label 22562: @1764684
      GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1764788), // Rule ID 11044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11044,
        GIR_EraseRootFromParent_Done,
      // Label 22563: @1764788
      GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1764892), // Rule ID 11045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11045,
        GIR_EraseRootFromParent_Done,
      // Label 22564: @1764892
      GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1764996), // Rule ID 11048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11048,
        GIR_EraseRootFromParent_Done,
      // Label 22565: @1764996
      GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1765100), // Rule ID 11049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11049,
        GIR_EraseRootFromParent_Done,
      // Label 22566: @1765100
      GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1765204), // Rule ID 11052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11052,
        GIR_EraseRootFromParent_Done,
      // Label 22567: @1765204
      GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1765308), // Rule ID 11053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11053,
        GIR_EraseRootFromParent_Done,
      // Label 22568: @1765308
      GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1765412), // Rule ID 11056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11056,
        GIR_EraseRootFromParent_Done,
      // Label 22569: @1765412
      GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1765516), // Rule ID 11057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11057,
        GIR_EraseRootFromParent_Done,
      // Label 22570: @1765516
      GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1765620), // Rule ID 11060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11060,
        GIR_EraseRootFromParent_Done,
      // Label 22571: @1765620
      GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1765724), // Rule ID 11061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11061,
        GIR_EraseRootFromParent_Done,
      // Label 22572: @1765724
      GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1765828), // Rule ID 11064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11064,
        GIR_EraseRootFromParent_Done,
      // Label 22573: @1765828
      GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1765932), // Rule ID 11065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11065,
        GIR_EraseRootFromParent_Done,
      // Label 22574: @1765932
      GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1766036), // Rule ID 11068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11068,
        GIR_EraseRootFromParent_Done,
      // Label 22575: @1766036
      GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1766140), // Rule ID 11069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11069,
        GIR_EraseRootFromParent_Done,
      // Label 22576: @1766140
      GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1766244), // Rule ID 11072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11072,
        GIR_EraseRootFromParent_Done,
      // Label 22577: @1766244
      GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1766348), // Rule ID 11073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11073,
        GIR_EraseRootFromParent_Done,
      // Label 22578: @1766348
      GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1766452), // Rule ID 11076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11076,
        GIR_EraseRootFromParent_Done,
      // Label 22579: @1766452
      GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1766556), // Rule ID 11077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11077,
        GIR_EraseRootFromParent_Done,
      // Label 22580: @1766556
      GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1766660), // Rule ID 11080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11080,
        GIR_EraseRootFromParent_Done,
      // Label 22581: @1766660
      GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1766764), // Rule ID 11081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11081,
        GIR_EraseRootFromParent_Done,
      // Label 22582: @1766764
      GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1766868), // Rule ID 11084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11084,
        GIR_EraseRootFromParent_Done,
      // Label 22583: @1766868
      GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1766972), // Rule ID 11085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11085,
        GIR_EraseRootFromParent_Done,
      // Label 22584: @1766972
      GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1767076), // Rule ID 11088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11088,
        GIR_EraseRootFromParent_Done,
      // Label 22585: @1767076
      GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1767180), // Rule ID 11089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11089,
        GIR_EraseRootFromParent_Done,
      // Label 22586: @1767180
      GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1767284), // Rule ID 11092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11092,
        GIR_EraseRootFromParent_Done,
      // Label 22587: @1767284
      GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1767388), // Rule ID 11093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11093,
        GIR_EraseRootFromParent_Done,
      // Label 22588: @1767388
      GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1767492), // Rule ID 11096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11096,
        GIR_EraseRootFromParent_Done,
      // Label 22589: @1767492
      GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1767596), // Rule ID 11097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11097,
        GIR_EraseRootFromParent_Done,
      // Label 22590: @1767596
      GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1767700), // Rule ID 11100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11100,
        GIR_EraseRootFromParent_Done,
      // Label 22591: @1767700
      GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1767804), // Rule ID 11101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11101,
        GIR_EraseRootFromParent_Done,
      // Label 22592: @1767804
      GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1767908), // Rule ID 11104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11104,
        GIR_EraseRootFromParent_Done,
      // Label 22593: @1767908
      GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1768012), // Rule ID 11105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11105,
        GIR_EraseRootFromParent_Done,
      // Label 22594: @1768012
      GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1768116), // Rule ID 11108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11108,
        GIR_EraseRootFromParent_Done,
      // Label 22595: @1768116
      GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1768220), // Rule ID 11109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11109,
        GIR_EraseRootFromParent_Done,
      // Label 22596: @1768220
      GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1768324), // Rule ID 11112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11112,
        GIR_EraseRootFromParent_Done,
      // Label 22597: @1768324
      GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1768428), // Rule ID 11113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11113,
        GIR_EraseRootFromParent_Done,
      // Label 22598: @1768428
      GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1768532), // Rule ID 11116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11116,
        GIR_EraseRootFromParent_Done,
      // Label 22599: @1768532
      GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1768636), // Rule ID 11117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11117,
        GIR_EraseRootFromParent_Done,
      // Label 22600: @1768636
      GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1768740), // Rule ID 11120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11120,
        GIR_EraseRootFromParent_Done,
      // Label 22601: @1768740
      GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1768844), // Rule ID 11121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11121,
        GIR_EraseRootFromParent_Done,
      // Label 22602: @1768844
      GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1768948), // Rule ID 11124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11124,
        GIR_EraseRootFromParent_Done,
      // Label 22603: @1768948
      GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1769052), // Rule ID 11125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11125,
        GIR_EraseRootFromParent_Done,
      // Label 22604: @1769052
      GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1769156), // Rule ID 11128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11128,
        GIR_EraseRootFromParent_Done,
      // Label 22605: @1769156
      GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1769260), // Rule ID 11129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11129,
        GIR_EraseRootFromParent_Done,
      // Label 22606: @1769260
      GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1769364), // Rule ID 11132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11132,
        GIR_EraseRootFromParent_Done,
      // Label 22607: @1769364
      GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1769468), // Rule ID 11133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11133,
        GIR_EraseRootFromParent_Done,
      // Label 22608: @1769468
      GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1769572), // Rule ID 11136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11136,
        GIR_EraseRootFromParent_Done,
      // Label 22609: @1769572
      GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1769676), // Rule ID 11137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11137,
        GIR_EraseRootFromParent_Done,
      // Label 22610: @1769676
      GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1769780), // Rule ID 11140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11140,
        GIR_EraseRootFromParent_Done,
      // Label 22611: @1769780
      GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1769884), // Rule ID 11141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11141,
        GIR_EraseRootFromParent_Done,
      // Label 22612: @1769884
      GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1769988), // Rule ID 11144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11144,
        GIR_EraseRootFromParent_Done,
      // Label 22613: @1769988
      GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1770092), // Rule ID 11145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11145,
        GIR_EraseRootFromParent_Done,
      // Label 22614: @1770092
      GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1770196), // Rule ID 11148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11148,
        GIR_EraseRootFromParent_Done,
      // Label 22615: @1770196
      GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1770300), // Rule ID 11149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11149,
        GIR_EraseRootFromParent_Done,
      // Label 22616: @1770300
      GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1770404), // Rule ID 11152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11152,
        GIR_EraseRootFromParent_Done,
      // Label 22617: @1770404
      GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1770508), // Rule ID 11153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11153,
        GIR_EraseRootFromParent_Done,
      // Label 22618: @1770508
      GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1770612), // Rule ID 11156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11156,
        GIR_EraseRootFromParent_Done,
      // Label 22619: @1770612
      GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1770716), // Rule ID 11157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11157,
        GIR_EraseRootFromParent_Done,
      // Label 22620: @1770716
      GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1770820), // Rule ID 11160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11160,
        GIR_EraseRootFromParent_Done,
      // Label 22621: @1770820
      GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1770924), // Rule ID 11161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11161,
        GIR_EraseRootFromParent_Done,
      // Label 22622: @1770924
      GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1771028), // Rule ID 11164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11164,
        GIR_EraseRootFromParent_Done,
      // Label 22623: @1771028
      GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1771132), // Rule ID 11165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11165,
        GIR_EraseRootFromParent_Done,
      // Label 22624: @1771132
      GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1771236), // Rule ID 11168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11168,
        GIR_EraseRootFromParent_Done,
      // Label 22625: @1771236
      GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1771340), // Rule ID 11169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11169,
        GIR_EraseRootFromParent_Done,
      // Label 22626: @1771340
      GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1771444), // Rule ID 11172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11172,
        GIR_EraseRootFromParent_Done,
      // Label 22627: @1771444
      GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1771548), // Rule ID 11173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11173,
        GIR_EraseRootFromParent_Done,
      // Label 22628: @1771548
      GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1771652), // Rule ID 11176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11176,
        GIR_EraseRootFromParent_Done,
      // Label 22629: @1771652
      GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1771756), // Rule ID 11177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11177,
        GIR_EraseRootFromParent_Done,
      // Label 22630: @1771756
      GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1771860), // Rule ID 11180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11180,
        GIR_EraseRootFromParent_Done,
      // Label 22631: @1771860
      GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1771964), // Rule ID 11181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11181,
        GIR_EraseRootFromParent_Done,
      // Label 22632: @1771964
      GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1772068), // Rule ID 11184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11184,
        GIR_EraseRootFromParent_Done,
      // Label 22633: @1772068
      GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1772172), // Rule ID 11185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11185,
        GIR_EraseRootFromParent_Done,
      // Label 22634: @1772172
      GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1772276), // Rule ID 11188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11188,
        GIR_EraseRootFromParent_Done,
      // Label 22635: @1772276
      GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1772380), // Rule ID 11189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11189,
        GIR_EraseRootFromParent_Done,
      // Label 22636: @1772380
      GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1772484), // Rule ID 11192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11192,
        GIR_EraseRootFromParent_Done,
      // Label 22637: @1772484
      GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1772588), // Rule ID 11193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11193,
        GIR_EraseRootFromParent_Done,
      // Label 22638: @1772588
      GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1772692), // Rule ID 11196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11196,
        GIR_EraseRootFromParent_Done,
      // Label 22639: @1772692
      GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1772796), // Rule ID 11197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11197,
        GIR_EraseRootFromParent_Done,
      // Label 22640: @1772796
      GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1772900), // Rule ID 11200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11200,
        GIR_EraseRootFromParent_Done,
      // Label 22641: @1772900
      GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1773004), // Rule ID 11201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11201,
        GIR_EraseRootFromParent_Done,
      // Label 22642: @1773004
      GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1773108), // Rule ID 11204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11204,
        GIR_EraseRootFromParent_Done,
      // Label 22643: @1773108
      GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1773212), // Rule ID 11205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11205,
        GIR_EraseRootFromParent_Done,
      // Label 22644: @1773212
      GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1773316), // Rule ID 11208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11208,
        GIR_EraseRootFromParent_Done,
      // Label 22645: @1773316
      GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1773420), // Rule ID 11209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11209,
        GIR_EraseRootFromParent_Done,
      // Label 22646: @1773420
      GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1773524), // Rule ID 11212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11212,
        GIR_EraseRootFromParent_Done,
      // Label 22647: @1773524
      GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1773628), // Rule ID 11213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11213,
        GIR_EraseRootFromParent_Done,
      // Label 22648: @1773628
      GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1773732), // Rule ID 11216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11216,
        GIR_EraseRootFromParent_Done,
      // Label 22649: @1773732
      GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1773836), // Rule ID 11217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11217,
        GIR_EraseRootFromParent_Done,
      // Label 22650: @1773836
      GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1773940), // Rule ID 11220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11220,
        GIR_EraseRootFromParent_Done,
      // Label 22651: @1773940
      GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1774044), // Rule ID 11221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11221,
        GIR_EraseRootFromParent_Done,
      // Label 22652: @1774044
      GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1774148), // Rule ID 11224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11224,
        GIR_EraseRootFromParent_Done,
      // Label 22653: @1774148
      GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1774252), // Rule ID 11225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11225,
        GIR_EraseRootFromParent_Done,
      // Label 22654: @1774252
      GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1774356), // Rule ID 11228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11228,
        GIR_EraseRootFromParent_Done,
      // Label 22655: @1774356
      GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1774460), // Rule ID 11229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11229,
        GIR_EraseRootFromParent_Done,
      // Label 22656: @1774460
      GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1774564), // Rule ID 11232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11232,
        GIR_EraseRootFromParent_Done,
      // Label 22657: @1774564
      GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1774668), // Rule ID 11233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11233,
        GIR_EraseRootFromParent_Done,
      // Label 22658: @1774668
      GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1774772), // Rule ID 11236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11236,
        GIR_EraseRootFromParent_Done,
      // Label 22659: @1774772
      GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1774876), // Rule ID 11237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11237,
        GIR_EraseRootFromParent_Done,
      // Label 22660: @1774876
      GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1774980), // Rule ID 11240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11240,
        GIR_EraseRootFromParent_Done,
      // Label 22661: @1774980
      GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1775084), // Rule ID 11241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11241,
        GIR_EraseRootFromParent_Done,
      // Label 22662: @1775084
      GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1775188), // Rule ID 11244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11244,
        GIR_EraseRootFromParent_Done,
      // Label 22663: @1775188
      GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1775292), // Rule ID 11245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11245,
        GIR_EraseRootFromParent_Done,
      // Label 22664: @1775292
      GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1775396), // Rule ID 11248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11248,
        GIR_EraseRootFromParent_Done,
      // Label 22665: @1775396
      GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1775500), // Rule ID 11249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11249,
        GIR_EraseRootFromParent_Done,
      // Label 22666: @1775500
      GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1775604), // Rule ID 11252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11252,
        GIR_EraseRootFromParent_Done,
      // Label 22667: @1775604
      GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1775708), // Rule ID 11253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11253,
        GIR_EraseRootFromParent_Done,
      // Label 22668: @1775708
      GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1775812), // Rule ID 11256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11256,
        GIR_EraseRootFromParent_Done,
      // Label 22669: @1775812
      GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1775916), // Rule ID 11257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11257,
        GIR_EraseRootFromParent_Done,
      // Label 22670: @1775916
      GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1776020), // Rule ID 11260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11260,
        GIR_EraseRootFromParent_Done,
      // Label 22671: @1776020
      GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1776124), // Rule ID 11261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11261,
        GIR_EraseRootFromParent_Done,
      // Label 22672: @1776124
      GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1776228), // Rule ID 11264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11264,
        GIR_EraseRootFromParent_Done,
      // Label 22673: @1776228
      GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1776332), // Rule ID 11265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11265,
        GIR_EraseRootFromParent_Done,
      // Label 22674: @1776332
      GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1776436), // Rule ID 11268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11268,
        GIR_EraseRootFromParent_Done,
      // Label 22675: @1776436
      GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1776540), // Rule ID 11269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11269,
        GIR_EraseRootFromParent_Done,
      // Label 22676: @1776540
      GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1776644), // Rule ID 11272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11272,
        GIR_EraseRootFromParent_Done,
      // Label 22677: @1776644
      GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1776748), // Rule ID 11273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11273,
        GIR_EraseRootFromParent_Done,
      // Label 22678: @1776748
      GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1776852), // Rule ID 11276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11276,
        GIR_EraseRootFromParent_Done,
      // Label 22679: @1776852
      GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1776956), // Rule ID 11277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11277,
        GIR_EraseRootFromParent_Done,
      // Label 22680: @1776956
      GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1777060), // Rule ID 11280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11280,
        GIR_EraseRootFromParent_Done,
      // Label 22681: @1777060
      GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1777164), // Rule ID 11281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11281,
        GIR_EraseRootFromParent_Done,
      // Label 22682: @1777164
      GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1777268), // Rule ID 11284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11284,
        GIR_EraseRootFromParent_Done,
      // Label 22683: @1777268
      GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1777372), // Rule ID 11285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11285,
        GIR_EraseRootFromParent_Done,
      // Label 22684: @1777372
      GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1777476), // Rule ID 11288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11288,
        GIR_EraseRootFromParent_Done,
      // Label 22685: @1777476
      GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1777580), // Rule ID 11289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11289,
        GIR_EraseRootFromParent_Done,
      // Label 22686: @1777580
      GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1777684), // Rule ID 11292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11292,
        GIR_EraseRootFromParent_Done,
      // Label 22687: @1777684
      GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1777788), // Rule ID 11293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11293,
        GIR_EraseRootFromParent_Done,
      // Label 22688: @1777788
      GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1777892), // Rule ID 11296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11296,
        GIR_EraseRootFromParent_Done,
      // Label 22689: @1777892
      GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1777996), // Rule ID 11297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11297,
        GIR_EraseRootFromParent_Done,
      // Label 22690: @1777996
      GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1778100), // Rule ID 11300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11300,
        GIR_EraseRootFromParent_Done,
      // Label 22691: @1778100
      GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1778204), // Rule ID 11301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11301,
        GIR_EraseRootFromParent_Done,
      // Label 22692: @1778204
      GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1778308), // Rule ID 11304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11304,
        GIR_EraseRootFromParent_Done,
      // Label 22693: @1778308
      GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1778412), // Rule ID 11305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11305,
        GIR_EraseRootFromParent_Done,
      // Label 22694: @1778412
      GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1778516), // Rule ID 11308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11308,
        GIR_EraseRootFromParent_Done,
      // Label 22695: @1778516
      GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1778620), // Rule ID 11309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11309,
        GIR_EraseRootFromParent_Done,
      // Label 22696: @1778620
      GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1778724), // Rule ID 11312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11312,
        GIR_EraseRootFromParent_Done,
      // Label 22697: @1778724
      GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1778828), // Rule ID 11313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11313,
        GIR_EraseRootFromParent_Done,
      // Label 22698: @1778828
      GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1778932), // Rule ID 11316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11316,
        GIR_EraseRootFromParent_Done,
      // Label 22699: @1778932
      GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1779036), // Rule ID 11317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11317,
        GIR_EraseRootFromParent_Done,
      // Label 22700: @1779036
      GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1779140), // Rule ID 11320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11320,
        GIR_EraseRootFromParent_Done,
      // Label 22701: @1779140
      GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1779244), // Rule ID 11321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11321,
        GIR_EraseRootFromParent_Done,
      // Label 22702: @1779244
      GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1779348), // Rule ID 11324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11324,
        GIR_EraseRootFromParent_Done,
      // Label 22703: @1779348
      GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1779452), // Rule ID 11325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11325,
        GIR_EraseRootFromParent_Done,
      // Label 22704: @1779452
      GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1779556), // Rule ID 11328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11328,
        GIR_EraseRootFromParent_Done,
      // Label 22705: @1779556
      GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1779660), // Rule ID 11329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11329,
        GIR_EraseRootFromParent_Done,
      // Label 22706: @1779660
      GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1779764), // Rule ID 11332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11332,
        GIR_EraseRootFromParent_Done,
      // Label 22707: @1779764
      GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1779868), // Rule ID 11333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11333,
        GIR_EraseRootFromParent_Done,
      // Label 22708: @1779868
      GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1779972), // Rule ID 11336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11336,
        GIR_EraseRootFromParent_Done,
      // Label 22709: @1779972
      GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1780076), // Rule ID 11337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11337,
        GIR_EraseRootFromParent_Done,
      // Label 22710: @1780076
      GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1780180), // Rule ID 11340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11340,
        GIR_EraseRootFromParent_Done,
      // Label 22711: @1780180
      GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1780284), // Rule ID 11341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11341,
        GIR_EraseRootFromParent_Done,
      // Label 22712: @1780284
      GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1780388), // Rule ID 11344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11344,
        GIR_EraseRootFromParent_Done,
      // Label 22713: @1780388
      GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1780492), // Rule ID 11345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11345,
        GIR_EraseRootFromParent_Done,
      // Label 22714: @1780492
      GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1780596), // Rule ID 11348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11348,
        GIR_EraseRootFromParent_Done,
      // Label 22715: @1780596
      GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1780700), // Rule ID 11349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11349,
        GIR_EraseRootFromParent_Done,
      // Label 22716: @1780700
      GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1780804), // Rule ID 11352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11352,
        GIR_EraseRootFromParent_Done,
      // Label 22717: @1780804
      GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1780908), // Rule ID 11353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11353,
        GIR_EraseRootFromParent_Done,
      // Label 22718: @1780908
      GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1781012), // Rule ID 11356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11356,
        GIR_EraseRootFromParent_Done,
      // Label 22719: @1781012
      GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1781116), // Rule ID 11357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11357,
        GIR_EraseRootFromParent_Done,
      // Label 22720: @1781116
      GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1781220), // Rule ID 11360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11360,
        GIR_EraseRootFromParent_Done,
      // Label 22721: @1781220
      GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1781324), // Rule ID 11361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11361,
        GIR_EraseRootFromParent_Done,
      // Label 22722: @1781324
      GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1781428), // Rule ID 11364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11364,
        GIR_EraseRootFromParent_Done,
      // Label 22723: @1781428
      GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1781532), // Rule ID 11365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11365,
        GIR_EraseRootFromParent_Done,
      // Label 22724: @1781532
      GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1781636), // Rule ID 11368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11368,
        GIR_EraseRootFromParent_Done,
      // Label 22725: @1781636
      GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1781740), // Rule ID 11369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11369,
        GIR_EraseRootFromParent_Done,
      // Label 22726: @1781740
      GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1781844), // Rule ID 11372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11372,
        GIR_EraseRootFromParent_Done,
      // Label 22727: @1781844
      GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1781948), // Rule ID 11373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11373,
        GIR_EraseRootFromParent_Done,
      // Label 22728: @1781948
      GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1782052), // Rule ID 11376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11376,
        GIR_EraseRootFromParent_Done,
      // Label 22729: @1782052
      GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1782156), // Rule ID 11377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11377,
        GIR_EraseRootFromParent_Done,
      // Label 22730: @1782156
      GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1782260), // Rule ID 11380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11380,
        GIR_EraseRootFromParent_Done,
      // Label 22731: @1782260
      GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1782364), // Rule ID 11381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11381,
        GIR_EraseRootFromParent_Done,
      // Label 22732: @1782364
      GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1782468), // Rule ID 11384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11384,
        GIR_EraseRootFromParent_Done,
      // Label 22733: @1782468
      GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1782572), // Rule ID 11385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11385,
        GIR_EraseRootFromParent_Done,
      // Label 22734: @1782572
      GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1782676), // Rule ID 11388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11388,
        GIR_EraseRootFromParent_Done,
      // Label 22735: @1782676
      GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1782780), // Rule ID 11389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11389,
        GIR_EraseRootFromParent_Done,
      // Label 22736: @1782780
      GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1782884), // Rule ID 11392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11392,
        GIR_EraseRootFromParent_Done,
      // Label 22737: @1782884
      GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1782988), // Rule ID 11393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11393,
        GIR_EraseRootFromParent_Done,
      // Label 22738: @1782988
      GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1783092), // Rule ID 11396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11396,
        GIR_EraseRootFromParent_Done,
      // Label 22739: @1783092
      GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1783196), // Rule ID 11397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11397,
        GIR_EraseRootFromParent_Done,
      // Label 22740: @1783196
      GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1783300), // Rule ID 11400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11400,
        GIR_EraseRootFromParent_Done,
      // Label 22741: @1783300
      GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1783404), // Rule ID 11401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11401,
        GIR_EraseRootFromParent_Done,
      // Label 22742: @1783404
      GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1783508), // Rule ID 11404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11404,
        GIR_EraseRootFromParent_Done,
      // Label 22743: @1783508
      GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1783612), // Rule ID 11405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11405,
        GIR_EraseRootFromParent_Done,
      // Label 22744: @1783612
      GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1783716), // Rule ID 11408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11408,
        GIR_EraseRootFromParent_Done,
      // Label 22745: @1783716
      GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1783820), // Rule ID 11409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11409,
        GIR_EraseRootFromParent_Done,
      // Label 22746: @1783820
      GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1783924), // Rule ID 11412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11412,
        GIR_EraseRootFromParent_Done,
      // Label 22747: @1783924
      GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1784028), // Rule ID 11413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11413,
        GIR_EraseRootFromParent_Done,
      // Label 22748: @1784028
      GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1784132), // Rule ID 11416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11416,
        GIR_EraseRootFromParent_Done,
      // Label 22749: @1784132
      GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1784236), // Rule ID 11417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11417,
        GIR_EraseRootFromParent_Done,
      // Label 22750: @1784236
      GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1784340), // Rule ID 11420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11420,
        GIR_EraseRootFromParent_Done,
      // Label 22751: @1784340
      GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1784444), // Rule ID 11421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11421,
        GIR_EraseRootFromParent_Done,
      // Label 22752: @1784444
      GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1784548), // Rule ID 11424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11424,
        GIR_EraseRootFromParent_Done,
      // Label 22753: @1784548
      GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1784652), // Rule ID 11425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11425,
        GIR_EraseRootFromParent_Done,
      // Label 22754: @1784652
      GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1784756), // Rule ID 11428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11428,
        GIR_EraseRootFromParent_Done,
      // Label 22755: @1784756
      GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1784860), // Rule ID 11429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11429,
        GIR_EraseRootFromParent_Done,
      // Label 22756: @1784860
      GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1784964), // Rule ID 11432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11432,
        GIR_EraseRootFromParent_Done,
      // Label 22757: @1784964
      GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1785068), // Rule ID 11433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11433,
        GIR_EraseRootFromParent_Done,
      // Label 22758: @1785068
      GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1785172), // Rule ID 11436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11436,
        GIR_EraseRootFromParent_Done,
      // Label 22759: @1785172
      GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1785276), // Rule ID 11437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11437,
        GIR_EraseRootFromParent_Done,
      // Label 22760: @1785276
      GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1785380), // Rule ID 11440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11440,
        GIR_EraseRootFromParent_Done,
      // Label 22761: @1785380
      GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1785484), // Rule ID 11441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11441,
        GIR_EraseRootFromParent_Done,
      // Label 22762: @1785484
      GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1785588), // Rule ID 11444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11444,
        GIR_EraseRootFromParent_Done,
      // Label 22763: @1785588
      GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1785692), // Rule ID 11445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11445,
        GIR_EraseRootFromParent_Done,
      // Label 22764: @1785692
      GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1785796), // Rule ID 11448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11448,
        GIR_EraseRootFromParent_Done,
      // Label 22765: @1785796
      GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1785900), // Rule ID 11449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11449,
        GIR_EraseRootFromParent_Done,
      // Label 22766: @1785900
      GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1786004), // Rule ID 11452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11452,
        GIR_EraseRootFromParent_Done,
      // Label 22767: @1786004
      GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1786108), // Rule ID 11453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11453,
        GIR_EraseRootFromParent_Done,
      // Label 22768: @1786108
      GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1786212), // Rule ID 11456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11456,
        GIR_EraseRootFromParent_Done,
      // Label 22769: @1786212
      GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1786316), // Rule ID 11457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11457,
        GIR_EraseRootFromParent_Done,
      // Label 22770: @1786316
      GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1786420), // Rule ID 11460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11460,
        GIR_EraseRootFromParent_Done,
      // Label 22771: @1786420
      GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1786524), // Rule ID 11461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11461,
        GIR_EraseRootFromParent_Done,
      // Label 22772: @1786524
      GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1786628), // Rule ID 11464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11464,
        GIR_EraseRootFromParent_Done,
      // Label 22773: @1786628
      GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1786732), // Rule ID 11465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11465,
        GIR_EraseRootFromParent_Done,
      // Label 22774: @1786732
      GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1786836), // Rule ID 11468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11468,
        GIR_EraseRootFromParent_Done,
      // Label 22775: @1786836
      GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1786940), // Rule ID 11469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11469,
        GIR_EraseRootFromParent_Done,
      // Label 22776: @1786940
      GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1787044), // Rule ID 11472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11472,
        GIR_EraseRootFromParent_Done,
      // Label 22777: @1787044
      GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1787148), // Rule ID 11473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11473,
        GIR_EraseRootFromParent_Done,
      // Label 22778: @1787148
      GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1787252), // Rule ID 11476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11476,
        GIR_EraseRootFromParent_Done,
      // Label 22779: @1787252
      GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1787356), // Rule ID 11477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11477,
        GIR_EraseRootFromParent_Done,
      // Label 22780: @1787356
      GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1787460), // Rule ID 11480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11480,
        GIR_EraseRootFromParent_Done,
      // Label 22781: @1787460
      GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1787564), // Rule ID 11481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11481,
        GIR_EraseRootFromParent_Done,
      // Label 22782: @1787564
      GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1787668), // Rule ID 11484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11484,
        GIR_EraseRootFromParent_Done,
      // Label 22783: @1787668
      GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1787772), // Rule ID 11485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11485,
        GIR_EraseRootFromParent_Done,
      // Label 22784: @1787772
      GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1787876), // Rule ID 11488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11488,
        GIR_EraseRootFromParent_Done,
      // Label 22785: @1787876
      GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1787980), // Rule ID 11489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11489,
        GIR_EraseRootFromParent_Done,
      // Label 22786: @1787980
      GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1788084), // Rule ID 11492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11492,
        GIR_EraseRootFromParent_Done,
      // Label 22787: @1788084
      GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1788188), // Rule ID 11493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11493,
        GIR_EraseRootFromParent_Done,
      // Label 22788: @1788188
      GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1788292), // Rule ID 11496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11496,
        GIR_EraseRootFromParent_Done,
      // Label 22789: @1788292
      GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1788396), // Rule ID 11497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11497,
        GIR_EraseRootFromParent_Done,
      // Label 22790: @1788396
      GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1788500), // Rule ID 11500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11500,
        GIR_EraseRootFromParent_Done,
      // Label 22791: @1788500
      GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1788604), // Rule ID 11501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11501,
        GIR_EraseRootFromParent_Done,
      // Label 22792: @1788604
      GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1788708), // Rule ID 11504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11504,
        GIR_EraseRootFromParent_Done,
      // Label 22793: @1788708
      GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1788812), // Rule ID 11505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11505,
        GIR_EraseRootFromParent_Done,
      // Label 22794: @1788812
      GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1788916), // Rule ID 11508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11508,
        GIR_EraseRootFromParent_Done,
      // Label 22795: @1788916
      GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1789020), // Rule ID 11509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11509,
        GIR_EraseRootFromParent_Done,
      // Label 22796: @1789020
      GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1789124), // Rule ID 11512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11512,
        GIR_EraseRootFromParent_Done,
      // Label 22797: @1789124
      GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1789228), // Rule ID 11513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11513,
        GIR_EraseRootFromParent_Done,
      // Label 22798: @1789228
      GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1789332), // Rule ID 11516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11516,
        GIR_EraseRootFromParent_Done,
      // Label 22799: @1789332
      GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1789436), // Rule ID 11517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11517,
        GIR_EraseRootFromParent_Done,
      // Label 22800: @1789436
      GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1789540), // Rule ID 11520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11520,
        GIR_EraseRootFromParent_Done,
      // Label 22801: @1789540
      GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1789644), // Rule ID 11521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11521,
        GIR_EraseRootFromParent_Done,
      // Label 22802: @1789644
      GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1789748), // Rule ID 11524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11524,
        GIR_EraseRootFromParent_Done,
      // Label 22803: @1789748
      GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1789852), // Rule ID 11525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11525,
        GIR_EraseRootFromParent_Done,
      // Label 22804: @1789852
      GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1789956), // Rule ID 11528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11528,
        GIR_EraseRootFromParent_Done,
      // Label 22805: @1789956
      GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1790060), // Rule ID 11529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11529,
        GIR_EraseRootFromParent_Done,
      // Label 22806: @1790060
      GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1790164), // Rule ID 11532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11532,
        GIR_EraseRootFromParent_Done,
      // Label 22807: @1790164
      GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1790268), // Rule ID 11533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11533,
        GIR_EraseRootFromParent_Done,
      // Label 22808: @1790268
      GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1790372), // Rule ID 11536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11536,
        GIR_EraseRootFromParent_Done,
      // Label 22809: @1790372
      GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1790476), // Rule ID 11537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11537,
        GIR_EraseRootFromParent_Done,
      // Label 22810: @1790476
      GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1790580), // Rule ID 11540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11540,
        GIR_EraseRootFromParent_Done,
      // Label 22811: @1790580
      GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1790684), // Rule ID 11541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11541,
        GIR_EraseRootFromParent_Done,
      // Label 22812: @1790684
      GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1790788), // Rule ID 11544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11544,
        GIR_EraseRootFromParent_Done,
      // Label 22813: @1790788
      GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1790892), // Rule ID 11545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11545,
        GIR_EraseRootFromParent_Done,
      // Label 22814: @1790892
      GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1790996), // Rule ID 11548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11548,
        GIR_EraseRootFromParent_Done,
      // Label 22815: @1790996
      GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1791100), // Rule ID 11549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11549,
        GIR_EraseRootFromParent_Done,
      // Label 22816: @1791100
      GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1791204), // Rule ID 11552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11552,
        GIR_EraseRootFromParent_Done,
      // Label 22817: @1791204
      GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1791308), // Rule ID 11553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11553,
        GIR_EraseRootFromParent_Done,
      // Label 22818: @1791308
      GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1791412), // Rule ID 11556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11556,
        GIR_EraseRootFromParent_Done,
      // Label 22819: @1791412
      GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1791516), // Rule ID 11557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11557,
        GIR_EraseRootFromParent_Done,
      // Label 22820: @1791516
      GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1791620), // Rule ID 11560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11560,
        GIR_EraseRootFromParent_Done,
      // Label 22821: @1791620
      GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1791724), // Rule ID 11561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11561,
        GIR_EraseRootFromParent_Done,
      // Label 22822: @1791724
      GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1791828), // Rule ID 11564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11564,
        GIR_EraseRootFromParent_Done,
      // Label 22823: @1791828
      GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1791932), // Rule ID 11565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11565,
        GIR_EraseRootFromParent_Done,
      // Label 22824: @1791932
      GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1792036), // Rule ID 11568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11568,
        GIR_EraseRootFromParent_Done,
      // Label 22825: @1792036
      GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1792140), // Rule ID 11569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11569,
        GIR_EraseRootFromParent_Done,
      // Label 22826: @1792140
      GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1792244), // Rule ID 11572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11572,
        GIR_EraseRootFromParent_Done,
      // Label 22827: @1792244
      GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1792348), // Rule ID 11573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11573,
        GIR_EraseRootFromParent_Done,
      // Label 22828: @1792348
      GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1792452), // Rule ID 11576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11576,
        GIR_EraseRootFromParent_Done,
      // Label 22829: @1792452
      GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1792556), // Rule ID 11577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11577,
        GIR_EraseRootFromParent_Done,
      // Label 22830: @1792556
      GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1792660), // Rule ID 11580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11580,
        GIR_EraseRootFromParent_Done,
      // Label 22831: @1792660
      GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1792764), // Rule ID 11581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11581,
        GIR_EraseRootFromParent_Done,
      // Label 22832: @1792764
      GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1792868), // Rule ID 11584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11584,
        GIR_EraseRootFromParent_Done,
      // Label 22833: @1792868
      GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1792972), // Rule ID 11585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11585,
        GIR_EraseRootFromParent_Done,
      // Label 22834: @1792972
      GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1793076), // Rule ID 11588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11588,
        GIR_EraseRootFromParent_Done,
      // Label 22835: @1793076
      GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1793180), // Rule ID 11589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11589,
        GIR_EraseRootFromParent_Done,
      // Label 22836: @1793180
      GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1793284), // Rule ID 11592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11592,
        GIR_EraseRootFromParent_Done,
      // Label 22837: @1793284
      GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1793388), // Rule ID 11593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11593,
        GIR_EraseRootFromParent_Done,
      // Label 22838: @1793388
      GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1793492), // Rule ID 11596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11596,
        GIR_EraseRootFromParent_Done,
      // Label 22839: @1793492
      GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1793596), // Rule ID 11597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11597,
        GIR_EraseRootFromParent_Done,
      // Label 22840: @1793596
      GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1793700), // Rule ID 11600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11600,
        GIR_EraseRootFromParent_Done,
      // Label 22841: @1793700
      GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1793804), // Rule ID 11601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11601,
        GIR_EraseRootFromParent_Done,
      // Label 22842: @1793804
      GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1793908), // Rule ID 11604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11604,
        GIR_EraseRootFromParent_Done,
      // Label 22843: @1793908
      GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1794012), // Rule ID 11605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11605,
        GIR_EraseRootFromParent_Done,
      // Label 22844: @1794012
      GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1794116), // Rule ID 11608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11608,
        GIR_EraseRootFromParent_Done,
      // Label 22845: @1794116
      GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1794220), // Rule ID 11609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11609,
        GIR_EraseRootFromParent_Done,
      // Label 22846: @1794220
      GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1794324), // Rule ID 11612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11612,
        GIR_EraseRootFromParent_Done,
      // Label 22847: @1794324
      GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1794428), // Rule ID 11613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11613,
        GIR_EraseRootFromParent_Done,
      // Label 22848: @1794428
      GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1794532), // Rule ID 11616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11616,
        GIR_EraseRootFromParent_Done,
      // Label 22849: @1794532
      GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1794636), // Rule ID 11617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11617,
        GIR_EraseRootFromParent_Done,
      // Label 22850: @1794636
      GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1794740), // Rule ID 11620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11620,
        GIR_EraseRootFromParent_Done,
      // Label 22851: @1794740
      GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1794844), // Rule ID 11621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11621,
        GIR_EraseRootFromParent_Done,
      // Label 22852: @1794844
      GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1794948), // Rule ID 11624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11624,
        GIR_EraseRootFromParent_Done,
      // Label 22853: @1794948
      GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1795052), // Rule ID 11625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11625,
        GIR_EraseRootFromParent_Done,
      // Label 22854: @1795052
      GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1795156), // Rule ID 11628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11628,
        GIR_EraseRootFromParent_Done,
      // Label 22855: @1795156
      GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1795260), // Rule ID 11629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10791:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11629,
        GIR_EraseRootFromParent_Done,
      // Label 22856: @1795260
      GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1795364), // Rule ID 11632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11632,
        GIR_EraseRootFromParent_Done,
      // Label 22857: @1795364
      GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1795468), // Rule ID 11633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10791:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11633,
        GIR_EraseRootFromParent_Done,
      // Label 22858: @1795468
      GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1795572), // Rule ID 11636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11636,
        GIR_EraseRootFromParent_Done,
      // Label 22859: @1795572
      GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1795676), // Rule ID 11637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10791:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11637,
        GIR_EraseRootFromParent_Done,
      // Label 22860: @1795676
      GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1795780), // Rule ID 11640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11640,
        GIR_EraseRootFromParent_Done,
      // Label 22861: @1795780
      GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1795884), // Rule ID 11641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10791:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11641,
        GIR_EraseRootFromParent_Done,
      // Label 22862: @1795884
      GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1795988), // Rule ID 11644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11644,
        GIR_EraseRootFromParent_Done,
      // Label 22863: @1795988
      GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1796092), // Rule ID 11645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11645,
        GIR_EraseRootFromParent_Done,
      // Label 22864: @1796092
      GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1796196), // Rule ID 11648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11648,
        GIR_EraseRootFromParent_Done,
      // Label 22865: @1796196
      GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1796300), // Rule ID 11649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11649,
        GIR_EraseRootFromParent_Done,
      // Label 22866: @1796300
      GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1796404), // Rule ID 11652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11652,
        GIR_EraseRootFromParent_Done,
      // Label 22867: @1796404
      GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1796508), // Rule ID 11653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11653,
        GIR_EraseRootFromParent_Done,
      // Label 22868: @1796508
      GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1796612), // Rule ID 11656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11656,
        GIR_EraseRootFromParent_Done,
      // Label 22869: @1796612
      GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1796716), // Rule ID 11657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11657,
        GIR_EraseRootFromParent_Done,
      // Label 22870: @1796716
      GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1796820), // Rule ID 11660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11660,
        GIR_EraseRootFromParent_Done,
      // Label 22871: @1796820
      GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1796924), // Rule ID 11661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11661,
        GIR_EraseRootFromParent_Done,
      // Label 22872: @1796924
      GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1797028), // Rule ID 11664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11664,
        GIR_EraseRootFromParent_Done,
      // Label 22873: @1797028
      GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1797132), // Rule ID 11665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11665,
        GIR_EraseRootFromParent_Done,
      // Label 22874: @1797132
      GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1797236), // Rule ID 11668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11668,
        GIR_EraseRootFromParent_Done,
      // Label 22875: @1797236
      GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1797340), // Rule ID 11669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11669,
        GIR_EraseRootFromParent_Done,
      // Label 22876: @1797340
      GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1797444), // Rule ID 11672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11672,
        GIR_EraseRootFromParent_Done,
      // Label 22877: @1797444
      GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1797548), // Rule ID 11673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11673,
        GIR_EraseRootFromParent_Done,
      // Label 22878: @1797548
      GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1797652), // Rule ID 11676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11676,
        GIR_EraseRootFromParent_Done,
      // Label 22879: @1797652
      GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1797756), // Rule ID 11677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11677,
        GIR_EraseRootFromParent_Done,
      // Label 22880: @1797756
      GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1797860), // Rule ID 11680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11680,
        GIR_EraseRootFromParent_Done,
      // Label 22881: @1797860
      GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1797964), // Rule ID 11681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10791:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11681,
        GIR_EraseRootFromParent_Done,
      // Label 22882: @1797964
      GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1798068), // Rule ID 11684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11684,
        GIR_EraseRootFromParent_Done,
      // Label 22883: @1798068
      GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1798172), // Rule ID 11685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10791:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11685,
        GIR_EraseRootFromParent_Done,
      // Label 22884: @1798172
      GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1798276), // Rule ID 11688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11688,
        GIR_EraseRootFromParent_Done,
      // Label 22885: @1798276
      GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1798380), // Rule ID 11689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10791:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11689,
        GIR_EraseRootFromParent_Done,
      // Label 22886: @1798380
      GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1798484), // Rule ID 11692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11692,
        GIR_EraseRootFromParent_Done,
      // Label 22887: @1798484
      GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1798588), // Rule ID 11693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11693,
        GIR_EraseRootFromParent_Done,
      // Label 22888: @1798588
      GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1798692), // Rule ID 11696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11696,
        GIR_EraseRootFromParent_Done,
      // Label 22889: @1798692
      GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1798796), // Rule ID 11697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11697,
        GIR_EraseRootFromParent_Done,
      // Label 22890: @1798796
      GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1798900), // Rule ID 11700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11700,
        GIR_EraseRootFromParent_Done,
      // Label 22891: @1798900
      GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1799004), // Rule ID 11701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11701,
        GIR_EraseRootFromParent_Done,
      // Label 22892: @1799004
      GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1799108), // Rule ID 11704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11704,
        GIR_EraseRootFromParent_Done,
      // Label 22893: @1799108
      GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1799212), // Rule ID 11705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11705,
        GIR_EraseRootFromParent_Done,
      // Label 22894: @1799212
      GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1799316), // Rule ID 11708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11708,
        GIR_EraseRootFromParent_Done,
      // Label 22895: @1799316
      GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1799420), // Rule ID 11709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11709,
        GIR_EraseRootFromParent_Done,
      // Label 22896: @1799420
      GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1799524), // Rule ID 11712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11712,
        GIR_EraseRootFromParent_Done,
      // Label 22897: @1799524
      GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1799628), // Rule ID 11713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11713,
        GIR_EraseRootFromParent_Done,
      // Label 22898: @1799628
      GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1799732), // Rule ID 11716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11716,
        GIR_EraseRootFromParent_Done,
      // Label 22899: @1799732
      GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1799836), // Rule ID 11717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11717,
        GIR_EraseRootFromParent_Done,
      // Label 22900: @1799836
      GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1799940), // Rule ID 11720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11720,
        GIR_EraseRootFromParent_Done,
      // Label 22901: @1799940
      GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1800044), // Rule ID 11721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11721,
        GIR_EraseRootFromParent_Done,
      // Label 22902: @1800044
      GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1800148), // Rule ID 11724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11724,
        GIR_EraseRootFromParent_Done,
      // Label 22903: @1800148
      GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1800252), // Rule ID 11725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11725,
        GIR_EraseRootFromParent_Done,
      // Label 22904: @1800252
      GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1800356), // Rule ID 11728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11728,
        GIR_EraseRootFromParent_Done,
      // Label 22905: @1800356
      GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1800460), // Rule ID 11729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11729,
        GIR_EraseRootFromParent_Done,
      // Label 22906: @1800460
      GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1800564), // Rule ID 11732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11732,
        GIR_EraseRootFromParent_Done,
      // Label 22907: @1800564
      GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1800668), // Rule ID 11733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11733,
        GIR_EraseRootFromParent_Done,
      // Label 22908: @1800668
      GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1800772), // Rule ID 11736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11736,
        GIR_EraseRootFromParent_Done,
      // Label 22909: @1800772
      GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1800876), // Rule ID 11737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11737,
        GIR_EraseRootFromParent_Done,
      // Label 22910: @1800876
      GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1800980), // Rule ID 11740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11740,
        GIR_EraseRootFromParent_Done,
      // Label 22911: @1800980
      GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1801084), // Rule ID 11741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11741,
        GIR_EraseRootFromParent_Done,
      // Label 22912: @1801084
      GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1801188), // Rule ID 11744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11744,
        GIR_EraseRootFromParent_Done,
      // Label 22913: @1801188
      GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1801292), // Rule ID 11745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11745,
        GIR_EraseRootFromParent_Done,
      // Label 22914: @1801292
      GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1801396), // Rule ID 11748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11748,
        GIR_EraseRootFromParent_Done,
      // Label 22915: @1801396
      GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1801500), // Rule ID 11749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11749,
        GIR_EraseRootFromParent_Done,
      // Label 22916: @1801500
      GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1801604), // Rule ID 11752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11752,
        GIR_EraseRootFromParent_Done,
      // Label 22917: @1801604
      GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1801708), // Rule ID 11753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11753,
        GIR_EraseRootFromParent_Done,
      // Label 22918: @1801708
      GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1801812), // Rule ID 11756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11756,
        GIR_EraseRootFromParent_Done,
      // Label 22919: @1801812
      GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1801916), // Rule ID 11757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11757,
        GIR_EraseRootFromParent_Done,
      // Label 22920: @1801916
      GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1802020), // Rule ID 11760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11760,
        GIR_EraseRootFromParent_Done,
      // Label 22921: @1802020
      GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1802124), // Rule ID 11761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11761,
        GIR_EraseRootFromParent_Done,
      // Label 22922: @1802124
      GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1802228), // Rule ID 11764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11764,
        GIR_EraseRootFromParent_Done,
      // Label 22923: @1802228
      GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1802332), // Rule ID 11765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11765,
        GIR_EraseRootFromParent_Done,
      // Label 22924: @1802332
      GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1802436), // Rule ID 11768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11768,
        GIR_EraseRootFromParent_Done,
      // Label 22925: @1802436
      GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1802540), // Rule ID 11769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11769,
        GIR_EraseRootFromParent_Done,
      // Label 22926: @1802540
      GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1802644), // Rule ID 11772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11772,
        GIR_EraseRootFromParent_Done,
      // Label 22927: @1802644
      GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1802748), // Rule ID 11773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11773,
        GIR_EraseRootFromParent_Done,
      // Label 22928: @1802748
      GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1802852), // Rule ID 11776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11776,
        GIR_EraseRootFromParent_Done,
      // Label 22929: @1802852
      GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1802956), // Rule ID 11777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11777,
        GIR_EraseRootFromParent_Done,
      // Label 22930: @1802956
      GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1803060), // Rule ID 11780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11780,
        GIR_EraseRootFromParent_Done,
      // Label 22931: @1803060
      GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1803164), // Rule ID 11781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11781,
        GIR_EraseRootFromParent_Done,
      // Label 22932: @1803164
      GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1803268), // Rule ID 11784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11784,
        GIR_EraseRootFromParent_Done,
      // Label 22933: @1803268
      GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1803372), // Rule ID 11785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11785,
        GIR_EraseRootFromParent_Done,
      // Label 22934: @1803372
      GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1803476), // Rule ID 11788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11788,
        GIR_EraseRootFromParent_Done,
      // Label 22935: @1803476
      GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1803580), // Rule ID 11789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11789,
        GIR_EraseRootFromParent_Done,
      // Label 22936: @1803580
      GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1803684), // Rule ID 11792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11792,
        GIR_EraseRootFromParent_Done,
      // Label 22937: @1803684
      GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1803788), // Rule ID 11793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11793,
        GIR_EraseRootFromParent_Done,
      // Label 22938: @1803788
      GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1803892), // Rule ID 11796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11796,
        GIR_EraseRootFromParent_Done,
      // Label 22939: @1803892
      GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1803996), // Rule ID 11797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11797,
        GIR_EraseRootFromParent_Done,
      // Label 22940: @1803996
      GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1804100), // Rule ID 11800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11800,
        GIR_EraseRootFromParent_Done,
      // Label 22941: @1804100
      GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1804204), // Rule ID 11801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11801,
        GIR_EraseRootFromParent_Done,
      // Label 22942: @1804204
      GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1804308), // Rule ID 11804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11804,
        GIR_EraseRootFromParent_Done,
      // Label 22943: @1804308
      GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1804412), // Rule ID 11805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10789:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11805,
        GIR_EraseRootFromParent_Done,
      // Label 22944: @1804412
      GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1804516), // Rule ID 11808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11808,
        GIR_EraseRootFromParent_Done,
      // Label 22945: @1804516
      GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1804620), // Rule ID 11809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10789:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11809,
        GIR_EraseRootFromParent_Done,
      // Label 22946: @1804620
      GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1804724), // Rule ID 11812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11812,
        GIR_EraseRootFromParent_Done,
      // Label 22947: @1804724
      GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1804828), // Rule ID 11813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10789:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11813,
        GIR_EraseRootFromParent_Done,
      // Label 22948: @1804828
      GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1804932), // Rule ID 11816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11816,
        GIR_EraseRootFromParent_Done,
      // Label 22949: @1804932
      GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1805036), // Rule ID 11817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10789:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11817,
        GIR_EraseRootFromParent_Done,
      // Label 22950: @1805036
      GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1805140), // Rule ID 11820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11820,
        GIR_EraseRootFromParent_Done,
      // Label 22951: @1805140
      GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1805244), // Rule ID 11821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11821,
        GIR_EraseRootFromParent_Done,
      // Label 22952: @1805244
      GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1805348), // Rule ID 11824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11824,
        GIR_EraseRootFromParent_Done,
      // Label 22953: @1805348
      GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1805452), // Rule ID 11825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11825,
        GIR_EraseRootFromParent_Done,
      // Label 22954: @1805452
      GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1805556), // Rule ID 11828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11828,
        GIR_EraseRootFromParent_Done,
      // Label 22955: @1805556
      GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1805660), // Rule ID 11829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11829,
        GIR_EraseRootFromParent_Done,
      // Label 22956: @1805660
      GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1805764), // Rule ID 11832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11832,
        GIR_EraseRootFromParent_Done,
      // Label 22957: @1805764
      GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1805868), // Rule ID 11833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11833,
        GIR_EraseRootFromParent_Done,
      // Label 22958: @1805868
      GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1805972), // Rule ID 11836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11836,
        GIR_EraseRootFromParent_Done,
      // Label 22959: @1805972
      GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1806076), // Rule ID 11837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11837,
        GIR_EraseRootFromParent_Done,
      // Label 22960: @1806076
      GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1806180), // Rule ID 11840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11840,
        GIR_EraseRootFromParent_Done,
      // Label 22961: @1806180
      GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1806284), // Rule ID 11841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11841,
        GIR_EraseRootFromParent_Done,
      // Label 22962: @1806284
      GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1806388), // Rule ID 11844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11844,
        GIR_EraseRootFromParent_Done,
      // Label 22963: @1806388
      GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1806492), // Rule ID 11845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11845,
        GIR_EraseRootFromParent_Done,
      // Label 22964: @1806492
      GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1806596), // Rule ID 11848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11848,
        GIR_EraseRootFromParent_Done,
      // Label 22965: @1806596
      GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1806700), // Rule ID 11849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11849,
        GIR_EraseRootFromParent_Done,
      // Label 22966: @1806700
      GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1806804), // Rule ID 11852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11852,
        GIR_EraseRootFromParent_Done,
      // Label 22967: @1806804
      GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1806908), // Rule ID 11853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11853,
        GIR_EraseRootFromParent_Done,
      // Label 22968: @1806908
      GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1807012), // Rule ID 11856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11856,
        GIR_EraseRootFromParent_Done,
      // Label 22969: @1807012
      GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1807116), // Rule ID 11857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10789:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11857,
        GIR_EraseRootFromParent_Done,
      // Label 22970: @1807116
      GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1807220), // Rule ID 11860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11860,
        GIR_EraseRootFromParent_Done,
      // Label 22971: @1807220
      GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1807324), // Rule ID 11861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10789:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11861,
        GIR_EraseRootFromParent_Done,
      // Label 22972: @1807324
      GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1807428), // Rule ID 11864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11864,
        GIR_EraseRootFromParent_Done,
      // Label 22973: @1807428
      GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1807532), // Rule ID 11865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10789:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11865,
        GIR_EraseRootFromParent_Done,
      // Label 22974: @1807532
      GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1807636), // Rule ID 11868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11868,
        GIR_EraseRootFromParent_Done,
      // Label 22975: @1807636
      GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1807740), // Rule ID 11869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11869,
        GIR_EraseRootFromParent_Done,
      // Label 22976: @1807740
      GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1807844), // Rule ID 11872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11872,
        GIR_EraseRootFromParent_Done,
      // Label 22977: @1807844
      GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1807948), // Rule ID 11873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11873,
        GIR_EraseRootFromParent_Done,
      // Label 22978: @1807948
      GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1808052), // Rule ID 11876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11876,
        GIR_EraseRootFromParent_Done,
      // Label 22979: @1808052
      GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1808156), // Rule ID 11877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11877,
        GIR_EraseRootFromParent_Done,
      // Label 22980: @1808156
      GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1808260), // Rule ID 11880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11880,
        GIR_EraseRootFromParent_Done,
      // Label 22981: @1808260
      GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1808364), // Rule ID 11881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11881,
        GIR_EraseRootFromParent_Done,
      // Label 22982: @1808364
      GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1808468), // Rule ID 11884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11884,
        GIR_EraseRootFromParent_Done,
      // Label 22983: @1808468
      GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1808572), // Rule ID 11885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11885,
        GIR_EraseRootFromParent_Done,
      // Label 22984: @1808572
      GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1808676), // Rule ID 11888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11888,
        GIR_EraseRootFromParent_Done,
      // Label 22985: @1808676
      GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1808780), // Rule ID 11889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11889,
        GIR_EraseRootFromParent_Done,
      // Label 22986: @1808780
      GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1808884), // Rule ID 11892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11892,
        GIR_EraseRootFromParent_Done,
      // Label 22987: @1808884
      GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1808988), // Rule ID 11893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11893,
        GIR_EraseRootFromParent_Done,
      // Label 22988: @1808988
      GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1809092), // Rule ID 11896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11896,
        GIR_EraseRootFromParent_Done,
      // Label 22989: @1809092
      GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1809196), // Rule ID 11897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11897,
        GIR_EraseRootFromParent_Done,
      // Label 22990: @1809196
      GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1809300), // Rule ID 11900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11900,
        GIR_EraseRootFromParent_Done,
      // Label 22991: @1809300
      GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1809404), // Rule ID 11901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11901,
        GIR_EraseRootFromParent_Done,
      // Label 22992: @1809404
      GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1809508), // Rule ID 11904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11904,
        GIR_EraseRootFromParent_Done,
      // Label 22993: @1809508
      GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1809612), // Rule ID 11905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11905,
        GIR_EraseRootFromParent_Done,
      // Label 22994: @1809612
      GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1809716), // Rule ID 11908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11908,
        GIR_EraseRootFromParent_Done,
      // Label 22995: @1809716
      GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1809820), // Rule ID 11909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11909,
        GIR_EraseRootFromParent_Done,
      // Label 22996: @1809820
      GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1809924), // Rule ID 11912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11912,
        GIR_EraseRootFromParent_Done,
      // Label 22997: @1809924
      GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1810028), // Rule ID 11913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11913,
        GIR_EraseRootFromParent_Done,
      // Label 22998: @1810028
      GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1810132), // Rule ID 11916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11916,
        GIR_EraseRootFromParent_Done,
      // Label 22999: @1810132
      GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1810236), // Rule ID 11917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11917,
        GIR_EraseRootFromParent_Done,
      // Label 23000: @1810236
      GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1810340), // Rule ID 11920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11920,
        GIR_EraseRootFromParent_Done,
      // Label 23001: @1810340
      GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1810444), // Rule ID 11921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11921,
        GIR_EraseRootFromParent_Done,
      // Label 23002: @1810444
      GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1810548), // Rule ID 11924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11924,
        GIR_EraseRootFromParent_Done,
      // Label 23003: @1810548
      GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1810652), // Rule ID 11925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11925,
        GIR_EraseRootFromParent_Done,
      // Label 23004: @1810652
      GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1810756), // Rule ID 11928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11928,
        GIR_EraseRootFromParent_Done,
      // Label 23005: @1810756
      GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1810860), // Rule ID 11929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11929,
        GIR_EraseRootFromParent_Done,
      // Label 23006: @1810860
      GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1810964), // Rule ID 11932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11932,
        GIR_EraseRootFromParent_Done,
      // Label 23007: @1810964
      GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1811068), // Rule ID 11933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11933,
        GIR_EraseRootFromParent_Done,
      // Label 23008: @1811068
      GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1811172), // Rule ID 11936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11936,
        GIR_EraseRootFromParent_Done,
      // Label 23009: @1811172
      GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1811276), // Rule ID 11937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11937,
        GIR_EraseRootFromParent_Done,
      // Label 23010: @1811276
      GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1811380), // Rule ID 11940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11940,
        GIR_EraseRootFromParent_Done,
      // Label 23011: @1811380
      GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1811484), // Rule ID 11941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11941,
        GIR_EraseRootFromParent_Done,
      // Label 23012: @1811484
      GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1811588), // Rule ID 11944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11944,
        GIR_EraseRootFromParent_Done,
      // Label 23013: @1811588
      GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1811692), // Rule ID 11945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11945,
        GIR_EraseRootFromParent_Done,
      // Label 23014: @1811692
      GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1811796), // Rule ID 11948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11948,
        GIR_EraseRootFromParent_Done,
      // Label 23015: @1811796
      GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1811900), // Rule ID 11949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11949,
        GIR_EraseRootFromParent_Done,
      // Label 23016: @1811900
      GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1812004), // Rule ID 11952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11952,
        GIR_EraseRootFromParent_Done,
      // Label 23017: @1812004
      GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1812108), // Rule ID 11953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11953,
        GIR_EraseRootFromParent_Done,
      // Label 23018: @1812108
      GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1812212), // Rule ID 11956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11956,
        GIR_EraseRootFromParent_Done,
      // Label 23019: @1812212
      GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1812316), // Rule ID 11957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11957,
        GIR_EraseRootFromParent_Done,
      // Label 23020: @1812316
      GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1812420), // Rule ID 11960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11960,
        GIR_EraseRootFromParent_Done,
      // Label 23021: @1812420
      GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1812524), // Rule ID 11961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11961,
        GIR_EraseRootFromParent_Done,
      // Label 23022: @1812524
      GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1812628), // Rule ID 11964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11964,
        GIR_EraseRootFromParent_Done,
      // Label 23023: @1812628
      GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1812732), // Rule ID 11965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11965,
        GIR_EraseRootFromParent_Done,
      // Label 23024: @1812732
      GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1812836), // Rule ID 11968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11968,
        GIR_EraseRootFromParent_Done,
      // Label 23025: @1812836
      GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1812940), // Rule ID 11969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11969,
        GIR_EraseRootFromParent_Done,
      // Label 23026: @1812940
      GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1813044), // Rule ID 11972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11972,
        GIR_EraseRootFromParent_Done,
      // Label 23027: @1813044
      GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1813148), // Rule ID 11973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11973,
        GIR_EraseRootFromParent_Done,
      // Label 23028: @1813148
      GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1813252), // Rule ID 11976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11976,
        GIR_EraseRootFromParent_Done,
      // Label 23029: @1813252
      GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1813356), // Rule ID 11977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11977,
        GIR_EraseRootFromParent_Done,
      // Label 23030: @1813356
      GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1813460), // Rule ID 11980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11980,
        GIR_EraseRootFromParent_Done,
      // Label 23031: @1813460
      GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1813564), // Rule ID 11981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11981,
        GIR_EraseRootFromParent_Done,
      // Label 23032: @1813564
      GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1813668), // Rule ID 11984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11984,
        GIR_EraseRootFromParent_Done,
      // Label 23033: @1813668
      GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1813772), // Rule ID 11985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11985,
        GIR_EraseRootFromParent_Done,
      // Label 23034: @1813772
      GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1813876), // Rule ID 11988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11988,
        GIR_EraseRootFromParent_Done,
      // Label 23035: @1813876
      GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1813980), // Rule ID 11989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11989,
        GIR_EraseRootFromParent_Done,
      // Label 23036: @1813980
      GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1814084), // Rule ID 11992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11992,
        GIR_EraseRootFromParent_Done,
      // Label 23037: @1814084
      GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1814188), // Rule ID 11993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11993,
        GIR_EraseRootFromParent_Done,
      // Label 23038: @1814188
      GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1814292), // Rule ID 11996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11996,
        GIR_EraseRootFromParent_Done,
      // Label 23039: @1814292
      GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1814396), // Rule ID 11997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11997,
        GIR_EraseRootFromParent_Done,
      // Label 23040: @1814396
      GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1814500), // Rule ID 12000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12000,
        GIR_EraseRootFromParent_Done,
      // Label 23041: @1814500
      GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1814604), // Rule ID 12001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12001,
        GIR_EraseRootFromParent_Done,
      // Label 23042: @1814604
      GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1814708), // Rule ID 12004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12004,
        GIR_EraseRootFromParent_Done,
      // Label 23043: @1814708
      GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1814812), // Rule ID 12005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12005,
        GIR_EraseRootFromParent_Done,
      // Label 23044: @1814812
      GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1814916), // Rule ID 12008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12008,
        GIR_EraseRootFromParent_Done,
      // Label 23045: @1814916
      GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1815020), // Rule ID 12009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12009,
        GIR_EraseRootFromParent_Done,
      // Label 23046: @1815020
      GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1815124), // Rule ID 12012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12012,
        GIR_EraseRootFromParent_Done,
      // Label 23047: @1815124
      GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1815228), // Rule ID 12013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12013,
        GIR_EraseRootFromParent_Done,
      // Label 23048: @1815228
      GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1815332), // Rule ID 12016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12016,
        GIR_EraseRootFromParent_Done,
      // Label 23049: @1815332
      GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1815436), // Rule ID 12017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12017,
        GIR_EraseRootFromParent_Done,
      // Label 23050: @1815436
      GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1815540), // Rule ID 12020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12020,
        GIR_EraseRootFromParent_Done,
      // Label 23051: @1815540
      GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1815644), // Rule ID 12021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12021,
        GIR_EraseRootFromParent_Done,
      // Label 23052: @1815644
      GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1815748), // Rule ID 12024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12024,
        GIR_EraseRootFromParent_Done,
      // Label 23053: @1815748
      GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1815852), // Rule ID 12025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12025,
        GIR_EraseRootFromParent_Done,
      // Label 23054: @1815852
      GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1815956), // Rule ID 12028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12028,
        GIR_EraseRootFromParent_Done,
      // Label 23055: @1815956
      GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1816060), // Rule ID 12029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12029,
        GIR_EraseRootFromParent_Done,
      // Label 23056: @1816060
      GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1816164), // Rule ID 12032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12032,
        GIR_EraseRootFromParent_Done,
      // Label 23057: @1816164
      GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1816268), // Rule ID 12033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12033,
        GIR_EraseRootFromParent_Done,
      // Label 23058: @1816268
      GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1816372), // Rule ID 12036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12036,
        GIR_EraseRootFromParent_Done,
      // Label 23059: @1816372
      GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1816476), // Rule ID 12037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12037,
        GIR_EraseRootFromParent_Done,
      // Label 23060: @1816476
      GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1816580), // Rule ID 12040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12040,
        GIR_EraseRootFromParent_Done,
      // Label 23061: @1816580
      GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1816684), // Rule ID 12041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12041,
        GIR_EraseRootFromParent_Done,
      // Label 23062: @1816684
      GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1816788), // Rule ID 12044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12044,
        GIR_EraseRootFromParent_Done,
      // Label 23063: @1816788
      GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1816892), // Rule ID 12045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12045,
        GIR_EraseRootFromParent_Done,
      // Label 23064: @1816892
      GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1816996), // Rule ID 12048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12048,
        GIR_EraseRootFromParent_Done,
      // Label 23065: @1816996
      GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1817100), // Rule ID 12049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12049,
        GIR_EraseRootFromParent_Done,
      // Label 23066: @1817100
      GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1817204), // Rule ID 12052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12052,
        GIR_EraseRootFromParent_Done,
      // Label 23067: @1817204
      GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1817308), // Rule ID 12053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12053,
        GIR_EraseRootFromParent_Done,
      // Label 23068: @1817308
      GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1817412), // Rule ID 12056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12056,
        GIR_EraseRootFromParent_Done,
      // Label 23069: @1817412
      GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1817516), // Rule ID 12057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12057,
        GIR_EraseRootFromParent_Done,
      // Label 23070: @1817516
      GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1817620), // Rule ID 12060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12060,
        GIR_EraseRootFromParent_Done,
      // Label 23071: @1817620
      GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1817724), // Rule ID 12061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12061,
        GIR_EraseRootFromParent_Done,
      // Label 23072: @1817724
      GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1817828), // Rule ID 12064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12064,
        GIR_EraseRootFromParent_Done,
      // Label 23073: @1817828
      GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1817932), // Rule ID 12065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12065,
        GIR_EraseRootFromParent_Done,
      // Label 23074: @1817932
      GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1818036), // Rule ID 12068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12068,
        GIR_EraseRootFromParent_Done,
      // Label 23075: @1818036
      GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1818140), // Rule ID 12069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12069,
        GIR_EraseRootFromParent_Done,
      // Label 23076: @1818140
      GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1818244), // Rule ID 12072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12072,
        GIR_EraseRootFromParent_Done,
      // Label 23077: @1818244
      GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1818348), // Rule ID 12073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12073,
        GIR_EraseRootFromParent_Done,
      // Label 23078: @1818348
      GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1818452), // Rule ID 12076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12076,
        GIR_EraseRootFromParent_Done,
      // Label 23079: @1818452
      GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1818556), // Rule ID 12077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12077,
        GIR_EraseRootFromParent_Done,
      // Label 23080: @1818556
      GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1818660), // Rule ID 12080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12080,
        GIR_EraseRootFromParent_Done,
      // Label 23081: @1818660
      GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1818764), // Rule ID 12081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12081,
        GIR_EraseRootFromParent_Done,
      // Label 23082: @1818764
      GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1818868), // Rule ID 12084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12084,
        GIR_EraseRootFromParent_Done,
      // Label 23083: @1818868
      GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1818972), // Rule ID 12085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12085,
        GIR_EraseRootFromParent_Done,
      // Label 23084: @1818972
      GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1819076), // Rule ID 12088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12088,
        GIR_EraseRootFromParent_Done,
      // Label 23085: @1819076
      GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1819180), // Rule ID 12089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12089,
        GIR_EraseRootFromParent_Done,
      // Label 23086: @1819180
      GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1819284), // Rule ID 12092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12092,
        GIR_EraseRootFromParent_Done,
      // Label 23087: @1819284
      GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1819388), // Rule ID 12093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12093,
        GIR_EraseRootFromParent_Done,
      // Label 23088: @1819388
      GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1819492), // Rule ID 12096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12096,
        GIR_EraseRootFromParent_Done,
      // Label 23089: @1819492
      GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1819596), // Rule ID 12097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12097,
        GIR_EraseRootFromParent_Done,
      // Label 23090: @1819596
      GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1819700), // Rule ID 12100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12100,
        GIR_EraseRootFromParent_Done,
      // Label 23091: @1819700
      GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1819804), // Rule ID 12101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12101,
        GIR_EraseRootFromParent_Done,
      // Label 23092: @1819804
      GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1819908), // Rule ID 12104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12104,
        GIR_EraseRootFromParent_Done,
      // Label 23093: @1819908
      GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1820012), // Rule ID 12105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12105,
        GIR_EraseRootFromParent_Done,
      // Label 23094: @1820012
      GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1820116), // Rule ID 12108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12108,
        GIR_EraseRootFromParent_Done,
      // Label 23095: @1820116
      GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1820220), // Rule ID 12109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12109,
        GIR_EraseRootFromParent_Done,
      // Label 23096: @1820220
      GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1820324), // Rule ID 12112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12112,
        GIR_EraseRootFromParent_Done,
      // Label 23097: @1820324
      GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1820428), // Rule ID 12113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12113,
        GIR_EraseRootFromParent_Done,
      // Label 23098: @1820428
      GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1820532), // Rule ID 12116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12116,
        GIR_EraseRootFromParent_Done,
      // Label 23099: @1820532
      GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1820636), // Rule ID 12117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12117,
        GIR_EraseRootFromParent_Done,
      // Label 23100: @1820636
      GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1820740), // Rule ID 12120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12120,
        GIR_EraseRootFromParent_Done,
      // Label 23101: @1820740
      GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1820844), // Rule ID 12121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12121,
        GIR_EraseRootFromParent_Done,
      // Label 23102: @1820844
      GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1820948), // Rule ID 12124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12124,
        GIR_EraseRootFromParent_Done,
      // Label 23103: @1820948
      GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1821052), // Rule ID 12125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12125,
        GIR_EraseRootFromParent_Done,
      // Label 23104: @1821052
      GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1821156), // Rule ID 12128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12128,
        GIR_EraseRootFromParent_Done,
      // Label 23105: @1821156
      GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1821260), // Rule ID 12129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12129,
        GIR_EraseRootFromParent_Done,
      // Label 23106: @1821260
      GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1821364), // Rule ID 12132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12132,
        GIR_EraseRootFromParent_Done,
      // Label 23107: @1821364
      GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1821468), // Rule ID 12133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12133,
        GIR_EraseRootFromParent_Done,
      // Label 23108: @1821468
      GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1821572), // Rule ID 12136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12136,
        GIR_EraseRootFromParent_Done,
      // Label 23109: @1821572
      GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1821676), // Rule ID 12137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12137,
        GIR_EraseRootFromParent_Done,
      // Label 23110: @1821676
      GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1821780), // Rule ID 12140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12140,
        GIR_EraseRootFromParent_Done,
      // Label 23111: @1821780
      GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1821884), // Rule ID 12141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12141,
        GIR_EraseRootFromParent_Done,
      // Label 23112: @1821884
      GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1821988), // Rule ID 12144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12144,
        GIR_EraseRootFromParent_Done,
      // Label 23113: @1821988
      GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1822092), // Rule ID 12145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12145,
        GIR_EraseRootFromParent_Done,
      // Label 23114: @1822092
      GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1822196), // Rule ID 12148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12148,
        GIR_EraseRootFromParent_Done,
      // Label 23115: @1822196
      GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1822300), // Rule ID 12149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12149,
        GIR_EraseRootFromParent_Done,
      // Label 23116: @1822300
      GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1822404), // Rule ID 12152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12152,
        GIR_EraseRootFromParent_Done,
      // Label 23117: @1822404
      GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1822508), // Rule ID 12153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12153,
        GIR_EraseRootFromParent_Done,
      // Label 23118: @1822508
      GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1822612), // Rule ID 12156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12156,
        GIR_EraseRootFromParent_Done,
      // Label 23119: @1822612
      GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1822716), // Rule ID 12157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12157,
        GIR_EraseRootFromParent_Done,
      // Label 23120: @1822716
      GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1822820), // Rule ID 12160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12160,
        GIR_EraseRootFromParent_Done,
      // Label 23121: @1822820
      GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1822924), // Rule ID 12161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12161,
        GIR_EraseRootFromParent_Done,
      // Label 23122: @1822924
      GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1823028), // Rule ID 12164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12164,
        GIR_EraseRootFromParent_Done,
      // Label 23123: @1823028
      GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1823132), // Rule ID 12165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12165,
        GIR_EraseRootFromParent_Done,
      // Label 23124: @1823132
      GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1823236), // Rule ID 12168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12168,
        GIR_EraseRootFromParent_Done,
      // Label 23125: @1823236
      GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1823340), // Rule ID 12169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12169,
        GIR_EraseRootFromParent_Done,
      // Label 23126: @1823340
      GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1823444), // Rule ID 12172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12172,
        GIR_EraseRootFromParent_Done,
      // Label 23127: @1823444
      GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1823548), // Rule ID 12173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12173,
        GIR_EraseRootFromParent_Done,
      // Label 23128: @1823548
      GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1823652), // Rule ID 12176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12176,
        GIR_EraseRootFromParent_Done,
      // Label 23129: @1823652
      GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1823756), // Rule ID 12177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12177,
        GIR_EraseRootFromParent_Done,
      // Label 23130: @1823756
      GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1823860), // Rule ID 12180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12180,
        GIR_EraseRootFromParent_Done,
      // Label 23131: @1823860
      GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1823964), // Rule ID 12181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12181,
        GIR_EraseRootFromParent_Done,
      // Label 23132: @1823964
      GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1824068), // Rule ID 12184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12184,
        GIR_EraseRootFromParent_Done,
      // Label 23133: @1824068
      GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1824172), // Rule ID 12185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12185,
        GIR_EraseRootFromParent_Done,
      // Label 23134: @1824172
      GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1824276), // Rule ID 12188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12188,
        GIR_EraseRootFromParent_Done,
      // Label 23135: @1824276
      GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1824380), // Rule ID 12189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12189,
        GIR_EraseRootFromParent_Done,
      // Label 23136: @1824380
      GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1824484), // Rule ID 12192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12192,
        GIR_EraseRootFromParent_Done,
      // Label 23137: @1824484
      GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1824588), // Rule ID 12193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12193,
        GIR_EraseRootFromParent_Done,
      // Label 23138: @1824588
      GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1824692), // Rule ID 12196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12196,
        GIR_EraseRootFromParent_Done,
      // Label 23139: @1824692
      GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1824796), // Rule ID 12197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12197,
        GIR_EraseRootFromParent_Done,
      // Label 23140: @1824796
      GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1824900), // Rule ID 12200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12200,
        GIR_EraseRootFromParent_Done,
      // Label 23141: @1824900
      GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1825004), // Rule ID 12201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12201,
        GIR_EraseRootFromParent_Done,
      // Label 23142: @1825004
      GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1825108), // Rule ID 12204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12204,
        GIR_EraseRootFromParent_Done,
      // Label 23143: @1825108
      GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1825212), // Rule ID 12205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12205,
        GIR_EraseRootFromParent_Done,
      // Label 23144: @1825212
      GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1825316), // Rule ID 12208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12208,
        GIR_EraseRootFromParent_Done,
      // Label 23145: @1825316
      GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1825420), // Rule ID 12209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12209,
        GIR_EraseRootFromParent_Done,
      // Label 23146: @1825420
      GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1825524), // Rule ID 12212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12212,
        GIR_EraseRootFromParent_Done,
      // Label 23147: @1825524
      GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1825628), // Rule ID 12213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12213,
        GIR_EraseRootFromParent_Done,
      // Label 23148: @1825628
      GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1825732), // Rule ID 12216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12216,
        GIR_EraseRootFromParent_Done,
      // Label 23149: @1825732
      GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1825836), // Rule ID 12217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12217,
        GIR_EraseRootFromParent_Done,
      // Label 23150: @1825836
      GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1825940), // Rule ID 12220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12220,
        GIR_EraseRootFromParent_Done,
      // Label 23151: @1825940
      GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1826044), // Rule ID 12221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12221,
        GIR_EraseRootFromParent_Done,
      // Label 23152: @1826044
      GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1826148), // Rule ID 12224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12224,
        GIR_EraseRootFromParent_Done,
      // Label 23153: @1826148
      GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1826252), // Rule ID 12225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12225,
        GIR_EraseRootFromParent_Done,
      // Label 23154: @1826252
      GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1826356), // Rule ID 12228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12228,
        GIR_EraseRootFromParent_Done,
      // Label 23155: @1826356
      GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1826460), // Rule ID 12229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12229,
        GIR_EraseRootFromParent_Done,
      // Label 23156: @1826460
      GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1826564), // Rule ID 12232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12232,
        GIR_EraseRootFromParent_Done,
      // Label 23157: @1826564
      GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1826668), // Rule ID 12233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12233,
        GIR_EraseRootFromParent_Done,
      // Label 23158: @1826668
      GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1826772), // Rule ID 12236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12236,
        GIR_EraseRootFromParent_Done,
      // Label 23159: @1826772
      GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1826876), // Rule ID 12237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12237,
        GIR_EraseRootFromParent_Done,
      // Label 23160: @1826876
      GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1826980), // Rule ID 12240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12240,
        GIR_EraseRootFromParent_Done,
      // Label 23161: @1826980
      GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1827084), // Rule ID 12241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12241,
        GIR_EraseRootFromParent_Done,
      // Label 23162: @1827084
      GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1827188), // Rule ID 12244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12244,
        GIR_EraseRootFromParent_Done,
      // Label 23163: @1827188
      GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1827292), // Rule ID 12245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12245,
        GIR_EraseRootFromParent_Done,
      // Label 23164: @1827292
      GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1827396), // Rule ID 12248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12248,
        GIR_EraseRootFromParent_Done,
      // Label 23165: @1827396
      GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1827500), // Rule ID 12249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12249,
        GIR_EraseRootFromParent_Done,
      // Label 23166: @1827500
      GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1827604), // Rule ID 12252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12252,
        GIR_EraseRootFromParent_Done,
      // Label 23167: @1827604
      GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1827708), // Rule ID 12253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12253,
        GIR_EraseRootFromParent_Done,
      // Label 23168: @1827708
      GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1827812), // Rule ID 12256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12256,
        GIR_EraseRootFromParent_Done,
      // Label 23169: @1827812
      GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1827916), // Rule ID 12257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12257,
        GIR_EraseRootFromParent_Done,
      // Label 23170: @1827916
      GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1828020), // Rule ID 12260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12260,
        GIR_EraseRootFromParent_Done,
      // Label 23171: @1828020
      GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1828124), // Rule ID 12261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12261,
        GIR_EraseRootFromParent_Done,
      // Label 23172: @1828124
      GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1828228), // Rule ID 12264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12264,
        GIR_EraseRootFromParent_Done,
      // Label 23173: @1828228
      GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1828332), // Rule ID 12265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12265,
        GIR_EraseRootFromParent_Done,
      // Label 23174: @1828332
      GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1828436), // Rule ID 12268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12268,
        GIR_EraseRootFromParent_Done,
      // Label 23175: @1828436
      GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1828540), // Rule ID 12269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12269,
        GIR_EraseRootFromParent_Done,
      // Label 23176: @1828540
      GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1828644), // Rule ID 12272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12272,
        GIR_EraseRootFromParent_Done,
      // Label 23177: @1828644
      GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1828748), // Rule ID 12273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12273,
        GIR_EraseRootFromParent_Done,
      // Label 23178: @1828748
      GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1828852), // Rule ID 12276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12276,
        GIR_EraseRootFromParent_Done,
      // Label 23179: @1828852
      GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1828956), // Rule ID 12277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12277,
        GIR_EraseRootFromParent_Done,
      // Label 23180: @1828956
      GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1829060), // Rule ID 12280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12280,
        GIR_EraseRootFromParent_Done,
      // Label 23181: @1829060
      GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1829164), // Rule ID 12281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12281,
        GIR_EraseRootFromParent_Done,
      // Label 23182: @1829164
      GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1829268), // Rule ID 12284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12284,
        GIR_EraseRootFromParent_Done,
      // Label 23183: @1829268
      GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1829372), // Rule ID 12285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12285,
        GIR_EraseRootFromParent_Done,
      // Label 23184: @1829372
      GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1829476), // Rule ID 12288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12288,
        GIR_EraseRootFromParent_Done,
      // Label 23185: @1829476
      GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1829580), // Rule ID 12289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12289,
        GIR_EraseRootFromParent_Done,
      // Label 23186: @1829580
      GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1829684), // Rule ID 12292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12292,
        GIR_EraseRootFromParent_Done,
      // Label 23187: @1829684
      GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1829788), // Rule ID 12293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12293,
        GIR_EraseRootFromParent_Done,
      // Label 23188: @1829788
      GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1829892), // Rule ID 12296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12296,
        GIR_EraseRootFromParent_Done,
      // Label 23189: @1829892
      GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1829996), // Rule ID 12297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12297,
        GIR_EraseRootFromParent_Done,
      // Label 23190: @1829996
      GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1830100), // Rule ID 12300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12300,
        GIR_EraseRootFromParent_Done,
      // Label 23191: @1830100
      GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1830204), // Rule ID 12301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12301,
        GIR_EraseRootFromParent_Done,
      // Label 23192: @1830204
      GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1830308), // Rule ID 12304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12304,
        GIR_EraseRootFromParent_Done,
      // Label 23193: @1830308
      GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1830412), // Rule ID 12305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12305,
        GIR_EraseRootFromParent_Done,
      // Label 23194: @1830412
      GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1830516), // Rule ID 12308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12308,
        GIR_EraseRootFromParent_Done,
      // Label 23195: @1830516
      GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1830620), // Rule ID 12309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12309,
        GIR_EraseRootFromParent_Done,
      // Label 23196: @1830620
      GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1830724), // Rule ID 12312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12312,
        GIR_EraseRootFromParent_Done,
      // Label 23197: @1830724
      GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1830828), // Rule ID 12313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12313,
        GIR_EraseRootFromParent_Done,
      // Label 23198: @1830828
      GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1830932), // Rule ID 12316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12316,
        GIR_EraseRootFromParent_Done,
      // Label 23199: @1830932
      GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1831036), // Rule ID 12317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12317,
        GIR_EraseRootFromParent_Done,
      // Label 23200: @1831036
      GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1831140), // Rule ID 12320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12320,
        GIR_EraseRootFromParent_Done,
      // Label 23201: @1831140
      GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1831244), // Rule ID 12321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12321,
        GIR_EraseRootFromParent_Done,
      // Label 23202: @1831244
      GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1831348), // Rule ID 12324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12324,
        GIR_EraseRootFromParent_Done,
      // Label 23203: @1831348
      GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1831452), // Rule ID 12325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12325,
        GIR_EraseRootFromParent_Done,
      // Label 23204: @1831452
      GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1831556), // Rule ID 12328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12328,
        GIR_EraseRootFromParent_Done,
      // Label 23205: @1831556
      GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1831660), // Rule ID 12329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12329,
        GIR_EraseRootFromParent_Done,
      // Label 23206: @1831660
      GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1831764), // Rule ID 12332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12332,
        GIR_EraseRootFromParent_Done,
      // Label 23207: @1831764
      GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1831868), // Rule ID 12333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12333,
        GIR_EraseRootFromParent_Done,
      // Label 23208: @1831868
      GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1831972), // Rule ID 12336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12336,
        GIR_EraseRootFromParent_Done,
      // Label 23209: @1831972
      GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1832076), // Rule ID 12337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12337,
        GIR_EraseRootFromParent_Done,
      // Label 23210: @1832076
      GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1832180), // Rule ID 12340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12340,
        GIR_EraseRootFromParent_Done,
      // Label 23211: @1832180
      GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1832284), // Rule ID 12341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12341,
        GIR_EraseRootFromParent_Done,
      // Label 23212: @1832284
      GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1832388), // Rule ID 12344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12344,
        GIR_EraseRootFromParent_Done,
      // Label 23213: @1832388
      GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1832492), // Rule ID 12345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12345,
        GIR_EraseRootFromParent_Done,
      // Label 23214: @1832492
      GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1832596), // Rule ID 12348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12348,
        GIR_EraseRootFromParent_Done,
      // Label 23215: @1832596
      GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1832700), // Rule ID 12349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12349,
        GIR_EraseRootFromParent_Done,
      // Label 23216: @1832700
      GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1832804), // Rule ID 12352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12352,
        GIR_EraseRootFromParent_Done,
      // Label 23217: @1832804
      GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1832908), // Rule ID 12353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12353,
        GIR_EraseRootFromParent_Done,
      // Label 23218: @1832908
      GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1833012), // Rule ID 12356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12356,
        GIR_EraseRootFromParent_Done,
      // Label 23219: @1833012
      GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1833116), // Rule ID 12357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12357,
        GIR_EraseRootFromParent_Done,
      // Label 23220: @1833116
      GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1833220), // Rule ID 12360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12360,
        GIR_EraseRootFromParent_Done,
      // Label 23221: @1833220
      GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1833324), // Rule ID 12361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12361,
        GIR_EraseRootFromParent_Done,
      // Label 23222: @1833324
      GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1833428), // Rule ID 12364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12364,
        GIR_EraseRootFromParent_Done,
      // Label 23223: @1833428
      GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1833532), // Rule ID 12365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12365,
        GIR_EraseRootFromParent_Done,
      // Label 23224: @1833532
      GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1833636), // Rule ID 12368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12368,
        GIR_EraseRootFromParent_Done,
      // Label 23225: @1833636
      GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1833740), // Rule ID 12369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12369,
        GIR_EraseRootFromParent_Done,
      // Label 23226: @1833740
      GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1833844), // Rule ID 12372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12372,
        GIR_EraseRootFromParent_Done,
      // Label 23227: @1833844
      GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1833948), // Rule ID 12373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12373,
        GIR_EraseRootFromParent_Done,
      // Label 23228: @1833948
      GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1834052), // Rule ID 12376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12376,
        GIR_EraseRootFromParent_Done,
      // Label 23229: @1834052
      GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1834156), // Rule ID 12377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12377,
        GIR_EraseRootFromParent_Done,
      // Label 23230: @1834156
      GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1834260), // Rule ID 12380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12380,
        GIR_EraseRootFromParent_Done,
      // Label 23231: @1834260
      GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1834364), // Rule ID 12381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12381,
        GIR_EraseRootFromParent_Done,
      // Label 23232: @1834364
      GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1834468), // Rule ID 12384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12384,
        GIR_EraseRootFromParent_Done,
      // Label 23233: @1834468
      GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1834572), // Rule ID 12385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12385,
        GIR_EraseRootFromParent_Done,
      // Label 23234: @1834572
      GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1834676), // Rule ID 12388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12388,
        GIR_EraseRootFromParent_Done,
      // Label 23235: @1834676
      GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1834780), // Rule ID 12389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12389,
        GIR_EraseRootFromParent_Done,
      // Label 23236: @1834780
      GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1834884), // Rule ID 12392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12392,
        GIR_EraseRootFromParent_Done,
      // Label 23237: @1834884
      GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1834988), // Rule ID 12393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12393,
        GIR_EraseRootFromParent_Done,
      // Label 23238: @1834988
      GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1835092), // Rule ID 12396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12396,
        GIR_EraseRootFromParent_Done,
      // Label 23239: @1835092
      GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1835196), // Rule ID 12397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12397,
        GIR_EraseRootFromParent_Done,
      // Label 23240: @1835196
      GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1835300), // Rule ID 12400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12400,
        GIR_EraseRootFromParent_Done,
      // Label 23241: @1835300
      GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1835404), // Rule ID 12401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12401,
        GIR_EraseRootFromParent_Done,
      // Label 23242: @1835404
      GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1835508), // Rule ID 12404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12404,
        GIR_EraseRootFromParent_Done,
      // Label 23243: @1835508
      GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1835612), // Rule ID 12405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12405,
        GIR_EraseRootFromParent_Done,
      // Label 23244: @1835612
      GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1835716), // Rule ID 12408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12408,
        GIR_EraseRootFromParent_Done,
      // Label 23245: @1835716
      GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1835820), // Rule ID 12409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12409,
        GIR_EraseRootFromParent_Done,
      // Label 23246: @1835820
      GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1835924), // Rule ID 12412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12412,
        GIR_EraseRootFromParent_Done,
      // Label 23247: @1835924
      GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1836028), // Rule ID 12413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12413,
        GIR_EraseRootFromParent_Done,
      // Label 23248: @1836028
      GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1836132), // Rule ID 12416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12416,
        GIR_EraseRootFromParent_Done,
      // Label 23249: @1836132
      GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1836236), // Rule ID 12417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12417,
        GIR_EraseRootFromParent_Done,
      // Label 23250: @1836236
      GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1836340), // Rule ID 12420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12420,
        GIR_EraseRootFromParent_Done,
      // Label 23251: @1836340
      GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1836444), // Rule ID 12421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12421,
        GIR_EraseRootFromParent_Done,
      // Label 23252: @1836444
      GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1836548), // Rule ID 12424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12424,
        GIR_EraseRootFromParent_Done,
      // Label 23253: @1836548
      GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1836652), // Rule ID 12425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12425,
        GIR_EraseRootFromParent_Done,
      // Label 23254: @1836652
      GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1836756), // Rule ID 12428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12428,
        GIR_EraseRootFromParent_Done,
      // Label 23255: @1836756
      GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1836860), // Rule ID 12429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12429,
        GIR_EraseRootFromParent_Done,
      // Label 23256: @1836860
      GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1836964), // Rule ID 12432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12432,
        GIR_EraseRootFromParent_Done,
      // Label 23257: @1836964
      GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1837068), // Rule ID 12433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12433,
        GIR_EraseRootFromParent_Done,
      // Label 23258: @1837068
      GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1837172), // Rule ID 12436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12436,
        GIR_EraseRootFromParent_Done,
      // Label 23259: @1837172
      GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1837276), // Rule ID 12437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12437,
        GIR_EraseRootFromParent_Done,
      // Label 23260: @1837276
      GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1837380), // Rule ID 12440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12440,
        GIR_EraseRootFromParent_Done,
      // Label 23261: @1837380
      GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1837484), // Rule ID 12441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12441,
        GIR_EraseRootFromParent_Done,
      // Label 23262: @1837484
      GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1837588), // Rule ID 12444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12444,
        GIR_EraseRootFromParent_Done,
      // Label 23263: @1837588
      GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1837692), // Rule ID 12445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12445,
        GIR_EraseRootFromParent_Done,
      // Label 23264: @1837692
      GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1837796), // Rule ID 12448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12448,
        GIR_EraseRootFromParent_Done,
      // Label 23265: @1837796
      GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1837900), // Rule ID 12449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12449,
        GIR_EraseRootFromParent_Done,
      // Label 23266: @1837900
      GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1838004), // Rule ID 12452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12452,
        GIR_EraseRootFromParent_Done,
      // Label 23267: @1838004
      GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1838108), // Rule ID 12453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12453,
        GIR_EraseRootFromParent_Done,
      // Label 23268: @1838108
      GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1838212), // Rule ID 12456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12456,
        GIR_EraseRootFromParent_Done,
      // Label 23269: @1838212
      GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1838316), // Rule ID 12457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12457,
        GIR_EraseRootFromParent_Done,
      // Label 23270: @1838316
      GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1838420), // Rule ID 12460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12460,
        GIR_EraseRootFromParent_Done,
      // Label 23271: @1838420
      GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1838524), // Rule ID 12461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12461,
        GIR_EraseRootFromParent_Done,
      // Label 23272: @1838524
      GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1838628), // Rule ID 12464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12464,
        GIR_EraseRootFromParent_Done,
      // Label 23273: @1838628
      GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1838732), // Rule ID 12465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12465,
        GIR_EraseRootFromParent_Done,
      // Label 23274: @1838732
      GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1838836), // Rule ID 12468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12468,
        GIR_EraseRootFromParent_Done,
      // Label 23275: @1838836
      GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1838940), // Rule ID 12469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12469,
        GIR_EraseRootFromParent_Done,
      // Label 23276: @1838940
      GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1839044), // Rule ID 12472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12472,
        GIR_EraseRootFromParent_Done,
      // Label 23277: @1839044
      GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1839148), // Rule ID 12473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12473,
        GIR_EraseRootFromParent_Done,
      // Label 23278: @1839148
      GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1839252), // Rule ID 12476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12476,
        GIR_EraseRootFromParent_Done,
      // Label 23279: @1839252
      GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1839356), // Rule ID 12477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12477,
        GIR_EraseRootFromParent_Done,
      // Label 23280: @1839356
      GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1839460), // Rule ID 12480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12480,
        GIR_EraseRootFromParent_Done,
      // Label 23281: @1839460
      GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1839564), // Rule ID 12481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12481,
        GIR_EraseRootFromParent_Done,
      // Label 23282: @1839564
      GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1839668), // Rule ID 12484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12484,
        GIR_EraseRootFromParent_Done,
      // Label 23283: @1839668
      GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1839772), // Rule ID 12485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12485,
        GIR_EraseRootFromParent_Done,
      // Label 23284: @1839772
      GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1839876), // Rule ID 12488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12488,
        GIR_EraseRootFromParent_Done,
      // Label 23285: @1839876
      GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1839980), // Rule ID 12489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12489,
        GIR_EraseRootFromParent_Done,
      // Label 23286: @1839980
      GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1840084), // Rule ID 12492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12492,
        GIR_EraseRootFromParent_Done,
      // Label 23287: @1840084
      GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1840188), // Rule ID 12493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12493,
        GIR_EraseRootFromParent_Done,
      // Label 23288: @1840188
      GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1840292), // Rule ID 12496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12496,
        GIR_EraseRootFromParent_Done,
      // Label 23289: @1840292
      GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1840396), // Rule ID 12497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12497,
        GIR_EraseRootFromParent_Done,
      // Label 23290: @1840396
      GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1840500), // Rule ID 12500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12500,
        GIR_EraseRootFromParent_Done,
      // Label 23291: @1840500
      GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1840604), // Rule ID 12501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12501,
        GIR_EraseRootFromParent_Done,
      // Label 23292: @1840604
      GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1840708), // Rule ID 12504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12504,
        GIR_EraseRootFromParent_Done,
      // Label 23293: @1840708
      GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1840812), // Rule ID 12505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12505,
        GIR_EraseRootFromParent_Done,
      // Label 23294: @1840812
      GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1840916), // Rule ID 12508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12508,
        GIR_EraseRootFromParent_Done,
      // Label 23295: @1840916
      GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1841020), // Rule ID 12509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12509,
        GIR_EraseRootFromParent_Done,
      // Label 23296: @1841020
      GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1841124), // Rule ID 12512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12512,
        GIR_EraseRootFromParent_Done,
      // Label 23297: @1841124
      GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1841228), // Rule ID 12513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12513,
        GIR_EraseRootFromParent_Done,
      // Label 23298: @1841228
      GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1841332), // Rule ID 12516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12516,
        GIR_EraseRootFromParent_Done,
      // Label 23299: @1841332
      GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1841436), // Rule ID 12517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12517,
        GIR_EraseRootFromParent_Done,
      // Label 23300: @1841436
      GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1841540), // Rule ID 12520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12520,
        GIR_EraseRootFromParent_Done,
      // Label 23301: @1841540
      GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1841644), // Rule ID 12521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12521,
        GIR_EraseRootFromParent_Done,
      // Label 23302: @1841644
      GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1841748), // Rule ID 12524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12524,
        GIR_EraseRootFromParent_Done,
      // Label 23303: @1841748
      GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1841852), // Rule ID 12525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12525,
        GIR_EraseRootFromParent_Done,
      // Label 23304: @1841852
      GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1841956), // Rule ID 12528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12528,
        GIR_EraseRootFromParent_Done,
      // Label 23305: @1841956
      GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1842060), // Rule ID 12529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12529,
        GIR_EraseRootFromParent_Done,
      // Label 23306: @1842060
      GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1842164), // Rule ID 12532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12532,
        GIR_EraseRootFromParent_Done,
      // Label 23307: @1842164
      GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1842268), // Rule ID 12533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12533,
        GIR_EraseRootFromParent_Done,
      // Label 23308: @1842268
      GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1842372), // Rule ID 12536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12536,
        GIR_EraseRootFromParent_Done,
      // Label 23309: @1842372
      GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1842476), // Rule ID 12537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12537,
        GIR_EraseRootFromParent_Done,
      // Label 23310: @1842476
      GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1842580), // Rule ID 12540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12540,
        GIR_EraseRootFromParent_Done,
      // Label 23311: @1842580
      GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1842684), // Rule ID 12541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12541,
        GIR_EraseRootFromParent_Done,
      // Label 23312: @1842684
      GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1842788), // Rule ID 12544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12544,
        GIR_EraseRootFromParent_Done,
      // Label 23313: @1842788
      GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1842892), // Rule ID 12545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12545,
        GIR_EraseRootFromParent_Done,
      // Label 23314: @1842892
      GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1842996), // Rule ID 12548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12548,
        GIR_EraseRootFromParent_Done,
      // Label 23315: @1842996
      GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1843100), // Rule ID 12549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12549,
        GIR_EraseRootFromParent_Done,
      // Label 23316: @1843100
      GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1843204), // Rule ID 12552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12552,
        GIR_EraseRootFromParent_Done,
      // Label 23317: @1843204
      GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1843308), // Rule ID 12553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12553,
        GIR_EraseRootFromParent_Done,
      // Label 23318: @1843308
      GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1843412), // Rule ID 12556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12556,
        GIR_EraseRootFromParent_Done,
      // Label 23319: @1843412
      GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1843516), // Rule ID 12557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12557,
        GIR_EraseRootFromParent_Done,
      // Label 23320: @1843516
      GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1843620), // Rule ID 12560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12560,
        GIR_EraseRootFromParent_Done,
      // Label 23321: @1843620
      GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1843724), // Rule ID 12561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12561,
        GIR_EraseRootFromParent_Done,
      // Label 23322: @1843724
      GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1843828), // Rule ID 12564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12564,
        GIR_EraseRootFromParent_Done,
      // Label 23323: @1843828
      GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1843932), // Rule ID 12565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12565,
        GIR_EraseRootFromParent_Done,
      // Label 23324: @1843932
      GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1844036), // Rule ID 12568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12568,
        GIR_EraseRootFromParent_Done,
      // Label 23325: @1844036
      GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1844140), // Rule ID 12569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12569,
        GIR_EraseRootFromParent_Done,
      // Label 23326: @1844140
      GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1844244), // Rule ID 12572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12572,
        GIR_EraseRootFromParent_Done,
      // Label 23327: @1844244
      GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1844348), // Rule ID 12573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12573,
        GIR_EraseRootFromParent_Done,
      // Label 23328: @1844348
      GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1844452), // Rule ID 12576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12576,
        GIR_EraseRootFromParent_Done,
      // Label 23329: @1844452
      GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1844556), // Rule ID 12577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12577,
        GIR_EraseRootFromParent_Done,
      // Label 23330: @1844556
      GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1844660), // Rule ID 12580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12580,
        GIR_EraseRootFromParent_Done,
      // Label 23331: @1844660
      GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1844764), // Rule ID 12581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12581,
        GIR_EraseRootFromParent_Done,
      // Label 23332: @1844764
      GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1844868), // Rule ID 12584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12584,
        GIR_EraseRootFromParent_Done,
      // Label 23333: @1844868
      GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1844972), // Rule ID 12585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12585,
        GIR_EraseRootFromParent_Done,
      // Label 23334: @1844972
      GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1845076), // Rule ID 12588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12588,
        GIR_EraseRootFromParent_Done,
      // Label 23335: @1845076
      GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1845180), // Rule ID 12589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12589,
        GIR_EraseRootFromParent_Done,
      // Label 23336: @1845180
      GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1845284), // Rule ID 12592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12592,
        GIR_EraseRootFromParent_Done,
      // Label 23337: @1845284
      GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1845388), // Rule ID 12593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12593,
        GIR_EraseRootFromParent_Done,
      // Label 23338: @1845388
      GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1845492), // Rule ID 12596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12596,
        GIR_EraseRootFromParent_Done,
      // Label 23339: @1845492
      GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1845596), // Rule ID 12597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12597,
        GIR_EraseRootFromParent_Done,
      // Label 23340: @1845596
      GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1845700), // Rule ID 12600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12600,
        GIR_EraseRootFromParent_Done,
      // Label 23341: @1845700
      GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1845804), // Rule ID 12601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12601,
        GIR_EraseRootFromParent_Done,
      // Label 23342: @1845804
      GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1845908), // Rule ID 12604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12604,
        GIR_EraseRootFromParent_Done,
      // Label 23343: @1845908
      GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1846012), // Rule ID 12605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12605,
        GIR_EraseRootFromParent_Done,
      // Label 23344: @1846012
      GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1846116), // Rule ID 12608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12608,
        GIR_EraseRootFromParent_Done,
      // Label 23345: @1846116
      GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1846220), // Rule ID 12609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12609,
        GIR_EraseRootFromParent_Done,
      // Label 23346: @1846220
      GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1846324), // Rule ID 12612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12612,
        GIR_EraseRootFromParent_Done,
      // Label 23347: @1846324
      GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1846428), // Rule ID 12613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12613,
        GIR_EraseRootFromParent_Done,
      // Label 23348: @1846428
      GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1846532), // Rule ID 12616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12616,
        GIR_EraseRootFromParent_Done,
      // Label 23349: @1846532
      GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1846636), // Rule ID 12617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12617,
        GIR_EraseRootFromParent_Done,
      // Label 23350: @1846636
      GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1846740), // Rule ID 12620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12620,
        GIR_EraseRootFromParent_Done,
      // Label 23351: @1846740
      GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1846844), // Rule ID 12621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12621,
        GIR_EraseRootFromParent_Done,
      // Label 23352: @1846844
      GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1846948), // Rule ID 12624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12624,
        GIR_EraseRootFromParent_Done,
      // Label 23353: @1846948
      GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1847052), // Rule ID 12625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12625,
        GIR_EraseRootFromParent_Done,
      // Label 23354: @1847052
      GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1847156), // Rule ID 12628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12628,
        GIR_EraseRootFromParent_Done,
      // Label 23355: @1847156
      GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1847260), // Rule ID 12629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12629,
        GIR_EraseRootFromParent_Done,
      // Label 23356: @1847260
      GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1847364), // Rule ID 12632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12632,
        GIR_EraseRootFromParent_Done,
      // Label 23357: @1847364
      GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1847468), // Rule ID 12633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12633,
        GIR_EraseRootFromParent_Done,
      // Label 23358: @1847468
      GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1847572), // Rule ID 12636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12636,
        GIR_EraseRootFromParent_Done,
      // Label 23359: @1847572
      GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1847676), // Rule ID 12637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12637,
        GIR_EraseRootFromParent_Done,
      // Label 23360: @1847676
      GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1847780), // Rule ID 12640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12640,
        GIR_EraseRootFromParent_Done,
      // Label 23361: @1847780
      GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1847884), // Rule ID 12641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12641,
        GIR_EraseRootFromParent_Done,
      // Label 23362: @1847884
      GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1847988), // Rule ID 12644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12644,
        GIR_EraseRootFromParent_Done,
      // Label 23363: @1847988
      GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1848092), // Rule ID 12645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12645,
        GIR_EraseRootFromParent_Done,
      // Label 23364: @1848092
      GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1848196), // Rule ID 12648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12648,
        GIR_EraseRootFromParent_Done,
      // Label 23365: @1848196
      GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1848300), // Rule ID 12649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12649,
        GIR_EraseRootFromParent_Done,
      // Label 23366: @1848300
      GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1848404), // Rule ID 12652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12652,
        GIR_EraseRootFromParent_Done,
      // Label 23367: @1848404
      GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1848508), // Rule ID 12653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12653,
        GIR_EraseRootFromParent_Done,
      // Label 23368: @1848508
      GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1848612), // Rule ID 12656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12656,
        GIR_EraseRootFromParent_Done,
      // Label 23369: @1848612
      GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1848716), // Rule ID 12657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12657,
        GIR_EraseRootFromParent_Done,
      // Label 23370: @1848716
      GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1848820), // Rule ID 12660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12660,
        GIR_EraseRootFromParent_Done,
      // Label 23371: @1848820
      GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1848924), // Rule ID 12661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12661,
        GIR_EraseRootFromParent_Done,
      // Label 23372: @1848924
      GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1849028), // Rule ID 12664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12664,
        GIR_EraseRootFromParent_Done,
      // Label 23373: @1849028
      GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1849132), // Rule ID 12665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12665,
        GIR_EraseRootFromParent_Done,
      // Label 23374: @1849132
      GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1849236), // Rule ID 12668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12668,
        GIR_EraseRootFromParent_Done,
      // Label 23375: @1849236
      GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1849340), // Rule ID 12669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12669,
        GIR_EraseRootFromParent_Done,
      // Label 23376: @1849340
      GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1849444), // Rule ID 12672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12672,
        GIR_EraseRootFromParent_Done,
      // Label 23377: @1849444
      GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1849548), // Rule ID 12673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12673,
        GIR_EraseRootFromParent_Done,
      // Label 23378: @1849548
      GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1849652), // Rule ID 12676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12676,
        GIR_EraseRootFromParent_Done,
      // Label 23379: @1849652
      GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1849756), // Rule ID 12677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12677,
        GIR_EraseRootFromParent_Done,
      // Label 23380: @1849756
      GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1849860), // Rule ID 12680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12680,
        GIR_EraseRootFromParent_Done,
      // Label 23381: @1849860
      GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1849964), // Rule ID 12681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12681,
        GIR_EraseRootFromParent_Done,
      // Label 23382: @1849964
      GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1850068), // Rule ID 12684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12684,
        GIR_EraseRootFromParent_Done,
      // Label 23383: @1850068
      GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1850172), // Rule ID 12685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12685,
        GIR_EraseRootFromParent_Done,
      // Label 23384: @1850172
      GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1850276), // Rule ID 12688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12688,
        GIR_EraseRootFromParent_Done,
      // Label 23385: @1850276
      GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1850380), // Rule ID 12689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11018:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12689,
        GIR_EraseRootFromParent_Done,
      // Label 23386: @1850380
      GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1850484), // Rule ID 12692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12692,
        GIR_EraseRootFromParent_Done,
      // Label 23387: @1850484
      GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1850588), // Rule ID 12693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11018:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12693,
        GIR_EraseRootFromParent_Done,
      // Label 23388: @1850588
      GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1850692), // Rule ID 12696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12696,
        GIR_EraseRootFromParent_Done,
      // Label 23389: @1850692
      GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1850796), // Rule ID 12697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11018:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12697,
        GIR_EraseRootFromParent_Done,
      // Label 23390: @1850796
      GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1850900), // Rule ID 12700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12700,
        GIR_EraseRootFromParent_Done,
      // Label 23391: @1850900
      GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1851004), // Rule ID 12701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11018:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12701,
        GIR_EraseRootFromParent_Done,
      // Label 23392: @1851004
      GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1851108), // Rule ID 12704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12704,
        GIR_EraseRootFromParent_Done,
      // Label 23393: @1851108
      GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1851212), // Rule ID 12705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12705,
        GIR_EraseRootFromParent_Done,
      // Label 23394: @1851212
      GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1851316), // Rule ID 12708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12708,
        GIR_EraseRootFromParent_Done,
      // Label 23395: @1851316
      GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1851420), // Rule ID 12709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12709,
        GIR_EraseRootFromParent_Done,
      // Label 23396: @1851420
      GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1851524), // Rule ID 12712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12712,
        GIR_EraseRootFromParent_Done,
      // Label 23397: @1851524
      GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1851628), // Rule ID 12713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12713,
        GIR_EraseRootFromParent_Done,
      // Label 23398: @1851628
      GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1851732), // Rule ID 12716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12716,
        GIR_EraseRootFromParent_Done,
      // Label 23399: @1851732
      GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1851836), // Rule ID 12717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12717,
        GIR_EraseRootFromParent_Done,
      // Label 23400: @1851836
      GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1851940), // Rule ID 12720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12720,
        GIR_EraseRootFromParent_Done,
      // Label 23401: @1851940
      GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1852044), // Rule ID 12721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12721,
        GIR_EraseRootFromParent_Done,
      // Label 23402: @1852044
      GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1852148), // Rule ID 12724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12724,
        GIR_EraseRootFromParent_Done,
      // Label 23403: @1852148
      GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1852252), // Rule ID 12725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12725,
        GIR_EraseRootFromParent_Done,
      // Label 23404: @1852252
      GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1852356), // Rule ID 12728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12728,
        GIR_EraseRootFromParent_Done,
      // Label 23405: @1852356
      GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1852460), // Rule ID 12729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12729,
        GIR_EraseRootFromParent_Done,
      // Label 23406: @1852460
      GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1852564), // Rule ID 12732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12732,
        GIR_EraseRootFromParent_Done,
      // Label 23407: @1852564
      GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1852668), // Rule ID 12733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12733,
        GIR_EraseRootFromParent_Done,
      // Label 23408: @1852668
      GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1852772), // Rule ID 12736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12736,
        GIR_EraseRootFromParent_Done,
      // Label 23409: @1852772
      GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1852876), // Rule ID 12737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12737,
        GIR_EraseRootFromParent_Done,
      // Label 23410: @1852876
      GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1852980), // Rule ID 12740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12740,
        GIR_EraseRootFromParent_Done,
      // Label 23411: @1852980
      GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1853084), // Rule ID 12741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11018:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12741,
        GIR_EraseRootFromParent_Done,
      // Label 23412: @1853084
      GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1853188), // Rule ID 12744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12744,
        GIR_EraseRootFromParent_Done,
      // Label 23413: @1853188
      GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1853292), // Rule ID 12745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11018:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12745,
        GIR_EraseRootFromParent_Done,
      // Label 23414: @1853292
      GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1853396), // Rule ID 12748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12748,
        GIR_EraseRootFromParent_Done,
      // Label 23415: @1853396
      GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1853500), // Rule ID 12749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11018:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12749,
        GIR_EraseRootFromParent_Done,
      // Label 23416: @1853500
      GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1853604), // Rule ID 12752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12752,
        GIR_EraseRootFromParent_Done,
      // Label 23417: @1853604
      GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1853708), // Rule ID 12753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12753,
        GIR_EraseRootFromParent_Done,
      // Label 23418: @1853708
      GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1853812), // Rule ID 12756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12756,
        GIR_EraseRootFromParent_Done,
      // Label 23419: @1853812
      GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1853916), // Rule ID 12757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12757,
        GIR_EraseRootFromParent_Done,
      // Label 23420: @1853916
      GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1854020), // Rule ID 12760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12760,
        GIR_EraseRootFromParent_Done,
      // Label 23421: @1854020
      GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1854124), // Rule ID 12761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12761,
        GIR_EraseRootFromParent_Done,
      // Label 23422: @1854124
      GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1854228), // Rule ID 12764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12764,
        GIR_EraseRootFromParent_Done,
      // Label 23423: @1854228
      GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1854332), // Rule ID 12765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12765,
        GIR_EraseRootFromParent_Done,
      // Label 23424: @1854332
      GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1854436), // Rule ID 12768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12768,
        GIR_EraseRootFromParent_Done,
      // Label 23425: @1854436
      GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1854540), // Rule ID 12769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12769,
        GIR_EraseRootFromParent_Done,
      // Label 23426: @1854540
      GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1854644), // Rule ID 12772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12772,
        GIR_EraseRootFromParent_Done,
      // Label 23427: @1854644
      GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1854748), // Rule ID 12773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12773,
        GIR_EraseRootFromParent_Done,
      // Label 23428: @1854748
      GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1854852), // Rule ID 12776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12776,
        GIR_EraseRootFromParent_Done,
      // Label 23429: @1854852
      GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1854956), // Rule ID 12777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12777,
        GIR_EraseRootFromParent_Done,
      // Label 23430: @1854956
      GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1855060), // Rule ID 12780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12780,
        GIR_EraseRootFromParent_Done,
      // Label 23431: @1855060
      GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1855164), // Rule ID 12781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12781,
        GIR_EraseRootFromParent_Done,
      // Label 23432: @1855164
      GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1855268), // Rule ID 12784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12784,
        GIR_EraseRootFromParent_Done,
      // Label 23433: @1855268
      GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1855372), // Rule ID 12785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12785,
        GIR_EraseRootFromParent_Done,
      // Label 23434: @1855372
      GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1855476), // Rule ID 12788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12788,
        GIR_EraseRootFromParent_Done,
      // Label 23435: @1855476
      GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1855580), // Rule ID 12789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12789,
        GIR_EraseRootFromParent_Done,
      // Label 23436: @1855580
      GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1855684), // Rule ID 12792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12792,
        GIR_EraseRootFromParent_Done,
      // Label 23437: @1855684
      GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1855788), // Rule ID 12793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12793,
        GIR_EraseRootFromParent_Done,
      // Label 23438: @1855788
      GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1855892), // Rule ID 12796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12796,
        GIR_EraseRootFromParent_Done,
      // Label 23439: @1855892
      GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1855996), // Rule ID 12797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12797,
        GIR_EraseRootFromParent_Done,
      // Label 23440: @1855996
      GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1856100), // Rule ID 12800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12800,
        GIR_EraseRootFromParent_Done,
      // Label 23441: @1856100
      GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1856204), // Rule ID 12801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12801,
        GIR_EraseRootFromParent_Done,
      // Label 23442: @1856204
      GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1856308), // Rule ID 12804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12804,
        GIR_EraseRootFromParent_Done,
      // Label 23443: @1856308
      GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1856412), // Rule ID 12805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12805,
        GIR_EraseRootFromParent_Done,
      // Label 23444: @1856412
      GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1856516), // Rule ID 12808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12808,
        GIR_EraseRootFromParent_Done,
      // Label 23445: @1856516
      GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1856620), // Rule ID 12809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12809,
        GIR_EraseRootFromParent_Done,
      // Label 23446: @1856620
      GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1856724), // Rule ID 12812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12812,
        GIR_EraseRootFromParent_Done,
      // Label 23447: @1856724
      GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1856828), // Rule ID 12813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12813,
        GIR_EraseRootFromParent_Done,
      // Label 23448: @1856828
      GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1856932), // Rule ID 12816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12816,
        GIR_EraseRootFromParent_Done,
      // Label 23449: @1856932
      GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1857036), // Rule ID 12817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12817,
        GIR_EraseRootFromParent_Done,
      // Label 23450: @1857036
      GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1857140), // Rule ID 12820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12820,
        GIR_EraseRootFromParent_Done,
      // Label 23451: @1857140
      GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1857244), // Rule ID 12821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12821,
        GIR_EraseRootFromParent_Done,
      // Label 23452: @1857244
      GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1857348), // Rule ID 12824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12824,
        GIR_EraseRootFromParent_Done,
      // Label 23453: @1857348
      GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1857452), // Rule ID 12825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12825,
        GIR_EraseRootFromParent_Done,
      // Label 23454: @1857452
      GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1857556), // Rule ID 12828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12828,
        GIR_EraseRootFromParent_Done,
      // Label 23455: @1857556
      GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1857660), // Rule ID 12829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12829,
        GIR_EraseRootFromParent_Done,
      // Label 23456: @1857660
      GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1857764), // Rule ID 12832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12832,
        GIR_EraseRootFromParent_Done,
      // Label 23457: @1857764
      GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1857868), // Rule ID 12833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12833,
        GIR_EraseRootFromParent_Done,
      // Label 23458: @1857868
      GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1857972), // Rule ID 12836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12836,
        GIR_EraseRootFromParent_Done,
      // Label 23459: @1857972
      GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1858076), // Rule ID 12837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12837,
        GIR_EraseRootFromParent_Done,
      // Label 23460: @1858076
      GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1858180), // Rule ID 12840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12840,
        GIR_EraseRootFromParent_Done,
      // Label 23461: @1858180
      GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1858284), // Rule ID 12841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12841,
        GIR_EraseRootFromParent_Done,
      // Label 23462: @1858284
      GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1858388), // Rule ID 12844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12844,
        GIR_EraseRootFromParent_Done,
      // Label 23463: @1858388
      GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1858492), // Rule ID 12845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12845,
        GIR_EraseRootFromParent_Done,
      // Label 23464: @1858492
      GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1858596), // Rule ID 12848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12848,
        GIR_EraseRootFromParent_Done,
      // Label 23465: @1858596
      GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1858700), // Rule ID 12849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12849,
        GIR_EraseRootFromParent_Done,
      // Label 23466: @1858700
      GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1858804), // Rule ID 12852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12852,
        GIR_EraseRootFromParent_Done,
      // Label 23467: @1858804
      GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1858908), // Rule ID 12853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12853,
        GIR_EraseRootFromParent_Done,
      // Label 23468: @1858908
      GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1859012), // Rule ID 12856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12856,
        GIR_EraseRootFromParent_Done,
      // Label 23469: @1859012
      GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1859116), // Rule ID 12857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12857,
        GIR_EraseRootFromParent_Done,
      // Label 23470: @1859116
      GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1859220), // Rule ID 12860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12860,
        GIR_EraseRootFromParent_Done,
      // Label 23471: @1859220
      GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1859324), // Rule ID 12861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12861,
        GIR_EraseRootFromParent_Done,
      // Label 23472: @1859324
      GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1859428), // Rule ID 12864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12864,
        GIR_EraseRootFromParent_Done,
      // Label 23473: @1859428
      GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1859532), // Rule ID 12865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12865,
        GIR_EraseRootFromParent_Done,
      // Label 23474: @1859532
      GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1859636), // Rule ID 12868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12868,
        GIR_EraseRootFromParent_Done,
      // Label 23475: @1859636
      GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1859740), // Rule ID 12869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12869,
        GIR_EraseRootFromParent_Done,
      // Label 23476: @1859740
      GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1859844), // Rule ID 12872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12872,
        GIR_EraseRootFromParent_Done,
      // Label 23477: @1859844
      GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1859948), // Rule ID 12873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12873,
        GIR_EraseRootFromParent_Done,
      // Label 23478: @1859948
      GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1860052), // Rule ID 12876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12876,
        GIR_EraseRootFromParent_Done,
      // Label 23479: @1860052
      GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1860156), // Rule ID 12877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12877,
        GIR_EraseRootFromParent_Done,
      // Label 23480: @1860156
      GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1860260), // Rule ID 12880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12880,
        GIR_EraseRootFromParent_Done,
      // Label 23481: @1860260
      GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1860364), // Rule ID 12881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12881,
        GIR_EraseRootFromParent_Done,
      // Label 23482: @1860364
      GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1860468), // Rule ID 12884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12884,
        GIR_EraseRootFromParent_Done,
      // Label 23483: @1860468
      GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1860572), // Rule ID 12885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12885,
        GIR_EraseRootFromParent_Done,
      // Label 23484: @1860572
      GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1860676), // Rule ID 12888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12888,
        GIR_EraseRootFromParent_Done,
      // Label 23485: @1860676
      GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1860780), // Rule ID 12889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12889,
        GIR_EraseRootFromParent_Done,
      // Label 23486: @1860780
      GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1860884), // Rule ID 12892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12892,
        GIR_EraseRootFromParent_Done,
      // Label 23487: @1860884
      GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1860988), // Rule ID 12893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12893,
        GIR_EraseRootFromParent_Done,
      // Label 23488: @1860988
      GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1861092), // Rule ID 12896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12896,
        GIR_EraseRootFromParent_Done,
      // Label 23489: @1861092
      GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1861196), // Rule ID 12897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12897,
        GIR_EraseRootFromParent_Done,
      // Label 23490: @1861196
      GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1861300), // Rule ID 12900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12900,
        GIR_EraseRootFromParent_Done,
      // Label 23491: @1861300
      GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1861404), // Rule ID 12901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12901,
        GIR_EraseRootFromParent_Done,
      // Label 23492: @1861404
      GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1861508), // Rule ID 12904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12904,
        GIR_EraseRootFromParent_Done,
      // Label 23493: @1861508
      GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1861612), // Rule ID 12905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12905,
        GIR_EraseRootFromParent_Done,
      // Label 23494: @1861612
      GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1861716), // Rule ID 12908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12908,
        GIR_EraseRootFromParent_Done,
      // Label 23495: @1861716
      GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1861820), // Rule ID 12909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12909,
        GIR_EraseRootFromParent_Done,
      // Label 23496: @1861820
      GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1861924), // Rule ID 12912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12912,
        GIR_EraseRootFromParent_Done,
      // Label 23497: @1861924
      GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1862028), // Rule ID 12913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12913,
        GIR_EraseRootFromParent_Done,
      // Label 23498: @1862028
      GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1862132), // Rule ID 12916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12916,
        GIR_EraseRootFromParent_Done,
      // Label 23499: @1862132
      GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1862236), // Rule ID 12917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12917,
        GIR_EraseRootFromParent_Done,
      // Label 23500: @1862236
      GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1862340), // Rule ID 12920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12920,
        GIR_EraseRootFromParent_Done,
      // Label 23501: @1862340
      GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1862444), // Rule ID 12921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12921,
        GIR_EraseRootFromParent_Done,
      // Label 23502: @1862444
      GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1862548), // Rule ID 12924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12924,
        GIR_EraseRootFromParent_Done,
      // Label 23503: @1862548
      GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1862652), // Rule ID 12925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12925,
        GIR_EraseRootFromParent_Done,
      // Label 23504: @1862652
      GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1862756), // Rule ID 12928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12928,
        GIR_EraseRootFromParent_Done,
      // Label 23505: @1862756
      GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1862860), // Rule ID 12929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12929,
        GIR_EraseRootFromParent_Done,
      // Label 23506: @1862860
      GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1862964), // Rule ID 12932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12932,
        GIR_EraseRootFromParent_Done,
      // Label 23507: @1862964
      GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1863068), // Rule ID 12933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12933,
        GIR_EraseRootFromParent_Done,
      // Label 23508: @1863068
      GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1863172), // Rule ID 12936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12936,
        GIR_EraseRootFromParent_Done,
      // Label 23509: @1863172
      GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1863276), // Rule ID 12937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12937,
        GIR_EraseRootFromParent_Done,
      // Label 23510: @1863276
      GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1863380), // Rule ID 12940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12940,
        GIR_EraseRootFromParent_Done,
      // Label 23511: @1863380
      GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1863484), // Rule ID 12941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12941,
        GIR_EraseRootFromParent_Done,
      // Label 23512: @1863484
      GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1863588), // Rule ID 12944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12944,
        GIR_EraseRootFromParent_Done,
      // Label 23513: @1863588
      GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1863692), // Rule ID 12945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12945,
        GIR_EraseRootFromParent_Done,
      // Label 23514: @1863692
      GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1863796), // Rule ID 12948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12948,
        GIR_EraseRootFromParent_Done,
      // Label 23515: @1863796
      GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1863900), // Rule ID 12949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12949,
        GIR_EraseRootFromParent_Done,
      // Label 23516: @1863900
      GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1864004), // Rule ID 12952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12952,
        GIR_EraseRootFromParent_Done,
      // Label 23517: @1864004
      GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1864108), // Rule ID 12953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12953,
        GIR_EraseRootFromParent_Done,
      // Label 23518: @1864108
      GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1864212), // Rule ID 12956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12956,
        GIR_EraseRootFromParent_Done,
      // Label 23519: @1864212
      GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1864316), // Rule ID 12957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12957,
        GIR_EraseRootFromParent_Done,
      // Label 23520: @1864316
      GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1864420), // Rule ID 12960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12960,
        GIR_EraseRootFromParent_Done,
      // Label 23521: @1864420
      GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1864524), // Rule ID 12961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12961,
        GIR_EraseRootFromParent_Done,
      // Label 23522: @1864524
      GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1864628), // Rule ID 12964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12964,
        GIR_EraseRootFromParent_Done,
      // Label 23523: @1864628
      GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1864732), // Rule ID 12965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12965,
        GIR_EraseRootFromParent_Done,
      // Label 23524: @1864732
      GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1864836), // Rule ID 12968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12968,
        GIR_EraseRootFromParent_Done,
      // Label 23525: @1864836
      GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1864940), // Rule ID 12969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12969,
        GIR_EraseRootFromParent_Done,
      // Label 23526: @1864940
      GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1865044), // Rule ID 12972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12972,
        GIR_EraseRootFromParent_Done,
      // Label 23527: @1865044
      GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1865148), // Rule ID 12973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12973,
        GIR_EraseRootFromParent_Done,
      // Label 23528: @1865148
      GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1865252), // Rule ID 12976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12976,
        GIR_EraseRootFromParent_Done,
      // Label 23529: @1865252
      GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1865356), // Rule ID 12977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12977,
        GIR_EraseRootFromParent_Done,
      // Label 23530: @1865356
      GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1865460), // Rule ID 12980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12980,
        GIR_EraseRootFromParent_Done,
      // Label 23531: @1865460
      GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1865564), // Rule ID 12981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12981,
        GIR_EraseRootFromParent_Done,
      // Label 23532: @1865564
      GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1865668), // Rule ID 12984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12984,
        GIR_EraseRootFromParent_Done,
      // Label 23533: @1865668
      GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1865772), // Rule ID 12985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12985,
        GIR_EraseRootFromParent_Done,
      // Label 23534: @1865772
      GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1865876), // Rule ID 12988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12988,
        GIR_EraseRootFromParent_Done,
      // Label 23535: @1865876
      GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1865980), // Rule ID 12989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12989,
        GIR_EraseRootFromParent_Done,
      // Label 23536: @1865980
      GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1866084), // Rule ID 12992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12992,
        GIR_EraseRootFromParent_Done,
      // Label 23537: @1866084
      GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1866188), // Rule ID 12993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12993,
        GIR_EraseRootFromParent_Done,
      // Label 23538: @1866188
      GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1866292), // Rule ID 12996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12996,
        GIR_EraseRootFromParent_Done,
      // Label 23539: @1866292
      GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1866396), // Rule ID 12997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12997,
        GIR_EraseRootFromParent_Done,
      // Label 23540: @1866396
      GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1866500), // Rule ID 13000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13000,
        GIR_EraseRootFromParent_Done,
      // Label 23541: @1866500
      GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1866604), // Rule ID 13001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13001,
        GIR_EraseRootFromParent_Done,
      // Label 23542: @1866604
      GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1866708), // Rule ID 13004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13004,
        GIR_EraseRootFromParent_Done,
      // Label 23543: @1866708
      GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1866812), // Rule ID 13005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13005,
        GIR_EraseRootFromParent_Done,
      // Label 23544: @1866812
      GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1866916), // Rule ID 13008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13008,
        GIR_EraseRootFromParent_Done,
      // Label 23545: @1866916
      GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1867020), // Rule ID 13009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13009,
        GIR_EraseRootFromParent_Done,
      // Label 23546: @1867020
      GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1867124), // Rule ID 13012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13012,
        GIR_EraseRootFromParent_Done,
      // Label 23547: @1867124
      GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1867228), // Rule ID 13013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13013,
        GIR_EraseRootFromParent_Done,
      // Label 23548: @1867228
      GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1867332), // Rule ID 13016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13016,
        GIR_EraseRootFromParent_Done,
      // Label 23549: @1867332
      GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1867436), // Rule ID 13017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13017,
        GIR_EraseRootFromParent_Done,
      // Label 23550: @1867436
      GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1867540), // Rule ID 13020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13020,
        GIR_EraseRootFromParent_Done,
      // Label 23551: @1867540
      GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1867644), // Rule ID 13021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13021,
        GIR_EraseRootFromParent_Done,
      // Label 23552: @1867644
      GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1867748), // Rule ID 13024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13024,
        GIR_EraseRootFromParent_Done,
      // Label 23553: @1867748
      GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1867852), // Rule ID 13025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13025,
        GIR_EraseRootFromParent_Done,
      // Label 23554: @1867852
      GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1867956), // Rule ID 13028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13028,
        GIR_EraseRootFromParent_Done,
      // Label 23555: @1867956
      GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1868060), // Rule ID 13029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13029,
        GIR_EraseRootFromParent_Done,
      // Label 23556: @1868060
      GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1868164), // Rule ID 13032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13032,
        GIR_EraseRootFromParent_Done,
      // Label 23557: @1868164
      GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1868268), // Rule ID 13033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13033,
        GIR_EraseRootFromParent_Done,
      // Label 23558: @1868268
      GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1868372), // Rule ID 13036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13036,
        GIR_EraseRootFromParent_Done,
      // Label 23559: @1868372
      GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1868476), // Rule ID 13037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13037,
        GIR_EraseRootFromParent_Done,
      // Label 23560: @1868476
      GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1868580), // Rule ID 13040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13040,
        GIR_EraseRootFromParent_Done,
      // Label 23561: @1868580
      GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1868684), // Rule ID 13041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13041,
        GIR_EraseRootFromParent_Done,
      // Label 23562: @1868684
      GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1868788), // Rule ID 13044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13044,
        GIR_EraseRootFromParent_Done,
      // Label 23563: @1868788
      GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1868892), // Rule ID 13045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13045,
        GIR_EraseRootFromParent_Done,
      // Label 23564: @1868892
      GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1868996), // Rule ID 13048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13048,
        GIR_EraseRootFromParent_Done,
      // Label 23565: @1868996
      GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1869100), // Rule ID 13049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13049,
        GIR_EraseRootFromParent_Done,
      // Label 23566: @1869100
      GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1869204), // Rule ID 13052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13052,
        GIR_EraseRootFromParent_Done,
      // Label 23567: @1869204
      GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1869308), // Rule ID 13053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13053,
        GIR_EraseRootFromParent_Done,
      // Label 23568: @1869308
      GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1869412), // Rule ID 13056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13056,
        GIR_EraseRootFromParent_Done,
      // Label 23569: @1869412
      GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1869516), // Rule ID 13057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13057,
        GIR_EraseRootFromParent_Done,
      // Label 23570: @1869516
      GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1869620), // Rule ID 13060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13060,
        GIR_EraseRootFromParent_Done,
      // Label 23571: @1869620
      GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1869724), // Rule ID 13061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13061,
        GIR_EraseRootFromParent_Done,
      // Label 23572: @1869724
      GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1869828), // Rule ID 13064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13064,
        GIR_EraseRootFromParent_Done,
      // Label 23573: @1869828
      GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1869932), // Rule ID 13065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13065,
        GIR_EraseRootFromParent_Done,
      // Label 23574: @1869932
      GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1870036), // Rule ID 13068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13068,
        GIR_EraseRootFromParent_Done,
      // Label 23575: @1870036
      GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1870140), // Rule ID 13069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13069,
        GIR_EraseRootFromParent_Done,
      // Label 23576: @1870140
      GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1870244), // Rule ID 13072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13072,
        GIR_EraseRootFromParent_Done,
      // Label 23577: @1870244
      GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1870348), // Rule ID 13073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13073,
        GIR_EraseRootFromParent_Done,
      // Label 23578: @1870348
      GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1870452), // Rule ID 13076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13076,
        GIR_EraseRootFromParent_Done,
      // Label 23579: @1870452
      GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1870556), // Rule ID 13077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13077,
        GIR_EraseRootFromParent_Done,
      // Label 23580: @1870556
      GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1870660), // Rule ID 13080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13080,
        GIR_EraseRootFromParent_Done,
      // Label 23581: @1870660
      GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1870764), // Rule ID 13081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13081,
        GIR_EraseRootFromParent_Done,
      // Label 23582: @1870764
      GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1870868), // Rule ID 13084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13084,
        GIR_EraseRootFromParent_Done,
      // Label 23583: @1870868
      GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1870972), // Rule ID 13085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13085,
        GIR_EraseRootFromParent_Done,
      // Label 23584: @1870972
      GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1871076), // Rule ID 13088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13088,
        GIR_EraseRootFromParent_Done,
      // Label 23585: @1871076
      GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1871180), // Rule ID 13089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13089,
        GIR_EraseRootFromParent_Done,
      // Label 23586: @1871180
      GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1871284), // Rule ID 13092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13092,
        GIR_EraseRootFromParent_Done,
      // Label 23587: @1871284
      GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1871388), // Rule ID 13093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13093,
        GIR_EraseRootFromParent_Done,
      // Label 23588: @1871388
      GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1871492), // Rule ID 13096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13096,
        GIR_EraseRootFromParent_Done,
      // Label 23589: @1871492
      GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1871596), // Rule ID 13097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13097,
        GIR_EraseRootFromParent_Done,
      // Label 23590: @1871596
      GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1871700), // Rule ID 13100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13100,
        GIR_EraseRootFromParent_Done,
      // Label 23591: @1871700
      GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1871804), // Rule ID 13101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13101,
        GIR_EraseRootFromParent_Done,
      // Label 23592: @1871804
      GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1871908), // Rule ID 13104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13104,
        GIR_EraseRootFromParent_Done,
      // Label 23593: @1871908
      GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1872012), // Rule ID 13105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13105,
        GIR_EraseRootFromParent_Done,
      // Label 23594: @1872012
      GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1872116), // Rule ID 13108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13108,
        GIR_EraseRootFromParent_Done,
      // Label 23595: @1872116
      GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1872220), // Rule ID 13109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13109,
        GIR_EraseRootFromParent_Done,
      // Label 23596: @1872220
      GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1872324), // Rule ID 13112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13112,
        GIR_EraseRootFromParent_Done,
      // Label 23597: @1872324
      GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1872428), // Rule ID 13113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13113,
        GIR_EraseRootFromParent_Done,
      // Label 23598: @1872428
      GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1872532), // Rule ID 13116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13116,
        GIR_EraseRootFromParent_Done,
      // Label 23599: @1872532
      GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1872636), // Rule ID 13117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13117,
        GIR_EraseRootFromParent_Done,
      // Label 23600: @1872636
      GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1872740), // Rule ID 13120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13120,
        GIR_EraseRootFromParent_Done,
      // Label 23601: @1872740
      GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1872844), // Rule ID 13121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13121,
        GIR_EraseRootFromParent_Done,
      // Label 23602: @1872844
      GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1872948), // Rule ID 13124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13124,
        GIR_EraseRootFromParent_Done,
      // Label 23603: @1872948
      GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1873052), // Rule ID 13125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13125,
        GIR_EraseRootFromParent_Done,
      // Label 23604: @1873052
      GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1873156), // Rule ID 13128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13128,
        GIR_EraseRootFromParent_Done,
      // Label 23605: @1873156
      GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1873260), // Rule ID 13129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13129,
        GIR_EraseRootFromParent_Done,
      // Label 23606: @1873260
      GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1873364), // Rule ID 13132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13132,
        GIR_EraseRootFromParent_Done,
      // Label 23607: @1873364
      GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1873468), // Rule ID 13133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13133,
        GIR_EraseRootFromParent_Done,
      // Label 23608: @1873468
      GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1873572), // Rule ID 13136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13136,
        GIR_EraseRootFromParent_Done,
      // Label 23609: @1873572
      GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1873676), // Rule ID 13137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13137,
        GIR_EraseRootFromParent_Done,
      // Label 23610: @1873676
      GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1873780), // Rule ID 13140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13140,
        GIR_EraseRootFromParent_Done,
      // Label 23611: @1873780
      GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1873884), // Rule ID 13141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13141,
        GIR_EraseRootFromParent_Done,
      // Label 23612: @1873884
      GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1873988), // Rule ID 13144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13144,
        GIR_EraseRootFromParent_Done,
      // Label 23613: @1873988
      GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1874092), // Rule ID 13145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13145,
        GIR_EraseRootFromParent_Done,
      // Label 23614: @1874092
      GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1874196), // Rule ID 13148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13148,
        GIR_EraseRootFromParent_Done,
      // Label 23615: @1874196
      GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1874300), // Rule ID 13149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13149,
        GIR_EraseRootFromParent_Done,
      // Label 23616: @1874300
      GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1874404), // Rule ID 13152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13152,
        GIR_EraseRootFromParent_Done,
      // Label 23617: @1874404
      GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1874508), // Rule ID 13153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13153,
        GIR_EraseRootFromParent_Done,
      // Label 23618: @1874508
      GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1874612), // Rule ID 13156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13156,
        GIR_EraseRootFromParent_Done,
      // Label 23619: @1874612
      GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1874716), // Rule ID 13157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13157,
        GIR_EraseRootFromParent_Done,
      // Label 23620: @1874716
      GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1874820), // Rule ID 13160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13160,
        GIR_EraseRootFromParent_Done,
      // Label 23621: @1874820
      GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1874924), // Rule ID 13161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13161,
        GIR_EraseRootFromParent_Done,
      // Label 23622: @1874924
      GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1875028), // Rule ID 13164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13164,
        GIR_EraseRootFromParent_Done,
      // Label 23623: @1875028
      GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1875132), // Rule ID 13165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13165,
        GIR_EraseRootFromParent_Done,
      // Label 23624: @1875132
      GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1875236), // Rule ID 13168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13168,
        GIR_EraseRootFromParent_Done,
      // Label 23625: @1875236
      GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1875340), // Rule ID 13169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13169,
        GIR_EraseRootFromParent_Done,
      // Label 23626: @1875340
      GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1875444), // Rule ID 13172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13172,
        GIR_EraseRootFromParent_Done,
      // Label 23627: @1875444
      GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1875548), // Rule ID 13173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13173,
        GIR_EraseRootFromParent_Done,
      // Label 23628: @1875548
      GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1875652), // Rule ID 13176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13176,
        GIR_EraseRootFromParent_Done,
      // Label 23629: @1875652
      GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1875756), // Rule ID 13177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13177,
        GIR_EraseRootFromParent_Done,
      // Label 23630: @1875756
      GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1875860), // Rule ID 13180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13180,
        GIR_EraseRootFromParent_Done,
      // Label 23631: @1875860
      GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1875964), // Rule ID 13181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13181,
        GIR_EraseRootFromParent_Done,
      // Label 23632: @1875964
      GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1876068), // Rule ID 13184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13184,
        GIR_EraseRootFromParent_Done,
      // Label 23633: @1876068
      GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1876172), // Rule ID 13185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13185,
        GIR_EraseRootFromParent_Done,
      // Label 23634: @1876172
      GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1876276), // Rule ID 13188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13188,
        GIR_EraseRootFromParent_Done,
      // Label 23635: @1876276
      GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1876380), // Rule ID 13189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13189,
        GIR_EraseRootFromParent_Done,
      // Label 23636: @1876380
      GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1876484), // Rule ID 13192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13192,
        GIR_EraseRootFromParent_Done,
      // Label 23637: @1876484
      GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1876588), // Rule ID 13193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13193,
        GIR_EraseRootFromParent_Done,
      // Label 23638: @1876588
      GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1876692), // Rule ID 13196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13196,
        GIR_EraseRootFromParent_Done,
      // Label 23639: @1876692
      GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1876796), // Rule ID 13197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13197,
        GIR_EraseRootFromParent_Done,
      // Label 23640: @1876796
      GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1876900), // Rule ID 13200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13200,
        GIR_EraseRootFromParent_Done,
      // Label 23641: @1876900
      GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1877004), // Rule ID 13201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13201,
        GIR_EraseRootFromParent_Done,
      // Label 23642: @1877004
      GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1877108), // Rule ID 13204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13204,
        GIR_EraseRootFromParent_Done,
      // Label 23643: @1877108
      GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1877212), // Rule ID 13205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13205,
        GIR_EraseRootFromParent_Done,
      // Label 23644: @1877212
      GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1877316), // Rule ID 13208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13208,
        GIR_EraseRootFromParent_Done,
      // Label 23645: @1877316
      GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1877420), // Rule ID 13209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13209,
        GIR_EraseRootFromParent_Done,
      // Label 23646: @1877420
      GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1877524), // Rule ID 13212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13212,
        GIR_EraseRootFromParent_Done,
      // Label 23647: @1877524
      GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1877628), // Rule ID 13213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13213,
        GIR_EraseRootFromParent_Done,
      // Label 23648: @1877628
      GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1877732), // Rule ID 13216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13216,
        GIR_EraseRootFromParent_Done,
      // Label 23649: @1877732
      GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1877836), // Rule ID 13217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13217,
        GIR_EraseRootFromParent_Done,
      // Label 23650: @1877836
      GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1877940), // Rule ID 13220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13220,
        GIR_EraseRootFromParent_Done,
      // Label 23651: @1877940
      GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1878044), // Rule ID 13221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13221,
        GIR_EraseRootFromParent_Done,
      // Label 23652: @1878044
      GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1878148), // Rule ID 13224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13224,
        GIR_EraseRootFromParent_Done,
      // Label 23653: @1878148
      GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1878252), // Rule ID 13225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13225,
        GIR_EraseRootFromParent_Done,
      // Label 23654: @1878252
      GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1878356), // Rule ID 13228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13228,
        GIR_EraseRootFromParent_Done,
      // Label 23655: @1878356
      GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1878460), // Rule ID 13229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13229,
        GIR_EraseRootFromParent_Done,
      // Label 23656: @1878460
      GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1878564), // Rule ID 13232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13232,
        GIR_EraseRootFromParent_Done,
      // Label 23657: @1878564
      GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1878668), // Rule ID 13233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13233,
        GIR_EraseRootFromParent_Done,
      // Label 23658: @1878668
      GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1878772), // Rule ID 13236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13236,
        GIR_EraseRootFromParent_Done,
      // Label 23659: @1878772
      GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1878876), // Rule ID 13237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13237,
        GIR_EraseRootFromParent_Done,
      // Label 23660: @1878876
      GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1878980), // Rule ID 13240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13240,
        GIR_EraseRootFromParent_Done,
      // Label 23661: @1878980
      GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1879084), // Rule ID 13241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13241,
        GIR_EraseRootFromParent_Done,
      // Label 23662: @1879084
      GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1879188), // Rule ID 13244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13244,
        GIR_EraseRootFromParent_Done,
      // Label 23663: @1879188
      GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1879292), // Rule ID 13245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13245,
        GIR_EraseRootFromParent_Done,
      // Label 23664: @1879292
      GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1879396), // Rule ID 13248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13248,
        GIR_EraseRootFromParent_Done,
      // Label 23665: @1879396
      GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1879500), // Rule ID 13249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13249,
        GIR_EraseRootFromParent_Done,
      // Label 23666: @1879500
      GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1879604), // Rule ID 13252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13252,
        GIR_EraseRootFromParent_Done,
      // Label 23667: @1879604
      GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1879708), // Rule ID 13253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13253,
        GIR_EraseRootFromParent_Done,
      // Label 23668: @1879708
      GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1879812), // Rule ID 13256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13256,
        GIR_EraseRootFromParent_Done,
      // Label 23669: @1879812
      GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1879916), // Rule ID 13257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13257,
        GIR_EraseRootFromParent_Done,
      // Label 23670: @1879916
      GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1880020), // Rule ID 13260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13260,
        GIR_EraseRootFromParent_Done,
      // Label 23671: @1880020
      GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1880124), // Rule ID 13261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13261,
        GIR_EraseRootFromParent_Done,
      // Label 23672: @1880124
      GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1880228), // Rule ID 13264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13264,
        GIR_EraseRootFromParent_Done,
      // Label 23673: @1880228
      GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1880332), // Rule ID 13265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13265,
        GIR_EraseRootFromParent_Done,
      // Label 23674: @1880332
      GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1880436), // Rule ID 13268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13268,
        GIR_EraseRootFromParent_Done,
      // Label 23675: @1880436
      GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1880540), // Rule ID 13269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13269,
        GIR_EraseRootFromParent_Done,
      // Label 23676: @1880540
      GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1880644), // Rule ID 13272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13272,
        GIR_EraseRootFromParent_Done,
      // Label 23677: @1880644
      GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1880748), // Rule ID 13273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13273,
        GIR_EraseRootFromParent_Done,
      // Label 23678: @1880748
      GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1880852), // Rule ID 13276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13276,
        GIR_EraseRootFromParent_Done,
      // Label 23679: @1880852
      GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1880956), // Rule ID 13277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13277,
        GIR_EraseRootFromParent_Done,
      // Label 23680: @1880956
      GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1881060), // Rule ID 13280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13280,
        GIR_EraseRootFromParent_Done,
      // Label 23681: @1881060
      GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1881164), // Rule ID 13281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13281,
        GIR_EraseRootFromParent_Done,
      // Label 23682: @1881164
      GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1881268), // Rule ID 13284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13284,
        GIR_EraseRootFromParent_Done,
      // Label 23683: @1881268
      GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1881372), // Rule ID 13285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13285,
        GIR_EraseRootFromParent_Done,
      // Label 23684: @1881372
      GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1881476), // Rule ID 13288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13288,
        GIR_EraseRootFromParent_Done,
      // Label 23685: @1881476
      GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1881580), // Rule ID 13289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13289,
        GIR_EraseRootFromParent_Done,
      // Label 23686: @1881580
      GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1881684), // Rule ID 13292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13292,
        GIR_EraseRootFromParent_Done,
      // Label 23687: @1881684
      GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1881788), // Rule ID 13293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13293,
        GIR_EraseRootFromParent_Done,
      // Label 23688: @1881788
      GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1881892), // Rule ID 13296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13296,
        GIR_EraseRootFromParent_Done,
      // Label 23689: @1881892
      GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1881996), // Rule ID 13297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13297,
        GIR_EraseRootFromParent_Done,
      // Label 23690: @1881996
      GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1882100), // Rule ID 13300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13300,
        GIR_EraseRootFromParent_Done,
      // Label 23691: @1882100
      GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1882204), // Rule ID 13301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13301,
        GIR_EraseRootFromParent_Done,
      // Label 23692: @1882204
      GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1882308), // Rule ID 13304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13304,
        GIR_EraseRootFromParent_Done,
      // Label 23693: @1882308
      GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1882412), // Rule ID 13305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13305,
        GIR_EraseRootFromParent_Done,
      // Label 23694: @1882412
      GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1882516), // Rule ID 13308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13308,
        GIR_EraseRootFromParent_Done,
      // Label 23695: @1882516
      GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1882620), // Rule ID 13309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13309,
        GIR_EraseRootFromParent_Done,
      // Label 23696: @1882620
      GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1882724), // Rule ID 13312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13312,
        GIR_EraseRootFromParent_Done,
      // Label 23697: @1882724
      GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1882828), // Rule ID 13313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13313,
        GIR_EraseRootFromParent_Done,
      // Label 23698: @1882828
      GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1882932), // Rule ID 13316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13316,
        GIR_EraseRootFromParent_Done,
      // Label 23699: @1882932
      GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1883036), // Rule ID 13317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13317,
        GIR_EraseRootFromParent_Done,
      // Label 23700: @1883036
      GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1883140), // Rule ID 13320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13320,
        GIR_EraseRootFromParent_Done,
      // Label 23701: @1883140
      GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1883244), // Rule ID 13321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13321,
        GIR_EraseRootFromParent_Done,
      // Label 23702: @1883244
      GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1883348), // Rule ID 13324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13324,
        GIR_EraseRootFromParent_Done,
      // Label 23703: @1883348
      GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1883452), // Rule ID 13325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13325,
        GIR_EraseRootFromParent_Done,
      // Label 23704: @1883452
      GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1883556), // Rule ID 13328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13328,
        GIR_EraseRootFromParent_Done,
      // Label 23705: @1883556
      GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1883660), // Rule ID 13329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13329,
        GIR_EraseRootFromParent_Done,
      // Label 23706: @1883660
      GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1883764), // Rule ID 13332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13332,
        GIR_EraseRootFromParent_Done,
      // Label 23707: @1883764
      GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1883868), // Rule ID 13333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13333,
        GIR_EraseRootFromParent_Done,
      // Label 23708: @1883868
      GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1883972), // Rule ID 13336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13336,
        GIR_EraseRootFromParent_Done,
      // Label 23709: @1883972
      GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1884076), // Rule ID 13337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13337,
        GIR_EraseRootFromParent_Done,
      // Label 23710: @1884076
      GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1884180), // Rule ID 13340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13340,
        GIR_EraseRootFromParent_Done,
      // Label 23711: @1884180
      GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1884284), // Rule ID 13341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13341,
        GIR_EraseRootFromParent_Done,
      // Label 23712: @1884284
      GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1884388), // Rule ID 13344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13344,
        GIR_EraseRootFromParent_Done,
      // Label 23713: @1884388
      GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1884492), // Rule ID 13345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13345,
        GIR_EraseRootFromParent_Done,
      // Label 23714: @1884492
      GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1884596), // Rule ID 13348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13348,
        GIR_EraseRootFromParent_Done,
      // Label 23715: @1884596
      GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1884700), // Rule ID 13349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13349,
        GIR_EraseRootFromParent_Done,
      // Label 23716: @1884700
      GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1884804), // Rule ID 13352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13352,
        GIR_EraseRootFromParent_Done,
      // Label 23717: @1884804
      GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1884908), // Rule ID 13353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13353,
        GIR_EraseRootFromParent_Done,
      // Label 23718: @1884908
      GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1885012), // Rule ID 13356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13356,
        GIR_EraseRootFromParent_Done,
      // Label 23719: @1885012
      GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1885116), // Rule ID 13357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13357,
        GIR_EraseRootFromParent_Done,
      // Label 23720: @1885116
      GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1885220), // Rule ID 13360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13360,
        GIR_EraseRootFromParent_Done,
      // Label 23721: @1885220
      GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1885324), // Rule ID 13361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13361,
        GIR_EraseRootFromParent_Done,
      // Label 23722: @1885324
      GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1885428), // Rule ID 13364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13364,
        GIR_EraseRootFromParent_Done,
      // Label 23723: @1885428
      GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1885532), // Rule ID 13365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13365,
        GIR_EraseRootFromParent_Done,
      // Label 23724: @1885532
      GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1885636), // Rule ID 13368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13368,
        GIR_EraseRootFromParent_Done,
      // Label 23725: @1885636
      GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1885740), // Rule ID 13369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13369,
        GIR_EraseRootFromParent_Done,
      // Label 23726: @1885740
      GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1885844), // Rule ID 13372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13372,
        GIR_EraseRootFromParent_Done,
      // Label 23727: @1885844
      GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1885948), // Rule ID 13373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13373,
        GIR_EraseRootFromParent_Done,
      // Label 23728: @1885948
      GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1886052), // Rule ID 13376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13376,
        GIR_EraseRootFromParent_Done,
      // Label 23729: @1886052
      GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1886156), // Rule ID 13377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13377,
        GIR_EraseRootFromParent_Done,
      // Label 23730: @1886156
      GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1886260), // Rule ID 13380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13380,
        GIR_EraseRootFromParent_Done,
      // Label 23731: @1886260
      GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1886364), // Rule ID 13381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13381,
        GIR_EraseRootFromParent_Done,
      // Label 23732: @1886364
      GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1886468), // Rule ID 13384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13384,
        GIR_EraseRootFromParent_Done,
      // Label 23733: @1886468
      GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1886572), // Rule ID 13385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13385,
        GIR_EraseRootFromParent_Done,
      // Label 23734: @1886572
      GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1886676), // Rule ID 13388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13388,
        GIR_EraseRootFromParent_Done,
      // Label 23735: @1886676
      GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1886780), // Rule ID 13389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13389,
        GIR_EraseRootFromParent_Done,
      // Label 23736: @1886780
      GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1886884), // Rule ID 13392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13392,
        GIR_EraseRootFromParent_Done,
      // Label 23737: @1886884
      GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1886988), // Rule ID 13393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13393,
        GIR_EraseRootFromParent_Done,
      // Label 23738: @1886988
      GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1887092), // Rule ID 13396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13396,
        GIR_EraseRootFromParent_Done,
      // Label 23739: @1887092
      GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1887196), // Rule ID 13397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13397,
        GIR_EraseRootFromParent_Done,
      // Label 23740: @1887196
      GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1887300), // Rule ID 13400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13400,
        GIR_EraseRootFromParent_Done,
      // Label 23741: @1887300
      GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1887404), // Rule ID 13401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13401,
        GIR_EraseRootFromParent_Done,
      // Label 23742: @1887404
      GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1887508), // Rule ID 13404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13404,
        GIR_EraseRootFromParent_Done,
      // Label 23743: @1887508
      GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1887612), // Rule ID 13405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13405,
        GIR_EraseRootFromParent_Done,
      // Label 23744: @1887612
      GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1887716), // Rule ID 13408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13408,
        GIR_EraseRootFromParent_Done,
      // Label 23745: @1887716
      GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1887820), // Rule ID 13409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13409,
        GIR_EraseRootFromParent_Done,
      // Label 23746: @1887820
      GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1887924), // Rule ID 13412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13412,
        GIR_EraseRootFromParent_Done,
      // Label 23747: @1887924
      GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1888028), // Rule ID 13413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13413,
        GIR_EraseRootFromParent_Done,
      // Label 23748: @1888028
      GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1888132), // Rule ID 13416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13416,
        GIR_EraseRootFromParent_Done,
      // Label 23749: @1888132
      GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1888236), // Rule ID 13417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13417,
        GIR_EraseRootFromParent_Done,
      // Label 23750: @1888236
      GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1888340), // Rule ID 13420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13420,
        GIR_EraseRootFromParent_Done,
      // Label 23751: @1888340
      GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1888444), // Rule ID 13421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13421,
        GIR_EraseRootFromParent_Done,
      // Label 23752: @1888444
      GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1888548), // Rule ID 13424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13424,
        GIR_EraseRootFromParent_Done,
      // Label 23753: @1888548
      GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1888652), // Rule ID 13425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13425,
        GIR_EraseRootFromParent_Done,
      // Label 23754: @1888652
      GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1888756), // Rule ID 13428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13428,
        GIR_EraseRootFromParent_Done,
      // Label 23755: @1888756
      GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1888860), // Rule ID 13429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13429,
        GIR_EraseRootFromParent_Done,
      // Label 23756: @1888860
      GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1888964), // Rule ID 13432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13432,
        GIR_EraseRootFromParent_Done,
      // Label 23757: @1888964
      GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1889068), // Rule ID 13433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13433,
        GIR_EraseRootFromParent_Done,
      // Label 23758: @1889068
      GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1889172), // Rule ID 13436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13436,
        GIR_EraseRootFromParent_Done,
      // Label 23759: @1889172
      GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1889276), // Rule ID 13437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13437,
        GIR_EraseRootFromParent_Done,
      // Label 23760: @1889276
      GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1889380), // Rule ID 13440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13440,
        GIR_EraseRootFromParent_Done,
      // Label 23761: @1889380
      GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1889484), // Rule ID 13441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13441,
        GIR_EraseRootFromParent_Done,
      // Label 23762: @1889484
      GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1889588), // Rule ID 13444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13444,
        GIR_EraseRootFromParent_Done,
      // Label 23763: @1889588
      GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1889692), // Rule ID 13445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13445,
        GIR_EraseRootFromParent_Done,
      // Label 23764: @1889692
      GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1889796), // Rule ID 13448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13448,
        GIR_EraseRootFromParent_Done,
      // Label 23765: @1889796
      GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1889900), // Rule ID 13449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13449,
        GIR_EraseRootFromParent_Done,
      // Label 23766: @1889900
      GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1890004), // Rule ID 13452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13452,
        GIR_EraseRootFromParent_Done,
      // Label 23767: @1890004
      GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1890108), // Rule ID 13453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13453,
        GIR_EraseRootFromParent_Done,
      // Label 23768: @1890108
      GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1890212), // Rule ID 13456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13456,
        GIR_EraseRootFromParent_Done,
      // Label 23769: @1890212
      GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1890316), // Rule ID 13457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13457,
        GIR_EraseRootFromParent_Done,
      // Label 23770: @1890316
      GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1890420), // Rule ID 13460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13460,
        GIR_EraseRootFromParent_Done,
      // Label 23771: @1890420
      GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1890524), // Rule ID 13461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13461,
        GIR_EraseRootFromParent_Done,
      // Label 23772: @1890524
      GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1890628), // Rule ID 13464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13464,
        GIR_EraseRootFromParent_Done,
      // Label 23773: @1890628
      GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1890732), // Rule ID 13465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13465,
        GIR_EraseRootFromParent_Done,
      // Label 23774: @1890732
      GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1890836), // Rule ID 13468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13468,
        GIR_EraseRootFromParent_Done,
      // Label 23775: @1890836
      GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1890940), // Rule ID 13469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13469,
        GIR_EraseRootFromParent_Done,
      // Label 23776: @1890940
      GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1891044), // Rule ID 13472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13472,
        GIR_EraseRootFromParent_Done,
      // Label 23777: @1891044
      GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1891148), // Rule ID 13473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13473,
        GIR_EraseRootFromParent_Done,
      // Label 23778: @1891148
      GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1891252), // Rule ID 13476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13476,
        GIR_EraseRootFromParent_Done,
      // Label 23779: @1891252
      GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1891356), // Rule ID 13477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13477,
        GIR_EraseRootFromParent_Done,
      // Label 23780: @1891356
      GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1891460), // Rule ID 13480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13480,
        GIR_EraseRootFromParent_Done,
      // Label 23781: @1891460
      GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1891564), // Rule ID 13481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13481,
        GIR_EraseRootFromParent_Done,
      // Label 23782: @1891564
      GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1891668), // Rule ID 13484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13484,
        GIR_EraseRootFromParent_Done,
      // Label 23783: @1891668
      GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1891772), // Rule ID 13485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13485,
        GIR_EraseRootFromParent_Done,
      // Label 23784: @1891772
      GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1891876), // Rule ID 13488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13488,
        GIR_EraseRootFromParent_Done,
      // Label 23785: @1891876
      GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1891980), // Rule ID 13489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13489,
        GIR_EraseRootFromParent_Done,
      // Label 23786: @1891980
      GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1892084), // Rule ID 13492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13492,
        GIR_EraseRootFromParent_Done,
      // Label 23787: @1892084
      GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1892188), // Rule ID 13493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13493,
        GIR_EraseRootFromParent_Done,
      // Label 23788: @1892188
      GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1892292), // Rule ID 13496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13496,
        GIR_EraseRootFromParent_Done,
      // Label 23789: @1892292
      GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1892396), // Rule ID 13497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13497,
        GIR_EraseRootFromParent_Done,
      // Label 23790: @1892396
      GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1892500), // Rule ID 13500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13500,
        GIR_EraseRootFromParent_Done,
      // Label 23791: @1892500
      GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1892604), // Rule ID 13501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13501,
        GIR_EraseRootFromParent_Done,
      // Label 23792: @1892604
      GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1892708), // Rule ID 13504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13504,
        GIR_EraseRootFromParent_Done,
      // Label 23793: @1892708
      GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1892812), // Rule ID 13505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13505,
        GIR_EraseRootFromParent_Done,
      // Label 23794: @1892812
      GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1892916), // Rule ID 13508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13508,
        GIR_EraseRootFromParent_Done,
      // Label 23795: @1892916
      GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1893020), // Rule ID 13509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13509,
        GIR_EraseRootFromParent_Done,
      // Label 23796: @1893020
      GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1893124), // Rule ID 13512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13512,
        GIR_EraseRootFromParent_Done,
      // Label 23797: @1893124
      GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1893228), // Rule ID 13513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13513,
        GIR_EraseRootFromParent_Done,
      // Label 23798: @1893228
      GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1893332), // Rule ID 13516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13516,
        GIR_EraseRootFromParent_Done,
      // Label 23799: @1893332
      GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1893436), // Rule ID 13517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13517,
        GIR_EraseRootFromParent_Done,
      // Label 23800: @1893436
      GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1893540), // Rule ID 13520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13520,
        GIR_EraseRootFromParent_Done,
      // Label 23801: @1893540
      GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1893644), // Rule ID 13521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13521,
        GIR_EraseRootFromParent_Done,
      // Label 23802: @1893644
      GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1893748), // Rule ID 13524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13524,
        GIR_EraseRootFromParent_Done,
      // Label 23803: @1893748
      GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1893852), // Rule ID 13525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13525,
        GIR_EraseRootFromParent_Done,
      // Label 23804: @1893852
      GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1893956), // Rule ID 13528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13528,
        GIR_EraseRootFromParent_Done,
      // Label 23805: @1893956
      GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1894060), // Rule ID 13529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13529,
        GIR_EraseRootFromParent_Done,
      // Label 23806: @1894060
      GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1894164), // Rule ID 13532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13532,
        GIR_EraseRootFromParent_Done,
      // Label 23807: @1894164
      GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1894268), // Rule ID 13533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13533,
        GIR_EraseRootFromParent_Done,
      // Label 23808: @1894268
      GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1894372), // Rule ID 13536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13536,
        GIR_EraseRootFromParent_Done,
      // Label 23809: @1894372
      GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1894476), // Rule ID 13537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13537,
        GIR_EraseRootFromParent_Done,
      // Label 23810: @1894476
      GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1894580), // Rule ID 13540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13540,
        GIR_EraseRootFromParent_Done,
      // Label 23811: @1894580
      GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1894684), // Rule ID 13541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13541,
        GIR_EraseRootFromParent_Done,
      // Label 23812: @1894684
      GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1894788), // Rule ID 13544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13544,
        GIR_EraseRootFromParent_Done,
      // Label 23813: @1894788
      GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1894892), // Rule ID 13545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13545,
        GIR_EraseRootFromParent_Done,
      // Label 23814: @1894892
      GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1894996), // Rule ID 13548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13548,
        GIR_EraseRootFromParent_Done,
      // Label 23815: @1894996
      GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1895100), // Rule ID 13549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13549,
        GIR_EraseRootFromParent_Done,
      // Label 23816: @1895100
      GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1895204), // Rule ID 13552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13552,
        GIR_EraseRootFromParent_Done,
      // Label 23817: @1895204
      GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1895308), // Rule ID 13553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13553,
        GIR_EraseRootFromParent_Done,
      // Label 23818: @1895308
      GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1895412), // Rule ID 13556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13556,
        GIR_EraseRootFromParent_Done,
      // Label 23819: @1895412
      GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1895516), // Rule ID 13557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13557,
        GIR_EraseRootFromParent_Done,
      // Label 23820: @1895516
      GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1895620), // Rule ID 13560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13560,
        GIR_EraseRootFromParent_Done,
      // Label 23821: @1895620
      GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1895724), // Rule ID 13561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13561,
        GIR_EraseRootFromParent_Done,
      // Label 23822: @1895724
      GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1895828), // Rule ID 13564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13564,
        GIR_EraseRootFromParent_Done,
      // Label 23823: @1895828
      GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1895932), // Rule ID 13565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13565,
        GIR_EraseRootFromParent_Done,
      // Label 23824: @1895932
      GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1896036), // Rule ID 13568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13568,
        GIR_EraseRootFromParent_Done,
      // Label 23825: @1896036
      GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1896140), // Rule ID 13569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13569,
        GIR_EraseRootFromParent_Done,
      // Label 23826: @1896140
      GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1896244), // Rule ID 13572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13572,
        GIR_EraseRootFromParent_Done,
      // Label 23827: @1896244
      GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1896348), // Rule ID 13573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13573,
        GIR_EraseRootFromParent_Done,
      // Label 23828: @1896348
      GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1896452), // Rule ID 13576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13576,
        GIR_EraseRootFromParent_Done,
      // Label 23829: @1896452
      GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1896556), // Rule ID 13577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13577,
        GIR_EraseRootFromParent_Done,
      // Label 23830: @1896556
      GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1896660), // Rule ID 13580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13580,
        GIR_EraseRootFromParent_Done,
      // Label 23831: @1896660
      GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1896764), // Rule ID 13581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13581,
        GIR_EraseRootFromParent_Done,
      // Label 23832: @1896764
      GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1896868), // Rule ID 13584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13584,
        GIR_EraseRootFromParent_Done,
      // Label 23833: @1896868
      GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1896972), // Rule ID 13585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13585,
        GIR_EraseRootFromParent_Done,
      // Label 23834: @1896972
      GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1897076), // Rule ID 13588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13588,
        GIR_EraseRootFromParent_Done,
      // Label 23835: @1897076
      GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1897180), // Rule ID 13589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13589,
        GIR_EraseRootFromParent_Done,
      // Label 23836: @1897180
      GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1897284), // Rule ID 13592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13592,
        GIR_EraseRootFromParent_Done,
      // Label 23837: @1897284
      GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1897388), // Rule ID 13593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13593,
        GIR_EraseRootFromParent_Done,
      // Label 23838: @1897388
      GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1897492), // Rule ID 13596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13596,
        GIR_EraseRootFromParent_Done,
      // Label 23839: @1897492
      GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1897596), // Rule ID 13597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13597,
        GIR_EraseRootFromParent_Done,
      // Label 23840: @1897596
      GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1897700), // Rule ID 13600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13600,
        GIR_EraseRootFromParent_Done,
      // Label 23841: @1897700
      GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1897804), // Rule ID 13601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13601,
        GIR_EraseRootFromParent_Done,
      // Label 23842: @1897804
      GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1897908), // Rule ID 13604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13604,
        GIR_EraseRootFromParent_Done,
      // Label 23843: @1897908
      GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1898012), // Rule ID 13605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13605,
        GIR_EraseRootFromParent_Done,
      // Label 23844: @1898012
      GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1898116), // Rule ID 13608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13608,
        GIR_EraseRootFromParent_Done,
      // Label 23845: @1898116
      GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1898220), // Rule ID 13609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13609,
        GIR_EraseRootFromParent_Done,
      // Label 23846: @1898220
      GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1898324), // Rule ID 13612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13612,
        GIR_EraseRootFromParent_Done,
      // Label 23847: @1898324
      GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1898428), // Rule ID 13613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13613,
        GIR_EraseRootFromParent_Done,
      // Label 23848: @1898428
      GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1898532), // Rule ID 13616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13616,
        GIR_EraseRootFromParent_Done,
      // Label 23849: @1898532
      GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1898636), // Rule ID 13617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13617,
        GIR_EraseRootFromParent_Done,
      // Label 23850: @1898636
      GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1898740), // Rule ID 13620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13620,
        GIR_EraseRootFromParent_Done,
      // Label 23851: @1898740
      GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1898844), // Rule ID 13621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13621,
        GIR_EraseRootFromParent_Done,
      // Label 23852: @1898844
      GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1898948), // Rule ID 13624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13624,
        GIR_EraseRootFromParent_Done,
      // Label 23853: @1898948
      GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1899052), // Rule ID 13625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13625,
        GIR_EraseRootFromParent_Done,
      // Label 23854: @1899052
      GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1899156), // Rule ID 13628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13628,
        GIR_EraseRootFromParent_Done,
      // Label 23855: @1899156
      GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1899260), // Rule ID 13629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13629,
        GIR_EraseRootFromParent_Done,
      // Label 23856: @1899260
      GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1899364), // Rule ID 13632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13632,
        GIR_EraseRootFromParent_Done,
      // Label 23857: @1899364
      GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1899468), // Rule ID 13633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13633,
        GIR_EraseRootFromParent_Done,
      // Label 23858: @1899468
      GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1899572), // Rule ID 13636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13636,
        GIR_EraseRootFromParent_Done,
      // Label 23859: @1899572
      GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1899676), // Rule ID 13637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13637,
        GIR_EraseRootFromParent_Done,
      // Label 23860: @1899676
      GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1899780), // Rule ID 13640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13640,
        GIR_EraseRootFromParent_Done,
      // Label 23861: @1899780
      GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1899884), // Rule ID 13641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13641,
        GIR_EraseRootFromParent_Done,
      // Label 23862: @1899884
      GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1899988), // Rule ID 13644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13644,
        GIR_EraseRootFromParent_Done,
      // Label 23863: @1899988
      GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1900092), // Rule ID 13645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13645,
        GIR_EraseRootFromParent_Done,
      // Label 23864: @1900092
      GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1900196), // Rule ID 13648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13648,
        GIR_EraseRootFromParent_Done,
      // Label 23865: @1900196
      GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1900300), // Rule ID 13649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13649,
        GIR_EraseRootFromParent_Done,
      // Label 23866: @1900300
      GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1900404), // Rule ID 13652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13652,
        GIR_EraseRootFromParent_Done,
      // Label 23867: @1900404
      GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1900508), // Rule ID 13653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13653,
        GIR_EraseRootFromParent_Done,
      // Label 23868: @1900508
      GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1900612), // Rule ID 13656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13656,
        GIR_EraseRootFromParent_Done,
      // Label 23869: @1900612
      GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1900716), // Rule ID 13657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13657,
        GIR_EraseRootFromParent_Done,
      // Label 23870: @1900716
      GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1900820), // Rule ID 13660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13660,
        GIR_EraseRootFromParent_Done,
      // Label 23871: @1900820
      GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1900924), // Rule ID 13661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13661,
        GIR_EraseRootFromParent_Done,
      // Label 23872: @1900924
      GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1901028), // Rule ID 13664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13664,
        GIR_EraseRootFromParent_Done,
      // Label 23873: @1901028
      GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1901132), // Rule ID 13665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13665,
        GIR_EraseRootFromParent_Done,
      // Label 23874: @1901132
      GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1901236), // Rule ID 13668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13668,
        GIR_EraseRootFromParent_Done,
      // Label 23875: @1901236
      GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1901340), // Rule ID 13669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13669,
        GIR_EraseRootFromParent_Done,
      // Label 23876: @1901340
      GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1901444), // Rule ID 13672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13672,
        GIR_EraseRootFromParent_Done,
      // Label 23877: @1901444
      GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1901548), // Rule ID 13673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13673,
        GIR_EraseRootFromParent_Done,
      // Label 23878: @1901548
      GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1901652), // Rule ID 13676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13676,
        GIR_EraseRootFromParent_Done,
      // Label 23879: @1901652
      GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1901756), // Rule ID 13677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13677,
        GIR_EraseRootFromParent_Done,
      // Label 23880: @1901756
      GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1901860), // Rule ID 13680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13680,
        GIR_EraseRootFromParent_Done,
      // Label 23881: @1901860
      GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1901964), // Rule ID 13681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13681,
        GIR_EraseRootFromParent_Done,
      // Label 23882: @1901964
      GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1902068), // Rule ID 13684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13684,
        GIR_EraseRootFromParent_Done,
      // Label 23883: @1902068
      GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1902172), // Rule ID 13685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13685,
        GIR_EraseRootFromParent_Done,
      // Label 23884: @1902172
      GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1902276), // Rule ID 13688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13688,
        GIR_EraseRootFromParent_Done,
      // Label 23885: @1902276
      GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1902380), // Rule ID 13689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13689,
        GIR_EraseRootFromParent_Done,
      // Label 23886: @1902380
      GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1902484), // Rule ID 13692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13692,
        GIR_EraseRootFromParent_Done,
      // Label 23887: @1902484
      GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1902588), // Rule ID 13693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13693,
        GIR_EraseRootFromParent_Done,
      // Label 23888: @1902588
      GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1902692), // Rule ID 13696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13696,
        GIR_EraseRootFromParent_Done,
      // Label 23889: @1902692
      GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1902796), // Rule ID 13697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13697,
        GIR_EraseRootFromParent_Done,
      // Label 23890: @1902796
      GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1902903), // Rule ID 13906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13906,
        GIR_EraseRootFromParent_Done,
      // Label 23891: @1902903
      GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1903010), // Rule ID 13907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13907,
        GIR_EraseRootFromParent_Done,
      // Label 23892: @1903010
      GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1903117), // Rule ID 13910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13910,
        GIR_EraseRootFromParent_Done,
      // Label 23893: @1903117
      GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1903224), // Rule ID 13911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13911,
        GIR_EraseRootFromParent_Done,
      // Label 23894: @1903224
      GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1903331), // Rule ID 13914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13914,
        GIR_EraseRootFromParent_Done,
      // Label 23895: @1903331
      GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1903438), // Rule ID 13915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13915,
        GIR_EraseRootFromParent_Done,
      // Label 23896: @1903438
      GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1903545), // Rule ID 13918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13918,
        GIR_EraseRootFromParent_Done,
      // Label 23897: @1903545
      GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1903652), // Rule ID 13919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13919,
        GIR_EraseRootFromParent_Done,
      // Label 23898: @1903652
      GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1903759), // Rule ID 13922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13922,
        GIR_EraseRootFromParent_Done,
      // Label 23899: @1903759
      GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1903866), // Rule ID 13923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13923,
        GIR_EraseRootFromParent_Done,
      // Label 23900: @1903866
      GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1903973), // Rule ID 13926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13926,
        GIR_EraseRootFromParent_Done,
      // Label 23901: @1903973
      GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1904080), // Rule ID 13927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13927,
        GIR_EraseRootFromParent_Done,
      // Label 23902: @1904080
      GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1904187), // Rule ID 13930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13930,
        GIR_EraseRootFromParent_Done,
      // Label 23903: @1904187
      GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1904294), // Rule ID 13931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13931,
        GIR_EraseRootFromParent_Done,
      // Label 23904: @1904294
      GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1904401), // Rule ID 13934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13934,
        GIR_EraseRootFromParent_Done,
      // Label 23905: @1904401
      GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1904508), // Rule ID 13935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13935,
        GIR_EraseRootFromParent_Done,
      // Label 23906: @1904508
      GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1904615), // Rule ID 13938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13938,
        GIR_EraseRootFromParent_Done,
      // Label 23907: @1904615
      GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1904722), // Rule ID 13939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13939,
        GIR_EraseRootFromParent_Done,
      // Label 23908: @1904722
      GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1904829), // Rule ID 13942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13942,
        GIR_EraseRootFromParent_Done,
      // Label 23909: @1904829
      GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1904936), // Rule ID 13943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13943,
        GIR_EraseRootFromParent_Done,
      // Label 23910: @1904936
      GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1905043), // Rule ID 13946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13946,
        GIR_EraseRootFromParent_Done,
      // Label 23911: @1905043
      GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1905150), // Rule ID 13947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13947,
        GIR_EraseRootFromParent_Done,
      // Label 23912: @1905150
      GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1905257), // Rule ID 13950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13950,
        GIR_EraseRootFromParent_Done,
      // Label 23913: @1905257
      GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1905364), // Rule ID 13951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13951,
        GIR_EraseRootFromParent_Done,
      // Label 23914: @1905364
      GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1905471), // Rule ID 13954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13954,
        GIR_EraseRootFromParent_Done,
      // Label 23915: @1905471
      GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1905578), // Rule ID 13955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13955,
        GIR_EraseRootFromParent_Done,
      // Label 23916: @1905578
      GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1905685), // Rule ID 13958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13958,
        GIR_EraseRootFromParent_Done,
      // Label 23917: @1905685
      GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1905792), // Rule ID 13959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13959,
        GIR_EraseRootFromParent_Done,
      // Label 23918: @1905792
      GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1905899), // Rule ID 13962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13962,
        GIR_EraseRootFromParent_Done,
      // Label 23919: @1905899
      GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1906006), // Rule ID 13963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13963,
        GIR_EraseRootFromParent_Done,
      // Label 23920: @1906006
      GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1906113), // Rule ID 13966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13966,
        GIR_EraseRootFromParent_Done,
      // Label 23921: @1906113
      GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1906220), // Rule ID 13967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13967,
        GIR_EraseRootFromParent_Done,
      // Label 23922: @1906220
      GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1906327), // Rule ID 13970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13970,
        GIR_EraseRootFromParent_Done,
      // Label 23923: @1906327
      GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1906434), // Rule ID 13971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13971,
        GIR_EraseRootFromParent_Done,
      // Label 23924: @1906434
      GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1906541), // Rule ID 13974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13974,
        GIR_EraseRootFromParent_Done,
      // Label 23925: @1906541
      GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1906648), // Rule ID 13975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13975,
        GIR_EraseRootFromParent_Done,
      // Label 23926: @1906648
      GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1906755), // Rule ID 13978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13978,
        GIR_EraseRootFromParent_Done,
      // Label 23927: @1906755
      GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1906862), // Rule ID 13979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13979,
        GIR_EraseRootFromParent_Done,
      // Label 23928: @1906862
      GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1906969), // Rule ID 13982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13982,
        GIR_EraseRootFromParent_Done,
      // Label 23929: @1906969
      GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1907076), // Rule ID 13983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13983,
        GIR_EraseRootFromParent_Done,
      // Label 23930: @1907076
      GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1907183), // Rule ID 13986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13986,
        GIR_EraseRootFromParent_Done,
      // Label 23931: @1907183
      GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1907290), // Rule ID 13987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13987,
        GIR_EraseRootFromParent_Done,
      // Label 23932: @1907290
      GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1907397), // Rule ID 13990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13990,
        GIR_EraseRootFromParent_Done,
      // Label 23933: @1907397
      GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1907504), // Rule ID 13991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13991,
        GIR_EraseRootFromParent_Done,
      // Label 23934: @1907504
      GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1907611), // Rule ID 13994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13994,
        GIR_EraseRootFromParent_Done,
      // Label 23935: @1907611
      GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1907718), // Rule ID 13995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13995,
        GIR_EraseRootFromParent_Done,
      // Label 23936: @1907718
      GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1907825), // Rule ID 13998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13998,
        GIR_EraseRootFromParent_Done,
      // Label 23937: @1907825
      GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1907932), // Rule ID 13999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13999,
        GIR_EraseRootFromParent_Done,
      // Label 23938: @1907932
      GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1908039), // Rule ID 14002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14002,
        GIR_EraseRootFromParent_Done,
      // Label 23939: @1908039
      GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1908146), // Rule ID 14003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14003,
        GIR_EraseRootFromParent_Done,
      // Label 23940: @1908146
      GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1908253), // Rule ID 14006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14006,
        GIR_EraseRootFromParent_Done,
      // Label 23941: @1908253
      GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1908360), // Rule ID 14007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14007,
        GIR_EraseRootFromParent_Done,
      // Label 23942: @1908360
      GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1908467), // Rule ID 14010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14010,
        GIR_EraseRootFromParent_Done,
      // Label 23943: @1908467
      GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1908574), // Rule ID 14011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14011,
        GIR_EraseRootFromParent_Done,
      // Label 23944: @1908574
      GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1908681), // Rule ID 14014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14014,
        GIR_EraseRootFromParent_Done,
      // Label 23945: @1908681
      GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1908788), // Rule ID 14015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14015,
        GIR_EraseRootFromParent_Done,
      // Label 23946: @1908788
      GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1908895), // Rule ID 14018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14018,
        GIR_EraseRootFromParent_Done,
      // Label 23947: @1908895
      GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1909002), // Rule ID 14019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14019,
        GIR_EraseRootFromParent_Done,
      // Label 23948: @1909002
      GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1909109), // Rule ID 14022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14022,
        GIR_EraseRootFromParent_Done,
      // Label 23949: @1909109
      GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1909216), // Rule ID 14023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14023,
        GIR_EraseRootFromParent_Done,
      // Label 23950: @1909216
      GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1909323), // Rule ID 14026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14026,
        GIR_EraseRootFromParent_Done,
      // Label 23951: @1909323
      GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1909430), // Rule ID 14027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14027,
        GIR_EraseRootFromParent_Done,
      // Label 23952: @1909430
      GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1909537), // Rule ID 14030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14030,
        GIR_EraseRootFromParent_Done,
      // Label 23953: @1909537
      GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1909644), // Rule ID 14031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14031,
        GIR_EraseRootFromParent_Done,
      // Label 23954: @1909644
      GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1909751), // Rule ID 14034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14034,
        GIR_EraseRootFromParent_Done,
      // Label 23955: @1909751
      GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1909858), // Rule ID 14035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14035,
        GIR_EraseRootFromParent_Done,
      // Label 23956: @1909858
      GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1909965), // Rule ID 14038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14038,
        GIR_EraseRootFromParent_Done,
      // Label 23957: @1909965
      GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1910072), // Rule ID 14039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14039,
        GIR_EraseRootFromParent_Done,
      // Label 23958: @1910072
      GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1910179), // Rule ID 14042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14042,
        GIR_EraseRootFromParent_Done,
      // Label 23959: @1910179
      GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1910286), // Rule ID 14043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14043,
        GIR_EraseRootFromParent_Done,
      // Label 23960: @1910286
      GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1910393), // Rule ID 14046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14046,
        GIR_EraseRootFromParent_Done,
      // Label 23961: @1910393
      GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1910500), // Rule ID 14047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14047,
        GIR_EraseRootFromParent_Done,
      // Label 23962: @1910500
      GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1910607), // Rule ID 14050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14050,
        GIR_EraseRootFromParent_Done,
      // Label 23963: @1910607
      GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1910714), // Rule ID 14051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14051,
        GIR_EraseRootFromParent_Done,
      // Label 23964: @1910714
      GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1910821), // Rule ID 14054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14054,
        GIR_EraseRootFromParent_Done,
      // Label 23965: @1910821
      GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1910928), // Rule ID 14055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14055,
        GIR_EraseRootFromParent_Done,
      // Label 23966: @1910928
      GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1911035), // Rule ID 14058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14058,
        GIR_EraseRootFromParent_Done,
      // Label 23967: @1911035
      GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1911142), // Rule ID 14059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14059,
        GIR_EraseRootFromParent_Done,
      // Label 23968: @1911142
      GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1911249), // Rule ID 14062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14062,
        GIR_EraseRootFromParent_Done,
      // Label 23969: @1911249
      GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1911356), // Rule ID 14063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14063,
        GIR_EraseRootFromParent_Done,
      // Label 23970: @1911356
      GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1911463), // Rule ID 14066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14066,
        GIR_EraseRootFromParent_Done,
      // Label 23971: @1911463
      GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1911570), // Rule ID 14067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14067,
        GIR_EraseRootFromParent_Done,
      // Label 23972: @1911570
      GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1911677), // Rule ID 14070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14070,
        GIR_EraseRootFromParent_Done,
      // Label 23973: @1911677
      GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1911784), // Rule ID 14071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14071,
        GIR_EraseRootFromParent_Done,
      // Label 23974: @1911784
      GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1911891), // Rule ID 14074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14074,
        GIR_EraseRootFromParent_Done,
      // Label 23975: @1911891
      GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1911998), // Rule ID 14075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14075,
        GIR_EraseRootFromParent_Done,
      // Label 23976: @1911998
      GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1912105), // Rule ID 14078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14078,
        GIR_EraseRootFromParent_Done,
      // Label 23977: @1912105
      GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1912212), // Rule ID 14079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14079,
        GIR_EraseRootFromParent_Done,
      // Label 23978: @1912212
      GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1912319), // Rule ID 14170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14170,
        GIR_EraseRootFromParent_Done,
      // Label 23979: @1912319
      GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1912426), // Rule ID 14171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14171,
        GIR_EraseRootFromParent_Done,
      // Label 23980: @1912426
      GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1912533), // Rule ID 14174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14174,
        GIR_EraseRootFromParent_Done,
      // Label 23981: @1912533
      GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1912640), // Rule ID 14175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14175,
        GIR_EraseRootFromParent_Done,
      // Label 23982: @1912640
      GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1912747), // Rule ID 14178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14178,
        GIR_EraseRootFromParent_Done,
      // Label 23983: @1912747
      GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1912854), // Rule ID 14179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14179,
        GIR_EraseRootFromParent_Done,
      // Label 23984: @1912854
      GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1912961), // Rule ID 14182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14182,
        GIR_EraseRootFromParent_Done,
      // Label 23985: @1912961
      GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1913068), // Rule ID 14183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14183,
        GIR_EraseRootFromParent_Done,
      // Label 23986: @1913068
      GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1913175), // Rule ID 14186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14186,
        GIR_EraseRootFromParent_Done,
      // Label 23987: @1913175
      GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1913282), // Rule ID 14187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14187,
        GIR_EraseRootFromParent_Done,
      // Label 23988: @1913282
      GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1913389), // Rule ID 14190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14190,
        GIR_EraseRootFromParent_Done,
      // Label 23989: @1913389
      GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1913496), // Rule ID 14191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14191,
        GIR_EraseRootFromParent_Done,
      // Label 23990: @1913496
      GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1913603), // Rule ID 14194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14194,
        GIR_EraseRootFromParent_Done,
      // Label 23991: @1913603
      GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1913710), // Rule ID 14195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14195,
        GIR_EraseRootFromParent_Done,
      // Label 23992: @1913710
      GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1913817), // Rule ID 14198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14198,
        GIR_EraseRootFromParent_Done,
      // Label 23993: @1913817
      GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1913924), // Rule ID 14199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14199,
        GIR_EraseRootFromParent_Done,
      // Label 23994: @1913924
      GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1914031), // Rule ID 14202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14202,
        GIR_EraseRootFromParent_Done,
      // Label 23995: @1914031
      GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1914138), // Rule ID 14203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14203,
        GIR_EraseRootFromParent_Done,
      // Label 23996: @1914138
      GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1914245), // Rule ID 14206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14206,
        GIR_EraseRootFromParent_Done,
      // Label 23997: @1914245
      GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1914352), // Rule ID 14207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14207,
        GIR_EraseRootFromParent_Done,
      // Label 23998: @1914352
      GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1914459), // Rule ID 14210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14210,
        GIR_EraseRootFromParent_Done,
      // Label 23999: @1914459
      GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1914566), // Rule ID 14211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14211,
        GIR_EraseRootFromParent_Done,
      // Label 24000: @1914566
      GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1914673), // Rule ID 14214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14214,
        GIR_EraseRootFromParent_Done,
      // Label 24001: @1914673
      GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1914780), // Rule ID 14215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14215,
        GIR_EraseRootFromParent_Done,
      // Label 24002: @1914780
      GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1914887), // Rule ID 14218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14218,
        GIR_EraseRootFromParent_Done,
      // Label 24003: @1914887
      GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1914994), // Rule ID 14219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14219,
        GIR_EraseRootFromParent_Done,
      // Label 24004: @1914994
      GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1915101), // Rule ID 14222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14222,
        GIR_EraseRootFromParent_Done,
      // Label 24005: @1915101
      GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1915208), // Rule ID 14223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14223,
        GIR_EraseRootFromParent_Done,
      // Label 24006: @1915208
      GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1915315), // Rule ID 14226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14226,
        GIR_EraseRootFromParent_Done,
      // Label 24007: @1915315
      GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1915422), // Rule ID 14227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14227,
        GIR_EraseRootFromParent_Done,
      // Label 24008: @1915422
      GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1915529), // Rule ID 14230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14230,
        GIR_EraseRootFromParent_Done,
      // Label 24009: @1915529
      GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1915636), // Rule ID 14231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14231,
        GIR_EraseRootFromParent_Done,
      // Label 24010: @1915636
      GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1915743), // Rule ID 14234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14234,
        GIR_EraseRootFromParent_Done,
      // Label 24011: @1915743
      GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1915850), // Rule ID 14235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14235,
        GIR_EraseRootFromParent_Done,
      // Label 24012: @1915850
      GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1915957), // Rule ID 14238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14238,
        GIR_EraseRootFromParent_Done,
      // Label 24013: @1915957
      GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1916064), // Rule ID 14239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14239,
        GIR_EraseRootFromParent_Done,
      // Label 24014: @1916064
      GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1916171), // Rule ID 14242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14242,
        GIR_EraseRootFromParent_Done,
      // Label 24015: @1916171
      GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1916278), // Rule ID 14243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14243,
        GIR_EraseRootFromParent_Done,
      // Label 24016: @1916278
      GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1916385), // Rule ID 14246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14246,
        GIR_EraseRootFromParent_Done,
      // Label 24017: @1916385
      GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1916492), // Rule ID 14247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14247,
        GIR_EraseRootFromParent_Done,
      // Label 24018: @1916492
      GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1916599), // Rule ID 14250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14250,
        GIR_EraseRootFromParent_Done,
      // Label 24019: @1916599
      GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1916706), // Rule ID 14251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14251,
        GIR_EraseRootFromParent_Done,
      // Label 24020: @1916706
      GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1916813), // Rule ID 14254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14254,
        GIR_EraseRootFromParent_Done,
      // Label 24021: @1916813
      GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1916920), // Rule ID 14255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14255,
        GIR_EraseRootFromParent_Done,
      // Label 24022: @1916920
      GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1917027), // Rule ID 14258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14258,
        GIR_EraseRootFromParent_Done,
      // Label 24023: @1917027
      GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1917134), // Rule ID 14259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14259,
        GIR_EraseRootFromParent_Done,
      // Label 24024: @1917134
      GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1917241), // Rule ID 14262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14262,
        GIR_EraseRootFromParent_Done,
      // Label 24025: @1917241
      GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1917348), // Rule ID 14263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14263,
        GIR_EraseRootFromParent_Done,
      // Label 24026: @1917348
      GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1917455), // Rule ID 14266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14266,
        GIR_EraseRootFromParent_Done,
      // Label 24027: @1917455
      GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1917562), // Rule ID 14267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14267,
        GIR_EraseRootFromParent_Done,
      // Label 24028: @1917562
      GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1917669), // Rule ID 14270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14270,
        GIR_EraseRootFromParent_Done,
      // Label 24029: @1917669
      GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1917776), // Rule ID 14271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14271,
        GIR_EraseRootFromParent_Done,
      // Label 24030: @1917776
      GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1917883), // Rule ID 14274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14274,
        GIR_EraseRootFromParent_Done,
      // Label 24031: @1917883
      GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1917990), // Rule ID 14275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14275,
        GIR_EraseRootFromParent_Done,
      // Label 24032: @1917990
      GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1918097), // Rule ID 14278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14278,
        GIR_EraseRootFromParent_Done,
      // Label 24033: @1918097
      GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1918204), // Rule ID 14279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14279,
        GIR_EraseRootFromParent_Done,
      // Label 24034: @1918204
      GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1918311), // Rule ID 14282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14282,
        GIR_EraseRootFromParent_Done,
      // Label 24035: @1918311
      GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1918418), // Rule ID 14283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14283,
        GIR_EraseRootFromParent_Done,
      // Label 24036: @1918418
      GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1918525), // Rule ID 14286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14286,
        GIR_EraseRootFromParent_Done,
      // Label 24037: @1918525
      GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1918632), // Rule ID 14287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14287,
        GIR_EraseRootFromParent_Done,
      // Label 24038: @1918632
      GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1918739), // Rule ID 14290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14290,
        GIR_EraseRootFromParent_Done,
      // Label 24039: @1918739
      GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1918846), // Rule ID 14291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14291,
        GIR_EraseRootFromParent_Done,
      // Label 24040: @1918846
      GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1918953), // Rule ID 14294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14294,
        GIR_EraseRootFromParent_Done,
      // Label 24041: @1918953
      GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1919060), // Rule ID 14295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14295,
        GIR_EraseRootFromParent_Done,
      // Label 24042: @1919060
      GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1919167), // Rule ID 14298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14298,
        GIR_EraseRootFromParent_Done,
      // Label 24043: @1919167
      GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1919274), // Rule ID 14299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14299,
        GIR_EraseRootFromParent_Done,
      // Label 24044: @1919274
      GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1919381), // Rule ID 14302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14302,
        GIR_EraseRootFromParent_Done,
      // Label 24045: @1919381
      GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1919488), // Rule ID 14303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14303,
        GIR_EraseRootFromParent_Done,
      // Label 24046: @1919488
      GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1919595), // Rule ID 14306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14306,
        GIR_EraseRootFromParent_Done,
      // Label 24047: @1919595
      GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1919702), // Rule ID 14307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14307,
        GIR_EraseRootFromParent_Done,
      // Label 24048: @1919702
      GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1919809), // Rule ID 14310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14310,
        GIR_EraseRootFromParent_Done,
      // Label 24049: @1919809
      GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1919916), // Rule ID 14311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14311,
        GIR_EraseRootFromParent_Done,
      // Label 24050: @1919916
      GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1920023), // Rule ID 14314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14314,
        GIR_EraseRootFromParent_Done,
      // Label 24051: @1920023
      GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1920130), // Rule ID 14315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14315,
        GIR_EraseRootFromParent_Done,
      // Label 24052: @1920130
      GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1920237), // Rule ID 14318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14318,
        GIR_EraseRootFromParent_Done,
      // Label 24053: @1920237
      GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1920344), // Rule ID 14319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14319,
        GIR_EraseRootFromParent_Done,
      // Label 24054: @1920344
      GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1920451), // Rule ID 14322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14322,
        GIR_EraseRootFromParent_Done,
      // Label 24055: @1920451
      GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1920558), // Rule ID 14323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14323,
        GIR_EraseRootFromParent_Done,
      // Label 24056: @1920558
      GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1920665), // Rule ID 14326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14326,
        GIR_EraseRootFromParent_Done,
      // Label 24057: @1920665
      GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1920772), // Rule ID 14327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14327,
        GIR_EraseRootFromParent_Done,
      // Label 24058: @1920772
      GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1920879), // Rule ID 14330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14330,
        GIR_EraseRootFromParent_Done,
      // Label 24059: @1920879
      GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1920986), // Rule ID 14331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14331,
        GIR_EraseRootFromParent_Done,
      // Label 24060: @1920986
      GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1921093), // Rule ID 14334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14334,
        GIR_EraseRootFromParent_Done,
      // Label 24061: @1921093
      GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1921200), // Rule ID 14335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14335,
        GIR_EraseRootFromParent_Done,
      // Label 24062: @1921200
      GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1921307), // Rule ID 14338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14338,
        GIR_EraseRootFromParent_Done,
      // Label 24063: @1921307
      GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1921414), // Rule ID 14339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14339,
        GIR_EraseRootFromParent_Done,
      // Label 24064: @1921414
      GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1921521), // Rule ID 14342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14342,
        GIR_EraseRootFromParent_Done,
      // Label 24065: @1921521
      GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1921628), // Rule ID 14343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14343,
        GIR_EraseRootFromParent_Done,
      // Label 24066: @1921628
      GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1921735), // Rule ID 14434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14434,
        GIR_EraseRootFromParent_Done,
      // Label 24067: @1921735
      GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1921842), // Rule ID 14435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14435,
        GIR_EraseRootFromParent_Done,
      // Label 24068: @1921842
      GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1921949), // Rule ID 14438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14438,
        GIR_EraseRootFromParent_Done,
      // Label 24069: @1921949
      GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1922056), // Rule ID 14439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14439,
        GIR_EraseRootFromParent_Done,
      // Label 24070: @1922056
      GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1922163), // Rule ID 14442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14442,
        GIR_EraseRootFromParent_Done,
      // Label 24071: @1922163
      GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1922270), // Rule ID 14443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14443,
        GIR_EraseRootFromParent_Done,
      // Label 24072: @1922270
      GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1922377), // Rule ID 14446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14446,
        GIR_EraseRootFromParent_Done,
      // Label 24073: @1922377
      GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1922484), // Rule ID 14447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14447,
        GIR_EraseRootFromParent_Done,
      // Label 24074: @1922484
      GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1922591), // Rule ID 14450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14450,
        GIR_EraseRootFromParent_Done,
      // Label 24075: @1922591
      GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1922698), // Rule ID 14451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14451,
        GIR_EraseRootFromParent_Done,
      // Label 24076: @1922698
      GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1922805), // Rule ID 14454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14454,
        GIR_EraseRootFromParent_Done,
      // Label 24077: @1922805
      GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1922912), // Rule ID 14455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14455,
        GIR_EraseRootFromParent_Done,
      // Label 24078: @1922912
      GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1923019), // Rule ID 14458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14458,
        GIR_EraseRootFromParent_Done,
      // Label 24079: @1923019
      GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1923126), // Rule ID 14459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14459,
        GIR_EraseRootFromParent_Done,
      // Label 24080: @1923126
      GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1923233), // Rule ID 14462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14462,
        GIR_EraseRootFromParent_Done,
      // Label 24081: @1923233
      GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1923340), // Rule ID 14463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14463,
        GIR_EraseRootFromParent_Done,
      // Label 24082: @1923340
      GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1923447), // Rule ID 14466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14466,
        GIR_EraseRootFromParent_Done,
      // Label 24083: @1923447
      GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1923554), // Rule ID 14467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14467,
        GIR_EraseRootFromParent_Done,
      // Label 24084: @1923554
      GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1923661), // Rule ID 14470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14470,
        GIR_EraseRootFromParent_Done,
      // Label 24085: @1923661
      GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1923768), // Rule ID 14471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14471,
        GIR_EraseRootFromParent_Done,
      // Label 24086: @1923768
      GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1923875), // Rule ID 14474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14474,
        GIR_EraseRootFromParent_Done,
      // Label 24087: @1923875
      GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1923982), // Rule ID 14475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14475,
        GIR_EraseRootFromParent_Done,
      // Label 24088: @1923982
      GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1924089), // Rule ID 14478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14478,
        GIR_EraseRootFromParent_Done,
      // Label 24089: @1924089
      GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1924196), // Rule ID 14479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14479,
        GIR_EraseRootFromParent_Done,
      // Label 24090: @1924196
      GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1924303), // Rule ID 14482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14482,
        GIR_EraseRootFromParent_Done,
      // Label 24091: @1924303
      GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1924410), // Rule ID 14483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14483,
        GIR_EraseRootFromParent_Done,
      // Label 24092: @1924410
      GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1924517), // Rule ID 14486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14486,
        GIR_EraseRootFromParent_Done,
      // Label 24093: @1924517
      GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1924624), // Rule ID 14487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14487,
        GIR_EraseRootFromParent_Done,
      // Label 24094: @1924624
      GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1924731), // Rule ID 14490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14490,
        GIR_EraseRootFromParent_Done,
      // Label 24095: @1924731
      GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1924838), // Rule ID 14491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14491,
        GIR_EraseRootFromParent_Done,
      // Label 24096: @1924838
      GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1924945), // Rule ID 14494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14494,
        GIR_EraseRootFromParent_Done,
      // Label 24097: @1924945
      GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1925052), // Rule ID 14495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14495,
        GIR_EraseRootFromParent_Done,
      // Label 24098: @1925052
      GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1925159), // Rule ID 14498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14498,
        GIR_EraseRootFromParent_Done,
      // Label 24099: @1925159
      GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1925266), // Rule ID 14499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14499,
        GIR_EraseRootFromParent_Done,
      // Label 24100: @1925266
      GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1925373), // Rule ID 14502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14502,
        GIR_EraseRootFromParent_Done,
      // Label 24101: @1925373
      GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1925480), // Rule ID 14503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14503,
        GIR_EraseRootFromParent_Done,
      // Label 24102: @1925480
      GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1925587), // Rule ID 14506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14506,
        GIR_EraseRootFromParent_Done,
      // Label 24103: @1925587
      GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1925694), // Rule ID 14507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14507,
        GIR_EraseRootFromParent_Done,
      // Label 24104: @1925694
      GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1925801), // Rule ID 14510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14510,
        GIR_EraseRootFromParent_Done,
      // Label 24105: @1925801
      GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1925908), // Rule ID 14511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14511,
        GIR_EraseRootFromParent_Done,
      // Label 24106: @1925908
      GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1926015), // Rule ID 14514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14514,
        GIR_EraseRootFromParent_Done,
      // Label 24107: @1926015
      GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1926122), // Rule ID 14515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14515,
        GIR_EraseRootFromParent_Done,
      // Label 24108: @1926122
      GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1926229), // Rule ID 14518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14518,
        GIR_EraseRootFromParent_Done,
      // Label 24109: @1926229
      GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1926336), // Rule ID 14519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14519,
        GIR_EraseRootFromParent_Done,
      // Label 24110: @1926336
      GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1926443), // Rule ID 14522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14522,
        GIR_EraseRootFromParent_Done,
      // Label 24111: @1926443
      GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1926550), // Rule ID 14523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14523,
        GIR_EraseRootFromParent_Done,
      // Label 24112: @1926550
      GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1926657), // Rule ID 14526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14526,
        GIR_EraseRootFromParent_Done,
      // Label 24113: @1926657
      GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1926764), // Rule ID 14527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14527,
        GIR_EraseRootFromParent_Done,
      // Label 24114: @1926764
      GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1926871), // Rule ID 14530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14530,
        GIR_EraseRootFromParent_Done,
      // Label 24115: @1926871
      GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1926978), // Rule ID 14531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14531,
        GIR_EraseRootFromParent_Done,
      // Label 24116: @1926978
      GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1927085), // Rule ID 14534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14534,
        GIR_EraseRootFromParent_Done,
      // Label 24117: @1927085
      GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1927192), // Rule ID 14535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14535,
        GIR_EraseRootFromParent_Done,
      // Label 24118: @1927192
      GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1927299), // Rule ID 14538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14538,
        GIR_EraseRootFromParent_Done,
      // Label 24119: @1927299
      GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1927406), // Rule ID 14539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14539,
        GIR_EraseRootFromParent_Done,
      // Label 24120: @1927406
      GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1927513), // Rule ID 14542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14542,
        GIR_EraseRootFromParent_Done,
      // Label 24121: @1927513
      GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1927620), // Rule ID 14543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14543,
        GIR_EraseRootFromParent_Done,
      // Label 24122: @1927620
      GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1927727), // Rule ID 14546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14546,
        GIR_EraseRootFromParent_Done,
      // Label 24123: @1927727
      GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1927834), // Rule ID 14547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11227:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14547,
        GIR_EraseRootFromParent_Done,
      // Label 24124: @1927834
      GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1927941), // Rule ID 14550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14550,
        GIR_EraseRootFromParent_Done,
      // Label 24125: @1927941
      GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1928048), // Rule ID 14551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14551,
        GIR_EraseRootFromParent_Done,
      // Label 24126: @1928048
      GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1928155), // Rule ID 14554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14554,
        GIR_EraseRootFromParent_Done,
      // Label 24127: @1928155
      GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1928262), // Rule ID 14555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14555,
        GIR_EraseRootFromParent_Done,
      // Label 24128: @1928262
      GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1928369), // Rule ID 14558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14558,
        GIR_EraseRootFromParent_Done,
      // Label 24129: @1928369
      GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1928476), // Rule ID 14559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14559,
        GIR_EraseRootFromParent_Done,
      // Label 24130: @1928476
      GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1928583), // Rule ID 14562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14562,
        GIR_EraseRootFromParent_Done,
      // Label 24131: @1928583
      GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1928690), // Rule ID 14563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14563,
        GIR_EraseRootFromParent_Done,
      // Label 24132: @1928690
      GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1928797), // Rule ID 14566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14566,
        GIR_EraseRootFromParent_Done,
      // Label 24133: @1928797
      GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1928904), // Rule ID 14567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14567,
        GIR_EraseRootFromParent_Done,
      // Label 24134: @1928904
      GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1929011), // Rule ID 14570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14570,
        GIR_EraseRootFromParent_Done,
      // Label 24135: @1929011
      GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1929118), // Rule ID 14571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14571,
        GIR_EraseRootFromParent_Done,
      // Label 24136: @1929118
      GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1929225), // Rule ID 14574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14574,
        GIR_EraseRootFromParent_Done,
      // Label 24137: @1929225
      GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1929332), // Rule ID 14575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14575,
        GIR_EraseRootFromParent_Done,
      // Label 24138: @1929332
      GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1929439), // Rule ID 14578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14578,
        GIR_EraseRootFromParent_Done,
      // Label 24139: @1929439
      GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1929546), // Rule ID 14579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14579,
        GIR_EraseRootFromParent_Done,
      // Label 24140: @1929546
      GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1929653), // Rule ID 14582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14582,
        GIR_EraseRootFromParent_Done,
      // Label 24141: @1929653
      GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1929760), // Rule ID 14583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14583,
        GIR_EraseRootFromParent_Done,
      // Label 24142: @1929760
      GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1929867), // Rule ID 14586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14586,
        GIR_EraseRootFromParent_Done,
      // Label 24143: @1929867
      GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1929974), // Rule ID 14587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14587,
        GIR_EraseRootFromParent_Done,
      // Label 24144: @1929974
      GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1930081), // Rule ID 14590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14590,
        GIR_EraseRootFromParent_Done,
      // Label 24145: @1930081
      GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1930188), // Rule ID 14591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14591,
        GIR_EraseRootFromParent_Done,
      // Label 24146: @1930188
      GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1930295), // Rule ID 14594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14594,
        GIR_EraseRootFromParent_Done,
      // Label 24147: @1930295
      GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1930402), // Rule ID 14595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14595,
        GIR_EraseRootFromParent_Done,
      // Label 24148: @1930402
      GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1930509), // Rule ID 14598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14598,
        GIR_EraseRootFromParent_Done,
      // Label 24149: @1930509
      GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1930616), // Rule ID 14599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14599,
        GIR_EraseRootFromParent_Done,
      // Label 24150: @1930616
      GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1930723), // Rule ID 14602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14602,
        GIR_EraseRootFromParent_Done,
      // Label 24151: @1930723
      GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1930830), // Rule ID 14603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14603,
        GIR_EraseRootFromParent_Done,
      // Label 24152: @1930830
      GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1930937), // Rule ID 14606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14606,
        GIR_EraseRootFromParent_Done,
      // Label 24153: @1930937
      GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1931044), // Rule ID 14607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14607,
        GIR_EraseRootFromParent_Done,
      // Label 24154: @1931044
      GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1931151), // Rule ID 14610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14610,
        GIR_EraseRootFromParent_Done,
      // Label 24155: @1931151
      GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1931258), // Rule ID 14611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14611,
        GIR_EraseRootFromParent_Done,
      // Label 24156: @1931258
      GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1931365), // Rule ID 14614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14614,
        GIR_EraseRootFromParent_Done,
      // Label 24157: @1931365
      GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1931472), // Rule ID 14615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14615,
        GIR_EraseRootFromParent_Done,
      // Label 24158: @1931472
      GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1931579), // Rule ID 14618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14618,
        GIR_EraseRootFromParent_Done,
      // Label 24159: @1931579
      GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1931686), // Rule ID 14619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14619,
        GIR_EraseRootFromParent_Done,
      // Label 24160: @1931686
      GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1931793), // Rule ID 14622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14622,
        GIR_EraseRootFromParent_Done,
      // Label 24161: @1931793
      GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1931900), // Rule ID 14623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14623,
        GIR_EraseRootFromParent_Done,
      // Label 24162: @1931900
      GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1932007), // Rule ID 14626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14626,
        GIR_EraseRootFromParent_Done,
      // Label 24163: @1932007
      GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1932114), // Rule ID 14627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14627,
        GIR_EraseRootFromParent_Done,
      // Label 24164: @1932114
      GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1932221), // Rule ID 14630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14630,
        GIR_EraseRootFromParent_Done,
      // Label 24165: @1932221
      GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1932328), // Rule ID 14631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14631,
        GIR_EraseRootFromParent_Done,
      // Label 24166: @1932328
      GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1932435), // Rule ID 14634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14634,
        GIR_EraseRootFromParent_Done,
      // Label 24167: @1932435
      GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1932542), // Rule ID 14635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14635,
        GIR_EraseRootFromParent_Done,
      // Label 24168: @1932542
      GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1932649), // Rule ID 14638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14638,
        GIR_EraseRootFromParent_Done,
      // Label 24169: @1932649
      GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1932756), // Rule ID 14639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14639,
        GIR_EraseRootFromParent_Done,
      // Label 24170: @1932756
      GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1932863), // Rule ID 14642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14642,
        GIR_EraseRootFromParent_Done,
      // Label 24171: @1932863
      GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1932970), // Rule ID 14643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14643,
        GIR_EraseRootFromParent_Done,
      // Label 24172: @1932970
      GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1933077), // Rule ID 14646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14646,
        GIR_EraseRootFromParent_Done,
      // Label 24173: @1933077
      GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1933184), // Rule ID 14647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14647,
        GIR_EraseRootFromParent_Done,
      // Label 24174: @1933184
      GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1933291), // Rule ID 14650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14650,
        GIR_EraseRootFromParent_Done,
      // Label 24175: @1933291
      GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1933398), // Rule ID 14651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14651,
        GIR_EraseRootFromParent_Done,
      // Label 24176: @1933398
      GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1933505), // Rule ID 14654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14654,
        GIR_EraseRootFromParent_Done,
      // Label 24177: @1933505
      GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1933612), // Rule ID 14655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14655,
        GIR_EraseRootFromParent_Done,
      // Label 24178: @1933612
      GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1933719), // Rule ID 14658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14658,
        GIR_EraseRootFromParent_Done,
      // Label 24179: @1933719
      GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1933826), // Rule ID 14659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14659,
        GIR_EraseRootFromParent_Done,
      // Label 24180: @1933826
      GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1933933), // Rule ID 14662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14662,
        GIR_EraseRootFromParent_Done,
      // Label 24181: @1933933
      GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1934040), // Rule ID 14663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14663,
        GIR_EraseRootFromParent_Done,
      // Label 24182: @1934040
      GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1934147), // Rule ID 14666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14666,
        GIR_EraseRootFromParent_Done,
      // Label 24183: @1934147
      GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1934254), // Rule ID 14667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14667,
        GIR_EraseRootFromParent_Done,
      // Label 24184: @1934254
      GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1934361), // Rule ID 14670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14670,
        GIR_EraseRootFromParent_Done,
      // Label 24185: @1934361
      GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1934468), // Rule ID 14671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14671,
        GIR_EraseRootFromParent_Done,
      // Label 24186: @1934468
      GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1934575), // Rule ID 14674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14674,
        GIR_EraseRootFromParent_Done,
      // Label 24187: @1934575
      GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1934682), // Rule ID 14675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14675,
        GIR_EraseRootFromParent_Done,
      // Label 24188: @1934682
      GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1934789), // Rule ID 14678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14678,
        GIR_EraseRootFromParent_Done,
      // Label 24189: @1934789
      GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1934896), // Rule ID 14679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14679,
        GIR_EraseRootFromParent_Done,
      // Label 24190: @1934896
      GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1935003), // Rule ID 14682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14682,
        GIR_EraseRootFromParent_Done,
      // Label 24191: @1935003
      GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1935110), // Rule ID 14683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14683,
        GIR_EraseRootFromParent_Done,
      // Label 24192: @1935110
      GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1935217), // Rule ID 14686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14686,
        GIR_EraseRootFromParent_Done,
      // Label 24193: @1935217
      GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1935324), // Rule ID 14687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14687,
        GIR_EraseRootFromParent_Done,
      // Label 24194: @1935324
      GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1935431), // Rule ID 14690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14690,
        GIR_EraseRootFromParent_Done,
      // Label 24195: @1935431
      GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1935538), // Rule ID 14691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14691,
        GIR_EraseRootFromParent_Done,
      // Label 24196: @1935538
      GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1935645), // Rule ID 14694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14694,
        GIR_EraseRootFromParent_Done,
      // Label 24197: @1935645
      GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1935752), // Rule ID 14695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14695,
        GIR_EraseRootFromParent_Done,
      // Label 24198: @1935752
      GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1935859), // Rule ID 14698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14698,
        GIR_EraseRootFromParent_Done,
      // Label 24199: @1935859
      GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1935966), // Rule ID 14699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14699,
        GIR_EraseRootFromParent_Done,
      // Label 24200: @1935966
      GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1936073), // Rule ID 14702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14702,
        GIR_EraseRootFromParent_Done,
      // Label 24201: @1936073
      GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1936180), // Rule ID 14703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14703,
        GIR_EraseRootFromParent_Done,
      // Label 24202: @1936180
      GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1936287), // Rule ID 14706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14706,
        GIR_EraseRootFromParent_Done,
      // Label 24203: @1936287
      GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1936394), // Rule ID 14707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14707,
        GIR_EraseRootFromParent_Done,
      // Label 24204: @1936394
      GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1936501), // Rule ID 14710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14710,
        GIR_EraseRootFromParent_Done,
      // Label 24205: @1936501
      GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1936608), // Rule ID 14711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14711,
        GIR_EraseRootFromParent_Done,
      // Label 24206: @1936608
      GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1936715), // Rule ID 14714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14714,
        GIR_EraseRootFromParent_Done,
      // Label 24207: @1936715
      GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1936822), // Rule ID 14715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14715,
        GIR_EraseRootFromParent_Done,
      // Label 24208: @1936822
      GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1936929), // Rule ID 14718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14718,
        GIR_EraseRootFromParent_Done,
      // Label 24209: @1936929
      GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1937036), // Rule ID 14719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14719,
        GIR_EraseRootFromParent_Done,
      // Label 24210: @1937036
      GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1937143), // Rule ID 14722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14722,
        GIR_EraseRootFromParent_Done,
      // Label 24211: @1937143
      GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1937250), // Rule ID 14723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11225:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14723,
        GIR_EraseRootFromParent_Done,
      // Label 24212: @1937250
      GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1937357), // Rule ID 14726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14726,
        GIR_EraseRootFromParent_Done,
      // Label 24213: @1937357
      GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1937464), // Rule ID 14727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14727,
        GIR_EraseRootFromParent_Done,
      // Label 24214: @1937464
      GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1937571), // Rule ID 14730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14730,
        GIR_EraseRootFromParent_Done,
      // Label 24215: @1937571
      GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1937678), // Rule ID 14731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14731,
        GIR_EraseRootFromParent_Done,
      // Label 24216: @1937678
      GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1937785), // Rule ID 14734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14734,
        GIR_EraseRootFromParent_Done,
      // Label 24217: @1937785
      GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1937892), // Rule ID 14735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14735,
        GIR_EraseRootFromParent_Done,
      // Label 24218: @1937892
      GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1937999), // Rule ID 14738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14738,
        GIR_EraseRootFromParent_Done,
      // Label 24219: @1937999
      GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1938106), // Rule ID 14739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14739,
        GIR_EraseRootFromParent_Done,
      // Label 24220: @1938106
      GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1938213), // Rule ID 14742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14742,
        GIR_EraseRootFromParent_Done,
      // Label 24221: @1938213
      GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1938320), // Rule ID 14743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14743,
        GIR_EraseRootFromParent_Done,
      // Label 24222: @1938320
      GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1938427), // Rule ID 14746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14746,
        GIR_EraseRootFromParent_Done,
      // Label 24223: @1938427
      GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1938534), // Rule ID 14747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14747,
        GIR_EraseRootFromParent_Done,
      // Label 24224: @1938534
      GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1938641), // Rule ID 14750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14750,
        GIR_EraseRootFromParent_Done,
      // Label 24225: @1938641
      GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1938748), // Rule ID 14751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14751,
        GIR_EraseRootFromParent_Done,
      // Label 24226: @1938748
      GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1938855), // Rule ID 14754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14754,
        GIR_EraseRootFromParent_Done,
      // Label 24227: @1938855
      GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1938962), // Rule ID 14755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14755,
        GIR_EraseRootFromParent_Done,
      // Label 24228: @1938962
      GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1939069), // Rule ID 14758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14758,
        GIR_EraseRootFromParent_Done,
      // Label 24229: @1939069
      GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1939176), // Rule ID 14759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14759,
        GIR_EraseRootFromParent_Done,
      // Label 24230: @1939176
      GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1939283), // Rule ID 14762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14762,
        GIR_EraseRootFromParent_Done,
      // Label 24231: @1939283
      GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1939390), // Rule ID 14763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14763,
        GIR_EraseRootFromParent_Done,
      // Label 24232: @1939390
      GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1939497), // Rule ID 14766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14766,
        GIR_EraseRootFromParent_Done,
      // Label 24233: @1939497
      GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1939604), // Rule ID 14767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14767,
        GIR_EraseRootFromParent_Done,
      // Label 24234: @1939604
      GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1939711), // Rule ID 14770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14770,
        GIR_EraseRootFromParent_Done,
      // Label 24235: @1939711
      GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1939818), // Rule ID 14771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14771,
        GIR_EraseRootFromParent_Done,
      // Label 24236: @1939818
      GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1939925), // Rule ID 14774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14774,
        GIR_EraseRootFromParent_Done,
      // Label 24237: @1939925
      GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1940032), // Rule ID 14775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14775,
        GIR_EraseRootFromParent_Done,
      // Label 24238: @1940032
      GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1940139), // Rule ID 14778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14778,
        GIR_EraseRootFromParent_Done,
      // Label 24239: @1940139
      GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1940246), // Rule ID 14779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14779,
        GIR_EraseRootFromParent_Done,
      // Label 24240: @1940246
      GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1940353), // Rule ID 14782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14782,
        GIR_EraseRootFromParent_Done,
      // Label 24241: @1940353
      GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1940460), // Rule ID 14783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14783,
        GIR_EraseRootFromParent_Done,
      // Label 24242: @1940460
      GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1940564), // Rule ID 19024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19024,
        GIR_EraseRootFromParent_Done,
      // Label 24243: @1940564
      GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1940668), // Rule ID 19025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19025,
        GIR_EraseRootFromParent_Done,
      // Label 24244: @1940668
      GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1940772), // Rule ID 19028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19028,
        GIR_EraseRootFromParent_Done,
      // Label 24245: @1940772
      GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1940876), // Rule ID 19029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19029,
        GIR_EraseRootFromParent_Done,
      // Label 24246: @1940876
      GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1940980), // Rule ID 19032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19032,
        GIR_EraseRootFromParent_Done,
      // Label 24247: @1940980
      GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1941084), // Rule ID 19033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19033,
        GIR_EraseRootFromParent_Done,
      // Label 24248: @1941084
      GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1941188), // Rule ID 19036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19036,
        GIR_EraseRootFromParent_Done,
      // Label 24249: @1941188
      GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1941292), // Rule ID 19037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19037,
        GIR_EraseRootFromParent_Done,
      // Label 24250: @1941292
      GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1941396), // Rule ID 19040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19040,
        GIR_EraseRootFromParent_Done,
      // Label 24251: @1941396
      GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1941500), // Rule ID 19041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19041,
        GIR_EraseRootFromParent_Done,
      // Label 24252: @1941500
      GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1941604), // Rule ID 19044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19044,
        GIR_EraseRootFromParent_Done,
      // Label 24253: @1941604
      GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1941708), // Rule ID 19045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19045,
        GIR_EraseRootFromParent_Done,
      // Label 24254: @1941708
      GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1941812), // Rule ID 19048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19048,
        GIR_EraseRootFromParent_Done,
      // Label 24255: @1941812
      GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1941916), // Rule ID 19049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19049,
        GIR_EraseRootFromParent_Done,
      // Label 24256: @1941916
      GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1942020), // Rule ID 19052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19052,
        GIR_EraseRootFromParent_Done,
      // Label 24257: @1942020
      GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1942124), // Rule ID 19053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19053,
        GIR_EraseRootFromParent_Done,
      // Label 24258: @1942124
      GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1942228), // Rule ID 19056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19056,
        GIR_EraseRootFromParent_Done,
      // Label 24259: @1942228
      GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1942332), // Rule ID 19057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19057,
        GIR_EraseRootFromParent_Done,
      // Label 24260: @1942332
      GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1942436), // Rule ID 19060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19060,
        GIR_EraseRootFromParent_Done,
      // Label 24261: @1942436
      GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1942540), // Rule ID 19061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19061,
        GIR_EraseRootFromParent_Done,
      // Label 24262: @1942540
      GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1942644), // Rule ID 19064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19064,
        GIR_EraseRootFromParent_Done,
      // Label 24263: @1942644
      GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1942748), // Rule ID 19065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19065,
        GIR_EraseRootFromParent_Done,
      // Label 24264: @1942748
      GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1942852), // Rule ID 19068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19068,
        GIR_EraseRootFromParent_Done,
      // Label 24265: @1942852
      GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1942956), // Rule ID 19069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19069,
        GIR_EraseRootFromParent_Done,
      // Label 24266: @1942956
      GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1943060), // Rule ID 19072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19072,
        GIR_EraseRootFromParent_Done,
      // Label 24267: @1943060
      GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1943164), // Rule ID 19073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19073,
        GIR_EraseRootFromParent_Done,
      // Label 24268: @1943164
      GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1943268), // Rule ID 19076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19076,
        GIR_EraseRootFromParent_Done,
      // Label 24269: @1943268
      GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1943372), // Rule ID 19077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19077,
        GIR_EraseRootFromParent_Done,
      // Label 24270: @1943372
      GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1943476), // Rule ID 19080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19080,
        GIR_EraseRootFromParent_Done,
      // Label 24271: @1943476
      GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1943580), // Rule ID 19081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19081,
        GIR_EraseRootFromParent_Done,
      // Label 24272: @1943580
      GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1943684), // Rule ID 19084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19084,
        GIR_EraseRootFromParent_Done,
      // Label 24273: @1943684
      GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1943788), // Rule ID 19085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19085,
        GIR_EraseRootFromParent_Done,
      // Label 24274: @1943788
      GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1943892), // Rule ID 19088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19088,
        GIR_EraseRootFromParent_Done,
      // Label 24275: @1943892
      GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1943996), // Rule ID 19089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19089,
        GIR_EraseRootFromParent_Done,
      // Label 24276: @1943996
      GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1944100), // Rule ID 19092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19092,
        GIR_EraseRootFromParent_Done,
      // Label 24277: @1944100
      GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1944204), // Rule ID 19093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19093,
        GIR_EraseRootFromParent_Done,
      // Label 24278: @1944204
      GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1944308), // Rule ID 19096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19096,
        GIR_EraseRootFromParent_Done,
      // Label 24279: @1944308
      GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1944412), // Rule ID 19097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10820:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19097,
        GIR_EraseRootFromParent_Done,
      // Label 24280: @1944412
      GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1944516), // Rule ID 19100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19100,
        GIR_EraseRootFromParent_Done,
      // Label 24281: @1944516
      GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1944620), // Rule ID 19101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10820:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19101,
        GIR_EraseRootFromParent_Done,
      // Label 24282: @1944620
      GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1944724), // Rule ID 19104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19104,
        GIR_EraseRootFromParent_Done,
      // Label 24283: @1944724
      GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1944828), // Rule ID 19105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10820:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19105,
        GIR_EraseRootFromParent_Done,
      // Label 24284: @1944828
      GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1944932), // Rule ID 19108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19108,
        GIR_EraseRootFromParent_Done,
      // Label 24285: @1944932
      GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1945036), // Rule ID 19109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19109,
        GIR_EraseRootFromParent_Done,
      // Label 24286: @1945036
      GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1945140), // Rule ID 19112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19112,
        GIR_EraseRootFromParent_Done,
      // Label 24287: @1945140
      GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1945244), // Rule ID 19113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19113,
        GIR_EraseRootFromParent_Done,
      // Label 24288: @1945244
      GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1945348), // Rule ID 19116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19116,
        GIR_EraseRootFromParent_Done,
      // Label 24289: @1945348
      GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1945452), // Rule ID 19117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19117,
        GIR_EraseRootFromParent_Done,
      // Label 24290: @1945452
      GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1945556), // Rule ID 19120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19120,
        GIR_EraseRootFromParent_Done,
      // Label 24291: @1945556
      GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1945660), // Rule ID 19121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19121,
        GIR_EraseRootFromParent_Done,
      // Label 24292: @1945660
      GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1945764), // Rule ID 19124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19124,
        GIR_EraseRootFromParent_Done,
      // Label 24293: @1945764
      GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1945868), // Rule ID 19125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19125,
        GIR_EraseRootFromParent_Done,
      // Label 24294: @1945868
      GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1945972), // Rule ID 19128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19128,
        GIR_EraseRootFromParent_Done,
      // Label 24295: @1945972
      GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1946076), // Rule ID 19129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19129,
        GIR_EraseRootFromParent_Done,
      // Label 24296: @1946076
      GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1946180), // Rule ID 19132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19132,
        GIR_EraseRootFromParent_Done,
      // Label 24297: @1946180
      GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1946284), // Rule ID 19133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10820:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19133,
        GIR_EraseRootFromParent_Done,
      // Label 24298: @1946284
      GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1946388), // Rule ID 19136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19136,
        GIR_EraseRootFromParent_Done,
      // Label 24299: @1946388
      GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1946492), // Rule ID 19137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10820:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19137,
        GIR_EraseRootFromParent_Done,
      // Label 24300: @1946492
      GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1946596), // Rule ID 19140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19140,
        GIR_EraseRootFromParent_Done,
      // Label 24301: @1946596
      GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1946700), // Rule ID 19141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10820:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19141,
        GIR_EraseRootFromParent_Done,
      // Label 24302: @1946700
      GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1946804), // Rule ID 19144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19144,
        GIR_EraseRootFromParent_Done,
      // Label 24303: @1946804
      GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1946908), // Rule ID 19145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19145,
        GIR_EraseRootFromParent_Done,
      // Label 24304: @1946908
      GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1947012), // Rule ID 19148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19148,
        GIR_EraseRootFromParent_Done,
      // Label 24305: @1947012
      GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1947116), // Rule ID 19149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19149,
        GIR_EraseRootFromParent_Done,
      // Label 24306: @1947116
      GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1947220), // Rule ID 19152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19152,
        GIR_EraseRootFromParent_Done,
      // Label 24307: @1947220
      GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1947324), // Rule ID 19153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19153,
        GIR_EraseRootFromParent_Done,
      // Label 24308: @1947324
      GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1947428), // Rule ID 19156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19156,
        GIR_EraseRootFromParent_Done,
      // Label 24309: @1947428
      GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1947532), // Rule ID 19157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19157,
        GIR_EraseRootFromParent_Done,
      // Label 24310: @1947532
      GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1947636), // Rule ID 19160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10817:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19160,
        GIR_EraseRootFromParent_Done,
      // Label 24311: @1947636
      GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1947740), // Rule ID 19161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10817:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19161,
        GIR_EraseRootFromParent_Done,
      // Label 24312: @1947740
      GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1947844), // Rule ID 19164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19164,
        GIR_EraseRootFromParent_Done,
      // Label 24313: @1947844
      GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1947948), // Rule ID 19165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19165,
        GIR_EraseRootFromParent_Done,
      // Label 24314: @1947948
      GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1948052), // Rule ID 19168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19168,
        GIR_EraseRootFromParent_Done,
      // Label 24315: @1948052
      GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1948156), // Rule ID 19169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19169,
        GIR_EraseRootFromParent_Done,
      // Label 24316: @1948156
      GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1948260), // Rule ID 19172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19172,
        GIR_EraseRootFromParent_Done,
      // Label 24317: @1948260
      GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1948364), // Rule ID 19173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19173,
        GIR_EraseRootFromParent_Done,
      // Label 24318: @1948364
      GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1948468), // Rule ID 19176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19176,
        GIR_EraseRootFromParent_Done,
      // Label 24319: @1948468
      GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1948572), // Rule ID 19177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19177,
        GIR_EraseRootFromParent_Done,
      // Label 24320: @1948572
      GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1948676), // Rule ID 19180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19180,
        GIR_EraseRootFromParent_Done,
      // Label 24321: @1948676
      GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1948780), // Rule ID 19181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19181,
        GIR_EraseRootFromParent_Done,
      // Label 24322: @1948780
      GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1948884), // Rule ID 19184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19184,
        GIR_EraseRootFromParent_Done,
      // Label 24323: @1948884
      GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1948988), // Rule ID 19185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19185,
        GIR_EraseRootFromParent_Done,
      // Label 24324: @1948988
      GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1949092), // Rule ID 19188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19188,
        GIR_EraseRootFromParent_Done,
      // Label 24325: @1949092
      GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1949196), // Rule ID 19189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19189,
        GIR_EraseRootFromParent_Done,
      // Label 24326: @1949196
      GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1949300), // Rule ID 19192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19192,
        GIR_EraseRootFromParent_Done,
      // Label 24327: @1949300
      GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1949404), // Rule ID 19193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19193,
        GIR_EraseRootFromParent_Done,
      // Label 24328: @1949404
      GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1949508), // Rule ID 19196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19196,
        GIR_EraseRootFromParent_Done,
      // Label 24329: @1949508
      GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1949612), // Rule ID 19197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19197,
        GIR_EraseRootFromParent_Done,
      // Label 24330: @1949612
      GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1949716), // Rule ID 19200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19200,
        GIR_EraseRootFromParent_Done,
      // Label 24331: @1949716
      GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1949820), // Rule ID 19201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19201,
        GIR_EraseRootFromParent_Done,
      // Label 24332: @1949820
      GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1949924), // Rule ID 19204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19204,
        GIR_EraseRootFromParent_Done,
      // Label 24333: @1949924
      GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1950028), // Rule ID 19205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19205,
        GIR_EraseRootFromParent_Done,
      // Label 24334: @1950028
      GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1950132), // Rule ID 19208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19208,
        GIR_EraseRootFromParent_Done,
      // Label 24335: @1950132
      GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1950236), // Rule ID 19209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19209,
        GIR_EraseRootFromParent_Done,
      // Label 24336: @1950236
      GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1950340), // Rule ID 19212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19212,
        GIR_EraseRootFromParent_Done,
      // Label 24337: @1950340
      GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1950444), // Rule ID 19213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19213,
        GIR_EraseRootFromParent_Done,
      // Label 24338: @1950444
      GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1950548), // Rule ID 19216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19216,
        GIR_EraseRootFromParent_Done,
      // Label 24339: @1950548
      GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1950652), // Rule ID 19217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10817:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19217,
        GIR_EraseRootFromParent_Done,
      // Label 24340: @1950652
      GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1950756), // Rule ID 19220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10817:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19220,
        GIR_EraseRootFromParent_Done,
      // Label 24341: @1950756
      GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1950860), // Rule ID 19221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10817:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19221,
        GIR_EraseRootFromParent_Done,
      // Label 24342: @1950860
      GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1950964), // Rule ID 19224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19224,
        GIR_EraseRootFromParent_Done,
      // Label 24343: @1950964
      GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1951068), // Rule ID 19225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10817:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19225,
        GIR_EraseRootFromParent_Done,
      // Label 24344: @1951068
      GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1951172), // Rule ID 19228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19228,
        GIR_EraseRootFromParent_Done,
      // Label 24345: @1951172
      GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1951276), // Rule ID 19229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19229,
        GIR_EraseRootFromParent_Done,
      // Label 24346: @1951276
      GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1951380), // Rule ID 19232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19232,
        GIR_EraseRootFromParent_Done,
      // Label 24347: @1951380
      GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1951484), // Rule ID 19233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19233,
        GIR_EraseRootFromParent_Done,
      // Label 24348: @1951484
      GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1951588), // Rule ID 19236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19236,
        GIR_EraseRootFromParent_Done,
      // Label 24349: @1951588
      GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1951692), // Rule ID 19237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19237,
        GIR_EraseRootFromParent_Done,
      // Label 24350: @1951692
      GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1951796), // Rule ID 19240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19240,
        GIR_EraseRootFromParent_Done,
      // Label 24351: @1951796
      GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1951900), // Rule ID 19241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19241,
        GIR_EraseRootFromParent_Done,
      // Label 24352: @1951900
      GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1952004), // Rule ID 19244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19244,
        GIR_EraseRootFromParent_Done,
      // Label 24353: @1952004
      GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1952108), // Rule ID 19245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19245,
        GIR_EraseRootFromParent_Done,
      // Label 24354: @1952108
      GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1952212), // Rule ID 19248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19248,
        GIR_EraseRootFromParent_Done,
      // Label 24355: @1952212
      GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1952316), // Rule ID 19249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19249,
        GIR_EraseRootFromParent_Done,
      // Label 24356: @1952316
      GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1952420), // Rule ID 19252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19252,
        GIR_EraseRootFromParent_Done,
      // Label 24357: @1952420
      GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1952524), // Rule ID 19253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10817:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19253,
        GIR_EraseRootFromParent_Done,
      // Label 24358: @1952524
      GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1952628), // Rule ID 19256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19256,
        GIR_EraseRootFromParent_Done,
      // Label 24359: @1952628
      GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1952732), // Rule ID 19257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10817:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19257,
        GIR_EraseRootFromParent_Done,
      // Label 24360: @1952732
      GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1952836), // Rule ID 19260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19260,
        GIR_EraseRootFromParent_Done,
      // Label 24361: @1952836
      GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1952940), // Rule ID 19261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10817:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19261,
        GIR_EraseRootFromParent_Done,
      // Label 24362: @1952940
      GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1953044), // Rule ID 19264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19264,
        GIR_EraseRootFromParent_Done,
      // Label 24363: @1953044
      GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1953148), // Rule ID 19265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19265,
        GIR_EraseRootFromParent_Done,
      // Label 24364: @1953148
      GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1953252), // Rule ID 19268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19268,
        GIR_EraseRootFromParent_Done,
      // Label 24365: @1953252
      GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1953356), // Rule ID 19269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19269,
        GIR_EraseRootFromParent_Done,
      // Label 24366: @1953356
      GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1953460), // Rule ID 19272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19272,
        GIR_EraseRootFromParent_Done,
      // Label 24367: @1953460
      GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1953564), // Rule ID 19273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19273,
        GIR_EraseRootFromParent_Done,
      // Label 24368: @1953564
      GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1953668), // Rule ID 19276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19276,
        GIR_EraseRootFromParent_Done,
      // Label 24369: @1953668
      GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1953772), // Rule ID 19277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19277,
        GIR_EraseRootFromParent_Done,
      // Label 24370: @1953772
      GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1953876), // Rule ID 19280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19280,
        GIR_EraseRootFromParent_Done,
      // Label 24371: @1953876
      GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1953980), // Rule ID 19281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19281,
        GIR_EraseRootFromParent_Done,
      // Label 24372: @1953980
      GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1954084), // Rule ID 19284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19284,
        GIR_EraseRootFromParent_Done,
      // Label 24373: @1954084
      GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1954188), // Rule ID 19285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19285,
        GIR_EraseRootFromParent_Done,
      // Label 24374: @1954188
      GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1954292), // Rule ID 19288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19288,
        GIR_EraseRootFromParent_Done,
      // Label 24375: @1954292
      GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1954396), // Rule ID 19289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19289,
        GIR_EraseRootFromParent_Done,
      // Label 24376: @1954396
      GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1954500), // Rule ID 19292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19292,
        GIR_EraseRootFromParent_Done,
      // Label 24377: @1954500
      GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1954604), // Rule ID 19293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19293,
        GIR_EraseRootFromParent_Done,
      // Label 24378: @1954604
      GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1954708), // Rule ID 19296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19296,
        GIR_EraseRootFromParent_Done,
      // Label 24379: @1954708
      GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1954812), // Rule ID 19297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19297,
        GIR_EraseRootFromParent_Done,
      // Label 24380: @1954812
      GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1954916), // Rule ID 19300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19300,
        GIR_EraseRootFromParent_Done,
      // Label 24381: @1954916
      GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1955020), // Rule ID 19301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19301,
        GIR_EraseRootFromParent_Done,
      // Label 24382: @1955020
      GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1955124), // Rule ID 19304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19304,
        GIR_EraseRootFromParent_Done,
      // Label 24383: @1955124
      GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1955228), // Rule ID 19305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19305,
        GIR_EraseRootFromParent_Done,
      // Label 24384: @1955228
      GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1955332), // Rule ID 19308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19308,
        GIR_EraseRootFromParent_Done,
      // Label 24385: @1955332
      GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1955436), // Rule ID 19309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19309,
        GIR_EraseRootFromParent_Done,
      // Label 24386: @1955436
      GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1955540), // Rule ID 19312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19312,
        GIR_EraseRootFromParent_Done,
      // Label 24387: @1955540
      GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1955644), // Rule ID 19313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19313,
        GIR_EraseRootFromParent_Done,
      // Label 24388: @1955644
      GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1955748), // Rule ID 19316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19316,
        GIR_EraseRootFromParent_Done,
      // Label 24389: @1955748
      GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1955852), // Rule ID 19317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19317,
        GIR_EraseRootFromParent_Done,
      // Label 24390: @1955852
      GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1955956), // Rule ID 19320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19320,
        GIR_EraseRootFromParent_Done,
      // Label 24391: @1955956
      GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1956060), // Rule ID 19321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19321,
        GIR_EraseRootFromParent_Done,
      // Label 24392: @1956060
      GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1956164), // Rule ID 19324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19324,
        GIR_EraseRootFromParent_Done,
      // Label 24393: @1956164
      GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1956268), // Rule ID 19325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19325,
        GIR_EraseRootFromParent_Done,
      // Label 24394: @1956268
      GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1956372), // Rule ID 19328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19328,
        GIR_EraseRootFromParent_Done,
      // Label 24395: @1956372
      GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1956476), // Rule ID 19329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19329,
        GIR_EraseRootFromParent_Done,
      // Label 24396: @1956476
      GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1956580), // Rule ID 19332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19332,
        GIR_EraseRootFromParent_Done,
      // Label 24397: @1956580
      GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1956684), // Rule ID 19333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19333,
        GIR_EraseRootFromParent_Done,
      // Label 24398: @1956684
      GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1956788), // Rule ID 19336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19336,
        GIR_EraseRootFromParent_Done,
      // Label 24399: @1956788
      GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1956892), // Rule ID 19337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10873:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19337,
        GIR_EraseRootFromParent_Done,
      // Label 24400: @1956892
      GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1956996), // Rule ID 19340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19340,
        GIR_EraseRootFromParent_Done,
      // Label 24401: @1956996
      GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1957100), // Rule ID 19341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10873:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19341,
        GIR_EraseRootFromParent_Done,
      // Label 24402: @1957100
      GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1957204), // Rule ID 19344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19344,
        GIR_EraseRootFromParent_Done,
      // Label 24403: @1957204
      GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1957308), // Rule ID 19345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10873:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19345,
        GIR_EraseRootFromParent_Done,
      // Label 24404: @1957308
      GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1957412), // Rule ID 19348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19348,
        GIR_EraseRootFromParent_Done,
      // Label 24405: @1957412
      GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1957516), // Rule ID 19349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19349,
        GIR_EraseRootFromParent_Done,
      // Label 24406: @1957516
      GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1957620), // Rule ID 19352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19352,
        GIR_EraseRootFromParent_Done,
      // Label 24407: @1957620
      GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1957724), // Rule ID 19353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19353,
        GIR_EraseRootFromParent_Done,
      // Label 24408: @1957724
      GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1957828), // Rule ID 19356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19356,
        GIR_EraseRootFromParent_Done,
      // Label 24409: @1957828
      GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1957932), // Rule ID 19357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19357,
        GIR_EraseRootFromParent_Done,
      // Label 24410: @1957932
      GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1958036), // Rule ID 19360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19360,
        GIR_EraseRootFromParent_Done,
      // Label 24411: @1958036
      GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1958140), // Rule ID 19361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19361,
        GIR_EraseRootFromParent_Done,
      // Label 24412: @1958140
      GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1958244), // Rule ID 19364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19364,
        GIR_EraseRootFromParent_Done,
      // Label 24413: @1958244
      GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1958348), // Rule ID 19365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19365,
        GIR_EraseRootFromParent_Done,
      // Label 24414: @1958348
      GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1958452), // Rule ID 19368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19368,
        GIR_EraseRootFromParent_Done,
      // Label 24415: @1958452
      GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1958556), // Rule ID 19369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19369,
        GIR_EraseRootFromParent_Done,
      // Label 24416: @1958556
      GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1958660), // Rule ID 19372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19372,
        GIR_EraseRootFromParent_Done,
      // Label 24417: @1958660
      GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1958764), // Rule ID 19373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10873:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19373,
        GIR_EraseRootFromParent_Done,
      // Label 24418: @1958764
      GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1958868), // Rule ID 19376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19376,
        GIR_EraseRootFromParent_Done,
      // Label 24419: @1958868
      GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1958972), // Rule ID 19377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10873:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19377,
        GIR_EraseRootFromParent_Done,
      // Label 24420: @1958972
      GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1959076), // Rule ID 19380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19380,
        GIR_EraseRootFromParent_Done,
      // Label 24421: @1959076
      GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1959180), // Rule ID 19381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10873:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19381,
        GIR_EraseRootFromParent_Done,
      // Label 24422: @1959180
      GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1959284), // Rule ID 19384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19384,
        GIR_EraseRootFromParent_Done,
      // Label 24423: @1959284
      GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1959388), // Rule ID 19385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19385,
        GIR_EraseRootFromParent_Done,
      // Label 24424: @1959388
      GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1959492), // Rule ID 19388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19388,
        GIR_EraseRootFromParent_Done,
      // Label 24425: @1959492
      GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1959596), // Rule ID 19389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19389,
        GIR_EraseRootFromParent_Done,
      // Label 24426: @1959596
      GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1959700), // Rule ID 19392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19392,
        GIR_EraseRootFromParent_Done,
      // Label 24427: @1959700
      GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1959804), // Rule ID 19393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19393,
        GIR_EraseRootFromParent_Done,
      // Label 24428: @1959804
      GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1959908), // Rule ID 19396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19396,
        GIR_EraseRootFromParent_Done,
      // Label 24429: @1959908
      GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1960012), // Rule ID 19397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19397,
        GIR_EraseRootFromParent_Done,
      // Label 24430: @1960012
      GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1960116), // Rule ID 19400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19400,
        GIR_EraseRootFromParent_Done,
      // Label 24431: @1960116
      GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1960220), // Rule ID 19401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19401,
        GIR_EraseRootFromParent_Done,
      // Label 24432: @1960220
      GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1960324), // Rule ID 19404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19404,
        GIR_EraseRootFromParent_Done,
      // Label 24433: @1960324
      GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1960428), // Rule ID 19405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19405,
        GIR_EraseRootFromParent_Done,
      // Label 24434: @1960428
      GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1960532), // Rule ID 19408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19408,
        GIR_EraseRootFromParent_Done,
      // Label 24435: @1960532
      GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1960636), // Rule ID 19409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19409,
        GIR_EraseRootFromParent_Done,
      // Label 24436: @1960636
      GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1960740), // Rule ID 19412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19412,
        GIR_EraseRootFromParent_Done,
      // Label 24437: @1960740
      GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1960844), // Rule ID 19413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19413,
        GIR_EraseRootFromParent_Done,
      // Label 24438: @1960844
      GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1960948), // Rule ID 19416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19416,
        GIR_EraseRootFromParent_Done,
      // Label 24439: @1960948
      GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1961052), // Rule ID 19417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19417,
        GIR_EraseRootFromParent_Done,
      // Label 24440: @1961052
      GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1961156), // Rule ID 19420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19420,
        GIR_EraseRootFromParent_Done,
      // Label 24441: @1961156
      GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1961260), // Rule ID 19421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19421,
        GIR_EraseRootFromParent_Done,
      // Label 24442: @1961260
      GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1961364), // Rule ID 19424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19424,
        GIR_EraseRootFromParent_Done,
      // Label 24443: @1961364
      GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1961468), // Rule ID 19425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19425,
        GIR_EraseRootFromParent_Done,
      // Label 24444: @1961468
      GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1961572), // Rule ID 19428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19428,
        GIR_EraseRootFromParent_Done,
      // Label 24445: @1961572
      GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1961676), // Rule ID 19429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19429,
        GIR_EraseRootFromParent_Done,
      // Label 24446: @1961676
      GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1961780), // Rule ID 19432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19432,
        GIR_EraseRootFromParent_Done,
      // Label 24447: @1961780
      GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1961884), // Rule ID 19433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19433,
        GIR_EraseRootFromParent_Done,
      // Label 24448: @1961884
      GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1961988), // Rule ID 19436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19436,
        GIR_EraseRootFromParent_Done,
      // Label 24449: @1961988
      GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1962092), // Rule ID 19437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19437,
        GIR_EraseRootFromParent_Done,
      // Label 24450: @1962092
      GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1962196), // Rule ID 19440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19440,
        GIR_EraseRootFromParent_Done,
      // Label 24451: @1962196
      GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1962300), // Rule ID 19441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19441,
        GIR_EraseRootFromParent_Done,
      // Label 24452: @1962300
      GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1962404), // Rule ID 19444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19444,
        GIR_EraseRootFromParent_Done,
      // Label 24453: @1962404
      GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1962508), // Rule ID 19445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19445,
        GIR_EraseRootFromParent_Done,
      // Label 24454: @1962508
      GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1962612), // Rule ID 19448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19448,
        GIR_EraseRootFromParent_Done,
      // Label 24455: @1962612
      GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1962716), // Rule ID 19449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19449,
        GIR_EraseRootFromParent_Done,
      // Label 24456: @1962716
      GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1962820), // Rule ID 19452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19452,
        GIR_EraseRootFromParent_Done,
      // Label 24457: @1962820
      GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1962924), // Rule ID 19453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19453,
        GIR_EraseRootFromParent_Done,
      // Label 24458: @1962924
      GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1963028), // Rule ID 19456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19456,
        GIR_EraseRootFromParent_Done,
      // Label 24459: @1963028
      GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1963132), // Rule ID 19457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10875:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19457,
        GIR_EraseRootFromParent_Done,
      // Label 24460: @1963132
      GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1963236), // Rule ID 19460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19460,
        GIR_EraseRootFromParent_Done,
      // Label 24461: @1963236
      GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1963340), // Rule ID 19461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10875:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19461,
        GIR_EraseRootFromParent_Done,
      // Label 24462: @1963340
      GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1963444), // Rule ID 19464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19464,
        GIR_EraseRootFromParent_Done,
      // Label 24463: @1963444
      GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1963548), // Rule ID 19465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10875:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19465,
        GIR_EraseRootFromParent_Done,
      // Label 24464: @1963548
      GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1963652), // Rule ID 19468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19468,
        GIR_EraseRootFromParent_Done,
      // Label 24465: @1963652
      GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1963756), // Rule ID 19469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19469,
        GIR_EraseRootFromParent_Done,
      // Label 24466: @1963756
      GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1963860), // Rule ID 19472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19472,
        GIR_EraseRootFromParent_Done,
      // Label 24467: @1963860
      GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1963964), // Rule ID 19473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19473,
        GIR_EraseRootFromParent_Done,
      // Label 24468: @1963964
      GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1964068), // Rule ID 19476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19476,
        GIR_EraseRootFromParent_Done,
      // Label 24469: @1964068
      GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1964172), // Rule ID 19477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19477,
        GIR_EraseRootFromParent_Done,
      // Label 24470: @1964172
      GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1964276), // Rule ID 19480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19480,
        GIR_EraseRootFromParent_Done,
      // Label 24471: @1964276
      GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1964380), // Rule ID 19481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19481,
        GIR_EraseRootFromParent_Done,
      // Label 24472: @1964380
      GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1964484), // Rule ID 19484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19484,
        GIR_EraseRootFromParent_Done,
      // Label 24473: @1964484
      GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1964588), // Rule ID 19485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19485,
        GIR_EraseRootFromParent_Done,
      // Label 24474: @1964588
      GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1964692), // Rule ID 19488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19488,
        GIR_EraseRootFromParent_Done,
      // Label 24475: @1964692
      GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1964796), // Rule ID 19489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19489,
        GIR_EraseRootFromParent_Done,
      // Label 24476: @1964796
      GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1964900), // Rule ID 19492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19492,
        GIR_EraseRootFromParent_Done,
      // Label 24477: @1964900
      GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1965004), // Rule ID 19493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10875:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19493,
        GIR_EraseRootFromParent_Done,
      // Label 24478: @1965004
      GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1965108), // Rule ID 19496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19496,
        GIR_EraseRootFromParent_Done,
      // Label 24479: @1965108
      GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1965212), // Rule ID 19497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10875:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19497,
        GIR_EraseRootFromParent_Done,
      // Label 24480: @1965212
      GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1965316), // Rule ID 19500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19500,
        GIR_EraseRootFromParent_Done,
      // Label 24481: @1965316
      GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1965420), // Rule ID 19501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10875:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19501,
        GIR_EraseRootFromParent_Done,
      // Label 24482: @1965420
      GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1965524), // Rule ID 19504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19504,
        GIR_EraseRootFromParent_Done,
      // Label 24483: @1965524
      GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1965628), // Rule ID 19505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19505,
        GIR_EraseRootFromParent_Done,
      // Label 24484: @1965628
      GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1965732), // Rule ID 19508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19508,
        GIR_EraseRootFromParent_Done,
      // Label 24485: @1965732
      GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1965836), // Rule ID 19509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19509,
        GIR_EraseRootFromParent_Done,
      // Label 24486: @1965836
      GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1965940), // Rule ID 19512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19512,
        GIR_EraseRootFromParent_Done,
      // Label 24487: @1965940
      GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1966044), // Rule ID 19513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19513,
        GIR_EraseRootFromParent_Done,
      // Label 24488: @1966044
      GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1966148), // Rule ID 19516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19516,
        GIR_EraseRootFromParent_Done,
      // Label 24489: @1966148
      GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1966252), // Rule ID 19517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19517,
        GIR_EraseRootFromParent_Done,
      // Label 24490: @1966252
      GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1966356), // Rule ID 19520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19520,
        GIR_EraseRootFromParent_Done,
      // Label 24491: @1966356
      GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1966460), // Rule ID 19521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19521,
        GIR_EraseRootFromParent_Done,
      // Label 24492: @1966460
      GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1966564), // Rule ID 19524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19524,
        GIR_EraseRootFromParent_Done,
      // Label 24493: @1966564
      GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1966668), // Rule ID 19525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19525,
        GIR_EraseRootFromParent_Done,
      // Label 24494: @1966668
      GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1966772), // Rule ID 19528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19528,
        GIR_EraseRootFromParent_Done,
      // Label 24495: @1966772
      GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1966876), // Rule ID 19529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19529,
        GIR_EraseRootFromParent_Done,
      // Label 24496: @1966876
      GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1966980), // Rule ID 19532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19532,
        GIR_EraseRootFromParent_Done,
      // Label 24497: @1966980
      GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1967084), // Rule ID 19533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19533,
        GIR_EraseRootFromParent_Done,
      // Label 24498: @1967084
      GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1967188), // Rule ID 19536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19536,
        GIR_EraseRootFromParent_Done,
      // Label 24499: @1967188
      GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1967292), // Rule ID 19537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19537,
        GIR_EraseRootFromParent_Done,
      // Label 24500: @1967292
      GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1967396), // Rule ID 19540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19540,
        GIR_EraseRootFromParent_Done,
      // Label 24501: @1967396
      GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1967500), // Rule ID 19541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19541,
        GIR_EraseRootFromParent_Done,
      // Label 24502: @1967500
      GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1967604), // Rule ID 19544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19544,
        GIR_EraseRootFromParent_Done,
      // Label 24503: @1967604
      GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1967708), // Rule ID 19545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19545,
        GIR_EraseRootFromParent_Done,
      // Label 24504: @1967708
      GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1967812), // Rule ID 19548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19548,
        GIR_EraseRootFromParent_Done,
      // Label 24505: @1967812
      GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1967916), // Rule ID 19549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19549,
        GIR_EraseRootFromParent_Done,
      // Label 24506: @1967916
      GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1968020), // Rule ID 19552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19552,
        GIR_EraseRootFromParent_Done,
      // Label 24507: @1968020
      GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1968124), // Rule ID 19553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19553,
        GIR_EraseRootFromParent_Done,
      // Label 24508: @1968124
      GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1968228), // Rule ID 19556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19556,
        GIR_EraseRootFromParent_Done,
      // Label 24509: @1968228
      GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1968332), // Rule ID 19557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19557,
        GIR_EraseRootFromParent_Done,
      // Label 24510: @1968332
      GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1968436), // Rule ID 19560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19560,
        GIR_EraseRootFromParent_Done,
      // Label 24511: @1968436
      GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1968540), // Rule ID 19561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19561,
        GIR_EraseRootFromParent_Done,
      // Label 24512: @1968540
      GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1968644), // Rule ID 19564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19564,
        GIR_EraseRootFromParent_Done,
      // Label 24513: @1968644
      GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1968748), // Rule ID 19565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19565,
        GIR_EraseRootFromParent_Done,
      // Label 24514: @1968748
      GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1968852), // Rule ID 19568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19568,
        GIR_EraseRootFromParent_Done,
      // Label 24515: @1968852
      GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1968956), // Rule ID 19569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19569,
        GIR_EraseRootFromParent_Done,
      // Label 24516: @1968956
      GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1969060), // Rule ID 19572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19572,
        GIR_EraseRootFromParent_Done,
      // Label 24517: @1969060
      GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1969164), // Rule ID 19573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19573,
        GIR_EraseRootFromParent_Done,
      // Label 24518: @1969164
      GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1969268), // Rule ID 19576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19576,
        GIR_EraseRootFromParent_Done,
      // Label 24519: @1969268
      GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1969372), // Rule ID 19577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10877:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19577,
        GIR_EraseRootFromParent_Done,
      // Label 24520: @1969372
      GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1969476), // Rule ID 19580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19580,
        GIR_EraseRootFromParent_Done,
      // Label 24521: @1969476
      GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1969580), // Rule ID 19581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10877:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19581,
        GIR_EraseRootFromParent_Done,
      // Label 24522: @1969580
      GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1969684), // Rule ID 19584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19584,
        GIR_EraseRootFromParent_Done,
      // Label 24523: @1969684
      GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1969788), // Rule ID 19585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10877:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19585,
        GIR_EraseRootFromParent_Done,
      // Label 24524: @1969788
      GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1969892), // Rule ID 19588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19588,
        GIR_EraseRootFromParent_Done,
      // Label 24525: @1969892
      GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1969996), // Rule ID 19589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19589,
        GIR_EraseRootFromParent_Done,
      // Label 24526: @1969996
      GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1970100), // Rule ID 19592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19592,
        GIR_EraseRootFromParent_Done,
      // Label 24527: @1970100
      GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1970204), // Rule ID 19593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19593,
        GIR_EraseRootFromParent_Done,
      // Label 24528: @1970204
      GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1970308), // Rule ID 19596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19596,
        GIR_EraseRootFromParent_Done,
      // Label 24529: @1970308
      GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1970412), // Rule ID 19597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19597,
        GIR_EraseRootFromParent_Done,
      // Label 24530: @1970412
      GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1970516), // Rule ID 19600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19600,
        GIR_EraseRootFromParent_Done,
      // Label 24531: @1970516
      GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1970620), // Rule ID 19601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19601,
        GIR_EraseRootFromParent_Done,
      // Label 24532: @1970620
      GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1970724), // Rule ID 19604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19604,
        GIR_EraseRootFromParent_Done,
      // Label 24533: @1970724
      GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1970828), // Rule ID 19605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19605,
        GIR_EraseRootFromParent_Done,
      // Label 24534: @1970828
      GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1970932), // Rule ID 19608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19608,
        GIR_EraseRootFromParent_Done,
      // Label 24535: @1970932
      GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1971036), // Rule ID 19609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19609,
        GIR_EraseRootFromParent_Done,
      // Label 24536: @1971036
      GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1971140), // Rule ID 19612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19612,
        GIR_EraseRootFromParent_Done,
      // Label 24537: @1971140
      GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1971244), // Rule ID 19613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10877:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19613,
        GIR_EraseRootFromParent_Done,
      // Label 24538: @1971244
      GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1971348), // Rule ID 19616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19616,
        GIR_EraseRootFromParent_Done,
      // Label 24539: @1971348
      GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1971452), // Rule ID 19617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10877:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19617,
        GIR_EraseRootFromParent_Done,
      // Label 24540: @1971452
      GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1971556), // Rule ID 19620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19620,
        GIR_EraseRootFromParent_Done,
      // Label 24541: @1971556
      GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1971660), // Rule ID 19621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10877:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19621,
        GIR_EraseRootFromParent_Done,
      // Label 24542: @1971660
      GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1971764), // Rule ID 23462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23462,
        GIR_EraseRootFromParent_Done,
      // Label 24543: @1971764
      GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1971868), // Rule ID 23463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23463,
        GIR_EraseRootFromParent_Done,
      // Label 24544: @1971868
      GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1971972), // Rule ID 23466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23466,
        GIR_EraseRootFromParent_Done,
      // Label 24545: @1971972
      GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1972076), // Rule ID 23467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23467,
        GIR_EraseRootFromParent_Done,
      // Label 24546: @1972076
      GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1972180), // Rule ID 23470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23470,
        GIR_EraseRootFromParent_Done,
      // Label 24547: @1972180
      GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1972284), // Rule ID 23471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23471,
        GIR_EraseRootFromParent_Done,
      // Label 24548: @1972284
      GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1972388), // Rule ID 23474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23474,
        GIR_EraseRootFromParent_Done,
      // Label 24549: @1972388
      GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1972492), // Rule ID 23475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23475,
        GIR_EraseRootFromParent_Done,
      // Label 24550: @1972492
      GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1972596), // Rule ID 23478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23478,
        GIR_EraseRootFromParent_Done,
      // Label 24551: @1972596
      GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1972700), // Rule ID 23479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23479,
        GIR_EraseRootFromParent_Done,
      // Label 24552: @1972700
      GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1972804), // Rule ID 23482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23482,
        GIR_EraseRootFromParent_Done,
      // Label 24553: @1972804
      GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1972908), // Rule ID 23483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23483,
        GIR_EraseRootFromParent_Done,
      // Label 24554: @1972908
      GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1973012), // Rule ID 23486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23486,
        GIR_EraseRootFromParent_Done,
      // Label 24555: @1973012
      GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1973116), // Rule ID 23487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23487,
        GIR_EraseRootFromParent_Done,
      // Label 24556: @1973116
      GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1973220), // Rule ID 23490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23490,
        GIR_EraseRootFromParent_Done,
      // Label 24557: @1973220
      GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1973324), // Rule ID 23491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23491,
        GIR_EraseRootFromParent_Done,
      // Label 24558: @1973324
      GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1973428), // Rule ID 23494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23494,
        GIR_EraseRootFromParent_Done,
      // Label 24559: @1973428
      GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1973532), // Rule ID 23495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23495,
        GIR_EraseRootFromParent_Done,
      // Label 24560: @1973532
      GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1973636), // Rule ID 23498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23498,
        GIR_EraseRootFromParent_Done,
      // Label 24561: @1973636
      GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1973740), // Rule ID 23499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23499,
        GIR_EraseRootFromParent_Done,
      // Label 24562: @1973740
      GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1973844), // Rule ID 23502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23502,
        GIR_EraseRootFromParent_Done,
      // Label 24563: @1973844
      GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1973948), // Rule ID 23503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23503,
        GIR_EraseRootFromParent_Done,
      // Label 24564: @1973948
      GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1974052), // Rule ID 23506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23506,
        GIR_EraseRootFromParent_Done,
      // Label 24565: @1974052
      GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1974156), // Rule ID 23507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23507,
        GIR_EraseRootFromParent_Done,
      // Label 24566: @1974156
      GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1974260), // Rule ID 23510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23510,
        GIR_EraseRootFromParent_Done,
      // Label 24567: @1974260
      GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1974364), // Rule ID 23511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23511,
        GIR_EraseRootFromParent_Done,
      // Label 24568: @1974364
      GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1974468), // Rule ID 23514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23514,
        GIR_EraseRootFromParent_Done,
      // Label 24569: @1974468
      GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1974572), // Rule ID 23515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23515,
        GIR_EraseRootFromParent_Done,
      // Label 24570: @1974572
      GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1974676), // Rule ID 23518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23518,
        GIR_EraseRootFromParent_Done,
      // Label 24571: @1974676
      GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1974780), // Rule ID 23519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23519,
        GIR_EraseRootFromParent_Done,
      // Label 24572: @1974780
      GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1974884), // Rule ID 23522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23522,
        GIR_EraseRootFromParent_Done,
      // Label 24573: @1974884
      GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1974988), // Rule ID 23523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23523,
        GIR_EraseRootFromParent_Done,
      // Label 24574: @1974988
      GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1975092), // Rule ID 23526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23526,
        GIR_EraseRootFromParent_Done,
      // Label 24575: @1975092
      GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1975196), // Rule ID 23527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23527,
        GIR_EraseRootFromParent_Done,
      // Label 24576: @1975196
      GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1975300), // Rule ID 23530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23530,
        GIR_EraseRootFromParent_Done,
      // Label 24577: @1975300
      GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1975404), // Rule ID 23531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23531,
        GIR_EraseRootFromParent_Done,
      // Label 24578: @1975404
      GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1975508), // Rule ID 23534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23534,
        GIR_EraseRootFromParent_Done,
      // Label 24579: @1975508
      GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1975612), // Rule ID 23535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23535,
        GIR_EraseRootFromParent_Done,
      // Label 24580: @1975612
      GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1975716), // Rule ID 23538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23538,
        GIR_EraseRootFromParent_Done,
      // Label 24581: @1975716
      GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1975820), // Rule ID 23539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23539,
        GIR_EraseRootFromParent_Done,
      // Label 24582: @1975820
      GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1975924), // Rule ID 23542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23542,
        GIR_EraseRootFromParent_Done,
      // Label 24583: @1975924
      GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1976028), // Rule ID 23543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23543,
        GIR_EraseRootFromParent_Done,
      // Label 24584: @1976028
      GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1976132), // Rule ID 23546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23546,
        GIR_EraseRootFromParent_Done,
      // Label 24585: @1976132
      GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1976236), // Rule ID 23547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23547,
        GIR_EraseRootFromParent_Done,
      // Label 24586: @1976236
      GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1976340), // Rule ID 23638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23638,
        GIR_EraseRootFromParent_Done,
      // Label 24587: @1976340
      GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1976444), // Rule ID 23639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23639,
        GIR_EraseRootFromParent_Done,
      // Label 24588: @1976444
      GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1976548), // Rule ID 23642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23642,
        GIR_EraseRootFromParent_Done,
      // Label 24589: @1976548
      GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1976652), // Rule ID 23643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23643,
        GIR_EraseRootFromParent_Done,
      // Label 24590: @1976652
      GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1976756), // Rule ID 23646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23646,
        GIR_EraseRootFromParent_Done,
      // Label 24591: @1976756
      GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1976860), // Rule ID 23647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23647,
        GIR_EraseRootFromParent_Done,
      // Label 24592: @1976860
      GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1976964), // Rule ID 23650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23650,
        GIR_EraseRootFromParent_Done,
      // Label 24593: @1976964
      GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1977068), // Rule ID 23651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23651,
        GIR_EraseRootFromParent_Done,
      // Label 24594: @1977068
      GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1977172), // Rule ID 23654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23654,
        GIR_EraseRootFromParent_Done,
      // Label 24595: @1977172
      GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1977276), // Rule ID 23655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23655,
        GIR_EraseRootFromParent_Done,
      // Label 24596: @1977276
      GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1977380), // Rule ID 23658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23658,
        GIR_EraseRootFromParent_Done,
      // Label 24597: @1977380
      GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1977484), // Rule ID 23659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23659,
        GIR_EraseRootFromParent_Done,
      // Label 24598: @1977484
      GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1977588), // Rule ID 23662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23662,
        GIR_EraseRootFromParent_Done,
      // Label 24599: @1977588
      GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1977692), // Rule ID 23663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23663,
        GIR_EraseRootFromParent_Done,
      // Label 24600: @1977692
      GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1977796), // Rule ID 23666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23666,
        GIR_EraseRootFromParent_Done,
      // Label 24601: @1977796
      GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1977900), // Rule ID 23667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23667,
        GIR_EraseRootFromParent_Done,
      // Label 24602: @1977900
      GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1978004), // Rule ID 23670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23670,
        GIR_EraseRootFromParent_Done,
      // Label 24603: @1978004
      GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1978108), // Rule ID 23671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23671,
        GIR_EraseRootFromParent_Done,
      // Label 24604: @1978108
      GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1978212), // Rule ID 23674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23674,
        GIR_EraseRootFromParent_Done,
      // Label 24605: @1978212
      GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1978316), // Rule ID 23675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23675,
        GIR_EraseRootFromParent_Done,
      // Label 24606: @1978316
      GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1978420), // Rule ID 23678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23678,
        GIR_EraseRootFromParent_Done,
      // Label 24607: @1978420
      GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1978524), // Rule ID 23679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23679,
        GIR_EraseRootFromParent_Done,
      // Label 24608: @1978524
      GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1978628), // Rule ID 23682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23682,
        GIR_EraseRootFromParent_Done,
      // Label 24609: @1978628
      GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1978732), // Rule ID 23683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23683,
        GIR_EraseRootFromParent_Done,
      // Label 24610: @1978732
      GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1978836), // Rule ID 23686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23686,
        GIR_EraseRootFromParent_Done,
      // Label 24611: @1978836
      GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1978940), // Rule ID 23687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23687,
        GIR_EraseRootFromParent_Done,
      // Label 24612: @1978940
      GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1979044), // Rule ID 23690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23690,
        GIR_EraseRootFromParent_Done,
      // Label 24613: @1979044
      GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1979148), // Rule ID 23691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23691,
        GIR_EraseRootFromParent_Done,
      // Label 24614: @1979148
      GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1979252), // Rule ID 23694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23694,
        GIR_EraseRootFromParent_Done,
      // Label 24615: @1979252
      GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1979356), // Rule ID 23695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23695,
        GIR_EraseRootFromParent_Done,
      // Label 24616: @1979356
      GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1979460), // Rule ID 23698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23698,
        GIR_EraseRootFromParent_Done,
      // Label 24617: @1979460
      GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1979564), // Rule ID 23699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23699,
        GIR_EraseRootFromParent_Done,
      // Label 24618: @1979564
      GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1979668), // Rule ID 23702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23702,
        GIR_EraseRootFromParent_Done,
      // Label 24619: @1979668
      GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1979772), // Rule ID 23703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23703,
        GIR_EraseRootFromParent_Done,
      // Label 24620: @1979772
      GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1979876), // Rule ID 23706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23706,
        GIR_EraseRootFromParent_Done,
      // Label 24621: @1979876
      GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1979980), // Rule ID 23707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23707,
        GIR_EraseRootFromParent_Done,
      // Label 24622: @1979980
      GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1980084), // Rule ID 23710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23710,
        GIR_EraseRootFromParent_Done,
      // Label 24623: @1980084
      GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1980188), // Rule ID 23711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23711,
        GIR_EraseRootFromParent_Done,
      // Label 24624: @1980188
      GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1980292), // Rule ID 23714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23714,
        GIR_EraseRootFromParent_Done,
      // Label 24625: @1980292
      GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1980396), // Rule ID 23715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23715,
        GIR_EraseRootFromParent_Done,
      // Label 24626: @1980396
      GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1980500), // Rule ID 23718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23718,
        GIR_EraseRootFromParent_Done,
      // Label 24627: @1980500
      GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1980604), // Rule ID 23719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23719,
        GIR_EraseRootFromParent_Done,
      // Label 24628: @1980604
      GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1980708), // Rule ID 23722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23722,
        GIR_EraseRootFromParent_Done,
      // Label 24629: @1980708
      GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1980812), // Rule ID 23723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23723,
        GIR_EraseRootFromParent_Done,
      // Label 24630: @1980812
      GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1980916), // Rule ID 23814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23814,
        GIR_EraseRootFromParent_Done,
      // Label 24631: @1980916
      GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1981020), // Rule ID 23815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23815,
        GIR_EraseRootFromParent_Done,
      // Label 24632: @1981020
      GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1981124), // Rule ID 23818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23818,
        GIR_EraseRootFromParent_Done,
      // Label 24633: @1981124
      GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1981228), // Rule ID 23819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23819,
        GIR_EraseRootFromParent_Done,
      // Label 24634: @1981228
      GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1981332), // Rule ID 23822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23822,
        GIR_EraseRootFromParent_Done,
      // Label 24635: @1981332
      GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1981436), // Rule ID 23823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23823,
        GIR_EraseRootFromParent_Done,
      // Label 24636: @1981436
      GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1981540), // Rule ID 23826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23826,
        GIR_EraseRootFromParent_Done,
      // Label 24637: @1981540
      GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1981644), // Rule ID 23827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23827,
        GIR_EraseRootFromParent_Done,
      // Label 24638: @1981644
      GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1981748), // Rule ID 23830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23830,
        GIR_EraseRootFromParent_Done,
      // Label 24639: @1981748
      GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1981852), // Rule ID 23831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23831,
        GIR_EraseRootFromParent_Done,
      // Label 24640: @1981852
      GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1981956), // Rule ID 23834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23834,
        GIR_EraseRootFromParent_Done,
      // Label 24641: @1981956
      GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1982060), // Rule ID 23835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23835,
        GIR_EraseRootFromParent_Done,
      // Label 24642: @1982060
      GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1982164), // Rule ID 23838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23838,
        GIR_EraseRootFromParent_Done,
      // Label 24643: @1982164
      GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1982268), // Rule ID 23839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23839,
        GIR_EraseRootFromParent_Done,
      // Label 24644: @1982268
      GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1982372), // Rule ID 23842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23842,
        GIR_EraseRootFromParent_Done,
      // Label 24645: @1982372
      GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1982476), // Rule ID 23843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23843,
        GIR_EraseRootFromParent_Done,
      // Label 24646: @1982476
      GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1982580), // Rule ID 23846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23846,
        GIR_EraseRootFromParent_Done,
      // Label 24647: @1982580
      GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1982684), // Rule ID 23847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23847,
        GIR_EraseRootFromParent_Done,
      // Label 24648: @1982684
      GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1982788), // Rule ID 23850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23850,
        GIR_EraseRootFromParent_Done,
      // Label 24649: @1982788
      GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1982892), // Rule ID 23851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23851,
        GIR_EraseRootFromParent_Done,
      // Label 24650: @1982892
      GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1982996), // Rule ID 23854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23854,
        GIR_EraseRootFromParent_Done,
      // Label 24651: @1982996
      GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1983100), // Rule ID 23855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23855,
        GIR_EraseRootFromParent_Done,
      // Label 24652: @1983100
      GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1983204), // Rule ID 23858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23858,
        GIR_EraseRootFromParent_Done,
      // Label 24653: @1983204
      GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1983308), // Rule ID 23859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23859,
        GIR_EraseRootFromParent_Done,
      // Label 24654: @1983308
      GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1983412), // Rule ID 23862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23862,
        GIR_EraseRootFromParent_Done,
      // Label 24655: @1983412
      GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1983516), // Rule ID 23863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23863,
        GIR_EraseRootFromParent_Done,
      // Label 24656: @1983516
      GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1983620), // Rule ID 23866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23866,
        GIR_EraseRootFromParent_Done,
      // Label 24657: @1983620
      GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1983724), // Rule ID 23867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23867,
        GIR_EraseRootFromParent_Done,
      // Label 24658: @1983724
      GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1983828), // Rule ID 23870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23870,
        GIR_EraseRootFromParent_Done,
      // Label 24659: @1983828
      GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1983932), // Rule ID 23871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23871,
        GIR_EraseRootFromParent_Done,
      // Label 24660: @1983932
      GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1984036), // Rule ID 23874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23874,
        GIR_EraseRootFromParent_Done,
      // Label 24661: @1984036
      GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1984140), // Rule ID 23875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23875,
        GIR_EraseRootFromParent_Done,
      // Label 24662: @1984140
      GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1984244), // Rule ID 23878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23878,
        GIR_EraseRootFromParent_Done,
      // Label 24663: @1984244
      GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1984348), // Rule ID 23879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23879,
        GIR_EraseRootFromParent_Done,
      // Label 24664: @1984348
      GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1984452), // Rule ID 23882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23882,
        GIR_EraseRootFromParent_Done,
      // Label 24665: @1984452
      GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1984556), // Rule ID 23883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23883,
        GIR_EraseRootFromParent_Done,
      // Label 24666: @1984556
      GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1984660), // Rule ID 23886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23886,
        GIR_EraseRootFromParent_Done,
      // Label 24667: @1984660
      GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1984764), // Rule ID 23887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23887,
        GIR_EraseRootFromParent_Done,
      // Label 24668: @1984764
      GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1984868), // Rule ID 23890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23890,
        GIR_EraseRootFromParent_Done,
      // Label 24669: @1984868
      GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1984972), // Rule ID 23891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23891,
        GIR_EraseRootFromParent_Done,
      // Label 24670: @1984972
      GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1985076), // Rule ID 23894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23894,
        GIR_EraseRootFromParent_Done,
      // Label 24671: @1985076
      GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1985180), // Rule ID 23895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23895,
        GIR_EraseRootFromParent_Done,
      // Label 24672: @1985180
      GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1985284), // Rule ID 23898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23898,
        GIR_EraseRootFromParent_Done,
      // Label 24673: @1985284
      GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1985388), // Rule ID 23899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23899,
        GIR_EraseRootFromParent_Done,
      // Label 24674: @1985388
      GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1985492), // Rule ID 23902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23902,
        GIR_EraseRootFromParent_Done,
      // Label 24675: @1985492
      GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1985596), // Rule ID 23903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23903,
        GIR_EraseRootFromParent_Done,
      // Label 24676: @1985596
      GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1985700), // Rule ID 23906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23906,
        GIR_EraseRootFromParent_Done,
      // Label 24677: @1985700
      GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1985804), // Rule ID 23907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23907,
        GIR_EraseRootFromParent_Done,
      // Label 24678: @1985804
      GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1985908), // Rule ID 23910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23910,
        GIR_EraseRootFromParent_Done,
      // Label 24679: @1985908
      GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1986012), // Rule ID 23911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23911,
        GIR_EraseRootFromParent_Done,
      // Label 24680: @1986012
      GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1986116), // Rule ID 23914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23914,
        GIR_EraseRootFromParent_Done,
      // Label 24681: @1986116
      GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1986220), // Rule ID 23915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23915,
        GIR_EraseRootFromParent_Done,
      // Label 24682: @1986220
      GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1986324), // Rule ID 23918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23918,
        GIR_EraseRootFromParent_Done,
      // Label 24683: @1986324
      GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1986428), // Rule ID 23919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23919,
        GIR_EraseRootFromParent_Done,
      // Label 24684: @1986428
      GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1986532), // Rule ID 23922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23922,
        GIR_EraseRootFromParent_Done,
      // Label 24685: @1986532
      GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1986636), // Rule ID 23923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23923,
        GIR_EraseRootFromParent_Done,
      // Label 24686: @1986636
      GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1986740), // Rule ID 23926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23926,
        GIR_EraseRootFromParent_Done,
      // Label 24687: @1986740
      GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1986844), // Rule ID 23927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23927,
        GIR_EraseRootFromParent_Done,
      // Label 24688: @1986844
      GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1986948), // Rule ID 23930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23930,
        GIR_EraseRootFromParent_Done,
      // Label 24689: @1986948
      GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1987052), // Rule ID 23931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23931,
        GIR_EraseRootFromParent_Done,
      // Label 24690: @1987052
      GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1987156), // Rule ID 23934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23934,
        GIR_EraseRootFromParent_Done,
      // Label 24691: @1987156
      GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1987260), // Rule ID 23935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23935,
        GIR_EraseRootFromParent_Done,
      // Label 24692: @1987260
      GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1987364), // Rule ID 23938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23938,
        GIR_EraseRootFromParent_Done,
      // Label 24693: @1987364
      GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1987468), // Rule ID 23939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23939,
        GIR_EraseRootFromParent_Done,
      // Label 24694: @1987468
      GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1987572), // Rule ID 23942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23942,
        GIR_EraseRootFromParent_Done,
      // Label 24695: @1987572
      GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1987676), // Rule ID 23943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23943,
        GIR_EraseRootFromParent_Done,
      // Label 24696: @1987676
      GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1987780), // Rule ID 23946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23946,
        GIR_EraseRootFromParent_Done,
      // Label 24697: @1987780
      GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1987884), // Rule ID 23947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23947,
        GIR_EraseRootFromParent_Done,
      // Label 24698: @1987884
      GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1987988), // Rule ID 23950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23950,
        GIR_EraseRootFromParent_Done,
      // Label 24699: @1987988
      GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1988092), // Rule ID 23951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23951,
        GIR_EraseRootFromParent_Done,
      // Label 24700: @1988092
      GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1988196), // Rule ID 23954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23954,
        GIR_EraseRootFromParent_Done,
      // Label 24701: @1988196
      GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1988300), // Rule ID 23955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23955,
        GIR_EraseRootFromParent_Done,
      // Label 24702: @1988300
      GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1988404), // Rule ID 23958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23958,
        GIR_EraseRootFromParent_Done,
      // Label 24703: @1988404
      GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1988508), // Rule ID 23959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23959,
        GIR_EraseRootFromParent_Done,
      // Label 24704: @1988508
      GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1988612), // Rule ID 23962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23962,
        GIR_EraseRootFromParent_Done,
      // Label 24705: @1988612
      GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1988716), // Rule ID 23963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23963,
        GIR_EraseRootFromParent_Done,
      // Label 24706: @1988716
      GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1988820), // Rule ID 23966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23966,
        GIR_EraseRootFromParent_Done,
      // Label 24707: @1988820
      GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1988924), // Rule ID 23967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23967,
        GIR_EraseRootFromParent_Done,
      // Label 24708: @1988924
      GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1989028), // Rule ID 23970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23970,
        GIR_EraseRootFromParent_Done,
      // Label 24709: @1989028
      GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1989132), // Rule ID 23971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23971,
        GIR_EraseRootFromParent_Done,
      // Label 24710: @1989132
      GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1989236), // Rule ID 23974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23974,
        GIR_EraseRootFromParent_Done,
      // Label 24711: @1989236
      GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1989340), // Rule ID 23975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23975,
        GIR_EraseRootFromParent_Done,
      // Label 24712: @1989340
      GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1989444), // Rule ID 23978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23978,
        GIR_EraseRootFromParent_Done,
      // Label 24713: @1989444
      GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1989548), // Rule ID 23979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23979,
        GIR_EraseRootFromParent_Done,
      // Label 24714: @1989548
      GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1989652), // Rule ID 23982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23982,
        GIR_EraseRootFromParent_Done,
      // Label 24715: @1989652
      GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1989756), // Rule ID 23983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23983,
        GIR_EraseRootFromParent_Done,
      // Label 24716: @1989756
      GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1989860), // Rule ID 23986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23986,
        GIR_EraseRootFromParent_Done,
      // Label 24717: @1989860
      GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1989964), // Rule ID 23987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23987,
        GIR_EraseRootFromParent_Done,
      // Label 24718: @1989964
      GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1990068), // Rule ID 23990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23990,
        GIR_EraseRootFromParent_Done,
      // Label 24719: @1990068
      GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1990172), // Rule ID 23991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23991,
        GIR_EraseRootFromParent_Done,
      // Label 24720: @1990172
      GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1990276), // Rule ID 23994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23994,
        GIR_EraseRootFromParent_Done,
      // Label 24721: @1990276
      GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1990380), // Rule ID 23995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23995,
        GIR_EraseRootFromParent_Done,
      // Label 24722: @1990380
      GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1990484), // Rule ID 23998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23998,
        GIR_EraseRootFromParent_Done,
      // Label 24723: @1990484
      GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1990588), // Rule ID 23999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23999,
        GIR_EraseRootFromParent_Done,
      // Label 24724: @1990588
      GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1990692), // Rule ID 24002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24002,
        GIR_EraseRootFromParent_Done,
      // Label 24725: @1990692
      GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1990796), // Rule ID 24003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24003,
        GIR_EraseRootFromParent_Done,
      // Label 24726: @1990796
      GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1990900), // Rule ID 24006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24006,
        GIR_EraseRootFromParent_Done,
      // Label 24727: @1990900
      GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1991004), // Rule ID 24007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24007,
        GIR_EraseRootFromParent_Done,
      // Label 24728: @1991004
      GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1991108), // Rule ID 24010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24010,
        GIR_EraseRootFromParent_Done,
      // Label 24729: @1991108
      GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1991212), // Rule ID 24011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24011,
        GIR_EraseRootFromParent_Done,
      // Label 24730: @1991212
      GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1991316), // Rule ID 24014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24014,
        GIR_EraseRootFromParent_Done,
      // Label 24731: @1991316
      GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1991420), // Rule ID 24015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24015,
        GIR_EraseRootFromParent_Done,
      // Label 24732: @1991420
      GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1991524), // Rule ID 24018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24018,
        GIR_EraseRootFromParent_Done,
      // Label 24733: @1991524
      GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1991628), // Rule ID 24019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24019,
        GIR_EraseRootFromParent_Done,
      // Label 24734: @1991628
      GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1991732), // Rule ID 24022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24022,
        GIR_EraseRootFromParent_Done,
      // Label 24735: @1991732
      GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1991836), // Rule ID 24023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24023,
        GIR_EraseRootFromParent_Done,
      // Label 24736: @1991836
      GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1991940), // Rule ID 24026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24026,
        GIR_EraseRootFromParent_Done,
      // Label 24737: @1991940
      GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1992044), // Rule ID 24027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24027,
        GIR_EraseRootFromParent_Done,
      // Label 24738: @1992044
      GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1992148), // Rule ID 24030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24030,
        GIR_EraseRootFromParent_Done,
      // Label 24739: @1992148
      GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1992252), // Rule ID 24031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24031,
        GIR_EraseRootFromParent_Done,
      // Label 24740: @1992252
      GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1992356), // Rule ID 24034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24034,
        GIR_EraseRootFromParent_Done,
      // Label 24741: @1992356
      GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1992460), // Rule ID 24035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24035,
        GIR_EraseRootFromParent_Done,
      // Label 24742: @1992460
      GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1992564), // Rule ID 24038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24038,
        GIR_EraseRootFromParent_Done,
      // Label 24743: @1992564
      GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1992668), // Rule ID 24039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24039,
        GIR_EraseRootFromParent_Done,
      // Label 24744: @1992668
      GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1992772), // Rule ID 24042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24042,
        GIR_EraseRootFromParent_Done,
      // Label 24745: @1992772
      GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1992876), // Rule ID 24043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24043,
        GIR_EraseRootFromParent_Done,
      // Label 24746: @1992876
      GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1992980), // Rule ID 24046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24046,
        GIR_EraseRootFromParent_Done,
      // Label 24747: @1992980
      GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1993084), // Rule ID 24047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24047,
        GIR_EraseRootFromParent_Done,
      // Label 24748: @1993084
      GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1993188), // Rule ID 24110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24110,
        GIR_EraseRootFromParent_Done,
      // Label 24749: @1993188
      GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1993292), // Rule ID 24111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24111,
        GIR_EraseRootFromParent_Done,
      // Label 24750: @1993292
      GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1993396), // Rule ID 24114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24114,
        GIR_EraseRootFromParent_Done,
      // Label 24751: @1993396
      GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1993500), // Rule ID 24115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24115,
        GIR_EraseRootFromParent_Done,
      // Label 24752: @1993500
      GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1993604), // Rule ID 24118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24118,
        GIR_EraseRootFromParent_Done,
      // Label 24753: @1993604
      GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1993708), // Rule ID 24119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24119,
        GIR_EraseRootFromParent_Done,
      // Label 24754: @1993708
      GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1993812), // Rule ID 24122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24122,
        GIR_EraseRootFromParent_Done,
      // Label 24755: @1993812
      GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1993916), // Rule ID 24123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24123,
        GIR_EraseRootFromParent_Done,
      // Label 24756: @1993916
      GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1994020), // Rule ID 24126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24126,
        GIR_EraseRootFromParent_Done,
      // Label 24757: @1994020
      GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1994124), // Rule ID 24127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24127,
        GIR_EraseRootFromParent_Done,
      // Label 24758: @1994124
      GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1994228), // Rule ID 24130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24130,
        GIR_EraseRootFromParent_Done,
      // Label 24759: @1994228
      GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1994332), // Rule ID 24131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24131,
        GIR_EraseRootFromParent_Done,
      // Label 24760: @1994332
      GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1994436), // Rule ID 24134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24134,
        GIR_EraseRootFromParent_Done,
      // Label 24761: @1994436
      GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1994540), // Rule ID 24135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24135,
        GIR_EraseRootFromParent_Done,
      // Label 24762: @1994540
      GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1994644), // Rule ID 24138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24138,
        GIR_EraseRootFromParent_Done,
      // Label 24763: @1994644
      GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1994748), // Rule ID 24139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24139,
        GIR_EraseRootFromParent_Done,
      // Label 24764: @1994748
      GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1994852), // Rule ID 24142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24142,
        GIR_EraseRootFromParent_Done,
      // Label 24765: @1994852
      GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1994956), // Rule ID 24143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24143,
        GIR_EraseRootFromParent_Done,
      // Label 24766: @1994956
      GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1995060), // Rule ID 24146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24146,
        GIR_EraseRootFromParent_Done,
      // Label 24767: @1995060
      GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1995164), // Rule ID 24147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24147,
        GIR_EraseRootFromParent_Done,
      // Label 24768: @1995164
      GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1995268), // Rule ID 24150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24150,
        GIR_EraseRootFromParent_Done,
      // Label 24769: @1995268
      GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1995372), // Rule ID 24151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24151,
        GIR_EraseRootFromParent_Done,
      // Label 24770: @1995372
      GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1995476), // Rule ID 24154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24154,
        GIR_EraseRootFromParent_Done,
      // Label 24771: @1995476
      GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1995580), // Rule ID 24155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24155,
        GIR_EraseRootFromParent_Done,
      // Label 24772: @1995580
      GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1995684), // Rule ID 24158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24158,
        GIR_EraseRootFromParent_Done,
      // Label 24773: @1995684
      GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1995788), // Rule ID 24159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24159,
        GIR_EraseRootFromParent_Done,
      // Label 24774: @1995788
      GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1995892), // Rule ID 24162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24162,
        GIR_EraseRootFromParent_Done,
      // Label 24775: @1995892
      GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1995996), // Rule ID 24163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24163,
        GIR_EraseRootFromParent_Done,
      // Label 24776: @1995996
      GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1996100), // Rule ID 24166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24166,
        GIR_EraseRootFromParent_Done,
      // Label 24777: @1996100
      GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1996204), // Rule ID 24167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24167,
        GIR_EraseRootFromParent_Done,
      // Label 24778: @1996204
      GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1996308), // Rule ID 24230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24230,
        GIR_EraseRootFromParent_Done,
      // Label 24779: @1996308
      GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1996412), // Rule ID 24231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24231,
        GIR_EraseRootFromParent_Done,
      // Label 24780: @1996412
      GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1996516), // Rule ID 24234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24234,
        GIR_EraseRootFromParent_Done,
      // Label 24781: @1996516
      GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1996620), // Rule ID 24235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24235,
        GIR_EraseRootFromParent_Done,
      // Label 24782: @1996620
      GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1996724), // Rule ID 24238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24238,
        GIR_EraseRootFromParent_Done,
      // Label 24783: @1996724
      GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1996828), // Rule ID 24239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24239,
        GIR_EraseRootFromParent_Done,
      // Label 24784: @1996828
      GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1996932), // Rule ID 24242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24242,
        GIR_EraseRootFromParent_Done,
      // Label 24785: @1996932
      GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1997036), // Rule ID 24243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10881:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24243,
        GIR_EraseRootFromParent_Done,
      // Label 24786: @1997036
      GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1997140), // Rule ID 24246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10881:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24246,
        GIR_EraseRootFromParent_Done,
      // Label 24787: @1997140
      GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1997244), // Rule ID 24247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10881:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24247,
        GIR_EraseRootFromParent_Done,
      // Label 24788: @1997244
      GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1997348), // Rule ID 24250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24250,
        GIR_EraseRootFromParent_Done,
      // Label 24789: @1997348
      GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1997452), // Rule ID 24251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10881:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24251,
        GIR_EraseRootFromParent_Done,
      // Label 24790: @1997452
      GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1997556), // Rule ID 24254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24254,
        GIR_EraseRootFromParent_Done,
      // Label 24791: @1997556
      GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1997660), // Rule ID 24255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24255,
        GIR_EraseRootFromParent_Done,
      // Label 24792: @1997660
      GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1997764), // Rule ID 24258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24258,
        GIR_EraseRootFromParent_Done,
      // Label 24793: @1997764
      GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1997868), // Rule ID 24259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24259,
        GIR_EraseRootFromParent_Done,
      // Label 24794: @1997868
      GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1997972), // Rule ID 24262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24262,
        GIR_EraseRootFromParent_Done,
      // Label 24795: @1997972
      GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1998076), // Rule ID 24263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24263,
        GIR_EraseRootFromParent_Done,
      // Label 24796: @1998076
      GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1998180), // Rule ID 24266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24266,
        GIR_EraseRootFromParent_Done,
      // Label 24797: @1998180
      GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1998284), // Rule ID 24267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24267,
        GIR_EraseRootFromParent_Done,
      // Label 24798: @1998284
      GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1998388), // Rule ID 24270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24270,
        GIR_EraseRootFromParent_Done,
      // Label 24799: @1998388
      GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1998492), // Rule ID 24271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24271,
        GIR_EraseRootFromParent_Done,
      // Label 24800: @1998492
      GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1998596), // Rule ID 24274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24274,
        GIR_EraseRootFromParent_Done,
      // Label 24801: @1998596
      GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1998700), // Rule ID 24275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24275,
        GIR_EraseRootFromParent_Done,
      // Label 24802: @1998700
      GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1998804), // Rule ID 24278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24278,
        GIR_EraseRootFromParent_Done,
      // Label 24803: @1998804
      GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1998908), // Rule ID 24279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10881:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24279,
        GIR_EraseRootFromParent_Done,
      // Label 24804: @1998908
      GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1999012), // Rule ID 24282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24282,
        GIR_EraseRootFromParent_Done,
      // Label 24805: @1999012
      GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1999116), // Rule ID 24283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10881:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24283,
        GIR_EraseRootFromParent_Done,
      // Label 24806: @1999116
      GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1999220), // Rule ID 24286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24286,
        GIR_EraseRootFromParent_Done,
      // Label 24807: @1999220
      GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1999324), // Rule ID 24287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10881:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24287,
        GIR_EraseRootFromParent_Done,
      // Label 24808: @1999324
      GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1999428), // Rule ID 24290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24290,
        GIR_EraseRootFromParent_Done,
      // Label 24809: @1999428
      GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1999532), // Rule ID 24291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24291,
        GIR_EraseRootFromParent_Done,
      // Label 24810: @1999532
      GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1999636), // Rule ID 24294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24294,
        GIR_EraseRootFromParent_Done,
      // Label 24811: @1999636
      GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1999740), // Rule ID 24295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24295,
        GIR_EraseRootFromParent_Done,
      // Label 24812: @1999740
      GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1999844), // Rule ID 24298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24298,
        GIR_EraseRootFromParent_Done,
      // Label 24813: @1999844
      GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1999948), // Rule ID 24299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24299,
        GIR_EraseRootFromParent_Done,
      // Label 24814: @1999948
      GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(2000052), // Rule ID 24302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24302,
        GIR_EraseRootFromParent_Done,
      // Label 24815: @2000052
      GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(2000156), // Rule ID 24303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10879:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24303,
        GIR_EraseRootFromParent_Done,
      // Label 24816: @2000156
      GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(2000260), // Rule ID 24306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10879:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24306,
        GIR_EraseRootFromParent_Done,
      // Label 24817: @2000260
      GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(2000364), // Rule ID 24307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10879:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24307,
        GIR_EraseRootFromParent_Done,
      // Label 24818: @2000364
      GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(2000468), // Rule ID 24310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24310,
        GIR_EraseRootFromParent_Done,
      // Label 24819: @2000468
      GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(2000572), // Rule ID 24311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10879:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24311,
        GIR_EraseRootFromParent_Done,
      // Label 24820: @2000572
      GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(2000676), // Rule ID 24314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24314,
        GIR_EraseRootFromParent_Done,
      // Label 24821: @2000676
      GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(2000780), // Rule ID 24315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24315,
        GIR_EraseRootFromParent_Done,
      // Label 24822: @2000780
      GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(2000884), // Rule ID 24318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24318,
        GIR_EraseRootFromParent_Done,
      // Label 24823: @2000884
      GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(2000988), // Rule ID 24319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24319,
        GIR_EraseRootFromParent_Done,
      // Label 24824: @2000988
      GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(2001092), // Rule ID 24322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24322,
        GIR_EraseRootFromParent_Done,
      // Label 24825: @2001092
      GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(2001196), // Rule ID 24323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24323,
        GIR_EraseRootFromParent_Done,
      // Label 24826: @2001196
      GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(2001300), // Rule ID 24326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24326,
        GIR_EraseRootFromParent_Done,
      // Label 24827: @2001300
      GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(2001404), // Rule ID 24327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24327,
        GIR_EraseRootFromParent_Done,
      // Label 24828: @2001404
      GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(2001508), // Rule ID 24330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24330,
        GIR_EraseRootFromParent_Done,
      // Label 24829: @2001508
      GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(2001612), // Rule ID 24331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24331,
        GIR_EraseRootFromParent_Done,
      // Label 24830: @2001612
      GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(2001716), // Rule ID 24334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24334,
        GIR_EraseRootFromParent_Done,
      // Label 24831: @2001716
      GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(2001820), // Rule ID 24335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24335,
        GIR_EraseRootFromParent_Done,
      // Label 24832: @2001820
      GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(2001924), // Rule ID 24338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24338,
        GIR_EraseRootFromParent_Done,
      // Label 24833: @2001924
      GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(2002028), // Rule ID 24339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10879:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24339,
        GIR_EraseRootFromParent_Done,
      // Label 24834: @2002028
      GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(2002132), // Rule ID 24342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24342,
        GIR_EraseRootFromParent_Done,
      // Label 24835: @2002132
      GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(2002236), // Rule ID 24343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10879:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24343,
        GIR_EraseRootFromParent_Done,
      // Label 24836: @2002236
      GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(2002340), // Rule ID 24346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24346,
        GIR_EraseRootFromParent_Done,
      // Label 24837: @2002340
      GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(2002444), // Rule ID 24347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10879:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24347,
        GIR_EraseRootFromParent_Done,
      // Label 24838: @2002444
      GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(2002548), // Rule ID 24350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24350,
        GIR_EraseRootFromParent_Done,
      // Label 24839: @2002548
      GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(2002652), // Rule ID 24351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24351,
        GIR_EraseRootFromParent_Done,
      // Label 24840: @2002652
      GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(2002756), // Rule ID 24354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24354,
        GIR_EraseRootFromParent_Done,
      // Label 24841: @2002756
      GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(2002860), // Rule ID 24355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24355,
        GIR_EraseRootFromParent_Done,
      // Label 24842: @2002860
      GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(2002964), // Rule ID 24358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24358,
        GIR_EraseRootFromParent_Done,
      // Label 24843: @2002964
      GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(2003068), // Rule ID 24359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24359,
        GIR_EraseRootFromParent_Done,
      // Label 24844: @2003068
      GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(2003172), // Rule ID 24362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24362,
        GIR_EraseRootFromParent_Done,
      // Label 24845: @2003172
      GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(2003276), // Rule ID 24363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24363,
        GIR_EraseRootFromParent_Done,
      // Label 24846: @2003276
      GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(2003380), // Rule ID 24366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24366,
        GIR_EraseRootFromParent_Done,
      // Label 24847: @2003380
      GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(2003484), // Rule ID 24367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24367,
        GIR_EraseRootFromParent_Done,
      // Label 24848: @2003484
      GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(2003588), // Rule ID 24370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24370,
        GIR_EraseRootFromParent_Done,
      // Label 24849: @2003588
      GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(2003692), // Rule ID 24371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24371,
        GIR_EraseRootFromParent_Done,
      // Label 24850: @2003692
      GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(2003796), // Rule ID 24374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11127:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24374,
        GIR_EraseRootFromParent_Done,
      // Label 24851: @2003796
      GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(2003900), // Rule ID 24375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11127:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24375,
        GIR_EraseRootFromParent_Done,
      // Label 24852: @2003900
      GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(2004004), // Rule ID 24378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24378,
        GIR_EraseRootFromParent_Done,
      // Label 24853: @2004004
      GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(2004108), // Rule ID 24379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24379,
        GIR_EraseRootFromParent_Done,
      // Label 24854: @2004108
      GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(2004212), // Rule ID 24382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24382,
        GIR_EraseRootFromParent_Done,
      // Label 24855: @2004212
      GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(2004316), // Rule ID 24383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24383,
        GIR_EraseRootFromParent_Done,
      // Label 24856: @2004316
      GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(2004420), // Rule ID 24386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24386,
        GIR_EraseRootFromParent_Done,
      // Label 24857: @2004420
      GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(2004524), // Rule ID 24387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24387,
        GIR_EraseRootFromParent_Done,
      // Label 24858: @2004524
      GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(2004628), // Rule ID 24390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24390,
        GIR_EraseRootFromParent_Done,
      // Label 24859: @2004628
      GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(2004732), // Rule ID 24391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24391,
        GIR_EraseRootFromParent_Done,
      // Label 24860: @2004732
      GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(2004836), // Rule ID 24394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24394,
        GIR_EraseRootFromParent_Done,
      // Label 24861: @2004836
      GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(2004940), // Rule ID 24395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24395,
        GIR_EraseRootFromParent_Done,
      // Label 24862: @2004940
      GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(2005044), // Rule ID 24398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24398,
        GIR_EraseRootFromParent_Done,
      // Label 24863: @2005044
      GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(2005148), // Rule ID 24399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24399,
        GIR_EraseRootFromParent_Done,
      // Label 24864: @2005148
      GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(2005252), // Rule ID 24402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24402,
        GIR_EraseRootFromParent_Done,
      // Label 24865: @2005252
      GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(2005356), // Rule ID 24403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24403,
        GIR_EraseRootFromParent_Done,
      // Label 24866: @2005356
      GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(2005460), // Rule ID 24406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24406,
        GIR_EraseRootFromParent_Done,
      // Label 24867: @2005460
      GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(2005564), // Rule ID 24407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24407,
        GIR_EraseRootFromParent_Done,
      // Label 24868: @2005564
      GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(2005668), // Rule ID 24410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24410,
        GIR_EraseRootFromParent_Done,
      // Label 24869: @2005668
      GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(2005772), // Rule ID 24411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24411,
        GIR_EraseRootFromParent_Done,
      // Label 24870: @2005772
      GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(2005876), // Rule ID 24414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24414,
        GIR_EraseRootFromParent_Done,
      // Label 24871: @2005876
      GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(2005980), // Rule ID 24415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24415,
        GIR_EraseRootFromParent_Done,
      // Label 24872: @2005980
      GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(2006084), // Rule ID 24418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24418,
        GIR_EraseRootFromParent_Done,
      // Label 24873: @2006084
      GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(2006188), // Rule ID 24419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24419,
        GIR_EraseRootFromParent_Done,
      // Label 24874: @2006188
      GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(2006292), // Rule ID 24422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24422,
        GIR_EraseRootFromParent_Done,
      // Label 24875: @2006292
      GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(2006396), // Rule ID 24423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24423,
        GIR_EraseRootFromParent_Done,
      // Label 24876: @2006396
      GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(2006500), // Rule ID 24426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24426,
        GIR_EraseRootFromParent_Done,
      // Label 24877: @2006500
      GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(2006604), // Rule ID 24427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24427,
        GIR_EraseRootFromParent_Done,
      // Label 24878: @2006604
      GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(2006708), // Rule ID 24430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24430,
        GIR_EraseRootFromParent_Done,
      // Label 24879: @2006708
      GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(2006812), // Rule ID 24431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24431,
        GIR_EraseRootFromParent_Done,
      // Label 24880: @2006812
      GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(2006916), // Rule ID 24434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24434,
        GIR_EraseRootFromParent_Done,
      // Label 24881: @2006916
      GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(2007020), // Rule ID 24435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24435,
        GIR_EraseRootFromParent_Done,
      // Label 24882: @2007020
      GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(2007124), // Rule ID 24438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24438,
        GIR_EraseRootFromParent_Done,
      // Label 24883: @2007124
      GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(2007228), // Rule ID 24439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24439,
        GIR_EraseRootFromParent_Done,
      // Label 24884: @2007228
      GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(2007332), // Rule ID 24442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24442,
        GIR_EraseRootFromParent_Done,
      // Label 24885: @2007332
      GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(2007436), // Rule ID 24443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24443,
        GIR_EraseRootFromParent_Done,
      // Label 24886: @2007436
      GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(2007540), // Rule ID 24446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24446,
        GIR_EraseRootFromParent_Done,
      // Label 24887: @2007540
      GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(2007644), // Rule ID 24447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24447,
        GIR_EraseRootFromParent_Done,
      // Label 24888: @2007644
      GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(2007748), // Rule ID 24450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24450,
        GIR_EraseRootFromParent_Done,
      // Label 24889: @2007748
      GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(2007852), // Rule ID 24451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24451,
        GIR_EraseRootFromParent_Done,
      // Label 24890: @2007852
      GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(2007956), // Rule ID 24454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24454,
        GIR_EraseRootFromParent_Done,
      // Label 24891: @2007956
      GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(2008060), // Rule ID 24455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24455,
        GIR_EraseRootFromParent_Done,
      // Label 24892: @2008060
      GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(2008164), // Rule ID 24458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24458,
        GIR_EraseRootFromParent_Done,
      // Label 24893: @2008164
      GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(2008268), // Rule ID 24459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24459,
        GIR_EraseRootFromParent_Done,
      // Label 24894: @2008268
      GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(2008372), // Rule ID 24462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24462,
        GIR_EraseRootFromParent_Done,
      // Label 24895: @2008372
      GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(2008476), // Rule ID 24463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11129:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24463,
        GIR_EraseRootFromParent_Done,
      // Label 24896: @2008476
      GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(2008580), // Rule ID 24466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24466,
        GIR_EraseRootFromParent_Done,
      // Label 24897: @2008580
      GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(2008684), // Rule ID 24467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24467,
        GIR_EraseRootFromParent_Done,
      // Label 24898: @2008684
      GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(2008788), // Rule ID 24470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24470,
        GIR_EraseRootFromParent_Done,
      // Label 24899: @2008788
      GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(2008892), // Rule ID 24471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24471,
        GIR_EraseRootFromParent_Done,
      // Label 24900: @2008892
      GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(2008996), // Rule ID 24474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24474,
        GIR_EraseRootFromParent_Done,
      // Label 24901: @2008996
      GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(2009100), // Rule ID 24475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24475,
        GIR_EraseRootFromParent_Done,
      // Label 24902: @2009100
      GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(2009204), // Rule ID 24478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24478,
        GIR_EraseRootFromParent_Done,
      // Label 24903: @2009204
      GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(2009308), // Rule ID 24479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24479,
        GIR_EraseRootFromParent_Done,
      // Label 24904: @2009308
      GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(2009412), // Rule ID 24482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24482,
        GIR_EraseRootFromParent_Done,
      // Label 24905: @2009412
      GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(2009516), // Rule ID 24483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24483,
        GIR_EraseRootFromParent_Done,
      // Label 24906: @2009516
      GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(2009620), // Rule ID 24486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24486,
        GIR_EraseRootFromParent_Done,
      // Label 24907: @2009620
      GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(2009724), // Rule ID 24487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24487,
        GIR_EraseRootFromParent_Done,
      // Label 24908: @2009724
      GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(2009828), // Rule ID 24490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24490,
        GIR_EraseRootFromParent_Done,
      // Label 24909: @2009828
      GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(2009932), // Rule ID 24491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24491,
        GIR_EraseRootFromParent_Done,
      // Label 24910: @2009932
      GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(2010036), // Rule ID 24494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24494,
        GIR_EraseRootFromParent_Done,
      // Label 24911: @2010036
      GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(2010140), // Rule ID 24495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24495,
        GIR_EraseRootFromParent_Done,
      // Label 24912: @2010140
      GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(2010244), // Rule ID 24498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24498,
        GIR_EraseRootFromParent_Done,
      // Label 24913: @2010244
      GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(2010348), // Rule ID 24499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24499,
        GIR_EraseRootFromParent_Done,
      // Label 24914: @2010348
      GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(2010452), // Rule ID 24502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24502,
        GIR_EraseRootFromParent_Done,
      // Label 24915: @2010452
      GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(2010556), // Rule ID 24503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24503,
        GIR_EraseRootFromParent_Done,
      // Label 24916: @2010556
      GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(2010660), // Rule ID 24506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24506,
        GIR_EraseRootFromParent_Done,
      // Label 24917: @2010660
      GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(2010764), // Rule ID 24507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24507,
        GIR_EraseRootFromParent_Done,
      // Label 24918: @2010764
      GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(2010868), // Rule ID 24510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24510,
        GIR_EraseRootFromParent_Done,
      // Label 24919: @2010868
      GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(2010972), // Rule ID 24511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24511,
        GIR_EraseRootFromParent_Done,
      // Label 24920: @2010972
      GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(2011076), // Rule ID 24514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24514,
        GIR_EraseRootFromParent_Done,
      // Label 24921: @2011076
      GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(2011180), // Rule ID 24515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24515,
        GIR_EraseRootFromParent_Done,
      // Label 24922: @2011180
      GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(2011284), // Rule ID 24518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24518,
        GIR_EraseRootFromParent_Done,
      // Label 24923: @2011284
      GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(2011388), // Rule ID 24519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24519,
        GIR_EraseRootFromParent_Done,
      // Label 24924: @2011388
      GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(2011492), // Rule ID 24522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24522,
        GIR_EraseRootFromParent_Done,
      // Label 24925: @2011492
      GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(2011596), // Rule ID 24523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24523,
        GIR_EraseRootFromParent_Done,
      // Label 24926: @2011596
      GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(2011700), // Rule ID 24614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24614,
        GIR_EraseRootFromParent_Done,
      // Label 24927: @2011700
      GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(2011804), // Rule ID 24615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24615,
        GIR_EraseRootFromParent_Done,
      // Label 24928: @2011804
      GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(2011908), // Rule ID 24618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24618,
        GIR_EraseRootFromParent_Done,
      // Label 24929: @2011908
      GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(2012012), // Rule ID 24619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24619,
        GIR_EraseRootFromParent_Done,
      // Label 24930: @2012012
      GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(2012116), // Rule ID 24622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24622,
        GIR_EraseRootFromParent_Done,
      // Label 24931: @2012116
      GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(2012220), // Rule ID 24623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24623,
        GIR_EraseRootFromParent_Done,
      // Label 24932: @2012220
      GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(2012324), // Rule ID 24626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24626,
        GIR_EraseRootFromParent_Done,
      // Label 24933: @2012324
      GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(2012428), // Rule ID 24627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24627,
        GIR_EraseRootFromParent_Done,
      // Label 24934: @2012428
      GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(2012532), // Rule ID 24630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24630,
        GIR_EraseRootFromParent_Done,
      // Label 24935: @2012532
      GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(2012636), // Rule ID 24631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24631,
        GIR_EraseRootFromParent_Done,
      // Label 24936: @2012636
      GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(2012740), // Rule ID 24634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24634,
        GIR_EraseRootFromParent_Done,
      // Label 24937: @2012740
      GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(2012844), // Rule ID 24635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24635,
        GIR_EraseRootFromParent_Done,
      // Label 24938: @2012844
      GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(2012948), // Rule ID 24638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11131:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24638,
        GIR_EraseRootFromParent_Done,
      // Label 24939: @2012948
      GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(2013052), // Rule ID 24639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11131:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24639,
        GIR_EraseRootFromParent_Done,
      // Label 24940: @2013052
      GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(2013156), // Rule ID 24642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24642,
        GIR_EraseRootFromParent_Done,
      // Label 24941: @2013156
      GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(2013260), // Rule ID 24643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24643,
        GIR_EraseRootFromParent_Done,
      // Label 24942: @2013260
      GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(2013364), // Rule ID 24646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24646,
        GIR_EraseRootFromParent_Done,
      // Label 24943: @2013364
      GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(2013468), // Rule ID 24647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24647,
        GIR_EraseRootFromParent_Done,
      // Label 24944: @2013468
      GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(2013572), // Rule ID 24650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24650,
        GIR_EraseRootFromParent_Done,
      // Label 24945: @2013572
      GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(2013676), // Rule ID 24651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24651,
        GIR_EraseRootFromParent_Done,
      // Label 24946: @2013676
      GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(2013780), // Rule ID 24654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24654,
        GIR_EraseRootFromParent_Done,
      // Label 24947: @2013780
      GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(2013884), // Rule ID 24655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24655,
        GIR_EraseRootFromParent_Done,
      // Label 24948: @2013884
      GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(2013988), // Rule ID 24658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24658,
        GIR_EraseRootFromParent_Done,
      // Label 24949: @2013988
      GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(2014092), // Rule ID 24659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24659,
        GIR_EraseRootFromParent_Done,
      // Label 24950: @2014092
      GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(2014196), // Rule ID 24662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24662,
        GIR_EraseRootFromParent_Done,
      // Label 24951: @2014196
      GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(2014300), // Rule ID 24663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24663,
        GIR_EraseRootFromParent_Done,
      // Label 24952: @2014300
      GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(2014404), // Rule ID 24666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24666,
        GIR_EraseRootFromParent_Done,
      // Label 24953: @2014404
      GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(2014508), // Rule ID 24667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24667,
        GIR_EraseRootFromParent_Done,
      // Label 24954: @2014508
      GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(2014612), // Rule ID 24670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24670,
        GIR_EraseRootFromParent_Done,
      // Label 24955: @2014612
      GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(2014716), // Rule ID 24671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24671,
        GIR_EraseRootFromParent_Done,
      // Label 24956: @2014716
      GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(2014820), // Rule ID 24674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24674,
        GIR_EraseRootFromParent_Done,
      // Label 24957: @2014820
      GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(2014924), // Rule ID 24675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24675,
        GIR_EraseRootFromParent_Done,
      // Label 24958: @2014924
      GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(2015028), // Rule ID 24678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24678,
        GIR_EraseRootFromParent_Done,
      // Label 24959: @2015028
      GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(2015132), // Rule ID 24679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24679,
        GIR_EraseRootFromParent_Done,
      // Label 24960: @2015132
      GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(2015236), // Rule ID 24682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24682,
        GIR_EraseRootFromParent_Done,
      // Label 24961: @2015236
      GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(2015340), // Rule ID 24683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24683,
        GIR_EraseRootFromParent_Done,
      // Label 24962: @2015340
      GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(2015444), // Rule ID 24686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24686,
        GIR_EraseRootFromParent_Done,
      // Label 24963: @2015444
      GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(2015548), // Rule ID 24687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24687,
        GIR_EraseRootFromParent_Done,
      // Label 24964: @2015548
      GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(2015652), // Rule ID 24690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24690,
        GIR_EraseRootFromParent_Done,
      // Label 24965: @2015652
      GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(2015756), // Rule ID 24691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24691,
        GIR_EraseRootFromParent_Done,
      // Label 24966: @2015756
      GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(2015860), // Rule ID 24694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24694,
        GIR_EraseRootFromParent_Done,
      // Label 24967: @2015860
      GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(2015964), // Rule ID 24695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24695,
        GIR_EraseRootFromParent_Done,
      // Label 24968: @2015964
      GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(2016068), // Rule ID 24698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24698,
        GIR_EraseRootFromParent_Done,
      // Label 24969: @2016068
      GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(2016172), // Rule ID 24699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24699,
        GIR_EraseRootFromParent_Done,
      // Label 24970: @2016172
      GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(2016276), // Rule ID 24702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24702,
        GIR_EraseRootFromParent_Done,
      // Label 24971: @2016276
      GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(2016380), // Rule ID 24703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24703,
        GIR_EraseRootFromParent_Done,
      // Label 24972: @2016380
      GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(2016484), // Rule ID 24706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24706,
        GIR_EraseRootFromParent_Done,
      // Label 24973: @2016484
      GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(2016588), // Rule ID 24707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24707,
        GIR_EraseRootFromParent_Done,
      // Label 24974: @2016588
      GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(2016692), // Rule ID 24710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24710,
        GIR_EraseRootFromParent_Done,
      // Label 24975: @2016692
      GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(2016796), // Rule ID 24711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24711,
        GIR_EraseRootFromParent_Done,
      // Label 24976: @2016796
      GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(2016900), // Rule ID 24714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24714,
        GIR_EraseRootFromParent_Done,
      // Label 24977: @2016900
      GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(2017004), // Rule ID 24715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24715,
        GIR_EraseRootFromParent_Done,
      // Label 24978: @2017004
      GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(2017108), // Rule ID 24718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24718,
        GIR_EraseRootFromParent_Done,
      // Label 24979: @2017108
      GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(2017212), // Rule ID 24719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24719,
        GIR_EraseRootFromParent_Done,
      // Label 24980: @2017212
      GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(2017316), // Rule ID 24722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24722,
        GIR_EraseRootFromParent_Done,
      // Label 24981: @2017316
      GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(2017420), // Rule ID 24723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24723,
        GIR_EraseRootFromParent_Done,
      // Label 24982: @2017420
      GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(2017524), // Rule ID 24726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24726,
        GIR_EraseRootFromParent_Done,
      // Label 24983: @2017524
      GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(2017628), // Rule ID 24727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24727,
        GIR_EraseRootFromParent_Done,
      // Label 24984: @2017628
      GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(2017732), // Rule ID 24730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24730,
        GIR_EraseRootFromParent_Done,
      // Label 24985: @2017732
      GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(2017836), // Rule ID 24731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24731,
        GIR_EraseRootFromParent_Done,
      // Label 24986: @2017836
      GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(2017940), // Rule ID 24734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24734,
        GIR_EraseRootFromParent_Done,
      // Label 24987: @2017940
      GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(2018044), // Rule ID 24735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24735,
        GIR_EraseRootFromParent_Done,
      // Label 24988: @2018044
      GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(2018148), // Rule ID 24738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24738,
        GIR_EraseRootFromParent_Done,
      // Label 24989: @2018148
      GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(2018252), // Rule ID 24739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24739,
        GIR_EraseRootFromParent_Done,
      // Label 24990: @2018252
      GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(2018356), // Rule ID 24742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24742,
        GIR_EraseRootFromParent_Done,
      // Label 24991: @2018356
      GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(2018460), // Rule ID 24743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24743,
        GIR_EraseRootFromParent_Done,
      // Label 24992: @2018460
      GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(2018564), // Rule ID 24746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24746,
        GIR_EraseRootFromParent_Done,
      // Label 24993: @2018564
      GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(2018668), // Rule ID 24747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24747,
        GIR_EraseRootFromParent_Done,
      // Label 24994: @2018668
      GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(2018772), // Rule ID 24750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24750,
        GIR_EraseRootFromParent_Done,
      // Label 24995: @2018772
      GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(2018876), // Rule ID 24751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24751,
        GIR_EraseRootFromParent_Done,
      // Label 24996: @2018876
      GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(2018980), // Rule ID 24754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24754,
        GIR_EraseRootFromParent_Done,
      // Label 24997: @2018980
      GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(2019084), // Rule ID 24755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24755,
        GIR_EraseRootFromParent_Done,
      // Label 24998: @2019084
      GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(2019188), // Rule ID 24758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24758,
        GIR_EraseRootFromParent_Done,
      // Label 24999: @2019188
      GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(2019292), // Rule ID 24759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24759,
        GIR_EraseRootFromParent_Done,
      // Label 25000: @2019292
      GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(2019396), // Rule ID 24762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24762,
        GIR_EraseRootFromParent_Done,
      // Label 25001: @2019396
      GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(2019500), // Rule ID 24763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24763,
        GIR_EraseRootFromParent_Done,
      // Label 25002: @2019500
      GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(2019604), // Rule ID 24766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24766,
        GIR_EraseRootFromParent_Done,
      // Label 25003: @2019604
      GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(2019708), // Rule ID 24767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24767,
        GIR_EraseRootFromParent_Done,
      // Label 25004: @2019708
      GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(2019812), // Rule ID 24806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24806,
        GIR_EraseRootFromParent_Done,
      // Label 25005: @2019812
      GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(2019916), // Rule ID 24807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24807,
        GIR_EraseRootFromParent_Done,
      // Label 25006: @2019916
      GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(2020020), // Rule ID 24810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24810,
        GIR_EraseRootFromParent_Done,
      // Label 25007: @2020020
      GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(2020124), // Rule ID 24811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24811,
        GIR_EraseRootFromParent_Done,
      // Label 25008: @2020124
      GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(2020228), // Rule ID 24814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24814,
        GIR_EraseRootFromParent_Done,
      // Label 25009: @2020228
      GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(2020332), // Rule ID 24815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24815,
        GIR_EraseRootFromParent_Done,
      // Label 25010: @2020332
      GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(2020436), // Rule ID 24818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24818,
        GIR_EraseRootFromParent_Done,
      // Label 25011: @2020436
      GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(2020540), // Rule ID 24819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24819,
        GIR_EraseRootFromParent_Done,
      // Label 25012: @2020540
      GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(2020644), // Rule ID 24822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24822,
        GIR_EraseRootFromParent_Done,
      // Label 25013: @2020644
      GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(2020748), // Rule ID 24823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24823,
        GIR_EraseRootFromParent_Done,
      // Label 25014: @2020748
      GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(2020852), // Rule ID 24826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24826,
        GIR_EraseRootFromParent_Done,
      // Label 25015: @2020852
      GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(2020956), // Rule ID 24827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24827,
        GIR_EraseRootFromParent_Done,
      // Label 25016: @2020956
      GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(2021060), // Rule ID 24830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24830,
        GIR_EraseRootFromParent_Done,
      // Label 25017: @2021060
      GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(2021164), // Rule ID 24831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24831,
        GIR_EraseRootFromParent_Done,
      // Label 25018: @2021164
      GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(2021268), // Rule ID 24834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24834,
        GIR_EraseRootFromParent_Done,
      // Label 25019: @2021268
      GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(2021372), // Rule ID 24835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24835,
        GIR_EraseRootFromParent_Done,
      // Label 25020: @2021372
      GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(2021476), // Rule ID 24838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24838,
        GIR_EraseRootFromParent_Done,
      // Label 25021: @2021476
      GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(2021580), // Rule ID 24839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24839,
        GIR_EraseRootFromParent_Done,
      // Label 25022: @2021580
      GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(2021684), // Rule ID 24842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24842,
        GIR_EraseRootFromParent_Done,
      // Label 25023: @2021684
      GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(2021788), // Rule ID 24843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24843,
        GIR_EraseRootFromParent_Done,
      // Label 25024: @2021788
      GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(2021892), // Rule ID 24846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24846,
        GIR_EraseRootFromParent_Done,
      // Label 25025: @2021892
      GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(2021996), // Rule ID 24847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24847,
        GIR_EraseRootFromParent_Done,
      // Label 25026: @2021996
      GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(2022100), // Rule ID 24850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24850,
        GIR_EraseRootFromParent_Done,
      // Label 25027: @2022100
      GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(2022204), // Rule ID 24851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24851,
        GIR_EraseRootFromParent_Done,
      // Label 25028: @2022204
      GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(2022308), // Rule ID 24878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24878,
        GIR_EraseRootFromParent_Done,
      // Label 25029: @2022308
      GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(2022412), // Rule ID 24879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24879,
        GIR_EraseRootFromParent_Done,
      // Label 25030: @2022412
      GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(2022516), // Rule ID 24882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24882,
        GIR_EraseRootFromParent_Done,
      // Label 25031: @2022516
      GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(2022620), // Rule ID 24883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24883,
        GIR_EraseRootFromParent_Done,
      // Label 25032: @2022620
      GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(2022724), // Rule ID 24886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24886,
        GIR_EraseRootFromParent_Done,
      // Label 25033: @2022724
      GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(2022828), // Rule ID 24887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24887,
        GIR_EraseRootFromParent_Done,
      // Label 25034: @2022828
      GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(2022932), // Rule ID 24890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24890,
        GIR_EraseRootFromParent_Done,
      // Label 25035: @2022932
      GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(2023036), // Rule ID 24891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24891,
        GIR_EraseRootFromParent_Done,
      // Label 25036: @2023036
      GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(2023140), // Rule ID 24894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24894,
        GIR_EraseRootFromParent_Done,
      // Label 25037: @2023140
      GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(2023244), // Rule ID 24895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24895,
        GIR_EraseRootFromParent_Done,
      // Label 25038: @2023244
      GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(2023348), // Rule ID 24898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24898,
        GIR_EraseRootFromParent_Done,
      // Label 25039: @2023348
      GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(2023452), // Rule ID 24899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24899,
        GIR_EraseRootFromParent_Done,
      // Label 25040: @2023452
      GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(2023556), // Rule ID 24902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24902,
        GIR_EraseRootFromParent_Done,
      // Label 25041: @2023556
      GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(2023660), // Rule ID 24903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24903,
        GIR_EraseRootFromParent_Done,
      // Label 25042: @2023660
      GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(2023764), // Rule ID 24906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24906,
        GIR_EraseRootFromParent_Done,
      // Label 25043: @2023764
      GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(2023868), // Rule ID 24907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24907,
        GIR_EraseRootFromParent_Done,
      // Label 25044: @2023868
      GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(2023972), // Rule ID 24910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24910,
        GIR_EraseRootFromParent_Done,
      // Label 25045: @2023972
      GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(2024076), // Rule ID 24911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24911,
        GIR_EraseRootFromParent_Done,
      // Label 25046: @2024076
      GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(2024180), // Rule ID 24914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24914,
        GIR_EraseRootFromParent_Done,
      // Label 25047: @2024180
      GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(2024284), // Rule ID 24915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24915,
        GIR_EraseRootFromParent_Done,
      // Label 25048: @2024284
      GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(2024388), // Rule ID 24918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24918,
        GIR_EraseRootFromParent_Done,
      // Label 25049: @2024388
      GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(2024492), // Rule ID 24919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24919,
        GIR_EraseRootFromParent_Done,
      // Label 25050: @2024492
      GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(2024596), // Rule ID 24922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24922,
        GIR_EraseRootFromParent_Done,
      // Label 25051: @2024596
      GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(2024700), // Rule ID 24923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24923,
        GIR_EraseRootFromParent_Done,
      // Label 25052: @2024700
      GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(2024804), // Rule ID 24926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24926,
        GIR_EraseRootFromParent_Done,
      // Label 25053: @2024804
      GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(2024908), // Rule ID 24927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24927,
        GIR_EraseRootFromParent_Done,
      // Label 25054: @2024908
      GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(2025012), // Rule ID 24930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24930,
        GIR_EraseRootFromParent_Done,
      // Label 25055: @2025012
      GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(2025116), // Rule ID 24931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24931,
        GIR_EraseRootFromParent_Done,
      // Label 25056: @2025116
      GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(2025220), // Rule ID 24934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24934,
        GIR_EraseRootFromParent_Done,
      // Label 25057: @2025220
      GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(2025324), // Rule ID 24935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24935,
        GIR_EraseRootFromParent_Done,
      // Label 25058: @2025324
      GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(2025428), // Rule ID 60346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60346,
        GIR_EraseRootFromParent_Done,
      // Label 25059: @2025428
      GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(2025532), // Rule ID 60347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60347,
        GIR_EraseRootFromParent_Done,
      // Label 25060: @2025532
      GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(2025636), // Rule ID 60350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60350,
        GIR_EraseRootFromParent_Done,
      // Label 25061: @2025636
      GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(2025740), // Rule ID 60351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60351,
        GIR_EraseRootFromParent_Done,
      // Label 25062: @2025740
      GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(2025844), // Rule ID 60354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60354,
        GIR_EraseRootFromParent_Done,
      // Label 25063: @2025844
      GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(2025948), // Rule ID 60355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60355,
        GIR_EraseRootFromParent_Done,
      // Label 25064: @2025948
      GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(2026052), // Rule ID 60358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60358,
        GIR_EraseRootFromParent_Done,
      // Label 25065: @2026052
      GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(2026156), // Rule ID 60359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60359,
        GIR_EraseRootFromParent_Done,
      // Label 25066: @2026156
      GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(2026260), // Rule ID 60362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60362,
        GIR_EraseRootFromParent_Done,
      // Label 25067: @2026260
      GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(2026364), // Rule ID 60363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60363,
        GIR_EraseRootFromParent_Done,
      // Label 25068: @2026364
      GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(2026468), // Rule ID 60366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60366,
        GIR_EraseRootFromParent_Done,
      // Label 25069: @2026468
      GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(2026572), // Rule ID 60367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60367,
        GIR_EraseRootFromParent_Done,
      // Label 25070: @2026572
      GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(2026676), // Rule ID 60370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60370,
        GIR_EraseRootFromParent_Done,
      // Label 25071: @2026676
      GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(2026780), // Rule ID 60371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60371,
        GIR_EraseRootFromParent_Done,
      // Label 25072: @2026780
      GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(2026884), // Rule ID 60374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60374,
        GIR_EraseRootFromParent_Done,
      // Label 25073: @2026884
      GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(2026988), // Rule ID 60375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60375,
        GIR_EraseRootFromParent_Done,
      // Label 25074: @2026988
      GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(2027092), // Rule ID 60378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60378,
        GIR_EraseRootFromParent_Done,
      // Label 25075: @2027092
      GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(2027196), // Rule ID 60379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60379,
        GIR_EraseRootFromParent_Done,
      // Label 25076: @2027196
      GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(2027300), // Rule ID 60382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60382,
        GIR_EraseRootFromParent_Done,
      // Label 25077: @2027300
      GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(2027404), // Rule ID 60383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60383,
        GIR_EraseRootFromParent_Done,
      // Label 25078: @2027404
      GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(2027508), // Rule ID 60386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60386,
        GIR_EraseRootFromParent_Done,
      // Label 25079: @2027508
      GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(2027612), // Rule ID 60387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60387,
        GIR_EraseRootFromParent_Done,
      // Label 25080: @2027612
      GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(2027716), // Rule ID 60390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60390,
        GIR_EraseRootFromParent_Done,
      // Label 25081: @2027716
      GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(2027820), // Rule ID 60391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60391,
        GIR_EraseRootFromParent_Done,
      // Label 25082: @2027820
      GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(2027924), // Rule ID 60394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60394,
        GIR_EraseRootFromParent_Done,
      // Label 25083: @2027924
      GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(2028028), // Rule ID 60395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60395,
        GIR_EraseRootFromParent_Done,
      // Label 25084: @2028028
      GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(2028132), // Rule ID 60398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60398,
        GIR_EraseRootFromParent_Done,
      // Label 25085: @2028132
      GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(2028236), // Rule ID 60399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60399,
        GIR_EraseRootFromParent_Done,
      // Label 25086: @2028236
      GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(2028340), // Rule ID 60402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60402,
        GIR_EraseRootFromParent_Done,
      // Label 25087: @2028340
      GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(2028444), // Rule ID 60403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60403,
        GIR_EraseRootFromParent_Done,
      // Label 25088: @2028444
      GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(2028548), // Rule ID 60406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60406,
        GIR_EraseRootFromParent_Done,
      // Label 25089: @2028548
      GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(2028652), // Rule ID 60407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60407,
        GIR_EraseRootFromParent_Done,
      // Label 25090: @2028652
      GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(2028756), // Rule ID 60414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60414,
        GIR_EraseRootFromParent_Done,
      // Label 25091: @2028756
      GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(2028860), // Rule ID 60415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60415,
        GIR_EraseRootFromParent_Done,
      // Label 25092: @2028860
      GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(2028964), // Rule ID 60422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60422,
        GIR_EraseRootFromParent_Done,
      // Label 25093: @2028964
      GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(2029068), // Rule ID 60423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60423,
        GIR_EraseRootFromParent_Done,
      // Label 25094: @2029068
      GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(2029172), // Rule ID 60430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60430,
        GIR_EraseRootFromParent_Done,
      // Label 25095: @2029172
      GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(2029276), // Rule ID 60431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60431,
        GIR_EraseRootFromParent_Done,
      // Label 25096: @2029276
      GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(2029380), // Rule ID 60438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60438,
        GIR_EraseRootFromParent_Done,
      // Label 25097: @2029380
      GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(2029484), // Rule ID 60439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60439,
        GIR_EraseRootFromParent_Done,
      // Label 25098: @2029484
      GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(2029588), // Rule ID 60446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60446,
        GIR_EraseRootFromParent_Done,
      // Label 25099: @2029588
      GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(2029692), // Rule ID 60447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60447,
        GIR_EraseRootFromParent_Done,
      // Label 25100: @2029692
      GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(2029796), // Rule ID 60454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60454,
        GIR_EraseRootFromParent_Done,
      // Label 25101: @2029796
      GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(2029900), // Rule ID 60455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60455,
        GIR_EraseRootFromParent_Done,
      // Label 25102: @2029900
      GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(2030004), // Rule ID 60462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60462,
        GIR_EraseRootFromParent_Done,
      // Label 25103: @2030004
      GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(2030108), // Rule ID 60463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60463,
        GIR_EraseRootFromParent_Done,
      // Label 25104: @2030108
      GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(2030212), // Rule ID 60470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60470,
        GIR_EraseRootFromParent_Done,
      // Label 25105: @2030212
      GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(2030316), // Rule ID 60471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60471,
        GIR_EraseRootFromParent_Done,
      // Label 25106: @2030316
      GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(2030420), // Rule ID 60478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60478,
        GIR_EraseRootFromParent_Done,
      // Label 25107: @2030420
      GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(2030524), // Rule ID 60479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60479,
        GIR_EraseRootFromParent_Done,
      // Label 25108: @2030524
      GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(2030628), // Rule ID 60486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60486,
        GIR_EraseRootFromParent_Done,
      // Label 25109: @2030628
      GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(2030732), // Rule ID 60487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60487,
        GIR_EraseRootFromParent_Done,
      // Label 25110: @2030732
      GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(2030836), // Rule ID 60494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60494,
        GIR_EraseRootFromParent_Done,
      // Label 25111: @2030836
      GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(2030940), // Rule ID 60495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60495,
        GIR_EraseRootFromParent_Done,
      // Label 25112: @2030940
      GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(2031044), // Rule ID 60502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60502,
        GIR_EraseRootFromParent_Done,
      // Label 25113: @2031044
      GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(2031148), // Rule ID 60503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60503,
        GIR_EraseRootFromParent_Done,
      // Label 25114: @2031148
      GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(2031252), // Rule ID 60510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60510,
        GIR_EraseRootFromParent_Done,
      // Label 25115: @2031252
      GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(2031356), // Rule ID 60511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60511,
        GIR_EraseRootFromParent_Done,
      // Label 25116: @2031356
      GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(2031460), // Rule ID 60518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60518,
        GIR_EraseRootFromParent_Done,
      // Label 25117: @2031460
      GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(2031564), // Rule ID 60519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60519,
        GIR_EraseRootFromParent_Done,
      // Label 25118: @2031564
      GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(2031668), // Rule ID 60526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10776:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60526,
        GIR_EraseRootFromParent_Done,
      // Label 25119: @2031668
      GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(2031772), // Rule ID 60527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10776:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60527,
        GIR_EraseRootFromParent_Done,
      // Label 25120: @2031772
      GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(2031876), // Rule ID 60530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10776:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60530,
        GIR_EraseRootFromParent_Done,
      // Label 25121: @2031876
      GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(2031980), // Rule ID 60531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10776:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60531,
        GIR_EraseRootFromParent_Done,
      // Label 25122: @2031980
      GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(2032084), // Rule ID 60534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10776:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60534,
        GIR_EraseRootFromParent_Done,
      // Label 25123: @2032084
      GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(2032188), // Rule ID 60535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10776:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60535,
        GIR_EraseRootFromParent_Done,
      // Label 25124: @2032188
      GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(2032292), // Rule ID 60538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10776:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60538,
        GIR_EraseRootFromParent_Done,
      // Label 25125: @2032292
      GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(2032396), // Rule ID 60539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10776:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60539,
        GIR_EraseRootFromParent_Done,
      // Label 25126: @2032396
      GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(2032500), // Rule ID 60542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10776:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60542,
        GIR_EraseRootFromParent_Done,
      // Label 25127: @2032500
      GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(2032604), // Rule ID 60543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10776:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60543,
        GIR_EraseRootFromParent_Done,
      // Label 25128: @2032604
      GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(2032708), // Rule ID 60546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10776:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60546,
        GIR_EraseRootFromParent_Done,
      // Label 25129: @2032708
      GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(2032812), // Rule ID 60547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10776:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60547,
        GIR_EraseRootFromParent_Done,
      // Label 25130: @2032812
      GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(2032916), // Rule ID 60550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10776:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60550,
        GIR_EraseRootFromParent_Done,
      // Label 25131: @2032916
      GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(2033020), // Rule ID 60551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10776:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60551,
        GIR_EraseRootFromParent_Done,
      // Label 25132: @2033020
      GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(2033124), // Rule ID 60554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10776:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60554,
        GIR_EraseRootFromParent_Done,
      // Label 25133: @2033124
      GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(2033228), // Rule ID 60555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10776:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60555,
        GIR_EraseRootFromParent_Done,
      // Label 25134: @2033228
      GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(2033332), // Rule ID 60558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10778:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60558,
        GIR_EraseRootFromParent_Done,
      // Label 25135: @2033332
      GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(2033436), // Rule ID 60559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10778:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60559,
        GIR_EraseRootFromParent_Done,
      // Label 25136: @2033436
      GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(2033540), // Rule ID 60562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10778:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60562,
        GIR_EraseRootFromParent_Done,
      // Label 25137: @2033540
      GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(2033644), // Rule ID 60563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10778:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60563,
        GIR_EraseRootFromParent_Done,
      // Label 25138: @2033644
      GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(2033748), // Rule ID 60566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10778:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60566,
        GIR_EraseRootFromParent_Done,
      // Label 25139: @2033748
      GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(2033852), // Rule ID 60567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10778:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60567,
        GIR_EraseRootFromParent_Done,
      // Label 25140: @2033852
      GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(2033956), // Rule ID 60570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10778:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60570,
        GIR_EraseRootFromParent_Done,
      // Label 25141: @2033956
      GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(2034060), // Rule ID 60571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10778:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60571,
        GIR_EraseRootFromParent_Done,
      // Label 25142: @2034060
      GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(2034164), // Rule ID 60574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10778:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60574,
        GIR_EraseRootFromParent_Done,
      // Label 25143: @2034164
      GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(2034268), // Rule ID 60575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10778:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60575,
        GIR_EraseRootFromParent_Done,
      // Label 25144: @2034268
      GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(2034372), // Rule ID 60578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10778:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60578,
        GIR_EraseRootFromParent_Done,
      // Label 25145: @2034372
      GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(2034476), // Rule ID 60579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10778:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60579,
        GIR_EraseRootFromParent_Done,
      // Label 25146: @2034476
      GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(2034580), // Rule ID 60582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10778:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60582,
        GIR_EraseRootFromParent_Done,
      // Label 25147: @2034580
      GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(2034684), // Rule ID 60583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10778:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60583,
        GIR_EraseRootFromParent_Done,
      // Label 25148: @2034684
      GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(2034788), // Rule ID 60586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10778:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60586,
        GIR_EraseRootFromParent_Done,
      // Label 25149: @2034788
      GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(2034892), // Rule ID 60587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10778:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60587,
        GIR_EraseRootFromParent_Done,
      // Label 25150: @2034892
      GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(2034996), // Rule ID 60590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60590,
        GIR_EraseRootFromParent_Done,
      // Label 25151: @2034996
      GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(2035100), // Rule ID 60591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60591,
        GIR_EraseRootFromParent_Done,
      // Label 25152: @2035100
      GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(2035204), // Rule ID 60594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60594,
        GIR_EraseRootFromParent_Done,
      // Label 25153: @2035204
      GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(2035308), // Rule ID 60595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60595,
        GIR_EraseRootFromParent_Done,
      // Label 25154: @2035308
      GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(2035412), // Rule ID 60598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60598,
        GIR_EraseRootFromParent_Done,
      // Label 25155: @2035412
      GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(2035516), // Rule ID 60599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60599,
        GIR_EraseRootFromParent_Done,
      // Label 25156: @2035516
      GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(2035620), // Rule ID 60602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60602,
        GIR_EraseRootFromParent_Done,
      // Label 25157: @2035620
      GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(2035724), // Rule ID 60603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60603,
        GIR_EraseRootFromParent_Done,
      // Label 25158: @2035724
      GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(2035828), // Rule ID 60606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60606,
        GIR_EraseRootFromParent_Done,
      // Label 25159: @2035828
      GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(2035932), // Rule ID 60607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60607,
        GIR_EraseRootFromParent_Done,
      // Label 25160: @2035932
      GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(2036036), // Rule ID 60610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60610,
        GIR_EraseRootFromParent_Done,
      // Label 25161: @2036036
      GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(2036140), // Rule ID 60611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60611,
        GIR_EraseRootFromParent_Done,
      // Label 25162: @2036140
      GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(2036244), // Rule ID 60614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60614,
        GIR_EraseRootFromParent_Done,
      // Label 25163: @2036244
      GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(2036348), // Rule ID 60615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60615,
        GIR_EraseRootFromParent_Done,
      // Label 25164: @2036348
      GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(2036452), // Rule ID 60618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60618,
        GIR_EraseRootFromParent_Done,
      // Label 25165: @2036452
      GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(2036556), // Rule ID 60619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60619,
        GIR_EraseRootFromParent_Done,
      // Label 25166: @2036556
      GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(2036660), // Rule ID 60622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60622,
        GIR_EraseRootFromParent_Done,
      // Label 25167: @2036660
      GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(2036764), // Rule ID 60623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60623,
        GIR_EraseRootFromParent_Done,
      // Label 25168: @2036764
      GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(2036868), // Rule ID 60626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60626,
        GIR_EraseRootFromParent_Done,
      // Label 25169: @2036868
      GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(2036972), // Rule ID 60627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60627,
        GIR_EraseRootFromParent_Done,
      // Label 25170: @2036972
      GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(2037076), // Rule ID 60630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60630,
        GIR_EraseRootFromParent_Done,
      // Label 25171: @2037076
      GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(2037180), // Rule ID 60631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60631,
        GIR_EraseRootFromParent_Done,
      // Label 25172: @2037180
      GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(2037284), // Rule ID 60634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60634,
        GIR_EraseRootFromParent_Done,
      // Label 25173: @2037284
      GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(2037388), // Rule ID 60635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60635,
        GIR_EraseRootFromParent_Done,
      // Label 25174: @2037388
      GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(2037492), // Rule ID 60638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60638,
        GIR_EraseRootFromParent_Done,
      // Label 25175: @2037492
      GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(2037596), // Rule ID 60639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60639,
        GIR_EraseRootFromParent_Done,
      // Label 25176: @2037596
      GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(2037700), // Rule ID 60642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60642,
        GIR_EraseRootFromParent_Done,
      // Label 25177: @2037700
      GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(2037804), // Rule ID 60643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60643,
        GIR_EraseRootFromParent_Done,
      // Label 25178: @2037804
      GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(2037908), // Rule ID 60646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60646,
        GIR_EraseRootFromParent_Done,
      // Label 25179: @2037908
      GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(2038012), // Rule ID 60647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60647,
        GIR_EraseRootFromParent_Done,
      // Label 25180: @2038012
      GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(2038116), // Rule ID 60650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60650,
        GIR_EraseRootFromParent_Done,
      // Label 25181: @2038116
      GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(2038220), // Rule ID 60651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60651,
        GIR_EraseRootFromParent_Done,
      // Label 25182: @2038220
      GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(2038324), // Rule ID 60654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60654,
        GIR_EraseRootFromParent_Done,
      // Label 25183: @2038324
      GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(2038428), // Rule ID 60655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60655,
        GIR_EraseRootFromParent_Done,
      // Label 25184: @2038428
      GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(2038532), // Rule ID 60658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60658,
        GIR_EraseRootFromParent_Done,
      // Label 25185: @2038532
      GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(2038636), // Rule ID 60659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60659,
        GIR_EraseRootFromParent_Done,
      // Label 25186: @2038636
      GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(2038740), // Rule ID 60662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60662,
        GIR_EraseRootFromParent_Done,
      // Label 25187: @2038740
      GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(2038844), // Rule ID 60663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60663,
        GIR_EraseRootFromParent_Done,
      // Label 25188: @2038844
      GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(2038948), // Rule ID 60666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60666,
        GIR_EraseRootFromParent_Done,
      // Label 25189: @2038948
      GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(2039052), // Rule ID 60667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60667,
        GIR_EraseRootFromParent_Done,
      // Label 25190: @2039052
      GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(2039156), // Rule ID 60670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60670,
        GIR_EraseRootFromParent_Done,
      // Label 25191: @2039156
      GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(2039260), // Rule ID 60671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60671,
        GIR_EraseRootFromParent_Done,
      // Label 25192: @2039260
      GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(2039364), // Rule ID 60674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60674,
        GIR_EraseRootFromParent_Done,
      // Label 25193: @2039364
      GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(2039468), // Rule ID 60675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60675,
        GIR_EraseRootFromParent_Done,
      // Label 25194: @2039468
      GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(2039572), // Rule ID 60678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60678,
        GIR_EraseRootFromParent_Done,
      // Label 25195: @2039572
      GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(2039676), // Rule ID 60679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60679,
        GIR_EraseRootFromParent_Done,
      // Label 25196: @2039676
      GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(2039780), // Rule ID 60682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60682,
        GIR_EraseRootFromParent_Done,
      // Label 25197: @2039780
      GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(2039884), // Rule ID 60683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60683,
        GIR_EraseRootFromParent_Done,
      // Label 25198: @2039884
      GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(2039988), // Rule ID 60686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60686,
        GIR_EraseRootFromParent_Done,
      // Label 25199: @2039988
      GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(2040092), // Rule ID 60687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60687,
        GIR_EraseRootFromParent_Done,
      // Label 25200: @2040092
      GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(2040196), // Rule ID 60690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60690,
        GIR_EraseRootFromParent_Done,
      // Label 25201: @2040196
      GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(2040300), // Rule ID 60691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60691,
        GIR_EraseRootFromParent_Done,
      // Label 25202: @2040300
      GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(2040404), // Rule ID 60694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60694,
        GIR_EraseRootFromParent_Done,
      // Label 25203: @2040404
      GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(2040508), // Rule ID 60695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60695,
        GIR_EraseRootFromParent_Done,
      // Label 25204: @2040508
      GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(2040612), // Rule ID 60698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60698,
        GIR_EraseRootFromParent_Done,
      // Label 25205: @2040612
      GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(2040716), // Rule ID 60699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60699,
        GIR_EraseRootFromParent_Done,
      // Label 25206: @2040716
      GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(2040820), // Rule ID 60702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60702,
        GIR_EraseRootFromParent_Done,
      // Label 25207: @2040820
      GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(2040924), // Rule ID 60703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10766:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60703,
        GIR_EraseRootFromParent_Done,
      // Label 25208: @2040924
      GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(2041028), // Rule ID 60706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60706,
        GIR_EraseRootFromParent_Done,
      // Label 25209: @2041028
      GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(2041132), // Rule ID 60707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10766:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60707,
        GIR_EraseRootFromParent_Done,
      // Label 25210: @2041132
      GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(2041236), // Rule ID 60710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60710,
        GIR_EraseRootFromParent_Done,
      // Label 25211: @2041236
      GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(2041340), // Rule ID 60711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10766:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60711,
        GIR_EraseRootFromParent_Done,
      // Label 25212: @2041340
      GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(2041444), // Rule ID 60714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60714,
        GIR_EraseRootFromParent_Done,
      // Label 25213: @2041444
      GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(2041548), // Rule ID 60715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10766:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60715,
        GIR_EraseRootFromParent_Done,
      // Label 25214: @2041548
      GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(2041652), // Rule ID 60718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60718,
        GIR_EraseRootFromParent_Done,
      // Label 25215: @2041652
      GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(2041756), // Rule ID 60719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60719,
        GIR_EraseRootFromParent_Done,
      // Label 25216: @2041756
      GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(2041860), // Rule ID 60722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60722,
        GIR_EraseRootFromParent_Done,
      // Label 25217: @2041860
      GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(2041964), // Rule ID 60723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60723,
        GIR_EraseRootFromParent_Done,
      // Label 25218: @2041964
      GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(2042068), // Rule ID 60726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60726,
        GIR_EraseRootFromParent_Done,
      // Label 25219: @2042068
      GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(2042172), // Rule ID 60727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60727,
        GIR_EraseRootFromParent_Done,
      // Label 25220: @2042172
      GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(2042276), // Rule ID 60730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60730,
        GIR_EraseRootFromParent_Done,
      // Label 25221: @2042276
      GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(2042380), // Rule ID 60731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60731,
        GIR_EraseRootFromParent_Done,
      // Label 25222: @2042380
      GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(2042484), // Rule ID 60734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60734,
        GIR_EraseRootFromParent_Done,
      // Label 25223: @2042484
      GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(2042588), // Rule ID 60735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60735,
        GIR_EraseRootFromParent_Done,
      // Label 25224: @2042588
      GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(2042692), // Rule ID 60738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60738,
        GIR_EraseRootFromParent_Done,
      // Label 25225: @2042692
      GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(2042796), // Rule ID 60739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60739,
        GIR_EraseRootFromParent_Done,
      // Label 25226: @2042796
      GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(2042900), // Rule ID 60742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60742,
        GIR_EraseRootFromParent_Done,
      // Label 25227: @2042900
      GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(2043004), // Rule ID 60743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60743,
        GIR_EraseRootFromParent_Done,
      // Label 25228: @2043004
      GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(2043108), // Rule ID 60746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60746,
        GIR_EraseRootFromParent_Done,
      // Label 25229: @2043108
      GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(2043212), // Rule ID 60747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60747,
        GIR_EraseRootFromParent_Done,
      // Label 25230: @2043212
      GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(2043316), // Rule ID 60750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60750,
        GIR_EraseRootFromParent_Done,
      // Label 25231: @2043316
      GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(2043420), // Rule ID 60751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60751,
        GIR_EraseRootFromParent_Done,
      // Label 25232: @2043420
      GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(2043524), // Rule ID 60754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60754,
        GIR_EraseRootFromParent_Done,
      // Label 25233: @2043524
      GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(2043628), // Rule ID 60755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10766:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60755,
        GIR_EraseRootFromParent_Done,
      // Label 25234: @2043628
      GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(2043732), // Rule ID 60758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60758,
        GIR_EraseRootFromParent_Done,
      // Label 25235: @2043732
      GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(2043836), // Rule ID 60759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10766:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60759,
        GIR_EraseRootFromParent_Done,
      // Label 25236: @2043836
      GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(2043940), // Rule ID 60762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60762,
        GIR_EraseRootFromParent_Done,
      // Label 25237: @2043940
      GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(2044044), // Rule ID 60763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10766:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60763,
        GIR_EraseRootFromParent_Done,
      // Label 25238: @2044044
      GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(2044148), // Rule ID 60942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60942,
        GIR_EraseRootFromParent_Done,
      // Label 25239: @2044148
      GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(2044252), // Rule ID 60943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60943,
        GIR_EraseRootFromParent_Done,
      // Label 25240: @2044252
      GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(2044356), // Rule ID 60946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60946,
        GIR_EraseRootFromParent_Done,
      // Label 25241: @2044356
      GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(2044460), // Rule ID 60947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60947,
        GIR_EraseRootFromParent_Done,
      // Label 25242: @2044460
      GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(2044564), // Rule ID 60950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60950,
        GIR_EraseRootFromParent_Done,
      // Label 25243: @2044564
      GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(2044668), // Rule ID 60951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60951,
        GIR_EraseRootFromParent_Done,
      // Label 25244: @2044668
      GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(2044772), // Rule ID 60954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60954,
        GIR_EraseRootFromParent_Done,
      // Label 25245: @2044772
      GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(2044876), // Rule ID 60955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60955,
        GIR_EraseRootFromParent_Done,
      // Label 25246: @2044876
      GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(2044980), // Rule ID 60958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60958,
        GIR_EraseRootFromParent_Done,
      // Label 25247: @2044980
      GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(2045084), // Rule ID 60959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60959,
        GIR_EraseRootFromParent_Done,
      // Label 25248: @2045084
      GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(2045188), // Rule ID 60962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60962,
        GIR_EraseRootFromParent_Done,
      // Label 25249: @2045188
      GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(2045292), // Rule ID 60963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60963,
        GIR_EraseRootFromParent_Done,
      // Label 25250: @2045292
      GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(2045396), // Rule ID 60966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60966,
        GIR_EraseRootFromParent_Done,
      // Label 25251: @2045396
      GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(2045500), // Rule ID 60967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60967,
        GIR_EraseRootFromParent_Done,
      // Label 25252: @2045500
      GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(2045604), // Rule ID 60970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60970,
        GIR_EraseRootFromParent_Done,
      // Label 25253: @2045604
      GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(2045708), // Rule ID 60971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60971,
        GIR_EraseRootFromParent_Done,
      // Label 25254: @2045708
      GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(2045812), // Rule ID 60974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60974,
        GIR_EraseRootFromParent_Done,
      // Label 25255: @2045812
      GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(2045916), // Rule ID 60975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60975,
        GIR_EraseRootFromParent_Done,
      // Label 25256: @2045916
      GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(2046020), // Rule ID 60978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60978,
        GIR_EraseRootFromParent_Done,
      // Label 25257: @2046020
      GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(2046124), // Rule ID 60979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60979,
        GIR_EraseRootFromParent_Done,
      // Label 25258: @2046124
      GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(2046228), // Rule ID 60982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60982,
        GIR_EraseRootFromParent_Done,
      // Label 25259: @2046228
      GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(2046332), // Rule ID 60983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60983,
        GIR_EraseRootFromParent_Done,
      // Label 25260: @2046332
      GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(2046436), // Rule ID 60986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60986,
        GIR_EraseRootFromParent_Done,
      // Label 25261: @2046436
      GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(2046540), // Rule ID 60987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60987,
        GIR_EraseRootFromParent_Done,
      // Label 25262: @2046540
      GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(2046644), // Rule ID 60990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60990,
        GIR_EraseRootFromParent_Done,
      // Label 25263: @2046644
      GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(2046748), // Rule ID 60991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60991,
        GIR_EraseRootFromParent_Done,
      // Label 25264: @2046748
      GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(2046852), // Rule ID 60994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60994,
        GIR_EraseRootFromParent_Done,
      // Label 25265: @2046852
      GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(2046956), // Rule ID 60995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60995,
        GIR_EraseRootFromParent_Done,
      // Label 25266: @2046956
      GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(2047060), // Rule ID 60998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60998,
        GIR_EraseRootFromParent_Done,
      // Label 25267: @2047060
      GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(2047164), // Rule ID 60999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60999,
        GIR_EraseRootFromParent_Done,
      // Label 25268: @2047164
      GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(2047268), // Rule ID 61002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61002,
        GIR_EraseRootFromParent_Done,
      // Label 25269: @2047268
      GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(2047372), // Rule ID 61003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61003,
        GIR_EraseRootFromParent_Done,
      // Label 25270: @2047372
      GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(2047476), // Rule ID 61006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61006,
        GIR_EraseRootFromParent_Done,
      // Label 25271: @2047476
      GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(2047580), // Rule ID 61007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61007,
        GIR_EraseRootFromParent_Done,
      // Label 25272: @2047580
      GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(2047684), // Rule ID 61010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61010,
        GIR_EraseRootFromParent_Done,
      // Label 25273: @2047684
      GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(2047788), // Rule ID 61011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61011,
        GIR_EraseRootFromParent_Done,
      // Label 25274: @2047788
      GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(2047892), // Rule ID 61014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61014,
        GIR_EraseRootFromParent_Done,
      // Label 25275: @2047892
      GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(2047996), // Rule ID 61015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61015,
        GIR_EraseRootFromParent_Done,
      // Label 25276: @2047996
      GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(2048100), // Rule ID 61018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61018,
        GIR_EraseRootFromParent_Done,
      // Label 25277: @2048100
      GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(2048204), // Rule ID 61019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61019,
        GIR_EraseRootFromParent_Done,
      // Label 25278: @2048204
      GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(2048308), // Rule ID 61022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61022,
        GIR_EraseRootFromParent_Done,
      // Label 25279: @2048308
      GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(2048412), // Rule ID 61023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61023,
        GIR_EraseRootFromParent_Done,
      // Label 25280: @2048412
      GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(2048516), // Rule ID 61026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61026,
        GIR_EraseRootFromParent_Done,
      // Label 25281: @2048516
      GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(2048620), // Rule ID 61027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61027,
        GIR_EraseRootFromParent_Done,
      // Label 25282: @2048620
      GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(2048724), // Rule ID 61030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61030,
        GIR_EraseRootFromParent_Done,
      // Label 25283: @2048724
      GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(2048828), // Rule ID 61031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61031,
        GIR_EraseRootFromParent_Done,
      // Label 25284: @2048828
      GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(2048932), // Rule ID 61034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61034,
        GIR_EraseRootFromParent_Done,
      // Label 25285: @2048932
      GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(2049036), // Rule ID 61035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61035,
        GIR_EraseRootFromParent_Done,
      // Label 25286: @2049036
      GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(2049140), // Rule ID 61038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61038,
        GIR_EraseRootFromParent_Done,
      // Label 25287: @2049140
      GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(2049244), // Rule ID 61039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61039,
        GIR_EraseRootFromParent_Done,
      // Label 25288: @2049244
      GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(2049348), // Rule ID 61042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61042,
        GIR_EraseRootFromParent_Done,
      // Label 25289: @2049348
      GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(2049452), // Rule ID 61043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61043,
        GIR_EraseRootFromParent_Done,
      // Label 25290: @2049452
      GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(2049556), // Rule ID 61046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61046,
        GIR_EraseRootFromParent_Done,
      // Label 25291: @2049556
      GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(2049660), // Rule ID 61047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61047,
        GIR_EraseRootFromParent_Done,
      // Label 25292: @2049660
      GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(2049764), // Rule ID 61050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61050,
        GIR_EraseRootFromParent_Done,
      // Label 25293: @2049764
      GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(2049868), // Rule ID 61051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61051,
        GIR_EraseRootFromParent_Done,
      // Label 25294: @2049868
      GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(2049972), // Rule ID 61054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61054,
        GIR_EraseRootFromParent_Done,
      // Label 25295: @2049972
      GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(2050076), // Rule ID 61055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61055,
        GIR_EraseRootFromParent_Done,
      // Label 25296: @2050076
      GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(2050180), // Rule ID 61058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61058,
        GIR_EraseRootFromParent_Done,
      // Label 25297: @2050180
      GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(2050284), // Rule ID 61059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61059,
        GIR_EraseRootFromParent_Done,
      // Label 25298: @2050284
      GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(2050388), // Rule ID 61062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61062,
        GIR_EraseRootFromParent_Done,
      // Label 25299: @2050388
      GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(2050492), // Rule ID 61063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61063,
        GIR_EraseRootFromParent_Done,
      // Label 25300: @2050492
      GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(2050596), // Rule ID 61066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61066,
        GIR_EraseRootFromParent_Done,
      // Label 25301: @2050596
      GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(2050700), // Rule ID 61067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61067,
        GIR_EraseRootFromParent_Done,
      // Label 25302: @2050700
      GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(2050804), // Rule ID 61070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61070,
        GIR_EraseRootFromParent_Done,
      // Label 25303: @2050804
      GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(2050908), // Rule ID 61071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61071,
        GIR_EraseRootFromParent_Done,
      // Label 25304: @2050908
      GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(2051012), // Rule ID 61074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61074,
        GIR_EraseRootFromParent_Done,
      // Label 25305: @2051012
      GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(2051116), // Rule ID 61075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61075,
        GIR_EraseRootFromParent_Done,
      // Label 25306: @2051116
      GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(2051220), // Rule ID 61078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61078,
        GIR_EraseRootFromParent_Done,
      // Label 25307: @2051220
      GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(2051324), // Rule ID 61079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61079,
        GIR_EraseRootFromParent_Done,
      // Label 25308: @2051324
      GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(2051428), // Rule ID 61082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61082,
        GIR_EraseRootFromParent_Done,
      // Label 25309: @2051428
      GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(2051532), // Rule ID 61083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61083,
        GIR_EraseRootFromParent_Done,
      // Label 25310: @2051532
      GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(2051636), // Rule ID 61086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61086,
        GIR_EraseRootFromParent_Done,
      // Label 25311: @2051636
      GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(2051740), // Rule ID 61087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61087,
        GIR_EraseRootFromParent_Done,
      // Label 25312: @2051740
      GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(2051844), // Rule ID 61090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61090,
        GIR_EraseRootFromParent_Done,
      // Label 25313: @2051844
      GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(2051948), // Rule ID 61091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61091,
        GIR_EraseRootFromParent_Done,
      // Label 25314: @2051948
      GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(2052052), // Rule ID 61094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61094,
        GIR_EraseRootFromParent_Done,
      // Label 25315: @2052052
      GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(2052156), // Rule ID 61095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61095,
        GIR_EraseRootFromParent_Done,
      // Label 25316: @2052156
      GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(2052260), // Rule ID 61098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61098,
        GIR_EraseRootFromParent_Done,
      // Label 25317: @2052260
      GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(2052364), // Rule ID 61099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61099,
        GIR_EraseRootFromParent_Done,
      // Label 25318: @2052364
      GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(2052468), // Rule ID 61102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61102,
        GIR_EraseRootFromParent_Done,
      // Label 25319: @2052468
      GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(2052572), // Rule ID 61103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61103,
        GIR_EraseRootFromParent_Done,
      // Label 25320: @2052572
      GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(2052676), // Rule ID 61106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61106,
        GIR_EraseRootFromParent_Done,
      // Label 25321: @2052676
      GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(2052780), // Rule ID 61107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61107,
        GIR_EraseRootFromParent_Done,
      // Label 25322: @2052780
      GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(2052884), // Rule ID 61110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61110,
        GIR_EraseRootFromParent_Done,
      // Label 25323: @2052884
      GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(2052988), // Rule ID 61111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61111,
        GIR_EraseRootFromParent_Done,
      // Label 25324: @2052988
      GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(2053092), // Rule ID 61114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61114,
        GIR_EraseRootFromParent_Done,
      // Label 25325: @2053092
      GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(2053196), // Rule ID 61115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61115,
        GIR_EraseRootFromParent_Done,
      // Label 25326: @2053196
      GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(2053300), // Rule ID 61202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61202,
        GIR_EraseRootFromParent_Done,
      // Label 25327: @2053300
      GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(2053404), // Rule ID 61203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61203,
        GIR_EraseRootFromParent_Done,
      // Label 25328: @2053404
      GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(2053508), // Rule ID 61206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61206,
        GIR_EraseRootFromParent_Done,
      // Label 25329: @2053508
      GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(2053612), // Rule ID 61207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61207,
        GIR_EraseRootFromParent_Done,
      // Label 25330: @2053612
      GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(2053716), // Rule ID 61210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61210,
        GIR_EraseRootFromParent_Done,
      // Label 25331: @2053716
      GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(2053820), // Rule ID 61211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61211,
        GIR_EraseRootFromParent_Done,
      // Label 25332: @2053820
      GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(2053924), // Rule ID 61214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61214,
        GIR_EraseRootFromParent_Done,
      // Label 25333: @2053924
      GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(2054028), // Rule ID 61215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61215,
        GIR_EraseRootFromParent_Done,
      // Label 25334: @2054028
      GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(2054132), // Rule ID 61218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61218,
        GIR_EraseRootFromParent_Done,
      // Label 25335: @2054132
      GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(2054236), // Rule ID 61219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61219,
        GIR_EraseRootFromParent_Done,
      // Label 25336: @2054236
      GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(2054340), // Rule ID 61222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61222,
        GIR_EraseRootFromParent_Done,
      // Label 25337: @2054340
      GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(2054444), // Rule ID 61223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61223,
        GIR_EraseRootFromParent_Done,
      // Label 25338: @2054444
      GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(2054548), // Rule ID 61226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61226,
        GIR_EraseRootFromParent_Done,
      // Label 25339: @2054548
      GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(2054652), // Rule ID 61227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61227,
        GIR_EraseRootFromParent_Done,
      // Label 25340: @2054652
      GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(2054756), // Rule ID 61230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61230,
        GIR_EraseRootFromParent_Done,
      // Label 25341: @2054756
      GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(2054860), // Rule ID 61231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61231,
        GIR_EraseRootFromParent_Done,
      // Label 25342: @2054860
      GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(2054964), // Rule ID 61234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61234,
        GIR_EraseRootFromParent_Done,
      // Label 25343: @2054964
      GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(2055068), // Rule ID 61235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61235,
        GIR_EraseRootFromParent_Done,
      // Label 25344: @2055068
      GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(2055172), // Rule ID 61238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61238,
        GIR_EraseRootFromParent_Done,
      // Label 25345: @2055172
      GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(2055276), // Rule ID 61239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61239,
        GIR_EraseRootFromParent_Done,
      // Label 25346: @2055276
      GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(2055380), // Rule ID 61242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61242,
        GIR_EraseRootFromParent_Done,
      // Label 25347: @2055380
      GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(2055484), // Rule ID 61243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61243,
        GIR_EraseRootFromParent_Done,
      // Label 25348: @2055484
      GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(2055588), // Rule ID 61246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61246,
        GIR_EraseRootFromParent_Done,
      // Label 25349: @2055588
      GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(2055692), // Rule ID 61247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61247,
        GIR_EraseRootFromParent_Done,
      // Label 25350: @2055692
      GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(2055796), // Rule ID 61250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61250,
        GIR_EraseRootFromParent_Done,
      // Label 25351: @2055796
      GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(2055900), // Rule ID 61251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61251,
        GIR_EraseRootFromParent_Done,
      // Label 25352: @2055900
      GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(2056004), // Rule ID 61254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61254,
        GIR_EraseRootFromParent_Done,
      // Label 25353: @2056004
      GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(2056108), // Rule ID 61255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61255,
        GIR_EraseRootFromParent_Done,
      // Label 25354: @2056108
      GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(2056212), // Rule ID 61258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61258,
        GIR_EraseRootFromParent_Done,
      // Label 25355: @2056212
      GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(2056316), // Rule ID 61259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61259,
        GIR_EraseRootFromParent_Done,
      // Label 25356: @2056316
      GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(2056420), // Rule ID 61262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61262,
        GIR_EraseRootFromParent_Done,
      // Label 25357: @2056420
      GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(2056524), // Rule ID 61263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61263,
        GIR_EraseRootFromParent_Done,
      // Label 25358: @2056524
      GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(2056628), // Rule ID 61266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61266,
        GIR_EraseRootFromParent_Done,
      // Label 25359: @2056628
      GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(2056732), // Rule ID 61267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61267,
        GIR_EraseRootFromParent_Done,
      // Label 25360: @2056732
      GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(2056836), // Rule ID 61270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61270,
        GIR_EraseRootFromParent_Done,
      // Label 25361: @2056836
      GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(2056940), // Rule ID 61271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61271,
        GIR_EraseRootFromParent_Done,
      // Label 25362: @2056940
      GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(2057044), // Rule ID 61274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61274,
        GIR_EraseRootFromParent_Done,
      // Label 25363: @2057044
      GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(2057148), // Rule ID 61275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61275,
        GIR_EraseRootFromParent_Done,
      // Label 25364: @2057148
      GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(2057252), // Rule ID 61278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61278,
        GIR_EraseRootFromParent_Done,
      // Label 25365: @2057252
      GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(2057356), // Rule ID 61279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61279,
        GIR_EraseRootFromParent_Done,
      // Label 25366: @2057356
      GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(2057460), // Rule ID 61282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61282,
        GIR_EraseRootFromParent_Done,
      // Label 25367: @2057460
      GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(2057564), // Rule ID 61283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61283,
        GIR_EraseRootFromParent_Done,
      // Label 25368: @2057564
      GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(2057668), // Rule ID 61286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61286,
        GIR_EraseRootFromParent_Done,
      // Label 25369: @2057668
      GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(2057772), // Rule ID 61287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61287,
        GIR_EraseRootFromParent_Done,
      // Label 25370: @2057772
      GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(2057876), // Rule ID 61290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61290,
        GIR_EraseRootFromParent_Done,
      // Label 25371: @2057876
      GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(2057980), // Rule ID 61291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61291,
        GIR_EraseRootFromParent_Done,
      // Label 25372: @2057980
      GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(2058084), // Rule ID 61294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61294,
        GIR_EraseRootFromParent_Done,
      // Label 25373: @2058084
      GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(2058188), // Rule ID 61295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61295,
        GIR_EraseRootFromParent_Done,
      // Label 25374: @2058188
      GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(2058292), // Rule ID 61298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61298,
        GIR_EraseRootFromParent_Done,
      // Label 25375: @2058292
      GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(2058396), // Rule ID 61299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61299,
        GIR_EraseRootFromParent_Done,
      // Label 25376: @2058396
      GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(2058500), // Rule ID 61302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61302,
        GIR_EraseRootFromParent_Done,
      // Label 25377: @2058500
      GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(2058604), // Rule ID 61303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61303,
        GIR_EraseRootFromParent_Done,
      // Label 25378: @2058604
      GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(2058708), // Rule ID 61306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61306,
        GIR_EraseRootFromParent_Done,
      // Label 25379: @2058708
      GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(2058812), // Rule ID 61307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61307,
        GIR_EraseRootFromParent_Done,
      // Label 25380: @2058812
      GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(2058916), // Rule ID 61310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61310,
        GIR_EraseRootFromParent_Done,
      // Label 25381: @2058916
      GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(2059020), // Rule ID 61311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61311,
        GIR_EraseRootFromParent_Done,
      // Label 25382: @2059020
      GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(2059124), // Rule ID 61314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61314,
        GIR_EraseRootFromParent_Done,
      // Label 25383: @2059124
      GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(2059228), // Rule ID 61315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61315,
        GIR_EraseRootFromParent_Done,
      // Label 25384: @2059228
      GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(2059332), // Rule ID 61318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61318,
        GIR_EraseRootFromParent_Done,
      // Label 25385: @2059332
      GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(2059436), // Rule ID 61319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61319,
        GIR_EraseRootFromParent_Done,
      // Label 25386: @2059436
      GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(2059540), // Rule ID 61322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61322,
        GIR_EraseRootFromParent_Done,
      // Label 25387: @2059540
      GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(2059644), // Rule ID 61323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61323,
        GIR_EraseRootFromParent_Done,
      // Label 25388: @2059644
      GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(2059748), // Rule ID 61326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61326,
        GIR_EraseRootFromParent_Done,
      // Label 25389: @2059748
      GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(2059852), // Rule ID 61327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61327,
        GIR_EraseRootFromParent_Done,
      // Label 25390: @2059852
      GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(2059956), // Rule ID 61330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61330,
        GIR_EraseRootFromParent_Done,
      // Label 25391: @2059956
      GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(2060060), // Rule ID 61331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61331,
        GIR_EraseRootFromParent_Done,
      // Label 25392: @2060060
      GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(2060164), // Rule ID 61334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61334,
        GIR_EraseRootFromParent_Done,
      // Label 25393: @2060164
      GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(2060268), // Rule ID 61335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61335,
        GIR_EraseRootFromParent_Done,
      // Label 25394: @2060268
      GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(2060372), // Rule ID 61338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61338,
        GIR_EraseRootFromParent_Done,
      // Label 25395: @2060372
      GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(2060476), // Rule ID 61339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61339,
        GIR_EraseRootFromParent_Done,
      // Label 25396: @2060476
      GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(2060580), // Rule ID 61342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61342,
        GIR_EraseRootFromParent_Done,
      // Label 25397: @2060580
      GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(2060684), // Rule ID 61343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61343,
        GIR_EraseRootFromParent_Done,
      // Label 25398: @2060684
      GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(2060788), // Rule ID 61346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61346,
        GIR_EraseRootFromParent_Done,
      // Label 25399: @2060788
      GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(2060892), // Rule ID 61347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61347,
        GIR_EraseRootFromParent_Done,
      // Label 25400: @2060892
      GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(2060996), // Rule ID 61350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61350,
        GIR_EraseRootFromParent_Done,
      // Label 25401: @2060996
      GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(2061100), // Rule ID 61351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61351,
        GIR_EraseRootFromParent_Done,
      // Label 25402: @2061100
      GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(2061204), // Rule ID 61354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61354,
        GIR_EraseRootFromParent_Done,
      // Label 25403: @2061204
      GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(2061308), // Rule ID 61355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61355,
        GIR_EraseRootFromParent_Done,
      // Label 25404: @2061308
      GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(2061412), // Rule ID 61358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61358,
        GIR_EraseRootFromParent_Done,
      // Label 25405: @2061412
      GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(2061516), // Rule ID 61359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61359,
        GIR_EraseRootFromParent_Done,
      // Label 25406: @2061516
      GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(2061620), // Rule ID 61362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61362,
        GIR_EraseRootFromParent_Done,
      // Label 25407: @2061620
      GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(2061724), // Rule ID 61363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61363,
        GIR_EraseRootFromParent_Done,
      // Label 25408: @2061724
      GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(2061828), // Rule ID 61366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61366,
        GIR_EraseRootFromParent_Done,
      // Label 25409: @2061828
      GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(2061932), // Rule ID 61367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61367,
        GIR_EraseRootFromParent_Done,
      // Label 25410: @2061932
      GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(2062036), // Rule ID 61370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61370,
        GIR_EraseRootFromParent_Done,
      // Label 25411: @2062036
      GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(2062140), // Rule ID 61371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61371,
        GIR_EraseRootFromParent_Done,
      // Label 25412: @2062140
      GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(2062244), // Rule ID 61374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61374,
        GIR_EraseRootFromParent_Done,
      // Label 25413: @2062244
      GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(2062348), // Rule ID 61375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61375,
        GIR_EraseRootFromParent_Done,
      // Label 25414: @2062348
      GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(2062452), // Rule ID 62016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10735:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62016,
        GIR_EraseRootFromParent_Done,
      // Label 25415: @2062452
      GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(2062556), // Rule ID 62017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10735:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62017,
        GIR_EraseRootFromParent_Done,
      // Label 25416: @2062556
      GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(2062660), // Rule ID 62020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10735:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62020,
        GIR_EraseRootFromParent_Done,
      // Label 25417: @2062660
      GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(2062764), // Rule ID 62021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10735:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62021,
        GIR_EraseRootFromParent_Done,
      // Label 25418: @2062764
      GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(2062868), // Rule ID 62024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10735:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62024,
        GIR_EraseRootFromParent_Done,
      // Label 25419: @2062868
      GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(2062972), // Rule ID 62025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10735:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62025,
        GIR_EraseRootFromParent_Done,
      // Label 25420: @2062972
      GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(2063076), // Rule ID 62028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10735:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62028,
        GIR_EraseRootFromParent_Done,
      // Label 25421: @2063076
      GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(2063180), // Rule ID 62029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10735:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62029,
        GIR_EraseRootFromParent_Done,
      // Label 25422: @2063180
      GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(2063284), // Rule ID 62032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10735:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62032,
        GIR_EraseRootFromParent_Done,
      // Label 25423: @2063284
      GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(2063388), // Rule ID 62033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10735:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62033,
        GIR_EraseRootFromParent_Done,
      // Label 25424: @2063388
      GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(2063492), // Rule ID 62036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10735:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62036,
        GIR_EraseRootFromParent_Done,
      // Label 25425: @2063492
      GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(2063596), // Rule ID 62037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10735:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62037,
        GIR_EraseRootFromParent_Done,
      // Label 25426: @2063596
      GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(2063700), // Rule ID 62040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10735:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62040,
        GIR_EraseRootFromParent_Done,
      // Label 25427: @2063700
      GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(2063804), // Rule ID 62041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10735:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62041,
        GIR_EraseRootFromParent_Done,
      // Label 25428: @2063804
      GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(2063908), // Rule ID 62044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10735:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62044,
        GIR_EraseRootFromParent_Done,
      // Label 25429: @2063908
      GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(2064012), // Rule ID 62045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10735:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62045,
        GIR_EraseRootFromParent_Done,
      // Label 25430: @2064012
      GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(2064116), // Rule ID 62048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10735:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62048,
        GIR_EraseRootFromParent_Done,
      // Label 25431: @2064116
      GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(2064220), // Rule ID 62049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10735:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62049,
        GIR_EraseRootFromParent_Done,
      // Label 25432: @2064220
      GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(2064324), // Rule ID 62052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10735:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62052,
        GIR_EraseRootFromParent_Done,
      // Label 25433: @2064324
      GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(2064428), // Rule ID 62053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10735:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62053,
        GIR_EraseRootFromParent_Done,
      // Label 25434: @2064428
      GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(2064532), // Rule ID 62056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10739:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62056,
        GIR_EraseRootFromParent_Done,
      // Label 25435: @2064532
      GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(2064636), // Rule ID 62057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10739:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62057,
        GIR_EraseRootFromParent_Done,
      // Label 25436: @2064636
      GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(2064740), // Rule ID 62060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10739:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62060,
        GIR_EraseRootFromParent_Done,
      // Label 25437: @2064740
      GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(2064844), // Rule ID 62061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10739:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62061,
        GIR_EraseRootFromParent_Done,
      // Label 25438: @2064844
      GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(2064948), // Rule ID 62064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10739:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62064,
        GIR_EraseRootFromParent_Done,
      // Label 25439: @2064948
      GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(2065052), // Rule ID 62065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10739:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62065,
        GIR_EraseRootFromParent_Done,
      // Label 25440: @2065052
      GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(2065156), // Rule ID 62068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10739:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62068,
        GIR_EraseRootFromParent_Done,
      // Label 25441: @2065156
      GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(2065260), // Rule ID 62069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10739:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62069,
        GIR_EraseRootFromParent_Done,
      // Label 25442: @2065260
      GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(2065364), // Rule ID 62072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10739:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62072,
        GIR_EraseRootFromParent_Done,
      // Label 25443: @2065364
      GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(2065468), // Rule ID 62073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10739:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62073,
        GIR_EraseRootFromParent_Done,
      // Label 25444: @2065468
      GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(2065572), // Rule ID 62076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10739:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62076,
        GIR_EraseRootFromParent_Done,
      // Label 25445: @2065572
      GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(2065676), // Rule ID 62077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10739:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62077,
        GIR_EraseRootFromParent_Done,
      // Label 25446: @2065676
      GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(2065780), // Rule ID 62080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10739:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62080,
        GIR_EraseRootFromParent_Done,
      // Label 25447: @2065780
      GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(2065884), // Rule ID 62081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10739:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62081,
        GIR_EraseRootFromParent_Done,
      // Label 25448: @2065884
      GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(2065988), // Rule ID 62084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10739:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62084,
        GIR_EraseRootFromParent_Done,
      // Label 25449: @2065988
      GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(2066092), // Rule ID 62085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10739:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62085,
        GIR_EraseRootFromParent_Done,
      // Label 25450: @2066092
      GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(2066196), // Rule ID 62088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10739:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62088,
        GIR_EraseRootFromParent_Done,
      // Label 25451: @2066196
      GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(2066300), // Rule ID 62089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10739:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62089,
        GIR_EraseRootFromParent_Done,
      // Label 25452: @2066300
      GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(2066404), // Rule ID 62092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10739:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62092,
        GIR_EraseRootFromParent_Done,
      // Label 25453: @2066404
      GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(2066508), // Rule ID 62093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10739:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62093,
        GIR_EraseRootFromParent_Done,
      // Label 25454: @2066508
      GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(2066612), // Rule ID 62096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10737:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62096,
        GIR_EraseRootFromParent_Done,
      // Label 25455: @2066612
      GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(2066716), // Rule ID 62097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10737:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62097,
        GIR_EraseRootFromParent_Done,
      // Label 25456: @2066716
      GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(2066820), // Rule ID 62100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10737:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62100,
        GIR_EraseRootFromParent_Done,
      // Label 25457: @2066820
      GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(2066924), // Rule ID 62101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10737:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62101,
        GIR_EraseRootFromParent_Done,
      // Label 25458: @2066924
      GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(2067028), // Rule ID 62104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10737:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62104,
        GIR_EraseRootFromParent_Done,
      // Label 25459: @2067028
      GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(2067132), // Rule ID 62105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10737:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62105,
        GIR_EraseRootFromParent_Done,
      // Label 25460: @2067132
      GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(2067236), // Rule ID 62108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10737:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62108,
        GIR_EraseRootFromParent_Done,
      // Label 25461: @2067236
      GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(2067340), // Rule ID 62109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10737:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62109,
        GIR_EraseRootFromParent_Done,
      // Label 25462: @2067340
      GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(2067444), // Rule ID 62112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10737:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62112,
        GIR_EraseRootFromParent_Done,
      // Label 25463: @2067444
      GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(2067548), // Rule ID 62113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10737:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62113,
        GIR_EraseRootFromParent_Done,
      // Label 25464: @2067548
      GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(2067652), // Rule ID 62116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10737:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62116,
        GIR_EraseRootFromParent_Done,
      // Label 25465: @2067652
      GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(2067756), // Rule ID 62117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10737:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62117,
        GIR_EraseRootFromParent_Done,
      // Label 25466: @2067756
      GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(2067860), // Rule ID 62120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10737:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62120,
        GIR_EraseRootFromParent_Done,
      // Label 25467: @2067860
      GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(2067964), // Rule ID 62121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10737:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62121,
        GIR_EraseRootFromParent_Done,
      // Label 25468: @2067964
      GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(2068068), // Rule ID 62124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10737:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62124,
        GIR_EraseRootFromParent_Done,
      // Label 25469: @2068068
      GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(2068172), // Rule ID 62125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10737:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62125,
        GIR_EraseRootFromParent_Done,
      // Label 25470: @2068172
      GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(2068276), // Rule ID 62128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10737:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62128,
        GIR_EraseRootFromParent_Done,
      // Label 25471: @2068276
      GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(2068380), // Rule ID 62129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10737:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62129,
        GIR_EraseRootFromParent_Done,
      // Label 25472: @2068380
      GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(2068484), // Rule ID 62132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10737:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62132,
        GIR_EraseRootFromParent_Done,
      // Label 25473: @2068484
      GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(2068588), // Rule ID 62133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10737:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62133,
        GIR_EraseRootFromParent_Done,
      // Label 25474: @2068588
      GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(2068692), // Rule ID 62136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10741:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62136,
        GIR_EraseRootFromParent_Done,
      // Label 25475: @2068692
      GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(2068796), // Rule ID 62137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10741:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62137,
        GIR_EraseRootFromParent_Done,
      // Label 25476: @2068796
      GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(2068900), // Rule ID 62140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10741:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62140,
        GIR_EraseRootFromParent_Done,
      // Label 25477: @2068900
      GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(2069004), // Rule ID 62141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10741:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62141,
        GIR_EraseRootFromParent_Done,
      // Label 25478: @2069004
      GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(2069108), // Rule ID 62144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10741:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62144,
        GIR_EraseRootFromParent_Done,
      // Label 25479: @2069108
      GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(2069212), // Rule ID 62145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10741:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62145,
        GIR_EraseRootFromParent_Done,
      // Label 25480: @2069212
      GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(2069316), // Rule ID 62148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10741:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62148,
        GIR_EraseRootFromParent_Done,
      // Label 25481: @2069316
      GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(2069420), // Rule ID 62149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10741:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62149,
        GIR_EraseRootFromParent_Done,
      // Label 25482: @2069420
      GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(2069524), // Rule ID 62152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10741:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62152,
        GIR_EraseRootFromParent_Done,
      // Label 25483: @2069524
      GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(2069628), // Rule ID 62153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10741:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/7, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62153,
        GIR_EraseRootFromParent_Done,
      // Label 25484: @2069628
      GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(2069735), // Rule ID 2644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2644,
        GIR_EraseRootFromParent_Done,
      // Label 25485: @2069735
      GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(2069842), // Rule ID 2645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2645,
        GIR_EraseRootFromParent_Done,
      // Label 25486: @2069842
      GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(2069949), // Rule ID 22682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22682,
        GIR_EraseRootFromParent_Done,
      // Label 25487: @2069949
      GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(2070056), // Rule ID 22683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22683,
        GIR_EraseRootFromParent_Done,
      // Label 25488: @2070056
      GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(2070163), // Rule ID 22686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22686,
        GIR_EraseRootFromParent_Done,
      // Label 25489: @2070163
      GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(2070270), // Rule ID 22687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22687,
        GIR_EraseRootFromParent_Done,
      // Label 25490: @2070270
      GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(2070377), // Rule ID 22690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22690,
        GIR_EraseRootFromParent_Done,
      // Label 25491: @2070377
      GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(2070484), // Rule ID 22691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22691,
        GIR_EraseRootFromParent_Done,
      // Label 25492: @2070484
      GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(2070591), // Rule ID 22694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22694,
        GIR_EraseRootFromParent_Done,
      // Label 25493: @2070591
      GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(2070698), // Rule ID 22695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22695,
        GIR_EraseRootFromParent_Done,
      // Label 25494: @2070698
      GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(2070805), // Rule ID 22698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22698,
        GIR_EraseRootFromParent_Done,
      // Label 25495: @2070805
      GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(2070912), // Rule ID 22699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22699,
        GIR_EraseRootFromParent_Done,
      // Label 25496: @2070912
      GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(2071019), // Rule ID 22702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22702,
        GIR_EraseRootFromParent_Done,
      // Label 25497: @2071019
      GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(2071126), // Rule ID 22703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22703,
        GIR_EraseRootFromParent_Done,
      // Label 25498: @2071126
      GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(2071233), // Rule ID 22706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22706,
        GIR_EraseRootFromParent_Done,
      // Label 25499: @2071233
      GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(2071340), // Rule ID 22707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22707,
        GIR_EraseRootFromParent_Done,
      // Label 25500: @2071340
      GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(2071447), // Rule ID 22710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22710,
        GIR_EraseRootFromParent_Done,
      // Label 25501: @2071447
      GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(2071554), // Rule ID 22711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10865:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22711,
        GIR_EraseRootFromParent_Done,
      // Label 25502: @2071554
      GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(2071661), // Rule ID 22714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22714,
        GIR_EraseRootFromParent_Done,
      // Label 25503: @2071661
      GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(2071768), // Rule ID 22715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22715,
        GIR_EraseRootFromParent_Done,
      // Label 25504: @2071768
      GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(2071875), // Rule ID 22718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22718,
        GIR_EraseRootFromParent_Done,
      // Label 25505: @2071875
      GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(2071982), // Rule ID 22719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22719,
        GIR_EraseRootFromParent_Done,
      // Label 25506: @2071982
      GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(2072089), // Rule ID 22722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22722,
        GIR_EraseRootFromParent_Done,
      // Label 25507: @2072089
      GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(2072196), // Rule ID 22723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10865:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22723,
        GIR_EraseRootFromParent_Done,
      // Label 25508: @2072196
      GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(2072303), // Rule ID 22726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22726,
        GIR_EraseRootFromParent_Done,
      // Label 25509: @2072303
      GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(2072410), // Rule ID 22727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22727,
        GIR_EraseRootFromParent_Done,
      // Label 25510: @2072410
      GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(2072517), // Rule ID 22730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22730,
        GIR_EraseRootFromParent_Done,
      // Label 25511: @2072517
      GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(2072624), // Rule ID 22731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22731,
        GIR_EraseRootFromParent_Done,
      // Label 25512: @2072624
      GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(2072731), // Rule ID 22734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22734,
        GIR_EraseRootFromParent_Done,
      // Label 25513: @2072731
      GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(2072838), // Rule ID 22735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10865:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22735,
        GIR_EraseRootFromParent_Done,
      // Label 25514: @2072838
      GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(2072945), // Rule ID 22738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22738,
        GIR_EraseRootFromParent_Done,
      // Label 25515: @2072945
      GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(2073052), // Rule ID 22739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22739,
        GIR_EraseRootFromParent_Done,
      // Label 25516: @2073052
      GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(2073159), // Rule ID 22742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22742,
        GIR_EraseRootFromParent_Done,
      // Label 25517: @2073159
      GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(2073266), // Rule ID 22743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22743,
        GIR_EraseRootFromParent_Done,
      // Label 25518: @2073266
      GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(2073373), // Rule ID 22746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22746,
        GIR_EraseRootFromParent_Done,
      // Label 25519: @2073373
      GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(2073480), // Rule ID 22747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22747,
        GIR_EraseRootFromParent_Done,
      // Label 25520: @2073480
      GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(2073587), // Rule ID 22750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22750,
        GIR_EraseRootFromParent_Done,
      // Label 25521: @2073587
      GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(2073694), // Rule ID 22751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22751,
        GIR_EraseRootFromParent_Done,
      // Label 25522: @2073694
      GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(2073801), // Rule ID 22754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22754,
        GIR_EraseRootFromParent_Done,
      // Label 25523: @2073801
      GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(2073908), // Rule ID 22755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22755,
        GIR_EraseRootFromParent_Done,
      // Label 25524: @2073908
      GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(2074015), // Rule ID 22758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22758,
        GIR_EraseRootFromParent_Done,
      // Label 25525: @2074015
      GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(2074122), // Rule ID 22759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22759,
        GIR_EraseRootFromParent_Done,
      // Label 25526: @2074122
      GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(2074229), // Rule ID 22762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22762,
        GIR_EraseRootFromParent_Done,
      // Label 25527: @2074229
      GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(2074336), // Rule ID 22763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22763,
        GIR_EraseRootFromParent_Done,
      // Label 25528: @2074336
      GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(2074443), // Rule ID 22766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22766,
        GIR_EraseRootFromParent_Done,
      // Label 25529: @2074443
      GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(2074550), // Rule ID 22767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22767,
        GIR_EraseRootFromParent_Done,
      // Label 25530: @2074550
      GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(2074657), // Rule ID 22770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22770,
        GIR_EraseRootFromParent_Done,
      // Label 25531: @2074657
      GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(2074764), // Rule ID 22771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10867:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22771,
        GIR_EraseRootFromParent_Done,
      // Label 25532: @2074764
      GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(2074871), // Rule ID 22774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22774,
        GIR_EraseRootFromParent_Done,
      // Label 25533: @2074871
      GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(2074978), // Rule ID 22775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22775,
        GIR_EraseRootFromParent_Done,
      // Label 25534: @2074978
      GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(2075085), // Rule ID 22778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22778,
        GIR_EraseRootFromParent_Done,
      // Label 25535: @2075085
      GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(2075192), // Rule ID 22779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22779,
        GIR_EraseRootFromParent_Done,
      // Label 25536: @2075192
      GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(2075299), // Rule ID 22782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22782,
        GIR_EraseRootFromParent_Done,
      // Label 25537: @2075299
      GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(2075406), // Rule ID 22783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10867:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22783,
        GIR_EraseRootFromParent_Done,
      // Label 25538: @2075406
      GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(2075513), // Rule ID 22786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22786,
        GIR_EraseRootFromParent_Done,
      // Label 25539: @2075513
      GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(2075620), // Rule ID 22787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22787,
        GIR_EraseRootFromParent_Done,
      // Label 25540: @2075620
      GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(2075727), // Rule ID 22790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22790,
        GIR_EraseRootFromParent_Done,
      // Label 25541: @2075727
      GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(2075834), // Rule ID 22791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22791,
        GIR_EraseRootFromParent_Done,
      // Label 25542: @2075834
      GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(2075941), // Rule ID 22794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22794,
        GIR_EraseRootFromParent_Done,
      // Label 25543: @2075941
      GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(2076048), // Rule ID 22795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10867:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22795,
        GIR_EraseRootFromParent_Done,
      // Label 25544: @2076048
      GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(2076155), // Rule ID 22918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22918,
        GIR_EraseRootFromParent_Done,
      // Label 25545: @2076155
      GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(2076262), // Rule ID 22919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22919,
        GIR_EraseRootFromParent_Done,
      // Label 25546: @2076262
      GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(2076369), // Rule ID 22922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22922,
        GIR_EraseRootFromParent_Done,
      // Label 25547: @2076369
      GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(2076476), // Rule ID 22923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22923,
        GIR_EraseRootFromParent_Done,
      // Label 25548: @2076476
      GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(2076583), // Rule ID 22926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22926,
        GIR_EraseRootFromParent_Done,
      // Label 25549: @2076583
      GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(2076690), // Rule ID 22927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22927,
        GIR_EraseRootFromParent_Done,
      // Label 25550: @2076690
      GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(2076797), // Rule ID 22930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22930,
        GIR_EraseRootFromParent_Done,
      // Label 25551: @2076797
      GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(2076904), // Rule ID 22931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22931,
        GIR_EraseRootFromParent_Done,
      // Label 25552: @2076904
      GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(2077011), // Rule ID 22934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22934,
        GIR_EraseRootFromParent_Done,
      // Label 25553: @2077011
      GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(2077118), // Rule ID 22935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22935,
        GIR_EraseRootFromParent_Done,
      // Label 25554: @2077118
      GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(2077225), // Rule ID 22938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22938,
        GIR_EraseRootFromParent_Done,
      // Label 25555: @2077225
      GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(2077332), // Rule ID 22939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22939,
        GIR_EraseRootFromParent_Done,
      // Label 25556: @2077332
      GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(2077439), // Rule ID 22942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22942,
        GIR_EraseRootFromParent_Done,
      // Label 25557: @2077439
      GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(2077546), // Rule ID 22943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22943,
        GIR_EraseRootFromParent_Done,
      // Label 25558: @2077546
      GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(2077653), // Rule ID 22946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22946,
        GIR_EraseRootFromParent_Done,
      // Label 25559: @2077653
      GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(2077760), // Rule ID 22947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10921:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22947,
        GIR_EraseRootFromParent_Done,
      // Label 25560: @2077760
      GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(2077867), // Rule ID 22950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22950,
        GIR_EraseRootFromParent_Done,
      // Label 25561: @2077867
      GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(2077974), // Rule ID 22951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22951,
        GIR_EraseRootFromParent_Done,
      // Label 25562: @2077974
      GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(2078081), // Rule ID 22954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22954,
        GIR_EraseRootFromParent_Done,
      // Label 25563: @2078081
      GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(2078188), // Rule ID 22955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22955,
        GIR_EraseRootFromParent_Done,
      // Label 25564: @2078188
      GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(2078295), // Rule ID 22958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22958,
        GIR_EraseRootFromParent_Done,
      // Label 25565: @2078295
      GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(2078402), // Rule ID 22959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10921:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22959,
        GIR_EraseRootFromParent_Done,
      // Label 25566: @2078402
      GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(2078509), // Rule ID 22962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22962,
        GIR_EraseRootFromParent_Done,
      // Label 25567: @2078509
      GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(2078616), // Rule ID 22963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22963,
        GIR_EraseRootFromParent_Done,
      // Label 25568: @2078616
      GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(2078723), // Rule ID 22966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22966,
        GIR_EraseRootFromParent_Done,
      // Label 25569: @2078723
      GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(2078830), // Rule ID 22967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22967,
        GIR_EraseRootFromParent_Done,
      // Label 25570: @2078830
      GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(2078937), // Rule ID 22970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22970,
        GIR_EraseRootFromParent_Done,
      // Label 25571: @2078937
      GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(2079044), // Rule ID 22971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22971,
        GIR_EraseRootFromParent_Done,
      // Label 25572: @2079044
      GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(2079151), // Rule ID 22974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22974,
        GIR_EraseRootFromParent_Done,
      // Label 25573: @2079151
      GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(2079258), // Rule ID 22975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22975,
        GIR_EraseRootFromParent_Done,
      // Label 25574: @2079258
      GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(2079365), // Rule ID 22978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22978,
        GIR_EraseRootFromParent_Done,
      // Label 25575: @2079365
      GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(2079472), // Rule ID 22979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22979,
        GIR_EraseRootFromParent_Done,
      // Label 25576: @2079472
      GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(2079579), // Rule ID 22982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22982,
        GIR_EraseRootFromParent_Done,
      // Label 25577: @2079579
      GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(2079686), // Rule ID 22983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22983,
        GIR_EraseRootFromParent_Done,
      // Label 25578: @2079686
      GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(2079793), // Rule ID 22986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22986,
        GIR_EraseRootFromParent_Done,
      // Label 25579: @2079793
      GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(2079900), // Rule ID 22987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22987,
        GIR_EraseRootFromParent_Done,
      // Label 25580: @2079900
      GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(2080007), // Rule ID 22990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22990,
        GIR_EraseRootFromParent_Done,
      // Label 25581: @2080007
      GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(2080114), // Rule ID 22991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10919:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22991,
        GIR_EraseRootFromParent_Done,
      // Label 25582: @2080114
      GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(2080221), // Rule ID 22994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22994,
        GIR_EraseRootFromParent_Done,
      // Label 25583: @2080221
      GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(2080328), // Rule ID 22995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22995,
        GIR_EraseRootFromParent_Done,
      // Label 25584: @2080328
      GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(2080435), // Rule ID 22998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22998,
        GIR_EraseRootFromParent_Done,
      // Label 25585: @2080435
      GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(2080542), // Rule ID 22999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22999,
        GIR_EraseRootFromParent_Done,
      // Label 25586: @2080542
      GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(2080649), // Rule ID 23002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23002,
        GIR_EraseRootFromParent_Done,
      // Label 25587: @2080649
      GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(2080756), // Rule ID 23003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10919:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23003,
        GIR_EraseRootFromParent_Done,
      // Label 25588: @2080756
      GIM_Reject,
    // Label 18586: @2080757
    GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(2305850),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
      GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(2080885), // Rule ID 15838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15838,
        GIR_EraseRootFromParent_Done,
      // Label 25590: @2080885
      GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(2081005), // Rule ID 15839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15839,
        GIR_EraseRootFromParent_Done,
      // Label 25591: @2081005
      GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(2081125), // Rule ID 15842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15842,
        GIR_EraseRootFromParent_Done,
      // Label 25592: @2081125
      GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(2081245), // Rule ID 15843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15843,
        GIR_EraseRootFromParent_Done,
      // Label 25593: @2081245
      GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(2081365), // Rule ID 15846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15846,
        GIR_EraseRootFromParent_Done,
      // Label 25594: @2081365
      GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(2081485), // Rule ID 15847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15847,
        GIR_EraseRootFromParent_Done,
      // Label 25595: @2081485
      GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(2081605), // Rule ID 15850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15850,
        GIR_EraseRootFromParent_Done,
      // Label 25596: @2081605
      GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(2081725), // Rule ID 15851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15851,
        GIR_EraseRootFromParent_Done,
      // Label 25597: @2081725
      GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(2081845), // Rule ID 15854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15854,
        GIR_EraseRootFromParent_Done,
      // Label 25598: @2081845
      GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(2081965), // Rule ID 15855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15855,
        GIR_EraseRootFromParent_Done,
      // Label 25599: @2081965
      GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(2082085), // Rule ID 15858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15858,
        GIR_EraseRootFromParent_Done,
      // Label 25600: @2082085
      GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(2082205), // Rule ID 15859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15859,
        GIR_EraseRootFromParent_Done,
      // Label 25601: @2082205
      GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(2082325), // Rule ID 15862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15862,
        GIR_EraseRootFromParent_Done,
      // Label 25602: @2082325
      GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(2082445), // Rule ID 15863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15863,
        GIR_EraseRootFromParent_Done,
      // Label 25603: @2082445
      GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(2082565), // Rule ID 15866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15866,
        GIR_EraseRootFromParent_Done,
      // Label 25604: @2082565
      GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(2082685), // Rule ID 15867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15867,
        GIR_EraseRootFromParent_Done,
      // Label 25605: @2082685
      GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(2082805), // Rule ID 15870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15870,
        GIR_EraseRootFromParent_Done,
      // Label 25606: @2082805
      GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(2082925), // Rule ID 15871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15871,
        GIR_EraseRootFromParent_Done,
      // Label 25607: @2082925
      GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(2083045), // Rule ID 15874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15874,
        GIR_EraseRootFromParent_Done,
      // Label 25608: @2083045
      GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(2083165), // Rule ID 15875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15875,
        GIR_EraseRootFromParent_Done,
      // Label 25609: @2083165
      GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(2083285), // Rule ID 15878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15878,
        GIR_EraseRootFromParent_Done,
      // Label 25610: @2083285
      GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(2083405), // Rule ID 15879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15879,
        GIR_EraseRootFromParent_Done,
      // Label 25611: @2083405
      GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(2083525), // Rule ID 15882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15882,
        GIR_EraseRootFromParent_Done,
      // Label 25612: @2083525
      GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(2083645), // Rule ID 15883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15883,
        GIR_EraseRootFromParent_Done,
      // Label 25613: @2083645
      GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(2083765), // Rule ID 15886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15886,
        GIR_EraseRootFromParent_Done,
      // Label 25614: @2083765
      GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(2083885), // Rule ID 15887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15887,
        GIR_EraseRootFromParent_Done,
      // Label 25615: @2083885
      GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(2084005), // Rule ID 15890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15890,
        GIR_EraseRootFromParent_Done,
      // Label 25616: @2084005
      GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(2084125), // Rule ID 15891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15891,
        GIR_EraseRootFromParent_Done,
      // Label 25617: @2084125
      GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(2084245), // Rule ID 15894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15894,
        GIR_EraseRootFromParent_Done,
      // Label 25618: @2084245
      GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(2084365), // Rule ID 15895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15895,
        GIR_EraseRootFromParent_Done,
      // Label 25619: @2084365
      GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(2084485), // Rule ID 15898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15898,
        GIR_EraseRootFromParent_Done,
      // Label 25620: @2084485
      GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(2084605), // Rule ID 15899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15899,
        GIR_EraseRootFromParent_Done,
      // Label 25621: @2084605
      GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(2084725), // Rule ID 15902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15902,
        GIR_EraseRootFromParent_Done,
      // Label 25622: @2084725
      GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(2084845), // Rule ID 15903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15903,
        GIR_EraseRootFromParent_Done,
      // Label 25623: @2084845
      GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(2084965), // Rule ID 15906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15906,
        GIR_EraseRootFromParent_Done,
      // Label 25624: @2084965
      GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(2085085), // Rule ID 15907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15907,
        GIR_EraseRootFromParent_Done,
      // Label 25625: @2085085
      GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(2085205), // Rule ID 15910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15910,
        GIR_EraseRootFromParent_Done,
      // Label 25626: @2085205
      GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(2085325), // Rule ID 15911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15911,
        GIR_EraseRootFromParent_Done,
      // Label 25627: @2085325
      GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(2085445), // Rule ID 15914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15914,
        GIR_EraseRootFromParent_Done,
      // Label 25628: @2085445
      GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(2085565), // Rule ID 15915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15915,
        GIR_EraseRootFromParent_Done,
      // Label 25629: @2085565
      GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(2085685), // Rule ID 15918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15918,
        GIR_EraseRootFromParent_Done,
      // Label 25630: @2085685
      GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(2085805), // Rule ID 15919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15919,
        GIR_EraseRootFromParent_Done,
      // Label 25631: @2085805
      GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(2085925), // Rule ID 15922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15922,
        GIR_EraseRootFromParent_Done,
      // Label 25632: @2085925
      GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(2086045), // Rule ID 15923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15923,
        GIR_EraseRootFromParent_Done,
      // Label 25633: @2086045
      GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(2086165), // Rule ID 16102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16102,
        GIR_EraseRootFromParent_Done,
      // Label 25634: @2086165
      GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(2086285), // Rule ID 16103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16103,
        GIR_EraseRootFromParent_Done,
      // Label 25635: @2086285
      GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(2086405), // Rule ID 16106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16106,
        GIR_EraseRootFromParent_Done,
      // Label 25636: @2086405
      GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(2086525), // Rule ID 16107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16107,
        GIR_EraseRootFromParent_Done,
      // Label 25637: @2086525
      GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(2086645), // Rule ID 16110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16110,
        GIR_EraseRootFromParent_Done,
      // Label 25638: @2086645
      GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(2086765), // Rule ID 16111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16111,
        GIR_EraseRootFromParent_Done,
      // Label 25639: @2086765
      GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(2086885), // Rule ID 16114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16114,
        GIR_EraseRootFromParent_Done,
      // Label 25640: @2086885
      GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(2087005), // Rule ID 16115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16115,
        GIR_EraseRootFromParent_Done,
      // Label 25641: @2087005
      GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(2087125), // Rule ID 16118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16118,
        GIR_EraseRootFromParent_Done,
      // Label 25642: @2087125
      GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(2087245), // Rule ID 16119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16119,
        GIR_EraseRootFromParent_Done,
      // Label 25643: @2087245
      GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(2087365), // Rule ID 16122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16122,
        GIR_EraseRootFromParent_Done,
      // Label 25644: @2087365
      GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(2087485), // Rule ID 16123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16123,
        GIR_EraseRootFromParent_Done,
      // Label 25645: @2087485
      GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(2087605), // Rule ID 16126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16126,
        GIR_EraseRootFromParent_Done,
      // Label 25646: @2087605
      GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(2087725), // Rule ID 16127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16127,
        GIR_EraseRootFromParent_Done,
      // Label 25647: @2087725
      GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(2087845), // Rule ID 16130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16130,
        GIR_EraseRootFromParent_Done,
      // Label 25648: @2087845
      GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(2087965), // Rule ID 16131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16131,
        GIR_EraseRootFromParent_Done,
      // Label 25649: @2087965
      GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(2088085), // Rule ID 16134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16134,
        GIR_EraseRootFromParent_Done,
      // Label 25650: @2088085
      GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(2088205), // Rule ID 16135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16135,
        GIR_EraseRootFromParent_Done,
      // Label 25651: @2088205
      GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(2088325), // Rule ID 16138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16138,
        GIR_EraseRootFromParent_Done,
      // Label 25652: @2088325
      GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(2088445), // Rule ID 16139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16139,
        GIR_EraseRootFromParent_Done,
      // Label 25653: @2088445
      GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(2088565), // Rule ID 16142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16142,
        GIR_EraseRootFromParent_Done,
      // Label 25654: @2088565
      GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(2088685), // Rule ID 16143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16143,
        GIR_EraseRootFromParent_Done,
      // Label 25655: @2088685
      GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(2088805), // Rule ID 16146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16146,
        GIR_EraseRootFromParent_Done,
      // Label 25656: @2088805
      GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(2088925), // Rule ID 16147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16147,
        GIR_EraseRootFromParent_Done,
      // Label 25657: @2088925
      GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(2089045), // Rule ID 16150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16150,
        GIR_EraseRootFromParent_Done,
      // Label 25658: @2089045
      GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(2089165), // Rule ID 16151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16151,
        GIR_EraseRootFromParent_Done,
      // Label 25659: @2089165
      GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(2089285), // Rule ID 16154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16154,
        GIR_EraseRootFromParent_Done,
      // Label 25660: @2089285
      GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(2089405), // Rule ID 16155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16155,
        GIR_EraseRootFromParent_Done,
      // Label 25661: @2089405
      GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(2089525), // Rule ID 16158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16158,
        GIR_EraseRootFromParent_Done,
      // Label 25662: @2089525
      GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(2089645), // Rule ID 16159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16159,
        GIR_EraseRootFromParent_Done,
      // Label 25663: @2089645
      GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(2089765), // Rule ID 16162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16162,
        GIR_EraseRootFromParent_Done,
      // Label 25664: @2089765
      GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(2089885), // Rule ID 16163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16163,
        GIR_EraseRootFromParent_Done,
      // Label 25665: @2089885
      GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(2090005), // Rule ID 16166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16166,
        GIR_EraseRootFromParent_Done,
      // Label 25666: @2090005
      GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(2090125), // Rule ID 16167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16167,
        GIR_EraseRootFromParent_Done,
      // Label 25667: @2090125
      GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(2090245), // Rule ID 16170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16170,
        GIR_EraseRootFromParent_Done,
      // Label 25668: @2090245
      GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(2090365), // Rule ID 16171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16171,
        GIR_EraseRootFromParent_Done,
      // Label 25669: @2090365
      GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(2090485), // Rule ID 16174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16174,
        GIR_EraseRootFromParent_Done,
      // Label 25670: @2090485
      GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(2090605), // Rule ID 16175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16175,
        GIR_EraseRootFromParent_Done,
      // Label 25671: @2090605
      GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(2090725), // Rule ID 16178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16178,
        GIR_EraseRootFromParent_Done,
      // Label 25672: @2090725
      GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(2090845), // Rule ID 16179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16179,
        GIR_EraseRootFromParent_Done,
      // Label 25673: @2090845
      GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(2090965), // Rule ID 16182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16182,
        GIR_EraseRootFromParent_Done,
      // Label 25674: @2090965
      GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(2091085), // Rule ID 16183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16183,
        GIR_EraseRootFromParent_Done,
      // Label 25675: @2091085
      GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(2091205), // Rule ID 16186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16186,
        GIR_EraseRootFromParent_Done,
      // Label 25676: @2091205
      GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(2091325), // Rule ID 16187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16187,
        GIR_EraseRootFromParent_Done,
      // Label 25677: @2091325
      GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(2091448), // Rule ID 16310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16310,
        GIR_EraseRootFromParent_Done,
      // Label 25678: @2091448
      GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(2091571), // Rule ID 16311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16311,
        GIR_EraseRootFromParent_Done,
      // Label 25679: @2091571
      GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(2091694), // Rule ID 16314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16314,
        GIR_EraseRootFromParent_Done,
      // Label 25680: @2091694
      GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(2091817), // Rule ID 16315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16315,
        GIR_EraseRootFromParent_Done,
      // Label 25681: @2091817
      GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(2091940), // Rule ID 16318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16318,
        GIR_EraseRootFromParent_Done,
      // Label 25682: @2091940
      GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(2092063), // Rule ID 16319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16319,
        GIR_EraseRootFromParent_Done,
      // Label 25683: @2092063
      GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(2092186), // Rule ID 16322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16322,
        GIR_EraseRootFromParent_Done,
      // Label 25684: @2092186
      GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(2092309), // Rule ID 16323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16323,
        GIR_EraseRootFromParent_Done,
      // Label 25685: @2092309
      GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(2092432), // Rule ID 16326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16326,
        GIR_EraseRootFromParent_Done,
      // Label 25686: @2092432
      GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(2092555), // Rule ID 16327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16327,
        GIR_EraseRootFromParent_Done,
      // Label 25687: @2092555
      GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(2092678), // Rule ID 16330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16330,
        GIR_EraseRootFromParent_Done,
      // Label 25688: @2092678
      GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(2092801), // Rule ID 16331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16331,
        GIR_EraseRootFromParent_Done,
      // Label 25689: @2092801
      GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(2092924), // Rule ID 16334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16334,
        GIR_EraseRootFromParent_Done,
      // Label 25690: @2092924
      GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(2093047), // Rule ID 16335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16335,
        GIR_EraseRootFromParent_Done,
      // Label 25691: @2093047
      GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(2093170), // Rule ID 16338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16338,
        GIR_EraseRootFromParent_Done,
      // Label 25692: @2093170
      GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(2093293), // Rule ID 16339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16339,
        GIR_EraseRootFromParent_Done,
      // Label 25693: @2093293
      GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(2093416), // Rule ID 16342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16342,
        GIR_EraseRootFromParent_Done,
      // Label 25694: @2093416
      GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(2093539), // Rule ID 16343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16343,
        GIR_EraseRootFromParent_Done,
      // Label 25695: @2093539
      GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(2093662), // Rule ID 16346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16346,
        GIR_EraseRootFromParent_Done,
      // Label 25696: @2093662
      GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(2093785), // Rule ID 16347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16347,
        GIR_EraseRootFromParent_Done,
      // Label 25697: @2093785
      GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(2093908), // Rule ID 16350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16350,
        GIR_EraseRootFromParent_Done,
      // Label 25698: @2093908
      GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(2094031), // Rule ID 16351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16351,
        GIR_EraseRootFromParent_Done,
      // Label 25699: @2094031
      GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(2094154), // Rule ID 16354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16354,
        GIR_EraseRootFromParent_Done,
      // Label 25700: @2094154
      GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(2094277), // Rule ID 16355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16355,
        GIR_EraseRootFromParent_Done,
      // Label 25701: @2094277
      GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(2094400), // Rule ID 16358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16358,
        GIR_EraseRootFromParent_Done,
      // Label 25702: @2094400
      GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(2094523), // Rule ID 16359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16359,
        GIR_EraseRootFromParent_Done,
      // Label 25703: @2094523
      GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(2094646), // Rule ID 16362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16362,
        GIR_EraseRootFromParent_Done,
      // Label 25704: @2094646
      GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(2094769), // Rule ID 16363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16363,
        GIR_EraseRootFromParent_Done,
      // Label 25705: @2094769
      GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(2094892), // Rule ID 16366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16366,
        GIR_EraseRootFromParent_Done,
      // Label 25706: @2094892
      GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(2095015), // Rule ID 16367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16367,
        GIR_EraseRootFromParent_Done,
      // Label 25707: @2095015
      GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(2095138), // Rule ID 16490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16490,
        GIR_EraseRootFromParent_Done,
      // Label 25708: @2095138
      GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(2095261), // Rule ID 16491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16491,
        GIR_EraseRootFromParent_Done,
      // Label 25709: @2095261
      GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(2095384), // Rule ID 16494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16494,
        GIR_EraseRootFromParent_Done,
      // Label 25710: @2095384
      GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(2095507), // Rule ID 16495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16495,
        GIR_EraseRootFromParent_Done,
      // Label 25711: @2095507
      GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(2095630), // Rule ID 16498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16498,
        GIR_EraseRootFromParent_Done,
      // Label 25712: @2095630
      GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(2095753), // Rule ID 16499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16499,
        GIR_EraseRootFromParent_Done,
      // Label 25713: @2095753
      GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(2095876), // Rule ID 16502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16502,
        GIR_EraseRootFromParent_Done,
      // Label 25714: @2095876
      GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(2095999), // Rule ID 16503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16503,
        GIR_EraseRootFromParent_Done,
      // Label 25715: @2095999
      GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(2096122), // Rule ID 16506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16506,
        GIR_EraseRootFromParent_Done,
      // Label 25716: @2096122
      GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(2096245), // Rule ID 16507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16507,
        GIR_EraseRootFromParent_Done,
      // Label 25717: @2096245
      GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(2096368), // Rule ID 16510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16510,
        GIR_EraseRootFromParent_Done,
      // Label 25718: @2096368
      GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(2096491), // Rule ID 16511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16511,
        GIR_EraseRootFromParent_Done,
      // Label 25719: @2096491
      GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(2096614), // Rule ID 16514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16514,
        GIR_EraseRootFromParent_Done,
      // Label 25720: @2096614
      GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(2096737), // Rule ID 16515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16515,
        GIR_EraseRootFromParent_Done,
      // Label 25721: @2096737
      GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(2096860), // Rule ID 16518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16518,
        GIR_EraseRootFromParent_Done,
      // Label 25722: @2096860
      GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(2096983), // Rule ID 16519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16519,
        GIR_EraseRootFromParent_Done,
      // Label 25723: @2096983
      GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(2097106), // Rule ID 16522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16522,
        GIR_EraseRootFromParent_Done,
      // Label 25724: @2097106
      GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(2097229), // Rule ID 16523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16523,
        GIR_EraseRootFromParent_Done,
      // Label 25725: @2097229
      GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(2097352), // Rule ID 16526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16526,
        GIR_EraseRootFromParent_Done,
      // Label 25726: @2097352
      GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(2097475), // Rule ID 16527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16527,
        GIR_EraseRootFromParent_Done,
      // Label 25727: @2097475
      GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(2097598), // Rule ID 16530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16530,
        GIR_EraseRootFromParent_Done,
      // Label 25728: @2097598
      GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(2097721), // Rule ID 16531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16531,
        GIR_EraseRootFromParent_Done,
      // Label 25729: @2097721
      GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(2097844), // Rule ID 16534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16534,
        GIR_EraseRootFromParent_Done,
      // Label 25730: @2097844
      GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(2097967), // Rule ID 16535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16535,
        GIR_EraseRootFromParent_Done,
      // Label 25731: @2097967
      GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(2098090), // Rule ID 16538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16538,
        GIR_EraseRootFromParent_Done,
      // Label 25732: @2098090
      GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(2098213), // Rule ID 16539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16539,
        GIR_EraseRootFromParent_Done,
      // Label 25733: @2098213
      GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(2098336), // Rule ID 16542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16542,
        GIR_EraseRootFromParent_Done,
      // Label 25734: @2098336
      GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(2098459), // Rule ID 16543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16543,
        GIR_EraseRootFromParent_Done,
      // Label 25735: @2098459
      GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(2098582), // Rule ID 16546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16546,
        GIR_EraseRootFromParent_Done,
      // Label 25736: @2098582
      GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(2098705), // Rule ID 16547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16547,
        GIR_EraseRootFromParent_Done,
      // Label 25737: @2098705
      GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(2098810), // Rule ID 2626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2626,
        GIR_EraseRootFromParent_Done,
      // Label 25738: @2098810
      GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(2098915), // Rule ID 2627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2627,
        GIR_EraseRootFromParent_Done,
      // Label 25739: @2098915
      GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(2099020), // Rule ID 16998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16998,
        GIR_EraseRootFromParent_Done,
      // Label 25740: @2099020
      GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(2099125), // Rule ID 16999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16999,
        GIR_EraseRootFromParent_Done,
      // Label 25741: @2099125
      GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(2099230), // Rule ID 17008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17008,
        GIR_EraseRootFromParent_Done,
      // Label 25742: @2099230
      GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(2099335), // Rule ID 17009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17009,
        GIR_EraseRootFromParent_Done,
      // Label 25743: @2099335
      GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(2099440), // Rule ID 17018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17018,
        GIR_EraseRootFromParent_Done,
      // Label 25744: @2099440
      GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(2099545), // Rule ID 17019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17019,
        GIR_EraseRootFromParent_Done,
      // Label 25745: @2099545
      GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(2099650), // Rule ID 17028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17028,
        GIR_EraseRootFromParent_Done,
      // Label 25746: @2099650
      GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(2099755), // Rule ID 17029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17029,
        GIR_EraseRootFromParent_Done,
      // Label 25747: @2099755
      GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(2099860), // Rule ID 17038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17038,
        GIR_EraseRootFromParent_Done,
      // Label 25748: @2099860
      GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(2099965), // Rule ID 17039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17039,
        GIR_EraseRootFromParent_Done,
      // Label 25749: @2099965
      GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(2100070), // Rule ID 17048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17048,
        GIR_EraseRootFromParent_Done,
      // Label 25750: @2100070
      GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(2100175), // Rule ID 17049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17049,
        GIR_EraseRootFromParent_Done,
      // Label 25751: @2100175
      GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(2100280), // Rule ID 17058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17058,
        GIR_EraseRootFromParent_Done,
      // Label 25752: @2100280
      GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(2100385), // Rule ID 17059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17059,
        GIR_EraseRootFromParent_Done,
      // Label 25753: @2100385
      GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(2100490), // Rule ID 17068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17068,
        GIR_EraseRootFromParent_Done,
      // Label 25754: @2100490
      GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(2100595), // Rule ID 17069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17069,
        GIR_EraseRootFromParent_Done,
      // Label 25755: @2100595
      GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(2100700), // Rule ID 17114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17114,
        GIR_EraseRootFromParent_Done,
      // Label 25756: @2100700
      GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(2100805), // Rule ID 17115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17115,
        GIR_EraseRootFromParent_Done,
      // Label 25757: @2100805
      GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(2100910), // Rule ID 17124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17124,
        GIR_EraseRootFromParent_Done,
      // Label 25758: @2100910
      GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(2101015), // Rule ID 17125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17125,
        GIR_EraseRootFromParent_Done,
      // Label 25759: @2101015
      GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(2101120), // Rule ID 17134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17134,
        GIR_EraseRootFromParent_Done,
      // Label 25760: @2101120
      GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(2101225), // Rule ID 17135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17135,
        GIR_EraseRootFromParent_Done,
      // Label 25761: @2101225
      GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(2101330), // Rule ID 17144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17144,
        GIR_EraseRootFromParent_Done,
      // Label 25762: @2101330
      GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(2101435), // Rule ID 17145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17145,
        GIR_EraseRootFromParent_Done,
      // Label 25763: @2101435
      GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(2101540), // Rule ID 17154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17154,
        GIR_EraseRootFromParent_Done,
      // Label 25764: @2101540
      GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(2101645), // Rule ID 17155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17155,
        GIR_EraseRootFromParent_Done,
      // Label 25765: @2101645
      GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(2101750), // Rule ID 17164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17164,
        GIR_EraseRootFromParent_Done,
      // Label 25766: @2101750
      GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(2101855), // Rule ID 17165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17165,
        GIR_EraseRootFromParent_Done,
      // Label 25767: @2101855
      GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(2101960), // Rule ID 17174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17174,
        GIR_EraseRootFromParent_Done,
      // Label 25768: @2101960
      GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(2102065), // Rule ID 17175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17175,
        GIR_EraseRootFromParent_Done,
      // Label 25769: @2102065
      GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(2102170), // Rule ID 17184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17184,
        GIR_EraseRootFromParent_Done,
      // Label 25770: @2102170
      GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(2102275), // Rule ID 17185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17185,
        GIR_EraseRootFromParent_Done,
      // Label 25771: @2102275
      GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(2102380), // Rule ID 17194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17194,
        GIR_EraseRootFromParent_Done,
      // Label 25772: @2102380
      GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(2102485), // Rule ID 17195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // MIs[0] passthru
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17195,
        GIR_EraseRootFromParent_Done,
      // Label 25773: @2102485
      GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(2102594), // Rule ID 2584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2584,
        GIR_EraseRootFromParent_Done,
      // Label 25774: @2102594
      GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(2102703), // Rule ID 2585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2585,
        GIR_EraseRootFromParent_Done,
      // Label 25775: @2102703
      GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(2102812), // Rule ID 2628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2628,
        GIR_EraseRootFromParent_Done,
      // Label 25776: @2102812
      GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(2102921), // Rule ID 2629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2629,
        GIR_EraseRootFromParent_Done,
      // Label 25777: @2102921
      GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(2103030), // Rule ID 2636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2636,
        GIR_EraseRootFromParent_Done,
      // Label 25778: @2103030
      GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(2103139), // Rule ID 2637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2637,
        GIR_EraseRootFromParent_Done,
      // Label 25779: @2103139
      GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(2103248), // Rule ID 14786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14786,
        GIR_EraseRootFromParent_Done,
      // Label 25780: @2103248
      GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(2103357), // Rule ID 14787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14787,
        GIR_EraseRootFromParent_Done,
      // Label 25781: @2103357
      GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(2103466), // Rule ID 14790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14790,
        GIR_EraseRootFromParent_Done,
      // Label 25782: @2103466
      GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(2103575), // Rule ID 14791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14791,
        GIR_EraseRootFromParent_Done,
      // Label 25783: @2103575
      GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(2103684), // Rule ID 14794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14794,
        GIR_EraseRootFromParent_Done,
      // Label 25784: @2103684
      GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(2103793), // Rule ID 14795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14795,
        GIR_EraseRootFromParent_Done,
      // Label 25785: @2103793
      GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(2103902), // Rule ID 14798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14798,
        GIR_EraseRootFromParent_Done,
      // Label 25786: @2103902
      GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(2104011), // Rule ID 14799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14799,
        GIR_EraseRootFromParent_Done,
      // Label 25787: @2104011
      GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(2104120), // Rule ID 14802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14802,
        GIR_EraseRootFromParent_Done,
      // Label 25788: @2104120
      GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(2104229), // Rule ID 14803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14803,
        GIR_EraseRootFromParent_Done,
      // Label 25789: @2104229
      GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(2104338), // Rule ID 14806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14806,
        GIR_EraseRootFromParent_Done,
      // Label 25790: @2104338
      GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(2104447), // Rule ID 14807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14807,
        GIR_EraseRootFromParent_Done,
      // Label 25791: @2104447
      GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(2104556), // Rule ID 14810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14810,
        GIR_EraseRootFromParent_Done,
      // Label 25792: @2104556
      GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(2104665), // Rule ID 14811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14811,
        GIR_EraseRootFromParent_Done,
      // Label 25793: @2104665
      GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(2104774), // Rule ID 14814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14814,
        GIR_EraseRootFromParent_Done,
      // Label 25794: @2104774
      GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(2104883), // Rule ID 14815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14815,
        GIR_EraseRootFromParent_Done,
      // Label 25795: @2104883
      GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(2104992), // Rule ID 14818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14818,
        GIR_EraseRootFromParent_Done,
      // Label 25796: @2104992
      GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(2105101), // Rule ID 14819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14819,
        GIR_EraseRootFromParent_Done,
      // Label 25797: @2105101
      GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(2105210), // Rule ID 14822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14822,
        GIR_EraseRootFromParent_Done,
      // Label 25798: @2105210
      GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(2105319), // Rule ID 14823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14823,
        GIR_EraseRootFromParent_Done,
      // Label 25799: @2105319
      GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(2105428), // Rule ID 14826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14826,
        GIR_EraseRootFromParent_Done,
      // Label 25800: @2105428
      GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(2105537), // Rule ID 14827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14827,
        GIR_EraseRootFromParent_Done,
      // Label 25801: @2105537
      GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(2105646), // Rule ID 14830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14830,
        GIR_EraseRootFromParent_Done,
      // Label 25802: @2105646
      GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(2105755), // Rule ID 14831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14831,
        GIR_EraseRootFromParent_Done,
      // Label 25803: @2105755
      GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(2105864), // Rule ID 14834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14834,
        GIR_EraseRootFromParent_Done,
      // Label 25804: @2105864
      GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(2105973), // Rule ID 14835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14835,
        GIR_EraseRootFromParent_Done,
      // Label 25805: @2105973
      GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(2106082), // Rule ID 14838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14838,
        GIR_EraseRootFromParent_Done,
      // Label 25806: @2106082
      GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(2106191), // Rule ID 14839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14839,
        GIR_EraseRootFromParent_Done,
      // Label 25807: @2106191
      GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(2106300), // Rule ID 14842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14842,
        GIR_EraseRootFromParent_Done,
      // Label 25808: @2106300
      GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(2106409), // Rule ID 14843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14843,
        GIR_EraseRootFromParent_Done,
      // Label 25809: @2106409
      GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(2106518), // Rule ID 14846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14846,
        GIR_EraseRootFromParent_Done,
      // Label 25810: @2106518
      GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(2106627), // Rule ID 14847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14847,
        GIR_EraseRootFromParent_Done,
      // Label 25811: @2106627
      GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(2106736), // Rule ID 14850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14850,
        GIR_EraseRootFromParent_Done,
      // Label 25812: @2106736
      GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(2106845), // Rule ID 14851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14851,
        GIR_EraseRootFromParent_Done,
      // Label 25813: @2106845
      GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(2106954), // Rule ID 14854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14854,
        GIR_EraseRootFromParent_Done,
      // Label 25814: @2106954
      GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(2107063), // Rule ID 14855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14855,
        GIR_EraseRootFromParent_Done,
      // Label 25815: @2107063
      GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(2107172), // Rule ID 14858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14858,
        GIR_EraseRootFromParent_Done,
      // Label 25816: @2107172
      GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(2107281), // Rule ID 14859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14859,
        GIR_EraseRootFromParent_Done,
      // Label 25817: @2107281
      GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(2107390), // Rule ID 14862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14862,
        GIR_EraseRootFromParent_Done,
      // Label 25818: @2107390
      GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(2107499), // Rule ID 14863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14863,
        GIR_EraseRootFromParent_Done,
      // Label 25819: @2107499
      GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(2107608), // Rule ID 14866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14866,
        GIR_EraseRootFromParent_Done,
      // Label 25820: @2107608
      GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(2107717), // Rule ID 14867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14867,
        GIR_EraseRootFromParent_Done,
      // Label 25821: @2107717
      GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(2107826), // Rule ID 14870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14870,
        GIR_EraseRootFromParent_Done,
      // Label 25822: @2107826
      GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(2107935), // Rule ID 14871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14871,
        GIR_EraseRootFromParent_Done,
      // Label 25823: @2107935
      GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(2108044), // Rule ID 14874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14874,
        GIR_EraseRootFromParent_Done,
      // Label 25824: @2108044
      GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(2108153), // Rule ID 14875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14875,
        GIR_EraseRootFromParent_Done,
      // Label 25825: @2108153
      GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(2108262), // Rule ID 14878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14878,
        GIR_EraseRootFromParent_Done,
      // Label 25826: @2108262
      GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(2108371), // Rule ID 14879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14879,
        GIR_EraseRootFromParent_Done,
      // Label 25827: @2108371
      GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(2108480), // Rule ID 14882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14882,
        GIR_EraseRootFromParent_Done,
      // Label 25828: @2108480
      GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(2108589), // Rule ID 14883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14883,
        GIR_EraseRootFromParent_Done,
      // Label 25829: @2108589
      GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(2108698), // Rule ID 14886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14886,
        GIR_EraseRootFromParent_Done,
      // Label 25830: @2108698
      GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(2108807), // Rule ID 14887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14887,
        GIR_EraseRootFromParent_Done,
      // Label 25831: @2108807
      GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(2108916), // Rule ID 14890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14890,
        GIR_EraseRootFromParent_Done,
      // Label 25832: @2108916
      GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(2109025), // Rule ID 14891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14891,
        GIR_EraseRootFromParent_Done,
      // Label 25833: @2109025
      GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(2109134), // Rule ID 14894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14894,
        GIR_EraseRootFromParent_Done,
      // Label 25834: @2109134
      GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(2109243), // Rule ID 14895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10748:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14895,
        GIR_EraseRootFromParent_Done,
      // Label 25835: @2109243
      GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(2109352), // Rule ID 14898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14898,
        GIR_EraseRootFromParent_Done,
      // Label 25836: @2109352
      GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(2109461), // Rule ID 14899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10748:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14899,
        GIR_EraseRootFromParent_Done,
      // Label 25837: @2109461
      GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(2109570), // Rule ID 14902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14902,
        GIR_EraseRootFromParent_Done,
      // Label 25838: @2109570
      GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(2109679), // Rule ID 14903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10748:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14903,
        GIR_EraseRootFromParent_Done,
      // Label 25839: @2109679
      GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(2109788), // Rule ID 14906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14906,
        GIR_EraseRootFromParent_Done,
      // Label 25840: @2109788
      GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(2109897), // Rule ID 14907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10748:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14907,
        GIR_EraseRootFromParent_Done,
      // Label 25841: @2109897
      GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(2110006), // Rule ID 14910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14910,
        GIR_EraseRootFromParent_Done,
      // Label 25842: @2110006
      GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(2110115), // Rule ID 14911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14911,
        GIR_EraseRootFromParent_Done,
      // Label 25843: @2110115
      GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(2110224), // Rule ID 14914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14914,
        GIR_EraseRootFromParent_Done,
      // Label 25844: @2110224
      GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(2110333), // Rule ID 14915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14915,
        GIR_EraseRootFromParent_Done,
      // Label 25845: @2110333
      GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(2110442), // Rule ID 14918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14918,
        GIR_EraseRootFromParent_Done,
      // Label 25846: @2110442
      GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(2110551), // Rule ID 14919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14919,
        GIR_EraseRootFromParent_Done,
      // Label 25847: @2110551
      GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(2110660), // Rule ID 14922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14922,
        GIR_EraseRootFromParent_Done,
      // Label 25848: @2110660
      GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(2110769), // Rule ID 14923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14923,
        GIR_EraseRootFromParent_Done,
      // Label 25849: @2110769
      GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(2110878), // Rule ID 14926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14926,
        GIR_EraseRootFromParent_Done,
      // Label 25850: @2110878
      GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(2110987), // Rule ID 14927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14927,
        GIR_EraseRootFromParent_Done,
      // Label 25851: @2110987
      GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(2111096), // Rule ID 14930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14930,
        GIR_EraseRootFromParent_Done,
      // Label 25852: @2111096
      GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(2111205), // Rule ID 14931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14931,
        GIR_EraseRootFromParent_Done,
      // Label 25853: @2111205
      GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(2111314), // Rule ID 14934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14934,
        GIR_EraseRootFromParent_Done,
      // Label 25854: @2111314
      GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(2111423), // Rule ID 14935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14935,
        GIR_EraseRootFromParent_Done,
      // Label 25855: @2111423
      GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(2111532), // Rule ID 14938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14938,
        GIR_EraseRootFromParent_Done,
      // Label 25856: @2111532
      GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(2111641), // Rule ID 14939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14939,
        GIR_EraseRootFromParent_Done,
      // Label 25857: @2111641
      GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(2111750), // Rule ID 14942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14942,
        GIR_EraseRootFromParent_Done,
      // Label 25858: @2111750
      GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(2111859), // Rule ID 14943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14943,
        GIR_EraseRootFromParent_Done,
      // Label 25859: @2111859
      GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(2111968), // Rule ID 14946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14946,
        GIR_EraseRootFromParent_Done,
      // Label 25860: @2111968
      GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(2112077), // Rule ID 14947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10748:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14947,
        GIR_EraseRootFromParent_Done,
      // Label 25861: @2112077
      GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(2112186), // Rule ID 14950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14950,
        GIR_EraseRootFromParent_Done,
      // Label 25862: @2112186
      GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(2112295), // Rule ID 14951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10748:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14951,
        GIR_EraseRootFromParent_Done,
      // Label 25863: @2112295
      GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(2112404), // Rule ID 14954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14954,
        GIR_EraseRootFromParent_Done,
      // Label 25864: @2112404
      GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(2112513), // Rule ID 14955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10748:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14955,
        GIR_EraseRootFromParent_Done,
      // Label 25865: @2112513
      GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(2112622), // Rule ID 14958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14958,
        GIR_EraseRootFromParent_Done,
      // Label 25866: @2112622
      GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(2112731), // Rule ID 14959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14959,
        GIR_EraseRootFromParent_Done,
      // Label 25867: @2112731
      GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(2112840), // Rule ID 14962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14962,
        GIR_EraseRootFromParent_Done,
      // Label 25868: @2112840
      GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(2112949), // Rule ID 14963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14963,
        GIR_EraseRootFromParent_Done,
      // Label 25869: @2112949
      GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(2113058), // Rule ID 14966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14966,
        GIR_EraseRootFromParent_Done,
      // Label 25870: @2113058
      GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(2113167), // Rule ID 14967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14967,
        GIR_EraseRootFromParent_Done,
      // Label 25871: @2113167
      GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(2113276), // Rule ID 14970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14970,
        GIR_EraseRootFromParent_Done,
      // Label 25872: @2113276
      GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(2113385), // Rule ID 14971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14971,
        GIR_EraseRootFromParent_Done,
      // Label 25873: @2113385
      GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(2113494), // Rule ID 14974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14974,
        GIR_EraseRootFromParent_Done,
      // Label 25874: @2113494
      GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(2113603), // Rule ID 14975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14975,
        GIR_EraseRootFromParent_Done,
      // Label 25875: @2113603
      GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(2113712), // Rule ID 14978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14978,
        GIR_EraseRootFromParent_Done,
      // Label 25876: @2113712
      GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(2113821), // Rule ID 14979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14979,
        GIR_EraseRootFromParent_Done,
      // Label 25877: @2113821
      GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(2113930), // Rule ID 14982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14982,
        GIR_EraseRootFromParent_Done,
      // Label 25878: @2113930
      GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(2114039), // Rule ID 14983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14983,
        GIR_EraseRootFromParent_Done,
      // Label 25879: @2114039
      GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(2114148), // Rule ID 14986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14986,
        GIR_EraseRootFromParent_Done,
      // Label 25880: @2114148
      GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(2114257), // Rule ID 14987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14987,
        GIR_EraseRootFromParent_Done,
      // Label 25881: @2114257
      GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(2114366), // Rule ID 14990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14990,
        GIR_EraseRootFromParent_Done,
      // Label 25882: @2114366
      GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(2114475), // Rule ID 14991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14991,
        GIR_EraseRootFromParent_Done,
      // Label 25883: @2114475
      GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(2114584), // Rule ID 14994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14994,
        GIR_EraseRootFromParent_Done,
      // Label 25884: @2114584
      GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(2114693), // Rule ID 14995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14995,
        GIR_EraseRootFromParent_Done,
      // Label 25885: @2114693
      GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(2114802), // Rule ID 14998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14998,
        GIR_EraseRootFromParent_Done,
      // Label 25886: @2114802
      GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(2114911), // Rule ID 14999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14999,
        GIR_EraseRootFromParent_Done,
      // Label 25887: @2114911
      GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(2115020), // Rule ID 15002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15002,
        GIR_EraseRootFromParent_Done,
      // Label 25888: @2115020
      GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(2115129), // Rule ID 15003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15003,
        GIR_EraseRootFromParent_Done,
      // Label 25889: @2115129
      GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(2115238), // Rule ID 15006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15006,
        GIR_EraseRootFromParent_Done,
      // Label 25890: @2115238
      GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(2115347), // Rule ID 15007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15007,
        GIR_EraseRootFromParent_Done,
      // Label 25891: @2115347
      GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(2115456), // Rule ID 15010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15010,
        GIR_EraseRootFromParent_Done,
      // Label 25892: @2115456
      GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(2115565), // Rule ID 15011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15011,
        GIR_EraseRootFromParent_Done,
      // Label 25893: @2115565
      GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(2115674), // Rule ID 15014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15014,
        GIR_EraseRootFromParent_Done,
      // Label 25894: @2115674
      GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(2115783), // Rule ID 15015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15015,
        GIR_EraseRootFromParent_Done,
      // Label 25895: @2115783
      GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(2115892), // Rule ID 15018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15018,
        GIR_EraseRootFromParent_Done,
      // Label 25896: @2115892
      GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(2116001), // Rule ID 15019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15019,
        GIR_EraseRootFromParent_Done,
      // Label 25897: @2116001
      GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(2116110), // Rule ID 15022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15022,
        GIR_EraseRootFromParent_Done,
      // Label 25898: @2116110
      GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(2116219), // Rule ID 15023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15023,
        GIR_EraseRootFromParent_Done,
      // Label 25899: @2116219
      GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(2116328), // Rule ID 15026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15026,
        GIR_EraseRootFromParent_Done,
      // Label 25900: @2116328
      GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(2116437), // Rule ID 15027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15027,
        GIR_EraseRootFromParent_Done,
      // Label 25901: @2116437
      GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(2116546), // Rule ID 15030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15030,
        GIR_EraseRootFromParent_Done,
      // Label 25902: @2116546
      GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(2116655), // Rule ID 15031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15031,
        GIR_EraseRootFromParent_Done,
      // Label 25903: @2116655
      GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(2116764), // Rule ID 15034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15034,
        GIR_EraseRootFromParent_Done,
      // Label 25904: @2116764
      GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(2116873), // Rule ID 15035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15035,
        GIR_EraseRootFromParent_Done,
      // Label 25905: @2116873
      GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(2116982), // Rule ID 15038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15038,
        GIR_EraseRootFromParent_Done,
      // Label 25906: @2116982
      GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(2117091), // Rule ID 15039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15039,
        GIR_EraseRootFromParent_Done,
      // Label 25907: @2117091
      GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(2117200), // Rule ID 15042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15042,
        GIR_EraseRootFromParent_Done,
      // Label 25908: @2117200
      GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(2117309), // Rule ID 15043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15043,
        GIR_EraseRootFromParent_Done,
      // Label 25909: @2117309
      GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(2117418), // Rule ID 15046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15046,
        GIR_EraseRootFromParent_Done,
      // Label 25910: @2117418
      GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(2117527), // Rule ID 15047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15047,
        GIR_EraseRootFromParent_Done,
      // Label 25911: @2117527
      GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(2117636), // Rule ID 15050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15050,
        GIR_EraseRootFromParent_Done,
      // Label 25912: @2117636
      GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(2117745), // Rule ID 15051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15051,
        GIR_EraseRootFromParent_Done,
      // Label 25913: @2117745
      GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(2117854), // Rule ID 15054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15054,
        GIR_EraseRootFromParent_Done,
      // Label 25914: @2117854
      GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(2117963), // Rule ID 15055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15055,
        GIR_EraseRootFromParent_Done,
      // Label 25915: @2117963
      GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(2118072), // Rule ID 15058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15058,
        GIR_EraseRootFromParent_Done,
      // Label 25916: @2118072
      GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(2118181), // Rule ID 15059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15059,
        GIR_EraseRootFromParent_Done,
      // Label 25917: @2118181
      GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(2118290), // Rule ID 15062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15062,
        GIR_EraseRootFromParent_Done,
      // Label 25918: @2118290
      GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(2118399), // Rule ID 15063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15063,
        GIR_EraseRootFromParent_Done,
      // Label 25919: @2118399
      GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(2118508), // Rule ID 15066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15066,
        GIR_EraseRootFromParent_Done,
      // Label 25920: @2118508
      GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(2118617), // Rule ID 15067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15067,
        GIR_EraseRootFromParent_Done,
      // Label 25921: @2118617
      GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(2118726), // Rule ID 15070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15070,
        GIR_EraseRootFromParent_Done,
      // Label 25922: @2118726
      GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(2118835), // Rule ID 15071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10770:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15071,
        GIR_EraseRootFromParent_Done,
      // Label 25923: @2118835
      GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(2118944), // Rule ID 15074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15074,
        GIR_EraseRootFromParent_Done,
      // Label 25924: @2118944
      GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(2119053), // Rule ID 15075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10770:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15075,
        GIR_EraseRootFromParent_Done,
      // Label 25925: @2119053
      GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(2119162), // Rule ID 15078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15078,
        GIR_EraseRootFromParent_Done,
      // Label 25926: @2119162
      GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(2119271), // Rule ID 15079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10770:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15079,
        GIR_EraseRootFromParent_Done,
      // Label 25927: @2119271
      GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(2119380), // Rule ID 15082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15082,
        GIR_EraseRootFromParent_Done,
      // Label 25928: @2119380
      GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(2119489), // Rule ID 15083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10770:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15083,
        GIR_EraseRootFromParent_Done,
      // Label 25929: @2119489
      GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(2119598), // Rule ID 15086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15086,
        GIR_EraseRootFromParent_Done,
      // Label 25930: @2119598
      GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(2119707), // Rule ID 15087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15087,
        GIR_EraseRootFromParent_Done,
      // Label 25931: @2119707
      GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(2119816), // Rule ID 15090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15090,
        GIR_EraseRootFromParent_Done,
      // Label 25932: @2119816
      GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(2119925), // Rule ID 15091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15091,
        GIR_EraseRootFromParent_Done,
      // Label 25933: @2119925
      GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(2120034), // Rule ID 15094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15094,
        GIR_EraseRootFromParent_Done,
      // Label 25934: @2120034
      GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(2120143), // Rule ID 15095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15095,
        GIR_EraseRootFromParent_Done,
      // Label 25935: @2120143
      GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(2120252), // Rule ID 15098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15098,
        GIR_EraseRootFromParent_Done,
      // Label 25936: @2120252
      GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(2120361), // Rule ID 15099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15099,
        GIR_EraseRootFromParent_Done,
      // Label 25937: @2120361
      GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(2120470), // Rule ID 15102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15102,
        GIR_EraseRootFromParent_Done,
      // Label 25938: @2120470
      GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(2120579), // Rule ID 15103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15103,
        GIR_EraseRootFromParent_Done,
      // Label 25939: @2120579
      GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(2120688), // Rule ID 15106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15106,
        GIR_EraseRootFromParent_Done,
      // Label 25940: @2120688
      GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(2120797), // Rule ID 15107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15107,
        GIR_EraseRootFromParent_Done,
      // Label 25941: @2120797
      GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(2120906), // Rule ID 15110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15110,
        GIR_EraseRootFromParent_Done,
      // Label 25942: @2120906
      GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(2121015), // Rule ID 15111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15111,
        GIR_EraseRootFromParent_Done,
      // Label 25943: @2121015
      GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(2121124), // Rule ID 15114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15114,
        GIR_EraseRootFromParent_Done,
      // Label 25944: @2121124
      GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(2121233), // Rule ID 15115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15115,
        GIR_EraseRootFromParent_Done,
      // Label 25945: @2121233
      GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(2121342), // Rule ID 15118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15118,
        GIR_EraseRootFromParent_Done,
      // Label 25946: @2121342
      GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(2121451), // Rule ID 15119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15119,
        GIR_EraseRootFromParent_Done,
      // Label 25947: @2121451
      GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(2121560), // Rule ID 15122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15122,
        GIR_EraseRootFromParent_Done,
      // Label 25948: @2121560
      GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(2121669), // Rule ID 15123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10770:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15123,
        GIR_EraseRootFromParent_Done,
      // Label 25949: @2121669
      GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(2121778), // Rule ID 15126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15126,
        GIR_EraseRootFromParent_Done,
      // Label 25950: @2121778
      GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(2121887), // Rule ID 15127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10770:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15127,
        GIR_EraseRootFromParent_Done,
      // Label 25951: @2121887
      GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(2121996), // Rule ID 15130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15130,
        GIR_EraseRootFromParent_Done,
      // Label 25952: @2121996
      GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(2122105), // Rule ID 15131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10770:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15131,
        GIR_EraseRootFromParent_Done,
      // Label 25953: @2122105
      GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(2122214), // Rule ID 15134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15134,
        GIR_EraseRootFromParent_Done,
      // Label 25954: @2122214
      GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(2122323), // Rule ID 15135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15135,
        GIR_EraseRootFromParent_Done,
      // Label 25955: @2122323
      GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(2122432), // Rule ID 15138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15138,
        GIR_EraseRootFromParent_Done,
      // Label 25956: @2122432
      GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(2122541), // Rule ID 15139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15139,
        GIR_EraseRootFromParent_Done,
      // Label 25957: @2122541
      GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(2122650), // Rule ID 15142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15142,
        GIR_EraseRootFromParent_Done,
      // Label 25958: @2122650
      GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(2122759), // Rule ID 15143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15143,
        GIR_EraseRootFromParent_Done,
      // Label 25959: @2122759
      GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(2122868), // Rule ID 15146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15146,
        GIR_EraseRootFromParent_Done,
      // Label 25960: @2122868
      GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(2122977), // Rule ID 15147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15147,
        GIR_EraseRootFromParent_Done,
      // Label 25961: @2122977
      GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(2123086), // Rule ID 15150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15150,
        GIR_EraseRootFromParent_Done,
      // Label 25962: @2123086
      GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(2123195), // Rule ID 15151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15151,
        GIR_EraseRootFromParent_Done,
      // Label 25963: @2123195
      GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(2123304), // Rule ID 15154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15154,
        GIR_EraseRootFromParent_Done,
      // Label 25964: @2123304
      GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(2123413), // Rule ID 15155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15155,
        GIR_EraseRootFromParent_Done,
      // Label 25965: @2123413
      GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(2123522), // Rule ID 15158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15158,
        GIR_EraseRootFromParent_Done,
      // Label 25966: @2123522
      GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(2123631), // Rule ID 15159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15159,
        GIR_EraseRootFromParent_Done,
      // Label 25967: @2123631
      GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(2123740), // Rule ID 15162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15162,
        GIR_EraseRootFromParent_Done,
      // Label 25968: @2123740
      GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(2123849), // Rule ID 15163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15163,
        GIR_EraseRootFromParent_Done,
      // Label 25969: @2123849
      GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(2123958), // Rule ID 15166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15166,
        GIR_EraseRootFromParent_Done,
      // Label 25970: @2123958
      GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(2124067), // Rule ID 15167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15167,
        GIR_EraseRootFromParent_Done,
      // Label 25971: @2124067
      GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(2124176), // Rule ID 15170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15170,
        GIR_EraseRootFromParent_Done,
      // Label 25972: @2124176
      GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(2124285), // Rule ID 15171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15171,
        GIR_EraseRootFromParent_Done,
      // Label 25973: @2124285
      GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(2124394), // Rule ID 15174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15174,
        GIR_EraseRootFromParent_Done,
      // Label 25974: @2124394
      GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(2124503), // Rule ID 15175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15175,
        GIR_EraseRootFromParent_Done,
      // Label 25975: @2124503
      GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(2124612), // Rule ID 15178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15178,
        GIR_EraseRootFromParent_Done,
      // Label 25976: @2124612
      GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(2124721), // Rule ID 15179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15179,
        GIR_EraseRootFromParent_Done,
      // Label 25977: @2124721
      GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(2124830), // Rule ID 15182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15182,
        GIR_EraseRootFromParent_Done,
      // Label 25978: @2124830
      GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(2124939), // Rule ID 15183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15183,
        GIR_EraseRootFromParent_Done,
      // Label 25979: @2124939
      GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(2125048), // Rule ID 15186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15186,
        GIR_EraseRootFromParent_Done,
      // Label 25980: @2125048
      GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(2125157), // Rule ID 15187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15187,
        GIR_EraseRootFromParent_Done,
      // Label 25981: @2125157
      GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(2125266), // Rule ID 15190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15190,
        GIR_EraseRootFromParent_Done,
      // Label 25982: @2125266
      GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(2125375), // Rule ID 15191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15191,
        GIR_EraseRootFromParent_Done,
      // Label 25983: @2125375
      GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(2125484), // Rule ID 15194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15194,
        GIR_EraseRootFromParent_Done,
      // Label 25984: @2125484
      GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(2125593), // Rule ID 15195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15195,
        GIR_EraseRootFromParent_Done,
      // Label 25985: @2125593
      GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(2125702), // Rule ID 15198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15198,
        GIR_EraseRootFromParent_Done,
      // Label 25986: @2125702
      GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(2125811), // Rule ID 15199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15199,
        GIR_EraseRootFromParent_Done,
      // Label 25987: @2125811
      GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(2125920), // Rule ID 15202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15202,
        GIR_EraseRootFromParent_Done,
      // Label 25988: @2125920
      GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(2126029), // Rule ID 15203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15203,
        GIR_EraseRootFromParent_Done,
      // Label 25989: @2126029
      GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(2126138), // Rule ID 15206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15206,
        GIR_EraseRootFromParent_Done,
      // Label 25990: @2126138
      GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(2126247), // Rule ID 15207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15207,
        GIR_EraseRootFromParent_Done,
      // Label 25991: @2126247
      GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(2126356), // Rule ID 15210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15210,
        GIR_EraseRootFromParent_Done,
      // Label 25992: @2126356
      GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(2126465), // Rule ID 15211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15211,
        GIR_EraseRootFromParent_Done,
      // Label 25993: @2126465
      GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(2126574), // Rule ID 15214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15214,
        GIR_EraseRootFromParent_Done,
      // Label 25994: @2126574
      GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(2126683), // Rule ID 15215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15215,
        GIR_EraseRootFromParent_Done,
      // Label 25995: @2126683
      GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(2126792), // Rule ID 15218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15218,
        GIR_EraseRootFromParent_Done,
      // Label 25996: @2126792
      GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(2126901), // Rule ID 15219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15219,
        GIR_EraseRootFromParent_Done,
      // Label 25997: @2126901
      GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(2127010), // Rule ID 15222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15222,
        GIR_EraseRootFromParent_Done,
      // Label 25998: @2127010
      GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(2127119), // Rule ID 15223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15223,
        GIR_EraseRootFromParent_Done,
      // Label 25999: @2127119
      GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(2127228), // Rule ID 15226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15226,
        GIR_EraseRootFromParent_Done,
      // Label 26000: @2127228
      GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(2127337), // Rule ID 15227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15227,
        GIR_EraseRootFromParent_Done,
      // Label 26001: @2127337
      GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(2127446), // Rule ID 15230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15230,
        GIR_EraseRootFromParent_Done,
      // Label 26002: @2127446
      GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(2127555), // Rule ID 15231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15231,
        GIR_EraseRootFromParent_Done,
      // Label 26003: @2127555
      GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(2127664), // Rule ID 15234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15234,
        GIR_EraseRootFromParent_Done,
      // Label 26004: @2127664
      GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(2127773), // Rule ID 15235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15235,
        GIR_EraseRootFromParent_Done,
      // Label 26005: @2127773
      GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(2127882), // Rule ID 15238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15238,
        GIR_EraseRootFromParent_Done,
      // Label 26006: @2127882
      GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(2127991), // Rule ID 15239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15239,
        GIR_EraseRootFromParent_Done,
      // Label 26007: @2127991
      GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(2128100), // Rule ID 15242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15242,
        GIR_EraseRootFromParent_Done,
      // Label 26008: @2128100
      GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(2128209), // Rule ID 15243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15243,
        GIR_EraseRootFromParent_Done,
      // Label 26009: @2128209
      GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(2128318), // Rule ID 15246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15246,
        GIR_EraseRootFromParent_Done,
      // Label 26010: @2128318
      GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(2128427), // Rule ID 15247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10768:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15247,
        GIR_EraseRootFromParent_Done,
      // Label 26011: @2128427
      GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(2128536), // Rule ID 15250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15250,
        GIR_EraseRootFromParent_Done,
      // Label 26012: @2128536
      GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(2128645), // Rule ID 15251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10768:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15251,
        GIR_EraseRootFromParent_Done,
      // Label 26013: @2128645
      GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(2128754), // Rule ID 15254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15254,
        GIR_EraseRootFromParent_Done,
      // Label 26014: @2128754
      GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(2128863), // Rule ID 15255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10768:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15255,
        GIR_EraseRootFromParent_Done,
      // Label 26015: @2128863
      GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(2128972), // Rule ID 15258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15258,
        GIR_EraseRootFromParent_Done,
      // Label 26016: @2128972
      GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(2129081), // Rule ID 15259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10768:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15259,
        GIR_EraseRootFromParent_Done,
      // Label 26017: @2129081
      GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(2129190), // Rule ID 15262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15262,
        GIR_EraseRootFromParent_Done,
      // Label 26018: @2129190
      GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(2129299), // Rule ID 15263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15263,
        GIR_EraseRootFromParent_Done,
      // Label 26019: @2129299
      GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(2129408), // Rule ID 15266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15266,
        GIR_EraseRootFromParent_Done,
      // Label 26020: @2129408
      GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(2129517), // Rule ID 15267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15267,
        GIR_EraseRootFromParent_Done,
      // Label 26021: @2129517
      GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(2129626), // Rule ID 15270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15270,
        GIR_EraseRootFromParent_Done,
      // Label 26022: @2129626
      GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(2129735), // Rule ID 15271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15271,
        GIR_EraseRootFromParent_Done,
      // Label 26023: @2129735
      GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(2129844), // Rule ID 15274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15274,
        GIR_EraseRootFromParent_Done,
      // Label 26024: @2129844
      GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(2129953), // Rule ID 15275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15275,
        GIR_EraseRootFromParent_Done,
      // Label 26025: @2129953
      GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(2130062), // Rule ID 15278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15278,
        GIR_EraseRootFromParent_Done,
      // Label 26026: @2130062
      GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(2130171), // Rule ID 15279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15279,
        GIR_EraseRootFromParent_Done,
      // Label 26027: @2130171
      GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(2130280), // Rule ID 15282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15282,
        GIR_EraseRootFromParent_Done,
      // Label 26028: @2130280
      GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(2130389), // Rule ID 15283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15283,
        GIR_EraseRootFromParent_Done,
      // Label 26029: @2130389
      GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(2130498), // Rule ID 15286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15286,
        GIR_EraseRootFromParent_Done,
      // Label 26030: @2130498
      GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(2130607), // Rule ID 15287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15287,
        GIR_EraseRootFromParent_Done,
      // Label 26031: @2130607
      GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(2130716), // Rule ID 15290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15290,
        GIR_EraseRootFromParent_Done,
      // Label 26032: @2130716
      GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(2130825), // Rule ID 15291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15291,
        GIR_EraseRootFromParent_Done,
      // Label 26033: @2130825
      GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(2130934), // Rule ID 15294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15294,
        GIR_EraseRootFromParent_Done,
      // Label 26034: @2130934
      GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(2131043), // Rule ID 15295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15295,
        GIR_EraseRootFromParent_Done,
      // Label 26035: @2131043
      GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(2131152), // Rule ID 15298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15298,
        GIR_EraseRootFromParent_Done,
      // Label 26036: @2131152
      GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(2131261), // Rule ID 15299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10768:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15299,
        GIR_EraseRootFromParent_Done,
      // Label 26037: @2131261
      GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(2131370), // Rule ID 15302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15302,
        GIR_EraseRootFromParent_Done,
      // Label 26038: @2131370
      GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(2131479), // Rule ID 15303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10768:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15303,
        GIR_EraseRootFromParent_Done,
      // Label 26039: @2131479
      GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(2131588), // Rule ID 15306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15306,
        GIR_EraseRootFromParent_Done,
      // Label 26040: @2131588
      GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(2131697), // Rule ID 15307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10768:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15307,
        GIR_EraseRootFromParent_Done,
      // Label 26041: @2131697
      GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(2131806), // Rule ID 15310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15310,
        GIR_EraseRootFromParent_Done,
      // Label 26042: @2131806
      GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(2131915), // Rule ID 15311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15311,
        GIR_EraseRootFromParent_Done,
      // Label 26043: @2131915
      GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(2132024), // Rule ID 15314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15314,
        GIR_EraseRootFromParent_Done,
      // Label 26044: @2132024
      GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(2132133), // Rule ID 15315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15315,
        GIR_EraseRootFromParent_Done,
      // Label 26045: @2132133
      GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(2132242), // Rule ID 15318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15318,
        GIR_EraseRootFromParent_Done,
      // Label 26046: @2132242
      GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(2132351), // Rule ID 15319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15319,
        GIR_EraseRootFromParent_Done,
      // Label 26047: @2132351
      GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(2132460), // Rule ID 15322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15322,
        GIR_EraseRootFromParent_Done,
      // Label 26048: @2132460
      GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(2132569), // Rule ID 15323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15323,
        GIR_EraseRootFromParent_Done,
      // Label 26049: @2132569
      GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(2132678), // Rule ID 15326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15326,
        GIR_EraseRootFromParent_Done,
      // Label 26050: @2132678
      GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(2132787), // Rule ID 15327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15327,
        GIR_EraseRootFromParent_Done,
      // Label 26051: @2132787
      GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(2132896), // Rule ID 15330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15330,
        GIR_EraseRootFromParent_Done,
      // Label 26052: @2132896
      GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(2133005), // Rule ID 15331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15331,
        GIR_EraseRootFromParent_Done,
      // Label 26053: @2133005
      GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(2133114), // Rule ID 15334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15334,
        GIR_EraseRootFromParent_Done,
      // Label 26054: @2133114
      GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(2133223), // Rule ID 15335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15335,
        GIR_EraseRootFromParent_Done,
      // Label 26055: @2133223
      GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(2133332), // Rule ID 15338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15338,
        GIR_EraseRootFromParent_Done,
      // Label 26056: @2133332
      GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(2133441), // Rule ID 15339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15339,
        GIR_EraseRootFromParent_Done,
      // Label 26057: @2133441
      GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(2133550), // Rule ID 15342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15342,
        GIR_EraseRootFromParent_Done,
      // Label 26058: @2133550
      GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(2133659), // Rule ID 15343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15343,
        GIR_EraseRootFromParent_Done,
      // Label 26059: @2133659
      GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(2133768), // Rule ID 15346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15346,
        GIR_EraseRootFromParent_Done,
      // Label 26060: @2133768
      GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(2133877), // Rule ID 15347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15347,
        GIR_EraseRootFromParent_Done,
      // Label 26061: @2133877
      GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(2133986), // Rule ID 15350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15350,
        GIR_EraseRootFromParent_Done,
      // Label 26062: @2133986
      GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(2134095), // Rule ID 15351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15351,
        GIR_EraseRootFromParent_Done,
      // Label 26063: @2134095
      GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(2134204), // Rule ID 15354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15354,
        GIR_EraseRootFromParent_Done,
      // Label 26064: @2134204
      GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(2134313), // Rule ID 15355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15355,
        GIR_EraseRootFromParent_Done,
      // Label 26065: @2134313
      GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(2134422), // Rule ID 15358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15358,
        GIR_EraseRootFromParent_Done,
      // Label 26066: @2134422
      GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(2134531), // Rule ID 15359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15359,
        GIR_EraseRootFromParent_Done,
      // Label 26067: @2134531
      GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(2134640), // Rule ID 15362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15362,
        GIR_EraseRootFromParent_Done,
      // Label 26068: @2134640
      GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(2134749), // Rule ID 15363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15363,
        GIR_EraseRootFromParent_Done,
      // Label 26069: @2134749
      GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(2134858), // Rule ID 15366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15366,
        GIR_EraseRootFromParent_Done,
      // Label 26070: @2134858
      GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(2134967), // Rule ID 15367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15367,
        GIR_EraseRootFromParent_Done,
      // Label 26071: @2134967
      GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(2135076), // Rule ID 15370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15370,
        GIR_EraseRootFromParent_Done,
      // Label 26072: @2135076
      GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(2135185), // Rule ID 15371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15371,
        GIR_EraseRootFromParent_Done,
      // Label 26073: @2135185
      GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(2135294), // Rule ID 15374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15374,
        GIR_EraseRootFromParent_Done,
      // Label 26074: @2135294
      GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(2135403), // Rule ID 15375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15375,
        GIR_EraseRootFromParent_Done,
      // Label 26075: @2135403
      GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(2135512), // Rule ID 15378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15378,
        GIR_EraseRootFromParent_Done,
      // Label 26076: @2135512
      GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(2135621), // Rule ID 15379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15379,
        GIR_EraseRootFromParent_Done,
      // Label 26077: @2135621
      GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(2135730), // Rule ID 15382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15382,
        GIR_EraseRootFromParent_Done,
      // Label 26078: @2135730
      GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(2135839), // Rule ID 15383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15383,
        GIR_EraseRootFromParent_Done,
      // Label 26079: @2135839
      GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(2135948), // Rule ID 15386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15386,
        GIR_EraseRootFromParent_Done,
      // Label 26080: @2135948
      GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(2136057), // Rule ID 15387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15387,
        GIR_EraseRootFromParent_Done,
      // Label 26081: @2136057
      GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(2136166), // Rule ID 15390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15390,
        GIR_EraseRootFromParent_Done,
      // Label 26082: @2136166
      GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(2136275), // Rule ID 15391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15391,
        GIR_EraseRootFromParent_Done,
      // Label 26083: @2136275
      GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(2136384), // Rule ID 15394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15394,
        GIR_EraseRootFromParent_Done,
      // Label 26084: @2136384
      GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(2136493), // Rule ID 15395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15395,
        GIR_EraseRootFromParent_Done,
      // Label 26085: @2136493
      GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(2136602), // Rule ID 15398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15398,
        GIR_EraseRootFromParent_Done,
      // Label 26086: @2136602
      GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(2136711), // Rule ID 15399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15399,
        GIR_EraseRootFromParent_Done,
      // Label 26087: @2136711
      GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(2136820), // Rule ID 15402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15402,
        GIR_EraseRootFromParent_Done,
      // Label 26088: @2136820
      GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(2136929), // Rule ID 15403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15403,
        GIR_EraseRootFromParent_Done,
      // Label 26089: @2136929
      GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(2137038), // Rule ID 15406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15406,
        GIR_EraseRootFromParent_Done,
      // Label 26090: @2137038
      GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(2137147), // Rule ID 15407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15407,
        GIR_EraseRootFromParent_Done,
      // Label 26091: @2137147
      GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(2137256), // Rule ID 15410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15410,
        GIR_EraseRootFromParent_Done,
      // Label 26092: @2137256
      GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(2137365), // Rule ID 15411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15411,
        GIR_EraseRootFromParent_Done,
      // Label 26093: @2137365
      GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(2137474), // Rule ID 15414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15414,
        GIR_EraseRootFromParent_Done,
      // Label 26094: @2137474
      GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(2137583), // Rule ID 15415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15415,
        GIR_EraseRootFromParent_Done,
      // Label 26095: @2137583
      GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(2137692), // Rule ID 15418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15418,
        GIR_EraseRootFromParent_Done,
      // Label 26096: @2137692
      GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(2137801), // Rule ID 15419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15419,
        GIR_EraseRootFromParent_Done,
      // Label 26097: @2137801
      GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(2137910), // Rule ID 15422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15422,
        GIR_EraseRootFromParent_Done,
      // Label 26098: @2137910
      GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(2138019), // Rule ID 15423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10746:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15423,
        GIR_EraseRootFromParent_Done,
      // Label 26099: @2138019
      GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(2138128), // Rule ID 15426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15426,
        GIR_EraseRootFromParent_Done,
      // Label 26100: @2138128
      GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(2138237), // Rule ID 15427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 10746:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15427,
        GIR_EraseRootFromParent_Done,
      // Label 26101: @2138237
      GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(2138346), // Rule ID 15430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15430,
        GIR_EraseRootFromParent_Done,
      // Label 26102: @2138346
      GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(2138455), // Rule ID 15431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 10746:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15431,
        GIR_EraseRootFromParent_Done,
      // Label 26103: @2138455
      GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(2138564), // Rule ID 15434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15434,
        GIR_EraseRootFromParent_Done,
      // Label 26104: @2138564
      GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(2138673), // Rule ID 15435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 10746:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15435,
        GIR_EraseRootFromParent_Done,
      // Label 26105: @2138673
      GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(2138782), // Rule ID 15438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15438,
        GIR_EraseRootFromParent_Done,
      // Label 26106: @2138782
      GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(2138891), // Rule ID 15439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15439,
        GIR_EraseRootFromParent_Done,
      // Label 26107: @2138891
      GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(2139000), // Rule ID 15442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15442,
        GIR_EraseRootFromParent_Done,
      // Label 26108: @2139000
      GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(2139109), // Rule ID 15443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15443,
        GIR_EraseRootFromParent_Done,
      // Label 26109: @2139109
      GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(2139218), // Rule ID 15446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15446,
        GIR_EraseRootFromParent_Done,
      // Label 26110: @2139218
      GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(2139327), // Rule ID 15447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15447,
        GIR_EraseRootFromParent_Done,
      // Label 26111: @2139327
      GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(2139436), // Rule ID 15450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15450,
        GIR_EraseRootFromParent_Done,
      // Label 26112: @2139436
      GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(2139545), // Rule ID 15451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15451,
        GIR_EraseRootFromParent_Done,
      // Label 26113: @2139545
      GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(2139654), // Rule ID 15454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15454,
        GIR_EraseRootFromParent_Done,
      // Label 26114: @2139654
      GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(2139763), // Rule ID 15455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15455,
        GIR_EraseRootFromParent_Done,
      // Label 26115: @2139763
      GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(2139872), // Rule ID 15458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15458,
        GIR_EraseRootFromParent_Done,
      // Label 26116: @2139872
      GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(2139981), // Rule ID 15459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15459,
        GIR_EraseRootFromParent_Done,
      // Label 26117: @2139981
      GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(2140090), // Rule ID 15462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15462,
        GIR_EraseRootFromParent_Done,
      // Label 26118: @2140090
      GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(2140199), // Rule ID 15463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15463,
        GIR_EraseRootFromParent_Done,
      // Label 26119: @2140199
      GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(2140308), // Rule ID 15466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15466,
        GIR_EraseRootFromParent_Done,
      // Label 26120: @2140308
      GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(2140417), // Rule ID 15467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15467,
        GIR_EraseRootFromParent_Done,
      // Label 26121: @2140417
      GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(2140526), // Rule ID 15470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15470,
        GIR_EraseRootFromParent_Done,
      // Label 26122: @2140526
      GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(2140635), // Rule ID 15471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15471,
        GIR_EraseRootFromParent_Done,
      // Label 26123: @2140635
      GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(2140744), // Rule ID 15474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15474,
        GIR_EraseRootFromParent_Done,
      // Label 26124: @2140744
      GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(2140853), // Rule ID 15475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 10746:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15475,
        GIR_EraseRootFromParent_Done,
      // Label 26125: @2140853
      GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(2140962), // Rule ID 15478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15478,
        GIR_EraseRootFromParent_Done,
      // Label 26126: @2140962
      GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(2141071), // Rule ID 15479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 10746:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15479,
        GIR_EraseRootFromParent_Done,
      // Label 26127: @2141071
      GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(2141180), // Rule ID 15482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15482,
        GIR_EraseRootFromParent_Done,
      // Label 26128: @2141180
      GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(2141289), // Rule ID 15483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 10746:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15483,
        GIR_EraseRootFromParent_Done,
      // Label 26129: @2141289
      GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(2141401), // Rule ID 15486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15486,
        GIR_EraseRootFromParent_Done,
      // Label 26130: @2141401
      GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(2141513), // Rule ID 15487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15487,
        GIR_EraseRootFromParent_Done,
      // Label 26131: @2141513
      GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(2141625), // Rule ID 15490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15490,
        GIR_EraseRootFromParent_Done,
      // Label 26132: @2141625
      GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(2141737), // Rule ID 15491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15491,
        GIR_EraseRootFromParent_Done,
      // Label 26133: @2141737
      GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(2141849), // Rule ID 15494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15494,
        GIR_EraseRootFromParent_Done,
      // Label 26134: @2141849
      GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(2141961), // Rule ID 15495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15495,
        GIR_EraseRootFromParent_Done,
      // Label 26135: @2141961
      GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(2142073), // Rule ID 15498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15498,
        GIR_EraseRootFromParent_Done,
      // Label 26136: @2142073
      GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(2142185), // Rule ID 15499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15499,
        GIR_EraseRootFromParent_Done,
      // Label 26137: @2142185
      GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(2142297), // Rule ID 15502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15502,
        GIR_EraseRootFromParent_Done,
      // Label 26138: @2142297
      GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(2142409), // Rule ID 15503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15503,
        GIR_EraseRootFromParent_Done,
      // Label 26139: @2142409
      GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(2142521), // Rule ID 15506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15506,
        GIR_EraseRootFromParent_Done,
      // Label 26140: @2142521
      GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(2142633), // Rule ID 15507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15507,
        GIR_EraseRootFromParent_Done,
      // Label 26141: @2142633
      GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(2142745), // Rule ID 15510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15510,
        GIR_EraseRootFromParent_Done,
      // Label 26142: @2142745
      GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(2142857), // Rule ID 15511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15511,
        GIR_EraseRootFromParent_Done,
      // Label 26143: @2142857
      GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(2142969), // Rule ID 15514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15514,
        GIR_EraseRootFromParent_Done,
      // Label 26144: @2142969
      GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(2143081), // Rule ID 15515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15515,
        GIR_EraseRootFromParent_Done,
      // Label 26145: @2143081
      GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(2143193), // Rule ID 15518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15518,
        GIR_EraseRootFromParent_Done,
      // Label 26146: @2143193
      GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(2143305), // Rule ID 15519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15519,
        GIR_EraseRootFromParent_Done,
      // Label 26147: @2143305
      GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(2143417), // Rule ID 15522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15522,
        GIR_EraseRootFromParent_Done,
      // Label 26148: @2143417
      GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(2143529), // Rule ID 15523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15523,
        GIR_EraseRootFromParent_Done,
      // Label 26149: @2143529
      GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(2143641), // Rule ID 15526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15526,
        GIR_EraseRootFromParent_Done,
      // Label 26150: @2143641
      GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(2143753), // Rule ID 15527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15527,
        GIR_EraseRootFromParent_Done,
      // Label 26151: @2143753
      GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(2143865), // Rule ID 15530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15530,
        GIR_EraseRootFromParent_Done,
      // Label 26152: @2143865
      GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(2143977), // Rule ID 15531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15531,
        GIR_EraseRootFromParent_Done,
      // Label 26153: @2143977
      GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(2144089), // Rule ID 15534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15534,
        GIR_EraseRootFromParent_Done,
      // Label 26154: @2144089
      GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(2144201), // Rule ID 15535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15535,
        GIR_EraseRootFromParent_Done,
      // Label 26155: @2144201
      GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(2144313), // Rule ID 15538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15538,
        GIR_EraseRootFromParent_Done,
      // Label 26156: @2144313
      GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(2144425), // Rule ID 15539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15539,
        GIR_EraseRootFromParent_Done,
      // Label 26157: @2144425
      GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(2144537), // Rule ID 15542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15542,
        GIR_EraseRootFromParent_Done,
      // Label 26158: @2144537
      GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(2144649), // Rule ID 15543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15543,
        GIR_EraseRootFromParent_Done,
      // Label 26159: @2144649
      GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(2144761), // Rule ID 15546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15546,
        GIR_EraseRootFromParent_Done,
      // Label 26160: @2144761
      GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(2144873), // Rule ID 15547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15547,
        GIR_EraseRootFromParent_Done,
      // Label 26161: @2144873
      GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(2144985), // Rule ID 15550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15550,
        GIR_EraseRootFromParent_Done,
      // Label 26162: @2144985
      GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(2145097), // Rule ID 15551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15551,
        GIR_EraseRootFromParent_Done,
      // Label 26163: @2145097
      GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(2145209), // Rule ID 15554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15554,
        GIR_EraseRootFromParent_Done,
      // Label 26164: @2145209
      GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(2145321), // Rule ID 15555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15555,
        GIR_EraseRootFromParent_Done,
      // Label 26165: @2145321
      GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(2145433), // Rule ID 15558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15558,
        GIR_EraseRootFromParent_Done,
      // Label 26166: @2145433
      GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(2145545), // Rule ID 15559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15559,
        GIR_EraseRootFromParent_Done,
      // Label 26167: @2145545
      GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(2145657), // Rule ID 15562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15562,
        GIR_EraseRootFromParent_Done,
      // Label 26168: @2145657
      GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(2145769), // Rule ID 15563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15563,
        GIR_EraseRootFromParent_Done,
      // Label 26169: @2145769
      GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(2145881), // Rule ID 15566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15566,
        GIR_EraseRootFromParent_Done,
      // Label 26170: @2145881
      GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(2145993), // Rule ID 15567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15567,
        GIR_EraseRootFromParent_Done,
      // Label 26171: @2145993
      GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(2146105), // Rule ID 15570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15570,
        GIR_EraseRootFromParent_Done,
      // Label 26172: @2146105
      GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(2146217), // Rule ID 15571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15571,
        GIR_EraseRootFromParent_Done,
      // Label 26173: @2146217
      GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(2146329), // Rule ID 15574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15574,
        GIR_EraseRootFromParent_Done,
      // Label 26174: @2146329
      GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(2146441), // Rule ID 15575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15575,
        GIR_EraseRootFromParent_Done,
      // Label 26175: @2146441
      GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(2146553), // Rule ID 15578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15578,
        GIR_EraseRootFromParent_Done,
      // Label 26176: @2146553
      GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(2146665), // Rule ID 15579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15579,
        GIR_EraseRootFromParent_Done,
      // Label 26177: @2146665
      GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(2146777), // Rule ID 15582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15582,
        GIR_EraseRootFromParent_Done,
      // Label 26178: @2146777
      GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(2146889), // Rule ID 15583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15583,
        GIR_EraseRootFromParent_Done,
      // Label 26179: @2146889
      GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(2147001), // Rule ID 15586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15586,
        GIR_EraseRootFromParent_Done,
      // Label 26180: @2147001
      GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(2147113), // Rule ID 15587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15587,
        GIR_EraseRootFromParent_Done,
      // Label 26181: @2147113
      GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(2147225), // Rule ID 15590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15590,
        GIR_EraseRootFromParent_Done,
      // Label 26182: @2147225
      GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(2147337), // Rule ID 15591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15591,
        GIR_EraseRootFromParent_Done,
      // Label 26183: @2147337
      GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(2147449), // Rule ID 15594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15594,
        GIR_EraseRootFromParent_Done,
      // Label 26184: @2147449
      GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(2147561), // Rule ID 15595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15595,
        GIR_EraseRootFromParent_Done,
      // Label 26185: @2147561
      GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(2147673), // Rule ID 15598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15598,
        GIR_EraseRootFromParent_Done,
      // Label 26186: @2147673
      GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(2147785), // Rule ID 15599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15599,
        GIR_EraseRootFromParent_Done,
      // Label 26187: @2147785
      GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(2147897), // Rule ID 15602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15602,
        GIR_EraseRootFromParent_Done,
      // Label 26188: @2147897
      GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(2148009), // Rule ID 15603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15603,
        GIR_EraseRootFromParent_Done,
      // Label 26189: @2148009
      GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(2148121), // Rule ID 15606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15606,
        GIR_EraseRootFromParent_Done,
      // Label 26190: @2148121
      GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(2148233), // Rule ID 15607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15607,
        GIR_EraseRootFromParent_Done,
      // Label 26191: @2148233
      GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(2148345), // Rule ID 15610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15610,
        GIR_EraseRootFromParent_Done,
      // Label 26192: @2148345
      GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(2148457), // Rule ID 15611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15611,
        GIR_EraseRootFromParent_Done,
      // Label 26193: @2148457
      GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(2148569), // Rule ID 15614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15614,
        GIR_EraseRootFromParent_Done,
      // Label 26194: @2148569
      GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(2148681), // Rule ID 15615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15615,
        GIR_EraseRootFromParent_Done,
      // Label 26195: @2148681
      GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(2148793), // Rule ID 15618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15618,
        GIR_EraseRootFromParent_Done,
      // Label 26196: @2148793
      GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(2148905), // Rule ID 15619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15619,
        GIR_EraseRootFromParent_Done,
      // Label 26197: @2148905
      GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(2149017), // Rule ID 15622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15622,
        GIR_EraseRootFromParent_Done,
      // Label 26198: @2149017
      GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(2149129), // Rule ID 15623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15623,
        GIR_EraseRootFromParent_Done,
      // Label 26199: @2149129
      GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(2149241), // Rule ID 15626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15626,
        GIR_EraseRootFromParent_Done,
      // Label 26200: @2149241
      GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(2149353), // Rule ID 15627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15627,
        GIR_EraseRootFromParent_Done,
      // Label 26201: @2149353
      GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(2149465), // Rule ID 15630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15630,
        GIR_EraseRootFromParent_Done,
      // Label 26202: @2149465
      GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(2149577), // Rule ID 15631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15631,
        GIR_EraseRootFromParent_Done,
      // Label 26203: @2149577
      GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(2149689), // Rule ID 15634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15634,
        GIR_EraseRootFromParent_Done,
      // Label 26204: @2149689
      GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(2149801), // Rule ID 15635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15635,
        GIR_EraseRootFromParent_Done,
      // Label 26205: @2149801
      GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(2149913), // Rule ID 15638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15638,
        GIR_EraseRootFromParent_Done,
      // Label 26206: @2149913
      GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(2150025), // Rule ID 15639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15639,
        GIR_EraseRootFromParent_Done,
      // Label 26207: @2150025
      GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(2150137), // Rule ID 15642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15642,
        GIR_EraseRootFromParent_Done,
      // Label 26208: @2150137
      GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(2150249), // Rule ID 15643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15643,
        GIR_EraseRootFromParent_Done,
      // Label 26209: @2150249
      GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(2150361), // Rule ID 15646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15646,
        GIR_EraseRootFromParent_Done,
      // Label 26210: @2150361
      GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(2150473), // Rule ID 15647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15647,
        GIR_EraseRootFromParent_Done,
      // Label 26211: @2150473
      GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(2150585), // Rule ID 15650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15650,
        GIR_EraseRootFromParent_Done,
      // Label 26212: @2150585
      GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(2150697), // Rule ID 15651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15651,
        GIR_EraseRootFromParent_Done,
      // Label 26213: @2150697
      GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(2150809), // Rule ID 15654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15654,
        GIR_EraseRootFromParent_Done,
      // Label 26214: @2150809
      GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(2150921), // Rule ID 15655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15655,
        GIR_EraseRootFromParent_Done,
      // Label 26215: @2150921
      GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(2151033), // Rule ID 15658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15658,
        GIR_EraseRootFromParent_Done,
      // Label 26216: @2151033
      GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(2151145), // Rule ID 15659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15659,
        GIR_EraseRootFromParent_Done,
      // Label 26217: @2151145
      GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(2151254), // Rule ID 15662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15662,
        GIR_EraseRootFromParent_Done,
      // Label 26218: @2151254
      GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(2151363), // Rule ID 15663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15663,
        GIR_EraseRootFromParent_Done,
      // Label 26219: @2151363
      GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(2151472), // Rule ID 15666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15666,
        GIR_EraseRootFromParent_Done,
      // Label 26220: @2151472
      GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(2151581), // Rule ID 15667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15667,
        GIR_EraseRootFromParent_Done,
      // Label 26221: @2151581
      GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(2151690), // Rule ID 15670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15670,
        GIR_EraseRootFromParent_Done,
      // Label 26222: @2151690
      GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(2151799), // Rule ID 15671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15671,
        GIR_EraseRootFromParent_Done,
      // Label 26223: @2151799
      GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(2151908), // Rule ID 15674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15674,
        GIR_EraseRootFromParent_Done,
      // Label 26224: @2151908
      GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(2152017), // Rule ID 15675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15675,
        GIR_EraseRootFromParent_Done,
      // Label 26225: @2152017
      GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(2152126), // Rule ID 15678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15678,
        GIR_EraseRootFromParent_Done,
      // Label 26226: @2152126
      GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(2152235), // Rule ID 15679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15679,
        GIR_EraseRootFromParent_Done,
      // Label 26227: @2152235
      GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(2152344), // Rule ID 15682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15682,
        GIR_EraseRootFromParent_Done,
      // Label 26228: @2152344
      GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(2152453), // Rule ID 15683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15683,
        GIR_EraseRootFromParent_Done,
      // Label 26229: @2152453
      GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(2152562), // Rule ID 15686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15686,
        GIR_EraseRootFromParent_Done,
      // Label 26230: @2152562
      GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(2152671), // Rule ID 15687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15687,
        GIR_EraseRootFromParent_Done,
      // Label 26231: @2152671
      GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(2152780), // Rule ID 15690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15690,
        GIR_EraseRootFromParent_Done,
      // Label 26232: @2152780
      GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(2152889), // Rule ID 15691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15691,
        GIR_EraseRootFromParent_Done,
      // Label 26233: @2152889
      GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(2152998), // Rule ID 15694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15694,
        GIR_EraseRootFromParent_Done,
      // Label 26234: @2152998
      GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(2153107), // Rule ID 15695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15695,
        GIR_EraseRootFromParent_Done,
      // Label 26235: @2153107
      GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(2153216), // Rule ID 15698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15698,
        GIR_EraseRootFromParent_Done,
      // Label 26236: @2153216
      GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(2153325), // Rule ID 15699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15699,
        GIR_EraseRootFromParent_Done,
      // Label 26237: @2153325
      GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(2153434), // Rule ID 15702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15702,
        GIR_EraseRootFromParent_Done,
      // Label 26238: @2153434
      GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(2153543), // Rule ID 15703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15703,
        GIR_EraseRootFromParent_Done,
      // Label 26239: @2153543
      GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(2153652), // Rule ID 15706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15706,
        GIR_EraseRootFromParent_Done,
      // Label 26240: @2153652
      GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(2153761), // Rule ID 15707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15707,
        GIR_EraseRootFromParent_Done,
      // Label 26241: @2153761
      GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(2153870), // Rule ID 15710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15710,
        GIR_EraseRootFromParent_Done,
      // Label 26242: @2153870
      GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(2153979), // Rule ID 15711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15711,
        GIR_EraseRootFromParent_Done,
      // Label 26243: @2153979
      GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(2154088), // Rule ID 15714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15714,
        GIR_EraseRootFromParent_Done,
      // Label 26244: @2154088
      GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(2154197), // Rule ID 15715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15715,
        GIR_EraseRootFromParent_Done,
      // Label 26245: @2154197
      GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(2154306), // Rule ID 15718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15718,
        GIR_EraseRootFromParent_Done,
      // Label 26246: @2154306
      GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(2154415), // Rule ID 15719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15719,
        GIR_EraseRootFromParent_Done,
      // Label 26247: @2154415
      GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(2154524), // Rule ID 15722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15722,
        GIR_EraseRootFromParent_Done,
      // Label 26248: @2154524
      GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(2154633), // Rule ID 15723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15723,
        GIR_EraseRootFromParent_Done,
      // Label 26249: @2154633
      GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(2154742), // Rule ID 15726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15726,
        GIR_EraseRootFromParent_Done,
      // Label 26250: @2154742
      GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(2154851), // Rule ID 15727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15727,
        GIR_EraseRootFromParent_Done,
      // Label 26251: @2154851
      GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(2154960), // Rule ID 15730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15730,
        GIR_EraseRootFromParent_Done,
      // Label 26252: @2154960
      GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(2155069), // Rule ID 15731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15731,
        GIR_EraseRootFromParent_Done,
      // Label 26253: @2155069
      GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(2155178), // Rule ID 15734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15734,
        GIR_EraseRootFromParent_Done,
      // Label 26254: @2155178
      GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(2155287), // Rule ID 15735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15735,
        GIR_EraseRootFromParent_Done,
      // Label 26255: @2155287
      GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(2155396), // Rule ID 15738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15738,
        GIR_EraseRootFromParent_Done,
      // Label 26256: @2155396
      GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(2155505), // Rule ID 15739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15739,
        GIR_EraseRootFromParent_Done,
      // Label 26257: @2155505
      GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(2155614), // Rule ID 15742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15742,
        GIR_EraseRootFromParent_Done,
      // Label 26258: @2155614
      GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(2155723), // Rule ID 15743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15743,
        GIR_EraseRootFromParent_Done,
      // Label 26259: @2155723
      GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(2155832), // Rule ID 15746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15746,
        GIR_EraseRootFromParent_Done,
      // Label 26260: @2155832
      GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(2155941), // Rule ID 15747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15747,
        GIR_EraseRootFromParent_Done,
      // Label 26261: @2155941
      GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(2156050), // Rule ID 15750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15750,
        GIR_EraseRootFromParent_Done,
      // Label 26262: @2156050
      GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(2156159), // Rule ID 15751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15751,
        GIR_EraseRootFromParent_Done,
      // Label 26263: @2156159
      GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(2156268), // Rule ID 15754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15754,
        GIR_EraseRootFromParent_Done,
      // Label 26264: @2156268
      GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(2156377), // Rule ID 15755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15755,
        GIR_EraseRootFromParent_Done,
      // Label 26265: @2156377
      GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(2156486), // Rule ID 15758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15758,
        GIR_EraseRootFromParent_Done,
      // Label 26266: @2156486
      GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(2156595), // Rule ID 15759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15759,
        GIR_EraseRootFromParent_Done,
      // Label 26267: @2156595
      GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(2156704), // Rule ID 15762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15762,
        GIR_EraseRootFromParent_Done,
      // Label 26268: @2156704
      GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(2156813), // Rule ID 15763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15763,
        GIR_EraseRootFromParent_Done,
      // Label 26269: @2156813
      GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(2156922), // Rule ID 15766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15766,
        GIR_EraseRootFromParent_Done,
      // Label 26270: @2156922
      GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(2157031), // Rule ID 15767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15767,
        GIR_EraseRootFromParent_Done,
      // Label 26271: @2157031
      GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(2157140), // Rule ID 15770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15770,
        GIR_EraseRootFromParent_Done,
      // Label 26272: @2157140
      GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(2157249), // Rule ID 15771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15771,
        GIR_EraseRootFromParent_Done,
      // Label 26273: @2157249
      GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(2157358), // Rule ID 15774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15774,
        GIR_EraseRootFromParent_Done,
      // Label 26274: @2157358
      GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(2157467), // Rule ID 15775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11209:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15775,
        GIR_EraseRootFromParent_Done,
      // Label 26275: @2157467
      GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(2157576), // Rule ID 15778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15778,
        GIR_EraseRootFromParent_Done,
      // Label 26276: @2157576
      GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(2157685), // Rule ID 15779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15779,
        GIR_EraseRootFromParent_Done,
      // Label 26277: @2157685
      GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(2157794), // Rule ID 15782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15782,
        GIR_EraseRootFromParent_Done,
      // Label 26278: @2157794
      GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(2157903), // Rule ID 15783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15783,
        GIR_EraseRootFromParent_Done,
      // Label 26279: @2157903
      GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(2158012), // Rule ID 15786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15786,
        GIR_EraseRootFromParent_Done,
      // Label 26280: @2158012
      GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(2158121), // Rule ID 15787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15787,
        GIR_EraseRootFromParent_Done,
      // Label 26281: @2158121
      GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(2158230), // Rule ID 15790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15790,
        GIR_EraseRootFromParent_Done,
      // Label 26282: @2158230
      GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(2158339), // Rule ID 15791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15791,
        GIR_EraseRootFromParent_Done,
      // Label 26283: @2158339
      GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(2158448), // Rule ID 15794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15794,
        GIR_EraseRootFromParent_Done,
      // Label 26284: @2158448
      GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(2158557), // Rule ID 15795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15795,
        GIR_EraseRootFromParent_Done,
      // Label 26285: @2158557
      GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(2158666), // Rule ID 15798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15798,
        GIR_EraseRootFromParent_Done,
      // Label 26286: @2158666
      GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(2158775), // Rule ID 15799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15799,
        GIR_EraseRootFromParent_Done,
      // Label 26287: @2158775
      GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(2158884), // Rule ID 15802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15802,
        GIR_EraseRootFromParent_Done,
      // Label 26288: @2158884
      GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(2158993), // Rule ID 15803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15803,
        GIR_EraseRootFromParent_Done,
      // Label 26289: @2158993
      GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(2159102), // Rule ID 15806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15806,
        GIR_EraseRootFromParent_Done,
      // Label 26290: @2159102
      GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(2159211), // Rule ID 15807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15807,
        GIR_EraseRootFromParent_Done,
      // Label 26291: @2159211
      GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(2159320), // Rule ID 15810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15810,
        GIR_EraseRootFromParent_Done,
      // Label 26292: @2159320
      GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(2159429), // Rule ID 15811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15811,
        GIR_EraseRootFromParent_Done,
      // Label 26293: @2159429
      GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(2159538), // Rule ID 15814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15814,
        GIR_EraseRootFromParent_Done,
      // Label 26294: @2159538
      GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(2159647), // Rule ID 15815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15815,
        GIR_EraseRootFromParent_Done,
      // Label 26295: @2159647
      GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(2159756), // Rule ID 15818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15818,
        GIR_EraseRootFromParent_Done,
      // Label 26296: @2159756
      GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(2159865), // Rule ID 15819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15819,
        GIR_EraseRootFromParent_Done,
      // Label 26297: @2159865
      GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(2159974), // Rule ID 15822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15822,
        GIR_EraseRootFromParent_Done,
      // Label 26298: @2159974
      GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(2160083), // Rule ID 15823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15823,
        GIR_EraseRootFromParent_Done,
      // Label 26299: @2160083
      GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(2160192), // Rule ID 15826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15826,
        GIR_EraseRootFromParent_Done,
      // Label 26300: @2160192
      GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(2160301), // Rule ID 15827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15827,
        GIR_EraseRootFromParent_Done,
      // Label 26301: @2160301
      GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(2160410), // Rule ID 15830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15830,
        GIR_EraseRootFromParent_Done,
      // Label 26302: @2160410
      GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(2160519), // Rule ID 15831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15831,
        GIR_EraseRootFromParent_Done,
      // Label 26303: @2160519
      GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(2160628), // Rule ID 15834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15834,
        GIR_EraseRootFromParent_Done,
      // Label 26304: @2160628
      GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(2160737), // Rule ID 15835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15835,
        GIR_EraseRootFromParent_Done,
      // Label 26305: @2160737
      GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(2160846), // Rule ID 15926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15926,
        GIR_EraseRootFromParent_Done,
      // Label 26306: @2160846
      GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(2160955), // Rule ID 15927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15927,
        GIR_EraseRootFromParent_Done,
      // Label 26307: @2160955
      GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(2161064), // Rule ID 15930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15930,
        GIR_EraseRootFromParent_Done,
      // Label 26308: @2161064
      GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(2161173), // Rule ID 15931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15931,
        GIR_EraseRootFromParent_Done,
      // Label 26309: @2161173
      GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(2161282), // Rule ID 15934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15934,
        GIR_EraseRootFromParent_Done,
      // Label 26310: @2161282
      GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(2161391), // Rule ID 15935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15935,
        GIR_EraseRootFromParent_Done,
      // Label 26311: @2161391
      GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(2161500), // Rule ID 15938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15938,
        GIR_EraseRootFromParent_Done,
      // Label 26312: @2161500
      GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(2161609), // Rule ID 15939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15939,
        GIR_EraseRootFromParent_Done,
      // Label 26313: @2161609
      GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(2161718), // Rule ID 15942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15942,
        GIR_EraseRootFromParent_Done,
      // Label 26314: @2161718
      GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(2161827), // Rule ID 15943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15943,
        GIR_EraseRootFromParent_Done,
      // Label 26315: @2161827
      GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(2161936), // Rule ID 15946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15946,
        GIR_EraseRootFromParent_Done,
      // Label 26316: @2161936
      GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(2162045), // Rule ID 15947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15947,
        GIR_EraseRootFromParent_Done,
      // Label 26317: @2162045
      GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(2162154), // Rule ID 15950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15950,
        GIR_EraseRootFromParent_Done,
      // Label 26318: @2162154
      GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(2162263), // Rule ID 15951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15951,
        GIR_EraseRootFromParent_Done,
      // Label 26319: @2162263
      GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(2162372), // Rule ID 15954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15954,
        GIR_EraseRootFromParent_Done,
      // Label 26320: @2162372
      GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(2162481), // Rule ID 15955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15955,
        GIR_EraseRootFromParent_Done,
      // Label 26321: @2162481
      GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(2162590), // Rule ID 15958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15958,
        GIR_EraseRootFromParent_Done,
      // Label 26322: @2162590
      GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(2162699), // Rule ID 15959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15959,
        GIR_EraseRootFromParent_Done,
      // Label 26323: @2162699
      GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(2162808), // Rule ID 15962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15962,
        GIR_EraseRootFromParent_Done,
      // Label 26324: @2162808
      GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(2162917), // Rule ID 15963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15963,
        GIR_EraseRootFromParent_Done,
      // Label 26325: @2162917
      GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(2163026), // Rule ID 15966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15966,
        GIR_EraseRootFromParent_Done,
      // Label 26326: @2163026
      GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(2163135), // Rule ID 15967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15967,
        GIR_EraseRootFromParent_Done,
      // Label 26327: @2163135
      GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(2163244), // Rule ID 15970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15970,
        GIR_EraseRootFromParent_Done,
      // Label 26328: @2163244
      GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(2163353), // Rule ID 15971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15971,
        GIR_EraseRootFromParent_Done,
      // Label 26329: @2163353
      GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(2163462), // Rule ID 15974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15974,
        GIR_EraseRootFromParent_Done,
      // Label 26330: @2163462
      GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(2163571), // Rule ID 15975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15975,
        GIR_EraseRootFromParent_Done,
      // Label 26331: @2163571
      GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(2163680), // Rule ID 15978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15978,
        GIR_EraseRootFromParent_Done,
      // Label 26332: @2163680
      GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(2163789), // Rule ID 15979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15979,
        GIR_EraseRootFromParent_Done,
      // Label 26333: @2163789
      GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(2163898), // Rule ID 15982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15982,
        GIR_EraseRootFromParent_Done,
      // Label 26334: @2163898
      GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(2164007), // Rule ID 15983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15983,
        GIR_EraseRootFromParent_Done,
      // Label 26335: @2164007
      GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(2164116), // Rule ID 15986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15986,
        GIR_EraseRootFromParent_Done,
      // Label 26336: @2164116
      GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(2164225), // Rule ID 15987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15987,
        GIR_EraseRootFromParent_Done,
      // Label 26337: @2164225
      GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(2164334), // Rule ID 15990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15990,
        GIR_EraseRootFromParent_Done,
      // Label 26338: @2164334
      GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(2164443), // Rule ID 15991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15991,
        GIR_EraseRootFromParent_Done,
      // Label 26339: @2164443
      GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(2164552), // Rule ID 15994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15994,
        GIR_EraseRootFromParent_Done,
      // Label 26340: @2164552
      GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(2164661), // Rule ID 15995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15995,
        GIR_EraseRootFromParent_Done,
      // Label 26341: @2164661
      GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(2164770), // Rule ID 15998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15998,
        GIR_EraseRootFromParent_Done,
      // Label 26342: @2164770
      GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(2164879), // Rule ID 15999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15999,
        GIR_EraseRootFromParent_Done,
      // Label 26343: @2164879
      GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(2164988), // Rule ID 16002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16002,
        GIR_EraseRootFromParent_Done,
      // Label 26344: @2164988
      GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(2165097), // Rule ID 16003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16003,
        GIR_EraseRootFromParent_Done,
      // Label 26345: @2165097
      GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(2165206), // Rule ID 16006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16006,
        GIR_EraseRootFromParent_Done,
      // Label 26346: @2165206
      GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(2165315), // Rule ID 16007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16007,
        GIR_EraseRootFromParent_Done,
      // Label 26347: @2165315
      GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(2165424), // Rule ID 16010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16010,
        GIR_EraseRootFromParent_Done,
      // Label 26348: @2165424
      GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(2165533), // Rule ID 16011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16011,
        GIR_EraseRootFromParent_Done,
      // Label 26349: @2165533
      GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(2165642), // Rule ID 16014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16014,
        GIR_EraseRootFromParent_Done,
      // Label 26350: @2165642
      GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(2165751), // Rule ID 16015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16015,
        GIR_EraseRootFromParent_Done,
      // Label 26351: @2165751
      GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(2165860), // Rule ID 16018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16018,
        GIR_EraseRootFromParent_Done,
      // Label 26352: @2165860
      GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(2165969), // Rule ID 16019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16019,
        GIR_EraseRootFromParent_Done,
      // Label 26353: @2165969
      GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(2166078), // Rule ID 16022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16022,
        GIR_EraseRootFromParent_Done,
      // Label 26354: @2166078
      GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(2166187), // Rule ID 16023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16023,
        GIR_EraseRootFromParent_Done,
      // Label 26355: @2166187
      GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(2166296), // Rule ID 16026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16026,
        GIR_EraseRootFromParent_Done,
      // Label 26356: @2166296
      GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(2166405), // Rule ID 16027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16027,
        GIR_EraseRootFromParent_Done,
      // Label 26357: @2166405
      GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(2166514), // Rule ID 16030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16030,
        GIR_EraseRootFromParent_Done,
      // Label 26358: @2166514
      GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(2166623), // Rule ID 16031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16031,
        GIR_EraseRootFromParent_Done,
      // Label 26359: @2166623
      GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(2166732), // Rule ID 16034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16034,
        GIR_EraseRootFromParent_Done,
      // Label 26360: @2166732
      GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(2166841), // Rule ID 16035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16035,
        GIR_EraseRootFromParent_Done,
      // Label 26361: @2166841
      GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(2166950), // Rule ID 16038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16038,
        GIR_EraseRootFromParent_Done,
      // Label 26362: @2166950
      GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(2167059), // Rule ID 16039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11207:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16039,
        GIR_EraseRootFromParent_Done,
      // Label 26363: @2167059
      GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(2167168), // Rule ID 16042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16042,
        GIR_EraseRootFromParent_Done,
      // Label 26364: @2167168
      GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(2167277), // Rule ID 16043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16043,
        GIR_EraseRootFromParent_Done,
      // Label 26365: @2167277
      GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(2167386), // Rule ID 16046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16046,
        GIR_EraseRootFromParent_Done,
      // Label 26366: @2167386
      GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(2167495), // Rule ID 16047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16047,
        GIR_EraseRootFromParent_Done,
      // Label 26367: @2167495
      GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(2167604), // Rule ID 16050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16050,
        GIR_EraseRootFromParent_Done,
      // Label 26368: @2167604
      GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(2167713), // Rule ID 16051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16051,
        GIR_EraseRootFromParent_Done,
      // Label 26369: @2167713
      GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(2167822), // Rule ID 16054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16054,
        GIR_EraseRootFromParent_Done,
      // Label 26370: @2167822
      GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(2167931), // Rule ID 16055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16055,
        GIR_EraseRootFromParent_Done,
      // Label 26371: @2167931
      GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(2168040), // Rule ID 16058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16058,
        GIR_EraseRootFromParent_Done,
      // Label 26372: @2168040
      GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(2168149), // Rule ID 16059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16059,
        GIR_EraseRootFromParent_Done,
      // Label 26373: @2168149
      GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(2168258), // Rule ID 16062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16062,
        GIR_EraseRootFromParent_Done,
      // Label 26374: @2168258
      GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(2168367), // Rule ID 16063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv64i8] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16063,
        GIR_EraseRootFromParent_Done,
      // Label 26375: @2168367
      GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(2168476), // Rule ID 16066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16066,
        GIR_EraseRootFromParent_Done,
      // Label 26376: @2168476
      GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(2168585), // Rule ID 16067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16067,
        GIR_EraseRootFromParent_Done,
      // Label 26377: @2168585
      GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(2168694), // Rule ID 16070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16070,
        GIR_EraseRootFromParent_Done,
      // Label 26378: @2168694
      GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(2168803), // Rule ID 16071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16071,
        GIR_EraseRootFromParent_Done,
      // Label 26379: @2168803
      GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(2168912), // Rule ID 16074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16074,
        GIR_EraseRootFromParent_Done,
      // Label 26380: @2168912
      GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(2169021), // Rule ID 16075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16075,
        GIR_EraseRootFromParent_Done,
      // Label 26381: @2169021
      GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(2169130), // Rule ID 16078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16078,
        GIR_EraseRootFromParent_Done,
      // Label 26382: @2169130
      GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(2169239), // Rule ID 16079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16079,
        GIR_EraseRootFromParent_Done,
      // Label 26383: @2169239
      GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(2169348), // Rule ID 16082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16082,
        GIR_EraseRootFromParent_Done,
      // Label 26384: @2169348
      GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(2169457), // Rule ID 16083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16083,
        GIR_EraseRootFromParent_Done,
      // Label 26385: @2169457
      GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(2169566), // Rule ID 16086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16086,
        GIR_EraseRootFromParent_Done,
      // Label 26386: @2169566
      GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(2169675), // Rule ID 16087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16087,
        GIR_EraseRootFromParent_Done,
      // Label 26387: @2169675
      GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(2169784), // Rule ID 16090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16090,
        GIR_EraseRootFromParent_Done,
      // Label 26388: @2169784
      GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(2169893), // Rule ID 16091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16091,
        GIR_EraseRootFromParent_Done,
      // Label 26389: @2169893
      GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(2170002), // Rule ID 16094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16094,
        GIR_EraseRootFromParent_Done,
      // Label 26390: @2170002
      GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(2170111), // Rule ID 16095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16095,
        GIR_EraseRootFromParent_Done,
      // Label 26391: @2170111
      GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(2170220), // Rule ID 16098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16098,
        GIR_EraseRootFromParent_Done,
      // Label 26392: @2170220
      GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(2170329), // Rule ID 16099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16099,
        GIR_EraseRootFromParent_Done,
      // Label 26393: @2170329
      GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(2170441), // Rule ID 16190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16190,
        GIR_EraseRootFromParent_Done,
      // Label 26394: @2170441
      GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(2170553), // Rule ID 16191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16191,
        GIR_EraseRootFromParent_Done,
      // Label 26395: @2170553
      GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(2170665), // Rule ID 16194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16194,
        GIR_EraseRootFromParent_Done,
      // Label 26396: @2170665
      GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(2170777), // Rule ID 16195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16195,
        GIR_EraseRootFromParent_Done,
      // Label 26397: @2170777
      GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(2170889), // Rule ID 16198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16198,
        GIR_EraseRootFromParent_Done,
      // Label 26398: @2170889
      GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(2171001), // Rule ID 16199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16199,
        GIR_EraseRootFromParent_Done,
      // Label 26399: @2171001
      GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(2171113), // Rule ID 16202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16202,
        GIR_EraseRootFromParent_Done,
      // Label 26400: @2171113
      GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(2171225), // Rule ID 16203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16203,
        GIR_EraseRootFromParent_Done,
      // Label 26401: @2171225
      GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(2171337), // Rule ID 16206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16206,
        GIR_EraseRootFromParent_Done,
      // Label 26402: @2171337
      GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(2171449), // Rule ID 16207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16207,
        GIR_EraseRootFromParent_Done,
      // Label 26403: @2171449
      GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(2171561), // Rule ID 16210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16210,
        GIR_EraseRootFromParent_Done,
      // Label 26404: @2171561
      GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(2171673), // Rule ID 16211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16211,
        GIR_EraseRootFromParent_Done,
      // Label 26405: @2171673
      GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(2171785), // Rule ID 16214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16214,
        GIR_EraseRootFromParent_Done,
      // Label 26406: @2171785
      GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(2171897), // Rule ID 16215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16215,
        GIR_EraseRootFromParent_Done,
      // Label 26407: @2171897
      GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(2172009), // Rule ID 16218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16218,
        GIR_EraseRootFromParent_Done,
      // Label 26408: @2172009
      GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(2172121), // Rule ID 16219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16219,
        GIR_EraseRootFromParent_Done,
      // Label 26409: @2172121
      GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(2172233), // Rule ID 16222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16222,
        GIR_EraseRootFromParent_Done,
      // Label 26410: @2172233
      GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(2172345), // Rule ID 16223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16223,
        GIR_EraseRootFromParent_Done,
      // Label 26411: @2172345
      GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(2172457), // Rule ID 16226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16226,
        GIR_EraseRootFromParent_Done,
      // Label 26412: @2172457
      GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(2172569), // Rule ID 16227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16227,
        GIR_EraseRootFromParent_Done,
      // Label 26413: @2172569
      GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(2172681), // Rule ID 16230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16230,
        GIR_EraseRootFromParent_Done,
      // Label 26414: @2172681
      GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(2172793), // Rule ID 16231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16231,
        GIR_EraseRootFromParent_Done,
      // Label 26415: @2172793
      GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(2172905), // Rule ID 16234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16234,
        GIR_EraseRootFromParent_Done,
      // Label 26416: @2172905
      GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(2173017), // Rule ID 16235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16235,
        GIR_EraseRootFromParent_Done,
      // Label 26417: @2173017
      GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(2173129), // Rule ID 16238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16238,
        GIR_EraseRootFromParent_Done,
      // Label 26418: @2173129
      GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(2173241), // Rule ID 16239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16239,
        GIR_EraseRootFromParent_Done,
      // Label 26419: @2173241
      GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(2173353), // Rule ID 16242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16242,
        GIR_EraseRootFromParent_Done,
      // Label 26420: @2173353
      GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(2173465), // Rule ID 16243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16243,
        GIR_EraseRootFromParent_Done,
      // Label 26421: @2173465
      GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(2173577), // Rule ID 16246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16246,
        GIR_EraseRootFromParent_Done,
      // Label 26422: @2173577
      GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(2173689), // Rule ID 16247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16247,
        GIR_EraseRootFromParent_Done,
      // Label 26423: @2173689
      GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(2173801), // Rule ID 16250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16250,
        GIR_EraseRootFromParent_Done,
      // Label 26424: @2173801
      GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(2173913), // Rule ID 16251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16251,
        GIR_EraseRootFromParent_Done,
      // Label 26425: @2173913
      GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(2174025), // Rule ID 16254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16254,
        GIR_EraseRootFromParent_Done,
      // Label 26426: @2174025
      GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(2174137), // Rule ID 16255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16255,
        GIR_EraseRootFromParent_Done,
      // Label 26427: @2174137
      GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(2174249), // Rule ID 16258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16258,
        GIR_EraseRootFromParent_Done,
      // Label 26428: @2174249
      GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(2174361), // Rule ID 16259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16259,
        GIR_EraseRootFromParent_Done,
      // Label 26429: @2174361
      GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(2174473), // Rule ID 16262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16262,
        GIR_EraseRootFromParent_Done,
      // Label 26430: @2174473
      GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(2174585), // Rule ID 16263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16263,
        GIR_EraseRootFromParent_Done,
      // Label 26431: @2174585
      GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(2174697), // Rule ID 16266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16266,
        GIR_EraseRootFromParent_Done,
      // Label 26432: @2174697
      GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(2174809), // Rule ID 16267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16267,
        GIR_EraseRootFromParent_Done,
      // Label 26433: @2174809
      GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(2174921), // Rule ID 16270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16270,
        GIR_EraseRootFromParent_Done,
      // Label 26434: @2174921
      GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(2175033), // Rule ID 16271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16271,
        GIR_EraseRootFromParent_Done,
      // Label 26435: @2175033
      GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(2175145), // Rule ID 16274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16274,
        GIR_EraseRootFromParent_Done,
      // Label 26436: @2175145
      GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(2175257), // Rule ID 16275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16275,
        GIR_EraseRootFromParent_Done,
      // Label 26437: @2175257
      GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(2175369), // Rule ID 16278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16278,
        GIR_EraseRootFromParent_Done,
      // Label 26438: @2175369
      GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(2175481), // Rule ID 16279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16279,
        GIR_EraseRootFromParent_Done,
      // Label 26439: @2175481
      GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(2175593), // Rule ID 16282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16282,
        GIR_EraseRootFromParent_Done,
      // Label 26440: @2175593
      GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(2175705), // Rule ID 16283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16283,
        GIR_EraseRootFromParent_Done,
      // Label 26441: @2175705
      GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(2175817), // Rule ID 16286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16286,
        GIR_EraseRootFromParent_Done,
      // Label 26442: @2175817
      GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(2175929), // Rule ID 16287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16287,
        GIR_EraseRootFromParent_Done,
      // Label 26443: @2175929
      GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(2176041), // Rule ID 16290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16290,
        GIR_EraseRootFromParent_Done,
      // Label 26444: @2176041
      GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(2176153), // Rule ID 16291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16291,
        GIR_EraseRootFromParent_Done,
      // Label 26445: @2176153
      GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(2176265), // Rule ID 16294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16294,
        GIR_EraseRootFromParent_Done,
      // Label 26446: @2176265
      GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(2176377), // Rule ID 16295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16295,
        GIR_EraseRootFromParent_Done,
      // Label 26447: @2176377
      GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(2176489), // Rule ID 16298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16298,
        GIR_EraseRootFromParent_Done,
      // Label 26448: @2176489
      GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(2176601), // Rule ID 16299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16299,
        GIR_EraseRootFromParent_Done,
      // Label 26449: @2176601
      GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(2176713), // Rule ID 16302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16302,
        GIR_EraseRootFromParent_Done,
      // Label 26450: @2176713
      GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(2176825), // Rule ID 16303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16303,
        GIR_EraseRootFromParent_Done,
      // Label 26451: @2176825
      GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(2176937), // Rule ID 16306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16306,
        GIR_EraseRootFromParent_Done,
      // Label 26452: @2176937
      GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(2177049), // Rule ID 16307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16307,
        GIR_EraseRootFromParent_Done,
      // Label 26453: @2177049
      GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(2177161), // Rule ID 16370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16370,
        GIR_EraseRootFromParent_Done,
      // Label 26454: @2177161
      GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(2177273), // Rule ID 16371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16371,
        GIR_EraseRootFromParent_Done,
      // Label 26455: @2177273
      GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(2177385), // Rule ID 16374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16374,
        GIR_EraseRootFromParent_Done,
      // Label 26456: @2177385
      GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(2177497), // Rule ID 16375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16375,
        GIR_EraseRootFromParent_Done,
      // Label 26457: @2177497
      GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(2177609), // Rule ID 16378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16378,
        GIR_EraseRootFromParent_Done,
      // Label 26458: @2177609
      GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(2177721), // Rule ID 16379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16379,
        GIR_EraseRootFromParent_Done,
      // Label 26459: @2177721
      GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(2177833), // Rule ID 16382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16382,
        GIR_EraseRootFromParent_Done,
      // Label 26460: @2177833
      GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(2177945), // Rule ID 16383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16383,
        GIR_EraseRootFromParent_Done,
      // Label 26461: @2177945
      GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(2178057), // Rule ID 16386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16386,
        GIR_EraseRootFromParent_Done,
      // Label 26462: @2178057
      GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(2178169), // Rule ID 16387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16387,
        GIR_EraseRootFromParent_Done,
      // Label 26463: @2178169
      GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(2178281), // Rule ID 16390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16390,
        GIR_EraseRootFromParent_Done,
      // Label 26464: @2178281
      GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(2178393), // Rule ID 16391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16391,
        GIR_EraseRootFromParent_Done,
      // Label 26465: @2178393
      GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(2178505), // Rule ID 16394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16394,
        GIR_EraseRootFromParent_Done,
      // Label 26466: @2178505
      GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(2178617), // Rule ID 16395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16395,
        GIR_EraseRootFromParent_Done,
      // Label 26467: @2178617
      GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(2178729), // Rule ID 16398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16398,
        GIR_EraseRootFromParent_Done,
      // Label 26468: @2178729
      GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(2178841), // Rule ID 16399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16399,
        GIR_EraseRootFromParent_Done,
      // Label 26469: @2178841
      GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(2178953), // Rule ID 16402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16402,
        GIR_EraseRootFromParent_Done,
      // Label 26470: @2178953
      GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(2179065), // Rule ID 16403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16403,
        GIR_EraseRootFromParent_Done,
      // Label 26471: @2179065
      GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(2179177), // Rule ID 16406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16406,
        GIR_EraseRootFromParent_Done,
      // Label 26472: @2179177
      GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(2179289), // Rule ID 16407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16407,
        GIR_EraseRootFromParent_Done,
      // Label 26473: @2179289
      GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(2179401), // Rule ID 16410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16410,
        GIR_EraseRootFromParent_Done,
      // Label 26474: @2179401
      GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(2179513), // Rule ID 16411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16411,
        GIR_EraseRootFromParent_Done,
      // Label 26475: @2179513
      GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(2179625), // Rule ID 16414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16414,
        GIR_EraseRootFromParent_Done,
      // Label 26476: @2179625
      GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(2179737), // Rule ID 16415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16415,
        GIR_EraseRootFromParent_Done,
      // Label 26477: @2179737
      GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(2179849), // Rule ID 16418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16418,
        GIR_EraseRootFromParent_Done,
      // Label 26478: @2179849
      GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(2179961), // Rule ID 16419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16419,
        GIR_EraseRootFromParent_Done,
      // Label 26479: @2179961
      GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(2180073), // Rule ID 16422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16422,
        GIR_EraseRootFromParent_Done,
      // Label 26480: @2180073
      GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(2180185), // Rule ID 16423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16423,
        GIR_EraseRootFromParent_Done,
      // Label 26481: @2180185
      GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(2180297), // Rule ID 16426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16426,
        GIR_EraseRootFromParent_Done,
      // Label 26482: @2180297
      GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(2180409), // Rule ID 16427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16427,
        GIR_EraseRootFromParent_Done,
      // Label 26483: @2180409
      GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(2180521), // Rule ID 16430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16430,
        GIR_EraseRootFromParent_Done,
      // Label 26484: @2180521
      GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(2180633), // Rule ID 16431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16431,
        GIR_EraseRootFromParent_Done,
      // Label 26485: @2180633
      GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(2180745), // Rule ID 16434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16434,
        GIR_EraseRootFromParent_Done,
      // Label 26486: @2180745
      GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(2180857), // Rule ID 16435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16435,
        GIR_EraseRootFromParent_Done,
      // Label 26487: @2180857
      GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(2180969), // Rule ID 16438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16438,
        GIR_EraseRootFromParent_Done,
      // Label 26488: @2180969
      GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(2181081), // Rule ID 16439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16439,
        GIR_EraseRootFromParent_Done,
      // Label 26489: @2181081
      GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(2181193), // Rule ID 16442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16442,
        GIR_EraseRootFromParent_Done,
      // Label 26490: @2181193
      GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(2181305), // Rule ID 16443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16443,
        GIR_EraseRootFromParent_Done,
      // Label 26491: @2181305
      GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(2181417), // Rule ID 16446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16446,
        GIR_EraseRootFromParent_Done,
      // Label 26492: @2181417
      GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(2181529), // Rule ID 16447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16447,
        GIR_EraseRootFromParent_Done,
      // Label 26493: @2181529
      GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(2181641), // Rule ID 16450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16450,
        GIR_EraseRootFromParent_Done,
      // Label 26494: @2181641
      GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(2181753), // Rule ID 16451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16451,
        GIR_EraseRootFromParent_Done,
      // Label 26495: @2181753
      GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(2181865), // Rule ID 16454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16454,
        GIR_EraseRootFromParent_Done,
      // Label 26496: @2181865
      GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(2181977), // Rule ID 16455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16455,
        GIR_EraseRootFromParent_Done,
      // Label 26497: @2181977
      GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(2182089), // Rule ID 16458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16458,
        GIR_EraseRootFromParent_Done,
      // Label 26498: @2182089
      GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(2182201), // Rule ID 16459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16459,
        GIR_EraseRootFromParent_Done,
      // Label 26499: @2182201
      GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(2182313), // Rule ID 16462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16462,
        GIR_EraseRootFromParent_Done,
      // Label 26500: @2182313
      GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(2182425), // Rule ID 16463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16463,
        GIR_EraseRootFromParent_Done,
      // Label 26501: @2182425
      GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(2182537), // Rule ID 16466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16466,
        GIR_EraseRootFromParent_Done,
      // Label 26502: @2182537
      GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(2182649), // Rule ID 16467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16467,
        GIR_EraseRootFromParent_Done,
      // Label 26503: @2182649
      GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(2182761), // Rule ID 16470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16470,
        GIR_EraseRootFromParent_Done,
      // Label 26504: @2182761
      GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(2182873), // Rule ID 16471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16471,
        GIR_EraseRootFromParent_Done,
      // Label 26505: @2182873
      GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(2182985), // Rule ID 16474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16474,
        GIR_EraseRootFromParent_Done,
      // Label 26506: @2182985
      GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(2183097), // Rule ID 16475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16475,
        GIR_EraseRootFromParent_Done,
      // Label 26507: @2183097
      GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(2183209), // Rule ID 16478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16478,
        GIR_EraseRootFromParent_Done,
      // Label 26508: @2183209
      GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(2183321), // Rule ID 16479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16479,
        GIR_EraseRootFromParent_Done,
      // Label 26509: @2183321
      GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(2183433), // Rule ID 16482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16482,
        GIR_EraseRootFromParent_Done,
      // Label 26510: @2183433
      GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(2183545), // Rule ID 16483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16483,
        GIR_EraseRootFromParent_Done,
      // Label 26511: @2183545
      GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(2183657), // Rule ID 16486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16486,
        GIR_EraseRootFromParent_Done,
      // Label 26512: @2183657
      GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(2183769), // Rule ID 16487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16487,
        GIR_EraseRootFromParent_Done,
      // Label 26513: @2183769
      GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(2183878), // Rule ID 16550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16550,
        GIR_EraseRootFromParent_Done,
      // Label 26514: @2183878
      GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(2183987), // Rule ID 16551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16551,
        GIR_EraseRootFromParent_Done,
      // Label 26515: @2183987
      GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(2184096), // Rule ID 16554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16554,
        GIR_EraseRootFromParent_Done,
      // Label 26516: @2184096
      GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(2184205), // Rule ID 16555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16555,
        GIR_EraseRootFromParent_Done,
      // Label 26517: @2184205
      GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(2184314), // Rule ID 16558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16558,
        GIR_EraseRootFromParent_Done,
      // Label 26518: @2184314
      GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(2184423), // Rule ID 16559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16559,
        GIR_EraseRootFromParent_Done,
      // Label 26519: @2184423
      GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(2184532), // Rule ID 16562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16562,
        GIR_EraseRootFromParent_Done,
      // Label 26520: @2184532
      GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(2184641), // Rule ID 16563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16563,
        GIR_EraseRootFromParent_Done,
      // Label 26521: @2184641
      GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(2184750), // Rule ID 16566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16566,
        GIR_EraseRootFromParent_Done,
      // Label 26522: @2184750
      GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(2184859), // Rule ID 16567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16567,
        GIR_EraseRootFromParent_Done,
      // Label 26523: @2184859
      GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(2184968), // Rule ID 16570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16570,
        GIR_EraseRootFromParent_Done,
      // Label 26524: @2184968
      GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(2185077), // Rule ID 16571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16571,
        GIR_EraseRootFromParent_Done,
      // Label 26525: @2185077
      GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(2185186), // Rule ID 16574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16574,
        GIR_EraseRootFromParent_Done,
      // Label 26526: @2185186
      GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(2185295), // Rule ID 16575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16575,
        GIR_EraseRootFromParent_Done,
      // Label 26527: @2185295
      GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(2185404), // Rule ID 16578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16578,
        GIR_EraseRootFromParent_Done,
      // Label 26528: @2185404
      GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(2185513), // Rule ID 16579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16579,
        GIR_EraseRootFromParent_Done,
      // Label 26529: @2185513
      GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(2185622), // Rule ID 16582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16582,
        GIR_EraseRootFromParent_Done,
      // Label 26530: @2185622
      GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(2185731), // Rule ID 16583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16583,
        GIR_EraseRootFromParent_Done,
      // Label 26531: @2185731
      GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(2185840), // Rule ID 16586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16586,
        GIR_EraseRootFromParent_Done,
      // Label 26532: @2185840
      GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(2185949), // Rule ID 16587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16587,
        GIR_EraseRootFromParent_Done,
      // Label 26533: @2185949
      GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(2186058), // Rule ID 16590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16590,
        GIR_EraseRootFromParent_Done,
      // Label 26534: @2186058
      GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(2186167), // Rule ID 16591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16591,
        GIR_EraseRootFromParent_Done,
      // Label 26535: @2186167
      GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(2186276), // Rule ID 16594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16594,
        GIR_EraseRootFromParent_Done,
      // Label 26536: @2186276
      GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(2186385), // Rule ID 16595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16595,
        GIR_EraseRootFromParent_Done,
      // Label 26537: @2186385
      GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(2186494), // Rule ID 16598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16598,
        GIR_EraseRootFromParent_Done,
      // Label 26538: @2186494
      GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(2186603), // Rule ID 16599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16599,
        GIR_EraseRootFromParent_Done,
      // Label 26539: @2186603
      GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(2186712), // Rule ID 16602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16602,
        GIR_EraseRootFromParent_Done,
      // Label 26540: @2186712
      GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(2186821), // Rule ID 16603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16603,
        GIR_EraseRootFromParent_Done,
      // Label 26541: @2186821
      GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(2186930), // Rule ID 16606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16606,
        GIR_EraseRootFromParent_Done,
      // Label 26542: @2186930
      GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(2187039), // Rule ID 16607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16607,
        GIR_EraseRootFromParent_Done,
      // Label 26543: @2187039
      GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(2187148), // Rule ID 16610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16610,
        GIR_EraseRootFromParent_Done,
      // Label 26544: @2187148
      GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(2187257), // Rule ID 16611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16611,
        GIR_EraseRootFromParent_Done,
      // Label 26545: @2187257
      GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(2187366), // Rule ID 16614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16614,
        GIR_EraseRootFromParent_Done,
      // Label 26546: @2187366
      GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(2187475), // Rule ID 16615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16615,
        GIR_EraseRootFromParent_Done,
      // Label 26547: @2187475
      GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(2187584), // Rule ID 16618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16618,
        GIR_EraseRootFromParent_Done,
      // Label 26548: @2187584
      GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(2187693), // Rule ID 16619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16619,
        GIR_EraseRootFromParent_Done,
      // Label 26549: @2187693
      GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(2187802), // Rule ID 16622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16622,
        GIR_EraseRootFromParent_Done,
      // Label 26550: @2187802
      GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(2187911), // Rule ID 16623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10793:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16623,
        GIR_EraseRootFromParent_Done,
      // Label 26551: @2187911
      GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(2188020), // Rule ID 16626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16626,
        GIR_EraseRootFromParent_Done,
      // Label 26552: @2188020
      GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(2188129), // Rule ID 16627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10793:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16627,
        GIR_EraseRootFromParent_Done,
      // Label 26553: @2188129
      GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(2188238), // Rule ID 16630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16630,
        GIR_EraseRootFromParent_Done,
      // Label 26554: @2188238
      GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(2188347), // Rule ID 16631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10793:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16631,
        GIR_EraseRootFromParent_Done,
      // Label 26555: @2188347
      GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(2188456), // Rule ID 16634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16634,
        GIR_EraseRootFromParent_Done,
      // Label 26556: @2188456
      GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(2188565), // Rule ID 16635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16635,
        GIR_EraseRootFromParent_Done,
      // Label 26557: @2188565
      GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(2188674), // Rule ID 16638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16638,
        GIR_EraseRootFromParent_Done,
      // Label 26558: @2188674
      GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(2188783), // Rule ID 16639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16639,
        GIR_EraseRootFromParent_Done,
      // Label 26559: @2188783
      GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(2188892), // Rule ID 16642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16642,
        GIR_EraseRootFromParent_Done,
      // Label 26560: @2188892
      GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(2189001), // Rule ID 16643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16643,
        GIR_EraseRootFromParent_Done,
      // Label 26561: @2189001
      GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(2189110), // Rule ID 16646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16646,
        GIR_EraseRootFromParent_Done,
      // Label 26562: @2189110
      GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(2189219), // Rule ID 16647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16647,
        GIR_EraseRootFromParent_Done,
      // Label 26563: @2189219
      GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(2189328), // Rule ID 16650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16650,
        GIR_EraseRootFromParent_Done,
      // Label 26564: @2189328
      GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(2189437), // Rule ID 16651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16651,
        GIR_EraseRootFromParent_Done,
      // Label 26565: @2189437
      GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(2189546), // Rule ID 16654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16654,
        GIR_EraseRootFromParent_Done,
      // Label 26566: @2189546
      GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(2189655), // Rule ID 16655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16655,
        GIR_EraseRootFromParent_Done,
      // Label 26567: @2189655
      GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(2189764), // Rule ID 16658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16658,
        GIR_EraseRootFromParent_Done,
      // Label 26568: @2189764
      GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(2189873), // Rule ID 16659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10793:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16659,
        GIR_EraseRootFromParent_Done,
      // Label 26569: @2189873
      GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(2189982), // Rule ID 16662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16662,
        GIR_EraseRootFromParent_Done,
      // Label 26570: @2189982
      GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(2190091), // Rule ID 16663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10793:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16663,
        GIR_EraseRootFromParent_Done,
      // Label 26571: @2190091
      GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(2190200), // Rule ID 16666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16666,
        GIR_EraseRootFromParent_Done,
      // Label 26572: @2190200
      GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(2190309), // Rule ID 16667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10793:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16667,
        GIR_EraseRootFromParent_Done,
      // Label 26573: @2190309
      GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(2190418), // Rule ID 16670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16670,
        GIR_EraseRootFromParent_Done,
      // Label 26574: @2190418
      GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(2190527), // Rule ID 16671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16671,
        GIR_EraseRootFromParent_Done,
      // Label 26575: @2190527
      GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(2190636), // Rule ID 16674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16674,
        GIR_EraseRootFromParent_Done,
      // Label 26576: @2190636
      GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(2190745), // Rule ID 16675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16675,
        GIR_EraseRootFromParent_Done,
      // Label 26577: @2190745
      GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(2190854), // Rule ID 16678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16678,
        GIR_EraseRootFromParent_Done,
      // Label 26578: @2190854
      GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(2190963), // Rule ID 16679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16679,
        GIR_EraseRootFromParent_Done,
      // Label 26579: @2190963
      GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(2191072), // Rule ID 16682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16682,
        GIR_EraseRootFromParent_Done,
      // Label 26580: @2191072
      GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(2191181), // Rule ID 16683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16683,
        GIR_EraseRootFromParent_Done,
      // Label 26581: @2191181
      GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(2191290), // Rule ID 16686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16686,
        GIR_EraseRootFromParent_Done,
      // Label 26582: @2191290
      GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(2191399), // Rule ID 16687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16687,
        GIR_EraseRootFromParent_Done,
      // Label 26583: @2191399
      GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(2191508), // Rule ID 16690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16690,
        GIR_EraseRootFromParent_Done,
      // Label 26584: @2191508
      GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(2191617), // Rule ID 16691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16691,
        GIR_EraseRootFromParent_Done,
      // Label 26585: @2191617
      GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(2191726), // Rule ID 16694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16694,
        GIR_EraseRootFromParent_Done,
      // Label 26586: @2191726
      GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(2191835), // Rule ID 16695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16695,
        GIR_EraseRootFromParent_Done,
      // Label 26587: @2191835
      GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(2191944), // Rule ID 16698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16698,
        GIR_EraseRootFromParent_Done,
      // Label 26588: @2191944
      GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(2192053), // Rule ID 16699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16699,
        GIR_EraseRootFromParent_Done,
      // Label 26589: @2192053
      GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(2192162), // Rule ID 16702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16702,
        GIR_EraseRootFromParent_Done,
      // Label 26590: @2192162
      GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(2192271), // Rule ID 16703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16703,
        GIR_EraseRootFromParent_Done,
      // Label 26591: @2192271
      GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(2192380), // Rule ID 16706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16706,
        GIR_EraseRootFromParent_Done,
      // Label 26592: @2192380
      GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(2192489), // Rule ID 16707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16707,
        GIR_EraseRootFromParent_Done,
      // Label 26593: @2192489
      GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(2192598), // Rule ID 16710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16710,
        GIR_EraseRootFromParent_Done,
      // Label 26594: @2192598
      GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(2192707), // Rule ID 16711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16711,
        GIR_EraseRootFromParent_Done,
      // Label 26595: @2192707
      GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(2192816), // Rule ID 16714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16714,
        GIR_EraseRootFromParent_Done,
      // Label 26596: @2192816
      GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(2192925), // Rule ID 16715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16715,
        GIR_EraseRootFromParent_Done,
      // Label 26597: @2192925
      GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(2193034), // Rule ID 16718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16718,
        GIR_EraseRootFromParent_Done,
      // Label 26598: @2193034
      GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(2193143), // Rule ID 16719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16719,
        GIR_EraseRootFromParent_Done,
      // Label 26599: @2193143
      GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(2193252), // Rule ID 16722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16722,
        GIR_EraseRootFromParent_Done,
      // Label 26600: @2193252
      GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(2193361), // Rule ID 16723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16723,
        GIR_EraseRootFromParent_Done,
      // Label 26601: @2193361
      GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(2193470), // Rule ID 16726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16726,
        GIR_EraseRootFromParent_Done,
      // Label 26602: @2193470
      GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(2193579), // Rule ID 16727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16727,
        GIR_EraseRootFromParent_Done,
      // Label 26603: @2193579
      GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(2193688), // Rule ID 16730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16730,
        GIR_EraseRootFromParent_Done,
      // Label 26604: @2193688
      GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(2193797), // Rule ID 16731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16731,
        GIR_EraseRootFromParent_Done,
      // Label 26605: @2193797
      GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(2193906), // Rule ID 16734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16734,
        GIR_EraseRootFromParent_Done,
      // Label 26606: @2193906
      GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(2194015), // Rule ID 16735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16735,
        GIR_EraseRootFromParent_Done,
      // Label 26607: @2194015
      GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(2194124), // Rule ID 16738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16738,
        GIR_EraseRootFromParent_Done,
      // Label 26608: @2194124
      GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(2194233), // Rule ID 16739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16739,
        GIR_EraseRootFromParent_Done,
      // Label 26609: @2194233
      GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(2194342), // Rule ID 16742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16742,
        GIR_EraseRootFromParent_Done,
      // Label 26610: @2194342
      GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(2194451), // Rule ID 16743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10885:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16743,
        GIR_EraseRootFromParent_Done,
      // Label 26611: @2194451
      GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(2194560), // Rule ID 16746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16746,
        GIR_EraseRootFromParent_Done,
      // Label 26612: @2194560
      GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(2194669), // Rule ID 16747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10885:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16747,
        GIR_EraseRootFromParent_Done,
      // Label 26613: @2194669
      GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(2194778), // Rule ID 16750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16750,
        GIR_EraseRootFromParent_Done,
      // Label 26614: @2194778
      GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(2194887), // Rule ID 16751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10885:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16751,
        GIR_EraseRootFromParent_Done,
      // Label 26615: @2194887
      GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(2194996), // Rule ID 16754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16754,
        GIR_EraseRootFromParent_Done,
      // Label 26616: @2194996
      GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(2195105), // Rule ID 16755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16755,
        GIR_EraseRootFromParent_Done,
      // Label 26617: @2195105
      GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(2195214), // Rule ID 16758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16758,
        GIR_EraseRootFromParent_Done,
      // Label 26618: @2195214
      GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(2195323), // Rule ID 16759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16759,
        GIR_EraseRootFromParent_Done,
      // Label 26619: @2195323
      GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(2195432), // Rule ID 16762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16762,
        GIR_EraseRootFromParent_Done,
      // Label 26620: @2195432
      GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(2195541), // Rule ID 16763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16763,
        GIR_EraseRootFromParent_Done,
      // Label 26621: @2195541
      GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(2195650), // Rule ID 16766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16766,
        GIR_EraseRootFromParent_Done,
      // Label 26622: @2195650
      GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(2195759), // Rule ID 16767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16767,
        GIR_EraseRootFromParent_Done,
      // Label 26623: @2195759
      GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(2195868), // Rule ID 16770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16770,
        GIR_EraseRootFromParent_Done,
      // Label 26624: @2195868
      GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(2195977), // Rule ID 16771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16771,
        GIR_EraseRootFromParent_Done,
      // Label 26625: @2195977
      GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(2196086), // Rule ID 16774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16774,
        GIR_EraseRootFromParent_Done,
      // Label 26626: @2196086
      GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(2196195), // Rule ID 16775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16775,
        GIR_EraseRootFromParent_Done,
      // Label 26627: @2196195
      GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(2196304), // Rule ID 16778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16778,
        GIR_EraseRootFromParent_Done,
      // Label 26628: @2196304
      GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(2196413), // Rule ID 16779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10885:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16779,
        GIR_EraseRootFromParent_Done,
      // Label 26629: @2196413
      GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(2196522), // Rule ID 16782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16782,
        GIR_EraseRootFromParent_Done,
      // Label 26630: @2196522
      GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(2196631), // Rule ID 16783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10885:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16783,
        GIR_EraseRootFromParent_Done,
      // Label 26631: @2196631
      GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(2196740), // Rule ID 16786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16786,
        GIR_EraseRootFromParent_Done,
      // Label 26632: @2196740
      GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(2196849), // Rule ID 16787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10885:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16787,
        GIR_EraseRootFromParent_Done,
      // Label 26633: @2196849
      GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(2196958), // Rule ID 16790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16790,
        GIR_EraseRootFromParent_Done,
      // Label 26634: @2196958
      GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(2197067), // Rule ID 16791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16791,
        GIR_EraseRootFromParent_Done,
      // Label 26635: @2197067
      GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(2197176), // Rule ID 16794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16794,
        GIR_EraseRootFromParent_Done,
      // Label 26636: @2197176
      GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(2197285), // Rule ID 16795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16795,
        GIR_EraseRootFromParent_Done,
      // Label 26637: @2197285
      GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(2197394), // Rule ID 16798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16798,
        GIR_EraseRootFromParent_Done,
      // Label 26638: @2197394
      GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(2197503), // Rule ID 16799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16799,
        GIR_EraseRootFromParent_Done,
      // Label 26639: @2197503
      GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(2197612), // Rule ID 16802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16802,
        GIR_EraseRootFromParent_Done,
      // Label 26640: @2197612
      GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(2197721), // Rule ID 16803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10871:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16803,
        GIR_EraseRootFromParent_Done,
      // Label 26641: @2197721
      GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(2197830), // Rule ID 16806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16806,
        GIR_EraseRootFromParent_Done,
      // Label 26642: @2197830
      GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(2197939), // Rule ID 16807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10871:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16807,
        GIR_EraseRootFromParent_Done,
      // Label 26643: @2197939
      GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(2198048), // Rule ID 16810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16810,
        GIR_EraseRootFromParent_Done,
      // Label 26644: @2198048
      GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(2198157), // Rule ID 16811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10871:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16811,
        GIR_EraseRootFromParent_Done,
      // Label 26645: @2198157
      GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(2198266), // Rule ID 16814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16814,
        GIR_EraseRootFromParent_Done,
      // Label 26646: @2198266
      GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(2198375), // Rule ID 16815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16815,
        GIR_EraseRootFromParent_Done,
      // Label 26647: @2198375
      GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(2198484), // Rule ID 16818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16818,
        GIR_EraseRootFromParent_Done,
      // Label 26648: @2198484
      GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(2198593), // Rule ID 16819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16819,
        GIR_EraseRootFromParent_Done,
      // Label 26649: @2198593
      GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(2198702), // Rule ID 16822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16822,
        GIR_EraseRootFromParent_Done,
      // Label 26650: @2198702
      GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(2198811), // Rule ID 16823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16823,
        GIR_EraseRootFromParent_Done,
      // Label 26651: @2198811
      GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(2198920), // Rule ID 16826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16826,
        GIR_EraseRootFromParent_Done,
      // Label 26652: @2198920
      GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(2199029), // Rule ID 16827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16827,
        GIR_EraseRootFromParent_Done,
      // Label 26653: @2199029
      GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(2199138), // Rule ID 16830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16830,
        GIR_EraseRootFromParent_Done,
      // Label 26654: @2199138
      GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(2199247), // Rule ID 16831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16831,
        GIR_EraseRootFromParent_Done,
      // Label 26655: @2199247
      GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(2199356), // Rule ID 16834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16834,
        GIR_EraseRootFromParent_Done,
      // Label 26656: @2199356
      GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(2199465), // Rule ID 16835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16835,
        GIR_EraseRootFromParent_Done,
      // Label 26657: @2199465
      GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(2199574), // Rule ID 16838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16838,
        GIR_EraseRootFromParent_Done,
      // Label 26658: @2199574
      GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(2199683), // Rule ID 16839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10871:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16839,
        GIR_EraseRootFromParent_Done,
      // Label 26659: @2199683
      GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(2199792), // Rule ID 16842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16842,
        GIR_EraseRootFromParent_Done,
      // Label 26660: @2199792
      GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(2199901), // Rule ID 16843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10871:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16843,
        GIR_EraseRootFromParent_Done,
      // Label 26661: @2199901
      GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(2200010), // Rule ID 16846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16846,
        GIR_EraseRootFromParent_Done,
      // Label 26662: @2200010
      GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(2200119), // Rule ID 16847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10871:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16847,
        GIR_EraseRootFromParent_Done,
      // Label 26663: @2200119
      GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(2200228), // Rule ID 16850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16850,
        GIR_EraseRootFromParent_Done,
      // Label 26664: @2200228
      GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(2200337), // Rule ID 16851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16851,
        GIR_EraseRootFromParent_Done,
      // Label 26665: @2200337
      GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(2200446), // Rule ID 16854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16854,
        GIR_EraseRootFromParent_Done,
      // Label 26666: @2200446
      GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(2200555), // Rule ID 16855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16855,
        GIR_EraseRootFromParent_Done,
      // Label 26667: @2200555
      GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(2200664), // Rule ID 16858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16858,
        GIR_EraseRootFromParent_Done,
      // Label 26668: @2200664
      GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(2200773), // Rule ID 16859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16859,
        GIR_EraseRootFromParent_Done,
      // Label 26669: @2200773
      GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(2200882), // Rule ID 16862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16862,
        GIR_EraseRootFromParent_Done,
      // Label 26670: @2200882
      GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(2200991), // Rule ID 16863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16863,
        GIR_EraseRootFromParent_Done,
      // Label 26671: @2200991
      GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(2201100), // Rule ID 16866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16866,
        GIR_EraseRootFromParent_Done,
      // Label 26672: @2201100
      GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(2201209), // Rule ID 16867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16867,
        GIR_EraseRootFromParent_Done,
      // Label 26673: @2201209
      GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(2201318), // Rule ID 16870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16870,
        GIR_EraseRootFromParent_Done,
      // Label 26674: @2201318
      GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(2201427), // Rule ID 16871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16871,
        GIR_EraseRootFromParent_Done,
      // Label 26675: @2201427
      GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(2201536), // Rule ID 16874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16874,
        GIR_EraseRootFromParent_Done,
      // Label 26676: @2201536
      GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(2201645), // Rule ID 16875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16875,
        GIR_EraseRootFromParent_Done,
      // Label 26677: @2201645
      GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(2201754), // Rule ID 16878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16878,
        GIR_EraseRootFromParent_Done,
      // Label 26678: @2201754
      GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(2201863), // Rule ID 16879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16879,
        GIR_EraseRootFromParent_Done,
      // Label 26679: @2201863
      GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(2201972), // Rule ID 16882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16882,
        GIR_EraseRootFromParent_Done,
      // Label 26680: @2201972
      GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(2202081), // Rule ID 16883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16883,
        GIR_EraseRootFromParent_Done,
      // Label 26681: @2202081
      GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(2202190), // Rule ID 16886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16886,
        GIR_EraseRootFromParent_Done,
      // Label 26682: @2202190
      GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(2202299), // Rule ID 16887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16887,
        GIR_EraseRootFromParent_Done,
      // Label 26683: @2202299
      GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(2202408), // Rule ID 16890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16890,
        GIR_EraseRootFromParent_Done,
      // Label 26684: @2202408
      GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(2202517), // Rule ID 16891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10887:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16891,
        GIR_EraseRootFromParent_Done,
      // Label 26685: @2202517
      GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(2202626), // Rule ID 16894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16894,
        GIR_EraseRootFromParent_Done,
      // Label 26686: @2202626
      GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(2202735), // Rule ID 16895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16895,
        GIR_EraseRootFromParent_Done,
      // Label 26687: @2202735
      GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(2202844), // Rule ID 16898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16898,
        GIR_EraseRootFromParent_Done,
      // Label 26688: @2202844
      GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(2202953), // Rule ID 16899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16899,
        GIR_EraseRootFromParent_Done,
      // Label 26689: @2202953
      GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(2203062), // Rule ID 16902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16902,
        GIR_EraseRootFromParent_Done,
      // Label 26690: @2203062
      GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(2203171), // Rule ID 16903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16903,
        GIR_EraseRootFromParent_Done,
      // Label 26691: @2203171
      GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(2203280), // Rule ID 16906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16906,
        GIR_EraseRootFromParent_Done,
      // Label 26692: @2203280
      GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(2203389), // Rule ID 16907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10887:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16907,
        GIR_EraseRootFromParent_Done,
      // Label 26693: @2203389
      GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(2203498), // Rule ID 16910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16910,
        GIR_EraseRootFromParent_Done,
      // Label 26694: @2203498
      GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(2203607), // Rule ID 16911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10887:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16911,
        GIR_EraseRootFromParent_Done,
      // Label 26695: @2203607
      GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(2203716), // Rule ID 16914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16914,
        GIR_EraseRootFromParent_Done,
      // Label 26696: @2203716
      GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(2203825), // Rule ID 16915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10887:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16915,
        GIR_EraseRootFromParent_Done,
      // Label 26697: @2203825
      GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(2203934), // Rule ID 16918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16918,
        GIR_EraseRootFromParent_Done,
      // Label 26698: @2203934
      GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(2204043), // Rule ID 16919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10887:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16919,
        GIR_EraseRootFromParent_Done,
      // Label 26699: @2204043
      GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(2204152), // Rule ID 16922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16922,
        GIR_EraseRootFromParent_Done,
      // Label 26700: @2204152
      GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(2204261), // Rule ID 16923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16923,
        GIR_EraseRootFromParent_Done,
      // Label 26701: @2204261
      GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(2204370), // Rule ID 16926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16926,
        GIR_EraseRootFromParent_Done,
      // Label 26702: @2204370
      GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(2204479), // Rule ID 16927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16927,
        GIR_EraseRootFromParent_Done,
      // Label 26703: @2204479
      GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(2204588), // Rule ID 16930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16930,
        GIR_EraseRootFromParent_Done,
      // Label 26704: @2204588
      GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(2204697), // Rule ID 16931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16931,
        GIR_EraseRootFromParent_Done,
      // Label 26705: @2204697
      GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(2204806), // Rule ID 16934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16934,
        GIR_EraseRootFromParent_Done,
      // Label 26706: @2204806
      GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(2204915), // Rule ID 16935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16935,
        GIR_EraseRootFromParent_Done,
      // Label 26707: @2204915
      GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(2205024), // Rule ID 16938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10923:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16938,
        GIR_EraseRootFromParent_Done,
      // Label 26708: @2205024
      GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(2205133), // Rule ID 16939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10923:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16939,
        GIR_EraseRootFromParent_Done,
      // Label 26709: @2205133
      GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(2205242), // Rule ID 16942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16942,
        GIR_EraseRootFromParent_Done,
      // Label 26710: @2205242
      GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(2205351), // Rule ID 16943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16943,
        GIR_EraseRootFromParent_Done,
      // Label 26711: @2205351
      GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(2205460), // Rule ID 16946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16946,
        GIR_EraseRootFromParent_Done,
      // Label 26712: @2205460
      GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(2205569), // Rule ID 16947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16947,
        GIR_EraseRootFromParent_Done,
      // Label 26713: @2205569
      GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(2205678), // Rule ID 16950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16950,
        GIR_EraseRootFromParent_Done,
      // Label 26714: @2205678
      GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(2205787), // Rule ID 16951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16951,
        GIR_EraseRootFromParent_Done,
      // Label 26715: @2205787
      GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(2205896), // Rule ID 16954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10923:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16954,
        GIR_EraseRootFromParent_Done,
      // Label 26716: @2205896
      GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(2206005), // Rule ID 16955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10923:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16955,
        GIR_EraseRootFromParent_Done,
      // Label 26717: @2206005
      GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(2206114), // Rule ID 16958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16958,
        GIR_EraseRootFromParent_Done,
      // Label 26718: @2206114
      GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(2206223), // Rule ID 16959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16959,
        GIR_EraseRootFromParent_Done,
      // Label 26719: @2206223
      GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(2206332), // Rule ID 16962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16962,
        GIR_EraseRootFromParent_Done,
      // Label 26720: @2206332
      GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(2206441), // Rule ID 16963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10923:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16963,
        GIR_EraseRootFromParent_Done,
      // Label 26721: @2206441
      GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(2206550), // Rule ID 16966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16966,
        GIR_EraseRootFromParent_Done,
      // Label 26722: @2206550
      GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(2206659), // Rule ID 16967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16967,
        GIR_EraseRootFromParent_Done,
      // Label 26723: @2206659
      GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(2206768), // Rule ID 16970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16970,
        GIR_EraseRootFromParent_Done,
      // Label 26724: @2206768
      GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(2206877), // Rule ID 16971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16971,
        GIR_EraseRootFromParent_Done,
      // Label 26725: @2206877
      GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(2206986), // Rule ID 16974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10923:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16974,
        GIR_EraseRootFromParent_Done,
      // Label 26726: @2206986
      GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(2207095), // Rule ID 16975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10923:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16975,
        GIR_EraseRootFromParent_Done,
      // Label 26727: @2207095
      GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(2207204), // Rule ID 16978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16978,
        GIR_EraseRootFromParent_Done,
      // Label 26728: @2207204
      GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(2207313), // Rule ID 16979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10923:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16979,
        GIR_EraseRootFromParent_Done,
      // Label 26729: @2207313
      GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(2207422), // Rule ID 16982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16982,
        GIR_EraseRootFromParent_Done,
      // Label 26730: @2207422
      GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(2207531), // Rule ID 16983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10923:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16983,
        GIR_EraseRootFromParent_Done,
      // Label 26731: @2207531
      GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(2207640), // Rule ID 16986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16986,
        GIR_EraseRootFromParent_Done,
      // Label 26732: @2207640
      GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(2207749), // Rule ID 16987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10923:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16987,
        GIR_EraseRootFromParent_Done,
      // Label 26733: @2207749
      GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(2207858), // Rule ID 16990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10923:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16990,
        GIR_EraseRootFromParent_Done,
      // Label 26734: @2207858
      GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(2207967), // Rule ID 16991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10923:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16991,
        GIR_EraseRootFromParent_Done,
      // Label 26735: @2207967
      GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(2208076), // Rule ID 17000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17000,
        GIR_EraseRootFromParent_Done,
      // Label 26736: @2208076
      GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(2208185), // Rule ID 17001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17001,
        GIR_EraseRootFromParent_Done,
      // Label 26737: @2208185
      GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(2208294), // Rule ID 17010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17010,
        GIR_EraseRootFromParent_Done,
      // Label 26738: @2208294
      GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(2208403), // Rule ID 17011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17011,
        GIR_EraseRootFromParent_Done,
      // Label 26739: @2208403
      GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(2208512), // Rule ID 17020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17020,
        GIR_EraseRootFromParent_Done,
      // Label 26740: @2208512
      GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(2208621), // Rule ID 17021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17021,
        GIR_EraseRootFromParent_Done,
      // Label 26741: @2208621
      GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(2208730), // Rule ID 17030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17030,
        GIR_EraseRootFromParent_Done,
      // Label 26742: @2208730
      GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(2208839), // Rule ID 17031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17031,
        GIR_EraseRootFromParent_Done,
      // Label 26743: @2208839
      GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(2208948), // Rule ID 17040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17040,
        GIR_EraseRootFromParent_Done,
      // Label 26744: @2208948
      GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(2209057), // Rule ID 17041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17041,
        GIR_EraseRootFromParent_Done,
      // Label 26745: @2209057
      GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(2209166), // Rule ID 17050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17050,
        GIR_EraseRootFromParent_Done,
      // Label 26746: @2209166
      GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(2209275), // Rule ID 17051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17051,
        GIR_EraseRootFromParent_Done,
      // Label 26747: @2209275
      GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(2209384), // Rule ID 17060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17060,
        GIR_EraseRootFromParent_Done,
      // Label 26748: @2209384
      GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(2209493), // Rule ID 17061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17061,
        GIR_EraseRootFromParent_Done,
      // Label 26749: @2209493
      GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(2209602), // Rule ID 17070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17070,
        GIR_EraseRootFromParent_Done,
      // Label 26750: @2209602
      GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(2209711), // Rule ID 17071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17071,
        GIR_EraseRootFromParent_Done,
      // Label 26751: @2209711
      GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(2209820), // Rule ID 17074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17074,
        GIR_EraseRootFromParent_Done,
      // Label 26752: @2209820
      GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(2209929), // Rule ID 17075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17075,
        GIR_EraseRootFromParent_Done,
      // Label 26753: @2209929
      GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(2210038), // Rule ID 17078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17078,
        GIR_EraseRootFromParent_Done,
      // Label 26754: @2210038
      GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(2210147), // Rule ID 17079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10889:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17079,
        GIR_EraseRootFromParent_Done,
      // Label 26755: @2210147
      GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(2210256), // Rule ID 17082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17082,
        GIR_EraseRootFromParent_Done,
      // Label 26756: @2210256
      GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(2210365), // Rule ID 17083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17083,
        GIR_EraseRootFromParent_Done,
      // Label 26757: @2210365
      GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(2210474), // Rule ID 17086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17086,
        GIR_EraseRootFromParent_Done,
      // Label 26758: @2210474
      GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(2210583), // Rule ID 17087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17087,
        GIR_EraseRootFromParent_Done,
      // Label 26759: @2210583
      GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(2210692), // Rule ID 17090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17090,
        GIR_EraseRootFromParent_Done,
      // Label 26760: @2210692
      GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(2210801), // Rule ID 17091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17091,
        GIR_EraseRootFromParent_Done,
      // Label 26761: @2210801
      GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(2210910), // Rule ID 17094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17094,
        GIR_EraseRootFromParent_Done,
      // Label 26762: @2210910
      GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(2211019), // Rule ID 17095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10889:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17095,
        GIR_EraseRootFromParent_Done,
      // Label 26763: @2211019
      GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2211128), // Rule ID 17098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17098,
        GIR_EraseRootFromParent_Done,
      // Label 26764: @2211128
      GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2211237), // Rule ID 17099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10889:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17099,
        GIR_EraseRootFromParent_Done,
      // Label 26765: @2211237
      GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2211346), // Rule ID 17102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17102,
        GIR_EraseRootFromParent_Done,
      // Label 26766: @2211346
      GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2211455), // Rule ID 17103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10889:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17103,
        GIR_EraseRootFromParent_Done,
      // Label 26767: @2211455
      GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2211564), // Rule ID 17106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17106,
        GIR_EraseRootFromParent_Done,
      // Label 26768: @2211564
      GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2211673), // Rule ID 17107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10889:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17107,
        GIR_EraseRootFromParent_Done,
      // Label 26769: @2211673
      GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2211782), // Rule ID 17116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17116,
        GIR_EraseRootFromParent_Done,
      // Label 26770: @2211782
      GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2211891), // Rule ID 17117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17117,
        GIR_EraseRootFromParent_Done,
      // Label 26771: @2211891
      GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2212000), // Rule ID 17126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17126,
        GIR_EraseRootFromParent_Done,
      // Label 26772: @2212000
      GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2212109), // Rule ID 17127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17127,
        GIR_EraseRootFromParent_Done,
      // Label 26773: @2212109
      GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2212218), // Rule ID 17136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17136,
        GIR_EraseRootFromParent_Done,
      // Label 26774: @2212218
      GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2212327), // Rule ID 17137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17137,
        GIR_EraseRootFromParent_Done,
      // Label 26775: @2212327
      GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2212436), // Rule ID 17146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17146,
        GIR_EraseRootFromParent_Done,
      // Label 26776: @2212436
      GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2212545), // Rule ID 17147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17147,
        GIR_EraseRootFromParent_Done,
      // Label 26777: @2212545
      GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2212654), // Rule ID 17156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17156,
        GIR_EraseRootFromParent_Done,
      // Label 26778: @2212654
      GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2212763), // Rule ID 17157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17157,
        GIR_EraseRootFromParent_Done,
      // Label 26779: @2212763
      GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2212872), // Rule ID 17166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17166,
        GIR_EraseRootFromParent_Done,
      // Label 26780: @2212872
      GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2212981), // Rule ID 17167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17167,
        GIR_EraseRootFromParent_Done,
      // Label 26781: @2212981
      GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2213090), // Rule ID 17176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17176,
        GIR_EraseRootFromParent_Done,
      // Label 26782: @2213090
      GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2213199), // Rule ID 17177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17177,
        GIR_EraseRootFromParent_Done,
      // Label 26783: @2213199
      GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2213308), // Rule ID 17186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17186,
        GIR_EraseRootFromParent_Done,
      // Label 26784: @2213308
      GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2213417), // Rule ID 17187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17187,
        GIR_EraseRootFromParent_Done,
      // Label 26785: @2213417
      GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2213526), // Rule ID 17196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17196,
        GIR_EraseRootFromParent_Done,
      // Label 26786: @2213526
      GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2213635), // Rule ID 17197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17197,
        GIR_EraseRootFromParent_Done,
      // Label 26787: @2213635
      GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2213744), // Rule ID 17200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17200,
        GIR_EraseRootFromParent_Done,
      // Label 26788: @2213744
      GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2213853), // Rule ID 17201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17201,
        GIR_EraseRootFromParent_Done,
      // Label 26789: @2213853
      GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2213962), // Rule ID 17204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17204,
        GIR_EraseRootFromParent_Done,
      // Label 26790: @2213962
      GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2214071), // Rule ID 17205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10925:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17205,
        GIR_EraseRootFromParent_Done,
      // Label 26791: @2214071
      GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2214180), // Rule ID 17208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17208,
        GIR_EraseRootFromParent_Done,
      // Label 26792: @2214180
      GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2214289), // Rule ID 17209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17209,
        GIR_EraseRootFromParent_Done,
      // Label 26793: @2214289
      GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2214398), // Rule ID 17212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17212,
        GIR_EraseRootFromParent_Done,
      // Label 26794: @2214398
      GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2214507), // Rule ID 17213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17213,
        GIR_EraseRootFromParent_Done,
      // Label 26795: @2214507
      GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2214616), // Rule ID 17216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17216,
        GIR_EraseRootFromParent_Done,
      // Label 26796: @2214616
      GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2214725), // Rule ID 17217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17217,
        GIR_EraseRootFromParent_Done,
      // Label 26797: @2214725
      GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2214834), // Rule ID 17220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17220,
        GIR_EraseRootFromParent_Done,
      // Label 26798: @2214834
      GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2214943), // Rule ID 17221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10925:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17221,
        GIR_EraseRootFromParent_Done,
      // Label 26799: @2214943
      GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2215052), // Rule ID 17224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17224,
        GIR_EraseRootFromParent_Done,
      // Label 26800: @2215052
      GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2215161), // Rule ID 17225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10925:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17225,
        GIR_EraseRootFromParent_Done,
      // Label 26801: @2215161
      GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2215270), // Rule ID 17228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17228,
        GIR_EraseRootFromParent_Done,
      // Label 26802: @2215270
      GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2215379), // Rule ID 17229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10925:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17229,
        GIR_EraseRootFromParent_Done,
      // Label 26803: @2215379
      GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2215488), // Rule ID 17232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17232,
        GIR_EraseRootFromParent_Done,
      // Label 26804: @2215488
      GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2215597), // Rule ID 17233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10925:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17233,
        GIR_EraseRootFromParent_Done,
      // Label 26805: @2215597
      GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2215706), // Rule ID 17236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17236,
        GIR_EraseRootFromParent_Done,
      // Label 26806: @2215706
      GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2215815), // Rule ID 17237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17237,
        GIR_EraseRootFromParent_Done,
      // Label 26807: @2215815
      GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2215924), // Rule ID 17240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17240,
        GIR_EraseRootFromParent_Done,
      // Label 26808: @2215924
      GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2216033), // Rule ID 17241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17241,
        GIR_EraseRootFromParent_Done,
      // Label 26809: @2216033
      GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2216142), // Rule ID 17244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17244,
        GIR_EraseRootFromParent_Done,
      // Label 26810: @2216142
      GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2216251), // Rule ID 17245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17245,
        GIR_EraseRootFromParent_Done,
      // Label 26811: @2216251
      GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2216360), // Rule ID 17248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17248,
        GIR_EraseRootFromParent_Done,
      // Label 26812: @2216360
      GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2216469), // Rule ID 17249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17249,
        GIR_EraseRootFromParent_Done,
      // Label 26813: @2216469
      GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2216578), // Rule ID 17252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10826:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17252,
        GIR_EraseRootFromParent_Done,
      // Label 26814: @2216578
      GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2216687), // Rule ID 17253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10826:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17253,
        GIR_EraseRootFromParent_Done,
      // Label 26815: @2216687
      GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2216796), // Rule ID 17256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17256,
        GIR_EraseRootFromParent_Done,
      // Label 26816: @2216796
      GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2216905), // Rule ID 17257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17257,
        GIR_EraseRootFromParent_Done,
      // Label 26817: @2216905
      GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2217014), // Rule ID 17260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17260,
        GIR_EraseRootFromParent_Done,
      // Label 26818: @2217014
      GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2217123), // Rule ID 17261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17261,
        GIR_EraseRootFromParent_Done,
      // Label 26819: @2217123
      GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2217232), // Rule ID 17264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17264,
        GIR_EraseRootFromParent_Done,
      // Label 26820: @2217232
      GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2217341), // Rule ID 17265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17265,
        GIR_EraseRootFromParent_Done,
      // Label 26821: @2217341
      GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2217450), // Rule ID 17268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17268,
        GIR_EraseRootFromParent_Done,
      // Label 26822: @2217450
      GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2217559), // Rule ID 17269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17269,
        GIR_EraseRootFromParent_Done,
      // Label 26823: @2217559
      GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2217668), // Rule ID 17272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17272,
        GIR_EraseRootFromParent_Done,
      // Label 26824: @2217668
      GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2217777), // Rule ID 17273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17273,
        GIR_EraseRootFromParent_Done,
      // Label 26825: @2217777
      GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2217886), // Rule ID 17276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17276,
        GIR_EraseRootFromParent_Done,
      // Label 26826: @2217886
      GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2217995), // Rule ID 17277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17277,
        GIR_EraseRootFromParent_Done,
      // Label 26827: @2217995
      GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2218104), // Rule ID 17280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17280,
        GIR_EraseRootFromParent_Done,
      // Label 26828: @2218104
      GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2218213), // Rule ID 17281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17281,
        GIR_EraseRootFromParent_Done,
      // Label 26829: @2218213
      GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2218322), // Rule ID 17284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17284,
        GIR_EraseRootFromParent_Done,
      // Label 26830: @2218322
      GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2218431), // Rule ID 17285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17285,
        GIR_EraseRootFromParent_Done,
      // Label 26831: @2218431
      GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2218540), // Rule ID 17288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17288,
        GIR_EraseRootFromParent_Done,
      // Label 26832: @2218540
      GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2218649), // Rule ID 17289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17289,
        GIR_EraseRootFromParent_Done,
      // Label 26833: @2218649
      GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2218758), // Rule ID 17292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17292,
        GIR_EraseRootFromParent_Done,
      // Label 26834: @2218758
      GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2218867), // Rule ID 17293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17293,
        GIR_EraseRootFromParent_Done,
      // Label 26835: @2218867
      GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2218976), // Rule ID 17296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17296,
        GIR_EraseRootFromParent_Done,
      // Label 26836: @2218976
      GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2219085), // Rule ID 17297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17297,
        GIR_EraseRootFromParent_Done,
      // Label 26837: @2219085
      GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2219194), // Rule ID 17300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17300,
        GIR_EraseRootFromParent_Done,
      // Label 26838: @2219194
      GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2219303), // Rule ID 17301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17301,
        GIR_EraseRootFromParent_Done,
      // Label 26839: @2219303
      GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2219412), // Rule ID 17304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17304,
        GIR_EraseRootFromParent_Done,
      // Label 26840: @2219412
      GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2219521), // Rule ID 17305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17305,
        GIR_EraseRootFromParent_Done,
      // Label 26841: @2219521
      GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2219630), // Rule ID 17308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17308,
        GIR_EraseRootFromParent_Done,
      // Label 26842: @2219630
      GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2219739), // Rule ID 17309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10826:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17309,
        GIR_EraseRootFromParent_Done,
      // Label 26843: @2219739
      GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2219848), // Rule ID 17312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10826:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17312,
        GIR_EraseRootFromParent_Done,
      // Label 26844: @2219848
      GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2219957), // Rule ID 17313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10826:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17313,
        GIR_EraseRootFromParent_Done,
      // Label 26845: @2219957
      GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2220066), // Rule ID 17316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17316,
        GIR_EraseRootFromParent_Done,
      // Label 26846: @2220066
      GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2220175), // Rule ID 17317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10826:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17317,
        GIR_EraseRootFromParent_Done,
      // Label 26847: @2220175
      GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2220284), // Rule ID 17320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17320,
        GIR_EraseRootFromParent_Done,
      // Label 26848: @2220284
      GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2220393), // Rule ID 17321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17321,
        GIR_EraseRootFromParent_Done,
      // Label 26849: @2220393
      GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2220502), // Rule ID 17324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17324,
        GIR_EraseRootFromParent_Done,
      // Label 26850: @2220502
      GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2220611), // Rule ID 17325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17325,
        GIR_EraseRootFromParent_Done,
      // Label 26851: @2220611
      GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2220720), // Rule ID 17328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17328,
        GIR_EraseRootFromParent_Done,
      // Label 26852: @2220720
      GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2220829), // Rule ID 17329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17329,
        GIR_EraseRootFromParent_Done,
      // Label 26853: @2220829
      GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2220938), // Rule ID 17332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17332,
        GIR_EraseRootFromParent_Done,
      // Label 26854: @2220938
      GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2221047), // Rule ID 17333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17333,
        GIR_EraseRootFromParent_Done,
      // Label 26855: @2221047
      GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2221156), // Rule ID 17336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17336,
        GIR_EraseRootFromParent_Done,
      // Label 26856: @2221156
      GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2221265), // Rule ID 17337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17337,
        GIR_EraseRootFromParent_Done,
      // Label 26857: @2221265
      GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2221374), // Rule ID 17340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17340,
        GIR_EraseRootFromParent_Done,
      // Label 26858: @2221374
      GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2221483), // Rule ID 17341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17341,
        GIR_EraseRootFromParent_Done,
      // Label 26859: @2221483
      GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2221592), // Rule ID 17344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17344,
        GIR_EraseRootFromParent_Done,
      // Label 26860: @2221592
      GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2221701), // Rule ID 17345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10826:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17345,
        GIR_EraseRootFromParent_Done,
      // Label 26861: @2221701
      GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2221810), // Rule ID 17348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17348,
        GIR_EraseRootFromParent_Done,
      // Label 26862: @2221810
      GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2221919), // Rule ID 17349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10826:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17349,
        GIR_EraseRootFromParent_Done,
      // Label 26863: @2221919
      GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2222028), // Rule ID 17352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17352,
        GIR_EraseRootFromParent_Done,
      // Label 26864: @2222028
      GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2222137), // Rule ID 17353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10826:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17353,
        GIR_EraseRootFromParent_Done,
      // Label 26865: @2222137
      GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2222246), // Rule ID 17356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17356,
        GIR_EraseRootFromParent_Done,
      // Label 26866: @2222246
      GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2222355), // Rule ID 17357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17357,
        GIR_EraseRootFromParent_Done,
      // Label 26867: @2222355
      GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2222464), // Rule ID 17360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17360,
        GIR_EraseRootFromParent_Done,
      // Label 26868: @2222464
      GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2222573), // Rule ID 17361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17361,
        GIR_EraseRootFromParent_Done,
      // Label 26869: @2222573
      GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2222682), // Rule ID 17364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17364,
        GIR_EraseRootFromParent_Done,
      // Label 26870: @2222682
      GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2222791), // Rule ID 17365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17365,
        GIR_EraseRootFromParent_Done,
      // Label 26871: @2222791
      GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2222900), // Rule ID 17368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17368,
        GIR_EraseRootFromParent_Done,
      // Label 26872: @2222900
      GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2223009), // Rule ID 17369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17369,
        GIR_EraseRootFromParent_Done,
      // Label 26873: @2223009
      GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2223118), // Rule ID 17372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10809:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17372,
        GIR_EraseRootFromParent_Done,
      // Label 26874: @2223118
      GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2223227), // Rule ID 17373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10809:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17373,
        GIR_EraseRootFromParent_Done,
      // Label 26875: @2223227
      GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2223336), // Rule ID 17376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17376,
        GIR_EraseRootFromParent_Done,
      // Label 26876: @2223336
      GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2223445), // Rule ID 17377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17377,
        GIR_EraseRootFromParent_Done,
      // Label 26877: @2223445
      GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2223554), // Rule ID 17380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17380,
        GIR_EraseRootFromParent_Done,
      // Label 26878: @2223554
      GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2223663), // Rule ID 17381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17381,
        GIR_EraseRootFromParent_Done,
      // Label 26879: @2223663
      GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2223772), // Rule ID 17384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17384,
        GIR_EraseRootFromParent_Done,
      // Label 26880: @2223772
      GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2223881), // Rule ID 17385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17385,
        GIR_EraseRootFromParent_Done,
      // Label 26881: @2223881
      GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2223990), // Rule ID 17388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17388,
        GIR_EraseRootFromParent_Done,
      // Label 26882: @2223990
      GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2224099), // Rule ID 17389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17389,
        GIR_EraseRootFromParent_Done,
      // Label 26883: @2224099
      GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2224208), // Rule ID 17392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17392,
        GIR_EraseRootFromParent_Done,
      // Label 26884: @2224208
      GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2224317), // Rule ID 17393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17393,
        GIR_EraseRootFromParent_Done,
      // Label 26885: @2224317
      GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2224426), // Rule ID 17396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17396,
        GIR_EraseRootFromParent_Done,
      // Label 26886: @2224426
      GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2224535), // Rule ID 17397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17397,
        GIR_EraseRootFromParent_Done,
      // Label 26887: @2224535
      GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2224644), // Rule ID 17400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17400,
        GIR_EraseRootFromParent_Done,
      // Label 26888: @2224644
      GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2224753), // Rule ID 17401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17401,
        GIR_EraseRootFromParent_Done,
      // Label 26889: @2224753
      GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2224862), // Rule ID 17404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17404,
        GIR_EraseRootFromParent_Done,
      // Label 26890: @2224862
      GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2224971), // Rule ID 17405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17405,
        GIR_EraseRootFromParent_Done,
      // Label 26891: @2224971
      GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2225080), // Rule ID 17408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17408,
        GIR_EraseRootFromParent_Done,
      // Label 26892: @2225080
      GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2225189), // Rule ID 17409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17409,
        GIR_EraseRootFromParent_Done,
      // Label 26893: @2225189
      GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2225298), // Rule ID 17412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17412,
        GIR_EraseRootFromParent_Done,
      // Label 26894: @2225298
      GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2225407), // Rule ID 17413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17413,
        GIR_EraseRootFromParent_Done,
      // Label 26895: @2225407
      GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2225516), // Rule ID 17416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17416,
        GIR_EraseRootFromParent_Done,
      // Label 26896: @2225516
      GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2225625), // Rule ID 17417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17417,
        GIR_EraseRootFromParent_Done,
      // Label 26897: @2225625
      GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2225734), // Rule ID 17420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17420,
        GIR_EraseRootFromParent_Done,
      // Label 26898: @2225734
      GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2225843), // Rule ID 17421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17421,
        GIR_EraseRootFromParent_Done,
      // Label 26899: @2225843
      GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2225952), // Rule ID 17424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17424,
        GIR_EraseRootFromParent_Done,
      // Label 26900: @2225952
      GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2226061), // Rule ID 17425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17425,
        GIR_EraseRootFromParent_Done,
      // Label 26901: @2226061
      GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2226170), // Rule ID 17428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17428,
        GIR_EraseRootFromParent_Done,
      // Label 26902: @2226170
      GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2226279), // Rule ID 17429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10809:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17429,
        GIR_EraseRootFromParent_Done,
      // Label 26903: @2226279
      GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2226388), // Rule ID 17432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10809:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17432,
        GIR_EraseRootFromParent_Done,
      // Label 26904: @2226388
      GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2226497), // Rule ID 17433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10809:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17433,
        GIR_EraseRootFromParent_Done,
      // Label 26905: @2226497
      GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2226606), // Rule ID 17436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17436,
        GIR_EraseRootFromParent_Done,
      // Label 26906: @2226606
      GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2226715), // Rule ID 17437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10809:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17437,
        GIR_EraseRootFromParent_Done,
      // Label 26907: @2226715
      GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2226824), // Rule ID 17440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17440,
        GIR_EraseRootFromParent_Done,
      // Label 26908: @2226824
      GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2226933), // Rule ID 17441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17441,
        GIR_EraseRootFromParent_Done,
      // Label 26909: @2226933
      GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2227042), // Rule ID 17444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17444,
        GIR_EraseRootFromParent_Done,
      // Label 26910: @2227042
      GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2227151), // Rule ID 17445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17445,
        GIR_EraseRootFromParent_Done,
      // Label 26911: @2227151
      GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2227260), // Rule ID 17448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17448,
        GIR_EraseRootFromParent_Done,
      // Label 26912: @2227260
      GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2227369), // Rule ID 17449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17449,
        GIR_EraseRootFromParent_Done,
      // Label 26913: @2227369
      GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2227478), // Rule ID 17452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17452,
        GIR_EraseRootFromParent_Done,
      // Label 26914: @2227478
      GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2227587), // Rule ID 17453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17453,
        GIR_EraseRootFromParent_Done,
      // Label 26915: @2227587
      GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2227696), // Rule ID 17456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17456,
        GIR_EraseRootFromParent_Done,
      // Label 26916: @2227696
      GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2227805), // Rule ID 17457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17457,
        GIR_EraseRootFromParent_Done,
      // Label 26917: @2227805
      GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2227914), // Rule ID 17460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17460,
        GIR_EraseRootFromParent_Done,
      // Label 26918: @2227914
      GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2228023), // Rule ID 17461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17461,
        GIR_EraseRootFromParent_Done,
      // Label 26919: @2228023
      GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2228132), // Rule ID 17464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17464,
        GIR_EraseRootFromParent_Done,
      // Label 26920: @2228132
      GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2228241), // Rule ID 17465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10809:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17465,
        GIR_EraseRootFromParent_Done,
      // Label 26921: @2228241
      GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2228350), // Rule ID 17468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17468,
        GIR_EraseRootFromParent_Done,
      // Label 26922: @2228350
      GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2228459), // Rule ID 17469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10809:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17469,
        GIR_EraseRootFromParent_Done,
      // Label 26923: @2228459
      GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2228568), // Rule ID 17472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17472,
        GIR_EraseRootFromParent_Done,
      // Label 26924: @2228568
      GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2228677), // Rule ID 17473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10809:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17473,
        GIR_EraseRootFromParent_Done,
      // Label 26925: @2228677
      GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2228786), // Rule ID 17476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17476,
        GIR_EraseRootFromParent_Done,
      // Label 26926: @2228786
      GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2228895), // Rule ID 17477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17477,
        GIR_EraseRootFromParent_Done,
      // Label 26927: @2228895
      GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2229004), // Rule ID 17480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17480,
        GIR_EraseRootFromParent_Done,
      // Label 26928: @2229004
      GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2229113), // Rule ID 17481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17481,
        GIR_EraseRootFromParent_Done,
      // Label 26929: @2229113
      GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2229222), // Rule ID 17484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17484,
        GIR_EraseRootFromParent_Done,
      // Label 26930: @2229222
      GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2229331), // Rule ID 17485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17485,
        GIR_EraseRootFromParent_Done,
      // Label 26931: @2229331
      GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2229440), // Rule ID 17488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17488,
        GIR_EraseRootFromParent_Done,
      // Label 26932: @2229440
      GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2229549), // Rule ID 17489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10857:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17489,
        GIR_EraseRootFromParent_Done,
      // Label 26933: @2229549
      GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2229658), // Rule ID 17492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17492,
        GIR_EraseRootFromParent_Done,
      // Label 26934: @2229658
      GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2229767), // Rule ID 17493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10857:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17493,
        GIR_EraseRootFromParent_Done,
      // Label 26935: @2229767
      GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2229876), // Rule ID 17496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17496,
        GIR_EraseRootFromParent_Done,
      // Label 26936: @2229876
      GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2229985), // Rule ID 17497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10857:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17497,
        GIR_EraseRootFromParent_Done,
      // Label 26937: @2229985
      GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2230094), // Rule ID 17500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17500,
        GIR_EraseRootFromParent_Done,
      // Label 26938: @2230094
      GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2230203), // Rule ID 17501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17501,
        GIR_EraseRootFromParent_Done,
      // Label 26939: @2230203
      GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2230312), // Rule ID 17504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17504,
        GIR_EraseRootFromParent_Done,
      // Label 26940: @2230312
      GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2230421), // Rule ID 17505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17505,
        GIR_EraseRootFromParent_Done,
      // Label 26941: @2230421
      GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2230530), // Rule ID 17508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17508,
        GIR_EraseRootFromParent_Done,
      // Label 26942: @2230530
      GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2230639), // Rule ID 17509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17509,
        GIR_EraseRootFromParent_Done,
      // Label 26943: @2230639
      GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2230748), // Rule ID 17512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17512,
        GIR_EraseRootFromParent_Done,
      // Label 26944: @2230748
      GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2230857), // Rule ID 17513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17513,
        GIR_EraseRootFromParent_Done,
      // Label 26945: @2230857
      GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2230966), // Rule ID 17516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17516,
        GIR_EraseRootFromParent_Done,
      // Label 26946: @2230966
      GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2231075), // Rule ID 17517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17517,
        GIR_EraseRootFromParent_Done,
      // Label 26947: @2231075
      GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2231184), // Rule ID 17520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17520,
        GIR_EraseRootFromParent_Done,
      // Label 26948: @2231184
      GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2231293), // Rule ID 17521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17521,
        GIR_EraseRootFromParent_Done,
      // Label 26949: @2231293
      GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2231402), // Rule ID 17524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17524,
        GIR_EraseRootFromParent_Done,
      // Label 26950: @2231402
      GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2231511), // Rule ID 17525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10857:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17525,
        GIR_EraseRootFromParent_Done,
      // Label 26951: @2231511
      GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2231620), // Rule ID 17528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17528,
        GIR_EraseRootFromParent_Done,
      // Label 26952: @2231620
      GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2231729), // Rule ID 17529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10857:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17529,
        GIR_EraseRootFromParent_Done,
      // Label 26953: @2231729
      GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2231838), // Rule ID 17532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17532,
        GIR_EraseRootFromParent_Done,
      // Label 26954: @2231838
      GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2231947), // Rule ID 17533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10857:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17533,
        GIR_EraseRootFromParent_Done,
      // Label 26955: @2231947
      GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2232056), // Rule ID 17536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10913:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17536,
        GIR_EraseRootFromParent_Done,
      // Label 26956: @2232056
      GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2232165), // Rule ID 17537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10913:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17537,
        GIR_EraseRootFromParent_Done,
      // Label 26957: @2232165
      GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2232274), // Rule ID 17540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10913:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17540,
        GIR_EraseRootFromParent_Done,
      // Label 26958: @2232274
      GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2232383), // Rule ID 17541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10913:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17541,
        GIR_EraseRootFromParent_Done,
      // Label 26959: @2232383
      GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2232492), // Rule ID 17544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10913:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17544,
        GIR_EraseRootFromParent_Done,
      // Label 26960: @2232492
      GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2232601), // Rule ID 17545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10913:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17545,
        GIR_EraseRootFromParent_Done,
      // Label 26961: @2232601
      GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2232710), // Rule ID 17548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10913:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17548,
        GIR_EraseRootFromParent_Done,
      // Label 26962: @2232710
      GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2232819), // Rule ID 17549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10913:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17549,
        GIR_EraseRootFromParent_Done,
      // Label 26963: @2232819
      GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2232928), // Rule ID 17552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10913:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17552,
        GIR_EraseRootFromParent_Done,
      // Label 26964: @2232928
      GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2233037), // Rule ID 17553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10913:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17553,
        GIR_EraseRootFromParent_Done,
      // Label 26965: @2233037
      GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2233146), // Rule ID 17556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10913:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17556,
        GIR_EraseRootFromParent_Done,
      // Label 26966: @2233146
      GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2233255), // Rule ID 17557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10913:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17557,
        GIR_EraseRootFromParent_Done,
      // Label 26967: @2233255
      GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2233364), // Rule ID 17560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10913:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17560,
        GIR_EraseRootFromParent_Done,
      // Label 26968: @2233364
      GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2233473), // Rule ID 17561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10913:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17561,
        GIR_EraseRootFromParent_Done,
      // Label 26969: @2233473
      GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2233582), // Rule ID 17564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10913:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17564,
        GIR_EraseRootFromParent_Done,
      // Label 26970: @2233582
      GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2233691), // Rule ID 17565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10913:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17565,
        GIR_EraseRootFromParent_Done,
      // Label 26971: @2233691
      GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2233800), // Rule ID 17568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10913:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17568,
        GIR_EraseRootFromParent_Done,
      // Label 26972: @2233800
      GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2233909), // Rule ID 17569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10913:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17569,
        GIR_EraseRootFromParent_Done,
      // Label 26973: @2233909
      GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2234018), // Rule ID 17572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10913:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17572,
        GIR_EraseRootFromParent_Done,
      // Label 26974: @2234018
      GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2234127), // Rule ID 17573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10913:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17573,
        GIR_EraseRootFromParent_Done,
      // Label 26975: @2234127
      GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2234236), // Rule ID 17576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10913:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17576,
        GIR_EraseRootFromParent_Done,
      // Label 26976: @2234236
      GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2234345), // Rule ID 17577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10913:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17577,
        GIR_EraseRootFromParent_Done,
      // Label 26977: @2234345
      GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2234454), // Rule ID 17580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10913:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17580,
        GIR_EraseRootFromParent_Done,
      // Label 26978: @2234454
      GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2234563), // Rule ID 17581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10913:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17581,
        GIR_EraseRootFromParent_Done,
      // Label 26979: @2234563
      GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2234672), // Rule ID 17584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10913:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17584,
        GIR_EraseRootFromParent_Done,
      // Label 26980: @2234672
      GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2234781), // Rule ID 17585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10913:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17585,
        GIR_EraseRootFromParent_Done,
      // Label 26981: @2234781
      GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2234890), // Rule ID 17588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10913:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17588,
        GIR_EraseRootFromParent_Done,
      // Label 26982: @2234890
      GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2234999), // Rule ID 17589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10913:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17589,
        GIR_EraseRootFromParent_Done,
      // Label 26983: @2234999
      GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2235108), // Rule ID 17592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10913:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17592,
        GIR_EraseRootFromParent_Done,
      // Label 26984: @2235108
      GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2235217), // Rule ID 17593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10913:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17593,
        GIR_EraseRootFromParent_Done,
      // Label 26985: @2235217
      GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2235326), // Rule ID 17596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10913:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17596,
        GIR_EraseRootFromParent_Done,
      // Label 26986: @2235326
      GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2235435), // Rule ID 17597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10913:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17597,
        GIR_EraseRootFromParent_Done,
      // Label 26987: @2235435
      GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2235544), // Rule ID 17600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10913:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17600,
        GIR_EraseRootFromParent_Done,
      // Label 26988: @2235544
      GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2235653), // Rule ID 17601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10913:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17601,
        GIR_EraseRootFromParent_Done,
      // Label 26989: @2235653
      GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2235762), // Rule ID 17604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10913:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17604,
        GIR_EraseRootFromParent_Done,
      // Label 26990: @2235762
      GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2235871), // Rule ID 17605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10913:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17605,
        GIR_EraseRootFromParent_Done,
      // Label 26991: @2235871
      GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2235980), // Rule ID 17608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17608,
        GIR_EraseRootFromParent_Done,
      // Label 26992: @2235980
      GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2236089), // Rule ID 17609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17609,
        GIR_EraseRootFromParent_Done,
      // Label 26993: @2236089
      GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2236198), // Rule ID 17612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17612,
        GIR_EraseRootFromParent_Done,
      // Label 26994: @2236198
      GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2236307), // Rule ID 17613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17613,
        GIR_EraseRootFromParent_Done,
      // Label 26995: @2236307
      GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2236416), // Rule ID 17616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17616,
        GIR_EraseRootFromParent_Done,
      // Label 26996: @2236416
      GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2236525), // Rule ID 17617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17617,
        GIR_EraseRootFromParent_Done,
      // Label 26997: @2236525
      GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2236634), // Rule ID 17620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10813:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17620,
        GIR_EraseRootFromParent_Done,
      // Label 26998: @2236634
      GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2236743), // Rule ID 17621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10813:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17621,
        GIR_EraseRootFromParent_Done,
      // Label 26999: @2236743
      GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2236852), // Rule ID 17624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17624,
        GIR_EraseRootFromParent_Done,
      // Label 27000: @2236852
      GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2236961), // Rule ID 17625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17625,
        GIR_EraseRootFromParent_Done,
      // Label 27001: @2236961
      GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2237070), // Rule ID 17628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17628,
        GIR_EraseRootFromParent_Done,
      // Label 27002: @2237070
      GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2237179), // Rule ID 17629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17629,
        GIR_EraseRootFromParent_Done,
      // Label 27003: @2237179
      GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2237288), // Rule ID 17632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17632,
        GIR_EraseRootFromParent_Done,
      // Label 27004: @2237288
      GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2237397), // Rule ID 17633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17633,
        GIR_EraseRootFromParent_Done,
      // Label 27005: @2237397
      GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2237506), // Rule ID 17636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17636,
        GIR_EraseRootFromParent_Done,
      // Label 27006: @2237506
      GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2237615), // Rule ID 17637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17637,
        GIR_EraseRootFromParent_Done,
      // Label 27007: @2237615
      GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2237724), // Rule ID 17640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17640,
        GIR_EraseRootFromParent_Done,
      // Label 27008: @2237724
      GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2237833), // Rule ID 17641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17641,
        GIR_EraseRootFromParent_Done,
      // Label 27009: @2237833
      GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2237942), // Rule ID 17644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17644,
        GIR_EraseRootFromParent_Done,
      // Label 27010: @2237942
      GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2238051), // Rule ID 17645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17645,
        GIR_EraseRootFromParent_Done,
      // Label 27011: @2238051
      GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2238160), // Rule ID 17648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17648,
        GIR_EraseRootFromParent_Done,
      // Label 27012: @2238160
      GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2238269), // Rule ID 17649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17649,
        GIR_EraseRootFromParent_Done,
      // Label 27013: @2238269
      GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2238378), // Rule ID 17652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17652,
        GIR_EraseRootFromParent_Done,
      // Label 27014: @2238378
      GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2238487), // Rule ID 17653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17653,
        GIR_EraseRootFromParent_Done,
      // Label 27015: @2238487
      GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2238596), // Rule ID 17656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17656,
        GIR_EraseRootFromParent_Done,
      // Label 27016: @2238596
      GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2238705), // Rule ID 17657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17657,
        GIR_EraseRootFromParent_Done,
      // Label 27017: @2238705
      GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2238814), // Rule ID 17660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17660,
        GIR_EraseRootFromParent_Done,
      // Label 27018: @2238814
      GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2238923), // Rule ID 17661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17661,
        GIR_EraseRootFromParent_Done,
      // Label 27019: @2238923
      GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2239032), // Rule ID 17664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17664,
        GIR_EraseRootFromParent_Done,
      // Label 27020: @2239032
      GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2239141), // Rule ID 17665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17665,
        GIR_EraseRootFromParent_Done,
      // Label 27021: @2239141
      GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2239250), // Rule ID 17668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17668,
        GIR_EraseRootFromParent_Done,
      // Label 27022: @2239250
      GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2239359), // Rule ID 17669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17669,
        GIR_EraseRootFromParent_Done,
      // Label 27023: @2239359
      GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2239468), // Rule ID 17672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17672,
        GIR_EraseRootFromParent_Done,
      // Label 27024: @2239468
      GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2239577), // Rule ID 17673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17673,
        GIR_EraseRootFromParent_Done,
      // Label 27025: @2239577
      GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2239686), // Rule ID 17676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17676,
        GIR_EraseRootFromParent_Done,
      // Label 27026: @2239686
      GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2239795), // Rule ID 17677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10813:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17677,
        GIR_EraseRootFromParent_Done,
      // Label 27027: @2239795
      GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2239904), // Rule ID 17680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10813:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17680,
        GIR_EraseRootFromParent_Done,
      // Label 27028: @2239904
      GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2240013), // Rule ID 17681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10813:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17681,
        GIR_EraseRootFromParent_Done,
      // Label 27029: @2240013
      GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2240122), // Rule ID 17684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17684,
        GIR_EraseRootFromParent_Done,
      // Label 27030: @2240122
      GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2240231), // Rule ID 17685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10813:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17685,
        GIR_EraseRootFromParent_Done,
      // Label 27031: @2240231
      GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2240340), // Rule ID 17688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17688,
        GIR_EraseRootFromParent_Done,
      // Label 27032: @2240340
      GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2240449), // Rule ID 17689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17689,
        GIR_EraseRootFromParent_Done,
      // Label 27033: @2240449
      GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2240558), // Rule ID 17692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17692,
        GIR_EraseRootFromParent_Done,
      // Label 27034: @2240558
      GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2240667), // Rule ID 17693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17693,
        GIR_EraseRootFromParent_Done,
      // Label 27035: @2240667
      GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2240776), // Rule ID 17696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17696,
        GIR_EraseRootFromParent_Done,
      // Label 27036: @2240776
      GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2240885), // Rule ID 17697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17697,
        GIR_EraseRootFromParent_Done,
      // Label 27037: @2240885
      GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2240994), // Rule ID 17700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17700,
        GIR_EraseRootFromParent_Done,
      // Label 27038: @2240994
      GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2241103), // Rule ID 17701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17701,
        GIR_EraseRootFromParent_Done,
      // Label 27039: @2241103
      GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2241212), // Rule ID 17704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17704,
        GIR_EraseRootFromParent_Done,
      // Label 27040: @2241212
      GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2241321), // Rule ID 17705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17705,
        GIR_EraseRootFromParent_Done,
      // Label 27041: @2241321
      GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2241430), // Rule ID 17708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17708,
        GIR_EraseRootFromParent_Done,
      // Label 27042: @2241430
      GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2241539), // Rule ID 17709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17709,
        GIR_EraseRootFromParent_Done,
      // Label 27043: @2241539
      GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2241648), // Rule ID 17712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17712,
        GIR_EraseRootFromParent_Done,
      // Label 27044: @2241648
      GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2241757), // Rule ID 17713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10813:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17713,
        GIR_EraseRootFromParent_Done,
      // Label 27045: @2241757
      GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2241866), // Rule ID 17716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17716,
        GIR_EraseRootFromParent_Done,
      // Label 27046: @2241866
      GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2241975), // Rule ID 17717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10813:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17717,
        GIR_EraseRootFromParent_Done,
      // Label 27047: @2241975
      GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2242084), // Rule ID 17720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17720,
        GIR_EraseRootFromParent_Done,
      // Label 27048: @2242084
      GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2242193), // Rule ID 17721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10813:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17721,
        GIR_EraseRootFromParent_Done,
      // Label 27049: @2242193
      GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2242302), // Rule ID 17724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17724,
        GIR_EraseRootFromParent_Done,
      // Label 27050: @2242302
      GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2242411), // Rule ID 17725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17725,
        GIR_EraseRootFromParent_Done,
      // Label 27051: @2242411
      GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2242520), // Rule ID 17728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17728,
        GIR_EraseRootFromParent_Done,
      // Label 27052: @2242520
      GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2242629), // Rule ID 17729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17729,
        GIR_EraseRootFromParent_Done,
      // Label 27053: @2242629
      GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2242738), // Rule ID 17732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17732,
        GIR_EraseRootFromParent_Done,
      // Label 27054: @2242738
      GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2242847), // Rule ID 17733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17733,
        GIR_EraseRootFromParent_Done,
      // Label 27055: @2242847
      GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2242956), // Rule ID 17736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17736,
        GIR_EraseRootFromParent_Done,
      // Label 27056: @2242956
      GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2243065), // Rule ID 17737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17737,
        GIR_EraseRootFromParent_Done,
      // Label 27057: @2243065
      GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2243174), // Rule ID 17740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17740,
        GIR_EraseRootFromParent_Done,
      // Label 27058: @2243174
      GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2243283), // Rule ID 17741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17741,
        GIR_EraseRootFromParent_Done,
      // Label 27059: @2243283
      GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2243392), // Rule ID 17744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17744,
        GIR_EraseRootFromParent_Done,
      // Label 27060: @2243392
      GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2243501), // Rule ID 17745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17745,
        GIR_EraseRootFromParent_Done,
      // Label 27061: @2243501
      GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2243610), // Rule ID 17748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17748,
        GIR_EraseRootFromParent_Done,
      // Label 27062: @2243610
      GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2243719), // Rule ID 17749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17749,
        GIR_EraseRootFromParent_Done,
      // Label 27063: @2243719
      GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2243828), // Rule ID 17752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17752,
        GIR_EraseRootFromParent_Done,
      // Label 27064: @2243828
      GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2243937), // Rule ID 17753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17753,
        GIR_EraseRootFromParent_Done,
      // Label 27065: @2243937
      GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2244046), // Rule ID 17756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17756,
        GIR_EraseRootFromParent_Done,
      // Label 27066: @2244046
      GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2244155), // Rule ID 17757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17757,
        GIR_EraseRootFromParent_Done,
      // Label 27067: @2244155
      GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2244264), // Rule ID 17760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17760,
        GIR_EraseRootFromParent_Done,
      // Label 27068: @2244264
      GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2244373), // Rule ID 17761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17761,
        GIR_EraseRootFromParent_Done,
      // Label 27069: @2244373
      GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2244482), // Rule ID 17764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17764,
        GIR_EraseRootFromParent_Done,
      // Label 27070: @2244482
      GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2244591), // Rule ID 17765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17765,
        GIR_EraseRootFromParent_Done,
      // Label 27071: @2244591
      GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2244700), // Rule ID 17768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17768,
        GIR_EraseRootFromParent_Done,
      // Label 27072: @2244700
      GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2244809), // Rule ID 17769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17769,
        GIR_EraseRootFromParent_Done,
      // Label 27073: @2244809
      GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2244918), // Rule ID 17772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17772,
        GIR_EraseRootFromParent_Done,
      // Label 27074: @2244918
      GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2245027), // Rule ID 17773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17773,
        GIR_EraseRootFromParent_Done,
      // Label 27075: @2245027
      GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2245136), // Rule ID 17776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17776,
        GIR_EraseRootFromParent_Done,
      // Label 27076: @2245136
      GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2245245), // Rule ID 17777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17777,
        GIR_EraseRootFromParent_Done,
      // Label 27077: @2245245
      GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2245354), // Rule ID 17780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17780,
        GIR_EraseRootFromParent_Done,
      // Label 27078: @2245354
      GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2245463), // Rule ID 17781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17781,
        GIR_EraseRootFromParent_Done,
      // Label 27079: @2245463
      GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2245572), // Rule ID 17784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17784,
        GIR_EraseRootFromParent_Done,
      // Label 27080: @2245572
      GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2245681), // Rule ID 17785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17785,
        GIR_EraseRootFromParent_Done,
      // Label 27081: @2245681
      GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2245790), // Rule ID 17788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17788,
        GIR_EraseRootFromParent_Done,
      // Label 27082: @2245790
      GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2245899), // Rule ID 17789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17789,
        GIR_EraseRootFromParent_Done,
      // Label 27083: @2245899
      GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2246008), // Rule ID 17792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17792,
        GIR_EraseRootFromParent_Done,
      // Label 27084: @2246008
      GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2246117), // Rule ID 17793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17793,
        GIR_EraseRootFromParent_Done,
      // Label 27085: @2246117
      GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2246226), // Rule ID 17796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17796,
        GIR_EraseRootFromParent_Done,
      // Label 27086: @2246226
      GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2246335), // Rule ID 17797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10849:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17797,
        GIR_EraseRootFromParent_Done,
      // Label 27087: @2246335
      GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2246444), // Rule ID 17800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17800,
        GIR_EraseRootFromParent_Done,
      // Label 27088: @2246444
      GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2246553), // Rule ID 17801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10849:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17801,
        GIR_EraseRootFromParent_Done,
      // Label 27089: @2246553
      GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2246662), // Rule ID 17804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17804,
        GIR_EraseRootFromParent_Done,
      // Label 27090: @2246662
      GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2246771), // Rule ID 17805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10849:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17805,
        GIR_EraseRootFromParent_Done,
      // Label 27091: @2246771
      GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2246880), // Rule ID 17808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17808,
        GIR_EraseRootFromParent_Done,
      // Label 27092: @2246880
      GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2246989), // Rule ID 17809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17809,
        GIR_EraseRootFromParent_Done,
      // Label 27093: @2246989
      GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2247098), // Rule ID 17812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17812,
        GIR_EraseRootFromParent_Done,
      // Label 27094: @2247098
      GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2247207), // Rule ID 17813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17813,
        GIR_EraseRootFromParent_Done,
      // Label 27095: @2247207
      GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2247316), // Rule ID 17816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17816,
        GIR_EraseRootFromParent_Done,
      // Label 27096: @2247316
      GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2247425), // Rule ID 17817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17817,
        GIR_EraseRootFromParent_Done,
      // Label 27097: @2247425
      GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2247534), // Rule ID 17820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17820,
        GIR_EraseRootFromParent_Done,
      // Label 27098: @2247534
      GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2247643), // Rule ID 17821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17821,
        GIR_EraseRootFromParent_Done,
      // Label 27099: @2247643
      GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2247752), // Rule ID 17824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17824,
        GIR_EraseRootFromParent_Done,
      // Label 27100: @2247752
      GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2247861), // Rule ID 17825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17825,
        GIR_EraseRootFromParent_Done,
      // Label 27101: @2247861
      GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2247970), // Rule ID 17828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17828,
        GIR_EraseRootFromParent_Done,
      // Label 27102: @2247970
      GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2248079), // Rule ID 17829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17829,
        GIR_EraseRootFromParent_Done,
      // Label 27103: @2248079
      GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2248188), // Rule ID 17832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17832,
        GIR_EraseRootFromParent_Done,
      // Label 27104: @2248188
      GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2248297), // Rule ID 17833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10849:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17833,
        GIR_EraseRootFromParent_Done,
      // Label 27105: @2248297
      GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2248406), // Rule ID 17836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17836,
        GIR_EraseRootFromParent_Done,
      // Label 27106: @2248406
      GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2248515), // Rule ID 17837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10849:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17837,
        GIR_EraseRootFromParent_Done,
      // Label 27107: @2248515
      GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2248624), // Rule ID 17840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17840,
        GIR_EraseRootFromParent_Done,
      // Label 27108: @2248624
      GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2248733), // Rule ID 17841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10849:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17841,
        GIR_EraseRootFromParent_Done,
      // Label 27109: @2248733
      GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2248842), // Rule ID 17844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17844,
        GIR_EraseRootFromParent_Done,
      // Label 27110: @2248842
      GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2248951), // Rule ID 17845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17845,
        GIR_EraseRootFromParent_Done,
      // Label 27111: @2248951
      GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2249060), // Rule ID 17848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17848,
        GIR_EraseRootFromParent_Done,
      // Label 27112: @2249060
      GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2249169), // Rule ID 17849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17849,
        GIR_EraseRootFromParent_Done,
      // Label 27113: @2249169
      GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2249278), // Rule ID 17852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17852,
        GIR_EraseRootFromParent_Done,
      // Label 27114: @2249278
      GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2249387), // Rule ID 17853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17853,
        GIR_EraseRootFromParent_Done,
      // Label 27115: @2249387
      GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2249496), // Rule ID 17856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17856,
        GIR_EraseRootFromParent_Done,
      // Label 27116: @2249496
      GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2249605), // Rule ID 17857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17857,
        GIR_EraseRootFromParent_Done,
      // Label 27117: @2249605
      GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2249714), // Rule ID 17860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17860,
        GIR_EraseRootFromParent_Done,
      // Label 27118: @2249714
      GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2249823), // Rule ID 17861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17861,
        GIR_EraseRootFromParent_Done,
      // Label 27119: @2249823
      GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2249932), // Rule ID 17864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17864,
        GIR_EraseRootFromParent_Done,
      // Label 27120: @2249932
      GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2250041), // Rule ID 17865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17865,
        GIR_EraseRootFromParent_Done,
      // Label 27121: @2250041
      GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2250150), // Rule ID 17868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17868,
        GIR_EraseRootFromParent_Done,
      // Label 27122: @2250150
      GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2250259), // Rule ID 17869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17869,
        GIR_EraseRootFromParent_Done,
      // Label 27123: @2250259
      GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2250368), // Rule ID 17872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17872,
        GIR_EraseRootFromParent_Done,
      // Label 27124: @2250368
      GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2250477), // Rule ID 17873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17873,
        GIR_EraseRootFromParent_Done,
      // Label 27125: @2250477
      GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2250586), // Rule ID 17876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17876,
        GIR_EraseRootFromParent_Done,
      // Label 27126: @2250586
      GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2250695), // Rule ID 17877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17877,
        GIR_EraseRootFromParent_Done,
      // Label 27127: @2250695
      GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2250804), // Rule ID 17880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17880,
        GIR_EraseRootFromParent_Done,
      // Label 27128: @2250804
      GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2250913), // Rule ID 17881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17881,
        GIR_EraseRootFromParent_Done,
      // Label 27129: @2250913
      GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2251022), // Rule ID 17884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17884,
        GIR_EraseRootFromParent_Done,
      // Label 27130: @2251022
      GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2251131), // Rule ID 17885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17885,
        GIR_EraseRootFromParent_Done,
      // Label 27131: @2251131
      GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2251240), // Rule ID 17888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17888,
        GIR_EraseRootFromParent_Done,
      // Label 27132: @2251240
      GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2251349), // Rule ID 17889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17889,
        GIR_EraseRootFromParent_Done,
      // Label 27133: @2251349
      GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2251458), // Rule ID 17892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17892,
        GIR_EraseRootFromParent_Done,
      // Label 27134: @2251458
      GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2251567), // Rule ID 17893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17893,
        GIR_EraseRootFromParent_Done,
      // Label 27135: @2251567
      GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2251676), // Rule ID 17896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17896,
        GIR_EraseRootFromParent_Done,
      // Label 27136: @2251676
      GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2251785), // Rule ID 17897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17897,
        GIR_EraseRootFromParent_Done,
      // Label 27137: @2251785
      GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2251894), // Rule ID 17900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17900,
        GIR_EraseRootFromParent_Done,
      // Label 27138: @2251894
      GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2252003), // Rule ID 17901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17901,
        GIR_EraseRootFromParent_Done,
      // Label 27139: @2252003
      GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2252112), // Rule ID 17904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17904,
        GIR_EraseRootFromParent_Done,
      // Label 27140: @2252112
      GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2252221), // Rule ID 17905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17905,
        GIR_EraseRootFromParent_Done,
      // Label 27141: @2252221
      GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2252330), // Rule ID 17908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17908,
        GIR_EraseRootFromParent_Done,
      // Label 27142: @2252330
      GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2252439), // Rule ID 17909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17909,
        GIR_EraseRootFromParent_Done,
      // Label 27143: @2252439
      GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2252548), // Rule ID 17912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17912,
        GIR_EraseRootFromParent_Done,
      // Label 27144: @2252548
      GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2252657), // Rule ID 17913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17913,
        GIR_EraseRootFromParent_Done,
      // Label 27145: @2252657
      GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2252766), // Rule ID 17916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17916,
        GIR_EraseRootFromParent_Done,
      // Label 27146: @2252766
      GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2252875), // Rule ID 17917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10822:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17917,
        GIR_EraseRootFromParent_Done,
      // Label 27147: @2252875
      GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2252984), // Rule ID 17920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17920,
        GIR_EraseRootFromParent_Done,
      // Label 27148: @2252984
      GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2253093), // Rule ID 17921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10822:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17921,
        GIR_EraseRootFromParent_Done,
      // Label 27149: @2253093
      GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2253202), // Rule ID 17924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17924,
        GIR_EraseRootFromParent_Done,
      // Label 27150: @2253202
      GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2253311), // Rule ID 17925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10822:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17925,
        GIR_EraseRootFromParent_Done,
      // Label 27151: @2253311
      GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2253420), // Rule ID 17928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17928,
        GIR_EraseRootFromParent_Done,
      // Label 27152: @2253420
      GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2253529), // Rule ID 17929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17929,
        GIR_EraseRootFromParent_Done,
      // Label 27153: @2253529
      GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2253638), // Rule ID 17932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17932,
        GIR_EraseRootFromParent_Done,
      // Label 27154: @2253638
      GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2253747), // Rule ID 17933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17933,
        GIR_EraseRootFromParent_Done,
      // Label 27155: @2253747
      GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2253856), // Rule ID 17936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17936,
        GIR_EraseRootFromParent_Done,
      // Label 27156: @2253856
      GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2253965), // Rule ID 17937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17937,
        GIR_EraseRootFromParent_Done,
      // Label 27157: @2253965
      GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2254074), // Rule ID 17940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17940,
        GIR_EraseRootFromParent_Done,
      // Label 27158: @2254074
      GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2254183), // Rule ID 17941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17941,
        GIR_EraseRootFromParent_Done,
      // Label 27159: @2254183
      GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2254292), // Rule ID 17944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17944,
        GIR_EraseRootFromParent_Done,
      // Label 27160: @2254292
      GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2254401), // Rule ID 17945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17945,
        GIR_EraseRootFromParent_Done,
      // Label 27161: @2254401
      GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2254510), // Rule ID 17948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17948,
        GIR_EraseRootFromParent_Done,
      // Label 27162: @2254510
      GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2254619), // Rule ID 17949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17949,
        GIR_EraseRootFromParent_Done,
      // Label 27163: @2254619
      GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2254728), // Rule ID 17952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17952,
        GIR_EraseRootFromParent_Done,
      // Label 27164: @2254728
      GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2254837), // Rule ID 17953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10822:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17953,
        GIR_EraseRootFromParent_Done,
      // Label 27165: @2254837
      GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2254946), // Rule ID 17956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17956,
        GIR_EraseRootFromParent_Done,
      // Label 27166: @2254946
      GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2255055), // Rule ID 17957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10822:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17957,
        GIR_EraseRootFromParent_Done,
      // Label 27167: @2255055
      GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2255164), // Rule ID 17960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17960,
        GIR_EraseRootFromParent_Done,
      // Label 27168: @2255164
      GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2255273), // Rule ID 17961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10822:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17961,
        GIR_EraseRootFromParent_Done,
      // Label 27169: @2255273
      GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2255382), // Rule ID 17964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17964,
        GIR_EraseRootFromParent_Done,
      // Label 27170: @2255382
      GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2255491), // Rule ID 17965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17965,
        GIR_EraseRootFromParent_Done,
      // Label 27171: @2255491
      GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2255600), // Rule ID 17968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17968,
        GIR_EraseRootFromParent_Done,
      // Label 27172: @2255600
      GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2255709), // Rule ID 17969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17969,
        GIR_EraseRootFromParent_Done,
      // Label 27173: @2255709
      GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2255818), // Rule ID 17972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17972,
        GIR_EraseRootFromParent_Done,
      // Label 27174: @2255818
      GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2255927), // Rule ID 17973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17973,
        GIR_EraseRootFromParent_Done,
      // Label 27175: @2255927
      GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2256036), // Rule ID 17976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17976,
        GIR_EraseRootFromParent_Done,
      // Label 27176: @2256036
      GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2256145), // Rule ID 17977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17977,
        GIR_EraseRootFromParent_Done,
      // Label 27177: @2256145
      GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2256254), // Rule ID 17980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17980,
        GIR_EraseRootFromParent_Done,
      // Label 27178: @2256254
      GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2256363), // Rule ID 17981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17981,
        GIR_EraseRootFromParent_Done,
      // Label 27179: @2256363
      GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2256472), // Rule ID 17984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17984,
        GIR_EraseRootFromParent_Done,
      // Label 27180: @2256472
      GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2256581), // Rule ID 17985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17985,
        GIR_EraseRootFromParent_Done,
      // Label 27181: @2256581
      GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2256690), // Rule ID 17988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17988,
        GIR_EraseRootFromParent_Done,
      // Label 27182: @2256690
      GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2256799), // Rule ID 17989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17989,
        GIR_EraseRootFromParent_Done,
      // Label 27183: @2256799
      GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2256908), // Rule ID 17992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17992,
        GIR_EraseRootFromParent_Done,
      // Label 27184: @2256908
      GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2257017), // Rule ID 17993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17993,
        GIR_EraseRootFromParent_Done,
      // Label 27185: @2257017
      GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2257126), // Rule ID 17996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17996,
        GIR_EraseRootFromParent_Done,
      // Label 27186: @2257126
      GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2257235), // Rule ID 17997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17997,
        GIR_EraseRootFromParent_Done,
      // Label 27187: @2257235
      GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2257344), // Rule ID 18000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18000,
        GIR_EraseRootFromParent_Done,
      // Label 27188: @2257344
      GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2257453), // Rule ID 18001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18001,
        GIR_EraseRootFromParent_Done,
      // Label 27189: @2257453
      GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2257562), // Rule ID 18004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18004,
        GIR_EraseRootFromParent_Done,
      // Label 27190: @2257562
      GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2257671), // Rule ID 18005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18005,
        GIR_EraseRootFromParent_Done,
      // Label 27191: @2257671
      GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2257780), // Rule ID 18008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18008,
        GIR_EraseRootFromParent_Done,
      // Label 27192: @2257780
      GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2257889), // Rule ID 18009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18009,
        GIR_EraseRootFromParent_Done,
      // Label 27193: @2257889
      GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2257998), // Rule ID 18012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18012,
        GIR_EraseRootFromParent_Done,
      // Label 27194: @2257998
      GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2258107), // Rule ID 18013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18013,
        GIR_EraseRootFromParent_Done,
      // Label 27195: @2258107
      GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2258216), // Rule ID 18016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18016,
        GIR_EraseRootFromParent_Done,
      // Label 27196: @2258216
      GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2258325), // Rule ID 18017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18017,
        GIR_EraseRootFromParent_Done,
      // Label 27197: @2258325
      GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2258434), // Rule ID 18020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18020,
        GIR_EraseRootFromParent_Done,
      // Label 27198: @2258434
      GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2258543), // Rule ID 18021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18021,
        GIR_EraseRootFromParent_Done,
      // Label 27199: @2258543
      GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2258652), // Rule ID 18024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18024,
        GIR_EraseRootFromParent_Done,
      // Label 27200: @2258652
      GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2258761), // Rule ID 18025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18025,
        GIR_EraseRootFromParent_Done,
      // Label 27201: @2258761
      GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2258870), // Rule ID 18028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18028,
        GIR_EraseRootFromParent_Done,
      // Label 27202: @2258870
      GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2258979), // Rule ID 18029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18029,
        GIR_EraseRootFromParent_Done,
      // Label 27203: @2258979
      GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2259088), // Rule ID 18032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18032,
        GIR_EraseRootFromParent_Done,
      // Label 27204: @2259088
      GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2259197), // Rule ID 18033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18033,
        GIR_EraseRootFromParent_Done,
      // Label 27205: @2259197
      GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2259306), // Rule ID 18036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18036,
        GIR_EraseRootFromParent_Done,
      // Label 27206: @2259306
      GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2259415), // Rule ID 18037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10853:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18037,
        GIR_EraseRootFromParent_Done,
      // Label 27207: @2259415
      GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2259524), // Rule ID 18040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18040,
        GIR_EraseRootFromParent_Done,
      // Label 27208: @2259524
      GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2259633), // Rule ID 18041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10853:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18041,
        GIR_EraseRootFromParent_Done,
      // Label 27209: @2259633
      GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2259742), // Rule ID 18044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18044,
        GIR_EraseRootFromParent_Done,
      // Label 27210: @2259742
      GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2259851), // Rule ID 18045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10853:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18045,
        GIR_EraseRootFromParent_Done,
      // Label 27211: @2259851
      GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2259960), // Rule ID 18048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18048,
        GIR_EraseRootFromParent_Done,
      // Label 27212: @2259960
      GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2260069), // Rule ID 18049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18049,
        GIR_EraseRootFromParent_Done,
      // Label 27213: @2260069
      GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2260178), // Rule ID 18052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18052,
        GIR_EraseRootFromParent_Done,
      // Label 27214: @2260178
      GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2260287), // Rule ID 18053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18053,
        GIR_EraseRootFromParent_Done,
      // Label 27215: @2260287
      GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2260396), // Rule ID 18056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18056,
        GIR_EraseRootFromParent_Done,
      // Label 27216: @2260396
      GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2260505), // Rule ID 18057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18057,
        GIR_EraseRootFromParent_Done,
      // Label 27217: @2260505
      GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2260614), // Rule ID 18060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18060,
        GIR_EraseRootFromParent_Done,
      // Label 27218: @2260614
      GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2260723), // Rule ID 18061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18061,
        GIR_EraseRootFromParent_Done,
      // Label 27219: @2260723
      GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2260832), // Rule ID 18064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18064,
        GIR_EraseRootFromParent_Done,
      // Label 27220: @2260832
      GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2260941), // Rule ID 18065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18065,
        GIR_EraseRootFromParent_Done,
      // Label 27221: @2260941
      GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2261050), // Rule ID 18068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18068,
        GIR_EraseRootFromParent_Done,
      // Label 27222: @2261050
      GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2261159), // Rule ID 18069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18069,
        GIR_EraseRootFromParent_Done,
      // Label 27223: @2261159
      GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2261268), // Rule ID 18072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18072,
        GIR_EraseRootFromParent_Done,
      // Label 27224: @2261268
      GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2261377), // Rule ID 18073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10853:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18073,
        GIR_EraseRootFromParent_Done,
      // Label 27225: @2261377
      GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2261486), // Rule ID 18076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18076,
        GIR_EraseRootFromParent_Done,
      // Label 27226: @2261486
      GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2261595), // Rule ID 18077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10853:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18077,
        GIR_EraseRootFromParent_Done,
      // Label 27227: @2261595
      GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2261704), // Rule ID 18080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18080,
        GIR_EraseRootFromParent_Done,
      // Label 27228: @2261704
      GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2261813), // Rule ID 18081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10853:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18081,
        GIR_EraseRootFromParent_Done,
      // Label 27229: @2261813
      GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2261922), // Rule ID 18084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18084,
        GIR_EraseRootFromParent_Done,
      // Label 27230: @2261922
      GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2262031), // Rule ID 18085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18085,
        GIR_EraseRootFromParent_Done,
      // Label 27231: @2262031
      GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2262140), // Rule ID 18088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18088,
        GIR_EraseRootFromParent_Done,
      // Label 27232: @2262140
      GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2262249), // Rule ID 18089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18089,
        GIR_EraseRootFromParent_Done,
      // Label 27233: @2262249
      GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2262358), // Rule ID 18092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18092,
        GIR_EraseRootFromParent_Done,
      // Label 27234: @2262358
      GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2262467), // Rule ID 18093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18093,
        GIR_EraseRootFromParent_Done,
      // Label 27235: @2262467
      GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2262576), // Rule ID 18096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18096,
        GIR_EraseRootFromParent_Done,
      // Label 27236: @2262576
      GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2262685), // Rule ID 18097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18097,
        GIR_EraseRootFromParent_Done,
      // Label 27237: @2262685
      GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2262794), // Rule ID 18100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10815:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18100,
        GIR_EraseRootFromParent_Done,
      // Label 27238: @2262794
      GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2262903), // Rule ID 18101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10815:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18101,
        GIR_EraseRootFromParent_Done,
      // Label 27239: @2262903
      GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2263012), // Rule ID 18104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18104,
        GIR_EraseRootFromParent_Done,
      // Label 27240: @2263012
      GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2263121), // Rule ID 18105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18105,
        GIR_EraseRootFromParent_Done,
      // Label 27241: @2263121
      GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2263230), // Rule ID 18108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18108,
        GIR_EraseRootFromParent_Done,
      // Label 27242: @2263230
      GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2263339), // Rule ID 18109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18109,
        GIR_EraseRootFromParent_Done,
      // Label 27243: @2263339
      GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2263448), // Rule ID 18112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18112,
        GIR_EraseRootFromParent_Done,
      // Label 27244: @2263448
      GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2263557), // Rule ID 18113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18113,
        GIR_EraseRootFromParent_Done,
      // Label 27245: @2263557
      GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2263666), // Rule ID 18116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18116,
        GIR_EraseRootFromParent_Done,
      // Label 27246: @2263666
      GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2263775), // Rule ID 18117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18117,
        GIR_EraseRootFromParent_Done,
      // Label 27247: @2263775
      GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2263884), // Rule ID 18120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18120,
        GIR_EraseRootFromParent_Done,
      // Label 27248: @2263884
      GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2263993), // Rule ID 18121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18121,
        GIR_EraseRootFromParent_Done,
      // Label 27249: @2263993
      GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2264102), // Rule ID 18124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18124,
        GIR_EraseRootFromParent_Done,
      // Label 27250: @2264102
      GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2264211), // Rule ID 18125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18125,
        GIR_EraseRootFromParent_Done,
      // Label 27251: @2264211
      GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2264320), // Rule ID 18128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18128,
        GIR_EraseRootFromParent_Done,
      // Label 27252: @2264320
      GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2264429), // Rule ID 18129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18129,
        GIR_EraseRootFromParent_Done,
      // Label 27253: @2264429
      GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2264538), // Rule ID 18132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18132,
        GIR_EraseRootFromParent_Done,
      // Label 27254: @2264538
      GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2264647), // Rule ID 18133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18133,
        GIR_EraseRootFromParent_Done,
      // Label 27255: @2264647
      GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2264756), // Rule ID 18136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18136,
        GIR_EraseRootFromParent_Done,
      // Label 27256: @2264756
      GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2264865), // Rule ID 18137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18137,
        GIR_EraseRootFromParent_Done,
      // Label 27257: @2264865
      GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2264974), // Rule ID 18140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18140,
        GIR_EraseRootFromParent_Done,
      // Label 27258: @2264974
      GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2265083), // Rule ID 18141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18141,
        GIR_EraseRootFromParent_Done,
      // Label 27259: @2265083
      GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2265192), // Rule ID 18144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18144,
        GIR_EraseRootFromParent_Done,
      // Label 27260: @2265192
      GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2265301), // Rule ID 18145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18145,
        GIR_EraseRootFromParent_Done,
      // Label 27261: @2265301
      GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2265410), // Rule ID 18148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18148,
        GIR_EraseRootFromParent_Done,
      // Label 27262: @2265410
      GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2265519), // Rule ID 18149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18149,
        GIR_EraseRootFromParent_Done,
      // Label 27263: @2265519
      GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2265628), // Rule ID 18152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18152,
        GIR_EraseRootFromParent_Done,
      // Label 27264: @2265628
      GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2265737), // Rule ID 18153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18153,
        GIR_EraseRootFromParent_Done,
      // Label 27265: @2265737
      GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2265846), // Rule ID 18156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18156,
        GIR_EraseRootFromParent_Done,
      // Label 27266: @2265846
      GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2265955), // Rule ID 18157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10815:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18157,
        GIR_EraseRootFromParent_Done,
      // Label 27267: @2265955
      GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2266064), // Rule ID 18160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10815:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18160,
        GIR_EraseRootFromParent_Done,
      // Label 27268: @2266064
      GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2266173), // Rule ID 18161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10815:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18161,
        GIR_EraseRootFromParent_Done,
      // Label 27269: @2266173
      GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2266282), // Rule ID 18164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18164,
        GIR_EraseRootFromParent_Done,
      // Label 27270: @2266282
      GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2266391), // Rule ID 18165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10815:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18165,
        GIR_EraseRootFromParent_Done,
      // Label 27271: @2266391
      GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2266500), // Rule ID 18168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18168,
        GIR_EraseRootFromParent_Done,
      // Label 27272: @2266500
      GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2266609), // Rule ID 18169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18169,
        GIR_EraseRootFromParent_Done,
      // Label 27273: @2266609
      GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2266718), // Rule ID 18172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18172,
        GIR_EraseRootFromParent_Done,
      // Label 27274: @2266718
      GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2266827), // Rule ID 18173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18173,
        GIR_EraseRootFromParent_Done,
      // Label 27275: @2266827
      GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2266936), // Rule ID 18176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18176,
        GIR_EraseRootFromParent_Done,
      // Label 27276: @2266936
      GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2267045), // Rule ID 18177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18177,
        GIR_EraseRootFromParent_Done,
      // Label 27277: @2267045
      GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2267154), // Rule ID 18180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18180,
        GIR_EraseRootFromParent_Done,
      // Label 27278: @2267154
      GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2267263), // Rule ID 18181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18181,
        GIR_EraseRootFromParent_Done,
      // Label 27279: @2267263
      GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2267372), // Rule ID 18184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18184,
        GIR_EraseRootFromParent_Done,
      // Label 27280: @2267372
      GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2267481), // Rule ID 18185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18185,
        GIR_EraseRootFromParent_Done,
      // Label 27281: @2267481
      GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2267590), // Rule ID 18188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18188,
        GIR_EraseRootFromParent_Done,
      // Label 27282: @2267590
      GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2267699), // Rule ID 18189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18189,
        GIR_EraseRootFromParent_Done,
      // Label 27283: @2267699
      GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2267808), // Rule ID 18192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18192,
        GIR_EraseRootFromParent_Done,
      // Label 27284: @2267808
      GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2267917), // Rule ID 18193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10815:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18193,
        GIR_EraseRootFromParent_Done,
      // Label 27285: @2267917
      GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2268026), // Rule ID 18196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18196,
        GIR_EraseRootFromParent_Done,
      // Label 27286: @2268026
      GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2268135), // Rule ID 18197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10815:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18197,
        GIR_EraseRootFromParent_Done,
      // Label 27287: @2268135
      GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2268244), // Rule ID 18200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18200,
        GIR_EraseRootFromParent_Done,
      // Label 27288: @2268244
      GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2268353), // Rule ID 18201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10815:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18201,
        GIR_EraseRootFromParent_Done,
      // Label 27289: @2268353
      GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2268462), // Rule ID 18204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18204,
        GIR_EraseRootFromParent_Done,
      // Label 27290: @2268462
      GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2268571), // Rule ID 18205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18205,
        GIR_EraseRootFromParent_Done,
      // Label 27291: @2268571
      GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2268680), // Rule ID 18208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18208,
        GIR_EraseRootFromParent_Done,
      // Label 27292: @2268680
      GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2268789), // Rule ID 18209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18209,
        GIR_EraseRootFromParent_Done,
      // Label 27293: @2268789
      GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2268898), // Rule ID 18212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18212,
        GIR_EraseRootFromParent_Done,
      // Label 27294: @2268898
      GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2269007), // Rule ID 18213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18213,
        GIR_EraseRootFromParent_Done,
      // Label 27295: @2269007
      GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2269116), // Rule ID 18216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18216,
        GIR_EraseRootFromParent_Done,
      // Label 27296: @2269116
      GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2269225), // Rule ID 18217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18217,
        GIR_EraseRootFromParent_Done,
      // Label 27297: @2269225
      GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2269334), // Rule ID 18220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18220,
        GIR_EraseRootFromParent_Done,
      // Label 27298: @2269334
      GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2269443), // Rule ID 18221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18221,
        GIR_EraseRootFromParent_Done,
      // Label 27299: @2269443
      GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2269552), // Rule ID 18224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18224,
        GIR_EraseRootFromParent_Done,
      // Label 27300: @2269552
      GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2269661), // Rule ID 18225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18225,
        GIR_EraseRootFromParent_Done,
      // Label 27301: @2269661
      GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2269770), // Rule ID 18228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18228,
        GIR_EraseRootFromParent_Done,
      // Label 27302: @2269770
      GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2269879), // Rule ID 18229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18229,
        GIR_EraseRootFromParent_Done,
      // Label 27303: @2269879
      GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2269988), // Rule ID 18232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18232,
        GIR_EraseRootFromParent_Done,
      // Label 27304: @2269988
      GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2270097), // Rule ID 18233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18233,
        GIR_EraseRootFromParent_Done,
      // Label 27305: @2270097
      GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2270206), // Rule ID 18236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18236,
        GIR_EraseRootFromParent_Done,
      // Label 27306: @2270206
      GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2270315), // Rule ID 18237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18237,
        GIR_EraseRootFromParent_Done,
      // Label 27307: @2270315
      GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2270424), // Rule ID 18240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18240,
        GIR_EraseRootFromParent_Done,
      // Label 27308: @2270424
      GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2270533), // Rule ID 18241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18241,
        GIR_EraseRootFromParent_Done,
      // Label 27309: @2270533
      GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2270642), // Rule ID 18244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18244,
        GIR_EraseRootFromParent_Done,
      // Label 27310: @2270642
      GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2270751), // Rule ID 18245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18245,
        GIR_EraseRootFromParent_Done,
      // Label 27311: @2270751
      GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2270860), // Rule ID 18248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18248,
        GIR_EraseRootFromParent_Done,
      // Label 27312: @2270860
      GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2270969), // Rule ID 18249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18249,
        GIR_EraseRootFromParent_Done,
      // Label 27313: @2270969
      GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2271078), // Rule ID 18252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18252,
        GIR_EraseRootFromParent_Done,
      // Label 27314: @2271078
      GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2271187), // Rule ID 18253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18253,
        GIR_EraseRootFromParent_Done,
      // Label 27315: @2271187
      GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2271296), // Rule ID 18256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18256,
        GIR_EraseRootFromParent_Done,
      // Label 27316: @2271296
      GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2271405), // Rule ID 18257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18257,
        GIR_EraseRootFromParent_Done,
      // Label 27317: @2271405
      GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2271514), // Rule ID 18260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18260,
        GIR_EraseRootFromParent_Done,
      // Label 27318: @2271514
      GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2271623), // Rule ID 18261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18261,
        GIR_EraseRootFromParent_Done,
      // Label 27319: @2271623
      GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2271732), // Rule ID 18264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18264,
        GIR_EraseRootFromParent_Done,
      // Label 27320: @2271732
      GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2271841), // Rule ID 18265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18265,
        GIR_EraseRootFromParent_Done,
      // Label 27321: @2271841
      GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2271950), // Rule ID 18268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18268,
        GIR_EraseRootFromParent_Done,
      // Label 27322: @2271950
      GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2272059), // Rule ID 18269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18269,
        GIR_EraseRootFromParent_Done,
      // Label 27323: @2272059
      GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2272168), // Rule ID 18272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18272,
        GIR_EraseRootFromParent_Done,
      // Label 27324: @2272168
      GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2272277), // Rule ID 18273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18273,
        GIR_EraseRootFromParent_Done,
      // Label 27325: @2272277
      GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2272386), // Rule ID 18276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18276,
        GIR_EraseRootFromParent_Done,
      // Label 27326: @2272386
      GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2272495), // Rule ID 18277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10851:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18277,
        GIR_EraseRootFromParent_Done,
      // Label 27327: @2272495
      GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2272604), // Rule ID 18280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18280,
        GIR_EraseRootFromParent_Done,
      // Label 27328: @2272604
      GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2272713), // Rule ID 18281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10851:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18281,
        GIR_EraseRootFromParent_Done,
      // Label 27329: @2272713
      GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2272822), // Rule ID 18284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18284,
        GIR_EraseRootFromParent_Done,
      // Label 27330: @2272822
      GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2272931), // Rule ID 18285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10851:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18285,
        GIR_EraseRootFromParent_Done,
      // Label 27331: @2272931
      GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2273040), // Rule ID 18288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18288,
        GIR_EraseRootFromParent_Done,
      // Label 27332: @2273040
      GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2273149), // Rule ID 18289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18289,
        GIR_EraseRootFromParent_Done,
      // Label 27333: @2273149
      GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2273258), // Rule ID 18292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18292,
        GIR_EraseRootFromParent_Done,
      // Label 27334: @2273258
      GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2273367), // Rule ID 18293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18293,
        GIR_EraseRootFromParent_Done,
      // Label 27335: @2273367
      GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2273476), // Rule ID 18296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18296,
        GIR_EraseRootFromParent_Done,
      // Label 27336: @2273476
      GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2273585), // Rule ID 18297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18297,
        GIR_EraseRootFromParent_Done,
      // Label 27337: @2273585
      GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2273694), // Rule ID 18300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18300,
        GIR_EraseRootFromParent_Done,
      // Label 27338: @2273694
      GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2273803), // Rule ID 18301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18301,
        GIR_EraseRootFromParent_Done,
      // Label 27339: @2273803
      GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2273912), // Rule ID 18304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18304,
        GIR_EraseRootFromParent_Done,
      // Label 27340: @2273912
      GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2274021), // Rule ID 18305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18305,
        GIR_EraseRootFromParent_Done,
      // Label 27341: @2274021
      GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2274130), // Rule ID 18308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18308,
        GIR_EraseRootFromParent_Done,
      // Label 27342: @2274130
      GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2274239), // Rule ID 18309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18309,
        GIR_EraseRootFromParent_Done,
      // Label 27343: @2274239
      GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2274348), // Rule ID 18312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18312,
        GIR_EraseRootFromParent_Done,
      // Label 27344: @2274348
      GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2274457), // Rule ID 18313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10851:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18313,
        GIR_EraseRootFromParent_Done,
      // Label 27345: @2274457
      GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2274566), // Rule ID 18316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18316,
        GIR_EraseRootFromParent_Done,
      // Label 27346: @2274566
      GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2274675), // Rule ID 18317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10851:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18317,
        GIR_EraseRootFromParent_Done,
      // Label 27347: @2274675
      GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2274784), // Rule ID 18320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18320,
        GIR_EraseRootFromParent_Done,
      // Label 27348: @2274784
      GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2274893), // Rule ID 18321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10851:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18321,
        GIR_EraseRootFromParent_Done,
      // Label 27349: @2274893
      GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2275002), // Rule ID 18324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18324,
        GIR_EraseRootFromParent_Done,
      // Label 27350: @2275002
      GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2275111), // Rule ID 18325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18325,
        GIR_EraseRootFromParent_Done,
      // Label 27351: @2275111
      GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2275220), // Rule ID 18328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18328,
        GIR_EraseRootFromParent_Done,
      // Label 27352: @2275220
      GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2275329), // Rule ID 18329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18329,
        GIR_EraseRootFromParent_Done,
      // Label 27353: @2275329
      GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2275438), // Rule ID 18332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18332,
        GIR_EraseRootFromParent_Done,
      // Label 27354: @2275438
      GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2275547), // Rule ID 18333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18333,
        GIR_EraseRootFromParent_Done,
      // Label 27355: @2275547
      GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2275656), // Rule ID 18336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18336,
        GIR_EraseRootFromParent_Done,
      // Label 27356: @2275656
      GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2275765), // Rule ID 18337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18337,
        GIR_EraseRootFromParent_Done,
      // Label 27357: @2275765
      GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2275874), // Rule ID 18340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18340,
        GIR_EraseRootFromParent_Done,
      // Label 27358: @2275874
      GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2275983), // Rule ID 18341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18341,
        GIR_EraseRootFromParent_Done,
      // Label 27359: @2275983
      GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2276092), // Rule ID 18344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18344,
        GIR_EraseRootFromParent_Done,
      // Label 27360: @2276092
      GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2276201), // Rule ID 18345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18345,
        GIR_EraseRootFromParent_Done,
      // Label 27361: @2276201
      GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2276310), // Rule ID 18348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18348,
        GIR_EraseRootFromParent_Done,
      // Label 27362: @2276310
      GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2276419), // Rule ID 18349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18349,
        GIR_EraseRootFromParent_Done,
      // Label 27363: @2276419
      GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2276528), // Rule ID 18352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18352,
        GIR_EraseRootFromParent_Done,
      // Label 27364: @2276528
      GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2276637), // Rule ID 18353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18353,
        GIR_EraseRootFromParent_Done,
      // Label 27365: @2276637
      GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2276746), // Rule ID 18356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18356,
        GIR_EraseRootFromParent_Done,
      // Label 27366: @2276746
      GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2276855), // Rule ID 18357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18357,
        GIR_EraseRootFromParent_Done,
      // Label 27367: @2276855
      GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2276964), // Rule ID 18360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18360,
        GIR_EraseRootFromParent_Done,
      // Label 27368: @2276964
      GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2277073), // Rule ID 18361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18361,
        GIR_EraseRootFromParent_Done,
      // Label 27369: @2277073
      GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2277182), // Rule ID 18364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18364,
        GIR_EraseRootFromParent_Done,
      // Label 27370: @2277182
      GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2277291), // Rule ID 18365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18365,
        GIR_EraseRootFromParent_Done,
      // Label 27371: @2277291
      GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2277400), // Rule ID 18368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18368,
        GIR_EraseRootFromParent_Done,
      // Label 27372: @2277400
      GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2277509), // Rule ID 18369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18369,
        GIR_EraseRootFromParent_Done,
      // Label 27373: @2277509
      GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2277618), // Rule ID 18372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18372,
        GIR_EraseRootFromParent_Done,
      // Label 27374: @2277618
      GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2277727), // Rule ID 18373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18373,
        GIR_EraseRootFromParent_Done,
      // Label 27375: @2277727
      GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2277836), // Rule ID 18376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18376,
        GIR_EraseRootFromParent_Done,
      // Label 27376: @2277836
      GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2277945), // Rule ID 18377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18377,
        GIR_EraseRootFromParent_Done,
      // Label 27377: @2277945
      GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2278054), // Rule ID 18380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18380,
        GIR_EraseRootFromParent_Done,
      // Label 27378: @2278054
      GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2278163), // Rule ID 18381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18381,
        GIR_EraseRootFromParent_Done,
      // Label 27379: @2278163
      GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2278272), // Rule ID 18384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18384,
        GIR_EraseRootFromParent_Done,
      // Label 27380: @2278272
      GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2278381), // Rule ID 18385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18385,
        GIR_EraseRootFromParent_Done,
      // Label 27381: @2278381
      GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2278490), // Rule ID 18388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18388,
        GIR_EraseRootFromParent_Done,
      // Label 27382: @2278490
      GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2278599), // Rule ID 18389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18389,
        GIR_EraseRootFromParent_Done,
      // Label 27383: @2278599
      GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2278708), // Rule ID 18392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18392,
        GIR_EraseRootFromParent_Done,
      // Label 27384: @2278708
      GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2278817), // Rule ID 18393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18393,
        GIR_EraseRootFromParent_Done,
      // Label 27385: @2278817
      GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2278926), // Rule ID 18396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18396,
        GIR_EraseRootFromParent_Done,
      // Label 27386: @2278926
      GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2279035), // Rule ID 18397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10824:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18397,
        GIR_EraseRootFromParent_Done,
      // Label 27387: @2279035
      GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2279144), // Rule ID 18400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18400,
        GIR_EraseRootFromParent_Done,
      // Label 27388: @2279144
      GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2279253), // Rule ID 18401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10824:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18401,
        GIR_EraseRootFromParent_Done,
      // Label 27389: @2279253
      GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2279362), // Rule ID 18404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18404,
        GIR_EraseRootFromParent_Done,
      // Label 27390: @2279362
      GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2279471), // Rule ID 18405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10824:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18405,
        GIR_EraseRootFromParent_Done,
      // Label 27391: @2279471
      GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2279580), // Rule ID 18408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18408,
        GIR_EraseRootFromParent_Done,
      // Label 27392: @2279580
      GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2279689), // Rule ID 18409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18409,
        GIR_EraseRootFromParent_Done,
      // Label 27393: @2279689
      GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2279798), // Rule ID 18412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18412,
        GIR_EraseRootFromParent_Done,
      // Label 27394: @2279798
      GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2279907), // Rule ID 18413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18413,
        GIR_EraseRootFromParent_Done,
      // Label 27395: @2279907
      GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2280016), // Rule ID 18416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18416,
        GIR_EraseRootFromParent_Done,
      // Label 27396: @2280016
      GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2280125), // Rule ID 18417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18417,
        GIR_EraseRootFromParent_Done,
      // Label 27397: @2280125
      GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2280234), // Rule ID 18420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18420,
        GIR_EraseRootFromParent_Done,
      // Label 27398: @2280234
      GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2280343), // Rule ID 18421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18421,
        GIR_EraseRootFromParent_Done,
      // Label 27399: @2280343
      GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2280452), // Rule ID 18424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18424,
        GIR_EraseRootFromParent_Done,
      // Label 27400: @2280452
      GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2280561), // Rule ID 18425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18425,
        GIR_EraseRootFromParent_Done,
      // Label 27401: @2280561
      GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2280670), // Rule ID 18428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18428,
        GIR_EraseRootFromParent_Done,
      // Label 27402: @2280670
      GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2280779), // Rule ID 18429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18429,
        GIR_EraseRootFromParent_Done,
      // Label 27403: @2280779
      GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2280888), // Rule ID 18432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18432,
        GIR_EraseRootFromParent_Done,
      // Label 27404: @2280888
      GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2280997), // Rule ID 18433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10824:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18433,
        GIR_EraseRootFromParent_Done,
      // Label 27405: @2280997
      GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2281106), // Rule ID 18436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18436,
        GIR_EraseRootFromParent_Done,
      // Label 27406: @2281106
      GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2281215), // Rule ID 18437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10824:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18437,
        GIR_EraseRootFromParent_Done,
      // Label 27407: @2281215
      GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2281324), // Rule ID 18440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18440,
        GIR_EraseRootFromParent_Done,
      // Label 27408: @2281324
      GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2281433), // Rule ID 18441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10824:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18441,
        GIR_EraseRootFromParent_Done,
      // Label 27409: @2281433
      GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2281542), // Rule ID 18444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18444,
        GIR_EraseRootFromParent_Done,
      // Label 27410: @2281542
      GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2281651), // Rule ID 18445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18445,
        GIR_EraseRootFromParent_Done,
      // Label 27411: @2281651
      GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2281760), // Rule ID 18448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18448,
        GIR_EraseRootFromParent_Done,
      // Label 27412: @2281760
      GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2281869), // Rule ID 18449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18449,
        GIR_EraseRootFromParent_Done,
      // Label 27413: @2281869
      GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2281978), // Rule ID 18452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18452,
        GIR_EraseRootFromParent_Done,
      // Label 27414: @2281978
      GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2282087), // Rule ID 18453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18453,
        GIR_EraseRootFromParent_Done,
      // Label 27415: @2282087
      GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2282196), // Rule ID 18456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18456,
        GIR_EraseRootFromParent_Done,
      // Label 27416: @2282196
      GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2282305), // Rule ID 18457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18457,
        GIR_EraseRootFromParent_Done,
      // Label 27417: @2282305
      GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2282414), // Rule ID 18460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18460,
        GIR_EraseRootFromParent_Done,
      // Label 27418: @2282414
      GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2282523), // Rule ID 18461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18461,
        GIR_EraseRootFromParent_Done,
      // Label 27419: @2282523
      GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2282632), // Rule ID 18464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18464,
        GIR_EraseRootFromParent_Done,
      // Label 27420: @2282632
      GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2282741), // Rule ID 18465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18465,
        GIR_EraseRootFromParent_Done,
      // Label 27421: @2282741
      GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2282850), // Rule ID 18468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18468,
        GIR_EraseRootFromParent_Done,
      // Label 27422: @2282850
      GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2282959), // Rule ID 18469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18469,
        GIR_EraseRootFromParent_Done,
      // Label 27423: @2282959
      GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2283068), // Rule ID 18472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18472,
        GIR_EraseRootFromParent_Done,
      // Label 27424: @2283068
      GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2283177), // Rule ID 18473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18473,
        GIR_EraseRootFromParent_Done,
      // Label 27425: @2283177
      GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2283286), // Rule ID 18476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18476,
        GIR_EraseRootFromParent_Done,
      // Label 27426: @2283286
      GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2283395), // Rule ID 18477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18477,
        GIR_EraseRootFromParent_Done,
      // Label 27427: @2283395
      GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2283504), // Rule ID 18480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18480,
        GIR_EraseRootFromParent_Done,
      // Label 27428: @2283504
      GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2283613), // Rule ID 18481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18481,
        GIR_EraseRootFromParent_Done,
      // Label 27429: @2283613
      GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2283722), // Rule ID 18484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18484,
        GIR_EraseRootFromParent_Done,
      // Label 27430: @2283722
      GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2283831), // Rule ID 18485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18485,
        GIR_EraseRootFromParent_Done,
      // Label 27431: @2283831
      GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2283940), // Rule ID 18488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18488,
        GIR_EraseRootFromParent_Done,
      // Label 27432: @2283940
      GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2284049), // Rule ID 18489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18489,
        GIR_EraseRootFromParent_Done,
      // Label 27433: @2284049
      GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2284158), // Rule ID 18492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18492,
        GIR_EraseRootFromParent_Done,
      // Label 27434: @2284158
      GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2284267), // Rule ID 18493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18493,
        GIR_EraseRootFromParent_Done,
      // Label 27435: @2284267
      GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2284376), // Rule ID 18496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18496,
        GIR_EraseRootFromParent_Done,
      // Label 27436: @2284376
      GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2284485), // Rule ID 18497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18497,
        GIR_EraseRootFromParent_Done,
      // Label 27437: @2284485
      GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2284594), // Rule ID 18500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18500,
        GIR_EraseRootFromParent_Done,
      // Label 27438: @2284594
      GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2284703), // Rule ID 18501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18501,
        GIR_EraseRootFromParent_Done,
      // Label 27439: @2284703
      GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2284812), // Rule ID 18504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18504,
        GIR_EraseRootFromParent_Done,
      // Label 27440: @2284812
      GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2284921), // Rule ID 18505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18505,
        GIR_EraseRootFromParent_Done,
      // Label 27441: @2284921
      GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2285030), // Rule ID 18508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18508,
        GIR_EraseRootFromParent_Done,
      // Label 27442: @2285030
      GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2285139), // Rule ID 18509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18509,
        GIR_EraseRootFromParent_Done,
      // Label 27443: @2285139
      GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2285248), // Rule ID 18512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18512,
        GIR_EraseRootFromParent_Done,
      // Label 27444: @2285248
      GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2285357), // Rule ID 18513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18513,
        GIR_EraseRootFromParent_Done,
      // Label 27445: @2285357
      GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2285466), // Rule ID 18516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18516,
        GIR_EraseRootFromParent_Done,
      // Label 27446: @2285466
      GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2285575), // Rule ID 18517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 10855:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18517,
        GIR_EraseRootFromParent_Done,
      // Label 27447: @2285575
      GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2285684), // Rule ID 18520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18520,
        GIR_EraseRootFromParent_Done,
      // Label 27448: @2285684
      GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2285793), // Rule ID 18521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10855:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18521,
        GIR_EraseRootFromParent_Done,
      // Label 27449: @2285793
      GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2285902), // Rule ID 18524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18524,
        GIR_EraseRootFromParent_Done,
      // Label 27450: @2285902
      GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2286011), // Rule ID 18525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10855:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18525,
        GIR_EraseRootFromParent_Done,
      // Label 27451: @2286011
      GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2286120), // Rule ID 18528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18528,
        GIR_EraseRootFromParent_Done,
      // Label 27452: @2286120
      GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2286229), // Rule ID 18529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18529,
        GIR_EraseRootFromParent_Done,
      // Label 27453: @2286229
      GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2286338), // Rule ID 18532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18532,
        GIR_EraseRootFromParent_Done,
      // Label 27454: @2286338
      GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2286447), // Rule ID 18533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f16] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18533,
        GIR_EraseRootFromParent_Done,
      // Label 27455: @2286447
      GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2286556), // Rule ID 18536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18536,
        GIR_EraseRootFromParent_Done,
      // Label 27456: @2286556
      GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2286665), // Rule ID 18537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv32f16] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, V0:{ *:[nxv32i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18537,
        GIR_EraseRootFromParent_Done,
      // Label 27457: @2286665
      GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2286774), // Rule ID 18540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18540,
        GIR_EraseRootFromParent_Done,
      // Label 27458: @2286774
      GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2286883), // Rule ID 18541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18541,
        GIR_EraseRootFromParent_Done,
      // Label 27459: @2286883
      GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2286992), // Rule ID 18544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18544,
        GIR_EraseRootFromParent_Done,
      // Label 27460: @2286992
      GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2287101), // Rule ID 18545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18545,
        GIR_EraseRootFromParent_Done,
      // Label 27461: @2287101
      GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2287210), // Rule ID 18548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18548,
        GIR_EraseRootFromParent_Done,
      // Label 27462: @2287210
      GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2287319), // Rule ID 18549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18549,
        GIR_EraseRootFromParent_Done,
      // Label 27463: @2287319
      GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2287428), // Rule ID 18552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18552,
        GIR_EraseRootFromParent_Done,
      // Label 27464: @2287428
      GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2287537), // Rule ID 18553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10855:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18553,
        GIR_EraseRootFromParent_Done,
      // Label 27465: @2287537
      GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2287646), // Rule ID 18556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18556,
        GIR_EraseRootFromParent_Done,
      // Label 27466: @2287646
      GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2287755), // Rule ID 18557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10855:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18557,
        GIR_EraseRootFromParent_Done,
      // Label 27467: @2287755
      GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2287864), // Rule ID 18560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18560,
        GIR_EraseRootFromParent_Done,
      // Label 27468: @2287864
      GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2287973), // Rule ID 18561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10855:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18561,
        GIR_EraseRootFromParent_Done,
      // Label 27469: @2287973
      GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2288082), // Rule ID 18564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18564,
        GIR_EraseRootFromParent_Done,
      // Label 27470: @2288082
      GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2288191), // Rule ID 18565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18565,
        GIR_EraseRootFromParent_Done,
      // Label 27471: @2288191
      GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2288300), // Rule ID 18568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18568,
        GIR_EraseRootFromParent_Done,
      // Label 27472: @2288300
      GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2288409), // Rule ID 18569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18569,
        GIR_EraseRootFromParent_Done,
      // Label 27473: @2288409
      GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2288518), // Rule ID 18572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18572,
        GIR_EraseRootFromParent_Done,
      // Label 27474: @2288518
      GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2288627), // Rule ID 18573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18573,
        GIR_EraseRootFromParent_Done,
      // Label 27475: @2288627
      GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2288736), // Rule ID 18576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18576,
        GIR_EraseRootFromParent_Done,
      // Label 27476: @2288736
      GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2288845), // Rule ID 18577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18577,
        GIR_EraseRootFromParent_Done,
      // Label 27477: @2288845
      GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2288954), // Rule ID 18580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18580,
        GIR_EraseRootFromParent_Done,
      // Label 27478: @2288954
      GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2289063), // Rule ID 18581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18581,
        GIR_EraseRootFromParent_Done,
      // Label 27479: @2289063
      GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2289172), // Rule ID 18584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18584,
        GIR_EraseRootFromParent_Done,
      // Label 27480: @2289172
      GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2289281), // Rule ID 18585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18585,
        GIR_EraseRootFromParent_Done,
      // Label 27481: @2289281
      GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2289390), // Rule ID 18588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18588,
        GIR_EraseRootFromParent_Done,
      // Label 27482: @2289390
      GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2289499), // Rule ID 18589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18589,
        GIR_EraseRootFromParent_Done,
      // Label 27483: @2289499
      GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2289608), // Rule ID 18592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18592,
        GIR_EraseRootFromParent_Done,
      // Label 27484: @2289608
      GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2289717), // Rule ID 18593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18593,
        GIR_EraseRootFromParent_Done,
      // Label 27485: @2289717
      GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2289826), // Rule ID 18596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18596,
        GIR_EraseRootFromParent_Done,
      // Label 27486: @2289826
      GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2289935), // Rule ID 18597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18597,
        GIR_EraseRootFromParent_Done,
      // Label 27487: @2289935
      GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2290044), // Rule ID 18600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18600,
        GIR_EraseRootFromParent_Done,
      // Label 27488: @2290044
      GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2290153), // Rule ID 18601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18601,
        GIR_EraseRootFromParent_Done,
      // Label 27489: @2290153
      GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2290262), // Rule ID 18604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18604,
        GIR_EraseRootFromParent_Done,
      // Label 27490: @2290262
      GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2290371), // Rule ID 18605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10907:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18605,
        GIR_EraseRootFromParent_Done,
      // Label 27491: @2290371
      GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2290480), // Rule ID 18608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18608,
        GIR_EraseRootFromParent_Done,
      // Label 27492: @2290480
      GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2290589), // Rule ID 18609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18609,
        GIR_EraseRootFromParent_Done,
      // Label 27493: @2290589
      GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2290698), // Rule ID 18612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18612,
        GIR_EraseRootFromParent_Done,
      // Label 27494: @2290698
      GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2290807), // Rule ID 18613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18613,
        GIR_EraseRootFromParent_Done,
      // Label 27495: @2290807
      GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2290916), // Rule ID 18616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18616,
        GIR_EraseRootFromParent_Done,
      // Label 27496: @2290916
      GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2291025), // Rule ID 18617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18617,
        GIR_EraseRootFromParent_Done,
      // Label 27497: @2291025
      GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2291134), // Rule ID 18620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18620,
        GIR_EraseRootFromParent_Done,
      // Label 27498: @2291134
      GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2291243), // Rule ID 18621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10907:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18621,
        GIR_EraseRootFromParent_Done,
      // Label 27499: @2291243
      GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2291352), // Rule ID 18624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18624,
        GIR_EraseRootFromParent_Done,
      // Label 27500: @2291352
      GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2291461), // Rule ID 18625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10907:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18625,
        GIR_EraseRootFromParent_Done,
      // Label 27501: @2291461
      GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2291570), // Rule ID 18628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18628,
        GIR_EraseRootFromParent_Done,
      // Label 27502: @2291570
      GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2291679), // Rule ID 18629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10907:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18629,
        GIR_EraseRootFromParent_Done,
      // Label 27503: @2291679
      GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2291788), // Rule ID 18632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18632,
        GIR_EraseRootFromParent_Done,
      // Label 27504: @2291788
      GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2291897), // Rule ID 18633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10907:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18633,
        GIR_EraseRootFromParent_Done,
      // Label 27505: @2291897
      GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2292006), // Rule ID 18636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18636,
        GIR_EraseRootFromParent_Done,
      // Label 27506: @2292006
      GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2292115), // Rule ID 18637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18637,
        GIR_EraseRootFromParent_Done,
      // Label 27507: @2292115
      GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2292224), // Rule ID 18640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18640,
        GIR_EraseRootFromParent_Done,
      // Label 27508: @2292224
      GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2292333), // Rule ID 18641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18641,
        GIR_EraseRootFromParent_Done,
      // Label 27509: @2292333
      GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2292442), // Rule ID 18644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18644,
        GIR_EraseRootFromParent_Done,
      // Label 27510: @2292442
      GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2292551), // Rule ID 18645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18645,
        GIR_EraseRootFromParent_Done,
      // Label 27511: @2292551
      GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2292660), // Rule ID 18648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18648,
        GIR_EraseRootFromParent_Done,
      // Label 27512: @2292660
      GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2292769), // Rule ID 18649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18649,
        GIR_EraseRootFromParent_Done,
      // Label 27513: @2292769
      GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2292878), // Rule ID 18652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10915:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18652,
        GIR_EraseRootFromParent_Done,
      // Label 27514: @2292878
      GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2292987), // Rule ID 18653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10915:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18653,
        GIR_EraseRootFromParent_Done,
      // Label 27515: @2292987
      GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2293096), // Rule ID 18656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18656,
        GIR_EraseRootFromParent_Done,
      // Label 27516: @2293096
      GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2293205), // Rule ID 18657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18657,
        GIR_EraseRootFromParent_Done,
      // Label 27517: @2293205
      GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2293314), // Rule ID 18660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18660,
        GIR_EraseRootFromParent_Done,
      // Label 27518: @2293314
      GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2293423), // Rule ID 18661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18661,
        GIR_EraseRootFromParent_Done,
      // Label 27519: @2293423
      GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2293532), // Rule ID 18664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18664,
        GIR_EraseRootFromParent_Done,
      // Label 27520: @2293532
      GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2293641), // Rule ID 18665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18665,
        GIR_EraseRootFromParent_Done,
      // Label 27521: @2293641
      GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2293750), // Rule ID 18668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10915:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18668,
        GIR_EraseRootFromParent_Done,
      // Label 27522: @2293750
      GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2293859), // Rule ID 18669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10915:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18669,
        GIR_EraseRootFromParent_Done,
      // Label 27523: @2293859
      GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2293968), // Rule ID 18672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18672,
        GIR_EraseRootFromParent_Done,
      // Label 27524: @2293968
      GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2294077), // Rule ID 18673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18673,
        GIR_EraseRootFromParent_Done,
      // Label 27525: @2294077
      GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2294186), // Rule ID 18676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18676,
        GIR_EraseRootFromParent_Done,
      // Label 27526: @2294186
      GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2294295), // Rule ID 18677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10915:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18677,
        GIR_EraseRootFromParent_Done,
      // Label 27527: @2294295
      GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2294404), // Rule ID 18680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18680,
        GIR_EraseRootFromParent_Done,
      // Label 27528: @2294404
      GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2294513), // Rule ID 18681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18681,
        GIR_EraseRootFromParent_Done,
      // Label 27529: @2294513
      GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2294622), // Rule ID 18684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18684,
        GIR_EraseRootFromParent_Done,
      // Label 27530: @2294622
      GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2294731), // Rule ID 18685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18685,
        GIR_EraseRootFromParent_Done,
      // Label 27531: @2294731
      GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2294840), // Rule ID 18688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10915:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18688,
        GIR_EraseRootFromParent_Done,
      // Label 27532: @2294840
      GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2294949), // Rule ID 18689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10915:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18689,
        GIR_EraseRootFromParent_Done,
      // Label 27533: @2294949
      GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2295058), // Rule ID 18692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18692,
        GIR_EraseRootFromParent_Done,
      // Label 27534: @2295058
      GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2295167), // Rule ID 18693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10915:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18693,
        GIR_EraseRootFromParent_Done,
      // Label 27535: @2295167
      GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2295276), // Rule ID 18696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18696,
        GIR_EraseRootFromParent_Done,
      // Label 27536: @2295276
      GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2295385), // Rule ID 18697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10915:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18697,
        GIR_EraseRootFromParent_Done,
      // Label 27537: @2295385
      GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2295494), // Rule ID 18700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18700,
        GIR_EraseRootFromParent_Done,
      // Label 27538: @2295494
      GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2295603), // Rule ID 18701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10915:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18701,
        GIR_EraseRootFromParent_Done,
      // Label 27539: @2295603
      GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2295712), // Rule ID 18704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10915:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18704,
        GIR_EraseRootFromParent_Done,
      // Label 27540: @2295712
      GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2295821), // Rule ID 18705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10915:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18705,
        GIR_EraseRootFromParent_Done,
      // Label 27541: @2295821
      GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2295930), // Rule ID 18708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10911:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18708,
        GIR_EraseRootFromParent_Done,
      // Label 27542: @2295930
      GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2296039), // Rule ID 18709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10911:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18709,
        GIR_EraseRootFromParent_Done,
      // Label 27543: @2296039
      GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2296148), // Rule ID 18712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10911:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18712,
        GIR_EraseRootFromParent_Done,
      // Label 27544: @2296148
      GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2296257), // Rule ID 18713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10911:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18713,
        GIR_EraseRootFromParent_Done,
      // Label 27545: @2296257
      GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2296366), // Rule ID 18716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10911:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18716,
        GIR_EraseRootFromParent_Done,
      // Label 27546: @2296366
      GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2296475), // Rule ID 18717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10911:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18717,
        GIR_EraseRootFromParent_Done,
      // Label 27547: @2296475
      GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2296584), // Rule ID 18720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10911:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18720,
        GIR_EraseRootFromParent_Done,
      // Label 27548: @2296584
      GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2296693), // Rule ID 18721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10911:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18721,
        GIR_EraseRootFromParent_Done,
      // Label 27549: @2296693
      GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2296802), // Rule ID 18724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10911:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18724,
        GIR_EraseRootFromParent_Done,
      // Label 27550: @2296802
      GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2296911), // Rule ID 18725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10911:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18725,
        GIR_EraseRootFromParent_Done,
      // Label 27551: @2296911
      GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2297020), // Rule ID 18728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10911:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18728,
        GIR_EraseRootFromParent_Done,
      // Label 27552: @2297020
      GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2297129), // Rule ID 18729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10911:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18729,
        GIR_EraseRootFromParent_Done,
      // Label 27553: @2297129
      GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2297238), // Rule ID 18732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10911:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18732,
        GIR_EraseRootFromParent_Done,
      // Label 27554: @2297238
      GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2297347), // Rule ID 18733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10911:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18733,
        GIR_EraseRootFromParent_Done,
      // Label 27555: @2297347
      GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2297456), // Rule ID 18736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10911:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18736,
        GIR_EraseRootFromParent_Done,
      // Label 27556: @2297456
      GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2297565), // Rule ID 18737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10911:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18737,
        GIR_EraseRootFromParent_Done,
      // Label 27557: @2297565
      GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2297674), // Rule ID 18740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10911:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18740,
        GIR_EraseRootFromParent_Done,
      // Label 27558: @2297674
      GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2297783), // Rule ID 18741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10911:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18741,
        GIR_EraseRootFromParent_Done,
      // Label 27559: @2297783
      GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2297892), // Rule ID 18744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10911:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18744,
        GIR_EraseRootFromParent_Done,
      // Label 27560: @2297892
      GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2298001), // Rule ID 18745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10911:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18745,
        GIR_EraseRootFromParent_Done,
      // Label 27561: @2298001
      GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2298110), // Rule ID 18748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10911:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18748,
        GIR_EraseRootFromParent_Done,
      // Label 27562: @2298110
      GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2298219), // Rule ID 18749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10911:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18749,
        GIR_EraseRootFromParent_Done,
      // Label 27563: @2298219
      GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2298328), // Rule ID 18752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10911:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18752,
        GIR_EraseRootFromParent_Done,
      // Label 27564: @2298328
      GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2298437), // Rule ID 18753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10911:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18753,
        GIR_EraseRootFromParent_Done,
      // Label 27565: @2298437
      GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2298546), // Rule ID 18756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10911:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18756,
        GIR_EraseRootFromParent_Done,
      // Label 27566: @2298546
      GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2298655), // Rule ID 18757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10911:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18757,
        GIR_EraseRootFromParent_Done,
      // Label 27567: @2298655
      GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2298764), // Rule ID 18760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10911:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18760,
        GIR_EraseRootFromParent_Done,
      // Label 27568: @2298764
      GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2298873), // Rule ID 18761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10911:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18761,
        GIR_EraseRootFromParent_Done,
      // Label 27569: @2298873
      GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2298982), // Rule ID 18764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10911:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18764,
        GIR_EraseRootFromParent_Done,
      // Label 27570: @2298982
      GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2299091), // Rule ID 18765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10911:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18765,
        GIR_EraseRootFromParent_Done,
      // Label 27571: @2299091
      GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2299200), // Rule ID 18768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10911:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18768,
        GIR_EraseRootFromParent_Done,
      // Label 27572: @2299200
      GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2299309), // Rule ID 18769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10911:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18769,
        GIR_EraseRootFromParent_Done,
      // Label 27573: @2299309
      GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2299418), // Rule ID 18772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10911:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18772,
        GIR_EraseRootFromParent_Done,
      // Label 27574: @2299418
      GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2299527), // Rule ID 18773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10911:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18773,
        GIR_EraseRootFromParent_Done,
      // Label 27575: @2299527
      GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2299636), // Rule ID 18776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10911:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18776,
        GIR_EraseRootFromParent_Done,
      // Label 27576: @2299636
      GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2299745), // Rule ID 18777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10911:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18777,
        GIR_EraseRootFromParent_Done,
      // Label 27577: @2299745
      GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2299854), // Rule ID 18780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18780,
        GIR_EraseRootFromParent_Done,
      // Label 27578: @2299854
      GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2299963), // Rule ID 18781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18781,
        GIR_EraseRootFromParent_Done,
      // Label 27579: @2299963
      GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2300072), // Rule ID 18784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18784,
        GIR_EraseRootFromParent_Done,
      // Label 27580: @2300072
      GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2300181), // Rule ID 18785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18785,
        GIR_EraseRootFromParent_Done,
      // Label 27581: @2300181
      GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2300290), // Rule ID 18788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18788,
        GIR_EraseRootFromParent_Done,
      // Label 27582: @2300290
      GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2300399), // Rule ID 18789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18789,
        GIR_EraseRootFromParent_Done,
      // Label 27583: @2300399
      GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2300508), // Rule ID 18792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18792,
        GIR_EraseRootFromParent_Done,
      // Label 27584: @2300508
      GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2300617), // Rule ID 18793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18793,
        GIR_EraseRootFromParent_Done,
      // Label 27585: @2300617
      GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2300726), // Rule ID 18796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10917:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18796,
        GIR_EraseRootFromParent_Done,
      // Label 27586: @2300726
      GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2300835), // Rule ID 18797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10917:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18797,
        GIR_EraseRootFromParent_Done,
      // Label 27587: @2300835
      GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2300944), // Rule ID 18800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18800,
        GIR_EraseRootFromParent_Done,
      // Label 27588: @2300944
      GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2301053), // Rule ID 18801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18801,
        GIR_EraseRootFromParent_Done,
      // Label 27589: @2301053
      GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2301162), // Rule ID 18804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18804,
        GIR_EraseRootFromParent_Done,
      // Label 27590: @2301162
      GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2301271), // Rule ID 18805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18805,
        GIR_EraseRootFromParent_Done,
      // Label 27591: @2301271
      GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2301380), // Rule ID 18808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18808,
        GIR_EraseRootFromParent_Done,
      // Label 27592: @2301380
      GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2301489), // Rule ID 18809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18809,
        GIR_EraseRootFromParent_Done,
      // Label 27593: @2301489
      GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2301598), // Rule ID 18812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10917:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18812,
        GIR_EraseRootFromParent_Done,
      // Label 27594: @2301598
      GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2301707), // Rule ID 18813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10917:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18813,
        GIR_EraseRootFromParent_Done,
      // Label 27595: @2301707
      GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2301816), // Rule ID 18816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18816,
        GIR_EraseRootFromParent_Done,
      // Label 27596: @2301816
      GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2301925), // Rule ID 18817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18817,
        GIR_EraseRootFromParent_Done,
      // Label 27597: @2301925
      GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2302034), // Rule ID 18820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18820,
        GIR_EraseRootFromParent_Done,
      // Label 27598: @2302034
      GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2302143), // Rule ID 18821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 10917:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18821,
        GIR_EraseRootFromParent_Done,
      // Label 27599: @2302143
      GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2302252), // Rule ID 18824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18824,
        GIR_EraseRootFromParent_Done,
      // Label 27600: @2302252
      GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2302361), // Rule ID 18825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18825,
        GIR_EraseRootFromParent_Done,
      // Label 27601: @2302361
      GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2302470), // Rule ID 18828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18828,
        GIR_EraseRootFromParent_Done,
      // Label 27602: @2302470
      GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2302579), // Rule ID 18829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f32] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18829,
        GIR_EraseRootFromParent_Done,
      // Label 27603: @2302579
      GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2302688), // Rule ID 18832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10917:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18832,
        GIR_EraseRootFromParent_Done,
      // Label 27604: @2302688
      GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2302797), // Rule ID 18833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16f32] } 10917:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18833,
        GIR_EraseRootFromParent_Done,
      // Label 27605: @2302797
      GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2302906), // Rule ID 18836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18836,
        GIR_EraseRootFromParent_Done,
      // Label 27606: @2302906
      GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2303015), // Rule ID 18837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1f64] } 10917:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18837,
        GIR_EraseRootFromParent_Done,
      // Label 27607: @2303015
      GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2303124), // Rule ID 18840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18840,
        GIR_EraseRootFromParent_Done,
      // Label 27608: @2303124
      GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2303233), // Rule ID 18841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 10917:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18841,
        GIR_EraseRootFromParent_Done,
      // Label 27609: @2303233
      GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2303342), // Rule ID 18844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18844,
        GIR_EraseRootFromParent_Done,
      // Label 27610: @2303342
      GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2303451), // Rule ID 18845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4f64] } 10917:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18845,
        GIR_EraseRootFromParent_Done,
      // Label 27611: @2303451
      GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2303560), // Rule ID 18848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10917:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18848,
        GIR_EraseRootFromParent_Done,
      // Label 27612: @2303560
      GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2303669), // Rule ID 18849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8f64] } 10917:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18849,
        GIR_EraseRootFromParent_Done,
      // Label 27613: @2303669
      GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2303778), // Rule ID 63767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10706:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63767,
        GIR_EraseRootFromParent_Done,
      // Label 27614: @2303778
      GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2303887), // Rule ID 63768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10706:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63768,
        GIR_EraseRootFromParent_Done,
      // Label 27615: @2303887
      GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2303996), // Rule ID 63771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10706:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63771,
        GIR_EraseRootFromParent_Done,
      // Label 27616: @2303996
      GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2304105), // Rule ID 63772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10706:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63772,
        GIR_EraseRootFromParent_Done,
      // Label 27617: @2304105
      GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2304214), // Rule ID 63775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10706:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63775,
        GIR_EraseRootFromParent_Done,
      // Label 27618: @2304214
      GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2304323), // Rule ID 63776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10706:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63776,
        GIR_EraseRootFromParent_Done,
      // Label 27619: @2304323
      GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2304432), // Rule ID 63779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10706:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63779,
        GIR_EraseRootFromParent_Done,
      // Label 27620: @2304432
      GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2304541), // Rule ID 63780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10706:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63780,
        GIR_EraseRootFromParent_Done,
      // Label 27621: @2304541
      GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2304650), // Rule ID 63783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10706:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63783,
        GIR_EraseRootFromParent_Done,
      // Label 27622: @2304650
      GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2304759), // Rule ID 63784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10706:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63784,
        GIR_EraseRootFromParent_Done,
      // Label 27623: @2304759
      GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2304868), // Rule ID 63787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10704:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63787,
        GIR_EraseRootFromParent_Done,
      // Label 27624: @2304868
      GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2304977), // Rule ID 63788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv1i8] } 10704:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv1i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63788,
        GIR_EraseRootFromParent_Done,
      // Label 27625: @2304977
      GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2305086), // Rule ID 63791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10704:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63791,
        GIR_EraseRootFromParent_Done,
      // Label 27626: @2305086
      GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2305195), // Rule ID 63792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv2i8] } 10704:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv2i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63792,
        GIR_EraseRootFromParent_Done,
      // Label 27627: @2305195
      GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2305304), // Rule ID 63795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10704:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63795,
        GIR_EraseRootFromParent_Done,
      // Label 27628: @2305304
      GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2305413), // Rule ID 63796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv4i8] } 10704:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv4i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63796,
        GIR_EraseRootFromParent_Done,
      // Label 27629: @2305413
      GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2305522), // Rule ID 63799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10704:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63799,
        GIR_EraseRootFromParent_Done,
      // Label 27630: @2305522
      GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2305631), // Rule ID 63800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv8i8] } 10704:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv8i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63800,
        GIR_EraseRootFromParent_Done,
      // Label 27631: @2305631
      GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2305740), // Rule ID 63803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10704:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63803,
        GIR_EraseRootFromParent_Done,
      // Label 27632: @2305740
      GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2305849), // Rule ID 63804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] round
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 10704:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, V0:{ *:[nxv16i1] }, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // passthru
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/4, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/6, // round
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/8, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63804,
        GIR_EraseRootFromParent_Done,
      // Label 27633: @2305849
      GIM_Reject,
    // Label 25589: @2305850
    GIM_Reject,
    // Label 38: @2305851
    GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2305934), // Rule ID 35 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
      // MIs[0] Operand 1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
      // MIs[0] accessinfo
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      // (intrinsic_void 192:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
      GIR_RootToRootCopy, /*OpIdx*/2, // ptr
      GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 35,
      GIR_EraseRootFromParent_Done,
    // Label 27634: @2305934
    GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2306839),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
      GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2306014), // Rule ID 605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i32] } 10640:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 605,
        GIR_EraseRootFromParent_Done,
      // Label 27636: @2306014
      GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2306086), // Rule ID 606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i32] } 10626:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 606,
        GIR_EraseRootFromParent_Done,
      // Label 27637: @2306086
      GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2306158), // Rule ID 607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i32] } 10634:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 607,
        GIR_EraseRootFromParent_Done,
      // Label 27638: @2306158
      GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2306230), // Rule ID 608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i32] } 10632:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 608,
        GIR_EraseRootFromParent_Done,
      // Label 27639: @2306230
      GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2306310), // Rule ID 611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i32] } 10636:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 611,
        GIR_EraseRootFromParent_Done,
      // Label 27640: @2306310
      GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2306390), // Rule ID 612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i32] } 10638:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 612,
        GIR_EraseRootFromParent_Done,
      // Label 27641: @2306390
      GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2306462), // Rule ID 618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i64] } 10641:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 618,
        GIR_EraseRootFromParent_Done,
      // Label 27642: @2306462
      GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2306534), // Rule ID 619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i64] } 10627:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 619,
        GIR_EraseRootFromParent_Done,
      // Label 27643: @2306534
      GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2306606), // Rule ID 620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i64] } 10635:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 620,
        GIR_EraseRootFromParent_Done,
      // Label 27644: @2306606
      GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2306678), // Rule ID 621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i64] } 10633:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 621,
        GIR_EraseRootFromParent_Done,
      // Label 27645: @2306678
      GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2306758), // Rule ID 624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i64] } 10637:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 624,
        GIR_EraseRootFromParent_Done,
      // Label 27646: @2306758
      GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2306838), // Rule ID 625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_w_chain:{ *:[i64] } 10639:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 625,
        GIR_EraseRootFromParent_Done,
      // Label 27647: @2306838
      GIM_Reject,
    // Label 27635: @2306839
    GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2307366),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
      GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2306936), // Rule ID 609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_w_chain:{ *:[i32] } 10628:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
        GIR_RootToRootCopy, /*OpIdx*/6, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 609,
        GIR_EraseRootFromParent_Done,
      // Label 27649: @2306936
      GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2307025), // Rule ID 610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_w_chain:{ *:[i32] } 10630:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
        GIR_RootToRootCopy, /*OpIdx*/6, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 610,
        GIR_EraseRootFromParent_Done,
      // Label 27650: @2307025
      GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2307114), // Rule ID 622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_w_chain:{ *:[i64] } 10629:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
        GIR_RootToRootCopy, /*OpIdx*/6, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 622,
        GIR_EraseRootFromParent_Done,
      // Label 27651: @2307114
      GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2307203), // Rule ID 623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_w_chain:{ *:[i64] } 10631:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // incr
        GIR_RootToRootCopy, /*OpIdx*/4, // mask
        GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
        GIR_RootToRootCopy, /*OpIdx*/6, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 623,
        GIR_EraseRootFromParent_Done,
      // Label 27652: @2307203
      GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2307284), // Rule ID 641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_w_chain:{ *:[i32] } 10642:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
        GIR_RootToRootCopy, /*OpIdx*/4, // newval
        GIR_RootToRootCopy, /*OpIdx*/5, // mask
        GIR_RootToRootCopy, /*OpIdx*/6, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 641,
        GIR_EraseRootFromParent_Done,
      // Label 27653: @2307284
      GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2307365), // Rule ID 642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[0] ordering
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_w_chain:{ *:[i64] } 10643:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
        GIR_RootToRootCopy, /*OpIdx*/4, // newval
        GIR_RootToRootCopy, /*OpIdx*/5, // mask
        GIR_RootToRootCopy, /*OpIdx*/6, // ordering
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 642,
        GIR_EraseRootFromParent_Done,
      // Label 27654: @2307365
      GIM_Reject,
    // Label 27648: @2307366
    GIM_Reject,
    // Label 39: @2307367
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 27670*/ GIMT_Encode4(2310487),
    /*GILLT_nxv1s16*//*Label 27655*/ GIMT_Encode4(2307478),
    /*GILLT_nxv1s32*//*Label 27656*/ GIMT_Encode4(2307582),
    /*GILLT_nxv1s64*//*Label 27657*/ GIMT_Encode4(2307799), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 27658*/ GIMT_Encode4(2308124),
    /*GILLT_nxv2s32*//*Label 27659*/ GIMT_Encode4(2308228),
    /*GILLT_nxv2s64*//*Label 27660*/ GIMT_Encode4(2308445), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 27661*/ GIMT_Encode4(2308770),
    /*GILLT_nxv4s32*//*Label 27662*/ GIMT_Encode4(2308874),
    /*GILLT_nxv4s64*//*Label 27663*/ GIMT_Encode4(2309091), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 27664*/ GIMT_Encode4(2309416),
    /*GILLT_nxv8s32*//*Label 27665*/ GIMT_Encode4(2309520),
    /*GILLT_nxv8s64*//*Label 27666*/ GIMT_Encode4(2309737), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 27667*/ GIMT_Encode4(2310062),
    /*GILLT_nxv16s32*//*Label 27668*/ GIMT_Encode4(2310166), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 27669*/ GIMT_Encode4(2310383),
    // Label 27655: @2307478
    GIM_Try, /*On fail goto*//*Label 27671*/ GIMT_Encode4(2307581),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27672*/ GIMT_Encode4(2307537), // Rule ID 47044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47044,
        GIR_EraseRootFromParent_Done,
      // Label 27672: @2307537
      GIM_Try, /*On fail goto*//*Label 27673*/ GIMT_Encode4(2307580), // Rule ID 47045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47045,
        GIR_EraseRootFromParent_Done,
      // Label 27673: @2307580
      GIM_Reject,
    // Label 27671: @2307581
    GIM_Reject,
    // Label 27656: @2307582
    GIM_Try, /*On fail goto*//*Label 27674*/ GIMT_Encode4(2307636), // Rule ID 47068 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47068,
      GIR_EraseRootFromParent_Done,
    // Label 27674: @2307636
    GIM_Try, /*On fail goto*//*Label 27675*/ GIMT_Encode4(2307690), // Rule ID 47069 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47069,
      GIR_EraseRootFromParent_Done,
    // Label 27675: @2307690
    GIM_Try, /*On fail goto*//*Label 27676*/ GIMT_Encode4(2307744), // Rule ID 47134 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47134,
      GIR_EraseRootFromParent_Done,
    // Label 27676: @2307744
    GIM_Try, /*On fail goto*//*Label 27677*/ GIMT_Encode4(2307798), // Rule ID 47135 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47135,
      GIR_EraseRootFromParent_Done,
    // Label 27677: @2307798
    GIM_Reject,
    // Label 27657: @2307799
    GIM_Try, /*On fail goto*//*Label 27678*/ GIMT_Encode4(2307853), // Rule ID 47088 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47088,
      GIR_EraseRootFromParent_Done,
    // Label 27678: @2307853
    GIM_Try, /*On fail goto*//*Label 27679*/ GIMT_Encode4(2307907), // Rule ID 47089 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47089,
      GIR_EraseRootFromParent_Done,
    // Label 27679: @2307907
    GIM_Try, /*On fail goto*//*Label 27680*/ GIMT_Encode4(2307961), // Rule ID 47154 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47154,
      GIR_EraseRootFromParent_Done,
    // Label 27680: @2307961
    GIM_Try, /*On fail goto*//*Label 27681*/ GIMT_Encode4(2308015), // Rule ID 47155 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47155,
      GIR_EraseRootFromParent_Done,
    // Label 27681: @2308015
    GIM_Try, /*On fail goto*//*Label 27682*/ GIMT_Encode4(2308069), // Rule ID 47188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47188,
      GIR_EraseRootFromParent_Done,
    // Label 27682: @2308069
    GIM_Try, /*On fail goto*//*Label 27683*/ GIMT_Encode4(2308123), // Rule ID 47189 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47189,
      GIR_EraseRootFromParent_Done,
    // Label 27683: @2308123
    GIM_Reject,
    // Label 27658: @2308124
    GIM_Try, /*On fail goto*//*Label 27684*/ GIMT_Encode4(2308227),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2308183), // Rule ID 47048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47048,
        GIR_EraseRootFromParent_Done,
      // Label 27685: @2308183
      GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2308226), // Rule ID 47049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47049,
        GIR_EraseRootFromParent_Done,
      // Label 27686: @2308226
      GIM_Reject,
    // Label 27684: @2308227
    GIM_Reject,
    // Label 27659: @2308228
    GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2308282), // Rule ID 47072 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47072,
      GIR_EraseRootFromParent_Done,
    // Label 27687: @2308282
    GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2308336), // Rule ID 47073 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47073,
      GIR_EraseRootFromParent_Done,
    // Label 27688: @2308336
    GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2308390), // Rule ID 47138 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47138,
      GIR_EraseRootFromParent_Done,
    // Label 27689: @2308390
    GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2308444), // Rule ID 47139 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47139,
      GIR_EraseRootFromParent_Done,
    // Label 27690: @2308444
    GIM_Reject,
    // Label 27660: @2308445
    GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2308499), // Rule ID 47092 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47092,
      GIR_EraseRootFromParent_Done,
    // Label 27691: @2308499
    GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2308553), // Rule ID 47093 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47093,
      GIR_EraseRootFromParent_Done,
    // Label 27692: @2308553
    GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2308607), // Rule ID 47158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47158,
      GIR_EraseRootFromParent_Done,
    // Label 27693: @2308607
    GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2308661), // Rule ID 47159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47159,
      GIR_EraseRootFromParent_Done,
    // Label 27694: @2308661
    GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2308715), // Rule ID 47192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47192,
      GIR_EraseRootFromParent_Done,
    // Label 27695: @2308715
    GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2308769), // Rule ID 47193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47193,
      GIR_EraseRootFromParent_Done,
    // Label 27696: @2308769
    GIM_Reject,
    // Label 27661: @2308770
    GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2308873),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2308829), // Rule ID 47052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47052,
        GIR_EraseRootFromParent_Done,
      // Label 27698: @2308829
      GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2308872), // Rule ID 47053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47053,
        GIR_EraseRootFromParent_Done,
      // Label 27699: @2308872
      GIM_Reject,
    // Label 27697: @2308873
    GIM_Reject,
    // Label 27662: @2308874
    GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2308928), // Rule ID 47076 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47076,
      GIR_EraseRootFromParent_Done,
    // Label 27700: @2308928
    GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2308982), // Rule ID 47077 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47077,
      GIR_EraseRootFromParent_Done,
    // Label 27701: @2308982
    GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2309036), // Rule ID 47142 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47142,
      GIR_EraseRootFromParent_Done,
    // Label 27702: @2309036
    GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2309090), // Rule ID 47143 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47143,
      GIR_EraseRootFromParent_Done,
    // Label 27703: @2309090
    GIM_Reject,
    // Label 27663: @2309091
    GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2309145), // Rule ID 47096 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47096,
      GIR_EraseRootFromParent_Done,
    // Label 27704: @2309145
    GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2309199), // Rule ID 47097 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47097,
      GIR_EraseRootFromParent_Done,
    // Label 27705: @2309199
    GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2309253), // Rule ID 47162 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47162,
      GIR_EraseRootFromParent_Done,
    // Label 27706: @2309253
    GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2309307), // Rule ID 47163 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47163,
      GIR_EraseRootFromParent_Done,
    // Label 27707: @2309307
    GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2309361), // Rule ID 47196 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47196,
      GIR_EraseRootFromParent_Done,
    // Label 27708: @2309361
    GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2309415), // Rule ID 47197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47197,
      GIR_EraseRootFromParent_Done,
    // Label 27709: @2309415
    GIM_Reject,
    // Label 27664: @2309416
    GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2309519),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2309475), // Rule ID 47056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47056,
        GIR_EraseRootFromParent_Done,
      // Label 27711: @2309475
      GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2309518), // Rule ID 47057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47057,
        GIR_EraseRootFromParent_Done,
      // Label 27712: @2309518
      GIM_Reject,
    // Label 27710: @2309519
    GIM_Reject,
    // Label 27665: @2309520
    GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2309574), // Rule ID 47080 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47080,
      GIR_EraseRootFromParent_Done,
    // Label 27713: @2309574
    GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2309628), // Rule ID 47081 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47081,
      GIR_EraseRootFromParent_Done,
    // Label 27714: @2309628
    GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2309682), // Rule ID 47146 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47146,
      GIR_EraseRootFromParent_Done,
    // Label 27715: @2309682
    GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2309736), // Rule ID 47147 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47147,
      GIR_EraseRootFromParent_Done,
    // Label 27716: @2309736
    GIM_Reject,
    // Label 27666: @2309737
    GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2309791), // Rule ID 47100 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47100,
      GIR_EraseRootFromParent_Done,
    // Label 27717: @2309791
    GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2309845), // Rule ID 47101 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47101,
      GIR_EraseRootFromParent_Done,
    // Label 27718: @2309845
    GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2309899), // Rule ID 47166 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47166,
      GIR_EraseRootFromParent_Done,
    // Label 27719: @2309899
    GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2309953), // Rule ID 47167 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47167,
      GIR_EraseRootFromParent_Done,
    // Label 27720: @2309953
    GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2310007), // Rule ID 47200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47200,
      GIR_EraseRootFromParent_Done,
    // Label 27721: @2310007
    GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2310061), // Rule ID 47201 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47201,
      GIR_EraseRootFromParent_Done,
    // Label 27722: @2310061
    GIM_Reject,
    // Label 27667: @2310062
    GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2310165),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2310121), // Rule ID 47060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47060,
        GIR_EraseRootFromParent_Done,
      // Label 27724: @2310121
      GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2310164), // Rule ID 47061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47061,
        GIR_EraseRootFromParent_Done,
      // Label 27725: @2310164
      GIM_Reject,
    // Label 27723: @2310165
    GIM_Reject,
    // Label 27668: @2310166
    GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2310220), // Rule ID 47084 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47084,
      GIR_EraseRootFromParent_Done,
    // Label 27726: @2310220
    GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2310274), // Rule ID 47085 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47085,
      GIR_EraseRootFromParent_Done,
    // Label 27727: @2310274
    GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2310328), // Rule ID 47150 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47150,
      GIR_EraseRootFromParent_Done,
    // Label 27728: @2310328
    GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2310382), // Rule ID 47151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47151,
      GIR_EraseRootFromParent_Done,
    // Label 27729: @2310382
    GIM_Reject,
    // Label 27669: @2310383
    GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2310486),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2310442), // Rule ID 47064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47064,
        GIR_EraseRootFromParent_Done,
      // Label 27731: @2310442
      GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2310485), // Rule ID 47065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47065,
        GIR_EraseRootFromParent_Done,
      // Label 27732: @2310485
      GIM_Reject,
    // Label 27730: @2310486
    GIM_Reject,
    // Label 27670: @2310487
    GIM_Reject,
    // Label 40: @2310488
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 27750*/ GIMT_Encode4(2313962),
    /*GILLT_s32*//*Label 27733*/ GIMT_Encode4(2310615),
    /*GILLT_s64*//*Label 27734*/ GIMT_Encode4(2310789), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 27735*/ GIMT_Encode4(2310953),
    /*GILLT_nxv1s32*//*Label 27736*/ GIMT_Encode4(2311057),
    /*GILLT_nxv1s64*//*Label 27737*/ GIMT_Encode4(2311274), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 27738*/ GIMT_Encode4(2311599),
    /*GILLT_nxv2s32*//*Label 27739*/ GIMT_Encode4(2311703),
    /*GILLT_nxv2s64*//*Label 27740*/ GIMT_Encode4(2311920), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 27741*/ GIMT_Encode4(2312245),
    /*GILLT_nxv4s32*//*Label 27742*/ GIMT_Encode4(2312349),
    /*GILLT_nxv4s64*//*Label 27743*/ GIMT_Encode4(2312566), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 27744*/ GIMT_Encode4(2312891),
    /*GILLT_nxv8s32*//*Label 27745*/ GIMT_Encode4(2312995),
    /*GILLT_nxv8s64*//*Label 27746*/ GIMT_Encode4(2313212), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 27747*/ GIMT_Encode4(2313537),
    /*GILLT_nxv16s32*//*Label 27748*/ GIMT_Encode4(2313641), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 27749*/ GIMT_Encode4(2313858),
    // Label 27733: @2310615
    GIM_Try, /*On fail goto*//*Label 27751*/ GIMT_Encode4(2310788),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27752*/ GIMT_Encode4(2310673), // Rule ID 64081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
        // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64081,
        GIR_EraseRootFromParent_Done,
      // Label 27752: @2310673
      GIM_Try, /*On fail goto*//*Label 27753*/ GIMT_Encode4(2310715), // Rule ID 64083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
        // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64083,
        GIR_EraseRootFromParent_Done,
      // Label 27753: @2310715
      GIM_Try, /*On fail goto*//*Label 27754*/ GIMT_Encode4(2310757), // Rule ID 64084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
        // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64084,
        GIR_EraseRootFromParent_Done,
      // Label 27754: @2310757
      GIM_Try, /*On fail goto*//*Label 27755*/ GIMT_Encode4(2310772), // Rule ID 64086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64086,
        GIR_Done,
      // Label 27755: @2310772
      GIM_Try, /*On fail goto*//*Label 27756*/ GIMT_Encode4(2310787), // Rule ID 64087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64087,
        GIR_Done,
      // Label 27756: @2310787
      GIM_Reject,
    // Label 27751: @2310788
    GIM_Reject,
    // Label 27734: @2310789
    GIM_Try, /*On fail goto*//*Label 27757*/ GIMT_Encode4(2310820), // Rule ID 64071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64071,
      GIR_EraseRootFromParent_Done,
    // Label 27757: @2310820
    GIM_Try, /*On fail goto*//*Label 27758*/ GIMT_Encode4(2310873), // Rule ID 64080 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64080,
      GIR_EraseRootFromParent_Done,
    // Label 27758: @2310873
    GIM_Try, /*On fail goto*//*Label 27759*/ GIMT_Encode4(2310926), // Rule ID 64082 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64082,
      GIR_EraseRootFromParent_Done,
    // Label 27759: @2310926
    GIM_Try, /*On fail goto*//*Label 27760*/ GIMT_Encode4(2310952), // Rule ID 64088 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64088,
      GIR_Done,
    // Label 27760: @2310952
    GIM_Reject,
    // Label 27735: @2310953
    GIM_Try, /*On fail goto*//*Label 27761*/ GIMT_Encode4(2311056),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27762*/ GIMT_Encode4(2311012), // Rule ID 47102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47102,
        GIR_EraseRootFromParent_Done,
      // Label 27762: @2311012
      GIM_Try, /*On fail goto*//*Label 27763*/ GIMT_Encode4(2311055), // Rule ID 47103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47103,
        GIR_EraseRootFromParent_Done,
      // Label 27763: @2311055
      GIM_Reject,
    // Label 27761: @2311056
    GIM_Reject,
    // Label 27736: @2311057
    GIM_Try, /*On fail goto*//*Label 27764*/ GIMT_Encode4(2311111), // Rule ID 47114 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47114,
      GIR_EraseRootFromParent_Done,
    // Label 27764: @2311111
    GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2311165), // Rule ID 47115 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47115,
      GIR_EraseRootFromParent_Done,
    // Label 27765: @2311165
    GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2311219), // Rule ID 47168 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47168,
      GIR_EraseRootFromParent_Done,
    // Label 27766: @2311219
    GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2311273), // Rule ID 47169 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47169,
      GIR_EraseRootFromParent_Done,
    // Label 27767: @2311273
    GIM_Reject,
    // Label 27737: @2311274
    GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2311328), // Rule ID 47124 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47124,
      GIR_EraseRootFromParent_Done,
    // Label 27768: @2311328
    GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2311382), // Rule ID 47125 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47125,
      GIR_EraseRootFromParent_Done,
    // Label 27769: @2311382
    GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2311436), // Rule ID 47178 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47178,
      GIR_EraseRootFromParent_Done,
    // Label 27770: @2311436
    GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2311490), // Rule ID 47179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47179,
      GIR_EraseRootFromParent_Done,
    // Label 27771: @2311490
    GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2311544), // Rule ID 47202 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47202,
      GIR_EraseRootFromParent_Done,
    // Label 27772: @2311544
    GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2311598), // Rule ID 47203 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47203,
      GIR_EraseRootFromParent_Done,
    // Label 27773: @2311598
    GIM_Reject,
    // Label 27738: @2311599
    GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2311702),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2311658), // Rule ID 47104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47104,
        GIR_EraseRootFromParent_Done,
      // Label 27775: @2311658
      GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2311701), // Rule ID 47105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47105,
        GIR_EraseRootFromParent_Done,
      // Label 27776: @2311701
      GIM_Reject,
    // Label 27774: @2311702
    GIM_Reject,
    // Label 27739: @2311703
    GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2311757), // Rule ID 47116 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47116,
      GIR_EraseRootFromParent_Done,
    // Label 27777: @2311757
    GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2311811), // Rule ID 47117 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47117,
      GIR_EraseRootFromParent_Done,
    // Label 27778: @2311811
    GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2311865), // Rule ID 47170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47170,
      GIR_EraseRootFromParent_Done,
    // Label 27779: @2311865
    GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2311919), // Rule ID 47171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47171,
      GIR_EraseRootFromParent_Done,
    // Label 27780: @2311919
    GIM_Reject,
    // Label 27740: @2311920
    GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2311974), // Rule ID 47126 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47126,
      GIR_EraseRootFromParent_Done,
    // Label 27781: @2311974
    GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2312028), // Rule ID 47127 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47127,
      GIR_EraseRootFromParent_Done,
    // Label 27782: @2312028
    GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2312082), // Rule ID 47180 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47180,
      GIR_EraseRootFromParent_Done,
    // Label 27783: @2312082
    GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2312136), // Rule ID 47181 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47181,
      GIR_EraseRootFromParent_Done,
    // Label 27784: @2312136
    GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2312190), // Rule ID 47204 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47204,
      GIR_EraseRootFromParent_Done,
    // Label 27785: @2312190
    GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2312244), // Rule ID 47205 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47205,
      GIR_EraseRootFromParent_Done,
    // Label 27786: @2312244
    GIM_Reject,
    // Label 27741: @2312245
    GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2312348),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2312304), // Rule ID 47106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47106,
        GIR_EraseRootFromParent_Done,
      // Label 27788: @2312304
      GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2312347), // Rule ID 47107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47107,
        GIR_EraseRootFromParent_Done,
      // Label 27789: @2312347
      GIM_Reject,
    // Label 27787: @2312348
    GIM_Reject,
    // Label 27742: @2312349
    GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2312403), // Rule ID 47118 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47118,
      GIR_EraseRootFromParent_Done,
    // Label 27790: @2312403
    GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2312457), // Rule ID 47119 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47119,
      GIR_EraseRootFromParent_Done,
    // Label 27791: @2312457
    GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2312511), // Rule ID 47172 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47172,
      GIR_EraseRootFromParent_Done,
    // Label 27792: @2312511
    GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2312565), // Rule ID 47173 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47173,
      GIR_EraseRootFromParent_Done,
    // Label 27793: @2312565
    GIM_Reject,
    // Label 27743: @2312566
    GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2312620), // Rule ID 47128 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47128,
      GIR_EraseRootFromParent_Done,
    // Label 27794: @2312620
    GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2312674), // Rule ID 47129 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47129,
      GIR_EraseRootFromParent_Done,
    // Label 27795: @2312674
    GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2312728), // Rule ID 47182 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47182,
      GIR_EraseRootFromParent_Done,
    // Label 27796: @2312728
    GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2312782), // Rule ID 47183 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47183,
      GIR_EraseRootFromParent_Done,
    // Label 27797: @2312782
    GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2312836), // Rule ID 47206 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47206,
      GIR_EraseRootFromParent_Done,
    // Label 27798: @2312836
    GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2312890), // Rule ID 47207 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47207,
      GIR_EraseRootFromParent_Done,
    // Label 27799: @2312890
    GIM_Reject,
    // Label 27744: @2312891
    GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2312994),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2312950), // Rule ID 47108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47108,
        GIR_EraseRootFromParent_Done,
      // Label 27801: @2312950
      GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2312993), // Rule ID 47109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47109,
        GIR_EraseRootFromParent_Done,
      // Label 27802: @2312993
      GIM_Reject,
    // Label 27800: @2312994
    GIM_Reject,
    // Label 27745: @2312995
    GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2313049), // Rule ID 47120 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47120,
      GIR_EraseRootFromParent_Done,
    // Label 27803: @2313049
    GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2313103), // Rule ID 47121 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47121,
      GIR_EraseRootFromParent_Done,
    // Label 27804: @2313103
    GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2313157), // Rule ID 47174 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47174,
      GIR_EraseRootFromParent_Done,
    // Label 27805: @2313157
    GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2313211), // Rule ID 47175 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47175,
      GIR_EraseRootFromParent_Done,
    // Label 27806: @2313211
    GIM_Reject,
    // Label 27746: @2313212
    GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2313266), // Rule ID 47130 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47130,
      GIR_EraseRootFromParent_Done,
    // Label 27807: @2313266
    GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2313320), // Rule ID 47131 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47131,
      GIR_EraseRootFromParent_Done,
    // Label 27808: @2313320
    GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2313374), // Rule ID 47184 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47184,
      GIR_EraseRootFromParent_Done,
    // Label 27809: @2313374
    GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2313428), // Rule ID 47185 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47185,
      GIR_EraseRootFromParent_Done,
    // Label 27810: @2313428
    GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2313482), // Rule ID 47208 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47208,
      GIR_EraseRootFromParent_Done,
    // Label 27811: @2313482
    GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2313536), // Rule ID 47209 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47209,
      GIR_EraseRootFromParent_Done,
    // Label 27812: @2313536
    GIM_Reject,
    // Label 27747: @2313537
    GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2313640),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2313596), // Rule ID 47110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47110,
        GIR_EraseRootFromParent_Done,
      // Label 27814: @2313596
      GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2313639), // Rule ID 47111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47111,
        GIR_EraseRootFromParent_Done,
      // Label 27815: @2313639
      GIM_Reject,
    // Label 27813: @2313640
    GIM_Reject,
    // Label 27748: @2313641
    GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2313695), // Rule ID 47122 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47122,
      GIR_EraseRootFromParent_Done,
    // Label 27816: @2313695
    GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2313749), // Rule ID 47123 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47123,
      GIR_EraseRootFromParent_Done,
    // Label 27817: @2313749
    GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2313803), // Rule ID 47176 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47176,
      GIR_EraseRootFromParent_Done,
    // Label 27818: @2313803
    GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2313857), // Rule ID 47177 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47177,
      GIR_EraseRootFromParent_Done,
    // Label 27819: @2313857
    GIM_Reject,
    // Label 27749: @2313858
    GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2313961),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2313917), // Rule ID 47112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47112,
        GIR_EraseRootFromParent_Done,
      // Label 27821: @2313917
      GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2313960), // Rule ID 47113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47113,
        GIR_EraseRootFromParent_Done,
      // Label 27822: @2313960
      GIM_Reject,
    // Label 27820: @2313961
    GIM_Reject,
    // Label 27750: @2313962
    GIM_Reject,
    // Label 41: @2313963
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 27825*/ GIMT_Encode4(2314511),
    /*GILLT_s32*//*Label 27823*/ GIMT_Encode4(2313982),
    /*GILLT_s64*//*Label 27824*/ GIMT_Encode4(2314214),
    // Label 27823: @2313982
    GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2314213),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2314026), // Rule ID 63883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63883,
        GIR_EraseRootFromParent_Done,
      // Label 27827: @2314026
      GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2314054), // Rule ID 63885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63885,
        GIR_EraseRootFromParent_Done,
      // Label 27828: @2314054
      GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2314082), // Rule ID 2383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2383,
        GIR_EraseRootFromParent_Done,
      // Label 27829: @2314082
      GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2314110), // Rule ID 2385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2385,
        GIR_EraseRootFromParent_Done,
      // Label 27830: @2314110
      GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2314144), // Rule ID 61966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61966,
        GIR_EraseRootFromParent_Done,
      // Label 27831: @2314144
      GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2314178), // Rule ID 61968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61968,
        GIR_EraseRootFromParent_Done,
      // Label 27832: @2314178
      GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2314212), // Rule ID 61970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61970,
        GIR_EraseRootFromParent_Done,
      // Label 27833: @2314212
      GIM_Reject,
    // Label 27826: @2314213
    GIM_Reject,
    // Label 27824: @2314214
    GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2314510),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2314258), // Rule ID 63882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63882,
        GIR_EraseRootFromParent_Done,
      // Label 27835: @2314258
      GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2314286), // Rule ID 63884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63884,
        GIR_EraseRootFromParent_Done,
      // Label 27836: @2314286
      GIM_Try, /*On fail goto*//*Label 27837*/ GIMT_Encode4(2314317), // Rule ID 256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 256,
        GIR_EraseRootFromParent_Done,
      // Label 27837: @2314317
      GIM_Try, /*On fail goto*//*Label 27838*/ GIMT_Encode4(2314345), // Rule ID 2382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2382,
        GIR_EraseRootFromParent_Done,
      // Label 27838: @2314345
      GIM_Try, /*On fail goto*//*Label 27839*/ GIMT_Encode4(2314373), // Rule ID 2384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2384,
        GIR_EraseRootFromParent_Done,
      // Label 27839: @2314373
      GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2314407), // Rule ID 61964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 31:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61964,
        GIR_EraseRootFromParent_Done,
      // Label 27840: @2314407
      GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2314441), // Rule ID 61965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61965,
        GIR_EraseRootFromParent_Done,
      // Label 27841: @2314441
      GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2314475), // Rule ID 61967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61967,
        GIR_EraseRootFromParent_Done,
      // Label 27842: @2314475
      GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2314509), // Rule ID 61969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61969,
        GIR_EraseRootFromParent_Done,
      // Label 27843: @2314509
      GIM_Reject,
    // Label 27834: @2314510
    GIM_Reject,
    // Label 27825: @2314511
    GIM_Reject,
    // Label 42: @2314512
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 27861*/ GIMT_Encode4(2318198),
    /*GILLT_s32*//*Label 27844*/ GIMT_Encode4(2314639),
    /*GILLT_s64*//*Label 27845*/ GIMT_Encode4(2314935), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 27846*/ GIMT_Encode4(2315189),
    /*GILLT_nxv1s32*//*Label 27847*/ GIMT_Encode4(2315293),
    /*GILLT_nxv1s64*//*Label 27848*/ GIMT_Encode4(2315510), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 27849*/ GIMT_Encode4(2315835),
    /*GILLT_nxv2s32*//*Label 27850*/ GIMT_Encode4(2315939),
    /*GILLT_nxv2s64*//*Label 27851*/ GIMT_Encode4(2316156), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 27852*/ GIMT_Encode4(2316481),
    /*GILLT_nxv4s32*//*Label 27853*/ GIMT_Encode4(2316585),
    /*GILLT_nxv4s64*//*Label 27854*/ GIMT_Encode4(2316802), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 27855*/ GIMT_Encode4(2317127),
    /*GILLT_nxv8s32*//*Label 27856*/ GIMT_Encode4(2317231),
    /*GILLT_nxv8s64*//*Label 27857*/ GIMT_Encode4(2317448), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 27858*/ GIMT_Encode4(2317773),
    /*GILLT_nxv16s32*//*Label 27859*/ GIMT_Encode4(2317877), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 27860*/ GIMT_Encode4(2318094),
    // Label 27844: @2314639
    GIM_Try, /*On fail goto*//*Label 27862*/ GIMT_Encode4(2314934),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27863*/ GIMT_Encode4(2314697), // Rule ID 64076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64076,
        GIR_EraseRootFromParent_Done,
      // Label 27863: @2314697
      GIM_Try, /*On fail goto*//*Label 27864*/ GIMT_Encode4(2314739), // Rule ID 64078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64078,
        GIR_EraseRootFromParent_Done,
      // Label 27864: @2314739
      GIM_Try, /*On fail goto*//*Label 27865*/ GIMT_Encode4(2314781), // Rule ID 64079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64079,
        GIR_EraseRootFromParent_Done,
      // Label 27865: @2314781
      GIM_Try, /*On fail goto*//*Label 27866*/ GIMT_Encode4(2314796), // Rule ID 64089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64089,
        GIR_Done,
      // Label 27866: @2314796
      GIM_Try, /*On fail goto*//*Label 27867*/ GIMT_Encode4(2314811), // Rule ID 64090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64090,
        GIR_Done,
      // Label 27867: @2314811
      GIM_Try, /*On fail goto*//*Label 27868*/ GIMT_Encode4(2314826), // Rule ID 64092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64092,
        GIR_Done,
      // Label 27868: @2314826
      GIM_Try, /*On fail goto*//*Label 27869*/ GIMT_Encode4(2314841), // Rule ID 64093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64093,
        GIR_Done,
      // Label 27869: @2314841
      GIM_Try, /*On fail goto*//*Label 27870*/ GIMT_Encode4(2314864), // Rule ID 64094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64094,
        GIR_EraseRootFromParent_Done,
      // Label 27870: @2314864
      GIM_Try, /*On fail goto*//*Label 27871*/ GIMT_Encode4(2314887), // Rule ID 64095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64095,
        GIR_EraseRootFromParent_Done,
      // Label 27871: @2314887
      GIM_Try, /*On fail goto*//*Label 27872*/ GIMT_Encode4(2314910), // Rule ID 64097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64097,
        GIR_EraseRootFromParent_Done,
      // Label 27872: @2314910
      GIM_Try, /*On fail goto*//*Label 27873*/ GIMT_Encode4(2314933), // Rule ID 64098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
        // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64098,
        GIR_EraseRootFromParent_Done,
      // Label 27873: @2314933
      GIM_Reject,
    // Label 27862: @2314934
    GIM_Reject,
    // Label 27845: @2314935
    GIM_Try, /*On fail goto*//*Label 27874*/ GIMT_Encode4(2314988), // Rule ID 64074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64074,
      GIR_EraseRootFromParent_Done,
    // Label 27874: @2314988
    GIM_Try, /*On fail goto*//*Label 27875*/ GIMT_Encode4(2315041), // Rule ID 64075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64075,
      GIR_EraseRootFromParent_Done,
    // Label 27875: @2315041
    GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2315094), // Rule ID 64077 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64077,
      GIR_EraseRootFromParent_Done,
    // Label 27876: @2315094
    GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2315128), // Rule ID 64085 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64085,
      GIR_EraseRootFromParent_Done,
    // Label 27877: @2315128
    GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2315154), // Rule ID 64091 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64091,
      GIR_Done,
    // Label 27878: @2315154
    GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2315188), // Rule ID 64096 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64096,
      GIR_EraseRootFromParent_Done,
    // Label 27879: @2315188
    GIM_Reject,
    // Label 27846: @2315189
    GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2315292),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2315248), // Rule ID 45582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45582,
        GIR_EraseRootFromParent_Done,
      // Label 27881: @2315248
      GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2315291), // Rule ID 45583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45583,
        GIR_EraseRootFromParent_Done,
      // Label 27882: @2315291
      GIM_Reject,
    // Label 27880: @2315292
    GIM_Reject,
    // Label 27847: @2315293
    GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2315347), // Rule ID 47066 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47066,
      GIR_EraseRootFromParent_Done,
    // Label 27883: @2315347
    GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2315401), // Rule ID 47067 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47067,
      GIR_EraseRootFromParent_Done,
    // Label 27884: @2315401
    GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2315455), // Rule ID 47132 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47132,
      GIR_EraseRootFromParent_Done,
    // Label 27885: @2315455
    GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2315509), // Rule ID 47133 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47133,
      GIR_EraseRootFromParent_Done,
    // Label 27886: @2315509
    GIM_Reject,
    // Label 27848: @2315510
    GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2315564), // Rule ID 47086 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47086,
      GIR_EraseRootFromParent_Done,
    // Label 27887: @2315564
    GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2315618), // Rule ID 47087 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47087,
      GIR_EraseRootFromParent_Done,
    // Label 27888: @2315618
    GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2315672), // Rule ID 47152 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47152,
      GIR_EraseRootFromParent_Done,
    // Label 27889: @2315672
    GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2315726), // Rule ID 47153 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47153,
      GIR_EraseRootFromParent_Done,
    // Label 27890: @2315726
    GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2315780), // Rule ID 47186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47186,
      GIR_EraseRootFromParent_Done,
    // Label 27891: @2315780
    GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2315834), // Rule ID 47187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47187,
      GIR_EraseRootFromParent_Done,
    // Label 27892: @2315834
    GIM_Reject,
    // Label 27849: @2315835
    GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2315938),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2315894), // Rule ID 47046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47046,
        GIR_EraseRootFromParent_Done,
      // Label 27894: @2315894
      GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2315937), // Rule ID 47047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47047,
        GIR_EraseRootFromParent_Done,
      // Label 27895: @2315937
      GIM_Reject,
    // Label 27893: @2315938
    GIM_Reject,
    // Label 27850: @2315939
    GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2315993), // Rule ID 47070 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47070,
      GIR_EraseRootFromParent_Done,
    // Label 27896: @2315993
    GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2316047), // Rule ID 47071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47071,
      GIR_EraseRootFromParent_Done,
    // Label 27897: @2316047
    GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2316101), // Rule ID 47136 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47136,
      GIR_EraseRootFromParent_Done,
    // Label 27898: @2316101
    GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2316155), // Rule ID 47137 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47137,
      GIR_EraseRootFromParent_Done,
    // Label 27899: @2316155
    GIM_Reject,
    // Label 27851: @2316156
    GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2316210), // Rule ID 47090 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47090,
      GIR_EraseRootFromParent_Done,
    // Label 27900: @2316210
    GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2316264), // Rule ID 47091 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47091,
      GIR_EraseRootFromParent_Done,
    // Label 27901: @2316264
    GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2316318), // Rule ID 47156 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47156,
      GIR_EraseRootFromParent_Done,
    // Label 27902: @2316318
    GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2316372), // Rule ID 47157 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47157,
      GIR_EraseRootFromParent_Done,
    // Label 27903: @2316372
    GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2316426), // Rule ID 47190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47190,
      GIR_EraseRootFromParent_Done,
    // Label 27904: @2316426
    GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2316480), // Rule ID 47191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47191,
      GIR_EraseRootFromParent_Done,
    // Label 27905: @2316480
    GIM_Reject,
    // Label 27852: @2316481
    GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2316584),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2316540), // Rule ID 47050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47050,
        GIR_EraseRootFromParent_Done,
      // Label 27907: @2316540
      GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2316583), // Rule ID 47051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47051,
        GIR_EraseRootFromParent_Done,
      // Label 27908: @2316583
      GIM_Reject,
    // Label 27906: @2316584
    GIM_Reject,
    // Label 27853: @2316585
    GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2316639), // Rule ID 47074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47074,
      GIR_EraseRootFromParent_Done,
    // Label 27909: @2316639
    GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2316693), // Rule ID 47075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47075,
      GIR_EraseRootFromParent_Done,
    // Label 27910: @2316693
    GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2316747), // Rule ID 47140 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47140,
      GIR_EraseRootFromParent_Done,
    // Label 27911: @2316747
    GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2316801), // Rule ID 47141 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47141,
      GIR_EraseRootFromParent_Done,
    // Label 27912: @2316801
    GIM_Reject,
    // Label 27854: @2316802
    GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2316856), // Rule ID 47094 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47094,
      GIR_EraseRootFromParent_Done,
    // Label 27913: @2316856
    GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2316910), // Rule ID 47095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47095,
      GIR_EraseRootFromParent_Done,
    // Label 27914: @2316910
    GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2316964), // Rule ID 47160 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47160,
      GIR_EraseRootFromParent_Done,
    // Label 27915: @2316964
    GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2317018), // Rule ID 47161 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47161,
      GIR_EraseRootFromParent_Done,
    // Label 27916: @2317018
    GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2317072), // Rule ID 47194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47194,
      GIR_EraseRootFromParent_Done,
    // Label 27917: @2317072
    GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2317126), // Rule ID 47195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47195,
      GIR_EraseRootFromParent_Done,
    // Label 27918: @2317126
    GIM_Reject,
    // Label 27855: @2317127
    GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2317230),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2317186), // Rule ID 47054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47054,
        GIR_EraseRootFromParent_Done,
      // Label 27920: @2317186
      GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2317229), // Rule ID 47055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47055,
        GIR_EraseRootFromParent_Done,
      // Label 27921: @2317229
      GIM_Reject,
    // Label 27919: @2317230
    GIM_Reject,
    // Label 27856: @2317231
    GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2317285), // Rule ID 47078 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47078,
      GIR_EraseRootFromParent_Done,
    // Label 27922: @2317285
    GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2317339), // Rule ID 47079 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47079,
      GIR_EraseRootFromParent_Done,
    // Label 27923: @2317339
    GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2317393), // Rule ID 47144 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47144,
      GIR_EraseRootFromParent_Done,
    // Label 27924: @2317393
    GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2317447), // Rule ID 47145 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47145,
      GIR_EraseRootFromParent_Done,
    // Label 27925: @2317447
    GIM_Reject,
    // Label 27857: @2317448
    GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2317502), // Rule ID 47098 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47098,
      GIR_EraseRootFromParent_Done,
    // Label 27926: @2317502
    GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2317556), // Rule ID 47099 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47099,
      GIR_EraseRootFromParent_Done,
    // Label 27927: @2317556
    GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2317610), // Rule ID 47164 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47164,
      GIR_EraseRootFromParent_Done,
    // Label 27928: @2317610
    GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2317664), // Rule ID 47165 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47165,
      GIR_EraseRootFromParent_Done,
    // Label 27929: @2317664
    GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2317718), // Rule ID 47198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47198,
      GIR_EraseRootFromParent_Done,
    // Label 27930: @2317718
    GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2317772), // Rule ID 47199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47199,
      GIR_EraseRootFromParent_Done,
    // Label 27931: @2317772
    GIM_Reject,
    // Label 27858: @2317773
    GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2317876),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2317832), // Rule ID 47058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47058,
        GIR_EraseRootFromParent_Done,
      // Label 27933: @2317832
      GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2317875), // Rule ID 47059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47059,
        GIR_EraseRootFromParent_Done,
      // Label 27934: @2317875
      GIM_Reject,
    // Label 27932: @2317876
    GIM_Reject,
    // Label 27859: @2317877
    GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2317931), // Rule ID 47082 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47082,
      GIR_EraseRootFromParent_Done,
    // Label 27935: @2317931
    GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2317985), // Rule ID 47083 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47083,
      GIR_EraseRootFromParent_Done,
    // Label 27936: @2317985
    GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2318039), // Rule ID 47148 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47148,
      GIR_EraseRootFromParent_Done,
    // Label 27937: @2318039
    GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2318093), // Rule ID 47149 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 47149,
      GIR_EraseRootFromParent_Done,
    // Label 27938: @2318093
    GIM_Reject,
    // Label 27860: @2318094
    GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2318197),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2318153), // Rule ID 47062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47062,
        GIR_EraseRootFromParent_Done,
      // Label 27940: @2318153
      GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2318196), // Rule ID 47063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47063,
        GIR_EraseRootFromParent_Done,
      // Label 27941: @2318196
      GIM_Reject,
    // Label 27939: @2318197
    GIM_Reject,
    // Label 27861: @2318198
    GIM_Reject,
    // Label 43: @2318199
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 27966*/ GIMT_Encode4(2321272),
    /*GILLT_s32*//*Label 27942*/ GIMT_Encode4(2318334),
    /*GILLT_s64*//*Label 27943*/ GIMT_Encode4(2318459), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 27944*/ GIMT_Encode4(2318742),
    /*GILLT_nxv1s16*//*Label 27945*/ GIMT_Encode4(2318857),
    /*GILLT_nxv1s32*//*Label 27946*/ GIMT_Encode4(2318972),
    /*GILLT_nxv1s64*//*Label 27947*/ GIMT_Encode4(2319087), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 27948*/ GIMT_Encode4(2319202),
    /*GILLT_nxv2s16*//*Label 27949*/ GIMT_Encode4(2319317),
    /*GILLT_nxv2s32*//*Label 27950*/ GIMT_Encode4(2319432),
    /*GILLT_nxv2s64*//*Label 27951*/ GIMT_Encode4(2319547), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 27952*/ GIMT_Encode4(2319662),
    /*GILLT_nxv4s16*//*Label 27953*/ GIMT_Encode4(2319777),
    /*GILLT_nxv4s32*//*Label 27954*/ GIMT_Encode4(2319892),
    /*GILLT_nxv4s64*//*Label 27955*/ GIMT_Encode4(2320007), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 27956*/ GIMT_Encode4(2320122),
    /*GILLT_nxv8s16*//*Label 27957*/ GIMT_Encode4(2320237),
    /*GILLT_nxv8s32*//*Label 27958*/ GIMT_Encode4(2320352),
    /*GILLT_nxv8s64*//*Label 27959*/ GIMT_Encode4(2320467), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 27960*/ GIMT_Encode4(2320582),
    /*GILLT_nxv16s16*//*Label 27961*/ GIMT_Encode4(2320697),
    /*GILLT_nxv16s32*//*Label 27962*/ GIMT_Encode4(2320812), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 27963*/ GIMT_Encode4(2320927),
    /*GILLT_nxv32s16*//*Label 27964*/ GIMT_Encode4(2321042), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 27965*/ GIMT_Encode4(2321157),
    // Label 27942: @2318334
    GIM_Try, /*On fail goto*//*Label 27967*/ GIMT_Encode4(2318458),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27968*/ GIMT_Encode4(2318386), // Rule ID 2339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2339,
        GIR_EraseRootFromParent_Done,
      // Label 27968: @2318386
      GIM_Try, /*On fail goto*//*Label 27969*/ GIMT_Encode4(2318424), // Rule ID 91 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 91,
        GIR_EraseRootFromParent_Done,
      // Label 27969: @2318424
      GIM_Try, /*On fail goto*//*Label 27970*/ GIMT_Encode4(2318457), // Rule ID 105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 105,
        GIR_EraseRootFromParent_Done,
      // Label 27970: @2318457
      GIM_Reject,
    // Label 27967: @2318458
    GIM_Reject,
    // Label 27943: @2318459
    GIM_Try, /*On fail goto*//*Label 27971*/ GIMT_Encode4(2318741),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27972*/ GIMT_Encode4(2318564), // Rule ID 253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 253,
        GIR_EraseRootFromParent_Done,
      // Label 27972: @2318564
      GIM_Try, /*On fail goto*//*Label 27973*/ GIMT_Encode4(2318632), // Rule ID 2457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2457,
        GIR_EraseRootFromParent_Done,
      // Label 27973: @2318632
      GIM_Try, /*On fail goto*//*Label 27974*/ GIMT_Encode4(2318669), // Rule ID 2338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2338,
        GIR_EraseRootFromParent_Done,
      // Label 27974: @2318669
      GIM_Try, /*On fail goto*//*Label 27975*/ GIMT_Encode4(2318707), // Rule ID 90 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 90,
        GIR_EraseRootFromParent_Done,
      // Label 27975: @2318707
      GIM_Try, /*On fail goto*//*Label 27976*/ GIMT_Encode4(2318740), // Rule ID 104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 104,
        GIR_EraseRootFromParent_Done,
      // Label 27976: @2318740
      GIM_Reject,
    // Label 27971: @2318741
    GIM_Reject,
    // Label 27944: @2318742
    GIM_Try, /*On fail goto*//*Label 27977*/ GIMT_Encode4(2318856),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27978*/ GIMT_Encode4(2318810), // Rule ID 47606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47606,
        GIR_EraseRootFromParent_Done,
      // Label 27978: @2318810
      GIM_Try, /*On fail goto*//*Label 27979*/ GIMT_Encode4(2318855), // Rule ID 47607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47607,
        GIR_EraseRootFromParent_Done,
      // Label 27979: @2318855
      GIM_Reject,
    // Label 27977: @2318856
    GIM_Reject,
    // Label 27945: @2318857
    GIM_Try, /*On fail goto*//*Label 27980*/ GIMT_Encode4(2318971),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2318925), // Rule ID 47618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47618,
        GIR_EraseRootFromParent_Done,
      // Label 27981: @2318925
      GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2318970), // Rule ID 47619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47619,
        GIR_EraseRootFromParent_Done,
      // Label 27982: @2318970
      GIM_Reject,
    // Label 27980: @2318971
    GIM_Reject,
    // Label 27946: @2318972
    GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2319086),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2319040), // Rule ID 47626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47626,
        GIR_EraseRootFromParent_Done,
      // Label 27984: @2319040
      GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2319085), // Rule ID 47627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47627,
        GIR_EraseRootFromParent_Done,
      // Label 27985: @2319085
      GIM_Reject,
    // Label 27983: @2319086
    GIM_Reject,
    // Label 27947: @2319087
    GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2319201),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2319155), // Rule ID 47642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47642,
        GIR_EraseRootFromParent_Done,
      // Label 27987: @2319155
      GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2319200), // Rule ID 47643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47643,
        GIR_EraseRootFromParent_Done,
      // Label 27988: @2319200
      GIM_Reject,
    // Label 27986: @2319201
    GIM_Reject,
    // Label 27948: @2319202
    GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2319316),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2319270), // Rule ID 47610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47610,
        GIR_EraseRootFromParent_Done,
      // Label 27990: @2319270
      GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2319315), // Rule ID 47611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47611,
        GIR_EraseRootFromParent_Done,
      // Label 27991: @2319315
      GIM_Reject,
    // Label 27989: @2319316
    GIM_Reject,
    // Label 27949: @2319317
    GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2319431),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2319385), // Rule ID 47622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47622,
        GIR_EraseRootFromParent_Done,
      // Label 27993: @2319385
      GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2319430), // Rule ID 47623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47623,
        GIR_EraseRootFromParent_Done,
      // Label 27994: @2319430
      GIM_Reject,
    // Label 27992: @2319431
    GIM_Reject,
    // Label 27950: @2319432
    GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2319546),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2319500), // Rule ID 47638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47638,
        GIR_EraseRootFromParent_Done,
      // Label 27996: @2319500
      GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2319545), // Rule ID 47639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47639,
        GIR_EraseRootFromParent_Done,
      // Label 27997: @2319545
      GIM_Reject,
    // Label 27995: @2319546
    GIM_Reject,
    // Label 27951: @2319547
    GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2319661),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2319615), // Rule ID 47682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47682,
        GIR_EraseRootFromParent_Done,
      // Label 27999: @2319615
      GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2319660), // Rule ID 47683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47683,
        GIR_EraseRootFromParent_Done,
      // Label 28000: @2319660
      GIM_Reject,
    // Label 27998: @2319661
    GIM_Reject,
    // Label 27952: @2319662
    GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2319776),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2319730), // Rule ID 47614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47614,
        GIR_EraseRootFromParent_Done,
      // Label 28002: @2319730
      GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2319775), // Rule ID 47615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47615,
        GIR_EraseRootFromParent_Done,
      // Label 28003: @2319775
      GIM_Reject,
    // Label 28001: @2319776
    GIM_Reject,
    // Label 27953: @2319777
    GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2319891),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2319845), // Rule ID 47634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47634,
        GIR_EraseRootFromParent_Done,
      // Label 28005: @2319845
      GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2319890), // Rule ID 47635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47635,
        GIR_EraseRootFromParent_Done,
      // Label 28006: @2319890
      GIM_Reject,
    // Label 28004: @2319891
    GIM_Reject,
    // Label 27954: @2319892
    GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2320006),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2319960), // Rule ID 47670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47670,
        GIR_EraseRootFromParent_Done,
      // Label 28008: @2319960
      GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2320005), // Rule ID 47671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47671,
        GIR_EraseRootFromParent_Done,
      // Label 28009: @2320005
      GIM_Reject,
    // Label 28007: @2320006
    GIM_Reject,
    // Label 27955: @2320007
    GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2320121),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2320075), // Rule ID 47686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47686,
        GIR_EraseRootFromParent_Done,
      // Label 28011: @2320075
      GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2320120), // Rule ID 47687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47687,
        GIR_EraseRootFromParent_Done,
      // Label 28012: @2320120
      GIM_Reject,
    // Label 28010: @2320121
    GIM_Reject,
    // Label 27956: @2320122
    GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2320236),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2320190), // Rule ID 47630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47630,
        GIR_EraseRootFromParent_Done,
      // Label 28014: @2320190
      GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2320235), // Rule ID 47631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47631,
        GIR_EraseRootFromParent_Done,
      // Label 28015: @2320235
      GIM_Reject,
    // Label 28013: @2320236
    GIM_Reject,
    // Label 27957: @2320237
    GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2320351),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2320305), // Rule ID 47658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47658,
        GIR_EraseRootFromParent_Done,
      // Label 28017: @2320305
      GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2320350), // Rule ID 47659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47659,
        GIR_EraseRootFromParent_Done,
      // Label 28018: @2320350
      GIM_Reject,
    // Label 28016: @2320351
    GIM_Reject,
    // Label 27958: @2320352
    GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2320466),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2320420), // Rule ID 47674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47674,
        GIR_EraseRootFromParent_Done,
      // Label 28020: @2320420
      GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2320465), // Rule ID 47675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47675,
        GIR_EraseRootFromParent_Done,
      // Label 28021: @2320465
      GIM_Reject,
    // Label 28019: @2320466
    GIM_Reject,
    // Label 27959: @2320467
    GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2320581),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2320535), // Rule ID 47690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47690,
        GIR_EraseRootFromParent_Done,
      // Label 28023: @2320535
      GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2320580), // Rule ID 47691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47691,
        GIR_EraseRootFromParent_Done,
      // Label 28024: @2320580
      GIM_Reject,
    // Label 28022: @2320581
    GIM_Reject,
    // Label 27960: @2320582
    GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2320696),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2320650), // Rule ID 47646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47646,
        GIR_EraseRootFromParent_Done,
      // Label 28026: @2320650
      GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2320695), // Rule ID 47647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47647,
        GIR_EraseRootFromParent_Done,
      // Label 28027: @2320695
      GIM_Reject,
    // Label 28025: @2320696
    GIM_Reject,
    // Label 27961: @2320697
    GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2320811),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2320765), // Rule ID 47662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47662,
        GIR_EraseRootFromParent_Done,
      // Label 28029: @2320765
      GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2320810), // Rule ID 47663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47663,
        GIR_EraseRootFromParent_Done,
      // Label 28030: @2320810
      GIM_Reject,
    // Label 28028: @2320811
    GIM_Reject,
    // Label 27962: @2320812
    GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2320926),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2320880), // Rule ID 47678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47678,
        GIR_EraseRootFromParent_Done,
      // Label 28032: @2320880
      GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2320925), // Rule ID 47679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47679,
        GIR_EraseRootFromParent_Done,
      // Label 28033: @2320925
      GIM_Reject,
    // Label 28031: @2320926
    GIM_Reject,
    // Label 27963: @2320927
    GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2321041),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2320995), // Rule ID 47650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47650,
        GIR_EraseRootFromParent_Done,
      // Label 28035: @2320995
      GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2321040), // Rule ID 47651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47651,
        GIR_EraseRootFromParent_Done,
      // Label 28036: @2321040
      GIM_Reject,
    // Label 28034: @2321041
    GIM_Reject,
    // Label 27964: @2321042
    GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2321156),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2321110), // Rule ID 47666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47666,
        GIR_EraseRootFromParent_Done,
      // Label 28038: @2321110
      GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2321155), // Rule ID 47667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47667,
        GIR_EraseRootFromParent_Done,
      // Label 28039: @2321155
      GIM_Reject,
    // Label 28037: @2321156
    GIM_Reject,
    // Label 27965: @2321157
    GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2321271),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2321225), // Rule ID 47654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47654,
        GIR_EraseRootFromParent_Done,
      // Label 28041: @2321225
      GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2321270), // Rule ID 47655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47655,
        GIR_EraseRootFromParent_Done,
      // Label 28042: @2321270
      GIM_Reject,
    // Label 28040: @2321271
    GIM_Reject,
    // Label 27966: @2321272
    GIM_Reject,
    // Label 44: @2321273
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 28067*/ GIMT_Encode4(2324178),
    /*GILLT_s32*//*Label 28043*/ GIMT_Encode4(2321408),
    /*GILLT_s64*//*Label 28044*/ GIMT_Encode4(2321492), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 28045*/ GIMT_Encode4(2321648),
    /*GILLT_nxv1s16*//*Label 28046*/ GIMT_Encode4(2321763),
    /*GILLT_nxv1s32*//*Label 28047*/ GIMT_Encode4(2321878),
    /*GILLT_nxv1s64*//*Label 28048*/ GIMT_Encode4(2321993), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 28049*/ GIMT_Encode4(2322108),
    /*GILLT_nxv2s16*//*Label 28050*/ GIMT_Encode4(2322223),
    /*GILLT_nxv2s32*//*Label 28051*/ GIMT_Encode4(2322338),
    /*GILLT_nxv2s64*//*Label 28052*/ GIMT_Encode4(2322453), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 28053*/ GIMT_Encode4(2322568),
    /*GILLT_nxv4s16*//*Label 28054*/ GIMT_Encode4(2322683),
    /*GILLT_nxv4s32*//*Label 28055*/ GIMT_Encode4(2322798),
    /*GILLT_nxv4s64*//*Label 28056*/ GIMT_Encode4(2322913), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 28057*/ GIMT_Encode4(2323028),
    /*GILLT_nxv8s16*//*Label 28058*/ GIMT_Encode4(2323143),
    /*GILLT_nxv8s32*//*Label 28059*/ GIMT_Encode4(2323258),
    /*GILLT_nxv8s64*//*Label 28060*/ GIMT_Encode4(2323373), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 28061*/ GIMT_Encode4(2323488),
    /*GILLT_nxv16s16*//*Label 28062*/ GIMT_Encode4(2323603),
    /*GILLT_nxv16s32*//*Label 28063*/ GIMT_Encode4(2323718), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 28064*/ GIMT_Encode4(2323833),
    /*GILLT_nxv32s16*//*Label 28065*/ GIMT_Encode4(2323948), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 28066*/ GIMT_Encode4(2324063),
    // Label 28043: @2321408
    GIM_Try, /*On fail goto*//*Label 28068*/ GIMT_Encode4(2321491),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28069*/ GIMT_Encode4(2321461), // Rule ID 93 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 93,
        GIR_EraseRootFromParent_Done,
      // Label 28069: @2321461
      GIM_Try, /*On fail goto*//*Label 28070*/ GIMT_Encode4(2321490), // Rule ID 107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 107,
        GIR_EraseRootFromParent_Done,
      // Label 28070: @2321490
      GIM_Reject,
    // Label 28068: @2321491
    GIM_Reject,
    // Label 28044: @2321492
    GIM_Try, /*On fail goto*//*Label 28071*/ GIMT_Encode4(2321647),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28072*/ GIMT_Encode4(2321575), // Rule ID 257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 257,
        GIR_EraseRootFromParent_Done,
      // Label 28072: @2321575
      GIM_Try, /*On fail goto*//*Label 28073*/ GIMT_Encode4(2321613), // Rule ID 92 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 92,
        GIR_EraseRootFromParent_Done,
      // Label 28073: @2321613
      GIM_Try, /*On fail goto*//*Label 28074*/ GIMT_Encode4(2321646), // Rule ID 106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 106,
        GIR_EraseRootFromParent_Done,
      // Label 28074: @2321646
      GIM_Reject,
    // Label 28071: @2321647
    GIM_Reject,
    // Label 28045: @2321648
    GIM_Try, /*On fail goto*//*Label 28075*/ GIMT_Encode4(2321762),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28076*/ GIMT_Encode4(2321716), // Rule ID 47738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47738,
        GIR_EraseRootFromParent_Done,
      // Label 28076: @2321716
      GIM_Try, /*On fail goto*//*Label 28077*/ GIMT_Encode4(2321761), // Rule ID 47739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47739,
        GIR_EraseRootFromParent_Done,
      // Label 28077: @2321761
      GIM_Reject,
    // Label 28075: @2321762
    GIM_Reject,
    // Label 28046: @2321763
    GIM_Try, /*On fail goto*//*Label 28078*/ GIMT_Encode4(2321877),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28079*/ GIMT_Encode4(2321831), // Rule ID 47750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47750,
        GIR_EraseRootFromParent_Done,
      // Label 28079: @2321831
      GIM_Try, /*On fail goto*//*Label 28080*/ GIMT_Encode4(2321876), // Rule ID 47751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47751,
        GIR_EraseRootFromParent_Done,
      // Label 28080: @2321876
      GIM_Reject,
    // Label 28078: @2321877
    GIM_Reject,
    // Label 28047: @2321878
    GIM_Try, /*On fail goto*//*Label 28081*/ GIMT_Encode4(2321992),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28082*/ GIMT_Encode4(2321946), // Rule ID 47758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47758,
        GIR_EraseRootFromParent_Done,
      // Label 28082: @2321946
      GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2321991), // Rule ID 47759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47759,
        GIR_EraseRootFromParent_Done,
      // Label 28083: @2321991
      GIM_Reject,
    // Label 28081: @2321992
    GIM_Reject,
    // Label 28048: @2321993
    GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2322107),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2322061), // Rule ID 47774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47774,
        GIR_EraseRootFromParent_Done,
      // Label 28085: @2322061
      GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2322106), // Rule ID 47775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47775,
        GIR_EraseRootFromParent_Done,
      // Label 28086: @2322106
      GIM_Reject,
    // Label 28084: @2322107
    GIM_Reject,
    // Label 28049: @2322108
    GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2322222),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2322176), // Rule ID 47742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47742,
        GIR_EraseRootFromParent_Done,
      // Label 28088: @2322176
      GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2322221), // Rule ID 47743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47743,
        GIR_EraseRootFromParent_Done,
      // Label 28089: @2322221
      GIM_Reject,
    // Label 28087: @2322222
    GIM_Reject,
    // Label 28050: @2322223
    GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2322337),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2322291), // Rule ID 47754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47754,
        GIR_EraseRootFromParent_Done,
      // Label 28091: @2322291
      GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2322336), // Rule ID 47755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47755,
        GIR_EraseRootFromParent_Done,
      // Label 28092: @2322336
      GIM_Reject,
    // Label 28090: @2322337
    GIM_Reject,
    // Label 28051: @2322338
    GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2322452),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2322406), // Rule ID 47770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47770,
        GIR_EraseRootFromParent_Done,
      // Label 28094: @2322406
      GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2322451), // Rule ID 47771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47771,
        GIR_EraseRootFromParent_Done,
      // Label 28095: @2322451
      GIM_Reject,
    // Label 28093: @2322452
    GIM_Reject,
    // Label 28052: @2322453
    GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2322567),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2322521), // Rule ID 47814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47814,
        GIR_EraseRootFromParent_Done,
      // Label 28097: @2322521
      GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2322566), // Rule ID 47815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47815,
        GIR_EraseRootFromParent_Done,
      // Label 28098: @2322566
      GIM_Reject,
    // Label 28096: @2322567
    GIM_Reject,
    // Label 28053: @2322568
    GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2322682),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2322636), // Rule ID 47746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47746,
        GIR_EraseRootFromParent_Done,
      // Label 28100: @2322636
      GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2322681), // Rule ID 47747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47747,
        GIR_EraseRootFromParent_Done,
      // Label 28101: @2322681
      GIM_Reject,
    // Label 28099: @2322682
    GIM_Reject,
    // Label 28054: @2322683
    GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2322797),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2322751), // Rule ID 47766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47766,
        GIR_EraseRootFromParent_Done,
      // Label 28103: @2322751
      GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2322796), // Rule ID 47767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47767,
        GIR_EraseRootFromParent_Done,
      // Label 28104: @2322796
      GIM_Reject,
    // Label 28102: @2322797
    GIM_Reject,
    // Label 28055: @2322798
    GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2322912),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2322866), // Rule ID 47802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47802,
        GIR_EraseRootFromParent_Done,
      // Label 28106: @2322866
      GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2322911), // Rule ID 47803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47803,
        GIR_EraseRootFromParent_Done,
      // Label 28107: @2322911
      GIM_Reject,
    // Label 28105: @2322912
    GIM_Reject,
    // Label 28056: @2322913
    GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2323027),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2322981), // Rule ID 47818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47818,
        GIR_EraseRootFromParent_Done,
      // Label 28109: @2322981
      GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2323026), // Rule ID 47819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47819,
        GIR_EraseRootFromParent_Done,
      // Label 28110: @2323026
      GIM_Reject,
    // Label 28108: @2323027
    GIM_Reject,
    // Label 28057: @2323028
    GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2323142),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2323096), // Rule ID 47762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47762,
        GIR_EraseRootFromParent_Done,
      // Label 28112: @2323096
      GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2323141), // Rule ID 47763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47763,
        GIR_EraseRootFromParent_Done,
      // Label 28113: @2323141
      GIM_Reject,
    // Label 28111: @2323142
    GIM_Reject,
    // Label 28058: @2323143
    GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2323257),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2323211), // Rule ID 47790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47790,
        GIR_EraseRootFromParent_Done,
      // Label 28115: @2323211
      GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2323256), // Rule ID 47791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47791,
        GIR_EraseRootFromParent_Done,
      // Label 28116: @2323256
      GIM_Reject,
    // Label 28114: @2323257
    GIM_Reject,
    // Label 28059: @2323258
    GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2323372),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2323326), // Rule ID 47806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47806,
        GIR_EraseRootFromParent_Done,
      // Label 28118: @2323326
      GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2323371), // Rule ID 47807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47807,
        GIR_EraseRootFromParent_Done,
      // Label 28119: @2323371
      GIM_Reject,
    // Label 28117: @2323372
    GIM_Reject,
    // Label 28060: @2323373
    GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2323487),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2323441), // Rule ID 47822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47822,
        GIR_EraseRootFromParent_Done,
      // Label 28121: @2323441
      GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2323486), // Rule ID 47823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47823,
        GIR_EraseRootFromParent_Done,
      // Label 28122: @2323486
      GIM_Reject,
    // Label 28120: @2323487
    GIM_Reject,
    // Label 28061: @2323488
    GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2323602),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2323556), // Rule ID 47778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47778,
        GIR_EraseRootFromParent_Done,
      // Label 28124: @2323556
      GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2323601), // Rule ID 47779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47779,
        GIR_EraseRootFromParent_Done,
      // Label 28125: @2323601
      GIM_Reject,
    // Label 28123: @2323602
    GIM_Reject,
    // Label 28062: @2323603
    GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2323717),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2323671), // Rule ID 47794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47794,
        GIR_EraseRootFromParent_Done,
      // Label 28127: @2323671
      GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2323716), // Rule ID 47795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47795,
        GIR_EraseRootFromParent_Done,
      // Label 28128: @2323716
      GIM_Reject,
    // Label 28126: @2323717
    GIM_Reject,
    // Label 28063: @2323718
    GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2323832),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2323786), // Rule ID 47810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47810,
        GIR_EraseRootFromParent_Done,
      // Label 28130: @2323786
      GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2323831), // Rule ID 47811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47811,
        GIR_EraseRootFromParent_Done,
      // Label 28131: @2323831
      GIM_Reject,
    // Label 28129: @2323832
    GIM_Reject,
    // Label 28064: @2323833
    GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2323947),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2323901), // Rule ID 47782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47782,
        GIR_EraseRootFromParent_Done,
      // Label 28133: @2323901
      GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2323946), // Rule ID 47783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47783,
        GIR_EraseRootFromParent_Done,
      // Label 28134: @2323946
      GIM_Reject,
    // Label 28132: @2323947
    GIM_Reject,
    // Label 28065: @2323948
    GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2324062),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2324016), // Rule ID 47798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47798,
        GIR_EraseRootFromParent_Done,
      // Label 28136: @2324016
      GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2324061), // Rule ID 47799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47799,
        GIR_EraseRootFromParent_Done,
      // Label 28137: @2324061
      GIM_Reject,
    // Label 28135: @2324062
    GIM_Reject,
    // Label 28066: @2324063
    GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2324177),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2324131), // Rule ID 47786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47786,
        GIR_EraseRootFromParent_Done,
      // Label 28139: @2324131
      GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2324176), // Rule ID 47787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47787,
        GIR_EraseRootFromParent_Done,
      // Label 28140: @2324176
      GIM_Reject,
    // Label 28138: @2324177
    GIM_Reject,
    // Label 28067: @2324178
    GIM_Reject,
    // Label 45: @2324179
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 28165*/ GIMT_Encode4(2327117),
    /*GILLT_s32*//*Label 28141*/ GIMT_Encode4(2324314),
    /*GILLT_s64*//*Label 28142*/ GIMT_Encode4(2324398), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 28143*/ GIMT_Encode4(2324587),
    /*GILLT_nxv1s16*//*Label 28144*/ GIMT_Encode4(2324702),
    /*GILLT_nxv1s32*//*Label 28145*/ GIMT_Encode4(2324817),
    /*GILLT_nxv1s64*//*Label 28146*/ GIMT_Encode4(2324932), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 28147*/ GIMT_Encode4(2325047),
    /*GILLT_nxv2s16*//*Label 28148*/ GIMT_Encode4(2325162),
    /*GILLT_nxv2s32*//*Label 28149*/ GIMT_Encode4(2325277),
    /*GILLT_nxv2s64*//*Label 28150*/ GIMT_Encode4(2325392), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 28151*/ GIMT_Encode4(2325507),
    /*GILLT_nxv4s16*//*Label 28152*/ GIMT_Encode4(2325622),
    /*GILLT_nxv4s32*//*Label 28153*/ GIMT_Encode4(2325737),
    /*GILLT_nxv4s64*//*Label 28154*/ GIMT_Encode4(2325852), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 28155*/ GIMT_Encode4(2325967),
    /*GILLT_nxv8s16*//*Label 28156*/ GIMT_Encode4(2326082),
    /*GILLT_nxv8s32*//*Label 28157*/ GIMT_Encode4(2326197),
    /*GILLT_nxv8s64*//*Label 28158*/ GIMT_Encode4(2326312), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 28159*/ GIMT_Encode4(2326427),
    /*GILLT_nxv16s16*//*Label 28160*/ GIMT_Encode4(2326542),
    /*GILLT_nxv16s32*//*Label 28161*/ GIMT_Encode4(2326657), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 28162*/ GIMT_Encode4(2326772),
    /*GILLT_nxv32s16*//*Label 28163*/ GIMT_Encode4(2326887), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 28164*/ GIMT_Encode4(2327002),
    // Label 28141: @2324314
    GIM_Try, /*On fail goto*//*Label 28166*/ GIMT_Encode4(2324397),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28167*/ GIMT_Encode4(2324367), // Rule ID 95 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 95,
        GIR_EraseRootFromParent_Done,
      // Label 28167: @2324367
      GIM_Try, /*On fail goto*//*Label 28168*/ GIMT_Encode4(2324396), // Rule ID 109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 109,
        GIR_EraseRootFromParent_Done,
      // Label 28168: @2324396
      GIM_Reject,
    // Label 28166: @2324397
    GIM_Reject,
    // Label 28142: @2324398
    GIM_Try, /*On fail goto*//*Label 28169*/ GIMT_Encode4(2324586),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28170*/ GIMT_Encode4(2324450), // Rule ID 61979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61979,
        GIR_EraseRootFromParent_Done,
      // Label 28170: @2324450
      GIM_Try, /*On fail goto*//*Label 28171*/ GIMT_Encode4(2324514), // Rule ID 259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 259,
        GIR_EraseRootFromParent_Done,
      // Label 28171: @2324514
      GIM_Try, /*On fail goto*//*Label 28172*/ GIMT_Encode4(2324552), // Rule ID 94 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 94,
        GIR_EraseRootFromParent_Done,
      // Label 28172: @2324552
      GIM_Try, /*On fail goto*//*Label 28173*/ GIMT_Encode4(2324585), // Rule ID 108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 108,
        GIR_EraseRootFromParent_Done,
      // Label 28173: @2324585
      GIM_Reject,
    // Label 28169: @2324586
    GIM_Reject,
    // Label 28143: @2324587
    GIM_Try, /*On fail goto*//*Label 28174*/ GIMT_Encode4(2324701),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28175*/ GIMT_Encode4(2324655), // Rule ID 47870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47870,
        GIR_EraseRootFromParent_Done,
      // Label 28175: @2324655
      GIM_Try, /*On fail goto*//*Label 28176*/ GIMT_Encode4(2324700), // Rule ID 47871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47871,
        GIR_EraseRootFromParent_Done,
      // Label 28176: @2324700
      GIM_Reject,
    // Label 28174: @2324701
    GIM_Reject,
    // Label 28144: @2324702
    GIM_Try, /*On fail goto*//*Label 28177*/ GIMT_Encode4(2324816),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28178*/ GIMT_Encode4(2324770), // Rule ID 47882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47882,
        GIR_EraseRootFromParent_Done,
      // Label 28178: @2324770
      GIM_Try, /*On fail goto*//*Label 28179*/ GIMT_Encode4(2324815), // Rule ID 47883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47883,
        GIR_EraseRootFromParent_Done,
      // Label 28179: @2324815
      GIM_Reject,
    // Label 28177: @2324816
    GIM_Reject,
    // Label 28145: @2324817
    GIM_Try, /*On fail goto*//*Label 28180*/ GIMT_Encode4(2324931),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28181*/ GIMT_Encode4(2324885), // Rule ID 47890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47890,
        GIR_EraseRootFromParent_Done,
      // Label 28181: @2324885
      GIM_Try, /*On fail goto*//*Label 28182*/ GIMT_Encode4(2324930), // Rule ID 47891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47891,
        GIR_EraseRootFromParent_Done,
      // Label 28182: @2324930
      GIM_Reject,
    // Label 28180: @2324931
    GIM_Reject,
    // Label 28146: @2324932
    GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2325046),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2325000), // Rule ID 47906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47906,
        GIR_EraseRootFromParent_Done,
      // Label 28184: @2325000
      GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2325045), // Rule ID 47907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47907,
        GIR_EraseRootFromParent_Done,
      // Label 28185: @2325045
      GIM_Reject,
    // Label 28183: @2325046
    GIM_Reject,
    // Label 28147: @2325047
    GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2325161),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2325115), // Rule ID 47874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47874,
        GIR_EraseRootFromParent_Done,
      // Label 28187: @2325115
      GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2325160), // Rule ID 47875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47875,
        GIR_EraseRootFromParent_Done,
      // Label 28188: @2325160
      GIM_Reject,
    // Label 28186: @2325161
    GIM_Reject,
    // Label 28148: @2325162
    GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2325276),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2325230), // Rule ID 47886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47886,
        GIR_EraseRootFromParent_Done,
      // Label 28190: @2325230
      GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2325275), // Rule ID 47887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47887,
        GIR_EraseRootFromParent_Done,
      // Label 28191: @2325275
      GIM_Reject,
    // Label 28189: @2325276
    GIM_Reject,
    // Label 28149: @2325277
    GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2325391),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2325345), // Rule ID 47902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47902,
        GIR_EraseRootFromParent_Done,
      // Label 28193: @2325345
      GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2325390), // Rule ID 47903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47903,
        GIR_EraseRootFromParent_Done,
      // Label 28194: @2325390
      GIM_Reject,
    // Label 28192: @2325391
    GIM_Reject,
    // Label 28150: @2325392
    GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2325506),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2325460), // Rule ID 47946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47946,
        GIR_EraseRootFromParent_Done,
      // Label 28196: @2325460
      GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2325505), // Rule ID 47947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47947,
        GIR_EraseRootFromParent_Done,
      // Label 28197: @2325505
      GIM_Reject,
    // Label 28195: @2325506
    GIM_Reject,
    // Label 28151: @2325507
    GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2325621),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2325575), // Rule ID 47878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47878,
        GIR_EraseRootFromParent_Done,
      // Label 28199: @2325575
      GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2325620), // Rule ID 47879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47879,
        GIR_EraseRootFromParent_Done,
      // Label 28200: @2325620
      GIM_Reject,
    // Label 28198: @2325621
    GIM_Reject,
    // Label 28152: @2325622
    GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2325736),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2325690), // Rule ID 47898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47898,
        GIR_EraseRootFromParent_Done,
      // Label 28202: @2325690
      GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2325735), // Rule ID 47899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47899,
        GIR_EraseRootFromParent_Done,
      // Label 28203: @2325735
      GIM_Reject,
    // Label 28201: @2325736
    GIM_Reject,
    // Label 28153: @2325737
    GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2325851),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2325805), // Rule ID 47934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47934,
        GIR_EraseRootFromParent_Done,
      // Label 28205: @2325805
      GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2325850), // Rule ID 47935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47935,
        GIR_EraseRootFromParent_Done,
      // Label 28206: @2325850
      GIM_Reject,
    // Label 28204: @2325851
    GIM_Reject,
    // Label 28154: @2325852
    GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2325966),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2325920), // Rule ID 47950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47950,
        GIR_EraseRootFromParent_Done,
      // Label 28208: @2325920
      GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2325965), // Rule ID 47951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47951,
        GIR_EraseRootFromParent_Done,
      // Label 28209: @2325965
      GIM_Reject,
    // Label 28207: @2325966
    GIM_Reject,
    // Label 28155: @2325967
    GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2326081),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2326035), // Rule ID 47894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47894,
        GIR_EraseRootFromParent_Done,
      // Label 28211: @2326035
      GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2326080), // Rule ID 47895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47895,
        GIR_EraseRootFromParent_Done,
      // Label 28212: @2326080
      GIM_Reject,
    // Label 28210: @2326081
    GIM_Reject,
    // Label 28156: @2326082
    GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2326196),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2326150), // Rule ID 47922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47922,
        GIR_EraseRootFromParent_Done,
      // Label 28214: @2326150
      GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2326195), // Rule ID 47923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47923,
        GIR_EraseRootFromParent_Done,
      // Label 28215: @2326195
      GIM_Reject,
    // Label 28213: @2326196
    GIM_Reject,
    // Label 28157: @2326197
    GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2326311),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2326265), // Rule ID 47938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47938,
        GIR_EraseRootFromParent_Done,
      // Label 28217: @2326265
      GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2326310), // Rule ID 47939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47939,
        GIR_EraseRootFromParent_Done,
      // Label 28218: @2326310
      GIM_Reject,
    // Label 28216: @2326311
    GIM_Reject,
    // Label 28158: @2326312
    GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2326426),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2326380), // Rule ID 47954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47954,
        GIR_EraseRootFromParent_Done,
      // Label 28220: @2326380
      GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2326425), // Rule ID 47955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47955,
        GIR_EraseRootFromParent_Done,
      // Label 28221: @2326425
      GIM_Reject,
    // Label 28219: @2326426
    GIM_Reject,
    // Label 28159: @2326427
    GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2326541),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2326495), // Rule ID 47910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47910,
        GIR_EraseRootFromParent_Done,
      // Label 28223: @2326495
      GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2326540), // Rule ID 47911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47911,
        GIR_EraseRootFromParent_Done,
      // Label 28224: @2326540
      GIM_Reject,
    // Label 28222: @2326541
    GIM_Reject,
    // Label 28160: @2326542
    GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2326656),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2326610), // Rule ID 47926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47926,
        GIR_EraseRootFromParent_Done,
      // Label 28226: @2326610
      GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2326655), // Rule ID 47927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47927,
        GIR_EraseRootFromParent_Done,
      // Label 28227: @2326655
      GIM_Reject,
    // Label 28225: @2326656
    GIM_Reject,
    // Label 28161: @2326657
    GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2326771),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2326725), // Rule ID 47942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47942,
        GIR_EraseRootFromParent_Done,
      // Label 28229: @2326725
      GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2326770), // Rule ID 47943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47943,
        GIR_EraseRootFromParent_Done,
      // Label 28230: @2326770
      GIM_Reject,
    // Label 28228: @2326771
    GIM_Reject,
    // Label 28162: @2326772
    GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2326886),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2326840), // Rule ID 47914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47914,
        GIR_EraseRootFromParent_Done,
      // Label 28232: @2326840
      GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2326885), // Rule ID 47915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47915,
        GIR_EraseRootFromParent_Done,
      // Label 28233: @2326885
      GIM_Reject,
    // Label 28231: @2326886
    GIM_Reject,
    // Label 28163: @2326887
    GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2327001),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2326955), // Rule ID 47930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47930,
        GIR_EraseRootFromParent_Done,
      // Label 28235: @2326955
      GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2327000), // Rule ID 47931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47931,
        GIR_EraseRootFromParent_Done,
      // Label 28236: @2327000
      GIM_Reject,
    // Label 28234: @2327001
    GIM_Reject,
    // Label 28164: @2327002
    GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2327116),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2327070), // Rule ID 47918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47918,
        GIR_EraseRootFromParent_Done,
      // Label 28238: @2327070
      GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2327115), // Rule ID 47919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47919,
        GIR_EraseRootFromParent_Done,
      // Label 28239: @2327115
      GIM_Reject,
    // Label 28237: @2327116
    GIM_Reject,
    // Label 28165: @2327117
    GIM_Reject,
    // Label 46: @2327118
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 28264*/ GIMT_Encode4(2330057),
    /*GILLT_s32*//*Label 28240*/ GIMT_Encode4(2327253),
    /*GILLT_s64*//*Label 28241*/ GIMT_Encode4(2327390), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 28242*/ GIMT_Encode4(2327527),
    /*GILLT_nxv1s16*//*Label 28243*/ GIMT_Encode4(2327642),
    /*GILLT_nxv1s32*//*Label 28244*/ GIMT_Encode4(2327757),
    /*GILLT_nxv1s64*//*Label 28245*/ GIMT_Encode4(2327872), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 28246*/ GIMT_Encode4(2327987),
    /*GILLT_nxv2s16*//*Label 28247*/ GIMT_Encode4(2328102),
    /*GILLT_nxv2s32*//*Label 28248*/ GIMT_Encode4(2328217),
    /*GILLT_nxv2s64*//*Label 28249*/ GIMT_Encode4(2328332), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 28250*/ GIMT_Encode4(2328447),
    /*GILLT_nxv4s16*//*Label 28251*/ GIMT_Encode4(2328562),
    /*GILLT_nxv4s32*//*Label 28252*/ GIMT_Encode4(2328677),
    /*GILLT_nxv4s64*//*Label 28253*/ GIMT_Encode4(2328792), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 28254*/ GIMT_Encode4(2328907),
    /*GILLT_nxv8s16*//*Label 28255*/ GIMT_Encode4(2329022),
    /*GILLT_nxv8s32*//*Label 28256*/ GIMT_Encode4(2329137),
    /*GILLT_nxv8s64*//*Label 28257*/ GIMT_Encode4(2329252), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 28258*/ GIMT_Encode4(2329367),
    /*GILLT_nxv16s16*//*Label 28259*/ GIMT_Encode4(2329482),
    /*GILLT_nxv16s32*//*Label 28260*/ GIMT_Encode4(2329597), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 28261*/ GIMT_Encode4(2329712),
    /*GILLT_nxv32s16*//*Label 28262*/ GIMT_Encode4(2329827), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 28263*/ GIMT_Encode4(2329942),
    // Label 28240: @2327253
    GIM_Try, /*On fail goto*//*Label 28265*/ GIMT_Encode4(2327389),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28266*/ GIMT_Encode4(2327306), // Rule ID 2321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2321,
        GIR_EraseRootFromParent_Done,
      // Label 28266: @2327306
      GIM_Try, /*On fail goto*//*Label 28267*/ GIMT_Encode4(2327340), // Rule ID 61961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61961,
        GIR_EraseRootFromParent_Done,
      // Label 28267: @2327340
      GIM_Try, /*On fail goto*//*Label 28268*/ GIMT_Encode4(2327369), // Rule ID 2319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2319,
        GIR_EraseRootFromParent_Done,
      // Label 28268: @2327369
      GIM_Try, /*On fail goto*//*Label 28269*/ GIMT_Encode4(2327388), // Rule ID 63859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63859,
        GIR_Done,
      // Label 28269: @2327388
      GIM_Reject,
    // Label 28265: @2327389
    GIM_Reject,
    // Label 28241: @2327390
    GIM_Try, /*On fail goto*//*Label 28270*/ GIMT_Encode4(2327526),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28271*/ GIMT_Encode4(2327443), // Rule ID 2320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2320,
        GIR_EraseRootFromParent_Done,
      // Label 28271: @2327443
      GIM_Try, /*On fail goto*//*Label 28272*/ GIMT_Encode4(2327477), // Rule ID 61960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61960,
        GIR_EraseRootFromParent_Done,
      // Label 28272: @2327477
      GIM_Try, /*On fail goto*//*Label 28273*/ GIMT_Encode4(2327506), // Rule ID 2318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2318,
        GIR_EraseRootFromParent_Done,
      // Label 28273: @2327506
      GIM_Try, /*On fail goto*//*Label 28274*/ GIMT_Encode4(2327525), // Rule ID 63858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63858,
        GIR_Done,
      // Label 28274: @2327525
      GIM_Reject,
    // Label 28270: @2327526
    GIM_Reject,
    // Label 28242: @2327527
    GIM_Try, /*On fail goto*//*Label 28275*/ GIMT_Encode4(2327641),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28276*/ GIMT_Encode4(2327595), // Rule ID 58778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58778,
        GIR_EraseRootFromParent_Done,
      // Label 28276: @2327595
      GIM_Try, /*On fail goto*//*Label 28277*/ GIMT_Encode4(2327640), // Rule ID 58779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58779,
        GIR_EraseRootFromParent_Done,
      // Label 28277: @2327640
      GIM_Reject,
    // Label 28275: @2327641
    GIM_Reject,
    // Label 28243: @2327642
    GIM_Try, /*On fail goto*//*Label 28278*/ GIMT_Encode4(2327756),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28279*/ GIMT_Encode4(2327710), // Rule ID 58790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58790,
        GIR_EraseRootFromParent_Done,
      // Label 28279: @2327710
      GIM_Try, /*On fail goto*//*Label 28280*/ GIMT_Encode4(2327755), // Rule ID 58791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58791,
        GIR_EraseRootFromParent_Done,
      // Label 28280: @2327755
      GIM_Reject,
    // Label 28278: @2327756
    GIM_Reject,
    // Label 28244: @2327757
    GIM_Try, /*On fail goto*//*Label 28281*/ GIMT_Encode4(2327871),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2327825), // Rule ID 58798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58798,
        GIR_EraseRootFromParent_Done,
      // Label 28282: @2327825
      GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2327870), // Rule ID 58799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58799,
        GIR_EraseRootFromParent_Done,
      // Label 28283: @2327870
      GIM_Reject,
    // Label 28281: @2327871
    GIM_Reject,
    // Label 28245: @2327872
    GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2327986),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2327940), // Rule ID 58814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58814,
        GIR_EraseRootFromParent_Done,
      // Label 28285: @2327940
      GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2327985), // Rule ID 58815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58815,
        GIR_EraseRootFromParent_Done,
      // Label 28286: @2327985
      GIM_Reject,
    // Label 28284: @2327986
    GIM_Reject,
    // Label 28246: @2327987
    GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2328101),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2328055), // Rule ID 58782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58782,
        GIR_EraseRootFromParent_Done,
      // Label 28288: @2328055
      GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2328100), // Rule ID 58783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58783,
        GIR_EraseRootFromParent_Done,
      // Label 28289: @2328100
      GIM_Reject,
    // Label 28287: @2328101
    GIM_Reject,
    // Label 28247: @2328102
    GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2328216),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2328170), // Rule ID 58794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58794,
        GIR_EraseRootFromParent_Done,
      // Label 28291: @2328170
      GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2328215), // Rule ID 58795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58795,
        GIR_EraseRootFromParent_Done,
      // Label 28292: @2328215
      GIM_Reject,
    // Label 28290: @2328216
    GIM_Reject,
    // Label 28248: @2328217
    GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2328331),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2328285), // Rule ID 58810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58810,
        GIR_EraseRootFromParent_Done,
      // Label 28294: @2328285
      GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2328330), // Rule ID 58811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58811,
        GIR_EraseRootFromParent_Done,
      // Label 28295: @2328330
      GIM_Reject,
    // Label 28293: @2328331
    GIM_Reject,
    // Label 28249: @2328332
    GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2328446),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2328400), // Rule ID 58854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58854,
        GIR_EraseRootFromParent_Done,
      // Label 28297: @2328400
      GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2328445), // Rule ID 58855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58855,
        GIR_EraseRootFromParent_Done,
      // Label 28298: @2328445
      GIM_Reject,
    // Label 28296: @2328446
    GIM_Reject,
    // Label 28250: @2328447
    GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2328561),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2328515), // Rule ID 58786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58786,
        GIR_EraseRootFromParent_Done,
      // Label 28300: @2328515
      GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2328560), // Rule ID 58787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58787,
        GIR_EraseRootFromParent_Done,
      // Label 28301: @2328560
      GIM_Reject,
    // Label 28299: @2328561
    GIM_Reject,
    // Label 28251: @2328562
    GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2328676),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2328630), // Rule ID 58806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58806,
        GIR_EraseRootFromParent_Done,
      // Label 28303: @2328630
      GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2328675), // Rule ID 58807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58807,
        GIR_EraseRootFromParent_Done,
      // Label 28304: @2328675
      GIM_Reject,
    // Label 28302: @2328676
    GIM_Reject,
    // Label 28252: @2328677
    GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2328791),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2328745), // Rule ID 58842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58842,
        GIR_EraseRootFromParent_Done,
      // Label 28306: @2328745
      GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2328790), // Rule ID 58843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58843,
        GIR_EraseRootFromParent_Done,
      // Label 28307: @2328790
      GIM_Reject,
    // Label 28305: @2328791
    GIM_Reject,
    // Label 28253: @2328792
    GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2328906),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2328860), // Rule ID 58858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58858,
        GIR_EraseRootFromParent_Done,
      // Label 28309: @2328860
      GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2328905), // Rule ID 58859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58859,
        GIR_EraseRootFromParent_Done,
      // Label 28310: @2328905
      GIM_Reject,
    // Label 28308: @2328906
    GIM_Reject,
    // Label 28254: @2328907
    GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2329021),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2328975), // Rule ID 58802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58802,
        GIR_EraseRootFromParent_Done,
      // Label 28312: @2328975
      GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2329020), // Rule ID 58803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58803,
        GIR_EraseRootFromParent_Done,
      // Label 28313: @2329020
      GIM_Reject,
    // Label 28311: @2329021
    GIM_Reject,
    // Label 28255: @2329022
    GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2329136),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2329090), // Rule ID 58830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58830,
        GIR_EraseRootFromParent_Done,
      // Label 28315: @2329090
      GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2329135), // Rule ID 58831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58831,
        GIR_EraseRootFromParent_Done,
      // Label 28316: @2329135
      GIM_Reject,
    // Label 28314: @2329136
    GIM_Reject,
    // Label 28256: @2329137
    GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2329251),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2329205), // Rule ID 58846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58846,
        GIR_EraseRootFromParent_Done,
      // Label 28318: @2329205
      GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2329250), // Rule ID 58847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58847,
        GIR_EraseRootFromParent_Done,
      // Label 28319: @2329250
      GIM_Reject,
    // Label 28317: @2329251
    GIM_Reject,
    // Label 28257: @2329252
    GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2329366),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2329320), // Rule ID 58862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58862,
        GIR_EraseRootFromParent_Done,
      // Label 28321: @2329320
      GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2329365), // Rule ID 58863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58863,
        GIR_EraseRootFromParent_Done,
      // Label 28322: @2329365
      GIM_Reject,
    // Label 28320: @2329366
    GIM_Reject,
    // Label 28258: @2329367
    GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2329481),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2329435), // Rule ID 58818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58818,
        GIR_EraseRootFromParent_Done,
      // Label 28324: @2329435
      GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2329480), // Rule ID 58819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58819,
        GIR_EraseRootFromParent_Done,
      // Label 28325: @2329480
      GIM_Reject,
    // Label 28323: @2329481
    GIM_Reject,
    // Label 28259: @2329482
    GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2329596),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2329550), // Rule ID 58834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58834,
        GIR_EraseRootFromParent_Done,
      // Label 28327: @2329550
      GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2329595), // Rule ID 58835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58835,
        GIR_EraseRootFromParent_Done,
      // Label 28328: @2329595
      GIM_Reject,
    // Label 28326: @2329596
    GIM_Reject,
    // Label 28260: @2329597
    GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2329711),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2329665), // Rule ID 58850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58850,
        GIR_EraseRootFromParent_Done,
      // Label 28330: @2329665
      GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2329710), // Rule ID 58851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58851,
        GIR_EraseRootFromParent_Done,
      // Label 28331: @2329710
      GIM_Reject,
    // Label 28329: @2329711
    GIM_Reject,
    // Label 28261: @2329712
    GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2329826),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2329780), // Rule ID 58822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58822,
        GIR_EraseRootFromParent_Done,
      // Label 28333: @2329780
      GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2329825), // Rule ID 58823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58823,
        GIR_EraseRootFromParent_Done,
      // Label 28334: @2329825
      GIM_Reject,
    // Label 28332: @2329826
    GIM_Reject,
    // Label 28262: @2329827
    GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2329941),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2329895), // Rule ID 58838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58838,
        GIR_EraseRootFromParent_Done,
      // Label 28336: @2329895
      GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2329940), // Rule ID 58839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58839,
        GIR_EraseRootFromParent_Done,
      // Label 28337: @2329940
      GIM_Reject,
    // Label 28335: @2329941
    GIM_Reject,
    // Label 28263: @2329942
    GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2330056),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2330010), // Rule ID 58826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58826,
        GIR_EraseRootFromParent_Done,
      // Label 28339: @2330010
      GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2330055), // Rule ID 58827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58827,
        GIR_EraseRootFromParent_Done,
      // Label 28340: @2330055
      GIM_Reject,
    // Label 28338: @2330056
    GIM_Reject,
    // Label 28264: @2330057
    GIM_Reject,
    // Label 47: @2330058
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 28365*/ GIMT_Encode4(2332967),
    /*GILLT_s32*//*Label 28341*/ GIMT_Encode4(2330193),
    /*GILLT_s64*//*Label 28342*/ GIMT_Encode4(2330315), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 28343*/ GIMT_Encode4(2330437),
    /*GILLT_nxv1s16*//*Label 28344*/ GIMT_Encode4(2330552),
    /*GILLT_nxv1s32*//*Label 28345*/ GIMT_Encode4(2330667),
    /*GILLT_nxv1s64*//*Label 28346*/ GIMT_Encode4(2330782), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 28347*/ GIMT_Encode4(2330897),
    /*GILLT_nxv2s16*//*Label 28348*/ GIMT_Encode4(2331012),
    /*GILLT_nxv2s32*//*Label 28349*/ GIMT_Encode4(2331127),
    /*GILLT_nxv2s64*//*Label 28350*/ GIMT_Encode4(2331242), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 28351*/ GIMT_Encode4(2331357),
    /*GILLT_nxv4s16*//*Label 28352*/ GIMT_Encode4(2331472),
    /*GILLT_nxv4s32*//*Label 28353*/ GIMT_Encode4(2331587),
    /*GILLT_nxv4s64*//*Label 28354*/ GIMT_Encode4(2331702), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 28355*/ GIMT_Encode4(2331817),
    /*GILLT_nxv8s16*//*Label 28356*/ GIMT_Encode4(2331932),
    /*GILLT_nxv8s32*//*Label 28357*/ GIMT_Encode4(2332047),
    /*GILLT_nxv8s64*//*Label 28358*/ GIMT_Encode4(2332162), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 28359*/ GIMT_Encode4(2332277),
    /*GILLT_nxv16s16*//*Label 28360*/ GIMT_Encode4(2332392),
    /*GILLT_nxv16s32*//*Label 28361*/ GIMT_Encode4(2332507), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 28362*/ GIMT_Encode4(2332622),
    /*GILLT_nxv32s16*//*Label 28363*/ GIMT_Encode4(2332737), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 28364*/ GIMT_Encode4(2332852),
    // Label 28341: @2330193
    GIM_Try, /*On fail goto*//*Label 28366*/ GIMT_Encode4(2330314),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28367*/ GIMT_Encode4(2330248), // Rule ID 2323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2323,
        GIR_EraseRootFromParent_Done,
      // Label 28367: @2330248
      GIM_Try, /*On fail goto*//*Label 28368*/ GIMT_Encode4(2330284), // Rule ID 61963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61963,
        GIR_EraseRootFromParent_Done,
      // Label 28368: @2330284
      GIM_Try, /*On fail goto*//*Label 28369*/ GIMT_Encode4(2330313), // Rule ID 2317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2317,
        GIR_EraseRootFromParent_Done,
      // Label 28369: @2330313
      GIM_Reject,
    // Label 28366: @2330314
    GIM_Reject,
    // Label 28342: @2330315
    GIM_Try, /*On fail goto*//*Label 28370*/ GIMT_Encode4(2330436),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28371*/ GIMT_Encode4(2330370), // Rule ID 2322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2322,
        GIR_EraseRootFromParent_Done,
      // Label 28371: @2330370
      GIM_Try, /*On fail goto*//*Label 28372*/ GIMT_Encode4(2330406), // Rule ID 61962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61962,
        GIR_EraseRootFromParent_Done,
      // Label 28372: @2330406
      GIM_Try, /*On fail goto*//*Label 28373*/ GIMT_Encode4(2330435), // Rule ID 2316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
        // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2316,
        GIR_EraseRootFromParent_Done,
      // Label 28373: @2330435
      GIM_Reject,
    // Label 28370: @2330436
    GIM_Reject,
    // Label 28343: @2330437
    GIM_Try, /*On fail goto*//*Label 28374*/ GIMT_Encode4(2330551),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28375*/ GIMT_Encode4(2330505), // Rule ID 58646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58646,
        GIR_EraseRootFromParent_Done,
      // Label 28375: @2330505
      GIM_Try, /*On fail goto*//*Label 28376*/ GIMT_Encode4(2330550), // Rule ID 58647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58647,
        GIR_EraseRootFromParent_Done,
      // Label 28376: @2330550
      GIM_Reject,
    // Label 28374: @2330551
    GIM_Reject,
    // Label 28344: @2330552
    GIM_Try, /*On fail goto*//*Label 28377*/ GIMT_Encode4(2330666),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28378*/ GIMT_Encode4(2330620), // Rule ID 58658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58658,
        GIR_EraseRootFromParent_Done,
      // Label 28378: @2330620
      GIM_Try, /*On fail goto*//*Label 28379*/ GIMT_Encode4(2330665), // Rule ID 58659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58659,
        GIR_EraseRootFromParent_Done,
      // Label 28379: @2330665
      GIM_Reject,
    // Label 28377: @2330666
    GIM_Reject,
    // Label 28345: @2330667
    GIM_Try, /*On fail goto*//*Label 28380*/ GIMT_Encode4(2330781),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28381*/ GIMT_Encode4(2330735), // Rule ID 58666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58666,
        GIR_EraseRootFromParent_Done,
      // Label 28381: @2330735
      GIM_Try, /*On fail goto*//*Label 28382*/ GIMT_Encode4(2330780), // Rule ID 58667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58667,
        GIR_EraseRootFromParent_Done,
      // Label 28382: @2330780
      GIM_Reject,
    // Label 28380: @2330781
    GIM_Reject,
    // Label 28346: @2330782
    GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2330896),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2330850), // Rule ID 58682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58682,
        GIR_EraseRootFromParent_Done,
      // Label 28384: @2330850
      GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2330895), // Rule ID 58683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58683,
        GIR_EraseRootFromParent_Done,
      // Label 28385: @2330895
      GIM_Reject,
    // Label 28383: @2330896
    GIM_Reject,
    // Label 28347: @2330897
    GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2331011),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2330965), // Rule ID 58650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58650,
        GIR_EraseRootFromParent_Done,
      // Label 28387: @2330965
      GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2331010), // Rule ID 58651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58651,
        GIR_EraseRootFromParent_Done,
      // Label 28388: @2331010
      GIM_Reject,
    // Label 28386: @2331011
    GIM_Reject,
    // Label 28348: @2331012
    GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2331126),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2331080), // Rule ID 58662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58662,
        GIR_EraseRootFromParent_Done,
      // Label 28390: @2331080
      GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2331125), // Rule ID 58663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58663,
        GIR_EraseRootFromParent_Done,
      // Label 28391: @2331125
      GIM_Reject,
    // Label 28389: @2331126
    GIM_Reject,
    // Label 28349: @2331127
    GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2331241),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2331195), // Rule ID 58678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58678,
        GIR_EraseRootFromParent_Done,
      // Label 28393: @2331195
      GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2331240), // Rule ID 58679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58679,
        GIR_EraseRootFromParent_Done,
      // Label 28394: @2331240
      GIM_Reject,
    // Label 28392: @2331241
    GIM_Reject,
    // Label 28350: @2331242
    GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2331356),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2331310), // Rule ID 58722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58722,
        GIR_EraseRootFromParent_Done,
      // Label 28396: @2331310
      GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2331355), // Rule ID 58723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58723,
        GIR_EraseRootFromParent_Done,
      // Label 28397: @2331355
      GIM_Reject,
    // Label 28395: @2331356
    GIM_Reject,
    // Label 28351: @2331357
    GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2331471),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2331425), // Rule ID 58654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58654,
        GIR_EraseRootFromParent_Done,
      // Label 28399: @2331425
      GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2331470), // Rule ID 58655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58655,
        GIR_EraseRootFromParent_Done,
      // Label 28400: @2331470
      GIM_Reject,
    // Label 28398: @2331471
    GIM_Reject,
    // Label 28352: @2331472
    GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2331586),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2331540), // Rule ID 58674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58674,
        GIR_EraseRootFromParent_Done,
      // Label 28402: @2331540
      GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2331585), // Rule ID 58675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58675,
        GIR_EraseRootFromParent_Done,
      // Label 28403: @2331585
      GIM_Reject,
    // Label 28401: @2331586
    GIM_Reject,
    // Label 28353: @2331587
    GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2331701),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2331655), // Rule ID 58710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58710,
        GIR_EraseRootFromParent_Done,
      // Label 28405: @2331655
      GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2331700), // Rule ID 58711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58711,
        GIR_EraseRootFromParent_Done,
      // Label 28406: @2331700
      GIM_Reject,
    // Label 28404: @2331701
    GIM_Reject,
    // Label 28354: @2331702
    GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2331816),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2331770), // Rule ID 58726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58726,
        GIR_EraseRootFromParent_Done,
      // Label 28408: @2331770
      GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2331815), // Rule ID 58727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58727,
        GIR_EraseRootFromParent_Done,
      // Label 28409: @2331815
      GIM_Reject,
    // Label 28407: @2331816
    GIM_Reject,
    // Label 28355: @2331817
    GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2331931),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2331885), // Rule ID 58670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58670,
        GIR_EraseRootFromParent_Done,
      // Label 28411: @2331885
      GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2331930), // Rule ID 58671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58671,
        GIR_EraseRootFromParent_Done,
      // Label 28412: @2331930
      GIM_Reject,
    // Label 28410: @2331931
    GIM_Reject,
    // Label 28356: @2331932
    GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2332046),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2332000), // Rule ID 58698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58698,
        GIR_EraseRootFromParent_Done,
      // Label 28414: @2332000
      GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2332045), // Rule ID 58699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58699,
        GIR_EraseRootFromParent_Done,
      // Label 28415: @2332045
      GIM_Reject,
    // Label 28413: @2332046
    GIM_Reject,
    // Label 28357: @2332047
    GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2332161),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2332115), // Rule ID 58714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58714,
        GIR_EraseRootFromParent_Done,
      // Label 28417: @2332115
      GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2332160), // Rule ID 58715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58715,
        GIR_EraseRootFromParent_Done,
      // Label 28418: @2332160
      GIM_Reject,
    // Label 28416: @2332161
    GIM_Reject,
    // Label 28358: @2332162
    GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2332276),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2332230), // Rule ID 58730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58730,
        GIR_EraseRootFromParent_Done,
      // Label 28420: @2332230
      GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2332275), // Rule ID 58731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58731,
        GIR_EraseRootFromParent_Done,
      // Label 28421: @2332275
      GIM_Reject,
    // Label 28419: @2332276
    GIM_Reject,
    // Label 28359: @2332277
    GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2332391),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2332345), // Rule ID 58686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58686,
        GIR_EraseRootFromParent_Done,
      // Label 28423: @2332345
      GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2332390), // Rule ID 58687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58687,
        GIR_EraseRootFromParent_Done,
      // Label 28424: @2332390
      GIM_Reject,
    // Label 28422: @2332391
    GIM_Reject,
    // Label 28360: @2332392
    GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2332506),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2332460), // Rule ID 58702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58702,
        GIR_EraseRootFromParent_Done,
      // Label 28426: @2332460
      GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2332505), // Rule ID 58703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58703,
        GIR_EraseRootFromParent_Done,
      // Label 28427: @2332505
      GIM_Reject,
    // Label 28425: @2332506
    GIM_Reject,
    // Label 28361: @2332507
    GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2332621),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2332575), // Rule ID 58718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58718,
        GIR_EraseRootFromParent_Done,
      // Label 28429: @2332575
      GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2332620), // Rule ID 58719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58719,
        GIR_EraseRootFromParent_Done,
      // Label 28430: @2332620
      GIM_Reject,
    // Label 28428: @2332621
    GIM_Reject,
    // Label 28362: @2332622
    GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2332736),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2332690), // Rule ID 58690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58690,
        GIR_EraseRootFromParent_Done,
      // Label 28432: @2332690
      GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2332735), // Rule ID 58691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58691,
        GIR_EraseRootFromParent_Done,
      // Label 28433: @2332735
      GIM_Reject,
    // Label 28431: @2332736
    GIM_Reject,
    // Label 28363: @2332737
    GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2332851),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2332805), // Rule ID 58706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58706,
        GIR_EraseRootFromParent_Done,
      // Label 28435: @2332805
      GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2332850), // Rule ID 58707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58707,
        GIR_EraseRootFromParent_Done,
      // Label 28436: @2332850
      GIM_Reject,
    // Label 28434: @2332851
    GIM_Reject,
    // Label 28364: @2332852
    GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2332966),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2332920), // Rule ID 58694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58694,
        GIR_EraseRootFromParent_Done,
      // Label 28438: @2332920
      GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2332965), // Rule ID 58695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58695,
        GIR_EraseRootFromParent_Done,
      // Label 28439: @2332965
      GIM_Reject,
    // Label 28437: @2332966
    GIM_Reject,
    // Label 28365: @2332967
    GIM_Reject,
    // Label 48: @2332968
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 28449*/ GIMT_Encode4(2359630),
    /*GILLT_s32*//*Label 28440*/ GIMT_Encode4(2333099),
    /*GILLT_s64*//*Label 28441*/ GIMT_Encode4(2335893),
    /*GILLT_nxv1s1*//*Label 28442*/ GIMT_Encode4(2338687), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 28443*/ GIMT_Encode4(2342528), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s1*//*Label 28444*/ GIMT_Encode4(2346369), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s1*//*Label 28445*/ GIMT_Encode4(2350210), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s1*//*Label 28446*/ GIMT_Encode4(2354051), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s1*//*Label 28447*/ GIMT_Encode4(2356932), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv64s1*//*Label 28448*/ GIMT_Encode4(2358853),
    // Label 28440: @2333099
    GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2333142), // Rule ID 159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 159,
      GIR_EraseRootFromParent_Done,
    // Label 28450: @2333142
    GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2333185), // Rule ID 63962 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63962,
      GIR_EraseRootFromParent_Done,
    // Label 28451: @2333185
    GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2333231), // Rule ID 63968 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63968,
      GIR_EraseRootFromParent_Done,
    // Label 28452: @2333231
    GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2333274), // Rule ID 63998 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63998,
      GIR_EraseRootFromParent_Done,
    // Label 28453: @2333274
    GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2333320), // Rule ID 64004 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64004,
      GIR_EraseRootFromParent_Done,
    // Label 28454: @2333320
    GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2333373), // Rule ID 149 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 149,
      GIR_EraseRootFromParent_Done,
    // Label 28455: @2333373
    GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2333426), // Rule ID 153 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 153,
      GIR_EraseRootFromParent_Done,
    // Label 28456: @2333426
    GIM_Try, /*On fail goto*//*Label 28457*/ GIMT_Encode4(2333479), // Rule ID 63954 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63954,
      GIR_EraseRootFromParent_Done,
    // Label 28457: @2333479
    GIM_Try, /*On fail goto*//*Label 28458*/ GIMT_Encode4(2333532), // Rule ID 63958 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63958,
      GIR_EraseRootFromParent_Done,
    // Label 28458: @2333532
    GIM_Try, /*On fail goto*//*Label 28459*/ GIMT_Encode4(2333609), // Rule ID 63964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63964,
      GIR_EraseRootFromParent_Done,
    // Label 28459: @2333609
    GIM_Try, /*On fail goto*//*Label 28460*/ GIMT_Encode4(2333689), // Rule ID 63970 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63970,
      GIR_EraseRootFromParent_Done,
    // Label 28460: @2333689
    GIM_Try, /*On fail goto*//*Label 28461*/ GIMT_Encode4(2333766), // Rule ID 63974 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63974,
      GIR_EraseRootFromParent_Done,
    // Label 28461: @2333766
    GIM_Try, /*On fail goto*//*Label 28462*/ GIMT_Encode4(2333843), // Rule ID 63978 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63978,
      GIR_EraseRootFromParent_Done,
    // Label 28462: @2333843
    GIM_Try, /*On fail goto*//*Label 28463*/ GIMT_Encode4(2333918), // Rule ID 63982 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63982,
      GIR_EraseRootFromParent_Done,
    // Label 28463: @2333918
    GIM_Try, /*On fail goto*//*Label 28464*/ GIMT_Encode4(2333993), // Rule ID 63986 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63986,
      GIR_EraseRootFromParent_Done,
    // Label 28464: @2333993
    GIM_Try, /*On fail goto*//*Label 28465*/ GIMT_Encode4(2334048), // Rule ID 63990 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63990,
      GIR_EraseRootFromParent_Done,
    // Label 28465: @2334048
    GIM_Try, /*On fail goto*//*Label 28466*/ GIMT_Encode4(2334103), // Rule ID 63994 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63994,
      GIR_EraseRootFromParent_Done,
    // Label 28466: @2334103
    GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2334180), // Rule ID 64000 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64000,
      GIR_EraseRootFromParent_Done,
    // Label 28467: @2334180
    GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2334260), // Rule ID 64006 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64006,
      GIR_EraseRootFromParent_Done,
    // Label 28468: @2334260
    GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2334337), // Rule ID 64010 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64010,
      GIR_EraseRootFromParent_Done,
    // Label 28469: @2334337
    GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2334414), // Rule ID 64014 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64014,
      GIR_EraseRootFromParent_Done,
    // Label 28470: @2334414
    GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2334489), // Rule ID 64018 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64018,
      GIR_EraseRootFromParent_Done,
    // Label 28471: @2334489
    GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2334564), // Rule ID 64022 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64022,
      GIR_EraseRootFromParent_Done,
    // Label 28472: @2334564
    GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2334619), // Rule ID 64026 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64026,
      GIR_EraseRootFromParent_Done,
    // Label 28473: @2334619
    GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2334674), // Rule ID 64030 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64030,
      GIR_EraseRootFromParent_Done,
    // Label 28474: @2334674
    GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2334716), // Rule ID 63871 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63871,
      GIR_EraseRootFromParent_Done,
    // Label 28475: @2334716
    GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2334758), // Rule ID 63873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63873,
      GIR_EraseRootFromParent_Done,
    // Label 28476: @2334758
    GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2334800), // Rule ID 147 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 147,
      GIR_EraseRootFromParent_Done,
    // Label 28477: @2334800
    GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2334842), // Rule ID 151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 151,
      GIR_EraseRootFromParent_Done,
    // Label 28478: @2334842
    GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2334884), // Rule ID 63956 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63956,
      GIR_EraseRootFromParent_Done,
    // Label 28479: @2334884
    GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2334926), // Rule ID 63960 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63960,
      GIR_EraseRootFromParent_Done,
    // Label 28480: @2334926
    GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2334992), // Rule ID 63966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63966,
      GIR_EraseRootFromParent_Done,
    // Label 28481: @2334992
    GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2335061), // Rule ID 63972 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63972,
      GIR_EraseRootFromParent_Done,
    // Label 28482: @2335061
    GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2335103), // Rule ID 63976 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63976,
      GIR_EraseRootFromParent_Done,
    // Label 28483: @2335103
    GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2335145), // Rule ID 63980 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63980,
      GIR_EraseRootFromParent_Done,
    // Label 28484: @2335145
    GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2335211), // Rule ID 63984 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63984,
      GIR_EraseRootFromParent_Done,
    // Label 28485: @2335211
    GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2335277), // Rule ID 63988 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63988,
      GIR_EraseRootFromParent_Done,
    // Label 28486: @2335277
    GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2335343), // Rule ID 63992 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63992,
      GIR_EraseRootFromParent_Done,
    // Label 28487: @2335343
    GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2335409), // Rule ID 63996 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63996,
      GIR_EraseRootFromParent_Done,
    // Label 28488: @2335409
    GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2335475), // Rule ID 64002 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64002,
      GIR_EraseRootFromParent_Done,
    // Label 28489: @2335475
    GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2335544), // Rule ID 64008 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64008,
      GIR_EraseRootFromParent_Done,
    // Label 28490: @2335544
    GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2335586), // Rule ID 64012 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64012,
      GIR_EraseRootFromParent_Done,
    // Label 28491: @2335586
    GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2335628), // Rule ID 64016 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64016,
      GIR_EraseRootFromParent_Done,
    // Label 28492: @2335628
    GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2335694), // Rule ID 64020 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64020,
      GIR_EraseRootFromParent_Done,
    // Label 28493: @2335694
    GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2335760), // Rule ID 64024 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64024,
      GIR_EraseRootFromParent_Done,
    // Label 28494: @2335760
    GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2335826), // Rule ID 64028 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64028,
      GIR_EraseRootFromParent_Done,
    // Label 28495: @2335826
    GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2335892), // Rule ID 64032 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64032,
      GIR_EraseRootFromParent_Done,
    // Label 28496: @2335892
    GIM_Reject,
    // Label 28441: @2335893
    GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2335936), // Rule ID 158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 158,
      GIR_EraseRootFromParent_Done,
    // Label 28497: @2335936
    GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2335979), // Rule ID 63961 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63961,
      GIR_EraseRootFromParent_Done,
    // Label 28498: @2335979
    GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2336025), // Rule ID 63967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63967,
      GIR_EraseRootFromParent_Done,
    // Label 28499: @2336025
    GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2336068), // Rule ID 63997 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63997,
      GIR_EraseRootFromParent_Done,
    // Label 28500: @2336068
    GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2336114), // Rule ID 64003 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64003,
      GIR_EraseRootFromParent_Done,
    // Label 28501: @2336114
    GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2336167), // Rule ID 148 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 148,
      GIR_EraseRootFromParent_Done,
    // Label 28502: @2336167
    GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2336220), // Rule ID 152 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 152,
      GIR_EraseRootFromParent_Done,
    // Label 28503: @2336220
    GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2336273), // Rule ID 63953 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63953,
      GIR_EraseRootFromParent_Done,
    // Label 28504: @2336273
    GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2336326), // Rule ID 63957 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63957,
      GIR_EraseRootFromParent_Done,
    // Label 28505: @2336326
    GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2336403), // Rule ID 63963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63963,
      GIR_EraseRootFromParent_Done,
    // Label 28506: @2336403
    GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2336483), // Rule ID 63969 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63969,
      GIR_EraseRootFromParent_Done,
    // Label 28507: @2336483
    GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2336560), // Rule ID 63973 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63973,
      GIR_EraseRootFromParent_Done,
    // Label 28508: @2336560
    GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2336637), // Rule ID 63977 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63977,
      GIR_EraseRootFromParent_Done,
    // Label 28509: @2336637
    GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2336712), // Rule ID 63981 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63981,
      GIR_EraseRootFromParent_Done,
    // Label 28510: @2336712
    GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2336787), // Rule ID 63985 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63985,
      GIR_EraseRootFromParent_Done,
    // Label 28511: @2336787
    GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2336842), // Rule ID 63989 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63989,
      GIR_EraseRootFromParent_Done,
    // Label 28512: @2336842
    GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2336897), // Rule ID 63993 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63993,
      GIR_EraseRootFromParent_Done,
    // Label 28513: @2336897
    GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2336974), // Rule ID 63999 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63999,
      GIR_EraseRootFromParent_Done,
    // Label 28514: @2336974
    GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2337054), // Rule ID 64005 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64005,
      GIR_EraseRootFromParent_Done,
    // Label 28515: @2337054
    GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2337131), // Rule ID 64009 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64009,
      GIR_EraseRootFromParent_Done,
    // Label 28516: @2337131
    GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2337208), // Rule ID 64013 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64013,
      GIR_EraseRootFromParent_Done,
    // Label 28517: @2337208
    GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2337283), // Rule ID 64017 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64017,
      GIR_EraseRootFromParent_Done,
    // Label 28518: @2337283
    GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2337358), // Rule ID 64021 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64021,
      GIR_EraseRootFromParent_Done,
    // Label 28519: @2337358
    GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2337413), // Rule ID 64025 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64025,
      GIR_EraseRootFromParent_Done,
    // Label 28520: @2337413
    GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2337468), // Rule ID 64029 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64029,
      GIR_EraseRootFromParent_Done,
    // Label 28521: @2337468
    GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2337510), // Rule ID 63870 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63870,
      GIR_EraseRootFromParent_Done,
    // Label 28522: @2337510
    GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2337552), // Rule ID 63872 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63872,
      GIR_EraseRootFromParent_Done,
    // Label 28523: @2337552
    GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2337594), // Rule ID 146 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 146,
      GIR_EraseRootFromParent_Done,
    // Label 28524: @2337594
    GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2337636), // Rule ID 150 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 150,
      GIR_EraseRootFromParent_Done,
    // Label 28525: @2337636
    GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2337678), // Rule ID 63955 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63955,
      GIR_EraseRootFromParent_Done,
    // Label 28526: @2337678
    GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2337720), // Rule ID 63959 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63959,
      GIR_EraseRootFromParent_Done,
    // Label 28527: @2337720
    GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2337786), // Rule ID 63965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63965,
      GIR_EraseRootFromParent_Done,
    // Label 28528: @2337786
    GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2337855), // Rule ID 63971 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63971,
      GIR_EraseRootFromParent_Done,
    // Label 28529: @2337855
    GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2337897), // Rule ID 63975 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63975,
      GIR_EraseRootFromParent_Done,
    // Label 28530: @2337897
    GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2337939), // Rule ID 63979 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63979,
      GIR_EraseRootFromParent_Done,
    // Label 28531: @2337939
    GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2338005), // Rule ID 63983 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63983,
      GIR_EraseRootFromParent_Done,
    // Label 28532: @2338005
    GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2338071), // Rule ID 63987 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63987,
      GIR_EraseRootFromParent_Done,
    // Label 28533: @2338071
    GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2338137), // Rule ID 63991 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63991,
      GIR_EraseRootFromParent_Done,
    // Label 28534: @2338137
    GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2338203), // Rule ID 63995 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63995,
      GIR_EraseRootFromParent_Done,
    // Label 28535: @2338203
    GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2338269), // Rule ID 64001 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64001,
      GIR_EraseRootFromParent_Done,
    // Label 28536: @2338269
    GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2338338), // Rule ID 64007 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64007,
      GIR_EraseRootFromParent_Done,
    // Label 28537: @2338338
    GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2338380), // Rule ID 64011 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64011,
      GIR_EraseRootFromParent_Done,
    // Label 28538: @2338380
    GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2338422), // Rule ID 64015 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64015,
      GIR_EraseRootFromParent_Done,
    // Label 28539: @2338422
    GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2338488), // Rule ID 64019 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64019,
      GIR_EraseRootFromParent_Done,
    // Label 28540: @2338488
    GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2338554), // Rule ID 64023 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64023,
      GIR_EraseRootFromParent_Done,
    // Label 28541: @2338554
    GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2338620), // Rule ID 64027 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64027,
      GIR_EraseRootFromParent_Done,
    // Label 28542: @2338620
    GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2338686), // Rule ID 64031 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 64031,
      GIR_EraseRootFromParent_Done,
    // Label 28543: @2338686
    GIM_Reject,
    // Label 28442: @2338687
    GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2338735), // Rule ID 45560 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45560,
      GIR_EraseRootFromParent_Done,
    // Label 28544: @2338735
    GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2338783), // Rule ID 45561 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45561,
      GIR_EraseRootFromParent_Done,
    // Label 28545: @2338783
    GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2338831), // Rule ID 45562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45562,
      GIR_EraseRootFromParent_Done,
    // Label 28546: @2338831
    GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2338879), // Rule ID 45563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45563,
      GIR_EraseRootFromParent_Done,
    // Label 28547: @2338879
    GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2338927), // Rule ID 48050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48050,
      GIR_EraseRootFromParent_Done,
    // Label 28548: @2338927
    GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2338975), // Rule ID 48051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48051,
      GIR_EraseRootFromParent_Done,
    // Label 28549: @2338975
    GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2339023), // Rule ID 48054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48054,
      GIR_EraseRootFromParent_Done,
    // Label 28550: @2339023
    GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2339071), // Rule ID 48055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48055,
      GIR_EraseRootFromParent_Done,
    // Label 28551: @2339071
    GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2339119), // Rule ID 48062 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48062,
      GIR_EraseRootFromParent_Done,
    // Label 28552: @2339119
    GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2339167), // Rule ID 48063 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48063,
      GIR_EraseRootFromParent_Done,
    // Label 28553: @2339167
    GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2339215), // Rule ID 48088 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48088,
      GIR_EraseRootFromParent_Done,
    // Label 28554: @2339215
    GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2339263), // Rule ID 48089 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48089,
      GIR_EraseRootFromParent_Done,
    // Label 28555: @2339263
    GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2339311), // Rule ID 48094 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48094,
      GIR_EraseRootFromParent_Done,
    // Label 28556: @2339311
    GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2339359), // Rule ID 48095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48095,
      GIR_EraseRootFromParent_Done,
    // Label 28557: @2339359
    GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2339407), // Rule ID 48098 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48098,
      GIR_EraseRootFromParent_Done,
    // Label 28558: @2339407
    GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2339455), // Rule ID 48099 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48099,
      GIR_EraseRootFromParent_Done,
    // Label 28559: @2339455
    GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2339503), // Rule ID 48106 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48106,
      GIR_EraseRootFromParent_Done,
    // Label 28560: @2339503
    GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2339551), // Rule ID 48107 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48107,
      GIR_EraseRootFromParent_Done,
    // Label 28561: @2339551
    GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2339599), // Rule ID 48132 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48132,
      GIR_EraseRootFromParent_Done,
    // Label 28562: @2339599
    GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2339647), // Rule ID 48133 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48133,
      GIR_EraseRootFromParent_Done,
    // Label 28563: @2339647
    GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2339695), // Rule ID 48138 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48138,
      GIR_EraseRootFromParent_Done,
    // Label 28564: @2339695
    GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2339743), // Rule ID 48139 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48139,
      GIR_EraseRootFromParent_Done,
    // Label 28565: @2339743
    GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2339791), // Rule ID 48142 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48142,
      GIR_EraseRootFromParent_Done,
    // Label 28566: @2339791
    GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2339839), // Rule ID 48143 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48143,
      GIR_EraseRootFromParent_Done,
    // Label 28567: @2339839
    GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2339887), // Rule ID 48150 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48150,
      GIR_EraseRootFromParent_Done,
    // Label 28568: @2339887
    GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2339935), // Rule ID 48151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48151,
      GIR_EraseRootFromParent_Done,
    // Label 28569: @2339935
    GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2339983), // Rule ID 48180 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48180,
      GIR_EraseRootFromParent_Done,
    // Label 28570: @2339983
    GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2340031), // Rule ID 48181 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48181,
      GIR_EraseRootFromParent_Done,
    // Label 28571: @2340031
    GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2340079), // Rule ID 48184 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48184,
      GIR_EraseRootFromParent_Done,
    // Label 28572: @2340079
    GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2340127), // Rule ID 48185 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48185,
      GIR_EraseRootFromParent_Done,
    // Label 28573: @2340127
    GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2340175), // Rule ID 48192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48192,
      GIR_EraseRootFromParent_Done,
    // Label 28574: @2340175
    GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2340223), // Rule ID 48193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48193,
      GIR_EraseRootFromParent_Done,
    // Label 28575: @2340223
    GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2340271), // Rule ID 48218 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48218,
      GIR_EraseRootFromParent_Done,
    // Label 28576: @2340271
    GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2340319), // Rule ID 48219 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48219,
      GIR_EraseRootFromParent_Done,
    // Label 28577: @2340319
    GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2340367), // Rule ID 48224 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48224,
      GIR_EraseRootFromParent_Done,
    // Label 28578: @2340367
    GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2340415), // Rule ID 48225 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48225,
      GIR_EraseRootFromParent_Done,
    // Label 28579: @2340415
    GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2340463), // Rule ID 48228 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48228,
      GIR_EraseRootFromParent_Done,
    // Label 28580: @2340463
    GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2340511), // Rule ID 48229 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48229,
      GIR_EraseRootFromParent_Done,
    // Label 28581: @2340511
    GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2340559), // Rule ID 48236 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48236,
      GIR_EraseRootFromParent_Done,
    // Label 28582: @2340559
    GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2340607), // Rule ID 48237 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48237,
      GIR_EraseRootFromParent_Done,
    // Label 28583: @2340607
    GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2340655), // Rule ID 48262 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48262,
      GIR_EraseRootFromParent_Done,
    // Label 28584: @2340655
    GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2340703), // Rule ID 48263 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48263,
      GIR_EraseRootFromParent_Done,
    // Label 28585: @2340703
    GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2340751), // Rule ID 48268 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48268,
      GIR_EraseRootFromParent_Done,
    // Label 28586: @2340751
    GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2340799), // Rule ID 48269 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48269,
      GIR_EraseRootFromParent_Done,
    // Label 28587: @2340799
    GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2340847), // Rule ID 48272 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48272,
      GIR_EraseRootFromParent_Done,
    // Label 28588: @2340847
    GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2340895), // Rule ID 48273 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48273,
      GIR_EraseRootFromParent_Done,
    // Label 28589: @2340895
    GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2340943), // Rule ID 48280 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48280,
      GIR_EraseRootFromParent_Done,
    // Label 28590: @2340943
    GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2340991), // Rule ID 48281 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48281,
      GIR_EraseRootFromParent_Done,
    // Label 28591: @2340991
    GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2341039), // Rule ID 48306 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48306,
      GIR_EraseRootFromParent_Done,
    // Label 28592: @2341039
    GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2341087), // Rule ID 48307 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48307,
      GIR_EraseRootFromParent_Done,
    // Label 28593: @2341087
    GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2341135), // Rule ID 48312 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48312,
      GIR_EraseRootFromParent_Done,
    // Label 28594: @2341135
    GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2341183), // Rule ID 48313 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48313,
      GIR_EraseRootFromParent_Done,
    // Label 28595: @2341183
    GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2341231), // Rule ID 48316 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48316,
      GIR_EraseRootFromParent_Done,
    // Label 28596: @2341231
    GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2341279), // Rule ID 48317 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48317,
      GIR_EraseRootFromParent_Done,
    // Label 28597: @2341279
    GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2341327), // Rule ID 48324 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48324,
      GIR_EraseRootFromParent_Done,
    // Label 28598: @2341327
    GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2341375), // Rule ID 48325 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48325,
      GIR_EraseRootFromParent_Done,
    // Label 28599: @2341375
    GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2341423), // Rule ID 48350 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48350,
      GIR_EraseRootFromParent_Done,
    // Label 28600: @2341423
    GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2341471), // Rule ID 48351 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48351,
      GIR_EraseRootFromParent_Done,
    // Label 28601: @2341471
    GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2341519), // Rule ID 48356 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48356,
      GIR_EraseRootFromParent_Done,
    // Label 28602: @2341519
    GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2341567), // Rule ID 48357 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48357,
      GIR_EraseRootFromParent_Done,
    // Label 28603: @2341567
    GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2341615), // Rule ID 48360 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48360,
      GIR_EraseRootFromParent_Done,
    // Label 28604: @2341615
    GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2341663), // Rule ID 48361 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48361,
      GIR_EraseRootFromParent_Done,
    // Label 28605: @2341663
    GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2341711), // Rule ID 48368 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48368,
      GIR_EraseRootFromParent_Done,
    // Label 28606: @2341711
    GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2341759), // Rule ID 48369 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48369,
      GIR_EraseRootFromParent_Done,
    // Label 28607: @2341759
    GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2341807), // Rule ID 48394 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48394,
      GIR_EraseRootFromParent_Done,
    // Label 28608: @2341807
    GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2341855), // Rule ID 48395 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48395,
      GIR_EraseRootFromParent_Done,
    // Label 28609: @2341855
    GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2341903), // Rule ID 48400 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48400,
      GIR_EraseRootFromParent_Done,
    // Label 28610: @2341903
    GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2341951), // Rule ID 48401 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48401,
      GIR_EraseRootFromParent_Done,
    // Label 28611: @2341951
    GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2341999), // Rule ID 48404 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48404,
      GIR_EraseRootFromParent_Done,
    // Label 28612: @2341999
    GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2342047), // Rule ID 48405 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48405,
      GIR_EraseRootFromParent_Done,
    // Label 28613: @2342047
    GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2342095), // Rule ID 48412 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48412,
      GIR_EraseRootFromParent_Done,
    // Label 28614: @2342095
    GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2342143), // Rule ID 48413 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48413,
      GIR_EraseRootFromParent_Done,
    // Label 28615: @2342143
    GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2342191), // Rule ID 48438 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48438,
      GIR_EraseRootFromParent_Done,
    // Label 28616: @2342191
    GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2342239), // Rule ID 48439 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48439,
      GIR_EraseRootFromParent_Done,
    // Label 28617: @2342239
    GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2342287), // Rule ID 48444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48444,
      GIR_EraseRootFromParent_Done,
    // Label 28618: @2342287
    GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2342335), // Rule ID 48445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48445,
      GIR_EraseRootFromParent_Done,
    // Label 28619: @2342335
    GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2342383), // Rule ID 48448 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48448,
      GIR_EraseRootFromParent_Done,
    // Label 28620: @2342383
    GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2342431), // Rule ID 48449 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48449,
      GIR_EraseRootFromParent_Done,
    // Label 28621: @2342431
    GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2342479), // Rule ID 48456 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48456,
      GIR_EraseRootFromParent_Done,
    // Label 28622: @2342479
    GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2342527), // Rule ID 48457 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48457,
      GIR_EraseRootFromParent_Done,
    // Label 28623: @2342527
    GIM_Reject,
    // Label 28443: @2342528
    GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2342576), // Rule ID 48046 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48046,
      GIR_EraseRootFromParent_Done,
    // Label 28624: @2342576
    GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2342624), // Rule ID 48047 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48047,
      GIR_EraseRootFromParent_Done,
    // Label 28625: @2342624
    GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2342672), // Rule ID 48052 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48052,
      GIR_EraseRootFromParent_Done,
    // Label 28626: @2342672
    GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2342720), // Rule ID 48053 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48053,
      GIR_EraseRootFromParent_Done,
    // Label 28627: @2342720
    GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2342768), // Rule ID 48060 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48060,
      GIR_EraseRootFromParent_Done,
    // Label 28628: @2342768
    GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2342816), // Rule ID 48061 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48061,
      GIR_EraseRootFromParent_Done,
    // Label 28629: @2342816
    GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2342864), // Rule ID 48082 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48082,
      GIR_EraseRootFromParent_Done,
    // Label 28630: @2342864
    GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2342912), // Rule ID 48083 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48083,
      GIR_EraseRootFromParent_Done,
    // Label 28631: @2342912
    GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2342960), // Rule ID 48090 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48090,
      GIR_EraseRootFromParent_Done,
    // Label 28632: @2342960
    GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2343008), // Rule ID 48091 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48091,
      GIR_EraseRootFromParent_Done,
    // Label 28633: @2343008
    GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2343056), // Rule ID 48096 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48096,
      GIR_EraseRootFromParent_Done,
    // Label 28634: @2343056
    GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2343104), // Rule ID 48097 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48097,
      GIR_EraseRootFromParent_Done,
    // Label 28635: @2343104
    GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2343152), // Rule ID 48104 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48104,
      GIR_EraseRootFromParent_Done,
    // Label 28636: @2343152
    GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2343200), // Rule ID 48105 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48105,
      GIR_EraseRootFromParent_Done,
    // Label 28637: @2343200
    GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2343248), // Rule ID 48126 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48126,
      GIR_EraseRootFromParent_Done,
    // Label 28638: @2343248
    GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2343296), // Rule ID 48127 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48127,
      GIR_EraseRootFromParent_Done,
    // Label 28639: @2343296
    GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2343344), // Rule ID 48134 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48134,
      GIR_EraseRootFromParent_Done,
    // Label 28640: @2343344
    GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2343392), // Rule ID 48135 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48135,
      GIR_EraseRootFromParent_Done,
    // Label 28641: @2343392
    GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2343440), // Rule ID 48140 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48140,
      GIR_EraseRootFromParent_Done,
    // Label 28642: @2343440
    GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2343488), // Rule ID 48141 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48141,
      GIR_EraseRootFromParent_Done,
    // Label 28643: @2343488
    GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2343536), // Rule ID 48148 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48148,
      GIR_EraseRootFromParent_Done,
    // Label 28644: @2343536
    GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2343584), // Rule ID 48149 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48149,
      GIR_EraseRootFromParent_Done,
    // Label 28645: @2343584
    GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2343632), // Rule ID 48170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48170,
      GIR_EraseRootFromParent_Done,
    // Label 28646: @2343632
    GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2343680), // Rule ID 48171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48171,
      GIR_EraseRootFromParent_Done,
    // Label 28647: @2343680
    GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2343728), // Rule ID 48176 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48176,
      GIR_EraseRootFromParent_Done,
    // Label 28648: @2343728
    GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2343776), // Rule ID 48177 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48177,
      GIR_EraseRootFromParent_Done,
    // Label 28649: @2343776
    GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2343824), // Rule ID 48182 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48182,
      GIR_EraseRootFromParent_Done,
    // Label 28650: @2343824
    GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2343872), // Rule ID 48183 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48183,
      GIR_EraseRootFromParent_Done,
    // Label 28651: @2343872
    GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2343920), // Rule ID 48190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48190,
      GIR_EraseRootFromParent_Done,
    // Label 28652: @2343920
    GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2343968), // Rule ID 48191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48191,
      GIR_EraseRootFromParent_Done,
    // Label 28653: @2343968
    GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2344016), // Rule ID 48212 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48212,
      GIR_EraseRootFromParent_Done,
    // Label 28654: @2344016
    GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2344064), // Rule ID 48213 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48213,
      GIR_EraseRootFromParent_Done,
    // Label 28655: @2344064
    GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2344112), // Rule ID 48220 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48220,
      GIR_EraseRootFromParent_Done,
    // Label 28656: @2344112
    GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2344160), // Rule ID 48221 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48221,
      GIR_EraseRootFromParent_Done,
    // Label 28657: @2344160
    GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2344208), // Rule ID 48226 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48226,
      GIR_EraseRootFromParent_Done,
    // Label 28658: @2344208
    GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2344256), // Rule ID 48227 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48227,
      GIR_EraseRootFromParent_Done,
    // Label 28659: @2344256
    GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2344304), // Rule ID 48234 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48234,
      GIR_EraseRootFromParent_Done,
    // Label 28660: @2344304
    GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2344352), // Rule ID 48235 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48235,
      GIR_EraseRootFromParent_Done,
    // Label 28661: @2344352
    GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2344400), // Rule ID 48256 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48256,
      GIR_EraseRootFromParent_Done,
    // Label 28662: @2344400
    GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2344448), // Rule ID 48257 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48257,
      GIR_EraseRootFromParent_Done,
    // Label 28663: @2344448
    GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2344496), // Rule ID 48264 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48264,
      GIR_EraseRootFromParent_Done,
    // Label 28664: @2344496
    GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2344544), // Rule ID 48265 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48265,
      GIR_EraseRootFromParent_Done,
    // Label 28665: @2344544
    GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2344592), // Rule ID 48270 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48270,
      GIR_EraseRootFromParent_Done,
    // Label 28666: @2344592
    GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2344640), // Rule ID 48271 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48271,
      GIR_EraseRootFromParent_Done,
    // Label 28667: @2344640
    GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2344688), // Rule ID 48278 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48278,
      GIR_EraseRootFromParent_Done,
    // Label 28668: @2344688
    GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2344736), // Rule ID 48279 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48279,
      GIR_EraseRootFromParent_Done,
    // Label 28669: @2344736
    GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2344784), // Rule ID 48300 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48300,
      GIR_EraseRootFromParent_Done,
    // Label 28670: @2344784
    GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2344832), // Rule ID 48301 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48301,
      GIR_EraseRootFromParent_Done,
    // Label 28671: @2344832
    GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2344880), // Rule ID 48308 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48308,
      GIR_EraseRootFromParent_Done,
    // Label 28672: @2344880
    GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2344928), // Rule ID 48309 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48309,
      GIR_EraseRootFromParent_Done,
    // Label 28673: @2344928
    GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2344976), // Rule ID 48314 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48314,
      GIR_EraseRootFromParent_Done,
    // Label 28674: @2344976
    GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2345024), // Rule ID 48315 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48315,
      GIR_EraseRootFromParent_Done,
    // Label 28675: @2345024
    GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2345072), // Rule ID 48322 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48322,
      GIR_EraseRootFromParent_Done,
    // Label 28676: @2345072
    GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2345120), // Rule ID 48323 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48323,
      GIR_EraseRootFromParent_Done,
    // Label 28677: @2345120
    GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2345168), // Rule ID 48344 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48344,
      GIR_EraseRootFromParent_Done,
    // Label 28678: @2345168
    GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2345216), // Rule ID 48345 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48345,
      GIR_EraseRootFromParent_Done,
    // Label 28679: @2345216
    GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2345264), // Rule ID 48352 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48352,
      GIR_EraseRootFromParent_Done,
    // Label 28680: @2345264
    GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2345312), // Rule ID 48353 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48353,
      GIR_EraseRootFromParent_Done,
    // Label 28681: @2345312
    GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2345360), // Rule ID 48358 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48358,
      GIR_EraseRootFromParent_Done,
    // Label 28682: @2345360
    GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2345408), // Rule ID 48359 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48359,
      GIR_EraseRootFromParent_Done,
    // Label 28683: @2345408
    GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2345456), // Rule ID 48366 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48366,
      GIR_EraseRootFromParent_Done,
    // Label 28684: @2345456
    GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2345504), // Rule ID 48367 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48367,
      GIR_EraseRootFromParent_Done,
    // Label 28685: @2345504
    GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2345552), // Rule ID 48388 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48388,
      GIR_EraseRootFromParent_Done,
    // Label 28686: @2345552
    GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2345600), // Rule ID 48389 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48389,
      GIR_EraseRootFromParent_Done,
    // Label 28687: @2345600
    GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2345648), // Rule ID 48396 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48396,
      GIR_EraseRootFromParent_Done,
    // Label 28688: @2345648
    GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2345696), // Rule ID 48397 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48397,
      GIR_EraseRootFromParent_Done,
    // Label 28689: @2345696
    GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2345744), // Rule ID 48402 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48402,
      GIR_EraseRootFromParent_Done,
    // Label 28690: @2345744
    GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2345792), // Rule ID 48403 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48403,
      GIR_EraseRootFromParent_Done,
    // Label 28691: @2345792
    GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2345840), // Rule ID 48410 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48410,
      GIR_EraseRootFromParent_Done,
    // Label 28692: @2345840
    GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2345888), // Rule ID 48411 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48411,
      GIR_EraseRootFromParent_Done,
    // Label 28693: @2345888
    GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2345936), // Rule ID 48432 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48432,
      GIR_EraseRootFromParent_Done,
    // Label 28694: @2345936
    GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2345984), // Rule ID 48433 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48433,
      GIR_EraseRootFromParent_Done,
    // Label 28695: @2345984
    GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2346032), // Rule ID 48440 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48440,
      GIR_EraseRootFromParent_Done,
    // Label 28696: @2346032
    GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2346080), // Rule ID 48441 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48441,
      GIR_EraseRootFromParent_Done,
    // Label 28697: @2346080
    GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2346128), // Rule ID 48446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48446,
      GIR_EraseRootFromParent_Done,
    // Label 28698: @2346128
    GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2346176), // Rule ID 48447 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48447,
      GIR_EraseRootFromParent_Done,
    // Label 28699: @2346176
    GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2346224), // Rule ID 48454 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48454,
      GIR_EraseRootFromParent_Done,
    // Label 28700: @2346224
    GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2346272), // Rule ID 48455 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48455,
      GIR_EraseRootFromParent_Done,
    // Label 28701: @2346272
    GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2346320), // Rule ID 48476 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48476,
      GIR_EraseRootFromParent_Done,
    // Label 28702: @2346320
    GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2346368), // Rule ID 48477 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48477,
      GIR_EraseRootFromParent_Done,
    // Label 28703: @2346368
    GIM_Reject,
    // Label 28444: @2346369
    GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2346417), // Rule ID 48048 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48048,
      GIR_EraseRootFromParent_Done,
    // Label 28704: @2346417
    GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2346465), // Rule ID 48049 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48049,
      GIR_EraseRootFromParent_Done,
    // Label 28705: @2346465
    GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2346513), // Rule ID 48058 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48058,
      GIR_EraseRootFromParent_Done,
    // Label 28706: @2346513
    GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2346561), // Rule ID 48059 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48059,
      GIR_EraseRootFromParent_Done,
    // Label 28707: @2346561
    GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2346609), // Rule ID 48076 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48076,
      GIR_EraseRootFromParent_Done,
    // Label 28708: @2346609
    GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2346657), // Rule ID 48077 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48077,
      GIR_EraseRootFromParent_Done,
    // Label 28709: @2346657
    GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2346705), // Rule ID 48084 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48084,
      GIR_EraseRootFromParent_Done,
    // Label 28710: @2346705
    GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2346753), // Rule ID 48085 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48085,
      GIR_EraseRootFromParent_Done,
    // Label 28711: @2346753
    GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2346801), // Rule ID 48092 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48092,
      GIR_EraseRootFromParent_Done,
    // Label 28712: @2346801
    GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2346849), // Rule ID 48093 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48093,
      GIR_EraseRootFromParent_Done,
    // Label 28713: @2346849
    GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2346897), // Rule ID 48102 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48102,
      GIR_EraseRootFromParent_Done,
    // Label 28714: @2346897
    GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2346945), // Rule ID 48103 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48103,
      GIR_EraseRootFromParent_Done,
    // Label 28715: @2346945
    GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2346993), // Rule ID 48120 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48120,
      GIR_EraseRootFromParent_Done,
    // Label 28716: @2346993
    GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2347041), // Rule ID 48121 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48121,
      GIR_EraseRootFromParent_Done,
    // Label 28717: @2347041
    GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2347089), // Rule ID 48128 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48128,
      GIR_EraseRootFromParent_Done,
    // Label 28718: @2347089
    GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2347137), // Rule ID 48129 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48129,
      GIR_EraseRootFromParent_Done,
    // Label 28719: @2347137
    GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2347185), // Rule ID 48136 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48136,
      GIR_EraseRootFromParent_Done,
    // Label 28720: @2347185
    GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2347233), // Rule ID 48137 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48137,
      GIR_EraseRootFromParent_Done,
    // Label 28721: @2347233
    GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2347281), // Rule ID 48146 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48146,
      GIR_EraseRootFromParent_Done,
    // Label 28722: @2347281
    GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2347329), // Rule ID 48147 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48147,
      GIR_EraseRootFromParent_Done,
    // Label 28723: @2347329
    GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2347377), // Rule ID 48164 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48164,
      GIR_EraseRootFromParent_Done,
    // Label 28724: @2347377
    GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2347425), // Rule ID 48165 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48165,
      GIR_EraseRootFromParent_Done,
    // Label 28725: @2347425
    GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2347473), // Rule ID 48172 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48172,
      GIR_EraseRootFromParent_Done,
    // Label 28726: @2347473
    GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2347521), // Rule ID 48173 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48173,
      GIR_EraseRootFromParent_Done,
    // Label 28727: @2347521
    GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2347569), // Rule ID 48178 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48178,
      GIR_EraseRootFromParent_Done,
    // Label 28728: @2347569
    GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2347617), // Rule ID 48179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48179,
      GIR_EraseRootFromParent_Done,
    // Label 28729: @2347617
    GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2347665), // Rule ID 48188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48188,
      GIR_EraseRootFromParent_Done,
    // Label 28730: @2347665
    GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2347713), // Rule ID 48189 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48189,
      GIR_EraseRootFromParent_Done,
    // Label 28731: @2347713
    GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2347761), // Rule ID 48206 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48206,
      GIR_EraseRootFromParent_Done,
    // Label 28732: @2347761
    GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2347809), // Rule ID 48207 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48207,
      GIR_EraseRootFromParent_Done,
    // Label 28733: @2347809
    GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2347857), // Rule ID 48214 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48214,
      GIR_EraseRootFromParent_Done,
    // Label 28734: @2347857
    GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2347905), // Rule ID 48215 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48215,
      GIR_EraseRootFromParent_Done,
    // Label 28735: @2347905
    GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2347953), // Rule ID 48222 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48222,
      GIR_EraseRootFromParent_Done,
    // Label 28736: @2347953
    GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2348001), // Rule ID 48223 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48223,
      GIR_EraseRootFromParent_Done,
    // Label 28737: @2348001
    GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2348049), // Rule ID 48232 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48232,
      GIR_EraseRootFromParent_Done,
    // Label 28738: @2348049
    GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2348097), // Rule ID 48233 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48233,
      GIR_EraseRootFromParent_Done,
    // Label 28739: @2348097
    GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2348145), // Rule ID 48250 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48250,
      GIR_EraseRootFromParent_Done,
    // Label 28740: @2348145
    GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2348193), // Rule ID 48251 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48251,
      GIR_EraseRootFromParent_Done,
    // Label 28741: @2348193
    GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2348241), // Rule ID 48258 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48258,
      GIR_EraseRootFromParent_Done,
    // Label 28742: @2348241
    GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2348289), // Rule ID 48259 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48259,
      GIR_EraseRootFromParent_Done,
    // Label 28743: @2348289
    GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2348337), // Rule ID 48266 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48266,
      GIR_EraseRootFromParent_Done,
    // Label 28744: @2348337
    GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2348385), // Rule ID 48267 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48267,
      GIR_EraseRootFromParent_Done,
    // Label 28745: @2348385
    GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2348433), // Rule ID 48276 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48276,
      GIR_EraseRootFromParent_Done,
    // Label 28746: @2348433
    GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2348481), // Rule ID 48277 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48277,
      GIR_EraseRootFromParent_Done,
    // Label 28747: @2348481
    GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2348529), // Rule ID 48294 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48294,
      GIR_EraseRootFromParent_Done,
    // Label 28748: @2348529
    GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2348577), // Rule ID 48295 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48295,
      GIR_EraseRootFromParent_Done,
    // Label 28749: @2348577
    GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2348625), // Rule ID 48302 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48302,
      GIR_EraseRootFromParent_Done,
    // Label 28750: @2348625
    GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2348673), // Rule ID 48303 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48303,
      GIR_EraseRootFromParent_Done,
    // Label 28751: @2348673
    GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2348721), // Rule ID 48310 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48310,
      GIR_EraseRootFromParent_Done,
    // Label 28752: @2348721
    GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2348769), // Rule ID 48311 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48311,
      GIR_EraseRootFromParent_Done,
    // Label 28753: @2348769
    GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2348817), // Rule ID 48320 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48320,
      GIR_EraseRootFromParent_Done,
    // Label 28754: @2348817
    GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2348865), // Rule ID 48321 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48321,
      GIR_EraseRootFromParent_Done,
    // Label 28755: @2348865
    GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2348913), // Rule ID 48338 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48338,
      GIR_EraseRootFromParent_Done,
    // Label 28756: @2348913
    GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2348961), // Rule ID 48339 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48339,
      GIR_EraseRootFromParent_Done,
    // Label 28757: @2348961
    GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2349009), // Rule ID 48346 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48346,
      GIR_EraseRootFromParent_Done,
    // Label 28758: @2349009
    GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2349057), // Rule ID 48347 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48347,
      GIR_EraseRootFromParent_Done,
    // Label 28759: @2349057
    GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2349105), // Rule ID 48354 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48354,
      GIR_EraseRootFromParent_Done,
    // Label 28760: @2349105
    GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2349153), // Rule ID 48355 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48355,
      GIR_EraseRootFromParent_Done,
    // Label 28761: @2349153
    GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2349201), // Rule ID 48364 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48364,
      GIR_EraseRootFromParent_Done,
    // Label 28762: @2349201
    GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2349249), // Rule ID 48365 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48365,
      GIR_EraseRootFromParent_Done,
    // Label 28763: @2349249
    GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2349297), // Rule ID 48382 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48382,
      GIR_EraseRootFromParent_Done,
    // Label 28764: @2349297
    GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2349345), // Rule ID 48383 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48383,
      GIR_EraseRootFromParent_Done,
    // Label 28765: @2349345
    GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2349393), // Rule ID 48390 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48390,
      GIR_EraseRootFromParent_Done,
    // Label 28766: @2349393
    GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2349441), // Rule ID 48391 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48391,
      GIR_EraseRootFromParent_Done,
    // Label 28767: @2349441
    GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2349489), // Rule ID 48398 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48398,
      GIR_EraseRootFromParent_Done,
    // Label 28768: @2349489
    GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2349537), // Rule ID 48399 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48399,
      GIR_EraseRootFromParent_Done,
    // Label 28769: @2349537
    GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2349585), // Rule ID 48408 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48408,
      GIR_EraseRootFromParent_Done,
    // Label 28770: @2349585
    GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2349633), // Rule ID 48409 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48409,
      GIR_EraseRootFromParent_Done,
    // Label 28771: @2349633
    GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2349681), // Rule ID 48426 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48426,
      GIR_EraseRootFromParent_Done,
    // Label 28772: @2349681
    GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2349729), // Rule ID 48427 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48427,
      GIR_EraseRootFromParent_Done,
    // Label 28773: @2349729
    GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2349777), // Rule ID 48434 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48434,
      GIR_EraseRootFromParent_Done,
    // Label 28774: @2349777
    GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2349825), // Rule ID 48435 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48435,
      GIR_EraseRootFromParent_Done,
    // Label 28775: @2349825
    GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2349873), // Rule ID 48442 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48442,
      GIR_EraseRootFromParent_Done,
    // Label 28776: @2349873
    GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2349921), // Rule ID 48443 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48443,
      GIR_EraseRootFromParent_Done,
    // Label 28777: @2349921
    GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2349969), // Rule ID 48452 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48452,
      GIR_EraseRootFromParent_Done,
    // Label 28778: @2349969
    GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2350017), // Rule ID 48453 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48453,
      GIR_EraseRootFromParent_Done,
    // Label 28779: @2350017
    GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2350065), // Rule ID 48470 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48470,
      GIR_EraseRootFromParent_Done,
    // Label 28780: @2350065
    GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2350113), // Rule ID 48471 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48471,
      GIR_EraseRootFromParent_Done,
    // Label 28781: @2350113
    GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2350161), // Rule ID 48478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48478,
      GIR_EraseRootFromParent_Done,
    // Label 28782: @2350161
    GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2350209), // Rule ID 48479 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48479,
      GIR_EraseRootFromParent_Done,
    // Label 28783: @2350209
    GIM_Reject,
    // Label 28445: @2350210
    GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2350258), // Rule ID 48056 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48056,
      GIR_EraseRootFromParent_Done,
    // Label 28784: @2350258
    GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2350306), // Rule ID 48057 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48057,
      GIR_EraseRootFromParent_Done,
    // Label 28785: @2350306
    GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2350354), // Rule ID 48070 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48070,
      GIR_EraseRootFromParent_Done,
    // Label 28786: @2350354
    GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2350402), // Rule ID 48071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48071,
      GIR_EraseRootFromParent_Done,
    // Label 28787: @2350402
    GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2350450), // Rule ID 48078 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48078,
      GIR_EraseRootFromParent_Done,
    // Label 28788: @2350450
    GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2350498), // Rule ID 48079 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48079,
      GIR_EraseRootFromParent_Done,
    // Label 28789: @2350498
    GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2350546), // Rule ID 48086 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48086,
      GIR_EraseRootFromParent_Done,
    // Label 28790: @2350546
    GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2350594), // Rule ID 48087 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48087,
      GIR_EraseRootFromParent_Done,
    // Label 28791: @2350594
    GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2350642), // Rule ID 48100 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48100,
      GIR_EraseRootFromParent_Done,
    // Label 28792: @2350642
    GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2350690), // Rule ID 48101 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48101,
      GIR_EraseRootFromParent_Done,
    // Label 28793: @2350690
    GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2350738), // Rule ID 48114 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48114,
      GIR_EraseRootFromParent_Done,
    // Label 28794: @2350738
    GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2350786), // Rule ID 48115 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48115,
      GIR_EraseRootFromParent_Done,
    // Label 28795: @2350786
    GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2350834), // Rule ID 48122 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48122,
      GIR_EraseRootFromParent_Done,
    // Label 28796: @2350834
    GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2350882), // Rule ID 48123 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48123,
      GIR_EraseRootFromParent_Done,
    // Label 28797: @2350882
    GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2350930), // Rule ID 48130 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48130,
      GIR_EraseRootFromParent_Done,
    // Label 28798: @2350930
    GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2350978), // Rule ID 48131 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48131,
      GIR_EraseRootFromParent_Done,
    // Label 28799: @2350978
    GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2351026), // Rule ID 48144 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48144,
      GIR_EraseRootFromParent_Done,
    // Label 28800: @2351026
    GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2351074), // Rule ID 48145 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48145,
      GIR_EraseRootFromParent_Done,
    // Label 28801: @2351074
    GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2351122), // Rule ID 48158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48158,
      GIR_EraseRootFromParent_Done,
    // Label 28802: @2351122
    GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2351170), // Rule ID 48159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48159,
      GIR_EraseRootFromParent_Done,
    // Label 28803: @2351170
    GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2351218), // Rule ID 48166 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48166,
      GIR_EraseRootFromParent_Done,
    // Label 28804: @2351218
    GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2351266), // Rule ID 48167 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48167,
      GIR_EraseRootFromParent_Done,
    // Label 28805: @2351266
    GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2351314), // Rule ID 48174 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48174,
      GIR_EraseRootFromParent_Done,
    // Label 28806: @2351314
    GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2351362), // Rule ID 48175 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48175,
      GIR_EraseRootFromParent_Done,
    // Label 28807: @2351362
    GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2351410), // Rule ID 48186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48186,
      GIR_EraseRootFromParent_Done,
    // Label 28808: @2351410
    GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2351458), // Rule ID 48187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48187,
      GIR_EraseRootFromParent_Done,
    // Label 28809: @2351458
    GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2351506), // Rule ID 48200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48200,
      GIR_EraseRootFromParent_Done,
    // Label 28810: @2351506
    GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2351554), // Rule ID 48201 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48201,
      GIR_EraseRootFromParent_Done,
    // Label 28811: @2351554
    GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2351602), // Rule ID 48208 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48208,
      GIR_EraseRootFromParent_Done,
    // Label 28812: @2351602
    GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2351650), // Rule ID 48209 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48209,
      GIR_EraseRootFromParent_Done,
    // Label 28813: @2351650
    GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2351698), // Rule ID 48216 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48216,
      GIR_EraseRootFromParent_Done,
    // Label 28814: @2351698
    GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2351746), // Rule ID 48217 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48217,
      GIR_EraseRootFromParent_Done,
    // Label 28815: @2351746
    GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2351794), // Rule ID 48230 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48230,
      GIR_EraseRootFromParent_Done,
    // Label 28816: @2351794
    GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2351842), // Rule ID 48231 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48231,
      GIR_EraseRootFromParent_Done,
    // Label 28817: @2351842
    GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2351890), // Rule ID 48244 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48244,
      GIR_EraseRootFromParent_Done,
    // Label 28818: @2351890
    GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2351938), // Rule ID 48245 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48245,
      GIR_EraseRootFromParent_Done,
    // Label 28819: @2351938
    GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2351986), // Rule ID 48252 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48252,
      GIR_EraseRootFromParent_Done,
    // Label 28820: @2351986
    GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2352034), // Rule ID 48253 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48253,
      GIR_EraseRootFromParent_Done,
    // Label 28821: @2352034
    GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2352082), // Rule ID 48260 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48260,
      GIR_EraseRootFromParent_Done,
    // Label 28822: @2352082
    GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2352130), // Rule ID 48261 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48261,
      GIR_EraseRootFromParent_Done,
    // Label 28823: @2352130
    GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2352178), // Rule ID 48274 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48274,
      GIR_EraseRootFromParent_Done,
    // Label 28824: @2352178
    GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2352226), // Rule ID 48275 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48275,
      GIR_EraseRootFromParent_Done,
    // Label 28825: @2352226
    GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2352274), // Rule ID 48288 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48288,
      GIR_EraseRootFromParent_Done,
    // Label 28826: @2352274
    GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2352322), // Rule ID 48289 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48289,
      GIR_EraseRootFromParent_Done,
    // Label 28827: @2352322
    GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2352370), // Rule ID 48296 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48296,
      GIR_EraseRootFromParent_Done,
    // Label 28828: @2352370
    GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2352418), // Rule ID 48297 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48297,
      GIR_EraseRootFromParent_Done,
    // Label 28829: @2352418
    GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2352466), // Rule ID 48304 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48304,
      GIR_EraseRootFromParent_Done,
    // Label 28830: @2352466
    GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2352514), // Rule ID 48305 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48305,
      GIR_EraseRootFromParent_Done,
    // Label 28831: @2352514
    GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2352562), // Rule ID 48318 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48318,
      GIR_EraseRootFromParent_Done,
    // Label 28832: @2352562
    GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2352610), // Rule ID 48319 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48319,
      GIR_EraseRootFromParent_Done,
    // Label 28833: @2352610
    GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2352658), // Rule ID 48332 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48332,
      GIR_EraseRootFromParent_Done,
    // Label 28834: @2352658
    GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2352706), // Rule ID 48333 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48333,
      GIR_EraseRootFromParent_Done,
    // Label 28835: @2352706
    GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2352754), // Rule ID 48340 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48340,
      GIR_EraseRootFromParent_Done,
    // Label 28836: @2352754
    GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2352802), // Rule ID 48341 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48341,
      GIR_EraseRootFromParent_Done,
    // Label 28837: @2352802
    GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2352850), // Rule ID 48348 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48348,
      GIR_EraseRootFromParent_Done,
    // Label 28838: @2352850
    GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2352898), // Rule ID 48349 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48349,
      GIR_EraseRootFromParent_Done,
    // Label 28839: @2352898
    GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2352946), // Rule ID 48362 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48362,
      GIR_EraseRootFromParent_Done,
    // Label 28840: @2352946
    GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2352994), // Rule ID 48363 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48363,
      GIR_EraseRootFromParent_Done,
    // Label 28841: @2352994
    GIM_Try, /*On fail goto*//*Label 28842*/ GIMT_Encode4(2353042), // Rule ID 48376 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48376,
      GIR_EraseRootFromParent_Done,
    // Label 28842: @2353042
    GIM_Try, /*On fail goto*//*Label 28843*/ GIMT_Encode4(2353090), // Rule ID 48377 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48377,
      GIR_EraseRootFromParent_Done,
    // Label 28843: @2353090
    GIM_Try, /*On fail goto*//*Label 28844*/ GIMT_Encode4(2353138), // Rule ID 48384 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48384,
      GIR_EraseRootFromParent_Done,
    // Label 28844: @2353138
    GIM_Try, /*On fail goto*//*Label 28845*/ GIMT_Encode4(2353186), // Rule ID 48385 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48385,
      GIR_EraseRootFromParent_Done,
    // Label 28845: @2353186
    GIM_Try, /*On fail goto*//*Label 28846*/ GIMT_Encode4(2353234), // Rule ID 48392 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48392,
      GIR_EraseRootFromParent_Done,
    // Label 28846: @2353234
    GIM_Try, /*On fail goto*//*Label 28847*/ GIMT_Encode4(2353282), // Rule ID 48393 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48393,
      GIR_EraseRootFromParent_Done,
    // Label 28847: @2353282
    GIM_Try, /*On fail goto*//*Label 28848*/ GIMT_Encode4(2353330), // Rule ID 48406 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48406,
      GIR_EraseRootFromParent_Done,
    // Label 28848: @2353330
    GIM_Try, /*On fail goto*//*Label 28849*/ GIMT_Encode4(2353378), // Rule ID 48407 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48407,
      GIR_EraseRootFromParent_Done,
    // Label 28849: @2353378
    GIM_Try, /*On fail goto*//*Label 28850*/ GIMT_Encode4(2353426), // Rule ID 48420 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48420,
      GIR_EraseRootFromParent_Done,
    // Label 28850: @2353426
    GIM_Try, /*On fail goto*//*Label 28851*/ GIMT_Encode4(2353474), // Rule ID 48421 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48421,
      GIR_EraseRootFromParent_Done,
    // Label 28851: @2353474
    GIM_Try, /*On fail goto*//*Label 28852*/ GIMT_Encode4(2353522), // Rule ID 48428 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48428,
      GIR_EraseRootFromParent_Done,
    // Label 28852: @2353522
    GIM_Try, /*On fail goto*//*Label 28853*/ GIMT_Encode4(2353570), // Rule ID 48429 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48429,
      GIR_EraseRootFromParent_Done,
    // Label 28853: @2353570
    GIM_Try, /*On fail goto*//*Label 28854*/ GIMT_Encode4(2353618), // Rule ID 48436 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48436,
      GIR_EraseRootFromParent_Done,
    // Label 28854: @2353618
    GIM_Try, /*On fail goto*//*Label 28855*/ GIMT_Encode4(2353666), // Rule ID 48437 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48437,
      GIR_EraseRootFromParent_Done,
    // Label 28855: @2353666
    GIM_Try, /*On fail goto*//*Label 28856*/ GIMT_Encode4(2353714), // Rule ID 48450 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48450,
      GIR_EraseRootFromParent_Done,
    // Label 28856: @2353714
    GIM_Try, /*On fail goto*//*Label 28857*/ GIMT_Encode4(2353762), // Rule ID 48451 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48451,
      GIR_EraseRootFromParent_Done,
    // Label 28857: @2353762
    GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2353810), // Rule ID 48464 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48464,
      GIR_EraseRootFromParent_Done,
    // Label 28858: @2353810
    GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2353858), // Rule ID 48465 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48465,
      GIR_EraseRootFromParent_Done,
    // Label 28859: @2353858
    GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2353906), // Rule ID 48472 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48472,
      GIR_EraseRootFromParent_Done,
    // Label 28860: @2353906
    GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2353954), // Rule ID 48473 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48473,
      GIR_EraseRootFromParent_Done,
    // Label 28861: @2353954
    GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2354002), // Rule ID 48480 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48480,
      GIR_EraseRootFromParent_Done,
    // Label 28862: @2354002
    GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2354050), // Rule ID 48481 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48481,
      GIR_EraseRootFromParent_Done,
    // Label 28863: @2354050
    GIM_Reject,
    // Label 28446: @2354051
    GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2354099), // Rule ID 48064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48064,
      GIR_EraseRootFromParent_Done,
    // Label 28864: @2354099
    GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2354147), // Rule ID 48065 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48065,
      GIR_EraseRootFromParent_Done,
    // Label 28865: @2354147
    GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2354195), // Rule ID 48072 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48072,
      GIR_EraseRootFromParent_Done,
    // Label 28866: @2354195
    GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2354243), // Rule ID 48073 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48073,
      GIR_EraseRootFromParent_Done,
    // Label 28867: @2354243
    GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2354291), // Rule ID 48080 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48080,
      GIR_EraseRootFromParent_Done,
    // Label 28868: @2354291
    GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2354339), // Rule ID 48081 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48081,
      GIR_EraseRootFromParent_Done,
    // Label 28869: @2354339
    GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2354387), // Rule ID 48108 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48108,
      GIR_EraseRootFromParent_Done,
    // Label 28870: @2354387
    GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2354435), // Rule ID 48109 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48109,
      GIR_EraseRootFromParent_Done,
    // Label 28871: @2354435
    GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2354483), // Rule ID 48116 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48116,
      GIR_EraseRootFromParent_Done,
    // Label 28872: @2354483
    GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2354531), // Rule ID 48117 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48117,
      GIR_EraseRootFromParent_Done,
    // Label 28873: @2354531
    GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2354579), // Rule ID 48124 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48124,
      GIR_EraseRootFromParent_Done,
    // Label 28874: @2354579
    GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2354627), // Rule ID 48125 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48125,
      GIR_EraseRootFromParent_Done,
    // Label 28875: @2354627
    GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2354675), // Rule ID 48152 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48152,
      GIR_EraseRootFromParent_Done,
    // Label 28876: @2354675
    GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2354723), // Rule ID 48153 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48153,
      GIR_EraseRootFromParent_Done,
    // Label 28877: @2354723
    GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2354771), // Rule ID 48160 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48160,
      GIR_EraseRootFromParent_Done,
    // Label 28878: @2354771
    GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2354819), // Rule ID 48161 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48161,
      GIR_EraseRootFromParent_Done,
    // Label 28879: @2354819
    GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2354867), // Rule ID 48168 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48168,
      GIR_EraseRootFromParent_Done,
    // Label 28880: @2354867
    GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2354915), // Rule ID 48169 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48169,
      GIR_EraseRootFromParent_Done,
    // Label 28881: @2354915
    GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2354963), // Rule ID 48194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48194,
      GIR_EraseRootFromParent_Done,
    // Label 28882: @2354963
    GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2355011), // Rule ID 48195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48195,
      GIR_EraseRootFromParent_Done,
    // Label 28883: @2355011
    GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2355059), // Rule ID 48202 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48202,
      GIR_EraseRootFromParent_Done,
    // Label 28884: @2355059
    GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2355107), // Rule ID 48203 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48203,
      GIR_EraseRootFromParent_Done,
    // Label 28885: @2355107
    GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2355155), // Rule ID 48210 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48210,
      GIR_EraseRootFromParent_Done,
    // Label 28886: @2355155
    GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2355203), // Rule ID 48211 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48211,
      GIR_EraseRootFromParent_Done,
    // Label 28887: @2355203
    GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2355251), // Rule ID 48238 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48238,
      GIR_EraseRootFromParent_Done,
    // Label 28888: @2355251
    GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2355299), // Rule ID 48239 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48239,
      GIR_EraseRootFromParent_Done,
    // Label 28889: @2355299
    GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2355347), // Rule ID 48246 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48246,
      GIR_EraseRootFromParent_Done,
    // Label 28890: @2355347
    GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2355395), // Rule ID 48247 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48247,
      GIR_EraseRootFromParent_Done,
    // Label 28891: @2355395
    GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2355443), // Rule ID 48254 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48254,
      GIR_EraseRootFromParent_Done,
    // Label 28892: @2355443
    GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2355491), // Rule ID 48255 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48255,
      GIR_EraseRootFromParent_Done,
    // Label 28893: @2355491
    GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2355539), // Rule ID 48282 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48282,
      GIR_EraseRootFromParent_Done,
    // Label 28894: @2355539
    GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2355587), // Rule ID 48283 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48283,
      GIR_EraseRootFromParent_Done,
    // Label 28895: @2355587
    GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2355635), // Rule ID 48290 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48290,
      GIR_EraseRootFromParent_Done,
    // Label 28896: @2355635
    GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2355683), // Rule ID 48291 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48291,
      GIR_EraseRootFromParent_Done,
    // Label 28897: @2355683
    GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2355731), // Rule ID 48298 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48298,
      GIR_EraseRootFromParent_Done,
    // Label 28898: @2355731
    GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2355779), // Rule ID 48299 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48299,
      GIR_EraseRootFromParent_Done,
    // Label 28899: @2355779
    GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2355827), // Rule ID 48326 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48326,
      GIR_EraseRootFromParent_Done,
    // Label 28900: @2355827
    GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2355875), // Rule ID 48327 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48327,
      GIR_EraseRootFromParent_Done,
    // Label 28901: @2355875
    GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2355923), // Rule ID 48334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48334,
      GIR_EraseRootFromParent_Done,
    // Label 28902: @2355923
    GIM_Try, /*On fail goto*//*Label 28903*/ GIMT_Encode4(2355971), // Rule ID 48335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48335,
      GIR_EraseRootFromParent_Done,
    // Label 28903: @2355971
    GIM_Try, /*On fail goto*//*Label 28904*/ GIMT_Encode4(2356019), // Rule ID 48342 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48342,
      GIR_EraseRootFromParent_Done,
    // Label 28904: @2356019
    GIM_Try, /*On fail goto*//*Label 28905*/ GIMT_Encode4(2356067), // Rule ID 48343 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48343,
      GIR_EraseRootFromParent_Done,
    // Label 28905: @2356067
    GIM_Try, /*On fail goto*//*Label 28906*/ GIMT_Encode4(2356115), // Rule ID 48370 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48370,
      GIR_EraseRootFromParent_Done,
    // Label 28906: @2356115
    GIM_Try, /*On fail goto*//*Label 28907*/ GIMT_Encode4(2356163), // Rule ID 48371 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48371,
      GIR_EraseRootFromParent_Done,
    // Label 28907: @2356163
    GIM_Try, /*On fail goto*//*Label 28908*/ GIMT_Encode4(2356211), // Rule ID 48378 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48378,
      GIR_EraseRootFromParent_Done,
    // Label 28908: @2356211
    GIM_Try, /*On fail goto*//*Label 28909*/ GIMT_Encode4(2356259), // Rule ID 48379 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48379,
      GIR_EraseRootFromParent_Done,
    // Label 28909: @2356259
    GIM_Try, /*On fail goto*//*Label 28910*/ GIMT_Encode4(2356307), // Rule ID 48386 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48386,
      GIR_EraseRootFromParent_Done,
    // Label 28910: @2356307
    GIM_Try, /*On fail goto*//*Label 28911*/ GIMT_Encode4(2356355), // Rule ID 48387 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48387,
      GIR_EraseRootFromParent_Done,
    // Label 28911: @2356355
    GIM_Try, /*On fail goto*//*Label 28912*/ GIMT_Encode4(2356403), // Rule ID 48414 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48414,
      GIR_EraseRootFromParent_Done,
    // Label 28912: @2356403
    GIM_Try, /*On fail goto*//*Label 28913*/ GIMT_Encode4(2356451), // Rule ID 48415 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48415,
      GIR_EraseRootFromParent_Done,
    // Label 28913: @2356451
    GIM_Try, /*On fail goto*//*Label 28914*/ GIMT_Encode4(2356499), // Rule ID 48422 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48422,
      GIR_EraseRootFromParent_Done,
    // Label 28914: @2356499
    GIM_Try, /*On fail goto*//*Label 28915*/ GIMT_Encode4(2356547), // Rule ID 48423 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48423,
      GIR_EraseRootFromParent_Done,
    // Label 28915: @2356547
    GIM_Try, /*On fail goto*//*Label 28916*/ GIMT_Encode4(2356595), // Rule ID 48430 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48430,
      GIR_EraseRootFromParent_Done,
    // Label 28916: @2356595
    GIM_Try, /*On fail goto*//*Label 28917*/ GIMT_Encode4(2356643), // Rule ID 48431 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48431,
      GIR_EraseRootFromParent_Done,
    // Label 28917: @2356643
    GIM_Try, /*On fail goto*//*Label 28918*/ GIMT_Encode4(2356691), // Rule ID 48458 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48458,
      GIR_EraseRootFromParent_Done,
    // Label 28918: @2356691
    GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2356739), // Rule ID 48459 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48459,
      GIR_EraseRootFromParent_Done,
    // Label 28919: @2356739
    GIM_Try, /*On fail goto*//*Label 28920*/ GIMT_Encode4(2356787), // Rule ID 48466 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48466,
      GIR_EraseRootFromParent_Done,
    // Label 28920: @2356787
    GIM_Try, /*On fail goto*//*Label 28921*/ GIMT_Encode4(2356835), // Rule ID 48467 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48467,
      GIR_EraseRootFromParent_Done,
    // Label 28921: @2356835
    GIM_Try, /*On fail goto*//*Label 28922*/ GIMT_Encode4(2356883), // Rule ID 48474 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48474,
      GIR_EraseRootFromParent_Done,
    // Label 28922: @2356883
    GIM_Try, /*On fail goto*//*Label 28923*/ GIMT_Encode4(2356931), // Rule ID 48475 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48475,
      GIR_EraseRootFromParent_Done,
    // Label 28923: @2356931
    GIM_Reject,
    // Label 28447: @2356932
    GIM_Try, /*On fail goto*//*Label 28924*/ GIMT_Encode4(2356980), // Rule ID 48066 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48066,
      GIR_EraseRootFromParent_Done,
    // Label 28924: @2356980
    GIM_Try, /*On fail goto*//*Label 28925*/ GIMT_Encode4(2357028), // Rule ID 48067 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48067,
      GIR_EraseRootFromParent_Done,
    // Label 28925: @2357028
    GIM_Try, /*On fail goto*//*Label 28926*/ GIMT_Encode4(2357076), // Rule ID 48074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48074,
      GIR_EraseRootFromParent_Done,
    // Label 28926: @2357076
    GIM_Try, /*On fail goto*//*Label 28927*/ GIMT_Encode4(2357124), // Rule ID 48075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48075,
      GIR_EraseRootFromParent_Done,
    // Label 28927: @2357124
    GIM_Try, /*On fail goto*//*Label 28928*/ GIMT_Encode4(2357172), // Rule ID 48110 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48110,
      GIR_EraseRootFromParent_Done,
    // Label 28928: @2357172
    GIM_Try, /*On fail goto*//*Label 28929*/ GIMT_Encode4(2357220), // Rule ID 48111 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48111,
      GIR_EraseRootFromParent_Done,
    // Label 28929: @2357220
    GIM_Try, /*On fail goto*//*Label 28930*/ GIMT_Encode4(2357268), // Rule ID 48118 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48118,
      GIR_EraseRootFromParent_Done,
    // Label 28930: @2357268
    GIM_Try, /*On fail goto*//*Label 28931*/ GIMT_Encode4(2357316), // Rule ID 48119 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48119,
      GIR_EraseRootFromParent_Done,
    // Label 28931: @2357316
    GIM_Try, /*On fail goto*//*Label 28932*/ GIMT_Encode4(2357364), // Rule ID 48154 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48154,
      GIR_EraseRootFromParent_Done,
    // Label 28932: @2357364
    GIM_Try, /*On fail goto*//*Label 28933*/ GIMT_Encode4(2357412), // Rule ID 48155 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48155,
      GIR_EraseRootFromParent_Done,
    // Label 28933: @2357412
    GIM_Try, /*On fail goto*//*Label 28934*/ GIMT_Encode4(2357460), // Rule ID 48162 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48162,
      GIR_EraseRootFromParent_Done,
    // Label 28934: @2357460
    GIM_Try, /*On fail goto*//*Label 28935*/ GIMT_Encode4(2357508), // Rule ID 48163 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48163,
      GIR_EraseRootFromParent_Done,
    // Label 28935: @2357508
    GIM_Try, /*On fail goto*//*Label 28936*/ GIMT_Encode4(2357556), // Rule ID 48196 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48196,
      GIR_EraseRootFromParent_Done,
    // Label 28936: @2357556
    GIM_Try, /*On fail goto*//*Label 28937*/ GIMT_Encode4(2357604), // Rule ID 48197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48197,
      GIR_EraseRootFromParent_Done,
    // Label 28937: @2357604
    GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2357652), // Rule ID 48204 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48204,
      GIR_EraseRootFromParent_Done,
    // Label 28938: @2357652
    GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2357700), // Rule ID 48205 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48205,
      GIR_EraseRootFromParent_Done,
    // Label 28939: @2357700
    GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2357748), // Rule ID 48240 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48240,
      GIR_EraseRootFromParent_Done,
    // Label 28940: @2357748
    GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2357796), // Rule ID 48241 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48241,
      GIR_EraseRootFromParent_Done,
    // Label 28941: @2357796
    GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2357844), // Rule ID 48248 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48248,
      GIR_EraseRootFromParent_Done,
    // Label 28942: @2357844
    GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2357892), // Rule ID 48249 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48249,
      GIR_EraseRootFromParent_Done,
    // Label 28943: @2357892
    GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2357940), // Rule ID 48284 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48284,
      GIR_EraseRootFromParent_Done,
    // Label 28944: @2357940
    GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2357988), // Rule ID 48285 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48285,
      GIR_EraseRootFromParent_Done,
    // Label 28945: @2357988
    GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2358036), // Rule ID 48292 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48292,
      GIR_EraseRootFromParent_Done,
    // Label 28946: @2358036
    GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2358084), // Rule ID 48293 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48293,
      GIR_EraseRootFromParent_Done,
    // Label 28947: @2358084
    GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2358132), // Rule ID 48328 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48328,
      GIR_EraseRootFromParent_Done,
    // Label 28948: @2358132
    GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2358180), // Rule ID 48329 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48329,
      GIR_EraseRootFromParent_Done,
    // Label 28949: @2358180
    GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2358228), // Rule ID 48336 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48336,
      GIR_EraseRootFromParent_Done,
    // Label 28950: @2358228
    GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2358276), // Rule ID 48337 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48337,
      GIR_EraseRootFromParent_Done,
    // Label 28951: @2358276
    GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2358324), // Rule ID 48372 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48372,
      GIR_EraseRootFromParent_Done,
    // Label 28952: @2358324
    GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2358372), // Rule ID 48373 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48373,
      GIR_EraseRootFromParent_Done,
    // Label 28953: @2358372
    GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2358420), // Rule ID 48380 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48380,
      GIR_EraseRootFromParent_Done,
    // Label 28954: @2358420
    GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2358468), // Rule ID 48381 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48381,
      GIR_EraseRootFromParent_Done,
    // Label 28955: @2358468
    GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2358516), // Rule ID 48416 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48416,
      GIR_EraseRootFromParent_Done,
    // Label 28956: @2358516
    GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2358564), // Rule ID 48417 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48417,
      GIR_EraseRootFromParent_Done,
    // Label 28957: @2358564
    GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2358612), // Rule ID 48424 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48424,
      GIR_EraseRootFromParent_Done,
    // Label 28958: @2358612
    GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2358660), // Rule ID 48425 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48425,
      GIR_EraseRootFromParent_Done,
    // Label 28959: @2358660
    GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2358708), // Rule ID 48460 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48460,
      GIR_EraseRootFromParent_Done,
    // Label 28960: @2358708
    GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2358756), // Rule ID 48461 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48461,
      GIR_EraseRootFromParent_Done,
    // Label 28961: @2358756
    GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2358804), // Rule ID 48468 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48468,
      GIR_EraseRootFromParent_Done,
    // Label 28962: @2358804
    GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2358852), // Rule ID 48469 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/3, // rs1
      GIR_RootToRootCopy, /*OpIdx*/2, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 48469,
      GIR_EraseRootFromParent_Done,
    // Label 28963: @2358852
    GIM_Reject,
    // Label 28448: @2358853
    GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2359629),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2358906), // Rule ID 48068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48068,
        GIR_EraseRootFromParent_Done,
      // Label 28965: @2358906
      GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2358944), // Rule ID 48069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48069,
        GIR_EraseRootFromParent_Done,
      // Label 28966: @2358944
      GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2358982), // Rule ID 48112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48112,
        GIR_EraseRootFromParent_Done,
      // Label 28967: @2358982
      GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2359020), // Rule ID 48113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48113,
        GIR_EraseRootFromParent_Done,
      // Label 28968: @2359020
      GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2359058), // Rule ID 48156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48156,
        GIR_EraseRootFromParent_Done,
      // Label 28969: @2359058
      GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2359096), // Rule ID 48157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48157,
        GIR_EraseRootFromParent_Done,
      // Label 28970: @2359096
      GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2359134), // Rule ID 48198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48198,
        GIR_EraseRootFromParent_Done,
      // Label 28971: @2359134
      GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2359172), // Rule ID 48199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48199,
        GIR_EraseRootFromParent_Done,
      // Label 28972: @2359172
      GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2359210), // Rule ID 48242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48242,
        GIR_EraseRootFromParent_Done,
      // Label 28973: @2359210
      GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2359248), // Rule ID 48243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48243,
        GIR_EraseRootFromParent_Done,
      // Label 28974: @2359248
      GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2359286), // Rule ID 48286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48286,
        GIR_EraseRootFromParent_Done,
      // Label 28975: @2359286
      GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2359324), // Rule ID 48287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48287,
        GIR_EraseRootFromParent_Done,
      // Label 28976: @2359324
      GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2359362), // Rule ID 48330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48330,
        GIR_EraseRootFromParent_Done,
      // Label 28977: @2359362
      GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2359400), // Rule ID 48331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48331,
        GIR_EraseRootFromParent_Done,
      // Label 28978: @2359400
      GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2359438), // Rule ID 48374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48374,
        GIR_EraseRootFromParent_Done,
      // Label 28979: @2359438
      GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2359476), // Rule ID 48375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48375,
        GIR_EraseRootFromParent_Done,
      // Label 28980: @2359476
      GIM_Try, /*On fail goto*//*Label 28981*/ GIMT_Encode4(2359514), // Rule ID 48418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48418,
        GIR_EraseRootFromParent_Done,
      // Label 28981: @2359514
      GIM_Try, /*On fail goto*//*Label 28982*/ GIMT_Encode4(2359552), // Rule ID 48419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48419,
        GIR_EraseRootFromParent_Done,
      // Label 28982: @2359552
      GIM_Try, /*On fail goto*//*Label 28983*/ GIMT_Encode4(2359590), // Rule ID 48462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48462,
        GIR_EraseRootFromParent_Done,
      // Label 28983: @2359590
      GIM_Try, /*On fail goto*//*Label 28984*/ GIMT_Encode4(2359628), // Rule ID 48463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48463,
        GIR_EraseRootFromParent_Done,
      // Label 28984: @2359628
      GIM_Reject,
    // Label 28964: @2359629
    GIM_Reject,
    // Label 28449: @2359630
    GIM_Reject,
    // Label 49: @2359631
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 28993*/ GIMT_Encode4(2367092),
    /*GILLT_s32*//*Label 28985*/ GIMT_Encode4(2359750),
    /*GILLT_s64*//*Label 28986*/ GIMT_Encode4(2360507),
    /*GILLT_nxv1s1*//*Label 28987*/ GIMT_Encode4(2361390), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 28988*/ GIMT_Encode4(2362543), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s1*//*Label 28989*/ GIMT_Encode4(2363696), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s1*//*Label 28990*/ GIMT_Encode4(2364849), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s1*//*Label 28991*/ GIMT_Encode4(2366002), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s1*//*Label 28992*/ GIMT_Encode4(2366771),
    // Label 28985: @2359750
    GIM_Try, /*On fail goto*//*Label 28994*/ GIMT_Encode4(2359792), // Rule ID 1224 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1224,
      GIR_EraseRootFromParent_Done,
    // Label 28994: @2359792
    GIM_Try, /*On fail goto*//*Label 28995*/ GIMT_Encode4(2359834), // Rule ID 1228 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1228,
      GIR_EraseRootFromParent_Done,
    // Label 28995: @2359834
    GIM_Try, /*On fail goto*//*Label 28996*/ GIMT_Encode4(2359876), // Rule ID 1272 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1272,
      GIR_EraseRootFromParent_Done,
    // Label 28996: @2359876
    GIM_Try, /*On fail goto*//*Label 28997*/ GIMT_Encode4(2359918), // Rule ID 1276 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1276,
      GIR_EraseRootFromParent_Done,
    // Label 28997: @2359918
    GIM_Try, /*On fail goto*//*Label 28998*/ GIMT_Encode4(2359960), // Rule ID 1288 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1288,
      GIR_EraseRootFromParent_Done,
    // Label 28998: @2359960
    GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2360002), // Rule ID 1292 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1292,
      GIR_EraseRootFromParent_Done,
    // Label 28999: @2360002
    GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2360044), // Rule ID 1604 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1604,
      GIR_EraseRootFromParent_Done,
    // Label 29000: @2360044
    GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2360086), // Rule ID 1608 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1608,
      GIR_EraseRootFromParent_Done,
    // Label 29001: @2360086
    GIM_Try, /*On fail goto*//*Label 29002*/ GIMT_Encode4(2360128), // Rule ID 1646 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1646,
      GIR_EraseRootFromParent_Done,
    // Label 29002: @2360128
    GIM_Try, /*On fail goto*//*Label 29003*/ GIMT_Encode4(2360170), // Rule ID 1654 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1654,
      GIR_EraseRootFromParent_Done,
    // Label 29003: @2360170
    GIM_Try, /*On fail goto*//*Label 29004*/ GIMT_Encode4(2360212), // Rule ID 1682 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1682,
      GIR_EraseRootFromParent_Done,
    // Label 29004: @2360212
    GIM_Try, /*On fail goto*//*Label 29005*/ GIMT_Encode4(2360254), // Rule ID 1690 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1690,
      GIR_EraseRootFromParent_Done,
    // Label 29005: @2360254
    GIM_Try, /*On fail goto*//*Label 29006*/ GIMT_Encode4(2360296), // Rule ID 1937 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1937,
      GIR_EraseRootFromParent_Done,
    // Label 29006: @2360296
    GIM_Try, /*On fail goto*//*Label 29007*/ GIMT_Encode4(2360338), // Rule ID 1941 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1941,
      GIR_EraseRootFromParent_Done,
    // Label 29007: @2360338
    GIM_Try, /*On fail goto*//*Label 29008*/ GIMT_Encode4(2360380), // Rule ID 1985 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1985,
      GIR_EraseRootFromParent_Done,
    // Label 29008: @2360380
    GIM_Try, /*On fail goto*//*Label 29009*/ GIMT_Encode4(2360422), // Rule ID 1989 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1989,
      GIR_EraseRootFromParent_Done,
    // Label 29009: @2360422
    GIM_Try, /*On fail goto*//*Label 29010*/ GIMT_Encode4(2360464), // Rule ID 2001 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2001,
      GIR_EraseRootFromParent_Done,
    // Label 29010: @2360464
    GIM_Try, /*On fail goto*//*Label 29011*/ GIMT_Encode4(2360506), // Rule ID 2005 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2005,
      GIR_EraseRootFromParent_Done,
    // Label 29011: @2360506
    GIM_Reject,
    // Label 28986: @2360507
    GIM_Try, /*On fail goto*//*Label 29012*/ GIMT_Encode4(2360549), // Rule ID 1223 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1223,
      GIR_EraseRootFromParent_Done,
    // Label 29012: @2360549
    GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2360591), // Rule ID 1227 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1227,
      GIR_EraseRootFromParent_Done,
    // Label 29013: @2360591
    GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2360633), // Rule ID 1271 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1271,
      GIR_EraseRootFromParent_Done,
    // Label 29014: @2360633
    GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2360675), // Rule ID 1275 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1275,
      GIR_EraseRootFromParent_Done,
    // Label 29015: @2360675
    GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2360717), // Rule ID 1287 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1287,
      GIR_EraseRootFromParent_Done,
    // Label 29016: @2360717
    GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2360759), // Rule ID 1291 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1291,
      GIR_EraseRootFromParent_Done,
    // Label 29017: @2360759
    GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2360801), // Rule ID 1603 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1603,
      GIR_EraseRootFromParent_Done,
    // Label 29018: @2360801
    GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2360843), // Rule ID 1607 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1607,
      GIR_EraseRootFromParent_Done,
    // Label 29019: @2360843
    GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2360885), // Rule ID 1610 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1610,
      GIR_EraseRootFromParent_Done,
    // Label 29020: @2360885
    GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2360927), // Rule ID 1645 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1645,
      GIR_EraseRootFromParent_Done,
    // Label 29021: @2360927
    GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2360969), // Rule ID 1653 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1653,
      GIR_EraseRootFromParent_Done,
    // Label 29022: @2360969
    GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2361011), // Rule ID 1662 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1662,
      GIR_EraseRootFromParent_Done,
    // Label 29023: @2361011
    GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2361053), // Rule ID 1666 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1666,
      GIR_EraseRootFromParent_Done,
    // Label 29024: @2361053
    GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2361095), // Rule ID 1681 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1681,
      GIR_EraseRootFromParent_Done,
    // Label 29025: @2361095
    GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2361137), // Rule ID 1689 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1689,
      GIR_EraseRootFromParent_Done,
    // Label 29026: @2361137
    GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2361179), // Rule ID 1936 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1936,
      GIR_EraseRootFromParent_Done,
    // Label 29027: @2361179
    GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2361221), // Rule ID 1940 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1940,
      GIR_EraseRootFromParent_Done,
    // Label 29028: @2361221
    GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2361263), // Rule ID 1984 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1984,
      GIR_EraseRootFromParent_Done,
    // Label 29029: @2361263
    GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2361305), // Rule ID 1988 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1988,
      GIR_EraseRootFromParent_Done,
    // Label 29030: @2361305
    GIM_Try, /*On fail goto*//*Label 29031*/ GIMT_Encode4(2361347), // Rule ID 2000 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2000,
      GIR_EraseRootFromParent_Done,
    // Label 29031: @2361347
    GIM_Try, /*On fail goto*//*Label 29032*/ GIMT_Encode4(2361389), // Rule ID 2004 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2004,
      GIR_EraseRootFromParent_Done,
    // Label 29032: @2361389
    GIM_Reject,
    // Label 28987: @2361390
    GIM_Try, /*On fail goto*//*Label 29033*/ GIMT_Encode4(2361438), // Rule ID 56404 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56404,
      GIR_EraseRootFromParent_Done,
    // Label 29033: @2361438
    GIM_Try, /*On fail goto*//*Label 29034*/ GIMT_Encode4(2361486), // Rule ID 56405 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56405,
      GIR_EraseRootFromParent_Done,
    // Label 29034: @2361486
    GIM_Try, /*On fail goto*//*Label 29035*/ GIMT_Encode4(2361534), // Rule ID 56424 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56424,
      GIR_EraseRootFromParent_Done,
    // Label 29035: @2361534
    GIM_Try, /*On fail goto*//*Label 29036*/ GIMT_Encode4(2361582), // Rule ID 56425 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56425,
      GIR_EraseRootFromParent_Done,
    // Label 29036: @2361582
    GIM_Try, /*On fail goto*//*Label 29037*/ GIMT_Encode4(2361630), // Rule ID 56454 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56454,
      GIR_EraseRootFromParent_Done,
    // Label 29037: @2361630
    GIM_Try, /*On fail goto*//*Label 29038*/ GIMT_Encode4(2361678), // Rule ID 56455 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56455,
      GIR_EraseRootFromParent_Done,
    // Label 29038: @2361678
    GIM_Try, /*On fail goto*//*Label 29039*/ GIMT_Encode4(2361726), // Rule ID 56704 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56704,
      GIR_EraseRootFromParent_Done,
    // Label 29039: @2361726
    GIM_Try, /*On fail goto*//*Label 29040*/ GIMT_Encode4(2361774), // Rule ID 56705 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56705,
      GIR_EraseRootFromParent_Done,
    // Label 29040: @2361774
    GIM_Try, /*On fail goto*//*Label 29041*/ GIMT_Encode4(2361822), // Rule ID 56724 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56724,
      GIR_EraseRootFromParent_Done,
    // Label 29041: @2361822
    GIM_Try, /*On fail goto*//*Label 29042*/ GIMT_Encode4(2361870), // Rule ID 56725 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56725,
      GIR_EraseRootFromParent_Done,
    // Label 29042: @2361870
    GIM_Try, /*On fail goto*//*Label 29043*/ GIMT_Encode4(2361918), // Rule ID 56754 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56754,
      GIR_EraseRootFromParent_Done,
    // Label 29043: @2361918
    GIM_Try, /*On fail goto*//*Label 29044*/ GIMT_Encode4(2361966), // Rule ID 56755 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56755,
      GIR_EraseRootFromParent_Done,
    // Label 29044: @2361966
    GIM_Try, /*On fail goto*//*Label 29045*/ GIMT_Encode4(2362014), // Rule ID 57004 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57004,
      GIR_EraseRootFromParent_Done,
    // Label 29045: @2362014
    GIM_Try, /*On fail goto*//*Label 29046*/ GIMT_Encode4(2362062), // Rule ID 57005 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57005,
      GIR_EraseRootFromParent_Done,
    // Label 29046: @2362062
    GIM_Try, /*On fail goto*//*Label 29047*/ GIMT_Encode4(2362110), // Rule ID 57024 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57024,
      GIR_EraseRootFromParent_Done,
    // Label 29047: @2362110
    GIM_Try, /*On fail goto*//*Label 29048*/ GIMT_Encode4(2362158), // Rule ID 57025 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57025,
      GIR_EraseRootFromParent_Done,
    // Label 29048: @2362158
    GIM_Try, /*On fail goto*//*Label 29049*/ GIMT_Encode4(2362206), // Rule ID 57054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57054,
      GIR_EraseRootFromParent_Done,
    // Label 29049: @2362206
    GIM_Try, /*On fail goto*//*Label 29050*/ GIMT_Encode4(2362254), // Rule ID 57055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57055,
      GIR_EraseRootFromParent_Done,
    // Label 29050: @2362254
    GIM_Try, /*On fail goto*//*Label 29051*/ GIMT_Encode4(2362302), // Rule ID 57304 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57304,
      GIR_EraseRootFromParent_Done,
    // Label 29051: @2362302
    GIM_Try, /*On fail goto*//*Label 29052*/ GIMT_Encode4(2362350), // Rule ID 57305 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57305,
      GIR_EraseRootFromParent_Done,
    // Label 29052: @2362350
    GIM_Try, /*On fail goto*//*Label 29053*/ GIMT_Encode4(2362398), // Rule ID 57324 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57324,
      GIR_EraseRootFromParent_Done,
    // Label 29053: @2362398
    GIM_Try, /*On fail goto*//*Label 29054*/ GIMT_Encode4(2362446), // Rule ID 57325 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57325,
      GIR_EraseRootFromParent_Done,
    // Label 29054: @2362446
    GIM_Try, /*On fail goto*//*Label 29055*/ GIMT_Encode4(2362494), // Rule ID 57354 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57354,
      GIR_EraseRootFromParent_Done,
    // Label 29055: @2362494
    GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2362542), // Rule ID 57355 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57355,
      GIR_EraseRootFromParent_Done,
    // Label 29056: @2362542
    GIM_Reject,
    // Label 28988: @2362543
    GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2362591), // Rule ID 56414 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56414,
      GIR_EraseRootFromParent_Done,
    // Label 29057: @2362591
    GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2362639), // Rule ID 56415 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56415,
      GIR_EraseRootFromParent_Done,
    // Label 29058: @2362639
    GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2362687), // Rule ID 56444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56444,
      GIR_EraseRootFromParent_Done,
    // Label 29059: @2362687
    GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2362735), // Rule ID 56445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56445,
      GIR_EraseRootFromParent_Done,
    // Label 29060: @2362735
    GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2362783), // Rule ID 56524 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56524,
      GIR_EraseRootFromParent_Done,
    // Label 29061: @2362783
    GIM_Try, /*On fail goto*//*Label 29062*/ GIMT_Encode4(2362831), // Rule ID 56525 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56525,
      GIR_EraseRootFromParent_Done,
    // Label 29062: @2362831
    GIM_Try, /*On fail goto*//*Label 29063*/ GIMT_Encode4(2362879), // Rule ID 56714 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56714,
      GIR_EraseRootFromParent_Done,
    // Label 29063: @2362879
    GIM_Try, /*On fail goto*//*Label 29064*/ GIMT_Encode4(2362927), // Rule ID 56715 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56715,
      GIR_EraseRootFromParent_Done,
    // Label 29064: @2362927
    GIM_Try, /*On fail goto*//*Label 29065*/ GIMT_Encode4(2362975), // Rule ID 56744 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56744,
      GIR_EraseRootFromParent_Done,
    // Label 29065: @2362975
    GIM_Try, /*On fail goto*//*Label 29066*/ GIMT_Encode4(2363023), // Rule ID 56745 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56745,
      GIR_EraseRootFromParent_Done,
    // Label 29066: @2363023
    GIM_Try, /*On fail goto*//*Label 29067*/ GIMT_Encode4(2363071), // Rule ID 56824 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56824,
      GIR_EraseRootFromParent_Done,
    // Label 29067: @2363071
    GIM_Try, /*On fail goto*//*Label 29068*/ GIMT_Encode4(2363119), // Rule ID 56825 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56825,
      GIR_EraseRootFromParent_Done,
    // Label 29068: @2363119
    GIM_Try, /*On fail goto*//*Label 29069*/ GIMT_Encode4(2363167), // Rule ID 57014 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57014,
      GIR_EraseRootFromParent_Done,
    // Label 29069: @2363167
    GIM_Try, /*On fail goto*//*Label 29070*/ GIMT_Encode4(2363215), // Rule ID 57015 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57015,
      GIR_EraseRootFromParent_Done,
    // Label 29070: @2363215
    GIM_Try, /*On fail goto*//*Label 29071*/ GIMT_Encode4(2363263), // Rule ID 57044 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57044,
      GIR_EraseRootFromParent_Done,
    // Label 29071: @2363263
    GIM_Try, /*On fail goto*//*Label 29072*/ GIMT_Encode4(2363311), // Rule ID 57045 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57045,
      GIR_EraseRootFromParent_Done,
    // Label 29072: @2363311
    GIM_Try, /*On fail goto*//*Label 29073*/ GIMT_Encode4(2363359), // Rule ID 57124 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57124,
      GIR_EraseRootFromParent_Done,
    // Label 29073: @2363359
    GIM_Try, /*On fail goto*//*Label 29074*/ GIMT_Encode4(2363407), // Rule ID 57125 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57125,
      GIR_EraseRootFromParent_Done,
    // Label 29074: @2363407
    GIM_Try, /*On fail goto*//*Label 29075*/ GIMT_Encode4(2363455), // Rule ID 57314 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57314,
      GIR_EraseRootFromParent_Done,
    // Label 29075: @2363455
    GIM_Try, /*On fail goto*//*Label 29076*/ GIMT_Encode4(2363503), // Rule ID 57315 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57315,
      GIR_EraseRootFromParent_Done,
    // Label 29076: @2363503
    GIM_Try, /*On fail goto*//*Label 29077*/ GIMT_Encode4(2363551), // Rule ID 57344 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57344,
      GIR_EraseRootFromParent_Done,
    // Label 29077: @2363551
    GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2363599), // Rule ID 57345 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57345,
      GIR_EraseRootFromParent_Done,
    // Label 29078: @2363599
    GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2363647), // Rule ID 57424 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57424,
      GIR_EraseRootFromParent_Done,
    // Label 29079: @2363647
    GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2363695), // Rule ID 57425 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57425,
      GIR_EraseRootFromParent_Done,
    // Label 29080: @2363695
    GIM_Reject,
    // Label 28989: @2363696
    GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2363744), // Rule ID 56434 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56434,
      GIR_EraseRootFromParent_Done,
    // Label 29081: @2363744
    GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2363792), // Rule ID 56435 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56435,
      GIR_EraseRootFromParent_Done,
    // Label 29082: @2363792
    GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2363840), // Rule ID 56494 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56494,
      GIR_EraseRootFromParent_Done,
    // Label 29083: @2363840
    GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2363888), // Rule ID 56495 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56495,
      GIR_EraseRootFromParent_Done,
    // Label 29084: @2363888
    GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2363936), // Rule ID 56534 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56534,
      GIR_EraseRootFromParent_Done,
    // Label 29085: @2363936
    GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2363984), // Rule ID 56535 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56535,
      GIR_EraseRootFromParent_Done,
    // Label 29086: @2363984
    GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2364032), // Rule ID 56734 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56734,
      GIR_EraseRootFromParent_Done,
    // Label 29087: @2364032
    GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2364080), // Rule ID 56735 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56735,
      GIR_EraseRootFromParent_Done,
    // Label 29088: @2364080
    GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2364128), // Rule ID 56794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56794,
      GIR_EraseRootFromParent_Done,
    // Label 29089: @2364128
    GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2364176), // Rule ID 56795 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56795,
      GIR_EraseRootFromParent_Done,
    // Label 29090: @2364176
    GIM_Try, /*On fail goto*//*Label 29091*/ GIMT_Encode4(2364224), // Rule ID 56834 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56834,
      GIR_EraseRootFromParent_Done,
    // Label 29091: @2364224
    GIM_Try, /*On fail goto*//*Label 29092*/ GIMT_Encode4(2364272), // Rule ID 56835 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56835,
      GIR_EraseRootFromParent_Done,
    // Label 29092: @2364272
    GIM_Try, /*On fail goto*//*Label 29093*/ GIMT_Encode4(2364320), // Rule ID 57034 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57034,
      GIR_EraseRootFromParent_Done,
    // Label 29093: @2364320
    GIM_Try, /*On fail goto*//*Label 29094*/ GIMT_Encode4(2364368), // Rule ID 57035 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57035,
      GIR_EraseRootFromParent_Done,
    // Label 29094: @2364368
    GIM_Try, /*On fail goto*//*Label 29095*/ GIMT_Encode4(2364416), // Rule ID 57094 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57094,
      GIR_EraseRootFromParent_Done,
    // Label 29095: @2364416
    GIM_Try, /*On fail goto*//*Label 29096*/ GIMT_Encode4(2364464), // Rule ID 57095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57095,
      GIR_EraseRootFromParent_Done,
    // Label 29096: @2364464
    GIM_Try, /*On fail goto*//*Label 29097*/ GIMT_Encode4(2364512), // Rule ID 57134 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57134,
      GIR_EraseRootFromParent_Done,
    // Label 29097: @2364512
    GIM_Try, /*On fail goto*//*Label 29098*/ GIMT_Encode4(2364560), // Rule ID 57135 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57135,
      GIR_EraseRootFromParent_Done,
    // Label 29098: @2364560
    GIM_Try, /*On fail goto*//*Label 29099*/ GIMT_Encode4(2364608), // Rule ID 57334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57334,
      GIR_EraseRootFromParent_Done,
    // Label 29099: @2364608
    GIM_Try, /*On fail goto*//*Label 29100*/ GIMT_Encode4(2364656), // Rule ID 57335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57335,
      GIR_EraseRootFromParent_Done,
    // Label 29100: @2364656
    GIM_Try, /*On fail goto*//*Label 29101*/ GIMT_Encode4(2364704), // Rule ID 57394 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57394,
      GIR_EraseRootFromParent_Done,
    // Label 29101: @2364704
    GIM_Try, /*On fail goto*//*Label 29102*/ GIMT_Encode4(2364752), // Rule ID 57395 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57395,
      GIR_EraseRootFromParent_Done,
    // Label 29102: @2364752
    GIM_Try, /*On fail goto*//*Label 29103*/ GIMT_Encode4(2364800), // Rule ID 57434 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57434,
      GIR_EraseRootFromParent_Done,
    // Label 29103: @2364800
    GIM_Try, /*On fail goto*//*Label 29104*/ GIMT_Encode4(2364848), // Rule ID 57435 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57435,
      GIR_EraseRootFromParent_Done,
    // Label 29104: @2364848
    GIM_Reject,
    // Label 28990: @2364849
    GIM_Try, /*On fail goto*//*Label 29105*/ GIMT_Encode4(2364897), // Rule ID 56464 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56464,
      GIR_EraseRootFromParent_Done,
    // Label 29105: @2364897
    GIM_Try, /*On fail goto*//*Label 29106*/ GIMT_Encode4(2364945), // Rule ID 56465 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56465,
      GIR_EraseRootFromParent_Done,
    // Label 29106: @2364945
    GIM_Try, /*On fail goto*//*Label 29107*/ GIMT_Encode4(2364993), // Rule ID 56504 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56504,
      GIR_EraseRootFromParent_Done,
    // Label 29107: @2364993
    GIM_Try, /*On fail goto*//*Label 29108*/ GIMT_Encode4(2365041), // Rule ID 56505 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56505,
      GIR_EraseRootFromParent_Done,
    // Label 29108: @2365041
    GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2365089), // Rule ID 56544 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56544,
      GIR_EraseRootFromParent_Done,
    // Label 29109: @2365089
    GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2365137), // Rule ID 56545 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56545,
      GIR_EraseRootFromParent_Done,
    // Label 29110: @2365137
    GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2365185), // Rule ID 56764 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56764,
      GIR_EraseRootFromParent_Done,
    // Label 29111: @2365185
    GIM_Try, /*On fail goto*//*Label 29112*/ GIMT_Encode4(2365233), // Rule ID 56765 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56765,
      GIR_EraseRootFromParent_Done,
    // Label 29112: @2365233
    GIM_Try, /*On fail goto*//*Label 29113*/ GIMT_Encode4(2365281), // Rule ID 56804 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56804,
      GIR_EraseRootFromParent_Done,
    // Label 29113: @2365281
    GIM_Try, /*On fail goto*//*Label 29114*/ GIMT_Encode4(2365329), // Rule ID 56805 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56805,
      GIR_EraseRootFromParent_Done,
    // Label 29114: @2365329
    GIM_Try, /*On fail goto*//*Label 29115*/ GIMT_Encode4(2365377), // Rule ID 56844 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56844,
      GIR_EraseRootFromParent_Done,
    // Label 29115: @2365377
    GIM_Try, /*On fail goto*//*Label 29116*/ GIMT_Encode4(2365425), // Rule ID 56845 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56845,
      GIR_EraseRootFromParent_Done,
    // Label 29116: @2365425
    GIM_Try, /*On fail goto*//*Label 29117*/ GIMT_Encode4(2365473), // Rule ID 57064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57064,
      GIR_EraseRootFromParent_Done,
    // Label 29117: @2365473
    GIM_Try, /*On fail goto*//*Label 29118*/ GIMT_Encode4(2365521), // Rule ID 57065 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57065,
      GIR_EraseRootFromParent_Done,
    // Label 29118: @2365521
    GIM_Try, /*On fail goto*//*Label 29119*/ GIMT_Encode4(2365569), // Rule ID 57104 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57104,
      GIR_EraseRootFromParent_Done,
    // Label 29119: @2365569
    GIM_Try, /*On fail goto*//*Label 29120*/ GIMT_Encode4(2365617), // Rule ID 57105 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57105,
      GIR_EraseRootFromParent_Done,
    // Label 29120: @2365617
    GIM_Try, /*On fail goto*//*Label 29121*/ GIMT_Encode4(2365665), // Rule ID 57144 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57144,
      GIR_EraseRootFromParent_Done,
    // Label 29121: @2365665
    GIM_Try, /*On fail goto*//*Label 29122*/ GIMT_Encode4(2365713), // Rule ID 57145 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57145,
      GIR_EraseRootFromParent_Done,
    // Label 29122: @2365713
    GIM_Try, /*On fail goto*//*Label 29123*/ GIMT_Encode4(2365761), // Rule ID 57364 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57364,
      GIR_EraseRootFromParent_Done,
    // Label 29123: @2365761
    GIM_Try, /*On fail goto*//*Label 29124*/ GIMT_Encode4(2365809), // Rule ID 57365 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57365,
      GIR_EraseRootFromParent_Done,
    // Label 29124: @2365809
    GIM_Try, /*On fail goto*//*Label 29125*/ GIMT_Encode4(2365857), // Rule ID 57404 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57404,
      GIR_EraseRootFromParent_Done,
    // Label 29125: @2365857
    GIM_Try, /*On fail goto*//*Label 29126*/ GIMT_Encode4(2365905), // Rule ID 57405 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57405,
      GIR_EraseRootFromParent_Done,
    // Label 29126: @2365905
    GIM_Try, /*On fail goto*//*Label 29127*/ GIMT_Encode4(2365953), // Rule ID 57444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57444,
      GIR_EraseRootFromParent_Done,
    // Label 29127: @2365953
    GIM_Try, /*On fail goto*//*Label 29128*/ GIMT_Encode4(2366001), // Rule ID 57445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57445,
      GIR_EraseRootFromParent_Done,
    // Label 29128: @2366001
    GIM_Reject,
    // Label 28991: @2366002
    GIM_Try, /*On fail goto*//*Label 29129*/ GIMT_Encode4(2366050), // Rule ID 56474 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56474,
      GIR_EraseRootFromParent_Done,
    // Label 29129: @2366050
    GIM_Try, /*On fail goto*//*Label 29130*/ GIMT_Encode4(2366098), // Rule ID 56475 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56475,
      GIR_EraseRootFromParent_Done,
    // Label 29130: @2366098
    GIM_Try, /*On fail goto*//*Label 29131*/ GIMT_Encode4(2366146), // Rule ID 56514 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56514,
      GIR_EraseRootFromParent_Done,
    // Label 29131: @2366146
    GIM_Try, /*On fail goto*//*Label 29132*/ GIMT_Encode4(2366194), // Rule ID 56515 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56515,
      GIR_EraseRootFromParent_Done,
    // Label 29132: @2366194
    GIM_Try, /*On fail goto*//*Label 29133*/ GIMT_Encode4(2366242), // Rule ID 56774 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56774,
      GIR_EraseRootFromParent_Done,
    // Label 29133: @2366242
    GIM_Try, /*On fail goto*//*Label 29134*/ GIMT_Encode4(2366290), // Rule ID 56775 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56775,
      GIR_EraseRootFromParent_Done,
    // Label 29134: @2366290
    GIM_Try, /*On fail goto*//*Label 29135*/ GIMT_Encode4(2366338), // Rule ID 56814 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56814,
      GIR_EraseRootFromParent_Done,
    // Label 29135: @2366338
    GIM_Try, /*On fail goto*//*Label 29136*/ GIMT_Encode4(2366386), // Rule ID 56815 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 56815,
      GIR_EraseRootFromParent_Done,
    // Label 29136: @2366386
    GIM_Try, /*On fail goto*//*Label 29137*/ GIMT_Encode4(2366434), // Rule ID 57074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57074,
      GIR_EraseRootFromParent_Done,
    // Label 29137: @2366434
    GIM_Try, /*On fail goto*//*Label 29138*/ GIMT_Encode4(2366482), // Rule ID 57075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57075,
      GIR_EraseRootFromParent_Done,
    // Label 29138: @2366482
    GIM_Try, /*On fail goto*//*Label 29139*/ GIMT_Encode4(2366530), // Rule ID 57114 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57114,
      GIR_EraseRootFromParent_Done,
    // Label 29139: @2366530
    GIM_Try, /*On fail goto*//*Label 29140*/ GIMT_Encode4(2366578), // Rule ID 57115 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57115,
      GIR_EraseRootFromParent_Done,
    // Label 29140: @2366578
    GIM_Try, /*On fail goto*//*Label 29141*/ GIMT_Encode4(2366626), // Rule ID 57374 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57374,
      GIR_EraseRootFromParent_Done,
    // Label 29141: @2366626
    GIM_Try, /*On fail goto*//*Label 29142*/ GIMT_Encode4(2366674), // Rule ID 57375 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57375,
      GIR_EraseRootFromParent_Done,
    // Label 29142: @2366674
    GIM_Try, /*On fail goto*//*Label 29143*/ GIMT_Encode4(2366722), // Rule ID 57414 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57414,
      GIR_EraseRootFromParent_Done,
    // Label 29143: @2366722
    GIM_Try, /*On fail goto*//*Label 29144*/ GIMT_Encode4(2366770), // Rule ID 57415 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // MIs[0] Operand 1
      GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/2, // rs1
      GIR_RootToRootCopy, /*OpIdx*/3, // rs2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57415,
      GIR_EraseRootFromParent_Done,
    // Label 29144: @2366770
    GIM_Reject,
    // Label 28992: @2366771
    GIM_Try, /*On fail goto*//*Label 29145*/ GIMT_Encode4(2367091),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29146*/ GIMT_Encode4(2366824), // Rule ID 56484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56484,
        GIR_EraseRootFromParent_Done,
      // Label 29146: @2366824
      GIM_Try, /*On fail goto*//*Label 29147*/ GIMT_Encode4(2366862), // Rule ID 56485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56485,
        GIR_EraseRootFromParent_Done,
      // Label 29147: @2366862
      GIM_Try, /*On fail goto*//*Label 29148*/ GIMT_Encode4(2366900), // Rule ID 56784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56784,
        GIR_EraseRootFromParent_Done,
      // Label 29148: @2366900
      GIM_Try, /*On fail goto*//*Label 29149*/ GIMT_Encode4(2366938), // Rule ID 56785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56785,
        GIR_EraseRootFromParent_Done,
      // Label 29149: @2366938
      GIM_Try, /*On fail goto*//*Label 29150*/ GIMT_Encode4(2366976), // Rule ID 57084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57084,
        GIR_EraseRootFromParent_Done,
      // Label 29150: @2366976
      GIM_Try, /*On fail goto*//*Label 29151*/ GIMT_Encode4(2367014), // Rule ID 57085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57085,
        GIR_EraseRootFromParent_Done,
      // Label 29151: @2367014
      GIM_Try, /*On fail goto*//*Label 29152*/ GIMT_Encode4(2367052), // Rule ID 57384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57384,
        GIR_EraseRootFromParent_Done,
      // Label 29152: @2367052
      GIM_Try, /*On fail goto*//*Label 29153*/ GIMT_Encode4(2367090), // Rule ID 57385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57385,
        GIR_EraseRootFromParent_Done,
      // Label 29153: @2367090
      GIM_Reject,
    // Label 29145: @2367091
    GIM_Reject,
    // Label 28993: @2367092
    GIM_Reject,
    // Label 50: @2367093
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29178*/ GIMT_Encode4(2373804),
    /*GILLT_s32*//*Label 29154*/ GIMT_Encode4(2367228),
    /*GILLT_s64*//*Label 29155*/ GIMT_Encode4(2367870), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 29156*/ GIMT_Encode4(2368512),
    /*GILLT_nxv1s16*//*Label 29157*/ GIMT_Encode4(2368668),
    /*GILLT_nxv1s32*//*Label 29158*/ GIMT_Encode4(2368948),
    /*GILLT_nxv1s64*//*Label 29159*/ GIMT_Encode4(2369228), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 29160*/ GIMT_Encode4(2369508),
    /*GILLT_nxv2s16*//*Label 29161*/ GIMT_Encode4(2369664),
    /*GILLT_nxv2s32*//*Label 29162*/ GIMT_Encode4(2369944),
    /*GILLT_nxv2s64*//*Label 29163*/ GIMT_Encode4(2370224), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 29164*/ GIMT_Encode4(2370504),
    /*GILLT_nxv4s16*//*Label 29165*/ GIMT_Encode4(2370660),
    /*GILLT_nxv4s32*//*Label 29166*/ GIMT_Encode4(2370940),
    /*GILLT_nxv4s64*//*Label 29167*/ GIMT_Encode4(2371220), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 29168*/ GIMT_Encode4(2371500),
    /*GILLT_nxv8s16*//*Label 29169*/ GIMT_Encode4(2371656),
    /*GILLT_nxv8s32*//*Label 29170*/ GIMT_Encode4(2371936),
    /*GILLT_nxv8s64*//*Label 29171*/ GIMT_Encode4(2372216), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 29172*/ GIMT_Encode4(2372496),
    /*GILLT_nxv16s16*//*Label 29173*/ GIMT_Encode4(2372652),
    /*GILLT_nxv16s32*//*Label 29174*/ GIMT_Encode4(2372932), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 29175*/ GIMT_Encode4(2373212),
    /*GILLT_nxv32s16*//*Label 29176*/ GIMT_Encode4(2373368), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 29177*/ GIMT_Encode4(2373648),
    // Label 29154: @2367228
    GIM_Try, /*On fail goto*//*Label 29179*/ GIMT_Encode4(2367869),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29180*/ GIMT_Encode4(2367309), // Rule ID 63940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63940,
        GIR_EraseRootFromParent_Done,
      // Label 29180: @2367309
      GIM_Try, /*On fail goto*//*Label 29181*/ GIMT_Encode4(2367372), // Rule ID 63946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR:{ *:[i32] }:$rs3, GPR:{ *:[i32] }:$rs1)  =>  (CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63946,
        GIR_EraseRootFromParent_Done,
      // Label 29181: @2367372
      GIM_Try, /*On fail goto*//*Label 29182*/ GIMT_Encode4(2367465), // Rule ID 63942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12_plus1),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_simm12_plus1>>:$y, SETNE:{ *:[Other] }), GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$x, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12_plus1>>:$y)), GPR:{ *:[i32] }:$rs3)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // y
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63942,
        GIR_EraseRootFromParent_Done,
      // Label 29182: @2367465
      GIM_Try, /*On fail goto*//*Label 29183*/ GIMT_Encode4(2367558), // Rule ID 63948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12_plus1),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_simm12_plus1>>:$y, SETEQ:{ *:[Other] }), GPR:{ *:[i32] }:$rs3, GPR:{ *:[i32] }:$rs1)  =>  (CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$x, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12_plus1>>:$y)), GPR:{ *:[i32] }:$rs3)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // y
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63948,
        GIR_EraseRootFromParent_Done,
      // Label 29183: @2367558
      GIM_Try, /*On fail goto*//*Label 29184*/ GIMT_Encode4(2367595), // Rule ID 61991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/3, // b
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // cond
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61991,
        GIR_EraseRootFromParent_Done,
      // Label 29184: @2367595
      GIM_Try, /*On fail goto*//*Label 29185*/ GIMT_Encode4(2367632), // Rule ID 61989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // a
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // cond
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61989,
        GIR_EraseRootFromParent_Done,
      // Label 29185: @2367632
      GIM_Try, /*On fail goto*//*Label 29186*/ GIMT_Encode4(2367717), // Rule ID 63944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR:{ *:[i32] }:$x, GPR:{ *:[i32] }:$y, SETNE:{ *:[Other] }), GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$x, GPR:{ *:[i32] }:$y), GPR:{ *:[i32] }:$rs3)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // y
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63944,
        GIR_EraseRootFromParent_Done,
      // Label 29186: @2367717
      GIM_Try, /*On fail goto*//*Label 29187*/ GIMT_Encode4(2367802), // Rule ID 63950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR:{ *:[i32] }:$x, GPR:{ *:[i32] }:$y, SETEQ:{ *:[Other] }), GPR:{ *:[i32] }:$rs3, GPR:{ *:[i32] }:$rs1)  =>  (CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$x, GPR:{ *:[i32] }:$y), GPR:{ *:[i32] }:$rs3)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // y
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63950,
        GIR_EraseRootFromParent_Done,
      // Label 29187: @2367802
      GIM_Try, /*On fail goto*//*Label 29188*/ GIMT_Encode4(2367835), // Rule ID 61987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // a
        GIR_RootToRootCopy, /*OpIdx*/3, // b
        GIR_RootToRootCopy, /*OpIdx*/1, // cond
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61987,
        GIR_EraseRootFromParent_Done,
      // Label 29188: @2367835
      GIM_Try, /*On fail goto*//*Label 29189*/ GIMT_Encode4(2367868), // Rule ID 63952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63952,
        GIR_EraseRootFromParent_Done,
      // Label 29189: @2367868
      GIM_Reject,
    // Label 29179: @2367869
    GIM_Reject,
    // Label 29155: @2367870
    GIM_Try, /*On fail goto*//*Label 29190*/ GIMT_Encode4(2368511),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29191*/ GIMT_Encode4(2367951), // Rule ID 63939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (select:{ *:[i64] } (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63939,
        GIR_EraseRootFromParent_Done,
      // Label 29191: @2367951
      GIM_Try, /*On fail goto*//*Label 29192*/ GIMT_Encode4(2368014), // Rule ID 63945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (select:{ *:[i64] } (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR:{ *:[i64] }:$rs3, GPR:{ *:[i64] }:$rs1)  =>  (CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63945,
        GIR_EraseRootFromParent_Done,
      // Label 29192: @2368014
      GIM_Try, /*On fail goto*//*Label 29193*/ GIMT_Encode4(2368107), // Rule ID 63941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12_plus1),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (select:{ *:[i64] } (setcc:{ *:[i64] } GPR:{ *:[i64] }:$x, (imm:{ *:[i64] })<<P:Predicate_simm12_plus1>>:$y, SETNE:{ *:[Other] }), GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$x, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12_plus1>>:$y)), GPR:{ *:[i64] }:$rs3)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // y
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63941,
        GIR_EraseRootFromParent_Done,
      // Label 29193: @2368107
      GIM_Try, /*On fail goto*//*Label 29194*/ GIMT_Encode4(2368200), // Rule ID 63947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12_plus1),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (select:{ *:[i64] } (setcc:{ *:[i64] } GPR:{ *:[i64] }:$x, (imm:{ *:[i64] })<<P:Predicate_simm12_plus1>>:$y, SETEQ:{ *:[Other] }), GPR:{ *:[i64] }:$rs3, GPR:{ *:[i64] }:$rs1)  =>  (CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$x, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12_plus1>>:$y)), GPR:{ *:[i64] }:$rs3)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // y
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63947,
        GIR_EraseRootFromParent_Done,
      // Label 29194: @2368200
      GIM_Try, /*On fail goto*//*Label 29195*/ GIMT_Encode4(2368237), // Rule ID 61990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/3, // b
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // cond
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61990,
        GIR_EraseRootFromParent_Done,
      // Label 29195: @2368237
      GIM_Try, /*On fail goto*//*Label 29196*/ GIMT_Encode4(2368274), // Rule ID 61988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // a
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // cond
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61988,
        GIR_EraseRootFromParent_Done,
      // Label 29196: @2368274
      GIM_Try, /*On fail goto*//*Label 29197*/ GIMT_Encode4(2368359), // Rule ID 63943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (select:{ *:[i64] } (setcc:{ *:[i64] } GPR:{ *:[i64] }:$x, GPR:{ *:[i64] }:$y, SETNE:{ *:[Other] }), GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$x, GPR:{ *:[i64] }:$y), GPR:{ *:[i64] }:$rs3)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // y
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63943,
        GIR_EraseRootFromParent_Done,
      // Label 29197: @2368359
      GIM_Try, /*On fail goto*//*Label 29198*/ GIMT_Encode4(2368444), // Rule ID 63949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        // MIs[1] Operand 1
        GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (select:{ *:[i64] } (setcc:{ *:[i64] } GPR:{ *:[i64] }:$x, GPR:{ *:[i64] }:$y, SETEQ:{ *:[Other] }), GPR:{ *:[i64] }:$rs3, GPR:{ *:[i64] }:$rs1)  =>  (CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$x, GPR:{ *:[i64] }:$y), GPR:{ *:[i64] }:$rs3)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // y
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63949,
        GIR_EraseRootFromParent_Done,
      // Label 29198: @2368444
      GIM_Try, /*On fail goto*//*Label 29199*/ GIMT_Encode4(2368477), // Rule ID 61986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
        GIR_RootToRootCopy, /*OpIdx*/2, // a
        GIR_RootToRootCopy, /*OpIdx*/3, // b
        GIR_RootToRootCopy, /*OpIdx*/1, // cond
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61986,
        GIR_EraseRootFromParent_Done,
      // Label 29199: @2368477
      GIM_Try, /*On fail goto*//*Label 29200*/ GIMT_Encode4(2368510), // Rule ID 63951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CCMOV),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63951,
        GIR_EraseRootFromParent_Done,
      // Label 29200: @2368510
      GIM_Reject,
    // Label 29190: @2368511
    GIM_Reject,
    // Label 29156: @2368512
    GIM_Try, /*On fail goto*//*Label 29201*/ GIMT_Encode4(2368667),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29202*/ GIMT_Encode4(2368604), // Rule ID 51794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv1i8] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51794,
        GIR_EraseRootFromParent_Done,
      // Label 29202: @2368604
      GIM_Try, /*On fail goto*//*Label 29203*/ GIMT_Encode4(2368666), // Rule ID 51795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv1i8] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51795,
        GIR_EraseRootFromParent_Done,
      // Label 29203: @2368666
      GIM_Reject,
    // Label 29201: @2368667
    GIM_Reject,
    // Label 29157: @2368668
    GIM_Try, /*On fail goto*//*Label 29204*/ GIMT_Encode4(2368947),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29205*/ GIMT_Encode4(2368760), // Rule ID 51812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv1i16] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51812,
        GIR_EraseRootFromParent_Done,
      // Label 29205: @2368760
      GIM_Try, /*On fail goto*//*Label 29206*/ GIMT_Encode4(2368822), // Rule ID 51813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv1i16] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51813,
        GIR_EraseRootFromParent_Done,
      // Label 29206: @2368822
      GIM_Try, /*On fail goto*//*Label 29207*/ GIMT_Encode4(2368884), // Rule ID 57454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv1f16] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57454,
        GIR_EraseRootFromParent_Done,
      // Label 29207: @2368884
      GIM_Try, /*On fail goto*//*Label 29208*/ GIMT_Encode4(2368946), // Rule ID 57455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv1f16] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57455,
        GIR_EraseRootFromParent_Done,
      // Label 29208: @2368946
      GIM_Reject,
    // Label 29204: @2368947
    GIM_Reject,
    // Label 29158: @2368948
    GIM_Try, /*On fail goto*//*Label 29209*/ GIMT_Encode4(2369227),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29210*/ GIMT_Encode4(2369040), // Rule ID 51824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv1i32] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51824,
        GIR_EraseRootFromParent_Done,
      // Label 29210: @2369040
      GIM_Try, /*On fail goto*//*Label 29211*/ GIMT_Encode4(2369102), // Rule ID 51825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv1i32] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51825,
        GIR_EraseRootFromParent_Done,
      // Label 29211: @2369102
      GIM_Try, /*On fail goto*//*Label 29212*/ GIMT_Encode4(2369164), // Rule ID 57474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv1f32] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57474,
        GIR_EraseRootFromParent_Done,
      // Label 29212: @2369164
      GIM_Try, /*On fail goto*//*Label 29213*/ GIMT_Encode4(2369226), // Rule ID 57475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv1f32] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57475,
        GIR_EraseRootFromParent_Done,
      // Label 29213: @2369226
      GIM_Reject,
    // Label 29209: @2369227
    GIM_Reject,
    // Label 29159: @2369228
    GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2369507),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2369320), // Rule ID 51848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (vselect:{ *:[nxv1i64] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51848,
        GIR_EraseRootFromParent_Done,
      // Label 29215: @2369320
      GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2369382), // Rule ID 51849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (vselect:{ *:[nxv1i64] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51849,
        GIR_EraseRootFromParent_Done,
      // Label 29216: @2369382
      GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2369444), // Rule ID 57504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (vselect:{ *:[nxv1f64] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57504,
        GIR_EraseRootFromParent_Done,
      // Label 29217: @2369444
      GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2369506), // Rule ID 57505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (vselect:{ *:[nxv1f64] } V0:{ *:[nxv1i1] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, V0:{ *:[nxv1i1] }, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57505,
        GIR_EraseRootFromParent_Done,
      // Label 29218: @2369506
      GIM_Reject,
    // Label 29214: @2369507
    GIM_Reject,
    // Label 29160: @2369508
    GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2369663),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2369600), // Rule ID 51800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv2i8] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51800,
        GIR_EraseRootFromParent_Done,
      // Label 29220: @2369600
      GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2369662), // Rule ID 51801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv2i8] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51801,
        GIR_EraseRootFromParent_Done,
      // Label 29221: @2369662
      GIM_Reject,
    // Label 29219: @2369663
    GIM_Reject,
    // Label 29161: @2369664
    GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2369943),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2369756), // Rule ID 51818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv2i16] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51818,
        GIR_EraseRootFromParent_Done,
      // Label 29223: @2369756
      GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2369818), // Rule ID 51819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv2i16] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51819,
        GIR_EraseRootFromParent_Done,
      // Label 29224: @2369818
      GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2369880), // Rule ID 57464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv2f16] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57464,
        GIR_EraseRootFromParent_Done,
      // Label 29225: @2369880
      GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2369942), // Rule ID 57465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv2f16] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57465,
        GIR_EraseRootFromParent_Done,
      // Label 29226: @2369942
      GIM_Reject,
    // Label 29222: @2369943
    GIM_Reject,
    // Label 29162: @2369944
    GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2370223),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2370036), // Rule ID 51842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv2i32] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51842,
        GIR_EraseRootFromParent_Done,
      // Label 29228: @2370036
      GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2370098), // Rule ID 51843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv2i32] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51843,
        GIR_EraseRootFromParent_Done,
      // Label 29229: @2370098
      GIM_Try, /*On fail goto*//*Label 29230*/ GIMT_Encode4(2370160), // Rule ID 57494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv2f32] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57494,
        GIR_EraseRootFromParent_Done,
      // Label 29230: @2370160
      GIM_Try, /*On fail goto*//*Label 29231*/ GIMT_Encode4(2370222), // Rule ID 57495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv2f32] } V0:{ *:[nxv2i1] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57495,
        GIR_EraseRootFromParent_Done,
      // Label 29231: @2370222
      GIM_Reject,
    // Label 29227: @2370223
    GIM_Reject,
    // Label 29163: @2370224
    GIM_Try, /*On fail goto*//*Label 29232*/ GIMT_Encode4(2370503),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2370316), // Rule ID 51908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (vselect:{ *:[nxv2i64] } V0:{ *:[nxv2i1] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51908,
        GIR_EraseRootFromParent_Done,
      // Label 29233: @2370316
      GIM_Try, /*On fail goto*//*Label 29234*/ GIMT_Encode4(2370378), // Rule ID 51909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (vselect:{ *:[nxv2i64] } V0:{ *:[nxv2i1] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51909,
        GIR_EraseRootFromParent_Done,
      // Label 29234: @2370378
      GIM_Try, /*On fail goto*//*Label 29235*/ GIMT_Encode4(2370440), // Rule ID 57574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (vselect:{ *:[nxv2f64] } V0:{ *:[nxv2i1] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57574,
        GIR_EraseRootFromParent_Done,
      // Label 29235: @2370440
      GIM_Try, /*On fail goto*//*Label 29236*/ GIMT_Encode4(2370502), // Rule ID 57575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (vselect:{ *:[nxv2f64] } V0:{ *:[nxv2i1] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, V0:{ *:[nxv2i1] }, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57575,
        GIR_EraseRootFromParent_Done,
      // Label 29236: @2370502
      GIM_Reject,
    // Label 29232: @2370503
    GIM_Reject,
    // Label 29164: @2370504
    GIM_Try, /*On fail goto*//*Label 29237*/ GIMT_Encode4(2370659),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29238*/ GIMT_Encode4(2370596), // Rule ID 51806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv4i8] } V0:{ *:[nxv4i1] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51806,
        GIR_EraseRootFromParent_Done,
      // Label 29238: @2370596
      GIM_Try, /*On fail goto*//*Label 29239*/ GIMT_Encode4(2370658), // Rule ID 51807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv4i8] } V0:{ *:[nxv4i1] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51807,
        GIR_EraseRootFromParent_Done,
      // Label 29239: @2370658
      GIM_Reject,
    // Label 29237: @2370659
    GIM_Reject,
    // Label 29165: @2370660
    GIM_Try, /*On fail goto*//*Label 29240*/ GIMT_Encode4(2370939),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29241*/ GIMT_Encode4(2370752), // Rule ID 51836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv4i16] } V0:{ *:[nxv4i1] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51836,
        GIR_EraseRootFromParent_Done,
      // Label 29241: @2370752
      GIM_Try, /*On fail goto*//*Label 29242*/ GIMT_Encode4(2370814), // Rule ID 51837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv4i16] } V0:{ *:[nxv4i1] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51837,
        GIR_EraseRootFromParent_Done,
      // Label 29242: @2370814
      GIM_Try, /*On fail goto*//*Label 29243*/ GIMT_Encode4(2370876), // Rule ID 57484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv4f16] } V0:{ *:[nxv4i1] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57484,
        GIR_EraseRootFromParent_Done,
      // Label 29243: @2370876
      GIM_Try, /*On fail goto*//*Label 29244*/ GIMT_Encode4(2370938), // Rule ID 57485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv4f16] } V0:{ *:[nxv4i1] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57485,
        GIR_EraseRootFromParent_Done,
      // Label 29244: @2370938
      GIM_Reject,
    // Label 29240: @2370939
    GIM_Reject,
    // Label 29166: @2370940
    GIM_Try, /*On fail goto*//*Label 29245*/ GIMT_Encode4(2371219),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29246*/ GIMT_Encode4(2371032), // Rule ID 51890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv4i32] } V0:{ *:[nxv4i1] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51890,
        GIR_EraseRootFromParent_Done,
      // Label 29246: @2371032
      GIM_Try, /*On fail goto*//*Label 29247*/ GIMT_Encode4(2371094), // Rule ID 51891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv4i32] } V0:{ *:[nxv4i1] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51891,
        GIR_EraseRootFromParent_Done,
      // Label 29247: @2371094
      GIM_Try, /*On fail goto*//*Label 29248*/ GIMT_Encode4(2371156), // Rule ID 57544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv4f32] } V0:{ *:[nxv4i1] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57544,
        GIR_EraseRootFromParent_Done,
      // Label 29248: @2371156
      GIM_Try, /*On fail goto*//*Label 29249*/ GIMT_Encode4(2371218), // Rule ID 57545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv4f32] } V0:{ *:[nxv4i1] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57545,
        GIR_EraseRootFromParent_Done,
      // Label 29249: @2371218
      GIM_Reject,
    // Label 29245: @2371219
    GIM_Reject,
    // Label 29167: @2371220
    GIM_Try, /*On fail goto*//*Label 29250*/ GIMT_Encode4(2371499),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29251*/ GIMT_Encode4(2371312), // Rule ID 51914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (vselect:{ *:[nxv4i64] } V0:{ *:[nxv4i1] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51914,
        GIR_EraseRootFromParent_Done,
      // Label 29251: @2371312
      GIM_Try, /*On fail goto*//*Label 29252*/ GIMT_Encode4(2371374), // Rule ID 51915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (vselect:{ *:[nxv4i64] } V0:{ *:[nxv4i1] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51915,
        GIR_EraseRootFromParent_Done,
      // Label 29252: @2371374
      GIM_Try, /*On fail goto*//*Label 29253*/ GIMT_Encode4(2371436), // Rule ID 57584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (vselect:{ *:[nxv4f64] } V0:{ *:[nxv4i1] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57584,
        GIR_EraseRootFromParent_Done,
      // Label 29253: @2371436
      GIM_Try, /*On fail goto*//*Label 29254*/ GIMT_Encode4(2371498), // Rule ID 57585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (vselect:{ *:[nxv4f64] } V0:{ *:[nxv4i1] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, V0:{ *:[nxv4i1] }, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57585,
        GIR_EraseRootFromParent_Done,
      // Label 29254: @2371498
      GIM_Reject,
    // Label 29250: @2371499
    GIM_Reject,
    // Label 29168: @2371500
    GIM_Try, /*On fail goto*//*Label 29255*/ GIMT_Encode4(2371655),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29256*/ GIMT_Encode4(2371592), // Rule ID 51830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv8i8] } V0:{ *:[nxv8i1] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51830,
        GIR_EraseRootFromParent_Done,
      // Label 29256: @2371592
      GIM_Try, /*On fail goto*//*Label 29257*/ GIMT_Encode4(2371654), // Rule ID 51831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv8i8] } V0:{ *:[nxv8i1] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51831,
        GIR_EraseRootFromParent_Done,
      // Label 29257: @2371654
      GIM_Reject,
    // Label 29255: @2371655
    GIM_Reject,
    // Label 29169: @2371656
    GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2371935),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2371748), // Rule ID 51872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv8i16] } V0:{ *:[nxv8i1] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51872,
        GIR_EraseRootFromParent_Done,
      // Label 29259: @2371748
      GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2371810), // Rule ID 51873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv8i16] } V0:{ *:[nxv8i1] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51873,
        GIR_EraseRootFromParent_Done,
      // Label 29260: @2371810
      GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2371872), // Rule ID 57514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv8f16] } V0:{ *:[nxv8i1] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57514,
        GIR_EraseRootFromParent_Done,
      // Label 29261: @2371872
      GIM_Try, /*On fail goto*//*Label 29262*/ GIMT_Encode4(2371934), // Rule ID 57515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv8f16] } V0:{ *:[nxv8i1] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57515,
        GIR_EraseRootFromParent_Done,
      // Label 29262: @2371934
      GIM_Reject,
    // Label 29258: @2371935
    GIM_Reject,
    // Label 29170: @2371936
    GIM_Try, /*On fail goto*//*Label 29263*/ GIMT_Encode4(2372215),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29264*/ GIMT_Encode4(2372028), // Rule ID 51896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv8i32] } V0:{ *:[nxv8i1] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51896,
        GIR_EraseRootFromParent_Done,
      // Label 29264: @2372028
      GIM_Try, /*On fail goto*//*Label 29265*/ GIMT_Encode4(2372090), // Rule ID 51897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv8i32] } V0:{ *:[nxv8i1] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51897,
        GIR_EraseRootFromParent_Done,
      // Label 29265: @2372090
      GIM_Try, /*On fail goto*//*Label 29266*/ GIMT_Encode4(2372152), // Rule ID 57554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv8f32] } V0:{ *:[nxv8i1] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57554,
        GIR_EraseRootFromParent_Done,
      // Label 29266: @2372152
      GIM_Try, /*On fail goto*//*Label 29267*/ GIMT_Encode4(2372214), // Rule ID 57555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv8f32] } V0:{ *:[nxv8i1] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57555,
        GIR_EraseRootFromParent_Done,
      // Label 29267: @2372214
      GIM_Reject,
    // Label 29263: @2372215
    GIM_Reject,
    // Label 29171: @2372216
    GIM_Try, /*On fail goto*//*Label 29268*/ GIMT_Encode4(2372495),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29269*/ GIMT_Encode4(2372308), // Rule ID 51920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (vselect:{ *:[nxv8i64] } V0:{ *:[nxv8i1] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51920,
        GIR_EraseRootFromParent_Done,
      // Label 29269: @2372308
      GIM_Try, /*On fail goto*//*Label 29270*/ GIMT_Encode4(2372370), // Rule ID 51921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (vselect:{ *:[nxv8i64] } V0:{ *:[nxv8i1] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51921,
        GIR_EraseRootFromParent_Done,
      // Label 29270: @2372370
      GIM_Try, /*On fail goto*//*Label 29271*/ GIMT_Encode4(2372432), // Rule ID 57594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (vselect:{ *:[nxv8f64] } V0:{ *:[nxv8i1] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i64] }, 6:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57594,
        GIR_EraseRootFromParent_Done,
      // Label 29271: @2372432
      GIM_Try, /*On fail goto*//*Label 29272*/ GIMT_Encode4(2372494), // Rule ID 57595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (vselect:{ *:[nxv8f64] } V0:{ *:[nxv8i1] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, V0:{ *:[nxv8i1] }, -1:{ *:[i32] }, 6:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57595,
        GIR_EraseRootFromParent_Done,
      // Label 29272: @2372494
      GIM_Reject,
    // Label 29268: @2372495
    GIM_Reject,
    // Label 29172: @2372496
    GIM_Try, /*On fail goto*//*Label 29273*/ GIMT_Encode4(2372651),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29274*/ GIMT_Encode4(2372588), // Rule ID 51854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv16i8] } V0:{ *:[nxv16i1] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51854,
        GIR_EraseRootFromParent_Done,
      // Label 29274: @2372588
      GIM_Try, /*On fail goto*//*Label 29275*/ GIMT_Encode4(2372650), // Rule ID 51855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv16i8] } V0:{ *:[nxv16i1] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51855,
        GIR_EraseRootFromParent_Done,
      // Label 29275: @2372650
      GIM_Reject,
    // Label 29273: @2372651
    GIM_Reject,
    // Label 29173: @2372652
    GIM_Try, /*On fail goto*//*Label 29276*/ GIMT_Encode4(2372931),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29277*/ GIMT_Encode4(2372744), // Rule ID 51878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv16i16] } V0:{ *:[nxv16i1] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51878,
        GIR_EraseRootFromParent_Done,
      // Label 29277: @2372744
      GIM_Try, /*On fail goto*//*Label 29278*/ GIMT_Encode4(2372806), // Rule ID 51879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv16i16] } V0:{ *:[nxv16i1] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51879,
        GIR_EraseRootFromParent_Done,
      // Label 29278: @2372806
      GIM_Try, /*On fail goto*//*Label 29279*/ GIMT_Encode4(2372868), // Rule ID 57524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv16f16] } V0:{ *:[nxv16i1] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57524,
        GIR_EraseRootFromParent_Done,
      // Label 29279: @2372868
      GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2372930), // Rule ID 57525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv16f16] } V0:{ *:[nxv16i1] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57525,
        GIR_EraseRootFromParent_Done,
      // Label 29280: @2372930
      GIM_Reject,
    // Label 29276: @2372931
    GIM_Reject,
    // Label 29174: @2372932
    GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2373211),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2373024), // Rule ID 51902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv16i32] } V0:{ *:[nxv16i1] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51902,
        GIR_EraseRootFromParent_Done,
      // Label 29282: @2373024
      GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2373086), // Rule ID 51903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv16i32] } V0:{ *:[nxv16i1] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51903,
        GIR_EraseRootFromParent_Done,
      // Label 29283: @2373086
      GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2373148), // Rule ID 57564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv16f32] } V0:{ *:[nxv16i1] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i64] }, 5:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57564,
        GIR_EraseRootFromParent_Done,
      // Label 29284: @2373148
      GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2373210), // Rule ID 57565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv16f32] } V0:{ *:[nxv16i1] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, V0:{ *:[nxv16i1] }, -1:{ *:[i32] }, 5:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57565,
        GIR_EraseRootFromParent_Done,
      // Label 29285: @2373210
      GIM_Reject,
    // Label 29281: @2373211
    GIM_Reject,
    // Label 29175: @2373212
    GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2373367),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2373304), // Rule ID 51860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv32i8] } V0:{ *:[nxv32i1] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51860,
        GIR_EraseRootFromParent_Done,
      // Label 29287: @2373304
      GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2373366), // Rule ID 51861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv32i8] } V0:{ *:[nxv32i1] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, V0:{ *:[nxv32i1] }, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51861,
        GIR_EraseRootFromParent_Done,
      // Label 29288: @2373366
      GIM_Reject,
    // Label 29286: @2373367
    GIM_Reject,
    // Label 29176: @2373368
    GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2373647),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2373460), // Rule ID 51884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv32i16] } V0:{ *:[nxv32i1] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51884,
        GIR_EraseRootFromParent_Done,
      // Label 29290: @2373460
      GIM_Try, /*On fail goto*//*Label 29291*/ GIMT_Encode4(2373522), // Rule ID 51885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv32i16] } V0:{ *:[nxv32i1] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, V0:{ *:[nxv32i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51885,
        GIR_EraseRootFromParent_Done,
      // Label 29291: @2373522
      GIM_Try, /*On fail goto*//*Label 29292*/ GIMT_Encode4(2373584), // Rule ID 57534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv32f16] } V0:{ *:[nxv32i1] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, V0:{ *:[nxv32i1] }, -1:{ *:[i64] }, 4:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57534,
        GIR_EraseRootFromParent_Done,
      // Label 29292: @2373584
      GIM_Try, /*On fail goto*//*Label 29293*/ GIMT_Encode4(2373646), // Rule ID 57535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv32f16] } V0:{ *:[nxv32i1] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, V0:{ *:[nxv32i1] }, -1:{ *:[i32] }, 4:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57535,
        GIR_EraseRootFromParent_Done,
      // Label 29293: @2373646
      GIM_Reject,
    // Label 29289: @2373647
    GIM_Reject,
    // Label 29177: @2373648
    GIM_Try, /*On fail goto*//*Label 29294*/ GIMT_Encode4(2373803),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29295*/ GIMT_Encode4(2373740), // Rule ID 51866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (vselect:{ *:[nxv64i8] } V0:{ *:[nxv64i1] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, -1:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51866,
        GIR_EraseRootFromParent_Done,
      // Label 29295: @2373740
      GIM_Try, /*On fail goto*//*Label 29296*/ GIMT_Encode4(2373802), // Rule ID 51867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (vselect:{ *:[nxv64i8] } V0:{ *:[nxv64i1] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, V0:{ *:[nxv64i1] }, -1:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51867,
        GIR_EraseRootFromParent_Done,
      // Label 29296: @2373802
      GIM_Reject,
    // Label 29294: @2373803
    GIM_Reject,
    // Label 29178: @2373804
    GIM_Reject,
    // Label 51: @2373805
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29321*/ GIMT_Encode4(2376538),
    /*GILLT_s32*//*Label 29297*/ GIMT_Encode4(2373940),
    /*GILLT_s64*//*Label 29298*/ GIMT_Encode4(2373974), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 29299*/ GIMT_Encode4(2374008),
    /*GILLT_nxv1s16*//*Label 29300*/ GIMT_Encode4(2374123),
    /*GILLT_nxv1s32*//*Label 29301*/ GIMT_Encode4(2374238),
    /*GILLT_nxv1s64*//*Label 29302*/ GIMT_Encode4(2374353), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 29303*/ GIMT_Encode4(2374468),
    /*GILLT_nxv2s16*//*Label 29304*/ GIMT_Encode4(2374583),
    /*GILLT_nxv2s32*//*Label 29305*/ GIMT_Encode4(2374698),
    /*GILLT_nxv2s64*//*Label 29306*/ GIMT_Encode4(2374813), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 29307*/ GIMT_Encode4(2374928),
    /*GILLT_nxv4s16*//*Label 29308*/ GIMT_Encode4(2375043),
    /*GILLT_nxv4s32*//*Label 29309*/ GIMT_Encode4(2375158),
    /*GILLT_nxv4s64*//*Label 29310*/ GIMT_Encode4(2375273), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 29311*/ GIMT_Encode4(2375388),
    /*GILLT_nxv8s16*//*Label 29312*/ GIMT_Encode4(2375503),
    /*GILLT_nxv8s32*//*Label 29313*/ GIMT_Encode4(2375618),
    /*GILLT_nxv8s64*//*Label 29314*/ GIMT_Encode4(2375733), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 29315*/ GIMT_Encode4(2375848),
    /*GILLT_nxv16s16*//*Label 29316*/ GIMT_Encode4(2375963),
    /*GILLT_nxv16s32*//*Label 29317*/ GIMT_Encode4(2376078), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 29318*/ GIMT_Encode4(2376193),
    /*GILLT_nxv32s16*//*Label 29319*/ GIMT_Encode4(2376308), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 29320*/ GIMT_Encode4(2376423),
    // Label 29297: @2373940
    GIM_Try, /*On fail goto*//*Label 29322*/ GIMT_Encode4(2373973), // Rule ID 292 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 292,
      GIR_Done,
    // Label 29322: @2373973
    GIM_Reject,
    // Label 29298: @2373974
    GIM_Try, /*On fail goto*//*Label 29323*/ GIMT_Encode4(2374007), // Rule ID 291 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 291,
      GIR_Done,
    // Label 29323: @2374007
    GIM_Reject,
    // Label 29299: @2374008
    GIM_Try, /*On fail goto*//*Label 29324*/ GIMT_Encode4(2374122),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29325*/ GIMT_Encode4(2374076), // Rule ID 50570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50570,
        GIR_EraseRootFromParent_Done,
      // Label 29325: @2374076
      GIM_Try, /*On fail goto*//*Label 29326*/ GIMT_Encode4(2374121), // Rule ID 50571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50571,
        GIR_EraseRootFromParent_Done,
      // Label 29326: @2374121
      GIM_Reject,
    // Label 29324: @2374122
    GIM_Reject,
    // Label 29300: @2374123
    GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2374237),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2374191), // Rule ID 50582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50582,
        GIR_EraseRootFromParent_Done,
      // Label 29328: @2374191
      GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2374236), // Rule ID 50583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50583,
        GIR_EraseRootFromParent_Done,
      // Label 29329: @2374236
      GIM_Reject,
    // Label 29327: @2374237
    GIM_Reject,
    // Label 29301: @2374238
    GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2374352),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2374306), // Rule ID 50590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50590,
        GIR_EraseRootFromParent_Done,
      // Label 29331: @2374306
      GIM_Try, /*On fail goto*//*Label 29332*/ GIMT_Encode4(2374351), // Rule ID 50591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50591,
        GIR_EraseRootFromParent_Done,
      // Label 29332: @2374351
      GIM_Reject,
    // Label 29330: @2374352
    GIM_Reject,
    // Label 29302: @2374353
    GIM_Try, /*On fail goto*//*Label 29333*/ GIMT_Encode4(2374467),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29334*/ GIMT_Encode4(2374421), // Rule ID 50658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50658,
        GIR_EraseRootFromParent_Done,
      // Label 29334: @2374421
      GIM_Try, /*On fail goto*//*Label 29335*/ GIMT_Encode4(2374466), // Rule ID 50659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50659,
        GIR_EraseRootFromParent_Done,
      // Label 29335: @2374466
      GIM_Reject,
    // Label 29333: @2374467
    GIM_Reject,
    // Label 29303: @2374468
    GIM_Try, /*On fail goto*//*Label 29336*/ GIMT_Encode4(2374582),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29337*/ GIMT_Encode4(2374536), // Rule ID 50574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50574,
        GIR_EraseRootFromParent_Done,
      // Label 29337: @2374536
      GIM_Try, /*On fail goto*//*Label 29338*/ GIMT_Encode4(2374581), // Rule ID 50575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50575,
        GIR_EraseRootFromParent_Done,
      // Label 29338: @2374581
      GIM_Reject,
    // Label 29336: @2374582
    GIM_Reject,
    // Label 29304: @2374583
    GIM_Try, /*On fail goto*//*Label 29339*/ GIMT_Encode4(2374697),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29340*/ GIMT_Encode4(2374651), // Rule ID 50586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50586,
        GIR_EraseRootFromParent_Done,
      // Label 29340: @2374651
      GIM_Try, /*On fail goto*//*Label 29341*/ GIMT_Encode4(2374696), // Rule ID 50587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50587,
        GIR_EraseRootFromParent_Done,
      // Label 29341: @2374696
      GIM_Reject,
    // Label 29339: @2374697
    GIM_Reject,
    // Label 29305: @2374698
    GIM_Try, /*On fail goto*//*Label 29342*/ GIMT_Encode4(2374812),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29343*/ GIMT_Encode4(2374766), // Rule ID 50602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50602,
        GIR_EraseRootFromParent_Done,
      // Label 29343: @2374766
      GIM_Try, /*On fail goto*//*Label 29344*/ GIMT_Encode4(2374811), // Rule ID 50603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50603,
        GIR_EraseRootFromParent_Done,
      // Label 29344: @2374811
      GIM_Reject,
    // Label 29342: @2374812
    GIM_Reject,
    // Label 29306: @2374813
    GIM_Try, /*On fail goto*//*Label 29345*/ GIMT_Encode4(2374927),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29346*/ GIMT_Encode4(2374881), // Rule ID 50662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50662,
        GIR_EraseRootFromParent_Done,
      // Label 29346: @2374881
      GIM_Try, /*On fail goto*//*Label 29347*/ GIMT_Encode4(2374926), // Rule ID 50663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50663,
        GIR_EraseRootFromParent_Done,
      // Label 29347: @2374926
      GIM_Reject,
    // Label 29345: @2374927
    GIM_Reject,
    // Label 29307: @2374928
    GIM_Try, /*On fail goto*//*Label 29348*/ GIMT_Encode4(2375042),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29349*/ GIMT_Encode4(2374996), // Rule ID 50578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50578,
        GIR_EraseRootFromParent_Done,
      // Label 29349: @2374996
      GIM_Try, /*On fail goto*//*Label 29350*/ GIMT_Encode4(2375041), // Rule ID 50579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50579,
        GIR_EraseRootFromParent_Done,
      // Label 29350: @2375041
      GIM_Reject,
    // Label 29348: @2375042
    GIM_Reject,
    // Label 29308: @2375043
    GIM_Try, /*On fail goto*//*Label 29351*/ GIMT_Encode4(2375157),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29352*/ GIMT_Encode4(2375111), // Rule ID 50598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50598,
        GIR_EraseRootFromParent_Done,
      // Label 29352: @2375111
      GIM_Try, /*On fail goto*//*Label 29353*/ GIMT_Encode4(2375156), // Rule ID 50599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50599,
        GIR_EraseRootFromParent_Done,
      // Label 29353: @2375156
      GIM_Reject,
    // Label 29351: @2375157
    GIM_Reject,
    // Label 29309: @2375158
    GIM_Try, /*On fail goto*//*Label 29354*/ GIMT_Encode4(2375272),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29355*/ GIMT_Encode4(2375226), // Rule ID 50630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50630,
        GIR_EraseRootFromParent_Done,
      // Label 29355: @2375226
      GIM_Try, /*On fail goto*//*Label 29356*/ GIMT_Encode4(2375271), // Rule ID 50631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50631,
        GIR_EraseRootFromParent_Done,
      // Label 29356: @2375271
      GIM_Reject,
    // Label 29354: @2375272
    GIM_Reject,
    // Label 29310: @2375273
    GIM_Try, /*On fail goto*//*Label 29357*/ GIMT_Encode4(2375387),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29358*/ GIMT_Encode4(2375341), // Rule ID 50666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50666,
        GIR_EraseRootFromParent_Done,
      // Label 29358: @2375341
      GIM_Try, /*On fail goto*//*Label 29359*/ GIMT_Encode4(2375386), // Rule ID 50667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50667,
        GIR_EraseRootFromParent_Done,
      // Label 29359: @2375386
      GIM_Reject,
    // Label 29357: @2375387
    GIM_Reject,
    // Label 29311: @2375388
    GIM_Try, /*On fail goto*//*Label 29360*/ GIMT_Encode4(2375502),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29361*/ GIMT_Encode4(2375456), // Rule ID 50594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50594,
        GIR_EraseRootFromParent_Done,
      // Label 29361: @2375456
      GIM_Try, /*On fail goto*//*Label 29362*/ GIMT_Encode4(2375501), // Rule ID 50595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50595,
        GIR_EraseRootFromParent_Done,
      // Label 29362: @2375501
      GIM_Reject,
    // Label 29360: @2375502
    GIM_Reject,
    // Label 29312: @2375503
    GIM_Try, /*On fail goto*//*Label 29363*/ GIMT_Encode4(2375617),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29364*/ GIMT_Encode4(2375571), // Rule ID 50618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50618,
        GIR_EraseRootFromParent_Done,
      // Label 29364: @2375571
      GIM_Try, /*On fail goto*//*Label 29365*/ GIMT_Encode4(2375616), // Rule ID 50619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50619,
        GIR_EraseRootFromParent_Done,
      // Label 29365: @2375616
      GIM_Reject,
    // Label 29363: @2375617
    GIM_Reject,
    // Label 29313: @2375618
    GIM_Try, /*On fail goto*//*Label 29366*/ GIMT_Encode4(2375732),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29367*/ GIMT_Encode4(2375686), // Rule ID 50634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50634,
        GIR_EraseRootFromParent_Done,
      // Label 29367: @2375686
      GIM_Try, /*On fail goto*//*Label 29368*/ GIMT_Encode4(2375731), // Rule ID 50635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50635,
        GIR_EraseRootFromParent_Done,
      // Label 29368: @2375731
      GIM_Reject,
    // Label 29366: @2375732
    GIM_Reject,
    // Label 29314: @2375733
    GIM_Try, /*On fail goto*//*Label 29369*/ GIMT_Encode4(2375847),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29370*/ GIMT_Encode4(2375801), // Rule ID 50670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50670,
        GIR_EraseRootFromParent_Done,
      // Label 29370: @2375801
      GIM_Try, /*On fail goto*//*Label 29371*/ GIMT_Encode4(2375846), // Rule ID 50671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50671,
        GIR_EraseRootFromParent_Done,
      // Label 29371: @2375846
      GIM_Reject,
    // Label 29369: @2375847
    GIM_Reject,
    // Label 29315: @2375848
    GIM_Try, /*On fail goto*//*Label 29372*/ GIMT_Encode4(2375962),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29373*/ GIMT_Encode4(2375916), // Rule ID 50606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50606,
        GIR_EraseRootFromParent_Done,
      // Label 29373: @2375916
      GIM_Try, /*On fail goto*//*Label 29374*/ GIMT_Encode4(2375961), // Rule ID 50607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50607,
        GIR_EraseRootFromParent_Done,
      // Label 29374: @2375961
      GIM_Reject,
    // Label 29372: @2375962
    GIM_Reject,
    // Label 29316: @2375963
    GIM_Try, /*On fail goto*//*Label 29375*/ GIMT_Encode4(2376077),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29376*/ GIMT_Encode4(2376031), // Rule ID 50622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50622,
        GIR_EraseRootFromParent_Done,
      // Label 29376: @2376031
      GIM_Try, /*On fail goto*//*Label 29377*/ GIMT_Encode4(2376076), // Rule ID 50623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50623,
        GIR_EraseRootFromParent_Done,
      // Label 29377: @2376076
      GIM_Reject,
    // Label 29375: @2376077
    GIM_Reject,
    // Label 29317: @2376078
    GIM_Try, /*On fail goto*//*Label 29378*/ GIMT_Encode4(2376192),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29379*/ GIMT_Encode4(2376146), // Rule ID 50638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50638,
        GIR_EraseRootFromParent_Done,
      // Label 29379: @2376146
      GIM_Try, /*On fail goto*//*Label 29380*/ GIMT_Encode4(2376191), // Rule ID 50639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50639,
        GIR_EraseRootFromParent_Done,
      // Label 29380: @2376191
      GIM_Reject,
    // Label 29378: @2376192
    GIM_Reject,
    // Label 29318: @2376193
    GIM_Try, /*On fail goto*//*Label 29381*/ GIMT_Encode4(2376307),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29382*/ GIMT_Encode4(2376261), // Rule ID 50610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50610,
        GIR_EraseRootFromParent_Done,
      // Label 29382: @2376261
      GIM_Try, /*On fail goto*//*Label 29383*/ GIMT_Encode4(2376306), // Rule ID 50611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50611,
        GIR_EraseRootFromParent_Done,
      // Label 29383: @2376306
      GIM_Reject,
    // Label 29381: @2376307
    GIM_Reject,
    // Label 29319: @2376308
    GIM_Try, /*On fail goto*//*Label 29384*/ GIMT_Encode4(2376422),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2376376), // Rule ID 50626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50626,
        GIR_EraseRootFromParent_Done,
      // Label 29385: @2376376
      GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2376421), // Rule ID 50627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50627,
        GIR_EraseRootFromParent_Done,
      // Label 29386: @2376421
      GIM_Reject,
    // Label 29384: @2376422
    GIM_Reject,
    // Label 29320: @2376423
    GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2376537),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2376491), // Rule ID 50614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50614,
        GIR_EraseRootFromParent_Done,
      // Label 29388: @2376491
      GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2376536), // Rule ID 50615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50615,
        GIR_EraseRootFromParent_Done,
      // Label 29389: @2376536
      GIM_Reject,
    // Label 29387: @2376537
    GIM_Reject,
    // Label 29321: @2376538
    GIM_Reject,
    // Label 52: @2376539
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29414*/ GIMT_Encode4(2379272),
    /*GILLT_s32*//*Label 29390*/ GIMT_Encode4(2376674),
    /*GILLT_s64*//*Label 29391*/ GIMT_Encode4(2376708), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 29392*/ GIMT_Encode4(2376742),
    /*GILLT_nxv1s16*//*Label 29393*/ GIMT_Encode4(2376857),
    /*GILLT_nxv1s32*//*Label 29394*/ GIMT_Encode4(2376972),
    /*GILLT_nxv1s64*//*Label 29395*/ GIMT_Encode4(2377087), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 29396*/ GIMT_Encode4(2377202),
    /*GILLT_nxv2s16*//*Label 29397*/ GIMT_Encode4(2377317),
    /*GILLT_nxv2s32*//*Label 29398*/ GIMT_Encode4(2377432),
    /*GILLT_nxv2s64*//*Label 29399*/ GIMT_Encode4(2377547), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 29400*/ GIMT_Encode4(2377662),
    /*GILLT_nxv4s16*//*Label 29401*/ GIMT_Encode4(2377777),
    /*GILLT_nxv4s32*//*Label 29402*/ GIMT_Encode4(2377892),
    /*GILLT_nxv4s64*//*Label 29403*/ GIMT_Encode4(2378007), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 29404*/ GIMT_Encode4(2378122),
    /*GILLT_nxv8s16*//*Label 29405*/ GIMT_Encode4(2378237),
    /*GILLT_nxv8s32*//*Label 29406*/ GIMT_Encode4(2378352),
    /*GILLT_nxv8s64*//*Label 29407*/ GIMT_Encode4(2378467), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 29408*/ GIMT_Encode4(2378582),
    /*GILLT_nxv16s16*//*Label 29409*/ GIMT_Encode4(2378697),
    /*GILLT_nxv16s32*//*Label 29410*/ GIMT_Encode4(2378812), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 29411*/ GIMT_Encode4(2378927),
    /*GILLT_nxv32s16*//*Label 29412*/ GIMT_Encode4(2379042), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 29413*/ GIMT_Encode4(2379157),
    // Label 29390: @2376674
    GIM_Try, /*On fail goto*//*Label 29415*/ GIMT_Encode4(2376707), // Rule ID 290 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 290,
      GIR_Done,
    // Label 29415: @2376707
    GIM_Reject,
    // Label 29391: @2376708
    GIM_Try, /*On fail goto*//*Label 29416*/ GIMT_Encode4(2376741), // Rule ID 289 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 289,
      GIR_Done,
    // Label 29416: @2376741
    GIM_Reject,
    // Label 29392: @2376742
    GIM_Try, /*On fail goto*//*Label 29417*/ GIMT_Encode4(2376856),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29418*/ GIMT_Encode4(2376810), // Rule ID 50498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50498,
        GIR_EraseRootFromParent_Done,
      // Label 29418: @2376810
      GIM_Try, /*On fail goto*//*Label 29419*/ GIMT_Encode4(2376855), // Rule ID 50499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50499,
        GIR_EraseRootFromParent_Done,
      // Label 29419: @2376855
      GIM_Reject,
    // Label 29417: @2376856
    GIM_Reject,
    // Label 29393: @2376857
    GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2376971),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2376925), // Rule ID 50510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50510,
        GIR_EraseRootFromParent_Done,
      // Label 29421: @2376925
      GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2376970), // Rule ID 50511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50511,
        GIR_EraseRootFromParent_Done,
      // Label 29422: @2376970
      GIM_Reject,
    // Label 29420: @2376971
    GIM_Reject,
    // Label 29394: @2376972
    GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2377086),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2377040), // Rule ID 50518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50518,
        GIR_EraseRootFromParent_Done,
      // Label 29424: @2377040
      GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2377085), // Rule ID 50519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50519,
        GIR_EraseRootFromParent_Done,
      // Label 29425: @2377085
      GIM_Reject,
    // Label 29423: @2377086
    GIM_Reject,
    // Label 29395: @2377087
    GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2377201),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2377155), // Rule ID 50642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50642,
        GIR_EraseRootFromParent_Done,
      // Label 29427: @2377155
      GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2377200), // Rule ID 50643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50643,
        GIR_EraseRootFromParent_Done,
      // Label 29428: @2377200
      GIM_Reject,
    // Label 29426: @2377201
    GIM_Reject,
    // Label 29396: @2377202
    GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2377316),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2377270), // Rule ID 50502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50502,
        GIR_EraseRootFromParent_Done,
      // Label 29430: @2377270
      GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2377315), // Rule ID 50503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50503,
        GIR_EraseRootFromParent_Done,
      // Label 29431: @2377315
      GIM_Reject,
    // Label 29429: @2377316
    GIM_Reject,
    // Label 29397: @2377317
    GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2377431),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2377385), // Rule ID 50514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50514,
        GIR_EraseRootFromParent_Done,
      // Label 29433: @2377385
      GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2377430), // Rule ID 50515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50515,
        GIR_EraseRootFromParent_Done,
      // Label 29434: @2377430
      GIM_Reject,
    // Label 29432: @2377431
    GIM_Reject,
    // Label 29398: @2377432
    GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2377546),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2377500), // Rule ID 50530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50530,
        GIR_EraseRootFromParent_Done,
      // Label 29436: @2377500
      GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2377545), // Rule ID 50531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50531,
        GIR_EraseRootFromParent_Done,
      // Label 29437: @2377545
      GIM_Reject,
    // Label 29435: @2377546
    GIM_Reject,
    // Label 29399: @2377547
    GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2377661),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2377615), // Rule ID 50646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50646,
        GIR_EraseRootFromParent_Done,
      // Label 29439: @2377615
      GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2377660), // Rule ID 50647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50647,
        GIR_EraseRootFromParent_Done,
      // Label 29440: @2377660
      GIM_Reject,
    // Label 29438: @2377661
    GIM_Reject,
    // Label 29400: @2377662
    GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2377776),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2377730), // Rule ID 50506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50506,
        GIR_EraseRootFromParent_Done,
      // Label 29442: @2377730
      GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2377775), // Rule ID 50507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50507,
        GIR_EraseRootFromParent_Done,
      // Label 29443: @2377775
      GIM_Reject,
    // Label 29441: @2377776
    GIM_Reject,
    // Label 29401: @2377777
    GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2377891),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2377845), // Rule ID 50526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50526,
        GIR_EraseRootFromParent_Done,
      // Label 29445: @2377845
      GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2377890), // Rule ID 50527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50527,
        GIR_EraseRootFromParent_Done,
      // Label 29446: @2377890
      GIM_Reject,
    // Label 29444: @2377891
    GIM_Reject,
    // Label 29402: @2377892
    GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2378006),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2377960), // Rule ID 50558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50558,
        GIR_EraseRootFromParent_Done,
      // Label 29448: @2377960
      GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2378005), // Rule ID 50559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50559,
        GIR_EraseRootFromParent_Done,
      // Label 29449: @2378005
      GIM_Reject,
    // Label 29447: @2378006
    GIM_Reject,
    // Label 29403: @2378007
    GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2378121),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29451*/ GIMT_Encode4(2378075), // Rule ID 50650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50650,
        GIR_EraseRootFromParent_Done,
      // Label 29451: @2378075
      GIM_Try, /*On fail goto*//*Label 29452*/ GIMT_Encode4(2378120), // Rule ID 50651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50651,
        GIR_EraseRootFromParent_Done,
      // Label 29452: @2378120
      GIM_Reject,
    // Label 29450: @2378121
    GIM_Reject,
    // Label 29404: @2378122
    GIM_Try, /*On fail goto*//*Label 29453*/ GIMT_Encode4(2378236),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29454*/ GIMT_Encode4(2378190), // Rule ID 50522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50522,
        GIR_EraseRootFromParent_Done,
      // Label 29454: @2378190
      GIM_Try, /*On fail goto*//*Label 29455*/ GIMT_Encode4(2378235), // Rule ID 50523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50523,
        GIR_EraseRootFromParent_Done,
      // Label 29455: @2378235
      GIM_Reject,
    // Label 29453: @2378236
    GIM_Reject,
    // Label 29405: @2378237
    GIM_Try, /*On fail goto*//*Label 29456*/ GIMT_Encode4(2378351),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29457*/ GIMT_Encode4(2378305), // Rule ID 50546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50546,
        GIR_EraseRootFromParent_Done,
      // Label 29457: @2378305
      GIM_Try, /*On fail goto*//*Label 29458*/ GIMT_Encode4(2378350), // Rule ID 50547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50547,
        GIR_EraseRootFromParent_Done,
      // Label 29458: @2378350
      GIM_Reject,
    // Label 29456: @2378351
    GIM_Reject,
    // Label 29406: @2378352
    GIM_Try, /*On fail goto*//*Label 29459*/ GIMT_Encode4(2378466),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29460*/ GIMT_Encode4(2378420), // Rule ID 50562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50562,
        GIR_EraseRootFromParent_Done,
      // Label 29460: @2378420
      GIM_Try, /*On fail goto*//*Label 29461*/ GIMT_Encode4(2378465), // Rule ID 50563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50563,
        GIR_EraseRootFromParent_Done,
      // Label 29461: @2378465
      GIM_Reject,
    // Label 29459: @2378466
    GIM_Reject,
    // Label 29407: @2378467
    GIM_Try, /*On fail goto*//*Label 29462*/ GIMT_Encode4(2378581),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29463*/ GIMT_Encode4(2378535), // Rule ID 50654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
        // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50654,
        GIR_EraseRootFromParent_Done,
      // Label 29463: @2378535
      GIM_Try, /*On fail goto*//*Label 29464*/ GIMT_Encode4(2378580), // Rule ID 50655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
        // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50655,
        GIR_EraseRootFromParent_Done,
      // Label 29464: @2378580
      GIM_Reject,
    // Label 29462: @2378581
    GIM_Reject,
    // Label 29408: @2378582
    GIM_Try, /*On fail goto*//*Label 29465*/ GIMT_Encode4(2378696),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29466*/ GIMT_Encode4(2378650), // Rule ID 50534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50534,
        GIR_EraseRootFromParent_Done,
      // Label 29466: @2378650
      GIM_Try, /*On fail goto*//*Label 29467*/ GIMT_Encode4(2378695), // Rule ID 50535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50535,
        GIR_EraseRootFromParent_Done,
      // Label 29467: @2378695
      GIM_Reject,
    // Label 29465: @2378696
    GIM_Reject,
    // Label 29409: @2378697
    GIM_Try, /*On fail goto*//*Label 29468*/ GIMT_Encode4(2378811),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29469*/ GIMT_Encode4(2378765), // Rule ID 50550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50550,
        GIR_EraseRootFromParent_Done,
      // Label 29469: @2378765
      GIM_Try, /*On fail goto*//*Label 29470*/ GIMT_Encode4(2378810), // Rule ID 50551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50551,
        GIR_EraseRootFromParent_Done,
      // Label 29470: @2378810
      GIM_Reject,
    // Label 29468: @2378811
    GIM_Reject,
    // Label 29410: @2378812
    GIM_Try, /*On fail goto*//*Label 29471*/ GIMT_Encode4(2378926),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29472*/ GIMT_Encode4(2378880), // Rule ID 50566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50566,
        GIR_EraseRootFromParent_Done,
      // Label 29472: @2378880
      GIM_Try, /*On fail goto*//*Label 29473*/ GIMT_Encode4(2378925), // Rule ID 50567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50567,
        GIR_EraseRootFromParent_Done,
      // Label 29473: @2378925
      GIM_Reject,
    // Label 29471: @2378926
    GIM_Reject,
    // Label 29411: @2378927
    GIM_Try, /*On fail goto*//*Label 29474*/ GIMT_Encode4(2379041),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29475*/ GIMT_Encode4(2378995), // Rule ID 50538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50538,
        GIR_EraseRootFromParent_Done,
      // Label 29475: @2378995
      GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2379040), // Rule ID 50539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50539,
        GIR_EraseRootFromParent_Done,
      // Label 29476: @2379040
      GIM_Reject,
    // Label 29474: @2379041
    GIM_Reject,
    // Label 29412: @2379042
    GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2379156),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2379110), // Rule ID 50554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50554,
        GIR_EraseRootFromParent_Done,
      // Label 29478: @2379110
      GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2379155), // Rule ID 50555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50555,
        GIR_EraseRootFromParent_Done,
      // Label 29479: @2379155
      GIM_Reject,
    // Label 29477: @2379156
    GIM_Reject,
    // Label 29413: @2379157
    GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2379271),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2379225), // Rule ID 50542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50542,
        GIR_EraseRootFromParent_Done,
      // Label 29481: @2379225
      GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2379270), // Rule ID 50543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50543,
        GIR_EraseRootFromParent_Done,
      // Label 29482: @2379270
      GIM_Reject,
    // Label 29480: @2379271
    GIM_Reject,
    // Label 29414: @2379272
    GIM_Reject,
    // Label 53: @2379273
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 29505*/ GIMT_Encode4(2382058),
    /*GILLT_nxv1s8*//*Label 29483*/ GIMT_Encode4(2379396),
    /*GILLT_nxv1s16*//*Label 29484*/ GIMT_Encode4(2379517),
    /*GILLT_nxv1s32*//*Label 29485*/ GIMT_Encode4(2379638),
    /*GILLT_nxv1s64*//*Label 29486*/ GIMT_Encode4(2379759), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 29487*/ GIMT_Encode4(2379880),
    /*GILLT_nxv2s16*//*Label 29488*/ GIMT_Encode4(2380001),
    /*GILLT_nxv2s32*//*Label 29489*/ GIMT_Encode4(2380122),
    /*GILLT_nxv2s64*//*Label 29490*/ GIMT_Encode4(2380243), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 29491*/ GIMT_Encode4(2380364),
    /*GILLT_nxv4s16*//*Label 29492*/ GIMT_Encode4(2380485),
    /*GILLT_nxv4s32*//*Label 29493*/ GIMT_Encode4(2380606),
    /*GILLT_nxv4s64*//*Label 29494*/ GIMT_Encode4(2380727), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 29495*/ GIMT_Encode4(2380848),
    /*GILLT_nxv8s16*//*Label 29496*/ GIMT_Encode4(2380969),
    /*GILLT_nxv8s32*//*Label 29497*/ GIMT_Encode4(2381090),
    /*GILLT_nxv8s64*//*Label 29498*/ GIMT_Encode4(2381211), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 29499*/ GIMT_Encode4(2381332),
    /*GILLT_nxv16s16*//*Label 29500*/ GIMT_Encode4(2381453),
    /*GILLT_nxv16s32*//*Label 29501*/ GIMT_Encode4(2381574), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 29502*/ GIMT_Encode4(2381695),
    /*GILLT_nxv32s16*//*Label 29503*/ GIMT_Encode4(2381816), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 29504*/ GIMT_Encode4(2381937),
    // Label 29483: @2379396
    GIM_Try, /*On fail goto*//*Label 29506*/ GIMT_Encode4(2379516),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29507*/ GIMT_Encode4(2379467), // Rule ID 52058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52058,
        GIR_EraseRootFromParent_Done,
      // Label 29507: @2379467
      GIM_Try, /*On fail goto*//*Label 29508*/ GIMT_Encode4(2379515), // Rule ID 52059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52059,
        GIR_EraseRootFromParent_Done,
      // Label 29508: @2379515
      GIM_Reject,
    // Label 29506: @2379516
    GIM_Reject,
    // Label 29484: @2379517
    GIM_Try, /*On fail goto*//*Label 29509*/ GIMT_Encode4(2379637),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29510*/ GIMT_Encode4(2379588), // Rule ID 52070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52070,
        GIR_EraseRootFromParent_Done,
      // Label 29510: @2379588
      GIM_Try, /*On fail goto*//*Label 29511*/ GIMT_Encode4(2379636), // Rule ID 52071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52071,
        GIR_EraseRootFromParent_Done,
      // Label 29511: @2379636
      GIM_Reject,
    // Label 29509: @2379637
    GIM_Reject,
    // Label 29485: @2379638
    GIM_Try, /*On fail goto*//*Label 29512*/ GIMT_Encode4(2379758),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29513*/ GIMT_Encode4(2379709), // Rule ID 52078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52078,
        GIR_EraseRootFromParent_Done,
      // Label 29513: @2379709
      GIM_Try, /*On fail goto*//*Label 29514*/ GIMT_Encode4(2379757), // Rule ID 52079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52079,
        GIR_EraseRootFromParent_Done,
      // Label 29514: @2379757
      GIM_Reject,
    // Label 29512: @2379758
    GIM_Reject,
    // Label 29486: @2379759
    GIM_Try, /*On fail goto*//*Label 29515*/ GIMT_Encode4(2379879),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29516*/ GIMT_Encode4(2379830), // Rule ID 52094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52094,
        GIR_EraseRootFromParent_Done,
      // Label 29516: @2379830
      GIM_Try, /*On fail goto*//*Label 29517*/ GIMT_Encode4(2379878), // Rule ID 52095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52095,
        GIR_EraseRootFromParent_Done,
      // Label 29517: @2379878
      GIM_Reject,
    // Label 29515: @2379879
    GIM_Reject,
    // Label 29487: @2379880
    GIM_Try, /*On fail goto*//*Label 29518*/ GIMT_Encode4(2380000),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29519*/ GIMT_Encode4(2379951), // Rule ID 52062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52062,
        GIR_EraseRootFromParent_Done,
      // Label 29519: @2379951
      GIM_Try, /*On fail goto*//*Label 29520*/ GIMT_Encode4(2379999), // Rule ID 52063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52063,
        GIR_EraseRootFromParent_Done,
      // Label 29520: @2379999
      GIM_Reject,
    // Label 29518: @2380000
    GIM_Reject,
    // Label 29488: @2380001
    GIM_Try, /*On fail goto*//*Label 29521*/ GIMT_Encode4(2380121),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29522*/ GIMT_Encode4(2380072), // Rule ID 52074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52074,
        GIR_EraseRootFromParent_Done,
      // Label 29522: @2380072
      GIM_Try, /*On fail goto*//*Label 29523*/ GIMT_Encode4(2380120), // Rule ID 52075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52075,
        GIR_EraseRootFromParent_Done,
      // Label 29523: @2380120
      GIM_Reject,
    // Label 29521: @2380121
    GIM_Reject,
    // Label 29489: @2380122
    GIM_Try, /*On fail goto*//*Label 29524*/ GIMT_Encode4(2380242),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29525*/ GIMT_Encode4(2380193), // Rule ID 52090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52090,
        GIR_EraseRootFromParent_Done,
      // Label 29525: @2380193
      GIM_Try, /*On fail goto*//*Label 29526*/ GIMT_Encode4(2380241), // Rule ID 52091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52091,
        GIR_EraseRootFromParent_Done,
      // Label 29526: @2380241
      GIM_Reject,
    // Label 29524: @2380242
    GIM_Reject,
    // Label 29490: @2380243
    GIM_Try, /*On fail goto*//*Label 29527*/ GIMT_Encode4(2380363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29528*/ GIMT_Encode4(2380314), // Rule ID 52134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52134,
        GIR_EraseRootFromParent_Done,
      // Label 29528: @2380314
      GIM_Try, /*On fail goto*//*Label 29529*/ GIMT_Encode4(2380362), // Rule ID 52135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52135,
        GIR_EraseRootFromParent_Done,
      // Label 29529: @2380362
      GIM_Reject,
    // Label 29527: @2380363
    GIM_Reject,
    // Label 29491: @2380364
    GIM_Try, /*On fail goto*//*Label 29530*/ GIMT_Encode4(2380484),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29531*/ GIMT_Encode4(2380435), // Rule ID 52066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52066,
        GIR_EraseRootFromParent_Done,
      // Label 29531: @2380435
      GIM_Try, /*On fail goto*//*Label 29532*/ GIMT_Encode4(2380483), // Rule ID 52067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52067,
        GIR_EraseRootFromParent_Done,
      // Label 29532: @2380483
      GIM_Reject,
    // Label 29530: @2380484
    GIM_Reject,
    // Label 29492: @2380485
    GIM_Try, /*On fail goto*//*Label 29533*/ GIMT_Encode4(2380605),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29534*/ GIMT_Encode4(2380556), // Rule ID 52086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52086,
        GIR_EraseRootFromParent_Done,
      // Label 29534: @2380556
      GIM_Try, /*On fail goto*//*Label 29535*/ GIMT_Encode4(2380604), // Rule ID 52087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52087,
        GIR_EraseRootFromParent_Done,
      // Label 29535: @2380604
      GIM_Reject,
    // Label 29533: @2380605
    GIM_Reject,
    // Label 29493: @2380606
    GIM_Try, /*On fail goto*//*Label 29536*/ GIMT_Encode4(2380726),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29537*/ GIMT_Encode4(2380677), // Rule ID 52122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52122,
        GIR_EraseRootFromParent_Done,
      // Label 29537: @2380677
      GIM_Try, /*On fail goto*//*Label 29538*/ GIMT_Encode4(2380725), // Rule ID 52123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52123,
        GIR_EraseRootFromParent_Done,
      // Label 29538: @2380725
      GIM_Reject,
    // Label 29536: @2380726
    GIM_Reject,
    // Label 29494: @2380727
    GIM_Try, /*On fail goto*//*Label 29539*/ GIMT_Encode4(2380847),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29540*/ GIMT_Encode4(2380798), // Rule ID 52138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52138,
        GIR_EraseRootFromParent_Done,
      // Label 29540: @2380798
      GIM_Try, /*On fail goto*//*Label 29541*/ GIMT_Encode4(2380846), // Rule ID 52139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52139,
        GIR_EraseRootFromParent_Done,
      // Label 29541: @2380846
      GIM_Reject,
    // Label 29539: @2380847
    GIM_Reject,
    // Label 29495: @2380848
    GIM_Try, /*On fail goto*//*Label 29542*/ GIMT_Encode4(2380968),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29543*/ GIMT_Encode4(2380919), // Rule ID 52082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52082,
        GIR_EraseRootFromParent_Done,
      // Label 29543: @2380919
      GIM_Try, /*On fail goto*//*Label 29544*/ GIMT_Encode4(2380967), // Rule ID 52083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52083,
        GIR_EraseRootFromParent_Done,
      // Label 29544: @2380967
      GIM_Reject,
    // Label 29542: @2380968
    GIM_Reject,
    // Label 29496: @2380969
    GIM_Try, /*On fail goto*//*Label 29545*/ GIMT_Encode4(2381089),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29546*/ GIMT_Encode4(2381040), // Rule ID 52110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52110,
        GIR_EraseRootFromParent_Done,
      // Label 29546: @2381040
      GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2381088), // Rule ID 52111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52111,
        GIR_EraseRootFromParent_Done,
      // Label 29547: @2381088
      GIM_Reject,
    // Label 29545: @2381089
    GIM_Reject,
    // Label 29497: @2381090
    GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2381210),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2381161), // Rule ID 52126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52126,
        GIR_EraseRootFromParent_Done,
      // Label 29549: @2381161
      GIM_Try, /*On fail goto*//*Label 29550*/ GIMT_Encode4(2381209), // Rule ID 52127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52127,
        GIR_EraseRootFromParent_Done,
      // Label 29550: @2381209
      GIM_Reject,
    // Label 29548: @2381210
    GIM_Reject,
    // Label 29498: @2381211
    GIM_Try, /*On fail goto*//*Label 29551*/ GIMT_Encode4(2381331),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29552*/ GIMT_Encode4(2381282), // Rule ID 52142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52142,
        GIR_EraseRootFromParent_Done,
      // Label 29552: @2381282
      GIM_Try, /*On fail goto*//*Label 29553*/ GIMT_Encode4(2381330), // Rule ID 52143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52143,
        GIR_EraseRootFromParent_Done,
      // Label 29553: @2381330
      GIM_Reject,
    // Label 29551: @2381331
    GIM_Reject,
    // Label 29499: @2381332
    GIM_Try, /*On fail goto*//*Label 29554*/ GIMT_Encode4(2381452),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29555*/ GIMT_Encode4(2381403), // Rule ID 52098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52098,
        GIR_EraseRootFromParent_Done,
      // Label 29555: @2381403
      GIM_Try, /*On fail goto*//*Label 29556*/ GIMT_Encode4(2381451), // Rule ID 52099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52099,
        GIR_EraseRootFromParent_Done,
      // Label 29556: @2381451
      GIM_Reject,
    // Label 29554: @2381452
    GIM_Reject,
    // Label 29500: @2381453
    GIM_Try, /*On fail goto*//*Label 29557*/ GIMT_Encode4(2381573),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29558*/ GIMT_Encode4(2381524), // Rule ID 52114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52114,
        GIR_EraseRootFromParent_Done,
      // Label 29558: @2381524
      GIM_Try, /*On fail goto*//*Label 29559*/ GIMT_Encode4(2381572), // Rule ID 52115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52115,
        GIR_EraseRootFromParent_Done,
      // Label 29559: @2381572
      GIM_Reject,
    // Label 29557: @2381573
    GIM_Reject,
    // Label 29501: @2381574
    GIM_Try, /*On fail goto*//*Label 29560*/ GIMT_Encode4(2381694),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29561*/ GIMT_Encode4(2381645), // Rule ID 52130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52130,
        GIR_EraseRootFromParent_Done,
      // Label 29561: @2381645
      GIM_Try, /*On fail goto*//*Label 29562*/ GIMT_Encode4(2381693), // Rule ID 52131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52131,
        GIR_EraseRootFromParent_Done,
      // Label 29562: @2381693
      GIM_Reject,
    // Label 29560: @2381694
    GIM_Reject,
    // Label 29502: @2381695
    GIM_Try, /*On fail goto*//*Label 29563*/ GIMT_Encode4(2381815),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29564*/ GIMT_Encode4(2381766), // Rule ID 52102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52102,
        GIR_EraseRootFromParent_Done,
      // Label 29564: @2381766
      GIM_Try, /*On fail goto*//*Label 29565*/ GIMT_Encode4(2381814), // Rule ID 52103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52103,
        GIR_EraseRootFromParent_Done,
      // Label 29565: @2381814
      GIM_Reject,
    // Label 29563: @2381815
    GIM_Reject,
    // Label 29503: @2381816
    GIM_Try, /*On fail goto*//*Label 29566*/ GIMT_Encode4(2381936),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29567*/ GIMT_Encode4(2381887), // Rule ID 52118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52118,
        GIR_EraseRootFromParent_Done,
      // Label 29567: @2381887
      GIM_Try, /*On fail goto*//*Label 29568*/ GIMT_Encode4(2381935), // Rule ID 52119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52119,
        GIR_EraseRootFromParent_Done,
      // Label 29568: @2381935
      GIM_Reject,
    // Label 29566: @2381936
    GIM_Reject,
    // Label 29504: @2381937
    GIM_Try, /*On fail goto*//*Label 29569*/ GIMT_Encode4(2382057),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29570*/ GIMT_Encode4(2382008), // Rule ID 52106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52106,
        GIR_EraseRootFromParent_Done,
      // Label 29570: @2382008
      GIM_Try, /*On fail goto*//*Label 29571*/ GIMT_Encode4(2382056), // Rule ID 52107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52107,
        GIR_EraseRootFromParent_Done,
      // Label 29571: @2382056
      GIM_Reject,
    // Label 29569: @2382057
    GIM_Reject,
    // Label 29505: @2382058
    GIM_Reject,
    // Label 54: @2382059
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 29594*/ GIMT_Encode4(2384844),
    /*GILLT_nxv1s8*//*Label 29572*/ GIMT_Encode4(2382182),
    /*GILLT_nxv1s16*//*Label 29573*/ GIMT_Encode4(2382303),
    /*GILLT_nxv1s32*//*Label 29574*/ GIMT_Encode4(2382424),
    /*GILLT_nxv1s64*//*Label 29575*/ GIMT_Encode4(2382545), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 29576*/ GIMT_Encode4(2382666),
    /*GILLT_nxv2s16*//*Label 29577*/ GIMT_Encode4(2382787),
    /*GILLT_nxv2s32*//*Label 29578*/ GIMT_Encode4(2382908),
    /*GILLT_nxv2s64*//*Label 29579*/ GIMT_Encode4(2383029), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 29580*/ GIMT_Encode4(2383150),
    /*GILLT_nxv4s16*//*Label 29581*/ GIMT_Encode4(2383271),
    /*GILLT_nxv4s32*//*Label 29582*/ GIMT_Encode4(2383392),
    /*GILLT_nxv4s64*//*Label 29583*/ GIMT_Encode4(2383513), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 29584*/ GIMT_Encode4(2383634),
    /*GILLT_nxv8s16*//*Label 29585*/ GIMT_Encode4(2383755),
    /*GILLT_nxv8s32*//*Label 29586*/ GIMT_Encode4(2383876),
    /*GILLT_nxv8s64*//*Label 29587*/ GIMT_Encode4(2383997), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 29588*/ GIMT_Encode4(2384118),
    /*GILLT_nxv16s16*//*Label 29589*/ GIMT_Encode4(2384239),
    /*GILLT_nxv16s32*//*Label 29590*/ GIMT_Encode4(2384360), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 29591*/ GIMT_Encode4(2384481),
    /*GILLT_nxv32s16*//*Label 29592*/ GIMT_Encode4(2384602), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 29593*/ GIMT_Encode4(2384723),
    // Label 29572: @2382182
    GIM_Try, /*On fail goto*//*Label 29595*/ GIMT_Encode4(2382302),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29596*/ GIMT_Encode4(2382253), // Rule ID 51926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51926,
        GIR_EraseRootFromParent_Done,
      // Label 29596: @2382253
      GIM_Try, /*On fail goto*//*Label 29597*/ GIMT_Encode4(2382301), // Rule ID 51927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51927,
        GIR_EraseRootFromParent_Done,
      // Label 29597: @2382301
      GIM_Reject,
    // Label 29595: @2382302
    GIM_Reject,
    // Label 29573: @2382303
    GIM_Try, /*On fail goto*//*Label 29598*/ GIMT_Encode4(2382423),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29599*/ GIMT_Encode4(2382374), // Rule ID 51938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51938,
        GIR_EraseRootFromParent_Done,
      // Label 29599: @2382374
      GIM_Try, /*On fail goto*//*Label 29600*/ GIMT_Encode4(2382422), // Rule ID 51939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51939,
        GIR_EraseRootFromParent_Done,
      // Label 29600: @2382422
      GIM_Reject,
    // Label 29598: @2382423
    GIM_Reject,
    // Label 29574: @2382424
    GIM_Try, /*On fail goto*//*Label 29601*/ GIMT_Encode4(2382544),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29602*/ GIMT_Encode4(2382495), // Rule ID 51946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51946,
        GIR_EraseRootFromParent_Done,
      // Label 29602: @2382495
      GIM_Try, /*On fail goto*//*Label 29603*/ GIMT_Encode4(2382543), // Rule ID 51947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51947,
        GIR_EraseRootFromParent_Done,
      // Label 29603: @2382543
      GIM_Reject,
    // Label 29601: @2382544
    GIM_Reject,
    // Label 29575: @2382545
    GIM_Try, /*On fail goto*//*Label 29604*/ GIMT_Encode4(2382665),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29605*/ GIMT_Encode4(2382616), // Rule ID 51962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51962,
        GIR_EraseRootFromParent_Done,
      // Label 29605: @2382616
      GIM_Try, /*On fail goto*//*Label 29606*/ GIMT_Encode4(2382664), // Rule ID 51963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51963,
        GIR_EraseRootFromParent_Done,
      // Label 29606: @2382664
      GIM_Reject,
    // Label 29604: @2382665
    GIM_Reject,
    // Label 29576: @2382666
    GIM_Try, /*On fail goto*//*Label 29607*/ GIMT_Encode4(2382786),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29608*/ GIMT_Encode4(2382737), // Rule ID 51930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51930,
        GIR_EraseRootFromParent_Done,
      // Label 29608: @2382737
      GIM_Try, /*On fail goto*//*Label 29609*/ GIMT_Encode4(2382785), // Rule ID 51931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51931,
        GIR_EraseRootFromParent_Done,
      // Label 29609: @2382785
      GIM_Reject,
    // Label 29607: @2382786
    GIM_Reject,
    // Label 29577: @2382787
    GIM_Try, /*On fail goto*//*Label 29610*/ GIMT_Encode4(2382907),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29611*/ GIMT_Encode4(2382858), // Rule ID 51942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51942,
        GIR_EraseRootFromParent_Done,
      // Label 29611: @2382858
      GIM_Try, /*On fail goto*//*Label 29612*/ GIMT_Encode4(2382906), // Rule ID 51943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51943,
        GIR_EraseRootFromParent_Done,
      // Label 29612: @2382906
      GIM_Reject,
    // Label 29610: @2382907
    GIM_Reject,
    // Label 29578: @2382908
    GIM_Try, /*On fail goto*//*Label 29613*/ GIMT_Encode4(2383028),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29614*/ GIMT_Encode4(2382979), // Rule ID 51958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51958,
        GIR_EraseRootFromParent_Done,
      // Label 29614: @2382979
      GIM_Try, /*On fail goto*//*Label 29615*/ GIMT_Encode4(2383027), // Rule ID 51959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51959,
        GIR_EraseRootFromParent_Done,
      // Label 29615: @2383027
      GIM_Reject,
    // Label 29613: @2383028
    GIM_Reject,
    // Label 29579: @2383029
    GIM_Try, /*On fail goto*//*Label 29616*/ GIMT_Encode4(2383149),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29617*/ GIMT_Encode4(2383100), // Rule ID 52002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52002,
        GIR_EraseRootFromParent_Done,
      // Label 29617: @2383100
      GIM_Try, /*On fail goto*//*Label 29618*/ GIMT_Encode4(2383148), // Rule ID 52003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52003,
        GIR_EraseRootFromParent_Done,
      // Label 29618: @2383148
      GIM_Reject,
    // Label 29616: @2383149
    GIM_Reject,
    // Label 29580: @2383150
    GIM_Try, /*On fail goto*//*Label 29619*/ GIMT_Encode4(2383270),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29620*/ GIMT_Encode4(2383221), // Rule ID 51934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51934,
        GIR_EraseRootFromParent_Done,
      // Label 29620: @2383221
      GIM_Try, /*On fail goto*//*Label 29621*/ GIMT_Encode4(2383269), // Rule ID 51935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51935,
        GIR_EraseRootFromParent_Done,
      // Label 29621: @2383269
      GIM_Reject,
    // Label 29619: @2383270
    GIM_Reject,
    // Label 29581: @2383271
    GIM_Try, /*On fail goto*//*Label 29622*/ GIMT_Encode4(2383391),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29623*/ GIMT_Encode4(2383342), // Rule ID 51954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51954,
        GIR_EraseRootFromParent_Done,
      // Label 29623: @2383342
      GIM_Try, /*On fail goto*//*Label 29624*/ GIMT_Encode4(2383390), // Rule ID 51955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51955,
        GIR_EraseRootFromParent_Done,
      // Label 29624: @2383390
      GIM_Reject,
    // Label 29622: @2383391
    GIM_Reject,
    // Label 29582: @2383392
    GIM_Try, /*On fail goto*//*Label 29625*/ GIMT_Encode4(2383512),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29626*/ GIMT_Encode4(2383463), // Rule ID 51990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51990,
        GIR_EraseRootFromParent_Done,
      // Label 29626: @2383463
      GIM_Try, /*On fail goto*//*Label 29627*/ GIMT_Encode4(2383511), // Rule ID 51991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51991,
        GIR_EraseRootFromParent_Done,
      // Label 29627: @2383511
      GIM_Reject,
    // Label 29625: @2383512
    GIM_Reject,
    // Label 29583: @2383513
    GIM_Try, /*On fail goto*//*Label 29628*/ GIMT_Encode4(2383633),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29629*/ GIMT_Encode4(2383584), // Rule ID 52006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52006,
        GIR_EraseRootFromParent_Done,
      // Label 29629: @2383584
      GIM_Try, /*On fail goto*//*Label 29630*/ GIMT_Encode4(2383632), // Rule ID 52007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52007,
        GIR_EraseRootFromParent_Done,
      // Label 29630: @2383632
      GIM_Reject,
    // Label 29628: @2383633
    GIM_Reject,
    // Label 29584: @2383634
    GIM_Try, /*On fail goto*//*Label 29631*/ GIMT_Encode4(2383754),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29632*/ GIMT_Encode4(2383705), // Rule ID 51950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51950,
        GIR_EraseRootFromParent_Done,
      // Label 29632: @2383705
      GIM_Try, /*On fail goto*//*Label 29633*/ GIMT_Encode4(2383753), // Rule ID 51951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51951,
        GIR_EraseRootFromParent_Done,
      // Label 29633: @2383753
      GIM_Reject,
    // Label 29631: @2383754
    GIM_Reject,
    // Label 29585: @2383755
    GIM_Try, /*On fail goto*//*Label 29634*/ GIMT_Encode4(2383875),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29635*/ GIMT_Encode4(2383826), // Rule ID 51978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51978,
        GIR_EraseRootFromParent_Done,
      // Label 29635: @2383826
      GIM_Try, /*On fail goto*//*Label 29636*/ GIMT_Encode4(2383874), // Rule ID 51979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51979,
        GIR_EraseRootFromParent_Done,
      // Label 29636: @2383874
      GIM_Reject,
    // Label 29634: @2383875
    GIM_Reject,
    // Label 29586: @2383876
    GIM_Try, /*On fail goto*//*Label 29637*/ GIMT_Encode4(2383996),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29638*/ GIMT_Encode4(2383947), // Rule ID 51994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51994,
        GIR_EraseRootFromParent_Done,
      // Label 29638: @2383947
      GIM_Try, /*On fail goto*//*Label 29639*/ GIMT_Encode4(2383995), // Rule ID 51995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51995,
        GIR_EraseRootFromParent_Done,
      // Label 29639: @2383995
      GIM_Reject,
    // Label 29637: @2383996
    GIM_Reject,
    // Label 29587: @2383997
    GIM_Try, /*On fail goto*//*Label 29640*/ GIMT_Encode4(2384117),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29641*/ GIMT_Encode4(2384068), // Rule ID 52010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52010,
        GIR_EraseRootFromParent_Done,
      // Label 29641: @2384068
      GIM_Try, /*On fail goto*//*Label 29642*/ GIMT_Encode4(2384116), // Rule ID 52011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52011,
        GIR_EraseRootFromParent_Done,
      // Label 29642: @2384116
      GIM_Reject,
    // Label 29640: @2384117
    GIM_Reject,
    // Label 29588: @2384118
    GIM_Try, /*On fail goto*//*Label 29643*/ GIMT_Encode4(2384238),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29644*/ GIMT_Encode4(2384189), // Rule ID 51966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51966,
        GIR_EraseRootFromParent_Done,
      // Label 29644: @2384189
      GIM_Try, /*On fail goto*//*Label 29645*/ GIMT_Encode4(2384237), // Rule ID 51967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51967,
        GIR_EraseRootFromParent_Done,
      // Label 29645: @2384237
      GIM_Reject,
    // Label 29643: @2384238
    GIM_Reject,
    // Label 29589: @2384239
    GIM_Try, /*On fail goto*//*Label 29646*/ GIMT_Encode4(2384359),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2384310), // Rule ID 51982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51982,
        GIR_EraseRootFromParent_Done,
      // Label 29647: @2384310
      GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2384358), // Rule ID 51983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51983,
        GIR_EraseRootFromParent_Done,
      // Label 29648: @2384358
      GIM_Reject,
    // Label 29646: @2384359
    GIM_Reject,
    // Label 29590: @2384360
    GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2384480),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2384431), // Rule ID 51998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51998,
        GIR_EraseRootFromParent_Done,
      // Label 29650: @2384431
      GIM_Try, /*On fail goto*//*Label 29651*/ GIMT_Encode4(2384479), // Rule ID 51999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51999,
        GIR_EraseRootFromParent_Done,
      // Label 29651: @2384479
      GIM_Reject,
    // Label 29649: @2384480
    GIM_Reject,
    // Label 29591: @2384481
    GIM_Try, /*On fail goto*//*Label 29652*/ GIMT_Encode4(2384601),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29653*/ GIMT_Encode4(2384552), // Rule ID 51970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51970,
        GIR_EraseRootFromParent_Done,
      // Label 29653: @2384552
      GIM_Try, /*On fail goto*//*Label 29654*/ GIMT_Encode4(2384600), // Rule ID 51971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51971,
        GIR_EraseRootFromParent_Done,
      // Label 29654: @2384600
      GIM_Reject,
    // Label 29652: @2384601
    GIM_Reject,
    // Label 29592: @2384602
    GIM_Try, /*On fail goto*//*Label 29655*/ GIMT_Encode4(2384722),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29656*/ GIMT_Encode4(2384673), // Rule ID 51986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51986,
        GIR_EraseRootFromParent_Done,
      // Label 29656: @2384673
      GIM_Try, /*On fail goto*//*Label 29657*/ GIMT_Encode4(2384721), // Rule ID 51987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51987,
        GIR_EraseRootFromParent_Done,
      // Label 29657: @2384721
      GIM_Reject,
    // Label 29655: @2384722
    GIM_Reject,
    // Label 29593: @2384723
    GIM_Try, /*On fail goto*//*Label 29658*/ GIMT_Encode4(2384843),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29659*/ GIMT_Encode4(2384794), // Rule ID 51974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51974,
        GIR_EraseRootFromParent_Done,
      // Label 29659: @2384794
      GIM_Try, /*On fail goto*//*Label 29660*/ GIMT_Encode4(2384842), // Rule ID 51975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51975,
        GIR_EraseRootFromParent_Done,
      // Label 29660: @2384842
      GIM_Reject,
    // Label 29658: @2384843
    GIM_Reject,
    // Label 29594: @2384844
    GIM_Reject,
    // Label 55: @2384845
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 29683*/ GIMT_Encode4(2387630),
    /*GILLT_nxv1s8*//*Label 29661*/ GIMT_Encode4(2384968),
    /*GILLT_nxv1s16*//*Label 29662*/ GIMT_Encode4(2385089),
    /*GILLT_nxv1s32*//*Label 29663*/ GIMT_Encode4(2385210),
    /*GILLT_nxv1s64*//*Label 29664*/ GIMT_Encode4(2385331), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 29665*/ GIMT_Encode4(2385452),
    /*GILLT_nxv2s16*//*Label 29666*/ GIMT_Encode4(2385573),
    /*GILLT_nxv2s32*//*Label 29667*/ GIMT_Encode4(2385694),
    /*GILLT_nxv2s64*//*Label 29668*/ GIMT_Encode4(2385815), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 29669*/ GIMT_Encode4(2385936),
    /*GILLT_nxv4s16*//*Label 29670*/ GIMT_Encode4(2386057),
    /*GILLT_nxv4s32*//*Label 29671*/ GIMT_Encode4(2386178),
    /*GILLT_nxv4s64*//*Label 29672*/ GIMT_Encode4(2386299), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 29673*/ GIMT_Encode4(2386420),
    /*GILLT_nxv8s16*//*Label 29674*/ GIMT_Encode4(2386541),
    /*GILLT_nxv8s32*//*Label 29675*/ GIMT_Encode4(2386662),
    /*GILLT_nxv8s64*//*Label 29676*/ GIMT_Encode4(2386783), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 29677*/ GIMT_Encode4(2386904),
    /*GILLT_nxv16s16*//*Label 29678*/ GIMT_Encode4(2387025),
    /*GILLT_nxv16s32*//*Label 29679*/ GIMT_Encode4(2387146), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 29680*/ GIMT_Encode4(2387267),
    /*GILLT_nxv32s16*//*Label 29681*/ GIMT_Encode4(2387388), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 29682*/ GIMT_Encode4(2387509),
    // Label 29661: @2384968
    GIM_Try, /*On fail goto*//*Label 29684*/ GIMT_Encode4(2385088),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29685*/ GIMT_Encode4(2385039), // Rule ID 52278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52278,
        GIR_EraseRootFromParent_Done,
      // Label 29685: @2385039
      GIM_Try, /*On fail goto*//*Label 29686*/ GIMT_Encode4(2385087), // Rule ID 52279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52279,
        GIR_EraseRootFromParent_Done,
      // Label 29686: @2385087
      GIM_Reject,
    // Label 29684: @2385088
    GIM_Reject,
    // Label 29662: @2385089
    GIM_Try, /*On fail goto*//*Label 29687*/ GIMT_Encode4(2385209),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29688*/ GIMT_Encode4(2385160), // Rule ID 52290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52290,
        GIR_EraseRootFromParent_Done,
      // Label 29688: @2385160
      GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2385208), // Rule ID 52291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52291,
        GIR_EraseRootFromParent_Done,
      // Label 29689: @2385208
      GIM_Reject,
    // Label 29687: @2385209
    GIM_Reject,
    // Label 29663: @2385210
    GIM_Try, /*On fail goto*//*Label 29690*/ GIMT_Encode4(2385330),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29691*/ GIMT_Encode4(2385281), // Rule ID 52298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52298,
        GIR_EraseRootFromParent_Done,
      // Label 29691: @2385281
      GIM_Try, /*On fail goto*//*Label 29692*/ GIMT_Encode4(2385329), // Rule ID 52299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52299,
        GIR_EraseRootFromParent_Done,
      // Label 29692: @2385329
      GIM_Reject,
    // Label 29690: @2385330
    GIM_Reject,
    // Label 29664: @2385331
    GIM_Try, /*On fail goto*//*Label 29693*/ GIMT_Encode4(2385451),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29694*/ GIMT_Encode4(2385402), // Rule ID 52314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52314,
        GIR_EraseRootFromParent_Done,
      // Label 29694: @2385402
      GIM_Try, /*On fail goto*//*Label 29695*/ GIMT_Encode4(2385450), // Rule ID 52315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52315,
        GIR_EraseRootFromParent_Done,
      // Label 29695: @2385450
      GIM_Reject,
    // Label 29693: @2385451
    GIM_Reject,
    // Label 29665: @2385452
    GIM_Try, /*On fail goto*//*Label 29696*/ GIMT_Encode4(2385572),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29697*/ GIMT_Encode4(2385523), // Rule ID 52282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52282,
        GIR_EraseRootFromParent_Done,
      // Label 29697: @2385523
      GIM_Try, /*On fail goto*//*Label 29698*/ GIMT_Encode4(2385571), // Rule ID 52283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52283,
        GIR_EraseRootFromParent_Done,
      // Label 29698: @2385571
      GIM_Reject,
    // Label 29696: @2385572
    GIM_Reject,
    // Label 29666: @2385573
    GIM_Try, /*On fail goto*//*Label 29699*/ GIMT_Encode4(2385693),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29700*/ GIMT_Encode4(2385644), // Rule ID 52294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52294,
        GIR_EraseRootFromParent_Done,
      // Label 29700: @2385644
      GIM_Try, /*On fail goto*//*Label 29701*/ GIMT_Encode4(2385692), // Rule ID 52295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52295,
        GIR_EraseRootFromParent_Done,
      // Label 29701: @2385692
      GIM_Reject,
    // Label 29699: @2385693
    GIM_Reject,
    // Label 29667: @2385694
    GIM_Try, /*On fail goto*//*Label 29702*/ GIMT_Encode4(2385814),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29703*/ GIMT_Encode4(2385765), // Rule ID 52310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52310,
        GIR_EraseRootFromParent_Done,
      // Label 29703: @2385765
      GIM_Try, /*On fail goto*//*Label 29704*/ GIMT_Encode4(2385813), // Rule ID 52311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52311,
        GIR_EraseRootFromParent_Done,
      // Label 29704: @2385813
      GIM_Reject,
    // Label 29702: @2385814
    GIM_Reject,
    // Label 29668: @2385815
    GIM_Try, /*On fail goto*//*Label 29705*/ GIMT_Encode4(2385935),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29706*/ GIMT_Encode4(2385886), // Rule ID 52354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52354,
        GIR_EraseRootFromParent_Done,
      // Label 29706: @2385886
      GIM_Try, /*On fail goto*//*Label 29707*/ GIMT_Encode4(2385934), // Rule ID 52355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52355,
        GIR_EraseRootFromParent_Done,
      // Label 29707: @2385934
      GIM_Reject,
    // Label 29705: @2385935
    GIM_Reject,
    // Label 29669: @2385936
    GIM_Try, /*On fail goto*//*Label 29708*/ GIMT_Encode4(2386056),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29709*/ GIMT_Encode4(2386007), // Rule ID 52286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52286,
        GIR_EraseRootFromParent_Done,
      // Label 29709: @2386007
      GIM_Try, /*On fail goto*//*Label 29710*/ GIMT_Encode4(2386055), // Rule ID 52287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52287,
        GIR_EraseRootFromParent_Done,
      // Label 29710: @2386055
      GIM_Reject,
    // Label 29708: @2386056
    GIM_Reject,
    // Label 29670: @2386057
    GIM_Try, /*On fail goto*//*Label 29711*/ GIMT_Encode4(2386177),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29712*/ GIMT_Encode4(2386128), // Rule ID 52306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52306,
        GIR_EraseRootFromParent_Done,
      // Label 29712: @2386128
      GIM_Try, /*On fail goto*//*Label 29713*/ GIMT_Encode4(2386176), // Rule ID 52307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52307,
        GIR_EraseRootFromParent_Done,
      // Label 29713: @2386176
      GIM_Reject,
    // Label 29711: @2386177
    GIM_Reject,
    // Label 29671: @2386178
    GIM_Try, /*On fail goto*//*Label 29714*/ GIMT_Encode4(2386298),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29715*/ GIMT_Encode4(2386249), // Rule ID 52342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52342,
        GIR_EraseRootFromParent_Done,
      // Label 29715: @2386249
      GIM_Try, /*On fail goto*//*Label 29716*/ GIMT_Encode4(2386297), // Rule ID 52343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52343,
        GIR_EraseRootFromParent_Done,
      // Label 29716: @2386297
      GIM_Reject,
    // Label 29714: @2386298
    GIM_Reject,
    // Label 29672: @2386299
    GIM_Try, /*On fail goto*//*Label 29717*/ GIMT_Encode4(2386419),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29718*/ GIMT_Encode4(2386370), // Rule ID 52358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52358,
        GIR_EraseRootFromParent_Done,
      // Label 29718: @2386370
      GIM_Try, /*On fail goto*//*Label 29719*/ GIMT_Encode4(2386418), // Rule ID 52359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52359,
        GIR_EraseRootFromParent_Done,
      // Label 29719: @2386418
      GIM_Reject,
    // Label 29717: @2386419
    GIM_Reject,
    // Label 29673: @2386420
    GIM_Try, /*On fail goto*//*Label 29720*/ GIMT_Encode4(2386540),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29721*/ GIMT_Encode4(2386491), // Rule ID 52302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52302,
        GIR_EraseRootFromParent_Done,
      // Label 29721: @2386491
      GIM_Try, /*On fail goto*//*Label 29722*/ GIMT_Encode4(2386539), // Rule ID 52303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52303,
        GIR_EraseRootFromParent_Done,
      // Label 29722: @2386539
      GIM_Reject,
    // Label 29720: @2386540
    GIM_Reject,
    // Label 29674: @2386541
    GIM_Try, /*On fail goto*//*Label 29723*/ GIMT_Encode4(2386661),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29724*/ GIMT_Encode4(2386612), // Rule ID 52330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52330,
        GIR_EraseRootFromParent_Done,
      // Label 29724: @2386612
      GIM_Try, /*On fail goto*//*Label 29725*/ GIMT_Encode4(2386660), // Rule ID 52331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52331,
        GIR_EraseRootFromParent_Done,
      // Label 29725: @2386660
      GIM_Reject,
    // Label 29723: @2386661
    GIM_Reject,
    // Label 29675: @2386662
    GIM_Try, /*On fail goto*//*Label 29726*/ GIMT_Encode4(2386782),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29727*/ GIMT_Encode4(2386733), // Rule ID 52346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52346,
        GIR_EraseRootFromParent_Done,
      // Label 29727: @2386733
      GIM_Try, /*On fail goto*//*Label 29728*/ GIMT_Encode4(2386781), // Rule ID 52347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52347,
        GIR_EraseRootFromParent_Done,
      // Label 29728: @2386781
      GIM_Reject,
    // Label 29726: @2386782
    GIM_Reject,
    // Label 29676: @2386783
    GIM_Try, /*On fail goto*//*Label 29729*/ GIMT_Encode4(2386903),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29730*/ GIMT_Encode4(2386854), // Rule ID 52362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52362,
        GIR_EraseRootFromParent_Done,
      // Label 29730: @2386854
      GIM_Try, /*On fail goto*//*Label 29731*/ GIMT_Encode4(2386902), // Rule ID 52363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52363,
        GIR_EraseRootFromParent_Done,
      // Label 29731: @2386902
      GIM_Reject,
    // Label 29729: @2386903
    GIM_Reject,
    // Label 29677: @2386904
    GIM_Try, /*On fail goto*//*Label 29732*/ GIMT_Encode4(2387024),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29733*/ GIMT_Encode4(2386975), // Rule ID 52318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52318,
        GIR_EraseRootFromParent_Done,
      // Label 29733: @2386975
      GIM_Try, /*On fail goto*//*Label 29734*/ GIMT_Encode4(2387023), // Rule ID 52319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52319,
        GIR_EraseRootFromParent_Done,
      // Label 29734: @2387023
      GIM_Reject,
    // Label 29732: @2387024
    GIM_Reject,
    // Label 29678: @2387025
    GIM_Try, /*On fail goto*//*Label 29735*/ GIMT_Encode4(2387145),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29736*/ GIMT_Encode4(2387096), // Rule ID 52334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52334,
        GIR_EraseRootFromParent_Done,
      // Label 29736: @2387096
      GIM_Try, /*On fail goto*//*Label 29737*/ GIMT_Encode4(2387144), // Rule ID 52335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52335,
        GIR_EraseRootFromParent_Done,
      // Label 29737: @2387144
      GIM_Reject,
    // Label 29735: @2387145
    GIM_Reject,
    // Label 29679: @2387146
    GIM_Try, /*On fail goto*//*Label 29738*/ GIMT_Encode4(2387266),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29739*/ GIMT_Encode4(2387217), // Rule ID 52350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52350,
        GIR_EraseRootFromParent_Done,
      // Label 29739: @2387217
      GIM_Try, /*On fail goto*//*Label 29740*/ GIMT_Encode4(2387265), // Rule ID 52351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52351,
        GIR_EraseRootFromParent_Done,
      // Label 29740: @2387265
      GIM_Reject,
    // Label 29738: @2387266
    GIM_Reject,
    // Label 29680: @2387267
    GIM_Try, /*On fail goto*//*Label 29741*/ GIMT_Encode4(2387387),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29742*/ GIMT_Encode4(2387338), // Rule ID 52322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52322,
        GIR_EraseRootFromParent_Done,
      // Label 29742: @2387338
      GIM_Try, /*On fail goto*//*Label 29743*/ GIMT_Encode4(2387386), // Rule ID 52323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52323,
        GIR_EraseRootFromParent_Done,
      // Label 29743: @2387386
      GIM_Reject,
    // Label 29741: @2387387
    GIM_Reject,
    // Label 29681: @2387388
    GIM_Try, /*On fail goto*//*Label 29744*/ GIMT_Encode4(2387508),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29745*/ GIMT_Encode4(2387459), // Rule ID 52338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52338,
        GIR_EraseRootFromParent_Done,
      // Label 29745: @2387459
      GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2387507), // Rule ID 52339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52339,
        GIR_EraseRootFromParent_Done,
      // Label 29746: @2387507
      GIM_Reject,
    // Label 29744: @2387508
    GIM_Reject,
    // Label 29682: @2387509
    GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2387629),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2387580), // Rule ID 52326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52326,
        GIR_EraseRootFromParent_Done,
      // Label 29748: @2387580
      GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2387628), // Rule ID 52327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52327,
        GIR_EraseRootFromParent_Done,
      // Label 29749: @2387628
      GIM_Reject,
    // Label 29747: @2387629
    GIM_Reject,
    // Label 29683: @2387630
    GIM_Reject,
    // Label 56: @2387631
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 29772*/ GIMT_Encode4(2390416),
    /*GILLT_nxv1s8*//*Label 29750*/ GIMT_Encode4(2387754),
    /*GILLT_nxv1s16*//*Label 29751*/ GIMT_Encode4(2387875),
    /*GILLT_nxv1s32*//*Label 29752*/ GIMT_Encode4(2387996),
    /*GILLT_nxv1s64*//*Label 29753*/ GIMT_Encode4(2388117), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 29754*/ GIMT_Encode4(2388238),
    /*GILLT_nxv2s16*//*Label 29755*/ GIMT_Encode4(2388359),
    /*GILLT_nxv2s32*//*Label 29756*/ GIMT_Encode4(2388480),
    /*GILLT_nxv2s64*//*Label 29757*/ GIMT_Encode4(2388601), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 29758*/ GIMT_Encode4(2388722),
    /*GILLT_nxv4s16*//*Label 29759*/ GIMT_Encode4(2388843),
    /*GILLT_nxv4s32*//*Label 29760*/ GIMT_Encode4(2388964),
    /*GILLT_nxv4s64*//*Label 29761*/ GIMT_Encode4(2389085), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 29762*/ GIMT_Encode4(2389206),
    /*GILLT_nxv8s16*//*Label 29763*/ GIMT_Encode4(2389327),
    /*GILLT_nxv8s32*//*Label 29764*/ GIMT_Encode4(2389448),
    /*GILLT_nxv8s64*//*Label 29765*/ GIMT_Encode4(2389569), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 29766*/ GIMT_Encode4(2389690),
    /*GILLT_nxv16s16*//*Label 29767*/ GIMT_Encode4(2389811),
    /*GILLT_nxv16s32*//*Label 29768*/ GIMT_Encode4(2389932), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 29769*/ GIMT_Encode4(2390053),
    /*GILLT_nxv32s16*//*Label 29770*/ GIMT_Encode4(2390174), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 29771*/ GIMT_Encode4(2390295),
    // Label 29750: @2387754
    GIM_Try, /*On fail goto*//*Label 29773*/ GIMT_Encode4(2387874),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29774*/ GIMT_Encode4(2387825), // Rule ID 52190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52190,
        GIR_EraseRootFromParent_Done,
      // Label 29774: @2387825
      GIM_Try, /*On fail goto*//*Label 29775*/ GIMT_Encode4(2387873), // Rule ID 52191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52191,
        GIR_EraseRootFromParent_Done,
      // Label 29775: @2387873
      GIM_Reject,
    // Label 29773: @2387874
    GIM_Reject,
    // Label 29751: @2387875
    GIM_Try, /*On fail goto*//*Label 29776*/ GIMT_Encode4(2387995),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29777*/ GIMT_Encode4(2387946), // Rule ID 52202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52202,
        GIR_EraseRootFromParent_Done,
      // Label 29777: @2387946
      GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2387994), // Rule ID 52203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52203,
        GIR_EraseRootFromParent_Done,
      // Label 29778: @2387994
      GIM_Reject,
    // Label 29776: @2387995
    GIM_Reject,
    // Label 29752: @2387996
    GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2388116),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2388067), // Rule ID 52210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52210,
        GIR_EraseRootFromParent_Done,
      // Label 29780: @2388067
      GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2388115), // Rule ID 52211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52211,
        GIR_EraseRootFromParent_Done,
      // Label 29781: @2388115
      GIM_Reject,
    // Label 29779: @2388116
    GIM_Reject,
    // Label 29753: @2388117
    GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2388237),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2388188), // Rule ID 52226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52226,
        GIR_EraseRootFromParent_Done,
      // Label 29783: @2388188
      GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2388236), // Rule ID 52227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52227,
        GIR_EraseRootFromParent_Done,
      // Label 29784: @2388236
      GIM_Reject,
    // Label 29782: @2388237
    GIM_Reject,
    // Label 29754: @2388238
    GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2388358),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2388309), // Rule ID 52194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52194,
        GIR_EraseRootFromParent_Done,
      // Label 29786: @2388309
      GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2388357), // Rule ID 52195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52195,
        GIR_EraseRootFromParent_Done,
      // Label 29787: @2388357
      GIM_Reject,
    // Label 29785: @2388358
    GIM_Reject,
    // Label 29755: @2388359
    GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2388479),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2388430), // Rule ID 52206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52206,
        GIR_EraseRootFromParent_Done,
      // Label 29789: @2388430
      GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2388478), // Rule ID 52207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52207,
        GIR_EraseRootFromParent_Done,
      // Label 29790: @2388478
      GIM_Reject,
    // Label 29788: @2388479
    GIM_Reject,
    // Label 29756: @2388480
    GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2388600),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2388551), // Rule ID 52222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52222,
        GIR_EraseRootFromParent_Done,
      // Label 29792: @2388551
      GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2388599), // Rule ID 52223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52223,
        GIR_EraseRootFromParent_Done,
      // Label 29793: @2388599
      GIM_Reject,
    // Label 29791: @2388600
    GIM_Reject,
    // Label 29757: @2388601
    GIM_Try, /*On fail goto*//*Label 29794*/ GIMT_Encode4(2388721),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29795*/ GIMT_Encode4(2388672), // Rule ID 52266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52266,
        GIR_EraseRootFromParent_Done,
      // Label 29795: @2388672
      GIM_Try, /*On fail goto*//*Label 29796*/ GIMT_Encode4(2388720), // Rule ID 52267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52267,
        GIR_EraseRootFromParent_Done,
      // Label 29796: @2388720
      GIM_Reject,
    // Label 29794: @2388721
    GIM_Reject,
    // Label 29758: @2388722
    GIM_Try, /*On fail goto*//*Label 29797*/ GIMT_Encode4(2388842),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29798*/ GIMT_Encode4(2388793), // Rule ID 52198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52198,
        GIR_EraseRootFromParent_Done,
      // Label 29798: @2388793
      GIM_Try, /*On fail goto*//*Label 29799*/ GIMT_Encode4(2388841), // Rule ID 52199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52199,
        GIR_EraseRootFromParent_Done,
      // Label 29799: @2388841
      GIM_Reject,
    // Label 29797: @2388842
    GIM_Reject,
    // Label 29759: @2388843
    GIM_Try, /*On fail goto*//*Label 29800*/ GIMT_Encode4(2388963),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29801*/ GIMT_Encode4(2388914), // Rule ID 52218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52218,
        GIR_EraseRootFromParent_Done,
      // Label 29801: @2388914
      GIM_Try, /*On fail goto*//*Label 29802*/ GIMT_Encode4(2388962), // Rule ID 52219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52219,
        GIR_EraseRootFromParent_Done,
      // Label 29802: @2388962
      GIM_Reject,
    // Label 29800: @2388963
    GIM_Reject,
    // Label 29760: @2388964
    GIM_Try, /*On fail goto*//*Label 29803*/ GIMT_Encode4(2389084),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29804*/ GIMT_Encode4(2389035), // Rule ID 52254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52254,
        GIR_EraseRootFromParent_Done,
      // Label 29804: @2389035
      GIM_Try, /*On fail goto*//*Label 29805*/ GIMT_Encode4(2389083), // Rule ID 52255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52255,
        GIR_EraseRootFromParent_Done,
      // Label 29805: @2389083
      GIM_Reject,
    // Label 29803: @2389084
    GIM_Reject,
    // Label 29761: @2389085
    GIM_Try, /*On fail goto*//*Label 29806*/ GIMT_Encode4(2389205),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29807*/ GIMT_Encode4(2389156), // Rule ID 52270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52270,
        GIR_EraseRootFromParent_Done,
      // Label 29807: @2389156
      GIM_Try, /*On fail goto*//*Label 29808*/ GIMT_Encode4(2389204), // Rule ID 52271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52271,
        GIR_EraseRootFromParent_Done,
      // Label 29808: @2389204
      GIM_Reject,
    // Label 29806: @2389205
    GIM_Reject,
    // Label 29762: @2389206
    GIM_Try, /*On fail goto*//*Label 29809*/ GIMT_Encode4(2389326),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29810*/ GIMT_Encode4(2389277), // Rule ID 52214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52214,
        GIR_EraseRootFromParent_Done,
      // Label 29810: @2389277
      GIM_Try, /*On fail goto*//*Label 29811*/ GIMT_Encode4(2389325), // Rule ID 52215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52215,
        GIR_EraseRootFromParent_Done,
      // Label 29811: @2389325
      GIM_Reject,
    // Label 29809: @2389326
    GIM_Reject,
    // Label 29763: @2389327
    GIM_Try, /*On fail goto*//*Label 29812*/ GIMT_Encode4(2389447),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29813*/ GIMT_Encode4(2389398), // Rule ID 52242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52242,
        GIR_EraseRootFromParent_Done,
      // Label 29813: @2389398
      GIM_Try, /*On fail goto*//*Label 29814*/ GIMT_Encode4(2389446), // Rule ID 52243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52243,
        GIR_EraseRootFromParent_Done,
      // Label 29814: @2389446
      GIM_Reject,
    // Label 29812: @2389447
    GIM_Reject,
    // Label 29764: @2389448
    GIM_Try, /*On fail goto*//*Label 29815*/ GIMT_Encode4(2389568),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29816*/ GIMT_Encode4(2389519), // Rule ID 52258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52258,
        GIR_EraseRootFromParent_Done,
      // Label 29816: @2389519
      GIM_Try, /*On fail goto*//*Label 29817*/ GIMT_Encode4(2389567), // Rule ID 52259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52259,
        GIR_EraseRootFromParent_Done,
      // Label 29817: @2389567
      GIM_Reject,
    // Label 29815: @2389568
    GIM_Reject,
    // Label 29765: @2389569
    GIM_Try, /*On fail goto*//*Label 29818*/ GIMT_Encode4(2389689),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29819*/ GIMT_Encode4(2389640), // Rule ID 52274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52274,
        GIR_EraseRootFromParent_Done,
      // Label 29819: @2389640
      GIM_Try, /*On fail goto*//*Label 29820*/ GIMT_Encode4(2389688), // Rule ID 52275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52275,
        GIR_EraseRootFromParent_Done,
      // Label 29820: @2389688
      GIM_Reject,
    // Label 29818: @2389689
    GIM_Reject,
    // Label 29766: @2389690
    GIM_Try, /*On fail goto*//*Label 29821*/ GIMT_Encode4(2389810),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29822*/ GIMT_Encode4(2389761), // Rule ID 52230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52230,
        GIR_EraseRootFromParent_Done,
      // Label 29822: @2389761
      GIM_Try, /*On fail goto*//*Label 29823*/ GIMT_Encode4(2389809), // Rule ID 52231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52231,
        GIR_EraseRootFromParent_Done,
      // Label 29823: @2389809
      GIM_Reject,
    // Label 29821: @2389810
    GIM_Reject,
    // Label 29767: @2389811
    GIM_Try, /*On fail goto*//*Label 29824*/ GIMT_Encode4(2389931),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29825*/ GIMT_Encode4(2389882), // Rule ID 52246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52246,
        GIR_EraseRootFromParent_Done,
      // Label 29825: @2389882
      GIM_Try, /*On fail goto*//*Label 29826*/ GIMT_Encode4(2389930), // Rule ID 52247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52247,
        GIR_EraseRootFromParent_Done,
      // Label 29826: @2389930
      GIM_Reject,
    // Label 29824: @2389931
    GIM_Reject,
    // Label 29768: @2389932
    GIM_Try, /*On fail goto*//*Label 29827*/ GIMT_Encode4(2390052),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29828*/ GIMT_Encode4(2390003), // Rule ID 52262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52262,
        GIR_EraseRootFromParent_Done,
      // Label 29828: @2390003
      GIM_Try, /*On fail goto*//*Label 29829*/ GIMT_Encode4(2390051), // Rule ID 52263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52263,
        GIR_EraseRootFromParent_Done,
      // Label 29829: @2390051
      GIM_Reject,
    // Label 29827: @2390052
    GIM_Reject,
    // Label 29769: @2390053
    GIM_Try, /*On fail goto*//*Label 29830*/ GIMT_Encode4(2390173),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29831*/ GIMT_Encode4(2390124), // Rule ID 52234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52234,
        GIR_EraseRootFromParent_Done,
      // Label 29831: @2390124
      GIM_Try, /*On fail goto*//*Label 29832*/ GIMT_Encode4(2390172), // Rule ID 52235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52235,
        GIR_EraseRootFromParent_Done,
      // Label 29832: @2390172
      GIM_Reject,
    // Label 29830: @2390173
    GIM_Reject,
    // Label 29770: @2390174
    GIM_Try, /*On fail goto*//*Label 29833*/ GIMT_Encode4(2390294),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29834*/ GIMT_Encode4(2390245), // Rule ID 52250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52250,
        GIR_EraseRootFromParent_Done,
      // Label 29834: @2390245
      GIM_Try, /*On fail goto*//*Label 29835*/ GIMT_Encode4(2390293), // Rule ID 52251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52251,
        GIR_EraseRootFromParent_Done,
      // Label 29835: @2390293
      GIM_Reject,
    // Label 29833: @2390294
    GIM_Reject,
    // Label 29771: @2390295
    GIM_Try, /*On fail goto*//*Label 29836*/ GIMT_Encode4(2390415),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29837*/ GIMT_Encode4(2390366), // Rule ID 52238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52238,
        GIR_EraseRootFromParent_Done,
      // Label 29837: @2390366
      GIM_Try, /*On fail goto*//*Label 29838*/ GIMT_Encode4(2390414), // Rule ID 52239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52239,
        GIR_EraseRootFromParent_Done,
      // Label 29838: @2390414
      GIM_Reject,
    // Label 29836: @2390415
    GIM_Reject,
    // Label 29772: @2390416
    GIM_Reject,
    // Label 57: @2390417
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 29857*/ GIMT_Encode4(2392844),
    /*GILLT_s16*//*Label 29839*/ GIMT_Encode4(2390548),
    /*GILLT_s32*//*Label 29840*/ GIMT_Encode4(2390697),
    /*GILLT_s64*//*Label 29841*/ GIMT_Encode4(2390846), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 29842*/ GIMT_Encode4(2391029),
    /*GILLT_nxv1s32*//*Label 29843*/ GIMT_Encode4(2391150),
    /*GILLT_nxv1s64*//*Label 29844*/ GIMT_Encode4(2391271), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 29845*/ GIMT_Encode4(2391392),
    /*GILLT_nxv2s32*//*Label 29846*/ GIMT_Encode4(2391513),
    /*GILLT_nxv2s64*//*Label 29847*/ GIMT_Encode4(2391634), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 29848*/ GIMT_Encode4(2391755),
    /*GILLT_nxv4s32*//*Label 29849*/ GIMT_Encode4(2391876),
    /*GILLT_nxv4s64*//*Label 29850*/ GIMT_Encode4(2391997), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 29851*/ GIMT_Encode4(2392118),
    /*GILLT_nxv8s32*//*Label 29852*/ GIMT_Encode4(2392239),
    /*GILLT_nxv8s64*//*Label 29853*/ GIMT_Encode4(2392360), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 29854*/ GIMT_Encode4(2392481),
    /*GILLT_nxv16s32*//*Label 29855*/ GIMT_Encode4(2392602), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 29856*/ GIMT_Encode4(2392723),
    // Label 29839: @2390548
    GIM_Try, /*On fail goto*//*Label 29858*/ GIMT_Encode4(2390696),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 29859*/ GIMT_Encode4(2390593), // Rule ID 1816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1816,
        GIR_EraseRootFromParent_Done,
      // Label 29859: @2390593
      GIM_Try, /*On fail goto*//*Label 29860*/ GIMT_Encode4(2390627), // Rule ID 1817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1817,
        GIR_EraseRootFromParent_Done,
      // Label 29860: @2390627
      GIM_Try, /*On fail goto*//*Label 29861*/ GIMT_Encode4(2390661), // Rule ID 1820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1820,
        GIR_EraseRootFromParent_Done,
      // Label 29861: @2390661
      GIM_Try, /*On fail goto*//*Label 29862*/ GIMT_Encode4(2390695), // Rule ID 1821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1821,
        GIR_EraseRootFromParent_Done,
      // Label 29862: @2390695
      GIM_Reject,
    // Label 29858: @2390696
    GIM_Reject,
    // Label 29840: @2390697
    GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2390845),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2390742), // Rule ID 1107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1107,
        GIR_EraseRootFromParent_Done,
      // Label 29864: @2390742
      GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2390776), // Rule ID 1108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1108,
        GIR_EraseRootFromParent_Done,
      // Label 29865: @2390776
      GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2390810), // Rule ID 1111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1111,
        GIR_EraseRootFromParent_Done,
      // Label 29866: @2390810
      GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2390844), // Rule ID 1112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1112,
        GIR_EraseRootFromParent_Done,
      // Label 29867: @2390844
      GIM_Reject,
    // Label 29863: @2390845
    GIM_Reject,
    // Label 29841: @2390846
    GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2391028),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2390891), // Rule ID 1442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1442,
        GIR_EraseRootFromParent_Done,
      // Label 29869: @2390891
      GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2390925), // Rule ID 1443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1443,
        GIR_EraseRootFromParent_Done,
      // Label 29870: @2390925
      GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2390959), // Rule ID 1446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1446,
        GIR_EraseRootFromParent_Done,
      // Label 29871: @2390959
      GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2390993), // Rule ID 1447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1447,
        GIR_EraseRootFromParent_Done,
      // Label 29872: @2390993
      GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2391027), // Rule ID 1449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1449,
        GIR_EraseRootFromParent_Done,
      // Label 29873: @2391027
      GIM_Reject,
    // Label 29868: @2391028
    GIM_Reject,
    // Label 29842: @2391029
    GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2391149),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2391100), // Rule ID 45542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45542,
        GIR_EraseRootFromParent_Done,
      // Label 29875: @2391100
      GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2391148), // Rule ID 45543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45543,
        GIR_EraseRootFromParent_Done,
      // Label 29876: @2391148
      GIM_Reject,
    // Label 29874: @2391149
    GIM_Reject,
    // Label 29843: @2391150
    GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2391270),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2391221), // Rule ID 52854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52854,
        GIR_EraseRootFromParent_Done,
      // Label 29878: @2391221
      GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2391269), // Rule ID 52855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52855,
        GIR_EraseRootFromParent_Done,
      // Label 29879: @2391269
      GIM_Reject,
    // Label 29877: @2391270
    GIM_Reject,
    // Label 29844: @2391271
    GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2391391),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2391342), // Rule ID 52890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52890,
        GIR_EraseRootFromParent_Done,
      // Label 29881: @2391342
      GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2391390), // Rule ID 52891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52891,
        GIR_EraseRootFromParent_Done,
      // Label 29882: @2391390
      GIM_Reject,
    // Label 29880: @2391391
    GIM_Reject,
    // Label 29845: @2391392
    GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2391512),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2391463), // Rule ID 52842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52842,
        GIR_EraseRootFromParent_Done,
      // Label 29884: @2391463
      GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2391511), // Rule ID 52843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52843,
        GIR_EraseRootFromParent_Done,
      // Label 29885: @2391511
      GIM_Reject,
    // Label 29883: @2391512
    GIM_Reject,
    // Label 29846: @2391513
    GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2391633),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2391584), // Rule ID 52878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52878,
        GIR_EraseRootFromParent_Done,
      // Label 29887: @2391584
      GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2391632), // Rule ID 52879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52879,
        GIR_EraseRootFromParent_Done,
      // Label 29888: @2391632
      GIM_Reject,
    // Label 29886: @2391633
    GIM_Reject,
    // Label 29847: @2391634
    GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2391754),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2391705), // Rule ID 52974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52974,
        GIR_EraseRootFromParent_Done,
      // Label 29890: @2391705
      GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2391753), // Rule ID 52975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52975,
        GIR_EraseRootFromParent_Done,
      // Label 29891: @2391753
      GIM_Reject,
    // Label 29889: @2391754
    GIM_Reject,
    // Label 29848: @2391755
    GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2391875),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29893*/ GIMT_Encode4(2391826), // Rule ID 52866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52866,
        GIR_EraseRootFromParent_Done,
      // Label 29893: @2391826
      GIM_Try, /*On fail goto*//*Label 29894*/ GIMT_Encode4(2391874), // Rule ID 52867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52867,
        GIR_EraseRootFromParent_Done,
      // Label 29894: @2391874
      GIM_Reject,
    // Label 29892: @2391875
    GIM_Reject,
    // Label 29849: @2391876
    GIM_Try, /*On fail goto*//*Label 29895*/ GIMT_Encode4(2391996),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29896*/ GIMT_Encode4(2391947), // Rule ID 52938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52938,
        GIR_EraseRootFromParent_Done,
      // Label 29896: @2391947
      GIM_Try, /*On fail goto*//*Label 29897*/ GIMT_Encode4(2391995), // Rule ID 52939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52939,
        GIR_EraseRootFromParent_Done,
      // Label 29897: @2391995
      GIM_Reject,
    // Label 29895: @2391996
    GIM_Reject,
    // Label 29850: @2391997
    GIM_Try, /*On fail goto*//*Label 29898*/ GIMT_Encode4(2392117),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29899*/ GIMT_Encode4(2392068), // Rule ID 52986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52986,
        GIR_EraseRootFromParent_Done,
      // Label 29899: @2392068
      GIM_Try, /*On fail goto*//*Label 29900*/ GIMT_Encode4(2392116), // Rule ID 52987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52987,
        GIR_EraseRootFromParent_Done,
      // Label 29900: @2392116
      GIM_Reject,
    // Label 29898: @2392117
    GIM_Reject,
    // Label 29851: @2392118
    GIM_Try, /*On fail goto*//*Label 29901*/ GIMT_Encode4(2392238),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29902*/ GIMT_Encode4(2392189), // Rule ID 52902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52902,
        GIR_EraseRootFromParent_Done,
      // Label 29902: @2392189
      GIM_Try, /*On fail goto*//*Label 29903*/ GIMT_Encode4(2392237), // Rule ID 52903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52903,
        GIR_EraseRootFromParent_Done,
      // Label 29903: @2392237
      GIM_Reject,
    // Label 29901: @2392238
    GIM_Reject,
    // Label 29852: @2392239
    GIM_Try, /*On fail goto*//*Label 29904*/ GIMT_Encode4(2392359),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29905*/ GIMT_Encode4(2392310), // Rule ID 52950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52950,
        GIR_EraseRootFromParent_Done,
      // Label 29905: @2392310
      GIM_Try, /*On fail goto*//*Label 29906*/ GIMT_Encode4(2392358), // Rule ID 52951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52951,
        GIR_EraseRootFromParent_Done,
      // Label 29906: @2392358
      GIM_Reject,
    // Label 29904: @2392359
    GIM_Reject,
    // Label 29853: @2392360
    GIM_Try, /*On fail goto*//*Label 29907*/ GIMT_Encode4(2392480),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29908*/ GIMT_Encode4(2392431), // Rule ID 52998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52998,
        GIR_EraseRootFromParent_Done,
      // Label 29908: @2392431
      GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2392479), // Rule ID 52999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52999,
        GIR_EraseRootFromParent_Done,
      // Label 29909: @2392479
      GIM_Reject,
    // Label 29907: @2392480
    GIM_Reject,
    // Label 29854: @2392481
    GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2392601),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2392552), // Rule ID 52914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52914,
        GIR_EraseRootFromParent_Done,
      // Label 29911: @2392552
      GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2392600), // Rule ID 52915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52915,
        GIR_EraseRootFromParent_Done,
      // Label 29912: @2392600
      GIM_Reject,
    // Label 29910: @2392601
    GIM_Reject,
    // Label 29855: @2392602
    GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2392722),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2392673), // Rule ID 52962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52962,
        GIR_EraseRootFromParent_Done,
      // Label 29914: @2392673
      GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2392721), // Rule ID 52963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52963,
        GIR_EraseRootFromParent_Done,
      // Label 29915: @2392721
      GIM_Reject,
    // Label 29913: @2392722
    GIM_Reject,
    // Label 29856: @2392723
    GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2392843),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2392794), // Rule ID 52926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52926,
        GIR_EraseRootFromParent_Done,
      // Label 29917: @2392794
      GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2392842), // Rule ID 52927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52927,
        GIR_EraseRootFromParent_Done,
      // Label 29918: @2392842
      GIM_Reject,
    // Label 29916: @2392843
    GIM_Reject,
    // Label 29857: @2392844
    GIM_Reject,
    // Label 58: @2392845
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 29937*/ GIMT_Encode4(2395272),
    /*GILLT_s16*//*Label 29919*/ GIMT_Encode4(2392976),
    /*GILLT_s32*//*Label 29920*/ GIMT_Encode4(2393125),
    /*GILLT_s64*//*Label 29921*/ GIMT_Encode4(2393274), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 29922*/ GIMT_Encode4(2393457),
    /*GILLT_nxv1s32*//*Label 29923*/ GIMT_Encode4(2393578),
    /*GILLT_nxv1s64*//*Label 29924*/ GIMT_Encode4(2393699), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 29925*/ GIMT_Encode4(2393820),
    /*GILLT_nxv2s32*//*Label 29926*/ GIMT_Encode4(2393941),
    /*GILLT_nxv2s64*//*Label 29927*/ GIMT_Encode4(2394062), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 29928*/ GIMT_Encode4(2394183),
    /*GILLT_nxv4s32*//*Label 29929*/ GIMT_Encode4(2394304),
    /*GILLT_nxv4s64*//*Label 29930*/ GIMT_Encode4(2394425), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 29931*/ GIMT_Encode4(2394546),
    /*GILLT_nxv8s32*//*Label 29932*/ GIMT_Encode4(2394667),
    /*GILLT_nxv8s64*//*Label 29933*/ GIMT_Encode4(2394788), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 29934*/ GIMT_Encode4(2394909),
    /*GILLT_nxv16s32*//*Label 29935*/ GIMT_Encode4(2395030), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 29936*/ GIMT_Encode4(2395151),
    // Label 29919: @2392976
    GIM_Try, /*On fail goto*//*Label 29938*/ GIMT_Encode4(2393124),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 29939*/ GIMT_Encode4(2393021), // Rule ID 1824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1824,
        GIR_EraseRootFromParent_Done,
      // Label 29939: @2393021
      GIM_Try, /*On fail goto*//*Label 29940*/ GIMT_Encode4(2393055), // Rule ID 1825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1825,
        GIR_EraseRootFromParent_Done,
      // Label 29940: @2393055
      GIM_Try, /*On fail goto*//*Label 29941*/ GIMT_Encode4(2393089), // Rule ID 1828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1828,
        GIR_EraseRootFromParent_Done,
      // Label 29941: @2393089
      GIM_Try, /*On fail goto*//*Label 29942*/ GIMT_Encode4(2393123), // Rule ID 1829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1829,
        GIR_EraseRootFromParent_Done,
      // Label 29942: @2393123
      GIM_Reject,
    // Label 29938: @2393124
    GIM_Reject,
    // Label 29920: @2393125
    GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2393273),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2393170), // Rule ID 1115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1115,
        GIR_EraseRootFromParent_Done,
      // Label 29944: @2393170
      GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2393204), // Rule ID 1116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1116,
        GIR_EraseRootFromParent_Done,
      // Label 29945: @2393204
      GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2393238), // Rule ID 1119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1119,
        GIR_EraseRootFromParent_Done,
      // Label 29946: @2393238
      GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2393272), // Rule ID 1120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1120,
        GIR_EraseRootFromParent_Done,
      // Label 29947: @2393272
      GIM_Reject,
    // Label 29943: @2393273
    GIM_Reject,
    // Label 29921: @2393274
    GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2393456),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2393319), // Rule ID 1452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1452,
        GIR_EraseRootFromParent_Done,
      // Label 29949: @2393319
      GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2393353), // Rule ID 1453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1453,
        GIR_EraseRootFromParent_Done,
      // Label 29950: @2393353
      GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2393387), // Rule ID 1456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1456,
        GIR_EraseRootFromParent_Done,
      // Label 29951: @2393387
      GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2393421), // Rule ID 1457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1457,
        GIR_EraseRootFromParent_Done,
      // Label 29952: @2393421
      GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2393455), // Rule ID 1459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1459,
        GIR_EraseRootFromParent_Done,
      // Label 29953: @2393455
      GIM_Reject,
    // Label 29948: @2393456
    GIM_Reject,
    // Label 29922: @2393457
    GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2393577),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2393528), // Rule ID 53010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53010,
        GIR_EraseRootFromParent_Done,
      // Label 29955: @2393528
      GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2393576), // Rule ID 53011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53011,
        GIR_EraseRootFromParent_Done,
      // Label 29956: @2393576
      GIM_Reject,
    // Label 29954: @2393577
    GIM_Reject,
    // Label 29923: @2393578
    GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2393698),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2393649), // Rule ID 53034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53034,
        GIR_EraseRootFromParent_Done,
      // Label 29958: @2393649
      GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2393697), // Rule ID 53035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53035,
        GIR_EraseRootFromParent_Done,
      // Label 29959: @2393697
      GIM_Reject,
    // Label 29957: @2393698
    GIM_Reject,
    // Label 29924: @2393699
    GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2393819),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2393770), // Rule ID 53070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53070,
        GIR_EraseRootFromParent_Done,
      // Label 29961: @2393770
      GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2393818), // Rule ID 53071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53071,
        GIR_EraseRootFromParent_Done,
      // Label 29962: @2393818
      GIM_Reject,
    // Label 29960: @2393819
    GIM_Reject,
    // Label 29925: @2393820
    GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2393940),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2393891), // Rule ID 53022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53022,
        GIR_EraseRootFromParent_Done,
      // Label 29964: @2393891
      GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2393939), // Rule ID 53023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53023,
        GIR_EraseRootFromParent_Done,
      // Label 29965: @2393939
      GIM_Reject,
    // Label 29963: @2393940
    GIM_Reject,
    // Label 29926: @2393941
    GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2394061),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2394012), // Rule ID 53058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53058,
        GIR_EraseRootFromParent_Done,
      // Label 29967: @2394012
      GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2394060), // Rule ID 53059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53059,
        GIR_EraseRootFromParent_Done,
      // Label 29968: @2394060
      GIM_Reject,
    // Label 29966: @2394061
    GIM_Reject,
    // Label 29927: @2394062
    GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2394182),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2394133), // Rule ID 53154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53154,
        GIR_EraseRootFromParent_Done,
      // Label 29970: @2394133
      GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2394181), // Rule ID 53155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53155,
        GIR_EraseRootFromParent_Done,
      // Label 29971: @2394181
      GIM_Reject,
    // Label 29969: @2394182
    GIM_Reject,
    // Label 29928: @2394183
    GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2394303),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2394254), // Rule ID 53046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53046,
        GIR_EraseRootFromParent_Done,
      // Label 29973: @2394254
      GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2394302), // Rule ID 53047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53047,
        GIR_EraseRootFromParent_Done,
      // Label 29974: @2394302
      GIM_Reject,
    // Label 29972: @2394303
    GIM_Reject,
    // Label 29929: @2394304
    GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2394424),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2394375), // Rule ID 53118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53118,
        GIR_EraseRootFromParent_Done,
      // Label 29976: @2394375
      GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2394423), // Rule ID 53119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53119,
        GIR_EraseRootFromParent_Done,
      // Label 29977: @2394423
      GIM_Reject,
    // Label 29975: @2394424
    GIM_Reject,
    // Label 29930: @2394425
    GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2394545),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2394496), // Rule ID 53166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53166,
        GIR_EraseRootFromParent_Done,
      // Label 29979: @2394496
      GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2394544), // Rule ID 53167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53167,
        GIR_EraseRootFromParent_Done,
      // Label 29980: @2394544
      GIM_Reject,
    // Label 29978: @2394545
    GIM_Reject,
    // Label 29931: @2394546
    GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2394666),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2394617), // Rule ID 53082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53082,
        GIR_EraseRootFromParent_Done,
      // Label 29982: @2394617
      GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2394665), // Rule ID 53083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53083,
        GIR_EraseRootFromParent_Done,
      // Label 29983: @2394665
      GIM_Reject,
    // Label 29981: @2394666
    GIM_Reject,
    // Label 29932: @2394667
    GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2394787),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2394738), // Rule ID 53130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53130,
        GIR_EraseRootFromParent_Done,
      // Label 29985: @2394738
      GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2394786), // Rule ID 53131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53131,
        GIR_EraseRootFromParent_Done,
      // Label 29986: @2394786
      GIM_Reject,
    // Label 29984: @2394787
    GIM_Reject,
    // Label 29933: @2394788
    GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2394908),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2394859), // Rule ID 53178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53178,
        GIR_EraseRootFromParent_Done,
      // Label 29988: @2394859
      GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2394907), // Rule ID 53179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53179,
        GIR_EraseRootFromParent_Done,
      // Label 29989: @2394907
      GIM_Reject,
    // Label 29987: @2394908
    GIM_Reject,
    // Label 29934: @2394909
    GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2395029),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2394980), // Rule ID 53094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53094,
        GIR_EraseRootFromParent_Done,
      // Label 29991: @2394980
      GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2395028), // Rule ID 53095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53095,
        GIR_EraseRootFromParent_Done,
      // Label 29992: @2395028
      GIM_Reject,
    // Label 29990: @2395029
    GIM_Reject,
    // Label 29935: @2395030
    GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2395150),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2395101), // Rule ID 53142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53142,
        GIR_EraseRootFromParent_Done,
      // Label 29994: @2395101
      GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2395149), // Rule ID 53143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53143,
        GIR_EraseRootFromParent_Done,
      // Label 29995: @2395149
      GIM_Reject,
    // Label 29993: @2395150
    GIM_Reject,
    // Label 29936: @2395151
    GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2395271),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2395222), // Rule ID 53106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53106,
        GIR_EraseRootFromParent_Done,
      // Label 29997: @2395222
      GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2395270), // Rule ID 53107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53107,
        GIR_EraseRootFromParent_Done,
      // Label 29998: @2395270
      GIM_Reject,
    // Label 29996: @2395271
    GIM_Reject,
    // Label 29937: @2395272
    GIM_Reject,
    // Label 59: @2395273
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30017*/ GIMT_Encode4(2397700),
    /*GILLT_s16*//*Label 29999*/ GIMT_Encode4(2395404),
    /*GILLT_s32*//*Label 30000*/ GIMT_Encode4(2395553),
    /*GILLT_s64*//*Label 30001*/ GIMT_Encode4(2395702), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 30002*/ GIMT_Encode4(2395885),
    /*GILLT_nxv1s32*//*Label 30003*/ GIMT_Encode4(2396006),
    /*GILLT_nxv1s64*//*Label 30004*/ GIMT_Encode4(2396127), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 30005*/ GIMT_Encode4(2396248),
    /*GILLT_nxv2s32*//*Label 30006*/ GIMT_Encode4(2396369),
    /*GILLT_nxv2s64*//*Label 30007*/ GIMT_Encode4(2396490), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 30008*/ GIMT_Encode4(2396611),
    /*GILLT_nxv4s32*//*Label 30009*/ GIMT_Encode4(2396732),
    /*GILLT_nxv4s64*//*Label 30010*/ GIMT_Encode4(2396853), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 30011*/ GIMT_Encode4(2396974),
    /*GILLT_nxv8s32*//*Label 30012*/ GIMT_Encode4(2397095),
    /*GILLT_nxv8s64*//*Label 30013*/ GIMT_Encode4(2397216), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 30014*/ GIMT_Encode4(2397337),
    /*GILLT_nxv16s32*//*Label 30015*/ GIMT_Encode4(2397458), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 30016*/ GIMT_Encode4(2397579),
    // Label 29999: @2395404
    GIM_Try, /*On fail goto*//*Label 30018*/ GIMT_Encode4(2395552),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 30019*/ GIMT_Encode4(2395449), // Rule ID 1832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1832,
        GIR_EraseRootFromParent_Done,
      // Label 30019: @2395449
      GIM_Try, /*On fail goto*//*Label 30020*/ GIMT_Encode4(2395483), // Rule ID 1833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1833,
        GIR_EraseRootFromParent_Done,
      // Label 30020: @2395483
      GIM_Try, /*On fail goto*//*Label 30021*/ GIMT_Encode4(2395517), // Rule ID 1836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1836,
        GIR_EraseRootFromParent_Done,
      // Label 30021: @2395517
      GIM_Try, /*On fail goto*//*Label 30022*/ GIMT_Encode4(2395551), // Rule ID 1837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1837,
        GIR_EraseRootFromParent_Done,
      // Label 30022: @2395551
      GIM_Reject,
    // Label 30018: @2395552
    GIM_Reject,
    // Label 30000: @2395553
    GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2395701),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2395598), // Rule ID 1123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1123,
        GIR_EraseRootFromParent_Done,
      // Label 30024: @2395598
      GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2395632), // Rule ID 1124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1124,
        GIR_EraseRootFromParent_Done,
      // Label 30025: @2395632
      GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2395666), // Rule ID 1127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1127,
        GIR_EraseRootFromParent_Done,
      // Label 30026: @2395666
      GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2395700), // Rule ID 1128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1128,
        GIR_EraseRootFromParent_Done,
      // Label 30027: @2395700
      GIM_Reject,
    // Label 30023: @2395701
    GIM_Reject,
    // Label 30001: @2395702
    GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2395884),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2395747), // Rule ID 1462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1462,
        GIR_EraseRootFromParent_Done,
      // Label 30029: @2395747
      GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2395781), // Rule ID 1463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1463,
        GIR_EraseRootFromParent_Done,
      // Label 30030: @2395781
      GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2395815), // Rule ID 1466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1466,
        GIR_EraseRootFromParent_Done,
      // Label 30031: @2395815
      GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2395849), // Rule ID 1467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1467,
        GIR_EraseRootFromParent_Done,
      // Label 30032: @2395849
      GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2395883), // Rule ID 1469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1469,
        GIR_EraseRootFromParent_Done,
      // Label 30033: @2395883
      GIM_Reject,
    // Label 30028: @2395884
    GIM_Reject,
    // Label 30002: @2395885
    GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2396005),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2395956), // Rule ID 53778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53778,
        GIR_EraseRootFromParent_Done,
      // Label 30035: @2395956
      GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2396004), // Rule ID 53779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53779,
        GIR_EraseRootFromParent_Done,
      // Label 30036: @2396004
      GIM_Reject,
    // Label 30034: @2396005
    GIM_Reject,
    // Label 30003: @2396006
    GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2396126),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2396077), // Rule ID 53802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53802,
        GIR_EraseRootFromParent_Done,
      // Label 30038: @2396077
      GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2396125), // Rule ID 53803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53803,
        GIR_EraseRootFromParent_Done,
      // Label 30039: @2396125
      GIM_Reject,
    // Label 30037: @2396126
    GIM_Reject,
    // Label 30004: @2396127
    GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2396247),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2396198), // Rule ID 53838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53838,
        GIR_EraseRootFromParent_Done,
      // Label 30041: @2396198
      GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2396246), // Rule ID 53839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53839,
        GIR_EraseRootFromParent_Done,
      // Label 30042: @2396246
      GIM_Reject,
    // Label 30040: @2396247
    GIM_Reject,
    // Label 30005: @2396248
    GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2396368),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2396319), // Rule ID 53790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53790,
        GIR_EraseRootFromParent_Done,
      // Label 30044: @2396319
      GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2396367), // Rule ID 53791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53791,
        GIR_EraseRootFromParent_Done,
      // Label 30045: @2396367
      GIM_Reject,
    // Label 30043: @2396368
    GIM_Reject,
    // Label 30006: @2396369
    GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2396489),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2396440), // Rule ID 53826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53826,
        GIR_EraseRootFromParent_Done,
      // Label 30047: @2396440
      GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2396488), // Rule ID 53827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53827,
        GIR_EraseRootFromParent_Done,
      // Label 30048: @2396488
      GIM_Reject,
    // Label 30046: @2396489
    GIM_Reject,
    // Label 30007: @2396490
    GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2396610),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2396561), // Rule ID 53922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53922,
        GIR_EraseRootFromParent_Done,
      // Label 30050: @2396561
      GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2396609), // Rule ID 53923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53923,
        GIR_EraseRootFromParent_Done,
      // Label 30051: @2396609
      GIM_Reject,
    // Label 30049: @2396610
    GIM_Reject,
    // Label 30008: @2396611
    GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2396731),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2396682), // Rule ID 53814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53814,
        GIR_EraseRootFromParent_Done,
      // Label 30053: @2396682
      GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2396730), // Rule ID 53815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53815,
        GIR_EraseRootFromParent_Done,
      // Label 30054: @2396730
      GIM_Reject,
    // Label 30052: @2396731
    GIM_Reject,
    // Label 30009: @2396732
    GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2396852),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2396803), // Rule ID 53886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53886,
        GIR_EraseRootFromParent_Done,
      // Label 30056: @2396803
      GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2396851), // Rule ID 53887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53887,
        GIR_EraseRootFromParent_Done,
      // Label 30057: @2396851
      GIM_Reject,
    // Label 30055: @2396852
    GIM_Reject,
    // Label 30010: @2396853
    GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2396973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2396924), // Rule ID 53934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53934,
        GIR_EraseRootFromParent_Done,
      // Label 30059: @2396924
      GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2396972), // Rule ID 53935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53935,
        GIR_EraseRootFromParent_Done,
      // Label 30060: @2396972
      GIM_Reject,
    // Label 30058: @2396973
    GIM_Reject,
    // Label 30011: @2396974
    GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2397094),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2397045), // Rule ID 53850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53850,
        GIR_EraseRootFromParent_Done,
      // Label 30062: @2397045
      GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2397093), // Rule ID 53851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53851,
        GIR_EraseRootFromParent_Done,
      // Label 30063: @2397093
      GIM_Reject,
    // Label 30061: @2397094
    GIM_Reject,
    // Label 30012: @2397095
    GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2397215),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2397166), // Rule ID 53898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53898,
        GIR_EraseRootFromParent_Done,
      // Label 30065: @2397166
      GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2397214), // Rule ID 53899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53899,
        GIR_EraseRootFromParent_Done,
      // Label 30066: @2397214
      GIM_Reject,
    // Label 30064: @2397215
    GIM_Reject,
    // Label 30013: @2397216
    GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2397336),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2397287), // Rule ID 53946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53946,
        GIR_EraseRootFromParent_Done,
      // Label 30068: @2397287
      GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2397335), // Rule ID 53947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53947,
        GIR_EraseRootFromParent_Done,
      // Label 30069: @2397335
      GIM_Reject,
    // Label 30067: @2397336
    GIM_Reject,
    // Label 30014: @2397337
    GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2397457),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2397408), // Rule ID 53862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53862,
        GIR_EraseRootFromParent_Done,
      // Label 30071: @2397408
      GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2397456), // Rule ID 53863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53863,
        GIR_EraseRootFromParent_Done,
      // Label 30072: @2397456
      GIM_Reject,
    // Label 30070: @2397457
    GIM_Reject,
    // Label 30015: @2397458
    GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2397578),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2397529), // Rule ID 53910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53910,
        GIR_EraseRootFromParent_Done,
      // Label 30074: @2397529
      GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2397577), // Rule ID 53911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53911,
        GIR_EraseRootFromParent_Done,
      // Label 30075: @2397577
      GIM_Reject,
    // Label 30073: @2397578
    GIM_Reject,
    // Label 30016: @2397579
    GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2397699),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2397650), // Rule ID 53874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53874,
        GIR_EraseRootFromParent_Done,
      // Label 30077: @2397650
      GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2397698), // Rule ID 53875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53875,
        GIR_EraseRootFromParent_Done,
      // Label 30078: @2397698
      GIM_Reject,
    // Label 30076: @2397699
    GIM_Reject,
    // Label 30017: @2397700
    GIM_Reject,
    // Label 60: @2397701
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30097*/ GIMT_Encode4(2414345),
    /*GILLT_s16*//*Label 30079*/ GIMT_Encode4(2397832),
    /*GILLT_s32*//*Label 30080*/ GIMT_Encode4(2399268),
    /*GILLT_s64*//*Label 30081*/ GIMT_Encode4(2400704), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 30082*/ GIMT_Encode4(2402495),
    /*GILLT_nxv1s32*//*Label 30083*/ GIMT_Encode4(2403285),
    /*GILLT_nxv1s64*//*Label 30084*/ GIMT_Encode4(2404075), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 30085*/ GIMT_Encode4(2404865),
    /*GILLT_nxv2s32*//*Label 30086*/ GIMT_Encode4(2405655),
    /*GILLT_nxv2s64*//*Label 30087*/ GIMT_Encode4(2406445), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 30088*/ GIMT_Encode4(2407235),
    /*GILLT_nxv4s32*//*Label 30089*/ GIMT_Encode4(2408025),
    /*GILLT_nxv4s64*//*Label 30090*/ GIMT_Encode4(2408815), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 30091*/ GIMT_Encode4(2409605),
    /*GILLT_nxv8s32*//*Label 30092*/ GIMT_Encode4(2410395),
    /*GILLT_nxv8s64*//*Label 30093*/ GIMT_Encode4(2411185), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 30094*/ GIMT_Encode4(2411975),
    /*GILLT_nxv16s32*//*Label 30095*/ GIMT_Encode4(2412765), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 30096*/ GIMT_Encode4(2413555),
    // Label 30079: @2397832
    GIM_Try, /*On fail goto*//*Label 30098*/ GIMT_Encode4(2399267),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 30099*/ GIMT_Encode4(2397918), // Rule ID 1873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1873,
        GIR_EraseRootFromParent_Done,
      // Label 30099: @2397918
      GIM_Try, /*On fail goto*//*Label 30100*/ GIMT_Encode4(2397990), // Rule ID 1874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1874,
        GIR_EraseRootFromParent_Done,
      // Label 30100: @2397990
      GIM_Try, /*On fail goto*//*Label 30101*/ GIMT_Encode4(2398062), // Rule ID 1906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1906,
        GIR_EraseRootFromParent_Done,
      // Label 30101: @2398062
      GIM_Try, /*On fail goto*//*Label 30102*/ GIMT_Encode4(2398134), // Rule ID 1907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1907,
        GIR_EraseRootFromParent_Done,
      // Label 30102: @2398134
      GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2398206), // Rule ID 64141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64141,
        GIR_EraseRootFromParent_Done,
      // Label 30103: @2398206
      GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2398278), // Rule ID 64142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64142,
        GIR_EraseRootFromParent_Done,
      // Label 30104: @2398278
      GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2398350), // Rule ID 64149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64149,
        GIR_EraseRootFromParent_Done,
      // Label 30105: @2398350
      GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2398422), // Rule ID 64150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64150,
        GIR_EraseRootFromParent_Done,
      // Label 30106: @2398422
      GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2398479), // Rule ID 1869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1869,
        GIR_EraseRootFromParent_Done,
      // Label 30107: @2398479
      GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2398536), // Rule ID 1870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1870,
        GIR_EraseRootFromParent_Done,
      // Label 30108: @2398536
      GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2398593), // Rule ID 1902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1902,
        GIR_EraseRootFromParent_Done,
      // Label 30109: @2398593
      GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2398650), // Rule ID 1903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1903,
        GIR_EraseRootFromParent_Done,
      // Label 30110: @2398650
      GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2398707), // Rule ID 64137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64137,
        GIR_EraseRootFromParent_Done,
      // Label 30111: @2398707
      GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2398764), // Rule ID 64138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64138,
        GIR_EraseRootFromParent_Done,
      // Label 30112: @2398764
      GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2398821), // Rule ID 64145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64145,
        GIR_EraseRootFromParent_Done,
      // Label 30113: @2398821
      GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2398878), // Rule ID 64146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64146,
        GIR_EraseRootFromParent_Done,
      // Label 30114: @2398878
      GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2398935), // Rule ID 1865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1865,
        GIR_EraseRootFromParent_Done,
      // Label 30115: @2398935
      GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2398992), // Rule ID 1866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1866,
        GIR_EraseRootFromParent_Done,
      // Label 30116: @2398992
      GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2399049), // Rule ID 1898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1898,
        GIR_EraseRootFromParent_Done,
      // Label 30117: @2399049
      GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2399106), // Rule ID 1899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1899,
        GIR_EraseRootFromParent_Done,
      // Label 30118: @2399106
      GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2399146), // Rule ID 1861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1861,
        GIR_EraseRootFromParent_Done,
      // Label 30119: @2399146
      GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2399186), // Rule ID 1862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1862,
        GIR_EraseRootFromParent_Done,
      // Label 30120: @2399186
      GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2399226), // Rule ID 1894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1894,
        GIR_EraseRootFromParent_Done,
      // Label 30121: @2399226
      GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2399266), // Rule ID 1895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1895,
        GIR_EraseRootFromParent_Done,
      // Label 30122: @2399266
      GIM_Reject,
    // Label 30098: @2399267
    GIM_Reject,
    // Label 30080: @2399268
    GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2400703),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2399354), // Rule ID 1172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1172,
        GIR_EraseRootFromParent_Done,
      // Label 30124: @2399354
      GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2399426), // Rule ID 1173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1173,
        GIR_EraseRootFromParent_Done,
      // Label 30125: @2399426
      GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2399498), // Rule ID 1193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1193,
        GIR_EraseRootFromParent_Done,
      // Label 30126: @2399498
      GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2399570), // Rule ID 1194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1194,
        GIR_EraseRootFromParent_Done,
      // Label 30127: @2399570
      GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2399642), // Rule ID 64105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64105,
        GIR_EraseRootFromParent_Done,
      // Label 30128: @2399642
      GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2399714), // Rule ID 64106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64106,
        GIR_EraseRootFromParent_Done,
      // Label 30129: @2399714
      GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2399786), // Rule ID 64113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64113,
        GIR_EraseRootFromParent_Done,
      // Label 30130: @2399786
      GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2399858), // Rule ID 64114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64114,
        GIR_EraseRootFromParent_Done,
      // Label 30131: @2399858
      GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2399915), // Rule ID 1168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1168,
        GIR_EraseRootFromParent_Done,
      // Label 30132: @2399915
      GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2399972), // Rule ID 1169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1169,
        GIR_EraseRootFromParent_Done,
      // Label 30133: @2399972
      GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2400029), // Rule ID 1189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1189,
        GIR_EraseRootFromParent_Done,
      // Label 30134: @2400029
      GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2400086), // Rule ID 1190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1190,
        GIR_EraseRootFromParent_Done,
      // Label 30135: @2400086
      GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2400143), // Rule ID 64101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64101,
        GIR_EraseRootFromParent_Done,
      // Label 30136: @2400143
      GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2400200), // Rule ID 64102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64102,
        GIR_EraseRootFromParent_Done,
      // Label 30137: @2400200
      GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2400257), // Rule ID 64109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64109,
        GIR_EraseRootFromParent_Done,
      // Label 30138: @2400257
      GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2400314), // Rule ID 64110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64110,
        GIR_EraseRootFromParent_Done,
      // Label 30139: @2400314
      GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2400371), // Rule ID 1164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1164,
        GIR_EraseRootFromParent_Done,
      // Label 30140: @2400371
      GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2400428), // Rule ID 1165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1165,
        GIR_EraseRootFromParent_Done,
      // Label 30141: @2400428
      GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2400485), // Rule ID 1185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1185,
        GIR_EraseRootFromParent_Done,
      // Label 30142: @2400485
      GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2400542), // Rule ID 1186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1186,
        GIR_EraseRootFromParent_Done,
      // Label 30143: @2400542
      GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2400582), // Rule ID 1160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1160,
        GIR_EraseRootFromParent_Done,
      // Label 30144: @2400582
      GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2400622), // Rule ID 1161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1161,
        GIR_EraseRootFromParent_Done,
      // Label 30145: @2400622
      GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2400662), // Rule ID 1181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1181,
        GIR_EraseRootFromParent_Done,
      // Label 30146: @2400662
      GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2400702), // Rule ID 1182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1182,
        GIR_EraseRootFromParent_Done,
      // Label 30147: @2400702
      GIM_Reject,
    // Label 30123: @2400703
    GIM_Reject,
    // Label 30081: @2400704
    GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2402494),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2400790), // Rule ID 1509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1509,
        GIR_EraseRootFromParent_Done,
      // Label 30149: @2400790
      GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2400862), // Rule ID 1510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1510,
        GIR_EraseRootFromParent_Done,
      // Label 30150: @2400862
      GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2400934), // Rule ID 1532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1532,
        GIR_EraseRootFromParent_Done,
      // Label 30151: @2400934
      GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2401006), // Rule ID 1564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1564,
        GIR_EraseRootFromParent_Done,
      // Label 30152: @2401006
      GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2401078), // Rule ID 1565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1565,
        GIR_EraseRootFromParent_Done,
      // Label 30153: @2401078
      GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2401150), // Rule ID 64121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64121,
        GIR_EraseRootFromParent_Done,
      // Label 30154: @2401150
      GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2401222), // Rule ID 64122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64122,
        GIR_EraseRootFromParent_Done,
      // Label 30155: @2401222
      GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2401294), // Rule ID 64126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64126,
        GIR_EraseRootFromParent_Done,
      // Label 30156: @2401294
      GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2401366), // Rule ID 64133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64133,
        GIR_EraseRootFromParent_Done,
      // Label 30157: @2401366
      GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2401438), // Rule ID 64134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64134,
        GIR_EraseRootFromParent_Done,
      // Label 30158: @2401438
      GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2401495), // Rule ID 1505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1505,
        GIR_EraseRootFromParent_Done,
      // Label 30159: @2401495
      GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2401552), // Rule ID 1506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1506,
        GIR_EraseRootFromParent_Done,
      // Label 30160: @2401552
      GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2401609), // Rule ID 1530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1530,
        GIR_EraseRootFromParent_Done,
      // Label 30161: @2401609
      GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2401666), // Rule ID 1560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1560,
        GIR_EraseRootFromParent_Done,
      // Label 30162: @2401666
      GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2401723), // Rule ID 1561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1561,
        GIR_EraseRootFromParent_Done,
      // Label 30163: @2401723
      GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2401780), // Rule ID 64117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64117,
        GIR_EraseRootFromParent_Done,
      // Label 30164: @2401780
      GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2401837), // Rule ID 64118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64118,
        GIR_EraseRootFromParent_Done,
      // Label 30165: @2401837
      GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2401894), // Rule ID 64124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64124,
        GIR_EraseRootFromParent_Done,
      // Label 30166: @2401894
      GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2401951), // Rule ID 64129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64129,
        GIR_EraseRootFromParent_Done,
      // Label 30167: @2401951
      GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2402008), // Rule ID 64130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64130,
        GIR_EraseRootFromParent_Done,
      // Label 30168: @2402008
      GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2402065), // Rule ID 1501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1501,
        GIR_EraseRootFromParent_Done,
      // Label 30169: @2402065
      GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2402122), // Rule ID 1502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1502,
        GIR_EraseRootFromParent_Done,
      // Label 30170: @2402122
      GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2402179), // Rule ID 1528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1528,
        GIR_EraseRootFromParent_Done,
      // Label 30171: @2402179
      GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2402236), // Rule ID 1556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1556,
        GIR_EraseRootFromParent_Done,
      // Label 30172: @2402236
      GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2402293), // Rule ID 1557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1557,
        GIR_EraseRootFromParent_Done,
      // Label 30173: @2402293
      GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2402333), // Rule ID 1497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1497,
        GIR_EraseRootFromParent_Done,
      // Label 30174: @2402333
      GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2402373), // Rule ID 1498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1498,
        GIR_EraseRootFromParent_Done,
      // Label 30175: @2402373
      GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2402413), // Rule ID 1526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1526,
        GIR_EraseRootFromParent_Done,
      // Label 30176: @2402413
      GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2402453), // Rule ID 1552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1552,
        GIR_EraseRootFromParent_Done,
      // Label 30177: @2402453
      GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2402493), // Rule ID 1553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1553,
        GIR_EraseRootFromParent_Done,
      // Label 30178: @2402493
      GIM_Reject,
    // Label 30148: @2402494
    GIM_Reject,
    // Label 30082: @2402495
    GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2403284),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2402590), // Rule ID 54392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54392,
        GIR_EraseRootFromParent_Done,
      // Label 30180: @2402590
      GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2402667), // Rule ID 54393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54393,
        GIR_EraseRootFromParent_Done,
      // Label 30181: @2402667
      GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2402744), // Rule ID 70945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70945,
        GIR_EraseRootFromParent_Done,
      // Label 30182: @2402744
      GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2402821), // Rule ID 70946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70946,
        GIR_EraseRootFromParent_Done,
      // Label 30183: @2402821
      GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2402883), // Rule ID 54396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54396,
        GIR_EraseRootFromParent_Done,
      // Label 30184: @2402883
      GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2402945), // Rule ID 54397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54397,
        GIR_EraseRootFromParent_Done,
      // Label 30185: @2402945
      GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2403007), // Rule ID 70949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70949,
        GIR_EraseRootFromParent_Done,
      // Label 30186: @2403007
      GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2403069), // Rule ID 70950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70950,
        GIR_EraseRootFromParent_Done,
      // Label 30187: @2403069
      GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2403131), // Rule ID 54388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54388,
        GIR_EraseRootFromParent_Done,
      // Label 30188: @2403131
      GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2403193), // Rule ID 54389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54389,
        GIR_EraseRootFromParent_Done,
      // Label 30189: @2403193
      GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2403238), // Rule ID 54384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54384,
        GIR_EraseRootFromParent_Done,
      // Label 30190: @2403238
      GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2403283), // Rule ID 54385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54385,
        GIR_EraseRootFromParent_Done,
      // Label 30191: @2403283
      GIM_Reject,
    // Label 30179: @2403284
    GIM_Reject,
    // Label 30083: @2403285
    GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2404074),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2403380), // Rule ID 54520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54520,
        GIR_EraseRootFromParent_Done,
      // Label 30193: @2403380
      GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2403457), // Rule ID 54521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54521,
        GIR_EraseRootFromParent_Done,
      // Label 30194: @2403457
      GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2403534), // Rule ID 71057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71057,
        GIR_EraseRootFromParent_Done,
      // Label 30195: @2403534
      GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2403611), // Rule ID 71058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71058,
        GIR_EraseRootFromParent_Done,
      // Label 30196: @2403611
      GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2403673), // Rule ID 54524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54524,
        GIR_EraseRootFromParent_Done,
      // Label 30197: @2403673
      GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2403735), // Rule ID 54525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54525,
        GIR_EraseRootFromParent_Done,
      // Label 30198: @2403735
      GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2403797), // Rule ID 71061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71061,
        GIR_EraseRootFromParent_Done,
      // Label 30199: @2403797
      GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2403859), // Rule ID 71062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71062,
        GIR_EraseRootFromParent_Done,
      // Label 30200: @2403859
      GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2403921), // Rule ID 54516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54516,
        GIR_EraseRootFromParent_Done,
      // Label 30201: @2403921
      GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2403983), // Rule ID 54517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54517,
        GIR_EraseRootFromParent_Done,
      // Label 30202: @2403983
      GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2404028), // Rule ID 54512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54512,
        GIR_EraseRootFromParent_Done,
      // Label 30203: @2404028
      GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2404073), // Rule ID 54513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54513,
        GIR_EraseRootFromParent_Done,
      // Label 30204: @2404073
      GIM_Reject,
    // Label 30192: @2404074
    GIM_Reject,
    // Label 30084: @2404075
    GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2404864),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2404170), // Rule ID 54712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54712,
        GIR_EraseRootFromParent_Done,
      // Label 30206: @2404170
      GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2404247), // Rule ID 54713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54713,
        GIR_EraseRootFromParent_Done,
      // Label 30207: @2404247
      GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2404324), // Rule ID 71225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71225,
        GIR_EraseRootFromParent_Done,
      // Label 30208: @2404324
      GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2404401), // Rule ID 71226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71226,
        GIR_EraseRootFromParent_Done,
      // Label 30209: @2404401
      GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2404463), // Rule ID 54716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54716,
        GIR_EraseRootFromParent_Done,
      // Label 30210: @2404463
      GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2404525), // Rule ID 54717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54717,
        GIR_EraseRootFromParent_Done,
      // Label 30211: @2404525
      GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2404587), // Rule ID 71229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71229,
        GIR_EraseRootFromParent_Done,
      // Label 30212: @2404587
      GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2404649), // Rule ID 71230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71230,
        GIR_EraseRootFromParent_Done,
      // Label 30213: @2404649
      GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2404711), // Rule ID 54708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54708,
        GIR_EraseRootFromParent_Done,
      // Label 30214: @2404711
      GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2404773), // Rule ID 54709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54709,
        GIR_EraseRootFromParent_Done,
      // Label 30215: @2404773
      GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2404818), // Rule ID 54704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54704,
        GIR_EraseRootFromParent_Done,
      // Label 30216: @2404818
      GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2404863), // Rule ID 54705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54705,
        GIR_EraseRootFromParent_Done,
      // Label 30217: @2404863
      GIM_Reject,
    // Label 30205: @2404864
    GIM_Reject,
    // Label 30085: @2404865
    GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2405654),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2404960), // Rule ID 54456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54456,
        GIR_EraseRootFromParent_Done,
      // Label 30219: @2404960
      GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2405037), // Rule ID 54457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54457,
        GIR_EraseRootFromParent_Done,
      // Label 30220: @2405037
      GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2405114), // Rule ID 71001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71001,
        GIR_EraseRootFromParent_Done,
      // Label 30221: @2405114
      GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2405191), // Rule ID 71002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71002,
        GIR_EraseRootFromParent_Done,
      // Label 30222: @2405191
      GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2405253), // Rule ID 54460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54460,
        GIR_EraseRootFromParent_Done,
      // Label 30223: @2405253
      GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2405315), // Rule ID 54461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54461,
        GIR_EraseRootFromParent_Done,
      // Label 30224: @2405315
      GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2405377), // Rule ID 71005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71005,
        GIR_EraseRootFromParent_Done,
      // Label 30225: @2405377
      GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2405439), // Rule ID 71006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71006,
        GIR_EraseRootFromParent_Done,
      // Label 30226: @2405439
      GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2405501), // Rule ID 54452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54452,
        GIR_EraseRootFromParent_Done,
      // Label 30227: @2405501
      GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2405563), // Rule ID 54453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54453,
        GIR_EraseRootFromParent_Done,
      // Label 30228: @2405563
      GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2405608), // Rule ID 54448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54448,
        GIR_EraseRootFromParent_Done,
      // Label 30229: @2405608
      GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2405653), // Rule ID 54449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54449,
        GIR_EraseRootFromParent_Done,
      // Label 30230: @2405653
      GIM_Reject,
    // Label 30218: @2405654
    GIM_Reject,
    // Label 30086: @2405655
    GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2406444),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2405750), // Rule ID 54648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54648,
        GIR_EraseRootFromParent_Done,
      // Label 30232: @2405750
      GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2405827), // Rule ID 54649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54649,
        GIR_EraseRootFromParent_Done,
      // Label 30233: @2405827
      GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2405904), // Rule ID 71169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71169,
        GIR_EraseRootFromParent_Done,
      // Label 30234: @2405904
      GIM_Try, /*On fail goto*//*Label 30235*/ GIMT_Encode4(2405981), // Rule ID 71170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71170,
        GIR_EraseRootFromParent_Done,
      // Label 30235: @2405981
      GIM_Try, /*On fail goto*//*Label 30236*/ GIMT_Encode4(2406043), // Rule ID 54652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54652,
        GIR_EraseRootFromParent_Done,
      // Label 30236: @2406043
      GIM_Try, /*On fail goto*//*Label 30237*/ GIMT_Encode4(2406105), // Rule ID 54653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54653,
        GIR_EraseRootFromParent_Done,
      // Label 30237: @2406105
      GIM_Try, /*On fail goto*//*Label 30238*/ GIMT_Encode4(2406167), // Rule ID 71173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71173,
        GIR_EraseRootFromParent_Done,
      // Label 30238: @2406167
      GIM_Try, /*On fail goto*//*Label 30239*/ GIMT_Encode4(2406229), // Rule ID 71174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71174,
        GIR_EraseRootFromParent_Done,
      // Label 30239: @2406229
      GIM_Try, /*On fail goto*//*Label 30240*/ GIMT_Encode4(2406291), // Rule ID 54644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54644,
        GIR_EraseRootFromParent_Done,
      // Label 30240: @2406291
      GIM_Try, /*On fail goto*//*Label 30241*/ GIMT_Encode4(2406353), // Rule ID 54645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54645,
        GIR_EraseRootFromParent_Done,
      // Label 30241: @2406353
      GIM_Try, /*On fail goto*//*Label 30242*/ GIMT_Encode4(2406398), // Rule ID 54640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54640,
        GIR_EraseRootFromParent_Done,
      // Label 30242: @2406398
      GIM_Try, /*On fail goto*//*Label 30243*/ GIMT_Encode4(2406443), // Rule ID 54641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54641,
        GIR_EraseRootFromParent_Done,
      // Label 30243: @2406443
      GIM_Reject,
    // Label 30231: @2406444
    GIM_Reject,
    // Label 30087: @2406445
    GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2407234),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2406540), // Rule ID 55160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55160,
        GIR_EraseRootFromParent_Done,
      // Label 30245: @2406540
      GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2406617), // Rule ID 55161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55161,
        GIR_EraseRootFromParent_Done,
      // Label 30246: @2406617
      GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2406694), // Rule ID 71617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71617,
        GIR_EraseRootFromParent_Done,
      // Label 30247: @2406694
      GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2406771), // Rule ID 71618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71618,
        GIR_EraseRootFromParent_Done,
      // Label 30248: @2406771
      GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2406833), // Rule ID 55164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55164,
        GIR_EraseRootFromParent_Done,
      // Label 30249: @2406833
      GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2406895), // Rule ID 55165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55165,
        GIR_EraseRootFromParent_Done,
      // Label 30250: @2406895
      GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2406957), // Rule ID 71621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71621,
        GIR_EraseRootFromParent_Done,
      // Label 30251: @2406957
      GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2407019), // Rule ID 71622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71622,
        GIR_EraseRootFromParent_Done,
      // Label 30252: @2407019
      GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2407081), // Rule ID 55156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55156,
        GIR_EraseRootFromParent_Done,
      // Label 30253: @2407081
      GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2407143), // Rule ID 55157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55157,
        GIR_EraseRootFromParent_Done,
      // Label 30254: @2407143
      GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2407188), // Rule ID 55152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55152,
        GIR_EraseRootFromParent_Done,
      // Label 30255: @2407188
      GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2407233), // Rule ID 55153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55153,
        GIR_EraseRootFromParent_Done,
      // Label 30256: @2407233
      GIM_Reject,
    // Label 30244: @2407234
    GIM_Reject,
    // Label 30088: @2407235
    GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2408024),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2407330), // Rule ID 54584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54584,
        GIR_EraseRootFromParent_Done,
      // Label 30258: @2407330
      GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2407407), // Rule ID 54585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54585,
        GIR_EraseRootFromParent_Done,
      // Label 30259: @2407407
      GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2407484), // Rule ID 71113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71113,
        GIR_EraseRootFromParent_Done,
      // Label 30260: @2407484
      GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2407561), // Rule ID 71114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71114,
        GIR_EraseRootFromParent_Done,
      // Label 30261: @2407561
      GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2407623), // Rule ID 54588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54588,
        GIR_EraseRootFromParent_Done,
      // Label 30262: @2407623
      GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2407685), // Rule ID 54589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54589,
        GIR_EraseRootFromParent_Done,
      // Label 30263: @2407685
      GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2407747), // Rule ID 71117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71117,
        GIR_EraseRootFromParent_Done,
      // Label 30264: @2407747
      GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2407809), // Rule ID 71118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71118,
        GIR_EraseRootFromParent_Done,
      // Label 30265: @2407809
      GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2407871), // Rule ID 54580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54580,
        GIR_EraseRootFromParent_Done,
      // Label 30266: @2407871
      GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2407933), // Rule ID 54581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54581,
        GIR_EraseRootFromParent_Done,
      // Label 30267: @2407933
      GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2407978), // Rule ID 54576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54576,
        GIR_EraseRootFromParent_Done,
      // Label 30268: @2407978
      GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2408023), // Rule ID 54577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54577,
        GIR_EraseRootFromParent_Done,
      // Label 30269: @2408023
      GIM_Reject,
    // Label 30257: @2408024
    GIM_Reject,
    // Label 30089: @2408025
    GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2408814),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2408120), // Rule ID 54968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54968,
        GIR_EraseRootFromParent_Done,
      // Label 30271: @2408120
      GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2408197), // Rule ID 54969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54969,
        GIR_EraseRootFromParent_Done,
      // Label 30272: @2408197
      GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2408274), // Rule ID 71449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71449,
        GIR_EraseRootFromParent_Done,
      // Label 30273: @2408274
      GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2408351), // Rule ID 71450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71450,
        GIR_EraseRootFromParent_Done,
      // Label 30274: @2408351
      GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2408413), // Rule ID 54972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54972,
        GIR_EraseRootFromParent_Done,
      // Label 30275: @2408413
      GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2408475), // Rule ID 54973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54973,
        GIR_EraseRootFromParent_Done,
      // Label 30276: @2408475
      GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2408537), // Rule ID 71453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71453,
        GIR_EraseRootFromParent_Done,
      // Label 30277: @2408537
      GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2408599), // Rule ID 71454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71454,
        GIR_EraseRootFromParent_Done,
      // Label 30278: @2408599
      GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2408661), // Rule ID 54964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54964,
        GIR_EraseRootFromParent_Done,
      // Label 30279: @2408661
      GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2408723), // Rule ID 54965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54965,
        GIR_EraseRootFromParent_Done,
      // Label 30280: @2408723
      GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2408768), // Rule ID 54960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54960,
        GIR_EraseRootFromParent_Done,
      // Label 30281: @2408768
      GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2408813), // Rule ID 54961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54961,
        GIR_EraseRootFromParent_Done,
      // Label 30282: @2408813
      GIM_Reject,
    // Label 30270: @2408814
    GIM_Reject,
    // Label 30090: @2408815
    GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2409604),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2408910), // Rule ID 55224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55224,
        GIR_EraseRootFromParent_Done,
      // Label 30284: @2408910
      GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2408987), // Rule ID 55225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55225,
        GIR_EraseRootFromParent_Done,
      // Label 30285: @2408987
      GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2409064), // Rule ID 71673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71673,
        GIR_EraseRootFromParent_Done,
      // Label 30286: @2409064
      GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2409141), // Rule ID 71674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71674,
        GIR_EraseRootFromParent_Done,
      // Label 30287: @2409141
      GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2409203), // Rule ID 55228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55228,
        GIR_EraseRootFromParent_Done,
      // Label 30288: @2409203
      GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2409265), // Rule ID 55229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55229,
        GIR_EraseRootFromParent_Done,
      // Label 30289: @2409265
      GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2409327), // Rule ID 71677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71677,
        GIR_EraseRootFromParent_Done,
      // Label 30290: @2409327
      GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2409389), // Rule ID 71678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71678,
        GIR_EraseRootFromParent_Done,
      // Label 30291: @2409389
      GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2409451), // Rule ID 55220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55220,
        GIR_EraseRootFromParent_Done,
      // Label 30292: @2409451
      GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2409513), // Rule ID 55221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55221,
        GIR_EraseRootFromParent_Done,
      // Label 30293: @2409513
      GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2409558), // Rule ID 55216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55216,
        GIR_EraseRootFromParent_Done,
      // Label 30294: @2409558
      GIM_Try, /*On fail goto*//*Label 30295*/ GIMT_Encode4(2409603), // Rule ID 55217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55217,
        GIR_EraseRootFromParent_Done,
      // Label 30295: @2409603
      GIM_Reject,
    // Label 30283: @2409604
    GIM_Reject,
    // Label 30091: @2409605
    GIM_Try, /*On fail goto*//*Label 30296*/ GIMT_Encode4(2410394),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30297*/ GIMT_Encode4(2409700), // Rule ID 54776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54776,
        GIR_EraseRootFromParent_Done,
      // Label 30297: @2409700
      GIM_Try, /*On fail goto*//*Label 30298*/ GIMT_Encode4(2409777), // Rule ID 54777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54777,
        GIR_EraseRootFromParent_Done,
      // Label 30298: @2409777
      GIM_Try, /*On fail goto*//*Label 30299*/ GIMT_Encode4(2409854), // Rule ID 71281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71281,
        GIR_EraseRootFromParent_Done,
      // Label 30299: @2409854
      GIM_Try, /*On fail goto*//*Label 30300*/ GIMT_Encode4(2409931), // Rule ID 71282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71282,
        GIR_EraseRootFromParent_Done,
      // Label 30300: @2409931
      GIM_Try, /*On fail goto*//*Label 30301*/ GIMT_Encode4(2409993), // Rule ID 54780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54780,
        GIR_EraseRootFromParent_Done,
      // Label 30301: @2409993
      GIM_Try, /*On fail goto*//*Label 30302*/ GIMT_Encode4(2410055), // Rule ID 54781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54781,
        GIR_EraseRootFromParent_Done,
      // Label 30302: @2410055
      GIM_Try, /*On fail goto*//*Label 30303*/ GIMT_Encode4(2410117), // Rule ID 71285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71285,
        GIR_EraseRootFromParent_Done,
      // Label 30303: @2410117
      GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2410179), // Rule ID 71286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71286,
        GIR_EraseRootFromParent_Done,
      // Label 30304: @2410179
      GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2410241), // Rule ID 54772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54772,
        GIR_EraseRootFromParent_Done,
      // Label 30305: @2410241
      GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2410303), // Rule ID 54773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54773,
        GIR_EraseRootFromParent_Done,
      // Label 30306: @2410303
      GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2410348), // Rule ID 54768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54768,
        GIR_EraseRootFromParent_Done,
      // Label 30307: @2410348
      GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2410393), // Rule ID 54769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54769,
        GIR_EraseRootFromParent_Done,
      // Label 30308: @2410393
      GIM_Reject,
    // Label 30296: @2410394
    GIM_Reject,
    // Label 30092: @2410395
    GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2411184),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2410490), // Rule ID 55032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55032,
        GIR_EraseRootFromParent_Done,
      // Label 30310: @2410490
      GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2410567), // Rule ID 55033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55033,
        GIR_EraseRootFromParent_Done,
      // Label 30311: @2410567
      GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2410644), // Rule ID 71505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71505,
        GIR_EraseRootFromParent_Done,
      // Label 30312: @2410644
      GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2410721), // Rule ID 71506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71506,
        GIR_EraseRootFromParent_Done,
      // Label 30313: @2410721
      GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2410783), // Rule ID 55036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55036,
        GIR_EraseRootFromParent_Done,
      // Label 30314: @2410783
      GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2410845), // Rule ID 55037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55037,
        GIR_EraseRootFromParent_Done,
      // Label 30315: @2410845
      GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2410907), // Rule ID 71509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71509,
        GIR_EraseRootFromParent_Done,
      // Label 30316: @2410907
      GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2410969), // Rule ID 71510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71510,
        GIR_EraseRootFromParent_Done,
      // Label 30317: @2410969
      GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2411031), // Rule ID 55028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55028,
        GIR_EraseRootFromParent_Done,
      // Label 30318: @2411031
      GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2411093), // Rule ID 55029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55029,
        GIR_EraseRootFromParent_Done,
      // Label 30319: @2411093
      GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2411138), // Rule ID 55024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55024,
        GIR_EraseRootFromParent_Done,
      // Label 30320: @2411138
      GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2411183), // Rule ID 55025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55025,
        GIR_EraseRootFromParent_Done,
      // Label 30321: @2411183
      GIM_Reject,
    // Label 30309: @2411184
    GIM_Reject,
    // Label 30093: @2411185
    GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2411974),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2411280), // Rule ID 55288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55288,
        GIR_EraseRootFromParent_Done,
      // Label 30323: @2411280
      GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2411357), // Rule ID 55289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55289,
        GIR_EraseRootFromParent_Done,
      // Label 30324: @2411357
      GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2411434), // Rule ID 71729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71729,
        GIR_EraseRootFromParent_Done,
      // Label 30325: @2411434
      GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2411511), // Rule ID 71730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71730,
        GIR_EraseRootFromParent_Done,
      // Label 30326: @2411511
      GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2411573), // Rule ID 55292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55292,
        GIR_EraseRootFromParent_Done,
      // Label 30327: @2411573
      GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2411635), // Rule ID 55293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55293,
        GIR_EraseRootFromParent_Done,
      // Label 30328: @2411635
      GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2411697), // Rule ID 71733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71733,
        GIR_EraseRootFromParent_Done,
      // Label 30329: @2411697
      GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2411759), // Rule ID 71734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71734,
        GIR_EraseRootFromParent_Done,
      // Label 30330: @2411759
      GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2411821), // Rule ID 55284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55284,
        GIR_EraseRootFromParent_Done,
      // Label 30331: @2411821
      GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2411883), // Rule ID 55285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55285,
        GIR_EraseRootFromParent_Done,
      // Label 30332: @2411883
      GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2411928), // Rule ID 55280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55280,
        GIR_EraseRootFromParent_Done,
      // Label 30333: @2411928
      GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2411973), // Rule ID 55281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55281,
        GIR_EraseRootFromParent_Done,
      // Label 30334: @2411973
      GIM_Reject,
    // Label 30322: @2411974
    GIM_Reject,
    // Label 30094: @2411975
    GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2412764),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2412070), // Rule ID 54840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54840,
        GIR_EraseRootFromParent_Done,
      // Label 30336: @2412070
      GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2412147), // Rule ID 54841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54841,
        GIR_EraseRootFromParent_Done,
      // Label 30337: @2412147
      GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2412224), // Rule ID 71337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71337,
        GIR_EraseRootFromParent_Done,
      // Label 30338: @2412224
      GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2412301), // Rule ID 71338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71338,
        GIR_EraseRootFromParent_Done,
      // Label 30339: @2412301
      GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2412363), // Rule ID 54844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54844,
        GIR_EraseRootFromParent_Done,
      // Label 30340: @2412363
      GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2412425), // Rule ID 54845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54845,
        GIR_EraseRootFromParent_Done,
      // Label 30341: @2412425
      GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2412487), // Rule ID 71341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71341,
        GIR_EraseRootFromParent_Done,
      // Label 30342: @2412487
      GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2412549), // Rule ID 71342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71342,
        GIR_EraseRootFromParent_Done,
      // Label 30343: @2412549
      GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2412611), // Rule ID 54836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54836,
        GIR_EraseRootFromParent_Done,
      // Label 30344: @2412611
      GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2412673), // Rule ID 54837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54837,
        GIR_EraseRootFromParent_Done,
      // Label 30345: @2412673
      GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2412718), // Rule ID 54832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54832,
        GIR_EraseRootFromParent_Done,
      // Label 30346: @2412718
      GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2412763), // Rule ID 54833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54833,
        GIR_EraseRootFromParent_Done,
      // Label 30347: @2412763
      GIM_Reject,
    // Label 30335: @2412764
    GIM_Reject,
    // Label 30095: @2412765
    GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2413554),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2412860), // Rule ID 55096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55096,
        GIR_EraseRootFromParent_Done,
      // Label 30349: @2412860
      GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2412937), // Rule ID 55097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55097,
        GIR_EraseRootFromParent_Done,
      // Label 30350: @2412937
      GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2413014), // Rule ID 71561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71561,
        GIR_EraseRootFromParent_Done,
      // Label 30351: @2413014
      GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2413091), // Rule ID 71562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71562,
        GIR_EraseRootFromParent_Done,
      // Label 30352: @2413091
      GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2413153), // Rule ID 55100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55100,
        GIR_EraseRootFromParent_Done,
      // Label 30353: @2413153
      GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2413215), // Rule ID 55101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55101,
        GIR_EraseRootFromParent_Done,
      // Label 30354: @2413215
      GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2413277), // Rule ID 71565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71565,
        GIR_EraseRootFromParent_Done,
      // Label 30355: @2413277
      GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2413339), // Rule ID 71566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71566,
        GIR_EraseRootFromParent_Done,
      // Label 30356: @2413339
      GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2413401), // Rule ID 55092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55092,
        GIR_EraseRootFromParent_Done,
      // Label 30357: @2413401
      GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2413463), // Rule ID 55093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55093,
        GIR_EraseRootFromParent_Done,
      // Label 30358: @2413463
      GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2413508), // Rule ID 55088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55088,
        GIR_EraseRootFromParent_Done,
      // Label 30359: @2413508
      GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2413553), // Rule ID 55089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55089,
        GIR_EraseRootFromParent_Done,
      // Label 30360: @2413553
      GIM_Reject,
    // Label 30348: @2413554
    GIM_Reject,
    // Label 30096: @2413555
    GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2414344),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2413650), // Rule ID 54904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54904,
        GIR_EraseRootFromParent_Done,
      // Label 30362: @2413650
      GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2413727), // Rule ID 54905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54905,
        GIR_EraseRootFromParent_Done,
      // Label 30363: @2413727
      GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2413804), // Rule ID 71393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71393,
        GIR_EraseRootFromParent_Done,
      // Label 30364: @2413804
      GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2413881), // Rule ID 71394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71394,
        GIR_EraseRootFromParent_Done,
      // Label 30365: @2413881
      GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2413943), // Rule ID 54908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54908,
        GIR_EraseRootFromParent_Done,
      // Label 30366: @2413943
      GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2414005), // Rule ID 54909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54909,
        GIR_EraseRootFromParent_Done,
      // Label 30367: @2414005
      GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2414067), // Rule ID 71397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71397,
        GIR_EraseRootFromParent_Done,
      // Label 30368: @2414067
      GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2414129), // Rule ID 71398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71398,
        GIR_EraseRootFromParent_Done,
      // Label 30369: @2414129
      GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2414191), // Rule ID 54900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54900,
        GIR_EraseRootFromParent_Done,
      // Label 30370: @2414191
      GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2414253), // Rule ID 54901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54901,
        GIR_EraseRootFromParent_Done,
      // Label 30371: @2414253
      GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2414298), // Rule ID 54896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54896,
        GIR_EraseRootFromParent_Done,
      // Label 30372: @2414298
      GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2414343), // Rule ID 54897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54897,
        GIR_EraseRootFromParent_Done,
      // Label 30373: @2414343
      GIM_Reject,
    // Label 30361: @2414344
    GIM_Reject,
    // Label 30097: @2414345
    GIM_Reject,
    // Label 61: @2414346
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30392*/ GIMT_Encode4(2416773),
    /*GILLT_s16*//*Label 30374*/ GIMT_Encode4(2414477),
    /*GILLT_s32*//*Label 30375*/ GIMT_Encode4(2414626),
    /*GILLT_s64*//*Label 30376*/ GIMT_Encode4(2414775), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 30377*/ GIMT_Encode4(2414958),
    /*GILLT_nxv1s32*//*Label 30378*/ GIMT_Encode4(2415079),
    /*GILLT_nxv1s64*//*Label 30379*/ GIMT_Encode4(2415200), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 30380*/ GIMT_Encode4(2415321),
    /*GILLT_nxv2s32*//*Label 30381*/ GIMT_Encode4(2415442),
    /*GILLT_nxv2s64*//*Label 30382*/ GIMT_Encode4(2415563), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 30383*/ GIMT_Encode4(2415684),
    /*GILLT_nxv4s32*//*Label 30384*/ GIMT_Encode4(2415805),
    /*GILLT_nxv4s64*//*Label 30385*/ GIMT_Encode4(2415926), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 30386*/ GIMT_Encode4(2416047),
    /*GILLT_nxv8s32*//*Label 30387*/ GIMT_Encode4(2416168),
    /*GILLT_nxv8s64*//*Label 30388*/ GIMT_Encode4(2416289), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 30389*/ GIMT_Encode4(2416410),
    /*GILLT_nxv16s32*//*Label 30390*/ GIMT_Encode4(2416531), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 30391*/ GIMT_Encode4(2416652),
    // Label 30374: @2414477
    GIM_Try, /*On fail goto*//*Label 30393*/ GIMT_Encode4(2414625),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 30394*/ GIMT_Encode4(2414522), // Rule ID 1840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1840,
        GIR_EraseRootFromParent_Done,
      // Label 30394: @2414522
      GIM_Try, /*On fail goto*//*Label 30395*/ GIMT_Encode4(2414556), // Rule ID 1841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1841,
        GIR_EraseRootFromParent_Done,
      // Label 30395: @2414556
      GIM_Try, /*On fail goto*//*Label 30396*/ GIMT_Encode4(2414590), // Rule ID 1844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1844,
        GIR_EraseRootFromParent_Done,
      // Label 30396: @2414590
      GIM_Try, /*On fail goto*//*Label 30397*/ GIMT_Encode4(2414624), // Rule ID 1845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1845,
        GIR_EraseRootFromParent_Done,
      // Label 30397: @2414624
      GIM_Reject,
    // Label 30393: @2414625
    GIM_Reject,
    // Label 30375: @2414626
    GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2414774),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2414671), // Rule ID 1131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1131,
        GIR_EraseRootFromParent_Done,
      // Label 30399: @2414671
      GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2414705), // Rule ID 1132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1132,
        GIR_EraseRootFromParent_Done,
      // Label 30400: @2414705
      GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2414739), // Rule ID 1135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1135,
        GIR_EraseRootFromParent_Done,
      // Label 30401: @2414739
      GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2414773), // Rule ID 1136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1136,
        GIR_EraseRootFromParent_Done,
      // Label 30402: @2414773
      GIM_Reject,
    // Label 30398: @2414774
    GIM_Reject,
    // Label 30376: @2414775
    GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2414957),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 30404*/ GIMT_Encode4(2414820), // Rule ID 1472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1472,
        GIR_EraseRootFromParent_Done,
      // Label 30404: @2414820
      GIM_Try, /*On fail goto*//*Label 30405*/ GIMT_Encode4(2414854), // Rule ID 1473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1473,
        GIR_EraseRootFromParent_Done,
      // Label 30405: @2414854
      GIM_Try, /*On fail goto*//*Label 30406*/ GIMT_Encode4(2414888), // Rule ID 1476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1476,
        GIR_EraseRootFromParent_Done,
      // Label 30406: @2414888
      GIM_Try, /*On fail goto*//*Label 30407*/ GIMT_Encode4(2414922), // Rule ID 1477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1477,
        GIR_EraseRootFromParent_Done,
      // Label 30407: @2414922
      GIM_Try, /*On fail goto*//*Label 30408*/ GIMT_Encode4(2414956), // Rule ID 1479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1479,
        GIR_EraseRootFromParent_Done,
      // Label 30408: @2414956
      GIM_Reject,
    // Label 30403: @2414957
    GIM_Reject,
    // Label 30377: @2414958
    GIM_Try, /*On fail goto*//*Label 30409*/ GIMT_Encode4(2415078),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30410*/ GIMT_Encode4(2415029), // Rule ID 53958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53958,
        GIR_EraseRootFromParent_Done,
      // Label 30410: @2415029
      GIM_Try, /*On fail goto*//*Label 30411*/ GIMT_Encode4(2415077), // Rule ID 53959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53959,
        GIR_EraseRootFromParent_Done,
      // Label 30411: @2415077
      GIM_Reject,
    // Label 30409: @2415078
    GIM_Reject,
    // Label 30378: @2415079
    GIM_Try, /*On fail goto*//*Label 30412*/ GIMT_Encode4(2415199),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30413*/ GIMT_Encode4(2415150), // Rule ID 53982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53982,
        GIR_EraseRootFromParent_Done,
      // Label 30413: @2415150
      GIM_Try, /*On fail goto*//*Label 30414*/ GIMT_Encode4(2415198), // Rule ID 53983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53983,
        GIR_EraseRootFromParent_Done,
      // Label 30414: @2415198
      GIM_Reject,
    // Label 30412: @2415199
    GIM_Reject,
    // Label 30379: @2415200
    GIM_Try, /*On fail goto*//*Label 30415*/ GIMT_Encode4(2415320),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30416*/ GIMT_Encode4(2415271), // Rule ID 54018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54018,
        GIR_EraseRootFromParent_Done,
      // Label 30416: @2415271
      GIM_Try, /*On fail goto*//*Label 30417*/ GIMT_Encode4(2415319), // Rule ID 54019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54019,
        GIR_EraseRootFromParent_Done,
      // Label 30417: @2415319
      GIM_Reject,
    // Label 30415: @2415320
    GIM_Reject,
    // Label 30380: @2415321
    GIM_Try, /*On fail goto*//*Label 30418*/ GIMT_Encode4(2415441),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30419*/ GIMT_Encode4(2415392), // Rule ID 53970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53970,
        GIR_EraseRootFromParent_Done,
      // Label 30419: @2415392
      GIM_Try, /*On fail goto*//*Label 30420*/ GIMT_Encode4(2415440), // Rule ID 53971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53971,
        GIR_EraseRootFromParent_Done,
      // Label 30420: @2415440
      GIM_Reject,
    // Label 30418: @2415441
    GIM_Reject,
    // Label 30381: @2415442
    GIM_Try, /*On fail goto*//*Label 30421*/ GIMT_Encode4(2415562),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30422*/ GIMT_Encode4(2415513), // Rule ID 54006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54006,
        GIR_EraseRootFromParent_Done,
      // Label 30422: @2415513
      GIM_Try, /*On fail goto*//*Label 30423*/ GIMT_Encode4(2415561), // Rule ID 54007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54007,
        GIR_EraseRootFromParent_Done,
      // Label 30423: @2415561
      GIM_Reject,
    // Label 30421: @2415562
    GIM_Reject,
    // Label 30382: @2415563
    GIM_Try, /*On fail goto*//*Label 30424*/ GIMT_Encode4(2415683),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30425*/ GIMT_Encode4(2415634), // Rule ID 54102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54102,
        GIR_EraseRootFromParent_Done,
      // Label 30425: @2415634
      GIM_Try, /*On fail goto*//*Label 30426*/ GIMT_Encode4(2415682), // Rule ID 54103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54103,
        GIR_EraseRootFromParent_Done,
      // Label 30426: @2415682
      GIM_Reject,
    // Label 30424: @2415683
    GIM_Reject,
    // Label 30383: @2415684
    GIM_Try, /*On fail goto*//*Label 30427*/ GIMT_Encode4(2415804),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30428*/ GIMT_Encode4(2415755), // Rule ID 53994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53994,
        GIR_EraseRootFromParent_Done,
      // Label 30428: @2415755
      GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2415803), // Rule ID 53995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53995,
        GIR_EraseRootFromParent_Done,
      // Label 30429: @2415803
      GIM_Reject,
    // Label 30427: @2415804
    GIM_Reject,
    // Label 30384: @2415805
    GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2415925),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2415876), // Rule ID 54066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54066,
        GIR_EraseRootFromParent_Done,
      // Label 30431: @2415876
      GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2415924), // Rule ID 54067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54067,
        GIR_EraseRootFromParent_Done,
      // Label 30432: @2415924
      GIM_Reject,
    // Label 30430: @2415925
    GIM_Reject,
    // Label 30385: @2415926
    GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2416046),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2415997), // Rule ID 54114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54114,
        GIR_EraseRootFromParent_Done,
      // Label 30434: @2415997
      GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2416045), // Rule ID 54115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54115,
        GIR_EraseRootFromParent_Done,
      // Label 30435: @2416045
      GIM_Reject,
    // Label 30433: @2416046
    GIM_Reject,
    // Label 30386: @2416047
    GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2416167),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2416118), // Rule ID 54030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54030,
        GIR_EraseRootFromParent_Done,
      // Label 30437: @2416118
      GIM_Try, /*On fail goto*//*Label 30438*/ GIMT_Encode4(2416166), // Rule ID 54031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54031,
        GIR_EraseRootFromParent_Done,
      // Label 30438: @2416166
      GIM_Reject,
    // Label 30436: @2416167
    GIM_Reject,
    // Label 30387: @2416168
    GIM_Try, /*On fail goto*//*Label 30439*/ GIMT_Encode4(2416288),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30440*/ GIMT_Encode4(2416239), // Rule ID 54078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54078,
        GIR_EraseRootFromParent_Done,
      // Label 30440: @2416239
      GIM_Try, /*On fail goto*//*Label 30441*/ GIMT_Encode4(2416287), // Rule ID 54079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54079,
        GIR_EraseRootFromParent_Done,
      // Label 30441: @2416287
      GIM_Reject,
    // Label 30439: @2416288
    GIM_Reject,
    // Label 30388: @2416289
    GIM_Try, /*On fail goto*//*Label 30442*/ GIMT_Encode4(2416409),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30443*/ GIMT_Encode4(2416360), // Rule ID 54126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54126,
        GIR_EraseRootFromParent_Done,
      // Label 30443: @2416360
      GIM_Try, /*On fail goto*//*Label 30444*/ GIMT_Encode4(2416408), // Rule ID 54127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54127,
        GIR_EraseRootFromParent_Done,
      // Label 30444: @2416408
      GIM_Reject,
    // Label 30442: @2416409
    GIM_Reject,
    // Label 30389: @2416410
    GIM_Try, /*On fail goto*//*Label 30445*/ GIMT_Encode4(2416530),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30446*/ GIMT_Encode4(2416481), // Rule ID 54042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54042,
        GIR_EraseRootFromParent_Done,
      // Label 30446: @2416481
      GIM_Try, /*On fail goto*//*Label 30447*/ GIMT_Encode4(2416529), // Rule ID 54043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54043,
        GIR_EraseRootFromParent_Done,
      // Label 30447: @2416529
      GIM_Reject,
    // Label 30445: @2416530
    GIM_Reject,
    // Label 30390: @2416531
    GIM_Try, /*On fail goto*//*Label 30448*/ GIMT_Encode4(2416651),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30449*/ GIMT_Encode4(2416602), // Rule ID 54090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54090,
        GIR_EraseRootFromParent_Done,
      // Label 30449: @2416602
      GIM_Try, /*On fail goto*//*Label 30450*/ GIMT_Encode4(2416650), // Rule ID 54091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54091,
        GIR_EraseRootFromParent_Done,
      // Label 30450: @2416650
      GIM_Reject,
    // Label 30448: @2416651
    GIM_Reject,
    // Label 30391: @2416652
    GIM_Try, /*On fail goto*//*Label 30451*/ GIMT_Encode4(2416772),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30452*/ GIMT_Encode4(2416723), // Rule ID 54054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54054,
        GIR_EraseRootFromParent_Done,
      // Label 30452: @2416723
      GIM_Try, /*On fail goto*//*Label 30453*/ GIMT_Encode4(2416771), // Rule ID 54055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54055,
        GIR_EraseRootFromParent_Done,
      // Label 30453: @2416771
      GIM_Reject,
    // Label 30451: @2416772
    GIM_Reject,
    // Label 30392: @2416773
    GIM_Reject,
    // Label 62: @2416774
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30472*/ GIMT_Encode4(2418744),
    /*GILLT_s16*//*Label 30454*/ GIMT_Encode4(2416905),
    /*GILLT_s32*//*Label 30455*/ GIMT_Encode4(2416969),
    /*GILLT_s64*//*Label 30456*/ GIMT_Encode4(2417033), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 30457*/ GIMT_Encode4(2417124),
    /*GILLT_nxv1s32*//*Label 30458*/ GIMT_Encode4(2417232),
    /*GILLT_nxv1s64*//*Label 30459*/ GIMT_Encode4(2417340), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 30460*/ GIMT_Encode4(2417448),
    /*GILLT_nxv2s32*//*Label 30461*/ GIMT_Encode4(2417556),
    /*GILLT_nxv2s64*//*Label 30462*/ GIMT_Encode4(2417664), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 30463*/ GIMT_Encode4(2417772),
    /*GILLT_nxv4s32*//*Label 30464*/ GIMT_Encode4(2417880),
    /*GILLT_nxv4s64*//*Label 30465*/ GIMT_Encode4(2417988), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 30466*/ GIMT_Encode4(2418096),
    /*GILLT_nxv8s32*//*Label 30467*/ GIMT_Encode4(2418204),
    /*GILLT_nxv8s64*//*Label 30468*/ GIMT_Encode4(2418312), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 30469*/ GIMT_Encode4(2418420),
    /*GILLT_nxv16s32*//*Label 30470*/ GIMT_Encode4(2418528), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 30471*/ GIMT_Encode4(2418636),
    // Label 30454: @2416905
    GIM_Try, /*On fail goto*//*Label 30473*/ GIMT_Encode4(2416968),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 30474*/ GIMT_Encode4(2416940), // Rule ID 1850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1850,
        GIR_EraseRootFromParent_Done,
      // Label 30474: @2416940
      GIM_Try, /*On fail goto*//*Label 30475*/ GIMT_Encode4(2416967), // Rule ID 1883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1883,
        GIR_EraseRootFromParent_Done,
      // Label 30475: @2416967
      GIM_Reject,
    // Label 30473: @2416968
    GIM_Reject,
    // Label 30455: @2416969
    GIM_Try, /*On fail goto*//*Label 30476*/ GIMT_Encode4(2417032),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 30477*/ GIMT_Encode4(2417004), // Rule ID 1141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1141,
        GIR_EraseRootFromParent_Done,
      // Label 30477: @2417004
      GIM_Try, /*On fail goto*//*Label 30478*/ GIMT_Encode4(2417031), // Rule ID 1149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1149,
        GIR_EraseRootFromParent_Done,
      // Label 30478: @2417031
      GIM_Reject,
    // Label 30476: @2417032
    GIM_Reject,
    // Label 30456: @2417033
    GIM_Try, /*On fail goto*//*Label 30479*/ GIMT_Encode4(2417123),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 30480*/ GIMT_Encode4(2417068), // Rule ID 1484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1484,
        GIR_EraseRootFromParent_Done,
      // Label 30480: @2417068
      GIM_Try, /*On fail goto*//*Label 30481*/ GIMT_Encode4(2417095), // Rule ID 1517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1517,
        GIR_EraseRootFromParent_Done,
      // Label 30481: @2417095
      GIM_Try, /*On fail goto*//*Label 30482*/ GIMT_Encode4(2417122), // Rule ID 1539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1539,
        GIR_EraseRootFromParent_Done,
      // Label 30482: @2417122
      GIM_Reject,
    // Label 30479: @2417123
    GIM_Reject,
    // Label 30457: @2417124
    GIM_Try, /*On fail goto*//*Label 30483*/ GIMT_Encode4(2417231),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30484*/ GIMT_Encode4(2417185), // Rule ID 55796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55796,
        GIR_EraseRootFromParent_Done,
      // Label 30484: @2417185
      GIM_Try, /*On fail goto*//*Label 30485*/ GIMT_Encode4(2417230), // Rule ID 55797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55797,
        GIR_EraseRootFromParent_Done,
      // Label 30485: @2417230
      GIM_Reject,
    // Label 30483: @2417231
    GIM_Reject,
    // Label 30458: @2417232
    GIM_Try, /*On fail goto*//*Label 30486*/ GIMT_Encode4(2417339),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30487*/ GIMT_Encode4(2417293), // Rule ID 55836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55836,
        GIR_EraseRootFromParent_Done,
      // Label 30487: @2417293
      GIM_Try, /*On fail goto*//*Label 30488*/ GIMT_Encode4(2417338), // Rule ID 55837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55837,
        GIR_EraseRootFromParent_Done,
      // Label 30488: @2417338
      GIM_Reject,
    // Label 30486: @2417339
    GIM_Reject,
    // Label 30459: @2417340
    GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2417447),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2417401), // Rule ID 55896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55896,
        GIR_EraseRootFromParent_Done,
      // Label 30490: @2417401
      GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2417446), // Rule ID 55897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55897,
        GIR_EraseRootFromParent_Done,
      // Label 30491: @2417446
      GIM_Reject,
    // Label 30489: @2417447
    GIM_Reject,
    // Label 30460: @2417448
    GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2417555),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2417509), // Rule ID 55816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55816,
        GIR_EraseRootFromParent_Done,
      // Label 30493: @2417509
      GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2417554), // Rule ID 55817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55817,
        GIR_EraseRootFromParent_Done,
      // Label 30494: @2417554
      GIM_Reject,
    // Label 30492: @2417555
    GIM_Reject,
    // Label 30461: @2417556
    GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2417663),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2417617), // Rule ID 55876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55876,
        GIR_EraseRootFromParent_Done,
      // Label 30496: @2417617
      GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2417662), // Rule ID 55877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55877,
        GIR_EraseRootFromParent_Done,
      // Label 30497: @2417662
      GIM_Reject,
    // Label 30495: @2417663
    GIM_Reject,
    // Label 30462: @2417664
    GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2417771),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2417725), // Rule ID 56036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56036,
        GIR_EraseRootFromParent_Done,
      // Label 30499: @2417725
      GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2417770), // Rule ID 56037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56037,
        GIR_EraseRootFromParent_Done,
      // Label 30500: @2417770
      GIM_Reject,
    // Label 30498: @2417771
    GIM_Reject,
    // Label 30463: @2417772
    GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2417879),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2417833), // Rule ID 55856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55856,
        GIR_EraseRootFromParent_Done,
      // Label 30502: @2417833
      GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2417878), // Rule ID 55857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55857,
        GIR_EraseRootFromParent_Done,
      // Label 30503: @2417878
      GIM_Reject,
    // Label 30501: @2417879
    GIM_Reject,
    // Label 30464: @2417880
    GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2417987),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2417941), // Rule ID 55976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55976,
        GIR_EraseRootFromParent_Done,
      // Label 30505: @2417941
      GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2417986), // Rule ID 55977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55977,
        GIR_EraseRootFromParent_Done,
      // Label 30506: @2417986
      GIM_Reject,
    // Label 30504: @2417987
    GIM_Reject,
    // Label 30465: @2417988
    GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2418095),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2418049), // Rule ID 56056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56056,
        GIR_EraseRootFromParent_Done,
      // Label 30508: @2418049
      GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2418094), // Rule ID 56057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56057,
        GIR_EraseRootFromParent_Done,
      // Label 30509: @2418094
      GIM_Reject,
    // Label 30507: @2418095
    GIM_Reject,
    // Label 30466: @2418096
    GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2418203),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2418157), // Rule ID 55916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55916,
        GIR_EraseRootFromParent_Done,
      // Label 30511: @2418157
      GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2418202), // Rule ID 55917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55917,
        GIR_EraseRootFromParent_Done,
      // Label 30512: @2418202
      GIM_Reject,
    // Label 30510: @2418203
    GIM_Reject,
    // Label 30467: @2418204
    GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2418311),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2418265), // Rule ID 55996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55996,
        GIR_EraseRootFromParent_Done,
      // Label 30514: @2418265
      GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2418310), // Rule ID 55997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55997,
        GIR_EraseRootFromParent_Done,
      // Label 30515: @2418310
      GIM_Reject,
    // Label 30513: @2418311
    GIM_Reject,
    // Label 30468: @2418312
    GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2418419),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2418373), // Rule ID 56076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56076,
        GIR_EraseRootFromParent_Done,
      // Label 30517: @2418373
      GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2418418), // Rule ID 56077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56077,
        GIR_EraseRootFromParent_Done,
      // Label 30518: @2418418
      GIM_Reject,
    // Label 30516: @2418419
    GIM_Reject,
    // Label 30469: @2418420
    GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2418527),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2418481), // Rule ID 55936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55936,
        GIR_EraseRootFromParent_Done,
      // Label 30520: @2418481
      GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2418526), // Rule ID 55937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55937,
        GIR_EraseRootFromParent_Done,
      // Label 30521: @2418526
      GIM_Reject,
    // Label 30519: @2418527
    GIM_Reject,
    // Label 30470: @2418528
    GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2418635),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2418589), // Rule ID 56016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56016,
        GIR_EraseRootFromParent_Done,
      // Label 30523: @2418589
      GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2418634), // Rule ID 56017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56017,
        GIR_EraseRootFromParent_Done,
      // Label 30524: @2418634
      GIM_Reject,
    // Label 30522: @2418635
    GIM_Reject,
    // Label 30471: @2418636
    GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2418743),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2418697), // Rule ID 55956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55956,
        GIR_EraseRootFromParent_Done,
      // Label 30526: @2418697
      GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2418742), // Rule ID 55957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55957,
        GIR_EraseRootFromParent_Done,
      // Label 30527: @2418742
      GIM_Reject,
    // Label 30525: @2418743
    GIM_Reject,
    // Label 30472: @2418744
    GIM_Reject,
    // Label 63: @2418745
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 30530*/ GIMT_Encode4(2419197),
    /*GILLT_s32*//*Label 30528*/ GIMT_Encode4(2418764),
    /*GILLT_s64*//*Label 30529*/ GIMT_Encode4(2418886),
    // Label 30528: @2418764
    GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2418885),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2418800), // Rule ID 2024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2024,
        GIR_EraseRootFromParent_Done,
      // Label 30532: @2418800
      GIM_Try, /*On fail goto*//*Label 30533*/ GIMT_Encode4(2418828), // Rule ID 2025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2025,
        GIR_EraseRootFromParent_Done,
      // Label 30533: @2418828
      GIM_Try, /*On fail goto*//*Label 30534*/ GIMT_Encode4(2418856), // Rule ID 2040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2040,
        GIR_EraseRootFromParent_Done,
      // Label 30534: @2418856
      GIM_Try, /*On fail goto*//*Label 30535*/ GIMT_Encode4(2418884), // Rule ID 2041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2041,
        GIR_EraseRootFromParent_Done,
      // Label 30535: @2418884
      GIM_Reject,
    // Label 30531: @2418885
    GIM_Reject,
    // Label 30529: @2418886
    GIM_Try, /*On fail goto*//*Label 30536*/ GIMT_Encode4(2418917), // Rule ID 1426 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1426,
      GIR_EraseRootFromParent_Done,
    // Label 30536: @2418917
    GIM_Try, /*On fail goto*//*Label 30537*/ GIMT_Encode4(2418948), // Rule ID 1427 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1427,
      GIR_EraseRootFromParent_Done,
    // Label 30537: @2418948
    GIM_Try, /*On fail goto*//*Label 30538*/ GIMT_Encode4(2418979), // Rule ID 1431 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1431,
      GIR_EraseRootFromParent_Done,
    // Label 30538: @2418979
    GIM_Try, /*On fail goto*//*Label 30539*/ GIMT_Encode4(2419010), // Rule ID 1438 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1438,
      GIR_EraseRootFromParent_Done,
    // Label 30539: @2419010
    GIM_Try, /*On fail goto*//*Label 30540*/ GIMT_Encode4(2419041), // Rule ID 1439 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1439,
      GIR_EraseRootFromParent_Done,
    // Label 30540: @2419041
    GIM_Try, /*On fail goto*//*Label 30541*/ GIMT_Encode4(2419072), // Rule ID 2158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2158,
      GIR_EraseRootFromParent_Done,
    // Label 30541: @2419072
    GIM_Try, /*On fail goto*//*Label 30542*/ GIMT_Encode4(2419103), // Rule ID 2159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2159,
      GIR_EraseRootFromParent_Done,
    // Label 30542: @2419103
    GIM_Try, /*On fail goto*//*Label 30543*/ GIMT_Encode4(2419134), // Rule ID 2170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2170,
      GIR_EraseRootFromParent_Done,
    // Label 30543: @2419134
    GIM_Try, /*On fail goto*//*Label 30544*/ GIMT_Encode4(2419165), // Rule ID 2171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2171,
      GIR_EraseRootFromParent_Done,
    // Label 30544: @2419165
    GIM_Try, /*On fail goto*//*Label 30545*/ GIMT_Encode4(2419196), // Rule ID 2179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2179,
      GIR_EraseRootFromParent_Done,
    // Label 30545: @2419196
    GIM_Reject,
    // Label 30530: @2419197
    GIM_Reject,
    // Label 64: @2419198
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 30557*/ GIMT_Encode4(2420733),
    /*GILLT_s16*//*Label 30546*/ GIMT_Encode4(2419313),
    /*GILLT_s32*//*Label 30547*/ GIMT_Encode4(2419593), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 30548*/ GIMT_Encode4(2419743),
    /*GILLT_nxv1s32*//*Label 30549*/ GIMT_Encode4(2419853), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 30550*/ GIMT_Encode4(2419963),
    /*GILLT_nxv2s32*//*Label 30551*/ GIMT_Encode4(2420073), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 30552*/ GIMT_Encode4(2420183),
    /*GILLT_nxv4s32*//*Label 30553*/ GIMT_Encode4(2420293), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 30554*/ GIMT_Encode4(2420403),
    /*GILLT_nxv8s32*//*Label 30555*/ GIMT_Encode4(2420513), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 30556*/ GIMT_Encode4(2420623),
    // Label 30546: @2419313
    GIM_Try, /*On fail goto*//*Label 30558*/ GIMT_Encode4(2419344), // Rule ID 2020 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2020,
      GIR_EraseRootFromParent_Done,
    // Label 30558: @2419344
    GIM_Try, /*On fail goto*//*Label 30559*/ GIMT_Encode4(2419375), // Rule ID 2021 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2021,
      GIR_EraseRootFromParent_Done,
    // Label 30559: @2419375
    GIM_Try, /*On fail goto*//*Label 30560*/ GIMT_Encode4(2419406), // Rule ID 2036 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2036,
      GIR_EraseRootFromParent_Done,
    // Label 30560: @2419406
    GIM_Try, /*On fail goto*//*Label 30561*/ GIMT_Encode4(2419437), // Rule ID 2037 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2037,
      GIR_EraseRootFromParent_Done,
    // Label 30561: @2419437
    GIM_Try, /*On fail goto*//*Label 30562*/ GIMT_Encode4(2419468), // Rule ID 2154 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2154,
      GIR_EraseRootFromParent_Done,
    // Label 30562: @2419468
    GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2419499), // Rule ID 2155 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2155,
      GIR_EraseRootFromParent_Done,
    // Label 30563: @2419499
    GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2419530), // Rule ID 2166 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2166,
      GIR_EraseRootFromParent_Done,
    // Label 30564: @2419530
    GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2419561), // Rule ID 2167 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2167,
      GIR_EraseRootFromParent_Done,
    // Label 30565: @2419561
    GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2419592), // Rule ID 2177 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2177,
      GIR_EraseRootFromParent_Done,
    // Label 30566: @2419592
    GIM_Reject,
    // Label 30547: @2419593
    GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2419742),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2419629), // Rule ID 1422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1422,
        GIR_EraseRootFromParent_Done,
      // Label 30568: @2419629
      GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2419657), // Rule ID 1423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1423,
        GIR_EraseRootFromParent_Done,
      // Label 30569: @2419657
      GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2419685), // Rule ID 1429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1429,
        GIR_EraseRootFromParent_Done,
      // Label 30570: @2419685
      GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2419713), // Rule ID 1434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1434,
        GIR_EraseRootFromParent_Done,
      // Label 30571: @2419713
      GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2419741), // Rule ID 1435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1435,
        GIR_EraseRootFromParent_Done,
      // Label 30572: @2419741
      GIM_Reject,
    // Label 30567: @2419742
    GIM_Reject,
    // Label 30548: @2419743
    GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2419852),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2419805), // Rule ID 58264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58264,
        GIR_EraseRootFromParent_Done,
      // Label 30574: @2419805
      GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2419851), // Rule ID 58265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58265,
        GIR_EraseRootFromParent_Done,
      // Label 30575: @2419851
      GIM_Reject,
    // Label 30573: @2419852
    GIM_Reject,
    // Label 30549: @2419853
    GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2419962),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2419915), // Rule ID 58274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58274,
        GIR_EraseRootFromParent_Done,
      // Label 30577: @2419915
      GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2419961), // Rule ID 58275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58275,
        GIR_EraseRootFromParent_Done,
      // Label 30578: @2419961
      GIM_Reject,
    // Label 30576: @2419962
    GIM_Reject,
    // Label 30550: @2419963
    GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2420072),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2420025), // Rule ID 58266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58266,
        GIR_EraseRootFromParent_Done,
      // Label 30580: @2420025
      GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2420071), // Rule ID 58267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58267,
        GIR_EraseRootFromParent_Done,
      // Label 30581: @2420071
      GIM_Reject,
    // Label 30579: @2420072
    GIM_Reject,
    // Label 30551: @2420073
    GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2420182),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2420135), // Rule ID 58276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58276,
        GIR_EraseRootFromParent_Done,
      // Label 30583: @2420135
      GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2420181), // Rule ID 58277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58277,
        GIR_EraseRootFromParent_Done,
      // Label 30584: @2420181
      GIM_Reject,
    // Label 30582: @2420182
    GIM_Reject,
    // Label 30552: @2420183
    GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2420292),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2420245), // Rule ID 58268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58268,
        GIR_EraseRootFromParent_Done,
      // Label 30586: @2420245
      GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2420291), // Rule ID 58269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58269,
        GIR_EraseRootFromParent_Done,
      // Label 30587: @2420291
      GIM_Reject,
    // Label 30585: @2420292
    GIM_Reject,
    // Label 30553: @2420293
    GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2420402),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2420355), // Rule ID 58278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58278,
        GIR_EraseRootFromParent_Done,
      // Label 30589: @2420355
      GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2420401), // Rule ID 58279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58279,
        GIR_EraseRootFromParent_Done,
      // Label 30590: @2420401
      GIM_Reject,
    // Label 30588: @2420402
    GIM_Reject,
    // Label 30554: @2420403
    GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2420512),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2420465), // Rule ID 58270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58270,
        GIR_EraseRootFromParent_Done,
      // Label 30592: @2420465
      GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2420511), // Rule ID 58271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58271,
        GIR_EraseRootFromParent_Done,
      // Label 30593: @2420511
      GIM_Reject,
    // Label 30591: @2420512
    GIM_Reject,
    // Label 30555: @2420513
    GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2420622),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30595*/ GIMT_Encode4(2420575), // Rule ID 58280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
        // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58280,
        GIR_EraseRootFromParent_Done,
      // Label 30595: @2420575
      GIM_Try, /*On fail goto*//*Label 30596*/ GIMT_Encode4(2420621), // Rule ID 58281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
        // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58281,
        GIR_EraseRootFromParent_Done,
      // Label 30596: @2420621
      GIM_Reject,
    // Label 30594: @2420622
    GIM_Reject,
    // Label 30556: @2420623
    GIM_Try, /*On fail goto*//*Label 30597*/ GIMT_Encode4(2420732),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30598*/ GIMT_Encode4(2420685), // Rule ID 58272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
        // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58272,
        GIR_EraseRootFromParent_Done,
      // Label 30598: @2420685
      GIM_Try, /*On fail goto*//*Label 30599*/ GIMT_Encode4(2420731), // Rule ID 58273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
        // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58273,
        GIR_EraseRootFromParent_Done,
      // Label 30599: @2420731
      GIM_Reject,
    // Label 30597: @2420732
    GIM_Reject,
    // Label 30557: @2420733
    GIM_Reject,
    // Label 65: @2420734
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 30623*/ GIMT_Encode4(2425619),
    /*GILLT_s32*//*Label 30600*/ GIMT_Encode4(2420861),
    /*GILLT_s64*//*Label 30601*/ GIMT_Encode4(2421234), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 30602*/ GIMT_Encode4(2421421),
    /*GILLT_nxv1s16*//*Label 30603*/ GIMT_Encode4(2421525),
    /*GILLT_nxv1s32*//*Label 30604*/ GIMT_Encode4(2421742),
    /*GILLT_nxv1s64*//*Label 30605*/ GIMT_Encode4(2422067), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 30606*/ GIMT_Encode4(2422284),
    /*GILLT_nxv2s16*//*Label 30607*/ GIMT_Encode4(2422388),
    /*GILLT_nxv2s32*//*Label 30608*/ GIMT_Encode4(2422605),
    /*GILLT_nxv2s64*//*Label 30609*/ GIMT_Encode4(2422930), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 30610*/ GIMT_Encode4(2423147),
    /*GILLT_nxv4s16*//*Label 30611*/ GIMT_Encode4(2423251),
    /*GILLT_nxv4s32*//*Label 30612*/ GIMT_Encode4(2423468),
    /*GILLT_nxv4s64*//*Label 30613*/ GIMT_Encode4(2423793), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 30614*/ GIMT_Encode4(2424010),
    /*GILLT_nxv8s16*//*Label 30615*/ GIMT_Encode4(2424114),
    /*GILLT_nxv8s32*//*Label 30616*/ GIMT_Encode4(2424331),
    /*GILLT_nxv8s64*//*Label 30617*/ GIMT_Encode4(2424656), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 30618*/ GIMT_Encode4(2424873),
    /*GILLT_nxv16s16*//*Label 30619*/ GIMT_Encode4(2424977),
    /*GILLT_nxv16s32*//*Label 30620*/ GIMT_Encode4(2425194), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 30621*/ GIMT_Encode4(2425411),
    /*GILLT_nxv32s16*//*Label 30622*/ GIMT_Encode4(2425515),
    // Label 30600: @2420861
    GIM_Try, /*On fail goto*//*Label 30624*/ GIMT_Encode4(2420892), // Rule ID 1314 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1314,
      GIR_EraseRootFromParent_Done,
    // Label 30624: @2420892
    GIM_Try, /*On fail goto*//*Label 30625*/ GIMT_Encode4(2420923), // Rule ID 1315 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1315,
      GIR_EraseRootFromParent_Done,
    // Label 30625: @2420923
    GIM_Try, /*On fail goto*//*Label 30626*/ GIMT_Encode4(2420954), // Rule ID 1340 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1340,
      GIR_EraseRootFromParent_Done,
    // Label 30626: @2420954
    GIM_Try, /*On fail goto*//*Label 30627*/ GIMT_Encode4(2420985), // Rule ID 1341 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1341,
      GIR_EraseRootFromParent_Done,
    // Label 30627: @2420985
    GIM_Try, /*On fail goto*//*Label 30628*/ GIMT_Encode4(2421016), // Rule ID 1708 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1708,
      GIR_EraseRootFromParent_Done,
    // Label 30628: @2421016
    GIM_Try, /*On fail goto*//*Label 30629*/ GIMT_Encode4(2421047), // Rule ID 1709 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1709,
      GIR_EraseRootFromParent_Done,
    // Label 30629: @2421047
    GIM_Try, /*On fail goto*//*Label 30630*/ GIMT_Encode4(2421078), // Rule ID 1734 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1734,
      GIR_EraseRootFromParent_Done,
    // Label 30630: @2421078
    GIM_Try, /*On fail goto*//*Label 30631*/ GIMT_Encode4(2421109), // Rule ID 1735 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1735,
      GIR_EraseRootFromParent_Done,
    // Label 30631: @2421109
    GIM_Try, /*On fail goto*//*Label 30632*/ GIMT_Encode4(2421140), // Rule ID 2050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2050,
      GIR_EraseRootFromParent_Done,
    // Label 30632: @2421140
    GIM_Try, /*On fail goto*//*Label 30633*/ GIMT_Encode4(2421171), // Rule ID 2051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2051,
      GIR_EraseRootFromParent_Done,
    // Label 30633: @2421171
    GIM_Try, /*On fail goto*//*Label 30634*/ GIMT_Encode4(2421202), // Rule ID 2076 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2076,
      GIR_EraseRootFromParent_Done,
    // Label 30634: @2421202
    GIM_Try, /*On fail goto*//*Label 30635*/ GIMT_Encode4(2421233), // Rule ID 2077 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2077,
      GIR_EraseRootFromParent_Done,
    // Label 30635: @2421233
    GIM_Reject,
    // Label 30601: @2421234
    GIM_Try, /*On fail goto*//*Label 30636*/ GIMT_Encode4(2421265), // Rule ID 1371 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1371,
      GIR_EraseRootFromParent_Done,
    // Label 30636: @2421265
    GIM_Try, /*On fail goto*//*Label 30637*/ GIMT_Encode4(2421296), // Rule ID 1399 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1399,
      GIR_EraseRootFromParent_Done,
    // Label 30637: @2421296
    GIM_Try, /*On fail goto*//*Label 30638*/ GIMT_Encode4(2421327), // Rule ID 1771 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1771,
      GIR_EraseRootFromParent_Done,
    // Label 30638: @2421327
    GIM_Try, /*On fail goto*//*Label 30639*/ GIMT_Encode4(2421358), // Rule ID 1799 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1799,
      GIR_EraseRootFromParent_Done,
    // Label 30639: @2421358
    GIM_Try, /*On fail goto*//*Label 30640*/ GIMT_Encode4(2421389), // Rule ID 2105 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2105,
      GIR_EraseRootFromParent_Done,
    // Label 30640: @2421389
    GIM_Try, /*On fail goto*//*Label 30641*/ GIMT_Encode4(2421420), // Rule ID 2131 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2131,
      GIR_EraseRootFromParent_Done,
    // Label 30641: @2421420
    GIM_Reject,
    // Label 30602: @2421421
    GIM_Try, /*On fail goto*//*Label 30642*/ GIMT_Encode4(2421524),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30643*/ GIMT_Encode4(2421480), // Rule ID 45606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45606,
        GIR_EraseRootFromParent_Done,
      // Label 30643: @2421480
      GIM_Try, /*On fail goto*//*Label 30644*/ GIMT_Encode4(2421523), // Rule ID 45607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45607,
        GIR_EraseRootFromParent_Done,
      // Label 30644: @2421523
      GIM_Reject,
    // Label 30642: @2421524
    GIM_Reject,
    // Label 30603: @2421525
    GIM_Try, /*On fail goto*//*Label 30645*/ GIMT_Encode4(2421579), // Rule ID 45590 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45590,
      GIR_EraseRootFromParent_Done,
    // Label 30645: @2421579
    GIM_Try, /*On fail goto*//*Label 30646*/ GIMT_Encode4(2421633), // Rule ID 45591 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45591,
      GIR_EraseRootFromParent_Done,
    // Label 30646: @2421633
    GIM_Try, /*On fail goto*//*Label 30647*/ GIMT_Encode4(2421687), // Rule ID 58102 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58102,
      GIR_EraseRootFromParent_Done,
    // Label 30647: @2421687
    GIM_Try, /*On fail goto*//*Label 30648*/ GIMT_Encode4(2421741), // Rule ID 58103 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58103,
      GIR_EraseRootFromParent_Done,
    // Label 30648: @2421741
    GIM_Reject,
    // Label 30604: @2421742
    GIM_Try, /*On fail goto*//*Label 30649*/ GIMT_Encode4(2421796), // Rule ID 45598 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45598,
      GIR_EraseRootFromParent_Done,
    // Label 30649: @2421796
    GIM_Try, /*On fail goto*//*Label 30650*/ GIMT_Encode4(2421850), // Rule ID 45599 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45599,
      GIR_EraseRootFromParent_Done,
    // Label 30650: @2421850
    GIM_Try, /*On fail goto*//*Label 30651*/ GIMT_Encode4(2421904), // Rule ID 57670 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57670,
      GIR_EraseRootFromParent_Done,
    // Label 30651: @2421904
    GIM_Try, /*On fail goto*//*Label 30652*/ GIMT_Encode4(2421958), // Rule ID 57671 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57671,
      GIR_EraseRootFromParent_Done,
    // Label 30652: @2421958
    GIM_Try, /*On fail goto*//*Label 30653*/ GIMT_Encode4(2422012), // Rule ID 58122 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58122,
      GIR_EraseRootFromParent_Done,
    // Label 30653: @2422012
    GIM_Try, /*On fail goto*//*Label 30654*/ GIMT_Encode4(2422066), // Rule ID 58123 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58123,
      GIR_EraseRootFromParent_Done,
    // Label 30654: @2422066
    GIM_Reject,
    // Label 30605: @2422067
    GIM_Try, /*On fail goto*//*Label 30655*/ GIMT_Encode4(2422121), // Rule ID 57682 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57682,
      GIR_EraseRootFromParent_Done,
    // Label 30655: @2422121
    GIM_Try, /*On fail goto*//*Label 30656*/ GIMT_Encode4(2422175), // Rule ID 57683 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57683,
      GIR_EraseRootFromParent_Done,
    // Label 30656: @2422175
    GIM_Try, /*On fail goto*//*Label 30657*/ GIMT_Encode4(2422229), // Rule ID 57914 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57914,
      GIR_EraseRootFromParent_Done,
    // Label 30657: @2422229
    GIM_Try, /*On fail goto*//*Label 30658*/ GIMT_Encode4(2422283), // Rule ID 57915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57915,
      GIR_EraseRootFromParent_Done,
    // Label 30658: @2422283
    GIM_Reject,
    // Label 30606: @2422284
    GIM_Try, /*On fail goto*//*Label 30659*/ GIMT_Encode4(2422387),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2422343), // Rule ID 58082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58082,
        GIR_EraseRootFromParent_Done,
      // Label 30660: @2422343
      GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2422386), // Rule ID 58083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58083,
        GIR_EraseRootFromParent_Done,
      // Label 30661: @2422386
      GIM_Reject,
    // Label 30659: @2422387
    GIM_Reject,
    // Label 30607: @2422388
    GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2422442), // Rule ID 57666 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57666,
      GIR_EraseRootFromParent_Done,
    // Label 30662: @2422442
    GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2422496), // Rule ID 57667 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57667,
      GIR_EraseRootFromParent_Done,
    // Label 30663: @2422496
    GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2422550), // Rule ID 58106 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58106,
      GIR_EraseRootFromParent_Done,
    // Label 30664: @2422550
    GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2422604), // Rule ID 58107 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58107,
      GIR_EraseRootFromParent_Done,
    // Label 30665: @2422604
    GIM_Reject,
    // Label 30608: @2422605
    GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2422659), // Rule ID 57678 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57678,
      GIR_EraseRootFromParent_Done,
    // Label 30666: @2422659
    GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2422713), // Rule ID 57679 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57679,
      GIR_EraseRootFromParent_Done,
    // Label 30667: @2422713
    GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2422767), // Rule ID 57898 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57898,
      GIR_EraseRootFromParent_Done,
    // Label 30668: @2422767
    GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2422821), // Rule ID 57899 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57899,
      GIR_EraseRootFromParent_Done,
    // Label 30669: @2422821
    GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2422875), // Rule ID 58126 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58126,
      GIR_EraseRootFromParent_Done,
    // Label 30670: @2422875
    GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2422929), // Rule ID 58127 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58127,
      GIR_EraseRootFromParent_Done,
    // Label 30671: @2422929
    GIM_Reject,
    // Label 30609: @2422930
    GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2422984), // Rule ID 57710 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57710,
      GIR_EraseRootFromParent_Done,
    // Label 30672: @2422984
    GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2423038), // Rule ID 57711 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57711,
      GIR_EraseRootFromParent_Done,
    // Label 30673: @2423038
    GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2423092), // Rule ID 57918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57918,
      GIR_EraseRootFromParent_Done,
    // Label 30674: @2423092
    GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2423146), // Rule ID 57919 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57919,
      GIR_EraseRootFromParent_Done,
    // Label 30675: @2423146
    GIM_Reject,
    // Label 30610: @2423147
    GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2423250),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2423206), // Rule ID 58086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58086,
        GIR_EraseRootFromParent_Done,
      // Label 30677: @2423206
      GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2423249), // Rule ID 58087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58087,
        GIR_EraseRootFromParent_Done,
      // Label 30678: @2423249
      GIM_Reject,
    // Label 30676: @2423250
    GIM_Reject,
    // Label 30611: @2423251
    GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2423305), // Rule ID 57674 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57674,
      GIR_EraseRootFromParent_Done,
    // Label 30679: @2423305
    GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2423359), // Rule ID 57675 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57675,
      GIR_EraseRootFromParent_Done,
    // Label 30680: @2423359
    GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2423413), // Rule ID 58110 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58110,
      GIR_EraseRootFromParent_Done,
    // Label 30681: @2423413
    GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2423467), // Rule ID 58111 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58111,
      GIR_EraseRootFromParent_Done,
    // Label 30682: @2423467
    GIM_Reject,
    // Label 30612: @2423468
    GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2423522), // Rule ID 57698 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57698,
      GIR_EraseRootFromParent_Done,
    // Label 30683: @2423522
    GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2423576), // Rule ID 57699 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57699,
      GIR_EraseRootFromParent_Done,
    // Label 30684: @2423576
    GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2423630), // Rule ID 57902 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57902,
      GIR_EraseRootFromParent_Done,
    // Label 30685: @2423630
    GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2423684), // Rule ID 57903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57903,
      GIR_EraseRootFromParent_Done,
    // Label 30686: @2423684
    GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2423738), // Rule ID 58130 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58130,
      GIR_EraseRootFromParent_Done,
    // Label 30687: @2423738
    GIM_Try, /*On fail goto*//*Label 30688*/ GIMT_Encode4(2423792), // Rule ID 58131 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58131,
      GIR_EraseRootFromParent_Done,
    // Label 30688: @2423792
    GIM_Reject,
    // Label 30613: @2423793
    GIM_Try, /*On fail goto*//*Label 30689*/ GIMT_Encode4(2423847), // Rule ID 57714 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57714,
      GIR_EraseRootFromParent_Done,
    // Label 30689: @2423847
    GIM_Try, /*On fail goto*//*Label 30690*/ GIMT_Encode4(2423901), // Rule ID 57715 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57715,
      GIR_EraseRootFromParent_Done,
    // Label 30690: @2423901
    GIM_Try, /*On fail goto*//*Label 30691*/ GIMT_Encode4(2423955), // Rule ID 57922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57922,
      GIR_EraseRootFromParent_Done,
    // Label 30691: @2423955
    GIM_Try, /*On fail goto*//*Label 30692*/ GIMT_Encode4(2424009), // Rule ID 57923 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57923,
      GIR_EraseRootFromParent_Done,
    // Label 30692: @2424009
    GIM_Reject,
    // Label 30614: @2424010
    GIM_Try, /*On fail goto*//*Label 30693*/ GIMT_Encode4(2424113),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30694*/ GIMT_Encode4(2424069), // Rule ID 58090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58090,
        GIR_EraseRootFromParent_Done,
      // Label 30694: @2424069
      GIM_Try, /*On fail goto*//*Label 30695*/ GIMT_Encode4(2424112), // Rule ID 58091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58091,
        GIR_EraseRootFromParent_Done,
      // Label 30695: @2424112
      GIM_Reject,
    // Label 30693: @2424113
    GIM_Reject,
    // Label 30615: @2424114
    GIM_Try, /*On fail goto*//*Label 30696*/ GIMT_Encode4(2424168), // Rule ID 57686 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57686,
      GIR_EraseRootFromParent_Done,
    // Label 30696: @2424168
    GIM_Try, /*On fail goto*//*Label 30697*/ GIMT_Encode4(2424222), // Rule ID 57687 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57687,
      GIR_EraseRootFromParent_Done,
    // Label 30697: @2424222
    GIM_Try, /*On fail goto*//*Label 30698*/ GIMT_Encode4(2424276), // Rule ID 58114 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58114,
      GIR_EraseRootFromParent_Done,
    // Label 30698: @2424276
    GIM_Try, /*On fail goto*//*Label 30699*/ GIMT_Encode4(2424330), // Rule ID 58115 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58115,
      GIR_EraseRootFromParent_Done,
    // Label 30699: @2424330
    GIM_Reject,
    // Label 30616: @2424331
    GIM_Try, /*On fail goto*//*Label 30700*/ GIMT_Encode4(2424385), // Rule ID 57702 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57702,
      GIR_EraseRootFromParent_Done,
    // Label 30700: @2424385
    GIM_Try, /*On fail goto*//*Label 30701*/ GIMT_Encode4(2424439), // Rule ID 57703 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57703,
      GIR_EraseRootFromParent_Done,
    // Label 30701: @2424439
    GIM_Try, /*On fail goto*//*Label 30702*/ GIMT_Encode4(2424493), // Rule ID 57906 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57906,
      GIR_EraseRootFromParent_Done,
    // Label 30702: @2424493
    GIM_Try, /*On fail goto*//*Label 30703*/ GIMT_Encode4(2424547), // Rule ID 57907 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57907,
      GIR_EraseRootFromParent_Done,
    // Label 30703: @2424547
    GIM_Try, /*On fail goto*//*Label 30704*/ GIMT_Encode4(2424601), // Rule ID 58134 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58134,
      GIR_EraseRootFromParent_Done,
    // Label 30704: @2424601
    GIM_Try, /*On fail goto*//*Label 30705*/ GIMT_Encode4(2424655), // Rule ID 58135 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58135,
      GIR_EraseRootFromParent_Done,
    // Label 30705: @2424655
    GIM_Reject,
    // Label 30617: @2424656
    GIM_Try, /*On fail goto*//*Label 30706*/ GIMT_Encode4(2424710), // Rule ID 57718 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57718,
      GIR_EraseRootFromParent_Done,
    // Label 30706: @2424710
    GIM_Try, /*On fail goto*//*Label 30707*/ GIMT_Encode4(2424764), // Rule ID 57719 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57719,
      GIR_EraseRootFromParent_Done,
    // Label 30707: @2424764
    GIM_Try, /*On fail goto*//*Label 30708*/ GIMT_Encode4(2424818), // Rule ID 57926 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57926,
      GIR_EraseRootFromParent_Done,
    // Label 30708: @2424818
    GIM_Try, /*On fail goto*//*Label 30709*/ GIMT_Encode4(2424872), // Rule ID 57927 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57927,
      GIR_EraseRootFromParent_Done,
    // Label 30709: @2424872
    GIM_Reject,
    // Label 30618: @2424873
    GIM_Try, /*On fail goto*//*Label 30710*/ GIMT_Encode4(2424976),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30711*/ GIMT_Encode4(2424932), // Rule ID 58094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58094,
        GIR_EraseRootFromParent_Done,
      // Label 30711: @2424932
      GIM_Try, /*On fail goto*//*Label 30712*/ GIMT_Encode4(2424975), // Rule ID 58095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58095,
        GIR_EraseRootFromParent_Done,
      // Label 30712: @2424975
      GIM_Reject,
    // Label 30710: @2424976
    GIM_Reject,
    // Label 30619: @2424977
    GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2425031), // Rule ID 57690 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57690,
      GIR_EraseRootFromParent_Done,
    // Label 30713: @2425031
    GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2425085), // Rule ID 57691 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57691,
      GIR_EraseRootFromParent_Done,
    // Label 30714: @2425085
    GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2425139), // Rule ID 58118 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58118,
      GIR_EraseRootFromParent_Done,
    // Label 30715: @2425139
    GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2425193), // Rule ID 58119 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58119,
      GIR_EraseRootFromParent_Done,
    // Label 30716: @2425193
    GIM_Reject,
    // Label 30620: @2425194
    GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2425248), // Rule ID 57706 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57706,
      GIR_EraseRootFromParent_Done,
    // Label 30717: @2425248
    GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2425302), // Rule ID 57707 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57707,
      GIR_EraseRootFromParent_Done,
    // Label 30718: @2425302
    GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2425356), // Rule ID 57910 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57910,
      GIR_EraseRootFromParent_Done,
    // Label 30719: @2425356
    GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2425410), // Rule ID 57911 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57911,
      GIR_EraseRootFromParent_Done,
    // Label 30720: @2425410
    GIM_Reject,
    // Label 30621: @2425411
    GIM_Try, /*On fail goto*//*Label 30721*/ GIMT_Encode4(2425514),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30722*/ GIMT_Encode4(2425470), // Rule ID 58098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58098,
        GIR_EraseRootFromParent_Done,
      // Label 30722: @2425470
      GIM_Try, /*On fail goto*//*Label 30723*/ GIMT_Encode4(2425513), // Rule ID 58099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58099,
        GIR_EraseRootFromParent_Done,
      // Label 30723: @2425513
      GIM_Reject,
    // Label 30721: @2425514
    GIM_Reject,
    // Label 30622: @2425515
    GIM_Try, /*On fail goto*//*Label 30724*/ GIMT_Encode4(2425618),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30725*/ GIMT_Encode4(2425574), // Rule ID 57694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57694,
        GIR_EraseRootFromParent_Done,
      // Label 30725: @2425574
      GIM_Try, /*On fail goto*//*Label 30726*/ GIMT_Encode4(2425617), // Rule ID 57695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57695,
        GIR_EraseRootFromParent_Done,
      // Label 30726: @2425617
      GIM_Reject,
    // Label 30724: @2425618
    GIM_Reject,
    // Label 30623: @2425619
    GIM_Reject,
    // Label 66: @2425620
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 30750*/ GIMT_Encode4(2430505),
    /*GILLT_s32*//*Label 30727*/ GIMT_Encode4(2425747),
    /*GILLT_s64*//*Label 30728*/ GIMT_Encode4(2426120), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 30729*/ GIMT_Encode4(2426307),
    /*GILLT_nxv1s16*//*Label 30730*/ GIMT_Encode4(2426411),
    /*GILLT_nxv1s32*//*Label 30731*/ GIMT_Encode4(2426628),
    /*GILLT_nxv1s64*//*Label 30732*/ GIMT_Encode4(2426953), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 30733*/ GIMT_Encode4(2427170),
    /*GILLT_nxv2s16*//*Label 30734*/ GIMT_Encode4(2427274),
    /*GILLT_nxv2s32*//*Label 30735*/ GIMT_Encode4(2427491),
    /*GILLT_nxv2s64*//*Label 30736*/ GIMT_Encode4(2427816), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 30737*/ GIMT_Encode4(2428033),
    /*GILLT_nxv4s16*//*Label 30738*/ GIMT_Encode4(2428137),
    /*GILLT_nxv4s32*//*Label 30739*/ GIMT_Encode4(2428354),
    /*GILLT_nxv4s64*//*Label 30740*/ GIMT_Encode4(2428679), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 30741*/ GIMT_Encode4(2428896),
    /*GILLT_nxv8s16*//*Label 30742*/ GIMT_Encode4(2429000),
    /*GILLT_nxv8s32*//*Label 30743*/ GIMT_Encode4(2429217),
    /*GILLT_nxv8s64*//*Label 30744*/ GIMT_Encode4(2429542), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 30745*/ GIMT_Encode4(2429759),
    /*GILLT_nxv16s16*//*Label 30746*/ GIMT_Encode4(2429863),
    /*GILLT_nxv16s32*//*Label 30747*/ GIMT_Encode4(2430080), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 30748*/ GIMT_Encode4(2430297),
    /*GILLT_nxv32s16*//*Label 30749*/ GIMT_Encode4(2430401),
    // Label 30727: @2425747
    GIM_Try, /*On fail goto*//*Label 30751*/ GIMT_Encode4(2425778), // Rule ID 1318 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1318,
      GIR_EraseRootFromParent_Done,
    // Label 30751: @2425778
    GIM_Try, /*On fail goto*//*Label 30752*/ GIMT_Encode4(2425809), // Rule ID 1319 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1319,
      GIR_EraseRootFromParent_Done,
    // Label 30752: @2425809
    GIM_Try, /*On fail goto*//*Label 30753*/ GIMT_Encode4(2425840), // Rule ID 1344 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1344,
      GIR_EraseRootFromParent_Done,
    // Label 30753: @2425840
    GIM_Try, /*On fail goto*//*Label 30754*/ GIMT_Encode4(2425871), // Rule ID 1345 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1345,
      GIR_EraseRootFromParent_Done,
    // Label 30754: @2425871
    GIM_Try, /*On fail goto*//*Label 30755*/ GIMT_Encode4(2425902), // Rule ID 1712 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1712,
      GIR_EraseRootFromParent_Done,
    // Label 30755: @2425902
    GIM_Try, /*On fail goto*//*Label 30756*/ GIMT_Encode4(2425933), // Rule ID 1713 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1713,
      GIR_EraseRootFromParent_Done,
    // Label 30756: @2425933
    GIM_Try, /*On fail goto*//*Label 30757*/ GIMT_Encode4(2425964), // Rule ID 1738 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1738,
      GIR_EraseRootFromParent_Done,
    // Label 30757: @2425964
    GIM_Try, /*On fail goto*//*Label 30758*/ GIMT_Encode4(2425995), // Rule ID 1739 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1739,
      GIR_EraseRootFromParent_Done,
    // Label 30758: @2425995
    GIM_Try, /*On fail goto*//*Label 30759*/ GIMT_Encode4(2426026), // Rule ID 2054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2054,
      GIR_EraseRootFromParent_Done,
    // Label 30759: @2426026
    GIM_Try, /*On fail goto*//*Label 30760*/ GIMT_Encode4(2426057), // Rule ID 2055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2055,
      GIR_EraseRootFromParent_Done,
    // Label 30760: @2426057
    GIM_Try, /*On fail goto*//*Label 30761*/ GIMT_Encode4(2426088), // Rule ID 2080 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2080,
      GIR_EraseRootFromParent_Done,
    // Label 30761: @2426088
    GIM_Try, /*On fail goto*//*Label 30762*/ GIMT_Encode4(2426119), // Rule ID 2081 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2081,
      GIR_EraseRootFromParent_Done,
    // Label 30762: @2426119
    GIM_Reject,
    // Label 30728: @2426120
    GIM_Try, /*On fail goto*//*Label 30763*/ GIMT_Encode4(2426151), // Rule ID 1373 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1373,
      GIR_EraseRootFromParent_Done,
    // Label 30763: @2426151
    GIM_Try, /*On fail goto*//*Label 30764*/ GIMT_Encode4(2426182), // Rule ID 1401 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1401,
      GIR_EraseRootFromParent_Done,
    // Label 30764: @2426182
    GIM_Try, /*On fail goto*//*Label 30765*/ GIMT_Encode4(2426213), // Rule ID 1773 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1773,
      GIR_EraseRootFromParent_Done,
    // Label 30765: @2426213
    GIM_Try, /*On fail goto*//*Label 30766*/ GIMT_Encode4(2426244), // Rule ID 1801 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1801,
      GIR_EraseRootFromParent_Done,
    // Label 30766: @2426244
    GIM_Try, /*On fail goto*//*Label 30767*/ GIMT_Encode4(2426275), // Rule ID 2107 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2107,
      GIR_EraseRootFromParent_Done,
    // Label 30767: @2426275
    GIM_Try, /*On fail goto*//*Label 30768*/ GIMT_Encode4(2426306), // Rule ID 2133 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2133,
      GIR_EraseRootFromParent_Done,
    // Label 30768: @2426306
    GIM_Reject,
    // Label 30729: @2426307
    GIM_Try, /*On fail goto*//*Label 30769*/ GIMT_Encode4(2426410),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30770*/ GIMT_Encode4(2426366), // Rule ID 58138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58138,
        GIR_EraseRootFromParent_Done,
      // Label 30770: @2426366
      GIM_Try, /*On fail goto*//*Label 30771*/ GIMT_Encode4(2426409), // Rule ID 58139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58139,
        GIR_EraseRootFromParent_Done,
      // Label 30771: @2426409
      GIM_Reject,
    // Label 30769: @2426410
    GIM_Reject,
    // Label 30730: @2426411
    GIM_Try, /*On fail goto*//*Label 30772*/ GIMT_Encode4(2426465), // Rule ID 57722 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57722,
      GIR_EraseRootFromParent_Done,
    // Label 30772: @2426465
    GIM_Try, /*On fail goto*//*Label 30773*/ GIMT_Encode4(2426519), // Rule ID 57723 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57723,
      GIR_EraseRootFromParent_Done,
    // Label 30773: @2426519
    GIM_Try, /*On fail goto*//*Label 30774*/ GIMT_Encode4(2426573), // Rule ID 58162 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58162,
      GIR_EraseRootFromParent_Done,
    // Label 30774: @2426573
    GIM_Try, /*On fail goto*//*Label 30775*/ GIMT_Encode4(2426627), // Rule ID 58163 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58163,
      GIR_EraseRootFromParent_Done,
    // Label 30775: @2426627
    GIM_Reject,
    // Label 30731: @2426628
    GIM_Try, /*On fail goto*//*Label 30776*/ GIMT_Encode4(2426682), // Rule ID 57730 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57730,
      GIR_EraseRootFromParent_Done,
    // Label 30776: @2426682
    GIM_Try, /*On fail goto*//*Label 30777*/ GIMT_Encode4(2426736), // Rule ID 57731 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57731,
      GIR_EraseRootFromParent_Done,
    // Label 30777: @2426736
    GIM_Try, /*On fail goto*//*Label 30778*/ GIMT_Encode4(2426790), // Rule ID 57930 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57930,
      GIR_EraseRootFromParent_Done,
    // Label 30778: @2426790
    GIM_Try, /*On fail goto*//*Label 30779*/ GIMT_Encode4(2426844), // Rule ID 57931 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57931,
      GIR_EraseRootFromParent_Done,
    // Label 30779: @2426844
    GIM_Try, /*On fail goto*//*Label 30780*/ GIMT_Encode4(2426898), // Rule ID 58182 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58182,
      GIR_EraseRootFromParent_Done,
    // Label 30780: @2426898
    GIM_Try, /*On fail goto*//*Label 30781*/ GIMT_Encode4(2426952), // Rule ID 58183 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58183,
      GIR_EraseRootFromParent_Done,
    // Label 30781: @2426952
    GIM_Reject,
    // Label 30732: @2426953
    GIM_Try, /*On fail goto*//*Label 30782*/ GIMT_Encode4(2427007), // Rule ID 57742 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57742,
      GIR_EraseRootFromParent_Done,
    // Label 30782: @2427007
    GIM_Try, /*On fail goto*//*Label 30783*/ GIMT_Encode4(2427061), // Rule ID 57743 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57743,
      GIR_EraseRootFromParent_Done,
    // Label 30783: @2427061
    GIM_Try, /*On fail goto*//*Label 30784*/ GIMT_Encode4(2427115), // Rule ID 57950 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57950,
      GIR_EraseRootFromParent_Done,
    // Label 30784: @2427115
    GIM_Try, /*On fail goto*//*Label 30785*/ GIMT_Encode4(2427169), // Rule ID 57951 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57951,
      GIR_EraseRootFromParent_Done,
    // Label 30785: @2427169
    GIM_Reject,
    // Label 30733: @2427170
    GIM_Try, /*On fail goto*//*Label 30786*/ GIMT_Encode4(2427273),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30787*/ GIMT_Encode4(2427229), // Rule ID 58142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58142,
        GIR_EraseRootFromParent_Done,
      // Label 30787: @2427229
      GIM_Try, /*On fail goto*//*Label 30788*/ GIMT_Encode4(2427272), // Rule ID 58143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58143,
        GIR_EraseRootFromParent_Done,
      // Label 30788: @2427272
      GIM_Reject,
    // Label 30786: @2427273
    GIM_Reject,
    // Label 30734: @2427274
    GIM_Try, /*On fail goto*//*Label 30789*/ GIMT_Encode4(2427328), // Rule ID 57726 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57726,
      GIR_EraseRootFromParent_Done,
    // Label 30789: @2427328
    GIM_Try, /*On fail goto*//*Label 30790*/ GIMT_Encode4(2427382), // Rule ID 57727 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57727,
      GIR_EraseRootFromParent_Done,
    // Label 30790: @2427382
    GIM_Try, /*On fail goto*//*Label 30791*/ GIMT_Encode4(2427436), // Rule ID 58166 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58166,
      GIR_EraseRootFromParent_Done,
    // Label 30791: @2427436
    GIM_Try, /*On fail goto*//*Label 30792*/ GIMT_Encode4(2427490), // Rule ID 58167 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58167,
      GIR_EraseRootFromParent_Done,
    // Label 30792: @2427490
    GIM_Reject,
    // Label 30735: @2427491
    GIM_Try, /*On fail goto*//*Label 30793*/ GIMT_Encode4(2427545), // Rule ID 57738 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57738,
      GIR_EraseRootFromParent_Done,
    // Label 30793: @2427545
    GIM_Try, /*On fail goto*//*Label 30794*/ GIMT_Encode4(2427599), // Rule ID 57739 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57739,
      GIR_EraseRootFromParent_Done,
    // Label 30794: @2427599
    GIM_Try, /*On fail goto*//*Label 30795*/ GIMT_Encode4(2427653), // Rule ID 57934 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57934,
      GIR_EraseRootFromParent_Done,
    // Label 30795: @2427653
    GIM_Try, /*On fail goto*//*Label 30796*/ GIMT_Encode4(2427707), // Rule ID 57935 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57935,
      GIR_EraseRootFromParent_Done,
    // Label 30796: @2427707
    GIM_Try, /*On fail goto*//*Label 30797*/ GIMT_Encode4(2427761), // Rule ID 58186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58186,
      GIR_EraseRootFromParent_Done,
    // Label 30797: @2427761
    GIM_Try, /*On fail goto*//*Label 30798*/ GIMT_Encode4(2427815), // Rule ID 58187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58187,
      GIR_EraseRootFromParent_Done,
    // Label 30798: @2427815
    GIM_Reject,
    // Label 30736: @2427816
    GIM_Try, /*On fail goto*//*Label 30799*/ GIMT_Encode4(2427870), // Rule ID 57770 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57770,
      GIR_EraseRootFromParent_Done,
    // Label 30799: @2427870
    GIM_Try, /*On fail goto*//*Label 30800*/ GIMT_Encode4(2427924), // Rule ID 57771 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57771,
      GIR_EraseRootFromParent_Done,
    // Label 30800: @2427924
    GIM_Try, /*On fail goto*//*Label 30801*/ GIMT_Encode4(2427978), // Rule ID 57954 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57954,
      GIR_EraseRootFromParent_Done,
    // Label 30801: @2427978
    GIM_Try, /*On fail goto*//*Label 30802*/ GIMT_Encode4(2428032), // Rule ID 57955 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57955,
      GIR_EraseRootFromParent_Done,
    // Label 30802: @2428032
    GIM_Reject,
    // Label 30737: @2428033
    GIM_Try, /*On fail goto*//*Label 30803*/ GIMT_Encode4(2428136),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 30804*/ GIMT_Encode4(2428092), // Rule ID 58146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58146,
        GIR_EraseRootFromParent_Done,
      // Label 30804: @2428092
      GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2428135), // Rule ID 58147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58147,
        GIR_EraseRootFromParent_Done,
      // Label 30805: @2428135
      GIM_Reject,
    // Label 30803: @2428136
    GIM_Reject,
    // Label 30738: @2428137
    GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2428191), // Rule ID 57734 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57734,
      GIR_EraseRootFromParent_Done,
    // Label 30806: @2428191
    GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2428245), // Rule ID 57735 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57735,
      GIR_EraseRootFromParent_Done,
    // Label 30807: @2428245
    GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2428299), // Rule ID 58170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58170,
      GIR_EraseRootFromParent_Done,
    // Label 30808: @2428299
    GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2428353), // Rule ID 58171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58171,
      GIR_EraseRootFromParent_Done,
    // Label 30809: @2428353
    GIM_Reject,
    // Label 30739: @2428354
    GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2428408), // Rule ID 57758 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57758,
      GIR_EraseRootFromParent_Done,
    // Label 30810: @2428408
    GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2428462), // Rule ID 57759 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57759,
      GIR_EraseRootFromParent_Done,
    // Label 30811: @2428462
    GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2428516), // Rule ID 57938 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57938,
      GIR_EraseRootFromParent_Done,
    // Label 30812: @2428516
    GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2428570), // Rule ID 57939 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57939,
      GIR_EraseRootFromParent_Done,
    // Label 30813: @2428570
    GIM_Try, /*On fail goto*//*Label 30814*/ GIMT_Encode4(2428624), // Rule ID 58190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58190,
      GIR_EraseRootFromParent_Done,
    // Label 30814: @2428624
    GIM_Try, /*On fail goto*//*Label 30815*/ GIMT_Encode4(2428678), // Rule ID 58191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58191,
      GIR_EraseRootFromParent_Done,
    // Label 30815: @2428678
    GIM_Reject,
    // Label 30740: @2428679
    GIM_Try, /*On fail goto*//*Label 30816*/ GIMT_Encode4(2428733), // Rule ID 57774 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57774,
      GIR_EraseRootFromParent_Done,
    // Label 30816: @2428733
    GIM_Try, /*On fail goto*//*Label 30817*/ GIMT_Encode4(2428787), // Rule ID 57775 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57775,
      GIR_EraseRootFromParent_Done,
    // Label 30817: @2428787
    GIM_Try, /*On fail goto*//*Label 30818*/ GIMT_Encode4(2428841), // Rule ID 57958 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57958,
      GIR_EraseRootFromParent_Done,
    // Label 30818: @2428841
    GIM_Try, /*On fail goto*//*Label 30819*/ GIMT_Encode4(2428895), // Rule ID 57959 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57959,
      GIR_EraseRootFromParent_Done,
    // Label 30819: @2428895
    GIM_Reject,
    // Label 30741: @2428896
    GIM_Try, /*On fail goto*//*Label 30820*/ GIMT_Encode4(2428999),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 30821*/ GIMT_Encode4(2428955), // Rule ID 58150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58150,
        GIR_EraseRootFromParent_Done,
      // Label 30821: @2428955
      GIM_Try, /*On fail goto*//*Label 30822*/ GIMT_Encode4(2428998), // Rule ID 58151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58151,
        GIR_EraseRootFromParent_Done,
      // Label 30822: @2428998
      GIM_Reject,
    // Label 30820: @2428999
    GIM_Reject,
    // Label 30742: @2429000
    GIM_Try, /*On fail goto*//*Label 30823*/ GIMT_Encode4(2429054), // Rule ID 57746 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57746,
      GIR_EraseRootFromParent_Done,
    // Label 30823: @2429054
    GIM_Try, /*On fail goto*//*Label 30824*/ GIMT_Encode4(2429108), // Rule ID 57747 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57747,
      GIR_EraseRootFromParent_Done,
    // Label 30824: @2429108
    GIM_Try, /*On fail goto*//*Label 30825*/ GIMT_Encode4(2429162), // Rule ID 58174 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58174,
      GIR_EraseRootFromParent_Done,
    // Label 30825: @2429162
    GIM_Try, /*On fail goto*//*Label 30826*/ GIMT_Encode4(2429216), // Rule ID 58175 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58175,
      GIR_EraseRootFromParent_Done,
    // Label 30826: @2429216
    GIM_Reject,
    // Label 30743: @2429217
    GIM_Try, /*On fail goto*//*Label 30827*/ GIMT_Encode4(2429271), // Rule ID 57762 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57762,
      GIR_EraseRootFromParent_Done,
    // Label 30827: @2429271
    GIM_Try, /*On fail goto*//*Label 30828*/ GIMT_Encode4(2429325), // Rule ID 57763 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57763,
      GIR_EraseRootFromParent_Done,
    // Label 30828: @2429325
    GIM_Try, /*On fail goto*//*Label 30829*/ GIMT_Encode4(2429379), // Rule ID 57942 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57942,
      GIR_EraseRootFromParent_Done,
    // Label 30829: @2429379
    GIM_Try, /*On fail goto*//*Label 30830*/ GIMT_Encode4(2429433), // Rule ID 57943 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57943,
      GIR_EraseRootFromParent_Done,
    // Label 30830: @2429433
    GIM_Try, /*On fail goto*//*Label 30831*/ GIMT_Encode4(2429487), // Rule ID 58194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58194,
      GIR_EraseRootFromParent_Done,
    // Label 30831: @2429487
    GIM_Try, /*On fail goto*//*Label 30832*/ GIMT_Encode4(2429541), // Rule ID 58195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58195,
      GIR_EraseRootFromParent_Done,
    // Label 30832: @2429541
    GIM_Reject,
    // Label 30744: @2429542
    GIM_Try, /*On fail goto*//*Label 30833*/ GIMT_Encode4(2429596), // Rule ID 57778 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57778,
      GIR_EraseRootFromParent_Done,
    // Label 30833: @2429596
    GIM_Try, /*On fail goto*//*Label 30834*/ GIMT_Encode4(2429650), // Rule ID 57779 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57779,
      GIR_EraseRootFromParent_Done,
    // Label 30834: @2429650
    GIM_Try, /*On fail goto*//*Label 30835*/ GIMT_Encode4(2429704), // Rule ID 57962 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57962,
      GIR_EraseRootFromParent_Done,
    // Label 30835: @2429704
    GIM_Try, /*On fail goto*//*Label 30836*/ GIMT_Encode4(2429758), // Rule ID 57963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57963,
      GIR_EraseRootFromParent_Done,
    // Label 30836: @2429758
    GIM_Reject,
    // Label 30745: @2429759
    GIM_Try, /*On fail goto*//*Label 30837*/ GIMT_Encode4(2429862),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 30838*/ GIMT_Encode4(2429818), // Rule ID 58154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58154,
        GIR_EraseRootFromParent_Done,
      // Label 30838: @2429818
      GIM_Try, /*On fail goto*//*Label 30839*/ GIMT_Encode4(2429861), // Rule ID 58155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58155,
        GIR_EraseRootFromParent_Done,
      // Label 30839: @2429861
      GIM_Reject,
    // Label 30837: @2429862
    GIM_Reject,
    // Label 30746: @2429863
    GIM_Try, /*On fail goto*//*Label 30840*/ GIMT_Encode4(2429917), // Rule ID 57750 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57750,
      GIR_EraseRootFromParent_Done,
    // Label 30840: @2429917
    GIM_Try, /*On fail goto*//*Label 30841*/ GIMT_Encode4(2429971), // Rule ID 57751 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57751,
      GIR_EraseRootFromParent_Done,
    // Label 30841: @2429971
    GIM_Try, /*On fail goto*//*Label 30842*/ GIMT_Encode4(2430025), // Rule ID 58178 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58178,
      GIR_EraseRootFromParent_Done,
    // Label 30842: @2430025
    GIM_Try, /*On fail goto*//*Label 30843*/ GIMT_Encode4(2430079), // Rule ID 58179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58179,
      GIR_EraseRootFromParent_Done,
    // Label 30843: @2430079
    GIM_Reject,
    // Label 30747: @2430080
    GIM_Try, /*On fail goto*//*Label 30844*/ GIMT_Encode4(2430134), // Rule ID 57766 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57766,
      GIR_EraseRootFromParent_Done,
    // Label 30844: @2430134
    GIM_Try, /*On fail goto*//*Label 30845*/ GIMT_Encode4(2430188), // Rule ID 57767 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57767,
      GIR_EraseRootFromParent_Done,
    // Label 30845: @2430188
    GIM_Try, /*On fail goto*//*Label 30846*/ GIMT_Encode4(2430242), // Rule ID 57946 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57946,
      GIR_EraseRootFromParent_Done,
    // Label 30846: @2430242
    GIM_Try, /*On fail goto*//*Label 30847*/ GIMT_Encode4(2430296), // Rule ID 57947 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57947,
      GIR_EraseRootFromParent_Done,
    // Label 30847: @2430296
    GIM_Reject,
    // Label 30748: @2430297
    GIM_Try, /*On fail goto*//*Label 30848*/ GIMT_Encode4(2430400),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30849*/ GIMT_Encode4(2430356), // Rule ID 58158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58158,
        GIR_EraseRootFromParent_Done,
      // Label 30849: @2430356
      GIM_Try, /*On fail goto*//*Label 30850*/ GIMT_Encode4(2430399), // Rule ID 58159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58159,
        GIR_EraseRootFromParent_Done,
      // Label 30850: @2430399
      GIM_Reject,
    // Label 30848: @2430400
    GIM_Reject,
    // Label 30749: @2430401
    GIM_Try, /*On fail goto*//*Label 30851*/ GIMT_Encode4(2430504),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 30852*/ GIMT_Encode4(2430460), // Rule ID 57754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
        // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57754,
        GIR_EraseRootFromParent_Done,
      // Label 30852: @2430460
      GIM_Try, /*On fail goto*//*Label 30853*/ GIMT_Encode4(2430503), // Rule ID 57755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
        // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57755,
        GIR_EraseRootFromParent_Done,
      // Label 30853: @2430503
      GIM_Reject,
    // Label 30851: @2430504
    GIM_Reject,
    // Label 30750: @2430505
    GIM_Reject,
    // Label 67: @2430506
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30872*/ GIMT_Encode4(2435791),
    /*GILLT_s16*//*Label 30854*/ GIMT_Encode4(2430637),
    /*GILLT_s32*//*Label 30855*/ GIMT_Encode4(2430898),
    /*GILLT_s64*//*Label 30856*/ GIMT_Encode4(2431159), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 30857*/ GIMT_Encode4(2431420),
    /*GILLT_nxv1s32*//*Label 30858*/ GIMT_Encode4(2431757),
    /*GILLT_nxv1s64*//*Label 30859*/ GIMT_Encode4(2432094), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 30860*/ GIMT_Encode4(2432317),
    /*GILLT_nxv2s32*//*Label 30861*/ GIMT_Encode4(2432654),
    /*GILLT_nxv2s64*//*Label 30862*/ GIMT_Encode4(2432991), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 30863*/ GIMT_Encode4(2433214),
    /*GILLT_nxv4s32*//*Label 30864*/ GIMT_Encode4(2433551),
    /*GILLT_nxv4s64*//*Label 30865*/ GIMT_Encode4(2433888), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 30866*/ GIMT_Encode4(2434111),
    /*GILLT_nxv8s32*//*Label 30867*/ GIMT_Encode4(2434448),
    /*GILLT_nxv8s64*//*Label 30868*/ GIMT_Encode4(2434785), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 30869*/ GIMT_Encode4(2435008),
    /*GILLT_nxv16s32*//*Label 30870*/ GIMT_Encode4(2435345), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 30871*/ GIMT_Encode4(2435568),
    // Label 30854: @2430637
    GIM_Try, /*On fail goto*//*Label 30873*/ GIMT_Encode4(2430674), // Rule ID 2119 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
      // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2119,
      GIR_EraseRootFromParent_Done,
    // Label 30873: @2430674
    GIM_Try, /*On fail goto*//*Label 30874*/ GIMT_Encode4(2430711), // Rule ID 2145 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
      // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2145,
      GIR_EraseRootFromParent_Done,
    // Label 30874: @2430711
    GIM_Try, /*On fail goto*//*Label 30875*/ GIMT_Encode4(2430742), // Rule ID 2068 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2068,
      GIR_EraseRootFromParent_Done,
    // Label 30875: @2430742
    GIM_Try, /*On fail goto*//*Label 30876*/ GIMT_Encode4(2430773), // Rule ID 2069 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2069,
      GIR_EraseRootFromParent_Done,
    // Label 30876: @2430773
    GIM_Try, /*On fail goto*//*Label 30877*/ GIMT_Encode4(2430804), // Rule ID 2094 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2094,
      GIR_EraseRootFromParent_Done,
    // Label 30877: @2430804
    GIM_Try, /*On fail goto*//*Label 30878*/ GIMT_Encode4(2430835), // Rule ID 2095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2095,
      GIR_EraseRootFromParent_Done,
    // Label 30878: @2430835
    GIM_Try, /*On fail goto*//*Label 30879*/ GIMT_Encode4(2430866), // Rule ID 2123 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2123,
      GIR_EraseRootFromParent_Done,
    // Label 30879: @2430866
    GIM_Try, /*On fail goto*//*Label 30880*/ GIMT_Encode4(2430897), // Rule ID 2149 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2149,
      GIR_EraseRootFromParent_Done,
    // Label 30880: @2430897
    GIM_Reject,
    // Label 30855: @2430898
    GIM_Try, /*On fail goto*//*Label 30881*/ GIMT_Encode4(2430935), // Rule ID 1385 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
      // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1385,
      GIR_EraseRootFromParent_Done,
    // Label 30881: @2430935
    GIM_Try, /*On fail goto*//*Label 30882*/ GIMT_Encode4(2430972), // Rule ID 1413 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
      // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1413,
      GIR_EraseRootFromParent_Done,
    // Label 30882: @2430972
    GIM_Try, /*On fail goto*//*Label 30883*/ GIMT_Encode4(2431003), // Rule ID 1332 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1332,
      GIR_EraseRootFromParent_Done,
    // Label 30883: @2431003
    GIM_Try, /*On fail goto*//*Label 30884*/ GIMT_Encode4(2431034), // Rule ID 1333 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1333,
      GIR_EraseRootFromParent_Done,
    // Label 30884: @2431034
    GIM_Try, /*On fail goto*//*Label 30885*/ GIMT_Encode4(2431065), // Rule ID 1358 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1358,
      GIR_EraseRootFromParent_Done,
    // Label 30885: @2431065
    GIM_Try, /*On fail goto*//*Label 30886*/ GIMT_Encode4(2431096), // Rule ID 1359 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1359,
      GIR_EraseRootFromParent_Done,
    // Label 30886: @2431096
    GIM_Try, /*On fail goto*//*Label 30887*/ GIMT_Encode4(2431127), // Rule ID 1389 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1389,
      GIR_EraseRootFromParent_Done,
    // Label 30887: @2431127
    GIM_Try, /*On fail goto*//*Label 30888*/ GIMT_Encode4(2431158), // Rule ID 1417 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1417,
      GIR_EraseRootFromParent_Done,
    // Label 30888: @2431158
    GIM_Reject,
    // Label 30856: @2431159
    GIM_Try, /*On fail goto*//*Label 30889*/ GIMT_Encode4(2431196), // Rule ID 1765 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
      // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1765,
      GIR_EraseRootFromParent_Done,
    // Label 30889: @2431196
    GIM_Try, /*On fail goto*//*Label 30890*/ GIMT_Encode4(2431233), // Rule ID 1793 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
      // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1793,
      GIR_EraseRootFromParent_Done,
    // Label 30890: @2431233
    GIM_Try, /*On fail goto*//*Label 30891*/ GIMT_Encode4(2431264), // Rule ID 1726 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1726,
      GIR_EraseRootFromParent_Done,
    // Label 30891: @2431264
    GIM_Try, /*On fail goto*//*Label 30892*/ GIMT_Encode4(2431295), // Rule ID 1727 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1727,
      GIR_EraseRootFromParent_Done,
    // Label 30892: @2431295
    GIM_Try, /*On fail goto*//*Label 30893*/ GIMT_Encode4(2431326), // Rule ID 1752 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1752,
      GIR_EraseRootFromParent_Done,
    // Label 30893: @2431326
    GIM_Try, /*On fail goto*//*Label 30894*/ GIMT_Encode4(2431357), // Rule ID 1753 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1753,
      GIR_EraseRootFromParent_Done,
    // Label 30894: @2431357
    GIM_Try, /*On fail goto*//*Label 30895*/ GIMT_Encode4(2431388), // Rule ID 1783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1783,
      GIR_EraseRootFromParent_Done,
    // Label 30895: @2431388
    GIM_Try, /*On fail goto*//*Label 30896*/ GIMT_Encode4(2431419), // Rule ID 1811 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1811,
      GIR_EraseRootFromParent_Done,
    // Label 30896: @2431419
    GIM_Reject,
    // Label 30857: @2431420
    GIM_Try, /*On fail goto*//*Label 30897*/ GIMT_Encode4(2431477), // Rule ID 45586 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45586,
      GIR_EraseRootFromParent_Done,
    // Label 30897: @2431477
    GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2431534), // Rule ID 45587 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45587,
      GIR_EraseRootFromParent_Done,
    // Label 30898: @2431534
    GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2431588), // Rule ID 45594 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45594,
      GIR_EraseRootFromParent_Done,
    // Label 30899: @2431588
    GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2431642), // Rule ID 45595 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45595,
      GIR_EraseRootFromParent_Done,
    // Label 30900: @2431642
    GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2431699), // Rule ID 45602 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45602,
      GIR_EraseRootFromParent_Done,
    // Label 30901: @2431699
    GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2431756), // Rule ID 45603 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 45603,
      GIR_EraseRootFromParent_Done,
    // Label 30902: @2431756
    GIM_Reject,
    // Label 30858: @2431757
    GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2431814), // Rule ID 57786 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57786,
      GIR_EraseRootFromParent_Done,
    // Label 30903: @2431814
    GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2431871), // Rule ID 57787 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57787,
      GIR_EraseRootFromParent_Done,
    // Label 30904: @2431871
    GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2431925), // Rule ID 57986 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57986,
      GIR_EraseRootFromParent_Done,
    // Label 30905: @2431925
    GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2431979), // Rule ID 57987 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57987,
      GIR_EraseRootFromParent_Done,
    // Label 30906: @2431979
    GIM_Try, /*On fail goto*//*Label 30907*/ GIMT_Encode4(2432036), // Rule ID 58214 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58214,
      GIR_EraseRootFromParent_Done,
    // Label 30907: @2432036
    GIM_Try, /*On fail goto*//*Label 30908*/ GIMT_Encode4(2432093), // Rule ID 58215 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58215,
      GIR_EraseRootFromParent_Done,
    // Label 30908: @2432093
    GIM_Reject,
    // Label 30859: @2432094
    GIM_Try, /*On fail goto*//*Label 30909*/ GIMT_Encode4(2432151), // Rule ID 57798 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57798,
      GIR_EraseRootFromParent_Done,
    // Label 30909: @2432151
    GIM_Try, /*On fail goto*//*Label 30910*/ GIMT_Encode4(2432208), // Rule ID 57799 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57799,
      GIR_EraseRootFromParent_Done,
    // Label 30910: @2432208
    GIM_Try, /*On fail goto*//*Label 30911*/ GIMT_Encode4(2432262), // Rule ID 58006 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58006,
      GIR_EraseRootFromParent_Done,
    // Label 30911: @2432262
    GIM_Try, /*On fail goto*//*Label 30912*/ GIMT_Encode4(2432316), // Rule ID 58007 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58007,
      GIR_EraseRootFromParent_Done,
    // Label 30912: @2432316
    GIM_Reject,
    // Label 30860: @2432317
    GIM_Try, /*On fail goto*//*Label 30913*/ GIMT_Encode4(2432374), // Rule ID 57782 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57782,
      GIR_EraseRootFromParent_Done,
    // Label 30913: @2432374
    GIM_Try, /*On fail goto*//*Label 30914*/ GIMT_Encode4(2432431), // Rule ID 57783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57783,
      GIR_EraseRootFromParent_Done,
    // Label 30914: @2432431
    GIM_Try, /*On fail goto*//*Label 30915*/ GIMT_Encode4(2432485), // Rule ID 57966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57966,
      GIR_EraseRootFromParent_Done,
    // Label 30915: @2432485
    GIM_Try, /*On fail goto*//*Label 30916*/ GIMT_Encode4(2432539), // Rule ID 57967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57967,
      GIR_EraseRootFromParent_Done,
    // Label 30916: @2432539
    GIM_Try, /*On fail goto*//*Label 30917*/ GIMT_Encode4(2432596), // Rule ID 58198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58198,
      GIR_EraseRootFromParent_Done,
    // Label 30917: @2432596
    GIM_Try, /*On fail goto*//*Label 30918*/ GIMT_Encode4(2432653), // Rule ID 58199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58199,
      GIR_EraseRootFromParent_Done,
    // Label 30918: @2432653
    GIM_Reject,
    // Label 30861: @2432654
    GIM_Try, /*On fail goto*//*Label 30919*/ GIMT_Encode4(2432711), // Rule ID 57794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57794,
      GIR_EraseRootFromParent_Done,
    // Label 30919: @2432711
    GIM_Try, /*On fail goto*//*Label 30920*/ GIMT_Encode4(2432768), // Rule ID 57795 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57795,
      GIR_EraseRootFromParent_Done,
    // Label 30920: @2432768
    GIM_Try, /*On fail goto*//*Label 30921*/ GIMT_Encode4(2432822), // Rule ID 57990 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57990,
      GIR_EraseRootFromParent_Done,
    // Label 30921: @2432822
    GIM_Try, /*On fail goto*//*Label 30922*/ GIMT_Encode4(2432876), // Rule ID 57991 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57991,
      GIR_EraseRootFromParent_Done,
    // Label 30922: @2432876
    GIM_Try, /*On fail goto*//*Label 30923*/ GIMT_Encode4(2432933), // Rule ID 58218 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58218,
      GIR_EraseRootFromParent_Done,
    // Label 30923: @2432933
    GIM_Try, /*On fail goto*//*Label 30924*/ GIMT_Encode4(2432990), // Rule ID 58219 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58219,
      GIR_EraseRootFromParent_Done,
    // Label 30924: @2432990
    GIM_Reject,
    // Label 30862: @2432991
    GIM_Try, /*On fail goto*//*Label 30925*/ GIMT_Encode4(2433048), // Rule ID 57826 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57826,
      GIR_EraseRootFromParent_Done,
    // Label 30925: @2433048
    GIM_Try, /*On fail goto*//*Label 30926*/ GIMT_Encode4(2433105), // Rule ID 57827 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57827,
      GIR_EraseRootFromParent_Done,
    // Label 30926: @2433105
    GIM_Try, /*On fail goto*//*Label 30927*/ GIMT_Encode4(2433159), // Rule ID 58010 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58010,
      GIR_EraseRootFromParent_Done,
    // Label 30927: @2433159
    GIM_Try, /*On fail goto*//*Label 30928*/ GIMT_Encode4(2433213), // Rule ID 58011 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58011,
      GIR_EraseRootFromParent_Done,
    // Label 30928: @2433213
    GIM_Reject,
    // Label 30863: @2433214
    GIM_Try, /*On fail goto*//*Label 30929*/ GIMT_Encode4(2433271), // Rule ID 57790 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57790,
      GIR_EraseRootFromParent_Done,
    // Label 30929: @2433271
    GIM_Try, /*On fail goto*//*Label 30930*/ GIMT_Encode4(2433328), // Rule ID 57791 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57791,
      GIR_EraseRootFromParent_Done,
    // Label 30930: @2433328
    GIM_Try, /*On fail goto*//*Label 30931*/ GIMT_Encode4(2433382), // Rule ID 57970 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57970,
      GIR_EraseRootFromParent_Done,
    // Label 30931: @2433382
    GIM_Try, /*On fail goto*//*Label 30932*/ GIMT_Encode4(2433436), // Rule ID 57971 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57971,
      GIR_EraseRootFromParent_Done,
    // Label 30932: @2433436
    GIM_Try, /*On fail goto*//*Label 30933*/ GIMT_Encode4(2433493), // Rule ID 58202 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58202,
      GIR_EraseRootFromParent_Done,
    // Label 30933: @2433493
    GIM_Try, /*On fail goto*//*Label 30934*/ GIMT_Encode4(2433550), // Rule ID 58203 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58203,
      GIR_EraseRootFromParent_Done,
    // Label 30934: @2433550
    GIM_Reject,
    // Label 30864: @2433551
    GIM_Try, /*On fail goto*//*Label 30935*/ GIMT_Encode4(2433608), // Rule ID 57814 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57814,
      GIR_EraseRootFromParent_Done,
    // Label 30935: @2433608
    GIM_Try, /*On fail goto*//*Label 30936*/ GIMT_Encode4(2433665), // Rule ID 57815 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57815,
      GIR_EraseRootFromParent_Done,
    // Label 30936: @2433665
    GIM_Try, /*On fail goto*//*Label 30937*/ GIMT_Encode4(2433719), // Rule ID 57994 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57994,
      GIR_EraseRootFromParent_Done,
    // Label 30937: @2433719
    GIM_Try, /*On fail goto*//*Label 30938*/ GIMT_Encode4(2433773), // Rule ID 57995 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57995,
      GIR_EraseRootFromParent_Done,
    // Label 30938: @2433773
    GIM_Try, /*On fail goto*//*Label 30939*/ GIMT_Encode4(2433830), // Rule ID 58222 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58222,
      GIR_EraseRootFromParent_Done,
    // Label 30939: @2433830
    GIM_Try, /*On fail goto*//*Label 30940*/ GIMT_Encode4(2433887), // Rule ID 58223 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58223,
      GIR_EraseRootFromParent_Done,
    // Label 30940: @2433887
    GIM_Reject,
    // Label 30865: @2433888
    GIM_Try, /*On fail goto*//*Label 30941*/ GIMT_Encode4(2433945), // Rule ID 57830 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57830,
      GIR_EraseRootFromParent_Done,
    // Label 30941: @2433945
    GIM_Try, /*On fail goto*//*Label 30942*/ GIMT_Encode4(2434002), // Rule ID 57831 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57831,
      GIR_EraseRootFromParent_Done,
    // Label 30942: @2434002
    GIM_Try, /*On fail goto*//*Label 30943*/ GIMT_Encode4(2434056), // Rule ID 58014 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58014,
      GIR_EraseRootFromParent_Done,
    // Label 30943: @2434056
    GIM_Try, /*On fail goto*//*Label 30944*/ GIMT_Encode4(2434110), // Rule ID 58015 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58015,
      GIR_EraseRootFromParent_Done,
    // Label 30944: @2434110
    GIM_Reject,
    // Label 30866: @2434111
    GIM_Try, /*On fail goto*//*Label 30945*/ GIMT_Encode4(2434168), // Rule ID 57802 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57802,
      GIR_EraseRootFromParent_Done,
    // Label 30945: @2434168
    GIM_Try, /*On fail goto*//*Label 30946*/ GIMT_Encode4(2434225), // Rule ID 57803 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57803,
      GIR_EraseRootFromParent_Done,
    // Label 30946: @2434225
    GIM_Try, /*On fail goto*//*Label 30947*/ GIMT_Encode4(2434279), // Rule ID 57974 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57974,
      GIR_EraseRootFromParent_Done,
    // Label 30947: @2434279
    GIM_Try, /*On fail goto*//*Label 30948*/ GIMT_Encode4(2434333), // Rule ID 57975 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57975,
      GIR_EraseRootFromParent_Done,
    // Label 30948: @2434333
    GIM_Try, /*On fail goto*//*Label 30949*/ GIMT_Encode4(2434390), // Rule ID 58206 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58206,
      GIR_EraseRootFromParent_Done,
    // Label 30949: @2434390
    GIM_Try, /*On fail goto*//*Label 30950*/ GIMT_Encode4(2434447), // Rule ID 58207 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58207,
      GIR_EraseRootFromParent_Done,
    // Label 30950: @2434447
    GIM_Reject,
    // Label 30867: @2434448
    GIM_Try, /*On fail goto*//*Label 30951*/ GIMT_Encode4(2434505), // Rule ID 57818 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57818,
      GIR_EraseRootFromParent_Done,
    // Label 30951: @2434505
    GIM_Try, /*On fail goto*//*Label 30952*/ GIMT_Encode4(2434562), // Rule ID 57819 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57819,
      GIR_EraseRootFromParent_Done,
    // Label 30952: @2434562
    GIM_Try, /*On fail goto*//*Label 30953*/ GIMT_Encode4(2434616), // Rule ID 57998 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57998,
      GIR_EraseRootFromParent_Done,
    // Label 30953: @2434616
    GIM_Try, /*On fail goto*//*Label 30954*/ GIMT_Encode4(2434670), // Rule ID 57999 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57999,
      GIR_EraseRootFromParent_Done,
    // Label 30954: @2434670
    GIM_Try, /*On fail goto*//*Label 30955*/ GIMT_Encode4(2434727), // Rule ID 58226 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58226,
      GIR_EraseRootFromParent_Done,
    // Label 30955: @2434727
    GIM_Try, /*On fail goto*//*Label 30956*/ GIMT_Encode4(2434784), // Rule ID 58227 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58227,
      GIR_EraseRootFromParent_Done,
    // Label 30956: @2434784
    GIM_Reject,
    // Label 30868: @2434785
    GIM_Try, /*On fail goto*//*Label 30957*/ GIMT_Encode4(2434842), // Rule ID 57834 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57834,
      GIR_EraseRootFromParent_Done,
    // Label 30957: @2434842
    GIM_Try, /*On fail goto*//*Label 30958*/ GIMT_Encode4(2434899), // Rule ID 57835 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57835,
      GIR_EraseRootFromParent_Done,
    // Label 30958: @2434899
    GIM_Try, /*On fail goto*//*Label 30959*/ GIMT_Encode4(2434953), // Rule ID 58018 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58018,
      GIR_EraseRootFromParent_Done,
    // Label 30959: @2434953
    GIM_Try, /*On fail goto*//*Label 30960*/ GIMT_Encode4(2435007), // Rule ID 58019 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58019,
      GIR_EraseRootFromParent_Done,
    // Label 30960: @2435007
    GIM_Reject,
    // Label 30869: @2435008
    GIM_Try, /*On fail goto*//*Label 30961*/ GIMT_Encode4(2435065), // Rule ID 57806 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57806,
      GIR_EraseRootFromParent_Done,
    // Label 30961: @2435065
    GIM_Try, /*On fail goto*//*Label 30962*/ GIMT_Encode4(2435122), // Rule ID 57807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57807,
      GIR_EraseRootFromParent_Done,
    // Label 30962: @2435122
    GIM_Try, /*On fail goto*//*Label 30963*/ GIMT_Encode4(2435176), // Rule ID 57978 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57978,
      GIR_EraseRootFromParent_Done,
    // Label 30963: @2435176
    GIM_Try, /*On fail goto*//*Label 30964*/ GIMT_Encode4(2435230), // Rule ID 57979 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57979,
      GIR_EraseRootFromParent_Done,
    // Label 30964: @2435230
    GIM_Try, /*On fail goto*//*Label 30965*/ GIMT_Encode4(2435287), // Rule ID 58210 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58210,
      GIR_EraseRootFromParent_Done,
    // Label 30965: @2435287
    GIM_Try, /*On fail goto*//*Label 30966*/ GIMT_Encode4(2435344), // Rule ID 58211 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58211,
      GIR_EraseRootFromParent_Done,
    // Label 30966: @2435344
    GIM_Reject,
    // Label 30870: @2435345
    GIM_Try, /*On fail goto*//*Label 30967*/ GIMT_Encode4(2435402), // Rule ID 57822 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57822,
      GIR_EraseRootFromParent_Done,
    // Label 30967: @2435402
    GIM_Try, /*On fail goto*//*Label 30968*/ GIMT_Encode4(2435459), // Rule ID 57823 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57823,
      GIR_EraseRootFromParent_Done,
    // Label 30968: @2435459
    GIM_Try, /*On fail goto*//*Label 30969*/ GIMT_Encode4(2435513), // Rule ID 58002 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58002,
      GIR_EraseRootFromParent_Done,
    // Label 30969: @2435513
    GIM_Try, /*On fail goto*//*Label 30970*/ GIMT_Encode4(2435567), // Rule ID 58003 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58003,
      GIR_EraseRootFromParent_Done,
    // Label 30970: @2435567
    GIM_Reject,
    // Label 30871: @2435568
    GIM_Try, /*On fail goto*//*Label 30971*/ GIMT_Encode4(2435625), // Rule ID 57810 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57810,
      GIR_EraseRootFromParent_Done,
    // Label 30971: @2435625
    GIM_Try, /*On fail goto*//*Label 30972*/ GIMT_Encode4(2435682), // Rule ID 57811 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57811,
      GIR_EraseRootFromParent_Done,
    // Label 30972: @2435682
    GIM_Try, /*On fail goto*//*Label 30973*/ GIMT_Encode4(2435736), // Rule ID 57982 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57982,
      GIR_EraseRootFromParent_Done,
    // Label 30973: @2435736
    GIM_Try, /*On fail goto*//*Label 30974*/ GIMT_Encode4(2435790), // Rule ID 57983 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57983,
      GIR_EraseRootFromParent_Done,
    // Label 30974: @2435790
    GIM_Reject,
    // Label 30872: @2435791
    GIM_Reject,
    // Label 68: @2435792
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 30993*/ GIMT_Encode4(2441077),
    /*GILLT_s16*//*Label 30975*/ GIMT_Encode4(2435923),
    /*GILLT_s32*//*Label 30976*/ GIMT_Encode4(2436184),
    /*GILLT_s64*//*Label 30977*/ GIMT_Encode4(2436445), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 30978*/ GIMT_Encode4(2436706),
    /*GILLT_nxv1s32*//*Label 30979*/ GIMT_Encode4(2437043),
    /*GILLT_nxv1s64*//*Label 30980*/ GIMT_Encode4(2437380), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 30981*/ GIMT_Encode4(2437603),
    /*GILLT_nxv2s32*//*Label 30982*/ GIMT_Encode4(2437940),
    /*GILLT_nxv2s64*//*Label 30983*/ GIMT_Encode4(2438277), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 30984*/ GIMT_Encode4(2438500),
    /*GILLT_nxv4s32*//*Label 30985*/ GIMT_Encode4(2438837),
    /*GILLT_nxv4s64*//*Label 30986*/ GIMT_Encode4(2439174), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 30987*/ GIMT_Encode4(2439397),
    /*GILLT_nxv8s32*//*Label 30988*/ GIMT_Encode4(2439734),
    /*GILLT_nxv8s64*//*Label 30989*/ GIMT_Encode4(2440071), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 30990*/ GIMT_Encode4(2440294),
    /*GILLT_nxv16s32*//*Label 30991*/ GIMT_Encode4(2440631), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 30992*/ GIMT_Encode4(2440854),
    // Label 30975: @2435923
    GIM_Try, /*On fail goto*//*Label 30994*/ GIMT_Encode4(2435960), // Rule ID 2121 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
      // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2121,
      GIR_EraseRootFromParent_Done,
    // Label 30994: @2435960
    GIM_Try, /*On fail goto*//*Label 30995*/ GIMT_Encode4(2435997), // Rule ID 2147 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
      // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2147,
      GIR_EraseRootFromParent_Done,
    // Label 30995: @2435997
    GIM_Try, /*On fail goto*//*Label 30996*/ GIMT_Encode4(2436028), // Rule ID 2072 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2072,
      GIR_EraseRootFromParent_Done,
    // Label 30996: @2436028
    GIM_Try, /*On fail goto*//*Label 30997*/ GIMT_Encode4(2436059), // Rule ID 2073 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2073,
      GIR_EraseRootFromParent_Done,
    // Label 30997: @2436059
    GIM_Try, /*On fail goto*//*Label 30998*/ GIMT_Encode4(2436090), // Rule ID 2098 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2098,
      GIR_EraseRootFromParent_Done,
    // Label 30998: @2436090
    GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2436121), // Rule ID 2099 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2099,
      GIR_EraseRootFromParent_Done,
    // Label 30999: @2436121
    GIM_Try, /*On fail goto*//*Label 31000*/ GIMT_Encode4(2436152), // Rule ID 2125 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2125,
      GIR_EraseRootFromParent_Done,
    // Label 31000: @2436152
    GIM_Try, /*On fail goto*//*Label 31001*/ GIMT_Encode4(2436183), // Rule ID 2151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2151,
      GIR_EraseRootFromParent_Done,
    // Label 31001: @2436183
    GIM_Reject,
    // Label 30976: @2436184
    GIM_Try, /*On fail goto*//*Label 31002*/ GIMT_Encode4(2436221), // Rule ID 1387 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
      // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1387,
      GIR_EraseRootFromParent_Done,
    // Label 31002: @2436221
    GIM_Try, /*On fail goto*//*Label 31003*/ GIMT_Encode4(2436258), // Rule ID 1415 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
      // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1415,
      GIR_EraseRootFromParent_Done,
    // Label 31003: @2436258
    GIM_Try, /*On fail goto*//*Label 31004*/ GIMT_Encode4(2436289), // Rule ID 1336 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1336,
      GIR_EraseRootFromParent_Done,
    // Label 31004: @2436289
    GIM_Try, /*On fail goto*//*Label 31005*/ GIMT_Encode4(2436320), // Rule ID 1337 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1337,
      GIR_EraseRootFromParent_Done,
    // Label 31005: @2436320
    GIM_Try, /*On fail goto*//*Label 31006*/ GIMT_Encode4(2436351), // Rule ID 1362 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1362,
      GIR_EraseRootFromParent_Done,
    // Label 31006: @2436351
    GIM_Try, /*On fail goto*//*Label 31007*/ GIMT_Encode4(2436382), // Rule ID 1363 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1363,
      GIR_EraseRootFromParent_Done,
    // Label 31007: @2436382
    GIM_Try, /*On fail goto*//*Label 31008*/ GIMT_Encode4(2436413), // Rule ID 1391 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1391,
      GIR_EraseRootFromParent_Done,
    // Label 31008: @2436413
    GIM_Try, /*On fail goto*//*Label 31009*/ GIMT_Encode4(2436444), // Rule ID 1419 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1419,
      GIR_EraseRootFromParent_Done,
    // Label 31009: @2436444
    GIM_Reject,
    // Label 30977: @2436445
    GIM_Try, /*On fail goto*//*Label 31010*/ GIMT_Encode4(2436482), // Rule ID 1767 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
      // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1767,
      GIR_EraseRootFromParent_Done,
    // Label 31010: @2436482
    GIM_Try, /*On fail goto*//*Label 31011*/ GIMT_Encode4(2436519), // Rule ID 1795 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
      // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1795,
      GIR_EraseRootFromParent_Done,
    // Label 31011: @2436519
    GIM_Try, /*On fail goto*//*Label 31012*/ GIMT_Encode4(2436550), // Rule ID 1730 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1730,
      GIR_EraseRootFromParent_Done,
    // Label 31012: @2436550
    GIM_Try, /*On fail goto*//*Label 31013*/ GIMT_Encode4(2436581), // Rule ID 1731 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1731,
      GIR_EraseRootFromParent_Done,
    // Label 31013: @2436581
    GIM_Try, /*On fail goto*//*Label 31014*/ GIMT_Encode4(2436612), // Rule ID 1756 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1756,
      GIR_EraseRootFromParent_Done,
    // Label 31014: @2436612
    GIM_Try, /*On fail goto*//*Label 31015*/ GIMT_Encode4(2436643), // Rule ID 1757 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1757,
      GIR_EraseRootFromParent_Done,
    // Label 31015: @2436643
    GIM_Try, /*On fail goto*//*Label 31016*/ GIMT_Encode4(2436674), // Rule ID 1785 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1785,
      GIR_EraseRootFromParent_Done,
    // Label 31016: @2436674
    GIM_Try, /*On fail goto*//*Label 31017*/ GIMT_Encode4(2436705), // Rule ID 1813 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1813,
      GIR_EraseRootFromParent_Done,
    // Label 31017: @2436705
    GIM_Reject,
    // Label 30978: @2436706
    GIM_Try, /*On fail goto*//*Label 31018*/ GIMT_Encode4(2436763), // Rule ID 57838 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57838,
      GIR_EraseRootFromParent_Done,
    // Label 31018: @2436763
    GIM_Try, /*On fail goto*//*Label 31019*/ GIMT_Encode4(2436820), // Rule ID 57839 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57839,
      GIR_EraseRootFromParent_Done,
    // Label 31019: @2436820
    GIM_Try, /*On fail goto*//*Label 31020*/ GIMT_Encode4(2436874), // Rule ID 58022 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58022,
      GIR_EraseRootFromParent_Done,
    // Label 31020: @2436874
    GIM_Try, /*On fail goto*//*Label 31021*/ GIMT_Encode4(2436928), // Rule ID 58023 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58023,
      GIR_EraseRootFromParent_Done,
    // Label 31021: @2436928
    GIM_Try, /*On fail goto*//*Label 31022*/ GIMT_Encode4(2436985), // Rule ID 58230 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58230,
      GIR_EraseRootFromParent_Done,
    // Label 31022: @2436985
    GIM_Try, /*On fail goto*//*Label 31023*/ GIMT_Encode4(2437042), // Rule ID 58231 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58231,
      GIR_EraseRootFromParent_Done,
    // Label 31023: @2437042
    GIM_Reject,
    // Label 30979: @2437043
    GIM_Try, /*On fail goto*//*Label 31024*/ GIMT_Encode4(2437100), // Rule ID 57846 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57846,
      GIR_EraseRootFromParent_Done,
    // Label 31024: @2437100
    GIM_Try, /*On fail goto*//*Label 31025*/ GIMT_Encode4(2437157), // Rule ID 57847 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57847,
      GIR_EraseRootFromParent_Done,
    // Label 31025: @2437157
    GIM_Try, /*On fail goto*//*Label 31026*/ GIMT_Encode4(2437211), // Rule ID 58046 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58046,
      GIR_EraseRootFromParent_Done,
    // Label 31026: @2437211
    GIM_Try, /*On fail goto*//*Label 31027*/ GIMT_Encode4(2437265), // Rule ID 58047 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58047,
      GIR_EraseRootFromParent_Done,
    // Label 31027: @2437265
    GIM_Try, /*On fail goto*//*Label 31028*/ GIMT_Encode4(2437322), // Rule ID 58250 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58250,
      GIR_EraseRootFromParent_Done,
    // Label 31028: @2437322
    GIM_Try, /*On fail goto*//*Label 31029*/ GIMT_Encode4(2437379), // Rule ID 58251 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58251,
      GIR_EraseRootFromParent_Done,
    // Label 31029: @2437379
    GIM_Reject,
    // Label 30980: @2437380
    GIM_Try, /*On fail goto*//*Label 31030*/ GIMT_Encode4(2437437), // Rule ID 57858 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57858,
      GIR_EraseRootFromParent_Done,
    // Label 31030: @2437437
    GIM_Try, /*On fail goto*//*Label 31031*/ GIMT_Encode4(2437494), // Rule ID 57859 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57859,
      GIR_EraseRootFromParent_Done,
    // Label 31031: @2437494
    GIM_Try, /*On fail goto*//*Label 31032*/ GIMT_Encode4(2437548), // Rule ID 58066 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58066,
      GIR_EraseRootFromParent_Done,
    // Label 31032: @2437548
    GIM_Try, /*On fail goto*//*Label 31033*/ GIMT_Encode4(2437602), // Rule ID 58067 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58067,
      GIR_EraseRootFromParent_Done,
    // Label 31033: @2437602
    GIM_Reject,
    // Label 30981: @2437603
    GIM_Try, /*On fail goto*//*Label 31034*/ GIMT_Encode4(2437660), // Rule ID 57842 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57842,
      GIR_EraseRootFromParent_Done,
    // Label 31034: @2437660
    GIM_Try, /*On fail goto*//*Label 31035*/ GIMT_Encode4(2437717), // Rule ID 57843 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57843,
      GIR_EraseRootFromParent_Done,
    // Label 31035: @2437717
    GIM_Try, /*On fail goto*//*Label 31036*/ GIMT_Encode4(2437771), // Rule ID 58026 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58026,
      GIR_EraseRootFromParent_Done,
    // Label 31036: @2437771
    GIM_Try, /*On fail goto*//*Label 31037*/ GIMT_Encode4(2437825), // Rule ID 58027 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58027,
      GIR_EraseRootFromParent_Done,
    // Label 31037: @2437825
    GIM_Try, /*On fail goto*//*Label 31038*/ GIMT_Encode4(2437882), // Rule ID 58234 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58234,
      GIR_EraseRootFromParent_Done,
    // Label 31038: @2437882
    GIM_Try, /*On fail goto*//*Label 31039*/ GIMT_Encode4(2437939), // Rule ID 58235 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58235,
      GIR_EraseRootFromParent_Done,
    // Label 31039: @2437939
    GIM_Reject,
    // Label 30982: @2437940
    GIM_Try, /*On fail goto*//*Label 31040*/ GIMT_Encode4(2437997), // Rule ID 57854 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57854,
      GIR_EraseRootFromParent_Done,
    // Label 31040: @2437997
    GIM_Try, /*On fail goto*//*Label 31041*/ GIMT_Encode4(2438054), // Rule ID 57855 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57855,
      GIR_EraseRootFromParent_Done,
    // Label 31041: @2438054
    GIM_Try, /*On fail goto*//*Label 31042*/ GIMT_Encode4(2438108), // Rule ID 58050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58050,
      GIR_EraseRootFromParent_Done,
    // Label 31042: @2438108
    GIM_Try, /*On fail goto*//*Label 31043*/ GIMT_Encode4(2438162), // Rule ID 58051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58051,
      GIR_EraseRootFromParent_Done,
    // Label 31043: @2438162
    GIM_Try, /*On fail goto*//*Label 31044*/ GIMT_Encode4(2438219), // Rule ID 58254 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58254,
      GIR_EraseRootFromParent_Done,
    // Label 31044: @2438219
    GIM_Try, /*On fail goto*//*Label 31045*/ GIMT_Encode4(2438276), // Rule ID 58255 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58255,
      GIR_EraseRootFromParent_Done,
    // Label 31045: @2438276
    GIM_Reject,
    // Label 30983: @2438277
    GIM_Try, /*On fail goto*//*Label 31046*/ GIMT_Encode4(2438334), // Rule ID 57886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57886,
      GIR_EraseRootFromParent_Done,
    // Label 31046: @2438334
    GIM_Try, /*On fail goto*//*Label 31047*/ GIMT_Encode4(2438391), // Rule ID 57887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57887,
      GIR_EraseRootFromParent_Done,
    // Label 31047: @2438391
    GIM_Try, /*On fail goto*//*Label 31048*/ GIMT_Encode4(2438445), // Rule ID 58070 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58070,
      GIR_EraseRootFromParent_Done,
    // Label 31048: @2438445
    GIM_Try, /*On fail goto*//*Label 31049*/ GIMT_Encode4(2438499), // Rule ID 58071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58071,
      GIR_EraseRootFromParent_Done,
    // Label 31049: @2438499
    GIM_Reject,
    // Label 30984: @2438500
    GIM_Try, /*On fail goto*//*Label 31050*/ GIMT_Encode4(2438557), // Rule ID 57850 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57850,
      GIR_EraseRootFromParent_Done,
    // Label 31050: @2438557
    GIM_Try, /*On fail goto*//*Label 31051*/ GIMT_Encode4(2438614), // Rule ID 57851 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57851,
      GIR_EraseRootFromParent_Done,
    // Label 31051: @2438614
    GIM_Try, /*On fail goto*//*Label 31052*/ GIMT_Encode4(2438668), // Rule ID 58030 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58030,
      GIR_EraseRootFromParent_Done,
    // Label 31052: @2438668
    GIM_Try, /*On fail goto*//*Label 31053*/ GIMT_Encode4(2438722), // Rule ID 58031 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58031,
      GIR_EraseRootFromParent_Done,
    // Label 31053: @2438722
    GIM_Try, /*On fail goto*//*Label 31054*/ GIMT_Encode4(2438779), // Rule ID 58238 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58238,
      GIR_EraseRootFromParent_Done,
    // Label 31054: @2438779
    GIM_Try, /*On fail goto*//*Label 31055*/ GIMT_Encode4(2438836), // Rule ID 58239 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58239,
      GIR_EraseRootFromParent_Done,
    // Label 31055: @2438836
    GIM_Reject,
    // Label 30985: @2438837
    GIM_Try, /*On fail goto*//*Label 31056*/ GIMT_Encode4(2438894), // Rule ID 57874 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57874,
      GIR_EraseRootFromParent_Done,
    // Label 31056: @2438894
    GIM_Try, /*On fail goto*//*Label 31057*/ GIMT_Encode4(2438951), // Rule ID 57875 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57875,
      GIR_EraseRootFromParent_Done,
    // Label 31057: @2438951
    GIM_Try, /*On fail goto*//*Label 31058*/ GIMT_Encode4(2439005), // Rule ID 58054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58054,
      GIR_EraseRootFromParent_Done,
    // Label 31058: @2439005
    GIM_Try, /*On fail goto*//*Label 31059*/ GIMT_Encode4(2439059), // Rule ID 58055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58055,
      GIR_EraseRootFromParent_Done,
    // Label 31059: @2439059
    GIM_Try, /*On fail goto*//*Label 31060*/ GIMT_Encode4(2439116), // Rule ID 58258 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58258,
      GIR_EraseRootFromParent_Done,
    // Label 31060: @2439116
    GIM_Try, /*On fail goto*//*Label 31061*/ GIMT_Encode4(2439173), // Rule ID 58259 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58259,
      GIR_EraseRootFromParent_Done,
    // Label 31061: @2439173
    GIM_Reject,
    // Label 30986: @2439174
    GIM_Try, /*On fail goto*//*Label 31062*/ GIMT_Encode4(2439231), // Rule ID 57890 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57890,
      GIR_EraseRootFromParent_Done,
    // Label 31062: @2439231
    GIM_Try, /*On fail goto*//*Label 31063*/ GIMT_Encode4(2439288), // Rule ID 57891 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57891,
      GIR_EraseRootFromParent_Done,
    // Label 31063: @2439288
    GIM_Try, /*On fail goto*//*Label 31064*/ GIMT_Encode4(2439342), // Rule ID 58074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58074,
      GIR_EraseRootFromParent_Done,
    // Label 31064: @2439342
    GIM_Try, /*On fail goto*//*Label 31065*/ GIMT_Encode4(2439396), // Rule ID 58075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58075,
      GIR_EraseRootFromParent_Done,
    // Label 31065: @2439396
    GIM_Reject,
    // Label 30987: @2439397
    GIM_Try, /*On fail goto*//*Label 31066*/ GIMT_Encode4(2439454), // Rule ID 57862 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57862,
      GIR_EraseRootFromParent_Done,
    // Label 31066: @2439454
    GIM_Try, /*On fail goto*//*Label 31067*/ GIMT_Encode4(2439511), // Rule ID 57863 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57863,
      GIR_EraseRootFromParent_Done,
    // Label 31067: @2439511
    GIM_Try, /*On fail goto*//*Label 31068*/ GIMT_Encode4(2439565), // Rule ID 58034 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58034,
      GIR_EraseRootFromParent_Done,
    // Label 31068: @2439565
    GIM_Try, /*On fail goto*//*Label 31069*/ GIMT_Encode4(2439619), // Rule ID 58035 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58035,
      GIR_EraseRootFromParent_Done,
    // Label 31069: @2439619
    GIM_Try, /*On fail goto*//*Label 31070*/ GIMT_Encode4(2439676), // Rule ID 58242 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58242,
      GIR_EraseRootFromParent_Done,
    // Label 31070: @2439676
    GIM_Try, /*On fail goto*//*Label 31071*/ GIMT_Encode4(2439733), // Rule ID 58243 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58243,
      GIR_EraseRootFromParent_Done,
    // Label 31071: @2439733
    GIM_Reject,
    // Label 30988: @2439734
    GIM_Try, /*On fail goto*//*Label 31072*/ GIMT_Encode4(2439791), // Rule ID 57878 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57878,
      GIR_EraseRootFromParent_Done,
    // Label 31072: @2439791
    GIM_Try, /*On fail goto*//*Label 31073*/ GIMT_Encode4(2439848), // Rule ID 57879 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57879,
      GIR_EraseRootFromParent_Done,
    // Label 31073: @2439848
    GIM_Try, /*On fail goto*//*Label 31074*/ GIMT_Encode4(2439902), // Rule ID 58058 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58058,
      GIR_EraseRootFromParent_Done,
    // Label 31074: @2439902
    GIM_Try, /*On fail goto*//*Label 31075*/ GIMT_Encode4(2439956), // Rule ID 58059 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58059,
      GIR_EraseRootFromParent_Done,
    // Label 31075: @2439956
    GIM_Try, /*On fail goto*//*Label 31076*/ GIMT_Encode4(2440013), // Rule ID 58262 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58262,
      GIR_EraseRootFromParent_Done,
    // Label 31076: @2440013
    GIM_Try, /*On fail goto*//*Label 31077*/ GIMT_Encode4(2440070), // Rule ID 58263 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58263,
      GIR_EraseRootFromParent_Done,
    // Label 31077: @2440070
    GIM_Reject,
    // Label 30989: @2440071
    GIM_Try, /*On fail goto*//*Label 31078*/ GIMT_Encode4(2440128), // Rule ID 57894 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57894,
      GIR_EraseRootFromParent_Done,
    // Label 31078: @2440128
    GIM_Try, /*On fail goto*//*Label 31079*/ GIMT_Encode4(2440185), // Rule ID 57895 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57895,
      GIR_EraseRootFromParent_Done,
    // Label 31079: @2440185
    GIM_Try, /*On fail goto*//*Label 31080*/ GIMT_Encode4(2440239), // Rule ID 58078 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58078,
      GIR_EraseRootFromParent_Done,
    // Label 31080: @2440239
    GIM_Try, /*On fail goto*//*Label 31081*/ GIMT_Encode4(2440293), // Rule ID 58079 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58079,
      GIR_EraseRootFromParent_Done,
    // Label 31081: @2440293
    GIM_Reject,
    // Label 30990: @2440294
    GIM_Try, /*On fail goto*//*Label 31082*/ GIMT_Encode4(2440351), // Rule ID 57866 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57866,
      GIR_EraseRootFromParent_Done,
    // Label 31082: @2440351
    GIM_Try, /*On fail goto*//*Label 31083*/ GIMT_Encode4(2440408), // Rule ID 57867 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57867,
      GIR_EraseRootFromParent_Done,
    // Label 31083: @2440408
    GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2440462), // Rule ID 58038 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58038,
      GIR_EraseRootFromParent_Done,
    // Label 31084: @2440462
    GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2440516), // Rule ID 58039 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58039,
      GIR_EraseRootFromParent_Done,
    // Label 31085: @2440516
    GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2440573), // Rule ID 58246 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58246,
      GIR_EraseRootFromParent_Done,
    // Label 31086: @2440573
    GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2440630), // Rule ID 58247 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58247,
      GIR_EraseRootFromParent_Done,
    // Label 31087: @2440630
    GIM_Reject,
    // Label 30991: @2440631
    GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2440688), // Rule ID 57882 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57882,
      GIR_EraseRootFromParent_Done,
    // Label 31088: @2440688
    GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2440745), // Rule ID 57883 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57883,
      GIR_EraseRootFromParent_Done,
    // Label 31089: @2440745
    GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2440799), // Rule ID 58062 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58062,
      GIR_EraseRootFromParent_Done,
    // Label 31090: @2440799
    GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2440853), // Rule ID 58063 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58063,
      GIR_EraseRootFromParent_Done,
    // Label 31091: @2440853
    GIM_Reject,
    // Label 30992: @2440854
    GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2440911), // Rule ID 57870 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57870,
      GIR_EraseRootFromParent_Done,
    // Label 31092: @2440911
    GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2440968), // Rule ID 57871 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 57871,
      GIR_EraseRootFromParent_Done,
    // Label 31093: @2440968
    GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2441022), // Rule ID 58042 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58042,
      GIR_EraseRootFromParent_Done,
    // Label 31094: @2441022
    GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2441076), // Rule ID 58043 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 58043,
      GIR_EraseRootFromParent_Done,
    // Label 31095: @2441076
    GIM_Reject,
    // Label 30993: @2441077
    GIM_Reject,
    // Label 69: @2441078
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31114*/ GIMT_Encode4(2443048),
    /*GILLT_s16*//*Label 31096*/ GIMT_Encode4(2441209),
    /*GILLT_s32*//*Label 31097*/ GIMT_Encode4(2441273),
    /*GILLT_s64*//*Label 31098*/ GIMT_Encode4(2441337), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 31099*/ GIMT_Encode4(2441428),
    /*GILLT_nxv1s32*//*Label 31100*/ GIMT_Encode4(2441536),
    /*GILLT_nxv1s64*//*Label 31101*/ GIMT_Encode4(2441644), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 31102*/ GIMT_Encode4(2441752),
    /*GILLT_nxv2s32*//*Label 31103*/ GIMT_Encode4(2441860),
    /*GILLT_nxv2s64*//*Label 31104*/ GIMT_Encode4(2441968), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 31105*/ GIMT_Encode4(2442076),
    /*GILLT_nxv4s32*//*Label 31106*/ GIMT_Encode4(2442184),
    /*GILLT_nxv4s64*//*Label 31107*/ GIMT_Encode4(2442292), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 31108*/ GIMT_Encode4(2442400),
    /*GILLT_nxv8s32*//*Label 31109*/ GIMT_Encode4(2442508),
    /*GILLT_nxv8s64*//*Label 31110*/ GIMT_Encode4(2442616), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 31111*/ GIMT_Encode4(2442724),
    /*GILLT_nxv16s32*//*Label 31112*/ GIMT_Encode4(2442832), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 31113*/ GIMT_Encode4(2442940),
    // Label 31096: @2441209
    GIM_Try, /*On fail goto*//*Label 31115*/ GIMT_Encode4(2441272),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 31116*/ GIMT_Encode4(2441244), // Rule ID 1851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1851,
        GIR_EraseRootFromParent_Done,
      // Label 31116: @2441244
      GIM_Try, /*On fail goto*//*Label 31117*/ GIMT_Encode4(2441271), // Rule ID 1884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1884,
        GIR_EraseRootFromParent_Done,
      // Label 31117: @2441271
      GIM_Reject,
    // Label 31115: @2441272
    GIM_Reject,
    // Label 31097: @2441273
    GIM_Try, /*On fail goto*//*Label 31118*/ GIMT_Encode4(2441336),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 31119*/ GIMT_Encode4(2441308), // Rule ID 1142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1142,
        GIR_EraseRootFromParent_Done,
      // Label 31119: @2441308
      GIM_Try, /*On fail goto*//*Label 31120*/ GIMT_Encode4(2441335), // Rule ID 1150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1150,
        GIR_EraseRootFromParent_Done,
      // Label 31120: @2441335
      GIM_Reject,
    // Label 31118: @2441336
    GIM_Reject,
    // Label 31098: @2441337
    GIM_Try, /*On fail goto*//*Label 31121*/ GIMT_Encode4(2441427),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 31122*/ GIMT_Encode4(2441372), // Rule ID 1485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1485,
        GIR_EraseRootFromParent_Done,
      // Label 31122: @2441372
      GIM_Try, /*On fail goto*//*Label 31123*/ GIMT_Encode4(2441399), // Rule ID 1518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1518,
        GIR_EraseRootFromParent_Done,
      // Label 31123: @2441399
      GIM_Try, /*On fail goto*//*Label 31124*/ GIMT_Encode4(2441426), // Rule ID 1540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1540,
        GIR_EraseRootFromParent_Done,
      // Label 31124: @2441426
      GIM_Reject,
    // Label 31121: @2441427
    GIM_Reject,
    // Label 31099: @2441428
    GIM_Try, /*On fail goto*//*Label 31125*/ GIMT_Encode4(2441535),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31126*/ GIMT_Encode4(2441489), // Rule ID 55794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55794,
        GIR_EraseRootFromParent_Done,
      // Label 31126: @2441489
      GIM_Try, /*On fail goto*//*Label 31127*/ GIMT_Encode4(2441534), // Rule ID 55795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55795,
        GIR_EraseRootFromParent_Done,
      // Label 31127: @2441534
      GIM_Reject,
    // Label 31125: @2441535
    GIM_Reject,
    // Label 31100: @2441536
    GIM_Try, /*On fail goto*//*Label 31128*/ GIMT_Encode4(2441643),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31129*/ GIMT_Encode4(2441597), // Rule ID 55834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55834,
        GIR_EraseRootFromParent_Done,
      // Label 31129: @2441597
      GIM_Try, /*On fail goto*//*Label 31130*/ GIMT_Encode4(2441642), // Rule ID 55835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55835,
        GIR_EraseRootFromParent_Done,
      // Label 31130: @2441642
      GIM_Reject,
    // Label 31128: @2441643
    GIM_Reject,
    // Label 31101: @2441644
    GIM_Try, /*On fail goto*//*Label 31131*/ GIMT_Encode4(2441751),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31132*/ GIMT_Encode4(2441705), // Rule ID 55894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55894,
        GIR_EraseRootFromParent_Done,
      // Label 31132: @2441705
      GIM_Try, /*On fail goto*//*Label 31133*/ GIMT_Encode4(2441750), // Rule ID 55895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55895,
        GIR_EraseRootFromParent_Done,
      // Label 31133: @2441750
      GIM_Reject,
    // Label 31131: @2441751
    GIM_Reject,
    // Label 31102: @2441752
    GIM_Try, /*On fail goto*//*Label 31134*/ GIMT_Encode4(2441859),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31135*/ GIMT_Encode4(2441813), // Rule ID 55814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55814,
        GIR_EraseRootFromParent_Done,
      // Label 31135: @2441813
      GIM_Try, /*On fail goto*//*Label 31136*/ GIMT_Encode4(2441858), // Rule ID 55815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55815,
        GIR_EraseRootFromParent_Done,
      // Label 31136: @2441858
      GIM_Reject,
    // Label 31134: @2441859
    GIM_Reject,
    // Label 31103: @2441860
    GIM_Try, /*On fail goto*//*Label 31137*/ GIMT_Encode4(2441967),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31138*/ GIMT_Encode4(2441921), // Rule ID 55874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55874,
        GIR_EraseRootFromParent_Done,
      // Label 31138: @2441921
      GIM_Try, /*On fail goto*//*Label 31139*/ GIMT_Encode4(2441966), // Rule ID 55875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55875,
        GIR_EraseRootFromParent_Done,
      // Label 31139: @2441966
      GIM_Reject,
    // Label 31137: @2441967
    GIM_Reject,
    // Label 31104: @2441968
    GIM_Try, /*On fail goto*//*Label 31140*/ GIMT_Encode4(2442075),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31141*/ GIMT_Encode4(2442029), // Rule ID 56034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56034,
        GIR_EraseRootFromParent_Done,
      // Label 31141: @2442029
      GIM_Try, /*On fail goto*//*Label 31142*/ GIMT_Encode4(2442074), // Rule ID 56035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56035,
        GIR_EraseRootFromParent_Done,
      // Label 31142: @2442074
      GIM_Reject,
    // Label 31140: @2442075
    GIM_Reject,
    // Label 31105: @2442076
    GIM_Try, /*On fail goto*//*Label 31143*/ GIMT_Encode4(2442183),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31144*/ GIMT_Encode4(2442137), // Rule ID 55854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55854,
        GIR_EraseRootFromParent_Done,
      // Label 31144: @2442137
      GIM_Try, /*On fail goto*//*Label 31145*/ GIMT_Encode4(2442182), // Rule ID 55855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55855,
        GIR_EraseRootFromParent_Done,
      // Label 31145: @2442182
      GIM_Reject,
    // Label 31143: @2442183
    GIM_Reject,
    // Label 31106: @2442184
    GIM_Try, /*On fail goto*//*Label 31146*/ GIMT_Encode4(2442291),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31147*/ GIMT_Encode4(2442245), // Rule ID 55974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55974,
        GIR_EraseRootFromParent_Done,
      // Label 31147: @2442245
      GIM_Try, /*On fail goto*//*Label 31148*/ GIMT_Encode4(2442290), // Rule ID 55975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55975,
        GIR_EraseRootFromParent_Done,
      // Label 31148: @2442290
      GIM_Reject,
    // Label 31146: @2442291
    GIM_Reject,
    // Label 31107: @2442292
    GIM_Try, /*On fail goto*//*Label 31149*/ GIMT_Encode4(2442399),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31150*/ GIMT_Encode4(2442353), // Rule ID 56054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56054,
        GIR_EraseRootFromParent_Done,
      // Label 31150: @2442353
      GIM_Try, /*On fail goto*//*Label 31151*/ GIMT_Encode4(2442398), // Rule ID 56055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56055,
        GIR_EraseRootFromParent_Done,
      // Label 31151: @2442398
      GIM_Reject,
    // Label 31149: @2442399
    GIM_Reject,
    // Label 31108: @2442400
    GIM_Try, /*On fail goto*//*Label 31152*/ GIMT_Encode4(2442507),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31153*/ GIMT_Encode4(2442461), // Rule ID 55914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55914,
        GIR_EraseRootFromParent_Done,
      // Label 31153: @2442461
      GIM_Try, /*On fail goto*//*Label 31154*/ GIMT_Encode4(2442506), // Rule ID 55915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55915,
        GIR_EraseRootFromParent_Done,
      // Label 31154: @2442506
      GIM_Reject,
    // Label 31152: @2442507
    GIM_Reject,
    // Label 31109: @2442508
    GIM_Try, /*On fail goto*//*Label 31155*/ GIMT_Encode4(2442615),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31156*/ GIMT_Encode4(2442569), // Rule ID 55994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55994,
        GIR_EraseRootFromParent_Done,
      // Label 31156: @2442569
      GIM_Try, /*On fail goto*//*Label 31157*/ GIMT_Encode4(2442614), // Rule ID 55995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55995,
        GIR_EraseRootFromParent_Done,
      // Label 31157: @2442614
      GIM_Reject,
    // Label 31155: @2442615
    GIM_Reject,
    // Label 31110: @2442616
    GIM_Try, /*On fail goto*//*Label 31158*/ GIMT_Encode4(2442723),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31159*/ GIMT_Encode4(2442677), // Rule ID 56074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56074,
        GIR_EraseRootFromParent_Done,
      // Label 31159: @2442677
      GIM_Try, /*On fail goto*//*Label 31160*/ GIMT_Encode4(2442722), // Rule ID 56075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56075,
        GIR_EraseRootFromParent_Done,
      // Label 31160: @2442722
      GIM_Reject,
    // Label 31158: @2442723
    GIM_Reject,
    // Label 31111: @2442724
    GIM_Try, /*On fail goto*//*Label 31161*/ GIMT_Encode4(2442831),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31162*/ GIMT_Encode4(2442785), // Rule ID 55934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55934,
        GIR_EraseRootFromParent_Done,
      // Label 31162: @2442785
      GIM_Try, /*On fail goto*//*Label 31163*/ GIMT_Encode4(2442830), // Rule ID 55935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55935,
        GIR_EraseRootFromParent_Done,
      // Label 31163: @2442830
      GIM_Reject,
    // Label 31161: @2442831
    GIM_Reject,
    // Label 31112: @2442832
    GIM_Try, /*On fail goto*//*Label 31164*/ GIMT_Encode4(2442939),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31165*/ GIMT_Encode4(2442893), // Rule ID 56014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56014,
        GIR_EraseRootFromParent_Done,
      // Label 31165: @2442893
      GIM_Try, /*On fail goto*//*Label 31166*/ GIMT_Encode4(2442938), // Rule ID 56015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56015,
        GIR_EraseRootFromParent_Done,
      // Label 31166: @2442938
      GIM_Reject,
    // Label 31164: @2442939
    GIM_Reject,
    // Label 31113: @2442940
    GIM_Try, /*On fail goto*//*Label 31167*/ GIMT_Encode4(2443047),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31168*/ GIMT_Encode4(2443001), // Rule ID 55954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55954,
        GIR_EraseRootFromParent_Done,
      // Label 31168: @2443001
      GIM_Try, /*On fail goto*//*Label 31169*/ GIMT_Encode4(2443046), // Rule ID 55955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_RootToRootCopy, /*OpIdx*/1, // rs
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55955,
        GIR_EraseRootFromParent_Done,
      // Label 31169: @2443046
      GIM_Reject,
    // Label 31167: @2443047
    GIM_Reject,
    // Label 31114: @2443048
    GIM_Reject,
    // Label 70: @2443049
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31188*/ GIMT_Encode4(2449110),
    /*GILLT_s16*//*Label 31170*/ GIMT_Encode4(2443180),
    /*GILLT_s32*//*Label 31171*/ GIMT_Encode4(2443856),
    /*GILLT_s64*//*Label 31172*/ GIMT_Encode4(2444532), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 31173*/ GIMT_Encode4(2445345),
    /*GILLT_nxv1s32*//*Label 31174*/ GIMT_Encode4(2445596),
    /*GILLT_nxv1s64*//*Label 31175*/ GIMT_Encode4(2445847), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 31176*/ GIMT_Encode4(2446098),
    /*GILLT_nxv2s32*//*Label 31177*/ GIMT_Encode4(2446349),
    /*GILLT_nxv2s64*//*Label 31178*/ GIMT_Encode4(2446600), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 31179*/ GIMT_Encode4(2446851),
    /*GILLT_nxv4s32*//*Label 31180*/ GIMT_Encode4(2447102),
    /*GILLT_nxv4s64*//*Label 31181*/ GIMT_Encode4(2447353), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 31182*/ GIMT_Encode4(2447604),
    /*GILLT_nxv8s32*//*Label 31183*/ GIMT_Encode4(2447855),
    /*GILLT_nxv8s64*//*Label 31184*/ GIMT_Encode4(2448106), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 31185*/ GIMT_Encode4(2448357),
    /*GILLT_nxv16s32*//*Label 31186*/ GIMT_Encode4(2448608), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 31187*/ GIMT_Encode4(2448859),
    // Label 31170: @2443180
    GIM_Try, /*On fail goto*//*Label 31189*/ GIMT_Encode4(2443855),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 31190*/ GIMT_Encode4(2443239), // Rule ID 1856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1856,
        GIR_EraseRootFromParent_Done,
      // Label 31190: @2443239
      GIM_Try, /*On fail goto*//*Label 31191*/ GIMT_Encode4(2443290), // Rule ID 1889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1889,
        GIR_EraseRootFromParent_Done,
      // Label 31191: @2443290
      GIM_Try, /*On fail goto*//*Label 31192*/ GIMT_Encode4(2443320), // Rule ID 1854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1854,
        GIR_Done,
      // Label 31192: @2443320
      GIM_Try, /*On fail goto*//*Label 31193*/ GIMT_Encode4(2443376), // Rule ID 1857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1857,
        GIR_EraseRootFromParent_Done,
      // Label 31193: @2443376
      GIM_Try, /*On fail goto*//*Label 31194*/ GIMT_Encode4(2443432), // Rule ID 1858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1858,
        GIR_EraseRootFromParent_Done,
      // Label 31194: @2443432
      GIM_Try, /*On fail goto*//*Label 31195*/ GIMT_Encode4(2443462), // Rule ID 1887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1887,
        GIR_Done,
      // Label 31195: @2443462
      GIM_Try, /*On fail goto*//*Label 31196*/ GIMT_Encode4(2443518), // Rule ID 1890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1890,
        GIR_EraseRootFromParent_Done,
      // Label 31196: @2443518
      GIM_Try, /*On fail goto*//*Label 31197*/ GIMT_Encode4(2443574), // Rule ID 1891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1891,
        GIR_EraseRootFromParent_Done,
      // Label 31197: @2443574
      GIM_Try, /*On fail goto*//*Label 31198*/ GIMT_Encode4(2443630), // Rule ID 2160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2160,
        GIR_EraseRootFromParent_Done,
      // Label 31198: @2443630
      GIM_Try, /*On fail goto*//*Label 31199*/ GIMT_Encode4(2443686), // Rule ID 2161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2161,
        GIR_EraseRootFromParent_Done,
      // Label 31199: @2443686
      GIM_Try, /*On fail goto*//*Label 31200*/ GIMT_Encode4(2443742), // Rule ID 2172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2172,
        GIR_EraseRootFromParent_Done,
      // Label 31200: @2443742
      GIM_Try, /*On fail goto*//*Label 31201*/ GIMT_Encode4(2443798), // Rule ID 2173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2173,
        GIR_EraseRootFromParent_Done,
      // Label 31201: @2443798
      GIM_Try, /*On fail goto*//*Label 31202*/ GIMT_Encode4(2443854), // Rule ID 2180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2180,
        GIR_EraseRootFromParent_Done,
      // Label 31202: @2443854
      GIM_Reject,
    // Label 31189: @2443855
    GIM_Reject,
    // Label 31171: @2443856
    GIM_Try, /*On fail goto*//*Label 31203*/ GIMT_Encode4(2444531),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 31204*/ GIMT_Encode4(2443915), // Rule ID 1157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1157,
        GIR_EraseRootFromParent_Done,
      // Label 31204: @2443915
      GIM_Try, /*On fail goto*//*Label 31205*/ GIMT_Encode4(2443966), // Rule ID 1178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1178,
        GIR_EraseRootFromParent_Done,
      // Label 31205: @2443966
      GIM_Try, /*On fail goto*//*Label 31206*/ GIMT_Encode4(2443996), // Rule ID 1153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1153,
        GIR_Done,
      // Label 31206: @2443996
      GIM_Try, /*On fail goto*//*Label 31207*/ GIMT_Encode4(2444026), // Rule ID 1154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1154,
        GIR_Done,
      // Label 31207: @2444026
      GIM_Try, /*On fail goto*//*Label 31208*/ GIMT_Encode4(2444082), // Rule ID 1493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1493,
        GIR_EraseRootFromParent_Done,
      // Label 31208: @2444082
      GIM_Try, /*On fail goto*//*Label 31209*/ GIMT_Encode4(2444138), // Rule ID 1494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1494,
        GIR_EraseRootFromParent_Done,
      // Label 31209: @2444138
      GIM_Try, /*On fail goto*//*Label 31210*/ GIMT_Encode4(2444194), // Rule ID 1524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1524,
        GIR_EraseRootFromParent_Done,
      // Label 31210: @2444194
      GIM_Try, /*On fail goto*//*Label 31211*/ GIMT_Encode4(2444250), // Rule ID 1548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1548,
        GIR_EraseRootFromParent_Done,
      // Label 31211: @2444250
      GIM_Try, /*On fail goto*//*Label 31212*/ GIMT_Encode4(2444306), // Rule ID 1549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1549,
        GIR_EraseRootFromParent_Done,
      // Label 31212: @2444306
      GIM_Try, /*On fail goto*//*Label 31213*/ GIMT_Encode4(2444362), // Rule ID 2032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2032,
        GIR_EraseRootFromParent_Done,
      // Label 31213: @2444362
      GIM_Try, /*On fail goto*//*Label 31214*/ GIMT_Encode4(2444418), // Rule ID 2033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2033,
        GIR_EraseRootFromParent_Done,
      // Label 31214: @2444418
      GIM_Try, /*On fail goto*//*Label 31215*/ GIMT_Encode4(2444474), // Rule ID 2046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2046,
        GIR_EraseRootFromParent_Done,
      // Label 31215: @2444474
      GIM_Try, /*On fail goto*//*Label 31216*/ GIMT_Encode4(2444530), // Rule ID 2047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2047,
        GIR_EraseRootFromParent_Done,
      // Label 31216: @2444530
      GIM_Reject,
    // Label 31203: @2444531
    GIM_Reject,
    // Label 31172: @2444532
    GIM_Try, /*On fail goto*//*Label 31217*/ GIMT_Encode4(2445344),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 31218*/ GIMT_Encode4(2444591), // Rule ID 1490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1490,
        GIR_EraseRootFromParent_Done,
      // Label 31218: @2444591
      GIM_Try, /*On fail goto*//*Label 31219*/ GIMT_Encode4(2444642), // Rule ID 1522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1522,
        GIR_EraseRootFromParent_Done,
      // Label 31219: @2444642
      GIM_Try, /*On fail goto*//*Label 31220*/ GIMT_Encode4(2444693), // Rule ID 1545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1545,
        GIR_EraseRootFromParent_Done,
      // Label 31220: @2444693
      GIM_Try, /*On fail goto*//*Label 31221*/ GIMT_Encode4(2444723), // Rule ID 1488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1488,
        GIR_Done,
      // Label 31221: @2444723
      GIM_Try, /*On fail goto*//*Label 31222*/ GIMT_Encode4(2444779), // Rule ID 1491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1491,
        GIR_EraseRootFromParent_Done,
      // Label 31222: @2444779
      GIM_Try, /*On fail goto*//*Label 31223*/ GIMT_Encode4(2444835), // Rule ID 1492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1492,
        GIR_EraseRootFromParent_Done,
      // Label 31223: @2444835
      GIM_Try, /*On fail goto*//*Label 31224*/ GIMT_Encode4(2444865), // Rule ID 1520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1520,
        GIR_Done,
      // Label 31224: @2444865
      GIM_Try, /*On fail goto*//*Label 31225*/ GIMT_Encode4(2444921), // Rule ID 1523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1523,
        GIR_EraseRootFromParent_Done,
      // Label 31225: @2444921
      GIM_Try, /*On fail goto*//*Label 31226*/ GIMT_Encode4(2444951), // Rule ID 1543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1543,
        GIR_Done,
      // Label 31226: @2444951
      GIM_Try, /*On fail goto*//*Label 31227*/ GIMT_Encode4(2445007), // Rule ID 1546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1546,
        GIR_EraseRootFromParent_Done,
      // Label 31227: @2445007
      GIM_Try, /*On fail goto*//*Label 31228*/ GIMT_Encode4(2445063), // Rule ID 1547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1547,
        GIR_EraseRootFromParent_Done,
      // Label 31228: @2445063
      GIM_Try, /*On fail goto*//*Label 31229*/ GIMT_Encode4(2445119), // Rule ID 2162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2162,
        GIR_EraseRootFromParent_Done,
      // Label 31229: @2445119
      GIM_Try, /*On fail goto*//*Label 31230*/ GIMT_Encode4(2445175), // Rule ID 2163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2163,
        GIR_EraseRootFromParent_Done,
      // Label 31230: @2445175
      GIM_Try, /*On fail goto*//*Label 31231*/ GIMT_Encode4(2445231), // Rule ID 2174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2174,
        GIR_EraseRootFromParent_Done,
      // Label 31231: @2445231
      GIM_Try, /*On fail goto*//*Label 31232*/ GIMT_Encode4(2445287), // Rule ID 2175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2175,
        GIR_EraseRootFromParent_Done,
      // Label 31232: @2445287
      GIM_Try, /*On fail goto*//*Label 31233*/ GIMT_Encode4(2445343), // Rule ID 2181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2181,
        GIR_EraseRootFromParent_Done,
      // Label 31233: @2445343
      GIM_Reject,
    // Label 31217: @2445344
    GIM_Reject,
    // Label 31173: @2445345
    GIM_Try, /*On fail goto*//*Label 31234*/ GIMT_Encode4(2445595),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31235*/ GIMT_Encode4(2445430), // Rule ID 55804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55804,
        GIR_EraseRootFromParent_Done,
      // Label 31235: @2445430
      GIM_Try, /*On fail goto*//*Label 31236*/ GIMT_Encode4(2445496), // Rule ID 55805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55805,
        GIR_EraseRootFromParent_Done,
      // Label 31236: @2445496
      GIM_Try, /*On fail goto*//*Label 31237*/ GIMT_Encode4(2445545), // Rule ID 55798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55798,
        GIR_EraseRootFromParent_Done,
      // Label 31237: @2445545
      GIM_Try, /*On fail goto*//*Label 31238*/ GIMT_Encode4(2445594), // Rule ID 55799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55799,
        GIR_EraseRootFromParent_Done,
      // Label 31238: @2445594
      GIM_Reject,
    // Label 31234: @2445595
    GIM_Reject,
    // Label 31174: @2445596
    GIM_Try, /*On fail goto*//*Label 31239*/ GIMT_Encode4(2445846),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31240*/ GIMT_Encode4(2445681), // Rule ID 55844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55844,
        GIR_EraseRootFromParent_Done,
      // Label 31240: @2445681
      GIM_Try, /*On fail goto*//*Label 31241*/ GIMT_Encode4(2445747), // Rule ID 55845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55845,
        GIR_EraseRootFromParent_Done,
      // Label 31241: @2445747
      GIM_Try, /*On fail goto*//*Label 31242*/ GIMT_Encode4(2445796), // Rule ID 55838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55838,
        GIR_EraseRootFromParent_Done,
      // Label 31242: @2445796
      GIM_Try, /*On fail goto*//*Label 31243*/ GIMT_Encode4(2445845), // Rule ID 55839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55839,
        GIR_EraseRootFromParent_Done,
      // Label 31243: @2445845
      GIM_Reject,
    // Label 31239: @2445846
    GIM_Reject,
    // Label 31175: @2445847
    GIM_Try, /*On fail goto*//*Label 31244*/ GIMT_Encode4(2446097),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31245*/ GIMT_Encode4(2445932), // Rule ID 55904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55904,
        GIR_EraseRootFromParent_Done,
      // Label 31245: @2445932
      GIM_Try, /*On fail goto*//*Label 31246*/ GIMT_Encode4(2445998), // Rule ID 55905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55905,
        GIR_EraseRootFromParent_Done,
      // Label 31246: @2445998
      GIM_Try, /*On fail goto*//*Label 31247*/ GIMT_Encode4(2446047), // Rule ID 55898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55898,
        GIR_EraseRootFromParent_Done,
      // Label 31247: @2446047
      GIM_Try, /*On fail goto*//*Label 31248*/ GIMT_Encode4(2446096), // Rule ID 55899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55899,
        GIR_EraseRootFromParent_Done,
      // Label 31248: @2446096
      GIM_Reject,
    // Label 31244: @2446097
    GIM_Reject,
    // Label 31176: @2446098
    GIM_Try, /*On fail goto*//*Label 31249*/ GIMT_Encode4(2446348),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31250*/ GIMT_Encode4(2446183), // Rule ID 55824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55824,
        GIR_EraseRootFromParent_Done,
      // Label 31250: @2446183
      GIM_Try, /*On fail goto*//*Label 31251*/ GIMT_Encode4(2446249), // Rule ID 55825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55825,
        GIR_EraseRootFromParent_Done,
      // Label 31251: @2446249
      GIM_Try, /*On fail goto*//*Label 31252*/ GIMT_Encode4(2446298), // Rule ID 55818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55818,
        GIR_EraseRootFromParent_Done,
      // Label 31252: @2446298
      GIM_Try, /*On fail goto*//*Label 31253*/ GIMT_Encode4(2446347), // Rule ID 55819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55819,
        GIR_EraseRootFromParent_Done,
      // Label 31253: @2446347
      GIM_Reject,
    // Label 31249: @2446348
    GIM_Reject,
    // Label 31177: @2446349
    GIM_Try, /*On fail goto*//*Label 31254*/ GIMT_Encode4(2446599),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31255*/ GIMT_Encode4(2446434), // Rule ID 55884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55884,
        GIR_EraseRootFromParent_Done,
      // Label 31255: @2446434
      GIM_Try, /*On fail goto*//*Label 31256*/ GIMT_Encode4(2446500), // Rule ID 55885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55885,
        GIR_EraseRootFromParent_Done,
      // Label 31256: @2446500
      GIM_Try, /*On fail goto*//*Label 31257*/ GIMT_Encode4(2446549), // Rule ID 55878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55878,
        GIR_EraseRootFromParent_Done,
      // Label 31257: @2446549
      GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2446598), // Rule ID 55879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55879,
        GIR_EraseRootFromParent_Done,
      // Label 31258: @2446598
      GIM_Reject,
    // Label 31254: @2446599
    GIM_Reject,
    // Label 31178: @2446600
    GIM_Try, /*On fail goto*//*Label 31259*/ GIMT_Encode4(2446850),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31260*/ GIMT_Encode4(2446685), // Rule ID 56044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56044,
        GIR_EraseRootFromParent_Done,
      // Label 31260: @2446685
      GIM_Try, /*On fail goto*//*Label 31261*/ GIMT_Encode4(2446751), // Rule ID 56045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56045,
        GIR_EraseRootFromParent_Done,
      // Label 31261: @2446751
      GIM_Try, /*On fail goto*//*Label 31262*/ GIMT_Encode4(2446800), // Rule ID 56038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56038,
        GIR_EraseRootFromParent_Done,
      // Label 31262: @2446800
      GIM_Try, /*On fail goto*//*Label 31263*/ GIMT_Encode4(2446849), // Rule ID 56039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56039,
        GIR_EraseRootFromParent_Done,
      // Label 31263: @2446849
      GIM_Reject,
    // Label 31259: @2446850
    GIM_Reject,
    // Label 31179: @2446851
    GIM_Try, /*On fail goto*//*Label 31264*/ GIMT_Encode4(2447101),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31265*/ GIMT_Encode4(2446936), // Rule ID 55864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55864,
        GIR_EraseRootFromParent_Done,
      // Label 31265: @2446936
      GIM_Try, /*On fail goto*//*Label 31266*/ GIMT_Encode4(2447002), // Rule ID 55865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55865,
        GIR_EraseRootFromParent_Done,
      // Label 31266: @2447002
      GIM_Try, /*On fail goto*//*Label 31267*/ GIMT_Encode4(2447051), // Rule ID 55858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55858,
        GIR_EraseRootFromParent_Done,
      // Label 31267: @2447051
      GIM_Try, /*On fail goto*//*Label 31268*/ GIMT_Encode4(2447100), // Rule ID 55859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55859,
        GIR_EraseRootFromParent_Done,
      // Label 31268: @2447100
      GIM_Reject,
    // Label 31264: @2447101
    GIM_Reject,
    // Label 31180: @2447102
    GIM_Try, /*On fail goto*//*Label 31269*/ GIMT_Encode4(2447352),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31270*/ GIMT_Encode4(2447187), // Rule ID 55984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55984,
        GIR_EraseRootFromParent_Done,
      // Label 31270: @2447187
      GIM_Try, /*On fail goto*//*Label 31271*/ GIMT_Encode4(2447253), // Rule ID 55985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55985,
        GIR_EraseRootFromParent_Done,
      // Label 31271: @2447253
      GIM_Try, /*On fail goto*//*Label 31272*/ GIMT_Encode4(2447302), // Rule ID 55978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55978,
        GIR_EraseRootFromParent_Done,
      // Label 31272: @2447302
      GIM_Try, /*On fail goto*//*Label 31273*/ GIMT_Encode4(2447351), // Rule ID 55979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55979,
        GIR_EraseRootFromParent_Done,
      // Label 31273: @2447351
      GIM_Reject,
    // Label 31269: @2447352
    GIM_Reject,
    // Label 31181: @2447353
    GIM_Try, /*On fail goto*//*Label 31274*/ GIMT_Encode4(2447603),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31275*/ GIMT_Encode4(2447438), // Rule ID 56064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56064,
        GIR_EraseRootFromParent_Done,
      // Label 31275: @2447438
      GIM_Try, /*On fail goto*//*Label 31276*/ GIMT_Encode4(2447504), // Rule ID 56065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56065,
        GIR_EraseRootFromParent_Done,
      // Label 31276: @2447504
      GIM_Try, /*On fail goto*//*Label 31277*/ GIMT_Encode4(2447553), // Rule ID 56058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56058,
        GIR_EraseRootFromParent_Done,
      // Label 31277: @2447553
      GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2447602), // Rule ID 56059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56059,
        GIR_EraseRootFromParent_Done,
      // Label 31278: @2447602
      GIM_Reject,
    // Label 31274: @2447603
    GIM_Reject,
    // Label 31182: @2447604
    GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2447854),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2447689), // Rule ID 55924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55924,
        GIR_EraseRootFromParent_Done,
      // Label 31280: @2447689
      GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2447755), // Rule ID 55925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55925,
        GIR_EraseRootFromParent_Done,
      // Label 31281: @2447755
      GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2447804), // Rule ID 55918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55918,
        GIR_EraseRootFromParent_Done,
      // Label 31282: @2447804
      GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2447853), // Rule ID 55919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55919,
        GIR_EraseRootFromParent_Done,
      // Label 31283: @2447853
      GIM_Reject,
    // Label 31279: @2447854
    GIM_Reject,
    // Label 31183: @2447855
    GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2448105),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2447940), // Rule ID 56004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56004,
        GIR_EraseRootFromParent_Done,
      // Label 31285: @2447940
      GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2448006), // Rule ID 56005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56005,
        GIR_EraseRootFromParent_Done,
      // Label 31286: @2448006
      GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2448055), // Rule ID 55998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55998,
        GIR_EraseRootFromParent_Done,
      // Label 31287: @2448055
      GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2448104), // Rule ID 55999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55999,
        GIR_EraseRootFromParent_Done,
      // Label 31288: @2448104
      GIM_Reject,
    // Label 31284: @2448105
    GIM_Reject,
    // Label 31184: @2448106
    GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2448356),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31290*/ GIMT_Encode4(2448191), // Rule ID 56084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56084,
        GIR_EraseRootFromParent_Done,
      // Label 31290: @2448191
      GIM_Try, /*On fail goto*//*Label 31291*/ GIMT_Encode4(2448257), // Rule ID 56085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56085,
        GIR_EraseRootFromParent_Done,
      // Label 31291: @2448257
      GIM_Try, /*On fail goto*//*Label 31292*/ GIMT_Encode4(2448306), // Rule ID 56078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56078,
        GIR_EraseRootFromParent_Done,
      // Label 31292: @2448306
      GIM_Try, /*On fail goto*//*Label 31293*/ GIMT_Encode4(2448355), // Rule ID 56079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56079,
        GIR_EraseRootFromParent_Done,
      // Label 31293: @2448355
      GIM_Reject,
    // Label 31289: @2448356
    GIM_Reject,
    // Label 31185: @2448357
    GIM_Try, /*On fail goto*//*Label 31294*/ GIMT_Encode4(2448607),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31295*/ GIMT_Encode4(2448442), // Rule ID 55944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55944,
        GIR_EraseRootFromParent_Done,
      // Label 31295: @2448442
      GIM_Try, /*On fail goto*//*Label 31296*/ GIMT_Encode4(2448508), // Rule ID 55945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55945,
        GIR_EraseRootFromParent_Done,
      // Label 31296: @2448508
      GIM_Try, /*On fail goto*//*Label 31297*/ GIMT_Encode4(2448557), // Rule ID 55938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55938,
        GIR_EraseRootFromParent_Done,
      // Label 31297: @2448557
      GIM_Try, /*On fail goto*//*Label 31298*/ GIMT_Encode4(2448606), // Rule ID 55939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55939,
        GIR_EraseRootFromParent_Done,
      // Label 31298: @2448606
      GIM_Reject,
    // Label 31294: @2448607
    GIM_Reject,
    // Label 31186: @2448608
    GIM_Try, /*On fail goto*//*Label 31299*/ GIMT_Encode4(2448858),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31300*/ GIMT_Encode4(2448693), // Rule ID 56024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56024,
        GIR_EraseRootFromParent_Done,
      // Label 31300: @2448693
      GIM_Try, /*On fail goto*//*Label 31301*/ GIMT_Encode4(2448759), // Rule ID 56025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56025,
        GIR_EraseRootFromParent_Done,
      // Label 31301: @2448759
      GIM_Try, /*On fail goto*//*Label 31302*/ GIMT_Encode4(2448808), // Rule ID 56018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56018,
        GIR_EraseRootFromParent_Done,
      // Label 31302: @2448808
      GIM_Try, /*On fail goto*//*Label 31303*/ GIMT_Encode4(2448857), // Rule ID 56019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56019,
        GIR_EraseRootFromParent_Done,
      // Label 31303: @2448857
      GIM_Reject,
    // Label 31299: @2448858
    GIM_Reject,
    // Label 31187: @2448859
    GIM_Try, /*On fail goto*//*Label 31304*/ GIMT_Encode4(2449109),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31305*/ GIMT_Encode4(2448944), // Rule ID 55964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55964,
        GIR_EraseRootFromParent_Done,
      // Label 31305: @2448944
      GIM_Try, /*On fail goto*//*Label 31306*/ GIMT_Encode4(2449010), // Rule ID 55965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55965,
        GIR_EraseRootFromParent_Done,
      // Label 31306: @2449010
      GIM_Try, /*On fail goto*//*Label 31307*/ GIMT_Encode4(2449059), // Rule ID 55958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55958,
        GIR_EraseRootFromParent_Done,
      // Label 31307: @2449059
      GIM_Try, /*On fail goto*//*Label 31308*/ GIMT_Encode4(2449108), // Rule ID 55959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55959,
        GIR_EraseRootFromParent_Done,
      // Label 31308: @2449108
      GIM_Reject,
    // Label 31304: @2449109
    GIM_Reject,
    // Label 31188: @2449110
    GIM_Reject,
    // Label 71: @2449111
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 31312*/ GIMT_Encode4(2449300),
    /*GILLT_s16*//*Label 31309*/ GIMT_Encode4(2449134),
    /*GILLT_s32*//*Label 31310*/ GIMT_Encode4(2449184),
    /*GILLT_s64*//*Label 31311*/ GIMT_Encode4(2449234),
    // Label 31309: @2449134
    GIM_Try, /*On fail goto*//*Label 31313*/ GIMT_Encode4(2449183),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 31314*/ GIMT_Encode4(2449166), // Rule ID 1924 //
        // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1924,
        GIR_EraseRootFromParent_Done,
      // Label 31314: @2449166
      GIM_Try, /*On fail goto*//*Label 31315*/ GIMT_Encode4(2449182), // Rule ID 1925 //
        // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1925,
        GIR_EraseRootFromParent_Done,
      // Label 31315: @2449182
      GIM_Reject,
    // Label 31313: @2449183
    GIM_Reject,
    // Label 31310: @2449184
    GIM_Try, /*On fail goto*//*Label 31316*/ GIMT_Encode4(2449233),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 31317*/ GIMT_Encode4(2449216), // Rule ID 1211 //
        // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1211,
        GIR_EraseRootFromParent_Done,
      // Label 31317: @2449216
      GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2449232), // Rule ID 1212 //
        // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1212,
        GIR_EraseRootFromParent_Done,
      // Label 31318: @2449232
      GIM_Reject,
    // Label 31316: @2449233
    GIM_Reject,
    // Label 31311: @2449234
    GIM_Try, /*On fail goto*//*Label 31319*/ GIMT_Encode4(2449299),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 31320*/ GIMT_Encode4(2449266), // Rule ID 1588 //
        // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1588,
        GIR_EraseRootFromParent_Done,
      // Label 31320: @2449266
      GIM_Try, /*On fail goto*//*Label 31321*/ GIMT_Encode4(2449282), // Rule ID 1589 //
        // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1589,
        GIR_EraseRootFromParent_Done,
      // Label 31321: @2449282
      GIM_Try, /*On fail goto*//*Label 31322*/ GIMT_Encode4(2449298), // Rule ID 1590 //
        // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1590,
        GIR_EraseRootFromParent_Done,
      // Label 31322: @2449298
      GIM_Reject,
    // Label 31319: @2449299
    GIM_Reject,
    // Label 31312: @2449300
    GIM_Reject,
    // Label 72: @2449301
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31341*/ GIMT_Encode4(2451385),
    /*GILLT_s16*//*Label 31323*/ GIMT_Encode4(2449432),
    /*GILLT_s32*//*Label 31324*/ GIMT_Encode4(2449499),
    /*GILLT_s64*//*Label 31325*/ GIMT_Encode4(2449566), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 31326*/ GIMT_Encode4(2449660),
    /*GILLT_nxv1s32*//*Label 31327*/ GIMT_Encode4(2449775),
    /*GILLT_nxv1s64*//*Label 31328*/ GIMT_Encode4(2449890), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 31329*/ GIMT_Encode4(2450005),
    /*GILLT_nxv2s32*//*Label 31330*/ GIMT_Encode4(2450120),
    /*GILLT_nxv2s64*//*Label 31331*/ GIMT_Encode4(2450235), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 31332*/ GIMT_Encode4(2450350),
    /*GILLT_nxv4s32*//*Label 31333*/ GIMT_Encode4(2450465),
    /*GILLT_nxv4s64*//*Label 31334*/ GIMT_Encode4(2450580), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 31335*/ GIMT_Encode4(2450695),
    /*GILLT_nxv8s32*//*Label 31336*/ GIMT_Encode4(2450810),
    /*GILLT_nxv8s64*//*Label 31337*/ GIMT_Encode4(2450925), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 31338*/ GIMT_Encode4(2451040),
    /*GILLT_nxv16s32*//*Label 31339*/ GIMT_Encode4(2451155), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 31340*/ GIMT_Encode4(2451270),
    // Label 31323: @2449432
    GIM_Try, /*On fail goto*//*Label 31342*/ GIMT_Encode4(2449498),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 31343*/ GIMT_Encode4(2449470), // Rule ID 1912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1912,
        GIR_Done,
      // Label 31343: @2449470
      GIM_Try, /*On fail goto*//*Label 31344*/ GIMT_Encode4(2449497), // Rule ID 1913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1913,
        GIR_Done,
      // Label 31344: @2449497
      GIM_Reject,
    // Label 31342: @2449498
    GIM_Reject,
    // Label 31324: @2449499
    GIM_Try, /*On fail goto*//*Label 31345*/ GIMT_Encode4(2449565),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 31346*/ GIMT_Encode4(2449537), // Rule ID 1199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1199,
        GIR_Done,
      // Label 31346: @2449537
      GIM_Try, /*On fail goto*//*Label 31347*/ GIMT_Encode4(2449564), // Rule ID 1200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1200,
        GIR_Done,
      // Label 31347: @2449564
      GIM_Reject,
    // Label 31345: @2449565
    GIM_Reject,
    // Label 31325: @2449566
    GIM_Try, /*On fail goto*//*Label 31348*/ GIMT_Encode4(2449659),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 31349*/ GIMT_Encode4(2449604), // Rule ID 1570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1570,
        GIR_Done,
      // Label 31349: @2449604
      GIM_Try, /*On fail goto*//*Label 31350*/ GIMT_Encode4(2449631), // Rule ID 1571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1571,
        GIR_Done,
      // Label 31350: @2449631
      GIM_Try, /*On fail goto*//*Label 31351*/ GIMT_Encode4(2449658), // Rule ID 1572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1572,
        GIR_Done,
      // Label 31351: @2449658
      GIM_Reject,
    // Label 31348: @2449659
    GIM_Reject,
    // Label 31326: @2449660
    GIM_Try, /*On fail goto*//*Label 31352*/ GIMT_Encode4(2449774),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31353*/ GIMT_Encode4(2449728), // Rule ID 45534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45534,
        GIR_EraseRootFromParent_Done,
      // Label 31353: @2449728
      GIM_Try, /*On fail goto*//*Label 31354*/ GIMT_Encode4(2449773), // Rule ID 45535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45535,
        GIR_EraseRootFromParent_Done,
      // Label 31354: @2449773
      GIM_Reject,
    // Label 31352: @2449774
    GIM_Reject,
    // Label 31327: @2449775
    GIM_Try, /*On fail goto*//*Label 31355*/ GIMT_Encode4(2449889),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31356*/ GIMT_Encode4(2449843), // Rule ID 56096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56096,
        GIR_EraseRootFromParent_Done,
      // Label 31356: @2449843
      GIM_Try, /*On fail goto*//*Label 31357*/ GIMT_Encode4(2449888), // Rule ID 56097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56097,
        GIR_EraseRootFromParent_Done,
      // Label 31357: @2449888
      GIM_Reject,
    // Label 31355: @2449889
    GIM_Reject,
    // Label 31328: @2449890
    GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2450004),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2449958), // Rule ID 56114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56114,
        GIR_EraseRootFromParent_Done,
      // Label 31359: @2449958
      GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2450003), // Rule ID 56115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56115,
        GIR_EraseRootFromParent_Done,
      // Label 31360: @2450003
      GIM_Reject,
    // Label 31358: @2450004
    GIM_Reject,
    // Label 31329: @2450005
    GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2450119),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2450073), // Rule ID 56090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56090,
        GIR_EraseRootFromParent_Done,
      // Label 31362: @2450073
      GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2450118), // Rule ID 56091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56091,
        GIR_EraseRootFromParent_Done,
      // Label 31363: @2450118
      GIM_Reject,
    // Label 31361: @2450119
    GIM_Reject,
    // Label 31330: @2450120
    GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2450234),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2450188), // Rule ID 56108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56108,
        GIR_EraseRootFromParent_Done,
      // Label 31365: @2450188
      GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2450233), // Rule ID 56109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56109,
        GIR_EraseRootFromParent_Done,
      // Label 31366: @2450233
      GIM_Reject,
    // Label 31364: @2450234
    GIM_Reject,
    // Label 31331: @2450235
    GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2450349),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2450303), // Rule ID 56156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56156,
        GIR_EraseRootFromParent_Done,
      // Label 31368: @2450303
      GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2450348), // Rule ID 56157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56157,
        GIR_EraseRootFromParent_Done,
      // Label 31369: @2450348
      GIM_Reject,
    // Label 31367: @2450349
    GIM_Reject,
    // Label 31332: @2450350
    GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2450464),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2450418), // Rule ID 56102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56102,
        GIR_EraseRootFromParent_Done,
      // Label 31371: @2450418
      GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2450463), // Rule ID 56103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56103,
        GIR_EraseRootFromParent_Done,
      // Label 31372: @2450463
      GIM_Reject,
    // Label 31370: @2450464
    GIM_Reject,
    // Label 31333: @2450465
    GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2450579),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2450533), // Rule ID 56138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56138,
        GIR_EraseRootFromParent_Done,
      // Label 31374: @2450533
      GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2450578), // Rule ID 56139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56139,
        GIR_EraseRootFromParent_Done,
      // Label 31375: @2450578
      GIM_Reject,
    // Label 31373: @2450579
    GIM_Reject,
    // Label 31334: @2450580
    GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2450694),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2450648), // Rule ID 56162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56162,
        GIR_EraseRootFromParent_Done,
      // Label 31377: @2450648
      GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2450693), // Rule ID 56163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56163,
        GIR_EraseRootFromParent_Done,
      // Label 31378: @2450693
      GIM_Reject,
    // Label 31376: @2450694
    GIM_Reject,
    // Label 31335: @2450695
    GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2450809),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2450763), // Rule ID 56120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56120,
        GIR_EraseRootFromParent_Done,
      // Label 31380: @2450763
      GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2450808), // Rule ID 56121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56121,
        GIR_EraseRootFromParent_Done,
      // Label 31381: @2450808
      GIM_Reject,
    // Label 31379: @2450809
    GIM_Reject,
    // Label 31336: @2450810
    GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2450924),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2450878), // Rule ID 56144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56144,
        GIR_EraseRootFromParent_Done,
      // Label 31383: @2450878
      GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2450923), // Rule ID 56145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56145,
        GIR_EraseRootFromParent_Done,
      // Label 31384: @2450923
      GIM_Reject,
    // Label 31382: @2450924
    GIM_Reject,
    // Label 31337: @2450925
    GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2451039),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2450993), // Rule ID 56168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56168,
        GIR_EraseRootFromParent_Done,
      // Label 31386: @2450993
      GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2451038), // Rule ID 56169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56169,
        GIR_EraseRootFromParent_Done,
      // Label 31387: @2451038
      GIM_Reject,
    // Label 31385: @2451039
    GIM_Reject,
    // Label 31338: @2451040
    GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2451154),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31389*/ GIMT_Encode4(2451108), // Rule ID 56126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56126,
        GIR_EraseRootFromParent_Done,
      // Label 31389: @2451108
      GIM_Try, /*On fail goto*//*Label 31390*/ GIMT_Encode4(2451153), // Rule ID 56127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56127,
        GIR_EraseRootFromParent_Done,
      // Label 31390: @2451153
      GIM_Reject,
    // Label 31388: @2451154
    GIM_Reject,
    // Label 31339: @2451155
    GIM_Try, /*On fail goto*//*Label 31391*/ GIMT_Encode4(2451269),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31392*/ GIMT_Encode4(2451223), // Rule ID 56150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56150,
        GIR_EraseRootFromParent_Done,
      // Label 31392: @2451223
      GIM_Try, /*On fail goto*//*Label 31393*/ GIMT_Encode4(2451268), // Rule ID 56151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56151,
        GIR_EraseRootFromParent_Done,
      // Label 31393: @2451268
      GIM_Reject,
    // Label 31391: @2451269
    GIM_Reject,
    // Label 31340: @2451270
    GIM_Try, /*On fail goto*//*Label 31394*/ GIMT_Encode4(2451384),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31395*/ GIMT_Encode4(2451338), // Rule ID 56132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56132,
        GIR_EraseRootFromParent_Done,
      // Label 31395: @2451338
      GIM_Try, /*On fail goto*//*Label 31396*/ GIMT_Encode4(2451383), // Rule ID 56133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56133,
        GIR_EraseRootFromParent_Done,
      // Label 31396: @2451383
      GIM_Reject,
    // Label 31394: @2451384
    GIM_Reject,
    // Label 31341: @2451385
    GIM_Reject,
    // Label 73: @2451386
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31415*/ GIMT_Encode4(2453470),
    /*GILLT_s16*//*Label 31397*/ GIMT_Encode4(2451517),
    /*GILLT_s32*//*Label 31398*/ GIMT_Encode4(2451584),
    /*GILLT_s64*//*Label 31399*/ GIMT_Encode4(2451651), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 31400*/ GIMT_Encode4(2451745),
    /*GILLT_nxv1s32*//*Label 31401*/ GIMT_Encode4(2451860),
    /*GILLT_nxv1s64*//*Label 31402*/ GIMT_Encode4(2451975), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 31403*/ GIMT_Encode4(2452090),
    /*GILLT_nxv2s32*//*Label 31404*/ GIMT_Encode4(2452205),
    /*GILLT_nxv2s64*//*Label 31405*/ GIMT_Encode4(2452320), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 31406*/ GIMT_Encode4(2452435),
    /*GILLT_nxv4s32*//*Label 31407*/ GIMT_Encode4(2452550),
    /*GILLT_nxv4s64*//*Label 31408*/ GIMT_Encode4(2452665), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 31409*/ GIMT_Encode4(2452780),
    /*GILLT_nxv8s32*//*Label 31410*/ GIMT_Encode4(2452895),
    /*GILLT_nxv8s64*//*Label 31411*/ GIMT_Encode4(2453010), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 31412*/ GIMT_Encode4(2453125),
    /*GILLT_nxv16s32*//*Label 31413*/ GIMT_Encode4(2453240), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 31414*/ GIMT_Encode4(2453355),
    // Label 31397: @2451517
    GIM_Try, /*On fail goto*//*Label 31416*/ GIMT_Encode4(2451583),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 31417*/ GIMT_Encode4(2451555), // Rule ID 1914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1914,
        GIR_Done,
      // Label 31417: @2451555
      GIM_Try, /*On fail goto*//*Label 31418*/ GIMT_Encode4(2451582), // Rule ID 1915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1915,
        GIR_Done,
      // Label 31418: @2451582
      GIM_Reject,
    // Label 31416: @2451583
    GIM_Reject,
    // Label 31398: @2451584
    GIM_Try, /*On fail goto*//*Label 31419*/ GIMT_Encode4(2451650),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 31420*/ GIMT_Encode4(2451622), // Rule ID 1201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1201,
        GIR_Done,
      // Label 31420: @2451622
      GIM_Try, /*On fail goto*//*Label 31421*/ GIMT_Encode4(2451649), // Rule ID 1202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1202,
        GIR_Done,
      // Label 31421: @2451649
      GIM_Reject,
    // Label 31419: @2451650
    GIM_Reject,
    // Label 31399: @2451651
    GIM_Try, /*On fail goto*//*Label 31422*/ GIMT_Encode4(2451744),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 31423*/ GIMT_Encode4(2451689), // Rule ID 1573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1573,
        GIR_Done,
      // Label 31423: @2451689
      GIM_Try, /*On fail goto*//*Label 31424*/ GIMT_Encode4(2451716), // Rule ID 1574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1574,
        GIR_Done,
      // Label 31424: @2451716
      GIM_Try, /*On fail goto*//*Label 31425*/ GIMT_Encode4(2451743), // Rule ID 1575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1575,
        GIR_Done,
      // Label 31425: @2451743
      GIM_Reject,
    // Label 31422: @2451744
    GIM_Reject,
    // Label 31400: @2451745
    GIM_Try, /*On fail goto*//*Label 31426*/ GIMT_Encode4(2451859),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31427*/ GIMT_Encode4(2451813), // Rule ID 56174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56174,
        GIR_EraseRootFromParent_Done,
      // Label 31427: @2451813
      GIM_Try, /*On fail goto*//*Label 31428*/ GIMT_Encode4(2451858), // Rule ID 56175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56175,
        GIR_EraseRootFromParent_Done,
      // Label 31428: @2451858
      GIM_Reject,
    // Label 31426: @2451859
    GIM_Reject,
    // Label 31401: @2451860
    GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2451974),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2451928), // Rule ID 56186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56186,
        GIR_EraseRootFromParent_Done,
      // Label 31430: @2451928
      GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2451973), // Rule ID 56187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56187,
        GIR_EraseRootFromParent_Done,
      // Label 31431: @2451973
      GIM_Reject,
    // Label 31429: @2451974
    GIM_Reject,
    // Label 31402: @2451975
    GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2452089),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2452043), // Rule ID 56204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56204,
        GIR_EraseRootFromParent_Done,
      // Label 31433: @2452043
      GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2452088), // Rule ID 56205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56205,
        GIR_EraseRootFromParent_Done,
      // Label 31434: @2452088
      GIM_Reject,
    // Label 31432: @2452089
    GIM_Reject,
    // Label 31403: @2452090
    GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2452204),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2452158), // Rule ID 56180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56180,
        GIR_EraseRootFromParent_Done,
      // Label 31436: @2452158
      GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2452203), // Rule ID 56181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56181,
        GIR_EraseRootFromParent_Done,
      // Label 31437: @2452203
      GIM_Reject,
    // Label 31435: @2452204
    GIM_Reject,
    // Label 31404: @2452205
    GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2452319),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2452273), // Rule ID 56198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56198,
        GIR_EraseRootFromParent_Done,
      // Label 31439: @2452273
      GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2452318), // Rule ID 56199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56199,
        GIR_EraseRootFromParent_Done,
      // Label 31440: @2452318
      GIM_Reject,
    // Label 31438: @2452319
    GIM_Reject,
    // Label 31405: @2452320
    GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2452434),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2452388), // Rule ID 56246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56246,
        GIR_EraseRootFromParent_Done,
      // Label 31442: @2452388
      GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2452433), // Rule ID 56247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56247,
        GIR_EraseRootFromParent_Done,
      // Label 31443: @2452433
      GIM_Reject,
    // Label 31441: @2452434
    GIM_Reject,
    // Label 31406: @2452435
    GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2452549),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2452503), // Rule ID 56192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56192,
        GIR_EraseRootFromParent_Done,
      // Label 31445: @2452503
      GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2452548), // Rule ID 56193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56193,
        GIR_EraseRootFromParent_Done,
      // Label 31446: @2452548
      GIM_Reject,
    // Label 31444: @2452549
    GIM_Reject,
    // Label 31407: @2452550
    GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2452664),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2452618), // Rule ID 56228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56228,
        GIR_EraseRootFromParent_Done,
      // Label 31448: @2452618
      GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2452663), // Rule ID 56229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56229,
        GIR_EraseRootFromParent_Done,
      // Label 31449: @2452663
      GIM_Reject,
    // Label 31447: @2452664
    GIM_Reject,
    // Label 31408: @2452665
    GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2452779),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2452733), // Rule ID 56252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56252,
        GIR_EraseRootFromParent_Done,
      // Label 31451: @2452733
      GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2452778), // Rule ID 56253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56253,
        GIR_EraseRootFromParent_Done,
      // Label 31452: @2452778
      GIM_Reject,
    // Label 31450: @2452779
    GIM_Reject,
    // Label 31409: @2452780
    GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2452894),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2452848), // Rule ID 56210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56210,
        GIR_EraseRootFromParent_Done,
      // Label 31454: @2452848
      GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2452893), // Rule ID 56211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56211,
        GIR_EraseRootFromParent_Done,
      // Label 31455: @2452893
      GIM_Reject,
    // Label 31453: @2452894
    GIM_Reject,
    // Label 31410: @2452895
    GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2453009),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2452963), // Rule ID 56234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56234,
        GIR_EraseRootFromParent_Done,
      // Label 31457: @2452963
      GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2453008), // Rule ID 56235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56235,
        GIR_EraseRootFromParent_Done,
      // Label 31458: @2453008
      GIM_Reject,
    // Label 31456: @2453009
    GIM_Reject,
    // Label 31411: @2453010
    GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2453124),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2453078), // Rule ID 56258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56258,
        GIR_EraseRootFromParent_Done,
      // Label 31460: @2453078
      GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2453123), // Rule ID 56259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56259,
        GIR_EraseRootFromParent_Done,
      // Label 31461: @2453123
      GIM_Reject,
    // Label 31459: @2453124
    GIM_Reject,
    // Label 31412: @2453125
    GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2453239),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2453193), // Rule ID 56216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56216,
        GIR_EraseRootFromParent_Done,
      // Label 31463: @2453193
      GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2453238), // Rule ID 56217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56217,
        GIR_EraseRootFromParent_Done,
      // Label 31464: @2453238
      GIM_Reject,
    // Label 31462: @2453239
    GIM_Reject,
    // Label 31413: @2453240
    GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2453354),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2453308), // Rule ID 56240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56240,
        GIR_EraseRootFromParent_Done,
      // Label 31466: @2453308
      GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2453353), // Rule ID 56241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56241,
        GIR_EraseRootFromParent_Done,
      // Label 31467: @2453353
      GIM_Reject,
    // Label 31465: @2453354
    GIM_Reject,
    // Label 31414: @2453355
    GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2453469),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31469*/ GIMT_Encode4(2453423), // Rule ID 56222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56222,
        GIR_EraseRootFromParent_Done,
      // Label 31469: @2453423
      GIM_Try, /*On fail goto*//*Label 31470*/ GIMT_Encode4(2453468), // Rule ID 56223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56223,
        GIR_EraseRootFromParent_Done,
      // Label 31470: @2453468
      GIM_Reject,
    // Label 31468: @2453469
    GIM_Reject,
    // Label 31415: @2453470
    GIM_Reject,
    // Label 74: @2453471
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 31474*/ GIMT_Encode4(2453596),
    /*GILLT_s16*//*Label 31471*/ GIMT_Encode4(2453494),
    /*GILLT_s32*//*Label 31472*/ GIMT_Encode4(2453528),
    /*GILLT_s64*//*Label 31473*/ GIMT_Encode4(2453562),
    // Label 31471: @2453494
    GIM_Try, /*On fail goto*//*Label 31475*/ GIMT_Encode4(2453527), // Rule ID 2266 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2266,
      GIR_Done,
    // Label 31475: @2453527
    GIM_Reject,
    // Label 31472: @2453528
    GIM_Try, /*On fail goto*//*Label 31476*/ GIMT_Encode4(2453561), // Rule ID 2184 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2184,
      GIR_Done,
    // Label 31476: @2453561
    GIM_Reject,
    // Label 31473: @2453562
    GIM_Try, /*On fail goto*//*Label 31477*/ GIMT_Encode4(2453595), // Rule ID 2224 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2224,
      GIR_Done,
    // Label 31477: @2453595
    GIM_Reject,
    // Label 31474: @2453596
    GIM_Reject,
    // Label 75: @2453597
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 31481*/ GIMT_Encode4(2453722),
    /*GILLT_s16*//*Label 31478*/ GIMT_Encode4(2453620),
    /*GILLT_s32*//*Label 31479*/ GIMT_Encode4(2453654),
    /*GILLT_s64*//*Label 31480*/ GIMT_Encode4(2453688),
    // Label 31478: @2453620
    GIM_Try, /*On fail goto*//*Label 31482*/ GIMT_Encode4(2453653), // Rule ID 2267 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2267,
      GIR_Done,
    // Label 31482: @2453653
    GIM_Reject,
    // Label 31479: @2453654
    GIM_Try, /*On fail goto*//*Label 31483*/ GIMT_Encode4(2453687), // Rule ID 2185 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2185,
      GIR_Done,
    // Label 31483: @2453687
    GIM_Reject,
    // Label 31480: @2453688
    GIM_Try, /*On fail goto*//*Label 31484*/ GIMT_Encode4(2453721), // Rule ID 2225 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2225,
      GIR_Done,
    // Label 31484: @2453721
    GIM_Reject,
    // Label 31481: @2453722
    GIM_Reject,
    // Label 76: @2453723
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31509*/ GIMT_Encode4(2456498),
    /*GILLT_s32*//*Label 31485*/ GIMT_Encode4(2453858),
    /*GILLT_s64*//*Label 31486*/ GIMT_Encode4(2453913), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 31487*/ GIMT_Encode4(2453968),
    /*GILLT_nxv1s16*//*Label 31488*/ GIMT_Encode4(2454083),
    /*GILLT_nxv1s32*//*Label 31489*/ GIMT_Encode4(2454198),
    /*GILLT_nxv1s64*//*Label 31490*/ GIMT_Encode4(2454313), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 31491*/ GIMT_Encode4(2454428),
    /*GILLT_nxv2s16*//*Label 31492*/ GIMT_Encode4(2454543),
    /*GILLT_nxv2s32*//*Label 31493*/ GIMT_Encode4(2454658),
    /*GILLT_nxv2s64*//*Label 31494*/ GIMT_Encode4(2454773), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 31495*/ GIMT_Encode4(2454888),
    /*GILLT_nxv4s16*//*Label 31496*/ GIMT_Encode4(2455003),
    /*GILLT_nxv4s32*//*Label 31497*/ GIMT_Encode4(2455118),
    /*GILLT_nxv4s64*//*Label 31498*/ GIMT_Encode4(2455233), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 31499*/ GIMT_Encode4(2455348),
    /*GILLT_nxv8s16*//*Label 31500*/ GIMT_Encode4(2455463),
    /*GILLT_nxv8s32*//*Label 31501*/ GIMT_Encode4(2455578),
    /*GILLT_nxv8s64*//*Label 31502*/ GIMT_Encode4(2455693), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 31503*/ GIMT_Encode4(2455808),
    /*GILLT_nxv16s16*//*Label 31504*/ GIMT_Encode4(2455923),
    /*GILLT_nxv16s32*//*Label 31505*/ GIMT_Encode4(2456038), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 31506*/ GIMT_Encode4(2456153),
    /*GILLT_nxv32s16*//*Label 31507*/ GIMT_Encode4(2456268), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 31508*/ GIMT_Encode4(2456383),
    // Label 31485: @2453858
    GIM_Try, /*On fail goto*//*Label 31510*/ GIMT_Encode4(2453912),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31511*/ GIMT_Encode4(2453896), // Rule ID 63875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63875,
        GIR_Done,
      // Label 31511: @2453896
      GIM_Try, /*On fail goto*//*Label 31512*/ GIMT_Encode4(2453911), // Rule ID 2387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2387,
        GIR_Done,
      // Label 31512: @2453911
      GIM_Reject,
    // Label 31510: @2453912
    GIM_Reject,
    // Label 31486: @2453913
    GIM_Try, /*On fail goto*//*Label 31513*/ GIMT_Encode4(2453967),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31514*/ GIMT_Encode4(2453951), // Rule ID 63874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63874,
        GIR_Done,
      // Label 31514: @2453951
      GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2453966), // Rule ID 2386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2386,
        GIR_Done,
      // Label 31515: @2453966
      GIM_Reject,
    // Label 31513: @2453967
    GIM_Reject,
    // Label 31487: @2453968
    GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2454082),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2454036), // Rule ID 50146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50146,
        GIR_EraseRootFromParent_Done,
      // Label 31517: @2454036
      GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2454081), // Rule ID 50147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50147,
        GIR_EraseRootFromParent_Done,
      // Label 31518: @2454081
      GIM_Reject,
    // Label 31516: @2454082
    GIM_Reject,
    // Label 31488: @2454083
    GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2454197),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2454151), // Rule ID 50158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50158,
        GIR_EraseRootFromParent_Done,
      // Label 31520: @2454151
      GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2454196), // Rule ID 50159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50159,
        GIR_EraseRootFromParent_Done,
      // Label 31521: @2454196
      GIM_Reject,
    // Label 31519: @2454197
    GIM_Reject,
    // Label 31489: @2454198
    GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2454312),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2454266), // Rule ID 50166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50166,
        GIR_EraseRootFromParent_Done,
      // Label 31523: @2454266
      GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2454311), // Rule ID 50167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50167,
        GIR_EraseRootFromParent_Done,
      // Label 31524: @2454311
      GIM_Reject,
    // Label 31522: @2454312
    GIM_Reject,
    // Label 31490: @2454313
    GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2454427),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2454381), // Rule ID 50182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50182,
        GIR_EraseRootFromParent_Done,
      // Label 31526: @2454381
      GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2454426), // Rule ID 50183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50183,
        GIR_EraseRootFromParent_Done,
      // Label 31527: @2454426
      GIM_Reject,
    // Label 31525: @2454427
    GIM_Reject,
    // Label 31491: @2454428
    GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2454542),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2454496), // Rule ID 50150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50150,
        GIR_EraseRootFromParent_Done,
      // Label 31529: @2454496
      GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2454541), // Rule ID 50151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50151,
        GIR_EraseRootFromParent_Done,
      // Label 31530: @2454541
      GIM_Reject,
    // Label 31528: @2454542
    GIM_Reject,
    // Label 31492: @2454543
    GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2454657),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2454611), // Rule ID 50162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50162,
        GIR_EraseRootFromParent_Done,
      // Label 31532: @2454611
      GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2454656), // Rule ID 50163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50163,
        GIR_EraseRootFromParent_Done,
      // Label 31533: @2454656
      GIM_Reject,
    // Label 31531: @2454657
    GIM_Reject,
    // Label 31493: @2454658
    GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2454772),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2454726), // Rule ID 50178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50178,
        GIR_EraseRootFromParent_Done,
      // Label 31535: @2454726
      GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2454771), // Rule ID 50179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50179,
        GIR_EraseRootFromParent_Done,
      // Label 31536: @2454771
      GIM_Reject,
    // Label 31534: @2454772
    GIM_Reject,
    // Label 31494: @2454773
    GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2454887),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2454841), // Rule ID 50222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50222,
        GIR_EraseRootFromParent_Done,
      // Label 31538: @2454841
      GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2454886), // Rule ID 50223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50223,
        GIR_EraseRootFromParent_Done,
      // Label 31539: @2454886
      GIM_Reject,
    // Label 31537: @2454887
    GIM_Reject,
    // Label 31495: @2454888
    GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2455002),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2454956), // Rule ID 50154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50154,
        GIR_EraseRootFromParent_Done,
      // Label 31541: @2454956
      GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2455001), // Rule ID 50155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50155,
        GIR_EraseRootFromParent_Done,
      // Label 31542: @2455001
      GIM_Reject,
    // Label 31540: @2455002
    GIM_Reject,
    // Label 31496: @2455003
    GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2455117),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2455071), // Rule ID 50174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50174,
        GIR_EraseRootFromParent_Done,
      // Label 31544: @2455071
      GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2455116), // Rule ID 50175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50175,
        GIR_EraseRootFromParent_Done,
      // Label 31545: @2455116
      GIM_Reject,
    // Label 31543: @2455117
    GIM_Reject,
    // Label 31497: @2455118
    GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2455232),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2455186), // Rule ID 50210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50210,
        GIR_EraseRootFromParent_Done,
      // Label 31547: @2455186
      GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2455231), // Rule ID 50211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50211,
        GIR_EraseRootFromParent_Done,
      // Label 31548: @2455231
      GIM_Reject,
    // Label 31546: @2455232
    GIM_Reject,
    // Label 31498: @2455233
    GIM_Try, /*On fail goto*//*Label 31549*/ GIMT_Encode4(2455347),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31550*/ GIMT_Encode4(2455301), // Rule ID 50226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50226,
        GIR_EraseRootFromParent_Done,
      // Label 31550: @2455301
      GIM_Try, /*On fail goto*//*Label 31551*/ GIMT_Encode4(2455346), // Rule ID 50227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50227,
        GIR_EraseRootFromParent_Done,
      // Label 31551: @2455346
      GIM_Reject,
    // Label 31549: @2455347
    GIM_Reject,
    // Label 31499: @2455348
    GIM_Try, /*On fail goto*//*Label 31552*/ GIMT_Encode4(2455462),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31553*/ GIMT_Encode4(2455416), // Rule ID 50170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50170,
        GIR_EraseRootFromParent_Done,
      // Label 31553: @2455416
      GIM_Try, /*On fail goto*//*Label 31554*/ GIMT_Encode4(2455461), // Rule ID 50171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50171,
        GIR_EraseRootFromParent_Done,
      // Label 31554: @2455461
      GIM_Reject,
    // Label 31552: @2455462
    GIM_Reject,
    // Label 31500: @2455463
    GIM_Try, /*On fail goto*//*Label 31555*/ GIMT_Encode4(2455577),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31556*/ GIMT_Encode4(2455531), // Rule ID 50198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50198,
        GIR_EraseRootFromParent_Done,
      // Label 31556: @2455531
      GIM_Try, /*On fail goto*//*Label 31557*/ GIMT_Encode4(2455576), // Rule ID 50199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50199,
        GIR_EraseRootFromParent_Done,
      // Label 31557: @2455576
      GIM_Reject,
    // Label 31555: @2455577
    GIM_Reject,
    // Label 31501: @2455578
    GIM_Try, /*On fail goto*//*Label 31558*/ GIMT_Encode4(2455692),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31559*/ GIMT_Encode4(2455646), // Rule ID 50214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50214,
        GIR_EraseRootFromParent_Done,
      // Label 31559: @2455646
      GIM_Try, /*On fail goto*//*Label 31560*/ GIMT_Encode4(2455691), // Rule ID 50215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50215,
        GIR_EraseRootFromParent_Done,
      // Label 31560: @2455691
      GIM_Reject,
    // Label 31558: @2455692
    GIM_Reject,
    // Label 31502: @2455693
    GIM_Try, /*On fail goto*//*Label 31561*/ GIMT_Encode4(2455807),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31562*/ GIMT_Encode4(2455761), // Rule ID 50230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50230,
        GIR_EraseRootFromParent_Done,
      // Label 31562: @2455761
      GIM_Try, /*On fail goto*//*Label 31563*/ GIMT_Encode4(2455806), // Rule ID 50231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50231,
        GIR_EraseRootFromParent_Done,
      // Label 31563: @2455806
      GIM_Reject,
    // Label 31561: @2455807
    GIM_Reject,
    // Label 31503: @2455808
    GIM_Try, /*On fail goto*//*Label 31564*/ GIMT_Encode4(2455922),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31565*/ GIMT_Encode4(2455876), // Rule ID 50186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50186,
        GIR_EraseRootFromParent_Done,
      // Label 31565: @2455876
      GIM_Try, /*On fail goto*//*Label 31566*/ GIMT_Encode4(2455921), // Rule ID 50187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50187,
        GIR_EraseRootFromParent_Done,
      // Label 31566: @2455921
      GIM_Reject,
    // Label 31564: @2455922
    GIM_Reject,
    // Label 31504: @2455923
    GIM_Try, /*On fail goto*//*Label 31567*/ GIMT_Encode4(2456037),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31568*/ GIMT_Encode4(2455991), // Rule ID 50202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50202,
        GIR_EraseRootFromParent_Done,
      // Label 31568: @2455991
      GIM_Try, /*On fail goto*//*Label 31569*/ GIMT_Encode4(2456036), // Rule ID 50203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50203,
        GIR_EraseRootFromParent_Done,
      // Label 31569: @2456036
      GIM_Reject,
    // Label 31567: @2456037
    GIM_Reject,
    // Label 31505: @2456038
    GIM_Try, /*On fail goto*//*Label 31570*/ GIMT_Encode4(2456152),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31571*/ GIMT_Encode4(2456106), // Rule ID 50218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50218,
        GIR_EraseRootFromParent_Done,
      // Label 31571: @2456106
      GIM_Try, /*On fail goto*//*Label 31572*/ GIMT_Encode4(2456151), // Rule ID 50219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50219,
        GIR_EraseRootFromParent_Done,
      // Label 31572: @2456151
      GIM_Reject,
    // Label 31570: @2456152
    GIM_Reject,
    // Label 31506: @2456153
    GIM_Try, /*On fail goto*//*Label 31573*/ GIMT_Encode4(2456267),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31574*/ GIMT_Encode4(2456221), // Rule ID 50190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50190,
        GIR_EraseRootFromParent_Done,
      // Label 31574: @2456221
      GIM_Try, /*On fail goto*//*Label 31575*/ GIMT_Encode4(2456266), // Rule ID 50191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50191,
        GIR_EraseRootFromParent_Done,
      // Label 31575: @2456266
      GIM_Reject,
    // Label 31573: @2456267
    GIM_Reject,
    // Label 31507: @2456268
    GIM_Try, /*On fail goto*//*Label 31576*/ GIMT_Encode4(2456382),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31577*/ GIMT_Encode4(2456336), // Rule ID 50206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50206,
        GIR_EraseRootFromParent_Done,
      // Label 31577: @2456336
      GIM_Try, /*On fail goto*//*Label 31578*/ GIMT_Encode4(2456381), // Rule ID 50207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50207,
        GIR_EraseRootFromParent_Done,
      // Label 31578: @2456381
      GIM_Reject,
    // Label 31576: @2456382
    GIM_Reject,
    // Label 31508: @2456383
    GIM_Try, /*On fail goto*//*Label 31579*/ GIMT_Encode4(2456497),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31580*/ GIMT_Encode4(2456451), // Rule ID 50194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50194,
        GIR_EraseRootFromParent_Done,
      // Label 31580: @2456451
      GIM_Try, /*On fail goto*//*Label 31581*/ GIMT_Encode4(2456496), // Rule ID 50195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50195,
        GIR_EraseRootFromParent_Done,
      // Label 31581: @2456496
      GIM_Reject,
    // Label 31579: @2456497
    GIM_Reject,
    // Label 31509: @2456498
    GIM_Reject,
    // Label 77: @2456499
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31606*/ GIMT_Encode4(2459274),
    /*GILLT_s32*//*Label 31582*/ GIMT_Encode4(2456634),
    /*GILLT_s64*//*Label 31583*/ GIMT_Encode4(2456689), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 31584*/ GIMT_Encode4(2456744),
    /*GILLT_nxv1s16*//*Label 31585*/ GIMT_Encode4(2456859),
    /*GILLT_nxv1s32*//*Label 31586*/ GIMT_Encode4(2456974),
    /*GILLT_nxv1s64*//*Label 31587*/ GIMT_Encode4(2457089), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 31588*/ GIMT_Encode4(2457204),
    /*GILLT_nxv2s16*//*Label 31589*/ GIMT_Encode4(2457319),
    /*GILLT_nxv2s32*//*Label 31590*/ GIMT_Encode4(2457434),
    /*GILLT_nxv2s64*//*Label 31591*/ GIMT_Encode4(2457549), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 31592*/ GIMT_Encode4(2457664),
    /*GILLT_nxv4s16*//*Label 31593*/ GIMT_Encode4(2457779),
    /*GILLT_nxv4s32*//*Label 31594*/ GIMT_Encode4(2457894),
    /*GILLT_nxv4s64*//*Label 31595*/ GIMT_Encode4(2458009), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 31596*/ GIMT_Encode4(2458124),
    /*GILLT_nxv8s16*//*Label 31597*/ GIMT_Encode4(2458239),
    /*GILLT_nxv8s32*//*Label 31598*/ GIMT_Encode4(2458354),
    /*GILLT_nxv8s64*//*Label 31599*/ GIMT_Encode4(2458469), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 31600*/ GIMT_Encode4(2458584),
    /*GILLT_nxv16s16*//*Label 31601*/ GIMT_Encode4(2458699),
    /*GILLT_nxv16s32*//*Label 31602*/ GIMT_Encode4(2458814), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 31603*/ GIMT_Encode4(2458929),
    /*GILLT_nxv32s16*//*Label 31604*/ GIMT_Encode4(2459044), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 31605*/ GIMT_Encode4(2459159),
    // Label 31582: @2456634
    GIM_Try, /*On fail goto*//*Label 31607*/ GIMT_Encode4(2456688),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31608*/ GIMT_Encode4(2456672), // Rule ID 63879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63879,
        GIR_Done,
      // Label 31608: @2456672
      GIM_Try, /*On fail goto*//*Label 31609*/ GIMT_Encode4(2456687), // Rule ID 2389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2389,
        GIR_Done,
      // Label 31609: @2456687
      GIM_Reject,
    // Label 31607: @2456688
    GIM_Reject,
    // Label 31583: @2456689
    GIM_Try, /*On fail goto*//*Label 31610*/ GIMT_Encode4(2456743),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31611*/ GIMT_Encode4(2456727), // Rule ID 63878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63878,
        GIR_Done,
      // Label 31611: @2456727
      GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2456742), // Rule ID 2388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2388,
        GIR_Done,
      // Label 31612: @2456742
      GIM_Reject,
    // Label 31610: @2456743
    GIM_Reject,
    // Label 31584: @2456744
    GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2456858),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2456812), // Rule ID 50322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50322,
        GIR_EraseRootFromParent_Done,
      // Label 31614: @2456812
      GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2456857), // Rule ID 50323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50323,
        GIR_EraseRootFromParent_Done,
      // Label 31615: @2456857
      GIM_Reject,
    // Label 31613: @2456858
    GIM_Reject,
    // Label 31585: @2456859
    GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2456973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2456927), // Rule ID 50334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50334,
        GIR_EraseRootFromParent_Done,
      // Label 31617: @2456927
      GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2456972), // Rule ID 50335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50335,
        GIR_EraseRootFromParent_Done,
      // Label 31618: @2456972
      GIM_Reject,
    // Label 31616: @2456973
    GIM_Reject,
    // Label 31586: @2456974
    GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2457088),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2457042), // Rule ID 50342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50342,
        GIR_EraseRootFromParent_Done,
      // Label 31620: @2457042
      GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2457087), // Rule ID 50343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50343,
        GIR_EraseRootFromParent_Done,
      // Label 31621: @2457087
      GIM_Reject,
    // Label 31619: @2457088
    GIM_Reject,
    // Label 31587: @2457089
    GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2457203),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2457157), // Rule ID 50358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50358,
        GIR_EraseRootFromParent_Done,
      // Label 31623: @2457157
      GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2457202), // Rule ID 50359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50359,
        GIR_EraseRootFromParent_Done,
      // Label 31624: @2457202
      GIM_Reject,
    // Label 31622: @2457203
    GIM_Reject,
    // Label 31588: @2457204
    GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2457318),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2457272), // Rule ID 50326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50326,
        GIR_EraseRootFromParent_Done,
      // Label 31626: @2457272
      GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2457317), // Rule ID 50327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50327,
        GIR_EraseRootFromParent_Done,
      // Label 31627: @2457317
      GIM_Reject,
    // Label 31625: @2457318
    GIM_Reject,
    // Label 31589: @2457319
    GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2457433),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31629*/ GIMT_Encode4(2457387), // Rule ID 50338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50338,
        GIR_EraseRootFromParent_Done,
      // Label 31629: @2457387
      GIM_Try, /*On fail goto*//*Label 31630*/ GIMT_Encode4(2457432), // Rule ID 50339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50339,
        GIR_EraseRootFromParent_Done,
      // Label 31630: @2457432
      GIM_Reject,
    // Label 31628: @2457433
    GIM_Reject,
    // Label 31590: @2457434
    GIM_Try, /*On fail goto*//*Label 31631*/ GIMT_Encode4(2457548),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31632*/ GIMT_Encode4(2457502), // Rule ID 50354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50354,
        GIR_EraseRootFromParent_Done,
      // Label 31632: @2457502
      GIM_Try, /*On fail goto*//*Label 31633*/ GIMT_Encode4(2457547), // Rule ID 50355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50355,
        GIR_EraseRootFromParent_Done,
      // Label 31633: @2457547
      GIM_Reject,
    // Label 31631: @2457548
    GIM_Reject,
    // Label 31591: @2457549
    GIM_Try, /*On fail goto*//*Label 31634*/ GIMT_Encode4(2457663),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31635*/ GIMT_Encode4(2457617), // Rule ID 50398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50398,
        GIR_EraseRootFromParent_Done,
      // Label 31635: @2457617
      GIM_Try, /*On fail goto*//*Label 31636*/ GIMT_Encode4(2457662), // Rule ID 50399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50399,
        GIR_EraseRootFromParent_Done,
      // Label 31636: @2457662
      GIM_Reject,
    // Label 31634: @2457663
    GIM_Reject,
    // Label 31592: @2457664
    GIM_Try, /*On fail goto*//*Label 31637*/ GIMT_Encode4(2457778),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31638*/ GIMT_Encode4(2457732), // Rule ID 50330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50330,
        GIR_EraseRootFromParent_Done,
      // Label 31638: @2457732
      GIM_Try, /*On fail goto*//*Label 31639*/ GIMT_Encode4(2457777), // Rule ID 50331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50331,
        GIR_EraseRootFromParent_Done,
      // Label 31639: @2457777
      GIM_Reject,
    // Label 31637: @2457778
    GIM_Reject,
    // Label 31593: @2457779
    GIM_Try, /*On fail goto*//*Label 31640*/ GIMT_Encode4(2457893),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31641*/ GIMT_Encode4(2457847), // Rule ID 50350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50350,
        GIR_EraseRootFromParent_Done,
      // Label 31641: @2457847
      GIM_Try, /*On fail goto*//*Label 31642*/ GIMT_Encode4(2457892), // Rule ID 50351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50351,
        GIR_EraseRootFromParent_Done,
      // Label 31642: @2457892
      GIM_Reject,
    // Label 31640: @2457893
    GIM_Reject,
    // Label 31594: @2457894
    GIM_Try, /*On fail goto*//*Label 31643*/ GIMT_Encode4(2458008),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31644*/ GIMT_Encode4(2457962), // Rule ID 50386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50386,
        GIR_EraseRootFromParent_Done,
      // Label 31644: @2457962
      GIM_Try, /*On fail goto*//*Label 31645*/ GIMT_Encode4(2458007), // Rule ID 50387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50387,
        GIR_EraseRootFromParent_Done,
      // Label 31645: @2458007
      GIM_Reject,
    // Label 31643: @2458008
    GIM_Reject,
    // Label 31595: @2458009
    GIM_Try, /*On fail goto*//*Label 31646*/ GIMT_Encode4(2458123),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31647*/ GIMT_Encode4(2458077), // Rule ID 50402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50402,
        GIR_EraseRootFromParent_Done,
      // Label 31647: @2458077
      GIM_Try, /*On fail goto*//*Label 31648*/ GIMT_Encode4(2458122), // Rule ID 50403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50403,
        GIR_EraseRootFromParent_Done,
      // Label 31648: @2458122
      GIM_Reject,
    // Label 31646: @2458123
    GIM_Reject,
    // Label 31596: @2458124
    GIM_Try, /*On fail goto*//*Label 31649*/ GIMT_Encode4(2458238),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31650*/ GIMT_Encode4(2458192), // Rule ID 50346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50346,
        GIR_EraseRootFromParent_Done,
      // Label 31650: @2458192
      GIM_Try, /*On fail goto*//*Label 31651*/ GIMT_Encode4(2458237), // Rule ID 50347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50347,
        GIR_EraseRootFromParent_Done,
      // Label 31651: @2458237
      GIM_Reject,
    // Label 31649: @2458238
    GIM_Reject,
    // Label 31597: @2458239
    GIM_Try, /*On fail goto*//*Label 31652*/ GIMT_Encode4(2458353),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2458307), // Rule ID 50374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50374,
        GIR_EraseRootFromParent_Done,
      // Label 31653: @2458307
      GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2458352), // Rule ID 50375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50375,
        GIR_EraseRootFromParent_Done,
      // Label 31654: @2458352
      GIM_Reject,
    // Label 31652: @2458353
    GIM_Reject,
    // Label 31598: @2458354
    GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2458468),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2458422), // Rule ID 50390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50390,
        GIR_EraseRootFromParent_Done,
      // Label 31656: @2458422
      GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2458467), // Rule ID 50391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50391,
        GIR_EraseRootFromParent_Done,
      // Label 31657: @2458467
      GIM_Reject,
    // Label 31655: @2458468
    GIM_Reject,
    // Label 31599: @2458469
    GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2458583),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2458537), // Rule ID 50406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50406,
        GIR_EraseRootFromParent_Done,
      // Label 31659: @2458537
      GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2458582), // Rule ID 50407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50407,
        GIR_EraseRootFromParent_Done,
      // Label 31660: @2458582
      GIM_Reject,
    // Label 31658: @2458583
    GIM_Reject,
    // Label 31600: @2458584
    GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2458698),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2458652), // Rule ID 50362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50362,
        GIR_EraseRootFromParent_Done,
      // Label 31662: @2458652
      GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2458697), // Rule ID 50363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50363,
        GIR_EraseRootFromParent_Done,
      // Label 31663: @2458697
      GIM_Reject,
    // Label 31661: @2458698
    GIM_Reject,
    // Label 31601: @2458699
    GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2458813),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2458767), // Rule ID 50378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50378,
        GIR_EraseRootFromParent_Done,
      // Label 31665: @2458767
      GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2458812), // Rule ID 50379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50379,
        GIR_EraseRootFromParent_Done,
      // Label 31666: @2458812
      GIM_Reject,
    // Label 31664: @2458813
    GIM_Reject,
    // Label 31602: @2458814
    GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2458928),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2458882), // Rule ID 50394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50394,
        GIR_EraseRootFromParent_Done,
      // Label 31668: @2458882
      GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2458927), // Rule ID 50395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50395,
        GIR_EraseRootFromParent_Done,
      // Label 31669: @2458927
      GIM_Reject,
    // Label 31667: @2458928
    GIM_Reject,
    // Label 31603: @2458929
    GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2459043),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2458997), // Rule ID 50366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50366,
        GIR_EraseRootFromParent_Done,
      // Label 31671: @2458997
      GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2459042), // Rule ID 50367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50367,
        GIR_EraseRootFromParent_Done,
      // Label 31672: @2459042
      GIM_Reject,
    // Label 31670: @2459043
    GIM_Reject,
    // Label 31604: @2459044
    GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2459158),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2459112), // Rule ID 50382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50382,
        GIR_EraseRootFromParent_Done,
      // Label 31674: @2459112
      GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2459157), // Rule ID 50383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50383,
        GIR_EraseRootFromParent_Done,
      // Label 31675: @2459157
      GIM_Reject,
    // Label 31673: @2459158
    GIM_Reject,
    // Label 31605: @2459159
    GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2459273),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2459227), // Rule ID 50370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50370,
        GIR_EraseRootFromParent_Done,
      // Label 31677: @2459227
      GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2459272), // Rule ID 50371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50371,
        GIR_EraseRootFromParent_Done,
      // Label 31678: @2459272
      GIM_Reject,
    // Label 31676: @2459273
    GIM_Reject,
    // Label 31606: @2459274
    GIM_Reject,
    // Label 78: @2459275
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31703*/ GIMT_Encode4(2462050),
    /*GILLT_s32*//*Label 31679*/ GIMT_Encode4(2459410),
    /*GILLT_s64*//*Label 31680*/ GIMT_Encode4(2459465), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 31681*/ GIMT_Encode4(2459520),
    /*GILLT_nxv1s16*//*Label 31682*/ GIMT_Encode4(2459635),
    /*GILLT_nxv1s32*//*Label 31683*/ GIMT_Encode4(2459750),
    /*GILLT_nxv1s64*//*Label 31684*/ GIMT_Encode4(2459865), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 31685*/ GIMT_Encode4(2459980),
    /*GILLT_nxv2s16*//*Label 31686*/ GIMT_Encode4(2460095),
    /*GILLT_nxv2s32*//*Label 31687*/ GIMT_Encode4(2460210),
    /*GILLT_nxv2s64*//*Label 31688*/ GIMT_Encode4(2460325), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 31689*/ GIMT_Encode4(2460440),
    /*GILLT_nxv4s16*//*Label 31690*/ GIMT_Encode4(2460555),
    /*GILLT_nxv4s32*//*Label 31691*/ GIMT_Encode4(2460670),
    /*GILLT_nxv4s64*//*Label 31692*/ GIMT_Encode4(2460785), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 31693*/ GIMT_Encode4(2460900),
    /*GILLT_nxv8s16*//*Label 31694*/ GIMT_Encode4(2461015),
    /*GILLT_nxv8s32*//*Label 31695*/ GIMT_Encode4(2461130),
    /*GILLT_nxv8s64*//*Label 31696*/ GIMT_Encode4(2461245), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 31697*/ GIMT_Encode4(2461360),
    /*GILLT_nxv16s16*//*Label 31698*/ GIMT_Encode4(2461475),
    /*GILLT_nxv16s32*//*Label 31699*/ GIMT_Encode4(2461590), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 31700*/ GIMT_Encode4(2461705),
    /*GILLT_nxv32s16*//*Label 31701*/ GIMT_Encode4(2461820), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 31702*/ GIMT_Encode4(2461935),
    // Label 31679: @2459410
    GIM_Try, /*On fail goto*//*Label 31704*/ GIMT_Encode4(2459464),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31705*/ GIMT_Encode4(2459448), // Rule ID 63877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63877,
        GIR_Done,
      // Label 31705: @2459448
      GIM_Try, /*On fail goto*//*Label 31706*/ GIMT_Encode4(2459463), // Rule ID 2391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2391,
        GIR_Done,
      // Label 31706: @2459463
      GIM_Reject,
    // Label 31704: @2459464
    GIM_Reject,
    // Label 31680: @2459465
    GIM_Try, /*On fail goto*//*Label 31707*/ GIMT_Encode4(2459519),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31708*/ GIMT_Encode4(2459503), // Rule ID 63876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63876,
        GIR_Done,
      // Label 31708: @2459503
      GIM_Try, /*On fail goto*//*Label 31709*/ GIMT_Encode4(2459518), // Rule ID 2390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2390,
        GIR_Done,
      // Label 31709: @2459518
      GIM_Reject,
    // Label 31707: @2459519
    GIM_Reject,
    // Label 31681: @2459520
    GIM_Try, /*On fail goto*//*Label 31710*/ GIMT_Encode4(2459634),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31711*/ GIMT_Encode4(2459588), // Rule ID 50058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50058,
        GIR_EraseRootFromParent_Done,
      // Label 31711: @2459588
      GIM_Try, /*On fail goto*//*Label 31712*/ GIMT_Encode4(2459633), // Rule ID 50059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50059,
        GIR_EraseRootFromParent_Done,
      // Label 31712: @2459633
      GIM_Reject,
    // Label 31710: @2459634
    GIM_Reject,
    // Label 31682: @2459635
    GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2459749),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31714*/ GIMT_Encode4(2459703), // Rule ID 50070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50070,
        GIR_EraseRootFromParent_Done,
      // Label 31714: @2459703
      GIM_Try, /*On fail goto*//*Label 31715*/ GIMT_Encode4(2459748), // Rule ID 50071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50071,
        GIR_EraseRootFromParent_Done,
      // Label 31715: @2459748
      GIM_Reject,
    // Label 31713: @2459749
    GIM_Reject,
    // Label 31683: @2459750
    GIM_Try, /*On fail goto*//*Label 31716*/ GIMT_Encode4(2459864),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31717*/ GIMT_Encode4(2459818), // Rule ID 50078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50078,
        GIR_EraseRootFromParent_Done,
      // Label 31717: @2459818
      GIM_Try, /*On fail goto*//*Label 31718*/ GIMT_Encode4(2459863), // Rule ID 50079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50079,
        GIR_EraseRootFromParent_Done,
      // Label 31718: @2459863
      GIM_Reject,
    // Label 31716: @2459864
    GIM_Reject,
    // Label 31684: @2459865
    GIM_Try, /*On fail goto*//*Label 31719*/ GIMT_Encode4(2459979),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31720*/ GIMT_Encode4(2459933), // Rule ID 50094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50094,
        GIR_EraseRootFromParent_Done,
      // Label 31720: @2459933
      GIM_Try, /*On fail goto*//*Label 31721*/ GIMT_Encode4(2459978), // Rule ID 50095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50095,
        GIR_EraseRootFromParent_Done,
      // Label 31721: @2459978
      GIM_Reject,
    // Label 31719: @2459979
    GIM_Reject,
    // Label 31685: @2459980
    GIM_Try, /*On fail goto*//*Label 31722*/ GIMT_Encode4(2460094),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31723*/ GIMT_Encode4(2460048), // Rule ID 50062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50062,
        GIR_EraseRootFromParent_Done,
      // Label 31723: @2460048
      GIM_Try, /*On fail goto*//*Label 31724*/ GIMT_Encode4(2460093), // Rule ID 50063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50063,
        GIR_EraseRootFromParent_Done,
      // Label 31724: @2460093
      GIM_Reject,
    // Label 31722: @2460094
    GIM_Reject,
    // Label 31686: @2460095
    GIM_Try, /*On fail goto*//*Label 31725*/ GIMT_Encode4(2460209),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31726*/ GIMT_Encode4(2460163), // Rule ID 50074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50074,
        GIR_EraseRootFromParent_Done,
      // Label 31726: @2460163
      GIM_Try, /*On fail goto*//*Label 31727*/ GIMT_Encode4(2460208), // Rule ID 50075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50075,
        GIR_EraseRootFromParent_Done,
      // Label 31727: @2460208
      GIM_Reject,
    // Label 31725: @2460209
    GIM_Reject,
    // Label 31687: @2460210
    GIM_Try, /*On fail goto*//*Label 31728*/ GIMT_Encode4(2460324),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31729*/ GIMT_Encode4(2460278), // Rule ID 50090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50090,
        GIR_EraseRootFromParent_Done,
      // Label 31729: @2460278
      GIM_Try, /*On fail goto*//*Label 31730*/ GIMT_Encode4(2460323), // Rule ID 50091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50091,
        GIR_EraseRootFromParent_Done,
      // Label 31730: @2460323
      GIM_Reject,
    // Label 31728: @2460324
    GIM_Reject,
    // Label 31688: @2460325
    GIM_Try, /*On fail goto*//*Label 31731*/ GIMT_Encode4(2460439),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31732*/ GIMT_Encode4(2460393), // Rule ID 50134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50134,
        GIR_EraseRootFromParent_Done,
      // Label 31732: @2460393
      GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2460438), // Rule ID 50135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50135,
        GIR_EraseRootFromParent_Done,
      // Label 31733: @2460438
      GIM_Reject,
    // Label 31731: @2460439
    GIM_Reject,
    // Label 31689: @2460440
    GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2460554),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2460508), // Rule ID 50066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50066,
        GIR_EraseRootFromParent_Done,
      // Label 31735: @2460508
      GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2460553), // Rule ID 50067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50067,
        GIR_EraseRootFromParent_Done,
      // Label 31736: @2460553
      GIM_Reject,
    // Label 31734: @2460554
    GIM_Reject,
    // Label 31690: @2460555
    GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2460669),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2460623), // Rule ID 50086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50086,
        GIR_EraseRootFromParent_Done,
      // Label 31738: @2460623
      GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2460668), // Rule ID 50087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50087,
        GIR_EraseRootFromParent_Done,
      // Label 31739: @2460668
      GIM_Reject,
    // Label 31737: @2460669
    GIM_Reject,
    // Label 31691: @2460670
    GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2460784),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2460738), // Rule ID 50122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50122,
        GIR_EraseRootFromParent_Done,
      // Label 31741: @2460738
      GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2460783), // Rule ID 50123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50123,
        GIR_EraseRootFromParent_Done,
      // Label 31742: @2460783
      GIM_Reject,
    // Label 31740: @2460784
    GIM_Reject,
    // Label 31692: @2460785
    GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2460899),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2460853), // Rule ID 50138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50138,
        GIR_EraseRootFromParent_Done,
      // Label 31744: @2460853
      GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2460898), // Rule ID 50139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50139,
        GIR_EraseRootFromParent_Done,
      // Label 31745: @2460898
      GIM_Reject,
    // Label 31743: @2460899
    GIM_Reject,
    // Label 31693: @2460900
    GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2461014),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2460968), // Rule ID 50082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50082,
        GIR_EraseRootFromParent_Done,
      // Label 31747: @2460968
      GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2461013), // Rule ID 50083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50083,
        GIR_EraseRootFromParent_Done,
      // Label 31748: @2461013
      GIM_Reject,
    // Label 31746: @2461014
    GIM_Reject,
    // Label 31694: @2461015
    GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2461129),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2461083), // Rule ID 50110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50110,
        GIR_EraseRootFromParent_Done,
      // Label 31750: @2461083
      GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2461128), // Rule ID 50111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50111,
        GIR_EraseRootFromParent_Done,
      // Label 31751: @2461128
      GIM_Reject,
    // Label 31749: @2461129
    GIM_Reject,
    // Label 31695: @2461130
    GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2461244),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2461198), // Rule ID 50126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50126,
        GIR_EraseRootFromParent_Done,
      // Label 31753: @2461198
      GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2461243), // Rule ID 50127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50127,
        GIR_EraseRootFromParent_Done,
      // Label 31754: @2461243
      GIM_Reject,
    // Label 31752: @2461244
    GIM_Reject,
    // Label 31696: @2461245
    GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2461359),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2461313), // Rule ID 50142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50142,
        GIR_EraseRootFromParent_Done,
      // Label 31756: @2461313
      GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2461358), // Rule ID 50143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50143,
        GIR_EraseRootFromParent_Done,
      // Label 31757: @2461358
      GIM_Reject,
    // Label 31755: @2461359
    GIM_Reject,
    // Label 31697: @2461360
    GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2461474),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2461428), // Rule ID 50098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50098,
        GIR_EraseRootFromParent_Done,
      // Label 31759: @2461428
      GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2461473), // Rule ID 50099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50099,
        GIR_EraseRootFromParent_Done,
      // Label 31760: @2461473
      GIM_Reject,
    // Label 31758: @2461474
    GIM_Reject,
    // Label 31698: @2461475
    GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2461589),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2461543), // Rule ID 50114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50114,
        GIR_EraseRootFromParent_Done,
      // Label 31762: @2461543
      GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2461588), // Rule ID 50115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50115,
        GIR_EraseRootFromParent_Done,
      // Label 31763: @2461588
      GIM_Reject,
    // Label 31761: @2461589
    GIM_Reject,
    // Label 31699: @2461590
    GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2461704),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2461658), // Rule ID 50130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50130,
        GIR_EraseRootFromParent_Done,
      // Label 31765: @2461658
      GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2461703), // Rule ID 50131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50131,
        GIR_EraseRootFromParent_Done,
      // Label 31766: @2461703
      GIM_Reject,
    // Label 31764: @2461704
    GIM_Reject,
    // Label 31700: @2461705
    GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2461819),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2461773), // Rule ID 50102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50102,
        GIR_EraseRootFromParent_Done,
      // Label 31768: @2461773
      GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2461818), // Rule ID 50103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50103,
        GIR_EraseRootFromParent_Done,
      // Label 31769: @2461818
      GIM_Reject,
    // Label 31767: @2461819
    GIM_Reject,
    // Label 31701: @2461820
    GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2461934),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2461888), // Rule ID 50118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50118,
        GIR_EraseRootFromParent_Done,
      // Label 31771: @2461888
      GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2461933), // Rule ID 50119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50119,
        GIR_EraseRootFromParent_Done,
      // Label 31772: @2461933
      GIM_Reject,
    // Label 31770: @2461934
    GIM_Reject,
    // Label 31702: @2461935
    GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2462049),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31774*/ GIMT_Encode4(2462003), // Rule ID 50106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50106,
        GIR_EraseRootFromParent_Done,
      // Label 31774: @2462003
      GIM_Try, /*On fail goto*//*Label 31775*/ GIMT_Encode4(2462048), // Rule ID 50107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50107,
        GIR_EraseRootFromParent_Done,
      // Label 31775: @2462048
      GIM_Reject,
    // Label 31773: @2462049
    GIM_Reject,
    // Label 31703: @2462050
    GIM_Reject,
    // Label 79: @2462051
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31800*/ GIMT_Encode4(2464826),
    /*GILLT_s32*//*Label 31776*/ GIMT_Encode4(2462186),
    /*GILLT_s64*//*Label 31777*/ GIMT_Encode4(2462241), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 31778*/ GIMT_Encode4(2462296),
    /*GILLT_nxv1s16*//*Label 31779*/ GIMT_Encode4(2462411),
    /*GILLT_nxv1s32*//*Label 31780*/ GIMT_Encode4(2462526),
    /*GILLT_nxv1s64*//*Label 31781*/ GIMT_Encode4(2462641), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 31782*/ GIMT_Encode4(2462756),
    /*GILLT_nxv2s16*//*Label 31783*/ GIMT_Encode4(2462871),
    /*GILLT_nxv2s32*//*Label 31784*/ GIMT_Encode4(2462986),
    /*GILLT_nxv2s64*//*Label 31785*/ GIMT_Encode4(2463101), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 31786*/ GIMT_Encode4(2463216),
    /*GILLT_nxv4s16*//*Label 31787*/ GIMT_Encode4(2463331),
    /*GILLT_nxv4s32*//*Label 31788*/ GIMT_Encode4(2463446),
    /*GILLT_nxv4s64*//*Label 31789*/ GIMT_Encode4(2463561), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 31790*/ GIMT_Encode4(2463676),
    /*GILLT_nxv8s16*//*Label 31791*/ GIMT_Encode4(2463791),
    /*GILLT_nxv8s32*//*Label 31792*/ GIMT_Encode4(2463906),
    /*GILLT_nxv8s64*//*Label 31793*/ GIMT_Encode4(2464021), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 31794*/ GIMT_Encode4(2464136),
    /*GILLT_nxv16s16*//*Label 31795*/ GIMT_Encode4(2464251),
    /*GILLT_nxv16s32*//*Label 31796*/ GIMT_Encode4(2464366), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 31797*/ GIMT_Encode4(2464481),
    /*GILLT_nxv32s16*//*Label 31798*/ GIMT_Encode4(2464596), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 31799*/ GIMT_Encode4(2464711),
    // Label 31776: @2462186
    GIM_Try, /*On fail goto*//*Label 31801*/ GIMT_Encode4(2462240),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31802*/ GIMT_Encode4(2462224), // Rule ID 63881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63881,
        GIR_Done,
      // Label 31802: @2462224
      GIM_Try, /*On fail goto*//*Label 31803*/ GIMT_Encode4(2462239), // Rule ID 2393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2393,
        GIR_Done,
      // Label 31803: @2462239
      GIM_Reject,
    // Label 31801: @2462240
    GIM_Reject,
    // Label 31777: @2462241
    GIM_Try, /*On fail goto*//*Label 31804*/ GIMT_Encode4(2462295),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31805*/ GIMT_Encode4(2462279), // Rule ID 63880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63880,
        GIR_Done,
      // Label 31805: @2462279
      GIM_Try, /*On fail goto*//*Label 31806*/ GIMT_Encode4(2462294), // Rule ID 2392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2392,
        GIR_Done,
      // Label 31806: @2462294
      GIM_Reject,
    // Label 31804: @2462295
    GIM_Reject,
    // Label 31778: @2462296
    GIM_Try, /*On fail goto*//*Label 31807*/ GIMT_Encode4(2462410),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31808*/ GIMT_Encode4(2462364), // Rule ID 50234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50234,
        GIR_EraseRootFromParent_Done,
      // Label 31808: @2462364
      GIM_Try, /*On fail goto*//*Label 31809*/ GIMT_Encode4(2462409), // Rule ID 50235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50235,
        GIR_EraseRootFromParent_Done,
      // Label 31809: @2462409
      GIM_Reject,
    // Label 31807: @2462410
    GIM_Reject,
    // Label 31779: @2462411
    GIM_Try, /*On fail goto*//*Label 31810*/ GIMT_Encode4(2462525),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31811*/ GIMT_Encode4(2462479), // Rule ID 50246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50246,
        GIR_EraseRootFromParent_Done,
      // Label 31811: @2462479
      GIM_Try, /*On fail goto*//*Label 31812*/ GIMT_Encode4(2462524), // Rule ID 50247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50247,
        GIR_EraseRootFromParent_Done,
      // Label 31812: @2462524
      GIM_Reject,
    // Label 31810: @2462525
    GIM_Reject,
    // Label 31780: @2462526
    GIM_Try, /*On fail goto*//*Label 31813*/ GIMT_Encode4(2462640),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31814*/ GIMT_Encode4(2462594), // Rule ID 50254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50254,
        GIR_EraseRootFromParent_Done,
      // Label 31814: @2462594
      GIM_Try, /*On fail goto*//*Label 31815*/ GIMT_Encode4(2462639), // Rule ID 50255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50255,
        GIR_EraseRootFromParent_Done,
      // Label 31815: @2462639
      GIM_Reject,
    // Label 31813: @2462640
    GIM_Reject,
    // Label 31781: @2462641
    GIM_Try, /*On fail goto*//*Label 31816*/ GIMT_Encode4(2462755),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31817*/ GIMT_Encode4(2462709), // Rule ID 50270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50270,
        GIR_EraseRootFromParent_Done,
      // Label 31817: @2462709
      GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2462754), // Rule ID 50271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50271,
        GIR_EraseRootFromParent_Done,
      // Label 31818: @2462754
      GIM_Reject,
    // Label 31816: @2462755
    GIM_Reject,
    // Label 31782: @2462756
    GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2462870),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2462824), // Rule ID 50238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50238,
        GIR_EraseRootFromParent_Done,
      // Label 31820: @2462824
      GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2462869), // Rule ID 50239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50239,
        GIR_EraseRootFromParent_Done,
      // Label 31821: @2462869
      GIM_Reject,
    // Label 31819: @2462870
    GIM_Reject,
    // Label 31783: @2462871
    GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2462985),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2462939), // Rule ID 50250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50250,
        GIR_EraseRootFromParent_Done,
      // Label 31823: @2462939
      GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2462984), // Rule ID 50251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50251,
        GIR_EraseRootFromParent_Done,
      // Label 31824: @2462984
      GIM_Reject,
    // Label 31822: @2462985
    GIM_Reject,
    // Label 31784: @2462986
    GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2463100),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2463054), // Rule ID 50266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50266,
        GIR_EraseRootFromParent_Done,
      // Label 31826: @2463054
      GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2463099), // Rule ID 50267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50267,
        GIR_EraseRootFromParent_Done,
      // Label 31827: @2463099
      GIM_Reject,
    // Label 31825: @2463100
    GIM_Reject,
    // Label 31785: @2463101
    GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2463215),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2463169), // Rule ID 50310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50310,
        GIR_EraseRootFromParent_Done,
      // Label 31829: @2463169
      GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2463214), // Rule ID 50311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50311,
        GIR_EraseRootFromParent_Done,
      // Label 31830: @2463214
      GIM_Reject,
    // Label 31828: @2463215
    GIM_Reject,
    // Label 31786: @2463216
    GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2463330),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2463284), // Rule ID 50242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50242,
        GIR_EraseRootFromParent_Done,
      // Label 31832: @2463284
      GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2463329), // Rule ID 50243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50243,
        GIR_EraseRootFromParent_Done,
      // Label 31833: @2463329
      GIM_Reject,
    // Label 31831: @2463330
    GIM_Reject,
    // Label 31787: @2463331
    GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2463445),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2463399), // Rule ID 50262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50262,
        GIR_EraseRootFromParent_Done,
      // Label 31835: @2463399
      GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2463444), // Rule ID 50263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50263,
        GIR_EraseRootFromParent_Done,
      // Label 31836: @2463444
      GIM_Reject,
    // Label 31834: @2463445
    GIM_Reject,
    // Label 31788: @2463446
    GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2463560),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2463514), // Rule ID 50298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50298,
        GIR_EraseRootFromParent_Done,
      // Label 31838: @2463514
      GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2463559), // Rule ID 50299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50299,
        GIR_EraseRootFromParent_Done,
      // Label 31839: @2463559
      GIM_Reject,
    // Label 31837: @2463560
    GIM_Reject,
    // Label 31789: @2463561
    GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2463675),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2463629), // Rule ID 50314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50314,
        GIR_EraseRootFromParent_Done,
      // Label 31841: @2463629
      GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2463674), // Rule ID 50315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50315,
        GIR_EraseRootFromParent_Done,
      // Label 31842: @2463674
      GIM_Reject,
    // Label 31840: @2463675
    GIM_Reject,
    // Label 31790: @2463676
    GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2463790),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2463744), // Rule ID 50258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50258,
        GIR_EraseRootFromParent_Done,
      // Label 31844: @2463744
      GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2463789), // Rule ID 50259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50259,
        GIR_EraseRootFromParent_Done,
      // Label 31845: @2463789
      GIM_Reject,
    // Label 31843: @2463790
    GIM_Reject,
    // Label 31791: @2463791
    GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2463905),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2463859), // Rule ID 50286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50286,
        GIR_EraseRootFromParent_Done,
      // Label 31847: @2463859
      GIM_Try, /*On fail goto*//*Label 31848*/ GIMT_Encode4(2463904), // Rule ID 50287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50287,
        GIR_EraseRootFromParent_Done,
      // Label 31848: @2463904
      GIM_Reject,
    // Label 31846: @2463905
    GIM_Reject,
    // Label 31792: @2463906
    GIM_Try, /*On fail goto*//*Label 31849*/ GIMT_Encode4(2464020),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31850*/ GIMT_Encode4(2463974), // Rule ID 50302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50302,
        GIR_EraseRootFromParent_Done,
      // Label 31850: @2463974
      GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2464019), // Rule ID 50303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50303,
        GIR_EraseRootFromParent_Done,
      // Label 31851: @2464019
      GIM_Reject,
    // Label 31849: @2464020
    GIM_Reject,
    // Label 31793: @2464021
    GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2464135),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2464089), // Rule ID 50318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50318,
        GIR_EraseRootFromParent_Done,
      // Label 31853: @2464089
      GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2464134), // Rule ID 50319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50319,
        GIR_EraseRootFromParent_Done,
      // Label 31854: @2464134
      GIM_Reject,
    // Label 31852: @2464135
    GIM_Reject,
    // Label 31794: @2464136
    GIM_Try, /*On fail goto*//*Label 31855*/ GIMT_Encode4(2464250),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31856*/ GIMT_Encode4(2464204), // Rule ID 50274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50274,
        GIR_EraseRootFromParent_Done,
      // Label 31856: @2464204
      GIM_Try, /*On fail goto*//*Label 31857*/ GIMT_Encode4(2464249), // Rule ID 50275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50275,
        GIR_EraseRootFromParent_Done,
      // Label 31857: @2464249
      GIM_Reject,
    // Label 31855: @2464250
    GIM_Reject,
    // Label 31795: @2464251
    GIM_Try, /*On fail goto*//*Label 31858*/ GIMT_Encode4(2464365),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31859*/ GIMT_Encode4(2464319), // Rule ID 50290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50290,
        GIR_EraseRootFromParent_Done,
      // Label 31859: @2464319
      GIM_Try, /*On fail goto*//*Label 31860*/ GIMT_Encode4(2464364), // Rule ID 50291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50291,
        GIR_EraseRootFromParent_Done,
      // Label 31860: @2464364
      GIM_Reject,
    // Label 31858: @2464365
    GIM_Reject,
    // Label 31796: @2464366
    GIM_Try, /*On fail goto*//*Label 31861*/ GIMT_Encode4(2464480),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31862*/ GIMT_Encode4(2464434), // Rule ID 50306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50306,
        GIR_EraseRootFromParent_Done,
      // Label 31862: @2464434
      GIM_Try, /*On fail goto*//*Label 31863*/ GIMT_Encode4(2464479), // Rule ID 50307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50307,
        GIR_EraseRootFromParent_Done,
      // Label 31863: @2464479
      GIM_Reject,
    // Label 31861: @2464480
    GIM_Reject,
    // Label 31797: @2464481
    GIM_Try, /*On fail goto*//*Label 31864*/ GIMT_Encode4(2464595),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31865*/ GIMT_Encode4(2464549), // Rule ID 50278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50278,
        GIR_EraseRootFromParent_Done,
      // Label 31865: @2464549
      GIM_Try, /*On fail goto*//*Label 31866*/ GIMT_Encode4(2464594), // Rule ID 50279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50279,
        GIR_EraseRootFromParent_Done,
      // Label 31866: @2464594
      GIM_Reject,
    // Label 31864: @2464595
    GIM_Reject,
    // Label 31798: @2464596
    GIM_Try, /*On fail goto*//*Label 31867*/ GIMT_Encode4(2464710),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31868*/ GIMT_Encode4(2464664), // Rule ID 50294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50294,
        GIR_EraseRootFromParent_Done,
      // Label 31868: @2464664
      GIM_Try, /*On fail goto*//*Label 31869*/ GIMT_Encode4(2464709), // Rule ID 50295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50295,
        GIR_EraseRootFromParent_Done,
      // Label 31869: @2464709
      GIM_Reject,
    // Label 31867: @2464710
    GIM_Reject,
    // Label 31799: @2464711
    GIM_Try, /*On fail goto*//*Label 31870*/ GIMT_Encode4(2464825),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31871*/ GIMT_Encode4(2464779), // Rule ID 50282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50282,
        GIR_EraseRootFromParent_Done,
      // Label 31871: @2464779
      GIM_Try, /*On fail goto*//*Label 31872*/ GIMT_Encode4(2464824), // Rule ID 50283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50283,
        GIR_EraseRootFromParent_Done,
      // Label 31872: @2464824
      GIM_Reject,
    // Label 31870: @2464825
    GIM_Reject,
    // Label 31800: @2464826
    GIM_Reject,
    // Label 80: @2464827
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 31875*/ GIMT_Encode4(2464984),
    /*GILLT_s32*//*Label 31873*/ GIMT_Encode4(2464846),
    /*GILLT_s64*//*Label 31874*/ GIMT_Encode4(2464915),
    // Label 31873: @2464846
    GIM_Try, /*On fail goto*//*Label 31876*/ GIMT_Encode4(2464914),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31877*/ GIMT_Encode4(2464877), // Rule ID 63869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
        // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63869,
        GIR_Done,
      // Label 31877: @2464877
      GIM_Try, /*On fail goto*//*Label 31878*/ GIMT_Encode4(2464913), // Rule ID 63806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
        // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63806,
        GIR_EraseRootFromParent_Done,
      // Label 31878: @2464913
      GIM_Reject,
    // Label 31876: @2464914
    GIM_Reject,
    // Label 31874: @2464915
    GIM_Try, /*On fail goto*//*Label 31879*/ GIMT_Encode4(2464983),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31880*/ GIMT_Encode4(2464946), // Rule ID 63868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
        // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63868,
        GIR_Done,
      // Label 31880: @2464946
      GIM_Try, /*On fail goto*//*Label 31881*/ GIMT_Encode4(2464982), // Rule ID 63805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
        // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63805,
        GIR_EraseRootFromParent_Done,
      // Label 31881: @2464982
      GIM_Reject,
    // Label 31879: @2464983
    GIM_Reject,
    // Label 31875: @2464984
    GIM_Reject,
    // Label 81: @2464985
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 31884*/ GIMT_Encode4(2465564),
    /*GILLT_s32*//*Label 31882*/ GIMT_Encode4(2465004),
    /*GILLT_s64*//*Label 31883*/ GIMT_Encode4(2465377),
    // Label 31882: @2465004
    GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2465035), // Rule ID 1328 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1328,
      GIR_EraseRootFromParent_Done,
    // Label 31885: @2465035
    GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2465066), // Rule ID 1329 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1329,
      GIR_EraseRootFromParent_Done,
    // Label 31886: @2465066
    GIM_Try, /*On fail goto*//*Label 31887*/ GIMT_Encode4(2465097), // Rule ID 1354 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1354,
      GIR_EraseRootFromParent_Done,
    // Label 31887: @2465097
    GIM_Try, /*On fail goto*//*Label 31888*/ GIMT_Encode4(2465128), // Rule ID 1355 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1355,
      GIR_EraseRootFromParent_Done,
    // Label 31888: @2465128
    GIM_Try, /*On fail goto*//*Label 31889*/ GIMT_Encode4(2465159), // Rule ID 1722 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1722,
      GIR_EraseRootFromParent_Done,
    // Label 31889: @2465159
    GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2465190), // Rule ID 1723 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1723,
      GIR_EraseRootFromParent_Done,
    // Label 31890: @2465190
    GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2465221), // Rule ID 1748 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1748,
      GIR_EraseRootFromParent_Done,
    // Label 31891: @2465221
    GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2465252), // Rule ID 1749 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1749,
      GIR_EraseRootFromParent_Done,
    // Label 31892: @2465252
    GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2465283), // Rule ID 2064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2064,
      GIR_EraseRootFromParent_Done,
    // Label 31893: @2465283
    GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2465314), // Rule ID 2065 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2065,
      GIR_EraseRootFromParent_Done,
    // Label 31894: @2465314
    GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2465345), // Rule ID 2090 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2090,
      GIR_EraseRootFromParent_Done,
    // Label 31895: @2465345
    GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2465376), // Rule ID 2091 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2091,
      GIR_EraseRootFromParent_Done,
    // Label 31896: @2465376
    GIM_Reject,
    // Label 31883: @2465377
    GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2465408), // Rule ID 1381 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1381,
      GIR_EraseRootFromParent_Done,
    // Label 31897: @2465408
    GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2465439), // Rule ID 1409 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1409,
      GIR_EraseRootFromParent_Done,
    // Label 31898: @2465439
    GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2465470), // Rule ID 1779 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1779,
      GIR_EraseRootFromParent_Done,
    // Label 31899: @2465470
    GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2465501), // Rule ID 1807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1807,
      GIR_EraseRootFromParent_Done,
    // Label 31900: @2465501
    GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2465532), // Rule ID 2115 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2115,
      GIR_EraseRootFromParent_Done,
    // Label 31901: @2465532
    GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2465563), // Rule ID 2141 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2141,
      GIR_EraseRootFromParent_Done,
    // Label 31902: @2465563
    GIM_Reject,
    // Label 31884: @2465564
    GIM_Reject,
    // Label 82: @2465565
    GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2465774),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 31907*/ GIMT_Encode4(2465773),
      /*GILLT_s16*//*Label 31904*/ GIMT_Encode4(2465596),
      /*GILLT_s32*//*Label 31905*/ GIMT_Encode4(2465655),
      /*GILLT_s64*//*Label 31906*/ GIMT_Encode4(2465714),
      // Label 31904: @2465596
      GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2465654),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 31909*/ GIMT_Encode4(2465629), // Rule ID 2117 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
          // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2117,
          GIR_EraseRootFromParent_Done,
        // Label 31909: @2465629
        GIM_Try, /*On fail goto*//*Label 31910*/ GIMT_Encode4(2465653), // Rule ID 2143 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
          // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2143,
          GIR_EraseRootFromParent_Done,
        // Label 31910: @2465653
        GIM_Reject,
      // Label 31908: @2465654
      GIM_Reject,
      // Label 31905: @2465655
      GIM_Try, /*On fail goto*//*Label 31911*/ GIMT_Encode4(2465713),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 31912*/ GIMT_Encode4(2465688), // Rule ID 1383 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
          // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1383,
          GIR_EraseRootFromParent_Done,
        // Label 31912: @2465688
        GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2465712), // Rule ID 1411 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
          // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1411,
          GIR_EraseRootFromParent_Done,
        // Label 31913: @2465712
        GIM_Reject,
      // Label 31911: @2465713
      GIM_Reject,
      // Label 31906: @2465714
      GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2465772),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2465747), // Rule ID 1781 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
          // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1781,
          GIR_EraseRootFromParent_Done,
        // Label 31915: @2465747
        GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2465771), // Rule ID 1809 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
          // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // rs1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1809,
          GIR_EraseRootFromParent_Done,
        // Label 31916: @2465771
        GIM_Reject,
      // Label 31914: @2465772
      GIM_Reject,
      // Label 31907: @2465773
      GIM_Reject,
    // Label 31903: @2465774
    GIM_Reject,
    // Label 83: @2465775
    GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2465790), // Rule ID 4 //
      // MIs[0] imm20
      GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
      // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4,
      GIR_Done,
    // Label 31917: @2465790
    GIM_Reject,
    // Label 84: @2465791
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31942*/ GIMT_Encode4(2468310),
    /*GILLT_s32*//*Label 31918*/ GIMT_Encode4(2465926),
    /*GILLT_s64*//*Label 31919*/ GIMT_Encode4(2465974), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 31920*/ GIMT_Encode4(2466022),
    /*GILLT_nxv1s16*//*Label 31921*/ GIMT_Encode4(2466126),
    /*GILLT_nxv1s32*//*Label 31922*/ GIMT_Encode4(2466230),
    /*GILLT_nxv1s64*//*Label 31923*/ GIMT_Encode4(2466334), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 31924*/ GIMT_Encode4(2466438),
    /*GILLT_nxv2s16*//*Label 31925*/ GIMT_Encode4(2466542),
    /*GILLT_nxv2s32*//*Label 31926*/ GIMT_Encode4(2466646),
    /*GILLT_nxv2s64*//*Label 31927*/ GIMT_Encode4(2466750), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 31928*/ GIMT_Encode4(2466854),
    /*GILLT_nxv4s16*//*Label 31929*/ GIMT_Encode4(2466958),
    /*GILLT_nxv4s32*//*Label 31930*/ GIMT_Encode4(2467062),
    /*GILLT_nxv4s64*//*Label 31931*/ GIMT_Encode4(2467166), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 31932*/ GIMT_Encode4(2467270),
    /*GILLT_nxv8s16*//*Label 31933*/ GIMT_Encode4(2467374),
    /*GILLT_nxv8s32*//*Label 31934*/ GIMT_Encode4(2467478),
    /*GILLT_nxv8s64*//*Label 31935*/ GIMT_Encode4(2467582), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 31936*/ GIMT_Encode4(2467686),
    /*GILLT_nxv16s16*//*Label 31937*/ GIMT_Encode4(2467790),
    /*GILLT_nxv16s32*//*Label 31938*/ GIMT_Encode4(2467894), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 31939*/ GIMT_Encode4(2467998),
    /*GILLT_nxv32s16*//*Label 31940*/ GIMT_Encode4(2468102), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 31941*/ GIMT_Encode4(2468206),
    // Label 31918: @2465926
    GIM_Try, /*On fail goto*//*Label 31943*/ GIMT_Encode4(2465973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31944*/ GIMT_Encode4(2465957), // Rule ID 2375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2375,
        GIR_Done,
      // Label 31944: @2465957
      GIM_Try, /*On fail goto*//*Label 31945*/ GIMT_Encode4(2465972), // Rule ID 63852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63852,
        GIR_Done,
      // Label 31945: @2465972
      GIM_Reject,
    // Label 31943: @2465973
    GIM_Reject,
    // Label 31919: @2465974
    GIM_Try, /*On fail goto*//*Label 31946*/ GIMT_Encode4(2466021),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31947*/ GIMT_Encode4(2466005), // Rule ID 2374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2374,
        GIR_Done,
      // Label 31947: @2466005
      GIM_Try, /*On fail goto*//*Label 31948*/ GIMT_Encode4(2466020), // Rule ID 63851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
        // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63851,
        GIR_Done,
      // Label 31948: @2466020
      GIM_Reject,
    // Label 31946: @2466021
    GIM_Reject,
    // Label 31920: @2466022
    GIM_Try, /*On fail goto*//*Label 31949*/ GIMT_Encode4(2466125),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31950*/ GIMT_Encode4(2466081), // Rule ID 58558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58558,
        GIR_EraseRootFromParent_Done,
      // Label 31950: @2466081
      GIM_Try, /*On fail goto*//*Label 31951*/ GIMT_Encode4(2466124), // Rule ID 58559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58559,
        GIR_EraseRootFromParent_Done,
      // Label 31951: @2466124
      GIM_Reject,
    // Label 31949: @2466125
    GIM_Reject,
    // Label 31921: @2466126
    GIM_Try, /*On fail goto*//*Label 31952*/ GIMT_Encode4(2466229),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31953*/ GIMT_Encode4(2466185), // Rule ID 58564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58564,
        GIR_EraseRootFromParent_Done,
      // Label 31953: @2466185
      GIM_Try, /*On fail goto*//*Label 31954*/ GIMT_Encode4(2466228), // Rule ID 58565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58565,
        GIR_EraseRootFromParent_Done,
      // Label 31954: @2466228
      GIM_Reject,
    // Label 31952: @2466229
    GIM_Reject,
    // Label 31922: @2466230
    GIM_Try, /*On fail goto*//*Label 31955*/ GIMT_Encode4(2466333),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31956*/ GIMT_Encode4(2466289), // Rule ID 58568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58568,
        GIR_EraseRootFromParent_Done,
      // Label 31956: @2466289
      GIM_Try, /*On fail goto*//*Label 31957*/ GIMT_Encode4(2466332), // Rule ID 58569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58569,
        GIR_EraseRootFromParent_Done,
      // Label 31957: @2466332
      GIM_Reject,
    // Label 31955: @2466333
    GIM_Reject,
    // Label 31923: @2466334
    GIM_Try, /*On fail goto*//*Label 31958*/ GIMT_Encode4(2466437),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31959*/ GIMT_Encode4(2466393), // Rule ID 58576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58576,
        GIR_EraseRootFromParent_Done,
      // Label 31959: @2466393
      GIM_Try, /*On fail goto*//*Label 31960*/ GIMT_Encode4(2466436), // Rule ID 58577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58577,
        GIR_EraseRootFromParent_Done,
      // Label 31960: @2466436
      GIM_Reject,
    // Label 31958: @2466437
    GIM_Reject,
    // Label 31924: @2466438
    GIM_Try, /*On fail goto*//*Label 31961*/ GIMT_Encode4(2466541),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31962*/ GIMT_Encode4(2466497), // Rule ID 58560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58560,
        GIR_EraseRootFromParent_Done,
      // Label 31962: @2466497
      GIM_Try, /*On fail goto*//*Label 31963*/ GIMT_Encode4(2466540), // Rule ID 58561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58561,
        GIR_EraseRootFromParent_Done,
      // Label 31963: @2466540
      GIM_Reject,
    // Label 31961: @2466541
    GIM_Reject,
    // Label 31925: @2466542
    GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2466645),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2466601), // Rule ID 58566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58566,
        GIR_EraseRootFromParent_Done,
      // Label 31965: @2466601
      GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2466644), // Rule ID 58567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58567,
        GIR_EraseRootFromParent_Done,
      // Label 31966: @2466644
      GIM_Reject,
    // Label 31964: @2466645
    GIM_Reject,
    // Label 31926: @2466646
    GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2466749),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2466705), // Rule ID 58574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58574,
        GIR_EraseRootFromParent_Done,
      // Label 31968: @2466705
      GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2466748), // Rule ID 58575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58575,
        GIR_EraseRootFromParent_Done,
      // Label 31969: @2466748
      GIM_Reject,
    // Label 31967: @2466749
    GIM_Reject,
    // Label 31927: @2466750
    GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2466853),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2466809), // Rule ID 58596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58596,
        GIR_EraseRootFromParent_Done,
      // Label 31971: @2466809
      GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2466852), // Rule ID 58597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58597,
        GIR_EraseRootFromParent_Done,
      // Label 31972: @2466852
      GIM_Reject,
    // Label 31970: @2466853
    GIM_Reject,
    // Label 31928: @2466854
    GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2466957),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2466913), // Rule ID 58562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58562,
        GIR_EraseRootFromParent_Done,
      // Label 31974: @2466913
      GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2466956), // Rule ID 58563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58563,
        GIR_EraseRootFromParent_Done,
      // Label 31975: @2466956
      GIM_Reject,
    // Label 31973: @2466957
    GIM_Reject,
    // Label 31929: @2466958
    GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2467061),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2467017), // Rule ID 58572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58572,
        GIR_EraseRootFromParent_Done,
      // Label 31977: @2467017
      GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2467060), // Rule ID 58573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58573,
        GIR_EraseRootFromParent_Done,
      // Label 31978: @2467060
      GIM_Reject,
    // Label 31976: @2467061
    GIM_Reject,
    // Label 31930: @2467062
    GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2467165),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2467121), // Rule ID 58590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58590,
        GIR_EraseRootFromParent_Done,
      // Label 31980: @2467121
      GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2467164), // Rule ID 58591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58591,
        GIR_EraseRootFromParent_Done,
      // Label 31981: @2467164
      GIM_Reject,
    // Label 31979: @2467165
    GIM_Reject,
    // Label 31931: @2467166
    GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2467269),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2467225), // Rule ID 58598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58598,
        GIR_EraseRootFromParent_Done,
      // Label 31983: @2467225
      GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2467268), // Rule ID 58599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58599,
        GIR_EraseRootFromParent_Done,
      // Label 31984: @2467268
      GIM_Reject,
    // Label 31982: @2467269
    GIM_Reject,
    // Label 31932: @2467270
    GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2467373),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2467329), // Rule ID 58570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58570,
        GIR_EraseRootFromParent_Done,
      // Label 31986: @2467329
      GIM_Try, /*On fail goto*//*Label 31987*/ GIMT_Encode4(2467372), // Rule ID 58571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58571,
        GIR_EraseRootFromParent_Done,
      // Label 31987: @2467372
      GIM_Reject,
    // Label 31985: @2467373
    GIM_Reject,
    // Label 31933: @2467374
    GIM_Try, /*On fail goto*//*Label 31988*/ GIMT_Encode4(2467477),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31989*/ GIMT_Encode4(2467433), // Rule ID 58584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58584,
        GIR_EraseRootFromParent_Done,
      // Label 31989: @2467433
      GIM_Try, /*On fail goto*//*Label 31990*/ GIMT_Encode4(2467476), // Rule ID 58585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58585,
        GIR_EraseRootFromParent_Done,
      // Label 31990: @2467476
      GIM_Reject,
    // Label 31988: @2467477
    GIM_Reject,
    // Label 31934: @2467478
    GIM_Try, /*On fail goto*//*Label 31991*/ GIMT_Encode4(2467581),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 31992*/ GIMT_Encode4(2467537), // Rule ID 58592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58592,
        GIR_EraseRootFromParent_Done,
      // Label 31992: @2467537
      GIM_Try, /*On fail goto*//*Label 31993*/ GIMT_Encode4(2467580), // Rule ID 58593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58593,
        GIR_EraseRootFromParent_Done,
      // Label 31993: @2467580
      GIM_Reject,
    // Label 31991: @2467581
    GIM_Reject,
    // Label 31935: @2467582
    GIM_Try, /*On fail goto*//*Label 31994*/ GIMT_Encode4(2467685),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 31995*/ GIMT_Encode4(2467641), // Rule ID 58600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58600,
        GIR_EraseRootFromParent_Done,
      // Label 31995: @2467641
      GIM_Try, /*On fail goto*//*Label 31996*/ GIMT_Encode4(2467684), // Rule ID 58601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58601,
        GIR_EraseRootFromParent_Done,
      // Label 31996: @2467684
      GIM_Reject,
    // Label 31994: @2467685
    GIM_Reject,
    // Label 31936: @2467686
    GIM_Try, /*On fail goto*//*Label 31997*/ GIMT_Encode4(2467789),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 31998*/ GIMT_Encode4(2467745), // Rule ID 58578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58578,
        GIR_EraseRootFromParent_Done,
      // Label 31998: @2467745
      GIM_Try, /*On fail goto*//*Label 31999*/ GIMT_Encode4(2467788), // Rule ID 58579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58579,
        GIR_EraseRootFromParent_Done,
      // Label 31999: @2467788
      GIM_Reject,
    // Label 31997: @2467789
    GIM_Reject,
    // Label 31937: @2467790
    GIM_Try, /*On fail goto*//*Label 32000*/ GIMT_Encode4(2467893),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32001*/ GIMT_Encode4(2467849), // Rule ID 58586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58586,
        GIR_EraseRootFromParent_Done,
      // Label 32001: @2467849
      GIM_Try, /*On fail goto*//*Label 32002*/ GIMT_Encode4(2467892), // Rule ID 58587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58587,
        GIR_EraseRootFromParent_Done,
      // Label 32002: @2467892
      GIM_Reject,
    // Label 32000: @2467893
    GIM_Reject,
    // Label 31938: @2467894
    GIM_Try, /*On fail goto*//*Label 32003*/ GIMT_Encode4(2467997),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32004*/ GIMT_Encode4(2467953), // Rule ID 58594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58594,
        GIR_EraseRootFromParent_Done,
      // Label 32004: @2467953
      GIM_Try, /*On fail goto*//*Label 32005*/ GIMT_Encode4(2467996), // Rule ID 58595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58595,
        GIR_EraseRootFromParent_Done,
      // Label 32005: @2467996
      GIM_Reject,
    // Label 32003: @2467997
    GIM_Reject,
    // Label 31939: @2467998
    GIM_Try, /*On fail goto*//*Label 32006*/ GIMT_Encode4(2468101),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32007*/ GIMT_Encode4(2468057), // Rule ID 58580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58580,
        GIR_EraseRootFromParent_Done,
      // Label 32007: @2468057
      GIM_Try, /*On fail goto*//*Label 32008*/ GIMT_Encode4(2468100), // Rule ID 58581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58581,
        GIR_EraseRootFromParent_Done,
      // Label 32008: @2468100
      GIM_Reject,
    // Label 32006: @2468101
    GIM_Reject,
    // Label 31940: @2468102
    GIM_Try, /*On fail goto*//*Label 32009*/ GIMT_Encode4(2468205),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32010*/ GIMT_Encode4(2468161), // Rule ID 58588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58588,
        GIR_EraseRootFromParent_Done,
      // Label 32010: @2468161
      GIM_Try, /*On fail goto*//*Label 32011*/ GIMT_Encode4(2468204), // Rule ID 58589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58589,
        GIR_EraseRootFromParent_Done,
      // Label 32011: @2468204
      GIM_Reject,
    // Label 32009: @2468205
    GIM_Reject,
    // Label 31941: @2468206
    GIM_Try, /*On fail goto*//*Label 32012*/ GIMT_Encode4(2468309),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32013*/ GIMT_Encode4(2468265), // Rule ID 58582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58582,
        GIR_EraseRootFromParent_Done,
      // Label 32013: @2468265
      GIM_Try, /*On fail goto*//*Label 32014*/ GIMT_Encode4(2468308), // Rule ID 58583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58583,
        GIR_EraseRootFromParent_Done,
      // Label 32014: @2468308
      GIM_Reject,
    // Label 32012: @2468309
    GIM_Reject,
    // Label 31942: @2468310
    GIM_Reject,
    // Label 85: @2468311
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32039*/ GIMT_Encode4(2470968),
    /*GILLT_s32*//*Label 32015*/ GIMT_Encode4(2468446),
    /*GILLT_s64*//*Label 32016*/ GIMT_Encode4(2468563), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 32017*/ GIMT_Encode4(2468680),
    /*GILLT_nxv1s16*//*Label 32018*/ GIMT_Encode4(2468784),
    /*GILLT_nxv1s32*//*Label 32019*/ GIMT_Encode4(2468888),
    /*GILLT_nxv1s64*//*Label 32020*/ GIMT_Encode4(2468992), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 32021*/ GIMT_Encode4(2469096),
    /*GILLT_nxv2s16*//*Label 32022*/ GIMT_Encode4(2469200),
    /*GILLT_nxv2s32*//*Label 32023*/ GIMT_Encode4(2469304),
    /*GILLT_nxv2s64*//*Label 32024*/ GIMT_Encode4(2469408), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 32025*/ GIMT_Encode4(2469512),
    /*GILLT_nxv4s16*//*Label 32026*/ GIMT_Encode4(2469616),
    /*GILLT_nxv4s32*//*Label 32027*/ GIMT_Encode4(2469720),
    /*GILLT_nxv4s64*//*Label 32028*/ GIMT_Encode4(2469824), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 32029*/ GIMT_Encode4(2469928),
    /*GILLT_nxv8s16*//*Label 32030*/ GIMT_Encode4(2470032),
    /*GILLT_nxv8s32*//*Label 32031*/ GIMT_Encode4(2470136),
    /*GILLT_nxv8s64*//*Label 32032*/ GIMT_Encode4(2470240), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 32033*/ GIMT_Encode4(2470344),
    /*GILLT_nxv16s16*//*Label 32034*/ GIMT_Encode4(2470448),
    /*GILLT_nxv16s32*//*Label 32035*/ GIMT_Encode4(2470552), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 32036*/ GIMT_Encode4(2470656),
    /*GILLT_nxv32s16*//*Label 32037*/ GIMT_Encode4(2470760), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 32038*/ GIMT_Encode4(2470864),
    // Label 32015: @2468446
    GIM_Try, /*On fail goto*//*Label 32040*/ GIMT_Encode4(2468562),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32041*/ GIMT_Encode4(2468504), // Rule ID 61974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61974,
        GIR_EraseRootFromParent_Done,
      // Label 32041: @2468504
      GIM_Try, /*On fail goto*//*Label 32042*/ GIMT_Encode4(2468523), // Rule ID 2373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2373,
        GIR_Done,
      // Label 32042: @2468523
      GIM_Try, /*On fail goto*//*Label 32043*/ GIMT_Encode4(2468542), // Rule ID 61972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61972,
        GIR_Done,
      // Label 32043: @2468542
      GIM_Try, /*On fail goto*//*Label 32044*/ GIMT_Encode4(2468561), // Rule ID 63854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63854,
        GIR_Done,
      // Label 32044: @2468561
      GIM_Reject,
    // Label 32040: @2468562
    GIM_Reject,
    // Label 32016: @2468563
    GIM_Try, /*On fail goto*//*Label 32045*/ GIMT_Encode4(2468679),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32046*/ GIMT_Encode4(2468621), // Rule ID 61973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61973,
        GIR_EraseRootFromParent_Done,
      // Label 32046: @2468621
      GIM_Try, /*On fail goto*//*Label 32047*/ GIMT_Encode4(2468640), // Rule ID 2372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2372,
        GIR_Done,
      // Label 32047: @2468640
      GIM_Try, /*On fail goto*//*Label 32048*/ GIMT_Encode4(2468659), // Rule ID 61971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61971,
        GIR_Done,
      // Label 32048: @2468659
      GIM_Try, /*On fail goto*//*Label 32049*/ GIMT_Encode4(2468678), // Rule ID 63853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63853,
        GIR_Done,
      // Label 32049: @2468678
      GIM_Reject,
    // Label 32045: @2468679
    GIM_Reject,
    // Label 32017: @2468680
    GIM_Try, /*On fail goto*//*Label 32050*/ GIMT_Encode4(2468783),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32051*/ GIMT_Encode4(2468739), // Rule ID 58514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58514,
        GIR_EraseRootFromParent_Done,
      // Label 32051: @2468739
      GIM_Try, /*On fail goto*//*Label 32052*/ GIMT_Encode4(2468782), // Rule ID 58515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58515,
        GIR_EraseRootFromParent_Done,
      // Label 32052: @2468782
      GIM_Reject,
    // Label 32050: @2468783
    GIM_Reject,
    // Label 32018: @2468784
    GIM_Try, /*On fail goto*//*Label 32053*/ GIMT_Encode4(2468887),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32054*/ GIMT_Encode4(2468843), // Rule ID 58520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58520,
        GIR_EraseRootFromParent_Done,
      // Label 32054: @2468843
      GIM_Try, /*On fail goto*//*Label 32055*/ GIMT_Encode4(2468886), // Rule ID 58521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58521,
        GIR_EraseRootFromParent_Done,
      // Label 32055: @2468886
      GIM_Reject,
    // Label 32053: @2468887
    GIM_Reject,
    // Label 32019: @2468888
    GIM_Try, /*On fail goto*//*Label 32056*/ GIMT_Encode4(2468991),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32057*/ GIMT_Encode4(2468947), // Rule ID 58524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58524,
        GIR_EraseRootFromParent_Done,
      // Label 32057: @2468947
      GIM_Try, /*On fail goto*//*Label 32058*/ GIMT_Encode4(2468990), // Rule ID 58525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58525,
        GIR_EraseRootFromParent_Done,
      // Label 32058: @2468990
      GIM_Reject,
    // Label 32056: @2468991
    GIM_Reject,
    // Label 32020: @2468992
    GIM_Try, /*On fail goto*//*Label 32059*/ GIMT_Encode4(2469095),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32060*/ GIMT_Encode4(2469051), // Rule ID 58532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58532,
        GIR_EraseRootFromParent_Done,
      // Label 32060: @2469051
      GIM_Try, /*On fail goto*//*Label 32061*/ GIMT_Encode4(2469094), // Rule ID 58533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58533,
        GIR_EraseRootFromParent_Done,
      // Label 32061: @2469094
      GIM_Reject,
    // Label 32059: @2469095
    GIM_Reject,
    // Label 32021: @2469096
    GIM_Try, /*On fail goto*//*Label 32062*/ GIMT_Encode4(2469199),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32063*/ GIMT_Encode4(2469155), // Rule ID 58516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58516,
        GIR_EraseRootFromParent_Done,
      // Label 32063: @2469155
      GIM_Try, /*On fail goto*//*Label 32064*/ GIMT_Encode4(2469198), // Rule ID 58517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58517,
        GIR_EraseRootFromParent_Done,
      // Label 32064: @2469198
      GIM_Reject,
    // Label 32062: @2469199
    GIM_Reject,
    // Label 32022: @2469200
    GIM_Try, /*On fail goto*//*Label 32065*/ GIMT_Encode4(2469303),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32066*/ GIMT_Encode4(2469259), // Rule ID 58522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58522,
        GIR_EraseRootFromParent_Done,
      // Label 32066: @2469259
      GIM_Try, /*On fail goto*//*Label 32067*/ GIMT_Encode4(2469302), // Rule ID 58523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58523,
        GIR_EraseRootFromParent_Done,
      // Label 32067: @2469302
      GIM_Reject,
    // Label 32065: @2469303
    GIM_Reject,
    // Label 32023: @2469304
    GIM_Try, /*On fail goto*//*Label 32068*/ GIMT_Encode4(2469407),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32069*/ GIMT_Encode4(2469363), // Rule ID 58530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58530,
        GIR_EraseRootFromParent_Done,
      // Label 32069: @2469363
      GIM_Try, /*On fail goto*//*Label 32070*/ GIMT_Encode4(2469406), // Rule ID 58531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58531,
        GIR_EraseRootFromParent_Done,
      // Label 32070: @2469406
      GIM_Reject,
    // Label 32068: @2469407
    GIM_Reject,
    // Label 32024: @2469408
    GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2469511),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2469467), // Rule ID 58552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58552,
        GIR_EraseRootFromParent_Done,
      // Label 32072: @2469467
      GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2469510), // Rule ID 58553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58553,
        GIR_EraseRootFromParent_Done,
      // Label 32073: @2469510
      GIM_Reject,
    // Label 32071: @2469511
    GIM_Reject,
    // Label 32025: @2469512
    GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2469615),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2469571), // Rule ID 58518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58518,
        GIR_EraseRootFromParent_Done,
      // Label 32075: @2469571
      GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2469614), // Rule ID 58519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58519,
        GIR_EraseRootFromParent_Done,
      // Label 32076: @2469614
      GIM_Reject,
    // Label 32074: @2469615
    GIM_Reject,
    // Label 32026: @2469616
    GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2469719),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32078*/ GIMT_Encode4(2469675), // Rule ID 58528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58528,
        GIR_EraseRootFromParent_Done,
      // Label 32078: @2469675
      GIM_Try, /*On fail goto*//*Label 32079*/ GIMT_Encode4(2469718), // Rule ID 58529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58529,
        GIR_EraseRootFromParent_Done,
      // Label 32079: @2469718
      GIM_Reject,
    // Label 32077: @2469719
    GIM_Reject,
    // Label 32027: @2469720
    GIM_Try, /*On fail goto*//*Label 32080*/ GIMT_Encode4(2469823),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32081*/ GIMT_Encode4(2469779), // Rule ID 58546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58546,
        GIR_EraseRootFromParent_Done,
      // Label 32081: @2469779
      GIM_Try, /*On fail goto*//*Label 32082*/ GIMT_Encode4(2469822), // Rule ID 58547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58547,
        GIR_EraseRootFromParent_Done,
      // Label 32082: @2469822
      GIM_Reject,
    // Label 32080: @2469823
    GIM_Reject,
    // Label 32028: @2469824
    GIM_Try, /*On fail goto*//*Label 32083*/ GIMT_Encode4(2469927),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32084*/ GIMT_Encode4(2469883), // Rule ID 58554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58554,
        GIR_EraseRootFromParent_Done,
      // Label 32084: @2469883
      GIM_Try, /*On fail goto*//*Label 32085*/ GIMT_Encode4(2469926), // Rule ID 58555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58555,
        GIR_EraseRootFromParent_Done,
      // Label 32085: @2469926
      GIM_Reject,
    // Label 32083: @2469927
    GIM_Reject,
    // Label 32029: @2469928
    GIM_Try, /*On fail goto*//*Label 32086*/ GIMT_Encode4(2470031),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32087*/ GIMT_Encode4(2469987), // Rule ID 58526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58526,
        GIR_EraseRootFromParent_Done,
      // Label 32087: @2469987
      GIM_Try, /*On fail goto*//*Label 32088*/ GIMT_Encode4(2470030), // Rule ID 58527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58527,
        GIR_EraseRootFromParent_Done,
      // Label 32088: @2470030
      GIM_Reject,
    // Label 32086: @2470031
    GIM_Reject,
    // Label 32030: @2470032
    GIM_Try, /*On fail goto*//*Label 32089*/ GIMT_Encode4(2470135),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32090*/ GIMT_Encode4(2470091), // Rule ID 58540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58540,
        GIR_EraseRootFromParent_Done,
      // Label 32090: @2470091
      GIM_Try, /*On fail goto*//*Label 32091*/ GIMT_Encode4(2470134), // Rule ID 58541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58541,
        GIR_EraseRootFromParent_Done,
      // Label 32091: @2470134
      GIM_Reject,
    // Label 32089: @2470135
    GIM_Reject,
    // Label 32031: @2470136
    GIM_Try, /*On fail goto*//*Label 32092*/ GIMT_Encode4(2470239),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32093*/ GIMT_Encode4(2470195), // Rule ID 58548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58548,
        GIR_EraseRootFromParent_Done,
      // Label 32093: @2470195
      GIM_Try, /*On fail goto*//*Label 32094*/ GIMT_Encode4(2470238), // Rule ID 58549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58549,
        GIR_EraseRootFromParent_Done,
      // Label 32094: @2470238
      GIM_Reject,
    // Label 32092: @2470239
    GIM_Reject,
    // Label 32032: @2470240
    GIM_Try, /*On fail goto*//*Label 32095*/ GIMT_Encode4(2470343),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32096*/ GIMT_Encode4(2470299), // Rule ID 58556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58556,
        GIR_EraseRootFromParent_Done,
      // Label 32096: @2470299
      GIM_Try, /*On fail goto*//*Label 32097*/ GIMT_Encode4(2470342), // Rule ID 58557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58557,
        GIR_EraseRootFromParent_Done,
      // Label 32097: @2470342
      GIM_Reject,
    // Label 32095: @2470343
    GIM_Reject,
    // Label 32033: @2470344
    GIM_Try, /*On fail goto*//*Label 32098*/ GIMT_Encode4(2470447),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32099*/ GIMT_Encode4(2470403), // Rule ID 58534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58534,
        GIR_EraseRootFromParent_Done,
      // Label 32099: @2470403
      GIM_Try, /*On fail goto*//*Label 32100*/ GIMT_Encode4(2470446), // Rule ID 58535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58535,
        GIR_EraseRootFromParent_Done,
      // Label 32100: @2470446
      GIM_Reject,
    // Label 32098: @2470447
    GIM_Reject,
    // Label 32034: @2470448
    GIM_Try, /*On fail goto*//*Label 32101*/ GIMT_Encode4(2470551),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32102*/ GIMT_Encode4(2470507), // Rule ID 58542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58542,
        GIR_EraseRootFromParent_Done,
      // Label 32102: @2470507
      GIM_Try, /*On fail goto*//*Label 32103*/ GIMT_Encode4(2470550), // Rule ID 58543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58543,
        GIR_EraseRootFromParent_Done,
      // Label 32103: @2470550
      GIM_Reject,
    // Label 32101: @2470551
    GIM_Reject,
    // Label 32035: @2470552
    GIM_Try, /*On fail goto*//*Label 32104*/ GIMT_Encode4(2470655),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32105*/ GIMT_Encode4(2470611), // Rule ID 58550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58550,
        GIR_EraseRootFromParent_Done,
      // Label 32105: @2470611
      GIM_Try, /*On fail goto*//*Label 32106*/ GIMT_Encode4(2470654), // Rule ID 58551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58551,
        GIR_EraseRootFromParent_Done,
      // Label 32106: @2470654
      GIM_Reject,
    // Label 32104: @2470655
    GIM_Reject,
    // Label 32036: @2470656
    GIM_Try, /*On fail goto*//*Label 32107*/ GIMT_Encode4(2470759),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32108*/ GIMT_Encode4(2470715), // Rule ID 58536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58536,
        GIR_EraseRootFromParent_Done,
      // Label 32108: @2470715
      GIM_Try, /*On fail goto*//*Label 32109*/ GIMT_Encode4(2470758), // Rule ID 58537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58537,
        GIR_EraseRootFromParent_Done,
      // Label 32109: @2470758
      GIM_Reject,
    // Label 32107: @2470759
    GIM_Reject,
    // Label 32037: @2470760
    GIM_Try, /*On fail goto*//*Label 32110*/ GIMT_Encode4(2470863),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32111*/ GIMT_Encode4(2470819), // Rule ID 58544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58544,
        GIR_EraseRootFromParent_Done,
      // Label 32111: @2470819
      GIM_Try, /*On fail goto*//*Label 32112*/ GIMT_Encode4(2470862), // Rule ID 58545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58545,
        GIR_EraseRootFromParent_Done,
      // Label 32112: @2470862
      GIM_Reject,
    // Label 32110: @2470863
    GIM_Reject,
    // Label 32038: @2470864
    GIM_Try, /*On fail goto*//*Label 32113*/ GIMT_Encode4(2470967),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32114*/ GIMT_Encode4(2470923), // Rule ID 58538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58538,
        GIR_EraseRootFromParent_Done,
      // Label 32114: @2470923
      GIM_Try, /*On fail goto*//*Label 32115*/ GIMT_Encode4(2470966), // Rule ID 58539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58539,
        GIR_EraseRootFromParent_Done,
      // Label 32115: @2470966
      GIM_Reject,
    // Label 32113: @2470967
    GIM_Reject,
    // Label 32039: @2470968
    GIM_Reject,
    // Label 86: @2470969
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32140*/ GIMT_Encode4(2473519),
    /*GILLT_s32*//*Label 32116*/ GIMT_Encode4(2471104),
    /*GILLT_s64*//*Label 32117*/ GIMT_Encode4(2471152), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 32118*/ GIMT_Encode4(2471231),
    /*GILLT_nxv1s16*//*Label 32119*/ GIMT_Encode4(2471335),
    /*GILLT_nxv1s32*//*Label 32120*/ GIMT_Encode4(2471439),
    /*GILLT_nxv1s64*//*Label 32121*/ GIMT_Encode4(2471543), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 32122*/ GIMT_Encode4(2471647),
    /*GILLT_nxv2s16*//*Label 32123*/ GIMT_Encode4(2471751),
    /*GILLT_nxv2s32*//*Label 32124*/ GIMT_Encode4(2471855),
    /*GILLT_nxv2s64*//*Label 32125*/ GIMT_Encode4(2471959), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 32126*/ GIMT_Encode4(2472063),
    /*GILLT_nxv4s16*//*Label 32127*/ GIMT_Encode4(2472167),
    /*GILLT_nxv4s32*//*Label 32128*/ GIMT_Encode4(2472271),
    /*GILLT_nxv4s64*//*Label 32129*/ GIMT_Encode4(2472375), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 32130*/ GIMT_Encode4(2472479),
    /*GILLT_nxv8s16*//*Label 32131*/ GIMT_Encode4(2472583),
    /*GILLT_nxv8s32*//*Label 32132*/ GIMT_Encode4(2472687),
    /*GILLT_nxv8s64*//*Label 32133*/ GIMT_Encode4(2472791), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 32134*/ GIMT_Encode4(2472895),
    /*GILLT_nxv16s16*//*Label 32135*/ GIMT_Encode4(2472999),
    /*GILLT_nxv16s32*//*Label 32136*/ GIMT_Encode4(2473103), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 32137*/ GIMT_Encode4(2473207),
    /*GILLT_nxv32s16*//*Label 32138*/ GIMT_Encode4(2473311), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 32139*/ GIMT_Encode4(2473415),
    // Label 32116: @2471104
    GIM_Try, /*On fail goto*//*Label 32141*/ GIMT_Encode4(2471151),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32142*/ GIMT_Encode4(2471135), // Rule ID 2377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
        // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2377,
        GIR_Done,
      // Label 32142: @2471135
      GIM_Try, /*On fail goto*//*Label 32143*/ GIMT_Encode4(2471150), // Rule ID 63857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
        // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63857,
        GIR_Done,
      // Label 32143: @2471150
      GIM_Reject,
    // Label 32141: @2471151
    GIM_Reject,
    // Label 32117: @2471152
    GIM_Try, /*On fail goto*//*Label 32144*/ GIMT_Encode4(2471230),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32145*/ GIMT_Encode4(2471191), // Rule ID 2380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
        // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2380,
        GIR_EraseRootFromParent_Done,
      // Label 32145: @2471191
      GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2471210), // Rule ID 2376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2376,
        GIR_Done,
      // Label 32146: @2471210
      GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2471229), // Rule ID 63856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63856,
        GIR_Done,
      // Label 32147: @2471229
      GIM_Reject,
    // Label 32144: @2471230
    GIM_Reject,
    // Label 32118: @2471231
    GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2471334),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2471290), // Rule ID 58602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58602,
        GIR_EraseRootFromParent_Done,
      // Label 32149: @2471290
      GIM_Try, /*On fail goto*//*Label 32150*/ GIMT_Encode4(2471333), // Rule ID 58603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58603,
        GIR_EraseRootFromParent_Done,
      // Label 32150: @2471333
      GIM_Reject,
    // Label 32148: @2471334
    GIM_Reject,
    // Label 32119: @2471335
    GIM_Try, /*On fail goto*//*Label 32151*/ GIMT_Encode4(2471438),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32152*/ GIMT_Encode4(2471394), // Rule ID 58608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58608,
        GIR_EraseRootFromParent_Done,
      // Label 32152: @2471394
      GIM_Try, /*On fail goto*//*Label 32153*/ GIMT_Encode4(2471437), // Rule ID 58609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58609,
        GIR_EraseRootFromParent_Done,
      // Label 32153: @2471437
      GIM_Reject,
    // Label 32151: @2471438
    GIM_Reject,
    // Label 32120: @2471439
    GIM_Try, /*On fail goto*//*Label 32154*/ GIMT_Encode4(2471542),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32155*/ GIMT_Encode4(2471498), // Rule ID 58612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58612,
        GIR_EraseRootFromParent_Done,
      // Label 32155: @2471498
      GIM_Try, /*On fail goto*//*Label 32156*/ GIMT_Encode4(2471541), // Rule ID 58613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58613,
        GIR_EraseRootFromParent_Done,
      // Label 32156: @2471541
      GIM_Reject,
    // Label 32154: @2471542
    GIM_Reject,
    // Label 32121: @2471543
    GIM_Try, /*On fail goto*//*Label 32157*/ GIMT_Encode4(2471646),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32158*/ GIMT_Encode4(2471602), // Rule ID 58620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58620,
        GIR_EraseRootFromParent_Done,
      // Label 32158: @2471602
      GIM_Try, /*On fail goto*//*Label 32159*/ GIMT_Encode4(2471645), // Rule ID 58621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58621,
        GIR_EraseRootFromParent_Done,
      // Label 32159: @2471645
      GIM_Reject,
    // Label 32157: @2471646
    GIM_Reject,
    // Label 32122: @2471647
    GIM_Try, /*On fail goto*//*Label 32160*/ GIMT_Encode4(2471750),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32161*/ GIMT_Encode4(2471706), // Rule ID 58604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58604,
        GIR_EraseRootFromParent_Done,
      // Label 32161: @2471706
      GIM_Try, /*On fail goto*//*Label 32162*/ GIMT_Encode4(2471749), // Rule ID 58605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58605,
        GIR_EraseRootFromParent_Done,
      // Label 32162: @2471749
      GIM_Reject,
    // Label 32160: @2471750
    GIM_Reject,
    // Label 32123: @2471751
    GIM_Try, /*On fail goto*//*Label 32163*/ GIMT_Encode4(2471854),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32164*/ GIMT_Encode4(2471810), // Rule ID 58610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58610,
        GIR_EraseRootFromParent_Done,
      // Label 32164: @2471810
      GIM_Try, /*On fail goto*//*Label 32165*/ GIMT_Encode4(2471853), // Rule ID 58611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58611,
        GIR_EraseRootFromParent_Done,
      // Label 32165: @2471853
      GIM_Reject,
    // Label 32163: @2471854
    GIM_Reject,
    // Label 32124: @2471855
    GIM_Try, /*On fail goto*//*Label 32166*/ GIMT_Encode4(2471958),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32167*/ GIMT_Encode4(2471914), // Rule ID 58618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58618,
        GIR_EraseRootFromParent_Done,
      // Label 32167: @2471914
      GIM_Try, /*On fail goto*//*Label 32168*/ GIMT_Encode4(2471957), // Rule ID 58619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58619,
        GIR_EraseRootFromParent_Done,
      // Label 32168: @2471957
      GIM_Reject,
    // Label 32166: @2471958
    GIM_Reject,
    // Label 32125: @2471959
    GIM_Try, /*On fail goto*//*Label 32169*/ GIMT_Encode4(2472062),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32170*/ GIMT_Encode4(2472018), // Rule ID 58640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58640,
        GIR_EraseRootFromParent_Done,
      // Label 32170: @2472018
      GIM_Try, /*On fail goto*//*Label 32171*/ GIMT_Encode4(2472061), // Rule ID 58641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58641,
        GIR_EraseRootFromParent_Done,
      // Label 32171: @2472061
      GIM_Reject,
    // Label 32169: @2472062
    GIM_Reject,
    // Label 32126: @2472063
    GIM_Try, /*On fail goto*//*Label 32172*/ GIMT_Encode4(2472166),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32173*/ GIMT_Encode4(2472122), // Rule ID 58606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58606,
        GIR_EraseRootFromParent_Done,
      // Label 32173: @2472122
      GIM_Try, /*On fail goto*//*Label 32174*/ GIMT_Encode4(2472165), // Rule ID 58607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58607,
        GIR_EraseRootFromParent_Done,
      // Label 32174: @2472165
      GIM_Reject,
    // Label 32172: @2472166
    GIM_Reject,
    // Label 32127: @2472167
    GIM_Try, /*On fail goto*//*Label 32175*/ GIMT_Encode4(2472270),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32176*/ GIMT_Encode4(2472226), // Rule ID 58616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58616,
        GIR_EraseRootFromParent_Done,
      // Label 32176: @2472226
      GIM_Try, /*On fail goto*//*Label 32177*/ GIMT_Encode4(2472269), // Rule ID 58617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58617,
        GIR_EraseRootFromParent_Done,
      // Label 32177: @2472269
      GIM_Reject,
    // Label 32175: @2472270
    GIM_Reject,
    // Label 32128: @2472271
    GIM_Try, /*On fail goto*//*Label 32178*/ GIMT_Encode4(2472374),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32179*/ GIMT_Encode4(2472330), // Rule ID 58634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58634,
        GIR_EraseRootFromParent_Done,
      // Label 32179: @2472330
      GIM_Try, /*On fail goto*//*Label 32180*/ GIMT_Encode4(2472373), // Rule ID 58635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58635,
        GIR_EraseRootFromParent_Done,
      // Label 32180: @2472373
      GIM_Reject,
    // Label 32178: @2472374
    GIM_Reject,
    // Label 32129: @2472375
    GIM_Try, /*On fail goto*//*Label 32181*/ GIMT_Encode4(2472478),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32182*/ GIMT_Encode4(2472434), // Rule ID 58642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58642,
        GIR_EraseRootFromParent_Done,
      // Label 32182: @2472434
      GIM_Try, /*On fail goto*//*Label 32183*/ GIMT_Encode4(2472477), // Rule ID 58643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58643,
        GIR_EraseRootFromParent_Done,
      // Label 32183: @2472477
      GIM_Reject,
    // Label 32181: @2472478
    GIM_Reject,
    // Label 32130: @2472479
    GIM_Try, /*On fail goto*//*Label 32184*/ GIMT_Encode4(2472582),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32185*/ GIMT_Encode4(2472538), // Rule ID 58614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58614,
        GIR_EraseRootFromParent_Done,
      // Label 32185: @2472538
      GIM_Try, /*On fail goto*//*Label 32186*/ GIMT_Encode4(2472581), // Rule ID 58615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58615,
        GIR_EraseRootFromParent_Done,
      // Label 32186: @2472581
      GIM_Reject,
    // Label 32184: @2472582
    GIM_Reject,
    // Label 32131: @2472583
    GIM_Try, /*On fail goto*//*Label 32187*/ GIMT_Encode4(2472686),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32188*/ GIMT_Encode4(2472642), // Rule ID 58628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58628,
        GIR_EraseRootFromParent_Done,
      // Label 32188: @2472642
      GIM_Try, /*On fail goto*//*Label 32189*/ GIMT_Encode4(2472685), // Rule ID 58629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58629,
        GIR_EraseRootFromParent_Done,
      // Label 32189: @2472685
      GIM_Reject,
    // Label 32187: @2472686
    GIM_Reject,
    // Label 32132: @2472687
    GIM_Try, /*On fail goto*//*Label 32190*/ GIMT_Encode4(2472790),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32191*/ GIMT_Encode4(2472746), // Rule ID 58636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58636,
        GIR_EraseRootFromParent_Done,
      // Label 32191: @2472746
      GIM_Try, /*On fail goto*//*Label 32192*/ GIMT_Encode4(2472789), // Rule ID 58637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58637,
        GIR_EraseRootFromParent_Done,
      // Label 32192: @2472789
      GIM_Reject,
    // Label 32190: @2472790
    GIM_Reject,
    // Label 32133: @2472791
    GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2472894),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2472850), // Rule ID 58644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58644,
        GIR_EraseRootFromParent_Done,
      // Label 32194: @2472850
      GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2472893), // Rule ID 58645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58645,
        GIR_EraseRootFromParent_Done,
      // Label 32195: @2472893
      GIM_Reject,
    // Label 32193: @2472894
    GIM_Reject,
    // Label 32134: @2472895
    GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2472998),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2472954), // Rule ID 58622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58622,
        GIR_EraseRootFromParent_Done,
      // Label 32197: @2472954
      GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2472997), // Rule ID 58623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58623,
        GIR_EraseRootFromParent_Done,
      // Label 32198: @2472997
      GIM_Reject,
    // Label 32196: @2472998
    GIM_Reject,
    // Label 32135: @2472999
    GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2473102),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2473058), // Rule ID 58630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58630,
        GIR_EraseRootFromParent_Done,
      // Label 32200: @2473058
      GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2473101), // Rule ID 58631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58631,
        GIR_EraseRootFromParent_Done,
      // Label 32201: @2473101
      GIM_Reject,
    // Label 32199: @2473102
    GIM_Reject,
    // Label 32136: @2473103
    GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2473206),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2473162), // Rule ID 58638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58638,
        GIR_EraseRootFromParent_Done,
      // Label 32203: @2473162
      GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2473205), // Rule ID 58639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58639,
        GIR_EraseRootFromParent_Done,
      // Label 32204: @2473205
      GIM_Reject,
    // Label 32202: @2473206
    GIM_Reject,
    // Label 32137: @2473207
    GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2473310),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2473266), // Rule ID 58624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58624,
        GIR_EraseRootFromParent_Done,
      // Label 32206: @2473266
      GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2473309), // Rule ID 58625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58625,
        GIR_EraseRootFromParent_Done,
      // Label 32207: @2473309
      GIM_Reject,
    // Label 32205: @2473310
    GIM_Reject,
    // Label 32138: @2473311
    GIM_Try, /*On fail goto*//*Label 32208*/ GIMT_Encode4(2473414),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32209*/ GIMT_Encode4(2473370), // Rule ID 58632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58632,
        GIR_EraseRootFromParent_Done,
      // Label 32209: @2473370
      GIM_Try, /*On fail goto*//*Label 32210*/ GIMT_Encode4(2473413), // Rule ID 58633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58633,
        GIR_EraseRootFromParent_Done,
      // Label 32210: @2473413
      GIM_Reject,
    // Label 32208: @2473414
    GIM_Reject,
    // Label 32139: @2473415
    GIM_Try, /*On fail goto*//*Label 32211*/ GIMT_Encode4(2473518),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32212*/ GIMT_Encode4(2473474), // Rule ID 58626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58626,
        GIR_EraseRootFromParent_Done,
      // Label 32212: @2473474
      GIM_Try, /*On fail goto*//*Label 32213*/ GIMT_Encode4(2473517), // Rule ID 58627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58627,
        GIR_EraseRootFromParent_Done,
      // Label 32213: @2473517
      GIM_Reject,
    // Label 32211: @2473518
    GIM_Reject,
    // Label 32140: @2473519
    GIM_Reject,
    // Label 87: @2473520
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32238*/ GIMT_Encode4(2476054),
    /*GILLT_s32*//*Label 32214*/ GIMT_Encode4(2473655),
    /*GILLT_s64*//*Label 32215*/ GIMT_Encode4(2473718), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 32216*/ GIMT_Encode4(2473766),
    /*GILLT_nxv1s16*//*Label 32217*/ GIMT_Encode4(2473870),
    /*GILLT_nxv1s32*//*Label 32218*/ GIMT_Encode4(2473974),
    /*GILLT_nxv1s64*//*Label 32219*/ GIMT_Encode4(2474078), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 32220*/ GIMT_Encode4(2474182),
    /*GILLT_nxv2s16*//*Label 32221*/ GIMT_Encode4(2474286),
    /*GILLT_nxv2s32*//*Label 32222*/ GIMT_Encode4(2474390),
    /*GILLT_nxv2s64*//*Label 32223*/ GIMT_Encode4(2474494), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 32224*/ GIMT_Encode4(2474598),
    /*GILLT_nxv4s16*//*Label 32225*/ GIMT_Encode4(2474702),
    /*GILLT_nxv4s32*//*Label 32226*/ GIMT_Encode4(2474806),
    /*GILLT_nxv4s64*//*Label 32227*/ GIMT_Encode4(2474910), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 32228*/ GIMT_Encode4(2475014),
    /*GILLT_nxv8s16*//*Label 32229*/ GIMT_Encode4(2475118),
    /*GILLT_nxv8s32*//*Label 32230*/ GIMT_Encode4(2475222),
    /*GILLT_nxv8s64*//*Label 32231*/ GIMT_Encode4(2475326), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 32232*/ GIMT_Encode4(2475430),
    /*GILLT_nxv16s16*//*Label 32233*/ GIMT_Encode4(2475534),
    /*GILLT_nxv16s32*//*Label 32234*/ GIMT_Encode4(2475638), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 32235*/ GIMT_Encode4(2475742),
    /*GILLT_nxv32s16*//*Label 32236*/ GIMT_Encode4(2475846), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 32237*/ GIMT_Encode4(2475950),
    // Label 32214: @2473655
    GIM_Try, /*On fail goto*//*Label 32239*/ GIMT_Encode4(2473717),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32240*/ GIMT_Encode4(2473686), // Rule ID 2394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
        // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2394,
        GIR_Done,
      // Label 32240: @2473686
      GIM_Try, /*On fail goto*//*Label 32241*/ GIMT_Encode4(2473701), // Rule ID 2395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
        // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2395,
        GIR_Done,
      // Label 32241: @2473701
      GIM_Try, /*On fail goto*//*Label 32242*/ GIMT_Encode4(2473716), // Rule ID 61976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
        // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61976,
        GIR_Done,
      // Label 32242: @2473716
      GIM_Reject,
    // Label 32239: @2473717
    GIM_Reject,
    // Label 32215: @2473718
    GIM_Try, /*On fail goto*//*Label 32243*/ GIMT_Encode4(2473765),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32244*/ GIMT_Encode4(2473749), // Rule ID 2396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
        // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2396,
        GIR_Done,
      // Label 32244: @2473749
      GIM_Try, /*On fail goto*//*Label 32245*/ GIMT_Encode4(2473764), // Rule ID 61975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
        // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61975,
        GIR_Done,
      // Label 32245: @2473764
      GIM_Reject,
    // Label 32243: @2473765
    GIM_Reject,
    // Label 32216: @2473766
    GIM_Try, /*On fail goto*//*Label 32246*/ GIMT_Encode4(2473869),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32247*/ GIMT_Encode4(2473825), // Rule ID 58470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58470,
        GIR_EraseRootFromParent_Done,
      // Label 32247: @2473825
      GIM_Try, /*On fail goto*//*Label 32248*/ GIMT_Encode4(2473868), // Rule ID 58471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58471,
        GIR_EraseRootFromParent_Done,
      // Label 32248: @2473868
      GIM_Reject,
    // Label 32246: @2473869
    GIM_Reject,
    // Label 32217: @2473870
    GIM_Try, /*On fail goto*//*Label 32249*/ GIMT_Encode4(2473973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32250*/ GIMT_Encode4(2473929), // Rule ID 58476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58476,
        GIR_EraseRootFromParent_Done,
      // Label 32250: @2473929
      GIM_Try, /*On fail goto*//*Label 32251*/ GIMT_Encode4(2473972), // Rule ID 58477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58477,
        GIR_EraseRootFromParent_Done,
      // Label 32251: @2473972
      GIM_Reject,
    // Label 32249: @2473973
    GIM_Reject,
    // Label 32218: @2473974
    GIM_Try, /*On fail goto*//*Label 32252*/ GIMT_Encode4(2474077),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32253*/ GIMT_Encode4(2474033), // Rule ID 58480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58480,
        GIR_EraseRootFromParent_Done,
      // Label 32253: @2474033
      GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2474076), // Rule ID 58481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58481,
        GIR_EraseRootFromParent_Done,
      // Label 32254: @2474076
      GIM_Reject,
    // Label 32252: @2474077
    GIM_Reject,
    // Label 32219: @2474078
    GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2474181),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2474137), // Rule ID 58488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
        // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58488,
        GIR_EraseRootFromParent_Done,
      // Label 32256: @2474137
      GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2474180), // Rule ID 58489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
        // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58489,
        GIR_EraseRootFromParent_Done,
      // Label 32257: @2474180
      GIM_Reject,
    // Label 32255: @2474181
    GIM_Reject,
    // Label 32220: @2474182
    GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2474285),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2474241), // Rule ID 58472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58472,
        GIR_EraseRootFromParent_Done,
      // Label 32259: @2474241
      GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2474284), // Rule ID 58473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58473,
        GIR_EraseRootFromParent_Done,
      // Label 32260: @2474284
      GIM_Reject,
    // Label 32258: @2474285
    GIM_Reject,
    // Label 32221: @2474286
    GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2474389),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2474345), // Rule ID 58478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58478,
        GIR_EraseRootFromParent_Done,
      // Label 32262: @2474345
      GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2474388), // Rule ID 58479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58479,
        GIR_EraseRootFromParent_Done,
      // Label 32263: @2474388
      GIM_Reject,
    // Label 32261: @2474389
    GIM_Reject,
    // Label 32222: @2474390
    GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2474493),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2474449), // Rule ID 58486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58486,
        GIR_EraseRootFromParent_Done,
      // Label 32265: @2474449
      GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2474492), // Rule ID 58487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58487,
        GIR_EraseRootFromParent_Done,
      // Label 32266: @2474492
      GIM_Reject,
    // Label 32264: @2474493
    GIM_Reject,
    // Label 32223: @2474494
    GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2474597),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2474553), // Rule ID 58508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
        // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58508,
        GIR_EraseRootFromParent_Done,
      // Label 32268: @2474553
      GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2474596), // Rule ID 58509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
        // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58509,
        GIR_EraseRootFromParent_Done,
      // Label 32269: @2474596
      GIM_Reject,
    // Label 32267: @2474597
    GIM_Reject,
    // Label 32224: @2474598
    GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2474701),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2474657), // Rule ID 58474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58474,
        GIR_EraseRootFromParent_Done,
      // Label 32271: @2474657
      GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2474700), // Rule ID 58475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58475,
        GIR_EraseRootFromParent_Done,
      // Label 32272: @2474700
      GIM_Reject,
    // Label 32270: @2474701
    GIM_Reject,
    // Label 32225: @2474702
    GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2474805),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2474761), // Rule ID 58484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58484,
        GIR_EraseRootFromParent_Done,
      // Label 32274: @2474761
      GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2474804), // Rule ID 58485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58485,
        GIR_EraseRootFromParent_Done,
      // Label 32275: @2474804
      GIM_Reject,
    // Label 32273: @2474805
    GIM_Reject,
    // Label 32226: @2474806
    GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2474909),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32277*/ GIMT_Encode4(2474865), // Rule ID 58502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58502,
        GIR_EraseRootFromParent_Done,
      // Label 32277: @2474865
      GIM_Try, /*On fail goto*//*Label 32278*/ GIMT_Encode4(2474908), // Rule ID 58503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58503,
        GIR_EraseRootFromParent_Done,
      // Label 32278: @2474908
      GIM_Reject,
    // Label 32276: @2474909
    GIM_Reject,
    // Label 32227: @2474910
    GIM_Try, /*On fail goto*//*Label 32279*/ GIMT_Encode4(2475013),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32280*/ GIMT_Encode4(2474969), // Rule ID 58510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
        // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58510,
        GIR_EraseRootFromParent_Done,
      // Label 32280: @2474969
      GIM_Try, /*On fail goto*//*Label 32281*/ GIMT_Encode4(2475012), // Rule ID 58511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
        // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58511,
        GIR_EraseRootFromParent_Done,
      // Label 32281: @2475012
      GIM_Reject,
    // Label 32279: @2475013
    GIM_Reject,
    // Label 32228: @2475014
    GIM_Try, /*On fail goto*//*Label 32282*/ GIMT_Encode4(2475117),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32283*/ GIMT_Encode4(2475073), // Rule ID 58482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58482,
        GIR_EraseRootFromParent_Done,
      // Label 32283: @2475073
      GIM_Try, /*On fail goto*//*Label 32284*/ GIMT_Encode4(2475116), // Rule ID 58483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58483,
        GIR_EraseRootFromParent_Done,
      // Label 32284: @2475116
      GIM_Reject,
    // Label 32282: @2475117
    GIM_Reject,
    // Label 32229: @2475118
    GIM_Try, /*On fail goto*//*Label 32285*/ GIMT_Encode4(2475221),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32286*/ GIMT_Encode4(2475177), // Rule ID 58496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58496,
        GIR_EraseRootFromParent_Done,
      // Label 32286: @2475177
      GIM_Try, /*On fail goto*//*Label 32287*/ GIMT_Encode4(2475220), // Rule ID 58497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58497,
        GIR_EraseRootFromParent_Done,
      // Label 32287: @2475220
      GIM_Reject,
    // Label 32285: @2475221
    GIM_Reject,
    // Label 32230: @2475222
    GIM_Try, /*On fail goto*//*Label 32288*/ GIMT_Encode4(2475325),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32289*/ GIMT_Encode4(2475281), // Rule ID 58504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58504,
        GIR_EraseRootFromParent_Done,
      // Label 32289: @2475281
      GIM_Try, /*On fail goto*//*Label 32290*/ GIMT_Encode4(2475324), // Rule ID 58505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58505,
        GIR_EraseRootFromParent_Done,
      // Label 32290: @2475324
      GIM_Reject,
    // Label 32288: @2475325
    GIM_Reject,
    // Label 32231: @2475326
    GIM_Try, /*On fail goto*//*Label 32291*/ GIMT_Encode4(2475429),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32292*/ GIMT_Encode4(2475385), // Rule ID 58512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
        // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58512,
        GIR_EraseRootFromParent_Done,
      // Label 32292: @2475385
      GIM_Try, /*On fail goto*//*Label 32293*/ GIMT_Encode4(2475428), // Rule ID 58513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
        // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58513,
        GIR_EraseRootFromParent_Done,
      // Label 32293: @2475428
      GIM_Reject,
    // Label 32291: @2475429
    GIM_Reject,
    // Label 32232: @2475430
    GIM_Try, /*On fail goto*//*Label 32294*/ GIMT_Encode4(2475533),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32295*/ GIMT_Encode4(2475489), // Rule ID 58490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58490,
        GIR_EraseRootFromParent_Done,
      // Label 32295: @2475489
      GIM_Try, /*On fail goto*//*Label 32296*/ GIMT_Encode4(2475532), // Rule ID 58491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58491,
        GIR_EraseRootFromParent_Done,
      // Label 32296: @2475532
      GIM_Reject,
    // Label 32294: @2475533
    GIM_Reject,
    // Label 32233: @2475534
    GIM_Try, /*On fail goto*//*Label 32297*/ GIMT_Encode4(2475637),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32298*/ GIMT_Encode4(2475593), // Rule ID 58498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58498,
        GIR_EraseRootFromParent_Done,
      // Label 32298: @2475593
      GIM_Try, /*On fail goto*//*Label 32299*/ GIMT_Encode4(2475636), // Rule ID 58499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58499,
        GIR_EraseRootFromParent_Done,
      // Label 32299: @2475636
      GIM_Reject,
    // Label 32297: @2475637
    GIM_Reject,
    // Label 32234: @2475638
    GIM_Try, /*On fail goto*//*Label 32300*/ GIMT_Encode4(2475741),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32301*/ GIMT_Encode4(2475697), // Rule ID 58506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58506,
        GIR_EraseRootFromParent_Done,
      // Label 32301: @2475697
      GIM_Try, /*On fail goto*//*Label 32302*/ GIMT_Encode4(2475740), // Rule ID 58507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58507,
        GIR_EraseRootFromParent_Done,
      // Label 32302: @2475740
      GIM_Reject,
    // Label 32300: @2475741
    GIM_Reject,
    // Label 32235: @2475742
    GIM_Try, /*On fail goto*//*Label 32303*/ GIMT_Encode4(2475845),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32304*/ GIMT_Encode4(2475801), // Rule ID 58492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58492,
        GIR_EraseRootFromParent_Done,
      // Label 32304: @2475801
      GIM_Try, /*On fail goto*//*Label 32305*/ GIMT_Encode4(2475844), // Rule ID 58493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58493,
        GIR_EraseRootFromParent_Done,
      // Label 32305: @2475844
      GIM_Reject,
    // Label 32303: @2475845
    GIM_Reject,
    // Label 32236: @2475846
    GIM_Try, /*On fail goto*//*Label 32306*/ GIMT_Encode4(2475949),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32307*/ GIMT_Encode4(2475905), // Rule ID 58500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58500,
        GIR_EraseRootFromParent_Done,
      // Label 32307: @2475905
      GIM_Try, /*On fail goto*//*Label 32308*/ GIMT_Encode4(2475948), // Rule ID 58501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58501,
        GIR_EraseRootFromParent_Done,
      // Label 32308: @2475948
      GIM_Reject,
    // Label 32306: @2475949
    GIM_Reject,
    // Label 32237: @2475950
    GIM_Try, /*On fail goto*//*Label 32309*/ GIMT_Encode4(2476053),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32310*/ GIMT_Encode4(2476009), // Rule ID 58494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
        // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58494,
        GIR_EraseRootFromParent_Done,
      // Label 32310: @2476009
      GIM_Try, /*On fail goto*//*Label 32311*/ GIMT_Encode4(2476052), // Rule ID 58495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
        // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58495,
        GIR_EraseRootFromParent_Done,
      // Label 32311: @2476052
      GIM_Reject,
    // Label 32309: @2476053
    GIM_Reject,
    // Label 32238: @2476054
    GIM_Reject,
    // Label 88: @2476055
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32336*/ GIMT_Encode4(2478548),
    /*GILLT_s32*//*Label 32312*/ GIMT_Encode4(2476190),
    /*GILLT_s64*//*Label 32313*/ GIMT_Encode4(2476225), GIMT_Encode4(0),
    /*GILLT_nxv1s8*//*Label 32314*/ GIMT_Encode4(2476260),
    /*GILLT_nxv1s16*//*Label 32315*/ GIMT_Encode4(2476364),
    /*GILLT_nxv1s32*//*Label 32316*/ GIMT_Encode4(2476468),
    /*GILLT_nxv1s64*//*Label 32317*/ GIMT_Encode4(2476572), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 32318*/ GIMT_Encode4(2476676),
    /*GILLT_nxv2s16*//*Label 32319*/ GIMT_Encode4(2476780),
    /*GILLT_nxv2s32*//*Label 32320*/ GIMT_Encode4(2476884),
    /*GILLT_nxv2s64*//*Label 32321*/ GIMT_Encode4(2476988), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 32322*/ GIMT_Encode4(2477092),
    /*GILLT_nxv4s16*//*Label 32323*/ GIMT_Encode4(2477196),
    /*GILLT_nxv4s32*//*Label 32324*/ GIMT_Encode4(2477300),
    /*GILLT_nxv4s64*//*Label 32325*/ GIMT_Encode4(2477404), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 32326*/ GIMT_Encode4(2477508),
    /*GILLT_nxv8s16*//*Label 32327*/ GIMT_Encode4(2477612),
    /*GILLT_nxv8s32*//*Label 32328*/ GIMT_Encode4(2477716),
    /*GILLT_nxv8s64*//*Label 32329*/ GIMT_Encode4(2477820), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 32330*/ GIMT_Encode4(2477924),
    /*GILLT_nxv16s16*//*Label 32331*/ GIMT_Encode4(2478028),
    /*GILLT_nxv16s32*//*Label 32332*/ GIMT_Encode4(2478132), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 32333*/ GIMT_Encode4(2478236),
    /*GILLT_nxv32s16*//*Label 32334*/ GIMT_Encode4(2478340), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 32335*/ GIMT_Encode4(2478444),
    // Label 32312: @2476190
    GIM_Try, /*On fail goto*//*Label 32337*/ GIMT_Encode4(2476224), // Rule ID 63862 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63862,
      GIR_EraseRootFromParent_Done,
    // Label 32337: @2476224
    GIM_Reject,
    // Label 32313: @2476225
    GIM_Try, /*On fail goto*//*Label 32338*/ GIMT_Encode4(2476259), // Rule ID 63861 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 63861,
      GIR_EraseRootFromParent_Done,
    // Label 32338: @2476259
    GIM_Reject,
    // Label 32314: @2476260
    GIM_Try, /*On fail goto*//*Label 32339*/ GIMT_Encode4(2476363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32340*/ GIMT_Encode4(2476319), // Rule ID 58294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58294,
        GIR_EraseRootFromParent_Done,
      // Label 32340: @2476319
      GIM_Try, /*On fail goto*//*Label 32341*/ GIMT_Encode4(2476362), // Rule ID 58295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58295,
        GIR_EraseRootFromParent_Done,
      // Label 32341: @2476362
      GIM_Reject,
    // Label 32339: @2476363
    GIM_Reject,
    // Label 32315: @2476364
    GIM_Try, /*On fail goto*//*Label 32342*/ GIMT_Encode4(2476467),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32343*/ GIMT_Encode4(2476423), // Rule ID 58432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58432,
        GIR_EraseRootFromParent_Done,
      // Label 32343: @2476423
      GIM_Try, /*On fail goto*//*Label 32344*/ GIMT_Encode4(2476466), // Rule ID 58433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58433,
        GIR_EraseRootFromParent_Done,
      // Label 32344: @2476466
      GIM_Reject,
    // Label 32342: @2476467
    GIM_Reject,
    // Label 32316: @2476468
    GIM_Try, /*On fail goto*//*Label 32345*/ GIMT_Encode4(2476571),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32346*/ GIMT_Encode4(2476527), // Rule ID 58436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58436,
        GIR_EraseRootFromParent_Done,
      // Label 32346: @2476527
      GIM_Try, /*On fail goto*//*Label 32347*/ GIMT_Encode4(2476570), // Rule ID 58437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58437,
        GIR_EraseRootFromParent_Done,
      // Label 32347: @2476570
      GIM_Reject,
    // Label 32345: @2476571
    GIM_Reject,
    // Label 32317: @2476572
    GIM_Try, /*On fail goto*//*Label 32348*/ GIMT_Encode4(2476675),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32349*/ GIMT_Encode4(2476631), // Rule ID 58444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58444,
        GIR_EraseRootFromParent_Done,
      // Label 32349: @2476631
      GIM_Try, /*On fail goto*//*Label 32350*/ GIMT_Encode4(2476674), // Rule ID 58445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58445,
        GIR_EraseRootFromParent_Done,
      // Label 32350: @2476674
      GIM_Reject,
    // Label 32348: @2476675
    GIM_Reject,
    // Label 32318: @2476676
    GIM_Try, /*On fail goto*//*Label 32351*/ GIMT_Encode4(2476779),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32352*/ GIMT_Encode4(2476735), // Rule ID 58428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58428,
        GIR_EraseRootFromParent_Done,
      // Label 32352: @2476735
      GIM_Try, /*On fail goto*//*Label 32353*/ GIMT_Encode4(2476778), // Rule ID 58429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58429,
        GIR_EraseRootFromParent_Done,
      // Label 32353: @2476778
      GIM_Reject,
    // Label 32351: @2476779
    GIM_Reject,
    // Label 32319: @2476780
    GIM_Try, /*On fail goto*//*Label 32354*/ GIMT_Encode4(2476883),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32355*/ GIMT_Encode4(2476839), // Rule ID 58434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58434,
        GIR_EraseRootFromParent_Done,
      // Label 32355: @2476839
      GIM_Try, /*On fail goto*//*Label 32356*/ GIMT_Encode4(2476882), // Rule ID 58435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58435,
        GIR_EraseRootFromParent_Done,
      // Label 32356: @2476882
      GIM_Reject,
    // Label 32354: @2476883
    GIM_Reject,
    // Label 32320: @2476884
    GIM_Try, /*On fail goto*//*Label 32357*/ GIMT_Encode4(2476987),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32358*/ GIMT_Encode4(2476943), // Rule ID 58442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58442,
        GIR_EraseRootFromParent_Done,
      // Label 32358: @2476943
      GIM_Try, /*On fail goto*//*Label 32359*/ GIMT_Encode4(2476986), // Rule ID 58443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58443,
        GIR_EraseRootFromParent_Done,
      // Label 32359: @2476986
      GIM_Reject,
    // Label 32357: @2476987
    GIM_Reject,
    // Label 32321: @2476988
    GIM_Try, /*On fail goto*//*Label 32360*/ GIMT_Encode4(2477091),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32361*/ GIMT_Encode4(2477047), // Rule ID 58464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58464,
        GIR_EraseRootFromParent_Done,
      // Label 32361: @2477047
      GIM_Try, /*On fail goto*//*Label 32362*/ GIMT_Encode4(2477090), // Rule ID 58465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58465,
        GIR_EraseRootFromParent_Done,
      // Label 32362: @2477090
      GIM_Reject,
    // Label 32360: @2477091
    GIM_Reject,
    // Label 32322: @2477092
    GIM_Try, /*On fail goto*//*Label 32363*/ GIMT_Encode4(2477195),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32364*/ GIMT_Encode4(2477151), // Rule ID 58430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58430,
        GIR_EraseRootFromParent_Done,
      // Label 32364: @2477151
      GIM_Try, /*On fail goto*//*Label 32365*/ GIMT_Encode4(2477194), // Rule ID 58431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58431,
        GIR_EraseRootFromParent_Done,
      // Label 32365: @2477194
      GIM_Reject,
    // Label 32363: @2477195
    GIM_Reject,
    // Label 32323: @2477196
    GIM_Try, /*On fail goto*//*Label 32366*/ GIMT_Encode4(2477299),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32367*/ GIMT_Encode4(2477255), // Rule ID 58440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58440,
        GIR_EraseRootFromParent_Done,
      // Label 32367: @2477255
      GIM_Try, /*On fail goto*//*Label 32368*/ GIMT_Encode4(2477298), // Rule ID 58441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58441,
        GIR_EraseRootFromParent_Done,
      // Label 32368: @2477298
      GIM_Reject,
    // Label 32366: @2477299
    GIM_Reject,
    // Label 32324: @2477300
    GIM_Try, /*On fail goto*//*Label 32369*/ GIMT_Encode4(2477403),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32370*/ GIMT_Encode4(2477359), // Rule ID 58458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58458,
        GIR_EraseRootFromParent_Done,
      // Label 32370: @2477359
      GIM_Try, /*On fail goto*//*Label 32371*/ GIMT_Encode4(2477402), // Rule ID 58459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58459,
        GIR_EraseRootFromParent_Done,
      // Label 32371: @2477402
      GIM_Reject,
    // Label 32369: @2477403
    GIM_Reject,
    // Label 32325: @2477404
    GIM_Try, /*On fail goto*//*Label 32372*/ GIMT_Encode4(2477507),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32373*/ GIMT_Encode4(2477463), // Rule ID 58466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58466,
        GIR_EraseRootFromParent_Done,
      // Label 32373: @2477463
      GIM_Try, /*On fail goto*//*Label 32374*/ GIMT_Encode4(2477506), // Rule ID 58467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58467,
        GIR_EraseRootFromParent_Done,
      // Label 32374: @2477506
      GIM_Reject,
    // Label 32372: @2477507
    GIM_Reject,
    // Label 32326: @2477508
    GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2477611),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2477567), // Rule ID 58438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58438,
        GIR_EraseRootFromParent_Done,
      // Label 32376: @2477567
      GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2477610), // Rule ID 58439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58439,
        GIR_EraseRootFromParent_Done,
      // Label 32377: @2477610
      GIM_Reject,
    // Label 32375: @2477611
    GIM_Reject,
    // Label 32327: @2477612
    GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2477715),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2477671), // Rule ID 58452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58452,
        GIR_EraseRootFromParent_Done,
      // Label 32379: @2477671
      GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2477714), // Rule ID 58453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58453,
        GIR_EraseRootFromParent_Done,
      // Label 32380: @2477714
      GIM_Reject,
    // Label 32378: @2477715
    GIM_Reject,
    // Label 32328: @2477716
    GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2477819),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2477775), // Rule ID 58460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58460,
        GIR_EraseRootFromParent_Done,
      // Label 32382: @2477775
      GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2477818), // Rule ID 58461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58461,
        GIR_EraseRootFromParent_Done,
      // Label 32383: @2477818
      GIM_Reject,
    // Label 32381: @2477819
    GIM_Reject,
    // Label 32329: @2477820
    GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2477923),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2477879), // Rule ID 58468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
        // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58468,
        GIR_EraseRootFromParent_Done,
      // Label 32385: @2477879
      GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2477922), // Rule ID 58469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
        // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58469,
        GIR_EraseRootFromParent_Done,
      // Label 32386: @2477922
      GIM_Reject,
    // Label 32384: @2477923
    GIM_Reject,
    // Label 32330: @2477924
    GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2478027),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2477983), // Rule ID 58446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58446,
        GIR_EraseRootFromParent_Done,
      // Label 32388: @2477983
      GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2478026), // Rule ID 58447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58447,
        GIR_EraseRootFromParent_Done,
      // Label 32389: @2478026
      GIM_Reject,
    // Label 32387: @2478027
    GIM_Reject,
    // Label 32331: @2478028
    GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2478131),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2478087), // Rule ID 58454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58454,
        GIR_EraseRootFromParent_Done,
      // Label 32391: @2478087
      GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2478130), // Rule ID 58455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58455,
        GIR_EraseRootFromParent_Done,
      // Label 32392: @2478130
      GIM_Reject,
    // Label 32390: @2478131
    GIM_Reject,
    // Label 32332: @2478132
    GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2478235),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2478191), // Rule ID 58462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58462,
        GIR_EraseRootFromParent_Done,
      // Label 32394: @2478191
      GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2478234), // Rule ID 58463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58463,
        GIR_EraseRootFromParent_Done,
      // Label 32395: @2478234
      GIM_Reject,
    // Label 32393: @2478235
    GIM_Reject,
    // Label 32333: @2478236
    GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2478339),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2478295), // Rule ID 58448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58448,
        GIR_EraseRootFromParent_Done,
      // Label 32397: @2478295
      GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2478338), // Rule ID 58449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58449,
        GIR_EraseRootFromParent_Done,
      // Label 32398: @2478338
      GIM_Reject,
    // Label 32396: @2478339
    GIM_Reject,
    // Label 32334: @2478340
    GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2478443),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2478399), // Rule ID 58456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58456,
        GIR_EraseRootFromParent_Done,
      // Label 32400: @2478399
      GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2478442), // Rule ID 58457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58457,
        GIR_EraseRootFromParent_Done,
      // Label 32401: @2478442
      GIM_Reject,
    // Label 32399: @2478443
    GIM_Reject,
    // Label 32335: @2478444
    GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2478547),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2478503), // Rule ID 58450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
        // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58450,
        GIR_EraseRootFromParent_Done,
      // Label 32403: @2478503
      GIM_Try, /*On fail goto*//*Label 32404*/ GIMT_Encode4(2478546), // Rule ID 58451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
        // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58451,
        GIR_EraseRootFromParent_Done,
      // Label 32404: @2478546
      GIM_Reject,
    // Label 32402: @2478547
    GIM_Reject,
    // Label 32336: @2478548
    GIM_Reject,
    // Label 89: @2478549
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32408*/ GIMT_Encode4(2478746),
    /*GILLT_s16*//*Label 32405*/ GIMT_Encode4(2478572),
    /*GILLT_s32*//*Label 32406*/ GIMT_Encode4(2478630),
    /*GILLT_s64*//*Label 32407*/ GIMT_Encode4(2478688),
    // Label 32405: @2478572
    GIM_Try, /*On fail goto*//*Label 32409*/ GIMT_Encode4(2478629),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 32410*/ GIMT_Encode4(2478608), // Rule ID 2290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
        // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2290,
        GIR_EraseRootFromParent_Done,
      // Label 32410: @2478608
      GIM_Try, /*On fail goto*//*Label 32411*/ GIMT_Encode4(2478628), // Rule ID 2291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
        // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2291,
        GIR_EraseRootFromParent_Done,
      // Label 32411: @2478628
      GIM_Reject,
    // Label 32409: @2478629
    GIM_Reject,
    // Label 32406: @2478630
    GIM_Try, /*On fail goto*//*Label 32412*/ GIMT_Encode4(2478687),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 32413*/ GIMT_Encode4(2478666), // Rule ID 2208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
        // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2208,
        GIR_EraseRootFromParent_Done,
      // Label 32413: @2478666
      GIM_Try, /*On fail goto*//*Label 32414*/ GIMT_Encode4(2478686), // Rule ID 2209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
        // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2209,
        GIR_EraseRootFromParent_Done,
      // Label 32414: @2478686
      GIM_Reject,
    // Label 32412: @2478687
    GIM_Reject,
    // Label 32407: @2478688
    GIM_Try, /*On fail goto*//*Label 32415*/ GIMT_Encode4(2478745),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 32416*/ GIMT_Encode4(2478724), // Rule ID 2248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
        // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2248,
        GIR_EraseRootFromParent_Done,
      // Label 32416: @2478724
      GIM_Try, /*On fail goto*//*Label 32417*/ GIMT_Encode4(2478744), // Rule ID 2249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
        // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2249,
        GIR_EraseRootFromParent_Done,
      // Label 32417: @2478744
      GIM_Reject,
    // Label 32415: @2478745
    GIM_Reject,
    // Label 32408: @2478746
    GIM_Reject,
    // Label 90: @2478747
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32436*/ GIMT_Encode4(2480922),
    /*GILLT_s16*//*Label 32418*/ GIMT_Encode4(2478878),
    /*GILLT_s32*//*Label 32419*/ GIMT_Encode4(2479000),
    /*GILLT_s64*//*Label 32420*/ GIMT_Encode4(2479122), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 32421*/ GIMT_Encode4(2479272),
    /*GILLT_nxv1s32*//*Label 32422*/ GIMT_Encode4(2479382),
    /*GILLT_nxv1s64*//*Label 32423*/ GIMT_Encode4(2479492), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 32424*/ GIMT_Encode4(2479602),
    /*GILLT_nxv2s32*//*Label 32425*/ GIMT_Encode4(2479712),
    /*GILLT_nxv2s64*//*Label 32426*/ GIMT_Encode4(2479822), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 32427*/ GIMT_Encode4(2479932),
    /*GILLT_nxv4s32*//*Label 32428*/ GIMT_Encode4(2480042),
    /*GILLT_nxv4s64*//*Label 32429*/ GIMT_Encode4(2480152), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 32430*/ GIMT_Encode4(2480262),
    /*GILLT_nxv8s32*//*Label 32431*/ GIMT_Encode4(2480372),
    /*GILLT_nxv8s64*//*Label 32432*/ GIMT_Encode4(2480482), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 32433*/ GIMT_Encode4(2480592),
    /*GILLT_nxv16s32*//*Label 32434*/ GIMT_Encode4(2480702), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 32435*/ GIMT_Encode4(2480812),
    // Label 32418: @2478878
    GIM_Try, /*On fail goto*//*Label 32437*/ GIMT_Encode4(2478999),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 32438*/ GIMT_Encode4(2478914), // Rule ID 1848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1848,
        GIR_EraseRootFromParent_Done,
      // Label 32438: @2478914
      GIM_Try, /*On fail goto*//*Label 32439*/ GIMT_Encode4(2478942), // Rule ID 1849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1849,
        GIR_EraseRootFromParent_Done,
      // Label 32439: @2478942
      GIM_Try, /*On fail goto*//*Label 32440*/ GIMT_Encode4(2478970), // Rule ID 1881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1881,
        GIR_EraseRootFromParent_Done,
      // Label 32440: @2478970
      GIM_Try, /*On fail goto*//*Label 32441*/ GIMT_Encode4(2478998), // Rule ID 1882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1882,
        GIR_EraseRootFromParent_Done,
      // Label 32441: @2478998
      GIM_Reject,
    // Label 32437: @2478999
    GIM_Reject,
    // Label 32419: @2479000
    GIM_Try, /*On fail goto*//*Label 32442*/ GIMT_Encode4(2479121),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 32443*/ GIMT_Encode4(2479036), // Rule ID 1139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1139,
        GIR_EraseRootFromParent_Done,
      // Label 32443: @2479036
      GIM_Try, /*On fail goto*//*Label 32444*/ GIMT_Encode4(2479064), // Rule ID 1140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1140,
        GIR_EraseRootFromParent_Done,
      // Label 32444: @2479064
      GIM_Try, /*On fail goto*//*Label 32445*/ GIMT_Encode4(2479092), // Rule ID 1147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1147,
        GIR_EraseRootFromParent_Done,
      // Label 32445: @2479092
      GIM_Try, /*On fail goto*//*Label 32446*/ GIMT_Encode4(2479120), // Rule ID 1148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1148,
        GIR_EraseRootFromParent_Done,
      // Label 32446: @2479120
      GIM_Reject,
    // Label 32442: @2479121
    GIM_Reject,
    // Label 32420: @2479122
    GIM_Try, /*On fail goto*//*Label 32447*/ GIMT_Encode4(2479271),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 32448*/ GIMT_Encode4(2479158), // Rule ID 1482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1482,
        GIR_EraseRootFromParent_Done,
      // Label 32448: @2479158
      GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2479186), // Rule ID 1483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1483,
        GIR_EraseRootFromParent_Done,
      // Label 32449: @2479186
      GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2479214), // Rule ID 1516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1516,
        GIR_EraseRootFromParent_Done,
      // Label 32450: @2479214
      GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2479242), // Rule ID 1537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1537,
        GIR_EraseRootFromParent_Done,
      // Label 32451: @2479242
      GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2479270), // Rule ID 1538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1538,
        GIR_EraseRootFromParent_Done,
      // Label 32452: @2479270
      GIM_Reject,
    // Label 32447: @2479271
    GIM_Reject,
    // Label 32421: @2479272
    GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2479381),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2479334), // Rule ID 55792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55792,
        GIR_EraseRootFromParent_Done,
      // Label 32454: @2479334
      GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2479380), // Rule ID 55793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55793,
        GIR_EraseRootFromParent_Done,
      // Label 32455: @2479380
      GIM_Reject,
    // Label 32453: @2479381
    GIM_Reject,
    // Label 32422: @2479382
    GIM_Try, /*On fail goto*//*Label 32456*/ GIMT_Encode4(2479491),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32457*/ GIMT_Encode4(2479444), // Rule ID 55832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55832,
        GIR_EraseRootFromParent_Done,
      // Label 32457: @2479444
      GIM_Try, /*On fail goto*//*Label 32458*/ GIMT_Encode4(2479490), // Rule ID 55833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55833,
        GIR_EraseRootFromParent_Done,
      // Label 32458: @2479490
      GIM_Reject,
    // Label 32456: @2479491
    GIM_Reject,
    // Label 32423: @2479492
    GIM_Try, /*On fail goto*//*Label 32459*/ GIMT_Encode4(2479601),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32460*/ GIMT_Encode4(2479554), // Rule ID 55892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55892,
        GIR_EraseRootFromParent_Done,
      // Label 32460: @2479554
      GIM_Try, /*On fail goto*//*Label 32461*/ GIMT_Encode4(2479600), // Rule ID 55893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55893,
        GIR_EraseRootFromParent_Done,
      // Label 32461: @2479600
      GIM_Reject,
    // Label 32459: @2479601
    GIM_Reject,
    // Label 32424: @2479602
    GIM_Try, /*On fail goto*//*Label 32462*/ GIMT_Encode4(2479711),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32463*/ GIMT_Encode4(2479664), // Rule ID 55812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55812,
        GIR_EraseRootFromParent_Done,
      // Label 32463: @2479664
      GIM_Try, /*On fail goto*//*Label 32464*/ GIMT_Encode4(2479710), // Rule ID 55813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55813,
        GIR_EraseRootFromParent_Done,
      // Label 32464: @2479710
      GIM_Reject,
    // Label 32462: @2479711
    GIM_Reject,
    // Label 32425: @2479712
    GIM_Try, /*On fail goto*//*Label 32465*/ GIMT_Encode4(2479821),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32466*/ GIMT_Encode4(2479774), // Rule ID 55872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55872,
        GIR_EraseRootFromParent_Done,
      // Label 32466: @2479774
      GIM_Try, /*On fail goto*//*Label 32467*/ GIMT_Encode4(2479820), // Rule ID 55873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55873,
        GIR_EraseRootFromParent_Done,
      // Label 32467: @2479820
      GIM_Reject,
    // Label 32465: @2479821
    GIM_Reject,
    // Label 32426: @2479822
    GIM_Try, /*On fail goto*//*Label 32468*/ GIMT_Encode4(2479931),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32469*/ GIMT_Encode4(2479884), // Rule ID 56032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56032,
        GIR_EraseRootFromParent_Done,
      // Label 32469: @2479884
      GIM_Try, /*On fail goto*//*Label 32470*/ GIMT_Encode4(2479930), // Rule ID 56033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56033,
        GIR_EraseRootFromParent_Done,
      // Label 32470: @2479930
      GIM_Reject,
    // Label 32468: @2479931
    GIM_Reject,
    // Label 32427: @2479932
    GIM_Try, /*On fail goto*//*Label 32471*/ GIMT_Encode4(2480041),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32472*/ GIMT_Encode4(2479994), // Rule ID 55852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55852,
        GIR_EraseRootFromParent_Done,
      // Label 32472: @2479994
      GIM_Try, /*On fail goto*//*Label 32473*/ GIMT_Encode4(2480040), // Rule ID 55853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55853,
        GIR_EraseRootFromParent_Done,
      // Label 32473: @2480040
      GIM_Reject,
    // Label 32471: @2480041
    GIM_Reject,
    // Label 32428: @2480042
    GIM_Try, /*On fail goto*//*Label 32474*/ GIMT_Encode4(2480151),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32475*/ GIMT_Encode4(2480104), // Rule ID 55972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55972,
        GIR_EraseRootFromParent_Done,
      // Label 32475: @2480104
      GIM_Try, /*On fail goto*//*Label 32476*/ GIMT_Encode4(2480150), // Rule ID 55973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55973,
        GIR_EraseRootFromParent_Done,
      // Label 32476: @2480150
      GIM_Reject,
    // Label 32474: @2480151
    GIM_Reject,
    // Label 32429: @2480152
    GIM_Try, /*On fail goto*//*Label 32477*/ GIMT_Encode4(2480261),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32478*/ GIMT_Encode4(2480214), // Rule ID 56052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56052,
        GIR_EraseRootFromParent_Done,
      // Label 32478: @2480214
      GIM_Try, /*On fail goto*//*Label 32479*/ GIMT_Encode4(2480260), // Rule ID 56053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56053,
        GIR_EraseRootFromParent_Done,
      // Label 32479: @2480260
      GIM_Reject,
    // Label 32477: @2480261
    GIM_Reject,
    // Label 32430: @2480262
    GIM_Try, /*On fail goto*//*Label 32480*/ GIMT_Encode4(2480371),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32481*/ GIMT_Encode4(2480324), // Rule ID 55912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55912,
        GIR_EraseRootFromParent_Done,
      // Label 32481: @2480324
      GIM_Try, /*On fail goto*//*Label 32482*/ GIMT_Encode4(2480370), // Rule ID 55913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55913,
        GIR_EraseRootFromParent_Done,
      // Label 32482: @2480370
      GIM_Reject,
    // Label 32480: @2480371
    GIM_Reject,
    // Label 32431: @2480372
    GIM_Try, /*On fail goto*//*Label 32483*/ GIMT_Encode4(2480481),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32484*/ GIMT_Encode4(2480434), // Rule ID 55992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55992,
        GIR_EraseRootFromParent_Done,
      // Label 32484: @2480434
      GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2480480), // Rule ID 55993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55993,
        GIR_EraseRootFromParent_Done,
      // Label 32485: @2480480
      GIM_Reject,
    // Label 32483: @2480481
    GIM_Reject,
    // Label 32432: @2480482
    GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2480591),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2480544), // Rule ID 56072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56072,
        GIR_EraseRootFromParent_Done,
      // Label 32487: @2480544
      GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2480590), // Rule ID 56073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56073,
        GIR_EraseRootFromParent_Done,
      // Label 32488: @2480590
      GIM_Reject,
    // Label 32486: @2480591
    GIM_Reject,
    // Label 32433: @2480592
    GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2480701),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32490*/ GIMT_Encode4(2480654), // Rule ID 55932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55932,
        GIR_EraseRootFromParent_Done,
      // Label 32490: @2480654
      GIM_Try, /*On fail goto*//*Label 32491*/ GIMT_Encode4(2480700), // Rule ID 55933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55933,
        GIR_EraseRootFromParent_Done,
      // Label 32491: @2480700
      GIM_Reject,
    // Label 32489: @2480701
    GIM_Reject,
    // Label 32434: @2480702
    GIM_Try, /*On fail goto*//*Label 32492*/ GIMT_Encode4(2480811),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32493*/ GIMT_Encode4(2480764), // Rule ID 56012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56012,
        GIR_EraseRootFromParent_Done,
      // Label 32493: @2480764
      GIM_Try, /*On fail goto*//*Label 32494*/ GIMT_Encode4(2480810), // Rule ID 56013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56013,
        GIR_EraseRootFromParent_Done,
      // Label 32494: @2480810
      GIM_Reject,
    // Label 32492: @2480811
    GIM_Reject,
    // Label 32435: @2480812
    GIM_Try, /*On fail goto*//*Label 32495*/ GIMT_Encode4(2480921),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32496*/ GIMT_Encode4(2480874), // Rule ID 55952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55952,
        GIR_EraseRootFromParent_Done,
      // Label 32496: @2480874
      GIM_Try, /*On fail goto*//*Label 32497*/ GIMT_Encode4(2480920), // Rule ID 55953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55953,
        GIR_EraseRootFromParent_Done,
      // Label 32497: @2480920
      GIM_Reject,
    // Label 32495: @2480921
    GIM_Reject,
    // Label 32436: @2480922
    GIM_Reject,
    // Label 91: @2480923
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32501*/ GIMT_Encode4(2481120),
    /*GILLT_s16*//*Label 32498*/ GIMT_Encode4(2480946),
    /*GILLT_s32*//*Label 32499*/ GIMT_Encode4(2481004),
    /*GILLT_s64*//*Label 32500*/ GIMT_Encode4(2481062),
    // Label 32498: @2480946
    GIM_Try, /*On fail goto*//*Label 32502*/ GIMT_Encode4(2481003),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 32503*/ GIMT_Encode4(2480982), // Rule ID 2286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
        // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2286,
        GIR_EraseRootFromParent_Done,
      // Label 32503: @2480982
      GIM_Try, /*On fail goto*//*Label 32504*/ GIMT_Encode4(2481002), // Rule ID 2287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
        // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2287,
        GIR_EraseRootFromParent_Done,
      // Label 32504: @2481002
      GIM_Reject,
    // Label 32502: @2481003
    GIM_Reject,
    // Label 32499: @2481004
    GIM_Try, /*On fail goto*//*Label 32505*/ GIMT_Encode4(2481061),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 32506*/ GIMT_Encode4(2481040), // Rule ID 2204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
        // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2204,
        GIR_EraseRootFromParent_Done,
      // Label 32506: @2481040
      GIM_Try, /*On fail goto*//*Label 32507*/ GIMT_Encode4(2481060), // Rule ID 2205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
        // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2205,
        GIR_EraseRootFromParent_Done,
      // Label 32507: @2481060
      GIM_Reject,
    // Label 32505: @2481061
    GIM_Reject,
    // Label 32500: @2481062
    GIM_Try, /*On fail goto*//*Label 32508*/ GIMT_Encode4(2481119),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2481098), // Rule ID 2244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
        // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2244,
        GIR_EraseRootFromParent_Done,
      // Label 32509: @2481098
      GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2481118), // Rule ID 2245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
        // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2245,
        GIR_EraseRootFromParent_Done,
      // Label 32510: @2481118
      GIM_Reject,
    // Label 32508: @2481119
    GIM_Reject,
    // Label 32501: @2481120
    GIM_Reject,
    // Label 92: @2481121
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32514*/ GIMT_Encode4(2481318),
    /*GILLT_s16*//*Label 32511*/ GIMT_Encode4(2481144),
    /*GILLT_s32*//*Label 32512*/ GIMT_Encode4(2481202),
    /*GILLT_s64*//*Label 32513*/ GIMT_Encode4(2481260),
    // Label 32511: @2481144
    GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2481201),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 32516*/ GIMT_Encode4(2481180), // Rule ID 2270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
        // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2270,
        GIR_EraseRootFromParent_Done,
      // Label 32516: @2481180
      GIM_Try, /*On fail goto*//*Label 32517*/ GIMT_Encode4(2481200), // Rule ID 2271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
        // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2271,
        GIR_EraseRootFromParent_Done,
      // Label 32517: @2481200
      GIM_Reject,
    // Label 32515: @2481201
    GIM_Reject,
    // Label 32512: @2481202
    GIM_Try, /*On fail goto*//*Label 32518*/ GIMT_Encode4(2481259),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 32519*/ GIMT_Encode4(2481238), // Rule ID 2188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
        // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2188,
        GIR_EraseRootFromParent_Done,
      // Label 32519: @2481238
      GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2481258), // Rule ID 2189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
        // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2189,
        GIR_EraseRootFromParent_Done,
      // Label 32520: @2481258
      GIM_Reject,
    // Label 32518: @2481259
    GIM_Reject,
    // Label 32513: @2481260
    GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2481317),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2481296), // Rule ID 2228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
        // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2228,
        GIR_EraseRootFromParent_Done,
      // Label 32522: @2481296
      GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2481316), // Rule ID 2229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
        // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2229,
        GIR_EraseRootFromParent_Done,
      // Label 32523: @2481316
      GIM_Reject,
    // Label 32521: @2481317
    GIM_Reject,
    // Label 32514: @2481318
    GIM_Reject,
    // Label 93: @2481319
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32527*/ GIMT_Encode4(2481516),
    /*GILLT_s16*//*Label 32524*/ GIMT_Encode4(2481342),
    /*GILLT_s32*//*Label 32525*/ GIMT_Encode4(2481400),
    /*GILLT_s64*//*Label 32526*/ GIMT_Encode4(2481458),
    // Label 32524: @2481342
    GIM_Try, /*On fail goto*//*Label 32528*/ GIMT_Encode4(2481399),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 32529*/ GIMT_Encode4(2481378), // Rule ID 2274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
        // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2274,
        GIR_EraseRootFromParent_Done,
      // Label 32529: @2481378
      GIM_Try, /*On fail goto*//*Label 32530*/ GIMT_Encode4(2481398), // Rule ID 2275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
        // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2275,
        GIR_EraseRootFromParent_Done,
      // Label 32530: @2481398
      GIM_Reject,
    // Label 32528: @2481399
    GIM_Reject,
    // Label 32525: @2481400
    GIM_Try, /*On fail goto*//*Label 32531*/ GIMT_Encode4(2481457),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 32532*/ GIMT_Encode4(2481436), // Rule ID 2192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
        // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2192,
        GIR_EraseRootFromParent_Done,
      // Label 32532: @2481436
      GIM_Try, /*On fail goto*//*Label 32533*/ GIMT_Encode4(2481456), // Rule ID 2193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
        // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2193,
        GIR_EraseRootFromParent_Done,
      // Label 32533: @2481456
      GIM_Reject,
    // Label 32531: @2481457
    GIM_Reject,
    // Label 32526: @2481458
    GIM_Try, /*On fail goto*//*Label 32534*/ GIMT_Encode4(2481515),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 32535*/ GIMT_Encode4(2481494), // Rule ID 2232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
        // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2232,
        GIR_EraseRootFromParent_Done,
      // Label 32535: @2481494
      GIM_Try, /*On fail goto*//*Label 32536*/ GIMT_Encode4(2481514), // Rule ID 2233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
        // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2233,
        GIR_EraseRootFromParent_Done,
      // Label 32536: @2481514
      GIM_Reject,
    // Label 32534: @2481515
    GIM_Reject,
    // Label 32527: @2481516
    GIM_Reject,
    // Label 94: @2481517
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32555*/ GIMT_Encode4(2483944),
    /*GILLT_s16*//*Label 32537*/ GIMT_Encode4(2481648),
    /*GILLT_s32*//*Label 32538*/ GIMT_Encode4(2481797),
    /*GILLT_s64*//*Label 32539*/ GIMT_Encode4(2481946), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 32540*/ GIMT_Encode4(2482129),
    /*GILLT_nxv1s32*//*Label 32541*/ GIMT_Encode4(2482250),
    /*GILLT_nxv1s64*//*Label 32542*/ GIMT_Encode4(2482371), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 32543*/ GIMT_Encode4(2482492),
    /*GILLT_nxv2s32*//*Label 32544*/ GIMT_Encode4(2482613),
    /*GILLT_nxv2s64*//*Label 32545*/ GIMT_Encode4(2482734), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 32546*/ GIMT_Encode4(2482855),
    /*GILLT_nxv4s32*//*Label 32547*/ GIMT_Encode4(2482976),
    /*GILLT_nxv4s64*//*Label 32548*/ GIMT_Encode4(2483097), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 32549*/ GIMT_Encode4(2483218),
    /*GILLT_nxv8s32*//*Label 32550*/ GIMT_Encode4(2483339),
    /*GILLT_nxv8s64*//*Label 32551*/ GIMT_Encode4(2483460), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 32552*/ GIMT_Encode4(2483581),
    /*GILLT_nxv16s32*//*Label 32553*/ GIMT_Encode4(2483702), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 32554*/ GIMT_Encode4(2483823),
    // Label 32537: @2481648
    GIM_Try, /*On fail goto*//*Label 32556*/ GIMT_Encode4(2481796),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 32557*/ GIMT_Encode4(2481693), // Rule ID 1814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1814,
        GIR_EraseRootFromParent_Done,
      // Label 32557: @2481693
      GIM_Try, /*On fail goto*//*Label 32558*/ GIMT_Encode4(2481727), // Rule ID 1815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1815,
        GIR_EraseRootFromParent_Done,
      // Label 32558: @2481727
      GIM_Try, /*On fail goto*//*Label 32559*/ GIMT_Encode4(2481761), // Rule ID 1818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1818,
        GIR_EraseRootFromParent_Done,
      // Label 32559: @2481761
      GIM_Try, /*On fail goto*//*Label 32560*/ GIMT_Encode4(2481795), // Rule ID 1819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1819,
        GIR_EraseRootFromParent_Done,
      // Label 32560: @2481795
      GIM_Reject,
    // Label 32556: @2481796
    GIM_Reject,
    // Label 32538: @2481797
    GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2481945),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2481842), // Rule ID 1105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1105,
        GIR_EraseRootFromParent_Done,
      // Label 32562: @2481842
      GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2481876), // Rule ID 1106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1106,
        GIR_EraseRootFromParent_Done,
      // Label 32563: @2481876
      GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2481910), // Rule ID 1109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1109,
        GIR_EraseRootFromParent_Done,
      // Label 32564: @2481910
      GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2481944), // Rule ID 1110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1110,
        GIR_EraseRootFromParent_Done,
      // Label 32565: @2481944
      GIM_Reject,
    // Label 32561: @2481945
    GIM_Reject,
    // Label 32539: @2481946
    GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2482128),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2481991), // Rule ID 1440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1440,
        GIR_EraseRootFromParent_Done,
      // Label 32567: @2481991
      GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2482025), // Rule ID 1441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1441,
        GIR_EraseRootFromParent_Done,
      // Label 32568: @2482025
      GIM_Try, /*On fail goto*//*Label 32569*/ GIMT_Encode4(2482059), // Rule ID 1444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1444,
        GIR_EraseRootFromParent_Done,
      // Label 32569: @2482059
      GIM_Try, /*On fail goto*//*Label 32570*/ GIMT_Encode4(2482093), // Rule ID 1445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1445,
        GIR_EraseRootFromParent_Done,
      // Label 32570: @2482093
      GIM_Try, /*On fail goto*//*Label 32571*/ GIMT_Encode4(2482127), // Rule ID 1448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1448,
        GIR_EraseRootFromParent_Done,
      // Label 32571: @2482127
      GIM_Reject,
    // Label 32566: @2482128
    GIM_Reject,
    // Label 32540: @2482129
    GIM_Try, /*On fail goto*//*Label 32572*/ GIMT_Encode4(2482249),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2482200), // Rule ID 45540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45540,
        GIR_EraseRootFromParent_Done,
      // Label 32573: @2482200
      GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2482248), // Rule ID 45541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45541,
        GIR_EraseRootFromParent_Done,
      // Label 32574: @2482248
      GIM_Reject,
    // Label 32572: @2482249
    GIM_Reject,
    // Label 32541: @2482250
    GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2482370),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2482321), // Rule ID 52852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52852,
        GIR_EraseRootFromParent_Done,
      // Label 32576: @2482321
      GIM_Try, /*On fail goto*//*Label 32577*/ GIMT_Encode4(2482369), // Rule ID 52853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52853,
        GIR_EraseRootFromParent_Done,
      // Label 32577: @2482369
      GIM_Reject,
    // Label 32575: @2482370
    GIM_Reject,
    // Label 32542: @2482371
    GIM_Try, /*On fail goto*//*Label 32578*/ GIMT_Encode4(2482491),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32579*/ GIMT_Encode4(2482442), // Rule ID 52888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52888,
        GIR_EraseRootFromParent_Done,
      // Label 32579: @2482442
      GIM_Try, /*On fail goto*//*Label 32580*/ GIMT_Encode4(2482490), // Rule ID 52889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52889,
        GIR_EraseRootFromParent_Done,
      // Label 32580: @2482490
      GIM_Reject,
    // Label 32578: @2482491
    GIM_Reject,
    // Label 32543: @2482492
    GIM_Try, /*On fail goto*//*Label 32581*/ GIMT_Encode4(2482612),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32582*/ GIMT_Encode4(2482563), // Rule ID 52840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52840,
        GIR_EraseRootFromParent_Done,
      // Label 32582: @2482563
      GIM_Try, /*On fail goto*//*Label 32583*/ GIMT_Encode4(2482611), // Rule ID 52841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52841,
        GIR_EraseRootFromParent_Done,
      // Label 32583: @2482611
      GIM_Reject,
    // Label 32581: @2482612
    GIM_Reject,
    // Label 32544: @2482613
    GIM_Try, /*On fail goto*//*Label 32584*/ GIMT_Encode4(2482733),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32585*/ GIMT_Encode4(2482684), // Rule ID 52876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52876,
        GIR_EraseRootFromParent_Done,
      // Label 32585: @2482684
      GIM_Try, /*On fail goto*//*Label 32586*/ GIMT_Encode4(2482732), // Rule ID 52877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52877,
        GIR_EraseRootFromParent_Done,
      // Label 32586: @2482732
      GIM_Reject,
    // Label 32584: @2482733
    GIM_Reject,
    // Label 32545: @2482734
    GIM_Try, /*On fail goto*//*Label 32587*/ GIMT_Encode4(2482854),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32588*/ GIMT_Encode4(2482805), // Rule ID 52972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52972,
        GIR_EraseRootFromParent_Done,
      // Label 32588: @2482805
      GIM_Try, /*On fail goto*//*Label 32589*/ GIMT_Encode4(2482853), // Rule ID 52973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52973,
        GIR_EraseRootFromParent_Done,
      // Label 32589: @2482853
      GIM_Reject,
    // Label 32587: @2482854
    GIM_Reject,
    // Label 32546: @2482855
    GIM_Try, /*On fail goto*//*Label 32590*/ GIMT_Encode4(2482975),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32591*/ GIMT_Encode4(2482926), // Rule ID 52864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52864,
        GIR_EraseRootFromParent_Done,
      // Label 32591: @2482926
      GIM_Try, /*On fail goto*//*Label 32592*/ GIMT_Encode4(2482974), // Rule ID 52865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52865,
        GIR_EraseRootFromParent_Done,
      // Label 32592: @2482974
      GIM_Reject,
    // Label 32590: @2482975
    GIM_Reject,
    // Label 32547: @2482976
    GIM_Try, /*On fail goto*//*Label 32593*/ GIMT_Encode4(2483096),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32594*/ GIMT_Encode4(2483047), // Rule ID 52936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52936,
        GIR_EraseRootFromParent_Done,
      // Label 32594: @2483047
      GIM_Try, /*On fail goto*//*Label 32595*/ GIMT_Encode4(2483095), // Rule ID 52937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52937,
        GIR_EraseRootFromParent_Done,
      // Label 32595: @2483095
      GIM_Reject,
    // Label 32593: @2483096
    GIM_Reject,
    // Label 32548: @2483097
    GIM_Try, /*On fail goto*//*Label 32596*/ GIMT_Encode4(2483217),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32597*/ GIMT_Encode4(2483168), // Rule ID 52984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52984,
        GIR_EraseRootFromParent_Done,
      // Label 32597: @2483168
      GIM_Try, /*On fail goto*//*Label 32598*/ GIMT_Encode4(2483216), // Rule ID 52985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52985,
        GIR_EraseRootFromParent_Done,
      // Label 32598: @2483216
      GIM_Reject,
    // Label 32596: @2483217
    GIM_Reject,
    // Label 32549: @2483218
    GIM_Try, /*On fail goto*//*Label 32599*/ GIMT_Encode4(2483338),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32600*/ GIMT_Encode4(2483289), // Rule ID 52900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52900,
        GIR_EraseRootFromParent_Done,
      // Label 32600: @2483289
      GIM_Try, /*On fail goto*//*Label 32601*/ GIMT_Encode4(2483337), // Rule ID 52901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52901,
        GIR_EraseRootFromParent_Done,
      // Label 32601: @2483337
      GIM_Reject,
    // Label 32599: @2483338
    GIM_Reject,
    // Label 32550: @2483339
    GIM_Try, /*On fail goto*//*Label 32602*/ GIMT_Encode4(2483459),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32603*/ GIMT_Encode4(2483410), // Rule ID 52948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52948,
        GIR_EraseRootFromParent_Done,
      // Label 32603: @2483410
      GIM_Try, /*On fail goto*//*Label 32604*/ GIMT_Encode4(2483458), // Rule ID 52949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52949,
        GIR_EraseRootFromParent_Done,
      // Label 32604: @2483458
      GIM_Reject,
    // Label 32602: @2483459
    GIM_Reject,
    // Label 32551: @2483460
    GIM_Try, /*On fail goto*//*Label 32605*/ GIMT_Encode4(2483580),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2483531), // Rule ID 52996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52996,
        GIR_EraseRootFromParent_Done,
      // Label 32606: @2483531
      GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2483579), // Rule ID 52997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52997,
        GIR_EraseRootFromParent_Done,
      // Label 32607: @2483579
      GIM_Reject,
    // Label 32605: @2483580
    GIM_Reject,
    // Label 32552: @2483581
    GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2483701),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2483652), // Rule ID 52912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52912,
        GIR_EraseRootFromParent_Done,
      // Label 32609: @2483652
      GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2483700), // Rule ID 52913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52913,
        GIR_EraseRootFromParent_Done,
      // Label 32610: @2483700
      GIM_Reject,
    // Label 32608: @2483701
    GIM_Reject,
    // Label 32553: @2483702
    GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2483822),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2483773), // Rule ID 52960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52960,
        GIR_EraseRootFromParent_Done,
      // Label 32612: @2483773
      GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2483821), // Rule ID 52961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52961,
        GIR_EraseRootFromParent_Done,
      // Label 32613: @2483821
      GIM_Reject,
    // Label 32611: @2483822
    GIM_Reject,
    // Label 32554: @2483823
    GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2483943),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2483894), // Rule ID 52924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52924,
        GIR_EraseRootFromParent_Done,
      // Label 32615: @2483894
      GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2483942), // Rule ID 52925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52925,
        GIR_EraseRootFromParent_Done,
      // Label 32616: @2483942
      GIM_Reject,
    // Label 32614: @2483943
    GIM_Reject,
    // Label 32555: @2483944
    GIM_Reject,
    // Label 95: @2483945
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32635*/ GIMT_Encode4(2486372),
    /*GILLT_s16*//*Label 32617*/ GIMT_Encode4(2484076),
    /*GILLT_s32*//*Label 32618*/ GIMT_Encode4(2484225),
    /*GILLT_s64*//*Label 32619*/ GIMT_Encode4(2484374), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 32620*/ GIMT_Encode4(2484557),
    /*GILLT_nxv1s32*//*Label 32621*/ GIMT_Encode4(2484678),
    /*GILLT_nxv1s64*//*Label 32622*/ GIMT_Encode4(2484799), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 32623*/ GIMT_Encode4(2484920),
    /*GILLT_nxv2s32*//*Label 32624*/ GIMT_Encode4(2485041),
    /*GILLT_nxv2s64*//*Label 32625*/ GIMT_Encode4(2485162), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 32626*/ GIMT_Encode4(2485283),
    /*GILLT_nxv4s32*//*Label 32627*/ GIMT_Encode4(2485404),
    /*GILLT_nxv4s64*//*Label 32628*/ GIMT_Encode4(2485525), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 32629*/ GIMT_Encode4(2485646),
    /*GILLT_nxv8s32*//*Label 32630*/ GIMT_Encode4(2485767),
    /*GILLT_nxv8s64*//*Label 32631*/ GIMT_Encode4(2485888), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 32632*/ GIMT_Encode4(2486009),
    /*GILLT_nxv16s32*//*Label 32633*/ GIMT_Encode4(2486130), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 32634*/ GIMT_Encode4(2486251),
    // Label 32617: @2484076
    GIM_Try, /*On fail goto*//*Label 32636*/ GIMT_Encode4(2484224),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 32637*/ GIMT_Encode4(2484121), // Rule ID 1822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1822,
        GIR_EraseRootFromParent_Done,
      // Label 32637: @2484121
      GIM_Try, /*On fail goto*//*Label 32638*/ GIMT_Encode4(2484155), // Rule ID 1823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1823,
        GIR_EraseRootFromParent_Done,
      // Label 32638: @2484155
      GIM_Try, /*On fail goto*//*Label 32639*/ GIMT_Encode4(2484189), // Rule ID 1826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1826,
        GIR_EraseRootFromParent_Done,
      // Label 32639: @2484189
      GIM_Try, /*On fail goto*//*Label 32640*/ GIMT_Encode4(2484223), // Rule ID 1827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1827,
        GIR_EraseRootFromParent_Done,
      // Label 32640: @2484223
      GIM_Reject,
    // Label 32636: @2484224
    GIM_Reject,
    // Label 32618: @2484225
    GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2484373),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2484270), // Rule ID 1113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1113,
        GIR_EraseRootFromParent_Done,
      // Label 32642: @2484270
      GIM_Try, /*On fail goto*//*Label 32643*/ GIMT_Encode4(2484304), // Rule ID 1114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1114,
        GIR_EraseRootFromParent_Done,
      // Label 32643: @2484304
      GIM_Try, /*On fail goto*//*Label 32644*/ GIMT_Encode4(2484338), // Rule ID 1117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1117,
        GIR_EraseRootFromParent_Done,
      // Label 32644: @2484338
      GIM_Try, /*On fail goto*//*Label 32645*/ GIMT_Encode4(2484372), // Rule ID 1118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1118,
        GIR_EraseRootFromParent_Done,
      // Label 32645: @2484372
      GIM_Reject,
    // Label 32641: @2484373
    GIM_Reject,
    // Label 32619: @2484374
    GIM_Try, /*On fail goto*//*Label 32646*/ GIMT_Encode4(2484556),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 32647*/ GIMT_Encode4(2484419), // Rule ID 1450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1450,
        GIR_EraseRootFromParent_Done,
      // Label 32647: @2484419
      GIM_Try, /*On fail goto*//*Label 32648*/ GIMT_Encode4(2484453), // Rule ID 1451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1451,
        GIR_EraseRootFromParent_Done,
      // Label 32648: @2484453
      GIM_Try, /*On fail goto*//*Label 32649*/ GIMT_Encode4(2484487), // Rule ID 1454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1454,
        GIR_EraseRootFromParent_Done,
      // Label 32649: @2484487
      GIM_Try, /*On fail goto*//*Label 32650*/ GIMT_Encode4(2484521), // Rule ID 1455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1455,
        GIR_EraseRootFromParent_Done,
      // Label 32650: @2484521
      GIM_Try, /*On fail goto*//*Label 32651*/ GIMT_Encode4(2484555), // Rule ID 1458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1458,
        GIR_EraseRootFromParent_Done,
      // Label 32651: @2484555
      GIM_Reject,
    // Label 32646: @2484556
    GIM_Reject,
    // Label 32620: @2484557
    GIM_Try, /*On fail goto*//*Label 32652*/ GIMT_Encode4(2484677),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32653*/ GIMT_Encode4(2484628), // Rule ID 53008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53008,
        GIR_EraseRootFromParent_Done,
      // Label 32653: @2484628
      GIM_Try, /*On fail goto*//*Label 32654*/ GIMT_Encode4(2484676), // Rule ID 53009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53009,
        GIR_EraseRootFromParent_Done,
      // Label 32654: @2484676
      GIM_Reject,
    // Label 32652: @2484677
    GIM_Reject,
    // Label 32621: @2484678
    GIM_Try, /*On fail goto*//*Label 32655*/ GIMT_Encode4(2484798),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32656*/ GIMT_Encode4(2484749), // Rule ID 53032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53032,
        GIR_EraseRootFromParent_Done,
      // Label 32656: @2484749
      GIM_Try, /*On fail goto*//*Label 32657*/ GIMT_Encode4(2484797), // Rule ID 53033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53033,
        GIR_EraseRootFromParent_Done,
      // Label 32657: @2484797
      GIM_Reject,
    // Label 32655: @2484798
    GIM_Reject,
    // Label 32622: @2484799
    GIM_Try, /*On fail goto*//*Label 32658*/ GIMT_Encode4(2484919),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32659*/ GIMT_Encode4(2484870), // Rule ID 53068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53068,
        GIR_EraseRootFromParent_Done,
      // Label 32659: @2484870
      GIM_Try, /*On fail goto*//*Label 32660*/ GIMT_Encode4(2484918), // Rule ID 53069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53069,
        GIR_EraseRootFromParent_Done,
      // Label 32660: @2484918
      GIM_Reject,
    // Label 32658: @2484919
    GIM_Reject,
    // Label 32623: @2484920
    GIM_Try, /*On fail goto*//*Label 32661*/ GIMT_Encode4(2485040),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32662*/ GIMT_Encode4(2484991), // Rule ID 53020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53020,
        GIR_EraseRootFromParent_Done,
      // Label 32662: @2484991
      GIM_Try, /*On fail goto*//*Label 32663*/ GIMT_Encode4(2485039), // Rule ID 53021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53021,
        GIR_EraseRootFromParent_Done,
      // Label 32663: @2485039
      GIM_Reject,
    // Label 32661: @2485040
    GIM_Reject,
    // Label 32624: @2485041
    GIM_Try, /*On fail goto*//*Label 32664*/ GIMT_Encode4(2485161),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32665*/ GIMT_Encode4(2485112), // Rule ID 53056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53056,
        GIR_EraseRootFromParent_Done,
      // Label 32665: @2485112
      GIM_Try, /*On fail goto*//*Label 32666*/ GIMT_Encode4(2485160), // Rule ID 53057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53057,
        GIR_EraseRootFromParent_Done,
      // Label 32666: @2485160
      GIM_Reject,
    // Label 32664: @2485161
    GIM_Reject,
    // Label 32625: @2485162
    GIM_Try, /*On fail goto*//*Label 32667*/ GIMT_Encode4(2485282),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32668*/ GIMT_Encode4(2485233), // Rule ID 53152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53152,
        GIR_EraseRootFromParent_Done,
      // Label 32668: @2485233
      GIM_Try, /*On fail goto*//*Label 32669*/ GIMT_Encode4(2485281), // Rule ID 53153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53153,
        GIR_EraseRootFromParent_Done,
      // Label 32669: @2485281
      GIM_Reject,
    // Label 32667: @2485282
    GIM_Reject,
    // Label 32626: @2485283
    GIM_Try, /*On fail goto*//*Label 32670*/ GIMT_Encode4(2485403),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32671*/ GIMT_Encode4(2485354), // Rule ID 53044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53044,
        GIR_EraseRootFromParent_Done,
      // Label 32671: @2485354
      GIM_Try, /*On fail goto*//*Label 32672*/ GIMT_Encode4(2485402), // Rule ID 53045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53045,
        GIR_EraseRootFromParent_Done,
      // Label 32672: @2485402
      GIM_Reject,
    // Label 32670: @2485403
    GIM_Reject,
    // Label 32627: @2485404
    GIM_Try, /*On fail goto*//*Label 32673*/ GIMT_Encode4(2485524),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32674*/ GIMT_Encode4(2485475), // Rule ID 53116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53116,
        GIR_EraseRootFromParent_Done,
      // Label 32674: @2485475
      GIM_Try, /*On fail goto*//*Label 32675*/ GIMT_Encode4(2485523), // Rule ID 53117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53117,
        GIR_EraseRootFromParent_Done,
      // Label 32675: @2485523
      GIM_Reject,
    // Label 32673: @2485524
    GIM_Reject,
    // Label 32628: @2485525
    GIM_Try, /*On fail goto*//*Label 32676*/ GIMT_Encode4(2485645),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32677*/ GIMT_Encode4(2485596), // Rule ID 53164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53164,
        GIR_EraseRootFromParent_Done,
      // Label 32677: @2485596
      GIM_Try, /*On fail goto*//*Label 32678*/ GIMT_Encode4(2485644), // Rule ID 53165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53165,
        GIR_EraseRootFromParent_Done,
      // Label 32678: @2485644
      GIM_Reject,
    // Label 32676: @2485645
    GIM_Reject,
    // Label 32629: @2485646
    GIM_Try, /*On fail goto*//*Label 32679*/ GIMT_Encode4(2485766),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2485717), // Rule ID 53080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53080,
        GIR_EraseRootFromParent_Done,
      // Label 32680: @2485717
      GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2485765), // Rule ID 53081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53081,
        GIR_EraseRootFromParent_Done,
      // Label 32681: @2485765
      GIM_Reject,
    // Label 32679: @2485766
    GIM_Reject,
    // Label 32630: @2485767
    GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2485887),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2485838), // Rule ID 53128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53128,
        GIR_EraseRootFromParent_Done,
      // Label 32683: @2485838
      GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2485886), // Rule ID 53129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53129,
        GIR_EraseRootFromParent_Done,
      // Label 32684: @2485886
      GIM_Reject,
    // Label 32682: @2485887
    GIM_Reject,
    // Label 32631: @2485888
    GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2486008),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2485959), // Rule ID 53176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53176,
        GIR_EraseRootFromParent_Done,
      // Label 32686: @2485959
      GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2486007), // Rule ID 53177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53177,
        GIR_EraseRootFromParent_Done,
      // Label 32687: @2486007
      GIM_Reject,
    // Label 32685: @2486008
    GIM_Reject,
    // Label 32632: @2486009
    GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2486129),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2486080), // Rule ID 53092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53092,
        GIR_EraseRootFromParent_Done,
      // Label 32689: @2486080
      GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2486128), // Rule ID 53093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53093,
        GIR_EraseRootFromParent_Done,
      // Label 32690: @2486128
      GIM_Reject,
    // Label 32688: @2486129
    GIM_Reject,
    // Label 32633: @2486130
    GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2486250),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2486201), // Rule ID 53140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53140,
        GIR_EraseRootFromParent_Done,
      // Label 32692: @2486201
      GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2486249), // Rule ID 53141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53141,
        GIR_EraseRootFromParent_Done,
      // Label 32693: @2486249
      GIM_Reject,
    // Label 32691: @2486250
    GIM_Reject,
    // Label 32634: @2486251
    GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2486371),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2486322), // Rule ID 53104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53104,
        GIR_EraseRootFromParent_Done,
      // Label 32695: @2486322
      GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2486370), // Rule ID 53105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53105,
        GIR_EraseRootFromParent_Done,
      // Label 32696: @2486370
      GIM_Reject,
    // Label 32694: @2486371
    GIM_Reject,
    // Label 32635: @2486372
    GIM_Reject,
    // Label 96: @2486373
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32715*/ GIMT_Encode4(2488800),
    /*GILLT_s16*//*Label 32697*/ GIMT_Encode4(2486504),
    /*GILLT_s32*//*Label 32698*/ GIMT_Encode4(2486653),
    /*GILLT_s64*//*Label 32699*/ GIMT_Encode4(2486802), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 32700*/ GIMT_Encode4(2486985),
    /*GILLT_nxv1s32*//*Label 32701*/ GIMT_Encode4(2487106),
    /*GILLT_nxv1s64*//*Label 32702*/ GIMT_Encode4(2487227), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 32703*/ GIMT_Encode4(2487348),
    /*GILLT_nxv2s32*//*Label 32704*/ GIMT_Encode4(2487469),
    /*GILLT_nxv2s64*//*Label 32705*/ GIMT_Encode4(2487590), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 32706*/ GIMT_Encode4(2487711),
    /*GILLT_nxv4s32*//*Label 32707*/ GIMT_Encode4(2487832),
    /*GILLT_nxv4s64*//*Label 32708*/ GIMT_Encode4(2487953), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 32709*/ GIMT_Encode4(2488074),
    /*GILLT_nxv8s32*//*Label 32710*/ GIMT_Encode4(2488195),
    /*GILLT_nxv8s64*//*Label 32711*/ GIMT_Encode4(2488316), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 32712*/ GIMT_Encode4(2488437),
    /*GILLT_nxv16s32*//*Label 32713*/ GIMT_Encode4(2488558), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 32714*/ GIMT_Encode4(2488679),
    // Label 32697: @2486504
    GIM_Try, /*On fail goto*//*Label 32716*/ GIMT_Encode4(2486652),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 32717*/ GIMT_Encode4(2486549), // Rule ID 1830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1830,
        GIR_EraseRootFromParent_Done,
      // Label 32717: @2486549
      GIM_Try, /*On fail goto*//*Label 32718*/ GIMT_Encode4(2486583), // Rule ID 1831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1831,
        GIR_EraseRootFromParent_Done,
      // Label 32718: @2486583
      GIM_Try, /*On fail goto*//*Label 32719*/ GIMT_Encode4(2486617), // Rule ID 1834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1834,
        GIR_EraseRootFromParent_Done,
      // Label 32719: @2486617
      GIM_Try, /*On fail goto*//*Label 32720*/ GIMT_Encode4(2486651), // Rule ID 1835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1835,
        GIR_EraseRootFromParent_Done,
      // Label 32720: @2486651
      GIM_Reject,
    // Label 32716: @2486652
    GIM_Reject,
    // Label 32698: @2486653
    GIM_Try, /*On fail goto*//*Label 32721*/ GIMT_Encode4(2486801),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 32722*/ GIMT_Encode4(2486698), // Rule ID 1121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1121,
        GIR_EraseRootFromParent_Done,
      // Label 32722: @2486698
      GIM_Try, /*On fail goto*//*Label 32723*/ GIMT_Encode4(2486732), // Rule ID 1122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1122,
        GIR_EraseRootFromParent_Done,
      // Label 32723: @2486732
      GIM_Try, /*On fail goto*//*Label 32724*/ GIMT_Encode4(2486766), // Rule ID 1125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1125,
        GIR_EraseRootFromParent_Done,
      // Label 32724: @2486766
      GIM_Try, /*On fail goto*//*Label 32725*/ GIMT_Encode4(2486800), // Rule ID 1126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1126,
        GIR_EraseRootFromParent_Done,
      // Label 32725: @2486800
      GIM_Reject,
    // Label 32721: @2486801
    GIM_Reject,
    // Label 32699: @2486802
    GIM_Try, /*On fail goto*//*Label 32726*/ GIMT_Encode4(2486984),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 32727*/ GIMT_Encode4(2486847), // Rule ID 1460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1460,
        GIR_EraseRootFromParent_Done,
      // Label 32727: @2486847
      GIM_Try, /*On fail goto*//*Label 32728*/ GIMT_Encode4(2486881), // Rule ID 1461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1461,
        GIR_EraseRootFromParent_Done,
      // Label 32728: @2486881
      GIM_Try, /*On fail goto*//*Label 32729*/ GIMT_Encode4(2486915), // Rule ID 1464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1464,
        GIR_EraseRootFromParent_Done,
      // Label 32729: @2486915
      GIM_Try, /*On fail goto*//*Label 32730*/ GIMT_Encode4(2486949), // Rule ID 1465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1465,
        GIR_EraseRootFromParent_Done,
      // Label 32730: @2486949
      GIM_Try, /*On fail goto*//*Label 32731*/ GIMT_Encode4(2486983), // Rule ID 1468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1468,
        GIR_EraseRootFromParent_Done,
      // Label 32731: @2486983
      GIM_Reject,
    // Label 32726: @2486984
    GIM_Reject,
    // Label 32700: @2486985
    GIM_Try, /*On fail goto*//*Label 32732*/ GIMT_Encode4(2487105),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32733*/ GIMT_Encode4(2487056), // Rule ID 53776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53776,
        GIR_EraseRootFromParent_Done,
      // Label 32733: @2487056
      GIM_Try, /*On fail goto*//*Label 32734*/ GIMT_Encode4(2487104), // Rule ID 53777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53777,
        GIR_EraseRootFromParent_Done,
      // Label 32734: @2487104
      GIM_Reject,
    // Label 32732: @2487105
    GIM_Reject,
    // Label 32701: @2487106
    GIM_Try, /*On fail goto*//*Label 32735*/ GIMT_Encode4(2487226),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32736*/ GIMT_Encode4(2487177), // Rule ID 53800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53800,
        GIR_EraseRootFromParent_Done,
      // Label 32736: @2487177
      GIM_Try, /*On fail goto*//*Label 32737*/ GIMT_Encode4(2487225), // Rule ID 53801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53801,
        GIR_EraseRootFromParent_Done,
      // Label 32737: @2487225
      GIM_Reject,
    // Label 32735: @2487226
    GIM_Reject,
    // Label 32702: @2487227
    GIM_Try, /*On fail goto*//*Label 32738*/ GIMT_Encode4(2487347),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32739*/ GIMT_Encode4(2487298), // Rule ID 53836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53836,
        GIR_EraseRootFromParent_Done,
      // Label 32739: @2487298
      GIM_Try, /*On fail goto*//*Label 32740*/ GIMT_Encode4(2487346), // Rule ID 53837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53837,
        GIR_EraseRootFromParent_Done,
      // Label 32740: @2487346
      GIM_Reject,
    // Label 32738: @2487347
    GIM_Reject,
    // Label 32703: @2487348
    GIM_Try, /*On fail goto*//*Label 32741*/ GIMT_Encode4(2487468),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2487419), // Rule ID 53788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53788,
        GIR_EraseRootFromParent_Done,
      // Label 32742: @2487419
      GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2487467), // Rule ID 53789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53789,
        GIR_EraseRootFromParent_Done,
      // Label 32743: @2487467
      GIM_Reject,
    // Label 32741: @2487468
    GIM_Reject,
    // Label 32704: @2487469
    GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2487589),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32745*/ GIMT_Encode4(2487540), // Rule ID 53824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53824,
        GIR_EraseRootFromParent_Done,
      // Label 32745: @2487540
      GIM_Try, /*On fail goto*//*Label 32746*/ GIMT_Encode4(2487588), // Rule ID 53825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53825,
        GIR_EraseRootFromParent_Done,
      // Label 32746: @2487588
      GIM_Reject,
    // Label 32744: @2487589
    GIM_Reject,
    // Label 32705: @2487590
    GIM_Try, /*On fail goto*//*Label 32747*/ GIMT_Encode4(2487710),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32748*/ GIMT_Encode4(2487661), // Rule ID 53920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53920,
        GIR_EraseRootFromParent_Done,
      // Label 32748: @2487661
      GIM_Try, /*On fail goto*//*Label 32749*/ GIMT_Encode4(2487709), // Rule ID 53921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53921,
        GIR_EraseRootFromParent_Done,
      // Label 32749: @2487709
      GIM_Reject,
    // Label 32747: @2487710
    GIM_Reject,
    // Label 32706: @2487711
    GIM_Try, /*On fail goto*//*Label 32750*/ GIMT_Encode4(2487831),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32751*/ GIMT_Encode4(2487782), // Rule ID 53812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53812,
        GIR_EraseRootFromParent_Done,
      // Label 32751: @2487782
      GIM_Try, /*On fail goto*//*Label 32752*/ GIMT_Encode4(2487830), // Rule ID 53813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53813,
        GIR_EraseRootFromParent_Done,
      // Label 32752: @2487830
      GIM_Reject,
    // Label 32750: @2487831
    GIM_Reject,
    // Label 32707: @2487832
    GIM_Try, /*On fail goto*//*Label 32753*/ GIMT_Encode4(2487952),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32754*/ GIMT_Encode4(2487903), // Rule ID 53884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53884,
        GIR_EraseRootFromParent_Done,
      // Label 32754: @2487903
      GIM_Try, /*On fail goto*//*Label 32755*/ GIMT_Encode4(2487951), // Rule ID 53885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53885,
        GIR_EraseRootFromParent_Done,
      // Label 32755: @2487951
      GIM_Reject,
    // Label 32753: @2487952
    GIM_Reject,
    // Label 32708: @2487953
    GIM_Try, /*On fail goto*//*Label 32756*/ GIMT_Encode4(2488073),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32757*/ GIMT_Encode4(2488024), // Rule ID 53932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53932,
        GIR_EraseRootFromParent_Done,
      // Label 32757: @2488024
      GIM_Try, /*On fail goto*//*Label 32758*/ GIMT_Encode4(2488072), // Rule ID 53933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53933,
        GIR_EraseRootFromParent_Done,
      // Label 32758: @2488072
      GIM_Reject,
    // Label 32756: @2488073
    GIM_Reject,
    // Label 32709: @2488074
    GIM_Try, /*On fail goto*//*Label 32759*/ GIMT_Encode4(2488194),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32760*/ GIMT_Encode4(2488145), // Rule ID 53848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53848,
        GIR_EraseRootFromParent_Done,
      // Label 32760: @2488145
      GIM_Try, /*On fail goto*//*Label 32761*/ GIMT_Encode4(2488193), // Rule ID 53849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53849,
        GIR_EraseRootFromParent_Done,
      // Label 32761: @2488193
      GIM_Reject,
    // Label 32759: @2488194
    GIM_Reject,
    // Label 32710: @2488195
    GIM_Try, /*On fail goto*//*Label 32762*/ GIMT_Encode4(2488315),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32763*/ GIMT_Encode4(2488266), // Rule ID 53896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53896,
        GIR_EraseRootFromParent_Done,
      // Label 32763: @2488266
      GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2488314), // Rule ID 53897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53897,
        GIR_EraseRootFromParent_Done,
      // Label 32764: @2488314
      GIM_Reject,
    // Label 32762: @2488315
    GIM_Reject,
    // Label 32711: @2488316
    GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2488436),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2488387), // Rule ID 53944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53944,
        GIR_EraseRootFromParent_Done,
      // Label 32766: @2488387
      GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2488435), // Rule ID 53945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53945,
        GIR_EraseRootFromParent_Done,
      // Label 32767: @2488435
      GIM_Reject,
    // Label 32765: @2488436
    GIM_Reject,
    // Label 32712: @2488437
    GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2488557),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2488508), // Rule ID 53860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53860,
        GIR_EraseRootFromParent_Done,
      // Label 32769: @2488508
      GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2488556), // Rule ID 53861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53861,
        GIR_EraseRootFromParent_Done,
      // Label 32770: @2488556
      GIM_Reject,
    // Label 32768: @2488557
    GIM_Reject,
    // Label 32713: @2488558
    GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2488678),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2488629), // Rule ID 53908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53908,
        GIR_EraseRootFromParent_Done,
      // Label 32772: @2488629
      GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2488677), // Rule ID 53909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53909,
        GIR_EraseRootFromParent_Done,
      // Label 32773: @2488677
      GIM_Reject,
    // Label 32771: @2488678
    GIM_Reject,
    // Label 32714: @2488679
    GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2488799),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2488750), // Rule ID 53872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53872,
        GIR_EraseRootFromParent_Done,
      // Label 32775: @2488750
      GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2488798), // Rule ID 53873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53873,
        GIR_EraseRootFromParent_Done,
      // Label 32776: @2488798
      GIM_Reject,
    // Label 32774: @2488799
    GIM_Reject,
    // Label 32715: @2488800
    GIM_Reject,
    // Label 97: @2488801
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32795*/ GIMT_Encode4(2491228),
    /*GILLT_s16*//*Label 32777*/ GIMT_Encode4(2488932),
    /*GILLT_s32*//*Label 32778*/ GIMT_Encode4(2489081),
    /*GILLT_s64*//*Label 32779*/ GIMT_Encode4(2489230), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 32780*/ GIMT_Encode4(2489413),
    /*GILLT_nxv1s32*//*Label 32781*/ GIMT_Encode4(2489534),
    /*GILLT_nxv1s64*//*Label 32782*/ GIMT_Encode4(2489655), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 32783*/ GIMT_Encode4(2489776),
    /*GILLT_nxv2s32*//*Label 32784*/ GIMT_Encode4(2489897),
    /*GILLT_nxv2s64*//*Label 32785*/ GIMT_Encode4(2490018), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 32786*/ GIMT_Encode4(2490139),
    /*GILLT_nxv4s32*//*Label 32787*/ GIMT_Encode4(2490260),
    /*GILLT_nxv4s64*//*Label 32788*/ GIMT_Encode4(2490381), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 32789*/ GIMT_Encode4(2490502),
    /*GILLT_nxv8s32*//*Label 32790*/ GIMT_Encode4(2490623),
    /*GILLT_nxv8s64*//*Label 32791*/ GIMT_Encode4(2490744), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 32792*/ GIMT_Encode4(2490865),
    /*GILLT_nxv16s32*//*Label 32793*/ GIMT_Encode4(2490986), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 32794*/ GIMT_Encode4(2491107),
    // Label 32777: @2488932
    GIM_Try, /*On fail goto*//*Label 32796*/ GIMT_Encode4(2489080),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 32797*/ GIMT_Encode4(2488977), // Rule ID 1838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1838,
        GIR_EraseRootFromParent_Done,
      // Label 32797: @2488977
      GIM_Try, /*On fail goto*//*Label 32798*/ GIMT_Encode4(2489011), // Rule ID 1839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1839,
        GIR_EraseRootFromParent_Done,
      // Label 32798: @2489011
      GIM_Try, /*On fail goto*//*Label 32799*/ GIMT_Encode4(2489045), // Rule ID 1842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1842,
        GIR_EraseRootFromParent_Done,
      // Label 32799: @2489045
      GIM_Try, /*On fail goto*//*Label 32800*/ GIMT_Encode4(2489079), // Rule ID 1843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1843,
        GIR_EraseRootFromParent_Done,
      // Label 32800: @2489079
      GIM_Reject,
    // Label 32796: @2489080
    GIM_Reject,
    // Label 32778: @2489081
    GIM_Try, /*On fail goto*//*Label 32801*/ GIMT_Encode4(2489229),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 32802*/ GIMT_Encode4(2489126), // Rule ID 1129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1129,
        GIR_EraseRootFromParent_Done,
      // Label 32802: @2489126
      GIM_Try, /*On fail goto*//*Label 32803*/ GIMT_Encode4(2489160), // Rule ID 1130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1130,
        GIR_EraseRootFromParent_Done,
      // Label 32803: @2489160
      GIM_Try, /*On fail goto*//*Label 32804*/ GIMT_Encode4(2489194), // Rule ID 1133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1133,
        GIR_EraseRootFromParent_Done,
      // Label 32804: @2489194
      GIM_Try, /*On fail goto*//*Label 32805*/ GIMT_Encode4(2489228), // Rule ID 1134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1134,
        GIR_EraseRootFromParent_Done,
      // Label 32805: @2489228
      GIM_Reject,
    // Label 32801: @2489229
    GIM_Reject,
    // Label 32779: @2489230
    GIM_Try, /*On fail goto*//*Label 32806*/ GIMT_Encode4(2489412),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 32807*/ GIMT_Encode4(2489275), // Rule ID 1470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1470,
        GIR_EraseRootFromParent_Done,
      // Label 32807: @2489275
      GIM_Try, /*On fail goto*//*Label 32808*/ GIMT_Encode4(2489309), // Rule ID 1471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1471,
        GIR_EraseRootFromParent_Done,
      // Label 32808: @2489309
      GIM_Try, /*On fail goto*//*Label 32809*/ GIMT_Encode4(2489343), // Rule ID 1474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1474,
        GIR_EraseRootFromParent_Done,
      // Label 32809: @2489343
      GIM_Try, /*On fail goto*//*Label 32810*/ GIMT_Encode4(2489377), // Rule ID 1475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1475,
        GIR_EraseRootFromParent_Done,
      // Label 32810: @2489377
      GIM_Try, /*On fail goto*//*Label 32811*/ GIMT_Encode4(2489411), // Rule ID 1478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1478,
        GIR_EraseRootFromParent_Done,
      // Label 32811: @2489411
      GIM_Reject,
    // Label 32806: @2489412
    GIM_Reject,
    // Label 32780: @2489413
    GIM_Try, /*On fail goto*//*Label 32812*/ GIMT_Encode4(2489533),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32813*/ GIMT_Encode4(2489484), // Rule ID 53956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53956,
        GIR_EraseRootFromParent_Done,
      // Label 32813: @2489484
      GIM_Try, /*On fail goto*//*Label 32814*/ GIMT_Encode4(2489532), // Rule ID 53957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53957,
        GIR_EraseRootFromParent_Done,
      // Label 32814: @2489532
      GIM_Reject,
    // Label 32812: @2489533
    GIM_Reject,
    // Label 32781: @2489534
    GIM_Try, /*On fail goto*//*Label 32815*/ GIMT_Encode4(2489654),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32816*/ GIMT_Encode4(2489605), // Rule ID 53980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53980,
        GIR_EraseRootFromParent_Done,
      // Label 32816: @2489605
      GIM_Try, /*On fail goto*//*Label 32817*/ GIMT_Encode4(2489653), // Rule ID 53981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53981,
        GIR_EraseRootFromParent_Done,
      // Label 32817: @2489653
      GIM_Reject,
    // Label 32815: @2489654
    GIM_Reject,
    // Label 32782: @2489655
    GIM_Try, /*On fail goto*//*Label 32818*/ GIMT_Encode4(2489775),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32819*/ GIMT_Encode4(2489726), // Rule ID 54016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54016,
        GIR_EraseRootFromParent_Done,
      // Label 32819: @2489726
      GIM_Try, /*On fail goto*//*Label 32820*/ GIMT_Encode4(2489774), // Rule ID 54017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54017,
        GIR_EraseRootFromParent_Done,
      // Label 32820: @2489774
      GIM_Reject,
    // Label 32818: @2489775
    GIM_Reject,
    // Label 32783: @2489776
    GIM_Try, /*On fail goto*//*Label 32821*/ GIMT_Encode4(2489896),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32822*/ GIMT_Encode4(2489847), // Rule ID 53968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53968,
        GIR_EraseRootFromParent_Done,
      // Label 32822: @2489847
      GIM_Try, /*On fail goto*//*Label 32823*/ GIMT_Encode4(2489895), // Rule ID 53969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53969,
        GIR_EraseRootFromParent_Done,
      // Label 32823: @2489895
      GIM_Reject,
    // Label 32821: @2489896
    GIM_Reject,
    // Label 32784: @2489897
    GIM_Try, /*On fail goto*//*Label 32824*/ GIMT_Encode4(2490017),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32825*/ GIMT_Encode4(2489968), // Rule ID 54004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54004,
        GIR_EraseRootFromParent_Done,
      // Label 32825: @2489968
      GIM_Try, /*On fail goto*//*Label 32826*/ GIMT_Encode4(2490016), // Rule ID 54005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54005,
        GIR_EraseRootFromParent_Done,
      // Label 32826: @2490016
      GIM_Reject,
    // Label 32824: @2490017
    GIM_Reject,
    // Label 32785: @2490018
    GIM_Try, /*On fail goto*//*Label 32827*/ GIMT_Encode4(2490138),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32828*/ GIMT_Encode4(2490089), // Rule ID 54100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54100,
        GIR_EraseRootFromParent_Done,
      // Label 32828: @2490089
      GIM_Try, /*On fail goto*//*Label 32829*/ GIMT_Encode4(2490137), // Rule ID 54101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54101,
        GIR_EraseRootFromParent_Done,
      // Label 32829: @2490137
      GIM_Reject,
    // Label 32827: @2490138
    GIM_Reject,
    // Label 32786: @2490139
    GIM_Try, /*On fail goto*//*Label 32830*/ GIMT_Encode4(2490259),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32831*/ GIMT_Encode4(2490210), // Rule ID 53992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53992,
        GIR_EraseRootFromParent_Done,
      // Label 32831: @2490210
      GIM_Try, /*On fail goto*//*Label 32832*/ GIMT_Encode4(2490258), // Rule ID 53993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53993,
        GIR_EraseRootFromParent_Done,
      // Label 32832: @2490258
      GIM_Reject,
    // Label 32830: @2490259
    GIM_Reject,
    // Label 32787: @2490260
    GIM_Try, /*On fail goto*//*Label 32833*/ GIMT_Encode4(2490380),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32834*/ GIMT_Encode4(2490331), // Rule ID 54064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54064,
        GIR_EraseRootFromParent_Done,
      // Label 32834: @2490331
      GIM_Try, /*On fail goto*//*Label 32835*/ GIMT_Encode4(2490379), // Rule ID 54065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54065,
        GIR_EraseRootFromParent_Done,
      // Label 32835: @2490379
      GIM_Reject,
    // Label 32833: @2490380
    GIM_Reject,
    // Label 32788: @2490381
    GIM_Try, /*On fail goto*//*Label 32836*/ GIMT_Encode4(2490501),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32837*/ GIMT_Encode4(2490452), // Rule ID 54112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54112,
        GIR_EraseRootFromParent_Done,
      // Label 32837: @2490452
      GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2490500), // Rule ID 54113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54113,
        GIR_EraseRootFromParent_Done,
      // Label 32838: @2490500
      GIM_Reject,
    // Label 32836: @2490501
    GIM_Reject,
    // Label 32789: @2490502
    GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2490622),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2490573), // Rule ID 54028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54028,
        GIR_EraseRootFromParent_Done,
      // Label 32840: @2490573
      GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2490621), // Rule ID 54029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54029,
        GIR_EraseRootFromParent_Done,
      // Label 32841: @2490621
      GIM_Reject,
    // Label 32839: @2490622
    GIM_Reject,
    // Label 32790: @2490623
    GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2490743),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2490694), // Rule ID 54076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54076,
        GIR_EraseRootFromParent_Done,
      // Label 32843: @2490694
      GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2490742), // Rule ID 54077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54077,
        GIR_EraseRootFromParent_Done,
      // Label 32844: @2490742
      GIM_Reject,
    // Label 32842: @2490743
    GIM_Reject,
    // Label 32791: @2490744
    GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2490864),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2490815), // Rule ID 54124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54124,
        GIR_EraseRootFromParent_Done,
      // Label 32846: @2490815
      GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2490863), // Rule ID 54125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54125,
        GIR_EraseRootFromParent_Done,
      // Label 32847: @2490863
      GIM_Reject,
    // Label 32845: @2490864
    GIM_Reject,
    // Label 32792: @2490865
    GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2490985),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2490936), // Rule ID 54040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54040,
        GIR_EraseRootFromParent_Done,
      // Label 32849: @2490936
      GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2490984), // Rule ID 54041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54041,
        GIR_EraseRootFromParent_Done,
      // Label 32850: @2490984
      GIM_Reject,
    // Label 32848: @2490985
    GIM_Reject,
    // Label 32793: @2490986
    GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2491106),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2491057), // Rule ID 54088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54088,
        GIR_EraseRootFromParent_Done,
      // Label 32852: @2491057
      GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2491105), // Rule ID 54089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54089,
        GIR_EraseRootFromParent_Done,
      // Label 32853: @2491105
      GIM_Reject,
    // Label 32851: @2491106
    GIM_Reject,
    // Label 32794: @2491107
    GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2491227),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2491178), // Rule ID 54052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54052,
        GIR_EraseRootFromParent_Done,
      // Label 32855: @2491178
      GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2491226), // Rule ID 54053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54053,
        GIR_EraseRootFromParent_Done,
      // Label 32856: @2491226
      GIM_Reject,
    // Label 32854: @2491227
    GIM_Reject,
    // Label 32795: @2491228
    GIM_Reject,
    // Label 98: @2491229
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32875*/ GIMT_Encode4(2507873),
    /*GILLT_s16*//*Label 32857*/ GIMT_Encode4(2491360),
    /*GILLT_s32*//*Label 32858*/ GIMT_Encode4(2492796),
    /*GILLT_s64*//*Label 32859*/ GIMT_Encode4(2494232), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 32860*/ GIMT_Encode4(2496023),
    /*GILLT_nxv1s32*//*Label 32861*/ GIMT_Encode4(2496813),
    /*GILLT_nxv1s64*//*Label 32862*/ GIMT_Encode4(2497603), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 32863*/ GIMT_Encode4(2498393),
    /*GILLT_nxv2s32*//*Label 32864*/ GIMT_Encode4(2499183),
    /*GILLT_nxv2s64*//*Label 32865*/ GIMT_Encode4(2499973), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 32866*/ GIMT_Encode4(2500763),
    /*GILLT_nxv4s32*//*Label 32867*/ GIMT_Encode4(2501553),
    /*GILLT_nxv4s64*//*Label 32868*/ GIMT_Encode4(2502343), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 32869*/ GIMT_Encode4(2503133),
    /*GILLT_nxv8s32*//*Label 32870*/ GIMT_Encode4(2503923),
    /*GILLT_nxv8s64*//*Label 32871*/ GIMT_Encode4(2504713), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 32872*/ GIMT_Encode4(2505503),
    /*GILLT_nxv16s32*//*Label 32873*/ GIMT_Encode4(2506293), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 32874*/ GIMT_Encode4(2507083),
    // Label 32857: @2491360
    GIM_Try, /*On fail goto*//*Label 32876*/ GIMT_Encode4(2492795),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 32877*/ GIMT_Encode4(2491446), // Rule ID 1871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1871,
        GIR_EraseRootFromParent_Done,
      // Label 32877: @2491446
      GIM_Try, /*On fail goto*//*Label 32878*/ GIMT_Encode4(2491518), // Rule ID 1872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1872,
        GIR_EraseRootFromParent_Done,
      // Label 32878: @2491518
      GIM_Try, /*On fail goto*//*Label 32879*/ GIMT_Encode4(2491590), // Rule ID 1904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1904,
        GIR_EraseRootFromParent_Done,
      // Label 32879: @2491590
      GIM_Try, /*On fail goto*//*Label 32880*/ GIMT_Encode4(2491662), // Rule ID 1905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1905,
        GIR_EraseRootFromParent_Done,
      // Label 32880: @2491662
      GIM_Try, /*On fail goto*//*Label 32881*/ GIMT_Encode4(2491734), // Rule ID 64139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64139,
        GIR_EraseRootFromParent_Done,
      // Label 32881: @2491734
      GIM_Try, /*On fail goto*//*Label 32882*/ GIMT_Encode4(2491806), // Rule ID 64140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64140,
        GIR_EraseRootFromParent_Done,
      // Label 32882: @2491806
      GIM_Try, /*On fail goto*//*Label 32883*/ GIMT_Encode4(2491878), // Rule ID 64147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64147,
        GIR_EraseRootFromParent_Done,
      // Label 32883: @2491878
      GIM_Try, /*On fail goto*//*Label 32884*/ GIMT_Encode4(2491950), // Rule ID 64148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64148,
        GIR_EraseRootFromParent_Done,
      // Label 32884: @2491950
      GIM_Try, /*On fail goto*//*Label 32885*/ GIMT_Encode4(2492007), // Rule ID 1867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1867,
        GIR_EraseRootFromParent_Done,
      // Label 32885: @2492007
      GIM_Try, /*On fail goto*//*Label 32886*/ GIMT_Encode4(2492064), // Rule ID 1868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1868,
        GIR_EraseRootFromParent_Done,
      // Label 32886: @2492064
      GIM_Try, /*On fail goto*//*Label 32887*/ GIMT_Encode4(2492121), // Rule ID 1900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1900,
        GIR_EraseRootFromParent_Done,
      // Label 32887: @2492121
      GIM_Try, /*On fail goto*//*Label 32888*/ GIMT_Encode4(2492178), // Rule ID 1901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1901,
        GIR_EraseRootFromParent_Done,
      // Label 32888: @2492178
      GIM_Try, /*On fail goto*//*Label 32889*/ GIMT_Encode4(2492235), // Rule ID 64135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64135,
        GIR_EraseRootFromParent_Done,
      // Label 32889: @2492235
      GIM_Try, /*On fail goto*//*Label 32890*/ GIMT_Encode4(2492292), // Rule ID 64136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64136,
        GIR_EraseRootFromParent_Done,
      // Label 32890: @2492292
      GIM_Try, /*On fail goto*//*Label 32891*/ GIMT_Encode4(2492349), // Rule ID 64143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64143,
        GIR_EraseRootFromParent_Done,
      // Label 32891: @2492349
      GIM_Try, /*On fail goto*//*Label 32892*/ GIMT_Encode4(2492406), // Rule ID 64144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64144,
        GIR_EraseRootFromParent_Done,
      // Label 32892: @2492406
      GIM_Try, /*On fail goto*//*Label 32893*/ GIMT_Encode4(2492463), // Rule ID 1863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1863,
        GIR_EraseRootFromParent_Done,
      // Label 32893: @2492463
      GIM_Try, /*On fail goto*//*Label 32894*/ GIMT_Encode4(2492520), // Rule ID 1864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1864,
        GIR_EraseRootFromParent_Done,
      // Label 32894: @2492520
      GIM_Try, /*On fail goto*//*Label 32895*/ GIMT_Encode4(2492577), // Rule ID 1896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1896,
        GIR_EraseRootFromParent_Done,
      // Label 32895: @2492577
      GIM_Try, /*On fail goto*//*Label 32896*/ GIMT_Encode4(2492634), // Rule ID 1897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1897,
        GIR_EraseRootFromParent_Done,
      // Label 32896: @2492634
      GIM_Try, /*On fail goto*//*Label 32897*/ GIMT_Encode4(2492674), // Rule ID 1859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1859,
        GIR_EraseRootFromParent_Done,
      // Label 32897: @2492674
      GIM_Try, /*On fail goto*//*Label 32898*/ GIMT_Encode4(2492714), // Rule ID 1860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1860,
        GIR_EraseRootFromParent_Done,
      // Label 32898: @2492714
      GIM_Try, /*On fail goto*//*Label 32899*/ GIMT_Encode4(2492754), // Rule ID 1892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1892,
        GIR_EraseRootFromParent_Done,
      // Label 32899: @2492754
      GIM_Try, /*On fail goto*//*Label 32900*/ GIMT_Encode4(2492794), // Rule ID 1893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1893,
        GIR_EraseRootFromParent_Done,
      // Label 32900: @2492794
      GIM_Reject,
    // Label 32876: @2492795
    GIM_Reject,
    // Label 32858: @2492796
    GIM_Try, /*On fail goto*//*Label 32901*/ GIMT_Encode4(2494231),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 32902*/ GIMT_Encode4(2492882), // Rule ID 1170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1170,
        GIR_EraseRootFromParent_Done,
      // Label 32902: @2492882
      GIM_Try, /*On fail goto*//*Label 32903*/ GIMT_Encode4(2492954), // Rule ID 1171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1171,
        GIR_EraseRootFromParent_Done,
      // Label 32903: @2492954
      GIM_Try, /*On fail goto*//*Label 32904*/ GIMT_Encode4(2493026), // Rule ID 1191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1191,
        GIR_EraseRootFromParent_Done,
      // Label 32904: @2493026
      GIM_Try, /*On fail goto*//*Label 32905*/ GIMT_Encode4(2493098), // Rule ID 1192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1192,
        GIR_EraseRootFromParent_Done,
      // Label 32905: @2493098
      GIM_Try, /*On fail goto*//*Label 32906*/ GIMT_Encode4(2493170), // Rule ID 64103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64103,
        GIR_EraseRootFromParent_Done,
      // Label 32906: @2493170
      GIM_Try, /*On fail goto*//*Label 32907*/ GIMT_Encode4(2493242), // Rule ID 64104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64104,
        GIR_EraseRootFromParent_Done,
      // Label 32907: @2493242
      GIM_Try, /*On fail goto*//*Label 32908*/ GIMT_Encode4(2493314), // Rule ID 64111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64111,
        GIR_EraseRootFromParent_Done,
      // Label 32908: @2493314
      GIM_Try, /*On fail goto*//*Label 32909*/ GIMT_Encode4(2493386), // Rule ID 64112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64112,
        GIR_EraseRootFromParent_Done,
      // Label 32909: @2493386
      GIM_Try, /*On fail goto*//*Label 32910*/ GIMT_Encode4(2493443), // Rule ID 1166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1166,
        GIR_EraseRootFromParent_Done,
      // Label 32910: @2493443
      GIM_Try, /*On fail goto*//*Label 32911*/ GIMT_Encode4(2493500), // Rule ID 1167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1167,
        GIR_EraseRootFromParent_Done,
      // Label 32911: @2493500
      GIM_Try, /*On fail goto*//*Label 32912*/ GIMT_Encode4(2493557), // Rule ID 1187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1187,
        GIR_EraseRootFromParent_Done,
      // Label 32912: @2493557
      GIM_Try, /*On fail goto*//*Label 32913*/ GIMT_Encode4(2493614), // Rule ID 1188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1188,
        GIR_EraseRootFromParent_Done,
      // Label 32913: @2493614
      GIM_Try, /*On fail goto*//*Label 32914*/ GIMT_Encode4(2493671), // Rule ID 64099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64099,
        GIR_EraseRootFromParent_Done,
      // Label 32914: @2493671
      GIM_Try, /*On fail goto*//*Label 32915*/ GIMT_Encode4(2493728), // Rule ID 64100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64100,
        GIR_EraseRootFromParent_Done,
      // Label 32915: @2493728
      GIM_Try, /*On fail goto*//*Label 32916*/ GIMT_Encode4(2493785), // Rule ID 64107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64107,
        GIR_EraseRootFromParent_Done,
      // Label 32916: @2493785
      GIM_Try, /*On fail goto*//*Label 32917*/ GIMT_Encode4(2493842), // Rule ID 64108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64108,
        GIR_EraseRootFromParent_Done,
      // Label 32917: @2493842
      GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2493899), // Rule ID 1162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1162,
        GIR_EraseRootFromParent_Done,
      // Label 32918: @2493899
      GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2493956), // Rule ID 1163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1163,
        GIR_EraseRootFromParent_Done,
      // Label 32919: @2493956
      GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2494013), // Rule ID 1183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1183,
        GIR_EraseRootFromParent_Done,
      // Label 32920: @2494013
      GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2494070), // Rule ID 1184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1184,
        GIR_EraseRootFromParent_Done,
      // Label 32921: @2494070
      GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2494110), // Rule ID 1158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1158,
        GIR_EraseRootFromParent_Done,
      // Label 32922: @2494110
      GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2494150), // Rule ID 1159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1159,
        GIR_EraseRootFromParent_Done,
      // Label 32923: @2494150
      GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2494190), // Rule ID 1179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1179,
        GIR_EraseRootFromParent_Done,
      // Label 32924: @2494190
      GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2494230), // Rule ID 1180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1180,
        GIR_EraseRootFromParent_Done,
      // Label 32925: @2494230
      GIM_Reject,
    // Label 32901: @2494231
    GIM_Reject,
    // Label 32859: @2494232
    GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2496022),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2494318), // Rule ID 1507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1507,
        GIR_EraseRootFromParent_Done,
      // Label 32927: @2494318
      GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2494390), // Rule ID 1508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1508,
        GIR_EraseRootFromParent_Done,
      // Label 32928: @2494390
      GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2494462), // Rule ID 1531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1531,
        GIR_EraseRootFromParent_Done,
      // Label 32929: @2494462
      GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2494534), // Rule ID 1562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1562,
        GIR_EraseRootFromParent_Done,
      // Label 32930: @2494534
      GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2494606), // Rule ID 1563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1563,
        GIR_EraseRootFromParent_Done,
      // Label 32931: @2494606
      GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2494678), // Rule ID 64119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64119,
        GIR_EraseRootFromParent_Done,
      // Label 32932: @2494678
      GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2494750), // Rule ID 64120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64120,
        GIR_EraseRootFromParent_Done,
      // Label 32933: @2494750
      GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2494822), // Rule ID 64125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64125,
        GIR_EraseRootFromParent_Done,
      // Label 32934: @2494822
      GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2494894), // Rule ID 64131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64131,
        GIR_EraseRootFromParent_Done,
      // Label 32935: @2494894
      GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2494966), // Rule ID 64132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64132,
        GIR_EraseRootFromParent_Done,
      // Label 32936: @2494966
      GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2495023), // Rule ID 1503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1503,
        GIR_EraseRootFromParent_Done,
      // Label 32937: @2495023
      GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2495080), // Rule ID 1504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1504,
        GIR_EraseRootFromParent_Done,
      // Label 32938: @2495080
      GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2495137), // Rule ID 1529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1529,
        GIR_EraseRootFromParent_Done,
      // Label 32939: @2495137
      GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2495194), // Rule ID 1558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1558,
        GIR_EraseRootFromParent_Done,
      // Label 32940: @2495194
      GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2495251), // Rule ID 1559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1559,
        GIR_EraseRootFromParent_Done,
      // Label 32941: @2495251
      GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2495308), // Rule ID 64115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64115,
        GIR_EraseRootFromParent_Done,
      // Label 32942: @2495308
      GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2495365), // Rule ID 64116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64116,
        GIR_EraseRootFromParent_Done,
      // Label 32943: @2495365
      GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2495422), // Rule ID 64123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64123,
        GIR_EraseRootFromParent_Done,
      // Label 32944: @2495422
      GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2495479), // Rule ID 64127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64127,
        GIR_EraseRootFromParent_Done,
      // Label 32945: @2495479
      GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2495536), // Rule ID 64128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64128,
        GIR_EraseRootFromParent_Done,
      // Label 32946: @2495536
      GIM_Try, /*On fail goto*//*Label 32947*/ GIMT_Encode4(2495593), // Rule ID 1499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1499,
        GIR_EraseRootFromParent_Done,
      // Label 32947: @2495593
      GIM_Try, /*On fail goto*//*Label 32948*/ GIMT_Encode4(2495650), // Rule ID 1500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1500,
        GIR_EraseRootFromParent_Done,
      // Label 32948: @2495650
      GIM_Try, /*On fail goto*//*Label 32949*/ GIMT_Encode4(2495707), // Rule ID 1527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1527,
        GIR_EraseRootFromParent_Done,
      // Label 32949: @2495707
      GIM_Try, /*On fail goto*//*Label 32950*/ GIMT_Encode4(2495764), // Rule ID 1554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1554,
        GIR_EraseRootFromParent_Done,
      // Label 32950: @2495764
      GIM_Try, /*On fail goto*//*Label 32951*/ GIMT_Encode4(2495821), // Rule ID 1555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1555,
        GIR_EraseRootFromParent_Done,
      // Label 32951: @2495821
      GIM_Try, /*On fail goto*//*Label 32952*/ GIMT_Encode4(2495861), // Rule ID 1495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1495,
        GIR_EraseRootFromParent_Done,
      // Label 32952: @2495861
      GIM_Try, /*On fail goto*//*Label 32953*/ GIMT_Encode4(2495901), // Rule ID 1496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1496,
        GIR_EraseRootFromParent_Done,
      // Label 32953: @2495901
      GIM_Try, /*On fail goto*//*Label 32954*/ GIMT_Encode4(2495941), // Rule ID 1525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1525,
        GIR_EraseRootFromParent_Done,
      // Label 32954: @2495941
      GIM_Try, /*On fail goto*//*Label 32955*/ GIMT_Encode4(2495981), // Rule ID 1550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1550,
        GIR_EraseRootFromParent_Done,
      // Label 32955: @2495981
      GIM_Try, /*On fail goto*//*Label 32956*/ GIMT_Encode4(2496021), // Rule ID 1551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_RootToRootCopy, /*OpIdx*/3, // rs3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1551,
        GIR_EraseRootFromParent_Done,
      // Label 32956: @2496021
      GIM_Reject,
    // Label 32926: @2496022
    GIM_Reject,
    // Label 32860: @2496023
    GIM_Try, /*On fail goto*//*Label 32957*/ GIMT_Encode4(2496812),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32958*/ GIMT_Encode4(2496118), // Rule ID 54390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54390,
        GIR_EraseRootFromParent_Done,
      // Label 32958: @2496118
      GIM_Try, /*On fail goto*//*Label 32959*/ GIMT_Encode4(2496195), // Rule ID 54391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54391,
        GIR_EraseRootFromParent_Done,
      // Label 32959: @2496195
      GIM_Try, /*On fail goto*//*Label 32960*/ GIMT_Encode4(2496272), // Rule ID 70943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70943,
        GIR_EraseRootFromParent_Done,
      // Label 32960: @2496272
      GIM_Try, /*On fail goto*//*Label 32961*/ GIMT_Encode4(2496349), // Rule ID 70944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70944,
        GIR_EraseRootFromParent_Done,
      // Label 32961: @2496349
      GIM_Try, /*On fail goto*//*Label 32962*/ GIMT_Encode4(2496411), // Rule ID 54394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54394,
        GIR_EraseRootFromParent_Done,
      // Label 32962: @2496411
      GIM_Try, /*On fail goto*//*Label 32963*/ GIMT_Encode4(2496473), // Rule ID 54395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54395,
        GIR_EraseRootFromParent_Done,
      // Label 32963: @2496473
      GIM_Try, /*On fail goto*//*Label 32964*/ GIMT_Encode4(2496535), // Rule ID 70947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70947,
        GIR_EraseRootFromParent_Done,
      // Label 32964: @2496535
      GIM_Try, /*On fail goto*//*Label 32965*/ GIMT_Encode4(2496597), // Rule ID 70948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70948,
        GIR_EraseRootFromParent_Done,
      // Label 32965: @2496597
      GIM_Try, /*On fail goto*//*Label 32966*/ GIMT_Encode4(2496659), // Rule ID 54386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54386,
        GIR_EraseRootFromParent_Done,
      // Label 32966: @2496659
      GIM_Try, /*On fail goto*//*Label 32967*/ GIMT_Encode4(2496721), // Rule ID 54387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54387,
        GIR_EraseRootFromParent_Done,
      // Label 32967: @2496721
      GIM_Try, /*On fail goto*//*Label 32968*/ GIMT_Encode4(2496766), // Rule ID 54382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54382,
        GIR_EraseRootFromParent_Done,
      // Label 32968: @2496766
      GIM_Try, /*On fail goto*//*Label 32969*/ GIMT_Encode4(2496811), // Rule ID 54383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54383,
        GIR_EraseRootFromParent_Done,
      // Label 32969: @2496811
      GIM_Reject,
    // Label 32957: @2496812
    GIM_Reject,
    // Label 32861: @2496813
    GIM_Try, /*On fail goto*//*Label 32970*/ GIMT_Encode4(2497602),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32971*/ GIMT_Encode4(2496908), // Rule ID 54518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54518,
        GIR_EraseRootFromParent_Done,
      // Label 32971: @2496908
      GIM_Try, /*On fail goto*//*Label 32972*/ GIMT_Encode4(2496985), // Rule ID 54519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54519,
        GIR_EraseRootFromParent_Done,
      // Label 32972: @2496985
      GIM_Try, /*On fail goto*//*Label 32973*/ GIMT_Encode4(2497062), // Rule ID 71055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71055,
        GIR_EraseRootFromParent_Done,
      // Label 32973: @2497062
      GIM_Try, /*On fail goto*//*Label 32974*/ GIMT_Encode4(2497139), // Rule ID 71056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71056,
        GIR_EraseRootFromParent_Done,
      // Label 32974: @2497139
      GIM_Try, /*On fail goto*//*Label 32975*/ GIMT_Encode4(2497201), // Rule ID 54522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54522,
        GIR_EraseRootFromParent_Done,
      // Label 32975: @2497201
      GIM_Try, /*On fail goto*//*Label 32976*/ GIMT_Encode4(2497263), // Rule ID 54523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54523,
        GIR_EraseRootFromParent_Done,
      // Label 32976: @2497263
      GIM_Try, /*On fail goto*//*Label 32977*/ GIMT_Encode4(2497325), // Rule ID 71059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71059,
        GIR_EraseRootFromParent_Done,
      // Label 32977: @2497325
      GIM_Try, /*On fail goto*//*Label 32978*/ GIMT_Encode4(2497387), // Rule ID 71060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71060,
        GIR_EraseRootFromParent_Done,
      // Label 32978: @2497387
      GIM_Try, /*On fail goto*//*Label 32979*/ GIMT_Encode4(2497449), // Rule ID 54514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54514,
        GIR_EraseRootFromParent_Done,
      // Label 32979: @2497449
      GIM_Try, /*On fail goto*//*Label 32980*/ GIMT_Encode4(2497511), // Rule ID 54515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54515,
        GIR_EraseRootFromParent_Done,
      // Label 32980: @2497511
      GIM_Try, /*On fail goto*//*Label 32981*/ GIMT_Encode4(2497556), // Rule ID 54510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54510,
        GIR_EraseRootFromParent_Done,
      // Label 32981: @2497556
      GIM_Try, /*On fail goto*//*Label 32982*/ GIMT_Encode4(2497601), // Rule ID 54511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54511,
        GIR_EraseRootFromParent_Done,
      // Label 32982: @2497601
      GIM_Reject,
    // Label 32970: @2497602
    GIM_Reject,
    // Label 32862: @2497603
    GIM_Try, /*On fail goto*//*Label 32983*/ GIMT_Encode4(2498392),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32984*/ GIMT_Encode4(2497698), // Rule ID 54710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54710,
        GIR_EraseRootFromParent_Done,
      // Label 32984: @2497698
      GIM_Try, /*On fail goto*//*Label 32985*/ GIMT_Encode4(2497775), // Rule ID 54711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54711,
        GIR_EraseRootFromParent_Done,
      // Label 32985: @2497775
      GIM_Try, /*On fail goto*//*Label 32986*/ GIMT_Encode4(2497852), // Rule ID 71223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71223,
        GIR_EraseRootFromParent_Done,
      // Label 32986: @2497852
      GIM_Try, /*On fail goto*//*Label 32987*/ GIMT_Encode4(2497929), // Rule ID 71224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71224,
        GIR_EraseRootFromParent_Done,
      // Label 32987: @2497929
      GIM_Try, /*On fail goto*//*Label 32988*/ GIMT_Encode4(2497991), // Rule ID 54714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54714,
        GIR_EraseRootFromParent_Done,
      // Label 32988: @2497991
      GIM_Try, /*On fail goto*//*Label 32989*/ GIMT_Encode4(2498053), // Rule ID 54715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54715,
        GIR_EraseRootFromParent_Done,
      // Label 32989: @2498053
      GIM_Try, /*On fail goto*//*Label 32990*/ GIMT_Encode4(2498115), // Rule ID 71227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71227,
        GIR_EraseRootFromParent_Done,
      // Label 32990: @2498115
      GIM_Try, /*On fail goto*//*Label 32991*/ GIMT_Encode4(2498177), // Rule ID 71228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71228,
        GIR_EraseRootFromParent_Done,
      // Label 32991: @2498177
      GIM_Try, /*On fail goto*//*Label 32992*/ GIMT_Encode4(2498239), // Rule ID 54706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54706,
        GIR_EraseRootFromParent_Done,
      // Label 32992: @2498239
      GIM_Try, /*On fail goto*//*Label 32993*/ GIMT_Encode4(2498301), // Rule ID 54707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54707,
        GIR_EraseRootFromParent_Done,
      // Label 32993: @2498301
      GIM_Try, /*On fail goto*//*Label 32994*/ GIMT_Encode4(2498346), // Rule ID 54702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54702,
        GIR_EraseRootFromParent_Done,
      // Label 32994: @2498346
      GIM_Try, /*On fail goto*//*Label 32995*/ GIMT_Encode4(2498391), // Rule ID 54703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54703,
        GIR_EraseRootFromParent_Done,
      // Label 32995: @2498391
      GIM_Reject,
    // Label 32983: @2498392
    GIM_Reject,
    // Label 32863: @2498393
    GIM_Try, /*On fail goto*//*Label 32996*/ GIMT_Encode4(2499182),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 32997*/ GIMT_Encode4(2498488), // Rule ID 54454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54454,
        GIR_EraseRootFromParent_Done,
      // Label 32997: @2498488
      GIM_Try, /*On fail goto*//*Label 32998*/ GIMT_Encode4(2498565), // Rule ID 54455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54455,
        GIR_EraseRootFromParent_Done,
      // Label 32998: @2498565
      GIM_Try, /*On fail goto*//*Label 32999*/ GIMT_Encode4(2498642), // Rule ID 70999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70999,
        GIR_EraseRootFromParent_Done,
      // Label 32999: @2498642
      GIM_Try, /*On fail goto*//*Label 33000*/ GIMT_Encode4(2498719), // Rule ID 71000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71000,
        GIR_EraseRootFromParent_Done,
      // Label 33000: @2498719
      GIM_Try, /*On fail goto*//*Label 33001*/ GIMT_Encode4(2498781), // Rule ID 54458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54458,
        GIR_EraseRootFromParent_Done,
      // Label 33001: @2498781
      GIM_Try, /*On fail goto*//*Label 33002*/ GIMT_Encode4(2498843), // Rule ID 54459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54459,
        GIR_EraseRootFromParent_Done,
      // Label 33002: @2498843
      GIM_Try, /*On fail goto*//*Label 33003*/ GIMT_Encode4(2498905), // Rule ID 71003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71003,
        GIR_EraseRootFromParent_Done,
      // Label 33003: @2498905
      GIM_Try, /*On fail goto*//*Label 33004*/ GIMT_Encode4(2498967), // Rule ID 71004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71004,
        GIR_EraseRootFromParent_Done,
      // Label 33004: @2498967
      GIM_Try, /*On fail goto*//*Label 33005*/ GIMT_Encode4(2499029), // Rule ID 54450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54450,
        GIR_EraseRootFromParent_Done,
      // Label 33005: @2499029
      GIM_Try, /*On fail goto*//*Label 33006*/ GIMT_Encode4(2499091), // Rule ID 54451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54451,
        GIR_EraseRootFromParent_Done,
      // Label 33006: @2499091
      GIM_Try, /*On fail goto*//*Label 33007*/ GIMT_Encode4(2499136), // Rule ID 54446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54446,
        GIR_EraseRootFromParent_Done,
      // Label 33007: @2499136
      GIM_Try, /*On fail goto*//*Label 33008*/ GIMT_Encode4(2499181), // Rule ID 54447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54447,
        GIR_EraseRootFromParent_Done,
      // Label 33008: @2499181
      GIM_Reject,
    // Label 32996: @2499182
    GIM_Reject,
    // Label 32864: @2499183
    GIM_Try, /*On fail goto*//*Label 33009*/ GIMT_Encode4(2499972),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33010*/ GIMT_Encode4(2499278), // Rule ID 54646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54646,
        GIR_EraseRootFromParent_Done,
      // Label 33010: @2499278
      GIM_Try, /*On fail goto*//*Label 33011*/ GIMT_Encode4(2499355), // Rule ID 54647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54647,
        GIR_EraseRootFromParent_Done,
      // Label 33011: @2499355
      GIM_Try, /*On fail goto*//*Label 33012*/ GIMT_Encode4(2499432), // Rule ID 71167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71167,
        GIR_EraseRootFromParent_Done,
      // Label 33012: @2499432
      GIM_Try, /*On fail goto*//*Label 33013*/ GIMT_Encode4(2499509), // Rule ID 71168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71168,
        GIR_EraseRootFromParent_Done,
      // Label 33013: @2499509
      GIM_Try, /*On fail goto*//*Label 33014*/ GIMT_Encode4(2499571), // Rule ID 54650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54650,
        GIR_EraseRootFromParent_Done,
      // Label 33014: @2499571
      GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2499633), // Rule ID 54651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54651,
        GIR_EraseRootFromParent_Done,
      // Label 33015: @2499633
      GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2499695), // Rule ID 71171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71171,
        GIR_EraseRootFromParent_Done,
      // Label 33016: @2499695
      GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2499757), // Rule ID 71172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71172,
        GIR_EraseRootFromParent_Done,
      // Label 33017: @2499757
      GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2499819), // Rule ID 54642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54642,
        GIR_EraseRootFromParent_Done,
      // Label 33018: @2499819
      GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2499881), // Rule ID 54643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54643,
        GIR_EraseRootFromParent_Done,
      // Label 33019: @2499881
      GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2499926), // Rule ID 54638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54638,
        GIR_EraseRootFromParent_Done,
      // Label 33020: @2499926
      GIM_Try, /*On fail goto*//*Label 33021*/ GIMT_Encode4(2499971), // Rule ID 54639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54639,
        GIR_EraseRootFromParent_Done,
      // Label 33021: @2499971
      GIM_Reject,
    // Label 33009: @2499972
    GIM_Reject,
    // Label 32865: @2499973
    GIM_Try, /*On fail goto*//*Label 33022*/ GIMT_Encode4(2500762),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 33023*/ GIMT_Encode4(2500068), // Rule ID 55158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55158,
        GIR_EraseRootFromParent_Done,
      // Label 33023: @2500068
      GIM_Try, /*On fail goto*//*Label 33024*/ GIMT_Encode4(2500145), // Rule ID 55159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55159,
        GIR_EraseRootFromParent_Done,
      // Label 33024: @2500145
      GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2500222), // Rule ID 71615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71615,
        GIR_EraseRootFromParent_Done,
      // Label 33025: @2500222
      GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2500299), // Rule ID 71616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71616,
        GIR_EraseRootFromParent_Done,
      // Label 33026: @2500299
      GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2500361), // Rule ID 55162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55162,
        GIR_EraseRootFromParent_Done,
      // Label 33027: @2500361
      GIM_Try, /*On fail goto*//*Label 33028*/ GIMT_Encode4(2500423), // Rule ID 55163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55163,
        GIR_EraseRootFromParent_Done,
      // Label 33028: @2500423
      GIM_Try, /*On fail goto*//*Label 33029*/ GIMT_Encode4(2500485), // Rule ID 71619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71619,
        GIR_EraseRootFromParent_Done,
      // Label 33029: @2500485
      GIM_Try, /*On fail goto*//*Label 33030*/ GIMT_Encode4(2500547), // Rule ID 71620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71620,
        GIR_EraseRootFromParent_Done,
      // Label 33030: @2500547
      GIM_Try, /*On fail goto*//*Label 33031*/ GIMT_Encode4(2500609), // Rule ID 55154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55154,
        GIR_EraseRootFromParent_Done,
      // Label 33031: @2500609
      GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2500671), // Rule ID 55155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55155,
        GIR_EraseRootFromParent_Done,
      // Label 33032: @2500671
      GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2500716), // Rule ID 55150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55150,
        GIR_EraseRootFromParent_Done,
      // Label 33033: @2500716
      GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2500761), // Rule ID 55151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55151,
        GIR_EraseRootFromParent_Done,
      // Label 33034: @2500761
      GIM_Reject,
    // Label 33022: @2500762
    GIM_Reject,
    // Label 32866: @2500763
    GIM_Try, /*On fail goto*//*Label 33035*/ GIMT_Encode4(2501552),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33036*/ GIMT_Encode4(2500858), // Rule ID 54582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54582,
        GIR_EraseRootFromParent_Done,
      // Label 33036: @2500858
      GIM_Try, /*On fail goto*//*Label 33037*/ GIMT_Encode4(2500935), // Rule ID 54583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54583,
        GIR_EraseRootFromParent_Done,
      // Label 33037: @2500935
      GIM_Try, /*On fail goto*//*Label 33038*/ GIMT_Encode4(2501012), // Rule ID 71111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71111,
        GIR_EraseRootFromParent_Done,
      // Label 33038: @2501012
      GIM_Try, /*On fail goto*//*Label 33039*/ GIMT_Encode4(2501089), // Rule ID 71112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71112,
        GIR_EraseRootFromParent_Done,
      // Label 33039: @2501089
      GIM_Try, /*On fail goto*//*Label 33040*/ GIMT_Encode4(2501151), // Rule ID 54586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54586,
        GIR_EraseRootFromParent_Done,
      // Label 33040: @2501151
      GIM_Try, /*On fail goto*//*Label 33041*/ GIMT_Encode4(2501213), // Rule ID 54587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54587,
        GIR_EraseRootFromParent_Done,
      // Label 33041: @2501213
      GIM_Try, /*On fail goto*//*Label 33042*/ GIMT_Encode4(2501275), // Rule ID 71115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71115,
        GIR_EraseRootFromParent_Done,
      // Label 33042: @2501275
      GIM_Try, /*On fail goto*//*Label 33043*/ GIMT_Encode4(2501337), // Rule ID 71116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71116,
        GIR_EraseRootFromParent_Done,
      // Label 33043: @2501337
      GIM_Try, /*On fail goto*//*Label 33044*/ GIMT_Encode4(2501399), // Rule ID 54578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54578,
        GIR_EraseRootFromParent_Done,
      // Label 33044: @2501399
      GIM_Try, /*On fail goto*//*Label 33045*/ GIMT_Encode4(2501461), // Rule ID 54579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54579,
        GIR_EraseRootFromParent_Done,
      // Label 33045: @2501461
      GIM_Try, /*On fail goto*//*Label 33046*/ GIMT_Encode4(2501506), // Rule ID 54574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54574,
        GIR_EraseRootFromParent_Done,
      // Label 33046: @2501506
      GIM_Try, /*On fail goto*//*Label 33047*/ GIMT_Encode4(2501551), // Rule ID 54575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54575,
        GIR_EraseRootFromParent_Done,
      // Label 33047: @2501551
      GIM_Reject,
    // Label 33035: @2501552
    GIM_Reject,
    // Label 32867: @2501553
    GIM_Try, /*On fail goto*//*Label 33048*/ GIMT_Encode4(2502342),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 33049*/ GIMT_Encode4(2501648), // Rule ID 54966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54966,
        GIR_EraseRootFromParent_Done,
      // Label 33049: @2501648
      GIM_Try, /*On fail goto*//*Label 33050*/ GIMT_Encode4(2501725), // Rule ID 54967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54967,
        GIR_EraseRootFromParent_Done,
      // Label 33050: @2501725
      GIM_Try, /*On fail goto*//*Label 33051*/ GIMT_Encode4(2501802), // Rule ID 71447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71447,
        GIR_EraseRootFromParent_Done,
      // Label 33051: @2501802
      GIM_Try, /*On fail goto*//*Label 33052*/ GIMT_Encode4(2501879), // Rule ID 71448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71448,
        GIR_EraseRootFromParent_Done,
      // Label 33052: @2501879
      GIM_Try, /*On fail goto*//*Label 33053*/ GIMT_Encode4(2501941), // Rule ID 54970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54970,
        GIR_EraseRootFromParent_Done,
      // Label 33053: @2501941
      GIM_Try, /*On fail goto*//*Label 33054*/ GIMT_Encode4(2502003), // Rule ID 54971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54971,
        GIR_EraseRootFromParent_Done,
      // Label 33054: @2502003
      GIM_Try, /*On fail goto*//*Label 33055*/ GIMT_Encode4(2502065), // Rule ID 71451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71451,
        GIR_EraseRootFromParent_Done,
      // Label 33055: @2502065
      GIM_Try, /*On fail goto*//*Label 33056*/ GIMT_Encode4(2502127), // Rule ID 71452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71452,
        GIR_EraseRootFromParent_Done,
      // Label 33056: @2502127
      GIM_Try, /*On fail goto*//*Label 33057*/ GIMT_Encode4(2502189), // Rule ID 54962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54962,
        GIR_EraseRootFromParent_Done,
      // Label 33057: @2502189
      GIM_Try, /*On fail goto*//*Label 33058*/ GIMT_Encode4(2502251), // Rule ID 54963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54963,
        GIR_EraseRootFromParent_Done,
      // Label 33058: @2502251
      GIM_Try, /*On fail goto*//*Label 33059*/ GIMT_Encode4(2502296), // Rule ID 54958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54958,
        GIR_EraseRootFromParent_Done,
      // Label 33059: @2502296
      GIM_Try, /*On fail goto*//*Label 33060*/ GIMT_Encode4(2502341), // Rule ID 54959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54959,
        GIR_EraseRootFromParent_Done,
      // Label 33060: @2502341
      GIM_Reject,
    // Label 33048: @2502342
    GIM_Reject,
    // Label 32868: @2502343
    GIM_Try, /*On fail goto*//*Label 33061*/ GIMT_Encode4(2503132),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 33062*/ GIMT_Encode4(2502438), // Rule ID 55222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55222,
        GIR_EraseRootFromParent_Done,
      // Label 33062: @2502438
      GIM_Try, /*On fail goto*//*Label 33063*/ GIMT_Encode4(2502515), // Rule ID 55223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55223,
        GIR_EraseRootFromParent_Done,
      // Label 33063: @2502515
      GIM_Try, /*On fail goto*//*Label 33064*/ GIMT_Encode4(2502592), // Rule ID 71671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71671,
        GIR_EraseRootFromParent_Done,
      // Label 33064: @2502592
      GIM_Try, /*On fail goto*//*Label 33065*/ GIMT_Encode4(2502669), // Rule ID 71672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71672,
        GIR_EraseRootFromParent_Done,
      // Label 33065: @2502669
      GIM_Try, /*On fail goto*//*Label 33066*/ GIMT_Encode4(2502731), // Rule ID 55226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55226,
        GIR_EraseRootFromParent_Done,
      // Label 33066: @2502731
      GIM_Try, /*On fail goto*//*Label 33067*/ GIMT_Encode4(2502793), // Rule ID 55227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55227,
        GIR_EraseRootFromParent_Done,
      // Label 33067: @2502793
      GIM_Try, /*On fail goto*//*Label 33068*/ GIMT_Encode4(2502855), // Rule ID 71675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71675,
        GIR_EraseRootFromParent_Done,
      // Label 33068: @2502855
      GIM_Try, /*On fail goto*//*Label 33069*/ GIMT_Encode4(2502917), // Rule ID 71676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71676,
        GIR_EraseRootFromParent_Done,
      // Label 33069: @2502917
      GIM_Try, /*On fail goto*//*Label 33070*/ GIMT_Encode4(2502979), // Rule ID 55218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55218,
        GIR_EraseRootFromParent_Done,
      // Label 33070: @2502979
      GIM_Try, /*On fail goto*//*Label 33071*/ GIMT_Encode4(2503041), // Rule ID 55219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55219,
        GIR_EraseRootFromParent_Done,
      // Label 33071: @2503041
      GIM_Try, /*On fail goto*//*Label 33072*/ GIMT_Encode4(2503086), // Rule ID 55214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55214,
        GIR_EraseRootFromParent_Done,
      // Label 33072: @2503086
      GIM_Try, /*On fail goto*//*Label 33073*/ GIMT_Encode4(2503131), // Rule ID 55215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55215,
        GIR_EraseRootFromParent_Done,
      // Label 33073: @2503131
      GIM_Reject,
    // Label 33061: @2503132
    GIM_Reject,
    // Label 32869: @2503133
    GIM_Try, /*On fail goto*//*Label 33074*/ GIMT_Encode4(2503922),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2503228), // Rule ID 54774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54774,
        GIR_EraseRootFromParent_Done,
      // Label 33075: @2503228
      GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2503305), // Rule ID 54775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54775,
        GIR_EraseRootFromParent_Done,
      // Label 33076: @2503305
      GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2503382), // Rule ID 71279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71279,
        GIR_EraseRootFromParent_Done,
      // Label 33077: @2503382
      GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2503459), // Rule ID 71280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71280,
        GIR_EraseRootFromParent_Done,
      // Label 33078: @2503459
      GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2503521), // Rule ID 54778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54778,
        GIR_EraseRootFromParent_Done,
      // Label 33079: @2503521
      GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2503583), // Rule ID 54779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54779,
        GIR_EraseRootFromParent_Done,
      // Label 33080: @2503583
      GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2503645), // Rule ID 71283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71283,
        GIR_EraseRootFromParent_Done,
      // Label 33081: @2503645
      GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2503707), // Rule ID 71284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71284,
        GIR_EraseRootFromParent_Done,
      // Label 33082: @2503707
      GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2503769), // Rule ID 54770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54770,
        GIR_EraseRootFromParent_Done,
      // Label 33083: @2503769
      GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2503831), // Rule ID 54771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54771,
        GIR_EraseRootFromParent_Done,
      // Label 33084: @2503831
      GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2503876), // Rule ID 54766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54766,
        GIR_EraseRootFromParent_Done,
      // Label 33085: @2503876
      GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2503921), // Rule ID 54767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54767,
        GIR_EraseRootFromParent_Done,
      // Label 33086: @2503921
      GIM_Reject,
    // Label 33074: @2503922
    GIM_Reject,
    // Label 32870: @2503923
    GIM_Try, /*On fail goto*//*Label 33087*/ GIMT_Encode4(2504712),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 33088*/ GIMT_Encode4(2504018), // Rule ID 55030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55030,
        GIR_EraseRootFromParent_Done,
      // Label 33088: @2504018
      GIM_Try, /*On fail goto*//*Label 33089*/ GIMT_Encode4(2504095), // Rule ID 55031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55031,
        GIR_EraseRootFromParent_Done,
      // Label 33089: @2504095
      GIM_Try, /*On fail goto*//*Label 33090*/ GIMT_Encode4(2504172), // Rule ID 71503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71503,
        GIR_EraseRootFromParent_Done,
      // Label 33090: @2504172
      GIM_Try, /*On fail goto*//*Label 33091*/ GIMT_Encode4(2504249), // Rule ID 71504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71504,
        GIR_EraseRootFromParent_Done,
      // Label 33091: @2504249
      GIM_Try, /*On fail goto*//*Label 33092*/ GIMT_Encode4(2504311), // Rule ID 55034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55034,
        GIR_EraseRootFromParent_Done,
      // Label 33092: @2504311
      GIM_Try, /*On fail goto*//*Label 33093*/ GIMT_Encode4(2504373), // Rule ID 55035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55035,
        GIR_EraseRootFromParent_Done,
      // Label 33093: @2504373
      GIM_Try, /*On fail goto*//*Label 33094*/ GIMT_Encode4(2504435), // Rule ID 71507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71507,
        GIR_EraseRootFromParent_Done,
      // Label 33094: @2504435
      GIM_Try, /*On fail goto*//*Label 33095*/ GIMT_Encode4(2504497), // Rule ID 71508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71508,
        GIR_EraseRootFromParent_Done,
      // Label 33095: @2504497
      GIM_Try, /*On fail goto*//*Label 33096*/ GIMT_Encode4(2504559), // Rule ID 55026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55026,
        GIR_EraseRootFromParent_Done,
      // Label 33096: @2504559
      GIM_Try, /*On fail goto*//*Label 33097*/ GIMT_Encode4(2504621), // Rule ID 55027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55027,
        GIR_EraseRootFromParent_Done,
      // Label 33097: @2504621
      GIM_Try, /*On fail goto*//*Label 33098*/ GIMT_Encode4(2504666), // Rule ID 55022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55022,
        GIR_EraseRootFromParent_Done,
      // Label 33098: @2504666
      GIM_Try, /*On fail goto*//*Label 33099*/ GIMT_Encode4(2504711), // Rule ID 55023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55023,
        GIR_EraseRootFromParent_Done,
      // Label 33099: @2504711
      GIM_Reject,
    // Label 33087: @2504712
    GIM_Reject,
    // Label 32871: @2504713
    GIM_Try, /*On fail goto*//*Label 33100*/ GIMT_Encode4(2505502),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 33101*/ GIMT_Encode4(2504808), // Rule ID 55286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55286,
        GIR_EraseRootFromParent_Done,
      // Label 33101: @2504808
      GIM_Try, /*On fail goto*//*Label 33102*/ GIMT_Encode4(2504885), // Rule ID 55287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55287,
        GIR_EraseRootFromParent_Done,
      // Label 33102: @2504885
      GIM_Try, /*On fail goto*//*Label 33103*/ GIMT_Encode4(2504962), // Rule ID 71727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71727,
        GIR_EraseRootFromParent_Done,
      // Label 33103: @2504962
      GIM_Try, /*On fail goto*//*Label 33104*/ GIMT_Encode4(2505039), // Rule ID 71728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71728,
        GIR_EraseRootFromParent_Done,
      // Label 33104: @2505039
      GIM_Try, /*On fail goto*//*Label 33105*/ GIMT_Encode4(2505101), // Rule ID 55290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55290,
        GIR_EraseRootFromParent_Done,
      // Label 33105: @2505101
      GIM_Try, /*On fail goto*//*Label 33106*/ GIMT_Encode4(2505163), // Rule ID 55291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55291,
        GIR_EraseRootFromParent_Done,
      // Label 33106: @2505163
      GIM_Try, /*On fail goto*//*Label 33107*/ GIMT_Encode4(2505225), // Rule ID 71731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71731,
        GIR_EraseRootFromParent_Done,
      // Label 33107: @2505225
      GIM_Try, /*On fail goto*//*Label 33108*/ GIMT_Encode4(2505287), // Rule ID 71732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71732,
        GIR_EraseRootFromParent_Done,
      // Label 33108: @2505287
      GIM_Try, /*On fail goto*//*Label 33109*/ GIMT_Encode4(2505349), // Rule ID 55282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55282,
        GIR_EraseRootFromParent_Done,
      // Label 33109: @2505349
      GIM_Try, /*On fail goto*//*Label 33110*/ GIMT_Encode4(2505411), // Rule ID 55283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55283,
        GIR_EraseRootFromParent_Done,
      // Label 33110: @2505411
      GIM_Try, /*On fail goto*//*Label 33111*/ GIMT_Encode4(2505456), // Rule ID 55278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55278,
        GIR_EraseRootFromParent_Done,
      // Label 33111: @2505456
      GIM_Try, /*On fail goto*//*Label 33112*/ GIMT_Encode4(2505501), // Rule ID 55279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55279,
        GIR_EraseRootFromParent_Done,
      // Label 33112: @2505501
      GIM_Reject,
    // Label 33100: @2505502
    GIM_Reject,
    // Label 32872: @2505503
    GIM_Try, /*On fail goto*//*Label 33113*/ GIMT_Encode4(2506292),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 33114*/ GIMT_Encode4(2505598), // Rule ID 54838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54838,
        GIR_EraseRootFromParent_Done,
      // Label 33114: @2505598
      GIM_Try, /*On fail goto*//*Label 33115*/ GIMT_Encode4(2505675), // Rule ID 54839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54839,
        GIR_EraseRootFromParent_Done,
      // Label 33115: @2505675
      GIM_Try, /*On fail goto*//*Label 33116*/ GIMT_Encode4(2505752), // Rule ID 71335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71335,
        GIR_EraseRootFromParent_Done,
      // Label 33116: @2505752
      GIM_Try, /*On fail goto*//*Label 33117*/ GIMT_Encode4(2505829), // Rule ID 71336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71336,
        GIR_EraseRootFromParent_Done,
      // Label 33117: @2505829
      GIM_Try, /*On fail goto*//*Label 33118*/ GIMT_Encode4(2505891), // Rule ID 54842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54842,
        GIR_EraseRootFromParent_Done,
      // Label 33118: @2505891
      GIM_Try, /*On fail goto*//*Label 33119*/ GIMT_Encode4(2505953), // Rule ID 54843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54843,
        GIR_EraseRootFromParent_Done,
      // Label 33119: @2505953
      GIM_Try, /*On fail goto*//*Label 33120*/ GIMT_Encode4(2506015), // Rule ID 71339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71339,
        GIR_EraseRootFromParent_Done,
      // Label 33120: @2506015
      GIM_Try, /*On fail goto*//*Label 33121*/ GIMT_Encode4(2506077), // Rule ID 71340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71340,
        GIR_EraseRootFromParent_Done,
      // Label 33121: @2506077
      GIM_Try, /*On fail goto*//*Label 33122*/ GIMT_Encode4(2506139), // Rule ID 54834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54834,
        GIR_EraseRootFromParent_Done,
      // Label 33122: @2506139
      GIM_Try, /*On fail goto*//*Label 33123*/ GIMT_Encode4(2506201), // Rule ID 54835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54835,
        GIR_EraseRootFromParent_Done,
      // Label 33123: @2506201
      GIM_Try, /*On fail goto*//*Label 33124*/ GIMT_Encode4(2506246), // Rule ID 54830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54830,
        GIR_EraseRootFromParent_Done,
      // Label 33124: @2506246
      GIM_Try, /*On fail goto*//*Label 33125*/ GIMT_Encode4(2506291), // Rule ID 54831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54831,
        GIR_EraseRootFromParent_Done,
      // Label 33125: @2506291
      GIM_Reject,
    // Label 33113: @2506292
    GIM_Reject,
    // Label 32873: @2506293
    GIM_Try, /*On fail goto*//*Label 33126*/ GIMT_Encode4(2507082),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 33127*/ GIMT_Encode4(2506388), // Rule ID 55094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55094,
        GIR_EraseRootFromParent_Done,
      // Label 33127: @2506388
      GIM_Try, /*On fail goto*//*Label 33128*/ GIMT_Encode4(2506465), // Rule ID 55095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55095,
        GIR_EraseRootFromParent_Done,
      // Label 33128: @2506465
      GIM_Try, /*On fail goto*//*Label 33129*/ GIMT_Encode4(2506542), // Rule ID 71559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71559,
        GIR_EraseRootFromParent_Done,
      // Label 33129: @2506542
      GIM_Try, /*On fail goto*//*Label 33130*/ GIMT_Encode4(2506619), // Rule ID 71560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71560,
        GIR_EraseRootFromParent_Done,
      // Label 33130: @2506619
      GIM_Try, /*On fail goto*//*Label 33131*/ GIMT_Encode4(2506681), // Rule ID 55098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55098,
        GIR_EraseRootFromParent_Done,
      // Label 33131: @2506681
      GIM_Try, /*On fail goto*//*Label 33132*/ GIMT_Encode4(2506743), // Rule ID 55099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55099,
        GIR_EraseRootFromParent_Done,
      // Label 33132: @2506743
      GIM_Try, /*On fail goto*//*Label 33133*/ GIMT_Encode4(2506805), // Rule ID 71563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71563,
        GIR_EraseRootFromParent_Done,
      // Label 33133: @2506805
      GIM_Try, /*On fail goto*//*Label 33134*/ GIMT_Encode4(2506867), // Rule ID 71564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71564,
        GIR_EraseRootFromParent_Done,
      // Label 33134: @2506867
      GIM_Try, /*On fail goto*//*Label 33135*/ GIMT_Encode4(2506929), // Rule ID 55090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55090,
        GIR_EraseRootFromParent_Done,
      // Label 33135: @2506929
      GIM_Try, /*On fail goto*//*Label 33136*/ GIMT_Encode4(2506991), // Rule ID 55091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55091,
        GIR_EraseRootFromParent_Done,
      // Label 33136: @2506991
      GIM_Try, /*On fail goto*//*Label 33137*/ GIMT_Encode4(2507036), // Rule ID 55086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55086,
        GIR_EraseRootFromParent_Done,
      // Label 33137: @2507036
      GIM_Try, /*On fail goto*//*Label 33138*/ GIMT_Encode4(2507081), // Rule ID 55087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55087,
        GIR_EraseRootFromParent_Done,
      // Label 33138: @2507081
      GIM_Reject,
    // Label 33126: @2507082
    GIM_Reject,
    // Label 32874: @2507083
    GIM_Try, /*On fail goto*//*Label 33139*/ GIMT_Encode4(2507872),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 33140*/ GIMT_Encode4(2507178), // Rule ID 54902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54902,
        GIR_EraseRootFromParent_Done,
      // Label 33140: @2507178
      GIM_Try, /*On fail goto*//*Label 33141*/ GIMT_Encode4(2507255), // Rule ID 54903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54903,
        GIR_EraseRootFromParent_Done,
      // Label 33141: @2507255
      GIM_Try, /*On fail goto*//*Label 33142*/ GIMT_Encode4(2507332), // Rule ID 71391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71391,
        GIR_EraseRootFromParent_Done,
      // Label 33142: @2507332
      GIM_Try, /*On fail goto*//*Label 33143*/ GIMT_Encode4(2507409), // Rule ID 71392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71392,
        GIR_EraseRootFromParent_Done,
      // Label 33143: @2507409
      GIM_Try, /*On fail goto*//*Label 33144*/ GIMT_Encode4(2507471), // Rule ID 54906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54906,
        GIR_EraseRootFromParent_Done,
      // Label 33144: @2507471
      GIM_Try, /*On fail goto*//*Label 33145*/ GIMT_Encode4(2507533), // Rule ID 54907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54907,
        GIR_EraseRootFromParent_Done,
      // Label 33145: @2507533
      GIM_Try, /*On fail goto*//*Label 33146*/ GIMT_Encode4(2507595), // Rule ID 71395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71395,
        GIR_EraseRootFromParent_Done,
      // Label 33146: @2507595
      GIM_Try, /*On fail goto*//*Label 33147*/ GIMT_Encode4(2507657), // Rule ID 71396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71396,
        GIR_EraseRootFromParent_Done,
      // Label 33147: @2507657
      GIM_Try, /*On fail goto*//*Label 33148*/ GIMT_Encode4(2507719), // Rule ID 54898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54898,
        GIR_EraseRootFromParent_Done,
      // Label 33148: @2507719
      GIM_Try, /*On fail goto*//*Label 33149*/ GIMT_Encode4(2507781), // Rule ID 54899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54899,
        GIR_EraseRootFromParent_Done,
      // Label 33149: @2507781
      GIM_Try, /*On fail goto*//*Label 33150*/ GIMT_Encode4(2507826), // Rule ID 54894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54894,
        GIR_EraseRootFromParent_Done,
      // Label 33150: @2507826
      GIM_Try, /*On fail goto*//*Label 33151*/ GIMT_Encode4(2507871), // Rule ID 54895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // rd
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54895,
        GIR_EraseRootFromParent_Done,
      // Label 33151: @2507871
      GIM_Reject,
    // Label 33139: @2507872
    GIM_Reject,
    // Label 32875: @2507873
    GIM_Reject,
    // Label 99: @2507874
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33170*/ GIMT_Encode4(2510049),
    /*GILLT_s16*//*Label 33152*/ GIMT_Encode4(2508005),
    /*GILLT_s32*//*Label 33153*/ GIMT_Encode4(2508127),
    /*GILLT_s64*//*Label 33154*/ GIMT_Encode4(2508249), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s16*//*Label 33155*/ GIMT_Encode4(2508399),
    /*GILLT_nxv1s32*//*Label 33156*/ GIMT_Encode4(2508509),
    /*GILLT_nxv1s64*//*Label 33157*/ GIMT_Encode4(2508619), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 33158*/ GIMT_Encode4(2508729),
    /*GILLT_nxv2s32*//*Label 33159*/ GIMT_Encode4(2508839),
    /*GILLT_nxv2s64*//*Label 33160*/ GIMT_Encode4(2508949), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 33161*/ GIMT_Encode4(2509059),
    /*GILLT_nxv4s32*//*Label 33162*/ GIMT_Encode4(2509169),
    /*GILLT_nxv4s64*//*Label 33163*/ GIMT_Encode4(2509279), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 33164*/ GIMT_Encode4(2509389),
    /*GILLT_nxv8s32*//*Label 33165*/ GIMT_Encode4(2509499),
    /*GILLT_nxv8s64*//*Label 33166*/ GIMT_Encode4(2509609), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s16*//*Label 33167*/ GIMT_Encode4(2509719),
    /*GILLT_nxv16s32*//*Label 33168*/ GIMT_Encode4(2509829), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s16*//*Label 33169*/ GIMT_Encode4(2509939),
    // Label 33152: @2508005
    GIM_Try, /*On fail goto*//*Label 33171*/ GIMT_Encode4(2508126),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 33172*/ GIMT_Encode4(2508041), // Rule ID 1846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1846,
        GIR_EraseRootFromParent_Done,
      // Label 33172: @2508041
      GIM_Try, /*On fail goto*//*Label 33173*/ GIMT_Encode4(2508069), // Rule ID 1847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
        // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1847,
        GIR_EraseRootFromParent_Done,
      // Label 33173: @2508069
      GIM_Try, /*On fail goto*//*Label 33174*/ GIMT_Encode4(2508097), // Rule ID 1879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1879,
        GIR_EraseRootFromParent_Done,
      // Label 33174: @2508097
      GIM_Try, /*On fail goto*//*Label 33175*/ GIMT_Encode4(2508125), // Rule ID 1880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
        // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1880,
        GIR_EraseRootFromParent_Done,
      // Label 33175: @2508125
      GIM_Reject,
    // Label 33171: @2508126
    GIM_Reject,
    // Label 33153: @2508127
    GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2508248),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2508163), // Rule ID 1137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1137,
        GIR_EraseRootFromParent_Done,
      // Label 33177: @2508163
      GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2508191), // Rule ID 1138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
        // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1138,
        GIR_EraseRootFromParent_Done,
      // Label 33178: @2508191
      GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2508219), // Rule ID 1145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1145,
        GIR_EraseRootFromParent_Done,
      // Label 33179: @2508219
      GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2508247), // Rule ID 1146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
        // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1146,
        GIR_EraseRootFromParent_Done,
      // Label 33180: @2508247
      GIM_Reject,
    // Label 33176: @2508248
    GIM_Reject,
    // Label 33154: @2508249
    GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2508398),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2508285), // Rule ID 1480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1480,
        GIR_EraseRootFromParent_Done,
      // Label 33182: @2508285
      GIM_Try, /*On fail goto*//*Label 33183*/ GIMT_Encode4(2508313), // Rule ID 1481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
        // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1481,
        GIR_EraseRootFromParent_Done,
      // Label 33183: @2508313
      GIM_Try, /*On fail goto*//*Label 33184*/ GIMT_Encode4(2508341), // Rule ID 1515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1515,
        GIR_EraseRootFromParent_Done,
      // Label 33184: @2508341
      GIM_Try, /*On fail goto*//*Label 33185*/ GIMT_Encode4(2508369), // Rule ID 1535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1535,
        GIR_EraseRootFromParent_Done,
      // Label 33185: @2508369
      GIM_Try, /*On fail goto*//*Label 33186*/ GIMT_Encode4(2508397), // Rule ID 1536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
        // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1536,
        GIR_EraseRootFromParent_Done,
      // Label 33186: @2508397
      GIM_Reject,
    // Label 33181: @2508398
    GIM_Reject,
    // Label 33155: @2508399
    GIM_Try, /*On fail goto*//*Label 33187*/ GIMT_Encode4(2508508),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33188*/ GIMT_Encode4(2508461), // Rule ID 55790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55790,
        GIR_EraseRootFromParent_Done,
      // Label 33188: @2508461
      GIM_Try, /*On fail goto*//*Label 33189*/ GIMT_Encode4(2508507), // Rule ID 55791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55791,
        GIR_EraseRootFromParent_Done,
      // Label 33189: @2508507
      GIM_Reject,
    // Label 33187: @2508508
    GIM_Reject,
    // Label 33156: @2508509
    GIM_Try, /*On fail goto*//*Label 33190*/ GIMT_Encode4(2508618),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33191*/ GIMT_Encode4(2508571), // Rule ID 55830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55830,
        GIR_EraseRootFromParent_Done,
      // Label 33191: @2508571
      GIM_Try, /*On fail goto*//*Label 33192*/ GIMT_Encode4(2508617), // Rule ID 55831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55831,
        GIR_EraseRootFromParent_Done,
      // Label 33192: @2508617
      GIM_Reject,
    // Label 33190: @2508618
    GIM_Reject,
    // Label 33157: @2508619
    GIM_Try, /*On fail goto*//*Label 33193*/ GIMT_Encode4(2508728),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33194*/ GIMT_Encode4(2508681), // Rule ID 55890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55890,
        GIR_EraseRootFromParent_Done,
      // Label 33194: @2508681
      GIM_Try, /*On fail goto*//*Label 33195*/ GIMT_Encode4(2508727), // Rule ID 55891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55891,
        GIR_EraseRootFromParent_Done,
      // Label 33195: @2508727
      GIM_Reject,
    // Label 33193: @2508728
    GIM_Reject,
    // Label 33158: @2508729
    GIM_Try, /*On fail goto*//*Label 33196*/ GIMT_Encode4(2508838),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33197*/ GIMT_Encode4(2508791), // Rule ID 55810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55810,
        GIR_EraseRootFromParent_Done,
      // Label 33197: @2508791
      GIM_Try, /*On fail goto*//*Label 33198*/ GIMT_Encode4(2508837), // Rule ID 55811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55811,
        GIR_EraseRootFromParent_Done,
      // Label 33198: @2508837
      GIM_Reject,
    // Label 33196: @2508838
    GIM_Reject,
    // Label 33159: @2508839
    GIM_Try, /*On fail goto*//*Label 33199*/ GIMT_Encode4(2508948),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33200*/ GIMT_Encode4(2508901), // Rule ID 55870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55870,
        GIR_EraseRootFromParent_Done,
      // Label 33200: @2508901
      GIM_Try, /*On fail goto*//*Label 33201*/ GIMT_Encode4(2508947), // Rule ID 55871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55871,
        GIR_EraseRootFromParent_Done,
      // Label 33201: @2508947
      GIM_Reject,
    // Label 33199: @2508948
    GIM_Reject,
    // Label 33160: @2508949
    GIM_Try, /*On fail goto*//*Label 33202*/ GIMT_Encode4(2509058),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 33203*/ GIMT_Encode4(2509011), // Rule ID 56030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56030,
        GIR_EraseRootFromParent_Done,
      // Label 33203: @2509011
      GIM_Try, /*On fail goto*//*Label 33204*/ GIMT_Encode4(2509057), // Rule ID 56031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56031,
        GIR_EraseRootFromParent_Done,
      // Label 33204: @2509057
      GIM_Reject,
    // Label 33202: @2509058
    GIM_Reject,
    // Label 33161: @2509059
    GIM_Try, /*On fail goto*//*Label 33205*/ GIMT_Encode4(2509168),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33206*/ GIMT_Encode4(2509121), // Rule ID 55850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55850,
        GIR_EraseRootFromParent_Done,
      // Label 33206: @2509121
      GIM_Try, /*On fail goto*//*Label 33207*/ GIMT_Encode4(2509167), // Rule ID 55851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55851,
        GIR_EraseRootFromParent_Done,
      // Label 33207: @2509167
      GIM_Reject,
    // Label 33205: @2509168
    GIM_Reject,
    // Label 33162: @2509169
    GIM_Try, /*On fail goto*//*Label 33208*/ GIMT_Encode4(2509278),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2509231), // Rule ID 55970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55970,
        GIR_EraseRootFromParent_Done,
      // Label 33209: @2509231
      GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2509277), // Rule ID 55971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55971,
        GIR_EraseRootFromParent_Done,
      // Label 33210: @2509277
      GIM_Reject,
    // Label 33208: @2509278
    GIM_Reject,
    // Label 33163: @2509279
    GIM_Try, /*On fail goto*//*Label 33211*/ GIMT_Encode4(2509388),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 33212*/ GIMT_Encode4(2509341), // Rule ID 56050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56050,
        GIR_EraseRootFromParent_Done,
      // Label 33212: @2509341
      GIM_Try, /*On fail goto*//*Label 33213*/ GIMT_Encode4(2509387), // Rule ID 56051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56051,
        GIR_EraseRootFromParent_Done,
      // Label 33213: @2509387
      GIM_Reject,
    // Label 33211: @2509388
    GIM_Reject,
    // Label 33164: @2509389
    GIM_Try, /*On fail goto*//*Label 33214*/ GIMT_Encode4(2509498),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
      GIM_Try, /*On fail goto*//*Label 33215*/ GIMT_Encode4(2509451), // Rule ID 55910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55910,
        GIR_EraseRootFromParent_Done,
      // Label 33215: @2509451
      GIM_Try, /*On fail goto*//*Label 33216*/ GIMT_Encode4(2509497), // Rule ID 55911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55911,
        GIR_EraseRootFromParent_Done,
      // Label 33216: @2509497
      GIM_Reject,
    // Label 33214: @2509498
    GIM_Reject,
    // Label 33165: @2509499
    GIM_Try, /*On fail goto*//*Label 33217*/ GIMT_Encode4(2509608),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 33218*/ GIMT_Encode4(2509561), // Rule ID 55990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55990,
        GIR_EraseRootFromParent_Done,
      // Label 33218: @2509561
      GIM_Try, /*On fail goto*//*Label 33219*/ GIMT_Encode4(2509607), // Rule ID 55991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55991,
        GIR_EraseRootFromParent_Done,
      // Label 33219: @2509607
      GIM_Reject,
    // Label 33217: @2509608
    GIM_Reject,
    // Label 33166: @2509609
    GIM_Try, /*On fail goto*//*Label 33220*/ GIMT_Encode4(2509718),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 33221*/ GIMT_Encode4(2509671), // Rule ID 56070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
        // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56070,
        GIR_EraseRootFromParent_Done,
      // Label 33221: @2509671
      GIM_Try, /*On fail goto*//*Label 33222*/ GIMT_Encode4(2509717), // Rule ID 56071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
        // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56071,
        GIR_EraseRootFromParent_Done,
      // Label 33222: @2509717
      GIM_Reject,
    // Label 33220: @2509718
    GIM_Reject,
    // Label 33167: @2509719
    GIM_Try, /*On fail goto*//*Label 33223*/ GIMT_Encode4(2509828),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
      GIM_Try, /*On fail goto*//*Label 33224*/ GIMT_Encode4(2509781), // Rule ID 55930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55930,
        GIR_EraseRootFromParent_Done,
      // Label 33224: @2509781
      GIM_Try, /*On fail goto*//*Label 33225*/ GIMT_Encode4(2509827), // Rule ID 55931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55931,
        GIR_EraseRootFromParent_Done,
      // Label 33225: @2509827
      GIM_Reject,
    // Label 33223: @2509828
    GIM_Reject,
    // Label 33168: @2509829
    GIM_Try, /*On fail goto*//*Label 33226*/ GIMT_Encode4(2509938),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 33227*/ GIMT_Encode4(2509891), // Rule ID 56010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
        // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56010,
        GIR_EraseRootFromParent_Done,
      // Label 33227: @2509891
      GIM_Try, /*On fail goto*//*Label 33228*/ GIMT_Encode4(2509937), // Rule ID 56011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
        // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56011,
        GIR_EraseRootFromParent_Done,
      // Label 33228: @2509937
      GIM_Reject,
    // Label 33226: @2509938
    GIM_Reject,
    // Label 33169: @2509939
    GIM_Try, /*On fail goto*//*Label 33229*/ GIMT_Encode4(2510048),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
      GIM_Try, /*On fail goto*//*Label 33230*/ GIMT_Encode4(2510001), // Rule ID 55950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
        // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55950,
        GIR_EraseRootFromParent_Done,
      // Label 33230: @2510001
      GIM_Try, /*On fail goto*//*Label 33231*/ GIMT_Encode4(2510047), // Rule ID 55951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
        // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rs2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55951,
        GIR_EraseRootFromParent_Done,
      // Label 33231: @2510047
      GIM_Reject,
    // Label 33229: @2510048
    GIM_Reject,
    // Label 33170: @2510049
    GIM_Reject,
    // Label 100: @2510050
    GIM_Try, /*On fail goto*//*Label 33232*/ GIMT_Encode4(2510062), // Rule ID 282 //
      // (trap)  =>  (UNIMP)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 282,
      GIR_Done,
    // Label 33232: @2510062
    GIM_Reject,
    // Label 101: @2510063
    GIM_Try, /*On fail goto*//*Label 33233*/ GIMT_Encode4(2510075), // Rule ID 283 //
      // (debugtrap)  =>  (EBREAK)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 283,
      GIR_Done,
    // Label 33233: @2510075
    GIM_Reject,
    // Label 102: @2510076
    GIM_Try, /*On fail goto*//*Label 33234*/ GIMT_Encode4(2510170),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33235*/ GIMT_Encode4(2510110), // Rule ID 2378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2378,
        GIR_Done,
      // Label 33235: @2510110
      GIM_Try, /*On fail goto*//*Label 33236*/ GIMT_Encode4(2510169), // Rule ID 61981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
        // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
        GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61981,
        GIR_EraseRootFromParent_Done,
      // Label 33236: @2510169
      GIM_Reject,
    // Label 33234: @2510170
    GIM_Reject,
    // Label 103: @2510171
    GIM_Try, /*On fail goto*//*Label 33237*/ GIMT_Encode4(2510200), // Rule ID 2379 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2379,
      GIR_Done,
    // Label 33237: @2510200
    GIM_Reject,
    // Label 104: @2510201
    GIM_Try, /*On fail goto*//*Label 33238*/ GIMT_Encode4(2510237), // Rule ID 305 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 305,
      GIR_Done,
    // Label 33238: @2510237
    GIM_Reject,
    // Label 105: @2510238
    GIM_Try, /*On fail goto*//*Label 33239*/ GIMT_Encode4(2510274), // Rule ID 304 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 304,
      GIR_Done,
    // Label 33239: @2510274
    GIM_Reject,
    // Label 106: @2510275
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33242*/ GIMT_Encode4(2510634),
    /*GILLT_s32*//*Label 33240*/ GIMT_Encode4(2510294),
    /*GILLT_s64*//*Label 33241*/ GIMT_Encode4(2510451),
    // Label 33240: @2510294
    GIM_Try, /*On fail goto*//*Label 33243*/ GIMT_Encode4(2510320), // Rule ID 1144 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1144,
      GIR_Done,
    // Label 33243: @2510320
    GIM_Try, /*On fail goto*//*Label 33244*/ GIMT_Encode4(2510346), // Rule ID 1152 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1152,
      GIR_Done,
    // Label 33244: @2510346
    GIM_Try, /*On fail goto*//*Label 33245*/ GIMT_Encode4(2510372), // Rule ID 1487 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1487,
      GIR_Done,
    // Label 33245: @2510372
    GIM_Try, /*On fail goto*//*Label 33246*/ GIMT_Encode4(2510398), // Rule ID 1542 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1542,
      GIR_Done,
    // Label 33246: @2510398
    GIM_Try, /*On fail goto*//*Label 33247*/ GIMT_Encode4(2510424), // Rule ID 1853 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1853,
      GIR_Done,
    // Label 33247: @2510424
    GIM_Try, /*On fail goto*//*Label 33248*/ GIMT_Encode4(2510450), // Rule ID 1886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1886,
      GIR_Done,
    // Label 33248: @2510450
    GIM_Reject,
    // Label 33241: @2510451
    GIM_Try, /*On fail goto*//*Label 33249*/ GIMT_Encode4(2510477), // Rule ID 1143 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
      // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1143,
      GIR_Done,
    // Label 33249: @2510477
    GIM_Try, /*On fail goto*//*Label 33250*/ GIMT_Encode4(2510503), // Rule ID 1151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
      // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1151,
      GIR_Done,
    // Label 33250: @2510503
    GIM_Try, /*On fail goto*//*Label 33251*/ GIMT_Encode4(2510529), // Rule ID 1486 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
      // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1486,
      GIR_Done,
    // Label 33251: @2510529
    GIM_Try, /*On fail goto*//*Label 33252*/ GIMT_Encode4(2510555), // Rule ID 1519 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1519,
      GIR_Done,
    // Label 33252: @2510555
    GIM_Try, /*On fail goto*//*Label 33253*/ GIMT_Encode4(2510581), // Rule ID 1541 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
      // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1541,
      GIR_Done,
    // Label 33253: @2510581
    GIM_Try, /*On fail goto*//*Label 33254*/ GIMT_Encode4(2510607), // Rule ID 1852 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
      // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1852,
      GIR_Done,
    // Label 33254: @2510607
    GIM_Try, /*On fail goto*//*Label 33255*/ GIMT_Encode4(2510633), // Rule ID 1885 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
      // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1885,
      GIR_Done,
    // Label 33255: @2510633
    GIM_Reject,
    // Label 33242: @2510634
    GIM_Reject,
    // Label 107: @2510635
    GIM_Try, /*On fail goto*//*Label 33256*/ GIMT_Encode4(2510832),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33260*/ GIMT_Encode4(2510831),
      /*GILLT_s16*//*Label 33257*/ GIMT_Encode4(2510666),
      /*GILLT_s32*//*Label 33258*/ GIMT_Encode4(2510721),
      /*GILLT_s64*//*Label 33259*/ GIMT_Encode4(2510776),
      // Label 33257: @2510666
      GIM_Try, /*On fail goto*//*Label 33261*/ GIMT_Encode4(2510720),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 33262*/ GIMT_Encode4(2510697), // Rule ID 2103 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2103,
          GIR_Done,
        // Label 33262: @2510697
        GIM_Try, /*On fail goto*//*Label 33263*/ GIMT_Encode4(2510719), // Rule ID 2129 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2129,
          GIR_Done,
        // Label 33263: @2510719
        GIM_Reject,
      // Label 33261: @2510720
      GIM_Reject,
      // Label 33258: @2510721
      GIM_Try, /*On fail goto*//*Label 33264*/ GIMT_Encode4(2510775),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 33265*/ GIMT_Encode4(2510752), // Rule ID 1369 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1369,
          GIR_Done,
        // Label 33265: @2510752
        GIM_Try, /*On fail goto*//*Label 33266*/ GIMT_Encode4(2510774), // Rule ID 1397 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1397,
          GIR_Done,
        // Label 33266: @2510774
        GIM_Reject,
      // Label 33264: @2510775
      GIM_Reject,
      // Label 33259: @2510776
      GIM_Try, /*On fail goto*//*Label 33267*/ GIMT_Encode4(2510830),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 33268*/ GIMT_Encode4(2510807), // Rule ID 1763 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1763,
          GIR_Done,
        // Label 33268: @2510807
        GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2510829), // Rule ID 1791 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1791,
          GIR_Done,
        // Label 33269: @2510829
        GIM_Reject,
      // Label 33267: @2510830
      GIM_Reject,
      // Label 33260: @2510831
      GIM_Reject,
    // Label 33256: @2510832
    GIM_Reject,
    // Label 108: @2510833
    GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2511030),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33274*/ GIMT_Encode4(2511029),
      /*GILLT_s16*//*Label 33271*/ GIMT_Encode4(2510864),
      /*GILLT_s32*//*Label 33272*/ GIMT_Encode4(2510919),
      /*GILLT_s64*//*Label 33273*/ GIMT_Encode4(2510974),
      // Label 33271: @2510864
      GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2510918),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 33276*/ GIMT_Encode4(2510895), // Rule ID 2101 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2101,
          GIR_Done,
        // Label 33276: @2510895
        GIM_Try, /*On fail goto*//*Label 33277*/ GIMT_Encode4(2510917), // Rule ID 2127 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2127,
          GIR_Done,
        // Label 33277: @2510917
        GIM_Reject,
      // Label 33275: @2510918
      GIM_Reject,
      // Label 33272: @2510919
      GIM_Try, /*On fail goto*//*Label 33278*/ GIMT_Encode4(2510973),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 33279*/ GIMT_Encode4(2510950), // Rule ID 1367 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1367,
          GIR_Done,
        // Label 33279: @2510950
        GIM_Try, /*On fail goto*//*Label 33280*/ GIMT_Encode4(2510972), // Rule ID 1395 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1395,
          GIR_Done,
        // Label 33280: @2510972
        GIM_Reject,
      // Label 33278: @2510973
      GIM_Reject,
      // Label 33273: @2510974
      GIM_Try, /*On fail goto*//*Label 33281*/ GIMT_Encode4(2511028),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 33282*/ GIMT_Encode4(2511005), // Rule ID 1761 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1761,
          GIR_Done,
        // Label 33282: @2511005
        GIM_Try, /*On fail goto*//*Label 33283*/ GIMT_Encode4(2511027), // Rule ID 1789 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
          // MIs[0] frm
          GIM_CheckIsImm, /*MI*/0, /*Op*/2,
          // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1789,
          GIR_Done,
        // Label 33283: @2511027
        GIM_Reject,
      // Label 33281: @2511028
      GIM_Reject,
      // Label 33274: @2511029
      GIM_Reject,
    // Label 33270: @2511030
    GIM_Reject,
    // Label 109: @2511031
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33286*/ GIMT_Encode4(2511090),
    /*GILLT_s32*//*Label 33284*/ GIMT_Encode4(2511050),
    /*GILLT_s64*//*Label 33285*/ GIMT_Encode4(2511070),
    // Label 33284: @2511050
    GIM_Try, /*On fail goto*//*Label 33287*/ GIMT_Encode4(2511069), // Rule ID 67 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 67,
      GIR_Done,
    // Label 33287: @2511069
    GIM_Reject,
    // Label 33285: @2511070
    GIM_Try, /*On fail goto*//*Label 33288*/ GIMT_Encode4(2511089), // Rule ID 66 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 66,
      GIR_Done,
    // Label 33288: @2511089
    GIM_Reject,
    // Label 33286: @2511090
    GIM_Reject,
    // Label 110: @2511091
    GIM_Try, /*On fail goto*//*Label 33289*/ GIMT_Encode4(2511127), // Rule ID 306 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 306,
      GIR_Done,
    // Label 33289: @2511127
    GIM_Reject,
    // Label 111: @2511128
    GIM_Try, /*On fail goto*//*Label 33290*/ GIMT_Encode4(2511252),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33291*/ GIMT_Encode4(2511186), // Rule ID 2327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2327,
        GIR_EraseRootFromParent_Done,
      // Label 33291: @2511186
      GIM_Try, /*On fail goto*//*Label 33292*/ GIMT_Encode4(2511222), // Rule ID 61978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61978,
        GIR_EraseRootFromParent_Done,
      // Label 33292: @2511222
      GIM_Try, /*On fail goto*//*Label 33293*/ GIMT_Encode4(2511251), // Rule ID 2324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
        // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2324,
        GIR_EraseRootFromParent_Done,
      // Label 33293: @2511251
      GIM_Reject,
    // Label 33290: @2511252
    GIM_Reject,
    // Label 112: @2511253
    GIM_Try, /*On fail goto*//*Label 33294*/ GIMT_Encode4(2511373),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 33295*/ GIMT_Encode4(2511309), // Rule ID 2326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2326,
        GIR_EraseRootFromParent_Done,
      // Label 33295: @2511309
      GIM_Try, /*On fail goto*//*Label 33296*/ GIMT_Encode4(2511343), // Rule ID 61977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61977,
        GIR_EraseRootFromParent_Done,
      // Label 33296: @2511343
      GIM_Try, /*On fail goto*//*Label 33297*/ GIMT_Encode4(2511372), // Rule ID 2325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
        // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rs1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2325,
        GIR_EraseRootFromParent_Done,
      // Label 33297: @2511372
      GIM_Reject,
    // Label 33294: @2511373
    GIM_Reject,
    // Label 113: @2511374
    GIM_Try, /*On fail goto*//*Label 33298*/ GIMT_Encode4(2511420), // Rule ID 261 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
      // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 261,
      GIR_EraseRootFromParent_Done,
    // Label 33298: @2511420
    GIM_Reject,
    // Label 114: @2511421
    GIM_Try, /*On fail goto*//*Label 33299*/ GIMT_Encode4(2511467), // Rule ID 263 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
      // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 263,
      GIR_EraseRootFromParent_Done,
    // Label 33299: @2511467
    GIM_Reject,
    // Label 115: @2511468
    GIM_Try, /*On fail goto*//*Label 33300*/ GIMT_Encode4(2511514), // Rule ID 262 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
      // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // rs1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 262,
      GIR_EraseRootFromParent_Done,
    // Label 33300: @2511514
    GIM_Reject,
    // Label 116: @2511515
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 33308*/ GIMT_Encode4(2512163),
    /*GILLT_nxv1s1*//*Label 33301*/ GIMT_Encode4(2511638), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 33302*/ GIMT_Encode4(2511713), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s1*//*Label 33303*/ GIMT_Encode4(2511788), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s1*//*Label 33304*/ GIMT_Encode4(2511863), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s1*//*Label 33305*/ GIMT_Encode4(2511938), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s1*//*Label 33306*/ GIMT_Encode4(2512013), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv64s1*//*Label 33307*/ GIMT_Encode4(2512088),
    // Label 33301: @2511638
    GIM_Try, /*On fail goto*//*Label 33309*/ GIMT_Encode4(2511675), // Rule ID 44468 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44468,
      GIR_EraseRootFromParent_Done,
    // Label 33309: @2511675
    GIM_Try, /*On fail goto*//*Label 33310*/ GIMT_Encode4(2511712), // Rule ID 44469 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44469,
      GIR_EraseRootFromParent_Done,
    // Label 33310: @2511712
    GIM_Reject,
    // Label 33302: @2511713
    GIM_Try, /*On fail goto*//*Label 33311*/ GIMT_Encode4(2511750), // Rule ID 44500 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44500,
      GIR_EraseRootFromParent_Done,
    // Label 33311: @2511750
    GIM_Try, /*On fail goto*//*Label 33312*/ GIMT_Encode4(2511787), // Rule ID 44501 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44501,
      GIR_EraseRootFromParent_Done,
    // Label 33312: @2511787
    GIM_Reject,
    // Label 33303: @2511788
    GIM_Try, /*On fail goto*//*Label 33313*/ GIMT_Encode4(2511825), // Rule ID 44532 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44532,
      GIR_EraseRootFromParent_Done,
    // Label 33313: @2511825
    GIM_Try, /*On fail goto*//*Label 33314*/ GIMT_Encode4(2511862), // Rule ID 44533 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44533,
      GIR_EraseRootFromParent_Done,
    // Label 33314: @2511862
    GIM_Reject,
    // Label 33304: @2511863
    GIM_Try, /*On fail goto*//*Label 33315*/ GIMT_Encode4(2511900), // Rule ID 44564 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44564,
      GIR_EraseRootFromParent_Done,
    // Label 33315: @2511900
    GIM_Try, /*On fail goto*//*Label 33316*/ GIMT_Encode4(2511937), // Rule ID 44565 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44565,
      GIR_EraseRootFromParent_Done,
    // Label 33316: @2511937
    GIM_Reject,
    // Label 33305: @2511938
    GIM_Try, /*On fail goto*//*Label 33317*/ GIMT_Encode4(2511975), // Rule ID 44596 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44596,
      GIR_EraseRootFromParent_Done,
    // Label 33317: @2511975
    GIM_Try, /*On fail goto*//*Label 33318*/ GIMT_Encode4(2512012), // Rule ID 44597 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44597,
      GIR_EraseRootFromParent_Done,
    // Label 33318: @2512012
    GIM_Reject,
    // Label 33306: @2512013
    GIM_Try, /*On fail goto*//*Label 33319*/ GIMT_Encode4(2512050), // Rule ID 44628 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44628,
      GIR_EraseRootFromParent_Done,
    // Label 33319: @2512050
    GIM_Try, /*On fail goto*//*Label 33320*/ GIMT_Encode4(2512087), // Rule ID 44629 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44629,
      GIR_EraseRootFromParent_Done,
    // Label 33320: @2512087
    GIM_Reject,
    // Label 33307: @2512088
    GIM_Try, /*On fail goto*//*Label 33321*/ GIMT_Encode4(2512125), // Rule ID 44660 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44660,
      GIR_EraseRootFromParent_Done,
    // Label 33321: @2512125
    GIM_Try, /*On fail goto*//*Label 33322*/ GIMT_Encode4(2512162), // Rule ID 44661 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44661,
      GIR_EraseRootFromParent_Done,
    // Label 33322: @2512162
    GIM_Reject,
    // Label 33308: @2512163
    GIM_Reject,
    // Label 117: @2512164
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 33330*/ GIMT_Encode4(2512812),
    /*GILLT_nxv1s1*//*Label 33323*/ GIMT_Encode4(2512287), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 33324*/ GIMT_Encode4(2512362), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s1*//*Label 33325*/ GIMT_Encode4(2512437), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s1*//*Label 33326*/ GIMT_Encode4(2512512), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s1*//*Label 33327*/ GIMT_Encode4(2512587), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv32s1*//*Label 33328*/ GIMT_Encode4(2512662), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv64s1*//*Label 33329*/ GIMT_Encode4(2512737),
    // Label 33323: @2512287
    GIM_Try, /*On fail goto*//*Label 33331*/ GIMT_Encode4(2512324), // Rule ID 44466 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44466,
      GIR_EraseRootFromParent_Done,
    // Label 33331: @2512324
    GIM_Try, /*On fail goto*//*Label 33332*/ GIMT_Encode4(2512361), // Rule ID 44467 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44467,
      GIR_EraseRootFromParent_Done,
    // Label 33332: @2512361
    GIM_Reject,
    // Label 33324: @2512362
    GIM_Try, /*On fail goto*//*Label 33333*/ GIMT_Encode4(2512399), // Rule ID 44498 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44498,
      GIR_EraseRootFromParent_Done,
    // Label 33333: @2512399
    GIM_Try, /*On fail goto*//*Label 33334*/ GIMT_Encode4(2512436), // Rule ID 44499 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44499,
      GIR_EraseRootFromParent_Done,
    // Label 33334: @2512436
    GIM_Reject,
    // Label 33325: @2512437
    GIM_Try, /*On fail goto*//*Label 33335*/ GIMT_Encode4(2512474), // Rule ID 44530 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44530,
      GIR_EraseRootFromParent_Done,
    // Label 33335: @2512474
    GIM_Try, /*On fail goto*//*Label 33336*/ GIMT_Encode4(2512511), // Rule ID 44531 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44531,
      GIR_EraseRootFromParent_Done,
    // Label 33336: @2512511
    GIM_Reject,
    // Label 33326: @2512512
    GIM_Try, /*On fail goto*//*Label 33337*/ GIMT_Encode4(2512549), // Rule ID 44562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44562,
      GIR_EraseRootFromParent_Done,
    // Label 33337: @2512549
    GIM_Try, /*On fail goto*//*Label 33338*/ GIMT_Encode4(2512586), // Rule ID 44563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44563,
      GIR_EraseRootFromParent_Done,
    // Label 33338: @2512586
    GIM_Reject,
    // Label 33327: @2512587
    GIM_Try, /*On fail goto*//*Label 33339*/ GIMT_Encode4(2512624), // Rule ID 44594 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44594,
      GIR_EraseRootFromParent_Done,
    // Label 33339: @2512624
    GIM_Try, /*On fail goto*//*Label 33340*/ GIMT_Encode4(2512661), // Rule ID 44595 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44595,
      GIR_EraseRootFromParent_Done,
    // Label 33340: @2512661
    GIM_Reject,
    // Label 33328: @2512662
    GIM_Try, /*On fail goto*//*Label 33341*/ GIMT_Encode4(2512699), // Rule ID 44626 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44626,
      GIR_EraseRootFromParent_Done,
    // Label 33341: @2512699
    GIM_Try, /*On fail goto*//*Label 33342*/ GIMT_Encode4(2512736), // Rule ID 44627 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44627,
      GIR_EraseRootFromParent_Done,
    // Label 33342: @2512736
    GIM_Reject,
    // Label 33329: @2512737
    GIM_Try, /*On fail goto*//*Label 33343*/ GIMT_Encode4(2512774), // Rule ID 44658 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44658,
      GIR_EraseRootFromParent_Done,
    // Label 33343: @2512774
    GIM_Try, /*On fail goto*//*Label 33344*/ GIMT_Encode4(2512811), // Rule ID 44659 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
      // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 44659,
      GIR_EraseRootFromParent_Done,
    // Label 33344: @2512811
    GIM_Reject,
    // Label 33330: @2512812
    GIM_Reject,
    // Label 118: @2512813
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 33367*/ GIMT_Encode4(2517070),
    /*GILLT_nxv1s8*//*Label 33345*/ GIMT_Encode4(2512936),
    /*GILLT_nxv1s16*//*Label 33346*/ GIMT_Encode4(2513053),
    /*GILLT_nxv1s32*//*Label 33347*/ GIMT_Encode4(2513274),
    /*GILLT_nxv1s64*//*Label 33348*/ GIMT_Encode4(2513495), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 33349*/ GIMT_Encode4(2513716),
    /*GILLT_nxv2s16*//*Label 33350*/ GIMT_Encode4(2513833),
    /*GILLT_nxv2s32*//*Label 33351*/ GIMT_Encode4(2514054),
    /*GILLT_nxv2s64*//*Label 33352*/ GIMT_Encode4(2514275), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 33353*/ GIMT_Encode4(2514496),
    /*GILLT_nxv4s16*//*Label 33354*/ GIMT_Encode4(2514613),
    /*GILLT_nxv4s32*//*Label 33355*/ GIMT_Encode4(2514834),
    /*GILLT_nxv4s64*//*Label 33356*/ GIMT_Encode4(2515055), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 33357*/ GIMT_Encode4(2515276),
    /*GILLT_nxv8s16*//*Label 33358*/ GIMT_Encode4(2515393),
    /*GILLT_nxv8s32*//*Label 33359*/ GIMT_Encode4(2515614),
    /*GILLT_nxv8s64*//*Label 33360*/ GIMT_Encode4(2515835), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 33361*/ GIMT_Encode4(2516056),
    /*GILLT_nxv16s16*//*Label 33362*/ GIMT_Encode4(2516173),
    /*GILLT_nxv16s32*//*Label 33363*/ GIMT_Encode4(2516394), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 33364*/ GIMT_Encode4(2516615),
    /*GILLT_nxv32s16*//*Label 33365*/ GIMT_Encode4(2516732), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 33366*/ GIMT_Encode4(2516953),
    // Label 33345: @2512936
    GIM_Try, /*On fail goto*//*Label 33368*/ GIMT_Encode4(2513052),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_Try, /*On fail goto*//*Label 33369*/ GIMT_Encode4(2512999), // Rule ID 31988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 31988,
        GIR_EraseRootFromParent_Done,
      // Label 33369: @2512999
      GIM_Try, /*On fail goto*//*Label 33370*/ GIMT_Encode4(2513051), // Rule ID 31989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 31989,
        GIR_EraseRootFromParent_Done,
      // Label 33370: @2513051
      GIM_Reject,
    // Label 33368: @2513052
    GIM_Reject,
    // Label 33346: @2513053
    GIM_Try, /*On fail goto*//*Label 33371*/ GIMT_Encode4(2513273),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_Try, /*On fail goto*//*Label 33372*/ GIMT_Encode4(2513116), // Rule ID 32258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32258,
        GIR_EraseRootFromParent_Done,
      // Label 33372: @2513116
      GIM_Try, /*On fail goto*//*Label 33373*/ GIMT_Encode4(2513168), // Rule ID 32259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32259,
        GIR_EraseRootFromParent_Done,
      // Label 33373: @2513168
      GIM_Try, /*On fail goto*//*Label 33374*/ GIMT_Encode4(2513220), // Rule ID 33968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33968,
        GIR_EraseRootFromParent_Done,
      // Label 33374: @2513220
      GIM_Try, /*On fail goto*//*Label 33375*/ GIMT_Encode4(2513272), // Rule ID 33969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33969,
        GIR_EraseRootFromParent_Done,
      // Label 33375: @2513272
      GIM_Reject,
    // Label 33371: @2513273
    GIM_Reject,
    // Label 33347: @2513274
    GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2513494),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_Try, /*On fail goto*//*Label 33377*/ GIMT_Encode4(2513337), // Rule ID 32438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32438,
        GIR_EraseRootFromParent_Done,
      // Label 33377: @2513337
      GIM_Try, /*On fail goto*//*Label 33378*/ GIMT_Encode4(2513389), // Rule ID 32439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32439,
        GIR_EraseRootFromParent_Done,
      // Label 33378: @2513389
      GIM_Try, /*On fail goto*//*Label 33379*/ GIMT_Encode4(2513441), // Rule ID 34148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34148,
        GIR_EraseRootFromParent_Done,
      // Label 33379: @2513441
      GIM_Try, /*On fail goto*//*Label 33380*/ GIMT_Encode4(2513493), // Rule ID 34149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34149,
        GIR_EraseRootFromParent_Done,
      // Label 33380: @2513493
      GIM_Reject,
    // Label 33376: @2513494
    GIM_Reject,
    // Label 33348: @2513495
    GIM_Try, /*On fail goto*//*Label 33381*/ GIMT_Encode4(2513715),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_Try, /*On fail goto*//*Label 33382*/ GIMT_Encode4(2513558), // Rule ID 32798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32798,
        GIR_EraseRootFromParent_Done,
      // Label 33382: @2513558
      GIM_Try, /*On fail goto*//*Label 33383*/ GIMT_Encode4(2513610), // Rule ID 32799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32799,
        GIR_EraseRootFromParent_Done,
      // Label 33383: @2513610
      GIM_Try, /*On fail goto*//*Label 33384*/ GIMT_Encode4(2513662), // Rule ID 34418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34418,
        GIR_EraseRootFromParent_Done,
      // Label 33384: @2513662
      GIM_Try, /*On fail goto*//*Label 33385*/ GIMT_Encode4(2513714), // Rule ID 34419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34419,
        GIR_EraseRootFromParent_Done,
      // Label 33385: @2513714
      GIM_Reject,
    // Label 33381: @2513715
    GIM_Reject,
    // Label 33349: @2513716
    GIM_Try, /*On fail goto*//*Label 33386*/ GIMT_Encode4(2513832),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_Try, /*On fail goto*//*Label 33387*/ GIMT_Encode4(2513779), // Rule ID 32078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32078,
        GIR_EraseRootFromParent_Done,
      // Label 33387: @2513779
      GIM_Try, /*On fail goto*//*Label 33388*/ GIMT_Encode4(2513831), // Rule ID 32079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32079,
        GIR_EraseRootFromParent_Done,
      // Label 33388: @2513831
      GIM_Reject,
    // Label 33386: @2513832
    GIM_Reject,
    // Label 33350: @2513833
    GIM_Try, /*On fail goto*//*Label 33389*/ GIMT_Encode4(2514053),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_Try, /*On fail goto*//*Label 33390*/ GIMT_Encode4(2513896), // Rule ID 32348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32348,
        GIR_EraseRootFromParent_Done,
      // Label 33390: @2513896
      GIM_Try, /*On fail goto*//*Label 33391*/ GIMT_Encode4(2513948), // Rule ID 32349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32349,
        GIR_EraseRootFromParent_Done,
      // Label 33391: @2513948
      GIM_Try, /*On fail goto*//*Label 33392*/ GIMT_Encode4(2514000), // Rule ID 34058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34058,
        GIR_EraseRootFromParent_Done,
      // Label 33392: @2514000
      GIM_Try, /*On fail goto*//*Label 33393*/ GIMT_Encode4(2514052), // Rule ID 34059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34059,
        GIR_EraseRootFromParent_Done,
      // Label 33393: @2514052
      GIM_Reject,
    // Label 33389: @2514053
    GIM_Reject,
    // Label 33351: @2514054
    GIM_Try, /*On fail goto*//*Label 33394*/ GIMT_Encode4(2514274),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_Try, /*On fail goto*//*Label 33395*/ GIMT_Encode4(2514117), // Rule ID 32708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32708,
        GIR_EraseRootFromParent_Done,
      // Label 33395: @2514117
      GIM_Try, /*On fail goto*//*Label 33396*/ GIMT_Encode4(2514169), // Rule ID 32709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32709,
        GIR_EraseRootFromParent_Done,
      // Label 33396: @2514169
      GIM_Try, /*On fail goto*//*Label 33397*/ GIMT_Encode4(2514221), // Rule ID 34328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34328,
        GIR_EraseRootFromParent_Done,
      // Label 33397: @2514221
      GIM_Try, /*On fail goto*//*Label 33398*/ GIMT_Encode4(2514273), // Rule ID 34329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34329,
        GIR_EraseRootFromParent_Done,
      // Label 33398: @2514273
      GIM_Reject,
    // Label 33394: @2514274
    GIM_Reject,
    // Label 33352: @2514275
    GIM_Try, /*On fail goto*//*Label 33399*/ GIMT_Encode4(2514495),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_Try, /*On fail goto*//*Label 33400*/ GIMT_Encode4(2514338), // Rule ID 33698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33698,
        GIR_EraseRootFromParent_Done,
      // Label 33400: @2514338
      GIM_Try, /*On fail goto*//*Label 33401*/ GIMT_Encode4(2514390), // Rule ID 33699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33699,
        GIR_EraseRootFromParent_Done,
      // Label 33401: @2514390
      GIM_Try, /*On fail goto*//*Label 33402*/ GIMT_Encode4(2514442), // Rule ID 35048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35048,
        GIR_EraseRootFromParent_Done,
      // Label 33402: @2514442
      GIM_Try, /*On fail goto*//*Label 33403*/ GIMT_Encode4(2514494), // Rule ID 35049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35049,
        GIR_EraseRootFromParent_Done,
      // Label 33403: @2514494
      GIM_Reject,
    // Label 33399: @2514495
    GIM_Reject,
    // Label 33353: @2514496
    GIM_Try, /*On fail goto*//*Label 33404*/ GIMT_Encode4(2514612),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_Try, /*On fail goto*//*Label 33405*/ GIMT_Encode4(2514559), // Rule ID 32168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32168,
        GIR_EraseRootFromParent_Done,
      // Label 33405: @2514559
      GIM_Try, /*On fail goto*//*Label 33406*/ GIMT_Encode4(2514611), // Rule ID 32169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32169,
        GIR_EraseRootFromParent_Done,
      // Label 33406: @2514611
      GIM_Reject,
    // Label 33404: @2514612
    GIM_Reject,
    // Label 33354: @2514613
    GIM_Try, /*On fail goto*//*Label 33407*/ GIMT_Encode4(2514833),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_Try, /*On fail goto*//*Label 33408*/ GIMT_Encode4(2514676), // Rule ID 32618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32618,
        GIR_EraseRootFromParent_Done,
      // Label 33408: @2514676
      GIM_Try, /*On fail goto*//*Label 33409*/ GIMT_Encode4(2514728), // Rule ID 32619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32619,
        GIR_EraseRootFromParent_Done,
      // Label 33409: @2514728
      GIM_Try, /*On fail goto*//*Label 33410*/ GIMT_Encode4(2514780), // Rule ID 34238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34238,
        GIR_EraseRootFromParent_Done,
      // Label 33410: @2514780
      GIM_Try, /*On fail goto*//*Label 33411*/ GIMT_Encode4(2514832), // Rule ID 34239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34239,
        GIR_EraseRootFromParent_Done,
      // Label 33411: @2514832
      GIM_Reject,
    // Label 33407: @2514833
    GIM_Reject,
    // Label 33355: @2514834
    GIM_Try, /*On fail goto*//*Label 33412*/ GIMT_Encode4(2515054),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_Try, /*On fail goto*//*Label 33413*/ GIMT_Encode4(2514897), // Rule ID 33428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33428,
        GIR_EraseRootFromParent_Done,
      // Label 33413: @2514897
      GIM_Try, /*On fail goto*//*Label 33414*/ GIMT_Encode4(2514949), // Rule ID 33429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33429,
        GIR_EraseRootFromParent_Done,
      // Label 33414: @2514949
      GIM_Try, /*On fail goto*//*Label 33415*/ GIMT_Encode4(2515001), // Rule ID 34778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34778,
        GIR_EraseRootFromParent_Done,
      // Label 33415: @2515001
      GIM_Try, /*On fail goto*//*Label 33416*/ GIMT_Encode4(2515053), // Rule ID 34779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34779,
        GIR_EraseRootFromParent_Done,
      // Label 33416: @2515053
      GIM_Reject,
    // Label 33412: @2515054
    GIM_Reject,
    // Label 33356: @2515055
    GIM_Try, /*On fail goto*//*Label 33417*/ GIMT_Encode4(2515275),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_Try, /*On fail goto*//*Label 33418*/ GIMT_Encode4(2515118), // Rule ID 33788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33788,
        GIR_EraseRootFromParent_Done,
      // Label 33418: @2515118
      GIM_Try, /*On fail goto*//*Label 33419*/ GIMT_Encode4(2515170), // Rule ID 33789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33789,
        GIR_EraseRootFromParent_Done,
      // Label 33419: @2515170
      GIM_Try, /*On fail goto*//*Label 33420*/ GIMT_Encode4(2515222), // Rule ID 35138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35138,
        GIR_EraseRootFromParent_Done,
      // Label 33420: @2515222
      GIM_Try, /*On fail goto*//*Label 33421*/ GIMT_Encode4(2515274), // Rule ID 35139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35139,
        GIR_EraseRootFromParent_Done,
      // Label 33421: @2515274
      GIM_Reject,
    // Label 33417: @2515275
    GIM_Reject,
    // Label 33357: @2515276
    GIM_Try, /*On fail goto*//*Label 33422*/ GIMT_Encode4(2515392),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_Try, /*On fail goto*//*Label 33423*/ GIMT_Encode4(2515339), // Rule ID 32528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32528,
        GIR_EraseRootFromParent_Done,
      // Label 33423: @2515339
      GIM_Try, /*On fail goto*//*Label 33424*/ GIMT_Encode4(2515391), // Rule ID 32529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32529,
        GIR_EraseRootFromParent_Done,
      // Label 33424: @2515391
      GIM_Reject,
    // Label 33422: @2515392
    GIM_Reject,
    // Label 33358: @2515393
    GIM_Try, /*On fail goto*//*Label 33425*/ GIMT_Encode4(2515613),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_Try, /*On fail goto*//*Label 33426*/ GIMT_Encode4(2515456), // Rule ID 33158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33158,
        GIR_EraseRootFromParent_Done,
      // Label 33426: @2515456
      GIM_Try, /*On fail goto*//*Label 33427*/ GIMT_Encode4(2515508), // Rule ID 33159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33159,
        GIR_EraseRootFromParent_Done,
      // Label 33427: @2515508
      GIM_Try, /*On fail goto*//*Label 33428*/ GIMT_Encode4(2515560), // Rule ID 34508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34508,
        GIR_EraseRootFromParent_Done,
      // Label 33428: @2515560
      GIM_Try, /*On fail goto*//*Label 33429*/ GIMT_Encode4(2515612), // Rule ID 34509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34509,
        GIR_EraseRootFromParent_Done,
      // Label 33429: @2515612
      GIM_Reject,
    // Label 33425: @2515613
    GIM_Reject,
    // Label 33359: @2515614
    GIM_Try, /*On fail goto*//*Label 33430*/ GIMT_Encode4(2515834),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_Try, /*On fail goto*//*Label 33431*/ GIMT_Encode4(2515677), // Rule ID 33518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33518,
        GIR_EraseRootFromParent_Done,
      // Label 33431: @2515677
      GIM_Try, /*On fail goto*//*Label 33432*/ GIMT_Encode4(2515729), // Rule ID 33519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33519,
        GIR_EraseRootFromParent_Done,
      // Label 33432: @2515729
      GIM_Try, /*On fail goto*//*Label 33433*/ GIMT_Encode4(2515781), // Rule ID 34868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34868,
        GIR_EraseRootFromParent_Done,
      // Label 33433: @2515781
      GIM_Try, /*On fail goto*//*Label 33434*/ GIMT_Encode4(2515833), // Rule ID 34869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34869,
        GIR_EraseRootFromParent_Done,
      // Label 33434: @2515833
      GIM_Reject,
    // Label 33430: @2515834
    GIM_Reject,
    // Label 33360: @2515835
    GIM_Try, /*On fail goto*//*Label 33435*/ GIMT_Encode4(2516055),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_Try, /*On fail goto*//*Label 33436*/ GIMT_Encode4(2515898), // Rule ID 33878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33878,
        GIR_EraseRootFromParent_Done,
      // Label 33436: @2515898
      GIM_Try, /*On fail goto*//*Label 33437*/ GIMT_Encode4(2515950), // Rule ID 33879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33879,
        GIR_EraseRootFromParent_Done,
      // Label 33437: @2515950
      GIM_Try, /*On fail goto*//*Label 33438*/ GIMT_Encode4(2516002), // Rule ID 35228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35228,
        GIR_EraseRootFromParent_Done,
      // Label 33438: @2516002
      GIM_Try, /*On fail goto*//*Label 33439*/ GIMT_Encode4(2516054), // Rule ID 35229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35229,
        GIR_EraseRootFromParent_Done,
      // Label 33439: @2516054
      GIM_Reject,
    // Label 33435: @2516055
    GIM_Reject,
    // Label 33361: @2516056
    GIM_Try, /*On fail goto*//*Label 33440*/ GIMT_Encode4(2516172),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_Try, /*On fail goto*//*Label 33441*/ GIMT_Encode4(2516119), // Rule ID 32888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32888,
        GIR_EraseRootFromParent_Done,
      // Label 33441: @2516119
      GIM_Try, /*On fail goto*//*Label 33442*/ GIMT_Encode4(2516171), // Rule ID 32889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32889,
        GIR_EraseRootFromParent_Done,
      // Label 33442: @2516171
      GIM_Reject,
    // Label 33440: @2516172
    GIM_Reject,
    // Label 33362: @2516173
    GIM_Try, /*On fail goto*//*Label 33443*/ GIMT_Encode4(2516393),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_Try, /*On fail goto*//*Label 33444*/ GIMT_Encode4(2516236), // Rule ID 33248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33248,
        GIR_EraseRootFromParent_Done,
      // Label 33444: @2516236
      GIM_Try, /*On fail goto*//*Label 33445*/ GIMT_Encode4(2516288), // Rule ID 33249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33249,
        GIR_EraseRootFromParent_Done,
      // Label 33445: @2516288
      GIM_Try, /*On fail goto*//*Label 33446*/ GIMT_Encode4(2516340), // Rule ID 34598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34598,
        GIR_EraseRootFromParent_Done,
      // Label 33446: @2516340
      GIM_Try, /*On fail goto*//*Label 33447*/ GIMT_Encode4(2516392), // Rule ID 34599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34599,
        GIR_EraseRootFromParent_Done,
      // Label 33447: @2516392
      GIM_Reject,
    // Label 33443: @2516393
    GIM_Reject,
    // Label 33363: @2516394
    GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2516614),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2516457), // Rule ID 33608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33608,
        GIR_EraseRootFromParent_Done,
      // Label 33449: @2516457
      GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2516509), // Rule ID 33609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33609,
        GIR_EraseRootFromParent_Done,
      // Label 33450: @2516509
      GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2516561), // Rule ID 34958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34958,
        GIR_EraseRootFromParent_Done,
      // Label 33451: @2516561
      GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2516613), // Rule ID 34959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34959,
        GIR_EraseRootFromParent_Done,
      // Label 33452: @2516613
      GIM_Reject,
    // Label 33448: @2516614
    GIM_Reject,
    // Label 33364: @2516615
    GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2516731),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2516678), // Rule ID 32978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32978,
        GIR_EraseRootFromParent_Done,
      // Label 33454: @2516678
      GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2516730), // Rule ID 32979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32979,
        GIR_EraseRootFromParent_Done,
      // Label 33455: @2516730
      GIM_Reject,
    // Label 33453: @2516731
    GIM_Reject,
    // Label 33365: @2516732
    GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2516952),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2516795), // Rule ID 33338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33338,
        GIR_EraseRootFromParent_Done,
      // Label 33457: @2516795
      GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2516847), // Rule ID 33339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33339,
        GIR_EraseRootFromParent_Done,
      // Label 33458: @2516847
      GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2516899), // Rule ID 34688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34688,
        GIR_EraseRootFromParent_Done,
      // Label 33459: @2516899
      GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2516951), // Rule ID 34689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34689,
        GIR_EraseRootFromParent_Done,
      // Label 33460: @2516951
      GIM_Reject,
    // Label 33456: @2516952
    GIM_Reject,
    // Label 33366: @2516953
    GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2517069),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2517016), // Rule ID 33068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33068,
        GIR_EraseRootFromParent_Done,
      // Label 33462: @2517016
      GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2517068), // Rule ID 33069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // passthru
        GIR_RootToRootCopy, /*OpIdx*/2, // rs2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33069,
        GIR_EraseRootFromParent_Done,
      // Label 33463: @2517068
      GIM_Reject,
    // Label 33461: @2517069
    GIM_Reject,
    // Label 33367: @2517070
    GIM_Reject,
    // Label 119: @2517071
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 33486*/ GIMT_Encode4(2531614),
    /*GILLT_nxv1s8*//*Label 33464*/ GIMT_Encode4(2517194),
    /*GILLT_nxv1s16*//*Label 33465*/ GIMT_Encode4(2517589),
    /*GILLT_nxv1s32*//*Label 33466*/ GIMT_Encode4(2518366),
    /*GILLT_nxv1s64*//*Label 33467*/ GIMT_Encode4(2519143), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 33468*/ GIMT_Encode4(2519920),
    /*GILLT_nxv2s16*//*Label 33469*/ GIMT_Encode4(2520315),
    /*GILLT_nxv2s32*//*Label 33470*/ GIMT_Encode4(2521092),
    /*GILLT_nxv2s64*//*Label 33471*/ GIMT_Encode4(2521869), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 33472*/ GIMT_Encode4(2522646),
    /*GILLT_nxv4s16*//*Label 33473*/ GIMT_Encode4(2523041),
    /*GILLT_nxv4s32*//*Label 33474*/ GIMT_Encode4(2523818),
    /*GILLT_nxv4s64*//*Label 33475*/ GIMT_Encode4(2524595), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 33476*/ GIMT_Encode4(2525372),
    /*GILLT_nxv8s16*//*Label 33477*/ GIMT_Encode4(2525767),
    /*GILLT_nxv8s32*//*Label 33478*/ GIMT_Encode4(2526544),
    /*GILLT_nxv8s64*//*Label 33479*/ GIMT_Encode4(2527321), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 33480*/ GIMT_Encode4(2528098),
    /*GILLT_nxv16s16*//*Label 33481*/ GIMT_Encode4(2528493),
    /*GILLT_nxv16s32*//*Label 33482*/ GIMT_Encode4(2529270), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 33483*/ GIMT_Encode4(2530047),
    /*GILLT_nxv32s16*//*Label 33484*/ GIMT_Encode4(2530442), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 33485*/ GIMT_Encode4(2531219),
    // Label 33464: @2517194
    GIM_Try, /*On fail goto*//*Label 33487*/ GIMT_Encode4(2517588),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_Try, /*On fail goto*//*Label 33488*/ GIMT_Encode4(2517306), // Rule ID 45228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45228,
        GIR_EraseRootFromParent_Done,
      // Label 33488: @2517306
      GIM_Try, /*On fail goto*//*Label 33489*/ GIMT_Encode4(2517407), // Rule ID 45229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45229,
        GIR_EraseRootFromParent_Done,
      // Label 33489: @2517407
      GIM_Try, /*On fail goto*//*Label 33490*/ GIMT_Encode4(2517497), // Rule ID 45230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45230,
        GIR_EraseRootFromParent_Done,
      // Label 33490: @2517497
      GIM_Try, /*On fail goto*//*Label 33491*/ GIMT_Encode4(2517587), // Rule ID 45231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45231,
        GIR_EraseRootFromParent_Done,
      // Label 33491: @2517587
      GIM_Reject,
    // Label 33487: @2517588
    GIM_Reject,
    // Label 33465: @2517589
    GIM_Try, /*On fail goto*//*Label 33492*/ GIMT_Encode4(2518365),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_Try, /*On fail goto*//*Label 33493*/ GIMT_Encode4(2517701), // Rule ID 45240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45240,
        GIR_EraseRootFromParent_Done,
      // Label 33493: @2517701
      GIM_Try, /*On fail goto*//*Label 33494*/ GIMT_Encode4(2517802), // Rule ID 45241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45241,
        GIR_EraseRootFromParent_Done,
      // Label 33494: @2517802
      GIM_Try, /*On fail goto*//*Label 33495*/ GIMT_Encode4(2517903), // Rule ID 45316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45316,
        GIR_EraseRootFromParent_Done,
      // Label 33495: @2517903
      GIM_Try, /*On fail goto*//*Label 33496*/ GIMT_Encode4(2518004), // Rule ID 45317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45317,
        GIR_EraseRootFromParent_Done,
      // Label 33496: @2518004
      GIM_Try, /*On fail goto*//*Label 33497*/ GIMT_Encode4(2518094), // Rule ID 45242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45242,
        GIR_EraseRootFromParent_Done,
      // Label 33497: @2518094
      GIM_Try, /*On fail goto*//*Label 33498*/ GIMT_Encode4(2518184), // Rule ID 45243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45243,
        GIR_EraseRootFromParent_Done,
      // Label 33498: @2518184
      GIM_Try, /*On fail goto*//*Label 33499*/ GIMT_Encode4(2518274), // Rule ID 45318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45318,
        GIR_EraseRootFromParent_Done,
      // Label 33499: @2518274
      GIM_Try, /*On fail goto*//*Label 33500*/ GIMT_Encode4(2518364), // Rule ID 45319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45319,
        GIR_EraseRootFromParent_Done,
      // Label 33500: @2518364
      GIM_Reject,
    // Label 33492: @2518365
    GIM_Reject,
    // Label 33466: @2518366
    GIM_Try, /*On fail goto*//*Label 33501*/ GIMT_Encode4(2519142),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_Try, /*On fail goto*//*Label 33502*/ GIMT_Encode4(2518478), // Rule ID 45248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45248,
        GIR_EraseRootFromParent_Done,
      // Label 33502: @2518478
      GIM_Try, /*On fail goto*//*Label 33503*/ GIMT_Encode4(2518579), // Rule ID 45249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45249,
        GIR_EraseRootFromParent_Done,
      // Label 33503: @2518579
      GIM_Try, /*On fail goto*//*Label 33504*/ GIMT_Encode4(2518680), // Rule ID 45324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45324,
        GIR_EraseRootFromParent_Done,
      // Label 33504: @2518680
      GIM_Try, /*On fail goto*//*Label 33505*/ GIMT_Encode4(2518781), // Rule ID 45325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45325,
        GIR_EraseRootFromParent_Done,
      // Label 33505: @2518781
      GIM_Try, /*On fail goto*//*Label 33506*/ GIMT_Encode4(2518871), // Rule ID 45250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45250,
        GIR_EraseRootFromParent_Done,
      // Label 33506: @2518871
      GIM_Try, /*On fail goto*//*Label 33507*/ GIMT_Encode4(2518961), // Rule ID 45251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45251,
        GIR_EraseRootFromParent_Done,
      // Label 33507: @2518961
      GIM_Try, /*On fail goto*//*Label 33508*/ GIMT_Encode4(2519051), // Rule ID 45326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45326,
        GIR_EraseRootFromParent_Done,
      // Label 33508: @2519051
      GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2519141), // Rule ID 45327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45327,
        GIR_EraseRootFromParent_Done,
      // Label 33509: @2519141
      GIM_Reject,
    // Label 33501: @2519142
    GIM_Reject,
    // Label 33467: @2519143
    GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2519919),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_Try, /*On fail goto*//*Label 33511*/ GIMT_Encode4(2519255), // Rule ID 45264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45264,
        GIR_EraseRootFromParent_Done,
      // Label 33511: @2519255
      GIM_Try, /*On fail goto*//*Label 33512*/ GIMT_Encode4(2519356), // Rule ID 45265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45265,
        GIR_EraseRootFromParent_Done,
      // Label 33512: @2519356
      GIM_Try, /*On fail goto*//*Label 33513*/ GIMT_Encode4(2519457), // Rule ID 45336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45336,
        GIR_EraseRootFromParent_Done,
      // Label 33513: @2519457
      GIM_Try, /*On fail goto*//*Label 33514*/ GIMT_Encode4(2519558), // Rule ID 45337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45337,
        GIR_EraseRootFromParent_Done,
      // Label 33514: @2519558
      GIM_Try, /*On fail goto*//*Label 33515*/ GIMT_Encode4(2519648), // Rule ID 45266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45266,
        GIR_EraseRootFromParent_Done,
      // Label 33515: @2519648
      GIM_Try, /*On fail goto*//*Label 33516*/ GIMT_Encode4(2519738), // Rule ID 45267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45267,
        GIR_EraseRootFromParent_Done,
      // Label 33516: @2519738
      GIM_Try, /*On fail goto*//*Label 33517*/ GIMT_Encode4(2519828), // Rule ID 45338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45338,
        GIR_EraseRootFromParent_Done,
      // Label 33517: @2519828
      GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2519918), // Rule ID 45339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45339,
        GIR_EraseRootFromParent_Done,
      // Label 33518: @2519918
      GIM_Reject,
    // Label 33510: @2519919
    GIM_Reject,
    // Label 33468: @2519920
    GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2520314),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2520032), // Rule ID 45232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45232,
        GIR_EraseRootFromParent_Done,
      // Label 33520: @2520032
      GIM_Try, /*On fail goto*//*Label 33521*/ GIMT_Encode4(2520133), // Rule ID 45233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45233,
        GIR_EraseRootFromParent_Done,
      // Label 33521: @2520133
      GIM_Try, /*On fail goto*//*Label 33522*/ GIMT_Encode4(2520223), // Rule ID 45234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45234,
        GIR_EraseRootFromParent_Done,
      // Label 33522: @2520223
      GIM_Try, /*On fail goto*//*Label 33523*/ GIMT_Encode4(2520313), // Rule ID 45235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45235,
        GIR_EraseRootFromParent_Done,
      // Label 33523: @2520313
      GIM_Reject,
    // Label 33519: @2520314
    GIM_Reject,
    // Label 33469: @2520315
    GIM_Try, /*On fail goto*//*Label 33524*/ GIMT_Encode4(2521091),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_Try, /*On fail goto*//*Label 33525*/ GIMT_Encode4(2520427), // Rule ID 45244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45244,
        GIR_EraseRootFromParent_Done,
      // Label 33525: @2520427
      GIM_Try, /*On fail goto*//*Label 33526*/ GIMT_Encode4(2520528), // Rule ID 45245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45245,
        GIR_EraseRootFromParent_Done,
      // Label 33526: @2520528
      GIM_Try, /*On fail goto*//*Label 33527*/ GIMT_Encode4(2520629), // Rule ID 45320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45320,
        GIR_EraseRootFromParent_Done,
      // Label 33527: @2520629
      GIM_Try, /*On fail goto*//*Label 33528*/ GIMT_Encode4(2520730), // Rule ID 45321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45321,
        GIR_EraseRootFromParent_Done,
      // Label 33528: @2520730
      GIM_Try, /*On fail goto*//*Label 33529*/ GIMT_Encode4(2520820), // Rule ID 45246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45246,
        GIR_EraseRootFromParent_Done,
      // Label 33529: @2520820
      GIM_Try, /*On fail goto*//*Label 33530*/ GIMT_Encode4(2520910), // Rule ID 45247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45247,
        GIR_EraseRootFromParent_Done,
      // Label 33530: @2520910
      GIM_Try, /*On fail goto*//*Label 33531*/ GIMT_Encode4(2521000), // Rule ID 45322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45322,
        GIR_EraseRootFromParent_Done,
      // Label 33531: @2521000
      GIM_Try, /*On fail goto*//*Label 33532*/ GIMT_Encode4(2521090), // Rule ID 45323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45323,
        GIR_EraseRootFromParent_Done,
      // Label 33532: @2521090
      GIM_Reject,
    // Label 33524: @2521091
    GIM_Reject,
    // Label 33470: @2521092
    GIM_Try, /*On fail goto*//*Label 33533*/ GIMT_Encode4(2521868),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_Try, /*On fail goto*//*Label 33534*/ GIMT_Encode4(2521204), // Rule ID 45260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45260,
        GIR_EraseRootFromParent_Done,
      // Label 33534: @2521204
      GIM_Try, /*On fail goto*//*Label 33535*/ GIMT_Encode4(2521305), // Rule ID 45261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45261,
        GIR_EraseRootFromParent_Done,
      // Label 33535: @2521305
      GIM_Try, /*On fail goto*//*Label 33536*/ GIMT_Encode4(2521406), // Rule ID 45332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45332,
        GIR_EraseRootFromParent_Done,
      // Label 33536: @2521406
      GIM_Try, /*On fail goto*//*Label 33537*/ GIMT_Encode4(2521507), // Rule ID 45333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45333,
        GIR_EraseRootFromParent_Done,
      // Label 33537: @2521507
      GIM_Try, /*On fail goto*//*Label 33538*/ GIMT_Encode4(2521597), // Rule ID 45262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45262,
        GIR_EraseRootFromParent_Done,
      // Label 33538: @2521597
      GIM_Try, /*On fail goto*//*Label 33539*/ GIMT_Encode4(2521687), // Rule ID 45263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45263,
        GIR_EraseRootFromParent_Done,
      // Label 33539: @2521687
      GIM_Try, /*On fail goto*//*Label 33540*/ GIMT_Encode4(2521777), // Rule ID 45334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45334,
        GIR_EraseRootFromParent_Done,
      // Label 33540: @2521777
      GIM_Try, /*On fail goto*//*Label 33541*/ GIMT_Encode4(2521867), // Rule ID 45335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45335,
        GIR_EraseRootFromParent_Done,
      // Label 33541: @2521867
      GIM_Reject,
    // Label 33533: @2521868
    GIM_Reject,
    // Label 33471: @2521869
    GIM_Try, /*On fail goto*//*Label 33542*/ GIMT_Encode4(2522645),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_Try, /*On fail goto*//*Label 33543*/ GIMT_Encode4(2521981), // Rule ID 45304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45304,
        GIR_EraseRootFromParent_Done,
      // Label 33543: @2521981
      GIM_Try, /*On fail goto*//*Label 33544*/ GIMT_Encode4(2522082), // Rule ID 45305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45305,
        GIR_EraseRootFromParent_Done,
      // Label 33544: @2522082
      GIM_Try, /*On fail goto*//*Label 33545*/ GIMT_Encode4(2522183), // Rule ID 45364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45364,
        GIR_EraseRootFromParent_Done,
      // Label 33545: @2522183
      GIM_Try, /*On fail goto*//*Label 33546*/ GIMT_Encode4(2522284), // Rule ID 45365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45365,
        GIR_EraseRootFromParent_Done,
      // Label 33546: @2522284
      GIM_Try, /*On fail goto*//*Label 33547*/ GIMT_Encode4(2522374), // Rule ID 45306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45306,
        GIR_EraseRootFromParent_Done,
      // Label 33547: @2522374
      GIM_Try, /*On fail goto*//*Label 33548*/ GIMT_Encode4(2522464), // Rule ID 45307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45307,
        GIR_EraseRootFromParent_Done,
      // Label 33548: @2522464
      GIM_Try, /*On fail goto*//*Label 33549*/ GIMT_Encode4(2522554), // Rule ID 45366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45366,
        GIR_EraseRootFromParent_Done,
      // Label 33549: @2522554
      GIM_Try, /*On fail goto*//*Label 33550*/ GIMT_Encode4(2522644), // Rule ID 45367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45367,
        GIR_EraseRootFromParent_Done,
      // Label 33550: @2522644
      GIM_Reject,
    // Label 33542: @2522645
    GIM_Reject,
    // Label 33472: @2522646
    GIM_Try, /*On fail goto*//*Label 33551*/ GIMT_Encode4(2523040),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_Try, /*On fail goto*//*Label 33552*/ GIMT_Encode4(2522758), // Rule ID 45236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45236,
        GIR_EraseRootFromParent_Done,
      // Label 33552: @2522758
      GIM_Try, /*On fail goto*//*Label 33553*/ GIMT_Encode4(2522859), // Rule ID 45237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45237,
        GIR_EraseRootFromParent_Done,
      // Label 33553: @2522859
      GIM_Try, /*On fail goto*//*Label 33554*/ GIMT_Encode4(2522949), // Rule ID 45238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45238,
        GIR_EraseRootFromParent_Done,
      // Label 33554: @2522949
      GIM_Try, /*On fail goto*//*Label 33555*/ GIMT_Encode4(2523039), // Rule ID 45239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45239,
        GIR_EraseRootFromParent_Done,
      // Label 33555: @2523039
      GIM_Reject,
    // Label 33551: @2523040
    GIM_Reject,
    // Label 33473: @2523041
    GIM_Try, /*On fail goto*//*Label 33556*/ GIMT_Encode4(2523817),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_Try, /*On fail goto*//*Label 33557*/ GIMT_Encode4(2523153), // Rule ID 45256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45256,
        GIR_EraseRootFromParent_Done,
      // Label 33557: @2523153
      GIM_Try, /*On fail goto*//*Label 33558*/ GIMT_Encode4(2523254), // Rule ID 45257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45257,
        GIR_EraseRootFromParent_Done,
      // Label 33558: @2523254
      GIM_Try, /*On fail goto*//*Label 33559*/ GIMT_Encode4(2523355), // Rule ID 45328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45328,
        GIR_EraseRootFromParent_Done,
      // Label 33559: @2523355
      GIM_Try, /*On fail goto*//*Label 33560*/ GIMT_Encode4(2523456), // Rule ID 45329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45329,
        GIR_EraseRootFromParent_Done,
      // Label 33560: @2523456
      GIM_Try, /*On fail goto*//*Label 33561*/ GIMT_Encode4(2523546), // Rule ID 45258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45258,
        GIR_EraseRootFromParent_Done,
      // Label 33561: @2523546
      GIM_Try, /*On fail goto*//*Label 33562*/ GIMT_Encode4(2523636), // Rule ID 45259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45259,
        GIR_EraseRootFromParent_Done,
      // Label 33562: @2523636
      GIM_Try, /*On fail goto*//*Label 33563*/ GIMT_Encode4(2523726), // Rule ID 45330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45330,
        GIR_EraseRootFromParent_Done,
      // Label 33563: @2523726
      GIM_Try, /*On fail goto*//*Label 33564*/ GIMT_Encode4(2523816), // Rule ID 45331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45331,
        GIR_EraseRootFromParent_Done,
      // Label 33564: @2523816
      GIM_Reject,
    // Label 33556: @2523817
    GIM_Reject,
    // Label 33474: @2523818
    GIM_Try, /*On fail goto*//*Label 33565*/ GIMT_Encode4(2524594),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_Try, /*On fail goto*//*Label 33566*/ GIMT_Encode4(2523930), // Rule ID 45292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45292,
        GIR_EraseRootFromParent_Done,
      // Label 33566: @2523930
      GIM_Try, /*On fail goto*//*Label 33567*/ GIMT_Encode4(2524031), // Rule ID 45293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45293,
        GIR_EraseRootFromParent_Done,
      // Label 33567: @2524031
      GIM_Try, /*On fail goto*//*Label 33568*/ GIMT_Encode4(2524132), // Rule ID 45352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45352,
        GIR_EraseRootFromParent_Done,
      // Label 33568: @2524132
      GIM_Try, /*On fail goto*//*Label 33569*/ GIMT_Encode4(2524233), // Rule ID 45353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45353,
        GIR_EraseRootFromParent_Done,
      // Label 33569: @2524233
      GIM_Try, /*On fail goto*//*Label 33570*/ GIMT_Encode4(2524323), // Rule ID 45294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45294,
        GIR_EraseRootFromParent_Done,
      // Label 33570: @2524323
      GIM_Try, /*On fail goto*//*Label 33571*/ GIMT_Encode4(2524413), // Rule ID 45295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45295,
        GIR_EraseRootFromParent_Done,
      // Label 33571: @2524413
      GIM_Try, /*On fail goto*//*Label 33572*/ GIMT_Encode4(2524503), // Rule ID 45354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45354,
        GIR_EraseRootFromParent_Done,
      // Label 33572: @2524503
      GIM_Try, /*On fail goto*//*Label 33573*/ GIMT_Encode4(2524593), // Rule ID 45355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45355,
        GIR_EraseRootFromParent_Done,
      // Label 33573: @2524593
      GIM_Reject,
    // Label 33565: @2524594
    GIM_Reject,
    // Label 33475: @2524595
    GIM_Try, /*On fail goto*//*Label 33574*/ GIMT_Encode4(2525371),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_Try, /*On fail goto*//*Label 33575*/ GIMT_Encode4(2524707), // Rule ID 45308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45308,
        GIR_EraseRootFromParent_Done,
      // Label 33575: @2524707
      GIM_Try, /*On fail goto*//*Label 33576*/ GIMT_Encode4(2524808), // Rule ID 45309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45309,
        GIR_EraseRootFromParent_Done,
      // Label 33576: @2524808
      GIM_Try, /*On fail goto*//*Label 33577*/ GIMT_Encode4(2524909), // Rule ID 45368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45368,
        GIR_EraseRootFromParent_Done,
      // Label 33577: @2524909
      GIM_Try, /*On fail goto*//*Label 33578*/ GIMT_Encode4(2525010), // Rule ID 45369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45369,
        GIR_EraseRootFromParent_Done,
      // Label 33578: @2525010
      GIM_Try, /*On fail goto*//*Label 33579*/ GIMT_Encode4(2525100), // Rule ID 45310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45310,
        GIR_EraseRootFromParent_Done,
      // Label 33579: @2525100
      GIM_Try, /*On fail goto*//*Label 33580*/ GIMT_Encode4(2525190), // Rule ID 45311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45311,
        GIR_EraseRootFromParent_Done,
      // Label 33580: @2525190
      GIM_Try, /*On fail goto*//*Label 33581*/ GIMT_Encode4(2525280), // Rule ID 45370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45370,
        GIR_EraseRootFromParent_Done,
      // Label 33581: @2525280
      GIM_Try, /*On fail goto*//*Label 33582*/ GIMT_Encode4(2525370), // Rule ID 45371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45371,
        GIR_EraseRootFromParent_Done,
      // Label 33582: @2525370
      GIM_Reject,
    // Label 33574: @2525371
    GIM_Reject,
    // Label 33476: @2525372
    GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2525766),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_Try, /*On fail goto*//*Label 33584*/ GIMT_Encode4(2525484), // Rule ID 45252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45252,
        GIR_EraseRootFromParent_Done,
      // Label 33584: @2525484
      GIM_Try, /*On fail goto*//*Label 33585*/ GIMT_Encode4(2525585), // Rule ID 45253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45253,
        GIR_EraseRootFromParent_Done,
      // Label 33585: @2525585
      GIM_Try, /*On fail goto*//*Label 33586*/ GIMT_Encode4(2525675), // Rule ID 45254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45254,
        GIR_EraseRootFromParent_Done,
      // Label 33586: @2525675
      GIM_Try, /*On fail goto*//*Label 33587*/ GIMT_Encode4(2525765), // Rule ID 45255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45255,
        GIR_EraseRootFromParent_Done,
      // Label 33587: @2525765
      GIM_Reject,
    // Label 33583: @2525766
    GIM_Reject,
    // Label 33477: @2525767
    GIM_Try, /*On fail goto*//*Label 33588*/ GIMT_Encode4(2526543),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_Try, /*On fail goto*//*Label 33589*/ GIMT_Encode4(2525879), // Rule ID 45280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45280,
        GIR_EraseRootFromParent_Done,
      // Label 33589: @2525879
      GIM_Try, /*On fail goto*//*Label 33590*/ GIMT_Encode4(2525980), // Rule ID 45281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45281,
        GIR_EraseRootFromParent_Done,
      // Label 33590: @2525980
      GIM_Try, /*On fail goto*//*Label 33591*/ GIMT_Encode4(2526081), // Rule ID 45340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45340,
        GIR_EraseRootFromParent_Done,
      // Label 33591: @2526081
      GIM_Try, /*On fail goto*//*Label 33592*/ GIMT_Encode4(2526182), // Rule ID 45341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45341,
        GIR_EraseRootFromParent_Done,
      // Label 33592: @2526182
      GIM_Try, /*On fail goto*//*Label 33593*/ GIMT_Encode4(2526272), // Rule ID 45282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45282,
        GIR_EraseRootFromParent_Done,
      // Label 33593: @2526272
      GIM_Try, /*On fail goto*//*Label 33594*/ GIMT_Encode4(2526362), // Rule ID 45283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45283,
        GIR_EraseRootFromParent_Done,
      // Label 33594: @2526362
      GIM_Try, /*On fail goto*//*Label 33595*/ GIMT_Encode4(2526452), // Rule ID 45342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45342,
        GIR_EraseRootFromParent_Done,
      // Label 33595: @2526452
      GIM_Try, /*On fail goto*//*Label 33596*/ GIMT_Encode4(2526542), // Rule ID 45343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45343,
        GIR_EraseRootFromParent_Done,
      // Label 33596: @2526542
      GIM_Reject,
    // Label 33588: @2526543
    GIM_Reject,
    // Label 33478: @2526544
    GIM_Try, /*On fail goto*//*Label 33597*/ GIMT_Encode4(2527320),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_Try, /*On fail goto*//*Label 33598*/ GIMT_Encode4(2526656), // Rule ID 45296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45296,
        GIR_EraseRootFromParent_Done,
      // Label 33598: @2526656
      GIM_Try, /*On fail goto*//*Label 33599*/ GIMT_Encode4(2526757), // Rule ID 45297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45297,
        GIR_EraseRootFromParent_Done,
      // Label 33599: @2526757
      GIM_Try, /*On fail goto*//*Label 33600*/ GIMT_Encode4(2526858), // Rule ID 45356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45356,
        GIR_EraseRootFromParent_Done,
      // Label 33600: @2526858
      GIM_Try, /*On fail goto*//*Label 33601*/ GIMT_Encode4(2526959), // Rule ID 45357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45357,
        GIR_EraseRootFromParent_Done,
      // Label 33601: @2526959
      GIM_Try, /*On fail goto*//*Label 33602*/ GIMT_Encode4(2527049), // Rule ID 45298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45298,
        GIR_EraseRootFromParent_Done,
      // Label 33602: @2527049
      GIM_Try, /*On fail goto*//*Label 33603*/ GIMT_Encode4(2527139), // Rule ID 45299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45299,
        GIR_EraseRootFromParent_Done,
      // Label 33603: @2527139
      GIM_Try, /*On fail goto*//*Label 33604*/ GIMT_Encode4(2527229), // Rule ID 45358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45358,
        GIR_EraseRootFromParent_Done,
      // Label 33604: @2527229
      GIM_Try, /*On fail goto*//*Label 33605*/ GIMT_Encode4(2527319), // Rule ID 45359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45359,
        GIR_EraseRootFromParent_Done,
      // Label 33605: @2527319
      GIM_Reject,
    // Label 33597: @2527320
    GIM_Reject,
    // Label 33479: @2527321
    GIM_Try, /*On fail goto*//*Label 33606*/ GIMT_Encode4(2528097),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_Try, /*On fail goto*//*Label 33607*/ GIMT_Encode4(2527433), // Rule ID 45312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45312,
        GIR_EraseRootFromParent_Done,
      // Label 33607: @2527433
      GIM_Try, /*On fail goto*//*Label 33608*/ GIMT_Encode4(2527534), // Rule ID 45313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45313,
        GIR_EraseRootFromParent_Done,
      // Label 33608: @2527534
      GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2527635), // Rule ID 45372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45372,
        GIR_EraseRootFromParent_Done,
      // Label 33609: @2527635
      GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2527736), // Rule ID 45373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45373,
        GIR_EraseRootFromParent_Done,
      // Label 33610: @2527736
      GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2527826), // Rule ID 45314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45314,
        GIR_EraseRootFromParent_Done,
      // Label 33611: @2527826
      GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2527916), // Rule ID 45315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45315,
        GIR_EraseRootFromParent_Done,
      // Label 33612: @2527916
      GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2528006), // Rule ID 45374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45374,
        GIR_EraseRootFromParent_Done,
      // Label 33613: @2528006
      GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2528096), // Rule ID 45375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45375,
        GIR_EraseRootFromParent_Done,
      // Label 33614: @2528096
      GIM_Reject,
    // Label 33606: @2528097
    GIM_Reject,
    // Label 33480: @2528098
    GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2528492),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_Try, /*On fail goto*//*Label 33616*/ GIMT_Encode4(2528210), // Rule ID 45268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45268,
        GIR_EraseRootFromParent_Done,
      // Label 33616: @2528210
      GIM_Try, /*On fail goto*//*Label 33617*/ GIMT_Encode4(2528311), // Rule ID 45269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45269,
        GIR_EraseRootFromParent_Done,
      // Label 33617: @2528311
      GIM_Try, /*On fail goto*//*Label 33618*/ GIMT_Encode4(2528401), // Rule ID 45270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45270,
        GIR_EraseRootFromParent_Done,
      // Label 33618: @2528401
      GIM_Try, /*On fail goto*//*Label 33619*/ GIMT_Encode4(2528491), // Rule ID 45271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45271,
        GIR_EraseRootFromParent_Done,
      // Label 33619: @2528491
      GIM_Reject,
    // Label 33615: @2528492
    GIM_Reject,
    // Label 33481: @2528493
    GIM_Try, /*On fail goto*//*Label 33620*/ GIMT_Encode4(2529269),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_Try, /*On fail goto*//*Label 33621*/ GIMT_Encode4(2528605), // Rule ID 45284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45284,
        GIR_EraseRootFromParent_Done,
      // Label 33621: @2528605
      GIM_Try, /*On fail goto*//*Label 33622*/ GIMT_Encode4(2528706), // Rule ID 45285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45285,
        GIR_EraseRootFromParent_Done,
      // Label 33622: @2528706
      GIM_Try, /*On fail goto*//*Label 33623*/ GIMT_Encode4(2528807), // Rule ID 45344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45344,
        GIR_EraseRootFromParent_Done,
      // Label 33623: @2528807
      GIM_Try, /*On fail goto*//*Label 33624*/ GIMT_Encode4(2528908), // Rule ID 45345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45345,
        GIR_EraseRootFromParent_Done,
      // Label 33624: @2528908
      GIM_Try, /*On fail goto*//*Label 33625*/ GIMT_Encode4(2528998), // Rule ID 45286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45286,
        GIR_EraseRootFromParent_Done,
      // Label 33625: @2528998
      GIM_Try, /*On fail goto*//*Label 33626*/ GIMT_Encode4(2529088), // Rule ID 45287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45287,
        GIR_EraseRootFromParent_Done,
      // Label 33626: @2529088
      GIM_Try, /*On fail goto*//*Label 33627*/ GIMT_Encode4(2529178), // Rule ID 45346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45346,
        GIR_EraseRootFromParent_Done,
      // Label 33627: @2529178
      GIM_Try, /*On fail goto*//*Label 33628*/ GIMT_Encode4(2529268), // Rule ID 45347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45347,
        GIR_EraseRootFromParent_Done,
      // Label 33628: @2529268
      GIM_Reject,
    // Label 33620: @2529269
    GIM_Reject,
    // Label 33482: @2529270
    GIM_Try, /*On fail goto*//*Label 33629*/ GIMT_Encode4(2530046),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_Try, /*On fail goto*//*Label 33630*/ GIMT_Encode4(2529382), // Rule ID 45300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45300,
        GIR_EraseRootFromParent_Done,
      // Label 33630: @2529382
      GIM_Try, /*On fail goto*//*Label 33631*/ GIMT_Encode4(2529483), // Rule ID 45301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45301,
        GIR_EraseRootFromParent_Done,
      // Label 33631: @2529483
      GIM_Try, /*On fail goto*//*Label 33632*/ GIMT_Encode4(2529584), // Rule ID 45360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45360,
        GIR_EraseRootFromParent_Done,
      // Label 33632: @2529584
      GIM_Try, /*On fail goto*//*Label 33633*/ GIMT_Encode4(2529685), // Rule ID 45361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45361,
        GIR_EraseRootFromParent_Done,
      // Label 33633: @2529685
      GIM_Try, /*On fail goto*//*Label 33634*/ GIMT_Encode4(2529775), // Rule ID 45302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45302,
        GIR_EraseRootFromParent_Done,
      // Label 33634: @2529775
      GIM_Try, /*On fail goto*//*Label 33635*/ GIMT_Encode4(2529865), // Rule ID 45303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45303,
        GIR_EraseRootFromParent_Done,
      // Label 33635: @2529865
      GIM_Try, /*On fail goto*//*Label 33636*/ GIMT_Encode4(2529955), // Rule ID 45362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45362,
        GIR_EraseRootFromParent_Done,
      // Label 33636: @2529955
      GIM_Try, /*On fail goto*//*Label 33637*/ GIMT_Encode4(2530045), // Rule ID 45363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45363,
        GIR_EraseRootFromParent_Done,
      // Label 33637: @2530045
      GIM_Reject,
    // Label 33629: @2530046
    GIM_Reject,
    // Label 33483: @2530047
    GIM_Try, /*On fail goto*//*Label 33638*/ GIMT_Encode4(2530441),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_Try, /*On fail goto*//*Label 33639*/ GIMT_Encode4(2530159), // Rule ID 45272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45272,
        GIR_EraseRootFromParent_Done,
      // Label 33639: @2530159
      GIM_Try, /*On fail goto*//*Label 33640*/ GIMT_Encode4(2530260), // Rule ID 45273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45273,
        GIR_EraseRootFromParent_Done,
      // Label 33640: @2530260
      GIM_Try, /*On fail goto*//*Label 33641*/ GIMT_Encode4(2530350), // Rule ID 45274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45274,
        GIR_EraseRootFromParent_Done,
      // Label 33641: @2530350
      GIM_Try, /*On fail goto*//*Label 33642*/ GIMT_Encode4(2530440), // Rule ID 45275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45275,
        GIR_EraseRootFromParent_Done,
      // Label 33642: @2530440
      GIM_Reject,
    // Label 33638: @2530441
    GIM_Reject,
    // Label 33484: @2530442
    GIM_Try, /*On fail goto*//*Label 33643*/ GIMT_Encode4(2531218),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_Try, /*On fail goto*//*Label 33644*/ GIMT_Encode4(2530554), // Rule ID 45288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45288,
        GIR_EraseRootFromParent_Done,
      // Label 33644: @2530554
      GIM_Try, /*On fail goto*//*Label 33645*/ GIMT_Encode4(2530655), // Rule ID 45289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45289,
        GIR_EraseRootFromParent_Done,
      // Label 33645: @2530655
      GIM_Try, /*On fail goto*//*Label 33646*/ GIMT_Encode4(2530756), // Rule ID 45348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45348,
        GIR_EraseRootFromParent_Done,
      // Label 33646: @2530756
      GIM_Try, /*On fail goto*//*Label 33647*/ GIMT_Encode4(2530857), // Rule ID 45349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45349,
        GIR_EraseRootFromParent_Done,
      // Label 33647: @2530857
      GIM_Try, /*On fail goto*//*Label 33648*/ GIMT_Encode4(2530947), // Rule ID 45290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45290,
        GIR_EraseRootFromParent_Done,
      // Label 33648: @2530947
      GIM_Try, /*On fail goto*//*Label 33649*/ GIMT_Encode4(2531037), // Rule ID 45291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45291,
        GIR_EraseRootFromParent_Done,
      // Label 33649: @2531037
      GIM_Try, /*On fail goto*//*Label 33650*/ GIMT_Encode4(2531127), // Rule ID 45350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45350,
        GIR_EraseRootFromParent_Done,
      // Label 33650: @2531127
      GIM_Try, /*On fail goto*//*Label 33651*/ GIMT_Encode4(2531217), // Rule ID 45351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45351,
        GIR_EraseRootFromParent_Done,
      // Label 33651: @2531217
      GIM_Reject,
    // Label 33643: @2531218
    GIM_Reject,
    // Label 33485: @2531219
    GIM_Try, /*On fail goto*//*Label 33652*/ GIMT_Encode4(2531613),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_Try, /*On fail goto*//*Label 33653*/ GIMT_Encode4(2531331), // Rule ID 45276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45276,
        GIR_EraseRootFromParent_Done,
      // Label 33653: @2531331
      GIM_Try, /*On fail goto*//*Label 33654*/ GIMT_Encode4(2531432), // Rule ID 45277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45277,
        GIR_EraseRootFromParent_Done,
      // Label 33654: @2531432
      GIM_Try, /*On fail goto*//*Label 33655*/ GIMT_Encode4(2531522), // Rule ID 45278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45278,
        GIR_EraseRootFromParent_Done,
      // Label 33655: @2531522
      GIM_Try, /*On fail goto*//*Label 33656*/ GIMT_Encode4(2531612), // Rule ID 45279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45279,
        GIR_EraseRootFromParent_Done,
      // Label 33656: @2531612
      GIM_Reject,
    // Label 33652: @2531613
    GIM_Reject,
    // Label 33486: @2531614
    GIM_Reject,
    // Label 120: @2531615
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 33679*/ GIMT_Encode4(2546158),
    /*GILLT_nxv1s8*//*Label 33657*/ GIMT_Encode4(2531738),
    /*GILLT_nxv1s16*//*Label 33658*/ GIMT_Encode4(2532133),
    /*GILLT_nxv1s32*//*Label 33659*/ GIMT_Encode4(2532910),
    /*GILLT_nxv1s64*//*Label 33660*/ GIMT_Encode4(2533687), GIMT_Encode4(0),
    /*GILLT_nxv2s8*//*Label 33661*/ GIMT_Encode4(2534464),
    /*GILLT_nxv2s16*//*Label 33662*/ GIMT_Encode4(2534859),
    /*GILLT_nxv2s32*//*Label 33663*/ GIMT_Encode4(2535636),
    /*GILLT_nxv2s64*//*Label 33664*/ GIMT_Encode4(2536413), GIMT_Encode4(0),
    /*GILLT_nxv4s8*//*Label 33665*/ GIMT_Encode4(2537190),
    /*GILLT_nxv4s16*//*Label 33666*/ GIMT_Encode4(2537585),
    /*GILLT_nxv4s32*//*Label 33667*/ GIMT_Encode4(2538362),
    /*GILLT_nxv4s64*//*Label 33668*/ GIMT_Encode4(2539139), GIMT_Encode4(0),
    /*GILLT_nxv8s8*//*Label 33669*/ GIMT_Encode4(2539916),
    /*GILLT_nxv8s16*//*Label 33670*/ GIMT_Encode4(2540311),
    /*GILLT_nxv8s32*//*Label 33671*/ GIMT_Encode4(2541088),
    /*GILLT_nxv8s64*//*Label 33672*/ GIMT_Encode4(2541865), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 33673*/ GIMT_Encode4(2542642),
    /*GILLT_nxv16s16*//*Label 33674*/ GIMT_Encode4(2543037),
    /*GILLT_nxv16s32*//*Label 33675*/ GIMT_Encode4(2543814), GIMT_Encode4(0),
    /*GILLT_nxv32s8*//*Label 33676*/ GIMT_Encode4(2544591),
    /*GILLT_nxv32s16*//*Label 33677*/ GIMT_Encode4(2544986), GIMT_Encode4(0),
    /*GILLT_nxv64s8*//*Label 33678*/ GIMT_Encode4(2545763),
    // Label 33657: @2531738
    GIM_Try, /*On fail goto*//*Label 33680*/ GIMT_Encode4(2532132),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
      GIM_Try, /*On fail goto*//*Label 33681*/ GIMT_Encode4(2531850), // Rule ID 25218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25218,
        GIR_EraseRootFromParent_Done,
      // Label 33681: @2531850
      GIM_Try, /*On fail goto*//*Label 33682*/ GIMT_Encode4(2531951), // Rule ID 25219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25219,
        GIR_EraseRootFromParent_Done,
      // Label 33682: @2531951
      GIM_Try, /*On fail goto*//*Label 33683*/ GIMT_Encode4(2532041), // Rule ID 25220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25220,
        GIR_EraseRootFromParent_Done,
      // Label 33683: @2532041
      GIM_Try, /*On fail goto*//*Label 33684*/ GIMT_Encode4(2532131), // Rule ID 25221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25221,
        GIR_EraseRootFromParent_Done,
      // Label 33684: @2532131
      GIM_Reject,
    // Label 33680: @2532132
    GIM_Reject,
    // Label 33658: @2532133
    GIM_Try, /*On fail goto*//*Label 33685*/ GIMT_Encode4(2532909),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
      GIM_Try, /*On fail goto*//*Label 33686*/ GIMT_Encode4(2532245), // Rule ID 45092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45092,
        GIR_EraseRootFromParent_Done,
      // Label 33686: @2532245
      GIM_Try, /*On fail goto*//*Label 33687*/ GIMT_Encode4(2532346), // Rule ID 45093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45093,
        GIR_EraseRootFromParent_Done,
      // Label 33687: @2532346
      GIM_Try, /*On fail goto*//*Label 33688*/ GIMT_Encode4(2532447), // Rule ID 45168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45168,
        GIR_EraseRootFromParent_Done,
      // Label 33688: @2532447
      GIM_Try, /*On fail goto*//*Label 33689*/ GIMT_Encode4(2532548), // Rule ID 45169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45169,
        GIR_EraseRootFromParent_Done,
      // Label 33689: @2532548
      GIM_Try, /*On fail goto*//*Label 33690*/ GIMT_Encode4(2532638), // Rule ID 45094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45094,
        GIR_EraseRootFromParent_Done,
      // Label 33690: @2532638
      GIM_Try, /*On fail goto*//*Label 33691*/ GIMT_Encode4(2532728), // Rule ID 45095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45095,
        GIR_EraseRootFromParent_Done,
      // Label 33691: @2532728
      GIM_Try, /*On fail goto*//*Label 33692*/ GIMT_Encode4(2532818), // Rule ID 45170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45170,
        GIR_EraseRootFromParent_Done,
      // Label 33692: @2532818
      GIM_Try, /*On fail goto*//*Label 33693*/ GIMT_Encode4(2532908), // Rule ID 45171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45171,
        GIR_EraseRootFromParent_Done,
      // Label 33693: @2532908
      GIM_Reject,
    // Label 33685: @2532909
    GIM_Reject,
    // Label 33659: @2532910
    GIM_Try, /*On fail goto*//*Label 33694*/ GIMT_Encode4(2533686),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
      GIM_Try, /*On fail goto*//*Label 33695*/ GIMT_Encode4(2533022), // Rule ID 45100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45100,
        GIR_EraseRootFromParent_Done,
      // Label 33695: @2533022
      GIM_Try, /*On fail goto*//*Label 33696*/ GIMT_Encode4(2533123), // Rule ID 45101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45101,
        GIR_EraseRootFromParent_Done,
      // Label 33696: @2533123
      GIM_Try, /*On fail goto*//*Label 33697*/ GIMT_Encode4(2533224), // Rule ID 45176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45176,
        GIR_EraseRootFromParent_Done,
      // Label 33697: @2533224
      GIM_Try, /*On fail goto*//*Label 33698*/ GIMT_Encode4(2533325), // Rule ID 45177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45177,
        GIR_EraseRootFromParent_Done,
      // Label 33698: @2533325
      GIM_Try, /*On fail goto*//*Label 33699*/ GIMT_Encode4(2533415), // Rule ID 45102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45102,
        GIR_EraseRootFromParent_Done,
      // Label 33699: @2533415
      GIM_Try, /*On fail goto*//*Label 33700*/ GIMT_Encode4(2533505), // Rule ID 45103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45103,
        GIR_EraseRootFromParent_Done,
      // Label 33700: @2533505
      GIM_Try, /*On fail goto*//*Label 33701*/ GIMT_Encode4(2533595), // Rule ID 45178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45178,
        GIR_EraseRootFromParent_Done,
      // Label 33701: @2533595
      GIM_Try, /*On fail goto*//*Label 33702*/ GIMT_Encode4(2533685), // Rule ID 45179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45179,
        GIR_EraseRootFromParent_Done,
      // Label 33702: @2533685
      GIM_Reject,
    // Label 33694: @2533686
    GIM_Reject,
    // Label 33660: @2533687
    GIM_Try, /*On fail goto*//*Label 33703*/ GIMT_Encode4(2534463),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
      GIM_Try, /*On fail goto*//*Label 33704*/ GIMT_Encode4(2533799), // Rule ID 45116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45116,
        GIR_EraseRootFromParent_Done,
      // Label 33704: @2533799
      GIM_Try, /*On fail goto*//*Label 33705*/ GIMT_Encode4(2533900), // Rule ID 45117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45117,
        GIR_EraseRootFromParent_Done,
      // Label 33705: @2533900
      GIM_Try, /*On fail goto*//*Label 33706*/ GIMT_Encode4(2534001), // Rule ID 45188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45188,
        GIR_EraseRootFromParent_Done,
      // Label 33706: @2534001
      GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2534102), // Rule ID 45189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45189,
        GIR_EraseRootFromParent_Done,
      // Label 33707: @2534102
      GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2534192), // Rule ID 45118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45118,
        GIR_EraseRootFromParent_Done,
      // Label 33708: @2534192
      GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2534282), // Rule ID 45119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45119,
        GIR_EraseRootFromParent_Done,
      // Label 33709: @2534282
      GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2534372), // Rule ID 45190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45190,
        GIR_EraseRootFromParent_Done,
      // Label 33710: @2534372
      GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2534462), // Rule ID 45191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv1i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45191,
        GIR_EraseRootFromParent_Done,
      // Label 33711: @2534462
      GIM_Reject,
    // Label 33703: @2534463
    GIM_Reject,
    // Label 33661: @2534464
    GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2534858),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
      GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2534576), // Rule ID 45084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45084,
        GIR_EraseRootFromParent_Done,
      // Label 33713: @2534576
      GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2534677), // Rule ID 45085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45085,
        GIR_EraseRootFromParent_Done,
      // Label 33714: @2534677
      GIM_Try, /*On fail goto*//*Label 33715*/ GIMT_Encode4(2534767), // Rule ID 45086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45086,
        GIR_EraseRootFromParent_Done,
      // Label 33715: @2534767
      GIM_Try, /*On fail goto*//*Label 33716*/ GIMT_Encode4(2534857), // Rule ID 45087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45087,
        GIR_EraseRootFromParent_Done,
      // Label 33716: @2534857
      GIM_Reject,
    // Label 33712: @2534858
    GIM_Reject,
    // Label 33662: @2534859
    GIM_Try, /*On fail goto*//*Label 33717*/ GIMT_Encode4(2535635),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_Try, /*On fail goto*//*Label 33718*/ GIMT_Encode4(2534971), // Rule ID 45096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45096,
        GIR_EraseRootFromParent_Done,
      // Label 33718: @2534971
      GIM_Try, /*On fail goto*//*Label 33719*/ GIMT_Encode4(2535072), // Rule ID 45097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45097,
        GIR_EraseRootFromParent_Done,
      // Label 33719: @2535072
      GIM_Try, /*On fail goto*//*Label 33720*/ GIMT_Encode4(2535173), // Rule ID 45172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45172,
        GIR_EraseRootFromParent_Done,
      // Label 33720: @2535173
      GIM_Try, /*On fail goto*//*Label 33721*/ GIMT_Encode4(2535274), // Rule ID 45173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45173,
        GIR_EraseRootFromParent_Done,
      // Label 33721: @2535274
      GIM_Try, /*On fail goto*//*Label 33722*/ GIMT_Encode4(2535364), // Rule ID 45098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45098,
        GIR_EraseRootFromParent_Done,
      // Label 33722: @2535364
      GIM_Try, /*On fail goto*//*Label 33723*/ GIMT_Encode4(2535454), // Rule ID 45099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45099,
        GIR_EraseRootFromParent_Done,
      // Label 33723: @2535454
      GIM_Try, /*On fail goto*//*Label 33724*/ GIMT_Encode4(2535544), // Rule ID 45174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45174,
        GIR_EraseRootFromParent_Done,
      // Label 33724: @2535544
      GIM_Try, /*On fail goto*//*Label 33725*/ GIMT_Encode4(2535634), // Rule ID 45175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45175,
        GIR_EraseRootFromParent_Done,
      // Label 33725: @2535634
      GIM_Reject,
    // Label 33717: @2535635
    GIM_Reject,
    // Label 33663: @2535636
    GIM_Try, /*On fail goto*//*Label 33726*/ GIMT_Encode4(2536412),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_Try, /*On fail goto*//*Label 33727*/ GIMT_Encode4(2535748), // Rule ID 45112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45112,
        GIR_EraseRootFromParent_Done,
      // Label 33727: @2535748
      GIM_Try, /*On fail goto*//*Label 33728*/ GIMT_Encode4(2535849), // Rule ID 45113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45113,
        GIR_EraseRootFromParent_Done,
      // Label 33728: @2535849
      GIM_Try, /*On fail goto*//*Label 33729*/ GIMT_Encode4(2535950), // Rule ID 45184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45184,
        GIR_EraseRootFromParent_Done,
      // Label 33729: @2535950
      GIM_Try, /*On fail goto*//*Label 33730*/ GIMT_Encode4(2536051), // Rule ID 45185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45185,
        GIR_EraseRootFromParent_Done,
      // Label 33730: @2536051
      GIM_Try, /*On fail goto*//*Label 33731*/ GIMT_Encode4(2536141), // Rule ID 45114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45114,
        GIR_EraseRootFromParent_Done,
      // Label 33731: @2536141
      GIM_Try, /*On fail goto*//*Label 33732*/ GIMT_Encode4(2536231), // Rule ID 45115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45115,
        GIR_EraseRootFromParent_Done,
      // Label 33732: @2536231
      GIM_Try, /*On fail goto*//*Label 33733*/ GIMT_Encode4(2536321), // Rule ID 45186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45186,
        GIR_EraseRootFromParent_Done,
      // Label 33733: @2536321
      GIM_Try, /*On fail goto*//*Label 33734*/ GIMT_Encode4(2536411), // Rule ID 45187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45187,
        GIR_EraseRootFromParent_Done,
      // Label 33734: @2536411
      GIM_Reject,
    // Label 33726: @2536412
    GIM_Reject,
    // Label 33664: @2536413
    GIM_Try, /*On fail goto*//*Label 33735*/ GIMT_Encode4(2537189),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_Try, /*On fail goto*//*Label 33736*/ GIMT_Encode4(2536525), // Rule ID 45156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45156,
        GIR_EraseRootFromParent_Done,
      // Label 33736: @2536525
      GIM_Try, /*On fail goto*//*Label 33737*/ GIMT_Encode4(2536626), // Rule ID 45157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45157,
        GIR_EraseRootFromParent_Done,
      // Label 33737: @2536626
      GIM_Try, /*On fail goto*//*Label 33738*/ GIMT_Encode4(2536727), // Rule ID 45216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45216,
        GIR_EraseRootFromParent_Done,
      // Label 33738: @2536727
      GIM_Try, /*On fail goto*//*Label 33739*/ GIMT_Encode4(2536828), // Rule ID 45217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45217,
        GIR_EraseRootFromParent_Done,
      // Label 33739: @2536828
      GIM_Try, /*On fail goto*//*Label 33740*/ GIMT_Encode4(2536918), // Rule ID 45158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45158,
        GIR_EraseRootFromParent_Done,
      // Label 33740: @2536918
      GIM_Try, /*On fail goto*//*Label 33741*/ GIMT_Encode4(2537008), // Rule ID 45159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45159,
        GIR_EraseRootFromParent_Done,
      // Label 33741: @2537008
      GIM_Try, /*On fail goto*//*Label 33742*/ GIMT_Encode4(2537098), // Rule ID 45218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45218,
        GIR_EraseRootFromParent_Done,
      // Label 33742: @2537098
      GIM_Try, /*On fail goto*//*Label 33743*/ GIMT_Encode4(2537188), // Rule ID 45219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv2i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45219,
        GIR_EraseRootFromParent_Done,
      // Label 33743: @2537188
      GIM_Reject,
    // Label 33735: @2537189
    GIM_Reject,
    // Label 33665: @2537190
    GIM_Try, /*On fail goto*//*Label 33744*/ GIMT_Encode4(2537584),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
      GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2537302), // Rule ID 45088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45088,
        GIR_EraseRootFromParent_Done,
      // Label 33745: @2537302
      GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2537403), // Rule ID 45089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45089,
        GIR_EraseRootFromParent_Done,
      // Label 33746: @2537403
      GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2537493), // Rule ID 45090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45090,
        GIR_EraseRootFromParent_Done,
      // Label 33747: @2537493
      GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2537583), // Rule ID 45091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45091,
        GIR_EraseRootFromParent_Done,
      // Label 33748: @2537583
      GIM_Reject,
    // Label 33744: @2537584
    GIM_Reject,
    // Label 33666: @2537585
    GIM_Try, /*On fail goto*//*Label 33749*/ GIMT_Encode4(2538361),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_Try, /*On fail goto*//*Label 33750*/ GIMT_Encode4(2537697), // Rule ID 45108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45108,
        GIR_EraseRootFromParent_Done,
      // Label 33750: @2537697
      GIM_Try, /*On fail goto*//*Label 33751*/ GIMT_Encode4(2537798), // Rule ID 45109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45109,
        GIR_EraseRootFromParent_Done,
      // Label 33751: @2537798
      GIM_Try, /*On fail goto*//*Label 33752*/ GIMT_Encode4(2537899), // Rule ID 45180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45180,
        GIR_EraseRootFromParent_Done,
      // Label 33752: @2537899
      GIM_Try, /*On fail goto*//*Label 33753*/ GIMT_Encode4(2538000), // Rule ID 45181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45181,
        GIR_EraseRootFromParent_Done,
      // Label 33753: @2538000
      GIM_Try, /*On fail goto*//*Label 33754*/ GIMT_Encode4(2538090), // Rule ID 45110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45110,
        GIR_EraseRootFromParent_Done,
      // Label 33754: @2538090
      GIM_Try, /*On fail goto*//*Label 33755*/ GIMT_Encode4(2538180), // Rule ID 45111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45111,
        GIR_EraseRootFromParent_Done,
      // Label 33755: @2538180
      GIM_Try, /*On fail goto*//*Label 33756*/ GIMT_Encode4(2538270), // Rule ID 45182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45182,
        GIR_EraseRootFromParent_Done,
      // Label 33756: @2538270
      GIM_Try, /*On fail goto*//*Label 33757*/ GIMT_Encode4(2538360), // Rule ID 45183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45183,
        GIR_EraseRootFromParent_Done,
      // Label 33757: @2538360
      GIM_Reject,
    // Label 33749: @2538361
    GIM_Reject,
    // Label 33667: @2538362
    GIM_Try, /*On fail goto*//*Label 33758*/ GIMT_Encode4(2539138),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_Try, /*On fail goto*//*Label 33759*/ GIMT_Encode4(2538474), // Rule ID 45144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45144,
        GIR_EraseRootFromParent_Done,
      // Label 33759: @2538474
      GIM_Try, /*On fail goto*//*Label 33760*/ GIMT_Encode4(2538575), // Rule ID 45145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45145,
        GIR_EraseRootFromParent_Done,
      // Label 33760: @2538575
      GIM_Try, /*On fail goto*//*Label 33761*/ GIMT_Encode4(2538676), // Rule ID 45204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45204,
        GIR_EraseRootFromParent_Done,
      // Label 33761: @2538676
      GIM_Try, /*On fail goto*//*Label 33762*/ GIMT_Encode4(2538777), // Rule ID 45205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45205,
        GIR_EraseRootFromParent_Done,
      // Label 33762: @2538777
      GIM_Try, /*On fail goto*//*Label 33763*/ GIMT_Encode4(2538867), // Rule ID 45146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45146,
        GIR_EraseRootFromParent_Done,
      // Label 33763: @2538867
      GIM_Try, /*On fail goto*//*Label 33764*/ GIMT_Encode4(2538957), // Rule ID 45147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45147,
        GIR_EraseRootFromParent_Done,
      // Label 33764: @2538957
      GIM_Try, /*On fail goto*//*Label 33765*/ GIMT_Encode4(2539047), // Rule ID 45206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45206,
        GIR_EraseRootFromParent_Done,
      // Label 33765: @2539047
      GIM_Try, /*On fail goto*//*Label 33766*/ GIMT_Encode4(2539137), // Rule ID 45207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45207,
        GIR_EraseRootFromParent_Done,
      // Label 33766: @2539137
      GIM_Reject,
    // Label 33758: @2539138
    GIM_Reject,
    // Label 33668: @2539139
    GIM_Try, /*On fail goto*//*Label 33767*/ GIMT_Encode4(2539915),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
      GIM_Try, /*On fail goto*//*Label 33768*/ GIMT_Encode4(2539251), // Rule ID 45160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45160,
        GIR_EraseRootFromParent_Done,
      // Label 33768: @2539251
      GIM_Try, /*On fail goto*//*Label 33769*/ GIMT_Encode4(2539352), // Rule ID 45161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45161,
        GIR_EraseRootFromParent_Done,
      // Label 33769: @2539352
      GIM_Try, /*On fail goto*//*Label 33770*/ GIMT_Encode4(2539453), // Rule ID 45220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45220,
        GIR_EraseRootFromParent_Done,
      // Label 33770: @2539453
      GIM_Try, /*On fail goto*//*Label 33771*/ GIMT_Encode4(2539554), // Rule ID 45221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45221,
        GIR_EraseRootFromParent_Done,
      // Label 33771: @2539554
      GIM_Try, /*On fail goto*//*Label 33772*/ GIMT_Encode4(2539644), // Rule ID 45162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45162,
        GIR_EraseRootFromParent_Done,
      // Label 33772: @2539644
      GIM_Try, /*On fail goto*//*Label 33773*/ GIMT_Encode4(2539734), // Rule ID 45163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45163,
        GIR_EraseRootFromParent_Done,
      // Label 33773: @2539734
      GIM_Try, /*On fail goto*//*Label 33774*/ GIMT_Encode4(2539824), // Rule ID 45222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45222,
        GIR_EraseRootFromParent_Done,
      // Label 33774: @2539824
      GIM_Try, /*On fail goto*//*Label 33775*/ GIMT_Encode4(2539914), // Rule ID 45223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv4i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45223,
        GIR_EraseRootFromParent_Done,
      // Label 33775: @2539914
      GIM_Reject,
    // Label 33767: @2539915
    GIM_Reject,
    // Label 33669: @2539916
    GIM_Try, /*On fail goto*//*Label 33776*/ GIMT_Encode4(2540310),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
      GIM_Try, /*On fail goto*//*Label 33777*/ GIMT_Encode4(2540028), // Rule ID 45104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45104,
        GIR_EraseRootFromParent_Done,
      // Label 33777: @2540028
      GIM_Try, /*On fail goto*//*Label 33778*/ GIMT_Encode4(2540129), // Rule ID 45105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45105,
        GIR_EraseRootFromParent_Done,
      // Label 33778: @2540129
      GIM_Try, /*On fail goto*//*Label 33779*/ GIMT_Encode4(2540219), // Rule ID 45106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45106,
        GIR_EraseRootFromParent_Done,
      // Label 33779: @2540219
      GIM_Try, /*On fail goto*//*Label 33780*/ GIMT_Encode4(2540309), // Rule ID 45107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45107,
        GIR_EraseRootFromParent_Done,
      // Label 33780: @2540309
      GIM_Reject,
    // Label 33776: @2540310
    GIM_Reject,
    // Label 33670: @2540311
    GIM_Try, /*On fail goto*//*Label 33781*/ GIMT_Encode4(2541087),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_Try, /*On fail goto*//*Label 33782*/ GIMT_Encode4(2540423), // Rule ID 45132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45132,
        GIR_EraseRootFromParent_Done,
      // Label 33782: @2540423
      GIM_Try, /*On fail goto*//*Label 33783*/ GIMT_Encode4(2540524), // Rule ID 45133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45133,
        GIR_EraseRootFromParent_Done,
      // Label 33783: @2540524
      GIM_Try, /*On fail goto*//*Label 33784*/ GIMT_Encode4(2540625), // Rule ID 45192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45192,
        GIR_EraseRootFromParent_Done,
      // Label 33784: @2540625
      GIM_Try, /*On fail goto*//*Label 33785*/ GIMT_Encode4(2540726), // Rule ID 45193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45193,
        GIR_EraseRootFromParent_Done,
      // Label 33785: @2540726
      GIM_Try, /*On fail goto*//*Label 33786*/ GIMT_Encode4(2540816), // Rule ID 45134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45134,
        GIR_EraseRootFromParent_Done,
      // Label 33786: @2540816
      GIM_Try, /*On fail goto*//*Label 33787*/ GIMT_Encode4(2540906), // Rule ID 45135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45135,
        GIR_EraseRootFromParent_Done,
      // Label 33787: @2540906
      GIM_Try, /*On fail goto*//*Label 33788*/ GIMT_Encode4(2540996), // Rule ID 45194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45194,
        GIR_EraseRootFromParent_Done,
      // Label 33788: @2540996
      GIM_Try, /*On fail goto*//*Label 33789*/ GIMT_Encode4(2541086), // Rule ID 45195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45195,
        GIR_EraseRootFromParent_Done,
      // Label 33789: @2541086
      GIM_Reject,
    // Label 33781: @2541087
    GIM_Reject,
    // Label 33671: @2541088
    GIM_Try, /*On fail goto*//*Label 33790*/ GIMT_Encode4(2541864),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
      GIM_Try, /*On fail goto*//*Label 33791*/ GIMT_Encode4(2541200), // Rule ID 45148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45148,
        GIR_EraseRootFromParent_Done,
      // Label 33791: @2541200
      GIM_Try, /*On fail goto*//*Label 33792*/ GIMT_Encode4(2541301), // Rule ID 45149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45149,
        GIR_EraseRootFromParent_Done,
      // Label 33792: @2541301
      GIM_Try, /*On fail goto*//*Label 33793*/ GIMT_Encode4(2541402), // Rule ID 45208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45208,
        GIR_EraseRootFromParent_Done,
      // Label 33793: @2541402
      GIM_Try, /*On fail goto*//*Label 33794*/ GIMT_Encode4(2541503), // Rule ID 45209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45209,
        GIR_EraseRootFromParent_Done,
      // Label 33794: @2541503
      GIM_Try, /*On fail goto*//*Label 33795*/ GIMT_Encode4(2541593), // Rule ID 45150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45150,
        GIR_EraseRootFromParent_Done,
      // Label 33795: @2541593
      GIM_Try, /*On fail goto*//*Label 33796*/ GIMT_Encode4(2541683), // Rule ID 45151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45151,
        GIR_EraseRootFromParent_Done,
      // Label 33796: @2541683
      GIM_Try, /*On fail goto*//*Label 33797*/ GIMT_Encode4(2541773), // Rule ID 45210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45210,
        GIR_EraseRootFromParent_Done,
      // Label 33797: @2541773
      GIM_Try, /*On fail goto*//*Label 33798*/ GIMT_Encode4(2541863), // Rule ID 45211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45211,
        GIR_EraseRootFromParent_Done,
      // Label 33798: @2541863
      GIM_Reject,
    // Label 33790: @2541864
    GIM_Reject,
    // Label 33672: @2541865
    GIM_Try, /*On fail goto*//*Label 33799*/ GIMT_Encode4(2542641),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
      GIM_Try, /*On fail goto*//*Label 33800*/ GIMT_Encode4(2541977), // Rule ID 45164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45164,
        GIR_EraseRootFromParent_Done,
      // Label 33800: @2541977
      GIM_Try, /*On fail goto*//*Label 33801*/ GIMT_Encode4(2542078), // Rule ID 45165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45165,
        GIR_EraseRootFromParent_Done,
      // Label 33801: @2542078
      GIM_Try, /*On fail goto*//*Label 33802*/ GIMT_Encode4(2542179), // Rule ID 45224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45224,
        GIR_EraseRootFromParent_Done,
      // Label 33802: @2542179
      GIM_Try, /*On fail goto*//*Label 33803*/ GIMT_Encode4(2542280), // Rule ID 45225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45225,
        GIR_EraseRootFromParent_Done,
      // Label 33803: @2542280
      GIM_Try, /*On fail goto*//*Label 33804*/ GIMT_Encode4(2542370), // Rule ID 45166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45166,
        GIR_EraseRootFromParent_Done,
      // Label 33804: @2542370
      GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2542460), // Rule ID 45167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45167,
        GIR_EraseRootFromParent_Done,
      // Label 33805: @2542460
      GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2542550), // Rule ID 45226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45226,
        GIR_EraseRootFromParent_Done,
      // Label 33806: @2542550
      GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2542640), // Rule ID 45227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv8i1] }, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45227,
        GIR_EraseRootFromParent_Done,
      // Label 33807: @2542640
      GIM_Reject,
    // Label 33799: @2542641
    GIM_Reject,
    // Label 33673: @2542642
    GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2543036),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2542754), // Rule ID 45120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45120,
        GIR_EraseRootFromParent_Done,
      // Label 33809: @2542754
      GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2542855), // Rule ID 45121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45121,
        GIR_EraseRootFromParent_Done,
      // Label 33810: @2542855
      GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2542945), // Rule ID 45122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45122,
        GIR_EraseRootFromParent_Done,
      // Label 33811: @2542945
      GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2543035), // Rule ID 45123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45123,
        GIR_EraseRootFromParent_Done,
      // Label 33812: @2543035
      GIM_Reject,
    // Label 33808: @2543036
    GIM_Reject,
    // Label 33674: @2543037
    GIM_Try, /*On fail goto*//*Label 33813*/ GIMT_Encode4(2543813),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
      GIM_Try, /*On fail goto*//*Label 33814*/ GIMT_Encode4(2543149), // Rule ID 45136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45136,
        GIR_EraseRootFromParent_Done,
      // Label 33814: @2543149
      GIM_Try, /*On fail goto*//*Label 33815*/ GIMT_Encode4(2543250), // Rule ID 45137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45137,
        GIR_EraseRootFromParent_Done,
      // Label 33815: @2543250
      GIM_Try, /*On fail goto*//*Label 33816*/ GIMT_Encode4(2543351), // Rule ID 45196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45196,
        GIR_EraseRootFromParent_Done,
      // Label 33816: @2543351
      GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2543452), // Rule ID 45197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45197,
        GIR_EraseRootFromParent_Done,
      // Label 33817: @2543452
      GIM_Try, /*On fail goto*//*Label 33818*/ GIMT_Encode4(2543542), // Rule ID 45138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45138,
        GIR_EraseRootFromParent_Done,
      // Label 33818: @2543542
      GIM_Try, /*On fail goto*//*Label 33819*/ GIMT_Encode4(2543632), // Rule ID 45139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45139,
        GIR_EraseRootFromParent_Done,
      // Label 33819: @2543632
      GIM_Try, /*On fail goto*//*Label 33820*/ GIMT_Encode4(2543722), // Rule ID 45198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45198,
        GIR_EraseRootFromParent_Done,
      // Label 33820: @2543722
      GIM_Try, /*On fail goto*//*Label 33821*/ GIMT_Encode4(2543812), // Rule ID 45199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45199,
        GIR_EraseRootFromParent_Done,
      // Label 33821: @2543812
      GIM_Reject,
    // Label 33813: @2543813
    GIM_Reject,
    // Label 33675: @2543814
    GIM_Try, /*On fail goto*//*Label 33822*/ GIMT_Encode4(2544590),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
      GIM_Try, /*On fail goto*//*Label 33823*/ GIMT_Encode4(2543926), // Rule ID 45152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45152,
        GIR_EraseRootFromParent_Done,
      // Label 33823: @2543926
      GIM_Try, /*On fail goto*//*Label 33824*/ GIMT_Encode4(2544027), // Rule ID 45153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45153,
        GIR_EraseRootFromParent_Done,
      // Label 33824: @2544027
      GIM_Try, /*On fail goto*//*Label 33825*/ GIMT_Encode4(2544128), // Rule ID 45212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45212,
        GIR_EraseRootFromParent_Done,
      // Label 33825: @2544128
      GIM_Try, /*On fail goto*//*Label 33826*/ GIMT_Encode4(2544229), // Rule ID 45213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45213,
        GIR_EraseRootFromParent_Done,
      // Label 33826: @2544229
      GIM_Try, /*On fail goto*//*Label 33827*/ GIMT_Encode4(2544319), // Rule ID 45154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45154,
        GIR_EraseRootFromParent_Done,
      // Label 33827: @2544319
      GIM_Try, /*On fail goto*//*Label 33828*/ GIMT_Encode4(2544409), // Rule ID 45155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45155,
        GIR_EraseRootFromParent_Done,
      // Label 33828: @2544409
      GIM_Try, /*On fail goto*//*Label 33829*/ GIMT_Encode4(2544499), // Rule ID 45214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45214,
        GIR_EraseRootFromParent_Done,
      // Label 33829: @2544499
      GIM_Try, /*On fail goto*//*Label 33830*/ GIMT_Encode4(2544589), // Rule ID 45215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv16i1] }, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45215,
        GIR_EraseRootFromParent_Done,
      // Label 33830: @2544589
      GIM_Reject,
    // Label 33822: @2544590
    GIM_Reject,
    // Label 33676: @2544591
    GIM_Try, /*On fail goto*//*Label 33831*/ GIMT_Encode4(2544985),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
      GIM_Try, /*On fail goto*//*Label 33832*/ GIMT_Encode4(2544703), // Rule ID 45124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45124,
        GIR_EraseRootFromParent_Done,
      // Label 33832: @2544703
      GIM_Try, /*On fail goto*//*Label 33833*/ GIMT_Encode4(2544804), // Rule ID 45125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45125,
        GIR_EraseRootFromParent_Done,
      // Label 33833: @2544804
      GIM_Try, /*On fail goto*//*Label 33834*/ GIMT_Encode4(2544894), // Rule ID 45126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45126,
        GIR_EraseRootFromParent_Done,
      // Label 33834: @2544894
      GIM_Try, /*On fail goto*//*Label 33835*/ GIMT_Encode4(2544984), // Rule ID 45127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45127,
        GIR_EraseRootFromParent_Done,
      // Label 33835: @2544984
      GIM_Reject,
    // Label 33831: @2544985
    GIM_Reject,
    // Label 33677: @2544986
    GIM_Try, /*On fail goto*//*Label 33836*/ GIMT_Encode4(2545762),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
      GIM_Try, /*On fail goto*//*Label 33837*/ GIMT_Encode4(2545098), // Rule ID 45140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45140,
        GIR_EraseRootFromParent_Done,
      // Label 33837: @2545098
      GIM_Try, /*On fail goto*//*Label 33838*/ GIMT_Encode4(2545199), // Rule ID 45141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45141,
        GIR_EraseRootFromParent_Done,
      // Label 33838: @2545199
      GIM_Try, /*On fail goto*//*Label 33839*/ GIMT_Encode4(2545300), // Rule ID 45200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45200,
        GIR_EraseRootFromParent_Done,
      // Label 33839: @2545300
      GIM_Try, /*On fail goto*//*Label 33840*/ GIMT_Encode4(2545401), // Rule ID 45201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45201,
        GIR_EraseRootFromParent_Done,
      // Label 33840: @2545401
      GIM_Try, /*On fail goto*//*Label 33841*/ GIMT_Encode4(2545491), // Rule ID 45142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45142,
        GIR_EraseRootFromParent_Done,
      // Label 33841: @2545491
      GIM_Try, /*On fail goto*//*Label 33842*/ GIMT_Encode4(2545581), // Rule ID 45143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45143,
        GIR_EraseRootFromParent_Done,
      // Label 33842: @2545581
      GIM_Try, /*On fail goto*//*Label 33843*/ GIMT_Encode4(2545671), // Rule ID 45202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45202,
        GIR_EraseRootFromParent_Done,
      // Label 33843: @2545671
      GIM_Try, /*On fail goto*//*Label 33844*/ GIMT_Encode4(2545761), // Rule ID 45203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv32i1] }, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45203,
        GIR_EraseRootFromParent_Done,
      // Label 33844: @2545761
      GIM_Reject,
    // Label 33836: @2545762
    GIM_Reject,
    // Label 33678: @2545763
    GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2546157),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
      GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2545875), // Rule ID 45128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45128,
        GIR_EraseRootFromParent_Done,
      // Label 33846: @2545875
      GIM_Try, /*On fail goto*//*Label 33847*/ GIMT_Encode4(2545976), // Rule ID 45129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45129,
        GIR_EraseRootFromParent_Done,
      // Label 33847: @2545976
      GIM_Try, /*On fail goto*//*Label 33848*/ GIMT_Encode4(2546066), // Rule ID 45130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45130,
        GIR_EraseRootFromParent_Done,
      // Label 33848: @2546066
      GIM_Try, /*On fail goto*//*Label 33849*/ GIMT_Encode4(2546156), // Rule ID 45131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
        // MIs[0] policy
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
        // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, V0:{ *:[nxv64i1] }, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // V0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // rd
        GIR_RootToRootCopy, /*OpIdx*/2, // rs1
        GIR_RootToRootCopy, /*OpIdx*/3, // rs2
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::V0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootToRootCopy, /*OpIdx*/6, // policy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 45131,
        GIR_EraseRootFromParent_Done,
      // Label 33849: @2546156
      GIM_Reject,
    // Label 33845: @2546157
    GIM_Reject,
    // Label 33679: @2546158
    GIM_Reject,
    // Label 121: @2546159
    GIM_Reject,
    }; // Size: 2546160 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
